/* THIS FILE IS AUTOGENERATED FROM PeerConnectionObserver.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_PeerConnectionObserverBinding_h
#define mozilla_dom_PeerConnectionObserverBinding_h

#include "GeckoProfiler.h"
#include "PeerConnectionObserverEnumsBinding.h"
#include "RTCPeerConnectionBinding.h"
#include "js/RootingAPI.h"
#include "jspubtd.h"
#include "mozilla/ErrorResult.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/CallbackInterface.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"
#include "mozilla/dom/ToJSValue.h"
#include "mozilla/dom/TypedArray.h"
#include "nsWeakReference.h"

class nsDOMDataChannel;

namespace mozilla {

class TransceiverImpl;

namespace dom {

class MediaStreamTrack;
struct NativePropertyHooks;
struct PCErrorData;
struct PCErrorDataAtoms;
class PeerConnectionObserver;
struct PeerConnectionObserverAtoms;
class ProtoAndIfaceCache;
class RTCPeerConnection;
struct RTCStatsReportInternal;

} // namespace dom

} // namespace mozilla

namespace mozilla {
namespace dom {

struct PCErrorData : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR nsString mMessage;
  MOZ_INIT_OUTSIDE_CTOR PCError mName;

  PCErrorData();

  explicit inline PCErrorData(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline PCErrorData(const PCErrorData& aOther)
  {
    *this = aOther;
  }

  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(const nsAString& aJSON);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  bool
  ToJSON(nsAString& aJSON) const;

  void
  TraceDictionary(JSTracer* trc);

  PCErrorData&
  operator=(const PCErrorData& aOther);

private:
  static bool
  InitIds(JSContext* cx, PCErrorDataAtoms* atomsCache);
};

namespace binding_detail {
struct FastPCErrorData : public PCErrorData
{
  inline FastPCErrorData()
    : PCErrorData(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace PeerConnectionObserver_Binding {

  typedef mozilla::dom::PeerConnectionObserver NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::dom::PeerConnectionObserver* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  // We declare this as an array so that retrieving a pointer to this
  // binding's property hooks only requires compile/link-time resolvable
  // address arithmetic.  Declaring it as a pointer instead would require
  // doing a run-time load to fetch a pointer to this binding's property
  // hooks.  And then structures which embedded a pointer to this structure
  // would require a run-time load for proper initialization, which would
  // then induce static constructors.  Lots of static constructors.
  extern const NativePropertyHooks sNativePropertyHooks[];

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::PeerConnectionObserver,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::PeerConnectionObserver,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace PeerConnectionObserver_Binding



class PeerConnectionObserverJSImpl : public CallbackInterface
{
public:
  explicit inline PeerConnectionObserverJSImpl(JSContext* aCx, JS::Handle<JSObject*> aCallback, JS::Handle<JSObject*> aCallbackGlobal, nsIGlobalObject* aIncumbentGlobal)
    : CallbackInterface(aCx, aCallback, aCallbackGlobal, aIncumbentGlobal)
  {
  }

  explicit inline PeerConnectionObserverJSImpl(JSObject* aCallback, JSObject* aCallbackGlobal, const FastCallbackConstructor& )
    : CallbackInterface(aCallback, aCallbackGlobal, FastCallbackConstructor())
  {
  }

  explicit inline PeerConnectionObserverJSImpl(JSObject* aCallback, JSObject* aCallbackGlobal, JSObject* aAsyncStack, nsIGlobalObject* aIncumbentGlobal)
    : CallbackInterface(aCallback, aCallbackGlobal, aAsyncStack, aIncumbentGlobal)
  {
  }

  void OnCreateOfferSuccess(const nsAString& offer, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnCreateOfferError(const PCErrorData& error, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnCreateAnswerSuccess(const nsAString& answer, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnCreateAnswerError(const PCErrorData& error, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnSetLocalDescriptionSuccess(ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnSetRemoteDescriptionSuccess(ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnSetLocalDescriptionError(const PCErrorData& error, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnSetRemoteDescriptionError(const PCErrorData& error, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnAddIceCandidateSuccess(ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnAddIceCandidateError(const PCErrorData& error, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnIceCandidate(uint16_t level, const nsAString& mid, const nsAString& candidate, const nsAString& ufrag, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnGetStatsSuccess(const RTCStatsReportInternal& report, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnGetStatsError(const nsAString& message, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void NotifyDataChannel(nsDOMDataChannel& channel, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnStateChange(PCObserverStateType state, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnTransceiverNeeded(const nsAString& kind, TransceiverImpl& transceiverImpl, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnDTMFToneChange(MediaStreamTrack& track, const nsAString& tone, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnPacket(uint32_t level, mozPacketDumpType type, bool sending, const ArrayBuffer& packet, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void SyncTransceivers(ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void __Init(RTCPeerConnection& domPC, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  inline bool
  operator==(const PeerConnectionObserverJSImpl& aOther) const
  {
    return CallbackInterface::operator==(aOther);
  }

private:
  static bool
  InitIds(JSContext* cx, PeerConnectionObserverAtoms* atomsCache);
};


class PeerConnectionObserver final : public nsSupportsWeakReference,
                                     public nsWrapperCache
{
public:
  NS_DECL_CYCLE_COLLECTING_ISUPPORTS
  NS_DECL_CYCLE_COLLECTION_SCRIPT_HOLDER_CLASS(PeerConnectionObserver)

private:
  RefPtr<PeerConnectionObserverJSImpl> mImpl;
  nsCOMPtr<nsIGlobalObject> mParent;

public:
  PeerConnectionObserver(JS::Handle<JSObject*> aJSImplObject, JS::Handle<JSObject*> aJSImplGlobal, nsIGlobalObject* aParent);

private:
  ~PeerConnectionObserver();

public:
  nsISupports* GetParentObject() const;

  virtual JSObject* WrapObject(JSContext* aCx, JS::Handle<JSObject*> aGivenProto) override;

  static already_AddRefed<PeerConnectionObserver> Constructor(const GlobalObject& global, JSContext* cx, RTCPeerConnection& domPC, ErrorResult& aRv, JS::Handle<JSObject*> aGivenProto = nullptr);

  void OnCreateOfferSuccess(const nsAString& offer, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnCreateOfferError(const PCErrorData& error, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnCreateAnswerSuccess(const nsAString& answer, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnCreateAnswerError(const PCErrorData& error, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnSetLocalDescriptionSuccess(ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnSetRemoteDescriptionSuccess(ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnSetLocalDescriptionError(const PCErrorData& error, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnSetRemoteDescriptionError(const PCErrorData& error, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnAddIceCandidateSuccess(ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnAddIceCandidateError(const PCErrorData& error, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnIceCandidate(uint16_t level, const nsAString& mid, const nsAString& candidate, const nsAString& ufrag, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnGetStatsSuccess(const RTCStatsReportInternal& report, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnGetStatsError(const nsAString& message, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void NotifyDataChannel(nsDOMDataChannel& channel, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnStateChange(PCObserverStateType state, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnTransceiverNeeded(const nsAString& kind, TransceiverImpl& transceiverImpl, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnDTMFToneChange(MediaStreamTrack& track, const nsAString& tone, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void OnPacket(uint32_t level, mozPacketDumpType type, bool sending, const ArrayBuffer& packet, ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  void SyncTransceivers(ErrorResult& aRv, JS::Realm* aRealm = nullptr);

  static bool
  _Create(JSContext* cx, unsigned argc, JS::Value* vp);
};


} // namespace dom
} // namespace mozilla

#endif // mozilla_dom_PeerConnectionObserverBinding_h
