/* THIS FILE IS AUTOGENERATED FROM WebExtensionPolicy.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_WebExtensionPolicyBinding_h
#define mozilla_dom_WebExtensionPolicyBinding_h

#include "GeckoProfiler.h"
#include "WebExtensionContentScriptBinding.h"
#include "js/RootingAPI.h"
#include "jspubtd.h"
#include "mozilla/ErrorResult.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/CallbackFunction.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/Promise.h"
#include "mozilla/dom/PrototypeList.h"
#include "mozilla/dom/ToJSValue.h"

namespace mozilla {

namespace dom {

class MatchGlobOrString;
class MatchPatternSetOrStringSequence;
struct NativePropertyHooks;
class OwningMatchGlobOrString;
class OwningMatchPatternSetOrStringSequence;
class Promise;
class ProtoAndIfaceCache;
struct WebExtensionContentScriptInit;
struct WebExtensionInitAtoms;
class WebExtensionLocalizeCallback;

} // namespace dom

namespace extensions {

class WebExtensionPolicy;
struct WebExtensionPolicyAtoms;

} // namespace extensions

} // namespace mozilla

namespace mozilla {
namespace dom {

struct WebExtensionInit : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR OwningMatchPatternSetOrStringSequence mAllowedOrigins;
  MOZ_INIT_OUTSIDE_CTOR Nullable<Sequence<nsString>> mBackgroundScripts;
  MOZ_INIT_OUTSIDE_CTOR nsString mBaseURL;
  MOZ_INIT_OUTSIDE_CTOR Sequence<WebExtensionContentScriptInit> mContentScripts;
  MOZ_INIT_OUTSIDE_CTOR nsString mContentSecurityPolicy;
  MOZ_INIT_OUTSIDE_CTOR nsString mId;
  MOZ_INIT_OUTSIDE_CTOR OwningNonNull<WebExtensionLocalizeCallback> mLocalizeCallback;
  MOZ_INIT_OUTSIDE_CTOR nsCString mMozExtensionHostname;
  MOZ_INIT_OUTSIDE_CTOR nsString mName;
  MOZ_INIT_OUTSIDE_CTOR Sequence<nsString> mPermissions;
  MOZ_INIT_OUTSIDE_CTOR Optional<OwningNonNull<Promise>> mReadyPromise;
  MOZ_INIT_OUTSIDE_CTOR Sequence<OwningMatchGlobOrString> mWebAccessibleResources;

  WebExtensionInit();

  explicit inline WebExtensionInit(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

private:
  WebExtensionInit(const WebExtensionInit&) = delete;
  WebExtensionInit& operator=(const WebExtensionInit&) = delete;

  static bool
  InitIds(JSContext* cx, WebExtensionInitAtoms* atomsCache);

public:
  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceDictionary(JSTracer* trc);

  inline void
  TraverseForCC(nsCycleCollectionTraversalCallback& aCallback, uint32_t aFlags)
  {
    ImplCycleCollectionTraverse(aCallback, mAllowedOrigins, "mAllowedOrigins", aFlags);
    ImplCycleCollectionTraverse(aCallback, mContentScripts, "mContentScripts", aFlags);
    ImplCycleCollectionTraverse(aCallback, mLocalizeCallback, "mLocalizeCallback", aFlags);
    ImplCycleCollectionTraverse(aCallback, mReadyPromise, "mReadyPromise", aFlags);
    ImplCycleCollectionTraverse(aCallback, mWebAccessibleResources, "mWebAccessibleResources", aFlags);
  }

  inline void
  UnlinkForCC()
  {
    ImplCycleCollectionUnlink(mAllowedOrigins);
    ImplCycleCollectionUnlink(mContentScripts);
    ImplCycleCollectionUnlink(mLocalizeCallback);
    ImplCycleCollectionUnlink(mReadyPromise);
    ImplCycleCollectionUnlink(mWebAccessibleResources);
  }
};

namespace binding_detail {
struct FastWebExtensionInit : public WebExtensionInit
{
  inline FastWebExtensionInit()
    : WebExtensionInit(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


class WebExtensionLocalizeCallback : public CallbackFunction
{
public:
  explicit inline WebExtensionLocalizeCallback(JSContext* aCx, JS::Handle<JSObject*> aCallback, JS::Handle<JSObject*> aCallbackGlobal, nsIGlobalObject* aIncumbentGlobal)
    : CallbackFunction(aCx, aCallback, aCallbackGlobal, aIncumbentGlobal)
  {
    MOZ_ASSERT(JS::IsCallable(mCallback));
  }

  explicit inline WebExtensionLocalizeCallback(JSObject* aCallback, JSObject* aCallbackGlobal, const FastCallbackConstructor& )
    : CallbackFunction(aCallback, aCallbackGlobal, FastCallbackConstructor())
  {
    MOZ_ASSERT(JS::IsCallable(mCallback));
  }

  explicit inline WebExtensionLocalizeCallback(JSObject* aCallback, JSObject* aCallbackGlobal, JSObject* aAsyncStack, nsIGlobalObject* aIncumbentGlobal)
    : CallbackFunction(aCallback, aCallbackGlobal, aAsyncStack, aIncumbentGlobal)
  {
    MOZ_ASSERT(JS::IsCallable(mCallback));
  }

  explicit inline WebExtensionLocalizeCallback(CallbackFunction* aOther)
    : CallbackFunction(aOther)
  {
  }

  template <typename T>
  MOZ_CAN_RUN_SCRIPT inline void
  Call(const T& thisVal, const nsAString& unlocalizedText, nsString& aRetVal, ErrorResult& aRv, const char* aExecutionReason = nullptr, ExceptionHandling aExceptionHandling = eReportExceptions, JS::Realm* aRealm = nullptr)
  {
    MOZ_ASSERT(!aRv.Failed(), "Don't pass an already-failed ErrorResult to a callback!");
    if (!aExecutionReason) {
      aExecutionReason = "WebExtensionLocalizeCallback";
    }
    CallSetup s(this, aRv, aExecutionReason, aExceptionHandling, aRealm);
    if (!s.GetContext()) {
      MOZ_ASSERT(aRv.Failed());
      return;
    }
    JS::Rooted<JS::Value> thisValJS(s.GetContext());
    if (!ToJSValue(s.GetContext(), thisVal, &thisValJS)) {
      aRv.Throw(NS_ERROR_FAILURE);
      return;
    }
    return Call(s.GetContext(), thisValJS, unlocalizedText, aRetVal, aRv);
  }

  MOZ_CAN_RUN_SCRIPT inline void
  Call(const nsAString& unlocalizedText, nsString& aRetVal, ErrorResult& aRv, const char* aExecutionReason = nullptr, ExceptionHandling aExceptionHandling = eReportExceptions, JS::Realm* aRealm = nullptr)
  {
    MOZ_ASSERT(!aRv.Failed(), "Don't pass an already-failed ErrorResult to a callback!");
    if (!aExecutionReason) {
      aExecutionReason = "WebExtensionLocalizeCallback";
    }
    CallSetup s(this, aRv, aExecutionReason, aExceptionHandling, aRealm);
    if (!s.GetContext()) {
      MOZ_ASSERT(aRv.Failed());
      return;
    }
    return Call(s.GetContext(), JS::UndefinedHandleValue, unlocalizedText, aRetVal, aRv);
  }

  template <typename T>
  MOZ_CAN_RUN_SCRIPT inline void
  Call(const T& thisVal, const nsAString& unlocalizedText, nsString& aRetVal, const char* aExecutionReason = nullptr)
  {
    return Call(thisVal, unlocalizedText, aRetVal, IgnoreErrors(), aExecutionReason);
  }

  MOZ_CAN_RUN_SCRIPT inline void
  Call(const nsAString& unlocalizedText, nsString& aRetVal, const char* aExecutionReason = nullptr)
  {
    return Call(unlocalizedText, aRetVal, IgnoreErrors(), aExecutionReason, eReportExceptions, nullptr);
  }

  inline bool
  operator==(const WebExtensionLocalizeCallback& aOther) const
  {
    return CallbackFunction::operator==(aOther);
  }

private:
  MOZ_CAN_RUN_SCRIPT void Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, const nsAString& unlocalizedText, nsString& aRetVal, ErrorResult& aRv);
};


namespace binding_detail {
class FastWebExtensionLocalizeCallback : public WebExtensionLocalizeCallback
{
public:
  explicit inline FastWebExtensionLocalizeCallback(JSObject* aCallback, JSObject* aCallbackGlobal)
    : WebExtensionLocalizeCallback(aCallback, aCallbackGlobal, FastCallbackConstructor())
  {
  }

  inline void
  Trace(JSTracer* aTracer)
  {
    WebExtensionLocalizeCallback::Trace(aTracer);
  }

  inline void
  FinishSlowJSInitIfMoreThanOneOwner(JSContext* aCx)
  {
    WebExtensionLocalizeCallback::FinishSlowJSInitIfMoreThanOneOwner(aCx);
  }
};
} // namespace binding_detail


namespace WebExtensionPolicy_Binding {

  typedef mozilla::extensions::WebExtensionPolicy NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::extensions::WebExtensionPolicy* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  // We declare this as an array so that retrieving a pointer to this
  // binding's property hooks only requires compile/link-time resolvable
  // address arithmetic.  Declaring it as a pointer instead would require
  // doing a run-time load to fetch a pointer to this binding's property
  // hooks.  And then structures which embedded a pointer to this structure
  // would require a run-time load for proper initialization, which would
  // then induce static constructors.  Lots of static constructors.
  extern const NativePropertyHooks sNativePropertyHooks[];

  void
  ClearCachedPermissionsValue(mozilla::extensions::WebExtensionPolicy* aObject);

  void
  ClearCachedContentScriptsValue(mozilla::extensions::WebExtensionPolicy* aObject);

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::WebExtensionPolicy,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::WebExtensionPolicy,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace WebExtensionPolicy_Binding



} // namespace dom
} // namespace mozilla

#endif // mozilla_dom_WebExtensionPolicyBinding_h
