/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM /builddir/build/BUILD/firefox-68.6.0/dom/interfaces/security/nsIReferrerInfo.idl
 */

#ifndef __gen_nsIReferrerInfo_h__
#define __gen_nsIReferrerInfo_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsISerializable_h__
#include "nsISerializable.h"
#endif

#include "mozilla/AlreadyAddRefed.h"
#include "mozilla/Assertions.h"
#include "mozilla/DebugOnly.h"

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIURI; /* forward declaration */


/* starting interface:    nsIReferrerInfo */
#define NS_IREFERRERINFO_IID_STR "081cdc36-f2e2-4f94-87bf-78578f06f1eb"

#define NS_IREFERRERINFO_IID \
  {0x081cdc36, 0xf2e2, 0x4f94, \
    { 0x87, 0xbf, 0x78, 0x57, 0x8f, 0x06, 0xf1, 0xeb }}

class NS_NO_VTABLE nsIReferrerInfo : public nsISerializable {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IREFERRERINFO_IID)

  /* [infallible] readonly attribute nsIURI originalReferrer; */
  NS_IMETHOD GetOriginalReferrer(nsIURI **aOriginalReferrer) = 0;
  inline already_AddRefed<nsIURI>GetOriginalReferrer()
  {
    nsIURI* result = nullptr;
    mozilla::DebugOnly<nsresult> rv = GetOriginalReferrer(&result);
    MOZ_ASSERT(NS_SUCCEEDED(rv));
    return already_AddRefed<nsIURI>(result);
  }

  /* [infallible] readonly attribute unsigned long referrerPolicy; */
  NS_IMETHOD GetReferrerPolicy(uint32_t *aReferrerPolicy) = 0;
  inline uint32_t GetReferrerPolicy()
  {
    uint32_t result;
    mozilla::DebugOnly<nsresult> rv = GetReferrerPolicy(&result);
    MOZ_ASSERT(NS_SUCCEEDED(rv));
    return result;
  }

  /* [infallible] readonly attribute boolean sendReferrer; */
  NS_IMETHOD GetSendReferrer(bool *aSendReferrer) = 0;
  inline bool GetSendReferrer()
  {
    bool result;
    mozilla::DebugOnly<nsresult> rv = GetSendReferrer(&result);
    MOZ_ASSERT(NS_SUCCEEDED(rv));
    return result;
  }

  /* [must_use,noscript,nostdcall,notxpcom] URIRef GetComputedReferrer (); */
  MOZ_MUST_USE virtual already_AddRefed<nsIURI> GetComputedReferrer(void) = 0;

  /* void init (in uint32_t aReferrerPolicy, [optional] in boolean aSendReferrer, [optional] in nsIURI aOriginalReferrer); */
  NS_IMETHOD Init(uint32_t aReferrerPolicy, bool aSendReferrer, nsIURI *aOriginalReferrer) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIReferrerInfo, NS_IREFERRERINFO_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIREFERRERINFO \
  using nsIReferrerInfo::GetOriginalReferrer; \
  NS_IMETHOD GetOriginalReferrer(nsIURI **aOriginalReferrer) override; \
  using nsIReferrerInfo::GetReferrerPolicy; \
  NS_IMETHOD GetReferrerPolicy(uint32_t *aReferrerPolicy) override; \
  using nsIReferrerInfo::GetSendReferrer; \
  NS_IMETHOD GetSendReferrer(bool *aSendReferrer) override; \
  MOZ_MUST_USE virtual already_AddRefed<nsIURI> GetComputedReferrer(void) override; \
  NS_IMETHOD Init(uint32_t aReferrerPolicy, bool aSendReferrer, nsIURI *aOriginalReferrer) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIREFERRERINFO \
  using nsIReferrerInfo::GetOriginalReferrer; \
  nsresult GetOriginalReferrer(nsIURI **aOriginalReferrer); \
  using nsIReferrerInfo::GetReferrerPolicy; \
  nsresult GetReferrerPolicy(uint32_t *aReferrerPolicy); \
  using nsIReferrerInfo::GetSendReferrer; \
  nsresult GetSendReferrer(bool *aSendReferrer); \
  MOZ_MUST_USE already_AddRefed<nsIURI> GetComputedReferrer(void); \
  nsresult Init(uint32_t aReferrerPolicy, bool aSendReferrer, nsIURI *aOriginalReferrer); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIREFERRERINFO(_to) \
  using nsIReferrerInfo::GetOriginalReferrer; \
  NS_IMETHOD GetOriginalReferrer(nsIURI **aOriginalReferrer) override { return _to GetOriginalReferrer(aOriginalReferrer); } \
  using nsIReferrerInfo::GetReferrerPolicy; \
  NS_IMETHOD GetReferrerPolicy(uint32_t *aReferrerPolicy) override { return _to GetReferrerPolicy(aReferrerPolicy); } \
  using nsIReferrerInfo::GetSendReferrer; \
  NS_IMETHOD GetSendReferrer(bool *aSendReferrer) override { return _to GetSendReferrer(aSendReferrer); } \
  MOZ_MUST_USE virtual already_AddRefed<nsIURI> GetComputedReferrer(void) override { return _to GetComputedReferrer(); } \
  NS_IMETHOD Init(uint32_t aReferrerPolicy, bool aSendReferrer, nsIURI *aOriginalReferrer) override { return _to Init(aReferrerPolicy, aSendReferrer, aOriginalReferrer); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIREFERRERINFO(_to) \
  NS_IMETHOD GetOriginalReferrer(nsIURI **aOriginalReferrer) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetOriginalReferrer(aOriginalReferrer); } \
  NS_IMETHOD GetReferrerPolicy(uint32_t *aReferrerPolicy) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetReferrerPolicy(aReferrerPolicy); } \
  NS_IMETHOD GetSendReferrer(bool *aSendReferrer) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSendReferrer(aSendReferrer); } \
  MOZ_MUST_USE virtual already_AddRefed<nsIURI> GetComputedReferrer(void) override; \
  NS_IMETHOD Init(uint32_t aReferrerPolicy, bool aSendReferrer, nsIURI *aOriginalReferrer) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Init(aReferrerPolicy, aSendReferrer, aOriginalReferrer); } 


#endif /* __gen_nsIReferrerInfo_h__ */
