/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM /builddir/build/BUILD/firefox-68.6.0/security/manager/ssl/nsISiteSecurityService.idl
 */

#ifndef __gen_nsISiteSecurityService_h__
#define __gen_nsISiteSecurityService_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#include "js/Value.h"

#include "mozilla/AlreadyAddRefed.h"
#include "mozilla/Assertions.h"
#include "mozilla/DebugOnly.h"

#include "js/GCAnnotations.h"

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIURI; /* forward declaration */

class nsIObserver; /* forward declaration */

class nsIHttpChannel; /* forward declaration */

class nsITransportSecurityInfo; /* forward declaration */

class nsISimpleEnumerator; /* forward declaration */

#include "nsStringFwd.h"
#include "nsTArrayForwardDeclare.h"
namespace mozilla
{
  namespace pkix
  {
    class Time;
  }
}

/* starting interface:    nsISiteSecurityState */
#define NS_ISITESECURITYSTATE_IID_STR "31313372-842c-4110-bdf1-6aea17c845ad"

#define NS_ISITESECURITYSTATE_IID \
  {0x31313372, 0x842c, 0x4110, \
    { 0xbd, 0xf1, 0x6a, 0xea, 0x17, 0xc8, 0x45, 0xad }}

class NS_NO_VTABLE nsISiteSecurityState : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_ISITESECURITYSTATE_IID)

  /* [must_use] readonly attribute ACString hostname; */
  MOZ_MUST_USE NS_IMETHOD GetHostname(nsACString& aHostname) = 0;

  /* [infallible] readonly attribute long long expireTime; */
  NS_IMETHOD GetExpireTime(int64_t *aExpireTime) = 0;
  inline int64_t GetExpireTime()
  {
    int64_t result;
    mozilla::DebugOnly<nsresult> rv = GetExpireTime(&result);
    MOZ_ASSERT(NS_SUCCEEDED(rv));
    return result;
  }

  /* [infallible] readonly attribute short securityPropertyState; */
  NS_IMETHOD GetSecurityPropertyState(int16_t *aSecurityPropertyState) = 0;
  inline int16_t GetSecurityPropertyState()
  {
    int16_t result;
    mozilla::DebugOnly<nsresult> rv = GetSecurityPropertyState(&result);
    MOZ_ASSERT(NS_SUCCEEDED(rv));
    return result;
  }

  /* [infallible] readonly attribute boolean includeSubdomains; */
  NS_IMETHOD GetIncludeSubdomains(bool *aIncludeSubdomains) = 0;
  inline bool GetIncludeSubdomains()
  {
    bool result;
    mozilla::DebugOnly<nsresult> rv = GetIncludeSubdomains(&result);
    MOZ_ASSERT(NS_SUCCEEDED(rv));
    return result;
  }

  /* [implicit_jscontext,must_use] readonly attribute jsval originAttributes; */
  MOZ_MUST_USE NS_IMETHOD GetOriginAttributes(JSContext* cx, JS::MutableHandleValue aOriginAttributes) = 0;

  enum {
    SECURITY_PROPERTY_UNSET = 0,
    SECURITY_PROPERTY_SET = 1,
    SECURITY_PROPERTY_KNOCKOUT = 2,
    SECURITY_PROPERTY_NEGATIVE = 3
  };

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsISiteSecurityState, NS_ISITESECURITYSTATE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISITESECURITYSTATE \
  MOZ_MUST_USE NS_IMETHOD GetHostname(nsACString& aHostname) override; \
  using nsISiteSecurityState::GetExpireTime; \
  NS_IMETHOD GetExpireTime(int64_t *aExpireTime) override; \
  using nsISiteSecurityState::GetSecurityPropertyState; \
  NS_IMETHOD GetSecurityPropertyState(int16_t *aSecurityPropertyState) override; \
  using nsISiteSecurityState::GetIncludeSubdomains; \
  NS_IMETHOD GetIncludeSubdomains(bool *aIncludeSubdomains) override; \
  MOZ_MUST_USE NS_IMETHOD GetOriginAttributes(JSContext* cx, JS::MutableHandleValue aOriginAttributes) override; \

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSISITESECURITYSTATE \
  MOZ_MUST_USE nsresult GetHostname(nsACString& aHostname); \
  using nsISiteSecurityState::GetExpireTime; \
  nsresult GetExpireTime(int64_t *aExpireTime); \
  using nsISiteSecurityState::GetSecurityPropertyState; \
  nsresult GetSecurityPropertyState(int16_t *aSecurityPropertyState); \
  using nsISiteSecurityState::GetIncludeSubdomains; \
  nsresult GetIncludeSubdomains(bool *aIncludeSubdomains); \
  MOZ_MUST_USE nsresult GetOriginAttributes(JSContext* cx, JS::MutableHandleValue aOriginAttributes); \

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISITESECURITYSTATE(_to) \
  MOZ_MUST_USE NS_IMETHOD GetHostname(nsACString& aHostname) override { return _to GetHostname(aHostname); } \
  using nsISiteSecurityState::GetExpireTime; \
  NS_IMETHOD GetExpireTime(int64_t *aExpireTime) override { return _to GetExpireTime(aExpireTime); } \
  using nsISiteSecurityState::GetSecurityPropertyState; \
  NS_IMETHOD GetSecurityPropertyState(int16_t *aSecurityPropertyState) override { return _to GetSecurityPropertyState(aSecurityPropertyState); } \
  using nsISiteSecurityState::GetIncludeSubdomains; \
  NS_IMETHOD GetIncludeSubdomains(bool *aIncludeSubdomains) override { return _to GetIncludeSubdomains(aIncludeSubdomains); } \
  MOZ_MUST_USE NS_IMETHOD GetOriginAttributes(JSContext* cx, JS::MutableHandleValue aOriginAttributes) override { return _to GetOriginAttributes(cx, aOriginAttributes); } \

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSISITESECURITYSTATE(_to) \
  MOZ_MUST_USE NS_IMETHOD GetHostname(nsACString& aHostname) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetHostname(aHostname); } \
  NS_IMETHOD GetExpireTime(int64_t *aExpireTime) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetExpireTime(aExpireTime); } \
  NS_IMETHOD GetSecurityPropertyState(int16_t *aSecurityPropertyState) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSecurityPropertyState(aSecurityPropertyState); } \
  NS_IMETHOD GetIncludeSubdomains(bool *aIncludeSubdomains) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIncludeSubdomains(aIncludeSubdomains); } \
  MOZ_MUST_USE NS_IMETHOD GetOriginAttributes(JSContext* cx, JS::MutableHandleValue aOriginAttributes) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetOriginAttributes(cx, aOriginAttributes); } \


/* starting interface:    nsISiteHSTSState */
#define NS_ISITEHSTSSTATE_IID_STR "9ff16e40-1029-496c-95c2-bc819872b216"

#define NS_ISITEHSTSSTATE_IID \
  {0x9ff16e40, 0x1029, 0x496c, \
    { 0x95, 0xc2, 0xbc, 0x81, 0x98, 0x72, 0xb2, 0x16 }}

class NS_NO_VTABLE nsISiteHSTSState : public nsISiteSecurityState {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_ISITEHSTSSTATE_IID)

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsISiteHSTSState, NS_ISITEHSTSSTATE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISITEHSTSSTATE \
  /* no methods! */

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSISITEHSTSSTATE \
  /* no methods! */

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISITEHSTSSTATE(_to) \
  /* no methods! */

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSISITEHSTSSTATE(_to) \
  /* no methods! */


/* starting interface:    nsISiteHPKPState */
#define NS_ISITEHPKPSTATE_IID_STR "ae395078-c7d0-474d-b147-f4aa203a9b2c"

#define NS_ISITEHPKPSTATE_IID \
  {0xae395078, 0xc7d0, 0x474d, \
    { 0xb1, 0x47, 0xf4, 0xaa, 0x20, 0x3a, 0x9b, 0x2c }}

class NS_NO_VTABLE nsISiteHPKPState : public nsISiteSecurityState {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_ISITEHPKPSTATE_IID)

  /* [must_use] readonly attribute nsISimpleEnumerator sha256Keys; */
  MOZ_MUST_USE NS_IMETHOD GetSha256Keys(nsISimpleEnumerator **aSha256Keys) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsISiteHPKPState, NS_ISITEHPKPSTATE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISITEHPKPSTATE \
  MOZ_MUST_USE NS_IMETHOD GetSha256Keys(nsISimpleEnumerator **aSha256Keys) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSISITEHPKPSTATE \
  MOZ_MUST_USE nsresult GetSha256Keys(nsISimpleEnumerator **aSha256Keys); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISITEHPKPSTATE(_to) \
  MOZ_MUST_USE NS_IMETHOD GetSha256Keys(nsISimpleEnumerator **aSha256Keys) override { return _to GetSha256Keys(aSha256Keys); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSISITEHPKPSTATE(_to) \
  MOZ_MUST_USE NS_IMETHOD GetSha256Keys(nsISimpleEnumerator **aSha256Keys) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSha256Keys(aSha256Keys); } 


/* starting interface:    nsISiteSecurityService */
#define NS_ISITESECURITYSERVICE_IID_STR "275127f8-dbd7-4681-afbf-6df0c6587a01"

#define NS_ISITESECURITYSERVICE_IID \
  {0x275127f8, 0xdbd7, 0x4681, \
    { 0xaf, 0xbf, 0x6d, 0xf0, 0xc6, 0x58, 0x7a, 0x01 }}

class NS_NO_VTABLE nsISiteSecurityService : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_ISITESECURITYSERVICE_IID)

  enum {
    HEADER_HSTS = 0U,
    HEADER_HPKP = 1U,
    HEADER_OMS = 2U,
    Success = 0U,
    ERROR_UNKNOWN = 1U,
    ERROR_UNTRUSTWORTHY_CONNECTION = 2U,
    ERROR_COULD_NOT_PARSE_HEADER = 3U,
    ERROR_NO_MAX_AGE = 4U,
    ERROR_MULTIPLE_MAX_AGES = 5U,
    ERROR_INVALID_MAX_AGE = 6U,
    ERROR_MULTIPLE_INCLUDE_SUBDOMAINS = 7U,
    ERROR_INVALID_INCLUDE_SUBDOMAINS = 8U,
    ERROR_INVALID_PIN = 9U,
    ERROR_MULTIPLE_REPORT_URIS = 10U,
    ERROR_PINSET_DOES_NOT_MATCH_CHAIN = 11U,
    ERROR_NO_BACKUP_PIN = 12U,
    ERROR_COULD_NOT_SAVE_STATE = 13U,
    ERROR_ROOT_NOT_BUILT_IN = 14U,
    SOURCE_UNKNOWN = 0U,
    SOURCE_PRELOAD_LIST = 1U,
    SOURCE_ORGANIC_REQUEST = 2U
  };

  /* [binaryname(ProcessHeader),must_use,noscript] void processHeaderNative (in uint32_t aType, in nsIURI aSourceURI, in ACString aHeader, in nsITransportSecurityInfo aSecInfo, in uint32_t aFlags, in uint32_t aSource, in const_OriginAttributesRef aOriginAttributes, [optional] out unsigned long long aMaxAge, [optional] out boolean aIncludeSubdomains, [optional] out uint32_t aFailureResult); */
  MOZ_MUST_USE NS_IMETHOD ProcessHeader(uint32_t aType, nsIURI *aSourceURI, const nsACString& aHeader, nsITransportSecurityInfo *aSecInfo, uint32_t aFlags, uint32_t aSource, const mozilla::OriginAttributes & aOriginAttributes, uint64_t *aMaxAge = nullptr, bool *aIncludeSubdomains = nullptr, uint32_t *aFailureResult = nullptr) = 0;

  /* [binaryname(ProcessHeaderScriptable),implicit_jscontext,must_use,optional_argc] void processHeader (in uint32_t aType, in nsIURI aSourceURI, in ACString aHeader, in nsITransportSecurityInfo aSecInfo, in uint32_t aFlags, in uint32_t aSource, [optional] in jsval aOriginAttributes, [optional] out unsigned long long aMaxAge, [optional] out boolean aIncludeSubdomains, [optional] out uint32_t aFailureResult); */
  JS_HAZ_CAN_RUN_SCRIPT MOZ_MUST_USE NS_IMETHOD ProcessHeaderScriptable(uint32_t aType, nsIURI *aSourceURI, const nsACString& aHeader, nsITransportSecurityInfo *aSecInfo, uint32_t aFlags, uint32_t aSource, JS::HandleValue aOriginAttributes, uint64_t *aMaxAge, bool *aIncludeSubdomains, uint32_t *aFailureResult, JSContext* cx, uint8_t _argc) = 0;

  /* [implicit_jscontext,must_use,optional_argc] void resetState (in uint32_t aType, in nsIURI aURI, in uint32_t aFlags, [optional] in jsval aOriginAttributes); */
  JS_HAZ_CAN_RUN_SCRIPT MOZ_MUST_USE NS_IMETHOD ResetState(uint32_t aType, nsIURI *aURI, uint32_t aFlags, JS::HandleValue aOriginAttributes, JSContext* cx, uint8_t _argc) = 0;

  /* [binaryname(IsSecureURI),must_use,noscript] boolean isSecureURINative (in uint32_t aType, in nsIURI aURI, in uint32_t aFlags, in const_OriginAttributesRef aOriginAttributes, [optional] out boolean aCached, [optional] out uint32_t aSource); */
  MOZ_MUST_USE NS_IMETHOD IsSecureURI(uint32_t aType, nsIURI *aURI, uint32_t aFlags, const mozilla::OriginAttributes & aOriginAttributes, bool *aCached, uint32_t *aSource, bool *_retval) = 0;

  /* [binaryname(IsSecureURIScriptable),implicit_jscontext,must_use,optional_argc] boolean isSecureURI (in uint32_t aType, in nsIURI aURI, in uint32_t aFlags, [optional] in jsval aOriginAttributes, [optional] out boolean aCached, [optional] out uint32_t aSource); */
  JS_HAZ_CAN_RUN_SCRIPT MOZ_MUST_USE NS_IMETHOD IsSecureURIScriptable(uint32_t aType, nsIURI *aURI, uint32_t aFlags, JS::HandleValue aOriginAttributes, bool *aCached, uint32_t *aSource, JSContext* cx, uint8_t _argc, bool *_retval) = 0;

  /* [must_use] void clearAll (); */
  JS_HAZ_CAN_RUN_SCRIPT MOZ_MUST_USE NS_IMETHOD ClearAll(void) = 0;

  /* [must_use] void clearPreloads (); */
  JS_HAZ_CAN_RUN_SCRIPT MOZ_MUST_USE NS_IMETHOD ClearPreloads(void) = 0;

  /* [must_use,noscript] boolean getKeyPinsForHostname (in ACString aHostname, in mozillaPkixTime evalTime, in const_OriginAttributesRef aOriginAttributes, out nsCStringTArrayRef aPinArray, out boolean aIncludeSubdomains); */
  MOZ_MUST_USE NS_IMETHOD GetKeyPinsForHostname(const nsACString& aHostname, mozilla::pkix::Time & evalTime, const mozilla::OriginAttributes & aOriginAttributes, nsTArray<nsCString> & aPinArray, bool *aIncludeSubdomains, bool *_retval) = 0;

  /* [implicit_jscontext,must_use,optional_argc] boolean setKeyPins (in ACString aHost, in boolean aIncludeSubdomains, in int64_t aExpires, in unsigned long aPinCount, [array, size_is (aPinCount)] in string aSha256Pins, [optional] in boolean aIsPreload, [optional] in jsval aOriginAttributes); */
  JS_HAZ_CAN_RUN_SCRIPT MOZ_MUST_USE NS_IMETHOD SetKeyPins(const nsACString& aHost, bool aIncludeSubdomains, int64_t aExpires, uint32_t aPinCount, const char * *aSha256Pins, bool aIsPreload, JS::HandleValue aOriginAttributes, JSContext* cx, uint8_t _argc, bool *_retval) = 0;

  /* [must_use] boolean setHSTSPreload (in ACString aHost, in boolean aIncludesSubdomains, in int64_t aExpires); */
  JS_HAZ_CAN_RUN_SCRIPT MOZ_MUST_USE NS_IMETHOD SetHSTSPreload(const nsACString& aHost, bool aIncludesSubdomains, int64_t aExpires, bool *_retval) = 0;

  /* [must_use] nsISimpleEnumerator enumerate (in uint32_t aType); */
  JS_HAZ_CAN_RUN_SCRIPT MOZ_MUST_USE NS_IMETHOD Enumerate(uint32_t aType, nsISimpleEnumerator **_retval) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsISiteSecurityService, NS_ISITESECURITYSERVICE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISITESECURITYSERVICE \
  MOZ_MUST_USE NS_IMETHOD ProcessHeader(uint32_t aType, nsIURI *aSourceURI, const nsACString& aHeader, nsITransportSecurityInfo *aSecInfo, uint32_t aFlags, uint32_t aSource, const mozilla::OriginAttributes & aOriginAttributes, uint64_t *aMaxAge = nullptr, bool *aIncludeSubdomains = nullptr, uint32_t *aFailureResult = nullptr) override; \
  MOZ_MUST_USE NS_IMETHOD ProcessHeaderScriptable(uint32_t aType, nsIURI *aSourceURI, const nsACString& aHeader, nsITransportSecurityInfo *aSecInfo, uint32_t aFlags, uint32_t aSource, JS::HandleValue aOriginAttributes, uint64_t *aMaxAge, bool *aIncludeSubdomains, uint32_t *aFailureResult, JSContext* cx, uint8_t _argc) override; \
  MOZ_MUST_USE NS_IMETHOD ResetState(uint32_t aType, nsIURI *aURI, uint32_t aFlags, JS::HandleValue aOriginAttributes, JSContext* cx, uint8_t _argc) override; \
  MOZ_MUST_USE NS_IMETHOD IsSecureURI(uint32_t aType, nsIURI *aURI, uint32_t aFlags, const mozilla::OriginAttributes & aOriginAttributes, bool *aCached, uint32_t *aSource, bool *_retval) override; \
  MOZ_MUST_USE NS_IMETHOD IsSecureURIScriptable(uint32_t aType, nsIURI *aURI, uint32_t aFlags, JS::HandleValue aOriginAttributes, bool *aCached, uint32_t *aSource, JSContext* cx, uint8_t _argc, bool *_retval) override; \
  MOZ_MUST_USE NS_IMETHOD ClearAll(void) override; \
  MOZ_MUST_USE NS_IMETHOD ClearPreloads(void) override; \
  MOZ_MUST_USE NS_IMETHOD GetKeyPinsForHostname(const nsACString& aHostname, mozilla::pkix::Time & evalTime, const mozilla::OriginAttributes & aOriginAttributes, nsTArray<nsCString> & aPinArray, bool *aIncludeSubdomains, bool *_retval) override; \
  MOZ_MUST_USE NS_IMETHOD SetKeyPins(const nsACString& aHost, bool aIncludeSubdomains, int64_t aExpires, uint32_t aPinCount, const char * *aSha256Pins, bool aIsPreload, JS::HandleValue aOriginAttributes, JSContext* cx, uint8_t _argc, bool *_retval) override; \
  MOZ_MUST_USE NS_IMETHOD SetHSTSPreload(const nsACString& aHost, bool aIncludesSubdomains, int64_t aExpires, bool *_retval) override; \
  MOZ_MUST_USE NS_IMETHOD Enumerate(uint32_t aType, nsISimpleEnumerator **_retval) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSISITESECURITYSERVICE \
  MOZ_MUST_USE nsresult ProcessHeader(uint32_t aType, nsIURI *aSourceURI, const nsACString& aHeader, nsITransportSecurityInfo *aSecInfo, uint32_t aFlags, uint32_t aSource, const mozilla::OriginAttributes & aOriginAttributes, uint64_t *aMaxAge = nullptr, bool *aIncludeSubdomains = nullptr, uint32_t *aFailureResult = nullptr); \
  MOZ_MUST_USE nsresult ProcessHeaderScriptable(uint32_t aType, nsIURI *aSourceURI, const nsACString& aHeader, nsITransportSecurityInfo *aSecInfo, uint32_t aFlags, uint32_t aSource, JS::HandleValue aOriginAttributes, uint64_t *aMaxAge, bool *aIncludeSubdomains, uint32_t *aFailureResult, JSContext* cx, uint8_t _argc); \
  MOZ_MUST_USE nsresult ResetState(uint32_t aType, nsIURI *aURI, uint32_t aFlags, JS::HandleValue aOriginAttributes, JSContext* cx, uint8_t _argc); \
  MOZ_MUST_USE nsresult IsSecureURI(uint32_t aType, nsIURI *aURI, uint32_t aFlags, const mozilla::OriginAttributes & aOriginAttributes, bool *aCached, uint32_t *aSource, bool *_retval); \
  MOZ_MUST_USE nsresult IsSecureURIScriptable(uint32_t aType, nsIURI *aURI, uint32_t aFlags, JS::HandleValue aOriginAttributes, bool *aCached, uint32_t *aSource, JSContext* cx, uint8_t _argc, bool *_retval); \
  MOZ_MUST_USE nsresult ClearAll(void); \
  MOZ_MUST_USE nsresult ClearPreloads(void); \
  MOZ_MUST_USE nsresult GetKeyPinsForHostname(const nsACString& aHostname, mozilla::pkix::Time & evalTime, const mozilla::OriginAttributes & aOriginAttributes, nsTArray<nsCString> & aPinArray, bool *aIncludeSubdomains, bool *_retval); \
  MOZ_MUST_USE nsresult SetKeyPins(const nsACString& aHost, bool aIncludeSubdomains, int64_t aExpires, uint32_t aPinCount, const char * *aSha256Pins, bool aIsPreload, JS::HandleValue aOriginAttributes, JSContext* cx, uint8_t _argc, bool *_retval); \
  MOZ_MUST_USE nsresult SetHSTSPreload(const nsACString& aHost, bool aIncludesSubdomains, int64_t aExpires, bool *_retval); \
  MOZ_MUST_USE nsresult Enumerate(uint32_t aType, nsISimpleEnumerator **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISITESECURITYSERVICE(_to) \
  MOZ_MUST_USE NS_IMETHOD ProcessHeader(uint32_t aType, nsIURI *aSourceURI, const nsACString& aHeader, nsITransportSecurityInfo *aSecInfo, uint32_t aFlags, uint32_t aSource, const mozilla::OriginAttributes & aOriginAttributes, uint64_t *aMaxAge = nullptr, bool *aIncludeSubdomains = nullptr, uint32_t *aFailureResult = nullptr) override { return _to ProcessHeader(aType, aSourceURI, aHeader, aSecInfo, aFlags, aSource, aOriginAttributes, aMaxAge, aIncludeSubdomains, aFailureResult); } \
  MOZ_MUST_USE NS_IMETHOD ProcessHeaderScriptable(uint32_t aType, nsIURI *aSourceURI, const nsACString& aHeader, nsITransportSecurityInfo *aSecInfo, uint32_t aFlags, uint32_t aSource, JS::HandleValue aOriginAttributes, uint64_t *aMaxAge, bool *aIncludeSubdomains, uint32_t *aFailureResult, JSContext* cx, uint8_t _argc) override { return _to ProcessHeaderScriptable(aType, aSourceURI, aHeader, aSecInfo, aFlags, aSource, aOriginAttributes, aMaxAge, aIncludeSubdomains, aFailureResult, cx, _argc); } \
  MOZ_MUST_USE NS_IMETHOD ResetState(uint32_t aType, nsIURI *aURI, uint32_t aFlags, JS::HandleValue aOriginAttributes, JSContext* cx, uint8_t _argc) override { return _to ResetState(aType, aURI, aFlags, aOriginAttributes, cx, _argc); } \
  MOZ_MUST_USE NS_IMETHOD IsSecureURI(uint32_t aType, nsIURI *aURI, uint32_t aFlags, const mozilla::OriginAttributes & aOriginAttributes, bool *aCached, uint32_t *aSource, bool *_retval) override { return _to IsSecureURI(aType, aURI, aFlags, aOriginAttributes, aCached, aSource, _retval); } \
  MOZ_MUST_USE NS_IMETHOD IsSecureURIScriptable(uint32_t aType, nsIURI *aURI, uint32_t aFlags, JS::HandleValue aOriginAttributes, bool *aCached, uint32_t *aSource, JSContext* cx, uint8_t _argc, bool *_retval) override { return _to IsSecureURIScriptable(aType, aURI, aFlags, aOriginAttributes, aCached, aSource, cx, _argc, _retval); } \
  MOZ_MUST_USE NS_IMETHOD ClearAll(void) override { return _to ClearAll(); } \
  MOZ_MUST_USE NS_IMETHOD ClearPreloads(void) override { return _to ClearPreloads(); } \
  MOZ_MUST_USE NS_IMETHOD GetKeyPinsForHostname(const nsACString& aHostname, mozilla::pkix::Time & evalTime, const mozilla::OriginAttributes & aOriginAttributes, nsTArray<nsCString> & aPinArray, bool *aIncludeSubdomains, bool *_retval) override { return _to GetKeyPinsForHostname(aHostname, evalTime, aOriginAttributes, aPinArray, aIncludeSubdomains, _retval); } \
  MOZ_MUST_USE NS_IMETHOD SetKeyPins(const nsACString& aHost, bool aIncludeSubdomains, int64_t aExpires, uint32_t aPinCount, const char * *aSha256Pins, bool aIsPreload, JS::HandleValue aOriginAttributes, JSContext* cx, uint8_t _argc, bool *_retval) override { return _to SetKeyPins(aHost, aIncludeSubdomains, aExpires, aPinCount, aSha256Pins, aIsPreload, aOriginAttributes, cx, _argc, _retval); } \
  MOZ_MUST_USE NS_IMETHOD SetHSTSPreload(const nsACString& aHost, bool aIncludesSubdomains, int64_t aExpires, bool *_retval) override { return _to SetHSTSPreload(aHost, aIncludesSubdomains, aExpires, _retval); } \
  MOZ_MUST_USE NS_IMETHOD Enumerate(uint32_t aType, nsISimpleEnumerator **_retval) override { return _to Enumerate(aType, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSISITESECURITYSERVICE(_to) \
  MOZ_MUST_USE NS_IMETHOD ProcessHeader(uint32_t aType, nsIURI *aSourceURI, const nsACString& aHeader, nsITransportSecurityInfo *aSecInfo, uint32_t aFlags, uint32_t aSource, const mozilla::OriginAttributes & aOriginAttributes, uint64_t *aMaxAge = nullptr, bool *aIncludeSubdomains = nullptr, uint32_t *aFailureResult = nullptr) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ProcessHeader(aType, aSourceURI, aHeader, aSecInfo, aFlags, aSource, aOriginAttributes, aMaxAge, aIncludeSubdomains, aFailureResult); } \
  MOZ_MUST_USE NS_IMETHOD ProcessHeaderScriptable(uint32_t aType, nsIURI *aSourceURI, const nsACString& aHeader, nsITransportSecurityInfo *aSecInfo, uint32_t aFlags, uint32_t aSource, JS::HandleValue aOriginAttributes, uint64_t *aMaxAge, bool *aIncludeSubdomains, uint32_t *aFailureResult, JSContext* cx, uint8_t _argc) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ProcessHeaderScriptable(aType, aSourceURI, aHeader, aSecInfo, aFlags, aSource, aOriginAttributes, aMaxAge, aIncludeSubdomains, aFailureResult, cx, _argc); } \
  MOZ_MUST_USE NS_IMETHOD ResetState(uint32_t aType, nsIURI *aURI, uint32_t aFlags, JS::HandleValue aOriginAttributes, JSContext* cx, uint8_t _argc) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ResetState(aType, aURI, aFlags, aOriginAttributes, cx, _argc); } \
  MOZ_MUST_USE NS_IMETHOD IsSecureURI(uint32_t aType, nsIURI *aURI, uint32_t aFlags, const mozilla::OriginAttributes & aOriginAttributes, bool *aCached, uint32_t *aSource, bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->IsSecureURI(aType, aURI, aFlags, aOriginAttributes, aCached, aSource, _retval); } \
  MOZ_MUST_USE NS_IMETHOD IsSecureURIScriptable(uint32_t aType, nsIURI *aURI, uint32_t aFlags, JS::HandleValue aOriginAttributes, bool *aCached, uint32_t *aSource, JSContext* cx, uint8_t _argc, bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->IsSecureURIScriptable(aType, aURI, aFlags, aOriginAttributes, aCached, aSource, cx, _argc, _retval); } \
  MOZ_MUST_USE NS_IMETHOD ClearAll(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ClearAll(); } \
  MOZ_MUST_USE NS_IMETHOD ClearPreloads(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ClearPreloads(); } \
  MOZ_MUST_USE NS_IMETHOD GetKeyPinsForHostname(const nsACString& aHostname, mozilla::pkix::Time & evalTime, const mozilla::OriginAttributes & aOriginAttributes, nsTArray<nsCString> & aPinArray, bool *aIncludeSubdomains, bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetKeyPinsForHostname(aHostname, evalTime, aOriginAttributes, aPinArray, aIncludeSubdomains, _retval); } \
  MOZ_MUST_USE NS_IMETHOD SetKeyPins(const nsACString& aHost, bool aIncludeSubdomains, int64_t aExpires, uint32_t aPinCount, const char * *aSha256Pins, bool aIsPreload, JS::HandleValue aOriginAttributes, JSContext* cx, uint8_t _argc, bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetKeyPins(aHost, aIncludeSubdomains, aExpires, aPinCount, aSha256Pins, aIsPreload, aOriginAttributes, cx, _argc, _retval); } \
  MOZ_MUST_USE NS_IMETHOD SetHSTSPreload(const nsACString& aHost, bool aIncludesSubdomains, int64_t aExpires, bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetHSTSPreload(aHost, aIncludesSubdomains, aExpires, _retval); } \
  MOZ_MUST_USE NS_IMETHOD Enumerate(uint32_t aType, nsISimpleEnumerator **_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Enumerate(aType, _retval); } 

#define NS_SSSERVICE_CONTRACTID "@mozilla.org/ssservice;1"

#endif /* __gen_nsISiteSecurityService_h__ */
