/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM /builddir/build/BUILD/firefox-68.6.0/security/manager/ssl/nsIX509Cert.idl
 */

#ifndef __gen_nsIX509Cert_h__
#define __gen_nsIX509Cert_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIArray; /* forward declaration */

class nsIX509CertValidity; /* forward declaration */

class nsIASN1Object; /* forward declaration */

class nsICertVerificationListener; /* forward declaration */

 /* forward declaration */
 typedef struct CERTCertificateStr CERTCertificate;

/* starting interface:    nsIX509Cert */
#define NS_IX509CERT_IID_STR "bdc3979a-5422-4cd5-8589-696b6e96ea83"

#define NS_IX509CERT_IID \
  {0xbdc3979a, 0x5422, 0x4cd5, \
    { 0x85, 0x89, 0x69, 0x6b, 0x6e, 0x96, 0xea, 0x83 }}

class NS_NO_VTABLE nsIX509Cert : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IX509CERT_IID)

  /* readonly attribute AString emailAddress; */
  NS_IMETHOD GetEmailAddress(nsAString& aEmailAddress) = 0;

  /* [must_use] readonly attribute bool isBuiltInRoot; */
  MOZ_MUST_USE NS_IMETHOD GetIsBuiltInRoot(bool *aIsBuiltInRoot) = 0;

  /* [must_use] void getEmailAddresses (out unsigned long length, [array, size_is (length), retval] out wstring addresses); */
  MOZ_MUST_USE NS_IMETHOD GetEmailAddresses(uint32_t *length, char16_t * **addresses) = 0;

  /* [must_use] boolean containsEmailAddress (in AString aEmailAddress); */
  MOZ_MUST_USE NS_IMETHOD ContainsEmailAddress(const nsAString& aEmailAddress, bool *_retval) = 0;

  /* readonly attribute AString subjectName; */
  NS_IMETHOD GetSubjectName(nsAString& aSubjectName) = 0;

  /* readonly attribute AString subjectAltNames; */
  NS_IMETHOD GetSubjectAltNames(nsAString& aSubjectAltNames) = 0;

  /* readonly attribute AString commonName; */
  NS_IMETHOD GetCommonName(nsAString& aCommonName) = 0;

  /* readonly attribute AString organization; */
  NS_IMETHOD GetOrganization(nsAString& aOrganization) = 0;

  /* [must_use] readonly attribute AString organizationalUnit; */
  MOZ_MUST_USE NS_IMETHOD GetOrganizationalUnit(nsAString& aOrganizationalUnit) = 0;

  /* readonly attribute AString sha256Fingerprint; */
  NS_IMETHOD GetSha256Fingerprint(nsAString& aSha256Fingerprint) = 0;

  /* [must_use] readonly attribute AString sha1Fingerprint; */
  MOZ_MUST_USE NS_IMETHOD GetSha1Fingerprint(nsAString& aSha1Fingerprint) = 0;

  /* readonly attribute AString tokenName; */
  NS_IMETHOD GetTokenName(nsAString& aTokenName) = 0;

  /* readonly attribute AString issuerName; */
  NS_IMETHOD GetIssuerName(nsAString& aIssuerName) = 0;

  /* [must_use] readonly attribute AString serialNumber; */
  MOZ_MUST_USE NS_IMETHOD GetSerialNumber(nsAString& aSerialNumber) = 0;

  /* [must_use] readonly attribute AString issuerCommonName; */
  MOZ_MUST_USE NS_IMETHOD GetIssuerCommonName(nsAString& aIssuerCommonName) = 0;

  /* readonly attribute AString issuerOrganization; */
  NS_IMETHOD GetIssuerOrganization(nsAString& aIssuerOrganization) = 0;

  /* [must_use] readonly attribute AString issuerOrganizationUnit; */
  MOZ_MUST_USE NS_IMETHOD GetIssuerOrganizationUnit(nsAString& aIssuerOrganizationUnit) = 0;

  /* readonly attribute nsIX509CertValidity validity; */
  NS_IMETHOD GetValidity(nsIX509CertValidity **aValidity) = 0;

  /* [must_use] readonly attribute ACString dbKey; */
  MOZ_MUST_USE NS_IMETHOD GetDbKey(nsACString& aDbKey) = 0;

  /* [must_use] readonly attribute AString displayName; */
  MOZ_MUST_USE NS_IMETHOD GetDisplayName(nsAString& aDisplayName) = 0;

  enum {
    UNKNOWN_CERT = 0U,
    CA_CERT = 1U,
    USER_CERT = 2U,
    EMAIL_CERT = 4U,
    SERVER_CERT = 8U,
    ANY_CERT = 65535U
  };

  /* readonly attribute unsigned long certType; */
  NS_IMETHOD GetCertType(uint32_t *aCertType) = 0;

  /* [must_use] readonly attribute boolean isSelfSigned; */
  MOZ_MUST_USE NS_IMETHOD GetIsSelfSigned(bool *aIsSelfSigned) = 0;

  /* [must_use] readonly attribute AString keyUsages; */
  MOZ_MUST_USE NS_IMETHOD GetKeyUsages(nsAString& aKeyUsages) = 0;

  /* [must_use] readonly attribute nsIASN1Object ASN1Structure; */
  MOZ_MUST_USE NS_IMETHOD GetASN1Structure(nsIASN1Object **aASN1Structure) = 0;

  /* [must_use] void getRawDER (out unsigned long length, [array, size_is (length), retval] out octet data); */
  MOZ_MUST_USE NS_IMETHOD GetRawDER(uint32_t *length, uint8_t **data) = 0;

  /* [must_use] boolean equals (in nsIX509Cert other); */
  MOZ_MUST_USE NS_IMETHOD Equals(nsIX509Cert *other, bool *_retval) = 0;

  /* [must_use] readonly attribute ACString sha256SubjectPublicKeyInfoDigest; */
  MOZ_MUST_USE NS_IMETHOD GetSha256SubjectPublicKeyInfoDigest(nsACString& aSha256SubjectPublicKeyInfoDigest) = 0;

  /* [must_use,noscript,notxpcom] CERTCertificatePtr getCert (); */
  MOZ_MUST_USE NS_IMETHOD_(CERTCertificate *) GetCert(void) = 0;

  /* [must_use] void markForPermDeletion (); */
  MOZ_MUST_USE NS_IMETHOD MarkForPermDeletion(void) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIX509Cert, NS_IX509CERT_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIX509CERT \
  NS_IMETHOD GetEmailAddress(nsAString& aEmailAddress) override; \
  MOZ_MUST_USE NS_IMETHOD GetIsBuiltInRoot(bool *aIsBuiltInRoot) override; \
  MOZ_MUST_USE NS_IMETHOD GetEmailAddresses(uint32_t *length, char16_t * **addresses) override; \
  MOZ_MUST_USE NS_IMETHOD ContainsEmailAddress(const nsAString& aEmailAddress, bool *_retval) override; \
  NS_IMETHOD GetSubjectName(nsAString& aSubjectName) override; \
  NS_IMETHOD GetSubjectAltNames(nsAString& aSubjectAltNames) override; \
  NS_IMETHOD GetCommonName(nsAString& aCommonName) override; \
  NS_IMETHOD GetOrganization(nsAString& aOrganization) override; \
  MOZ_MUST_USE NS_IMETHOD GetOrganizationalUnit(nsAString& aOrganizationalUnit) override; \
  NS_IMETHOD GetSha256Fingerprint(nsAString& aSha256Fingerprint) override; \
  MOZ_MUST_USE NS_IMETHOD GetSha1Fingerprint(nsAString& aSha1Fingerprint) override; \
  NS_IMETHOD GetTokenName(nsAString& aTokenName) override; \
  NS_IMETHOD GetIssuerName(nsAString& aIssuerName) override; \
  MOZ_MUST_USE NS_IMETHOD GetSerialNumber(nsAString& aSerialNumber) override; \
  MOZ_MUST_USE NS_IMETHOD GetIssuerCommonName(nsAString& aIssuerCommonName) override; \
  NS_IMETHOD GetIssuerOrganization(nsAString& aIssuerOrganization) override; \
  MOZ_MUST_USE NS_IMETHOD GetIssuerOrganizationUnit(nsAString& aIssuerOrganizationUnit) override; \
  NS_IMETHOD GetValidity(nsIX509CertValidity **aValidity) override; \
  MOZ_MUST_USE NS_IMETHOD GetDbKey(nsACString& aDbKey) override; \
  MOZ_MUST_USE NS_IMETHOD GetDisplayName(nsAString& aDisplayName) override; \
  NS_IMETHOD GetCertType(uint32_t *aCertType) override; \
  MOZ_MUST_USE NS_IMETHOD GetIsSelfSigned(bool *aIsSelfSigned) override; \
  MOZ_MUST_USE NS_IMETHOD GetKeyUsages(nsAString& aKeyUsages) override; \
  MOZ_MUST_USE NS_IMETHOD GetASN1Structure(nsIASN1Object **aASN1Structure) override; \
  MOZ_MUST_USE NS_IMETHOD GetRawDER(uint32_t *length, uint8_t **data) override; \
  MOZ_MUST_USE NS_IMETHOD Equals(nsIX509Cert *other, bool *_retval) override; \
  MOZ_MUST_USE NS_IMETHOD GetSha256SubjectPublicKeyInfoDigest(nsACString& aSha256SubjectPublicKeyInfoDigest) override; \
  MOZ_MUST_USE NS_IMETHOD_(CERTCertificate *) GetCert(void) override; \
  MOZ_MUST_USE NS_IMETHOD MarkForPermDeletion(void) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIX509CERT \
  nsresult GetEmailAddress(nsAString& aEmailAddress); \
  MOZ_MUST_USE nsresult GetIsBuiltInRoot(bool *aIsBuiltInRoot); \
  MOZ_MUST_USE nsresult GetEmailAddresses(uint32_t *length, char16_t * **addresses); \
  MOZ_MUST_USE nsresult ContainsEmailAddress(const nsAString& aEmailAddress, bool *_retval); \
  nsresult GetSubjectName(nsAString& aSubjectName); \
  nsresult GetSubjectAltNames(nsAString& aSubjectAltNames); \
  nsresult GetCommonName(nsAString& aCommonName); \
  nsresult GetOrganization(nsAString& aOrganization); \
  MOZ_MUST_USE nsresult GetOrganizationalUnit(nsAString& aOrganizationalUnit); \
  nsresult GetSha256Fingerprint(nsAString& aSha256Fingerprint); \
  MOZ_MUST_USE nsresult GetSha1Fingerprint(nsAString& aSha1Fingerprint); \
  nsresult GetTokenName(nsAString& aTokenName); \
  nsresult GetIssuerName(nsAString& aIssuerName); \
  MOZ_MUST_USE nsresult GetSerialNumber(nsAString& aSerialNumber); \
  MOZ_MUST_USE nsresult GetIssuerCommonName(nsAString& aIssuerCommonName); \
  nsresult GetIssuerOrganization(nsAString& aIssuerOrganization); \
  MOZ_MUST_USE nsresult GetIssuerOrganizationUnit(nsAString& aIssuerOrganizationUnit); \
  nsresult GetValidity(nsIX509CertValidity **aValidity); \
  MOZ_MUST_USE nsresult GetDbKey(nsACString& aDbKey); \
  MOZ_MUST_USE nsresult GetDisplayName(nsAString& aDisplayName); \
  nsresult GetCertType(uint32_t *aCertType); \
  MOZ_MUST_USE nsresult GetIsSelfSigned(bool *aIsSelfSigned); \
  MOZ_MUST_USE nsresult GetKeyUsages(nsAString& aKeyUsages); \
  MOZ_MUST_USE nsresult GetASN1Structure(nsIASN1Object **aASN1Structure); \
  MOZ_MUST_USE nsresult GetRawDER(uint32_t *length, uint8_t **data); \
  MOZ_MUST_USE nsresult Equals(nsIX509Cert *other, bool *_retval); \
  MOZ_MUST_USE nsresult GetSha256SubjectPublicKeyInfoDigest(nsACString& aSha256SubjectPublicKeyInfoDigest); \
  MOZ_MUST_USE nsresult_(CERTCertificate *) GetCert(void); \
  MOZ_MUST_USE nsresult MarkForPermDeletion(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIX509CERT(_to) \
  NS_IMETHOD GetEmailAddress(nsAString& aEmailAddress) override { return _to GetEmailAddress(aEmailAddress); } \
  MOZ_MUST_USE NS_IMETHOD GetIsBuiltInRoot(bool *aIsBuiltInRoot) override { return _to GetIsBuiltInRoot(aIsBuiltInRoot); } \
  MOZ_MUST_USE NS_IMETHOD GetEmailAddresses(uint32_t *length, char16_t * **addresses) override { return _to GetEmailAddresses(length, addresses); } \
  MOZ_MUST_USE NS_IMETHOD ContainsEmailAddress(const nsAString& aEmailAddress, bool *_retval) override { return _to ContainsEmailAddress(aEmailAddress, _retval); } \
  NS_IMETHOD GetSubjectName(nsAString& aSubjectName) override { return _to GetSubjectName(aSubjectName); } \
  NS_IMETHOD GetSubjectAltNames(nsAString& aSubjectAltNames) override { return _to GetSubjectAltNames(aSubjectAltNames); } \
  NS_IMETHOD GetCommonName(nsAString& aCommonName) override { return _to GetCommonName(aCommonName); } \
  NS_IMETHOD GetOrganization(nsAString& aOrganization) override { return _to GetOrganization(aOrganization); } \
  MOZ_MUST_USE NS_IMETHOD GetOrganizationalUnit(nsAString& aOrganizationalUnit) override { return _to GetOrganizationalUnit(aOrganizationalUnit); } \
  NS_IMETHOD GetSha256Fingerprint(nsAString& aSha256Fingerprint) override { return _to GetSha256Fingerprint(aSha256Fingerprint); } \
  MOZ_MUST_USE NS_IMETHOD GetSha1Fingerprint(nsAString& aSha1Fingerprint) override { return _to GetSha1Fingerprint(aSha1Fingerprint); } \
  NS_IMETHOD GetTokenName(nsAString& aTokenName) override { return _to GetTokenName(aTokenName); } \
  NS_IMETHOD GetIssuerName(nsAString& aIssuerName) override { return _to GetIssuerName(aIssuerName); } \
  MOZ_MUST_USE NS_IMETHOD GetSerialNumber(nsAString& aSerialNumber) override { return _to GetSerialNumber(aSerialNumber); } \
  MOZ_MUST_USE NS_IMETHOD GetIssuerCommonName(nsAString& aIssuerCommonName) override { return _to GetIssuerCommonName(aIssuerCommonName); } \
  NS_IMETHOD GetIssuerOrganization(nsAString& aIssuerOrganization) override { return _to GetIssuerOrganization(aIssuerOrganization); } \
  MOZ_MUST_USE NS_IMETHOD GetIssuerOrganizationUnit(nsAString& aIssuerOrganizationUnit) override { return _to GetIssuerOrganizationUnit(aIssuerOrganizationUnit); } \
  NS_IMETHOD GetValidity(nsIX509CertValidity **aValidity) override { return _to GetValidity(aValidity); } \
  MOZ_MUST_USE NS_IMETHOD GetDbKey(nsACString& aDbKey) override { return _to GetDbKey(aDbKey); } \
  MOZ_MUST_USE NS_IMETHOD GetDisplayName(nsAString& aDisplayName) override { return _to GetDisplayName(aDisplayName); } \
  NS_IMETHOD GetCertType(uint32_t *aCertType) override { return _to GetCertType(aCertType); } \
  MOZ_MUST_USE NS_IMETHOD GetIsSelfSigned(bool *aIsSelfSigned) override { return _to GetIsSelfSigned(aIsSelfSigned); } \
  MOZ_MUST_USE NS_IMETHOD GetKeyUsages(nsAString& aKeyUsages) override { return _to GetKeyUsages(aKeyUsages); } \
  MOZ_MUST_USE NS_IMETHOD GetASN1Structure(nsIASN1Object **aASN1Structure) override { return _to GetASN1Structure(aASN1Structure); } \
  MOZ_MUST_USE NS_IMETHOD GetRawDER(uint32_t *length, uint8_t **data) override { return _to GetRawDER(length, data); } \
  MOZ_MUST_USE NS_IMETHOD Equals(nsIX509Cert *other, bool *_retval) override { return _to Equals(other, _retval); } \
  MOZ_MUST_USE NS_IMETHOD GetSha256SubjectPublicKeyInfoDigest(nsACString& aSha256SubjectPublicKeyInfoDigest) override { return _to GetSha256SubjectPublicKeyInfoDigest(aSha256SubjectPublicKeyInfoDigest); } \
  MOZ_MUST_USE NS_IMETHOD_(CERTCertificate *) GetCert(void) override { return _to GetCert(); } \
  MOZ_MUST_USE NS_IMETHOD MarkForPermDeletion(void) override { return _to MarkForPermDeletion(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIX509CERT(_to) \
  NS_IMETHOD GetEmailAddress(nsAString& aEmailAddress) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetEmailAddress(aEmailAddress); } \
  MOZ_MUST_USE NS_IMETHOD GetIsBuiltInRoot(bool *aIsBuiltInRoot) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsBuiltInRoot(aIsBuiltInRoot); } \
  MOZ_MUST_USE NS_IMETHOD GetEmailAddresses(uint32_t *length, char16_t * **addresses) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetEmailAddresses(length, addresses); } \
  MOZ_MUST_USE NS_IMETHOD ContainsEmailAddress(const nsAString& aEmailAddress, bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ContainsEmailAddress(aEmailAddress, _retval); } \
  NS_IMETHOD GetSubjectName(nsAString& aSubjectName) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSubjectName(aSubjectName); } \
  NS_IMETHOD GetSubjectAltNames(nsAString& aSubjectAltNames) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSubjectAltNames(aSubjectAltNames); } \
  NS_IMETHOD GetCommonName(nsAString& aCommonName) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCommonName(aCommonName); } \
  NS_IMETHOD GetOrganization(nsAString& aOrganization) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetOrganization(aOrganization); } \
  MOZ_MUST_USE NS_IMETHOD GetOrganizationalUnit(nsAString& aOrganizationalUnit) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetOrganizationalUnit(aOrganizationalUnit); } \
  NS_IMETHOD GetSha256Fingerprint(nsAString& aSha256Fingerprint) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSha256Fingerprint(aSha256Fingerprint); } \
  MOZ_MUST_USE NS_IMETHOD GetSha1Fingerprint(nsAString& aSha1Fingerprint) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSha1Fingerprint(aSha1Fingerprint); } \
  NS_IMETHOD GetTokenName(nsAString& aTokenName) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTokenName(aTokenName); } \
  NS_IMETHOD GetIssuerName(nsAString& aIssuerName) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIssuerName(aIssuerName); } \
  MOZ_MUST_USE NS_IMETHOD GetSerialNumber(nsAString& aSerialNumber) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSerialNumber(aSerialNumber); } \
  MOZ_MUST_USE NS_IMETHOD GetIssuerCommonName(nsAString& aIssuerCommonName) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIssuerCommonName(aIssuerCommonName); } \
  NS_IMETHOD GetIssuerOrganization(nsAString& aIssuerOrganization) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIssuerOrganization(aIssuerOrganization); } \
  MOZ_MUST_USE NS_IMETHOD GetIssuerOrganizationUnit(nsAString& aIssuerOrganizationUnit) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIssuerOrganizationUnit(aIssuerOrganizationUnit); } \
  NS_IMETHOD GetValidity(nsIX509CertValidity **aValidity) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetValidity(aValidity); } \
  MOZ_MUST_USE NS_IMETHOD GetDbKey(nsACString& aDbKey) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDbKey(aDbKey); } \
  MOZ_MUST_USE NS_IMETHOD GetDisplayName(nsAString& aDisplayName) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDisplayName(aDisplayName); } \
  NS_IMETHOD GetCertType(uint32_t *aCertType) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCertType(aCertType); } \
  MOZ_MUST_USE NS_IMETHOD GetIsSelfSigned(bool *aIsSelfSigned) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsSelfSigned(aIsSelfSigned); } \
  MOZ_MUST_USE NS_IMETHOD GetKeyUsages(nsAString& aKeyUsages) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetKeyUsages(aKeyUsages); } \
  MOZ_MUST_USE NS_IMETHOD GetASN1Structure(nsIASN1Object **aASN1Structure) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetASN1Structure(aASN1Structure); } \
  MOZ_MUST_USE NS_IMETHOD GetRawDER(uint32_t *length, uint8_t **data) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRawDER(length, data); } \
  MOZ_MUST_USE NS_IMETHOD Equals(nsIX509Cert *other, bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Equals(other, _retval); } \
  MOZ_MUST_USE NS_IMETHOD GetSha256SubjectPublicKeyInfoDigest(nsACString& aSha256SubjectPublicKeyInfoDigest) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSha256SubjectPublicKeyInfoDigest(aSha256SubjectPublicKeyInfoDigest); } \
  MOZ_MUST_USE NS_IMETHOD_(CERTCertificate *) GetCert(void) override; \
  MOZ_MUST_USE NS_IMETHOD MarkForPermDeletion(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->MarkForPermDeletion(); } 


#endif /* __gen_nsIX509Cert_h__ */
