/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* THIS FILE IS AUTOGENERATED FROM HiddenPluginEvent.webidl BY Codegen.py - DO NOT EDIT */

#include "EventBinding.h"
#include "HiddenPluginEvent.h"
#include "HiddenPluginEventBinding.h"
#include "js/GCAPI.h"
#include "mozilla/dom/HiddenPluginEvent.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "nsIPluginTag.h"

namespace mozilla {
namespace dom {


NS_IMPL_CYCLE_COLLECTION_CLASS(HiddenPluginEvent)

NS_IMPL_ADDREF_INHERITED(HiddenPluginEvent, Event)
NS_IMPL_RELEASE_INHERITED(HiddenPluginEvent, Event)

NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN_INHERITED(HiddenPluginEvent, Event)
  NS_IMPL_CYCLE_COLLECTION_TRAVERSE(mTag)
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END

NS_IMPL_CYCLE_COLLECTION_TRACE_BEGIN_INHERITED(HiddenPluginEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRACE_END

NS_IMPL_CYCLE_COLLECTION_UNLINK_BEGIN_INHERITED(HiddenPluginEvent, Event)
  NS_IMPL_CYCLE_COLLECTION_UNLINK(mTag)
NS_IMPL_CYCLE_COLLECTION_UNLINK_END

NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION(HiddenPluginEvent)
NS_INTERFACE_MAP_END_INHERITING(Event)

HiddenPluginEvent::HiddenPluginEvent(mozilla::dom::EventTarget* aOwner)
  : Event(aOwner, nullptr, nullptr)
{
}

HiddenPluginEvent::~HiddenPluginEvent()
{
}

HiddenPluginEvent*
HiddenPluginEvent::AsHiddenPluginEvent()
{
  return this;
}

JSObject*
HiddenPluginEvent::WrapObjectInternal(JSContext* aCx, JS::Handle<JSObject*> aGivenProto)
{
  return HiddenPluginEvent_Binding::Wrap(aCx, this, aGivenProto);
}

already_AddRefed<HiddenPluginEvent>
HiddenPluginEvent::Constructor(mozilla::dom::EventTarget* aOwner, const nsAString& aType, const HiddenPluginEventInit& aEventInit)
{
  RefPtr<HiddenPluginEvent> e = new HiddenPluginEvent(aOwner);
  bool trusted = e->Init(aOwner);
  e->InitEvent(aType, aEventInit.mBubbles, aEventInit.mCancelable);
  e->mTag = aEventInit.mTag;
  e->SetTrusted(trusted);
  e->SetComposed(aEventInit.mComposed);
  return e.forget();
}

already_AddRefed<HiddenPluginEvent>
HiddenPluginEvent::Constructor(const GlobalObject& aGlobal, const nsAString& aType, const HiddenPluginEventInit& aEventInit, ErrorResult& aRv)
{
  nsCOMPtr<mozilla::dom::EventTarget> owner = do_QueryInterface(aGlobal.GetAsSupports());
  return Constructor(owner, aType, aEventInit);
}

nsIPluginTag*
HiddenPluginEvent::GetTag() const
{
  return mTag;
}


} // namespace dom
} // namespace mozilla
