/* THIS FILE IS AUTOGENERATED FROM LoadURIOptions.webidl BY Codegen.py - DO NOT EDIT */

#include "AtomList.h"
#include "LoadURIOptionsBinding.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/TypeTraits.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/ScriptSettings.h"

namespace mozilla {
namespace dom {

namespace binding_detail {}; // Just to make sure it's known as a namespace
using namespace mozilla::dom::binding_detail;



LoadURIOptions::LoadURIOptions()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
LoadURIOptions::InitIds(JSContext* cx, LoadURIOptionsAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->triggeringPrincipal_id.init(cx, "triggeringPrincipal") ||
      !atomsCache->referrerInfo_id.init(cx, "referrerInfo") ||
      !atomsCache->postData_id.init(cx, "postData") ||
      !atomsCache->loadFlags_id.init(cx, "loadFlags") ||
      !atomsCache->headers_id.init(cx, "headers") ||
      !atomsCache->csp_id.init(cx, "csp") ||
      !atomsCache->baseURI_id.init(cx, "baseURI")) {
    return false;
  }
  return true;
}

bool
LoadURIOptions::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  // Also evaluate isNullOrUndefined in order to avoid false-positive
  // checkers by static analysis tools
  MOZ_ASSERT_IF(!cx, val.isNull() && val.isNullOrUndefined());
  LoadURIOptionsAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<LoadURIOptionsAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    MOZ_ASSERT(cx);
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->baseURI_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (temp.ref().isObject()) {
      static_assert(IsRefcounted<nsIURI>::value, "We can only store refcounted classes.");
      RefPtr<nsIURI> holder;
      JS::Rooted<JSObject*> source(cx, &temp.ref().toObject());
      if (NS_FAILED(UnwrapArg<nsIURI>(cx, source, getter_AddRefs(holder)))) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "'baseURI' member of LoadURIOptions", "URI");
        return false;
      }
      MOZ_ASSERT(holder);
      mBaseURI = holder;
    } else if (temp.ref().isNullOrUndefined()) {
      mBaseURI = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'baseURI' member of LoadURIOptions");
      return false;
    }
  } else {
    mBaseURI = nullptr;
  }
  mIsAnyMemberPresent = true;

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->csp_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (temp.ref().isObject()) {
      static_assert(IsRefcounted<nsIContentSecurityPolicy>::value, "We can only store refcounted classes.");
      RefPtr<nsIContentSecurityPolicy> holder;
      JS::Rooted<JSObject*> source(cx, &temp.ref().toObject());
      if (NS_FAILED(UnwrapArg<nsIContentSecurityPolicy>(cx, source, getter_AddRefs(holder)))) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "'csp' member of LoadURIOptions", "ContentSecurityPolicy");
        return false;
      }
      MOZ_ASSERT(holder);
      mCsp = holder;
    } else if (temp.ref().isNullOrUndefined()) {
      mCsp = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'csp' member of LoadURIOptions");
      return false;
    }
  } else {
    mCsp = nullptr;
  }
  mIsAnyMemberPresent = true;

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->headers_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (temp.ref().isObject()) {
      static_assert(IsRefcounted<nsIInputStream>::value, "We can only store refcounted classes.");
      RefPtr<nsIInputStream> holder;
      JS::Rooted<JSObject*> source(cx, &temp.ref().toObject());
      if (NS_FAILED(UnwrapArg<nsIInputStream>(cx, source, getter_AddRefs(holder)))) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "'headers' member of LoadURIOptions", "InputStream");
        return false;
      }
      MOZ_ASSERT(holder);
      mHeaders = holder;
    } else if (temp.ref().isNullOrUndefined()) {
      mHeaders = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'headers' member of LoadURIOptions");
      return false;
    }
  } else {
    mHeaders = nullptr;
  }
  mIsAnyMemberPresent = true;

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->loadFlags_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<int32_t, eDefault>(cx, temp.ref(), &mLoadFlags)) {
      return false;
    }
  } else {
    mLoadFlags = 0;
  }
  mIsAnyMemberPresent = true;

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->postData_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (temp.ref().isObject()) {
      static_assert(IsRefcounted<nsIInputStream>::value, "We can only store refcounted classes.");
      RefPtr<nsIInputStream> holder;
      JS::Rooted<JSObject*> source(cx, &temp.ref().toObject());
      if (NS_FAILED(UnwrapArg<nsIInputStream>(cx, source, getter_AddRefs(holder)))) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "'postData' member of LoadURIOptions", "InputStream");
        return false;
      }
      MOZ_ASSERT(holder);
      mPostData = holder;
    } else if (temp.ref().isNullOrUndefined()) {
      mPostData = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'postData' member of LoadURIOptions");
      return false;
    }
  } else {
    mPostData = nullptr;
  }
  mIsAnyMemberPresent = true;

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->referrerInfo_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (temp.ref().isObject()) {
      static_assert(IsRefcounted<nsIReferrerInfo>::value, "We can only store refcounted classes.");
      RefPtr<nsIReferrerInfo> holder;
      JS::Rooted<JSObject*> source(cx, &temp.ref().toObject());
      if (NS_FAILED(UnwrapArg<nsIReferrerInfo>(cx, source, getter_AddRefs(holder)))) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "'referrerInfo' member of LoadURIOptions", "ReferrerInfo");
        return false;
      }
      MOZ_ASSERT(holder);
      mReferrerInfo = holder;
    } else if (temp.ref().isNullOrUndefined()) {
      mReferrerInfo = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'referrerInfo' member of LoadURIOptions");
      return false;
    }
  } else {
    mReferrerInfo = nullptr;
  }
  mIsAnyMemberPresent = true;

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->triggeringPrincipal_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (temp.ref().isObject()) {
      static_assert(IsRefcounted<nsIPrincipal>::value, "We can only store refcounted classes.");
      RefPtr<nsIPrincipal> holder;
      JS::Rooted<JSObject*> source(cx, &temp.ref().toObject());
      if (NS_FAILED(UnwrapArg<nsIPrincipal>(cx, source, getter_AddRefs(holder)))) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "'triggeringPrincipal' member of LoadURIOptions", "Principal");
        return false;
      }
      MOZ_ASSERT(holder);
      mTriggeringPrincipal = holder;
    } else if (temp.ref().isNullOrUndefined()) {
      mTriggeringPrincipal = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'triggeringPrincipal' member of LoadURIOptions");
      return false;
    }
  } else {
    mTriggeringPrincipal = nullptr;
  }
  mIsAnyMemberPresent = true;
  return true;
}

bool
LoadURIOptions::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  LoadURIOptionsAtoms* atomsCache = GetAtomCache<LoadURIOptionsAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    RefPtr<nsIURI> const & currentValue = mBaseURI;
    if (!currentValue) {
      temp.setNull();
      if (!JS_DefinePropertyById(cx, obj, atomsCache->baseURI_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    }
    if (!WrapObject(cx, currentValue, &NS_GET_IID(nsIURI), &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->baseURI_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(false);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    RefPtr<nsIContentSecurityPolicy> const & currentValue = mCsp;
    if (!currentValue) {
      temp.setNull();
      if (!JS_DefinePropertyById(cx, obj, atomsCache->csp_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    }
    if (!WrapObject(cx, currentValue, &NS_GET_IID(nsIContentSecurityPolicy), &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->csp_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(false);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    RefPtr<nsIInputStream> const & currentValue = mHeaders;
    if (!currentValue) {
      temp.setNull();
      if (!JS_DefinePropertyById(cx, obj, atomsCache->headers_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    }
    if (!WrapObject(cx, currentValue, &NS_GET_IID(nsIInputStream), &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->headers_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(false);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    int32_t const & currentValue = mLoadFlags;
    temp.setInt32(int32_t(currentValue));
    if (!JS_DefinePropertyById(cx, obj, atomsCache->loadFlags_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(false);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    RefPtr<nsIInputStream> const & currentValue = mPostData;
    if (!currentValue) {
      temp.setNull();
      if (!JS_DefinePropertyById(cx, obj, atomsCache->postData_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    }
    if (!WrapObject(cx, currentValue, &NS_GET_IID(nsIInputStream), &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->postData_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(false);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    RefPtr<nsIReferrerInfo> const & currentValue = mReferrerInfo;
    if (!currentValue) {
      temp.setNull();
      if (!JS_DefinePropertyById(cx, obj, atomsCache->referrerInfo_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    }
    if (!WrapObject(cx, currentValue, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->referrerInfo_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(false);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    RefPtr<nsIPrincipal> const & currentValue = mTriggeringPrincipal;
    if (!currentValue) {
      temp.setNull();
      if (!JS_DefinePropertyById(cx, obj, atomsCache->triggeringPrincipal_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    }
    if (!WrapObject(cx, currentValue, &NS_GET_IID(nsIPrincipal), &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->triggeringPrincipal_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(false);

  return true;
}

void
LoadURIOptions::TraceDictionary(JSTracer* trc)
{
}



LoadURIOptions&
LoadURIOptions::operator=(const LoadURIOptions& aOther)
{
  DictionaryBase::operator=(aOther);
  mBaseURI = aOther.mBaseURI;
  mCsp = aOther.mCsp;
  mHeaders = aOther.mHeaders;
  mLoadFlags = aOther.mLoadFlags;
  mPostData = aOther.mPostData;
  mReferrerInfo = aOther.mReferrerInfo;
  mTriggeringPrincipal = aOther.mTriggeringPrincipal;
  return *this;
}

namespace binding_detail {
} // namespace binding_detail


} // namespace dom
} // namespace mozilla
