/* THIS FILE IS AUTOGENERATED FROM MozFrameLoaderOwner.webidl BY Codegen.py - DO NOT EDIT */

#include "AtomList.h"
#include "MozFrameLoaderOwnerBinding.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/TypeTraits.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/ScriptSettings.h"

namespace mozilla {
namespace dom {

namespace binding_detail {}; // Just to make sure it's known as a namespace
using namespace mozilla::dom::binding_detail;



RemotenessOptions::RemotenessOptions()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
RemotenessOptions::InitIds(JSContext* cx, RemotenessOptionsAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->sameProcessAsFrameLoader_id.init(cx, "sameProcessAsFrameLoader") ||
      !atomsCache->replaceBrowsingContext_id.init(cx, "replaceBrowsingContext") ||
      !atomsCache->remoteType_id.init(cx, "remoteType") ||
      !atomsCache->pendingSwitchID_id.init(cx, "pendingSwitchID") ||
      !atomsCache->opener_id.init(cx, "opener")) {
    return false;
  }
  return true;
}

bool
RemotenessOptions::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  // Also evaluate isNullOrUndefined in order to avoid false-positive
  // checkers by static analysis tools
  MOZ_ASSERT_IF(!cx, val.isNull() && val.isNullOrUndefined());
  RemotenessOptionsAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<RemotenessOptionsAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    MOZ_ASSERT(cx);
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->opener_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mOpener.Construct();
    if (temp.ref().isObject()) {
      JS::Rooted<JSObject*> source(cx, &temp.ref().toObject());
      if (NS_FAILED(UnwrapWindowProxyArg(cx, source, (mOpener.Value()).SetValue()))) {
          ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "'opener' member of RemotenessOptions", "WindowProxy");
          return false;
      }
    } else if (temp.ref().isNullOrUndefined()) {
      (mOpener.Value()).SetNull();
    } else {
      ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "'opener' member of RemotenessOptions", "WindowProxy");
      return false;
    }
    mIsAnyMemberPresent = true;
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->pendingSwitchID_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mPendingSwitchID.Construct();
    if (!ValueToPrimitive<uint64_t, eDefault>(cx, temp.ref(), &(mPendingSwitchID.Value()))) {
      return false;
    }
    mIsAnyMemberPresent = true;
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->remoteType_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mRemoteType.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eNull, eNull, (mRemoteType.Value()))) {
      return false;
    }
    mIsAnyMemberPresent = true;
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->replaceBrowsingContext_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &mReplaceBrowsingContext)) {
      return false;
    }
  } else {
    mReplaceBrowsingContext = false;
  }
  mIsAnyMemberPresent = true;

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->sameProcessAsFrameLoader_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mSameProcessAsFrameLoader.Construct();
    if (temp.ref().isObject()) {
      static_assert(IsRefcounted<nsFrameLoader>::value, "We can only store refcounted classes.");
      {
        // Our JSContext should be in the right global to do unwrapping in.
        nsresult rv = UnwrapObject<prototypes::id::FrameLoader, nsFrameLoader>(temp.ptr(), (mSameProcessAsFrameLoader.Value()), cx);
        if (NS_FAILED(rv)) {
          ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "'sameProcessAsFrameLoader' member of RemotenessOptions", "FrameLoader");
          return false;
        }
      }
    } else if (temp.ref().isNullOrUndefined()) {
      (mSameProcessAsFrameLoader.Value()) = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'sameProcessAsFrameLoader' member of RemotenessOptions");
      return false;
    }
    mIsAnyMemberPresent = true;
  }
  return true;
}

bool
RemotenessOptions::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  RemotenessOptionsAtoms* atomsCache = GetAtomCache<RemotenessOptionsAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mOpener.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      Nullable<mozilla::dom::WindowProxyHolder> const & currentValue = mOpener.InternalValue();
      if (currentValue.IsNull()) {
        temp.setNull();
        if (!JS_DefinePropertyById(cx, obj, atomsCache->opener_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      }
      if (!WrapObject(cx, currentValue.Value(), &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->opener_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(false);
  }

  if (mPendingSwitchID.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint64_t const & currentValue = mPendingSwitchID.InternalValue();
      temp.set(JS_NumberValue(double(currentValue)));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->pendingSwitchID_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(false);
  }

  if (mRemoteType.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mRemoteType.InternalValue();
      if (!xpc::StringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->remoteType_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(false);
  }

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    bool const & currentValue = mReplaceBrowsingContext;
    temp.setBoolean(currentValue);
    if (!JS_DefinePropertyById(cx, obj, atomsCache->replaceBrowsingContext_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(false);

  if (mSameProcessAsFrameLoader.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      RefPtr<nsFrameLoader> const & currentValue = mSameProcessAsFrameLoader.InternalValue();
      if (!currentValue) {
        temp.setNull();
        if (!JS_DefinePropertyById(cx, obj, atomsCache->sameProcessAsFrameLoader_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      }
      if (!GetOrCreateDOMReflector(cx, currentValue, &temp)) {
        MOZ_ASSERT(JS_IsExceptionPending(cx));
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->sameProcessAsFrameLoader_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(false);
  }

  return true;
}

void
RemotenessOptions::TraceDictionary(JSTracer* trc)
{
}



RemotenessOptions&
RemotenessOptions::operator=(const RemotenessOptions& aOther)
{
  DictionaryBase::operator=(aOther);
  mOpener.Reset();
  if (aOther.mOpener.WasPassed()) {
    mOpener.Construct(aOther.mOpener.Value());
  }
  mPendingSwitchID.Reset();
  if (aOther.mPendingSwitchID.WasPassed()) {
    mPendingSwitchID.Construct(aOther.mPendingSwitchID.Value());
  }
  mRemoteType.Reset();
  if (aOther.mRemoteType.WasPassed()) {
    mRemoteType.Construct(aOther.mRemoteType.Value());
  }
  mReplaceBrowsingContext = aOther.mReplaceBrowsingContext;
  mSameProcessAsFrameLoader.Reset();
  if (aOther.mSameProcessAsFrameLoader.WasPassed()) {
    mSameProcessAsFrameLoader.Construct(aOther.mSameProcessAsFrameLoader.Value());
  }
  return *this;
}

namespace binding_detail {
} // namespace binding_detail


} // namespace dom
} // namespace mozilla
