//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/cache/PCacheChild.h"
#include "mozilla/dom/cache/CacheChild.h"

#include "mozilla/ipc/PBackgroundChild.h"
#include "mozilla/dom/cache/PCacheOpChild.h"
#include "mozilla/dom/cache/PCacheStreamControlChild.h"
#include "mozilla/ipc/PFileDescriptorSetChild.h"
#include "mozilla/ipc/PChildToParentStreamChild.h"
#include "mozilla/ipc/PParentToChildStreamChild.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace dom {
namespace cache {


auto PCacheChild::Recv__delete__() -> mozilla::ipc::IPCResult
{
    return IPC_OK();
}

auto PCacheChild::ActorDestroy(ActorDestroyReason aWhy) -> void
{
}

MOZ_IMPLICIT PCacheChild::PCacheChild() :
    mozilla::ipc::IProtocol(mozilla::ipc::ChildSide),
    mLivenessState(mozilla::ipc::LivenessState::Dead)
{
    MOZ_COUNT_CTOR(PCacheChild);
}

PCacheChild::~PCacheChild()
{
    MOZ_COUNT_DTOR(PCacheChild);
}

auto PCacheChild::Manager() const -> PBackgroundChild*
{
    return static_cast<PBackgroundChild*>(IProtocol::Manager());
}

auto PCacheChild::ManagedPCacheOpChild(nsTArray<PCacheOpChild*>& aArr) const -> void
{
    (mManagedPCacheOpChild).ToArray(aArr);
}

auto PCacheChild::ManagedPCacheOpChild() const -> const ManagedContainer<PCacheOpChild>&
{
    return mManagedPCacheOpChild;
}

auto PCacheChild::OpenPCacheOpEndpoint(PCacheOpChild* aActor) -> ManagedEndpoint<PCacheOpParent>
{
    if ((!(aActor))) {
        NS_WARNING("Error constructing actor PCacheOpChild");
        return ManagedEndpoint<PCacheOpParent>();
    }
    (aActor)->SetManagerAndRegister(this);
    (mManagedPCacheOpChild).PutEntry(aActor);
    (aActor)->mLivenessState = mozilla::ipc::LivenessState::Start;

    return ManagedEndpoint<PCacheOpParent>(mozilla::ipc::PrivateIPDLInterface(), (aActor)->Id());
}

auto PCacheChild::BindPCacheOpEndpoint(
        ManagedEndpoint<PCacheOpChild> aEndpoint,
        PCacheOpChild* aActor) -> bool
{
    MOZ_RELEASE_ASSERT((aEndpoint).ActorId(), "Invalid Endpoint!");
    if ((!(aActor))) {
        NS_WARNING("Error constructing actor PCacheOpChild");
        return false;
    }
    (aActor)->SetManagerAndRegister(this, (*((aEndpoint).ActorId())));
    (mManagedPCacheOpChild).PutEntry(aActor);
    (aActor)->mLivenessState = mozilla::ipc::LivenessState::Start;

    return true;
}

auto PCacheChild::SendPCacheOpConstructor(const CacheOpArgs& aOpArgs) -> PCacheOpChild*
{
    return SendPCacheOpConstructor((static_cast<CacheChild*>(this))->AllocPCacheOpChild(aOpArgs), aOpArgs);
}

auto PCacheChild::SendPCacheOpConstructor(
        PCacheOpChild* actor,
        const CacheOpArgs& aOpArgs) -> PCacheOpChild*
{
    if ((!(actor))) {
        NS_WARNING("Error constructing actor PCacheOpChild");
        return nullptr;
    }
    (actor)->SetManagerAndRegister(this);
    (mManagedPCacheOpChild).PutEntry(actor);
    (actor)->mLivenessState = mozilla::ipc::LivenessState::Start;

    IPC::Message* msg__ = PCache::Msg_PCacheOpConstructor(Id());

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    WriteIPDLParam(msg__, this, actor);
    // Sentinel = 'actor'
    (msg__)->WriteSentinel(875202478);
    WriteIPDLParam(msg__, this, aOpArgs);
    // Sentinel = 'aOpArgs'
    (msg__)->WriteSentinel(2628124652);



    if (mozilla::ipc::LoggingEnabledFor("PCacheChild")) {
        mozilla::ipc::LogMessageForProtocol("PCacheChild", OtherPid(), "Sending ", (msg__)->type(), mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PCache::Msg_PCacheOpConstructor", OTHER);
    if ((!(StateTransition(false, (&(mLivenessState)))))) {
        mozilla::ipc::LogicError("Transition error");
    }

    bool sendok__ = (GetIPCChannel())->Send(msg__);
    if ((!(sendok__))) {
        NS_WARNING("Error sending constructor");
    }
    return actor;
}

auto PCacheChild::SendTeardown() -> bool
{
    IPC::Message* msg__ = PCache::Msg_Teardown(Id());





    if (mozilla::ipc::LoggingEnabledFor("PCacheChild")) {
        mozilla::ipc::LogMessageForProtocol("PCacheChild", OtherPid(), "Sending ", (msg__)->type(), mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PCache::Msg_Teardown", OTHER);
    if ((!(StateTransition(false, (&(mLivenessState)))))) {
        mozilla::ipc::LogicError("Transition error");
    }

    bool sendok__ = (GetIPCChannel())->Send(msg__);
    return sendok__;
}

auto PCacheChild::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    case PCacheOpMsgStart:
        {
            PCacheOpChild* actor = static_cast<PCacheOpChild*>(aListener);
            auto& container = mManagedPCacheOpChild;
            MOZ_RELEASE_ASSERT((container).Contains(actor), "actor not managed by this!");

            (container).RemoveEntry(actor);
            (static_cast<CacheChild*>(this))->DeallocPCacheOpChild(actor);
            return;
        }
    default:
        {
            FatalError("unreached");
            return;
        }
    }
}

auto PCacheChild::OnMessageReceived(const Message& msg__) -> PCacheChild::Result
{
    switch ((msg__).type()) {
    case PCache::Reply_PCacheOpConstructor__ID:
        {
            return MsgProcessed;
        }
    case PCache::Msg___delete____ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PCacheChild")) {
                mozilla::ipc::LogMessageForProtocol("PCacheChild", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PCache::Msg___delete__", OTHER);

            PickleIterator iter__(msg__);
            PCacheChild* actor;

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(actor)))))) {
                FatalError("Error deserializing 'PCache'");
                return MsgValueError;
            }
            if ((!((*((&(actor))))))) {
                FatalError("Error deserializing 'PCache'");
                return MsgValueError;
            }
            // Sentinel = 'actor'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 875202478)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'PCache'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__, (msg__).type());
            if ((!(StateTransition(true, (&(mLivenessState)))))) {
                FatalError("Transition error");
                return MsgValueError;
            }
            if ((!((static_cast<CacheChild*>(this))->Recv__delete__()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }


            IProtocol* mgr = (actor)->Manager();
            (actor)->DestroySubtree(Deletion);
            (actor)->DeallocSubtree();
            (mgr)->RemoveManagee(PCacheMsgStart, actor);

            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PCacheChild::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PCacheChild::Result
{
    return MsgNotKnown;
}

auto PCacheChild::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PCacheChild::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PCacheChild::GetProtocolTypeId() -> int32_t
{
    return PCacheMsgStart;
}

auto PCacheChild::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(Id());

    ActorDestroyReason subtreewhy = (((why) == (Deletion)) || ((why) == (FailedConstructor)) ? AncestorDeletion : why);

    {
        // Recursively shutting down PCacheOp kids
        nsTArray<PCacheOpChild*> kids;
        // Accumulate kids into a stable structure to iterate over
        ManagedPCacheOpChild(kids);
        for (auto& kid : kids) {
            // Guarding against a child removing a sibling from the list during the iteration.
            if ((mManagedPCacheOpChild).Contains(kid)) {
                (kid)->DestroySubtree(subtreewhy);
            }
        }
    }

    // Reject owning pending responses.
    (GetIPCChannel())->RejectPendingResponsesForActor(this);

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PCacheChild::DeallocSubtree() -> void
{
    {
        // Recursively deleting PCacheOp kids
        for (auto iter = (mManagedPCacheOpChild).Iter(); (!((iter).Done())); (iter).Next()) {
            (((iter).Get())->GetKey())->DeallocSubtree();
        }

        for (auto iter = (mManagedPCacheOpChild).Iter(); (!((iter).Done())); (iter).Next()) {
            (static_cast<CacheChild*>(this))->DeallocPCacheOpChild(((iter).Get())->GetKey());
        }
        (mManagedPCacheOpChild).Clear();
    }
}



} // namespace cache
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::dom::cache::PCacheChild>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    int32_t id;
    if ((!(aVar))) {
        id = 0;
    }
    else {
        id = (aVar)->Id();
        if ((1) == (id)) {
            (aActor)->FatalError("actor has been |delete|d");
        }
        MOZ_ASSERT(((aActor)->GetIPCChannel()) == ((aVar)->GetIPCChannel()), "Actor must be from the same channel as the actor it's being sent over");
    }
    WriteIPDLParam(aMsg, aActor, id);
}

auto IPDLParamTraits<mozilla::dom::cache::PCacheChild>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor = (aActor)->ReadActor(aMsg, aIter, true, "PCache", PCacheMsgStart);
    if ((actor).isNothing()) {
        return false;
    }

    (*(aVar)) = static_cast<mozilla::dom::cache::PCacheChild*>((actor).value());
    return true;
}

} // namespace ipc
} // namespace mozilla
