//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/cache/PCacheParent.h"
#include "mozilla/dom/cache/CacheParent.h"

#include "mozilla/ipc/PBackgroundParent.h"
#include "mozilla/dom/cache/PCacheOpParent.h"
#include "mozilla/dom/cache/PCacheStreamControlParent.h"
#include "mozilla/ipc/PFileDescriptorSetParent.h"
#include "mozilla/ipc/PChildToParentStreamParent.h"
#include "mozilla/ipc/PParentToChildStreamParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace dom {
namespace cache {


auto PCacheParent::RecvPCacheOpConstructor(
        PCacheOpParent* actor,
        const CacheOpArgs& aOpArgs) -> mozilla::ipc::IPCResult
{
    return IPC_OK();
}

MOZ_IMPLICIT PCacheParent::PCacheParent() :
    mozilla::ipc::IProtocol(mozilla::ipc::ParentSide),
    mLivenessState(mozilla::ipc::LivenessState::Dead)
{
    MOZ_COUNT_CTOR(PCacheParent);
}

PCacheParent::~PCacheParent()
{
    MOZ_COUNT_DTOR(PCacheParent);
}

auto PCacheParent::Manager() const -> PBackgroundParent*
{
    return static_cast<PBackgroundParent*>(IProtocol::Manager());
}

auto PCacheParent::ManagedPCacheOpParent(nsTArray<PCacheOpParent*>& aArr) const -> void
{
    (mManagedPCacheOpParent).ToArray(aArr);
}

auto PCacheParent::ManagedPCacheOpParent() const -> const ManagedContainer<PCacheOpParent>&
{
    return mManagedPCacheOpParent;
}

auto PCacheParent::OpenPCacheOpEndpoint(PCacheOpParent* aActor) -> ManagedEndpoint<PCacheOpChild>
{
    if ((!(aActor))) {
        NS_WARNING("Error constructing actor PCacheOpParent");
        return ManagedEndpoint<PCacheOpChild>();
    }
    (aActor)->SetManagerAndRegister(this);
    (mManagedPCacheOpParent).PutEntry(aActor);
    (aActor)->mLivenessState = mozilla::ipc::LivenessState::Start;

    return ManagedEndpoint<PCacheOpChild>(mozilla::ipc::PrivateIPDLInterface(), (aActor)->Id());
}

auto PCacheParent::BindPCacheOpEndpoint(
        ManagedEndpoint<PCacheOpParent> aEndpoint,
        PCacheOpParent* aActor) -> bool
{
    MOZ_RELEASE_ASSERT((aEndpoint).ActorId(), "Invalid Endpoint!");
    if ((!(aActor))) {
        NS_WARNING("Error constructing actor PCacheOpParent");
        return false;
    }
    (aActor)->SetManagerAndRegister(this, (*((aEndpoint).ActorId())));
    (mManagedPCacheOpParent).PutEntry(aActor);
    (aActor)->mLivenessState = mozilla::ipc::LivenessState::Start;

    return true;
}

auto PCacheParent::Send__delete__(PCacheParent* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    IPC::Message* msg__ = PCache::Msg___delete__((actor)->Id());

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    WriteIPDLParam(msg__, actor, actor);
    // Sentinel = 'actor'
    (msg__)->WriteSentinel(875202478);



    if (mozilla::ipc::LoggingEnabledFor("PCacheParent")) {
        mozilla::ipc::LogMessageForProtocol("PCacheParent", (actor)->OtherPid(), "Sending ", (msg__)->type(), mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PCache::Msg___delete__", OTHER);
    if ((!(StateTransition(true, (&((actor)->mLivenessState)))))) {
        mozilla::ipc::LogicError("Transition error");
    }

    bool sendok__ = ((actor)->GetIPCChannel())->Send(msg__);

    IProtocol* mgr = (actor)->Manager();
    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    (mgr)->RemoveManagee(PCacheMsgStart, actor);
    return sendok__;
}

auto PCacheParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    case PCacheOpMsgStart:
        {
            PCacheOpParent* actor = static_cast<PCacheOpParent*>(aListener);
            auto& container = mManagedPCacheOpParent;
            MOZ_RELEASE_ASSERT((container).Contains(actor), "actor not managed by this!");

            (container).RemoveEntry(actor);
            (static_cast<CacheParent*>(this))->DeallocPCacheOpParent(actor);
            return;
        }
    default:
        {
            FatalError("unreached");
            return;
        }
    }
}

auto PCacheParent::OnMessageReceived(const Message& msg__) -> PCacheParent::Result
{
    switch ((msg__).type()) {
    case PCache::Msg_PCacheOpConstructor__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PCacheParent")) {
                mozilla::ipc::LogMessageForProtocol("PCacheParent", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PCache::Msg_PCacheOpConstructor", OTHER);

            PickleIterator iter__(msg__);
            ActorHandle handle__;
            PCacheOpParent* actor;
            CacheOpArgs aOpArgs;

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(handle__)))))) {
                FatalError("Error deserializing 'ActorHandle'");
                return MsgValueError;
            }
            // Sentinel = 'actor'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 875202478)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'ActorHandle'");
                return MsgValueError;
            }
            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aOpArgs)))))) {
                FatalError("Error deserializing 'CacheOpArgs'");
                return MsgValueError;
            }
            // Sentinel = 'aOpArgs'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 2628124652)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'CacheOpArgs'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__, (msg__).type());
            if ((!(StateTransition(false, (&(mLivenessState)))))) {
                FatalError("Transition error");
                return MsgValueError;
            }
            actor = (static_cast<CacheParent*>(this))->AllocPCacheOpParent(aOpArgs);
            if ((!(actor))) {
                NS_WARNING("Error constructing actor PCacheOpParent");
                return MsgValueError;
            }
            (actor)->SetManagerAndRegister(this, (handle__).mId);
            (mManagedPCacheOpParent).PutEntry(actor);
            (actor)->mLivenessState = mozilla::ipc::LivenessState::Start;

            if ((!((static_cast<CacheParent*>(this))->RecvPCacheOpConstructor(std::move(actor), std::move(aOpArgs))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCache::Msg_Teardown__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PCacheParent")) {
                mozilla::ipc::LogMessageForProtocol("PCacheParent", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PCache::Msg_Teardown", OTHER);

            if ((!(StateTransition(false, (&(mLivenessState)))))) {
                FatalError("Transition error");
                return MsgValueError;
            }
            if ((!((static_cast<CacheParent*>(this))->RecvTeardown()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCache::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PCacheParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PCacheParent::Result
{
    return MsgNotKnown;
}

auto PCacheParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PCacheParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PCacheParent::GetProtocolTypeId() -> int32_t
{
    return PCacheMsgStart;
}

auto PCacheParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(Id());

    ActorDestroyReason subtreewhy = (((why) == (Deletion)) || ((why) == (FailedConstructor)) ? AncestorDeletion : why);

    {
        // Recursively shutting down PCacheOp kids
        nsTArray<PCacheOpParent*> kids;
        // Accumulate kids into a stable structure to iterate over
        ManagedPCacheOpParent(kids);
        for (auto& kid : kids) {
            // Guarding against a child removing a sibling from the list during the iteration.
            if ((mManagedPCacheOpParent).Contains(kid)) {
                (kid)->DestroySubtree(subtreewhy);
            }
        }
    }

    // Reject owning pending responses.
    (GetIPCChannel())->RejectPendingResponsesForActor(this);

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PCacheParent::DeallocSubtree() -> void
{
    {
        // Recursively deleting PCacheOp kids
        for (auto iter = (mManagedPCacheOpParent).Iter(); (!((iter).Done())); (iter).Next()) {
            (((iter).Get())->GetKey())->DeallocSubtree();
        }

        for (auto iter = (mManagedPCacheOpParent).Iter(); (!((iter).Done())); (iter).Next()) {
            (static_cast<CacheParent*>(this))->DeallocPCacheOpParent(((iter).Get())->GetKey());
        }
        (mManagedPCacheOpParent).Clear();
    }
}



} // namespace cache
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::dom::cache::PCacheParent>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    int32_t id;
    if ((!(aVar))) {
        id = 0;
    }
    else {
        id = (aVar)->Id();
        if ((1) == (id)) {
            (aActor)->FatalError("actor has been |delete|d");
        }
        MOZ_ASSERT(((aActor)->GetIPCChannel()) == ((aVar)->GetIPCChannel()), "Actor must be from the same channel as the actor it's being sent over");
    }
    WriteIPDLParam(aMsg, aActor, id);
}

auto IPDLParamTraits<mozilla::dom::cache::PCacheParent>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor = (aActor)->ReadActor(aMsg, aIter, true, "PCache", PCacheMsgStart);
    if ((actor).isNothing()) {
        return false;
    }

    (*(aVar)) = static_cast<mozilla::dom::cache::PCacheParent*>((actor).value());
    return true;
}

} // namespace ipc
} // namespace mozilla
