//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/PClientSourceParent.h"

#include "mozilla/dom/PClientManagerParent.h"
#include "mozilla/dom/PClientSourceOpParent.h"
#include "mozilla/dom/PIPCBlobInputStreamParent.h"
#include "mozilla/ipc/PChildToParentStreamParent.h"
#include "mozilla/ipc/PParentToChildStreamParent.h"
#include "mozilla/ipc/PFileDescriptorSetParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace dom {


MOZ_IMPLICIT PClientSourceParent::PClientSourceParent() :
    mozilla::ipc::IProtocol(mozilla::ipc::ParentSide),
    mLivenessState(mozilla::ipc::LivenessState::Dead)
{
    MOZ_COUNT_CTOR(PClientSourceParent);
}

PClientSourceParent::~PClientSourceParent()
{
    MOZ_COUNT_DTOR(PClientSourceParent);
}

auto PClientSourceParent::Manager() const -> PClientManagerParent*
{
    return static_cast<PClientManagerParent*>(IProtocol::Manager());
}

auto PClientSourceParent::ManagedPClientSourceOpParent(nsTArray<PClientSourceOpParent*>& aArr) const -> void
{
    (mManagedPClientSourceOpParent).ToArray(aArr);
}

auto PClientSourceParent::ManagedPClientSourceOpParent() const -> const ManagedContainer<PClientSourceOpParent>&
{
    return mManagedPClientSourceOpParent;
}

auto PClientSourceParent::OpenPClientSourceOpEndpoint(PClientSourceOpParent* aActor) -> ManagedEndpoint<PClientSourceOpChild>
{
    if ((!(aActor))) {
        NS_WARNING("Error constructing actor PClientSourceOpParent");
        return ManagedEndpoint<PClientSourceOpChild>();
    }
    (aActor)->SetManagerAndRegister(this);
    (mManagedPClientSourceOpParent).PutEntry(aActor);
    (aActor)->mLivenessState = mozilla::ipc::LivenessState::Start;

    return ManagedEndpoint<PClientSourceOpChild>(mozilla::ipc::PrivateIPDLInterface(), (aActor)->Id());
}

auto PClientSourceParent::BindPClientSourceOpEndpoint(
        ManagedEndpoint<PClientSourceOpParent> aEndpoint,
        PClientSourceOpParent* aActor) -> bool
{
    MOZ_RELEASE_ASSERT((aEndpoint).ActorId(), "Invalid Endpoint!");
    if ((!(aActor))) {
        NS_WARNING("Error constructing actor PClientSourceOpParent");
        return false;
    }
    (aActor)->SetManagerAndRegister(this, (*((aEndpoint).ActorId())));
    (mManagedPClientSourceOpParent).PutEntry(aActor);
    (aActor)->mLivenessState = mozilla::ipc::LivenessState::Start;

    return true;
}

auto PClientSourceParent::SendPClientSourceOpConstructor(const ClientOpConstructorArgs& aArgs) -> PClientSourceOpParent*
{
    return SendPClientSourceOpConstructor(AllocPClientSourceOpParent(aArgs), aArgs);
}

auto PClientSourceParent::SendPClientSourceOpConstructor(
        PClientSourceOpParent* actor,
        const ClientOpConstructorArgs& aArgs) -> PClientSourceOpParent*
{
    if ((!(actor))) {
        NS_WARNING("Error constructing actor PClientSourceOpParent");
        return nullptr;
    }
    (actor)->SetManagerAndRegister(this);
    (mManagedPClientSourceOpParent).PutEntry(actor);
    (actor)->mLivenessState = mozilla::ipc::LivenessState::Start;

    IPC::Message* msg__ = PClientSource::Msg_PClientSourceOpConstructor(Id());

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    WriteIPDLParam(msg__, this, actor);
    // Sentinel = 'actor'
    (msg__)->WriteSentinel(875202478);
    WriteIPDLParam(msg__, this, aArgs);
    // Sentinel = 'aArgs'
    (msg__)->WriteSentinel(424150951);



    if (mozilla::ipc::LoggingEnabledFor("PClientSourceParent")) {
        mozilla::ipc::LogMessageForProtocol("PClientSourceParent", OtherPid(), "Sending ", (msg__)->type(), mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PClientSource::Msg_PClientSourceOpConstructor", OTHER);
    if ((!(StateTransition(false, (&(mLivenessState)))))) {
        mozilla::ipc::LogicError("Transition error");
    }

    bool sendok__ = (GetIPCChannel())->Send(msg__);
    if ((!(sendok__))) {
        NS_WARNING("Error sending constructor");
    }
    return actor;
}

auto PClientSourceParent::Send__delete__(PClientSourceParent* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    IPC::Message* msg__ = PClientSource::Msg___delete__((actor)->Id());

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    WriteIPDLParam(msg__, actor, actor);
    // Sentinel = 'actor'
    (msg__)->WriteSentinel(875202478);



    if (mozilla::ipc::LoggingEnabledFor("PClientSourceParent")) {
        mozilla::ipc::LogMessageForProtocol("PClientSourceParent", (actor)->OtherPid(), "Sending ", (msg__)->type(), mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PClientSource::Msg___delete__", OTHER);
    if ((!(StateTransition(true, (&((actor)->mLivenessState)))))) {
        mozilla::ipc::LogicError("Transition error");
    }

    bool sendok__ = ((actor)->GetIPCChannel())->Send(msg__);

    IProtocol* mgr = (actor)->Manager();
    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    (mgr)->RemoveManagee(PClientSourceMsgStart, actor);
    return sendok__;
}

auto PClientSourceParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    case PClientSourceOpMsgStart:
        {
            PClientSourceOpParent* actor = static_cast<PClientSourceOpParent*>(aListener);
            auto& container = mManagedPClientSourceOpParent;
            MOZ_RELEASE_ASSERT((container).Contains(actor), "actor not managed by this!");

            (container).RemoveEntry(actor);
            DeallocPClientSourceOpParent(actor);
            return;
        }
    default:
        {
            FatalError("unreached");
            return;
        }
    }
}

auto PClientSourceParent::OnMessageReceived(const Message& msg__) -> PClientSourceParent::Result
{
    switch ((msg__).type()) {
    case PClientSource::Msg_Teardown__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PClientSourceParent")) {
                mozilla::ipc::LogMessageForProtocol("PClientSourceParent", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PClientSource::Msg_Teardown", OTHER);

            if ((!(StateTransition(false, (&(mLivenessState)))))) {
                FatalError("Transition error");
                return MsgValueError;
            }
            if ((!(RecvTeardown()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PClientSource::Msg_ExecutionReady__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PClientSourceParent")) {
                mozilla::ipc::LogMessageForProtocol("PClientSourceParent", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PClientSource::Msg_ExecutionReady", OTHER);

            PickleIterator iter__(msg__);
            ClientSourceExecutionReadyArgs aArgs;

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aArgs)))))) {
                FatalError("Error deserializing 'ClientSourceExecutionReadyArgs'");
                return MsgValueError;
            }
            // Sentinel = 'aArgs'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 424150951)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'ClientSourceExecutionReadyArgs'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__, (msg__).type());
            if ((!(StateTransition(false, (&(mLivenessState)))))) {
                FatalError("Transition error");
                return MsgValueError;
            }
            if ((!(RecvExecutionReady(std::move(aArgs))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PClientSource::Msg_Freeze__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PClientSourceParent")) {
                mozilla::ipc::LogMessageForProtocol("PClientSourceParent", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PClientSource::Msg_Freeze", OTHER);

            if ((!(StateTransition(false, (&(mLivenessState)))))) {
                FatalError("Transition error");
                return MsgValueError;
            }
            if ((!(RecvFreeze()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PClientSource::Msg_Thaw__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PClientSourceParent")) {
                mozilla::ipc::LogMessageForProtocol("PClientSourceParent", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PClientSource::Msg_Thaw", OTHER);

            if ((!(StateTransition(false, (&(mLivenessState)))))) {
                FatalError("Transition error");
                return MsgValueError;
            }
            if ((!(RecvThaw()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PClientSource::Msg_InheritController__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PClientSourceParent")) {
                mozilla::ipc::LogMessageForProtocol("PClientSourceParent", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PClientSource::Msg_InheritController", OTHER);

            PickleIterator iter__(msg__);
            ClientControlledArgs aArgs;

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aArgs)))))) {
                FatalError("Error deserializing 'ClientControlledArgs'");
                return MsgValueError;
            }
            // Sentinel = 'aArgs'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 424150951)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'ClientControlledArgs'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__, (msg__).type());
            if ((!(StateTransition(false, (&(mLivenessState)))))) {
                FatalError("Transition error");
                return MsgValueError;
            }
            if ((!(RecvInheritController(std::move(aArgs))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PClientSource::Msg_NoteDOMContentLoaded__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PClientSourceParent")) {
                mozilla::ipc::LogMessageForProtocol("PClientSourceParent", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PClientSource::Msg_NoteDOMContentLoaded", OTHER);

            if ((!(StateTransition(false, (&(mLivenessState)))))) {
                FatalError("Transition error");
                return MsgValueError;
            }
            if ((!(RecvNoteDOMContentLoaded()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PClientSource::Reply_PClientSourceOpConstructor__ID:
        {
            return MsgProcessed;
        }
    case PClientSource::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PClientSourceParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PClientSourceParent::Result
{
    switch ((msg__).type()) {
    case PClientSource::Msg_WorkerSyncPing__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PClientSourceParent")) {
                mozilla::ipc::LogMessageForProtocol("PClientSourceParent", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PClientSource::Msg_WorkerSyncPing", OTHER);

            if ((!(StateTransition(false, (&(mLivenessState)))))) {
                FatalError("Transition error");
                return MsgValueError;
            }
            int32_t id__ = Id();
            if ((!(RecvWorkerSyncPing()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            reply__ = PClientSource::Reply_WorkerSyncPing(id__);


            if (mozilla::ipc::LoggingEnabledFor("PClientSourceParent")) {
                mozilla::ipc::LogMessageForProtocol("PClientSourceParent", OtherPid(), "Sending reply ", (reply__)->type(), mozilla::ipc::MessageDirection::eSending);
            }
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PClientSourceParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PClientSourceParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PClientSourceParent::GetProtocolTypeId() -> int32_t
{
    return PClientSourceMsgStart;
}

auto PClientSourceParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(Id());

    ActorDestroyReason subtreewhy = (((why) == (Deletion)) || ((why) == (FailedConstructor)) ? AncestorDeletion : why);

    {
        // Recursively shutting down PClientSourceOp kids
        nsTArray<PClientSourceOpParent*> kids;
        // Accumulate kids into a stable structure to iterate over
        ManagedPClientSourceOpParent(kids);
        for (auto& kid : kids) {
            // Guarding against a child removing a sibling from the list during the iteration.
            if ((mManagedPClientSourceOpParent).Contains(kid)) {
                (kid)->DestroySubtree(subtreewhy);
            }
        }
    }

    // Reject owning pending responses.
    (GetIPCChannel())->RejectPendingResponsesForActor(this);

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PClientSourceParent::DeallocSubtree() -> void
{
    {
        // Recursively deleting PClientSourceOp kids
        for (auto iter = (mManagedPClientSourceOpParent).Iter(); (!((iter).Done())); (iter).Next()) {
            (((iter).Get())->GetKey())->DeallocSubtree();
        }

        for (auto iter = (mManagedPClientSourceOpParent).Iter(); (!((iter).Done())); (iter).Next()) {
            DeallocPClientSourceOpParent(((iter).Get())->GetKey());
        }
        (mManagedPClientSourceOpParent).Clear();
    }
}



} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::dom::PClientSourceParent>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    int32_t id;
    if ((!(aVar))) {
        id = 0;
    }
    else {
        id = (aVar)->Id();
        if ((1) == (id)) {
            (aActor)->FatalError("actor has been |delete|d");
        }
        MOZ_ASSERT(((aActor)->GetIPCChannel()) == ((aVar)->GetIPCChannel()), "Actor must be from the same channel as the actor it's being sent over");
    }
    WriteIPDLParam(aMsg, aActor, id);
}

auto IPDLParamTraits<mozilla::dom::PClientSourceParent>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor = (aActor)->ReadActor(aMsg, aIter, true, "PClientSource", PClientSourceMsgStart);
    if ((actor).isNothing()) {
        return false;
    }

    (*(aVar)) = static_cast<mozilla::dom::PClientSourceParent*>((actor).value());
    return true;
}

} // namespace ipc
} // namespace mozilla
