//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/PMIDIManagerParent.h"
#include "mozilla/dom/MIDIManagerParent.h"

#include "mozilla/ipc/PBackgroundParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace dom {


MOZ_IMPLICIT PMIDIManagerParent::PMIDIManagerParent() :
    mozilla::ipc::IProtocol(mozilla::ipc::ParentSide),
    mLivenessState(mozilla::ipc::LivenessState::Dead)
{
    MOZ_COUNT_CTOR(PMIDIManagerParent);
}

PMIDIManagerParent::~PMIDIManagerParent()
{
    MOZ_COUNT_DTOR(PMIDIManagerParent);
}

auto PMIDIManagerParent::Manager() const -> PBackgroundParent*
{
    return static_cast<PBackgroundParent*>(IProtocol::Manager());
}

auto PMIDIManagerParent::SendMIDIPortListUpdate(const MIDIPortList& aPortList) -> bool
{
    IPC::Message* msg__ = PMIDIManager::Msg_MIDIPortListUpdate(Id());

    WriteIPDLParam(msg__, this, aPortList);
    // Sentinel = 'aPortList'
    (msg__)->WriteSentinel(2060275621);




    if (mozilla::ipc::LoggingEnabledFor("PMIDIManagerParent")) {
        mozilla::ipc::LogMessageForProtocol("PMIDIManagerParent", OtherPid(), "Sending ", (msg__)->type(), mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PMIDIManager::Msg_MIDIPortListUpdate", OTHER);
    if ((!(StateTransition(false, (&(mLivenessState)))))) {
        mozilla::ipc::LogicError("Transition error");
    }

    bool sendok__ = (GetIPCChannel())->Send(msg__);
    return sendok__;
}

auto PMIDIManagerParent::Send__delete__(PMIDIManagerParent* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    IPC::Message* msg__ = PMIDIManager::Msg___delete__((actor)->Id());

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    WriteIPDLParam(msg__, actor, actor);
    // Sentinel = 'actor'
    (msg__)->WriteSentinel(875202478);



    if (mozilla::ipc::LoggingEnabledFor("PMIDIManagerParent")) {
        mozilla::ipc::LogMessageForProtocol("PMIDIManagerParent", (actor)->OtherPid(), "Sending ", (msg__)->type(), mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PMIDIManager::Msg___delete__", OTHER);
    if ((!(StateTransition(true, (&((actor)->mLivenessState)))))) {
        mozilla::ipc::LogicError("Transition error");
    }

    bool sendok__ = ((actor)->GetIPCChannel())->Send(msg__);

    IProtocol* mgr = (actor)->Manager();
    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    (mgr)->RemoveManagee(PMIDIManagerMsgStart, actor);
    return sendok__;
}

auto PMIDIManagerParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PMIDIManagerParent::OnMessageReceived(const Message& msg__) -> PMIDIManagerParent::Result
{
    switch ((msg__).type()) {
    case PMIDIManager::Msg_Shutdown__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PMIDIManagerParent")) {
                mozilla::ipc::LogMessageForProtocol("PMIDIManagerParent", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PMIDIManager::Msg_Shutdown", OTHER);

            if ((!(StateTransition(false, (&(mLivenessState)))))) {
                FatalError("Transition error");
                return MsgValueError;
            }
            if ((!((static_cast<MIDIManagerParent*>(this))->RecvShutdown()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PMIDIManager::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PMIDIManagerParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PMIDIManagerParent::Result
{
    return MsgNotKnown;
}

auto PMIDIManagerParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PMIDIManagerParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PMIDIManagerParent::GetProtocolTypeId() -> int32_t
{
    return PMIDIManagerMsgStart;
}

auto PMIDIManagerParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(Id());

    // Reject owning pending responses.
    (GetIPCChannel())->RejectPendingResponsesForActor(this);

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PMIDIManagerParent::DeallocSubtree() -> void
{
}



} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::dom::PMIDIManagerParent>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    int32_t id;
    if ((!(aVar))) {
        id = 0;
    }
    else {
        id = (aVar)->Id();
        if ((1) == (id)) {
            (aActor)->FatalError("actor has been |delete|d");
        }
        MOZ_ASSERT(((aActor)->GetIPCChannel()) == ((aVar)->GetIPCChannel()), "Actor must be from the same channel as the actor it's being sent over");
    }
    WriteIPDLParam(aMsg, aActor, id);
}

auto IPDLParamTraits<mozilla::dom::PMIDIManagerParent>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor = (aActor)->ReadActor(aMsg, aIter, true, "PMIDIManager", PMIDIManagerMsgStart);
    if ((actor).isNothing()) {
        return false;
    }

    (*(aVar)) = static_cast<mozilla::dom::PMIDIManagerParent*>((actor).value());
    return true;
}

} // namespace ipc
} // namespace mozilla
