//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/media/PMediaParent.h"

#include "mozilla/dom/PContentParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace media {


MOZ_IMPLICIT PMediaParent::PMediaParent() :
    mozilla::ipc::IProtocol(mozilla::ipc::ParentSide),
    mLivenessState(mozilla::ipc::LivenessState::Dead)
{
    MOZ_COUNT_CTOR(PMediaParent);
}

PMediaParent::~PMediaParent()
{
    MOZ_COUNT_DTOR(PMediaParent);
}

auto PMediaParent::Manager() const -> PContentParent*
{
    return static_cast<PContentParent*>(IProtocol::Manager());
}

auto PMediaParent::Send__delete__(PMediaParent* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    IPC::Message* msg__ = PMedia::Msg___delete__((actor)->Id());

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    WriteIPDLParam(msg__, actor, actor);
    // Sentinel = 'actor'
    (msg__)->WriteSentinel(875202478);



    if (mozilla::ipc::LoggingEnabledFor("PMediaParent")) {
        mozilla::ipc::LogMessageForProtocol("PMediaParent", (actor)->OtherPid(), "Sending ", (msg__)->type(), mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PMedia::Msg___delete__", OTHER);
    if ((!(StateTransition(true, (&((actor)->mLivenessState)))))) {
        mozilla::ipc::LogicError("Transition error");
    }

    bool sendok__ = ((actor)->GetIPCChannel())->Send(msg__);

    IProtocol* mgr = (actor)->Manager();
    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    (mgr)->RemoveManagee(PMediaMsgStart, actor);
    return sendok__;
}

auto PMediaParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PMediaParent::OnMessageReceived(const Message& msg__) -> PMediaParent::Result
{
    switch ((msg__).type()) {
    case PMedia::Msg_GetPrincipalKey__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PMediaParent")) {
                mozilla::ipc::LogMessageForProtocol("PMediaParent", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PMedia::Msg_GetPrincipalKey", OTHER);

            PickleIterator iter__(msg__);
            PrincipalInfo aPrincipal;
            bool aPersist;

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aPrincipal)))))) {
                FatalError("Error deserializing 'PrincipalInfo'");
                return MsgValueError;
            }
            // Sentinel = 'aPrincipal'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 4097511)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'PrincipalInfo'");
                return MsgValueError;
            }
            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aPersist)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            // Sentinel = 'aPersist'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 4167438139)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'bool'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__, (msg__).type());
            if ((!(StateTransition(false, (&(mLivenessState)))))) {
                FatalError("Transition error");
                return MsgValueError;
            }
            int32_t id__ = Id();

            int32_t seqno__ = (msg__).seqno();
            WeakPtr<PMediaParent> self__ = this;
            GetPrincipalKeyResolver resolver = [this, self__, id__, seqno__](const nsCString& aParam) {
                if ((!(self__))) {
                    NS_WARNING("Not resolving response because actor is dead.");
                    return;
                }
                if ((mLivenessState) == (mozilla::ipc::LivenessState::Dead)) {
                    NS_WARNING("Not resolving response because actor is destroyed.");
                    return;
                }
                bool resolve__ = true;
                nsCString aKey;
                aKey = std::move(aParam);
                IPC::Message* reply__ = PMedia::Reply_GetPrincipalKey(id__);
                WriteIPDLParam(reply__, self__, resolve__);
                // Sentinel = 'resolve__'
                (reply__)->WriteSentinel(3997392463);
                WriteIPDLParam(reply__, self__, aKey);
                // Sentinel = 'aKey'
                (reply__)->WriteSentinel(3415890794);
                (reply__)->set_seqno(seqno__);

                if (mozilla::ipc::LoggingEnabledFor("PMediaParent")) {
                    mozilla::ipc::LogMessageForProtocol("PMediaParent", OtherPid(), "Sending reply ", (reply__)->type(), mozilla::ipc::MessageDirection::eSending);
                }
                bool sendok__ = (GetIPCChannel())->Send(reply__);
                if ((!(sendok__))) {
                    NS_WARNING("Error sending reply");
                }
            };
            if ((!(RecvGetPrincipalKey(std::move(aPrincipal), std::move(aPersist), std::move(resolver))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PMedia::Msg_SanitizeOriginKeys__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PMediaParent")) {
                mozilla::ipc::LogMessageForProtocol("PMediaParent", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PMedia::Msg_SanitizeOriginKeys", OTHER);

            PickleIterator iter__(msg__);
            uint64_t aSinceWhen;
            bool aOnlyPrivateBrowsing;

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aSinceWhen)))))) {
                FatalError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            // Sentinel = 'aSinceWhen'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 2883988047)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aOnlyPrivateBrowsing)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            // Sentinel = 'aOnlyPrivateBrowsing'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 1580982783)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'bool'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__, (msg__).type());
            if ((!(StateTransition(false, (&(mLivenessState)))))) {
                FatalError("Transition error");
                return MsgValueError;
            }
            if ((!(RecvSanitizeOriginKeys(std::move(aSinceWhen), std::move(aOnlyPrivateBrowsing))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PMedia::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PMediaParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PMediaParent::Result
{
    return MsgNotKnown;
}

auto PMediaParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PMediaParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PMediaParent::GetProtocolTypeId() -> int32_t
{
    return PMediaMsgStart;
}

auto PMediaParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(Id());

    // Reject owning pending responses.
    (GetIPCChannel())->RejectPendingResponsesForActor(this);

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PMediaParent::DeallocSubtree() -> void
{
}



} // namespace media
} // namespace mozilla
namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::media::PMediaParent>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    int32_t id;
    if ((!(aVar))) {
        id = 0;
    }
    else {
        id = (aVar)->Id();
        if ((1) == (id)) {
            (aActor)->FatalError("actor has been |delete|d");
        }
        MOZ_ASSERT(((aActor)->GetIPCChannel()) == ((aVar)->GetIPCChannel()), "Actor must be from the same channel as the actor it's being sent over");
    }
    WriteIPDLParam(aMsg, aActor, id);
}

auto IPDLParamTraits<mozilla::media::PMediaParent>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor = (aActor)->ReadActor(aMsg, aIter, true, "PMedia", PMediaMsgStart);
    if ((actor).isNothing()) {
        return false;
    }

    (*(aVar)) = static_cast<mozilla::media::PMediaParent*>((actor).value());
    return true;
}

} // namespace ipc
} // namespace mozilla
