//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/PWebAuthnTransactionParent.h"
#include "mozilla/dom/WebAuthnTransactionParent.h"

#include "mozilla/ipc/PBackgroundParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace dom {


MOZ_IMPLICIT PWebAuthnTransactionParent::PWebAuthnTransactionParent() :
    mozilla::ipc::IProtocol(mozilla::ipc::ParentSide),
    mLivenessState(mozilla::ipc::LivenessState::Dead)
{
    MOZ_COUNT_CTOR(PWebAuthnTransactionParent);
}

PWebAuthnTransactionParent::~PWebAuthnTransactionParent()
{
    MOZ_COUNT_DTOR(PWebAuthnTransactionParent);
}

auto PWebAuthnTransactionParent::Manager() const -> PBackgroundParent*
{
    return static_cast<PBackgroundParent*>(IProtocol::Manager());
}

auto PWebAuthnTransactionParent::Send__delete__(PWebAuthnTransactionParent* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    IPC::Message* msg__ = PWebAuthnTransaction::Msg___delete__((actor)->Id());

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    WriteIPDLParam(msg__, actor, actor);
    // Sentinel = 'actor'
    (msg__)->WriteSentinel(875202478);



    if (mozilla::ipc::LoggingEnabledFor("PWebAuthnTransactionParent")) {
        mozilla::ipc::LogMessageForProtocol("PWebAuthnTransactionParent", (actor)->OtherPid(), "Sending ", (msg__)->type(), mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PWebAuthnTransaction::Msg___delete__", OTHER);
    if ((!(StateTransition(true, (&((actor)->mLivenessState)))))) {
        mozilla::ipc::LogicError("Transition error");
    }

    bool sendok__ = ((actor)->GetIPCChannel())->Send(msg__);

    IProtocol* mgr = (actor)->Manager();
    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    (mgr)->RemoveManagee(PWebAuthnTransactionMsgStart, actor);
    return sendok__;
}

auto PWebAuthnTransactionParent::SendConfirmRegister(
        const uint64_t& aTransactionId,
        const WebAuthnMakeCredentialResult& aResult) -> bool
{
    IPC::Message* msg__ = PWebAuthnTransaction::Msg_ConfirmRegister(Id());

    WriteIPDLParam(msg__, this, aTransactionId);
    // Sentinel = 'aTransactionId'
    (msg__)->WriteSentinel(3266273614);
    WriteIPDLParam(msg__, this, aResult);
    // Sentinel = 'aResult'
    (msg__)->WriteSentinel(3888726089);




    if (mozilla::ipc::LoggingEnabledFor("PWebAuthnTransactionParent")) {
        mozilla::ipc::LogMessageForProtocol("PWebAuthnTransactionParent", OtherPid(), "Sending ", (msg__)->type(), mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PWebAuthnTransaction::Msg_ConfirmRegister", OTHER);
    if ((!(StateTransition(false, (&(mLivenessState)))))) {
        mozilla::ipc::LogicError("Transition error");
    }

    bool sendok__ = (GetIPCChannel())->Send(msg__);
    return sendok__;
}

auto PWebAuthnTransactionParent::SendConfirmSign(
        const uint64_t& aTransactionId,
        const WebAuthnGetAssertionResult& aResult) -> bool
{
    IPC::Message* msg__ = PWebAuthnTransaction::Msg_ConfirmSign(Id());

    WriteIPDLParam(msg__, this, aTransactionId);
    // Sentinel = 'aTransactionId'
    (msg__)->WriteSentinel(3266273614);
    WriteIPDLParam(msg__, this, aResult);
    // Sentinel = 'aResult'
    (msg__)->WriteSentinel(3888726089);




    if (mozilla::ipc::LoggingEnabledFor("PWebAuthnTransactionParent")) {
        mozilla::ipc::LogMessageForProtocol("PWebAuthnTransactionParent", OtherPid(), "Sending ", (msg__)->type(), mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PWebAuthnTransaction::Msg_ConfirmSign", OTHER);
    if ((!(StateTransition(false, (&(mLivenessState)))))) {
        mozilla::ipc::LogicError("Transition error");
    }

    bool sendok__ = (GetIPCChannel())->Send(msg__);
    return sendok__;
}

auto PWebAuthnTransactionParent::SendAbort(
        const uint64_t& aTransactionId,
        const nsresult& Error) -> bool
{
    IPC::Message* msg__ = PWebAuthnTransaction::Msg_Abort(Id());

    WriteIPDLParam(msg__, this, aTransactionId);
    // Sentinel = 'aTransactionId'
    (msg__)->WriteSentinel(3266273614);
    WriteIPDLParam(msg__, this, Error);
    // Sentinel = 'Error'
    (msg__)->WriteSentinel(1861840727);




    if (mozilla::ipc::LoggingEnabledFor("PWebAuthnTransactionParent")) {
        mozilla::ipc::LogMessageForProtocol("PWebAuthnTransactionParent", OtherPid(), "Sending ", (msg__)->type(), mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PWebAuthnTransaction::Msg_Abort", OTHER);
    if ((!(StateTransition(false, (&(mLivenessState)))))) {
        mozilla::ipc::LogicError("Transition error");
    }

    bool sendok__ = (GetIPCChannel())->Send(msg__);
    return sendok__;
}

auto PWebAuthnTransactionParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PWebAuthnTransactionParent::OnMessageReceived(const Message& msg__) -> PWebAuthnTransactionParent::Result
{
    switch ((msg__).type()) {
    case PWebAuthnTransaction::Msg_RequestRegister__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PWebAuthnTransactionParent")) {
                mozilla::ipc::LogMessageForProtocol("PWebAuthnTransactionParent", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PWebAuthnTransaction::Msg_RequestRegister", OTHER);

            PickleIterator iter__(msg__);
            uint64_t aTransactionId;
            WebAuthnMakeCredentialInfo aTransactionInfo;

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aTransactionId)))))) {
                FatalError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            // Sentinel = 'aTransactionId'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 3266273614)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aTransactionInfo)))))) {
                FatalError("Error deserializing 'WebAuthnMakeCredentialInfo'");
                return MsgValueError;
            }
            // Sentinel = 'aTransactionInfo'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 1312922839)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'WebAuthnMakeCredentialInfo'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__, (msg__).type());
            if ((!(StateTransition(false, (&(mLivenessState)))))) {
                FatalError("Transition error");
                return MsgValueError;
            }
            if ((!((static_cast<WebAuthnTransactionParent*>(this))->RecvRequestRegister(std::move(aTransactionId), std::move(aTransactionInfo))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PWebAuthnTransaction::Msg_RequestSign__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PWebAuthnTransactionParent")) {
                mozilla::ipc::LogMessageForProtocol("PWebAuthnTransactionParent", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PWebAuthnTransaction::Msg_RequestSign", OTHER);

            PickleIterator iter__(msg__);
            uint64_t aTransactionId;
            WebAuthnGetAssertionInfo aTransactionInfo;

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aTransactionId)))))) {
                FatalError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            // Sentinel = 'aTransactionId'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 3266273614)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aTransactionInfo)))))) {
                FatalError("Error deserializing 'WebAuthnGetAssertionInfo'");
                return MsgValueError;
            }
            // Sentinel = 'aTransactionInfo'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 1312922839)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'WebAuthnGetAssertionInfo'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__, (msg__).type());
            if ((!(StateTransition(false, (&(mLivenessState)))))) {
                FatalError("Transition error");
                return MsgValueError;
            }
            if ((!((static_cast<WebAuthnTransactionParent*>(this))->RecvRequestSign(std::move(aTransactionId), std::move(aTransactionInfo))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PWebAuthnTransaction::Msg_RequestCancel__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PWebAuthnTransactionParent")) {
                mozilla::ipc::LogMessageForProtocol("PWebAuthnTransactionParent", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PWebAuthnTransaction::Msg_RequestCancel", OTHER);

            PickleIterator iter__(msg__);
            uint64_t aTransactionId;

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aTransactionId)))))) {
                FatalError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            // Sentinel = 'aTransactionId'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 3266273614)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__, (msg__).type());
            if ((!(StateTransition(false, (&(mLivenessState)))))) {
                FatalError("Transition error");
                return MsgValueError;
            }
            if ((!((static_cast<WebAuthnTransactionParent*>(this))->RecvRequestCancel(std::move(aTransactionId))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PWebAuthnTransaction::Msg_DestroyMe__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PWebAuthnTransactionParent")) {
                mozilla::ipc::LogMessageForProtocol("PWebAuthnTransactionParent", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PWebAuthnTransaction::Msg_DestroyMe", OTHER);

            if ((!(StateTransition(false, (&(mLivenessState)))))) {
                FatalError("Transition error");
                return MsgValueError;
            }
            if ((!((static_cast<WebAuthnTransactionParent*>(this))->RecvDestroyMe()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PWebAuthnTransaction::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PWebAuthnTransactionParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PWebAuthnTransactionParent::Result
{
    return MsgNotKnown;
}

auto PWebAuthnTransactionParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PWebAuthnTransactionParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PWebAuthnTransactionParent::GetProtocolTypeId() -> int32_t
{
    return PWebAuthnTransactionMsgStart;
}

auto PWebAuthnTransactionParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(Id());

    // Reject owning pending responses.
    (GetIPCChannel())->RejectPendingResponsesForActor(this);

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PWebAuthnTransactionParent::DeallocSubtree() -> void
{
}



} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::dom::PWebAuthnTransactionParent>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    int32_t id;
    if ((!(aVar))) {
        id = 0;
    }
    else {
        id = (aVar)->Id();
        if ((1) == (id)) {
            (aActor)->FatalError("actor has been |delete|d");
        }
        MOZ_ASSERT(((aActor)->GetIPCChannel()) == ((aVar)->GetIPCChannel()), "Actor must be from the same channel as the actor it's being sent over");
    }
    WriteIPDLParam(aMsg, aActor, id);
}

auto IPDLParamTraits<mozilla::dom::PWebAuthnTransactionParent>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor = (aActor)->ReadActor(aMsg, aIter, true, "PWebAuthnTransaction", PWebAuthnTransactionMsgStart);
    if ((actor).isNothing()) {
        return false;
    }

    (*(aVar)) = static_cast<mozilla::dom::PWebAuthnTransactionParent*>((actor).value());
    return true;
}

} // namespace ipc
} // namespace mozilla
