//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PRemoteDecoder_h
#define PRemoteDecoder_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/PMediaDecoderParams.h"
#include "mozilla/layers/LayersSurfaces.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RemoteVideoDataIPDL|
//
namespace mozilla {
class RemoteVideoDataIPDL final
{
private:
    typedef mozilla::MediaDataIPDL MediaDataIPDL;
    typedef mozilla::gfx::IntSize IntSize;
    typedef mozilla::layers::SurfaceDescriptorBuffer SurfaceDescriptorBuffer;

public:
    MOZ_IMPLICIT RemoteVideoDataIPDL() :
        base_(),
        display_(),
        frameSize_(),
        sdBuffer_(),
        frameID_()
    {
    }

    MOZ_IMPLICIT RemoteVideoDataIPDL(
            const MediaDataIPDL& _base,
            const IntSize& _display,
            const IntSize& _frameSize,
            const SurfaceDescriptorBuffer& _sdBuffer,
            const int32_t& _frameID) :
        base_(_base),
        display_(_display),
        frameSize_(_frameSize),
        sdBuffer_(_sdBuffer),
        frameID_(_frameID)
    {
    }

    bool
    operator==(const RemoteVideoDataIPDL& _o) const;

    bool
    operator!=(const RemoteVideoDataIPDL& _o) const;

    MediaDataIPDL&
    base()
    {
        return base_;
    }
    const MediaDataIPDL&
    base() const
    {
        return base_;
    }

    IntSize&
    display()
    {
        return display_;
    }
    const IntSize&
    display() const
    {
        return display_;
    }

    IntSize&
    frameSize()
    {
        return frameSize_;
    }
    const IntSize&
    frameSize() const
    {
        return frameSize_;
    }

    SurfaceDescriptorBuffer&
    sdBuffer()
    {
        return sdBuffer_;
    }
    const SurfaceDescriptorBuffer&
    sdBuffer() const
    {
        return sdBuffer_;
    }

    int32_t&
    frameID()
    {
        return frameID_;
    }
    const int32_t&
    frameID() const
    {
        return frameID_;
    }

private:
    MediaDataIPDL base_;
    IntSize display_;
    IntSize frameSize_;
    SurfaceDescriptorBuffer sdBuffer_;
    int32_t frameID_;
};
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::RemoteVideoDataIPDL>
{
    typedef mozilla::RemoteVideoDataIPDL paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RemoteAudioDataIPDL|
//
namespace mozilla {
class RemoteAudioDataIPDL final
{
private:
    typedef mozilla::MediaDataIPDL MediaDataIPDL;
    typedef mozilla::ipc::Shmem Shmem;

public:
    MOZ_IMPLICIT RemoteAudioDataIPDL() :
        base_(),
        buffer_(),
        channels_(),
        rate_(),
        channelMap_()
    {
    }

    MOZ_IMPLICIT RemoteAudioDataIPDL(
            const MediaDataIPDL& _base,
            const uint32_t& _channels,
            const uint32_t& _rate,
            const uint32_t& _channelMap,
            Shmem&& _buffer) :
        base_(_base),
        buffer_(_buffer),
        channels_(_channels),
        rate_(_rate),
        channelMap_(_channelMap)
    {
    }

    bool
    operator==(const RemoteAudioDataIPDL& _o) const;

    bool
    operator!=(const RemoteAudioDataIPDL& _o) const;

    MediaDataIPDL&
    base()
    {
        return base_;
    }
    const MediaDataIPDL&
    base() const
    {
        return base_;
    }

    uint32_t&
    channels()
    {
        return channels_;
    }
    const uint32_t&
    channels() const
    {
        return channels_;
    }

    uint32_t&
    rate()
    {
        return rate_;
    }
    const uint32_t&
    rate() const
    {
        return rate_;
    }

    uint32_t&
    channelMap()
    {
        return channelMap_;
    }
    const uint32_t&
    channelMap() const
    {
        return channelMap_;
    }

    Shmem&
    buffer()
    {
        return buffer_;
    }
    Shmem&
    buffer() const
    {
        return const_cast<Shmem&>(buffer_);
    }

private:
    void
    StaticAssertions() const;
    MediaDataIPDL base_;
    Shmem buffer_;
    uint32_t channels_;
    uint32_t rate_;
    uint32_t channelMap_;
};
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::RemoteAudioDataIPDL>
{
    typedef mozilla::RemoteAudioDataIPDL paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union DecodedOutputIPDL|
//
namespace mozilla {
class DecodedOutputIPDL final
{
public:
    enum Type {
        T__None,
        TRemoteAudioDataIPDL = 1,
        TRemoteVideoDataIPDL,
        T__Last = TRemoteVideoDataIPDL
    };

private:
    typedef mozilla::RemoteAudioDataIPDL RemoteAudioDataIPDL;
    typedef mozilla::RemoteVideoDataIPDL RemoteVideoDataIPDL;
    typedef RemoteAudioDataIPDL RemoteAudioDataIPDL__tdef;
    typedef RemoteVideoDataIPDL RemoteVideoDataIPDL__tdef;

    union Value {
        mozilla::AlignedStorage2<RemoteAudioDataIPDL> VRemoteAudioDataIPDL;
        mozilla::AlignedStorage2<RemoteVideoDataIPDL> VRemoteVideoDataIPDL;
    };

    RemoteAudioDataIPDL*
    ptr_RemoteAudioDataIPDL()
    {
        return ((mValue).VRemoteAudioDataIPDL).addr();
    }
    const RemoteAudioDataIPDL*
    constptr_RemoteAudioDataIPDL() const
    {
        return ((mValue).VRemoteAudioDataIPDL).addr();
    }
    RemoteVideoDataIPDL*
    ptr_RemoteVideoDataIPDL()
    {
        return ((mValue).VRemoteVideoDataIPDL).addr();
    }
    const RemoteVideoDataIPDL*
    constptr_RemoteVideoDataIPDL() const
    {
        return ((mValue).VRemoteVideoDataIPDL).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT DecodedOutputIPDL() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT DecodedOutputIPDL(const RemoteAudioDataIPDL& aOther);

    MOZ_IMPLICIT DecodedOutputIPDL(RemoteAudioDataIPDL&& aOther);

    MOZ_IMPLICIT DecodedOutputIPDL(const RemoteVideoDataIPDL& aOther);

    MOZ_IMPLICIT DecodedOutputIPDL(RemoteVideoDataIPDL&& aOther);

    MOZ_IMPLICIT DecodedOutputIPDL(const DecodedOutputIPDL& aOther);

    MOZ_IMPLICIT DecodedOutputIPDL(DecodedOutputIPDL&& aOther);

    ~DecodedOutputIPDL();

    Type
    type() const
    {
        return mType;
    }

    DecodedOutputIPDL&
    operator=(const RemoteAudioDataIPDL& aRhs);

    DecodedOutputIPDL&
    operator=(RemoteAudioDataIPDL&& aRhs);

    DecodedOutputIPDL&
    operator=(const RemoteVideoDataIPDL& aRhs);

    DecodedOutputIPDL&
    operator=(RemoteVideoDataIPDL&& aRhs);

    DecodedOutputIPDL&
    operator=(const DecodedOutputIPDL& aRhs);

    DecodedOutputIPDL&
    operator=(DecodedOutputIPDL&& aRhs);

    bool
    operator==(const RemoteAudioDataIPDL& aRhs) const;

    bool
    operator==(const RemoteVideoDataIPDL& aRhs) const;

    bool
    operator==(const DecodedOutputIPDL& aRhs) const;

    RemoteAudioDataIPDL&
    get_RemoteAudioDataIPDL()
    {
        AssertSanity(TRemoteAudioDataIPDL);
        return (*(ptr_RemoteAudioDataIPDL()));
    }
    const RemoteAudioDataIPDL&
    get_RemoteAudioDataIPDL() const
    {
        AssertSanity(TRemoteAudioDataIPDL);
        return (*(constptr_RemoteAudioDataIPDL()));
    }
    void
    get(RemoteAudioDataIPDL* aOutValue) const;
    operator RemoteAudioDataIPDL&()
    {
        return get_RemoteAudioDataIPDL();
    }
    operator const RemoteAudioDataIPDL&() const
    {
        return get_RemoteAudioDataIPDL();
    }

    RemoteVideoDataIPDL&
    get_RemoteVideoDataIPDL()
    {
        AssertSanity(TRemoteVideoDataIPDL);
        return (*(ptr_RemoteVideoDataIPDL()));
    }
    const RemoteVideoDataIPDL&
    get_RemoteVideoDataIPDL() const
    {
        AssertSanity(TRemoteVideoDataIPDL);
        return (*(constptr_RemoteVideoDataIPDL()));
    }
    void
    get(RemoteVideoDataIPDL* aOutValue) const;
    operator RemoteVideoDataIPDL&()
    {
        return get_RemoteVideoDataIPDL();
    }
    operator const RemoteVideoDataIPDL&() const
    {
        return get_RemoteVideoDataIPDL();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::DecodedOutputIPDL>
{
    typedef mozilla::DecodedOutputIPDL paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
class PRemoteDecoderParent;
} // namespace mozilla
namespace mozilla {
class PRemoteDecoderChild;
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PRemoteDecoderChild and PRemoteDecoderParent
//
namespace mozilla {
namespace PRemoteDecoder {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::PRemoteDecoderParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::PRemoteDecoderChild>* aChild);

enum MessageType {
    PRemoteDecoderStart = PRemoteDecoderMsgStart << 16,
    Msg_Init__ID,
    Msg_Input__ID,
    Msg_Flush__ID,
    Msg_Drain__ID,
    Msg_Shutdown__ID,
    Msg_SetSeekThreshold__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_InitComplete__ID,
    Msg_InitFailed__ID,
    Msg_FlushComplete__ID,
    Msg_ShutdownComplete__ID,
    Msg_Output__ID,
    Msg_InputExhausted__ID,
    Msg_DrainComplete__ID,
    Msg_Error__ID,
    PRemoteDecoderEnd
};

IPC::Message*
Msg_Init(int32_t routingId);

IPC::Message*
Msg_Input(int32_t routingId);

IPC::Message*
Msg_Flush(int32_t routingId);

IPC::Message*
Msg_Drain(int32_t routingId);

IPC::Message*
Msg_Shutdown(int32_t routingId);

IPC::Message*
Msg_SetSeekThreshold(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);

IPC::Message*
Msg_InitComplete(int32_t routingId);

IPC::Message*
Msg_InitFailed(int32_t routingId);

IPC::Message*
Msg_FlushComplete(int32_t routingId);

IPC::Message*
Msg_ShutdownComplete(int32_t routingId);

IPC::Message*
Msg_Output(int32_t routingId);

IPC::Message*
Msg_InputExhausted(int32_t routingId);

IPC::Message*
Msg_DrainComplete(int32_t routingId);

IPC::Message*
Msg_Error(int32_t routingId);



} // namespace PRemoteDecoder
} // namespace mozilla

#endif // ifndef PRemoteDecoder_h
