//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PVideoDecoder_h
#define PVideoDecoder_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/PMediaDecoderParams.h"
#include "mozilla/layers/LayersSurfaces.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct VideoDataIPDL|
//
namespace mozilla {
class VideoDataIPDL final
{
private:
    typedef mozilla::MediaDataIPDL MediaDataIPDL;
    typedef mozilla::gfx::IntSize IntSize;
    typedef mozilla::layers::SurfaceDescriptorGPUVideo SurfaceDescriptorGPUVideo;

public:
    MOZ_IMPLICIT VideoDataIPDL() :
        base_(),
        display_(),
        frameSize_(),
        sd_(),
        frameID_()
    {
    }

    MOZ_IMPLICIT VideoDataIPDL(
            const MediaDataIPDL& _base,
            const IntSize& _display,
            const IntSize& _frameSize,
            const SurfaceDescriptorGPUVideo& _sd,
            const int32_t& _frameID) :
        base_(_base),
        display_(_display),
        frameSize_(_frameSize),
        sd_(_sd),
        frameID_(_frameID)
    {
    }

    bool
    operator==(const VideoDataIPDL& _o) const;

    bool
    operator!=(const VideoDataIPDL& _o) const;

    MediaDataIPDL&
    base()
    {
        return base_;
    }
    const MediaDataIPDL&
    base() const
    {
        return base_;
    }

    IntSize&
    display()
    {
        return display_;
    }
    const IntSize&
    display() const
    {
        return display_;
    }

    IntSize&
    frameSize()
    {
        return frameSize_;
    }
    const IntSize&
    frameSize() const
    {
        return frameSize_;
    }

    SurfaceDescriptorGPUVideo&
    sd()
    {
        return sd_;
    }
    const SurfaceDescriptorGPUVideo&
    sd() const
    {
        return sd_;
    }

    int32_t&
    frameID()
    {
        return frameID_;
    }
    const int32_t&
    frameID() const
    {
        return frameID_;
    }

private:
    MediaDataIPDL base_;
    IntSize display_;
    IntSize frameSize_;
    SurfaceDescriptorGPUVideo sd_;
    int32_t frameID_;
};
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::VideoDataIPDL>
{
    typedef mozilla::VideoDataIPDL paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
class PVideoDecoderParent;
} // namespace mozilla
namespace mozilla {
class PVideoDecoderChild;
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PVideoDecoderChild and PVideoDecoderParent
//
namespace mozilla {
namespace PVideoDecoder {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::PVideoDecoderParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::PVideoDecoderChild>* aChild);

enum MessageType {
    PVideoDecoderStart = PVideoDecoderMsgStart << 16,
    Msg_Init__ID,
    Msg_Input__ID,
    Msg_Flush__ID,
    Msg_Drain__ID,
    Msg_Shutdown__ID,
    Msg_SetSeekThreshold__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_InitComplete__ID,
    Msg_InitFailed__ID,
    Msg_FlushComplete__ID,
    Msg_ShutdownComplete__ID,
    Msg_Output__ID,
    Msg_InputExhausted__ID,
    Msg_DrainComplete__ID,
    Msg_Error__ID,
    PVideoDecoderEnd
};

IPC::Message*
Msg_Init(int32_t routingId);

IPC::Message*
Msg_Input(int32_t routingId);

IPC::Message*
Msg_Flush(int32_t routingId);

IPC::Message*
Msg_Drain(int32_t routingId);

IPC::Message*
Msg_Shutdown(int32_t routingId);

IPC::Message*
Msg_SetSeekThreshold(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);

IPC::Message*
Msg_InitComplete(int32_t routingId);

IPC::Message*
Msg_InitFailed(int32_t routingId);

IPC::Message*
Msg_FlushComplete(int32_t routingId);

IPC::Message*
Msg_ShutdownComplete(int32_t routingId);

IPC::Message*
Msg_Output(int32_t routingId);

IPC::Message*
Msg_InputExhausted(int32_t routingId);

IPC::Message*
Msg_DrainComplete(int32_t routingId);

IPC::Message*
Msg_Error(int32_t routingId);



} // namespace PVideoDecoder
} // namespace mozilla

#endif // ifndef PVideoDecoder_h
