//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef DOMTypes_h
#define DOMTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"

// Headers for typedefs
#include "Units.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/HalScreenConfiguration.h"
#include "mozilla/dom/BrowsingContext.h"
#include "mozilla/dom/CSPMessageUtils.h"
#include "mozilla/dom/PermissionMessageUtils.h"
#include "mozilla/dom/ReferrerInfoUtils.h"
#include "mozilla/gfx/Types.h"
#include "mozilla/ipc/URIUtils.h"
#include "mozilla/dom/IPCBlob.h"
#include "mozilla/ipc/IPCStream.h"
#include "mozilla/ipc/ProtocolTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MessagePortIdentifier|
//
namespace mozilla {
namespace dom {
class MessagePortIdentifier final
{
private:

public:
    MOZ_IMPLICIT MessagePortIdentifier() :
        uuid_(),
        destinationUuid_(),
        neutered_(),
        sequenceId_()
    {
    }

    MOZ_IMPLICIT MessagePortIdentifier(
            const nsID& _uuid,
            const nsID& _destinationUuid,
            const uint32_t& _sequenceId,
            const bool& _neutered) :
        uuid_(_uuid),
        destinationUuid_(_destinationUuid),
        neutered_(_neutered),
        sequenceId_(_sequenceId)
    {
    }

    bool
    operator==(const MessagePortIdentifier& _o) const;

    bool
    operator!=(const MessagePortIdentifier& _o) const;

    nsID&
    uuid()
    {
        return uuid_;
    }
    const nsID&
    uuid() const
    {
        return uuid_;
    }

    nsID&
    destinationUuid()
    {
        return destinationUuid_;
    }
    const nsID&
    destinationUuid() const
    {
        return destinationUuid_;
    }

    uint32_t&
    sequenceId()
    {
        return sequenceId_;
    }
    const uint32_t&
    sequenceId() const
    {
        return sequenceId_;
    }

    bool&
    neutered()
    {
        return neutered_;
    }
    const bool&
    neutered() const
    {
        return neutered_;
    }

private:
    nsID uuid_;
    nsID destinationUuid_;
    bool neutered_;
    uint32_t sequenceId_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::MessagePortIdentifier>
{
    typedef mozilla::dom::MessagePortIdentifier paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClonedMessageData|
//
namespace mozilla {
namespace dom {
class ClonedMessageData final
{
private:
    typedef mozilla::SerializedStructuredCloneBuffer SerializedStructuredCloneBuffer;
    typedef mozilla::dom::IPCBlob IPCBlob;
    typedef mozilla::ipc::IPCStream IPCStream;
    typedef mozilla::dom::MessagePortIdentifier MessagePortIdentifier;

public:
    MOZ_IMPLICIT ClonedMessageData() :
        data_(),
        blobs_(),
        inputStreams_(),
        identfiers_()
    {
    }

    MOZ_IMPLICIT ClonedMessageData(
            const SerializedStructuredCloneBuffer& _data,
            const nsTArray<IPCBlob>& _blobs,
            const nsTArray<IPCStream>& _inputStreams,
            const nsTArray<MessagePortIdentifier>& _identfiers) :
        data_(_data),
        blobs_(_blobs),
        inputStreams_(_inputStreams),
        identfiers_(_identfiers)
    {
    }

    bool
    operator==(const ClonedMessageData& _o) const;

    bool
    operator!=(const ClonedMessageData& _o) const;

    SerializedStructuredCloneBuffer&
    data()
    {
        return data_;
    }
    const SerializedStructuredCloneBuffer&
    data() const
    {
        return data_;
    }

    nsTArray<IPCBlob>&
    blobs()
    {
        return blobs_;
    }
    const nsTArray<IPCBlob>&
    blobs() const
    {
        return blobs_;
    }

    nsTArray<IPCStream>&
    inputStreams()
    {
        return inputStreams_;
    }
    const nsTArray<IPCStream>&
    inputStreams() const
    {
        return inputStreams_;
    }

    nsTArray<MessagePortIdentifier>&
    identfiers()
    {
        return identfiers_;
    }
    const nsTArray<MessagePortIdentifier>&
    identfiers() const
    {
        return identfiers_;
    }

private:
    SerializedStructuredCloneBuffer data_;
    nsTArray<IPCBlob> blobs_;
    nsTArray<IPCStream> inputStreams_;
    nsTArray<MessagePortIdentifier> identfiers_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::ClonedMessageData>
{
    typedef mozilla::dom::ClonedMessageData paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union IPCDataTransferData|
//
namespace mozilla {
namespace dom {
class IPCDataTransferData final
{
public:
    enum Type {
        T__None,
        TnsString = 1,
        TShmem,
        TIPCBlob,
        T__Last = TIPCBlob
    };

private:
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::dom::IPCBlob IPCBlob;
    typedef nsString nsString__tdef;
    typedef Shmem Shmem__tdef;
    typedef IPCBlob IPCBlob__tdef;

    union Value {
        mozilla::AlignedStorage2<nsString> VnsString;
        mozilla::AlignedStorage2<Shmem> VShmem;
        mozilla::AlignedStorage2<IPCBlob> VIPCBlob;
    };

    nsString*
    ptr_nsString()
    {
        return ((mValue).VnsString).addr();
    }
    const nsString*
    constptr_nsString() const
    {
        return ((mValue).VnsString).addr();
    }
    Shmem*
    ptr_Shmem()
    {
        return ((mValue).VShmem).addr();
    }
    const Shmem*
    constptr_Shmem() const
    {
        return ((mValue).VShmem).addr();
    }
    IPCBlob*
    ptr_IPCBlob()
    {
        return ((mValue).VIPCBlob).addr();
    }
    const IPCBlob*
    constptr_IPCBlob() const
    {
        return ((mValue).VIPCBlob).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT IPCDataTransferData() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT IPCDataTransferData(const nsString& aOther);

    MOZ_IMPLICIT IPCDataTransferData(nsString&& aOther);

    MOZ_IMPLICIT IPCDataTransferData(Shmem&& aOther);

    MOZ_IMPLICIT IPCDataTransferData(const IPCBlob& aOther);

    MOZ_IMPLICIT IPCDataTransferData(IPCBlob&& aOther);

    MOZ_IMPLICIT IPCDataTransferData(const IPCDataTransferData& aOther);

    MOZ_IMPLICIT IPCDataTransferData(IPCDataTransferData&& aOther);

    ~IPCDataTransferData();

    Type
    type() const
    {
        return mType;
    }

    IPCDataTransferData&
    operator=(const nsString& aRhs);

    IPCDataTransferData&
    operator=(nsString&& aRhs);

    IPCDataTransferData&
    operator=(Shmem&& aRhs);

    IPCDataTransferData&
    operator=(const IPCBlob& aRhs);

    IPCDataTransferData&
    operator=(IPCBlob&& aRhs);

    IPCDataTransferData&
    operator=(const IPCDataTransferData& aRhs);

    IPCDataTransferData&
    operator=(IPCDataTransferData&& aRhs);

    bool
    operator==(const nsString& aRhs) const;

    bool
    operator==(Shmem&& aRhs) const;

    bool
    operator==(const IPCBlob& aRhs) const;

    bool
    operator==(const IPCDataTransferData& aRhs) const;

    nsString&
    get_nsString()
    {
        AssertSanity(TnsString);
        return (*(ptr_nsString()));
    }
    const nsString&
    get_nsString() const
    {
        AssertSanity(TnsString);
        return (*(constptr_nsString()));
    }
    void
    get(nsString* aOutValue) const;
    operator nsString&()
    {
        return get_nsString();
    }
    operator const nsString&() const
    {
        return get_nsString();
    }

    Shmem&
    get_Shmem()
    {
        AssertSanity(TShmem);
        return (*(ptr_Shmem()));
    }
    Shmem&
    get_Shmem() const
    {
        AssertSanity(TShmem);
        return const_cast<Shmem&>((*(constptr_Shmem())));
    }
    void
    get(Shmem* aOutValue) const;
    operator Shmem&()
    {
        return get_Shmem();
    }
    operator Shmem&() const
    {
        return get_Shmem();
    }

    IPCBlob&
    get_IPCBlob()
    {
        AssertSanity(TIPCBlob);
        return (*(ptr_IPCBlob()));
    }
    const IPCBlob&
    get_IPCBlob() const
    {
        AssertSanity(TIPCBlob);
        return (*(constptr_IPCBlob()));
    }
    void
    get(IPCBlob* aOutValue) const;
    operator IPCBlob&()
    {
        return get_IPCBlob();
    }
    operator const IPCBlob&() const
    {
        return get_IPCBlob();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCDataTransferData>
{
    typedef mozilla::dom::IPCDataTransferData paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCDataTransferImage|
//
namespace mozilla {
namespace dom {
class IPCDataTransferImage final
{
private:
    typedef mozilla::gfx::SurfaceFormat SurfaceFormat;

public:
    MOZ_IMPLICIT IPCDataTransferImage() :
        format_(),
        width_(),
        height_(),
        stride_()
    {
    }

    MOZ_IMPLICIT IPCDataTransferImage(
            const uint32_t& _width,
            const uint32_t& _height,
            const uint32_t& _stride,
            const SurfaceFormat& _format) :
        format_(_format),
        width_(_width),
        height_(_height),
        stride_(_stride)
    {
    }

    bool
    operator==(const IPCDataTransferImage& _o) const;

    bool
    operator!=(const IPCDataTransferImage& _o) const;

    uint32_t&
    width()
    {
        return width_;
    }
    const uint32_t&
    width() const
    {
        return width_;
    }

    uint32_t&
    height()
    {
        return height_;
    }
    const uint32_t&
    height() const
    {
        return height_;
    }

    uint32_t&
    stride()
    {
        return stride_;
    }
    const uint32_t&
    stride() const
    {
        return stride_;
    }

    SurfaceFormat&
    format()
    {
        return format_;
    }
    const SurfaceFormat&
    format() const
    {
        return format_;
    }

private:
    void
    StaticAssertions() const;
    SurfaceFormat format_;
    uint32_t width_;
    uint32_t height_;
    uint32_t stride_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCDataTransferImage>
{
    typedef mozilla::dom::IPCDataTransferImage paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCDataTransferItem|
//
namespace mozilla {
namespace dom {
class IPCDataTransferItem final
{
private:
    typedef mozilla::dom::IPCDataTransferImage IPCDataTransferImage;
    typedef mozilla::dom::IPCDataTransferData IPCDataTransferData;

public:
    MOZ_IMPLICIT IPCDataTransferItem() :
        flavor_(),
        imageDetails_(),
        data_()
    {
    }

    MOZ_IMPLICIT IPCDataTransferItem(
            const nsCString& _flavor,
            const IPCDataTransferImage& _imageDetails,
            const IPCDataTransferData& _data) :
        flavor_(_flavor),
        imageDetails_(_imageDetails),
        data_(_data)
    {
    }

    bool
    operator==(const IPCDataTransferItem& _o) const;

    bool
    operator!=(const IPCDataTransferItem& _o) const;

    nsCString&
    flavor()
    {
        return flavor_;
    }
    const nsCString&
    flavor() const
    {
        return flavor_;
    }

    IPCDataTransferImage&
    imageDetails()
    {
        return imageDetails_;
    }
    const IPCDataTransferImage&
    imageDetails() const
    {
        return imageDetails_;
    }

    IPCDataTransferData&
    data()
    {
        return data_;
    }
    const IPCDataTransferData&
    data() const
    {
        return data_;
    }

private:
    nsCString flavor_;
    IPCDataTransferImage imageDetails_;
    IPCDataTransferData data_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCDataTransferItem>
{
    typedef mozilla::dom::IPCDataTransferItem paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCDataTransfer|
//
namespace mozilla {
namespace dom {
class IPCDataTransfer final
{
private:
    typedef mozilla::dom::IPCDataTransferItem IPCDataTransferItem;

public:
    MOZ_IMPLICIT IPCDataTransfer() :
        items_()
    {
    }

    MOZ_IMPLICIT IPCDataTransfer(const nsTArray<IPCDataTransferItem>& _items) :
        items_(_items)
    {
    }

    bool
    operator==(const IPCDataTransfer& _o) const;

    bool
    operator!=(const IPCDataTransfer& _o) const;

    nsTArray<IPCDataTransferItem>&
    items()
    {
        return items_;
    }
    const nsTArray<IPCDataTransferItem>&
    items() const
    {
        return items_;
    }

private:
    nsTArray<IPCDataTransferItem> items_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCDataTransfer>
{
    typedef mozilla::dom::IPCDataTransfer paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ScreenDetails|
//
namespace mozilla {
namespace dom {
class ScreenDetails final
{
private:

public:
    MOZ_IMPLICIT ScreenDetails() :
        rect_(),
        rectDisplayPix_(),
        availRect_(),
        availRectDisplayPix_(),
        contentsScaleFactor_(),
        defaultCSSScaleFactor_(),
        pixelDepth_(),
        colorDepth_(),
        dpi_()
    {
    }

    MOZ_IMPLICIT ScreenDetails(
            const LayoutDeviceIntRect& _rect,
            const DesktopIntRect& _rectDisplayPix,
            const LayoutDeviceIntRect& _availRect,
            const DesktopIntRect& _availRectDisplayPix,
            const int32_t& _pixelDepth,
            const int32_t& _colorDepth,
            const DesktopToLayoutDeviceScale& _contentsScaleFactor,
            const CSSToLayoutDeviceScale& _defaultCSSScaleFactor,
            const float& _dpi) :
        rect_(_rect),
        rectDisplayPix_(_rectDisplayPix),
        availRect_(_availRect),
        availRectDisplayPix_(_availRectDisplayPix),
        contentsScaleFactor_(_contentsScaleFactor),
        defaultCSSScaleFactor_(_defaultCSSScaleFactor),
        pixelDepth_(_pixelDepth),
        colorDepth_(_colorDepth),
        dpi_(_dpi)
    {
    }

    bool
    operator==(const ScreenDetails& _o) const;

    bool
    operator!=(const ScreenDetails& _o) const;

    LayoutDeviceIntRect&
    rect()
    {
        return rect_;
    }
    const LayoutDeviceIntRect&
    rect() const
    {
        return rect_;
    }

    DesktopIntRect&
    rectDisplayPix()
    {
        return rectDisplayPix_;
    }
    const DesktopIntRect&
    rectDisplayPix() const
    {
        return rectDisplayPix_;
    }

    LayoutDeviceIntRect&
    availRect()
    {
        return availRect_;
    }
    const LayoutDeviceIntRect&
    availRect() const
    {
        return availRect_;
    }

    DesktopIntRect&
    availRectDisplayPix()
    {
        return availRectDisplayPix_;
    }
    const DesktopIntRect&
    availRectDisplayPix() const
    {
        return availRectDisplayPix_;
    }

    int32_t&
    pixelDepth()
    {
        return pixelDepth_;
    }
    const int32_t&
    pixelDepth() const
    {
        return pixelDepth_;
    }

    int32_t&
    colorDepth()
    {
        return colorDepth_;
    }
    const int32_t&
    colorDepth() const
    {
        return colorDepth_;
    }

    DesktopToLayoutDeviceScale&
    contentsScaleFactor()
    {
        return contentsScaleFactor_;
    }
    const DesktopToLayoutDeviceScale&
    contentsScaleFactor() const
    {
        return contentsScaleFactor_;
    }

    CSSToLayoutDeviceScale&
    defaultCSSScaleFactor()
    {
        return defaultCSSScaleFactor_;
    }
    const CSSToLayoutDeviceScale&
    defaultCSSScaleFactor() const
    {
        return defaultCSSScaleFactor_;
    }

    float&
    dpi()
    {
        return dpi_;
    }
    const float&
    dpi() const
    {
        return dpi_;
    }

private:
    void
    StaticAssertions() const;
    LayoutDeviceIntRect rect_;
    DesktopIntRect rectDisplayPix_;
    LayoutDeviceIntRect availRect_;
    DesktopIntRect availRectDisplayPix_;
    DesktopToLayoutDeviceScale contentsScaleFactor_;
    CSSToLayoutDeviceScale defaultCSSScaleFactor_;
    int32_t pixelDepth_;
    int32_t colorDepth_;
    float dpi_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::ScreenDetails>
{
    typedef mozilla::dom::ScreenDetails paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct DimensionInfo|
//
namespace mozilla {
namespace dom {
class DimensionInfo final
{
private:
    typedef hal::ScreenOrientation ScreenOrientation;
    typedef mozilla::LayoutDeviceIntPoint LayoutDeviceIntPoint;

public:
    MOZ_IMPLICIT DimensionInfo() :
        rect_(),
        size_(),
        orientation_(),
        clientOffset_(),
        chromeOffset_()
    {
    }

    MOZ_IMPLICIT DimensionInfo(
            const CSSRect& _rect,
            const CSSSize& _size,
            const ScreenOrientation& _orientation,
            const LayoutDeviceIntPoint& _clientOffset,
            const LayoutDeviceIntPoint& _chromeOffset) :
        rect_(_rect),
        size_(_size),
        orientation_(_orientation),
        clientOffset_(_clientOffset),
        chromeOffset_(_chromeOffset)
    {
    }

    bool
    operator==(const DimensionInfo& _o) const;

    bool
    operator!=(const DimensionInfo& _o) const;

    CSSRect&
    rect()
    {
        return rect_;
    }
    const CSSRect&
    rect() const
    {
        return rect_;
    }

    CSSSize&
    size()
    {
        return size_;
    }
    const CSSSize&
    size() const
    {
        return size_;
    }

    ScreenOrientation&
    orientation()
    {
        return orientation_;
    }
    const ScreenOrientation&
    orientation() const
    {
        return orientation_;
    }

    LayoutDeviceIntPoint&
    clientOffset()
    {
        return clientOffset_;
    }
    const LayoutDeviceIntPoint&
    clientOffset() const
    {
        return clientOffset_;
    }

    LayoutDeviceIntPoint&
    chromeOffset()
    {
        return chromeOffset_;
    }
    const LayoutDeviceIntPoint&
    chromeOffset() const
    {
        return chromeOffset_;
    }

private:
    CSSRect rect_;
    CSSSize size_;
    ScreenOrientation orientation_;
    LayoutDeviceIntPoint clientOffset_;
    LayoutDeviceIntPoint chromeOffset_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::DimensionInfo>
{
    typedef mozilla::dom::DimensionInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FrameScriptInfo|
//
namespace mozilla {
namespace dom {
class FrameScriptInfo final
{
private:

public:
    MOZ_IMPLICIT FrameScriptInfo() :
        url_(),
        runInGlobalScope_()
    {
    }

    MOZ_IMPLICIT FrameScriptInfo(
            const nsString& _url,
            const bool& _runInGlobalScope) :
        url_(_url),
        runInGlobalScope_(_runInGlobalScope)
    {
    }

    bool
    operator==(const FrameScriptInfo& _o) const;

    bool
    operator!=(const FrameScriptInfo& _o) const;

    nsString&
    url()
    {
        return url_;
    }
    const nsString&
    url() const
    {
        return url_;
    }

    bool&
    runInGlobalScope()
    {
        return runInGlobalScope_;
    }
    const bool&
    runInGlobalScope() const
    {
        return runInGlobalScope_;
    }

private:
    nsString url_;
    bool runInGlobalScope_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::FrameScriptInfo>
{
    typedef mozilla::dom::FrameScriptInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CreatedWindowInfo|
//
namespace mozilla {
namespace dom {
class CreatedWindowInfo final
{
private:
    typedef mozilla::dom::FrameScriptInfo FrameScriptInfo;
    typedef mozilla::dom::DimensionInfo DimensionInfo;

public:
    MOZ_IMPLICIT CreatedWindowInfo() :
        rv_(),
        windowOpened_(),
        frameScripts_(),
        urlToLoad_(),
        dimensions_(),
        hasSiblings_(),
        maxTouchPoints_()
    {
    }

    MOZ_IMPLICIT CreatedWindowInfo(
            const nsresult& _rv,
            const bool& _windowOpened,
            const nsTArray<FrameScriptInfo>& _frameScripts,
            const nsCString& _urlToLoad,
            const uint32_t& _maxTouchPoints,
            const DimensionInfo& _dimensions,
            const bool& _hasSiblings) :
        rv_(_rv),
        windowOpened_(_windowOpened),
        frameScripts_(_frameScripts),
        urlToLoad_(_urlToLoad),
        dimensions_(_dimensions),
        hasSiblings_(_hasSiblings),
        maxTouchPoints_(_maxTouchPoints)
    {
    }

    bool
    operator==(const CreatedWindowInfo& _o) const;

    bool
    operator!=(const CreatedWindowInfo& _o) const;

    nsresult&
    rv()
    {
        return rv_;
    }
    const nsresult&
    rv() const
    {
        return rv_;
    }

    bool&
    windowOpened()
    {
        return windowOpened_;
    }
    const bool&
    windowOpened() const
    {
        return windowOpened_;
    }

    nsTArray<FrameScriptInfo>&
    frameScripts()
    {
        return frameScripts_;
    }
    const nsTArray<FrameScriptInfo>&
    frameScripts() const
    {
        return frameScripts_;
    }

    nsCString&
    urlToLoad()
    {
        return urlToLoad_;
    }
    const nsCString&
    urlToLoad() const
    {
        return urlToLoad_;
    }

    uint32_t&
    maxTouchPoints()
    {
        return maxTouchPoints_;
    }
    const uint32_t&
    maxTouchPoints() const
    {
        return maxTouchPoints_;
    }

    DimensionInfo&
    dimensions()
    {
        return dimensions_;
    }
    const DimensionInfo&
    dimensions() const
    {
        return dimensions_;
    }

    bool&
    hasSiblings()
    {
        return hasSiblings_;
    }
    const bool&
    hasSiblings() const
    {
        return hasSiblings_;
    }

private:
    nsresult rv_;
    bool windowOpened_;
    nsTArray<FrameScriptInfo> frameScripts_;
    nsCString urlToLoad_;
    DimensionInfo dimensions_;
    bool hasSiblings_;
    uint32_t maxTouchPoints_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::CreatedWindowInfo>
{
    typedef mozilla::dom::CreatedWindowInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MediaMemoryInfo|
//
namespace mozilla {
namespace dom {
class MediaMemoryInfo final
{
private:

public:
    MOZ_IMPLICIT MediaMemoryInfo() :
        audioSize_(),
        videoSize_(),
        resourcesSize_()
    {
    }

    MOZ_IMPLICIT MediaMemoryInfo(
            const uint64_t& _audioSize,
            const uint64_t& _videoSize,
            const uint64_t& _resourcesSize) :
        audioSize_(_audioSize),
        videoSize_(_videoSize),
        resourcesSize_(_resourcesSize)
    {
    }

    bool
    operator==(const MediaMemoryInfo& _o) const;

    bool
    operator!=(const MediaMemoryInfo& _o) const;

    uint64_t&
    audioSize()
    {
        return audioSize_;
    }
    const uint64_t&
    audioSize() const
    {
        return audioSize_;
    }

    uint64_t&
    videoSize()
    {
        return videoSize_;
    }
    const uint64_t&
    videoSize() const
    {
        return videoSize_;
    }

    uint64_t&
    resourcesSize()
    {
        return resourcesSize_;
    }
    const uint64_t&
    resourcesSize() const
    {
        return resourcesSize_;
    }

private:
    void
    StaticAssertions() const;
    uint64_t audioSize_;
    uint64_t videoSize_;
    uint64_t resourcesSize_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::MediaMemoryInfo>
{
    typedef mozilla::dom::MediaMemoryInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct PerformanceMemoryInfo|
//
namespace mozilla {
namespace dom {
class PerformanceMemoryInfo final
{
private:
    typedef mozilla::dom::MediaMemoryInfo MediaMemoryInfo;

public:
    MOZ_IMPLICIT PerformanceMemoryInfo() :
        media_(),
        domDom_(),
        domStyle_(),
        domOther_(),
        GCHeapUsage_()
    {
    }

    MOZ_IMPLICIT PerformanceMemoryInfo(
            const MediaMemoryInfo& _media,
            const uint64_t& _domDom,
            const uint64_t& _domStyle,
            const uint64_t& _domOther,
            const uint64_t& _GCHeapUsage) :
        media_(_media),
        domDom_(_domDom),
        domStyle_(_domStyle),
        domOther_(_domOther),
        GCHeapUsage_(_GCHeapUsage)
    {
    }

    bool
    operator==(const PerformanceMemoryInfo& _o) const;

    bool
    operator!=(const PerformanceMemoryInfo& _o) const;

    MediaMemoryInfo&
    media()
    {
        return media_;
    }
    const MediaMemoryInfo&
    media() const
    {
        return media_;
    }

    uint64_t&
    domDom()
    {
        return domDom_;
    }
    const uint64_t&
    domDom() const
    {
        return domDom_;
    }

    uint64_t&
    domStyle()
    {
        return domStyle_;
    }
    const uint64_t&
    domStyle() const
    {
        return domStyle_;
    }

    uint64_t&
    domOther()
    {
        return domOther_;
    }
    const uint64_t&
    domOther() const
    {
        return domOther_;
    }

    uint64_t&
    GCHeapUsage()
    {
        return GCHeapUsage_;
    }
    const uint64_t&
    GCHeapUsage() const
    {
        return GCHeapUsage_;
    }

private:
    void
    StaticAssertions() const;
    MediaMemoryInfo media_;
    uint64_t domDom_;
    uint64_t domStyle_;
    uint64_t domOther_;
    uint64_t GCHeapUsage_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::PerformanceMemoryInfo>
{
    typedef mozilla::dom::PerformanceMemoryInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CategoryDispatch|
//
namespace mozilla {
namespace dom {
class CategoryDispatch final
{
private:

public:
    MOZ_IMPLICIT CategoryDispatch() :
        category_(),
        count_()
    {
    }

    MOZ_IMPLICIT CategoryDispatch(
            const uint16_t& _category,
            const uint16_t& _count) :
        category_(_category),
        count_(_count)
    {
    }

    bool
    operator==(const CategoryDispatch& _o) const;

    bool
    operator!=(const CategoryDispatch& _o) const;

    uint16_t&
    category()
    {
        return category_;
    }
    const uint16_t&
    category() const
    {
        return category_;
    }

    uint16_t&
    count()
    {
        return count_;
    }
    const uint16_t&
    count() const
    {
        return count_;
    }

private:
    void
    StaticAssertions() const;
    uint16_t category_;
    uint16_t count_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::CategoryDispatch>
{
    typedef mozilla::dom::CategoryDispatch paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct PerformanceInfo|
//
namespace mozilla {
namespace dom {
class PerformanceInfo final
{
private:
    typedef mozilla::dom::PerformanceMemoryInfo PerformanceMemoryInfo;
    typedef mozilla::dom::CategoryDispatch CategoryDispatch;

public:
    MOZ_IMPLICIT PerformanceInfo() :
        host_(),
        isWorker_(),
        isTopLevel_(),
        memory_(),
        items_(),
        windowId_(),
        duration_(),
        counterId_(),
        pid_()
    {
    }

    MOZ_IMPLICIT PerformanceInfo(
            const nsCString& _host,
            const uint32_t& _pid,
            const uint64_t& _windowId,
            const uint64_t& _duration,
            const uint64_t& _counterId,
            const bool& _isWorker,
            const bool& _isTopLevel,
            const PerformanceMemoryInfo& _memory,
            const nsTArray<CategoryDispatch>& _items) :
        host_(_host),
        isWorker_(_isWorker),
        isTopLevel_(_isTopLevel),
        memory_(_memory),
        items_(_items),
        windowId_(_windowId),
        duration_(_duration),
        counterId_(_counterId),
        pid_(_pid)
    {
    }

    bool
    operator==(const PerformanceInfo& _o) const;

    bool
    operator!=(const PerformanceInfo& _o) const;

    nsCString&
    host()
    {
        return host_;
    }
    const nsCString&
    host() const
    {
        return host_;
    }

    uint32_t&
    pid()
    {
        return pid_;
    }
    const uint32_t&
    pid() const
    {
        return pid_;
    }

    uint64_t&
    windowId()
    {
        return windowId_;
    }
    const uint64_t&
    windowId() const
    {
        return windowId_;
    }

    uint64_t&
    duration()
    {
        return duration_;
    }
    const uint64_t&
    duration() const
    {
        return duration_;
    }

    uint64_t&
    counterId()
    {
        return counterId_;
    }
    const uint64_t&
    counterId() const
    {
        return counterId_;
    }

    bool&
    isWorker()
    {
        return isWorker_;
    }
    const bool&
    isWorker() const
    {
        return isWorker_;
    }

    bool&
    isTopLevel()
    {
        return isTopLevel_;
    }
    const bool&
    isTopLevel() const
    {
        return isTopLevel_;
    }

    PerformanceMemoryInfo&
    memory()
    {
        return memory_;
    }
    const PerformanceMemoryInfo&
    memory() const
    {
        return memory_;
    }

    nsTArray<CategoryDispatch>&
    items()
    {
        return items_;
    }
    const nsTArray<CategoryDispatch>&
    items() const
    {
        return items_;
    }

private:
    void
    StaticAssertions() const;
    nsCString host_;
    bool isWorker_;
    bool isTopLevel_;
    PerformanceMemoryInfo memory_;
    nsTArray<CategoryDispatch> items_;
    uint64_t windowId_;
    uint64_t duration_;
    uint64_t counterId_;
    uint32_t pid_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::PerformanceInfo>
{
    typedef mozilla::dom::PerformanceInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WindowGlobalInit|
//
namespace mozilla {
namespace dom {
class WindowGlobalInit final
{
private:
    typedef mozilla::dom::BrowsingContext BrowsingContext;

public:
    MOZ_IMPLICIT WindowGlobalInit() :
        principal_(),
        documentURI_(),
        browsingContext_(),
        innerWindowId_(),
        outerWindowId_()
    {
    }

    MOZ_IMPLICIT WindowGlobalInit(
            nsIPrincipal* _principal,
            nsIURI* _documentURI,
            BrowsingContext* _browsingContext,
            const uint64_t& _innerWindowId,
            const uint64_t& _outerWindowId) :
        principal_(_principal),
        documentURI_(_documentURI),
        browsingContext_(_browsingContext),
        innerWindowId_(_innerWindowId),
        outerWindowId_(_outerWindowId)
    {
    }

    bool
    operator==(const WindowGlobalInit& _o) const;

    bool
    operator!=(const WindowGlobalInit& _o) const;

    RefPtr<nsIPrincipal>&
    principal()
    {
        return principal_;
    }
    nsIPrincipal*
    principal() const
    {
        return principal_;
    }

    RefPtr<nsIURI>&
    documentURI()
    {
        return documentURI_;
    }
    nsIURI*
    documentURI() const
    {
        return documentURI_;
    }

    RefPtr<BrowsingContext>&
    browsingContext()
    {
        return browsingContext_;
    }
    BrowsingContext*
    browsingContext() const
    {
        return browsingContext_;
    }

    uint64_t&
    innerWindowId()
    {
        return innerWindowId_;
    }
    const uint64_t&
    innerWindowId() const
    {
        return innerWindowId_;
    }

    uint64_t&
    outerWindowId()
    {
        return outerWindowId_;
    }
    const uint64_t&
    outerWindowId() const
    {
        return outerWindowId_;
    }

private:
    void
    StaticAssertions() const;
    RefPtr<nsIPrincipal> principal_;
    RefPtr<nsIURI> documentURI_;
    RefPtr<BrowsingContext> browsingContext_;
    uint64_t innerWindowId_;
    uint64_t outerWindowId_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::WindowGlobalInit>
{
    typedef mozilla::dom::WindowGlobalInit paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct DocShellLoadStateInit|
//
namespace mozilla {
namespace dom {
class DocShellLoadStateInit final
{
private:

public:
    MOZ_IMPLICIT DocShellLoadStateInit() :
        URI_(),
        OriginalURI_(),
        ResultPrincipalURI_(),
        ResultPrincipalURIIsSome_(),
        TriggeringPrincipal_(),
        ReferrerInfo_(),
        KeepResultPrincipalURIIfSet_(),
        LoadReplace_(),
        InheritPrincipal_(),
        PrincipalIsExplicit_(),
        PrincipalToInherit_(),
        ForceAllowDataURI_(),
        OriginalFrameSrc_(),
        Target_(),
        BaseURI_(),
        FirstParty_(),
        TypeHint_(),
        FileName_(),
        IsFromProcessingFrameAttributes_(),
        Csp_(),
        LoadType_(),
        LoadFlags_()
    {
    }

    MOZ_IMPLICIT DocShellLoadStateInit(
            nsIURI* _URI,
            nsIURI* _OriginalURI,
            nsIURI* _ResultPrincipalURI,
            const bool& _ResultPrincipalURIIsSome,
            nsIPrincipal* _TriggeringPrincipal,
            nsIReferrerInfo* _ReferrerInfo,
            const bool& _KeepResultPrincipalURIIfSet,
            const bool& _LoadReplace,
            const bool& _InheritPrincipal,
            const bool& _PrincipalIsExplicit,
            nsIPrincipal* _PrincipalToInherit,
            const bool& _ForceAllowDataURI,
            const bool& _OriginalFrameSrc,
            const uint32_t& _LoadType,
            const nsString& _Target,
            nsIURI* _BaseURI,
            const uint32_t& _LoadFlags,
            const bool& _FirstParty,
            const nsCString& _TypeHint,
            const nsString& _FileName,
            const bool& _IsFromProcessingFrameAttributes,
            nsIContentSecurityPolicy* _Csp) :
        URI_(_URI),
        OriginalURI_(_OriginalURI),
        ResultPrincipalURI_(_ResultPrincipalURI),
        ResultPrincipalURIIsSome_(_ResultPrincipalURIIsSome),
        TriggeringPrincipal_(_TriggeringPrincipal),
        ReferrerInfo_(_ReferrerInfo),
        KeepResultPrincipalURIIfSet_(_KeepResultPrincipalURIIfSet),
        LoadReplace_(_LoadReplace),
        InheritPrincipal_(_InheritPrincipal),
        PrincipalIsExplicit_(_PrincipalIsExplicit),
        PrincipalToInherit_(_PrincipalToInherit),
        ForceAllowDataURI_(_ForceAllowDataURI),
        OriginalFrameSrc_(_OriginalFrameSrc),
        Target_(_Target),
        BaseURI_(_BaseURI),
        FirstParty_(_FirstParty),
        TypeHint_(_TypeHint),
        FileName_(_FileName),
        IsFromProcessingFrameAttributes_(_IsFromProcessingFrameAttributes),
        Csp_(_Csp),
        LoadType_(_LoadType),
        LoadFlags_(_LoadFlags)
    {
    }

    bool
    operator==(const DocShellLoadStateInit& _o) const;

    bool
    operator!=(const DocShellLoadStateInit& _o) const;

    RefPtr<nsIURI>&
    URI()
    {
        return URI_;
    }
    nsIURI*
    URI() const
    {
        return URI_;
    }

    RefPtr<nsIURI>&
    OriginalURI()
    {
        return OriginalURI_;
    }
    nsIURI*
    OriginalURI() const
    {
        return OriginalURI_;
    }

    RefPtr<nsIURI>&
    ResultPrincipalURI()
    {
        return ResultPrincipalURI_;
    }
    nsIURI*
    ResultPrincipalURI() const
    {
        return ResultPrincipalURI_;
    }

    bool&
    ResultPrincipalURIIsSome()
    {
        return ResultPrincipalURIIsSome_;
    }
    const bool&
    ResultPrincipalURIIsSome() const
    {
        return ResultPrincipalURIIsSome_;
    }

    RefPtr<nsIPrincipal>&
    TriggeringPrincipal()
    {
        return TriggeringPrincipal_;
    }
    nsIPrincipal*
    TriggeringPrincipal() const
    {
        return TriggeringPrincipal_;
    }

    RefPtr<nsIReferrerInfo>&
    ReferrerInfo()
    {
        return ReferrerInfo_;
    }
    nsIReferrerInfo*
    ReferrerInfo() const
    {
        return ReferrerInfo_;
    }

    bool&
    KeepResultPrincipalURIIfSet()
    {
        return KeepResultPrincipalURIIfSet_;
    }
    const bool&
    KeepResultPrincipalURIIfSet() const
    {
        return KeepResultPrincipalURIIfSet_;
    }

    bool&
    LoadReplace()
    {
        return LoadReplace_;
    }
    const bool&
    LoadReplace() const
    {
        return LoadReplace_;
    }

    bool&
    InheritPrincipal()
    {
        return InheritPrincipal_;
    }
    const bool&
    InheritPrincipal() const
    {
        return InheritPrincipal_;
    }

    bool&
    PrincipalIsExplicit()
    {
        return PrincipalIsExplicit_;
    }
    const bool&
    PrincipalIsExplicit() const
    {
        return PrincipalIsExplicit_;
    }

    RefPtr<nsIPrincipal>&
    PrincipalToInherit()
    {
        return PrincipalToInherit_;
    }
    nsIPrincipal*
    PrincipalToInherit() const
    {
        return PrincipalToInherit_;
    }

    bool&
    ForceAllowDataURI()
    {
        return ForceAllowDataURI_;
    }
    const bool&
    ForceAllowDataURI() const
    {
        return ForceAllowDataURI_;
    }

    bool&
    OriginalFrameSrc()
    {
        return OriginalFrameSrc_;
    }
    const bool&
    OriginalFrameSrc() const
    {
        return OriginalFrameSrc_;
    }

    uint32_t&
    LoadType()
    {
        return LoadType_;
    }
    const uint32_t&
    LoadType() const
    {
        return LoadType_;
    }

    nsString&
    Target()
    {
        return Target_;
    }
    const nsString&
    Target() const
    {
        return Target_;
    }

    RefPtr<nsIURI>&
    BaseURI()
    {
        return BaseURI_;
    }
    nsIURI*
    BaseURI() const
    {
        return BaseURI_;
    }

    uint32_t&
    LoadFlags()
    {
        return LoadFlags_;
    }
    const uint32_t&
    LoadFlags() const
    {
        return LoadFlags_;
    }

    bool&
    FirstParty()
    {
        return FirstParty_;
    }
    const bool&
    FirstParty() const
    {
        return FirstParty_;
    }

    nsCString&
    TypeHint()
    {
        return TypeHint_;
    }
    const nsCString&
    TypeHint() const
    {
        return TypeHint_;
    }

    nsString&
    FileName()
    {
        return FileName_;
    }
    const nsString&
    FileName() const
    {
        return FileName_;
    }

    bool&
    IsFromProcessingFrameAttributes()
    {
        return IsFromProcessingFrameAttributes_;
    }
    const bool&
    IsFromProcessingFrameAttributes() const
    {
        return IsFromProcessingFrameAttributes_;
    }

    RefPtr<nsIContentSecurityPolicy>&
    Csp()
    {
        return Csp_;
    }
    nsIContentSecurityPolicy*
    Csp() const
    {
        return Csp_;
    }

private:
    void
    StaticAssertions() const;
    RefPtr<nsIURI> URI_;
    RefPtr<nsIURI> OriginalURI_;
    RefPtr<nsIURI> ResultPrincipalURI_;
    bool ResultPrincipalURIIsSome_;
    RefPtr<nsIPrincipal> TriggeringPrincipal_;
    RefPtr<nsIReferrerInfo> ReferrerInfo_;
    bool KeepResultPrincipalURIIfSet_;
    bool LoadReplace_;
    bool InheritPrincipal_;
    bool PrincipalIsExplicit_;
    RefPtr<nsIPrincipal> PrincipalToInherit_;
    bool ForceAllowDataURI_;
    bool OriginalFrameSrc_;
    nsString Target_;
    RefPtr<nsIURI> BaseURI_;
    bool FirstParty_;
    nsCString TypeHint_;
    nsString FileName_;
    bool IsFromProcessingFrameAttributes_;
    RefPtr<nsIContentSecurityPolicy> Csp_;
    uint32_t LoadType_;
    uint32_t LoadFlags_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::DocShellLoadStateInit>
{
    typedef mozilla::dom::DocShellLoadStateInit paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef DOMTypes_h
