//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef IPCBlob_h
#define IPCBlob_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/ipc/IPCStream.h"
#include "mozilla/ipc/ProtocolTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCFile|
//
namespace mozilla {
namespace dom {
class IPCFile final
{
private:

public:
    MOZ_IMPLICIT IPCFile() :
        name_(),
        DOMPath_(),
        fullPath_(),
        isDirectory_(),
        lastModified_()
    {
    }

    MOZ_IMPLICIT IPCFile(
            const nsString& _name,
            const int64_t& _lastModified,
            const nsString& _DOMPath,
            const nsString& _fullPath,
            const bool& _isDirectory) :
        name_(_name),
        DOMPath_(_DOMPath),
        fullPath_(_fullPath),
        isDirectory_(_isDirectory),
        lastModified_(_lastModified)
    {
    }

    bool
    operator==(const IPCFile& _o) const;

    bool
    operator!=(const IPCFile& _o) const;

    nsString&
    name()
    {
        return name_;
    }
    const nsString&
    name() const
    {
        return name_;
    }

    int64_t&
    lastModified()
    {
        return lastModified_;
    }
    const int64_t&
    lastModified() const
    {
        return lastModified_;
    }

    nsString&
    DOMPath()
    {
        return DOMPath_;
    }
    const nsString&
    DOMPath() const
    {
        return DOMPath_;
    }

    nsString&
    fullPath()
    {
        return fullPath_;
    }
    const nsString&
    fullPath() const
    {
        return fullPath_;
    }

    bool&
    isDirectory()
    {
        return isDirectory_;
    }
    const bool&
    isDirectory() const
    {
        return isDirectory_;
    }

private:
    nsString name_;
    nsString DOMPath_;
    nsString fullPath_;
    bool isDirectory_;
    int64_t lastModified_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCFile>
{
    typedef mozilla::dom::IPCFile paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {
class PIPCBlobInputStreamParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PIPCBlobInputStreamChild;
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union IPCBlobStream|
//
namespace mozilla {
namespace dom {
class IPCBlobStream final
{
public:
    enum Type {
        T__None,
        TPIPCBlobInputStreamParent = 1,
        TPIPCBlobInputStreamChild,
        TIPCStream,
        T__Last = TIPCStream
    };

private:
    typedef mozilla::dom::PIPCBlobInputStreamParent PIPCBlobInputStreamParent;
    typedef mozilla::dom::PIPCBlobInputStreamChild PIPCBlobInputStreamChild;
    typedef mozilla::ipc::IPCStream IPCStream;
    typedef PIPCBlobInputStreamParent* PIPCBlobInputStreamParent__tdef;
    typedef PIPCBlobInputStreamChild* PIPCBlobInputStreamChild__tdef;
    typedef IPCStream IPCStream__tdef;

    union Value {
        mozilla::AlignedStorage2<PIPCBlobInputStreamParent*> VPIPCBlobInputStreamParent;
        mozilla::AlignedStorage2<PIPCBlobInputStreamChild*> VPIPCBlobInputStreamChild;
        mozilla::AlignedStorage2<IPCStream> VIPCStream;
    };

    PIPCBlobInputStreamParent**
    ptr_PIPCBlobInputStreamParent()
    {
        return ((mValue).VPIPCBlobInputStreamParent).addr();
    }
    PIPCBlobInputStreamParent* const*
    constptr_PIPCBlobInputStreamParent() const
    {
        return ((mValue).VPIPCBlobInputStreamParent).addr();
    }
    PIPCBlobInputStreamChild**
    ptr_PIPCBlobInputStreamChild()
    {
        return ((mValue).VPIPCBlobInputStreamChild).addr();
    }
    PIPCBlobInputStreamChild* const*
    constptr_PIPCBlobInputStreamChild() const
    {
        return ((mValue).VPIPCBlobInputStreamChild).addr();
    }
    IPCStream*
    ptr_IPCStream()
    {
        return ((mValue).VIPCStream).addr();
    }
    const IPCStream*
    constptr_IPCStream() const
    {
        return ((mValue).VIPCStream).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT IPCBlobStream() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT IPCBlobStream(PIPCBlobInputStreamParent* aOther);

    MOZ_IMPLICIT IPCBlobStream(PIPCBlobInputStreamChild* aOther);

    MOZ_IMPLICIT IPCBlobStream(const IPCStream& aOther);

    MOZ_IMPLICIT IPCBlobStream(IPCStream&& aOther);

    MOZ_IMPLICIT IPCBlobStream(const IPCBlobStream& aOther);

    MOZ_IMPLICIT IPCBlobStream(IPCBlobStream&& aOther);

    ~IPCBlobStream();

    Type
    type() const
    {
        return mType;
    }

    IPCBlobStream&
    operator=(PIPCBlobInputStreamParent* aRhs);

    IPCBlobStream&
    operator=(PIPCBlobInputStreamChild* aRhs);

    IPCBlobStream&
    operator=(const IPCStream& aRhs);

    IPCBlobStream&
    operator=(IPCStream&& aRhs);

    IPCBlobStream&
    operator=(const IPCBlobStream& aRhs);

    IPCBlobStream&
    operator=(IPCBlobStream&& aRhs);

    bool
    operator==(PIPCBlobInputStreamParent* aRhs) const;

    bool
    operator==(PIPCBlobInputStreamChild* aRhs) const;

    bool
    operator==(const IPCStream& aRhs) const;

    bool
    operator==(const IPCBlobStream& aRhs) const;

    PIPCBlobInputStreamParent*&
    get_PIPCBlobInputStreamParent()
    {
        AssertSanity(TPIPCBlobInputStreamParent);
        return (*(ptr_PIPCBlobInputStreamParent()));
    }
    PIPCBlobInputStreamParent*
    get_PIPCBlobInputStreamParent() const
    {
        AssertSanity(TPIPCBlobInputStreamParent);
        return (*(constptr_PIPCBlobInputStreamParent()));
    }
    void
    get(PIPCBlobInputStreamParent** aOutValue) const;
    operator PIPCBlobInputStreamParent*&()
    {
        return get_PIPCBlobInputStreamParent();
    }
    operator PIPCBlobInputStreamParent*() const
    {
        return get_PIPCBlobInputStreamParent();
    }

    PIPCBlobInputStreamChild*&
    get_PIPCBlobInputStreamChild()
    {
        AssertSanity(TPIPCBlobInputStreamChild);
        return (*(ptr_PIPCBlobInputStreamChild()));
    }
    PIPCBlobInputStreamChild*
    get_PIPCBlobInputStreamChild() const
    {
        AssertSanity(TPIPCBlobInputStreamChild);
        return (*(constptr_PIPCBlobInputStreamChild()));
    }
    void
    get(PIPCBlobInputStreamChild** aOutValue) const;
    operator PIPCBlobInputStreamChild*&()
    {
        return get_PIPCBlobInputStreamChild();
    }
    operator PIPCBlobInputStreamChild*() const
    {
        return get_PIPCBlobInputStreamChild();
    }

    IPCStream&
    get_IPCStream()
    {
        AssertSanity(TIPCStream);
        return (*(ptr_IPCStream()));
    }
    const IPCStream&
    get_IPCStream() const
    {
        AssertSanity(TIPCStream);
        return (*(constptr_IPCStream()));
    }
    void
    get(IPCStream* aOutValue) const;
    operator IPCStream&()
    {
        return get_IPCStream();
    }
    operator const IPCStream&() const
    {
        return get_IPCStream();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCBlobStream>
{
    typedef mozilla::dom::IPCBlobStream paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCBlob|
//
namespace mozilla {
namespace dom {
class IPCBlob final
{
private:
    typedef mozilla::dom::IPCBlobStream IPCBlobStream;
    typedef mozilla::dom::IPCFile IPCFile;

public:
    MOZ_IMPLICIT IPCBlob() :
        type_(),
        blobImplType_(),
        inputStream_(),
        file_(),
        size_(),
        fileId_()
    {
    }

    MOZ_IMPLICIT IPCBlob(
            const nsString& _type,
            const uint64_t& _size,
            const nsString& _blobImplType,
            const IPCBlobStream& _inputStream,
            const mozilla::Maybe<IPCFile>& _file,
            const int64_t& _fileId) :
        type_(_type),
        blobImplType_(_blobImplType),
        inputStream_(_inputStream),
        file_(_file),
        size_(_size),
        fileId_(_fileId)
    {
    }

    bool
    operator==(const IPCBlob& _o) const;

    bool
    operator!=(const IPCBlob& _o) const;

    nsString&
    type()
    {
        return type_;
    }
    const nsString&
    type() const
    {
        return type_;
    }

    uint64_t&
    size()
    {
        return size_;
    }
    const uint64_t&
    size() const
    {
        return size_;
    }

    nsString&
    blobImplType()
    {
        return blobImplType_;
    }
    const nsString&
    blobImplType() const
    {
        return blobImplType_;
    }

    IPCBlobStream&
    inputStream()
    {
        return inputStream_;
    }
    const IPCBlobStream&
    inputStream() const
    {
        return inputStream_;
    }

    mozilla::Maybe<IPCFile>&
    file()
    {
        return file_;
    }
    const mozilla::Maybe<IPCFile>&
    file() const
    {
        return file_;
    }

    int64_t&
    fileId()
    {
        return fileId_;
    }
    const int64_t&
    fileId() const
    {
        return fileId_;
    }

private:
    void
    StaticAssertions() const;
    nsString type_;
    nsString blobImplType_;
    IPCBlobStream inputStream_;
    mozilla::Maybe<IPCFile> file_;
    uint64_t size_;
    int64_t fileId_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCBlob>
{
    typedef mozilla::dom::IPCBlob paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef IPCBlob_h
