//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PBackgroundFileRequest_h
#define PBackgroundFileRequest_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileRequestMetadata|
//
namespace mozilla {
namespace dom {
class FileRequestMetadata final
{
private:

public:
    MOZ_IMPLICIT FileRequestMetadata() :
        size_(),
        lastModified_()
    {
    }

    MOZ_IMPLICIT FileRequestMetadata(
            const mozilla::Maybe<uint64_t>& _size,
            const mozilla::Maybe<int64_t>& _lastModified) :
        size_(_size),
        lastModified_(_lastModified)
    {
    }

    bool
    operator==(const FileRequestMetadata& _o) const;

    bool
    operator!=(const FileRequestMetadata& _o) const;

    mozilla::Maybe<uint64_t>&
    size()
    {
        return size_;
    }
    const mozilla::Maybe<uint64_t>&
    size() const
    {
        return size_;
    }

    mozilla::Maybe<int64_t>&
    lastModified()
    {
        return lastModified_;
    }
    const mozilla::Maybe<int64_t>&
    lastModified() const
    {
        return lastModified_;
    }

private:
    mozilla::Maybe<uint64_t> size_;
    mozilla::Maybe<int64_t> lastModified_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::FileRequestMetadata>
{
    typedef mozilla::dom::FileRequestMetadata paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileRequestGetMetadataResponse|
//
namespace mozilla {
namespace dom {
class FileRequestGetMetadataResponse final
{
private:
    typedef mozilla::dom::FileRequestMetadata FileRequestMetadata;

public:
    MOZ_IMPLICIT FileRequestGetMetadataResponse() :
        metadata_()
    {
    }

    MOZ_IMPLICIT FileRequestGetMetadataResponse(const FileRequestMetadata& _metadata) :
        metadata_(_metadata)
    {
    }

    bool
    operator==(const FileRequestGetMetadataResponse& _o) const;

    bool
    operator!=(const FileRequestGetMetadataResponse& _o) const;

    FileRequestMetadata&
    metadata()
    {
        return metadata_;
    }
    const FileRequestMetadata&
    metadata() const
    {
        return metadata_;
    }

private:
    FileRequestMetadata metadata_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::FileRequestGetMetadataResponse>
{
    typedef mozilla::dom::FileRequestGetMetadataResponse paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileRequestReadResponse|
//
namespace mozilla {
namespace dom {
class FileRequestReadResponse final
{
private:

public:
    MOZ_IMPLICIT FileRequestReadResponse() :
        data_()
    {
    }

    MOZ_IMPLICIT FileRequestReadResponse(const nsCString& _data) :
        data_(_data)
    {
    }

    bool
    operator==(const FileRequestReadResponse& _o) const;

    bool
    operator!=(const FileRequestReadResponse& _o) const;

    nsCString&
    data()
    {
        return data_;
    }
    const nsCString&
    data() const
    {
        return data_;
    }

private:
    nsCString data_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::FileRequestReadResponse>
{
    typedef mozilla::dom::FileRequestReadResponse paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileRequestWriteResponse|
//
namespace mozilla {
namespace dom {
class FileRequestWriteResponse final
{
private:

public:
    MOZ_IMPLICIT FileRequestWriteResponse()
    {
    }

    bool
    operator==(const FileRequestWriteResponse& _o) const;

    bool
    operator!=(const FileRequestWriteResponse& _o) const;

private:
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::FileRequestWriteResponse>
{
    typedef mozilla::dom::FileRequestWriteResponse paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileRequestTruncateResponse|
//
namespace mozilla {
namespace dom {
class FileRequestTruncateResponse final
{
private:

public:
    MOZ_IMPLICIT FileRequestTruncateResponse()
    {
    }

    bool
    operator==(const FileRequestTruncateResponse& _o) const;

    bool
    operator!=(const FileRequestTruncateResponse& _o) const;

private:
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::FileRequestTruncateResponse>
{
    typedef mozilla::dom::FileRequestTruncateResponse paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileRequestFlushResponse|
//
namespace mozilla {
namespace dom {
class FileRequestFlushResponse final
{
private:

public:
    MOZ_IMPLICIT FileRequestFlushResponse()
    {
    }

    bool
    operator==(const FileRequestFlushResponse& _o) const;

    bool
    operator!=(const FileRequestFlushResponse& _o) const;

private:
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::FileRequestFlushResponse>
{
    typedef mozilla::dom::FileRequestFlushResponse paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {
class PPendingIPCBlobParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PPendingIPCBlobChild;
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileRequestGetFileResponse|
//
namespace mozilla {
namespace dom {
class FileRequestGetFileResponse final
{
private:
    typedef mozilla::dom::PPendingIPCBlobParent PPendingIPCBlobParent;
    typedef mozilla::dom::PPendingIPCBlobChild PPendingIPCBlobChild;
    typedef mozilla::dom::FileRequestMetadata FileRequestMetadata;

public:
    MOZ_IMPLICIT FileRequestGetFileResponse() :
        fileParent_(),
        fileChild_(),
        metadata_()
    {
    }

    MOZ_IMPLICIT FileRequestGetFileResponse(
            PPendingIPCBlobParent* _fileParent,
            PPendingIPCBlobChild* _fileChild,
            const FileRequestMetadata& _metadata) :
        fileParent_(_fileParent),
        fileChild_(_fileChild),
        metadata_(_metadata)
    {
    }

    bool
    operator==(const FileRequestGetFileResponse& _o) const;

    bool
    operator!=(const FileRequestGetFileResponse& _o) const;

    PPendingIPCBlobParent*&
    fileParent()
    {
        return fileParent_;
    }
    PPendingIPCBlobParent*
    fileParent() const
    {
        return fileParent_;
    }

    PPendingIPCBlobChild*&
    fileChild()
    {
        return fileChild_;
    }
    PPendingIPCBlobChild*
    fileChild() const
    {
        return fileChild_;
    }

    FileRequestMetadata&
    metadata()
    {
        return metadata_;
    }
    const FileRequestMetadata&
    metadata() const
    {
        return metadata_;
    }

private:
    PPendingIPCBlobParent* fileParent_;
    PPendingIPCBlobChild* fileChild_;
    FileRequestMetadata metadata_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::FileRequestGetFileResponse>
{
    typedef mozilla::dom::FileRequestGetFileResponse paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FileRequestResponse|
//
namespace mozilla {
namespace dom {
class FileRequestResponse final
{
public:
    enum Type {
        T__None,
        Tnsresult = 1,
        TFileRequestGetMetadataResponse,
        TFileRequestReadResponse,
        TFileRequestWriteResponse,
        TFileRequestTruncateResponse,
        TFileRequestFlushResponse,
        TFileRequestGetFileResponse,
        T__Last = TFileRequestGetFileResponse
    };

private:
    typedef mozilla::dom::FileRequestGetMetadataResponse FileRequestGetMetadataResponse;
    typedef mozilla::dom::FileRequestReadResponse FileRequestReadResponse;
    typedef mozilla::dom::FileRequestWriteResponse FileRequestWriteResponse;
    typedef mozilla::dom::FileRequestTruncateResponse FileRequestTruncateResponse;
    typedef mozilla::dom::FileRequestFlushResponse FileRequestFlushResponse;
    typedef mozilla::dom::FileRequestGetFileResponse FileRequestGetFileResponse;
    typedef nsresult nsresult__tdef;
    typedef FileRequestGetMetadataResponse FileRequestGetMetadataResponse__tdef;
    typedef FileRequestReadResponse FileRequestReadResponse__tdef;
    typedef FileRequestWriteResponse FileRequestWriteResponse__tdef;
    typedef FileRequestTruncateResponse FileRequestTruncateResponse__tdef;
    typedef FileRequestFlushResponse FileRequestFlushResponse__tdef;
    typedef FileRequestGetFileResponse FileRequestGetFileResponse__tdef;

    union Value {
        mozilla::AlignedStorage2<nsresult> Vnsresult;
        mozilla::AlignedStorage2<FileRequestGetMetadataResponse> VFileRequestGetMetadataResponse;
        mozilla::AlignedStorage2<FileRequestReadResponse> VFileRequestReadResponse;
        mozilla::AlignedStorage2<FileRequestWriteResponse> VFileRequestWriteResponse;
        mozilla::AlignedStorage2<FileRequestTruncateResponse> VFileRequestTruncateResponse;
        mozilla::AlignedStorage2<FileRequestFlushResponse> VFileRequestFlushResponse;
        mozilla::AlignedStorage2<FileRequestGetFileResponse> VFileRequestGetFileResponse;
    };

    nsresult*
    ptr_nsresult()
    {
        return ((mValue).Vnsresult).addr();
    }
    const nsresult*
    constptr_nsresult() const
    {
        return ((mValue).Vnsresult).addr();
    }
    FileRequestGetMetadataResponse*
    ptr_FileRequestGetMetadataResponse()
    {
        return ((mValue).VFileRequestGetMetadataResponse).addr();
    }
    const FileRequestGetMetadataResponse*
    constptr_FileRequestGetMetadataResponse() const
    {
        return ((mValue).VFileRequestGetMetadataResponse).addr();
    }
    FileRequestReadResponse*
    ptr_FileRequestReadResponse()
    {
        return ((mValue).VFileRequestReadResponse).addr();
    }
    const FileRequestReadResponse*
    constptr_FileRequestReadResponse() const
    {
        return ((mValue).VFileRequestReadResponse).addr();
    }
    FileRequestWriteResponse*
    ptr_FileRequestWriteResponse()
    {
        return ((mValue).VFileRequestWriteResponse).addr();
    }
    const FileRequestWriteResponse*
    constptr_FileRequestWriteResponse() const
    {
        return ((mValue).VFileRequestWriteResponse).addr();
    }
    FileRequestTruncateResponse*
    ptr_FileRequestTruncateResponse()
    {
        return ((mValue).VFileRequestTruncateResponse).addr();
    }
    const FileRequestTruncateResponse*
    constptr_FileRequestTruncateResponse() const
    {
        return ((mValue).VFileRequestTruncateResponse).addr();
    }
    FileRequestFlushResponse*
    ptr_FileRequestFlushResponse()
    {
        return ((mValue).VFileRequestFlushResponse).addr();
    }
    const FileRequestFlushResponse*
    constptr_FileRequestFlushResponse() const
    {
        return ((mValue).VFileRequestFlushResponse).addr();
    }
    FileRequestGetFileResponse*
    ptr_FileRequestGetFileResponse()
    {
        return ((mValue).VFileRequestGetFileResponse).addr();
    }
    const FileRequestGetFileResponse*
    constptr_FileRequestGetFileResponse() const
    {
        return ((mValue).VFileRequestGetFileResponse).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FileRequestResponse() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FileRequestResponse(const nsresult& aOther);

    MOZ_IMPLICIT FileRequestResponse(nsresult&& aOther);

    MOZ_IMPLICIT FileRequestResponse(const FileRequestGetMetadataResponse& aOther);

    MOZ_IMPLICIT FileRequestResponse(FileRequestGetMetadataResponse&& aOther);

    MOZ_IMPLICIT FileRequestResponse(const FileRequestReadResponse& aOther);

    MOZ_IMPLICIT FileRequestResponse(FileRequestReadResponse&& aOther);

    MOZ_IMPLICIT FileRequestResponse(const FileRequestWriteResponse& aOther);

    MOZ_IMPLICIT FileRequestResponse(FileRequestWriteResponse&& aOther);

    MOZ_IMPLICIT FileRequestResponse(const FileRequestTruncateResponse& aOther);

    MOZ_IMPLICIT FileRequestResponse(FileRequestTruncateResponse&& aOther);

    MOZ_IMPLICIT FileRequestResponse(const FileRequestFlushResponse& aOther);

    MOZ_IMPLICIT FileRequestResponse(FileRequestFlushResponse&& aOther);

    MOZ_IMPLICIT FileRequestResponse(const FileRequestGetFileResponse& aOther);

    MOZ_IMPLICIT FileRequestResponse(FileRequestGetFileResponse&& aOther);

    MOZ_IMPLICIT FileRequestResponse(const FileRequestResponse& aOther);

    MOZ_IMPLICIT FileRequestResponse(FileRequestResponse&& aOther);

    ~FileRequestResponse();

    Type
    type() const
    {
        return mType;
    }

    FileRequestResponse&
    operator=(const nsresult& aRhs);

    FileRequestResponse&
    operator=(nsresult&& aRhs);

    FileRequestResponse&
    operator=(const FileRequestGetMetadataResponse& aRhs);

    FileRequestResponse&
    operator=(FileRequestGetMetadataResponse&& aRhs);

    FileRequestResponse&
    operator=(const FileRequestReadResponse& aRhs);

    FileRequestResponse&
    operator=(FileRequestReadResponse&& aRhs);

    FileRequestResponse&
    operator=(const FileRequestWriteResponse& aRhs);

    FileRequestResponse&
    operator=(FileRequestWriteResponse&& aRhs);

    FileRequestResponse&
    operator=(const FileRequestTruncateResponse& aRhs);

    FileRequestResponse&
    operator=(FileRequestTruncateResponse&& aRhs);

    FileRequestResponse&
    operator=(const FileRequestFlushResponse& aRhs);

    FileRequestResponse&
    operator=(FileRequestFlushResponse&& aRhs);

    FileRequestResponse&
    operator=(const FileRequestGetFileResponse& aRhs);

    FileRequestResponse&
    operator=(FileRequestGetFileResponse&& aRhs);

    FileRequestResponse&
    operator=(const FileRequestResponse& aRhs);

    FileRequestResponse&
    operator=(FileRequestResponse&& aRhs);

    bool
    operator==(const nsresult& aRhs) const;

    bool
    operator==(const FileRequestGetMetadataResponse& aRhs) const;

    bool
    operator==(const FileRequestReadResponse& aRhs) const;

    bool
    operator==(const FileRequestWriteResponse& aRhs) const;

    bool
    operator==(const FileRequestTruncateResponse& aRhs) const;

    bool
    operator==(const FileRequestFlushResponse& aRhs) const;

    bool
    operator==(const FileRequestGetFileResponse& aRhs) const;

    bool
    operator==(const FileRequestResponse& aRhs) const;

    nsresult&
    get_nsresult()
    {
        AssertSanity(Tnsresult);
        return (*(ptr_nsresult()));
    }
    const nsresult&
    get_nsresult() const
    {
        AssertSanity(Tnsresult);
        return (*(constptr_nsresult()));
    }
    void
    get(nsresult* aOutValue) const;
    operator nsresult&()
    {
        return get_nsresult();
    }
    operator const nsresult&() const
    {
        return get_nsresult();
    }

    FileRequestGetMetadataResponse&
    get_FileRequestGetMetadataResponse()
    {
        AssertSanity(TFileRequestGetMetadataResponse);
        return (*(ptr_FileRequestGetMetadataResponse()));
    }
    const FileRequestGetMetadataResponse&
    get_FileRequestGetMetadataResponse() const
    {
        AssertSanity(TFileRequestGetMetadataResponse);
        return (*(constptr_FileRequestGetMetadataResponse()));
    }
    void
    get(FileRequestGetMetadataResponse* aOutValue) const;
    operator FileRequestGetMetadataResponse&()
    {
        return get_FileRequestGetMetadataResponse();
    }
    operator const FileRequestGetMetadataResponse&() const
    {
        return get_FileRequestGetMetadataResponse();
    }

    FileRequestReadResponse&
    get_FileRequestReadResponse()
    {
        AssertSanity(TFileRequestReadResponse);
        return (*(ptr_FileRequestReadResponse()));
    }
    const FileRequestReadResponse&
    get_FileRequestReadResponse() const
    {
        AssertSanity(TFileRequestReadResponse);
        return (*(constptr_FileRequestReadResponse()));
    }
    void
    get(FileRequestReadResponse* aOutValue) const;
    operator FileRequestReadResponse&()
    {
        return get_FileRequestReadResponse();
    }
    operator const FileRequestReadResponse&() const
    {
        return get_FileRequestReadResponse();
    }

    FileRequestWriteResponse&
    get_FileRequestWriteResponse()
    {
        AssertSanity(TFileRequestWriteResponse);
        return (*(ptr_FileRequestWriteResponse()));
    }
    const FileRequestWriteResponse&
    get_FileRequestWriteResponse() const
    {
        AssertSanity(TFileRequestWriteResponse);
        return (*(constptr_FileRequestWriteResponse()));
    }
    void
    get(FileRequestWriteResponse* aOutValue) const;
    operator FileRequestWriteResponse&()
    {
        return get_FileRequestWriteResponse();
    }
    operator const FileRequestWriteResponse&() const
    {
        return get_FileRequestWriteResponse();
    }

    FileRequestTruncateResponse&
    get_FileRequestTruncateResponse()
    {
        AssertSanity(TFileRequestTruncateResponse);
        return (*(ptr_FileRequestTruncateResponse()));
    }
    const FileRequestTruncateResponse&
    get_FileRequestTruncateResponse() const
    {
        AssertSanity(TFileRequestTruncateResponse);
        return (*(constptr_FileRequestTruncateResponse()));
    }
    void
    get(FileRequestTruncateResponse* aOutValue) const;
    operator FileRequestTruncateResponse&()
    {
        return get_FileRequestTruncateResponse();
    }
    operator const FileRequestTruncateResponse&() const
    {
        return get_FileRequestTruncateResponse();
    }

    FileRequestFlushResponse&
    get_FileRequestFlushResponse()
    {
        AssertSanity(TFileRequestFlushResponse);
        return (*(ptr_FileRequestFlushResponse()));
    }
    const FileRequestFlushResponse&
    get_FileRequestFlushResponse() const
    {
        AssertSanity(TFileRequestFlushResponse);
        return (*(constptr_FileRequestFlushResponse()));
    }
    void
    get(FileRequestFlushResponse* aOutValue) const;
    operator FileRequestFlushResponse&()
    {
        return get_FileRequestFlushResponse();
    }
    operator const FileRequestFlushResponse&() const
    {
        return get_FileRequestFlushResponse();
    }

    FileRequestGetFileResponse&
    get_FileRequestGetFileResponse()
    {
        AssertSanity(TFileRequestGetFileResponse);
        return (*(ptr_FileRequestGetFileResponse()));
    }
    const FileRequestGetFileResponse&
    get_FileRequestGetFileResponse() const
    {
        AssertSanity(TFileRequestGetFileResponse);
        return (*(constptr_FileRequestGetFileResponse()));
    }
    void
    get(FileRequestGetFileResponse* aOutValue) const;
    operator FileRequestGetFileResponse&()
    {
        return get_FileRequestGetFileResponse();
    }
    operator const FileRequestGetFileResponse&() const
    {
        return get_FileRequestGetFileResponse();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::FileRequestResponse>
{
    typedef mozilla::dom::FileRequestResponse paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBackgroundFileRequestParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBackgroundFileRequestChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PBackgroundFileRequestChild and PBackgroundFileRequestParent
//
namespace mozilla {
namespace dom {
namespace PBackgroundFileRequest {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PBackgroundFileRequestParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PBackgroundFileRequestChild>* aChild);

enum MessageType {
    PBackgroundFileRequestStart = PBackgroundFileRequestMsgStart << 16,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_Progress__ID,
    PBackgroundFileRequestEnd
};

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);

IPC::Message*
Msg_Progress(int32_t routingId);



} // namespace PBackgroundFileRequest
} // namespace dom
} // namespace mozilla

#endif // ifndef PBackgroundFileRequest_h
