//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PTabContext_h
#define PTabContext_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"

// Headers for typedefs
#include "mozilla/ipc/BackgroundUtils.h"
#include "nsPIDOMWindow.h"
#include "mozilla/dom/PBrowserOrId.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct PopupIPCTabContext|
//
namespace mozilla {
namespace dom {
class PopupIPCTabContext final
{
private:
    typedef mozilla::dom::PBrowserOrId PBrowserOrId;

public:
    MOZ_IMPLICIT PopupIPCTabContext() :
        opener_(),
        isMozBrowserElement_(),
        chromeOuterWindowID_()
    {
    }

    MOZ_IMPLICIT PopupIPCTabContext(
            const PBrowserOrId& _opener,
            const bool& _isMozBrowserElement,
            const uint64_t& _chromeOuterWindowID) :
        opener_(_opener),
        isMozBrowserElement_(_isMozBrowserElement),
        chromeOuterWindowID_(_chromeOuterWindowID)
    {
    }

    bool
    operator==(const PopupIPCTabContext& _o) const;

    bool
    operator!=(const PopupIPCTabContext& _o) const;

    PBrowserOrId&
    opener()
    {
        return opener_;
    }
    const PBrowserOrId&
    opener() const
    {
        return opener_;
    }

    bool&
    isMozBrowserElement()
    {
        return isMozBrowserElement_;
    }
    const bool&
    isMozBrowserElement() const
    {
        return isMozBrowserElement_;
    }

    uint64_t&
    chromeOuterWindowID()
    {
        return chromeOuterWindowID_;
    }
    const uint64_t&
    chromeOuterWindowID() const
    {
        return chromeOuterWindowID_;
    }

private:
    PBrowserOrId opener_;
    bool isMozBrowserElement_;
    uint64_t chromeOuterWindowID_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::PopupIPCTabContext>
{
    typedef mozilla::dom::PopupIPCTabContext paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FrameIPCTabContext|
//
namespace mozilla {
namespace dom {
class FrameIPCTabContext final
{
private:
    typedef mozilla::OriginAttributes OriginAttributes;

public:
    MOZ_IMPLICIT FrameIPCTabContext() :
        originAttributes_(),
        isMozBrowserElement_(),
        presentationURL_(),
        showAccelerators_(),
        showFocusRings_(),
        chromeOuterWindowID_()
    {
    }

    MOZ_IMPLICIT FrameIPCTabContext(
            const OriginAttributes& _originAttributes,
            const bool& _isMozBrowserElement,
            const uint64_t& _chromeOuterWindowID,
            const nsString& _presentationURL,
            const UIStateChangeType& _showAccelerators,
            const UIStateChangeType& _showFocusRings) :
        originAttributes_(_originAttributes),
        isMozBrowserElement_(_isMozBrowserElement),
        presentationURL_(_presentationURL),
        showAccelerators_(_showAccelerators),
        showFocusRings_(_showFocusRings),
        chromeOuterWindowID_(_chromeOuterWindowID)
    {
    }

    bool
    operator==(const FrameIPCTabContext& _o) const;

    bool
    operator!=(const FrameIPCTabContext& _o) const;

    OriginAttributes&
    originAttributes()
    {
        return originAttributes_;
    }
    const OriginAttributes&
    originAttributes() const
    {
        return originAttributes_;
    }

    bool&
    isMozBrowserElement()
    {
        return isMozBrowserElement_;
    }
    const bool&
    isMozBrowserElement() const
    {
        return isMozBrowserElement_;
    }

    uint64_t&
    chromeOuterWindowID()
    {
        return chromeOuterWindowID_;
    }
    const uint64_t&
    chromeOuterWindowID() const
    {
        return chromeOuterWindowID_;
    }

    nsString&
    presentationURL()
    {
        return presentationURL_;
    }
    const nsString&
    presentationURL() const
    {
        return presentationURL_;
    }

    UIStateChangeType&
    showAccelerators()
    {
        return showAccelerators_;
    }
    const UIStateChangeType&
    showAccelerators() const
    {
        return showAccelerators_;
    }

    UIStateChangeType&
    showFocusRings()
    {
        return showFocusRings_;
    }
    const UIStateChangeType&
    showFocusRings() const
    {
        return showFocusRings_;
    }

private:
    OriginAttributes originAttributes_;
    bool isMozBrowserElement_;
    nsString presentationURL_;
    UIStateChangeType showAccelerators_;
    UIStateChangeType showFocusRings_;
    uint64_t chromeOuterWindowID_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::FrameIPCTabContext>
{
    typedef mozilla::dom::FrameIPCTabContext paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct JSPluginFrameIPCTabContext|
//
namespace mozilla {
namespace dom {
class JSPluginFrameIPCTabContext final
{
private:

public:
    MOZ_IMPLICIT JSPluginFrameIPCTabContext() :
        jsPluginId_()
    {
    }

    MOZ_IMPLICIT JSPluginFrameIPCTabContext(const uint32_t& _jsPluginId) :
        jsPluginId_(_jsPluginId)
    {
    }

    bool
    operator==(const JSPluginFrameIPCTabContext& _o) const;

    bool
    operator!=(const JSPluginFrameIPCTabContext& _o) const;

    uint32_t&
    jsPluginId()
    {
        return jsPluginId_;
    }
    const uint32_t&
    jsPluginId() const
    {
        return jsPluginId_;
    }

private:
    uint32_t jsPluginId_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::JSPluginFrameIPCTabContext>
{
    typedef mozilla::dom::JSPluginFrameIPCTabContext paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct UnsafeIPCTabContext|
//
namespace mozilla {
namespace dom {
class UnsafeIPCTabContext final
{
private:

public:
    MOZ_IMPLICIT UnsafeIPCTabContext()
    {
    }

    bool
    operator==(const UnsafeIPCTabContext& _o) const;

    bool
    operator!=(const UnsafeIPCTabContext& _o) const;

private:
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::UnsafeIPCTabContext>
{
    typedef mozilla::dom::UnsafeIPCTabContext paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union IPCTabContext|
//
namespace mozilla {
namespace dom {
class IPCTabContext final
{
public:
    enum Type {
        T__None,
        TPopupIPCTabContext = 1,
        TFrameIPCTabContext,
        TJSPluginFrameIPCTabContext,
        TUnsafeIPCTabContext,
        T__Last = TUnsafeIPCTabContext
    };

private:
    typedef mozilla::dom::PopupIPCTabContext PopupIPCTabContext;
    typedef mozilla::dom::FrameIPCTabContext FrameIPCTabContext;
    typedef mozilla::dom::JSPluginFrameIPCTabContext JSPluginFrameIPCTabContext;
    typedef mozilla::dom::UnsafeIPCTabContext UnsafeIPCTabContext;
    typedef PopupIPCTabContext PopupIPCTabContext__tdef;
    typedef FrameIPCTabContext FrameIPCTabContext__tdef;
    typedef JSPluginFrameIPCTabContext JSPluginFrameIPCTabContext__tdef;
    typedef UnsafeIPCTabContext UnsafeIPCTabContext__tdef;

    union Value {
        mozilla::AlignedStorage2<PopupIPCTabContext> VPopupIPCTabContext;
        mozilla::AlignedStorage2<FrameIPCTabContext> VFrameIPCTabContext;
        mozilla::AlignedStorage2<JSPluginFrameIPCTabContext> VJSPluginFrameIPCTabContext;
        mozilla::AlignedStorage2<UnsafeIPCTabContext> VUnsafeIPCTabContext;
    };

    PopupIPCTabContext*
    ptr_PopupIPCTabContext()
    {
        return ((mValue).VPopupIPCTabContext).addr();
    }
    const PopupIPCTabContext*
    constptr_PopupIPCTabContext() const
    {
        return ((mValue).VPopupIPCTabContext).addr();
    }
    FrameIPCTabContext*
    ptr_FrameIPCTabContext()
    {
        return ((mValue).VFrameIPCTabContext).addr();
    }
    const FrameIPCTabContext*
    constptr_FrameIPCTabContext() const
    {
        return ((mValue).VFrameIPCTabContext).addr();
    }
    JSPluginFrameIPCTabContext*
    ptr_JSPluginFrameIPCTabContext()
    {
        return ((mValue).VJSPluginFrameIPCTabContext).addr();
    }
    const JSPluginFrameIPCTabContext*
    constptr_JSPluginFrameIPCTabContext() const
    {
        return ((mValue).VJSPluginFrameIPCTabContext).addr();
    }
    UnsafeIPCTabContext*
    ptr_UnsafeIPCTabContext()
    {
        return ((mValue).VUnsafeIPCTabContext).addr();
    }
    const UnsafeIPCTabContext*
    constptr_UnsafeIPCTabContext() const
    {
        return ((mValue).VUnsafeIPCTabContext).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT IPCTabContext() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT IPCTabContext(const PopupIPCTabContext& aOther);

    MOZ_IMPLICIT IPCTabContext(PopupIPCTabContext&& aOther);

    MOZ_IMPLICIT IPCTabContext(const FrameIPCTabContext& aOther);

    MOZ_IMPLICIT IPCTabContext(FrameIPCTabContext&& aOther);

    MOZ_IMPLICIT IPCTabContext(const JSPluginFrameIPCTabContext& aOther);

    MOZ_IMPLICIT IPCTabContext(JSPluginFrameIPCTabContext&& aOther);

    MOZ_IMPLICIT IPCTabContext(const UnsafeIPCTabContext& aOther);

    MOZ_IMPLICIT IPCTabContext(UnsafeIPCTabContext&& aOther);

    MOZ_IMPLICIT IPCTabContext(const IPCTabContext& aOther);

    MOZ_IMPLICIT IPCTabContext(IPCTabContext&& aOther);

    ~IPCTabContext();

    Type
    type() const
    {
        return mType;
    }

    IPCTabContext&
    operator=(const PopupIPCTabContext& aRhs);

    IPCTabContext&
    operator=(PopupIPCTabContext&& aRhs);

    IPCTabContext&
    operator=(const FrameIPCTabContext& aRhs);

    IPCTabContext&
    operator=(FrameIPCTabContext&& aRhs);

    IPCTabContext&
    operator=(const JSPluginFrameIPCTabContext& aRhs);

    IPCTabContext&
    operator=(JSPluginFrameIPCTabContext&& aRhs);

    IPCTabContext&
    operator=(const UnsafeIPCTabContext& aRhs);

    IPCTabContext&
    operator=(UnsafeIPCTabContext&& aRhs);

    IPCTabContext&
    operator=(const IPCTabContext& aRhs);

    IPCTabContext&
    operator=(IPCTabContext&& aRhs);

    bool
    operator==(const PopupIPCTabContext& aRhs) const;

    bool
    operator==(const FrameIPCTabContext& aRhs) const;

    bool
    operator==(const JSPluginFrameIPCTabContext& aRhs) const;

    bool
    operator==(const UnsafeIPCTabContext& aRhs) const;

    bool
    operator==(const IPCTabContext& aRhs) const;

    PopupIPCTabContext&
    get_PopupIPCTabContext()
    {
        AssertSanity(TPopupIPCTabContext);
        return (*(ptr_PopupIPCTabContext()));
    }
    const PopupIPCTabContext&
    get_PopupIPCTabContext() const
    {
        AssertSanity(TPopupIPCTabContext);
        return (*(constptr_PopupIPCTabContext()));
    }
    void
    get(PopupIPCTabContext* aOutValue) const;
    operator PopupIPCTabContext&()
    {
        return get_PopupIPCTabContext();
    }
    operator const PopupIPCTabContext&() const
    {
        return get_PopupIPCTabContext();
    }

    FrameIPCTabContext&
    get_FrameIPCTabContext()
    {
        AssertSanity(TFrameIPCTabContext);
        return (*(ptr_FrameIPCTabContext()));
    }
    const FrameIPCTabContext&
    get_FrameIPCTabContext() const
    {
        AssertSanity(TFrameIPCTabContext);
        return (*(constptr_FrameIPCTabContext()));
    }
    void
    get(FrameIPCTabContext* aOutValue) const;
    operator FrameIPCTabContext&()
    {
        return get_FrameIPCTabContext();
    }
    operator const FrameIPCTabContext&() const
    {
        return get_FrameIPCTabContext();
    }

    JSPluginFrameIPCTabContext&
    get_JSPluginFrameIPCTabContext()
    {
        AssertSanity(TJSPluginFrameIPCTabContext);
        return (*(ptr_JSPluginFrameIPCTabContext()));
    }
    const JSPluginFrameIPCTabContext&
    get_JSPluginFrameIPCTabContext() const
    {
        AssertSanity(TJSPluginFrameIPCTabContext);
        return (*(constptr_JSPluginFrameIPCTabContext()));
    }
    void
    get(JSPluginFrameIPCTabContext* aOutValue) const;
    operator JSPluginFrameIPCTabContext&()
    {
        return get_JSPluginFrameIPCTabContext();
    }
    operator const JSPluginFrameIPCTabContext&() const
    {
        return get_JSPluginFrameIPCTabContext();
    }

    UnsafeIPCTabContext&
    get_UnsafeIPCTabContext()
    {
        AssertSanity(TUnsafeIPCTabContext);
        return (*(ptr_UnsafeIPCTabContext()));
    }
    const UnsafeIPCTabContext&
    get_UnsafeIPCTabContext() const
    {
        AssertSanity(TUnsafeIPCTabContext);
        return (*(constptr_UnsafeIPCTabContext()));
    }
    void
    get(UnsafeIPCTabContext* aOutValue) const;
    operator UnsafeIPCTabContext&()
    {
        return get_UnsafeIPCTabContext();
    }
    operator const UnsafeIPCTabContext&() const
    {
        return get_UnsafeIPCTabContext();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCTabContext>
{
    typedef mozilla::dom::IPCTabContext paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef PTabContext_h
