//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef RemoteWorkerTypes_h
#define RemoteWorkerTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"
#include "mozilla/dom/ClientIPCUtils.h"
#include "mozilla/dom/ClientIPCTypes.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"
#include "mozilla/ipc/URIParams.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RemoteWorkerData|
//
namespace mozilla {
namespace dom {
class RemoteWorkerData final
{
private:
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef mozilla::ipc::ContentSecurityPolicy ContentSecurityPolicy;
    typedef mozilla::dom::IPCClientInfo IPCClientInfo;
    typedef nsContentUtils::StorageAccess StorageAccess;

public:
    MOZ_IMPLICIT RemoteWorkerData() :
        originalScriptURL_(),
        baseScriptURL_(),
        resolvedScriptURL_(),
        name_(),
        loadingPrincipalInfo_(),
        loadingPrincipalCsp_(),
        loadingPrincipalPreloadCsp_(),
        principalInfo_(),
        principalCsp_(),
        principalPreloadCsp_(),
        storagePrincipalInfo_(),
        storagePrincipalCsp_(),
        storagePrincipalPreloadCsp_(),
        domain_(),
        isSecureContext_(),
        clientInfo_(),
        storageAccess_(),
        isSharedWorker_()
    {
    }

    MOZ_IMPLICIT RemoteWorkerData(
            const nsString& _originalScriptURL,
            const URIParams& _baseScriptURL,
            const URIParams& _resolvedScriptURL,
            const nsString& _name,
            const PrincipalInfo& _loadingPrincipalInfo,
            const nsTArray<ContentSecurityPolicy>& _loadingPrincipalCsp,
            const nsTArray<ContentSecurityPolicy>& _loadingPrincipalPreloadCsp,
            const PrincipalInfo& _principalInfo,
            const nsTArray<ContentSecurityPolicy>& _principalCsp,
            const nsTArray<ContentSecurityPolicy>& _principalPreloadCsp,
            const PrincipalInfo& _storagePrincipalInfo,
            const nsTArray<ContentSecurityPolicy>& _storagePrincipalCsp,
            const nsTArray<ContentSecurityPolicy>& _storagePrincipalPreloadCsp,
            const nsCString& _domain,
            const bool& _isSecureContext,
            const mozilla::Maybe<IPCClientInfo>& _clientInfo,
            const StorageAccess& _storageAccess,
            const bool& _isSharedWorker) :
        originalScriptURL_(_originalScriptURL),
        baseScriptURL_(_baseScriptURL),
        resolvedScriptURL_(_resolvedScriptURL),
        name_(_name),
        loadingPrincipalInfo_(_loadingPrincipalInfo),
        loadingPrincipalCsp_(_loadingPrincipalCsp),
        loadingPrincipalPreloadCsp_(_loadingPrincipalPreloadCsp),
        principalInfo_(_principalInfo),
        principalCsp_(_principalCsp),
        principalPreloadCsp_(_principalPreloadCsp),
        storagePrincipalInfo_(_storagePrincipalInfo),
        storagePrincipalCsp_(_storagePrincipalCsp),
        storagePrincipalPreloadCsp_(_storagePrincipalPreloadCsp),
        domain_(_domain),
        isSecureContext_(_isSecureContext),
        clientInfo_(_clientInfo),
        storageAccess_(_storageAccess),
        isSharedWorker_(_isSharedWorker)
    {
    }

    bool
    operator==(const RemoteWorkerData& _o) const;

    bool
    operator!=(const RemoteWorkerData& _o) const;

    nsString&
    originalScriptURL()
    {
        return originalScriptURL_;
    }
    const nsString&
    originalScriptURL() const
    {
        return originalScriptURL_;
    }

    URIParams&
    baseScriptURL()
    {
        return baseScriptURL_;
    }
    const URIParams&
    baseScriptURL() const
    {
        return baseScriptURL_;
    }

    URIParams&
    resolvedScriptURL()
    {
        return resolvedScriptURL_;
    }
    const URIParams&
    resolvedScriptURL() const
    {
        return resolvedScriptURL_;
    }

    nsString&
    name()
    {
        return name_;
    }
    const nsString&
    name() const
    {
        return name_;
    }

    PrincipalInfo&
    loadingPrincipalInfo()
    {
        return loadingPrincipalInfo_;
    }
    const PrincipalInfo&
    loadingPrincipalInfo() const
    {
        return loadingPrincipalInfo_;
    }

    nsTArray<ContentSecurityPolicy>&
    loadingPrincipalCsp()
    {
        return loadingPrincipalCsp_;
    }
    const nsTArray<ContentSecurityPolicy>&
    loadingPrincipalCsp() const
    {
        return loadingPrincipalCsp_;
    }

    nsTArray<ContentSecurityPolicy>&
    loadingPrincipalPreloadCsp()
    {
        return loadingPrincipalPreloadCsp_;
    }
    const nsTArray<ContentSecurityPolicy>&
    loadingPrincipalPreloadCsp() const
    {
        return loadingPrincipalPreloadCsp_;
    }

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    nsTArray<ContentSecurityPolicy>&
    principalCsp()
    {
        return principalCsp_;
    }
    const nsTArray<ContentSecurityPolicy>&
    principalCsp() const
    {
        return principalCsp_;
    }

    nsTArray<ContentSecurityPolicy>&
    principalPreloadCsp()
    {
        return principalPreloadCsp_;
    }
    const nsTArray<ContentSecurityPolicy>&
    principalPreloadCsp() const
    {
        return principalPreloadCsp_;
    }

    PrincipalInfo&
    storagePrincipalInfo()
    {
        return storagePrincipalInfo_;
    }
    const PrincipalInfo&
    storagePrincipalInfo() const
    {
        return storagePrincipalInfo_;
    }

    nsTArray<ContentSecurityPolicy>&
    storagePrincipalCsp()
    {
        return storagePrincipalCsp_;
    }
    const nsTArray<ContentSecurityPolicy>&
    storagePrincipalCsp() const
    {
        return storagePrincipalCsp_;
    }

    nsTArray<ContentSecurityPolicy>&
    storagePrincipalPreloadCsp()
    {
        return storagePrincipalPreloadCsp_;
    }
    const nsTArray<ContentSecurityPolicy>&
    storagePrincipalPreloadCsp() const
    {
        return storagePrincipalPreloadCsp_;
    }

    nsCString&
    domain()
    {
        return domain_;
    }
    const nsCString&
    domain() const
    {
        return domain_;
    }

    bool&
    isSecureContext()
    {
        return isSecureContext_;
    }
    const bool&
    isSecureContext() const
    {
        return isSecureContext_;
    }

    mozilla::Maybe<IPCClientInfo>&
    clientInfo()
    {
        return clientInfo_;
    }
    const mozilla::Maybe<IPCClientInfo>&
    clientInfo() const
    {
        return clientInfo_;
    }

    StorageAccess&
    storageAccess()
    {
        return storageAccess_;
    }
    const StorageAccess&
    storageAccess() const
    {
        return storageAccess_;
    }

    bool&
    isSharedWorker()
    {
        return isSharedWorker_;
    }
    const bool&
    isSharedWorker() const
    {
        return isSharedWorker_;
    }

private:
    nsString originalScriptURL_;
    URIParams baseScriptURL_;
    URIParams resolvedScriptURL_;
    nsString name_;
    PrincipalInfo loadingPrincipalInfo_;
    nsTArray<ContentSecurityPolicy> loadingPrincipalCsp_;
    nsTArray<ContentSecurityPolicy> loadingPrincipalPreloadCsp_;
    PrincipalInfo principalInfo_;
    nsTArray<ContentSecurityPolicy> principalCsp_;
    nsTArray<ContentSecurityPolicy> principalPreloadCsp_;
    PrincipalInfo storagePrincipalInfo_;
    nsTArray<ContentSecurityPolicy> storagePrincipalCsp_;
    nsTArray<ContentSecurityPolicy> storagePrincipalPreloadCsp_;
    nsCString domain_;
    bool isSecureContext_;
    mozilla::Maybe<IPCClientInfo> clientInfo_;
    StorageAccess storageAccess_;
    bool isSharedWorker_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::RemoteWorkerData>
{
    typedef mozilla::dom::RemoteWorkerData paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ErrorDataNote|
//
namespace mozilla {
namespace dom {
class ErrorDataNote final
{
private:

public:
    MOZ_IMPLICIT ErrorDataNote() :
        message_(),
        filename_(),
        lineNumber_(),
        columnNumber_()
    {
    }

    MOZ_IMPLICIT ErrorDataNote(
            const uint32_t& _lineNumber,
            const uint32_t& _columnNumber,
            const nsString& _message,
            const nsString& _filename) :
        message_(_message),
        filename_(_filename),
        lineNumber_(_lineNumber),
        columnNumber_(_columnNumber)
    {
    }

    bool
    operator==(const ErrorDataNote& _o) const;

    bool
    operator!=(const ErrorDataNote& _o) const;

    uint32_t&
    lineNumber()
    {
        return lineNumber_;
    }
    const uint32_t&
    lineNumber() const
    {
        return lineNumber_;
    }

    uint32_t&
    columnNumber()
    {
        return columnNumber_;
    }
    const uint32_t&
    columnNumber() const
    {
        return columnNumber_;
    }

    nsString&
    message()
    {
        return message_;
    }
    const nsString&
    message() const
    {
        return message_;
    }

    nsString&
    filename()
    {
        return filename_;
    }
    const nsString&
    filename() const
    {
        return filename_;
    }

private:
    void
    StaticAssertions() const;
    nsString message_;
    nsString filename_;
    uint32_t lineNumber_;
    uint32_t columnNumber_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::ErrorDataNote>
{
    typedef mozilla::dom::ErrorDataNote paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ErrorData|
//
namespace mozilla {
namespace dom {
class ErrorData final
{
private:
    typedef mozilla::dom::ErrorDataNote ErrorDataNote;

public:
    MOZ_IMPLICIT ErrorData() :
        message_(),
        filename_(),
        line_(),
        notes_(),
        lineNumber_(),
        columnNumber_(),
        flags_()
    {
    }

    MOZ_IMPLICIT ErrorData(
            const uint32_t& _lineNumber,
            const uint32_t& _columnNumber,
            const uint32_t& _flags,
            const nsString& _message,
            const nsString& _filename,
            const nsString& _line,
            const nsTArray<ErrorDataNote>& _notes) :
        message_(_message),
        filename_(_filename),
        line_(_line),
        notes_(_notes),
        lineNumber_(_lineNumber),
        columnNumber_(_columnNumber),
        flags_(_flags)
    {
    }

    bool
    operator==(const ErrorData& _o) const;

    bool
    operator!=(const ErrorData& _o) const;

    uint32_t&
    lineNumber()
    {
        return lineNumber_;
    }
    const uint32_t&
    lineNumber() const
    {
        return lineNumber_;
    }

    uint32_t&
    columnNumber()
    {
        return columnNumber_;
    }
    const uint32_t&
    columnNumber() const
    {
        return columnNumber_;
    }

    uint32_t&
    flags()
    {
        return flags_;
    }
    const uint32_t&
    flags() const
    {
        return flags_;
    }

    nsString&
    message()
    {
        return message_;
    }
    const nsString&
    message() const
    {
        return message_;
    }

    nsString&
    filename()
    {
        return filename_;
    }
    const nsString&
    filename() const
    {
        return filename_;
    }

    nsString&
    line()
    {
        return line_;
    }
    const nsString&
    line() const
    {
        return line_;
    }

    nsTArray<ErrorDataNote>&
    notes()
    {
        return notes_;
    }
    const nsTArray<ErrorDataNote>&
    notes() const
    {
        return notes_;
    }

private:
    void
    StaticAssertions() const;
    nsString message_;
    nsString filename_;
    nsString line_;
    nsTArray<ErrorDataNote> notes_;
    uint32_t lineNumber_;
    uint32_t columnNumber_;
    uint32_t flags_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::ErrorData>
{
    typedef mozilla::dom::ErrorData paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union ErrorValue|
//
namespace mozilla {
namespace dom {
class ErrorValue final
{
public:
    enum Type {
        T__None,
        Tnsresult = 1,
        TErrorData,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::dom::ErrorData ErrorData;
    typedef mozilla::void_t void_t;
    typedef nsresult nsresult__tdef;
    typedef ErrorData ErrorData__tdef;
    typedef void_t void_t__tdef;

    union Value {
        mozilla::AlignedStorage2<nsresult> Vnsresult;
        mozilla::AlignedStorage2<ErrorData> VErrorData;
        mozilla::AlignedStorage2<void_t> Vvoid_t;
    };

    nsresult*
    ptr_nsresult()
    {
        return ((mValue).Vnsresult).addr();
    }
    const nsresult*
    constptr_nsresult() const
    {
        return ((mValue).Vnsresult).addr();
    }
    ErrorData*
    ptr_ErrorData()
    {
        return ((mValue).VErrorData).addr();
    }
    const ErrorData*
    constptr_ErrorData() const
    {
        return ((mValue).VErrorData).addr();
    }
    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT ErrorValue() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT ErrorValue(const nsresult& aOther);

    MOZ_IMPLICIT ErrorValue(nsresult&& aOther);

    MOZ_IMPLICIT ErrorValue(const ErrorData& aOther);

    MOZ_IMPLICIT ErrorValue(ErrorData&& aOther);

    MOZ_IMPLICIT ErrorValue(const void_t& aOther);

    MOZ_IMPLICIT ErrorValue(void_t&& aOther);

    MOZ_IMPLICIT ErrorValue(const ErrorValue& aOther);

    MOZ_IMPLICIT ErrorValue(ErrorValue&& aOther);

    ~ErrorValue();

    Type
    type() const
    {
        return mType;
    }

    ErrorValue&
    operator=(const nsresult& aRhs);

    ErrorValue&
    operator=(nsresult&& aRhs);

    ErrorValue&
    operator=(const ErrorData& aRhs);

    ErrorValue&
    operator=(ErrorData&& aRhs);

    ErrorValue&
    operator=(const void_t& aRhs);

    ErrorValue&
    operator=(void_t&& aRhs);

    ErrorValue&
    operator=(const ErrorValue& aRhs);

    ErrorValue&
    operator=(ErrorValue&& aRhs);

    bool
    operator==(const nsresult& aRhs) const;

    bool
    operator==(const ErrorData& aRhs) const;

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const ErrorValue& aRhs) const;

    nsresult&
    get_nsresult()
    {
        AssertSanity(Tnsresult);
        return (*(ptr_nsresult()));
    }
    const nsresult&
    get_nsresult() const
    {
        AssertSanity(Tnsresult);
        return (*(constptr_nsresult()));
    }
    void
    get(nsresult* aOutValue) const;
    operator nsresult&()
    {
        return get_nsresult();
    }
    operator const nsresult&() const
    {
        return get_nsresult();
    }

    ErrorData&
    get_ErrorData()
    {
        AssertSanity(TErrorData);
        return (*(ptr_ErrorData()));
    }
    const ErrorData&
    get_ErrorData() const
    {
        AssertSanity(TErrorData);
        return (*(constptr_ErrorData()));
    }
    void
    get(ErrorData* aOutValue) const;
    operator ErrorData&()
    {
        return get_ErrorData();
    }
    operator const ErrorData&() const
    {
        return get_ErrorData();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::ErrorValue>
{
    typedef mozilla::dom::ErrorValue paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef RemoteWorkerTypes_h
