//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef NeckoChannelParams_h
#define NeckoChannelParams_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"

// Headers for typedefs
#include "mozilla/TimeStamp.h"
#include "mozilla/ipc/BackgroundUtils.h"
#include "mozilla/net/PHttpChannelParams.h"
#include "nsHttpResponseHead.h"
#include "mozilla/dom/BlobTypes.h"
#include "mozilla/dom/ClientIPCTypes.h"
#include "mozilla/ipc/URIParams.h"
#include "mozilla/dom/IPCServiceWorkerDescriptor.h"
#include "mozilla/ipc/IPCStream.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"
#include "mozilla/dom/DOMTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CookiePermissionData|
//
namespace mozilla {
namespace net {
class CookiePermissionData final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;

public:
    MOZ_IMPLICIT CookiePermissionData() :
        principalInfo_(),
        cookiePermission_()
    {
    }

    MOZ_IMPLICIT CookiePermissionData(
            const PrincipalInfo& _principalInfo,
            const uint32_t& _cookiePermission) :
        principalInfo_(_principalInfo),
        cookiePermission_(_cookiePermission)
    {
    }

    bool
    operator==(const CookiePermissionData& _o) const;

    bool
    operator!=(const CookiePermissionData& _o) const;

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    uint32_t&
    cookiePermission()
    {
        return cookiePermission_;
    }
    const uint32_t&
    cookiePermission() const
    {
        return cookiePermission_;
    }

private:
    PrincipalInfo principalInfo_;
    uint32_t cookiePermission_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::CookiePermissionData>
{
    typedef mozilla::net::CookiePermissionData paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CookieSettingsArgs|
//
namespace mozilla {
namespace net {
class CookieSettingsArgs final
{
private:
    typedef mozilla::net::CookiePermissionData CookiePermissionData;

public:
    MOZ_IMPLICIT CookieSettingsArgs() :
        cookiePermissions_(),
        isFixed_(),
        cookieBehavior_()
    {
    }

    MOZ_IMPLICIT CookieSettingsArgs(
            const uint32_t& _cookieBehavior,
            const nsTArray<CookiePermissionData>& _cookiePermissions,
            const bool& _isFixed) :
        cookiePermissions_(_cookiePermissions),
        isFixed_(_isFixed),
        cookieBehavior_(_cookieBehavior)
    {
    }

    bool
    operator==(const CookieSettingsArgs& _o) const;

    bool
    operator!=(const CookieSettingsArgs& _o) const;

    uint32_t&
    cookieBehavior()
    {
        return cookieBehavior_;
    }
    const uint32_t&
    cookieBehavior() const
    {
        return cookieBehavior_;
    }

    nsTArray<CookiePermissionData>&
    cookiePermissions()
    {
        return cookiePermissions_;
    }
    const nsTArray<CookiePermissionData>&
    cookiePermissions() const
    {
        return cookiePermissions_;
    }

    bool&
    isFixed()
    {
        return isFixed_;
    }
    const bool&
    isFixed() const
    {
        return isFixed_;
    }

private:
    nsTArray<CookiePermissionData> cookiePermissions_;
    bool isFixed_;
    uint32_t cookieBehavior_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::CookieSettingsArgs>
{
    typedef mozilla::net::CookieSettingsArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct PreferredAlternativeDataTypeParams|
//
namespace mozilla {
namespace net {
class PreferredAlternativeDataTypeParams final
{
private:

public:
    MOZ_IMPLICIT PreferredAlternativeDataTypeParams() :
        type_(),
        contentType_(),
        deliverAltData_()
    {
    }

    MOZ_IMPLICIT PreferredAlternativeDataTypeParams(
            const nsCString& _type,
            const nsCString& _contentType,
            const bool& _deliverAltData) :
        type_(_type),
        contentType_(_contentType),
        deliverAltData_(_deliverAltData)
    {
    }

    bool
    operator==(const PreferredAlternativeDataTypeParams& _o) const;

    bool
    operator!=(const PreferredAlternativeDataTypeParams& _o) const;

    nsCString&
    type()
    {
        return type_;
    }
    const nsCString&
    type() const
    {
        return type_;
    }

    nsCString&
    contentType()
    {
        return contentType_;
    }
    const nsCString&
    contentType() const
    {
        return contentType_;
    }

    bool&
    deliverAltData()
    {
        return deliverAltData_;
    }
    const bool&
    deliverAltData() const
    {
        return deliverAltData_;
    }

private:
    nsCString type_;
    nsCString contentType_;
    bool deliverAltData_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::PreferredAlternativeDataTypeParams>
{
    typedef mozilla::net::PreferredAlternativeDataTypeParams paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RedirectHistoryEntryInfo|
//
namespace mozilla {
namespace net {
class RedirectHistoryEntryInfo final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef mozilla::ipc::URIParams URIParams;

public:
    MOZ_IMPLICIT RedirectHistoryEntryInfo() :
        principalInfo_(),
        referrerUri_(),
        remoteAddress_()
    {
    }

    MOZ_IMPLICIT RedirectHistoryEntryInfo(
            const PrincipalInfo& _principalInfo,
            const mozilla::Maybe<URIParams>& _referrerUri,
            const nsCString& _remoteAddress) :
        principalInfo_(_principalInfo),
        referrerUri_(_referrerUri),
        remoteAddress_(_remoteAddress)
    {
    }

    bool
    operator==(const RedirectHistoryEntryInfo& _o) const;

    bool
    operator!=(const RedirectHistoryEntryInfo& _o) const;

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    mozilla::Maybe<URIParams>&
    referrerUri()
    {
        return referrerUri_;
    }
    const mozilla::Maybe<URIParams>&
    referrerUri() const
    {
        return referrerUri_;
    }

    nsCString&
    remoteAddress()
    {
        return remoteAddress_;
    }
    const nsCString&
    remoteAddress() const
    {
        return remoteAddress_;
    }

private:
    PrincipalInfo principalInfo_;
    mozilla::Maybe<URIParams> referrerUri_;
    nsCString remoteAddress_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::RedirectHistoryEntryInfo>
{
    typedef mozilla::net::RedirectHistoryEntryInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LoadInfoArgs|
//
namespace mozilla {
namespace net {
class LoadInfoArgs final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::OriginAttributes OriginAttributes;
    typedef mozilla::net::RedirectHistoryEntryInfo RedirectHistoryEntryInfo;
    typedef mozilla::dom::IPCClientInfo IPCClientInfo;
    typedef mozilla::dom::IPCServiceWorkerDescriptor IPCServiceWorkerDescriptor;
    typedef mozilla::net::CookieSettingsArgs CookieSettingsArgs;

public:
    MOZ_IMPLICIT LoadInfoArgs() :
        requestingPrincipalInfo_(),
        triggeringPrincipalInfo_(),
        principalToInheritInfo_(),
        sandboxedLoadingPrincipalInfo_(),
        topLevelPrincipalInfo_(),
        topLevelStorageAreaPrincipalInfo_(),
        resultPrincipalURI_(),
        upgradeInsecureRequests_(),
        browserUpgradeInsecureRequests_(),
        browserWouldUpgradeInsecureRequests_(),
        forceAllowDataURI_(),
        allowInsecureRedirectToDataURI_(),
        skipContentPolicyCheckForWebRequest_(),
        forceInheritPrincipalDropped_(),
        initialSecurityCheckDone_(),
        isInThirdPartyContext_(),
        isDocshellReload_(),
        sendCSPViolationEvents_(),
        originAttributes_(),
        redirectChainIncludingInternalRedirects_(),
        redirectChain_(),
        ancestorPrincipals_(),
        ancestorOuterWindowIDs_(),
        clientInfo_(),
        reservedClientInfo_(),
        initialClientInfo_(),
        controller_(),
        corsUnsafeHeaders_(),
        forcePreflight_(),
        isPreflight_(),
        loadTriggeredFromExternal_(),
        serviceWorkerTaintingSynthesized_(),
        documentHasUserInteracted_(),
        documentHasLoaded_(),
        cspNonce_(),
        isFromProcessingFrameAttributes_(),
        cookieSettings_(),
        innerWindowID_(),
        outerWindowID_(),
        parentOuterWindowID_(),
        topOuterWindowID_(),
        frameOuterWindowID_(),
        browsingContextID_(),
        frameBrowsingContextID_(),
        securityFlags_(),
        contentPolicyType_(),
        tainting_(),
        requestBlockingReason_()
    {
    }

    MOZ_IMPLICIT LoadInfoArgs(
            const mozilla::Maybe<PrincipalInfo>& _requestingPrincipalInfo,
            const PrincipalInfo& _triggeringPrincipalInfo,
            const mozilla::Maybe<PrincipalInfo>& _principalToInheritInfo,
            const mozilla::Maybe<PrincipalInfo>& _sandboxedLoadingPrincipalInfo,
            const mozilla::Maybe<PrincipalInfo>& _topLevelPrincipalInfo,
            const mozilla::Maybe<PrincipalInfo>& _topLevelStorageAreaPrincipalInfo,
            const mozilla::Maybe<URIParams>& _resultPrincipalURI,
            const uint32_t& _securityFlags,
            const uint32_t& _contentPolicyType,
            const uint32_t& _tainting,
            const bool& _upgradeInsecureRequests,
            const bool& _browserUpgradeInsecureRequests,
            const bool& _browserWouldUpgradeInsecureRequests,
            const bool& _forceAllowDataURI,
            const bool& _allowInsecureRedirectToDataURI,
            const bool& _skipContentPolicyCheckForWebRequest,
            const bool& _forceInheritPrincipalDropped,
            const uint64_t& _innerWindowID,
            const uint64_t& _outerWindowID,
            const uint64_t& _parentOuterWindowID,
            const uint64_t& _topOuterWindowID,
            const uint64_t& _frameOuterWindowID,
            const uint64_t& _browsingContextID,
            const uint64_t& _frameBrowsingContextID,
            const bool& _initialSecurityCheckDone,
            const bool& _isInThirdPartyContext,
            const bool& _isDocshellReload,
            const bool& _sendCSPViolationEvents,
            const OriginAttributes& _originAttributes,
            const nsTArray<RedirectHistoryEntryInfo>& _redirectChainIncludingInternalRedirects,
            const nsTArray<RedirectHistoryEntryInfo>& _redirectChain,
            const nsTArray<PrincipalInfo>& _ancestorPrincipals,
            const nsTArray<uint64_t>& _ancestorOuterWindowIDs,
            const mozilla::Maybe<IPCClientInfo>& _clientInfo,
            const mozilla::Maybe<IPCClientInfo>& _reservedClientInfo,
            const mozilla::Maybe<IPCClientInfo>& _initialClientInfo,
            const mozilla::Maybe<IPCServiceWorkerDescriptor>& _controller,
            const nsTArray<nsCString>& _corsUnsafeHeaders,
            const bool& _forcePreflight,
            const bool& _isPreflight,
            const bool& _loadTriggeredFromExternal,
            const bool& _serviceWorkerTaintingSynthesized,
            const bool& _documentHasUserInteracted,
            const bool& _documentHasLoaded,
            const nsString& _cspNonce,
            const bool& _isFromProcessingFrameAttributes,
            const CookieSettingsArgs& _cookieSettings,
            const uint32_t& _requestBlockingReason) :
        requestingPrincipalInfo_(_requestingPrincipalInfo),
        triggeringPrincipalInfo_(_triggeringPrincipalInfo),
        principalToInheritInfo_(_principalToInheritInfo),
        sandboxedLoadingPrincipalInfo_(_sandboxedLoadingPrincipalInfo),
        topLevelPrincipalInfo_(_topLevelPrincipalInfo),
        topLevelStorageAreaPrincipalInfo_(_topLevelStorageAreaPrincipalInfo),
        resultPrincipalURI_(_resultPrincipalURI),
        upgradeInsecureRequests_(_upgradeInsecureRequests),
        browserUpgradeInsecureRequests_(_browserUpgradeInsecureRequests),
        browserWouldUpgradeInsecureRequests_(_browserWouldUpgradeInsecureRequests),
        forceAllowDataURI_(_forceAllowDataURI),
        allowInsecureRedirectToDataURI_(_allowInsecureRedirectToDataURI),
        skipContentPolicyCheckForWebRequest_(_skipContentPolicyCheckForWebRequest),
        forceInheritPrincipalDropped_(_forceInheritPrincipalDropped),
        initialSecurityCheckDone_(_initialSecurityCheckDone),
        isInThirdPartyContext_(_isInThirdPartyContext),
        isDocshellReload_(_isDocshellReload),
        sendCSPViolationEvents_(_sendCSPViolationEvents),
        originAttributes_(_originAttributes),
        redirectChainIncludingInternalRedirects_(_redirectChainIncludingInternalRedirects),
        redirectChain_(_redirectChain),
        ancestorPrincipals_(_ancestorPrincipals),
        ancestorOuterWindowIDs_(_ancestorOuterWindowIDs),
        clientInfo_(_clientInfo),
        reservedClientInfo_(_reservedClientInfo),
        initialClientInfo_(_initialClientInfo),
        controller_(_controller),
        corsUnsafeHeaders_(_corsUnsafeHeaders),
        forcePreflight_(_forcePreflight),
        isPreflight_(_isPreflight),
        loadTriggeredFromExternal_(_loadTriggeredFromExternal),
        serviceWorkerTaintingSynthesized_(_serviceWorkerTaintingSynthesized),
        documentHasUserInteracted_(_documentHasUserInteracted),
        documentHasLoaded_(_documentHasLoaded),
        cspNonce_(_cspNonce),
        isFromProcessingFrameAttributes_(_isFromProcessingFrameAttributes),
        cookieSettings_(_cookieSettings),
        innerWindowID_(_innerWindowID),
        outerWindowID_(_outerWindowID),
        parentOuterWindowID_(_parentOuterWindowID),
        topOuterWindowID_(_topOuterWindowID),
        frameOuterWindowID_(_frameOuterWindowID),
        browsingContextID_(_browsingContextID),
        frameBrowsingContextID_(_frameBrowsingContextID),
        securityFlags_(_securityFlags),
        contentPolicyType_(_contentPolicyType),
        tainting_(_tainting),
        requestBlockingReason_(_requestBlockingReason)
    {
    }

    bool
    operator==(const LoadInfoArgs& _o) const;

    bool
    operator!=(const LoadInfoArgs& _o) const;

    mozilla::Maybe<PrincipalInfo>&
    requestingPrincipalInfo()
    {
        return requestingPrincipalInfo_;
    }
    const mozilla::Maybe<PrincipalInfo>&
    requestingPrincipalInfo() const
    {
        return requestingPrincipalInfo_;
    }

    PrincipalInfo&
    triggeringPrincipalInfo()
    {
        return triggeringPrincipalInfo_;
    }
    const PrincipalInfo&
    triggeringPrincipalInfo() const
    {
        return triggeringPrincipalInfo_;
    }

    mozilla::Maybe<PrincipalInfo>&
    principalToInheritInfo()
    {
        return principalToInheritInfo_;
    }
    const mozilla::Maybe<PrincipalInfo>&
    principalToInheritInfo() const
    {
        return principalToInheritInfo_;
    }

    mozilla::Maybe<PrincipalInfo>&
    sandboxedLoadingPrincipalInfo()
    {
        return sandboxedLoadingPrincipalInfo_;
    }
    const mozilla::Maybe<PrincipalInfo>&
    sandboxedLoadingPrincipalInfo() const
    {
        return sandboxedLoadingPrincipalInfo_;
    }

    mozilla::Maybe<PrincipalInfo>&
    topLevelPrincipalInfo()
    {
        return topLevelPrincipalInfo_;
    }
    const mozilla::Maybe<PrincipalInfo>&
    topLevelPrincipalInfo() const
    {
        return topLevelPrincipalInfo_;
    }

    mozilla::Maybe<PrincipalInfo>&
    topLevelStorageAreaPrincipalInfo()
    {
        return topLevelStorageAreaPrincipalInfo_;
    }
    const mozilla::Maybe<PrincipalInfo>&
    topLevelStorageAreaPrincipalInfo() const
    {
        return topLevelStorageAreaPrincipalInfo_;
    }

    mozilla::Maybe<URIParams>&
    resultPrincipalURI()
    {
        return resultPrincipalURI_;
    }
    const mozilla::Maybe<URIParams>&
    resultPrincipalURI() const
    {
        return resultPrincipalURI_;
    }

    uint32_t&
    securityFlags()
    {
        return securityFlags_;
    }
    const uint32_t&
    securityFlags() const
    {
        return securityFlags_;
    }

    uint32_t&
    contentPolicyType()
    {
        return contentPolicyType_;
    }
    const uint32_t&
    contentPolicyType() const
    {
        return contentPolicyType_;
    }

    uint32_t&
    tainting()
    {
        return tainting_;
    }
    const uint32_t&
    tainting() const
    {
        return tainting_;
    }

    bool&
    upgradeInsecureRequests()
    {
        return upgradeInsecureRequests_;
    }
    const bool&
    upgradeInsecureRequests() const
    {
        return upgradeInsecureRequests_;
    }

    bool&
    browserUpgradeInsecureRequests()
    {
        return browserUpgradeInsecureRequests_;
    }
    const bool&
    browserUpgradeInsecureRequests() const
    {
        return browserUpgradeInsecureRequests_;
    }

    bool&
    browserWouldUpgradeInsecureRequests()
    {
        return browserWouldUpgradeInsecureRequests_;
    }
    const bool&
    browserWouldUpgradeInsecureRequests() const
    {
        return browserWouldUpgradeInsecureRequests_;
    }

    bool&
    forceAllowDataURI()
    {
        return forceAllowDataURI_;
    }
    const bool&
    forceAllowDataURI() const
    {
        return forceAllowDataURI_;
    }

    bool&
    allowInsecureRedirectToDataURI()
    {
        return allowInsecureRedirectToDataURI_;
    }
    const bool&
    allowInsecureRedirectToDataURI() const
    {
        return allowInsecureRedirectToDataURI_;
    }

    bool&
    skipContentPolicyCheckForWebRequest()
    {
        return skipContentPolicyCheckForWebRequest_;
    }
    const bool&
    skipContentPolicyCheckForWebRequest() const
    {
        return skipContentPolicyCheckForWebRequest_;
    }

    bool&
    forceInheritPrincipalDropped()
    {
        return forceInheritPrincipalDropped_;
    }
    const bool&
    forceInheritPrincipalDropped() const
    {
        return forceInheritPrincipalDropped_;
    }

    uint64_t&
    innerWindowID()
    {
        return innerWindowID_;
    }
    const uint64_t&
    innerWindowID() const
    {
        return innerWindowID_;
    }

    uint64_t&
    outerWindowID()
    {
        return outerWindowID_;
    }
    const uint64_t&
    outerWindowID() const
    {
        return outerWindowID_;
    }

    uint64_t&
    parentOuterWindowID()
    {
        return parentOuterWindowID_;
    }
    const uint64_t&
    parentOuterWindowID() const
    {
        return parentOuterWindowID_;
    }

    uint64_t&
    topOuterWindowID()
    {
        return topOuterWindowID_;
    }
    const uint64_t&
    topOuterWindowID() const
    {
        return topOuterWindowID_;
    }

    uint64_t&
    frameOuterWindowID()
    {
        return frameOuterWindowID_;
    }
    const uint64_t&
    frameOuterWindowID() const
    {
        return frameOuterWindowID_;
    }

    uint64_t&
    browsingContextID()
    {
        return browsingContextID_;
    }
    const uint64_t&
    browsingContextID() const
    {
        return browsingContextID_;
    }

    uint64_t&
    frameBrowsingContextID()
    {
        return frameBrowsingContextID_;
    }
    const uint64_t&
    frameBrowsingContextID() const
    {
        return frameBrowsingContextID_;
    }

    bool&
    initialSecurityCheckDone()
    {
        return initialSecurityCheckDone_;
    }
    const bool&
    initialSecurityCheckDone() const
    {
        return initialSecurityCheckDone_;
    }

    bool&
    isInThirdPartyContext()
    {
        return isInThirdPartyContext_;
    }
    const bool&
    isInThirdPartyContext() const
    {
        return isInThirdPartyContext_;
    }

    bool&
    isDocshellReload()
    {
        return isDocshellReload_;
    }
    const bool&
    isDocshellReload() const
    {
        return isDocshellReload_;
    }

    bool&
    sendCSPViolationEvents()
    {
        return sendCSPViolationEvents_;
    }
    const bool&
    sendCSPViolationEvents() const
    {
        return sendCSPViolationEvents_;
    }

    OriginAttributes&
    originAttributes()
    {
        return originAttributes_;
    }
    const OriginAttributes&
    originAttributes() const
    {
        return originAttributes_;
    }

    nsTArray<RedirectHistoryEntryInfo>&
    redirectChainIncludingInternalRedirects()
    {
        return redirectChainIncludingInternalRedirects_;
    }
    const nsTArray<RedirectHistoryEntryInfo>&
    redirectChainIncludingInternalRedirects() const
    {
        return redirectChainIncludingInternalRedirects_;
    }

    nsTArray<RedirectHistoryEntryInfo>&
    redirectChain()
    {
        return redirectChain_;
    }
    const nsTArray<RedirectHistoryEntryInfo>&
    redirectChain() const
    {
        return redirectChain_;
    }

    nsTArray<PrincipalInfo>&
    ancestorPrincipals()
    {
        return ancestorPrincipals_;
    }
    const nsTArray<PrincipalInfo>&
    ancestorPrincipals() const
    {
        return ancestorPrincipals_;
    }

    nsTArray<uint64_t>&
    ancestorOuterWindowIDs()
    {
        return ancestorOuterWindowIDs_;
    }
    const nsTArray<uint64_t>&
    ancestorOuterWindowIDs() const
    {
        return ancestorOuterWindowIDs_;
    }

    mozilla::Maybe<IPCClientInfo>&
    clientInfo()
    {
        return clientInfo_;
    }
    const mozilla::Maybe<IPCClientInfo>&
    clientInfo() const
    {
        return clientInfo_;
    }

    mozilla::Maybe<IPCClientInfo>&
    reservedClientInfo()
    {
        return reservedClientInfo_;
    }
    const mozilla::Maybe<IPCClientInfo>&
    reservedClientInfo() const
    {
        return reservedClientInfo_;
    }

    mozilla::Maybe<IPCClientInfo>&
    initialClientInfo()
    {
        return initialClientInfo_;
    }
    const mozilla::Maybe<IPCClientInfo>&
    initialClientInfo() const
    {
        return initialClientInfo_;
    }

    mozilla::Maybe<IPCServiceWorkerDescriptor>&
    controller()
    {
        return controller_;
    }
    const mozilla::Maybe<IPCServiceWorkerDescriptor>&
    controller() const
    {
        return controller_;
    }

    nsTArray<nsCString>&
    corsUnsafeHeaders()
    {
        return corsUnsafeHeaders_;
    }
    const nsTArray<nsCString>&
    corsUnsafeHeaders() const
    {
        return corsUnsafeHeaders_;
    }

    bool&
    forcePreflight()
    {
        return forcePreflight_;
    }
    const bool&
    forcePreflight() const
    {
        return forcePreflight_;
    }

    bool&
    isPreflight()
    {
        return isPreflight_;
    }
    const bool&
    isPreflight() const
    {
        return isPreflight_;
    }

    bool&
    loadTriggeredFromExternal()
    {
        return loadTriggeredFromExternal_;
    }
    const bool&
    loadTriggeredFromExternal() const
    {
        return loadTriggeredFromExternal_;
    }

    bool&
    serviceWorkerTaintingSynthesized()
    {
        return serviceWorkerTaintingSynthesized_;
    }
    const bool&
    serviceWorkerTaintingSynthesized() const
    {
        return serviceWorkerTaintingSynthesized_;
    }

    bool&
    documentHasUserInteracted()
    {
        return documentHasUserInteracted_;
    }
    const bool&
    documentHasUserInteracted() const
    {
        return documentHasUserInteracted_;
    }

    bool&
    documentHasLoaded()
    {
        return documentHasLoaded_;
    }
    const bool&
    documentHasLoaded() const
    {
        return documentHasLoaded_;
    }

    nsString&
    cspNonce()
    {
        return cspNonce_;
    }
    const nsString&
    cspNonce() const
    {
        return cspNonce_;
    }

    bool&
    isFromProcessingFrameAttributes()
    {
        return isFromProcessingFrameAttributes_;
    }
    const bool&
    isFromProcessingFrameAttributes() const
    {
        return isFromProcessingFrameAttributes_;
    }

    CookieSettingsArgs&
    cookieSettings()
    {
        return cookieSettings_;
    }
    const CookieSettingsArgs&
    cookieSettings() const
    {
        return cookieSettings_;
    }

    uint32_t&
    requestBlockingReason()
    {
        return requestBlockingReason_;
    }
    const uint32_t&
    requestBlockingReason() const
    {
        return requestBlockingReason_;
    }

private:
    void
    StaticAssertions() const;
    mozilla::Maybe<PrincipalInfo> requestingPrincipalInfo_;
    PrincipalInfo triggeringPrincipalInfo_;
    mozilla::Maybe<PrincipalInfo> principalToInheritInfo_;
    mozilla::Maybe<PrincipalInfo> sandboxedLoadingPrincipalInfo_;
    mozilla::Maybe<PrincipalInfo> topLevelPrincipalInfo_;
    mozilla::Maybe<PrincipalInfo> topLevelStorageAreaPrincipalInfo_;
    mozilla::Maybe<URIParams> resultPrincipalURI_;
    bool upgradeInsecureRequests_;
    bool browserUpgradeInsecureRequests_;
    bool browserWouldUpgradeInsecureRequests_;
    bool forceAllowDataURI_;
    bool allowInsecureRedirectToDataURI_;
    bool skipContentPolicyCheckForWebRequest_;
    bool forceInheritPrincipalDropped_;
    bool initialSecurityCheckDone_;
    bool isInThirdPartyContext_;
    bool isDocshellReload_;
    bool sendCSPViolationEvents_;
    OriginAttributes originAttributes_;
    nsTArray<RedirectHistoryEntryInfo> redirectChainIncludingInternalRedirects_;
    nsTArray<RedirectHistoryEntryInfo> redirectChain_;
    nsTArray<PrincipalInfo> ancestorPrincipals_;
    nsTArray<uint64_t> ancestorOuterWindowIDs_;
    mozilla::Maybe<IPCClientInfo> clientInfo_;
    mozilla::Maybe<IPCClientInfo> reservedClientInfo_;
    mozilla::Maybe<IPCClientInfo> initialClientInfo_;
    mozilla::Maybe<IPCServiceWorkerDescriptor> controller_;
    nsTArray<nsCString> corsUnsafeHeaders_;
    bool forcePreflight_;
    bool isPreflight_;
    bool loadTriggeredFromExternal_;
    bool serviceWorkerTaintingSynthesized_;
    bool documentHasUserInteracted_;
    bool documentHasLoaded_;
    nsString cspNonce_;
    bool isFromProcessingFrameAttributes_;
    CookieSettingsArgs cookieSettings_;
    uint64_t innerWindowID_;
    uint64_t outerWindowID_;
    uint64_t parentOuterWindowID_;
    uint64_t topOuterWindowID_;
    uint64_t frameOuterWindowID_;
    uint64_t browsingContextID_;
    uint64_t frameBrowsingContextID_;
    uint32_t securityFlags_;
    uint32_t contentPolicyType_;
    uint32_t tainting_;
    uint32_t requestBlockingReason_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::LoadInfoArgs>
{
    typedef mozilla::net::LoadInfoArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ParentLoadInfoForwarderArgs|
//
namespace mozilla {
namespace net {
class ParentLoadInfoForwarderArgs final
{
private:
    typedef mozilla::dom::IPCServiceWorkerDescriptor IPCServiceWorkerDescriptor;
    typedef mozilla::net::CookieSettingsArgs CookieSettingsArgs;

public:
    MOZ_IMPLICIT ParentLoadInfoForwarderArgs() :
        allowInsecureRedirectToDataURI_(),
        controller_(),
        serviceWorkerTaintingSynthesized_(),
        documentHasUserInteracted_(),
        documentHasLoaded_(),
        cookieSettings_(),
        tainting_(),
        requestBlockingReason_()
    {
    }

    MOZ_IMPLICIT ParentLoadInfoForwarderArgs(
            const bool& _allowInsecureRedirectToDataURI,
            const mozilla::Maybe<IPCServiceWorkerDescriptor>& _controller,
            const uint32_t& _tainting,
            const bool& _serviceWorkerTaintingSynthesized,
            const bool& _documentHasUserInteracted,
            const bool& _documentHasLoaded,
            const mozilla::Maybe<CookieSettingsArgs>& _cookieSettings,
            const uint32_t& _requestBlockingReason) :
        allowInsecureRedirectToDataURI_(_allowInsecureRedirectToDataURI),
        controller_(_controller),
        serviceWorkerTaintingSynthesized_(_serviceWorkerTaintingSynthesized),
        documentHasUserInteracted_(_documentHasUserInteracted),
        documentHasLoaded_(_documentHasLoaded),
        cookieSettings_(_cookieSettings),
        tainting_(_tainting),
        requestBlockingReason_(_requestBlockingReason)
    {
    }

    bool
    operator==(const ParentLoadInfoForwarderArgs& _o) const;

    bool
    operator!=(const ParentLoadInfoForwarderArgs& _o) const;

    bool&
    allowInsecureRedirectToDataURI()
    {
        return allowInsecureRedirectToDataURI_;
    }
    const bool&
    allowInsecureRedirectToDataURI() const
    {
        return allowInsecureRedirectToDataURI_;
    }

    mozilla::Maybe<IPCServiceWorkerDescriptor>&
    controller()
    {
        return controller_;
    }
    const mozilla::Maybe<IPCServiceWorkerDescriptor>&
    controller() const
    {
        return controller_;
    }

    uint32_t&
    tainting()
    {
        return tainting_;
    }
    const uint32_t&
    tainting() const
    {
        return tainting_;
    }

    bool&
    serviceWorkerTaintingSynthesized()
    {
        return serviceWorkerTaintingSynthesized_;
    }
    const bool&
    serviceWorkerTaintingSynthesized() const
    {
        return serviceWorkerTaintingSynthesized_;
    }

    bool&
    documentHasUserInteracted()
    {
        return documentHasUserInteracted_;
    }
    const bool&
    documentHasUserInteracted() const
    {
        return documentHasUserInteracted_;
    }

    bool&
    documentHasLoaded()
    {
        return documentHasLoaded_;
    }
    const bool&
    documentHasLoaded() const
    {
        return documentHasLoaded_;
    }

    mozilla::Maybe<CookieSettingsArgs>&
    cookieSettings()
    {
        return cookieSettings_;
    }
    const mozilla::Maybe<CookieSettingsArgs>&
    cookieSettings() const
    {
        return cookieSettings_;
    }

    uint32_t&
    requestBlockingReason()
    {
        return requestBlockingReason_;
    }
    const uint32_t&
    requestBlockingReason() const
    {
        return requestBlockingReason_;
    }

private:
    void
    StaticAssertions() const;
    bool allowInsecureRedirectToDataURI_;
    mozilla::Maybe<IPCServiceWorkerDescriptor> controller_;
    bool serviceWorkerTaintingSynthesized_;
    bool documentHasUserInteracted_;
    bool documentHasLoaded_;
    mozilla::Maybe<CookieSettingsArgs> cookieSettings_;
    uint32_t tainting_;
    uint32_t requestBlockingReason_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::ParentLoadInfoForwarderArgs>
{
    typedef mozilla::net::ParentLoadInfoForwarderArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ChildLoadInfoForwarderArgs|
//
namespace mozilla {
namespace net {
class ChildLoadInfoForwarderArgs final
{
private:
    typedef mozilla::dom::IPCClientInfo IPCClientInfo;
    typedef mozilla::dom::IPCServiceWorkerDescriptor IPCServiceWorkerDescriptor;

public:
    MOZ_IMPLICIT ChildLoadInfoForwarderArgs() :
        reservedClientInfo_(),
        initialClientInfo_(),
        controller_()
    {
    }

    MOZ_IMPLICIT ChildLoadInfoForwarderArgs(
            const mozilla::Maybe<IPCClientInfo>& _reservedClientInfo,
            const mozilla::Maybe<IPCClientInfo>& _initialClientInfo,
            const mozilla::Maybe<IPCServiceWorkerDescriptor>& _controller) :
        reservedClientInfo_(_reservedClientInfo),
        initialClientInfo_(_initialClientInfo),
        controller_(_controller)
    {
    }

    bool
    operator==(const ChildLoadInfoForwarderArgs& _o) const;

    bool
    operator!=(const ChildLoadInfoForwarderArgs& _o) const;

    mozilla::Maybe<IPCClientInfo>&
    reservedClientInfo()
    {
        return reservedClientInfo_;
    }
    const mozilla::Maybe<IPCClientInfo>&
    reservedClientInfo() const
    {
        return reservedClientInfo_;
    }

    mozilla::Maybe<IPCClientInfo>&
    initialClientInfo()
    {
        return initialClientInfo_;
    }
    const mozilla::Maybe<IPCClientInfo>&
    initialClientInfo() const
    {
        return initialClientInfo_;
    }

    mozilla::Maybe<IPCServiceWorkerDescriptor>&
    controller()
    {
        return controller_;
    }
    const mozilla::Maybe<IPCServiceWorkerDescriptor>&
    controller() const
    {
        return controller_;
    }

private:
    mozilla::Maybe<IPCClientInfo> reservedClientInfo_;
    mozilla::Maybe<IPCClientInfo> initialClientInfo_;
    mozilla::Maybe<IPCServiceWorkerDescriptor> controller_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::ChildLoadInfoForwarderArgs>
{
    typedef mozilla::net::ChildLoadInfoForwarderArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CorsPreflightArgs|
//
namespace mozilla {
namespace net {
class CorsPreflightArgs final
{
private:

public:
    MOZ_IMPLICIT CorsPreflightArgs() :
        unsafeHeaders_()
    {
    }

    MOZ_IMPLICIT CorsPreflightArgs(const nsTArray<nsCString>& _unsafeHeaders) :
        unsafeHeaders_(_unsafeHeaders)
    {
    }

    bool
    operator==(const CorsPreflightArgs& _o) const;

    bool
    operator!=(const CorsPreflightArgs& _o) const;

    nsTArray<nsCString>&
    unsafeHeaders()
    {
        return unsafeHeaders_;
    }
    const nsTArray<nsCString>&
    unsafeHeaders() const
    {
        return unsafeHeaders_;
    }

private:
    nsTArray<nsCString> unsafeHeaders_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::CorsPreflightArgs>
{
    typedef mozilla::net::CorsPreflightArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelOpenArgs|
//
namespace mozilla {
namespace net {
class HttpChannelOpenArgs final
{
private:
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::ipc::IPCStream IPCStream;
    typedef mozilla::net::LoadInfoArgs LoadInfoArgs;
    typedef mozilla::net::nsHttpResponseHead nsHttpResponseHead;
    typedef mozilla::net::CorsPreflightArgs CorsPreflightArgs;
    typedef mozilla::net::PreferredAlternativeDataTypeParams PreferredAlternativeDataTypeParams;
    typedef mozilla::TimeStamp TimeStamp;

public:
    MOZ_IMPLICIT HttpChannelOpenArgs() :
        uri_(),
        original_(),
        doc_(),
        referrerInfo_(),
        originalReferrer_(),
        apiRedirectTo_(),
        topWindowURI_(),
        requestHeaders_(),
        requestMethod_(),
        uploadStream_(),
        uploadStreamHasHeaders_(),
        allowSTS_(),
        resumeAt_(),
        entityID_(),
        chooseApplicationCache_(),
        appCacheClientID_(),
        allowSpdy_(),
        allowAltSvc_(),
        beConservative_(),
        loadInfo_(),
        synthesizedResponseHead_(),
        synthesizedSecurityInfoSerialization_(),
        preflightArgs_(),
        blockAuthPrompt_(),
        suspendAfterSynthesizeResponse_(),
        allowStaleCacheContent_(),
        contentTypeHint_(),
        integrityMetadata_(),
        preferredAlternativeTypes_(),
        launchServiceWorkerStart_(),
        launchServiceWorkerEnd_(),
        dispatchFetchEventStart_(),
        dispatchFetchEventEnd_(),
        handleFetchEventStart_(),
        handleFetchEventEnd_(),
        forceMainDocumentChannel_(),
        navigationStartTimeStamp_(),
        startPos_(),
        requestContextID_(),
        channelId_(),
        contentWindowId_(),
        topLevelOuterContentWindowId_(),
        originalReferrerPolicy_(),
        referrerPolicy_(),
        loadFlags_(),
        classOfService_(),
        thirdPartyFlags_(),
        tlsFlags_(),
        cacheKey_(),
        initialRwin_(),
        corsMode_(),
        redirectMode_(),
        priority_(),
        redirectionLimit_()
    {
    }

    MOZ_IMPLICIT HttpChannelOpenArgs(
            const URIParams& _uri,
            const mozilla::Maybe<URIParams>& _original,
            const mozilla::Maybe<URIParams>& _doc,
            nsIReferrerInfo* _referrerInfo,
            const mozilla::Maybe<URIParams>& _originalReferrer,
            const uint32_t& _originalReferrerPolicy,
            const uint32_t& _referrerPolicy,
            const mozilla::Maybe<URIParams>& _apiRedirectTo,
            const mozilla::Maybe<URIParams>& _topWindowURI,
            const uint32_t& _loadFlags,
            const RequestHeaderTuples& _requestHeaders,
            const nsCString& _requestMethod,
            const mozilla::Maybe<IPCStream>& _uploadStream,
            const bool& _uploadStreamHasHeaders,
            const int16_t& _priority,
            const uint32_t& _classOfService,
            const uint8_t& _redirectionLimit,
            const bool& _allowSTS,
            const uint32_t& _thirdPartyFlags,
            const bool& _resumeAt,
            const uint64_t& _startPos,
            const nsCString& _entityID,
            const bool& _chooseApplicationCache,
            const nsCString& _appCacheClientID,
            const bool& _allowSpdy,
            const bool& _allowAltSvc,
            const bool& _beConservative,
            const uint32_t& _tlsFlags,
            const mozilla::Maybe<LoadInfoArgs>& _loadInfo,
            const mozilla::Maybe<nsHttpResponseHead>& _synthesizedResponseHead,
            const nsCString& _synthesizedSecurityInfoSerialization,
            const uint32_t& _cacheKey,
            const uint64_t& _requestContextID,
            const mozilla::Maybe<CorsPreflightArgs>& _preflightArgs,
            const uint32_t& _initialRwin,
            const bool& _blockAuthPrompt,
            const bool& _suspendAfterSynthesizeResponse,
            const bool& _allowStaleCacheContent,
            const nsCString& _contentTypeHint,
            const uint32_t& _corsMode,
            const uint32_t& _redirectMode,
            const uint64_t& _channelId,
            const nsString& _integrityMetadata,
            const uint64_t& _contentWindowId,
            const nsTArray<PreferredAlternativeDataTypeParams>& _preferredAlternativeTypes,
            const uint64_t& _topLevelOuterContentWindowId,
            const TimeStamp& _launchServiceWorkerStart,
            const TimeStamp& _launchServiceWorkerEnd,
            const TimeStamp& _dispatchFetchEventStart,
            const TimeStamp& _dispatchFetchEventEnd,
            const TimeStamp& _handleFetchEventStart,
            const TimeStamp& _handleFetchEventEnd,
            const bool& _forceMainDocumentChannel,
            const TimeStamp& _navigationStartTimeStamp) :
        uri_(_uri),
        original_(_original),
        doc_(_doc),
        referrerInfo_(_referrerInfo),
        originalReferrer_(_originalReferrer),
        apiRedirectTo_(_apiRedirectTo),
        topWindowURI_(_topWindowURI),
        requestHeaders_(_requestHeaders),
        requestMethod_(_requestMethod),
        uploadStream_(_uploadStream),
        uploadStreamHasHeaders_(_uploadStreamHasHeaders),
        allowSTS_(_allowSTS),
        resumeAt_(_resumeAt),
        entityID_(_entityID),
        chooseApplicationCache_(_chooseApplicationCache),
        appCacheClientID_(_appCacheClientID),
        allowSpdy_(_allowSpdy),
        allowAltSvc_(_allowAltSvc),
        beConservative_(_beConservative),
        loadInfo_(_loadInfo),
        synthesizedResponseHead_(_synthesizedResponseHead),
        synthesizedSecurityInfoSerialization_(_synthesizedSecurityInfoSerialization),
        preflightArgs_(_preflightArgs),
        blockAuthPrompt_(_blockAuthPrompt),
        suspendAfterSynthesizeResponse_(_suspendAfterSynthesizeResponse),
        allowStaleCacheContent_(_allowStaleCacheContent),
        contentTypeHint_(_contentTypeHint),
        integrityMetadata_(_integrityMetadata),
        preferredAlternativeTypes_(_preferredAlternativeTypes),
        launchServiceWorkerStart_(_launchServiceWorkerStart),
        launchServiceWorkerEnd_(_launchServiceWorkerEnd),
        dispatchFetchEventStart_(_dispatchFetchEventStart),
        dispatchFetchEventEnd_(_dispatchFetchEventEnd),
        handleFetchEventStart_(_handleFetchEventStart),
        handleFetchEventEnd_(_handleFetchEventEnd),
        forceMainDocumentChannel_(_forceMainDocumentChannel),
        navigationStartTimeStamp_(_navigationStartTimeStamp),
        startPos_(_startPos),
        requestContextID_(_requestContextID),
        channelId_(_channelId),
        contentWindowId_(_contentWindowId),
        topLevelOuterContentWindowId_(_topLevelOuterContentWindowId),
        originalReferrerPolicy_(_originalReferrerPolicy),
        referrerPolicy_(_referrerPolicy),
        loadFlags_(_loadFlags),
        classOfService_(_classOfService),
        thirdPartyFlags_(_thirdPartyFlags),
        tlsFlags_(_tlsFlags),
        cacheKey_(_cacheKey),
        initialRwin_(_initialRwin),
        corsMode_(_corsMode),
        redirectMode_(_redirectMode),
        priority_(_priority),
        redirectionLimit_(_redirectionLimit)
    {
    }

    bool
    operator==(const HttpChannelOpenArgs& _o) const;

    bool
    operator!=(const HttpChannelOpenArgs& _o) const;

    URIParams&
    uri()
    {
        return uri_;
    }
    const URIParams&
    uri() const
    {
        return uri_;
    }

    mozilla::Maybe<URIParams>&
    original()
    {
        return original_;
    }
    const mozilla::Maybe<URIParams>&
    original() const
    {
        return original_;
    }

    mozilla::Maybe<URIParams>&
    doc()
    {
        return doc_;
    }
    const mozilla::Maybe<URIParams>&
    doc() const
    {
        return doc_;
    }

    RefPtr<nsIReferrerInfo>&
    referrerInfo()
    {
        return referrerInfo_;
    }
    nsIReferrerInfo*
    referrerInfo() const
    {
        return referrerInfo_;
    }

    mozilla::Maybe<URIParams>&
    originalReferrer()
    {
        return originalReferrer_;
    }
    const mozilla::Maybe<URIParams>&
    originalReferrer() const
    {
        return originalReferrer_;
    }

    uint32_t&
    originalReferrerPolicy()
    {
        return originalReferrerPolicy_;
    }
    const uint32_t&
    originalReferrerPolicy() const
    {
        return originalReferrerPolicy_;
    }

    uint32_t&
    referrerPolicy()
    {
        return referrerPolicy_;
    }
    const uint32_t&
    referrerPolicy() const
    {
        return referrerPolicy_;
    }

    mozilla::Maybe<URIParams>&
    apiRedirectTo()
    {
        return apiRedirectTo_;
    }
    const mozilla::Maybe<URIParams>&
    apiRedirectTo() const
    {
        return apiRedirectTo_;
    }

    mozilla::Maybe<URIParams>&
    topWindowURI()
    {
        return topWindowURI_;
    }
    const mozilla::Maybe<URIParams>&
    topWindowURI() const
    {
        return topWindowURI_;
    }

    uint32_t&
    loadFlags()
    {
        return loadFlags_;
    }
    const uint32_t&
    loadFlags() const
    {
        return loadFlags_;
    }

    RequestHeaderTuples&
    requestHeaders()
    {
        return requestHeaders_;
    }
    const RequestHeaderTuples&
    requestHeaders() const
    {
        return requestHeaders_;
    }

    nsCString&
    requestMethod()
    {
        return requestMethod_;
    }
    const nsCString&
    requestMethod() const
    {
        return requestMethod_;
    }

    mozilla::Maybe<IPCStream>&
    uploadStream()
    {
        return uploadStream_;
    }
    const mozilla::Maybe<IPCStream>&
    uploadStream() const
    {
        return uploadStream_;
    }

    bool&
    uploadStreamHasHeaders()
    {
        return uploadStreamHasHeaders_;
    }
    const bool&
    uploadStreamHasHeaders() const
    {
        return uploadStreamHasHeaders_;
    }

    int16_t&
    priority()
    {
        return priority_;
    }
    const int16_t&
    priority() const
    {
        return priority_;
    }

    uint32_t&
    classOfService()
    {
        return classOfService_;
    }
    const uint32_t&
    classOfService() const
    {
        return classOfService_;
    }

    uint8_t&
    redirectionLimit()
    {
        return redirectionLimit_;
    }
    const uint8_t&
    redirectionLimit() const
    {
        return redirectionLimit_;
    }

    bool&
    allowSTS()
    {
        return allowSTS_;
    }
    const bool&
    allowSTS() const
    {
        return allowSTS_;
    }

    uint32_t&
    thirdPartyFlags()
    {
        return thirdPartyFlags_;
    }
    const uint32_t&
    thirdPartyFlags() const
    {
        return thirdPartyFlags_;
    }

    bool&
    resumeAt()
    {
        return resumeAt_;
    }
    const bool&
    resumeAt() const
    {
        return resumeAt_;
    }

    uint64_t&
    startPos()
    {
        return startPos_;
    }
    const uint64_t&
    startPos() const
    {
        return startPos_;
    }

    nsCString&
    entityID()
    {
        return entityID_;
    }
    const nsCString&
    entityID() const
    {
        return entityID_;
    }

    bool&
    chooseApplicationCache()
    {
        return chooseApplicationCache_;
    }
    const bool&
    chooseApplicationCache() const
    {
        return chooseApplicationCache_;
    }

    nsCString&
    appCacheClientID()
    {
        return appCacheClientID_;
    }
    const nsCString&
    appCacheClientID() const
    {
        return appCacheClientID_;
    }

    bool&
    allowSpdy()
    {
        return allowSpdy_;
    }
    const bool&
    allowSpdy() const
    {
        return allowSpdy_;
    }

    bool&
    allowAltSvc()
    {
        return allowAltSvc_;
    }
    const bool&
    allowAltSvc() const
    {
        return allowAltSvc_;
    }

    bool&
    beConservative()
    {
        return beConservative_;
    }
    const bool&
    beConservative() const
    {
        return beConservative_;
    }

    uint32_t&
    tlsFlags()
    {
        return tlsFlags_;
    }
    const uint32_t&
    tlsFlags() const
    {
        return tlsFlags_;
    }

    mozilla::Maybe<LoadInfoArgs>&
    loadInfo()
    {
        return loadInfo_;
    }
    const mozilla::Maybe<LoadInfoArgs>&
    loadInfo() const
    {
        return loadInfo_;
    }

    mozilla::Maybe<nsHttpResponseHead>&
    synthesizedResponseHead()
    {
        return synthesizedResponseHead_;
    }
    const mozilla::Maybe<nsHttpResponseHead>&
    synthesizedResponseHead() const
    {
        return synthesizedResponseHead_;
    }

    nsCString&
    synthesizedSecurityInfoSerialization()
    {
        return synthesizedSecurityInfoSerialization_;
    }
    const nsCString&
    synthesizedSecurityInfoSerialization() const
    {
        return synthesizedSecurityInfoSerialization_;
    }

    uint32_t&
    cacheKey()
    {
        return cacheKey_;
    }
    const uint32_t&
    cacheKey() const
    {
        return cacheKey_;
    }

    uint64_t&
    requestContextID()
    {
        return requestContextID_;
    }
    const uint64_t&
    requestContextID() const
    {
        return requestContextID_;
    }

    mozilla::Maybe<CorsPreflightArgs>&
    preflightArgs()
    {
        return preflightArgs_;
    }
    const mozilla::Maybe<CorsPreflightArgs>&
    preflightArgs() const
    {
        return preflightArgs_;
    }

    uint32_t&
    initialRwin()
    {
        return initialRwin_;
    }
    const uint32_t&
    initialRwin() const
    {
        return initialRwin_;
    }

    bool&
    blockAuthPrompt()
    {
        return blockAuthPrompt_;
    }
    const bool&
    blockAuthPrompt() const
    {
        return blockAuthPrompt_;
    }

    bool&
    suspendAfterSynthesizeResponse()
    {
        return suspendAfterSynthesizeResponse_;
    }
    const bool&
    suspendAfterSynthesizeResponse() const
    {
        return suspendAfterSynthesizeResponse_;
    }

    bool&
    allowStaleCacheContent()
    {
        return allowStaleCacheContent_;
    }
    const bool&
    allowStaleCacheContent() const
    {
        return allowStaleCacheContent_;
    }

    nsCString&
    contentTypeHint()
    {
        return contentTypeHint_;
    }
    const nsCString&
    contentTypeHint() const
    {
        return contentTypeHint_;
    }

    uint32_t&
    corsMode()
    {
        return corsMode_;
    }
    const uint32_t&
    corsMode() const
    {
        return corsMode_;
    }

    uint32_t&
    redirectMode()
    {
        return redirectMode_;
    }
    const uint32_t&
    redirectMode() const
    {
        return redirectMode_;
    }

    uint64_t&
    channelId()
    {
        return channelId_;
    }
    const uint64_t&
    channelId() const
    {
        return channelId_;
    }

    nsString&
    integrityMetadata()
    {
        return integrityMetadata_;
    }
    const nsString&
    integrityMetadata() const
    {
        return integrityMetadata_;
    }

    uint64_t&
    contentWindowId()
    {
        return contentWindowId_;
    }
    const uint64_t&
    contentWindowId() const
    {
        return contentWindowId_;
    }

    nsTArray<PreferredAlternativeDataTypeParams>&
    preferredAlternativeTypes()
    {
        return preferredAlternativeTypes_;
    }
    const nsTArray<PreferredAlternativeDataTypeParams>&
    preferredAlternativeTypes() const
    {
        return preferredAlternativeTypes_;
    }

    uint64_t&
    topLevelOuterContentWindowId()
    {
        return topLevelOuterContentWindowId_;
    }
    const uint64_t&
    topLevelOuterContentWindowId() const
    {
        return topLevelOuterContentWindowId_;
    }

    TimeStamp&
    launchServiceWorkerStart()
    {
        return launchServiceWorkerStart_;
    }
    const TimeStamp&
    launchServiceWorkerStart() const
    {
        return launchServiceWorkerStart_;
    }

    TimeStamp&
    launchServiceWorkerEnd()
    {
        return launchServiceWorkerEnd_;
    }
    const TimeStamp&
    launchServiceWorkerEnd() const
    {
        return launchServiceWorkerEnd_;
    }

    TimeStamp&
    dispatchFetchEventStart()
    {
        return dispatchFetchEventStart_;
    }
    const TimeStamp&
    dispatchFetchEventStart() const
    {
        return dispatchFetchEventStart_;
    }

    TimeStamp&
    dispatchFetchEventEnd()
    {
        return dispatchFetchEventEnd_;
    }
    const TimeStamp&
    dispatchFetchEventEnd() const
    {
        return dispatchFetchEventEnd_;
    }

    TimeStamp&
    handleFetchEventStart()
    {
        return handleFetchEventStart_;
    }
    const TimeStamp&
    handleFetchEventStart() const
    {
        return handleFetchEventStart_;
    }

    TimeStamp&
    handleFetchEventEnd()
    {
        return handleFetchEventEnd_;
    }
    const TimeStamp&
    handleFetchEventEnd() const
    {
        return handleFetchEventEnd_;
    }

    bool&
    forceMainDocumentChannel()
    {
        return forceMainDocumentChannel_;
    }
    const bool&
    forceMainDocumentChannel() const
    {
        return forceMainDocumentChannel_;
    }

    TimeStamp&
    navigationStartTimeStamp()
    {
        return navigationStartTimeStamp_;
    }
    const TimeStamp&
    navigationStartTimeStamp() const
    {
        return navigationStartTimeStamp_;
    }

private:
    void
    StaticAssertions() const;
    URIParams uri_;
    mozilla::Maybe<URIParams> original_;
    mozilla::Maybe<URIParams> doc_;
    RefPtr<nsIReferrerInfo> referrerInfo_;
    mozilla::Maybe<URIParams> originalReferrer_;
    mozilla::Maybe<URIParams> apiRedirectTo_;
    mozilla::Maybe<URIParams> topWindowURI_;
    RequestHeaderTuples requestHeaders_;
    nsCString requestMethod_;
    mozilla::Maybe<IPCStream> uploadStream_;
    bool uploadStreamHasHeaders_;
    bool allowSTS_;
    bool resumeAt_;
    nsCString entityID_;
    bool chooseApplicationCache_;
    nsCString appCacheClientID_;
    bool allowSpdy_;
    bool allowAltSvc_;
    bool beConservative_;
    mozilla::Maybe<LoadInfoArgs> loadInfo_;
    mozilla::Maybe<nsHttpResponseHead> synthesizedResponseHead_;
    nsCString synthesizedSecurityInfoSerialization_;
    mozilla::Maybe<CorsPreflightArgs> preflightArgs_;
    bool blockAuthPrompt_;
    bool suspendAfterSynthesizeResponse_;
    bool allowStaleCacheContent_;
    nsCString contentTypeHint_;
    nsString integrityMetadata_;
    nsTArray<PreferredAlternativeDataTypeParams> preferredAlternativeTypes_;
    TimeStamp launchServiceWorkerStart_;
    TimeStamp launchServiceWorkerEnd_;
    TimeStamp dispatchFetchEventStart_;
    TimeStamp dispatchFetchEventEnd_;
    TimeStamp handleFetchEventStart_;
    TimeStamp handleFetchEventEnd_;
    bool forceMainDocumentChannel_;
    TimeStamp navigationStartTimeStamp_;
    uint64_t startPos_;
    uint64_t requestContextID_;
    uint64_t channelId_;
    uint64_t contentWindowId_;
    uint64_t topLevelOuterContentWindowId_;
    uint32_t originalReferrerPolicy_;
    uint32_t referrerPolicy_;
    uint32_t loadFlags_;
    uint32_t classOfService_;
    uint32_t thirdPartyFlags_;
    uint32_t tlsFlags_;
    uint32_t cacheKey_;
    uint32_t initialRwin_;
    uint32_t corsMode_;
    uint32_t redirectMode_;
    int16_t priority_;
    uint8_t redirectionLimit_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::HttpChannelOpenArgs>
{
    typedef mozilla::net::HttpChannelOpenArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelConnectArgs|
//
namespace mozilla {
namespace net {
class HttpChannelConnectArgs final
{
private:

public:
    MOZ_IMPLICIT HttpChannelConnectArgs() :
        shouldIntercept_(),
        registrarId_()
    {
    }

    MOZ_IMPLICIT HttpChannelConnectArgs(
            const uint32_t& _registrarId,
            const bool& _shouldIntercept) :
        shouldIntercept_(_shouldIntercept),
        registrarId_(_registrarId)
    {
    }

    bool
    operator==(const HttpChannelConnectArgs& _o) const;

    bool
    operator!=(const HttpChannelConnectArgs& _o) const;

    uint32_t&
    registrarId()
    {
        return registrarId_;
    }
    const uint32_t&
    registrarId() const
    {
        return registrarId_;
    }

    bool&
    shouldIntercept()
    {
        return shouldIntercept_;
    }
    const bool&
    shouldIntercept() const
    {
        return shouldIntercept_;
    }

private:
    bool shouldIntercept_;
    uint32_t registrarId_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::HttpChannelConnectArgs>
{
    typedef mozilla::net::HttpChannelConnectArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union HttpChannelCreationArgs|
//
namespace mozilla {
namespace net {
class HttpChannelCreationArgs final
{
public:
    enum Type {
        T__None,
        THttpChannelOpenArgs = 1,
        THttpChannelConnectArgs,
        T__Last = THttpChannelConnectArgs
    };

private:
    typedef mozilla::net::HttpChannelOpenArgs HttpChannelOpenArgs;
    typedef mozilla::net::HttpChannelConnectArgs HttpChannelConnectArgs;
    typedef HttpChannelOpenArgs HttpChannelOpenArgs__tdef;
    typedef HttpChannelConnectArgs HttpChannelConnectArgs__tdef;

    union Value {
        mozilla::AlignedStorage2<HttpChannelOpenArgs> VHttpChannelOpenArgs;
        mozilla::AlignedStorage2<HttpChannelConnectArgs> VHttpChannelConnectArgs;
    };

    HttpChannelOpenArgs*
    ptr_HttpChannelOpenArgs()
    {
        return ((mValue).VHttpChannelOpenArgs).addr();
    }
    const HttpChannelOpenArgs*
    constptr_HttpChannelOpenArgs() const
    {
        return ((mValue).VHttpChannelOpenArgs).addr();
    }
    HttpChannelConnectArgs*
    ptr_HttpChannelConnectArgs()
    {
        return ((mValue).VHttpChannelConnectArgs).addr();
    }
    const HttpChannelConnectArgs*
    constptr_HttpChannelConnectArgs() const
    {
        return ((mValue).VHttpChannelConnectArgs).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT HttpChannelCreationArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT HttpChannelCreationArgs(const HttpChannelOpenArgs& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(HttpChannelOpenArgs&& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(const HttpChannelConnectArgs& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(HttpChannelConnectArgs&& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(const HttpChannelCreationArgs& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(HttpChannelCreationArgs&& aOther);

    ~HttpChannelCreationArgs();

    Type
    type() const
    {
        return mType;
    }

    HttpChannelCreationArgs&
    operator=(const HttpChannelOpenArgs& aRhs);

    HttpChannelCreationArgs&
    operator=(HttpChannelOpenArgs&& aRhs);

    HttpChannelCreationArgs&
    operator=(const HttpChannelConnectArgs& aRhs);

    HttpChannelCreationArgs&
    operator=(HttpChannelConnectArgs&& aRhs);

    HttpChannelCreationArgs&
    operator=(const HttpChannelCreationArgs& aRhs);

    HttpChannelCreationArgs&
    operator=(HttpChannelCreationArgs&& aRhs);

    bool
    operator==(const HttpChannelOpenArgs& aRhs) const;

    bool
    operator==(const HttpChannelConnectArgs& aRhs) const;

    bool
    operator==(const HttpChannelCreationArgs& aRhs) const;

    HttpChannelOpenArgs&
    get_HttpChannelOpenArgs()
    {
        AssertSanity(THttpChannelOpenArgs);
        return (*(ptr_HttpChannelOpenArgs()));
    }
    const HttpChannelOpenArgs&
    get_HttpChannelOpenArgs() const
    {
        AssertSanity(THttpChannelOpenArgs);
        return (*(constptr_HttpChannelOpenArgs()));
    }
    void
    get(HttpChannelOpenArgs* aOutValue) const;
    operator HttpChannelOpenArgs&()
    {
        return get_HttpChannelOpenArgs();
    }
    operator const HttpChannelOpenArgs&() const
    {
        return get_HttpChannelOpenArgs();
    }

    HttpChannelConnectArgs&
    get_HttpChannelConnectArgs()
    {
        AssertSanity(THttpChannelConnectArgs);
        return (*(ptr_HttpChannelConnectArgs()));
    }
    const HttpChannelConnectArgs&
    get_HttpChannelConnectArgs() const
    {
        AssertSanity(THttpChannelConnectArgs);
        return (*(constptr_HttpChannelConnectArgs()));
    }
    void
    get(HttpChannelConnectArgs* aOutValue) const;
    operator HttpChannelConnectArgs&()
    {
        return get_HttpChannelConnectArgs();
    }
    operator const HttpChannelConnectArgs&() const
    {
        return get_HttpChannelConnectArgs();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::HttpChannelCreationArgs>
{
    typedef mozilla::net::HttpChannelCreationArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FTPChannelOpenArgs|
//
namespace mozilla {
namespace net {
class FTPChannelOpenArgs final
{
private:
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::ipc::IPCStream IPCStream;
    typedef mozilla::net::LoadInfoArgs LoadInfoArgs;

public:
    MOZ_IMPLICIT FTPChannelOpenArgs() :
        uri_(),
        entityID_(),
        uploadStream_(),
        loadInfo_(),
        startPos_(),
        loadFlags_()
    {
    }

    MOZ_IMPLICIT FTPChannelOpenArgs(
            const URIParams& _uri,
            const uint64_t& _startPos,
            const nsCString& _entityID,
            const mozilla::Maybe<IPCStream>& _uploadStream,
            const mozilla::Maybe<LoadInfoArgs>& _loadInfo,
            const uint32_t& _loadFlags) :
        uri_(_uri),
        entityID_(_entityID),
        uploadStream_(_uploadStream),
        loadInfo_(_loadInfo),
        startPos_(_startPos),
        loadFlags_(_loadFlags)
    {
    }

    bool
    operator==(const FTPChannelOpenArgs& _o) const;

    bool
    operator!=(const FTPChannelOpenArgs& _o) const;

    URIParams&
    uri()
    {
        return uri_;
    }
    const URIParams&
    uri() const
    {
        return uri_;
    }

    uint64_t&
    startPos()
    {
        return startPos_;
    }
    const uint64_t&
    startPos() const
    {
        return startPos_;
    }

    nsCString&
    entityID()
    {
        return entityID_;
    }
    const nsCString&
    entityID() const
    {
        return entityID_;
    }

    mozilla::Maybe<IPCStream>&
    uploadStream()
    {
        return uploadStream_;
    }
    const mozilla::Maybe<IPCStream>&
    uploadStream() const
    {
        return uploadStream_;
    }

    mozilla::Maybe<LoadInfoArgs>&
    loadInfo()
    {
        return loadInfo_;
    }
    const mozilla::Maybe<LoadInfoArgs>&
    loadInfo() const
    {
        return loadInfo_;
    }

    uint32_t&
    loadFlags()
    {
        return loadFlags_;
    }
    const uint32_t&
    loadFlags() const
    {
        return loadFlags_;
    }

private:
    URIParams uri_;
    nsCString entityID_;
    mozilla::Maybe<IPCStream> uploadStream_;
    mozilla::Maybe<LoadInfoArgs> loadInfo_;
    uint64_t startPos_;
    uint32_t loadFlags_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::FTPChannelOpenArgs>
{
    typedef mozilla::net::FTPChannelOpenArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FTPChannelConnectArgs|
//
namespace mozilla {
namespace net {
class FTPChannelConnectArgs final
{
private:

public:
    MOZ_IMPLICIT FTPChannelConnectArgs() :
        channelId_()
    {
    }

    MOZ_IMPLICIT FTPChannelConnectArgs(const uint32_t& _channelId) :
        channelId_(_channelId)
    {
    }

    bool
    operator==(const FTPChannelConnectArgs& _o) const;

    bool
    operator!=(const FTPChannelConnectArgs& _o) const;

    uint32_t&
    channelId()
    {
        return channelId_;
    }
    const uint32_t&
    channelId() const
    {
        return channelId_;
    }

private:
    uint32_t channelId_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::FTPChannelConnectArgs>
{
    typedef mozilla::net::FTPChannelConnectArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FTPChannelCreationArgs|
//
namespace mozilla {
namespace net {
class FTPChannelCreationArgs final
{
public:
    enum Type {
        T__None,
        TFTPChannelOpenArgs = 1,
        TFTPChannelConnectArgs,
        T__Last = TFTPChannelConnectArgs
    };

private:
    typedef mozilla::net::FTPChannelOpenArgs FTPChannelOpenArgs;
    typedef mozilla::net::FTPChannelConnectArgs FTPChannelConnectArgs;
    typedef FTPChannelOpenArgs FTPChannelOpenArgs__tdef;
    typedef FTPChannelConnectArgs FTPChannelConnectArgs__tdef;

    union Value {
        mozilla::AlignedStorage2<FTPChannelOpenArgs> VFTPChannelOpenArgs;
        mozilla::AlignedStorage2<FTPChannelConnectArgs> VFTPChannelConnectArgs;
    };

    FTPChannelOpenArgs*
    ptr_FTPChannelOpenArgs()
    {
        return ((mValue).VFTPChannelOpenArgs).addr();
    }
    const FTPChannelOpenArgs*
    constptr_FTPChannelOpenArgs() const
    {
        return ((mValue).VFTPChannelOpenArgs).addr();
    }
    FTPChannelConnectArgs*
    ptr_FTPChannelConnectArgs()
    {
        return ((mValue).VFTPChannelConnectArgs).addr();
    }
    const FTPChannelConnectArgs*
    constptr_FTPChannelConnectArgs() const
    {
        return ((mValue).VFTPChannelConnectArgs).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FTPChannelCreationArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FTPChannelCreationArgs(const FTPChannelOpenArgs& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(FTPChannelOpenArgs&& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(const FTPChannelConnectArgs& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(FTPChannelConnectArgs&& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(const FTPChannelCreationArgs& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(FTPChannelCreationArgs&& aOther);

    ~FTPChannelCreationArgs();

    Type
    type() const
    {
        return mType;
    }

    FTPChannelCreationArgs&
    operator=(const FTPChannelOpenArgs& aRhs);

    FTPChannelCreationArgs&
    operator=(FTPChannelOpenArgs&& aRhs);

    FTPChannelCreationArgs&
    operator=(const FTPChannelConnectArgs& aRhs);

    FTPChannelCreationArgs&
    operator=(FTPChannelConnectArgs&& aRhs);

    FTPChannelCreationArgs&
    operator=(const FTPChannelCreationArgs& aRhs);

    FTPChannelCreationArgs&
    operator=(FTPChannelCreationArgs&& aRhs);

    bool
    operator==(const FTPChannelOpenArgs& aRhs) const;

    bool
    operator==(const FTPChannelConnectArgs& aRhs) const;

    bool
    operator==(const FTPChannelCreationArgs& aRhs) const;

    FTPChannelOpenArgs&
    get_FTPChannelOpenArgs()
    {
        AssertSanity(TFTPChannelOpenArgs);
        return (*(ptr_FTPChannelOpenArgs()));
    }
    const FTPChannelOpenArgs&
    get_FTPChannelOpenArgs() const
    {
        AssertSanity(TFTPChannelOpenArgs);
        return (*(constptr_FTPChannelOpenArgs()));
    }
    void
    get(FTPChannelOpenArgs* aOutValue) const;
    operator FTPChannelOpenArgs&()
    {
        return get_FTPChannelOpenArgs();
    }
    operator const FTPChannelOpenArgs&() const
    {
        return get_FTPChannelOpenArgs();
    }

    FTPChannelConnectArgs&
    get_FTPChannelConnectArgs()
    {
        AssertSanity(TFTPChannelConnectArgs);
        return (*(ptr_FTPChannelConnectArgs()));
    }
    const FTPChannelConnectArgs&
    get_FTPChannelConnectArgs() const
    {
        AssertSanity(TFTPChannelConnectArgs);
        return (*(constptr_FTPChannelConnectArgs()));
    }
    void
    get(FTPChannelConnectArgs* aOutValue) const;
    operator FTPChannelConnectArgs&()
    {
        return get_FTPChannelConnectArgs();
    }
    operator const FTPChannelConnectArgs&() const
    {
        return get_FTPChannelConnectArgs();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::FTPChannelCreationArgs>
{
    typedef mozilla::net::FTPChannelCreationArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace net {
class PHttpChannelParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PHttpChannelChild;
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelDiverterArgs|
//
namespace mozilla {
namespace net {
class HttpChannelDiverterArgs final
{
private:
    typedef mozilla::net::PHttpChannelParent PHttpChannelParent;
    typedef mozilla::net::PHttpChannelChild PHttpChannelChild;

public:
    MOZ_IMPLICIT HttpChannelDiverterArgs() :
        mChannelParent_(),
        mChannelChild_(),
        mApplyConversion_()
    {
    }

    MOZ_IMPLICIT HttpChannelDiverterArgs(
            PHttpChannelParent* _mChannelParent,
            PHttpChannelChild* _mChannelChild,
            const bool& _mApplyConversion) :
        mChannelParent_(_mChannelParent),
        mChannelChild_(_mChannelChild),
        mApplyConversion_(_mApplyConversion)
    {
    }

    bool
    operator==(const HttpChannelDiverterArgs& _o) const;

    bool
    operator!=(const HttpChannelDiverterArgs& _o) const;

    PHttpChannelParent*&
    mChannelParent()
    {
        return mChannelParent_;
    }
    PHttpChannelParent*
    mChannelParent() const
    {
        return mChannelParent_;
    }

    PHttpChannelChild*&
    mChannelChild()
    {
        return mChannelChild_;
    }
    PHttpChannelChild*
    mChannelChild() const
    {
        return mChannelChild_;
    }

    bool&
    mApplyConversion()
    {
        return mApplyConversion_;
    }
    const bool&
    mApplyConversion() const
    {
        return mApplyConversion_;
    }

private:
    PHttpChannelParent* mChannelParent_;
    PHttpChannelChild* mChannelChild_;
    bool mApplyConversion_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::HttpChannelDiverterArgs>
{
    typedef mozilla::net::HttpChannelDiverterArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace net {
class PFTPChannelParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PFTPChannelChild;
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union ChannelDiverterArgs|
//
namespace mozilla {
namespace net {
class ChannelDiverterArgs final
{
public:
    enum Type {
        T__None,
        THttpChannelDiverterArgs = 1,
        TPFTPChannelParent,
        TPFTPChannelChild,
        T__Last = TPFTPChannelChild
    };

private:
    typedef mozilla::net::HttpChannelDiverterArgs HttpChannelDiverterArgs;
    typedef mozilla::net::PFTPChannelParent PFTPChannelParent;
    typedef mozilla::net::PFTPChannelChild PFTPChannelChild;
    typedef HttpChannelDiverterArgs HttpChannelDiverterArgs__tdef;
    typedef PFTPChannelParent* PFTPChannelParent__tdef;
    typedef PFTPChannelChild* PFTPChannelChild__tdef;

    union Value {
        mozilla::AlignedStorage2<HttpChannelDiverterArgs> VHttpChannelDiverterArgs;
        mozilla::AlignedStorage2<PFTPChannelParent*> VPFTPChannelParent;
        mozilla::AlignedStorage2<PFTPChannelChild*> VPFTPChannelChild;
    };

    HttpChannelDiverterArgs*
    ptr_HttpChannelDiverterArgs()
    {
        return ((mValue).VHttpChannelDiverterArgs).addr();
    }
    const HttpChannelDiverterArgs*
    constptr_HttpChannelDiverterArgs() const
    {
        return ((mValue).VHttpChannelDiverterArgs).addr();
    }
    PFTPChannelParent**
    ptr_PFTPChannelParent()
    {
        return ((mValue).VPFTPChannelParent).addr();
    }
    PFTPChannelParent* const*
    constptr_PFTPChannelParent() const
    {
        return ((mValue).VPFTPChannelParent).addr();
    }
    PFTPChannelChild**
    ptr_PFTPChannelChild()
    {
        return ((mValue).VPFTPChannelChild).addr();
    }
    PFTPChannelChild* const*
    constptr_PFTPChannelChild() const
    {
        return ((mValue).VPFTPChannelChild).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT ChannelDiverterArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT ChannelDiverterArgs(const HttpChannelDiverterArgs& aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(HttpChannelDiverterArgs&& aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(PFTPChannelParent* aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(PFTPChannelChild* aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(const ChannelDiverterArgs& aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(ChannelDiverterArgs&& aOther);

    ~ChannelDiverterArgs();

    Type
    type() const
    {
        return mType;
    }

    ChannelDiverterArgs&
    operator=(const HttpChannelDiverterArgs& aRhs);

    ChannelDiverterArgs&
    operator=(HttpChannelDiverterArgs&& aRhs);

    ChannelDiverterArgs&
    operator=(PFTPChannelParent* aRhs);

    ChannelDiverterArgs&
    operator=(PFTPChannelChild* aRhs);

    ChannelDiverterArgs&
    operator=(const ChannelDiverterArgs& aRhs);

    ChannelDiverterArgs&
    operator=(ChannelDiverterArgs&& aRhs);

    bool
    operator==(const HttpChannelDiverterArgs& aRhs) const;

    bool
    operator==(PFTPChannelParent* aRhs) const;

    bool
    operator==(PFTPChannelChild* aRhs) const;

    bool
    operator==(const ChannelDiverterArgs& aRhs) const;

    HttpChannelDiverterArgs&
    get_HttpChannelDiverterArgs()
    {
        AssertSanity(THttpChannelDiverterArgs);
        return (*(ptr_HttpChannelDiverterArgs()));
    }
    const HttpChannelDiverterArgs&
    get_HttpChannelDiverterArgs() const
    {
        AssertSanity(THttpChannelDiverterArgs);
        return (*(constptr_HttpChannelDiverterArgs()));
    }
    void
    get(HttpChannelDiverterArgs* aOutValue) const;
    operator HttpChannelDiverterArgs&()
    {
        return get_HttpChannelDiverterArgs();
    }
    operator const HttpChannelDiverterArgs&() const
    {
        return get_HttpChannelDiverterArgs();
    }

    PFTPChannelParent*&
    get_PFTPChannelParent()
    {
        AssertSanity(TPFTPChannelParent);
        return (*(ptr_PFTPChannelParent()));
    }
    PFTPChannelParent*
    get_PFTPChannelParent() const
    {
        AssertSanity(TPFTPChannelParent);
        return (*(constptr_PFTPChannelParent()));
    }
    void
    get(PFTPChannelParent** aOutValue) const;
    operator PFTPChannelParent*&()
    {
        return get_PFTPChannelParent();
    }
    operator PFTPChannelParent*() const
    {
        return get_PFTPChannelParent();
    }

    PFTPChannelChild*&
    get_PFTPChannelChild()
    {
        AssertSanity(TPFTPChannelChild);
        return (*(ptr_PFTPChannelChild()));
    }
    PFTPChannelChild*
    get_PFTPChannelChild() const
    {
        AssertSanity(TPFTPChannelChild);
        return (*(constptr_PFTPChannelChild()));
    }
    void
    get(PFTPChannelChild** aOutValue) const;
    operator PFTPChannelChild*&()
    {
        return get_PFTPChannelChild();
    }
    operator PFTPChannelChild*() const
    {
        return get_PFTPChannelChild();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::ChannelDiverterArgs>
{
    typedef mozilla::net::ChannelDiverterArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CookieStruct|
//
namespace mozilla {
namespace net {
class CookieStruct final
{
private:

public:
    MOZ_IMPLICIT CookieStruct() :
        name_(),
        value_(),
        host_(),
        path_(),
        isHttpOnly_(),
        isSession_(),
        isSecure_(),
        expiry_(),
        lastAccessed_(),
        creationTime_(),
        sameSite_()
    {
    }

    MOZ_IMPLICIT CookieStruct(
            const nsCString& _name,
            const nsCString& _value,
            const nsCString& _host,
            const nsCString& _path,
            const int64_t& _expiry,
            const int64_t& _lastAccessed,
            const int64_t& _creationTime,
            const bool& _isHttpOnly,
            const bool& _isSession,
            const bool& _isSecure,
            const int8_t& _sameSite) :
        name_(_name),
        value_(_value),
        host_(_host),
        path_(_path),
        isHttpOnly_(_isHttpOnly),
        isSession_(_isSession),
        isSecure_(_isSecure),
        expiry_(_expiry),
        lastAccessed_(_lastAccessed),
        creationTime_(_creationTime),
        sameSite_(_sameSite)
    {
    }

    bool
    operator==(const CookieStruct& _o) const;

    bool
    operator!=(const CookieStruct& _o) const;

    nsCString&
    name()
    {
        return name_;
    }
    const nsCString&
    name() const
    {
        return name_;
    }

    nsCString&
    value()
    {
        return value_;
    }
    const nsCString&
    value() const
    {
        return value_;
    }

    nsCString&
    host()
    {
        return host_;
    }
    const nsCString&
    host() const
    {
        return host_;
    }

    nsCString&
    path()
    {
        return path_;
    }
    const nsCString&
    path() const
    {
        return path_;
    }

    int64_t&
    expiry()
    {
        return expiry_;
    }
    const int64_t&
    expiry() const
    {
        return expiry_;
    }

    int64_t&
    lastAccessed()
    {
        return lastAccessed_;
    }
    const int64_t&
    lastAccessed() const
    {
        return lastAccessed_;
    }

    int64_t&
    creationTime()
    {
        return creationTime_;
    }
    const int64_t&
    creationTime() const
    {
        return creationTime_;
    }

    bool&
    isHttpOnly()
    {
        return isHttpOnly_;
    }
    const bool&
    isHttpOnly() const
    {
        return isHttpOnly_;
    }

    bool&
    isSession()
    {
        return isSession_;
    }
    const bool&
    isSession() const
    {
        return isSession_;
    }

    bool&
    isSecure()
    {
        return isSecure_;
    }
    const bool&
    isSecure() const
    {
        return isSecure_;
    }

    int8_t&
    sameSite()
    {
        return sameSite_;
    }
    const int8_t&
    sameSite() const
    {
        return sameSite_;
    }

private:
    void
    StaticAssertions() const;
    nsCString name_;
    nsCString value_;
    nsCString host_;
    nsCString path_;
    bool isHttpOnly_;
    bool isSession_;
    bool isSecure_;
    int64_t expiry_;
    int64_t lastAccessed_;
    int64_t creationTime_;
    int8_t sameSite_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::CookieStruct>
{
    typedef mozilla::net::CookieStruct paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef NeckoChannelParams_h
