/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/. */

// See the comment in ServoBindings.h about the same.
#pragma GCC diagnostic push
#ifdef __clang__
#  pragma GCC diagnostic ignored "-Wreturn-type-c-linkage"
#endif

#ifndef mozilla_ServoStyleConsts_h
#define mozilla_ServoStyleConsts_h

/* Generated with cbindgen:0.8.7 */

/* DO NOT MODIFY THIS MANUALLY! This file was generated using cbindgen.
 * To generate this file:
 *   1. Get the latest cbindgen using `cargo install --force cbindgen`
 *      a. Alternatively, you can clone `https://github.com/eqrion/cbindgen` and use a tagged release
 *   2. Run `rustup run nightly cbindgen toolkit/library/rust/ --lockfile Cargo.lock --crate style -o layout/style/ServoStyleConsts.h`
 */


#include <cstdarg>
#include <cstdint>
#include <cstdlib>
#include <new>
#include "mozilla/ServoStyleConstsForwards.h"

namespace mozilla {

/// Whether to allow negative lengths or not.
enum class StyleAllowedNumericType : uint8_t {
  /// Allow all kind of numeric values.
  All,
  /// Allow only non-negative numeric values.
  NonNegative,
  /// Allow only numeric values greater or equal to 1.0.
  AtLeastOne,
};

/// The value for the `appearance` property.
/// https://developer.mozilla.org/en-US/docs/Web/CSS/-moz-appearance
enum class StyleAppearance : uint8_t {
  /// No appearance at all.
  None,
  /// A typical dialog button.
  Button,
  /// Various arrows that go in buttons
  ButtonArrowDown,
  ButtonArrowNext,
  ButtonArrowPrevious,
  ButtonArrowUp,
  /// A rectangular button that contains complex content
  /// like images (e.g. HTML <button> elements)
  ButtonBevel,
  /// The focus outline box inside of a button.
  ButtonFocus,
  /// The caret of a text area
  Caret,
  /// A dual toolbar button (e.g., a Back button with a dropdown)
  Dualbutton,
  /// A groupbox.
  Groupbox,
  /// A inner-spin button.
  InnerSpinButton,
  /// List boxes.
  Listbox,
  /// A listbox item.
  Listitem,
  /// Menu Bar background
  Menubar,
  /// <menu> and <menuitem> appearances
  Menuitem,
  Checkmenuitem,
  Radiomenuitem,
  /// For text on non-iconic menuitems only
  Menuitemtext,
  /// A dropdown list.
  Menulist,
  /// The dropdown button(s) that open up a dropdown list.
  MenulistButton,
  /// The text part of a dropdown list, to left of button.
  MenulistText,
  /// An editable textfield with a dropdown list (a combobox).
  MenulistTextfield,
  /// Menu Popup background.
  Menupopup,
  /// menu checkbox/radio appearances
  Menucheckbox,
  Menuradio,
  Menuseparator,
  Menuarrow,
  /// An image in the menu gutter, like in bookmarks or history.
  Menuimage,
  /// A horizontal meter bar.
  Meter,
  /// The meter bar's meter indicator.
  Meterchunk,
  /// The "arrowed" part of the dropdown button that open up a dropdown list.
  MozMenulistButton,
  /// For HTML's <input type=number>
  NumberInput,
  /// A horizontal progress bar.
  ProgressBar,
  /// The progress bar's progress indicator
  Progresschunk,
  /// A vertical progress bar.
  ProgressbarVertical,
  /// A checkbox element.
  Checkbox,
  /// A radio element within a radio group.
  Radio,
  /// A generic container that always repaints on state changes. This is a
  /// hack to make XUL checkboxes and radio buttons work.
  CheckboxContainer,
  RadioContainer,
  /// The label part of a checkbox or radio button, used for painting a focus
  /// outline.
  CheckboxLabel,
  RadioLabel,
  /// nsRangeFrame and its subparts
  Range,
  RangeThumb,
  /// The resizer background area in a status bar for the resizer widget in
  /// the corner of a window.
  Resizerpanel,
  /// The resizer itself.
  Resizer,
  /// A slider.
  ScaleHorizontal,
  ScaleVertical,
  /// A slider's thumb.
  ScalethumbHorizontal,
  ScalethumbVertical,
  /// If the platform supports it, the left/right chunks of the slider thumb.
  Scalethumbstart,
  Scalethumbend,
  /// The ticks for a slider.
  Scalethumbtick,
  /// A scrollbar.
  Scrollbar,
  /// A small scrollbar.
  ScrollbarSmall,
  /// The scrollbar slider
  ScrollbarHorizontal,
  ScrollbarVertical,
  /// A scrollbar button (up/down/left/right).
  /// Keep these in order (some code casts these values to `int` in order to
  /// compare them against each other).
  ScrollbarbuttonUp,
  ScrollbarbuttonDown,
  ScrollbarbuttonLeft,
  ScrollbarbuttonRight,
  /// The scrollbar thumb.
  ScrollbarthumbHorizontal,
  ScrollbarthumbVertical,
  /// The scrollbar track.
  ScrollbartrackHorizontal,
  ScrollbartrackVertical,
  /// The scroll corner
  Scrollcorner,
  /// A searchfield.
  Searchfield,
  /// A separator.  Can be horizontal or vertical.
  Separator,
  /// A spin control (up/down control for time/date pickers).
  Spinner,
  /// The up button of a spin control.
  SpinnerUpbutton,
  /// The down button of a spin control.
  SpinnerDownbutton,
  /// The textfield of a spin control
  SpinnerTextfield,
  /// A splitter.  Can be horizontal or vertical.
  Splitter,
  /// A status bar in a main application window.
  Statusbar,
  /// A single pane of a status bar.
  Statusbarpanel,
  /// A single tab in a tab widget.
  Tab,
  /// A single pane (inside the tabpanels container).
  Tabpanel,
  /// The tab panels container.
  Tabpanels,
  /// The tabs scroll arrows (left/right).
  TabScrollArrowBack,
  TabScrollArrowForward,
  /// A multi-line text field, e.g. HTML <textarea>.
  Textarea,
  /// A single-line text field, e.g. HTML <input type=text>.
  Textfield,
  /// A toolbar in an application window.
  Toolbar,
  /// A single toolbar button (with no associated dropdown).
  Toolbarbutton,
  /// The dropdown portion of a toolbar button
  ToolbarbuttonDropdown,
  /// The gripper for a toolbar.
  Toolbargripper,
  /// The toolbox that contains the toolbars.
  Toolbox,
  /// A tooltip.
  Tooltip,
  /// A listbox or tree widget header
  Treeheader,
  /// An individual header cell
  Treeheadercell,
  /// The sort arrow for a header.
  Treeheadersortarrow,
  /// A tree item.
  Treeitem,
  /// A tree widget branch line
  Treeline,
  /// A tree widget twisty.
  Treetwisty,
  /// Open tree widget twisty.
  Treetwistyopen,
  /// A tree widget.
  Treeview,
  /// Window and dialog backgrounds.
  Window,
  Dialog,
  /// Vista Rebars.
  MozWinCommunicationsToolbox,
  MozWinMediaToolbox,
  MozWinBrowsertabbarToolbox,
  /// Vista glass.
  MozWinGlass,
  MozWinBorderlessGlass,
  /// -moz-apperance style used in setting proper glass margins.
  MozWinExcludeGlass,
  /// Titlebar elements on the Mac.
  MozMacFullscreenButton,
  /// Mac help button.
  MozMacHelpButton,
  /// Windows themed window frame elements.
  MozWindowButtonBox,
  MozWindowButtonBoxMaximized,
  MozWindowButtonClose,
  MozWindowButtonMaximize,
  MozWindowButtonMinimize,
  MozWindowButtonRestore,
  MozWindowFrameBottom,
  MozWindowFrameLeft,
  MozWindowFrameRight,
  MozWindowTitlebar,
  MozWindowTitlebarMaximized,
  MozGtkInfoBar,
  MozMacActiveSourceListSelection,
  MozMacDisclosureButtonClosed,
  MozMacDisclosureButtonOpen,
  MozMacSourceList,
  MozMacSourceListSelection,
  MozMacVibrancyDark,
  MozMacVibrancyLight,
  MozMacVibrantTitlebarDark,
  MozMacVibrantTitlebarLight,
  /// A non-disappearing scrollbar.
  ScrollbarNonDisappearing,
  /// A themed focus outline (for outline:auto).
  /// This isn't exposed to CSS at all, just here for convenience.
  FocusOutline,
  /// A dummy variant that should be last to let the GTK widget do hackery.
  Count,
};

/// A specified value for a single side of a `border-style` property.
/// The order here corresponds to the integer values from the border conflict
/// resolution rules in CSS 2.1 § 17.6.2.1. Higher values override lower values.
enum class StyleBorderStyle : uint8_t {
  Hidden,
  None,
  Inset,
  Groove,
  Outset,
  Ridge,
  Dotted,
  Dashed,
  Solid,
  Double,
};

/// A kind of break between two boxes.
/// https://drafts.csswg.org/css-break/#break-between
enum class StyleBreakBetween : uint8_t {
  Always,
  Auto,
  Page,
  Avoid,
  Left,
  Right,
};

/// A kind of break within a box.
/// https://drafts.csswg.org/css-break/#break-within
enum class StyleBreakWithin : uint8_t {
  Auto,
  Avoid,
};

/// The keywords allowed in the Cursor property.
/// https://drafts.csswg.org/css-ui-4/#propdef-cursor
enum class StyleCursorKind : uint8_t {
  None,
  Default,
  Pointer,
  ContextMenu,
  Help,
  Progress,
  Wait,
  Cell,
  Crosshair,
  Text,
  VerticalText,
  Alias,
  Copy,
  Move,
  NoDrop,
  NotAllowed,
  Grab,
  Grabbing,
  EResize,
  NResize,
  NeResize,
  NwResize,
  SResize,
  SeResize,
  SwResize,
  WResize,
  EwResize,
  NsResize,
  NeswResize,
  NwseResize,
  ColResize,
  RowResize,
  AllScroll,
  ZoomIn,
  ZoomOut,
  Auto,
};

/// Defines an element’s display type, which consists of
/// the two basic qualities of how an element generates boxes
/// <https://drafts.csswg.org/css-display/#propdef-display>
/// NOTE(emilio): Order is important in Gecko!
/// If you change it, make sure to take a look at the
/// FrameConstructionDataByDisplay stuff (both the XUL and non-XUL version), and
/// ensure it's still correct!
enum class StyleDisplay : uint8_t {
  None = 0,
  Block,
  FlowRoot,
  Inline,
  InlineBlock,
  ListItem,
  Table,
  InlineTable,
  TableRowGroup,
  TableColumn,
  TableColumnGroup,
  TableHeaderGroup,
  TableFooterGroup,
  TableRow,
  TableCell,
  TableCaption,
  Flex,
  InlineFlex,
  Grid,
  InlineGrid,
  Ruby,
  RubyBase,
  RubyBaseContainer,
  RubyText,
  RubyTextContainer,
  Contents,
  WebkitBox,
  WebkitInlineBox,
  MozBox,
  MozInlineBox,
  MozGrid,
  MozInlineGrid,
  MozGridGroup,
  MozGridLine,
  MozStack,
  MozInlineStack,
  MozDeck,
  MozGroupbox,
  MozPopup,
};

/// Values for the display-mode media feature.
enum class StyleDisplayMode : uint8_t {
  Browser = 0,
  MinimalUi,
  Standalone,
  Fullscreen,
};

/// A type for possible values for min- and max- flavors of width, height,
/// block-size, and inline-size.
enum class StyleExtremumLength : uint8_t {
  MaxContent,
  MinContent,
  MozFitContent,
  MozAvailable,
};

enum class StyleFillRule : uint8_t {
  Nonzero,
  Evenodd,
};

/// A computed value for the `float` property.
enum class StyleFloat : uint8_t {
  Left,
  Right,
  None,
};

/// A font-display value for a @font-face rule.
/// The font-display descriptor determines how a font face is displayed based
/// on whether and when it is downloaded and ready to use.
enum class StyleFontDisplay : uint8_t {
  Auto,
  Block,
  Swap,
  Fallback,
  Optional,
};

/// Font family names must either be given quoted as strings,
/// or unquoted as a sequence of one or more identifiers.
enum class StyleFontFamilyNameSyntax : uint8_t {
  /// The family name was specified in a quoted form, e.g. "Font Name"
  /// or 'Font Name'.
  Quoted,
  /// The family name was specified in an unquoted form as a sequence of
  /// identifiers.
  Identifiers,
};

/// A generic font-family name.
/// The order here is important, if you change it make sure that
/// `gfxPlatformFontList.h`s ranged array and `gfxFontFamilyList`'s
/// sSingleGenerics are updated as well.
enum class StyleGenericFontFamily : uint8_t {
  /// No generic family specified, only for internal usage.
  None,
  Serif,
  SansSerif,
  Monospace,
  Cursive,
  Fantasy,
  /// An internal value for emoji font selection.
  MozEmoji,
};

/// The path command absolute type.
enum class StyleIsAbsolute : uint8_t {
  Yes,
  No,
};

enum class StyleIsOrdinalInRange : uint8_t {
  Auto,
  InRange,
  NotInRange,
  NoOrdinalSpecified,
};

/// Specified and computed `-moz-list-reversed` property (for UA sheets only).
enum class StyleMozListReversed : uint8_t {
  /// the initial value
  False,
  /// exclusively used for <ol reversed> in our html.css UA sheet
  True,
};

/// Each style rule has an origin, which determines where it enters the cascade.
/// <https://drafts.csswg.org/css-cascade/#cascading-origins>
enum class StyleOrigin : uint8_t {
  /// <https://drafts.csswg.org/css-cascade/#cascade-origin-user-agent>
  UserAgent = 1,
  /// <https://drafts.csswg.org/css-cascade/#cascade-origin-user>
  User = 2,
  /// <https://drafts.csswg.org/css-cascade/#cascade-origin-author>
  Author = 4,
};

/// The value for the `overflow-x` / `overflow-y` properties.
enum class StyleOverflow : uint8_t {
  Visible,
  Hidden,
  Scroll,
  Auto,
  MozHiddenUnscrollable,
};

enum class StyleOverflowAnchor : uint8_t {
  Auto,
  None,
};

enum class StyleOverflowClipBox : uint8_t {
  PaddingBox,
  ContentBox,
};

/// Values for the `overflow-wrap` property.
enum class StyleOverflowWrap : uint8_t {
  Normal,
  BreakWord,
  Anywhere,
};

enum class StyleOverscrollBehavior : uint8_t {
  Auto,
  Contain,
  None,
};

/// Values for the prefers-color-scheme media feature.
enum class StylePrefersColorScheme : uint8_t {
  Light,
  Dark,
  NoPreference,
};

/// A computed value for the `resize` property.
enum class StyleResize : uint8_t {
  None,
  Both,
  Horizontal,
  Vertical,
};

/// The kind of sanitization to use when parsing a stylesheet.
enum class StyleSanitizationKind : uint8_t {
  /// Perform no sanitization.
  None,
  /// Allow only @font-face, style rules, and @namespace.
  Standard,
  /// Allow everything but conditional rules.
  NoConditionalRules,
};

/// Specified value of scroll-snap-align keyword value.
enum class StyleScrollSnapAlignKeyword : uint8_t {
  None,
  Start,
  End,
  Center,
};

/// https://drafts.csswg.org/css-scroll-snap-1/#snap-axis
enum class StyleScrollSnapAxis : uint8_t {
  X,
  Y,
  Block,
  Inline,
  Both,
};

/// https://drafts.csswg.org/css-scroll-snap-1/#snap-strictness
enum class StyleScrollSnapStrictness : uint8_t {
  None,
  Mandatory,
  Proximity,
};

enum class StyleStepPosition : uint8_t {
  JumpStart,
  JumpEnd,
  JumpNone,
  JumpBoth,
  Start,
  End,
};

/// System colors.
enum class StyleSystemColor : uint8_t {
  WindowBackground,
  WindowForeground,
  WidgetBackground,
  WidgetForeground,
  WidgetSelectBackground,
  WidgetSelectForeground,
  Widget3DHighlight,
  Widget3DShadow,
  TextBackground,
  TextForeground,
  TextSelectBackground,
  TextSelectForeground,
  TextSelectForegroundCustom,
  TextSelectBackgroundDisabled,
  TextSelectBackgroundAttention,
  TextHighlightBackground,
  TextHighlightForeground,
  IMERawInputBackground,
  IMERawInputForeground,
  IMERawInputUnderline,
  IMESelectedRawTextBackground,
  IMESelectedRawTextForeground,
  IMESelectedRawTextUnderline,
  IMEConvertedTextBackground,
  IMEConvertedTextForeground,
  IMEConvertedTextUnderline,
  IMESelectedConvertedTextBackground,
  IMESelectedConvertedTextForeground,
  IMESelectedConvertedTextUnderline,
  SpellCheckerUnderline,
  Activeborder,
  Activecaption,
  Appworkspace,
  Background,
  Buttonface,
  Buttonhighlight,
  Buttonshadow,
  Buttontext,
  Captiontext,
  Graytext,
  Highlight,
  Highlighttext,
  Inactiveborder,
  Inactivecaption,
  Inactivecaptiontext,
  Infobackground,
  Infotext,
  Menu,
  Menutext,
  Scrollbar,
  Threeddarkshadow,
  Threedface,
  Threedhighlight,
  Threedlightshadow,
  Threedshadow,
  Window,
  Windowframe,
  Windowtext,
  MozButtondefault,
  MozField,
  MozFieldtext,
  MozDialog,
  MozDialogtext,
  /// Used to highlight valid regions to drop something onto.
  MozDragtargetzone,
  /// Used for selected but not focused cell backgrounds.
  MozCellhighlight,
  /// Used for selected but not focused cell text.
  MozCellhighlighttext,
  /// Used for selected but not focused html cell backgrounds.
  MozHtmlCellhighlight,
  /// Used for selected but not focused html cell text.
  MozHtmlCellhighlighttext,
  /// Used to button text background when hovered.
  MozButtonhoverface,
  /// Used to button text color when hovered.
  MozButtonhovertext,
  /// Used for menu item backgrounds when hovered.
  MozMenuhover,
  /// Used for menu item text when hovered.
  MozMenuhovertext,
  /// Used for menubar item text.
  MozMenubartext,
  /// Used for menubar item text when hovered.
  MozMenubarhovertext,
  /// On platforms where these colors are the same as -moz-field, use
  /// -moz-fieldtext as foreground color
  MozEventreerow,
  MozOddtreerow,
  /// Used for button text when pressed.
  MozGtkButtonactivetext,
  /// Used for button text when pressed.
  MozMacButtonactivetext,
  /// Background color of chrome toolbars in active windows.
  MozMacChromeActive,
  /// Background color of chrome toolbars in inactive windows.
  MozMacChromeInactive,
  /// Foreground color of default buttons.
  MozMacDefaultbuttontext,
  /// Ring color around text fields and lists.
  MozMacFocusring,
  /// Color used when mouse is over a menu item.
  MozMacMenuselect,
  /// Color used to do shadows on menu items.
  MozMacMenushadow,
  /// Color used to display text for disabled menu items.
  MozMacMenutextdisable,
  /// Color used to display text while mouse is over a menu item.
  MozMacMenutextselect,
  /// Text color of disabled text on toolbars.
  MozMacDisabledtoolbartext,
  /// Inactive light hightlight
  MozMacSecondaryhighlight,
  /// Font smoothing background colors needed by the Mac OS X theme, based on
  /// -moz-appearance names.
  MozMacVibrancyLight,
  MozMacVibrancyDark,
  MozMacVibrantTitlebarLight,
  MozMacVibrantTitlebarDark,
  MozMacMenupopup,
  MozMacMenuitem,
  MozMacActiveMenuitem,
  MozMacSourceList,
  MozMacSourceListSelection,
  MozMacActiveSourceListSelection,
  MozMacTooltip,
  /// Accent color for title bar.
  MozWinAccentcolor,
  /// Color from drawing text over the accent color.
  MozWinAccentcolortext,
  /// Media rebar text.
  MozWinMediatext,
  /// Communications rebar text.
  MozWinCommunicationstext,
  /// Hyperlink color extracted from the system, not affected by the
  /// browser.anchor_color user pref.
  /// There is no OS-specified safe background color for this text, but it is
  /// used regularly within Windows and the Gnome DE on Dialog and Window
  /// colors.
  MozNativehyperlinktext,
  /// Combobox widgets
  MozComboboxtext,
  MozCombobox,
  MozGtkInfoBarText,
  End,
};

/// Specified keyword values for case transforms in the text-transform property. (These are exclusive.)
enum class StyleTextTransformCase {
  /// No case transform.
  None,
  /// All uppercase.
  Uppercase,
  /// All lowercase.
  Lowercase,
  /// Capitalize each word.
  Capitalize,
};

enum class StyleTimingKeyword : uint8_t {
  Linear,
  Ease,
  EaseIn,
  EaseOut,
  EaseInOut,
};

/// The specified value for the `user-select` property.
/// https://drafts.csswg.org/css-ui-4/#propdef-user-select
enum class StyleUserSelect : uint8_t {
  Auto,
  Text,
  None,
  /// Force selection of all children.
  All,
};

enum class StyleVerticalAlignKeyword : uint8_t {
  Baseline,
  Sub,
  Super,
  Top,
  TextTop,
  Middle,
  Bottom,
  TextBottom,
  MozMiddleWithBaseline,
};

/// Values for the `word-break` property.
enum class StyleWordBreak : uint8_t {
  Normal,
  BreakAll,
  KeepAll,
  /// The break-word value, needed for compat.
  /// Specifying `word-break: break-word` makes `overflow-wrap` behave as
  /// `anywhere`, and `word-break` behave like `normal`.
  BreakWord,
};

/// Gecko-FFI-safe Arc (T is an ArcInner).
/// This can be null.
/// Leaks on drop. Please don't drop this.
template<typename GeckoType>
struct StyleStrong {
  const GeckoType *ptr;

  bool operator==(const StyleStrong& other) const {
    return ptr == other.ptr;
  }
  bool operator!=(const StyleStrong& other) const {
    return ptr != other.ptr;
  }
  already_AddRefed<GeckoType> Consume() {
    already_AddRefed<GeckoType> ret(const_cast<GeckoType*>(ptr));
    ptr = nullptr;
    return ret;
  }
};

/// A CSS float value.
using StyleCSSFloat = float;

/// A `<number>` value.
using StyleNumber = StyleCSSFloat;

/// A computed angle in degrees.
struct StyleAngle {
  StyleCSSFloat _0;

  bool operator==(const StyleAngle& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StyleAngle& other) const {
    return _0 != other._0;
  }
  inline static StyleAngle Zero();
  inline float ToDegrees() const;
  inline double ToRadians() const;
};

/// A value of the `Rotate` property
/// <https://drafts.csswg.org/css-transforms-2/#individual-transforms>
template<typename Number, typename Angle>
struct StyleGenericRotate {
  enum class Tag : uint8_t {
    /// 'none'
    None,
    /// '<angle>'
    Rotate,
    /// '<number>{3} <angle>'
    Rotate3D,
  };

  struct StyleRotate_Body {
    Angle _0;

    bool operator==(const StyleRotate_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleRotate_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleRotate3D_Body {
    Number _0;
    Number _1;
    Number _2;
    Angle _3;

    bool operator==(const StyleRotate3D_Body& other) const {
      return _0 == other._0 &&
             _1 == other._1 &&
             _2 == other._2 &&
             _3 == other._3;
    }
    bool operator!=(const StyleRotate3D_Body& other) const {
      return _0 != other._0 ||
             _1 != other._1 ||
             _2 != other._2 ||
             _3 != other._3;
    }
  };

  Tag tag;
  union {
    StyleRotate_Body rotate;
    StyleRotate3D_Body rotate3_d;
  };

  static StyleGenericRotate None() {
    StyleGenericRotate result;
    result.tag = Tag::None;
    return result;
  }

  static StyleGenericRotate Rotate(const Angle &a0) {
    StyleGenericRotate result;
    ::new (&result.rotate._0) (Angle)(a0);
    result.tag = Tag::Rotate;
    return result;
  }

  static StyleGenericRotate Rotate3D(const Number &a0,
                                     const Number &a1,
                                     const Number &a2,
                                     const Angle &a3) {
    StyleGenericRotate result;
    ::new (&result.rotate3_d._0) (Number)(a0);
    ::new (&result.rotate3_d._1) (Number)(a1);
    ::new (&result.rotate3_d._2) (Number)(a2);
    ::new (&result.rotate3_d._3) (Angle)(a3);
    result.tag = Tag::Rotate3D;
    return result;
  }

  bool IsNone() const {
    return tag == Tag::None;
  }

  bool IsRotate() const {
    return tag == Tag::Rotate;
  }

  bool IsRotate3D() const {
    return tag == Tag::Rotate3D;
  }

  const Angle& AsRotate() const {
    MOZ_ASSERT(IsRotate());
    return rotate._0;
  }

  const StyleRotate3D_Body& AsRotate3D() const {
    MOZ_ASSERT(IsRotate3D());
    return rotate3_d;
  }

  bool operator==(const StyleGenericRotate& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Rotate: return rotate == other.rotate;
      case Tag::Rotate3D: return rotate3_d == other.rotate3_d;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericRotate& other) const {
    return !(*this == other);
  }

  ~StyleGenericRotate() {
    switch (tag) {
      case Tag::Rotate: rotate.~StyleRotate_Body(); break;
      case Tag::Rotate3D: rotate3_d.~StyleRotate3D_Body(); break;
      default: break;
    }
  }
};

/// A computed CSS `rotate`
using StyleRotate = StyleGenericRotate<StyleNumber, StyleAngle>;

/// A value of the `Scale` property
/// <https://drafts.csswg.org/css-transforms-2/#individual-transforms>
template<typename Number>
struct StyleGenericScale {
  enum class Tag : uint8_t {
    /// 'none'
    None,
    /// '<number>{1,2}'
    Scale,
    /// '<number>{3}'
    Scale3D,
  };

  struct StyleScale_Body {
    Number _0;
    Number _1;

    bool operator==(const StyleScale_Body& other) const {
      return _0 == other._0 &&
             _1 == other._1;
    }
    bool operator!=(const StyleScale_Body& other) const {
      return _0 != other._0 ||
             _1 != other._1;
    }
  };

  struct StyleScale3D_Body {
    Number _0;
    Number _1;
    Number _2;

    bool operator==(const StyleScale3D_Body& other) const {
      return _0 == other._0 &&
             _1 == other._1 &&
             _2 == other._2;
    }
    bool operator!=(const StyleScale3D_Body& other) const {
      return _0 != other._0 ||
             _1 != other._1 ||
             _2 != other._2;
    }
  };

  Tag tag;
  union {
    StyleScale_Body scale;
    StyleScale3D_Body scale3_d;
  };

  static StyleGenericScale None() {
    StyleGenericScale result;
    result.tag = Tag::None;
    return result;
  }

  static StyleGenericScale Scale(const Number &a0,
                                 const Number &a1) {
    StyleGenericScale result;
    ::new (&result.scale._0) (Number)(a0);
    ::new (&result.scale._1) (Number)(a1);
    result.tag = Tag::Scale;
    return result;
  }

  static StyleGenericScale Scale3D(const Number &a0,
                                   const Number &a1,
                                   const Number &a2) {
    StyleGenericScale result;
    ::new (&result.scale3_d._0) (Number)(a0);
    ::new (&result.scale3_d._1) (Number)(a1);
    ::new (&result.scale3_d._2) (Number)(a2);
    result.tag = Tag::Scale3D;
    return result;
  }

  bool IsNone() const {
    return tag == Tag::None;
  }

  bool IsScale() const {
    return tag == Tag::Scale;
  }

  bool IsScale3D() const {
    return tag == Tag::Scale3D;
  }

  const StyleScale_Body& AsScale() const {
    MOZ_ASSERT(IsScale());
    return scale;
  }

  const StyleScale3D_Body& AsScale3D() const {
    MOZ_ASSERT(IsScale3D());
    return scale3_d;
  }

  bool operator==(const StyleGenericScale& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Scale: return scale == other.scale;
      case Tag::Scale3D: return scale3_d == other.scale3_d;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericScale& other) const {
    return !(*this == other);
  }

  ~StyleGenericScale() {
    switch (tag) {
      case Tag::Scale: scale.~StyleScale_Body(); break;
      case Tag::Scale3D: scale3_d.~StyleScale3D_Body(); break;
      default: break;
    }
  }
};

/// A computed CSS `scale`
using StyleScale = StyleGenericScale<StyleNumber>;

/// The computed `<length>` value.
struct StyleCSSPixelLength {
  StyleCSSFloat _0;

  bool operator==(const StyleCSSPixelLength& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StyleCSSPixelLength& other) const {
    return _0 != other._0;
  }
  inline nscoord ToAppUnits() const;
  inline bool IsZero() const;
  float ToCSSPixels() const { return _0; }
};

/// An alias of computed `<length>` value.
using StyleLength = StyleCSSPixelLength;

/// A CSS integer value.
using StyleCSSInteger = int32_t;

/// A `<integer>` value.
using StyleInteger = StyleCSSInteger;

/// A computed percentage.
struct StylePercentage {
  StyleCSSFloat _0;

  bool operator==(const StylePercentage& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StylePercentage& other) const {
    return _0 != other._0;
  }
};

/// A `<length-percentage>` value. This can be either a `<length>`, a
/// `<percentage>`, or a combination of both via `calc()`.
/// https://drafts.csswg.org/css-values-4/#typedef-length-percentage
struct StyleLengthPercentage {
  StyleLength length;
  StylePercentage percentage;
  StyleAllowedNumericType clamping_mode;
  /// Whether we specified a percentage or not.
  bool has_percentage;
  /// Whether this was from a calc() expression. This is needed because right
  /// now we don't treat calc() the same way as non-calc everywhere, but
  /// that's a bug in most cases.
  /// Please don't add new uses of this that aren't for converting to Gecko's
  /// representation, or to interpolate values.
  /// See https://github.com/w3c/csswg-drafts/issues/3482.
  bool was_calc;

  bool operator==(const StyleLengthPercentage& other) const {
    return length == other.length &&
           percentage == other.percentage &&
           clamping_mode == other.clamping_mode &&
           has_percentage == other.has_percentage &&
           was_calc == other.was_calc;
  }
  bool operator!=(const StyleLengthPercentage& other) const {
    return length != other.length ||
           percentage != other.percentage ||
           clamping_mode != other.clamping_mode ||
           has_percentage != other.has_percentage ||
           was_calc != other.was_calc;
  }
  // Defined in nsStyleCoord.h
  static constexpr inline StyleLengthPercentage Zero();
  static inline StyleLengthPercentage FromAppUnits(nscoord);
  static inline StyleLengthPercentage FromPixels(CSSCoord);
  static inline StyleLengthPercentage FromPercentage(float);
  inline CSSCoord LengthInCSSPixels() const;
  inline float Percentage() const;
  inline bool HasPercent() const;
  inline bool ConvertsToLength() const;
  inline nscoord ToLength() const;
  inline bool ConvertsToPercentage() const;
  inline bool HasLengthAndPercentage() const;
  inline float ToPercentage() const;
  inline bool IsDefinitelyZero() const;
  inline CSSCoord ResolveToCSSPixels(CSSCoord aPercentageBasisInCSSPixels) const;
  template<typename T> inline CSSCoord ResolveToCSSPixelsWith(T aPercentageGetter) const;
  template<typename T, typename U>
  inline nscoord Resolve(T aPercentageGetter, U aPercentRoundingFunction) const;
  template<typename T>
  inline nscoord Resolve(nscoord aPercentageBasis, T aPercentRoundingFunction) const;
  template<typename T> inline nscoord Resolve(T aPercentageGetter) const;
  inline nscoord Resolve(nscoord aPercentageBasis) const;
};

/// A generic 2D transformation matrix.
template<typename T>
struct StyleGenericMatrix {
  T a;
  T b;
  T c;
  T d;
  T e;
  T f;

  bool operator==(const StyleGenericMatrix& other) const {
    return a == other.a &&
           b == other.b &&
           c == other.c &&
           d == other.d &&
           e == other.e &&
           f == other.f;
  }
  bool operator!=(const StyleGenericMatrix& other) const {
    return a != other.a ||
           b != other.b ||
           c != other.c ||
           d != other.d ||
           e != other.e ||
           f != other.f;
  }
};

template<typename T>
struct StyleGenericMatrix3D {
  T m11;
  T m12;
  T m13;
  T m14;
  T m21;
  T m22;
  T m23;
  T m24;
  T m31;
  T m32;
  T m33;
  T m34;
  T m41;
  T m42;
  T m43;
  T m44;

  bool operator==(const StyleGenericMatrix3D& other) const {
    return m11 == other.m11 &&
           m12 == other.m12 &&
           m13 == other.m13 &&
           m14 == other.m14 &&
           m21 == other.m21 &&
           m22 == other.m22 &&
           m23 == other.m23 &&
           m24 == other.m24 &&
           m31 == other.m31 &&
           m32 == other.m32 &&
           m33 == other.m33 &&
           m34 == other.m34 &&
           m41 == other.m41 &&
           m42 == other.m42 &&
           m43 == other.m43 &&
           m44 == other.m44;
  }
  bool operator!=(const StyleGenericMatrix3D& other) const {
    return m11 != other.m11 ||
           m12 != other.m12 ||
           m13 != other.m13 ||
           m14 != other.m14 ||
           m21 != other.m21 ||
           m22 != other.m22 ||
           m23 != other.m23 ||
           m24 != other.m24 ||
           m31 != other.m31 ||
           m32 != other.m32 ||
           m33 != other.m33 ||
           m34 != other.m34 ||
           m41 != other.m41 ||
           m42 != other.m42 ||
           m43 != other.m43 ||
           m44 != other.m44;
  }
};

/// A struct that basically replaces a `Box<[T]>`, but which cbindgen can
/// understand.
/// We could rely on the struct layout of `Box<[T]>` per:
/// https://github.com/rust-lang/unsafe-code-guidelines/blob/master/reference/src/layout/pointers.md
/// But handling fat pointers with cbindgen both in structs and argument
/// positions more generally is a bit tricky.
template<typename T>
struct StyleOwnedSlice {
  T *ptr;
  uintptr_t len;
  StyleOwnedSlice() :
    ptr((T*)alignof(T)),
    len(0) {}

  // Should be easily implementable if wanted, but the default implementation would leak.
  StyleOwnedSlice& operator=(const StyleOwnedSlice&) = delete;
  StyleOwnedSlice& operator=(StyleOwnedSlice&&) = delete;

  inline StyleOwnedSlice(const StyleOwnedSlice&);
  inline StyleOwnedSlice(StyleOwnedSlice&&);

  inline void Clear();

  inline ~StyleOwnedSlice();

  Span<const T> AsSpan() const {
    return MakeSpan(ptr, len);
  }

  size_t Length() const {
    return AsSpan().Length();
  }

  bool IsEmpty() const { return Length() == 0; }

  bool operator==(const StyleOwnedSlice& other) const {
    return AsSpan() == other.AsSpan();
  }

  bool operator!=(const StyleOwnedSlice& other) const {
    return !(*this == other);
  }
};

/// A value of the `transform` property
template<typename T>
struct StyleGenericTransform {
  StyleOwnedSlice<T> _0;

  bool operator==(const StyleGenericTransform& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StyleGenericTransform& other) const {
    return _0 != other._0;
  }
  inline Span<const T> Operations() const;
  inline bool IsNone() const;
};

/// A single operation in the list of a `transform` value
template<typename Angle, typename Number, typename Length, typename Integer, typename LengthPercentage>
struct StyleGenericTransformOperation {
  enum class Tag : uint8_t {
    /// Represents a 2D 2x3 matrix.
    Matrix,
    /// Represents a 3D 4x4 matrix.
    Matrix3D,
    /// A 2D skew.
    /// If the second angle is not provided it is assumed zero.
    /// Syntax can be skew(angle) or skew(angle, angle)
    Skew,
    /// skewX(angle)
    SkewX,
    /// skewY(angle)
    SkewY,
    /// translate(x, y) or translate(x)
    Translate,
    /// translateX(x)
    TranslateX,
    /// translateY(y)
    TranslateY,
    /// translateZ(z)
    TranslateZ,
    /// translate3d(x, y, z)
    Translate3D,
    /// A 2D scaling factor.
    /// Syntax can be scale(factor) or scale(factor, factor)
    Scale,
    /// scaleX(factor)
    ScaleX,
    /// scaleY(factor)
    ScaleY,
    /// scaleZ(factor)
    ScaleZ,
    /// scale3D(factorX, factorY, factorZ)
    Scale3D,
    /// Describes a 2D Rotation.
    /// In a 3D scene `rotate(angle)` is equivalent to `rotateZ(angle)`.
    Rotate,
    /// Rotation in 3D space around the x-axis.
    RotateX,
    /// Rotation in 3D space around the y-axis.
    RotateY,
    /// Rotation in 3D space around the z-axis.
    RotateZ,
    /// Rotation in 3D space.
    /// Generalization of rotateX, rotateY and rotateZ.
    Rotate3D,
    /// Specifies a perspective projection matrix.
    /// Part of CSS Transform Module Level 2 and defined at
    /// [§ 13.1. 3D Transform Function](https://drafts.csswg.org/css-transforms-2/#funcdef-perspective).
    /// The value must be greater than or equal to zero.
    Perspective,
    /// A intermediate type for interpolation of mismatched transform lists.
    InterpolateMatrix,
    /// A intermediate type for accumulation of mismatched transform lists.
    AccumulateMatrix,
  };

  struct StyleMatrix_Body {
    StyleGenericMatrix<Number> _0;

    bool operator==(const StyleMatrix_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleMatrix_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleMatrix3D_Body {
    StyleGenericMatrix3D<Number> _0;

    bool operator==(const StyleMatrix3D_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleMatrix3D_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleSkew_Body {
    Angle _0;
    Angle _1;

    bool operator==(const StyleSkew_Body& other) const {
      return _0 == other._0 &&
             _1 == other._1;
    }
    bool operator!=(const StyleSkew_Body& other) const {
      return _0 != other._0 ||
             _1 != other._1;
    }
  };

  struct StyleSkewX_Body {
    Angle _0;

    bool operator==(const StyleSkewX_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleSkewX_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleSkewY_Body {
    Angle _0;

    bool operator==(const StyleSkewY_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleSkewY_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleTranslate_Body {
    LengthPercentage _0;
    LengthPercentage _1;

    bool operator==(const StyleTranslate_Body& other) const {
      return _0 == other._0 &&
             _1 == other._1;
    }
    bool operator!=(const StyleTranslate_Body& other) const {
      return _0 != other._0 ||
             _1 != other._1;
    }
  };

  struct StyleTranslateX_Body {
    LengthPercentage _0;

    bool operator==(const StyleTranslateX_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleTranslateX_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleTranslateY_Body {
    LengthPercentage _0;

    bool operator==(const StyleTranslateY_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleTranslateY_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleTranslateZ_Body {
    Length _0;

    bool operator==(const StyleTranslateZ_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleTranslateZ_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleTranslate3D_Body {
    LengthPercentage _0;
    LengthPercentage _1;
    Length _2;

    bool operator==(const StyleTranslate3D_Body& other) const {
      return _0 == other._0 &&
             _1 == other._1 &&
             _2 == other._2;
    }
    bool operator!=(const StyleTranslate3D_Body& other) const {
      return _0 != other._0 ||
             _1 != other._1 ||
             _2 != other._2;
    }
  };

  struct StyleScale_Body {
    Number _0;
    Number _1;

    bool operator==(const StyleScale_Body& other) const {
      return _0 == other._0 &&
             _1 == other._1;
    }
    bool operator!=(const StyleScale_Body& other) const {
      return _0 != other._0 ||
             _1 != other._1;
    }
  };

  struct StyleScaleX_Body {
    Number _0;

    bool operator==(const StyleScaleX_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleScaleX_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleScaleY_Body {
    Number _0;

    bool operator==(const StyleScaleY_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleScaleY_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleScaleZ_Body {
    Number _0;

    bool operator==(const StyleScaleZ_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleScaleZ_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleScale3D_Body {
    Number _0;
    Number _1;
    Number _2;

    bool operator==(const StyleScale3D_Body& other) const {
      return _0 == other._0 &&
             _1 == other._1 &&
             _2 == other._2;
    }
    bool operator!=(const StyleScale3D_Body& other) const {
      return _0 != other._0 ||
             _1 != other._1 ||
             _2 != other._2;
    }
  };

  struct StyleRotate_Body {
    Angle _0;

    bool operator==(const StyleRotate_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleRotate_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleRotateX_Body {
    Angle _0;

    bool operator==(const StyleRotateX_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleRotateX_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleRotateY_Body {
    Angle _0;

    bool operator==(const StyleRotateY_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleRotateY_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleRotateZ_Body {
    Angle _0;

    bool operator==(const StyleRotateZ_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleRotateZ_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleRotate3D_Body {
    Number _0;
    Number _1;
    Number _2;
    Angle _3;

    bool operator==(const StyleRotate3D_Body& other) const {
      return _0 == other._0 &&
             _1 == other._1 &&
             _2 == other._2 &&
             _3 == other._3;
    }
    bool operator!=(const StyleRotate3D_Body& other) const {
      return _0 != other._0 ||
             _1 != other._1 ||
             _2 != other._2 ||
             _3 != other._3;
    }
  };

  struct StylePerspective_Body {
    Length _0;

    bool operator==(const StylePerspective_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StylePerspective_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleInterpolateMatrix_Body {
    StyleGenericTransform<StyleGenericTransformOperation<Angle, Number, Length, Integer, LengthPercentage>> from_list;
    StyleGenericTransform<StyleGenericTransformOperation<Angle, Number, Length, Integer, LengthPercentage>> to_list;
    StylePercentage progress;

    bool operator==(const StyleInterpolateMatrix_Body& other) const {
      return from_list == other.from_list &&
             to_list == other.to_list &&
             progress == other.progress;
    }
    bool operator!=(const StyleInterpolateMatrix_Body& other) const {
      return from_list != other.from_list ||
             to_list != other.to_list ||
             progress != other.progress;
    }
  };

  struct StyleAccumulateMatrix_Body {
    StyleGenericTransform<StyleGenericTransformOperation<Angle, Number, Length, Integer, LengthPercentage>> from_list;
    StyleGenericTransform<StyleGenericTransformOperation<Angle, Number, Length, Integer, LengthPercentage>> to_list;
    Integer count;

    bool operator==(const StyleAccumulateMatrix_Body& other) const {
      return from_list == other.from_list &&
             to_list == other.to_list &&
             count == other.count;
    }
    bool operator!=(const StyleAccumulateMatrix_Body& other) const {
      return from_list != other.from_list ||
             to_list != other.to_list ||
             count != other.count;
    }
  };

  Tag tag;
  union {
    StyleMatrix_Body matrix;
    StyleMatrix3D_Body matrix3_d;
    StyleSkew_Body skew;
    StyleSkewX_Body skew_x;
    StyleSkewY_Body skew_y;
    StyleTranslate_Body translate;
    StyleTranslateX_Body translate_x;
    StyleTranslateY_Body translate_y;
    StyleTranslateZ_Body translate_z;
    StyleTranslate3D_Body translate3_d;
    StyleScale_Body scale;
    StyleScaleX_Body scale_x;
    StyleScaleY_Body scale_y;
    StyleScaleZ_Body scale_z;
    StyleScale3D_Body scale3_d;
    StyleRotate_Body rotate;
    StyleRotateX_Body rotate_x;
    StyleRotateY_Body rotate_y;
    StyleRotateZ_Body rotate_z;
    StyleRotate3D_Body rotate3_d;
    StylePerspective_Body perspective;
    StyleInterpolateMatrix_Body interpolate_matrix;
    StyleAccumulateMatrix_Body accumulate_matrix;
  };

  static StyleGenericTransformOperation Matrix(const StyleGenericMatrix<Number> &a0) {
    StyleGenericTransformOperation result;
    ::new (&result.matrix._0) (StyleGenericMatrix<Number>)(a0);
    result.tag = Tag::Matrix;
    return result;
  }

  static StyleGenericTransformOperation Matrix3D(const StyleGenericMatrix3D<Number> &a0) {
    StyleGenericTransformOperation result;
    ::new (&result.matrix3_d._0) (StyleGenericMatrix3D<Number>)(a0);
    result.tag = Tag::Matrix3D;
    return result;
  }

  static StyleGenericTransformOperation Skew(const Angle &a0,
                                             const Angle &a1) {
    StyleGenericTransformOperation result;
    ::new (&result.skew._0) (Angle)(a0);
    ::new (&result.skew._1) (Angle)(a1);
    result.tag = Tag::Skew;
    return result;
  }

  static StyleGenericTransformOperation SkewX(const Angle &a0) {
    StyleGenericTransformOperation result;
    ::new (&result.skew_x._0) (Angle)(a0);
    result.tag = Tag::SkewX;
    return result;
  }

  static StyleGenericTransformOperation SkewY(const Angle &a0) {
    StyleGenericTransformOperation result;
    ::new (&result.skew_y._0) (Angle)(a0);
    result.tag = Tag::SkewY;
    return result;
  }

  static StyleGenericTransformOperation Translate(const LengthPercentage &a0,
                                                  const LengthPercentage &a1) {
    StyleGenericTransformOperation result;
    ::new (&result.translate._0) (LengthPercentage)(a0);
    ::new (&result.translate._1) (LengthPercentage)(a1);
    result.tag = Tag::Translate;
    return result;
  }

  static StyleGenericTransformOperation TranslateX(const LengthPercentage &a0) {
    StyleGenericTransformOperation result;
    ::new (&result.translate_x._0) (LengthPercentage)(a0);
    result.tag = Tag::TranslateX;
    return result;
  }

  static StyleGenericTransformOperation TranslateY(const LengthPercentage &a0) {
    StyleGenericTransformOperation result;
    ::new (&result.translate_y._0) (LengthPercentage)(a0);
    result.tag = Tag::TranslateY;
    return result;
  }

  static StyleGenericTransformOperation TranslateZ(const Length &a0) {
    StyleGenericTransformOperation result;
    ::new (&result.translate_z._0) (Length)(a0);
    result.tag = Tag::TranslateZ;
    return result;
  }

  static StyleGenericTransformOperation Translate3D(const LengthPercentage &a0,
                                                    const LengthPercentage &a1,
                                                    const Length &a2) {
    StyleGenericTransformOperation result;
    ::new (&result.translate3_d._0) (LengthPercentage)(a0);
    ::new (&result.translate3_d._1) (LengthPercentage)(a1);
    ::new (&result.translate3_d._2) (Length)(a2);
    result.tag = Tag::Translate3D;
    return result;
  }

  static StyleGenericTransformOperation Scale(const Number &a0,
                                              const Number &a1) {
    StyleGenericTransformOperation result;
    ::new (&result.scale._0) (Number)(a0);
    ::new (&result.scale._1) (Number)(a1);
    result.tag = Tag::Scale;
    return result;
  }

  static StyleGenericTransformOperation ScaleX(const Number &a0) {
    StyleGenericTransformOperation result;
    ::new (&result.scale_x._0) (Number)(a0);
    result.tag = Tag::ScaleX;
    return result;
  }

  static StyleGenericTransformOperation ScaleY(const Number &a0) {
    StyleGenericTransformOperation result;
    ::new (&result.scale_y._0) (Number)(a0);
    result.tag = Tag::ScaleY;
    return result;
  }

  static StyleGenericTransformOperation ScaleZ(const Number &a0) {
    StyleGenericTransformOperation result;
    ::new (&result.scale_z._0) (Number)(a0);
    result.tag = Tag::ScaleZ;
    return result;
  }

  static StyleGenericTransformOperation Scale3D(const Number &a0,
                                                const Number &a1,
                                                const Number &a2) {
    StyleGenericTransformOperation result;
    ::new (&result.scale3_d._0) (Number)(a0);
    ::new (&result.scale3_d._1) (Number)(a1);
    ::new (&result.scale3_d._2) (Number)(a2);
    result.tag = Tag::Scale3D;
    return result;
  }

  static StyleGenericTransformOperation Rotate(const Angle &a0) {
    StyleGenericTransformOperation result;
    ::new (&result.rotate._0) (Angle)(a0);
    result.tag = Tag::Rotate;
    return result;
  }

  static StyleGenericTransformOperation RotateX(const Angle &a0) {
    StyleGenericTransformOperation result;
    ::new (&result.rotate_x._0) (Angle)(a0);
    result.tag = Tag::RotateX;
    return result;
  }

  static StyleGenericTransformOperation RotateY(const Angle &a0) {
    StyleGenericTransformOperation result;
    ::new (&result.rotate_y._0) (Angle)(a0);
    result.tag = Tag::RotateY;
    return result;
  }

  static StyleGenericTransformOperation RotateZ(const Angle &a0) {
    StyleGenericTransformOperation result;
    ::new (&result.rotate_z._0) (Angle)(a0);
    result.tag = Tag::RotateZ;
    return result;
  }

  static StyleGenericTransformOperation Rotate3D(const Number &a0,
                                                 const Number &a1,
                                                 const Number &a2,
                                                 const Angle &a3) {
    StyleGenericTransformOperation result;
    ::new (&result.rotate3_d._0) (Number)(a0);
    ::new (&result.rotate3_d._1) (Number)(a1);
    ::new (&result.rotate3_d._2) (Number)(a2);
    ::new (&result.rotate3_d._3) (Angle)(a3);
    result.tag = Tag::Rotate3D;
    return result;
  }

  static StyleGenericTransformOperation Perspective(const Length &a0) {
    StyleGenericTransformOperation result;
    ::new (&result.perspective._0) (Length)(a0);
    result.tag = Tag::Perspective;
    return result;
  }

  static StyleGenericTransformOperation InterpolateMatrix(const StyleGenericTransform<StyleGenericTransformOperation<Angle, Number, Length, Integer, LengthPercentage>> &aFromList,
                                                          const StyleGenericTransform<StyleGenericTransformOperation<Angle, Number, Length, Integer, LengthPercentage>> &aToList,
                                                          const StylePercentage &aProgress) {
    StyleGenericTransformOperation result;
    ::new (&result.interpolate_matrix.from_list) (StyleGenericTransform<StyleGenericTransformOperation<Angle, Number, Length, Integer, LengthPercentage>>)(aFromList);
    ::new (&result.interpolate_matrix.to_list) (StyleGenericTransform<StyleGenericTransformOperation<Angle, Number, Length, Integer, LengthPercentage>>)(aToList);
    ::new (&result.interpolate_matrix.progress) (StylePercentage)(aProgress);
    result.tag = Tag::InterpolateMatrix;
    return result;
  }

  static StyleGenericTransformOperation AccumulateMatrix(const StyleGenericTransform<StyleGenericTransformOperation<Angle, Number, Length, Integer, LengthPercentage>> &aFromList,
                                                         const StyleGenericTransform<StyleGenericTransformOperation<Angle, Number, Length, Integer, LengthPercentage>> &aToList,
                                                         const Integer &aCount) {
    StyleGenericTransformOperation result;
    ::new (&result.accumulate_matrix.from_list) (StyleGenericTransform<StyleGenericTransformOperation<Angle, Number, Length, Integer, LengthPercentage>>)(aFromList);
    ::new (&result.accumulate_matrix.to_list) (StyleGenericTransform<StyleGenericTransformOperation<Angle, Number, Length, Integer, LengthPercentage>>)(aToList);
    ::new (&result.accumulate_matrix.count) (Integer)(aCount);
    result.tag = Tag::AccumulateMatrix;
    return result;
  }

  bool IsMatrix() const {
    return tag == Tag::Matrix;
  }

  bool IsMatrix3D() const {
    return tag == Tag::Matrix3D;
  }

  bool IsSkew() const {
    return tag == Tag::Skew;
  }

  bool IsSkewX() const {
    return tag == Tag::SkewX;
  }

  bool IsSkewY() const {
    return tag == Tag::SkewY;
  }

  bool IsTranslate() const {
    return tag == Tag::Translate;
  }

  bool IsTranslateX() const {
    return tag == Tag::TranslateX;
  }

  bool IsTranslateY() const {
    return tag == Tag::TranslateY;
  }

  bool IsTranslateZ() const {
    return tag == Tag::TranslateZ;
  }

  bool IsTranslate3D() const {
    return tag == Tag::Translate3D;
  }

  bool IsScale() const {
    return tag == Tag::Scale;
  }

  bool IsScaleX() const {
    return tag == Tag::ScaleX;
  }

  bool IsScaleY() const {
    return tag == Tag::ScaleY;
  }

  bool IsScaleZ() const {
    return tag == Tag::ScaleZ;
  }

  bool IsScale3D() const {
    return tag == Tag::Scale3D;
  }

  bool IsRotate() const {
    return tag == Tag::Rotate;
  }

  bool IsRotateX() const {
    return tag == Tag::RotateX;
  }

  bool IsRotateY() const {
    return tag == Tag::RotateY;
  }

  bool IsRotateZ() const {
    return tag == Tag::RotateZ;
  }

  bool IsRotate3D() const {
    return tag == Tag::Rotate3D;
  }

  bool IsPerspective() const {
    return tag == Tag::Perspective;
  }

  bool IsInterpolateMatrix() const {
    return tag == Tag::InterpolateMatrix;
  }

  bool IsAccumulateMatrix() const {
    return tag == Tag::AccumulateMatrix;
  }

  const StyleGenericMatrix<Number>& AsMatrix() const {
    MOZ_ASSERT(IsMatrix());
    return matrix._0;
  }

  const StyleGenericMatrix3D<Number>& AsMatrix3D() const {
    MOZ_ASSERT(IsMatrix3D());
    return matrix3_d._0;
  }

  const StyleSkew_Body& AsSkew() const {
    MOZ_ASSERT(IsSkew());
    return skew;
  }

  const Angle& AsSkewX() const {
    MOZ_ASSERT(IsSkewX());
    return skew_x._0;
  }

  const Angle& AsSkewY() const {
    MOZ_ASSERT(IsSkewY());
    return skew_y._0;
  }

  const StyleTranslate_Body& AsTranslate() const {
    MOZ_ASSERT(IsTranslate());
    return translate;
  }

  const LengthPercentage& AsTranslateX() const {
    MOZ_ASSERT(IsTranslateX());
    return translate_x._0;
  }

  const LengthPercentage& AsTranslateY() const {
    MOZ_ASSERT(IsTranslateY());
    return translate_y._0;
  }

  const Length& AsTranslateZ() const {
    MOZ_ASSERT(IsTranslateZ());
    return translate_z._0;
  }

  const StyleTranslate3D_Body& AsTranslate3D() const {
    MOZ_ASSERT(IsTranslate3D());
    return translate3_d;
  }

  const StyleScale_Body& AsScale() const {
    MOZ_ASSERT(IsScale());
    return scale;
  }

  const Number& AsScaleX() const {
    MOZ_ASSERT(IsScaleX());
    return scale_x._0;
  }

  const Number& AsScaleY() const {
    MOZ_ASSERT(IsScaleY());
    return scale_y._0;
  }

  const Number& AsScaleZ() const {
    MOZ_ASSERT(IsScaleZ());
    return scale_z._0;
  }

  const StyleScale3D_Body& AsScale3D() const {
    MOZ_ASSERT(IsScale3D());
    return scale3_d;
  }

  const Angle& AsRotate() const {
    MOZ_ASSERT(IsRotate());
    return rotate._0;
  }

  const Angle& AsRotateX() const {
    MOZ_ASSERT(IsRotateX());
    return rotate_x._0;
  }

  const Angle& AsRotateY() const {
    MOZ_ASSERT(IsRotateY());
    return rotate_y._0;
  }

  const Angle& AsRotateZ() const {
    MOZ_ASSERT(IsRotateZ());
    return rotate_z._0;
  }

  const StyleRotate3D_Body& AsRotate3D() const {
    MOZ_ASSERT(IsRotate3D());
    return rotate3_d;
  }

  const Length& AsPerspective() const {
    MOZ_ASSERT(IsPerspective());
    return perspective._0;
  }

  const StyleInterpolateMatrix_Body& AsInterpolateMatrix() const {
    MOZ_ASSERT(IsInterpolateMatrix());
    return interpolate_matrix;
  }

  const StyleAccumulateMatrix_Body& AsAccumulateMatrix() const {
    MOZ_ASSERT(IsAccumulateMatrix());
    return accumulate_matrix;
  }

  bool operator==(const StyleGenericTransformOperation& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Matrix: return matrix == other.matrix;
      case Tag::Matrix3D: return matrix3_d == other.matrix3_d;
      case Tag::Skew: return skew == other.skew;
      case Tag::SkewX: return skew_x == other.skew_x;
      case Tag::SkewY: return skew_y == other.skew_y;
      case Tag::Translate: return translate == other.translate;
      case Tag::TranslateX: return translate_x == other.translate_x;
      case Tag::TranslateY: return translate_y == other.translate_y;
      case Tag::TranslateZ: return translate_z == other.translate_z;
      case Tag::Translate3D: return translate3_d == other.translate3_d;
      case Tag::Scale: return scale == other.scale;
      case Tag::ScaleX: return scale_x == other.scale_x;
      case Tag::ScaleY: return scale_y == other.scale_y;
      case Tag::ScaleZ: return scale_z == other.scale_z;
      case Tag::Scale3D: return scale3_d == other.scale3_d;
      case Tag::Rotate: return rotate == other.rotate;
      case Tag::RotateX: return rotate_x == other.rotate_x;
      case Tag::RotateY: return rotate_y == other.rotate_y;
      case Tag::RotateZ: return rotate_z == other.rotate_z;
      case Tag::Rotate3D: return rotate3_d == other.rotate3_d;
      case Tag::Perspective: return perspective == other.perspective;
      case Tag::InterpolateMatrix: return interpolate_matrix == other.interpolate_matrix;
      case Tag::AccumulateMatrix: return accumulate_matrix == other.accumulate_matrix;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericTransformOperation& other) const {
    return !(*this == other);
  }

  ~StyleGenericTransformOperation() {
    switch (tag) {
      case Tag::Matrix: matrix.~StyleMatrix_Body(); break;
      case Tag::Matrix3D: matrix3_d.~StyleMatrix3D_Body(); break;
      case Tag::Skew: skew.~StyleSkew_Body(); break;
      case Tag::SkewX: skew_x.~StyleSkewX_Body(); break;
      case Tag::SkewY: skew_y.~StyleSkewY_Body(); break;
      case Tag::Translate: translate.~StyleTranslate_Body(); break;
      case Tag::TranslateX: translate_x.~StyleTranslateX_Body(); break;
      case Tag::TranslateY: translate_y.~StyleTranslateY_Body(); break;
      case Tag::TranslateZ: translate_z.~StyleTranslateZ_Body(); break;
      case Tag::Translate3D: translate3_d.~StyleTranslate3D_Body(); break;
      case Tag::Scale: scale.~StyleScale_Body(); break;
      case Tag::ScaleX: scale_x.~StyleScaleX_Body(); break;
      case Tag::ScaleY: scale_y.~StyleScaleY_Body(); break;
      case Tag::ScaleZ: scale_z.~StyleScaleZ_Body(); break;
      case Tag::Scale3D: scale3_d.~StyleScale3D_Body(); break;
      case Tag::Rotate: rotate.~StyleRotate_Body(); break;
      case Tag::RotateX: rotate_x.~StyleRotateX_Body(); break;
      case Tag::RotateY: rotate_y.~StyleRotateY_Body(); break;
      case Tag::RotateZ: rotate_z.~StyleRotateZ_Body(); break;
      case Tag::Rotate3D: rotate3_d.~StyleRotate3D_Body(); break;
      case Tag::Perspective: perspective.~StylePerspective_Body(); break;
      case Tag::InterpolateMatrix: interpolate_matrix.~StyleInterpolateMatrix_Body(); break;
      case Tag::AccumulateMatrix: accumulate_matrix.~StyleAccumulateMatrix_Body(); break;
      default: break;
    }
  }

  StyleGenericTransformOperation(const StyleGenericTransformOperation& other)
   : tag(other.tag) {
    switch (tag) {
      case Tag::Matrix: ::new (&matrix) (StyleMatrix_Body)(other.matrix); break;
      case Tag::Matrix3D: ::new (&matrix3_d) (StyleMatrix3D_Body)(other.matrix3_d); break;
      case Tag::Skew: ::new (&skew) (StyleSkew_Body)(other.skew); break;
      case Tag::SkewX: ::new (&skew_x) (StyleSkewX_Body)(other.skew_x); break;
      case Tag::SkewY: ::new (&skew_y) (StyleSkewY_Body)(other.skew_y); break;
      case Tag::Translate: ::new (&translate) (StyleTranslate_Body)(other.translate); break;
      case Tag::TranslateX: ::new (&translate_x) (StyleTranslateX_Body)(other.translate_x); break;
      case Tag::TranslateY: ::new (&translate_y) (StyleTranslateY_Body)(other.translate_y); break;
      case Tag::TranslateZ: ::new (&translate_z) (StyleTranslateZ_Body)(other.translate_z); break;
      case Tag::Translate3D: ::new (&translate3_d) (StyleTranslate3D_Body)(other.translate3_d); break;
      case Tag::Scale: ::new (&scale) (StyleScale_Body)(other.scale); break;
      case Tag::ScaleX: ::new (&scale_x) (StyleScaleX_Body)(other.scale_x); break;
      case Tag::ScaleY: ::new (&scale_y) (StyleScaleY_Body)(other.scale_y); break;
      case Tag::ScaleZ: ::new (&scale_z) (StyleScaleZ_Body)(other.scale_z); break;
      case Tag::Scale3D: ::new (&scale3_d) (StyleScale3D_Body)(other.scale3_d); break;
      case Tag::Rotate: ::new (&rotate) (StyleRotate_Body)(other.rotate); break;
      case Tag::RotateX: ::new (&rotate_x) (StyleRotateX_Body)(other.rotate_x); break;
      case Tag::RotateY: ::new (&rotate_y) (StyleRotateY_Body)(other.rotate_y); break;
      case Tag::RotateZ: ::new (&rotate_z) (StyleRotateZ_Body)(other.rotate_z); break;
      case Tag::Rotate3D: ::new (&rotate3_d) (StyleRotate3D_Body)(other.rotate3_d); break;
      case Tag::Perspective: ::new (&perspective) (StylePerspective_Body)(other.perspective); break;
      case Tag::InterpolateMatrix: ::new (&interpolate_matrix) (StyleInterpolateMatrix_Body)(other.interpolate_matrix); break;
      case Tag::AccumulateMatrix: ::new (&accumulate_matrix) (StyleAccumulateMatrix_Body)(other.accumulate_matrix); break;
      default: break;
    }
  }
 private:
  // Private default constructor without initialization so that the helper
  // constructor functions still work as expected. They take care of
  // initializing the fields properly.
  StyleGenericTransformOperation() {}
 public:
};

/// A single operation in a computed CSS `transform`
using StyleTransformOperation = StyleGenericTransformOperation<StyleAngle, StyleNumber, StyleLength, StyleInteger, StyleLengthPercentage>;

/// A computed CSS `transform`
using StyleTransform = StyleGenericTransform<StyleTransformOperation>;

/// A value of the `translate` property
/// https://drafts.csswg.org/css-transforms-2/#individual-transform-serialization:
/// If a 2d translation is specified, the property must serialize with only one
/// or two values (per usual, if the second value is 0px, the default, it must
/// be omitted when serializing).
/// If a 3d translation is specified, all three values must be serialized.
/// We don't omit the 3rd component even if it is 0px for now, and the
/// related spec issue is https://github.com/w3c/csswg-drafts/issues/3305
/// <https://drafts.csswg.org/css-transforms-2/#individual-transforms>
template<typename LengthPercentage, typename Length>
struct StyleGenericTranslate {
  enum class Tag : uint8_t {
    /// 'none'
    None,
    /// '<length-percentage>' or '<length-percentage> <length-percentage>'
    Translate,
    /// '<length-percentage> <length-percentage> <length>'
    Translate3D,
  };

  struct StyleTranslate_Body {
    LengthPercentage _0;
    LengthPercentage _1;

    bool operator==(const StyleTranslate_Body& other) const {
      return _0 == other._0 &&
             _1 == other._1;
    }
    bool operator!=(const StyleTranslate_Body& other) const {
      return _0 != other._0 ||
             _1 != other._1;
    }
  };

  struct StyleTranslate3D_Body {
    LengthPercentage _0;
    LengthPercentage _1;
    Length _2;

    bool operator==(const StyleTranslate3D_Body& other) const {
      return _0 == other._0 &&
             _1 == other._1 &&
             _2 == other._2;
    }
    bool operator!=(const StyleTranslate3D_Body& other) const {
      return _0 != other._0 ||
             _1 != other._1 ||
             _2 != other._2;
    }
  };

  Tag tag;
  union {
    StyleTranslate_Body translate;
    StyleTranslate3D_Body translate3_d;
  };

  static StyleGenericTranslate None() {
    StyleGenericTranslate result;
    result.tag = Tag::None;
    return result;
  }

  static StyleGenericTranslate Translate(const LengthPercentage &a0,
                                         const LengthPercentage &a1) {
    StyleGenericTranslate result;
    ::new (&result.translate._0) (LengthPercentage)(a0);
    ::new (&result.translate._1) (LengthPercentage)(a1);
    result.tag = Tag::Translate;
    return result;
  }

  static StyleGenericTranslate Translate3D(const LengthPercentage &a0,
                                           const LengthPercentage &a1,
                                           const Length &a2) {
    StyleGenericTranslate result;
    ::new (&result.translate3_d._0) (LengthPercentage)(a0);
    ::new (&result.translate3_d._1) (LengthPercentage)(a1);
    ::new (&result.translate3_d._2) (Length)(a2);
    result.tag = Tag::Translate3D;
    return result;
  }

  bool IsNone() const {
    return tag == Tag::None;
  }

  bool IsTranslate() const {
    return tag == Tag::Translate;
  }

  bool IsTranslate3D() const {
    return tag == Tag::Translate3D;
  }

  const StyleTranslate_Body& AsTranslate() const {
    MOZ_ASSERT(IsTranslate());
    return translate;
  }

  const StyleTranslate3D_Body& AsTranslate3D() const {
    MOZ_ASSERT(IsTranslate3D());
    return translate3_d;
  }

  bool operator==(const StyleGenericTranslate& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Translate: return translate == other.translate;
      case Tag::Translate3D: return translate3_d == other.translate3_d;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericTranslate& other) const {
    return !(*this == other);
  }

  ~StyleGenericTranslate() {
    switch (tag) {
      case Tag::Translate: translate.~StyleTranslate_Body(); break;
      case Tag::Translate3D: translate3_d.~StyleTranslate3D_Body(); break;
      default: break;
    }
  }
};

/// A computed CSS `translate`
using StyleTranslate = StyleGenericTranslate<StyleLengthPercentage, StyleLength>;

/// Gecko-FFI-safe owned pointer.
/// Cannot be null, and leaks on drop, so needs to be converted into a rust-side
/// `Box` before.
template<typename GeckoType>
struct StyleOwned {
  GeckoType *ptr;

  bool operator==(const StyleOwned& other) const {
    return ptr == other.ptr;
  }
  bool operator!=(const StyleOwned& other) const {
    return ptr != other.ptr;
  }
  UniquePtr<GeckoType> Consume() {
    UniquePtr<GeckoType> ret(ptr);
    ptr = nullptr;
    return ret;
  }
};

/// A wrapper of Non-negative values.
template<typename T>
using StyleNonNegative = T;

/// A wrapper of LengthPercentage, whose value must be >= 0.
using StyleNonNegativeLengthPercentage = StyleNonNegative<StyleLengthPercentage>;

/// A CSS value made of four components, where its `ToCss` impl will try to
/// serialize as few components as possible, like for example in `border-width`.
template<typename T>
struct StyleRect {
  T _0;
  T _1;
  T _2;
  T _3;

  bool operator==(const StyleRect& other) const {
    return _0 == other._0 &&
           _1 == other._1 &&
           _2 == other._2 &&
           _3 == other._3;
  }
  bool operator!=(const StyleRect& other) const {
    return _0 != other._0 ||
           _1 != other._1 ||
           _2 != other._2 ||
           _3 != other._3;
  }
  // Defined in nsStyleCoord.h
  template<typename Predicate> inline bool All(Predicate) const;
  template<typename Predicate> inline bool Any(Predicate) const;

  // Defined in WritingModes.h
  inline const T& Get(mozilla::Side) const;
  inline const T& Get(mozilla::WritingMode, mozilla::LogicalSide) const;
  inline const T& GetIStart(mozilla::WritingMode) const;
  inline const T& GetBStart(mozilla::WritingMode) const;
  inline const T& GetIEnd(mozilla::WritingMode) const;
  inline const T& GetBEnd(mozilla::WritingMode) const;
};

/// A generic size, for `border-*-radius` longhand properties, or
/// `border-spacing`.
template<typename L>
struct StyleSize2D {
  L width;
  L height;

  bool operator==(const StyleSize2D& other) const {
    return width == other.width &&
           height == other.height;
  }
  bool operator!=(const StyleSize2D& other) const {
    return width != other.width ||
           height != other.height;
  }
};

/// A generic value for the `border-*-radius` longhand properties.
template<typename L>
struct StyleGenericBorderCornerRadius {
  StyleSize2D<L> _0;

  bool operator==(const StyleGenericBorderCornerRadius& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StyleGenericBorderCornerRadius& other) const {
    return _0 != other._0;
  }
};

/// A generic value for `border-radius`, `outline-radius` and `inset()`.
/// <https://drafts.csswg.org/css-backgrounds-3/#border-radius>
template<typename LengthPercentage>
struct StyleGenericBorderRadius {
  /// The top left radius.
  StyleGenericBorderCornerRadius<LengthPercentage> top_left;
  /// The top right radius.
  StyleGenericBorderCornerRadius<LengthPercentage> top_right;
  /// The bottom right radius.
  StyleGenericBorderCornerRadius<LengthPercentage> bottom_right;
  /// The bottom left radius.
  StyleGenericBorderCornerRadius<LengthPercentage> bottom_left;

  bool operator==(const StyleGenericBorderRadius& other) const {
    return top_left == other.top_left &&
           top_right == other.top_right &&
           bottom_right == other.bottom_right &&
           bottom_left == other.bottom_left;
  }
  bool operator!=(const StyleGenericBorderRadius& other) const {
    return top_left != other.top_left ||
           top_right != other.top_right ||
           bottom_right != other.bottom_right ||
           bottom_left != other.bottom_left;
  }
  inline const StyleLengthPercentage& Get(mozilla::HalfCorner) const;
};

/// <https://drafts.csswg.org/css-shapes/#funcdef-inset>
template<typename LengthPercentage, typename NonNegativeLengthPercentage>
struct StyleInsetRect {
  StyleRect<LengthPercentage> rect;
  StyleGenericBorderRadius<NonNegativeLengthPercentage> round;

  bool operator==(const StyleInsetRect& other) const {
    return rect == other.rect &&
           round == other.round;
  }
  bool operator!=(const StyleInsetRect& other) const {
    return rect != other.rect ||
           round != other.round;
  }
};

/// A generic type for representing a CSS [position](https://drafts.csswg.org/css-values/#position).
template<typename H, typename V>
struct StyleGenericPosition {
  /// The horizontal component of position.
  H horizontal;
  /// The vertical component of position.
  V vertical;

  bool operator==(const StyleGenericPosition& other) const {
    return horizontal == other.horizontal &&
           vertical == other.vertical;
  }
  bool operator!=(const StyleGenericPosition& other) const {
    return horizontal != other.horizontal ||
           vertical != other.vertical;
  }
  inline bool DependsOnPositioningAreaSize() const;
  static inline StyleGenericPosition FromPercentage(float);
};

/// <https://drafts.csswg.org/css-shapes/#typedef-shape-radius>
template<typename NonNegativeLengthPercentage>
struct StyleGenericShapeRadius {
  enum class Tag : uint8_t {
    Length,
    ClosestSide,
    FarthestSide,
  };

  struct StyleLength_Body {
    NonNegativeLengthPercentage _0;

    bool operator==(const StyleLength_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleLength_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleLength_Body length;
  };

  static StyleGenericShapeRadius Length(const NonNegativeLengthPercentage &a0) {
    StyleGenericShapeRadius result;
    ::new (&result.length._0) (NonNegativeLengthPercentage)(a0);
    result.tag = Tag::Length;
    return result;
  }

  static StyleGenericShapeRadius ClosestSide() {
    StyleGenericShapeRadius result;
    result.tag = Tag::ClosestSide;
    return result;
  }

  static StyleGenericShapeRadius FarthestSide() {
    StyleGenericShapeRadius result;
    result.tag = Tag::FarthestSide;
    return result;
  }

  bool IsLength() const {
    return tag == Tag::Length;
  }

  bool IsClosestSide() const {
    return tag == Tag::ClosestSide;
  }

  bool IsFarthestSide() const {
    return tag == Tag::FarthestSide;
  }

  const NonNegativeLengthPercentage& AsLength() const {
    MOZ_ASSERT(IsLength());
    return length._0;
  }

  bool operator==(const StyleGenericShapeRadius& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Length: return length == other.length;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericShapeRadius& other) const {
    return !(*this == other);
  }

  ~StyleGenericShapeRadius() {
    switch (tag) {
      case Tag::Length: length.~StyleLength_Body(); break;
      default: break;
    }
  }
};

/// <https://drafts.csswg.org/css-shapes/#funcdef-circle>
template<typename H, typename V, typename NonNegativeLengthPercentage>
struct StyleCircle {
  StyleGenericPosition<H, V> position;
  StyleGenericShapeRadius<NonNegativeLengthPercentage> radius;

  bool operator==(const StyleCircle& other) const {
    return position == other.position &&
           radius == other.radius;
  }
  bool operator!=(const StyleCircle& other) const {
    return position != other.position ||
           radius != other.radius;
  }
};

/// <https://drafts.csswg.org/css-shapes/#funcdef-ellipse>
template<typename H, typename V, typename NonNegativeLengthPercentage>
struct StyleEllipse {
  StyleGenericPosition<H, V> position;
  StyleGenericShapeRadius<NonNegativeLengthPercentage> semiaxis_x;
  StyleGenericShapeRadius<NonNegativeLengthPercentage> semiaxis_y;

  bool operator==(const StyleEllipse& other) const {
    return position == other.position &&
           semiaxis_x == other.semiaxis_x &&
           semiaxis_y == other.semiaxis_y;
  }
  bool operator!=(const StyleEllipse& other) const {
    return position != other.position ||
           semiaxis_x != other.semiaxis_x ||
           semiaxis_y != other.semiaxis_y;
  }
};

/// Coordinates for Polygon.
template<typename LengthPercentage>
struct StylePolygonCoord {
  LengthPercentage _0;
  LengthPercentage _1;

  bool operator==(const StylePolygonCoord& other) const {
    return _0 == other._0 &&
           _1 == other._1;
  }
  bool operator!=(const StylePolygonCoord& other) const {
    return _0 != other._0 ||
           _1 != other._1;
  }
};

/// A generic type for representing the `polygon()` function
/// <https://drafts.csswg.org/css-shapes/#funcdef-polygon>
template<typename LengthPercentage>
struct StyleGenericPolygon {
  /// The filling rule for a polygon.
  StyleFillRule fill;
  /// A collection of (x, y) coordinates to draw the polygon.
  StyleOwnedSlice<StylePolygonCoord<LengthPercentage>> coordinates;

  bool operator==(const StyleGenericPolygon& other) const {
    return fill == other.fill &&
           coordinates == other.coordinates;
  }
  bool operator!=(const StyleGenericPolygon& other) const {
    return fill != other.fill ||
           coordinates != other.coordinates;
  }
};

template<typename H, typename V, typename LengthPercentage, typename NonNegativeLengthPercentage>
struct StyleGenericBasicShape {
  enum class Tag : uint8_t {
    Inset,
    Circle,
    Ellipse,
    Polygon,
  };

  struct StyleInset_Body {
    StyleInsetRect<LengthPercentage, NonNegativeLengthPercentage> _0;

    bool operator==(const StyleInset_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleInset_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleCircle_Body {
    StyleCircle<H, V, NonNegativeLengthPercentage> _0;

    bool operator==(const StyleCircle_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleCircle_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleEllipse_Body {
    StyleEllipse<H, V, NonNegativeLengthPercentage> _0;

    bool operator==(const StyleEllipse_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleEllipse_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StylePolygon_Body {
    StyleGenericPolygon<LengthPercentage> _0;

    bool operator==(const StylePolygon_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StylePolygon_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleInset_Body inset;
    StyleCircle_Body circle;
    StyleEllipse_Body ellipse;
    StylePolygon_Body polygon;
  };

  static StyleGenericBasicShape Inset(const StyleInsetRect<LengthPercentage, NonNegativeLengthPercentage> &a0) {
    StyleGenericBasicShape result;
    ::new (&result.inset._0) (StyleInsetRect<LengthPercentage, NonNegativeLengthPercentage>)(a0);
    result.tag = Tag::Inset;
    return result;
  }

  static StyleGenericBasicShape Circle(const StyleCircle<H, V, NonNegativeLengthPercentage> &a0) {
    StyleGenericBasicShape result;
    ::new (&result.circle._0) (StyleCircle<H, V, NonNegativeLengthPercentage>)(a0);
    result.tag = Tag::Circle;
    return result;
  }

  static StyleGenericBasicShape Ellipse(const StyleEllipse<H, V, NonNegativeLengthPercentage> &a0) {
    StyleGenericBasicShape result;
    ::new (&result.ellipse._0) (StyleEllipse<H, V, NonNegativeLengthPercentage>)(a0);
    result.tag = Tag::Ellipse;
    return result;
  }

  static StyleGenericBasicShape Polygon(const StyleGenericPolygon<LengthPercentage> &a0) {
    StyleGenericBasicShape result;
    ::new (&result.polygon._0) (StyleGenericPolygon<LengthPercentage>)(a0);
    result.tag = Tag::Polygon;
    return result;
  }

  bool IsInset() const {
    return tag == Tag::Inset;
  }

  bool IsCircle() const {
    return tag == Tag::Circle;
  }

  bool IsEllipse() const {
    return tag == Tag::Ellipse;
  }

  bool IsPolygon() const {
    return tag == Tag::Polygon;
  }

  const StyleInsetRect<LengthPercentage, NonNegativeLengthPercentage>& AsInset() const {
    MOZ_ASSERT(IsInset());
    return inset._0;
  }

  const StyleCircle<H, V, NonNegativeLengthPercentage>& AsCircle() const {
    MOZ_ASSERT(IsCircle());
    return circle._0;
  }

  const StyleEllipse<H, V, NonNegativeLengthPercentage>& AsEllipse() const {
    MOZ_ASSERT(IsEllipse());
    return ellipse._0;
  }

  const StyleGenericPolygon<LengthPercentage>& AsPolygon() const {
    MOZ_ASSERT(IsPolygon());
    return polygon._0;
  }

  bool operator==(const StyleGenericBasicShape& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Inset: return inset == other.inset;
      case Tag::Circle: return circle == other.circle;
      case Tag::Ellipse: return ellipse == other.ellipse;
      case Tag::Polygon: return polygon == other.polygon;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericBasicShape& other) const {
    return !(*this == other);
  }

  ~StyleGenericBasicShape() {
    switch (tag) {
      case Tag::Inset: inset.~StyleInset_Body(); break;
      case Tag::Circle: circle.~StyleCircle_Body(); break;
      case Tag::Ellipse: ellipse.~StyleEllipse_Body(); break;
      case Tag::Polygon: polygon.~StylePolygon_Body(); break;
      default: break;
    }
  }
};

/// A computed basic shape.
using StyleBasicShape = StyleGenericBasicShape<StyleLengthPercentage, StyleLengthPercentage, StyleLengthPercentage, StyleNonNegativeLengthPercentage>;

struct StyleAdditiveSymbol {
  int32_t weight;
  nsString symbol;

  bool operator==(const StyleAdditiveSymbol& other) const {
    return weight == other.weight &&
           symbol == other.symbol;
  }
  bool operator!=(const StyleAdditiveSymbol& other) const {
    return weight != other.weight ||
           symbol != other.symbol;
  }
};

struct StyleCounterSpeakAs {
  enum class Tag : uint8_t {
    None,
    Auto,
    Bullets,
    Numbers,
    Words,
    Ident,
  };

  struct StyleIdent_Body {
    nsAtom *_0;

    bool operator==(const StyleIdent_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleIdent_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleIdent_Body ident;
  };

  static StyleCounterSpeakAs None() {
    StyleCounterSpeakAs result;
    result.tag = Tag::None;
    return result;
  }

  static StyleCounterSpeakAs Auto() {
    StyleCounterSpeakAs result;
    result.tag = Tag::Auto;
    return result;
  }

  static StyleCounterSpeakAs Bullets() {
    StyleCounterSpeakAs result;
    result.tag = Tag::Bullets;
    return result;
  }

  static StyleCounterSpeakAs Numbers() {
    StyleCounterSpeakAs result;
    result.tag = Tag::Numbers;
    return result;
  }

  static StyleCounterSpeakAs Words() {
    StyleCounterSpeakAs result;
    result.tag = Tag::Words;
    return result;
  }

  static StyleCounterSpeakAs Ident(nsAtom *const &a0) {
    StyleCounterSpeakAs result;
    ::new (&result.ident._0) (nsAtom*)(a0);
    result.tag = Tag::Ident;
    return result;
  }

  bool IsNone() const {
    return tag == Tag::None;
  }

  bool IsAuto() const {
    return tag == Tag::Auto;
  }

  bool IsBullets() const {
    return tag == Tag::Bullets;
  }

  bool IsNumbers() const {
    return tag == Tag::Numbers;
  }

  bool IsWords() const {
    return tag == Tag::Words;
  }

  bool IsIdent() const {
    return tag == Tag::Ident;
  }

  nsAtom*const & AsIdent() const {
    MOZ_ASSERT(IsIdent());
    return ident._0;
  }

  bool operator==(const StyleCounterSpeakAs& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Ident: return ident == other.ident;
      default: return true;
    }
  }

  bool operator!=(const StyleCounterSpeakAs& other) const {
    return !(*this == other);
  }

  ~StyleCounterSpeakAs() {
    switch (tag) {
      case Tag::Ident: ident.~StyleIdent_Body(); break;
      default: break;
    }
  }
};

/// font-language-override can only have a single three-letter
/// OpenType "language system" tag, so we should be able to compute
/// it and store it as a 32-bit integer
/// (see http://www.microsoft.com/typography/otspec/languagetags.htm).
struct StyleFontLanguageOverride {
  uint32_t _0;

  bool operator==(const StyleFontLanguageOverride& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StyleFontLanguageOverride& other) const {
    return _0 != other._0;
  }
};

/// The computed representation of the above, so that
/// Gecko can read them easily.
struct StyleComputedFontStretchRange {
  float _0;
  float _1;

  bool operator==(const StyleComputedFontStretchRange& other) const {
    return _0 == other._0 &&
           _1 == other._1;
  }
  bool operator!=(const StyleComputedFontStretchRange& other) const {
    return _0 != other._0 ||
           _1 != other._1;
  }
};

/// The computed representation of the above, with angles in degrees, so that
/// Gecko can read them easily.
union StyleComputedFontStyleDescriptor {
  enum class Tag : uint8_t {
    Normal,
    Italic,
    Oblique,
  };

  struct Oblique_Body {
    Tag tag;
    float _0;
    float _1;

    bool operator==(const Oblique_Body& other) const {
      return _0 == other._0 &&
             _1 == other._1;
    }
    bool operator!=(const Oblique_Body& other) const {
      return _0 != other._0 ||
             _1 != other._1;
    }
  };

  struct {
    Tag tag;
  };
  Oblique_Body oblique;

  static StyleComputedFontStyleDescriptor Normal() {
    StyleComputedFontStyleDescriptor result;
    result.tag = Tag::Normal;
    return result;
  }

  static StyleComputedFontStyleDescriptor Italic() {
    StyleComputedFontStyleDescriptor result;
    result.tag = Tag::Italic;
    return result;
  }

  static StyleComputedFontStyleDescriptor Oblique(const float &a0,
                                                  const float &a1) {
    StyleComputedFontStyleDescriptor result;
    ::new (&result.oblique._0) (float)(a0);
    ::new (&result.oblique._1) (float)(a1);
    result.tag = Tag::Oblique;
    return result;
  }

  bool IsNormal() const {
    return tag == Tag::Normal;
  }

  bool IsItalic() const {
    return tag == Tag::Italic;
  }

  bool IsOblique() const {
    return tag == Tag::Oblique;
  }

  const Oblique_Body& AsOblique() const {
    MOZ_ASSERT(IsOblique());
    return oblique;
  }

  bool operator==(const StyleComputedFontStyleDescriptor& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Oblique: return oblique == other.oblique;
      default: return true;
    }
  }

  bool operator!=(const StyleComputedFontStyleDescriptor& other) const {
    return !(*this == other);
  }

  ~StyleComputedFontStyleDescriptor() {
    switch (tag) {
      case Tag::Oblique: oblique.~Oblique_Body(); break;
      default: break;
    }
  }
};

/// The computed representation of the above so Gecko can read them easily.
/// This one is needed because cbindgen doesn't know how to generate
/// specified::Number.
struct StyleComputedFontWeightRange {
  float _0;
  float _1;

  bool operator==(const StyleComputedFontWeightRange& other) const {
    return _0 == other._0 &&
           _1 == other._1;
  }
  bool operator!=(const StyleComputedFontWeightRange& other) const {
    return _0 != other._0 ||
           _1 != other._1;
  }
};

/// A POD representation for Gecko. All pointers here are non-owned and as such
/// can't outlive the rule they came from, but we can't enforce that via C++.
/// All the strings are of course utf8.
union StyleFontFaceSourceListComponent {
  enum class Tag : uint8_t {
    Url,
    Local,
    FormatHint,
  };

  struct Url_Body {
    Tag tag;
    const StyleURLValue *_0;

    bool operator==(const Url_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const Url_Body& other) const {
      return _0 != other._0;
    }
  };

  struct Local_Body {
    Tag tag;
    nsAtom *_0;

    bool operator==(const Local_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const Local_Body& other) const {
      return _0 != other._0;
    }
  };

  struct FormatHint_Body {
    Tag tag;
    uintptr_t length;
    const uint8_t *utf8_bytes;

    bool operator==(const FormatHint_Body& other) const {
      return length == other.length &&
             utf8_bytes == other.utf8_bytes;
    }
    bool operator!=(const FormatHint_Body& other) const {
      return length != other.length ||
             utf8_bytes != other.utf8_bytes;
    }
  };

  struct {
    Tag tag;
  };
  Url_Body url;
  Local_Body local;
  FormatHint_Body format_hint;

  static StyleFontFaceSourceListComponent Url(const StyleURLValue *const &a0) {
    StyleFontFaceSourceListComponent result;
    ::new (&result.url._0) (const StyleURLValue*)(a0);
    result.tag = Tag::Url;
    return result;
  }

  static StyleFontFaceSourceListComponent Local(nsAtom *const &a0) {
    StyleFontFaceSourceListComponent result;
    ::new (&result.local._0) (nsAtom*)(a0);
    result.tag = Tag::Local;
    return result;
  }

  static StyleFontFaceSourceListComponent FormatHint(const uintptr_t &aLength,
                                                     const uint8_t *const &aUtf8Bytes) {
    StyleFontFaceSourceListComponent result;
    ::new (&result.format_hint.length) (uintptr_t)(aLength);
    ::new (&result.format_hint.utf8_bytes) (const uint8_t*)(aUtf8Bytes);
    result.tag = Tag::FormatHint;
    return result;
  }

  bool IsUrl() const {
    return tag == Tag::Url;
  }

  bool IsLocal() const {
    return tag == Tag::Local;
  }

  bool IsFormatHint() const {
    return tag == Tag::FormatHint;
  }

  const StyleURLValue*const & AsUrl() const {
    MOZ_ASSERT(IsUrl());
    return url._0;
  }

  nsAtom*const & AsLocal() const {
    MOZ_ASSERT(IsLocal());
    return local._0;
  }

  const FormatHint_Body& AsFormatHint() const {
    MOZ_ASSERT(IsFormatHint());
    return format_hint;
  }

  bool operator==(const StyleFontFaceSourceListComponent& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Url: return url == other.url;
      case Tag::Local: return local == other.local;
      case Tag::FormatHint: return format_hint == other.format_hint;
      default: return true;
    }
  }

  bool operator!=(const StyleFontFaceSourceListComponent& other) const {
    return !(*this == other);
  }

  ~StyleFontFaceSourceListComponent() {
    switch (tag) {
      case Tag::Url: url.~Url_Body(); break;
      case Tag::Local: local.~Local_Body(); break;
      case Tag::FormatHint: format_hint.~FormatHint_Body(); break;
      default: break;
    }
  }
};

/// One contiguous range of code points.
/// Can not be empty. Can represent a single code point when start == end.
struct StyleUnicodeRange {
  /// Inclusive start of the range. In [0, end].
  uint32_t start;
  /// Inclusive end of the range. In [0, 0x10FFFF].
  uint32_t end;

  bool operator==(const StyleUnicodeRange& other) const {
    return start == other.start &&
           end == other.end;
  }
  bool operator!=(const StyleUnicodeRange& other) const {
    return start != other.start ||
           end != other.end;
  }
};

/// The value of an IntersectionObserver's rootMargin property.
/// Only bare px or percentage values are allowed. Other length units and
/// calc() values are not allowed.
/// <https://w3c.github.io/IntersectionObserver/#parse-a-root-margin>
using StyleIntersectionObserverRootMargin = StyleRect<StyleLengthPercentage>;

/// The kind of restyle we need to do for a given element.
struct StyleRestyleHint {
  uint8_t bits;

  explicit operator bool() const {
    return !!bits;
  }
  StyleRestyleHint operator|(const StyleRestyleHint& other) const {
    return {static_cast<decltype(bits)>(this->bits | other.bits)};
  }
  StyleRestyleHint& operator|=(const StyleRestyleHint& other) {
    *this = (*this | other);
    return *this;
  }
  StyleRestyleHint operator&(const StyleRestyleHint& other) const {
    return {static_cast<decltype(bits)>(this->bits & other.bits)};
  }
  StyleRestyleHint& operator&=(const StyleRestyleHint& other) {
    *this = (*this & other);
    return *this;
  }
  bool operator==(const StyleRestyleHint& other) const {
    return bits == other.bits;
  }
  bool operator!=(const StyleRestyleHint& other) const {
    return bits != other.bits;
  }
  static inline StyleRestyleHint RestyleSubtree();
  static inline StyleRestyleHint RecascadeSubtree();
  static inline StyleRestyleHint ForAnimations();
};
static const StyleRestyleHint StyleRestyleHint_RESTYLE_SELF = (StyleRestyleHint){ .bits = 1 << 0 };
static const StyleRestyleHint StyleRestyleHint_RESTYLE_DESCENDANTS = (StyleRestyleHint){ .bits = 1 << 1 };
static const StyleRestyleHint StyleRestyleHint_RECASCADE_SELF = (StyleRestyleHint){ .bits = 1 << 2 };
static const StyleRestyleHint StyleRestyleHint_RECASCADE_DESCENDANTS = (StyleRestyleHint){ .bits = 1 << 3 };
static const StyleRestyleHint StyleRestyleHint_RESTYLE_CSS_TRANSITIONS = (StyleRestyleHint){ .bits = 1 << 4 };
static const StyleRestyleHint StyleRestyleHint_RESTYLE_CSS_ANIMATIONS = (StyleRestyleHint){ .bits = 1 << 5 };
static const StyleRestyleHint StyleRestyleHint_RESTYLE_STYLE_ATTRIBUTE = (StyleRestyleHint){ .bits = 1 << 6 };
static const StyleRestyleHint StyleRestyleHint_RESTYLE_SMIL = (StyleRestyleHint){ .bits = 1 << 7 };

/// A struct that basically replaces a Box<str>, but with a defined layout,
/// suitable for FFI.
struct StyleOwnedStr {
  StyleOwnedSlice<uint8_t> _0;

  bool operator==(const StyleOwnedStr& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StyleOwnedStr& other) const {
    return _0 != other._0;
  }
  inline nsDependentCSubstring AsString() const;
};

/// A quote pair.
struct StyleQuotePair {
  /// The opening quote.
  StyleOwnedStr opening;
  /// The closing quote.
  StyleOwnedStr closing;

  bool operator==(const StyleQuotePair& other) const {
    return opening == other.opening &&
           closing == other.closing;
  }
  bool operator!=(const StyleQuotePair& other) const {
    return opening != other.opening ||
           closing != other.closing;
  }
};

/// The inner pointer of an ArcSlice<T>, to be sent via FFI.
/// The type of the pointer is a bit of a lie, we just want to preserve the type
/// but these pointers cannot be constructed outside of this crate, so we're
/// good.
template<typename T>
struct StyleForgottenArcSlicePtr {
  T *_0;

  bool operator==(const StyleForgottenArcSlicePtr& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StyleForgottenArcSlicePtr& other) const {
    return _0 != other._0;
  }
};

/// Gecko-FFI-safe owned pointer.
/// Can be null, and just as `Owned` leaks on `Drop`.
template<typename GeckoType>
struct StyleOwnedOrNull {
  GeckoType *ptr;

  bool operator==(const StyleOwnedOrNull& other) const {
    return ptr == other.ptr;
  }
  bool operator!=(const StyleOwnedOrNull& other) const {
    return ptr != other.ptr;
  }
  UniquePtr<GeckoType> Consume() {
    UniquePtr<GeckoType> ret(ptr);
    ptr = nullptr;
    return ret;
  }
};

/// A computed value for the `border-radius` property.
using StyleBorderRadius = StyleGenericBorderRadius<StyleNonNegativeLengthPercentage>;

/// <https://drafts.csswg.org/css-ui/#propdef-outline-style>
struct StyleOutlineStyle {
  enum class Tag : uint8_t {
    /// auto
    Auto,
    /// <border-style>
    BorderStyle,
  };

  struct StyleBorderStyle_Body {
    StyleBorderStyle _0;

    bool operator==(const StyleBorderStyle_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleBorderStyle_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleBorderStyle_Body border_style;
  };

  static StyleOutlineStyle Auto() {
    StyleOutlineStyle result;
    result.tag = Tag::Auto;
    return result;
  }

  static StyleOutlineStyle BorderStyle(const StyleBorderStyle &a0) {
    StyleOutlineStyle result;
    ::new (&result.border_style._0) (StyleBorderStyle)(a0);
    result.tag = Tag::BorderStyle;
    return result;
  }

  bool IsAuto() const {
    return tag == Tag::Auto;
  }

  bool IsBorderStyle() const {
    return tag == Tag::BorderStyle;
  }

  const StyleBorderStyle& AsBorderStyle() const {
    MOZ_ASSERT(IsBorderStyle());
    return border_style._0;
  }

  bool operator==(const StyleOutlineStyle& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::BorderStyle: return border_style == other.border_style;
      default: return true;
    }
  }

  bool operator!=(const StyleOutlineStyle& other) const {
    return !(*this == other);
  }

  ~StyleOutlineStyle() {
    switch (tag) {
      case Tag::BorderStyle: border_style.~StyleBorderStyle_Body(); break;
      default: break;
    }
  }
};

/// A generic easing function.
template<typename Integer, typename Number>
struct StyleTimingFunction {
  enum class Tag : uint8_t {
    /// `linear | ease | ease-in | ease-out | ease-in-out`
    Keyword,
    /// `cubic-bezier(<number>, <number>, <number>, <number>)`
    CubicBezier,
    /// `step-start | step-end | steps(<integer>, [ <step-position> ]?)`
    /// `<step-position> = jump-start | jump-end | jump-none | jump-both | start | end`
    Steps,
  };

  struct StyleKeyword_Body {
    StyleTimingKeyword _0;

    bool operator==(const StyleKeyword_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleKeyword_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleCubicBezier_Body {
    Number x1;
    Number y1;
    Number x2;
    Number y2;

    bool operator==(const StyleCubicBezier_Body& other) const {
      return x1 == other.x1 &&
             y1 == other.y1 &&
             x2 == other.x2 &&
             y2 == other.y2;
    }
    bool operator!=(const StyleCubicBezier_Body& other) const {
      return x1 != other.x1 ||
             y1 != other.y1 ||
             x2 != other.x2 ||
             y2 != other.y2;
    }
  };

  struct StyleSteps_Body {
    Integer _0;
    StyleStepPosition _1;

    bool operator==(const StyleSteps_Body& other) const {
      return _0 == other._0 &&
             _1 == other._1;
    }
    bool operator!=(const StyleSteps_Body& other) const {
      return _0 != other._0 ||
             _1 != other._1;
    }
  };

  Tag tag;
  union {
    StyleKeyword_Body keyword;
    StyleCubicBezier_Body cubic_bezier;
    StyleSteps_Body steps;
  };

  static StyleTimingFunction Keyword(const StyleTimingKeyword &a0) {
    StyleTimingFunction result;
    ::new (&result.keyword._0) (StyleTimingKeyword)(a0);
    result.tag = Tag::Keyword;
    return result;
  }

  static StyleTimingFunction CubicBezier(const Number &aX1,
                                         const Number &aY1,
                                         const Number &aX2,
                                         const Number &aY2) {
    StyleTimingFunction result;
    ::new (&result.cubic_bezier.x1) (Number)(aX1);
    ::new (&result.cubic_bezier.y1) (Number)(aY1);
    ::new (&result.cubic_bezier.x2) (Number)(aX2);
    ::new (&result.cubic_bezier.y2) (Number)(aY2);
    result.tag = Tag::CubicBezier;
    return result;
  }

  static StyleTimingFunction Steps(const Integer &a0,
                                   const StyleStepPosition &a1) {
    StyleTimingFunction result;
    ::new (&result.steps._0) (Integer)(a0);
    ::new (&result.steps._1) (StyleStepPosition)(a1);
    result.tag = Tag::Steps;
    return result;
  }

  bool IsKeyword() const {
    return tag == Tag::Keyword;
  }

  bool IsCubicBezier() const {
    return tag == Tag::CubicBezier;
  }

  bool IsSteps() const {
    return tag == Tag::Steps;
  }

  const StyleTimingKeyword& AsKeyword() const {
    MOZ_ASSERT(IsKeyword());
    return keyword._0;
  }

  const StyleCubicBezier_Body& AsCubicBezier() const {
    MOZ_ASSERT(IsCubicBezier());
    return cubic_bezier;
  }

  const StyleSteps_Body& AsSteps() const {
    MOZ_ASSERT(IsSteps());
    return steps;
  }

  bool operator==(const StyleTimingFunction& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Keyword: return keyword == other.keyword;
      case Tag::CubicBezier: return cubic_bezier == other.cubic_bezier;
      case Tag::Steps: return steps == other.steps;
      default: return true;
    }
  }

  bool operator!=(const StyleTimingFunction& other) const {
    return !(*this == other);
  }

  ~StyleTimingFunction() {
    switch (tag) {
      case Tag::Keyword: keyword.~StyleKeyword_Body(); break;
      case Tag::CubicBezier: cubic_bezier.~StyleCubicBezier_Body(); break;
      case Tag::Steps: steps.~StyleSteps_Body(); break;
      default: break;
    }
  }
};

/// A computed timing function.
using StyleComputedTimingFunction = StyleTimingFunction<StyleInteger, StyleNumber>;

/// The path coord type.
struct StyleCoordPair {
  StyleCSSFloat _0;
  StyleCSSFloat _1;

  bool operator==(const StyleCoordPair& other) const {
    return _0 == other._0 &&
           _1 == other._1;
  }
  bool operator!=(const StyleCoordPair& other) const {
    return _0 != other._0 ||
           _1 != other._1;
  }
};

/// The EllipticalArc flag type.
struct StyleArcFlag {
  bool _0;

  bool operator==(const StyleArcFlag& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StyleArcFlag& other) const {
    return _0 != other._0;
  }
};

/// The SVG path command.
/// The fields of these commands are self-explanatory, so we skip the documents.
/// Note: the index of the control points, e.g. control1, control2, are mapping to the control
/// points of the Bézier curve in the spec.
/// https://www.w3.org/TR/SVG11/paths.html#PathData
struct StylePathCommand {
  enum class Tag : uint8_t {
    /// The unknown type.
    /// https://www.w3.org/TR/SVG/paths.html#__svg__SVGPathSeg__PATHSEG_UNKNOWN
    Unknown,
    /// The "moveto" command.
    MoveTo,
    /// The "lineto" command.
    LineTo,
    /// The horizontal "lineto" command.
    HorizontalLineTo,
    /// The vertical "lineto" command.
    VerticalLineTo,
    /// The cubic Bézier curve command.
    CurveTo,
    /// The smooth curve command.
    SmoothCurveTo,
    /// The quadratic Bézier curve command.
    QuadBezierCurveTo,
    /// The smooth quadratic Bézier curve command.
    SmoothQuadBezierCurveTo,
    /// The elliptical arc curve command.
    EllipticalArc,
    /// The "closepath" command.
    ClosePath,
  };

  struct StyleMoveTo_Body {
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleMoveTo_Body& other) const {
      return point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleMoveTo_Body& other) const {
      return point != other.point ||
             absolute != other.absolute;
    }
  };

  struct StyleLineTo_Body {
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleLineTo_Body& other) const {
      return point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleLineTo_Body& other) const {
      return point != other.point ||
             absolute != other.absolute;
    }
  };

  struct StyleHorizontalLineTo_Body {
    StyleCSSFloat x;
    StyleIsAbsolute absolute;

    bool operator==(const StyleHorizontalLineTo_Body& other) const {
      return x == other.x &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleHorizontalLineTo_Body& other) const {
      return x != other.x ||
             absolute != other.absolute;
    }
  };

  struct StyleVerticalLineTo_Body {
    StyleCSSFloat y;
    StyleIsAbsolute absolute;

    bool operator==(const StyleVerticalLineTo_Body& other) const {
      return y == other.y &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleVerticalLineTo_Body& other) const {
      return y != other.y ||
             absolute != other.absolute;
    }
  };

  struct StyleCurveTo_Body {
    StyleCoordPair control1;
    StyleCoordPair control2;
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleCurveTo_Body& other) const {
      return control1 == other.control1 &&
             control2 == other.control2 &&
             point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleCurveTo_Body& other) const {
      return control1 != other.control1 ||
             control2 != other.control2 ||
             point != other.point ||
             absolute != other.absolute;
    }
  };

  struct StyleSmoothCurveTo_Body {
    StyleCoordPair control2;
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleSmoothCurveTo_Body& other) const {
      return control2 == other.control2 &&
             point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleSmoothCurveTo_Body& other) const {
      return control2 != other.control2 ||
             point != other.point ||
             absolute != other.absolute;
    }
  };

  struct StyleQuadBezierCurveTo_Body {
    StyleCoordPair control1;
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleQuadBezierCurveTo_Body& other) const {
      return control1 == other.control1 &&
             point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleQuadBezierCurveTo_Body& other) const {
      return control1 != other.control1 ||
             point != other.point ||
             absolute != other.absolute;
    }
  };

  struct StyleSmoothQuadBezierCurveTo_Body {
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleSmoothQuadBezierCurveTo_Body& other) const {
      return point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleSmoothQuadBezierCurveTo_Body& other) const {
      return point != other.point ||
             absolute != other.absolute;
    }
  };

  struct StyleEllipticalArc_Body {
    StyleCSSFloat rx;
    StyleCSSFloat ry;
    StyleCSSFloat angle;
    StyleArcFlag large_arc_flag;
    StyleArcFlag sweep_flag;
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleEllipticalArc_Body& other) const {
      return rx == other.rx &&
             ry == other.ry &&
             angle == other.angle &&
             large_arc_flag == other.large_arc_flag &&
             sweep_flag == other.sweep_flag &&
             point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleEllipticalArc_Body& other) const {
      return rx != other.rx ||
             ry != other.ry ||
             angle != other.angle ||
             large_arc_flag != other.large_arc_flag ||
             sweep_flag != other.sweep_flag ||
             point != other.point ||
             absolute != other.absolute;
    }
  };

  Tag tag;
  union {
    StyleMoveTo_Body move_to;
    StyleLineTo_Body line_to;
    StyleHorizontalLineTo_Body horizontal_line_to;
    StyleVerticalLineTo_Body vertical_line_to;
    StyleCurveTo_Body curve_to;
    StyleSmoothCurveTo_Body smooth_curve_to;
    StyleQuadBezierCurveTo_Body quad_bezier_curve_to;
    StyleSmoothQuadBezierCurveTo_Body smooth_quad_bezier_curve_to;
    StyleEllipticalArc_Body elliptical_arc;
  };

  static StylePathCommand Unknown() {
    StylePathCommand result;
    result.tag = Tag::Unknown;
    return result;
  }

  static StylePathCommand MoveTo(const StyleCoordPair &aPoint,
                                 const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    ::new (&result.move_to.point) (StyleCoordPair)(aPoint);
    ::new (&result.move_to.absolute) (StyleIsAbsolute)(aAbsolute);
    result.tag = Tag::MoveTo;
    return result;
  }

  static StylePathCommand LineTo(const StyleCoordPair &aPoint,
                                 const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    ::new (&result.line_to.point) (StyleCoordPair)(aPoint);
    ::new (&result.line_to.absolute) (StyleIsAbsolute)(aAbsolute);
    result.tag = Tag::LineTo;
    return result;
  }

  static StylePathCommand HorizontalLineTo(const StyleCSSFloat &aX,
                                           const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    ::new (&result.horizontal_line_to.x) (StyleCSSFloat)(aX);
    ::new (&result.horizontal_line_to.absolute) (StyleIsAbsolute)(aAbsolute);
    result.tag = Tag::HorizontalLineTo;
    return result;
  }

  static StylePathCommand VerticalLineTo(const StyleCSSFloat &aY,
                                         const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    ::new (&result.vertical_line_to.y) (StyleCSSFloat)(aY);
    ::new (&result.vertical_line_to.absolute) (StyleIsAbsolute)(aAbsolute);
    result.tag = Tag::VerticalLineTo;
    return result;
  }

  static StylePathCommand CurveTo(const StyleCoordPair &aControl1,
                                  const StyleCoordPair &aControl2,
                                  const StyleCoordPair &aPoint,
                                  const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    ::new (&result.curve_to.control1) (StyleCoordPair)(aControl1);
    ::new (&result.curve_to.control2) (StyleCoordPair)(aControl2);
    ::new (&result.curve_to.point) (StyleCoordPair)(aPoint);
    ::new (&result.curve_to.absolute) (StyleIsAbsolute)(aAbsolute);
    result.tag = Tag::CurveTo;
    return result;
  }

  static StylePathCommand SmoothCurveTo(const StyleCoordPair &aControl2,
                                        const StyleCoordPair &aPoint,
                                        const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    ::new (&result.smooth_curve_to.control2) (StyleCoordPair)(aControl2);
    ::new (&result.smooth_curve_to.point) (StyleCoordPair)(aPoint);
    ::new (&result.smooth_curve_to.absolute) (StyleIsAbsolute)(aAbsolute);
    result.tag = Tag::SmoothCurveTo;
    return result;
  }

  static StylePathCommand QuadBezierCurveTo(const StyleCoordPair &aControl1,
                                            const StyleCoordPair &aPoint,
                                            const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    ::new (&result.quad_bezier_curve_to.control1) (StyleCoordPair)(aControl1);
    ::new (&result.quad_bezier_curve_to.point) (StyleCoordPair)(aPoint);
    ::new (&result.quad_bezier_curve_to.absolute) (StyleIsAbsolute)(aAbsolute);
    result.tag = Tag::QuadBezierCurveTo;
    return result;
  }

  static StylePathCommand SmoothQuadBezierCurveTo(const StyleCoordPair &aPoint,
                                                  const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    ::new (&result.smooth_quad_bezier_curve_to.point) (StyleCoordPair)(aPoint);
    ::new (&result.smooth_quad_bezier_curve_to.absolute) (StyleIsAbsolute)(aAbsolute);
    result.tag = Tag::SmoothQuadBezierCurveTo;
    return result;
  }

  static StylePathCommand EllipticalArc(const StyleCSSFloat &aRx,
                                        const StyleCSSFloat &aRy,
                                        const StyleCSSFloat &aAngle,
                                        const StyleArcFlag &aLargeArcFlag,
                                        const StyleArcFlag &aSweepFlag,
                                        const StyleCoordPair &aPoint,
                                        const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    ::new (&result.elliptical_arc.rx) (StyleCSSFloat)(aRx);
    ::new (&result.elliptical_arc.ry) (StyleCSSFloat)(aRy);
    ::new (&result.elliptical_arc.angle) (StyleCSSFloat)(aAngle);
    ::new (&result.elliptical_arc.large_arc_flag) (StyleArcFlag)(aLargeArcFlag);
    ::new (&result.elliptical_arc.sweep_flag) (StyleArcFlag)(aSweepFlag);
    ::new (&result.elliptical_arc.point) (StyleCoordPair)(aPoint);
    ::new (&result.elliptical_arc.absolute) (StyleIsAbsolute)(aAbsolute);
    result.tag = Tag::EllipticalArc;
    return result;
  }

  static StylePathCommand ClosePath() {
    StylePathCommand result;
    result.tag = Tag::ClosePath;
    return result;
  }

  bool IsUnknown() const {
    return tag == Tag::Unknown;
  }

  bool IsMoveTo() const {
    return tag == Tag::MoveTo;
  }

  bool IsLineTo() const {
    return tag == Tag::LineTo;
  }

  bool IsHorizontalLineTo() const {
    return tag == Tag::HorizontalLineTo;
  }

  bool IsVerticalLineTo() const {
    return tag == Tag::VerticalLineTo;
  }

  bool IsCurveTo() const {
    return tag == Tag::CurveTo;
  }

  bool IsSmoothCurveTo() const {
    return tag == Tag::SmoothCurveTo;
  }

  bool IsQuadBezierCurveTo() const {
    return tag == Tag::QuadBezierCurveTo;
  }

  bool IsSmoothQuadBezierCurveTo() const {
    return tag == Tag::SmoothQuadBezierCurveTo;
  }

  bool IsEllipticalArc() const {
    return tag == Tag::EllipticalArc;
  }

  bool IsClosePath() const {
    return tag == Tag::ClosePath;
  }

  const StyleMoveTo_Body& AsMoveTo() const {
    MOZ_ASSERT(IsMoveTo());
    return move_to;
  }

  const StyleLineTo_Body& AsLineTo() const {
    MOZ_ASSERT(IsLineTo());
    return line_to;
  }

  const StyleHorizontalLineTo_Body& AsHorizontalLineTo() const {
    MOZ_ASSERT(IsHorizontalLineTo());
    return horizontal_line_to;
  }

  const StyleVerticalLineTo_Body& AsVerticalLineTo() const {
    MOZ_ASSERT(IsVerticalLineTo());
    return vertical_line_to;
  }

  const StyleCurveTo_Body& AsCurveTo() const {
    MOZ_ASSERT(IsCurveTo());
    return curve_to;
  }

  const StyleSmoothCurveTo_Body& AsSmoothCurveTo() const {
    MOZ_ASSERT(IsSmoothCurveTo());
    return smooth_curve_to;
  }

  const StyleQuadBezierCurveTo_Body& AsQuadBezierCurveTo() const {
    MOZ_ASSERT(IsQuadBezierCurveTo());
    return quad_bezier_curve_to;
  }

  const StyleSmoothQuadBezierCurveTo_Body& AsSmoothQuadBezierCurveTo() const {
    MOZ_ASSERT(IsSmoothQuadBezierCurveTo());
    return smooth_quad_bezier_curve_to;
  }

  const StyleEllipticalArc_Body& AsEllipticalArc() const {
    MOZ_ASSERT(IsEllipticalArc());
    return elliptical_arc;
  }

  bool operator==(const StylePathCommand& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::MoveTo: return move_to == other.move_to;
      case Tag::LineTo: return line_to == other.line_to;
      case Tag::HorizontalLineTo: return horizontal_line_to == other.horizontal_line_to;
      case Tag::VerticalLineTo: return vertical_line_to == other.vertical_line_to;
      case Tag::CurveTo: return curve_to == other.curve_to;
      case Tag::SmoothCurveTo: return smooth_curve_to == other.smooth_curve_to;
      case Tag::QuadBezierCurveTo: return quad_bezier_curve_to == other.quad_bezier_curve_to;
      case Tag::SmoothQuadBezierCurveTo: return smooth_quad_bezier_curve_to == other.smooth_quad_bezier_curve_to;
      case Tag::EllipticalArc: return elliptical_arc == other.elliptical_arc;
      default: return true;
    }
  }

  bool operator!=(const StylePathCommand& other) const {
    return !(*this == other);
  }

  ~StylePathCommand() {
    switch (tag) {
      case Tag::MoveTo: move_to.~StyleMoveTo_Body(); break;
      case Tag::LineTo: line_to.~StyleLineTo_Body(); break;
      case Tag::HorizontalLineTo: horizontal_line_to.~StyleHorizontalLineTo_Body(); break;
      case Tag::VerticalLineTo: vertical_line_to.~StyleVerticalLineTo_Body(); break;
      case Tag::CurveTo: curve_to.~StyleCurveTo_Body(); break;
      case Tag::SmoothCurveTo: smooth_curve_to.~StyleSmoothCurveTo_Body(); break;
      case Tag::QuadBezierCurveTo: quad_bezier_curve_to.~StyleQuadBezierCurveTo_Body(); break;
      case Tag::SmoothQuadBezierCurveTo: smooth_quad_bezier_curve_to.~StyleSmoothQuadBezierCurveTo_Body(); break;
      case Tag::EllipticalArc: elliptical_arc.~StyleEllipticalArc_Body(); break;
      default: break;
    }
  }
};

/// https://drafts.csswg.org/css-scroll-snap-1/#scroll-snap-align
struct StyleScrollSnapAlign {
  StyleScrollSnapAlignKeyword block;
  StyleScrollSnapAlignKeyword inline_;

  bool operator==(const StyleScrollSnapAlign& other) const {
    return block == other.block &&
           inline_ == other.inline_;
  }
  bool operator!=(const StyleScrollSnapAlign& other) const {
    return block != other.block ||
           inline_ != other.inline_;
  }
};

/// https://drafts.csswg.org/css-scroll-snap-1/#scroll-snap-type
struct StyleScrollSnapType {
  StyleScrollSnapAxis axis;
  StyleScrollSnapStrictness strictness;

  bool operator==(const StyleScrollSnapType& other) const {
    return axis == other.axis &&
           strictness == other.strictness;
  }
  bool operator!=(const StyleScrollSnapType& other) const {
    return axis != other.axis ||
           strictness != other.strictness;
  }
};

/// A computed value for the `letter-spacing` property.
using StyleLetterSpacing = StyleLength;

/// A `<length-percentage> | auto` value.
template<typename LengthPercent>
struct StyleGenericLengthPercentageOrAuto {
  enum class Tag : uint8_t {
    LengthPercentage,
    Auto,
  };

  struct StyleLengthPercentage_Body {
    LengthPercent _0;

    bool operator==(const StyleLengthPercentage_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleLengthPercentage_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleLengthPercentage_Body length_percentage;
  };

  static StyleGenericLengthPercentageOrAuto LengthPercentage(const LengthPercent &a0) {
    StyleGenericLengthPercentageOrAuto result;
    ::new (&result.length_percentage._0) (LengthPercent)(a0);
    result.tag = Tag::LengthPercentage;
    return result;
  }

  static StyleGenericLengthPercentageOrAuto Auto() {
    StyleGenericLengthPercentageOrAuto result;
    result.tag = Tag::Auto;
    return result;
  }

  bool IsLengthPercentage() const {
    return tag == Tag::LengthPercentage;
  }

  bool IsAuto() const {
    return tag == Tag::Auto;
  }

  const LengthPercent& AsLengthPercentage() const {
    MOZ_ASSERT(IsLengthPercentage());
    return length_percentage._0;
  }

  bool operator==(const StyleGenericLengthPercentageOrAuto& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::LengthPercentage: return length_percentage == other.length_percentage;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericLengthPercentageOrAuto& other) const {
    return !(*this == other);
  }

  ~StyleGenericLengthPercentageOrAuto() {
    switch (tag) {
      case Tag::LengthPercentage: length_percentage.~StyleLengthPercentage_Body(); break;
      default: break;
    }
  }
  inline bool ConvertsToLength() const;
  inline nscoord ToLength() const;
  inline bool ConvertsToPercentage() const;
  inline float ToPercentage() const;
  inline bool HasPercent() const;
  inline bool HasLengthAndPercentage() const;

  // Just some convenient aliases for LengthOrAuto, to avoid confusing naming.
  inline bool IsLength() const;
  inline const StyleLength& AsLength() const;
};

/// A computed type for `<length-percentage> | auto`.
using StyleLengthPercentageOrAuto = StyleGenericLengthPercentageOrAuto<StyleLengthPercentage>;

/// A wrapper of Number, but the value >= 0.
using StyleNonNegativeNumber = StyleNonNegative<StyleCSSFloat>;

/// A wrapper of Length, whose value must be >= 0.
using StyleNonNegativeLength = StyleNonNegative<StyleLength>;

/// A generic value for the `line-height` property.
template<typename N, typename L>
struct StyleGenericLineHeight {
  enum class Tag : uint8_t {
    /// `normal`
    Normal,
    /// `-moz-block-height`
    MozBlockHeight,
    /// `<number>`
    Number,
    /// `<length-percentage>`
    Length,
  };

  struct StyleNumber_Body {
    N _0;

    bool operator==(const StyleNumber_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleNumber_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleLength_Body {
    L _0;

    bool operator==(const StyleLength_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleLength_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleNumber_Body number;
    StyleLength_Body length;
  };

  static StyleGenericLineHeight Normal() {
    StyleGenericLineHeight result;
    result.tag = Tag::Normal;
    return result;
  }

  static StyleGenericLineHeight MozBlockHeight() {
    StyleGenericLineHeight result;
    result.tag = Tag::MozBlockHeight;
    return result;
  }

  static StyleGenericLineHeight Number(const N &a0) {
    StyleGenericLineHeight result;
    ::new (&result.number._0) (N)(a0);
    result.tag = Tag::Number;
    return result;
  }

  static StyleGenericLineHeight Length(const L &a0) {
    StyleGenericLineHeight result;
    ::new (&result.length._0) (L)(a0);
    result.tag = Tag::Length;
    return result;
  }

  bool IsNormal() const {
    return tag == Tag::Normal;
  }

  bool IsMozBlockHeight() const {
    return tag == Tag::MozBlockHeight;
  }

  bool IsNumber() const {
    return tag == Tag::Number;
  }

  bool IsLength() const {
    return tag == Tag::Length;
  }

  const N& AsNumber() const {
    MOZ_ASSERT(IsNumber());
    return number._0;
  }

  const L& AsLength() const {
    MOZ_ASSERT(IsLength());
    return length._0;
  }

  bool operator==(const StyleGenericLineHeight& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Number: return number == other.number;
      case Tag::Length: return length == other.length;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericLineHeight& other) const {
    return !(*this == other);
  }

  ~StyleGenericLineHeight() {
    switch (tag) {
      case Tag::Number: number.~StyleNumber_Body(); break;
      case Tag::Length: length.~StyleLength_Body(); break;
      default: break;
    }
  }
};

/// A computed value for the `line-height` property.
using StyleLineHeight = StyleGenericLineHeight<StyleNonNegativeNumber, StyleNonNegativeLength>;

/// A wrapper of LengthPercentageOrAuto, whose value must be >= 0.
using StyleNonNegativeLengthPercentageOrAuto = StyleGenericLengthPercentageOrAuto<StyleNonNegativeLengthPercentage>;

/// A generic `<length-percentage>` | normal` value.
template<typename LengthPercent>
struct StyleGenericLengthPercentageOrNormal {
  enum class Tag : uint8_t {
    LengthPercentage,
    Normal,
  };

  struct StyleLengthPercentage_Body {
    LengthPercent _0;

    bool operator==(const StyleLengthPercentage_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleLengthPercentage_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleLengthPercentage_Body length_percentage;
  };

  static StyleGenericLengthPercentageOrNormal LengthPercentage(const LengthPercent &a0) {
    StyleGenericLengthPercentageOrNormal result;
    ::new (&result.length_percentage._0) (LengthPercent)(a0);
    result.tag = Tag::LengthPercentage;
    return result;
  }

  static StyleGenericLengthPercentageOrNormal Normal() {
    StyleGenericLengthPercentageOrNormal result;
    result.tag = Tag::Normal;
    return result;
  }

  bool IsLengthPercentage() const {
    return tag == Tag::LengthPercentage;
  }

  bool IsNormal() const {
    return tag == Tag::Normal;
  }

  const LengthPercent& AsLengthPercentage() const {
    MOZ_ASSERT(IsLengthPercentage());
    return length_percentage._0;
  }

  bool operator==(const StyleGenericLengthPercentageOrNormal& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::LengthPercentage: return length_percentage == other.length_percentage;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericLengthPercentageOrNormal& other) const {
    return !(*this == other);
  }

  ~StyleGenericLengthPercentageOrNormal() {
    switch (tag) {
      case Tag::LengthPercentage: length_percentage.~StyleLengthPercentage_Body(); break;
      default: break;
    }
  }
};

/// Either a computed NonNegativeLengthPercentage or the `normal` keyword.
using StyleNonNegativeLengthPercentageOrNormal = StyleGenericLengthPercentageOrNormal<StyleNonNegativeLengthPercentage>;

/// Either a computed `<length>` or the `auto` keyword.
using StyleLengthOrAuto = StyleGenericLengthPercentageOrAuto<StyleLength>;

/// Either a non-negative `<length>` or the `auto` keyword.
using StyleNonNegativeLengthOrAuto = StyleGenericLengthPercentageOrAuto<StyleNonNegativeLength>;

/// A generic value for the `width`, `height`, `min-width`, or `min-height` property.
/// Unlike `max-width` or `max-height` properties, a Size can be `auto`,
/// and cannot be `none`.
/// Note that it only accepts non-negative values.
template<typename LengthPercent>
struct StyleGenericSize {
  enum class Tag : uint8_t {
    LengthPercentage,
    Auto,
    ExtremumLength,
  };

  struct StyleLengthPercentage_Body {
    LengthPercent _0;

    bool operator==(const StyleLengthPercentage_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleLengthPercentage_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleExtremumLength_Body {
    StyleExtremumLength _0;

    bool operator==(const StyleExtremumLength_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleExtremumLength_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleLengthPercentage_Body length_percentage;
    StyleExtremumLength_Body extremum_length;
  };

  static StyleGenericSize LengthPercentage(const LengthPercent &a0) {
    StyleGenericSize result;
    ::new (&result.length_percentage._0) (LengthPercent)(a0);
    result.tag = Tag::LengthPercentage;
    return result;
  }

  static StyleGenericSize Auto() {
    StyleGenericSize result;
    result.tag = Tag::Auto;
    return result;
  }

  static StyleGenericSize ExtremumLength(const StyleExtremumLength &a0) {
    StyleGenericSize result;
    ::new (&result.extremum_length._0) (StyleExtremumLength)(a0);
    result.tag = Tag::ExtremumLength;
    return result;
  }

  bool IsLengthPercentage() const {
    return tag == Tag::LengthPercentage;
  }

  bool IsAuto() const {
    return tag == Tag::Auto;
  }

  bool IsExtremumLength() const {
    return tag == Tag::ExtremumLength;
  }

  const LengthPercent& AsLengthPercentage() const {
    MOZ_ASSERT(IsLengthPercentage());
    return length_percentage._0;
  }

  const StyleExtremumLength& AsExtremumLength() const {
    MOZ_ASSERT(IsExtremumLength());
    return extremum_length._0;
  }

  bool operator==(const StyleGenericSize& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::LengthPercentage: return length_percentage == other.length_percentage;
      case Tag::ExtremumLength: return extremum_length == other.extremum_length;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericSize& other) const {
    return !(*this == other);
  }

  ~StyleGenericSize() {
    switch (tag) {
      case Tag::LengthPercentage: length_percentage.~StyleLengthPercentage_Body(); break;
      case Tag::ExtremumLength: extremum_length.~StyleExtremumLength_Body(); break;
      default: break;
    }
  }
  inline bool ConvertsToLength() const;
  inline nscoord ToLength() const;
  inline bool ConvertsToPercentage() const;
  inline float ToPercentage() const;
  inline bool HasPercent() const;
  inline bool HasLengthAndPercentage() const;
  inline bool BehavesLikeInitialValueOnBlockAxis() const;
};

/// A computed value for `min-width`, `min-height`, `width` or `height` property.
using StyleSize = StyleGenericSize<StyleNonNegativeLengthPercentage>;

/// A generic value for the `max-width` or `max-height` property.
template<typename LengthPercent>
struct StyleGenericMaxSize {
  enum class Tag : uint8_t {
    LengthPercentage,
    None,
    ExtremumLength,
  };

  struct StyleLengthPercentage_Body {
    LengthPercent _0;

    bool operator==(const StyleLengthPercentage_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleLengthPercentage_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleExtremumLength_Body {
    StyleExtremumLength _0;

    bool operator==(const StyleExtremumLength_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleExtremumLength_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleLengthPercentage_Body length_percentage;
    StyleExtremumLength_Body extremum_length;
  };

  static StyleGenericMaxSize LengthPercentage(const LengthPercent &a0) {
    StyleGenericMaxSize result;
    ::new (&result.length_percentage._0) (LengthPercent)(a0);
    result.tag = Tag::LengthPercentage;
    return result;
  }

  static StyleGenericMaxSize None() {
    StyleGenericMaxSize result;
    result.tag = Tag::None;
    return result;
  }

  static StyleGenericMaxSize ExtremumLength(const StyleExtremumLength &a0) {
    StyleGenericMaxSize result;
    ::new (&result.extremum_length._0) (StyleExtremumLength)(a0);
    result.tag = Tag::ExtremumLength;
    return result;
  }

  bool IsLengthPercentage() const {
    return tag == Tag::LengthPercentage;
  }

  bool IsNone() const {
    return tag == Tag::None;
  }

  bool IsExtremumLength() const {
    return tag == Tag::ExtremumLength;
  }

  const LengthPercent& AsLengthPercentage() const {
    MOZ_ASSERT(IsLengthPercentage());
    return length_percentage._0;
  }

  const StyleExtremumLength& AsExtremumLength() const {
    MOZ_ASSERT(IsExtremumLength());
    return extremum_length._0;
  }

  bool operator==(const StyleGenericMaxSize& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::LengthPercentage: return length_percentage == other.length_percentage;
      case Tag::ExtremumLength: return extremum_length == other.extremum_length;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericMaxSize& other) const {
    return !(*this == other);
  }

  ~StyleGenericMaxSize() {
    switch (tag) {
      case Tag::LengthPercentage: length_percentage.~StyleLengthPercentage_Body(); break;
      case Tag::ExtremumLength: extremum_length.~StyleExtremumLength_Body(); break;
      default: break;
    }
  }
  inline bool ConvertsToLength() const;
  inline nscoord ToLength() const;
  inline bool ConvertsToPercentage() const;
  inline float ToPercentage() const;
  inline bool HasPercent() const;
  inline bool HasLengthAndPercentage() const;
  inline bool BehavesLikeInitialValueOnBlockAxis() const;
};

/// A computed value for `max-width` or `min-height` property.
using StyleMaxSize = StyleGenericMaxSize<StyleNonNegativeLengthPercentage>;

/// A generic value for the `flex-basis` property.
template<typename S>
struct StyleGenericFlexBasis {
  enum class Tag {
    /// `content`
    Content,
    /// `<width>`
    Size,
  };

  struct StyleSize_Body {
    S _0;

    bool operator==(const StyleSize_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleSize_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleSize_Body size;
  };

  static StyleGenericFlexBasis Content() {
    StyleGenericFlexBasis result;
    result.tag = Tag::Content;
    return result;
  }

  static StyleGenericFlexBasis Size(const S &a0) {
    StyleGenericFlexBasis result;
    ::new (&result.size._0) (S)(a0);
    result.tag = Tag::Size;
    return result;
  }

  bool IsContent() const {
    return tag == Tag::Content;
  }

  bool IsSize() const {
    return tag == Tag::Size;
  }

  const S& AsSize() const {
    MOZ_ASSERT(IsSize());
    return size._0;
  }

  bool operator==(const StyleGenericFlexBasis& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Size: return size == other.size;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericFlexBasis& other) const {
    return !(*this == other);
  }

  ~StyleGenericFlexBasis() {
    switch (tag) {
      case Tag::Size: size.~StyleSize_Body(); break;
      default: break;
    }
  }
  inline bool IsAuto() const;
};

/// A computed value for the `flex-basis` property.
using StyleFlexBasis = StyleGenericFlexBasis<StyleSize>;

/// The computed value of a CSS horizontal position.
using StyleHorizontalPosition = StyleLengthPercentage;

/// The computed value of a CSS vertical position.
using StyleVerticalPosition = StyleLengthPercentage;

/// The computed value of a CSS `<position>`
using StylePosition = StyleGenericPosition<StyleHorizontalPosition, StyleVerticalPosition>;

/// A generic value for the `background-size` property.
template<typename LengthPercent>
struct StyleGenericBackgroundSize {
  enum class Tag : uint8_t {
    /// `<width> <height>`
    ExplicitSize,
    /// `cover`
    Cover,
    /// `contain`
    Contain,
  };

  struct StyleExplicitSize_Body {
    /// Explicit width.
    StyleGenericLengthPercentageOrAuto<LengthPercent> width;
    /// Explicit height.
    /// NOTE(emilio): We should probably simplify all these in case `width`
    /// and `height` are the same, but all other browsers agree on only
    /// special-casing `auto`.
    StyleGenericLengthPercentageOrAuto<LengthPercent> height;

    bool operator==(const StyleExplicitSize_Body& other) const {
      return width == other.width &&
             height == other.height;
    }
    bool operator!=(const StyleExplicitSize_Body& other) const {
      return width != other.width ||
             height != other.height;
    }
  };

  Tag tag;
  union {
    StyleExplicitSize_Body explicit_size;
  };

  static StyleGenericBackgroundSize ExplicitSize(const StyleGenericLengthPercentageOrAuto<LengthPercent> &aWidth,
                                                 const StyleGenericLengthPercentageOrAuto<LengthPercent> &aHeight) {
    StyleGenericBackgroundSize result;
    ::new (&result.explicit_size.width) (StyleGenericLengthPercentageOrAuto<LengthPercent>)(aWidth);
    ::new (&result.explicit_size.height) (StyleGenericLengthPercentageOrAuto<LengthPercent>)(aHeight);
    result.tag = Tag::ExplicitSize;
    return result;
  }

  static StyleGenericBackgroundSize Cover() {
    StyleGenericBackgroundSize result;
    result.tag = Tag::Cover;
    return result;
  }

  static StyleGenericBackgroundSize Contain() {
    StyleGenericBackgroundSize result;
    result.tag = Tag::Contain;
    return result;
  }

  bool IsExplicitSize() const {
    return tag == Tag::ExplicitSize;
  }

  bool IsCover() const {
    return tag == Tag::Cover;
  }

  bool IsContain() const {
    return tag == Tag::Contain;
  }

  const StyleExplicitSize_Body& AsExplicitSize() const {
    MOZ_ASSERT(IsExplicitSize());
    return explicit_size;
  }

  bool operator==(const StyleGenericBackgroundSize& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::ExplicitSize: return explicit_size == other.explicit_size;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericBackgroundSize& other) const {
    return !(*this == other);
  }

  ~StyleGenericBackgroundSize() {
    switch (tag) {
      case Tag::ExplicitSize: explicit_size.~StyleExplicitSize_Body(); break;
      default: break;
    }
  }
  bool IsInitialValue() const;
};

/// A computed value for the `background-size` property.
using StyleBackgroundSize = StyleGenericBackgroundSize<StyleNonNegativeLengthPercentage>;

struct StyleNumberOrPercentage {
  enum class Tag : uint8_t {
    Percentage,
    Number,
  };

  struct StylePercentage_Body {
    StylePercentage _0;

    bool operator==(const StylePercentage_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StylePercentage_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleNumber_Body {
    StyleNumber _0;

    bool operator==(const StyleNumber_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleNumber_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StylePercentage_Body percentage;
    StyleNumber_Body number;
  };

  static StyleNumberOrPercentage Percentage(const StylePercentage &a0) {
    StyleNumberOrPercentage result;
    ::new (&result.percentage._0) (StylePercentage)(a0);
    result.tag = Tag::Percentage;
    return result;
  }

  static StyleNumberOrPercentage Number(const StyleNumber &a0) {
    StyleNumberOrPercentage result;
    ::new (&result.number._0) (StyleNumber)(a0);
    result.tag = Tag::Number;
    return result;
  }

  bool IsPercentage() const {
    return tag == Tag::Percentage;
  }

  bool IsNumber() const {
    return tag == Tag::Number;
  }

  const StylePercentage& AsPercentage() const {
    MOZ_ASSERT(IsPercentage());
    return percentage._0;
  }

  const StyleNumber& AsNumber() const {
    MOZ_ASSERT(IsNumber());
    return number._0;
  }

  bool operator==(const StyleNumberOrPercentage& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Percentage: return percentage == other.percentage;
      case Tag::Number: return number == other.number;
      default: return true;
    }
  }

  bool operator!=(const StyleNumberOrPercentage& other) const {
    return !(*this == other);
  }

  ~StyleNumberOrPercentage() {
    switch (tag) {
      case Tag::Percentage: percentage.~StylePercentage_Body(); break;
      case Tag::Number: number.~StyleNumber_Body(); break;
      default: break;
    }
  }
};

/// A non-negative <number-percentage>.
using StyleNonNegativeNumberOrPercentage = StyleNonNegative<StyleNumberOrPercentage>;

/// A generic value for the `border-image-slice` property.
template<typename NumberOrPercentage>
struct StyleGenericBorderImageSlice {
  /// The offsets.
  StyleRect<NumberOrPercentage> offsets;
  /// Whether to fill the middle part.
  bool fill;

  bool operator==(const StyleGenericBorderImageSlice& other) const {
    return offsets == other.offsets &&
           fill == other.fill;
  }
  bool operator!=(const StyleGenericBorderImageSlice& other) const {
    return offsets != other.offsets ||
           fill != other.fill;
  }
};

/// A computed value for the `border-image-slice` property.
using StyleBorderImageSlice = StyleGenericBorderImageSlice<StyleNonNegativeNumberOrPercentage>;

/// A generic value for the `border-spacing` property.
template<typename L>
using StyleBorderSpacing = StyleSize2D<L>;

/// A generic `<length>` | `<number>` value for the `-moz-tab-size` property.
template<typename L, typename N>
struct StyleGenericLengthOrNumber {
  enum class Tag : uint8_t {
    /// A number.
    /// NOTE: Numbers need to be before lengths, in order to parse them
    /// first, since `0` should be a number, not the `0px` length.
    Number,
    /// A length.
    Length,
  };

  struct StyleNumber_Body {
    N _0;

    bool operator==(const StyleNumber_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleNumber_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleLength_Body {
    L _0;

    bool operator==(const StyleLength_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleLength_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleNumber_Body number;
    StyleLength_Body length;
  };

  static StyleGenericLengthOrNumber Number(const N &a0) {
    StyleGenericLengthOrNumber result;
    ::new (&result.number._0) (N)(a0);
    result.tag = Tag::Number;
    return result;
  }

  static StyleGenericLengthOrNumber Length(const L &a0) {
    StyleGenericLengthOrNumber result;
    ::new (&result.length._0) (L)(a0);
    result.tag = Tag::Length;
    return result;
  }

  bool IsNumber() const {
    return tag == Tag::Number;
  }

  bool IsLength() const {
    return tag == Tag::Length;
  }

  const N& AsNumber() const {
    MOZ_ASSERT(IsNumber());
    return number._0;
  }

  const L& AsLength() const {
    MOZ_ASSERT(IsLength());
    return length._0;
  }

  bool operator==(const StyleGenericLengthOrNumber& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Number: return number == other.number;
      case Tag::Length: return length == other.length;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericLengthOrNumber& other) const {
    return !(*this == other);
  }

  ~StyleGenericLengthOrNumber() {
    switch (tag) {
      case Tag::Number: number.~StyleNumber_Body(); break;
      case Tag::Length: length.~StyleLength_Body(); break;
      default: break;
    }
  }
};

/// Either a non-negative `<length>` or a `<number>`.
using StyleNonNegativeLengthOrNumber = StyleGenericLengthOrNumber<StyleNonNegativeLength, StyleNonNegativeNumber>;

/// A specified rectangle made of four `<length-or-number>` values.
using StyleNonNegativeLengthOrNumberRect = StyleRect<StyleNonNegativeLengthOrNumber>;

/// A generic value for the `perspective` property.
template<typename NonNegativeLength>
struct StyleGenericPerspective {
  enum class Tag : uint8_t {
    /// A non-negative length.
    Length,
    /// The keyword `none`.
    None,
  };

  struct StyleLength_Body {
    NonNegativeLength _0;

    bool operator==(const StyleLength_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleLength_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleLength_Body length;
  };

  static StyleGenericPerspective Length(const NonNegativeLength &a0) {
    StyleGenericPerspective result;
    ::new (&result.length._0) (NonNegativeLength)(a0);
    result.tag = Tag::Length;
    return result;
  }

  static StyleGenericPerspective None() {
    StyleGenericPerspective result;
    result.tag = Tag::None;
    return result;
  }

  bool IsLength() const {
    return tag == Tag::Length;
  }

  bool IsNone() const {
    return tag == Tag::None;
  }

  const NonNegativeLength& AsLength() const {
    MOZ_ASSERT(IsLength());
    return length._0;
  }

  bool operator==(const StyleGenericPerspective& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Length: return length == other.length;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericPerspective& other) const {
    return !(*this == other);
  }

  ~StyleGenericPerspective() {
    switch (tag) {
      case Tag::Length: length.~StyleLength_Body(); break;
      default: break;
    }
  }
};

/// A computed value for the `perspective` property.
using StylePerspective = StyleGenericPerspective<StyleNonNegativeLength>;

/// A generic value for the `z-index` property.
template<typename I>
struct StyleGenericZIndex {
  enum class Tag : uint8_t {
    /// An integer value.
    Integer,
    /// The keyword `auto`.
    Auto,
  };

  struct StyleInteger_Body {
    I _0;

    bool operator==(const StyleInteger_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleInteger_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleInteger_Body integer;
  };

  static StyleGenericZIndex Integer(const I &a0) {
    StyleGenericZIndex result;
    ::new (&result.integer._0) (I)(a0);
    result.tag = Tag::Integer;
    return result;
  }

  static StyleGenericZIndex Auto() {
    StyleGenericZIndex result;
    result.tag = Tag::Auto;
    return result;
  }

  bool IsInteger() const {
    return tag == Tag::Integer;
  }

  bool IsAuto() const {
    return tag == Tag::Auto;
  }

  const I& AsInteger() const {
    MOZ_ASSERT(IsInteger());
    return integer._0;
  }

  bool operator==(const StyleGenericZIndex& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Integer: return integer == other.integer;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericZIndex& other) const {
    return !(*this == other);
  }

  ~StyleGenericZIndex() {
    switch (tag) {
      case Tag::Integer: integer.~StyleInteger_Body(); break;
      default: break;
    }
  }
};

/// A computed value for the `z-index` property.
using StyleZIndex = StyleGenericZIndex<StyleInteger>;

/// A generic transform origin.
template<typename H, typename V, typename Depth>
struct StyleGenericTransformOrigin {
  /// The horizontal origin.
  H horizontal;
  /// The vertical origin.
  V vertical;
  /// The depth.
  Depth depth;

  bool operator==(const StyleGenericTransformOrigin& other) const {
    return horizontal == other.horizontal &&
           vertical == other.vertical &&
           depth == other.depth;
  }
  bool operator!=(const StyleGenericTransformOrigin& other) const {
    return horizontal != other.horizontal ||
           vertical != other.vertical ||
           depth != other.depth;
  }
};

/// The computed value of a CSS `<transform-origin>`
using StyleTransformOrigin = StyleGenericTransformOrigin<StyleLengthPercentage, StyleLengthPercentage, StyleLength>;

/// Constants for contain: https://drafts.csswg.org/css-contain/#contain-property
struct StyleContain {
  uint8_t bits;

  explicit operator bool() const {
    return !!bits;
  }
  StyleContain operator|(const StyleContain& other) const {
    return {static_cast<decltype(bits)>(this->bits | other.bits)};
  }
  StyleContain& operator|=(const StyleContain& other) {
    *this = (*this | other);
    return *this;
  }
  StyleContain operator&(const StyleContain& other) const {
    return {static_cast<decltype(bits)>(this->bits & other.bits)};
  }
  StyleContain& operator&=(const StyleContain& other) {
    *this = (*this & other);
    return *this;
  }
  bool operator==(const StyleContain& other) const {
    return bits == other.bits;
  }
  bool operator!=(const StyleContain& other) const {
    return bits != other.bits;
  }
};
static const StyleContain StyleContain_NONE = (StyleContain){ .bits = 0 };
static const StyleContain StyleContain_SIZE = (StyleContain){ .bits = 1 << 0 };
static const StyleContain StyleContain_LAYOUT = (StyleContain){ .bits = 1 << 1 };
static const StyleContain StyleContain_PAINT = (StyleContain){ .bits = 1 << 2 };
static const StyleContain StyleContain_STRICT = (StyleContain){ .bits = 1 << 3 };
static const StyleContain StyleContain_CONTENT = (StyleContain){ .bits = 1 << 4 };

/// Values for the `touch-action` property.
/// These constants match Gecko's `NS_STYLE_TOUCH_ACTION_*` constants.
struct StyleTouchAction {
  uint8_t bits;

  explicit operator bool() const {
    return !!bits;
  }
  StyleTouchAction operator|(const StyleTouchAction& other) const {
    return {static_cast<decltype(bits)>(this->bits | other.bits)};
  }
  StyleTouchAction& operator|=(const StyleTouchAction& other) {
    *this = (*this | other);
    return *this;
  }
  StyleTouchAction operator&(const StyleTouchAction& other) const {
    return {static_cast<decltype(bits)>(this->bits & other.bits)};
  }
  StyleTouchAction& operator&=(const StyleTouchAction& other) {
    *this = (*this & other);
    return *this;
  }
  bool operator==(const StyleTouchAction& other) const {
    return bits == other.bits;
  }
  bool operator!=(const StyleTouchAction& other) const {
    return bits != other.bits;
  }
};
static const StyleTouchAction StyleTouchAction_NONE = (StyleTouchAction){ .bits = 1 << 0 };
static const StyleTouchAction StyleTouchAction_AUTO = (StyleTouchAction){ .bits = 1 << 1 };
static const StyleTouchAction StyleTouchAction_PAN_X = (StyleTouchAction){ .bits = 1 << 2 };
static const StyleTouchAction StyleTouchAction_PAN_Y = (StyleTouchAction){ .bits = 1 << 3 };
static const StyleTouchAction StyleTouchAction_MANIPULATION = (StyleTouchAction){ .bits = 1 << 4 };

/// A handle to a Gecko atom.
/// This is either a strong reference to a dynamic atom (an nsAtom pointer),
/// or an offset from gGkAtoms to the nsStaticAtom object.
struct StyleAtom {
  uintptr_t _0;

  bool operator==(const StyleAtom& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StyleAtom& other) const {
    return _0 != other._0;
  }
  StyleAtom(size_t) = delete;
  StyleAtom() = delete;

  // NOTE(emilio): For now we don't need to expose anything else, but it'd be trivial if we wanted to.
  inline bool IsStatic() const;
  inline nsAtom* AsAtom() const;

  inline StyleAtom(const StyleAtom& aOther);
  inline ~StyleAtom();
};

/// <https://drafts.csswg.org/css-values-4/#custom-idents>
struct StyleCustomIdent {
  StyleAtom _0;

  bool operator==(const StyleCustomIdent& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StyleCustomIdent& other) const {
    return _0 != other._0;
  }
  inline nsAtom* AsAtom() const;
};

/// The change bits that we care about.
struct StyleWillChangeBits {
  uint8_t bits;

  explicit operator bool() const {
    return !!bits;
  }
  StyleWillChangeBits operator|(const StyleWillChangeBits& other) const {
    return {static_cast<decltype(bits)>(this->bits | other.bits)};
  }
  StyleWillChangeBits& operator|=(const StyleWillChangeBits& other) {
    *this = (*this | other);
    return *this;
  }
  StyleWillChangeBits operator&(const StyleWillChangeBits& other) const {
    return {static_cast<decltype(bits)>(this->bits & other.bits)};
  }
  StyleWillChangeBits& operator&=(const StyleWillChangeBits& other) {
    *this = (*this & other);
    return *this;
  }
  bool operator==(const StyleWillChangeBits& other) const {
    return bits == other.bits;
  }
  bool operator!=(const StyleWillChangeBits& other) const {
    return bits != other.bits;
  }
};
static const StyleWillChangeBits StyleWillChangeBits_STACKING_CONTEXT = (StyleWillChangeBits){ .bits = 1 << 0 };
static const StyleWillChangeBits StyleWillChangeBits_TRANSFORM = (StyleWillChangeBits){ .bits = 1 << 1 };
static const StyleWillChangeBits StyleWillChangeBits_SCROLL = (StyleWillChangeBits){ .bits = 1 << 2 };
static const StyleWillChangeBits StyleWillChangeBits_OPACITY = (StyleWillChangeBits){ .bits = 1 << 3 };
static const StyleWillChangeBits StyleWillChangeBits_FIXPOS_CB = (StyleWillChangeBits){ .bits = 1 << 4 };
static const StyleWillChangeBits StyleWillChangeBits_ABSPOS_CB = (StyleWillChangeBits){ .bits = 1 << 5 };

/// Provides a rendering hint to the user agent, stating what kinds of changes
/// the author expects to perform on the element.
/// `auto` is represented by an empty `features` list.
/// <https://drafts.csswg.org/css-will-change/#will-change>
struct StyleWillChange {
  /// The features that are supposed to change.
  /// TODO(emilio): Consider using ArcSlice since we just clone them from the
  /// specified value? That'd save an allocation, which could be worth it.
  StyleOwnedSlice<StyleCustomIdent> features;
  /// A bitfield with the kind of change that the value will create, based
  /// on the above field.
  StyleWillChangeBits bits;

  bool operator==(const StyleWillChange& other) const {
    return features == other.features &&
           bits == other.bits;
  }
  bool operator!=(const StyleWillChange& other) const {
    return features != other.features ||
           bits != other.bits;
  }
};

/// Specified keyword values for the text-decoration-line property.
struct StyleTextDecorationLine {
  uint8_t bits;

  explicit operator bool() const {
    return !!bits;
  }
  StyleTextDecorationLine operator|(const StyleTextDecorationLine& other) const {
    return {static_cast<decltype(bits)>(this->bits | other.bits)};
  }
  StyleTextDecorationLine& operator|=(const StyleTextDecorationLine& other) {
    *this = (*this | other);
    return *this;
  }
  StyleTextDecorationLine operator&(const StyleTextDecorationLine& other) const {
    return {static_cast<decltype(bits)>(this->bits & other.bits)};
  }
  StyleTextDecorationLine& operator&=(const StyleTextDecorationLine& other) {
    *this = (*this & other);
    return *this;
  }
  bool operator==(const StyleTextDecorationLine& other) const {
    return bits == other.bits;
  }
  bool operator!=(const StyleTextDecorationLine& other) const {
    return bits != other.bits;
  }
};
static const StyleTextDecorationLine StyleTextDecorationLine_NONE = (StyleTextDecorationLine){ .bits = 0 };
static const StyleTextDecorationLine StyleTextDecorationLine_UNDERLINE = (StyleTextDecorationLine){ .bits = 1 << 0 };
static const StyleTextDecorationLine StyleTextDecorationLine_OVERLINE = (StyleTextDecorationLine){ .bits = 1 << 1 };
static const StyleTextDecorationLine StyleTextDecorationLine_LINE_THROUGH = (StyleTextDecorationLine){ .bits = 1 << 2 };
static const StyleTextDecorationLine StyleTextDecorationLine_BLINK = (StyleTextDecorationLine){ .bits = 1 << 3 };
static const StyleTextDecorationLine StyleTextDecorationLine_COLOR_OVERRIDE = (StyleTextDecorationLine){ .bits = 16 };

/// Specified keyword values for non-case transforms in the text-transform property. (Non-exclusive.)
struct StyleTextTransformOther {
  uint8_t bits;

  explicit operator bool() const {
    return !!bits;
  }
  StyleTextTransformOther operator|(const StyleTextTransformOther& other) const {
    return {static_cast<decltype(bits)>(this->bits | other.bits)};
  }
  StyleTextTransformOther& operator|=(const StyleTextTransformOther& other) {
    *this = (*this | other);
    return *this;
  }
  StyleTextTransformOther operator&(const StyleTextTransformOther& other) const {
    return {static_cast<decltype(bits)>(this->bits & other.bits)};
  }
  StyleTextTransformOther& operator&=(const StyleTextTransformOther& other) {
    *this = (*this & other);
    return *this;
  }
  bool operator==(const StyleTextTransformOther& other) const {
    return bits == other.bits;
  }
  bool operator!=(const StyleTextTransformOther& other) const {
    return bits != other.bits;
  }
};
static const StyleTextTransformOther StyleTextTransformOther_FULL_WIDTH = (StyleTextTransformOther){ .bits = 1 << 0 };
static const StyleTextTransformOther StyleTextTransformOther_FULL_SIZE_KANA = (StyleTextTransformOther){ .bits = 1 << 1 };

/// Specified value of the text-transform property, stored in two parts:
/// the case-related transforms (mutually exclusive, only one may be in effect), and others (non-exclusive).
struct StyleTextTransform {
  /// Case transform, if any.
  StyleTextTransformCase case_;
  /// Non-case transforms.
  StyleTextTransformOther other_;

  bool operator==(const StyleTextTransform& other) const {
    return case_ == other.case_ &&
           other_ == other.other_;
  }
  bool operator!=(const StyleTextTransform& other) const {
    return case_ != other.case_ ||
           other_ != other.other_;
  }
  static inline StyleTextTransform None();
  inline bool IsNone() const;
};

/// A color with red, green, blue, and alpha components, in a byte each.
struct StyleRGBA {
  /// The red component.
  uint8_t red;
  /// The green component.
  uint8_t green;
  /// The blue component.
  uint8_t blue;
  /// The alpha component.
  uint8_t alpha;

  bool operator==(const StyleRGBA& other) const {
    return red == other.red &&
           green == other.green &&
           blue == other.blue &&
           alpha == other.alpha;
  }
  bool operator!=(const StyleRGBA& other) const {
    return red != other.red ||
           green != other.green ||
           blue != other.blue ||
           alpha != other.alpha;
  }
  static inline StyleRGBA Transparent();
  static inline StyleRGBA FromColor(nscolor);

  inline nscolor ToColor() const;
};

/// Ratios representing the contribution of color and currentcolor to
/// the final color value.
struct StyleComplexColorRatios {
  /// Numeric color contribution.
  float bg;
  /// currentcolor contribution.
  float fg;

  bool operator==(const StyleComplexColorRatios& other) const {
    return bg == other.bg &&
           fg == other.fg;
  }
  bool operator!=(const StyleComplexColorRatios& other) const {
    return bg != other.bg ||
           fg != other.fg;
  }
};
static const StyleComplexColorRatios StyleComplexColorRatios_NUMERIC = (StyleComplexColorRatios){ .bg = 1, .fg = 0 };
static const StyleComplexColorRatios StyleComplexColorRatios_CURRENT_COLOR = (StyleComplexColorRatios){ .bg = 0, .fg = 1 };

/// This enum represents a combined color from a numeric color and
/// the current foreground color (currentcolor keyword).
template<typename RGBA>
struct StyleGenericColor {
  enum class Tag : uint8_t {
    /// Numeric RGBA color.
    Numeric,
    /// The current foreground color.
    CurrentColor,
    /// A linear combination of numeric color and currentcolor.
    /// The formula is: `color * ratios.bg + currentcolor * ratios.fg`.
    Complex,
  };

  struct StyleNumeric_Body {
    RGBA _0;

    bool operator==(const StyleNumeric_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleNumeric_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleComplex_Body {
    /// The actual numeric color.
    RGBA color;
    /// The ratios of mixing between numeric and currentcolor.
    StyleComplexColorRatios ratios;

    bool operator==(const StyleComplex_Body& other) const {
      return color == other.color &&
             ratios == other.ratios;
    }
    bool operator!=(const StyleComplex_Body& other) const {
      return color != other.color ||
             ratios != other.ratios;
    }
  };

  Tag tag;
  union {
    StyleNumeric_Body numeric;
    StyleComplex_Body complex;
  };

  static StyleGenericColor Numeric(const RGBA &a0) {
    StyleGenericColor result;
    ::new (&result.numeric._0) (RGBA)(a0);
    result.tag = Tag::Numeric;
    return result;
  }

  static StyleGenericColor CurrentColor() {
    StyleGenericColor result;
    result.tag = Tag::CurrentColor;
    return result;
  }

  static StyleGenericColor Complex(const RGBA &aColor,
                                   const StyleComplexColorRatios &aRatios) {
    StyleGenericColor result;
    ::new (&result.complex.color) (RGBA)(aColor);
    ::new (&result.complex.ratios) (StyleComplexColorRatios)(aRatios);
    result.tag = Tag::Complex;
    return result;
  }

  bool IsNumeric() const {
    return tag == Tag::Numeric;
  }

  bool IsCurrentColor() const {
    return tag == Tag::CurrentColor;
  }

  bool IsComplex() const {
    return tag == Tag::Complex;
  }

  const RGBA& AsNumeric() const {
    MOZ_ASSERT(IsNumeric());
    return numeric._0;
  }

  const StyleComplex_Body& AsComplex() const {
    MOZ_ASSERT(IsComplex());
    return complex;
  }

  bool operator==(const StyleGenericColor& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Numeric: return numeric == other.numeric;
      case Tag::Complex: return complex == other.complex;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericColor& other) const {
    return !(*this == other);
  }

  ~StyleGenericColor() {
    switch (tag) {
      case Tag::Numeric: numeric.~StyleNumeric_Body(); break;
      case Tag::Complex: complex.~StyleComplex_Body(); break;
      default: break;
    }
  }
  static inline StyleGenericColor FromColor(nscolor);
  static inline StyleGenericColor Black();
  static inline StyleGenericColor White();
  static inline StyleGenericColor Transparent();
  bool MaybeTransparent() const;
  /**
   * Compute the final color, taking into account the foreground color from the
   * frame's ComputedStyle.
   */
  nscolor CalcColor(const nsIFrame*) const;
  /**
   * Compute the final color, taking into account the foreground color from the
   * style.
   */
  nscolor CalcColor(const ComputedStyle&) const;
  /**
   * Compute the final color, making the argument the foreground color.
   */
  nscolor CalcColor(nscolor) const;
  nscolor CalcColor(const StyleRGBA&) const;
};

/// An animated value for `<color>`.
using StyleColor = StyleGenericColor<StyleRGBA>;

/// A generic value for `scrollbar-color` property.
/// https://drafts.csswg.org/css-scrollbars-1/#scrollbar-color
template<typename Color>
struct StyleGenericScrollbarColor {
  enum class Tag : uint8_t {
    /// `auto`
    Auto,
    /// `<color>{2}`
    Colors,
  };

  struct StyleColors_Body {
    /// First `<color>`, for color of the scrollbar thumb.
    Color thumb;
    /// Second `<color>`, for color of the scrollbar track.
    Color track;

    bool operator==(const StyleColors_Body& other) const {
      return thumb == other.thumb &&
             track == other.track;
    }
    bool operator!=(const StyleColors_Body& other) const {
      return thumb != other.thumb ||
             track != other.track;
    }
  };

  Tag tag;
  union {
    StyleColors_Body colors;
  };

  static StyleGenericScrollbarColor Auto() {
    StyleGenericScrollbarColor result;
    result.tag = Tag::Auto;
    return result;
  }

  static StyleGenericScrollbarColor Colors(const Color &aThumb,
                                           const Color &aTrack) {
    StyleGenericScrollbarColor result;
    ::new (&result.colors.thumb) (Color)(aThumb);
    ::new (&result.colors.track) (Color)(aTrack);
    result.tag = Tag::Colors;
    return result;
  }

  bool IsAuto() const {
    return tag == Tag::Auto;
  }

  bool IsColors() const {
    return tag == Tag::Colors;
  }

  const StyleColors_Body& AsColors() const {
    MOZ_ASSERT(IsColors());
    return colors;
  }

  bool operator==(const StyleGenericScrollbarColor& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Colors: return colors == other.colors;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericScrollbarColor& other) const {
    return !(*this == other);
  }

  ~StyleGenericScrollbarColor() {
    switch (tag) {
      case Tag::Colors: colors.~StyleColors_Body(); break;
      default: break;
    }
  }
};

/// A computed value for `scrollbar-color` property.
using StyleScrollbarColor = StyleGenericScrollbarColor<StyleColor>;

/// Either `<color>` or `auto`.
template<typename C>
struct StyleGenericColorOrAuto {
  enum class Tag : uint8_t {
    /// A `<color>`.
    Color,
    /// `auto`
    Auto,
  };

  struct StyleColor_Body {
    C _0;

    bool operator==(const StyleColor_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleColor_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleColor_Body color;
  };

  static StyleGenericColorOrAuto Color(const C &a0) {
    StyleGenericColorOrAuto result;
    ::new (&result.color._0) (C)(a0);
    result.tag = Tag::Color;
    return result;
  }

  static StyleGenericColorOrAuto Auto() {
    StyleGenericColorOrAuto result;
    result.tag = Tag::Auto;
    return result;
  }

  bool IsColor() const {
    return tag == Tag::Color;
  }

  bool IsAuto() const {
    return tag == Tag::Auto;
  }

  const C& AsColor() const {
    MOZ_ASSERT(IsColor());
    return color._0;
  }

  bool operator==(const StyleGenericColorOrAuto& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Color: return color == other.color;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericColorOrAuto& other) const {
    return !(*this == other);
  }

  ~StyleGenericColorOrAuto() {
    switch (tag) {
      case Tag::Color: color.~StyleColor_Body(); break;
      default: break;
    }
  }
};

/// auto | <color>
using StyleColorOrAuto = StyleGenericColorOrAuto<StyleColor>;

/// A gradient item.
/// <https://drafts.csswg.org/css-images-4/#color-stop-syntax>
template<typename Color, typename LengthPercentage>
struct StyleGenericGradientItem {
  enum class Tag : uint8_t {
    /// A simple color stop, without position.
    SimpleColorStop,
    /// A complex color stop, with a position.
    ComplexColorStop,
    /// An interpolation hint.
    InterpolationHint,
  };

  struct StyleSimpleColorStop_Body {
    Color _0;

    bool operator==(const StyleSimpleColorStop_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleSimpleColorStop_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleComplexColorStop_Body {
    /// The color for the stop.
    Color color;
    /// The position for the stop.
    LengthPercentage position;

    bool operator==(const StyleComplexColorStop_Body& other) const {
      return color == other.color &&
             position == other.position;
    }
    bool operator!=(const StyleComplexColorStop_Body& other) const {
      return color != other.color ||
             position != other.position;
    }
  };

  struct StyleInterpolationHint_Body {
    LengthPercentage _0;

    bool operator==(const StyleInterpolationHint_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleInterpolationHint_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleSimpleColorStop_Body simple_color_stop;
    StyleComplexColorStop_Body complex_color_stop;
    StyleInterpolationHint_Body interpolation_hint;
  };

  static StyleGenericGradientItem SimpleColorStop(const Color &a0) {
    StyleGenericGradientItem result;
    ::new (&result.simple_color_stop._0) (Color)(a0);
    result.tag = Tag::SimpleColorStop;
    return result;
  }

  static StyleGenericGradientItem ComplexColorStop(const Color &aColor,
                                                   const LengthPercentage &aPosition) {
    StyleGenericGradientItem result;
    ::new (&result.complex_color_stop.color) (Color)(aColor);
    ::new (&result.complex_color_stop.position) (LengthPercentage)(aPosition);
    result.tag = Tag::ComplexColorStop;
    return result;
  }

  static StyleGenericGradientItem InterpolationHint(const LengthPercentage &a0) {
    StyleGenericGradientItem result;
    ::new (&result.interpolation_hint._0) (LengthPercentage)(a0);
    result.tag = Tag::InterpolationHint;
    return result;
  }

  bool IsSimpleColorStop() const {
    return tag == Tag::SimpleColorStop;
  }

  bool IsComplexColorStop() const {
    return tag == Tag::ComplexColorStop;
  }

  bool IsInterpolationHint() const {
    return tag == Tag::InterpolationHint;
  }

  const Color& AsSimpleColorStop() const {
    MOZ_ASSERT(IsSimpleColorStop());
    return simple_color_stop._0;
  }

  const StyleComplexColorStop_Body& AsComplexColorStop() const {
    MOZ_ASSERT(IsComplexColorStop());
    return complex_color_stop;
  }

  const LengthPercentage& AsInterpolationHint() const {
    MOZ_ASSERT(IsInterpolationHint());
    return interpolation_hint._0;
  }

  bool operator==(const StyleGenericGradientItem& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::SimpleColorStop: return simple_color_stop == other.simple_color_stop;
      case Tag::ComplexColorStop: return complex_color_stop == other.complex_color_stop;
      case Tag::InterpolationHint: return interpolation_hint == other.interpolation_hint;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericGradientItem& other) const {
    return !(*this == other);
  }

  ~StyleGenericGradientItem() {
    switch (tag) {
      case Tag::SimpleColorStop: simple_color_stop.~StyleSimpleColorStop_Body(); break;
      case Tag::ComplexColorStop: complex_color_stop.~StyleComplexColorStop_Body(); break;
      case Tag::InterpolationHint: interpolation_hint.~StyleInterpolationHint_Body(); break;
      default: break;
    }
  }
};

/// A computed gradient item.
using StyleGradientItem = StyleGenericGradientItem<StyleColor, StyleLengthPercentage>;

/// A generic value for the `vertical-align` property.
template<typename LengthPercentage>
struct StyleGenericVerticalAlign {
  enum class Tag : uint8_t {
    /// One of the vertical-align keywords.
    Keyword,
    /// `<length-percentage>`
    Length,
  };

  struct StyleKeyword_Body {
    StyleVerticalAlignKeyword _0;

    bool operator==(const StyleKeyword_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleKeyword_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleLength_Body {
    LengthPercentage _0;

    bool operator==(const StyleLength_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleLength_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleKeyword_Body keyword;
    StyleLength_Body length;
  };

  static StyleGenericVerticalAlign Keyword(const StyleVerticalAlignKeyword &a0) {
    StyleGenericVerticalAlign result;
    ::new (&result.keyword._0) (StyleVerticalAlignKeyword)(a0);
    result.tag = Tag::Keyword;
    return result;
  }

  static StyleGenericVerticalAlign Length(const LengthPercentage &a0) {
    StyleGenericVerticalAlign result;
    ::new (&result.length._0) (LengthPercentage)(a0);
    result.tag = Tag::Length;
    return result;
  }

  bool IsKeyword() const {
    return tag == Tag::Keyword;
  }

  bool IsLength() const {
    return tag == Tag::Length;
  }

  const StyleVerticalAlignKeyword& AsKeyword() const {
    MOZ_ASSERT(IsKeyword());
    return keyword._0;
  }

  const LengthPercentage& AsLength() const {
    MOZ_ASSERT(IsLength());
    return length._0;
  }

  bool operator==(const StyleGenericVerticalAlign& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Keyword: return keyword == other.keyword;
      case Tag::Length: return length == other.length;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericVerticalAlign& other) const {
    return !(*this == other);
  }

  ~StyleGenericVerticalAlign() {
    switch (tag) {
      case Tag::Keyword: keyword.~StyleKeyword_Body(); break;
      case Tag::Length: length.~StyleLength_Body(); break;
      default: break;
    }
  }
};

/// A computed value for the `vertical-align` property.
using StyleVerticalAlign = StyleGenericVerticalAlign<StyleLengthPercentage>;

/// The computed value of `ShapeRadius`
using StyleShapeRadius = StyleGenericShapeRadius<StyleNonNegativeLengthPercentage>;

/// Header data with an inline length. Consumers that use HeaderWithLength as the
/// Header type in HeaderSlice can take advantage of ThinArc.
template<typename H>
struct StyleHeaderWithLength {
  /// The fixed-sized data.
  H header;
  /// The slice length.
  uintptr_t length;

  bool operator==(const StyleHeaderWithLength& other) const {
    return header == other.header &&
           length == other.length;
  }
  bool operator!=(const StyleHeaderWithLength& other) const {
    return header != other.header ||
           length != other.length;
  }
};

/// Structure to allow Arc-managing some fixed-sized data and a variably-sized
/// slice in a single allocation.
template<typename H, typename T>
struct StyleHeaderSlice {
  /// The fixed-sized data.
  H header;
  /// The dynamically-sized data.
  T slice;

  bool operator==(const StyleHeaderSlice& other) const {
    return header == other.header &&
           slice == other.slice;
  }
  bool operator!=(const StyleHeaderSlice& other) const {
    return header != other.header ||
           slice != other.slice;
  }
};

template<typename H, typename T>
using StyleHeaderSliceWithLength = StyleHeaderSlice<StyleHeaderWithLength<H>, T>;

/// The object allocated by an Arc<T>
template<typename T>
struct StyleArcInner {
  StyleAtomicUsize count;
  T data;

  bool operator==(const StyleArcInner& other) const {
    return count == other.count &&
           data == other.data;
  }
  bool operator!=(const StyleArcInner& other) const {
    return count != other.count ||
           data != other.data;
  }
};

/// A "thin" `Arc` containing dynamically sized data
/// This is functionally equivalent to Arc<(H, [T])>
/// When you create an `Arc` containing a dynamically sized type
/// like `HeaderSlice<H, [T]>`, the `Arc` is represented on the stack
/// as a "fat pointer", where the length of the slice is stored
/// alongside the `Arc`'s pointer. In some situations you may wish to
/// have a thin pointer instead, perhaps for FFI compatibility
/// or space efficiency.
/// Note that we use `[T; 0]` in order to have the right alignment for `T`.
/// `ThinArc` solves this by storing the length in the allocation itself,
/// via `HeaderSliceWithLength`.
template<typename H, typename T>
struct StyleThinArc {
  StyleArcInner<StyleHeaderSliceWithLength<H, T[0]>> *ptr;

  bool operator==(const StyleThinArc& other) const {
    return ptr == other.ptr;
  }
  bool operator!=(const StyleThinArc& other) const {
    return ptr != other.ptr;
  }
};

/// A wrapper type for a refcounted slice using ThinArc.
template<typename T>
struct StyleArcSlice {
  StyleThinArc<uint64_t, T> _0;
  inline StyleArcSlice();
  inline StyleArcSlice(const StyleArcSlice& aOther);

  // Should be easily implementable if wanted, but the default implementation would leak.
  StyleArcSlice& operator=(const StyleArcSlice&) = delete;
  StyleArcSlice& operator=(StyleArcSlice&&) = delete;

  inline explicit StyleArcSlice(const StyleForgottenArcSlicePtr<T>& aPtr);
  inline ~StyleArcSlice();
  inline Span<const T> AsSpan() const;
  inline size_t Length() const;
  inline bool IsEmpty() const;
  inline bool operator==(const StyleArcSlice& other) const;
  inline bool operator!=(const StyleArcSlice& other) const;
};

/// The context properties we understand.
struct StyleContextPropertyBits {
  uint8_t bits;

  explicit operator bool() const {
    return !!bits;
  }
  StyleContextPropertyBits operator|(const StyleContextPropertyBits& other) const {
    return {static_cast<decltype(bits)>(this->bits | other.bits)};
  }
  StyleContextPropertyBits& operator|=(const StyleContextPropertyBits& other) {
    *this = (*this | other);
    return *this;
  }
  StyleContextPropertyBits operator&(const StyleContextPropertyBits& other) const {
    return {static_cast<decltype(bits)>(this->bits & other.bits)};
  }
  StyleContextPropertyBits& operator&=(const StyleContextPropertyBits& other) {
    *this = (*this & other);
    return *this;
  }
  bool operator==(const StyleContextPropertyBits& other) const {
    return bits == other.bits;
  }
  bool operator!=(const StyleContextPropertyBits& other) const {
    return bits != other.bits;
  }
};
static const StyleContextPropertyBits StyleContextPropertyBits_FILL = (StyleContextPropertyBits){ .bits = 1 << 0 };
static const StyleContextPropertyBits StyleContextPropertyBits_STROKE = (StyleContextPropertyBits){ .bits = 1 << 1 };
static const StyleContextPropertyBits StyleContextPropertyBits_FILL_OPACITY = (StyleContextPropertyBits){ .bits = 1 << 2 };
static const StyleContextPropertyBits StyleContextPropertyBits_STROKE_OPACITY = (StyleContextPropertyBits){ .bits = 1 << 3 };

/// Specified MozContextProperties value.
/// Nonstandard (https://developer.mozilla.org/en-US/docs/Web/CSS/-moz-context-properties)
struct StyleMozContextProperties {
  StyleArcSlice<StyleCustomIdent> idents;
  StyleContextPropertyBits bits;

  bool operator==(const StyleMozContextProperties& other) const {
    return idents == other.idents &&
           bits == other.bits;
  }
  bool operator!=(const StyleMozContextProperties& other) const {
    return idents != other.idents ||
           bits != other.bits;
  }
};

/// Specified and computed `quotes` property.
struct StyleQuotes {
  StyleArcSlice<StyleQuotePair> _0;

  bool operator==(const StyleQuotes& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StyleQuotes& other) const {
    return _0 != other._0;
  }
};

/// A generic value for the `drop-shadow()` filter and the `text-shadow` property.
/// Contrary to the canonical order from the spec, the color is serialised
/// first, like in Gecko and Webkit.
template<typename Color, typename SizeLength, typename ShapeLength>
struct StyleGenericSimpleShadow {
  /// Color.
  Color color;
  /// Horizontal radius.
  SizeLength horizontal;
  /// Vertical radius.
  SizeLength vertical;
  /// Blur radius.
  ShapeLength blur;

  bool operator==(const StyleGenericSimpleShadow& other) const {
    return color == other.color &&
           horizontal == other.horizontal &&
           vertical == other.vertical &&
           blur == other.blur;
  }
  bool operator!=(const StyleGenericSimpleShadow& other) const {
    return color != other.color ||
           horizontal != other.horizontal ||
           vertical != other.vertical ||
           blur != other.blur;
  }
};

/// A generic value for a single `box-shadow`.
template<typename Color, typename SizeLength, typename BlurShapeLength, typename ShapeLength>
struct StyleGenericBoxShadow {
  /// The base shadow.
  StyleGenericSimpleShadow<Color, SizeLength, BlurShapeLength> base;
  /// The spread radius.
  ShapeLength spread;
  /// Whether this is an inset box shadow.
  bool inset;

  bool operator==(const StyleGenericBoxShadow& other) const {
    return base == other.base &&
           spread == other.spread &&
           inset == other.inset;
  }
  bool operator!=(const StyleGenericBoxShadow& other) const {
    return base != other.base ||
           spread != other.spread ||
           inset != other.inset;
  }
};

/// A computed value for a single shadow of the `box-shadow` property.
using StyleBoxShadow = StyleGenericBoxShadow<StyleColor, StyleLength, StyleNonNegativeLength, StyleLength>;

/// A computed value for the `drop-shadow()` filter.
using StyleSimpleShadow = StyleGenericSimpleShadow<StyleColor, StyleLength, StyleNonNegativeLength>;

extern "C" {

void Servo_AnimationCompose(RawServoAnimationValueMap *raw_value_map,
                            const RawServoAnimationValueTable *base_values,
                            nsCSSPropertyID css_property,
                            const AnimationPropertySegment *segment,
                            const AnimationPropertySegment *last_segment,
                            const ComputedTiming *computed_timing,
                            StyleIterationCompositeOperation iteration_composite);

StyleStrong<StyleRawServoAnimationValue> Servo_AnimationValue_Color(nsCSSPropertyID color_property,
                                                                    nscolor color);

StyleStrong<StyleRawServoAnimationValue> Servo_AnimationValue_Compute(const StyleRawGeckoElement *element,
                                                                      const StyleRawServoDeclarationBlock *declarations,
                                                                      const StyleComputedValues *style,
                                                                      const StyleRawServoStyleSet *raw_data);

bool Servo_AnimationValue_DeepEqual(const StyleRawServoAnimationValue *this_,
                                    const StyleRawServoAnimationValue *other);

nscolor Servo_AnimationValue_GetColor(const StyleRawServoAnimationValue *value,
                                      nscolor foreground_color);

float Servo_AnimationValue_GetOpacity(const StyleRawServoAnimationValue *value);

nsCSSPropertyID Servo_AnimationValue_GetPropertyId(const StyleRawServoAnimationValue *value);

const StyleRotate *Servo_AnimationValue_GetRotate(const StyleRawServoAnimationValue *value);

const StyleScale *Servo_AnimationValue_GetScale(const StyleRawServoAnimationValue *value);

const StyleTransform *Servo_AnimationValue_GetTransform(const StyleRawServoAnimationValue *value);

const StyleTranslate *Servo_AnimationValue_GetTranslate(const StyleRawServoAnimationValue *value);

StyleStrong<StyleRawServoAnimationValue> Servo_AnimationValue_Opacity(float opacity);

StyleStrong<StyleRawServoAnimationValue> Servo_AnimationValue_Rotate(const StyleRotate *r);

StyleStrong<StyleRawServoAnimationValue> Servo_AnimationValue_Scale(const StyleScale *s);

void Servo_AnimationValue_Serialize(const StyleRawServoAnimationValue *value,
                                    nsCSSPropertyID property,
                                    nsAString *buffer);

StyleStrong<StyleRawServoAnimationValue> Servo_AnimationValue_Transform(const StyleTransformOperation *list,
                                                                        uintptr_t len);

StyleStrong<StyleRawServoAnimationValue> Servo_AnimationValue_Translate(const StyleTranslate *t);

StyleStrong<StyleRawServoDeclarationBlock> Servo_AnimationValue_Uncompute(const StyleRawServoAnimationValue *value);

StyleStrong<StyleRawServoAnimationValue> Servo_AnimationValues_Accumulate(const StyleRawServoAnimationValue *a,
                                                                          const StyleRawServoAnimationValue *b,
                                                                          uint64_t count);

StyleStrong<StyleRawServoAnimationValue> Servo_AnimationValues_Add(const StyleRawServoAnimationValue *a,
                                                                   const StyleRawServoAnimationValue *b);

double Servo_AnimationValues_ComputeDistance(const StyleRawServoAnimationValue *from,
                                             const StyleRawServoAnimationValue *to);

StyleStrong<StyleRawServoAnimationValue> Servo_AnimationValues_GetZeroValue(const StyleRawServoAnimationValue *value_to_match);

StyleStrong<StyleRawServoAnimationValue> Servo_AnimationValues_Interpolate(const StyleRawServoAnimationValue *from,
                                                                           const StyleRawServoAnimationValue *to,
                                                                           double progress);

bool Servo_AnimationValues_IsInterpolable(const StyleRawServoAnimationValue *from,
                                          const StyleRawServoAnimationValue *to);

void Servo_AssertTreeIsClean(const StyleRawGeckoElement *root);

void Servo_AuthorStyles_AppendStyleSheet(StyleRawServoAuthorStyles *styles,
                                         const StyleDomStyleSheet *sheet);

StyleOwned<StyleRawServoAuthorStyles> Servo_AuthorStyles_Create();

void Servo_AuthorStyles_Drop(StyleRawServoAuthorStyles *styles);

void Servo_AuthorStyles_Flush(StyleRawServoAuthorStyles *styles,
                              const StyleRawServoStyleSet *document_set);

void Servo_AuthorStyles_ForceDirty(StyleRawServoAuthorStyles *styles);

void Servo_AuthorStyles_InsertStyleSheetBefore(StyleRawServoAuthorStyles *styles,
                                               const StyleDomStyleSheet *sheet,
                                               const StyleDomStyleSheet *before_sheet);

void Servo_AuthorStyles_RemoveStyleSheet(StyleRawServoAuthorStyles *styles,
                                         const StyleDomStyleSheet *sheet);

uintptr_t Servo_AuthorStyles_SizeOfIncludingThis(StyleGeckoMallocSizeOf malloc_size_of,
                                                 StyleGeckoMallocSizeOf malloc_enclosing_size_of,
                                                 const StyleRawServoAuthorStyles *styles);

bool Servo_CSSSupports(const nsACString *cond);

bool Servo_CSSSupports2(const nsACString *property, const nsACString *value);

/// Returns a unique pointer to a clone of the shape image.
/// Probably temporary, as we move more stuff to cbindgen.
StyleBasicShape *Servo_CloneBasicShape(const StyleBasicShape *v);

StyleStrong<StyleRawServoAnimationValue> Servo_ComposeAnimationSegment(const AnimationPropertySegment *segment,
                                                                       const StyleRawServoAnimationValue *underlying_value,
                                                                       const StyleRawServoAnimationValue *last_value,
                                                                       StyleIterationCompositeOperation iteration_composite,
                                                                       double progress,
                                                                       uint64_t current_iteration);

bool Servo_ComputeColor(const StyleRawServoStyleSet *raw_data,
                        nscolor current_color,
                        const nsAString *value,
                        nscolor *result_color,
                        bool *was_current_color,
                        StyleLoader *loader);

StyleStrong<StyleRawServoAnimationValue> Servo_ComputedValues_ExtractAnimationValue(const StyleComputedValues *computed_values,
                                                                                    nsCSSPropertyID property_id);

StyleStrong<StyleComputedValues> Servo_ComputedValues_GetForAnonymousBox(const StyleComputedValues *parent_style_or_null,
                                                                         PseudoStyleType pseudo,
                                                                         const StyleRawServoStyleSet *raw_data);

void Servo_ComputedValues_GetStyleRuleList(const StyleComputedValues *values,
                                           nsTArray<const StyleRawServoStyleRule*> *rules);

StyleStrong<StyleComputedValues> Servo_ComputedValues_Inherit(const StyleRawServoStyleSet *raw_data,
                                                              PseudoStyleType pseudo,
                                                              const StyleComputedValues *parent_style_context,
                                                              InheritTarget target);

StyleStrong<StyleComputedValues> Servo_ComputedValues_ResolveXULTreePseudoStyle(const StyleRawGeckoElement *element,
                                                                                nsAtom *pseudo_tag,
                                                                                const StyleComputedValues *inherited_style,
                                                                                const AtomArray *input_word,
                                                                                const StyleRawServoStyleSet *raw_data);

bool Servo_ComputedValues_SpecifiesAnimationsOrTransitions(const StyleComputedValues *values);

void Servo_CounterStyleRule_GetAdditiveSymbols(const StyleRawServoCounterStyleRule *rule,
                                               StyleOwnedSlice<StyleAdditiveSymbol> *symbols);

nsAtom *Servo_CounterStyleRule_GetExtended(const StyleRawServoCounterStyleRule *rule);

nsAtom *Servo_CounterStyleRule_GetFallback(const StyleRawServoCounterStyleRule *rule);

int32_t Servo_CounterStyleRule_GetFixedFirstValue(const StyleRawServoCounterStyleRule *rule);

uint32_t Servo_CounterStyleRule_GetGeneration(const StyleRawServoCounterStyleRule *rule);

nsAtom *Servo_CounterStyleRule_GetName(const StyleRawServoCounterStyleRule *rule);

bool Servo_CounterStyleRule_GetNegative(const StyleRawServoCounterStyleRule *rule,
                                        nsString *prefix,
                                        nsString *suffix);

bool Servo_CounterStyleRule_GetPad(const StyleRawServoCounterStyleRule *rule,
                                   int32_t *width,
                                   nsString *symbol);

bool Servo_CounterStyleRule_GetPrefix(const StyleRawServoCounterStyleRule *rule,
                                      nsString *out);

void Servo_CounterStyleRule_GetSpeakAs(const StyleRawServoCounterStyleRule *rule,
                                       StyleCounterSpeakAs *out);

bool Servo_CounterStyleRule_GetSuffix(const StyleRawServoCounterStyleRule *rule,
                                      nsString *out);

void Servo_CounterStyleRule_GetSymbols(const StyleRawServoCounterStyleRule *rule,
                                       StyleOwnedSlice<nsString> *symbols);

uint8_t Servo_CounterStyleRule_GetSystem(const StyleRawServoCounterStyleRule *rule);

StyleIsOrdinalInRange Servo_CounterStyleRule_IsInRange(const StyleRawServoCounterStyleRule *rule,
                                                       int32_t ordinal);

bool Servo_CounterStyleRule_SetName(const StyleRawServoCounterStyleRule *rule,
                                    const nsACString *value);

nsresult Servo_CssRules_DeleteRule(const StyleServoCssRules *rules,
                                   uint32_t index);

nsresult Servo_CssRules_InsertRule(const StyleServoCssRules *rules,
                                   const StyleRawServoStyleSheetContents *contents,
                                   const nsACString *rule,
                                   uint32_t index,
                                   bool nested,
                                   StyleLoader *loader,
                                   StyleDomStyleSheet *gecko_stylesheet,
                                   uint16_t *rule_type);

void Servo_CssRules_ListTypes(const StyleServoCssRules *rules,
                              nsTArray<uintptr_t> *result);

URLExtraData *Servo_CssUrlData_GetExtraData(const StyleRawServoCssUrlData *url);

void Servo_CssUrlData_GetSerialization(const StyleRawServoCssUrlData *url,
                                       const uint8_t **utf8_chars,
                                       uint32_t *utf8_len);

bool Servo_CssUrlData_IsLocalRef(const StyleRawServoCssUrlData *url);

StyleStrong<StyleRawServoDeclarationBlock> Servo_DeclarationBlock_Clone(const StyleRawServoDeclarationBlock *declarations);

uint32_t Servo_DeclarationBlock_Count(const StyleRawServoDeclarationBlock *declarations);

StyleStrong<StyleRawServoDeclarationBlock> Servo_DeclarationBlock_CreateEmpty();

bool Servo_DeclarationBlock_Equals(const StyleRawServoDeclarationBlock *a,
                                   const StyleRawServoDeclarationBlock *b);

void Servo_DeclarationBlock_GetCssText(const StyleRawServoDeclarationBlock *declarations,
                                       nsAString *result);

bool Servo_DeclarationBlock_GetNthProperty(const StyleRawServoDeclarationBlock *declarations,
                                           uint32_t index,
                                           nsAString *result);

bool Servo_DeclarationBlock_GetPropertyIsImportant(const StyleRawServoDeclarationBlock *declarations,
                                                   const nsACString *property);

void Servo_DeclarationBlock_GetPropertyValue(const StyleRawServoDeclarationBlock *declarations,
                                             const nsACString *property,
                                             nsAString *value);

void Servo_DeclarationBlock_GetPropertyValueById(const StyleRawServoDeclarationBlock *declarations,
                                                 nsCSSPropertyID property,
                                                 nsAString *value);

bool Servo_DeclarationBlock_HasCSSWideKeyword(const StyleRawServoDeclarationBlock *declarations,
                                              nsCSSPropertyID property);

bool Servo_DeclarationBlock_PropertyIsSet(const StyleRawServoDeclarationBlock *declarations,
                                          nsCSSPropertyID property);

bool Servo_DeclarationBlock_RemoveProperty(const StyleRawServoDeclarationBlock *declarations,
                                           const nsACString *property,
                                           DeclarationBlockMutationClosure before_change_closure);

bool Servo_DeclarationBlock_RemovePropertyById(const StyleRawServoDeclarationBlock *declarations,
                                               nsCSSPropertyID property,
                                               DeclarationBlockMutationClosure before_change_closure);

void Servo_DeclarationBlock_SerializeOneValue(const StyleRawServoDeclarationBlock *declarations,
                                              nsCSSPropertyID property_id,
                                              nsAString *buffer,
                                              const StyleComputedValues *computed_values,
                                              const StyleRawServoDeclarationBlock *custom_properties);

void Servo_DeclarationBlock_SetAutoValue(const StyleRawServoDeclarationBlock *declarations,
                                         nsCSSPropertyID property);

void Servo_DeclarationBlock_SetBackgroundImage(const StyleRawServoDeclarationBlock *declarations,
                                               const nsAString *value,
                                               URLExtraData *raw_extra_data);

void Servo_DeclarationBlock_SetColorValue(const StyleRawServoDeclarationBlock *declarations,
                                          nsCSSPropertyID property,
                                          nscolor value);

void Servo_DeclarationBlock_SetCounterResetListItem(const StyleRawServoDeclarationBlock *declarations,
                                                    int32_t counter_value);

void Servo_DeclarationBlock_SetCounterSetListItem(const StyleRawServoDeclarationBlock *declarations,
                                                  int32_t counter_value);

void Servo_DeclarationBlock_SetCurrentColor(const StyleRawServoDeclarationBlock *declarations,
                                            nsCSSPropertyID property);

void Servo_DeclarationBlock_SetFontFamily(const StyleRawServoDeclarationBlock *declarations,
                                          const nsAString *value);

void Servo_DeclarationBlock_SetIdentStringValue(const StyleRawServoDeclarationBlock *declarations,
                                                nsCSSPropertyID property,
                                                nsAtom *value);

void Servo_DeclarationBlock_SetIntValue(const StyleRawServoDeclarationBlock *declarations,
                                        nsCSSPropertyID property,
                                        int32_t value);

void Servo_DeclarationBlock_SetKeywordValue(const StyleRawServoDeclarationBlock *declarations,
                                            nsCSSPropertyID property,
                                            int32_t value);

void Servo_DeclarationBlock_SetLengthValue(const StyleRawServoDeclarationBlock *declarations,
                                           nsCSSPropertyID property,
                                           float value,
                                           nsCSSUnit unit);

void Servo_DeclarationBlock_SetNumberValue(const StyleRawServoDeclarationBlock *declarations,
                                           nsCSSPropertyID property,
                                           float value);

void Servo_DeclarationBlock_SetPercentValue(const StyleRawServoDeclarationBlock *declarations,
                                            nsCSSPropertyID property,
                                            float value);

void Servo_DeclarationBlock_SetPixelValue(const StyleRawServoDeclarationBlock *declarations,
                                          nsCSSPropertyID property,
                                          float value);

bool Servo_DeclarationBlock_SetProperty(const StyleRawServoDeclarationBlock *declarations,
                                        const nsACString *property,
                                        const nsACString *value,
                                        bool is_important,
                                        URLExtraData *data,
                                        ParsingMode parsing_mode,
                                        nsCompatibility quirks_mode,
                                        StyleLoader *loader,
                                        DeclarationBlockMutationClosure before_change_closure);

bool Servo_DeclarationBlock_SetPropertyById(const StyleRawServoDeclarationBlock *declarations,
                                            nsCSSPropertyID property,
                                            const nsACString *value,
                                            bool is_important,
                                            URLExtraData *data,
                                            ParsingMode parsing_mode,
                                            nsCompatibility quirks_mode,
                                            StyleLoader *loader,
                                            DeclarationBlockMutationClosure before_change_closure);

bool Servo_DeclarationBlock_SetPropertyToAnimationValue(const StyleRawServoDeclarationBlock *declarations,
                                                        const StyleRawServoAnimationValue *animation_value);

void Servo_DeclarationBlock_SetTextDecorationColorOverride(const StyleRawServoDeclarationBlock *declarations);

void Servo_Element_ClearData(const StyleRawGeckoElement *element);

StyleStrong<StyleComputedValues> Servo_Element_GetPrimaryComputedValues(const StyleRawGeckoElement *element);

StyleStrong<StyleComputedValues> Servo_Element_GetPseudoComputedValues(const StyleRawGeckoElement *element,
                                                                       uintptr_t index);

bool Servo_Element_HasPrimaryComputedValues(const StyleRawGeckoElement *element);

bool Servo_Element_HasPseudoComputedValues(const StyleRawGeckoElement *element,
                                           uintptr_t index);

bool Servo_Element_IsDisplayContents(const StyleRawGeckoElement *element);

bool Servo_Element_IsDisplayNone(const StyleRawGeckoElement *element);

bool Servo_Element_IsPrimaryStyleReusedViaRuleNode(const StyleRawGeckoElement *element);

uintptr_t Servo_Element_SizeOfExcludingThisAndCVs(StyleGeckoMallocSizeOf malloc_size_of,
                                                  StyleGeckoMallocSizeOf malloc_enclosing_size_of,
                                                  SeenPtrs *seen_ptrs,
                                                  const StyleRawGeckoElement *element);

StyleStrong<StyleRawServoFontFaceRule> Servo_FontFaceRule_Clone(const StyleRawServoFontFaceRule *rule);

StyleStrong<StyleRawServoFontFaceRule> Servo_FontFaceRule_CreateEmpty();

void Servo_FontFaceRule_GetDeclCssText(const StyleRawServoFontFaceRule *rule,
                                       nsAString *result);

void Servo_FontFaceRule_GetDescriptorCssText(const StyleRawServoFontFaceRule *rule,
                                             nsCSSFontDesc desc,
                                             nsAString *result);

nsAtom *Servo_FontFaceRule_GetFamilyName(const StyleRawServoFontFaceRule *rule);

void Servo_FontFaceRule_GetFeatureSettings(const StyleRawServoFontFaceRule *rule,
                                           nsTArray<gfxFontFeature> *features);

bool Servo_FontFaceRule_GetFontDisplay(const StyleRawServoFontFaceRule *rule,
                                       StyleFontDisplay *out);

bool Servo_FontFaceRule_GetFontLanguageOverride(const StyleRawServoFontFaceRule *rule,
                                                StyleFontLanguageOverride *out);

bool Servo_FontFaceRule_GetFontStretch(const StyleRawServoFontFaceRule *rule,
                                       StyleComputedFontStretchRange *out);

bool Servo_FontFaceRule_GetFontStyle(const StyleRawServoFontFaceRule *rule,
                                     StyleComputedFontStyleDescriptor *out);

bool Servo_FontFaceRule_GetFontWeight(const StyleRawServoFontFaceRule *rule,
                                      StyleComputedFontWeightRange *out);

void Servo_FontFaceRule_GetSourceLocation(const StyleRawServoFontFaceRule *rule,
                                          uint32_t *line,
                                          uint32_t *column);

void Servo_FontFaceRule_GetSources(const StyleRawServoFontFaceRule *rule,
                                   nsTArray<StyleFontFaceSourceListComponent> *out);

const StyleUnicodeRange *Servo_FontFaceRule_GetUnicodeRanges(const StyleRawServoFontFaceRule *rule,
                                                             uintptr_t *out_len);

void Servo_FontFaceRule_GetVariationSettings(const StyleRawServoFontFaceRule *rule,
                                             nsTArray<gfxFontVariation> *variations);

nsCSSFontDesc Servo_FontFaceRule_IndexGetter(const StyleRawServoFontFaceRule *rule,
                                             uint32_t index);

uint32_t Servo_FontFaceRule_Length(const StyleRawServoFontFaceRule *rule);

void Servo_FontFaceRule_ResetDescriptor(const StyleRawServoFontFaceRule *rule,
                                        nsCSSFontDesc desc);

bool Servo_FontFaceRule_SetDescriptor(const StyleRawServoFontFaceRule *rule,
                                      nsCSSFontDesc desc,
                                      const nsACString *value,
                                      URLExtraData *data,
                                      bool *out_changed);

void Servo_FontFeatureValuesRule_GetFontFamily(const StyleRawServoFontFeatureValuesRule *rule,
                                               nsAString *result);

void Servo_FontFeatureValuesRule_GetValueText(const StyleRawServoFontFeatureValuesRule *rule,
                                              nsAString *result);

void Servo_GetAnimationValues(const StyleRawServoDeclarationBlock *declarations,
                              const StyleRawGeckoElement *element,
                              const StyleComputedValues *style,
                              const StyleRawServoStyleSet *raw_data,
                              nsTArray<RefPtr<StyleRawServoAnimationValue>> *animation_values);

void Servo_GetComputedKeyframeValues(const nsTArray<Keyframe> *keyframes,
                                     const StyleRawGeckoElement *element,
                                     const StyleComputedValues *style,
                                     const StyleRawServoStyleSet *raw_data,
                                     nsTArray<ComputedKeyframeValues> *computed_keyframes);

uint32_t Servo_GetCustomPropertiesCount(const StyleComputedValues *computed_values);

bool Servo_GetCustomPropertyNameAt(const StyleComputedValues *computed_values,
                                   uint32_t index,
                                   nsAString *name);

bool Servo_GetCustomPropertyValue(const StyleComputedValues *computed_values,
                                  const nsAString *name,
                                  nsAString *value);

void Servo_GetProperties_Overriding_Animation(const StyleRawGeckoElement *element,
                                              const nsTArray<nsCSSPropertyID> *list,
                                              nsCSSPropertyIDSet *set);

void Servo_GetPropertyValue(const StyleComputedValues *style,
                            nsCSSPropertyID prop,
                            nsAString *value);

bool Servo_HasAuthorSpecifiedRules(const StyleRawServoStyleSet *raw_data,
                                   const StyleComputedValues *style,
                                   const StyleRawGeckoElement *element,
                                   uint32_t rule_type_mask);

bool Servo_HasPendingRestyleAncestor(const StyleRawGeckoElement *element);

void Servo_ImportRule_GetHref(const StyleRawServoImportRule *rule,
                              nsAString *result);

const StyleDomStyleSheet *Servo_ImportRule_GetSheet(const StyleRawServoImportRule *rule);

void Servo_ImportRule_SetSheet(const StyleRawServoImportRule *rule,
                               StyleDomStyleSheet *sheet);

void Servo_Initialize(URLExtraData *dummy_url_data);

void Servo_InitializeCooperativeThread();

bool Servo_IntersectionObserverRootMargin_Parse(const nsAString *value,
                                                StyleIntersectionObserverRootMargin *result);

void Servo_IntersectionObserverRootMargin_ToString(const StyleIntersectionObserverRootMargin *root_margin,
                                                   nsAString *result);

void Servo_InvalidateStyleForDocStateChanges(const StyleRawGeckoElement *root,
                                             const StyleRawServoStyleSet *document_style,
                                             const nsTArray<const StyleRawServoAuthorStyles*> *non_document_styles,
                                             uint64_t states_changed);

bool Servo_IsCssPropertyRecordedInUseCounter(const StyleUseCounters *use_counters,
                                             const nsACString *property,
                                             bool *known_prop);

bool Servo_IsValidCSSColor(const nsAString *value);

bool Servo_IsWorkerThread();

void Servo_Keyframe_GetKeyText(const StyleRawServoKeyframe *keyframe,
                               nsAString *result);

StyleStrong<StyleRawServoDeclarationBlock> Servo_Keyframe_GetStyle(const StyleRawServoKeyframe *keyframe);

bool Servo_Keyframe_SetKeyText(const StyleRawServoKeyframe *keyframe,
                               const nsACString *text);

void Servo_Keyframe_SetStyle(const StyleRawServoKeyframe *keyframe,
                             const StyleRawServoDeclarationBlock *declarations);

bool Servo_KeyframesRule_AppendRule(const StyleRawServoKeyframesRule *rule,
                                    const StyleRawServoStyleSheetContents *contents,
                                    const nsACString *css);

void Servo_KeyframesRule_DeleteRule(const StyleRawServoKeyframesRule *rule,
                                    uint32_t index);

uint32_t Servo_KeyframesRule_FindRule(const StyleRawServoKeyframesRule *rule,
                                      const nsACString *key);

uint32_t Servo_KeyframesRule_GetCount(const StyleRawServoKeyframesRule *rule);

StyleStrong<StyleRawServoKeyframe> Servo_KeyframesRule_GetKeyframeAt(const StyleRawServoKeyframesRule *rule,
                                                                     uint32_t index,
                                                                     uint32_t *line,
                                                                     uint32_t *column);

nsAtom *Servo_KeyframesRule_GetName(const StyleRawServoKeyframesRule *rule);

void Servo_KeyframesRule_SetName(const StyleRawServoKeyframesRule *rule,
                                 nsAtom *name);

void Servo_MatrixTransform_Operate(StyleMatrixTransformOperator matrix_operator,
                                   const StyleMatrix4x4Components *from,
                                   const StyleMatrix4x4Components *to,
                                   double progress,
                                   StyleMatrix4x4Components *output);

/// Checks whether the rule tree has crossed its threshold for unused nodes, and
/// if so, frees them.
void Servo_MaybeGCRuleTree(const StyleRawServoStyleSet *raw_data);

void Servo_MediaList_AppendMedium(const StyleRawServoMediaList *list,
                                  const nsACString *new_medium);

StyleStrong<StyleRawServoMediaList> Servo_MediaList_Create();

StyleStrong<StyleRawServoMediaList> Servo_MediaList_DeepClone(const StyleRawServoMediaList *list);

bool Servo_MediaList_DeleteMedium(const StyleRawServoMediaList *list,
                                  const nsACString *old_medium);

uint32_t Servo_MediaList_GetLength(const StyleRawServoMediaList *list);

bool Servo_MediaList_GetMediumAt(const StyleRawServoMediaList *list,
                                 uint32_t index,
                                 nsAString *result);

void Servo_MediaList_GetText(const StyleRawServoMediaList *list,
                             nsAString *result);

bool Servo_MediaList_Matches(const StyleRawServoMediaList *list,
                             const StyleRawServoStyleSet *raw_data);

void Servo_MediaList_SetText(const StyleRawServoMediaList *list,
                             const nsACString *text,
                             StyleCallerType caller_type);

uintptr_t Servo_MediaList_SizeOfIncludingThis(StyleGeckoMallocSizeOf malloc_size_of,
                                              StyleGeckoMallocSizeOf malloc_enclosing_size_of,
                                              const StyleRawServoMediaList *list);

StyleStrong<StyleRawServoMediaList> Servo_MediaRule_GetMedia(const StyleRawServoMediaRule *rule);

void Servo_MozDocumentRule_GetConditionText(const StyleRawServoMozDocumentRule *rule,
                                            nsAString *result);

nsAtom *Servo_NamespaceRule_GetPrefix(const StyleRawServoNamespaceRule *rule);

nsAtom *Servo_NamespaceRule_GetURI(const StyleRawServoNamespaceRule *rule);

void Servo_NoteExplicitHints(const StyleRawGeckoElement *element,
                             StyleRestyleHint restyle_hint,
                             nsChangeHint change_hint);

StyleStrong<StyleRawServoDeclarationBlock> Servo_PageRule_GetStyle(const StyleRawServoPageRule *rule);

void Servo_PageRule_SetStyle(const StyleRawServoPageRule *rule,
                             const StyleRawServoDeclarationBlock *declarations);

bool Servo_ParseEasing(const nsAString *easing,
                       URLExtraData *data,
                       nsTimingFunction *output);

bool Servo_ParseFontShorthandForMatching(const nsAString *value,
                                         URLExtraData *data,
                                         RefPtr<SharedFontList> *family,
                                         StyleComputedFontStyleDescriptor *style,
                                         float *stretch,
                                         float *weight);

StyleStrong<StyleRawServoDeclarationBlock> Servo_ParseProperty(nsCSSPropertyID property,
                                                               const nsACString *value,
                                                               URLExtraData *data,
                                                               ParsingMode parsing_mode,
                                                               nsCompatibility quirks_mode,
                                                               StyleLoader *loader);

StyleStrong<StyleRawServoDeclarationBlock> Servo_ParseStyleAttribute(const nsACString *data,
                                                                     URLExtraData *raw_extra_data,
                                                                     nsCompatibility quirks_mode,
                                                                     StyleLoader *loader);

bool Servo_ParseTransformIntoMatrix(const nsAString *value,
                                    bool *contain_3d,
                                    StyleMatrix4x4Components *result);

void Servo_ProcessInvalidations(const StyleRawServoStyleSet *set,
                                const StyleRawGeckoElement *element,
                                const ServoElementSnapshotTable *snapshots);

void Servo_Property_GetCSSValuesForProperty(const nsACString *prop_name,
                                            bool *found,
                                            nsTArray<nsString> *result);

const uint8_t *Servo_Property_GetName(nsCSSPropertyID prop,
                                      uint32_t *out_length);

bool Servo_Property_IsAnimatable(nsCSSPropertyID prop);

bool Servo_Property_IsDiscreteAnimatable(nsCSSPropertyID property);

bool Servo_Property_IsInherited(const nsACString *prop_name);

bool Servo_Property_IsShorthand(const nsACString *prop_name, bool *found);

bool Servo_Property_IsTransitionable(nsCSSPropertyID prop);

nsCSSPropertyID Servo_Property_LookupEnabledForAllContent(const nsACString *prop);

bool Servo_Property_SupportsType(const nsACString *prop_name,
                                 uint8_t ty,
                                 bool *found);

uint64_t Servo_PseudoClass_GetStates(const nsACString *name);

StyleForgottenArcSlicePtr<StyleQuotePair> Servo_Quotes_GetInitialValue();

StyleStrong<StyleComputedValues> Servo_ReparentStyle(const StyleComputedValues *style_to_reparent,
                                                     const StyleComputedValues *parent_style,
                                                     const StyleComputedValues *parent_style_ignoring_first_line,
                                                     const StyleComputedValues *layout_parent_style,
                                                     const StyleRawGeckoElement *element,
                                                     const StyleRawServoStyleSet *raw_data);

nsCSSPropertyID Servo_ResolveLogicalProperty(nsCSSPropertyID property_id,
                                             const StyleComputedValues *style);

StyleStrong<StyleComputedValues> Servo_ResolvePseudoStyle(const StyleRawGeckoElement *element,
                                                          PseudoStyleType pseudo_type,
                                                          bool is_probe,
                                                          const StyleComputedValues *inherited_style,
                                                          const StyleRawServoStyleSet *raw_data);

StyleStrong<StyleComputedValues> Servo_ResolveStyle(const StyleRawGeckoElement *element,
                                                    const StyleRawServoStyleSet *_raw_data);

StyleStrong<StyleComputedValues> Servo_ResolveStyleLazily(const StyleRawGeckoElement *element,
                                                          PseudoStyleType pseudo_type,
                                                          StyleRuleInclusion rule_inclusion,
                                                          const ServoElementSnapshotTable *snapshots,
                                                          const StyleRawServoStyleSet *raw_data);

const StyleRawGeckoElement *Servo_SelectorList_Closest(const StyleRawGeckoElement *element,
                                                       const StyleRawServoSelectorList *selectors);

void Servo_SelectorList_Drop(StyleRawServoSelectorList *list);

bool Servo_SelectorList_Matches(const StyleRawGeckoElement *element,
                                const StyleRawServoSelectorList *selectors);

StyleOwnedOrNull<StyleRawServoSelectorList> Servo_SelectorList_Parse(const nsACString *selector_list);

void Servo_SelectorList_QueryAll(const StyleRawGeckoNode *node,
                                 const StyleRawServoSelectorList *selectors,
                                 nsSimpleContentList *content_list,
                                 bool may_use_invalidation);

const StyleRawGeckoElement *Servo_SelectorList_QueryFirst(const StyleRawGeckoNode *node,
                                                          const StyleRawServoSelectorList *selectors,
                                                          bool may_use_invalidation);

void Servo_SerializeBorderRadius(const StyleBorderRadius *radius,
                                 nsAString *output);

void Servo_SerializeEasing(const nsTimingFunction *easing, nsAString *output);

void Servo_SerializeFontValueForCanvas(const StyleRawServoDeclarationBlock *declarations,
                                       nsAString *buffer);

void Servo_SetExplicitStyle(const StyleRawGeckoElement *element,
                            const StyleComputedValues *style);

const StyleServoCssRules *Servo_SharedMemoryBuilder_AddStylesheet(StyleRawServoSharedMemoryBuilder *builder,
                                                                  const StyleRawServoStyleSheetContents *raw_contents);

StyleRawServoSharedMemoryBuilder *Servo_SharedMemoryBuilder_Create(uint8_t *buffer,
                                                                   uintptr_t len);

void Servo_SharedMemoryBuilder_Drop(StyleRawServoSharedMemoryBuilder *builder);

uintptr_t Servo_SharedMemoryBuilder_GetLength(StyleRawServoSharedMemoryBuilder *builder);

void Servo_Shutdown();

void Servo_SourceSizeList_Drop(StyleRawServoSourceSizeList *list);

int32_t Servo_SourceSizeList_Evaluate(const StyleRawServoStyleSet *raw_data,
                                      const StyleRawServoSourceSizeList *list);

StyleOwned<StyleRawServoSourceSizeList> Servo_SourceSizeList_Parse(const nsACString *value);

void *Servo_StyleArcSlice_EmptyPtr();

void Servo_StyleRule_GetSelectorCount(const StyleRawServoStyleRule *rule,
                                      uint32_t *count);

void Servo_StyleRule_GetSelectorText(const StyleRawServoStyleRule *rule,
                                     nsAString *result);

void Servo_StyleRule_GetSelectorTextAtIndex(const StyleRawServoStyleRule *rule,
                                            uint32_t index,
                                            nsAString *result);

void Servo_StyleRule_GetSpecificityAtIndex(const StyleRawServoStyleRule *rule,
                                           uint32_t index,
                                           uint64_t *specificity);

StyleStrong<StyleRawServoDeclarationBlock> Servo_StyleRule_GetStyle(const StyleRawServoStyleRule *rule);

bool Servo_StyleRule_SelectorMatchesElement(const StyleRawServoStyleRule *rule,
                                            const StyleRawGeckoElement *element,
                                            uint32_t index,
                                            PseudoStyleType pseudo_type);

bool Servo_StyleRule_SetSelectorText(const StyleRawServoStyleSheetContents *sheet,
                                     const StyleRawServoStyleRule *rule,
                                     const nsAString *text);

void Servo_StyleRule_SetStyle(const StyleRawServoStyleRule *rule,
                              const StyleRawServoDeclarationBlock *declarations);

void Servo_StyleSet_AddSizeOfExcludingThis(StyleGeckoMallocSizeOf malloc_size_of,
                                           StyleGeckoMallocSizeOf malloc_enclosing_size_of,
                                           ServoStyleSetSizes *sizes,
                                           const StyleRawServoStyleSet *raw_data);

void Servo_StyleSet_AppendStyleSheet(const StyleRawServoStyleSet *raw_data,
                                     const StyleDomStyleSheet *sheet);

gfxFontFeatureValueSet *Servo_StyleSet_BuildFontFeatureValueSet(const StyleRawServoStyleSet *raw_data);

void Servo_StyleSet_CompatModeChanged(const StyleRawServoStyleSet *raw_data);

void Servo_StyleSet_Drop(StyleRawServoStyleSet *data);

void Servo_StyleSet_FlushStyleSheets(const StyleRawServoStyleSet *raw_data,
                                     const StyleRawGeckoElement *doc_element,
                                     const ServoElementSnapshotTable *snapshots);

StyleStrong<StyleComputedValues> Servo_StyleSet_GetBaseComputedValuesForElement(const StyleRawServoStyleSet *raw_style_set,
                                                                                const StyleRawGeckoElement *element,
                                                                                const StyleComputedValues *computed_values,
                                                                                const ServoElementSnapshotTable *snapshots);

StyleStrong<StyleComputedValues> Servo_StyleSet_GetComputedValuesByAddingAnimation(const StyleRawServoStyleSet *raw_style_set,
                                                                                   const StyleRawGeckoElement *element,
                                                                                   const StyleComputedValues *computed_values,
                                                                                   const ServoElementSnapshotTable *snapshots,
                                                                                   const StyleRawServoAnimationValue *animation_value);

const StyleRawServoCounterStyleRule *Servo_StyleSet_GetCounterStyleRule(const StyleRawServoStyleSet *raw_data,
                                                                        nsAtom *name);

void Servo_StyleSet_GetFontFaceRules(const StyleRawServoStyleSet *raw_data,
                                     nsTArray<nsFontFaceRuleContainer> *rules);

bool Servo_StyleSet_GetKeyframesForName(const StyleRawServoStyleSet *raw_data,
                                        const StyleRawGeckoElement *element,
                                        const StyleComputedValues *style,
                                        nsAtom *name,
                                        const nsTimingFunction *inherited_timing_function,
                                        nsTArray<Keyframe> *keyframes);

const StyleDomStyleSheet *Servo_StyleSet_GetSheetAt(const StyleRawServoStyleSet *raw_data,
                                                    StyleOrigin origin,
                                                    uintptr_t index);

uintptr_t Servo_StyleSet_GetSheetCount(const StyleRawServoStyleSet *raw_data,
                                       StyleOrigin origin);

bool Servo_StyleSet_HasDocumentStateDependency(const StyleRawServoStyleSet *raw_data,
                                               uint64_t state);

bool Servo_StyleSet_HasStateDependency(const StyleRawServoStyleSet *raw_data,
                                       const StyleRawGeckoElement *element,
                                       uint64_t state);

StyleRawServoStyleSet *Servo_StyleSet_Init(const StyleDocument *doc);

void Servo_StyleSet_InsertStyleSheetBefore(const StyleRawServoStyleSet *raw_data,
                                           const StyleDomStyleSheet *sheet,
                                           const StyleDomStyleSheet *before_sheet);

MediumFeaturesChangedResult Servo_StyleSet_MediumFeaturesChanged(const StyleRawServoStyleSet *document_set,
                                                                 nsTArray<StyleRawServoAuthorStyles*> *non_document_styles,
                                                                 bool may_affect_default_style);

bool Servo_StyleSet_MightHaveAttributeDependency(const StyleRawServoStyleSet *raw_data,
                                                 const StyleRawGeckoElement *element,
                                                 nsAtom *local_name);

void Servo_StyleSet_NoteStyleSheetsChanged(const StyleRawServoStyleSet *raw_data,
                                           OriginFlags changed_origins);

void Servo_StyleSet_RebuildCachedData(const StyleRawServoStyleSet *raw_data);

void Servo_StyleSet_RemoveStyleSheet(const StyleRawServoStyleSet *raw_data,
                                     const StyleDomStyleSheet *sheet);

StyleStrong<StyleComputedValues> Servo_StyleSet_ResolveForDeclarations(const StyleRawServoStyleSet *raw_data,
                                                                       const StyleComputedValues *parent_style_context,
                                                                       const StyleRawServoDeclarationBlock *declarations);

void Servo_StyleSet_SetAuthorStyleDisabled(const StyleRawServoStyleSet *raw_data,
                                           bool author_style_disabled);

StyleStrong<StyleRawServoStyleSheetContents> Servo_StyleSheet_Clone(const StyleRawServoStyleSheetContents *raw_sheet,
                                                                    const StyleDomStyleSheet *reference_sheet);

StyleStrong<StyleRawServoStyleSheetContents> Servo_StyleSheet_Empty(StyleSheetParsingMode mode);

StyleStrong<StyleRawServoStyleSheetContents> Servo_StyleSheet_FromSharedData(URLExtraData *extra_data,
                                                                             const StyleServoCssRules *shared_rules);

/// Note: The load_data corresponds to this sheet, and is passed as the parent
/// load data for child sheet loads. It may be null for certain cases where we
/// know we won't have child loads.
StyleStrong<StyleRawServoStyleSheetContents> Servo_StyleSheet_FromUTF8Bytes(StyleLoader *loader,
                                                                            StyleDomStyleSheet *stylesheet,
                                                                            StyleSheetLoadData *load_data,
                                                                            const nsACString *bytes,
                                                                            StyleSheetParsingMode mode,
                                                                            URLExtraData *extra_data,
                                                                            uint32_t line_number_offset,
                                                                            nsCompatibility quirks_mode,
                                                                            StyleLoaderReusableStyleSheets *reusable_sheets,
                                                                            const StyleUseCounters *use_counters,
                                                                            StyleSanitizationKind sanitization_kind,
                                                                            nsAString *sanitized_output);

void Servo_StyleSheet_FromUTF8BytesAsync(StyleSheetLoadDataHolder *load_data,
                                         URLExtraData *extra_data,
                                         const nsACString *bytes,
                                         StyleSheetParsingMode mode,
                                         uint32_t line_number_offset,
                                         nsCompatibility quirks_mode,
                                         bool should_record_use_counters);

StyleOrigin Servo_StyleSheet_GetOrigin(const StyleRawServoStyleSheetContents *sheet);

StyleStrong<StyleServoCssRules> Servo_StyleSheet_GetRules(const StyleRawServoStyleSheetContents *sheet);

void Servo_StyleSheet_GetSourceMapURL(const StyleRawServoStyleSheetContents *sheet,
                                      nsAString *result);

void Servo_StyleSheet_GetSourceURL(const StyleRawServoStyleSheetContents *sheet,
                                   nsAString *result);

bool Servo_StyleSheet_HasRules(const StyleRawServoStyleSheetContents *raw_contents);

uintptr_t Servo_StyleSheet_SizeOfIncludingThis(StyleGeckoMallocSizeOf malloc_size_of,
                                               StyleGeckoMallocSizeOf malloc_enclosing_size_of,
                                               const StyleRawServoStyleSheetContents *sheet);

uint32_t Servo_StyleWorkerThreadCount();

void Servo_SupportsRule_GetConditionText(const StyleRawServoSupportsRule *rule,
                                         nsAString *result);

uint32_t Servo_TakeChangeHint(const StyleRawGeckoElement *element,
                              bool *was_restyled);

/// Traverses the subtree rooted at `root` for restyling.
/// Returns whether the root was restyled. Whether anything else was restyled or
/// not can be inferred from the dirty bits in the rest of the tree.
bool Servo_TraverseSubtree(const StyleRawGeckoElement *root,
                           const StyleRawServoStyleSet *raw_data,
                           const ServoElementSnapshotTable *snapshots,
                           ServoTraversalFlags raw_flags);

void Servo_UACache_AddSizeOf(StyleGeckoMallocSizeOf malloc_size_of,
                             StyleGeckoMallocSizeOf malloc_enclosing_size_of,
                             ServoStyleSetSizes *sizes);

StyleOwned<StyleStyleUseCounters> Servo_UseCounters_Create();

void Servo_UseCounters_Drop(StyleStyleUseCounters *c);

void Servo_UseCounters_Merge(const StyleUseCounters *doc_counters,
                             const StyleUseCounters *sheet_counters);

} // extern "C"

} // namespace mozilla

#endif // mozilla_ServoStyleConsts_h

#pragma GCC diagnostic pop
#include "mozilla/ServoStyleConstsInlines.h"

