/* automatically generated by rust-bindgen */

pub use self::root::*;
pub use self::root::mozilla::*;
pub use self::root::mozilla::css::*;
pub use self::root::mozilla::dom::*;
use atomic_refcell::AtomicRefCell;
use data::ElementData;
pub type RustCell<T> = ::std::cell::Cell<T>;
pub type ServoNodeData = AtomicRefCell<ElementData>;
pub type ServoWritingMode = ::logical_geometry::WritingMode;
pub type ServoCustomPropertiesMap = Option<::servo_arc::Arc<::custom_properties::CustomPropertiesMap>>;
pub type ServoRuleNode = Option<::rule_tree::StrongRuleNode>;
pub type ServoVisitedStyle = Option<::servo_arc::RawOffsetArc<::properties::ComputedValues>>;
pub type ServoComputedValueFlags = ::properties::computed_value_flags::ComputedValueFlags;
pub type ServoRawOffsetArc<T> = ::servo_arc::RawOffsetArc<T>;
pub type ServoManuallyDrop<T> = ::std::mem::ManuallyDrop<T>;
pub type nsACString = nsstring::nsACString;
pub type nsAString = nsstring::nsAString;
pub type nsCString = nsstring::nsCString;
pub type nsString = nsstring::nsString;

#[allow(non_snake_case, non_camel_case_types, non_upper_case_globals)]
pub mod root {
    #[repr(C)]
    #[derive(Copy, Clone, Debug, Default, Eq, Hash, Ord, PartialEq, PartialOrd)]
    pub struct __BindgenBitfieldUnit<Storage, Align> {
        storage: Storage,
        align: [Align; 0],
    }
    impl<Storage, Align> __BindgenBitfieldUnit<Storage, Align> {
        #[inline]
        pub fn new(storage: Storage) -> Self {
            Self { storage, align: [] }
        }
    }
    impl<Storage, Align> __BindgenBitfieldUnit<Storage, Align>
    where
        Storage: AsRef<[u8]> + AsMut<[u8]>,
    {
        #[inline]
        pub fn get_bit(&self, index: usize) -> bool {
            debug_assert!(index / 8 < self.storage.as_ref().len());
            let byte_index = index / 8;
            let byte = self.storage.as_ref()[byte_index];
            let bit_index = if cfg!(target_endian = "big") {
                7 - (index % 8)
            } else {
                index % 8
            };
            let mask = 1 << bit_index;
            byte & mask == mask
        }
        #[inline]
        pub fn set_bit(&mut self, index: usize, val: bool) {
            debug_assert!(index / 8 < self.storage.as_ref().len());
            let byte_index = index / 8;
            let byte = &mut self.storage.as_mut()[byte_index];
            let bit_index = if cfg!(target_endian = "big") {
                7 - (index % 8)
            } else {
                index % 8
            };
            let mask = 1 << bit_index;
            if val {
                *byte |= mask;
            } else {
                *byte &= !mask;
            }
        }
        #[inline]
        pub fn get(&self, bit_offset: usize, bit_width: u8) -> u64 {
            debug_assert!(bit_width <= 64);
            debug_assert!(bit_offset / 8 < self.storage.as_ref().len());
            debug_assert!((bit_offset + (bit_width as usize)) / 8 <= self.storage.as_ref().len());
            let mut val = 0;
            for i in 0..(bit_width as usize) {
                if self.get_bit(i + bit_offset) {
                    let index = if cfg!(target_endian = "big") {
                        bit_width as usize - 1 - i
                    } else {
                        i
                    };
                    val |= 1 << index;
                }
            }
            val
        }
        #[inline]
        pub fn set(&mut self, bit_offset: usize, bit_width: u8, val: u64) {
            debug_assert!(bit_width <= 64);
            debug_assert!(bit_offset / 8 < self.storage.as_ref().len());
            debug_assert!((bit_offset + (bit_width as usize)) / 8 <= self.storage.as_ref().len());
            for i in 0..(bit_width as usize) {
                let mask = 1 << i;
                let val_bit_is_set = val & mask == mask;
                let index = if cfg!(target_endian = "big") {
                    bit_width as usize - 1 - i
                } else {
                    i
                };
                self.set_bit(index + bit_offset, val_bit_is_set);
            }
        }
    }
    #[repr(C)]
    #[derive(Default)]
    pub struct __IncompleteArrayField<T>(::std::marker::PhantomData<T>, [T; 0]);
    impl<T> __IncompleteArrayField<T> {
        #[inline]
        pub fn new() -> Self {
            __IncompleteArrayField(::std::marker::PhantomData, [])
        }
        #[inline]
        pub unsafe fn as_ptr(&self) -> *const T {
            ::std::mem::transmute(self)
        }
        #[inline]
        pub unsafe fn as_mut_ptr(&mut self) -> *mut T {
            ::std::mem::transmute(self)
        }
        #[inline]
        pub unsafe fn as_slice(&self, len: usize) -> &[T] {
            ::std::slice::from_raw_parts(self.as_ptr(), len)
        }
        #[inline]
        pub unsafe fn as_mut_slice(&mut self, len: usize) -> &mut [T] {
            ::std::slice::from_raw_parts_mut(self.as_mut_ptr(), len)
        }
    }
    impl<T> ::std::fmt::Debug for __IncompleteArrayField<T> {
        fn fmt(&self, fmt: &mut ::std::fmt::Formatter<'_>) -> ::std::fmt::Result {
            fmt.write_str("__IncompleteArrayField")
        }
    }
    impl<T> ::std::clone::Clone for __IncompleteArrayField<T> {
        #[inline]
        fn clone(&self) -> Self {
            Self::new()
        }
    }
    #[repr(C)]
    pub struct __BindgenUnionField<T>(::std::marker::PhantomData<T>);
    impl<T> __BindgenUnionField<T> {
        #[inline]
        pub fn new() -> Self {
            __BindgenUnionField(::std::marker::PhantomData)
        }
        #[inline]
        pub unsafe fn as_ref(&self) -> &T {
            ::std::mem::transmute(self)
        }
        #[inline]
        pub unsafe fn as_mut(&mut self) -> &mut T {
            ::std::mem::transmute(self)
        }
    }
    impl<T> ::std::default::Default for __BindgenUnionField<T> {
        #[inline]
        fn default() -> Self {
            Self::new()
        }
    }
    impl<T> ::std::clone::Clone for __BindgenUnionField<T> {
        #[inline]
        fn clone(&self) -> Self {
            Self::new()
        }
    }
    impl<T> ::std::marker::Copy for __BindgenUnionField<T> {}
    impl<T> ::std::fmt::Debug for __BindgenUnionField<T> {
        fn fmt(&self, fmt: &mut ::std::fmt::Formatter<'_>) -> ::std::fmt::Result {
            fmt.write_str("__BindgenUnionField")
        }
    }
    impl<T> ::std::hash::Hash for __BindgenUnionField<T> {
        fn hash<H: ::std::hash::Hasher>(&self, _state: &mut H) {}
    }
    impl<T> ::std::cmp::PartialEq for __BindgenUnionField<T> {
        fn eq(&self, _other: &__BindgenUnionField<T>) -> bool {
            true
        }
    }
    impl<T> ::std::cmp::Eq for __BindgenUnionField<T> {}
    #[allow(unused_imports)]
    use self::super::root;
    pub const NS_FONT_STYLE_NORMAL: u32 = 0;
    pub const NS_FONT_STYLE_ITALIC: u32 = 1;
    pub const NS_FONT_STYLE_OBLIQUE: u32 = 2;
    pub const NS_FONT_WEIGHT_NORMAL: u32 = 400;
    pub const NS_FONT_WEIGHT_BOLD: u32 = 700;
    pub const NS_FONT_WEIGHT_THIN: u32 = 100;
    pub const NS_FONT_STRETCH_ULTRA_CONDENSED: u32 = 50;
    pub const NS_FONT_STRETCH_EXTRA_CONDENSED: u32 = 62;
    pub const NS_FONT_STRETCH_CONDENSED: u32 = 75;
    pub const NS_FONT_STRETCH_SEMI_CONDENSED: u32 = 87;
    pub const NS_FONT_STRETCH_NORMAL: u32 = 100;
    pub const NS_FONT_STRETCH_SEMI_EXPANDED: u32 = 112;
    pub const NS_FONT_STRETCH_EXPANDED: u32 = 125;
    pub const NS_FONT_STRETCH_EXTRA_EXPANDED: u32 = 150;
    pub const NS_FONT_STRETCH_ULTRA_EXPANDED: u32 = 200;
    pub const NS_FONT_SMOOTHING_AUTO: u32 = 0;
    pub const NS_FONT_SMOOTHING_GRAYSCALE: u32 = 1;
    pub const NS_FONT_KERNING_AUTO: u32 = 0;
    pub const NS_FONT_KERNING_NONE: u32 = 1;
    pub const NS_FONT_KERNING_NORMAL: u32 = 2;
    pub const NS_FONT_SYNTHESIS_WEIGHT: u32 = 1;
    pub const NS_FONT_SYNTHESIS_STYLE: u32 = 2;
    pub const NS_FONT_OPTICAL_SIZING_AUTO: u32 = 0;
    pub const NS_FONT_OPTICAL_SIZING_NONE: u32 = 1;
    pub const NS_FONT_VARIANT_ALTERNATES_NORMAL: u32 = 0;
    pub const NS_FONT_VARIANT_ALTERNATES_HISTORICAL: u32 = 1;
    pub const NS_FONT_VARIANT_ALTERNATES_STYLISTIC: u32 = 2;
    pub const NS_FONT_VARIANT_ALTERNATES_STYLESET: u32 = 4;
    pub const NS_FONT_VARIANT_ALTERNATES_CHARACTER_VARIANT: u32 = 8;
    pub const NS_FONT_VARIANT_ALTERNATES_SWASH: u32 = 16;
    pub const NS_FONT_VARIANT_ALTERNATES_ORNAMENTS: u32 = 32;
    pub const NS_FONT_VARIANT_ALTERNATES_ANNOTATION: u32 = 64;
    pub const NS_FONT_VARIANT_ALTERNATES_COUNT: u32 = 7;
    pub const NS_FONT_VARIANT_ALTERNATES_ENUMERATED_MASK: u32 = 1;
    pub const NS_FONT_VARIANT_ALTERNATES_FUNCTIONAL_MASK: u32 = 126;
    pub const NS_FONT_VARIANT_CAPS_NORMAL: u32 = 0;
    pub const NS_FONT_VARIANT_CAPS_SMALLCAPS: u32 = 1;
    pub const NS_FONT_VARIANT_CAPS_ALLSMALL: u32 = 2;
    pub const NS_FONT_VARIANT_CAPS_PETITECAPS: u32 = 3;
    pub const NS_FONT_VARIANT_CAPS_ALLPETITE: u32 = 4;
    pub const NS_FONT_VARIANT_CAPS_TITLING: u32 = 5;
    pub const NS_FONT_VARIANT_CAPS_UNICASE: u32 = 6;
    pub const NS_FONT_VARIANT_EAST_ASIAN_NORMAL: u32 = 0;
    pub const NS_FONT_VARIANT_EAST_ASIAN_JIS78: u32 = 1;
    pub const NS_FONT_VARIANT_EAST_ASIAN_JIS83: u32 = 2;
    pub const NS_FONT_VARIANT_EAST_ASIAN_JIS90: u32 = 4;
    pub const NS_FONT_VARIANT_EAST_ASIAN_JIS04: u32 = 8;
    pub const NS_FONT_VARIANT_EAST_ASIAN_SIMPLIFIED: u32 = 16;
    pub const NS_FONT_VARIANT_EAST_ASIAN_TRADITIONAL: u32 = 32;
    pub const NS_FONT_VARIANT_EAST_ASIAN_FULL_WIDTH: u32 = 64;
    pub const NS_FONT_VARIANT_EAST_ASIAN_PROP_WIDTH: u32 = 128;
    pub const NS_FONT_VARIANT_EAST_ASIAN_RUBY: u32 = 256;
    pub const NS_FONT_VARIANT_EAST_ASIAN_COUNT: u32 = 9;
    pub const NS_FONT_VARIANT_EAST_ASIAN_VARIANT_MASK: u32 = 63;
    pub const NS_FONT_VARIANT_EAST_ASIAN_WIDTH_MASK: u32 = 192;
    pub const NS_FONT_VARIANT_LIGATURES_NORMAL: u32 = 0;
    pub const NS_FONT_VARIANT_LIGATURES_NONE: u32 = 1;
    pub const NS_FONT_VARIANT_LIGATURES_COMMON: u32 = 2;
    pub const NS_FONT_VARIANT_LIGATURES_NO_COMMON: u32 = 4;
    pub const NS_FONT_VARIANT_LIGATURES_DISCRETIONARY: u32 = 8;
    pub const NS_FONT_VARIANT_LIGATURES_NO_DISCRETIONARY: u32 = 16;
    pub const NS_FONT_VARIANT_LIGATURES_HISTORICAL: u32 = 32;
    pub const NS_FONT_VARIANT_LIGATURES_NO_HISTORICAL: u32 = 64;
    pub const NS_FONT_VARIANT_LIGATURES_CONTEXTUAL: u32 = 128;
    pub const NS_FONT_VARIANT_LIGATURES_NO_CONTEXTUAL: u32 = 256;
    pub const NS_FONT_VARIANT_LIGATURES_COUNT: u32 = 9;
    pub const NS_FONT_VARIANT_LIGATURES_COMMON_MASK: u32 = 6;
    pub const NS_FONT_VARIANT_LIGATURES_DISCRETIONARY_MASK: u32 = 24;
    pub const NS_FONT_VARIANT_LIGATURES_HISTORICAL_MASK: u32 = 96;
    pub const NS_FONT_VARIANT_LIGATURES_CONTEXTUAL_MASK: u32 = 384;
    pub const NS_FONT_VARIANT_NUMERIC_NORMAL: u32 = 0;
    pub const NS_FONT_VARIANT_NUMERIC_LINING: u32 = 1;
    pub const NS_FONT_VARIANT_NUMERIC_OLDSTYLE: u32 = 2;
    pub const NS_FONT_VARIANT_NUMERIC_PROPORTIONAL: u32 = 4;
    pub const NS_FONT_VARIANT_NUMERIC_TABULAR: u32 = 8;
    pub const NS_FONT_VARIANT_NUMERIC_DIAGONAL_FRACTIONS: u32 = 16;
    pub const NS_FONT_VARIANT_NUMERIC_STACKED_FRACTIONS: u32 = 32;
    pub const NS_FONT_VARIANT_NUMERIC_SLASHZERO: u32 = 64;
    pub const NS_FONT_VARIANT_NUMERIC_ORDINAL: u32 = 128;
    pub const NS_FONT_VARIANT_NUMERIC_COUNT: u32 = 8;
    pub const NS_FONT_VARIANT_NUMERIC_FIGURE_MASK: u32 = 3;
    pub const NS_FONT_VARIANT_NUMERIC_SPACING_MASK: u32 = 12;
    pub const NS_FONT_VARIANT_NUMERIC_FRACTION_MASK: u32 = 48;
    pub const NS_FONT_VARIANT_POSITION_NORMAL: u32 = 0;
    pub const NS_FONT_VARIANT_POSITION_SUPER: u32 = 1;
    pub const NS_FONT_VARIANT_POSITION_SUB: u32 = 2;
    pub const NS_FONT_VARIANT_WIDTH_NORMAL: u32 = 0;
    pub const NS_FONT_VARIANT_WIDTH_FULL: u32 = 1;
    pub const NS_FONT_VARIANT_WIDTH_HALF: u32 = 2;
    pub const NS_FONT_VARIANT_WIDTH_THIRD: u32 = 3;
    pub const NS_FONT_VARIANT_WIDTH_QUARTER: u32 = 4;
    pub const NS_FONT_SUBSCRIPT_OFFSET_RATIO: f64 = 0.2;
    pub const NS_FONT_SUPERSCRIPT_OFFSET_RATIO: f64 = 0.34;
    pub const NS_FONT_SUB_SUPER_SIZE_RATIO_SMALL: f64 = 0.82;
    pub const NS_FONT_SUB_SUPER_SIZE_RATIO_LARGE: f64 = 0.667;
    pub const NS_FONT_SUB_SUPER_SMALL_SIZE: f64 = 20.0;
    pub const NS_FONT_SUB_SUPER_LARGE_SIZE: f64 = 45.0;
    pub const NS_STYLE_DIRECTION_LTR: u32 = 0;
    pub const NS_STYLE_DIRECTION_RTL: u32 = 1;
    pub const NS_STYLE_WRITING_MODE_HORIZONTAL_TB: u32 = 0;
    pub const NS_STYLE_WRITING_MODE_VERTICAL_RL: u32 = 1;
    pub const NS_STYLE_WRITING_MODE_VERTICAL_LR: u32 = 3;
    pub const NS_STYLE_WRITING_MODE_SIDEWAYS_MASK: u32 = 4;
    pub const NS_STYLE_WRITING_MODE_SIDEWAYS_RL: u32 = 5;
    pub const NS_STYLE_WRITING_MODE_SIDEWAYS_LR: u32 = 7;
    pub const NS_STYLE_ALIGN_AUTO: u32 = 0;
    pub const NS_STYLE_ALIGN_NORMAL: u32 = 1;
    pub const NS_STYLE_ALIGN_START: u32 = 2;
    pub const NS_STYLE_ALIGN_END: u32 = 3;
    pub const NS_STYLE_ALIGN_FLEX_START: u32 = 4;
    pub const NS_STYLE_ALIGN_FLEX_END: u32 = 5;
    pub const NS_STYLE_ALIGN_CENTER: u32 = 6;
    pub const NS_STYLE_ALIGN_LEFT: u32 = 7;
    pub const NS_STYLE_ALIGN_RIGHT: u32 = 8;
    pub const NS_STYLE_ALIGN_BASELINE: u32 = 9;
    pub const NS_STYLE_ALIGN_LAST_BASELINE: u32 = 10;
    pub const NS_STYLE_ALIGN_STRETCH: u32 = 11;
    pub const NS_STYLE_ALIGN_SELF_START: u32 = 12;
    pub const NS_STYLE_ALIGN_SELF_END: u32 = 13;
    pub const NS_STYLE_ALIGN_SPACE_BETWEEN: u32 = 14;
    pub const NS_STYLE_ALIGN_SPACE_AROUND: u32 = 15;
    pub const NS_STYLE_ALIGN_SPACE_EVENLY: u32 = 16;
    pub const NS_STYLE_ALIGN_LEGACY: u32 = 32;
    pub const NS_STYLE_ALIGN_SAFE: u32 = 64;
    pub const NS_STYLE_ALIGN_UNSAFE: u32 = 128;
    pub const NS_STYLE_ALIGN_FLAG_BITS: u32 = 224;
    pub const NS_STYLE_ALIGN_ALL_BITS: u32 = 255;
    pub const NS_STYLE_ALIGN_ALL_SHIFT: u32 = 8;
    pub const NS_STYLE_JUSTIFY_AUTO: u32 = 0;
    pub const NS_STYLE_JUSTIFY_NORMAL: u32 = 1;
    pub const NS_STYLE_JUSTIFY_START: u32 = 2;
    pub const NS_STYLE_JUSTIFY_END: u32 = 3;
    pub const NS_STYLE_JUSTIFY_FLEX_START: u32 = 4;
    pub const NS_STYLE_JUSTIFY_FLEX_END: u32 = 5;
    pub const NS_STYLE_JUSTIFY_CENTER: u32 = 6;
    pub const NS_STYLE_JUSTIFY_LEFT: u32 = 7;
    pub const NS_STYLE_JUSTIFY_RIGHT: u32 = 8;
    pub const NS_STYLE_JUSTIFY_BASELINE: u32 = 9;
    pub const NS_STYLE_JUSTIFY_LAST_BASELINE: u32 = 10;
    pub const NS_STYLE_JUSTIFY_STRETCH: u32 = 11;
    pub const NS_STYLE_JUSTIFY_SELF_START: u32 = 12;
    pub const NS_STYLE_JUSTIFY_SELF_END: u32 = 13;
    pub const NS_STYLE_JUSTIFY_SPACE_BETWEEN: u32 = 14;
    pub const NS_STYLE_JUSTIFY_SPACE_AROUND: u32 = 15;
    pub const NS_STYLE_JUSTIFY_SPACE_EVENLY: u32 = 16;
    pub const NS_STYLE_JUSTIFY_LEGACY: u32 = 32;
    pub const NS_STYLE_JUSTIFY_SAFE: u32 = 64;
    pub const NS_STYLE_JUSTIFY_UNSAFE: u32 = 128;
    pub const NS_STYLE_JUSTIFY_FLAG_BITS: u32 = 224;
    pub const NS_STYLE_JUSTIFY_ALL_BITS: u32 = 255;
    pub const NS_STYLE_JUSTIFY_ALL_SHIFT: u32 = 8;
    pub const NS_STYLE_FLEX_WRAP_NOWRAP: u32 = 0;
    pub const NS_STYLE_FLEX_WRAP_WRAP: u32 = 1;
    pub const NS_STYLE_FLEX_WRAP_WRAP_REVERSE: u32 = 2;
    pub const NS_STYLE_ORDER_INITIAL: u32 = 0;
    pub const NS_STYLE_FILTER_NONE: u32 = 0;
    pub const NS_STYLE_FILTER_URL: u32 = 1;
    pub const NS_STYLE_FILTER_BLUR: u32 = 2;
    pub const NS_STYLE_FILTER_BRIGHTNESS: u32 = 3;
    pub const NS_STYLE_FILTER_CONTRAST: u32 = 4;
    pub const NS_STYLE_FILTER_GRAYSCALE: u32 = 5;
    pub const NS_STYLE_FILTER_INVERT: u32 = 6;
    pub const NS_STYLE_FILTER_OPACITY: u32 = 7;
    pub const NS_STYLE_FILTER_SATURATE: u32 = 8;
    pub const NS_STYLE_FILTER_SEPIA: u32 = 9;
    pub const NS_STYLE_FILTER_HUE_ROTATE: u32 = 10;
    pub const NS_STYLE_FILTER_DROP_SHADOW: u32 = 11;
    pub const NS_STYLE_FONT_SIZE_XXSMALL: u32 = 0;
    pub const NS_STYLE_FONT_SIZE_XSMALL: u32 = 1;
    pub const NS_STYLE_FONT_SIZE_SMALL: u32 = 2;
    pub const NS_STYLE_FONT_SIZE_MEDIUM: u32 = 3;
    pub const NS_STYLE_FONT_SIZE_LARGE: u32 = 4;
    pub const NS_STYLE_FONT_SIZE_XLARGE: u32 = 5;
    pub const NS_STYLE_FONT_SIZE_XXLARGE: u32 = 6;
    pub const NS_STYLE_FONT_SIZE_XXXLARGE: u32 = 7;
    pub const NS_STYLE_FONT_SIZE_LARGER: u32 = 8;
    pub const NS_STYLE_FONT_SIZE_SMALLER: u32 = 9;
    pub const NS_STYLE_FONT_SIZE_NO_KEYWORD: u32 = 10;
    pub const NS_STYLE_GRID_AUTO_FLOW_ROW: u32 = 1;
    pub const NS_STYLE_GRID_AUTO_FLOW_COLUMN: u32 = 2;
    pub const NS_STYLE_GRID_AUTO_FLOW_DENSE: u32 = 4;
    pub const NS_STYLE_GRID_TEMPLATE_SUBGRID: u32 = 0;
    pub const NS_STYLE_GRID_REPEAT_AUTO_FILL: u32 = 0;
    pub const NS_STYLE_GRID_REPEAT_AUTO_FIT: u32 = 1;
    pub const NS_MATHML_DEFAULT_SCRIPT_SIZE_MULTIPLIER: f64 = 0.71;
    pub const NS_MATHML_DEFAULT_SCRIPT_MIN_SIZE_PT: u32 = 8;
    pub const NS_MATHML_MATHVARIANT_NONE: u32 = 0;
    pub const NS_MATHML_MATHVARIANT_NORMAL: u32 = 1;
    pub const NS_MATHML_MATHVARIANT_BOLD: u32 = 2;
    pub const NS_MATHML_MATHVARIANT_ITALIC: u32 = 3;
    pub const NS_MATHML_MATHVARIANT_BOLD_ITALIC: u32 = 4;
    pub const NS_MATHML_MATHVARIANT_SCRIPT: u32 = 5;
    pub const NS_MATHML_MATHVARIANT_BOLD_SCRIPT: u32 = 6;
    pub const NS_MATHML_MATHVARIANT_FRAKTUR: u32 = 7;
    pub const NS_MATHML_MATHVARIANT_DOUBLE_STRUCK: u32 = 8;
    pub const NS_MATHML_MATHVARIANT_BOLD_FRAKTUR: u32 = 9;
    pub const NS_MATHML_MATHVARIANT_SANS_SERIF: u32 = 10;
    pub const NS_MATHML_MATHVARIANT_BOLD_SANS_SERIF: u32 = 11;
    pub const NS_MATHML_MATHVARIANT_SANS_SERIF_ITALIC: u32 = 12;
    pub const NS_MATHML_MATHVARIANT_SANS_SERIF_BOLD_ITALIC: u32 = 13;
    pub const NS_MATHML_MATHVARIANT_MONOSPACE: u32 = 14;
    pub const NS_MATHML_MATHVARIANT_INITIAL: u32 = 15;
    pub const NS_MATHML_MATHVARIANT_TAILED: u32 = 16;
    pub const NS_MATHML_MATHVARIANT_LOOPED: u32 = 17;
    pub const NS_MATHML_MATHVARIANT_STRETCHED: u32 = 18;
    pub const NS_MATHML_DISPLAYSTYLE_INLINE: u32 = 0;
    pub const NS_MATHML_DISPLAYSTYLE_BLOCK: u32 = 1;
    pub const NS_STYLE_POSITION_STATIC: u32 = 0;
    pub const NS_STYLE_POSITION_RELATIVE: u32 = 1;
    pub const NS_STYLE_POSITION_ABSOLUTE: u32 = 2;
    pub const NS_STYLE_POSITION_FIXED: u32 = 3;
    pub const NS_STYLE_POSITION_STICKY: u32 = 4;
    pub const NS_STYLE_CLIP_AUTO: u32 = 0;
    pub const NS_STYLE_CLIP_RECT: u32 = 1;
    pub const NS_STYLE_CLIP_TYPE_MASK: u32 = 15;
    pub const NS_STYLE_CLIP_LEFT_AUTO: u32 = 16;
    pub const NS_STYLE_CLIP_TOP_AUTO: u32 = 32;
    pub const NS_STYLE_CLIP_RIGHT_AUTO: u32 = 64;
    pub const NS_STYLE_CLIP_BOTTOM_AUTO: u32 = 128;
    pub const NS_STYLE_FRAME_YES: u32 = 0;
    pub const NS_STYLE_FRAME_NO: u32 = 1;
    pub const NS_STYLE_FRAME_0: u32 = 2;
    pub const NS_STYLE_FRAME_1: u32 = 3;
    pub const NS_STYLE_FRAME_ON: u32 = 4;
    pub const NS_STYLE_FRAME_OFF: u32 = 5;
    pub const NS_STYLE_FRAME_AUTO: u32 = 6;
    pub const NS_STYLE_FRAME_SCROLL: u32 = 7;
    pub const NS_STYLE_FRAME_NOSCROLL: u32 = 8;
    pub const NS_STYLE_LIST_STYLE_CUSTOM: i32 = -1;
    pub const NS_STYLE_LIST_STYLE_NONE: u32 = 0;
    pub const NS_STYLE_LIST_STYLE_DECIMAL: u32 = 1;
    pub const NS_STYLE_LIST_STYLE_DISC: u32 = 2;
    pub const NS_STYLE_LIST_STYLE_CIRCLE: u32 = 3;
    pub const NS_STYLE_LIST_STYLE_SQUARE: u32 = 4;
    pub const NS_STYLE_LIST_STYLE_DISCLOSURE_CLOSED: u32 = 5;
    pub const NS_STYLE_LIST_STYLE_DISCLOSURE_OPEN: u32 = 6;
    pub const NS_STYLE_LIST_STYLE_HEBREW: u32 = 7;
    pub const NS_STYLE_LIST_STYLE_JAPANESE_INFORMAL: u32 = 8;
    pub const NS_STYLE_LIST_STYLE_JAPANESE_FORMAL: u32 = 9;
    pub const NS_STYLE_LIST_STYLE_KOREAN_HANGUL_FORMAL: u32 = 10;
    pub const NS_STYLE_LIST_STYLE_KOREAN_HANJA_INFORMAL: u32 = 11;
    pub const NS_STYLE_LIST_STYLE_KOREAN_HANJA_FORMAL: u32 = 12;
    pub const NS_STYLE_LIST_STYLE_SIMP_CHINESE_INFORMAL: u32 = 13;
    pub const NS_STYLE_LIST_STYLE_SIMP_CHINESE_FORMAL: u32 = 14;
    pub const NS_STYLE_LIST_STYLE_TRAD_CHINESE_INFORMAL: u32 = 15;
    pub const NS_STYLE_LIST_STYLE_TRAD_CHINESE_FORMAL: u32 = 16;
    pub const NS_STYLE_LIST_STYLE_ETHIOPIC_NUMERIC: u32 = 17;
    pub const NS_STYLE_LIST_STYLE_LOWER_ROMAN: u32 = 100;
    pub const NS_STYLE_LIST_STYLE_UPPER_ROMAN: u32 = 101;
    pub const NS_STYLE_LIST_STYLE_LOWER_ALPHA: u32 = 102;
    pub const NS_STYLE_LIST_STYLE_UPPER_ALPHA: u32 = 103;
    pub const NS_STYLE_LIST_STYLE_POSITION_INSIDE: u32 = 0;
    pub const NS_STYLE_LIST_STYLE_POSITION_OUTSIDE: u32 = 1;
    pub const NS_STYLE_POINTER_EVENTS_NONE: u32 = 0;
    pub const NS_STYLE_POINTER_EVENTS_VISIBLEPAINTED: u32 = 1;
    pub const NS_STYLE_POINTER_EVENTS_VISIBLEFILL: u32 = 2;
    pub const NS_STYLE_POINTER_EVENTS_VISIBLESTROKE: u32 = 3;
    pub const NS_STYLE_POINTER_EVENTS_VISIBLE: u32 = 4;
    pub const NS_STYLE_POINTER_EVENTS_PAINTED: u32 = 5;
    pub const NS_STYLE_POINTER_EVENTS_FILL: u32 = 6;
    pub const NS_STYLE_POINTER_EVENTS_STROKE: u32 = 7;
    pub const NS_STYLE_POINTER_EVENTS_ALL: u32 = 8;
    pub const NS_STYLE_POINTER_EVENTS_AUTO: u32 = 9;
    pub const NS_STYLE_IMAGE_ORIENTATION_FLIP: u32 = 0;
    pub const NS_STYLE_IMAGE_ORIENTATION_FROM_IMAGE: u32 = 1;
    pub const NS_STYLE_ISOLATION_AUTO: u32 = 0;
    pub const NS_STYLE_ISOLATION_ISOLATE: u32 = 1;
    pub const NS_STYLE_OBJECT_FIT_FILL: u32 = 0;
    pub const NS_STYLE_OBJECT_FIT_CONTAIN: u32 = 1;
    pub const NS_STYLE_OBJECT_FIT_COVER: u32 = 2;
    pub const NS_STYLE_OBJECT_FIT_NONE: u32 = 3;
    pub const NS_STYLE_OBJECT_FIT_SCALE_DOWN: u32 = 4;
    pub const NS_STYLE_TEXT_ALIGN_START: u32 = 0;
    pub const NS_STYLE_TEXT_ALIGN_LEFT: u32 = 1;
    pub const NS_STYLE_TEXT_ALIGN_RIGHT: u32 = 2;
    pub const NS_STYLE_TEXT_ALIGN_CENTER: u32 = 3;
    pub const NS_STYLE_TEXT_ALIGN_JUSTIFY: u32 = 4;
    pub const NS_STYLE_TEXT_ALIGN_CHAR: u32 = 5;
    pub const NS_STYLE_TEXT_ALIGN_END: u32 = 6;
    pub const NS_STYLE_TEXT_ALIGN_AUTO: u32 = 7;
    pub const NS_STYLE_TEXT_ALIGN_MOZ_CENTER: u32 = 8;
    pub const NS_STYLE_TEXT_ALIGN_MOZ_RIGHT: u32 = 9;
    pub const NS_STYLE_TEXT_ALIGN_MOZ_LEFT: u32 = 10;
    pub const NS_STYLE_TEXT_DECORATION_STYLE_NONE: u32 = 0;
    pub const NS_STYLE_TEXT_DECORATION_STYLE_DOTTED: u32 = 1;
    pub const NS_STYLE_TEXT_DECORATION_STYLE_DASHED: u32 = 2;
    pub const NS_STYLE_TEXT_DECORATION_STYLE_SOLID: u32 = 3;
    pub const NS_STYLE_TEXT_DECORATION_STYLE_DOUBLE: u32 = 4;
    pub const NS_STYLE_TEXT_DECORATION_STYLE_WAVY: u32 = 5;
    pub const NS_STYLE_TEXT_DECORATION_STYLE_MAX: u32 = 5;
    pub const NS_STYLE_TEXT_OVERFLOW_CLIP: u32 = 0;
    pub const NS_STYLE_TEXT_OVERFLOW_ELLIPSIS: u32 = 1;
    pub const NS_STYLE_TEXT_OVERFLOW_STRING: u32 = 2;
    pub const NS_STYLE_TEXT_TRANSFORM_NONE: u32 = 0;
    pub const NS_STYLE_TEXT_TRANSFORM_CAPITALIZE: u32 = 1;
    pub const NS_STYLE_TEXT_TRANSFORM_LOWERCASE: u32 = 2;
    pub const NS_STYLE_TEXT_TRANSFORM_UPPERCASE: u32 = 3;
    pub const NS_STYLE_TEXT_TRANSFORM_FULL_WIDTH: u32 = 4;
    pub const NS_STYLE_TEXT_TRANSFORM_FULL_SIZE_KANA: u32 = 5;
    pub const NS_STYLE_TOP_LAYER_NONE: u32 = 0;
    pub const NS_STYLE_TOP_LAYER_TOP: u32 = 1;
    pub const NS_STYLE_VISIBILITY_HIDDEN: u32 = 0;
    pub const NS_STYLE_VISIBILITY_VISIBLE: u32 = 1;
    pub const NS_STYLE_VISIBILITY_COLLAPSE: u32 = 2;
    pub const NS_STYLE_TABSIZE_INITIAL: u32 = 8;
    pub const NS_STYLE_RUBY_ALIGN_START: u32 = 0;
    pub const NS_STYLE_RUBY_ALIGN_CENTER: u32 = 1;
    pub const NS_STYLE_RUBY_ALIGN_SPACE_BETWEEN: u32 = 2;
    pub const NS_STYLE_RUBY_ALIGN_SPACE_AROUND: u32 = 3;
    pub const NS_STYLE_RUBY_POSITION_OVER: u32 = 0;
    pub const NS_STYLE_RUBY_POSITION_UNDER: u32 = 1;
    pub const NS_STYLE_RUBY_POSITION_INTER_CHARACTER: u32 = 2;
    pub const NS_STYLE_TEXT_SIZE_ADJUST_NONE: u32 = 0;
    pub const NS_STYLE_TEXT_SIZE_ADJUST_AUTO: u32 = 1;
    pub const NS_STYLE_TEXT_ORIENTATION_MIXED: u32 = 0;
    pub const NS_STYLE_TEXT_ORIENTATION_UPRIGHT: u32 = 1;
    pub const NS_STYLE_TEXT_ORIENTATION_SIDEWAYS: u32 = 2;
    pub const NS_STYLE_TEXT_COMBINE_UPRIGHT_NONE: u32 = 0;
    pub const NS_STYLE_TEXT_COMBINE_UPRIGHT_ALL: u32 = 1;
    pub const NS_STYLE_LINE_HEIGHT_BLOCK_HEIGHT: u32 = 0;
    pub const NS_STYLE_UNICODE_BIDI_NORMAL: u32 = 0;
    pub const NS_STYLE_UNICODE_BIDI_EMBED: u32 = 1;
    pub const NS_STYLE_UNICODE_BIDI_ISOLATE: u32 = 2;
    pub const NS_STYLE_UNICODE_BIDI_BIDI_OVERRIDE: u32 = 4;
    pub const NS_STYLE_UNICODE_BIDI_ISOLATE_OVERRIDE: u32 = 6;
    pub const NS_STYLE_UNICODE_BIDI_PLAINTEXT: u32 = 8;
    pub const NS_STYLE_TABLE_LAYOUT_AUTO: u32 = 0;
    pub const NS_STYLE_TABLE_LAYOUT_FIXED: u32 = 1;
    pub const NS_STYLE_TABLE_EMPTY_CELLS_HIDE: u32 = 0;
    pub const NS_STYLE_TABLE_EMPTY_CELLS_SHOW: u32 = 1;
    pub const NS_STYLE_CAPTION_SIDE_TOP: u32 = 0;
    pub const NS_STYLE_CAPTION_SIDE_RIGHT: u32 = 1;
    pub const NS_STYLE_CAPTION_SIDE_BOTTOM: u32 = 2;
    pub const NS_STYLE_CAPTION_SIDE_LEFT: u32 = 3;
    pub const NS_STYLE_CAPTION_SIDE_TOP_OUTSIDE: u32 = 4;
    pub const NS_STYLE_CAPTION_SIDE_BOTTOM_OUTSIDE: u32 = 5;
    pub const NS_STYLE_CELL_SCOPE_ROW: u32 = 0;
    pub const NS_STYLE_CELL_SCOPE_COL: u32 = 1;
    pub const NS_STYLE_CELL_SCOPE_ROWGROUP: u32 = 2;
    pub const NS_STYLE_CELL_SCOPE_COLGROUP: u32 = 3;
    pub const NS_STYLE_PAGE_MARKS_NONE: u32 = 0;
    pub const NS_STYLE_PAGE_MARKS_CROP: u32 = 1;
    pub const NS_STYLE_PAGE_MARKS_REGISTER: u32 = 2;
    pub const NS_STYLE_PAGE_SIZE_AUTO: u32 = 0;
    pub const NS_STYLE_PAGE_SIZE_PORTRAIT: u32 = 1;
    pub const NS_STYLE_PAGE_SIZE_LANDSCAPE: u32 = 2;
    pub const NS_STYLE_PAGE_BREAK_AUTO: u32 = 0;
    pub const NS_STYLE_PAGE_BREAK_ALWAYS: u32 = 1;
    pub const NS_STYLE_PAGE_BREAK_AVOID: u32 = 2;
    pub const NS_STYLE_PAGE_BREAK_LEFT: u32 = 3;
    pub const NS_STYLE_PAGE_BREAK_RIGHT: u32 = 4;
    pub const NS_STYLE_IME_MODE_AUTO: u32 = 0;
    pub const NS_STYLE_IME_MODE_NORMAL: u32 = 1;
    pub const NS_STYLE_IME_MODE_ACTIVE: u32 = 2;
    pub const NS_STYLE_IME_MODE_DISABLED: u32 = 3;
    pub const NS_STYLE_IME_MODE_INACTIVE: u32 = 4;
    pub const NS_STYLE_GRADIENT_SHAPE_LINEAR: u32 = 0;
    pub const NS_STYLE_GRADIENT_SHAPE_ELLIPTICAL: u32 = 1;
    pub const NS_STYLE_GRADIENT_SHAPE_CIRCULAR: u32 = 2;
    pub const NS_STYLE_GRADIENT_SIZE_CLOSEST_SIDE: u32 = 0;
    pub const NS_STYLE_GRADIENT_SIZE_CLOSEST_CORNER: u32 = 1;
    pub const NS_STYLE_GRADIENT_SIZE_FARTHEST_SIDE: u32 = 2;
    pub const NS_STYLE_GRADIENT_SIZE_FARTHEST_CORNER: u32 = 3;
    pub const NS_STYLE_GRADIENT_SIZE_EXPLICIT_SIZE: u32 = 4;
    pub const NS_STYLE_WINDOW_SHADOW_NONE: u32 = 0;
    pub const NS_STYLE_WINDOW_SHADOW_DEFAULT: u32 = 1;
    pub const NS_STYLE_WINDOW_SHADOW_MENU: u32 = 2;
    pub const NS_STYLE_WINDOW_SHADOW_TOOLTIP: u32 = 3;
    pub const NS_STYLE_WINDOW_SHADOW_SHEET: u32 = 4;
    pub const NS_STYLE_DOMINANT_BASELINE_AUTO: u32 = 0;
    pub const NS_STYLE_DOMINANT_BASELINE_USE_SCRIPT: u32 = 1;
    pub const NS_STYLE_DOMINANT_BASELINE_NO_CHANGE: u32 = 2;
    pub const NS_STYLE_DOMINANT_BASELINE_RESET_SIZE: u32 = 3;
    pub const NS_STYLE_DOMINANT_BASELINE_IDEOGRAPHIC: u32 = 4;
    pub const NS_STYLE_DOMINANT_BASELINE_ALPHABETIC: u32 = 5;
    pub const NS_STYLE_DOMINANT_BASELINE_HANGING: u32 = 6;
    pub const NS_STYLE_DOMINANT_BASELINE_MATHEMATICAL: u32 = 7;
    pub const NS_STYLE_DOMINANT_BASELINE_CENTRAL: u32 = 8;
    pub const NS_STYLE_DOMINANT_BASELINE_MIDDLE: u32 = 9;
    pub const NS_STYLE_DOMINANT_BASELINE_TEXT_AFTER_EDGE: u32 = 10;
    pub const NS_STYLE_DOMINANT_BASELINE_TEXT_BEFORE_EDGE: u32 = 11;
    pub const NS_STYLE_IMAGE_RENDERING_AUTO: u32 = 0;
    pub const NS_STYLE_IMAGE_RENDERING_OPTIMIZESPEED: u32 = 1;
    pub const NS_STYLE_IMAGE_RENDERING_OPTIMIZEQUALITY: u32 = 2;
    pub const NS_STYLE_IMAGE_RENDERING_CRISP_EDGES: u32 = 3;
    pub const NS_STYLE_MASK_TYPE_LUMINANCE: u32 = 0;
    pub const NS_STYLE_MASK_TYPE_ALPHA: u32 = 1;
    pub const NS_STYLE_PAINT_ORDER_NORMAL: u32 = 0;
    pub const NS_STYLE_PAINT_ORDER_FILL: u32 = 1;
    pub const NS_STYLE_PAINT_ORDER_STROKE: u32 = 2;
    pub const NS_STYLE_PAINT_ORDER_MARKERS: u32 = 3;
    pub const NS_STYLE_PAINT_ORDER_LAST_VALUE: u32 = 3;
    pub const NS_STYLE_PAINT_ORDER_BITWIDTH: u32 = 2;
    pub const NS_STYLE_SHAPE_RENDERING_AUTO: u32 = 0;
    pub const NS_STYLE_SHAPE_RENDERING_OPTIMIZESPEED: u32 = 1;
    pub const NS_STYLE_SHAPE_RENDERING_CRISPEDGES: u32 = 2;
    pub const NS_STYLE_SHAPE_RENDERING_GEOMETRICPRECISION: u32 = 3;
    pub const NS_STYLE_STROKE_LINECAP_BUTT: u32 = 0;
    pub const NS_STYLE_STROKE_LINECAP_ROUND: u32 = 1;
    pub const NS_STYLE_STROKE_LINECAP_SQUARE: u32 = 2;
    pub const NS_STYLE_STROKE_LINEJOIN_MITER: u32 = 0;
    pub const NS_STYLE_STROKE_LINEJOIN_ROUND: u32 = 1;
    pub const NS_STYLE_STROKE_LINEJOIN_BEVEL: u32 = 2;
    pub const NS_STYLE_STROKE_PROP_CONTEXT_VALUE: u32 = 0;
    pub const NS_STYLE_TEXT_ANCHOR_START: u32 = 0;
    pub const NS_STYLE_TEXT_ANCHOR_MIDDLE: u32 = 1;
    pub const NS_STYLE_TEXT_ANCHOR_END: u32 = 2;
    pub const NS_STYLE_TEXT_EMPHASIS_POSITION_OVER: u32 = 1;
    pub const NS_STYLE_TEXT_EMPHASIS_POSITION_UNDER: u32 = 2;
    pub const NS_STYLE_TEXT_EMPHASIS_POSITION_LEFT: u32 = 4;
    pub const NS_STYLE_TEXT_EMPHASIS_POSITION_RIGHT: u32 = 8;
    pub const NS_STYLE_TEXT_EMPHASIS_POSITION_DEFAULT: u32 = 9;
    pub const NS_STYLE_TEXT_EMPHASIS_POSITION_DEFAULT_ZH: u32 = 10;
    pub const NS_STYLE_TEXT_EMPHASIS_STYLE_NONE: u32 = 0;
    pub const NS_STYLE_TEXT_EMPHASIS_STYLE_FILL_MASK: u32 = 8;
    pub const NS_STYLE_TEXT_EMPHASIS_STYLE_FILLED: u32 = 0;
    pub const NS_STYLE_TEXT_EMPHASIS_STYLE_OPEN: u32 = 8;
    pub const NS_STYLE_TEXT_EMPHASIS_STYLE_SHAPE_MASK: u32 = 7;
    pub const NS_STYLE_TEXT_EMPHASIS_STYLE_DOT: u32 = 1;
    pub const NS_STYLE_TEXT_EMPHASIS_STYLE_CIRCLE: u32 = 2;
    pub const NS_STYLE_TEXT_EMPHASIS_STYLE_DOUBLE_CIRCLE: u32 = 3;
    pub const NS_STYLE_TEXT_EMPHASIS_STYLE_TRIANGLE: u32 = 4;
    pub const NS_STYLE_TEXT_EMPHASIS_STYLE_SESAME: u32 = 5;
    pub const NS_STYLE_TEXT_EMPHASIS_STYLE_STRING: u32 = 255;
    pub const NS_STYLE_COLOR_INTERPOLATION_AUTO: u32 = 0;
    pub const NS_STYLE_COLOR_INTERPOLATION_SRGB: u32 = 1;
    pub const NS_STYLE_COLOR_INTERPOLATION_LINEARRGB: u32 = 2;
    pub const NS_STYLE_VECTOR_EFFECT_NONE: u32 = 0;
    pub const NS_STYLE_VECTOR_EFFECT_NON_SCALING_STROKE: u32 = 1;
    pub const NS_STYLE_BACKFACE_VISIBILITY_VISIBLE: u32 = 1;
    pub const NS_STYLE_BACKFACE_VISIBILITY_HIDDEN: u32 = 0;
    pub const NS_STYLE_TRANSFORM_STYLE_FLAT: u32 = 0;
    pub const NS_STYLE_TRANSFORM_STYLE_PRESERVE_3D: u32 = 1;
    pub const NS_STYLE_CONTEXT_FILL_OPACITY: u32 = 0;
    pub const NS_STYLE_CONTEXT_STROKE_OPACITY: u32 = 1;
    pub const NS_STYLE_BLEND_NORMAL: u32 = 0;
    pub const NS_STYLE_BLEND_MULTIPLY: u32 = 1;
    pub const NS_STYLE_BLEND_SCREEN: u32 = 2;
    pub const NS_STYLE_BLEND_OVERLAY: u32 = 3;
    pub const NS_STYLE_BLEND_DARKEN: u32 = 4;
    pub const NS_STYLE_BLEND_LIGHTEN: u32 = 5;
    pub const NS_STYLE_BLEND_COLOR_DODGE: u32 = 6;
    pub const NS_STYLE_BLEND_COLOR_BURN: u32 = 7;
    pub const NS_STYLE_BLEND_HARD_LIGHT: u32 = 8;
    pub const NS_STYLE_BLEND_SOFT_LIGHT: u32 = 9;
    pub const NS_STYLE_BLEND_DIFFERENCE: u32 = 10;
    pub const NS_STYLE_BLEND_EXCLUSION: u32 = 11;
    pub const NS_STYLE_BLEND_HUE: u32 = 12;
    pub const NS_STYLE_BLEND_SATURATION: u32 = 13;
    pub const NS_STYLE_BLEND_COLOR: u32 = 14;
    pub const NS_STYLE_BLEND_LUMINOSITY: u32 = 15;
    pub const NS_STYLE_MASK_COMPOSITE_ADD: u32 = 0;
    pub const NS_STYLE_MASK_COMPOSITE_SUBTRACT: u32 = 1;
    pub const NS_STYLE_MASK_COMPOSITE_INTERSECT: u32 = 2;
    pub const NS_STYLE_MASK_COMPOSITE_EXCLUDE: u32 = 3;
    pub const NS_STYLE_CONTROL_CHARACTER_VISIBILITY_HIDDEN: u32 = 0;
    pub const NS_STYLE_CONTROL_CHARACTER_VISIBILITY_VISIBLE: u32 = 1;
    pub const NS_STYLE_COUNTER_SYSTEM_CYCLIC: u32 = 0;
    pub const NS_STYLE_COUNTER_SYSTEM_NUMERIC: u32 = 1;
    pub const NS_STYLE_COUNTER_SYSTEM_ALPHABETIC: u32 = 2;
    pub const NS_STYLE_COUNTER_SYSTEM_SYMBOLIC: u32 = 3;
    pub const NS_STYLE_COUNTER_SYSTEM_ADDITIVE: u32 = 4;
    pub const NS_STYLE_COUNTER_SYSTEM_FIXED: u32 = 5;
    pub const NS_STYLE_COUNTER_SYSTEM_EXTENDS: u32 = 6;
    pub const NS_STYLE_COUNTER_RANGE_INFINITE: u32 = 0;
    pub const NS_STYLE_COUNTER_SPEAKAS_BULLETS: u32 = 0;
    pub const NS_STYLE_COUNTER_SPEAKAS_NUMBERS: u32 = 1;
    pub const NS_STYLE_COUNTER_SPEAKAS_WORDS: u32 = 2;
    pub const NS_STYLE_COUNTER_SPEAKAS_SPELL_OUT: u32 = 3;
    pub const NS_STYLE_COUNTER_SPEAKAS_OTHER: u32 = 255;
    pub const NS_STYLE_SCROLL_BEHAVIOR_AUTO: u32 = 0;
    pub const NS_STYLE_SCROLL_BEHAVIOR_SMOOTH: u32 = 1;
    pub const NS_FONT_VARIANT_NORMAL: u32 = 0;
    pub const NS_FONT_VARIANT_SMALL_CAPS: u32 = 1;
    pub const kNameSpaceID_Unknown: i32 = -1;
    pub const kNameSpaceID_XMLNS: u32 = 1;
    pub const kNameSpaceID_XML: u32 = 2;
    pub const kNameSpaceID_XHTML: u32 = 3;
    pub const kNameSpaceID_XLink: u32 = 4;
    pub const kNameSpaceID_XSLT: u32 = 5;
    pub const kNameSpaceID_XBL: u32 = 6;
    pub const kNameSpaceID_MathML: u32 = 7;
    pub const kNameSpaceID_RDF: u32 = 8;
    pub const kNameSpaceID_XUL: u32 = 9;
    pub const kNameSpaceID_SVG: u32 = 10;
    pub const kNameSpaceID_disabled_MathML: u32 = 11;
    pub const kNameSpaceID_disabled_SVG: u32 = 12;
    pub const kNameSpaceID_LastBuiltin: u32 = 12;
    pub const NS_ATTRVALUE_MAX_STRINGLENGTH_ATOM: u32 = 12;
    pub const NS_ATTRVALUE_INTEGERTYPE_BITS: u32 = 4;
    pub const NS_ATTRVALUE_INTEGERTYPE_MULTIPLIER: u32 = 16;
    pub const NS_ATTRVALUE_INTEGERTYPE_MAXVALUE: u32 = 134217727;
    pub const NS_ATTRVALUE_INTEGERTYPE_MINVALUE: i32 = -134217728;
    pub const NS_ATTRVALUE_ENUMTABLEINDEX_BITS: u32 = 12;
    pub const NS_ATTRVALUE_ENUMTABLE_VALUE_NEEDS_TO_UPPER: u32 = 2048;
    pub const NS_ATTRVALUE_ENUMTABLEINDEX_MAXVALUE: u32 = 2047;
    pub const kNameSpaceID_Wildcard: i32 = -2147483648;
    pub const NS_AUTHOR_SPECIFIED_BACKGROUND: u32 = 1;
    pub const NS_AUTHOR_SPECIFIED_BORDER: u32 = 2;
    pub const NS_AUTHOR_SPECIFIED_PADDING: u32 = 4;
    pub const CSS_PSEUDO_ELEMENT_IS_CSS2: u32 = 1;
    pub const CSS_PSEUDO_ELEMENT_CONTAINS_ELEMENTS: u32 = 2;
    pub const CSS_PSEUDO_ELEMENT_SUPPORTS_STYLE_ATTRIBUTE: u32 = 4;
    pub const CSS_PSEUDO_ELEMENT_SUPPORTS_USER_ACTION_STATE: u32 = 8;
    pub const CSS_PSEUDO_ELEMENT_ENABLED_IN_UA_SHEETS: u32 = 16;
    pub const CSS_PSEUDO_ELEMENT_ENABLED_IN_CHROME: u32 = 32;
    pub const CSS_PSEUDO_ELEMENT_ENABLED_IN_UA_SHEETS_AND_CHROME: u32 = 48;
    pub const CSS_PSEUDO_ELEMENT_IS_JS_CREATED_NAC: u32 = 64;
    pub const CSS_PSEUDO_ELEMENT_IS_FLEX_OR_GRID_ITEM: u32 = 128;
    pub mod std {
        #[allow(unused_imports)]
        use self::super::super::root;
        pub type integral_constant_value_type<_Tp> = _Tp;
        pub type integral_constant_type = u8;
        pub type false_type = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct __and_ {
            pub _address: u8,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct is_empty {
            pub _address: u8,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct make_unsigned {
            pub _address: u8,
        }
        pub type make_unsigned_type = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct aligned_storage_type {
            pub __data: root::__BindgenUnionField<*mut ::std::os::raw::c_uchar>,
            pub __align: root::__BindgenUnionField<root::std::aligned_storage_type__bindgen_ty_1>,
            pub bindgen_union_field: u64,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct aligned_storage_type__bindgen_ty_1 {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_aligned_storage_type() {
            assert_eq!(
                ::std::mem::size_of::<aligned_storage_type>(),
                8usize,
                concat!("Size of: ", stringify!(aligned_storage_type))
            );
            assert_eq!(
                ::std::mem::align_of::<aligned_storage_type>(),
                8usize,
                concat!("Alignment of ", stringify!(aligned_storage_type))
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct __detector {
            pub _address: u8,
        }
        pub type __detector_value_t = root::std::false_type;
        pub type __detector_type<_Default> = _Default;
        pub type __detected_or = root::std::__detector;
        pub type __detected_or_t = root::std::__detected_or;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct nothrow_t {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_nothrow_t() {
            assert_eq!(
                ::std::mem::size_of::<nothrow_t>(),
                1usize,
                concat!("Size of: ", stringify!(nothrow_t))
            );
            assert_eq!(
                ::std::mem::align_of::<nothrow_t>(),
                1usize,
                concat!("Alignment of ", stringify!(nothrow_t))
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct input_iterator_tag {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_input_iterator_tag() {
            assert_eq!(
                ::std::mem::size_of::<input_iterator_tag>(),
                1usize,
                concat!("Size of: ", stringify!(input_iterator_tag))
            );
            assert_eq!(
                ::std::mem::align_of::<input_iterator_tag>(),
                1usize,
                concat!("Alignment of ", stringify!(input_iterator_tag))
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct iterator {
            pub _address: u8,
        }
        pub type iterator_iterator_category<_Category> = _Category;
        pub type iterator_value_type<_Tp> = _Tp;
        pub type iterator_difference_type<_Distance> = _Distance;
        pub type iterator_pointer<_Pointer> = _Pointer;
        pub type iterator_reference<_Reference> = _Reference;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct __iterator_traits {
            pub _address: u8,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct iterator_traits {
            pub _address: u8,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct __undefined {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct __get_first_arg {
            pub _address: u8,
        }
        pub type __get_first_arg_type = root::std::__undefined;
        pub type __get_first_arg_t = root::std::__get_first_arg;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct __replace_first_arg {
            pub _address: u8,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct pointer_traits {
            pub _address: u8,
        }
        pub type pointer_traits___element_type = [u8; 0usize];
        pub type pointer_traits___difference_type = [u8; 0usize];
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct pointer_traits___rebind {
            pub _address: u8,
        }
        pub type pointer_traits_pointer<_Ptr> = _Ptr;
        pub type pointer_traits_element_type = root::std::__detected_or_t;
        pub type pointer_traits_difference_type = root::std::__detected_or_t;
        pub type pointer_traits_rebind = root::std::pointer_traits___rebind;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct reverse_iterator<_Iterator> {
            pub current: _Iterator,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<_Iterator>>,
        }
        pub type reverse_iterator___traits_type = root::std::iterator_traits;
        pub type reverse_iterator_iterator_type<_Iterator> = _Iterator;
        pub type reverse_iterator_difference_type = root::std::reverse_iterator___traits_type;
        pub type reverse_iterator_pointer = root::std::reverse_iterator___traits_type;
        pub type reverse_iterator_reference = root::std::reverse_iterator___traits_type;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct __allocator_traits_base {
            pub _address: u8,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct __allocator_traits_base___rebind {
            pub _address: u8,
        }
        pub type __allocator_traits_base___pointer = [u8; 0usize];
        pub type __allocator_traits_base___c_pointer = [u8; 0usize];
        pub type __allocator_traits_base___v_pointer = [u8; 0usize];
        pub type __allocator_traits_base___cv_pointer = [u8; 0usize];
        pub type __allocator_traits_base___pocca = [u8; 0usize];
        pub type __allocator_traits_base___pocma = [u8; 0usize];
        pub type __allocator_traits_base___pocs = [u8; 0usize];
        pub type __allocator_traits_base___equal = [u8; 0usize];
        #[test]
        fn bindgen_test_layout___allocator_traits_base() {
            assert_eq!(
                ::std::mem::size_of::<__allocator_traits_base>(),
                1usize,
                concat!("Size of: ", stringify!(__allocator_traits_base))
            );
            assert_eq!(
                ::std::mem::align_of::<__allocator_traits_base>(),
                1usize,
                concat!("Alignment of ", stringify!(__allocator_traits_base))
            );
        }
        pub type __alloc_rebind = root::std::__allocator_traits_base;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct allocator_traits {
            pub _address: u8,
        }
        pub type allocator_traits_allocator_type<_Alloc> = _Alloc;
        pub type allocator_traits_value_type = [u8; 0usize];
        pub type allocator_traits_pointer = root::std::__detected_or_t;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct allocator_traits__Ptr {
            pub _address: u8,
        }
        pub type allocator_traits__Ptr_type = [u8; 0usize];
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct allocator_traits__Diff {
            pub _address: u8,
        }
        pub type allocator_traits__Diff_type = root::std::pointer_traits;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct allocator_traits__Size {
            pub _address: u8,
        }
        pub type allocator_traits_const_pointer = [u8; 0usize];
        pub type allocator_traits_void_pointer = root::std::allocator_traits__Ptr;
        pub type allocator_traits_const_void_pointer = root::std::allocator_traits__Ptr;
        pub type allocator_traits_difference_type = [u8; 0usize];
        pub type allocator_traits_size_type = [u8; 0usize];
        pub type allocator_traits_propagate_on_container_copy_assignment =
            root::std::__detected_or_t;
        pub type allocator_traits_propagate_on_container_move_assignment =
            root::std::__detected_or_t;
        pub type allocator_traits_propagate_on_container_swap = root::std::__detected_or_t;
        pub type allocator_traits_is_always_equal = root::std::__detected_or_t;
        pub type allocator_traits_rebind_alloc = root::std::__alloc_rebind;
        pub type allocator_traits_rebind_traits = root::std::allocator_traits;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct allocator_traits___construct_helper {
            pub _address: u8,
        }
        pub type allocator_traits___construct_helper_type<_Alloc> = _Alloc;
        pub type allocator_traits___has_construct = root::std::allocator_traits___construct_helper;
        #[repr(C)]
        pub struct _Vector_base {
            pub _M_impl: root::std::_Vector_base__Vector_impl,
        }
        pub type _Vector_base__Tp_alloc_type = [u8; 0usize];
        pub type _Vector_base_pointer = [u8; 0usize];
        #[repr(C)]
        pub struct _Vector_base__Vector_impl {
            pub _M_start: root::std::_Vector_base_pointer,
            pub _M_finish: root::std::_Vector_base_pointer,
            pub _M_end_of_storage: root::std::_Vector_base_pointer,
        }
        pub type _Vector_base_allocator_type<_Alloc> = _Alloc;
        #[repr(C)]
        pub struct vector {
            pub _base: root::std::_Vector_base,
        }
        pub type vector__Base = root::std::_Vector_base;
        pub type vector__Tp_alloc_type = root::std::vector__Base;
        pub type vector__Alloc_traits = root::__gnu_cxx::__alloc_traits;
        pub type vector_value_type<_Tp> = _Tp;
        pub type vector_pointer = root::std::vector__Base;
        pub type vector_const_pointer = root::std::vector__Alloc_traits;
        pub type vector_reference = root::std::vector__Alloc_traits;
        pub type vector_const_reference = root::std::vector__Alloc_traits;
        pub type vector_iterator = root::__gnu_cxx::__normal_iterator<root::std::vector_pointer>;
        pub type vector_const_iterator =
            root::__gnu_cxx::__normal_iterator<root::std::vector_const_pointer>;
        pub type vector_const_reverse_iterator =
            root::std::reverse_iterator<root::std::vector_const_iterator>;
        pub type vector_reverse_iterator = root::std::reverse_iterator<root::std::vector_iterator>;
        pub type vector_size_type = usize;
        pub type vector_difference_type = isize;
        pub type vector_allocator_type<_Alloc> = _Alloc;
        #[repr(C)]
        #[derive(Debug)]
        pub struct vector__Temporary_value {
            pub _M_this: *mut root::std::vector,
            pub __buf: u8,
        }
        pub type _Base_bitset__WordT = ::std::os::raw::c_ulong;
        pub type bitset__Base = u8;
        pub type bitset__WordT = ::std::os::raw::c_ulong;
        #[repr(C)]
        #[derive(Debug)]
        pub struct bitset_reference {
            pub _M_wp: *mut root::std::bitset__WordT,
            pub _M_bpos: usize,
        }
    }
    pub mod __gnu_cxx {
        #[allow(unused_imports)]
        use self::super::super::root;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct __normal_iterator<_Iterator> {
            pub _M_current: _Iterator,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<_Iterator>>,
        }
        pub type __normal_iterator___traits_type = root::std::iterator_traits;
        pub type __normal_iterator_iterator_type<_Iterator> = _Iterator;
        pub type __normal_iterator_iterator_category =
            root::__gnu_cxx::__normal_iterator___traits_type;
        pub type __normal_iterator_value_type = root::__gnu_cxx::__normal_iterator___traits_type;
        pub type __normal_iterator_difference_type =
            root::__gnu_cxx::__normal_iterator___traits_type;
        pub type __normal_iterator_reference = root::__gnu_cxx::__normal_iterator___traits_type;
        pub type __normal_iterator_pointer = root::__gnu_cxx::__normal_iterator___traits_type;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct __alloc_traits {
            pub _address: u8,
        }
        pub type __alloc_traits_allocator_type<_Alloc> = _Alloc;
        pub type __alloc_traits__Base_type = root::std::allocator_traits;
        pub type __alloc_traits_value_type = root::__gnu_cxx::__alloc_traits__Base_type;
        pub type __alloc_traits_pointer = root::__gnu_cxx::__alloc_traits__Base_type;
        pub type __alloc_traits_const_pointer = root::__gnu_cxx::__alloc_traits__Base_type;
        pub type __alloc_traits_size_type = root::__gnu_cxx::__alloc_traits__Base_type;
        pub type __alloc_traits_difference_type = root::__gnu_cxx::__alloc_traits__Base_type;
        pub type __alloc_traits_reference = *mut root::__gnu_cxx::__alloc_traits_value_type;
        pub type __alloc_traits_const_reference = *const root::__gnu_cxx::__alloc_traits_value_type;
        pub type __alloc_traits___is_custom_pointer = root::std::__and_;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct __alloc_traits_rebind {
            pub _address: u8,
        }
        pub type __alloc_traits_rebind_other = root::__gnu_cxx::__alloc_traits__Base_type;
    }
    pub type __int8_t = ::std::os::raw::c_schar;
    pub type __uint8_t = ::std::os::raw::c_uchar;
    pub type __int16_t = ::std::os::raw::c_short;
    pub type __uint16_t = ::std::os::raw::c_ushort;
    pub type __int32_t = ::std::os::raw::c_int;
    pub type __uint32_t = ::std::os::raw::c_uint;
    pub type __int64_t = ::std::os::raw::c_long;
    pub type __uint64_t = ::std::os::raw::c_ulong;
    pub mod mozilla {
        #[allow(unused_imports)]
        use self::super::super::root;
        pub use cssparser::UnicodeRange as StyleUnicodeRange;
        pub use cssparser::RGBA as StyleRGBA;
        pub use font_face::ComputedFontStretchRange as StyleComputedFontStretchRange;
        pub use font_face::ComputedFontStyleDescriptor as StyleComputedFontStyleDescriptor;
        pub use font_face::ComputedFontWeightRange as StyleComputedFontWeightRange;
        pub use font_face::FontDisplay as StyleFontDisplay;
        pub use font_face::FontFaceSourceListComponent as StyleFontFaceSourceListComponent;
        pub use gecko::media_features::DisplayMode as StyleDisplayMode;
        pub use gecko::media_features::PrefersColorScheme as StylePrefersColorScheme;
        pub use gecko_bindings::sugar::ownership::Owned as StyleOwned;
        pub use gecko_bindings::sugar::ownership::OwnedOrNull as StyleOwnedOrNull;
        pub use gecko_bindings::sugar::ownership::Strong as StyleStrong;
        pub use invalidation::element::restyle_hints::RestyleHint as StyleRestyleHint;
        pub use style_traits::arc_slice::ArcSlice as StyleArcSlice;
        pub use style_traits::arc_slice::ForgottenArcSlicePtr as StyleForgottenArcSlicePtr;
        pub use style_traits::owned_slice::OwnedSlice as StyleOwnedSlice;
        pub use style_traits::owned_str::OwnedStr as StyleOwnedStr;
        pub use stylesheets::Origin as StyleOrigin;
        pub use values::computed::easing::TimingFunction as StyleComputedTimingFunction;
        pub use values::computed::font::FontFamilyNameSyntax as StyleFontFamilyNameSyntax;
        pub use values::computed::font::FontLanguageOverride as StyleFontLanguageOverride;
        pub use values::computed::font::GenericFontFamily as StyleGenericFontFamily;
        pub use values::computed::length::CSSPixelLength as StyleCSSPixelLength;
        pub use values::computed::length::ExtremumLength as StyleExtremumLength;
        pub use values::computed::text::LetterSpacing as StyleLetterSpacing;
        pub use values::computed::ui::CursorKind as StyleCursorKind;
        pub use values::computed::Angle as StyleAngle;
        pub use values::computed::BackgroundSize as StyleBackgroundSize;
        pub use values::computed::BorderImageSlice as StyleBorderImageSlice;
        pub use values::computed::BorderStyle as StyleBorderStyle;
        pub use values::computed::BreakBetween as StyleBreakBetween;
        pub use values::computed::BreakWithin as StyleBreakWithin;
        pub use values::computed::CSSPixelLength as StyleLength;
        pub use values::computed::Contain as StyleContain;
        pub use values::computed::FlexBasis as StyleFlexBasis;
        pub use values::computed::Float as StyleFloat;
        pub use values::computed::LengthPercentage as StyleLengthPercentage;
        pub use values::computed::LengthPercentageOrAuto as StyleLengthPercentageOrAuto;
        pub use values::computed::MaxSize as StyleMaxSize;
        pub use values::computed::MozListReversed as StyleMozListReversed;
        pub use values::computed::NonNegativeLength as StyleNonNegativeLength;
        pub use values::computed::NonNegativeLengthPercentage as StyleNonNegativeLengthPercentage;
        pub use values::computed::NonNegativeLengthPercentageOrAuto as StyleNonNegativeLengthPercentageOrAuto;
        pub use values::computed::NonNegativeNumber as StyleNonNegativeNumber;
        pub use values::computed::OutlineStyle as StyleOutlineStyle;
        pub use values::computed::Overflow as StyleOverflow;
        pub use values::computed::OverflowAnchor as StyleOverflowAnchor;
        pub use values::computed::OverflowClipBox as StyleOverflowClipBox;
        pub use values::computed::OverflowWrap as StyleOverflowWrap;
        pub use values::computed::OverscrollBehavior as StyleOverscrollBehavior;
        pub use values::computed::Percentage as StylePercentage;
        pub use values::computed::Perspective as StylePerspective;
        pub use values::computed::Position as StylePosition;
        pub use values::computed::Resize as StyleResize;
        pub use values::computed::ScrollSnapAlign as StyleScrollSnapAlign;
        pub use values::computed::ScrollSnapStrictness as StyleScrollSnapStrictness;
        pub use values::computed::ScrollSnapType as StyleScrollSnapType;
        pub use values::computed::Size as StyleSize;
        pub use values::computed::TextAlign as StyleTextAlign;
        pub use values::computed::TextDecorationLine as StyleTextDecorationLine;
        pub use values::computed::TextTransform as StyleTextTransform;
        pub use values::computed::TouchAction as StyleTouchAction;
        pub use values::computed::TransformOrigin as StyleTransformOrigin;
        pub use values::computed::UserSelect as StyleUserSelect;
        pub use values::computed::WordBreak as StyleWordBreak;
        pub use values::computed::ZIndex as StyleZIndex;
        pub use values::generics::background::BackgroundSize as StyleGenericBackgroundSize;
        pub use values::generics::basic_shape::BasicShape as StyleGenericBasicShape;
        pub use values::generics::basic_shape::FillRule as StyleFillRule;
        pub use values::generics::border::BorderRadius as StyleGenericBorderRadius;
        pub use values::generics::box_::Perspective as StyleGenericPerspective;
        pub use values::generics::box_::VerticalAlign as StyleGenericVerticalAlign;
        pub use values::generics::box_::VerticalAlignKeyword as StyleVerticalAlignKeyword;
        pub use values::generics::color::Color as StyleGenericColor;
        pub use values::generics::color::ColorOrAuto as StyleGenericColorOrAuto;
        pub use values::generics::effects::BoxShadow as StyleGenericBoxShadow;
        pub use values::generics::effects::SimpleShadow as StyleGenericSimpleShadow;
        pub use values::generics::flex::FlexBasis as StyleGenericFlexBasis;
        pub use values::generics::image::GradientItem as StyleGenericGradientItem;
        pub use values::generics::length::LengthOrNumber as StyleGenericLengthOrNumber;
        pub use values::generics::length::LengthPercentageOrAuto as StyleGenericLengthPercentageOrAuto;
        pub use values::generics::length::LengthPercentageOrNormal as StyleGenericLengthPercentageOrNormal;
        pub use values::generics::length::MaxSize as StyleGenericMaxSize;
        pub use values::generics::length::Size as StyleGenericSize;
        pub use values::generics::position::ZIndex as StyleGenericZIndex;
        pub use values::generics::rect::Rect as StyleRect;
        pub use values::generics::text::LineHeight as StyleGenericLineHeight;
        pub use values::generics::transform::Rotate as StyleGenericRotate;
        pub use values::generics::transform::Scale as StyleGenericScale;
        pub use values::generics::transform::Transform as StyleGenericTransform;
        pub use values::generics::transform::TransformOperation as StyleGenericTransformOperation;
        pub use values::generics::transform::Translate as StyleGenericTranslate;
        pub use values::generics::ui::ScrollbarColor as StyleGenericScrollbarColor;
        pub use values::specified::box_::WillChange as StyleWillChange;
        pub use values::specified::color::SystemColor as StyleSystemColor;
        pub use values::specified::gecko::IntersectionObserverRootMargin as StyleIntersectionObserverRootMargin;
        pub use values::specified::list::Quotes as StyleQuotes;
        pub use values::specified::svg::MozContextProperties as StyleMozContextProperties;
        pub use values::specified::svg_path::PathCommand as StylePathCommand;
        pub use values::specified::Appearance as StyleAppearance;
        pub use values::specified::Display as StyleDisplay;
        pub mod detail {
            #[allow(unused_imports)]
            use self::super::super::super::root;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct VariantTag {
                pub _address: u8,
            }
            pub type VariantTag_Type = u8;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ThreadLocal {
                pub _address: u8,
            }
            pub type ThreadLocal_Type = u8;
            #[repr(C)]
            #[derive(Debug)]
            pub struct MutexImpl {
                pub platformData_: [*mut ::std::os::raw::c_void; 5usize],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct MutexImpl_PlatformData {
                _unused: [u8; 0],
            }
            #[test]
            fn bindgen_test_layout_MutexImpl() {
                assert_eq!(
                    ::std::mem::size_of::<MutexImpl>(),
                    40usize,
                    concat!("Size of: ", stringify!(MutexImpl))
                );
                assert_eq!(
                    ::std::mem::align_of::<MutexImpl>(),
                    8usize,
                    concat!("Alignment of ", stringify!(MutexImpl))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<MutexImpl>())).platformData_ as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(MutexImpl),
                        "::",
                        stringify!(platformData_)
                    )
                );
            }
            pub const StringDataFlags_TERMINATED: root::mozilla::detail::StringDataFlags = 1;
            pub const StringDataFlags_VOIDED: root::mozilla::detail::StringDataFlags = 2;
            pub const StringDataFlags_REFCOUNTED: root::mozilla::detail::StringDataFlags = 4;
            pub const StringDataFlags_OWNED: root::mozilla::detail::StringDataFlags = 8;
            pub const StringDataFlags_INLINE: root::mozilla::detail::StringDataFlags = 16;
            pub const StringDataFlags_LITERAL: root::mozilla::detail::StringDataFlags = 32;
            pub type StringDataFlags = u16;
            pub const StringClassFlags_INLINE: root::mozilla::detail::StringClassFlags = 1;
            pub const StringClassFlags_NULL_TERMINATED: root::mozilla::detail::StringClassFlags = 2;
            pub type StringClassFlags = u16;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct nsTStringRepr<T> {
                pub mData: *mut root::mozilla::detail::nsTStringRepr_char_type<T>,
                pub mLength: root::mozilla::detail::nsTStringRepr_size_type,
                pub mDataFlags: root::mozilla::detail::nsTStringRepr_DataFlags,
                pub mClassFlags: root::mozilla::detail::nsTStringRepr_ClassFlags,
                pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
            }
            pub type nsTStringRepr_fallible_t = root::mozilla::fallible_t;
            pub type nsTStringRepr_char_type<T> = T;
            pub type nsTStringRepr_self_type<T> = root::mozilla::detail::nsTStringRepr<T>;
            pub type nsTStringRepr_base_string_type<T> =
                root::mozilla::detail::nsTStringRepr_self_type<T>;
            pub type nsTStringRepr_substring_type<T> = root::nsTSubstring<T>;
            pub type nsTStringRepr_substring_tuple_type<T> = root::nsTSubstringTuple<T>;
            pub type nsTStringRepr_const_iterator<T> =
                root::nsReadingIterator<root::mozilla::detail::nsTStringRepr_char_type<T>>;
            pub type nsTStringRepr_iterator<T> =
                *mut root::mozilla::detail::nsTStringRepr_char_type<T>;
            pub type nsTStringRepr_comparator_type = root::nsTStringComparator;
            pub type nsTStringRepr_const_char_iterator<T> =
                *const root::mozilla::detail::nsTStringRepr_char_type<T>;
            pub type nsTStringRepr_index_type = u32;
            pub type nsTStringRepr_size_type = u32;
            pub use self::super::super::super::root::mozilla::detail::StringClassFlags as nsTStringRepr_ClassFlags;
            pub use self::super::super::super::root::mozilla::detail::StringDataFlags as nsTStringRepr_DataFlags;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct nsTStringRepr_raw_type {
                pub _address: u8,
            }
            pub type nsTStringRepr_raw_type_type<U> = *const U;
            #[repr(C)]
            #[repr(align(4))]
            pub struct GkAtoms {
                pub _bindgen_opaque_blob: [u32; 21757usize],
            }
            pub const GkAtoms_Atoms_SystemPrincipal: root::mozilla::detail::GkAtoms_Atoms = 0;
            pub const GkAtoms_Atoms__empty: root::mozilla::detail::GkAtoms_Atoms = 1;
            pub const GkAtoms_Atoms__0: root::mozilla::detail::GkAtoms_Atoms = 2;
            pub const GkAtoms_Atoms__1: root::mozilla::detail::GkAtoms_Atoms = 3;
            pub const GkAtoms_Atoms_moz: root::mozilla::detail::GkAtoms_Atoms = 4;
            pub const GkAtoms_Atoms_mozframetype: root::mozilla::detail::GkAtoms_Atoms = 5;
            pub const GkAtoms_Atoms__moz_abspos: root::mozilla::detail::GkAtoms_Atoms = 6;
            pub const GkAtoms_Atoms__moz_activated: root::mozilla::detail::GkAtoms_Atoms = 7;
            pub const GkAtoms_Atoms__moz_anonclass: root::mozilla::detail::GkAtoms_Atoms = 8;
            pub const GkAtoms_Atoms__moz_resizing: root::mozilla::detail::GkAtoms_Atoms = 9;
            pub const GkAtoms_Atoms_mozallowfullscreen: root::mozilla::detail::GkAtoms_Atoms = 10;
            pub const GkAtoms_Atoms_moztype: root::mozilla::detail::GkAtoms_Atoms = 11;
            pub const GkAtoms_Atoms_mozdirty: root::mozilla::detail::GkAtoms_Atoms = 12;
            pub const GkAtoms_Atoms_mozdisallowselectionprint:
                root::mozilla::detail::GkAtoms_Atoms = 13;
            pub const GkAtoms_Atoms_mozpersist: root::mozilla::detail::GkAtoms_Atoms = 14;
            pub const GkAtoms_Atoms_mozdonotsend: root::mozilla::detail::GkAtoms_Atoms = 15;
            pub const GkAtoms_Atoms_mozeditorbogusnode: root::mozilla::detail::GkAtoms_Atoms = 16;
            pub const GkAtoms_Atoms_mozgeneratedcontentbefore:
                root::mozilla::detail::GkAtoms_Atoms = 17;
            pub const GkAtoms_Atoms_mozgeneratedcontentafter: root::mozilla::detail::GkAtoms_Atoms =
                18;
            pub const GkAtoms_Atoms_mozgeneratedcontentmarker:
                root::mozilla::detail::GkAtoms_Atoms = 19;
            pub const GkAtoms_Atoms_mozgeneratedcontentimage: root::mozilla::detail::GkAtoms_Atoms =
                20;
            pub const GkAtoms_Atoms_mozquote: root::mozilla::detail::GkAtoms_Atoms = 21;
            pub const GkAtoms_Atoms_mozsignature: root::mozilla::detail::GkAtoms_Atoms = 22;
            pub const GkAtoms_Atoms__moz_is_glyph: root::mozilla::detail::GkAtoms_Atoms = 23;
            pub const GkAtoms_Atoms__moz_original_size: root::mozilla::detail::GkAtoms_Atoms = 24;
            pub const GkAtoms_Atoms_menuactive: root::mozilla::detail::GkAtoms_Atoms = 25;
            pub const GkAtoms_Atoms__poundDefault: root::mozilla::detail::GkAtoms_Atoms = 26;
            pub const GkAtoms_Atoms__asterisk: root::mozilla::detail::GkAtoms_Atoms = 27;
            pub const GkAtoms_Atoms_a: root::mozilla::detail::GkAtoms_Atoms = 28;
            pub const GkAtoms_Atoms_abbr: root::mozilla::detail::GkAtoms_Atoms = 29;
            pub const GkAtoms_Atoms_abort: root::mozilla::detail::GkAtoms_Atoms = 30;
            pub const GkAtoms_Atoms_above: root::mozilla::detail::GkAtoms_Atoms = 31;
            pub const GkAtoms_Atoms_acceltext: root::mozilla::detail::GkAtoms_Atoms = 32;
            pub const GkAtoms_Atoms_accept: root::mozilla::detail::GkAtoms_Atoms = 33;
            pub const GkAtoms_Atoms_acceptcharset: root::mozilla::detail::GkAtoms_Atoms = 34;
            pub const GkAtoms_Atoms_accessiblenode: root::mozilla::detail::GkAtoms_Atoms = 35;
            pub const GkAtoms_Atoms_accesskey: root::mozilla::detail::GkAtoms_Atoms = 36;
            pub const GkAtoms_Atoms_acronym: root::mozilla::detail::GkAtoms_Atoms = 37;
            pub const GkAtoms_Atoms_action: root::mozilla::detail::GkAtoms_Atoms = 38;
            pub const GkAtoms_Atoms_active: root::mozilla::detail::GkAtoms_Atoms = 39;
            pub const GkAtoms_Atoms_activateontab: root::mozilla::detail::GkAtoms_Atoms = 40;
            pub const GkAtoms_Atoms_actuate: root::mozilla::detail::GkAtoms_Atoms = 41;
            pub const GkAtoms_Atoms_address: root::mozilla::detail::GkAtoms_Atoms = 42;
            pub const GkAtoms_Atoms_after: root::mozilla::detail::GkAtoms_Atoms = 43;
            pub const GkAtoms_Atoms_align: root::mozilla::detail::GkAtoms_Atoms = 44;
            pub const GkAtoms_Atoms_alink: root::mozilla::detail::GkAtoms_Atoms = 45;
            pub const GkAtoms_Atoms_all: root::mozilla::detail::GkAtoms_Atoms = 46;
            pub const GkAtoms_Atoms_allow: root::mozilla::detail::GkAtoms_Atoms = 47;
            pub const GkAtoms_Atoms_allowdirs: root::mozilla::detail::GkAtoms_Atoms = 48;
            pub const GkAtoms_Atoms_allowevents: root::mozilla::detail::GkAtoms_Atoms = 49;
            pub const GkAtoms_Atoms_allowforms: root::mozilla::detail::GkAtoms_Atoms = 50;
            pub const GkAtoms_Atoms_allowfullscreen: root::mozilla::detail::GkAtoms_Atoms = 51;
            pub const GkAtoms_Atoms_allowmodals: root::mozilla::detail::GkAtoms_Atoms = 52;
            pub const GkAtoms_Atoms_alloworientationlock: root::mozilla::detail::GkAtoms_Atoms = 53;
            pub const GkAtoms_Atoms_allowpaymentrequest: root::mozilla::detail::GkAtoms_Atoms = 54;
            pub const GkAtoms_Atoms_allowpointerlock: root::mozilla::detail::GkAtoms_Atoms = 55;
            pub const GkAtoms_Atoms_allowpopupstoescapesandbox:
                root::mozilla::detail::GkAtoms_Atoms = 56;
            pub const GkAtoms_Atoms_allowpopups: root::mozilla::detail::GkAtoms_Atoms = 57;
            pub const GkAtoms_Atoms_allowpresentation: root::mozilla::detail::GkAtoms_Atoms = 58;
            pub const GkAtoms_Atoms_allowstorageaccessbyuseractivatetion:
                root::mozilla::detail::GkAtoms_Atoms = 59;
            pub const GkAtoms_Atoms_allowsameorigin: root::mozilla::detail::GkAtoms_Atoms = 60;
            pub const GkAtoms_Atoms_allowscripts: root::mozilla::detail::GkAtoms_Atoms = 61;
            pub const GkAtoms_Atoms_allowscriptstoclose: root::mozilla::detail::GkAtoms_Atoms = 62;
            pub const GkAtoms_Atoms_allowtopnavigation: root::mozilla::detail::GkAtoms_Atoms = 63;
            pub const GkAtoms_Atoms_allowuntrusted: root::mozilla::detail::GkAtoms_Atoms = 64;
            pub const GkAtoms_Atoms_alt: root::mozilla::detail::GkAtoms_Atoms = 65;
            pub const GkAtoms_Atoms_alternate: root::mozilla::detail::GkAtoms_Atoms = 66;
            pub const GkAtoms_Atoms_always: root::mozilla::detail::GkAtoms_Atoms = 67;
            pub const GkAtoms_Atoms_ancestor: root::mozilla::detail::GkAtoms_Atoms = 68;
            pub const GkAtoms_Atoms_ancestorOrSelf: root::mozilla::detail::GkAtoms_Atoms = 69;
            pub const GkAtoms_Atoms_anchor: root::mozilla::detail::GkAtoms_Atoms = 70;
            pub const GkAtoms_Atoms__and: root::mozilla::detail::GkAtoms_Atoms = 71;
            pub const GkAtoms_Atoms_animations: root::mozilla::detail::GkAtoms_Atoms = 72;
            pub const GkAtoms_Atoms_anonid: root::mozilla::detail::GkAtoms_Atoms = 73;
            pub const GkAtoms_Atoms_anonlocation: root::mozilla::detail::GkAtoms_Atoms = 74;
            pub const GkAtoms_Atoms_anonymousDiv: root::mozilla::detail::GkAtoms_Atoms = 75;
            pub const GkAtoms_Atoms_any: root::mozilla::detail::GkAtoms_Atoms = 76;
            pub const GkAtoms_Atoms_any_hover: root::mozilla::detail::GkAtoms_Atoms = 77;
            pub const GkAtoms_Atoms_any_pointer: root::mozilla::detail::GkAtoms_Atoms = 78;
            pub const GkAtoms_Atoms_applet: root::mozilla::detail::GkAtoms_Atoms = 79;
            pub const GkAtoms_Atoms_applyImports: root::mozilla::detail::GkAtoms_Atoms = 80;
            pub const GkAtoms_Atoms_applyTemplates: root::mozilla::detail::GkAtoms_Atoms = 81;
            pub const GkAtoms_Atoms_archive: root::mozilla::detail::GkAtoms_Atoms = 82;
            pub const GkAtoms_Atoms_area: root::mozilla::detail::GkAtoms_Atoms = 83;
            pub const GkAtoms_Atoms_aria_activedescendant: root::mozilla::detail::GkAtoms_Atoms =
                84;
            pub const GkAtoms_Atoms_aria_atomic: root::mozilla::detail::GkAtoms_Atoms = 85;
            pub const GkAtoms_Atoms_aria_autocomplete: root::mozilla::detail::GkAtoms_Atoms = 86;
            pub const GkAtoms_Atoms_aria_busy: root::mozilla::detail::GkAtoms_Atoms = 87;
            pub const GkAtoms_Atoms_aria_checked: root::mozilla::detail::GkAtoms_Atoms = 88;
            pub const GkAtoms_Atoms_aria_controls: root::mozilla::detail::GkAtoms_Atoms = 89;
            pub const GkAtoms_Atoms_aria_current: root::mozilla::detail::GkAtoms_Atoms = 90;
            pub const GkAtoms_Atoms_aria_describedby: root::mozilla::detail::GkAtoms_Atoms = 91;
            pub const GkAtoms_Atoms_aria_disabled: root::mozilla::detail::GkAtoms_Atoms = 92;
            pub const GkAtoms_Atoms_aria_dropeffect: root::mozilla::detail::GkAtoms_Atoms = 93;
            pub const GkAtoms_Atoms_aria_expanded: root::mozilla::detail::GkAtoms_Atoms = 94;
            pub const GkAtoms_Atoms_aria_flowto: root::mozilla::detail::GkAtoms_Atoms = 95;
            pub const GkAtoms_Atoms_aria_haspopup: root::mozilla::detail::GkAtoms_Atoms = 96;
            pub const GkAtoms_Atoms_aria_hidden: root::mozilla::detail::GkAtoms_Atoms = 97;
            pub const GkAtoms_Atoms_aria_invalid: root::mozilla::detail::GkAtoms_Atoms = 98;
            pub const GkAtoms_Atoms_aria_labelledby: root::mozilla::detail::GkAtoms_Atoms = 99;
            pub const GkAtoms_Atoms_aria_level: root::mozilla::detail::GkAtoms_Atoms = 100;
            pub const GkAtoms_Atoms_aria_live: root::mozilla::detail::GkAtoms_Atoms = 101;
            pub const GkAtoms_Atoms_aria_multiline: root::mozilla::detail::GkAtoms_Atoms = 102;
            pub const GkAtoms_Atoms_aria_multiselectable: root::mozilla::detail::GkAtoms_Atoms =
                103;
            pub const GkAtoms_Atoms_aria_owns: root::mozilla::detail::GkAtoms_Atoms = 104;
            pub const GkAtoms_Atoms_aria_posinset: root::mozilla::detail::GkAtoms_Atoms = 105;
            pub const GkAtoms_Atoms_aria_pressed: root::mozilla::detail::GkAtoms_Atoms = 106;
            pub const GkAtoms_Atoms_aria_readonly: root::mozilla::detail::GkAtoms_Atoms = 107;
            pub const GkAtoms_Atoms_aria_relevant: root::mozilla::detail::GkAtoms_Atoms = 108;
            pub const GkAtoms_Atoms_aria_required: root::mozilla::detail::GkAtoms_Atoms = 109;
            pub const GkAtoms_Atoms_aria_selected: root::mozilla::detail::GkAtoms_Atoms = 110;
            pub const GkAtoms_Atoms_aria_setsize: root::mozilla::detail::GkAtoms_Atoms = 111;
            pub const GkAtoms_Atoms_aria_sort: root::mozilla::detail::GkAtoms_Atoms = 112;
            pub const GkAtoms_Atoms_aria_valuemax: root::mozilla::detail::GkAtoms_Atoms = 113;
            pub const GkAtoms_Atoms_aria_valuemin: root::mozilla::detail::GkAtoms_Atoms = 114;
            pub const GkAtoms_Atoms_aria_valuenow: root::mozilla::detail::GkAtoms_Atoms = 115;
            pub const GkAtoms_Atoms_arrow: root::mozilla::detail::GkAtoms_Atoms = 116;
            pub const GkAtoms_Atoms_article: root::mozilla::detail::GkAtoms_Atoms = 117;
            pub const GkAtoms_Atoms_as_: root::mozilla::detail::GkAtoms_Atoms = 118;
            pub const GkAtoms_Atoms_ascending: root::mozilla::detail::GkAtoms_Atoms = 119;
            pub const GkAtoms_Atoms_aside: root::mozilla::detail::GkAtoms_Atoms = 120;
            pub const GkAtoms_Atoms_aspectRatio: root::mozilla::detail::GkAtoms_Atoms = 121;
            pub const GkAtoms_Atoms_async_: root::mozilla::detail::GkAtoms_Atoms = 122;
            pub const GkAtoms_Atoms_attribute: root::mozilla::detail::GkAtoms_Atoms = 123;
            pub const GkAtoms_Atoms_attributes: root::mozilla::detail::GkAtoms_Atoms = 124;
            pub const GkAtoms_Atoms_attributeSet: root::mozilla::detail::GkAtoms_Atoms = 125;
            pub const GkAtoms_Atoms__auto: root::mozilla::detail::GkAtoms_Atoms = 126;
            pub const GkAtoms_Atoms_autocheck: root::mozilla::detail::GkAtoms_Atoms = 127;
            pub const GkAtoms_Atoms_autocomplete: root::mozilla::detail::GkAtoms_Atoms = 128;
            pub const GkAtoms_Atoms_autocomplete_richlistbox: root::mozilla::detail::GkAtoms_Atoms =
                129;
            pub const GkAtoms_Atoms_autofocus: root::mozilla::detail::GkAtoms_Atoms = 130;
            pub const GkAtoms_Atoms_autoplay: root::mozilla::detail::GkAtoms_Atoms = 131;
            pub const GkAtoms_Atoms_axis: root::mozilla::detail::GkAtoms_Atoms = 132;
            pub const GkAtoms_Atoms_b: root::mozilla::detail::GkAtoms_Atoms = 133;
            pub const GkAtoms_Atoms_background: root::mozilla::detail::GkAtoms_Atoms = 134;
            pub const GkAtoms_Atoms_bar: root::mozilla::detail::GkAtoms_Atoms = 135;
            pub const GkAtoms_Atoms_base: root::mozilla::detail::GkAtoms_Atoms = 136;
            pub const GkAtoms_Atoms_basefont: root::mozilla::detail::GkAtoms_Atoms = 137;
            pub const GkAtoms_Atoms_baseline: root::mozilla::detail::GkAtoms_Atoms = 138;
            pub const GkAtoms_Atoms_bdi: root::mozilla::detail::GkAtoms_Atoms = 139;
            pub const GkAtoms_Atoms_bdo: root::mozilla::detail::GkAtoms_Atoms = 140;
            pub const GkAtoms_Atoms_before: root::mozilla::detail::GkAtoms_Atoms = 141;
            pub const GkAtoms_Atoms_behavior: root::mozilla::detail::GkAtoms_Atoms = 142;
            pub const GkAtoms_Atoms_below: root::mozilla::detail::GkAtoms_Atoms = 143;
            pub const GkAtoms_Atoms_bgcolor: root::mozilla::detail::GkAtoms_Atoms = 144;
            pub const GkAtoms_Atoms_bgsound: root::mozilla::detail::GkAtoms_Atoms = 145;
            pub const GkAtoms_Atoms_big: root::mozilla::detail::GkAtoms_Atoms = 146;
            pub const GkAtoms_Atoms_binding: root::mozilla::detail::GkAtoms_Atoms = 147;
            pub const GkAtoms_Atoms_bindings: root::mozilla::detail::GkAtoms_Atoms = 148;
            pub const GkAtoms_Atoms_bindToUntrustedContent: root::mozilla::detail::GkAtoms_Atoms =
                149;
            pub const GkAtoms_Atoms_black: root::mozilla::detail::GkAtoms_Atoms = 150;
            pub const GkAtoms_Atoms_block: root::mozilla::detail::GkAtoms_Atoms = 151;
            pub const GkAtoms_Atoms_blockquote: root::mozilla::detail::GkAtoms_Atoms = 152;
            pub const GkAtoms_Atoms_blur: root::mozilla::detail::GkAtoms_Atoms = 153;
            pub const GkAtoms_Atoms_body: root::mozilla::detail::GkAtoms_Atoms = 154;
            pub const GkAtoms_Atoms_boolean: root::mozilla::detail::GkAtoms_Atoms = 155;
            pub const GkAtoms_Atoms_border: root::mozilla::detail::GkAtoms_Atoms = 156;
            pub const GkAtoms_Atoms_bordercolor: root::mozilla::detail::GkAtoms_Atoms = 157;
            pub const GkAtoms_Atoms_both: root::mozilla::detail::GkAtoms_Atoms = 158;
            pub const GkAtoms_Atoms_bottom: root::mozilla::detail::GkAtoms_Atoms = 159;
            pub const GkAtoms_Atoms_bottomend: root::mozilla::detail::GkAtoms_Atoms = 160;
            pub const GkAtoms_Atoms_bottomstart: root::mozilla::detail::GkAtoms_Atoms = 161;
            pub const GkAtoms_Atoms_bottomleft: root::mozilla::detail::GkAtoms_Atoms = 162;
            pub const GkAtoms_Atoms_bottommargin: root::mozilla::detail::GkAtoms_Atoms = 163;
            pub const GkAtoms_Atoms_bottomright: root::mozilla::detail::GkAtoms_Atoms = 164;
            pub const GkAtoms_Atoms_box_: root::mozilla::detail::GkAtoms_Atoms = 165;
            pub const GkAtoms_Atoms_br: root::mozilla::detail::GkAtoms_Atoms = 166;
            pub const GkAtoms_Atoms_browser: root::mozilla::detail::GkAtoms_Atoms = 167;
            pub const GkAtoms_Atoms_mozbrowser: root::mozilla::detail::GkAtoms_Atoms = 168;
            pub const GkAtoms_Atoms_button: root::mozilla::detail::GkAtoms_Atoms = 169;
            pub const GkAtoms_Atoms_brighttitlebarforeground: root::mozilla::detail::GkAtoms_Atoms =
                170;
            pub const GkAtoms_Atoms_callTemplate: root::mozilla::detail::GkAtoms_Atoms = 171;
            pub const GkAtoms_Atoms_canvas: root::mozilla::detail::GkAtoms_Atoms = 172;
            pub const GkAtoms_Atoms_caption: root::mozilla::detail::GkAtoms_Atoms = 173;
            pub const GkAtoms_Atoms_captionBox: root::mozilla::detail::GkAtoms_Atoms = 174;
            pub const GkAtoms_Atoms_caseOrder: root::mozilla::detail::GkAtoms_Atoms = 175;
            pub const GkAtoms_Atoms_cdataSectionElements: root::mozilla::detail::GkAtoms_Atoms =
                176;
            pub const GkAtoms_Atoms_ceiling: root::mozilla::detail::GkAtoms_Atoms = 177;
            pub const GkAtoms_Atoms_cell: root::mozilla::detail::GkAtoms_Atoms = 178;
            pub const GkAtoms_Atoms_cellpadding: root::mozilla::detail::GkAtoms_Atoms = 179;
            pub const GkAtoms_Atoms_cellspacing: root::mozilla::detail::GkAtoms_Atoms = 180;
            pub const GkAtoms_Atoms_center: root::mozilla::detail::GkAtoms_Atoms = 181;
            pub const GkAtoms_Atoms_change: root::mozilla::detail::GkAtoms_Atoms = 182;
            pub const GkAtoms_Atoms__char: root::mozilla::detail::GkAtoms_Atoms = 183;
            pub const GkAtoms_Atoms_characterData: root::mozilla::detail::GkAtoms_Atoms = 184;
            pub const GkAtoms_Atoms_charcode: root::mozilla::detail::GkAtoms_Atoms = 185;
            pub const GkAtoms_Atoms_charoff: root::mozilla::detail::GkAtoms_Atoms = 186;
            pub const GkAtoms_Atoms_charset: root::mozilla::detail::GkAtoms_Atoms = 187;
            pub const GkAtoms_Atoms_checkbox: root::mozilla::detail::GkAtoms_Atoms = 188;
            pub const GkAtoms_Atoms_checkboxLabel: root::mozilla::detail::GkAtoms_Atoms = 189;
            pub const GkAtoms_Atoms_checked: root::mozilla::detail::GkAtoms_Atoms = 190;
            pub const GkAtoms_Atoms_child: root::mozilla::detail::GkAtoms_Atoms = 191;
            pub const GkAtoms_Atoms_children: root::mozilla::detail::GkAtoms_Atoms = 192;
            pub const GkAtoms_Atoms_childList: root::mozilla::detail::GkAtoms_Atoms = 193;
            pub const GkAtoms_Atoms_choose: root::mozilla::detail::GkAtoms_Atoms = 194;
            pub const GkAtoms_Atoms_chromemargin: root::mozilla::detail::GkAtoms_Atoms = 195;
            pub const GkAtoms_Atoms_exposeToUntrustedContent: root::mozilla::detail::GkAtoms_Atoms =
                196;
            pub const GkAtoms_Atoms_circ: root::mozilla::detail::GkAtoms_Atoms = 197;
            pub const GkAtoms_Atoms_circle: root::mozilla::detail::GkAtoms_Atoms = 198;
            pub const GkAtoms_Atoms_cite: root::mozilla::detail::GkAtoms_Atoms = 199;
            pub const GkAtoms_Atoms__class: root::mozilla::detail::GkAtoms_Atoms = 200;
            pub const GkAtoms_Atoms_classid: root::mozilla::detail::GkAtoms_Atoms = 201;
            pub const GkAtoms_Atoms_clear: root::mozilla::detail::GkAtoms_Atoms = 202;
            pub const GkAtoms_Atoms_click: root::mozilla::detail::GkAtoms_Atoms = 203;
            pub const GkAtoms_Atoms_clickcount: root::mozilla::detail::GkAtoms_Atoms = 204;
            pub const GkAtoms_Atoms_clickthrough: root::mozilla::detail::GkAtoms_Atoms = 205;
            pub const GkAtoms_Atoms_movetoclick: root::mozilla::detail::GkAtoms_Atoms = 206;
            pub const GkAtoms_Atoms_clip: root::mozilla::detail::GkAtoms_Atoms = 207;
            pub const GkAtoms_Atoms_close: root::mozilla::detail::GkAtoms_Atoms = 208;
            pub const GkAtoms_Atoms_closed: root::mozilla::detail::GkAtoms_Atoms = 209;
            pub const GkAtoms_Atoms_closemenu: root::mozilla::detail::GkAtoms_Atoms = 210;
            pub const GkAtoms_Atoms_code: root::mozilla::detail::GkAtoms_Atoms = 211;
            pub const GkAtoms_Atoms_codebase: root::mozilla::detail::GkAtoms_Atoms = 212;
            pub const GkAtoms_Atoms_codetype: root::mozilla::detail::GkAtoms_Atoms = 213;
            pub const GkAtoms_Atoms_col: root::mozilla::detail::GkAtoms_Atoms = 214;
            pub const GkAtoms_Atoms_colgroup: root::mozilla::detail::GkAtoms_Atoms = 215;
            pub const GkAtoms_Atoms_collapse: root::mozilla::detail::GkAtoms_Atoms = 216;
            pub const GkAtoms_Atoms_collapsed: root::mozilla::detail::GkAtoms_Atoms = 217;
            pub const GkAtoms_Atoms_color: root::mozilla::detail::GkAtoms_Atoms = 218;
            pub const GkAtoms_Atoms_colorIndex: root::mozilla::detail::GkAtoms_Atoms = 219;
            pub const GkAtoms_Atoms_cols: root::mozilla::detail::GkAtoms_Atoms = 220;
            pub const GkAtoms_Atoms_colspan: root::mozilla::detail::GkAtoms_Atoms = 221;
            pub const GkAtoms_Atoms_combobox: root::mozilla::detail::GkAtoms_Atoms = 222;
            pub const GkAtoms_Atoms_command: root::mozilla::detail::GkAtoms_Atoms = 223;
            pub const GkAtoms_Atoms_commandupdater: root::mozilla::detail::GkAtoms_Atoms = 224;
            pub const GkAtoms_Atoms_comment: root::mozilla::detail::GkAtoms_Atoms = 225;
            pub const GkAtoms_Atoms_compact: root::mozilla::detail::GkAtoms_Atoms = 226;
            pub const GkAtoms_Atoms_concat: root::mozilla::detail::GkAtoms_Atoms = 227;
            pub const GkAtoms_Atoms_constructor: root::mozilla::detail::GkAtoms_Atoms = 228;
            pub const GkAtoms_Atoms_consumeoutsideclicks: root::mozilla::detail::GkAtoms_Atoms =
                229;
            pub const GkAtoms_Atoms_container: root::mozilla::detail::GkAtoms_Atoms = 230;
            pub const GkAtoms_Atoms_contains: root::mozilla::detail::GkAtoms_Atoms = 231;
            pub const GkAtoms_Atoms_content: root::mozilla::detail::GkAtoms_Atoms = 232;
            pub const GkAtoms_Atoms_contenteditable: root::mozilla::detail::GkAtoms_Atoms = 233;
            pub const GkAtoms_Atoms_headerContentDisposition: root::mozilla::detail::GkAtoms_Atoms =
                234;
            pub const GkAtoms_Atoms_headerContentLanguage: root::mozilla::detail::GkAtoms_Atoms =
                235;
            pub const GkAtoms_Atoms_contentLocation: root::mozilla::detail::GkAtoms_Atoms = 236;
            pub const GkAtoms_Atoms_headerContentScriptType: root::mozilla::detail::GkAtoms_Atoms =
                237;
            pub const GkAtoms_Atoms_headerContentStyleType: root::mozilla::detail::GkAtoms_Atoms =
                238;
            pub const GkAtoms_Atoms_headerContentType: root::mozilla::detail::GkAtoms_Atoms = 239;
            pub const GkAtoms_Atoms_consumeanchor: root::mozilla::detail::GkAtoms_Atoms = 240;
            pub const GkAtoms_Atoms_context: root::mozilla::detail::GkAtoms_Atoms = 241;
            pub const GkAtoms_Atoms_contextmenu: root::mozilla::detail::GkAtoms_Atoms = 242;
            pub const GkAtoms_Atoms_control: root::mozilla::detail::GkAtoms_Atoms = 243;
            pub const GkAtoms_Atoms_controls: root::mozilla::detail::GkAtoms_Atoms = 244;
            pub const GkAtoms_Atoms_coords: root::mozilla::detail::GkAtoms_Atoms = 245;
            pub const GkAtoms_Atoms_copy: root::mozilla::detail::GkAtoms_Atoms = 246;
            pub const GkAtoms_Atoms_copyOf: root::mozilla::detail::GkAtoms_Atoms = 247;
            pub const GkAtoms_Atoms_count: root::mozilla::detail::GkAtoms_Atoms = 248;
            pub const GkAtoms_Atoms_crop: root::mozilla::detail::GkAtoms_Atoms = 249;
            pub const GkAtoms_Atoms_crossorigin: root::mozilla::detail::GkAtoms_Atoms = 250;
            pub const GkAtoms_Atoms_curpos: root::mozilla::detail::GkAtoms_Atoms = 251;
            pub const GkAtoms_Atoms_current: root::mozilla::detail::GkAtoms_Atoms = 252;
            pub const GkAtoms_Atoms_cutoutregion: root::mozilla::detail::GkAtoms_Atoms = 253;
            pub const GkAtoms_Atoms_cycler: root::mozilla::detail::GkAtoms_Atoms = 254;
            pub const GkAtoms_Atoms_dashed: root::mozilla::detail::GkAtoms_Atoms = 255;
            pub const GkAtoms_Atoms_data: root::mozilla::detail::GkAtoms_Atoms = 256;
            pub const GkAtoms_Atoms_datalist: root::mozilla::detail::GkAtoms_Atoms = 257;
            pub const GkAtoms_Atoms_datal10nid: root::mozilla::detail::GkAtoms_Atoms = 258;
            pub const GkAtoms_Atoms_datal10nargs: root::mozilla::detail::GkAtoms_Atoms = 259;
            pub const GkAtoms_Atoms_datal10nattrs: root::mozilla::detail::GkAtoms_Atoms = 260;
            pub const GkAtoms_Atoms_datal10nname: root::mozilla::detail::GkAtoms_Atoms = 261;
            pub const GkAtoms_Atoms_dataType: root::mozilla::detail::GkAtoms_Atoms = 262;
            pub const GkAtoms_Atoms_dateTime: root::mozilla::detail::GkAtoms_Atoms = 263;
            pub const GkAtoms_Atoms_date: root::mozilla::detail::GkAtoms_Atoms = 264;
            pub const GkAtoms_Atoms_datetime: root::mozilla::detail::GkAtoms_Atoms = 265;
            pub const GkAtoms_Atoms_dd: root::mozilla::detail::GkAtoms_Atoms = 266;
            pub const GkAtoms_Atoms_decimal: root::mozilla::detail::GkAtoms_Atoms = 267;
            pub const GkAtoms_Atoms_decimalFormat: root::mozilla::detail::GkAtoms_Atoms = 268;
            pub const GkAtoms_Atoms_decimalSeparator: root::mozilla::detail::GkAtoms_Atoms = 269;
            pub const GkAtoms_Atoms_declare: root::mozilla::detail::GkAtoms_Atoms = 270;
            pub const GkAtoms_Atoms_decoderDoctor: root::mozilla::detail::GkAtoms_Atoms = 271;
            pub const GkAtoms_Atoms_decoding: root::mozilla::detail::GkAtoms_Atoms = 272;
            pub const GkAtoms_Atoms_decrement: root::mozilla::detail::GkAtoms_Atoms = 273;
            pub const GkAtoms_Atoms__default: root::mozilla::detail::GkAtoms_Atoms = 274;
            pub const GkAtoms_Atoms_headerDefaultStyle: root::mozilla::detail::GkAtoms_Atoms = 275;
            pub const GkAtoms_Atoms_defer: root::mozilla::detail::GkAtoms_Atoms = 276;
            pub const GkAtoms_Atoms_del: root::mozilla::detail::GkAtoms_Atoms = 277;
            pub const GkAtoms_Atoms_deprecation: root::mozilla::detail::GkAtoms_Atoms = 278;
            pub const GkAtoms_Atoms_descendant: root::mozilla::detail::GkAtoms_Atoms = 279;
            pub const GkAtoms_Atoms_descendantOrSelf: root::mozilla::detail::GkAtoms_Atoms = 280;
            pub const GkAtoms_Atoms_descending: root::mozilla::detail::GkAtoms_Atoms = 281;
            pub const GkAtoms_Atoms_description: root::mozilla::detail::GkAtoms_Atoms = 282;
            pub const GkAtoms_Atoms_destructor: root::mozilla::detail::GkAtoms_Atoms = 283;
            pub const GkAtoms_Atoms_details: root::mozilla::detail::GkAtoms_Atoms = 284;
            pub const GkAtoms_Atoms_deviceAspectRatio: root::mozilla::detail::GkAtoms_Atoms = 285;
            pub const GkAtoms_Atoms_deviceHeight: root::mozilla::detail::GkAtoms_Atoms = 286;
            pub const GkAtoms_Atoms_devicePixelRatio: root::mozilla::detail::GkAtoms_Atoms = 287;
            pub const GkAtoms_Atoms_deviceWidth: root::mozilla::detail::GkAtoms_Atoms = 288;
            pub const GkAtoms_Atoms_dfn: root::mozilla::detail::GkAtoms_Atoms = 289;
            pub const GkAtoms_Atoms_dialog: root::mozilla::detail::GkAtoms_Atoms = 290;
            pub const GkAtoms_Atoms_difference: root::mozilla::detail::GkAtoms_Atoms = 291;
            pub const GkAtoms_Atoms_digit: root::mozilla::detail::GkAtoms_Atoms = 292;
            pub const GkAtoms_Atoms_dir: root::mozilla::detail::GkAtoms_Atoms = 293;
            pub const GkAtoms_Atoms_dirAutoSetBy: root::mozilla::detail::GkAtoms_Atoms = 294;
            pub const GkAtoms_Atoms_directory: root::mozilla::detail::GkAtoms_Atoms = 295;
            pub const GkAtoms_Atoms_disableOutputEscaping: root::mozilla::detail::GkAtoms_Atoms =
                296;
            pub const GkAtoms_Atoms_disabled: root::mozilla::detail::GkAtoms_Atoms = 297;
            pub const GkAtoms_Atoms_disableglobalhistory: root::mozilla::detail::GkAtoms_Atoms =
                298;
            pub const GkAtoms_Atoms_disablehistory: root::mozilla::detail::GkAtoms_Atoms = 299;
            pub const GkAtoms_Atoms_disablefullscreen: root::mozilla::detail::GkAtoms_Atoms = 300;
            pub const GkAtoms_Atoms_disclosure_closed: root::mozilla::detail::GkAtoms_Atoms = 301;
            pub const GkAtoms_Atoms_disclosure_open: root::mozilla::detail::GkAtoms_Atoms = 302;
            pub const GkAtoms_Atoms_display: root::mozilla::detail::GkAtoms_Atoms = 303;
            pub const GkAtoms_Atoms_displayMode: root::mozilla::detail::GkAtoms_Atoms = 304;
            pub const GkAtoms_Atoms_distinct: root::mozilla::detail::GkAtoms_Atoms = 305;
            pub const GkAtoms_Atoms_div: root::mozilla::detail::GkAtoms_Atoms = 306;
            pub const GkAtoms_Atoms_dl: root::mozilla::detail::GkAtoms_Atoms = 307;
            pub const GkAtoms_Atoms_docAbstract: root::mozilla::detail::GkAtoms_Atoms = 308;
            pub const GkAtoms_Atoms_docAcknowledgments: root::mozilla::detail::GkAtoms_Atoms = 309;
            pub const GkAtoms_Atoms_docAfterword: root::mozilla::detail::GkAtoms_Atoms = 310;
            pub const GkAtoms_Atoms_docAppendix: root::mozilla::detail::GkAtoms_Atoms = 311;
            pub const GkAtoms_Atoms_docBacklink: root::mozilla::detail::GkAtoms_Atoms = 312;
            pub const GkAtoms_Atoms_docBiblioentry: root::mozilla::detail::GkAtoms_Atoms = 313;
            pub const GkAtoms_Atoms_docBibliography: root::mozilla::detail::GkAtoms_Atoms = 314;
            pub const GkAtoms_Atoms_docBiblioref: root::mozilla::detail::GkAtoms_Atoms = 315;
            pub const GkAtoms_Atoms_docChapter: root::mozilla::detail::GkAtoms_Atoms = 316;
            pub const GkAtoms_Atoms_docColophon: root::mozilla::detail::GkAtoms_Atoms = 317;
            pub const GkAtoms_Atoms_docConclusion: root::mozilla::detail::GkAtoms_Atoms = 318;
            pub const GkAtoms_Atoms_docCover: root::mozilla::detail::GkAtoms_Atoms = 319;
            pub const GkAtoms_Atoms_docCredit: root::mozilla::detail::GkAtoms_Atoms = 320;
            pub const GkAtoms_Atoms_docCredits: root::mozilla::detail::GkAtoms_Atoms = 321;
            pub const GkAtoms_Atoms_docDedication: root::mozilla::detail::GkAtoms_Atoms = 322;
            pub const GkAtoms_Atoms_docEndnote: root::mozilla::detail::GkAtoms_Atoms = 323;
            pub const GkAtoms_Atoms_docEndnotes: root::mozilla::detail::GkAtoms_Atoms = 324;
            pub const GkAtoms_Atoms_docEpigraph: root::mozilla::detail::GkAtoms_Atoms = 325;
            pub const GkAtoms_Atoms_docEpilogue: root::mozilla::detail::GkAtoms_Atoms = 326;
            pub const GkAtoms_Atoms_docErrata: root::mozilla::detail::GkAtoms_Atoms = 327;
            pub const GkAtoms_Atoms_docExample: root::mozilla::detail::GkAtoms_Atoms = 328;
            pub const GkAtoms_Atoms_docFootnote: root::mozilla::detail::GkAtoms_Atoms = 329;
            pub const GkAtoms_Atoms_docForeword: root::mozilla::detail::GkAtoms_Atoms = 330;
            pub const GkAtoms_Atoms_docGlossary: root::mozilla::detail::GkAtoms_Atoms = 331;
            pub const GkAtoms_Atoms_docGlossref: root::mozilla::detail::GkAtoms_Atoms = 332;
            pub const GkAtoms_Atoms_docIndex: root::mozilla::detail::GkAtoms_Atoms = 333;
            pub const GkAtoms_Atoms_docIntroduction: root::mozilla::detail::GkAtoms_Atoms = 334;
            pub const GkAtoms_Atoms_docNoteref: root::mozilla::detail::GkAtoms_Atoms = 335;
            pub const GkAtoms_Atoms_docNotice: root::mozilla::detail::GkAtoms_Atoms = 336;
            pub const GkAtoms_Atoms_docPagebreak: root::mozilla::detail::GkAtoms_Atoms = 337;
            pub const GkAtoms_Atoms_docPagelist: root::mozilla::detail::GkAtoms_Atoms = 338;
            pub const GkAtoms_Atoms_docPart: root::mozilla::detail::GkAtoms_Atoms = 339;
            pub const GkAtoms_Atoms_docPreface: root::mozilla::detail::GkAtoms_Atoms = 340;
            pub const GkAtoms_Atoms_docPrologue: root::mozilla::detail::GkAtoms_Atoms = 341;
            pub const GkAtoms_Atoms_docPullquote: root::mozilla::detail::GkAtoms_Atoms = 342;
            pub const GkAtoms_Atoms_docQna: root::mozilla::detail::GkAtoms_Atoms = 343;
            pub const GkAtoms_Atoms_docSubtitle: root::mozilla::detail::GkAtoms_Atoms = 344;
            pub const GkAtoms_Atoms_docTip: root::mozilla::detail::GkAtoms_Atoms = 345;
            pub const GkAtoms_Atoms_docToc: root::mozilla::detail::GkAtoms_Atoms = 346;
            pub const GkAtoms_Atoms_doctypePublic: root::mozilla::detail::GkAtoms_Atoms = 347;
            pub const GkAtoms_Atoms_doctypeSystem: root::mozilla::detail::GkAtoms_Atoms = 348;
            pub const GkAtoms_Atoms_document: root::mozilla::detail::GkAtoms_Atoms = 349;
            pub const GkAtoms_Atoms_down: root::mozilla::detail::GkAtoms_Atoms = 350;
            pub const GkAtoms_Atoms_download: root::mozilla::detail::GkAtoms_Atoms = 351;
            pub const GkAtoms_Atoms_drag: root::mozilla::detail::GkAtoms_Atoms = 352;
            pub const GkAtoms_Atoms_draggable: root::mozilla::detail::GkAtoms_Atoms = 353;
            pub const GkAtoms_Atoms_dragging: root::mozilla::detail::GkAtoms_Atoms = 354;
            pub const GkAtoms_Atoms_dragSession: root::mozilla::detail::GkAtoms_Atoms = 355;
            pub const GkAtoms_Atoms_drawintitlebar: root::mozilla::detail::GkAtoms_Atoms = 356;
            pub const GkAtoms_Atoms_drawtitle: root::mozilla::detail::GkAtoms_Atoms = 357;
            pub const GkAtoms_Atoms_dropAfter: root::mozilla::detail::GkAtoms_Atoms = 358;
            pub const GkAtoms_Atoms_dropBefore: root::mozilla::detail::GkAtoms_Atoms = 359;
            pub const GkAtoms_Atoms_dropOn: root::mozilla::detail::GkAtoms_Atoms = 360;
            pub const GkAtoms_Atoms_dropMarker: root::mozilla::detail::GkAtoms_Atoms = 361;
            pub const GkAtoms_Atoms_dt: root::mozilla::detail::GkAtoms_Atoms = 362;
            pub const GkAtoms_Atoms_e: root::mozilla::detail::GkAtoms_Atoms = 363;
            pub const GkAtoms_Atoms_editable: root::mozilla::detail::GkAtoms_Atoms = 364;
            pub const GkAtoms_Atoms_editing: root::mozilla::detail::GkAtoms_Atoms = 365;
            pub const GkAtoms_Atoms_editor: root::mozilla::detail::GkAtoms_Atoms = 366;
            pub const GkAtoms_Atoms_element: root::mozilla::detail::GkAtoms_Atoms = 367;
            pub const GkAtoms_Atoms_elementAvailable: root::mozilla::detail::GkAtoms_Atoms = 368;
            pub const GkAtoms_Atoms_elements: root::mozilla::detail::GkAtoms_Atoms = 369;
            pub const GkAtoms_Atoms_em: root::mozilla::detail::GkAtoms_Atoms = 370;
            pub const GkAtoms_Atoms_embed: root::mozilla::detail::GkAtoms_Atoms = 371;
            pub const GkAtoms_Atoms_empty: root::mozilla::detail::GkAtoms_Atoms = 372;
            pub const GkAtoms_Atoms_encoding: root::mozilla::detail::GkAtoms_Atoms = 373;
            pub const GkAtoms_Atoms_enctype: root::mozilla::detail::GkAtoms_Atoms = 374;
            pub const GkAtoms_Atoms_end: root::mozilla::detail::GkAtoms_Atoms = 375;
            pub const GkAtoms_Atoms_endEvent: root::mozilla::detail::GkAtoms_Atoms = 376;
            pub const GkAtoms_Atoms_equalsize: root::mozilla::detail::GkAtoms_Atoms = 377;
            pub const GkAtoms_Atoms_error: root::mozilla::detail::GkAtoms_Atoms = 378;
            pub const GkAtoms_Atoms_ethiopic_numeric: root::mozilla::detail::GkAtoms_Atoms = 379;
            pub const GkAtoms_Atoms_even: root::mozilla::detail::GkAtoms_Atoms = 380;
            pub const GkAtoms_Atoms_event: root::mozilla::detail::GkAtoms_Atoms = 381;
            pub const GkAtoms_Atoms_events: root::mozilla::detail::GkAtoms_Atoms = 382;
            pub const GkAtoms_Atoms_excludeResultPrefixes: root::mozilla::detail::GkAtoms_Atoms =
                383;
            pub const GkAtoms_Atoms_extends: root::mozilla::detail::GkAtoms_Atoms = 384;
            pub const GkAtoms_Atoms_extensionElementPrefixes: root::mozilla::detail::GkAtoms_Atoms =
                385;
            pub const GkAtoms_Atoms_face: root::mozilla::detail::GkAtoms_Atoms = 386;
            pub const GkAtoms_Atoms_fallback: root::mozilla::detail::GkAtoms_Atoms = 387;
            pub const GkAtoms_Atoms__false: root::mozilla::detail::GkAtoms_Atoms = 388;
            pub const GkAtoms_Atoms_farthest: root::mozilla::detail::GkAtoms_Atoms = 389;
            pub const GkAtoms_Atoms_featurePolicyViolation: root::mozilla::detail::GkAtoms_Atoms =
                390;
            pub const GkAtoms_Atoms_field: root::mozilla::detail::GkAtoms_Atoms = 391;
            pub const GkAtoms_Atoms_fieldset: root::mozilla::detail::GkAtoms_Atoms = 392;
            pub const GkAtoms_Atoms_file: root::mozilla::detail::GkAtoms_Atoms = 393;
            pub const GkAtoms_Atoms_figcaption: root::mozilla::detail::GkAtoms_Atoms = 394;
            pub const GkAtoms_Atoms_figure: root::mozilla::detail::GkAtoms_Atoms = 395;
            pub const GkAtoms_Atoms_findbar: root::mozilla::detail::GkAtoms_Atoms = 396;
            pub const GkAtoms_Atoms_fixed: root::mozilla::detail::GkAtoms_Atoms = 397;
            pub const GkAtoms_Atoms_fission: root::mozilla::detail::GkAtoms_Atoms = 398;
            pub const GkAtoms_Atoms_flags: root::mozilla::detail::GkAtoms_Atoms = 399;
            pub const GkAtoms_Atoms_flex: root::mozilla::detail::GkAtoms_Atoms = 400;
            pub const GkAtoms_Atoms_flip: root::mozilla::detail::GkAtoms_Atoms = 401;
            pub const GkAtoms_Atoms_floating: root::mozilla::detail::GkAtoms_Atoms = 402;
            pub const GkAtoms_Atoms_floor: root::mozilla::detail::GkAtoms_Atoms = 403;
            pub const GkAtoms_Atoms_flowlength: root::mozilla::detail::GkAtoms_Atoms = 404;
            pub const GkAtoms_Atoms_focus: root::mozilla::detail::GkAtoms_Atoms = 405;
            pub const GkAtoms_Atoms_focused: root::mozilla::detail::GkAtoms_Atoms = 406;
            pub const GkAtoms_Atoms_followanchor: root::mozilla::detail::GkAtoms_Atoms = 407;
            pub const GkAtoms_Atoms_following: root::mozilla::detail::GkAtoms_Atoms = 408;
            pub const GkAtoms_Atoms_followingSibling: root::mozilla::detail::GkAtoms_Atoms = 409;
            pub const GkAtoms_Atoms_font: root::mozilla::detail::GkAtoms_Atoms = 410;
            pub const GkAtoms_Atoms_fontWeight: root::mozilla::detail::GkAtoms_Atoms = 411;
            pub const GkAtoms_Atoms_footer: root::mozilla::detail::GkAtoms_Atoms = 412;
            pub const GkAtoms_Atoms__for: root::mozilla::detail::GkAtoms_Atoms = 413;
            pub const GkAtoms_Atoms_forEach: root::mozilla::detail::GkAtoms_Atoms = 414;
            pub const GkAtoms_Atoms_forceOwnRefreshDriver: root::mozilla::detail::GkAtoms_Atoms =
                415;
            pub const GkAtoms_Atoms_form: root::mozilla::detail::GkAtoms_Atoms = 416;
            pub const GkAtoms_Atoms_formaction: root::mozilla::detail::GkAtoms_Atoms = 417;
            pub const GkAtoms_Atoms_format: root::mozilla::detail::GkAtoms_Atoms = 418;
            pub const GkAtoms_Atoms_formatNumber: root::mozilla::detail::GkAtoms_Atoms = 419;
            pub const GkAtoms_Atoms_formenctype: root::mozilla::detail::GkAtoms_Atoms = 420;
            pub const GkAtoms_Atoms_formmethod: root::mozilla::detail::GkAtoms_Atoms = 421;
            pub const GkAtoms_Atoms_formnovalidate: root::mozilla::detail::GkAtoms_Atoms = 422;
            pub const GkAtoms_Atoms_formtarget: root::mozilla::detail::GkAtoms_Atoms = 423;
            pub const GkAtoms_Atoms_frame: root::mozilla::detail::GkAtoms_Atoms = 424;
            pub const GkAtoms_Atoms_frameborder: root::mozilla::detail::GkAtoms_Atoms = 425;
            pub const GkAtoms_Atoms_frameset: root::mozilla::detail::GkAtoms_Atoms = 426;
            pub const GkAtoms_Atoms_from: root::mozilla::detail::GkAtoms_Atoms = 427;
            pub const GkAtoms_Atoms_fullscreenchange: root::mozilla::detail::GkAtoms_Atoms = 428;
            pub const GkAtoms_Atoms_fullscreenerror: root::mozilla::detail::GkAtoms_Atoms = 429;
            pub const GkAtoms_Atoms_functionAvailable: root::mozilla::detail::GkAtoms_Atoms = 430;
            pub const GkAtoms_Atoms_generateId: root::mozilla::detail::GkAtoms_Atoms = 431;
            pub const GkAtoms_Atoms_getter: root::mozilla::detail::GkAtoms_Atoms = 432;
            pub const GkAtoms_Atoms_graphicsDocument: root::mozilla::detail::GkAtoms_Atoms = 433;
            pub const GkAtoms_Atoms_graphicsObject: root::mozilla::detail::GkAtoms_Atoms = 434;
            pub const GkAtoms_Atoms_graphicsSymbol: root::mozilla::detail::GkAtoms_Atoms = 435;
            pub const GkAtoms_Atoms_grid: root::mozilla::detail::GkAtoms_Atoms = 436;
            pub const GkAtoms_Atoms_group: root::mozilla::detail::GkAtoms_Atoms = 437;
            pub const GkAtoms_Atoms_groups: root::mozilla::detail::GkAtoms_Atoms = 438;
            pub const GkAtoms_Atoms_groupbox: root::mozilla::detail::GkAtoms_Atoms = 439;
            pub const GkAtoms_Atoms_groupingSeparator: root::mozilla::detail::GkAtoms_Atoms = 440;
            pub const GkAtoms_Atoms_groupingSize: root::mozilla::detail::GkAtoms_Atoms = 441;
            pub const GkAtoms_Atoms_grow: root::mozilla::detail::GkAtoms_Atoms = 442;
            pub const GkAtoms_Atoms_h1: root::mozilla::detail::GkAtoms_Atoms = 443;
            pub const GkAtoms_Atoms_h2: root::mozilla::detail::GkAtoms_Atoms = 444;
            pub const GkAtoms_Atoms_h3: root::mozilla::detail::GkAtoms_Atoms = 445;
            pub const GkAtoms_Atoms_h4: root::mozilla::detail::GkAtoms_Atoms = 446;
            pub const GkAtoms_Atoms_h5: root::mozilla::detail::GkAtoms_Atoms = 447;
            pub const GkAtoms_Atoms_h6: root::mozilla::detail::GkAtoms_Atoms = 448;
            pub const GkAtoms_Atoms_handheldFriendly: root::mozilla::detail::GkAtoms_Atoms = 449;
            pub const GkAtoms_Atoms_handler: root::mozilla::detail::GkAtoms_Atoms = 450;
            pub const GkAtoms_Atoms_handlers: root::mozilla::detail::GkAtoms_Atoms = 451;
            pub const GkAtoms_Atoms_HARD: root::mozilla::detail::GkAtoms_Atoms = 452;
            pub const GkAtoms_Atoms_hasSameNode: root::mozilla::detail::GkAtoms_Atoms = 453;
            pub const GkAtoms_Atoms_hbox: root::mozilla::detail::GkAtoms_Atoms = 454;
            pub const GkAtoms_Atoms_head: root::mozilla::detail::GkAtoms_Atoms = 455;
            pub const GkAtoms_Atoms_header: root::mozilla::detail::GkAtoms_Atoms = 456;
            pub const GkAtoms_Atoms_headers: root::mozilla::detail::GkAtoms_Atoms = 457;
            pub const GkAtoms_Atoms_hebrew: root::mozilla::detail::GkAtoms_Atoms = 458;
            pub const GkAtoms_Atoms_height: root::mozilla::detail::GkAtoms_Atoms = 459;
            pub const GkAtoms_Atoms_hgroup: root::mozilla::detail::GkAtoms_Atoms = 460;
            pub const GkAtoms_Atoms_hidden: root::mozilla::detail::GkAtoms_Atoms = 461;
            pub const GkAtoms_Atoms_hidechrome: root::mozilla::detail::GkAtoms_Atoms = 462;
            pub const GkAtoms_Atoms_hidecolumnpicker: root::mozilla::detail::GkAtoms_Atoms = 463;
            pub const GkAtoms_Atoms_high: root::mozilla::detail::GkAtoms_Atoms = 464;
            pub const GkAtoms_Atoms_highest: root::mozilla::detail::GkAtoms_Atoms = 465;
            pub const GkAtoms_Atoms_horizontal: root::mozilla::detail::GkAtoms_Atoms = 466;
            pub const GkAtoms_Atoms_hover: root::mozilla::detail::GkAtoms_Atoms = 467;
            pub const GkAtoms_Atoms_hr: root::mozilla::detail::GkAtoms_Atoms = 468;
            pub const GkAtoms_Atoms_href: root::mozilla::detail::GkAtoms_Atoms = 469;
            pub const GkAtoms_Atoms_hreflang: root::mozilla::detail::GkAtoms_Atoms = 470;
            pub const GkAtoms_Atoms_hsides: root::mozilla::detail::GkAtoms_Atoms = 471;
            pub const GkAtoms_Atoms_hspace: root::mozilla::detail::GkAtoms_Atoms = 472;
            pub const GkAtoms_Atoms_html: root::mozilla::detail::GkAtoms_Atoms = 473;
            pub const GkAtoms_Atoms_httpEquiv: root::mozilla::detail::GkAtoms_Atoms = 474;
            pub const GkAtoms_Atoms_i: root::mozilla::detail::GkAtoms_Atoms = 475;
            pub const GkAtoms_Atoms_icon: root::mozilla::detail::GkAtoms_Atoms = 476;
            pub const GkAtoms_Atoms_id: root::mozilla::detail::GkAtoms_Atoms = 477;
            pub const GkAtoms_Atoms__if: root::mozilla::detail::GkAtoms_Atoms = 478;
            pub const GkAtoms_Atoms_iframe: root::mozilla::detail::GkAtoms_Atoms = 479;
            pub const GkAtoms_Atoms_ignorekeys: root::mozilla::detail::GkAtoms_Atoms = 480;
            pub const GkAtoms_Atoms_ignoreuserfocus: root::mozilla::detail::GkAtoms_Atoms = 481;
            pub const GkAtoms_Atoms_image: root::mozilla::detail::GkAtoms_Atoms = 482;
            pub const GkAtoms_Atoms_imageClickedPoint: root::mozilla::detail::GkAtoms_Atoms = 483;
            pub const GkAtoms_Atoms_img: root::mozilla::detail::GkAtoms_Atoms = 484;
            pub const GkAtoms_Atoms_implementation: root::mozilla::detail::GkAtoms_Atoms = 485;
            pub const GkAtoms_Atoms_implements: root::mozilla::detail::GkAtoms_Atoms = 486;
            pub const GkAtoms_Atoms_import: root::mozilla::detail::GkAtoms_Atoms = 487;
            pub const GkAtoms_Atoms_include: root::mozilla::detail::GkAtoms_Atoms = 488;
            pub const GkAtoms_Atoms_includes: root::mozilla::detail::GkAtoms_Atoms = 489;
            pub const GkAtoms_Atoms_incontentshell: root::mozilla::detail::GkAtoms_Atoms = 490;
            pub const GkAtoms_Atoms_increment: root::mozilla::detail::GkAtoms_Atoms = 491;
            pub const GkAtoms_Atoms_indent: root::mozilla::detail::GkAtoms_Atoms = 492;
            pub const GkAtoms_Atoms_indeterminate: root::mozilla::detail::GkAtoms_Atoms = 493;
            pub const GkAtoms_Atoms_index: root::mozilla::detail::GkAtoms_Atoms = 494;
            pub const GkAtoms_Atoms_infinity: root::mozilla::detail::GkAtoms_Atoms = 495;
            pub const GkAtoms_Atoms_inherits: root::mozilla::detail::GkAtoms_Atoms = 496;
            pub const GkAtoms_Atoms_inheritOverflow: root::mozilla::detail::GkAtoms_Atoms = 497;
            pub const GkAtoms_Atoms_inheritstyle: root::mozilla::detail::GkAtoms_Atoms = 498;
            pub const GkAtoms_Atoms_initial_scale: root::mozilla::detail::GkAtoms_Atoms = 499;
            pub const GkAtoms_Atoms_input: root::mozilla::detail::GkAtoms_Atoms = 500;
            pub const GkAtoms_Atoms_inputmode: root::mozilla::detail::GkAtoms_Atoms = 501;
            pub const GkAtoms_Atoms_ins: root::mozilla::detail::GkAtoms_Atoms = 502;
            pub const GkAtoms_Atoms_insertafter: root::mozilla::detail::GkAtoms_Atoms = 503;
            pub const GkAtoms_Atoms_insertbefore: root::mozilla::detail::GkAtoms_Atoms = 504;
            pub const GkAtoms_Atoms_integer: root::mozilla::detail::GkAtoms_Atoms = 505;
            pub const GkAtoms_Atoms_integrity: root::mozilla::detail::GkAtoms_Atoms = 506;
            pub const GkAtoms_Atoms_intersection: root::mozilla::detail::GkAtoms_Atoms = 507;
            pub const GkAtoms_Atoms_intersectionobserverlist: root::mozilla::detail::GkAtoms_Atoms =
                508;
            pub const GkAtoms_Atoms_is: root::mozilla::detail::GkAtoms_Atoms = 509;
            pub const GkAtoms_Atoms_ismap: root::mozilla::detail::GkAtoms_Atoms = 510;
            pub const GkAtoms_Atoms_itemid: root::mozilla::detail::GkAtoms_Atoms = 511;
            pub const GkAtoms_Atoms_itemprop: root::mozilla::detail::GkAtoms_Atoms = 512;
            pub const GkAtoms_Atoms_itemref: root::mozilla::detail::GkAtoms_Atoms = 513;
            pub const GkAtoms_Atoms_itemscope: root::mozilla::detail::GkAtoms_Atoms = 514;
            pub const GkAtoms_Atoms_itemtype: root::mozilla::detail::GkAtoms_Atoms = 515;
            pub const GkAtoms_Atoms_japanese_formal: root::mozilla::detail::GkAtoms_Atoms = 516;
            pub const GkAtoms_Atoms_japanese_informal: root::mozilla::detail::GkAtoms_Atoms = 517;
            pub const GkAtoms_Atoms_kbd: root::mozilla::detail::GkAtoms_Atoms = 518;
            pub const GkAtoms_Atoms_keepcurrentinview: root::mozilla::detail::GkAtoms_Atoms = 519;
            pub const GkAtoms_Atoms_keepobjectsalive: root::mozilla::detail::GkAtoms_Atoms = 520;
            pub const GkAtoms_Atoms_key: root::mozilla::detail::GkAtoms_Atoms = 521;
            pub const GkAtoms_Atoms_keycode: root::mozilla::detail::GkAtoms_Atoms = 522;
            pub const GkAtoms_Atoms_keydown: root::mozilla::detail::GkAtoms_Atoms = 523;
            pub const GkAtoms_Atoms_keygen: root::mozilla::detail::GkAtoms_Atoms = 524;
            pub const GkAtoms_Atoms_keypress: root::mozilla::detail::GkAtoms_Atoms = 525;
            pub const GkAtoms_Atoms_keyset: root::mozilla::detail::GkAtoms_Atoms = 526;
            pub const GkAtoms_Atoms_keysystem: root::mozilla::detail::GkAtoms_Atoms = 527;
            pub const GkAtoms_Atoms_keytext: root::mozilla::detail::GkAtoms_Atoms = 528;
            pub const GkAtoms_Atoms_keyup: root::mozilla::detail::GkAtoms_Atoms = 529;
            pub const GkAtoms_Atoms_kind: root::mozilla::detail::GkAtoms_Atoms = 530;
            pub const GkAtoms_Atoms_korean_hangul_formal: root::mozilla::detail::GkAtoms_Atoms =
                531;
            pub const GkAtoms_Atoms_korean_hanja_formal: root::mozilla::detail::GkAtoms_Atoms = 532;
            pub const GkAtoms_Atoms_korean_hanja_informal: root::mozilla::detail::GkAtoms_Atoms =
                533;
            pub const GkAtoms_Atoms_label: root::mozilla::detail::GkAtoms_Atoms = 534;
            pub const GkAtoms_Atoms_lang: root::mozilla::detail::GkAtoms_Atoms = 535;
            pub const GkAtoms_Atoms_language: root::mozilla::detail::GkAtoms_Atoms = 536;
            pub const GkAtoms_Atoms_last: root::mozilla::detail::GkAtoms_Atoms = 537;
            pub const GkAtoms_Atoms_layer: root::mozilla::detail::GkAtoms_Atoms = 538;
            pub const GkAtoms_Atoms_LayerActivity: root::mozilla::detail::GkAtoms_Atoms = 539;
            pub const GkAtoms_Atoms_leading: root::mozilla::detail::GkAtoms_Atoms = 540;
            pub const GkAtoms_Atoms_leaf: root::mozilla::detail::GkAtoms_Atoms = 541;
            pub const GkAtoms_Atoms_left: root::mozilla::detail::GkAtoms_Atoms = 542;
            pub const GkAtoms_Atoms_leftmargin: root::mozilla::detail::GkAtoms_Atoms = 543;
            pub const GkAtoms_Atoms_legend: root::mozilla::detail::GkAtoms_Atoms = 544;
            pub const GkAtoms_Atoms_length: root::mozilla::detail::GkAtoms_Atoms = 545;
            pub const GkAtoms_Atoms_letterValue: root::mozilla::detail::GkAtoms_Atoms = 546;
            pub const GkAtoms_Atoms_level: root::mozilla::detail::GkAtoms_Atoms = 547;
            pub const GkAtoms_Atoms_lhs: root::mozilla::detail::GkAtoms_Atoms = 548;
            pub const GkAtoms_Atoms_li: root::mozilla::detail::GkAtoms_Atoms = 549;
            pub const GkAtoms_Atoms_line: root::mozilla::detail::GkAtoms_Atoms = 550;
            pub const GkAtoms_Atoms_link: root::mozilla::detail::GkAtoms_Atoms = 551;
            pub const GkAtoms_Atoms_linkset: root::mozilla::detail::GkAtoms_Atoms = 552;
            pub const GkAtoms_Atoms_listbox: root::mozilla::detail::GkAtoms_Atoms = 553;
            pub const GkAtoms_Atoms_listener: root::mozilla::detail::GkAtoms_Atoms = 554;
            pub const GkAtoms_Atoms_listheader: root::mozilla::detail::GkAtoms_Atoms = 555;
            pub const GkAtoms_Atoms_listing: root::mozilla::detail::GkAtoms_Atoms = 556;
            pub const GkAtoms_Atoms_listitem: root::mozilla::detail::GkAtoms_Atoms = 557;
            pub const GkAtoms_Atoms_load: root::mozilla::detail::GkAtoms_Atoms = 558;
            pub const GkAtoms_Atoms_triggeringprincipal: root::mozilla::detail::GkAtoms_Atoms = 559;
            pub const GkAtoms_Atoms_localedir: root::mozilla::detail::GkAtoms_Atoms = 560;
            pub const GkAtoms_Atoms_localName: root::mozilla::detail::GkAtoms_Atoms = 561;
            pub const GkAtoms_Atoms_localization: root::mozilla::detail::GkAtoms_Atoms = 562;
            pub const GkAtoms_Atoms_longdesc: root::mozilla::detail::GkAtoms_Atoms = 563;
            pub const GkAtoms_Atoms_loop_: root::mozilla::detail::GkAtoms_Atoms = 564;
            pub const GkAtoms_Atoms_low: root::mozilla::detail::GkAtoms_Atoms = 565;
            pub const GkAtoms_Atoms_lowerFirst: root::mozilla::detail::GkAtoms_Atoms = 566;
            pub const GkAtoms_Atoms_lowest: root::mozilla::detail::GkAtoms_Atoms = 567;
            pub const GkAtoms_Atoms_lowsrc: root::mozilla::detail::GkAtoms_Atoms = 568;
            pub const GkAtoms_Atoms_ltr: root::mozilla::detail::GkAtoms_Atoms = 569;
            pub const GkAtoms_Atoms_lwtheme: root::mozilla::detail::GkAtoms_Atoms = 570;
            pub const GkAtoms_Atoms_lwthemetextcolor: root::mozilla::detail::GkAtoms_Atoms = 571;
            pub const GkAtoms_Atoms_main: root::mozilla::detail::GkAtoms_Atoms = 572;
            pub const GkAtoms_Atoms_map: root::mozilla::detail::GkAtoms_Atoms = 573;
            pub const GkAtoms_Atoms_manifest: root::mozilla::detail::GkAtoms_Atoms = 574;
            pub const GkAtoms_Atoms_marginBottom: root::mozilla::detail::GkAtoms_Atoms = 575;
            pub const GkAtoms_Atoms_marginLeft: root::mozilla::detail::GkAtoms_Atoms = 576;
            pub const GkAtoms_Atoms_marginRight: root::mozilla::detail::GkAtoms_Atoms = 577;
            pub const GkAtoms_Atoms_marginTop: root::mozilla::detail::GkAtoms_Atoms = 578;
            pub const GkAtoms_Atoms_marginheight: root::mozilla::detail::GkAtoms_Atoms = 579;
            pub const GkAtoms_Atoms_marginwidth: root::mozilla::detail::GkAtoms_Atoms = 580;
            pub const GkAtoms_Atoms_mark: root::mozilla::detail::GkAtoms_Atoms = 581;
            pub const GkAtoms_Atoms_marquee: root::mozilla::detail::GkAtoms_Atoms = 582;
            pub const GkAtoms_Atoms_match_: root::mozilla::detail::GkAtoms_Atoms = 583;
            pub const GkAtoms_Atoms_max: root::mozilla::detail::GkAtoms_Atoms = 584;
            pub const GkAtoms_Atoms_maxheight: root::mozilla::detail::GkAtoms_Atoms = 585;
            pub const GkAtoms_Atoms_maximum_scale: root::mozilla::detail::GkAtoms_Atoms = 586;
            pub const GkAtoms_Atoms_maxlength: root::mozilla::detail::GkAtoms_Atoms = 587;
            pub const GkAtoms_Atoms_maxpos: root::mozilla::detail::GkAtoms_Atoms = 588;
            pub const GkAtoms_Atoms_maxwidth: root::mozilla::detail::GkAtoms_Atoms = 589;
            pub const GkAtoms_Atoms_media: root::mozilla::detail::GkAtoms_Atoms = 590;
            pub const GkAtoms_Atoms_mediaType: root::mozilla::detail::GkAtoms_Atoms = 591;
            pub const GkAtoms_Atoms_menu: root::mozilla::detail::GkAtoms_Atoms = 592;
            pub const GkAtoms_Atoms_menubar: root::mozilla::detail::GkAtoms_Atoms = 593;
            pub const GkAtoms_Atoms_menubutton: root::mozilla::detail::GkAtoms_Atoms = 594;
            pub const GkAtoms_Atoms_menucaption: root::mozilla::detail::GkAtoms_Atoms = 595;
            pub const GkAtoms_Atoms_menugroup: root::mozilla::detail::GkAtoms_Atoms = 596;
            pub const GkAtoms_Atoms_menuitem: root::mozilla::detail::GkAtoms_Atoms = 597;
            pub const GkAtoms_Atoms_menulist: root::mozilla::detail::GkAtoms_Atoms = 598;
            pub const GkAtoms_Atoms_menupopup: root::mozilla::detail::GkAtoms_Atoms = 599;
            pub const GkAtoms_Atoms_menuseparator: root::mozilla::detail::GkAtoms_Atoms = 600;
            pub const GkAtoms_Atoms_mesh: root::mozilla::detail::GkAtoms_Atoms = 601;
            pub const GkAtoms_Atoms_message: root::mozilla::detail::GkAtoms_Atoms = 602;
            pub const GkAtoms_Atoms_meta: root::mozilla::detail::GkAtoms_Atoms = 603;
            pub const GkAtoms_Atoms_referrer: root::mozilla::detail::GkAtoms_Atoms = 604;
            pub const GkAtoms_Atoms_referrerpolicy: root::mozilla::detail::GkAtoms_Atoms = 605;
            pub const GkAtoms_Atoms_renderroot: root::mozilla::detail::GkAtoms_Atoms = 606;
            pub const GkAtoms_Atoms_headerReferrerPolicy: root::mozilla::detail::GkAtoms_Atoms =
                607;
            pub const GkAtoms_Atoms_meter: root::mozilla::detail::GkAtoms_Atoms = 608;
            pub const GkAtoms_Atoms_method: root::mozilla::detail::GkAtoms_Atoms = 609;
            pub const GkAtoms_Atoms_middle: root::mozilla::detail::GkAtoms_Atoms = 610;
            pub const GkAtoms_Atoms_min: root::mozilla::detail::GkAtoms_Atoms = 611;
            pub const GkAtoms_Atoms_minheight: root::mozilla::detail::GkAtoms_Atoms = 612;
            pub const GkAtoms_Atoms_minimum_scale: root::mozilla::detail::GkAtoms_Atoms = 613;
            pub const GkAtoms_Atoms_minlength: root::mozilla::detail::GkAtoms_Atoms = 614;
            pub const GkAtoms_Atoms_minpos: root::mozilla::detail::GkAtoms_Atoms = 615;
            pub const GkAtoms_Atoms_minusSign: root::mozilla::detail::GkAtoms_Atoms = 616;
            pub const GkAtoms_Atoms_minwidth: root::mozilla::detail::GkAtoms_Atoms = 617;
            pub const GkAtoms_Atoms_mixed: root::mozilla::detail::GkAtoms_Atoms = 618;
            pub const GkAtoms_Atoms_messagemanagergroup: root::mozilla::detail::GkAtoms_Atoms = 619;
            pub const GkAtoms_Atoms_mod_: root::mozilla::detail::GkAtoms_Atoms = 620;
            pub const GkAtoms_Atoms_mode: root::mozilla::detail::GkAtoms_Atoms = 621;
            pub const GkAtoms_Atoms_modifiers: root::mozilla::detail::GkAtoms_Atoms = 622;
            pub const GkAtoms_Atoms_monochrome: root::mozilla::detail::GkAtoms_Atoms = 623;
            pub const GkAtoms_Atoms_mouseover: root::mozilla::detail::GkAtoms_Atoms = 624;
            pub const GkAtoms_Atoms_mousethrough: root::mozilla::detail::GkAtoms_Atoms = 625;
            pub const GkAtoms_Atoms_mozAccessiblecaret: root::mozilla::detail::GkAtoms_Atoms = 626;
            pub const GkAtoms_Atoms_mozCustomContentContainer:
                root::mozilla::detail::GkAtoms_Atoms = 627;
            pub const GkAtoms_Atoms_mozCollapsed: root::mozilla::detail::GkAtoms_Atoms = 628;
            pub const GkAtoms_Atoms_mozGrabber: root::mozilla::detail::GkAtoms_Atoms = 629;
            pub const GkAtoms_Atoms_mozNativeAnonymous: root::mozilla::detail::GkAtoms_Atoms = 630;
            pub const GkAtoms_Atoms_mozprivatebrowsing: root::mozilla::detail::GkAtoms_Atoms = 631;
            pub const GkAtoms_Atoms_mozResizer: root::mozilla::detail::GkAtoms_Atoms = 632;
            pub const GkAtoms_Atoms_mozResizingInfo: root::mozilla::detail::GkAtoms_Atoms = 633;
            pub const GkAtoms_Atoms_mozResizingShadow: root::mozilla::detail::GkAtoms_Atoms = 634;
            pub const GkAtoms_Atoms_mozTableAddColumnAfter: root::mozilla::detail::GkAtoms_Atoms =
                635;
            pub const GkAtoms_Atoms_mozTableAddColumnBefore: root::mozilla::detail::GkAtoms_Atoms =
                636;
            pub const GkAtoms_Atoms_mozTableAddRowAfter: root::mozilla::detail::GkAtoms_Atoms = 637;
            pub const GkAtoms_Atoms_mozTableAddRowBefore: root::mozilla::detail::GkAtoms_Atoms =
                638;
            pub const GkAtoms_Atoms_mozTableRemoveRow: root::mozilla::detail::GkAtoms_Atoms = 639;
            pub const GkAtoms_Atoms_mozTableRemoveColumn: root::mozilla::detail::GkAtoms_Atoms =
                640;
            pub const GkAtoms_Atoms_moz_opaque: root::mozilla::detail::GkAtoms_Atoms = 641;
            pub const GkAtoms_Atoms_moz_action_hint: root::mozilla::detail::GkAtoms_Atoms = 642;
            pub const GkAtoms_Atoms_multicol: root::mozilla::detail::GkAtoms_Atoms = 643;
            pub const GkAtoms_Atoms_multiple: root::mozilla::detail::GkAtoms_Atoms = 644;
            pub const GkAtoms_Atoms_muted: root::mozilla::detail::GkAtoms_Atoms = 645;
            pub const GkAtoms_Atoms_name: root::mozilla::detail::GkAtoms_Atoms = 646;
            pub const GkAtoms_Atoms__namespace: root::mozilla::detail::GkAtoms_Atoms = 647;
            pub const GkAtoms_Atoms_namespaceAlias: root::mozilla::detail::GkAtoms_Atoms = 648;
            pub const GkAtoms_Atoms_namespaceUri: root::mozilla::detail::GkAtoms_Atoms = 649;
            pub const GkAtoms_Atoms_NaN: root::mozilla::detail::GkAtoms_Atoms = 650;
            pub const GkAtoms_Atoms_n: root::mozilla::detail::GkAtoms_Atoms = 651;
            pub const GkAtoms_Atoms_nativeAnonymousChildList: root::mozilla::detail::GkAtoms_Atoms =
                652;
            pub const GkAtoms_Atoms_nav: root::mozilla::detail::GkAtoms_Atoms = 653;
            pub const GkAtoms_Atoms_ne: root::mozilla::detail::GkAtoms_Atoms = 654;
            pub const GkAtoms_Atoms_never: root::mozilla::detail::GkAtoms_Atoms = 655;
            pub const GkAtoms_Atoms__new: root::mozilla::detail::GkAtoms_Atoms = 656;
            pub const GkAtoms_Atoms_newline: root::mozilla::detail::GkAtoms_Atoms = 657;
            pub const GkAtoms_Atoms_nextRemoteTabId: root::mozilla::detail::GkAtoms_Atoms = 658;
            pub const GkAtoms_Atoms_no: root::mozilla::detail::GkAtoms_Atoms = 659;
            pub const GkAtoms_Atoms_noautofocus: root::mozilla::detail::GkAtoms_Atoms = 660;
            pub const GkAtoms_Atoms_noautohide: root::mozilla::detail::GkAtoms_Atoms = 661;
            pub const GkAtoms_Atoms_norolluponanchor: root::mozilla::detail::GkAtoms_Atoms = 662;
            pub const GkAtoms_Atoms_noBar: root::mozilla::detail::GkAtoms_Atoms = 663;
            pub const GkAtoms_Atoms_nobr: root::mozilla::detail::GkAtoms_Atoms = 664;
            pub const GkAtoms_Atoms_nodefaultsrc: root::mozilla::detail::GkAtoms_Atoms = 665;
            pub const GkAtoms_Atoms_nodeSet: root::mozilla::detail::GkAtoms_Atoms = 666;
            pub const GkAtoms_Atoms_noembed: root::mozilla::detail::GkAtoms_Atoms = 667;
            pub const GkAtoms_Atoms_noframes: root::mozilla::detail::GkAtoms_Atoms = 668;
            pub const GkAtoms_Atoms_nohref: root::mozilla::detail::GkAtoms_Atoms = 669;
            pub const GkAtoms_Atoms_noisolation: root::mozilla::detail::GkAtoms_Atoms = 670;
            pub const GkAtoms_Atoms_nomodule: root::mozilla::detail::GkAtoms_Atoms = 671;
            pub const GkAtoms_Atoms_nonce: root::mozilla::detail::GkAtoms_Atoms = 672;
            pub const GkAtoms_Atoms_none: root::mozilla::detail::GkAtoms_Atoms = 673;
            pub const GkAtoms_Atoms_noresize: root::mozilla::detail::GkAtoms_Atoms = 674;
            pub const GkAtoms_Atoms_normal: root::mozilla::detail::GkAtoms_Atoms = 675;
            pub const GkAtoms_Atoms_normalizeSpace: root::mozilla::detail::GkAtoms_Atoms = 676;
            pub const GkAtoms_Atoms_noscript: root::mozilla::detail::GkAtoms_Atoms = 677;
            pub const GkAtoms_Atoms_noshade: root::mozilla::detail::GkAtoms_Atoms = 678;
            pub const GkAtoms_Atoms_notification: root::mozilla::detail::GkAtoms_Atoms = 679;
            pub const GkAtoms_Atoms_novalidate: root::mozilla::detail::GkAtoms_Atoms = 680;
            pub const GkAtoms_Atoms__not: root::mozilla::detail::GkAtoms_Atoms = 681;
            pub const GkAtoms_Atoms_nowrap: root::mozilla::detail::GkAtoms_Atoms = 682;
            pub const GkAtoms_Atoms_number: root::mozilla::detail::GkAtoms_Atoms = 683;
            pub const GkAtoms_Atoms_nw: root::mozilla::detail::GkAtoms_Atoms = 684;
            pub const GkAtoms_Atoms_object: root::mozilla::detail::GkAtoms_Atoms = 685;
            pub const GkAtoms_Atoms_objectType: root::mozilla::detail::GkAtoms_Atoms = 686;
            pub const GkAtoms_Atoms_observes: root::mozilla::detail::GkAtoms_Atoms = 687;
            pub const GkAtoms_Atoms_odd: root::mozilla::detail::GkAtoms_Atoms = 688;
            pub const GkAtoms_Atoms_OFF: root::mozilla::detail::GkAtoms_Atoms = 689;
            pub const GkAtoms_Atoms_ol: root::mozilla::detail::GkAtoms_Atoms = 690;
            pub const GkAtoms_Atoms_omitXmlDeclaration: root::mozilla::detail::GkAtoms_Atoms = 691;
            pub const GkAtoms_Atoms_onabort: root::mozilla::detail::GkAtoms_Atoms = 692;
            pub const GkAtoms_Atoms_onmozaccesskeynotfound: root::mozilla::detail::GkAtoms_Atoms =
                693;
            pub const GkAtoms_Atoms_onactivate: root::mozilla::detail::GkAtoms_Atoms = 694;
            pub const GkAtoms_Atoms_onafterprint: root::mozilla::detail::GkAtoms_Atoms = 695;
            pub const GkAtoms_Atoms_onafterscriptexecute: root::mozilla::detail::GkAtoms_Atoms =
                696;
            pub const GkAtoms_Atoms_onanimationcancel: root::mozilla::detail::GkAtoms_Atoms = 697;
            pub const GkAtoms_Atoms_onanimationend: root::mozilla::detail::GkAtoms_Atoms = 698;
            pub const GkAtoms_Atoms_onanimationiteration: root::mozilla::detail::GkAtoms_Atoms =
                699;
            pub const GkAtoms_Atoms_onanimationstart: root::mozilla::detail::GkAtoms_Atoms = 700;
            pub const GkAtoms_Atoms_onAppCommand: root::mozilla::detail::GkAtoms_Atoms = 701;
            pub const GkAtoms_Atoms_onappinstalled: root::mozilla::detail::GkAtoms_Atoms = 702;
            pub const GkAtoms_Atoms_onaudioprocess: root::mozilla::detail::GkAtoms_Atoms = 703;
            pub const GkAtoms_Atoms_onauxclick: root::mozilla::detail::GkAtoms_Atoms = 704;
            pub const GkAtoms_Atoms_onbeforecopy: root::mozilla::detail::GkAtoms_Atoms = 705;
            pub const GkAtoms_Atoms_onbeforecut: root::mozilla::detail::GkAtoms_Atoms = 706;
            pub const GkAtoms_Atoms_onbeforepaste: root::mozilla::detail::GkAtoms_Atoms = 707;
            pub const GkAtoms_Atoms_onbeforeprint: root::mozilla::detail::GkAtoms_Atoms = 708;
            pub const GkAtoms_Atoms_onbeforescriptexecute: root::mozilla::detail::GkAtoms_Atoms =
                709;
            pub const GkAtoms_Atoms_onbeforeunload: root::mozilla::detail::GkAtoms_Atoms = 710;
            pub const GkAtoms_Atoms_onblocked: root::mozilla::detail::GkAtoms_Atoms = 711;
            pub const GkAtoms_Atoms_onblur: root::mozilla::detail::GkAtoms_Atoms = 712;
            pub const GkAtoms_Atoms_onbounce: root::mozilla::detail::GkAtoms_Atoms = 713;
            pub const GkAtoms_Atoms_onbroadcast: root::mozilla::detail::GkAtoms_Atoms = 714;
            pub const GkAtoms_Atoms_onbufferedamountlow: root::mozilla::detail::GkAtoms_Atoms = 715;
            pub const GkAtoms_Atoms_oncached: root::mozilla::detail::GkAtoms_Atoms = 716;
            pub const GkAtoms_Atoms_oncancel: root::mozilla::detail::GkAtoms_Atoms = 717;
            pub const GkAtoms_Atoms_onchange: root::mozilla::detail::GkAtoms_Atoms = 718;
            pub const GkAtoms_Atoms_onchargingchange: root::mozilla::detail::GkAtoms_Atoms = 719;
            pub const GkAtoms_Atoms_onchargingtimechange: root::mozilla::detail::GkAtoms_Atoms =
                720;
            pub const GkAtoms_Atoms_onchecking: root::mozilla::detail::GkAtoms_Atoms = 721;
            pub const GkAtoms_Atoms_onCheckboxStateChange: root::mozilla::detail::GkAtoms_Atoms =
                722;
            pub const GkAtoms_Atoms_onCheckKeyPressEventModel:
                root::mozilla::detail::GkAtoms_Atoms = 723;
            pub const GkAtoms_Atoms_onclick: root::mozilla::detail::GkAtoms_Atoms = 724;
            pub const GkAtoms_Atoms_onclose: root::mozilla::detail::GkAtoms_Atoms = 725;
            pub const GkAtoms_Atoms_oncommand: root::mozilla::detail::GkAtoms_Atoms = 726;
            pub const GkAtoms_Atoms_oncommandupdate: root::mozilla::detail::GkAtoms_Atoms = 727;
            pub const GkAtoms_Atoms_oncomplete: root::mozilla::detail::GkAtoms_Atoms = 728;
            pub const GkAtoms_Atoms_oncompositionend: root::mozilla::detail::GkAtoms_Atoms = 729;
            pub const GkAtoms_Atoms_oncompositionstart: root::mozilla::detail::GkAtoms_Atoms = 730;
            pub const GkAtoms_Atoms_oncompositionupdate: root::mozilla::detail::GkAtoms_Atoms = 731;
            pub const GkAtoms_Atoms_onconnect: root::mozilla::detail::GkAtoms_Atoms = 732;
            pub const GkAtoms_Atoms_onconnectionavailable: root::mozilla::detail::GkAtoms_Atoms =
                733;
            pub const GkAtoms_Atoms_oncontextmenu: root::mozilla::detail::GkAtoms_Atoms = 734;
            pub const GkAtoms_Atoms_oncopy: root::mozilla::detail::GkAtoms_Atoms = 735;
            pub const GkAtoms_Atoms_oncut: root::mozilla::detail::GkAtoms_Atoms = 736;
            pub const GkAtoms_Atoms_ondblclick: root::mozilla::detail::GkAtoms_Atoms = 737;
            pub const GkAtoms_Atoms_ondischargingtimechange: root::mozilla::detail::GkAtoms_Atoms =
                738;
            pub const GkAtoms_Atoms_ondownloading: root::mozilla::detail::GkAtoms_Atoms = 739;
            pub const GkAtoms_Atoms_onDOMActivate: root::mozilla::detail::GkAtoms_Atoms = 740;
            pub const GkAtoms_Atoms_onDOMAttrModified: root::mozilla::detail::GkAtoms_Atoms = 741;
            pub const GkAtoms_Atoms_onDOMCharacterDataModified:
                root::mozilla::detail::GkAtoms_Atoms = 742;
            pub const GkAtoms_Atoms_onDOMFocusIn: root::mozilla::detail::GkAtoms_Atoms = 743;
            pub const GkAtoms_Atoms_onDOMFocusOut: root::mozilla::detail::GkAtoms_Atoms = 744;
            pub const GkAtoms_Atoms_onDOMMouseScroll: root::mozilla::detail::GkAtoms_Atoms = 745;
            pub const GkAtoms_Atoms_onDOMNodeInserted: root::mozilla::detail::GkAtoms_Atoms = 746;
            pub const GkAtoms_Atoms_onDOMNodeInsertedIntoDocument:
                root::mozilla::detail::GkAtoms_Atoms = 747;
            pub const GkAtoms_Atoms_onDOMNodeRemoved: root::mozilla::detail::GkAtoms_Atoms = 748;
            pub const GkAtoms_Atoms_onDOMNodeRemovedFromDocument:
                root::mozilla::detail::GkAtoms_Atoms = 749;
            pub const GkAtoms_Atoms_onDOMSubtreeModified: root::mozilla::detail::GkAtoms_Atoms =
                750;
            pub const GkAtoms_Atoms_ondata: root::mozilla::detail::GkAtoms_Atoms = 751;
            pub const GkAtoms_Atoms_ondrag: root::mozilla::detail::GkAtoms_Atoms = 752;
            pub const GkAtoms_Atoms_ondragdrop: root::mozilla::detail::GkAtoms_Atoms = 753;
            pub const GkAtoms_Atoms_ondragend: root::mozilla::detail::GkAtoms_Atoms = 754;
            pub const GkAtoms_Atoms_ondragenter: root::mozilla::detail::GkAtoms_Atoms = 755;
            pub const GkAtoms_Atoms_ondragexit: root::mozilla::detail::GkAtoms_Atoms = 756;
            pub const GkAtoms_Atoms_ondragleave: root::mozilla::detail::GkAtoms_Atoms = 757;
            pub const GkAtoms_Atoms_ondragover: root::mozilla::detail::GkAtoms_Atoms = 758;
            pub const GkAtoms_Atoms_ondragstart: root::mozilla::detail::GkAtoms_Atoms = 759;
            pub const GkAtoms_Atoms_ondrain: root::mozilla::detail::GkAtoms_Atoms = 760;
            pub const GkAtoms_Atoms_ondrop: root::mozilla::detail::GkAtoms_Atoms = 761;
            pub const GkAtoms_Atoms_onerror: root::mozilla::detail::GkAtoms_Atoms = 762;
            pub const GkAtoms_Atoms_onfinish: root::mozilla::detail::GkAtoms_Atoms = 763;
            pub const GkAtoms_Atoms_onfocus: root::mozilla::detail::GkAtoms_Atoms = 764;
            pub const GkAtoms_Atoms_onfocusin: root::mozilla::detail::GkAtoms_Atoms = 765;
            pub const GkAtoms_Atoms_onfocusout: root::mozilla::detail::GkAtoms_Atoms = 766;
            pub const GkAtoms_Atoms_onfullscreenchange: root::mozilla::detail::GkAtoms_Atoms = 767;
            pub const GkAtoms_Atoms_onfullscreenerror: root::mozilla::detail::GkAtoms_Atoms = 768;
            pub const GkAtoms_Atoms_onget: root::mozilla::detail::GkAtoms_Atoms = 769;
            pub const GkAtoms_Atoms_onhashchange: root::mozilla::detail::GkAtoms_Atoms = 770;
            pub const GkAtoms_Atoms_oninput: root::mozilla::detail::GkAtoms_Atoms = 771;
            pub const GkAtoms_Atoms_oninstall: root::mozilla::detail::GkAtoms_Atoms = 772;
            pub const GkAtoms_Atoms_oninvalid: root::mozilla::detail::GkAtoms_Atoms = 773;
            pub const GkAtoms_Atoms_onkeydown: root::mozilla::detail::GkAtoms_Atoms = 774;
            pub const GkAtoms_Atoms_onkeypress: root::mozilla::detail::GkAtoms_Atoms = 775;
            pub const GkAtoms_Atoms_onkeyup: root::mozilla::detail::GkAtoms_Atoms = 776;
            pub const GkAtoms_Atoms_onlanguagechange: root::mozilla::detail::GkAtoms_Atoms = 777;
            pub const GkAtoms_Atoms_onlevelchange: root::mozilla::detail::GkAtoms_Atoms = 778;
            pub const GkAtoms_Atoms_onload: root::mozilla::detail::GkAtoms_Atoms = 779;
            pub const GkAtoms_Atoms_onloading: root::mozilla::detail::GkAtoms_Atoms = 780;
            pub const GkAtoms_Atoms_onloadingdone: root::mozilla::detail::GkAtoms_Atoms = 781;
            pub const GkAtoms_Atoms_onloadingerror: root::mozilla::detail::GkAtoms_Atoms = 782;
            pub const GkAtoms_Atoms_onpopstate: root::mozilla::detail::GkAtoms_Atoms = 783;
            pub const GkAtoms_Atoms_only: root::mozilla::detail::GkAtoms_Atoms = 784;
            pub const GkAtoms_Atoms_onmerchantvalidation: root::mozilla::detail::GkAtoms_Atoms =
                785;
            pub const GkAtoms_Atoms_onmessage: root::mozilla::detail::GkAtoms_Atoms = 786;
            pub const GkAtoms_Atoms_onmessageerror: root::mozilla::detail::GkAtoms_Atoms = 787;
            pub const GkAtoms_Atoms_onmidimessage: root::mozilla::detail::GkAtoms_Atoms = 788;
            pub const GkAtoms_Atoms_onmousedown: root::mozilla::detail::GkAtoms_Atoms = 789;
            pub const GkAtoms_Atoms_onmouseenter: root::mozilla::detail::GkAtoms_Atoms = 790;
            pub const GkAtoms_Atoms_onmouseleave: root::mozilla::detail::GkAtoms_Atoms = 791;
            pub const GkAtoms_Atoms_onmouselongtap: root::mozilla::detail::GkAtoms_Atoms = 792;
            pub const GkAtoms_Atoms_onmousemove: root::mozilla::detail::GkAtoms_Atoms = 793;
            pub const GkAtoms_Atoms_onmouseout: root::mozilla::detail::GkAtoms_Atoms = 794;
            pub const GkAtoms_Atoms_onmouseover: root::mozilla::detail::GkAtoms_Atoms = 795;
            pub const GkAtoms_Atoms_onMozMouseHittest: root::mozilla::detail::GkAtoms_Atoms = 796;
            pub const GkAtoms_Atoms_onmouseup: root::mozilla::detail::GkAtoms_Atoms = 797;
            pub const GkAtoms_Atoms_onMozAfterPaint: root::mozilla::detail::GkAtoms_Atoms = 798;
            pub const GkAtoms_Atoms_onmozfullscreenchange: root::mozilla::detail::GkAtoms_Atoms =
                799;
            pub const GkAtoms_Atoms_onmozfullscreenerror: root::mozilla::detail::GkAtoms_Atoms =
                800;
            pub const GkAtoms_Atoms_onmozkeydownonplugin: root::mozilla::detail::GkAtoms_Atoms =
                801;
            pub const GkAtoms_Atoms_onmozkeyuponplugin: root::mozilla::detail::GkAtoms_Atoms = 802;
            pub const GkAtoms_Atoms_onmozpointerlockchange: root::mozilla::detail::GkAtoms_Atoms =
                803;
            pub const GkAtoms_Atoms_onmozpointerlockerror: root::mozilla::detail::GkAtoms_Atoms =
                804;
            pub const GkAtoms_Atoms_onMozMousePixelScroll: root::mozilla::detail::GkAtoms_Atoms =
                805;
            pub const GkAtoms_Atoms_onMozScrolledAreaChanged: root::mozilla::detail::GkAtoms_Atoms =
                806;
            pub const GkAtoms_Atoms_onmute: root::mozilla::detail::GkAtoms_Atoms = 807;
            pub const GkAtoms_Atoms_onnotificationclick: root::mozilla::detail::GkAtoms_Atoms = 808;
            pub const GkAtoms_Atoms_onnotificationclose: root::mozilla::detail::GkAtoms_Atoms = 809;
            pub const GkAtoms_Atoms_onnoupdate: root::mozilla::detail::GkAtoms_Atoms = 810;
            pub const GkAtoms_Atoms_onobsolete: root::mozilla::detail::GkAtoms_Atoms = 811;
            pub const GkAtoms_Atoms_ononline: root::mozilla::detail::GkAtoms_Atoms = 812;
            pub const GkAtoms_Atoms_onoffline: root::mozilla::detail::GkAtoms_Atoms = 813;
            pub const GkAtoms_Atoms_onopen: root::mozilla::detail::GkAtoms_Atoms = 814;
            pub const GkAtoms_Atoms_onorientationchange: root::mozilla::detail::GkAtoms_Atoms = 815;
            pub const GkAtoms_Atoms_onoverflow: root::mozilla::detail::GkAtoms_Atoms = 816;
            pub const GkAtoms_Atoms_onpagehide: root::mozilla::detail::GkAtoms_Atoms = 817;
            pub const GkAtoms_Atoms_onpageshow: root::mozilla::detail::GkAtoms_Atoms = 818;
            pub const GkAtoms_Atoms_onpaste: root::mozilla::detail::GkAtoms_Atoms = 819;
            pub const GkAtoms_Atoms_onpayerdetailchange: root::mozilla::detail::GkAtoms_Atoms = 820;
            pub const GkAtoms_Atoms_onpaymentmethodchange: root::mozilla::detail::GkAtoms_Atoms =
                821;
            pub const GkAtoms_Atoms_onpointerlockchange: root::mozilla::detail::GkAtoms_Atoms = 822;
            pub const GkAtoms_Atoms_onpointerlockerror: root::mozilla::detail::GkAtoms_Atoms = 823;
            pub const GkAtoms_Atoms_onpopuphidden: root::mozilla::detail::GkAtoms_Atoms = 824;
            pub const GkAtoms_Atoms_onpopuphiding: root::mozilla::detail::GkAtoms_Atoms = 825;
            pub const GkAtoms_Atoms_onpopuppositioned: root::mozilla::detail::GkAtoms_Atoms = 826;
            pub const GkAtoms_Atoms_onpopupshowing: root::mozilla::detail::GkAtoms_Atoms = 827;
            pub const GkAtoms_Atoms_onpopupshown: root::mozilla::detail::GkAtoms_Atoms = 828;
            pub const GkAtoms_Atoms_onprocessorerror: root::mozilla::detail::GkAtoms_Atoms = 829;
            pub const GkAtoms_Atoms_onpush: root::mozilla::detail::GkAtoms_Atoms = 830;
            pub const GkAtoms_Atoms_onpushsubscriptionchange: root::mozilla::detail::GkAtoms_Atoms =
                831;
            pub const GkAtoms_Atoms_onRadioStateChange: root::mozilla::detail::GkAtoms_Atoms = 832;
            pub const GkAtoms_Atoms_onreadystatechange: root::mozilla::detail::GkAtoms_Atoms = 833;
            pub const GkAtoms_Atoms_onrejectionhandled: root::mozilla::detail::GkAtoms_Atoms = 834;
            pub const GkAtoms_Atoms_onrequestprogress: root::mozilla::detail::GkAtoms_Atoms = 835;
            pub const GkAtoms_Atoms_onresourcetimingbufferfull:
                root::mozilla::detail::GkAtoms_Atoms = 836;
            pub const GkAtoms_Atoms_onresponseprogress: root::mozilla::detail::GkAtoms_Atoms = 837;
            pub const GkAtoms_Atoms_onRequest: root::mozilla::detail::GkAtoms_Atoms = 838;
            pub const GkAtoms_Atoms_onreset: root::mozilla::detail::GkAtoms_Atoms = 839;
            pub const GkAtoms_Atoms_onresize: root::mozilla::detail::GkAtoms_Atoms = 840;
            pub const GkAtoms_Atoms_onscroll: root::mozilla::detail::GkAtoms_Atoms = 841;
            pub const GkAtoms_Atoms_onselect: root::mozilla::detail::GkAtoms_Atoms = 842;
            pub const GkAtoms_Atoms_onselectionchange: root::mozilla::detail::GkAtoms_Atoms = 843;
            pub const GkAtoms_Atoms_onselectstart: root::mozilla::detail::GkAtoms_Atoms = 844;
            pub const GkAtoms_Atoms_onset: root::mozilla::detail::GkAtoms_Atoms = 845;
            pub const GkAtoms_Atoms_onshippingaddresschange: root::mozilla::detail::GkAtoms_Atoms =
                846;
            pub const GkAtoms_Atoms_onshippingoptionchange: root::mozilla::detail::GkAtoms_Atoms =
                847;
            pub const GkAtoms_Atoms_onshow: root::mozilla::detail::GkAtoms_Atoms = 848;
            pub const GkAtoms_Atoms_onstatechange: root::mozilla::detail::GkAtoms_Atoms = 849;
            pub const GkAtoms_Atoms_onstorage: root::mozilla::detail::GkAtoms_Atoms = 850;
            pub const GkAtoms_Atoms_onsubmit: root::mozilla::detail::GkAtoms_Atoms = 851;
            pub const GkAtoms_Atoms_onsuccess: root::mozilla::detail::GkAtoms_Atoms = 852;
            pub const GkAtoms_Atoms_ontypechange: root::mozilla::detail::GkAtoms_Atoms = 853;
            pub const GkAtoms_Atoms_onterminate: root::mozilla::detail::GkAtoms_Atoms = 854;
            pub const GkAtoms_Atoms_ontext: root::mozilla::detail::GkAtoms_Atoms = 855;
            pub const GkAtoms_Atoms_ontoggle: root::mozilla::detail::GkAtoms_Atoms = 856;
            pub const GkAtoms_Atoms_ontouchstart: root::mozilla::detail::GkAtoms_Atoms = 857;
            pub const GkAtoms_Atoms_ontouchend: root::mozilla::detail::GkAtoms_Atoms = 858;
            pub const GkAtoms_Atoms_ontouchmove: root::mozilla::detail::GkAtoms_Atoms = 859;
            pub const GkAtoms_Atoms_ontouchcancel: root::mozilla::detail::GkAtoms_Atoms = 860;
            pub const GkAtoms_Atoms_ontransitioncancel: root::mozilla::detail::GkAtoms_Atoms = 861;
            pub const GkAtoms_Atoms_ontransitionend: root::mozilla::detail::GkAtoms_Atoms = 862;
            pub const GkAtoms_Atoms_ontransitionrun: root::mozilla::detail::GkAtoms_Atoms = 863;
            pub const GkAtoms_Atoms_ontransitionstart: root::mozilla::detail::GkAtoms_Atoms = 864;
            pub const GkAtoms_Atoms_onunderflow: root::mozilla::detail::GkAtoms_Atoms = 865;
            pub const GkAtoms_Atoms_onunhandledrejection: root::mozilla::detail::GkAtoms_Atoms =
                866;
            pub const GkAtoms_Atoms_onunload: root::mozilla::detail::GkAtoms_Atoms = 867;
            pub const GkAtoms_Atoms_onunmute: root::mozilla::detail::GkAtoms_Atoms = 868;
            pub const GkAtoms_Atoms_onupdatefound: root::mozilla::detail::GkAtoms_Atoms = 869;
            pub const GkAtoms_Atoms_onupdateready: root::mozilla::detail::GkAtoms_Atoms = 870;
            pub const GkAtoms_Atoms_onupgradeneeded: root::mozilla::detail::GkAtoms_Atoms = 871;
            pub const GkAtoms_Atoms_onversionchange: root::mozilla::detail::GkAtoms_Atoms = 872;
            pub const GkAtoms_Atoms_onvisibilitychange: root::mozilla::detail::GkAtoms_Atoms = 873;
            pub const GkAtoms_Atoms_onvoiceschanged: root::mozilla::detail::GkAtoms_Atoms = 874;
            pub const GkAtoms_Atoms_onvrdisplayactivate: root::mozilla::detail::GkAtoms_Atoms = 875;
            pub const GkAtoms_Atoms_onvrdisplayconnect: root::mozilla::detail::GkAtoms_Atoms = 876;
            pub const GkAtoms_Atoms_onvrdisplaydeactivate: root::mozilla::detail::GkAtoms_Atoms =
                877;
            pub const GkAtoms_Atoms_onvrdisplaydisconnect: root::mozilla::detail::GkAtoms_Atoms =
                878;
            pub const GkAtoms_Atoms_onvrdisplaypresentchange: root::mozilla::detail::GkAtoms_Atoms =
                879;
            pub const GkAtoms_Atoms_onwebkitAnimationEnd: root::mozilla::detail::GkAtoms_Atoms =
                880;
            pub const GkAtoms_Atoms_onwebkitAnimationIteration:
                root::mozilla::detail::GkAtoms_Atoms = 881;
            pub const GkAtoms_Atoms_onwebkitAnimationStart: root::mozilla::detail::GkAtoms_Atoms =
                882;
            pub const GkAtoms_Atoms_onwebkitTransitionEnd: root::mozilla::detail::GkAtoms_Atoms =
                883;
            pub const GkAtoms_Atoms_onwebkitanimationend: root::mozilla::detail::GkAtoms_Atoms =
                884;
            pub const GkAtoms_Atoms_onwebkitanimationiteration:
                root::mozilla::detail::GkAtoms_Atoms = 885;
            pub const GkAtoms_Atoms_onwebkitanimationstart: root::mozilla::detail::GkAtoms_Atoms =
                886;
            pub const GkAtoms_Atoms_onwebkittransitionend: root::mozilla::detail::GkAtoms_Atoms =
                887;
            pub const GkAtoms_Atoms_onwheel: root::mozilla::detail::GkAtoms_Atoms = 888;
            pub const GkAtoms_Atoms_open: root::mozilla::detail::GkAtoms_Atoms = 889;
            pub const GkAtoms_Atoms_optgroup: root::mozilla::detail::GkAtoms_Atoms = 890;
            pub const GkAtoms_Atoms_optimum: root::mozilla::detail::GkAtoms_Atoms = 891;
            pub const GkAtoms_Atoms_option: root::mozilla::detail::GkAtoms_Atoms = 892;
            pub const GkAtoms_Atoms__or: root::mozilla::detail::GkAtoms_Atoms = 893;
            pub const GkAtoms_Atoms_order: root::mozilla::detail::GkAtoms_Atoms = 894;
            pub const GkAtoms_Atoms_ordinal: root::mozilla::detail::GkAtoms_Atoms = 895;
            pub const GkAtoms_Atoms_orient: root::mozilla::detail::GkAtoms_Atoms = 896;
            pub const GkAtoms_Atoms_orientation: root::mozilla::detail::GkAtoms_Atoms = 897;
            pub const GkAtoms_Atoms_otherwise: root::mozilla::detail::GkAtoms_Atoms = 898;
            pub const GkAtoms_Atoms_output: root::mozilla::detail::GkAtoms_Atoms = 899;
            pub const GkAtoms_Atoms_overflow: root::mozilla::detail::GkAtoms_Atoms = 900;
            pub const GkAtoms_Atoms_overflowBlock: root::mozilla::detail::GkAtoms_Atoms = 901;
            pub const GkAtoms_Atoms_overflowInline: root::mozilla::detail::GkAtoms_Atoms = 902;
            pub const GkAtoms_Atoms_overlay: root::mozilla::detail::GkAtoms_Atoms = 903;
            pub const GkAtoms_Atoms_p: root::mozilla::detail::GkAtoms_Atoms = 904;
            pub const GkAtoms_Atoms_pack: root::mozilla::detail::GkAtoms_Atoms = 905;
            pub const GkAtoms_Atoms_page: root::mozilla::detail::GkAtoms_Atoms = 906;
            pub const GkAtoms_Atoms_pageincrement: root::mozilla::detail::GkAtoms_Atoms = 907;
            pub const GkAtoms_Atoms_paint_order: root::mozilla::detail::GkAtoms_Atoms = 908;
            pub const GkAtoms_Atoms_panel: root::mozilla::detail::GkAtoms_Atoms = 909;
            pub const GkAtoms_Atoms_paragraph: root::mozilla::detail::GkAtoms_Atoms = 910;
            pub const GkAtoms_Atoms_param: root::mozilla::detail::GkAtoms_Atoms = 911;
            pub const GkAtoms_Atoms_parameter: root::mozilla::detail::GkAtoms_Atoms = 912;
            pub const GkAtoms_Atoms_parent: root::mozilla::detail::GkAtoms_Atoms = 913;
            pub const GkAtoms_Atoms_parentfocused: root::mozilla::detail::GkAtoms_Atoms = 914;
            pub const GkAtoms_Atoms_parsererror: root::mozilla::detail::GkAtoms_Atoms = 915;
            pub const GkAtoms_Atoms_part: root::mozilla::detail::GkAtoms_Atoms = 916;
            pub const GkAtoms_Atoms_password: root::mozilla::detail::GkAtoms_Atoms = 917;
            pub const GkAtoms_Atoms_pattern: root::mozilla::detail::GkAtoms_Atoms = 918;
            pub const GkAtoms_Atoms_patternSeparator: root::mozilla::detail::GkAtoms_Atoms = 919;
            pub const GkAtoms_Atoms_perMille: root::mozilla::detail::GkAtoms_Atoms = 920;
            pub const GkAtoms_Atoms_percent: root::mozilla::detail::GkAtoms_Atoms = 921;
            pub const GkAtoms_Atoms_persist: root::mozilla::detail::GkAtoms_Atoms = 922;
            pub const GkAtoms_Atoms_phase: root::mozilla::detail::GkAtoms_Atoms = 923;
            pub const GkAtoms_Atoms_picture: root::mozilla::detail::GkAtoms_Atoms = 924;
            pub const GkAtoms_Atoms_ping: root::mozilla::detail::GkAtoms_Atoms = 925;
            pub const GkAtoms_Atoms_pinned: root::mozilla::detail::GkAtoms_Atoms = 926;
            pub const GkAtoms_Atoms_placeholder: root::mozilla::detail::GkAtoms_Atoms = 927;
            pub const GkAtoms_Atoms_plaintext: root::mozilla::detail::GkAtoms_Atoms = 928;
            pub const GkAtoms_Atoms_playbackrate: root::mozilla::detail::GkAtoms_Atoms = 929;
            pub const GkAtoms_Atoms_pointSize: root::mozilla::detail::GkAtoms_Atoms = 930;
            pub const GkAtoms_Atoms_poly: root::mozilla::detail::GkAtoms_Atoms = 931;
            pub const GkAtoms_Atoms_polygon: root::mozilla::detail::GkAtoms_Atoms = 932;
            pub const GkAtoms_Atoms_popup: root::mozilla::detail::GkAtoms_Atoms = 933;
            pub const GkAtoms_Atoms_popupalign: root::mozilla::detail::GkAtoms_Atoms = 934;
            pub const GkAtoms_Atoms_popupanchor: root::mozilla::detail::GkAtoms_Atoms = 935;
            pub const GkAtoms_Atoms_popupgroup: root::mozilla::detail::GkAtoms_Atoms = 936;
            pub const GkAtoms_Atoms_popupset: root::mozilla::detail::GkAtoms_Atoms = 937;
            pub const GkAtoms_Atoms_popupsinherittooltip: root::mozilla::detail::GkAtoms_Atoms =
                938;
            pub const GkAtoms_Atoms_position: root::mozilla::detail::GkAtoms_Atoms = 939;
            pub const GkAtoms_Atoms_poster: root::mozilla::detail::GkAtoms_Atoms = 940;
            pub const GkAtoms_Atoms_pre: root::mozilla::detail::GkAtoms_Atoms = 941;
            pub const GkAtoms_Atoms_preceding: root::mozilla::detail::GkAtoms_Atoms = 942;
            pub const GkAtoms_Atoms_precedingSibling: root::mozilla::detail::GkAtoms_Atoms = 943;
            pub const GkAtoms_Atoms_prefersReducedMotion: root::mozilla::detail::GkAtoms_Atoms =
                944;
            pub const GkAtoms_Atoms_prefersColorScheme: root::mozilla::detail::GkAtoms_Atoms = 945;
            pub const GkAtoms_Atoms_prefix: root::mozilla::detail::GkAtoms_Atoms = 946;
            pub const GkAtoms_Atoms_preload: root::mozilla::detail::GkAtoms_Atoms = 947;
            pub const GkAtoms_Atoms_mozpresentation: root::mozilla::detail::GkAtoms_Atoms = 948;
            pub const GkAtoms_Atoms_preserve: root::mozilla::detail::GkAtoms_Atoms = 949;
            pub const GkAtoms_Atoms_preserveSpace: root::mozilla::detail::GkAtoms_Atoms = 950;
            pub const GkAtoms_Atoms_preventdefault: root::mozilla::detail::GkAtoms_Atoms = 951;
            pub const GkAtoms_Atoms_previewDiv: root::mozilla::detail::GkAtoms_Atoms = 952;
            pub const GkAtoms_Atoms_primary: root::mozilla::detail::GkAtoms_Atoms = 953;
            pub const GkAtoms_Atoms_print: root::mozilla::detail::GkAtoms_Atoms = 954;
            pub const GkAtoms_Atoms_priority: root::mozilla::detail::GkAtoms_Atoms = 955;
            pub const GkAtoms_Atoms_processingInstruction: root::mozilla::detail::GkAtoms_Atoms =
                956;
            pub const GkAtoms_Atoms_profile: root::mozilla::detail::GkAtoms_Atoms = 957;
            pub const GkAtoms_Atoms_progress: root::mozilla::detail::GkAtoms_Atoms = 958;
            pub const GkAtoms_Atoms_prompt: root::mozilla::detail::GkAtoms_Atoms = 959;
            pub const GkAtoms_Atoms_properties: root::mozilla::detail::GkAtoms_Atoms = 960;
            pub const GkAtoms_Atoms_property: root::mozilla::detail::GkAtoms_Atoms = 961;
            pub const GkAtoms_Atoms_pubdate: root::mozilla::detail::GkAtoms_Atoms = 962;
            pub const GkAtoms_Atoms_q: root::mozilla::detail::GkAtoms_Atoms = 963;
            pub const GkAtoms_Atoms_radio: root::mozilla::detail::GkAtoms_Atoms = 964;
            pub const GkAtoms_Atoms_radioLabel: root::mozilla::detail::GkAtoms_Atoms = 965;
            pub const GkAtoms_Atoms_radiogroup: root::mozilla::detail::GkAtoms_Atoms = 966;
            pub const GkAtoms_Atoms_range: root::mozilla::detail::GkAtoms_Atoms = 967;
            pub const GkAtoms_Atoms_readonly: root::mozilla::detail::GkAtoms_Atoms = 968;
            pub const GkAtoms_Atoms_rect: root::mozilla::detail::GkAtoms_Atoms = 969;
            pub const GkAtoms_Atoms_rectangle: root::mozilla::detail::GkAtoms_Atoms = 970;
            pub const GkAtoms_Atoms_refresh: root::mozilla::detail::GkAtoms_Atoms = 971;
            pub const GkAtoms_Atoms_rel: root::mozilla::detail::GkAtoms_Atoms = 972;
            pub const GkAtoms_Atoms_rem: root::mozilla::detail::GkAtoms_Atoms = 973;
            pub const GkAtoms_Atoms_remote: root::mozilla::detail::GkAtoms_Atoms = 974;
            pub const GkAtoms_Atoms_removeelement: root::mozilla::detail::GkAtoms_Atoms = 975;
            pub const GkAtoms_Atoms_renderingobserverset: root::mozilla::detail::GkAtoms_Atoms =
                976;
            pub const GkAtoms_Atoms_repeat: root::mozilla::detail::GkAtoms_Atoms = 977;
            pub const GkAtoms_Atoms_replace: root::mozilla::detail::GkAtoms_Atoms = 978;
            pub const GkAtoms_Atoms_requestcontextid: root::mozilla::detail::GkAtoms_Atoms = 979;
            pub const GkAtoms_Atoms_required: root::mozilla::detail::GkAtoms_Atoms = 980;
            pub const GkAtoms_Atoms_reserved: root::mozilla::detail::GkAtoms_Atoms = 981;
            pub const GkAtoms_Atoms_reset: root::mozilla::detail::GkAtoms_Atoms = 982;
            pub const GkAtoms_Atoms_resizeafter: root::mozilla::detail::GkAtoms_Atoms = 983;
            pub const GkAtoms_Atoms_resizebefore: root::mozilla::detail::GkAtoms_Atoms = 984;
            pub const GkAtoms_Atoms_resizer: root::mozilla::detail::GkAtoms_Atoms = 985;
            pub const GkAtoms_Atoms_resolution: root::mozilla::detail::GkAtoms_Atoms = 986;
            pub const GkAtoms_Atoms_resources: root::mozilla::detail::GkAtoms_Atoms = 987;
            pub const GkAtoms_Atoms_result: root::mozilla::detail::GkAtoms_Atoms = 988;
            pub const GkAtoms_Atoms_resultPrefix: root::mozilla::detail::GkAtoms_Atoms = 989;
            pub const GkAtoms_Atoms_retargetdocumentfocus: root::mozilla::detail::GkAtoms_Atoms =
                990;
            pub const GkAtoms_Atoms_rev: root::mozilla::detail::GkAtoms_Atoms = 991;
            pub const GkAtoms_Atoms_reverse: root::mozilla::detail::GkAtoms_Atoms = 992;
            pub const GkAtoms_Atoms_reversed: root::mozilla::detail::GkAtoms_Atoms = 993;
            pub const GkAtoms_Atoms_rhs: root::mozilla::detail::GkAtoms_Atoms = 994;
            pub const GkAtoms_Atoms_richlistbox: root::mozilla::detail::GkAtoms_Atoms = 995;
            pub const GkAtoms_Atoms_richlistitem: root::mozilla::detail::GkAtoms_Atoms = 996;
            pub const GkAtoms_Atoms_right: root::mozilla::detail::GkAtoms_Atoms = 997;
            pub const GkAtoms_Atoms_rightmargin: root::mozilla::detail::GkAtoms_Atoms = 998;
            pub const GkAtoms_Atoms_role: root::mozilla::detail::GkAtoms_Atoms = 999;
            pub const GkAtoms_Atoms_rolluponmousewheel: root::mozilla::detail::GkAtoms_Atoms = 1000;
            pub const GkAtoms_Atoms_round: root::mozilla::detail::GkAtoms_Atoms = 1001;
            pub const GkAtoms_Atoms_row: root::mozilla::detail::GkAtoms_Atoms = 1002;
            pub const GkAtoms_Atoms_rows: root::mozilla::detail::GkAtoms_Atoms = 1003;
            pub const GkAtoms_Atoms_rowspan: root::mozilla::detail::GkAtoms_Atoms = 1004;
            pub const GkAtoms_Atoms_rb: root::mozilla::detail::GkAtoms_Atoms = 1005;
            pub const GkAtoms_Atoms_rp: root::mozilla::detail::GkAtoms_Atoms = 1006;
            pub const GkAtoms_Atoms_rt: root::mozilla::detail::GkAtoms_Atoms = 1007;
            pub const GkAtoms_Atoms_rtc: root::mozilla::detail::GkAtoms_Atoms = 1008;
            pub const GkAtoms_Atoms_rtl: root::mozilla::detail::GkAtoms_Atoms = 1009;
            pub const GkAtoms_Atoms_ruby: root::mozilla::detail::GkAtoms_Atoms = 1010;
            pub const GkAtoms_Atoms_rubyBase: root::mozilla::detail::GkAtoms_Atoms = 1011;
            pub const GkAtoms_Atoms_rubyBaseContainer: root::mozilla::detail::GkAtoms_Atoms = 1012;
            pub const GkAtoms_Atoms_rubyText: root::mozilla::detail::GkAtoms_Atoms = 1013;
            pub const GkAtoms_Atoms_rubyTextContainer: root::mozilla::detail::GkAtoms_Atoms = 1014;
            pub const GkAtoms_Atoms_rules: root::mozilla::detail::GkAtoms_Atoms = 1015;
            pub const GkAtoms_Atoms_s: root::mozilla::detail::GkAtoms_Atoms = 1016;
            pub const GkAtoms_Atoms_safe_area_inset_top: root::mozilla::detail::GkAtoms_Atoms =
                1017;
            pub const GkAtoms_Atoms_safe_area_inset_bottom: root::mozilla::detail::GkAtoms_Atoms =
                1018;
            pub const GkAtoms_Atoms_safe_area_inset_left: root::mozilla::detail::GkAtoms_Atoms =
                1019;
            pub const GkAtoms_Atoms_safe_area_inset_right: root::mozilla::detail::GkAtoms_Atoms =
                1020;
            pub const GkAtoms_Atoms_samp: root::mozilla::detail::GkAtoms_Atoms = 1021;
            pub const GkAtoms_Atoms_sandbox: root::mozilla::detail::GkAtoms_Atoms = 1022;
            pub const GkAtoms_Atoms_sbattr: root::mozilla::detail::GkAtoms_Atoms = 1023;
            pub const GkAtoms_Atoms_scale: root::mozilla::detail::GkAtoms_Atoms = 1024;
            pub const GkAtoms_Atoms_scan: root::mozilla::detail::GkAtoms_Atoms = 1025;
            pub const GkAtoms_Atoms_scheme: root::mozilla::detail::GkAtoms_Atoms = 1026;
            pub const GkAtoms_Atoms_scope: root::mozilla::detail::GkAtoms_Atoms = 1027;
            pub const GkAtoms_Atoms_scoped: root::mozilla::detail::GkAtoms_Atoms = 1028;
            pub const GkAtoms_Atoms_screen: root::mozilla::detail::GkAtoms_Atoms = 1029;
            pub const GkAtoms_Atoms_screenX: root::mozilla::detail::GkAtoms_Atoms = 1030;
            pub const GkAtoms_Atoms_screenY: root::mozilla::detail::GkAtoms_Atoms = 1031;
            pub const GkAtoms_Atoms_script: root::mozilla::detail::GkAtoms_Atoms = 1032;
            pub const GkAtoms_Atoms_scriptEnabledBeforePrintOrPreview:
                root::mozilla::detail::GkAtoms_Atoms = 1033;
            pub const GkAtoms_Atoms_scrollbar: root::mozilla::detail::GkAtoms_Atoms = 1034;
            pub const GkAtoms_Atoms_scrollbarThumb: root::mozilla::detail::GkAtoms_Atoms = 1035;
            pub const GkAtoms_Atoms_scrollamount: root::mozilla::detail::GkAtoms_Atoms = 1036;
            pub const GkAtoms_Atoms_scrollbarbutton: root::mozilla::detail::GkAtoms_Atoms = 1037;
            pub const GkAtoms_Atoms_scrollbarDownBottom: root::mozilla::detail::GkAtoms_Atoms =
                1038;
            pub const GkAtoms_Atoms_scrollbarDownTop: root::mozilla::detail::GkAtoms_Atoms = 1039;
            pub const GkAtoms_Atoms_scrollbarUpBottom: root::mozilla::detail::GkAtoms_Atoms = 1040;
            pub const GkAtoms_Atoms_scrollbarUpTop: root::mozilla::detail::GkAtoms_Atoms = 1041;
            pub const GkAtoms_Atoms_scrollbox: root::mozilla::detail::GkAtoms_Atoms = 1042;
            pub const GkAtoms_Atoms_scrollcorner: root::mozilla::detail::GkAtoms_Atoms = 1043;
            pub const GkAtoms_Atoms_scrolldelay: root::mozilla::detail::GkAtoms_Atoms = 1044;
            pub const GkAtoms_Atoms_scrolling: root::mozilla::detail::GkAtoms_Atoms = 1045;
            pub const GkAtoms_Atoms_scrollPosition: root::mozilla::detail::GkAtoms_Atoms = 1046;
            pub const GkAtoms_Atoms_se: root::mozilla::detail::GkAtoms_Atoms = 1047;
            pub const GkAtoms_Atoms_section: root::mozilla::detail::GkAtoms_Atoms = 1048;
            pub const GkAtoms_Atoms_select: root::mozilla::detail::GkAtoms_Atoms = 1049;
            pub const GkAtoms_Atoms_selected: root::mozilla::detail::GkAtoms_Atoms = 1050;
            pub const GkAtoms_Atoms_selectedIndex: root::mozilla::detail::GkAtoms_Atoms = 1051;
            pub const GkAtoms_Atoms_selectedindex: root::mozilla::detail::GkAtoms_Atoms = 1052;
            pub const GkAtoms_Atoms_self_: root::mozilla::detail::GkAtoms_Atoms = 1053;
            pub const GkAtoms_Atoms_seltype: root::mozilla::detail::GkAtoms_Atoms = 1054;
            pub const GkAtoms_Atoms_setcookie: root::mozilla::detail::GkAtoms_Atoms = 1055;
            pub const GkAtoms_Atoms_setter: root::mozilla::detail::GkAtoms_Atoms = 1056;
            pub const GkAtoms_Atoms_shape: root::mozilla::detail::GkAtoms_Atoms = 1057;
            pub const GkAtoms_Atoms_show: root::mozilla::detail::GkAtoms_Atoms = 1058;
            pub const GkAtoms_Atoms_showcaret: root::mozilla::detail::GkAtoms_Atoms = 1059;
            pub const GkAtoms_Atoms_showresizer: root::mozilla::detail::GkAtoms_Atoms = 1060;
            pub const GkAtoms_Atoms_simple: root::mozilla::detail::GkAtoms_Atoms = 1061;
            pub const GkAtoms_Atoms_simp_chinese_formal: root::mozilla::detail::GkAtoms_Atoms =
                1062;
            pub const GkAtoms_Atoms_simp_chinese_informal: root::mozilla::detail::GkAtoms_Atoms =
                1063;
            pub const GkAtoms_Atoms_single: root::mozilla::detail::GkAtoms_Atoms = 1064;
            pub const GkAtoms_Atoms_size: root::mozilla::detail::GkAtoms_Atoms = 1065;
            pub const GkAtoms_Atoms_sizes: root::mozilla::detail::GkAtoms_Atoms = 1066;
            pub const GkAtoms_Atoms_sizemode: root::mozilla::detail::GkAtoms_Atoms = 1067;
            pub const GkAtoms_Atoms_sizetopopup: root::mozilla::detail::GkAtoms_Atoms = 1068;
            pub const GkAtoms_Atoms_slider: root::mozilla::detail::GkAtoms_Atoms = 1069;
            pub const GkAtoms_Atoms_small: root::mozilla::detail::GkAtoms_Atoms = 1070;
            pub const GkAtoms_Atoms_smooth: root::mozilla::detail::GkAtoms_Atoms = 1071;
            pub const GkAtoms_Atoms_snap: root::mozilla::detail::GkAtoms_Atoms = 1072;
            pub const GkAtoms_Atoms_solid: root::mozilla::detail::GkAtoms_Atoms = 1073;
            pub const GkAtoms_Atoms_sort: root::mozilla::detail::GkAtoms_Atoms = 1074;
            pub const GkAtoms_Atoms_sortActive: root::mozilla::detail::GkAtoms_Atoms = 1075;
            pub const GkAtoms_Atoms_sortDirection: root::mozilla::detail::GkAtoms_Atoms = 1076;
            pub const GkAtoms_Atoms_sorted: root::mozilla::detail::GkAtoms_Atoms = 1077;
            pub const GkAtoms_Atoms_sorthints: root::mozilla::detail::GkAtoms_Atoms = 1078;
            pub const GkAtoms_Atoms_source: root::mozilla::detail::GkAtoms_Atoms = 1079;
            pub const GkAtoms_Atoms_sourcetext: root::mozilla::detail::GkAtoms_Atoms = 1080;
            pub const GkAtoms_Atoms_space: root::mozilla::detail::GkAtoms_Atoms = 1081;
            pub const GkAtoms_Atoms_spacer: root::mozilla::detail::GkAtoms_Atoms = 1082;
            pub const GkAtoms_Atoms_span: root::mozilla::detail::GkAtoms_Atoms = 1083;
            pub const GkAtoms_Atoms_spellcheck: root::mozilla::detail::GkAtoms_Atoms = 1084;
            pub const GkAtoms_Atoms_split: root::mozilla::detail::GkAtoms_Atoms = 1085;
            pub const GkAtoms_Atoms_splitter: root::mozilla::detail::GkAtoms_Atoms = 1086;
            pub const GkAtoms_Atoms_spring: root::mozilla::detail::GkAtoms_Atoms = 1087;
            pub const GkAtoms_Atoms_square: root::mozilla::detail::GkAtoms_Atoms = 1088;
            pub const GkAtoms_Atoms_src: root::mozilla::detail::GkAtoms_Atoms = 1089;
            pub const GkAtoms_Atoms_srcdoc: root::mozilla::detail::GkAtoms_Atoms = 1090;
            pub const GkAtoms_Atoms_srclang: root::mozilla::detail::GkAtoms_Atoms = 1091;
            pub const GkAtoms_Atoms_srcset: root::mozilla::detail::GkAtoms_Atoms = 1092;
            pub const GkAtoms_Atoms_standalone: root::mozilla::detail::GkAtoms_Atoms = 1093;
            pub const GkAtoms_Atoms_standby: root::mozilla::detail::GkAtoms_Atoms = 1094;
            pub const GkAtoms_Atoms_start: root::mozilla::detail::GkAtoms_Atoms = 1095;
            pub const GkAtoms_Atoms_startsWith: root::mozilla::detail::GkAtoms_Atoms = 1096;
            pub const GkAtoms_Atoms_state: root::mozilla::detail::GkAtoms_Atoms = 1097;
            pub const GkAtoms_Atoms_statusbar: root::mozilla::detail::GkAtoms_Atoms = 1098;
            pub const GkAtoms_Atoms_step: root::mozilla::detail::GkAtoms_Atoms = 1099;
            pub const GkAtoms_Atoms_stop: root::mozilla::detail::GkAtoms_Atoms = 1100;
            pub const GkAtoms_Atoms_stretch: root::mozilla::detail::GkAtoms_Atoms = 1101;
            pub const GkAtoms_Atoms_strike: root::mozilla::detail::GkAtoms_Atoms = 1102;
            pub const GkAtoms_Atoms_string: root::mozilla::detail::GkAtoms_Atoms = 1103;
            pub const GkAtoms_Atoms_stringLength: root::mozilla::detail::GkAtoms_Atoms = 1104;
            pub const GkAtoms_Atoms_stripSpace: root::mozilla::detail::GkAtoms_Atoms = 1105;
            pub const GkAtoms_Atoms_strong: root::mozilla::detail::GkAtoms_Atoms = 1106;
            pub const GkAtoms_Atoms_style: root::mozilla::detail::GkAtoms_Atoms = 1107;
            pub const GkAtoms_Atoms_stylesheet: root::mozilla::detail::GkAtoms_Atoms = 1108;
            pub const GkAtoms_Atoms_stylesheetPrefix: root::mozilla::detail::GkAtoms_Atoms = 1109;
            pub const GkAtoms_Atoms_submit: root::mozilla::detail::GkAtoms_Atoms = 1110;
            pub const GkAtoms_Atoms_substate: root::mozilla::detail::GkAtoms_Atoms = 1111;
            pub const GkAtoms_Atoms_substring: root::mozilla::detail::GkAtoms_Atoms = 1112;
            pub const GkAtoms_Atoms_substringAfter: root::mozilla::detail::GkAtoms_Atoms = 1113;
            pub const GkAtoms_Atoms_substringBefore: root::mozilla::detail::GkAtoms_Atoms = 1114;
            pub const GkAtoms_Atoms_sub: root::mozilla::detail::GkAtoms_Atoms = 1115;
            pub const GkAtoms_Atoms_sum: root::mozilla::detail::GkAtoms_Atoms = 1116;
            pub const GkAtoms_Atoms_sup: root::mozilla::detail::GkAtoms_Atoms = 1117;
            pub const GkAtoms_Atoms_summary: root::mozilla::detail::GkAtoms_Atoms = 1118;
            pub const GkAtoms_Atoms_sw: root::mozilla::detail::GkAtoms_Atoms = 1119;
            pub const GkAtoms_Atoms_systemProperty: root::mozilla::detail::GkAtoms_Atoms = 1120;
            pub const GkAtoms_Atoms_tab: root::mozilla::detail::GkAtoms_Atoms = 1121;
            pub const GkAtoms_Atoms_tabindex: root::mozilla::detail::GkAtoms_Atoms = 1122;
            pub const GkAtoms_Atoms_table: root::mozilla::detail::GkAtoms_Atoms = 1123;
            pub const GkAtoms_Atoms_tabpanel: root::mozilla::detail::GkAtoms_Atoms = 1124;
            pub const GkAtoms_Atoms_tabpanels: root::mozilla::detail::GkAtoms_Atoms = 1125;
            pub const GkAtoms_Atoms_tag: root::mozilla::detail::GkAtoms_Atoms = 1126;
            pub const GkAtoms_Atoms_target: root::mozilla::detail::GkAtoms_Atoms = 1127;
            pub const GkAtoms_Atoms_targets: root::mozilla::detail::GkAtoms_Atoms = 1128;
            pub const GkAtoms_Atoms_tbody: root::mozilla::detail::GkAtoms_Atoms = 1129;
            pub const GkAtoms_Atoms_td: root::mozilla::detail::GkAtoms_Atoms = 1130;
            pub const GkAtoms_Atoms__template: root::mozilla::detail::GkAtoms_Atoms = 1131;
            pub const GkAtoms_Atoms_text_decoration: root::mozilla::detail::GkAtoms_Atoms = 1132;
            pub const GkAtoms_Atoms_terminate: root::mozilla::detail::GkAtoms_Atoms = 1133;
            pub const GkAtoms_Atoms_term: root::mozilla::detail::GkAtoms_Atoms = 1134;
            pub const GkAtoms_Atoms_test: root::mozilla::detail::GkAtoms_Atoms = 1135;
            pub const GkAtoms_Atoms_text: root::mozilla::detail::GkAtoms_Atoms = 1136;
            pub const GkAtoms_Atoms_textAlign: root::mozilla::detail::GkAtoms_Atoms = 1137;
            pub const GkAtoms_Atoms_textarea: root::mozilla::detail::GkAtoms_Atoms = 1138;
            pub const GkAtoms_Atoms_textbox: root::mozilla::detail::GkAtoms_Atoms = 1139;
            pub const GkAtoms_Atoms_textLink: root::mozilla::detail::GkAtoms_Atoms = 1140;
            pub const GkAtoms_Atoms_textNodeDirectionalityMap:
                root::mozilla::detail::GkAtoms_Atoms = 1141;
            pub const GkAtoms_Atoms_textOverlay: root::mozilla::detail::GkAtoms_Atoms = 1142;
            pub const GkAtoms_Atoms_tfoot: root::mozilla::detail::GkAtoms_Atoms = 1143;
            pub const GkAtoms_Atoms_th: root::mozilla::detail::GkAtoms_Atoms = 1144;
            pub const GkAtoms_Atoms_thead: root::mozilla::detail::GkAtoms_Atoms = 1145;
            pub const GkAtoms_Atoms_thumb: root::mozilla::detail::GkAtoms_Atoms = 1146;
            pub const GkAtoms_Atoms_time: root::mozilla::detail::GkAtoms_Atoms = 1147;
            pub const GkAtoms_Atoms_title: root::mozilla::detail::GkAtoms_Atoms = 1148;
            pub const GkAtoms_Atoms_titlebar: root::mozilla::detail::GkAtoms_Atoms = 1149;
            pub const GkAtoms_Atoms_titletip: root::mozilla::detail::GkAtoms_Atoms = 1150;
            pub const GkAtoms_Atoms_token: root::mozilla::detail::GkAtoms_Atoms = 1151;
            pub const GkAtoms_Atoms_tokenize: root::mozilla::detail::GkAtoms_Atoms = 1152;
            pub const GkAtoms_Atoms_toolbar: root::mozilla::detail::GkAtoms_Atoms = 1153;
            pub const GkAtoms_Atoms_toolbarbutton: root::mozilla::detail::GkAtoms_Atoms = 1154;
            pub const GkAtoms_Atoms_toolbarbuttonMultilineText:
                root::mozilla::detail::GkAtoms_Atoms = 1155;
            pub const GkAtoms_Atoms_toolbaritem: root::mozilla::detail::GkAtoms_Atoms = 1156;
            pub const GkAtoms_Atoms_toolbarpaletteitem: root::mozilla::detail::GkAtoms_Atoms = 1157;
            pub const GkAtoms_Atoms_toolbox: root::mozilla::detail::GkAtoms_Atoms = 1158;
            pub const GkAtoms_Atoms_tooltip: root::mozilla::detail::GkAtoms_Atoms = 1159;
            pub const GkAtoms_Atoms_tooltiptext: root::mozilla::detail::GkAtoms_Atoms = 1160;
            pub const GkAtoms_Atoms_top: root::mozilla::detail::GkAtoms_Atoms = 1161;
            pub const GkAtoms_Atoms_topleft: root::mozilla::detail::GkAtoms_Atoms = 1162;
            pub const GkAtoms_Atoms_topmargin: root::mozilla::detail::GkAtoms_Atoms = 1163;
            pub const GkAtoms_Atoms_topright: root::mozilla::detail::GkAtoms_Atoms = 1164;
            pub const GkAtoms_Atoms_tr: root::mozilla::detail::GkAtoms_Atoms = 1165;
            pub const GkAtoms_Atoms_track: root::mozilla::detail::GkAtoms_Atoms = 1166;
            pub const GkAtoms_Atoms_trad_chinese_formal: root::mozilla::detail::GkAtoms_Atoms =
                1167;
            pub const GkAtoms_Atoms_trad_chinese_informal: root::mozilla::detail::GkAtoms_Atoms =
                1168;
            pub const GkAtoms_Atoms_trailing: root::mozilla::detail::GkAtoms_Atoms = 1169;
            pub const GkAtoms_Atoms_transform: root::mozilla::detail::GkAtoms_Atoms = 1170;
            pub const GkAtoms_Atoms_transform_3d: root::mozilla::detail::GkAtoms_Atoms = 1171;
            pub const GkAtoms_Atoms_transformiix: root::mozilla::detail::GkAtoms_Atoms = 1172;
            pub const GkAtoms_Atoms_translate: root::mozilla::detail::GkAtoms_Atoms = 1173;
            pub const GkAtoms_Atoms_transparent: root::mozilla::detail::GkAtoms_Atoms = 1174;
            pub const GkAtoms_Atoms_tree: root::mozilla::detail::GkAtoms_Atoms = 1175;
            pub const GkAtoms_Atoms_treecell: root::mozilla::detail::GkAtoms_Atoms = 1176;
            pub const GkAtoms_Atoms_treechildren: root::mozilla::detail::GkAtoms_Atoms = 1177;
            pub const GkAtoms_Atoms_treecol: root::mozilla::detail::GkAtoms_Atoms = 1178;
            pub const GkAtoms_Atoms_treecolpicker: root::mozilla::detail::GkAtoms_Atoms = 1179;
            pub const GkAtoms_Atoms_treecols: root::mozilla::detail::GkAtoms_Atoms = 1180;
            pub const GkAtoms_Atoms_treeitem: root::mozilla::detail::GkAtoms_Atoms = 1181;
            pub const GkAtoms_Atoms_treerow: root::mozilla::detail::GkAtoms_Atoms = 1182;
            pub const GkAtoms_Atoms_treeseparator: root::mozilla::detail::GkAtoms_Atoms = 1183;
            pub const GkAtoms_Atoms__true: root::mozilla::detail::GkAtoms_Atoms = 1184;
            pub const GkAtoms_Atoms_truespeed: root::mozilla::detail::GkAtoms_Atoms = 1185;
            pub const GkAtoms_Atoms_tt: root::mozilla::detail::GkAtoms_Atoms = 1186;
            pub const GkAtoms_Atoms_type_: root::mozilla::detail::GkAtoms_Atoms = 1187;
            pub const GkAtoms_Atoms_u: root::mozilla::detail::GkAtoms_Atoms = 1188;
            pub const GkAtoms_Atoms_ul: root::mozilla::detail::GkAtoms_Atoms = 1189;
            pub const GkAtoms_Atoms_unparsedEntityUri: root::mozilla::detail::GkAtoms_Atoms = 1190;
            pub const GkAtoms_Atoms_up: root::mozilla::detail::GkAtoms_Atoms = 1191;
            pub const GkAtoms_Atoms_upperFirst: root::mozilla::detail::GkAtoms_Atoms = 1192;
            pub const GkAtoms_Atoms_use_: root::mozilla::detail::GkAtoms_Atoms = 1193;
            pub const GkAtoms_Atoms_useAttributeSets: root::mozilla::detail::GkAtoms_Atoms = 1194;
            pub const GkAtoms_Atoms_usemap: root::mozilla::detail::GkAtoms_Atoms = 1195;
            pub const GkAtoms_Atoms_user_scalable: root::mozilla::detail::GkAtoms_Atoms = 1196;
            pub const GkAtoms_Atoms_validate: root::mozilla::detail::GkAtoms_Atoms = 1197;
            pub const GkAtoms_Atoms_valign: root::mozilla::detail::GkAtoms_Atoms = 1198;
            pub const GkAtoms_Atoms_value: root::mozilla::detail::GkAtoms_Atoms = 1199;
            pub const GkAtoms_Atoms_values: root::mozilla::detail::GkAtoms_Atoms = 1200;
            pub const GkAtoms_Atoms_valueOf: root::mozilla::detail::GkAtoms_Atoms = 1201;
            pub const GkAtoms_Atoms_valuetype: root::mozilla::detail::GkAtoms_Atoms = 1202;
            pub const GkAtoms_Atoms_var: root::mozilla::detail::GkAtoms_Atoms = 1203;
            pub const GkAtoms_Atoms_variable: root::mozilla::detail::GkAtoms_Atoms = 1204;
            pub const GkAtoms_Atoms_vendor: root::mozilla::detail::GkAtoms_Atoms = 1205;
            pub const GkAtoms_Atoms_vendorUrl: root::mozilla::detail::GkAtoms_Atoms = 1206;
            pub const GkAtoms_Atoms_version: root::mozilla::detail::GkAtoms_Atoms = 1207;
            pub const GkAtoms_Atoms_vertical: root::mozilla::detail::GkAtoms_Atoms = 1208;
            pub const GkAtoms_Atoms_audio: root::mozilla::detail::GkAtoms_Atoms = 1209;
            pub const GkAtoms_Atoms_video: root::mozilla::detail::GkAtoms_Atoms = 1210;
            pub const GkAtoms_Atoms_viewport: root::mozilla::detail::GkAtoms_Atoms = 1211;
            pub const GkAtoms_Atoms_viewport_height: root::mozilla::detail::GkAtoms_Atoms = 1212;
            pub const GkAtoms_Atoms_viewport_initial_scale: root::mozilla::detail::GkAtoms_Atoms =
                1213;
            pub const GkAtoms_Atoms_viewport_maximum_scale: root::mozilla::detail::GkAtoms_Atoms =
                1214;
            pub const GkAtoms_Atoms_viewport_minimum_scale: root::mozilla::detail::GkAtoms_Atoms =
                1215;
            pub const GkAtoms_Atoms_viewport_user_scalable: root::mozilla::detail::GkAtoms_Atoms =
                1216;
            pub const GkAtoms_Atoms_viewport_width: root::mozilla::detail::GkAtoms_Atoms = 1217;
            pub const GkAtoms_Atoms_visibility: root::mozilla::detail::GkAtoms_Atoms = 1218;
            pub const GkAtoms_Atoms_visuallyselected: root::mozilla::detail::GkAtoms_Atoms = 1219;
            pub const GkAtoms_Atoms_vlink: root::mozilla::detail::GkAtoms_Atoms = 1220;
            pub const GkAtoms_Atoms__void: root::mozilla::detail::GkAtoms_Atoms = 1221;
            pub const GkAtoms_Atoms_vsides: root::mozilla::detail::GkAtoms_Atoms = 1222;
            pub const GkAtoms_Atoms_vspace: root::mozilla::detail::GkAtoms_Atoms = 1223;
            pub const GkAtoms_Atoms_w: root::mozilla::detail::GkAtoms_Atoms = 1224;
            pub const GkAtoms_Atoms_wbr: root::mozilla::detail::GkAtoms_Atoms = 1225;
            pub const GkAtoms_Atoms_webkitdirectory: root::mozilla::detail::GkAtoms_Atoms = 1226;
            pub const GkAtoms_Atoms_when: root::mozilla::detail::GkAtoms_Atoms = 1227;
            pub const GkAtoms_Atoms_white: root::mozilla::detail::GkAtoms_Atoms = 1228;
            pub const GkAtoms_Atoms_width: root::mozilla::detail::GkAtoms_Atoms = 1229;
            pub const GkAtoms_Atoms_willChange: root::mozilla::detail::GkAtoms_Atoms = 1230;
            pub const GkAtoms_Atoms_window: root::mozilla::detail::GkAtoms_Atoms = 1231;
            pub const GkAtoms_Atoms_headerWindowTarget: root::mozilla::detail::GkAtoms_Atoms = 1232;
            pub const GkAtoms_Atoms_windowtype: root::mozilla::detail::GkAtoms_Atoms = 1233;
            pub const GkAtoms_Atoms_withParam: root::mozilla::detail::GkAtoms_Atoms = 1234;
            pub const GkAtoms_Atoms_wizard: root::mozilla::detail::GkAtoms_Atoms = 1235;
            pub const GkAtoms_Atoms_wrap: root::mozilla::detail::GkAtoms_Atoms = 1236;
            pub const GkAtoms_Atoms_headerDNSPrefetchControl: root::mozilla::detail::GkAtoms_Atoms =
                1237;
            pub const GkAtoms_Atoms_headerCSP: root::mozilla::detail::GkAtoms_Atoms = 1238;
            pub const GkAtoms_Atoms_headerCSPReportOnly: root::mozilla::detail::GkAtoms_Atoms =
                1239;
            pub const GkAtoms_Atoms_headerXFO: root::mozilla::detail::GkAtoms_Atoms = 1240;
            pub const GkAtoms_Atoms_x_western: root::mozilla::detail::GkAtoms_Atoms = 1241;
            pub const GkAtoms_Atoms_xml: root::mozilla::detail::GkAtoms_Atoms = 1242;
            pub const GkAtoms_Atoms_xml_stylesheet: root::mozilla::detail::GkAtoms_Atoms = 1243;
            pub const GkAtoms_Atoms_xmlns: root::mozilla::detail::GkAtoms_Atoms = 1244;
            pub const GkAtoms_Atoms_xmp: root::mozilla::detail::GkAtoms_Atoms = 1245;
            pub const GkAtoms_Atoms_xul: root::mozilla::detail::GkAtoms_Atoms = 1246;
            pub const GkAtoms_Atoms_yes: root::mozilla::detail::GkAtoms_Atoms = 1247;
            pub const GkAtoms_Atoms_z_index: root::mozilla::detail::GkAtoms_Atoms = 1248;
            pub const GkAtoms_Atoms_zeroDigit: root::mozilla::detail::GkAtoms_Atoms = 1249;
            pub const GkAtoms_Atoms_zlevel: root::mozilla::detail::GkAtoms_Atoms = 1250;
            pub const GkAtoms_Atoms_percentage: root::mozilla::detail::GkAtoms_Atoms = 1251;
            pub const GkAtoms_Atoms_A: root::mozilla::detail::GkAtoms_Atoms = 1252;
            pub const GkAtoms_Atoms_alignment_baseline: root::mozilla::detail::GkAtoms_Atoms = 1253;
            pub const GkAtoms_Atoms_amplitude: root::mozilla::detail::GkAtoms_Atoms = 1254;
            pub const GkAtoms_Atoms_animate: root::mozilla::detail::GkAtoms_Atoms = 1255;
            pub const GkAtoms_Atoms_animateColor: root::mozilla::detail::GkAtoms_Atoms = 1256;
            pub const GkAtoms_Atoms_animateMotion: root::mozilla::detail::GkAtoms_Atoms = 1257;
            pub const GkAtoms_Atoms_animateTransform: root::mozilla::detail::GkAtoms_Atoms = 1258;
            pub const GkAtoms_Atoms_arithmetic: root::mozilla::detail::GkAtoms_Atoms = 1259;
            pub const GkAtoms_Atoms_atop: root::mozilla::detail::GkAtoms_Atoms = 1260;
            pub const GkAtoms_Atoms_azimuth: root::mozilla::detail::GkAtoms_Atoms = 1261;
            pub const GkAtoms_Atoms_B: root::mozilla::detail::GkAtoms_Atoms = 1262;
            pub const GkAtoms_Atoms_backgroundColor: root::mozilla::detail::GkAtoms_Atoms = 1263;
            pub const GkAtoms_Atoms_background_image: root::mozilla::detail::GkAtoms_Atoms = 1264;
            pub const GkAtoms_Atoms_baseFrequency: root::mozilla::detail::GkAtoms_Atoms = 1265;
            pub const GkAtoms_Atoms_baseline_shift: root::mozilla::detail::GkAtoms_Atoms = 1266;
            pub const GkAtoms_Atoms_bias: root::mozilla::detail::GkAtoms_Atoms = 1267;
            pub const GkAtoms_Atoms_caption_side: root::mozilla::detail::GkAtoms_Atoms = 1268;
            pub const GkAtoms_Atoms_clip_path: root::mozilla::detail::GkAtoms_Atoms = 1269;
            pub const GkAtoms_Atoms_clip_rule: root::mozilla::detail::GkAtoms_Atoms = 1270;
            pub const GkAtoms_Atoms_clipPath: root::mozilla::detail::GkAtoms_Atoms = 1271;
            pub const GkAtoms_Atoms_clipPathUnits: root::mozilla::detail::GkAtoms_Atoms = 1272;
            pub const GkAtoms_Atoms_cm: root::mozilla::detail::GkAtoms_Atoms = 1273;
            pub const GkAtoms_Atoms_colorBurn: root::mozilla::detail::GkAtoms_Atoms = 1274;
            pub const GkAtoms_Atoms_colorDodge: root::mozilla::detail::GkAtoms_Atoms = 1275;
            pub const GkAtoms_Atoms_colorInterpolation: root::mozilla::detail::GkAtoms_Atoms = 1276;
            pub const GkAtoms_Atoms_colorInterpolationFilters:
                root::mozilla::detail::GkAtoms_Atoms = 1277;
            pub const GkAtoms_Atoms_colorProfile: root::mozilla::detail::GkAtoms_Atoms = 1278;
            pub const GkAtoms_Atoms_cursor: root::mozilla::detail::GkAtoms_Atoms = 1279;
            pub const GkAtoms_Atoms_cx: root::mozilla::detail::GkAtoms_Atoms = 1280;
            pub const GkAtoms_Atoms_cy: root::mozilla::detail::GkAtoms_Atoms = 1281;
            pub const GkAtoms_Atoms_d: root::mozilla::detail::GkAtoms_Atoms = 1282;
            pub const GkAtoms_Atoms_darken: root::mozilla::detail::GkAtoms_Atoms = 1283;
            pub const GkAtoms_Atoms_defs: root::mozilla::detail::GkAtoms_Atoms = 1284;
            pub const GkAtoms_Atoms_deg: root::mozilla::detail::GkAtoms_Atoms = 1285;
            pub const GkAtoms_Atoms_desc: root::mozilla::detail::GkAtoms_Atoms = 1286;
            pub const GkAtoms_Atoms_diffuseConstant: root::mozilla::detail::GkAtoms_Atoms = 1287;
            pub const GkAtoms_Atoms_dilate: root::mozilla::detail::GkAtoms_Atoms = 1288;
            pub const GkAtoms_Atoms_direction: root::mozilla::detail::GkAtoms_Atoms = 1289;
            pub const GkAtoms_Atoms_disable: root::mozilla::detail::GkAtoms_Atoms = 1290;
            pub const GkAtoms_Atoms_disc: root::mozilla::detail::GkAtoms_Atoms = 1291;
            pub const GkAtoms_Atoms_discrete: root::mozilla::detail::GkAtoms_Atoms = 1292;
            pub const GkAtoms_Atoms_divisor: root::mozilla::detail::GkAtoms_Atoms = 1293;
            pub const GkAtoms_Atoms_dominant_baseline: root::mozilla::detail::GkAtoms_Atoms = 1294;
            pub const GkAtoms_Atoms_duplicate: root::mozilla::detail::GkAtoms_Atoms = 1295;
            pub const GkAtoms_Atoms_dx: root::mozilla::detail::GkAtoms_Atoms = 1296;
            pub const GkAtoms_Atoms_dy: root::mozilla::detail::GkAtoms_Atoms = 1297;
            pub const GkAtoms_Atoms_edgeMode: root::mozilla::detail::GkAtoms_Atoms = 1298;
            pub const GkAtoms_Atoms_ellipse: root::mozilla::detail::GkAtoms_Atoms = 1299;
            pub const GkAtoms_Atoms_elevation: root::mozilla::detail::GkAtoms_Atoms = 1300;
            pub const GkAtoms_Atoms_erode: root::mozilla::detail::GkAtoms_Atoms = 1301;
            pub const GkAtoms_Atoms_ex: root::mozilla::detail::GkAtoms_Atoms = 1302;
            pub const GkAtoms_Atoms_exact: root::mozilla::detail::GkAtoms_Atoms = 1303;
            pub const GkAtoms_Atoms_exclusion: root::mozilla::detail::GkAtoms_Atoms = 1304;
            pub const GkAtoms_Atoms_exponent: root::mozilla::detail::GkAtoms_Atoms = 1305;
            pub const GkAtoms_Atoms_feBlend: root::mozilla::detail::GkAtoms_Atoms = 1306;
            pub const GkAtoms_Atoms_feColorMatrix: root::mozilla::detail::GkAtoms_Atoms = 1307;
            pub const GkAtoms_Atoms_feComponentTransfer: root::mozilla::detail::GkAtoms_Atoms =
                1308;
            pub const GkAtoms_Atoms_feComposite: root::mozilla::detail::GkAtoms_Atoms = 1309;
            pub const GkAtoms_Atoms_feConvolveMatrix: root::mozilla::detail::GkAtoms_Atoms = 1310;
            pub const GkAtoms_Atoms_feDiffuseLighting: root::mozilla::detail::GkAtoms_Atoms = 1311;
            pub const GkAtoms_Atoms_feDisplacementMap: root::mozilla::detail::GkAtoms_Atoms = 1312;
            pub const GkAtoms_Atoms_feDistantLight: root::mozilla::detail::GkAtoms_Atoms = 1313;
            pub const GkAtoms_Atoms_feDropShadow: root::mozilla::detail::GkAtoms_Atoms = 1314;
            pub const GkAtoms_Atoms_feFlood: root::mozilla::detail::GkAtoms_Atoms = 1315;
            pub const GkAtoms_Atoms_feFuncA: root::mozilla::detail::GkAtoms_Atoms = 1316;
            pub const GkAtoms_Atoms_feFuncB: root::mozilla::detail::GkAtoms_Atoms = 1317;
            pub const GkAtoms_Atoms_feFuncG: root::mozilla::detail::GkAtoms_Atoms = 1318;
            pub const GkAtoms_Atoms_feFuncR: root::mozilla::detail::GkAtoms_Atoms = 1319;
            pub const GkAtoms_Atoms_feGaussianBlur: root::mozilla::detail::GkAtoms_Atoms = 1320;
            pub const GkAtoms_Atoms_feImage: root::mozilla::detail::GkAtoms_Atoms = 1321;
            pub const GkAtoms_Atoms_feMerge: root::mozilla::detail::GkAtoms_Atoms = 1322;
            pub const GkAtoms_Atoms_feMergeNode: root::mozilla::detail::GkAtoms_Atoms = 1323;
            pub const GkAtoms_Atoms_feMorphology: root::mozilla::detail::GkAtoms_Atoms = 1324;
            pub const GkAtoms_Atoms_feOffset: root::mozilla::detail::GkAtoms_Atoms = 1325;
            pub const GkAtoms_Atoms_fePointLight: root::mozilla::detail::GkAtoms_Atoms = 1326;
            pub const GkAtoms_Atoms_feSpecularLighting: root::mozilla::detail::GkAtoms_Atoms = 1327;
            pub const GkAtoms_Atoms_feSpotLight: root::mozilla::detail::GkAtoms_Atoms = 1328;
            pub const GkAtoms_Atoms_feTile: root::mozilla::detail::GkAtoms_Atoms = 1329;
            pub const GkAtoms_Atoms_feTurbulence: root::mozilla::detail::GkAtoms_Atoms = 1330;
            pub const GkAtoms_Atoms_fill: root::mozilla::detail::GkAtoms_Atoms = 1331;
            pub const GkAtoms_Atoms_fill_opacity: root::mozilla::detail::GkAtoms_Atoms = 1332;
            pub const GkAtoms_Atoms_fill_rule: root::mozilla::detail::GkAtoms_Atoms = 1333;
            pub const GkAtoms_Atoms_filter: root::mozilla::detail::GkAtoms_Atoms = 1334;
            pub const GkAtoms_Atoms_filterUnits: root::mozilla::detail::GkAtoms_Atoms = 1335;
            pub const GkAtoms_Atoms__float: root::mozilla::detail::GkAtoms_Atoms = 1336;
            pub const GkAtoms_Atoms_flood_color: root::mozilla::detail::GkAtoms_Atoms = 1337;
            pub const GkAtoms_Atoms_flood_opacity: root::mozilla::detail::GkAtoms_Atoms = 1338;
            pub const GkAtoms_Atoms_font_face: root::mozilla::detail::GkAtoms_Atoms = 1339;
            pub const GkAtoms_Atoms_font_face_format: root::mozilla::detail::GkAtoms_Atoms = 1340;
            pub const GkAtoms_Atoms_font_face_name: root::mozilla::detail::GkAtoms_Atoms = 1341;
            pub const GkAtoms_Atoms_font_face_src: root::mozilla::detail::GkAtoms_Atoms = 1342;
            pub const GkAtoms_Atoms_font_face_uri: root::mozilla::detail::GkAtoms_Atoms = 1343;
            pub const GkAtoms_Atoms_font_family: root::mozilla::detail::GkAtoms_Atoms = 1344;
            pub const GkAtoms_Atoms_font_size: root::mozilla::detail::GkAtoms_Atoms = 1345;
            pub const GkAtoms_Atoms_font_size_adjust: root::mozilla::detail::GkAtoms_Atoms = 1346;
            pub const GkAtoms_Atoms_font_stretch: root::mozilla::detail::GkAtoms_Atoms = 1347;
            pub const GkAtoms_Atoms_font_style: root::mozilla::detail::GkAtoms_Atoms = 1348;
            pub const GkAtoms_Atoms_font_variant: root::mozilla::detail::GkAtoms_Atoms = 1349;
            pub const GkAtoms_Atoms_foreignObject: root::mozilla::detail::GkAtoms_Atoms = 1350;
            pub const GkAtoms_Atoms_fractalNoise: root::mozilla::detail::GkAtoms_Atoms = 1351;
            pub const GkAtoms_Atoms_fr: root::mozilla::detail::GkAtoms_Atoms = 1352;
            pub const GkAtoms_Atoms_fx: root::mozilla::detail::GkAtoms_Atoms = 1353;
            pub const GkAtoms_Atoms_fy: root::mozilla::detail::GkAtoms_Atoms = 1354;
            pub const GkAtoms_Atoms_G: root::mozilla::detail::GkAtoms_Atoms = 1355;
            pub const GkAtoms_Atoms_g: root::mozilla::detail::GkAtoms_Atoms = 1356;
            pub const GkAtoms_Atoms_gamma: root::mozilla::detail::GkAtoms_Atoms = 1357;
            pub const GkAtoms_Atoms_generic_: root::mozilla::detail::GkAtoms_Atoms = 1358;
            pub const GkAtoms_Atoms_glyphRef: root::mozilla::detail::GkAtoms_Atoms = 1359;
            pub const GkAtoms_Atoms_grad: root::mozilla::detail::GkAtoms_Atoms = 1360;
            pub const GkAtoms_Atoms_gradientTransform: root::mozilla::detail::GkAtoms_Atoms = 1361;
            pub const GkAtoms_Atoms_gradientUnits: root::mozilla::detail::GkAtoms_Atoms = 1362;
            pub const GkAtoms_Atoms_hardLight: root::mozilla::detail::GkAtoms_Atoms = 1363;
            pub const GkAtoms_Atoms_hue: root::mozilla::detail::GkAtoms_Atoms = 1364;
            pub const GkAtoms_Atoms_hueRotate: root::mozilla::detail::GkAtoms_Atoms = 1365;
            pub const GkAtoms_Atoms_identity: root::mozilla::detail::GkAtoms_Atoms = 1366;
            pub const GkAtoms_Atoms_image_rendering: root::mozilla::detail::GkAtoms_Atoms = 1367;
            pub const GkAtoms_Atoms_in_: root::mozilla::detail::GkAtoms_Atoms = 1368;
            pub const GkAtoms_Atoms_in2: root::mozilla::detail::GkAtoms_Atoms = 1369;
            pub const GkAtoms_Atoms_intercept: root::mozilla::detail::GkAtoms_Atoms = 1370;
            pub const GkAtoms_Atoms_k1: root::mozilla::detail::GkAtoms_Atoms = 1371;
            pub const GkAtoms_Atoms_k2: root::mozilla::detail::GkAtoms_Atoms = 1372;
            pub const GkAtoms_Atoms_k3: root::mozilla::detail::GkAtoms_Atoms = 1373;
            pub const GkAtoms_Atoms_k4: root::mozilla::detail::GkAtoms_Atoms = 1374;
            pub const GkAtoms_Atoms_kernelMatrix: root::mozilla::detail::GkAtoms_Atoms = 1375;
            pub const GkAtoms_Atoms_kernelUnitLength: root::mozilla::detail::GkAtoms_Atoms = 1376;
            pub const GkAtoms_Atoms_lengthAdjust: root::mozilla::detail::GkAtoms_Atoms = 1377;
            pub const GkAtoms_Atoms_letter_spacing: root::mozilla::detail::GkAtoms_Atoms = 1378;
            pub const GkAtoms_Atoms_lighten: root::mozilla::detail::GkAtoms_Atoms = 1379;
            pub const GkAtoms_Atoms_lighting_color: root::mozilla::detail::GkAtoms_Atoms = 1380;
            pub const GkAtoms_Atoms_limitingConeAngle: root::mozilla::detail::GkAtoms_Atoms = 1381;
            pub const GkAtoms_Atoms_linear: root::mozilla::detail::GkAtoms_Atoms = 1382;
            pub const GkAtoms_Atoms_linearGradient: root::mozilla::detail::GkAtoms_Atoms = 1383;
            pub const GkAtoms_Atoms_list_item: root::mozilla::detail::GkAtoms_Atoms = 1384;
            pub const GkAtoms_Atoms_list_style_type: root::mozilla::detail::GkAtoms_Atoms = 1385;
            pub const GkAtoms_Atoms_luminanceToAlpha: root::mozilla::detail::GkAtoms_Atoms = 1386;
            pub const GkAtoms_Atoms_luminosity: root::mozilla::detail::GkAtoms_Atoms = 1387;
            pub const GkAtoms_Atoms_magnify: root::mozilla::detail::GkAtoms_Atoms = 1388;
            pub const GkAtoms_Atoms_marker: root::mozilla::detail::GkAtoms_Atoms = 1389;
            pub const GkAtoms_Atoms_marker_end: root::mozilla::detail::GkAtoms_Atoms = 1390;
            pub const GkAtoms_Atoms_marker_mid: root::mozilla::detail::GkAtoms_Atoms = 1391;
            pub const GkAtoms_Atoms_marker_start: root::mozilla::detail::GkAtoms_Atoms = 1392;
            pub const GkAtoms_Atoms_markerHeight: root::mozilla::detail::GkAtoms_Atoms = 1393;
            pub const GkAtoms_Atoms_markerUnits: root::mozilla::detail::GkAtoms_Atoms = 1394;
            pub const GkAtoms_Atoms_markerWidth: root::mozilla::detail::GkAtoms_Atoms = 1395;
            pub const GkAtoms_Atoms_mask: root::mozilla::detail::GkAtoms_Atoms = 1396;
            pub const GkAtoms_Atoms_maskContentUnits: root::mozilla::detail::GkAtoms_Atoms = 1397;
            pub const GkAtoms_Atoms_mask_type: root::mozilla::detail::GkAtoms_Atoms = 1398;
            pub const GkAtoms_Atoms_maskUnits: root::mozilla::detail::GkAtoms_Atoms = 1399;
            pub const GkAtoms_Atoms_matrix: root::mozilla::detail::GkAtoms_Atoms = 1400;
            pub const GkAtoms_Atoms_metadata: root::mozilla::detail::GkAtoms_Atoms = 1401;
            pub const GkAtoms_Atoms_missingGlyph: root::mozilla::detail::GkAtoms_Atoms = 1402;
            pub const GkAtoms_Atoms_mm: root::mozilla::detail::GkAtoms_Atoms = 1403;
            pub const GkAtoms_Atoms_mpath: root::mozilla::detail::GkAtoms_Atoms = 1404;
            pub const GkAtoms_Atoms_noStitch: root::mozilla::detail::GkAtoms_Atoms = 1405;
            pub const GkAtoms_Atoms_numOctaves: root::mozilla::detail::GkAtoms_Atoms = 1406;
            pub const GkAtoms_Atoms_multiply: root::mozilla::detail::GkAtoms_Atoms = 1407;
            pub const GkAtoms_Atoms_objectBoundingBox: root::mozilla::detail::GkAtoms_Atoms = 1408;
            pub const GkAtoms_Atoms_offset: root::mozilla::detail::GkAtoms_Atoms = 1409;
            pub const GkAtoms_Atoms_onSVGLoad: root::mozilla::detail::GkAtoms_Atoms = 1410;
            pub const GkAtoms_Atoms_onSVGResize: root::mozilla::detail::GkAtoms_Atoms = 1411;
            pub const GkAtoms_Atoms_onSVGScroll: root::mozilla::detail::GkAtoms_Atoms = 1412;
            pub const GkAtoms_Atoms_onSVGUnload: root::mozilla::detail::GkAtoms_Atoms = 1413;
            pub const GkAtoms_Atoms_onSVGZoom: root::mozilla::detail::GkAtoms_Atoms = 1414;
            pub const GkAtoms_Atoms_onzoom: root::mozilla::detail::GkAtoms_Atoms = 1415;
            pub const GkAtoms_Atoms_opacity: root::mozilla::detail::GkAtoms_Atoms = 1416;
            pub const GkAtoms_Atoms__operator: root::mozilla::detail::GkAtoms_Atoms = 1417;
            pub const GkAtoms_Atoms_out: root::mozilla::detail::GkAtoms_Atoms = 1418;
            pub const GkAtoms_Atoms_over: root::mozilla::detail::GkAtoms_Atoms = 1419;
            pub const GkAtoms_Atoms_overridePreserveAspectRatio:
                root::mozilla::detail::GkAtoms_Atoms = 1420;
            pub const GkAtoms_Atoms_pad: root::mozilla::detail::GkAtoms_Atoms = 1421;
            pub const GkAtoms_Atoms_path: root::mozilla::detail::GkAtoms_Atoms = 1422;
            pub const GkAtoms_Atoms_pathLength: root::mozilla::detail::GkAtoms_Atoms = 1423;
            pub const GkAtoms_Atoms_patternContentUnits: root::mozilla::detail::GkAtoms_Atoms =
                1424;
            pub const GkAtoms_Atoms_patternTransform: root::mozilla::detail::GkAtoms_Atoms = 1425;
            pub const GkAtoms_Atoms_patternUnits: root::mozilla::detail::GkAtoms_Atoms = 1426;
            pub const GkAtoms_Atoms_pc: root::mozilla::detail::GkAtoms_Atoms = 1427;
            pub const GkAtoms_Atoms_pointer: root::mozilla::detail::GkAtoms_Atoms = 1428;
            pub const GkAtoms_Atoms_pointer_events: root::mozilla::detail::GkAtoms_Atoms = 1429;
            pub const GkAtoms_Atoms_points: root::mozilla::detail::GkAtoms_Atoms = 1430;
            pub const GkAtoms_Atoms_pointsAtX: root::mozilla::detail::GkAtoms_Atoms = 1431;
            pub const GkAtoms_Atoms_pointsAtY: root::mozilla::detail::GkAtoms_Atoms = 1432;
            pub const GkAtoms_Atoms_pointsAtZ: root::mozilla::detail::GkAtoms_Atoms = 1433;
            pub const GkAtoms_Atoms_polyline: root::mozilla::detail::GkAtoms_Atoms = 1434;
            pub const GkAtoms_Atoms_preserveAlpha: root::mozilla::detail::GkAtoms_Atoms = 1435;
            pub const GkAtoms_Atoms_preserveAspectRatio: root::mozilla::detail::GkAtoms_Atoms =
                1436;
            pub const GkAtoms_Atoms_primitiveUnits: root::mozilla::detail::GkAtoms_Atoms = 1437;
            pub const GkAtoms_Atoms_pt: root::mozilla::detail::GkAtoms_Atoms = 1438;
            pub const GkAtoms_Atoms_px: root::mozilla::detail::GkAtoms_Atoms = 1439;
            pub const GkAtoms_Atoms_R: root::mozilla::detail::GkAtoms_Atoms = 1440;
            pub const GkAtoms_Atoms_r: root::mozilla::detail::GkAtoms_Atoms = 1441;
            pub const GkAtoms_Atoms_rad: root::mozilla::detail::GkAtoms_Atoms = 1442;
            pub const GkAtoms_Atoms_radialGradient: root::mozilla::detail::GkAtoms_Atoms = 1443;
            pub const GkAtoms_Atoms_radius: root::mozilla::detail::GkAtoms_Atoms = 1444;
            pub const GkAtoms_Atoms_reflect: root::mozilla::detail::GkAtoms_Atoms = 1445;
            pub const GkAtoms_Atoms_refX: root::mozilla::detail::GkAtoms_Atoms = 1446;
            pub const GkAtoms_Atoms_refY: root::mozilla::detail::GkAtoms_Atoms = 1447;
            pub const GkAtoms_Atoms_requiredExtensions: root::mozilla::detail::GkAtoms_Atoms = 1448;
            pub const GkAtoms_Atoms_requiredFeatures: root::mozilla::detail::GkAtoms_Atoms = 1449;
            pub const GkAtoms_Atoms_rotate: root::mozilla::detail::GkAtoms_Atoms = 1450;
            pub const GkAtoms_Atoms_rx: root::mozilla::detail::GkAtoms_Atoms = 1451;
            pub const GkAtoms_Atoms_ry: root::mozilla::detail::GkAtoms_Atoms = 1452;
            pub const GkAtoms_Atoms_saturate: root::mozilla::detail::GkAtoms_Atoms = 1453;
            pub const GkAtoms_Atoms_saturation: root::mozilla::detail::GkAtoms_Atoms = 1454;
            pub const GkAtoms_Atoms_set: root::mozilla::detail::GkAtoms_Atoms = 1455;
            pub const GkAtoms_Atoms_seed: root::mozilla::detail::GkAtoms_Atoms = 1456;
            pub const GkAtoms_Atoms_shape_rendering: root::mozilla::detail::GkAtoms_Atoms = 1457;
            pub const GkAtoms_Atoms_simpleScopeChain: root::mozilla::detail::GkAtoms_Atoms = 1458;
            pub const GkAtoms_Atoms_skewX: root::mozilla::detail::GkAtoms_Atoms = 1459;
            pub const GkAtoms_Atoms_skewY: root::mozilla::detail::GkAtoms_Atoms = 1460;
            pub const GkAtoms_Atoms_slope: root::mozilla::detail::GkAtoms_Atoms = 1461;
            pub const GkAtoms_Atoms_slot: root::mozilla::detail::GkAtoms_Atoms = 1462;
            pub const GkAtoms_Atoms_softLight: root::mozilla::detail::GkAtoms_Atoms = 1463;
            pub const GkAtoms_Atoms_spacing: root::mozilla::detail::GkAtoms_Atoms = 1464;
            pub const GkAtoms_Atoms_spacingAndGlyphs: root::mozilla::detail::GkAtoms_Atoms = 1465;
            pub const GkAtoms_Atoms_specularConstant: root::mozilla::detail::GkAtoms_Atoms = 1466;
            pub const GkAtoms_Atoms_specularExponent: root::mozilla::detail::GkAtoms_Atoms = 1467;
            pub const GkAtoms_Atoms_spreadMethod: root::mozilla::detail::GkAtoms_Atoms = 1468;
            pub const GkAtoms_Atoms_startOffset: root::mozilla::detail::GkAtoms_Atoms = 1469;
            pub const GkAtoms_Atoms_stdDeviation: root::mozilla::detail::GkAtoms_Atoms = 1470;
            pub const GkAtoms_Atoms_stitch: root::mozilla::detail::GkAtoms_Atoms = 1471;
            pub const GkAtoms_Atoms_stitchTiles: root::mozilla::detail::GkAtoms_Atoms = 1472;
            pub const GkAtoms_Atoms_stop_color: root::mozilla::detail::GkAtoms_Atoms = 1473;
            pub const GkAtoms_Atoms_stop_opacity: root::mozilla::detail::GkAtoms_Atoms = 1474;
            pub const GkAtoms_Atoms_stroke: root::mozilla::detail::GkAtoms_Atoms = 1475;
            pub const GkAtoms_Atoms_stroke_dasharray: root::mozilla::detail::GkAtoms_Atoms = 1476;
            pub const GkAtoms_Atoms_stroke_dashoffset: root::mozilla::detail::GkAtoms_Atoms = 1477;
            pub const GkAtoms_Atoms_stroke_linecap: root::mozilla::detail::GkAtoms_Atoms = 1478;
            pub const GkAtoms_Atoms_stroke_linejoin: root::mozilla::detail::GkAtoms_Atoms = 1479;
            pub const GkAtoms_Atoms_stroke_miterlimit: root::mozilla::detail::GkAtoms_Atoms = 1480;
            pub const GkAtoms_Atoms_stroke_opacity: root::mozilla::detail::GkAtoms_Atoms = 1481;
            pub const GkAtoms_Atoms_stroke_width: root::mozilla::detail::GkAtoms_Atoms = 1482;
            pub const GkAtoms_Atoms_strokeWidth: root::mozilla::detail::GkAtoms_Atoms = 1483;
            pub const GkAtoms_Atoms_surfaceScale: root::mozilla::detail::GkAtoms_Atoms = 1484;
            pub const GkAtoms_Atoms_svg: root::mozilla::detail::GkAtoms_Atoms = 1485;
            pub const GkAtoms_Atoms_svgSwitch: root::mozilla::detail::GkAtoms_Atoms = 1486;
            pub const GkAtoms_Atoms_symbol: root::mozilla::detail::GkAtoms_Atoms = 1487;
            pub const GkAtoms_Atoms_systemLanguage: root::mozilla::detail::GkAtoms_Atoms = 1488;
            pub const GkAtoms_Atoms_tableValues: root::mozilla::detail::GkAtoms_Atoms = 1489;
            pub const GkAtoms_Atoms_targetX: root::mozilla::detail::GkAtoms_Atoms = 1490;
            pub const GkAtoms_Atoms_targetY: root::mozilla::detail::GkAtoms_Atoms = 1491;
            pub const GkAtoms_Atoms_text_anchor: root::mozilla::detail::GkAtoms_Atoms = 1492;
            pub const GkAtoms_Atoms_text_rendering: root::mozilla::detail::GkAtoms_Atoms = 1493;
            pub const GkAtoms_Atoms_textLength: root::mozilla::detail::GkAtoms_Atoms = 1494;
            pub const GkAtoms_Atoms_textPath: root::mozilla::detail::GkAtoms_Atoms = 1495;
            pub const GkAtoms_Atoms_tref: root::mozilla::detail::GkAtoms_Atoms = 1496;
            pub const GkAtoms_Atoms_tspan: root::mozilla::detail::GkAtoms_Atoms = 1497;
            pub const GkAtoms_Atoms_turbulence: root::mozilla::detail::GkAtoms_Atoms = 1498;
            pub const GkAtoms_Atoms_unicode_bidi: root::mozilla::detail::GkAtoms_Atoms = 1499;
            pub const GkAtoms_Atoms_userSpaceOnUse: root::mozilla::detail::GkAtoms_Atoms = 1500;
            pub const GkAtoms_Atoms_view: root::mozilla::detail::GkAtoms_Atoms = 1501;
            pub const GkAtoms_Atoms_viewBox: root::mozilla::detail::GkAtoms_Atoms = 1502;
            pub const GkAtoms_Atoms_viewTarget: root::mozilla::detail::GkAtoms_Atoms = 1503;
            pub const GkAtoms_Atoms_white_space: root::mozilla::detail::GkAtoms_Atoms = 1504;
            pub const GkAtoms_Atoms_word_spacing: root::mozilla::detail::GkAtoms_Atoms = 1505;
            pub const GkAtoms_Atoms_writing_mode: root::mozilla::detail::GkAtoms_Atoms = 1506;
            pub const GkAtoms_Atoms_x: root::mozilla::detail::GkAtoms_Atoms = 1507;
            pub const GkAtoms_Atoms_x1: root::mozilla::detail::GkAtoms_Atoms = 1508;
            pub const GkAtoms_Atoms_x2: root::mozilla::detail::GkAtoms_Atoms = 1509;
            pub const GkAtoms_Atoms_xChannelSelector: root::mozilla::detail::GkAtoms_Atoms = 1510;
            pub const GkAtoms_Atoms_xor_: root::mozilla::detail::GkAtoms_Atoms = 1511;
            pub const GkAtoms_Atoms_y: root::mozilla::detail::GkAtoms_Atoms = 1512;
            pub const GkAtoms_Atoms_y1: root::mozilla::detail::GkAtoms_Atoms = 1513;
            pub const GkAtoms_Atoms_y2: root::mozilla::detail::GkAtoms_Atoms = 1514;
            pub const GkAtoms_Atoms_yChannelSelector: root::mozilla::detail::GkAtoms_Atoms = 1515;
            pub const GkAtoms_Atoms_z: root::mozilla::detail::GkAtoms_Atoms = 1516;
            pub const GkAtoms_Atoms_zoomAndPan: root::mozilla::detail::GkAtoms_Atoms = 1517;
            pub const GkAtoms_Atoms_vector_effect: root::mozilla::detail::GkAtoms_Atoms = 1518;
            pub const GkAtoms_Atoms_vertical_align: root::mozilla::detail::GkAtoms_Atoms = 1519;
            pub const GkAtoms_Atoms_accumulate: root::mozilla::detail::GkAtoms_Atoms = 1520;
            pub const GkAtoms_Atoms_additive: root::mozilla::detail::GkAtoms_Atoms = 1521;
            pub const GkAtoms_Atoms_attributeName: root::mozilla::detail::GkAtoms_Atoms = 1522;
            pub const GkAtoms_Atoms_attributeType: root::mozilla::detail::GkAtoms_Atoms = 1523;
            pub const GkAtoms_Atoms_auto_reverse: root::mozilla::detail::GkAtoms_Atoms = 1524;
            pub const GkAtoms_Atoms_begin: root::mozilla::detail::GkAtoms_Atoms = 1525;
            pub const GkAtoms_Atoms_beginEvent: root::mozilla::detail::GkAtoms_Atoms = 1526;
            pub const GkAtoms_Atoms_by: root::mozilla::detail::GkAtoms_Atoms = 1527;
            pub const GkAtoms_Atoms_calcMode: root::mozilla::detail::GkAtoms_Atoms = 1528;
            pub const GkAtoms_Atoms_dur: root::mozilla::detail::GkAtoms_Atoms = 1529;
            pub const GkAtoms_Atoms_keyPoints: root::mozilla::detail::GkAtoms_Atoms = 1530;
            pub const GkAtoms_Atoms_keySplines: root::mozilla::detail::GkAtoms_Atoms = 1531;
            pub const GkAtoms_Atoms_keyTimes: root::mozilla::detail::GkAtoms_Atoms = 1532;
            pub const GkAtoms_Atoms_mozAnimateMotionDummyAttr:
                root::mozilla::detail::GkAtoms_Atoms = 1533;
            pub const GkAtoms_Atoms_onbegin: root::mozilla::detail::GkAtoms_Atoms = 1534;
            pub const GkAtoms_Atoms_onbeginEvent: root::mozilla::detail::GkAtoms_Atoms = 1535;
            pub const GkAtoms_Atoms_onend: root::mozilla::detail::GkAtoms_Atoms = 1536;
            pub const GkAtoms_Atoms_onendEvent: root::mozilla::detail::GkAtoms_Atoms = 1537;
            pub const GkAtoms_Atoms_onrepeat: root::mozilla::detail::GkAtoms_Atoms = 1538;
            pub const GkAtoms_Atoms_onrepeatEvent: root::mozilla::detail::GkAtoms_Atoms = 1539;
            pub const GkAtoms_Atoms_repeatCount: root::mozilla::detail::GkAtoms_Atoms = 1540;
            pub const GkAtoms_Atoms_repeatDur: root::mozilla::detail::GkAtoms_Atoms = 1541;
            pub const GkAtoms_Atoms_repeatEvent: root::mozilla::detail::GkAtoms_Atoms = 1542;
            pub const GkAtoms_Atoms_restart: root::mozilla::detail::GkAtoms_Atoms = 1543;
            pub const GkAtoms_Atoms_to: root::mozilla::detail::GkAtoms_Atoms = 1544;
            pub const GkAtoms_Atoms_abs_: root::mozilla::detail::GkAtoms_Atoms = 1545;
            pub const GkAtoms_Atoms_accent_: root::mozilla::detail::GkAtoms_Atoms = 1546;
            pub const GkAtoms_Atoms_accentunder_: root::mozilla::detail::GkAtoms_Atoms = 1547;
            pub const GkAtoms_Atoms_actiontype_: root::mozilla::detail::GkAtoms_Atoms = 1548;
            pub const GkAtoms_Atoms_alignmentscope_: root::mozilla::detail::GkAtoms_Atoms = 1549;
            pub const GkAtoms_Atoms_altimg_: root::mozilla::detail::GkAtoms_Atoms = 1550;
            pub const GkAtoms_Atoms_altimg_height_: root::mozilla::detail::GkAtoms_Atoms = 1551;
            pub const GkAtoms_Atoms_altimg_valign_: root::mozilla::detail::GkAtoms_Atoms = 1552;
            pub const GkAtoms_Atoms_altimg_width_: root::mozilla::detail::GkAtoms_Atoms = 1553;
            pub const GkAtoms_Atoms_annotation_: root::mozilla::detail::GkAtoms_Atoms = 1554;
            pub const GkAtoms_Atoms_annotation_xml_: root::mozilla::detail::GkAtoms_Atoms = 1555;
            pub const GkAtoms_Atoms_apply_: root::mozilla::detail::GkAtoms_Atoms = 1556;
            pub const GkAtoms_Atoms_approx_: root::mozilla::detail::GkAtoms_Atoms = 1557;
            pub const GkAtoms_Atoms_arccos_: root::mozilla::detail::GkAtoms_Atoms = 1558;
            pub const GkAtoms_Atoms_arccosh_: root::mozilla::detail::GkAtoms_Atoms = 1559;
            pub const GkAtoms_Atoms_arccot_: root::mozilla::detail::GkAtoms_Atoms = 1560;
            pub const GkAtoms_Atoms_arccoth_: root::mozilla::detail::GkAtoms_Atoms = 1561;
            pub const GkAtoms_Atoms_arccsc_: root::mozilla::detail::GkAtoms_Atoms = 1562;
            pub const GkAtoms_Atoms_arccsch_: root::mozilla::detail::GkAtoms_Atoms = 1563;
            pub const GkAtoms_Atoms_arcsec_: root::mozilla::detail::GkAtoms_Atoms = 1564;
            pub const GkAtoms_Atoms_arcsech_: root::mozilla::detail::GkAtoms_Atoms = 1565;
            pub const GkAtoms_Atoms_arcsin_: root::mozilla::detail::GkAtoms_Atoms = 1566;
            pub const GkAtoms_Atoms_arcsinh_: root::mozilla::detail::GkAtoms_Atoms = 1567;
            pub const GkAtoms_Atoms_arctan_: root::mozilla::detail::GkAtoms_Atoms = 1568;
            pub const GkAtoms_Atoms_arctanh_: root::mozilla::detail::GkAtoms_Atoms = 1569;
            pub const GkAtoms_Atoms_arg_: root::mozilla::detail::GkAtoms_Atoms = 1570;
            pub const GkAtoms_Atoms_bevelled_: root::mozilla::detail::GkAtoms_Atoms = 1571;
            pub const GkAtoms_Atoms_bind_: root::mozilla::detail::GkAtoms_Atoms = 1572;
            pub const GkAtoms_Atoms_bvar_: root::mozilla::detail::GkAtoms_Atoms = 1573;
            pub const GkAtoms_Atoms_card_: root::mozilla::detail::GkAtoms_Atoms = 1574;
            pub const GkAtoms_Atoms_cartesianproduct_: root::mozilla::detail::GkAtoms_Atoms = 1575;
            pub const GkAtoms_Atoms_cbytes_: root::mozilla::detail::GkAtoms_Atoms = 1576;
            pub const GkAtoms_Atoms_cd_: root::mozilla::detail::GkAtoms_Atoms = 1577;
            pub const GkAtoms_Atoms_cdgroup_: root::mozilla::detail::GkAtoms_Atoms = 1578;
            pub const GkAtoms_Atoms_cerror_: root::mozilla::detail::GkAtoms_Atoms = 1579;
            pub const GkAtoms_Atoms_charalign_: root::mozilla::detail::GkAtoms_Atoms = 1580;
            pub const GkAtoms_Atoms_ci_: root::mozilla::detail::GkAtoms_Atoms = 1581;
            pub const GkAtoms_Atoms_closure_: root::mozilla::detail::GkAtoms_Atoms = 1582;
            pub const GkAtoms_Atoms_cn_: root::mozilla::detail::GkAtoms_Atoms = 1583;
            pub const GkAtoms_Atoms_codomain_: root::mozilla::detail::GkAtoms_Atoms = 1584;
            pub const GkAtoms_Atoms_columnalign_: root::mozilla::detail::GkAtoms_Atoms = 1585;
            pub const GkAtoms_Atoms_columnalignment_: root::mozilla::detail::GkAtoms_Atoms = 1586;
            pub const GkAtoms_Atoms_columnlines_: root::mozilla::detail::GkAtoms_Atoms = 1587;
            pub const GkAtoms_Atoms_columnspacing_: root::mozilla::detail::GkAtoms_Atoms = 1588;
            pub const GkAtoms_Atoms_columnspan_: root::mozilla::detail::GkAtoms_Atoms = 1589;
            pub const GkAtoms_Atoms_columnwidth_: root::mozilla::detail::GkAtoms_Atoms = 1590;
            pub const GkAtoms_Atoms_complexes_: root::mozilla::detail::GkAtoms_Atoms = 1591;
            pub const GkAtoms_Atoms_compose_: root::mozilla::detail::GkAtoms_Atoms = 1592;
            pub const GkAtoms_Atoms_condition_: root::mozilla::detail::GkAtoms_Atoms = 1593;
            pub const GkAtoms_Atoms_conjugate_: root::mozilla::detail::GkAtoms_Atoms = 1594;
            pub const GkAtoms_Atoms_cos_: root::mozilla::detail::GkAtoms_Atoms = 1595;
            pub const GkAtoms_Atoms_cosh_: root::mozilla::detail::GkAtoms_Atoms = 1596;
            pub const GkAtoms_Atoms_cot_: root::mozilla::detail::GkAtoms_Atoms = 1597;
            pub const GkAtoms_Atoms_coth_: root::mozilla::detail::GkAtoms_Atoms = 1598;
            pub const GkAtoms_Atoms_crossout_: root::mozilla::detail::GkAtoms_Atoms = 1599;
            pub const GkAtoms_Atoms_csc_: root::mozilla::detail::GkAtoms_Atoms = 1600;
            pub const GkAtoms_Atoms_csch_: root::mozilla::detail::GkAtoms_Atoms = 1601;
            pub const GkAtoms_Atoms_cs_: root::mozilla::detail::GkAtoms_Atoms = 1602;
            pub const GkAtoms_Atoms_csymbol_: root::mozilla::detail::GkAtoms_Atoms = 1603;
            pub const GkAtoms_Atoms_curl_: root::mozilla::detail::GkAtoms_Atoms = 1604;
            pub const GkAtoms_Atoms_decimalpoint_: root::mozilla::detail::GkAtoms_Atoms = 1605;
            pub const GkAtoms_Atoms_definitionURL_: root::mozilla::detail::GkAtoms_Atoms = 1606;
            pub const GkAtoms_Atoms_degree_: root::mozilla::detail::GkAtoms_Atoms = 1607;
            pub const GkAtoms_Atoms_denomalign_: root::mozilla::detail::GkAtoms_Atoms = 1608;
            pub const GkAtoms_Atoms_depth_: root::mozilla::detail::GkAtoms_Atoms = 1609;
            pub const GkAtoms_Atoms_determinant_: root::mozilla::detail::GkAtoms_Atoms = 1610;
            pub const GkAtoms_Atoms_diff_: root::mozilla::detail::GkAtoms_Atoms = 1611;
            pub const GkAtoms_Atoms_displaystyle_: root::mozilla::detail::GkAtoms_Atoms = 1612;
            pub const GkAtoms_Atoms_divergence_: root::mozilla::detail::GkAtoms_Atoms = 1613;
            pub const GkAtoms_Atoms_divide_: root::mozilla::detail::GkAtoms_Atoms = 1614;
            pub const GkAtoms_Atoms_domain_: root::mozilla::detail::GkAtoms_Atoms = 1615;
            pub const GkAtoms_Atoms_domainofapplication_: root::mozilla::detail::GkAtoms_Atoms =
                1616;
            pub const GkAtoms_Atoms_edge_: root::mozilla::detail::GkAtoms_Atoms = 1617;
            pub const GkAtoms_Atoms_el: root::mozilla::detail::GkAtoms_Atoms = 1618;
            pub const GkAtoms_Atoms_emptyset_: root::mozilla::detail::GkAtoms_Atoms = 1619;
            pub const GkAtoms_Atoms_eq_: root::mozilla::detail::GkAtoms_Atoms = 1620;
            pub const GkAtoms_Atoms_equalcolumns_: root::mozilla::detail::GkAtoms_Atoms = 1621;
            pub const GkAtoms_Atoms_equalrows_: root::mozilla::detail::GkAtoms_Atoms = 1622;
            pub const GkAtoms_Atoms_equivalent_: root::mozilla::detail::GkAtoms_Atoms = 1623;
            pub const GkAtoms_Atoms_eulergamma_: root::mozilla::detail::GkAtoms_Atoms = 1624;
            pub const GkAtoms_Atoms_exists_: root::mozilla::detail::GkAtoms_Atoms = 1625;
            pub const GkAtoms_Atoms_exp_: root::mozilla::detail::GkAtoms_Atoms = 1626;
            pub const GkAtoms_Atoms_exponentiale_: root::mozilla::detail::GkAtoms_Atoms = 1627;
            pub const GkAtoms_Atoms_factorial_: root::mozilla::detail::GkAtoms_Atoms = 1628;
            pub const GkAtoms_Atoms_factorof_: root::mozilla::detail::GkAtoms_Atoms = 1629;
            pub const GkAtoms_Atoms_fence_: root::mozilla::detail::GkAtoms_Atoms = 1630;
            pub const GkAtoms_Atoms_fn_: root::mozilla::detail::GkAtoms_Atoms = 1631;
            pub const GkAtoms_Atoms_fontfamily_: root::mozilla::detail::GkAtoms_Atoms = 1632;
            pub const GkAtoms_Atoms_fontsize_: root::mozilla::detail::GkAtoms_Atoms = 1633;
            pub const GkAtoms_Atoms_fontstyle_: root::mozilla::detail::GkAtoms_Atoms = 1634;
            pub const GkAtoms_Atoms_fontweight_: root::mozilla::detail::GkAtoms_Atoms = 1635;
            pub const GkAtoms_Atoms_forall_: root::mozilla::detail::GkAtoms_Atoms = 1636;
            pub const GkAtoms_Atoms_framespacing_: root::mozilla::detail::GkAtoms_Atoms = 1637;
            pub const GkAtoms_Atoms_gcd_: root::mozilla::detail::GkAtoms_Atoms = 1638;
            pub const GkAtoms_Atoms_geq_: root::mozilla::detail::GkAtoms_Atoms = 1639;
            pub const GkAtoms_Atoms_groupalign_: root::mozilla::detail::GkAtoms_Atoms = 1640;
            pub const GkAtoms_Atoms_gt_: root::mozilla::detail::GkAtoms_Atoms = 1641;
            pub const GkAtoms_Atoms_ident_: root::mozilla::detail::GkAtoms_Atoms = 1642;
            pub const GkAtoms_Atoms_imaginaryi_: root::mozilla::detail::GkAtoms_Atoms = 1643;
            pub const GkAtoms_Atoms_imaginary_: root::mozilla::detail::GkAtoms_Atoms = 1644;
            pub const GkAtoms_Atoms_implies_: root::mozilla::detail::GkAtoms_Atoms = 1645;
            pub const GkAtoms_Atoms_indentalignfirst_: root::mozilla::detail::GkAtoms_Atoms = 1646;
            pub const GkAtoms_Atoms_indentalign_: root::mozilla::detail::GkAtoms_Atoms = 1647;
            pub const GkAtoms_Atoms_indentalignlast_: root::mozilla::detail::GkAtoms_Atoms = 1648;
            pub const GkAtoms_Atoms_indentshiftfirst_: root::mozilla::detail::GkAtoms_Atoms = 1649;
            pub const GkAtoms_Atoms_indentshift_: root::mozilla::detail::GkAtoms_Atoms = 1650;
            pub const GkAtoms_Atoms_indenttarget_: root::mozilla::detail::GkAtoms_Atoms = 1651;
            pub const GkAtoms_Atoms_integers_: root::mozilla::detail::GkAtoms_Atoms = 1652;
            pub const GkAtoms_Atoms_intersect_: root::mozilla::detail::GkAtoms_Atoms = 1653;
            pub const GkAtoms_Atoms_interval_: root::mozilla::detail::GkAtoms_Atoms = 1654;
            pub const GkAtoms_Atoms_int_: root::mozilla::detail::GkAtoms_Atoms = 1655;
            pub const GkAtoms_Atoms_inverse_: root::mozilla::detail::GkAtoms_Atoms = 1656;
            pub const GkAtoms_Atoms_lambda_: root::mozilla::detail::GkAtoms_Atoms = 1657;
            pub const GkAtoms_Atoms_laplacian_: root::mozilla::detail::GkAtoms_Atoms = 1658;
            pub const GkAtoms_Atoms_largeop_: root::mozilla::detail::GkAtoms_Atoms = 1659;
            pub const GkAtoms_Atoms_lcm_: root::mozilla::detail::GkAtoms_Atoms = 1660;
            pub const GkAtoms_Atoms_leq_: root::mozilla::detail::GkAtoms_Atoms = 1661;
            pub const GkAtoms_Atoms_limit_: root::mozilla::detail::GkAtoms_Atoms = 1662;
            pub const GkAtoms_Atoms_linebreak_: root::mozilla::detail::GkAtoms_Atoms = 1663;
            pub const GkAtoms_Atoms_linebreakmultchar_: root::mozilla::detail::GkAtoms_Atoms = 1664;
            pub const GkAtoms_Atoms_linebreakstyle_: root::mozilla::detail::GkAtoms_Atoms = 1665;
            pub const GkAtoms_Atoms_linethickness_: root::mozilla::detail::GkAtoms_Atoms = 1666;
            pub const GkAtoms_Atoms_list_: root::mozilla::detail::GkAtoms_Atoms = 1667;
            pub const GkAtoms_Atoms_ln_: root::mozilla::detail::GkAtoms_Atoms = 1668;
            pub const GkAtoms_Atoms_location_: root::mozilla::detail::GkAtoms_Atoms = 1669;
            pub const GkAtoms_Atoms_logbase_: root::mozilla::detail::GkAtoms_Atoms = 1670;
            pub const GkAtoms_Atoms_log_: root::mozilla::detail::GkAtoms_Atoms = 1671;
            pub const GkAtoms_Atoms_longdivstyle_: root::mozilla::detail::GkAtoms_Atoms = 1672;
            pub const GkAtoms_Atoms_lowlimit_: root::mozilla::detail::GkAtoms_Atoms = 1673;
            pub const GkAtoms_Atoms_lquote_: root::mozilla::detail::GkAtoms_Atoms = 1674;
            pub const GkAtoms_Atoms_lspace_: root::mozilla::detail::GkAtoms_Atoms = 1675;
            pub const GkAtoms_Atoms_lt_: root::mozilla::detail::GkAtoms_Atoms = 1676;
            pub const GkAtoms_Atoms_maction_: root::mozilla::detail::GkAtoms_Atoms = 1677;
            pub const GkAtoms_Atoms_maligngroup_: root::mozilla::detail::GkAtoms_Atoms = 1678;
            pub const GkAtoms_Atoms_malignmark_: root::mozilla::detail::GkAtoms_Atoms = 1679;
            pub const GkAtoms_Atoms_mathbackground_: root::mozilla::detail::GkAtoms_Atoms = 1680;
            pub const GkAtoms_Atoms_mathcolor_: root::mozilla::detail::GkAtoms_Atoms = 1681;
            pub const GkAtoms_Atoms_mathsize_: root::mozilla::detail::GkAtoms_Atoms = 1682;
            pub const GkAtoms_Atoms_mathvariant_: root::mozilla::detail::GkAtoms_Atoms = 1683;
            pub const GkAtoms_Atoms_matrixrow_: root::mozilla::detail::GkAtoms_Atoms = 1684;
            pub const GkAtoms_Atoms_maxsize_: root::mozilla::detail::GkAtoms_Atoms = 1685;
            pub const GkAtoms_Atoms_mean_: root::mozilla::detail::GkAtoms_Atoms = 1686;
            pub const GkAtoms_Atoms_median_: root::mozilla::detail::GkAtoms_Atoms = 1687;
            pub const GkAtoms_Atoms_menclose_: root::mozilla::detail::GkAtoms_Atoms = 1688;
            pub const GkAtoms_Atoms_merror_: root::mozilla::detail::GkAtoms_Atoms = 1689;
            pub const GkAtoms_Atoms_mfenced_: root::mozilla::detail::GkAtoms_Atoms = 1690;
            pub const GkAtoms_Atoms_mfrac_: root::mozilla::detail::GkAtoms_Atoms = 1691;
            pub const GkAtoms_Atoms_mglyph_: root::mozilla::detail::GkAtoms_Atoms = 1692;
            pub const GkAtoms_Atoms_mi_: root::mozilla::detail::GkAtoms_Atoms = 1693;
            pub const GkAtoms_Atoms_minlabelspacing_: root::mozilla::detail::GkAtoms_Atoms = 1694;
            pub const GkAtoms_Atoms_minsize_: root::mozilla::detail::GkAtoms_Atoms = 1695;
            pub const GkAtoms_Atoms_minus_: root::mozilla::detail::GkAtoms_Atoms = 1696;
            pub const GkAtoms_Atoms_mlabeledtr_: root::mozilla::detail::GkAtoms_Atoms = 1697;
            pub const GkAtoms_Atoms_mlongdiv_: root::mozilla::detail::GkAtoms_Atoms = 1698;
            pub const GkAtoms_Atoms_mmultiscripts_: root::mozilla::detail::GkAtoms_Atoms = 1699;
            pub const GkAtoms_Atoms_mn_: root::mozilla::detail::GkAtoms_Atoms = 1700;
            pub const GkAtoms_Atoms_momentabout_: root::mozilla::detail::GkAtoms_Atoms = 1701;
            pub const GkAtoms_Atoms_moment_: root::mozilla::detail::GkAtoms_Atoms = 1702;
            pub const GkAtoms_Atoms_mo_: root::mozilla::detail::GkAtoms_Atoms = 1703;
            pub const GkAtoms_Atoms_movablelimits_: root::mozilla::detail::GkAtoms_Atoms = 1704;
            pub const GkAtoms_Atoms_mover_: root::mozilla::detail::GkAtoms_Atoms = 1705;
            pub const GkAtoms_Atoms_mpadded_: root::mozilla::detail::GkAtoms_Atoms = 1706;
            pub const GkAtoms_Atoms_mphantom_: root::mozilla::detail::GkAtoms_Atoms = 1707;
            pub const GkAtoms_Atoms_mprescripts_: root::mozilla::detail::GkAtoms_Atoms = 1708;
            pub const GkAtoms_Atoms_mroot_: root::mozilla::detail::GkAtoms_Atoms = 1709;
            pub const GkAtoms_Atoms_mrow_: root::mozilla::detail::GkAtoms_Atoms = 1710;
            pub const GkAtoms_Atoms_mscarries_: root::mozilla::detail::GkAtoms_Atoms = 1711;
            pub const GkAtoms_Atoms_mscarry_: root::mozilla::detail::GkAtoms_Atoms = 1712;
            pub const GkAtoms_Atoms_msgroup_: root::mozilla::detail::GkAtoms_Atoms = 1713;
            pub const GkAtoms_Atoms_msline_: root::mozilla::detail::GkAtoms_Atoms = 1714;
            pub const GkAtoms_Atoms_ms_: root::mozilla::detail::GkAtoms_Atoms = 1715;
            pub const GkAtoms_Atoms_mspace_: root::mozilla::detail::GkAtoms_Atoms = 1716;
            pub const GkAtoms_Atoms_msqrt_: root::mozilla::detail::GkAtoms_Atoms = 1717;
            pub const GkAtoms_Atoms_msrow_: root::mozilla::detail::GkAtoms_Atoms = 1718;
            pub const GkAtoms_Atoms_mstack_: root::mozilla::detail::GkAtoms_Atoms = 1719;
            pub const GkAtoms_Atoms_mstyle_: root::mozilla::detail::GkAtoms_Atoms = 1720;
            pub const GkAtoms_Atoms_msub_: root::mozilla::detail::GkAtoms_Atoms = 1721;
            pub const GkAtoms_Atoms_msubsup_: root::mozilla::detail::GkAtoms_Atoms = 1722;
            pub const GkAtoms_Atoms_msup_: root::mozilla::detail::GkAtoms_Atoms = 1723;
            pub const GkAtoms_Atoms_mtable_: root::mozilla::detail::GkAtoms_Atoms = 1724;
            pub const GkAtoms_Atoms_mtd_: root::mozilla::detail::GkAtoms_Atoms = 1725;
            pub const GkAtoms_Atoms_mtext_: root::mozilla::detail::GkAtoms_Atoms = 1726;
            pub const GkAtoms_Atoms_mtr_: root::mozilla::detail::GkAtoms_Atoms = 1727;
            pub const GkAtoms_Atoms_munder_: root::mozilla::detail::GkAtoms_Atoms = 1728;
            pub const GkAtoms_Atoms_munderover_: root::mozilla::detail::GkAtoms_Atoms = 1729;
            pub const GkAtoms_Atoms_naturalnumbers_: root::mozilla::detail::GkAtoms_Atoms = 1730;
            pub const GkAtoms_Atoms_neq_: root::mozilla::detail::GkAtoms_Atoms = 1731;
            pub const GkAtoms_Atoms_notanumber_: root::mozilla::detail::GkAtoms_Atoms = 1732;
            pub const GkAtoms_Atoms_notation_: root::mozilla::detail::GkAtoms_Atoms = 1733;
            pub const GkAtoms_Atoms_note_: root::mozilla::detail::GkAtoms_Atoms = 1734;
            pub const GkAtoms_Atoms_notin_: root::mozilla::detail::GkAtoms_Atoms = 1735;
            pub const GkAtoms_Atoms_notprsubset_: root::mozilla::detail::GkAtoms_Atoms = 1736;
            pub const GkAtoms_Atoms_notsubset_: root::mozilla::detail::GkAtoms_Atoms = 1737;
            pub const GkAtoms_Atoms_numalign_: root::mozilla::detail::GkAtoms_Atoms = 1738;
            pub const GkAtoms_Atoms_other: root::mozilla::detail::GkAtoms_Atoms = 1739;
            pub const GkAtoms_Atoms_outerproduct_: root::mozilla::detail::GkAtoms_Atoms = 1740;
            pub const GkAtoms_Atoms_partialdiff_: root::mozilla::detail::GkAtoms_Atoms = 1741;
            pub const GkAtoms_Atoms_piece_: root::mozilla::detail::GkAtoms_Atoms = 1742;
            pub const GkAtoms_Atoms_piecewise_: root::mozilla::detail::GkAtoms_Atoms = 1743;
            pub const GkAtoms_Atoms_pi_: root::mozilla::detail::GkAtoms_Atoms = 1744;
            pub const GkAtoms_Atoms_plus_: root::mozilla::detail::GkAtoms_Atoms = 1745;
            pub const GkAtoms_Atoms_power_: root::mozilla::detail::GkAtoms_Atoms = 1746;
            pub const GkAtoms_Atoms_primes_: root::mozilla::detail::GkAtoms_Atoms = 1747;
            pub const GkAtoms_Atoms_product_: root::mozilla::detail::GkAtoms_Atoms = 1748;
            pub const GkAtoms_Atoms_prsubset_: root::mozilla::detail::GkAtoms_Atoms = 1749;
            pub const GkAtoms_Atoms_quotient_: root::mozilla::detail::GkAtoms_Atoms = 1750;
            pub const GkAtoms_Atoms_rationals_: root::mozilla::detail::GkAtoms_Atoms = 1751;
            pub const GkAtoms_Atoms_real_: root::mozilla::detail::GkAtoms_Atoms = 1752;
            pub const GkAtoms_Atoms_reals_: root::mozilla::detail::GkAtoms_Atoms = 1753;
            pub const GkAtoms_Atoms_reln_: root::mozilla::detail::GkAtoms_Atoms = 1754;
            pub const GkAtoms_Atoms_root_: root::mozilla::detail::GkAtoms_Atoms = 1755;
            pub const GkAtoms_Atoms_rowalign_: root::mozilla::detail::GkAtoms_Atoms = 1756;
            pub const GkAtoms_Atoms_rowlines_: root::mozilla::detail::GkAtoms_Atoms = 1757;
            pub const GkAtoms_Atoms_rowspacing_: root::mozilla::detail::GkAtoms_Atoms = 1758;
            pub const GkAtoms_Atoms_rquote_: root::mozilla::detail::GkAtoms_Atoms = 1759;
            pub const GkAtoms_Atoms_rspace_: root::mozilla::detail::GkAtoms_Atoms = 1760;
            pub const GkAtoms_Atoms_scalarproduct_: root::mozilla::detail::GkAtoms_Atoms = 1761;
            pub const GkAtoms_Atoms_schemaLocation_: root::mozilla::detail::GkAtoms_Atoms = 1762;
            pub const GkAtoms_Atoms_scriptlevel_: root::mozilla::detail::GkAtoms_Atoms = 1763;
            pub const GkAtoms_Atoms_scriptminsize_: root::mozilla::detail::GkAtoms_Atoms = 1764;
            pub const GkAtoms_Atoms_scriptsizemultiplier_: root::mozilla::detail::GkAtoms_Atoms =
                1765;
            pub const GkAtoms_Atoms_scriptsize_: root::mozilla::detail::GkAtoms_Atoms = 1766;
            pub const GkAtoms_Atoms_sdev_: root::mozilla::detail::GkAtoms_Atoms = 1767;
            pub const GkAtoms_Atoms_sech_: root::mozilla::detail::GkAtoms_Atoms = 1768;
            pub const GkAtoms_Atoms_sec_: root::mozilla::detail::GkAtoms_Atoms = 1769;
            pub const GkAtoms_Atoms_selection_: root::mozilla::detail::GkAtoms_Atoms = 1770;
            pub const GkAtoms_Atoms_selector_: root::mozilla::detail::GkAtoms_Atoms = 1771;
            pub const GkAtoms_Atoms_semantics_: root::mozilla::detail::GkAtoms_Atoms = 1772;
            pub const GkAtoms_Atoms_separator_: root::mozilla::detail::GkAtoms_Atoms = 1773;
            pub const GkAtoms_Atoms_separators_: root::mozilla::detail::GkAtoms_Atoms = 1774;
            pub const GkAtoms_Atoms_sep_: root::mozilla::detail::GkAtoms_Atoms = 1775;
            pub const GkAtoms_Atoms_setdiff_: root::mozilla::detail::GkAtoms_Atoms = 1776;
            pub const GkAtoms_Atoms_share_: root::mozilla::detail::GkAtoms_Atoms = 1777;
            pub const GkAtoms_Atoms_shift_: root::mozilla::detail::GkAtoms_Atoms = 1778;
            pub const GkAtoms_Atoms_side_: root::mozilla::detail::GkAtoms_Atoms = 1779;
            pub const GkAtoms_Atoms_sinh_: root::mozilla::detail::GkAtoms_Atoms = 1780;
            pub const GkAtoms_Atoms_sin_: root::mozilla::detail::GkAtoms_Atoms = 1781;
            pub const GkAtoms_Atoms_stackalign_: root::mozilla::detail::GkAtoms_Atoms = 1782;
            pub const GkAtoms_Atoms_stretchy_: root::mozilla::detail::GkAtoms_Atoms = 1783;
            pub const GkAtoms_Atoms_subscriptshift_: root::mozilla::detail::GkAtoms_Atoms = 1784;
            pub const GkAtoms_Atoms_subset_: root::mozilla::detail::GkAtoms_Atoms = 1785;
            pub const GkAtoms_Atoms_superscriptshift_: root::mozilla::detail::GkAtoms_Atoms = 1786;
            pub const GkAtoms_Atoms_symmetric_: root::mozilla::detail::GkAtoms_Atoms = 1787;
            pub const GkAtoms_Atoms_tanh_: root::mozilla::detail::GkAtoms_Atoms = 1788;
            pub const GkAtoms_Atoms_tan_: root::mozilla::detail::GkAtoms_Atoms = 1789;
            pub const GkAtoms_Atoms_tendsto_: root::mozilla::detail::GkAtoms_Atoms = 1790;
            pub const GkAtoms_Atoms_times_: root::mozilla::detail::GkAtoms_Atoms = 1791;
            pub const GkAtoms_Atoms_transpose_: root::mozilla::detail::GkAtoms_Atoms = 1792;
            pub const GkAtoms_Atoms_union_: root::mozilla::detail::GkAtoms_Atoms = 1793;
            pub const GkAtoms_Atoms_uplimit_: root::mozilla::detail::GkAtoms_Atoms = 1794;
            pub const GkAtoms_Atoms_variance_: root::mozilla::detail::GkAtoms_Atoms = 1795;
            pub const GkAtoms_Atoms_vectorproduct_: root::mozilla::detail::GkAtoms_Atoms = 1796;
            pub const GkAtoms_Atoms_vector_: root::mozilla::detail::GkAtoms_Atoms = 1797;
            pub const GkAtoms_Atoms_voffset_: root::mozilla::detail::GkAtoms_Atoms = 1798;
            pub const GkAtoms_Atoms_xref_: root::mozilla::detail::GkAtoms_Atoms = 1799;
            pub const GkAtoms_Atoms_math: root::mozilla::detail::GkAtoms_Atoms = 1800;
            pub const GkAtoms_Atoms_booleanFromString: root::mozilla::detail::GkAtoms_Atoms = 1801;
            pub const GkAtoms_Atoms_countNonEmpty: root::mozilla::detail::GkAtoms_Atoms = 1802;
            pub const GkAtoms_Atoms_daysFromDate: root::mozilla::detail::GkAtoms_Atoms = 1803;
            pub const GkAtoms_Atoms_secondsFromDateTime: root::mozilla::detail::GkAtoms_Atoms =
                1804;
            pub const GkAtoms_Atoms_onMozSwipeGestureMayStart:
                root::mozilla::detail::GkAtoms_Atoms = 1805;
            pub const GkAtoms_Atoms_onMozSwipeGestureStart: root::mozilla::detail::GkAtoms_Atoms =
                1806;
            pub const GkAtoms_Atoms_onMozSwipeGestureUpdate: root::mozilla::detail::GkAtoms_Atoms =
                1807;
            pub const GkAtoms_Atoms_onMozSwipeGestureEnd: root::mozilla::detail::GkAtoms_Atoms =
                1808;
            pub const GkAtoms_Atoms_onMozSwipeGesture: root::mozilla::detail::GkAtoms_Atoms = 1809;
            pub const GkAtoms_Atoms_onMozMagnifyGestureStart: root::mozilla::detail::GkAtoms_Atoms =
                1810;
            pub const GkAtoms_Atoms_onMozMagnifyGestureUpdate:
                root::mozilla::detail::GkAtoms_Atoms = 1811;
            pub const GkAtoms_Atoms_onMozMagnifyGesture: root::mozilla::detail::GkAtoms_Atoms =
                1812;
            pub const GkAtoms_Atoms_onMozRotateGestureStart: root::mozilla::detail::GkAtoms_Atoms =
                1813;
            pub const GkAtoms_Atoms_onMozRotateGestureUpdate: root::mozilla::detail::GkAtoms_Atoms =
                1814;
            pub const GkAtoms_Atoms_onMozRotateGesture: root::mozilla::detail::GkAtoms_Atoms = 1815;
            pub const GkAtoms_Atoms_onMozTapGesture: root::mozilla::detail::GkAtoms_Atoms = 1816;
            pub const GkAtoms_Atoms_onMozPressTapGesture: root::mozilla::detail::GkAtoms_Atoms =
                1817;
            pub const GkAtoms_Atoms_onMozEdgeUIStarted: root::mozilla::detail::GkAtoms_Atoms = 1818;
            pub const GkAtoms_Atoms_onMozEdgeUICanceled: root::mozilla::detail::GkAtoms_Atoms =
                1819;
            pub const GkAtoms_Atoms_onMozEdgeUICompleted: root::mozilla::detail::GkAtoms_Atoms =
                1820;
            pub const GkAtoms_Atoms_onpointerdown: root::mozilla::detail::GkAtoms_Atoms = 1821;
            pub const GkAtoms_Atoms_onpointermove: root::mozilla::detail::GkAtoms_Atoms = 1822;
            pub const GkAtoms_Atoms_onpointerup: root::mozilla::detail::GkAtoms_Atoms = 1823;
            pub const GkAtoms_Atoms_onpointercancel: root::mozilla::detail::GkAtoms_Atoms = 1824;
            pub const GkAtoms_Atoms_onpointerover: root::mozilla::detail::GkAtoms_Atoms = 1825;
            pub const GkAtoms_Atoms_onpointerout: root::mozilla::detail::GkAtoms_Atoms = 1826;
            pub const GkAtoms_Atoms_onpointerenter: root::mozilla::detail::GkAtoms_Atoms = 1827;
            pub const GkAtoms_Atoms_onpointerleave: root::mozilla::detail::GkAtoms_Atoms = 1828;
            pub const GkAtoms_Atoms_ongotpointercapture: root::mozilla::detail::GkAtoms_Atoms =
                1829;
            pub const GkAtoms_Atoms_onlostpointercapture: root::mozilla::detail::GkAtoms_Atoms =
                1830;
            pub const GkAtoms_Atoms_ondevicemotion: root::mozilla::detail::GkAtoms_Atoms = 1831;
            pub const GkAtoms_Atoms_ondeviceorientation: root::mozilla::detail::GkAtoms_Atoms =
                1832;
            pub const GkAtoms_Atoms_onabsolutedeviceorientation:
                root::mozilla::detail::GkAtoms_Atoms = 1833;
            pub const GkAtoms_Atoms_ondeviceproximity: root::mozilla::detail::GkAtoms_Atoms = 1834;
            pub const GkAtoms_Atoms_onmozorientationchange: root::mozilla::detail::GkAtoms_Atoms =
                1835;
            pub const GkAtoms_Atoms_onuserproximity: root::mozilla::detail::GkAtoms_Atoms = 1836;
            pub const GkAtoms_Atoms_ondevicelight: root::mozilla::detail::GkAtoms_Atoms = 1837;
            pub const GkAtoms_Atoms_ondevicechange: root::mozilla::detail::GkAtoms_Atoms = 1838;
            pub const GkAtoms_Atoms_onmozvisualresize: root::mozilla::detail::GkAtoms_Atoms = 1839;
            pub const GkAtoms_Atoms_onmozvisualscroll: root::mozilla::detail::GkAtoms_Atoms = 1840;
            pub const GkAtoms_Atoms_moz_extension: root::mozilla::detail::GkAtoms_Atoms = 1841;
            pub const GkAtoms_Atoms_all_urlsPermission: root::mozilla::detail::GkAtoms_Atoms = 1842;
            pub const GkAtoms_Atoms_clipboardRead: root::mozilla::detail::GkAtoms_Atoms = 1843;
            pub const GkAtoms_Atoms_clipboardWrite: root::mozilla::detail::GkAtoms_Atoms = 1844;
            pub const GkAtoms_Atoms_debugger: root::mozilla::detail::GkAtoms_Atoms = 1845;
            pub const GkAtoms_Atoms_mozillaAddons: root::mozilla::detail::GkAtoms_Atoms = 1846;
            pub const GkAtoms_Atoms_tabs: root::mozilla::detail::GkAtoms_Atoms = 1847;
            pub const GkAtoms_Atoms_webRequestBlocking: root::mozilla::detail::GkAtoms_Atoms = 1848;
            pub const GkAtoms_Atoms_http: root::mozilla::detail::GkAtoms_Atoms = 1849;
            pub const GkAtoms_Atoms_https: root::mozilla::detail::GkAtoms_Atoms = 1850;
            pub const GkAtoms_Atoms_proxy: root::mozilla::detail::GkAtoms_Atoms = 1851;
            pub const GkAtoms_Atoms_privateBrowsingAllowedPermission:
                root::mozilla::detail::GkAtoms_Atoms = 1852;
            pub const GkAtoms_Atoms_decimal_leading_zero: root::mozilla::detail::GkAtoms_Atoms =
                1853;
            pub const GkAtoms_Atoms_arabic_indic: root::mozilla::detail::GkAtoms_Atoms = 1854;
            pub const GkAtoms_Atoms_armenian: root::mozilla::detail::GkAtoms_Atoms = 1855;
            pub const GkAtoms_Atoms_upper_armenian: root::mozilla::detail::GkAtoms_Atoms = 1856;
            pub const GkAtoms_Atoms_lower_armenian: root::mozilla::detail::GkAtoms_Atoms = 1857;
            pub const GkAtoms_Atoms_bengali: root::mozilla::detail::GkAtoms_Atoms = 1858;
            pub const GkAtoms_Atoms_cambodian: root::mozilla::detail::GkAtoms_Atoms = 1859;
            pub const GkAtoms_Atoms_khmer: root::mozilla::detail::GkAtoms_Atoms = 1860;
            pub const GkAtoms_Atoms_cjk_decimal: root::mozilla::detail::GkAtoms_Atoms = 1861;
            pub const GkAtoms_Atoms_devanagari: root::mozilla::detail::GkAtoms_Atoms = 1862;
            pub const GkAtoms_Atoms_georgian: root::mozilla::detail::GkAtoms_Atoms = 1863;
            pub const GkAtoms_Atoms_gujarati: root::mozilla::detail::GkAtoms_Atoms = 1864;
            pub const GkAtoms_Atoms_gurmukhi: root::mozilla::detail::GkAtoms_Atoms = 1865;
            pub const GkAtoms_Atoms_kannada: root::mozilla::detail::GkAtoms_Atoms = 1866;
            pub const GkAtoms_Atoms_lao: root::mozilla::detail::GkAtoms_Atoms = 1867;
            pub const GkAtoms_Atoms_malayalam: root::mozilla::detail::GkAtoms_Atoms = 1868;
            pub const GkAtoms_Atoms_mongolian: root::mozilla::detail::GkAtoms_Atoms = 1869;
            pub const GkAtoms_Atoms_myanmar: root::mozilla::detail::GkAtoms_Atoms = 1870;
            pub const GkAtoms_Atoms_oriya: root::mozilla::detail::GkAtoms_Atoms = 1871;
            pub const GkAtoms_Atoms_persian: root::mozilla::detail::GkAtoms_Atoms = 1872;
            pub const GkAtoms_Atoms_lower_roman: root::mozilla::detail::GkAtoms_Atoms = 1873;
            pub const GkAtoms_Atoms_upper_roman: root::mozilla::detail::GkAtoms_Atoms = 1874;
            pub const GkAtoms_Atoms_tamil: root::mozilla::detail::GkAtoms_Atoms = 1875;
            pub const GkAtoms_Atoms_telugu: root::mozilla::detail::GkAtoms_Atoms = 1876;
            pub const GkAtoms_Atoms_thai: root::mozilla::detail::GkAtoms_Atoms = 1877;
            pub const GkAtoms_Atoms_tibetan: root::mozilla::detail::GkAtoms_Atoms = 1878;
            pub const GkAtoms_Atoms_lower_alpha: root::mozilla::detail::GkAtoms_Atoms = 1879;
            pub const GkAtoms_Atoms_lower_latin: root::mozilla::detail::GkAtoms_Atoms = 1880;
            pub const GkAtoms_Atoms_upper_alpha: root::mozilla::detail::GkAtoms_Atoms = 1881;
            pub const GkAtoms_Atoms_upper_latin: root::mozilla::detail::GkAtoms_Atoms = 1882;
            pub const GkAtoms_Atoms_cjk_heavenly_stem: root::mozilla::detail::GkAtoms_Atoms = 1883;
            pub const GkAtoms_Atoms_cjk_earthly_branch: root::mozilla::detail::GkAtoms_Atoms = 1884;
            pub const GkAtoms_Atoms_lower_greek: root::mozilla::detail::GkAtoms_Atoms = 1885;
            pub const GkAtoms_Atoms_hiragana: root::mozilla::detail::GkAtoms_Atoms = 1886;
            pub const GkAtoms_Atoms_hiragana_iroha: root::mozilla::detail::GkAtoms_Atoms = 1887;
            pub const GkAtoms_Atoms_katakana: root::mozilla::detail::GkAtoms_Atoms = 1888;
            pub const GkAtoms_Atoms_katakana_iroha: root::mozilla::detail::GkAtoms_Atoms = 1889;
            pub const GkAtoms_Atoms_cjk_ideographic: root::mozilla::detail::GkAtoms_Atoms = 1890;
            pub const GkAtoms_Atoms__moz_arabic_indic: root::mozilla::detail::GkAtoms_Atoms = 1891;
            pub const GkAtoms_Atoms__moz_persian: root::mozilla::detail::GkAtoms_Atoms = 1892;
            pub const GkAtoms_Atoms__moz_urdu: root::mozilla::detail::GkAtoms_Atoms = 1893;
            pub const GkAtoms_Atoms__moz_devanagari: root::mozilla::detail::GkAtoms_Atoms = 1894;
            pub const GkAtoms_Atoms__moz_bengali: root::mozilla::detail::GkAtoms_Atoms = 1895;
            pub const GkAtoms_Atoms__moz_gurmukhi: root::mozilla::detail::GkAtoms_Atoms = 1896;
            pub const GkAtoms_Atoms__moz_gujarati: root::mozilla::detail::GkAtoms_Atoms = 1897;
            pub const GkAtoms_Atoms__moz_oriya: root::mozilla::detail::GkAtoms_Atoms = 1898;
            pub const GkAtoms_Atoms__moz_tamil: root::mozilla::detail::GkAtoms_Atoms = 1899;
            pub const GkAtoms_Atoms__moz_telugu: root::mozilla::detail::GkAtoms_Atoms = 1900;
            pub const GkAtoms_Atoms__moz_kannada: root::mozilla::detail::GkAtoms_Atoms = 1901;
            pub const GkAtoms_Atoms__moz_malayalam: root::mozilla::detail::GkAtoms_Atoms = 1902;
            pub const GkAtoms_Atoms__moz_thai: root::mozilla::detail::GkAtoms_Atoms = 1903;
            pub const GkAtoms_Atoms__moz_lao: root::mozilla::detail::GkAtoms_Atoms = 1904;
            pub const GkAtoms_Atoms__moz_myanmar: root::mozilla::detail::GkAtoms_Atoms = 1905;
            pub const GkAtoms_Atoms__moz_khmer: root::mozilla::detail::GkAtoms_Atoms = 1906;
            pub const GkAtoms_Atoms__moz_cjk_heavenly_stem: root::mozilla::detail::GkAtoms_Atoms =
                1907;
            pub const GkAtoms_Atoms__moz_cjk_earthly_branch: root::mozilla::detail::GkAtoms_Atoms =
                1908;
            pub const GkAtoms_Atoms__moz_hangul: root::mozilla::detail::GkAtoms_Atoms = 1909;
            pub const GkAtoms_Atoms__moz_hangul_consonant: root::mozilla::detail::GkAtoms_Atoms =
                1910;
            pub const GkAtoms_Atoms__moz_ethiopic_halehame: root::mozilla::detail::GkAtoms_Atoms =
                1911;
            pub const GkAtoms_Atoms__moz_ethiopic_halehame_am:
                root::mozilla::detail::GkAtoms_Atoms = 1912;
            pub const GkAtoms_Atoms__moz_ethiopic_halehame_ti_er:
                root::mozilla::detail::GkAtoms_Atoms = 1913;
            pub const GkAtoms_Atoms__moz_ethiopic_halehame_ti_et:
                root::mozilla::detail::GkAtoms_Atoms = 1914;
            pub const GkAtoms_Atoms__moz_trad_chinese_informal:
                root::mozilla::detail::GkAtoms_Atoms = 1915;
            pub const GkAtoms_Atoms__moz_trad_chinese_formal: root::mozilla::detail::GkAtoms_Atoms =
                1916;
            pub const GkAtoms_Atoms__moz_simp_chinese_informal:
                root::mozilla::detail::GkAtoms_Atoms = 1917;
            pub const GkAtoms_Atoms__moz_simp_chinese_formal: root::mozilla::detail::GkAtoms_Atoms =
                1918;
            pub const GkAtoms_Atoms__moz_japanese_informal: root::mozilla::detail::GkAtoms_Atoms =
                1919;
            pub const GkAtoms_Atoms__moz_japanese_formal: root::mozilla::detail::GkAtoms_Atoms =
                1920;
            pub const GkAtoms_Atoms__moz_ethiopic_numeric: root::mozilla::detail::GkAtoms_Atoms =
                1921;
            pub const GkAtoms_Atoms_cdataTagName: root::mozilla::detail::GkAtoms_Atoms = 1922;
            pub const GkAtoms_Atoms_commentTagName: root::mozilla::detail::GkAtoms_Atoms = 1923;
            pub const GkAtoms_Atoms_documentNodeName: root::mozilla::detail::GkAtoms_Atoms = 1924;
            pub const GkAtoms_Atoms_documentFragmentNodeName: root::mozilla::detail::GkAtoms_Atoms =
                1925;
            pub const GkAtoms_Atoms_documentTypeNodeName: root::mozilla::detail::GkAtoms_Atoms =
                1926;
            pub const GkAtoms_Atoms_processingInstructionTagName:
                root::mozilla::detail::GkAtoms_Atoms = 1927;
            pub const GkAtoms_Atoms_textTagName: root::mozilla::detail::GkAtoms_Atoms = 1928;
            pub const GkAtoms_Atoms_placeholderFrame: root::mozilla::detail::GkAtoms_Atoms = 1929;
            pub const GkAtoms_Atoms_onloadend: root::mozilla::detail::GkAtoms_Atoms = 1930;
            pub const GkAtoms_Atoms_onloadstart: root::mozilla::detail::GkAtoms_Atoms = 1931;
            pub const GkAtoms_Atoms_onprogress: root::mozilla::detail::GkAtoms_Atoms = 1932;
            pub const GkAtoms_Atoms_onsuspend: root::mozilla::detail::GkAtoms_Atoms = 1933;
            pub const GkAtoms_Atoms_onemptied: root::mozilla::detail::GkAtoms_Atoms = 1934;
            pub const GkAtoms_Atoms_onstalled: root::mozilla::detail::GkAtoms_Atoms = 1935;
            pub const GkAtoms_Atoms_onplay: root::mozilla::detail::GkAtoms_Atoms = 1936;
            pub const GkAtoms_Atoms_onpause: root::mozilla::detail::GkAtoms_Atoms = 1937;
            pub const GkAtoms_Atoms_onloadedmetadata: root::mozilla::detail::GkAtoms_Atoms = 1938;
            pub const GkAtoms_Atoms_onloadeddata: root::mozilla::detail::GkAtoms_Atoms = 1939;
            pub const GkAtoms_Atoms_onwaiting: root::mozilla::detail::GkAtoms_Atoms = 1940;
            pub const GkAtoms_Atoms_onplaying: root::mozilla::detail::GkAtoms_Atoms = 1941;
            pub const GkAtoms_Atoms_oncanplay: root::mozilla::detail::GkAtoms_Atoms = 1942;
            pub const GkAtoms_Atoms_oncanplaythrough: root::mozilla::detail::GkAtoms_Atoms = 1943;
            pub const GkAtoms_Atoms_onseeking: root::mozilla::detail::GkAtoms_Atoms = 1944;
            pub const GkAtoms_Atoms_onseeked: root::mozilla::detail::GkAtoms_Atoms = 1945;
            pub const GkAtoms_Atoms_ontimeout: root::mozilla::detail::GkAtoms_Atoms = 1946;
            pub const GkAtoms_Atoms_ontimeupdate: root::mozilla::detail::GkAtoms_Atoms = 1947;
            pub const GkAtoms_Atoms_onended: root::mozilla::detail::GkAtoms_Atoms = 1948;
            pub const GkAtoms_Atoms_onratechange: root::mozilla::detail::GkAtoms_Atoms = 1949;
            pub const GkAtoms_Atoms_ondurationchange: root::mozilla::detail::GkAtoms_Atoms = 1950;
            pub const GkAtoms_Atoms_onvolumechange: root::mozilla::detail::GkAtoms_Atoms = 1951;
            pub const GkAtoms_Atoms_onaddtrack: root::mozilla::detail::GkAtoms_Atoms = 1952;
            pub const GkAtoms_Atoms_oncontrollerchange: root::mozilla::detail::GkAtoms_Atoms = 1953;
            pub const GkAtoms_Atoms_oncuechange: root::mozilla::detail::GkAtoms_Atoms = 1954;
            pub const GkAtoms_Atoms_onenter: root::mozilla::detail::GkAtoms_Atoms = 1955;
            pub const GkAtoms_Atoms_onexit: root::mozilla::detail::GkAtoms_Atoms = 1956;
            pub const GkAtoms_Atoms_onencrypted: root::mozilla::detail::GkAtoms_Atoms = 1957;
            pub const GkAtoms_Atoms_onwaitingforkey: root::mozilla::detail::GkAtoms_Atoms = 1958;
            pub const GkAtoms_Atoms_onkeystatuseschange: root::mozilla::detail::GkAtoms_Atoms =
                1959;
            pub const GkAtoms_Atoms_onremovetrack: root::mozilla::detail::GkAtoms_Atoms = 1960;
            pub const GkAtoms_Atoms_loadstart: root::mozilla::detail::GkAtoms_Atoms = 1961;
            pub const GkAtoms_Atoms_suspend: root::mozilla::detail::GkAtoms_Atoms = 1962;
            pub const GkAtoms_Atoms_emptied: root::mozilla::detail::GkAtoms_Atoms = 1963;
            pub const GkAtoms_Atoms_play: root::mozilla::detail::GkAtoms_Atoms = 1964;
            pub const GkAtoms_Atoms_pause: root::mozilla::detail::GkAtoms_Atoms = 1965;
            pub const GkAtoms_Atoms_loadedmetadata: root::mozilla::detail::GkAtoms_Atoms = 1966;
            pub const GkAtoms_Atoms_loadeddata: root::mozilla::detail::GkAtoms_Atoms = 1967;
            pub const GkAtoms_Atoms_waiting: root::mozilla::detail::GkAtoms_Atoms = 1968;
            pub const GkAtoms_Atoms_playing: root::mozilla::detail::GkAtoms_Atoms = 1969;
            pub const GkAtoms_Atoms_timeupdate: root::mozilla::detail::GkAtoms_Atoms = 1970;
            pub const GkAtoms_Atoms_canplay: root::mozilla::detail::GkAtoms_Atoms = 1971;
            pub const GkAtoms_Atoms_canplaythrough: root::mozilla::detail::GkAtoms_Atoms = 1972;
            pub const GkAtoms_Atoms_ondataavailable: root::mozilla::detail::GkAtoms_Atoms = 1973;
            pub const GkAtoms_Atoms_onwarning: root::mozilla::detail::GkAtoms_Atoms = 1974;
            pub const GkAtoms_Atoms_onstart: root::mozilla::detail::GkAtoms_Atoms = 1975;
            pub const GkAtoms_Atoms_onstop: root::mozilla::detail::GkAtoms_Atoms = 1976;
            pub const GkAtoms_Atoms_onphoto: root::mozilla::detail::GkAtoms_Atoms = 1977;
            pub const GkAtoms_Atoms_ongamepadbuttondown: root::mozilla::detail::GkAtoms_Atoms =
                1978;
            pub const GkAtoms_Atoms_ongamepadbuttonup: root::mozilla::detail::GkAtoms_Atoms = 1979;
            pub const GkAtoms_Atoms_ongamepadaxismove: root::mozilla::detail::GkAtoms_Atoms = 1980;
            pub const GkAtoms_Atoms_ongamepadconnected: root::mozilla::detail::GkAtoms_Atoms = 1981;
            pub const GkAtoms_Atoms_ongamepaddisconnected: root::mozilla::detail::GkAtoms_Atoms =
                1982;
            pub const GkAtoms_Atoms_onfetch: root::mozilla::detail::GkAtoms_Atoms = 1983;
            pub const GkAtoms_Atoms_afterPseudoProperty: root::mozilla::detail::GkAtoms_Atoms =
                1984;
            pub const GkAtoms_Atoms_animationsProperty: root::mozilla::detail::GkAtoms_Atoms = 1985;
            pub const GkAtoms_Atoms_animationsOfBeforeProperty:
                root::mozilla::detail::GkAtoms_Atoms = 1986;
            pub const GkAtoms_Atoms_animationsOfAfterProperty:
                root::mozilla::detail::GkAtoms_Atoms = 1987;
            pub const GkAtoms_Atoms_animationsOfMarkerProperty:
                root::mozilla::detail::GkAtoms_Atoms = 1988;
            pub const GkAtoms_Atoms_animationEffectsProperty: root::mozilla::detail::GkAtoms_Atoms =
                1989;
            pub const GkAtoms_Atoms_animationEffectsForBeforeProperty:
                root::mozilla::detail::GkAtoms_Atoms = 1990;
            pub const GkAtoms_Atoms_animationEffectsForAfterProperty:
                root::mozilla::detail::GkAtoms_Atoms = 1991;
            pub const GkAtoms_Atoms_animationEffectsForMarkerProperty:
                root::mozilla::detail::GkAtoms_Atoms = 1992;
            pub const GkAtoms_Atoms_beforePseudoProperty: root::mozilla::detail::GkAtoms_Atoms =
                1993;
            pub const GkAtoms_Atoms_cssPseudoElementBeforeProperty:
                root::mozilla::detail::GkAtoms_Atoms = 1994;
            pub const GkAtoms_Atoms_cssPseudoElementAfterProperty:
                root::mozilla::detail::GkAtoms_Atoms = 1995;
            pub const GkAtoms_Atoms_cssPseudoElementMarkerProperty:
                root::mozilla::detail::GkAtoms_Atoms = 1996;
            pub const GkAtoms_Atoms_transitionsProperty: root::mozilla::detail::GkAtoms_Atoms =
                1997;
            pub const GkAtoms_Atoms_transitionsOfBeforeProperty:
                root::mozilla::detail::GkAtoms_Atoms = 1998;
            pub const GkAtoms_Atoms_transitionsOfAfterProperty:
                root::mozilla::detail::GkAtoms_Atoms = 1999;
            pub const GkAtoms_Atoms_transitionsOfMarkerProperty:
                root::mozilla::detail::GkAtoms_Atoms = 2000;
            pub const GkAtoms_Atoms_genConInitializerProperty:
                root::mozilla::detail::GkAtoms_Atoms = 2001;
            pub const GkAtoms_Atoms_labelMouseDownPtProperty: root::mozilla::detail::GkAtoms_Atoms =
                2002;
            pub const GkAtoms_Atoms_lockedStyleStates: root::mozilla::detail::GkAtoms_Atoms = 2003;
            pub const GkAtoms_Atoms_apzCallbackTransform: root::mozilla::detail::GkAtoms_Atoms =
                2004;
            pub const GkAtoms_Atoms_restylableAnonymousNode: root::mozilla::detail::GkAtoms_Atoms =
                2005;
            pub const GkAtoms_Atoms_docLevelNativeAnonymousContent:
                root::mozilla::detail::GkAtoms_Atoms = 2006;
            pub const GkAtoms_Atoms_paintRequestTime: root::mozilla::detail::GkAtoms_Atoms = 2007;
            pub const GkAtoms_Atoms_pseudoProperty: root::mozilla::detail::GkAtoms_Atoms = 2008;
            pub const GkAtoms_Atoms_manualNACProperty: root::mozilla::detail::GkAtoms_Atoms = 2009;
            pub const GkAtoms_Atoms_markerPseudoProperty: root::mozilla::detail::GkAtoms_Atoms =
                2010;
            pub const GkAtoms_Atoms_Japanese: root::mozilla::detail::GkAtoms_Atoms = 2011;
            pub const GkAtoms_Atoms_Chinese: root::mozilla::detail::GkAtoms_Atoms = 2012;
            pub const GkAtoms_Atoms_Taiwanese: root::mozilla::detail::GkAtoms_Atoms = 2013;
            pub const GkAtoms_Atoms_HongKongChinese: root::mozilla::detail::GkAtoms_Atoms = 2014;
            pub const GkAtoms_Atoms_Unicode: root::mozilla::detail::GkAtoms_Atoms = 2015;
            pub const GkAtoms_Atoms_ko: root::mozilla::detail::GkAtoms_Atoms = 2016;
            pub const GkAtoms_Atoms_zh_cn: root::mozilla::detail::GkAtoms_Atoms = 2017;
            pub const GkAtoms_Atoms_zh_tw: root::mozilla::detail::GkAtoms_Atoms = 2018;
            pub const GkAtoms_Atoms_x_cyrillic: root::mozilla::detail::GkAtoms_Atoms = 2019;
            pub const GkAtoms_Atoms_he: root::mozilla::detail::GkAtoms_Atoms = 2020;
            pub const GkAtoms_Atoms_ar: root::mozilla::detail::GkAtoms_Atoms = 2021;
            pub const GkAtoms_Atoms_x_devanagari: root::mozilla::detail::GkAtoms_Atoms = 2022;
            pub const GkAtoms_Atoms_x_tamil: root::mozilla::detail::GkAtoms_Atoms = 2023;
            pub const GkAtoms_Atoms_x_armn: root::mozilla::detail::GkAtoms_Atoms = 2024;
            pub const GkAtoms_Atoms_x_beng: root::mozilla::detail::GkAtoms_Atoms = 2025;
            pub const GkAtoms_Atoms_x_cans: root::mozilla::detail::GkAtoms_Atoms = 2026;
            pub const GkAtoms_Atoms_x_ethi: root::mozilla::detail::GkAtoms_Atoms = 2027;
            pub const GkAtoms_Atoms_x_geor: root::mozilla::detail::GkAtoms_Atoms = 2028;
            pub const GkAtoms_Atoms_x_gujr: root::mozilla::detail::GkAtoms_Atoms = 2029;
            pub const GkAtoms_Atoms_x_guru: root::mozilla::detail::GkAtoms_Atoms = 2030;
            pub const GkAtoms_Atoms_x_khmr: root::mozilla::detail::GkAtoms_Atoms = 2031;
            pub const GkAtoms_Atoms_x_knda: root::mozilla::detail::GkAtoms_Atoms = 2032;
            pub const GkAtoms_Atoms_x_mlym: root::mozilla::detail::GkAtoms_Atoms = 2033;
            pub const GkAtoms_Atoms_x_orya: root::mozilla::detail::GkAtoms_Atoms = 2034;
            pub const GkAtoms_Atoms_x_sinh: root::mozilla::detail::GkAtoms_Atoms = 2035;
            pub const GkAtoms_Atoms_x_telu: root::mozilla::detail::GkAtoms_Atoms = 2036;
            pub const GkAtoms_Atoms_x_tibt: root::mozilla::detail::GkAtoms_Atoms = 2037;
            pub const GkAtoms_Atoms_az: root::mozilla::detail::GkAtoms_Atoms = 2038;
            pub const GkAtoms_Atoms_ba: root::mozilla::detail::GkAtoms_Atoms = 2039;
            pub const GkAtoms_Atoms_crh: root::mozilla::detail::GkAtoms_Atoms = 2040;
            pub const GkAtoms_Atoms_ga: root::mozilla::detail::GkAtoms_Atoms = 2041;
            pub const GkAtoms_Atoms_nl: root::mozilla::detail::GkAtoms_Atoms = 2042;
            pub const GkAtoms_Atoms_x_math: root::mozilla::detail::GkAtoms_Atoms = 2043;
            pub const GkAtoms_Atoms_zh: root::mozilla::detail::GkAtoms_Atoms = 2044;
            pub const GkAtoms_Atoms_TypingTxnName: root::mozilla::detail::GkAtoms_Atoms = 2045;
            pub const GkAtoms_Atoms_IMETxnName: root::mozilla::detail::GkAtoms_Atoms = 2046;
            pub const GkAtoms_Atoms_DeleteTxnName: root::mozilla::detail::GkAtoms_Atoms = 2047;
            pub const GkAtoms_Atoms_serif: root::mozilla::detail::GkAtoms_Atoms = 2048;
            pub const GkAtoms_Atoms_sans_serif: root::mozilla::detail::GkAtoms_Atoms = 2049;
            pub const GkAtoms_Atoms_cursive: root::mozilla::detail::GkAtoms_Atoms = 2050;
            pub const GkAtoms_Atoms_fantasy: root::mozilla::detail::GkAtoms_Atoms = 2051;
            pub const GkAtoms_Atoms_monospace: root::mozilla::detail::GkAtoms_Atoms = 2052;
            pub const GkAtoms_Atoms_mozfixed: root::mozilla::detail::GkAtoms_Atoms = 2053;
            pub const GkAtoms_Atoms_RemoteId: root::mozilla::detail::GkAtoms_Atoms = 2054;
            pub const GkAtoms_Atoms_RemoteType: root::mozilla::detail::GkAtoms_Atoms = 2055;
            pub const GkAtoms_Atoms_DisplayPort: root::mozilla::detail::GkAtoms_Atoms = 2056;
            pub const GkAtoms_Atoms_DisplayPortMargins: root::mozilla::detail::GkAtoms_Atoms = 2057;
            pub const GkAtoms_Atoms_DisplayPortBase: root::mozilla::detail::GkAtoms_Atoms = 2058;
            pub const GkAtoms_Atoms_forcemessagemanager: root::mozilla::detail::GkAtoms_Atoms =
                2059;
            pub const GkAtoms_Atoms_preloadedState: root::mozilla::detail::GkAtoms_Atoms = 2060;
            pub const GkAtoms_Atoms_RecordExecution: root::mozilla::detail::GkAtoms_Atoms = 2061;
            pub const GkAtoms_Atoms_ReplayExecution: root::mozilla::detail::GkAtoms_Atoms = 2062;
            pub const GkAtoms_Atoms_windows_win7: root::mozilla::detail::GkAtoms_Atoms = 2063;
            pub const GkAtoms_Atoms_windows_win8: root::mozilla::detail::GkAtoms_Atoms = 2064;
            pub const GkAtoms_Atoms_windows_win10: root::mozilla::detail::GkAtoms_Atoms = 2065;
            pub const GkAtoms_Atoms__moz_scrollbar_start_backward:
                root::mozilla::detail::GkAtoms_Atoms = 2066;
            pub const GkAtoms_Atoms__moz_scrollbar_start_forward:
                root::mozilla::detail::GkAtoms_Atoms = 2067;
            pub const GkAtoms_Atoms__moz_scrollbar_end_backward:
                root::mozilla::detail::GkAtoms_Atoms = 2068;
            pub const GkAtoms_Atoms__moz_scrollbar_end_forward:
                root::mozilla::detail::GkAtoms_Atoms = 2069;
            pub const GkAtoms_Atoms__moz_scrollbar_thumb_proportional:
                root::mozilla::detail::GkAtoms_Atoms = 2070;
            pub const GkAtoms_Atoms__moz_overlay_scrollbars: root::mozilla::detail::GkAtoms_Atoms =
                2071;
            pub const GkAtoms_Atoms__moz_windows_accent_color_in_titlebar:
                root::mozilla::detail::GkAtoms_Atoms = 2072;
            pub const GkAtoms_Atoms__moz_windows_default_theme:
                root::mozilla::detail::GkAtoms_Atoms = 2073;
            pub const GkAtoms_Atoms__moz_mac_graphite_theme: root::mozilla::detail::GkAtoms_Atoms =
                2074;
            pub const GkAtoms_Atoms__moz_mac_yosemite_theme: root::mozilla::detail::GkAtoms_Atoms =
                2075;
            pub const GkAtoms_Atoms__moz_windows_compositor: root::mozilla::detail::GkAtoms_Atoms =
                2076;
            pub const GkAtoms_Atoms__moz_windows_classic: root::mozilla::detail::GkAtoms_Atoms =
                2077;
            pub const GkAtoms_Atoms__moz_windows_glass: root::mozilla::detail::GkAtoms_Atoms = 2078;
            pub const GkAtoms_Atoms__moz_os_version: root::mozilla::detail::GkAtoms_Atoms = 2079;
            pub const GkAtoms_Atoms__moz_touch_enabled: root::mozilla::detail::GkAtoms_Atoms = 2080;
            pub const GkAtoms_Atoms__moz_menubar_drag: root::mozilla::detail::GkAtoms_Atoms = 2081;
            pub const GkAtoms_Atoms__moz_device_pixel_ratio: root::mozilla::detail::GkAtoms_Atoms =
                2082;
            pub const GkAtoms_Atoms__moz_device_orientation: root::mozilla::detail::GkAtoms_Atoms =
                2083;
            pub const GkAtoms_Atoms__moz_is_resource_document:
                root::mozilla::detail::GkAtoms_Atoms = 2084;
            pub const GkAtoms_Atoms__moz_swipe_animation_enabled:
                root::mozilla::detail::GkAtoms_Atoms = 2085;
            pub const GkAtoms_Atoms__moz_gtk_csd_available: root::mozilla::detail::GkAtoms_Atoms =
                2086;
            pub const GkAtoms_Atoms__moz_gtk_csd_hide_titlebar_by_default:
                root::mozilla::detail::GkAtoms_Atoms = 2087;
            pub const GkAtoms_Atoms__moz_gtk_csd_transparent_background:
                root::mozilla::detail::GkAtoms_Atoms = 2088;
            pub const GkAtoms_Atoms__moz_gtk_csd_minimize_button:
                root::mozilla::detail::GkAtoms_Atoms = 2089;
            pub const GkAtoms_Atoms__moz_gtk_csd_maximize_button:
                root::mozilla::detail::GkAtoms_Atoms = 2090;
            pub const GkAtoms_Atoms__moz_gtk_csd_close_button:
                root::mozilla::detail::GkAtoms_Atoms = 2091;
            pub const GkAtoms_Atoms__moz_gtk_csd_reversed_placement:
                root::mozilla::detail::GkAtoms_Atoms = 2092;
            pub const GkAtoms_Atoms__moz_system_dark_theme: root::mozilla::detail::GkAtoms_Atoms =
                2093;
            pub const GkAtoms_Atoms_Back: root::mozilla::detail::GkAtoms_Atoms = 2094;
            pub const GkAtoms_Atoms_Forward: root::mozilla::detail::GkAtoms_Atoms = 2095;
            pub const GkAtoms_Atoms_Reload: root::mozilla::detail::GkAtoms_Atoms = 2096;
            pub const GkAtoms_Atoms_Stop: root::mozilla::detail::GkAtoms_Atoms = 2097;
            pub const GkAtoms_Atoms_Search: root::mozilla::detail::GkAtoms_Atoms = 2098;
            pub const GkAtoms_Atoms_Bookmarks: root::mozilla::detail::GkAtoms_Atoms = 2099;
            pub const GkAtoms_Atoms_Home: root::mozilla::detail::GkAtoms_Atoms = 2100;
            pub const GkAtoms_Atoms_NextTrack: root::mozilla::detail::GkAtoms_Atoms = 2101;
            pub const GkAtoms_Atoms_PreviousTrack: root::mozilla::detail::GkAtoms_Atoms = 2102;
            pub const GkAtoms_Atoms_MediaStop: root::mozilla::detail::GkAtoms_Atoms = 2103;
            pub const GkAtoms_Atoms_PlayPause: root::mozilla::detail::GkAtoms_Atoms = 2104;
            pub const GkAtoms_Atoms_New: root::mozilla::detail::GkAtoms_Atoms = 2105;
            pub const GkAtoms_Atoms_Open: root::mozilla::detail::GkAtoms_Atoms = 2106;
            pub const GkAtoms_Atoms_Close: root::mozilla::detail::GkAtoms_Atoms = 2107;
            pub const GkAtoms_Atoms_Save: root::mozilla::detail::GkAtoms_Atoms = 2108;
            pub const GkAtoms_Atoms_Find: root::mozilla::detail::GkAtoms_Atoms = 2109;
            pub const GkAtoms_Atoms_Help: root::mozilla::detail::GkAtoms_Atoms = 2110;
            pub const GkAtoms_Atoms_Print: root::mozilla::detail::GkAtoms_Atoms = 2111;
            pub const GkAtoms_Atoms_SendMail: root::mozilla::detail::GkAtoms_Atoms = 2112;
            pub const GkAtoms_Atoms_ForwardMail: root::mozilla::detail::GkAtoms_Atoms = 2113;
            pub const GkAtoms_Atoms_ReplyToMail: root::mozilla::detail::GkAtoms_Atoms = 2114;
            pub const GkAtoms_Atoms_mouseWheel: root::mozilla::detail::GkAtoms_Atoms = 2115;
            pub const GkAtoms_Atoms_pixels: root::mozilla::detail::GkAtoms_Atoms = 2116;
            pub const GkAtoms_Atoms_lines: root::mozilla::detail::GkAtoms_Atoms = 2117;
            pub const GkAtoms_Atoms_pages: root::mozilla::detail::GkAtoms_Atoms = 2118;
            pub const GkAtoms_Atoms_scrollbars: root::mozilla::detail::GkAtoms_Atoms = 2119;
            pub const GkAtoms_Atoms_apz: root::mozilla::detail::GkAtoms_Atoms = 2120;
            pub const GkAtoms_Atoms_restore: root::mozilla::detail::GkAtoms_Atoms = 2121;
            pub const GkAtoms_Atoms_relative: root::mozilla::detail::GkAtoms_Atoms = 2122;
            pub const GkAtoms_Atoms_alert: root::mozilla::detail::GkAtoms_Atoms = 2123;
            pub const GkAtoms_Atoms_alertdialog: root::mozilla::detail::GkAtoms_Atoms = 2124;
            pub const GkAtoms_Atoms_application: root::mozilla::detail::GkAtoms_Atoms = 2125;
            pub const GkAtoms_Atoms_aria_colcount: root::mozilla::detail::GkAtoms_Atoms = 2126;
            pub const GkAtoms_Atoms_aria_colindex: root::mozilla::detail::GkAtoms_Atoms = 2127;
            pub const GkAtoms_Atoms_aria_details: root::mozilla::detail::GkAtoms_Atoms = 2128;
            pub const GkAtoms_Atoms_aria_errormessage: root::mozilla::detail::GkAtoms_Atoms = 2129;
            pub const GkAtoms_Atoms_aria_grabbed: root::mozilla::detail::GkAtoms_Atoms = 2130;
            pub const GkAtoms_Atoms_aria_label: root::mozilla::detail::GkAtoms_Atoms = 2131;
            pub const GkAtoms_Atoms_aria_modal: root::mozilla::detail::GkAtoms_Atoms = 2132;
            pub const GkAtoms_Atoms_aria_orientation: root::mozilla::detail::GkAtoms_Atoms = 2133;
            pub const GkAtoms_Atoms_aria_rowcount: root::mozilla::detail::GkAtoms_Atoms = 2134;
            pub const GkAtoms_Atoms_aria_rowindex: root::mozilla::detail::GkAtoms_Atoms = 2135;
            pub const GkAtoms_Atoms_aria_valuetext: root::mozilla::detail::GkAtoms_Atoms = 2136;
            pub const GkAtoms_Atoms_auto_generated: root::mozilla::detail::GkAtoms_Atoms = 2137;
            pub const GkAtoms_Atoms_banner: root::mozilla::detail::GkAtoms_Atoms = 2138;
            pub const GkAtoms_Atoms_checkable: root::mozilla::detail::GkAtoms_Atoms = 2139;
            pub const GkAtoms_Atoms_columnheader: root::mozilla::detail::GkAtoms_Atoms = 2140;
            pub const GkAtoms_Atoms_complementary: root::mozilla::detail::GkAtoms_Atoms = 2141;
            pub const GkAtoms_Atoms_containerAtomic: root::mozilla::detail::GkAtoms_Atoms = 2142;
            pub const GkAtoms_Atoms_containerBusy: root::mozilla::detail::GkAtoms_Atoms = 2143;
            pub const GkAtoms_Atoms_containerLive: root::mozilla::detail::GkAtoms_Atoms = 2144;
            pub const GkAtoms_Atoms_containerLiveRole: root::mozilla::detail::GkAtoms_Atoms = 2145;
            pub const GkAtoms_Atoms_containerRelevant: root::mozilla::detail::GkAtoms_Atoms = 2146;
            pub const GkAtoms_Atoms_contentinfo: root::mozilla::detail::GkAtoms_Atoms = 2147;
            pub const GkAtoms_Atoms_cycles: root::mozilla::detail::GkAtoms_Atoms = 2148;
            pub const GkAtoms_Atoms_datatable: root::mozilla::detail::GkAtoms_Atoms = 2149;
            pub const GkAtoms_Atoms_eventFromInput: root::mozilla::detail::GkAtoms_Atoms = 2150;
            pub const GkAtoms_Atoms_feed: root::mozilla::detail::GkAtoms_Atoms = 2151;
            pub const GkAtoms_Atoms_grammar: root::mozilla::detail::GkAtoms_Atoms = 2152;
            pub const GkAtoms_Atoms_gridcell: root::mozilla::detail::GkAtoms_Atoms = 2153;
            pub const GkAtoms_Atoms_heading: root::mozilla::detail::GkAtoms_Atoms = 2154;
            pub const GkAtoms_Atoms_hitregion: root::mozilla::detail::GkAtoms_Atoms = 2155;
            pub const GkAtoms_Atoms_inlinevalue: root::mozilla::detail::GkAtoms_Atoms = 2156;
            pub const GkAtoms_Atoms_invalid: root::mozilla::detail::GkAtoms_Atoms = 2157;
            pub const GkAtoms_Atoms_lineNumber: root::mozilla::detail::GkAtoms_Atoms = 2158;
            pub const GkAtoms_Atoms_live: root::mozilla::detail::GkAtoms_Atoms = 2159;
            pub const GkAtoms_Atoms_menuitemcheckbox: root::mozilla::detail::GkAtoms_Atoms = 2160;
            pub const GkAtoms_Atoms_menuitemradio: root::mozilla::detail::GkAtoms_Atoms = 2161;
            pub const GkAtoms_Atoms_navigation: root::mozilla::detail::GkAtoms_Atoms = 2162;
            pub const GkAtoms_Atoms_polite: root::mozilla::detail::GkAtoms_Atoms = 2163;
            pub const GkAtoms_Atoms_posinset: root::mozilla::detail::GkAtoms_Atoms = 2164;
            pub const GkAtoms_Atoms_presentation: root::mozilla::detail::GkAtoms_Atoms = 2165;
            pub const GkAtoms_Atoms_progressbar: root::mozilla::detail::GkAtoms_Atoms = 2166;
            pub const GkAtoms_Atoms_region: root::mozilla::detail::GkAtoms_Atoms = 2167;
            pub const GkAtoms_Atoms_rowgroup: root::mozilla::detail::GkAtoms_Atoms = 2168;
            pub const GkAtoms_Atoms_rowheader: root::mozilla::detail::GkAtoms_Atoms = 2169;
            pub const GkAtoms_Atoms_search: root::mozilla::detail::GkAtoms_Atoms = 2170;
            pub const GkAtoms_Atoms_searchbox: root::mozilla::detail::GkAtoms_Atoms = 2171;
            pub const GkAtoms_Atoms_setsize: root::mozilla::detail::GkAtoms_Atoms = 2172;
            pub const GkAtoms_Atoms_spelling: root::mozilla::detail::GkAtoms_Atoms = 2173;
            pub const GkAtoms_Atoms_spinbutton: root::mozilla::detail::GkAtoms_Atoms = 2174;
            pub const GkAtoms_Atoms_status: root::mozilla::detail::GkAtoms_Atoms = 2175;
            pub const GkAtoms_Atoms_tableCellIndex: root::mozilla::detail::GkAtoms_Atoms = 2176;
            pub const GkAtoms_Atoms_tablist: root::mozilla::detail::GkAtoms_Atoms = 2177;
            pub const GkAtoms_Atoms_textIndent: root::mozilla::detail::GkAtoms_Atoms = 2178;
            pub const GkAtoms_Atoms_textInputType: root::mozilla::detail::GkAtoms_Atoms = 2179;
            pub const GkAtoms_Atoms_textLineThroughColor: root::mozilla::detail::GkAtoms_Atoms =
                2180;
            pub const GkAtoms_Atoms_textLineThroughStyle: root::mozilla::detail::GkAtoms_Atoms =
                2181;
            pub const GkAtoms_Atoms_textPosition: root::mozilla::detail::GkAtoms_Atoms = 2182;
            pub const GkAtoms_Atoms_textUnderlineColor: root::mozilla::detail::GkAtoms_Atoms = 2183;
            pub const GkAtoms_Atoms_textUnderlineStyle: root::mozilla::detail::GkAtoms_Atoms = 2184;
            pub const GkAtoms_Atoms_timer: root::mozilla::detail::GkAtoms_Atoms = 2185;
            pub const GkAtoms_Atoms_toolbarname: root::mozilla::detail::GkAtoms_Atoms = 2186;
            pub const GkAtoms_Atoms_toolbarseparator: root::mozilla::detail::GkAtoms_Atoms = 2187;
            pub const GkAtoms_Atoms_toolbarspacer: root::mozilla::detail::GkAtoms_Atoms = 2188;
            pub const GkAtoms_Atoms_toolbarspring: root::mozilla::detail::GkAtoms_Atoms = 2189;
            pub const GkAtoms_Atoms_treegrid: root::mozilla::detail::GkAtoms_Atoms = 2190;
            pub const GkAtoms_Atoms__undefined: root::mozilla::detail::GkAtoms_Atoms = 2191;
            pub const GkAtoms_Atoms_xmlroles: root::mozilla::detail::GkAtoms_Atoms = 2192;
            pub const GkAtoms_Atoms_close_fence: root::mozilla::detail::GkAtoms_Atoms = 2193;
            pub const GkAtoms_Atoms_denominator: root::mozilla::detail::GkAtoms_Atoms = 2194;
            pub const GkAtoms_Atoms_numerator: root::mozilla::detail::GkAtoms_Atoms = 2195;
            pub const GkAtoms_Atoms_open_fence: root::mozilla::detail::GkAtoms_Atoms = 2196;
            pub const GkAtoms_Atoms_overscript: root::mozilla::detail::GkAtoms_Atoms = 2197;
            pub const GkAtoms_Atoms_presubscript: root::mozilla::detail::GkAtoms_Atoms = 2198;
            pub const GkAtoms_Atoms_presuperscript: root::mozilla::detail::GkAtoms_Atoms = 2199;
            pub const GkAtoms_Atoms_root_index: root::mozilla::detail::GkAtoms_Atoms = 2200;
            pub const GkAtoms_Atoms_subscript: root::mozilla::detail::GkAtoms_Atoms = 2201;
            pub const GkAtoms_Atoms_superscript: root::mozilla::detail::GkAtoms_Atoms = 2202;
            pub const GkAtoms_Atoms_underscript: root::mozilla::detail::GkAtoms_Atoms = 2203;
            pub const GkAtoms_Atoms_onaudiostart: root::mozilla::detail::GkAtoms_Atoms = 2204;
            pub const GkAtoms_Atoms_onaudioend: root::mozilla::detail::GkAtoms_Atoms = 2205;
            pub const GkAtoms_Atoms_onsoundstart: root::mozilla::detail::GkAtoms_Atoms = 2206;
            pub const GkAtoms_Atoms_onsoundend: root::mozilla::detail::GkAtoms_Atoms = 2207;
            pub const GkAtoms_Atoms_onspeechstart: root::mozilla::detail::GkAtoms_Atoms = 2208;
            pub const GkAtoms_Atoms_onspeechend: root::mozilla::detail::GkAtoms_Atoms = 2209;
            pub const GkAtoms_Atoms_onresult: root::mozilla::detail::GkAtoms_Atoms = 2210;
            pub const GkAtoms_Atoms_onnomatch: root::mozilla::detail::GkAtoms_Atoms = 2211;
            pub const GkAtoms_Atoms_onresume: root::mozilla::detail::GkAtoms_Atoms = 2212;
            pub const GkAtoms_Atoms_onmark: root::mozilla::detail::GkAtoms_Atoms = 2213;
            pub const GkAtoms_Atoms_onboundary: root::mozilla::detail::GkAtoms_Atoms = 2214;
            pub const GkAtoms_Atoms_usercontextid: root::mozilla::detail::GkAtoms_Atoms = 2215;
            pub const GkAtoms_Atoms_nsuri_xmlns: root::mozilla::detail::GkAtoms_Atoms = 2216;
            pub const GkAtoms_Atoms_nsuri_xml: root::mozilla::detail::GkAtoms_Atoms = 2217;
            pub const GkAtoms_Atoms_nsuri_xhtml: root::mozilla::detail::GkAtoms_Atoms = 2218;
            pub const GkAtoms_Atoms_nsuri_xlink: root::mozilla::detail::GkAtoms_Atoms = 2219;
            pub const GkAtoms_Atoms_nsuri_xslt: root::mozilla::detail::GkAtoms_Atoms = 2220;
            pub const GkAtoms_Atoms_nsuri_xbl: root::mozilla::detail::GkAtoms_Atoms = 2221;
            pub const GkAtoms_Atoms_nsuri_mathml: root::mozilla::detail::GkAtoms_Atoms = 2222;
            pub const GkAtoms_Atoms_nsuri_rdf: root::mozilla::detail::GkAtoms_Atoms = 2223;
            pub const GkAtoms_Atoms_nsuri_xul: root::mozilla::detail::GkAtoms_Atoms = 2224;
            pub const GkAtoms_Atoms_nsuri_svg: root::mozilla::detail::GkAtoms_Atoms = 2225;
            pub const GkAtoms_Atoms_nsuri_parsererror: root::mozilla::detail::GkAtoms_Atoms = 2226;
            pub const GkAtoms_Atoms_onsourceopen: root::mozilla::detail::GkAtoms_Atoms = 2227;
            pub const GkAtoms_Atoms_onsourceended: root::mozilla::detail::GkAtoms_Atoms = 2228;
            pub const GkAtoms_Atoms_onsourceclosed: root::mozilla::detail::GkAtoms_Atoms = 2229;
            pub const GkAtoms_Atoms_onupdatestart: root::mozilla::detail::GkAtoms_Atoms = 2230;
            pub const GkAtoms_Atoms_onupdate: root::mozilla::detail::GkAtoms_Atoms = 2231;
            pub const GkAtoms_Atoms_onupdateend: root::mozilla::detail::GkAtoms_Atoms = 2232;
            pub const GkAtoms_Atoms_onaddsourcebuffer: root::mozilla::detail::GkAtoms_Atoms = 2233;
            pub const GkAtoms_Atoms_onremovesourcebuffer: root::mozilla::detail::GkAtoms_Atoms =
                2234;
            pub const GkAtoms_Atoms_about: root::mozilla::detail::GkAtoms_Atoms = 2235;
            pub const GkAtoms_Atoms_ID: root::mozilla::detail::GkAtoms_Atoms = 2236;
            pub const GkAtoms_Atoms_nodeID: root::mozilla::detail::GkAtoms_Atoms = 2237;
            pub const GkAtoms_Atoms_aboutEach: root::mozilla::detail::GkAtoms_Atoms = 2238;
            pub const GkAtoms_Atoms_resource: root::mozilla::detail::GkAtoms_Atoms = 2239;
            pub const GkAtoms_Atoms_RDF: root::mozilla::detail::GkAtoms_Atoms = 2240;
            pub const GkAtoms_Atoms_Description: root::mozilla::detail::GkAtoms_Atoms = 2241;
            pub const GkAtoms_Atoms_Bag: root::mozilla::detail::GkAtoms_Atoms = 2242;
            pub const GkAtoms_Atoms_Seq: root::mozilla::detail::GkAtoms_Atoms = 2243;
            pub const GkAtoms_Atoms_Alt: root::mozilla::detail::GkAtoms_Atoms = 2244;
            pub const GkAtoms_Atoms_parseType: root::mozilla::detail::GkAtoms_Atoms = 2245;
            pub const GkAtoms_Atoms_DirectoryService_CurrentProcess:
                root::mozilla::detail::GkAtoms_Atoms = 2246;
            pub const GkAtoms_Atoms_DirectoryService_GRE_Directory:
                root::mozilla::detail::GkAtoms_Atoms = 2247;
            pub const GkAtoms_Atoms_DirectoryService_GRE_BinDirectory:
                root::mozilla::detail::GkAtoms_Atoms = 2248;
            pub const GkAtoms_Atoms_DirectoryService_OS_TemporaryDirectory:
                root::mozilla::detail::GkAtoms_Atoms = 2249;
            pub const GkAtoms_Atoms_DirectoryService_OS_CurrentProcessDirectory:
                root::mozilla::detail::GkAtoms_Atoms = 2250;
            pub const GkAtoms_Atoms_DirectoryService_OS_CurrentWorkingDirectory:
                root::mozilla::detail::GkAtoms_Atoms = 2251;
            pub const GkAtoms_Atoms_DirectoryService_OS_DesktopDirectory:
                root::mozilla::detail::GkAtoms_Atoms = 2252;
            pub const GkAtoms_Atoms_DirectoryService_InitCurrentProcess_dummy:
                root::mozilla::detail::GkAtoms_Atoms = 2253;
            pub const GkAtoms_Atoms_DirectoryService_SystemDirectory:
                root::mozilla::detail::GkAtoms_Atoms = 2254;
            pub const GkAtoms_Atoms_DirectoryService_UserLibDirectory:
                root::mozilla::detail::GkAtoms_Atoms = 2255;
            pub const GkAtoms_Atoms_DirectoryService_DefaultDownloadDirectory:
                root::mozilla::detail::GkAtoms_Atoms = 2256;
            pub const GkAtoms_Atoms_DirectoryService_LocalApplicationsDirectory:
                root::mozilla::detail::GkAtoms_Atoms = 2257;
            pub const GkAtoms_Atoms_DirectoryService_UserPreferencesDirectory:
                root::mozilla::detail::GkAtoms_Atoms = 2258;
            pub const GkAtoms_Atoms_DirectoryService_PictureDocumentsDirectory:
                root::mozilla::detail::GkAtoms_Atoms = 2259;
            pub const GkAtoms_Atoms_DirectoryService_WindowsDirectory:
                root::mozilla::detail::GkAtoms_Atoms = 2260;
            pub const GkAtoms_Atoms_DirectoryService_WindowsProgramFiles:
                root::mozilla::detail::GkAtoms_Atoms = 2261;
            pub const GkAtoms_Atoms_DirectoryService_Programs:
                root::mozilla::detail::GkAtoms_Atoms = 2262;
            pub const GkAtoms_Atoms_DirectoryService_Favorites:
                root::mozilla::detail::GkAtoms_Atoms = 2263;
            pub const GkAtoms_Atoms_DirectoryService_Appdata: root::mozilla::detail::GkAtoms_Atoms =
                2264;
            pub const GkAtoms_Atoms_DirectoryService_LocalAppdata:
                root::mozilla::detail::GkAtoms_Atoms = 2265;
            pub const GkAtoms_Atoms_DirectoryService_LocalAppdataLow:
                root::mozilla::detail::GkAtoms_Atoms = 2266;
            pub const GkAtoms_Atoms_DirectoryService_LowIntegrityTempBase:
                root::mozilla::detail::GkAtoms_Atoms = 2267;
            pub const GkAtoms_Atoms_DirectoryService_WinCookiesDirectory:
                root::mozilla::detail::GkAtoms_Atoms = 2268;
            pub const GkAtoms_Atoms_PseudoElement_after: root::mozilla::detail::GkAtoms_Atoms =
                2269;
            pub const GkAtoms_Atoms_PseudoElement_before: root::mozilla::detail::GkAtoms_Atoms =
                2270;
            pub const GkAtoms_Atoms_PseudoElement_marker: root::mozilla::detail::GkAtoms_Atoms =
                2271;
            pub const GkAtoms_Atoms_PseudoElement_backdrop: root::mozilla::detail::GkAtoms_Atoms =
                2272;
            pub const GkAtoms_Atoms_PseudoElement_cue: root::mozilla::detail::GkAtoms_Atoms = 2273;
            pub const GkAtoms_Atoms_PseudoElement_firstLetter:
                root::mozilla::detail::GkAtoms_Atoms = 2274;
            pub const GkAtoms_Atoms_PseudoElement_firstLine: root::mozilla::detail::GkAtoms_Atoms =
                2275;
            pub const GkAtoms_Atoms_PseudoElement_selection: root::mozilla::detail::GkAtoms_Atoms =
                2276;
            pub const GkAtoms_Atoms_PseudoElement_mozFocusInner:
                root::mozilla::detail::GkAtoms_Atoms = 2277;
            pub const GkAtoms_Atoms_PseudoElement_mozFocusOuter:
                root::mozilla::detail::GkAtoms_Atoms = 2278;
            pub const GkAtoms_Atoms_PseudoElement_mozMathAnonymous:
                root::mozilla::detail::GkAtoms_Atoms = 2279;
            pub const GkAtoms_Atoms_PseudoElement_mozNumberWrapper:
                root::mozilla::detail::GkAtoms_Atoms = 2280;
            pub const GkAtoms_Atoms_PseudoElement_mozNumberText:
                root::mozilla::detail::GkAtoms_Atoms = 2281;
            pub const GkAtoms_Atoms_PseudoElement_mozNumberSpinBox:
                root::mozilla::detail::GkAtoms_Atoms = 2282;
            pub const GkAtoms_Atoms_PseudoElement_mozNumberSpinUp:
                root::mozilla::detail::GkAtoms_Atoms = 2283;
            pub const GkAtoms_Atoms_PseudoElement_mozNumberSpinDown:
                root::mozilla::detail::GkAtoms_Atoms = 2284;
            pub const GkAtoms_Atoms_PseudoElement_mozProgressBar:
                root::mozilla::detail::GkAtoms_Atoms = 2285;
            pub const GkAtoms_Atoms_PseudoElement_mozRangeTrack:
                root::mozilla::detail::GkAtoms_Atoms = 2286;
            pub const GkAtoms_Atoms_PseudoElement_mozRangeProgress:
                root::mozilla::detail::GkAtoms_Atoms = 2287;
            pub const GkAtoms_Atoms_PseudoElement_mozRangeThumb:
                root::mozilla::detail::GkAtoms_Atoms = 2288;
            pub const GkAtoms_Atoms_PseudoElement_mozMeterBar:
                root::mozilla::detail::GkAtoms_Atoms = 2289;
            pub const GkAtoms_Atoms_PseudoElement_placeholder:
                root::mozilla::detail::GkAtoms_Atoms = 2290;
            pub const GkAtoms_Atoms_PseudoElement_mozColorSwatch:
                root::mozilla::detail::GkAtoms_Atoms = 2291;
            pub const GkAtoms_Atoms_AnonBox_oofPlaceholder: root::mozilla::detail::GkAtoms_Atoms =
                2292;
            pub const GkAtoms_Atoms_AnonBox_horizontalFramesetBorder:
                root::mozilla::detail::GkAtoms_Atoms = 2293;
            pub const GkAtoms_Atoms_AnonBox_verticalFramesetBorder:
                root::mozilla::detail::GkAtoms_Atoms = 2294;
            pub const GkAtoms_Atoms_AnonBox_framesetBlank: root::mozilla::detail::GkAtoms_Atoms =
                2295;
            pub const GkAtoms_Atoms_AnonBox_tableColGroup: root::mozilla::detail::GkAtoms_Atoms =
                2296;
            pub const GkAtoms_Atoms_AnonBox_tableCol: root::mozilla::detail::GkAtoms_Atoms = 2297;
            pub const GkAtoms_Atoms_AnonBox_pageBreak: root::mozilla::detail::GkAtoms_Atoms = 2298;
            pub const GkAtoms_Atoms_AnonBox_columnSpanWrapper:
                root::mozilla::detail::GkAtoms_Atoms = 2299;
            pub const GkAtoms_Atoms_AnonBox_mozText: root::mozilla::detail::GkAtoms_Atoms = 2300;
            pub const GkAtoms_Atoms_AnonBox_firstLetterContinuation:
                root::mozilla::detail::GkAtoms_Atoms = 2301;
            pub const GkAtoms_Atoms_AnonBox_mozBlockInsideInlineWrapper:
                root::mozilla::detail::GkAtoms_Atoms = 2302;
            pub const GkAtoms_Atoms_AnonBox_mozMathMLAnonymousBlock:
                root::mozilla::detail::GkAtoms_Atoms = 2303;
            pub const GkAtoms_Atoms_AnonBox_mozXULAnonymousBlock:
                root::mozilla::detail::GkAtoms_Atoms = 2304;
            pub const GkAtoms_Atoms_AnonBox_mozLineFrame: root::mozilla::detail::GkAtoms_Atoms =
                2305;
            pub const GkAtoms_Atoms_AnonBox_buttonContent: root::mozilla::detail::GkAtoms_Atoms =
                2306;
            pub const GkAtoms_Atoms_AnonBox_cellContent: root::mozilla::detail::GkAtoms_Atoms =
                2307;
            pub const GkAtoms_Atoms_AnonBox_dropDownList: root::mozilla::detail::GkAtoms_Atoms =
                2308;
            pub const GkAtoms_Atoms_AnonBox_fieldsetContent: root::mozilla::detail::GkAtoms_Atoms =
                2309;
            pub const GkAtoms_Atoms_AnonBox_mozDisplayComboboxControlFrame:
                root::mozilla::detail::GkAtoms_Atoms = 2310;
            pub const GkAtoms_Atoms_AnonBox_htmlCanvasContent:
                root::mozilla::detail::GkAtoms_Atoms = 2311;
            pub const GkAtoms_Atoms_AnonBox_inlineTable: root::mozilla::detail::GkAtoms_Atoms =
                2312;
            pub const GkAtoms_Atoms_AnonBox_table: root::mozilla::detail::GkAtoms_Atoms = 2313;
            pub const GkAtoms_Atoms_AnonBox_tableCell: root::mozilla::detail::GkAtoms_Atoms = 2314;
            pub const GkAtoms_Atoms_AnonBox_tableWrapper: root::mozilla::detail::GkAtoms_Atoms =
                2315;
            pub const GkAtoms_Atoms_AnonBox_tableRowGroup: root::mozilla::detail::GkAtoms_Atoms =
                2316;
            pub const GkAtoms_Atoms_AnonBox_tableRow: root::mozilla::detail::GkAtoms_Atoms = 2317;
            pub const GkAtoms_Atoms_AnonBox_canvas: root::mozilla::detail::GkAtoms_Atoms = 2318;
            pub const GkAtoms_Atoms_AnonBox_page: root::mozilla::detail::GkAtoms_Atoms = 2319;
            pub const GkAtoms_Atoms_AnonBox_pageContent: root::mozilla::detail::GkAtoms_Atoms =
                2320;
            pub const GkAtoms_Atoms_AnonBox_pageSequence: root::mozilla::detail::GkAtoms_Atoms =
                2321;
            pub const GkAtoms_Atoms_AnonBox_scrolledContent: root::mozilla::detail::GkAtoms_Atoms =
                2322;
            pub const GkAtoms_Atoms_AnonBox_scrolledCanvas: root::mozilla::detail::GkAtoms_Atoms =
                2323;
            pub const GkAtoms_Atoms_AnonBox_scrolledPageSequence:
                root::mozilla::detail::GkAtoms_Atoms = 2324;
            pub const GkAtoms_Atoms_AnonBox_columnSet: root::mozilla::detail::GkAtoms_Atoms = 2325;
            pub const GkAtoms_Atoms_AnonBox_columnContent: root::mozilla::detail::GkAtoms_Atoms =
                2326;
            pub const GkAtoms_Atoms_AnonBox_viewport: root::mozilla::detail::GkAtoms_Atoms = 2327;
            pub const GkAtoms_Atoms_AnonBox_viewportScroll: root::mozilla::detail::GkAtoms_Atoms =
                2328;
            pub const GkAtoms_Atoms_AnonBox_anonymousFlexItem:
                root::mozilla::detail::GkAtoms_Atoms = 2329;
            pub const GkAtoms_Atoms_AnonBox_anonymousGridItem:
                root::mozilla::detail::GkAtoms_Atoms = 2330;
            pub const GkAtoms_Atoms_AnonBox_ruby: root::mozilla::detail::GkAtoms_Atoms = 2331;
            pub const GkAtoms_Atoms_AnonBox_rubyBase: root::mozilla::detail::GkAtoms_Atoms = 2332;
            pub const GkAtoms_Atoms_AnonBox_rubyBaseContainer:
                root::mozilla::detail::GkAtoms_Atoms = 2333;
            pub const GkAtoms_Atoms_AnonBox_rubyText: root::mozilla::detail::GkAtoms_Atoms = 2334;
            pub const GkAtoms_Atoms_AnonBox_rubyTextContainer:
                root::mozilla::detail::GkAtoms_Atoms = 2335;
            pub const GkAtoms_Atoms_AnonBox_mozTreeColumn: root::mozilla::detail::GkAtoms_Atoms =
                2336;
            pub const GkAtoms_Atoms_AnonBox_mozTreeRow: root::mozilla::detail::GkAtoms_Atoms = 2337;
            pub const GkAtoms_Atoms_AnonBox_mozTreeSeparator: root::mozilla::detail::GkAtoms_Atoms =
                2338;
            pub const GkAtoms_Atoms_AnonBox_mozTreeCell: root::mozilla::detail::GkAtoms_Atoms =
                2339;
            pub const GkAtoms_Atoms_AnonBox_mozTreeIndentation:
                root::mozilla::detail::GkAtoms_Atoms = 2340;
            pub const GkAtoms_Atoms_AnonBox_mozTreeLine: root::mozilla::detail::GkAtoms_Atoms =
                2341;
            pub const GkAtoms_Atoms_AnonBox_mozTreeTwisty: root::mozilla::detail::GkAtoms_Atoms =
                2342;
            pub const GkAtoms_Atoms_AnonBox_mozTreeImage: root::mozilla::detail::GkAtoms_Atoms =
                2343;
            pub const GkAtoms_Atoms_AnonBox_mozTreeCellText: root::mozilla::detail::GkAtoms_Atoms =
                2344;
            pub const GkAtoms_Atoms_AnonBox_mozTreeCheckbox: root::mozilla::detail::GkAtoms_Atoms =
                2345;
            pub const GkAtoms_Atoms_AnonBox_mozTreeDropFeedback:
                root::mozilla::detail::GkAtoms_Atoms = 2346;
            pub const GkAtoms_Atoms_AnonBox_mozSVGMarkerAnonChild:
                root::mozilla::detail::GkAtoms_Atoms = 2347;
            pub const GkAtoms_Atoms_AnonBox_mozSVGOuterSVGAnonChild:
                root::mozilla::detail::GkAtoms_Atoms = 2348;
            pub const GkAtoms_Atoms_AnonBox_mozSVGForeignContent:
                root::mozilla::detail::GkAtoms_Atoms = 2349;
            pub const GkAtoms_Atoms_AnonBox_mozSVGText: root::mozilla::detail::GkAtoms_Atoms = 2350;
            pub const GkAtoms_Atoms_xlink: root::mozilla::detail::GkAtoms_Atoms = 2351;
            pub const GkAtoms_Atoms_xml_space: root::mozilla::detail::GkAtoms_Atoms = 2352;
            pub const GkAtoms_Atoms_xml_lang: root::mozilla::detail::GkAtoms_Atoms = 2353;
            pub const GkAtoms_Atoms_aria_grab: root::mozilla::detail::GkAtoms_Atoms = 2354;
            pub const GkAtoms_Atoms_aria_channel: root::mozilla::detail::GkAtoms_Atoms = 2355;
            pub const GkAtoms_Atoms_aria_secret: root::mozilla::detail::GkAtoms_Atoms = 2356;
            pub const GkAtoms_Atoms_aria_templateid: root::mozilla::detail::GkAtoms_Atoms = 2357;
            pub const GkAtoms_Atoms_aria_datatype: root::mozilla::detail::GkAtoms_Atoms = 2358;
            pub const GkAtoms_Atoms_local: root::mozilla::detail::GkAtoms_Atoms = 2359;
            pub const GkAtoms_Atoms_xchannelselector: root::mozilla::detail::GkAtoms_Atoms = 2360;
            pub const GkAtoms_Atoms_ychannelselector: root::mozilla::detail::GkAtoms_Atoms = 2361;
            pub const GkAtoms_Atoms_enable_background: root::mozilla::detail::GkAtoms_Atoms = 2362;
            pub const GkAtoms_Atoms_calcmode: root::mozilla::detail::GkAtoms_Atoms = 2363;
            pub const GkAtoms_Atoms_specularexponent: root::mozilla::detail::GkAtoms_Atoms = 2364;
            pub const GkAtoms_Atoms_specularconstant: root::mozilla::detail::GkAtoms_Atoms = 2365;
            pub const GkAtoms_Atoms_gradienttransform: root::mozilla::detail::GkAtoms_Atoms = 2366;
            pub const GkAtoms_Atoms_gradientunits: root::mozilla::detail::GkAtoms_Atoms = 2367;
            pub const GkAtoms_Atoms_rendering_intent: root::mozilla::detail::GkAtoms_Atoms = 2368;
            pub const GkAtoms_Atoms_stddeviation: root::mozilla::detail::GkAtoms_Atoms = 2369;
            pub const GkAtoms_Atoms_basefrequency: root::mozilla::detail::GkAtoms_Atoms = 2370;
            pub const GkAtoms_Atoms_baseprofile: root::mozilla::detail::GkAtoms_Atoms = 2371;
            pub const GkAtoms_Atoms_baseProfile: root::mozilla::detail::GkAtoms_Atoms = 2372;
            pub const GkAtoms_Atoms_edgemode: root::mozilla::detail::GkAtoms_Atoms = 2373;
            pub const GkAtoms_Atoms_repeatcount: root::mozilla::detail::GkAtoms_Atoms = 2374;
            pub const GkAtoms_Atoms_repeatdur: root::mozilla::detail::GkAtoms_Atoms = 2375;
            pub const GkAtoms_Atoms_spreadmethod: root::mozilla::detail::GkAtoms_Atoms = 2376;
            pub const GkAtoms_Atoms_diffuseconstant: root::mozilla::detail::GkAtoms_Atoms = 2377;
            pub const GkAtoms_Atoms_surfacescale: root::mozilla::detail::GkAtoms_Atoms = 2378;
            pub const GkAtoms_Atoms_lengthadjust: root::mozilla::detail::GkAtoms_Atoms = 2379;
            pub const GkAtoms_Atoms_origin: root::mozilla::detail::GkAtoms_Atoms = 2380;
            pub const GkAtoms_Atoms_targetx: root::mozilla::detail::GkAtoms_Atoms = 2381;
            pub const GkAtoms_Atoms_targety: root::mozilla::detail::GkAtoms_Atoms = 2382;
            pub const GkAtoms_Atoms_pathlength: root::mozilla::detail::GkAtoms_Atoms = 2383;
            pub const GkAtoms_Atoms_definitionurl: root::mozilla::detail::GkAtoms_Atoms = 2384;
            pub const GkAtoms_Atoms_limitingconeangle: root::mozilla::detail::GkAtoms_Atoms = 2385;
            pub const GkAtoms_Atoms_markerheight: root::mozilla::detail::GkAtoms_Atoms = 2386;
            pub const GkAtoms_Atoms_markerwidth: root::mozilla::detail::GkAtoms_Atoms = 2387;
            pub const GkAtoms_Atoms_maskunits: root::mozilla::detail::GkAtoms_Atoms = 2388;
            pub const GkAtoms_Atoms_markerunits: root::mozilla::detail::GkAtoms_Atoms = 2389;
            pub const GkAtoms_Atoms_maskcontentunits: root::mozilla::detail::GkAtoms_Atoms = 2390;
            pub const GkAtoms_Atoms_tablevalues: root::mozilla::detail::GkAtoms_Atoms = 2391;
            pub const GkAtoms_Atoms_primitiveunits: root::mozilla::detail::GkAtoms_Atoms = 2392;
            pub const GkAtoms_Atoms_zoomandpan: root::mozilla::detail::GkAtoms_Atoms = 2393;
            pub const GkAtoms_Atoms_kernelmatrix: root::mozilla::detail::GkAtoms_Atoms = 2394;
            pub const GkAtoms_Atoms_kerning: root::mozilla::detail::GkAtoms_Atoms = 2395;
            pub const GkAtoms_Atoms_kernelunitlength: root::mozilla::detail::GkAtoms_Atoms = 2396;
            pub const GkAtoms_Atoms_pointsatx: root::mozilla::detail::GkAtoms_Atoms = 2397;
            pub const GkAtoms_Atoms_pointsaty: root::mozilla::detail::GkAtoms_Atoms = 2398;
            pub const GkAtoms_Atoms_pointsatz: root::mozilla::detail::GkAtoms_Atoms = 2399;
            pub const GkAtoms_Atoms_xlink_href: root::mozilla::detail::GkAtoms_Atoms = 2400;
            pub const GkAtoms_Atoms_xlink_title: root::mozilla::detail::GkAtoms_Atoms = 2401;
            pub const GkAtoms_Atoms_xlink_role: root::mozilla::detail::GkAtoms_Atoms = 2402;
            pub const GkAtoms_Atoms_xlink_arcrole: root::mozilla::detail::GkAtoms_Atoms = 2403;
            pub const GkAtoms_Atoms_arcrole: root::mozilla::detail::GkAtoms_Atoms = 2404;
            pub const GkAtoms_Atoms_xmlns_xlink: root::mozilla::detail::GkAtoms_Atoms = 2405;
            pub const GkAtoms_Atoms_xlink_type: root::mozilla::detail::GkAtoms_Atoms = 2406;
            pub const GkAtoms_Atoms_xlink_show: root::mozilla::detail::GkAtoms_Atoms = 2407;
            pub const GkAtoms_Atoms_xlink_actuate: root::mozilla::detail::GkAtoms_Atoms = 2408;
            pub const GkAtoms_Atoms_color_rendering: root::mozilla::detail::GkAtoms_Atoms = 2409;
            pub const GkAtoms_Atoms_numoctaves: root::mozilla::detail::GkAtoms_Atoms = 2410;
            pub const GkAtoms_Atoms_onmousewheel: root::mozilla::detail::GkAtoms_Atoms = 2411;
            pub const GkAtoms_Atoms_clippathunits: root::mozilla::detail::GkAtoms_Atoms = 2412;
            pub const GkAtoms_Atoms_glyph_orientation_vertical:
                root::mozilla::detail::GkAtoms_Atoms = 2413;
            pub const GkAtoms_Atoms_glyph_orientation_horizontal:
                root::mozilla::detail::GkAtoms_Atoms = 2414;
            pub const GkAtoms_Atoms_glyphref: root::mozilla::detail::GkAtoms_Atoms = 2415;
            pub const GkAtoms_Atoms_keypoints: root::mozilla::detail::GkAtoms_Atoms = 2416;
            pub const GkAtoms_Atoms_attributename: root::mozilla::detail::GkAtoms_Atoms = 2417;
            pub const GkAtoms_Atoms_attributetype: root::mozilla::detail::GkAtoms_Atoms = 2418;
            pub const GkAtoms_Atoms_startoffset: root::mozilla::detail::GkAtoms_Atoms = 2419;
            pub const GkAtoms_Atoms_keysplines: root::mozilla::detail::GkAtoms_Atoms = 2420;
            pub const GkAtoms_Atoms_preservealpha: root::mozilla::detail::GkAtoms_Atoms = 2421;
            pub const GkAtoms_Atoms_preserveaspectratio: root::mozilla::detail::GkAtoms_Atoms =
                2422;
            pub const GkAtoms_Atoms_alttext: root::mozilla::detail::GkAtoms_Atoms = 2423;
            pub const GkAtoms_Atoms_filterunits: root::mozilla::detail::GkAtoms_Atoms = 2424;
            pub const GkAtoms_Atoms_keytimes: root::mozilla::detail::GkAtoms_Atoms = 2425;
            pub const GkAtoms_Atoms_patterntransform: root::mozilla::detail::GkAtoms_Atoms = 2426;
            pub const GkAtoms_Atoms_patternunits: root::mozilla::detail::GkAtoms_Atoms = 2427;
            pub const GkAtoms_Atoms_patterncontentunits: root::mozilla::detail::GkAtoms_Atoms =
                2428;
            pub const GkAtoms_Atoms_stitchtiles: root::mozilla::detail::GkAtoms_Atoms = 2429;
            pub const GkAtoms_Atoms_systemlanguage: root::mozilla::detail::GkAtoms_Atoms = 2430;
            pub const GkAtoms_Atoms_textlength: root::mozilla::detail::GkAtoms_Atoms = 2431;
            pub const GkAtoms_Atoms_requiredfeatures: root::mozilla::detail::GkAtoms_Atoms = 2432;
            pub const GkAtoms_Atoms_requiredextensions: root::mozilla::detail::GkAtoms_Atoms = 2433;
            pub const GkAtoms_Atoms_viewtarget: root::mozilla::detail::GkAtoms_Atoms = 2434;
            pub const GkAtoms_Atoms_viewbox: root::mozilla::detail::GkAtoms_Atoms = 2435;
            pub const GkAtoms_Atoms_refx: root::mozilla::detail::GkAtoms_Atoms = 2436;
            pub const GkAtoms_Atoms_refy: root::mozilla::detail::GkAtoms_Atoms = 2437;
            pub const GkAtoms_Atoms_fefunca: root::mozilla::detail::GkAtoms_Atoms = 2438;
            pub const GkAtoms_Atoms_fefuncb: root::mozilla::detail::GkAtoms_Atoms = 2439;
            pub const GkAtoms_Atoms_feblend: root::mozilla::detail::GkAtoms_Atoms = 2440;
            pub const GkAtoms_Atoms_feflood: root::mozilla::detail::GkAtoms_Atoms = 2441;
            pub const GkAtoms_Atoms_feturbulence: root::mozilla::detail::GkAtoms_Atoms = 2442;
            pub const GkAtoms_Atoms_femergenode: root::mozilla::detail::GkAtoms_Atoms = 2443;
            pub const GkAtoms_Atoms_feimage: root::mozilla::detail::GkAtoms_Atoms = 2444;
            pub const GkAtoms_Atoms_femerge: root::mozilla::detail::GkAtoms_Atoms = 2445;
            pub const GkAtoms_Atoms_fetile: root::mozilla::detail::GkAtoms_Atoms = 2446;
            pub const GkAtoms_Atoms_fecomposite: root::mozilla::detail::GkAtoms_Atoms = 2447;
            pub const GkAtoms_Atoms_altglyphdef: root::mozilla::detail::GkAtoms_Atoms = 2448;
            pub const GkAtoms_Atoms_altGlyphDef: root::mozilla::detail::GkAtoms_Atoms = 2449;
            pub const GkAtoms_Atoms_fefuncg: root::mozilla::detail::GkAtoms_Atoms = 2450;
            pub const GkAtoms_Atoms_fediffuselighting: root::mozilla::detail::GkAtoms_Atoms = 2451;
            pub const GkAtoms_Atoms_fespecularlighting: root::mozilla::detail::GkAtoms_Atoms = 2452;
            pub const GkAtoms_Atoms_altglyph: root::mozilla::detail::GkAtoms_Atoms = 2453;
            pub const GkAtoms_Atoms_altGlyph: root::mozilla::detail::GkAtoms_Atoms = 2454;
            pub const GkAtoms_Atoms_clippath: root::mozilla::detail::GkAtoms_Atoms = 2455;
            pub const GkAtoms_Atoms_textpath: root::mozilla::detail::GkAtoms_Atoms = 2456;
            pub const GkAtoms_Atoms_altglyphitem: root::mozilla::detail::GkAtoms_Atoms = 2457;
            pub const GkAtoms_Atoms_altGlyphItem: root::mozilla::detail::GkAtoms_Atoms = 2458;
            pub const GkAtoms_Atoms_animatetransform: root::mozilla::detail::GkAtoms_Atoms = 2459;
            pub const GkAtoms_Atoms_animatemotion: root::mozilla::detail::GkAtoms_Atoms = 2460;
            pub const GkAtoms_Atoms_fedisplacementmap: root::mozilla::detail::GkAtoms_Atoms = 2461;
            pub const GkAtoms_Atoms_animatecolor: root::mozilla::detail::GkAtoms_Atoms = 2462;
            pub const GkAtoms_Atoms_fefuncr: root::mozilla::detail::GkAtoms_Atoms = 2463;
            pub const GkAtoms_Atoms_fecomponenttransfer: root::mozilla::detail::GkAtoms_Atoms =
                2464;
            pub const GkAtoms_Atoms_fegaussianblur: root::mozilla::detail::GkAtoms_Atoms = 2465;
            pub const GkAtoms_Atoms_foreignobject: root::mozilla::detail::GkAtoms_Atoms = 2466;
            pub const GkAtoms_Atoms_feoffset: root::mozilla::detail::GkAtoms_Atoms = 2467;
            pub const GkAtoms_Atoms_fespotlight: root::mozilla::detail::GkAtoms_Atoms = 2468;
            pub const GkAtoms_Atoms_fepointlight: root::mozilla::detail::GkAtoms_Atoms = 2469;
            pub const GkAtoms_Atoms_fedistantlight: root::mozilla::detail::GkAtoms_Atoms = 2470;
            pub const GkAtoms_Atoms_lineargradient: root::mozilla::detail::GkAtoms_Atoms = 2471;
            pub const GkAtoms_Atoms_radialgradient: root::mozilla::detail::GkAtoms_Atoms = 2472;
            pub const GkAtoms_Atoms_fedropshadow: root::mozilla::detail::GkAtoms_Atoms = 2473;
            pub const GkAtoms_Atoms_fecolormatrix: root::mozilla::detail::GkAtoms_Atoms = 2474;
            pub const GkAtoms_Atoms_feconvolvematrix: root::mozilla::detail::GkAtoms_Atoms = 2475;
            pub const GkAtoms_Atoms_femorphology: root::mozilla::detail::GkAtoms_Atoms = 2476;
            pub const GkAtoms_Atoms_AtomsCount: root::mozilla::detail::GkAtoms_Atoms = 2477;
            pub type GkAtoms_Atoms = i32;
            #[test]
            fn bindgen_test_layout_GkAtoms() {
                assert_eq!(
                    ::std::mem::size_of::<GkAtoms>(),
                    87028usize,
                    concat!("Size of: ", stringify!(GkAtoms))
                );
                assert_eq!(
                    ::std::mem::align_of::<GkAtoms>(),
                    4usize,
                    concat!("Alignment of ", stringify!(GkAtoms))
                );
            }
            pub const kGkAtomsArrayOffset: isize = 57304;
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla6detail8gGkAtomsE"]
                pub static gGkAtoms: root::mozilla::detail::GkAtoms;
            }
            #[doc = " LinkedList supports refcounted elements using this adapter class. Clients"]
            #[doc = " using LinkedList<RefPtr<T>> will get a data structure that holds a strong"]
            #[doc = " reference to T as long as T is in the list."]
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct LinkedListElementTraits {
                pub _address: u8,
            }
            pub type LinkedListElementTraits_RawType<T> = *mut T;
            pub type LinkedListElementTraits_ConstRawType<T> = *const T;
            pub type LinkedListElementTraits_ClientType<T> = *mut T;
            pub type LinkedListElementTraits_ConstClientType<T> = *const T;
            #[repr(C)]
            #[derive(Debug)]
            pub struct HashTableEntry {
                pub mValueData: *mut ::std::os::raw::c_uchar,
            }
            pub type HashTableEntry_NonConstT = root::mozilla::RemoveConst;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct EntrySlot {
                pub mEntry: *mut root::mozilla::detail::EntrySlot_Entry,
                pub mKeyHash: *mut root::mozilla::HashNumber,
            }
            pub type EntrySlot_NonConstT = root::mozilla::RemoveConst;
            pub type EntrySlot_Entry = root::mozilla::detail::HashTableEntry;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct HashTable {
                pub _address: u8,
            }
            pub type HashTable_NonConstT = root::mozilla::RemoveConst;
            pub type HashTable_Key = [u8; 0usize];
            pub type HashTable_Lookup = [u8; 0usize];
            pub type HashTable_Entry = root::mozilla::detail::HashTableEntry;
            pub type HashTable_Slot = root::mozilla::detail::EntrySlot;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct HashTable_Ptr {
                pub mSlot: root::mozilla::detail::HashTable_Slot,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct HashTable_AddPtr {
                pub _base: root::mozilla::detail::HashTable_Ptr,
                pub mKeyHash: root::mozilla::HashNumber,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct HashTable_Iterator {
                pub mCur: root::mozilla::detail::HashTable_Slot,
                pub mEnd: root::mozilla::detail::HashTable_Slot,
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct HashTable_ModIterator {
                pub _base: root::mozilla::detail::HashTable_Iterator,
                pub mTable: *mut u8,
                pub mRekeyed: bool,
                pub mRemoved: bool,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct HashTable_Range {
                pub mIter: root::mozilla::detail::HashTable_Iterator,
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct HashTable_Enum {
                pub mIter: root::mozilla::detail::HashTable_ModIterator,
            }
            pub const HashTable_FailureBehavior_DontReportFailure:
                root::mozilla::detail::HashTable_FailureBehavior = 0;
            pub const HashTable_FailureBehavior_ReportFailure:
                root::mozilla::detail::HashTable_FailureBehavior = 0;
            pub type HashTable_FailureBehavior = i32;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct HashTable_FakeSlot {
                pub c: *mut ::std::os::raw::c_uchar,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct HashTable_DoubleHash {
                pub mHash2: root::mozilla::HashNumber,
                pub mSizeMask: root::mozilla::HashNumber,
            }
            pub const HashTable_LookupReason_ForNonAdd:
                root::mozilla::detail::HashTable_LookupReason = 0;
            pub const HashTable_LookupReason_ForAdd: root::mozilla::detail::HashTable_LookupReason =
                0;
            pub type HashTable_LookupReason = i32;
            pub const HashTable_RebuildStatus_NotOverloaded:
                root::mozilla::detail::HashTable_RebuildStatus = 0;
            pub const HashTable_RebuildStatus_Rehashed:
                root::mozilla::detail::HashTable_RebuildStatus = 0;
            pub const HashTable_RebuildStatus_RehashFailed:
                root::mozilla::detail::HashTable_RebuildStatus = 0;
            pub type HashTable_RebuildStatus = i32;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct WeakReference {
                pub _address: u8,
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct ConditionVariableImpl {
                pub platformData_: [*mut ::std::os::raw::c_void; 6usize],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ConditionVariableImpl_PlatformData {
                _unused: [u8; 0],
            }
            #[test]
            fn bindgen_test_layout_ConditionVariableImpl() {
                assert_eq!(
                    ::std::mem::size_of::<ConditionVariableImpl>(),
                    48usize,
                    concat!("Size of: ", stringify!(ConditionVariableImpl))
                );
                assert_eq!(
                    ::std::mem::align_of::<ConditionVariableImpl>(),
                    8usize,
                    concat!("Alignment of ", stringify!(ConditionVariableImpl))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ConditionVariableImpl>())).platformData_ as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ConditionVariableImpl),
                        "::",
                        stringify!(platformData_)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct FreePolicy {
                pub _address: u8,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct FramePropertyTypeHelper {
                pub _address: u8,
            }
            pub type FramePropertyTypeHelper_Type<T> = *mut T;
        }
        pub type fallible_t = root::std::nothrow_t;
        pub type IntegralConstant_ValueType<T> = T;
        pub type IntegralConstant_Type = u8;
        #[doc = " Convenient aliases."]
        pub type TrueType = u8;
        pub type FalseType = u8;
        #[doc = " RemoveConst removes top-level const qualifications on a type."]
        #[doc = ""]
        #[doc = " mozilla::RemoveConst<int>::Type is int;"]
        #[doc = " mozilla::RemoveConst<const int>::Type is int;"]
        #[doc = " mozilla::RemoveConst<const int*>::Type is const int*;"]
        #[doc = " mozilla::RemoveConst<int* const>::Type is int*."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct RemoveConst {
            pub _address: u8,
        }
        pub type RemoveConst_Type<T> = T;
        pub type Conditional_Type<A> = A;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct Nothing {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_Nothing() {
            assert_eq!(
                ::std::mem::size_of::<Nothing>(),
                1usize,
                concat!("Size of: ", stringify!(Nothing))
            );
            assert_eq!(
                ::std::mem::align_of::<Nothing>(),
                1usize,
                concat!("Alignment of ", stringify!(Nothing))
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct Maybe {
            pub _address: u8,
        }
        pub type Maybe_ValueType<T> = T;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct ReverseIterator<IteratorT> {
            pub mCurrent: IteratorT,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<IteratorT>>,
        }
        pub type Array_iterator<T> = *mut T;
        pub type Array_const_iterator<T> = *const T;
        pub type Array_reverse_iterator<T> = root::mozilla::ReverseIterator<T>;
        pub type Array_const_reverse_iterator<T> = root::mozilla::ReverseIterator<T>;
        #[doc = " A default deletion policy using plain old operator delete."]
        #[doc = ""]
        #[doc = " Note that this type can be specialized, but authors should beware of the risk"]
        #[doc = " that the specialization may at some point cease to match (either because it"]
        #[doc = " gets moved to a different compilation unit or the signature changes). If the"]
        #[doc = " non-specialized (|delete|-based) version compiles for that type but does the"]
        #[doc = " wrong thing, bad things could happen."]
        #[doc = ""]
        #[doc = " This is a non-issue for types which are always incomplete (i.e. opaque handle"]
        #[doc = " types), since |delete|-ing such a type will always trigger a compilation"]
        #[doc = " error."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct DefaultDelete {
            pub _address: u8,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StaticRefPtr<T> {
            pub mRawPtr: *mut T,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
        }
        pub type MallocSizeOf =
            ::std::option::Option<unsafe extern "C" fn(p: *const ::std::os::raw::c_void) -> usize>;
        pub type HashNumber = u32;
        #[doc = " # mozilla::Variant"]
        #[doc = ""]
        #[doc = " A variant / tagged union / heterogenous disjoint union / sum-type template"]
        #[doc = " class. Similar in concept to (but not derived from) `boost::variant`."]
        #[doc = ""]
        #[doc = " Sometimes, you may wish to use a C union with non-POD types. However, this is"]
        #[doc = " forbidden in C++ because it is not clear which type in the union should have"]
        #[doc = " its constructor and destructor run on creation and deletion"]
        #[doc = " respectively. This is the problem that `mozilla::Variant` solves."]
        #[doc = ""]
        #[doc = " ## Usage"]
        #[doc = ""]
        #[doc = " A `mozilla::Variant` instance is constructed (via move or copy) from one of"]
        #[doc = " its variant types (ignoring const and references). It does *not* support"]
        #[doc = " construction from subclasses of variant types or types that coerce to one of"]
        #[doc = " the variant types."]
        #[doc = ""]
        #[doc = "     Variant<char, uint32_t> v1(\'a\');"]
        #[doc = "     Variant<UniquePtr<A>, B, C> v2(MakeUnique<A>());"]
        #[doc = "     Variant<bool, char> v3(VariantType<char>, 0); // disambiguation needed"]
        #[doc = "     Variant<int, int> v4(VariantIndex<1>, 0); // 2nd int"]
        #[doc = ""]
        #[doc = " Because specifying the full type of a Variant value is often verbose,"]
        #[doc = " there are two easier ways to construct values:"]
        #[doc = ""]
        #[doc = " A. AsVariant() can be used to construct a Variant value using type inference"]
        #[doc = " in contexts such as expressions or when returning values from functions."]
        #[doc = " Because AsVariant() must copy or move the value into a temporary and this"]
        #[doc = " cannot necessarily be elided by the compiler, it\'s mostly appropriate only"]
        #[doc = " for use with primitive or very small types."]
        #[doc = ""]
        #[doc = "     Variant<char, uint32_t> Foo() { return AsVariant(\'x\'); }"]
        #[doc = "     // ..."]
        #[doc = "     Variant<char, uint32_t> v1 = Foo();  // v1 holds char(\'x\')."]
        #[doc = ""]
        #[doc = " B. Brace-construction with VariantType or VariantIndex; this also allows"]
        #[doc = " in-place construction with any number of arguments."]
        #[doc = ""]
        #[doc = "     struct AB { AB(int, int){...} };"]
        #[doc = "     static Variant<AB, bool> foo()"]
        #[doc = "     {"]
        #[doc = "       return {VariantIndex<0>{}, 1, 2};"]
        #[doc = "     }"]
        #[doc = "     // ..."]
        #[doc = "     Variant<AB, bool> v0 = Foo();  // v0 holds AB(1,2)."]
        #[doc = ""]
        #[doc = " All access to the contained value goes through type-safe accessors."]
        #[doc = " Either the stored type, or the type index may be provided."]
        #[doc = ""]
        #[doc = "     void"]
        #[doc = "     Foo(Variant<A, B, C> v)"]
        #[doc = "     {"]
        #[doc = "       if (v.is<A>()) {"]
        #[doc = "         A& ref = v.as<A>();"]
        #[doc = "         ..."]
        #[doc = "       } else (v.is<1>()) { // Instead of v.is<B>."]
        #[doc = "         ..."]
        #[doc = "       } else {"]
        #[doc = "         ..."]
        #[doc = "       }"]
        #[doc = "     }"]
        #[doc = ""]
        #[doc = " In some situation, a Variant may be constructed from templated types, in"]
        #[doc = " which case it is possible that the same type could be given multiple times by"]
        #[doc = " an external developer. Or seemingly-different types could be aliases."]
        #[doc = " In this case, repeated types can only be accessed through their index, to"]
        #[doc = " prevent ambiguous access by type."]
        #[doc = ""]
        #[doc = "    // Bad!"]
        #[doc = "    template <typename T>"]
        #[doc = "    struct ResultOrError"]
        #[doc = "    {"]
        #[doc = "      Variant<T, int> m;"]
        #[doc = "      ResultOrError() : m(int(0)) {} // Error \'0\' by default"]
        #[doc = "      ResultOrError(const T& r) : m(r) {}"]
        #[doc = "      bool IsResult() const { return m.is<T>(); }"]
        #[doc = "      bool IsError() const { return m.is<int>(); }"]
        #[doc = "    };"]
        #[doc = "    // Now instantiante with the result being an int too:"]
        #[doc = "    ResultOrError<int> myResult(123); // Fail!"]
        #[doc = "    // In Variant<int, int>, which \'int\' are we refering to, from inside"]
        #[doc = "    // ResultOrError functions?"]
        #[doc = ""]
        #[doc = "    // Good!"]
        #[doc = "    template <typename T>"]
        #[doc = "    struct ResultOrError"]
        #[doc = "    {"]
        #[doc = "      Variant<T, int> m;"]
        #[doc = "      ResultOrError() : m(VariantIndex<1>{}, 0) {} // Error \'0\' by default"]
        #[doc = "      ResultOrError(const T& r) : m(VariantIndex<0>{}, r) {}"]
        #[doc = "      bool IsResult() const { return m.is<0>(); } // 0 -> T"]
        #[doc = "      bool IsError() const { return m.is<1>(); } // 1 -> int"]
        #[doc = "    };"]
        #[doc = "    // Now instantiante with the result being an int too:"]
        #[doc = "    ResultOrError<int> myResult(123); // It now works!"]
        #[doc = ""]
        #[doc = " Attempting to use the contained value as type `T1` when the `Variant`"]
        #[doc = " instance contains a value of type `T2` causes an assertion failure."]
        #[doc = ""]
        #[doc = "     A a;"]
        #[doc = "     Variant<A, B, C> v(a);"]
        #[doc = "     v.as<B>(); // <--- Assertion failure!"]
        #[doc = ""]
        #[doc = " Trying to use a `Variant<Ts...>` instance as some type `U` that is not a"]
        #[doc = " member of the set of `Ts...` is a compiler error."]
        #[doc = ""]
        #[doc = "     A a;"]
        #[doc = "     Variant<A, B, C> v(a);"]
        #[doc = "     v.as<SomeRandomType>(); // <--- Compiler error!"]
        #[doc = ""]
        #[doc = " Additionally, you can turn a `Variant` that `is<T>` into a `T` by moving it"]
        #[doc = " out of the containing `Variant` instance with the `extract<T>` method:"]
        #[doc = ""]
        #[doc = "     Variant<UniquePtr<A>, B, C> v(MakeUnique<A>());"]
        #[doc = "     auto ptr = v.extract<UniquePtr<A>>();"]
        #[doc = ""]
        #[doc = " Finally, you can exhaustively match on the contained variant and branch into"]
        #[doc = " different code paths depending on which type is contained. This is preferred"]
        #[doc = " to manually checking every variant type T with is<T>() because it provides"]
        #[doc = " compile-time checking that you handled every type, rather than runtime"]
        #[doc = " assertion failures."]
        #[doc = ""]
        #[doc = "     // Bad!"]
        #[doc = "     char* foo(Variant<A, B, C, D>& v) {"]
        #[doc = "       if (v.is<A>()) {"]
        #[doc = "         return ...;"]
        #[doc = "       } else if (v.is<B>()) {"]
        #[doc = "         return ...;"]
        #[doc = "       } else {"]
        #[doc = "         return doSomething(v.as<C>()); // Forgot about case D!"]
        #[doc = "       }"]
        #[doc = "     }"]
        #[doc = ""]
        #[doc = "     // Instead, a single function object (that can deal with all possible"]
        #[doc = "     // options) may be provided:"]
        #[doc = "     struct FooMatcher"]
        #[doc = "     {"]
        #[doc = "       // The return type of all matchers must be identical."]
        #[doc = "       char* operator()(A& a) { ... }"]
        #[doc = "       char* operator()(B& b) { ... }"]
        #[doc = "       char* operator()(C& c) { ... }"]
        #[doc = "       char* operator()(D& d) { ... } // Compile-time error to forget D!"]
        #[doc = "     }"]
        #[doc = "     char* foo(Variant<A, B, C, D>& v) {"]
        #[doc = "       return v.match(FooMatcher());"]
        #[doc = "     }"]
        #[doc = ""]
        #[doc = "     // In some situations, a single generic lambda may also be appropriate:"]
        #[doc = "     char* foo(Variant<A, B, C, D>& v) {"]
        #[doc = "       return v.match([](auto&){...});"]
        #[doc = "     }"]
        #[doc = ""]
        #[doc = "     // Alternatively, multiple function objects may be provided, each one"]
        #[doc = "     // corresponding to an option, in the same order:"]
        #[doc = "     char* foo(Variant<A, B, C, D>& v) {"]
        #[doc = "       return v.match([](A&) { ... },"]
        #[doc = "                      [](B&) { ... },"]
        #[doc = "                      [](C&) { ... },"]
        #[doc = "                      [](D&) { ... });"]
        #[doc = "     }"]
        #[doc = ""]
        #[doc = " ## Examples"]
        #[doc = ""]
        #[doc = " A tree is either an empty leaf, or a node with a value and two children:"]
        #[doc = ""]
        #[doc = "     struct Leaf { };"]
        #[doc = ""]
        #[doc = "     template<typename T>"]
        #[doc = "     struct Node"]
        #[doc = "     {"]
        #[doc = "       T value;"]
        #[doc = "       Tree<T>* left;"]
        #[doc = "       Tree<T>* right;"]
        #[doc = "     };"]
        #[doc = ""]
        #[doc = "     template<typename T>"]
        #[doc = "     using Tree = Variant<Leaf, Node<T>>;"]
        #[doc = ""]
        #[doc = " A copy-on-write string is either a non-owning reference to some existing"]
        #[doc = " string, or an owning reference to our copy:"]
        #[doc = ""]
        #[doc = "     class CopyOnWriteString"]
        #[doc = "     {"]
        #[doc = "       Variant<const char*, UniquePtr<char[]>> string;"]
        #[doc = ""]
        #[doc = "       ..."]
        #[doc = "     };"]
        #[doc = ""]
        #[doc = " Because Variant must be aligned suitable to hold any value stored within it,"]
        #[doc = " and because |alignas| requirements don\'t affect platform ABI with respect to"]
        #[doc = " how parameters are laid out in memory, Variant can\'t be used as the type of a"]
        #[doc = " function parameter.  Pass Variant to functions by pointer or reference"]
        #[doc = " instead."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct Variant {
            pub rawData: *mut ::std::os::raw::c_uchar,
            pub tag: root::mozilla::Variant_Tag,
        }
        pub type Variant_Tag = root::mozilla::detail::VariantTag;
        pub type Variant_Impl = u8;
        pub mod recordreplay {
            #[allow(unused_imports)]
            use self::super::super::super::root;
        }
        pub mod dom {
            #[allow(unused_imports)]
            use self::super::super::super::root;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Promise {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct AllOwningUnionBase {
                pub _address: u8,
            }
            #[test]
            fn bindgen_test_layout_AllOwningUnionBase() {
                assert_eq!(
                    ::std::mem::size_of::<AllOwningUnionBase>(),
                    1usize,
                    concat!("Size of: ", stringify!(AllOwningUnionBase))
                );
                assert_eq!(
                    ::std::mem::align_of::<AllOwningUnionBase>(),
                    1usize,
                    concat!("Alignment of ", stringify!(AllOwningUnionBase))
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Sequence {
                pub _address: u8,
            }
            #[repr(u32)]
            #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
            pub enum CallerType {
                System = 0,
                NonSystem = 1,
            }
            #[repr(C)]
            pub struct URLParams {
                pub mParams: root::nsTArray<root::mozilla::dom::URLParams_Param>,
            }
            #[repr(C)]
            pub struct URLParams_ForEachIterator__bindgen_vtable(::std::os::raw::c_void);
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct URLParams_ForEachIterator {
                pub vtable_: *const URLParams_ForEachIterator__bindgen_vtable,
            }
            #[test]
            fn bindgen_test_layout_URLParams_ForEachIterator() {
                assert_eq!(
                    ::std::mem::size_of::<URLParams_ForEachIterator>(),
                    8usize,
                    concat!("Size of: ", stringify!(URLParams_ForEachIterator))
                );
                assert_eq!(
                    ::std::mem::align_of::<URLParams_ForEachIterator>(),
                    8usize,
                    concat!("Alignment of ", stringify!(URLParams_ForEachIterator))
                );
            }
            #[repr(C)]
            pub struct URLParams_Param {
                pub mKey: ::gecko_bindings::structs::nsString,
                pub mValue: ::gecko_bindings::structs::nsString,
            }
            #[test]
            fn bindgen_test_layout_URLParams_Param() {
                assert_eq!(
                    ::std::mem::size_of::<URLParams_Param>(),
                    32usize,
                    concat!("Size of: ", stringify!(URLParams_Param))
                );
                assert_eq!(
                    ::std::mem::align_of::<URLParams_Param>(),
                    8usize,
                    concat!("Alignment of ", stringify!(URLParams_Param))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<URLParams_Param>())).mKey as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(URLParams_Param),
                        "::",
                        stringify!(mKey)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<URLParams_Param>())).mValue as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(URLParams_Param),
                        "::",
                        stringify!(mValue)
                    )
                );
            }
            #[test]
            fn bindgen_test_layout_URLParams() {
                assert_eq!(
                    ::std::mem::size_of::<URLParams>(),
                    8usize,
                    concat!("Size of: ", stringify!(URLParams))
                );
                assert_eq!(
                    ::std::mem::align_of::<URLParams>(),
                    8usize,
                    concat!("Alignment of ", stringify!(URLParams))
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<URLParams>())).mParams as *const _ as usize },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(URLParams),
                        "::",
                        stringify!(mParams)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Nullable {
                pub _address: u8,
            }
            pub mod prototypes {
                #[allow(unused_imports)]
                use self::super::super::super::super::root;
            }
            pub mod constructors {
                #[allow(unused_imports)]
                use self::super::super::super::super::root;
            }
            pub mod namedpropertiesobjects {
                #[allow(unused_imports)]
                use self::super::super::super::super::root;
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ClientSource {
                _unused: [u8; 0],
            }
            pub const OrientationType_Portrait_primary: root::mozilla::dom::OrientationType = 0;
            pub const OrientationType_Portrait_secondary: root::mozilla::dom::OrientationType = 1;
            pub const OrientationType_Landscape_primary: root::mozilla::dom::OrientationType = 2;
            pub const OrientationType_Landscape_secondary: root::mozilla::dom::OrientationType = 3;
            pub const OrientationType_EndGuard_: root::mozilla::dom::OrientationType = 4;
            pub type OrientationType = u8;
            pub const VisibilityState_Hidden: root::mozilla::dom::VisibilityState = 0;
            pub const VisibilityState_Visible: root::mozilla::dom::VisibilityState = 1;
            pub const VisibilityState_EndGuard_: root::mozilla::dom::VisibilityState = 2;
            pub type VisibilityState = u8;
            pub const FlashClassification_Unknown: root::mozilla::dom::FlashClassification = 0;
            pub const FlashClassification_Allowed: root::mozilla::dom::FlashClassification = 1;
            pub const FlashClassification_Denied: root::mozilla::dom::FlashClassification = 2;
            pub const FlashClassification_EndGuard_: root::mozilla::dom::FlashClassification = 3;
            pub type FlashClassification = u8;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct IPCClientInfo {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct TabGroup {
                _unused: [u8; 0],
            }
            #[repr(C)]
            pub struct DispatcherTrait__bindgen_vtable(::std::os::raw::c_void);
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct DispatcherTrait {
                pub vtable_: *const DispatcherTrait__bindgen_vtable,
            }
            #[test]
            fn bindgen_test_layout_DispatcherTrait() {
                assert_eq!(
                    ::std::mem::size_of::<DispatcherTrait>(),
                    8usize,
                    concat!("Size of: ", stringify!(DispatcherTrait))
                );
                assert_eq!(
                    ::std::mem::align_of::<DispatcherTrait>(),
                    8usize,
                    concat!("Alignment of ", stringify!(DispatcherTrait))
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct IPCServiceWorkerDescriptor {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct DocGroup {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ImageTracker {
                _unused: [u8; 0],
            }
            pub mod CSSStyleSheet_Binding {
                #[allow(unused_imports)]
                use self::super::super::super::super::root;
            }
            #[repr(C)]
            pub struct SRIMetadata {
                pub mHashes: root::nsTArray<::gecko_bindings::structs::nsCString>,
                pub mIntegrityString: ::gecko_bindings::structs::nsString,
                pub mAlgorithm: ::gecko_bindings::structs::nsCString,
                pub mAlgorithmType: i8,
                pub mEmpty: bool,
            }
            pub const SRIMetadata_MAX_ALTERNATE_HASHES: u32 = 256;
            pub const SRIMetadata_UNKNOWN_ALGORITHM: i8 = -1;
            #[test]
            fn bindgen_test_layout_SRIMetadata() {
                assert_eq!(
                    ::std::mem::size_of::<SRIMetadata>(),
                    48usize,
                    concat!("Size of: ", stringify!(SRIMetadata))
                );
                assert_eq!(
                    ::std::mem::align_of::<SRIMetadata>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SRIMetadata))
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<SRIMetadata>())).mHashes as *const _ as usize },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SRIMetadata),
                        "::",
                        stringify!(mHashes)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SRIMetadata>())).mIntegrityString as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SRIMetadata),
                        "::",
                        stringify!(mIntegrityString)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SRIMetadata>())).mAlgorithm as *const _ as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SRIMetadata),
                        "::",
                        stringify!(mAlgorithm)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SRIMetadata>())).mAlgorithmType as *const _ as usize
                    },
                    40usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SRIMetadata),
                        "::",
                        stringify!(mAlgorithmType)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<SRIMetadata>())).mEmpty as *const _ as usize },
                    41usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SRIMetadata),
                        "::",
                        stringify!(mEmpty)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct CSSImportRule {
                _unused: [u8; 0],
            }
            #[repr(C)]
            pub struct NodeInfo {
                pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
                pub mDocument: *mut root::mozilla::dom::Document,
                pub mInner: root::mozilla::dom::NodeInfo_NodeInfoInner,
                pub mOwnerManager: root::RefPtr<root::nsNodeInfoManager>,
                pub mQualifiedName: ::gecko_bindings::structs::nsString,
                pub mNodeName: ::gecko_bindings::structs::nsString,
                pub mLocalName: ::gecko_bindings::structs::nsString,
            }
            pub type NodeInfo_HasThreadSafeRefCnt = root::mozilla::FalseType;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct NodeInfo_cycleCollection {
                pub _base: root::nsCycleCollectionParticipant,
            }
            #[test]
            fn bindgen_test_layout_NodeInfo_cycleCollection() {
                assert_eq!(
                    ::std::mem::size_of::<NodeInfo_cycleCollection>(),
                    16usize,
                    concat!("Size of: ", stringify!(NodeInfo_cycleCollection))
                );
                assert_eq!(
                    ::std::mem::align_of::<NodeInfo_cycleCollection>(),
                    8usize,
                    concat!("Alignment of ", stringify!(NodeInfo_cycleCollection))
                );
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct NodeInfo_NodeInfoInner {
                pub mName: *mut root::nsAtom,
                pub mPrefix: *mut root::nsAtom,
                pub mNamespaceID: i32,
                pub mNodeType: u16,
                pub mNameString: *const ::gecko_bindings::structs::nsAString,
                pub mExtraName: *mut root::nsAtom,
                pub mHash: [u32; 2usize],
            }
            #[test]
            fn bindgen_test_layout_NodeInfo_NodeInfoInner() {
                assert_eq!(
                    ::std::mem::size_of::<NodeInfo_NodeInfoInner>(),
                    48usize,
                    concat!("Size of: ", stringify!(NodeInfo_NodeInfoInner))
                );
                assert_eq!(
                    ::std::mem::align_of::<NodeInfo_NodeInfoInner>(),
                    8usize,
                    concat!("Alignment of ", stringify!(NodeInfo_NodeInfoInner))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<NodeInfo_NodeInfoInner>())).mName as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(NodeInfo_NodeInfoInner),
                        "::",
                        stringify!(mName)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<NodeInfo_NodeInfoInner>())).mPrefix as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(NodeInfo_NodeInfoInner),
                        "::",
                        stringify!(mPrefix)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<NodeInfo_NodeInfoInner>())).mNamespaceID as *const _
                            as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(NodeInfo_NodeInfoInner),
                        "::",
                        stringify!(mNamespaceID)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<NodeInfo_NodeInfoInner>())).mNodeType as *const _
                            as usize
                    },
                    20usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(NodeInfo_NodeInfoInner),
                        "::",
                        stringify!(mNodeType)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<NodeInfo_NodeInfoInner>())).mNameString as *const _
                            as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(NodeInfo_NodeInfoInner),
                        "::",
                        stringify!(mNameString)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<NodeInfo_NodeInfoInner>())).mExtraName as *const _
                            as usize
                    },
                    32usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(NodeInfo_NodeInfoInner),
                        "::",
                        stringify!(mExtraName)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<NodeInfo_NodeInfoInner>())).mHash as *const _
                            as usize
                    },
                    40usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(NodeInfo_NodeInfoInner),
                        "::",
                        stringify!(mHash)
                    )
                );
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom8NodeInfo21_cycleCollectorGlobalE"]
                pub static mut NodeInfo__cycleCollectorGlobal:
                    root::mozilla::dom::NodeInfo_cycleCollection;
            }
            #[test]
            fn bindgen_test_layout_NodeInfo() {
                assert_eq!(
                    ::std::mem::size_of::<NodeInfo>(),
                    120usize,
                    concat!("Size of: ", stringify!(NodeInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<NodeInfo>(),
                    8usize,
                    concat!("Alignment of ", stringify!(NodeInfo))
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<NodeInfo>())).mRefCnt as *const _ as usize },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(NodeInfo),
                        "::",
                        stringify!(mRefCnt)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<NodeInfo>())).mDocument as *const _ as usize },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(NodeInfo),
                        "::",
                        stringify!(mDocument)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<NodeInfo>())).mInner as *const _ as usize },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(NodeInfo),
                        "::",
                        stringify!(mInner)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<NodeInfo>())).mOwnerManager as *const _ as usize
                    },
                    64usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(NodeInfo),
                        "::",
                        stringify!(mOwnerManager)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<NodeInfo>())).mQualifiedName as *const _ as usize
                    },
                    72usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(NodeInfo),
                        "::",
                        stringify!(mQualifiedName)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<NodeInfo>())).mNodeName as *const _ as usize },
                    88usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(NodeInfo),
                        "::",
                        stringify!(mNodeName)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<NodeInfo>())).mLocalName as *const _ as usize },
                    104usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(NodeInfo),
                        "::",
                        stringify!(mLocalName)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Event {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct EventTarget {
                pub _base: root::nsISupports,
                pub _base_1: root::nsWrapperCache,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct EventTarget_COMTypeInfo {
                pub _address: u8,
            }
            #[test]
            fn bindgen_test_layout_EventTarget() {
                assert_eq!(
                    ::std::mem::size_of::<EventTarget>(),
                    32usize,
                    concat!("Size of: ", stringify!(EventTarget))
                );
                assert_eq!(
                    ::std::mem::align_of::<EventTarget>(),
                    8usize,
                    concat!("Alignment of ", stringify!(EventTarget))
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct BoxQuadOptions {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ConvertCoordinateOptions {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct DOMPoint {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct DOMQuad {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGUseElement {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct TextOrElementOrDocument {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct DOMPointInit {
                _unused: [u8; 0],
            }
            #[repr(u8)]
            #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
            pub enum FillMode {
                None = 0,
                Forwards = 1,
                Backwards = 2,
                Both = 3,
                Auto = 4,
                EndGuard_ = 5,
            }
            #[repr(u8)]
            #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
            pub enum PlaybackDirection {
                Normal = 0,
                Reverse = 1,
                Alternate = 2,
                Alternate_reverse = 3,
                EndGuard_ = 4,
            }
            #[doc = " Struct that stores info on an attribute. The name and value must either both"]
            #[doc = " be null or both be non-null."]
            #[doc = ""]
            #[doc = " Note that, just as the pointers returned by GetAttrNameAt, the pointers that"]
            #[doc = " this struct hold are only valid until the element or its attributes are"]
            #[doc = " mutated (directly or via script)."]
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct BorrowedAttrInfo {
                pub mName: *const root::nsAttrName,
                pub mValue: *const root::nsAttrValue,
            }
            #[test]
            fn bindgen_test_layout_BorrowedAttrInfo() {
                assert_eq!(
                    ::std::mem::size_of::<BorrowedAttrInfo>(),
                    16usize,
                    concat!("Size of: ", stringify!(BorrowedAttrInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<BorrowedAttrInfo>(),
                    8usize,
                    concat!("Alignment of ", stringify!(BorrowedAttrInfo))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BorrowedAttrInfo>())).mName as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BorrowedAttrInfo),
                        "::",
                        stringify!(mName)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BorrowedAttrInfo>())).mValue as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BorrowedAttrInfo),
                        "::",
                        stringify!(mValue)
                    )
                );
            }
            #[repr(C)]
            pub struct ScriptSettingsStackEntry {
                pub mGlobalObject: root::nsCOMPtr,
                pub mType: root::mozilla::dom::ScriptSettingsStackEntry_Type,
                pub mOlder: *mut root::mozilla::dom::ScriptSettingsStackEntry,
            }
            pub const ScriptSettingsStackEntry_Type_eEntryScript:
                root::mozilla::dom::ScriptSettingsStackEntry_Type = 0;
            pub const ScriptSettingsStackEntry_Type_eIncumbentScript:
                root::mozilla::dom::ScriptSettingsStackEntry_Type = 1;
            pub const ScriptSettingsStackEntry_Type_eJSAPI:
                root::mozilla::dom::ScriptSettingsStackEntry_Type = 2;
            pub const ScriptSettingsStackEntry_Type_eNoJSAPI:
                root::mozilla::dom::ScriptSettingsStackEntry_Type = 3;
            pub type ScriptSettingsStackEntry_Type = u32;
            #[test]
            fn bindgen_test_layout_ScriptSettingsStackEntry() {
                assert_eq!(
                    ::std::mem::size_of::<ScriptSettingsStackEntry>(),
                    24usize,
                    concat!("Size of: ", stringify!(ScriptSettingsStackEntry))
                );
                assert_eq!(
                    ::std::mem::align_of::<ScriptSettingsStackEntry>(),
                    8usize,
                    concat!("Alignment of ", stringify!(ScriptSettingsStackEntry))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScriptSettingsStackEntry>())).mGlobalObject
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScriptSettingsStackEntry),
                        "::",
                        stringify!(mGlobalObject)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScriptSettingsStackEntry>())).mType as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScriptSettingsStackEntry),
                        "::",
                        stringify!(mType)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScriptSettingsStackEntry>())).mOlder as *const _
                            as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScriptSettingsStackEntry),
                        "::",
                        stringify!(mOlder)
                    )
                );
            }
            #[repr(C)]
            pub struct AutoJSAPI {
                pub _base: root::mozilla::dom::ScriptSettingsStackEntry,
                pub mAutoNullableRealm: [u64; 3usize],
                pub mCx: *mut root::JSContext,
                pub mIsMainThread: bool,
                pub mOldWarningReporter: [u64; 2usize],
            }
            #[test]
            fn bindgen_test_layout_AutoJSAPI() {
                assert_eq!(
                    ::std::mem::size_of::<AutoJSAPI>(),
                    80usize,
                    concat!("Size of: ", stringify!(AutoJSAPI))
                );
                assert_eq!(
                    ::std::mem::align_of::<AutoJSAPI>(),
                    8usize,
                    concat!("Alignment of ", stringify!(AutoJSAPI))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<AutoJSAPI>())).mAutoNullableRealm as *const _
                            as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(AutoJSAPI),
                        "::",
                        stringify!(mAutoNullableRealm)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<AutoJSAPI>())).mCx as *const _ as usize },
                    48usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(AutoJSAPI),
                        "::",
                        stringify!(mCx)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<AutoJSAPI>())).mIsMainThread as *const _ as usize
                    },
                    56usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(AutoJSAPI),
                        "::",
                        stringify!(mIsMainThread)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<AutoJSAPI>())).mOldWarningReporter as *const _
                            as usize
                    },
                    64usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(AutoJSAPI),
                        "::",
                        stringify!(mOldWarningReporter)
                    )
                );
            }
            #[repr(C)]
            pub struct AutoEntryScript {
                pub _base: root::mozilla::dom::AutoJSAPI,
                pub mWebIDLCallerPrincipal: *mut root::nsIPrincipal,
                pub mDocShellEntryMonitor: [u64; 5usize],
                pub mScriptActivity: [u8; 3usize],
                pub mCallerOverride: root::JS::AutoHideScriptedCaller,
                pub mAutoProfilerLabel: root::mozilla::AutoProfilerLabel,
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct AutoEntryScript_DocshellEntryMonitor {
                pub _base: root::JS::dbg::AutoEntryMonitor,
                pub mReason: *const ::std::os::raw::c_char,
            }
            #[test]
            fn bindgen_test_layout_AutoEntryScript_DocshellEntryMonitor() {
                assert_eq!(
                    ::std::mem::size_of::<AutoEntryScript_DocshellEntryMonitor>(),
                    32usize,
                    concat!(
                        "Size of: ",
                        stringify!(AutoEntryScript_DocshellEntryMonitor)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<AutoEntryScript_DocshellEntryMonitor>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(AutoEntryScript_DocshellEntryMonitor)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<AutoEntryScript_DocshellEntryMonitor>())).mReason
                            as *const _ as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(AutoEntryScript_DocshellEntryMonitor),
                        "::",
                        stringify!(mReason)
                    )
                );
            }
            #[test]
            fn bindgen_test_layout_AutoEntryScript() {
                assert_eq!(
                    ::std::mem::size_of::<AutoEntryScript>(),
                    152usize,
                    concat!("Size of: ", stringify!(AutoEntryScript))
                );
                assert_eq!(
                    ::std::mem::align_of::<AutoEntryScript>(),
                    8usize,
                    concat!("Alignment of ", stringify!(AutoEntryScript))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<AutoEntryScript>())).mWebIDLCallerPrincipal
                            as *const _ as usize
                    },
                    80usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(AutoEntryScript),
                        "::",
                        stringify!(mWebIDLCallerPrincipal)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<AutoEntryScript>())).mDocShellEntryMonitor
                            as *const _ as usize
                    },
                    88usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(AutoEntryScript),
                        "::",
                        stringify!(mDocShellEntryMonitor)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<AutoEntryScript>())).mScriptActivity as *const _
                            as usize
                    },
                    128usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(AutoEntryScript),
                        "::",
                        stringify!(mScriptActivity)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<AutoEntryScript>())).mCallerOverride as *const _
                            as usize
                    },
                    136usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(AutoEntryScript),
                        "::",
                        stringify!(mCallerOverride)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<AutoEntryScript>())).mAutoProfilerLabel as *const _
                            as usize
                    },
                    144usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(AutoEntryScript),
                        "::",
                        stringify!(mAutoProfilerLabel)
                    )
                );
            }
            #[repr(C)]
            pub struct AutoIncumbentScript {
                pub _base: root::mozilla::dom::ScriptSettingsStackEntry,
                pub mCallerOverride: root::JS::AutoHideScriptedCaller,
            }
            #[test]
            fn bindgen_test_layout_AutoIncumbentScript() {
                assert_eq!(
                    ::std::mem::size_of::<AutoIncumbentScript>(),
                    32usize,
                    concat!("Size of: ", stringify!(AutoIncumbentScript))
                );
                assert_eq!(
                    ::std::mem::align_of::<AutoIncumbentScript>(),
                    8usize,
                    concat!("Alignment of ", stringify!(AutoIncumbentScript))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<AutoIncumbentScript>())).mCallerOverride as *const _
                            as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(AutoIncumbentScript),
                        "::",
                        stringify!(mCallerOverride)
                    )
                );
            }
            #[repr(C)]
            pub struct CallbackObject {
                pub _base: root::nsISupports,
                pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
                pub mCallback: root::JS::Heap<*mut root::JSObject>,
                pub mCallbackGlobal: root::JS::Heap<*mut root::JSObject>,
                pub mCreationStack: root::JS::Heap<*mut root::JSObject>,
                pub mIncumbentGlobal: root::nsCOMPtr,
                pub mIncumbentJSGlobal: root::JS::TenuredHeap,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct CallbackObject_COMTypeInfo {
                pub _address: u8,
            }
            pub type CallbackObject_HasThreadSafeRefCnt = root::mozilla::FalseType;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct CallbackObject_cycleCollection {
                pub _base: root::nsXPCOMCycleCollectionParticipant,
            }
            #[test]
            fn bindgen_test_layout_CallbackObject_cycleCollection() {
                assert_eq!(
                    ::std::mem::size_of::<CallbackObject_cycleCollection>(),
                    16usize,
                    concat!("Size of: ", stringify!(CallbackObject_cycleCollection))
                );
                assert_eq!(
                    ::std::mem::align_of::<CallbackObject_cycleCollection>(),
                    8usize,
                    concat!("Alignment of ", stringify!(CallbackObject_cycleCollection))
                );
            }
            pub const CallbackObject_ExceptionHandling_eReportExceptions:
                root::mozilla::dom::CallbackObject_ExceptionHandling = 0;
            pub const CallbackObject_ExceptionHandling_eRethrowContentExceptions:
                root::mozilla::dom::CallbackObject_ExceptionHandling = 1;
            pub const CallbackObject_ExceptionHandling_eRethrowExceptions:
                root::mozilla::dom::CallbackObject_ExceptionHandling = 2;
            pub type CallbackObject_ExceptionHandling = u32;
            #[repr(C)]
            pub struct CallbackObject_JSObjectsDropper {
                pub mHolder: root::RefPtr<root::mozilla::dom::CallbackObject>,
            }
            #[test]
            fn bindgen_test_layout_CallbackObject_JSObjectsDropper() {
                assert_eq!(
                    ::std::mem::size_of::<CallbackObject_JSObjectsDropper>(),
                    8usize,
                    concat!("Size of: ", stringify!(CallbackObject_JSObjectsDropper))
                );
                assert_eq!(
                    ::std::mem::align_of::<CallbackObject_JSObjectsDropper>(),
                    8usize,
                    concat!("Alignment of ", stringify!(CallbackObject_JSObjectsDropper))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject_JSObjectsDropper>())).mHolder
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject_JSObjectsDropper),
                        "::",
                        stringify!(mHolder)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct CallbackObject_FastCallbackConstructor {
                pub _address: u8,
            }
            #[test]
            fn bindgen_test_layout_CallbackObject_FastCallbackConstructor() {
                assert_eq!(
                    ::std::mem::size_of::<CallbackObject_FastCallbackConstructor>(),
                    1usize,
                    concat!(
                        "Size of: ",
                        stringify!(CallbackObject_FastCallbackConstructor)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<CallbackObject_FastCallbackConstructor>(),
                    1usize,
                    concat!(
                        "Alignment of ",
                        stringify!(CallbackObject_FastCallbackConstructor)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct CallbackObject_CallSetup {
                pub mCx: *mut root::JSContext,
                pub mRealm: *mut root::JS::Realm,
                pub mAutoEntryScript: [u64; 20usize],
                pub mAutoIncumbentScript: [u64; 5usize],
                pub mRootedCallable: [u64; 4usize],
                pub mRootedCallableGlobal: [u64; 4usize],
                pub mAsyncStack: [u64; 4usize],
                pub mAsyncStackSetter: [u64; 7usize],
                pub mAr: [u64; 3usize],
                pub mErrorResult: *mut root::mozilla::ErrorResult,
                pub mExceptionHandling: root::mozilla::dom::CallbackObject_ExceptionHandling,
                pub mIsMainThread: bool,
            }
            #[test]
            fn bindgen_test_layout_CallbackObject_CallSetup() {
                assert_eq!(
                    ::std::mem::size_of::<CallbackObject_CallSetup>(),
                    408usize,
                    concat!("Size of: ", stringify!(CallbackObject_CallSetup))
                );
                assert_eq!(
                    ::std::mem::align_of::<CallbackObject_CallSetup>(),
                    8usize,
                    concat!("Alignment of ", stringify!(CallbackObject_CallSetup))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject_CallSetup>())).mCx as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject_CallSetup),
                        "::",
                        stringify!(mCx)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject_CallSetup>())).mRealm as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject_CallSetup),
                        "::",
                        stringify!(mRealm)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject_CallSetup>())).mAutoEntryScript
                            as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject_CallSetup),
                        "::",
                        stringify!(mAutoEntryScript)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject_CallSetup>())).mAutoIncumbentScript
                            as *const _ as usize
                    },
                    176usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject_CallSetup),
                        "::",
                        stringify!(mAutoIncumbentScript)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject_CallSetup>())).mRootedCallable
                            as *const _ as usize
                    },
                    216usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject_CallSetup),
                        "::",
                        stringify!(mRootedCallable)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject_CallSetup>())).mRootedCallableGlobal
                            as *const _ as usize
                    },
                    248usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject_CallSetup),
                        "::",
                        stringify!(mRootedCallableGlobal)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject_CallSetup>())).mAsyncStack as *const _
                            as usize
                    },
                    280usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject_CallSetup),
                        "::",
                        stringify!(mAsyncStack)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject_CallSetup>())).mAsyncStackSetter
                            as *const _ as usize
                    },
                    312usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject_CallSetup),
                        "::",
                        stringify!(mAsyncStackSetter)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject_CallSetup>())).mAr as *const _
                            as usize
                    },
                    368usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject_CallSetup),
                        "::",
                        stringify!(mAr)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject_CallSetup>())).mErrorResult
                            as *const _ as usize
                    },
                    392usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject_CallSetup),
                        "::",
                        stringify!(mErrorResult)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject_CallSetup>())).mExceptionHandling
                            as *const _ as usize
                    },
                    400usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject_CallSetup),
                        "::",
                        stringify!(mExceptionHandling)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject_CallSetup>())).mIsMainThread
                            as *const _ as usize
                    },
                    404usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject_CallSetup),
                        "::",
                        stringify!(mIsMainThread)
                    )
                );
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom14CallbackObject21_cycleCollectorGlobalE"]
                pub static mut CallbackObject__cycleCollectorGlobal:
                    root::mozilla::dom::CallbackObject_cycleCollection;
            }
            #[test]
            fn bindgen_test_layout_CallbackObject() {
                assert_eq!(
                    ::std::mem::size_of::<CallbackObject>(),
                    56usize,
                    concat!("Size of: ", stringify!(CallbackObject))
                );
                assert_eq!(
                    ::std::mem::align_of::<CallbackObject>(),
                    8usize,
                    concat!("Alignment of ", stringify!(CallbackObject))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject>())).mRefCnt as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject),
                        "::",
                        stringify!(mRefCnt)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject>())).mCallback as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject),
                        "::",
                        stringify!(mCallback)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject>())).mCallbackGlobal as *const _
                            as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject),
                        "::",
                        stringify!(mCallbackGlobal)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject>())).mCreationStack as *const _
                            as usize
                    },
                    32usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject),
                        "::",
                        stringify!(mCreationStack)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject>())).mIncumbentGlobal as *const _
                            as usize
                    },
                    40usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject),
                        "::",
                        stringify!(mIncumbentGlobal)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<CallbackObject>())).mIncumbentJSGlobal as *const _
                            as usize
                    },
                    48usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(CallbackObject),
                        "::",
                        stringify!(mIncumbentJSGlobal)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct CallbackObjectHolderBase {
                pub _address: u8,
            }
            #[test]
            fn bindgen_test_layout_CallbackObjectHolderBase() {
                assert_eq!(
                    ::std::mem::size_of::<CallbackObjectHolderBase>(),
                    1usize,
                    concat!("Size of: ", stringify!(CallbackObjectHolderBase))
                );
                assert_eq!(
                    ::std::mem::align_of::<CallbackObjectHolderBase>(),
                    1usize,
                    concat!("Alignment of ", stringify!(CallbackObjectHolderBase))
                );
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct CallbackObjectHolder {
                pub mPtrBits: usize,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct AudioContext {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ContentFrameMessageManager {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Navigator {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Performance {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Report {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ReportingObserver {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct TimeoutManager {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct WindowGlobalChild {
                _unused: [u8; 0],
            }
            pub const LargeAllocStatus_NONE: root::mozilla::dom::LargeAllocStatus = 0;
            pub const LargeAllocStatus_SUCCESS: root::mozilla::dom::LargeAllocStatus = 1;
            pub const LargeAllocStatus_NON_GET: root::mozilla::dom::LargeAllocStatus = 2;
            pub const LargeAllocStatus_NON_E10S: root::mozilla::dom::LargeAllocStatus = 3;
            pub const LargeAllocStatus_NOT_ONLY_TOPLEVEL_IN_TABGROUP:
                root::mozilla::dom::LargeAllocStatus = 4;
            pub const LargeAllocStatus_NON_WIN32: root::mozilla::dom::LargeAllocStatus = 5;
            pub type LargeAllocStatus = u8;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct BrowsingContextGroup {
                _unused: [u8; 0],
            }
            #[repr(C)]
            pub struct BrowsingContextBase {
                pub mName: ::gecko_bindings::structs::nsString,
                pub mClosed: bool,
                pub mCrossOriginPolicy: root::nsILoadInfo_CrossOriginPolicy,
                pub mOpenerPolicy: root::nsILoadInfo_CrossOriginOpenerPolicy,
                pub mOpenerId: u64,
                pub mIsActivatedByUserGesture: bool,
            }
            #[test]
            fn bindgen_test_layout_BrowsingContextBase() {
                assert_eq!(
                    ::std::mem::size_of::<BrowsingContextBase>(),
                    40usize,
                    concat!("Size of: ", stringify!(BrowsingContextBase))
                );
                assert_eq!(
                    ::std::mem::align_of::<BrowsingContextBase>(),
                    8usize,
                    concat!("Alignment of ", stringify!(BrowsingContextBase))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContextBase>())).mName as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContextBase),
                        "::",
                        stringify!(mName)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContextBase>())).mClosed as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContextBase),
                        "::",
                        stringify!(mClosed)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContextBase>())).mCrossOriginPolicy
                            as *const _ as usize
                    },
                    17usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContextBase),
                        "::",
                        stringify!(mCrossOriginPolicy)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContextBase>())).mOpenerPolicy as *const _
                            as usize
                    },
                    18usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContextBase),
                        "::",
                        stringify!(mOpenerPolicy)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContextBase>())).mOpenerId as *const _
                            as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContextBase),
                        "::",
                        stringify!(mOpenerId)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContextBase>())).mIsActivatedByUserGesture
                            as *const _ as usize
                    },
                    32usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContextBase),
                        "::",
                        stringify!(mIsActivatedByUserGesture)
                    )
                );
            }
            #[repr(C)]
            pub struct BrowsingContext {
                pub _base: root::nsWrapperCache,
                pub _base_1: root::mozilla::dom::BrowsingContextBase,
                pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
                pub mType: root::mozilla::dom::BrowsingContext_Type,
                pub mBrowsingContextId: u64,
                pub mGroup: root::RefPtr<root::mozilla::dom::BrowsingContextGroup>,
                pub mParent: root::RefPtr<root::mozilla::dom::BrowsingContext>,
                pub mChildren: root::mozilla::dom::BrowsingContext_Children,
                pub mDocShell: root::nsCOMPtr,
                pub mEmbedderElement: root::RefPtr<root::mozilla::dom::Element>,
                pub mWindowProxy: root::JS::Heap<*mut root::JSObject>,
                pub mLocation: root::mozilla::dom::BrowsingContext_LocationProxy,
                pub mFieldEpochs: root::mozilla::dom::BrowsingContext_FieldEpochs,
                pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 1usize], u8>,
                pub __bindgen_padding_0: [u8; 7usize],
            }
            pub const BrowsingContext_Type_Chrome: root::mozilla::dom::BrowsingContext_Type = 0;
            pub const BrowsingContext_Type_Content: root::mozilla::dom::BrowsingContext_Type = 1;
            pub type BrowsingContext_Type = i32;
            pub type BrowsingContext_Children =
                root::nsTArray<root::RefPtr<root::mozilla::dom::BrowsingContext>>;
            pub type BrowsingContext_HasThreadSafeRefCnt = root::mozilla::FalseType;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct BrowsingContext_cycleCollection {
                pub _base: root::nsScriptObjectTracer,
            }
            #[test]
            fn bindgen_test_layout_BrowsingContext_cycleCollection() {
                assert_eq!(
                    ::std::mem::size_of::<BrowsingContext_cycleCollection>(),
                    16usize,
                    concat!("Size of: ", stringify!(BrowsingContext_cycleCollection))
                );
                assert_eq!(
                    ::std::mem::align_of::<BrowsingContext_cycleCollection>(),
                    8usize,
                    concat!("Alignment of ", stringify!(BrowsingContext_cycleCollection))
                );
            }
            #[doc = " Each synced racy field in a BrowsingContext needs to have a epoch value"]
            #[doc = " which is used to resolve race conflicts by ensuring that only the last"]
            #[doc = " message received in the parent process wins."]
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct BrowsingContext_FieldEpochs {
                pub mName: u64,
                pub mClosed: u64,
                pub mIsActivatedByUserGesture: u64,
            }
            #[test]
            fn bindgen_test_layout_BrowsingContext_FieldEpochs() {
                assert_eq!(
                    ::std::mem::size_of::<BrowsingContext_FieldEpochs>(),
                    24usize,
                    concat!("Size of: ", stringify!(BrowsingContext_FieldEpochs))
                );
                assert_eq!(
                    ::std::mem::align_of::<BrowsingContext_FieldEpochs>(),
                    8usize,
                    concat!("Alignment of ", stringify!(BrowsingContext_FieldEpochs))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext_FieldEpochs>())).mName as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext_FieldEpochs),
                        "::",
                        stringify!(mName)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext_FieldEpochs>())).mClosed as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext_FieldEpochs),
                        "::",
                        stringify!(mClosed)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext_FieldEpochs>()))
                            .mIsActivatedByUserGesture as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext_FieldEpochs),
                        "::",
                        stringify!(mIsActivatedByUserGesture)
                    )
                );
            }
            #[doc = " Transaction object. This object is used to specify and then commit"]
            #[doc = " modifications to synchronized fields in BrowsingContexts."]
            #[repr(C)]
            #[derive(Debug)]
            pub struct BrowsingContext_Transaction {
                pub mName: [u64; 3usize],
                pub mClosed: [u8; 2usize],
                pub mCrossOriginPolicy: [u8; 2usize],
                pub mOpenerPolicy: [u8; 2usize],
                pub mOpenerId: [u64; 2usize],
                pub mIsActivatedByUserGesture: [u8; 2usize],
            }
            #[test]
            fn bindgen_test_layout_BrowsingContext_Transaction() {
                assert_eq!(
                    ::std::mem::size_of::<BrowsingContext_Transaction>(),
                    56usize,
                    concat!("Size of: ", stringify!(BrowsingContext_Transaction))
                );
                assert_eq!(
                    ::std::mem::align_of::<BrowsingContext_Transaction>(),
                    8usize,
                    concat!("Alignment of ", stringify!(BrowsingContext_Transaction))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext_Transaction>())).mName as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext_Transaction),
                        "::",
                        stringify!(mName)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext_Transaction>())).mClosed as *const _
                            as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext_Transaction),
                        "::",
                        stringify!(mClosed)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext_Transaction>())).mCrossOriginPolicy
                            as *const _ as usize
                    },
                    26usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext_Transaction),
                        "::",
                        stringify!(mCrossOriginPolicy)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext_Transaction>())).mOpenerPolicy
                            as *const _ as usize
                    },
                    28usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext_Transaction),
                        "::",
                        stringify!(mOpenerPolicy)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext_Transaction>())).mOpenerId
                            as *const _ as usize
                    },
                    32usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext_Transaction),
                        "::",
                        stringify!(mOpenerId)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext_Transaction>()))
                            .mIsActivatedByUserGesture as *const _ as usize
                    },
                    48usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext_Transaction),
                        "::",
                        stringify!(mIsActivatedByUserGesture)
                    )
                );
            }
            #[doc = " Information required to initialize a BrowsingContext in another process."]
            #[doc = " This object may be serialized over IPC."]
            #[repr(C)]
            pub struct BrowsingContext_IPCInitializer {
                pub mId: u64,
                pub mParentId: u64,
                pub mCached: bool,
                pub mName: ::gecko_bindings::structs::nsString,
                pub mClosed: bool,
                pub mCrossOriginPolicy: root::nsILoadInfo_CrossOriginPolicy,
                pub mOpenerPolicy: root::nsILoadInfo_CrossOriginOpenerPolicy,
                pub mOpenerId: u64,
                pub mIsActivatedByUserGesture: bool,
            }
            #[test]
            fn bindgen_test_layout_BrowsingContext_IPCInitializer() {
                assert_eq!(
                    ::std::mem::size_of::<BrowsingContext_IPCInitializer>(),
                    64usize,
                    concat!("Size of: ", stringify!(BrowsingContext_IPCInitializer))
                );
                assert_eq!(
                    ::std::mem::align_of::<BrowsingContext_IPCInitializer>(),
                    8usize,
                    concat!("Alignment of ", stringify!(BrowsingContext_IPCInitializer))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext_IPCInitializer>())).mId as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext_IPCInitializer),
                        "::",
                        stringify!(mId)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext_IPCInitializer>())).mParentId
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext_IPCInitializer),
                        "::",
                        stringify!(mParentId)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext_IPCInitializer>())).mCached
                            as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext_IPCInitializer),
                        "::",
                        stringify!(mCached)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext_IPCInitializer>())).mName as *const _
                            as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext_IPCInitializer),
                        "::",
                        stringify!(mName)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext_IPCInitializer>())).mClosed
                            as *const _ as usize
                    },
                    40usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext_IPCInitializer),
                        "::",
                        stringify!(mClosed)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext_IPCInitializer>()))
                            .mCrossOriginPolicy as *const _ as usize
                    },
                    41usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext_IPCInitializer),
                        "::",
                        stringify!(mCrossOriginPolicy)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext_IPCInitializer>())).mOpenerPolicy
                            as *const _ as usize
                    },
                    42usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext_IPCInitializer),
                        "::",
                        stringify!(mOpenerPolicy)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext_IPCInitializer>())).mOpenerId
                            as *const _ as usize
                    },
                    48usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext_IPCInitializer),
                        "::",
                        stringify!(mOpenerId)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext_IPCInitializer>()))
                            .mIsActivatedByUserGesture as *const _ as usize
                    },
                    56usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext_IPCInitializer),
                        "::",
                        stringify!(mIsActivatedByUserGesture)
                    )
                );
            }
            #[doc = " LocationProxy is the class for the native object stored as a private in a"]
            #[doc = " RemoteLocationProxy proxy representing a Location object in a different"]
            #[doc = " process. It forwards all operations to its BrowsingContext and aggregates"]
            #[doc = " its refcount to that BrowsingContext."]
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct BrowsingContext_LocationProxy {
                pub _address: u8,
            }
            #[test]
            fn bindgen_test_layout_BrowsingContext_LocationProxy() {
                assert_eq!(
                    ::std::mem::size_of::<BrowsingContext_LocationProxy>(),
                    1usize,
                    concat!("Size of: ", stringify!(BrowsingContext_LocationProxy))
                );
                assert_eq!(
                    ::std::mem::align_of::<BrowsingContext_LocationProxy>(),
                    1usize,
                    concat!("Alignment of ", stringify!(BrowsingContext_LocationProxy))
                );
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom15BrowsingContext21_cycleCollectorGlobalE"]
                pub static mut BrowsingContext__cycleCollectorGlobal:
                    root::mozilla::dom::BrowsingContext_cycleCollection;
            }
            #[test]
            fn bindgen_test_layout_BrowsingContext() {
                assert_eq!(
                    ::std::mem::size_of::<BrowsingContext>(),
                    176usize,
                    concat!("Size of: ", stringify!(BrowsingContext))
                );
                assert_eq!(
                    ::std::mem::align_of::<BrowsingContext>(),
                    8usize,
                    concat!("Alignment of ", stringify!(BrowsingContext))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext>())).mRefCnt as *const _ as usize
                    },
                    64usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext),
                        "::",
                        stringify!(mRefCnt)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext>())).mType as *const _ as usize
                    },
                    72usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext),
                        "::",
                        stringify!(mType)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext>())).mBrowsingContextId as *const _
                            as usize
                    },
                    80usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext),
                        "::",
                        stringify!(mBrowsingContextId)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext>())).mGroup as *const _ as usize
                    },
                    88usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext),
                        "::",
                        stringify!(mGroup)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext>())).mParent as *const _ as usize
                    },
                    96usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext),
                        "::",
                        stringify!(mParent)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext>())).mChildren as *const _ as usize
                    },
                    104usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext),
                        "::",
                        stringify!(mChildren)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext>())).mDocShell as *const _ as usize
                    },
                    112usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext),
                        "::",
                        stringify!(mDocShell)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext>())).mEmbedderElement as *const _
                            as usize
                    },
                    120usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext),
                        "::",
                        stringify!(mEmbedderElement)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext>())).mWindowProxy as *const _
                            as usize
                    },
                    128usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext),
                        "::",
                        stringify!(mWindowProxy)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext>())).mLocation as *const _ as usize
                    },
                    136usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext),
                        "::",
                        stringify!(mLocation)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<BrowsingContext>())).mFieldEpochs as *const _
                            as usize
                    },
                    144usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(BrowsingContext),
                        "::",
                        stringify!(mFieldEpochs)
                    )
                );
            }
            impl BrowsingContext {
                #[inline]
                pub fn mIsInProcess(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsInProcess(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(0usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn new_bitfield_1(
                    mIsInProcess: bool,
                ) -> root::__BindgenBitfieldUnit<[u8; 1usize], u8> {
                    let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 1usize], u8> =
                        Default::default();
                    __bindgen_bitfield_unit.set(0usize, 1u8, {
                        let mIsInProcess: u8 = unsafe { ::std::mem::transmute(mIsInProcess) };
                        mIsInProcess as u64
                    });
                    __bindgen_bitfield_unit
                }
            }
            #[repr(C)]
            pub struct ContentBlockingLog {
                pub mLog: root::mozilla::dom::ContentBlockingLog_OriginDataTable,
            }
            pub use self::super::super::super::root::mozilla::AntiTrackingCommon_StorageAccessGrantedReason as ContentBlockingLog_StorageAccessGrantedReason;
            #[repr(C)]
            pub struct ContentBlockingLog_LogEntry {
                pub mType: u32,
                pub mRepeatCount: u32,
                pub mBlocked: bool,
                pub mReason: [u32; 2usize],
                pub mTrackingFullHashes: root::nsTArray<::gecko_bindings::structs::nsCString>,
            }
            #[test]
            fn bindgen_test_layout_ContentBlockingLog_LogEntry() {
                assert_eq!(
                    ::std::mem::size_of::<ContentBlockingLog_LogEntry>(),
                    32usize,
                    concat!("Size of: ", stringify!(ContentBlockingLog_LogEntry))
                );
                assert_eq!(
                    ::std::mem::align_of::<ContentBlockingLog_LogEntry>(),
                    8usize,
                    concat!("Alignment of ", stringify!(ContentBlockingLog_LogEntry))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ContentBlockingLog_LogEntry>())).mType as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ContentBlockingLog_LogEntry),
                        "::",
                        stringify!(mType)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ContentBlockingLog_LogEntry>())).mRepeatCount
                            as *const _ as usize
                    },
                    4usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ContentBlockingLog_LogEntry),
                        "::",
                        stringify!(mRepeatCount)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ContentBlockingLog_LogEntry>())).mBlocked as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ContentBlockingLog_LogEntry),
                        "::",
                        stringify!(mBlocked)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ContentBlockingLog_LogEntry>())).mReason as *const _
                            as usize
                    },
                    12usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ContentBlockingLog_LogEntry),
                        "::",
                        stringify!(mReason)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ContentBlockingLog_LogEntry>())).mTrackingFullHashes
                            as *const _ as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ContentBlockingLog_LogEntry),
                        "::",
                        stringify!(mTrackingFullHashes)
                    )
                );
            }
            #[repr(C)]
            pub struct ContentBlockingLog_OriginDataEntry {
                pub mHasTrackingContentLoaded: bool,
                pub mHasCookiesLoaded: [u8; 2usize],
                pub mLogs: root::nsTArray<root::mozilla::dom::ContentBlockingLog_LogEntry>,
            }
            #[test]
            fn bindgen_test_layout_ContentBlockingLog_OriginDataEntry() {
                assert_eq!(
                    ::std::mem::size_of::<ContentBlockingLog_OriginDataEntry>(),
                    16usize,
                    concat!("Size of: ", stringify!(ContentBlockingLog_OriginDataEntry))
                );
                assert_eq!(
                    ::std::mem::align_of::<ContentBlockingLog_OriginDataEntry>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(ContentBlockingLog_OriginDataEntry)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ContentBlockingLog_OriginDataEntry>()))
                            .mHasTrackingContentLoaded as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ContentBlockingLog_OriginDataEntry),
                        "::",
                        stringify!(mHasTrackingContentLoaded)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ContentBlockingLog_OriginDataEntry>()))
                            .mHasCookiesLoaded as *const _ as usize
                    },
                    1usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ContentBlockingLog_OriginDataEntry),
                        "::",
                        stringify!(mHasCookiesLoaded)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ContentBlockingLog_OriginDataEntry>())).mLogs
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ContentBlockingLog_OriginDataEntry),
                        "::",
                        stringify!(mLogs)
                    )
                );
            }
            #[repr(C)]
            pub struct ContentBlockingLog_OriginEntry {
                pub mOrigin: ::gecko_bindings::structs::nsCString,
                pub mData: root::mozilla::UniquePtr<
                    root::mozilla::dom::ContentBlockingLog_OriginDataEntry,
                >,
            }
            #[test]
            fn bindgen_test_layout_ContentBlockingLog_OriginEntry() {
                assert_eq!(
                    ::std::mem::size_of::<ContentBlockingLog_OriginEntry>(),
                    24usize,
                    concat!("Size of: ", stringify!(ContentBlockingLog_OriginEntry))
                );
                assert_eq!(
                    ::std::mem::align_of::<ContentBlockingLog_OriginEntry>(),
                    8usize,
                    concat!("Alignment of ", stringify!(ContentBlockingLog_OriginEntry))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ContentBlockingLog_OriginEntry>())).mOrigin
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ContentBlockingLog_OriginEntry),
                        "::",
                        stringify!(mOrigin)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ContentBlockingLog_OriginEntry>())).mData as *const _
                            as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ContentBlockingLog_OriginEntry),
                        "::",
                        stringify!(mData)
                    )
                );
            }
            pub type ContentBlockingLog_OriginDataTable =
                root::nsTArray<root::mozilla::dom::ContentBlockingLog_OriginEntry>;
            #[repr(C)]
            #[derive(Debug)]
            pub struct ContentBlockingLog_StringWriteFunc {
                pub _base: root::mozilla::JSONWriteFunc,
                pub mBuffer: *mut ::gecko_bindings::structs::nsACString,
            }
            #[test]
            fn bindgen_test_layout_ContentBlockingLog_StringWriteFunc() {
                assert_eq!(
                    ::std::mem::size_of::<ContentBlockingLog_StringWriteFunc>(),
                    16usize,
                    concat!("Size of: ", stringify!(ContentBlockingLog_StringWriteFunc))
                );
                assert_eq!(
                    ::std::mem::align_of::<ContentBlockingLog_StringWriteFunc>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(ContentBlockingLog_StringWriteFunc)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ContentBlockingLog_StringWriteFunc>())).mBuffer
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ContentBlockingLog_StringWriteFunc),
                        "::",
                        stringify!(mBuffer)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ContentBlockingLog_Comparator {
                pub _address: u8,
            }
            #[test]
            fn bindgen_test_layout_ContentBlockingLog_Comparator() {
                assert_eq!(
                    ::std::mem::size_of::<ContentBlockingLog_Comparator>(),
                    1usize,
                    concat!("Size of: ", stringify!(ContentBlockingLog_Comparator))
                );
                assert_eq!(
                    ::std::mem::align_of::<ContentBlockingLog_Comparator>(),
                    1usize,
                    concat!("Alignment of ", stringify!(ContentBlockingLog_Comparator))
                );
            }
            #[test]
            fn bindgen_test_layout_ContentBlockingLog() {
                assert_eq!(
                    ::std::mem::size_of::<ContentBlockingLog>(),
                    8usize,
                    concat!("Size of: ", stringify!(ContentBlockingLog))
                );
                assert_eq!(
                    ::std::mem::align_of::<ContentBlockingLog>(),
                    8usize,
                    concat!("Alignment of ", stringify!(ContentBlockingLog))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ContentBlockingLog>())).mLog as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ContentBlockingLog),
                        "::",
                        stringify!(mLog)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct TreeOrderedArray {
                pub mList: u8,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct nsRadioGroupStruct {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct StyleSheetList {
                _unused: [u8; 0],
            }
            #[repr(C)]
            pub struct DocumentOrShadowRoot__bindgen_vtable(::std::os::raw::c_void);
            #[doc = " A class meant to be shared by ShadowRoot and Document, that holds a list of"]
            #[doc = " stylesheets."]
            #[doc = ""]
            #[doc = " TODO(emilio, bug 1418159): In the future this should hold most of the"]
            #[doc = " relevant style state, this should allow us to fix bug 548397."]
            #[repr(C)]
            pub struct DocumentOrShadowRoot {
                pub vtable_: *const DocumentOrShadowRoot__bindgen_vtable,
                pub mStyleSheets: root::nsTArray<root::RefPtr<root::mozilla::StyleSheet>>,
                pub mDOMStyleSheets: root::RefPtr<root::mozilla::dom::StyleSheetList>,
                pub mIdentifierMap: [u64; 4usize],
                pub mRadioGroups: [u64; 4usize],
                pub mAsNode: *mut root::nsINode,
                pub mKind: root::mozilla::dom::DocumentOrShadowRoot_Kind,
            }
            pub const DocumentOrShadowRoot_Kind_Document:
                root::mozilla::dom::DocumentOrShadowRoot_Kind = 0;
            pub const DocumentOrShadowRoot_Kind_ShadowRoot:
                root::mozilla::dom::DocumentOrShadowRoot_Kind = 1;
            pub type DocumentOrShadowRoot_Kind = i32;
            #[doc = " This gets fired when the element that an id refers to changes."]
            #[doc = " This fires at difficult times. It is generally not safe to do anything"]
            #[doc = " which could modify the DOM in any way. Use"]
            #[doc = " nsContentUtils::AddScriptRunner."]
            #[doc = " @return true to keep the callback in the callback set, false"]
            #[doc = " to remove it."]
            pub type DocumentOrShadowRoot_IDTargetObserver = ::std::option::Option<
                unsafe extern "C" fn(
                    aOldElement: *mut root::mozilla::dom::Element,
                    aNewelement: *mut root::mozilla::dom::Element,
                    aData: *mut ::std::os::raw::c_void,
                ) -> bool,
            >;
            #[test]
            fn bindgen_test_layout_DocumentOrShadowRoot() {
                assert_eq!(
                    ::std::mem::size_of::<DocumentOrShadowRoot>(),
                    104usize,
                    concat!("Size of: ", stringify!(DocumentOrShadowRoot))
                );
                assert_eq!(
                    ::std::mem::align_of::<DocumentOrShadowRoot>(),
                    8usize,
                    concat!("Alignment of ", stringify!(DocumentOrShadowRoot))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<DocumentOrShadowRoot>())).mStyleSheets as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(DocumentOrShadowRoot),
                        "::",
                        stringify!(mStyleSheets)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<DocumentOrShadowRoot>())).mDOMStyleSheets as *const _
                            as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(DocumentOrShadowRoot),
                        "::",
                        stringify!(mDOMStyleSheets)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<DocumentOrShadowRoot>())).mIdentifierMap as *const _
                            as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(DocumentOrShadowRoot),
                        "::",
                        stringify!(mIdentifierMap)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<DocumentOrShadowRoot>())).mRadioGroups as *const _
                            as usize
                    },
                    56usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(DocumentOrShadowRoot),
                        "::",
                        stringify!(mRadioGroups)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<DocumentOrShadowRoot>())).mAsNode as *const _
                            as usize
                    },
                    88usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(DocumentOrShadowRoot),
                        "::",
                        stringify!(mAsNode)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<DocumentOrShadowRoot>())).mKind as *const _ as usize
                    },
                    96usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(DocumentOrShadowRoot),
                        "::",
                        stringify!(mKind)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct AnonymousContent {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct BoxObject {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct XULBroadcastManager {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct XULPersist {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct DocumentL10n {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct DocumentTimeline {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct DOMImplementation {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct FeaturePolicy {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct FontFaceSet {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct HTMLImageElement {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Link {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct MediaQueryList {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ScriptLoader {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct XPathEvaluator {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct DOMStyleSheetSetList {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ResizeObserverController {
                _unused: [u8; 0],
            }
            #[repr(C)]
            pub struct DocHeaderData {
                pub mField: root::RefPtr<root::nsAtom>,
                pub mData: ::gecko_bindings::structs::nsString,
                pub mNext: *mut root::mozilla::dom::DocHeaderData,
            }
            #[test]
            fn bindgen_test_layout_DocHeaderData() {
                assert_eq!(
                    ::std::mem::size_of::<DocHeaderData>(),
                    32usize,
                    concat!("Size of: ", stringify!(DocHeaderData))
                );
                assert_eq!(
                    ::std::mem::align_of::<DocHeaderData>(),
                    8usize,
                    concat!("Alignment of ", stringify!(DocHeaderData))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<DocHeaderData>())).mField as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(DocHeaderData),
                        "::",
                        stringify!(mField)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<DocHeaderData>())).mData as *const _ as usize },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(DocHeaderData),
                        "::",
                        stringify!(mData)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<DocHeaderData>())).mNext as *const _ as usize },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(DocHeaderData),
                        "::",
                        stringify!(mNext)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct ExternalResourceMap {
                pub mMap: [u64; 4usize],
                pub mPendingLoads: [u64; 4usize],
                pub mHaveShutDown: bool,
            }
            pub type ExternalResourceMap_SubDocEnumFunc = ::std::option::Option<
                unsafe extern "C" fn(
                    aDocument: *mut root::mozilla::dom::Document,
                    aData: *mut ::std::os::raw::c_void,
                ) -> bool,
            >;
            #[doc = " A class that represents an external resource load that has begun but"]
            #[doc = " doesn\'t have a document yet.  Observers can be registered on this object,"]
            #[doc = " and will be notified after the document is created.  Observers registered"]
            #[doc = " after the document has been created will NOT be notified.  When observers"]
            #[doc = " are notified, the subject will be the newly-created document, the topic"]
            #[doc = " will be \"external-resource-document-created\", and the data will be null."]
            #[doc = " If document creation fails for some reason, observers will still be"]
            #[doc = " notified, with a null document pointer."]
            #[repr(C)]
            #[derive(Debug)]
            pub struct ExternalResourceMap_ExternalResourceLoad {
                pub _base: root::nsISupports,
                pub mObservers: [u64; 10usize],
            }
            #[test]
            fn bindgen_test_layout_ExternalResourceMap_ExternalResourceLoad() {
                assert_eq!(
                    ::std::mem::size_of::<ExternalResourceMap_ExternalResourceLoad>(),
                    88usize,
                    concat!(
                        "Size of: ",
                        stringify!(ExternalResourceMap_ExternalResourceLoad)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<ExternalResourceMap_ExternalResourceLoad>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(ExternalResourceMap_ExternalResourceLoad)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ExternalResourceMap_ExternalResourceLoad>()))
                            .mObservers as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ExternalResourceMap_ExternalResourceLoad),
                        "::",
                        stringify!(mObservers)
                    )
                );
            }
            #[repr(C)]
            pub struct ExternalResourceMap_ExternalResource {
                pub mDocument: root::RefPtr<root::mozilla::dom::Document>,
                pub mViewer: root::nsCOMPtr,
                pub mLoadGroup: root::nsCOMPtr,
            }
            #[test]
            fn bindgen_test_layout_ExternalResourceMap_ExternalResource() {
                assert_eq!(
                    ::std::mem::size_of::<ExternalResourceMap_ExternalResource>(),
                    24usize,
                    concat!(
                        "Size of: ",
                        stringify!(ExternalResourceMap_ExternalResource)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<ExternalResourceMap_ExternalResource>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(ExternalResourceMap_ExternalResource)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ExternalResourceMap_ExternalResource>())).mDocument
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ExternalResourceMap_ExternalResource),
                        "::",
                        stringify!(mDocument)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ExternalResourceMap_ExternalResource>())).mViewer
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ExternalResourceMap_ExternalResource),
                        "::",
                        stringify!(mViewer)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ExternalResourceMap_ExternalResource>())).mLoadGroup
                            as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ExternalResourceMap_ExternalResource),
                        "::",
                        stringify!(mLoadGroup)
                    )
                );
            }
            #[repr(C)]
            pub struct ExternalResourceMap_PendingLoad {
                pub _base: root::mozilla::dom::ExternalResourceMap_ExternalResourceLoad,
                pub _base_1: root::nsIStreamListener,
                pub mRefCnt: root::nsAutoRefCnt,
                pub mDisplayDocument: root::RefPtr<root::mozilla::dom::Document>,
                pub mTargetListener: root::nsCOMPtr,
                pub mURI: root::nsCOMPtr,
            }
            pub type ExternalResourceMap_PendingLoad_HasThreadSafeRefCnt = root::mozilla::FalseType;
            #[test]
            fn bindgen_test_layout_ExternalResourceMap_PendingLoad() {
                assert_eq!(
                    ::std::mem::size_of::<ExternalResourceMap_PendingLoad>(),
                    128usize,
                    concat!("Size of: ", stringify!(ExternalResourceMap_PendingLoad))
                );
                assert_eq!(
                    ::std::mem::align_of::<ExternalResourceMap_PendingLoad>(),
                    8usize,
                    concat!("Alignment of ", stringify!(ExternalResourceMap_PendingLoad))
                );
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct ExternalResourceMap_LoadgroupCallbacks {
                pub _base: root::nsIInterfaceRequestor,
                pub mRefCnt: root::nsAutoRefCnt,
                pub mCallbacks: root::nsCOMPtr,
            }
            pub type ExternalResourceMap_LoadgroupCallbacks_HasThreadSafeRefCnt =
                root::mozilla::FalseType;
            #[repr(C)]
            #[derive(Debug)]
            pub struct ExternalResourceMap_LoadgroupCallbacks_nsILoadContextShim {
                pub _base: root::nsIInterfaceRequestor,
                pub _base_1: root::nsILoadContext,
                pub mRefCnt: root::nsAutoRefCnt,
                pub mIfReq: root::nsCOMPtr,
                pub mRealPtr: root::nsCOMPtr,
            }
            pub type ExternalResourceMap_LoadgroupCallbacks_nsILoadContextShim_HasThreadSafeRefCnt =
                root::mozilla::FalseType;
            #[test]
            fn bindgen_test_layout_ExternalResourceMap_LoadgroupCallbacks_nsILoadContextShim() {
                assert_eq!(
                    ::std::mem::size_of::<ExternalResourceMap_LoadgroupCallbacks_nsILoadContextShim>(
                    ),
                    40usize,
                    concat!(
                        "Size of: ",
                        stringify!(ExternalResourceMap_LoadgroupCallbacks_nsILoadContextShim)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<ExternalResourceMap_LoadgroupCallbacks_nsILoadContextShim>(
                    ),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(ExternalResourceMap_LoadgroupCallbacks_nsILoadContextShim)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct ExternalResourceMap_LoadgroupCallbacks_nsIProgressEventSinkShim {
                pub _base: root::nsIInterfaceRequestor,
                pub _base_1: root::nsIProgressEventSink,
                pub mRefCnt: root::nsAutoRefCnt,
                pub mIfReq: root::nsCOMPtr,
                pub mRealPtr: root::nsCOMPtr,
            }
            pub type ExternalResourceMap_LoadgroupCallbacks_nsIProgressEventSinkShim_HasThreadSafeRefCnt =
                root::mozilla::FalseType;
            #[test]
            fn bindgen_test_layout_ExternalResourceMap_LoadgroupCallbacks_nsIProgressEventSinkShim()
            {
                assert_eq!(
                    ::std::mem::size_of::<
                        ExternalResourceMap_LoadgroupCallbacks_nsIProgressEventSinkShim,
                    >(),
                    40usize,
                    concat!(
                        "Size of: ",
                        stringify!(ExternalResourceMap_LoadgroupCallbacks_nsIProgressEventSinkShim)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<
                        ExternalResourceMap_LoadgroupCallbacks_nsIProgressEventSinkShim,
                    >(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(ExternalResourceMap_LoadgroupCallbacks_nsIProgressEventSinkShim)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct ExternalResourceMap_LoadgroupCallbacks_nsIChannelEventSinkShim {
                pub _base: root::nsIInterfaceRequestor,
                pub _base_1: root::nsIChannelEventSink,
                pub mRefCnt: root::nsAutoRefCnt,
                pub mIfReq: root::nsCOMPtr,
                pub mRealPtr: root::nsCOMPtr,
            }
            pub type ExternalResourceMap_LoadgroupCallbacks_nsIChannelEventSinkShim_HasThreadSafeRefCnt =
                root::mozilla::FalseType;
            #[test]
            fn bindgen_test_layout_ExternalResourceMap_LoadgroupCallbacks_nsIChannelEventSinkShim()
            {
                assert_eq!(
                    ::std::mem::size_of::<
                        ExternalResourceMap_LoadgroupCallbacks_nsIChannelEventSinkShim,
                    >(),
                    40usize,
                    concat!(
                        "Size of: ",
                        stringify!(ExternalResourceMap_LoadgroupCallbacks_nsIChannelEventSinkShim)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<
                        ExternalResourceMap_LoadgroupCallbacks_nsIChannelEventSinkShim,
                    >(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(ExternalResourceMap_LoadgroupCallbacks_nsIChannelEventSinkShim)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct ExternalResourceMap_LoadgroupCallbacks_nsIApplicationCacheContainerShim {
                pub _base: root::nsIInterfaceRequestor,
                pub _base_1: root::nsIApplicationCacheContainer,
                pub mRefCnt: root::nsAutoRefCnt,
                pub mIfReq: root::nsCOMPtr,
                pub mRealPtr: root::nsCOMPtr,
            }
            pub type ExternalResourceMap_LoadgroupCallbacks_nsIApplicationCacheContainerShim_HasThreadSafeRefCnt =
                root::mozilla::FalseType;
            #[test]
            fn bindgen_test_layout_ExternalResourceMap_LoadgroupCallbacks_nsIApplicationCacheContainerShim(
            ) {
                assert_eq!(
                    ::std::mem::size_of::<
                        ExternalResourceMap_LoadgroupCallbacks_nsIApplicationCacheContainerShim,
                    >(),
                    40usize,
                    concat!(
                        "Size of: ",
                        stringify!(
                            ExternalResourceMap_LoadgroupCallbacks_nsIApplicationCacheContainerShim
                        )
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<
                        ExternalResourceMap_LoadgroupCallbacks_nsIApplicationCacheContainerShim,
                    >(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(
                            ExternalResourceMap_LoadgroupCallbacks_nsIApplicationCacheContainerShim
                        )
                    )
                );
            }
            #[test]
            fn bindgen_test_layout_ExternalResourceMap_LoadgroupCallbacks() {
                assert_eq!(
                    ::std::mem::size_of::<ExternalResourceMap_LoadgroupCallbacks>(),
                    24usize,
                    concat!(
                        "Size of: ",
                        stringify!(ExternalResourceMap_LoadgroupCallbacks)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<ExternalResourceMap_LoadgroupCallbacks>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(ExternalResourceMap_LoadgroupCallbacks)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ExternalResourceMap_LoadgroupCallbacks>())).mRefCnt
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ExternalResourceMap_LoadgroupCallbacks),
                        "::",
                        stringify!(mRefCnt)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ExternalResourceMap_LoadgroupCallbacks>()))
                            .mCallbacks as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ExternalResourceMap_LoadgroupCallbacks),
                        "::",
                        stringify!(mCallbacks)
                    )
                );
            }
            #[test]
            fn bindgen_test_layout_ExternalResourceMap() {
                assert_eq!(
                    ::std::mem::size_of::<ExternalResourceMap>(),
                    72usize,
                    concat!("Size of: ", stringify!(ExternalResourceMap))
                );
                assert_eq!(
                    ::std::mem::align_of::<ExternalResourceMap>(),
                    8usize,
                    concat!("Alignment of ", stringify!(ExternalResourceMap))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ExternalResourceMap>())).mMap as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ExternalResourceMap),
                        "::",
                        stringify!(mMap)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ExternalResourceMap>())).mPendingLoads as *const _
                            as usize
                    },
                    32usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ExternalResourceMap),
                        "::",
                        stringify!(mPendingLoads)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ExternalResourceMap>())).mHaveShutDown as *const _
                            as usize
                    },
                    64usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ExternalResourceMap),
                        "::",
                        stringify!(mHaveShutDown)
                    )
                );
            }
            #[repr(C)]
            pub struct Document {
                pub _base: root::nsINode,
                pub _base_1: root::mozilla::dom::DocumentOrShadowRoot,
                pub _base_2: root::nsSupportsWeakReference,
                pub _base_3: root::nsIRadioGroupContainer,
                pub _base_4: root::nsIScriptObjectPrincipal,
                pub _base_5: root::nsIApplicationCacheContainer,
                pub _base_6: root::nsStubMutationObserver,
                pub _base_7: root::mozilla::dom::DispatcherTrait,
                pub _base_8: u64,
                pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
                pub mDocumentL10n: root::RefPtr<root::mozilla::dom::DocumentL10n>,
                pub mL10nResources: root::nsTArray<::gecko_bindings::structs::nsString>,
                pub mApplicationCache: root::nsCOMPtr,
                pub mDeprecationWarnedAbout: u64,
                pub mDocWarningWarnedAbout: u64,
                pub mSelectorCache:
                    root::mozilla::UniquePtr<root::mozilla::dom::Document_SelectorCache>,
                pub mStyleSet: root::mozilla::UniquePtr<root::mozilla::ServoStyleSet>,
                pub mReferrer: ::gecko_bindings::structs::nsCString,
                pub mLastModified: ::gecko_bindings::structs::nsString,
                pub mDocumentURI: root::nsCOMPtr,
                pub mOriginalURI: root::nsCOMPtr,
                pub mChromeXHRDocURI: root::nsCOMPtr,
                pub mDocumentBaseURI: root::nsCOMPtr,
                pub mChromeXHRDocBaseURI: root::nsCOMPtr,
                pub mBaseDomain: ::gecko_bindings::structs::nsCString,
                pub mCachedURLData: root::RefPtr<root::mozilla::URLExtraData>,
                pub mDocumentLoadGroup: root::nsWeakPtr,
                pub mReferrerPolicySet: bool,
                pub mReferrerPolicy: root::mozilla::dom::Document_ReferrerPolicyEnum,
                pub mBlockAllMixedContent: bool,
                pub mBlockAllMixedContentPreloads: bool,
                pub mUpgradeInsecureRequests: bool,
                pub mUpgradeInsecurePreloads: bool,
                pub mDocumentContainer: u64,
                pub mCharacterSet: root::mozilla::NotNull<*const root::mozilla::Encoding>,
                pub mCharacterSetSource: i32,
                pub mParentDocument: *mut root::mozilla::dom::Document,
                pub mCachedRootElement: *mut root::mozilla::dom::Element,
                pub mNodeInfoManager: *mut root::nsNodeInfoManager,
                pub mCSSLoader: root::RefPtr<root::mozilla::css::Loader>,
                pub mStyleImageLoader: root::RefPtr<root::mozilla::css::ImageLoader>,
                pub mAttrStyleSheet: root::RefPtr<root::nsHTMLStyleSheet>,
                pub mStyleAttrStyleSheet: root::RefPtr<root::nsHTMLCSSStyleSheet>,
                pub mImageTracker: root::RefPtr<root::mozilla::dom::ImageTracker>,
                pub mComposedShadowRoots: root::mozilla::dom::Document_ShadowRootSet,
                pub mSVGUseElementsNeedingShadowTreeUpdate:
                    root::mozilla::dom::Document_SVGUseElementSet,
                pub mActivityObservers: u64,
                pub mStyledLinks: [u64; 4usize],
                pub mLinksToUpdate: root::mozilla::dom::Document_LinksToUpdateList,
                pub mAnimationController: root::RefPtr<root::mozilla::SMILAnimationController>,
                pub mPropertyTable: root::nsPropertyTable,
                pub mChildrenCollection: root::nsCOMPtr,
                pub mImages: root::RefPtr<root::nsContentList>,
                pub mEmbeds: root::RefPtr<root::nsContentList>,
                pub mLinks: root::RefPtr<root::nsContentList>,
                pub mForms: root::RefPtr<root::nsContentList>,
                pub mScripts: root::RefPtr<root::nsContentList>,
                pub mApplets: root::nsCOMPtr,
                pub mAnchors: root::RefPtr<root::nsContentList>,
                pub mFontFaceSet: root::RefPtr<root::mozilla::dom::FontFaceSet>,
                pub mLastFocusTime: root::mozilla::TimeStamp,
                pub mDocumentState: root::mozilla::EventStates,
                pub mReadyForIdle: root::RefPtr<root::mozilla::dom::Promise>,
                pub mFeaturePolicy: root::RefPtr<root::mozilla::dom::FeaturePolicy>,
                pub mResizeObserverController:
                    root::mozilla::UniquePtr<root::mozilla::dom::ResizeObserverController>,
                pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 11usize], u8>,
                pub mPendingFullscreenRequests: u8,
                pub mXMLDeclarationBits: u8,
                pub mOnloadBlockCount: u32,
                pub mAsyncOnloadBlockCount: u32,
                pub mCompatMode: root::nsCompatibility,
                pub mReadyState: root::mozilla::dom::Document_ReadyState,
                pub mAncestorIsLoading: bool,
                pub mVisibilityState: root::mozilla::dom::VisibilityState,
                pub mType: root::mozilla::dom::Document_Type,
                pub mDefaultElementType: u8,
                pub mAllowXULXBL: root::mozilla::dom::Document_Tri,
                pub mScriptGlobalObject: root::nsCOMPtr,
                pub mOriginalDocument: root::RefPtr<root::mozilla::dom::Document>,
                pub mBidiOptions: u32,
                pub mSandboxFlags: u32,
                pub mContentLanguage: ::gecko_bindings::structs::nsCString,
                pub mChannel: root::nsCOMPtr,
                pub mContentType: ::gecko_bindings::structs::nsCString,
                pub mContentTypeForWriteCalls: ::gecko_bindings::structs::nsCString,
                pub mSecurityInfo: root::nsCOMPtr,
                pub mFailedChannel: root::nsCOMPtr,
                pub mPartID: u32,
                pub mMarkedCCGeneration: u32,
                pub mPresShell: *mut root::mozilla::PresShell,
                pub mSubtreeModifiedTargets: root::nsCOMArray,
                pub mSubtreeModifiedDepth: u32,
                pub mPreloadingImages: [u64; 4usize],
                pub mPreloadedPreconnects: [u64; 4usize],
                pub mPreloadPictureDepth: u32,
                pub mPreloadPictureFoundSource: ::gecko_bindings::structs::nsString,
                pub mDisplayDocument: root::RefPtr<root::mozilla::dom::Document>,
                pub mEventsSuppressed: u32,
                pub mSuspendedQueues:
                    root::nsTArray<root::RefPtr<root::mozilla::net::ChannelEventQueue>>,
                pub mSuppressedEventListener: root::RefPtr<root::mozilla::dom::EventListener>,
                #[doc = " https://html.spec.whatwg.org/#ignore-destructive-writes-counter"]
                pub mIgnoreDestructiveWritesCounter: u32,
                #[doc = " The current frame request callback handle"]
                pub mFrameRequestCallbackCounter: i32,
                pub mStaticCloneCount: u32,
                pub mLatestStaticClone: u64,
                pub mBlockedNodesByClassifier: root::nsTArray<root::nsWeakPtr>,
                pub mWindow: *mut root::nsPIDOMWindowInner,
                pub mCachedEncoder: root::nsCOMPtr,
                pub mFrameRequestCallbacks:
                    root::nsTArray<root::mozilla::dom::Document_FrameRequest>,
                pub mCanceledFrameRequestCallbacks: [u64; 3usize],
                pub mBFCacheEntry: *mut root::nsIBFCacheEntry,
                pub mBaseTarget: ::gecko_bindings::structs::nsString,
                pub mStateObjectContainer: root::nsCOMPtr,
                pub mStateObjectCached: root::nsCOMPtr,
                pub mInSyncOperationCount: u32,
                pub mXPathEvaluator: root::mozilla::UniquePtr<root::mozilla::dom::XPathEvaluator>,
                pub mAnonymousContents:
                    root::nsTArray<root::RefPtr<root::mozilla::dom::AnonymousContent>>,
                pub mBlockDOMContentLoaded: u32,
                pub mDOMMediaQueryLists: root::mozilla::LinkedList,
                pub mObservers: [u64; 2usize],
                pub mUseCounters: [u64; 3usize],
                pub mChildDocumentUseCounters: [u64; 3usize],
                pub mNotifiedPageForUseCounter: [u64; 3usize],
                pub mStyleUseCounters: root::mozilla::UniquePtr<root::StyleUseCounters>,
                pub mUserHasInteracted: bool,
                pub mHasUserInteractionTimerScheduled: bool,
                pub mPageUnloadingEventTimeStamp: root::mozilla::TimeStamp,
                pub mDocGroup: root::RefPtr<root::nsINode_DocGroup>,
                pub mTrackingScripts: [u64; 4usize],
                pub mContentBlockingLog: root::mozilla::dom::ContentBlockingLog,
                pub mAncestorPrincipals: root::nsTArray<root::nsCOMPtr>,
                pub mAncestorOuterWindowIDs: root::nsTArray<u64>,
                pub mParser: root::nsCOMPtr,
                pub mPrototypeDocument: root::RefPtr<root::nsXULPrototypeDocument>,
                pub mStackRefCnt: root::nsrefcnt,
                pub mWeakSink: root::nsWeakPtr,
                pub mUpdateNestLevel: u32,
                pub mViewportType: root::mozilla::dom::Document_ViewportType,
                pub mSubDocuments: *mut root::PLDHashTable,
                pub mHeaderData: *mut root::mozilla::dom::DocHeaderData,
                pub mFlashClassification: root::mozilla::dom::FlashClassification,
                pub mIsThirdPartyForFlashClassifier: [u8; 2usize],
                pub mPendingTitleChangeEvent: u64,
                pub mTiming: root::RefPtr<root::nsDOMNavigationTiming>,
                pub mLoadingTimeStamp: root::mozilla::TimeStamp,
                pub mAutoFocusElement: root::nsWeakPtr,
                pub mScrollToRef: ::gecko_bindings::structs::nsCString,
                pub mScrollAnchorAdjustmentLength: root::nscoord,
                pub mScrollAnchorAdjustmentCount: i32,
                pub mScopeObject: root::nsWeakPtr,
                pub mIntersectionObservers: [u64; 4usize],
                pub mFullscreenStack: root::nsTArray<root::nsWeakPtr>,
                pub mFullscreenRoot: root::nsWeakPtr,
                pub mDOMImplementation: root::RefPtr<root::mozilla::dom::DOMImplementation>,
                pub mImageMaps: root::RefPtr<root::nsContentList>,
                pub mResponsiveContent: [u64; 4usize],
                pub mPlugins: [u64; 4usize],
                pub mDocumentTimeline: root::RefPtr<root::mozilla::dom::DocumentTimeline>,
                pub mTimelines: root::mozilla::LinkedList,
                pub mScriptLoader: root::RefPtr<root::mozilla::dom::ScriptLoader>,
                pub mBoxObjectTable: *mut u8,
                pub mPendingAnimationTracker: root::RefPtr<root::mozilla::PendingAnimationTracker>,
                pub mTemplateContentsOwner: root::RefPtr<root::mozilla::dom::Document>,
                pub mExternalResourceMap: root::mozilla::dom::ExternalResourceMap,
                pub mOrientationPendingPromise: root::RefPtr<root::mozilla::dom::Promise>,
                pub mCurrentOrientationAngle: u16,
                pub mCurrentOrientationType: root::mozilla::dom::OrientationType,
                pub mInitializableFrameLoaders: root::nsTArray<root::RefPtr<root::nsFrameLoader>>,
                pub mFrameLoaderFinalizers: root::nsTArray<root::nsCOMPtr>,
                pub mFrameLoaderRunner: u64,
                pub mLayoutHistoryState: root::nsCOMPtr,
                pub mScaleMinFloat: root::mozilla::LayoutDeviceToScreenScale,
                pub mScaleMaxFloat: root::mozilla::LayoutDeviceToScreenScale,
                pub mScaleFloat: root::mozilla::LayoutDeviceToScreenScale,
                pub mPixelRatio: root::mozilla::CSSToLayoutDeviceScale,
                pub mMinWidth: root::mozilla::CSSCoord,
                pub mMaxWidth: root::mozilla::CSSCoord,
                pub mMinHeight: root::mozilla::CSSCoord,
                pub mMaxHeight: root::mozilla::CSSCoord,
                pub mListenerManager: root::RefPtr<root::mozilla::EventListenerManager>,
                pub mMaybeEndOutermostXBLUpdateRunner: root::nsCOMPtr,
                pub mOnloadBlocker: root::nsCOMPtr,
                pub mAdditionalSheets:
                    [root::nsTArray<root::RefPtr<root::mozilla::StyleSheet>>; 3usize],
                pub mLastStyleSheetSet: ::gecko_bindings::structs::nsString,
                pub mPreferredStyleSheetSet: ::gecko_bindings::structs::nsString,
                pub mStyleSheetSetList: root::RefPtr<root::mozilla::dom::DOMStyleSheetSetList>,
                pub mLazySVGPresElements: [u64; 4usize],
                pub mLangGroupFontPrefs: root::mozilla::LangGroupFontPrefs,
                pub mLanguagesUsed: [u64; 4usize],
                pub mLanguageFromCharset: root::RefPtr<root::nsAtom>,
                pub mServoRestyleRoot: root::nsCOMPtr,
                pub mServoRestyleRootDirtyBits: u32,
                pub mThrowOnDynamicMarkupInsertionCounter: u32,
                pub mIgnoreOpensDuringUnloadCounter: u32,
                pub mCommandDispatcher: root::nsCOMPtr,
                pub mXULBroadcastManager: root::RefPtr<root::mozilla::dom::XULBroadcastManager>,
                pub mXULPersist: root::RefPtr<root::mozilla::dom::XULPersist>,
                pub mDocLWTheme: root::mozilla::dom::Document_DocumentTheme,
                pub mSavedResolution: f32,
                pub mPendingInitialTranslation: bool,
                pub mCookieSettings: root::nsCOMPtr,
                pub mGeneration: i32,
                pub mCachedTabSizeGeneration: i32,
                pub mCachedTabSizes: root::nsTabSizes,
                pub mInRDMPane: bool,
                pub mIntrinsicStoragePrincipal: root::nsCOMPtr,
                pub mExpandoAndGeneration: root::js::ExpandoAndGeneration,
            }
            pub type Document_ExternalResourceLoad =
                root::mozilla::dom::ExternalResourceMap_ExternalResourceLoad;
            pub use self::super::super::super::root::mozilla::net::ReferrerPolicy as Document_ReferrerPolicyEnum;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Document_COMTypeInfo {
                pub _address: u8,
            }
            pub type Document_HasThreadSafeRefCnt = root::mozilla::FalseType;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Document_cycleCollection {
                pub _base: root::nsXPCOMCycleCollectionParticipant,
            }
            #[test]
            fn bindgen_test_layout_Document_cycleCollection() {
                assert_eq!(
                    ::std::mem::size_of::<Document_cycleCollection>(),
                    16usize,
                    concat!("Size of: ", stringify!(Document_cycleCollection))
                );
                assert_eq!(
                    ::std::mem::align_of::<Document_cycleCollection>(),
                    8usize,
                    concat!("Alignment of ", stringify!(Document_cycleCollection))
                );
            }
            #[repr(C)]
            pub struct Document_PageUnloadingEventTimeStamp {
                pub mDocument: root::RefPtr<root::mozilla::dom::Document>,
                pub mSet: bool,
            }
            #[test]
            fn bindgen_test_layout_Document_PageUnloadingEventTimeStamp() {
                assert_eq!(
                    ::std::mem::size_of::<Document_PageUnloadingEventTimeStamp>(),
                    16usize,
                    concat!(
                        "Size of: ",
                        stringify!(Document_PageUnloadingEventTimeStamp)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<Document_PageUnloadingEventTimeStamp>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(Document_PageUnloadingEventTimeStamp)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<Document_PageUnloadingEventTimeStamp>())).mDocument
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Document_PageUnloadingEventTimeStamp),
                        "::",
                        stringify!(mDocument)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<Document_PageUnloadingEventTimeStamp>())).mSet
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Document_PageUnloadingEventTimeStamp),
                        "::",
                        stringify!(mSet)
                    )
                );
            }
            #[repr(C)]
            pub struct Document_SelectorCacheKey {
                pub mKey: ::gecko_bindings::structs::nsString,
                pub mState: root::nsExpirationState,
            }
            #[test]
            fn bindgen_test_layout_Document_SelectorCacheKey() {
                assert_eq!(
                    ::std::mem::size_of::<Document_SelectorCacheKey>(),
                    24usize,
                    concat!("Size of: ", stringify!(Document_SelectorCacheKey))
                );
                assert_eq!(
                    ::std::mem::align_of::<Document_SelectorCacheKey>(),
                    8usize,
                    concat!("Alignment of ", stringify!(Document_SelectorCacheKey))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<Document_SelectorCacheKey>())).mKey as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Document_SelectorCacheKey),
                        "::",
                        stringify!(mKey)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<Document_SelectorCacheKey>())).mState as *const _
                            as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Document_SelectorCacheKey),
                        "::",
                        stringify!(mState)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Document_SelectorCacheKeyDeleter {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[repr(align(8))]
            #[derive(Debug, Copy, Clone)]
            pub struct Document_SelectorCache {
                pub _bindgen_opaque_blob: [u64; 16usize],
            }
            pub type Document_SelectorCache_SelectorList =
                root::mozilla::UniquePtr<root::RawServoSelectorList>;
            #[test]
            fn bindgen_test_layout_Document_SelectorCache() {
                assert_eq!(
                    ::std::mem::size_of::<Document_SelectorCache>(),
                    128usize,
                    concat!("Size of: ", stringify!(Document_SelectorCache))
                );
                assert_eq!(
                    ::std::mem::align_of::<Document_SelectorCache>(),
                    8usize,
                    concat!("Alignment of ", stringify!(Document_SelectorCache))
                );
            }
            pub const Document_additionalSheetType_eAgentSheet:
                root::mozilla::dom::Document_additionalSheetType = 0;
            pub const Document_additionalSheetType_eUserSheet:
                root::mozilla::dom::Document_additionalSheetType = 1;
            pub const Document_additionalSheetType_eAuthorSheet:
                root::mozilla::dom::Document_additionalSheetType = 2;
            pub const Document_additionalSheetType_AdditionalSheetTypeCount:
                root::mozilla::dom::Document_additionalSheetType = 3;
            pub type Document_additionalSheetType = u32;
            pub const Document_ReadyState_READYSTATE_UNINITIALIZED:
                root::mozilla::dom::Document_ReadyState = 0;
            pub const Document_ReadyState_READYSTATE_LOADING:
                root::mozilla::dom::Document_ReadyState = 1;
            pub const Document_ReadyState_READYSTATE_INTERACTIVE:
                root::mozilla::dom::Document_ReadyState = 3;
            pub const Document_ReadyState_READYSTATE_COMPLETE:
                root::mozilla::dom::Document_ReadyState = 4;
            pub type Document_ReadyState = u32;
            #[doc = " Enumerate all subdocuments."]
            #[doc = " The enumerator callback should return true to continue enumerating, or"]
            #[doc = " false to stop.  This will never get passed a null aDocument."]
            pub type Document_SubDocEnumFunc = ::std::option::Option<
                unsafe extern "C" fn(
                    arg1: *mut root::mozilla::dom::Document,
                    aData: *mut ::std::os::raw::c_void,
                ) -> bool,
            >;
            #[doc = " Collect all the descendant documents for which |aCalback| returns true."]
            #[doc = " The callback function must not mutate any state for the given document."]
            pub type Document_nsDocTestFunc = ::std::option::Option<
                unsafe extern "C" fn(aDocument: *const root::mozilla::dom::Document) -> bool,
            >;
            pub type Document_ActivityObserverEnumerator = ::std::option::Option<
                unsafe extern "C" fn(
                    arg1: *mut root::nsISupports,
                    arg2: *mut ::std::os::raw::c_void,
                ),
            >;
            #[repr(u32)]
            #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
            pub enum Document_DocumentTheme {
                Doc_Theme_Uninitialized = 0,
                Doc_Theme_None = 1,
                Doc_Theme_Neutral = 2,
                Doc_Theme_Dark = 3,
                Doc_Theme_Bright = 4,
            }
            pub const Document_MediaDocumentKind_NotMedia:
                root::mozilla::dom::Document_MediaDocumentKind = 0;
            pub const Document_MediaDocumentKind_Video:
                root::mozilla::dom::Document_MediaDocumentKind = 1;
            pub const Document_MediaDocumentKind_Image:
                root::mozilla::dom::Document_MediaDocumentKind = 2;
            pub const Document_MediaDocumentKind_Plugin:
                root::mozilla::dom::Document_MediaDocumentKind = 3;
            pub type Document_MediaDocumentKind = i32;
            #[repr(C)]
            #[derive(Debug)]
            pub struct Document_FrameRequest {
                pub mCallback: root::RefPtr<root::mozilla::dom::FrameRequestCallback>,
                pub mHandle: i32,
            }
            #[test]
            fn bindgen_test_layout_Document_FrameRequest() {
                assert_eq!(
                    ::std::mem::size_of::<Document_FrameRequest>(),
                    16usize,
                    concat!("Size of: ", stringify!(Document_FrameRequest))
                );
                assert_eq!(
                    ::std::mem::align_of::<Document_FrameRequest>(),
                    8usize,
                    concat!("Alignment of ", stringify!(Document_FrameRequest))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<Document_FrameRequest>())).mCallback as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Document_FrameRequest),
                        "::",
                        stringify!(mCallback)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<Document_FrameRequest>())).mHandle as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Document_FrameRequest),
                        "::",
                        stringify!(mHandle)
                    )
                );
            }
            pub type Document_ShadowRootSet = [u64; 4usize];
            pub const Document_DeprecatedOperations_eEnablePrivilege:
                root::mozilla::dom::Document_DeprecatedOperations = 0;
            pub const Document_DeprecatedOperations_eMutationEvent:
                root::mozilla::dom::Document_DeprecatedOperations = 1;
            pub const Document_DeprecatedOperations_eComponents:
                root::mozilla::dom::Document_DeprecatedOperations = 2;
            pub const Document_DeprecatedOperations_eNodeIteratorDetach:
                root::mozilla::dom::Document_DeprecatedOperations = 3;
            pub const Document_DeprecatedOperations_eLenientThis:
                root::mozilla::dom::Document_DeprecatedOperations = 4;
            pub const Document_DeprecatedOperations_eMozGetAsFile:
                root::mozilla::dom::Document_DeprecatedOperations = 5;
            pub const Document_DeprecatedOperations_eUseOfCaptureEvents:
                root::mozilla::dom::Document_DeprecatedOperations = 6;
            pub const Document_DeprecatedOperations_eUseOfReleaseEvents:
                root::mozilla::dom::Document_DeprecatedOperations = 7;
            pub const Document_DeprecatedOperations_eUseOfDOM3LoadMethod:
                root::mozilla::dom::Document_DeprecatedOperations = 8;
            pub const Document_DeprecatedOperations_eChromeUseOfDOM3LoadMethod:
                root::mozilla::dom::Document_DeprecatedOperations = 9;
            pub const Document_DeprecatedOperations_eShowModalDialog:
                root::mozilla::dom::Document_DeprecatedOperations = 10;
            pub const Document_DeprecatedOperations_eSyncXMLHttpRequest:
                root::mozilla::dom::Document_DeprecatedOperations = 11;
            pub const Document_DeprecatedOperations_eWindow_Cc_ontrollers:
                root::mozilla::dom::Document_DeprecatedOperations = 12;
            pub const Document_DeprecatedOperations_eImportXULIntoContent:
                root::mozilla::dom::Document_DeprecatedOperations = 13;
            pub const Document_DeprecatedOperations_eNavigatorGetUserMedia:
                root::mozilla::dom::Document_DeprecatedOperations = 14;
            pub const Document_DeprecatedOperations_eWebrtcDeprecatedPrefix:
                root::mozilla::dom::Document_DeprecatedOperations = 15;
            pub const Document_DeprecatedOperations_eRTCPeerConnectionGetStreams:
                root::mozilla::dom::Document_DeprecatedOperations = 16;
            pub const Document_DeprecatedOperations_eAppCache:
                root::mozilla::dom::Document_DeprecatedOperations = 17;
            pub const Document_DeprecatedOperations_eAppCacheInsecure:
                root::mozilla::dom::Document_DeprecatedOperations = 18;
            pub const Document_DeprecatedOperations_ePrefixedImageSmoothingEnabled:
                root::mozilla::dom::Document_DeprecatedOperations = 19;
            pub const Document_DeprecatedOperations_eLenientSetter:
                root::mozilla::dom::Document_DeprecatedOperations = 20;
            pub const Document_DeprecatedOperations_eImageBitmapRenderingContext_TransferImageBitmap : root :: mozilla :: dom :: Document_DeprecatedOperations = 21 ;
            pub const Document_DeprecatedOperations_eWindowContentUntrusted:
                root::mozilla::dom::Document_DeprecatedOperations = 22;
            pub const Document_DeprecatedOperations_eRegisterProtocolHandlerInsecure:
                root::mozilla::dom::Document_DeprecatedOperations = 23;
            pub const Document_DeprecatedOperations_eMixedDisplayObjectSubrequest:
                root::mozilla::dom::Document_DeprecatedOperations = 24;
            pub const Document_DeprecatedOperations_eMotionEvent:
                root::mozilla::dom::Document_DeprecatedOperations = 25;
            pub const Document_DeprecatedOperations_eOrientationEvent:
                root::mozilla::dom::Document_DeprecatedOperations = 26;
            pub const Document_DeprecatedOperations_eProximityEvent:
                root::mozilla::dom::Document_DeprecatedOperations = 27;
            pub const Document_DeprecatedOperations_eAmbientLightEvent:
                root::mozilla::dom::Document_DeprecatedOperations = 28;
            pub const Document_DeprecatedOperations_eIDBOpenDBOptions_StorageType:
                root::mozilla::dom::Document_DeprecatedOperations = 29;
            pub const Document_DeprecatedOperations_eMozBoxOrInlineBoxDisplay:
                root::mozilla::dom::Document_DeprecatedOperations = 30;
            pub const Document_DeprecatedOperations_eDOMQuadBoundsAttr:
                root::mozilla::dom::Document_DeprecatedOperations = 31;
            pub const Document_DeprecatedOperations_eDeprecatedTestingInterface:
                root::mozilla::dom::Document_DeprecatedOperations = 32;
            pub const Document_DeprecatedOperations_eDeprecatedTestingMethod:
                root::mozilla::dom::Document_DeprecatedOperations = 33;
            pub const Document_DeprecatedOperations_eDeprecatedTestingAttribute:
                root::mozilla::dom::Document_DeprecatedOperations = 34;
            pub const Document_DeprecatedOperations_eCreateImageBitmapCanvasRenderingContext2D:
                root::mozilla::dom::Document_DeprecatedOperations = 35;
            pub const Document_DeprecatedOperations_eMozRequestFullScreenDeprecatedPrefix:
                root::mozilla::dom::Document_DeprecatedOperations = 36;
            pub const Document_DeprecatedOperations_eMozfullscreenchangeDeprecatedPrefix:
                root::mozilla::dom::Document_DeprecatedOperations = 37;
            pub const Document_DeprecatedOperations_eMozfullscreenerrorDeprecatedPrefix:
                root::mozilla::dom::Document_DeprecatedOperations = 38;
            pub const Document_DeprecatedOperations_eExternal_AddSearchProvider:
                root::mozilla::dom::Document_DeprecatedOperations = 39;
            pub const Document_DeprecatedOperations_eMouseEvent_MozPressure:
                root::mozilla::dom::Document_DeprecatedOperations = 40;
            pub const Document_DeprecatedOperations_eDeprecatedOperationCount:
                root::mozilla::dom::Document_DeprecatedOperations = 41;
            pub type Document_DeprecatedOperations = u32;
            pub const Document_DocumentWarnings_eIgnoringWillChangeOverBudget:
                root::mozilla::dom::Document_DocumentWarnings = 0;
            pub const Document_DocumentWarnings_ePreventDefaultFromPassiveListener:
                root::mozilla::dom::Document_DocumentWarnings = 1;
            pub const Document_DocumentWarnings_eSVGRefLoop:
                root::mozilla::dom::Document_DocumentWarnings = 2;
            pub const Document_DocumentWarnings_eSVGRefChainLengthExceeded:
                root::mozilla::dom::Document_DocumentWarnings = 3;
            pub const Document_DocumentWarnings_eDocumentWarningCount:
                root::mozilla::dom::Document_DocumentWarnings = 4;
            pub type Document_DocumentWarnings = u32;
            pub const Document_ElementCallbackType_eConnected:
                root::mozilla::dom::Document_ElementCallbackType = 0;
            pub const Document_ElementCallbackType_eDisconnected:
                root::mozilla::dom::Document_ElementCallbackType = 1;
            pub const Document_ElementCallbackType_eAdopted:
                root::mozilla::dom::Document_ElementCallbackType = 2;
            pub const Document_ElementCallbackType_eAttributeChanged:
                root::mozilla::dom::Document_ElementCallbackType = 3;
            pub const Document_ElementCallbackType_eGetCustomInterface:
                root::mozilla::dom::Document_ElementCallbackType = 4;
            pub type Document_ElementCallbackType = u32;
            pub const Document_UseCounterReportKind_eDefault:
                root::mozilla::dom::Document_UseCounterReportKind = 0;
            pub const Document_UseCounterReportKind_eIncludeExternalResources:
                root::mozilla::dom::Document_UseCounterReportKind = 1;
            pub type Document_UseCounterReportKind = i32;
            pub type Document_SVGUseElementSet = [u64; 4usize];
            pub type Document_LinksToUpdateList = [u64; 3usize];
            #[repr(u32)]
            #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
            pub enum Document_Type {
                eUnknown = 0,
                eHTML = 1,
                eXHTML = 2,
                eGenericXML = 3,
                eSVG = 4,
                eXUL = 5,
            }
            pub const Document_Tri_eTriUnset: root::mozilla::dom::Document_Tri = 0;
            pub const Document_Tri_eTriFalse: root::mozilla::dom::Document_Tri = 1;
            pub const Document_Tri_eTriTrue: root::mozilla::dom::Document_Tri = 2;
            pub type Document_Tri = u32;
            pub const Document_ViewportType_DisplayWidthHeight:
                root::mozilla::dom::Document_ViewportType = 0;
            pub const Document_ViewportType_Specified: root::mozilla::dom::Document_ViewportType =
                1;
            pub const Document_ViewportType_Unknown: root::mozilla::dom::Document_ViewportType = 2;
            pub const Document_ViewportType_NoValidContent:
                root::mozilla::dom::Document_ViewportType = 3;
            pub type Document_ViewportType = u8;
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom8Document21_cycleCollectorGlobalE"]
                pub static mut Document__cycleCollectorGlobal:
                    root::mozilla::dom::Document_cycleCollection;
            }
            pub const Document_kSegmentSize: usize = 128;
            #[test]
            fn bindgen_test_layout_Document() {
                assert_eq!(
                    ::std::mem::size_of::<Document>(),
                    2712usize,
                    concat!("Size of: ", stringify!(Document))
                );
                assert_eq!(
                    ::std::mem::align_of::<Document>(),
                    8usize,
                    concat!("Alignment of ", stringify!(Document))
                );
            }
            impl Document {
                #[inline]
                pub fn mBidiEnabled(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mBidiEnabled(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(0usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mMayNeedFontPrefsUpdate(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mMayNeedFontPrefsUpdate(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(1usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mMathMLEnabled(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mMathMLEnabled(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(2usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mIsInitialDocumentInWindow(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsInitialDocumentInWindow(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(3usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mIgnoreDocGroupMismatches(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIgnoreDocGroupMismatches(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(4usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mLoadedAsData(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mLoadedAsData(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(5usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mLoadedAsInteractiveData(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mLoadedAsInteractiveData(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(6usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mMayStartLayout(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mMayStartLayout(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(7usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mHaveFiredTitleChange(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mHaveFiredTitleChange(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(8usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mIsShowing(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(9usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsShowing(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(9usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mVisible(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(10usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mVisible(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(10usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mRemovedFromDocShell(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(11usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mRemovedFromDocShell(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(11usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mAllowDNSPrefetch(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(12usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mAllowDNSPrefetch(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(12usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mIsStaticDocument(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(13usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsStaticDocument(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(13usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mCreatingStaticClone(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(14usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mCreatingStaticClone(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(14usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mInUnlinkOrDeletion(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(15usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mInUnlinkOrDeletion(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(15usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mHasHadScriptHandlingObject(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(16usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mHasHadScriptHandlingObject(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(16usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mIsBeingUsedAsImage(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(17usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsBeingUsedAsImage(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(17usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mDocURISchemeIsChrome(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(18usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mDocURISchemeIsChrome(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(18usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mInChromeDocShell(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(19usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mInChromeDocShell(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(19usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mIsSyntheticDocument(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(20usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsSyntheticDocument(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(20usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mHasLinksToUpdateRunnable(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(21usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mHasLinksToUpdateRunnable(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(21usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mFlushingPendingLinkUpdates(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(22usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mFlushingPendingLinkUpdates(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(22usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mMayHaveDOMMutationObservers(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(23usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mMayHaveDOMMutationObservers(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(23usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mMayHaveAnimationObservers(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(24usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mMayHaveAnimationObservers(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(24usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mHasMixedActiveContentLoaded(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(25usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mHasMixedActiveContentLoaded(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(25usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mHasMixedActiveContentBlocked(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(26usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mHasMixedActiveContentBlocked(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(26usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mHasMixedDisplayContentLoaded(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(27usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mHasMixedDisplayContentLoaded(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(27usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mHasMixedDisplayContentBlocked(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(28usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mHasMixedDisplayContentBlocked(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(28usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mHasMixedContentObjectSubrequest(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(29usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mHasMixedContentObjectSubrequest(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(29usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mHasCSP(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(30usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mHasCSP(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(30usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mHasUnsafeEvalCSP(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(31usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mHasUnsafeEvalCSP(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(31usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mHasUnsafeInlineCSP(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(32usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mHasUnsafeInlineCSP(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(32usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mBFCacheDisallowed(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(33usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mBFCacheDisallowed(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(33usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mHasHadDefaultView(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(34usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mHasHadDefaultView(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(34usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mStyleSheetChangeEventsEnabled(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(35usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mStyleSheetChangeEventsEnabled(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(35usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mIsSrcdocDocument(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(36usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsSrcdocDocument(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(36usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mHasDisplayDocument(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(37usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mHasDisplayDocument(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(37usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mFontFaceSetDirty(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(38usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mFontFaceSetDirty(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(38usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mDidFireDOMContentLoaded(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(39usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mDidFireDOMContentLoaded(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(39usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mHasScrollLinkedEffect(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(40usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mHasScrollLinkedEffect(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(40usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mFrameRequestCallbacksScheduled(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(41usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mFrameRequestCallbacksScheduled(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(41usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mIsTopLevelContentDocument(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(42usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsTopLevelContentDocument(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(42usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mIsContentDocument(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(43usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsContentDocument(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(43usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mDidCallBeginLoad(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(44usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mDidCallBeginLoad(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(44usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mAllowPaymentRequest(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(45usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mAllowPaymentRequest(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(45usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mEncodingMenuDisabled(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(46usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mEncodingMenuDisabled(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(46usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mLinksEnabled(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(47usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mLinksEnabled(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(47usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mIsSVGGlyphsDocument(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(48usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsSVGGlyphsDocument(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(48usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mInDestructor(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(49usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mInDestructor(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(49usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mIsGoingAway(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(50usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsGoingAway(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(50usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mInXBLUpdate(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(51usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mInXBLUpdate(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(51usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mNeedsReleaseAfterStackRefCntRelease(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(52usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mNeedsReleaseAfterStackRefCntRelease(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(52usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mStyleSetFilled(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(53usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mStyleSetFilled(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(53usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mQuirkSheetAdded(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(54usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mQuirkSheetAdded(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(54usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mContentEditableSheetAdded(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(55usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mContentEditableSheetAdded(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(55usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mDesignModeSheetAdded(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(56usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mDesignModeSheetAdded(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(56usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mSSApplicableStateNotificationPending(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(57usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mSSApplicableStateNotificationPending(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(57usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mMayHaveTitleElement(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(58usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mMayHaveTitleElement(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(58usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mDOMLoadingSet(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(59usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mDOMLoadingSet(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(59usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mDOMInteractiveSet(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(60usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mDOMInteractiveSet(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(60usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mDOMCompleteSet(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(61usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mDOMCompleteSet(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(61usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mAutoFocusFired(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(62usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mAutoFocusFired(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(62usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mScrolledToRefAlready(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(63usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mScrolledToRefAlready(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(63usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mChangeScrollPosWhenScrollingToRef(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(64usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mChangeScrollPosWhenScrollingToRef(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(64usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mHasWarnedAboutBoxObjects(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(65usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mHasWarnedAboutBoxObjects(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(65usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mDelayFrameLoaderInitialization(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(66usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mDelayFrameLoaderInitialization(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(66usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mSynchronousDOMContentLoaded(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(67usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mSynchronousDOMContentLoaded(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(67usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mMaybeServiceWorkerControlled(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(68usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mMaybeServiceWorkerControlled(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(68usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mAllowZoom(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(69usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mAllowZoom(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(69usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mValidScaleFloat(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(70usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mValidScaleFloat(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(70usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mValidMinScale(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(71usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mValidMinScale(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(71usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mValidMaxScale(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(72usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mValidMaxScale(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(72usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mWidthStrEmpty(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(73usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mWidthStrEmpty(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(73usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mParserAborted(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(74usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mParserAborted(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(74usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mReportedUseCounters(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(75usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mReportedUseCounters(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(75usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mHasReportedShadowDOMUsage(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(76usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mHasReportedShadowDOMUsage(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(76usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mDocTreeHadAudibleMedia(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(77usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mDocTreeHadAudibleMedia(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(77usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mDocTreeHadPlayRevoked(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(78usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mDocTreeHadPlayRevoked(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(78usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mHasDelayedRefreshEvent(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(79usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mHasDelayedRefreshEvent(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(79usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mLoadEventFiring(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(80usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mLoadEventFiring(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(80usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mSkipLoadEventAfterClose(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(81usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mSkipLoadEventAfterClose(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(81usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mDisableCookieAccess(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(82usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mDisableCookieAccess(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(82usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn new_bitfield_1(
                    mBidiEnabled: bool,
                    mMayNeedFontPrefsUpdate: bool,
                    mMathMLEnabled: bool,
                    mIsInitialDocumentInWindow: bool,
                    mIgnoreDocGroupMismatches: bool,
                    mLoadedAsData: bool,
                    mLoadedAsInteractiveData: bool,
                    mMayStartLayout: bool,
                    mHaveFiredTitleChange: bool,
                    mIsShowing: bool,
                    mVisible: bool,
                    mRemovedFromDocShell: bool,
                    mAllowDNSPrefetch: bool,
                    mIsStaticDocument: bool,
                    mCreatingStaticClone: bool,
                    mInUnlinkOrDeletion: bool,
                    mHasHadScriptHandlingObject: bool,
                    mIsBeingUsedAsImage: bool,
                    mDocURISchemeIsChrome: bool,
                    mInChromeDocShell: bool,
                    mIsSyntheticDocument: bool,
                    mHasLinksToUpdateRunnable: bool,
                    mFlushingPendingLinkUpdates: bool,
                    mMayHaveDOMMutationObservers: bool,
                    mMayHaveAnimationObservers: bool,
                    mHasMixedActiveContentLoaded: bool,
                    mHasMixedActiveContentBlocked: bool,
                    mHasMixedDisplayContentLoaded: bool,
                    mHasMixedDisplayContentBlocked: bool,
                    mHasMixedContentObjectSubrequest: bool,
                    mHasCSP: bool,
                    mHasUnsafeEvalCSP: bool,
                    mHasUnsafeInlineCSP: bool,
                    mBFCacheDisallowed: bool,
                    mHasHadDefaultView: bool,
                    mStyleSheetChangeEventsEnabled: bool,
                    mIsSrcdocDocument: bool,
                    mHasDisplayDocument: bool,
                    mFontFaceSetDirty: bool,
                    mDidFireDOMContentLoaded: bool,
                    mHasScrollLinkedEffect: bool,
                    mFrameRequestCallbacksScheduled: bool,
                    mIsTopLevelContentDocument: bool,
                    mIsContentDocument: bool,
                    mDidCallBeginLoad: bool,
                    mAllowPaymentRequest: bool,
                    mEncodingMenuDisabled: bool,
                    mLinksEnabled: bool,
                    mIsSVGGlyphsDocument: bool,
                    mInDestructor: bool,
                    mIsGoingAway: bool,
                    mInXBLUpdate: bool,
                    mNeedsReleaseAfterStackRefCntRelease: bool,
                    mStyleSetFilled: bool,
                    mQuirkSheetAdded: bool,
                    mContentEditableSheetAdded: bool,
                    mDesignModeSheetAdded: bool,
                    mSSApplicableStateNotificationPending: bool,
                    mMayHaveTitleElement: bool,
                    mDOMLoadingSet: bool,
                    mDOMInteractiveSet: bool,
                    mDOMCompleteSet: bool,
                    mAutoFocusFired: bool,
                    mScrolledToRefAlready: bool,
                    mChangeScrollPosWhenScrollingToRef: bool,
                    mHasWarnedAboutBoxObjects: bool,
                    mDelayFrameLoaderInitialization: bool,
                    mSynchronousDOMContentLoaded: bool,
                    mMaybeServiceWorkerControlled: bool,
                    mAllowZoom: bool,
                    mValidScaleFloat: bool,
                    mValidMinScale: bool,
                    mValidMaxScale: bool,
                    mWidthStrEmpty: bool,
                    mParserAborted: bool,
                    mReportedUseCounters: bool,
                    mHasReportedShadowDOMUsage: bool,
                    mDocTreeHadAudibleMedia: bool,
                    mDocTreeHadPlayRevoked: bool,
                    mHasDelayedRefreshEvent: bool,
                    mLoadEventFiring: bool,
                    mSkipLoadEventAfterClose: bool,
                    mDisableCookieAccess: bool,
                ) -> root::__BindgenBitfieldUnit<[u8; 11usize], u8> {
                    let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<
                        [u8; 11usize],
                        u8,
                    > = Default::default();
                    __bindgen_bitfield_unit.set(0usize, 1u8, {
                        let mBidiEnabled: u8 = unsafe { ::std::mem::transmute(mBidiEnabled) };
                        mBidiEnabled as u64
                    });
                    __bindgen_bitfield_unit.set(1usize, 1u8, {
                        let mMayNeedFontPrefsUpdate: u8 =
                            unsafe { ::std::mem::transmute(mMayNeedFontPrefsUpdate) };
                        mMayNeedFontPrefsUpdate as u64
                    });
                    __bindgen_bitfield_unit.set(2usize, 1u8, {
                        let mMathMLEnabled: u8 = unsafe { ::std::mem::transmute(mMathMLEnabled) };
                        mMathMLEnabled as u64
                    });
                    __bindgen_bitfield_unit.set(3usize, 1u8, {
                        let mIsInitialDocumentInWindow: u8 =
                            unsafe { ::std::mem::transmute(mIsInitialDocumentInWindow) };
                        mIsInitialDocumentInWindow as u64
                    });
                    __bindgen_bitfield_unit.set(4usize, 1u8, {
                        let mIgnoreDocGroupMismatches: u8 =
                            unsafe { ::std::mem::transmute(mIgnoreDocGroupMismatches) };
                        mIgnoreDocGroupMismatches as u64
                    });
                    __bindgen_bitfield_unit.set(5usize, 1u8, {
                        let mLoadedAsData: u8 = unsafe { ::std::mem::transmute(mLoadedAsData) };
                        mLoadedAsData as u64
                    });
                    __bindgen_bitfield_unit.set(6usize, 1u8, {
                        let mLoadedAsInteractiveData: u8 =
                            unsafe { ::std::mem::transmute(mLoadedAsInteractiveData) };
                        mLoadedAsInteractiveData as u64
                    });
                    __bindgen_bitfield_unit.set(7usize, 1u8, {
                        let mMayStartLayout: u8 = unsafe { ::std::mem::transmute(mMayStartLayout) };
                        mMayStartLayout as u64
                    });
                    __bindgen_bitfield_unit.set(8usize, 1u8, {
                        let mHaveFiredTitleChange: u8 =
                            unsafe { ::std::mem::transmute(mHaveFiredTitleChange) };
                        mHaveFiredTitleChange as u64
                    });
                    __bindgen_bitfield_unit.set(9usize, 1u8, {
                        let mIsShowing: u8 = unsafe { ::std::mem::transmute(mIsShowing) };
                        mIsShowing as u64
                    });
                    __bindgen_bitfield_unit.set(10usize, 1u8, {
                        let mVisible: u8 = unsafe { ::std::mem::transmute(mVisible) };
                        mVisible as u64
                    });
                    __bindgen_bitfield_unit.set(11usize, 1u8, {
                        let mRemovedFromDocShell: u8 =
                            unsafe { ::std::mem::transmute(mRemovedFromDocShell) };
                        mRemovedFromDocShell as u64
                    });
                    __bindgen_bitfield_unit.set(12usize, 1u8, {
                        let mAllowDNSPrefetch: u8 =
                            unsafe { ::std::mem::transmute(mAllowDNSPrefetch) };
                        mAllowDNSPrefetch as u64
                    });
                    __bindgen_bitfield_unit.set(13usize, 1u8, {
                        let mIsStaticDocument: u8 =
                            unsafe { ::std::mem::transmute(mIsStaticDocument) };
                        mIsStaticDocument as u64
                    });
                    __bindgen_bitfield_unit.set(14usize, 1u8, {
                        let mCreatingStaticClone: u8 =
                            unsafe { ::std::mem::transmute(mCreatingStaticClone) };
                        mCreatingStaticClone as u64
                    });
                    __bindgen_bitfield_unit.set(15usize, 1u8, {
                        let mInUnlinkOrDeletion: u8 =
                            unsafe { ::std::mem::transmute(mInUnlinkOrDeletion) };
                        mInUnlinkOrDeletion as u64
                    });
                    __bindgen_bitfield_unit.set(16usize, 1u8, {
                        let mHasHadScriptHandlingObject: u8 =
                            unsafe { ::std::mem::transmute(mHasHadScriptHandlingObject) };
                        mHasHadScriptHandlingObject as u64
                    });
                    __bindgen_bitfield_unit.set(17usize, 1u8, {
                        let mIsBeingUsedAsImage: u8 =
                            unsafe { ::std::mem::transmute(mIsBeingUsedAsImage) };
                        mIsBeingUsedAsImage as u64
                    });
                    __bindgen_bitfield_unit.set(18usize, 1u8, {
                        let mDocURISchemeIsChrome: u8 =
                            unsafe { ::std::mem::transmute(mDocURISchemeIsChrome) };
                        mDocURISchemeIsChrome as u64
                    });
                    __bindgen_bitfield_unit.set(19usize, 1u8, {
                        let mInChromeDocShell: u8 =
                            unsafe { ::std::mem::transmute(mInChromeDocShell) };
                        mInChromeDocShell as u64
                    });
                    __bindgen_bitfield_unit.set(20usize, 1u8, {
                        let mIsSyntheticDocument: u8 =
                            unsafe { ::std::mem::transmute(mIsSyntheticDocument) };
                        mIsSyntheticDocument as u64
                    });
                    __bindgen_bitfield_unit.set(21usize, 1u8, {
                        let mHasLinksToUpdateRunnable: u8 =
                            unsafe { ::std::mem::transmute(mHasLinksToUpdateRunnable) };
                        mHasLinksToUpdateRunnable as u64
                    });
                    __bindgen_bitfield_unit.set(22usize, 1u8, {
                        let mFlushingPendingLinkUpdates: u8 =
                            unsafe { ::std::mem::transmute(mFlushingPendingLinkUpdates) };
                        mFlushingPendingLinkUpdates as u64
                    });
                    __bindgen_bitfield_unit.set(23usize, 1u8, {
                        let mMayHaveDOMMutationObservers: u8 =
                            unsafe { ::std::mem::transmute(mMayHaveDOMMutationObservers) };
                        mMayHaveDOMMutationObservers as u64
                    });
                    __bindgen_bitfield_unit.set(24usize, 1u8, {
                        let mMayHaveAnimationObservers: u8 =
                            unsafe { ::std::mem::transmute(mMayHaveAnimationObservers) };
                        mMayHaveAnimationObservers as u64
                    });
                    __bindgen_bitfield_unit.set(25usize, 1u8, {
                        let mHasMixedActiveContentLoaded: u8 =
                            unsafe { ::std::mem::transmute(mHasMixedActiveContentLoaded) };
                        mHasMixedActiveContentLoaded as u64
                    });
                    __bindgen_bitfield_unit.set(26usize, 1u8, {
                        let mHasMixedActiveContentBlocked: u8 =
                            unsafe { ::std::mem::transmute(mHasMixedActiveContentBlocked) };
                        mHasMixedActiveContentBlocked as u64
                    });
                    __bindgen_bitfield_unit.set(27usize, 1u8, {
                        let mHasMixedDisplayContentLoaded: u8 =
                            unsafe { ::std::mem::transmute(mHasMixedDisplayContentLoaded) };
                        mHasMixedDisplayContentLoaded as u64
                    });
                    __bindgen_bitfield_unit.set(28usize, 1u8, {
                        let mHasMixedDisplayContentBlocked: u8 =
                            unsafe { ::std::mem::transmute(mHasMixedDisplayContentBlocked) };
                        mHasMixedDisplayContentBlocked as u64
                    });
                    __bindgen_bitfield_unit.set(29usize, 1u8, {
                        let mHasMixedContentObjectSubrequest: u8 =
                            unsafe { ::std::mem::transmute(mHasMixedContentObjectSubrequest) };
                        mHasMixedContentObjectSubrequest as u64
                    });
                    __bindgen_bitfield_unit.set(30usize, 1u8, {
                        let mHasCSP: u8 = unsafe { ::std::mem::transmute(mHasCSP) };
                        mHasCSP as u64
                    });
                    __bindgen_bitfield_unit.set(31usize, 1u8, {
                        let mHasUnsafeEvalCSP: u8 =
                            unsafe { ::std::mem::transmute(mHasUnsafeEvalCSP) };
                        mHasUnsafeEvalCSP as u64
                    });
                    __bindgen_bitfield_unit.set(32usize, 1u8, {
                        let mHasUnsafeInlineCSP: u8 =
                            unsafe { ::std::mem::transmute(mHasUnsafeInlineCSP) };
                        mHasUnsafeInlineCSP as u64
                    });
                    __bindgen_bitfield_unit.set(33usize, 1u8, {
                        let mBFCacheDisallowed: u8 =
                            unsafe { ::std::mem::transmute(mBFCacheDisallowed) };
                        mBFCacheDisallowed as u64
                    });
                    __bindgen_bitfield_unit.set(34usize, 1u8, {
                        let mHasHadDefaultView: u8 =
                            unsafe { ::std::mem::transmute(mHasHadDefaultView) };
                        mHasHadDefaultView as u64
                    });
                    __bindgen_bitfield_unit.set(35usize, 1u8, {
                        let mStyleSheetChangeEventsEnabled: u8 =
                            unsafe { ::std::mem::transmute(mStyleSheetChangeEventsEnabled) };
                        mStyleSheetChangeEventsEnabled as u64
                    });
                    __bindgen_bitfield_unit.set(36usize, 1u8, {
                        let mIsSrcdocDocument: u8 =
                            unsafe { ::std::mem::transmute(mIsSrcdocDocument) };
                        mIsSrcdocDocument as u64
                    });
                    __bindgen_bitfield_unit.set(37usize, 1u8, {
                        let mHasDisplayDocument: u8 =
                            unsafe { ::std::mem::transmute(mHasDisplayDocument) };
                        mHasDisplayDocument as u64
                    });
                    __bindgen_bitfield_unit.set(38usize, 1u8, {
                        let mFontFaceSetDirty: u8 =
                            unsafe { ::std::mem::transmute(mFontFaceSetDirty) };
                        mFontFaceSetDirty as u64
                    });
                    __bindgen_bitfield_unit.set(39usize, 1u8, {
                        let mDidFireDOMContentLoaded: u8 =
                            unsafe { ::std::mem::transmute(mDidFireDOMContentLoaded) };
                        mDidFireDOMContentLoaded as u64
                    });
                    __bindgen_bitfield_unit.set(40usize, 1u8, {
                        let mHasScrollLinkedEffect: u8 =
                            unsafe { ::std::mem::transmute(mHasScrollLinkedEffect) };
                        mHasScrollLinkedEffect as u64
                    });
                    __bindgen_bitfield_unit.set(41usize, 1u8, {
                        let mFrameRequestCallbacksScheduled: u8 =
                            unsafe { ::std::mem::transmute(mFrameRequestCallbacksScheduled) };
                        mFrameRequestCallbacksScheduled as u64
                    });
                    __bindgen_bitfield_unit.set(42usize, 1u8, {
                        let mIsTopLevelContentDocument: u8 =
                            unsafe { ::std::mem::transmute(mIsTopLevelContentDocument) };
                        mIsTopLevelContentDocument as u64
                    });
                    __bindgen_bitfield_unit.set(43usize, 1u8, {
                        let mIsContentDocument: u8 =
                            unsafe { ::std::mem::transmute(mIsContentDocument) };
                        mIsContentDocument as u64
                    });
                    __bindgen_bitfield_unit.set(44usize, 1u8, {
                        let mDidCallBeginLoad: u8 =
                            unsafe { ::std::mem::transmute(mDidCallBeginLoad) };
                        mDidCallBeginLoad as u64
                    });
                    __bindgen_bitfield_unit.set(45usize, 1u8, {
                        let mAllowPaymentRequest: u8 =
                            unsafe { ::std::mem::transmute(mAllowPaymentRequest) };
                        mAllowPaymentRequest as u64
                    });
                    __bindgen_bitfield_unit.set(46usize, 1u8, {
                        let mEncodingMenuDisabled: u8 =
                            unsafe { ::std::mem::transmute(mEncodingMenuDisabled) };
                        mEncodingMenuDisabled as u64
                    });
                    __bindgen_bitfield_unit.set(47usize, 1u8, {
                        let mLinksEnabled: u8 = unsafe { ::std::mem::transmute(mLinksEnabled) };
                        mLinksEnabled as u64
                    });
                    __bindgen_bitfield_unit.set(48usize, 1u8, {
                        let mIsSVGGlyphsDocument: u8 =
                            unsafe { ::std::mem::transmute(mIsSVGGlyphsDocument) };
                        mIsSVGGlyphsDocument as u64
                    });
                    __bindgen_bitfield_unit.set(49usize, 1u8, {
                        let mInDestructor: u8 = unsafe { ::std::mem::transmute(mInDestructor) };
                        mInDestructor as u64
                    });
                    __bindgen_bitfield_unit.set(50usize, 1u8, {
                        let mIsGoingAway: u8 = unsafe { ::std::mem::transmute(mIsGoingAway) };
                        mIsGoingAway as u64
                    });
                    __bindgen_bitfield_unit.set(51usize, 1u8, {
                        let mInXBLUpdate: u8 = unsafe { ::std::mem::transmute(mInXBLUpdate) };
                        mInXBLUpdate as u64
                    });
                    __bindgen_bitfield_unit.set(52usize, 1u8, {
                        let mNeedsReleaseAfterStackRefCntRelease: u8 =
                            unsafe { ::std::mem::transmute(mNeedsReleaseAfterStackRefCntRelease) };
                        mNeedsReleaseAfterStackRefCntRelease as u64
                    });
                    __bindgen_bitfield_unit.set(53usize, 1u8, {
                        let mStyleSetFilled: u8 = unsafe { ::std::mem::transmute(mStyleSetFilled) };
                        mStyleSetFilled as u64
                    });
                    __bindgen_bitfield_unit.set(54usize, 1u8, {
                        let mQuirkSheetAdded: u8 =
                            unsafe { ::std::mem::transmute(mQuirkSheetAdded) };
                        mQuirkSheetAdded as u64
                    });
                    __bindgen_bitfield_unit.set(55usize, 1u8, {
                        let mContentEditableSheetAdded: u8 =
                            unsafe { ::std::mem::transmute(mContentEditableSheetAdded) };
                        mContentEditableSheetAdded as u64
                    });
                    __bindgen_bitfield_unit.set(56usize, 1u8, {
                        let mDesignModeSheetAdded: u8 =
                            unsafe { ::std::mem::transmute(mDesignModeSheetAdded) };
                        mDesignModeSheetAdded as u64
                    });
                    __bindgen_bitfield_unit.set(57usize, 1u8, {
                        let mSSApplicableStateNotificationPending: u8 =
                            unsafe { ::std::mem::transmute(mSSApplicableStateNotificationPending) };
                        mSSApplicableStateNotificationPending as u64
                    });
                    __bindgen_bitfield_unit.set(58usize, 1u8, {
                        let mMayHaveTitleElement: u8 =
                            unsafe { ::std::mem::transmute(mMayHaveTitleElement) };
                        mMayHaveTitleElement as u64
                    });
                    __bindgen_bitfield_unit.set(59usize, 1u8, {
                        let mDOMLoadingSet: u8 = unsafe { ::std::mem::transmute(mDOMLoadingSet) };
                        mDOMLoadingSet as u64
                    });
                    __bindgen_bitfield_unit.set(60usize, 1u8, {
                        let mDOMInteractiveSet: u8 =
                            unsafe { ::std::mem::transmute(mDOMInteractiveSet) };
                        mDOMInteractiveSet as u64
                    });
                    __bindgen_bitfield_unit.set(61usize, 1u8, {
                        let mDOMCompleteSet: u8 = unsafe { ::std::mem::transmute(mDOMCompleteSet) };
                        mDOMCompleteSet as u64
                    });
                    __bindgen_bitfield_unit.set(62usize, 1u8, {
                        let mAutoFocusFired: u8 = unsafe { ::std::mem::transmute(mAutoFocusFired) };
                        mAutoFocusFired as u64
                    });
                    __bindgen_bitfield_unit.set(63usize, 1u8, {
                        let mScrolledToRefAlready: u8 =
                            unsafe { ::std::mem::transmute(mScrolledToRefAlready) };
                        mScrolledToRefAlready as u64
                    });
                    __bindgen_bitfield_unit.set(64usize, 1u8, {
                        let mChangeScrollPosWhenScrollingToRef: u8 =
                            unsafe { ::std::mem::transmute(mChangeScrollPosWhenScrollingToRef) };
                        mChangeScrollPosWhenScrollingToRef as u64
                    });
                    __bindgen_bitfield_unit.set(65usize, 1u8, {
                        let mHasWarnedAboutBoxObjects: u8 =
                            unsafe { ::std::mem::transmute(mHasWarnedAboutBoxObjects) };
                        mHasWarnedAboutBoxObjects as u64
                    });
                    __bindgen_bitfield_unit.set(66usize, 1u8, {
                        let mDelayFrameLoaderInitialization: u8 =
                            unsafe { ::std::mem::transmute(mDelayFrameLoaderInitialization) };
                        mDelayFrameLoaderInitialization as u64
                    });
                    __bindgen_bitfield_unit.set(67usize, 1u8, {
                        let mSynchronousDOMContentLoaded: u8 =
                            unsafe { ::std::mem::transmute(mSynchronousDOMContentLoaded) };
                        mSynchronousDOMContentLoaded as u64
                    });
                    __bindgen_bitfield_unit.set(68usize, 1u8, {
                        let mMaybeServiceWorkerControlled: u8 =
                            unsafe { ::std::mem::transmute(mMaybeServiceWorkerControlled) };
                        mMaybeServiceWorkerControlled as u64
                    });
                    __bindgen_bitfield_unit.set(69usize, 1u8, {
                        let mAllowZoom: u8 = unsafe { ::std::mem::transmute(mAllowZoom) };
                        mAllowZoom as u64
                    });
                    __bindgen_bitfield_unit.set(70usize, 1u8, {
                        let mValidScaleFloat: u8 =
                            unsafe { ::std::mem::transmute(mValidScaleFloat) };
                        mValidScaleFloat as u64
                    });
                    __bindgen_bitfield_unit.set(71usize, 1u8, {
                        let mValidMinScale: u8 = unsafe { ::std::mem::transmute(mValidMinScale) };
                        mValidMinScale as u64
                    });
                    __bindgen_bitfield_unit.set(72usize, 1u8, {
                        let mValidMaxScale: u8 = unsafe { ::std::mem::transmute(mValidMaxScale) };
                        mValidMaxScale as u64
                    });
                    __bindgen_bitfield_unit.set(73usize, 1u8, {
                        let mWidthStrEmpty: u8 = unsafe { ::std::mem::transmute(mWidthStrEmpty) };
                        mWidthStrEmpty as u64
                    });
                    __bindgen_bitfield_unit.set(74usize, 1u8, {
                        let mParserAborted: u8 = unsafe { ::std::mem::transmute(mParserAborted) };
                        mParserAborted as u64
                    });
                    __bindgen_bitfield_unit.set(75usize, 1u8, {
                        let mReportedUseCounters: u8 =
                            unsafe { ::std::mem::transmute(mReportedUseCounters) };
                        mReportedUseCounters as u64
                    });
                    __bindgen_bitfield_unit.set(76usize, 1u8, {
                        let mHasReportedShadowDOMUsage: u8 =
                            unsafe { ::std::mem::transmute(mHasReportedShadowDOMUsage) };
                        mHasReportedShadowDOMUsage as u64
                    });
                    __bindgen_bitfield_unit.set(77usize, 1u8, {
                        let mDocTreeHadAudibleMedia: u8 =
                            unsafe { ::std::mem::transmute(mDocTreeHadAudibleMedia) };
                        mDocTreeHadAudibleMedia as u64
                    });
                    __bindgen_bitfield_unit.set(78usize, 1u8, {
                        let mDocTreeHadPlayRevoked: u8 =
                            unsafe { ::std::mem::transmute(mDocTreeHadPlayRevoked) };
                        mDocTreeHadPlayRevoked as u64
                    });
                    __bindgen_bitfield_unit.set(79usize, 1u8, {
                        let mHasDelayedRefreshEvent: u8 =
                            unsafe { ::std::mem::transmute(mHasDelayedRefreshEvent) };
                        mHasDelayedRefreshEvent as u64
                    });
                    __bindgen_bitfield_unit.set(80usize, 1u8, {
                        let mLoadEventFiring: u8 =
                            unsafe { ::std::mem::transmute(mLoadEventFiring) };
                        mLoadEventFiring as u64
                    });
                    __bindgen_bitfield_unit.set(81usize, 1u8, {
                        let mSkipLoadEventAfterClose: u8 =
                            unsafe { ::std::mem::transmute(mSkipLoadEventAfterClose) };
                        mSkipLoadEventAfterClose as u64
                    });
                    __bindgen_bitfield_unit.set(82usize, 1u8, {
                        let mDisableCookieAccess: u8 =
                            unsafe { ::std::mem::transmute(mDisableCookieAccess) };
                        mDisableCookieAccess as u64
                    });
                    __bindgen_bitfield_unit
                }
            }
            #[repr(C)]
            #[repr(align(8))]
            #[derive(Debug, Copy, Clone)]
            pub struct IntersectionCallback {
                pub _bindgen_opaque_blob: [u64; 7usize],
            }
            #[test]
            fn bindgen_test_layout_IntersectionCallback() {
                assert_eq!(
                    ::std::mem::size_of::<IntersectionCallback>(),
                    56usize,
                    concat!("Size of: ", stringify!(IntersectionCallback))
                );
                assert_eq!(
                    ::std::mem::align_of::<IntersectionCallback>(),
                    8usize,
                    concat!("Alignment of ", stringify!(IntersectionCallback))
                );
            }
            #[repr(C)]
            pub struct DOMIntersectionObserverEntry {
                pub _base: root::nsISupports,
                pub _base_1: root::nsWrapperCache,
                pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
                pub mOwner: root::nsCOMPtr,
                pub mTime: root::DOMHighResTimeStamp,
                pub mRootBounds: root::RefPtr<root::mozilla::dom::DOMRect>,
                pub mBoundingClientRect: root::RefPtr<root::mozilla::dom::DOMRect>,
                pub mIntersectionRect: root::RefPtr<root::mozilla::dom::DOMRect>,
                pub mIsIntersecting: bool,
                pub mTarget: root::RefPtr<root::mozilla::dom::Element>,
                pub mIntersectionRatio: f64,
            }
            pub type DOMIntersectionObserverEntry_HasThreadSafeRefCnt = root::mozilla::FalseType;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct DOMIntersectionObserverEntry_cycleCollection {
                pub _base: root::nsXPCOMCycleCollectionParticipant,
            }
            #[test]
            fn bindgen_test_layout_DOMIntersectionObserverEntry_cycleCollection() {
                assert_eq!(
                    ::std::mem::size_of::<DOMIntersectionObserverEntry_cycleCollection>(),
                    16usize,
                    concat!(
                        "Size of: ",
                        stringify!(DOMIntersectionObserverEntry_cycleCollection)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<DOMIntersectionObserverEntry_cycleCollection>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(DOMIntersectionObserverEntry_cycleCollection)
                    )
                );
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom28DOMIntersectionObserverEntry21_cycleCollectorGlobalE"]
                pub static mut DOMIntersectionObserverEntry__cycleCollectorGlobal:
                    root::mozilla::dom::DOMIntersectionObserverEntry_cycleCollection;
            }
            #[test]
            fn bindgen_test_layout_DOMIntersectionObserverEntry() {
                assert_eq!(
                    ::std::mem::size_of::<DOMIntersectionObserverEntry>(),
                    104usize,
                    concat!("Size of: ", stringify!(DOMIntersectionObserverEntry))
                );
                assert_eq!(
                    ::std::mem::align_of::<DOMIntersectionObserverEntry>(),
                    8usize,
                    concat!("Alignment of ", stringify!(DOMIntersectionObserverEntry))
                );
            }
            #[repr(C)]
            pub struct DOMIntersectionObserver {
                pub _base: root::nsISupports,
                pub _base_1: root::nsWrapperCache,
                pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
                pub mOwner: root::nsCOMPtr,
                pub mDocument: root::RefPtr<root::mozilla::dom::Document>,
                pub mCallback: root::RefPtr<root::mozilla::dom::IntersectionCallback>,
                pub mRoot: root::RefPtr<root::mozilla::dom::Element>,
                pub mRootMargin: root::mozilla::StyleRect<root::mozilla::LengthPercentage>,
                pub mThresholds: root::nsTArray<f64>,
                pub mObservationTargets: root::nsTArray<*mut root::mozilla::dom::Element>,
                pub mQueuedEntries:
                    root::nsTArray<root::RefPtr<root::mozilla::dom::DOMIntersectionObserverEntry>>,
                pub mConnected: bool,
            }
            pub type DOMIntersectionObserver_HasThreadSafeRefCnt = root::mozilla::FalseType;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct DOMIntersectionObserver_cycleCollection {
                pub _base: root::nsXPCOMCycleCollectionParticipant,
            }
            #[test]
            fn bindgen_test_layout_DOMIntersectionObserver_cycleCollection() {
                assert_eq!(
                    ::std::mem::size_of::<DOMIntersectionObserver_cycleCollection>(),
                    16usize,
                    concat!(
                        "Size of: ",
                        stringify!(DOMIntersectionObserver_cycleCollection)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<DOMIntersectionObserver_cycleCollection>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(DOMIntersectionObserver_cycleCollection)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct DOMIntersectionObserver_COMTypeInfo {
                pub _address: u8,
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom23DOMIntersectionObserver21_cycleCollectorGlobalE"]
                pub static mut DOMIntersectionObserver__cycleCollectorGlobal:
                    root::mozilla::dom::DOMIntersectionObserver_cycleCollection;
            }
            #[test]
            fn bindgen_test_layout_DOMIntersectionObserver() {
                assert_eq!(
                    ::std::mem::size_of::<DOMIntersectionObserver>(),
                    152usize,
                    concat!("Size of: ", stringify!(DOMIntersectionObserver))
                );
                assert_eq!(
                    ::std::mem::align_of::<DOMIntersectionObserver>(),
                    8usize,
                    concat!("Alignment of ", stringify!(DOMIntersectionObserver))
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct BrowserChild {
                _unused: [u8; 0],
            }
            #[repr(C)]
            pub struct Attr {
                pub _base: root::nsINode,
                pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
                pub mAttrMap: root::RefPtr<root::nsDOMAttributeMap>,
                pub mValue: ::gecko_bindings::structs::nsString,
            }
            pub type Attr_HasThreadSafeRefCnt = root::mozilla::FalseType;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Attr_cycleCollection {
                pub _base: root::nsXPCOMCycleCollectionParticipant,
            }
            #[test]
            fn bindgen_test_layout_Attr_cycleCollection() {
                assert_eq!(
                    ::std::mem::size_of::<Attr_cycleCollection>(),
                    16usize,
                    concat!("Size of: ", stringify!(Attr_cycleCollection))
                );
                assert_eq!(
                    ::std::mem::align_of::<Attr_cycleCollection>(),
                    8usize,
                    concat!("Alignment of ", stringify!(Attr_cycleCollection))
                );
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom4Attr21_cycleCollectorGlobalE"]
                pub static mut Attr__cycleCollectorGlobal: root::mozilla::dom::Attr_cycleCollection;
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom4Attr12sInitializedE"]
                pub static mut Attr_sInitialized: bool;
            }
            #[test]
            fn bindgen_test_layout_Attr() {
                assert_eq!(
                    ::std::mem::size_of::<Attr>(),
                    128usize,
                    concat!("Size of: ", stringify!(Attr))
                );
                assert_eq!(
                    ::std::mem::align_of::<Attr>(),
                    8usize,
                    concat!("Alignment of ", stringify!(Attr))
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<Attr>())).mRefCnt as *const _ as usize },
                    96usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Attr),
                        "::",
                        stringify!(mRefCnt)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<Attr>())).mAttrMap as *const _ as usize },
                    104usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Attr),
                        "::",
                        stringify!(mAttrMap)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<Attr>())).mValue as *const _ as usize },
                    112usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Attr),
                        "::",
                        stringify!(mValue)
                    )
                );
            }
            #[repr(C)]
            #[repr(align(8))]
            #[derive(Debug, Copy, Clone)]
            pub struct FrameRequestCallback {
                pub _bindgen_opaque_blob: [u64; 7usize],
            }
            #[test]
            fn bindgen_test_layout_FrameRequestCallback() {
                assert_eq!(
                    ::std::mem::size_of::<FrameRequestCallback>(),
                    56usize,
                    concat!("Size of: ", stringify!(FrameRequestCallback))
                );
                assert_eq!(
                    ::std::mem::align_of::<FrameRequestCallback>(),
                    8usize,
                    concat!("Alignment of ", stringify!(FrameRequestCallback))
                );
            }
            #[repr(C)]
            pub struct Touch {
                pub _base: root::nsISupports,
                pub _base_1: root::nsWrapperCache,
                pub _base_2: root::mozilla::WidgetPointerHelper,
                pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
                pub mOriginalTarget: root::nsCOMPtr,
                pub mTarget: root::nsCOMPtr,
                pub mRefPoint: root::mozilla::LayoutDeviceIntPoint,
                pub mChanged: bool,
                pub mIsTouchEventSuppressed: bool,
                pub mMessage: u32,
                pub mIdentifier: i32,
                pub mPagePoint: root::mozilla::CSSIntPoint,
                pub mClientPoint: root::mozilla::CSSIntPoint,
                pub mScreenPoint: root::mozilla::CSSIntPoint,
                pub mRadius: root::mozilla::LayoutDeviceIntPoint,
                pub mRotationAngle: f32,
                pub mForce: f32,
                pub mPointsInitialized: bool,
            }
            pub type Touch_HasThreadSafeRefCnt = root::mozilla::FalseType;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Touch_cycleCollection {
                pub _base: root::nsXPCOMCycleCollectionParticipant,
            }
            #[test]
            fn bindgen_test_layout_Touch_cycleCollection() {
                assert_eq!(
                    ::std::mem::size_of::<Touch_cycleCollection>(),
                    16usize,
                    concat!("Size of: ", stringify!(Touch_cycleCollection))
                );
                assert_eq!(
                    ::std::mem::align_of::<Touch_cycleCollection>(),
                    8usize,
                    concat!("Alignment of ", stringify!(Touch_cycleCollection))
                );
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom5Touch21_cycleCollectorGlobalE"]
                pub static mut Touch__cycleCollectorGlobal:
                    root::mozilla::dom::Touch_cycleCollection;
            }
            #[test]
            fn bindgen_test_layout_Touch() {
                assert_eq!(
                    ::std::mem::size_of::<Touch>(),
                    152usize,
                    concat!("Size of: ", stringify!(Touch))
                );
                assert_eq!(
                    ::std::mem::align_of::<Touch>(),
                    8usize,
                    concat!("Alignment of ", stringify!(Touch))
                );
            }
            #[repr(C)]
            pub struct CallbackInterface {
                pub _base: root::mozilla::dom::CallbackObject,
            }
            #[test]
            fn bindgen_test_layout_CallbackInterface() {
                assert_eq!(
                    ::std::mem::size_of::<CallbackInterface>(),
                    56usize,
                    concat!("Size of: ", stringify!(CallbackInterface))
                );
                assert_eq!(
                    ::std::mem::align_of::<CallbackInterface>(),
                    8usize,
                    concat!("Alignment of ", stringify!(CallbackInterface))
                );
            }
            #[repr(C)]
            pub struct EventListener {
                pub _base: root::mozilla::dom::CallbackInterface,
            }
            #[test]
            fn bindgen_test_layout_EventListener() {
                assert_eq!(
                    ::std::mem::size_of::<EventListener>(),
                    56usize,
                    concat!("Size of: ", stringify!(EventListener))
                );
                assert_eq!(
                    ::std::mem::align_of::<EventListener>(),
                    8usize,
                    concat!("Alignment of ", stringify!(EventListener))
                );
            }
            #[repr(C)]
            pub struct VisualViewport {
                pub _base: root::mozilla::DOMEventTargetHelper,
                pub mResizeEvent:
                    root::RefPtr<root::mozilla::dom::VisualViewport_VisualViewportResizeEvent>,
                pub mScrollEvent:
                    root::RefPtr<root::mozilla::dom::VisualViewport_VisualViewportScrollEvent>,
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct VisualViewport_VisualViewportResizeEvent {
                pub _base: root::mozilla::Runnable,
                pub mViewport: *mut root::mozilla::dom::VisualViewport,
                pub mPresContext: u64,
            }
            #[test]
            fn bindgen_test_layout_VisualViewport_VisualViewportResizeEvent() {
                assert_eq!(
                    ::std::mem::size_of::<VisualViewport_VisualViewportResizeEvent>(),
                    32usize,
                    concat!(
                        "Size of: ",
                        stringify!(VisualViewport_VisualViewportResizeEvent)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<VisualViewport_VisualViewportResizeEvent>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(VisualViewport_VisualViewportResizeEvent)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<VisualViewport_VisualViewportResizeEvent>()))
                            .mViewport as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(VisualViewport_VisualViewportResizeEvent),
                        "::",
                        stringify!(mViewport)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<VisualViewport_VisualViewportResizeEvent>()))
                            .mPresContext as *const _ as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(VisualViewport_VisualViewportResizeEvent),
                        "::",
                        stringify!(mPresContext)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct VisualViewport_VisualViewportScrollEvent {
                pub _base: root::mozilla::Runnable,
                pub mViewport: *mut root::mozilla::dom::VisualViewport,
                pub mPresContext: u64,
                pub mPrevVisualOffset: root::nsPoint,
                pub mPrevLayoutOffset: root::nsPoint,
            }
            #[test]
            fn bindgen_test_layout_VisualViewport_VisualViewportScrollEvent() {
                assert_eq!(
                    ::std::mem::size_of::<VisualViewport_VisualViewportScrollEvent>(),
                    48usize,
                    concat!(
                        "Size of: ",
                        stringify!(VisualViewport_VisualViewportScrollEvent)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<VisualViewport_VisualViewportScrollEvent>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(VisualViewport_VisualViewportScrollEvent)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<VisualViewport_VisualViewportScrollEvent>()))
                            .mViewport as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(VisualViewport_VisualViewportScrollEvent),
                        "::",
                        stringify!(mViewport)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<VisualViewport_VisualViewportScrollEvent>()))
                            .mPresContext as *const _ as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(VisualViewport_VisualViewportScrollEvent),
                        "::",
                        stringify!(mPresContext)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<VisualViewport_VisualViewportScrollEvent>()))
                            .mPrevVisualOffset as *const _ as usize
                    },
                    32usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(VisualViewport_VisualViewportScrollEvent),
                        "::",
                        stringify!(mPrevVisualOffset)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<VisualViewport_VisualViewportScrollEvent>()))
                            .mPrevLayoutOffset as *const _ as usize
                    },
                    40usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(VisualViewport_VisualViewportScrollEvent),
                        "::",
                        stringify!(mPrevLayoutOffset)
                    )
                );
            }
            #[test]
            fn bindgen_test_layout_VisualViewport() {
                assert_eq!(
                    ::std::mem::size_of::<VisualViewport>(),
                    136usize,
                    concat!("Size of: ", stringify!(VisualViewport))
                );
                assert_eq!(
                    ::std::mem::align_of::<VisualViewport>(),
                    8usize,
                    concat!("Alignment of ", stringify!(VisualViewport))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<VisualViewport>())).mResizeEvent as *const _ as usize
                    },
                    120usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(VisualViewport),
                        "::",
                        stringify!(mResizeEvent)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<VisualViewport>())).mScrollEvent as *const _ as usize
                    },
                    128usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(VisualViewport),
                        "::",
                        stringify!(mScrollEvent)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct XBLChildrenElement {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct CustomElementData {
                _unused: [u8; 0],
            }
            #[repr(C)]
            pub struct FragmentOrElement {
                pub _base: root::nsIContent,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct FragmentOrElement_cycleCollection {
                pub _base: root::nsIContent_cycleCollection,
            }
            #[test]
            fn bindgen_test_layout_FragmentOrElement_cycleCollection() {
                assert_eq!(
                    ::std::mem::size_of::<FragmentOrElement_cycleCollection>(),
                    16usize,
                    concat!("Size of: ", stringify!(FragmentOrElement_cycleCollection))
                );
                assert_eq!(
                    ::std::mem::align_of::<FragmentOrElement_cycleCollection>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(FragmentOrElement_cycleCollection)
                    )
                );
            }
            #[doc = " There are a set of DOM- and scripting-specific instance variables"]
            #[doc = " that may only be instantiated when a content object is accessed"]
            #[doc = " through the DOM. Rather than burn actual slots in the content"]
            #[doc = " objects for each of these instance variables, we put them off"]
            #[doc = " in a side structure that\'s only allocated when the content is"]
            #[doc = " accessed through the DOM."]
            #[repr(C)]
            pub struct FragmentOrElement_nsExtendedDOMSlots {
                pub _base: root::nsIContent_nsExtendedContentSlots,
                #[doc = " SMIL Overridde style rules (for SMIL animation of CSS properties)"]
                #[doc = " @see Element::GetSMILOverrideStyle"]
                pub mSMILOverrideStyle: root::RefPtr<root::nsDOMCSSAttributeDeclaration>,
                #[doc = " Holds any SMIL override style declaration for this element."]
                pub mSMILOverrideStyleDeclaration: root::RefPtr<root::mozilla::DeclarationBlock>,
                #[doc = " The controllers of the XUL Element."]
                pub mControllers: root::nsCOMPtr,
                #[doc = " An object implementing the .labels property for this element."]
                pub mLabelsList: root::RefPtr<root::nsLabelsNodeList>,
                #[doc = " ShadowRoot bound to the element."]
                pub mShadowRoot: root::RefPtr<root::mozilla::dom::ShadowRoot>,
                #[doc = " XBL binding installed on the element."]
                pub mXBLBinding: root::RefPtr<root::nsXBLBinding>,
                #[doc = " Web components custom element data."]
                pub mCustomElementData: root::RefPtr<root::mozilla::dom::CustomElementData>,
            }
            #[test]
            fn bindgen_test_layout_FragmentOrElement_nsExtendedDOMSlots() {
                assert_eq!(
                    ::std::mem::size_of::<FragmentOrElement_nsExtendedDOMSlots>(),
                    96usize,
                    concat!(
                        "Size of: ",
                        stringify!(FragmentOrElement_nsExtendedDOMSlots)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<FragmentOrElement_nsExtendedDOMSlots>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(FragmentOrElement_nsExtendedDOMSlots)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FragmentOrElement_nsExtendedDOMSlots>()))
                            .mSMILOverrideStyle as *const _ as usize
                    },
                    40usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FragmentOrElement_nsExtendedDOMSlots),
                        "::",
                        stringify!(mSMILOverrideStyle)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FragmentOrElement_nsExtendedDOMSlots>()))
                            .mSMILOverrideStyleDeclaration as *const _
                            as usize
                    },
                    48usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FragmentOrElement_nsExtendedDOMSlots),
                        "::",
                        stringify!(mSMILOverrideStyleDeclaration)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FragmentOrElement_nsExtendedDOMSlots>()))
                            .mControllers as *const _ as usize
                    },
                    56usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FragmentOrElement_nsExtendedDOMSlots),
                        "::",
                        stringify!(mControllers)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FragmentOrElement_nsExtendedDOMSlots>())).mLabelsList
                            as *const _ as usize
                    },
                    64usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FragmentOrElement_nsExtendedDOMSlots),
                        "::",
                        stringify!(mLabelsList)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FragmentOrElement_nsExtendedDOMSlots>())).mShadowRoot
                            as *const _ as usize
                    },
                    72usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FragmentOrElement_nsExtendedDOMSlots),
                        "::",
                        stringify!(mShadowRoot)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FragmentOrElement_nsExtendedDOMSlots>())).mXBLBinding
                            as *const _ as usize
                    },
                    80usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FragmentOrElement_nsExtendedDOMSlots),
                        "::",
                        stringify!(mXBLBinding)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FragmentOrElement_nsExtendedDOMSlots>()))
                            .mCustomElementData as *const _ as usize
                    },
                    88usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FragmentOrElement_nsExtendedDOMSlots),
                        "::",
                        stringify!(mCustomElementData)
                    )
                );
            }
            #[repr(C)]
            pub struct FragmentOrElement_nsDOMSlots {
                pub _base: root::nsIContent_nsContentSlots,
                #[doc = " The .style attribute (an interface that forwards to the actual"]
                #[doc = " style rules)"]
                #[doc = " @see nsGenericHTMLElement::GetStyle"]
                pub mStyle: root::nsCOMPtr,
                #[doc = " The .dataset attribute."]
                #[doc = " @see nsGenericHTMLElement::GetDataset"]
                pub mDataset: *mut root::nsDOMStringMap,
                #[doc = " @see Element::Attributes"]
                pub mAttributeMap: root::RefPtr<root::nsDOMAttributeMap>,
                #[doc = " An object implementing the .children property for this element."]
                pub mChildrenList: root::RefPtr<root::nsContentList>,
                #[doc = " An object implementing the .classList property for this element."]
                pub mClassList: root::RefPtr<root::nsDOMTokenList>,
            }
            #[test]
            fn bindgen_test_layout_FragmentOrElement_nsDOMSlots() {
                assert_eq!(
                    ::std::mem::size_of::<FragmentOrElement_nsDOMSlots>(),
                    112usize,
                    concat!("Size of: ", stringify!(FragmentOrElement_nsDOMSlots))
                );
                assert_eq!(
                    ::std::mem::align_of::<FragmentOrElement_nsDOMSlots>(),
                    8usize,
                    concat!("Alignment of ", stringify!(FragmentOrElement_nsDOMSlots))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FragmentOrElement_nsDOMSlots>())).mStyle as *const _
                            as usize
                    },
                    72usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FragmentOrElement_nsDOMSlots),
                        "::",
                        stringify!(mStyle)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FragmentOrElement_nsDOMSlots>())).mDataset
                            as *const _ as usize
                    },
                    80usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FragmentOrElement_nsDOMSlots),
                        "::",
                        stringify!(mDataset)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FragmentOrElement_nsDOMSlots>())).mAttributeMap
                            as *const _ as usize
                    },
                    88usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FragmentOrElement_nsDOMSlots),
                        "::",
                        stringify!(mAttributeMap)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FragmentOrElement_nsDOMSlots>())).mChildrenList
                            as *const _ as usize
                    },
                    96usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FragmentOrElement_nsDOMSlots),
                        "::",
                        stringify!(mChildrenList)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FragmentOrElement_nsDOMSlots>())).mClassList
                            as *const _ as usize
                    },
                    104usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FragmentOrElement_nsDOMSlots),
                        "::",
                        stringify!(mClassList)
                    )
                );
            }
            #[doc = " In case ExtendedDOMSlots is needed before normal DOMSlots, an instance of"]
            #[doc = " FatSlots class, which combines those two slot types, is created."]
            #[doc = " This way we can avoid extra allocation for ExtendedDOMSlots."]
            #[doc = " FatSlots is useful for example when creating Custom Elements."]
            #[repr(C)]
            pub struct FragmentOrElement_FatSlots {
                pub _base: root::mozilla::dom::FragmentOrElement_nsDOMSlots,
                pub _base_1: root::mozilla::dom::FragmentOrElement_nsExtendedDOMSlots,
            }
            #[test]
            fn bindgen_test_layout_FragmentOrElement_FatSlots() {
                assert_eq!(
                    ::std::mem::size_of::<FragmentOrElement_FatSlots>(),
                    208usize,
                    concat!("Size of: ", stringify!(FragmentOrElement_FatSlots))
                );
                assert_eq!(
                    ::std::mem::align_of::<FragmentOrElement_FatSlots>(),
                    8usize,
                    concat!("Alignment of ", stringify!(FragmentOrElement_FatSlots))
                );
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom17FragmentOrElement21_cycleCollectorGlobalE"]
                pub static mut FragmentOrElement__cycleCollectorGlobal:
                    root::mozilla::dom::FragmentOrElement_cycleCollection;
            }
            #[test]
            fn bindgen_test_layout_FragmentOrElement() {
                assert_eq!(
                    ::std::mem::size_of::<FragmentOrElement>(),
                    104usize,
                    concat!("Size of: ", stringify!(FragmentOrElement))
                );
                assert_eq!(
                    ::std::mem::align_of::<FragmentOrElement>(),
                    8usize,
                    concat!("Alignment of ", stringify!(FragmentOrElement))
                );
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct DOMRectReadOnly {
                pub _base: root::nsISupports,
                pub _base_1: root::nsWrapperCache,
                pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
                pub mParent: root::nsCOMPtr,
                pub mX: f64,
                pub mY: f64,
                pub mWidth: f64,
                pub mHeight: f64,
            }
            pub type DOMRectReadOnly_HasThreadSafeRefCnt = root::mozilla::FalseType;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct DOMRectReadOnly_cycleCollection {
                pub _base: root::nsXPCOMCycleCollectionParticipant,
            }
            #[test]
            fn bindgen_test_layout_DOMRectReadOnly_cycleCollection() {
                assert_eq!(
                    ::std::mem::size_of::<DOMRectReadOnly_cycleCollection>(),
                    16usize,
                    concat!("Size of: ", stringify!(DOMRectReadOnly_cycleCollection))
                );
                assert_eq!(
                    ::std::mem::align_of::<DOMRectReadOnly_cycleCollection>(),
                    8usize,
                    concat!("Alignment of ", stringify!(DOMRectReadOnly_cycleCollection))
                );
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom15DOMRectReadOnly21_cycleCollectorGlobalE"]
                pub static mut DOMRectReadOnly__cycleCollectorGlobal:
                    root::mozilla::dom::DOMRectReadOnly_cycleCollection;
            }
            #[test]
            fn bindgen_test_layout_DOMRectReadOnly() {
                assert_eq!(
                    ::std::mem::size_of::<DOMRectReadOnly>(),
                    80usize,
                    concat!("Size of: ", stringify!(DOMRectReadOnly))
                );
                assert_eq!(
                    ::std::mem::align_of::<DOMRectReadOnly>(),
                    8usize,
                    concat!("Alignment of ", stringify!(DOMRectReadOnly))
                );
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct DOMRect {
                pub _base: root::mozilla::dom::DOMRectReadOnly,
            }
            #[test]
            fn bindgen_test_layout_DOMRect() {
                assert_eq!(
                    ::std::mem::size_of::<DOMRect>(),
                    80usize,
                    concat!("Size of: ", stringify!(DOMRect))
                );
                assert_eq!(
                    ::std::mem::align_of::<DOMRect>(),
                    8usize,
                    concat!("Alignment of ", stringify!(DOMRect))
                );
            }
            pub const ShadowRootMode_Open: root::mozilla::dom::ShadowRootMode = 0;
            pub const ShadowRootMode_Closed: root::mozilla::dom::ShadowRootMode = 1;
            pub const ShadowRootMode_EndGuard_: root::mozilla::dom::ShadowRootMode = 2;
            pub type ShadowRootMode = u8;
            #[repr(C)]
            pub struct Element {
                pub _base: root::mozilla::dom::FragmentOrElement,
                pub mState: root::mozilla::EventStates,
                pub mServoData: ::gecko_bindings::structs::RustCell<*mut ::gecko_bindings::structs::ServoNodeData>,
                pub mAttrs: root::AttrArray,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Element_COMTypeInfo {
                pub _address: u8,
            }
            #[doc = " StyleStateLocks is used to specify which event states should be locked,"]
            #[doc = " and whether they should be locked to on or off."]
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Element_StyleStateLocks {
                pub mLocks: root::mozilla::EventStates,
                pub mValues: root::mozilla::EventStates,
            }
            #[test]
            fn bindgen_test_layout_Element_StyleStateLocks() {
                assert_eq!(
                    ::std::mem::size_of::<Element_StyleStateLocks>(),
                    16usize,
                    concat!("Size of: ", stringify!(Element_StyleStateLocks))
                );
                assert_eq!(
                    ::std::mem::align_of::<Element_StyleStateLocks>(),
                    8usize,
                    concat!("Alignment of ", stringify!(Element_StyleStateLocks))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<Element_StyleStateLocks>())).mLocks as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Element_StyleStateLocks),
                        "::",
                        stringify!(mLocks)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<Element_StyleStateLocks>())).mValues as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Element_StyleStateLocks),
                        "::",
                        stringify!(mValues)
                    )
                );
            }
            pub const Element_ATTR_MISSING: root::mozilla::dom::Element__bindgen_ty_1 = -1;
            pub const Element_ATTR_VALUE_NO_MATCH: root::mozilla::dom::Element__bindgen_ty_1 = -2;
            pub type Element__bindgen_ty_1 = i32;
            #[doc = " Check whether this Element\'s given attribute has one of a given list of"]
            #[doc = " values. If there is a match, we return the index in the list of the first"]
            #[doc = " matching value. If there was no attribute at all, then we return"]
            #[doc = " ATTR_MISSING. If there was an attribute but it didn\'t match, we return"]
            #[doc = " ATTR_VALUE_NO_MATCH. A non-negative result always indicates a match."]
            #[doc = ""]
            #[doc = " @param aNameSpaceID The namespace ID of the attribute.  Must not"]
            #[doc = "                     be kNameSpaceID_Unknown."]
            #[doc = " @param aName The name atom of the attribute.  Must not be null."]
            #[doc = " @param aValues a nullptr-terminated array of pointers to atom values to"]
            #[doc = " test against."]
            #[doc = " @param aCaseSensitive Whether to do a case-sensitive compare on the values."]
            #[doc = " @return ATTR_MISSING, ATTR_VALUE_NO_MATCH or the non-negative index"]
            #[doc = " indicating the first value of aValues that matched"]
            pub type Element_AttrValuesArray = *mut root::nsStaticAtom;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Element_MappedAttributeEntry {
                pub attribute: *const root::nsStaticAtom,
            }
            #[test]
            fn bindgen_test_layout_Element_MappedAttributeEntry() {
                assert_eq!(
                    ::std::mem::size_of::<Element_MappedAttributeEntry>(),
                    8usize,
                    concat!("Size of: ", stringify!(Element_MappedAttributeEntry))
                );
                assert_eq!(
                    ::std::mem::align_of::<Element_MappedAttributeEntry>(),
                    8usize,
                    concat!("Alignment of ", stringify!(Element_MappedAttributeEntry))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<Element_MappedAttributeEntry>())).attribute
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Element_MappedAttributeEntry),
                        "::",
                        stringify!(attribute)
                    )
                );
            }
            pub const Element_UnattachShadowRoot_No:
                root::mozilla::dom::Element_UnattachShadowRoot = 0;
            pub const Element_UnattachShadowRoot_Yes:
                root::mozilla::dom::Element_UnattachShadowRoot = 1;
            pub type Element_UnattachShadowRoot = i32;
            pub const Element_kAllServoDescendantBits: u32 = 3178496;
            pub const Element_kFireMutationEvent: bool = true;
            pub const Element_kDontFireMutationEvent: bool = false;
            pub const Element_kNotifyDocumentObservers: bool = true;
            pub const Element_kDontNotifyDocumentObservers: bool = false;
            pub const Element_kCallAfterSetAttr: bool = true;
            pub const Element_kDontCallAfterSetAttr: bool = false;
            #[test]
            fn bindgen_test_layout_Element() {
                assert_eq!(
                    ::std::mem::size_of::<Element>(),
                    128usize,
                    concat!("Size of: ", stringify!(Element))
                );
                assert_eq!(
                    ::std::mem::align_of::<Element>(),
                    8usize,
                    concat!("Alignment of ", stringify!(Element))
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<Element>())).mState as *const _ as usize },
                    104usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Element),
                        "::",
                        stringify!(mState)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<Element>())).mServoData as *const _ as usize },
                    112usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Element),
                        "::",
                        stringify!(mServoData)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<Element>())).mAttrs as *const _ as usize },
                    120usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Element),
                        "::",
                        stringify!(mAttrs)
                    )
                );
            }
            #[repr(C)]
            pub struct HTMLSlotElement {
                pub _base: root::nsGenericHTMLElement,
                pub mAssignedNodes: root::nsTArray<root::RefPtr<root::nsINode>>,
                pub mInSignalSlotList: bool,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct HTMLSlotElement_cycleCollection {
                pub _base: root::mozilla::dom::FragmentOrElement_cycleCollection,
            }
            #[test]
            fn bindgen_test_layout_HTMLSlotElement_cycleCollection() {
                assert_eq!(
                    ::std::mem::size_of::<HTMLSlotElement_cycleCollection>(),
                    16usize,
                    concat!("Size of: ", stringify!(HTMLSlotElement_cycleCollection))
                );
                assert_eq!(
                    ::std::mem::align_of::<HTMLSlotElement_cycleCollection>(),
                    8usize,
                    concat!("Alignment of ", stringify!(HTMLSlotElement_cycleCollection))
                );
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom15HTMLSlotElement21_cycleCollectorGlobalE"]
                pub static mut HTMLSlotElement__cycleCollectorGlobal:
                    root::mozilla::dom::HTMLSlotElement_cycleCollection;
            }
            #[test]
            fn bindgen_test_layout_HTMLSlotElement() {
                assert_eq!(
                    ::std::mem::size_of::<HTMLSlotElement>(),
                    144usize,
                    concat!("Size of: ", stringify!(HTMLSlotElement))
                );
                assert_eq!(
                    ::std::mem::align_of::<HTMLSlotElement>(),
                    8usize,
                    concat!("Alignment of ", stringify!(HTMLSlotElement))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<HTMLSlotElement>())).mAssignedNodes as *const _
                            as usize
                    },
                    128usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(HTMLSlotElement),
                        "::",
                        stringify!(mAssignedNodes)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<HTMLSlotElement>())).mInSignalSlotList as *const _
                            as usize
                    },
                    136usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(HTMLSlotElement),
                        "::",
                        stringify!(mInSignalSlotList)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct OwningNodeOrString {
                pub mType: root::mozilla::dom::OwningNodeOrString_Type,
                pub mValue: root::mozilla::dom::OwningNodeOrString_Value,
            }
            pub const OwningNodeOrString_Type_eUninitialized:
                root::mozilla::dom::OwningNodeOrString_Type = 0;
            pub const OwningNodeOrString_Type_eNode: root::mozilla::dom::OwningNodeOrString_Type =
                1;
            pub const OwningNodeOrString_Type_eString: root::mozilla::dom::OwningNodeOrString_Type =
                2;
            pub type OwningNodeOrString_Type = u32;
            #[repr(C)]
            #[repr(align(8))]
            #[derive(Debug, Copy, Clone)]
            pub struct OwningNodeOrString_Value {
                pub _bindgen_opaque_blob: [u64; 2usize],
            }
            #[test]
            fn bindgen_test_layout_OwningNodeOrString_Value() {
                assert_eq!(
                    ::std::mem::size_of::<OwningNodeOrString_Value>(),
                    16usize,
                    concat!("Size of: ", stringify!(OwningNodeOrString_Value))
                );
                assert_eq!(
                    ::std::mem::align_of::<OwningNodeOrString_Value>(),
                    8usize,
                    concat!("Alignment of ", stringify!(OwningNodeOrString_Value))
                );
            }
            #[test]
            fn bindgen_test_layout_OwningNodeOrString() {
                assert_eq!(
                    ::std::mem::size_of::<OwningNodeOrString>(),
                    24usize,
                    concat!("Size of: ", stringify!(OwningNodeOrString))
                );
                assert_eq!(
                    ::std::mem::align_of::<OwningNodeOrString>(),
                    8usize,
                    concat!("Alignment of ", stringify!(OwningNodeOrString))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<OwningNodeOrString>())).mType as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(OwningNodeOrString),
                        "::",
                        stringify!(mType)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<OwningNodeOrString>())).mValue as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(OwningNodeOrString),
                        "::",
                        stringify!(mValue)
                    )
                );
            }
            #[repr(u8)]
            #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
            pub enum CompositeOperation {
                Replace = 0,
                Add = 1,
                Accumulate = 2,
                EndGuard_ = 3,
            }
            pub const CompositeOperationOrAuto_Replace:
                root::mozilla::dom::CompositeOperationOrAuto = 0;
            pub const CompositeOperationOrAuto_Add: root::mozilla::dom::CompositeOperationOrAuto =
                1;
            pub const CompositeOperationOrAuto_Accumulate:
                root::mozilla::dom::CompositeOperationOrAuto = 2;
            pub const CompositeOperationOrAuto_Auto: root::mozilla::dom::CompositeOperationOrAuto =
                3;
            pub const CompositeOperationOrAuto_EndGuard_:
                root::mozilla::dom::CompositeOperationOrAuto = 4;
            pub type CompositeOperationOrAuto = u8;
            #[repr(u8)]
            #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
            pub enum IterationCompositeOperation {
                Replace = 0,
                Accumulate = 1,
                EndGuard_ = 2,
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct MediaList {
                pub _base: root::nsISupports,
                pub _base_1: root::nsWrapperCache,
                pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
                pub mStyleSheet: *mut root::mozilla::StyleSheet,
                pub mRawList: root::RefPtr<root::RawServoMediaList>,
            }
            pub type MediaList_HasThreadSafeRefCnt = root::mozilla::FalseType;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct MediaList_cycleCollection {
                pub _base: root::nsXPCOMCycleCollectionParticipant,
            }
            #[test]
            fn bindgen_test_layout_MediaList_cycleCollection() {
                assert_eq!(
                    ::std::mem::size_of::<MediaList_cycleCollection>(),
                    16usize,
                    concat!("Size of: ", stringify!(MediaList_cycleCollection))
                );
                assert_eq!(
                    ::std::mem::align_of::<MediaList_cycleCollection>(),
                    8usize,
                    concat!("Alignment of ", stringify!(MediaList_cycleCollection))
                );
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom9MediaList21_cycleCollectorGlobalE"]
                pub static mut MediaList__cycleCollectorGlobal:
                    root::mozilla::dom::MediaList_cycleCollection;
            }
            #[test]
            fn bindgen_test_layout_MediaList() {
                assert_eq!(
                    ::std::mem::size_of::<MediaList>(),
                    56usize,
                    concat!("Size of: ", stringify!(MediaList))
                );
                assert_eq!(
                    ::std::mem::align_of::<MediaList>(),
                    8usize,
                    concat!("Alignment of ", stringify!(MediaList))
                );
            }
            #[repr(C)]
            pub struct DocumentFragment {
                pub _base: root::mozilla::dom::FragmentOrElement,
                pub mHost: root::RefPtr<root::mozilla::dom::Element>,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct DocumentFragment_cycleCollection {
                pub _base: root::mozilla::dom::FragmentOrElement_cycleCollection,
            }
            #[test]
            fn bindgen_test_layout_DocumentFragment_cycleCollection() {
                assert_eq!(
                    ::std::mem::size_of::<DocumentFragment_cycleCollection>(),
                    16usize,
                    concat!("Size of: ", stringify!(DocumentFragment_cycleCollection))
                );
                assert_eq!(
                    ::std::mem::align_of::<DocumentFragment_cycleCollection>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(DocumentFragment_cycleCollection)
                    )
                );
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom16DocumentFragment21_cycleCollectorGlobalE"]
                pub static mut DocumentFragment__cycleCollectorGlobal:
                    root::mozilla::dom::DocumentFragment_cycleCollection;
            }
            #[test]
            fn bindgen_test_layout_DocumentFragment() {
                assert_eq!(
                    ::std::mem::size_of::<DocumentFragment>(),
                    112usize,
                    concat!("Size of: ", stringify!(DocumentFragment))
                );
                assert_eq!(
                    ::std::mem::align_of::<DocumentFragment>(),
                    8usize,
                    concat!("Alignment of ", stringify!(DocumentFragment))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<DocumentFragment>())).mHost as *const _ as usize
                    },
                    104usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(DocumentFragment),
                        "::",
                        stringify!(mHost)
                    )
                );
            }
            #[repr(C)]
            pub struct ShadowRoot {
                pub _base: root::mozilla::dom::DocumentFragment,
                pub _base_1: root::mozilla::dom::DocumentOrShadowRoot,
                pub _base_2: root::nsStubMutationObserver,
                pub _base_3: root::nsIRadioGroupContainer,
                pub mMode: root::mozilla::dom::ShadowRootMode,
                pub mServoStyles: root::mozilla::UniquePtr<root::RawServoAuthorStyles>,
                pub mStyleRuleMap: root::mozilla::UniquePtr<root::mozilla::ServoStyleRuleMap>,
                pub mSlotMap: [u64; 4usize],
                pub mIsUAWidget: bool,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ShadowRoot_cycleCollection {
                pub _base: root::mozilla::dom::DocumentFragment_cycleCollection,
            }
            #[test]
            fn bindgen_test_layout_ShadowRoot_cycleCollection() {
                assert_eq!(
                    ::std::mem::size_of::<ShadowRoot_cycleCollection>(),
                    16usize,
                    concat!("Size of: ", stringify!(ShadowRoot_cycleCollection))
                );
                assert_eq!(
                    ::std::mem::align_of::<ShadowRoot_cycleCollection>(),
                    8usize,
                    concat!("Alignment of ", stringify!(ShadowRoot_cycleCollection))
                );
            }
            #[doc = " Represents the insertion point in a slot for a given node."]
            #[repr(C)]
            #[derive(Debug)]
            pub struct ShadowRoot_SlotAssignment {
                pub mSlot: *mut root::mozilla::dom::HTMLSlotElement,
                pub mIndex: [u32; 2usize],
            }
            #[test]
            fn bindgen_test_layout_ShadowRoot_SlotAssignment() {
                assert_eq!(
                    ::std::mem::size_of::<ShadowRoot_SlotAssignment>(),
                    16usize,
                    concat!("Size of: ", stringify!(ShadowRoot_SlotAssignment))
                );
                assert_eq!(
                    ::std::mem::align_of::<ShadowRoot_SlotAssignment>(),
                    8usize,
                    concat!("Alignment of ", stringify!(ShadowRoot_SlotAssignment))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ShadowRoot_SlotAssignment>())).mSlot as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ShadowRoot_SlotAssignment),
                        "::",
                        stringify!(mSlot)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ShadowRoot_SlotAssignment>())).mIndex as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ShadowRoot_SlotAssignment),
                        "::",
                        stringify!(mIndex)
                    )
                );
            }
            pub type ShadowRoot_SlotArray = root::mozilla::dom::TreeOrderedArray;
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom10ShadowRoot21_cycleCollectorGlobalE"]
                pub static mut ShadowRoot__cycleCollectorGlobal:
                    root::mozilla::dom::ShadowRoot_cycleCollection;
            }
            #[test]
            fn bindgen_test_layout_ShadowRoot() {
                assert_eq!(
                    ::std::mem::size_of::<ShadowRoot>(),
                    296usize,
                    concat!("Size of: ", stringify!(ShadowRoot))
                );
                assert_eq!(
                    ::std::mem::align_of::<ShadowRoot>(),
                    8usize,
                    concat!("Alignment of ", stringify!(ShadowRoot))
                );
            }
            #[repr(C)]
            pub struct SVGAnimatedClass {
                pub mAnimVal: root::nsAutoPtr<::gecko_bindings::structs::nsString>,
            }
            pub type SVGAnimatedClass_SVGElement = root::mozilla::dom::SVGElement;
            #[repr(C)]
            #[derive(Debug)]
            pub struct SVGAnimatedClass_SMILString {
                pub _base: root::mozilla::SMILAttr,
                pub mVal: *mut root::mozilla::dom::SVGAnimatedClass,
                pub mSVGElement: *mut root::mozilla::dom::SVGAnimatedClass_SVGElement,
            }
            #[test]
            fn bindgen_test_layout_SVGAnimatedClass_SMILString() {
                assert_eq!(
                    ::std::mem::size_of::<SVGAnimatedClass_SMILString>(),
                    24usize,
                    concat!("Size of: ", stringify!(SVGAnimatedClass_SMILString))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGAnimatedClass_SMILString>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SVGAnimatedClass_SMILString))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGAnimatedClass_SMILString>())).mVal as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGAnimatedClass_SMILString),
                        "::",
                        stringify!(mVal)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGAnimatedClass_SMILString>())).mSVGElement
                            as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGAnimatedClass_SMILString),
                        "::",
                        stringify!(mSVGElement)
                    )
                );
            }
            #[test]
            fn bindgen_test_layout_SVGAnimatedClass() {
                assert_eq!(
                    ::std::mem::size_of::<SVGAnimatedClass>(),
                    8usize,
                    concat!("Size of: ", stringify!(SVGAnimatedClass))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGAnimatedClass>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SVGAnimatedClass))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGAnimatedClass>())).mAnimVal as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGAnimatedClass),
                        "::",
                        stringify!(mAnimVal)
                    )
                );
            }
            pub type SVGElementBase = root::nsStyledElement;
            #[repr(C)]
            pub struct SVGElement {
                pub _base: root::mozilla::dom::SVGElementBase,
                pub mClassAttribute: root::mozilla::dom::SVGAnimatedClass,
                pub mClassAnimAttr: root::nsAutoPtr<root::nsAttrValue>,
                pub mContentDeclarationBlock: root::RefPtr<root::mozilla::DeclarationBlock>,
            }
            #[doc = " Flag to indicate to GetAnimatedXxx() methods that the object being"]
            #[doc = " requested should be allocated if it hasn\'t already been allocated, and"]
            #[doc = " that the method should not return null. Only applicable to methods that"]
            #[doc = " need to allocate the object that they return."]
            pub const SVGElement_DO_ALLOCATE: root::mozilla::dom::SVGElement__bindgen_ty_1 = 1;
            pub type SVGElement__bindgen_ty_1 = u32;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_LengthInfo {
                pub mName: *mut root::nsStaticAtom,
                pub mDefaultValue: f32,
                pub mDefaultUnitType: u8,
                pub mCtxType: u8,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_LengthInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_LengthInfo>(),
                    16usize,
                    concat!("Size of: ", stringify!(SVGElement_LengthInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_LengthInfo>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SVGElement_LengthInfo))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_LengthInfo>())).mName as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_LengthInfo),
                        "::",
                        stringify!(mName)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_LengthInfo>())).mDefaultValue as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_LengthInfo),
                        "::",
                        stringify!(mDefaultValue)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_LengthInfo>())).mDefaultUnitType
                            as *const _ as usize
                    },
                    12usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_LengthInfo),
                        "::",
                        stringify!(mDefaultUnitType)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_LengthInfo>())).mCtxType as *const _
                            as usize
                    },
                    13usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_LengthInfo),
                        "::",
                        stringify!(mCtxType)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_LengthAttributesInfo {
                pub mLengths: *mut root::mozilla::SVGAnimatedLength,
                pub mLengthInfo: *const root::mozilla::dom::SVGElement_LengthInfo,
                pub mLengthCount: u32,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_LengthAttributesInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_LengthAttributesInfo>(),
                    24usize,
                    concat!("Size of: ", stringify!(SVGElement_LengthAttributesInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_LengthAttributesInfo>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SVGElement_LengthAttributesInfo))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_LengthAttributesInfo>())).mLengths
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_LengthAttributesInfo),
                        "::",
                        stringify!(mLengths)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_LengthAttributesInfo>())).mLengthInfo
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_LengthAttributesInfo),
                        "::",
                        stringify!(mLengthInfo)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_LengthAttributesInfo>())).mLengthCount
                            as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_LengthAttributesInfo),
                        "::",
                        stringify!(mLengthCount)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_NumberInfo {
                pub mName: *mut root::nsStaticAtom,
                pub mDefaultValue: f32,
                pub mPercentagesAllowed: bool,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_NumberInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_NumberInfo>(),
                    16usize,
                    concat!("Size of: ", stringify!(SVGElement_NumberInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_NumberInfo>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SVGElement_NumberInfo))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_NumberInfo>())).mName as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_NumberInfo),
                        "::",
                        stringify!(mName)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_NumberInfo>())).mDefaultValue as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_NumberInfo),
                        "::",
                        stringify!(mDefaultValue)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_NumberInfo>())).mPercentagesAllowed
                            as *const _ as usize
                    },
                    12usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_NumberInfo),
                        "::",
                        stringify!(mPercentagesAllowed)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_NumberAttributesInfo {
                pub mNumbers: *mut root::mozilla::SVGAnimatedNumber,
                pub mNumberInfo: *const root::mozilla::dom::SVGElement_NumberInfo,
                pub mNumberCount: u32,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_NumberAttributesInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_NumberAttributesInfo>(),
                    24usize,
                    concat!("Size of: ", stringify!(SVGElement_NumberAttributesInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_NumberAttributesInfo>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SVGElement_NumberAttributesInfo))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_NumberAttributesInfo>())).mNumbers
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_NumberAttributesInfo),
                        "::",
                        stringify!(mNumbers)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_NumberAttributesInfo>())).mNumberInfo
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_NumberAttributesInfo),
                        "::",
                        stringify!(mNumberInfo)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_NumberAttributesInfo>())).mNumberCount
                            as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_NumberAttributesInfo),
                        "::",
                        stringify!(mNumberCount)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_NumberPairInfo {
                pub mName: *mut root::nsStaticAtom,
                pub mDefaultValue1: f32,
                pub mDefaultValue2: f32,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_NumberPairInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_NumberPairInfo>(),
                    16usize,
                    concat!("Size of: ", stringify!(SVGElement_NumberPairInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_NumberPairInfo>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SVGElement_NumberPairInfo))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_NumberPairInfo>())).mName as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_NumberPairInfo),
                        "::",
                        stringify!(mName)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_NumberPairInfo>())).mDefaultValue1
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_NumberPairInfo),
                        "::",
                        stringify!(mDefaultValue1)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_NumberPairInfo>())).mDefaultValue2
                            as *const _ as usize
                    },
                    12usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_NumberPairInfo),
                        "::",
                        stringify!(mDefaultValue2)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_NumberPairAttributesInfo {
                pub mNumberPairs: *mut root::mozilla::SVGAnimatedNumberPair,
                pub mNumberPairInfo: *const root::mozilla::dom::SVGElement_NumberPairInfo,
                pub mNumberPairCount: u32,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_NumberPairAttributesInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_NumberPairAttributesInfo>(),
                    24usize,
                    concat!("Size of: ", stringify!(SVGElement_NumberPairAttributesInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_NumberPairAttributesInfo>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(SVGElement_NumberPairAttributesInfo)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_NumberPairAttributesInfo>())).mNumberPairs
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_NumberPairAttributesInfo),
                        "::",
                        stringify!(mNumberPairs)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_NumberPairAttributesInfo>()))
                            .mNumberPairInfo as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_NumberPairAttributesInfo),
                        "::",
                        stringify!(mNumberPairInfo)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_NumberPairAttributesInfo>()))
                            .mNumberPairCount as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_NumberPairAttributesInfo),
                        "::",
                        stringify!(mNumberPairCount)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_IntegerInfo {
                pub mName: *mut root::nsStaticAtom,
                pub mDefaultValue: i32,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_IntegerInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_IntegerInfo>(),
                    16usize,
                    concat!("Size of: ", stringify!(SVGElement_IntegerInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_IntegerInfo>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SVGElement_IntegerInfo))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_IntegerInfo>())).mName as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_IntegerInfo),
                        "::",
                        stringify!(mName)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_IntegerInfo>())).mDefaultValue as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_IntegerInfo),
                        "::",
                        stringify!(mDefaultValue)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_IntegerAttributesInfo {
                pub mIntegers: *mut root::mozilla::SVGAnimatedInteger,
                pub mIntegerInfo: *const root::mozilla::dom::SVGElement_IntegerInfo,
                pub mIntegerCount: u32,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_IntegerAttributesInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_IntegerAttributesInfo>(),
                    24usize,
                    concat!("Size of: ", stringify!(SVGElement_IntegerAttributesInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_IntegerAttributesInfo>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(SVGElement_IntegerAttributesInfo)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_IntegerAttributesInfo>())).mIntegers
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_IntegerAttributesInfo),
                        "::",
                        stringify!(mIntegers)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_IntegerAttributesInfo>())).mIntegerInfo
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_IntegerAttributesInfo),
                        "::",
                        stringify!(mIntegerInfo)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_IntegerAttributesInfo>())).mIntegerCount
                            as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_IntegerAttributesInfo),
                        "::",
                        stringify!(mIntegerCount)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_IntegerPairInfo {
                pub mName: *mut root::nsStaticAtom,
                pub mDefaultValue1: i32,
                pub mDefaultValue2: i32,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_IntegerPairInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_IntegerPairInfo>(),
                    16usize,
                    concat!("Size of: ", stringify!(SVGElement_IntegerPairInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_IntegerPairInfo>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SVGElement_IntegerPairInfo))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_IntegerPairInfo>())).mName as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_IntegerPairInfo),
                        "::",
                        stringify!(mName)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_IntegerPairInfo>())).mDefaultValue1
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_IntegerPairInfo),
                        "::",
                        stringify!(mDefaultValue1)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_IntegerPairInfo>())).mDefaultValue2
                            as *const _ as usize
                    },
                    12usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_IntegerPairInfo),
                        "::",
                        stringify!(mDefaultValue2)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_IntegerPairAttributesInfo {
                pub mIntegerPairs: *mut root::mozilla::SVGAnimatedIntegerPair,
                pub mIntegerPairInfo: *const root::mozilla::dom::SVGElement_IntegerPairInfo,
                pub mIntegerPairCount: u32,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_IntegerPairAttributesInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_IntegerPairAttributesInfo>(),
                    24usize,
                    concat!(
                        "Size of: ",
                        stringify!(SVGElement_IntegerPairAttributesInfo)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_IntegerPairAttributesInfo>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(SVGElement_IntegerPairAttributesInfo)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_IntegerPairAttributesInfo>()))
                            .mIntegerPairs as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_IntegerPairAttributesInfo),
                        "::",
                        stringify!(mIntegerPairs)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_IntegerPairAttributesInfo>()))
                            .mIntegerPairInfo as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_IntegerPairAttributesInfo),
                        "::",
                        stringify!(mIntegerPairInfo)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_IntegerPairAttributesInfo>()))
                            .mIntegerPairCount as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_IntegerPairAttributesInfo),
                        "::",
                        stringify!(mIntegerPairCount)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_BooleanInfo {
                pub mName: *mut root::nsStaticAtom,
                pub mDefaultValue: bool,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_BooleanInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_BooleanInfo>(),
                    16usize,
                    concat!("Size of: ", stringify!(SVGElement_BooleanInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_BooleanInfo>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SVGElement_BooleanInfo))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_BooleanInfo>())).mName as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_BooleanInfo),
                        "::",
                        stringify!(mName)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_BooleanInfo>())).mDefaultValue as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_BooleanInfo),
                        "::",
                        stringify!(mDefaultValue)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_BooleanAttributesInfo {
                pub mBooleans: *mut root::mozilla::SVGAnimatedBoolean,
                pub mBooleanInfo: *const root::mozilla::dom::SVGElement_BooleanInfo,
                pub mBooleanCount: u32,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_BooleanAttributesInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_BooleanAttributesInfo>(),
                    24usize,
                    concat!("Size of: ", stringify!(SVGElement_BooleanAttributesInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_BooleanAttributesInfo>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(SVGElement_BooleanAttributesInfo)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_BooleanAttributesInfo>())).mBooleans
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_BooleanAttributesInfo),
                        "::",
                        stringify!(mBooleans)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_BooleanAttributesInfo>())).mBooleanInfo
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_BooleanAttributesInfo),
                        "::",
                        stringify!(mBooleanInfo)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_BooleanAttributesInfo>())).mBooleanCount
                            as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_BooleanAttributesInfo),
                        "::",
                        stringify!(mBooleanCount)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_EnumInfo {
                pub mName: *mut root::nsStaticAtom,
                pub mMapping: *const root::mozilla::SVGEnumMapping,
                pub mDefaultValue: u16,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_EnumInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_EnumInfo>(),
                    24usize,
                    concat!("Size of: ", stringify!(SVGElement_EnumInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_EnumInfo>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SVGElement_EnumInfo))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_EnumInfo>())).mName as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_EnumInfo),
                        "::",
                        stringify!(mName)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_EnumInfo>())).mMapping as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_EnumInfo),
                        "::",
                        stringify!(mMapping)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_EnumInfo>())).mDefaultValue as *const _
                            as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_EnumInfo),
                        "::",
                        stringify!(mDefaultValue)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_EnumAttributesInfo {
                pub mEnums: *mut root::mozilla::SVGAnimatedEnumeration,
                pub mEnumInfo: *const root::mozilla::dom::SVGElement_EnumInfo,
                pub mEnumCount: u32,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_EnumAttributesInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_EnumAttributesInfo>(),
                    24usize,
                    concat!("Size of: ", stringify!(SVGElement_EnumAttributesInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_EnumAttributesInfo>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SVGElement_EnumAttributesInfo))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_EnumAttributesInfo>())).mEnums as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_EnumAttributesInfo),
                        "::",
                        stringify!(mEnums)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_EnumAttributesInfo>())).mEnumInfo
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_EnumAttributesInfo),
                        "::",
                        stringify!(mEnumInfo)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_EnumAttributesInfo>())).mEnumCount
                            as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_EnumAttributesInfo),
                        "::",
                        stringify!(mEnumCount)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_NumberListInfo {
                pub mName: *mut root::nsStaticAtom,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_NumberListInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_NumberListInfo>(),
                    8usize,
                    concat!("Size of: ", stringify!(SVGElement_NumberListInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_NumberListInfo>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SVGElement_NumberListInfo))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_NumberListInfo>())).mName as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_NumberListInfo),
                        "::",
                        stringify!(mName)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_NumberListAttributesInfo {
                pub mNumberLists: *mut root::mozilla::SVGAnimatedNumberList,
                pub mNumberListInfo: *const root::mozilla::dom::SVGElement_NumberListInfo,
                pub mNumberListCount: u32,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_NumberListAttributesInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_NumberListAttributesInfo>(),
                    24usize,
                    concat!("Size of: ", stringify!(SVGElement_NumberListAttributesInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_NumberListAttributesInfo>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(SVGElement_NumberListAttributesInfo)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_NumberListAttributesInfo>())).mNumberLists
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_NumberListAttributesInfo),
                        "::",
                        stringify!(mNumberLists)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_NumberListAttributesInfo>()))
                            .mNumberListInfo as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_NumberListAttributesInfo),
                        "::",
                        stringify!(mNumberListInfo)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_NumberListAttributesInfo>()))
                            .mNumberListCount as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_NumberListAttributesInfo),
                        "::",
                        stringify!(mNumberListCount)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_LengthListInfo {
                pub mName: *mut root::nsStaticAtom,
                pub mAxis: u8,
                #[doc = " Flag to indicate whether appending zeros to the end of the list would"]
                #[doc = " change the rendering of the SVG for the attribute in question. For x and"]
                #[doc = " y on the <text> element this is true, but for dx and dy on <text> this"]
                #[doc = " is false. This flag is fed down to SVGLengthListSMILType so it can"]
                #[doc = " determine if it can sensibly animate from-to lists of different lengths,"]
                #[doc = " which is desirable in the case of dx and dy."]
                pub mCouldZeroPadList: bool,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_LengthListInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_LengthListInfo>(),
                    16usize,
                    concat!("Size of: ", stringify!(SVGElement_LengthListInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_LengthListInfo>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SVGElement_LengthListInfo))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_LengthListInfo>())).mName as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_LengthListInfo),
                        "::",
                        stringify!(mName)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_LengthListInfo>())).mAxis as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_LengthListInfo),
                        "::",
                        stringify!(mAxis)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_LengthListInfo>())).mCouldZeroPadList
                            as *const _ as usize
                    },
                    9usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_LengthListInfo),
                        "::",
                        stringify!(mCouldZeroPadList)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_LengthListAttributesInfo {
                pub mLengthLists: *mut root::mozilla::SVGAnimatedLengthList,
                pub mLengthListInfo: *const root::mozilla::dom::SVGElement_LengthListInfo,
                pub mLengthListCount: u32,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_LengthListAttributesInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_LengthListAttributesInfo>(),
                    24usize,
                    concat!("Size of: ", stringify!(SVGElement_LengthListAttributesInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_LengthListAttributesInfo>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(SVGElement_LengthListAttributesInfo)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_LengthListAttributesInfo>())).mLengthLists
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_LengthListAttributesInfo),
                        "::",
                        stringify!(mLengthLists)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_LengthListAttributesInfo>()))
                            .mLengthListInfo as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_LengthListAttributesInfo),
                        "::",
                        stringify!(mLengthListInfo)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_LengthListAttributesInfo>()))
                            .mLengthListCount as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_LengthListAttributesInfo),
                        "::",
                        stringify!(mLengthListCount)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_StringInfo {
                pub mName: *mut root::nsStaticAtom,
                pub mNamespaceID: i32,
                pub mIsAnimatable: bool,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_StringInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_StringInfo>(),
                    16usize,
                    concat!("Size of: ", stringify!(SVGElement_StringInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_StringInfo>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SVGElement_StringInfo))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_StringInfo>())).mName as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_StringInfo),
                        "::",
                        stringify!(mName)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_StringInfo>())).mNamespaceID as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_StringInfo),
                        "::",
                        stringify!(mNamespaceID)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_StringInfo>())).mIsAnimatable as *const _
                            as usize
                    },
                    12usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_StringInfo),
                        "::",
                        stringify!(mIsAnimatable)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_StringAttributesInfo {
                pub mStrings: *mut root::mozilla::SVGAnimatedString,
                pub mStringInfo: *const root::mozilla::dom::SVGElement_StringInfo,
                pub mStringCount: u32,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_StringAttributesInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_StringAttributesInfo>(),
                    24usize,
                    concat!("Size of: ", stringify!(SVGElement_StringAttributesInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_StringAttributesInfo>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SVGElement_StringAttributesInfo))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_StringAttributesInfo>())).mStrings
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_StringAttributesInfo),
                        "::",
                        stringify!(mStrings)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_StringAttributesInfo>())).mStringInfo
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_StringAttributesInfo),
                        "::",
                        stringify!(mStringInfo)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_StringAttributesInfo>())).mStringCount
                            as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_StringAttributesInfo),
                        "::",
                        stringify!(mStringCount)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_StringListInfo {
                pub mName: *mut root::nsStaticAtom,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_StringListInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_StringListInfo>(),
                    8usize,
                    concat!("Size of: ", stringify!(SVGElement_StringListInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_StringListInfo>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SVGElement_StringListInfo))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_StringListInfo>())).mName as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_StringListInfo),
                        "::",
                        stringify!(mName)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SVGElement_StringListAttributesInfo {
                pub mStringLists: *mut root::mozilla::SVGStringList,
                pub mStringListInfo: *const root::mozilla::dom::SVGElement_StringListInfo,
                pub mStringListCount: u32,
            }
            #[test]
            fn bindgen_test_layout_SVGElement_StringListAttributesInfo() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement_StringListAttributesInfo>(),
                    24usize,
                    concat!("Size of: ", stringify!(SVGElement_StringListAttributesInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement_StringListAttributesInfo>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(SVGElement_StringListAttributesInfo)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_StringListAttributesInfo>())).mStringLists
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_StringListAttributesInfo),
                        "::",
                        stringify!(mStringLists)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_StringListAttributesInfo>()))
                            .mStringListInfo as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_StringListAttributesInfo),
                        "::",
                        stringify!(mStringListInfo)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement_StringListAttributesInfo>()))
                            .mStringListCount as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement_StringListAttributesInfo),
                        "::",
                        stringify!(mStringListCount)
                    )
                );
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom10SVGElement14sFillStrokeMapE"]
                pub static mut SVGElement_sFillStrokeMap:
                    [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom10SVGElement12sGraphicsMapE"]
                pub static mut SVGElement_sGraphicsMap:
                    [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom10SVGElement23sTextContentElementsMapE"]
                pub static mut SVGElement_sTextContentElementsMap:
                    [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom10SVGElement21sFontSpecificationMapE"]
                pub static mut SVGElement_sFontSpecificationMap:
                    [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom10SVGElement16sGradientStopMapE"]
                pub static mut SVGElement_sGradientStopMap:
                    [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom10SVGElement13sViewportsMapE"]
                pub static mut SVGElement_sViewportsMap:
                    [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom10SVGElement11sMarkersMapE"]
                pub static mut SVGElement_sMarkersMap:
                    [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom10SVGElement9sColorMapE"]
                pub static mut SVGElement_sColorMap:
                    [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom10SVGElement11sFiltersMapE"]
                pub static mut SVGElement_sFiltersMap:
                    [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom10SVGElement11sFEFloodMapE"]
                pub static mut SVGElement_sFEFloodMap:
                    [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom10SVGElement19sLightingEffectsMapE"]
                pub static mut SVGElement_sLightingEffectsMap:
                    [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom10SVGElement8sMaskMapE"]
                pub static mut SVGElement_sMaskMap:
                    [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3dom10SVGElement16sSVGUnitTypesMapE"]
                pub static mut SVGElement_sSVGUnitTypesMap: [root::mozilla::SVGEnumMapping; 0usize];
            }
            #[test]
            fn bindgen_test_layout_SVGElement() {
                assert_eq!(
                    ::std::mem::size_of::<SVGElement>(),
                    152usize,
                    concat!("Size of: ", stringify!(SVGElement))
                );
                assert_eq!(
                    ::std::mem::align_of::<SVGElement>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SVGElement))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement>())).mClassAttribute as *const _ as usize
                    },
                    128usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement),
                        "::",
                        stringify!(mClassAttribute)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement>())).mClassAnimAttr as *const _ as usize
                    },
                    136usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement),
                        "::",
                        stringify!(mClassAnimAttr)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SVGElement>())).mContentDeclarationBlock as *const _
                            as usize
                    },
                    144usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SVGElement),
                        "::",
                        stringify!(mContentDeclarationBlock)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ExplicitChildIterator {
                pub mParent: *const root::nsIContent,
                pub mParentAsSlot: *const root::mozilla::dom::HTMLSlotElement,
                pub mChild: *mut root::nsIContent,
                pub mDefaultChild: *mut root::nsIContent,
                pub mIsFirst: bool,
                pub mIndexInInserted: u32,
            }
            #[test]
            fn bindgen_test_layout_ExplicitChildIterator() {
                assert_eq!(
                    ::std::mem::size_of::<ExplicitChildIterator>(),
                    40usize,
                    concat!("Size of: ", stringify!(ExplicitChildIterator))
                );
                assert_eq!(
                    ::std::mem::align_of::<ExplicitChildIterator>(),
                    8usize,
                    concat!("Alignment of ", stringify!(ExplicitChildIterator))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ExplicitChildIterator>())).mParent as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ExplicitChildIterator),
                        "::",
                        stringify!(mParent)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ExplicitChildIterator>())).mParentAsSlot as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ExplicitChildIterator),
                        "::",
                        stringify!(mParentAsSlot)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ExplicitChildIterator>())).mChild as *const _
                            as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ExplicitChildIterator),
                        "::",
                        stringify!(mChild)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ExplicitChildIterator>())).mDefaultChild as *const _
                            as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ExplicitChildIterator),
                        "::",
                        stringify!(mDefaultChild)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ExplicitChildIterator>())).mIsFirst as *const _
                            as usize
                    },
                    32usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ExplicitChildIterator),
                        "::",
                        stringify!(mIsFirst)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ExplicitChildIterator>())).mIndexInInserted
                            as *const _ as usize
                    },
                    36usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ExplicitChildIterator),
                        "::",
                        stringify!(mIndexInInserted)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct FlattenedChildIterator {
                pub _base: root::mozilla::dom::ExplicitChildIterator,
                pub mOriginalContent: *const root::nsIContent,
                pub mXBLInvolved: [u8; 2usize],
            }
            #[test]
            fn bindgen_test_layout_FlattenedChildIterator() {
                assert_eq!(
                    ::std::mem::size_of::<FlattenedChildIterator>(),
                    56usize,
                    concat!("Size of: ", stringify!(FlattenedChildIterator))
                );
                assert_eq!(
                    ::std::mem::align_of::<FlattenedChildIterator>(),
                    8usize,
                    concat!("Alignment of ", stringify!(FlattenedChildIterator))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FlattenedChildIterator>())).mOriginalContent
                            as *const _ as usize
                    },
                    40usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FlattenedChildIterator),
                        "::",
                        stringify!(mOriginalContent)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FlattenedChildIterator>())).mXBLInvolved as *const _
                            as usize
                    },
                    48usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FlattenedChildIterator),
                        "::",
                        stringify!(mXBLInvolved)
                    )
                );
            }
            #[doc = " AllChildrenIterator traverses the children of an element including before /"]
            #[doc = " after content and optionally XBL children.  The iterator can be initialized"]
            #[doc = " to start at the end by providing false for aStartAtBeginning in order to"]
            #[doc = " start iterating in reverse from the last child."]
            #[doc = ""]
            #[doc = " Note: it assumes that no mutation of the DOM or frame tree takes place during"]
            #[doc = " iteration, and will break horribly if that is not true."]
            #[repr(C)]
            #[derive(Debug)]
            pub struct AllChildrenIterator {
                pub _base: root::mozilla::dom::FlattenedChildIterator,
                pub mAnonKids: root::nsTArray<*mut root::nsIContent>,
                pub mAnonKidsIdx: u32,
                pub mFlags: u32,
                pub mPhase: root::mozilla::dom::AllChildrenIterator_IteratorPhase,
            }
            pub const AllChildrenIterator_IteratorPhase_eAtBegin:
                root::mozilla::dom::AllChildrenIterator_IteratorPhase = 0;
            pub const AllChildrenIterator_IteratorPhase_eAtMarkerKid:
                root::mozilla::dom::AllChildrenIterator_IteratorPhase = 1;
            pub const AllChildrenIterator_IteratorPhase_eAtBeforeKid:
                root::mozilla::dom::AllChildrenIterator_IteratorPhase = 2;
            pub const AllChildrenIterator_IteratorPhase_eAtExplicitKids:
                root::mozilla::dom::AllChildrenIterator_IteratorPhase = 3;
            pub const AllChildrenIterator_IteratorPhase_eAtAnonKids:
                root::mozilla::dom::AllChildrenIterator_IteratorPhase = 4;
            pub const AllChildrenIterator_IteratorPhase_eAtAfterKid:
                root::mozilla::dom::AllChildrenIterator_IteratorPhase = 5;
            pub const AllChildrenIterator_IteratorPhase_eAtEnd:
                root::mozilla::dom::AllChildrenIterator_IteratorPhase = 6;
            pub type AllChildrenIterator_IteratorPhase = u32;
            #[test]
            fn bindgen_test_layout_AllChildrenIterator() {
                assert_eq!(
                    ::std::mem::size_of::<AllChildrenIterator>(),
                    80usize,
                    concat!("Size of: ", stringify!(AllChildrenIterator))
                );
                assert_eq!(
                    ::std::mem::align_of::<AllChildrenIterator>(),
                    8usize,
                    concat!("Alignment of ", stringify!(AllChildrenIterator))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<AllChildrenIterator>())).mAnonKids as *const _
                            as usize
                    },
                    56usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(AllChildrenIterator),
                        "::",
                        stringify!(mAnonKids)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<AllChildrenIterator>())).mAnonKidsIdx as *const _
                            as usize
                    },
                    64usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(AllChildrenIterator),
                        "::",
                        stringify!(mAnonKidsIdx)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<AllChildrenIterator>())).mFlags as *const _ as usize
                    },
                    68usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(AllChildrenIterator),
                        "::",
                        stringify!(mFlags)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<AllChildrenIterator>())).mPhase as *const _ as usize
                    },
                    72usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(AllChildrenIterator),
                        "::",
                        stringify!(mPhase)
                    )
                );
            }
            #[doc = " StyleChildrenIterator traverses the children of the element from the"]
            #[doc = " perspective of the style system, particularly the children we need to"]
            #[doc = " traverse during restyle."]
            #[doc = ""]
            #[doc = " At present, this is identical to AllChildrenIterator with"]
            #[doc = " (eAllChildren | eSkipDocumentLevelNativeAnonymousContent). We used to have"]
            #[doc = " detect and skip any native anonymous children that are used to implement some"]
            #[doc = " special magic in here that went away, but we keep the separate class so"]
            #[doc = " we can reintroduce special magic back if needed."]
            #[doc = ""]
            #[doc = " Note: it assumes that no mutation of the DOM or frame tree takes place during"]
            #[doc = " iteration, and will break horribly if that is not true."]
            #[doc = ""]
            #[doc = " We require this to be memmovable since Rust code can create and move"]
            #[doc = " StyleChildrenIterators."]
            #[repr(C)]
            #[derive(Debug)]
            pub struct StyleChildrenIterator {
                pub _base: root::mozilla::dom::AllChildrenIterator,
            }
            #[test]
            fn bindgen_test_layout_StyleChildrenIterator() {
                assert_eq!(
                    ::std::mem::size_of::<StyleChildrenIterator>(),
                    80usize,
                    concat!("Size of: ", stringify!(StyleChildrenIterator))
                );
                assert_eq!(
                    ::std::mem::align_of::<StyleChildrenIterator>(),
                    8usize,
                    concat!("Alignment of ", stringify!(StyleChildrenIterator))
                );
            }
        }
        pub const ThreadSafeAutoRefCntWithRecording_isThreadSafe: bool = true;
        pub type ThreadSafeAutoRefCnt = u64;
        pub mod gfx {
            #[allow(unused_imports)]
            use self::super::super::super::root;
            pub type Float = f32;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct CoordTyped {
                pub _address: u8,
            }
            pub type CoordTyped_Super = u8;
            #[repr(C)]
            #[repr(align(1))]
            #[derive(Debug, Copy, Clone)]
            pub struct UnknownUnits {
                pub _bindgen_opaque_blob: u8,
            }
            #[test]
            fn bindgen_test_layout_UnknownUnits() {
                assert_eq!(
                    ::std::mem::size_of::<UnknownUnits>(),
                    1usize,
                    concat!("Size of: ", stringify!(UnknownUnits))
                );
                assert_eq!(
                    ::std::mem::align_of::<UnknownUnits>(),
                    1usize,
                    concat!("Alignment of ", stringify!(UnknownUnits))
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct IntPointTyped {
                pub _address: u8,
            }
            pub type IntPointTyped_ToInt = u32;
            pub type IntPointTyped_Coord = u8;
            pub type IntPointTyped_Super = u8;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct PointTyped {
                pub _address: u8,
            }
            pub type PointTyped_Coord = u8;
            pub type PointTyped_Super = u8;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct IntSizeTyped {
                pub _address: u8,
            }
            pub type IntSizeTyped_ToInt = u32;
            pub type IntSizeTyped_Super = u8;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SizeTyped {
                pub _address: u8,
            }
            pub type SizeTyped_Super = u8;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct IntMarginTyped {
                pub _address: u8,
            }
            pub type IntMarginTyped_Super = u8;
            pub type IntMargin = [u32; 4usize];
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct MarginTyped {
                pub _address: u8,
            }
            pub type MarginTyped_Super = u8;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct IntRectTyped {
                pub _address: u8,
            }
            pub type IntRectTyped_Super = u8;
            pub type IntRectTyped_Self = u8;
            pub type IntRectTyped_ToInt = u32;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct RectTyped {
                pub _address: u8,
            }
            pub type RectTyped_Super = u8;
            pub type RectDouble = [u64; 4usize];
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ScaleFactor {
                pub _address: u8,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ScaleFactors2D {
                pub _address: u8,
            }
            pub type Matrix = [u32; 6usize];
            pub type Matrix4x4 = [u32; 16usize];
            pub type Matrix4x4Flagged = [u32; 17usize];
            #[repr(C)]
            #[repr(align(8))]
            #[derive(Debug, Copy, Clone)]
            pub struct UserData {
                pub _bindgen_opaque_blob: [u64; 2usize],
            }
            pub type UserData_destroyFunc = u64;
            #[repr(C)]
            #[repr(align(8))]
            #[derive(Debug, Copy, Clone)]
            pub struct UserData_Entry {
                pub _bindgen_opaque_blob: [u64; 3usize],
            }
            #[test]
            fn bindgen_test_layout_UserData_Entry() {
                assert_eq!(
                    ::std::mem::size_of::<UserData_Entry>(),
                    24usize,
                    concat!("Size of: ", stringify!(UserData_Entry))
                );
                assert_eq!(
                    ::std::mem::align_of::<UserData_Entry>(),
                    8usize,
                    concat!("Alignment of ", stringify!(UserData_Entry))
                );
            }
            #[test]
            fn bindgen_test_layout_UserData() {
                assert_eq!(
                    ::std::mem::size_of::<UserData>(),
                    16usize,
                    concat!("Size of: ", stringify!(UserData))
                );
                assert_eq!(
                    ::std::mem::align_of::<UserData>(),
                    8usize,
                    concat!("Alignment of ", stringify!(UserData))
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct FontVariation {
                pub mTag: u32,
                pub mValue: f32,
            }
            #[test]
            fn bindgen_test_layout_FontVariation() {
                assert_eq!(
                    ::std::mem::size_of::<FontVariation>(),
                    8usize,
                    concat!("Size of: ", stringify!(FontVariation))
                );
                assert_eq!(
                    ::std::mem::align_of::<FontVariation>(),
                    4usize,
                    concat!("Alignment of ", stringify!(FontVariation))
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<FontVariation>())).mTag as *const _ as usize },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FontVariation),
                        "::",
                        stringify!(mTag)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FontVariation>())).mValue as *const _ as usize
                    },
                    4usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FontVariation),
                        "::",
                        stringify!(mValue)
                    )
                );
            }
            #[repr(C)]
            pub struct SourceSurface__bindgen_vtable(::std::os::raw::c_void);
            #[doc = " This is the base class for source surfaces. These objects are surfaces"]
            #[doc = " which may be used as a source in a SurfacePattern or a DrawSurface call."]
            #[doc = " They cannot be drawn to directly."]
            #[doc = ""]
            #[doc = " Although SourceSurface has thread-safe refcount, some SourceSurface cannot"]
            #[doc = " be used on random threads at the same time. Only DataSourceSurface can be"]
            #[doc = " used on random threads now. This will be fixed in the future. Eventually"]
            #[doc = " all SourceSurface should be thread-safe."]
            #[repr(C)]
            #[derive(Debug)]
            pub struct SourceSurface {
                pub vtable_: *const SourceSurface__bindgen_vtable,
                pub _base: u64,
                pub mUserData: root::mozilla::gfx::UserData,
            }
            #[test]
            fn bindgen_test_layout_SourceSurface() {
                assert_eq!(
                    ::std::mem::size_of::<SourceSurface>(),
                    32usize,
                    concat!("Size of: ", stringify!(SourceSurface))
                );
                assert_eq!(
                    ::std::mem::align_of::<SourceSurface>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SourceSurface))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SourceSurface>())).mUserData as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SourceSurface),
                        "::",
                        stringify!(mUserData)
                    )
                );
            }
            #[doc = " This is the main class used for all the drawing. It is created through the"]
            #[doc = " factory and accepts drawing commands. The results of drawing to a target"]
            #[doc = " may be used either through a Snapshot or by flushing the target and directly"]
            #[doc = " accessing the backing store a DrawTarget was created with."]
            #[repr(C)]
            #[repr(align(8))]
            #[derive(Debug, Copy, Clone)]
            pub struct DrawTarget {
                pub _bindgen_opaque_blob: [u64; 10usize],
            }
            #[test]
            fn bindgen_test_layout_DrawTarget() {
                assert_eq!(
                    ::std::mem::size_of::<DrawTarget>(),
                    80usize,
                    concat!("Size of: ", stringify!(DrawTarget))
                );
                assert_eq!(
                    ::std::mem::align_of::<DrawTarget>(),
                    8usize,
                    concat!("Alignment of ", stringify!(DrawTarget))
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct IntRegionTyped {
                pub _address: u8,
            }
            pub type IntRegionTyped_Super = u8;
            pub type IntRegionTyped_RectType = u8;
            pub type IntRegionTyped_PointType = u8;
            pub type IntRegionTyped_MarginType = u8;
        }
        pub mod layers {
            #[allow(unused_imports)]
            use self::super::super::super::root;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct LayersId {
                pub mId: u64,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct LayersId_HashFn {
                pub _address: u8,
            }
            #[test]
            fn bindgen_test_layout_LayersId_HashFn() {
                assert_eq!(
                    ::std::mem::size_of::<LayersId_HashFn>(),
                    1usize,
                    concat!("Size of: ", stringify!(LayersId_HashFn))
                );
                assert_eq!(
                    ::std::mem::align_of::<LayersId_HashFn>(),
                    1usize,
                    concat!("Alignment of ", stringify!(LayersId_HashFn))
                );
            }
            #[test]
            fn bindgen_test_layout_LayersId() {
                assert_eq!(
                    ::std::mem::size_of::<LayersId>(),
                    8usize,
                    concat!("Size of: ", stringify!(LayersId))
                );
                assert_eq!(
                    ::std::mem::align_of::<LayersId>(),
                    8usize,
                    concat!("Alignment of ", stringify!(LayersId))
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<LayersId>())).mId as *const _ as usize },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(LayersId),
                        "::",
                        stringify!(mId)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct BaseTransactionId {
                pub mId: u64,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct TransactionIdType {
                pub _address: u8,
            }
            #[test]
            fn bindgen_test_layout_TransactionIdType() {
                assert_eq!(
                    ::std::mem::size_of::<TransactionIdType>(),
                    1usize,
                    concat!("Size of: ", stringify!(TransactionIdType))
                );
                assert_eq!(
                    ::std::mem::align_of::<TransactionIdType>(),
                    1usize,
                    concat!("Alignment of ", stringify!(TransactionIdType))
                );
            }
            pub type TransactionId = root::mozilla::layers::BaseTransactionId;
            pub const LayersBackend_LAYERS_NONE: root::mozilla::layers::LayersBackend = 0;
            pub const LayersBackend_LAYERS_BASIC: root::mozilla::layers::LayersBackend = 1;
            pub const LayersBackend_LAYERS_OPENGL: root::mozilla::layers::LayersBackend = 2;
            pub const LayersBackend_LAYERS_D3D11: root::mozilla::layers::LayersBackend = 3;
            pub const LayersBackend_LAYERS_CLIENT: root::mozilla::layers::LayersBackend = 4;
            pub const LayersBackend_LAYERS_WR: root::mozilla::layers::LayersBackend = 5;
            pub const LayersBackend_LAYERS_LAST: root::mozilla::layers::LayersBackend = 6;
            pub type LayersBackend = i8;
            #[doc = " This class allows us to uniquely identify a scrollable layer. The"]
            #[doc = " mLayersId identifies the layer tree (corresponding to a child process"]
            #[doc = " and/or tab) that the scrollable layer belongs to. The mPresShellId"]
            #[doc = " is a temporal identifier (corresponding to the document loaded that"]
            #[doc = " contains the scrollable layer, which may change over time). The"]
            #[doc = " mScrollId corresponds to the actual frame that is scrollable."]
            #[repr(C)]
            #[derive(Debug)]
            pub struct ScrollableLayerGuid {
                pub mLayersId: root::mozilla::layers::LayersId,
                pub mPresShellId: u32,
                pub mScrollId: root::mozilla::layers::ScrollableLayerGuid_ViewID,
            }
            pub type ScrollableLayerGuid_ViewID = u64;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ScrollableLayerGuid_HashFn {
                pub _address: u8,
            }
            #[test]
            fn bindgen_test_layout_ScrollableLayerGuid_HashFn() {
                assert_eq!(
                    ::std::mem::size_of::<ScrollableLayerGuid_HashFn>(),
                    1usize,
                    concat!("Size of: ", stringify!(ScrollableLayerGuid_HashFn))
                );
                assert_eq!(
                    ::std::mem::align_of::<ScrollableLayerGuid_HashFn>(),
                    1usize,
                    concat!("Alignment of ", stringify!(ScrollableLayerGuid_HashFn))
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ScrollableLayerGuid_HashIgnoringPresShellFn {
                pub _address: u8,
            }
            #[test]
            fn bindgen_test_layout_ScrollableLayerGuid_HashIgnoringPresShellFn() {
                assert_eq!(
                    ::std::mem::size_of::<ScrollableLayerGuid_HashIgnoringPresShellFn>(),
                    1usize,
                    concat!(
                        "Size of: ",
                        stringify!(ScrollableLayerGuid_HashIgnoringPresShellFn)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<ScrollableLayerGuid_HashIgnoringPresShellFn>(),
                    1usize,
                    concat!(
                        "Alignment of ",
                        stringify!(ScrollableLayerGuid_HashIgnoringPresShellFn)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ScrollableLayerGuid_EqualIgnoringPresShellFn {
                pub _address: u8,
            }
            #[test]
            fn bindgen_test_layout_ScrollableLayerGuid_EqualIgnoringPresShellFn() {
                assert_eq!(
                    ::std::mem::size_of::<ScrollableLayerGuid_EqualIgnoringPresShellFn>(),
                    1usize,
                    concat!(
                        "Size of: ",
                        stringify!(ScrollableLayerGuid_EqualIgnoringPresShellFn)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<ScrollableLayerGuid_EqualIgnoringPresShellFn>(),
                    1usize,
                    concat!(
                        "Alignment of ",
                        stringify!(ScrollableLayerGuid_EqualIgnoringPresShellFn)
                    )
                );
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla6layers19ScrollableLayerGuid14NULL_SCROLL_IDE"]
                pub static ScrollableLayerGuid_NULL_SCROLL_ID:
                    root::mozilla::layers::ScrollableLayerGuid_ViewID;
            }
            pub const ScrollableLayerGuid_START_SCROLL_ID:
                root::mozilla::layers::ScrollableLayerGuid_ViewID = 2;
            #[test]
            fn bindgen_test_layout_ScrollableLayerGuid() {
                assert_eq!(
                    ::std::mem::size_of::<ScrollableLayerGuid>(),
                    24usize,
                    concat!("Size of: ", stringify!(ScrollableLayerGuid))
                );
                assert_eq!(
                    ::std::mem::align_of::<ScrollableLayerGuid>(),
                    8usize,
                    concat!("Alignment of ", stringify!(ScrollableLayerGuid))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScrollableLayerGuid>())).mLayersId as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScrollableLayerGuid),
                        "::",
                        stringify!(mLayersId)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScrollableLayerGuid>())).mPresShellId as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScrollableLayerGuid),
                        "::",
                        stringify!(mPresShellId)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScrollableLayerGuid>())).mScrollId as *const _
                            as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScrollableLayerGuid),
                        "::",
                        stringify!(mScrollId)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct SLGuidAndRenderRoot {
                pub mScrollableLayerGuid: root::mozilla::layers::ScrollableLayerGuid,
                pub mRenderRoot: root::mozilla::wr::RenderRoot,
            }
            #[test]
            fn bindgen_test_layout_SLGuidAndRenderRoot() {
                assert_eq!(
                    ::std::mem::size_of::<SLGuidAndRenderRoot>(),
                    32usize,
                    concat!("Size of: ", stringify!(SLGuidAndRenderRoot))
                );
                assert_eq!(
                    ::std::mem::align_of::<SLGuidAndRenderRoot>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SLGuidAndRenderRoot))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SLGuidAndRenderRoot>())).mScrollableLayerGuid
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SLGuidAndRenderRoot),
                        "::",
                        stringify!(mScrollableLayerGuid)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SLGuidAndRenderRoot>())).mRenderRoot as *const _
                            as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SLGuidAndRenderRoot),
                        "::",
                        stringify!(mRenderRoot)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct ZoomConstraints {
                pub mAllowZoom: bool,
                pub mAllowDoubleTapZoom: bool,
                pub mMinZoom: root::mozilla::CSSToParentLayerScale,
                pub mMaxZoom: root::mozilla::CSSToParentLayerScale,
            }
            #[test]
            fn bindgen_test_layout_ZoomConstraints() {
                assert_eq!(
                    ::std::mem::size_of::<ZoomConstraints>(),
                    12usize,
                    concat!("Size of: ", stringify!(ZoomConstraints))
                );
                assert_eq!(
                    ::std::mem::align_of::<ZoomConstraints>(),
                    4usize,
                    concat!("Alignment of ", stringify!(ZoomConstraints))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ZoomConstraints>())).mAllowZoom as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ZoomConstraints),
                        "::",
                        stringify!(mAllowZoom)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ZoomConstraints>())).mAllowDoubleTapZoom as *const _
                            as usize
                    },
                    1usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ZoomConstraints),
                        "::",
                        stringify!(mAllowDoubleTapZoom)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ZoomConstraints>())).mMinZoom as *const _ as usize
                    },
                    4usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ZoomConstraints),
                        "::",
                        stringify!(mMinZoom)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ZoomConstraints>())).mMaxZoom as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ZoomConstraints),
                        "::",
                        stringify!(mMaxZoom)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct AsyncDragMetrics {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct CompositorBridgeChild {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct LayerManager {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct LayerManagerComposite {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct PLayerTransactionChild {
                _unused: [u8; 0],
            }
            #[doc = " Metrics about a scroll frame that are sent to the compositor and used"]
            #[doc = " by APZ."]
            #[doc = ""]
            #[doc = " This is used for two main purposes:"]
            #[doc = ""]
            #[doc = "   (1) Sending information about a scroll frame to the compositor and APZ"]
            #[doc = "       as part of a layers or WebRender transaction."]
            #[doc = "   (2) Storing information about a scroll frame in APZ that persists"]
            #[doc = "       between transactions."]
            #[doc = ""]
            #[doc = " TODO: Separate these two uses into two distinct structures."]
            #[doc = ""]
            #[doc = " A related class, RepaintRequest, is used for sending information about a"]
            #[doc = " scroll frame back from the compositor to the main thread when requesting"]
            #[doc = " a repaint of the scroll frame\'s contents."]
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct FrameMetrics {
                pub mScrollId: root::mozilla::layers::FrameMetrics_ViewID,
                pub mPresShellResolution: f32,
                pub mCompositionBounds: root::mozilla::ParentLayerRect,
                pub mDisplayPort: root::mozilla::CSSRect,
                pub mCriticalDisplayPort: root::mozilla::CSSRect,
                pub mScrollableRect: root::mozilla::CSSRect,
                pub mCumulativeResolution: root::mozilla::LayoutDeviceToLayerScale2D,
                pub mDevPixelsPerCSSPixel: root::mozilla::CSSToLayoutDeviceScale,
                pub mScrollOffset: root::mozilla::CSSPoint,
                pub mBaseScrollOffset: root::mozilla::CSSPoint,
                pub mZoom: root::mozilla::CSSToParentLayerScale2D,
                pub mScrollGeneration: u32,
                pub mSmoothScrollOffset: root::mozilla::CSSPoint,
                pub mRootCompositionSize: root::mozilla::CSSSize,
                pub mDisplayPortMargins: root::mozilla::ScreenMargin,
                pub mPresShellId: u32,
                pub mLayoutViewport: root::mozilla::CSSRect,
                pub mExtraResolution: root::mozilla::ScreenToLayerScale2D,
                pub mPaintRequestTime: root::mozilla::TimeStamp,
                pub mScrollUpdateType: root::mozilla::layers::FrameMetrics_ScrollOffsetUpdateType,
                pub mVisualViewportOffset: root::mozilla::CSSPoint,
                pub mVisualScrollUpdateType:
                    root::mozilla::layers::FrameMetrics_ScrollOffsetUpdateType,
                pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 1usize], u8>,
                pub __bindgen_padding_0: u16,
            }
            pub type FrameMetrics_ViewID = root::mozilla::layers::ScrollableLayerGuid_ViewID;
            pub const FrameMetrics_ScrollOffsetUpdateType_eNone:
                root::mozilla::layers::FrameMetrics_ScrollOffsetUpdateType = 0;
            pub const FrameMetrics_ScrollOffsetUpdateType_eMainThread:
                root::mozilla::layers::FrameMetrics_ScrollOffsetUpdateType = 1;
            pub const FrameMetrics_ScrollOffsetUpdateType_ePending:
                root::mozilla::layers::FrameMetrics_ScrollOffsetUpdateType = 2;
            pub const FrameMetrics_ScrollOffsetUpdateType_eRestore:
                root::mozilla::layers::FrameMetrics_ScrollOffsetUpdateType = 3;
            pub type FrameMetrics_ScrollOffsetUpdateType = u8;
            pub const FrameMetrics_sScrollOffsetUpdateTypeCount: usize = 4;
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla6layers12FrameMetrics30sHighestScrollOffsetUpdateTypeE"]
                pub static FrameMetrics_sHighestScrollOffsetUpdateType:
                    root::mozilla::layers::FrameMetrics_ScrollOffsetUpdateType;
            }
            #[test]
            fn bindgen_test_layout_FrameMetrics() {
                assert_eq!(
                    ::std::mem::size_of::<FrameMetrics>(),
                    200usize,
                    concat!("Size of: ", stringify!(FrameMetrics))
                );
                assert_eq!(
                    ::std::mem::align_of::<FrameMetrics>(),
                    8usize,
                    concat!("Alignment of ", stringify!(FrameMetrics))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mScrollId as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mScrollId)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mPresShellResolution as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mPresShellResolution)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mCompositionBounds as *const _
                            as usize
                    },
                    12usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mCompositionBounds)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mDisplayPort as *const _ as usize
                    },
                    28usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mDisplayPort)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mCriticalDisplayPort as *const _
                            as usize
                    },
                    44usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mCriticalDisplayPort)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mScrollableRect as *const _
                            as usize
                    },
                    60usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mScrollableRect)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mCumulativeResolution as *const _
                            as usize
                    },
                    76usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mCumulativeResolution)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mDevPixelsPerCSSPixel as *const _
                            as usize
                    },
                    84usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mDevPixelsPerCSSPixel)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mScrollOffset as *const _ as usize
                    },
                    88usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mScrollOffset)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mBaseScrollOffset as *const _
                            as usize
                    },
                    96usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mBaseScrollOffset)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<FrameMetrics>())).mZoom as *const _ as usize },
                    104usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mZoom)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mScrollGeneration as *const _
                            as usize
                    },
                    112usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mScrollGeneration)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mSmoothScrollOffset as *const _
                            as usize
                    },
                    116usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mSmoothScrollOffset)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mRootCompositionSize as *const _
                            as usize
                    },
                    124usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mRootCompositionSize)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mDisplayPortMargins as *const _
                            as usize
                    },
                    132usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mDisplayPortMargins)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mPresShellId as *const _ as usize
                    },
                    148usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mPresShellId)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mLayoutViewport as *const _
                            as usize
                    },
                    152usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mLayoutViewport)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mExtraResolution as *const _
                            as usize
                    },
                    168usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mExtraResolution)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mPaintRequestTime as *const _
                            as usize
                    },
                    176usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mPaintRequestTime)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mScrollUpdateType as *const _
                            as usize
                    },
                    184usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mScrollUpdateType)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mVisualViewportOffset as *const _
                            as usize
                    },
                    188usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mVisualViewportOffset)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameMetrics>())).mVisualScrollUpdateType as *const _
                            as usize
                    },
                    196usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameMetrics),
                        "::",
                        stringify!(mVisualScrollUpdateType)
                    )
                );
            }
            impl FrameMetrics {
                #[inline]
                pub fn mIsRootContent(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsRootContent(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(0usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mIsRelative(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsRelative(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(1usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mDoSmoothScroll(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mDoSmoothScroll(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(2usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mIsScrollInfoLayer(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsScrollInfoLayer(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(3usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn new_bitfield_1(
                    mIsRootContent: bool,
                    mIsRelative: bool,
                    mDoSmoothScroll: bool,
                    mIsScrollInfoLayer: bool,
                ) -> root::__BindgenBitfieldUnit<[u8; 1usize], u8> {
                    let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 1usize], u8> =
                        Default::default();
                    __bindgen_bitfield_unit.set(0usize, 1u8, {
                        let mIsRootContent: u8 = unsafe { ::std::mem::transmute(mIsRootContent) };
                        mIsRootContent as u64
                    });
                    __bindgen_bitfield_unit.set(1usize, 1u8, {
                        let mIsRelative: u8 = unsafe { ::std::mem::transmute(mIsRelative) };
                        mIsRelative as u64
                    });
                    __bindgen_bitfield_unit.set(2usize, 1u8, {
                        let mDoSmoothScroll: u8 = unsafe { ::std::mem::transmute(mDoSmoothScroll) };
                        mDoSmoothScroll as u64
                    });
                    __bindgen_bitfield_unit.set(3usize, 1u8, {
                        let mIsScrollInfoLayer: u8 =
                            unsafe { ::std::mem::transmute(mIsScrollInfoLayer) };
                        mIsScrollInfoLayer as u64
                    });
                    __bindgen_bitfield_unit
                }
            }
            #[repr(C)]
            pub struct ScrollSnapInfo {
                pub mScrollSnapTypeX: root::mozilla::StyleScrollSnapStrictness,
                pub mScrollSnapTypeY: root::mozilla::StyleScrollSnapStrictness,
                pub mScrollSnapIntervalX: [u32; 2usize],
                pub mScrollSnapIntervalY: [u32; 2usize],
                pub mScrollSnapDestination: root::nsPoint,
                pub mScrollSnapCoordinates: root::nsTArray<root::nsPoint>,
                pub mSnapPositionX: root::nsTArray<root::nscoord>,
                pub mSnapPositionY: root::nsTArray<root::nscoord>,
                pub mXRangeWiderThanSnapport:
                    root::nsTArray<root::mozilla::layers::ScrollSnapInfo_ScrollSnapRange>,
                pub mYRangeWiderThanSnapport:
                    root::nsTArray<root::mozilla::layers::ScrollSnapInfo_ScrollSnapRange>,
                pub mSnapportSize: root::nsSize,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ScrollSnapInfo_ScrollSnapRange {
                pub mStart: root::nscoord,
                pub mEnd: root::nscoord,
            }
            #[test]
            fn bindgen_test_layout_ScrollSnapInfo_ScrollSnapRange() {
                assert_eq!(
                    ::std::mem::size_of::<ScrollSnapInfo_ScrollSnapRange>(),
                    8usize,
                    concat!("Size of: ", stringify!(ScrollSnapInfo_ScrollSnapRange))
                );
                assert_eq!(
                    ::std::mem::align_of::<ScrollSnapInfo_ScrollSnapRange>(),
                    4usize,
                    concat!("Alignment of ", stringify!(ScrollSnapInfo_ScrollSnapRange))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScrollSnapInfo_ScrollSnapRange>())).mStart
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScrollSnapInfo_ScrollSnapRange),
                        "::",
                        stringify!(mStart)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScrollSnapInfo_ScrollSnapRange>())).mEnd as *const _
                            as usize
                    },
                    4usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScrollSnapInfo_ScrollSnapRange),
                        "::",
                        stringify!(mEnd)
                    )
                );
            }
            #[test]
            fn bindgen_test_layout_ScrollSnapInfo() {
                assert_eq!(
                    ::std::mem::size_of::<ScrollSnapInfo>(),
                    80usize,
                    concat!("Size of: ", stringify!(ScrollSnapInfo))
                );
                assert_eq!(
                    ::std::mem::align_of::<ScrollSnapInfo>(),
                    8usize,
                    concat!("Alignment of ", stringify!(ScrollSnapInfo))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScrollSnapInfo>())).mScrollSnapTypeX as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScrollSnapInfo),
                        "::",
                        stringify!(mScrollSnapTypeX)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScrollSnapInfo>())).mScrollSnapTypeY as *const _
                            as usize
                    },
                    1usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScrollSnapInfo),
                        "::",
                        stringify!(mScrollSnapTypeY)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScrollSnapInfo>())).mScrollSnapIntervalX as *const _
                            as usize
                    },
                    4usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScrollSnapInfo),
                        "::",
                        stringify!(mScrollSnapIntervalX)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScrollSnapInfo>())).mScrollSnapIntervalY as *const _
                            as usize
                    },
                    12usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScrollSnapInfo),
                        "::",
                        stringify!(mScrollSnapIntervalY)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScrollSnapInfo>())).mScrollSnapDestination
                            as *const _ as usize
                    },
                    20usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScrollSnapInfo),
                        "::",
                        stringify!(mScrollSnapDestination)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScrollSnapInfo>())).mScrollSnapCoordinates
                            as *const _ as usize
                    },
                    32usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScrollSnapInfo),
                        "::",
                        stringify!(mScrollSnapCoordinates)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScrollSnapInfo>())).mSnapPositionX as *const _
                            as usize
                    },
                    40usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScrollSnapInfo),
                        "::",
                        stringify!(mSnapPositionX)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScrollSnapInfo>())).mSnapPositionY as *const _
                            as usize
                    },
                    48usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScrollSnapInfo),
                        "::",
                        stringify!(mSnapPositionY)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScrollSnapInfo>())).mXRangeWiderThanSnapport
                            as *const _ as usize
                    },
                    56usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScrollSnapInfo),
                        "::",
                        stringify!(mXRangeWiderThanSnapport)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScrollSnapInfo>())).mYRangeWiderThanSnapport
                            as *const _ as usize
                    },
                    64usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScrollSnapInfo),
                        "::",
                        stringify!(mYRangeWiderThanSnapport)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<ScrollSnapInfo>())).mSnapportSize as *const _
                            as usize
                    },
                    72usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(ScrollSnapInfo),
                        "::",
                        stringify!(mSnapportSize)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Layer {
                _unused: [u8; 0],
            }
            #[doc = " This class is used for communicating information about the currently focused"]
            #[doc = " element of a document and the scrollable frames to use when keyboard"]
            #[doc = " scrolling it. It is created on the main thread at paint-time, but is then"]
            #[doc = " passed over IPC to the compositor/APZ code."]
            #[repr(C)]
            #[derive(Debug)]
            pub struct FocusTarget {
                pub mSequenceNumber: u64,
                pub mFocusHasKeyEventListeners: bool,
                pub mData: root::mozilla::Variant,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct FocusTarget_ScrollTargets {
                pub mHorizontal: root::mozilla::layers::ScrollableLayerGuid_ViewID,
                pub mHorizontalRenderRoot: root::mozilla::wr::RenderRoot,
                pub mVertical: root::mozilla::layers::ScrollableLayerGuid_ViewID,
                pub mVerticalRenderRoot: root::mozilla::wr::RenderRoot,
            }
            #[test]
            fn bindgen_test_layout_FocusTarget_ScrollTargets() {
                assert_eq!(
                    ::std::mem::size_of::<FocusTarget_ScrollTargets>(),
                    32usize,
                    concat!("Size of: ", stringify!(FocusTarget_ScrollTargets))
                );
                assert_eq!(
                    ::std::mem::align_of::<FocusTarget_ScrollTargets>(),
                    8usize,
                    concat!("Alignment of ", stringify!(FocusTarget_ScrollTargets))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FocusTarget_ScrollTargets>())).mHorizontal
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FocusTarget_ScrollTargets),
                        "::",
                        stringify!(mHorizontal)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FocusTarget_ScrollTargets>())).mHorizontalRenderRoot
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FocusTarget_ScrollTargets),
                        "::",
                        stringify!(mHorizontalRenderRoot)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FocusTarget_ScrollTargets>())).mVertical as *const _
                            as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FocusTarget_ScrollTargets),
                        "::",
                        stringify!(mVertical)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FocusTarget_ScrollTargets>())).mVerticalRenderRoot
                            as *const _ as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FocusTarget_ScrollTargets),
                        "::",
                        stringify!(mVerticalRenderRoot)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct FocusTarget_NoFocusTarget {
                pub _address: u8,
            }
            #[test]
            fn bindgen_test_layout_FocusTarget_NoFocusTarget() {
                assert_eq!(
                    ::std::mem::size_of::<FocusTarget_NoFocusTarget>(),
                    1usize,
                    concat!("Size of: ", stringify!(FocusTarget_NoFocusTarget))
                );
                assert_eq!(
                    ::std::mem::align_of::<FocusTarget_NoFocusTarget>(),
                    1usize,
                    concat!("Alignment of ", stringify!(FocusTarget_NoFocusTarget))
                );
            }
            #[test]
            fn bindgen_test_layout_FocusTarget() {
                assert_eq!(
                    ::std::mem::size_of::<FocusTarget>(),
                    56usize,
                    concat!("Size of: ", stringify!(FocusTarget))
                );
                assert_eq!(
                    ::std::mem::align_of::<FocusTarget>(),
                    8usize,
                    concat!("Alignment of ", stringify!(FocusTarget))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FocusTarget>())).mSequenceNumber as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FocusTarget),
                        "::",
                        stringify!(mSequenceNumber)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FocusTarget>())).mFocusHasKeyEventListeners
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FocusTarget),
                        "::",
                        stringify!(mFocusHasKeyEventListeners)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<FocusTarget>())).mData as *const _ as usize },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FocusTarget),
                        "::",
                        stringify!(mData)
                    )
                );
            }
            #[repr(C)]
            pub struct TransactionIdAllocator__bindgen_vtable(::std::os::raw::c_void);
            #[repr(C)]
            #[derive(Debug)]
            pub struct TransactionIdAllocator {
                pub vtable_: *const TransactionIdAllocator__bindgen_vtable,
                pub mRefCnt: root::nsAutoRefCnt,
            }
            pub type TransactionIdAllocator_HasThreadSafeRefCnt = root::mozilla::FalseType;
            #[test]
            fn bindgen_test_layout_TransactionIdAllocator() {
                assert_eq!(
                    ::std::mem::size_of::<TransactionIdAllocator>(),
                    16usize,
                    concat!("Size of: ", stringify!(TransactionIdAllocator))
                );
                assert_eq!(
                    ::std::mem::align_of::<TransactionIdAllocator>(),
                    8usize,
                    concat!("Alignment of ", stringify!(TransactionIdAllocator))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<TransactionIdAllocator>())).mRefCnt as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(TransactionIdAllocator),
                        "::",
                        stringify!(mRefCnt)
                    )
                );
            }
        }
        pub type AtomArray = root::nsTArray<root::RefPtr<root::nsAtom>>;
        #[repr(u32)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum Side {
            eSideTop = 0,
            eSideRight = 1,
            eSideBottom = 2,
            eSideLeft = 3,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum HalfCorner {
            eCornerTopLeftX = 0,
            eCornerTopLeftY = 1,
            eCornerTopRightX = 2,
            eCornerTopRightY = 3,
            eCornerBottomRightX = 4,
            eCornerBottomRightY = 5,
            eCornerBottomLeftX = 6,
            eCornerBottomLeftY = 7,
        }
        #[doc = " Sides represents a set of physical sides."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct Sides {
            pub mBits: u8,
        }
        #[test]
        fn bindgen_test_layout_Sides() {
            assert_eq!(
                ::std::mem::size_of::<Sides>(),
                1usize,
                concat!("Size of: ", stringify!(Sides))
            );
            assert_eq!(
                ::std::mem::align_of::<Sides>(),
                1usize,
                concat!("Alignment of ", stringify!(Sides))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<Sides>())).mBits as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(Sides),
                    "::",
                    stringify!(mBits)
                )
            );
        }
        pub mod external {
            #[allow(unused_imports)]
            use self::super::super::super::root;
        }
        pub const LogLevel_Disabled: root::mozilla::LogLevel = 0;
        pub const LogLevel_Error: root::mozilla::LogLevel = 1;
        pub const LogLevel_Warning: root::mozilla::LogLevel = 2;
        pub const LogLevel_Info: root::mozilla::LogLevel = 3;
        pub const LogLevel_Debug: root::mozilla::LogLevel = 4;
        pub const LogLevel_Verbose: root::mozilla::LogLevel = 5;
        pub type LogLevel = i32;
        #[repr(C)]
        #[derive(Debug)]
        pub struct LogModule {
            pub mName: *mut ::std::os::raw::c_char,
            pub mLevel: u32,
        }
        #[test]
        fn bindgen_test_layout_LogModule() {
            assert_eq!(
                ::std::mem::size_of::<LogModule>(),
                16usize,
                concat!("Size of: ", stringify!(LogModule))
            );
            assert_eq!(
                ::std::mem::align_of::<LogModule>(),
                8usize,
                concat!("Alignment of ", stringify!(LogModule))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<LogModule>())).mName as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(LogModule),
                    "::",
                    stringify!(mName)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<LogModule>())).mLevel as *const _ as usize },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(LogModule),
                    "::",
                    stringify!(mLevel)
                )
            );
        }
        #[doc = " Helper class that lazy loads the given log module. This is safe to use for"]
        #[doc = " declaring static references to log modules and can be used as a replacement"]
        #[doc = " for accessing a LogModule directly."]
        #[doc = ""]
        #[doc = " Example usage:"]
        #[doc = "   static LazyLogModule sLayoutLog(\"layout\");"]
        #[doc = ""]
        #[doc = "   void Foo() {"]
        #[doc = "     MOZ_LOG(sLayoutLog, LogLevel::Verbose, (\"Entering foo\"));"]
        #[doc = "   }"]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct LazyLogModule {
            pub mLogName: *const ::std::os::raw::c_char,
            pub mLog: u64,
        }
        #[test]
        fn bindgen_test_layout_LazyLogModule() {
            assert_eq!(
                ::std::mem::size_of::<LazyLogModule>(),
                16usize,
                concat!("Size of: ", stringify!(LazyLogModule))
            );
            assert_eq!(
                ::std::mem::align_of::<LazyLogModule>(),
                8usize,
                concat!("Alignment of ", stringify!(LazyLogModule))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<LazyLogModule>())).mLogName as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(LazyLogModule),
                    "::",
                    stringify!(mLogName)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<LazyLogModule>())).mLog as *const _ as usize },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(LazyLogModule),
                    "::",
                    stringify!(mLog)
                )
            );
        }
        #[doc = " BlockingResourceBase"]
        #[doc = " Base class of resources that might block clients trying to acquire them."]
        #[doc = " Does debugging and deadlock detection in DEBUG builds."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct BlockingResourceBase {
            pub _address: u8,
        }
        pub const BlockingResourceBase_BlockingResourceType_eMutex:
            root::mozilla::BlockingResourceBase_BlockingResourceType = 0;
        pub const BlockingResourceBase_BlockingResourceType_eReentrantMonitor:
            root::mozilla::BlockingResourceBase_BlockingResourceType = 1;
        pub const BlockingResourceBase_BlockingResourceType_eCondVar:
            root::mozilla::BlockingResourceBase_BlockingResourceType = 2;
        pub const BlockingResourceBase_BlockingResourceType_eRecursiveMutex:
            root::mozilla::BlockingResourceBase_BlockingResourceType = 3;
        pub type BlockingResourceBase_BlockingResourceType = u32;
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla20BlockingResourceBase17kResourceTypeNameE"]
            pub static mut BlockingResourceBase_kResourceTypeName:
                [*const ::std::os::raw::c_char; 0usize];
        }
        #[test]
        fn bindgen_test_layout_BlockingResourceBase() {
            assert_eq!(
                ::std::mem::size_of::<BlockingResourceBase>(),
                1usize,
                concat!("Size of: ", stringify!(BlockingResourceBase))
            );
            assert_eq!(
                ::std::mem::align_of::<BlockingResourceBase>(),
                1usize,
                concat!("Alignment of ", stringify!(BlockingResourceBase))
            );
        }
        #[doc = " OffTheBooksMutex is identical to Mutex, except that OffTheBooksMutex doesn\'t"]
        #[doc = " include leak checking.  Sometimes you want to intentionally \"leak\" a mutex"]
        #[doc = " until shutdown; in these cases, OffTheBooksMutex is for you."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct OffTheBooksMutex {
            pub _base: root::mozilla::detail::MutexImpl,
        }
        #[test]
        fn bindgen_test_layout_OffTheBooksMutex() {
            assert_eq!(
                ::std::mem::size_of::<OffTheBooksMutex>(),
                40usize,
                concat!("Size of: ", stringify!(OffTheBooksMutex))
            );
            assert_eq!(
                ::std::mem::align_of::<OffTheBooksMutex>(),
                8usize,
                concat!("Alignment of ", stringify!(OffTheBooksMutex))
            );
        }
        #[doc = " Mutex"]
        #[doc = " When possible, use MutexAutoLock/MutexAutoUnlock to lock/unlock this"]
        #[doc = " mutex within a scope, instead of calling Lock/Unlock directly."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct Mutex {
            pub _base: root::mozilla::OffTheBooksMutex,
        }
        #[test]
        fn bindgen_test_layout_Mutex() {
            assert_eq!(
                ::std::mem::size_of::<Mutex>(),
                40usize,
                concat!("Size of: ", stringify!(Mutex))
            );
            assert_eq!(
                ::std::mem::align_of::<Mutex>(),
                8usize,
                concat!("Alignment of ", stringify!(Mutex))
            );
        }
        pub mod wr {
            #[allow(unused_imports)]
            use self::super::super::super::root;
            pub const RenderRoot_Default: root::mozilla::wr::RenderRoot = 0;
            pub const RenderRoot_Content: root::mozilla::wr::RenderRoot = 1;
            pub type RenderRoot = u8;
        }
        pub type CSSCoord = u32;
        pub type CSSPoint = [u32; 2usize];
        pub type CSSIntPoint = [u32; 2usize];
        pub type CSSSize = [u32; 2usize];
        pub type CSSRect = [u32; 4usize];
        pub type LayoutDeviceIntPoint = [u32; 2usize];
        pub type LayoutDeviceIntSize = [u32; 2usize];
        pub type LayoutDeviceIntRect = [u32; 4usize];
        pub type LayoutDeviceIntMargin = [u32; 4usize];
        pub type LayoutDeviceIntRegion = u8;
        pub type ScreenPoint = [u32; 2usize];
        pub type ScreenIntPoint = u8;
        pub type ScreenIntSize = u8;
        pub type ScreenMargin = [u32; 4usize];
        pub type ParentLayerRect = [u32; 4usize];
        pub type DesktopIntRect = [u32; 4usize];
        pub type CSSToLayoutDeviceScale = u32;
        pub type CSSToScreenScale = u8;
        pub type CSSToParentLayerScale = u32;
        pub type LayoutDeviceToScreenScale = u32;
        pub type CSSToParentLayerScale2D = [u32; 2usize];
        pub type LayoutDeviceToLayerScale2D = [u32; 2usize];
        pub type ScreenToLayerScale2D = [u32; 2usize];
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct CSSPixel {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_CSSPixel() {
            assert_eq!(
                ::std::mem::size_of::<CSSPixel>(),
                1usize,
                concat!("Size of: ", stringify!(CSSPixel))
            );
            assert_eq!(
                ::std::mem::align_of::<CSSPixel>(),
                1usize,
                concat!("Alignment of ", stringify!(CSSPixel))
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct LayoutDevicePixel {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_LayoutDevicePixel() {
            assert_eq!(
                ::std::mem::size_of::<LayoutDevicePixel>(),
                1usize,
                concat!("Size of: ", stringify!(LayoutDevicePixel))
            );
            assert_eq!(
                ::std::mem::align_of::<LayoutDevicePixel>(),
                1usize,
                concat!("Alignment of ", stringify!(LayoutDevicePixel))
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct LayerPixel {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_LayerPixel() {
            assert_eq!(
                ::std::mem::size_of::<LayerPixel>(),
                1usize,
                concat!("Size of: ", stringify!(LayerPixel))
            );
            assert_eq!(
                ::std::mem::align_of::<LayerPixel>(),
                1usize,
                concat!("Alignment of ", stringify!(LayerPixel))
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct ScreenPixel {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_ScreenPixel() {
            assert_eq!(
                ::std::mem::size_of::<ScreenPixel>(),
                1usize,
                concat!("Size of: ", stringify!(ScreenPixel))
            );
            assert_eq!(
                ::std::mem::align_of::<ScreenPixel>(),
                1usize,
                concat!("Alignment of ", stringify!(ScreenPixel))
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct ParentLayerPixel {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_ParentLayerPixel() {
            assert_eq!(
                ::std::mem::size_of::<ParentLayerPixel>(),
                1usize,
                concat!("Size of: ", stringify!(ParentLayerPixel))
            );
            assert_eq!(
                ::std::mem::align_of::<ParentLayerPixel>(),
                1usize,
                concat!("Alignment of ", stringify!(ParentLayerPixel))
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct DesktopPixel {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_DesktopPixel() {
            assert_eq!(
                ::std::mem::size_of::<DesktopPixel>(),
                1usize,
                concat!("Size of: ", stringify!(DesktopPixel))
            );
            assert_eq!(
                ::std::mem::align_of::<DesktopPixel>(),
                1usize,
                concat!("Alignment of ", stringify!(DesktopPixel))
            );
        }
        pub const ServoTraversalFlags_Empty: root::mozilla::ServoTraversalFlags = 0;
        pub const ServoTraversalFlags_AnimationOnly: root::mozilla::ServoTraversalFlags = 1;
        pub const ServoTraversalFlags_ForCSSRuleChanges: root::mozilla::ServoTraversalFlags = 2;
        pub const ServoTraversalFlags_FinalAnimationTraversal: root::mozilla::ServoTraversalFlags =
            4;
        pub const ServoTraversalFlags_ParallelTraversal: root::mozilla::ServoTraversalFlags = 128;
        pub const ServoTraversalFlags_FlushThrottledAnimations: root::mozilla::ServoTraversalFlags =
            256;
        pub type ServoTraversalFlags = u32;
        #[repr(i32)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleRuleInclusion {
            All = 0,
            DefaultOnly = 1,
        }
        pub const UpdateAnimationsTasks_CSSAnimations: root::mozilla::UpdateAnimationsTasks = 1;
        pub const UpdateAnimationsTasks_CSSTransitions: root::mozilla::UpdateAnimationsTasks = 2;
        pub const UpdateAnimationsTasks_EffectProperties: root::mozilla::UpdateAnimationsTasks = 4;
        pub const UpdateAnimationsTasks_CascadeResults: root::mozilla::UpdateAnimationsTasks = 8;
        pub const UpdateAnimationsTasks_DisplayChangedFromNone:
            root::mozilla::UpdateAnimationsTasks = 16;
        pub type UpdateAnimationsTasks = u8;
        pub const ParsingMode_Default: root::mozilla::ParsingMode = 0;
        pub const ParsingMode_AllowUnitlessLength: root::mozilla::ParsingMode = 1;
        pub const ParsingMode_AllowAllNumericValues: root::mozilla::ParsingMode = 2;
        pub type ParsingMode = u8;
        #[repr(i32)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum InheritTarget {
            Text = 0,
            FirstLetterContinuation = 1,
            PlaceholderFrame = 2,
        }
        pub const PointerCapabilities_None: root::mozilla::PointerCapabilities = 0;
        pub const PointerCapabilities_Coarse: root::mozilla::PointerCapabilities = 1;
        pub const PointerCapabilities_Fine: root::mozilla::PointerCapabilities = 2;
        pub const PointerCapabilities_Hover: root::mozilla::PointerCapabilities = 4;
        pub type PointerCapabilities = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct ServoStyleSetSizes {
            pub mRuleTree: usize,
            pub mPrecomputedPseudos: usize,
            pub mElementAndPseudosMaps: usize,
            pub mInvalidationMap: usize,
            pub mRevalidationSelectors: usize,
            pub mOther: usize,
        }
        #[test]
        fn bindgen_test_layout_ServoStyleSetSizes() {
            assert_eq!(
                ::std::mem::size_of::<ServoStyleSetSizes>(),
                48usize,
                concat!("Size of: ", stringify!(ServoStyleSetSizes))
            );
            assert_eq!(
                ::std::mem::align_of::<ServoStyleSetSizes>(),
                8usize,
                concat!("Alignment of ", stringify!(ServoStyleSetSizes))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoStyleSetSizes>())).mRuleTree as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoStyleSetSizes),
                    "::",
                    stringify!(mRuleTree)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoStyleSetSizes>())).mPrecomputedPseudos as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoStyleSetSizes),
                    "::",
                    stringify!(mPrecomputedPseudos)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoStyleSetSizes>())).mElementAndPseudosMaps
                        as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoStyleSetSizes),
                    "::",
                    stringify!(mElementAndPseudosMaps)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoStyleSetSizes>())).mInvalidationMap as *const _
                        as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoStyleSetSizes),
                    "::",
                    stringify!(mInvalidationMap)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoStyleSetSizes>())).mRevalidationSelectors
                        as *const _ as usize
                },
                32usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoStyleSetSizes),
                    "::",
                    stringify!(mRevalidationSelectors)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoStyleSetSizes>())).mOther as *const _ as usize
                },
                40usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoStyleSetSizes),
                    "::",
                    stringify!(mOther)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct DeclarationBlockMutationClosure {
            pub function:
                ::std::option::Option<unsafe extern "C" fn(arg1: *mut ::std::os::raw::c_void)>,
            pub data: *mut ::std::os::raw::c_void,
        }
        #[test]
        fn bindgen_test_layout_DeclarationBlockMutationClosure() {
            assert_eq!(
                ::std::mem::size_of::<DeclarationBlockMutationClosure>(),
                16usize,
                concat!("Size of: ", stringify!(DeclarationBlockMutationClosure))
            );
            assert_eq!(
                ::std::mem::align_of::<DeclarationBlockMutationClosure>(),
                8usize,
                concat!("Alignment of ", stringify!(DeclarationBlockMutationClosure))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<DeclarationBlockMutationClosure>())).function as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DeclarationBlockMutationClosure),
                    "::",
                    stringify!(function)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<DeclarationBlockMutationClosure>())).data as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DeclarationBlockMutationClosure),
                    "::",
                    stringify!(data)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct MediumFeaturesChangedResult {
            pub mAffectsDocumentRules: bool,
            pub mAffectsNonDocumentRules: bool,
            pub mUsesViewportUnits: bool,
        }
        #[test]
        fn bindgen_test_layout_MediumFeaturesChangedResult() {
            assert_eq!(
                ::std::mem::size_of::<MediumFeaturesChangedResult>(),
                3usize,
                concat!("Size of: ", stringify!(MediumFeaturesChangedResult))
            );
            assert_eq!(
                ::std::mem::align_of::<MediumFeaturesChangedResult>(),
                1usize,
                concat!("Alignment of ", stringify!(MediumFeaturesChangedResult))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<MediumFeaturesChangedResult>())).mAffectsDocumentRules
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(MediumFeaturesChangedResult),
                    "::",
                    stringify!(mAffectsDocumentRules)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<MediumFeaturesChangedResult>())).mAffectsNonDocumentRules
                        as *const _ as usize
                },
                1usize,
                concat!(
                    "Offset of field: ",
                    stringify!(MediumFeaturesChangedResult),
                    "::",
                    stringify!(mAffectsNonDocumentRules)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<MediumFeaturesChangedResult>())).mUsesViewportUnits
                        as *const _ as usize
                },
                2usize,
                concat!(
                    "Offset of field: ",
                    stringify!(MediumFeaturesChangedResult),
                    "::",
                    stringify!(mUsesViewportUnits)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct FontSizePrefs {
            pub mDefaultVariableSize: root::nscoord,
            pub mDefaultSerifSize: root::nscoord,
            pub mDefaultSansSerifSize: root::nscoord,
            pub mDefaultMonospaceSize: root::nscoord,
            pub mDefaultCursiveSize: root::nscoord,
            pub mDefaultFantasySize: root::nscoord,
        }
        #[test]
        fn bindgen_test_layout_FontSizePrefs() {
            assert_eq!(
                ::std::mem::size_of::<FontSizePrefs>(),
                24usize,
                concat!("Size of: ", stringify!(FontSizePrefs))
            );
            assert_eq!(
                ::std::mem::align_of::<FontSizePrefs>(),
                4usize,
                concat!("Alignment of ", stringify!(FontSizePrefs))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<FontSizePrefs>())).mDefaultVariableSize as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(FontSizePrefs),
                    "::",
                    stringify!(mDefaultVariableSize)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<FontSizePrefs>())).mDefaultSerifSize as *const _ as usize
                },
                4usize,
                concat!(
                    "Offset of field: ",
                    stringify!(FontSizePrefs),
                    "::",
                    stringify!(mDefaultSerifSize)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<FontSizePrefs>())).mDefaultSansSerifSize as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(FontSizePrefs),
                    "::",
                    stringify!(mDefaultSansSerifSize)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<FontSizePrefs>())).mDefaultMonospaceSize as *const _
                        as usize
                },
                12usize,
                concat!(
                    "Offset of field: ",
                    stringify!(FontSizePrefs),
                    "::",
                    stringify!(mDefaultMonospaceSize)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<FontSizePrefs>())).mDefaultCursiveSize as *const _
                        as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(FontSizePrefs),
                    "::",
                    stringify!(mDefaultCursiveSize)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<FontSizePrefs>())).mDefaultFantasySize as *const _
                        as usize
                },
                20usize,
                concat!(
                    "Offset of field: ",
                    stringify!(FontSizePrefs),
                    "::",
                    stringify!(mDefaultFantasySize)
                )
            );
        }
        pub type ComputedKeyframeValues =
            root::nsTArray<root::mozilla::PropertyStyleAnimationValuePair>;
        #[test]
        fn __bindgen_test_layout_DefaultDelete_open0_RawServoStyleSet_close0_instantiation() {
            assert_eq!(
                ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
                1usize,
                concat!(
                    "Size of template specialization: ",
                    stringify!(root::mozilla::DefaultDelete)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
                1usize,
                concat!(
                    "Alignment of template specialization: ",
                    stringify!(root::mozilla::DefaultDelete)
                )
            );
        }
        #[test]
        fn __bindgen_test_layout_DefaultDelete_open0_RawServoAuthorStyles_close0_instantiation() {
            assert_eq!(
                ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
                1usize,
                concat!(
                    "Size of template specialization: ",
                    stringify!(root::mozilla::DefaultDelete)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
                1usize,
                concat!(
                    "Alignment of template specialization: ",
                    stringify!(root::mozilla::DefaultDelete)
                )
            );
        }
        #[test]
        fn __bindgen_test_layout_DefaultDelete_open0_RawServoSelectorList_close0_instantiation() {
            assert_eq!(
                ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
                1usize,
                concat!(
                    "Size of template specialization: ",
                    stringify!(root::mozilla::DefaultDelete)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
                1usize,
                concat!(
                    "Alignment of template specialization: ",
                    stringify!(root::mozilla::DefaultDelete)
                )
            );
        }
        #[test]
        fn __bindgen_test_layout_DefaultDelete_open0_RawServoSharedMemoryBuilder_close0_instantiation(
        ) {
            assert_eq!(
                ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
                1usize,
                concat!(
                    "Size of template specialization: ",
                    stringify!(root::mozilla::DefaultDelete)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
                1usize,
                concat!(
                    "Alignment of template specialization: ",
                    stringify!(root::mozilla::DefaultDelete)
                )
            );
        }
        #[test]
        fn __bindgen_test_layout_DefaultDelete_open0_RawServoSourceSizeList_close0_instantiation() {
            assert_eq!(
                ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
                1usize,
                concat!(
                    "Size of template specialization: ",
                    stringify!(root::mozilla::DefaultDelete)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
                1usize,
                concat!(
                    "Alignment of template specialization: ",
                    stringify!(root::mozilla::DefaultDelete)
                )
            );
        }
        #[test]
        fn __bindgen_test_layout_DefaultDelete_open0_StyleUseCounters_close0_instantiation() {
            assert_eq!(
                ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
                1usize,
                concat!(
                    "Size of template specialization: ",
                    stringify!(root::mozilla::DefaultDelete)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
                1usize,
                concat!(
                    "Alignment of template specialization: ",
                    stringify!(root::mozilla::DefaultDelete)
                )
            );
        }
        pub type Matrix4x4Components = [f32; 16usize];
        pub mod css {
            #[allow(unused_imports)]
            use self::super::super::super::root;
            pub type SheetLoadDataHolder =
                root::nsMainThreadPtrHolder<root::mozilla::css::SheetLoadData>;
            #[repr(C)]
            #[derive(Debug)]
            pub struct URLValue {
                pub mRefCnt: u64,
                pub mURI: root::nsCOMPtr,
                pub mURIResolved: bool,
                pub mCssUrl: root::RefPtr<root::RawServoCssUrlData>,
                pub mCORSMode: root::mozilla::CORSMode,
                pub mLoadID: u64,
            }
            pub type URLValue_HasThreadSafeRefCnt = root::mozilla::TrueType;
            #[test]
            fn bindgen_test_layout_URLValue() {
                assert_eq!(
                    ::std::mem::size_of::<URLValue>(),
                    48usize,
                    concat!("Size of: ", stringify!(URLValue))
                );
                assert_eq!(
                    ::std::mem::align_of::<URLValue>(),
                    8usize,
                    concat!("Alignment of ", stringify!(URLValue))
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<URLValue>())).mRefCnt as *const _ as usize },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(URLValue),
                        "::",
                        stringify!(mRefCnt)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<URLValue>())).mURI as *const _ as usize },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(URLValue),
                        "::",
                        stringify!(mURI)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<URLValue>())).mURIResolved as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(URLValue),
                        "::",
                        stringify!(mURIResolved)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<URLValue>())).mCssUrl as *const _ as usize },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(URLValue),
                        "::",
                        stringify!(mCssUrl)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<URLValue>())).mCORSMode as *const _ as usize },
                    32usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(URLValue),
                        "::",
                        stringify!(mCORSMode)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<URLValue>())).mLoadID as *const _ as usize },
                    40usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(URLValue),
                        "::",
                        stringify!(mLoadID)
                    )
                );
            }
            #[repr(C)]
            pub struct GridNamedArea {
                pub mName: ::gecko_bindings::structs::nsString,
                pub mColumnStart: u32,
                pub mColumnEnd: u32,
                pub mRowStart: u32,
                pub mRowEnd: u32,
            }
            #[test]
            fn bindgen_test_layout_GridNamedArea() {
                assert_eq!(
                    ::std::mem::size_of::<GridNamedArea>(),
                    32usize,
                    concat!("Size of: ", stringify!(GridNamedArea))
                );
                assert_eq!(
                    ::std::mem::align_of::<GridNamedArea>(),
                    8usize,
                    concat!("Alignment of ", stringify!(GridNamedArea))
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<GridNamedArea>())).mName as *const _ as usize },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(GridNamedArea),
                        "::",
                        stringify!(mName)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<GridNamedArea>())).mColumnStart as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(GridNamedArea),
                        "::",
                        stringify!(mColumnStart)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<GridNamedArea>())).mColumnEnd as *const _ as usize
                    },
                    20usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(GridNamedArea),
                        "::",
                        stringify!(mColumnEnd)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<GridNamedArea>())).mRowStart as *const _ as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(GridNamedArea),
                        "::",
                        stringify!(mRowStart)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<GridNamedArea>())).mRowEnd as *const _ as usize
                    },
                    28usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(GridNamedArea),
                        "::",
                        stringify!(mRowEnd)
                    )
                );
            }
            #[repr(C)]
            pub struct GridTemplateAreasValue {
                pub mNamedAreas: root::nsTArray<root::mozilla::css::GridNamedArea>,
                pub mTemplates: root::nsTArray<::gecko_bindings::structs::nsString>,
                pub mNColumns: u32,
                pub mRefCnt: u64,
            }
            pub type GridTemplateAreasValue_HasThreadSafeRefCnt = root::mozilla::TrueType;
            #[test]
            fn bindgen_test_layout_GridTemplateAreasValue() {
                assert_eq!(
                    ::std::mem::size_of::<GridTemplateAreasValue>(),
                    32usize,
                    concat!("Size of: ", stringify!(GridTemplateAreasValue))
                );
                assert_eq!(
                    ::std::mem::align_of::<GridTemplateAreasValue>(),
                    8usize,
                    concat!("Alignment of ", stringify!(GridTemplateAreasValue))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<GridTemplateAreasValue>())).mNamedAreas as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(GridTemplateAreasValue),
                        "::",
                        stringify!(mNamedAreas)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<GridTemplateAreasValue>())).mTemplates as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(GridTemplateAreasValue),
                        "::",
                        stringify!(mTemplates)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<GridTemplateAreasValue>())).mNColumns as *const _
                            as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(GridTemplateAreasValue),
                        "::",
                        stringify!(mNColumns)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<GridTemplateAreasValue>())).mRefCnt as *const _
                            as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(GridTemplateAreasValue),
                        "::",
                        stringify!(mRefCnt)
                    )
                );
            }
            #[repr(u8)]
            #[doc = " Enum defining the mode in which a sheet is to be parsed.  This is"]
            #[doc = " usually, but not always, the same as the cascade level at which the"]
            #[doc = " sheet will apply (see nsStyleSet.h).  Most of the Loader APIs only"]
            #[doc = " support loading of author sheets."]
            #[doc = ""]
            #[doc = " Author sheets are the normal case: styles embedded in or linked"]
            #[doc = " from HTML pages.  They are also the most restricted."]
            #[doc = ""]
            #[doc = " User sheets can do anything author sheets can do, and also get"]
            #[doc = " access to a few CSS extensions that are not yet suitable for"]
            #[doc = " exposure on the public Web, but are very useful for expressing"]
            #[doc = " user style overrides, such as @-moz-document rules."]
            #[doc = ""]
            #[doc = " XXX: eUserSheetFeatures was added in bug 1035091, but some patches in"]
            #[doc = " that bug never landed to use this enum value. Currently, all the features"]
            #[doc = " in user sheet are also available in author sheet."]
            #[doc = ""]
            #[doc = " Agent sheets have access to all author- and user-sheet features"]
            #[doc = " plus more extensions that are necessary for internal use but,"]
            #[doc = " again, not yet suitable for exposure on the public Web.  Some of"]
            #[doc = " these are outright unsafe to expose; in particular, incorrect"]
            #[doc = " styling of anonymous box pseudo-elements can violate layout"]
            #[doc = " invariants."]
            #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
            pub enum SheetParsingMode {
                eAuthorSheetFeatures = 0,
                eUserSheetFeatures = 1,
                eAgentSheetFeatures = 2,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Rule {
                _unused: [u8; 0],
            }
            #[doc = " Style sheet reuse *"]
            #[repr(C)]
            pub struct LoaderReusableStyleSheets {
                pub mReusableSheets: root::nsTArray<root::RefPtr<root::mozilla::StyleSheet>>,
            }
            #[test]
            fn bindgen_test_layout_LoaderReusableStyleSheets() {
                assert_eq!(
                    ::std::mem::size_of::<LoaderReusableStyleSheets>(),
                    8usize,
                    concat!("Size of: ", stringify!(LoaderReusableStyleSheets))
                );
                assert_eq!(
                    ::std::mem::align_of::<LoaderReusableStyleSheets>(),
                    8usize,
                    concat!("Alignment of ", stringify!(LoaderReusableStyleSheets))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<LoaderReusableStyleSheets>())).mReusableSheets
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(LoaderReusableStyleSheets),
                        "::",
                        stringify!(mReusableSheets)
                    )
                );
            }
            #[repr(C)]
            pub struct Loader {
                pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
                pub mSheets: root::mozilla::UniquePtr<root::mozilla::css::Loader_Sheets>,
                pub mPostedEvents: root::mozilla::css::Loader_LoadDataArray,
                pub mObservers: [u64; 2usize],
                pub mDocument: *mut root::mozilla::dom::Document,
                pub mDocGroup: root::RefPtr<root::mozilla::dom::DocGroup>,
                pub mDatasToNotifyOn: u32,
                pub mCompatMode: root::nsCompatibility,
                pub mEnabled: bool,
                pub mReporter: root::nsCOMPtr,
            }
            pub use self::super::super::super::root::mozilla::net::ReferrerPolicy as Loader_ReferrerPolicy;
            pub use self::super::super::super::root::nsIStyleSheetLinkingElement_Completed as Loader_Completed;
            pub use self::super::super::super::root::nsIStyleSheetLinkingElement_HasAlternateRel as Loader_HasAlternateRel;
            pub use self::super::super::super::root::nsIStyleSheetLinkingElement_IsAlternate as Loader_IsAlternate;
            pub use self::super::super::super::root::nsIStyleSheetLinkingElement_IsExplicitlyEnabled as Loader_IsExplicitlyEnabled;
            pub use self::super::super::super::root::nsIStyleSheetLinkingElement_IsInline as Loader_IsInline;
            pub use self::super::super::super::root::nsIStyleSheetLinkingElement_MediaMatched as Loader_MediaMatched;
            pub type Loader_LoadSheetResult = root::nsIStyleSheetLinkingElement_Update;
            pub type Loader_SheetInfo = root::nsIStyleSheetLinkingElement_SheetInfo;
            pub type Loader_HasThreadSafeRefCnt = root::mozilla::FalseType;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Loader_cycleCollection {
                pub _base: root::nsCycleCollectionParticipant,
            }
            #[test]
            fn bindgen_test_layout_Loader_cycleCollection() {
                assert_eq!(
                    ::std::mem::size_of::<Loader_cycleCollection>(),
                    16usize,
                    concat!("Size of: ", stringify!(Loader_cycleCollection))
                );
                assert_eq!(
                    ::std::mem::align_of::<Loader_cycleCollection>(),
                    8usize,
                    concat!("Alignment of ", stringify!(Loader_cycleCollection))
                );
            }
            pub type Loader_LoadDataArray =
                root::nsTArray<root::RefPtr<root::mozilla::css::SheetLoadData>>;
            pub const Loader_AllowAsyncParse_Yes: root::mozilla::css::Loader_AllowAsyncParse = 0;
            pub const Loader_AllowAsyncParse_No: root::mozilla::css::Loader_AllowAsyncParse = 1;
            pub type Loader_AllowAsyncParse = i32;
            #[repr(C)]
            #[derive(Debug)]
            pub struct Loader_Sheets {
                pub mCompleteSheets: [u64; 4usize],
                pub mLoadingDatas: [u64; 4usize],
                pub mPendingDatas: [u64; 4usize],
            }
            #[test]
            fn bindgen_test_layout_Loader_Sheets() {
                assert_eq!(
                    ::std::mem::size_of::<Loader_Sheets>(),
                    96usize,
                    concat!("Size of: ", stringify!(Loader_Sheets))
                );
                assert_eq!(
                    ::std::mem::align_of::<Loader_Sheets>(),
                    8usize,
                    concat!("Alignment of ", stringify!(Loader_Sheets))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<Loader_Sheets>())).mCompleteSheets as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Loader_Sheets),
                        "::",
                        stringify!(mCompleteSheets)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<Loader_Sheets>())).mLoadingDatas as *const _ as usize
                    },
                    32usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Loader_Sheets),
                        "::",
                        stringify!(mLoadingDatas)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<Loader_Sheets>())).mPendingDatas as *const _ as usize
                    },
                    64usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Loader_Sheets),
                        "::",
                        stringify!(mPendingDatas)
                    )
                );
            }
            extern "C" {
                #[link_name = "\u{1}_ZN7mozilla3css6Loader21_cycleCollectorGlobalE"]
                pub static mut Loader__cycleCollectorGlobal:
                    root::mozilla::css::Loader_cycleCollection;
            }
            #[test]
            fn bindgen_test_layout_Loader() {
                assert_eq!(
                    ::std::mem::size_of::<Loader>(),
                    80usize,
                    concat!("Size of: ", stringify!(Loader))
                );
                assert_eq!(
                    ::std::mem::align_of::<Loader>(),
                    8usize,
                    concat!("Alignment of ", stringify!(Loader))
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<Loader>())).mRefCnt as *const _ as usize },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Loader),
                        "::",
                        stringify!(mRefCnt)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<Loader>())).mSheets as *const _ as usize },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Loader),
                        "::",
                        stringify!(mSheets)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<Loader>())).mPostedEvents as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Loader),
                        "::",
                        stringify!(mPostedEvents)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<Loader>())).mObservers as *const _ as usize },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Loader),
                        "::",
                        stringify!(mObservers)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<Loader>())).mDocument as *const _ as usize },
                    40usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Loader),
                        "::",
                        stringify!(mDocument)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<Loader>())).mDocGroup as *const _ as usize },
                    48usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Loader),
                        "::",
                        stringify!(mDocGroup)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<Loader>())).mDatasToNotifyOn as *const _ as usize
                    },
                    56usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Loader),
                        "::",
                        stringify!(mDatasToNotifyOn)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<Loader>())).mCompatMode as *const _ as usize },
                    60usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Loader),
                        "::",
                        stringify!(mCompatMode)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<Loader>())).mEnabled as *const _ as usize },
                    64usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Loader),
                        "::",
                        stringify!(mEnabled)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<Loader>())).mReporter as *const _ as usize },
                    72usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(Loader),
                        "::",
                        stringify!(mReporter)
                    )
                );
            }
            #[repr(C)]
            pub struct SheetLoadData {
                pub _base: root::nsIRunnable,
                pub _base_1: root::nsIThreadObserver,
                pub mRefCnt: root::nsAutoRefCnt,
                pub mLoader: root::RefPtr<root::mozilla::css::Loader>,
                pub mTitle: ::gecko_bindings::structs::nsString,
                pub mEncoding: *const root::mozilla::Encoding,
                pub mURI: root::nsCOMPtr,
                pub mLineNumber: u32,
                pub mSheet: root::RefPtr<root::mozilla::StyleSheet>,
                pub mNext: *mut root::mozilla::css::SheetLoadData,
                pub mParentData: root::RefPtr<root::mozilla::css::SheetLoadData>,
                pub mPendingChildren: u32,
                pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 2usize], u8>,
                pub mOwningElement: root::nsCOMPtr,
                pub mObserver: root::nsCOMPtr,
                pub mLoaderPrincipal: root::nsCOMPtr,
                pub mRequestingNode: root::nsCOMPtr,
                pub mPreloadEncoding: *const root::mozilla::Encoding,
            }
            pub use self::super::super::super::root::nsIStyleSheetLinkingElement_IsAlternate as SheetLoadData_IsAlternate;
            pub use self::super::super::super::root::nsIStyleSheetLinkingElement_MediaMatched as SheetLoadData_MediaMatched;
            pub type SheetLoadData_HasThreadSafeRefCnt = root::mozilla::FalseType;
            #[test]
            fn bindgen_test_layout_SheetLoadData() {
                assert_eq!(
                    ::std::mem::size_of::<SheetLoadData>(),
                    144usize,
                    concat!("Size of: ", stringify!(SheetLoadData))
                );
                assert_eq!(
                    ::std::mem::align_of::<SheetLoadData>(),
                    8usize,
                    concat!("Alignment of ", stringify!(SheetLoadData))
                );
            }
            impl SheetLoadData {
                #[inline]
                pub fn mSyncLoad(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mSyncLoad(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(0usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mIsNonDocumentSheet(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsNonDocumentSheet(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(1usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mIsLoading(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsLoading(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(2usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mIsBeingParsed(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsBeingParsed(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(3usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mIsCancelled(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsCancelled(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(4usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mMustNotify(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mMustNotify(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(5usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mWasAlternate(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mWasAlternate(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(6usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mMediaMatched(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mMediaMatched(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(7usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mUseSystemPrincipal(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mUseSystemPrincipal(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(8usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mSheetAlreadyComplete(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(9usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mSheetAlreadyComplete(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(9usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mIsCrossOriginNoCORS(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(10usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mIsCrossOriginNoCORS(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(10usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mBlockResourceTiming(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(11usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mBlockResourceTiming(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(11usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn mLoadFailed(&self) -> bool {
                    unsafe { ::std::mem::transmute(self._bitfield_1.get(12usize, 1u8) as u8) }
                }
                #[inline]
                pub fn set_mLoadFailed(&mut self, val: bool) {
                    unsafe {
                        let val: u8 = ::std::mem::transmute(val);
                        self._bitfield_1.set(12usize, 1u8, val as u64)
                    }
                }
                #[inline]
                pub fn new_bitfield_1(
                    mSyncLoad: bool,
                    mIsNonDocumentSheet: bool,
                    mIsLoading: bool,
                    mIsBeingParsed: bool,
                    mIsCancelled: bool,
                    mMustNotify: bool,
                    mWasAlternate: bool,
                    mMediaMatched: bool,
                    mUseSystemPrincipal: bool,
                    mSheetAlreadyComplete: bool,
                    mIsCrossOriginNoCORS: bool,
                    mBlockResourceTiming: bool,
                    mLoadFailed: bool,
                ) -> root::__BindgenBitfieldUnit<[u8; 2usize], u8> {
                    let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 2usize], u8> =
                        Default::default();
                    __bindgen_bitfield_unit.set(0usize, 1u8, {
                        let mSyncLoad: u8 = unsafe { ::std::mem::transmute(mSyncLoad) };
                        mSyncLoad as u64
                    });
                    __bindgen_bitfield_unit.set(1usize, 1u8, {
                        let mIsNonDocumentSheet: u8 =
                            unsafe { ::std::mem::transmute(mIsNonDocumentSheet) };
                        mIsNonDocumentSheet as u64
                    });
                    __bindgen_bitfield_unit.set(2usize, 1u8, {
                        let mIsLoading: u8 = unsafe { ::std::mem::transmute(mIsLoading) };
                        mIsLoading as u64
                    });
                    __bindgen_bitfield_unit.set(3usize, 1u8, {
                        let mIsBeingParsed: u8 = unsafe { ::std::mem::transmute(mIsBeingParsed) };
                        mIsBeingParsed as u64
                    });
                    __bindgen_bitfield_unit.set(4usize, 1u8, {
                        let mIsCancelled: u8 = unsafe { ::std::mem::transmute(mIsCancelled) };
                        mIsCancelled as u64
                    });
                    __bindgen_bitfield_unit.set(5usize, 1u8, {
                        let mMustNotify: u8 = unsafe { ::std::mem::transmute(mMustNotify) };
                        mMustNotify as u64
                    });
                    __bindgen_bitfield_unit.set(6usize, 1u8, {
                        let mWasAlternate: u8 = unsafe { ::std::mem::transmute(mWasAlternate) };
                        mWasAlternate as u64
                    });
                    __bindgen_bitfield_unit.set(7usize, 1u8, {
                        let mMediaMatched: u8 = unsafe { ::std::mem::transmute(mMediaMatched) };
                        mMediaMatched as u64
                    });
                    __bindgen_bitfield_unit.set(8usize, 1u8, {
                        let mUseSystemPrincipal: u8 =
                            unsafe { ::std::mem::transmute(mUseSystemPrincipal) };
                        mUseSystemPrincipal as u64
                    });
                    __bindgen_bitfield_unit.set(9usize, 1u8, {
                        let mSheetAlreadyComplete: u8 =
                            unsafe { ::std::mem::transmute(mSheetAlreadyComplete) };
                        mSheetAlreadyComplete as u64
                    });
                    __bindgen_bitfield_unit.set(10usize, 1u8, {
                        let mIsCrossOriginNoCORS: u8 =
                            unsafe { ::std::mem::transmute(mIsCrossOriginNoCORS) };
                        mIsCrossOriginNoCORS as u64
                    });
                    __bindgen_bitfield_unit.set(11usize, 1u8, {
                        let mBlockResourceTiming: u8 =
                            unsafe { ::std::mem::transmute(mBlockResourceTiming) };
                        mBlockResourceTiming as u64
                    });
                    __bindgen_bitfield_unit.set(12usize, 1u8, {
                        let mLoadFailed: u8 = unsafe { ::std::mem::transmute(mLoadFailed) };
                        mLoadFailed as u64
                    });
                    __bindgen_bitfield_unit
                }
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ImageLoader {
                _unused: [u8; 0],
            }
            #[repr(i32)]
            #[doc = " Enum defining the type of matching function for a @-moz-document rule"]
            #[doc = " condition."]
            #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
            pub enum DocumentMatchingFunction {
                URL = 0,
                URLPrefix = 1,
                Domain = 2,
                RegExp = 3,
                MediaDocument = 4,
            }
        }
        #[doc = " Allow all kind of numeric values."]
        pub const StyleAllowedNumericType_All: root::mozilla::StyleAllowedNumericType = 0;
        #[doc = " Allow only non-negative numeric values."]
        pub const StyleAllowedNumericType_NonNegative: root::mozilla::StyleAllowedNumericType = 1;
        #[doc = " Allow only numeric values greater or equal to 1.0."]
        pub const StyleAllowedNumericType_AtLeastOne: root::mozilla::StyleAllowedNumericType = 2;
        #[doc = " Whether to allow negative lengths or not."]
        pub type StyleAllowedNumericType = u8;
        pub const StyleIsAbsolute_Yes: root::mozilla::StyleIsAbsolute = 0;
        pub const StyleIsAbsolute_No: root::mozilla::StyleIsAbsolute = 1;
        #[doc = " The path command absolute type."]
        pub type StyleIsAbsolute = u8;
        pub const StyleScrollSnapAlignKeyword_None: root::mozilla::StyleScrollSnapAlignKeyword = 0;
        pub const StyleScrollSnapAlignKeyword_Start: root::mozilla::StyleScrollSnapAlignKeyword = 1;
        pub const StyleScrollSnapAlignKeyword_End: root::mozilla::StyleScrollSnapAlignKeyword = 2;
        pub const StyleScrollSnapAlignKeyword_Center: root::mozilla::StyleScrollSnapAlignKeyword =
            3;
        #[doc = " Specified value of scroll-snap-align keyword value."]
        pub type StyleScrollSnapAlignKeyword = u8;
        pub const StyleScrollSnapAxis_X: root::mozilla::StyleScrollSnapAxis = 0;
        pub const StyleScrollSnapAxis_Y: root::mozilla::StyleScrollSnapAxis = 1;
        pub const StyleScrollSnapAxis_Block: root::mozilla::StyleScrollSnapAxis = 2;
        pub const StyleScrollSnapAxis_Inline: root::mozilla::StyleScrollSnapAxis = 3;
        pub const StyleScrollSnapAxis_Both: root::mozilla::StyleScrollSnapAxis = 4;
        #[doc = " https://drafts.csswg.org/css-scroll-snap-1/#snap-axis"]
        pub type StyleScrollSnapAxis = u8;
        pub const StyleStepPosition_JumpStart: root::mozilla::StyleStepPosition = 0;
        pub const StyleStepPosition_JumpEnd: root::mozilla::StyleStepPosition = 1;
        pub const StyleStepPosition_JumpNone: root::mozilla::StyleStepPosition = 2;
        pub const StyleStepPosition_JumpBoth: root::mozilla::StyleStepPosition = 3;
        pub const StyleStepPosition_Start: root::mozilla::StyleStepPosition = 4;
        pub const StyleStepPosition_End: root::mozilla::StyleStepPosition = 5;
        pub type StyleStepPosition = u8;
        #[doc = " No case transform."]
        pub const StyleTextTransformCase_None: root::mozilla::StyleTextTransformCase = 0;
        #[doc = " All uppercase."]
        pub const StyleTextTransformCase_Uppercase: root::mozilla::StyleTextTransformCase = 1;
        #[doc = " All lowercase."]
        pub const StyleTextTransformCase_Lowercase: root::mozilla::StyleTextTransformCase = 2;
        #[doc = " Capitalize each word."]
        pub const StyleTextTransformCase_Capitalize: root::mozilla::StyleTextTransformCase = 3;
        #[doc = " Specified keyword values for case transforms in the text-transform property. (These are exclusive.)"]
        pub type StyleTextTransformCase = i32;
        pub const StyleTimingKeyword_Linear: root::mozilla::StyleTimingKeyword = 0;
        pub const StyleTimingKeyword_Ease: root::mozilla::StyleTimingKeyword = 1;
        pub const StyleTimingKeyword_EaseIn: root::mozilla::StyleTimingKeyword = 2;
        pub const StyleTimingKeyword_EaseOut: root::mozilla::StyleTimingKeyword = 3;
        pub const StyleTimingKeyword_EaseInOut: root::mozilla::StyleTimingKeyword = 4;
        pub type StyleTimingKeyword = u8;
        #[doc = " A CSS float value."]
        pub type StyleCSSFloat = f32;
        #[doc = " A `<number>` value."]
        pub type StyleNumber = root::mozilla::StyleCSSFloat;
        #[doc = " \'none\'"]
        pub const StyleGenericRotate_Tag_None: root::mozilla::StyleGenericRotate_Tag = 0;
        #[doc = " \'<angle>\'"]
        pub const StyleGenericRotate_Tag_Rotate: root::mozilla::StyleGenericRotate_Tag = 0;
        #[doc = " \'<number>{3} <angle>\'"]
        pub const StyleGenericRotate_Tag_Rotate3D: root::mozilla::StyleGenericRotate_Tag = 0;
        pub type StyleGenericRotate_Tag = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericRotate_StyleRotate_Body<Angle> {
            pub _0: Angle,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<Angle>>,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericRotate_StyleRotate3D_Body<Number, Angle> {
            pub _0: Number,
            pub _1: Number,
            pub _2: Number,
            pub _3: Angle,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<Number>>,
            pub _phantom_1: ::std::marker::PhantomData<::std::cell::UnsafeCell<Angle>>,
        }
        #[repr(C)]
        #[derive(Copy, Clone)]
        pub struct StyleGenericRotate__bindgen_ty_1<Number, Angle> {
            pub rotate: root::__BindgenUnionField<
                root::mozilla::StyleGenericRotate_StyleRotate_Body<Angle>,
            >,
            pub rotate3_d: root::__BindgenUnionField<
                root::mozilla::StyleGenericRotate_StyleRotate3D_Body<Number, Angle>,
            >,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<Number>>,
            pub _phantom_1: ::std::marker::PhantomData<::std::cell::UnsafeCell<Angle>>,
        }
        #[doc = " A computed CSS `rotate`"]
        pub type StyleRotate = root::mozilla::StyleGenericRotate<
            root::mozilla::StyleNumber,
            root::mozilla::StyleAngle,
        >;
        #[doc = " \'none\'"]
        pub const StyleGenericScale_Tag_None: root::mozilla::StyleGenericScale_Tag = 0;
        #[doc = " \'<number>{1,2}\'"]
        pub const StyleGenericScale_Tag_Scale: root::mozilla::StyleGenericScale_Tag = 0;
        #[doc = " \'<number>{3}\'"]
        pub const StyleGenericScale_Tag_Scale3D: root::mozilla::StyleGenericScale_Tag = 0;
        pub type StyleGenericScale_Tag = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericScale_StyleScale_Body<Number> {
            pub _0: Number,
            pub _1: Number,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<Number>>,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericScale_StyleScale3D_Body<Number> {
            pub _0: Number,
            pub _1: Number,
            pub _2: Number,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<Number>>,
        }
        #[repr(C)]
        #[derive(Copy, Clone)]
        pub struct StyleGenericScale__bindgen_ty_1<Number> {
            pub scale:
                root::__BindgenUnionField<root::mozilla::StyleGenericScale_StyleScale_Body<Number>>,
            pub scale3_d: root::__BindgenUnionField<
                root::mozilla::StyleGenericScale_StyleScale3D_Body<Number>,
            >,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<Number>>,
        }
        #[doc = " A computed CSS `scale`"]
        pub type StyleScale = root::mozilla::StyleGenericScale<root::mozilla::StyleNumber>;
        #[doc = " A CSS integer value."]
        pub type StyleCSSInteger = i32;
        #[doc = " A `<integer>` value."]
        pub type StyleInteger = root::mozilla::StyleCSSInteger;
        #[doc = " A generic 2D transformation matrix."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericMatrix<T> {
            pub a: T,
            pub b: T,
            pub c: T,
            pub d: T,
            pub e: T,
            pub f: T,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericMatrix3D<T> {
            pub m11: T,
            pub m12: T,
            pub m13: T,
            pub m14: T,
            pub m21: T,
            pub m22: T,
            pub m23: T,
            pub m24: T,
            pub m31: T,
            pub m32: T,
            pub m33: T,
            pub m34: T,
            pub m41: T,
            pub m42: T,
            pub m43: T,
            pub m44: T,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
        }
        #[doc = " A single operation in a computed CSS `transform`"]
        pub type StyleTransformOperation = root::mozilla::StyleGenericTransformOperation<
            root::mozilla::StyleAngle,
            root::mozilla::StyleNumber,
            root::mozilla::StyleLength,
            root::mozilla::StyleInteger,
            root::mozilla::StyleLengthPercentage,
        >;
        #[doc = " A computed CSS `transform`"]
        pub type StyleTransform =
            root::mozilla::StyleGenericTransform<root::mozilla::StyleTransformOperation>;
        #[doc = " \'none\'"]
        pub const StyleGenericTranslate_Tag_None: root::mozilla::StyleGenericTranslate_Tag = 0;
        #[doc = " \'<length-percentage>\' or \'<length-percentage> <length-percentage>\'"]
        pub const StyleGenericTranslate_Tag_Translate: root::mozilla::StyleGenericTranslate_Tag = 0;
        #[doc = " \'<length-percentage> <length-percentage> <length>\'"]
        pub const StyleGenericTranslate_Tag_Translate3D: root::mozilla::StyleGenericTranslate_Tag =
            0;
        pub type StyleGenericTranslate_Tag = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericTranslate_StyleTranslate_Body<LengthPercentage> {
            pub _0: LengthPercentage,
            pub _1: LengthPercentage,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercentage>>,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericTranslate_StyleTranslate3D_Body<LengthPercentage, Length> {
            pub _0: LengthPercentage,
            pub _1: LengthPercentage,
            pub _2: Length,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercentage>>,
            pub _phantom_1: ::std::marker::PhantomData<::std::cell::UnsafeCell<Length>>,
        }
        #[repr(C)]
        #[derive(Copy, Clone)]
        pub struct StyleGenericTranslate__bindgen_ty_1<LengthPercentage, Length> {
            pub translate: root::__BindgenUnionField<
                root::mozilla::StyleGenericTranslate_StyleTranslate_Body<LengthPercentage>,
            >,
            pub translate3_d: root::__BindgenUnionField<
                root::mozilla::StyleGenericTranslate_StyleTranslate3D_Body<
                    LengthPercentage,
                    Length,
                >,
            >,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercentage>>,
            pub _phantom_1: ::std::marker::PhantomData<::std::cell::UnsafeCell<Length>>,
        }
        #[doc = " A computed CSS `translate`"]
        pub type StyleTranslate = root::mozilla::StyleGenericTranslate<
            root::mozilla::StyleLengthPercentage,
            root::mozilla::StyleLength,
        >;
        #[doc = " A wrapper of Non-negative values."]
        pub type StyleNonNegative<T> = T;
        #[doc = " A generic size, for `border-*-radius` longhand properties, or"]
        #[doc = " `border-spacing`."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleSize2D<L> {
            pub width: L,
            pub height: L,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<L>>,
        }
        #[doc = " A generic value for the `border-*-radius` longhand properties."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericBorderCornerRadius<L> {
            pub _0: root::mozilla::StyleSize2D<L>,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<L>>,
        }
        #[doc = " <https://drafts.csswg.org/css-shapes/#funcdef-inset>"]
        #[repr(C)]
        pub struct StyleInsetRect<LengthPercentage, NonNegativeLengthPercentage> {
            pub rect: root::mozilla::StyleRect<LengthPercentage>,
            pub round: root::mozilla::StyleGenericBorderRadius<NonNegativeLengthPercentage>,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercentage>>,
            pub _phantom_1:
                ::std::marker::PhantomData<::std::cell::UnsafeCell<NonNegativeLengthPercentage>>,
        }
        #[doc = " A generic type for representing a CSS [position](https://drafts.csswg.org/css-values/#position)."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericPosition<H, V> {
            #[doc = " The horizontal component of position."]
            pub horizontal: H,
            #[doc = " The vertical component of position."]
            pub vertical: V,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<H>>,
            pub _phantom_1: ::std::marker::PhantomData<::std::cell::UnsafeCell<V>>,
        }
        #[doc = " <https://drafts.csswg.org/css-shapes/#typedef-shape-radius>"]
        #[repr(C)]
        pub struct StyleGenericShapeRadius<NonNegativeLengthPercentage> {
            pub tag: root::mozilla::StyleGenericShapeRadius_Tag,
            pub __bindgen_anon_1:
                root::mozilla::StyleGenericShapeRadius__bindgen_ty_1<NonNegativeLengthPercentage>,
            pub _phantom_0:
                ::std::marker::PhantomData<::std::cell::UnsafeCell<NonNegativeLengthPercentage>>,
        }
        pub const StyleGenericShapeRadius_Tag_Length: root::mozilla::StyleGenericShapeRadius_Tag =
            0;
        pub const StyleGenericShapeRadius_Tag_ClosestSide:
            root::mozilla::StyleGenericShapeRadius_Tag = 0;
        pub const StyleGenericShapeRadius_Tag_FarthestSide:
            root::mozilla::StyleGenericShapeRadius_Tag = 0;
        pub type StyleGenericShapeRadius_Tag = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericShapeRadius_StyleLength_Body<NonNegativeLengthPercentage> {
            pub _0: NonNegativeLengthPercentage,
            pub _phantom_0:
                ::std::marker::PhantomData<::std::cell::UnsafeCell<NonNegativeLengthPercentage>>,
        }
        #[repr(C)]
        #[derive(Copy, Clone)]
        pub struct StyleGenericShapeRadius__bindgen_ty_1<NonNegativeLengthPercentage> {
            pub length: root::__BindgenUnionField<
                root::mozilla::StyleGenericShapeRadius_StyleLength_Body<
                    NonNegativeLengthPercentage,
                >,
            >,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0:
                ::std::marker::PhantomData<::std::cell::UnsafeCell<NonNegativeLengthPercentage>>,
        }
        #[doc = " <https://drafts.csswg.org/css-shapes/#funcdef-circle>"]
        #[repr(C)]
        pub struct StyleCircle<H, V, NonNegativeLengthPercentage> {
            pub position: root::mozilla::StyleGenericPosition<H, V>,
            pub radius: root::mozilla::StyleGenericShapeRadius<NonNegativeLengthPercentage>,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<H>>,
            pub _phantom_1: ::std::marker::PhantomData<::std::cell::UnsafeCell<V>>,
            pub _phantom_2:
                ::std::marker::PhantomData<::std::cell::UnsafeCell<NonNegativeLengthPercentage>>,
        }
        #[doc = " <https://drafts.csswg.org/css-shapes/#funcdef-ellipse>"]
        #[repr(C)]
        pub struct StyleEllipse<H, V, NonNegativeLengthPercentage> {
            pub position: root::mozilla::StyleGenericPosition<H, V>,
            pub semiaxis_x: root::mozilla::StyleGenericShapeRadius<NonNegativeLengthPercentage>,
            pub semiaxis_y: root::mozilla::StyleGenericShapeRadius<NonNegativeLengthPercentage>,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<H>>,
            pub _phantom_1: ::std::marker::PhantomData<::std::cell::UnsafeCell<V>>,
            pub _phantom_2:
                ::std::marker::PhantomData<::std::cell::UnsafeCell<NonNegativeLengthPercentage>>,
        }
        #[doc = " Coordinates for Polygon."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StylePolygonCoord<LengthPercentage> {
            pub _0: LengthPercentage,
            pub _1: LengthPercentage,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercentage>>,
        }
        #[doc = " A generic type for representing the `polygon()` function"]
        #[doc = " <https://drafts.csswg.org/css-shapes/#funcdef-polygon>"]
        #[repr(C)]
        pub struct StyleGenericPolygon<LengthPercentage> {
            #[doc = " The filling rule for a polygon."]
            pub fill: root::mozilla::StyleFillRule,
            #[doc = " A collection of (x, y) coordinates to draw the polygon."]
            pub coordinates:
                root::mozilla::StyleOwnedSlice<root::mozilla::StylePolygonCoord<LengthPercentage>>,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercentage>>,
        }
        pub const StyleGenericBasicShape_Tag_Inset: root::mozilla::StyleGenericBasicShape_Tag = 0;
        pub const StyleGenericBasicShape_Tag_Circle: root::mozilla::StyleGenericBasicShape_Tag = 0;
        pub const StyleGenericBasicShape_Tag_Ellipse: root::mozilla::StyleGenericBasicShape_Tag = 0;
        pub const StyleGenericBasicShape_Tag_Polygon: root::mozilla::StyleGenericBasicShape_Tag = 0;
        pub type StyleGenericBasicShape_Tag = u8;
        #[repr(C)]
        pub struct StyleGenericBasicShape_StyleInset_Body<
            LengthPercentage,
            NonNegativeLengthPercentage,
        > {
            pub _0: root::mozilla::StyleInsetRect<LengthPercentage, NonNegativeLengthPercentage>,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercentage>>,
            pub _phantom_1:
                ::std::marker::PhantomData<::std::cell::UnsafeCell<NonNegativeLengthPercentage>>,
        }
        #[repr(C)]
        pub struct StyleGenericBasicShape_StyleCircle_Body<H, V, NonNegativeLengthPercentage> {
            pub _0: root::mozilla::StyleCircle<H, V, NonNegativeLengthPercentage>,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<H>>,
            pub _phantom_1: ::std::marker::PhantomData<::std::cell::UnsafeCell<V>>,
            pub _phantom_2:
                ::std::marker::PhantomData<::std::cell::UnsafeCell<NonNegativeLengthPercentage>>,
        }
        #[repr(C)]
        pub struct StyleGenericBasicShape_StyleEllipse_Body<H, V, NonNegativeLengthPercentage> {
            pub _0: root::mozilla::StyleEllipse<H, V, NonNegativeLengthPercentage>,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<H>>,
            pub _phantom_1: ::std::marker::PhantomData<::std::cell::UnsafeCell<V>>,
            pub _phantom_2:
                ::std::marker::PhantomData<::std::cell::UnsafeCell<NonNegativeLengthPercentage>>,
        }
        #[repr(C)]
        pub struct StyleGenericBasicShape_StylePolygon_Body<LengthPercentage> {
            pub _0: root::mozilla::StyleGenericPolygon<LengthPercentage>,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercentage>>,
        }
        #[repr(C)]
        pub struct StyleGenericBasicShape__bindgen_ty_1<
            H,
            V,
            LengthPercentage,
            NonNegativeLengthPercentage,
        > {
            pub inset: root::__BindgenUnionField<
                root::mozilla::StyleGenericBasicShape_StyleInset_Body<
                    LengthPercentage,
                    NonNegativeLengthPercentage,
                >,
            >,
            pub circle: root::__BindgenUnionField<
                root::mozilla::StyleGenericBasicShape_StyleCircle_Body<
                    H,
                    V,
                    NonNegativeLengthPercentage,
                >,
            >,
            pub ellipse: root::__BindgenUnionField<
                root::mozilla::StyleGenericBasicShape_StyleEllipse_Body<
                    H,
                    V,
                    NonNegativeLengthPercentage,
                >,
            >,
            pub polygon: root::__BindgenUnionField<
                root::mozilla::StyleGenericBasicShape_StylePolygon_Body<LengthPercentage>,
            >,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<H>>,
            pub _phantom_1: ::std::marker::PhantomData<::std::cell::UnsafeCell<V>>,
            pub _phantom_2: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercentage>>,
            pub _phantom_3:
                ::std::marker::PhantomData<::std::cell::UnsafeCell<NonNegativeLengthPercentage>>,
        }
        #[doc = " A computed basic shape."]
        pub type StyleBasicShape = root::mozilla::StyleGenericBasicShape<
            root::mozilla::StyleLengthPercentage,
            root::mozilla::StyleLengthPercentage,
            root::mozilla::StyleLengthPercentage,
            root::mozilla::StyleNonNegativeLengthPercentage,
        >;
        #[doc = " A quote pair."]
        #[repr(C)]
        pub struct StyleQuotePair {
            #[doc = " The opening quote."]
            pub opening: root::mozilla::StyleOwnedStr,
            #[doc = " The closing quote."]
            pub closing: root::mozilla::StyleOwnedStr,
        }
        #[test]
        fn bindgen_test_layout_StyleQuotePair() {
            assert_eq!(
                ::std::mem::size_of::<StyleQuotePair>(),
                32usize,
                concat!("Size of: ", stringify!(StyleQuotePair))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleQuotePair>(),
                8usize,
                concat!("Alignment of ", stringify!(StyleQuotePair))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<StyleQuotePair>())).opening as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleQuotePair),
                    "::",
                    stringify!(opening)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<StyleQuotePair>())).closing as *const _ as usize },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleQuotePair),
                    "::",
                    stringify!(closing)
                )
            );
        }
        #[doc = " A computed value for the `border-radius` property."]
        pub type StyleBorderRadius = root::mozilla::StyleGenericBorderRadius<
            root::mozilla::StyleNonNegativeLengthPercentage,
        >;
        #[doc = " auto"]
        pub const StyleOutlineStyle_Tag_Auto: root::mozilla::StyleOutlineStyle_Tag = 0;
        #[doc = " <border-style>"]
        pub const StyleOutlineStyle_Tag_BorderStyle: root::mozilla::StyleOutlineStyle_Tag = 1;
        pub type StyleOutlineStyle_Tag = u8;
        #[repr(C)]
        pub struct StyleOutlineStyle_StyleBorderStyle_Body {
            pub _0: root::mozilla::StyleBorderStyle,
        }
        #[test]
        fn bindgen_test_layout_StyleOutlineStyle_StyleBorderStyle_Body() {
            assert_eq!(
                ::std::mem::size_of::<StyleOutlineStyle_StyleBorderStyle_Body>(),
                1usize,
                concat!(
                    "Size of: ",
                    stringify!(StyleOutlineStyle_StyleBorderStyle_Body)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<StyleOutlineStyle_StyleBorderStyle_Body>(),
                1usize,
                concat!(
                    "Alignment of ",
                    stringify!(StyleOutlineStyle_StyleBorderStyle_Body)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleOutlineStyle_StyleBorderStyle_Body>()))._0
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleOutlineStyle_StyleBorderStyle_Body),
                    "::",
                    stringify!(_0)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct StyleOutlineStyle__bindgen_ty_1 {
            pub border_style:
                root::__BindgenUnionField<root::mozilla::StyleOutlineStyle_StyleBorderStyle_Body>,
            pub bindgen_union_field: u8,
        }
        #[test]
        fn bindgen_test_layout_StyleOutlineStyle__bindgen_ty_1() {
            assert_eq!(
                ::std::mem::size_of::<StyleOutlineStyle__bindgen_ty_1>(),
                1usize,
                concat!("Size of: ", stringify!(StyleOutlineStyle__bindgen_ty_1))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleOutlineStyle__bindgen_ty_1>(),
                1usize,
                concat!("Alignment of ", stringify!(StyleOutlineStyle__bindgen_ty_1))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleOutlineStyle__bindgen_ty_1>())).border_style
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleOutlineStyle__bindgen_ty_1),
                    "::",
                    stringify!(border_style)
                )
            );
        }
        #[doc = " The path coord type."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleCoordPair {
            pub _0: root::mozilla::StyleCSSFloat,
            pub _1: root::mozilla::StyleCSSFloat,
        }
        #[test]
        fn bindgen_test_layout_StyleCoordPair() {
            assert_eq!(
                ::std::mem::size_of::<StyleCoordPair>(),
                8usize,
                concat!("Size of: ", stringify!(StyleCoordPair))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleCoordPair>(),
                4usize,
                concat!("Alignment of ", stringify!(StyleCoordPair))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<StyleCoordPair>()))._0 as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleCoordPair),
                    "::",
                    stringify!(_0)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<StyleCoordPair>()))._1 as *const _ as usize },
                4usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleCoordPair),
                    "::",
                    stringify!(_1)
                )
            );
        }
        #[doc = " The EllipticalArc flag type."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleArcFlag {
            pub _0: bool,
        }
        #[test]
        fn bindgen_test_layout_StyleArcFlag() {
            assert_eq!(
                ::std::mem::size_of::<StyleArcFlag>(),
                1usize,
                concat!("Size of: ", stringify!(StyleArcFlag))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleArcFlag>(),
                1usize,
                concat!("Alignment of ", stringify!(StyleArcFlag))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<StyleArcFlag>()))._0 as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleArcFlag),
                    "::",
                    stringify!(_0)
                )
            );
        }
        #[doc = " The unknown type."]
        #[doc = " https://www.w3.org/TR/SVG/paths.html#__svg__SVGPathSeg__PATHSEG_UNKNOWN"]
        pub const StylePathCommand_Tag_Unknown: root::mozilla::StylePathCommand_Tag = 0;
        #[doc = " The \"moveto\" command."]
        pub const StylePathCommand_Tag_MoveTo: root::mozilla::StylePathCommand_Tag = 1;
        #[doc = " The \"lineto\" command."]
        pub const StylePathCommand_Tag_LineTo: root::mozilla::StylePathCommand_Tag = 2;
        #[doc = " The horizontal \"lineto\" command."]
        pub const StylePathCommand_Tag_HorizontalLineTo: root::mozilla::StylePathCommand_Tag = 3;
        #[doc = " The vertical \"lineto\" command."]
        pub const StylePathCommand_Tag_VerticalLineTo: root::mozilla::StylePathCommand_Tag = 4;
        #[doc = " The cubic B\u{e9}zier curve command."]
        pub const StylePathCommand_Tag_CurveTo: root::mozilla::StylePathCommand_Tag = 5;
        #[doc = " The smooth curve command."]
        pub const StylePathCommand_Tag_SmoothCurveTo: root::mozilla::StylePathCommand_Tag = 6;
        #[doc = " The quadratic B\u{e9}zier curve command."]
        pub const StylePathCommand_Tag_QuadBezierCurveTo: root::mozilla::StylePathCommand_Tag = 7;
        #[doc = " The smooth quadratic B\u{e9}zier curve command."]
        pub const StylePathCommand_Tag_SmoothQuadBezierCurveTo:
            root::mozilla::StylePathCommand_Tag = 8;
        #[doc = " The elliptical arc curve command."]
        pub const StylePathCommand_Tag_EllipticalArc: root::mozilla::StylePathCommand_Tag = 9;
        #[doc = " The \"closepath\" command."]
        pub const StylePathCommand_Tag_ClosePath: root::mozilla::StylePathCommand_Tag = 10;
        pub type StylePathCommand_Tag = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StylePathCommand_StyleMoveTo_Body {
            pub point: root::mozilla::StyleCoordPair,
            pub absolute: root::mozilla::StyleIsAbsolute,
        }
        #[test]
        fn bindgen_test_layout_StylePathCommand_StyleMoveTo_Body() {
            assert_eq!(
                ::std::mem::size_of::<StylePathCommand_StyleMoveTo_Body>(),
                12usize,
                concat!("Size of: ", stringify!(StylePathCommand_StyleMoveTo_Body))
            );
            assert_eq!(
                ::std::mem::align_of::<StylePathCommand_StyleMoveTo_Body>(),
                4usize,
                concat!(
                    "Alignment of ",
                    stringify!(StylePathCommand_StyleMoveTo_Body)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleMoveTo_Body>())).point as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleMoveTo_Body),
                    "::",
                    stringify!(point)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleMoveTo_Body>())).absolute
                        as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleMoveTo_Body),
                    "::",
                    stringify!(absolute)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StylePathCommand_StyleLineTo_Body {
            pub point: root::mozilla::StyleCoordPair,
            pub absolute: root::mozilla::StyleIsAbsolute,
        }
        #[test]
        fn bindgen_test_layout_StylePathCommand_StyleLineTo_Body() {
            assert_eq!(
                ::std::mem::size_of::<StylePathCommand_StyleLineTo_Body>(),
                12usize,
                concat!("Size of: ", stringify!(StylePathCommand_StyleLineTo_Body))
            );
            assert_eq!(
                ::std::mem::align_of::<StylePathCommand_StyleLineTo_Body>(),
                4usize,
                concat!(
                    "Alignment of ",
                    stringify!(StylePathCommand_StyleLineTo_Body)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleLineTo_Body>())).point as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleLineTo_Body),
                    "::",
                    stringify!(point)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleLineTo_Body>())).absolute
                        as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleLineTo_Body),
                    "::",
                    stringify!(absolute)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StylePathCommand_StyleHorizontalLineTo_Body {
            pub x: root::mozilla::StyleCSSFloat,
            pub absolute: root::mozilla::StyleIsAbsolute,
        }
        #[test]
        fn bindgen_test_layout_StylePathCommand_StyleHorizontalLineTo_Body() {
            assert_eq!(
                ::std::mem::size_of::<StylePathCommand_StyleHorizontalLineTo_Body>(),
                8usize,
                concat!(
                    "Size of: ",
                    stringify!(StylePathCommand_StyleHorizontalLineTo_Body)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<StylePathCommand_StyleHorizontalLineTo_Body>(),
                4usize,
                concat!(
                    "Alignment of ",
                    stringify!(StylePathCommand_StyleHorizontalLineTo_Body)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleHorizontalLineTo_Body>())).x
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleHorizontalLineTo_Body),
                    "::",
                    stringify!(x)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleHorizontalLineTo_Body>())).absolute
                        as *const _ as usize
                },
                4usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleHorizontalLineTo_Body),
                    "::",
                    stringify!(absolute)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StylePathCommand_StyleVerticalLineTo_Body {
            pub y: root::mozilla::StyleCSSFloat,
            pub absolute: root::mozilla::StyleIsAbsolute,
        }
        #[test]
        fn bindgen_test_layout_StylePathCommand_StyleVerticalLineTo_Body() {
            assert_eq!(
                ::std::mem::size_of::<StylePathCommand_StyleVerticalLineTo_Body>(),
                8usize,
                concat!(
                    "Size of: ",
                    stringify!(StylePathCommand_StyleVerticalLineTo_Body)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<StylePathCommand_StyleVerticalLineTo_Body>(),
                4usize,
                concat!(
                    "Alignment of ",
                    stringify!(StylePathCommand_StyleVerticalLineTo_Body)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleVerticalLineTo_Body>())).y
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleVerticalLineTo_Body),
                    "::",
                    stringify!(y)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleVerticalLineTo_Body>())).absolute
                        as *const _ as usize
                },
                4usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleVerticalLineTo_Body),
                    "::",
                    stringify!(absolute)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StylePathCommand_StyleCurveTo_Body {
            pub control1: root::mozilla::StyleCoordPair,
            pub control2: root::mozilla::StyleCoordPair,
            pub point: root::mozilla::StyleCoordPair,
            pub absolute: root::mozilla::StyleIsAbsolute,
        }
        #[test]
        fn bindgen_test_layout_StylePathCommand_StyleCurveTo_Body() {
            assert_eq!(
                ::std::mem::size_of::<StylePathCommand_StyleCurveTo_Body>(),
                28usize,
                concat!("Size of: ", stringify!(StylePathCommand_StyleCurveTo_Body))
            );
            assert_eq!(
                ::std::mem::align_of::<StylePathCommand_StyleCurveTo_Body>(),
                4usize,
                concat!(
                    "Alignment of ",
                    stringify!(StylePathCommand_StyleCurveTo_Body)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleCurveTo_Body>())).control1
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleCurveTo_Body),
                    "::",
                    stringify!(control1)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleCurveTo_Body>())).control2
                        as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleCurveTo_Body),
                    "::",
                    stringify!(control2)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleCurveTo_Body>())).point as *const _
                        as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleCurveTo_Body),
                    "::",
                    stringify!(point)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleCurveTo_Body>())).absolute
                        as *const _ as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleCurveTo_Body),
                    "::",
                    stringify!(absolute)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StylePathCommand_StyleSmoothCurveTo_Body {
            pub control2: root::mozilla::StyleCoordPair,
            pub point: root::mozilla::StyleCoordPair,
            pub absolute: root::mozilla::StyleIsAbsolute,
        }
        #[test]
        fn bindgen_test_layout_StylePathCommand_StyleSmoothCurveTo_Body() {
            assert_eq!(
                ::std::mem::size_of::<StylePathCommand_StyleSmoothCurveTo_Body>(),
                20usize,
                concat!(
                    "Size of: ",
                    stringify!(StylePathCommand_StyleSmoothCurveTo_Body)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<StylePathCommand_StyleSmoothCurveTo_Body>(),
                4usize,
                concat!(
                    "Alignment of ",
                    stringify!(StylePathCommand_StyleSmoothCurveTo_Body)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleSmoothCurveTo_Body>())).control2
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleSmoothCurveTo_Body),
                    "::",
                    stringify!(control2)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleSmoothCurveTo_Body>())).point
                        as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleSmoothCurveTo_Body),
                    "::",
                    stringify!(point)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleSmoothCurveTo_Body>())).absolute
                        as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleSmoothCurveTo_Body),
                    "::",
                    stringify!(absolute)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StylePathCommand_StyleQuadBezierCurveTo_Body {
            pub control1: root::mozilla::StyleCoordPair,
            pub point: root::mozilla::StyleCoordPair,
            pub absolute: root::mozilla::StyleIsAbsolute,
        }
        #[test]
        fn bindgen_test_layout_StylePathCommand_StyleQuadBezierCurveTo_Body() {
            assert_eq!(
                ::std::mem::size_of::<StylePathCommand_StyleQuadBezierCurveTo_Body>(),
                20usize,
                concat!(
                    "Size of: ",
                    stringify!(StylePathCommand_StyleQuadBezierCurveTo_Body)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<StylePathCommand_StyleQuadBezierCurveTo_Body>(),
                4usize,
                concat!(
                    "Alignment of ",
                    stringify!(StylePathCommand_StyleQuadBezierCurveTo_Body)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleQuadBezierCurveTo_Body>()))
                        .control1 as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleQuadBezierCurveTo_Body),
                    "::",
                    stringify!(control1)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleQuadBezierCurveTo_Body>())).point
                        as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleQuadBezierCurveTo_Body),
                    "::",
                    stringify!(point)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleQuadBezierCurveTo_Body>()))
                        .absolute as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleQuadBezierCurveTo_Body),
                    "::",
                    stringify!(absolute)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StylePathCommand_StyleSmoothQuadBezierCurveTo_Body {
            pub point: root::mozilla::StyleCoordPair,
            pub absolute: root::mozilla::StyleIsAbsolute,
        }
        #[test]
        fn bindgen_test_layout_StylePathCommand_StyleSmoothQuadBezierCurveTo_Body() {
            assert_eq!(
                ::std::mem::size_of::<StylePathCommand_StyleSmoothQuadBezierCurveTo_Body>(),
                12usize,
                concat!(
                    "Size of: ",
                    stringify!(StylePathCommand_StyleSmoothQuadBezierCurveTo_Body)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<StylePathCommand_StyleSmoothQuadBezierCurveTo_Body>(),
                4usize,
                concat!(
                    "Alignment of ",
                    stringify!(StylePathCommand_StyleSmoothQuadBezierCurveTo_Body)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleSmoothQuadBezierCurveTo_Body>()))
                        .point as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleSmoothQuadBezierCurveTo_Body),
                    "::",
                    stringify!(point)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleSmoothQuadBezierCurveTo_Body>()))
                        .absolute as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleSmoothQuadBezierCurveTo_Body),
                    "::",
                    stringify!(absolute)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StylePathCommand_StyleEllipticalArc_Body {
            pub rx: root::mozilla::StyleCSSFloat,
            pub ry: root::mozilla::StyleCSSFloat,
            pub angle: root::mozilla::StyleCSSFloat,
            pub large_arc_flag: root::mozilla::StyleArcFlag,
            pub sweep_flag: root::mozilla::StyleArcFlag,
            pub point: root::mozilla::StyleCoordPair,
            pub absolute: root::mozilla::StyleIsAbsolute,
        }
        #[test]
        fn bindgen_test_layout_StylePathCommand_StyleEllipticalArc_Body() {
            assert_eq!(
                ::std::mem::size_of::<StylePathCommand_StyleEllipticalArc_Body>(),
                28usize,
                concat!(
                    "Size of: ",
                    stringify!(StylePathCommand_StyleEllipticalArc_Body)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<StylePathCommand_StyleEllipticalArc_Body>(),
                4usize,
                concat!(
                    "Alignment of ",
                    stringify!(StylePathCommand_StyleEllipticalArc_Body)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleEllipticalArc_Body>())).rx
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleEllipticalArc_Body),
                    "::",
                    stringify!(rx)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleEllipticalArc_Body>())).ry
                        as *const _ as usize
                },
                4usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleEllipticalArc_Body),
                    "::",
                    stringify!(ry)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleEllipticalArc_Body>())).angle
                        as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleEllipticalArc_Body),
                    "::",
                    stringify!(angle)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleEllipticalArc_Body>()))
                        .large_arc_flag as *const _ as usize
                },
                12usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleEllipticalArc_Body),
                    "::",
                    stringify!(large_arc_flag)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleEllipticalArc_Body>())).sweep_flag
                        as *const _ as usize
                },
                13usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleEllipticalArc_Body),
                    "::",
                    stringify!(sweep_flag)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleEllipticalArc_Body>())).point
                        as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleEllipticalArc_Body),
                    "::",
                    stringify!(point)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand_StyleEllipticalArc_Body>())).absolute
                        as *const _ as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand_StyleEllipticalArc_Body),
                    "::",
                    stringify!(absolute)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StylePathCommand__bindgen_ty_1 {
            pub move_to:
                root::__BindgenUnionField<root::mozilla::StylePathCommand_StyleMoveTo_Body>,
            pub line_to:
                root::__BindgenUnionField<root::mozilla::StylePathCommand_StyleLineTo_Body>,
            pub horizontal_line_to: root::__BindgenUnionField<
                root::mozilla::StylePathCommand_StyleHorizontalLineTo_Body,
            >,
            pub vertical_line_to:
                root::__BindgenUnionField<root::mozilla::StylePathCommand_StyleVerticalLineTo_Body>,
            pub curve_to:
                root::__BindgenUnionField<root::mozilla::StylePathCommand_StyleCurveTo_Body>,
            pub smooth_curve_to:
                root::__BindgenUnionField<root::mozilla::StylePathCommand_StyleSmoothCurveTo_Body>,
            pub quad_bezier_curve_to: root::__BindgenUnionField<
                root::mozilla::StylePathCommand_StyleQuadBezierCurveTo_Body,
            >,
            pub smooth_quad_bezier_curve_to: root::__BindgenUnionField<
                root::mozilla::StylePathCommand_StyleSmoothQuadBezierCurveTo_Body,
            >,
            pub elliptical_arc:
                root::__BindgenUnionField<root::mozilla::StylePathCommand_StyleEllipticalArc_Body>,
            pub bindgen_union_field: [u32; 7usize],
        }
        #[test]
        fn bindgen_test_layout_StylePathCommand__bindgen_ty_1() {
            assert_eq!(
                ::std::mem::size_of::<StylePathCommand__bindgen_ty_1>(),
                28usize,
                concat!("Size of: ", stringify!(StylePathCommand__bindgen_ty_1))
            );
            assert_eq!(
                ::std::mem::align_of::<StylePathCommand__bindgen_ty_1>(),
                4usize,
                concat!("Alignment of ", stringify!(StylePathCommand__bindgen_ty_1))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand__bindgen_ty_1>())).move_to as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand__bindgen_ty_1),
                    "::",
                    stringify!(move_to)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand__bindgen_ty_1>())).line_to as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand__bindgen_ty_1),
                    "::",
                    stringify!(line_to)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand__bindgen_ty_1>())).horizontal_line_to
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand__bindgen_ty_1),
                    "::",
                    stringify!(horizontal_line_to)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand__bindgen_ty_1>())).vertical_line_to
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand__bindgen_ty_1),
                    "::",
                    stringify!(vertical_line_to)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand__bindgen_ty_1>())).curve_to as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand__bindgen_ty_1),
                    "::",
                    stringify!(curve_to)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand__bindgen_ty_1>())).smooth_curve_to
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand__bindgen_ty_1),
                    "::",
                    stringify!(smooth_curve_to)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand__bindgen_ty_1>())).quad_bezier_curve_to
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand__bindgen_ty_1),
                    "::",
                    stringify!(quad_bezier_curve_to)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand__bindgen_ty_1>()))
                        .smooth_quad_bezier_curve_to as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand__bindgen_ty_1),
                    "::",
                    stringify!(smooth_quad_bezier_curve_to)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StylePathCommand__bindgen_ty_1>())).elliptical_arc
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StylePathCommand__bindgen_ty_1),
                    "::",
                    stringify!(elliptical_arc)
                )
            );
        }
        pub const StyleGenericLengthPercentageOrAuto_Tag_LengthPercentage:
            root::mozilla::StyleGenericLengthPercentageOrAuto_Tag = 0;
        pub const StyleGenericLengthPercentageOrAuto_Tag_Auto:
            root::mozilla::StyleGenericLengthPercentageOrAuto_Tag = 0;
        pub type StyleGenericLengthPercentageOrAuto_Tag = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericLengthPercentageOrAuto_StyleLengthPercentage_Body<LengthPercent> {
            pub _0: LengthPercent,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercent>>,
        }
        #[repr(C)]
        #[derive(Copy, Clone)]
        pub struct StyleGenericLengthPercentageOrAuto__bindgen_ty_1<LengthPercent> {
            pub length_percentage: root::__BindgenUnionField<
                root::mozilla::StyleGenericLengthPercentageOrAuto_StyleLengthPercentage_Body<
                    LengthPercent,
                >,
            >,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercent>>,
        }
        #[test]
        fn __bindgen_test_layout_StyleNonNegative_open0_StyleCSSFloat_close0_instantiation() {
            assert_eq!(
                ::std::mem::size_of::<root::mozilla::StyleNonNegative<root::mozilla::StyleCSSFloat>>(
                ),
                4usize,
                concat!(
                    "Size of template specialization: ",
                    stringify!(root::mozilla::StyleNonNegative<root::mozilla::StyleCSSFloat>)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<root::mozilla::StyleNonNegative<root::mozilla::StyleCSSFloat>>(
                ),
                4usize,
                concat!(
                    "Alignment of template specialization: ",
                    stringify!(root::mozilla::StyleNonNegative<root::mozilla::StyleCSSFloat>)
                )
            );
        }
        #[doc = " `normal`"]
        pub const StyleGenericLineHeight_Tag_Normal: root::mozilla::StyleGenericLineHeight_Tag = 0;
        #[doc = " `-moz-block-height`"]
        pub const StyleGenericLineHeight_Tag_MozBlockHeight:
            root::mozilla::StyleGenericLineHeight_Tag = 0;
        #[doc = " `<number>`"]
        pub const StyleGenericLineHeight_Tag_Number: root::mozilla::StyleGenericLineHeight_Tag = 0;
        #[doc = " `<length-percentage>`"]
        pub const StyleGenericLineHeight_Tag_Length: root::mozilla::StyleGenericLineHeight_Tag = 0;
        pub type StyleGenericLineHeight_Tag = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericLineHeight_StyleNumber_Body<N> {
            pub _0: N,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<N>>,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericLineHeight_StyleLength_Body<L> {
            pub _0: L,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<L>>,
        }
        #[repr(C)]
        #[derive(Copy, Clone)]
        pub struct StyleGenericLineHeight__bindgen_ty_1<N, L> {
            pub number: root::__BindgenUnionField<
                root::mozilla::StyleGenericLineHeight_StyleNumber_Body<N>,
            >,
            pub length: root::__BindgenUnionField<
                root::mozilla::StyleGenericLineHeight_StyleLength_Body<L>,
            >,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<N>>,
            pub _phantom_1: ::std::marker::PhantomData<::std::cell::UnsafeCell<L>>,
        }
        #[doc = " A computed value for the `line-height` property."]
        pub type StyleLineHeight = root::mozilla::StyleGenericLineHeight<
            root::mozilla::StyleNonNegativeNumber,
            root::mozilla::StyleNonNegativeLength,
        >;
        pub const StyleGenericLengthPercentageOrNormal_Tag_LengthPercentage:
            root::mozilla::StyleGenericLengthPercentageOrNormal_Tag = 0;
        pub const StyleGenericLengthPercentageOrNormal_Tag_Normal:
            root::mozilla::StyleGenericLengthPercentageOrNormal_Tag = 0;
        pub type StyleGenericLengthPercentageOrNormal_Tag = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericLengthPercentageOrNormal_StyleLengthPercentage_Body<LengthPercent> {
            pub _0: LengthPercent,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercent>>,
        }
        #[repr(C)]
        #[derive(Copy, Clone)]
        pub struct StyleGenericLengthPercentageOrNormal__bindgen_ty_1<LengthPercent> {
            pub length_percentage: root::__BindgenUnionField<
                root::mozilla::StyleGenericLengthPercentageOrNormal_StyleLengthPercentage_Body<
                    LengthPercent,
                >,
            >,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercent>>,
        }
        #[doc = " Either a computed NonNegativeLengthPercentage or the `normal` keyword."]
        pub type StyleNonNegativeLengthPercentageOrNormal =
            root::mozilla::StyleGenericLengthPercentageOrNormal<
                root::mozilla::StyleNonNegativeLengthPercentage,
            >;
        #[doc = " Either a non-negative `<length>` or the `auto` keyword."]
        pub type StyleNonNegativeLengthOrAuto = root::mozilla::StyleGenericLengthPercentageOrAuto<
            root::mozilla::StyleNonNegativeLength,
        >;
        pub const StyleGenericSize_Tag_LengthPercentage: root::mozilla::StyleGenericSize_Tag = 0;
        pub const StyleGenericSize_Tag_Auto: root::mozilla::StyleGenericSize_Tag = 0;
        pub const StyleGenericSize_Tag_ExtremumLength: root::mozilla::StyleGenericSize_Tag = 0;
        pub type StyleGenericSize_Tag = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericSize_StyleLengthPercentage_Body<LengthPercent> {
            pub _0: LengthPercent,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercent>>,
        }
        #[repr(C)]
        pub struct StyleGenericSize_StyleExtremumLength_Body {
            pub _0: root::mozilla::StyleExtremumLength,
        }
        #[repr(C)]
        pub struct StyleGenericSize__bindgen_ty_1<LengthPercent> {
            pub length_percentage: root::__BindgenUnionField<
                root::mozilla::StyleGenericSize_StyleLengthPercentage_Body<LengthPercent>,
            >,
            pub extremum_length:
                root::__BindgenUnionField<root::mozilla::StyleGenericSize_StyleExtremumLength_Body>,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercent>>,
        }
        pub const StyleGenericMaxSize_Tag_LengthPercentage: root::mozilla::StyleGenericMaxSize_Tag =
            0;
        pub const StyleGenericMaxSize_Tag_None: root::mozilla::StyleGenericMaxSize_Tag = 0;
        pub const StyleGenericMaxSize_Tag_ExtremumLength: root::mozilla::StyleGenericMaxSize_Tag =
            0;
        pub type StyleGenericMaxSize_Tag = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericMaxSize_StyleLengthPercentage_Body<LengthPercent> {
            pub _0: LengthPercent,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercent>>,
        }
        #[repr(C)]
        pub struct StyleGenericMaxSize_StyleExtremumLength_Body {
            pub _0: root::mozilla::StyleExtremumLength,
        }
        #[repr(C)]
        pub struct StyleGenericMaxSize__bindgen_ty_1<LengthPercent> {
            pub length_percentage: root::__BindgenUnionField<
                root::mozilla::StyleGenericMaxSize_StyleLengthPercentage_Body<LengthPercent>,
            >,
            pub extremum_length: root::__BindgenUnionField<
                root::mozilla::StyleGenericMaxSize_StyleExtremumLength_Body,
            >,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercent>>,
        }
        #[doc = " `content`"]
        pub const StyleGenericFlexBasis_Tag_Content: root::mozilla::StyleGenericFlexBasis_Tag = 0;
        #[doc = " `<width>`"]
        pub const StyleGenericFlexBasis_Tag_Size: root::mozilla::StyleGenericFlexBasis_Tag = 0;
        pub type StyleGenericFlexBasis_Tag = i32;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericFlexBasis_StyleSize_Body<S> {
            pub _0: S,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<S>>,
        }
        #[repr(C)]
        #[derive(Copy, Clone)]
        pub struct StyleGenericFlexBasis__bindgen_ty_1<S> {
            pub size:
                root::__BindgenUnionField<root::mozilla::StyleGenericFlexBasis_StyleSize_Body<S>>,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<S>>,
        }
        #[doc = " The computed value of a CSS horizontal position."]
        pub type StyleHorizontalPosition = root::mozilla::StyleLengthPercentage;
        #[doc = " The computed value of a CSS vertical position."]
        pub type StyleVerticalPosition = root::mozilla::StyleLengthPercentage;
        #[doc = " `<width> <height>`"]
        pub const StyleGenericBackgroundSize_Tag_ExplicitSize:
            root::mozilla::StyleGenericBackgroundSize_Tag = 0;
        #[doc = " `cover`"]
        pub const StyleGenericBackgroundSize_Tag_Cover:
            root::mozilla::StyleGenericBackgroundSize_Tag = 0;
        #[doc = " `contain`"]
        pub const StyleGenericBackgroundSize_Tag_Contain:
            root::mozilla::StyleGenericBackgroundSize_Tag = 0;
        pub type StyleGenericBackgroundSize_Tag = u8;
        #[repr(C)]
        pub struct StyleGenericBackgroundSize_StyleExplicitSize_Body<LengthPercent> {
            #[doc = " Explicit width."]
            pub width: root::mozilla::StyleGenericLengthPercentageOrAuto<LengthPercent>,
            #[doc = " Explicit height."]
            #[doc = " NOTE(emilio): We should probably simplify all these in case `width`"]
            #[doc = " and `height` are the same, but all other browsers agree on only"]
            #[doc = " special-casing `auto`."]
            pub height: root::mozilla::StyleGenericLengthPercentageOrAuto<LengthPercent>,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercent>>,
        }
        #[repr(C)]
        pub struct StyleGenericBackgroundSize__bindgen_ty_1<LengthPercent> {
            pub explicit_size: root::__BindgenUnionField<
                root::mozilla::StyleGenericBackgroundSize_StyleExplicitSize_Body<LengthPercent>,
            >,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercent>>,
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct StyleNumberOrPercentage {
            pub tag: root::mozilla::StyleNumberOrPercentage_Tag,
            pub __bindgen_anon_1: root::mozilla::StyleNumberOrPercentage__bindgen_ty_1,
        }
        pub const StyleNumberOrPercentage_Tag_Percentage:
            root::mozilla::StyleNumberOrPercentage_Tag = 0;
        pub const StyleNumberOrPercentage_Tag_Number: root::mozilla::StyleNumberOrPercentage_Tag =
            1;
        pub type StyleNumberOrPercentage_Tag = u8;
        #[repr(C)]
        pub struct StyleNumberOrPercentage_StylePercentage_Body {
            pub _0: root::mozilla::StylePercentage,
        }
        #[test]
        fn bindgen_test_layout_StyleNumberOrPercentage_StylePercentage_Body() {
            assert_eq!(
                ::std::mem::size_of::<StyleNumberOrPercentage_StylePercentage_Body>(),
                4usize,
                concat!(
                    "Size of: ",
                    stringify!(StyleNumberOrPercentage_StylePercentage_Body)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<StyleNumberOrPercentage_StylePercentage_Body>(),
                4usize,
                concat!(
                    "Alignment of ",
                    stringify!(StyleNumberOrPercentage_StylePercentage_Body)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleNumberOrPercentage_StylePercentage_Body>()))._0
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleNumberOrPercentage_StylePercentage_Body),
                    "::",
                    stringify!(_0)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleNumberOrPercentage_StyleNumber_Body {
            pub _0: root::mozilla::StyleNumber,
        }
        #[test]
        fn bindgen_test_layout_StyleNumberOrPercentage_StyleNumber_Body() {
            assert_eq!(
                ::std::mem::size_of::<StyleNumberOrPercentage_StyleNumber_Body>(),
                4usize,
                concat!(
                    "Size of: ",
                    stringify!(StyleNumberOrPercentage_StyleNumber_Body)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<StyleNumberOrPercentage_StyleNumber_Body>(),
                4usize,
                concat!(
                    "Alignment of ",
                    stringify!(StyleNumberOrPercentage_StyleNumber_Body)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleNumberOrPercentage_StyleNumber_Body>()))._0
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleNumberOrPercentage_StyleNumber_Body),
                    "::",
                    stringify!(_0)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct StyleNumberOrPercentage__bindgen_ty_1 {
            pub percentage: root::__BindgenUnionField<
                root::mozilla::StyleNumberOrPercentage_StylePercentage_Body,
            >,
            pub number:
                root::__BindgenUnionField<root::mozilla::StyleNumberOrPercentage_StyleNumber_Body>,
            pub bindgen_union_field: u32,
        }
        #[test]
        fn bindgen_test_layout_StyleNumberOrPercentage__bindgen_ty_1() {
            assert_eq!(
                ::std::mem::size_of::<StyleNumberOrPercentage__bindgen_ty_1>(),
                4usize,
                concat!(
                    "Size of: ",
                    stringify!(StyleNumberOrPercentage__bindgen_ty_1)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<StyleNumberOrPercentage__bindgen_ty_1>(),
                4usize,
                concat!(
                    "Alignment of ",
                    stringify!(StyleNumberOrPercentage__bindgen_ty_1)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleNumberOrPercentage__bindgen_ty_1>())).percentage
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleNumberOrPercentage__bindgen_ty_1),
                    "::",
                    stringify!(percentage)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleNumberOrPercentage__bindgen_ty_1>())).number
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleNumberOrPercentage__bindgen_ty_1),
                    "::",
                    stringify!(number)
                )
            );
        }
        #[test]
        fn bindgen_test_layout_StyleNumberOrPercentage() {
            assert_eq!(
                ::std::mem::size_of::<StyleNumberOrPercentage>(),
                8usize,
                concat!("Size of: ", stringify!(StyleNumberOrPercentage))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleNumberOrPercentage>(),
                4usize,
                concat!("Alignment of ", stringify!(StyleNumberOrPercentage))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleNumberOrPercentage>())).tag as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleNumberOrPercentage),
                    "::",
                    stringify!(tag)
                )
            );
        }
        #[doc = " A non-negative <number-percentage>."]
        pub type StyleNonNegativeNumberOrPercentage = root::mozilla::StyleNumberOrPercentage;
        #[doc = " A generic value for the `border-image-slice` property."]
        #[repr(C)]
        pub struct StyleGenericBorderImageSlice<NumberOrPercentage> {
            #[doc = " The offsets."]
            pub offsets: root::mozilla::StyleRect<NumberOrPercentage>,
            #[doc = " Whether to fill the middle part."]
            pub fill: bool,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<NumberOrPercentage>>,
        }
        #[doc = " A number."]
        #[doc = " NOTE: Numbers need to be before lengths, in order to parse them"]
        #[doc = " first, since `0` should be a number, not the `0px` length."]
        pub const StyleGenericLengthOrNumber_Tag_Number:
            root::mozilla::StyleGenericLengthOrNumber_Tag = 0;
        #[doc = " A length."]
        pub const StyleGenericLengthOrNumber_Tag_Length:
            root::mozilla::StyleGenericLengthOrNumber_Tag = 0;
        pub type StyleGenericLengthOrNumber_Tag = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericLengthOrNumber_StyleNumber_Body<N> {
            pub _0: N,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<N>>,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericLengthOrNumber_StyleLength_Body<L> {
            pub _0: L,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<L>>,
        }
        #[repr(C)]
        #[derive(Copy, Clone)]
        pub struct StyleGenericLengthOrNumber__bindgen_ty_1<L, N> {
            pub number: root::__BindgenUnionField<
                root::mozilla::StyleGenericLengthOrNumber_StyleNumber_Body<N>,
            >,
            pub length: root::__BindgenUnionField<
                root::mozilla::StyleGenericLengthOrNumber_StyleLength_Body<L>,
            >,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<L>>,
            pub _phantom_1: ::std::marker::PhantomData<::std::cell::UnsafeCell<N>>,
        }
        #[doc = " Either a non-negative `<length>` or a `<number>`."]
        pub type StyleNonNegativeLengthOrNumber = root::mozilla::StyleGenericLengthOrNumber<
            root::mozilla::StyleNonNegativeLength,
            root::mozilla::StyleNonNegativeNumber,
        >;
        #[doc = " A specified rectangle made of four `<length-or-number>` values."]
        pub type StyleNonNegativeLengthOrNumberRect =
            root::mozilla::StyleRect<root::mozilla::StyleNonNegativeLengthOrNumber>;
        #[doc = " A non-negative length."]
        pub const StyleGenericPerspective_Tag_Length: root::mozilla::StyleGenericPerspective_Tag =
            0;
        #[doc = " The keyword `none`."]
        pub const StyleGenericPerspective_Tag_None: root::mozilla::StyleGenericPerspective_Tag = 0;
        pub type StyleGenericPerspective_Tag = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericPerspective_StyleLength_Body<NonNegativeLength> {
            pub _0: NonNegativeLength,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<NonNegativeLength>>,
        }
        #[repr(C)]
        #[derive(Copy, Clone)]
        pub struct StyleGenericPerspective__bindgen_ty_1<NonNegativeLength> {
            pub length: root::__BindgenUnionField<
                root::mozilla::StyleGenericPerspective_StyleLength_Body<NonNegativeLength>,
            >,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<NonNegativeLength>>,
        }
        #[doc = " An integer value."]
        pub const StyleGenericZIndex_Tag_Integer: root::mozilla::StyleGenericZIndex_Tag = 0;
        #[doc = " The keyword `auto`."]
        pub const StyleGenericZIndex_Tag_Auto: root::mozilla::StyleGenericZIndex_Tag = 0;
        pub type StyleGenericZIndex_Tag = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericZIndex_StyleInteger_Body<I> {
            pub _0: I,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<I>>,
        }
        #[repr(C)]
        #[derive(Copy, Clone)]
        pub struct StyleGenericZIndex__bindgen_ty_1<I> {
            pub integer:
                root::__BindgenUnionField<root::mozilla::StyleGenericZIndex_StyleInteger_Body<I>>,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<I>>,
        }
        #[doc = " A generic transform origin."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericTransformOrigin<H, V, Depth> {
            #[doc = " The horizontal origin."]
            pub horizontal: H,
            #[doc = " The vertical origin."]
            pub vertical: V,
            #[doc = " The depth."]
            pub depth: Depth,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<H>>,
            pub _phantom_1: ::std::marker::PhantomData<::std::cell::UnsafeCell<V>>,
            pub _phantom_2: ::std::marker::PhantomData<::std::cell::UnsafeCell<Depth>>,
        }
        #[doc = " A handle to a Gecko atom."]
        #[doc = " This is either a strong reference to a dynamic atom (an nsAtom pointer),"]
        #[doc = " or an offset from gGkAtoms to the nsStaticAtom object."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct StyleAtom {
            pub _0: usize,
        }
        #[test]
        fn bindgen_test_layout_StyleAtom() {
            assert_eq!(
                ::std::mem::size_of::<StyleAtom>(),
                8usize,
                concat!("Size of: ", stringify!(StyleAtom))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleAtom>(),
                8usize,
                concat!("Alignment of ", stringify!(StyleAtom))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<StyleAtom>()))._0 as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleAtom),
                    "::",
                    stringify!(_0)
                )
            );
        }
        #[doc = " <https://drafts.csswg.org/css-values-4/#custom-idents>"]
        #[repr(C)]
        #[derive(Debug)]
        pub struct StyleCustomIdent {
            pub _0: root::mozilla::StyleAtom,
        }
        #[test]
        fn bindgen_test_layout_StyleCustomIdent() {
            assert_eq!(
                ::std::mem::size_of::<StyleCustomIdent>(),
                8usize,
                concat!("Size of: ", stringify!(StyleCustomIdent))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleCustomIdent>(),
                8usize,
                concat!("Alignment of ", stringify!(StyleCustomIdent))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<StyleCustomIdent>()))._0 as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleCustomIdent),
                    "::",
                    stringify!(_0)
                )
            );
        }
        #[doc = " The change bits that we care about."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleWillChangeBits {
            pub bits: u8,
        }
        #[test]
        fn bindgen_test_layout_StyleWillChangeBits() {
            assert_eq!(
                ::std::mem::size_of::<StyleWillChangeBits>(),
                1usize,
                concat!("Size of: ", stringify!(StyleWillChangeBits))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleWillChangeBits>(),
                1usize,
                concat!("Alignment of ", stringify!(StyleWillChangeBits))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleWillChangeBits>())).bits as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleWillChangeBits),
                    "::",
                    stringify!(bits)
                )
            );
        }
        #[doc = " Specified keyword values for non-case transforms in the text-transform property. (Non-exclusive.)"]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleTextTransformOther {
            pub bits: u8,
        }
        #[test]
        fn bindgen_test_layout_StyleTextTransformOther() {
            assert_eq!(
                ::std::mem::size_of::<StyleTextTransformOther>(),
                1usize,
                concat!("Size of: ", stringify!(StyleTextTransformOther))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleTextTransformOther>(),
                1usize,
                concat!("Alignment of ", stringify!(StyleTextTransformOther))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleTextTransformOther>())).bits as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleTextTransformOther),
                    "::",
                    stringify!(bits)
                )
            );
        }
        #[doc = " Ratios representing the contribution of color and currentcolor to"]
        #[doc = " the final color value."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleComplexColorRatios {
            #[doc = " Numeric color contribution."]
            pub bg: f32,
            #[doc = " currentcolor contribution."]
            pub fg: f32,
        }
        #[test]
        fn bindgen_test_layout_StyleComplexColorRatios() {
            assert_eq!(
                ::std::mem::size_of::<StyleComplexColorRatios>(),
                8usize,
                concat!("Size of: ", stringify!(StyleComplexColorRatios))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleComplexColorRatios>(),
                4usize,
                concat!("Alignment of ", stringify!(StyleComplexColorRatios))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleComplexColorRatios>())).bg as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleComplexColorRatios),
                    "::",
                    stringify!(bg)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleComplexColorRatios>())).fg as *const _ as usize
                },
                4usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleComplexColorRatios),
                    "::",
                    stringify!(fg)
                )
            );
        }
        #[doc = " Numeric RGBA color."]
        pub const StyleGenericColor_Tag_Numeric: root::mozilla::StyleGenericColor_Tag = 0;
        #[doc = " The current foreground color."]
        pub const StyleGenericColor_Tag_CurrentColor: root::mozilla::StyleGenericColor_Tag = 0;
        #[doc = " A linear combination of numeric color and currentcolor."]
        #[doc = " The formula is: `color * ratios.bg + currentcolor * ratios.fg`."]
        pub const StyleGenericColor_Tag_Complex: root::mozilla::StyleGenericColor_Tag = 0;
        pub type StyleGenericColor_Tag = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericColor_StyleNumeric_Body<RGBA> {
            pub _0: RGBA,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<RGBA>>,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericColor_StyleComplex_Body<RGBA> {
            #[doc = " The actual numeric color."]
            pub color: RGBA,
            #[doc = " The ratios of mixing between numeric and currentcolor."]
            pub ratios: root::mozilla::StyleComplexColorRatios,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<RGBA>>,
        }
        #[repr(C)]
        #[derive(Copy, Clone)]
        pub struct StyleGenericColor__bindgen_ty_1<RGBA> {
            pub numeric:
                root::__BindgenUnionField<root::mozilla::StyleGenericColor_StyleNumeric_Body<RGBA>>,
            pub complex:
                root::__BindgenUnionField<root::mozilla::StyleGenericColor_StyleComplex_Body<RGBA>>,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<RGBA>>,
        }
        #[doc = " An animated value for `<color>`."]
        pub type StyleColor = root::mozilla::StyleGenericColor<root::mozilla::StyleRGBA>;
        #[doc = " `auto`"]
        pub const StyleGenericScrollbarColor_Tag_Auto:
            root::mozilla::StyleGenericScrollbarColor_Tag = 0;
        #[doc = " `<color>{2}`"]
        pub const StyleGenericScrollbarColor_Tag_Colors:
            root::mozilla::StyleGenericScrollbarColor_Tag = 0;
        pub type StyleGenericScrollbarColor_Tag = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericScrollbarColor_StyleColors_Body<Color> {
            #[doc = " First `<color>`, for color of the scrollbar thumb."]
            pub thumb: Color,
            #[doc = " Second `<color>`, for color of the scrollbar track."]
            pub track: Color,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<Color>>,
        }
        #[repr(C)]
        #[derive(Copy, Clone)]
        pub struct StyleGenericScrollbarColor__bindgen_ty_1<Color> {
            pub colors: root::__BindgenUnionField<
                root::mozilla::StyleGenericScrollbarColor_StyleColors_Body<Color>,
            >,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<Color>>,
        }
        #[doc = " A computed value for `scrollbar-color` property."]
        pub type StyleScrollbarColor =
            root::mozilla::StyleGenericScrollbarColor<root::mozilla::StyleColor>;
        #[doc = " A `<color>`."]
        pub const StyleGenericColorOrAuto_Tag_Color: root::mozilla::StyleGenericColorOrAuto_Tag = 0;
        #[doc = " `auto`"]
        pub const StyleGenericColorOrAuto_Tag_Auto: root::mozilla::StyleGenericColorOrAuto_Tag = 0;
        pub type StyleGenericColorOrAuto_Tag = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericColorOrAuto_StyleColor_Body<C> {
            pub _0: C,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<C>>,
        }
        #[repr(C)]
        #[derive(Copy, Clone)]
        pub struct StyleGenericColorOrAuto__bindgen_ty_1<C> {
            pub color: root::__BindgenUnionField<
                root::mozilla::StyleGenericColorOrAuto_StyleColor_Body<C>,
            >,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<C>>,
        }
        #[doc = " auto | <color>"]
        pub type StyleColorOrAuto =
            root::mozilla::StyleGenericColorOrAuto<root::mozilla::StyleColor>;
        #[doc = " A simple color stop, without position."]
        pub const StyleGenericGradientItem_Tag_SimpleColorStop:
            root::mozilla::StyleGenericGradientItem_Tag = 0;
        #[doc = " A complex color stop, with a position."]
        pub const StyleGenericGradientItem_Tag_ComplexColorStop:
            root::mozilla::StyleGenericGradientItem_Tag = 0;
        #[doc = " An interpolation hint."]
        pub const StyleGenericGradientItem_Tag_InterpolationHint:
            root::mozilla::StyleGenericGradientItem_Tag = 0;
        pub type StyleGenericGradientItem_Tag = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericGradientItem_StyleSimpleColorStop_Body<Color> {
            pub _0: Color,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<Color>>,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericGradientItem_StyleComplexColorStop_Body<Color, LengthPercentage> {
            #[doc = " The color for the stop."]
            pub color: Color,
            #[doc = " The position for the stop."]
            pub position: LengthPercentage,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<Color>>,
            pub _phantom_1: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercentage>>,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericGradientItem_StyleInterpolationHint_Body<LengthPercentage> {
            pub _0: LengthPercentage,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercentage>>,
        }
        #[repr(C)]
        #[derive(Copy, Clone)]
        pub struct StyleGenericGradientItem__bindgen_ty_1<Color, LengthPercentage> {
            pub simple_color_stop: root::__BindgenUnionField<
                root::mozilla::StyleGenericGradientItem_StyleSimpleColorStop_Body<Color>,
            >,
            pub complex_color_stop: root::__BindgenUnionField<
                root::mozilla::StyleGenericGradientItem_StyleComplexColorStop_Body<
                    Color,
                    LengthPercentage,
                >,
            >,
            pub interpolation_hint: root::__BindgenUnionField<
                root::mozilla::StyleGenericGradientItem_StyleInterpolationHint_Body<
                    LengthPercentage,
                >,
            >,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<Color>>,
            pub _phantom_1: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercentage>>,
        }
        #[doc = " A computed gradient item."]
        pub type StyleGradientItem = root::mozilla::StyleGenericGradientItem<
            root::mozilla::StyleColor,
            root::mozilla::StyleLengthPercentage,
        >;
        #[doc = " One of the vertical-align keywords."]
        pub const StyleGenericVerticalAlign_Tag_Keyword:
            root::mozilla::StyleGenericVerticalAlign_Tag = 0;
        #[doc = " `<length-percentage>`"]
        pub const StyleGenericVerticalAlign_Tag_Length:
            root::mozilla::StyleGenericVerticalAlign_Tag = 0;
        pub type StyleGenericVerticalAlign_Tag = u8;
        #[repr(C)]
        pub struct StyleGenericVerticalAlign_StyleKeyword_Body {
            pub _0: root::mozilla::StyleVerticalAlignKeyword,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleGenericVerticalAlign_StyleLength_Body<LengthPercentage> {
            pub _0: LengthPercentage,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercentage>>,
        }
        #[repr(C)]
        pub struct StyleGenericVerticalAlign__bindgen_ty_1<LengthPercentage> {
            pub keyword: root::__BindgenUnionField<
                root::mozilla::StyleGenericVerticalAlign_StyleKeyword_Body,
            >,
            pub length: root::__BindgenUnionField<
                root::mozilla::StyleGenericVerticalAlign_StyleLength_Body<LengthPercentage>,
            >,
            pub bindgen_union_field: [u8; 0usize],
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<LengthPercentage>>,
        }
        #[doc = " A computed value for the `vertical-align` property."]
        pub type StyleVerticalAlign =
            root::mozilla::StyleGenericVerticalAlign<root::mozilla::StyleLengthPercentage>;
        #[doc = " The computed value of `ShapeRadius`"]
        pub type StyleShapeRadius =
            root::mozilla::StyleGenericShapeRadius<root::mozilla::StyleNonNegativeLengthPercentage>;
        #[doc = " A \"thin\" `Arc` containing dynamically sized data"]
        #[doc = " This is functionally equivalent to Arc<(H, [T])>"]
        #[doc = " When you create an `Arc` containing a dynamically sized type"]
        #[doc = " like `HeaderSlice<H, [T]>`, the `Arc` is represented on the stack"]
        #[doc = " as a \"fat pointer\", where the length of the slice is stored"]
        #[doc = " alongside the `Arc`\'s pointer. In some situations you may wish to"]
        #[doc = " have a thin pointer instead, perhaps for FFI compatibility"]
        #[doc = " or space efficiency."]
        #[doc = " Note that we use `[T; 0]` in order to have the right alignment for `T`."]
        #[doc = " `ThinArc` solves this by storing the length in the allocation itself,"]
        #[doc = " via `HeaderSliceWithLength`."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleThinArc {
            pub _address: u8,
        }
        #[doc = " The context properties we understand."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleContextPropertyBits {
            pub bits: u8,
        }
        #[test]
        fn bindgen_test_layout_StyleContextPropertyBits() {
            assert_eq!(
                ::std::mem::size_of::<StyleContextPropertyBits>(),
                1usize,
                concat!("Size of: ", stringify!(StyleContextPropertyBits))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleContextPropertyBits>(),
                1usize,
                concat!("Alignment of ", stringify!(StyleContextPropertyBits))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleContextPropertyBits>())).bits as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleContextPropertyBits),
                    "::",
                    stringify!(bits)
                )
            );
        }
        #[doc = " A computed value for a single shadow of the `box-shadow` property."]
        pub type StyleBoxShadow = root::mozilla::StyleGenericBoxShadow<
            root::mozilla::StyleColor,
            root::mozilla::StyleLength,
            root::mozilla::StyleNonNegativeLength,
            root::mozilla::StyleLength,
        >;
        #[doc = " A computed value for the `drop-shadow()` filter."]
        pub type StyleSimpleShadow = root::mozilla::StyleGenericSimpleShadow<
            root::mozilla::StyleColor,
            root::mozilla::StyleLength,
            root::mozilla::StyleNonNegativeLength,
        >;
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleBoxAlign {
            Stretch = 0,
            Start = 1,
            Center = 2,
            Baseline = 3,
            End = 4,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleBoxDecorationBreak {
            Slice = 0,
            Clone = 1,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleBoxDirection {
            Normal = 0,
            Reverse = 1,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleBoxOrient {
            Horizontal = 0,
            Vertical = 1,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleBoxPack {
            Start = 0,
            Center = 1,
            End = 2,
            Justify = 3,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleBoxSizing {
            Content = 0,
            Border = 1,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleClear {
            None = 0,
            Left = 1,
            Right = 2,
            Both = 3,
            Line = 8,
            Max = 13,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleColumnFill {
            Balance = 0,
            Auto = 1,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleColumnSpan {
            None = 0,
            All = 1,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleContentType {
            String = 1,
            Image = 10,
            Attr = 20,
            Counter = 30,
            Counters = 31,
            OpenQuote = 40,
            CloseQuote = 41,
            NoOpenQuote = 42,
            NoCloseQuote = 43,
            AltContent = 50,
            Uninitialized = 51,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleGeometryBox {
            ContentBox = 0,
            PaddingBox = 1,
            BorderBox = 2,
            MarginBox = 3,
            FillBox = 4,
            StrokeBox = 5,
            ViewBox = 6,
            NoClip = 7,
            Text = 8,
            NoBox = 9,
            MozAlmostPadding = 127,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleFloatEdge {
            ContentBox = 0,
            MarginBox = 1,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleHyphens {
            None = 0,
            Manual = 1,
            Auto = 2,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleImageOrientation {
            None = 0,
            FromImage = 1,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleScrollbarWidth {
            Auto = 0,
            Thin = 1,
            None = 2,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleShapeSourceType {
            None = 0,
            URL = 1,
            Image = 2,
            Shape = 3,
            Box = 4,
            Path = 5,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleStackSizing {
            Ignore = 0,
            StretchToFit = 1,
            IgnoreHorizontal = 2,
            IgnoreVertical = 3,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleTextJustify {
            None = 0,
            Auto = 1,
            InterWord = 2,
            InterCharacter = 3,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleUserFocus {
            None = 0,
            Ignore = 1,
            Normal = 2,
            SelectAll = 3,
            SelectBefore = 4,
            SelectAfter = 5,
            SelectSame = 6,
            SelectMenu = 7,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleUserInput {
            None = 0,
            Auto = 1,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleUserModify {
            ReadOnly = 0,
            ReadWrite = 1,
            WriteOnly = 2,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleWindowDragging {
            Default = 0,
            Drag = 1,
            NoDrag = 2,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleOrient {
            Inline = 0,
            Block = 1,
            Horizontal = 2,
            Vertical = 3,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleAnimationPlayState {
            Running = 0,
            Paused = 1,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleImageLayerAttachment {
            Scroll = 0,
            Fixed = 1,
            Local = 2,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleImageLayerRepeat {
            NoRepeat = 0,
            RepeatX = 1,
            RepeatY = 2,
            Repeat = 3,
            Space = 4,
            Round = 5,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleMaskMode {
            Alpha = 0,
            Luminance = 1,
            MatchSource = 2,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleBorderCollapse {
            Collapse = 0,
            Separate = 1,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleBorderImageRepeat {
            Stretch = 0,
            Repeat = 1,
            Round = 2,
            Space = 3,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleFlexDirection {
            Row = 0,
            RowReverse = 1,
            Column = 2,
            ColumnReverse = 3,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleGridTrackBreadth {
            MaxContent = 1,
            MinContent = 2,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleWhiteSpace {
            Normal = 0,
            Pre = 1,
            Nowrap = 2,
            PreWrap = 3,
            PreLine = 4,
            PreSpace = 5,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleTextRendering {
            Auto = 0,
            Optimizespeed = 1,
            Optimizelegibility = 2,
            Geometricprecision = 3,
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum StyleColorAdjust {
            Economy = 0,
            Exact = 1,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct NotNull<T> {
            pub mBasePtr: T,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
        }
        #[repr(C)]
        #[repr(align(8))]
        #[derive(Debug, Copy, Clone)]
        pub struct TimeStamp63Bit {
            pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 8usize], u64>,
        }
        #[test]
        fn bindgen_test_layout_TimeStamp63Bit() {
            assert_eq!(
                ::std::mem::size_of::<TimeStamp63Bit>(),
                8usize,
                concat!("Size of: ", stringify!(TimeStamp63Bit))
            );
            assert_eq!(
                ::std::mem::align_of::<TimeStamp63Bit>(),
                8usize,
                concat!("Alignment of ", stringify!(TimeStamp63Bit))
            );
        }
        impl TimeStamp63Bit {
            #[inline]
            pub fn mUsedCanonicalNow(&self) -> u64 {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u64) }
            }
            #[inline]
            pub fn set_mUsedCanonicalNow(&mut self, val: u64) {
                unsafe {
                    let val: u64 = ::std::mem::transmute(val);
                    self._bitfield_1.set(0usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mTimeStamp(&self) -> u64 {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 63u8) as u64) }
            }
            #[inline]
            pub fn set_mTimeStamp(&mut self, val: u64) {
                unsafe {
                    let val: u64 = ::std::mem::transmute(val);
                    self._bitfield_1.set(1usize, 63u8, val as u64)
                }
            }
            #[inline]
            pub fn new_bitfield_1(
                mUsedCanonicalNow: u64,
                mTimeStamp: u64,
            ) -> root::__BindgenBitfieldUnit<[u8; 8usize], u64> {
                let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 8usize], u64> =
                    Default::default();
                __bindgen_bitfield_unit.set(0usize, 1u8, {
                    let mUsedCanonicalNow: u64 =
                        unsafe { ::std::mem::transmute(mUsedCanonicalNow) };
                    mUsedCanonicalNow as u64
                });
                __bindgen_bitfield_unit.set(1usize, 63u8, {
                    let mTimeStamp: u64 = unsafe { ::std::mem::transmute(mTimeStamp) };
                    mTimeStamp as u64
                });
                __bindgen_bitfield_unit
            }
        }
        pub type TimeStampValue = root::mozilla::TimeStamp63Bit;
        #[doc = " Instances of this class represent the length of an interval of time."]
        #[doc = " Negative durations are allowed, meaning the end is before the start."]
        #[doc = ""]
        #[doc = " Internally the duration is stored as a int64_t in units of"]
        #[doc = " PR_TicksPerSecond() when building with NSPR interval timers, or a"]
        #[doc = " system-dependent unit when building with system clocks.  The"]
        #[doc = " system-dependent unit must be constant, otherwise the semantics of"]
        #[doc = " this class would be broken."]
        #[doc = ""]
        #[doc = " The ValueCalculator template parameter determines how arithmetic"]
        #[doc = " operations are performed on the integer count of ticks (mValue)."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct BaseTimeDuration {
            pub mValue: i64,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct BaseTimeDuration__SomethingVeryRandomHere {
            _unused: [u8; 0],
        }
        #[doc = " Perform arithmetic operations on the value of a BaseTimeDuration without"]
        #[doc = " doing strict checks on the range of values."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct TimeDurationValueCalculator {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_TimeDurationValueCalculator() {
            assert_eq!(
                ::std::mem::size_of::<TimeDurationValueCalculator>(),
                1usize,
                concat!("Size of: ", stringify!(TimeDurationValueCalculator))
            );
            assert_eq!(
                ::std::mem::align_of::<TimeDurationValueCalculator>(),
                1usize,
                concat!("Alignment of ", stringify!(TimeDurationValueCalculator))
            );
        }
        #[doc = " Specialization of BaseTimeDuration that uses TimeDurationValueCalculator for"]
        #[doc = " arithmetic on the mValue member."]
        #[doc = ""]
        #[doc = " Use this class for time durations that are *not* expected to hold values of"]
        #[doc = " Forever (or the negative equivalent) or when such time duration are *not*"]
        #[doc = " expected to be used in arithmetic operations."]
        pub type TimeDuration = root::mozilla::BaseTimeDuration;
        #[doc = " Instances of this class represent moments in time, or a special"]
        #[doc = " \"null\" moment. We do not use the non-monotonic system clock or"]
        #[doc = " local time, since they can be reset, causing apparent backward"]
        #[doc = " travel in time, which can confuse algorithms. Instead we measure"]
        #[doc = " elapsed time according to the system.  This time can never go"]
        #[doc = " backwards (i.e. it never wraps around, at least not in less than"]
        #[doc = " five million years of system elapsed time). It might not advance"]
        #[doc = " while the system is sleeping. If TimeStamp::SetNow() is not called"]
        #[doc = " at all for hours or days, we might not notice the passage of some"]
        #[doc = " of that time."]
        #[doc = ""]
        #[doc = " We deliberately do not expose a way to convert TimeStamps to some"]
        #[doc = " particular unit. All you can do is compute a difference between two"]
        #[doc = " TimeStamps to get a TimeDuration. You can also add a TimeDuration"]
        #[doc = " to a TimeStamp to get a new TimeStamp. You can\'t do something"]
        #[doc = " meaningless like add two TimeStamps."]
        #[doc = ""]
        #[doc = " Internally this is implemented as either a wrapper around"]
        #[doc = "   - high-resolution, monotonic, system clocks if they exist on this"]
        #[doc = "     platform"]
        #[doc = "   - PRIntervalTime otherwise.  We detect wraparounds of"]
        #[doc = "     PRIntervalTime and work around them."]
        #[doc = ""]
        #[doc = " This class is similar to C++11\'s time_point, however it is"]
        #[doc = " explicitly nullable and provides an IsNull() method. time_point"]
        #[doc = " is initialized to the clock\'s epoch and provides a"]
        #[doc = " time_since_epoch() method that functions similiarly. i.e."]
        #[doc = " t.IsNull() is equivalent to t.time_since_epoch() =="]
        #[doc = " decltype(t)::duration::zero();"]
        #[doc = ""]
        #[doc = " Note that, since TimeStamp objects are small, prefer to pass them by value"]
        #[doc = " unless there is a specific reason not to do so."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct TimeStamp {
            #[doc = " When built with PRIntervalTime, a value of 0 means this instance"]
            #[doc = " is \"null\". Otherwise, the low 32 bits represent a PRIntervalTime,"]
            #[doc = " and the high 32 bits represent a counter of the number of"]
            #[doc = " rollovers of PRIntervalTime that we\'ve seen. This counter starts"]
            #[doc = " at 1 to avoid a real time colliding with the \"null\" value."]
            #[doc = ""]
            #[doc = " PR_INTERVAL_MAX is set at 100,000 ticks per second. So the minimum"]
            #[doc = " time to wrap around is about 2^64/100000 seconds, i.e. about"]
            #[doc = " 5,849,424 years."]
            #[doc = ""]
            #[doc = " When using a system clock, a value is system dependent."]
            pub mValue: root::mozilla::TimeStampValue,
        }
        #[test]
        fn bindgen_test_layout_TimeStamp() {
            assert_eq!(
                ::std::mem::size_of::<TimeStamp>(),
                8usize,
                concat!("Size of: ", stringify!(TimeStamp))
            );
            assert_eq!(
                ::std::mem::align_of::<TimeStamp>(),
                8usize,
                concat!("Alignment of ", stringify!(TimeStamp))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<TimeStamp>())).mValue as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(TimeStamp),
                    "::",
                    stringify!(mValue)
                )
            );
        }
        #[doc = " font family name, an Atom for the name if not a generic and"]
        #[doc = " a font type indicated named family or which generic family"]
        #[repr(C)]
        pub struct FontFamilyName {
            pub mName: root::RefPtr<root::nsAtom>,
            pub mSyntax: root::mozilla::StyleFontFamilyNameSyntax,
            pub mGeneric: root::mozilla::StyleGenericFontFamily,
        }
        pub use self::super::super::root::mozilla::StyleFontFamilyNameSyntax as FontFamilyName_Syntax;
        #[test]
        fn bindgen_test_layout_FontFamilyName() {
            assert_eq!(
                ::std::mem::size_of::<FontFamilyName>(),
                16usize,
                concat!("Size of: ", stringify!(FontFamilyName))
            );
            assert_eq!(
                ::std::mem::align_of::<FontFamilyName>(),
                8usize,
                concat!("Alignment of ", stringify!(FontFamilyName))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<FontFamilyName>())).mName as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(FontFamilyName),
                    "::",
                    stringify!(mName)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<FontFamilyName>())).mSyntax as *const _ as usize },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(FontFamilyName),
                    "::",
                    stringify!(mSyntax)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<FontFamilyName>())).mGeneric as *const _ as usize },
                9usize,
                concat!(
                    "Offset of field: ",
                    stringify!(FontFamilyName),
                    "::",
                    stringify!(mGeneric)
                )
            );
        }
        #[doc = " A refcounted array of FontFamilyNames.  We use this to store the specified"]
        #[doc = " and computed value of the font-family property."]
        #[doc = ""]
        #[doc = " TODO(heycam): It might better to define this type (and FontFamilyList and"]
        #[doc = " FontFamilyName) in Rust."]
        #[repr(C)]
        pub struct SharedFontList {
            pub mRefCnt: u64,
            pub mNames: root::nsTArray<root::mozilla::FontFamilyName>,
        }
        pub use self::super::super::root::mozilla::StyleFontFamilyNameSyntax as SharedFontList_Syntax;
        pub type SharedFontList_HasThreadSafeRefCnt = root::mozilla::TrueType;
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla14SharedFontList6sEmptyE"]
            pub static mut SharedFontList_sEmpty:
                root::mozilla::StaticRefPtr<root::mozilla::SharedFontList>;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla14SharedFontList15sSingleGenericsE"]
            pub static mut SharedFontList_sSingleGenerics:
                [root::mozilla::StaticRefPtr<root::mozilla::SharedFontList>; 6usize];
        }
        #[test]
        fn bindgen_test_layout_SharedFontList() {
            assert_eq!(
                ::std::mem::size_of::<SharedFontList>(),
                16usize,
                concat!("Size of: ", stringify!(SharedFontList))
            );
            assert_eq!(
                ::std::mem::align_of::<SharedFontList>(),
                8usize,
                concat!("Alignment of ", stringify!(SharedFontList))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<SharedFontList>())).mRefCnt as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(SharedFontList),
                    "::",
                    stringify!(mRefCnt)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<SharedFontList>())).mNames as *const _ as usize },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(SharedFontList),
                    "::",
                    stringify!(mNames)
                )
            );
        }
        #[test]
        fn __bindgen_test_layout_StaticRefPtr_open0_SharedFontList_close0_instantiation() {
            assert_eq!(
                ::std::mem::size_of::<root::mozilla::StaticRefPtr<root::mozilla::SharedFontList>>(),
                8usize,
                concat!(
                    "Size of template specialization: ",
                    stringify!(root::mozilla::StaticRefPtr<root::mozilla::SharedFontList>)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<root::mozilla::StaticRefPtr<root::mozilla::SharedFontList>>(
                ),
                8usize,
                concat!(
                    "Alignment of template specialization: ",
                    stringify!(root::mozilla::StaticRefPtr<root::mozilla::SharedFontList>)
                )
            );
        }
        #[test]
        fn __bindgen_test_layout_StaticRefPtr_open0_SharedFontList_close0_instantiation_1() {
            assert_eq!(
                ::std::mem::size_of::<root::mozilla::StaticRefPtr<root::mozilla::SharedFontList>>(),
                8usize,
                concat!(
                    "Size of template specialization: ",
                    stringify!(root::mozilla::StaticRefPtr<root::mozilla::SharedFontList>)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<root::mozilla::StaticRefPtr<root::mozilla::SharedFontList>>(
                ),
                8usize,
                concat!(
                    "Alignment of template specialization: ",
                    stringify!(root::mozilla::StaticRefPtr<root::mozilla::SharedFontList>)
                )
            );
        }
        #[doc = " font family list, array of font families and a default font type."]
        #[doc = " font family names are either named strings or generics. the default"]
        #[doc = " font type is used to preserve the variable font fallback behavior"]
        #[repr(C)]
        pub struct FontFamilyList {
            pub mFontlist: root::mozilla::NotNull<root::RefPtr<root::mozilla::SharedFontList>>,
            pub mDefaultFontType: root::mozilla::StyleGenericFontFamily,
        }
        pub use self::super::super::root::mozilla::StyleFontFamilyNameSyntax as FontFamilyList_Syntax;
        #[test]
        fn bindgen_test_layout_FontFamilyList() {
            assert_eq!(
                ::std::mem::size_of::<FontFamilyList>(),
                16usize,
                concat!("Size of: ", stringify!(FontFamilyList))
            );
            assert_eq!(
                ::std::mem::align_of::<FontFamilyList>(),
                8usize,
                concat!("Alignment of ", stringify!(FontFamilyList))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<FontFamilyList>())).mFontlist as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(FontFamilyList),
                    "::",
                    stringify!(mFontlist)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<FontFamilyList>())).mDefaultFontType as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(FontFamilyList),
                    "::",
                    stringify!(mDefaultFontType)
                )
            );
        }
        pub type EnumeratedArray_ArrayType = u8;
        pub type EnumeratedArray_iterator = root::mozilla::EnumeratedArray_ArrayType;
        pub type EnumeratedArray_const_iterator = root::mozilla::EnumeratedArray_ArrayType;
        pub type EnumeratedArray_reverse_iterator = root::mozilla::EnumeratedArray_ArrayType;
        pub type EnumeratedArray_const_reverse_iterator = root::mozilla::EnumeratedArray_ArrayType;
        #[doc = " font-weight: range 1..1000, fractional values permitted; keywords"]
        #[doc = " \'normal\', \'bold\' aliased to 400, 700 respectively; relative keywords"]
        #[doc = " \'lighter\', \'bolder\' (not currently handled here)."]
        #[doc = ""]
        #[doc = " We use an unsigned 10.6 fixed-point value (range 0.0 - 1023.984375)"]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct FontWeight {
            pub _base: u16,
        }
        pub type FontWeight_InternalType = u16;
        pub const FontWeight_kNormal: root::mozilla::FontWeight_InternalType = 25600;
        pub const FontWeight_kBold: root::mozilla::FontWeight_InternalType = 44800;
        pub const FontWeight_kBoldThreshold: root::mozilla::FontWeight_InternalType = 38400;
        pub const FontWeight_kThin: root::mozilla::FontWeight_InternalType = 6400;
        pub const FontWeight_kExtraBold: root::mozilla::FontWeight_InternalType = 57600;
        #[test]
        fn bindgen_test_layout_FontWeight() {
            assert_eq!(
                ::std::mem::size_of::<FontWeight>(),
                2usize,
                concat!("Size of: ", stringify!(FontWeight))
            );
            assert_eq!(
                ::std::mem::align_of::<FontWeight>(),
                2usize,
                concat!("Alignment of ", stringify!(FontWeight))
            );
        }
        #[doc = " font-stretch is represented as a percentage relative to \'normal\'."]
        #[doc = ""]
        #[doc = " css-fonts says the value must be >= 0%, and normal is 100%. Keywords"]
        #[doc = " from ultra-condensed to ultra-expanded are aliased to percentages"]
        #[doc = " from 50% to 200%; values outside that range are unlikely to be common,"]
        #[doc = " but could occur."]
        #[doc = ""]
        #[doc = " Like font-weight, we use an unsigned 10.6 fixed-point value (range"]
        #[doc = " 0.0 - 1023.984375)."]
        #[doc = ""]
        #[doc = " We arbitrarily limit here to 1000%. (If that becomes a problem, we"]
        #[doc = " could reduce the number of fractional bits and increase the limit.)"]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct FontStretch {
            pub _base: u16,
        }
        pub type FontStretch_InternalType = u16;
        pub const FontStretch_kUltraCondensed: root::mozilla::FontStretch_InternalType = 3200;
        pub const FontStretch_kExtraCondensed: root::mozilla::FontStretch_InternalType = 4000;
        pub const FontStretch_kCondensed: root::mozilla::FontStretch_InternalType = 4800;
        pub const FontStretch_kSemiCondensed: root::mozilla::FontStretch_InternalType = 5600;
        pub const FontStretch_kNormal: root::mozilla::FontStretch_InternalType = 6400;
        pub const FontStretch_kSemiExpanded: root::mozilla::FontStretch_InternalType = 7200;
        pub const FontStretch_kExpanded: root::mozilla::FontStretch_InternalType = 8000;
        pub const FontStretch_kExtraExpanded: root::mozilla::FontStretch_InternalType = 9600;
        pub const FontStretch_kUltraExpanded: root::mozilla::FontStretch_InternalType = 12800;
        #[test]
        fn bindgen_test_layout_FontStretch() {
            assert_eq!(
                ::std::mem::size_of::<FontStretch>(),
                2usize,
                concat!("Size of: ", stringify!(FontStretch))
            );
            assert_eq!(
                ::std::mem::align_of::<FontStretch>(),
                2usize,
                concat!("Alignment of ", stringify!(FontStretch))
            );
        }
        #[doc = " font-style: normal | italic | oblique <angle>?"]
        #[doc = " values of <angle> below -90 or above 90 not permitted"]
        #[doc = " - Use a signed 8.8 fixed-point value"]
        #[doc = "   (representable range -128.0 - 127.99609375)"]
        #[doc = " - Define min value (-128.0) as meaning \'normal\'"]
        #[doc = " - Define max value (127.99609375) as \'italic\'"]
        #[doc = " - Other values represent \'oblique <angle>\'"]
        #[doc = " - Note that \'oblique 0deg\' is distinct from \'normal\' (should it be?)"]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct FontSlantStyle {
            pub _base: u16,
        }
        pub type FontSlantStyle_InternalType = i16;
        pub const FontSlantStyle_kDefaultAngle: f32 = 14.0;
        pub const FontSlantStyle_kNormal: root::mozilla::FontSlantStyle_InternalType = -32768;
        pub const FontSlantStyle_kItalic: root::mozilla::FontSlantStyle_InternalType = 32767;
        #[test]
        fn bindgen_test_layout_FontSlantStyle() {
            assert_eq!(
                ::std::mem::size_of::<FontSlantStyle>(),
                2usize,
                concat!("Size of: ", stringify!(FontSlantStyle))
            );
            assert_eq!(
                ::std::mem::align_of::<FontSlantStyle>(),
                2usize,
                concat!("Alignment of ", stringify!(FontSlantStyle))
            );
        }
        pub type LengthPercentage = root::mozilla::StyleLengthPercentage;
        pub type LengthPercentageOrAuto = root::mozilla::StyleLengthPercentageOrAuto;
        pub type NonNegativeLengthPercentage = root::mozilla::StyleNonNegativeLengthPercentage;
        pub type NonNegativeLengthPercentageOrAuto =
            root::mozilla::StyleNonNegativeLengthPercentageOrAuto;
        pub type NonNegativeLengthPercentageOrNormal =
            root::mozilla::StyleNonNegativeLengthPercentageOrNormal;
        pub type Length = root::mozilla::StyleLength;
        pub type NonNegativeLengthOrAuto = root::mozilla::StyleNonNegativeLengthOrAuto;
        pub type RestyleHint = root::mozilla::StyleRestyleHint;
        #[doc = " The default of not using CORS to validate cross-origin loads."]
        pub const CORSMode_CORS_NONE: root::mozilla::CORSMode = 0;
        #[doc = " Validate cross-site loads using CORS, but do not send any credentials"]
        #[doc = " (cookies, HTTP auth logins, etc) along with the request."]
        pub const CORSMode_CORS_ANONYMOUS: root::mozilla::CORSMode = 1;
        #[doc = " Validate cross-site loads using CORS, and send credentials such as cookies"]
        #[doc = " and HTTP auth logins along with the request."]
        pub const CORSMode_CORS_USE_CREDENTIALS: root::mozilla::CORSMode = 2;
        pub type CORSMode = u8;
        #[repr(C)]
        #[derive(Debug)]
        pub struct LinkedListElement {
            pub mNext: *mut root::mozilla::LinkedListElement,
            pub mPrev: *mut root::mozilla::LinkedListElement,
            pub mIsSentinel: bool,
        }
        pub type LinkedListElement_Traits = root::mozilla::detail::LinkedListElementTraits;
        pub type LinkedListElement_RawType = root::mozilla::LinkedListElement_Traits;
        pub type LinkedListElement_ConstRawType = root::mozilla::LinkedListElement_Traits;
        pub type LinkedListElement_ClientType = root::mozilla::LinkedListElement_Traits;
        pub type LinkedListElement_ConstClientType = root::mozilla::LinkedListElement_Traits;
        pub const LinkedListElement_NodeKind_Normal: root::mozilla::LinkedListElement_NodeKind = 0;
        pub const LinkedListElement_NodeKind_Sentinel: root::mozilla::LinkedListElement_NodeKind =
            0;
        pub type LinkedListElement_NodeKind = i32;
        #[repr(C)]
        #[derive(Debug)]
        pub struct LinkedList {
            pub sentinel: root::mozilla::LinkedListElement,
        }
        pub type LinkedList_Traits = root::mozilla::detail::LinkedListElementTraits;
        pub type LinkedList_RawType = root::mozilla::LinkedList_Traits;
        pub type LinkedList_ConstRawType = root::mozilla::LinkedList_Traits;
        pub type LinkedList_ClientType = root::mozilla::LinkedList_Traits;
        pub type LinkedList_ConstClientType = root::mozilla::LinkedList_Traits;
        pub type LinkedList_ElementType = *mut root::mozilla::LinkedListElement;
        pub type LinkedList_ConstElementType = *const root::mozilla::LinkedListElement;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct LinkedList_Iterator<Type> {
            pub mCurrent: Type,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<Type>>,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct MallocAllocPolicy {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_MallocAllocPolicy() {
            assert_eq!(
                ::std::mem::size_of::<MallocAllocPolicy>(),
                1usize,
                concat!("Size of: ", stringify!(MallocAllocPolicy))
            );
            assert_eq!(
                ::std::mem::align_of::<MallocAllocPolicy>(),
                1usize,
                concat!("Alignment of ", stringify!(MallocAllocPolicy))
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct HashSet {
            pub _address: u8,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct HashSet_SetHashPolicy<HashPolicy> {
            pub _base: HashPolicy,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<HashPolicy>>,
        }
        pub type HashSet_SetHashPolicy_Base<HashPolicy> = HashPolicy;
        pub type HashSet_SetHashPolicy_KeyType<T> = T;
        pub type HashSet_Impl = u8;
        pub type HashSet_Lookup = [u8; 0usize];
        pub type HashSet_Entry<T> = T;
        pub type HashSet_Ptr = root::mozilla::HashSet_Impl;
        pub type HashSet_AddPtr = root::mozilla::HashSet_Impl;
        pub type HashSet_Iterator = root::mozilla::HashSet_Impl;
        pub type HashSet_ModIterator = root::mozilla::HashSet_Impl;
        pub type HashSet_Range = root::mozilla::HashSet_Impl;
        pub type HashSet_Enum = root::mozilla::HashSet_Impl;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct DefaultHasher {
            pub _address: u8,
        }
        pub type DefaultHasher_Lookup<Key> = Key;
        pub type Vector_Impl = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct Vector_CapacityAndReserved {
            pub mCapacity: usize,
        }
        pub type Vector_ElementType<T> = T;
        pub const Vector_InlineLength: root::mozilla::Vector__bindgen_ty_1 = 0;
        pub type Vector__bindgen_ty_1 = i32;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct Vector_Range<T> {
            pub mCur: *mut T,
            pub mEnd: *mut T,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct Vector_ConstRange<T> {
            pub mCur: *const T,
            pub mEnd: *const T,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct OwningNonNull<T> {
            pub mPtr: root::RefPtr<T>,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
        }
        pub mod binding_danger {
            #[allow(unused_imports)]
            use self::super::super::super::root;
            #[doc = " Templated implementation class for various ErrorResult-like things.  The"]
            #[doc = " instantiations differ only in terms of their cleanup policies (used in the"]
            #[doc = " destructor), which they can specify via the template argument.  Note that"]
            #[doc = " this means it\'s safe to reinterpret_cast between the instantiations unless"]
            #[doc = " you plan to invoke the destructor through such a cast pointer."]
            #[doc = ""]
            #[doc = " A cleanup policy consists of two booleans: whether to assert that we\'ve been"]
            #[doc = " reported or suppressed, and whether to then go ahead and suppress the"]
            #[doc = " exception."]
            #[repr(C)]
            #[derive(Debug)]
            pub struct TErrorResult {
                pub mResult: root::nsresult,
                pub mExtra: root::mozilla::binding_danger::TErrorResult_Extra,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct TErrorResult_Message {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct TErrorResult_DOMExceptionInfo {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct TErrorResult_Extra {
                pub mMessage: root::__BindgenUnionField<
                    *mut root::mozilla::binding_danger::TErrorResult_Message,
                >,
                pub mJSException: root::__BindgenUnionField<root::JS::Value>,
                pub mDOMExceptionInfo: root::__BindgenUnionField<
                    *mut root::mozilla::binding_danger::TErrorResult_DOMExceptionInfo,
                >,
                pub bindgen_union_field: u64,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct AssertAndSuppressCleanupPolicy {
                pub _address: u8,
            }
            pub const AssertAndSuppressCleanupPolicy_assertHandled: bool = true;
            pub const AssertAndSuppressCleanupPolicy_suppress: bool = true;
            pub const AssertAndSuppressCleanupPolicy_assertSameThread: bool = true;
            #[test]
            fn bindgen_test_layout_AssertAndSuppressCleanupPolicy() {
                assert_eq!(
                    ::std::mem::size_of::<AssertAndSuppressCleanupPolicy>(),
                    1usize,
                    concat!("Size of: ", stringify!(AssertAndSuppressCleanupPolicy))
                );
                assert_eq!(
                    ::std::mem::align_of::<AssertAndSuppressCleanupPolicy>(),
                    1usize,
                    concat!("Alignment of ", stringify!(AssertAndSuppressCleanupPolicy))
                );
            }
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct ErrorResult {
            pub _base: root::mozilla::binding_danger::TErrorResult,
        }
        pub type ErrorResult_BaseErrorResult = root::mozilla::binding_danger::TErrorResult;
        #[test]
        fn bindgen_test_layout_ErrorResult() {
            assert_eq!(
                ::std::mem::size_of::<ErrorResult>(),
                16usize,
                concat!("Size of: ", stringify!(ErrorResult))
            );
            assert_eq!(
                ::std::mem::align_of::<ErrorResult>(),
                8usize,
                concat!("Alignment of ", stringify!(ErrorResult))
            );
        }
        pub mod net {
            #[allow(unused_imports)]
            use self::super::super::super::root;
            pub const ReferrerPolicy_RP_No_Referrer: root::mozilla::net::ReferrerPolicy = 2;
            pub const ReferrerPolicy_RP_Origin: root::mozilla::net::ReferrerPolicy = 3;
            pub const ReferrerPolicy_RP_No_Referrer_When_Downgrade:
                root::mozilla::net::ReferrerPolicy = 1;
            pub const ReferrerPolicy_RP_Origin_When_Crossorigin:
                root::mozilla::net::ReferrerPolicy = 4;
            pub const ReferrerPolicy_RP_Unsafe_URL: root::mozilla::net::ReferrerPolicy = 5;
            pub const ReferrerPolicy_RP_Same_Origin: root::mozilla::net::ReferrerPolicy = 6;
            pub const ReferrerPolicy_RP_Strict_Origin: root::mozilla::net::ReferrerPolicy = 7;
            pub const ReferrerPolicy_RP_Strict_Origin_When_Cross_Origin:
                root::mozilla::net::ReferrerPolicy = 8;
            pub const ReferrerPolicy_RP_Unset: root::mozilla::net::ReferrerPolicy = 0;
            pub type ReferrerPolicy = u32;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ChannelEventQueue {
                _unused: [u8; 0],
            }
        }
        pub mod profiler {
            #[allow(unused_imports)]
            use self::super::super::super::root;
            pub mod detail {
                #[allow(unused_imports)]
                use self::super::super::super::super::root;
                #[repr(C)]
                #[derive(Debug, Copy, Clone)]
                pub struct RacyFeatures {
                    pub _address: u8,
                }
                pub const RacyFeatures_Active: u32 = 2147483648;
                extern "C" {
                    #[link_name = "\u{1}_ZN7mozilla8profiler6detail12RacyFeatures18sActiveAndFeaturesE"]
                    pub static mut RacyFeatures_sActiveAndFeatures: u32;
                }
                #[test]
                fn bindgen_test_layout_RacyFeatures() {
                    assert_eq!(
                        ::std::mem::size_of::<RacyFeatures>(),
                        1usize,
                        concat!("Size of: ", stringify!(RacyFeatures))
                    );
                    assert_eq!(
                        ::std::mem::align_of::<RacyFeatures>(),
                        1usize,
                        concat!("Alignment of ", stringify!(RacyFeatures))
                    );
                }
            }
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct AutoProfilerLabel {
            pub mProfilingStack: *mut root::ProfilingStack,
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla17AutoProfilerLabel15sProfilingStackE"]
            pub static mut AutoProfilerLabel_sProfilingStack: u64;
        }
        #[test]
        fn bindgen_test_layout_AutoProfilerLabel() {
            assert_eq!(
                ::std::mem::size_of::<AutoProfilerLabel>(),
                8usize,
                concat!("Size of: ", stringify!(AutoProfilerLabel))
            );
            assert_eq!(
                ::std::mem::align_of::<AutoProfilerLabel>(),
                8usize,
                concat!("Alignment of ", stringify!(AutoProfilerLabel))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AutoProfilerLabel>())).mProfilingStack as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AutoProfilerLabel),
                    "::",
                    stringify!(mProfilingStack)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct URLExtraData {
            pub mRefCnt: u64,
            pub mBaseURI: root::nsCOMPtr,
            pub mReferrer: root::nsCOMPtr,
            pub mReferrerPolicy: root::mozilla::net::ReferrerPolicy,
            pub mPrincipal: root::nsCOMPtr,
            pub mIsChrome: bool,
        }
        pub type URLExtraData_HasThreadSafeRefCnt = root::mozilla::TrueType;
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla12URLExtraData7sSharedE"]
            pub static mut URLExtraData_sShared:
                [root::mozilla::StaticRefPtr<root::mozilla::URLExtraData>; 15usize];
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla12URLExtraData6sDummyE"]
            pub static mut URLExtraData_sDummy:
                root::mozilla::StaticRefPtr<root::mozilla::URLExtraData>;
        }
        #[test]
        fn bindgen_test_layout_URLExtraData() {
            assert_eq!(
                ::std::mem::size_of::<URLExtraData>(),
                48usize,
                concat!("Size of: ", stringify!(URLExtraData))
            );
            assert_eq!(
                ::std::mem::align_of::<URLExtraData>(),
                8usize,
                concat!("Alignment of ", stringify!(URLExtraData))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<URLExtraData>())).mRefCnt as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(URLExtraData),
                    "::",
                    stringify!(mRefCnt)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<URLExtraData>())).mBaseURI as *const _ as usize },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(URLExtraData),
                    "::",
                    stringify!(mBaseURI)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<URLExtraData>())).mReferrer as *const _ as usize },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(URLExtraData),
                    "::",
                    stringify!(mReferrer)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<URLExtraData>())).mReferrerPolicy as *const _ as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(URLExtraData),
                    "::",
                    stringify!(mReferrerPolicy)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<URLExtraData>())).mPrincipal as *const _ as usize },
                32usize,
                concat!(
                    "Offset of field: ",
                    stringify!(URLExtraData),
                    "::",
                    stringify!(mPrincipal)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<URLExtraData>())).mIsChrome as *const _ as usize },
                40usize,
                concat!(
                    "Offset of field: ",
                    stringify!(URLExtraData),
                    "::",
                    stringify!(mIsChrome)
                )
            );
        }
        #[test]
        fn __bindgen_test_layout_StaticRefPtr_open0_URLExtraData_close0_instantiation() {
            assert_eq!(
                ::std::mem::size_of::<root::mozilla::StaticRefPtr<root::mozilla::URLExtraData>>(),
                8usize,
                concat!(
                    "Size of template specialization: ",
                    stringify!(root::mozilla::StaticRefPtr<root::mozilla::URLExtraData>)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<root::mozilla::StaticRefPtr<root::mozilla::URLExtraData>>(),
                8usize,
                concat!(
                    "Alignment of template specialization: ",
                    stringify!(root::mozilla::StaticRefPtr<root::mozilla::URLExtraData>)
                )
            );
        }
        #[test]
        fn __bindgen_test_layout_StaticRefPtr_open0_URLExtraData_close0_instantiation_1() {
            assert_eq!(
                ::std::mem::size_of::<root::mozilla::StaticRefPtr<root::mozilla::URLExtraData>>(),
                8usize,
                concat!(
                    "Size of template specialization: ",
                    stringify!(root::mozilla::StaticRefPtr<root::mozilla::URLExtraData>)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<root::mozilla::StaticRefPtr<root::mozilla::URLExtraData>>(),
                8usize,
                concat!(
                    "Alignment of template specialization: ",
                    stringify!(root::mozilla::StaticRefPtr<root::mozilla::URLExtraData>)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct Runnable {
            pub _base: root::nsIRunnable,
            pub mRefCnt: u64,
        }
        pub type Runnable_HasThreadSafeRefCnt = root::mozilla::TrueType;
        #[test]
        fn bindgen_test_layout_Runnable() {
            assert_eq!(
                ::std::mem::size_of::<Runnable>(),
                16usize,
                concat!("Size of: ", stringify!(Runnable))
            );
            assert_eq!(
                ::std::mem::align_of::<Runnable>(),
                8usize,
                concat!("Alignment of ", stringify!(Runnable))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<Runnable>())).mRefCnt as *const _ as usize },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(Runnable),
                    "::",
                    stringify!(mRefCnt)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct CancelableRunnable {
            pub _base: root::mozilla::Runnable,
            pub _base_1: root::nsICancelableRunnable,
        }
        #[test]
        fn bindgen_test_layout_CancelableRunnable() {
            assert_eq!(
                ::std::mem::size_of::<CancelableRunnable>(),
                24usize,
                concat!("Size of: ", stringify!(CancelableRunnable))
            );
            assert_eq!(
                ::std::mem::align_of::<CancelableRunnable>(),
                8usize,
                concat!("Alignment of ", stringify!(CancelableRunnable))
            );
        }
        pub mod image {
            #[allow(unused_imports)]
            use self::super::super::super::root;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct Image {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ProgressTracker {
                _unused: [u8; 0],
            }
            #[repr(C)]
            pub struct IProgressObserver__bindgen_vtable(::std::os::raw::c_void);
            #[doc = " An interface for observing changes to image state, as reported by"]
            #[doc = " ProgressTracker."]
            #[doc = ""]
            #[doc = " This is the ImageLib-internal version of imgINotificationObserver,"]
            #[doc = " essentially, with implementation details that code outside of ImageLib"]
            #[doc = " shouldn\'t see."]
            #[doc = ""]
            #[doc = " XXX(seth): It\'s preferable to avoid adding anything to this interface if"]
            #[doc = " possible.  In the long term, it would be ideal to get to a place where we can"]
            #[doc = " just use the imgINotificationObserver interface internally as well."]
            #[repr(C)]
            #[derive(Debug)]
            pub struct IProgressObserver {
                pub vtable_: *const IProgressObserver__bindgen_vtable,
                pub _base: u64,
            }
            #[test]
            fn bindgen_test_layout_IProgressObserver() {
                assert_eq!(
                    ::std::mem::size_of::<IProgressObserver>(),
                    16usize,
                    concat!("Size of: ", stringify!(IProgressObserver))
                );
                assert_eq!(
                    ::std::mem::align_of::<IProgressObserver>(),
                    8usize,
                    concat!("Alignment of ", stringify!(IProgressObserver))
                );
            }
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SupportsWeakPtr {
            pub _address: u8,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct WeakPtr {
            pub _address: u8,
        }
        pub type WeakPtr_WeakReference = u8;
        #[repr(C)]
        pub struct CounterStyle__bindgen_vtable(::std::os::raw::c_void);
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct CounterStyle {
            pub vtable_: *const CounterStyle__bindgen_vtable,
            pub mStyle: i32,
        }
        #[test]
        fn bindgen_test_layout_CounterStyle() {
            assert_eq!(
                ::std::mem::size_of::<CounterStyle>(),
                16usize,
                concat!("Size of: ", stringify!(CounterStyle))
            );
            assert_eq!(
                ::std::mem::align_of::<CounterStyle>(),
                8usize,
                concat!("Alignment of ", stringify!(CounterStyle))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<CounterStyle>())).mStyle as *const _ as usize },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(CounterStyle),
                    "::",
                    stringify!(mStyle)
                )
            );
        }
        #[repr(C)]
        pub struct AnonymousCounterStyle {
            pub _base: root::mozilla::CounterStyle,
            pub mRefCnt: u64,
            pub mSingleString: bool,
            pub mSystem: u8,
            pub mSymbols: root::nsTArray<::gecko_bindings::structs::nsString>,
        }
        pub type AnonymousCounterStyle_HasThreadSafeRefCnt = root::mozilla::TrueType;
        #[test]
        fn bindgen_test_layout_AnonymousCounterStyle() {
            assert_eq!(
                ::std::mem::size_of::<AnonymousCounterStyle>(),
                40usize,
                concat!("Size of: ", stringify!(AnonymousCounterStyle))
            );
            assert_eq!(
                ::std::mem::align_of::<AnonymousCounterStyle>(),
                8usize,
                concat!("Alignment of ", stringify!(AnonymousCounterStyle))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AnonymousCounterStyle>())).mRefCnt as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AnonymousCounterStyle),
                    "::",
                    stringify!(mRefCnt)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AnonymousCounterStyle>())).mSingleString as *const _
                        as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AnonymousCounterStyle),
                    "::",
                    stringify!(mSingleString)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AnonymousCounterStyle>())).mSystem as *const _ as usize
                },
                25usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AnonymousCounterStyle),
                    "::",
                    stringify!(mSystem)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AnonymousCounterStyle>())).mSymbols as *const _ as usize
                },
                32usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AnonymousCounterStyle),
                    "::",
                    stringify!(mSymbols)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct CounterStylePtr {
            pub mRaw: usize,
        }
        pub const CounterStylePtr_Type_eAnonymousCounterStyle: root::mozilla::CounterStylePtr_Type =
            0;
        pub const CounterStylePtr_Type_eAtom: root::mozilla::CounterStylePtr_Type = 1;
        pub const CounterStylePtr_Type_eMask: root::mozilla::CounterStylePtr_Type = 1;
        pub type CounterStylePtr_Type = u64;
        #[test]
        fn bindgen_test_layout_CounterStylePtr() {
            assert_eq!(
                ::std::mem::size_of::<CounterStylePtr>(),
                8usize,
                concat!("Size of: ", stringify!(CounterStylePtr))
            );
            assert_eq!(
                ::std::mem::align_of::<CounterStylePtr>(),
                8usize,
                concat!("Alignment of ", stringify!(CounterStylePtr))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<CounterStylePtr>())).mRaw as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(CounterStylePtr),
                    "::",
                    stringify!(mRaw)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct CounterStyleManager {
            pub mRefCnt: root::nsAutoRefCnt,
            pub mPresContext: *mut root::nsPresContext,
            pub mStyles: [u64; 4usize],
            pub mRetiredStyles: root::nsTArray<*mut root::mozilla::CounterStyle>,
        }
        pub type CounterStyleManager_HasThreadSafeRefCnt = root::mozilla::FalseType;
        #[test]
        fn bindgen_test_layout_CounterStyleManager() {
            assert_eq!(
                ::std::mem::size_of::<CounterStyleManager>(),
                56usize,
                concat!("Size of: ", stringify!(CounterStyleManager))
            );
            assert_eq!(
                ::std::mem::align_of::<CounterStyleManager>(),
                8usize,
                concat!("Alignment of ", stringify!(CounterStyleManager))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<CounterStyleManager>())).mRefCnt as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(CounterStyleManager),
                    "::",
                    stringify!(mRefCnt)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<CounterStyleManager>())).mPresContext as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(CounterStyleManager),
                    "::",
                    stringify!(mPresContext)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<CounterStyleManager>())).mStyles as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(CounterStyleManager),
                    "::",
                    stringify!(mStyles)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<CounterStyleManager>())).mRetiredStyles as *const _
                        as usize
                },
                48usize,
                concat!(
                    "Offset of field: ",
                    stringify!(CounterStyleManager),
                    "::",
                    stringify!(mRetiredStyles)
                )
            );
        }
        pub type Position = root::mozilla::StylePosition;
        #[repr(C)]
        pub struct StyleTransition {
            pub mTimingFunction: root::nsTimingFunction,
            pub mDuration: f32,
            pub mDelay: f32,
            pub mProperty: root::nsCSSPropertyID,
            pub mUnknownProperty: root::RefPtr<root::nsAtom>,
        }
        #[test]
        fn bindgen_test_layout_StyleTransition() {
            assert_eq!(
                ::std::mem::size_of::<StyleTransition>(),
                40usize,
                concat!("Size of: ", stringify!(StyleTransition))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleTransition>(),
                8usize,
                concat!("Alignment of ", stringify!(StyleTransition))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleTransition>())).mTimingFunction as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleTransition),
                    "::",
                    stringify!(mTimingFunction)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleTransition>())).mDuration as *const _ as usize
                },
                20usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleTransition),
                    "::",
                    stringify!(mDuration)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<StyleTransition>())).mDelay as *const _ as usize },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleTransition),
                    "::",
                    stringify!(mDelay)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleTransition>())).mProperty as *const _ as usize
                },
                28usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleTransition),
                    "::",
                    stringify!(mProperty)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleTransition>())).mUnknownProperty as *const _
                        as usize
                },
                32usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleTransition),
                    "::",
                    stringify!(mUnknownProperty)
                )
            );
        }
        #[repr(C)]
        pub struct StyleAnimation {
            pub mTimingFunction: root::nsTimingFunction,
            pub mDuration: f32,
            pub mDelay: f32,
            pub mName: root::RefPtr<root::nsAtom>,
            pub mDirection: root::mozilla::dom::PlaybackDirection,
            pub mFillMode: root::mozilla::dom::FillMode,
            pub mPlayState: root::mozilla::StyleAnimationPlayState,
            pub mIterationCount: f32,
        }
        #[test]
        fn bindgen_test_layout_StyleAnimation() {
            assert_eq!(
                ::std::mem::size_of::<StyleAnimation>(),
                48usize,
                concat!("Size of: ", stringify!(StyleAnimation))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleAnimation>(),
                8usize,
                concat!("Alignment of ", stringify!(StyleAnimation))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleAnimation>())).mTimingFunction as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleAnimation),
                    "::",
                    stringify!(mTimingFunction)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleAnimation>())).mDuration as *const _ as usize
                },
                20usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleAnimation),
                    "::",
                    stringify!(mDuration)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<StyleAnimation>())).mDelay as *const _ as usize },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleAnimation),
                    "::",
                    stringify!(mDelay)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<StyleAnimation>())).mName as *const _ as usize },
                32usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleAnimation),
                    "::",
                    stringify!(mName)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleAnimation>())).mDirection as *const _ as usize
                },
                40usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleAnimation),
                    "::",
                    stringify!(mDirection)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleAnimation>())).mFillMode as *const _ as usize
                },
                41usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleAnimation),
                    "::",
                    stringify!(mFillMode)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleAnimation>())).mPlayState as *const _ as usize
                },
                42usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleAnimation),
                    "::",
                    stringify!(mPlayState)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleAnimation>())).mIterationCount as *const _ as usize
                },
                44usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleAnimation),
                    "::",
                    stringify!(mIterationCount)
                )
            );
        }
        #[repr(C)]
        pub struct StyleSVGPath {
            pub mPath: root::mozilla::StyleArcSlice<root::mozilla::StylePathCommand>,
            pub mFillRule: root::mozilla::StyleFillRule,
        }
        #[test]
        fn bindgen_test_layout_StyleSVGPath() {
            assert_eq!(
                ::std::mem::size_of::<StyleSVGPath>(),
                16usize,
                concat!("Size of: ", stringify!(StyleSVGPath))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleSVGPath>(),
                8usize,
                concat!("Alignment of ", stringify!(StyleSVGPath))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<StyleSVGPath>())).mPath as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSVGPath),
                    "::",
                    stringify!(mPath)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<StyleSVGPath>())).mFillRule as *const _ as usize },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSVGPath),
                    "::",
                    stringify!(mFillRule)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct StyleShapeSource {
            pub __bindgen_anon_1: root::mozilla::StyleShapeSource__bindgen_ty_1,
            pub mType: root::mozilla::StyleShapeSourceType,
            pub mReferenceBox: root::mozilla::StyleGeometryBox,
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct StyleShapeSource__bindgen_ty_1 {
            pub mBasicShape:
                root::__BindgenUnionField<root::mozilla::UniquePtr<root::mozilla::StyleBasicShape>>,
            pub mShapeImage:
                root::__BindgenUnionField<root::mozilla::UniquePtr<root::nsStyleImage>>,
            pub mSVGPath:
                root::__BindgenUnionField<root::mozilla::UniquePtr<root::mozilla::StyleSVGPath>>,
            pub bindgen_union_field: u64,
        }
        #[test]
        fn bindgen_test_layout_StyleShapeSource__bindgen_ty_1() {
            assert_eq!(
                ::std::mem::size_of::<StyleShapeSource__bindgen_ty_1>(),
                8usize,
                concat!("Size of: ", stringify!(StyleShapeSource__bindgen_ty_1))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleShapeSource__bindgen_ty_1>(),
                8usize,
                concat!("Alignment of ", stringify!(StyleShapeSource__bindgen_ty_1))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleShapeSource__bindgen_ty_1>())).mBasicShape
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleShapeSource__bindgen_ty_1),
                    "::",
                    stringify!(mBasicShape)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleShapeSource__bindgen_ty_1>())).mShapeImage
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleShapeSource__bindgen_ty_1),
                    "::",
                    stringify!(mShapeImage)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleShapeSource__bindgen_ty_1>())).mSVGPath as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleShapeSource__bindgen_ty_1),
                    "::",
                    stringify!(mSVGPath)
                )
            );
        }
        #[test]
        fn bindgen_test_layout_StyleShapeSource() {
            assert_eq!(
                ::std::mem::size_of::<StyleShapeSource>(),
                16usize,
                concat!("Size of: ", stringify!(StyleShapeSource))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleShapeSource>(),
                8usize,
                concat!("Alignment of ", stringify!(StyleShapeSource))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<StyleShapeSource>())).mType as *const _ as usize },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleShapeSource),
                    "::",
                    stringify!(mType)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleShapeSource>())).mReferenceBox as *const _ as usize
                },
                9usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleShapeSource),
                    "::",
                    stringify!(mReferenceBox)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct StyleMotion {
            pub mOffsetPath: root::mozilla::StyleShapeSource,
        }
        #[test]
        fn bindgen_test_layout_StyleMotion() {
            assert_eq!(
                ::std::mem::size_of::<StyleMotion>(),
                16usize,
                concat!("Size of: ", stringify!(StyleMotion))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleMotion>(),
                8usize,
                concat!("Alignment of ", stringify!(StyleMotion))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<StyleMotion>())).mOffsetPath as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleMotion),
                    "::",
                    stringify!(mOffsetPath)
                )
            );
        }
        #[doc = " <div rustbindgen=\"true\" replaces=\"mozilla::UniquePtr\">"]
        #[doc = ""]
        #[doc = " TODO(Emilio): This is a workaround and we should be able to get rid of this"]
        #[doc = " one."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct UniquePtr<T> {
            pub mPtr: *mut T,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct AnimationValue {
            pub mServo: root::RefPtr<root::RawServoAnimationValue>,
        }
        #[test]
        fn bindgen_test_layout_AnimationValue() {
            assert_eq!(
                ::std::mem::size_of::<AnimationValue>(),
                8usize,
                concat!("Size of: ", stringify!(AnimationValue))
            );
            assert_eq!(
                ::std::mem::align_of::<AnimationValue>(),
                8usize,
                concat!("Alignment of ", stringify!(AnimationValue))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<AnimationValue>())).mServo as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AnimationValue),
                    "::",
                    stringify!(mServo)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct PropertyStyleAnimationValuePair {
            pub mProperty: root::nsCSSPropertyID,
            pub mValue: root::mozilla::AnimationValue,
        }
        #[test]
        fn bindgen_test_layout_PropertyStyleAnimationValuePair() {
            assert_eq!(
                ::std::mem::size_of::<PropertyStyleAnimationValuePair>(),
                16usize,
                concat!("Size of: ", stringify!(PropertyStyleAnimationValuePair))
            );
            assert_eq!(
                ::std::mem::align_of::<PropertyStyleAnimationValuePair>(),
                8usize,
                concat!("Alignment of ", stringify!(PropertyStyleAnimationValuePair))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PropertyStyleAnimationValuePair>())).mProperty
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PropertyStyleAnimationValuePair),
                    "::",
                    stringify!(mProperty)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PropertyStyleAnimationValuePair>())).mValue as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PropertyStyleAnimationValuePair),
                    "::",
                    stringify!(mValue)
                )
            );
        }
        #[doc = " Similarly to OffTheBooksMutex, OffTheBooksCondvar is identical to CondVar,"]
        #[doc = " except that OffTheBooksCondVar doesn\'t include leak checking.  Sometimes"]
        #[doc = " you want to intentionally \"leak\" a CondVar until shutdown; in these cases,"]
        #[doc = " OffTheBooksCondVar is for you."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct OffTheBooksCondVar {
            pub mLock: *mut root::mozilla::OffTheBooksMutex,
            pub mImpl: root::mozilla::detail::ConditionVariableImpl,
        }
        #[test]
        fn bindgen_test_layout_OffTheBooksCondVar() {
            assert_eq!(
                ::std::mem::size_of::<OffTheBooksCondVar>(),
                56usize,
                concat!("Size of: ", stringify!(OffTheBooksCondVar))
            );
            assert_eq!(
                ::std::mem::align_of::<OffTheBooksCondVar>(),
                8usize,
                concat!("Alignment of ", stringify!(OffTheBooksCondVar))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<OffTheBooksCondVar>())).mLock as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(OffTheBooksCondVar),
                    "::",
                    stringify!(mLock)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<OffTheBooksCondVar>())).mImpl as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(OffTheBooksCondVar),
                    "::",
                    stringify!(mImpl)
                )
            );
        }
        #[doc = " CondVar"]
        #[doc = " Vanilla condition variable.  Please don\'t use this unless you have a"]
        #[doc = " compelling reason --- Monitor provides a simpler API."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct CondVar {
            pub _base: root::mozilla::OffTheBooksCondVar,
        }
        #[test]
        fn bindgen_test_layout_CondVar() {
            assert_eq!(
                ::std::mem::size_of::<CondVar>(),
                56usize,
                concat!("Size of: ", stringify!(CondVar))
            );
            assert_eq!(
                ::std::mem::align_of::<CondVar>(),
                8usize,
                concat!("Alignment of ", stringify!(CondVar))
            );
        }
        #[doc = " Monitor provides a *non*-reentrant monitor: *not* a Java-style"]
        #[doc = " monitor.  If your code needs support for reentrancy, use"]
        #[doc = " ReentrantMonitor instead.  (Rarely should reentrancy be needed.)"]
        #[doc = ""]
        #[doc = " Instead of directly calling Monitor methods, it\'s safer and simpler"]
        #[doc = " to instead use the RAII wrappers MonitorAutoLock and"]
        #[doc = " MonitorAutoUnlock."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct Monitor {
            pub mMutex: root::mozilla::Mutex,
            pub mCondVar: root::mozilla::CondVar,
        }
        #[test]
        fn bindgen_test_layout_Monitor() {
            assert_eq!(
                ::std::mem::size_of::<Monitor>(),
                96usize,
                concat!("Size of: ", stringify!(Monitor))
            );
            assert_eq!(
                ::std::mem::align_of::<Monitor>(),
                8usize,
                concat!("Alignment of ", stringify!(Monitor))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<Monitor>())).mMutex as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(Monitor),
                    "::",
                    stringify!(mMutex)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<Monitor>())).mCondVar as *const _ as usize },
                40usize,
                concat!(
                    "Offset of field: ",
                    stringify!(Monitor),
                    "::",
                    stringify!(mCondVar)
                )
            );
        }
        #[repr(C)]
        pub struct MozPromiseRefcountable__bindgen_vtable(::std::os::raw::c_void);
        #[repr(C)]
        #[derive(Debug)]
        pub struct MozPromiseRefcountable {
            pub vtable_: *const MozPromiseRefcountable__bindgen_vtable,
            pub mRefCnt: u64,
        }
        pub type MozPromiseRefcountable_HasThreadSafeRefCnt = root::mozilla::TrueType;
        #[test]
        fn bindgen_test_layout_MozPromiseRefcountable() {
            assert_eq!(
                ::std::mem::size_of::<MozPromiseRefcountable>(),
                16usize,
                concat!("Size of: ", stringify!(MozPromiseRefcountable))
            );
            assert_eq!(
                ::std::mem::align_of::<MozPromiseRefcountable>(),
                8usize,
                concat!("Alignment of ", stringify!(MozPromiseRefcountable))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<MozPromiseRefcountable>())).mRefCnt as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(MozPromiseRefcountable),
                    "::",
                    stringify!(mRefCnt)
                )
            );
        }
        pub type MozPromise_ResolveValueType<ResolveValueT> = ResolveValueT;
        pub type MozPromise_RejectValueType<RejectValueT> = RejectValueT;
        #[repr(C)]
        #[derive(Debug)]
        pub struct MozPromise_ResolveOrRejectValue {
            pub mValue: root::mozilla::MozPromise_ResolveOrRejectValue_Storage,
        }
        pub const MozPromise_ResolveOrRejectValue_NothingIndex:
            root::mozilla::MozPromise_ResolveOrRejectValue__bindgen_ty_1 = 0;
        pub const MozPromise_ResolveOrRejectValue_ResolveIndex:
            root::mozilla::MozPromise_ResolveOrRejectValue__bindgen_ty_1 = 0;
        pub const MozPromise_ResolveOrRejectValue_RejectIndex:
            root::mozilla::MozPromise_ResolveOrRejectValue__bindgen_ty_1 = 0;
        pub type MozPromise_ResolveOrRejectValue__bindgen_ty_1 = i32;
        pub type MozPromise_ResolveOrRejectValue_Storage = root::mozilla::Variant;
        pub type MozPromise_AllPromiseType = u8;
        #[repr(C)]
        #[derive(Debug)]
        pub struct MozPromise_AllPromiseHolder {
            pub _base: root::mozilla::MozPromiseRefcountable,
            pub mResolveValues: u8,
            pub mPromise: root::RefPtr<root::mozilla::MozPromise_AllPromiseType>,
            pub mOutstandingPromises: usize,
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct MozPromise_Request {
            pub _base: root::mozilla::MozPromiseRefcountable,
            pub mComplete: bool,
            pub mDisconnected: bool,
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct MozPromise_ThenValueBase {
            pub _base: root::mozilla::MozPromise_Request,
            pub mResponseTarget: root::nsCOMPtr,
            pub mCallSite: *const ::std::os::raw::c_char,
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct MozPromise_ThenValueBase_ResolveOrRejectRunnable {
            pub _base: root::mozilla::CancelableRunnable,
            pub mThenValue: root::RefPtr<root::mozilla::MozPromise_ThenValueBase>,
            pub mPromise: u8,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct MozPromise_ThenValue {
            pub _address: u8,
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct MozPromise_ThenCommand<ThenValueType> {
            pub mCallSite: *const ::std::os::raw::c_char,
            pub mThenValue: root::RefPtr<ThenValueType>,
            pub mReceiver: u8,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<ThenValueType>>,
        }
        pub type MozPromise_ThenCommand_PromiseType = [u8; 0usize];
        pub type MozPromise_ThenCommand_Private = [u8; 0usize];
        #[repr(C)]
        #[derive(Debug)]
        pub struct MozPromise_Private {
            pub _base: u8,
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct MozPromiseHolder<PromiseType> {
            pub mMonitor: *mut root::mozilla::Monitor,
            pub mPromise: root::RefPtr<PromiseType>,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<PromiseType>>,
        }
        #[doc = " Struct for data common to CSSStyleSheetInner and ServoStyleSheet."]
        #[repr(C)]
        pub struct StyleSheetInfo {
            pub mSheetURI: root::nsCOMPtr,
            pub mOriginalSheetURI: root::nsCOMPtr,
            pub mBaseURI: root::nsCOMPtr,
            pub mPrincipal: root::nsCOMPtr,
            pub mCORSMode: root::mozilla::CORSMode,
            pub mReferrerPolicy: root::mozilla::StyleSheetInfo_ReferrerPolicy,
            pub mIntegrity: root::mozilla::dom::SRIMetadata,
            pub mFirstChild: root::RefPtr<root::mozilla::StyleSheet>,
            pub mSheets: [u64; 10usize],
            pub mSourceMapURL: ::gecko_bindings::structs::nsString,
            pub mSourceMapURLFromComment: ::gecko_bindings::structs::nsString,
            pub mSourceURL: ::gecko_bindings::structs::nsString,
            pub mContents: root::RefPtr<root::RawServoStyleSheetContents>,
            pub mSharedMemory: root::RefPtr<root::nsLayoutStylesheetCacheShm>,
            pub mURLData: root::RefPtr<root::mozilla::URLExtraData>,
        }
        pub use self::super::super::root::mozilla::net::ReferrerPolicy as StyleSheetInfo_ReferrerPolicy;
        #[test]
        fn bindgen_test_layout_StyleSheetInfo() {
            assert_eq!(
                ::std::mem::size_of::<StyleSheetInfo>(),
                248usize,
                concat!("Size of: ", stringify!(StyleSheetInfo))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleSheetInfo>(),
                8usize,
                concat!("Alignment of ", stringify!(StyleSheetInfo))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleSheetInfo>())).mSheetURI as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSheetInfo),
                    "::",
                    stringify!(mSheetURI)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleSheetInfo>())).mOriginalSheetURI as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSheetInfo),
                    "::",
                    stringify!(mOriginalSheetURI)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<StyleSheetInfo>())).mBaseURI as *const _ as usize },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSheetInfo),
                    "::",
                    stringify!(mBaseURI)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleSheetInfo>())).mPrincipal as *const _ as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSheetInfo),
                    "::",
                    stringify!(mPrincipal)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleSheetInfo>())).mCORSMode as *const _ as usize
                },
                32usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSheetInfo),
                    "::",
                    stringify!(mCORSMode)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleSheetInfo>())).mReferrerPolicy as *const _ as usize
                },
                36usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSheetInfo),
                    "::",
                    stringify!(mReferrerPolicy)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleSheetInfo>())).mIntegrity as *const _ as usize
                },
                40usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSheetInfo),
                    "::",
                    stringify!(mIntegrity)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleSheetInfo>())).mFirstChild as *const _ as usize
                },
                88usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSheetInfo),
                    "::",
                    stringify!(mFirstChild)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<StyleSheetInfo>())).mSheets as *const _ as usize },
                96usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSheetInfo),
                    "::",
                    stringify!(mSheets)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleSheetInfo>())).mSourceMapURL as *const _ as usize
                },
                176usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSheetInfo),
                    "::",
                    stringify!(mSourceMapURL)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleSheetInfo>())).mSourceMapURLFromComment as *const _
                        as usize
                },
                192usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSheetInfo),
                    "::",
                    stringify!(mSourceMapURLFromComment)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleSheetInfo>())).mSourceURL as *const _ as usize
                },
                208usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSheetInfo),
                    "::",
                    stringify!(mSourceURL)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleSheetInfo>())).mContents as *const _ as usize
                },
                224usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSheetInfo),
                    "::",
                    stringify!(mContents)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleSheetInfo>())).mSharedMemory as *const _ as usize
                },
                232usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSheetInfo),
                    "::",
                    stringify!(mSharedMemory)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<StyleSheetInfo>())).mURLData as *const _ as usize },
                240usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSheetInfo),
                    "::",
                    stringify!(mURLData)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct ServoCSSRuleList {
            _unused: [u8; 0],
        }
        pub type StyleSheetParsePromise = [u64; 14usize];
        pub const StyleSheetState_Disabled: root::mozilla::StyleSheetState = 1;
        pub const StyleSheetState_Complete: root::mozilla::StyleSheetState = 2;
        pub const StyleSheetState_ForcedUniqueInner: root::mozilla::StyleSheetState = 4;
        pub const StyleSheetState_ModifiedRules: root::mozilla::StyleSheetState = 8;
        pub type StyleSheetState = u8;
        #[repr(C)]
        pub struct StyleSheet {
            pub _base: root::nsICSSLoaderObserver,
            pub _base_1: root::nsWrapperCache,
            pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
            pub mParent: *mut root::mozilla::StyleSheet,
            pub mTitle: ::gecko_bindings::structs::nsString,
            pub mDocumentOrShadowRoot: *mut root::mozilla::dom::DocumentOrShadowRoot,
            pub mOwningNode: *mut root::nsINode,
            pub mOwnerRule: *mut root::mozilla::dom::CSSImportRule,
            pub mMedia: root::RefPtr<root::mozilla::dom::MediaList>,
            pub mNext: root::RefPtr<root::mozilla::StyleSheet>,
            pub mParsingMode: root::mozilla::css::SheetParsingMode,
            pub mState: root::mozilla::StyleSheet_State,
            pub mAssociationMode: root::mozilla::StyleSheet_AssociationMode,
            pub mInner: *mut root::mozilla::StyleSheetInfo,
            pub mStyleSets: root::nsTArray<*mut root::mozilla::ServoStyleSet>,
            pub mRuleList: root::RefPtr<root::mozilla::ServoCSSRuleList>,
            pub mParsePromise:
                root::mozilla::MozPromiseHolder<root::mozilla::StyleSheetParsePromise>,
        }
        pub use self::super::super::root::mozilla::StyleSheetState as StyleSheet_State;
        pub type StyleSheet_HasThreadSafeRefCnt = root::mozilla::FalseType;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleSheet_cycleCollection {
            pub _base: root::nsXPCOMCycleCollectionParticipant,
        }
        #[test]
        fn bindgen_test_layout_StyleSheet_cycleCollection() {
            assert_eq!(
                ::std::mem::size_of::<StyleSheet_cycleCollection>(),
                16usize,
                concat!("Size of: ", stringify!(StyleSheet_cycleCollection))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleSheet_cycleCollection>(),
                8usize,
                concat!("Alignment of ", stringify!(StyleSheet_cycleCollection))
            );
        }
        pub const StyleSheet_ChangeType_Added: root::mozilla::StyleSheet_ChangeType = 0;
        pub const StyleSheet_ChangeType_Removed: root::mozilla::StyleSheet_ChangeType = 1;
        pub const StyleSheet_ChangeType_ApplicableStateChanged:
            root::mozilla::StyleSheet_ChangeType = 2;
        pub const StyleSheet_ChangeType_RuleAdded: root::mozilla::StyleSheet_ChangeType = 3;
        pub const StyleSheet_ChangeType_RuleRemoved: root::mozilla::StyleSheet_ChangeType = 4;
        pub const StyleSheet_ChangeType_RuleChanged: root::mozilla::StyleSheet_ChangeType = 5;
        #[doc = " The different changes that a stylesheet may go through."]
        #[doc = ""]
        #[doc = " Used by the StyleSets in order to handle more efficiently some kinds of"]
        #[doc = " changes."]
        pub type StyleSheet_ChangeType = i32;
        pub const StyleSheet_AssociationMode_OwnedByDocumentOrShadowRoot:
            root::mozilla::StyleSheet_AssociationMode = 0;
        pub const StyleSheet_AssociationMode_NotOwnedByDocumentOrShadowRoot:
            root::mozilla::StyleSheet_AssociationMode = 1;
        pub type StyleSheet_AssociationMode = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StyleSheet_ChildSheetListBuilder {
            pub sheetSlot: *mut root::RefPtr<root::mozilla::StyleSheet>,
            pub parent: *mut root::mozilla::StyleSheet,
        }
        #[test]
        fn bindgen_test_layout_StyleSheet_ChildSheetListBuilder() {
            assert_eq!(
                ::std::mem::size_of::<StyleSheet_ChildSheetListBuilder>(),
                16usize,
                concat!("Size of: ", stringify!(StyleSheet_ChildSheetListBuilder))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleSheet_ChildSheetListBuilder>(),
                8usize,
                concat!(
                    "Alignment of ",
                    stringify!(StyleSheet_ChildSheetListBuilder)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleSheet_ChildSheetListBuilder>())).sheetSlot
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSheet_ChildSheetListBuilder),
                    "::",
                    stringify!(sheetSlot)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StyleSheet_ChildSheetListBuilder>())).parent as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StyleSheet_ChildSheetListBuilder),
                    "::",
                    stringify!(parent)
                )
            );
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla10StyleSheet21_cycleCollectorGlobalE"]
            pub static mut StyleSheet__cycleCollectorGlobal:
                root::mozilla::StyleSheet_cycleCollection;
        }
        #[test]
        fn bindgen_test_layout_StyleSheet() {
            assert_eq!(
                ::std::mem::size_of::<StyleSheet>(),
                152usize,
                concat!("Size of: ", stringify!(StyleSheet))
            );
            assert_eq!(
                ::std::mem::align_of::<StyleSheet>(),
                8usize,
                concat!("Alignment of ", stringify!(StyleSheet))
            );
        }
        pub type MruCache_KeyType<Key> = Key;
        pub type MruCache_ValueType<Value> = Value;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct MruCache_Entry<Value> {
            pub mEntry: *mut root::mozilla::MruCache_ValueType<Value>,
            pub mMatch: bool,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<Value>>,
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct URIPrincipalReferrerPolicyAndCORSModeHashKey {
            pub _base: root::nsURIHashKey,
            pub mPrincipal: root::nsCOMPtr,
            pub mCORSMode: root::mozilla::CORSMode,
            pub mReferrerPolicy:
                root::mozilla::URIPrincipalReferrerPolicyAndCORSModeHashKey_ReferrerPolicy,
        }
        pub type URIPrincipalReferrerPolicyAndCORSModeHashKey_KeyType =
            *mut root::mozilla::URIPrincipalReferrerPolicyAndCORSModeHashKey;
        pub type URIPrincipalReferrerPolicyAndCORSModeHashKey_KeyTypePointer =
            *const root::mozilla::URIPrincipalReferrerPolicyAndCORSModeHashKey;
        pub use self::super::super::root::mozilla::net::ReferrerPolicy as URIPrincipalReferrerPolicyAndCORSModeHashKey_ReferrerPolicy;
        pub const URIPrincipalReferrerPolicyAndCORSModeHashKey_ALLOW_MEMMOVE:
            root::mozilla::URIPrincipalReferrerPolicyAndCORSModeHashKey__bindgen_ty_1 = 1;
        pub type URIPrincipalReferrerPolicyAndCORSModeHashKey__bindgen_ty_1 = u32;
        #[test]
        fn bindgen_test_layout_URIPrincipalReferrerPolicyAndCORSModeHashKey() {
            assert_eq!(
                ::std::mem::size_of::<URIPrincipalReferrerPolicyAndCORSModeHashKey>(),
                24usize,
                concat!(
                    "Size of: ",
                    stringify!(URIPrincipalReferrerPolicyAndCORSModeHashKey)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<URIPrincipalReferrerPolicyAndCORSModeHashKey>(),
                8usize,
                concat!(
                    "Alignment of ",
                    stringify!(URIPrincipalReferrerPolicyAndCORSModeHashKey)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<URIPrincipalReferrerPolicyAndCORSModeHashKey>()))
                        .mPrincipal as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(URIPrincipalReferrerPolicyAndCORSModeHashKey),
                    "::",
                    stringify!(mPrincipal)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<URIPrincipalReferrerPolicyAndCORSModeHashKey>()))
                        .mCORSMode as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(URIPrincipalReferrerPolicyAndCORSModeHashKey),
                    "::",
                    stringify!(mCORSMode)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<URIPrincipalReferrerPolicyAndCORSModeHashKey>()))
                        .mReferrerPolicy as *const _ as usize
                },
                20usize,
                concat!(
                    "Offset of field: ",
                    stringify!(URIPrincipalReferrerPolicyAndCORSModeHashKey),
                    "::",
                    stringify!(mReferrerPolicy)
                )
            );
        }
        #[doc = " An encoding as defined in the Encoding Standard"]
        #[doc = " (https://encoding.spec.whatwg.org/)."]
        #[doc = ""]
        #[doc = " See https://docs.rs/encoding_rs/ for the Rust API docs."]
        #[doc = ""]
        #[doc = " An _encoding_ defines a mapping from a byte sequence to a Unicode code point"]
        #[doc = " sequence and, in most cases, vice versa. Each encoding has a name, an output"]
        #[doc = " encoding, and one or more labels."]
        #[doc = ""]
        #[doc = " _Labels_ are ASCII-case-insensitive strings that are used to identify an"]
        #[doc = " encoding in formats and protocols. The _name_ of the encoding is the"]
        #[doc = " preferred label in the case appropriate for returning from the"]
        #[doc = " `characterSet` property of the `Document` DOM interface, except for"]
        #[doc = " the replacement encoding whose name is not one of its labels."]
        #[doc = ""]
        #[doc = " The _output encoding_ is the encoding used for form submission and URL"]
        #[doc = " parsing on Web pages in the encoding. This is UTF-8 for the replacement,"]
        #[doc = " UTF-16LE and UTF-16BE encodings and the encoding itself for other"]
        #[doc = " encodings."]
        #[doc = ""]
        #[doc = " # Streaming vs. Non-Streaming"]
        #[doc = ""]
        #[doc = " When you have the entire input in a single buffer, you can use the"]
        #[doc = " methods `Decode()`, `DecodeWithBOMRemoval()`,"]
        #[doc = " `DecodeWithoutBOMHandling()`,"]
        #[doc = " `DecodeWithoutBOMHandlingAndWithoutReplacement()` and"]
        #[doc = " `Encode()`. Unlike the rest of the API (apart from the `NewDecoder()` and"]
        #[doc = " NewEncoder()` methods), these methods perform heap allocations. You should"]
        #[doc = " the `Decoder` and `Encoder` objects when your input is split into multiple"]
        #[doc = " buffers or when you want to control the allocation of the output buffers."]
        #[doc = ""]
        #[doc = " # Instances"]
        #[doc = ""]
        #[doc = " All instances of `Encoding` are statically allocated and have the process\'s"]
        #[doc = " lifetime. There is precisely one unique `Encoding` instance for each"]
        #[doc = " encoding defined in the Encoding Standard."]
        #[doc = ""]
        #[doc = " To obtain a reference to a particular encoding whose identity you know at"]
        #[doc = " compile time, use a `static` that refers to encoding. There is a `static`"]
        #[doc = " for each encoding. The `static`s are named in all caps with hyphens"]
        #[doc = " replaced with underscores and with `_ENCODING` appended to the"]
        #[doc = " name. For example, if you know at compile time that you will want to"]
        #[doc = " decode using the UTF-8 encoding, use the `UTF_8_ENCODING` `static`."]
        #[doc = ""]
        #[doc = " If you don\'t know what encoding you need at compile time and need to"]
        #[doc = " dynamically get an encoding by label, use `Encoding::for_label()`."]
        #[doc = ""]
        #[doc = " Pointers to `Encoding` can be compared with `==` to check for the sameness"]
        #[doc = " of two encodings."]
        #[doc = ""]
        #[doc = " A pointer to a `mozilla::Encoding` in C++ is the same thing as a pointer"]
        #[doc = " to an `encoding_rs::Encoding` in Rust. When writing FFI code, use"]
        #[doc = " `const mozilla::Encoding*` in the C signature and"]
        #[doc = " `*const encoding_rs::Encoding` is the corresponding Rust signature."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct Encoding {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_Encoding() {
            assert_eq!(
                ::std::mem::size_of::<Encoding>(),
                1usize,
                concat!("Size of: ", stringify!(Encoding))
            );
            assert_eq!(
                ::std::mem::align_of::<Encoding>(),
                1usize,
                concat!("Alignment of ", stringify!(Encoding))
            );
        }
        #[doc = " A converter that decodes a byte stream into Unicode according to a"]
        #[doc = " character encoding in a streaming (incremental) manner."]
        #[doc = ""]
        #[doc = " The various `Decode*` methods take an input buffer (`aSrc`) and an output"]
        #[doc = " buffer `aDst` both of which are caller-allocated. There are variants for"]
        #[doc = " both UTF-8 and UTF-16 output buffers."]
        #[doc = ""]
        #[doc = " A `Decode*` method decodes bytes from `aSrc` into Unicode characters stored"]
        #[doc = " into `aDst` until one of the following three things happens:"]
        #[doc = ""]
        #[doc = " 1. A malformed byte sequence is encountered (`*WithoutReplacement`"]
        #[doc = "    variants only)."]
        #[doc = ""]
        #[doc = " 2. The output buffer has been filled so near capacity that the decoder"]
        #[doc = "    cannot be sure that processing an additional byte of input wouldn\'t"]
        #[doc = "    cause so much output that the output buffer would overflow."]
        #[doc = ""]
        #[doc = " 3. All the input bytes have been processed."]
        #[doc = ""]
        #[doc = " The `Decode*` method then returns tuple of a status indicating which one"]
        #[doc = " of the three reasons to return happened, how many input bytes were read,"]
        #[doc = " how many output code units (`uint8_t` when decoding into UTF-8 and `char16_t`"]
        #[doc = " when decoding to UTF-16) were written, and in the case of the"]
        #[doc = " variants performing replacement, a boolean indicating whether an error was"]
        #[doc = " replaced with the REPLACEMENT CHARACTER during the call."]
        #[doc = ""]
        #[doc = " The number of bytes \"written\" is what\'s logically written. Garbage may be"]
        #[doc = " written in the output buffer beyond the point logically written to."]
        #[doc = ""]
        #[doc = " In the case of the `*WithoutReplacement` variants, the status is a"]
        #[doc = " `uint32_t` whose possible values are packed info about a malformed byte"]
        #[doc = " sequence, `kOutputFull` and `kInputEmpty` corresponding to the three cases"]
        #[doc = " listed above)."]
        #[doc = ""]
        #[doc = " Packed info about malformed sequences has the following format:"]
        #[doc = " The lowest 8 bits, which can have the decimal value 0, 1, 2 or 3,"]
        #[doc = " indicate the number of bytes that were consumed after the malformed"]
        #[doc = " sequence and whose next-lowest 8 bits, when shifted right by 8 indicate"]
        #[doc = " the length of the malformed byte sequence (possible decimal values 1, 2,"]
        #[doc = " 3 or 4). The maximum possible sum of the two is 6."]
        #[doc = ""]
        #[doc = " In the case of methods whose name does not end with"]
        #[doc = " `*WithoutReplacement`, malformed sequences are automatically replaced"]
        #[doc = " with the REPLACEMENT CHARACTER and errors do not cause the methods to"]
        #[doc = " return early."]
        #[doc = ""]
        #[doc = " When decoding to UTF-8, the output buffer must have at least 4 bytes of"]
        #[doc = " space. When decoding to UTF-16, the output buffer must have at least two"]
        #[doc = " UTF-16 code units (`char16_t`) of space."]
        #[doc = ""]
        #[doc = " When decoding to UTF-8 without replacement, the methods are guaranteed"]
        #[doc = " not to return indicating that more output space is needed if the length"]
        #[doc = " of the output buffer is at least the length returned by"]
        #[doc = " `MaxUTF8BufferLengthWithoutReplacement()`. When decoding to UTF-8"]
        #[doc = " with replacement, the length of the output buffer that guarantees the"]
        #[doc = " methods not to return indicating that more output space is needed is given"]
        #[doc = " by `MaxUTF8BufferLength()`. When decoding to UTF-16 with"]
        #[doc = " or without replacement, the length of the output buffer that guarantees"]
        #[doc = " the methods not to return indicating that more output space is needed is"]
        #[doc = " given by `MaxUTF16BufferLength()`."]
        #[doc = ""]
        #[doc = " The output written into `aDst` is guaranteed to be valid UTF-8 or UTF-16,"]
        #[doc = " and the output after each `Decode*` call is guaranteed to consist of"]
        #[doc = " complete characters. (I.e. the code unit sequence for the last character is"]
        #[doc = " guaranteed not to be split across output buffers.)"]
        #[doc = ""]
        #[doc = " The boolean argument `aLast` indicates that the end of the stream is reached"]
        #[doc = " when all the bytes in `aSrc` have been consumed."]
        #[doc = ""]
        #[doc = " A `Decoder` object can be used to incrementally decode a byte stream."]
        #[doc = ""]
        #[doc = " During the processing of a single stream, the caller must call `Decode*`"]
        #[doc = " zero or more times with `aLast` set to `false` and then call `Decode*` at"]
        #[doc = " least once with `aLast` set to `true`. If `Decode*` returns `kInputEmpty`,"]
        #[doc = " the processing of the stream has ended. Otherwise, the caller must call"]
        #[doc = " `Decode*` again with `aLast` set to `true` (or treat a malformed result,"]
        #[doc = " i.e. neither `kInputEmpty` nor `kOutputFull`, as a fatal error)."]
        #[doc = ""]
        #[doc = " Once the stream has ended, the `Decoder` object must not be used anymore."]
        #[doc = " That is, you need to create another one to process another stream."]
        #[doc = ""]
        #[doc = " When the decoder returns `kOutputFull` or the decoder returns a malformed"]
        #[doc = " result and the caller does not wish to treat it as a fatal error, the input"]
        #[doc = " buffer `aSrc` may not have been completely consumed. In that case, the caller"]
        #[doc = " must pass the unconsumed contents of `aSrc` to `Decode*` again upon the next"]
        #[doc = " call."]
        #[doc = ""]
        #[doc = " # Infinite loops"]
        #[doc = ""]
        #[doc = " When converting with a fixed-size output buffer whose size is too small to"]
        #[doc = " accommodate one character of output, an infinite loop ensues. When"]
        #[doc = " converting with a fixed-size output buffer, it generally makes sense to"]
        #[doc = " make the buffer fairly large (e.g. couple of kilobytes)."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct Decoder {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_Decoder() {
            assert_eq!(
                ::std::mem::size_of::<Decoder>(),
                1usize,
                concat!("Size of: ", stringify!(Decoder))
            );
            assert_eq!(
                ::std::mem::align_of::<Decoder>(),
                1usize,
                concat!("Alignment of ", stringify!(Decoder))
            );
        }
        #[doc = " A converter that encodes a Unicode stream into bytes according to a"]
        #[doc = " character encoding in a streaming (incremental) manner."]
        #[doc = ""]
        #[doc = " The various `Encode*` methods take an input buffer (`aSrc`) and an output"]
        #[doc = " buffer `aDst` both of which are caller-allocated. There are variants for"]
        #[doc = " both UTF-8 and UTF-16 input buffers."]
        #[doc = ""]
        #[doc = " An `Encode*` method encode characters from `aSrc` into bytes characters"]
        #[doc = " stored into `aDst` until one of the following three things happens:"]
        #[doc = ""]
        #[doc = " 1. An unmappable character is encountered (`*WithoutReplacement` variants"]
        #[doc = "    only)."]
        #[doc = ""]
        #[doc = " 2. The output buffer has been filled so near capacity that the decoder"]
        #[doc = "    cannot be sure that processing an additional character of input wouldn\'t"]
        #[doc = "    cause so much output that the output buffer would overflow."]
        #[doc = ""]
        #[doc = " 3. All the input characters have been processed."]
        #[doc = ""]
        #[doc = " The `Encode*` method then returns tuple of a status indicating which one"]
        #[doc = " of the three reasons to return happened, how many input code units (`uint8_t`"]
        #[doc = " when encoding from UTF-8 and `char16_t` when encoding from UTF-16) were read,"]
        #[doc = " how many output bytes were written, and in the case of the variants that"]
        #[doc = " perform replacement, a boolean indicating whether an unmappable"]
        #[doc = " character was replaced with a numeric character reference during the call."]
        #[doc = ""]
        #[doc = " The number of bytes \"written\" is what\'s logically written. Garbage may be"]
        #[doc = " written in the output buffer beyond the point logically written to."]
        #[doc = ""]
        #[doc = " In the case of the methods whose name ends with"]
        #[doc = " `*WithoutReplacement`, the status is a `uint32_t` whose possible values"]
        #[doc = " are an unmappable code point, `kOutputFull` and `kInputEmpty` corresponding"]
        #[doc = " to the three cases listed above)."]
        #[doc = ""]
        #[doc = " In the case of methods whose name does not end with"]
        #[doc = " `*WithoutReplacement`, unmappable characters are automatically replaced"]
        #[doc = " with the corresponding numeric character references and unmappable"]
        #[doc = " characters do not cause the methods to return early."]
        #[doc = ""]
        #[doc = " When encoding from UTF-8 without replacement, the methods are guaranteed"]
        #[doc = " not to return indicating that more output space is needed if the length"]
        #[doc = " of the output buffer is at least the length returned by"]
        #[doc = " `MaxBufferLengthFromUTF8WithoutReplacement()`. When encoding from"]
        #[doc = " UTF-8 with replacement, the length of the output buffer that guarantees the"]
        #[doc = " methods not to return indicating that more output space is needed in the"]
        #[doc = " absence of unmappable characters is given by"]
        #[doc = " `MaxBufferLengthFromUTF8IfNoUnmappables()`. When encoding from"]
        #[doc = " UTF-16 without replacement, the methods are guaranteed not to return"]
        #[doc = " indicating that more output space is needed if the length of the output"]
        #[doc = " buffer is at least the length returned by"]
        #[doc = " `MaxBufferLengthFromUTF16WithoutReplacement()`. When encoding"]
        #[doc = " from UTF-16 with replacement, the the length of the output buffer that"]
        #[doc = " guarantees the methods not to return indicating that more output space is"]
        #[doc = " needed in the absence of unmappable characters is given by"]
        #[doc = " `MaxBufferLengthFromUTF16IfNoUnmappables()`."]
        #[doc = " When encoding with replacement, applications are not expected to size the"]
        #[doc = " buffer for the worst case ahead of time but to resize the buffer if there"]
        #[doc = " are unmappable characters. This is why max length queries are only available"]
        #[doc = " for the case where there are no unmappable characters."]
        #[doc = ""]
        #[doc = " When encoding from UTF-8, each `aSrc` buffer _must_ be valid UTF-8. When"]
        #[doc = " encoding from UTF-16, unpaired surrogates in the input are treated as U+FFFD"]
        #[doc = " REPLACEMENT CHARACTERS. Therefore, in order for astral characters not to"]
        #[doc = " turn into a pair of REPLACEMENT CHARACTERS, the caller must ensure that"]
        #[doc = " surrogate pairs are not split across input buffer boundaries."]
        #[doc = ""]
        #[doc = " After an `Encode*` call returns, the output produced so far, taken as a"]
        #[doc = " whole from the start of the stream, is guaranteed to consist of a valid"]
        #[doc = " byte sequence in the target encoding. (I.e. the code unit sequence for a"]
        #[doc = " character is guaranteed not to be split across output buffers. However, due"]
        #[doc = " to the stateful nature of ISO-2022-JP, the stream needs to be considered"]
        #[doc = " from the start for it to be valid. For other encodings, the validity holds"]
        #[doc = " on a per-output buffer basis.)"]
        #[doc = ""]
        #[doc = " The boolean argument `aLast` indicates that the end of the stream is reached"]
        #[doc = " when all the characters in `aSrc` have been consumed. This argument is needed"]
        #[doc = " for ISO-2022-JP and is ignored for other encodings."]
        #[doc = ""]
        #[doc = " An `Encoder` object can be used to incrementally encode a byte stream."]
        #[doc = ""]
        #[doc = " During the processing of a single stream, the caller must call `Encode*`"]
        #[doc = " zero or more times with `aLast` set to `false` and then call `Encode*` at"]
        #[doc = " least once with `aLast` set to `true`. If `Encode*` returns `kInputEmpty`,"]
        #[doc = " the processing of the stream has ended. Otherwise, the caller must call"]
        #[doc = " `Encode*` again with `aLast` set to `true` (or treat an unmappable result,"]
        #[doc = " i.e. neither `kInputEmpty` nor `kOutputFull`, as a fatal error)."]
        #[doc = ""]
        #[doc = " Once the stream has ended, the `Encoder` object must not be used anymore."]
        #[doc = " That is, you need to create another one to process another stream."]
        #[doc = ""]
        #[doc = " When the encoder returns `kOutputFull` or the encoder returns an unmappable"]
        #[doc = " result and the caller does not wish to treat it as a fatal error, the input"]
        #[doc = " buffer `aSrc` may not have been completely consumed. In that case, the caller"]
        #[doc = " must pass the unconsumed contents of `aSrc` to `Encode*` again upon the next"]
        #[doc = " call."]
        #[doc = ""]
        #[doc = " # Infinite loops"]
        #[doc = ""]
        #[doc = " When converting with a fixed-size output buffer whose size is too small to"]
        #[doc = " accommodate one character of output, an infinite loop ensues. When"]
        #[doc = " converting with a fixed-size output buffer, it generally makes sense to"]
        #[doc = " make the buffer fairly large (e.g. couple of kilobytes)."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct Encoder {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_Encoder() {
            assert_eq!(
                ::std::mem::size_of::<Encoder>(),
                1usize,
                concat!("Size of: ", stringify!(Encoder))
            );
            assert_eq!(
                ::std::mem::align_of::<Encoder>(),
                1usize,
                concat!("Alignment of ", stringify!(Encoder))
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct DeclarationBlock {
            pub mRefCnt: u64,
            pub mContainer: root::mozilla::DeclarationBlock__bindgen_ty_1,
            pub mRaw: root::RefPtr<root::RawServoDeclarationBlock>,
            pub mImmutable: bool,
            pub mIsDirty: u32,
        }
        pub type DeclarationBlock_HasThreadSafeRefCnt = root::mozilla::TrueType;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct DeclarationBlock__bindgen_ty_1 {
            pub mRaw: root::__BindgenUnionField<usize>,
            pub mOwningRule: root::__BindgenUnionField<*mut root::mozilla::css::Rule>,
            pub mHTMLCSSStyleSheet: root::__BindgenUnionField<*mut root::nsHTMLCSSStyleSheet>,
            pub bindgen_union_field: u64,
        }
        #[test]
        fn bindgen_test_layout_DeclarationBlock__bindgen_ty_1() {
            assert_eq!(
                ::std::mem::size_of::<DeclarationBlock__bindgen_ty_1>(),
                8usize,
                concat!("Size of: ", stringify!(DeclarationBlock__bindgen_ty_1))
            );
            assert_eq!(
                ::std::mem::align_of::<DeclarationBlock__bindgen_ty_1>(),
                8usize,
                concat!("Alignment of ", stringify!(DeclarationBlock__bindgen_ty_1))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<DeclarationBlock__bindgen_ty_1>())).mRaw as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DeclarationBlock__bindgen_ty_1),
                    "::",
                    stringify!(mRaw)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<DeclarationBlock__bindgen_ty_1>())).mOwningRule
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DeclarationBlock__bindgen_ty_1),
                    "::",
                    stringify!(mOwningRule)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<DeclarationBlock__bindgen_ty_1>())).mHTMLCSSStyleSheet
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DeclarationBlock__bindgen_ty_1),
                    "::",
                    stringify!(mHTMLCSSStyleSheet)
                )
            );
        }
        #[test]
        fn bindgen_test_layout_DeclarationBlock() {
            assert_eq!(
                ::std::mem::size_of::<DeclarationBlock>(),
                32usize,
                concat!("Size of: ", stringify!(DeclarationBlock))
            );
            assert_eq!(
                ::std::mem::align_of::<DeclarationBlock>(),
                8usize,
                concat!("Alignment of ", stringify!(DeclarationBlock))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<DeclarationBlock>())).mRefCnt as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DeclarationBlock),
                    "::",
                    stringify!(mRefCnt)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<DeclarationBlock>())).mContainer as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DeclarationBlock),
                    "::",
                    stringify!(mContainer)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<DeclarationBlock>())).mRaw as *const _ as usize },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DeclarationBlock),
                    "::",
                    stringify!(mRaw)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<DeclarationBlock>())).mImmutable as *const _ as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DeclarationBlock),
                    "::",
                    stringify!(mImmutable)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<DeclarationBlock>())).mIsDirty as *const _ as usize
                },
                28usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DeclarationBlock),
                    "::",
                    stringify!(mIsDirty)
                )
            );
        }
        #[doc = " Event messages"]
        pub type EventMessageType = u16;
        pub const EventMessage_eVoidEvent: root::mozilla::EventMessage = 0;
        pub const EventMessage_eAllEvents: root::mozilla::EventMessage = 1;
        pub const EventMessage_eWindowClose: root::mozilla::EventMessage = 2;
        pub const EventMessage_eKeyPress: root::mozilla::EventMessage = 3;
        pub const EventMessage_eKeyUp: root::mozilla::EventMessage = 4;
        pub const EventMessage_eKeyDown: root::mozilla::EventMessage = 5;
        pub const EventMessage_eKeyDownOnPlugin: root::mozilla::EventMessage = 6;
        pub const EventMessage_eKeyUpOnPlugin: root::mozilla::EventMessage = 7;
        pub const EventMessage_eAccessKeyNotFound: root::mozilla::EventMessage = 8;
        pub const EventMessage_eResize: root::mozilla::EventMessage = 9;
        pub const EventMessage_eScroll: root::mozilla::EventMessage = 10;
        pub const EventMessage_eMozVisualResize: root::mozilla::EventMessage = 11;
        pub const EventMessage_eMozVisualScroll: root::mozilla::EventMessage = 12;
        pub const EventMessage_eInstall: root::mozilla::EventMessage = 13;
        pub const EventMessage_eAppInstalled: root::mozilla::EventMessage = 14;
        pub const EventMessage_ePluginActivate: root::mozilla::EventMessage = 15;
        pub const EventMessage_ePluginFocus: root::mozilla::EventMessage = 16;
        pub const EventMessage_eOffline: root::mozilla::EventMessage = 17;
        pub const EventMessage_eOnline: root::mozilla::EventMessage = 18;
        pub const EventMessage_eLanguageChange: root::mozilla::EventMessage = 19;
        pub const EventMessage_eMouseMove: root::mozilla::EventMessage = 20;
        pub const EventMessage_eMouseUp: root::mozilla::EventMessage = 21;
        pub const EventMessage_eMouseDown: root::mozilla::EventMessage = 22;
        pub const EventMessage_eMouseEnterIntoWidget: root::mozilla::EventMessage = 23;
        pub const EventMessage_eMouseExitFromWidget: root::mozilla::EventMessage = 24;
        pub const EventMessage_eMouseDoubleClick: root::mozilla::EventMessage = 25;
        pub const EventMessage_eMouseClick: root::mozilla::EventMessage = 26;
        pub const EventMessage_eMouseAuxClick: root::mozilla::EventMessage = 27;
        pub const EventMessage_eMouseActivate: root::mozilla::EventMessage = 28;
        pub const EventMessage_eMouseOver: root::mozilla::EventMessage = 29;
        pub const EventMessage_eMouseOut: root::mozilla::EventMessage = 30;
        pub const EventMessage_eMouseHitTest: root::mozilla::EventMessage = 31;
        pub const EventMessage_eMouseEnter: root::mozilla::EventMessage = 32;
        pub const EventMessage_eMouseLeave: root::mozilla::EventMessage = 33;
        pub const EventMessage_eMouseTouchDrag: root::mozilla::EventMessage = 34;
        pub const EventMessage_eMouseLongTap: root::mozilla::EventMessage = 35;
        pub const EventMessage_eMouseEventFirst: root::mozilla::EventMessage = 20;
        pub const EventMessage_eMouseEventLast: root::mozilla::EventMessage = 35;
        pub const EventMessage_ePointerMove: root::mozilla::EventMessage = 36;
        pub const EventMessage_ePointerUp: root::mozilla::EventMessage = 37;
        pub const EventMessage_ePointerDown: root::mozilla::EventMessage = 38;
        pub const EventMessage_ePointerOver: root::mozilla::EventMessage = 39;
        pub const EventMessage_ePointerOut: root::mozilla::EventMessage = 40;
        pub const EventMessage_ePointerEnter: root::mozilla::EventMessage = 41;
        pub const EventMessage_ePointerLeave: root::mozilla::EventMessage = 42;
        pub const EventMessage_ePointerCancel: root::mozilla::EventMessage = 43;
        pub const EventMessage_ePointerGotCapture: root::mozilla::EventMessage = 44;
        pub const EventMessage_ePointerLostCapture: root::mozilla::EventMessage = 45;
        pub const EventMessage_ePointerEventFirst: root::mozilla::EventMessage = 36;
        pub const EventMessage_ePointerEventLast: root::mozilla::EventMessage = 45;
        pub const EventMessage_eContextMenu: root::mozilla::EventMessage = 46;
        pub const EventMessage_eCueChange: root::mozilla::EventMessage = 47;
        pub const EventMessage_eLoad: root::mozilla::EventMessage = 48;
        pub const EventMessage_eUnload: root::mozilla::EventMessage = 49;
        pub const EventMessage_eHashChange: root::mozilla::EventMessage = 50;
        pub const EventMessage_eImageAbort: root::mozilla::EventMessage = 51;
        pub const EventMessage_eLoadError: root::mozilla::EventMessage = 52;
        pub const EventMessage_eLoadEnd: root::mozilla::EventMessage = 53;
        pub const EventMessage_ePopState: root::mozilla::EventMessage = 54;
        pub const EventMessage_eRejectionHandled: root::mozilla::EventMessage = 55;
        pub const EventMessage_eStorage: root::mozilla::EventMessage = 56;
        pub const EventMessage_eUnhandledRejection: root::mozilla::EventMessage = 57;
        pub const EventMessage_eBeforeUnload: root::mozilla::EventMessage = 58;
        pub const EventMessage_eReadyStateChange: root::mozilla::EventMessage = 59;
        pub const EventMessage_eFormSubmit: root::mozilla::EventMessage = 60;
        pub const EventMessage_eFormReset: root::mozilla::EventMessage = 61;
        pub const EventMessage_eFormChange: root::mozilla::EventMessage = 62;
        pub const EventMessage_eFormSelect: root::mozilla::EventMessage = 63;
        pub const EventMessage_eFormInvalid: root::mozilla::EventMessage = 64;
        pub const EventMessage_eFormCheckboxStateChange: root::mozilla::EventMessage = 65;
        pub const EventMessage_eFormRadioStateChange: root::mozilla::EventMessage = 66;
        pub const EventMessage_eFocus: root::mozilla::EventMessage = 67;
        pub const EventMessage_eBlur: root::mozilla::EventMessage = 68;
        pub const EventMessage_eFocusIn: root::mozilla::EventMessage = 69;
        pub const EventMessage_eFocusOut: root::mozilla::EventMessage = 70;
        pub const EventMessage_eDragEnter: root::mozilla::EventMessage = 71;
        pub const EventMessage_eDragOver: root::mozilla::EventMessage = 72;
        pub const EventMessage_eDragExit: root::mozilla::EventMessage = 73;
        pub const EventMessage_eDrag: root::mozilla::EventMessage = 74;
        pub const EventMessage_eDragEnd: root::mozilla::EventMessage = 75;
        pub const EventMessage_eDragStart: root::mozilla::EventMessage = 76;
        pub const EventMessage_eDrop: root::mozilla::EventMessage = 77;
        pub const EventMessage_eDragLeave: root::mozilla::EventMessage = 78;
        pub const EventMessage_eDragDropEventFirst: root::mozilla::EventMessage = 71;
        pub const EventMessage_eDragDropEventLast: root::mozilla::EventMessage = 78;
        pub const EventMessage_eXULPopupShowing: root::mozilla::EventMessage = 79;
        pub const EventMessage_eXULPopupShown: root::mozilla::EventMessage = 80;
        pub const EventMessage_eXULPopupPositioned: root::mozilla::EventMessage = 81;
        pub const EventMessage_eXULPopupHiding: root::mozilla::EventMessage = 82;
        pub const EventMessage_eXULPopupHidden: root::mozilla::EventMessage = 83;
        pub const EventMessage_eXULBroadcast: root::mozilla::EventMessage = 84;
        pub const EventMessage_eXULCommandUpdate: root::mozilla::EventMessage = 85;
        pub const EventMessage_eLegacyMouseLineOrPageScroll: root::mozilla::EventMessage = 86;
        pub const EventMessage_eLegacyMousePixelScroll: root::mozilla::EventMessage = 87;
        pub const EventMessage_eScrollPortUnderflow: root::mozilla::EventMessage = 88;
        pub const EventMessage_eScrollPortOverflow: root::mozilla::EventMessage = 89;
        pub const EventMessage_eLegacySubtreeModified: root::mozilla::EventMessage = 90;
        pub const EventMessage_eLegacyNodeInserted: root::mozilla::EventMessage = 91;
        pub const EventMessage_eLegacyNodeRemoved: root::mozilla::EventMessage = 92;
        pub const EventMessage_eLegacyNodeRemovedFromDocument: root::mozilla::EventMessage = 93;
        pub const EventMessage_eLegacyNodeInsertedIntoDocument: root::mozilla::EventMessage = 94;
        pub const EventMessage_eLegacyAttrModified: root::mozilla::EventMessage = 95;
        pub const EventMessage_eLegacyCharacterDataModified: root::mozilla::EventMessage = 96;
        pub const EventMessage_eLegacyMutationEventFirst: root::mozilla::EventMessage = 90;
        pub const EventMessage_eLegacyMutationEventLast: root::mozilla::EventMessage = 96;
        pub const EventMessage_eUnidentifiedEvent: root::mozilla::EventMessage = 97;
        pub const EventMessage_eCompositionStart: root::mozilla::EventMessage = 98;
        pub const EventMessage_eCompositionEnd: root::mozilla::EventMessage = 99;
        pub const EventMessage_eCompositionUpdate: root::mozilla::EventMessage = 100;
        pub const EventMessage_eCompositionChange: root::mozilla::EventMessage = 101;
        pub const EventMessage_eCompositionCommitAsIs: root::mozilla::EventMessage = 102;
        pub const EventMessage_eCompositionCommit: root::mozilla::EventMessage = 103;
        pub const EventMessage_eCompositionCommitRequestHandled: root::mozilla::EventMessage = 104;
        pub const EventMessage_eLegacyDOMActivate: root::mozilla::EventMessage = 105;
        pub const EventMessage_eLegacyDOMFocusIn: root::mozilla::EventMessage = 106;
        pub const EventMessage_eLegacyDOMFocusOut: root::mozilla::EventMessage = 107;
        pub const EventMessage_ePageShow: root::mozilla::EventMessage = 108;
        pub const EventMessage_ePageHide: root::mozilla::EventMessage = 109;
        pub const EventMessage_eSVGLoad: root::mozilla::EventMessage = 110;
        pub const EventMessage_eSVGUnload: root::mozilla::EventMessage = 111;
        pub const EventMessage_eSVGResize: root::mozilla::EventMessage = 112;
        pub const EventMessage_eSVGScroll: root::mozilla::EventMessage = 113;
        pub const EventMessage_eSVGZoom: root::mozilla::EventMessage = 114;
        pub const EventMessage_eXULCommand: root::mozilla::EventMessage = 115;
        pub const EventMessage_eCopy: root::mozilla::EventMessage = 116;
        pub const EventMessage_eCut: root::mozilla::EventMessage = 117;
        pub const EventMessage_ePaste: root::mozilla::EventMessage = 118;
        pub const EventMessage_ePasteNoFormatting: root::mozilla::EventMessage = 119;
        pub const EventMessage_eQuerySelectedText: root::mozilla::EventMessage = 120;
        pub const EventMessage_eQueryTextContent: root::mozilla::EventMessage = 121;
        pub const EventMessage_eQueryCaretRect: root::mozilla::EventMessage = 122;
        pub const EventMessage_eQueryTextRect: root::mozilla::EventMessage = 123;
        pub const EventMessage_eQueryTextRectArray: root::mozilla::EventMessage = 124;
        pub const EventMessage_eQueryEditorRect: root::mozilla::EventMessage = 125;
        pub const EventMessage_eQueryContentState: root::mozilla::EventMessage = 126;
        pub const EventMessage_eQuerySelectionAsTransferable: root::mozilla::EventMessage = 127;
        pub const EventMessage_eQueryCharacterAtPoint: root::mozilla::EventMessage = 128;
        pub const EventMessage_eQueryDOMWidgetHittest: root::mozilla::EventMessage = 129;
        pub const EventMessage_eLoadStart: root::mozilla::EventMessage = 130;
        pub const EventMessage_eProgress: root::mozilla::EventMessage = 131;
        pub const EventMessage_eSuspend: root::mozilla::EventMessage = 132;
        pub const EventMessage_eEmptied: root::mozilla::EventMessage = 133;
        pub const EventMessage_eStalled: root::mozilla::EventMessage = 134;
        pub const EventMessage_ePlay: root::mozilla::EventMessage = 135;
        pub const EventMessage_ePause: root::mozilla::EventMessage = 136;
        pub const EventMessage_eLoadedMetaData: root::mozilla::EventMessage = 137;
        pub const EventMessage_eLoadedData: root::mozilla::EventMessage = 138;
        pub const EventMessage_eWaiting: root::mozilla::EventMessage = 139;
        pub const EventMessage_ePlaying: root::mozilla::EventMessage = 140;
        pub const EventMessage_eCanPlay: root::mozilla::EventMessage = 141;
        pub const EventMessage_eCanPlayThrough: root::mozilla::EventMessage = 142;
        pub const EventMessage_eSeeking: root::mozilla::EventMessage = 143;
        pub const EventMessage_eSeeked: root::mozilla::EventMessage = 144;
        pub const EventMessage_eTimeUpdate: root::mozilla::EventMessage = 145;
        pub const EventMessage_eEnded: root::mozilla::EventMessage = 146;
        pub const EventMessage_eRateChange: root::mozilla::EventMessage = 147;
        pub const EventMessage_eDurationChange: root::mozilla::EventMessage = 148;
        pub const EventMessage_eVolumeChange: root::mozilla::EventMessage = 149;
        pub const EventMessage_eAfterPaint: root::mozilla::EventMessage = 150;
        pub const EventMessage_eSwipeGestureMayStart: root::mozilla::EventMessage = 151;
        pub const EventMessage_eSwipeGestureStart: root::mozilla::EventMessage = 152;
        pub const EventMessage_eSwipeGestureUpdate: root::mozilla::EventMessage = 153;
        pub const EventMessage_eSwipeGestureEnd: root::mozilla::EventMessage = 154;
        pub const EventMessage_eSwipeGesture: root::mozilla::EventMessage = 155;
        pub const EventMessage_eMagnifyGestureStart: root::mozilla::EventMessage = 156;
        pub const EventMessage_eMagnifyGestureUpdate: root::mozilla::EventMessage = 157;
        pub const EventMessage_eMagnifyGesture: root::mozilla::EventMessage = 158;
        pub const EventMessage_eRotateGestureStart: root::mozilla::EventMessage = 159;
        pub const EventMessage_eRotateGestureUpdate: root::mozilla::EventMessage = 160;
        pub const EventMessage_eRotateGesture: root::mozilla::EventMessage = 161;
        pub const EventMessage_eTapGesture: root::mozilla::EventMessage = 162;
        pub const EventMessage_ePressTapGesture: root::mozilla::EventMessage = 163;
        pub const EventMessage_eEdgeUIStarted: root::mozilla::EventMessage = 164;
        pub const EventMessage_eEdgeUICanceled: root::mozilla::EventMessage = 165;
        pub const EventMessage_eEdgeUICompleted: root::mozilla::EventMessage = 166;
        pub const EventMessage_ePluginInputEvent: root::mozilla::EventMessage = 167;
        pub const EventMessage_eSetSelection: root::mozilla::EventMessage = 168;
        pub const EventMessage_eContentCommandCut: root::mozilla::EventMessage = 169;
        pub const EventMessage_eContentCommandCopy: root::mozilla::EventMessage = 170;
        pub const EventMessage_eContentCommandPaste: root::mozilla::EventMessage = 171;
        pub const EventMessage_eContentCommandDelete: root::mozilla::EventMessage = 172;
        pub const EventMessage_eContentCommandUndo: root::mozilla::EventMessage = 173;
        pub const EventMessage_eContentCommandRedo: root::mozilla::EventMessage = 174;
        pub const EventMessage_eContentCommandPasteTransferable: root::mozilla::EventMessage = 175;
        pub const EventMessage_eContentCommandLookUpDictionary: root::mozilla::EventMessage = 176;
        pub const EventMessage_eContentCommandScroll: root::mozilla::EventMessage = 177;
        pub const EventMessage_eGestureNotify: root::mozilla::EventMessage = 178;
        pub const EventMessage_eScrolledAreaChanged: root::mozilla::EventMessage = 179;
        pub const EventMessage_eTransitionStart: root::mozilla::EventMessage = 180;
        pub const EventMessage_eTransitionRun: root::mozilla::EventMessage = 181;
        pub const EventMessage_eTransitionEnd: root::mozilla::EventMessage = 182;
        pub const EventMessage_eTransitionCancel: root::mozilla::EventMessage = 183;
        pub const EventMessage_eAnimationStart: root::mozilla::EventMessage = 184;
        pub const EventMessage_eAnimationEnd: root::mozilla::EventMessage = 185;
        pub const EventMessage_eAnimationIteration: root::mozilla::EventMessage = 186;
        pub const EventMessage_eAnimationCancel: root::mozilla::EventMessage = 187;
        pub const EventMessage_eWebkitTransitionEnd: root::mozilla::EventMessage = 188;
        pub const EventMessage_eWebkitAnimationStart: root::mozilla::EventMessage = 189;
        pub const EventMessage_eWebkitAnimationEnd: root::mozilla::EventMessage = 190;
        pub const EventMessage_eWebkitAnimationIteration: root::mozilla::EventMessage = 191;
        pub const EventMessage_eSMILBeginEvent: root::mozilla::EventMessage = 192;
        pub const EventMessage_eSMILEndEvent: root::mozilla::EventMessage = 193;
        pub const EventMessage_eSMILRepeatEvent: root::mozilla::EventMessage = 194;
        pub const EventMessage_eAudioProcess: root::mozilla::EventMessage = 195;
        pub const EventMessage_eAudioComplete: root::mozilla::EventMessage = 196;
        pub const EventMessage_eBeforeScriptExecute: root::mozilla::EventMessage = 197;
        pub const EventMessage_eAfterScriptExecute: root::mozilla::EventMessage = 198;
        pub const EventMessage_eBeforePrint: root::mozilla::EventMessage = 199;
        pub const EventMessage_eAfterPrint: root::mozilla::EventMessage = 200;
        pub const EventMessage_eMessage: root::mozilla::EventMessage = 201;
        pub const EventMessage_eMessageError: root::mozilla::EventMessage = 202;
        pub const EventMessage_eOpen: root::mozilla::EventMessage = 203;
        pub const EventMessage_eDeviceOrientation: root::mozilla::EventMessage = 204;
        pub const EventMessage_eAbsoluteDeviceOrientation: root::mozilla::EventMessage = 205;
        pub const EventMessage_eDeviceMotion: root::mozilla::EventMessage = 206;
        pub const EventMessage_eDeviceProximity: root::mozilla::EventMessage = 207;
        pub const EventMessage_eUserProximity: root::mozilla::EventMessage = 208;
        pub const EventMessage_eDeviceLight: root::mozilla::EventMessage = 209;
        pub const EventMessage_eVRDisplayActivate: root::mozilla::EventMessage = 210;
        pub const EventMessage_eVRDisplayDeactivate: root::mozilla::EventMessage = 211;
        pub const EventMessage_eVRDisplayConnect: root::mozilla::EventMessage = 212;
        pub const EventMessage_eVRDisplayDisconnect: root::mozilla::EventMessage = 213;
        pub const EventMessage_eVRDisplayPresentChange: root::mozilla::EventMessage = 214;
        pub const EventMessage_eShow: root::mozilla::EventMessage = 215;
        pub const EventMessage_eFullscreenChange: root::mozilla::EventMessage = 216;
        pub const EventMessage_eFullscreenError: root::mozilla::EventMessage = 217;
        pub const EventMessage_eMozFullscreenChange: root::mozilla::EventMessage = 218;
        pub const EventMessage_eMozFullscreenError: root::mozilla::EventMessage = 219;
        pub const EventMessage_eTouchStart: root::mozilla::EventMessage = 220;
        pub const EventMessage_eTouchMove: root::mozilla::EventMessage = 221;
        pub const EventMessage_eTouchEnd: root::mozilla::EventMessage = 222;
        pub const EventMessage_eTouchCancel: root::mozilla::EventMessage = 223;
        pub const EventMessage_eTouchPointerCancel: root::mozilla::EventMessage = 224;
        pub const EventMessage_ePointerLockChange: root::mozilla::EventMessage = 225;
        pub const EventMessage_ePointerLockError: root::mozilla::EventMessage = 226;
        pub const EventMessage_eMozPointerLockChange: root::mozilla::EventMessage = 227;
        pub const EventMessage_eMozPointerLockError: root::mozilla::EventMessage = 228;
        pub const EventMessage_eWheel: root::mozilla::EventMessage = 229;
        pub const EventMessage_eWheelOperationStart: root::mozilla::EventMessage = 230;
        pub const EventMessage_eWheelOperationEnd: root::mozilla::EventMessage = 231;
        pub const EventMessage_eTimeChange: root::mozilla::EventMessage = 232;
        pub const EventMessage_eNetworkUpload: root::mozilla::EventMessage = 233;
        pub const EventMessage_eNetworkDownload: root::mozilla::EventMessage = 234;
        pub const EventMessage_eMediaRecorderDataAvailable: root::mozilla::EventMessage = 235;
        pub const EventMessage_eMediaRecorderWarning: root::mozilla::EventMessage = 236;
        pub const EventMessage_eMediaRecorderStop: root::mozilla::EventMessage = 237;
        pub const EventMessage_eGamepadButtonDown: root::mozilla::EventMessage = 238;
        pub const EventMessage_eGamepadButtonUp: root::mozilla::EventMessage = 239;
        pub const EventMessage_eGamepadAxisMove: root::mozilla::EventMessage = 240;
        pub const EventMessage_eGamepadConnected: root::mozilla::EventMessage = 241;
        pub const EventMessage_eGamepadDisconnected: root::mozilla::EventMessage = 242;
        pub const EventMessage_eGamepadEventFirst: root::mozilla::EventMessage = 238;
        pub const EventMessage_eGamepadEventLast: root::mozilla::EventMessage = 242;
        pub const EventMessage_eEditorInput: root::mozilla::EventMessage = 243;
        pub const EventMessage_eSelectStart: root::mozilla::EventMessage = 244;
        pub const EventMessage_eSelectionChange: root::mozilla::EventMessage = 245;
        pub const EventMessage_eVisibilityChange: root::mozilla::EventMessage = 246;
        pub const EventMessage_eToggle: root::mozilla::EventMessage = 247;
        pub const EventMessage_eClose: root::mozilla::EventMessage = 248;
        pub const EventMessage_eMarqueeBounce: root::mozilla::EventMessage = 249;
        pub const EventMessage_eMarqueeStart: root::mozilla::EventMessage = 250;
        pub const EventMessage_eMarqueeFinish: root::mozilla::EventMessage = 251;
        pub const EventMessage_eEventMessage_MaxValue: root::mozilla::EventMessage = 252;
        pub type EventMessage = u16;
        #[doc = " Event class IDs"]
        pub type EventClassIDType = u8;
        pub const EventClassID_eBasicEventClass: root::mozilla::EventClassID = 0;
        pub const EventClassID_eGUIEventClass: root::mozilla::EventClassID = 1;
        pub const EventClassID_eInputEventClass: root::mozilla::EventClassID = 2;
        pub const EventClassID_eUIEventClass: root::mozilla::EventClassID = 3;
        pub const EventClassID_eKeyboardEventClass: root::mozilla::EventClassID = 4;
        pub const EventClassID_eCompositionEventClass: root::mozilla::EventClassID = 5;
        pub const EventClassID_eQueryContentEventClass: root::mozilla::EventClassID = 6;
        pub const EventClassID_eSelectionEventClass: root::mozilla::EventClassID = 7;
        pub const EventClassID_eEditorInputEventClass: root::mozilla::EventClassID = 8;
        pub const EventClassID_eMouseEventBaseClass: root::mozilla::EventClassID = 9;
        pub const EventClassID_eMouseEventClass: root::mozilla::EventClassID = 10;
        pub const EventClassID_eDragEventClass: root::mozilla::EventClassID = 11;
        pub const EventClassID_eMouseScrollEventClass: root::mozilla::EventClassID = 12;
        pub const EventClassID_eWheelEventClass: root::mozilla::EventClassID = 13;
        pub const EventClassID_ePointerEventClass: root::mozilla::EventClassID = 14;
        pub const EventClassID_eGestureNotifyEventClass: root::mozilla::EventClassID = 15;
        pub const EventClassID_eSimpleGestureEventClass: root::mozilla::EventClassID = 16;
        pub const EventClassID_eTouchEventClass: root::mozilla::EventClassID = 17;
        pub const EventClassID_eScrollPortEventClass: root::mozilla::EventClassID = 18;
        pub const EventClassID_eScrollAreaEventClass: root::mozilla::EventClassID = 19;
        pub const EventClassID_eFormEventClass: root::mozilla::EventClassID = 20;
        pub const EventClassID_eClipboardEventClass: root::mozilla::EventClassID = 21;
        pub const EventClassID_eFocusEventClass: root::mozilla::EventClassID = 22;
        pub const EventClassID_eTransitionEventClass: root::mozilla::EventClassID = 23;
        pub const EventClassID_eAnimationEventClass: root::mozilla::EventClassID = 24;
        pub const EventClassID_eSMILTimeEventClass: root::mozilla::EventClassID = 25;
        pub const EventClassID_eCommandEventClass: root::mozilla::EventClassID = 26;
        pub const EventClassID_eContentCommandEventClass: root::mozilla::EventClassID = 27;
        pub const EventClassID_ePluginEventClass: root::mozilla::EventClassID = 28;
        pub const EventClassID_eMutationEventClass: root::mozilla::EventClassID = 29;
        pub type EventClassID = u8;
        #[doc = " mozilla::Modifiers"]
        pub type Modifiers = u16;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGAnimatedIntegerPair {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGAnimatedLength {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGAnimatedNumberPair {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGAnimatedOrient {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGAnimatedPreserveAspectRatio {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGAnimatedViewBox {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGLengthList {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGNumberList {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGPathData {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGPointList {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGStringList {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGTransformList {
            _unused: [u8; 0],
        }
        pub type SegmentedVector_Segment = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SegmentedVector_IterImpl {
            pub mSegment: *mut root::mozilla::SegmentedVector_Segment,
            pub mIndex: usize,
        }
        #[doc = " EventStates is the class used to represent the event states of nsIContent"]
        #[doc = " instances. These states are calculated by IntrinsicState() and"]
        #[doc = " ContentStatesChanged() has to be called when one of them changes thus"]
        #[doc = " informing the layout/style engine of the change."]
        #[doc = " Event states are associated with pseudo-classes."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct EventStates {
            pub mStates: root::mozilla::EventStates_InternalType,
        }
        pub type EventStates_InternalType = u64;
        pub type EventStates_ServoType = u64;
        #[test]
        fn bindgen_test_layout_EventStates() {
            assert_eq!(
                ::std::mem::size_of::<EventStates>(),
                8usize,
                concat!("Size of: ", stringify!(EventStates))
            );
            assert_eq!(
                ::std::mem::align_of::<EventStates>(),
                8usize,
                concat!("Alignment of ", stringify!(EventStates))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<EventStates>())).mStates as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(EventStates),
                    "::",
                    stringify!(mStates)
                )
            );
        }
        pub const AntiTrackingCommon_StorageAccessGrantedReason_eStorageAccessAPI:
            root::mozilla::AntiTrackingCommon_StorageAccessGrantedReason = 0;
        pub const AntiTrackingCommon_StorageAccessGrantedReason_eOpenerAfterUserInteraction:
            root::mozilla::AntiTrackingCommon_StorageAccessGrantedReason = 1;
        pub const AntiTrackingCommon_StorageAccessGrantedReason_eOpener:
            root::mozilla::AntiTrackingCommon_StorageAccessGrantedReason = 2;
        pub type AntiTrackingCommon_StorageAccessGrantedReason = u32;
        pub const UseCounter_eUseCounter_UNKNOWN: root::mozilla::UseCounter = -1;
        pub const UseCounter_eUseCounter_SVGSVGElement_getElementById: root::mozilla::UseCounter =
            0;
        pub const UseCounter_eUseCounter_SVGSVGElement_currentScale_getter:
            root::mozilla::UseCounter = 1;
        pub const UseCounter_eUseCounter_SVGSVGElement_currentScale_setter:
            root::mozilla::UseCounter = 2;
        pub const UseCounter_eUseCounter_property_Fill: root::mozilla::UseCounter = 3;
        pub const UseCounter_eUseCounter_property_FillOpacity: root::mozilla::UseCounter = 4;
        pub const UseCounter_eUseCounter_XMLDocument_async_getter: root::mozilla::UseCounter = 5;
        pub const UseCounter_eUseCounter_XMLDocument_async_setter: root::mozilla::UseCounter = 6;
        pub const UseCounter_eUseCounter_DOMError_name_getter: root::mozilla::UseCounter = 7;
        pub const UseCounter_eUseCounter_DOMError_name_setter: root::mozilla::UseCounter = 8;
        pub const UseCounter_eUseCounter_DOMError_message_getter: root::mozilla::UseCounter = 9;
        pub const UseCounter_eUseCounter_DOMError_message_setter: root::mozilla::UseCounter = 10;
        pub const UseCounter_eUseCounter_custom_DOMErrorConstructor: root::mozilla::UseCounter = 11;
        pub const UseCounter_eUseCounter_PushManager_subscribe: root::mozilla::UseCounter = 12;
        pub const UseCounter_eUseCounter_PushSubscription_unsubscribe: root::mozilla::UseCounter =
            13;
        pub const UseCounter_eUseCounter_Window_sidebar_getter: root::mozilla::UseCounter = 14;
        pub const UseCounter_eUseCounter_Window_sidebar_setter: root::mozilla::UseCounter = 15;
        pub const UseCounter_eUseCounter_OfflineResourceList_swapCache: root::mozilla::UseCounter =
            16;
        pub const UseCounter_eUseCounter_OfflineResourceList_update: root::mozilla::UseCounter = 17;
        pub const UseCounter_eUseCounter_OfflineResourceList_status_getter:
            root::mozilla::UseCounter = 18;
        pub const UseCounter_eUseCounter_OfflineResourceList_status_setter:
            root::mozilla::UseCounter = 19;
        pub const UseCounter_eUseCounter_OfflineResourceList_onchecking_getter:
            root::mozilla::UseCounter = 20;
        pub const UseCounter_eUseCounter_OfflineResourceList_onchecking_setter:
            root::mozilla::UseCounter = 21;
        pub const UseCounter_eUseCounter_OfflineResourceList_onerror_getter:
            root::mozilla::UseCounter = 22;
        pub const UseCounter_eUseCounter_OfflineResourceList_onerror_setter:
            root::mozilla::UseCounter = 23;
        pub const UseCounter_eUseCounter_OfflineResourceList_onnoupdate_getter:
            root::mozilla::UseCounter = 24;
        pub const UseCounter_eUseCounter_OfflineResourceList_onnoupdate_setter:
            root::mozilla::UseCounter = 25;
        pub const UseCounter_eUseCounter_OfflineResourceList_ondownloading_getter:
            root::mozilla::UseCounter = 26;
        pub const UseCounter_eUseCounter_OfflineResourceList_ondownloading_setter:
            root::mozilla::UseCounter = 27;
        pub const UseCounter_eUseCounter_OfflineResourceList_onprogress_getter:
            root::mozilla::UseCounter = 28;
        pub const UseCounter_eUseCounter_OfflineResourceList_onprogress_setter:
            root::mozilla::UseCounter = 29;
        pub const UseCounter_eUseCounter_OfflineResourceList_onupdateready_getter:
            root::mozilla::UseCounter = 30;
        pub const UseCounter_eUseCounter_OfflineResourceList_onupdateready_setter:
            root::mozilla::UseCounter = 31;
        pub const UseCounter_eUseCounter_OfflineResourceList_oncached_getter:
            root::mozilla::UseCounter = 32;
        pub const UseCounter_eUseCounter_OfflineResourceList_oncached_setter:
            root::mozilla::UseCounter = 33;
        pub const UseCounter_eUseCounter_OfflineResourceList_onobsolete_getter:
            root::mozilla::UseCounter = 34;
        pub const UseCounter_eUseCounter_OfflineResourceList_onobsolete_setter:
            root::mozilla::UseCounter = 35;
        pub const UseCounter_eUseCounter_IDBDatabase_createMutableFile: root::mozilla::UseCounter =
            36;
        pub const UseCounter_eUseCounter_IDBDatabase_mozCreateFileHandle:
            root::mozilla::UseCounter = 37;
        pub const UseCounter_eUseCounter_IDBMutableFile_open: root::mozilla::UseCounter = 38;
        pub const UseCounter_eUseCounter_IDBMutableFile_getFile: root::mozilla::UseCounter = 39;
        pub const UseCounter_eUseCounter_DataTransfer_addElement: root::mozilla::UseCounter = 40;
        pub const UseCounter_eUseCounter_DataTransfer_mozItemCount_getter:
            root::mozilla::UseCounter = 41;
        pub const UseCounter_eUseCounter_DataTransfer_mozItemCount_setter:
            root::mozilla::UseCounter = 42;
        pub const UseCounter_eUseCounter_DataTransfer_mozCursor_getter: root::mozilla::UseCounter =
            43;
        pub const UseCounter_eUseCounter_DataTransfer_mozCursor_setter: root::mozilla::UseCounter =
            44;
        pub const UseCounter_eUseCounter_DataTransfer_mozTypesAt: root::mozilla::UseCounter = 45;
        pub const UseCounter_eUseCounter_DataTransfer_mozClearDataAt: root::mozilla::UseCounter =
            46;
        pub const UseCounter_eUseCounter_DataTransfer_mozSetDataAt: root::mozilla::UseCounter = 47;
        pub const UseCounter_eUseCounter_DataTransfer_mozGetDataAt: root::mozilla::UseCounter = 48;
        pub const UseCounter_eUseCounter_DataTransfer_mozUserCancelled_getter:
            root::mozilla::UseCounter = 49;
        pub const UseCounter_eUseCounter_DataTransfer_mozUserCancelled_setter:
            root::mozilla::UseCounter = 50;
        pub const UseCounter_eUseCounter_DataTransfer_mozSourceNode_getter:
            root::mozilla::UseCounter = 51;
        pub const UseCounter_eUseCounter_DataTransfer_mozSourceNode_setter:
            root::mozilla::UseCounter = 52;
        pub const UseCounter_eUseCounter_custom_onstart: root::mozilla::UseCounter = 53;
        pub const UseCounter_eUseCounter_custom_onbounce: root::mozilla::UseCounter = 54;
        pub const UseCounter_eUseCounter_custom_onfinish: root::mozilla::UseCounter = 55;
        pub const UseCounter_eUseCounter_custom_JS_asmjs: root::mozilla::UseCounter = 56;
        pub const UseCounter_eUseCounter_custom_JS_wasm: root::mozilla::UseCounter = 57;
        pub const UseCounter_eUseCounter_console_assert: root::mozilla::UseCounter = 58;
        pub const UseCounter_eUseCounter_console_clear: root::mozilla::UseCounter = 59;
        pub const UseCounter_eUseCounter_console_count: root::mozilla::UseCounter = 60;
        pub const UseCounter_eUseCounter_console_countReset: root::mozilla::UseCounter = 61;
        pub const UseCounter_eUseCounter_console_debug: root::mozilla::UseCounter = 62;
        pub const UseCounter_eUseCounter_console_error: root::mozilla::UseCounter = 63;
        pub const UseCounter_eUseCounter_console_info: root::mozilla::UseCounter = 64;
        pub const UseCounter_eUseCounter_console_log: root::mozilla::UseCounter = 65;
        pub const UseCounter_eUseCounter_console_table: root::mozilla::UseCounter = 66;
        pub const UseCounter_eUseCounter_console_trace: root::mozilla::UseCounter = 67;
        pub const UseCounter_eUseCounter_console_warn: root::mozilla::UseCounter = 68;
        pub const UseCounter_eUseCounter_console_dir: root::mozilla::UseCounter = 69;
        pub const UseCounter_eUseCounter_console_dirxml: root::mozilla::UseCounter = 70;
        pub const UseCounter_eUseCounter_console_group: root::mozilla::UseCounter = 71;
        pub const UseCounter_eUseCounter_console_groupCollapsed: root::mozilla::UseCounter = 72;
        pub const UseCounter_eUseCounter_console_groupEnd: root::mozilla::UseCounter = 73;
        pub const UseCounter_eUseCounter_console_time: root::mozilla::UseCounter = 74;
        pub const UseCounter_eUseCounter_console_timeLog: root::mozilla::UseCounter = 75;
        pub const UseCounter_eUseCounter_console_timeEnd: root::mozilla::UseCounter = 76;
        pub const UseCounter_eUseCounter_console_exception: root::mozilla::UseCounter = 77;
        pub const UseCounter_eUseCounter_console_timeStamp: root::mozilla::UseCounter = 78;
        pub const UseCounter_eUseCounter_console_profile: root::mozilla::UseCounter = 79;
        pub const UseCounter_eUseCounter_console_profileEnd: root::mozilla::UseCounter = 80;
        pub const UseCounter_eUseCounter_custom_DocumentOpen: root::mozilla::UseCounter = 81;
        pub const UseCounter_eUseCounter_custom_FilteredCrossOriginIFrame:
            root::mozilla::UseCounter = 82;
        pub const UseCounter_eUseCounter_CustomElementRegistry_define: root::mozilla::UseCounter =
            83;
        pub const UseCounter_eUseCounter_Element_attachShadow: root::mozilla::UseCounter = 84;
        pub const UseCounter_eUseCounter_MediaDevices_enumerateDevices: root::mozilla::UseCounter =
            85;
        pub const UseCounter_eUseCounter_custom_EnumerateDevicesInsec: root::mozilla::UseCounter =
            86;
        pub const UseCounter_eUseCounter_custom_EnumerateDevicesUnfocused:
            root::mozilla::UseCounter = 87;
        pub const UseCounter_eUseCounter_MediaDevices_getUserMedia: root::mozilla::UseCounter = 88;
        pub const UseCounter_eUseCounter_Navigator_mozGetUserMedia: root::mozilla::UseCounter = 89;
        pub const UseCounter_eUseCounter_custom_GetUserMediaUnfocused: root::mozilla::UseCounter =
            90;
        pub const UseCounter_eUseCounter_custom_GetUserMediaInsec: root::mozilla::UseCounter = 91;
        pub const UseCounter_eUseCounter_custom_MozGetUserMediaInsec: root::mozilla::UseCounter =
            92;
        pub const UseCounter_eUseCounter_custom_GetUserMediaXOrigin: root::mozilla::UseCounter = 93;
        pub const UseCounter_eUseCounter_custom_MozGetUserMediaXOrigin: root::mozilla::UseCounter =
            94;
        pub const UseCounter_eUseCounter_MediaDevices_getDisplayMedia: root::mozilla::UseCounter =
            95;
        pub const UseCounter_eUseCounter_custom_GetDisplayMediaXOrigin: root::mozilla::UseCounter =
            96;
        pub const UseCounter_eUseCounter_EnablePrivilege: root::mozilla::UseCounter = 97;
        pub const UseCounter_eUseCounter_MutationEvent: root::mozilla::UseCounter = 98;
        pub const UseCounter_eUseCounter_Components: root::mozilla::UseCounter = 99;
        pub const UseCounter_eUseCounter_NodeIteratorDetach: root::mozilla::UseCounter = 100;
        pub const UseCounter_eUseCounter_LenientThis: root::mozilla::UseCounter = 101;
        pub const UseCounter_eUseCounter_MozGetAsFile: root::mozilla::UseCounter = 102;
        pub const UseCounter_eUseCounter_UseOfCaptureEvents: root::mozilla::UseCounter = 103;
        pub const UseCounter_eUseCounter_UseOfReleaseEvents: root::mozilla::UseCounter = 104;
        pub const UseCounter_eUseCounter_UseOfDOM3LoadMethod: root::mozilla::UseCounter = 105;
        pub const UseCounter_eUseCounter_ChromeUseOfDOM3LoadMethod: root::mozilla::UseCounter = 106;
        pub const UseCounter_eUseCounter_ShowModalDialog: root::mozilla::UseCounter = 107;
        pub const UseCounter_eUseCounter_SyncXMLHttpRequest: root::mozilla::UseCounter = 108;
        pub const UseCounter_eUseCounter_Window_Cc_ontrollers: root::mozilla::UseCounter = 109;
        pub const UseCounter_eUseCounter_ImportXULIntoContent: root::mozilla::UseCounter = 110;
        pub const UseCounter_eUseCounter_NavigatorGetUserMedia: root::mozilla::UseCounter = 111;
        pub const UseCounter_eUseCounter_WebrtcDeprecatedPrefix: root::mozilla::UseCounter = 112;
        pub const UseCounter_eUseCounter_RTCPeerConnectionGetStreams: root::mozilla::UseCounter =
            113;
        pub const UseCounter_eUseCounter_AppCache: root::mozilla::UseCounter = 114;
        pub const UseCounter_eUseCounter_AppCacheInsecure: root::mozilla::UseCounter = 115;
        pub const UseCounter_eUseCounter_PrefixedImageSmoothingEnabled: root::mozilla::UseCounter =
            116;
        pub const UseCounter_eUseCounter_LenientSetter: root::mozilla::UseCounter = 117;
        pub const UseCounter_eUseCounter_ImageBitmapRenderingContext_TransferImageBitmap:
            root::mozilla::UseCounter = 118;
        pub const UseCounter_eUseCounter_WindowContentUntrusted: root::mozilla::UseCounter = 119;
        pub const UseCounter_eUseCounter_RegisterProtocolHandlerInsecure:
            root::mozilla::UseCounter = 120;
        pub const UseCounter_eUseCounter_MixedDisplayObjectSubrequest: root::mozilla::UseCounter =
            121;
        pub const UseCounter_eUseCounter_MotionEvent: root::mozilla::UseCounter = 122;
        pub const UseCounter_eUseCounter_OrientationEvent: root::mozilla::UseCounter = 123;
        pub const UseCounter_eUseCounter_ProximityEvent: root::mozilla::UseCounter = 124;
        pub const UseCounter_eUseCounter_AmbientLightEvent: root::mozilla::UseCounter = 125;
        pub const UseCounter_eUseCounter_IDBOpenDBOptions_StorageType: root::mozilla::UseCounter =
            126;
        pub const UseCounter_eUseCounter_MozBoxOrInlineBoxDisplay: root::mozilla::UseCounter = 127;
        pub const UseCounter_eUseCounter_DOMQuadBoundsAttr: root::mozilla::UseCounter = 128;
        pub const UseCounter_eUseCounter_DeprecatedTestingInterface: root::mozilla::UseCounter =
            129;
        pub const UseCounter_eUseCounter_DeprecatedTestingMethod: root::mozilla::UseCounter = 130;
        pub const UseCounter_eUseCounter_DeprecatedTestingAttribute: root::mozilla::UseCounter =
            131;
        pub const UseCounter_eUseCounter_CreateImageBitmapCanvasRenderingContext2D:
            root::mozilla::UseCounter = 132;
        pub const UseCounter_eUseCounter_MozRequestFullScreenDeprecatedPrefix:
            root::mozilla::UseCounter = 133;
        pub const UseCounter_eUseCounter_MozfullscreenchangeDeprecatedPrefix:
            root::mozilla::UseCounter = 134;
        pub const UseCounter_eUseCounter_MozfullscreenerrorDeprecatedPrefix:
            root::mozilla::UseCounter = 135;
        pub const UseCounter_eUseCounter_External_AddSearchProvider: root::mozilla::UseCounter =
            136;
        pub const UseCounter_eUseCounter_MouseEvent_MozPressure: root::mozilla::UseCounter = 137;
        pub const UseCounter_eUseCounter_Count: root::mozilla::UseCounter = 138;
        pub type UseCounter = i16;
        #[repr(C)]
        pub struct LangGroupFontPrefs {
            pub mLangGroup: *mut root::nsStaticAtom,
            pub mMinimumFontSize: root::nscoord,
            pub mDefaultVariableFont: root::nsFont,
            pub mDefaultSerifFont: root::nsFont,
            pub mDefaultSansSerifFont: root::nsFont,
            pub mDefaultMonospaceFont: root::nsFont,
            pub mDefaultCursiveFont: root::nsFont,
            pub mDefaultFantasyFont: root::nsFont,
            pub mNext: root::mozilla::UniquePtr<root::mozilla::LangGroupFontPrefs>,
        }
        #[test]
        fn bindgen_test_layout_LangGroupFontPrefs() {
            assert_eq!(
                ::std::mem::size_of::<LangGroupFontPrefs>(),
                504usize,
                concat!("Size of: ", stringify!(LangGroupFontPrefs))
            );
            assert_eq!(
                ::std::mem::align_of::<LangGroupFontPrefs>(),
                8usize,
                concat!("Alignment of ", stringify!(LangGroupFontPrefs))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<LangGroupFontPrefs>())).mLangGroup as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(LangGroupFontPrefs),
                    "::",
                    stringify!(mLangGroup)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<LangGroupFontPrefs>())).mMinimumFontSize as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(LangGroupFontPrefs),
                    "::",
                    stringify!(mMinimumFontSize)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<LangGroupFontPrefs>())).mDefaultVariableFont as *const _
                        as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(LangGroupFontPrefs),
                    "::",
                    stringify!(mDefaultVariableFont)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<LangGroupFontPrefs>())).mDefaultSerifFont as *const _
                        as usize
                },
                96usize,
                concat!(
                    "Offset of field: ",
                    stringify!(LangGroupFontPrefs),
                    "::",
                    stringify!(mDefaultSerifFont)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<LangGroupFontPrefs>())).mDefaultSansSerifFont as *const _
                        as usize
                },
                176usize,
                concat!(
                    "Offset of field: ",
                    stringify!(LangGroupFontPrefs),
                    "::",
                    stringify!(mDefaultSansSerifFont)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<LangGroupFontPrefs>())).mDefaultMonospaceFont as *const _
                        as usize
                },
                256usize,
                concat!(
                    "Offset of field: ",
                    stringify!(LangGroupFontPrefs),
                    "::",
                    stringify!(mDefaultMonospaceFont)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<LangGroupFontPrefs>())).mDefaultCursiveFont as *const _
                        as usize
                },
                336usize,
                concat!(
                    "Offset of field: ",
                    stringify!(LangGroupFontPrefs),
                    "::",
                    stringify!(mDefaultCursiveFont)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<LangGroupFontPrefs>())).mDefaultFantasyFont as *const _
                        as usize
                },
                416usize,
                concat!(
                    "Offset of field: ",
                    stringify!(LangGroupFontPrefs),
                    "::",
                    stringify!(mDefaultFantasyFont)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<LangGroupFontPrefs>())).mNext as *const _ as usize
                },
                496usize,
                concat!(
                    "Offset of field: ",
                    stringify!(LangGroupFontPrefs),
                    "::",
                    stringify!(mNext)
                )
            );
        }
        #[doc = " Some functionality that has historically lived on nsPresContext does not"]
        #[doc = " actually need to be per-document. This singleton class serves as a host"]
        #[doc = " for that functionality. We delegate to it from nsPresContext where"]
        #[doc = " appropriate, and use it standalone in some cases as well."]
        #[repr(C)]
        pub struct StaticPresData {
            pub mLangService: *mut root::nsLanguageAtomService,
            pub mLangGroupFontPrefs: root::mozilla::LangGroupFontPrefs,
        }
        #[test]
        fn bindgen_test_layout_StaticPresData() {
            assert_eq!(
                ::std::mem::size_of::<StaticPresData>(),
                512usize,
                concat!("Size of: ", stringify!(StaticPresData))
            );
            assert_eq!(
                ::std::mem::align_of::<StaticPresData>(),
                8usize,
                concat!("Alignment of ", stringify!(StaticPresData))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StaticPresData>())).mLangService as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StaticPresData),
                    "::",
                    stringify!(mLangService)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<StaticPresData>())).mLangGroupFontPrefs as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(StaticPresData),
                    "::",
                    stringify!(mLangGroupFontPrefs)
                )
            );
        }
        #[repr(C)]
        pub struct JSONWriteFunc__bindgen_vtable(::std::os::raw::c_void);
        #[repr(C)]
        #[derive(Debug)]
        pub struct JSONWriteFunc {
            pub vtable_: *const JSONWriteFunc__bindgen_vtable,
        }
        #[test]
        fn bindgen_test_layout_JSONWriteFunc() {
            assert_eq!(
                ::std::mem::size_of::<JSONWriteFunc>(),
                8usize,
                concat!("Size of: ", stringify!(JSONWriteFunc))
            );
            assert_eq!(
                ::std::mem::align_of::<JSONWriteFunc>(),
                8usize,
                concat!("Alignment of ", stringify!(JSONWriteFunc))
            );
        }
        pub type RelaxedAtomicBool = u32;
        pub type RelaxedAtomicInt32 = u32;
        pub type RelaxedAtomicUint32 = u32;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StaticPrefs {
            pub _address: u8,
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs40sVarCache_accessibility_monoaudio_enableE"]
            pub static mut StaticPrefs_sVarCache_accessibility_monoaudio_enable:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs28sVarCache_clipboard_autocopyE"]
            pub static mut StaticPrefs_sVarCache_clipboard_autocopy: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs48sVarCache_dom_animations_api_compositing_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_animations_api_compositing_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs41sVarCache_dom_animations_api_core_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_animations_api_core_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs50sVarCache_dom_animations_api_getAnimations_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_animations_api_getAnimations_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs55sVarCache_dom_animations_api_implicit_keyframes_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_animations_api_implicit_keyframes_enabled:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs46sVarCache_dom_animations_api_timelines_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_animations_api_timelines_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs73sVarCache_dom_compositionevent_text_dispatch_only_system_group_in_contentE"]
            pub static mut StaticPrefs_sVarCache_dom_compositionevent_text_dispatch_only_system_group_in_content:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs42sVarCache_dom_ipc_tabs_shutdownTimeoutSecsE"]
            pub static mut StaticPrefs_sVarCache_dom_ipc_tabs_shutdownTimeoutSecs:
                root::mozilla::RelaxedAtomicUint32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs43sVarCache_dom_event_clipboardevents_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_event_clipboardevents_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs75sVarCache_dom_keyboardevent_keypress_set_keycode_and_charcode_to_same_valueE"]
            pub static mut StaticPrefs_sVarCache_dom_keyboardevent_keypress_set_keycode_and_charcode_to_same_value:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs45sVarCache_dom_input_events_conform_to_level_1E"]
            pub static mut StaticPrefs_sVarCache_dom_input_events_conform_to_level_1: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs55sVarCache_dom_input_skip_cursor_move_for_same_value_setE"]
            pub static mut StaticPrefs_sVarCache_dom_input_skip_cursor_move_for_same_value_set:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs50sVarCache_dom_webcomponents_shadowdom_report_usageE"]
            pub static mut StaticPrefs_sVarCache_dom_webcomponents_shadowdom_report_usage: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs44sVarCache_dom_mutation_events_cssom_disabledE"]
            pub static mut StaticPrefs_sVarCache_dom_mutation_events_cssom_disabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs45sVarCache_dom_link_disabled_attribute_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_link_disabled_attribute_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs39sVarCache_dom_timeout_defer_during_loadE"]
            pub static mut StaticPrefs_sVarCache_dom_timeout_defer_during_load: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs39sVarCache_dom_timeout_max_idle_defer_msE"]
            pub static mut StaticPrefs_sVarCache_dom_timeout_max_idle_defer_ms: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs54sVarCache_dom_performance_children_results_ipc_timeoutE"]
            pub static mut StaticPrefs_sVarCache_dom_performance_children_results_ipc_timeout: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs38sVarCache_dom_payments_request_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_payments_request_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs56sVarCache_dom_payments_request_user_interaction_requiredE"]
            pub static mut StaticPrefs_sVarCache_dom_payments_request_user_interaction_required:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs39sVarCache_dom_payments_response_timeoutE"]
            pub static mut StaticPrefs_sVarCache_dom_payments_response_timeout: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs28sVarCache_dom_caches_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_caches_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs36sVarCache_dom_caches_testing_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_caches_testing_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs52sVarCache_dom_performance_enable_user_timing_loggingE"]
            pub static mut StaticPrefs_sVarCache_dom_performance_enable_user_timing_logging:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs38sVarCache_dom_webnotifications_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_webnotifications_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs44sVarCache_dom_webnotifications_allowinsecureE"]
            pub static mut StaticPrefs_sVarCache_dom_webnotifications_allowinsecure:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs53sVarCache_dom_webnotifications_requireuserinteractionE"]
            pub static mut StaticPrefs_sVarCache_dom_webnotifications_requireuserinteraction:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs52sVarCache_dom_webnotifications_serviceworker_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_webnotifications_serviceworker_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs57sVarCache_dom_webnotifications_requireinteraction_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_webnotifications_requireinteraction_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs36sVarCache_dom_serviceWorkers_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_serviceWorkers_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs44sVarCache_dom_serviceWorkers_testing_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_serviceWorkers_testing_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs51sVarCache_dom_testing_structuredclonetester_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_testing_structuredclonetester_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs36sVarCache_dom_storageManager_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_storageManager_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs46sVarCache_dom_promise_rejection_events_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_promise_rejection_events_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs26sVarCache_dom_push_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_push_enabled: root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs43sVarCache_dom_webkitBlink_dirPicker_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_webkitBlink_dirPicker_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs29sVarCache_dom_netinfo_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_netinfo_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs35sVarCache_dom_fetchObserver_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_fetchObserver_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs32sVarCache_dom_enable_performanceE"]
            pub static mut StaticPrefs_sVarCache_dom_enable_performance:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs41sVarCache_dom_enable_performance_observerE"]
            pub static mut StaticPrefs_sVarCache_dom_enable_performance_observer:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs36sVarCache_dom_enable_resource_timingE"]
            pub static mut StaticPrefs_sVarCache_dom_enable_resource_timing: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs50sVarCache_dom_enable_performance_navigation_timingE"]
            pub static mut StaticPrefs_sVarCache_dom_enable_performance_navigation_timing: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs58sVarCache_dom_performance_enable_notify_performance_timingE"]
            pub static mut StaticPrefs_sVarCache_dom_performance_enable_notify_performance_timing:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs58sVarCache_browser_measurement_render_anims_and_video_solidE"]
            pub static mut StaticPrefs_sVarCache_browser_measurement_render_anims_and_video_solid:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs45sVarCache_dom_indexedDB_storageOption_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_indexedDB_storageOption_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs50sVarCache_dom_script_loader_bytecode_cache_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_script_loader_bytecode_cache_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs51sVarCache_dom_script_loader_bytecode_cache_strategyE"]
            pub static mut StaticPrefs_sVarCache_dom_script_loader_bytecode_cache_strategy: i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs41sVarCache_browser_dom_window_dump_enabledE"]
            pub static mut StaticPrefs_sVarCache_browser_dom_window_dump_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs50sVarCache_dom_worker_canceling_timeoutMillisecondsE"]
            pub static mut StaticPrefs_sVarCache_dom_worker_canceling_timeoutMilliseconds:
                root::mozilla::RelaxedAtomicUint32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs48sVarCache_dom_worker_use_medium_high_event_queueE"]
            pub static mut StaticPrefs_sVarCache_dom_worker_use_medium_high_event_queue:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs53sVarCache_dom_xhr_standard_content_type_normalizationE"]
            pub static mut StaticPrefs_sVarCache_dom_xhr_standard_content_type_normalization:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs48sVarCache_dom_block_external_protocol_in_iframesE"]
            pub static mut StaticPrefs_sVarCache_dom_block_external_protocol_in_iframes: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs54sVarCache_dom_delay_block_external_protocol_in_iframesE"]
            pub static mut StaticPrefs_sVarCache_dom_delay_block_external_protocol_in_iframes: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs35sVarCache_dom_block_multiple_popupsE"]
            pub static mut StaticPrefs_sVarCache_dom_block_multiple_popups: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs41sVarCache_dom_targetBlankNoOpener_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_targetBlankNoOpener_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs38sVarCache_dom_disable_open_during_loadE"]
            pub static mut StaticPrefs_sVarCache_dom_disable_open_during_load: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs36sVarCache_dom_storage_access_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_storage_access_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs46sVarCache_dom_prototype_document_cache_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_prototype_document_cache_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs48sVarCache_dom_storage_access_auto_grants_delayedE"]
            pub static mut StaticPrefs_sVarCache_dom_storage_access_auto_grants_delayed: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs44sVarCache_dom_window_open_noreferrer_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_window_open_noreferrer_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs32sVarCache_dom_file_createInChildE"]
            pub static mut StaticPrefs_sVarCache_dom_file_createInChild:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs28sVarCache_dom_allow_cut_copyE"]
            pub static mut StaticPrefs_sVarCache_dom_allow_cut_copy: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs45sVarCache_dom_forms_autocomplete_formautofillE"]
            pub static mut StaticPrefs_sVarCache_dom_forms_autocomplete_formautofill: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs41sVarCache_dom_requestIdleCallback_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_requestIdleCallback_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs39sVarCache_dom_placeholder_show_on_focusE"]
            pub static mut StaticPrefs_sVarCache_dom_placeholder_show_on_focus: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs52sVarCache_dom_presentation_testing_simulate_receiverE"]
            pub static mut StaticPrefs_sVarCache_dom_presentation_testing_simulate_receiver: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs41sVarCache_dom_largeAllocation_forceEnableE"]
            pub static mut StaticPrefs_sVarCache_dom_largeAllocation_forceEnable: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs43sVarCache_dom_metaElement_setCookie_allowedE"]
            pub static mut StaticPrefs_sVarCache_dom_metaElement_setCookie_allowed: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs50sVarCache_extensions_allowPrivateBrowsingByDefaultE"]
            pub static mut StaticPrefs_sVarCache_extensions_allowPrivateBrowsingByDefault: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs55sVarCache_extensions_cookiesBehavior_overrideOnTopLevelE"]
            pub static mut StaticPrefs_sVarCache_extensions_cookiesBehavior_overrideOnTopLevel:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs41sVarCache_extensions_webextensions_remoteE"]
            pub static mut StaticPrefs_sVarCache_extensions_webextensions_remote: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs33sVarCache_full_screen_api_enabledE"]
            pub static mut StaticPrefs_sVarCache_full_screen_api_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs42sVarCache_full_screen_api_unprefix_enabledE"]
            pub static mut StaticPrefs_sVarCache_full_screen_api_unprefix_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs53sVarCache_full_screen_api_allow_trusted_requests_onlyE"]
            pub static mut StaticPrefs_sVarCache_full_screen_api_allow_trusted_requests_only: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs48sVarCache_browser_display_focus_ring_on_anythingE"]
            pub static mut StaticPrefs_sVarCache_browser_display_focus_ring_on_anything: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs42sVarCache_browser_display_focus_ring_widthE"]
            pub static mut StaticPrefs_sVarCache_browser_display_focus_ring_width: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs42sVarCache_browser_display_focus_ring_styleE"]
            pub static mut StaticPrefs_sVarCache_browser_display_focus_ring_style: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs43sVarCache_browser_display_use_system_colorsE"]
            pub static mut StaticPrefs_sVarCache_browser_display_use_system_colors: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs44sVarCache_browser_display_document_color_useE"]
            pub static mut StaticPrefs_sVarCache_browser_display_document_color_use: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs42sVarCache_browser_display_use_focus_colorsE"]
            pub static mut StaticPrefs_sVarCache_browser_display_use_focus_colors: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs35sVarCache_browser_underline_anchorsE"]
            pub static mut StaticPrefs_sVarCache_browser_underline_anchors: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs27sVarCache_browser_autofocusE"]
            pub static mut StaticPrefs_sVarCache_browser_autofocus: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs44sVarCache_browser_display_use_document_fontsE"]
            pub static mut StaticPrefs_sVarCache_browser_display_use_document_fonts:
                root::mozilla::RelaxedAtomicInt32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs49sVarCache_gfx_font_rendering_opentype_svg_enabledE"]
            pub static mut StaticPrefs_sVarCache_gfx_font_rendering_opentype_svg_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs37sVarCache_gfx_offscreencanvas_enabledE"]
            pub static mut StaticPrefs_sVarCache_gfx_offscreencanvas_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs38sVarCache_gfx_font_ahem_antialias_noneE"]
            pub static mut StaticPrefs_sVarCache_gfx_font_ahem_antialias_none:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs35sVarCache_gfx_omta_background_colorE"]
            pub static mut StaticPrefs_sVarCache_gfx_omta_background_color: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs29sVarCache_html5_offmainthreadE"]
            pub static mut StaticPrefs_sVarCache_html5_offmainthread: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs39sVarCache_html5_flushtimer_initialdelayE"]
            pub static mut StaticPrefs_sVarCache_html5_flushtimer_initialdelay:
                root::mozilla::RelaxedAtomicInt32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs42sVarCache_html5_flushtimer_subsequentdelayE"]
            pub static mut StaticPrefs_sVarCache_html5_flushtimer_subsequentdelay:
                root::mozilla::RelaxedAtomicInt32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs37sVarCache_layout_cursor_block_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_cursor_block_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs38sVarCache_layout_cursor_block_max_sizeE"]
            pub static mut StaticPrefs_sVarCache_layout_cursor_block_max_size: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs40sVarCache_layout_accessiblecaret_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_accessiblecaret_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs49sVarCache_layout_accessiblecaret_enabled_on_touchE"]
            pub static mut StaticPrefs_sVarCache_layout_accessiblecaret_enabled_on_touch: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs44sVarCache_layout_accessiblecaret_always_tiltE"]
            pub static mut StaticPrefs_sVarCache_layout_accessiblecaret_always_tilt: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs79sVarCache_layout_accessiblecaret_caret_shown_when_long_tapping_on_empty_contentE"]
            pub static mut StaticPrefs_sVarCache_layout_accessiblecaret_caret_shown_when_long_tapping_on_empty_content:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs58sVarCache_layout_accessiblecaret_script_change_update_modeE"]
            pub static mut StaticPrefs_sVarCache_layout_accessiblecaret_script_change_update_mode:
                i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs66sVarCache_layout_accessiblecaret_allow_dragging_across_other_caretE"]
            pub static mut StaticPrefs_sVarCache_layout_accessiblecaret_allow_dragging_across_other_caret:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs47sVarCache_layout_accessiblecaret_hapticfeedbackE"]
            pub static mut StaticPrefs_sVarCache_layout_accessiblecaret_hapticfeedback: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs66sVarCache_layout_accessiblecaret_extend_selection_for_phone_numberE"]
            pub static mut StaticPrefs_sVarCache_layout_accessiblecaret_extend_selection_for_phone_number:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs60sVarCache_layout_accessiblecaret_hide_carets_for_mouse_inputE"]
            pub static mut StaticPrefs_sVarCache_layout_accessiblecaret_hide_carets_for_mouse_input:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs38sVarCache_layout_accessiblecaret_widthE"]
            pub static mut StaticPrefs_sVarCache_layout_accessiblecaret_width: f32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs39sVarCache_layout_accessiblecaret_heightE"]
            pub static mut StaticPrefs_sVarCache_layout_accessiblecaret_height: f32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs44sVarCache_layout_accessiblecaret_margin_leftE"]
            pub static mut StaticPrefs_sVarCache_layout_accessiblecaret_margin_left: f32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs54sVarCache_layout_accessiblecaret_use_long_tap_injectorE"]
            pub static mut StaticPrefs_sVarCache_layout_accessiblecaret_use_long_tap_injector: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs37sVarCache_layout_css_parsing_parallelE"]
            pub static mut StaticPrefs_sVarCache_layout_css_parsing_parallel: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs41sVarCache_layout_css_use_counters_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_use_counters_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs34sVarCache_layout_css_report_errorsE"]
            pub static mut StaticPrefs_sVarCache_layout_css_report_errors: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs41sVarCache_layout_css_font_display_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_font_display_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs36sVarCache_layout_css_prefixes_webkitE"]
            pub static mut StaticPrefs_sVarCache_layout_css_prefixes_webkit: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs55sVarCache_layout_css_prefixes_device_pixel_ratio_webkitE"]
            pub static mut StaticPrefs_sVarCache_layout_css_prefixes_device_pixel_ratio_webkit:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs48sVarCache_layout_css_simple_moz_gradient_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_simple_moz_gradient_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs54sVarCache_layout_css_offset_logical_properties_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_offset_logical_properties_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs47sVarCache_layout_css_control_characters_visibleE"]
            pub static mut StaticPrefs_sVarCache_layout_css_control_characters_visible: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs42sVarCache_layout_css_visited_links_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_visited_links_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs46sVarCache_layout_css_webkit_appearance_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_webkit_appearance_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs49sVarCache_layout_css_moz_document_content_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_moz_document_content_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs48sVarCache_layout_css_moz_binding_content_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_moz_binding_content_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs46sVarCache_layout_css_supports_selector_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_supports_selector_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs57sVarCache_layout_css_moz_document_url_prefix_hack_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_moz_document_url_prefix_hack_enabled:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs55sVarCache_layout_css_xul_display_values_content_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_xul_display_values_content_enabled:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs59sVarCache_layout_css_xul_box_display_values_content_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_xul_box_display_values_content_enabled:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs53sVarCache_layout_css_xul_tree_pseudos_content_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_xul_tree_pseudos_content_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs56sVarCache_layout_css_grid_template_subgrid_value_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_grid_template_subgrid_value_enabled:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs65sVarCache_layout_css_line_height_moz_block_height_content_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_line_height_moz_block_height_content_enabled:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs44sVarCache_layout_css_font_variations_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_font_variations_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs46sVarCache_layout_css_emulate_moz_box_with_flexE"]
            pub static mut StaticPrefs_sVarCache_layout_css_emulate_moz_box_with_flex: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs50sVarCache_layout_css_unknown_webkit_pseudo_elementE"]
            pub static mut StaticPrefs_sVarCache_layout_css_unknown_webkit_pseudo_element: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs43sVarCache_layout_css_clip_path_path_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_clip_path_path_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs40sVarCache_layout_css_column_span_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_column_span_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs36sVarCache_layout_css_contain_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_contain_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs47sVarCache_layout_css_step_position_jump_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_step_position_jump_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs45sVarCache_layout_dynamic_reflow_roots_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_dynamic_reflow_roots_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs58sVarCache_layout_lower_priority_refresh_driver_during_loadE"]
            pub static mut StaticPrefs_sVarCache_layout_lower_priority_refresh_driver_during_load:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs45sVarCache_layout_css_scroll_anchoring_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_scroll_anchoring_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs47sVarCache_layout_css_scroll_anchoring_highlightE"]
            pub static mut StaticPrefs_sVarCache_layout_css_scroll_anchoring_highlight: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs43sVarCache_layout_css_scroll_snap_v1_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_scroll_snap_v1_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs40sVarCache_layout_css_scroll_snap_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_scroll_snap_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs52sVarCache_layout_css_shared_memory_ua_sheets_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_shared_memory_ua_sheets_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs43sVarCache_layout_css_resizeobserver_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_resizeobserver_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs40sVarCache_layout_css_getBoxQuads_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_getBoxQuads_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs38sVarCache_xul_panel_animations_enabledE"]
            pub static mut StaticPrefs_sVarCache_xul_panel_animations_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs46sVarCache_layout_css_webkit_line_clamp_enabledE"]
            pub static mut StaticPrefs_sVarCache_layout_css_webkit_line_clamp_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs50sVarCache_javascript_options_gc_on_memory_pressureE"]
            pub static mut StaticPrefs_sVarCache_javascript_options_gc_on_memory_pressure: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs53sVarCache_javascript_options_compact_on_user_inactiveE"]
            pub static mut StaticPrefs_sVarCache_javascript_options_compact_on_user_inactive: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs59sVarCache_javascript_options_compact_on_user_inactive_delayE"]
            pub static mut StaticPrefs_sVarCache_javascript_options_compact_on_user_inactive_delay:
                u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs36sVarCache_javascript_options_mem_logE"]
            pub static mut StaticPrefs_sVarCache_javascript_options_mem_log: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs39sVarCache_javascript_options_mem_notifyE"]
            pub static mut StaticPrefs_sVarCache_javascript_options_mem_notify: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs36sVarCache_javascript_options_streamsE"]
            pub static mut StaticPrefs_sVarCache_javascript_options_streams:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs35sVarCache_javascript_options_bigintE"]
            pub static mut StaticPrefs_sVarCache_javascript_options_bigint:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs48sVarCache_javascript_options_experimental_fieldsE"]
            pub static mut StaticPrefs_sVarCache_javascript_options_experimental_fields:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs51sVarCache_javascript_options_experimental_await_fixE"]
            pub static mut StaticPrefs_sVarCache_javascript_options_experimental_await_fix:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs51sVarCache_dom_ipc_cancel_content_js_when_navigatingE"]
            pub static mut StaticPrefs_sVarCache_dom_ipc_cancel_content_js_when_navigating: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs24sVarCache_MediaCacheSizeE"]
            pub static mut StaticPrefs_sVarCache_MediaCacheSize: root::mozilla::RelaxedAtomicUint32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs32sVarCache_MediaCacheCellularSizeE"]
            pub static mut StaticPrefs_sVarCache_MediaCacheCellularSize:
                root::mozilla::RelaxedAtomicUint32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs33sVarCache_MediaMemoryCacheMaxSizeE"]
            pub static mut StaticPrefs_sVarCache_MediaMemoryCacheMaxSize: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs42sVarCache_MediaMemoryCachesCombinedLimitKbE"]
            pub static mut StaticPrefs_sVarCache_MediaMemoryCachesCombinedLimitKb: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs48sVarCache_MediaMemoryCachesCombinedLimitPcSysmemE"]
            pub static mut StaticPrefs_sVarCache_MediaMemoryCachesCombinedLimitPcSysmem: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs35sVarCache_MediaCacheResumeThresholdE"]
            pub static mut StaticPrefs_sVarCache_MediaCacheResumeThreshold:
                root::mozilla::RelaxedAtomicUint32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs43sVarCache_MediaCacheCellularResumeThresholdE"]
            pub static mut StaticPrefs_sVarCache_MediaCacheCellularResumeThreshold:
                root::mozilla::RelaxedAtomicUint32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs34sVarCache_MediaCacheReadaheadLimitE"]
            pub static mut StaticPrefs_sVarCache_MediaCacheReadaheadLimit:
                root::mozilla::RelaxedAtomicUint32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs42sVarCache_MediaCacheCellularReadaheadLimitE"]
            pub static mut StaticPrefs_sVarCache_MediaCacheCellularReadaheadLimit:
                root::mozilla::RelaxedAtomicUint32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs32sVarCache_MediaResamplingEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaResamplingEnabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs33sVarCache_MediaForcestereoEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaForcestereoEnabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs32sVarCache_MediaRuinAvSyncEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaRuinAvSyncEnabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs25sVarCache_MediaEmeEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaEmeEnabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs47sVarCache_MediaClearkeyPersistentLicenseEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaClearkeyPersistentLicenseEnabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs31sVarCache_MediaGmpInsecureAllowE"]
            pub static mut StaticPrefs_sVarCache_MediaGmpInsecureAllow:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs30sVarCache_MediaUseBlankDecoderE"]
            pub static mut StaticPrefs_sVarCache_MediaUseBlankDecoder:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs32sVarCache_MediaGpuProcessDecoderE"]
            pub static mut StaticPrefs_sVarCache_MediaGpuProcessDecoder:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs32sVarCache_MediaRddProcessEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaRddProcessEnabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs41sVarCache_MediaRddProcessStartupTimeoutMsE"]
            pub static mut StaticPrefs_sVarCache_MediaRddProcessStartupTimeoutMs:
                root::mozilla::RelaxedAtomicInt32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs31sVarCache_MediaRddVorbisEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaRddVorbisEnabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs33sVarCache_media_navigator_enabledE"]
            pub static mut StaticPrefs_sVarCache_media_navigator_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs40sVarCache_media_devices_insecure_enabledE"]
            pub static mut StaticPrefs_sVarCache_media_devices_insecure_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs45sVarCache_media_getusermedia_insecure_enabledE"]
            pub static mut StaticPrefs_sVarCache_media_getusermedia_insecure_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs38sVarCache_media_peerconnection_enabledE"]
            pub static mut StaticPrefs_sVarCache_media_peerconnection_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs50sVarCache_MediaNavigatorMediadatadecoderVPXEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaNavigatorMediadatadecoderVPXEnabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs51sVarCache_MediaNavigatorMediadatadecoderH264EnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaNavigatorMediadatadecoderH264Enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs28sVarCache_MediaFfmpegEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaFfmpegEnabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs38sVarCache_MediaLibavcodecAllowObsoleteE"]
            pub static mut StaticPrefs_sVarCache_MediaLibavcodecAllowObsolete: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs27sVarCache_MediaFfvpxEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaFfvpxEnabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs38sVarCache_MediaFfmpegLowLatencyEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaFfmpegLowLatencyEnabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs36sVarCache_MediaDecoderRecycleEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaDecoderRecycleEnabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs47sVarCache_MediaDecoderSkipToNextKeyFrameEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaDecoderSkipToNextKeyFrameEnabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs32sVarCache_MediaGmpDecoderEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaGmpDecoderEnabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs28sVarCache_MediaEmeAudioBlankE"]
            pub static mut StaticPrefs_sVarCache_MediaEmeAudioBlank:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs28sVarCache_MediaEmeVideoBlankE"]
            pub static mut StaticPrefs_sVarCache_MediaEmeVideoBlank:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs40sVarCache_MediaEmeChromiumApiVideoShmemsE"]
            pub static mut StaticPrefs_sVarCache_MediaEmeChromiumApiVideoShmems:
                root::mozilla::RelaxedAtomicUint32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs39sVarCache_MediaSuspendBkgndVideoEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaSuspendBkgndVideoEnabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs39sVarCache_MediaSuspendBkgndVideoDelayMsE"]
            pub static mut StaticPrefs_sVarCache_MediaSuspendBkgndVideoDelayMs:
                root::mozilla::RelaxedAtomicUint32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs38sVarCache_MediaDormantOnPauseTimeoutMsE"]
            pub static mut StaticPrefs_sVarCache_MediaDormantOnPauseTimeoutMs:
                root::mozilla::RelaxedAtomicInt32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs45sVarCache_MediaWebspeechSynthForceGlobalQueueE"]
            pub static mut StaticPrefs_sVarCache_MediaWebspeechSynthForceGlobalQueue: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs34sVarCache_MediaWebspeechTestEnableE"]
            pub static mut StaticPrefs_sVarCache_MediaWebspeechTestEnable: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs41sVarCache_MediaWebspeechTextFakeFsmEventsE"]
            pub static mut StaticPrefs_sVarCache_MediaWebspeechTextFakeFsmEvents: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs50sVarCache_MediaWebspeechTextFakeRecognitionServiceE"]
            pub static mut StaticPrefs_sVarCache_MediaWebspeechTextFakeRecognitionService: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs41sVarCache_MediaWebspeechRecognitionEnableE"]
            pub static mut StaticPrefs_sVarCache_MediaWebspeechRecognitionEnable: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs46sVarCache_MediaWebspeechRecognitionForceEnableE"]
            pub static mut StaticPrefs_sVarCache_MediaWebspeechRecognitionForceEnable: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs33sVarCache_MediaEncoderWebMEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaEncoderWebMEnabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs34sVarCache_MediaAudioMaxDecodeErrorE"]
            pub static mut StaticPrefs_sVarCache_MediaAudioMaxDecodeError: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs34sVarCache_MediaVideoMaxDecodeErrorE"]
            pub static mut StaticPrefs_sVarCache_MediaVideoMaxDecodeError: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs26sVarCache_MediaOpusEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaOpusEnabled: root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs26sVarCache_MediaWaveEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaWaveEnabled: root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs25sVarCache_MediaOggEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaOggEnabled: root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs26sVarCache_MediaWebMEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaWebMEnabled: root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs25sVarCache_MediaAv1EnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaAv1Enabled: root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs26sVarCache_MediaAv1UseDav1dE"]
            pub static mut StaticPrefs_sVarCache_MediaAv1UseDav1d: root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs26sVarCache_MediaFlacEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaFlacEnabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs25sVarCache_MediaHlsEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaHlsEnabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs25sVarCache_MediaMp4EnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaMp4Enabled: root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs39sVarCache_MediaPlaybackWarningsAsErrorsE"]
            pub static mut StaticPrefs_sVarCache_MediaPlaybackWarningsAsErrors:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs41sVarCache_MediaResumeBkgndVideoOnTabhoverE"]
            pub static mut StaticPrefs_sVarCache_MediaResumeBkgndVideoOnTabhover: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs48sVarCache_MediaVideocontrolsLockVideoOrientationE"]
            pub static mut StaticPrefs_sVarCache_MediaVideocontrolsLockVideoOrientation: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs30sVarCache_MediaSeamlessLoopingE"]
            pub static mut StaticPrefs_sVarCache_MediaSeamlessLooping:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs32sVarCache_MediaBlockEventEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaBlockEventEnabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs34sVarCache_MediaCapabilitiesEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaCapabilitiesEnabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs40sVarCache_MediaCapabilitiesScreenEnabledE"]
            pub static mut StaticPrefs_sVarCache_MediaCapabilitiesScreenEnabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs30sVarCache_MediaBenchmarkVp9FpsE"]
            pub static mut StaticPrefs_sVarCache_MediaBenchmarkVp9Fps:
                root::mozilla::RelaxedAtomicUint32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs36sVarCache_MediaBenchmarkVp9ThresholdE"]
            pub static mut StaticPrefs_sVarCache_MediaBenchmarkVp9Threshold:
                root::mozilla::RelaxedAtomicUint32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs39sVarCache_MediaBenchmarkVp9VersioncheckE"]
            pub static mut StaticPrefs_sVarCache_MediaBenchmarkVp9Versioncheck:
                root::mozilla::RelaxedAtomicUint32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs30sVarCache_MediaBenchmarkFramesE"]
            pub static mut StaticPrefs_sVarCache_MediaBenchmarkFrames:
                root::mozilla::RelaxedAtomicUint32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs31sVarCache_MediaBenchmarkTimeoutE"]
            pub static mut StaticPrefs_sVarCache_MediaBenchmarkTimeout:
                root::mozilla::RelaxedAtomicUint32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs31sVarCache_MediaTestVideoSuspendE"]
            pub static mut StaticPrefs_sVarCache_MediaTestVideoSuspend:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs33sVarCache_MediaAutoplayAllowMutedE"]
            pub static mut StaticPrefs_sVarCache_MediaAutoplayAllowMuted:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs47sVarCache_MediaAutoplayBlackListOverrideDefaultE"]
            pub static mut StaticPrefs_sVarCache_MediaAutoplayBlackListOverrideDefault:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs50sVarCache_network_auth_subresource_http_auth_allowE"]
            pub static mut StaticPrefs_sVarCache_network_auth_subresource_http_auth_allow: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs67sVarCache_network_auth_subresource_img_cross_origin_http_auth_allowE"]
            pub static mut StaticPrefs_sVarCache_network_auth_subresource_img_cross_origin_http_auth_allow:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs74sVarCache_network_auth_non_web_content_triggered_resources_http_auth_allowE"]
            pub static mut StaticPrefs_sVarCache_network_auth_non_web_content_triggered_resources_http_auth_allow:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs39sVarCache_network_cookie_cookieBehaviorE"]
            pub static mut StaticPrefs_sVarCache_network_cookie_cookieBehavior:
                root::mozilla::RelaxedAtomicInt32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs39sVarCache_network_cookie_staleThresholdE"]
            pub static mut StaticPrefs_sVarCache_network_cookie_staleThreshold: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs39sVarCache_network_cookie_lifetimePolicyE"]
            pub static mut StaticPrefs_sVarCache_network_cookie_lifetimePolicy:
                root::mozilla::RelaxedAtomicInt32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs35sVarCache_network_predictor_enabledE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs54sVarCache_network_cookieSettings_unblocked_for_testingE"]
            pub static mut StaticPrefs_sVarCache_network_cookieSettings_unblocked_for_testing: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs47sVarCache_network_predictor_enable_hover_on_sslE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_enable_hover_on_ssl: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs43sVarCache_network_predictor_enable_prefetchE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_enable_prefetch: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs48sVarCache_network_predictor_page_degradation_dayE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_page_degradation_day: i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs49sVarCache_network_predictor_page_degradation_weekE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_page_degradation_week: i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs50sVarCache_network_predictor_page_degradation_monthE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_page_degradation_month: i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs49sVarCache_network_predictor_page_degradation_yearE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_page_degradation_year: i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs48sVarCache_network_predictor_page_degradation_maxE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_page_degradation_max: i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs55sVarCache_network_predictor_subresource_degradation_dayE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_subresource_degradation_day: i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs56sVarCache_network_predictor_subresource_degradation_weekE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_subresource_degradation_week:
                i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs57sVarCache_network_predictor_subresource_degradation_monthE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_subresource_degradation_month:
                i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs56sVarCache_network_predictor_subresource_degradation_yearE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_subresource_degradation_year:
                i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs55sVarCache_network_predictor_subresource_degradation_maxE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_subresource_degradation_max: i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs55sVarCache_network_predictor_prefetch_rolling_load_countE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_prefetch_rolling_load_count: i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs51sVarCache_network_predictor_prefetch_min_confidenceE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_prefetch_min_confidence: i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs53sVarCache_network_predictor_preconnect_min_confidenceE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_preconnect_min_confidence: i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs53sVarCache_network_predictor_preresolve_min_confidenceE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_preresolve_min_confidence: i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs52sVarCache_network_predictor_prefetch_force_valid_forE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_prefetch_force_valid_for: i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs51sVarCache_network_predictor_max_resources_per_entryE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_max_resources_per_entry: i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs42sVarCache_network_predictor_max_uri_lengthE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_max_uri_length: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs39sVarCache_network_predictor_doing_testsE"]
            pub static mut StaticPrefs_sVarCache_network_predictor_doing_tests: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs42sVarCache_network_traffic_analyzer_enabledE"]
            pub static mut StaticPrefs_sVarCache_network_traffic_analyzer_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs37sVarCache_network_delay_tracking_loadE"]
            pub static mut StaticPrefs_sVarCache_network_delay_tracking_load: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs50sVarCache_network_dns_resolver_shutdown_timeout_msE"]
            pub static mut StaticPrefs_sVarCache_network_dns_resolver_shutdown_timeout_ms: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs38sVarCache_network_http_tailing_enabledE"]
            pub static mut StaticPrefs_sVarCache_network_http_tailing_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs48sVarCache_browser_sessionstore_dom_storage_limitE"]
            pub static mut StaticPrefs_sVarCache_browser_sessionstore_dom_storage_limit: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs36sVarCache_plain_text_wrap_long_linesE"]
            pub static mut StaticPrefs_sVarCache_plain_text_wrap_long_lines: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs59sVarCache_browser_contentblocking_allowlist_storage_enabledE"]
            pub static mut StaticPrefs_sVarCache_browser_contentblocking_allowlist_storage_enabled:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs63sVarCache_browser_contentblocking_allowlist_annotations_enabledE"]
            pub static mut StaticPrefs_sVarCache_browser_contentblocking_allowlist_annotations_enabled:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs50sVarCache_browser_contentblocking_originlog_lengthE"]
            pub static mut StaticPrefs_sVarCache_browser_contentblocking_originlog_length: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs74sVarCache_browser_contentblocking_rejecttrackers_control_center_ui_enabledE"]
            pub static mut StaticPrefs_sVarCache_browser_contentblocking_rejecttrackers_control_center_ui_enabled:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs36sVarCache_privacy_file_unique_originE"]
            pub static mut StaticPrefs_sVarCache_privacy_file_unique_origin: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs55sVarCache_privacy_annotate_channels_strict_list_enabledE"]
            pub static mut StaticPrefs_sVarCache_privacy_annotate_channels_strict_list_enabled:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs54sVarCache_privacy_trackingprotection_annotate_channelsE"]
            pub static mut StaticPrefs_sVarCache_privacy_trackingprotection_annotate_channels: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs59sVarCache_privacy_trackingprotection_fingerprinting_enabledE"]
            pub static mut StaticPrefs_sVarCache_privacy_trackingprotection_fingerprinting_enabled:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs68sVarCache_privacy_trackingprotection_fingerprinting_annotate_enabledE"]
            pub static mut StaticPrefs_sVarCache_privacy_trackingprotection_fingerprinting_annotate_enabled:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs57sVarCache_privacy_trackingprotection_cryptomining_enabledE"]
            pub static mut StaticPrefs_sVarCache_privacy_trackingprotection_cryptomining_enabled:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs66sVarCache_privacy_trackingprotection_cryptomining_annotate_enabledE"]
            pub static mut StaticPrefs_sVarCache_privacy_trackingprotection_cryptomining_annotate_enabled:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs31sVarCache_privacy_spoof_englishE"]
            pub static mut StaticPrefs_sVarCache_privacy_spoof_english:
                root::mozilla::RelaxedAtomicUint32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs42sVarCache_privacy_donottrackheader_enabledE"]
            pub static mut StaticPrefs_sVarCache_privacy_donottrackheader_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs59sVarCache_privacy_trackingprotection_lower_network_priorityE"]
            pub static mut StaticPrefs_sVarCache_privacy_trackingprotection_lower_network_priority:
                bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs52sVarCache_privacy_restrict3rdpartystorage_expirationE"]
            pub static mut StaticPrefs_sVarCache_privacy_restrict3rdpartystorage_expiration: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs44sVarCache_privacy_userInteraction_expirationE"]
            pub static mut StaticPrefs_sVarCache_privacy_userInteraction_expiration: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs51sVarCache_privacy_userInteraction_document_intervalE"]
            pub static mut StaticPrefs_sVarCache_privacy_userInteraction_document_interval: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs40sVarCache_privacy_documentCookies_maxageE"]
            pub static mut StaticPrefs_sVarCache_privacy_documentCookies_maxage: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs38sVarCache_privacy_resistFingerprintingE"]
            pub static mut StaticPrefs_sVarCache_privacy_resistFingerprinting:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs74sVarCache_privacy_resistFingerprinting_autoDeclineNoUserInputCanvasPromptsE"]
            pub static mut StaticPrefs_sVarCache_privacy_resistFingerprinting_autoDeclineNoUserInputCanvasPrompts:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs53sVarCache_privacy_storagePrincipal_enabledForTrackersE"]
            pub static mut StaticPrefs_sVarCache_privacy_storagePrincipal_enabledForTrackers:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs38sVarCache_privacy_window_maxInnerWidthE"]
            pub static mut StaticPrefs_sVarCache_privacy_window_maxInnerWidth: i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs39sVarCache_privacy_window_maxInnerHeightE"]
            pub static mut StaticPrefs_sVarCache_privacy_window_maxInnerHeight: i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs50sVarCache_dom_event_handling_user_input_time_limitE"]
            pub static mut StaticPrefs_sVarCache_dom_event_handling_user_input_time_limit: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs48sVarCache_browser_safebrowsing_passwords_enabledE"]
            pub static mut StaticPrefs_sVarCache_browser_safebrowsing_passwords_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs46sVarCache_browser_safebrowsing_malware_enabledE"]
            pub static mut StaticPrefs_sVarCache_browser_safebrowsing_malware_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs47sVarCache_browser_safebrowsing_phishing_enabledE"]
            pub static mut StaticPrefs_sVarCache_browser_safebrowsing_phishing_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs50sVarCache_browser_safebrowsing_blockedURIs_enabledE"]
            pub static mut StaticPrefs_sVarCache_browser_safebrowsing_blockedURIs_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs55sVarCache_browser_safebrowsing_prefixset_max_array_sizeE"]
            pub static mut StaticPrefs_sVarCache_browser_safebrowsing_prefixset_max_array_size:
                root::mozilla::RelaxedAtomicUint32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs50sVarCache_browser_tabs_remote_useCrossOriginPolicyE"]
            pub static mut StaticPrefs_sVarCache_browser_tabs_remote_useCrossOriginPolicy: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs43sVarCache_ui_use_standins_for_native_colorsE"]
            pub static mut StaticPrefs_sVarCache_ui_use_standins_for_native_colors:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs32sVarCache_ui_use_activity_cursorE"]
            pub static mut StaticPrefs_sVarCache_ui_use_activity_cursor: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs45sVarCache_channelclassifier_allowlist_exampleE"]
            pub static mut StaticPrefs_sVarCache_channelclassifier_allowlist_example: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs29sVarCache_security_csp_enableE"]
            pub static mut StaticPrefs_sVarCache_security_csp_enable: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs42sVarCache_security_csp_enableStrictDynamicE"]
            pub static mut StaticPrefs_sVarCache_security_csp_enableStrictDynamic: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs57sVarCache_security_csp_reporting_script_sample_max_lengthE"]
            pub static mut StaticPrefs_sVarCache_security_csp_reporting_script_sample_max_length:
                i32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs37sVarCache_view_source_editor_externalE"]
            pub static mut StaticPrefs_sVarCache_view_source_editor_external: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs26sVarCache_devtools_enabledE"]
            pub static mut StaticPrefs_sVarCache_devtools_enabled: root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs40sVarCache_devtools_console_stdout_chromeE"]
            pub static mut StaticPrefs_sVarCache_devtools_console_stdout_chrome:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs41sVarCache_devtools_console_stdout_contentE"]
            pub static mut StaticPrefs_sVarCache_devtools_console_stdout_content:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs44sVarCache_dom_security_featurePolicy_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_security_featurePolicy_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs51sVarCache_dom_security_featurePolicy_header_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_security_featurePolicy_header_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs51sVarCache_dom_security_featurePolicy_webidl_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_security_featurePolicy_webidl_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs36sVarCache_plugins_flashBlock_enabledE"]
            pub static mut StaticPrefs_sVarCache_plugins_flashBlock_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs33sVarCache_plugins_http_https_onlyE"]
            pub static mut StaticPrefs_sVarCache_plugins_http_https_only: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs31sVarCache_dom_reporting_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_reporting_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs39sVarCache_dom_reporting_testing_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_reporting_testing_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs45sVarCache_dom_reporting_featurePolicy_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_reporting_featurePolicy_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs38sVarCache_dom_reporting_header_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_reporting_header_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs39sVarCache_dom_reporting_cleanup_timeoutE"]
            pub static mut StaticPrefs_sVarCache_dom_reporting_cleanup_timeout: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs42sVarCache_dom_reporting_delivering_timeoutE"]
            pub static mut StaticPrefs_sVarCache_dom_reporting_delivering_timeout: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs46sVarCache_dom_reporting_delivering_maxFailuresE"]
            pub static mut StaticPrefs_sVarCache_dom_reporting_delivering_maxFailures: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs45sVarCache_dom_reporting_delivering_maxReportsE"]
            pub static mut StaticPrefs_sVarCache_dom_reporting_delivering_maxReports: u32;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs50sVarCache_dom_w3c_touch_events_legacy_apis_enabledE"]
            pub static mut StaticPrefs_sVarCache_dom_w3c_touch_events_legacy_apis_enabled: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs41sVarCache_medium_high_event_queue_enabledE"]
            pub static mut StaticPrefs_sVarCache_medium_high_event_queue_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs47sVarCache_security_fileuri_strict_origin_policyE"]
            pub static mut StaticPrefs_sVarCache_security_fileuri_strict_origin_policy:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs61sVarCache_privacy_trackingprotection_origin_telemetry_enabledE"]
            pub static mut StaticPrefs_sVarCache_privacy_trackingprotection_origin_telemetry_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla11StaticPrefs54sVarCache_telemetry_origin_telemetry_test_mode_enabledE"]
            pub static mut StaticPrefs_sVarCache_telemetry_origin_telemetry_test_mode_enabled:
                root::mozilla::RelaxedAtomicBool;
        }
        #[test]
        fn bindgen_test_layout_StaticPrefs() {
            assert_eq!(
                ::std::mem::size_of::<StaticPrefs>(),
                1usize,
                concat!("Size of: ", stringify!(StaticPrefs))
            );
            assert_eq!(
                ::std::mem::align_of::<StaticPrefs>(),
                1usize,
                concat!("Alignment of ", stringify!(StaticPrefs))
            );
        }
        #[repr(C)]
        #[repr(align(8))]
        #[derive(Debug, Copy, Clone)]
        pub struct SeenPtrs {
            pub _bindgen_opaque_blob: [u64; 4usize],
        }
        #[test]
        fn bindgen_test_layout_SeenPtrs() {
            assert_eq!(
                ::std::mem::size_of::<SeenPtrs>(),
                32usize,
                concat!("Size of: ", stringify!(SeenPtrs))
            );
            assert_eq!(
                ::std::mem::align_of::<SeenPtrs>(),
                8usize,
                concat!("Alignment of ", stringify!(SeenPtrs))
            );
        }
        #[doc = " Right now our identifier map entries contain information for \'name\'"]
        #[doc = " and \'id\' mappings of a given string. This is so that"]
        #[doc = " nsHTMLDocument::ResolveName only has to do one hash lookup instead"]
        #[doc = " of two. It\'s not clear whether this still matters for performance."]
        #[doc = ""]
        #[doc = " We also store the document.all result list here. This is mainly so that"]
        #[doc = " when all elements with the given ID are removed and we remove"]
        #[doc = " the ID\'s IdentifierMapEntry, the document.all result is released too."]
        #[doc = " Perhaps the document.all results should have their own hashtable"]
        #[doc = " in nsHTMLDocument."]
        #[repr(C)]
        pub struct IdentifierMapEntry {
            pub mKey: root::mozilla::IdentifierMapEntry_AtomOrString,
            pub mIdContentList: root::mozilla::dom::TreeOrderedArray,
            pub mNameContentList: root::RefPtr<root::nsBaseContentList>,
            pub mChangeCallbacks: u64,
            pub mImageElement: root::RefPtr<root::mozilla::IdentifierMapEntry_Element>,
        }
        pub type IdentifierMapEntry_Document = root::mozilla::dom::Document;
        pub type IdentifierMapEntry_Element = root::mozilla::dom::Element;
        pub use self::super::super::root::mozilla::net::ReferrerPolicy as IdentifierMapEntry_ReferrerPolicy;
        #[doc = " @see Document::IDTargetObserver, this is just here to avoid include hell."]
        pub type IdentifierMapEntry_IDTargetObserver = ::std::option::Option<
            unsafe extern "C" fn(
                aOldElement: *mut root::mozilla::IdentifierMapEntry_Element,
                aNewelement: *mut root::mozilla::IdentifierMapEntry_Element,
                aData: *mut ::std::os::raw::c_void,
            ) -> bool,
        >;
        #[repr(C)]
        pub struct IdentifierMapEntry_AtomOrString {
            pub mAtom: root::RefPtr<root::nsAtom>,
            pub mString: ::gecko_bindings::structs::nsString,
        }
        #[test]
        fn bindgen_test_layout_IdentifierMapEntry_AtomOrString() {
            assert_eq!(
                ::std::mem::size_of::<IdentifierMapEntry_AtomOrString>(),
                24usize,
                concat!("Size of: ", stringify!(IdentifierMapEntry_AtomOrString))
            );
            assert_eq!(
                ::std::mem::align_of::<IdentifierMapEntry_AtomOrString>(),
                8usize,
                concat!("Alignment of ", stringify!(IdentifierMapEntry_AtomOrString))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<IdentifierMapEntry_AtomOrString>())).mAtom as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(IdentifierMapEntry_AtomOrString),
                    "::",
                    stringify!(mAtom)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<IdentifierMapEntry_AtomOrString>())).mString as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(IdentifierMapEntry_AtomOrString),
                    "::",
                    stringify!(mString)
                )
            );
        }
        pub type IdentifierMapEntry_KeyType = *const root::mozilla::IdentifierMapEntry_AtomOrString;
        pub type IdentifierMapEntry_KeyTypePointer =
            *const root::mozilla::IdentifierMapEntry_AtomOrString;
        pub const IdentifierMapEntry_ALLOW_MEMMOVE:
            root::mozilla::IdentifierMapEntry__bindgen_ty_1 = 0;
        pub type IdentifierMapEntry__bindgen_ty_1 = u32;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct IdentifierMapEntry_ChangeCallback {
            pub mCallback: root::mozilla::IdentifierMapEntry_IDTargetObserver,
            pub mData: *mut ::std::os::raw::c_void,
            pub mForImage: bool,
        }
        #[test]
        fn bindgen_test_layout_IdentifierMapEntry_ChangeCallback() {
            assert_eq!(
                ::std::mem::size_of::<IdentifierMapEntry_ChangeCallback>(),
                24usize,
                concat!("Size of: ", stringify!(IdentifierMapEntry_ChangeCallback))
            );
            assert_eq!(
                ::std::mem::align_of::<IdentifierMapEntry_ChangeCallback>(),
                8usize,
                concat!(
                    "Alignment of ",
                    stringify!(IdentifierMapEntry_ChangeCallback)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<IdentifierMapEntry_ChangeCallback>())).mCallback
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(IdentifierMapEntry_ChangeCallback),
                    "::",
                    stringify!(mCallback)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<IdentifierMapEntry_ChangeCallback>())).mData as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(IdentifierMapEntry_ChangeCallback),
                    "::",
                    stringify!(mData)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<IdentifierMapEntry_ChangeCallback>())).mForImage
                        as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(IdentifierMapEntry_ChangeCallback),
                    "::",
                    stringify!(mForImage)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct IdentifierMapEntry_ChangeCallbackEntry {
            pub mKey: root::mozilla::IdentifierMapEntry_ChangeCallback,
        }
        pub type IdentifierMapEntry_ChangeCallbackEntry_KeyType =
            root::mozilla::IdentifierMapEntry_ChangeCallback;
        pub type IdentifierMapEntry_ChangeCallbackEntry_KeyTypePointer =
            *const root::mozilla::IdentifierMapEntry_ChangeCallback;
        pub const IdentifierMapEntry_ChangeCallbackEntry_ALLOW_MEMMOVE:
            root::mozilla::IdentifierMapEntry_ChangeCallbackEntry__bindgen_ty_1 = 1;
        pub type IdentifierMapEntry_ChangeCallbackEntry__bindgen_ty_1 = u32;
        #[test]
        fn bindgen_test_layout_IdentifierMapEntry_ChangeCallbackEntry() {
            assert_eq!(
                ::std::mem::size_of::<IdentifierMapEntry_ChangeCallbackEntry>(),
                24usize,
                concat!(
                    "Size of: ",
                    stringify!(IdentifierMapEntry_ChangeCallbackEntry)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<IdentifierMapEntry_ChangeCallbackEntry>(),
                8usize,
                concat!(
                    "Alignment of ",
                    stringify!(IdentifierMapEntry_ChangeCallbackEntry)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<IdentifierMapEntry_ChangeCallbackEntry>())).mKey
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(IdentifierMapEntry_ChangeCallbackEntry),
                    "::",
                    stringify!(mKey)
                )
            );
        }
        #[test]
        fn bindgen_test_layout_IdentifierMapEntry() {
            assert_eq!(
                ::std::mem::size_of::<IdentifierMapEntry>(),
                72usize,
                concat!("Size of: ", stringify!(IdentifierMapEntry))
            );
            assert_eq!(
                ::std::mem::align_of::<IdentifierMapEntry>(),
                8usize,
                concat!("Alignment of ", stringify!(IdentifierMapEntry))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<IdentifierMapEntry>())).mKey as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(IdentifierMapEntry),
                    "::",
                    stringify!(mKey)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<IdentifierMapEntry>())).mIdContentList as *const _
                        as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(IdentifierMapEntry),
                    "::",
                    stringify!(mIdContentList)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<IdentifierMapEntry>())).mNameContentList as *const _
                        as usize
                },
                48usize,
                concat!(
                    "Offset of field: ",
                    stringify!(IdentifierMapEntry),
                    "::",
                    stringify!(mNameContentList)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<IdentifierMapEntry>())).mChangeCallbacks as *const _
                        as usize
                },
                56usize,
                concat!(
                    "Offset of field: ",
                    stringify!(IdentifierMapEntry),
                    "::",
                    stringify!(mChangeCallbacks)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<IdentifierMapEntry>())).mImageElement as *const _
                        as usize
                },
                64usize,
                concat!(
                    "Offset of field: ",
                    stringify!(IdentifierMapEntry),
                    "::",
                    stringify!(mImageElement)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct FullscreenExit {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct FullscreenRequest {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct PendingAnimationTracker {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SMILAnimationController {
            _unused: [u8; 0],
        }
        #[doc = " EnumSet<T, U> is a set of values defined by an enumeration. It is implemented"]
        #[doc = " using a bit mask with the size of U for each value. It works both for enum"]
        #[doc = " and enum class types."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct EnumSet<Serialized> {
            pub mBitField: Serialized,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<Serialized>>,
        }
        pub type EnumSet_valueType<T> = T;
        #[repr(C)]
        #[derive(Debug)]
        pub struct EnumSet_ConstIterator<Serialized> {
            pub mSet: *const root::mozilla::EnumSet<Serialized>,
            pub mPos: u32,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<Serialized>>,
        }
        pub mod widget {
            #[allow(unused_imports)]
            use self::super::super::super::root;
            #[doc = " Preference for receiving IME updates"]
            #[doc = ""]
            #[doc = " If mWantUpdates is not NOTIFY_NOTHING, nsTextStateManager will observe text"]
            #[doc = " change and/or selection change and call nsIWidget::NotifyIME() with"]
            #[doc = " NOTIFY_IME_OF_SELECTION_CHANGE and/or NOTIFY_IME_OF_TEXT_CHANGE."]
            #[doc = " Please note that the text change observing cost is very expensive especially"]
            #[doc = " on an HTML editor has focus."]
            #[doc = " If the IME implementation on a particular platform doesn\'t care about"]
            #[doc = " NOTIFY_IME_OF_SELECTION_CHANGE and/or NOTIFY_IME_OF_TEXT_CHANGE,"]
            #[doc = " they should set mWantUpdates to NOTIFY_NOTHING to avoid the cost."]
            #[doc = " If the IME implementation needs notifications even while our process is"]
            #[doc = " deactive, it should also set NOTIFY_DURING_DEACTIVE."]
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct IMENotificationRequests {
                pub mWantUpdates: root::mozilla::widget::IMENotificationRequests_Notifications,
            }
            pub type IMENotificationRequests_Notifications = u8;
            pub const IMENotificationRequests_NOTIFY_NOTHING:
                root::mozilla::widget::IMENotificationRequests__bindgen_ty_1 = 0;
            pub const IMENotificationRequests_NOTIFY_TEXT_CHANGE:
                root::mozilla::widget::IMENotificationRequests__bindgen_ty_1 = 2;
            pub const IMENotificationRequests_NOTIFY_POSITION_CHANGE:
                root::mozilla::widget::IMENotificationRequests__bindgen_ty_1 = 4;
            pub const IMENotificationRequests_NOTIFY_MOUSE_BUTTON_EVENT_ON_CHAR:
                root::mozilla::widget::IMENotificationRequests__bindgen_ty_1 = 8;
            pub const IMENotificationRequests_NOTIFY_DURING_DEACTIVE:
                root::mozilla::widget::IMENotificationRequests__bindgen_ty_1 = 128;
            pub const IMENotificationRequests_NOTIFY_ALL:
                root::mozilla::widget::IMENotificationRequests__bindgen_ty_1 = 14;
            pub type IMENotificationRequests__bindgen_ty_1 = u8;
            #[test]
            fn bindgen_test_layout_IMENotificationRequests() {
                assert_eq!(
                    ::std::mem::size_of::<IMENotificationRequests>(),
                    1usize,
                    concat!("Size of: ", stringify!(IMENotificationRequests))
                );
                assert_eq!(
                    ::std::mem::align_of::<IMENotificationRequests>(),
                    1usize,
                    concat!("Alignment of ", stringify!(IMENotificationRequests))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotificationRequests>())).mWantUpdates as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotificationRequests),
                        "::",
                        stringify!(mWantUpdates)
                    )
                );
            }
            #[doc = " Contains IMEStatus plus information about the current"]
            #[doc = " input context that the IME can use as hints if desired."]
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct IMEState {
                pub mEnabled: root::mozilla::widget::IMEState_Enabled,
                pub mOpen: root::mozilla::widget::IMEState_Open,
            }
            #[doc = " \'Disabled\' means the user cannot use IME. So, the IME open state should"]
            #[doc = " be \'closed\' during \'disabled\'."]
            pub const IMEState_Enabled_DISABLED: root::mozilla::widget::IMEState_Enabled = 0;
            #[doc = " \'Enabled\' means the user can use IME."]
            pub const IMEState_Enabled_ENABLED: root::mozilla::widget::IMEState_Enabled = 1;
            #[doc = " \'Password\' state is a special case for the password editors."]
            #[doc = " E.g., on mac, the password editors should disable the non-Roman"]
            #[doc = " keyboard layouts at getting focus. Thus, the password editor may have"]
            #[doc = " special rules on some platforms."]
            pub const IMEState_Enabled_PASSWORD: root::mozilla::widget::IMEState_Enabled = 2;
            #[doc = " This state is used when a plugin is focused."]
            #[doc = " When a plug-in is focused content, we should send native events"]
            #[doc = " directly. Because we don\'t process some native events, but they may"]
            #[doc = " be needed by the plug-in."]
            pub const IMEState_Enabled_PLUGIN: root::mozilla::widget::IMEState_Enabled = 3;
            #[doc = " \'Unknown\' is useful when you cache this enum.  So, this shouldn\'t be"]
            #[doc = " used with nsIWidget::SetInputContext()."]
            pub const IMEState_Enabled_UNKNOWN: root::mozilla::widget::IMEState_Enabled = 4;
            #[doc = " IME enabled states, the mEnabled value of"]
            #[doc = " SetInputContext()/GetInputContext() should be one value of following"]
            #[doc = " values."]
            #[doc = ""]
            #[doc = " WARNING: If you change these values, you also need to edit:"]
            #[doc = "   nsIDOMWindowUtils.idl"]
            #[doc = "   nsContentUtils::GetWidgetStatusFromIMEStatus"]
            pub type IMEState_Enabled = u32;
            #[doc = " \'Unsupported\' means the platform cannot return actual IME open state."]
            #[doc = " This value is used only by GetInputContext()."]
            pub const IMEState_Open_OPEN_STATE_NOT_SUPPORTED: root::mozilla::widget::IMEState_Open =
                0;
            #[doc = " \'Don\'t change\' means the widget shouldn\'t change IME open state when"]
            #[doc = " SetInputContext() is called."]
            pub const IMEState_Open_DONT_CHANGE_OPEN_STATE: root::mozilla::widget::IMEState_Open =
                0;
            #[doc = " \'Open\' means that IME should compose in its primary language (or latest"]
            #[doc = " input mode except direct ASCII character input mode).  Even if IME is"]
            #[doc = " opened by this value, users should be able to close IME by theirselves."]
            #[doc = " Web contents can specify this value by |ime-mode: active;|."]
            pub const IMEState_Open_OPEN: root::mozilla::widget::IMEState_Open = 1;
            #[doc = " \'Closed\' means that IME shouldn\'t handle key events (or should handle"]
            #[doc = " as ASCII character inputs on mobile device).  Even if IME is closed by"]
            #[doc = " this value, users should be able to open IME by theirselves."]
            #[doc = " Web contents can specify this value by |ime-mode: inactive;|."]
            pub const IMEState_Open_CLOSED: root::mozilla::widget::IMEState_Open = 2;
            #[doc = " IME open states the mOpen value of SetInputContext() should be one value of"]
            #[doc = " OPEN, CLOSE or DONT_CHANGE_OPEN_STATE.  GetInputContext() should return"]
            #[doc = " OPEN, CLOSE or OPEN_STATE_NOT_SUPPORTED."]
            pub type IMEState_Open = u32;
            #[test]
            fn bindgen_test_layout_IMEState() {
                assert_eq!(
                    ::std::mem::size_of::<IMEState>(),
                    8usize,
                    concat!("Size of: ", stringify!(IMEState))
                );
                assert_eq!(
                    ::std::mem::align_of::<IMEState>(),
                    4usize,
                    concat!("Alignment of ", stringify!(IMEState))
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<IMEState>())).mEnabled as *const _ as usize },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMEState),
                        "::",
                        stringify!(mEnabled)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<IMEState>())).mOpen as *const _ as usize },
                    4usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMEState),
                        "::",
                        stringify!(mOpen)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct NativeIMEContext {
                pub mRawNativeIMEContext: usize,
                pub mOriginProcessID: u64,
            }
            #[test]
            fn bindgen_test_layout_NativeIMEContext() {
                assert_eq!(
                    ::std::mem::size_of::<NativeIMEContext>(),
                    16usize,
                    concat!("Size of: ", stringify!(NativeIMEContext))
                );
                assert_eq!(
                    ::std::mem::align_of::<NativeIMEContext>(),
                    8usize,
                    concat!("Alignment of ", stringify!(NativeIMEContext))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<NativeIMEContext>())).mRawNativeIMEContext
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(NativeIMEContext),
                        "::",
                        stringify!(mRawNativeIMEContext)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<NativeIMEContext>())).mOriginProcessID as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(NativeIMEContext),
                        "::",
                        stringify!(mOriginProcessID)
                    )
                );
            }
            #[repr(C)]
            pub struct InputContext {
                pub mIMEState: root::mozilla::widget::IMEState,
                pub mHTMLInputType: ::gecko_bindings::structs::nsString,
                pub mHTMLInputInputmode: ::gecko_bindings::structs::nsString,
                pub mActionHint: ::gecko_bindings::structs::nsString,
                pub mOrigin: root::mozilla::widget::InputContext_Origin,
                pub mMayBeIMEUnaware: bool,
                #[doc = " True if the document has ever received user input"]
                pub mHasHandledUserInput: bool,
                pub mInPrivateBrowsing: bool,
            }
            pub const InputContext_Origin_ORIGIN_MAIN: root::mozilla::widget::InputContext_Origin =
                0;
            pub const InputContext_Origin_ORIGIN_CONTENT:
                root::mozilla::widget::InputContext_Origin = 1;
            #[doc = " mOrigin indicates whether this focus event refers to main or remote"]
            #[doc = " content."]
            pub type InputContext_Origin = u32;
            #[test]
            fn bindgen_test_layout_InputContext() {
                assert_eq!(
                    ::std::mem::size_of::<InputContext>(),
                    64usize,
                    concat!("Size of: ", stringify!(InputContext))
                );
                assert_eq!(
                    ::std::mem::align_of::<InputContext>(),
                    8usize,
                    concat!("Alignment of ", stringify!(InputContext))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<InputContext>())).mIMEState as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(InputContext),
                        "::",
                        stringify!(mIMEState)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<InputContext>())).mHTMLInputType as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(InputContext),
                        "::",
                        stringify!(mHTMLInputType)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<InputContext>())).mHTMLInputInputmode as *const _
                            as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(InputContext),
                        "::",
                        stringify!(mHTMLInputInputmode)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<InputContext>())).mActionHint as *const _ as usize
                    },
                    40usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(InputContext),
                        "::",
                        stringify!(mActionHint)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<InputContext>())).mOrigin as *const _ as usize
                    },
                    56usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(InputContext),
                        "::",
                        stringify!(mOrigin)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<InputContext>())).mMayBeIMEUnaware as *const _
                            as usize
                    },
                    60usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(InputContext),
                        "::",
                        stringify!(mMayBeIMEUnaware)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<InputContext>())).mHasHandledUserInput as *const _
                            as usize
                    },
                    61usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(InputContext),
                        "::",
                        stringify!(mHasHandledUserInput)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<InputContext>())).mInPrivateBrowsing as *const _
                            as usize
                    },
                    62usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(InputContext),
                        "::",
                        stringify!(mInPrivateBrowsing)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct InputContextAction {
                pub mCause: root::mozilla::widget::InputContextAction_Cause,
                pub mFocusChange: root::mozilla::widget::InputContextAction_FocusChange,
            }
            pub const InputContextAction_Cause_CAUSE_UNKNOWN:
                root::mozilla::widget::InputContextAction_Cause = 0;
            pub const InputContextAction_Cause_CAUSE_UNKNOWN_CHROME:
                root::mozilla::widget::InputContextAction_Cause = 1;
            pub const InputContextAction_Cause_CAUSE_KEY:
                root::mozilla::widget::InputContextAction_Cause = 2;
            pub const InputContextAction_Cause_CAUSE_MOUSE:
                root::mozilla::widget::InputContextAction_Cause = 3;
            pub const InputContextAction_Cause_CAUSE_TOUCH:
                root::mozilla::widget::InputContextAction_Cause = 4;
            pub const InputContextAction_Cause_CAUSE_UNKNOWN_DURING_NON_KEYBOARD_INPUT:
                root::mozilla::widget::InputContextAction_Cause = 5;
            pub const InputContextAction_Cause_CAUSE_UNKNOWN_DURING_KEYBOARD_INPUT:
                root::mozilla::widget::InputContextAction_Cause = 6;
            #[doc = " mCause indicates what action causes calling nsIWidget::SetInputContext()."]
            #[doc = " It must be one of following values."]
            pub type InputContextAction_Cause = u32;
            pub const InputContextAction_FocusChange_FOCUS_NOT_CHANGED:
                root::mozilla::widget::InputContextAction_FocusChange = 0;
            pub const InputContextAction_FocusChange_GOT_FOCUS:
                root::mozilla::widget::InputContextAction_FocusChange = 1;
            pub const InputContextAction_FocusChange_LOST_FOCUS:
                root::mozilla::widget::InputContextAction_FocusChange = 2;
            pub const InputContextAction_FocusChange_MENU_GOT_PSEUDO_FOCUS:
                root::mozilla::widget::InputContextAction_FocusChange = 3;
            pub const InputContextAction_FocusChange_MENU_LOST_PSEUDO_FOCUS:
                root::mozilla::widget::InputContextAction_FocusChange = 4;
            pub const InputContextAction_FocusChange_WIDGET_CREATED:
                root::mozilla::widget::InputContextAction_FocusChange = 5;
            #[doc = " mFocusChange indicates what happened for focus."]
            pub type InputContextAction_FocusChange = u32;
            #[test]
            fn bindgen_test_layout_InputContextAction() {
                assert_eq!(
                    ::std::mem::size_of::<InputContextAction>(),
                    8usize,
                    concat!("Size of: ", stringify!(InputContextAction))
                );
                assert_eq!(
                    ::std::mem::align_of::<InputContextAction>(),
                    4usize,
                    concat!("Alignment of ", stringify!(InputContextAction))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<InputContextAction>())).mCause as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(InputContextAction),
                        "::",
                        stringify!(mCause)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<InputContextAction>())).mFocusChange as *const _
                            as usize
                    },
                    4usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(InputContextAction),
                        "::",
                        stringify!(mFocusChange)
                    )
                );
            }
            pub type IMEMessageType = i8;
            pub const IMEMessage_NOTIFY_IME_OF_NOTHING: root::mozilla::widget::IMEMessage = 0;
            pub const IMEMessage_NOTIFY_IME_OF_FOCUS: root::mozilla::widget::IMEMessage = 1;
            pub const IMEMessage_NOTIFY_IME_OF_BLUR: root::mozilla::widget::IMEMessage = 2;
            pub const IMEMessage_NOTIFY_IME_OF_SELECTION_CHANGE: root::mozilla::widget::IMEMessage =
                3;
            pub const IMEMessage_NOTIFY_IME_OF_TEXT_CHANGE: root::mozilla::widget::IMEMessage = 4;
            pub const IMEMessage_NOTIFY_IME_OF_COMPOSITION_EVENT_HANDLED:
                root::mozilla::widget::IMEMessage = 5;
            pub const IMEMessage_NOTIFY_IME_OF_POSITION_CHANGE: root::mozilla::widget::IMEMessage =
                6;
            pub const IMEMessage_NOTIFY_IME_OF_MOUSE_BUTTON_EVENT:
                root::mozilla::widget::IMEMessage = 7;
            pub const IMEMessage_REQUEST_TO_COMMIT_COMPOSITION: root::mozilla::widget::IMEMessage =
                8;
            pub const IMEMessage_REQUEST_TO_CANCEL_COMPOSITION: root::mozilla::widget::IMEMessage =
                9;
            pub type IMEMessage = i8;
            #[repr(C)]
            #[derive(Debug)]
            pub struct IMENotification {
                pub mMessage: root::mozilla::widget::IMEMessage,
                pub __bindgen_anon_1: root::mozilla::widget::IMENotification__bindgen_ty_1,
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct IMENotification_Point {
                pub mX: i32,
                pub mY: i32,
            }
            #[test]
            fn bindgen_test_layout_IMENotification_Point() {
                assert_eq!(
                    ::std::mem::size_of::<IMENotification_Point>(),
                    8usize,
                    concat!("Size of: ", stringify!(IMENotification_Point))
                );
                assert_eq!(
                    ::std::mem::align_of::<IMENotification_Point>(),
                    4usize,
                    concat!("Alignment of ", stringify!(IMENotification_Point))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_Point>())).mX as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_Point),
                        "::",
                        stringify!(mX)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_Point>())).mY as *const _ as usize
                    },
                    4usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_Point),
                        "::",
                        stringify!(mY)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct IMENotification_Rect {
                pub mX: i32,
                pub mY: i32,
                pub mWidth: i32,
                pub mHeight: i32,
            }
            #[test]
            fn bindgen_test_layout_IMENotification_Rect() {
                assert_eq!(
                    ::std::mem::size_of::<IMENotification_Rect>(),
                    16usize,
                    concat!("Size of: ", stringify!(IMENotification_Rect))
                );
                assert_eq!(
                    ::std::mem::align_of::<IMENotification_Rect>(),
                    4usize,
                    concat!("Alignment of ", stringify!(IMENotification_Rect))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_Rect>())).mX as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_Rect),
                        "::",
                        stringify!(mX)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_Rect>())).mY as *const _ as usize
                    },
                    4usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_Rect),
                        "::",
                        stringify!(mY)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_Rect>())).mWidth as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_Rect),
                        "::",
                        stringify!(mWidth)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_Rect>())).mHeight as *const _
                            as usize
                    },
                    12usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_Rect),
                        "::",
                        stringify!(mHeight)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct IMENotification_SelectionChangeDataBase {
                pub mOffset: u32,
                pub mString: *mut ::gecko_bindings::structs::nsString,
                pub mWritingMode: u8,
                pub mReversed: bool,
                pub mCausedByComposition: bool,
                pub mCausedBySelectionEvent: bool,
                pub mOccurredDuringComposition: bool,
            }
            #[test]
            fn bindgen_test_layout_IMENotification_SelectionChangeDataBase() {
                assert_eq!(
                    ::std::mem::size_of::<IMENotification_SelectionChangeDataBase>(),
                    24usize,
                    concat!(
                        "Size of: ",
                        stringify!(IMENotification_SelectionChangeDataBase)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<IMENotification_SelectionChangeDataBase>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(IMENotification_SelectionChangeDataBase)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_SelectionChangeDataBase>())).mOffset
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_SelectionChangeDataBase),
                        "::",
                        stringify!(mOffset)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_SelectionChangeDataBase>())).mString
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_SelectionChangeDataBase),
                        "::",
                        stringify!(mString)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_SelectionChangeDataBase>()))
                            .mWritingMode as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_SelectionChangeDataBase),
                        "::",
                        stringify!(mWritingMode)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_SelectionChangeDataBase>()))
                            .mReversed as *const _ as usize
                    },
                    17usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_SelectionChangeDataBase),
                        "::",
                        stringify!(mReversed)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_SelectionChangeDataBase>()))
                            .mCausedByComposition as *const _ as usize
                    },
                    18usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_SelectionChangeDataBase),
                        "::",
                        stringify!(mCausedByComposition)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_SelectionChangeDataBase>()))
                            .mCausedBySelectionEvent as *const _ as usize
                    },
                    19usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_SelectionChangeDataBase),
                        "::",
                        stringify!(mCausedBySelectionEvent)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_SelectionChangeDataBase>()))
                            .mOccurredDuringComposition as *const _ as usize
                    },
                    20usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_SelectionChangeDataBase),
                        "::",
                        stringify!(mOccurredDuringComposition)
                    )
                );
            }
            #[repr(C)]
            pub struct IMENotification_SelectionChangeData {
                pub _base: root::mozilla::widget::IMENotification_SelectionChangeDataBase,
                pub mStringInstance: ::gecko_bindings::structs::nsString,
            }
            #[test]
            fn bindgen_test_layout_IMENotification_SelectionChangeData() {
                assert_eq!(
                    ::std::mem::size_of::<IMENotification_SelectionChangeData>(),
                    40usize,
                    concat!("Size of: ", stringify!(IMENotification_SelectionChangeData))
                );
                assert_eq!(
                    ::std::mem::align_of::<IMENotification_SelectionChangeData>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(IMENotification_SelectionChangeData)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_SelectionChangeData>()))
                            .mStringInstance as *const _ as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_SelectionChangeData),
                        "::",
                        stringify!(mStringInstance)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct IMENotification_TextChangeDataBase {
                pub mStartOffset: u32,
                pub mRemovedEndOffset: u32,
                pub mAddedEndOffset: u32,
                pub mCausedOnlyByComposition: bool,
                pub mIncludingChangesDuringComposition: bool,
                pub mIncludingChangesWithoutComposition: bool,
            }
            #[test]
            fn bindgen_test_layout_IMENotification_TextChangeDataBase() {
                assert_eq!(
                    ::std::mem::size_of::<IMENotification_TextChangeDataBase>(),
                    16usize,
                    concat!("Size of: ", stringify!(IMENotification_TextChangeDataBase))
                );
                assert_eq!(
                    ::std::mem::align_of::<IMENotification_TextChangeDataBase>(),
                    4usize,
                    concat!(
                        "Alignment of ",
                        stringify!(IMENotification_TextChangeDataBase)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_TextChangeDataBase>())).mStartOffset
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_TextChangeDataBase),
                        "::",
                        stringify!(mStartOffset)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_TextChangeDataBase>()))
                            .mRemovedEndOffset as *const _ as usize
                    },
                    4usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_TextChangeDataBase),
                        "::",
                        stringify!(mRemovedEndOffset)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_TextChangeDataBase>()))
                            .mAddedEndOffset as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_TextChangeDataBase),
                        "::",
                        stringify!(mAddedEndOffset)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_TextChangeDataBase>()))
                            .mCausedOnlyByComposition as *const _ as usize
                    },
                    12usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_TextChangeDataBase),
                        "::",
                        stringify!(mCausedOnlyByComposition)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_TextChangeDataBase>()))
                            .mIncludingChangesDuringComposition as *const _
                            as usize
                    },
                    13usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_TextChangeDataBase),
                        "::",
                        stringify!(mIncludingChangesDuringComposition)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_TextChangeDataBase>()))
                            .mIncludingChangesWithoutComposition as *const _
                            as usize
                    },
                    14usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_TextChangeDataBase),
                        "::",
                        stringify!(mIncludingChangesWithoutComposition)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct IMENotification_TextChangeData {
                pub _base: root::mozilla::widget::IMENotification_TextChangeDataBase,
            }
            #[test]
            fn bindgen_test_layout_IMENotification_TextChangeData() {
                assert_eq!(
                    ::std::mem::size_of::<IMENotification_TextChangeData>(),
                    16usize,
                    concat!("Size of: ", stringify!(IMENotification_TextChangeData))
                );
                assert_eq!(
                    ::std::mem::align_of::<IMENotification_TextChangeData>(),
                    4usize,
                    concat!("Alignment of ", stringify!(IMENotification_TextChangeData))
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct IMENotification_MouseButtonEventData {
                pub mEventMessage: root::mozilla::EventMessage,
                pub mOffset: u32,
                pub mCursorPos: root::mozilla::widget::IMENotification_Point,
                pub mCharRect: root::mozilla::widget::IMENotification_Rect,
                pub mButton: i16,
                pub mButtons: i16,
                pub mModifiers: root::mozilla::Modifiers,
            }
            #[test]
            fn bindgen_test_layout_IMENotification_MouseButtonEventData() {
                assert_eq!(
                    ::std::mem::size_of::<IMENotification_MouseButtonEventData>(),
                    40usize,
                    concat!(
                        "Size of: ",
                        stringify!(IMENotification_MouseButtonEventData)
                    )
                );
                assert_eq!(
                    ::std::mem::align_of::<IMENotification_MouseButtonEventData>(),
                    4usize,
                    concat!(
                        "Alignment of ",
                        stringify!(IMENotification_MouseButtonEventData)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_MouseButtonEventData>()))
                            .mEventMessage as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_MouseButtonEventData),
                        "::",
                        stringify!(mEventMessage)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_MouseButtonEventData>())).mOffset
                            as *const _ as usize
                    },
                    4usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_MouseButtonEventData),
                        "::",
                        stringify!(mOffset)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_MouseButtonEventData>())).mCursorPos
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_MouseButtonEventData),
                        "::",
                        stringify!(mCursorPos)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_MouseButtonEventData>())).mCharRect
                            as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_MouseButtonEventData),
                        "::",
                        stringify!(mCharRect)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_MouseButtonEventData>())).mButton
                            as *const _ as usize
                    },
                    32usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_MouseButtonEventData),
                        "::",
                        stringify!(mButton)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_MouseButtonEventData>())).mButtons
                            as *const _ as usize
                    },
                    34usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_MouseButtonEventData),
                        "::",
                        stringify!(mButtons)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification_MouseButtonEventData>())).mModifiers
                            as *const _ as usize
                    },
                    36usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification_MouseButtonEventData),
                        "::",
                        stringify!(mModifiers)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct IMENotification__bindgen_ty_1 {
                pub mSelectionChangeData: root::__BindgenUnionField<
                    root::mozilla::widget::IMENotification_SelectionChangeDataBase,
                >,
                pub mTextChangeData: root::__BindgenUnionField<
                    root::mozilla::widget::IMENotification_TextChangeDataBase,
                >,
                pub mMouseButtonEventData: root::__BindgenUnionField<
                    root::mozilla::widget::IMENotification_MouseButtonEventData,
                >,
                pub bindgen_union_field: [u64; 5usize],
            }
            #[test]
            fn bindgen_test_layout_IMENotification__bindgen_ty_1() {
                assert_eq!(
                    ::std::mem::size_of::<IMENotification__bindgen_ty_1>(),
                    40usize,
                    concat!("Size of: ", stringify!(IMENotification__bindgen_ty_1))
                );
                assert_eq!(
                    ::std::mem::align_of::<IMENotification__bindgen_ty_1>(),
                    8usize,
                    concat!("Alignment of ", stringify!(IMENotification__bindgen_ty_1))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification__bindgen_ty_1>()))
                            .mSelectionChangeData as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification__bindgen_ty_1),
                        "::",
                        stringify!(mSelectionChangeData)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification__bindgen_ty_1>())).mTextChangeData
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification__bindgen_ty_1),
                        "::",
                        stringify!(mTextChangeData)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification__bindgen_ty_1>()))
                            .mMouseButtonEventData as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification__bindgen_ty_1),
                        "::",
                        stringify!(mMouseButtonEventData)
                    )
                );
            }
            #[test]
            fn bindgen_test_layout_IMENotification() {
                assert_eq!(
                    ::std::mem::size_of::<IMENotification>(),
                    48usize,
                    concat!("Size of: ", stringify!(IMENotification))
                );
                assert_eq!(
                    ::std::mem::align_of::<IMENotification>(),
                    8usize,
                    concat!("Alignment of ", stringify!(IMENotification))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<IMENotification>())).mMessage as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(IMENotification),
                        "::",
                        stringify!(mMessage)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct TextEventDispatcher {
                _unused: [u8; 0],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct TextEventDispatcherListener {
                _unused: [u8; 0],
            }
            #[doc = " Size constraints for setting the minimum and maximum size of a widget."]
            #[doc = " Values are in device pixels."]
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct SizeConstraints {
                pub mMinSize: root::mozilla::LayoutDeviceIntSize,
                pub mMaxSize: root::mozilla::LayoutDeviceIntSize,
            }
            #[test]
            fn bindgen_test_layout_SizeConstraints() {
                assert_eq!(
                    ::std::mem::size_of::<SizeConstraints>(),
                    16usize,
                    concat!("Size of: ", stringify!(SizeConstraints))
                );
                assert_eq!(
                    ::std::mem::align_of::<SizeConstraints>(),
                    4usize,
                    concat!("Alignment of ", stringify!(SizeConstraints))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SizeConstraints>())).mMinSize as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SizeConstraints),
                        "::",
                        stringify!(mMinSize)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<SizeConstraints>())).mMaxSize as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(SizeConstraints),
                        "::",
                        stringify!(mMaxSize)
                    )
                );
            }
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct EventTargetChainItem {
            _unused: [u8; 0],
        }
        #[doc = " mozilla::BaseEventFlags"]
        #[doc = ""]
        #[doc = " BaseEventFlags must be a POD struct for safe to use memcpy (including"]
        #[doc = " in ParamTraits<BaseEventFlags>).  So don\'t make virtual methods, constructor,"]
        #[doc = " destructor and operators."]
        #[doc = " This is necessary for VC which is NOT C++0x compiler."]
        #[repr(C, packed)]
        #[derive(Debug, Copy, Clone)]
        pub struct BaseEventFlags {
            pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 4usize], u8>,
        }
        pub type BaseEventFlags_RawFlags = u32;
        #[test]
        fn bindgen_test_layout_BaseEventFlags() {
            assert_eq!(
                ::std::mem::size_of::<BaseEventFlags>(),
                4usize,
                concat!("Size of: ", stringify!(BaseEventFlags))
            );
            assert_eq!(
                ::std::mem::align_of::<BaseEventFlags>(),
                1usize,
                concat!("Alignment of ", stringify!(BaseEventFlags))
            );
        }
        impl BaseEventFlags {
            #[inline]
            pub fn mIsTrusted(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsTrusted(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(0usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mInBubblingPhase(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mInBubblingPhase(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(1usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mInCapturePhase(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mInCapturePhase(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(2usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mInSystemGroup(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mInSystemGroup(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(3usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mCancelable(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mCancelable(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(4usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mBubbles(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mBubbles(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(5usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mPropagationStopped(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mPropagationStopped(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(6usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mImmediatePropagationStopped(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mImmediatePropagationStopped(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(7usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mDefaultPrevented(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mDefaultPrevented(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(8usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mDefaultPreventedByContent(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(9usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mDefaultPreventedByContent(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(9usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mDefaultPreventedByChrome(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(10usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mDefaultPreventedByChrome(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(10usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mMultipleActionsPrevented(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(11usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mMultipleActionsPrevented(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(11usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mMultiplePreActionsPrevented(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(12usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mMultiplePreActionsPrevented(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(12usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsBeingDispatched(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(13usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsBeingDispatched(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(13usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mDispatchedAtLeastOnce(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(14usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mDispatchedAtLeastOnce(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(14usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsSynthesizedForTests(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(15usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsSynthesizedForTests(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(15usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mExceptionWasRaised(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(16usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mExceptionWasRaised(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(16usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mRetargetToNonNativeAnonymous(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(17usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mRetargetToNonNativeAnonymous(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(17usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mNoContentDispatch(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(18usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mNoContentDispatch(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(18usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mOnlyChromeDispatch(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(19usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mOnlyChromeDispatch(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(19usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsReservedByChrome(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(20usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsReservedByChrome(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(20usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mOnlySystemGroupDispatchInContent(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(21usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mOnlySystemGroupDispatchInContent(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(21usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mOnlySystemGroupDispatch(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(22usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mOnlySystemGroupDispatch(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(22usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mHandledByAPZ(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(23usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mHandledByAPZ(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(23usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mInPassiveListener(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(24usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mInPassiveListener(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(24usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mComposed(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(25usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mComposed(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(25usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mComposedInNativeAnonymousContent(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(26usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mComposedInNativeAnonymousContent(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(26usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsSuppressedOrDelayed(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(27usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsSuppressedOrDelayed(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(27usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsPositionless(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(28usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsPositionless(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(28usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mNoRemoteProcessDispatch(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(29usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mNoRemoteProcessDispatch(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(29usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mWantReplyFromContentProcess(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(30usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mWantReplyFromContentProcess(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(30usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mPostedToRemoteProcess(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(31usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mPostedToRemoteProcess(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(31usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn new_bitfield_1(
                mIsTrusted: bool,
                mInBubblingPhase: bool,
                mInCapturePhase: bool,
                mInSystemGroup: bool,
                mCancelable: bool,
                mBubbles: bool,
                mPropagationStopped: bool,
                mImmediatePropagationStopped: bool,
                mDefaultPrevented: bool,
                mDefaultPreventedByContent: bool,
                mDefaultPreventedByChrome: bool,
                mMultipleActionsPrevented: bool,
                mMultiplePreActionsPrevented: bool,
                mIsBeingDispatched: bool,
                mDispatchedAtLeastOnce: bool,
                mIsSynthesizedForTests: bool,
                mExceptionWasRaised: bool,
                mRetargetToNonNativeAnonymous: bool,
                mNoContentDispatch: bool,
                mOnlyChromeDispatch: bool,
                mIsReservedByChrome: bool,
                mOnlySystemGroupDispatchInContent: bool,
                mOnlySystemGroupDispatch: bool,
                mHandledByAPZ: bool,
                mInPassiveListener: bool,
                mComposed: bool,
                mComposedInNativeAnonymousContent: bool,
                mIsSuppressedOrDelayed: bool,
                mIsPositionless: bool,
                mNoRemoteProcessDispatch: bool,
                mWantReplyFromContentProcess: bool,
                mPostedToRemoteProcess: bool,
            ) -> root::__BindgenBitfieldUnit<[u8; 4usize], u8> {
                let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 4usize], u8> =
                    Default::default();
                __bindgen_bitfield_unit.set(0usize, 1u8, {
                    let mIsTrusted: u8 = unsafe { ::std::mem::transmute(mIsTrusted) };
                    mIsTrusted as u64
                });
                __bindgen_bitfield_unit.set(1usize, 1u8, {
                    let mInBubblingPhase: u8 = unsafe { ::std::mem::transmute(mInBubblingPhase) };
                    mInBubblingPhase as u64
                });
                __bindgen_bitfield_unit.set(2usize, 1u8, {
                    let mInCapturePhase: u8 = unsafe { ::std::mem::transmute(mInCapturePhase) };
                    mInCapturePhase as u64
                });
                __bindgen_bitfield_unit.set(3usize, 1u8, {
                    let mInSystemGroup: u8 = unsafe { ::std::mem::transmute(mInSystemGroup) };
                    mInSystemGroup as u64
                });
                __bindgen_bitfield_unit.set(4usize, 1u8, {
                    let mCancelable: u8 = unsafe { ::std::mem::transmute(mCancelable) };
                    mCancelable as u64
                });
                __bindgen_bitfield_unit.set(5usize, 1u8, {
                    let mBubbles: u8 = unsafe { ::std::mem::transmute(mBubbles) };
                    mBubbles as u64
                });
                __bindgen_bitfield_unit.set(6usize, 1u8, {
                    let mPropagationStopped: u8 =
                        unsafe { ::std::mem::transmute(mPropagationStopped) };
                    mPropagationStopped as u64
                });
                __bindgen_bitfield_unit.set(7usize, 1u8, {
                    let mImmediatePropagationStopped: u8 =
                        unsafe { ::std::mem::transmute(mImmediatePropagationStopped) };
                    mImmediatePropagationStopped as u64
                });
                __bindgen_bitfield_unit.set(8usize, 1u8, {
                    let mDefaultPrevented: u8 = unsafe { ::std::mem::transmute(mDefaultPrevented) };
                    mDefaultPrevented as u64
                });
                __bindgen_bitfield_unit.set(9usize, 1u8, {
                    let mDefaultPreventedByContent: u8 =
                        unsafe { ::std::mem::transmute(mDefaultPreventedByContent) };
                    mDefaultPreventedByContent as u64
                });
                __bindgen_bitfield_unit.set(10usize, 1u8, {
                    let mDefaultPreventedByChrome: u8 =
                        unsafe { ::std::mem::transmute(mDefaultPreventedByChrome) };
                    mDefaultPreventedByChrome as u64
                });
                __bindgen_bitfield_unit.set(11usize, 1u8, {
                    let mMultipleActionsPrevented: u8 =
                        unsafe { ::std::mem::transmute(mMultipleActionsPrevented) };
                    mMultipleActionsPrevented as u64
                });
                __bindgen_bitfield_unit.set(12usize, 1u8, {
                    let mMultiplePreActionsPrevented: u8 =
                        unsafe { ::std::mem::transmute(mMultiplePreActionsPrevented) };
                    mMultiplePreActionsPrevented as u64
                });
                __bindgen_bitfield_unit.set(13usize, 1u8, {
                    let mIsBeingDispatched: u8 =
                        unsafe { ::std::mem::transmute(mIsBeingDispatched) };
                    mIsBeingDispatched as u64
                });
                __bindgen_bitfield_unit.set(14usize, 1u8, {
                    let mDispatchedAtLeastOnce: u8 =
                        unsafe { ::std::mem::transmute(mDispatchedAtLeastOnce) };
                    mDispatchedAtLeastOnce as u64
                });
                __bindgen_bitfield_unit.set(15usize, 1u8, {
                    let mIsSynthesizedForTests: u8 =
                        unsafe { ::std::mem::transmute(mIsSynthesizedForTests) };
                    mIsSynthesizedForTests as u64
                });
                __bindgen_bitfield_unit.set(16usize, 1u8, {
                    let mExceptionWasRaised: u8 =
                        unsafe { ::std::mem::transmute(mExceptionWasRaised) };
                    mExceptionWasRaised as u64
                });
                __bindgen_bitfield_unit.set(17usize, 1u8, {
                    let mRetargetToNonNativeAnonymous: u8 =
                        unsafe { ::std::mem::transmute(mRetargetToNonNativeAnonymous) };
                    mRetargetToNonNativeAnonymous as u64
                });
                __bindgen_bitfield_unit.set(18usize, 1u8, {
                    let mNoContentDispatch: u8 =
                        unsafe { ::std::mem::transmute(mNoContentDispatch) };
                    mNoContentDispatch as u64
                });
                __bindgen_bitfield_unit.set(19usize, 1u8, {
                    let mOnlyChromeDispatch: u8 =
                        unsafe { ::std::mem::transmute(mOnlyChromeDispatch) };
                    mOnlyChromeDispatch as u64
                });
                __bindgen_bitfield_unit.set(20usize, 1u8, {
                    let mIsReservedByChrome: u8 =
                        unsafe { ::std::mem::transmute(mIsReservedByChrome) };
                    mIsReservedByChrome as u64
                });
                __bindgen_bitfield_unit.set(21usize, 1u8, {
                    let mOnlySystemGroupDispatchInContent: u8 =
                        unsafe { ::std::mem::transmute(mOnlySystemGroupDispatchInContent) };
                    mOnlySystemGroupDispatchInContent as u64
                });
                __bindgen_bitfield_unit.set(22usize, 1u8, {
                    let mOnlySystemGroupDispatch: u8 =
                        unsafe { ::std::mem::transmute(mOnlySystemGroupDispatch) };
                    mOnlySystemGroupDispatch as u64
                });
                __bindgen_bitfield_unit.set(23usize, 1u8, {
                    let mHandledByAPZ: u8 = unsafe { ::std::mem::transmute(mHandledByAPZ) };
                    mHandledByAPZ as u64
                });
                __bindgen_bitfield_unit.set(24usize, 1u8, {
                    let mInPassiveListener: u8 =
                        unsafe { ::std::mem::transmute(mInPassiveListener) };
                    mInPassiveListener as u64
                });
                __bindgen_bitfield_unit.set(25usize, 1u8, {
                    let mComposed: u8 = unsafe { ::std::mem::transmute(mComposed) };
                    mComposed as u64
                });
                __bindgen_bitfield_unit.set(26usize, 1u8, {
                    let mComposedInNativeAnonymousContent: u8 =
                        unsafe { ::std::mem::transmute(mComposedInNativeAnonymousContent) };
                    mComposedInNativeAnonymousContent as u64
                });
                __bindgen_bitfield_unit.set(27usize, 1u8, {
                    let mIsSuppressedOrDelayed: u8 =
                        unsafe { ::std::mem::transmute(mIsSuppressedOrDelayed) };
                    mIsSuppressedOrDelayed as u64
                });
                __bindgen_bitfield_unit.set(28usize, 1u8, {
                    let mIsPositionless: u8 = unsafe { ::std::mem::transmute(mIsPositionless) };
                    mIsPositionless as u64
                });
                __bindgen_bitfield_unit.set(29usize, 1u8, {
                    let mNoRemoteProcessDispatch: u8 =
                        unsafe { ::std::mem::transmute(mNoRemoteProcessDispatch) };
                    mNoRemoteProcessDispatch as u64
                });
                __bindgen_bitfield_unit.set(30usize, 1u8, {
                    let mWantReplyFromContentProcess: u8 =
                        unsafe { ::std::mem::transmute(mWantReplyFromContentProcess) };
                    mWantReplyFromContentProcess as u64
                });
                __bindgen_bitfield_unit.set(31usize, 1u8, {
                    let mPostedToRemoteProcess: u8 =
                        unsafe { ::std::mem::transmute(mPostedToRemoteProcess) };
                    mPostedToRemoteProcess as u64
                });
                __bindgen_bitfield_unit
            }
        }
        #[doc = " mozilla::WidgetEventTime"]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct WidgetEventTime {
            pub mTime: u64,
            pub mTimeStamp: root::mozilla::TimeStamp,
        }
        #[test]
        fn bindgen_test_layout_WidgetEventTime() {
            assert_eq!(
                ::std::mem::size_of::<WidgetEventTime>(),
                16usize,
                concat!("Size of: ", stringify!(WidgetEventTime))
            );
            assert_eq!(
                ::std::mem::align_of::<WidgetEventTime>(),
                8usize,
                concat!("Alignment of ", stringify!(WidgetEventTime))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<WidgetEventTime>())).mTime as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetEventTime),
                    "::",
                    stringify!(mTime)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetEventTime>())).mTimeStamp as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetEventTime),
                    "::",
                    stringify!(mTimeStamp)
                )
            );
        }
        #[repr(C)]
        pub struct WidgetEvent__bindgen_vtable(::std::os::raw::c_void);
        #[doc = " mozilla::WidgetEvent"]
        #[repr(C)]
        pub struct WidgetEvent {
            pub vtable_: *const WidgetEvent__bindgen_vtable,
            pub _base: root::mozilla::WidgetEventTime,
            pub mClass: root::mozilla::EventClassID,
            pub mMessage: root::mozilla::EventMessage,
            pub mRefPoint: root::mozilla::LayoutDeviceIntPoint,
            pub mLastRefPoint: root::mozilla::LayoutDeviceIntPoint,
            pub mFocusSequenceNumber: u64,
            pub mFlags: root::mozilla::BaseEventFlags,
            pub mSpecifiedEventType: root::RefPtr<root::nsAtom>,
            pub mSpecifiedEventTypeString: ::gecko_bindings::structs::nsString,
            pub mTarget: root::nsCOMPtr,
            pub mCurrentTarget: root::nsCOMPtr,
            pub mOriginalTarget: root::nsCOMPtr,
            #[doc = " The possible related target"]
            pub mRelatedTarget: root::nsCOMPtr,
            pub mOriginalRelatedTarget: root::nsCOMPtr,
            pub mPath: *mut root::nsTArray<root::mozilla::EventTargetChainItem>,
            pub mLayersId: root::mozilla::layers::LayersId,
        }
        #[test]
        fn bindgen_test_layout_WidgetEvent() {
            assert_eq!(
                ::std::mem::size_of::<WidgetEvent>(),
                144usize,
                concat!("Size of: ", stringify!(WidgetEvent))
            );
            assert_eq!(
                ::std::mem::align_of::<WidgetEvent>(),
                8usize,
                concat!("Alignment of ", stringify!(WidgetEvent))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<WidgetEvent>())).mClass as *const _ as usize },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetEvent),
                    "::",
                    stringify!(mClass)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<WidgetEvent>())).mMessage as *const _ as usize },
                26usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetEvent),
                    "::",
                    stringify!(mMessage)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<WidgetEvent>())).mRefPoint as *const _ as usize },
                28usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetEvent),
                    "::",
                    stringify!(mRefPoint)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetEvent>())).mLastRefPoint as *const _ as usize
                },
                36usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetEvent),
                    "::",
                    stringify!(mLastRefPoint)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetEvent>())).mFocusSequenceNumber as *const _
                        as usize
                },
                48usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetEvent),
                    "::",
                    stringify!(mFocusSequenceNumber)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<WidgetEvent>())).mFlags as *const _ as usize },
                56usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetEvent),
                    "::",
                    stringify!(mFlags)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetEvent>())).mSpecifiedEventType as *const _ as usize
                },
                64usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetEvent),
                    "::",
                    stringify!(mSpecifiedEventType)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetEvent>())).mSpecifiedEventTypeString as *const _
                        as usize
                },
                72usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetEvent),
                    "::",
                    stringify!(mSpecifiedEventTypeString)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<WidgetEvent>())).mTarget as *const _ as usize },
                88usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetEvent),
                    "::",
                    stringify!(mTarget)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetEvent>())).mCurrentTarget as *const _ as usize
                },
                96usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetEvent),
                    "::",
                    stringify!(mCurrentTarget)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetEvent>())).mOriginalTarget as *const _ as usize
                },
                104usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetEvent),
                    "::",
                    stringify!(mOriginalTarget)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetEvent>())).mRelatedTarget as *const _ as usize
                },
                112usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetEvent),
                    "::",
                    stringify!(mRelatedTarget)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetEvent>())).mOriginalRelatedTarget as *const _
                        as usize
                },
                120usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetEvent),
                    "::",
                    stringify!(mOriginalRelatedTarget)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<WidgetEvent>())).mPath as *const _ as usize },
                128usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetEvent),
                    "::",
                    stringify!(mPath)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<WidgetEvent>())).mLayersId as *const _ as usize },
                136usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetEvent),
                    "::",
                    stringify!(mLayersId)
                )
            );
        }
        #[doc = " mozilla::NativeEventData"]
        #[doc = ""]
        #[doc = " WidgetGUIEvent\'s mPluginEvent member used to be a void* pointer,"]
        #[doc = " used to reference external, OS-specific data structures."]
        #[doc = ""]
        #[doc = " That void* pointer wasn\'t serializable by itself, causing"]
        #[doc = " certain plugin events not to function in e10s. See bug 586656."]
        #[doc = ""]
        #[doc = " To make this serializable, we changed this void* pointer into"]
        #[doc = " a proper buffer, and copy these external data structures into this"]
        #[doc = " buffer."]
        #[doc = ""]
        #[doc = " That buffer is NativeEventData::mBuffer below."]
        #[doc = ""]
        #[doc = " We wrap this in that NativeEventData class providing operators to"]
        #[doc = " be compatible with existing code that was written around"]
        #[doc = " the old void* field."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct NativeEventData {
            pub mBuffer: root::nsTArray<u8>,
        }
        #[test]
        fn bindgen_test_layout_NativeEventData() {
            assert_eq!(
                ::std::mem::size_of::<NativeEventData>(),
                8usize,
                concat!("Size of: ", stringify!(NativeEventData))
            );
            assert_eq!(
                ::std::mem::align_of::<NativeEventData>(),
                8usize,
                concat!("Alignment of ", stringify!(NativeEventData))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<NativeEventData>())).mBuffer as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(NativeEventData),
                    "::",
                    stringify!(mBuffer)
                )
            );
        }
        #[doc = " mozilla::WidgetGUIEvent"]
        #[repr(C)]
        pub struct WidgetGUIEvent {
            pub _base: root::mozilla::WidgetEvent,
            pub mWidget: root::nsCOMPtr,
            pub mPluginEvent: root::mozilla::WidgetGUIEvent_PluginEvent,
        }
        pub type WidgetGUIEvent_PluginEvent = root::mozilla::NativeEventData;
        #[test]
        fn bindgen_test_layout_WidgetGUIEvent() {
            assert_eq!(
                ::std::mem::size_of::<WidgetGUIEvent>(),
                160usize,
                concat!("Size of: ", stringify!(WidgetGUIEvent))
            );
            assert_eq!(
                ::std::mem::align_of::<WidgetGUIEvent>(),
                8usize,
                concat!("Alignment of ", stringify!(WidgetGUIEvent))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<WidgetGUIEvent>())).mWidget as *const _ as usize },
                144usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetGUIEvent),
                    "::",
                    stringify!(mWidget)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetGUIEvent>())).mPluginEvent as *const _ as usize
                },
                152usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetGUIEvent),
                    "::",
                    stringify!(mPluginEvent)
                )
            );
        }
        #[doc = " mozilla::WidgetInputEvent"]
        #[repr(C)]
        pub struct WidgetInputEvent {
            pub _base: root::mozilla::WidgetGUIEvent,
            pub mModifiers: root::mozilla::Modifiers,
        }
        #[test]
        fn bindgen_test_layout_WidgetInputEvent() {
            assert_eq!(
                ::std::mem::size_of::<WidgetInputEvent>(),
                168usize,
                concat!("Size of: ", stringify!(WidgetInputEvent))
            );
            assert_eq!(
                ::std::mem::align_of::<WidgetInputEvent>(),
                8usize,
                concat!("Alignment of ", stringify!(WidgetInputEvent))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetInputEvent>())).mModifiers as *const _ as usize
                },
                160usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetInputEvent),
                    "::",
                    stringify!(mModifiers)
                )
            );
        }
        pub mod intl {
            #[allow(unused_imports)]
            use self::super::super::super::root;
            #[repr(C)]
            #[derive(Debug)]
            pub struct LineBreaker {
                pub mRefCnt: root::nsAutoRefCnt,
            }
            pub type LineBreaker_HasThreadSafeRefCnt = root::mozilla::FalseType;
            pub const LineBreaker_kWordBreak_Normal:
                root::mozilla::intl::LineBreaker__bindgen_ty_1 = 0;
            pub const LineBreaker_kWordBreak_BreakAll:
                root::mozilla::intl::LineBreaker__bindgen_ty_1 = 1;
            pub const LineBreaker_kWordBreak_KeepAll:
                root::mozilla::intl::LineBreaker__bindgen_ty_1 = 2;
            pub type LineBreaker__bindgen_ty_1 = u32;
            #[test]
            fn bindgen_test_layout_LineBreaker() {
                assert_eq!(
                    ::std::mem::size_of::<LineBreaker>(),
                    8usize,
                    concat!("Size of: ", stringify!(LineBreaker))
                );
                assert_eq!(
                    ::std::mem::align_of::<LineBreaker>(),
                    8usize,
                    concat!("Alignment of ", stringify!(LineBreaker))
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<LineBreaker>())).mRefCnt as *const _ as usize },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(LineBreaker),
                        "::",
                        stringify!(mRefCnt)
                    )
                );
            }
            #[repr(C)]
            #[derive(Debug)]
            pub struct WordBreaker {
                pub mRefCnt: root::nsAutoRefCnt,
            }
            pub type WordBreaker_HasThreadSafeRefCnt = root::mozilla::FalseType;
            #[test]
            fn bindgen_test_layout_WordBreaker() {
                assert_eq!(
                    ::std::mem::size_of::<WordBreaker>(),
                    8usize,
                    concat!("Size of: ", stringify!(WordBreaker))
                );
                assert_eq!(
                    ::std::mem::align_of::<WordBreaker>(),
                    8usize,
                    concat!("Alignment of ", stringify!(WordBreaker))
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<WordBreaker>())).mRefCnt as *const _ as usize },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(WordBreaker),
                        "::",
                        stringify!(mRefCnt)
                    )
                );
            }
        }
        #[repr(C)]
        pub struct ScrollStyles {
            pub mHorizontal: root::mozilla::StyleOverflow,
            pub mVertical: root::mozilla::StyleOverflow,
            pub mScrollBehavior: u8,
            pub mOverscrollBehaviorX: root::mozilla::StyleOverscrollBehavior,
            pub mOverscrollBehaviorY: root::mozilla::StyleOverscrollBehavior,
            pub mScrollSnapTypeX: root::mozilla::StyleScrollSnapStrictness,
            pub mScrollSnapTypeY: root::mozilla::StyleScrollSnapStrictness,
            pub mScrollSnapPointsX: root::nsStyleCoord,
            pub mScrollSnapPointsY: root::nsStyleCoord,
            pub mScrollSnapDestinationX: root::mozilla::LengthPercentage,
            pub mScrollSnapDestinationY: root::mozilla::LengthPercentage,
        }
        #[test]
        fn bindgen_test_layout_ScrollStyles() {
            assert_eq!(
                ::std::mem::size_of::<ScrollStyles>(),
                64usize,
                concat!("Size of: ", stringify!(ScrollStyles))
            );
            assert_eq!(
                ::std::mem::align_of::<ScrollStyles>(),
                8usize,
                concat!("Alignment of ", stringify!(ScrollStyles))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ScrollStyles>())).mHorizontal as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ScrollStyles),
                    "::",
                    stringify!(mHorizontal)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<ScrollStyles>())).mVertical as *const _ as usize },
                1usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ScrollStyles),
                    "::",
                    stringify!(mVertical)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ScrollStyles>())).mScrollBehavior as *const _ as usize
                },
                2usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ScrollStyles),
                    "::",
                    stringify!(mScrollBehavior)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ScrollStyles>())).mOverscrollBehaviorX as *const _
                        as usize
                },
                3usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ScrollStyles),
                    "::",
                    stringify!(mOverscrollBehaviorX)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ScrollStyles>())).mOverscrollBehaviorY as *const _
                        as usize
                },
                4usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ScrollStyles),
                    "::",
                    stringify!(mOverscrollBehaviorY)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ScrollStyles>())).mScrollSnapTypeX as *const _ as usize
                },
                5usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ScrollStyles),
                    "::",
                    stringify!(mScrollSnapTypeX)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ScrollStyles>())).mScrollSnapTypeY as *const _ as usize
                },
                6usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ScrollStyles),
                    "::",
                    stringify!(mScrollSnapTypeY)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ScrollStyles>())).mScrollSnapPointsX as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ScrollStyles),
                    "::",
                    stringify!(mScrollSnapPointsX)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ScrollStyles>())).mScrollSnapPointsY as *const _ as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ScrollStyles),
                    "::",
                    stringify!(mScrollSnapPointsY)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ScrollStyles>())).mScrollSnapDestinationX as *const _
                        as usize
                },
                40usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ScrollStyles),
                    "::",
                    stringify!(mScrollSnapDestinationX)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ScrollStyles>())).mScrollSnapDestinationY as *const _
                        as usize
                },
                52usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ScrollStyles),
                    "::",
                    stringify!(mScrollSnapDestinationY)
                )
            );
        }
        pub const ScrollMode_Instant: root::mozilla::ScrollMode = 0;
        pub const ScrollMode_Smooth: root::mozilla::ScrollMode = 1;
        pub const ScrollMode_SmoothMsd: root::mozilla::ScrollMode = 2;
        pub const ScrollMode_Normal: root::mozilla::ScrollMode = 3;
        #[doc = " Scroll modes for main-thread scroll operations. These are mostly used"]
        #[doc = " by nsIScrollableFrame methods."]
        #[doc = ""]
        #[doc = " When a scroll operation is requested, we ask for instant, smooth,"]
        #[doc = " smooth msd, or normal scrolling."]
        #[doc = ""]
        #[doc = " |eSmooth| scrolls have a symmetrical acceleration and deceleration curve"]
        #[doc = " modeled with a set of splines that guarantee that the destination will be"]
        #[doc = " reached over a fixed time interval.  |eSmooth| will only be smooth if smooth"]
        #[doc = " scrolling is actually enabled.  This behavior is utilized by keyboard and"]
        #[doc = " mouse wheel scrolling events."]
        #[doc = ""]
        #[doc = " |eSmoothMsd| implements a physically based model that approximates the"]
        #[doc = " behavior of a mass-spring-damper system.  |eSmoothMsd| scrolls have a"]
        #[doc = " non-symmetrical acceleration and deceleration curve, can potentially"]
        #[doc = " overshoot the destination on intermediate frames, and complete over a"]
        #[doc = " variable time interval.  |eSmoothMsd| will only be smooth if cssom-view"]
        #[doc = " smooth-scrolling is enabled."]
        #[doc = ""]
        #[doc = " |eInstant| is always synchronous, |eNormal| can be asynchronous."]
        #[doc = ""]
        #[doc = " If an |eInstant| scroll request happens while a |eSmooth| or async scroll is"]
        #[doc = " already in progress, the async scroll is interrupted and we instantly"]
        #[doc = " scroll to the destination."]
        #[doc = ""]
        #[doc = " If an |eInstant| or |eSmooth| scroll request happens while a |eSmoothMsd|"]
        #[doc = " scroll is already in progress, the |eSmoothMsd| scroll is interrupted without"]
        #[doc = " first scrolling to the destination."]
        pub type ScrollMode = i32;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct ContainerLayerParameters {
            _unused: [u8; 0],
        }
        pub mod layout {
            #[allow(unused_imports)]
            use self::super::super::super::root;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct ScrollAnchorContainer {
                _unused: [u8; 0],
            }
            pub const FrameChildListID_kPrincipalList: root::mozilla::layout::FrameChildListID = 0;
            pub const FrameChildListID_kPopupList: root::mozilla::layout::FrameChildListID = 1;
            pub const FrameChildListID_kCaptionList: root::mozilla::layout::FrameChildListID = 2;
            pub const FrameChildListID_kColGroupList: root::mozilla::layout::FrameChildListID = 3;
            pub const FrameChildListID_kSelectPopupList: root::mozilla::layout::FrameChildListID =
                4;
            pub const FrameChildListID_kAbsoluteList: root::mozilla::layout::FrameChildListID = 5;
            pub const FrameChildListID_kFixedList: root::mozilla::layout::FrameChildListID = 6;
            pub const FrameChildListID_kOverflowList: root::mozilla::layout::FrameChildListID = 7;
            pub const FrameChildListID_kOverflowContainersList:
                root::mozilla::layout::FrameChildListID = 8;
            pub const FrameChildListID_kExcessOverflowContainersList:
                root::mozilla::layout::FrameChildListID = 9;
            pub const FrameChildListID_kOverflowOutOfFlowList:
                root::mozilla::layout::FrameChildListID = 10;
            pub const FrameChildListID_kFloatList: root::mozilla::layout::FrameChildListID = 11;
            pub const FrameChildListID_kBulletList: root::mozilla::layout::FrameChildListID = 12;
            pub const FrameChildListID_kPushedFloatsList: root::mozilla::layout::FrameChildListID =
                13;
            pub const FrameChildListID_kBackdropList: root::mozilla::layout::FrameChildListID = 14;
            pub const FrameChildListID_kNoReflowPrincipalList:
                root::mozilla::layout::FrameChildListID = 15;
            pub type FrameChildListID = u32;
            #[repr(C)]
            pub struct PostFrameDestroyData {
                pub mAnonymousContent: [u64; 102usize],
            }
            #[test]
            fn bindgen_test_layout_PostFrameDestroyData() {
                assert_eq!(
                    ::std::mem::size_of::<PostFrameDestroyData>(),
                    816usize,
                    concat!("Size of: ", stringify!(PostFrameDestroyData))
                );
                assert_eq!(
                    ::std::mem::align_of::<PostFrameDestroyData>(),
                    8usize,
                    concat!("Alignment of ", stringify!(PostFrameDestroyData))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<PostFrameDestroyData>())).mAnonymousContent
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(PostFrameDestroyData),
                        "::",
                        stringify!(mAnonymousContent)
                    )
                );
            }
            pub type FrameChildListIDs = root::mozilla::EnumSet<::std::os::raw::c_uint>;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct FrameChildList {
                pub mList: root::nsFrameList,
                pub mID: root::mozilla::layout::FrameChildListID,
            }
            #[test]
            fn bindgen_test_layout_FrameChildList() {
                assert_eq!(
                    ::std::mem::size_of::<FrameChildList>(),
                    24usize,
                    concat!("Size of: ", stringify!(FrameChildList))
                );
                assert_eq!(
                    ::std::mem::align_of::<FrameChildList>(),
                    8usize,
                    concat!("Alignment of ", stringify!(FrameChildList))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameChildList>())).mList as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameChildList),
                        "::",
                        stringify!(mList)
                    )
                );
                assert_eq!(
                    unsafe { &(*(::std::ptr::null::<FrameChildList>())).mID as *const _ as usize },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameChildList),
                        "::",
                        stringify!(mID)
                    )
                );
            }
            #[doc = " A class to iterate frame child lists."]
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct FrameChildListArrayIterator {
                pub mLists: *const root::nsTArray<root::mozilla::layout::FrameChildList>,
                pub mCurrentIndex: u32,
            }
            #[test]
            fn bindgen_test_layout_FrameChildListArrayIterator() {
                assert_eq!(
                    ::std::mem::size_of::<FrameChildListArrayIterator>(),
                    16usize,
                    concat!("Size of: ", stringify!(FrameChildListArrayIterator))
                );
                assert_eq!(
                    ::std::mem::align_of::<FrameChildListArrayIterator>(),
                    8usize,
                    concat!("Alignment of ", stringify!(FrameChildListArrayIterator))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameChildListArrayIterator>())).mLists as *const _
                            as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameChildListArrayIterator),
                        "::",
                        stringify!(mLists)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameChildListArrayIterator>())).mCurrentIndex
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameChildListArrayIterator),
                        "::",
                        stringify!(mCurrentIndex)
                    )
                );
            }
            #[doc = " A class for retrieving a frame\'s child lists and iterate them."]
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct FrameChildListIterator {
                pub _base: root::mozilla::layout::FrameChildListArrayIterator,
                pub mLists: [u64; 14usize],
            }
            #[test]
            fn bindgen_test_layout_FrameChildListIterator() {
                assert_eq!(
                    ::std::mem::size_of::<FrameChildListIterator>(),
                    128usize,
                    concat!("Size of: ", stringify!(FrameChildListIterator))
                );
                assert_eq!(
                    ::std::mem::align_of::<FrameChildListIterator>(),
                    8usize,
                    concat!("Alignment of ", stringify!(FrameChildListIterator))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<FrameChildListIterator>())).mLists as *const _
                            as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(FrameChildListIterator),
                        "::",
                        stringify!(mLists)
                    )
                );
            }
        }
        pub const MediaFeatureChangeReason_ViewportChange: root::mozilla::MediaFeatureChangeReason =
            1;
        pub const MediaFeatureChangeReason_ZoomChange: root::mozilla::MediaFeatureChangeReason = 2;
        pub const MediaFeatureChangeReason_ResolutionChange:
            root::mozilla::MediaFeatureChangeReason = 4;
        pub const MediaFeatureChangeReason_MediumChange: root::mozilla::MediaFeatureChangeReason =
            8;
        pub const MediaFeatureChangeReason_SizeModeChange: root::mozilla::MediaFeatureChangeReason =
            16;
        pub const MediaFeatureChangeReason_SystemMetricsChange:
            root::mozilla::MediaFeatureChangeReason = 32;
        pub const MediaFeatureChangeReason_DeviceSizeIsPageSizeChange:
            root::mozilla::MediaFeatureChangeReason = 64;
        pub const MediaFeatureChangeReason_DisplayModeChange:
            root::mozilla::MediaFeatureChangeReason = 128;
        pub type MediaFeatureChangeReason = i32;
        #[repr(C)]
        pub struct MediaFeatureChange {
            pub mRestyleHint: root::mozilla::RestyleHint,
            pub mChangeHint: root::nsChangeHint,
            pub mReason: root::mozilla::MediaFeatureChangeReason,
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla18MediaFeatureChange11kAllChangesE"]
            pub static MediaFeatureChange_kAllChanges: root::mozilla::MediaFeatureChangeReason;
        }
        #[test]
        fn bindgen_test_layout_MediaFeatureChange() {
            assert_eq!(
                ::std::mem::size_of::<MediaFeatureChange>(),
                12usize,
                concat!("Size of: ", stringify!(MediaFeatureChange))
            );
            assert_eq!(
                ::std::mem::align_of::<MediaFeatureChange>(),
                4usize,
                concat!("Alignment of ", stringify!(MediaFeatureChange))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<MediaFeatureChange>())).mRestyleHint as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(MediaFeatureChange),
                    "::",
                    stringify!(mRestyleHint)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<MediaFeatureChange>())).mChangeHint as *const _ as usize
                },
                4usize,
                concat!(
                    "Offset of field: ",
                    stringify!(MediaFeatureChange),
                    "::",
                    stringify!(mChangeHint)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<MediaFeatureChange>())).mReason as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(MediaFeatureChange),
                    "::",
                    stringify!(mReason)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct PreferenceSheet {
            pub _address: u8,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct PreferenceSheet_Prefs {
            pub mLinkColor: root::nscolor,
            pub mActiveLinkColor: root::nscolor,
            pub mVisitedLinkColor: root::nscolor,
            pub mDefaultColor: root::nscolor,
            pub mDefaultBackgroundColor: root::nscolor,
            pub mLinkBackgroundColor: root::nscolor,
            pub mFocusTextColor: root::nscolor,
            pub mFocusBackgroundColor: root::nscolor,
            pub mIsChrome: bool,
            pub mUseAccessibilityTheme: bool,
            pub mUnderlineLinks: bool,
            pub mUseFocusColors: bool,
            pub mFocusRingWidth: u8,
            pub mFocusRingStyle: u8,
            pub mFocusRingOnAnything: bool,
        }
        #[test]
        fn bindgen_test_layout_PreferenceSheet_Prefs() {
            assert_eq!(
                ::std::mem::size_of::<PreferenceSheet_Prefs>(),
                40usize,
                concat!("Size of: ", stringify!(PreferenceSheet_Prefs))
            );
            assert_eq!(
                ::std::mem::align_of::<PreferenceSheet_Prefs>(),
                4usize,
                concat!("Alignment of ", stringify!(PreferenceSheet_Prefs))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PreferenceSheet_Prefs>())).mLinkColor as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PreferenceSheet_Prefs),
                    "::",
                    stringify!(mLinkColor)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PreferenceSheet_Prefs>())).mActiveLinkColor as *const _
                        as usize
                },
                4usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PreferenceSheet_Prefs),
                    "::",
                    stringify!(mActiveLinkColor)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PreferenceSheet_Prefs>())).mVisitedLinkColor as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PreferenceSheet_Prefs),
                    "::",
                    stringify!(mVisitedLinkColor)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PreferenceSheet_Prefs>())).mDefaultColor as *const _
                        as usize
                },
                12usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PreferenceSheet_Prefs),
                    "::",
                    stringify!(mDefaultColor)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PreferenceSheet_Prefs>())).mDefaultBackgroundColor
                        as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PreferenceSheet_Prefs),
                    "::",
                    stringify!(mDefaultBackgroundColor)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PreferenceSheet_Prefs>())).mLinkBackgroundColor
                        as *const _ as usize
                },
                20usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PreferenceSheet_Prefs),
                    "::",
                    stringify!(mLinkBackgroundColor)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PreferenceSheet_Prefs>())).mFocusTextColor as *const _
                        as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PreferenceSheet_Prefs),
                    "::",
                    stringify!(mFocusTextColor)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PreferenceSheet_Prefs>())).mFocusBackgroundColor
                        as *const _ as usize
                },
                28usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PreferenceSheet_Prefs),
                    "::",
                    stringify!(mFocusBackgroundColor)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PreferenceSheet_Prefs>())).mIsChrome as *const _ as usize
                },
                32usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PreferenceSheet_Prefs),
                    "::",
                    stringify!(mIsChrome)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PreferenceSheet_Prefs>())).mUseAccessibilityTheme
                        as *const _ as usize
                },
                33usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PreferenceSheet_Prefs),
                    "::",
                    stringify!(mUseAccessibilityTheme)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PreferenceSheet_Prefs>())).mUnderlineLinks as *const _
                        as usize
                },
                34usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PreferenceSheet_Prefs),
                    "::",
                    stringify!(mUnderlineLinks)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PreferenceSheet_Prefs>())).mUseFocusColors as *const _
                        as usize
                },
                35usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PreferenceSheet_Prefs),
                    "::",
                    stringify!(mUseFocusColors)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PreferenceSheet_Prefs>())).mFocusRingWidth as *const _
                        as usize
                },
                36usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PreferenceSheet_Prefs),
                    "::",
                    stringify!(mFocusRingWidth)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PreferenceSheet_Prefs>())).mFocusRingStyle as *const _
                        as usize
                },
                37usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PreferenceSheet_Prefs),
                    "::",
                    stringify!(mFocusRingStyle)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PreferenceSheet_Prefs>())).mFocusRingOnAnything
                        as *const _ as usize
                },
                38usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PreferenceSheet_Prefs),
                    "::",
                    stringify!(mFocusRingOnAnything)
                )
            );
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla15PreferenceSheet12sInitializedE"]
            pub static mut PreferenceSheet_sInitialized: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla15PreferenceSheet13sContentPrefsE"]
            pub static mut PreferenceSheet_sContentPrefs: root::mozilla::PreferenceSheet_Prefs;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla15PreferenceSheet12sChromePrefsE"]
            pub static mut PreferenceSheet_sChromePrefs: root::mozilla::PreferenceSheet_Prefs;
        }
        #[test]
        fn bindgen_test_layout_PreferenceSheet() {
            assert_eq!(
                ::std::mem::size_of::<PreferenceSheet>(),
                1usize,
                concat!("Size of: ", stringify!(PreferenceSheet))
            );
            assert_eq!(
                ::std::mem::align_of::<PreferenceSheet>(),
                1usize,
                concat!("Alignment of ", stringify!(PreferenceSheet))
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct AnimationEventDispatcher {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct EventStateManager {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct RestyleManager {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[repr(align(2))]
        #[derive(Debug, Copy, Clone)]
        pub struct ScrollAxis {
            pub _bindgen_opaque_blob: [u16; 2usize],
        }
        #[test]
        fn bindgen_test_layout_ScrollAxis() {
            assert_eq!(
                ::std::mem::size_of::<ScrollAxis>(),
                4usize,
                concat!("Size of: ", stringify!(ScrollAxis))
            );
            assert_eq!(
                ::std::mem::align_of::<ScrollAxis>(),
                2usize,
                concat!("Alignment of ", stringify!(ScrollAxis))
            );
        }
        pub const ScrollFlags_None: root::mozilla::ScrollFlags = 0;
        pub const ScrollFlags_ScrollFirstAncestorOnly: root::mozilla::ScrollFlags = 1;
        pub const ScrollFlags_ScrollOverflowHidden: root::mozilla::ScrollFlags = 2;
        pub const ScrollFlags_ScrollNoParentFrames: root::mozilla::ScrollFlags = 4;
        pub const ScrollFlags_ScrollSmooth: root::mozilla::ScrollFlags = 8;
        pub const ScrollFlags_ScrollSmoothAuto: root::mozilla::ScrollFlags = 16;
        pub const ScrollFlags_ScrollSnap: root::mozilla::ScrollFlags = 32;
        pub const ScrollFlags_IgnoreMarginAndPadding: root::mozilla::ScrollFlags = 64;
        pub const ScrollFlags_AnchorScrollFlags: root::mozilla::ScrollFlags = 6;
        pub type ScrollFlags = i32;
        pub const RenderingStateFlags_None: root::mozilla::RenderingStateFlags = 0;
        pub const RenderingStateFlags_IgnoringViewportScrolling:
            root::mozilla::RenderingStateFlags = 1;
        pub const RenderingStateFlags_DrawWindowNotFlushing: root::mozilla::RenderingStateFlags = 2;
        pub type RenderingStateFlags = u8;
        #[repr(C)]
        pub struct WidgetPointerEventHolder__bindgen_vtable(::std::os::raw::c_void);
        #[repr(C)]
        pub struct WidgetPointerEventHolder {
            pub vtable_: *const WidgetPointerEventHolder__bindgen_vtable,
            pub mEvents: root::nsTArray<root::mozilla::WidgetPointerEvent>,
            pub mRefCnt: root::nsAutoRefCnt,
        }
        pub type WidgetPointerEventHolder_HasThreadSafeRefCnt = root::mozilla::FalseType;
        #[test]
        fn bindgen_test_layout_WidgetPointerEventHolder() {
            assert_eq!(
                ::std::mem::size_of::<WidgetPointerEventHolder>(),
                24usize,
                concat!("Size of: ", stringify!(WidgetPointerEventHolder))
            );
            assert_eq!(
                ::std::mem::align_of::<WidgetPointerEventHolder>(),
                8usize,
                concat!("Alignment of ", stringify!(WidgetPointerEventHolder))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetPointerEventHolder>())).mEvents as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetPointerEventHolder),
                    "::",
                    stringify!(mEvents)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetPointerEventHolder>())).mRefCnt as *const _
                        as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetPointerEventHolder),
                    "::",
                    stringify!(mRefCnt)
                )
            );
        }
        #[doc = " mozilla::WidgetPointerHelper"]
        #[repr(C)]
        pub struct WidgetPointerHelper {
            pub pointerId: u32,
            pub tiltX: u32,
            pub tiltY: u32,
            pub twist: u32,
            pub tangentialPressure: f32,
            pub convertToPointer: bool,
            pub mCoalescedWidgetEvents: root::RefPtr<root::mozilla::WidgetPointerEventHolder>,
        }
        #[test]
        fn bindgen_test_layout_WidgetPointerHelper() {
            assert_eq!(
                ::std::mem::size_of::<WidgetPointerHelper>(),
                32usize,
                concat!("Size of: ", stringify!(WidgetPointerHelper))
            );
            assert_eq!(
                ::std::mem::align_of::<WidgetPointerHelper>(),
                8usize,
                concat!("Alignment of ", stringify!(WidgetPointerHelper))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetPointerHelper>())).pointerId as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetPointerHelper),
                    "::",
                    stringify!(pointerId)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetPointerHelper>())).tiltX as *const _ as usize
                },
                4usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetPointerHelper),
                    "::",
                    stringify!(tiltX)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetPointerHelper>())).tiltY as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetPointerHelper),
                    "::",
                    stringify!(tiltY)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetPointerHelper>())).twist as *const _ as usize
                },
                12usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetPointerHelper),
                    "::",
                    stringify!(twist)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetPointerHelper>())).tangentialPressure as *const _
                        as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetPointerHelper),
                    "::",
                    stringify!(tangentialPressure)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetPointerHelper>())).convertToPointer as *const _
                        as usize
                },
                20usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetPointerHelper),
                    "::",
                    stringify!(convertToPointer)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetPointerHelper>())).mCoalescedWidgetEvents
                        as *const _ as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetPointerHelper),
                    "::",
                    stringify!(mCoalescedWidgetEvents)
                )
            );
        }
        #[doc = " mozilla::WidgetMouseEventBase"]
        #[repr(C)]
        pub struct WidgetMouseEventBase {
            pub _base: root::mozilla::WidgetInputEvent,
            pub mRegion: ::gecko_bindings::structs::nsString,
            pub mPressure: f32,
            pub mButton: i16,
            pub mButtons: i16,
            pub mInputSource: u16,
            pub mHitCluster: bool,
        }
        #[test]
        fn bindgen_test_layout_WidgetMouseEventBase() {
            assert_eq!(
                ::std::mem::size_of::<WidgetMouseEventBase>(),
                200usize,
                concat!("Size of: ", stringify!(WidgetMouseEventBase))
            );
            assert_eq!(
                ::std::mem::align_of::<WidgetMouseEventBase>(),
                8usize,
                concat!("Alignment of ", stringify!(WidgetMouseEventBase))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetMouseEventBase>())).mRegion as *const _ as usize
                },
                168usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetMouseEventBase),
                    "::",
                    stringify!(mRegion)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetMouseEventBase>())).mPressure as *const _ as usize
                },
                184usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetMouseEventBase),
                    "::",
                    stringify!(mPressure)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetMouseEventBase>())).mButton as *const _ as usize
                },
                188usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetMouseEventBase),
                    "::",
                    stringify!(mButton)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetMouseEventBase>())).mButtons as *const _ as usize
                },
                190usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetMouseEventBase),
                    "::",
                    stringify!(mButtons)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetMouseEventBase>())).mInputSource as *const _
                        as usize
                },
                192usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetMouseEventBase),
                    "::",
                    stringify!(mInputSource)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetMouseEventBase>())).mHitCluster as *const _
                        as usize
                },
                194usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetMouseEventBase),
                    "::",
                    stringify!(mHitCluster)
                )
            );
        }
        #[doc = " mozilla::WidgetMouseEvent"]
        #[repr(C)]
        pub struct WidgetMouseEvent {
            pub _base: root::mozilla::WidgetMouseEventBase,
            pub _base_1: root::mozilla::WidgetPointerHelper,
            pub mClickTarget: root::nsCOMPtr,
            pub mReason: root::mozilla::WidgetMouseEvent_Reason,
            pub mContextMenuTrigger: root::mozilla::WidgetMouseEvent_ContextMenuTrigger,
            pub mExitFrom: root::mozilla::WidgetMouseEvent_ExitFrom,
            pub mIgnoreRootScrollFrame: bool,
            pub mClickCount: u32,
            pub mUseLegacyNonPrimaryDispatch: bool,
        }
        pub type WidgetMouseEvent_ReasonType = bool;
        pub const WidgetMouseEvent_Reason_eReal: root::mozilla::WidgetMouseEvent_Reason = 0;
        pub const WidgetMouseEvent_Reason_eSynthesized: root::mozilla::WidgetMouseEvent_Reason = 1;
        pub type WidgetMouseEvent_Reason = u8;
        pub type WidgetMouseEvent_ContextMenuTriggerType = bool;
        pub const WidgetMouseEvent_ContextMenuTrigger_eNormal:
            root::mozilla::WidgetMouseEvent_ContextMenuTrigger = 0;
        pub const WidgetMouseEvent_ContextMenuTrigger_eContextMenuKey:
            root::mozilla::WidgetMouseEvent_ContextMenuTrigger = 1;
        pub type WidgetMouseEvent_ContextMenuTrigger = u8;
        pub type WidgetMouseEvent_ExitFromType = bool;
        pub const WidgetMouseEvent_ExitFrom_eChild: root::mozilla::WidgetMouseEvent_ExitFrom = 0;
        pub const WidgetMouseEvent_ExitFrom_eTopLevel: root::mozilla::WidgetMouseEvent_ExitFrom = 1;
        pub type WidgetMouseEvent_ExitFrom = u8;
        #[test]
        fn bindgen_test_layout_WidgetMouseEvent() {
            assert_eq!(
                ::std::mem::size_of::<WidgetMouseEvent>(),
                256usize,
                concat!("Size of: ", stringify!(WidgetMouseEvent))
            );
            assert_eq!(
                ::std::mem::align_of::<WidgetMouseEvent>(),
                8usize,
                concat!("Alignment of ", stringify!(WidgetMouseEvent))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetMouseEvent>())).mClickTarget as *const _ as usize
                },
                232usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetMouseEvent),
                    "::",
                    stringify!(mClickTarget)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetMouseEvent>())).mReason as *const _ as usize
                },
                240usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetMouseEvent),
                    "::",
                    stringify!(mReason)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetMouseEvent>())).mContextMenuTrigger as *const _
                        as usize
                },
                241usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetMouseEvent),
                    "::",
                    stringify!(mContextMenuTrigger)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetMouseEvent>())).mExitFrom as *const _ as usize
                },
                242usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetMouseEvent),
                    "::",
                    stringify!(mExitFrom)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetMouseEvent>())).mIgnoreRootScrollFrame as *const _
                        as usize
                },
                243usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetMouseEvent),
                    "::",
                    stringify!(mIgnoreRootScrollFrame)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetMouseEvent>())).mClickCount as *const _ as usize
                },
                244usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetMouseEvent),
                    "::",
                    stringify!(mClickCount)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetMouseEvent>())).mUseLegacyNonPrimaryDispatch
                        as *const _ as usize
                },
                248usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetMouseEvent),
                    "::",
                    stringify!(mUseLegacyNonPrimaryDispatch)
                )
            );
        }
        #[doc = " mozilla::WidgetPointerEvent"]
        #[repr(C)]
        pub struct WidgetPointerEvent {
            pub _base: root::mozilla::WidgetMouseEvent,
            pub mWidth: u32,
            pub mHeight: u32,
            pub mIsPrimary: bool,
        }
        #[test]
        fn bindgen_test_layout_WidgetPointerEvent() {
            assert_eq!(
                ::std::mem::size_of::<WidgetPointerEvent>(),
                264usize,
                concat!("Size of: ", stringify!(WidgetPointerEvent))
            );
            assert_eq!(
                ::std::mem::align_of::<WidgetPointerEvent>(),
                8usize,
                concat!("Alignment of ", stringify!(WidgetPointerEvent))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetPointerEvent>())).mWidth as *const _ as usize
                },
                252usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetPointerEvent),
                    "::",
                    stringify!(mWidth)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetPointerEvent>())).mHeight as *const _ as usize
                },
                256usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetPointerEvent),
                    "::",
                    stringify!(mHeight)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WidgetPointerEvent>())).mIsPrimary as *const _ as usize
                },
                260usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WidgetPointerEvent),
                    "::",
                    stringify!(mIsPrimary)
                )
            );
        }
        #[repr(C)]
        pub struct TouchManager {
            pub mPresShell: root::RefPtr<root::mozilla::PresShell>,
            pub mDocument: root::RefPtr<root::mozilla::dom::Document>,
        }
        #[repr(C)]
        pub struct TouchManager_TouchInfo {
            pub mTouch: root::RefPtr<root::mozilla::dom::Touch>,
            pub mNonAnonymousTarget: root::nsCOMPtr,
            pub mConvertToPointer: bool,
        }
        #[test]
        fn bindgen_test_layout_TouchManager_TouchInfo() {
            assert_eq!(
                ::std::mem::size_of::<TouchManager_TouchInfo>(),
                24usize,
                concat!("Size of: ", stringify!(TouchManager_TouchInfo))
            );
            assert_eq!(
                ::std::mem::align_of::<TouchManager_TouchInfo>(),
                8usize,
                concat!("Alignment of ", stringify!(TouchManager_TouchInfo))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<TouchManager_TouchInfo>())).mTouch as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(TouchManager_TouchInfo),
                    "::",
                    stringify!(mTouch)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<TouchManager_TouchInfo>())).mNonAnonymousTarget
                        as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(TouchManager_TouchInfo),
                    "::",
                    stringify!(mNonAnonymousTarget)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<TouchManager_TouchInfo>())).mConvertToPointer as *const _
                        as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(TouchManager_TouchInfo),
                    "::",
                    stringify!(mConvertToPointer)
                )
            );
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla12TouchManager17sCaptureTouchListE"]
            pub static mut TouchManager_sCaptureTouchList: *mut u8;
        }
        #[test]
        fn bindgen_test_layout_TouchManager() {
            assert_eq!(
                ::std::mem::size_of::<TouchManager>(),
                16usize,
                concat!("Size of: ", stringify!(TouchManager))
            );
            assert_eq!(
                ::std::mem::align_of::<TouchManager>(),
                8usize,
                concat!("Alignment of ", stringify!(TouchManager))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<TouchManager>())).mPresShell as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(TouchManager),
                    "::",
                    stringify!(mPresShell)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<TouchManager>())).mDocument as *const _ as usize },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(TouchManager),
                    "::",
                    stringify!(mDocument)
                )
            );
        }
        #[doc = " A PostTraversalTask is a task to be performed immediately after a Servo"]
        #[doc = " traversal.  There are just a few tasks we need to perform, so we use this"]
        #[doc = " class rather than Runnables, to avoid virtual calls and some allocations."]
        #[doc = ""]
        #[doc = " A PostTraversalTask is only safe to run immediately after the Servo"]
        #[doc = " traversal, since it can hold raw pointers to DOM objects."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct PostTraversalTask {
            pub mType: root::mozilla::PostTraversalTask_Type,
            pub mTarget: *mut ::std::os::raw::c_void,
            pub mResult: root::nsresult,
        }
        pub const PostTraversalTask_Type_ResolveFontFaceLoadedPromise:
            root::mozilla::PostTraversalTask_Type = 0;
        pub const PostTraversalTask_Type_RejectFontFaceLoadedPromise:
            root::mozilla::PostTraversalTask_Type = 1;
        pub const PostTraversalTask_Type_DispatchLoadingEventAndReplaceReadyPromise:
            root::mozilla::PostTraversalTask_Type = 2;
        pub const PostTraversalTask_Type_DispatchFontFaceSetCheckLoadingFinishedAfterDelay:
            root::mozilla::PostTraversalTask_Type = 3;
        pub const PostTraversalTask_Type_LoadFontEntry: root::mozilla::PostTraversalTask_Type = 4;
        pub const PostTraversalTask_Type_InitializeFamily: root::mozilla::PostTraversalTask_Type =
            5;
        pub const PostTraversalTask_Type_FontInfoUpdate: root::mozilla::PostTraversalTask_Type = 6;
        pub type PostTraversalTask_Type = i32;
        #[test]
        fn bindgen_test_layout_PostTraversalTask() {
            assert_eq!(
                ::std::mem::size_of::<PostTraversalTask>(),
                24usize,
                concat!("Size of: ", stringify!(PostTraversalTask))
            );
            assert_eq!(
                ::std::mem::align_of::<PostTraversalTask>(),
                8usize,
                concat!("Alignment of ", stringify!(PostTraversalTask))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<PostTraversalTask>())).mType as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PostTraversalTask),
                    "::",
                    stringify!(mType)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PostTraversalTask>())).mTarget as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PostTraversalTask),
                    "::",
                    stringify!(mTarget)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PostTraversalTask>())).mResult as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PostTraversalTask),
                    "::",
                    stringify!(mResult)
                )
            );
        }
        pub const CSSEnabledState_ForAllContent: root::mozilla::CSSEnabledState = 0;
        pub const CSSEnabledState_InUASheets: root::mozilla::CSSEnabledState = 1;
        pub const CSSEnabledState_InChrome: root::mozilla::CSSEnabledState = 2;
        pub const CSSEnabledState_IgnoreEnabledState: root::mozilla::CSSEnabledState = 255;
        pub type CSSEnabledState = i32;
        impl root::mozilla::PseudoStyleType {
            pub const AnonBoxesStart: root::mozilla::PseudoStyleType =
                PseudoStyleType::CSSPseudoElementsEnd;
        }
        impl root::mozilla::PseudoStyleType {
            pub const InheritingAnonBoxesStart: root::mozilla::PseudoStyleType =
                PseudoStyleType::CSSPseudoElementsEnd;
        }
        impl root::mozilla::PseudoStyleType {
            pub const __reset_1: root::mozilla::PseudoStyleType = PseudoStyleType::mozColorSwatch;
        }
        impl root::mozilla::PseudoStyleType {
            pub const mozText: root::mozilla::PseudoStyleType =
                PseudoStyleType::CSSPseudoElementsEnd;
        }
        impl root::mozilla::PseudoStyleType {
            pub const __reset_2: root::mozilla::PseudoStyleType = PseudoStyleType::mozSVGText;
        }
        impl root::mozilla::PseudoStyleType {
            pub const mozMathMLAnonymousBlock: root::mozilla::PseudoStyleType =
                PseudoStyleType::WrapperAnonBoxesStart;
        }
        impl root::mozilla::PseudoStyleType {
            pub const InheritingAnonBoxesEnd: root::mozilla::PseudoStyleType =
                PseudoStyleType::WrapperAnonBoxesEnd;
        }
        impl root::mozilla::PseudoStyleType {
            pub const NonInheritingAnonBoxesStart: root::mozilla::PseudoStyleType =
                PseudoStyleType::WrapperAnonBoxesEnd;
        }
        impl root::mozilla::PseudoStyleType {
            pub const __reset_3: root::mozilla::PseudoStyleType =
                PseudoStyleType::rubyTextContainer;
        }
        impl root::mozilla::PseudoStyleType {
            pub const oofPlaceholder: root::mozilla::PseudoStyleType =
                PseudoStyleType::WrapperAnonBoxesEnd;
        }
        impl root::mozilla::PseudoStyleType {
            pub const AnonBoxesEnd: root::mozilla::PseudoStyleType =
                PseudoStyleType::NonInheritingAnonBoxesEnd;
        }
        impl root::mozilla::PseudoStyleType {
            pub const XULTree: root::mozilla::PseudoStyleType =
                PseudoStyleType::NonInheritingAnonBoxesEnd;
        }
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum PseudoStyleType {
            after = 0,
            before = 1,
            marker = 2,
            backdrop = 3,
            cue = 4,
            firstLetter = 5,
            firstLine = 6,
            selection = 7,
            mozFocusInner = 8,
            mozFocusOuter = 9,
            mozMathAnonymous = 10,
            mozNumberWrapper = 11,
            mozNumberText = 12,
            mozNumberSpinBox = 13,
            mozNumberSpinUp = 14,
            mozNumberSpinDown = 15,
            mozProgressBar = 16,
            mozRangeTrack = 17,
            mozRangeProgress = 18,
            mozRangeThumb = 19,
            mozMeterBar = 20,
            placeholder = 21,
            mozColorSwatch = 22,
            CSSPseudoElementsEnd = 23,
            firstLetterContinuation = 24,
            mozBlockInsideInlineWrapper = 25,
            mozXULAnonymousBlock = 26,
            mozLineFrame = 27,
            buttonContent = 28,
            cellContent = 29,
            dropDownList = 30,
            fieldsetContent = 31,
            mozDisplayComboboxControlFrame = 32,
            htmlCanvasContent = 33,
            tableWrapper = 34,
            canvas = 35,
            page = 36,
            pageContent = 37,
            pageSequence = 38,
            scrolledContent = 39,
            scrolledCanvas = 40,
            scrolledPageSequence = 41,
            columnSet = 42,
            columnContent = 43,
            viewport = 44,
            viewportScroll = 45,
            mozTreeColumn = 46,
            mozTreeRow = 47,
            mozTreeSeparator = 48,
            mozTreeCell = 49,
            mozTreeIndentation = 50,
            mozTreeLine = 51,
            mozTreeTwisty = 52,
            mozTreeImage = 53,
            mozTreeCellText = 54,
            mozTreeCheckbox = 55,
            mozTreeDropFeedback = 56,
            mozSVGMarkerAnonChild = 57,
            mozSVGOuterSVGAnonChild = 58,
            mozSVGForeignContent = 59,
            mozSVGText = 60,
            WrapperAnonBoxesStart = 61,
            inlineTable = 62,
            table = 63,
            tableCell = 64,
            tableRowGroup = 65,
            tableRow = 66,
            anonymousFlexItem = 67,
            anonymousGridItem = 68,
            ruby = 69,
            rubyBase = 70,
            rubyBaseContainer = 71,
            rubyText = 72,
            rubyTextContainer = 73,
            WrapperAnonBoxesEnd = 74,
            horizontalFramesetBorder = 75,
            verticalFramesetBorder = 76,
            framesetBlank = 77,
            tableColGroup = 78,
            tableCol = 79,
            pageBreak = 80,
            columnSpanWrapper = 81,
            NonInheritingAnonBoxesEnd = 82,
            NotPseudo = 83,
            MAX = 84,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct ServoStyleRuleMap {
            _unused: [u8; 0],
        }
        pub const StylistState_NotDirty: root::mozilla::StylistState = 0;
        pub const StylistState_StyleSheetsDirty: root::mozilla::StylistState = 1;
        pub const StylistState_ShadowDOMStyleSheetsDirty: root::mozilla::StylistState = 2;
        pub type StylistState = u8;
        impl OriginFlags {
            pub const UserAgent: root::mozilla::OriginFlags = root::mozilla::OriginFlags(1);
        }
        impl OriginFlags {
            pub const User: root::mozilla::OriginFlags = root::mozilla::OriginFlags(2);
        }
        impl OriginFlags {
            pub const Author: root::mozilla::OriginFlags = root::mozilla::OriginFlags(4);
        }
        impl OriginFlags {
            pub const All: root::mozilla::OriginFlags = root::mozilla::OriginFlags(7);
        }
        impl ::std::ops::BitOr<root::mozilla::OriginFlags> for root::mozilla::OriginFlags {
            type Output = Self;
            #[inline]
            fn bitor(self, other: Self) -> Self {
                OriginFlags(self.0 | other.0)
            }
        }
        impl ::std::ops::BitOrAssign for root::mozilla::OriginFlags {
            #[inline]
            fn bitor_assign(&mut self, rhs: root::mozilla::OriginFlags) {
                self.0 |= rhs.0;
            }
        }
        impl ::std::ops::BitAnd<root::mozilla::OriginFlags> for root::mozilla::OriginFlags {
            type Output = Self;
            #[inline]
            fn bitand(self, other: Self) -> Self {
                OriginFlags(self.0 & other.0)
            }
        }
        impl ::std::ops::BitAndAssign for root::mozilla::OriginFlags {
            #[inline]
            fn bitand_assign(&mut self, rhs: root::mozilla::OriginFlags) {
                self.0 &= rhs.0;
            }
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub struct OriginFlags(pub u8);
        #[doc = " The set of style sheets that apply to a document, backed by a Servo"]
        #[doc = " Stylist.  A ServoStyleSet contains StyleSheets."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct ServoStyleSet {
            pub mDocument: *mut root::mozilla::dom::Document,
            pub mRawSet: root::mozilla::UniquePtr<root::RawServoStyleSet>,
            pub mStyleRuleMap: root::mozilla::UniquePtr<root::mozilla::ServoStyleRuleMap>,
            pub mUserFontSetUpdateGeneration: u64,
            pub mPostTraversalTasks: root::nsTArray<root::mozilla::PostTraversalTask>,
            pub mNonInheritingComputedStyles: [u64; 8usize],
            pub mStylistState: root::mozilla::StylistState,
            pub mAuthorStyleDisabled: bool,
            pub mNeedsRestyleAfterEnsureUniqueInner: bool,
        }
        pub type ServoStyleSet_SnapshotTable = root::mozilla::ServoElementSnapshotTable;
        pub use self::super::super::root::mozilla::StyleOrigin as ServoStyleSet_Origin;
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla13ServoStyleSet8kOriginsE"]
            pub static mut ServoStyleSet_kOrigins: [root::mozilla::StyleOrigin; 3usize];
        }
        #[test]
        fn bindgen_test_layout_ServoStyleSet() {
            assert_eq!(
                ::std::mem::size_of::<ServoStyleSet>(),
                112usize,
                concat!("Size of: ", stringify!(ServoStyleSet))
            );
            assert_eq!(
                ::std::mem::align_of::<ServoStyleSet>(),
                8usize,
                concat!("Alignment of ", stringify!(ServoStyleSet))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<ServoStyleSet>())).mDocument as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoStyleSet),
                    "::",
                    stringify!(mDocument)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<ServoStyleSet>())).mRawSet as *const _ as usize },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoStyleSet),
                    "::",
                    stringify!(mRawSet)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoStyleSet>())).mStyleRuleMap as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoStyleSet),
                    "::",
                    stringify!(mStyleRuleMap)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoStyleSet>())).mUserFontSetUpdateGeneration
                        as *const _ as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoStyleSet),
                    "::",
                    stringify!(mUserFontSetUpdateGeneration)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoStyleSet>())).mPostTraversalTasks as *const _
                        as usize
                },
                32usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoStyleSet),
                    "::",
                    stringify!(mPostTraversalTasks)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoStyleSet>())).mNonInheritingComputedStyles
                        as *const _ as usize
                },
                40usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoStyleSet),
                    "::",
                    stringify!(mNonInheritingComputedStyles)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoStyleSet>())).mStylistState as *const _ as usize
                },
                104usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoStyleSet),
                    "::",
                    stringify!(mStylistState)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoStyleSet>())).mAuthorStyleDisabled as *const _
                        as usize
                },
                105usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoStyleSet),
                    "::",
                    stringify!(mAuthorStyleDisabled)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoStyleSet>())).mNeedsRestyleAfterEnsureUniqueInner
                        as *const _ as usize
                },
                106usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoStyleSet),
                    "::",
                    stringify!(mNeedsRestyleAfterEnsureUniqueInner)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct RelativeTimeline {
            pub mRandomTimelineSeed: u64,
        }
        #[test]
        fn bindgen_test_layout_RelativeTimeline() {
            assert_eq!(
                ::std::mem::size_of::<RelativeTimeline>(),
                8usize,
                concat!("Size of: ", stringify!(RelativeTimeline))
            );
            assert_eq!(
                ::std::mem::align_of::<RelativeTimeline>(),
                8usize,
                concat!("Alignment of ", stringify!(RelativeTimeline))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<RelativeTimeline>())).mRandomTimelineSeed as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(RelativeTimeline),
                    "::",
                    stringify!(mRandomTimelineSeed)
                )
            );
        }
        pub const Visibility_Untracked: root::mozilla::Visibility = 0;
        pub const Visibility_ApproximatelyNonVisible: root::mozilla::Visibility = 1;
        pub const Visibility_ApproximatelyVisible: root::mozilla::Visibility = 2;
        pub type Visibility = u8;
        pub const OnNonvisible_DiscardImages: root::mozilla::OnNonvisible = 0;
        pub type OnNonvisible = u8;
        pub type EventListenerHolder = root::mozilla::dom::CallbackObjectHolder;
        #[repr(C, packed)]
        #[derive(Debug, Copy, Clone)]
        pub struct EventListenerFlags {
            pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 1usize], u8>,
        }
        #[test]
        fn bindgen_test_layout_EventListenerFlags() {
            assert_eq!(
                ::std::mem::size_of::<EventListenerFlags>(),
                1usize,
                concat!("Size of: ", stringify!(EventListenerFlags))
            );
            assert_eq!(
                ::std::mem::align_of::<EventListenerFlags>(),
                1usize,
                concat!("Alignment of ", stringify!(EventListenerFlags))
            );
        }
        impl EventListenerFlags {
            #[inline]
            pub fn mListenerIsJSListener(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mListenerIsJSListener(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(0usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mCapture(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mCapture(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(1usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mInSystemGroup(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mInSystemGroup(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(2usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mAllowUntrustedEvents(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mAllowUntrustedEvents(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(3usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mPassive(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mPassive(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(4usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mOnce(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mOnce(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(5usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn new_bitfield_1(
                mListenerIsJSListener: bool,
                mCapture: bool,
                mInSystemGroup: bool,
                mAllowUntrustedEvents: bool,
                mPassive: bool,
                mOnce: bool,
            ) -> root::__BindgenBitfieldUnit<[u8; 1usize], u8> {
                let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 1usize], u8> =
                    Default::default();
                __bindgen_bitfield_unit.set(0usize, 1u8, {
                    let mListenerIsJSListener: u8 =
                        unsafe { ::std::mem::transmute(mListenerIsJSListener) };
                    mListenerIsJSListener as u64
                });
                __bindgen_bitfield_unit.set(1usize, 1u8, {
                    let mCapture: u8 = unsafe { ::std::mem::transmute(mCapture) };
                    mCapture as u64
                });
                __bindgen_bitfield_unit.set(2usize, 1u8, {
                    let mInSystemGroup: u8 = unsafe { ::std::mem::transmute(mInSystemGroup) };
                    mInSystemGroup as u64
                });
                __bindgen_bitfield_unit.set(3usize, 1u8, {
                    let mAllowUntrustedEvents: u8 =
                        unsafe { ::std::mem::transmute(mAllowUntrustedEvents) };
                    mAllowUntrustedEvents as u64
                });
                __bindgen_bitfield_unit.set(4usize, 1u8, {
                    let mPassive: u8 = unsafe { ::std::mem::transmute(mPassive) };
                    mPassive as u64
                });
                __bindgen_bitfield_unit.set(5usize, 1u8, {
                    let mOnce: u8 = unsafe { ::std::mem::transmute(mOnce) };
                    mOnce as u64
                });
                __bindgen_bitfield_unit
            }
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct EventListenerManagerBase {
            pub mNoListenerForEvent: root::mozilla::EventMessage,
            pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 2usize], u8>,
        }
        #[test]
        fn bindgen_test_layout_EventListenerManagerBase() {
            assert_eq!(
                ::std::mem::size_of::<EventListenerManagerBase>(),
                4usize,
                concat!("Size of: ", stringify!(EventListenerManagerBase))
            );
            assert_eq!(
                ::std::mem::align_of::<EventListenerManagerBase>(),
                2usize,
                concat!("Alignment of ", stringify!(EventListenerManagerBase))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<EventListenerManagerBase>())).mNoListenerForEvent
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(EventListenerManagerBase),
                    "::",
                    stringify!(mNoListenerForEvent)
                )
            );
        }
        impl EventListenerManagerBase {
            #[inline]
            pub fn mMayHavePaintEventListener(&self) -> u16 {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u16) }
            }
            #[inline]
            pub fn set_mMayHavePaintEventListener(&mut self, val: u16) {
                unsafe {
                    let val: u16 = ::std::mem::transmute(val);
                    self._bitfield_1.set(0usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mMayHaveMutationListeners(&self) -> u16 {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u16) }
            }
            #[inline]
            pub fn set_mMayHaveMutationListeners(&mut self, val: u16) {
                unsafe {
                    let val: u16 = ::std::mem::transmute(val);
                    self._bitfield_1.set(1usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mMayHaveCapturingListeners(&self) -> u16 {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u16) }
            }
            #[inline]
            pub fn set_mMayHaveCapturingListeners(&mut self, val: u16) {
                unsafe {
                    let val: u16 = ::std::mem::transmute(val);
                    self._bitfield_1.set(2usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mMayHaveSystemGroupListeners(&self) -> u16 {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u16) }
            }
            #[inline]
            pub fn set_mMayHaveSystemGroupListeners(&mut self, val: u16) {
                unsafe {
                    let val: u16 = ::std::mem::transmute(val);
                    self._bitfield_1.set(3usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mMayHaveTouchEventListener(&self) -> u16 {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u16) }
            }
            #[inline]
            pub fn set_mMayHaveTouchEventListener(&mut self, val: u16) {
                unsafe {
                    let val: u16 = ::std::mem::transmute(val);
                    self._bitfield_1.set(4usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mMayHaveMouseEnterLeaveEventListener(&self) -> u16 {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u16) }
            }
            #[inline]
            pub fn set_mMayHaveMouseEnterLeaveEventListener(&mut self, val: u16) {
                unsafe {
                    let val: u16 = ::std::mem::transmute(val);
                    self._bitfield_1.set(5usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mMayHavePointerEnterLeaveEventListener(&self) -> u16 {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u16) }
            }
            #[inline]
            pub fn set_mMayHavePointerEnterLeaveEventListener(&mut self, val: u16) {
                unsafe {
                    let val: u16 = ::std::mem::transmute(val);
                    self._bitfield_1.set(6usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mMayHaveKeyEventListener(&self) -> u16 {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u16) }
            }
            #[inline]
            pub fn set_mMayHaveKeyEventListener(&mut self, val: u16) {
                unsafe {
                    let val: u16 = ::std::mem::transmute(val);
                    self._bitfield_1.set(7usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mMayHaveInputOrCompositionEventListener(&self) -> u16 {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u16) }
            }
            #[inline]
            pub fn set_mMayHaveInputOrCompositionEventListener(&mut self, val: u16) {
                unsafe {
                    let val: u16 = ::std::mem::transmute(val);
                    self._bitfield_1.set(8usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mMayHaveSelectionChangeEventListener(&self) -> u16 {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(9usize, 1u8) as u16) }
            }
            #[inline]
            pub fn set_mMayHaveSelectionChangeEventListener(&mut self, val: u16) {
                unsafe {
                    let val: u16 = ::std::mem::transmute(val);
                    self._bitfield_1.set(9usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mClearingListeners(&self) -> u16 {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(10usize, 1u8) as u16) }
            }
            #[inline]
            pub fn set_mClearingListeners(&mut self, val: u16) {
                unsafe {
                    let val: u16 = ::std::mem::transmute(val);
                    self._bitfield_1.set(10usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsMainThreadELM(&self) -> u16 {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(11usize, 1u8) as u16) }
            }
            #[inline]
            pub fn set_mIsMainThreadELM(&mut self, val: u16) {
                unsafe {
                    let val: u16 = ::std::mem::transmute(val);
                    self._bitfield_1.set(11usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn new_bitfield_1(
                mMayHavePaintEventListener: u16,
                mMayHaveMutationListeners: u16,
                mMayHaveCapturingListeners: u16,
                mMayHaveSystemGroupListeners: u16,
                mMayHaveTouchEventListener: u16,
                mMayHaveMouseEnterLeaveEventListener: u16,
                mMayHavePointerEnterLeaveEventListener: u16,
                mMayHaveKeyEventListener: u16,
                mMayHaveInputOrCompositionEventListener: u16,
                mMayHaveSelectionChangeEventListener: u16,
                mClearingListeners: u16,
                mIsMainThreadELM: u16,
            ) -> root::__BindgenBitfieldUnit<[u8; 2usize], u8> {
                let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 2usize], u8> =
                    Default::default();
                __bindgen_bitfield_unit.set(0usize, 1u8, {
                    let mMayHavePaintEventListener: u16 =
                        unsafe { ::std::mem::transmute(mMayHavePaintEventListener) };
                    mMayHavePaintEventListener as u64
                });
                __bindgen_bitfield_unit.set(1usize, 1u8, {
                    let mMayHaveMutationListeners: u16 =
                        unsafe { ::std::mem::transmute(mMayHaveMutationListeners) };
                    mMayHaveMutationListeners as u64
                });
                __bindgen_bitfield_unit.set(2usize, 1u8, {
                    let mMayHaveCapturingListeners: u16 =
                        unsafe { ::std::mem::transmute(mMayHaveCapturingListeners) };
                    mMayHaveCapturingListeners as u64
                });
                __bindgen_bitfield_unit.set(3usize, 1u8, {
                    let mMayHaveSystemGroupListeners: u16 =
                        unsafe { ::std::mem::transmute(mMayHaveSystemGroupListeners) };
                    mMayHaveSystemGroupListeners as u64
                });
                __bindgen_bitfield_unit.set(4usize, 1u8, {
                    let mMayHaveTouchEventListener: u16 =
                        unsafe { ::std::mem::transmute(mMayHaveTouchEventListener) };
                    mMayHaveTouchEventListener as u64
                });
                __bindgen_bitfield_unit.set(5usize, 1u8, {
                    let mMayHaveMouseEnterLeaveEventListener: u16 =
                        unsafe { ::std::mem::transmute(mMayHaveMouseEnterLeaveEventListener) };
                    mMayHaveMouseEnterLeaveEventListener as u64
                });
                __bindgen_bitfield_unit.set(6usize, 1u8, {
                    let mMayHavePointerEnterLeaveEventListener: u16 =
                        unsafe { ::std::mem::transmute(mMayHavePointerEnterLeaveEventListener) };
                    mMayHavePointerEnterLeaveEventListener as u64
                });
                __bindgen_bitfield_unit.set(7usize, 1u8, {
                    let mMayHaveKeyEventListener: u16 =
                        unsafe { ::std::mem::transmute(mMayHaveKeyEventListener) };
                    mMayHaveKeyEventListener as u64
                });
                __bindgen_bitfield_unit.set(8usize, 1u8, {
                    let mMayHaveInputOrCompositionEventListener: u16 =
                        unsafe { ::std::mem::transmute(mMayHaveInputOrCompositionEventListener) };
                    mMayHaveInputOrCompositionEventListener as u64
                });
                __bindgen_bitfield_unit.set(9usize, 1u8, {
                    let mMayHaveSelectionChangeEventListener: u16 =
                        unsafe { ::std::mem::transmute(mMayHaveSelectionChangeEventListener) };
                    mMayHaveSelectionChangeEventListener as u64
                });
                __bindgen_bitfield_unit.set(10usize, 1u8, {
                    let mClearingListeners: u16 =
                        unsafe { ::std::mem::transmute(mClearingListeners) };
                    mClearingListeners as u64
                });
                __bindgen_bitfield_unit.set(11usize, 1u8, {
                    let mIsMainThreadELM: u16 = unsafe { ::std::mem::transmute(mIsMainThreadELM) };
                    mIsMainThreadELM as u64
                });
                __bindgen_bitfield_unit
            }
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct EventListenerManager {
            pub _base: root::mozilla::EventListenerManagerBase,
            pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
            pub mListeners: [u64; 9usize],
            pub mTarget: *mut root::mozilla::dom::EventTarget,
            pub mNoListenerForEventAtom: root::RefPtr<root::nsAtom>,
        }
        #[repr(C)]
        pub struct EventListenerManager_Listener {
            pub mListener: root::mozilla::EventListenerHolder,
            pub mTypeAtom: root::RefPtr<root::nsAtom>,
            pub mEventMessage: root::mozilla::EventMessage,
            pub mListenerType: root::mozilla::EventListenerManager_Listener_ListenerType,
            pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 1usize], u8>,
            pub mFlags: root::mozilla::EventListenerFlags,
        }
        pub const EventListenerManager_Listener_ListenerType_eNoListener:
            root::mozilla::EventListenerManager_Listener_ListenerType = 0;
        pub const EventListenerManager_Listener_ListenerType_eNativeListener:
            root::mozilla::EventListenerManager_Listener_ListenerType = 1;
        pub const EventListenerManager_Listener_ListenerType_eJSEventListener:
            root::mozilla::EventListenerManager_Listener_ListenerType = 2;
        pub const EventListenerManager_Listener_ListenerType_eWebIDLListener:
            root::mozilla::EventListenerManager_Listener_ListenerType = 3;
        pub type EventListenerManager_Listener_ListenerType = u8;
        #[test]
        fn bindgen_test_layout_EventListenerManager_Listener() {
            assert_eq!(
                ::std::mem::size_of::<EventListenerManager_Listener>(),
                24usize,
                concat!("Size of: ", stringify!(EventListenerManager_Listener))
            );
            assert_eq!(
                ::std::mem::align_of::<EventListenerManager_Listener>(),
                8usize,
                concat!("Alignment of ", stringify!(EventListenerManager_Listener))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<EventListenerManager_Listener>())).mListener as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(EventListenerManager_Listener),
                    "::",
                    stringify!(mListener)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<EventListenerManager_Listener>())).mTypeAtom as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(EventListenerManager_Listener),
                    "::",
                    stringify!(mTypeAtom)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<EventListenerManager_Listener>())).mEventMessage
                        as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(EventListenerManager_Listener),
                    "::",
                    stringify!(mEventMessage)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<EventListenerManager_Listener>())).mListenerType
                        as *const _ as usize
                },
                18usize,
                concat!(
                    "Offset of field: ",
                    stringify!(EventListenerManager_Listener),
                    "::",
                    stringify!(mListenerType)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<EventListenerManager_Listener>())).mFlags as *const _
                        as usize
                },
                20usize,
                concat!(
                    "Offset of field: ",
                    stringify!(EventListenerManager_Listener),
                    "::",
                    stringify!(mFlags)
                )
            );
        }
        impl EventListenerManager_Listener {
            #[inline]
            pub fn mListenerIsHandler(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mListenerIsHandler(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(0usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mHandlerIsString(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mHandlerIsString(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(1usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mAllEvents(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mAllEvents(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(2usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsChrome(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsChrome(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(3usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn new_bitfield_1(
                mListenerIsHandler: bool,
                mHandlerIsString: bool,
                mAllEvents: bool,
                mIsChrome: bool,
            ) -> root::__BindgenBitfieldUnit<[u8; 1usize], u8> {
                let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 1usize], u8> =
                    Default::default();
                __bindgen_bitfield_unit.set(0usize, 1u8, {
                    let mListenerIsHandler: u8 =
                        unsafe { ::std::mem::transmute(mListenerIsHandler) };
                    mListenerIsHandler as u64
                });
                __bindgen_bitfield_unit.set(1usize, 1u8, {
                    let mHandlerIsString: u8 = unsafe { ::std::mem::transmute(mHandlerIsString) };
                    mHandlerIsString as u64
                });
                __bindgen_bitfield_unit.set(2usize, 1u8, {
                    let mAllEvents: u8 = unsafe { ::std::mem::transmute(mAllEvents) };
                    mAllEvents as u64
                });
                __bindgen_bitfield_unit.set(3usize, 1u8, {
                    let mIsChrome: u8 = unsafe { ::std::mem::transmute(mIsChrome) };
                    mIsChrome as u64
                });
                __bindgen_bitfield_unit
            }
        }
        pub type EventListenerManager_HasThreadSafeRefCnt = root::mozilla::FalseType;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct EventListenerManager_cycleCollection {
            pub _base: root::nsCycleCollectionParticipant,
        }
        #[test]
        fn bindgen_test_layout_EventListenerManager_cycleCollection() {
            assert_eq!(
                ::std::mem::size_of::<EventListenerManager_cycleCollection>(),
                16usize,
                concat!(
                    "Size of: ",
                    stringify!(EventListenerManager_cycleCollection)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<EventListenerManager_cycleCollection>(),
                8usize,
                concat!(
                    "Alignment of ",
                    stringify!(EventListenerManager_cycleCollection)
                )
            );
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla20EventListenerManager21_cycleCollectorGlobalE"]
            pub static mut EventListenerManager__cycleCollectorGlobal:
                root::mozilla::EventListenerManager_cycleCollection;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla20EventListenerManager23sMainThreadCreatedCountE"]
            pub static mut EventListenerManager_sMainThreadCreatedCount: u32;
        }
        #[test]
        fn bindgen_test_layout_EventListenerManager() {
            assert_eq!(
                ::std::mem::size_of::<EventListenerManager>(),
                104usize,
                concat!("Size of: ", stringify!(EventListenerManager))
            );
            assert_eq!(
                ::std::mem::align_of::<EventListenerManager>(),
                8usize,
                concat!("Alignment of ", stringify!(EventListenerManager))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<EventListenerManager>())).mRefCnt as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(EventListenerManager),
                    "::",
                    stringify!(mRefCnt)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<EventListenerManager>())).mListeners as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(EventListenerManager),
                    "::",
                    stringify!(mListeners)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<EventListenerManager>())).mTarget as *const _ as usize
                },
                88usize,
                concat!(
                    "Offset of field: ",
                    stringify!(EventListenerManager),
                    "::",
                    stringify!(mTarget)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<EventListenerManager>())).mNoListenerForEventAtom
                        as *const _ as usize
                },
                96usize,
                concat!(
                    "Offset of field: ",
                    stringify!(EventListenerManager),
                    "::",
                    stringify!(mNoListenerForEventAtom)
                )
            );
        }
        #[repr(C)]
        pub struct DOMEventTargetHelper {
            pub _base: root::mozilla::dom::EventTarget,
            pub _base_1: root::mozilla::LinkedListElement,
            pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
            pub mListenerManager: root::RefPtr<root::mozilla::EventListenerManager>,
            pub mParentObject: *mut root::nsIGlobalObject,
            pub mOwnerWindow: *mut root::nsPIDOMWindowInner,
            pub mHasOrHasHadOwnerWindow: bool,
            pub mKeepingAliveTypes: root::mozilla::DOMEventTargetHelper__bindgen_ty_1,
            pub mIsKeptAlive: bool,
        }
        pub type DOMEventTargetHelper_HasThreadSafeRefCnt = root::mozilla::FalseType;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct DOMEventTargetHelper_cycleCollection {
            pub _base: root::nsXPCOMCycleCollectionParticipant,
        }
        #[test]
        fn bindgen_test_layout_DOMEventTargetHelper_cycleCollection() {
            assert_eq!(
                ::std::mem::size_of::<DOMEventTargetHelper_cycleCollection>(),
                16usize,
                concat!(
                    "Size of: ",
                    stringify!(DOMEventTargetHelper_cycleCollection)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<DOMEventTargetHelper_cycleCollection>(),
                8usize,
                concat!(
                    "Alignment of ",
                    stringify!(DOMEventTargetHelper_cycleCollection)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct DOMEventTargetHelper_COMTypeInfo {
            pub _address: u8,
        }
        #[repr(C)]
        pub struct DOMEventTargetHelper__bindgen_ty_1 {
            pub mStrings: root::nsTArray<::gecko_bindings::structs::nsString>,
            pub mAtoms: root::nsTArray<root::RefPtr<root::nsAtom>>,
        }
        #[test]
        fn bindgen_test_layout_DOMEventTargetHelper__bindgen_ty_1() {
            assert_eq!(
                ::std::mem::size_of::<DOMEventTargetHelper__bindgen_ty_1>(),
                16usize,
                concat!("Size of: ", stringify!(DOMEventTargetHelper__bindgen_ty_1))
            );
            assert_eq!(
                ::std::mem::align_of::<DOMEventTargetHelper__bindgen_ty_1>(),
                8usize,
                concat!(
                    "Alignment of ",
                    stringify!(DOMEventTargetHelper__bindgen_ty_1)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<DOMEventTargetHelper__bindgen_ty_1>())).mStrings
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DOMEventTargetHelper__bindgen_ty_1),
                    "::",
                    stringify!(mStrings)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<DOMEventTargetHelper__bindgen_ty_1>())).mAtoms
                        as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DOMEventTargetHelper__bindgen_ty_1),
                    "::",
                    stringify!(mAtoms)
                )
            );
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla20DOMEventTargetHelper21_cycleCollectorGlobalE"]
            pub static mut DOMEventTargetHelper__cycleCollectorGlobal:
                root::mozilla::DOMEventTargetHelper_cycleCollection;
        }
        #[test]
        fn bindgen_test_layout_DOMEventTargetHelper() {
            assert_eq!(
                ::std::mem::size_of::<DOMEventTargetHelper>(),
                120usize,
                concat!("Size of: ", stringify!(DOMEventTargetHelper))
            );
            assert_eq!(
                ::std::mem::align_of::<DOMEventTargetHelper>(),
                8usize,
                concat!("Alignment of ", stringify!(DOMEventTargetHelper))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<DOMEventTargetHelper>())).mRefCnt as *const _ as usize
                },
                56usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DOMEventTargetHelper),
                    "::",
                    stringify!(mRefCnt)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<DOMEventTargetHelper>())).mListenerManager as *const _
                        as usize
                },
                64usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DOMEventTargetHelper),
                    "::",
                    stringify!(mListenerManager)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<DOMEventTargetHelper>())).mParentObject as *const _
                        as usize
                },
                72usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DOMEventTargetHelper),
                    "::",
                    stringify!(mParentObject)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<DOMEventTargetHelper>())).mOwnerWindow as *const _
                        as usize
                },
                80usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DOMEventTargetHelper),
                    "::",
                    stringify!(mOwnerWindow)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<DOMEventTargetHelper>())).mHasOrHasHadOwnerWindow
                        as *const _ as usize
                },
                88usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DOMEventTargetHelper),
                    "::",
                    stringify!(mHasOrHasHadOwnerWindow)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<DOMEventTargetHelper>())).mKeepingAliveTypes as *const _
                        as usize
                },
                96usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DOMEventTargetHelper),
                    "::",
                    stringify!(mKeepingAliveTypes)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<DOMEventTargetHelper>())).mIsKeptAlive as *const _
                        as usize
                },
                112usize,
                concat!(
                    "Offset of field: ",
                    stringify!(DOMEventTargetHelper),
                    "::",
                    stringify!(mIsKeptAlive)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct VsyncIdType {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_VsyncIdType() {
            assert_eq!(
                ::std::mem::size_of::<VsyncIdType>(),
                1usize,
                concat!("Size of: ", stringify!(VsyncIdType))
            );
            assert_eq!(
                ::std::mem::align_of::<VsyncIdType>(),
                1usize,
                concat!("Alignment of ", stringify!(VsyncIdType))
            );
        }
        pub type VsyncId = root::mozilla::layers::BaseTransactionId;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct PendingFullscreenEvent {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct RefreshDriverTimer {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct AccessibleCaretEventHub {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct GeckoMVMContext {
            _unused: [u8; 0],
        }
        pub mod a11y {
            #[allow(unused_imports)]
            use self::super::super::super::root;
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct DocAccessible {
                _unused: [u8; 0],
            }
        }
        #[doc = " Presentation shell. Presentation shells are the controlling point for"]
        #[doc = " managing the presentation of a document.  The presentation shell holds a"]
        #[doc = " live reference to the document, the presentation context, the style"]
        #[doc = " manager, the style set and the root frame."]
        #[doc = ""]
        #[doc = " When this object is Release\'d, it will release the document, the"]
        #[doc = " presentation context, the style manager, the style set and the root frame."]
        #[repr(C)]
        pub struct PresShell {
            pub _base: root::nsStubDocumentObserver,
            pub _base_1: root::nsISelectionController,
            pub _base_2: root::nsIObserver,
            pub _base_3: root::nsSupportsWeakReference,
            pub mRefCnt: root::nsAutoRefCnt,
            pub mUpdateApproximateFrameVisibilityEvent: u64,
            pub mApproximatelyVisibleFrames: root::mozilla::PresShell_VisibleFrames,
            pub mDocument: root::RefPtr<root::mozilla::PresShell_Document>,
            pub mPresContext: root::RefPtr<root::nsPresContext>,
            pub mPrefStyleSheet: root::RefPtr<root::mozilla::StyleSheet>,
            pub mFrameConstructor: root::mozilla::UniquePtr<root::nsCSSFrameConstructor>,
            pub mViewManager: *mut root::nsViewManager,
            pub mSelection: root::RefPtr<root::nsFrameSelection>,
            pub mCaret: root::RefPtr<root::nsCaret>,
            pub mOriginalCaret: root::RefPtr<root::nsCaret>,
            pub mAccessibleCaretEventHub: root::RefPtr<root::mozilla::AccessibleCaretEventHub>,
            pub mFrameManager: *mut root::nsFrameManager,
            pub mForwardingContainer: u64,
            pub mLastReflowStart: root::DOMHighResTimeStamp,
            pub mReflowContinueTimer: root::nsCOMPtr,
            pub mAutoWeakFrames: *mut root::AutoWeakFrame,
            pub mWeakFrames: [u64; 4usize],
            pub mDirtyRoots: root::mozilla::PresShell_DirtyRootsList,
            pub mStyleCause: root::UniqueProfilerBacktrace,
            pub mReflowCause: root::UniqueProfilerBacktrace,
            pub mDelayedEvents:
                root::nsTArray<root::mozilla::UniquePtr<root::mozilla::PresShell_DelayedEvent>>,
            pub mSynthMouseMoveEvent:
                root::nsRevocableEventPtr<root::mozilla::PresShell_nsSynthMouseMoveEvent>,
            pub mTouchManager: root::mozilla::TouchManager,
            pub mZoomConstraintsClient: root::RefPtr<root::ZoomConstraintsClient>,
            pub mMVMContext: root::RefPtr<root::mozilla::GeckoMVMContext>,
            pub mMobileViewportManager: root::RefPtr<root::MobileViewportManager>,
            pub mPaintSuppressionTimer: root::nsCOMPtr,
            pub mDelayedPaintTimer: root::nsCOMPtr,
            pub mPointerEventTarget: root::nsCOMPtr,
            pub mLastAnchorScrolledTo: root::nsCOMPtr,
            pub mContentToScrollTo: root::nsCOMPtr,
            pub mDocAccessible: *mut root::mozilla::a11y::DocAccessible,
            pub mCurrentEventFrame: *mut root::nsIFrame,
            pub mCurrentEventContent: root::nsCOMPtr,
            pub mCurrentEventFrameStack: root::nsTArray<*mut root::nsIFrame>,
            pub mCurrentEventContentStack: root::nsCOMArray,
            pub mFramesToDirty: [u64; 4usize],
            pub mPendingScrollAnchorSelection: [u64; 4usize],
            pub mPendingScrollAnchorAdjustment: [u64; 4usize],
            pub mFirstCallbackEventRequest: *mut root::nsCallbackEventRequest,
            pub mLastCallbackEventRequest: *mut root::nsCallbackEventRequest,
            pub mMouseLocation: root::nsPoint,
            pub mMouseEventTargetGuid: root::mozilla::layers::ScrollableLayerGuid,
            pub mVisualViewportSize: root::nsSize,
            pub mAPZFocusTarget: root::mozilla::PresShell_FocusTarget,
            pub mFrameArena: [u64; 536usize],
            pub mVisualViewportOffset: [u32; 3usize],
            pub mPendingVisualScrollUpdate: [u32; 4usize],
            pub mResolution: [u32; 2usize],
            pub mLoadBegin: root::mozilla::TimeStamp,
            pub mLastOSWake: root::mozilla::TimeStamp,
            pub mPaintCount: u64,
            pub mAPZFocusSequenceNumber: u64,
            pub mLastAnchorScrollPositionY: root::nscoord,
            pub mCanvasBackgroundColor: root::nscolor,
            pub mActiveSuppressDisplayport: i32,
            pub mPresShellId: u32,
            pub mFontSizeInflationEmPerLine: u32,
            pub mFontSizeInflationMinTwips: u32,
            pub mFontSizeInflationLineThreshold: u32,
            pub mSelectionFlags: i16,
            pub mChangeNestCount: u16,
            pub mRenderingStateFlags: root::mozilla::RenderingStateFlags,
            pub mInFlush: bool,
            pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 6usize], u8>,
        }
        pub type PresShell_Document = root::mozilla::dom::Document;
        pub type PresShell_Element = root::mozilla::dom::Element;
        pub type PresShell_SourceSurface = root::mozilla::gfx::SourceSurface;
        pub type PresShell_FocusTarget = root::mozilla::layers::FocusTarget;
        pub type PresShell_FrameMetrics = root::mozilla::layers::FrameMetrics;
        pub type PresShell_LayerManager = root::mozilla::layers::LayerManager;
        pub type PresShell_VisibleFrames = [u64; 4usize];
        pub type PresShell_HasThreadSafeRefCnt = root::mozilla::FalseType;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct PresShell_COMTypeInfo {
            pub _address: u8,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct PresShell_VisualScrollUpdate {
            pub mVisualScrollOffset: root::nsPoint,
            pub mUpdateType: root::mozilla::layers::FrameMetrics_ScrollOffsetUpdateType,
            pub mAcknowledged: bool,
        }
        #[test]
        fn bindgen_test_layout_PresShell_VisualScrollUpdate() {
            assert_eq!(
                ::std::mem::size_of::<PresShell_VisualScrollUpdate>(),
                12usize,
                concat!("Size of: ", stringify!(PresShell_VisualScrollUpdate))
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell_VisualScrollUpdate>(),
                4usize,
                concat!("Alignment of ", stringify!(PresShell_VisualScrollUpdate))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_VisualScrollUpdate>())).mVisualScrollOffset
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_VisualScrollUpdate),
                    "::",
                    stringify!(mVisualScrollOffset)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_VisualScrollUpdate>())).mUpdateType as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_VisualScrollUpdate),
                    "::",
                    stringify!(mUpdateType)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_VisualScrollUpdate>())).mAcknowledged
                        as *const _ as usize
                },
                9usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_VisualScrollUpdate),
                    "::",
                    stringify!(mAcknowledged)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct PresShell_AutoAssertNoFlush {
            pub mPresShell: *mut root::mozilla::PresShell,
            pub mOldForbidden: bool,
        }
        #[test]
        fn bindgen_test_layout_PresShell_AutoAssertNoFlush() {
            assert_eq!(
                ::std::mem::size_of::<PresShell_AutoAssertNoFlush>(),
                16usize,
                concat!("Size of: ", stringify!(PresShell_AutoAssertNoFlush))
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell_AutoAssertNoFlush>(),
                8usize,
                concat!("Alignment of ", stringify!(PresShell_AutoAssertNoFlush))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_AutoAssertNoFlush>())).mPresShell as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_AutoAssertNoFlush),
                    "::",
                    stringify!(mPresShell)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_AutoAssertNoFlush>())).mOldForbidden
                        as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_AutoAssertNoFlush),
                    "::",
                    stringify!(mOldForbidden)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct PresShell_ScrollIntoViewData {
            pub mContentScrollVAxis: root::mozilla::ScrollAxis,
            pub mContentScrollHAxis: root::mozilla::ScrollAxis,
            pub mContentToScrollToFlags: root::mozilla::ScrollFlags,
        }
        #[test]
        fn bindgen_test_layout_PresShell_ScrollIntoViewData() {
            assert_eq!(
                ::std::mem::size_of::<PresShell_ScrollIntoViewData>(),
                12usize,
                concat!("Size of: ", stringify!(PresShell_ScrollIntoViewData))
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell_ScrollIntoViewData>(),
                4usize,
                concat!("Alignment of ", stringify!(PresShell_ScrollIntoViewData))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_ScrollIntoViewData>())).mContentScrollVAxis
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_ScrollIntoViewData),
                    "::",
                    stringify!(mContentScrollVAxis)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_ScrollIntoViewData>())).mContentScrollHAxis
                        as *const _ as usize
                },
                4usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_ScrollIntoViewData),
                    "::",
                    stringify!(mContentScrollHAxis)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_ScrollIntoViewData>())).mContentToScrollToFlags
                        as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_ScrollIntoViewData),
                    "::",
                    stringify!(mContentToScrollToFlags)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct PresShell_RenderingState {
            pub mResolution: [u32; 2usize],
            pub mRenderingStateFlags: root::mozilla::RenderingStateFlags,
        }
        #[test]
        fn bindgen_test_layout_PresShell_RenderingState() {
            assert_eq!(
                ::std::mem::size_of::<PresShell_RenderingState>(),
                12usize,
                concat!("Size of: ", stringify!(PresShell_RenderingState))
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell_RenderingState>(),
                4usize,
                concat!("Alignment of ", stringify!(PresShell_RenderingState))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_RenderingState>())).mResolution as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_RenderingState),
                    "::",
                    stringify!(mResolution)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_RenderingState>())).mRenderingStateFlags
                        as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_RenderingState),
                    "::",
                    stringify!(mRenderingStateFlags)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct PresShell_AutoSaveRestoreRenderingState {
            pub mPresShell: *mut root::mozilla::PresShell,
            pub mOldState: root::mozilla::PresShell_RenderingState,
        }
        #[test]
        fn bindgen_test_layout_PresShell_AutoSaveRestoreRenderingState() {
            assert_eq!(
                ::std::mem::size_of::<PresShell_AutoSaveRestoreRenderingState>(),
                24usize,
                concat!(
                    "Size of: ",
                    stringify!(PresShell_AutoSaveRestoreRenderingState)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell_AutoSaveRestoreRenderingState>(),
                8usize,
                concat!(
                    "Alignment of ",
                    stringify!(PresShell_AutoSaveRestoreRenderingState)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_AutoSaveRestoreRenderingState>())).mPresShell
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_AutoSaveRestoreRenderingState),
                    "::",
                    stringify!(mPresShell)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_AutoSaveRestoreRenderingState>())).mOldState
                        as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_AutoSaveRestoreRenderingState),
                    "::",
                    stringify!(mOldState)
                )
            );
        }
        #[repr(C)]
        pub struct PresShell_DelayedEvent__bindgen_vtable(::std::os::raw::c_void);
        #[repr(C)]
        #[derive(Debug)]
        pub struct PresShell_DelayedEvent {
            pub vtable_: *const PresShell_DelayedEvent__bindgen_vtable,
        }
        #[test]
        fn bindgen_test_layout_PresShell_DelayedEvent() {
            assert_eq!(
                ::std::mem::size_of::<PresShell_DelayedEvent>(),
                8usize,
                concat!("Size of: ", stringify!(PresShell_DelayedEvent))
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell_DelayedEvent>(),
                8usize,
                concat!("Alignment of ", stringify!(PresShell_DelayedEvent))
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct PresShell_DelayedInputEvent {
            pub _base: root::mozilla::PresShell_DelayedEvent,
            pub mEvent: *mut root::mozilla::WidgetInputEvent,
        }
        #[test]
        fn bindgen_test_layout_PresShell_DelayedInputEvent() {
            assert_eq!(
                ::std::mem::size_of::<PresShell_DelayedInputEvent>(),
                16usize,
                concat!("Size of: ", stringify!(PresShell_DelayedInputEvent))
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell_DelayedInputEvent>(),
                8usize,
                concat!("Alignment of ", stringify!(PresShell_DelayedInputEvent))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_DelayedInputEvent>())).mEvent as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_DelayedInputEvent),
                    "::",
                    stringify!(mEvent)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct PresShell_DelayedMouseEvent {
            pub _base: root::mozilla::PresShell_DelayedInputEvent,
        }
        #[test]
        fn bindgen_test_layout_PresShell_DelayedMouseEvent() {
            assert_eq!(
                ::std::mem::size_of::<PresShell_DelayedMouseEvent>(),
                16usize,
                concat!("Size of: ", stringify!(PresShell_DelayedMouseEvent))
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell_DelayedMouseEvent>(),
                8usize,
                concat!("Alignment of ", stringify!(PresShell_DelayedMouseEvent))
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct PresShell_DelayedKeyEvent {
            pub _base: root::mozilla::PresShell_DelayedInputEvent,
        }
        #[test]
        fn bindgen_test_layout_PresShell_DelayedKeyEvent() {
            assert_eq!(
                ::std::mem::size_of::<PresShell_DelayedKeyEvent>(),
                16usize,
                concat!("Size of: ", stringify!(PresShell_DelayedKeyEvent))
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell_DelayedKeyEvent>(),
                8usize,
                concat!("Alignment of ", stringify!(PresShell_DelayedKeyEvent))
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct PresShell_nsSynthMouseMoveEvent {
            pub _base: root::nsARefreshObserver,
            pub mRefCnt: root::nsAutoRefCnt,
            pub mPresShell: *mut root::mozilla::PresShell,
            pub mFromScroll: bool,
        }
        pub type PresShell_nsSynthMouseMoveEvent_HasThreadSafeRefCnt = root::mozilla::FalseType;
        #[test]
        fn bindgen_test_layout_PresShell_nsSynthMouseMoveEvent() {
            assert_eq!(
                ::std::mem::size_of::<PresShell_nsSynthMouseMoveEvent>(),
                32usize,
                concat!("Size of: ", stringify!(PresShell_nsSynthMouseMoveEvent))
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell_nsSynthMouseMoveEvent>(),
                8usize,
                concat!("Alignment of ", stringify!(PresShell_nsSynthMouseMoveEvent))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_nsSynthMouseMoveEvent>())).mRefCnt as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_nsSynthMouseMoveEvent),
                    "::",
                    stringify!(mRefCnt)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_nsSynthMouseMoveEvent>())).mPresShell
                        as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_nsSynthMouseMoveEvent),
                    "::",
                    stringify!(mPresShell)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_nsSynthMouseMoveEvent>())).mFromScroll
                        as *const _ as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_nsSynthMouseMoveEvent),
                    "::",
                    stringify!(mFromScroll)
                )
            );
        }
        #[doc = " EventHandler is implementation of PresShell::HandleEvent()."]
        #[repr(C)]
        pub struct PresShell_EventHandler {
            pub mPresShell: root::mozilla::OwningNonNull<root::mozilla::PresShell>,
            pub mCurrentEventInfoSetter:
                *mut root::mozilla::PresShell_EventHandler_AutoCurrentEventInfoSetter,
        }
        #[doc = " EventTargetData struct stores a set of a PresShell (event handler),"]
        #[doc = " a frame (to handle the event) and a content (event target for the frame)."]
        #[repr(C)]
        pub struct PresShell_EventHandler_EventTargetData {
            pub mPresShell: root::RefPtr<root::mozilla::PresShell>,
            pub mFrame: *mut root::nsIFrame,
            pub mContent: root::nsCOMPtr,
            pub mOverrideClickTarget: root::nsCOMPtr,
        }
        #[test]
        fn bindgen_test_layout_PresShell_EventHandler_EventTargetData() {
            assert_eq!(
                ::std::mem::size_of::<PresShell_EventHandler_EventTargetData>(),
                32usize,
                concat!(
                    "Size of: ",
                    stringify!(PresShell_EventHandler_EventTargetData)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell_EventHandler_EventTargetData>(),
                8usize,
                concat!(
                    "Alignment of ",
                    stringify!(PresShell_EventHandler_EventTargetData)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_EventHandler_EventTargetData>())).mPresShell
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_EventHandler_EventTargetData),
                    "::",
                    stringify!(mPresShell)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_EventHandler_EventTargetData>())).mFrame
                        as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_EventHandler_EventTargetData),
                    "::",
                    stringify!(mFrame)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_EventHandler_EventTargetData>())).mContent
                        as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_EventHandler_EventTargetData),
                    "::",
                    stringify!(mContent)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_EventHandler_EventTargetData>()))
                        .mOverrideClickTarget as *const _ as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_EventHandler_EventTargetData),
                    "::",
                    stringify!(mOverrideClickTarget)
                )
            );
        }
        #[doc = " HandlingTimeAccumulator() may accumulate handling time of telemetry"]
        #[doc = " for each type of events."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct PresShell_EventHandler_HandlingTimeAccumulator {
            pub mEventHandler: *const root::mozilla::PresShell_EventHandler,
            pub mEvent: *const root::mozilla::WidgetEvent,
            pub mHandlingStartTime: root::mozilla::TimeStamp,
        }
        #[test]
        fn bindgen_test_layout_PresShell_EventHandler_HandlingTimeAccumulator() {
            assert_eq!(
                ::std::mem::size_of::<PresShell_EventHandler_HandlingTimeAccumulator>(),
                24usize,
                concat!(
                    "Size of: ",
                    stringify!(PresShell_EventHandler_HandlingTimeAccumulator)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell_EventHandler_HandlingTimeAccumulator>(),
                8usize,
                concat!(
                    "Alignment of ",
                    stringify!(PresShell_EventHandler_HandlingTimeAccumulator)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_EventHandler_HandlingTimeAccumulator>()))
                        .mEventHandler as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_EventHandler_HandlingTimeAccumulator),
                    "::",
                    stringify!(mEventHandler)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_EventHandler_HandlingTimeAccumulator>()))
                        .mEvent as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_EventHandler_HandlingTimeAccumulator),
                    "::",
                    stringify!(mEvent)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_EventHandler_HandlingTimeAccumulator>()))
                        .mHandlingStartTime as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_EventHandler_HandlingTimeAccumulator),
                    "::",
                    stringify!(mHandlingStartTime)
                )
            );
        }
        #[doc = " AutoCurrentEventInfoSetter() pushes and pops current event info of"]
        #[doc = " aEventHandler.mPresShell."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct PresShell_EventHandler_AutoCurrentEventInfoSetter {
            pub mEventHandler: *mut root::mozilla::PresShell_EventHandler,
        }
        #[test]
        fn bindgen_test_layout_PresShell_EventHandler_AutoCurrentEventInfoSetter() {
            assert_eq!(
                ::std::mem::size_of::<PresShell_EventHandler_AutoCurrentEventInfoSetter>(),
                8usize,
                concat!(
                    "Size of: ",
                    stringify!(PresShell_EventHandler_AutoCurrentEventInfoSetter)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell_EventHandler_AutoCurrentEventInfoSetter>(),
                8usize,
                concat!(
                    "Alignment of ",
                    stringify!(PresShell_EventHandler_AutoCurrentEventInfoSetter)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_EventHandler_AutoCurrentEventInfoSetter>()))
                        .mEventHandler as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_EventHandler_AutoCurrentEventInfoSetter),
                    "::",
                    stringify!(mEventHandler)
                )
            );
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla9PresShell12EventHandler17sLastInputCreatedE"]
            pub static mut PresShell_EventHandler_sLastInputCreated: root::mozilla::TimeStamp;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla9PresShell12EventHandler19sLastInputProcessedE"]
            pub static mut PresShell_EventHandler_sLastInputProcessed: root::mozilla::TimeStamp;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla9PresShell12EventHandler30sLastKeyDownEventTargetElementE"]
            pub static mut PresShell_EventHandler_sLastKeyDownEventTargetElement:
                root::mozilla::StaticRefPtr<root::mozilla::dom::Element>;
        }
        #[test]
        fn bindgen_test_layout_PresShell_EventHandler() {
            assert_eq!(
                ::std::mem::size_of::<PresShell_EventHandler>(),
                16usize,
                concat!("Size of: ", stringify!(PresShell_EventHandler))
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell_EventHandler>(),
                8usize,
                concat!("Alignment of ", stringify!(PresShell_EventHandler))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_EventHandler>())).mPresShell as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_EventHandler),
                    "::",
                    stringify!(mPresShell)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_EventHandler>())).mCurrentEventInfoSetter
                        as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_EventHandler),
                    "::",
                    stringify!(mCurrentEventInfoSetter)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct PresShell_DirtyRootsList {
            pub mList: root::nsTArray<root::mozilla::PresShell_DirtyRootsList_FrameAndDepth>,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct PresShell_DirtyRootsList_FrameAndDepth {
            pub mFrame: *mut root::nsIFrame,
            pub mDepth: u32,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct PresShell_DirtyRootsList_FrameAndDepth_CompareByReverseDepth {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_PresShell_DirtyRootsList_FrameAndDepth_CompareByReverseDepth() {
            assert_eq!(
                ::std::mem::size_of::<PresShell_DirtyRootsList_FrameAndDepth_CompareByReverseDepth>(
                ),
                1usize,
                concat!(
                    "Size of: ",
                    stringify!(PresShell_DirtyRootsList_FrameAndDepth_CompareByReverseDepth)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell_DirtyRootsList_FrameAndDepth_CompareByReverseDepth>(
                ),
                1usize,
                concat!(
                    "Alignment of ",
                    stringify!(PresShell_DirtyRootsList_FrameAndDepth_CompareByReverseDepth)
                )
            );
        }
        #[test]
        fn bindgen_test_layout_PresShell_DirtyRootsList_FrameAndDepth() {
            assert_eq!(
                ::std::mem::size_of::<PresShell_DirtyRootsList_FrameAndDepth>(),
                16usize,
                concat!(
                    "Size of: ",
                    stringify!(PresShell_DirtyRootsList_FrameAndDepth)
                )
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell_DirtyRootsList_FrameAndDepth>(),
                8usize,
                concat!(
                    "Alignment of ",
                    stringify!(PresShell_DirtyRootsList_FrameAndDepth)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_DirtyRootsList_FrameAndDepth>())).mFrame
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_DirtyRootsList_FrameAndDepth),
                    "::",
                    stringify!(mFrame)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_DirtyRootsList_FrameAndDepth>())).mDepth
                        as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_DirtyRootsList_FrameAndDepth),
                    "::",
                    stringify!(mDepth)
                )
            );
        }
        #[test]
        fn bindgen_test_layout_PresShell_DirtyRootsList() {
            assert_eq!(
                ::std::mem::size_of::<PresShell_DirtyRootsList>(),
                8usize,
                concat!("Size of: ", stringify!(PresShell_DirtyRootsList))
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell_DirtyRootsList>(),
                8usize,
                concat!("Alignment of ", stringify!(PresShell_DirtyRootsList))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_DirtyRootsList>())).mList as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_DirtyRootsList),
                    "::",
                    stringify!(mList)
                )
            );
        }
        #[repr(C)]
        pub struct PresShell_CapturingContentInfo {
            pub mContent: root::mozilla::StaticRefPtr<root::nsIContent>,
            pub mAllowed: bool,
            pub mPointerLock: bool,
            pub mRetargetToElement: bool,
            pub mPreventDrag: bool,
        }
        #[test]
        fn bindgen_test_layout_PresShell_CapturingContentInfo() {
            assert_eq!(
                ::std::mem::size_of::<PresShell_CapturingContentInfo>(),
                16usize,
                concat!("Size of: ", stringify!(PresShell_CapturingContentInfo))
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell_CapturingContentInfo>(),
                8usize,
                concat!("Alignment of ", stringify!(PresShell_CapturingContentInfo))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_CapturingContentInfo>())).mContent as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_CapturingContentInfo),
                    "::",
                    stringify!(mContent)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_CapturingContentInfo>())).mAllowed as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_CapturingContentInfo),
                    "::",
                    stringify!(mAllowed)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_CapturingContentInfo>())).mPointerLock
                        as *const _ as usize
                },
                9usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_CapturingContentInfo),
                    "::",
                    stringify!(mPointerLock)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_CapturingContentInfo>())).mRetargetToElement
                        as *const _ as usize
                },
                10usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_CapturingContentInfo),
                    "::",
                    stringify!(mRetargetToElement)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PresShell_CapturingContentInfo>())).mPreventDrag
                        as *const _ as usize
                },
                11usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PresShell_CapturingContentInfo),
                    "::",
                    stringify!(mPreventDrag)
                )
            );
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla9PresShell4gLogE"]
            pub static mut PresShell_gLog: root::mozilla::LazyLogModule;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla9PresShell21sCapturingContentInfoE"]
            pub static mut PresShell_sCapturingContentInfo:
                root::mozilla::PresShell_CapturingContentInfo;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla9PresShell26sDisableNonTestMouseEventsE"]
            pub static mut PresShell_sDisableNonTestMouseEvents: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla9PresShell20sProcessInteractableE"]
            pub static mut PresShell_sProcessInteractable: bool;
        }
        #[test]
        fn bindgen_test_layout_PresShell() {
            assert_eq!(
                ::std::mem::size_of::<PresShell>(),
                5000usize,
                concat!("Size of: ", stringify!(PresShell))
            );
            assert_eq!(
                ::std::mem::align_of::<PresShell>(),
                8usize,
                concat!("Alignment of ", stringify!(PresShell))
            );
        }
        impl PresShell {
            #[inline]
            pub fn mCaretEnabled(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mCaretEnabled(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(0usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mNeedLayoutFlush(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mNeedLayoutFlush(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(1usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mNeedStyleFlush(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mNeedStyleFlush(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(2usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mNeedThrottledAnimationFlush(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mNeedThrottledAnimationFlush(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(3usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mVisualViewportSizeSet(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mVisualViewportSizeSet(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(4usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mDidInitialize(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mDidInitialize(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(5usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsDestroying(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsDestroying(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(6usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsReflowing(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsReflowing(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(7usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsObservingDocument(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsObservingDocument(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(8usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mForbiddenToFlush(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(9usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mForbiddenToFlush(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(9usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsDocumentGone(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(10usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsDocumentGone(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(10usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mHaveShutDown(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(11usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mHaveShutDown(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(11usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mPaintingSuppressed(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(12usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mPaintingSuppressed(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(12usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mLastRootReflowHadUnconstrainedBSize(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(13usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mLastRootReflowHadUnconstrainedBSize(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(13usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mShouldUnsuppressPainting(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(14usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mShouldUnsuppressPainting(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(14usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIgnoreFrameDestruction(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(15usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIgnoreFrameDestruction(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(15usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsActive(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(16usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsActive(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(16usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mFrozen(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(17usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mFrozen(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(17usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsFirstPaint(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(18usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsFirstPaint(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(18usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mObservesMutationsForPrint(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(19usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mObservesMutationsForPrint(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(19usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mWasLastReflowInterrupted(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(20usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mWasLastReflowInterrupted(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(20usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mObservingStyleFlushes(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(21usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mObservingStyleFlushes(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(21usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mObservingLayoutFlushes(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(22usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mObservingLayoutFlushes(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(22usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mResizeEventPending(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(23usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mResizeEventPending(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(23usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mFontSizeInflationForceEnabled(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(24usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mFontSizeInflationForceEnabled(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(24usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mFontSizeInflationDisabledInMasterProcess(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(25usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mFontSizeInflationDisabledInMasterProcess(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(25usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mFontSizeInflationEnabled(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(26usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mFontSizeInflationEnabled(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(26usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mPaintingIsFrozen(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(27usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mPaintingIsFrozen(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(27usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsNeverPainting(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(28usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsNeverPainting(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(28usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mResolutionUpdated(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(29usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mResolutionUpdated(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(29usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mResolutionUpdatedByApz(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(30usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mResolutionUpdatedByApz(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(30usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mUnderHiddenEmbedderElement(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(31usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mUnderHiddenEmbedderElement(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(31usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mDocumentLoading(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(32usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mDocumentLoading(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(32usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mNoDelayedMouseEvents(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(33usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mNoDelayedMouseEvents(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(33usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mNoDelayedKeyEvents(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(34usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mNoDelayedKeyEvents(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(34usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mApproximateFrameVisibilityVisited(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(35usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mApproximateFrameVisibilityVisited(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(35usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mNextPaintCompressed(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(36usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mNextPaintCompressed(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(36usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mHasCSSBackgroundColor(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(37usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mHasCSSBackgroundColor(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(37usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsLastChromeOnlyEscapeKeyConsumed(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(38usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsLastChromeOnlyEscapeKeyConsumed(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(38usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mHasReceivedPaintMessage(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(39usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mHasReceivedPaintMessage(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(39usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsLastKeyDownCanceled(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(40usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsLastKeyDownCanceled(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(40usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mHasHandledUserInput(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(41usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mHasHandledUserInput(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(41usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mForceDispatchKeyPressEventsForNonPrintableKeys(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(42usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mForceDispatchKeyPressEventsForNonPrintableKeys(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(42usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mForceUseLegacyKeyCodeAndCharCodeValues(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(43usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mForceUseLegacyKeyCodeAndCharCodeValues(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(43usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mInitializedWithKeyPressEventDispatchingBlacklist(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(44usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mInitializedWithKeyPressEventDispatchingBlacklist(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(44usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mForceUseLegacyNonPrimaryDispatch(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(45usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mForceUseLegacyNonPrimaryDispatch(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(45usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mInitializedWithClickEventDispatchingBlacklist(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(46usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mInitializedWithClickEventDispatchingBlacklist(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(46usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn new_bitfield_1(
                mCaretEnabled: bool,
                mNeedLayoutFlush: bool,
                mNeedStyleFlush: bool,
                mNeedThrottledAnimationFlush: bool,
                mVisualViewportSizeSet: bool,
                mDidInitialize: bool,
                mIsDestroying: bool,
                mIsReflowing: bool,
                mIsObservingDocument: bool,
                mForbiddenToFlush: bool,
                mIsDocumentGone: bool,
                mHaveShutDown: bool,
                mPaintingSuppressed: bool,
                mLastRootReflowHadUnconstrainedBSize: bool,
                mShouldUnsuppressPainting: bool,
                mIgnoreFrameDestruction: bool,
                mIsActive: bool,
                mFrozen: bool,
                mIsFirstPaint: bool,
                mObservesMutationsForPrint: bool,
                mWasLastReflowInterrupted: bool,
                mObservingStyleFlushes: bool,
                mObservingLayoutFlushes: bool,
                mResizeEventPending: bool,
                mFontSizeInflationForceEnabled: bool,
                mFontSizeInflationDisabledInMasterProcess: bool,
                mFontSizeInflationEnabled: bool,
                mPaintingIsFrozen: bool,
                mIsNeverPainting: bool,
                mResolutionUpdated: bool,
                mResolutionUpdatedByApz: bool,
                mUnderHiddenEmbedderElement: bool,
                mDocumentLoading: bool,
                mNoDelayedMouseEvents: bool,
                mNoDelayedKeyEvents: bool,
                mApproximateFrameVisibilityVisited: bool,
                mNextPaintCompressed: bool,
                mHasCSSBackgroundColor: bool,
                mIsLastChromeOnlyEscapeKeyConsumed: bool,
                mHasReceivedPaintMessage: bool,
                mIsLastKeyDownCanceled: bool,
                mHasHandledUserInput: bool,
                mForceDispatchKeyPressEventsForNonPrintableKeys: bool,
                mForceUseLegacyKeyCodeAndCharCodeValues: bool,
                mInitializedWithKeyPressEventDispatchingBlacklist: bool,
                mForceUseLegacyNonPrimaryDispatch: bool,
                mInitializedWithClickEventDispatchingBlacklist: bool,
            ) -> root::__BindgenBitfieldUnit<[u8; 6usize], u8> {
                let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 6usize], u8> =
                    Default::default();
                __bindgen_bitfield_unit.set(0usize, 1u8, {
                    let mCaretEnabled: u8 = unsafe { ::std::mem::transmute(mCaretEnabled) };
                    mCaretEnabled as u64
                });
                __bindgen_bitfield_unit.set(1usize, 1u8, {
                    let mNeedLayoutFlush: u8 = unsafe { ::std::mem::transmute(mNeedLayoutFlush) };
                    mNeedLayoutFlush as u64
                });
                __bindgen_bitfield_unit.set(2usize, 1u8, {
                    let mNeedStyleFlush: u8 = unsafe { ::std::mem::transmute(mNeedStyleFlush) };
                    mNeedStyleFlush as u64
                });
                __bindgen_bitfield_unit.set(3usize, 1u8, {
                    let mNeedThrottledAnimationFlush: u8 =
                        unsafe { ::std::mem::transmute(mNeedThrottledAnimationFlush) };
                    mNeedThrottledAnimationFlush as u64
                });
                __bindgen_bitfield_unit.set(4usize, 1u8, {
                    let mVisualViewportSizeSet: u8 =
                        unsafe { ::std::mem::transmute(mVisualViewportSizeSet) };
                    mVisualViewportSizeSet as u64
                });
                __bindgen_bitfield_unit.set(5usize, 1u8, {
                    let mDidInitialize: u8 = unsafe { ::std::mem::transmute(mDidInitialize) };
                    mDidInitialize as u64
                });
                __bindgen_bitfield_unit.set(6usize, 1u8, {
                    let mIsDestroying: u8 = unsafe { ::std::mem::transmute(mIsDestroying) };
                    mIsDestroying as u64
                });
                __bindgen_bitfield_unit.set(7usize, 1u8, {
                    let mIsReflowing: u8 = unsafe { ::std::mem::transmute(mIsReflowing) };
                    mIsReflowing as u64
                });
                __bindgen_bitfield_unit.set(8usize, 1u8, {
                    let mIsObservingDocument: u8 =
                        unsafe { ::std::mem::transmute(mIsObservingDocument) };
                    mIsObservingDocument as u64
                });
                __bindgen_bitfield_unit.set(9usize, 1u8, {
                    let mForbiddenToFlush: u8 = unsafe { ::std::mem::transmute(mForbiddenToFlush) };
                    mForbiddenToFlush as u64
                });
                __bindgen_bitfield_unit.set(10usize, 1u8, {
                    let mIsDocumentGone: u8 = unsafe { ::std::mem::transmute(mIsDocumentGone) };
                    mIsDocumentGone as u64
                });
                __bindgen_bitfield_unit.set(11usize, 1u8, {
                    let mHaveShutDown: u8 = unsafe { ::std::mem::transmute(mHaveShutDown) };
                    mHaveShutDown as u64
                });
                __bindgen_bitfield_unit.set(12usize, 1u8, {
                    let mPaintingSuppressed: u8 =
                        unsafe { ::std::mem::transmute(mPaintingSuppressed) };
                    mPaintingSuppressed as u64
                });
                __bindgen_bitfield_unit.set(13usize, 1u8, {
                    let mLastRootReflowHadUnconstrainedBSize: u8 =
                        unsafe { ::std::mem::transmute(mLastRootReflowHadUnconstrainedBSize) };
                    mLastRootReflowHadUnconstrainedBSize as u64
                });
                __bindgen_bitfield_unit.set(14usize, 1u8, {
                    let mShouldUnsuppressPainting: u8 =
                        unsafe { ::std::mem::transmute(mShouldUnsuppressPainting) };
                    mShouldUnsuppressPainting as u64
                });
                __bindgen_bitfield_unit.set(15usize, 1u8, {
                    let mIgnoreFrameDestruction: u8 =
                        unsafe { ::std::mem::transmute(mIgnoreFrameDestruction) };
                    mIgnoreFrameDestruction as u64
                });
                __bindgen_bitfield_unit.set(16usize, 1u8, {
                    let mIsActive: u8 = unsafe { ::std::mem::transmute(mIsActive) };
                    mIsActive as u64
                });
                __bindgen_bitfield_unit.set(17usize, 1u8, {
                    let mFrozen: u8 = unsafe { ::std::mem::transmute(mFrozen) };
                    mFrozen as u64
                });
                __bindgen_bitfield_unit.set(18usize, 1u8, {
                    let mIsFirstPaint: u8 = unsafe { ::std::mem::transmute(mIsFirstPaint) };
                    mIsFirstPaint as u64
                });
                __bindgen_bitfield_unit.set(19usize, 1u8, {
                    let mObservesMutationsForPrint: u8 =
                        unsafe { ::std::mem::transmute(mObservesMutationsForPrint) };
                    mObservesMutationsForPrint as u64
                });
                __bindgen_bitfield_unit.set(20usize, 1u8, {
                    let mWasLastReflowInterrupted: u8 =
                        unsafe { ::std::mem::transmute(mWasLastReflowInterrupted) };
                    mWasLastReflowInterrupted as u64
                });
                __bindgen_bitfield_unit.set(21usize, 1u8, {
                    let mObservingStyleFlushes: u8 =
                        unsafe { ::std::mem::transmute(mObservingStyleFlushes) };
                    mObservingStyleFlushes as u64
                });
                __bindgen_bitfield_unit.set(22usize, 1u8, {
                    let mObservingLayoutFlushes: u8 =
                        unsafe { ::std::mem::transmute(mObservingLayoutFlushes) };
                    mObservingLayoutFlushes as u64
                });
                __bindgen_bitfield_unit.set(23usize, 1u8, {
                    let mResizeEventPending: u8 =
                        unsafe { ::std::mem::transmute(mResizeEventPending) };
                    mResizeEventPending as u64
                });
                __bindgen_bitfield_unit.set(24usize, 1u8, {
                    let mFontSizeInflationForceEnabled: u8 =
                        unsafe { ::std::mem::transmute(mFontSizeInflationForceEnabled) };
                    mFontSizeInflationForceEnabled as u64
                });
                __bindgen_bitfield_unit.set(25usize, 1u8, {
                    let mFontSizeInflationDisabledInMasterProcess: u8 =
                        unsafe { ::std::mem::transmute(mFontSizeInflationDisabledInMasterProcess) };
                    mFontSizeInflationDisabledInMasterProcess as u64
                });
                __bindgen_bitfield_unit.set(26usize, 1u8, {
                    let mFontSizeInflationEnabled: u8 =
                        unsafe { ::std::mem::transmute(mFontSizeInflationEnabled) };
                    mFontSizeInflationEnabled as u64
                });
                __bindgen_bitfield_unit.set(27usize, 1u8, {
                    let mPaintingIsFrozen: u8 = unsafe { ::std::mem::transmute(mPaintingIsFrozen) };
                    mPaintingIsFrozen as u64
                });
                __bindgen_bitfield_unit.set(28usize, 1u8, {
                    let mIsNeverPainting: u8 = unsafe { ::std::mem::transmute(mIsNeverPainting) };
                    mIsNeverPainting as u64
                });
                __bindgen_bitfield_unit.set(29usize, 1u8, {
                    let mResolutionUpdated: u8 =
                        unsafe { ::std::mem::transmute(mResolutionUpdated) };
                    mResolutionUpdated as u64
                });
                __bindgen_bitfield_unit.set(30usize, 1u8, {
                    let mResolutionUpdatedByApz: u8 =
                        unsafe { ::std::mem::transmute(mResolutionUpdatedByApz) };
                    mResolutionUpdatedByApz as u64
                });
                __bindgen_bitfield_unit.set(31usize, 1u8, {
                    let mUnderHiddenEmbedderElement: u8 =
                        unsafe { ::std::mem::transmute(mUnderHiddenEmbedderElement) };
                    mUnderHiddenEmbedderElement as u64
                });
                __bindgen_bitfield_unit.set(32usize, 1u8, {
                    let mDocumentLoading: u8 = unsafe { ::std::mem::transmute(mDocumentLoading) };
                    mDocumentLoading as u64
                });
                __bindgen_bitfield_unit.set(33usize, 1u8, {
                    let mNoDelayedMouseEvents: u8 =
                        unsafe { ::std::mem::transmute(mNoDelayedMouseEvents) };
                    mNoDelayedMouseEvents as u64
                });
                __bindgen_bitfield_unit.set(34usize, 1u8, {
                    let mNoDelayedKeyEvents: u8 =
                        unsafe { ::std::mem::transmute(mNoDelayedKeyEvents) };
                    mNoDelayedKeyEvents as u64
                });
                __bindgen_bitfield_unit.set(35usize, 1u8, {
                    let mApproximateFrameVisibilityVisited: u8 =
                        unsafe { ::std::mem::transmute(mApproximateFrameVisibilityVisited) };
                    mApproximateFrameVisibilityVisited as u64
                });
                __bindgen_bitfield_unit.set(36usize, 1u8, {
                    let mNextPaintCompressed: u8 =
                        unsafe { ::std::mem::transmute(mNextPaintCompressed) };
                    mNextPaintCompressed as u64
                });
                __bindgen_bitfield_unit.set(37usize, 1u8, {
                    let mHasCSSBackgroundColor: u8 =
                        unsafe { ::std::mem::transmute(mHasCSSBackgroundColor) };
                    mHasCSSBackgroundColor as u64
                });
                __bindgen_bitfield_unit.set(38usize, 1u8, {
                    let mIsLastChromeOnlyEscapeKeyConsumed: u8 =
                        unsafe { ::std::mem::transmute(mIsLastChromeOnlyEscapeKeyConsumed) };
                    mIsLastChromeOnlyEscapeKeyConsumed as u64
                });
                __bindgen_bitfield_unit.set(39usize, 1u8, {
                    let mHasReceivedPaintMessage: u8 =
                        unsafe { ::std::mem::transmute(mHasReceivedPaintMessage) };
                    mHasReceivedPaintMessage as u64
                });
                __bindgen_bitfield_unit.set(40usize, 1u8, {
                    let mIsLastKeyDownCanceled: u8 =
                        unsafe { ::std::mem::transmute(mIsLastKeyDownCanceled) };
                    mIsLastKeyDownCanceled as u64
                });
                __bindgen_bitfield_unit.set(41usize, 1u8, {
                    let mHasHandledUserInput: u8 =
                        unsafe { ::std::mem::transmute(mHasHandledUserInput) };
                    mHasHandledUserInput as u64
                });
                __bindgen_bitfield_unit.set(42usize, 1u8, {
                    let mForceDispatchKeyPressEventsForNonPrintableKeys: u8 = unsafe {
                        ::std::mem::transmute(mForceDispatchKeyPressEventsForNonPrintableKeys)
                    };
                    mForceDispatchKeyPressEventsForNonPrintableKeys as u64
                });
                __bindgen_bitfield_unit.set(43usize, 1u8, {
                    let mForceUseLegacyKeyCodeAndCharCodeValues: u8 =
                        unsafe { ::std::mem::transmute(mForceUseLegacyKeyCodeAndCharCodeValues) };
                    mForceUseLegacyKeyCodeAndCharCodeValues as u64
                });
                __bindgen_bitfield_unit.set(44usize, 1u8, {
                    let mInitializedWithKeyPressEventDispatchingBlacklist: u8 = unsafe {
                        ::std::mem::transmute(mInitializedWithKeyPressEventDispatchingBlacklist)
                    };
                    mInitializedWithKeyPressEventDispatchingBlacklist as u64
                });
                __bindgen_bitfield_unit.set(45usize, 1u8, {
                    let mForceUseLegacyNonPrimaryDispatch: u8 =
                        unsafe { ::std::mem::transmute(mForceUseLegacyNonPrimaryDispatch) };
                    mForceUseLegacyNonPrimaryDispatch as u64
                });
                __bindgen_bitfield_unit.set(46usize, 1u8, {
                    let mInitializedWithClickEventDispatchingBlacklist: u8 = unsafe {
                        ::std::mem::transmute(mInitializedWithClickEventDispatchingBlacklist)
                    };
                    mInitializedWithClickEventDispatchingBlacklist as u64
                });
                __bindgen_bitfield_unit
            }
        }
        #[repr(C)]
        pub struct SMILAttr__bindgen_vtable(::std::os::raw::c_void);
        #[doc = ""]
        #[repr(C)]
        #[derive(Debug)]
        pub struct SMILAttr {
            pub vtable_: *const SMILAttr__bindgen_vtable,
        }
        #[test]
        fn bindgen_test_layout_SMILAttr() {
            assert_eq!(
                ::std::mem::size_of::<SMILAttr>(),
                8usize,
                concat!("Size of: ", stringify!(SMILAttr))
            );
            assert_eq!(
                ::std::mem::align_of::<SMILAttr>(),
                8usize,
                concat!("Alignment of ", stringify!(SMILAttr))
            );
        }
        #[doc = " Utility class to provide scaling defined in a keySplines element."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SMILKeySpline {
            pub mX1: f64,
            pub mY1: f64,
            pub mX2: f64,
            pub mY2: f64,
            pub mSampleValues: [f64; 11usize],
        }
        pub const SMILKeySpline_kSplineTableSize: root::mozilla::SMILKeySpline__bindgen_ty_1 = 11;
        pub type SMILKeySpline__bindgen_ty_1 = u32;
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla13SMILKeySpline15kSampleStepSizeE"]
            pub static SMILKeySpline_kSampleStepSize: f64;
        }
        #[test]
        fn bindgen_test_layout_SMILKeySpline() {
            assert_eq!(
                ::std::mem::size_of::<SMILKeySpline>(),
                120usize,
                concat!("Size of: ", stringify!(SMILKeySpline))
            );
            assert_eq!(
                ::std::mem::align_of::<SMILKeySpline>(),
                8usize,
                concat!("Alignment of ", stringify!(SMILKeySpline))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<SMILKeySpline>())).mX1 as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(SMILKeySpline),
                    "::",
                    stringify!(mX1)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<SMILKeySpline>())).mY1 as *const _ as usize },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(SMILKeySpline),
                    "::",
                    stringify!(mY1)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<SMILKeySpline>())).mX2 as *const _ as usize },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(SMILKeySpline),
                    "::",
                    stringify!(mX2)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<SMILKeySpline>())).mY2 as *const _ as usize },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(SMILKeySpline),
                    "::",
                    stringify!(mY2)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<SMILKeySpline>())).mSampleValues as *const _ as usize
                },
                32usize,
                concat!(
                    "Offset of field: ",
                    stringify!(SMILKeySpline),
                    "::",
                    stringify!(mSampleValues)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct ComputedTimingFunction {
            pub mType: root::mozilla::ComputedTimingFunction_Type,
            pub mTimingFunction: root::mozilla::SMILKeySpline,
            pub mSteps: root::mozilla::ComputedTimingFunction_StepFunc,
        }
        pub const ComputedTimingFunction_Type_Ease: root::mozilla::ComputedTimingFunction_Type = 1;
        pub const ComputedTimingFunction_Type_Linear: root::mozilla::ComputedTimingFunction_Type =
            0;
        pub const ComputedTimingFunction_Type_EaseIn: root::mozilla::ComputedTimingFunction_Type =
            2;
        pub const ComputedTimingFunction_Type_EaseOut: root::mozilla::ComputedTimingFunction_Type =
            3;
        pub const ComputedTimingFunction_Type_EaseInOut:
            root::mozilla::ComputedTimingFunction_Type = 4;
        pub const ComputedTimingFunction_Type_CubicBezier:
            root::mozilla::ComputedTimingFunction_Type = 5;
        pub const ComputedTimingFunction_Type_Step: root::mozilla::ComputedTimingFunction_Type = 6;
        pub type ComputedTimingFunction_Type = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct ComputedTimingFunction_StepFunc {
            pub mSteps: u32,
            pub mPos: root::mozilla::StyleStepPosition,
        }
        #[test]
        fn bindgen_test_layout_ComputedTimingFunction_StepFunc() {
            assert_eq!(
                ::std::mem::size_of::<ComputedTimingFunction_StepFunc>(),
                8usize,
                concat!("Size of: ", stringify!(ComputedTimingFunction_StepFunc))
            );
            assert_eq!(
                ::std::mem::align_of::<ComputedTimingFunction_StepFunc>(),
                4usize,
                concat!("Alignment of ", stringify!(ComputedTimingFunction_StepFunc))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ComputedTimingFunction_StepFunc>())).mSteps as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedTimingFunction_StepFunc),
                    "::",
                    stringify!(mSteps)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ComputedTimingFunction_StepFunc>())).mPos as *const _
                        as usize
                },
                4usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedTimingFunction_StepFunc),
                    "::",
                    stringify!(mPos)
                )
            );
        }
        pub const ComputedTimingFunction_BeforeFlag_Unset:
            root::mozilla::ComputedTimingFunction_BeforeFlag = 0;
        pub const ComputedTimingFunction_BeforeFlag_Set:
            root::mozilla::ComputedTimingFunction_BeforeFlag = 1;
        pub type ComputedTimingFunction_BeforeFlag = i32;
        #[test]
        fn bindgen_test_layout_ComputedTimingFunction() {
            assert_eq!(
                ::std::mem::size_of::<ComputedTimingFunction>(),
                136usize,
                concat!("Size of: ", stringify!(ComputedTimingFunction))
            );
            assert_eq!(
                ::std::mem::align_of::<ComputedTimingFunction>(),
                8usize,
                concat!("Alignment of ", stringify!(ComputedTimingFunction))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ComputedTimingFunction>())).mType as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedTimingFunction),
                    "::",
                    stringify!(mType)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ComputedTimingFunction>())).mTimingFunction as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedTimingFunction),
                    "::",
                    stringify!(mTimingFunction)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ComputedTimingFunction>())).mSteps as *const _ as usize
                },
                128usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedTimingFunction),
                    "::",
                    stringify!(mSteps)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct AnimationPropertySegment {
            pub mFromKey: f32,
            pub mToKey: f32,
            pub mFromValue: root::mozilla::AnimationValue,
            pub mToValue: root::mozilla::AnimationValue,
            pub mTimingFunction: [u64; 18usize],
            pub mFromComposite: root::mozilla::dom::CompositeOperation,
            pub mToComposite: root::mozilla::dom::CompositeOperation,
        }
        #[test]
        fn bindgen_test_layout_AnimationPropertySegment() {
            assert_eq!(
                ::std::mem::size_of::<AnimationPropertySegment>(),
                176usize,
                concat!("Size of: ", stringify!(AnimationPropertySegment))
            );
            assert_eq!(
                ::std::mem::align_of::<AnimationPropertySegment>(),
                8usize,
                concat!("Alignment of ", stringify!(AnimationPropertySegment))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AnimationPropertySegment>())).mFromKey as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AnimationPropertySegment),
                    "::",
                    stringify!(mFromKey)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AnimationPropertySegment>())).mToKey as *const _ as usize
                },
                4usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AnimationPropertySegment),
                    "::",
                    stringify!(mToKey)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AnimationPropertySegment>())).mFromValue as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AnimationPropertySegment),
                    "::",
                    stringify!(mFromValue)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AnimationPropertySegment>())).mToValue as *const _
                        as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AnimationPropertySegment),
                    "::",
                    stringify!(mToValue)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AnimationPropertySegment>())).mTimingFunction as *const _
                        as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AnimationPropertySegment),
                    "::",
                    stringify!(mTimingFunction)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AnimationPropertySegment>())).mFromComposite as *const _
                        as usize
                },
                168usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AnimationPropertySegment),
                    "::",
                    stringify!(mFromComposite)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AnimationPropertySegment>())).mToComposite as *const _
                        as usize
                },
                169usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AnimationPropertySegment),
                    "::",
                    stringify!(mToComposite)
                )
            );
        }
        #[doc = " A ValueCalculator class that performs additional checks before performing"]
        #[doc = " arithmetic operations such that if either operand is Forever (or the"]
        #[doc = " negative equivalent) the result remains Forever (or the negative equivalent"]
        #[doc = " as appropriate)."]
        #[doc = ""]
        #[doc = " Currently this only checks if either argument to each operation is"]
        #[doc = " Forever/-Forever. However, it is possible that, for example,"]
        #[doc = " aA + aB > INT64_MAX (or < INT64_MIN)."]
        #[doc = ""]
        #[doc = " We currently don\'t check for that case since we don\'t expect that to"]
        #[doc = " happen often except under test conditions in which case the wrapping"]
        #[doc = " behavior is probably acceptable."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct StickyTimeDurationValueCalculator {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_StickyTimeDurationValueCalculator() {
            assert_eq!(
                ::std::mem::size_of::<StickyTimeDurationValueCalculator>(),
                1usize,
                concat!("Size of: ", stringify!(StickyTimeDurationValueCalculator))
            );
            assert_eq!(
                ::std::mem::align_of::<StickyTimeDurationValueCalculator>(),
                1usize,
                concat!(
                    "Alignment of ",
                    stringify!(StickyTimeDurationValueCalculator)
                )
            );
        }
        #[doc = " Specialization of BaseTimeDuration that uses"]
        #[doc = " StickyTimeDurationValueCalculator for arithmetic on the mValue member."]
        #[doc = ""]
        #[doc = " Use this class when you need a time duration that is expected to hold values"]
        #[doc = " of Forever (or the negative equivalent) *and* when you expect that"]
        #[doc = " time duration to be used in arithmetic operations (and not just value"]
        #[doc = " comparisons)."]
        pub type StickyTimeDuration = root::mozilla::BaseTimeDuration;
        #[doc = " Stores the results of calculating the timing properties of an animation"]
        #[doc = " at a given sample time."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct ComputedTiming {
            pub mActiveDuration: root::mozilla::StickyTimeDuration,
            pub mActiveTime: root::mozilla::StickyTimeDuration,
            pub mEndTime: root::mozilla::StickyTimeDuration,
            pub mProgress: [u64; 2usize],
            pub mCurrentIteration: u64,
            pub mIterations: f64,
            pub mIterationStart: f64,
            pub mDuration: root::mozilla::StickyTimeDuration,
            pub mFill: root::mozilla::dom::FillMode,
            pub mPhase: root::mozilla::ComputedTiming_AnimationPhase,
            pub mBeforeFlag: root::mozilla::ComputedTimingFunction_BeforeFlag,
        }
        pub const ComputedTiming_AnimationPhase_Idle: root::mozilla::ComputedTiming_AnimationPhase =
            0;
        pub const ComputedTiming_AnimationPhase_Before:
            root::mozilla::ComputedTiming_AnimationPhase = 1;
        pub const ComputedTiming_AnimationPhase_Active:
            root::mozilla::ComputedTiming_AnimationPhase = 2;
        pub const ComputedTiming_AnimationPhase_After:
            root::mozilla::ComputedTiming_AnimationPhase = 3;
        pub type ComputedTiming_AnimationPhase = i32;
        #[test]
        fn bindgen_test_layout_ComputedTiming() {
            assert_eq!(
                ::std::mem::size_of::<ComputedTiming>(),
                88usize,
                concat!("Size of: ", stringify!(ComputedTiming))
            );
            assert_eq!(
                ::std::mem::align_of::<ComputedTiming>(),
                8usize,
                concat!("Alignment of ", stringify!(ComputedTiming))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ComputedTiming>())).mActiveDuration as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedTiming),
                    "::",
                    stringify!(mActiveDuration)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ComputedTiming>())).mActiveTime as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedTiming),
                    "::",
                    stringify!(mActiveTime)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<ComputedTiming>())).mEndTime as *const _ as usize },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedTiming),
                    "::",
                    stringify!(mEndTime)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ComputedTiming>())).mProgress as *const _ as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedTiming),
                    "::",
                    stringify!(mProgress)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ComputedTiming>())).mCurrentIteration as *const _
                        as usize
                },
                40usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedTiming),
                    "::",
                    stringify!(mCurrentIteration)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ComputedTiming>())).mIterations as *const _ as usize
                },
                48usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedTiming),
                    "::",
                    stringify!(mIterations)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ComputedTiming>())).mIterationStart as *const _ as usize
                },
                56usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedTiming),
                    "::",
                    stringify!(mIterationStart)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ComputedTiming>())).mDuration as *const _ as usize
                },
                64usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedTiming),
                    "::",
                    stringify!(mDuration)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<ComputedTiming>())).mFill as *const _ as usize },
                72usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedTiming),
                    "::",
                    stringify!(mFill)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<ComputedTiming>())).mPhase as *const _ as usize },
                76usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedTiming),
                    "::",
                    stringify!(mPhase)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ComputedTiming>())).mBeforeFlag as *const _ as usize
                },
                80usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedTiming),
                    "::",
                    stringify!(mBeforeFlag)
                )
            );
        }
        #[doc = " A property-value pair specified on a keyframe."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct PropertyValuePair {
            pub mProperty: root::nsCSSPropertyID,
            pub mServoDeclarationBlock: root::RefPtr<root::RawServoDeclarationBlock>,
        }
        #[test]
        fn bindgen_test_layout_PropertyValuePair() {
            assert_eq!(
                ::std::mem::size_of::<PropertyValuePair>(),
                16usize,
                concat!("Size of: ", stringify!(PropertyValuePair))
            );
            assert_eq!(
                ::std::mem::align_of::<PropertyValuePair>(),
                8usize,
                concat!("Alignment of ", stringify!(PropertyValuePair))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PropertyValuePair>())).mProperty as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PropertyValuePair),
                    "::",
                    stringify!(mProperty)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PropertyValuePair>())).mServoDeclarationBlock as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PropertyValuePair),
                    "::",
                    stringify!(mServoDeclarationBlock)
                )
            );
        }
        #[doc = " A single keyframe."]
        #[doc = ""]
        #[doc = " This is the canonical form in which keyframe effects are stored and"]
        #[doc = " corresponds closely to the type of objects returned via the getKeyframes()"]
        #[doc = " API."]
        #[doc = ""]
        #[doc = " Before computing an output animation value, however, we flatten these frames"]
        #[doc = " down to a series of per-property value arrays where we also resolve any"]
        #[doc = " overlapping shorthands/longhands, convert specified CSS values to computed"]
        #[doc = " values, etc."]
        #[doc = ""]
        #[doc = " When the target element or computed style changes, however, we rebuild these"]
        #[doc = " per-property arrays from the original list of keyframes objects. As a result,"]
        #[doc = " these objects represent the master definition of the effect\'s values."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct Keyframe {
            pub mOffset: [u64; 2usize],
            pub mComputedOffset: f64,
            pub mTimingFunction: [u64; 18usize],
            pub mComposite: root::mozilla::dom::CompositeOperationOrAuto,
            pub mPropertyValues: root::nsTArray<root::mozilla::PropertyValuePair>,
        }
        pub const Keyframe_kComputedOffsetNotSet: f64 = -1.0;
        #[test]
        fn bindgen_test_layout_Keyframe() {
            assert_eq!(
                ::std::mem::size_of::<Keyframe>(),
                184usize,
                concat!("Size of: ", stringify!(Keyframe))
            );
            assert_eq!(
                ::std::mem::align_of::<Keyframe>(),
                8usize,
                concat!("Alignment of ", stringify!(Keyframe))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<Keyframe>())).mOffset as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(Keyframe),
                    "::",
                    stringify!(mOffset)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<Keyframe>())).mComputedOffset as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(Keyframe),
                    "::",
                    stringify!(mComputedOffset)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<Keyframe>())).mTimingFunction as *const _ as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(Keyframe),
                    "::",
                    stringify!(mTimingFunction)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<Keyframe>())).mComposite as *const _ as usize },
                168usize,
                concat!(
                    "Offset of field: ",
                    stringify!(Keyframe),
                    "::",
                    stringify!(mComposite)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<Keyframe>())).mPropertyValues as *const _ as usize
                },
                176usize,
                concat!(
                    "Offset of field: ",
                    stringify!(Keyframe),
                    "::",
                    stringify!(mPropertyValues)
                )
            );
        }
        #[repr(u8)]
        #[doc = " A bitflags enum class used to determine what data does a ServoElementSnapshot"]
        #[doc = " contains."]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum ServoElementSnapshotFlags {
            State = 1,
            Attributes = 2,
            Id = 4,
            MaybeClass = 8,
            OtherPseudoClassState = 16,
        }
        #[doc = " This class holds all non-tree-structural state of an element that might be"]
        #[doc = " used for selector matching eventually."]
        #[doc = ""]
        #[doc = " This means the attributes, and the element state, such as :hover, :active,"]
        #[doc = " etc..."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct ServoElementSnapshot {
            pub mAttrs: root::nsTArray<root::AttrArray_InternalAttr>,
            pub mClass: root::nsAttrValue,
            pub mState: root::mozilla::ServoElementSnapshot_ServoStateType,
            pub mContains: root::mozilla::ServoElementSnapshot_Flags,
            pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 1usize], u8>,
            pub __bindgen_padding_0: [u16; 3usize],
        }
        pub type ServoElementSnapshot_BorrowedAttrInfo = root::mozilla::dom::BorrowedAttrInfo;
        pub type ServoElementSnapshot_Element = root::mozilla::dom::Element;
        pub type ServoElementSnapshot_ServoStateType = root::mozilla::EventStates_ServoType;
        pub use self::super::super::root::mozilla::ServoElementSnapshotFlags as ServoElementSnapshot_Flags;
        #[test]
        fn bindgen_test_layout_ServoElementSnapshot() {
            assert_eq!(
                ::std::mem::size_of::<ServoElementSnapshot>(),
                32usize,
                concat!("Size of: ", stringify!(ServoElementSnapshot))
            );
            assert_eq!(
                ::std::mem::align_of::<ServoElementSnapshot>(),
                8usize,
                concat!("Alignment of ", stringify!(ServoElementSnapshot))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoElementSnapshot>())).mAttrs as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoElementSnapshot),
                    "::",
                    stringify!(mAttrs)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoElementSnapshot>())).mClass as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoElementSnapshot),
                    "::",
                    stringify!(mClass)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoElementSnapshot>())).mState as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoElementSnapshot),
                    "::",
                    stringify!(mState)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoElementSnapshot>())).mContains as *const _ as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoElementSnapshot),
                    "::",
                    stringify!(mContains)
                )
            );
        }
        impl ServoElementSnapshot {
            #[inline]
            pub fn mIsHTMLElementInHTMLDocument(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsHTMLElementInHTMLDocument(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(0usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsInChromeDocument(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsInChromeDocument(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(1usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mSupportsLangAttr(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mSupportsLangAttr(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(2usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsTableBorderNonzero(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsTableBorderNonzero(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(3usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIsMozBrowserFrame(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIsMozBrowserFrame(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(4usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mClassAttributeChanged(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mClassAttributeChanged(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(5usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mIdAttributeChanged(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mIdAttributeChanged(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(6usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn mOtherAttributeChanged(&self) -> bool {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u8) }
            }
            #[inline]
            pub fn set_mOtherAttributeChanged(&mut self, val: bool) {
                unsafe {
                    let val: u8 = ::std::mem::transmute(val);
                    self._bitfield_1.set(7usize, 1u8, val as u64)
                }
            }
            #[inline]
            pub fn new_bitfield_1(
                mIsHTMLElementInHTMLDocument: bool,
                mIsInChromeDocument: bool,
                mSupportsLangAttr: bool,
                mIsTableBorderNonzero: bool,
                mIsMozBrowserFrame: bool,
                mClassAttributeChanged: bool,
                mIdAttributeChanged: bool,
                mOtherAttributeChanged: bool,
            ) -> root::__BindgenBitfieldUnit<[u8; 1usize], u8> {
                let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 1usize], u8> =
                    Default::default();
                __bindgen_bitfield_unit.set(0usize, 1u8, {
                    let mIsHTMLElementInHTMLDocument: u8 =
                        unsafe { ::std::mem::transmute(mIsHTMLElementInHTMLDocument) };
                    mIsHTMLElementInHTMLDocument as u64
                });
                __bindgen_bitfield_unit.set(1usize, 1u8, {
                    let mIsInChromeDocument: u8 =
                        unsafe { ::std::mem::transmute(mIsInChromeDocument) };
                    mIsInChromeDocument as u64
                });
                __bindgen_bitfield_unit.set(2usize, 1u8, {
                    let mSupportsLangAttr: u8 = unsafe { ::std::mem::transmute(mSupportsLangAttr) };
                    mSupportsLangAttr as u64
                });
                __bindgen_bitfield_unit.set(3usize, 1u8, {
                    let mIsTableBorderNonzero: u8 =
                        unsafe { ::std::mem::transmute(mIsTableBorderNonzero) };
                    mIsTableBorderNonzero as u64
                });
                __bindgen_bitfield_unit.set(4usize, 1u8, {
                    let mIsMozBrowserFrame: u8 =
                        unsafe { ::std::mem::transmute(mIsMozBrowserFrame) };
                    mIsMozBrowserFrame as u64
                });
                __bindgen_bitfield_unit.set(5usize, 1u8, {
                    let mClassAttributeChanged: u8 =
                        unsafe { ::std::mem::transmute(mClassAttributeChanged) };
                    mClassAttributeChanged as u64
                });
                __bindgen_bitfield_unit.set(6usize, 1u8, {
                    let mIdAttributeChanged: u8 =
                        unsafe { ::std::mem::transmute(mIdAttributeChanged) };
                    mIdAttributeChanged as u64
                });
                __bindgen_bitfield_unit.set(7usize, 1u8, {
                    let mOtherAttributeChanged: u8 =
                        unsafe { ::std::mem::transmute(mOtherAttributeChanged) };
                    mOtherAttributeChanged as u64
                });
                __bindgen_bitfield_unit
            }
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct ServoElementSnapshotTable {
            pub _base: [u64; 4usize],
        }
        #[test]
        fn bindgen_test_layout_ServoElementSnapshotTable() {
            assert_eq!(
                ::std::mem::size_of::<ServoElementSnapshotTable>(),
                32usize,
                concat!("Size of: ", stringify!(ServoElementSnapshotTable))
            );
            assert_eq!(
                ::std::mem::align_of::<ServoElementSnapshotTable>(),
                8usize,
                concat!("Alignment of ", stringify!(ServoElementSnapshotTable))
            );
        }
        pub const CaretAssociationHint_CARET_ASSOCIATE_BEFORE: root::mozilla::CaretAssociationHint =
            0;
        pub const CaretAssociationHint_CARET_ASSOCIATE_AFTER: root::mozilla::CaretAssociationHint =
            1;
        #[doc = " Hint whether a caret is associated with the content before a"]
        #[doc = " given character offset (ASSOCIATE_BEFORE), or with the content after a given"]
        #[doc = " character offset (ASSOCIATE_AFTER)."]
        pub type CaretAssociationHint = u32;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct FramePropertyDescriptorUntyped {
            pub mDestructor: root::mozilla::FramePropertyDescriptorUntyped_UntypedDestructor,
            pub mDestructorWithFrame:
                root::mozilla::FramePropertyDescriptorUntyped_UntypedDestructorWithFrame,
        }
        #[doc = " mDestructor will be called if it\'s non-null."]
        pub type FramePropertyDescriptorUntyped_UntypedDestructor = ::std::option::Option<
            unsafe extern "C" fn(aPropertyValue: *mut ::std::os::raw::c_void),
        >;
        #[doc = " mDestructorWithFrame will be called if it\'s non-null and mDestructor"]
        #[doc = " is null. WARNING: The frame passed to mDestructorWithFrame may"]
        #[doc = " be a dangling frame pointer, if this is being called during"]
        #[doc = " presshell teardown. Do not use it except to compare against"]
        #[doc = " other frame pointers. No frame will have been allocated with"]
        #[doc = " the same address yet."]
        pub type FramePropertyDescriptorUntyped_UntypedDestructorWithFrame = ::std::option::Option<
            unsafe extern "C" fn(
                aFrame: *const root::nsIFrame,
                aPropertyValue: *mut ::std::os::raw::c_void,
            ),
        >;
        #[test]
        fn bindgen_test_layout_FramePropertyDescriptorUntyped() {
            assert_eq!(
                ::std::mem::size_of::<FramePropertyDescriptorUntyped>(),
                16usize,
                concat!("Size of: ", stringify!(FramePropertyDescriptorUntyped))
            );
            assert_eq!(
                ::std::mem::align_of::<FramePropertyDescriptorUntyped>(),
                8usize,
                concat!("Alignment of ", stringify!(FramePropertyDescriptorUntyped))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<FramePropertyDescriptorUntyped>())).mDestructor
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(FramePropertyDescriptorUntyped),
                    "::",
                    stringify!(mDestructor)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<FramePropertyDescriptorUntyped>())).mDestructorWithFrame
                        as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(FramePropertyDescriptorUntyped),
                    "::",
                    stringify!(mDestructorWithFrame)
                )
            );
        }
        #[doc = " A pointer to a FramePropertyDescriptor serves as a unique property ID."]
        #[doc = " The FramePropertyDescriptor stores metadata about the property."]
        #[doc = " Currently the only metadata is a destructor function. The destructor"]
        #[doc = " function is called on property values when they are overwritten or"]
        #[doc = " deleted."]
        #[doc = ""]
        #[doc = " To use this class, declare a global (i.e., file, class or function-scope"]
        #[doc = " static member) FramePropertyDescriptor and pass its address as"]
        #[doc = " aProperty in the FrameProperties methods."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct FramePropertyDescriptor {
            pub _base: root::mozilla::FramePropertyDescriptorUntyped,
        }
        pub type FramePropertyDescriptor_Destructor<T> =
            ::std::option::Option<unsafe extern "C" fn(aPropertyValue: *mut T)>;
        pub type FramePropertyDescriptor_DestructorWithFrame<T> = ::std::option::Option<
            unsafe extern "C" fn(aaFrame: *const root::nsIFrame, aPropertyValue: *mut T),
        >;
        #[doc = " The FrameProperties class is optimized for storing 0 or 1 properties on"]
        #[doc = " a given frame. Storing very large numbers of properties on a single"]
        #[doc = " frame will not be efficient."]
        #[doc = ""]
        #[doc = " Property values are passed as void* but do not actually have to be"]
        #[doc = " valid pointers. You can use NS_INT32_TO_PTR/NS_PTR_TO_INT32 to"]
        #[doc = " store int32_t values. Null/zero values can be stored and retrieved."]
        #[doc = " Of course, the destructor function (if any) must handle such values"]
        #[doc = " correctly."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct FrameProperties {
            pub mProperties: root::nsTArray<root::mozilla::FrameProperties_PropertyValue>,
        }
        pub type FrameProperties_Descriptor = *const root::mozilla::FramePropertyDescriptor;
        pub type FrameProperties_UntypedDescriptor =
            *const root::mozilla::FramePropertyDescriptorUntyped;
        pub type FrameProperties_PropertyType = root::mozilla::detail::FramePropertyTypeHelper;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct FrameProperties_ReinterpretHelper {
            pub _address: u8,
        }
        #[doc = " Stores a property descriptor/value pair."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct FrameProperties_PropertyValue {
            pub mProperty: root::mozilla::FrameProperties_UntypedDescriptor,
            pub mValue: *mut ::std::os::raw::c_void,
        }
        #[test]
        fn bindgen_test_layout_FrameProperties_PropertyValue() {
            assert_eq!(
                ::std::mem::size_of::<FrameProperties_PropertyValue>(),
                16usize,
                concat!("Size of: ", stringify!(FrameProperties_PropertyValue))
            );
            assert_eq!(
                ::std::mem::align_of::<FrameProperties_PropertyValue>(),
                8usize,
                concat!("Alignment of ", stringify!(FrameProperties_PropertyValue))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<FrameProperties_PropertyValue>())).mProperty as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(FrameProperties_PropertyValue),
                    "::",
                    stringify!(mProperty)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<FrameProperties_PropertyValue>())).mValue as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(FrameProperties_PropertyValue),
                    "::",
                    stringify!(mValue)
                )
            );
        }
        #[doc = " Used with an array of PropertyValues to allow lookups that compare"]
        #[doc = " only on the FramePropertyDescriptor."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct FrameProperties_PropertyComparator {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_FrameProperties_PropertyComparator() {
            assert_eq!(
                ::std::mem::size_of::<FrameProperties_PropertyComparator>(),
                1usize,
                concat!("Size of: ", stringify!(FrameProperties_PropertyComparator))
            );
            assert_eq!(
                ::std::mem::align_of::<FrameProperties_PropertyComparator>(),
                1usize,
                concat!(
                    "Alignment of ",
                    stringify!(FrameProperties_PropertyComparator)
                )
            );
        }
        #[test]
        fn bindgen_test_layout_FrameProperties() {
            assert_eq!(
                ::std::mem::size_of::<FrameProperties>(),
                8usize,
                concat!("Size of: ", stringify!(FrameProperties))
            );
            assert_eq!(
                ::std::mem::align_of::<FrameProperties>(),
                8usize,
                concat!("Alignment of ", stringify!(FrameProperties))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<FrameProperties>())).mProperties as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(FrameProperties),
                    "::",
                    stringify!(mProperties)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SmallPointerArray {
            pub _address: u8,
        }
        pub type SmallPointerArray_iterator<T> = *mut *mut T;
        pub type SmallPointerArray_const_iterator<T> = *mut *const T;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SmallPointerArray_Element<T> {
            pub mValue: root::__BindgenUnionField<*mut T>,
            pub mVector: root::__BindgenUnionField<*mut root::std::vector>,
            pub bindgen_union_field: u64,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct CachedInheritingStyles {
            pub mBits: usize,
        }
        pub type CachedInheritingStyles_IndirectCache = [u64; 6usize];
        #[test]
        fn bindgen_test_layout_CachedInheritingStyles() {
            assert_eq!(
                ::std::mem::size_of::<CachedInheritingStyles>(),
                8usize,
                concat!("Size of: ", stringify!(CachedInheritingStyles))
            );
            assert_eq!(
                ::std::mem::align_of::<CachedInheritingStyles>(),
                8usize,
                concat!("Alignment of ", stringify!(CachedInheritingStyles))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<CachedInheritingStyles>())).mBits as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(CachedInheritingStyles),
                    "::",
                    stringify!(mBits)
                )
            );
        }
        pub const ComputedStyleBit_HasTextDecorationLines: root::mozilla::ComputedStyleBit = 1;
        pub const ComputedStyleBit_SuppressLineBreak: root::mozilla::ComputedStyleBit = 2;
        pub const ComputedStyleBit_IsTextCombined: root::mozilla::ComputedStyleBit = 4;
        pub const ComputedStyleBit_RelevantLinkVisited: root::mozilla::ComputedStyleBit = 8;
        pub const ComputedStyleBit_HasPseudoElementData: root::mozilla::ComputedStyleBit = 16;
        pub const ComputedStyleBit_DependsOnFontMetrics: root::mozilla::ComputedStyleBit = 512;
        #[doc = " A ComputedStyle represents the computed style data for an element."]
        #[doc = ""]
        #[doc = " The computed style data are stored in a set of reference counted structs"]
        #[doc = " (see nsStyleStruct.h) that are stored directly on the ComputedStyle."]
        #[doc = ""]
        #[doc = " Style structs are immutable once they have been produced, so when any change"]
        #[doc = " is made that needs a restyle, we create a new ComputedStyle."]
        #[doc = ""]
        #[doc = " ComputedStyles are reference counted. References are generally held by:"]
        #[doc = ""]
        #[doc = "  1. nsIFrame::mComputedStyle, for every frame"]
        #[doc = "  2. Element::mServoData, for every element not inside a display:none subtree"]
        #[doc = "  3. nsComputedDOMStyle, when created for elements in display:none subtrees"]
        #[doc = "  4. media_queries::Device, which holds the initial value of every property"]
        pub type ComputedStyleBit = u16;
        #[repr(C)]
        pub struct ComputedStyle {
            pub mSource: root::ServoComputedData,
            pub mCachedInheritingStyles: root::mozilla::CachedInheritingStyles,
            pub mPseudoType: root::mozilla::PseudoStyleType,
        }
        pub use self::super::super::root::mozilla::ComputedStyleBit as ComputedStyle_Bit;
        #[test]
        fn bindgen_test_layout_ComputedStyle() {
            assert_eq!(
                ::std::mem::size_of::<ComputedStyle>(),
                232usize,
                concat!("Size of: ", stringify!(ComputedStyle))
            );
            assert_eq!(
                ::std::mem::align_of::<ComputedStyle>(),
                8usize,
                concat!("Alignment of ", stringify!(ComputedStyle))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<ComputedStyle>())).mSource as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedStyle),
                    "::",
                    stringify!(mSource)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ComputedStyle>())).mCachedInheritingStyles as *const _
                        as usize
                },
                216usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedStyle),
                    "::",
                    stringify!(mCachedInheritingStyles)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ComputedStyle>())).mPseudoType as *const _ as usize
                },
                224usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ComputedStyle),
                    "::",
                    stringify!(mPseudoType)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoFont {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleFont>,
        }
        #[test]
        fn bindgen_test_layout_GeckoFont() {
            assert_eq!(
                ::std::mem::size_of::<GeckoFont>(),
                120usize,
                concat!("Size of: ", stringify!(GeckoFont))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoFont>(),
                8usize,
                concat!("Alignment of ", stringify!(GeckoFont))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoFont>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoFont),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoColor {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleColor>,
        }
        #[test]
        fn bindgen_test_layout_GeckoColor() {
            assert_eq!(
                ::std::mem::size_of::<GeckoColor>(),
                4usize,
                concat!("Size of: ", stringify!(GeckoColor))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoColor>(),
                1usize,
                concat!("Alignment of ", stringify!(GeckoColor))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoColor>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoColor),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoList {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleList>,
        }
        #[test]
        fn bindgen_test_layout_GeckoList() {
            assert_eq!(
                ::std::mem::size_of::<GeckoList>(),
                56usize,
                concat!("Size of: ", stringify!(GeckoList))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoList>(),
                8usize,
                concat!("Alignment of ", stringify!(GeckoList))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoList>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoList),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoText {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleText>,
        }
        #[test]
        fn bindgen_test_layout_GeckoText() {
            assert_eq!(
                ::std::mem::size_of::<GeckoText>(),
                144usize,
                concat!("Size of: ", stringify!(GeckoText))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoText>(),
                8usize,
                concat!("Alignment of ", stringify!(GeckoText))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoText>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoText),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoVisibility {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleVisibility>,
        }
        #[test]
        fn bindgen_test_layout_GeckoVisibility() {
            assert_eq!(
                ::std::mem::size_of::<GeckoVisibility>(),
                7usize,
                concat!("Size of: ", stringify!(GeckoVisibility))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoVisibility>(),
                1usize,
                concat!("Alignment of ", stringify!(GeckoVisibility))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoVisibility>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoVisibility),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoUI {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleUI>,
        }
        #[test]
        fn bindgen_test_layout_GeckoUI() {
            assert_eq!(
                ::std::mem::size_of::<GeckoUI>(),
                72usize,
                concat!("Size of: ", stringify!(GeckoUI))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoUI>(),
                8usize,
                concat!("Alignment of ", stringify!(GeckoUI))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoUI>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoUI),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoTableBorder {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleTableBorder>,
        }
        #[test]
        fn bindgen_test_layout_GeckoTableBorder() {
            assert_eq!(
                ::std::mem::size_of::<GeckoTableBorder>(),
                12usize,
                concat!("Size of: ", stringify!(GeckoTableBorder))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoTableBorder>(),
                4usize,
                concat!("Alignment of ", stringify!(GeckoTableBorder))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoTableBorder>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoTableBorder),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoSVG {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleSVG>,
        }
        #[test]
        fn bindgen_test_layout_GeckoSVG() {
            assert_eq!(
                ::std::mem::size_of::<GeckoSVG>(),
                176usize,
                concat!("Size of: ", stringify!(GeckoSVG))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoSVG>(),
                8usize,
                concat!("Alignment of ", stringify!(GeckoSVG))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoSVG>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoSVG),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoBackground {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleBackground>,
        }
        #[test]
        fn bindgen_test_layout_GeckoBackground() {
            assert_eq!(
                ::std::mem::size_of::<GeckoBackground>(),
                176usize,
                concat!("Size of: ", stringify!(GeckoBackground))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoBackground>(),
                8usize,
                concat!("Alignment of ", stringify!(GeckoBackground))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoBackground>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoBackground),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoPosition {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStylePosition>,
        }
        #[test]
        fn bindgen_test_layout_GeckoPosition() {
            assert_eq!(
                ::std::mem::size_of::<GeckoPosition>(),
                464usize,
                concat!("Size of: ", stringify!(GeckoPosition))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoPosition>(),
                8usize,
                concat!("Alignment of ", stringify!(GeckoPosition))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoPosition>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoPosition),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoTextReset {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleTextReset>,
        }
        #[test]
        fn bindgen_test_layout_GeckoTextReset() {
            assert_eq!(
                ::std::mem::size_of::<GeckoTextReset>(),
                88usize,
                concat!("Size of: ", stringify!(GeckoTextReset))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoTextReset>(),
                8usize,
                concat!("Alignment of ", stringify!(GeckoTextReset))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoTextReset>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoTextReset),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoDisplay {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleDisplay>,
        }
        #[test]
        fn bindgen_test_layout_GeckoDisplay() {
            assert_eq!(
                ::std::mem::size_of::<GeckoDisplay>(),
                504usize,
                concat!("Size of: ", stringify!(GeckoDisplay))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoDisplay>(),
                8usize,
                concat!("Alignment of ", stringify!(GeckoDisplay))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoDisplay>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoDisplay),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoContent {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleContent>,
        }
        #[test]
        fn bindgen_test_layout_GeckoContent() {
            assert_eq!(
                ::std::mem::size_of::<GeckoContent>(),
                32usize,
                concat!("Size of: ", stringify!(GeckoContent))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoContent>(),
                8usize,
                concat!("Alignment of ", stringify!(GeckoContent))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoContent>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoContent),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoUIReset {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleUIReset>,
        }
        #[test]
        fn bindgen_test_layout_GeckoUIReset() {
            assert_eq!(
                ::std::mem::size_of::<GeckoUIReset>(),
                64usize,
                concat!("Size of: ", stringify!(GeckoUIReset))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoUIReset>(),
                8usize,
                concat!("Alignment of ", stringify!(GeckoUIReset))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoUIReset>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoUIReset),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoTable {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleTable>,
        }
        #[test]
        fn bindgen_test_layout_GeckoTable() {
            assert_eq!(
                ::std::mem::size_of::<GeckoTable>(),
                8usize,
                concat!("Size of: ", stringify!(GeckoTable))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoTable>(),
                4usize,
                concat!("Alignment of ", stringify!(GeckoTable))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoTable>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoTable),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoMargin {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleMargin>,
        }
        #[test]
        fn bindgen_test_layout_GeckoMargin() {
            assert_eq!(
                ::std::mem::size_of::<GeckoMargin>(),
                80usize,
                concat!("Size of: ", stringify!(GeckoMargin))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoMargin>(),
                4usize,
                concat!("Alignment of ", stringify!(GeckoMargin))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoMargin>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoMargin),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoPadding {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStylePadding>,
        }
        #[test]
        fn bindgen_test_layout_GeckoPadding() {
            assert_eq!(
                ::std::mem::size_of::<GeckoPadding>(),
                112usize,
                concat!("Size of: ", stringify!(GeckoPadding))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoPadding>(),
                4usize,
                concat!("Alignment of ", stringify!(GeckoPadding))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoPadding>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoPadding),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoBorder {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleBorder>,
        }
        #[test]
        fn bindgen_test_layout_GeckoBorder() {
            assert_eq!(
                ::std::mem::size_of::<GeckoBorder>(),
                344usize,
                concat!("Size of: ", stringify!(GeckoBorder))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoBorder>(),
                8usize,
                concat!("Alignment of ", stringify!(GeckoBorder))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoBorder>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoBorder),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoOutline {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleOutline>,
        }
        #[test]
        fn bindgen_test_layout_GeckoOutline() {
            assert_eq!(
                ::std::mem::size_of::<GeckoOutline>(),
                132usize,
                concat!("Size of: ", stringify!(GeckoOutline))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoOutline>(),
                4usize,
                concat!("Alignment of ", stringify!(GeckoOutline))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoOutline>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoOutline),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoXUL {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleXUL>,
        }
        #[test]
        fn bindgen_test_layout_GeckoXUL() {
            assert_eq!(
                ::std::mem::size_of::<GeckoXUL>(),
                16usize,
                concat!("Size of: ", stringify!(GeckoXUL))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoXUL>(),
                4usize,
                concat!("Alignment of ", stringify!(GeckoXUL))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoXUL>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoXUL),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoSVGReset {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleSVGReset>,
        }
        #[test]
        fn bindgen_test_layout_GeckoSVGReset() {
            assert_eq!(
                ::std::mem::size_of::<GeckoSVGReset>(),
                240usize,
                concat!("Size of: ", stringify!(GeckoSVGReset))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoSVGReset>(),
                8usize,
                concat!("Alignment of ", stringify!(GeckoSVGReset))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoSVGReset>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoSVGReset),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoColumn {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleColumn>,
        }
        #[test]
        fn bindgen_test_layout_GeckoColumn() {
            assert_eq!(
                ::std::mem::size_of::<GeckoColumn>(),
                40usize,
                concat!("Size of: ", stringify!(GeckoColumn))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoColumn>(),
                4usize,
                concat!("Alignment of ", stringify!(GeckoColumn))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoColumn>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoColumn),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[repr(C)]
        pub struct GeckoEffects {
            pub gecko: ::gecko_bindings::structs::ServoManuallyDrop<root::nsStyleEffects>,
        }
        #[test]
        fn bindgen_test_layout_GeckoEffects() {
            assert_eq!(
                ::std::mem::size_of::<GeckoEffects>(),
                48usize,
                concat!("Size of: ", stringify!(GeckoEffects))
            );
            assert_eq!(
                ::std::mem::align_of::<GeckoEffects>(),
                8usize,
                concat!("Alignment of ", stringify!(GeckoEffects))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<GeckoEffects>())).gecko as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(GeckoEffects),
                    "::",
                    stringify!(gecko)
                )
            );
        }
        #[doc = " LogicalSides represents a set of logical sides."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct LogicalSides {
            pub mBits: u8,
        }
        #[test]
        fn bindgen_test_layout_LogicalSides() {
            assert_eq!(
                ::std::mem::size_of::<LogicalSides>(),
                1usize,
                concat!("Size of: ", stringify!(LogicalSides))
            );
            assert_eq!(
                ::std::mem::align_of::<LogicalSides>(),
                1usize,
                concat!("Alignment of ", stringify!(LogicalSides))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<LogicalSides>())).mBits as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(LogicalSides),
                    "::",
                    stringify!(mBits)
                )
            );
        }
        #[doc = " mozilla::WritingMode is an immutable class representing a"]
        #[doc = " writing mode."]
        #[doc = ""]
        #[doc = " It efficiently stores the writing mode and can rapidly compute"]
        #[doc = " interesting things about it for use in layout."]
        #[doc = ""]
        #[doc = " Writing modes are computed from the CSS \'direction\',"]
        #[doc = " \'writing-mode\', and \'text-orientation\' properties."]
        #[doc = " See CSS3 Writing Modes for more information"]
        #[doc = "   http://www.w3.org/TR/css3-writing-modes/"]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct WritingMode {
            pub mWritingMode: u8,
        }
        pub const WritingMode_InlineDir_eInlineLTR: root::mozilla::WritingMode_InlineDir = 0;
        pub const WritingMode_InlineDir_eInlineRTL: root::mozilla::WritingMode_InlineDir = 2;
        pub const WritingMode_InlineDir_eInlineTTB: root::mozilla::WritingMode_InlineDir = 1;
        pub const WritingMode_InlineDir_eInlineBTT: root::mozilla::WritingMode_InlineDir = 3;
        #[doc = " Absolute inline flow direction"]
        pub type WritingMode_InlineDir = u32;
        pub const WritingMode_BlockDir_eBlockTB: root::mozilla::WritingMode_BlockDir = 0;
        pub const WritingMode_BlockDir_eBlockRL: root::mozilla::WritingMode_BlockDir = 1;
        pub const WritingMode_BlockDir_eBlockLR: root::mozilla::WritingMode_BlockDir = 5;
        #[doc = " Absolute block flow direction"]
        pub type WritingMode_BlockDir = u32;
        pub const WritingMode_BidiDir_eBidiLTR: root::mozilla::WritingMode_BidiDir = 0;
        pub const WritingMode_BidiDir_eBidiRTL: root::mozilla::WritingMode_BidiDir = 16;
        #[doc = " Line-relative (bidi-relative) inline flow direction"]
        pub type WritingMode_BidiDir = u32;
        pub const WritingMode_eUnknownWritingMode: root::mozilla::WritingMode__bindgen_ty_1 = 255;
        #[doc = " Unknown writing mode (should never actually be stored or used anywhere)."]
        pub type WritingMode__bindgen_ty_1 = u32;
        pub const WritingMode_Masks_eOrientationMask: root::mozilla::WritingMode_Masks = 1;
        pub const WritingMode_Masks_eInlineFlowMask: root::mozilla::WritingMode_Masks = 2;
        pub const WritingMode_Masks_eBlockFlowMask: root::mozilla::WritingMode_Masks = 4;
        pub const WritingMode_Masks_eLineOrientMask: root::mozilla::WritingMode_Masks = 8;
        pub const WritingMode_Masks_eBidiMask: root::mozilla::WritingMode_Masks = 16;
        pub const WritingMode_Masks_eSidewaysMask: root::mozilla::WritingMode_Masks = 32;
        pub const WritingMode_Masks_eInlineMask: root::mozilla::WritingMode_Masks = 3;
        pub const WritingMode_Masks_eBlockMask: root::mozilla::WritingMode_Masks = 5;
        pub type WritingMode_Masks = u32;
        #[test]
        fn bindgen_test_layout_WritingMode() {
            assert_eq!(
                ::std::mem::size_of::<WritingMode>(),
                1usize,
                concat!("Size of: ", stringify!(WritingMode))
            );
            assert_eq!(
                ::std::mem::align_of::<WritingMode>(),
                1usize,
                concat!("Alignment of ", stringify!(WritingMode))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<WritingMode>())).mWritingMode as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(WritingMode),
                    "::",
                    stringify!(mWritingMode)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct ReflowInput {
            _unused: [u8; 0],
        }
        #[doc = " Reflow metrics used to return the frame\'s desired size and alignment"]
        #[doc = " information."]
        #[doc = ""]
        #[doc = " @see #Reflow()"]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct ReflowOutput {
            pub mBoundingMetrics: root::nsBoundingMetrics,
            pub mCarriedOutBEndMargin: root::nsCollapsingMargin,
            pub mOverflowAreas: root::nsOverflowAreas,
            pub mISize: root::nscoord,
            pub mBSize: root::nscoord,
            pub mBlockStartAscent: root::nscoord,
            pub mWritingMode: root::mozilla::WritingMode,
        }
        pub const ReflowOutput_ASK_FOR_BASELINE: root::mozilla::ReflowOutput__bindgen_ty_1 =
            1073741823;
        pub type ReflowOutput__bindgen_ty_1 = u32;
        #[test]
        fn bindgen_test_layout_ReflowOutput() {
            assert_eq!(
                ::std::mem::size_of::<ReflowOutput>(),
                76usize,
                concat!("Size of: ", stringify!(ReflowOutput))
            );
            assert_eq!(
                ::std::mem::align_of::<ReflowOutput>(),
                4usize,
                concat!("Alignment of ", stringify!(ReflowOutput))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ReflowOutput>())).mBoundingMetrics as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ReflowOutput),
                    "::",
                    stringify!(mBoundingMetrics)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ReflowOutput>())).mCarriedOutBEndMargin as *const _
                        as usize
                },
                20usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ReflowOutput),
                    "::",
                    stringify!(mCarriedOutBEndMargin)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ReflowOutput>())).mOverflowAreas as *const _ as usize
                },
                28usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ReflowOutput),
                    "::",
                    stringify!(mOverflowAreas)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<ReflowOutput>())).mISize as *const _ as usize },
                60usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ReflowOutput),
                    "::",
                    stringify!(mISize)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<ReflowOutput>())).mBSize as *const _ as usize },
                64usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ReflowOutput),
                    "::",
                    stringify!(mBSize)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ReflowOutput>())).mBlockStartAscent as *const _ as usize
                },
                68usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ReflowOutput),
                    "::",
                    stringify!(mBlockStartAscent)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ReflowOutput>())).mWritingMode as *const _ as usize
                },
                72usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ReflowOutput),
                    "::",
                    stringify!(mWritingMode)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct LookAndFeel {
            pub _address: u8,
        }
        pub use self::super::super::root::mozilla::StyleSystemColor as LookAndFeel_ColorID;
        pub const LookAndFeel_IntID_eIntID_CaretBlinkTime: root::mozilla::LookAndFeel_IntID = 0;
        pub const LookAndFeel_IntID_eIntID_CaretWidth: root::mozilla::LookAndFeel_IntID = 1;
        pub const LookAndFeel_IntID_eIntID_ShowCaretDuringSelection:
            root::mozilla::LookAndFeel_IntID = 2;
        pub const LookAndFeel_IntID_eIntID_SelectTextfieldsOnKeyFocus:
            root::mozilla::LookAndFeel_IntID = 3;
        pub const LookAndFeel_IntID_eIntID_SubmenuDelay: root::mozilla::LookAndFeel_IntID = 4;
        pub const LookAndFeel_IntID_eIntID_MenusCanOverlapOSBar: root::mozilla::LookAndFeel_IntID =
            5;
        pub const LookAndFeel_IntID_eIntID_UseOverlayScrollbars: root::mozilla::LookAndFeel_IntID =
            6;
        pub const LookAndFeel_IntID_eIntID_AllowOverlayScrollbarsOverlap:
            root::mozilla::LookAndFeel_IntID = 7;
        pub const LookAndFeel_IntID_eIntID_ShowHideScrollbars: root::mozilla::LookAndFeel_IntID = 8;
        pub const LookAndFeel_IntID_eIntID_SkipNavigatingDisabledMenuItem:
            root::mozilla::LookAndFeel_IntID = 9;
        pub const LookAndFeel_IntID_eIntID_DragThresholdX: root::mozilla::LookAndFeel_IntID = 10;
        pub const LookAndFeel_IntID_eIntID_DragThresholdY: root::mozilla::LookAndFeel_IntID = 11;
        pub const LookAndFeel_IntID_eIntID_UseAccessibilityTheme: root::mozilla::LookAndFeel_IntID =
            12;
        pub const LookAndFeel_IntID_eIntID_ScrollArrowStyle: root::mozilla::LookAndFeel_IntID = 13;
        pub const LookAndFeel_IntID_eIntID_ScrollSliderStyle: root::mozilla::LookAndFeel_IntID = 14;
        pub const LookAndFeel_IntID_eIntID_ScrollButtonLeftMouseButtonAction:
            root::mozilla::LookAndFeel_IntID = 15;
        pub const LookAndFeel_IntID_eIntID_ScrollButtonMiddleMouseButtonAction:
            root::mozilla::LookAndFeel_IntID = 16;
        pub const LookAndFeel_IntID_eIntID_ScrollButtonRightMouseButtonAction:
            root::mozilla::LookAndFeel_IntID = 17;
        pub const LookAndFeel_IntID_eIntID_TreeOpenDelay: root::mozilla::LookAndFeel_IntID = 18;
        pub const LookAndFeel_IntID_eIntID_TreeCloseDelay: root::mozilla::LookAndFeel_IntID = 19;
        pub const LookAndFeel_IntID_eIntID_TreeLazyScrollDelay: root::mozilla::LookAndFeel_IntID =
            20;
        pub const LookAndFeel_IntID_eIntID_TreeScrollDelay: root::mozilla::LookAndFeel_IntID = 21;
        pub const LookAndFeel_IntID_eIntID_TreeScrollLinesMax: root::mozilla::LookAndFeel_IntID =
            22;
        pub const LookAndFeel_IntID_eIntID_TabFocusModel: root::mozilla::LookAndFeel_IntID = 23;
        pub const LookAndFeel_IntID_eIntID_ChosenMenuItemsShouldBlink:
            root::mozilla::LookAndFeel_IntID = 24;
        pub const LookAndFeel_IntID_eIntID_WindowsAccentColorInTitlebar:
            root::mozilla::LookAndFeel_IntID = 25;
        pub const LookAndFeel_IntID_eIntID_WindowsDefaultTheme: root::mozilla::LookAndFeel_IntID =
            26;
        pub const LookAndFeel_IntID_eIntID_DWMCompositor: root::mozilla::LookAndFeel_IntID = 27;
        pub const LookAndFeel_IntID_eIntID_WindowsClassic: root::mozilla::LookAndFeel_IntID = 28;
        pub const LookAndFeel_IntID_eIntID_WindowsGlass: root::mozilla::LookAndFeel_IntID = 29;
        pub const LookAndFeel_IntID_eIntID_TouchEnabled: root::mozilla::LookAndFeel_IntID = 30;
        pub const LookAndFeel_IntID_eIntID_MacGraphiteTheme: root::mozilla::LookAndFeel_IntID = 31;
        pub const LookAndFeel_IntID_eIntID_MacYosemiteTheme: root::mozilla::LookAndFeel_IntID = 32;
        pub const LookAndFeel_IntID_eIntID_AlertNotificationOrigin:
            root::mozilla::LookAndFeel_IntID = 33;
        #[doc = " If true, clicking on a scrollbar (not as in dragging the thumb) defaults"]
        #[doc = " to scrolling the view corresponding to the clicked point. Otherwise, we"]
        #[doc = " only do so if the scrollbar is clicked using the middle mouse button or"]
        #[doc = " if shift is pressed when the scrollbar is clicked."]
        pub const LookAndFeel_IntID_eIntID_ScrollToClick: root::mozilla::LookAndFeel_IntID = 34;
        #[doc = " IME and spell checker underline styles, the values should be"]
        #[doc = " NS_DECORATION_LINE_STYLE_*.  They are defined below."]
        pub const LookAndFeel_IntID_eIntID_IMERawInputUnderlineStyle:
            root::mozilla::LookAndFeel_IntID = 35;
        #[doc = " IME and spell checker underline styles, the values should be"]
        #[doc = " NS_DECORATION_LINE_STYLE_*.  They are defined below."]
        pub const LookAndFeel_IntID_eIntID_IMESelectedRawTextUnderlineStyle:
            root::mozilla::LookAndFeel_IntID = 36;
        #[doc = " IME and spell checker underline styles, the values should be"]
        #[doc = " NS_DECORATION_LINE_STYLE_*.  They are defined below."]
        pub const LookAndFeel_IntID_eIntID_IMEConvertedTextUnderlineStyle:
            root::mozilla::LookAndFeel_IntID = 37;
        #[doc = " IME and spell checker underline styles, the values should be"]
        #[doc = " NS_DECORATION_LINE_STYLE_*.  They are defined below."]
        pub const LookAndFeel_IntID_eIntID_IMESelectedConvertedTextUnderline:
            root::mozilla::LookAndFeel_IntID = 38;
        #[doc = " IME and spell checker underline styles, the values should be"]
        #[doc = " NS_DECORATION_LINE_STYLE_*.  They are defined below."]
        pub const LookAndFeel_IntID_eIntID_SpellCheckerUnderlineStyle:
            root::mozilla::LookAndFeel_IntID = 39;
        #[doc = " If this metric != 0, support window dragging on the menubar."]
        pub const LookAndFeel_IntID_eIntID_MenuBarDrag: root::mozilla::LookAndFeel_IntID = 40;
        #[doc = " Return the appropriate WindowsThemeIdentifier for the current theme."]
        pub const LookAndFeel_IntID_eIntID_WindowsThemeIdentifier:
            root::mozilla::LookAndFeel_IntID = 41;
        #[doc = " Return an appropriate os version identifier."]
        pub const LookAndFeel_IntID_eIntID_OperatingSystemVersionIdentifier:
            root::mozilla::LookAndFeel_IntID = 42;
        #[doc = " 0: scrollbar button repeats to scroll only when cursor is on the button."]
        #[doc = " 1: scrollbar button repeats to scroll even if cursor is outside of it."]
        pub const LookAndFeel_IntID_eIntID_ScrollbarButtonAutoRepeatBehavior:
            root::mozilla::LookAndFeel_IntID = 43;
        #[doc = " Delay before showing a tooltip."]
        pub const LookAndFeel_IntID_eIntID_TooltipDelay: root::mozilla::LookAndFeel_IntID = 44;
        #[doc = " Delay before showing a tooltip."]
        pub const LookAndFeel_IntID_eIntID_SwipeAnimationEnabled: root::mozilla::LookAndFeel_IntID =
            45;
        #[doc = " Delay before showing a tooltip."]
        pub const LookAndFeel_IntID_eIntID_ScrollbarDisplayOnMouseMove:
            root::mozilla::LookAndFeel_IntID = 46;
        #[doc = " Delay before showing a tooltip."]
        pub const LookAndFeel_IntID_eIntID_ScrollbarFadeBeginDelay:
            root::mozilla::LookAndFeel_IntID = 47;
        #[doc = " Delay before showing a tooltip."]
        pub const LookAndFeel_IntID_eIntID_ScrollbarFadeDuration: root::mozilla::LookAndFeel_IntID =
            48;
        #[doc = " Distance in pixels to offset the context menu from the cursor"]
        #[doc = " on open."]
        pub const LookAndFeel_IntID_eIntID_ContextMenuOffsetVertical:
            root::mozilla::LookAndFeel_IntID = 49;
        #[doc = " Distance in pixels to offset the context menu from the cursor"]
        #[doc = " on open."]
        pub const LookAndFeel_IntID_eIntID_ContextMenuOffsetHorizontal:
            root::mozilla::LookAndFeel_IntID = 50;
        #[doc = " Distance in pixels to offset the context menu from the cursor"]
        #[doc = " on open."]
        pub const LookAndFeel_IntID_eIntID_GTKCSDAvailable: root::mozilla::LookAndFeel_IntID = 51;
        #[doc = " Distance in pixels to offset the context menu from the cursor"]
        #[doc = " on open."]
        pub const LookAndFeel_IntID_eIntID_GTKCSDHideTitlebarByDefault:
            root::mozilla::LookAndFeel_IntID = 52;
        #[doc = " Distance in pixels to offset the context menu from the cursor"]
        #[doc = " on open."]
        pub const LookAndFeel_IntID_eIntID_GTKCSDTransparentBackground:
            root::mozilla::LookAndFeel_IntID = 53;
        #[doc = " Distance in pixels to offset the context menu from the cursor"]
        #[doc = " on open."]
        pub const LookAndFeel_IntID_eIntID_GTKCSDMinimizeButton: root::mozilla::LookAndFeel_IntID =
            54;
        #[doc = " Distance in pixels to offset the context menu from the cursor"]
        #[doc = " on open."]
        pub const LookAndFeel_IntID_eIntID_GTKCSDMaximizeButton: root::mozilla::LookAndFeel_IntID =
            55;
        #[doc = " Distance in pixels to offset the context menu from the cursor"]
        #[doc = " on open."]
        pub const LookAndFeel_IntID_eIntID_GTKCSDCloseButton: root::mozilla::LookAndFeel_IntID = 56;
        #[doc = " Distance in pixels to offset the context menu from the cursor"]
        #[doc = " on open."]
        pub const LookAndFeel_IntID_eIntID_GTKCSDReversedPlacement:
            root::mozilla::LookAndFeel_IntID = 57;
        #[doc = " Distance in pixels to offset the context menu from the cursor"]
        #[doc = " on open."]
        pub const LookAndFeel_IntID_eIntID_SystemUsesDarkTheme: root::mozilla::LookAndFeel_IntID =
            58;
        #[doc = " Corresponding to prefers-reduced-motion."]
        #[doc = " https://drafts.csswg.org/mediaqueries-5/#prefers-reduced-motion"]
        #[doc = " 0: no-preference"]
        #[doc = " 1: reduce"]
        pub const LookAndFeel_IntID_eIntID_PrefersReducedMotion: root::mozilla::LookAndFeel_IntID =
            59;
        #[doc = " Corresponding to PointerCapabilities in ServoTypes.h"]
        #[doc = " 0: None"]
        #[doc = " 1: Coarse"]
        #[doc = " 2: Fine"]
        #[doc = " 4: Hover"]
        pub const LookAndFeel_IntID_eIntID_PrimaryPointerCapabilities:
            root::mozilla::LookAndFeel_IntID = 60;
        #[doc = " Corresponding to union of PointerCapabilities values in ServoTypes.h"]
        #[doc = " E.g. if there is a mouse and a digitizer, the value will be"]
        #[doc = " \'Coarse | Fine | Hover\'."]
        pub const LookAndFeel_IntID_eIntID_AllPointerCapabilities:
            root::mozilla::LookAndFeel_IntID = 61;
        pub type LookAndFeel_IntID = u32;
        pub const LookAndFeel_WindowsTheme_eWindowsTheme_Generic:
            root::mozilla::LookAndFeel_WindowsTheme = 0;
        pub const LookAndFeel_WindowsTheme_eWindowsTheme_Classic:
            root::mozilla::LookAndFeel_WindowsTheme = 1;
        pub const LookAndFeel_WindowsTheme_eWindowsTheme_Aero:
            root::mozilla::LookAndFeel_WindowsTheme = 2;
        pub const LookAndFeel_WindowsTheme_eWindowsTheme_LunaBlue:
            root::mozilla::LookAndFeel_WindowsTheme = 3;
        pub const LookAndFeel_WindowsTheme_eWindowsTheme_LunaOlive:
            root::mozilla::LookAndFeel_WindowsTheme = 4;
        pub const LookAndFeel_WindowsTheme_eWindowsTheme_LunaSilver:
            root::mozilla::LookAndFeel_WindowsTheme = 5;
        pub const LookAndFeel_WindowsTheme_eWindowsTheme_Royale:
            root::mozilla::LookAndFeel_WindowsTheme = 6;
        pub const LookAndFeel_WindowsTheme_eWindowsTheme_Zune:
            root::mozilla::LookAndFeel_WindowsTheme = 7;
        pub const LookAndFeel_WindowsTheme_eWindowsTheme_AeroLite:
            root::mozilla::LookAndFeel_WindowsTheme = 8;
        #[doc = " Windows themes we currently detect."]
        pub type LookAndFeel_WindowsTheme = u32;
        pub const LookAndFeel_OperatingSystemVersion_eOperatingSystemVersion_Windows7:
            root::mozilla::LookAndFeel_OperatingSystemVersion = 2;
        pub const LookAndFeel_OperatingSystemVersion_eOperatingSystemVersion_Windows8:
            root::mozilla::LookAndFeel_OperatingSystemVersion = 3;
        pub const LookAndFeel_OperatingSystemVersion_eOperatingSystemVersion_Windows10:
            root::mozilla::LookAndFeel_OperatingSystemVersion = 4;
        pub const LookAndFeel_OperatingSystemVersion_eOperatingSystemVersion_Unknown:
            root::mozilla::LookAndFeel_OperatingSystemVersion = 5;
        #[doc = " Operating system versions."]
        pub type LookAndFeel_OperatingSystemVersion = u32;
        pub const LookAndFeel_eScrollArrow_None: root::mozilla::LookAndFeel__bindgen_ty_1 = 0;
        pub const LookAndFeel_eScrollArrow_StartBackward: root::mozilla::LookAndFeel__bindgen_ty_1 =
            4096;
        pub const LookAndFeel_eScrollArrow_StartForward: root::mozilla::LookAndFeel__bindgen_ty_1 =
            256;
        pub const LookAndFeel_eScrollArrow_EndBackward: root::mozilla::LookAndFeel__bindgen_ty_1 =
            16;
        pub const LookAndFeel_eScrollArrow_EndForward: root::mozilla::LookAndFeel__bindgen_ty_1 = 1;
        pub type LookAndFeel__bindgen_ty_1 = u32;
        pub const LookAndFeel_eScrollArrowStyle_Single: root::mozilla::LookAndFeel__bindgen_ty_2 =
            4097;
        pub const LookAndFeel_eScrollArrowStyle_BothAtBottom:
            root::mozilla::LookAndFeel__bindgen_ty_2 = 17;
        pub const LookAndFeel_eScrollArrowStyle_BothAtEachEnd:
            root::mozilla::LookAndFeel__bindgen_ty_2 = 4369;
        pub const LookAndFeel_eScrollArrowStyle_BothAtTop:
            root::mozilla::LookAndFeel__bindgen_ty_2 = 4352;
        pub type LookAndFeel__bindgen_ty_2 = u32;
        pub const LookAndFeel_eScrollThumbStyle_Normal: root::mozilla::LookAndFeel__bindgen_ty_3 =
            0;
        pub const LookAndFeel_eScrollThumbStyle_Proportional:
            root::mozilla::LookAndFeel__bindgen_ty_3 = 1;
        pub type LookAndFeel__bindgen_ty_3 = u32;
        pub const LookAndFeel_FloatID_eFloatID_IMEUnderlineRelativeSize:
            root::mozilla::LookAndFeel_FloatID = 0;
        pub const LookAndFeel_FloatID_eFloatID_SpellCheckerUnderlineRelativeSize:
            root::mozilla::LookAndFeel_FloatID = 1;
        pub const LookAndFeel_FloatID_eFloatID_CaretAspectRatio:
            root::mozilla::LookAndFeel_FloatID = 2;
        pub type LookAndFeel_FloatID = u32;
        impl root::mozilla::LookAndFeel_FontID {
            pub const FontID_MINIMUM: root::mozilla::LookAndFeel_FontID =
                LookAndFeel_FontID::eFont_Caption;
        }
        impl root::mozilla::LookAndFeel_FontID {
            pub const FontID_MAXIMUM: root::mozilla::LookAndFeel_FontID =
                LookAndFeel_FontID::eFont_Widget;
        }
        #[repr(u32)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum LookAndFeel_FontID {
            eFont_Caption = 1,
            eFont_Icon = 2,
            eFont_Menu = 3,
            eFont_MessageBox = 4,
            eFont_SmallCaption = 5,
            eFont_StatusBar = 6,
            eFont_Window = 7,
            eFont_Document = 8,
            eFont_Workspace = 9,
            eFont_Desktop = 10,
            eFont_Info = 11,
            eFont_Dialog = 12,
            eFont_Button = 13,
            eFont_PullDownMenu = 14,
            eFont_List = 15,
            eFont_Field = 16,
            eFont_Tooltips = 17,
            eFont_Widget = 18,
        }
        #[test]
        fn bindgen_test_layout_LookAndFeel() {
            assert_eq!(
                ::std::mem::size_of::<LookAndFeel>(),
                1usize,
                concat!("Size of: ", stringify!(LookAndFeel))
            );
            assert_eq!(
                ::std::mem::align_of::<LookAndFeel>(),
                1usize,
                concat!("Alignment of ", stringify!(LookAndFeel))
            );
        }
        pub const CSSPropFlags_Inaccessible: root::mozilla::CSSPropFlags = 1;
        pub const CSSPropFlags_GetCSNeedsLayoutFlush: root::mozilla::CSSPropFlags = 2;
        pub const CSSPropFlags_EnabledInUASheets: root::mozilla::CSSPropFlags = 4;
        pub const CSSPropFlags_EnabledInChrome: root::mozilla::CSSPropFlags = 8;
        pub const CSSPropFlags_EnabledInUASheetsAndChrome: root::mozilla::CSSPropFlags = 12;
        pub const CSSPropFlags_EnabledMask: root::mozilla::CSSPropFlags = 12;
        pub const CSSPropFlags_CanAnimateOnCompositor: root::mozilla::CSSPropFlags = 16;
        pub const CSSPropFlags_Internal: root::mozilla::CSSPropFlags = 32;
        pub const CSSPropFlags_SerializedByServo: root::mozilla::CSSPropFlags = 64;
        pub const CSSPropFlags_IsLogical: root::mozilla::CSSPropFlags = 128;
        pub type CSSPropFlags = u8;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGAnimatedBoolean {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGAnimatedEnumeration {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGAnimatedInteger {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGAnimatedLengthList {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGAnimatedNumber {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGAnimatedNumberList {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGAnimatedString {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SVGEnumMapping {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct ServoRestyleState {
            _unused: [u8; 0],
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct DisplayItemData {
            _unused: [u8; 0],
        }
        pub const LayoutFrameType_Backdrop: root::mozilla::LayoutFrameType = 0;
        pub const LayoutFrameType_Block: root::mozilla::LayoutFrameType = 1;
        pub const LayoutFrameType_Box: root::mozilla::LayoutFrameType = 2;
        pub const LayoutFrameType_Br: root::mozilla::LayoutFrameType = 3;
        pub const LayoutFrameType_Bullet: root::mozilla::LayoutFrameType = 4;
        pub const LayoutFrameType_BCTableCell: root::mozilla::LayoutFrameType = 5;
        pub const LayoutFrameType_Canvas: root::mozilla::LayoutFrameType = 6;
        pub const LayoutFrameType_CheckboxRadio: root::mozilla::LayoutFrameType = 7;
        pub const LayoutFrameType_ColorControl: root::mozilla::LayoutFrameType = 8;
        pub const LayoutFrameType_ColumnSet: root::mozilla::LayoutFrameType = 9;
        pub const LayoutFrameType_ColumnSetWrapper: root::mozilla::LayoutFrameType = 10;
        pub const LayoutFrameType_ComboboxControl: root::mozilla::LayoutFrameType = 11;
        pub const LayoutFrameType_ComboboxDisplay: root::mozilla::LayoutFrameType = 12;
        pub const LayoutFrameType_Deck: root::mozilla::LayoutFrameType = 13;
        pub const LayoutFrameType_DateTimeControl: root::mozilla::LayoutFrameType = 14;
        pub const LayoutFrameType_Details: root::mozilla::LayoutFrameType = 15;
        pub const LayoutFrameType_FieldSet: root::mozilla::LayoutFrameType = 16;
        pub const LayoutFrameType_FlexContainer: root::mozilla::LayoutFrameType = 17;
        pub const LayoutFrameType_FrameSet: root::mozilla::LayoutFrameType = 18;
        pub const LayoutFrameType_GfxButtonControl: root::mozilla::LayoutFrameType = 19;
        pub const LayoutFrameType_GridContainer: root::mozilla::LayoutFrameType = 20;
        pub const LayoutFrameType_HTMLButtonControl: root::mozilla::LayoutFrameType = 21;
        pub const LayoutFrameType_HTMLCanvas: root::mozilla::LayoutFrameType = 22;
        pub const LayoutFrameType_HTMLVideo: root::mozilla::LayoutFrameType = 23;
        pub const LayoutFrameType_Image: root::mozilla::LayoutFrameType = 24;
        pub const LayoutFrameType_ImageBox: root::mozilla::LayoutFrameType = 25;
        pub const LayoutFrameType_ImageControl: root::mozilla::LayoutFrameType = 26;
        pub const LayoutFrameType_Inline: root::mozilla::LayoutFrameType = 27;
        pub const LayoutFrameType_LeafBox: root::mozilla::LayoutFrameType = 28;
        pub const LayoutFrameType_Legend: root::mozilla::LayoutFrameType = 29;
        pub const LayoutFrameType_Letter: root::mozilla::LayoutFrameType = 30;
        pub const LayoutFrameType_Line: root::mozilla::LayoutFrameType = 31;
        pub const LayoutFrameType_ListControl: root::mozilla::LayoutFrameType = 32;
        pub const LayoutFrameType_Menu: root::mozilla::LayoutFrameType = 33;
        pub const LayoutFrameType_MenuPopup: root::mozilla::LayoutFrameType = 34;
        pub const LayoutFrameType_Meter: root::mozilla::LayoutFrameType = 35;
        pub const LayoutFrameType_None: root::mozilla::LayoutFrameType = 36;
        pub const LayoutFrameType_NumberControl: root::mozilla::LayoutFrameType = 37;
        pub const LayoutFrameType_Object: root::mozilla::LayoutFrameType = 38;
        pub const LayoutFrameType_Page: root::mozilla::LayoutFrameType = 39;
        pub const LayoutFrameType_PageBreak: root::mozilla::LayoutFrameType = 40;
        pub const LayoutFrameType_PageContent: root::mozilla::LayoutFrameType = 41;
        pub const LayoutFrameType_Placeholder: root::mozilla::LayoutFrameType = 42;
        pub const LayoutFrameType_Progress: root::mozilla::LayoutFrameType = 43;
        pub const LayoutFrameType_PopupSet: root::mozilla::LayoutFrameType = 44;
        pub const LayoutFrameType_Range: root::mozilla::LayoutFrameType = 45;
        pub const LayoutFrameType_Root: root::mozilla::LayoutFrameType = 46;
        pub const LayoutFrameType_Ruby: root::mozilla::LayoutFrameType = 47;
        pub const LayoutFrameType_RubyBase: root::mozilla::LayoutFrameType = 48;
        pub const LayoutFrameType_RubyBaseContainer: root::mozilla::LayoutFrameType = 49;
        pub const LayoutFrameType_RubyText: root::mozilla::LayoutFrameType = 50;
        pub const LayoutFrameType_RubyTextContainer: root::mozilla::LayoutFrameType = 51;
        pub const LayoutFrameType_Scroll: root::mozilla::LayoutFrameType = 52;
        pub const LayoutFrameType_Scrollbar: root::mozilla::LayoutFrameType = 53;
        pub const LayoutFrameType_Sequence: root::mozilla::LayoutFrameType = 54;
        pub const LayoutFrameType_Slider: root::mozilla::LayoutFrameType = 55;
        pub const LayoutFrameType_SubDocument: root::mozilla::LayoutFrameType = 56;
        pub const LayoutFrameType_SVGA: root::mozilla::LayoutFrameType = 57;
        pub const LayoutFrameType_SVGClipPath: root::mozilla::LayoutFrameType = 58;
        pub const LayoutFrameType_SVGFilter: root::mozilla::LayoutFrameType = 59;
        pub const LayoutFrameType_SVGForeignObject: root::mozilla::LayoutFrameType = 60;
        pub const LayoutFrameType_SVGFEContainer: root::mozilla::LayoutFrameType = 61;
        pub const LayoutFrameType_SVGFELeaf: root::mozilla::LayoutFrameType = 62;
        pub const LayoutFrameType_SVGFEImage: root::mozilla::LayoutFrameType = 63;
        pub const LayoutFrameType_SVGFEUnstyledLeaf: root::mozilla::LayoutFrameType = 64;
        pub const LayoutFrameType_SVGG: root::mozilla::LayoutFrameType = 65;
        pub const LayoutFrameType_SVGGenericContainer: root::mozilla::LayoutFrameType = 66;
        pub const LayoutFrameType_SVGGeometry: root::mozilla::LayoutFrameType = 67;
        pub const LayoutFrameType_SVGImage: root::mozilla::LayoutFrameType = 68;
        pub const LayoutFrameType_SVGInnerSVG: root::mozilla::LayoutFrameType = 69;
        pub const LayoutFrameType_SVGLinearGradient: root::mozilla::LayoutFrameType = 70;
        pub const LayoutFrameType_SVGMask: root::mozilla::LayoutFrameType = 71;
        pub const LayoutFrameType_SVGMarker: root::mozilla::LayoutFrameType = 72;
        pub const LayoutFrameType_SVGMarkerAnonChild: root::mozilla::LayoutFrameType = 73;
        pub const LayoutFrameType_SVGOuterSVG: root::mozilla::LayoutFrameType = 74;
        pub const LayoutFrameType_SVGOuterSVGAnonChild: root::mozilla::LayoutFrameType = 75;
        pub const LayoutFrameType_SVGPattern: root::mozilla::LayoutFrameType = 76;
        pub const LayoutFrameType_SVGRadialGradient: root::mozilla::LayoutFrameType = 77;
        pub const LayoutFrameType_SVGStop: root::mozilla::LayoutFrameType = 78;
        pub const LayoutFrameType_SVGSwitch: root::mozilla::LayoutFrameType = 79;
        pub const LayoutFrameType_SVGSymbol: root::mozilla::LayoutFrameType = 80;
        pub const LayoutFrameType_SVGText: root::mozilla::LayoutFrameType = 81;
        pub const LayoutFrameType_SVGUse: root::mozilla::LayoutFrameType = 82;
        pub const LayoutFrameType_SVGView: root::mozilla::LayoutFrameType = 83;
        pub const LayoutFrameType_Table: root::mozilla::LayoutFrameType = 84;
        pub const LayoutFrameType_TableCell: root::mozilla::LayoutFrameType = 85;
        pub const LayoutFrameType_TableCol: root::mozilla::LayoutFrameType = 86;
        pub const LayoutFrameType_TableColGroup: root::mozilla::LayoutFrameType = 87;
        pub const LayoutFrameType_TableRow: root::mozilla::LayoutFrameType = 88;
        pub const LayoutFrameType_TableRowGroup: root::mozilla::LayoutFrameType = 89;
        pub const LayoutFrameType_TableWrapper: root::mozilla::LayoutFrameType = 90;
        pub const LayoutFrameType_Text: root::mozilla::LayoutFrameType = 91;
        pub const LayoutFrameType_TextInput: root::mozilla::LayoutFrameType = 92;
        pub const LayoutFrameType_Viewport: root::mozilla::LayoutFrameType = 93;
        pub const LayoutFrameType_XULLabel: root::mozilla::LayoutFrameType = 94;
        pub type LayoutFrameType = u8;
        pub const BaselineSharingGroup_First: root::mozilla::BaselineSharingGroup = 0;
        pub const BaselineSharingGroup_Last: root::mozilla::BaselineSharingGroup = 1;
        pub type BaselineSharingGroup = i32;
        pub const AlignmentContext_Inline: root::mozilla::AlignmentContext = 0;
        pub const AlignmentContext_Table: root::mozilla::AlignmentContext = 1;
        pub const AlignmentContext_Flexbox: root::mozilla::AlignmentContext = 2;
        pub const AlignmentContext_Grid: root::mozilla::AlignmentContext = 3;
        pub type AlignmentContext = i32;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct NonOwningAnimationTarget {
            pub mElement: *mut root::mozilla::dom::Element,
            pub mPseudoType: root::mozilla::PseudoStyleType,
        }
        #[test]
        fn bindgen_test_layout_NonOwningAnimationTarget() {
            assert_eq!(
                ::std::mem::size_of::<NonOwningAnimationTarget>(),
                16usize,
                concat!("Size of: ", stringify!(NonOwningAnimationTarget))
            );
            assert_eq!(
                ::std::mem::align_of::<NonOwningAnimationTarget>(),
                8usize,
                concat!("Alignment of ", stringify!(NonOwningAnimationTarget))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<NonOwningAnimationTarget>())).mElement as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(NonOwningAnimationTarget),
                    "::",
                    stringify!(mElement)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<NonOwningAnimationTarget>())).mPseudoType as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(NonOwningAnimationTarget),
                    "::",
                    stringify!(mPseudoType)
                )
            );
        }
        #[repr(C)]
        pub struct PseudoElementHashEntry {
            pub mElement: root::RefPtr<root::mozilla::dom::Element>,
            pub mPseudoType: root::mozilla::PseudoStyleType,
        }
        pub type PseudoElementHashEntry_KeyType = root::mozilla::NonOwningAnimationTarget;
        pub type PseudoElementHashEntry_KeyTypePointer =
            *const root::mozilla::NonOwningAnimationTarget;
        pub const PseudoElementHashEntry_ALLOW_MEMMOVE:
            root::mozilla::PseudoElementHashEntry__bindgen_ty_1 = 1;
        pub type PseudoElementHashEntry__bindgen_ty_1 = u32;
        #[test]
        fn bindgen_test_layout_PseudoElementHashEntry() {
            assert_eq!(
                ::std::mem::size_of::<PseudoElementHashEntry>(),
                16usize,
                concat!("Size of: ", stringify!(PseudoElementHashEntry))
            );
            assert_eq!(
                ::std::mem::align_of::<PseudoElementHashEntry>(),
                8usize,
                concat!("Alignment of ", stringify!(PseudoElementHashEntry))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PseudoElementHashEntry>())).mElement as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PseudoElementHashEntry),
                    "::",
                    stringify!(mElement)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<PseudoElementHashEntry>())).mPseudoType as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(PseudoElementHashEntry),
                    "::",
                    stringify!(mPseudoType)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct EffectCompositor {
            pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
            pub mPresContext: *mut root::nsPresContext,
            pub mElementsToRestyle: [u64; 8usize],
            pub mIsInPreTraverse: bool,
        }
        pub type EffectCompositor_HasThreadSafeRefCnt = root::mozilla::FalseType;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct EffectCompositor_cycleCollection {
            pub _base: root::nsCycleCollectionParticipant,
        }
        #[test]
        fn bindgen_test_layout_EffectCompositor_cycleCollection() {
            assert_eq!(
                ::std::mem::size_of::<EffectCompositor_cycleCollection>(),
                16usize,
                concat!("Size of: ", stringify!(EffectCompositor_cycleCollection))
            );
            assert_eq!(
                ::std::mem::align_of::<EffectCompositor_cycleCollection>(),
                8usize,
                concat!(
                    "Alignment of ",
                    stringify!(EffectCompositor_cycleCollection)
                )
            );
        }
        #[repr(u32)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum EffectCompositor_CascadeLevel {
            Animations = 0,
            Transitions = 1,
        }
        pub const EffectCompositor_RestyleType_Throttled:
            root::mozilla::EffectCompositor_RestyleType = 0;
        pub const EffectCompositor_RestyleType_Standard:
            root::mozilla::EffectCompositor_RestyleType = 1;
        pub const EffectCompositor_RestyleType_Layer: root::mozilla::EffectCompositor_RestyleType =
            2;
        pub type EffectCompositor_RestyleType = i32;
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla16EffectCompositor21_cycleCollectorGlobalE"]
            pub static mut EffectCompositor__cycleCollectorGlobal:
                root::mozilla::EffectCompositor_cycleCollection;
        }
        pub const EffectCompositor_kCascadeLevelCount: usize = 2;
        #[test]
        fn bindgen_test_layout_EffectCompositor() {
            assert_eq!(
                ::std::mem::size_of::<EffectCompositor>(),
                88usize,
                concat!("Size of: ", stringify!(EffectCompositor))
            );
            assert_eq!(
                ::std::mem::align_of::<EffectCompositor>(),
                8usize,
                concat!("Alignment of ", stringify!(EffectCompositor))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<EffectCompositor>())).mRefCnt as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(EffectCompositor),
                    "::",
                    stringify!(mRefCnt)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<EffectCompositor>())).mPresContext as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(EffectCompositor),
                    "::",
                    stringify!(mPresContext)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<EffectCompositor>())).mElementsToRestyle as *const _
                        as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(EffectCompositor),
                    "::",
                    stringify!(mElementsToRestyle)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<EffectCompositor>())).mIsInPreTraverse as *const _
                        as usize
                },
                80usize,
                concat!(
                    "Offset of field: ",
                    stringify!(EffectCompositor),
                    "::",
                    stringify!(mIsInPreTraverse)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct ServoTraversalStatistics {
            pub mElementsTraversed: u32,
            pub mElementsStyled: u32,
            pub mElementsMatched: u32,
            pub mStylesShared: u32,
            pub mStylesReused: u32,
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla24ServoTraversalStatistics7sActiveE"]
            pub static mut ServoTraversalStatistics_sActive: bool;
        }
        extern "C" {
            #[link_name = "\u{1}_ZN7mozilla24ServoTraversalStatistics10sSingletonE"]
            pub static mut ServoTraversalStatistics_sSingleton:
                root::mozilla::ServoTraversalStatistics;
        }
        #[test]
        fn bindgen_test_layout_ServoTraversalStatistics() {
            assert_eq!(
                ::std::mem::size_of::<ServoTraversalStatistics>(),
                20usize,
                concat!("Size of: ", stringify!(ServoTraversalStatistics))
            );
            assert_eq!(
                ::std::mem::align_of::<ServoTraversalStatistics>(),
                4usize,
                concat!("Alignment of ", stringify!(ServoTraversalStatistics))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoTraversalStatistics>())).mElementsTraversed
                        as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoTraversalStatistics),
                    "::",
                    stringify!(mElementsTraversed)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoTraversalStatistics>())).mElementsStyled as *const _
                        as usize
                },
                4usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoTraversalStatistics),
                    "::",
                    stringify!(mElementsStyled)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoTraversalStatistics>())).mElementsMatched
                        as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoTraversalStatistics),
                    "::",
                    stringify!(mElementsMatched)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoTraversalStatistics>())).mStylesShared as *const _
                        as usize
                },
                12usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoTraversalStatistics),
                    "::",
                    stringify!(mStylesShared)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ServoTraversalStatistics>())).mStylesReused as *const _
                        as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ServoTraversalStatistics),
                    "::",
                    stringify!(mStylesReused)
                )
            );
        }
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct InfallibleAllocPolicy {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_InfallibleAllocPolicy() {
        assert_eq!(
            ::std::mem::size_of::<InfallibleAllocPolicy>(),
            1usize,
            concat!("Size of: ", stringify!(InfallibleAllocPolicy))
        );
        assert_eq!(
            ::std::mem::align_of::<InfallibleAllocPolicy>(),
            1usize,
            concat!("Alignment of ", stringify!(InfallibleAllocPolicy))
        );
    }
    #[doc = " MozRefCountType is Mozilla\'s reference count type."]
    #[doc = ""]
    #[doc = " We use the same type to represent the refcount of RefCounted objects"]
    #[doc = " as well, in order to be able to use the leak detection facilities"]
    #[doc = " that are implemented by XPCOM."]
    #[doc = ""]
    #[doc = " Note that this type is not in the mozilla namespace so that it is"]
    #[doc = " usable for both C and C++ code."]
    pub type MozRefCountType = usize;
    impl root::nsresult {
        pub const NS_ERROR_NO_INTERFACE: root::nsresult = nsresult::NS_NOINTERFACE;
    }
    impl root::nsresult {
        pub const NS_ERROR_INVALID_ARG: root::nsresult = nsresult::NS_ERROR_ILLEGAL_VALUE;
    }
    impl root::nsresult {
        pub const NS_ERROR_INVALID_POINTER: root::nsresult = nsresult::NS_ERROR_ILLEGAL_VALUE;
    }
    impl root::nsresult {
        pub const NS_ERROR_NULL_POINTER: root::nsresult = nsresult::NS_ERROR_ILLEGAL_VALUE;
    }
    impl root::nsresult {
        pub const NS_BINDING_SUCCEEDED: root::nsresult = nsresult::NS_OK;
    }
    impl root::nsresult {
        pub const NS_NET_STATUS_RESOLVING_HOST: root::nsresult = nsresult::NS_BINDING_REDIRECTED;
    }
    impl root::nsresult {
        pub const NS_NET_STATUS_RESOLVED_HOST: root::nsresult =
            nsresult::NS_ERROR_ALREADY_CONNECTED;
    }
    impl root::nsresult {
        pub const NS_NET_STATUS_CONNECTED_TO: root::nsresult = nsresult::NS_BINDING_RETARGETED;
    }
    impl root::nsresult {
        pub const NS_NET_STATUS_TLS_HANDSHAKE_STARTING: root::nsresult =
            nsresult::NS_ERROR_NOT_CONNECTED;
    }
    impl root::nsresult {
        pub const NS_NET_STATUS_TLS_HANDSHAKE_ENDED: root::nsresult =
            nsresult::NS_ERROR_CONNECTION_REFUSED;
    }
    impl root::nsresult {
        pub const NS_NET_STATUS_WAITING_FOR: root::nsresult = nsresult::NS_ERROR_MALFORMED_URI;
    }
    impl root::nsresult {
        pub const NS_ERROR_HTMLPARSER_CONTINUE: root::nsresult = nsresult::NS_OK;
    }
    impl root::nsresult {
        pub const NS_RDF_ASSERTION_ACCEPTED: root::nsresult = nsresult::NS_OK;
    }
    impl root::nsresult {
        pub const NS_ERROR_ILLEGAL_INPUT: root::nsresult = nsresult::NS_ERROR_UDEC_ILLEGALINPUT;
    }
    impl root::nsresult {
        pub const NS_ERROR_XPATH_INVALID_ARG: root::nsresult = nsresult::NS_ERROR_ILLEGAL_VALUE;
    }
    impl root::nsresult {
        pub const NS_SUCCESS_RESTART_APP: root::nsresult = nsresult::NS_SUCCESS_DONT_FIXUP;
    }
    #[repr(u32)]
    #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
    pub enum nsresult {
        NS_OK = 0,
        NS_ERROR_BASE = 3253927936,
        NS_ERROR_NOT_INITIALIZED = 3253927937,
        NS_ERROR_ALREADY_INITIALIZED = 3253927938,
        NS_ERROR_NOT_IMPLEMENTED = 2147500033,
        NS_NOINTERFACE = 2147500034,
        NS_ERROR_ABORT = 2147500036,
        NS_ERROR_FAILURE = 2147500037,
        NS_ERROR_UNEXPECTED = 2147549183,
        NS_ERROR_OUT_OF_MEMORY = 2147942414,
        NS_ERROR_ILLEGAL_VALUE = 2147942487,
        NS_ERROR_NO_AGGREGATION = 2147746064,
        NS_ERROR_NOT_AVAILABLE = 2147746065,
        NS_ERROR_FACTORY_NOT_REGISTERED = 2147746132,
        NS_ERROR_FACTORY_REGISTER_AGAIN = 2147746133,
        NS_ERROR_FACTORY_NOT_LOADED = 2147746296,
        NS_ERROR_FACTORY_NO_SIGNATURE_SUPPORT = 3253928193,
        NS_ERROR_FACTORY_EXISTS = 3253928192,
        NS_ERROR_CANNOT_CONVERT_DATA = 2152071169,
        NS_ERROR_OBJECT_IS_IMMUTABLE = 2152071170,
        NS_ERROR_LOSS_OF_SIGNIFICANT_DATA = 2152071171,
        NS_ERROR_NOT_SAME_THREAD = 2152071172,
        NS_ERROR_ILLEGAL_DURING_SHUTDOWN = 2152071198,
        NS_ERROR_SERVICE_NOT_AVAILABLE = 2152071190,
        NS_SUCCESS_LOSS_OF_INSIGNIFICANT_DATA = 4587521,
        NS_SUCCESS_INTERRUPTED_TRAVERSE = 4587522,
        NS_BASE_STREAM_CLOSED = 2152136706,
        NS_BASE_STREAM_OSERROR = 2152136707,
        NS_BASE_STREAM_ILLEGAL_ARGS = 2152136708,
        NS_BASE_STREAM_NO_CONVERTER = 2152136709,
        NS_BASE_STREAM_BAD_CONVERSION = 2152136710,
        NS_BASE_STREAM_WOULD_BLOCK = 2152136711,
        NS_ERROR_GFX_PRINTER_NO_PRINTER_AVAILABLE = 2152202241,
        NS_ERROR_GFX_PRINTER_NAME_NOT_FOUND = 2152202242,
        NS_ERROR_GFX_PRINTER_COULD_NOT_OPEN_FILE = 2152202243,
        NS_ERROR_GFX_PRINTER_STARTDOC = 2152202244,
        NS_ERROR_GFX_PRINTER_ENDDOC = 2152202245,
        NS_ERROR_GFX_PRINTER_STARTPAGE = 2152202246,
        NS_ERROR_GFX_PRINTER_DOC_IS_BUSY = 2152202247,
        NS_ERROR_GFX_CMAP_MALFORMED = 2152202291,
        NS_SUCCESS_EVENT_CONSUMED = 4784129,
        NS_SUCCESS_EVENT_HANDLED_ASYNCHRONOUSLY = 4784130,
        NS_BINDING_FAILED = 2152398849,
        NS_BINDING_ABORTED = 2152398850,
        NS_BINDING_REDIRECTED = 2152398851,
        NS_BINDING_RETARGETED = 2152398852,
        NS_ERROR_MALFORMED_URI = 2152398858,
        NS_ERROR_IN_PROGRESS = 2152398863,
        NS_ERROR_NO_CONTENT = 2152398865,
        NS_ERROR_UNKNOWN_PROTOCOL = 2152398866,
        NS_ERROR_INVALID_CONTENT_ENCODING = 2152398875,
        NS_ERROR_CORRUPTED_CONTENT = 2152398877,
        NS_ERROR_INVALID_SIGNATURE = 2152398906,
        NS_ERROR_FIRST_HEADER_FIELD_COMPONENT_EMPTY = 2152398882,
        NS_ERROR_ALREADY_OPENED = 2152398921,
        NS_ERROR_ALREADY_CONNECTED = 2152398859,
        NS_ERROR_NOT_CONNECTED = 2152398860,
        NS_ERROR_CONNECTION_REFUSED = 2152398861,
        NS_ERROR_NET_TIMEOUT = 2152398862,
        NS_ERROR_OFFLINE = 2152398864,
        NS_ERROR_PORT_ACCESS_NOT_ALLOWED = 2152398867,
        NS_ERROR_NET_RESET = 2152398868,
        NS_ERROR_NET_INTERRUPT = 2152398919,
        NS_ERROR_PROXY_CONNECTION_REFUSED = 2152398920,
        NS_ERROR_PROXY_AUTHENTICATION_FAILED = 2152399255,
        NS_ERROR_TOO_MANY_REQUESTS = 2152399277,
        NS_ERROR_PROXY_BAD_GATEWAY = 2152399350,
        NS_ERROR_PROXY_GATEWAY_TIMEOUT = 2152399352,
        NS_ERROR_NET_PARTIAL_TRANSFER = 2152398924,
        NS_ERROR_NET_INADEQUATE_SECURITY = 2152398930,
        NS_ERROR_NET_HTTP2_SENT_GOAWAY = 2152398931,
        NS_ERROR_NOT_RESUMABLE = 2152398873,
        NS_ERROR_REDIRECT_LOOP = 2152398879,
        NS_ERROR_ENTITY_CHANGED = 2152398880,
        NS_ERROR_UNSAFE_CONTENT_TYPE = 2152398922,
        NS_ERROR_REMOTE_XUL = 2152398923,
        NS_ERROR_LOAD_SHOWED_ERRORPAGE = 2152398925,
        NS_ERROR_DOCSHELL_DYING = 2152398926,
        NS_ERROR_FTP_LOGIN = 2152398869,
        NS_ERROR_FTP_CWD = 2152398870,
        NS_ERROR_FTP_PASV = 2152398871,
        NS_ERROR_FTP_PWD = 2152398872,
        NS_ERROR_FTP_LIST = 2152398876,
        NS_ERROR_UNKNOWN_HOST = 2152398878,
        NS_ERROR_DNS_LOOKUP_QUEUE_FULL = 2152398881,
        NS_ERROR_UNKNOWN_PROXY_HOST = 2152398890,
        NS_ERROR_UNKNOWN_SOCKET_TYPE = 2152398899,
        NS_ERROR_SOCKET_CREATE_FAILED = 2152398900,
        NS_ERROR_SOCKET_ADDRESS_NOT_SUPPORTED = 2152398901,
        NS_ERROR_SOCKET_ADDRESS_IN_USE = 2152398902,
        NS_ERROR_CACHE_KEY_NOT_FOUND = 2152398909,
        NS_ERROR_CACHE_DATA_IS_STREAM = 2152398910,
        NS_ERROR_CACHE_DATA_IS_NOT_STREAM = 2152398911,
        NS_ERROR_CACHE_WAIT_FOR_VALIDATION = 2152398912,
        NS_ERROR_CACHE_ENTRY_DOOMED = 2152398913,
        NS_ERROR_CACHE_READ_ACCESS_DENIED = 2152398914,
        NS_ERROR_CACHE_WRITE_ACCESS_DENIED = 2152398915,
        NS_ERROR_CACHE_IN_USE = 2152398916,
        NS_ERROR_DOCUMENT_NOT_CACHED = 2152398918,
        NS_ERROR_INSUFFICIENT_DOMAIN_LEVELS = 2152398928,
        NS_ERROR_HOST_IS_IP_ADDRESS = 2152398929,
        NS_SUCCESS_ADOPTED_DATA = 4915290,
        NS_NET_STATUS_BEGIN_FTP_TRANSACTION = 4915227,
        NS_NET_STATUS_END_FTP_TRANSACTION = 4915228,
        NS_SUCCESS_AUTH_FINISHED = 4915240,
        NS_NET_STATUS_READING = 2152398856,
        NS_NET_STATUS_WRITING = 2152398857,
        NS_NET_STATUS_CONNECTING_TO = 2152398855,
        NS_NET_STATUS_SENDING_TO = 2152398853,
        NS_NET_STATUS_RECEIVING_FROM = 2152398854,
        NS_ERROR_INTERCEPTION_FAILED = 2152398948,
        NS_ERROR_PLUGINS_PLUGINSNOTCHANGED = 2152465384,
        NS_ERROR_PLUGIN_DISABLED = 2152465385,
        NS_ERROR_PLUGIN_BLOCKLISTED = 2152465386,
        NS_ERROR_PLUGIN_TIME_RANGE_NOT_SUPPORTED = 2152465387,
        NS_ERROR_PLUGIN_CLICKTOPLAY = 2152465388,
        NS_OK_PARSE_SHEET = 5046273,
        NS_POSITION_BEFORE_TABLE = 5046275,
        NS_ERROR_HTMLPARSER_EOF = 2152596456,
        NS_ERROR_HTMLPARSER_UNKNOWN = 2152596457,
        NS_ERROR_HTMLPARSER_CANTPROPAGATE = 2152596458,
        NS_ERROR_HTMLPARSER_CONTEXTMISMATCH = 2152596459,
        NS_ERROR_HTMLPARSER_BADFILENAME = 2152596460,
        NS_ERROR_HTMLPARSER_BADURL = 2152596461,
        NS_ERROR_HTMLPARSER_INVALIDPARSERCONTEXT = 2152596462,
        NS_ERROR_HTMLPARSER_INTERRUPTED = 2152596463,
        NS_ERROR_HTMLPARSER_BLOCK = 2152596464,
        NS_ERROR_HTMLPARSER_BADTOKENIZER = 2152596465,
        NS_ERROR_HTMLPARSER_BADATTRIBUTE = 2152596466,
        NS_ERROR_HTMLPARSER_UNRESOLVEDDTD = 2152596467,
        NS_ERROR_HTMLPARSER_MISPLACEDTABLECONTENT = 2152596468,
        NS_ERROR_HTMLPARSER_BADDTD = 2152596469,
        NS_ERROR_HTMLPARSER_BADCONTEXT = 2152596470,
        NS_ERROR_HTMLPARSER_STOPPARSING = 2152596471,
        NS_ERROR_HTMLPARSER_UNTERMINATEDSTRINGLITERAL = 2152596472,
        NS_ERROR_HTMLPARSER_HIERARCHYTOODEEP = 2152596473,
        NS_ERROR_HTMLPARSER_FAKE_ENDTAG = 2152596474,
        NS_ERROR_HTMLPARSER_INVALID_COMMENT = 2152596475,
        NS_RDF_NO_VALUE = 5177346,
        NS_RDF_ASSERTION_REJECTED = 5177347,
        NS_RDF_STOP_VISIT = 5177348,
        NS_ERROR_UCONV_NOCONV = 2152726529,
        NS_ERROR_UDEC_ILLEGALINPUT = 2152726542,
        NS_OK_HAD_REPLACEMENTS = 5242883,
        NS_OK_UDEC_MOREINPUT = 5242892,
        NS_OK_UDEC_MOREOUTPUT = 5242893,
        NS_OK_UENC_MOREOUTPUT = 5242914,
        NS_ERROR_UENC_NOMAPPING = 5242915,
        NS_ERROR_FILE_UNRECOGNIZED_PATH = 2152857601,
        NS_ERROR_FILE_UNRESOLVABLE_SYMLINK = 2152857602,
        NS_ERROR_FILE_EXECUTION_FAILED = 2152857603,
        NS_ERROR_FILE_UNKNOWN_TYPE = 2152857604,
        NS_ERROR_FILE_DESTINATION_NOT_DIR = 2152857605,
        NS_ERROR_FILE_TARGET_DOES_NOT_EXIST = 2152857606,
        NS_ERROR_FILE_COPY_OR_MOVE_FAILED = 2152857607,
        NS_ERROR_FILE_ALREADY_EXISTS = 2152857608,
        NS_ERROR_FILE_INVALID_PATH = 2152857609,
        NS_ERROR_FILE_DISK_FULL = 2152857610,
        NS_ERROR_FILE_CORRUPTED = 2152857611,
        NS_ERROR_FILE_NOT_DIRECTORY = 2152857612,
        NS_ERROR_FILE_IS_DIRECTORY = 2152857613,
        NS_ERROR_FILE_IS_LOCKED = 2152857614,
        NS_ERROR_FILE_TOO_BIG = 2152857615,
        NS_ERROR_FILE_NO_DEVICE_SPACE = 2152857616,
        NS_ERROR_FILE_NAME_TOO_LONG = 2152857617,
        NS_ERROR_FILE_NOT_FOUND = 2152857618,
        NS_ERROR_FILE_READ_ONLY = 2152857619,
        NS_ERROR_FILE_DIR_NOT_EMPTY = 2152857620,
        NS_ERROR_FILE_ACCESS_DENIED = 2152857621,
        NS_SUCCESS_FILE_DIRECTORY_EMPTY = 5373953,
        NS_SUCCESS_AGGREGATE_RESULT = 5373954,
        NS_ERROR_DOM_INDEX_SIZE_ERR = 2152923137,
        NS_ERROR_DOM_HIERARCHY_REQUEST_ERR = 2152923139,
        NS_ERROR_DOM_WRONG_DOCUMENT_ERR = 2152923140,
        NS_ERROR_DOM_INVALID_CHARACTER_ERR = 2152923141,
        NS_ERROR_DOM_NO_MODIFICATION_ALLOWED_ERR = 2152923143,
        NS_ERROR_DOM_NOT_FOUND_ERR = 2152923144,
        NS_ERROR_DOM_NOT_SUPPORTED_ERR = 2152923145,
        NS_ERROR_DOM_INUSE_ATTRIBUTE_ERR = 2152923146,
        NS_ERROR_DOM_INVALID_STATE_ERR = 2152923147,
        NS_ERROR_DOM_SYNTAX_ERR = 2152923148,
        NS_ERROR_DOM_INVALID_MODIFICATION_ERR = 2152923149,
        NS_ERROR_DOM_NAMESPACE_ERR = 2152923150,
        NS_ERROR_DOM_INVALID_ACCESS_ERR = 2152923151,
        NS_ERROR_DOM_TYPE_MISMATCH_ERR = 2152923153,
        NS_ERROR_DOM_SECURITY_ERR = 2152923154,
        NS_ERROR_DOM_NETWORK_ERR = 2152923155,
        NS_ERROR_DOM_ABORT_ERR = 2152923156,
        NS_ERROR_DOM_URL_MISMATCH_ERR = 2152923157,
        NS_ERROR_DOM_QUOTA_EXCEEDED_ERR = 2152923158,
        NS_ERROR_DOM_TIMEOUT_ERR = 2152923159,
        NS_ERROR_DOM_INVALID_NODE_TYPE_ERR = 2152923160,
        NS_ERROR_DOM_DATA_CLONE_ERR = 2152923161,
        NS_ERROR_TYPE_ERR = 2152923162,
        NS_ERROR_RANGE_ERR = 2152923163,
        NS_ERROR_DOM_ENCODING_NOT_SUPPORTED_ERR = 2152923164,
        NS_ERROR_DOM_INVALID_POINTER_ERR = 2152923165,
        NS_ERROR_DOM_UNKNOWN_ERR = 2152923166,
        NS_ERROR_DOM_DATA_ERR = 2152923167,
        NS_ERROR_DOM_OPERATION_ERR = 2152923168,
        NS_ERROR_DOM_NOT_ALLOWED_ERR = 2152923169,
        NS_ERROR_DOM_SECMAN_ERR = 2152924137,
        NS_ERROR_DOM_WRONG_TYPE_ERR = 2152924138,
        NS_ERROR_DOM_NOT_OBJECT_ERR = 2152924139,
        NS_ERROR_DOM_NOT_XPC_OBJECT_ERR = 2152924140,
        NS_ERROR_DOM_NOT_NUMBER_ERR = 2152924141,
        NS_ERROR_DOM_NOT_BOOLEAN_ERR = 2152924142,
        NS_ERROR_DOM_NOT_FUNCTION_ERR = 2152924143,
        NS_ERROR_DOM_TOO_FEW_PARAMETERS_ERR = 2152924144,
        NS_ERROR_DOM_PROP_ACCESS_DENIED = 2152924146,
        NS_ERROR_DOM_XPCONNECT_ACCESS_DENIED = 2152924147,
        NS_ERROR_DOM_BAD_URI = 2152924148,
        NS_ERROR_DOM_RETVAL_UNDEFINED = 2152924149,
        NS_ERROR_UNCATCHABLE_EXCEPTION = 2152924151,
        NS_ERROR_DOM_MALFORMED_URI = 2152924152,
        NS_ERROR_DOM_INVALID_HEADER_NAME = 2152924153,
        NS_ERROR_DOM_INVALID_STATE_XHR_HAS_INVALID_CONTEXT = 2152924154,
        NS_ERROR_DOM_INVALID_STATE_XHR_MUST_BE_OPENED = 2152924155,
        NS_ERROR_DOM_INVALID_STATE_XHR_MUST_NOT_BE_SENDING = 2152924156,
        NS_ERROR_DOM_INVALID_STATE_XHR_MUST_NOT_BE_LOADING_OR_DONE = 2152924157,
        NS_ERROR_DOM_INVALID_STATE_XHR_HAS_WRONG_RESPONSETYPE_FOR_RESPONSEXML = 2152924158,
        NS_ERROR_DOM_INVALID_STATE_XHR_HAS_WRONG_RESPONSETYPE_FOR_RESPONSETEXT = 2152924159,
        NS_ERROR_DOM_INVALID_STATE_XHR_CHUNKED_RESPONSETYPES_UNSUPPORTED_FOR_SYNC = 2152924160,
        NS_ERROR_DOM_INVALID_ACCESS_XHR_TIMEOUT_AND_RESPONSETYPE_UNSUPPORTED_FOR_SYNC = 2152924161,
        NS_ERROR_DOM_JS_DECODING_ERROR = 2152924162,
        NS_ERROR_DOM_IMAGE_INACTIVE_DOCUMENT = 2152924163,
        NS_ERROR_DOM_IMAGE_INVALID_REQUEST = 2152924164,
        NS_ERROR_DOM_IMAGE_BROKEN = 2152924165,
        NS_SUCCESS_DOM_NO_OPERATION = 5439489,
        NS_SUCCESS_DOM_SCRIPT_EVALUATION_THREW = 5439490,
        NS_SUCCESS_DOM_SCRIPT_EVALUATION_THREW_UNCATCHABLE = 5439491,
        NS_IMAGELIB_ERROR_FAILURE = 2152988677,
        NS_IMAGELIB_ERROR_NO_DECODER = 2152988678,
        NS_IMAGELIB_ERROR_NOT_FINISHED = 2152988679,
        NS_IMAGELIB_ERROR_NO_ENCODER = 2152988681,
        NS_ERROR_EDITOR_DESTROYED = 2153119745,
        NS_ERROR_EDITOR_UNEXPECTED_DOM_TREE = 2153119746,
        NS_ERROR_EDITOR_ACTION_CANCELED = 2153119747,
        NS_SUCCESS_EDITOR_ELEMENT_NOT_FOUND = 5636097,
        NS_SUCCESS_EDITOR_FOUND_TARGET = 5636098,
        NS_ERROR_XPC_NOT_ENOUGH_ARGS = 2153185281,
        NS_ERROR_XPC_NEED_OUT_OBJECT = 2153185282,
        NS_ERROR_XPC_CANT_SET_OUT_VAL = 2153185283,
        NS_ERROR_XPC_NATIVE_RETURNED_FAILURE = 2153185284,
        NS_ERROR_XPC_CANT_GET_INTERFACE_INFO = 2153185285,
        NS_ERROR_XPC_CANT_GET_PARAM_IFACE_INFO = 2153185286,
        NS_ERROR_XPC_CANT_GET_METHOD_INFO = 2153185287,
        NS_ERROR_XPC_UNEXPECTED = 2153185288,
        NS_ERROR_XPC_BAD_CONVERT_JS = 2153185289,
        NS_ERROR_XPC_BAD_CONVERT_NATIVE = 2153185290,
        NS_ERROR_XPC_BAD_CONVERT_JS_NULL_REF = 2153185291,
        NS_ERROR_XPC_BAD_OP_ON_WN_PROTO = 2153185292,
        NS_ERROR_XPC_CANT_CONVERT_WN_TO_FUN = 2153185293,
        NS_ERROR_XPC_CANT_DEFINE_PROP_ON_WN = 2153185294,
        NS_ERROR_XPC_CANT_WATCH_WN_STATIC = 2153185295,
        NS_ERROR_XPC_CANT_EXPORT_WN_STATIC = 2153185296,
        NS_ERROR_XPC_SCRIPTABLE_CALL_FAILED = 2153185297,
        NS_ERROR_XPC_SCRIPTABLE_CTOR_FAILED = 2153185298,
        NS_ERROR_XPC_CANT_CALL_WO_SCRIPTABLE = 2153185299,
        NS_ERROR_XPC_CANT_CTOR_WO_SCRIPTABLE = 2153185300,
        NS_ERROR_XPC_CI_RETURNED_FAILURE = 2153185301,
        NS_ERROR_XPC_GS_RETURNED_FAILURE = 2153185302,
        NS_ERROR_XPC_BAD_CID = 2153185303,
        NS_ERROR_XPC_BAD_IID = 2153185304,
        NS_ERROR_XPC_CANT_CREATE_WN = 2153185305,
        NS_ERROR_XPC_JS_THREW_EXCEPTION = 2153185306,
        NS_ERROR_XPC_JS_THREW_NATIVE_OBJECT = 2153185307,
        NS_ERROR_XPC_JS_THREW_JS_OBJECT = 2153185308,
        NS_ERROR_XPC_JS_THREW_NULL = 2153185309,
        NS_ERROR_XPC_JS_THREW_STRING = 2153185310,
        NS_ERROR_XPC_JS_THREW_NUMBER = 2153185311,
        NS_ERROR_XPC_JAVASCRIPT_ERROR = 2153185312,
        NS_ERROR_XPC_JAVASCRIPT_ERROR_WITH_DETAILS = 2153185313,
        NS_ERROR_XPC_CANT_CONVERT_PRIMITIVE_TO_ARRAY = 2153185314,
        NS_ERROR_XPC_CANT_CONVERT_OBJECT_TO_ARRAY = 2153185315,
        NS_ERROR_XPC_NOT_ENOUGH_ELEMENTS_IN_ARRAY = 2153185316,
        NS_ERROR_XPC_CANT_GET_ARRAY_INFO = 2153185317,
        NS_ERROR_XPC_NOT_ENOUGH_CHARS_IN_STRING = 2153185318,
        NS_ERROR_XPC_SECURITY_MANAGER_VETO = 2153185319,
        NS_ERROR_XPC_INTERFACE_NOT_SCRIPTABLE = 2153185320,
        NS_ERROR_XPC_INTERFACE_NOT_FROM_NSISUPPORTS = 2153185321,
        NS_ERROR_XPC_CANT_GET_JSOBJECT_OF_DOM_OBJECT = 2153185322,
        NS_ERROR_XPC_CANT_SET_READ_ONLY_CONSTANT = 2153185323,
        NS_ERROR_XPC_CANT_SET_READ_ONLY_ATTRIBUTE = 2153185324,
        NS_ERROR_XPC_CANT_SET_READ_ONLY_METHOD = 2153185325,
        NS_ERROR_XPC_CANT_ADD_PROP_TO_WRAPPED_NATIVE = 2153185326,
        NS_ERROR_XPC_CALL_TO_SCRIPTABLE_FAILED = 2153185327,
        NS_ERROR_XPC_JSOBJECT_HAS_NO_FUNCTION_NAMED = 2153185328,
        NS_ERROR_XPC_BAD_ID_STRING = 2153185329,
        NS_ERROR_XPC_BAD_INITIALIZER_NAME = 2153185330,
        NS_ERROR_XPC_HAS_BEEN_SHUTDOWN = 2153185331,
        NS_ERROR_XPC_CANT_MODIFY_PROP_ON_WN = 2153185332,
        NS_ERROR_XPC_BAD_CONVERT_JS_ZERO_ISNOT_NULL = 2153185333,
        NS_ERROR_XPC_CANT_PASS_CPOW_TO_NATIVE = 2153185334,
        NS_ERROR_LAUNCHED_CHILD_PROCESS = 2153251016,
        NS_ERROR_SHOW_PROFILE_MANAGER = 2153251017,
        NS_ERROR_DATABASE_CHANGED = 2153251018,
        NS_ERROR_CSP_FORM_ACTION_VIOLATION = 2153381986,
        NS_ERROR_CSP_FRAME_ANCESTOR_VIOLATION = 2153381987,
        NS_ERROR_SRI_CORRUPT = 2153382088,
        NS_ERROR_SRI_DISABLED = 2153382089,
        NS_ERROR_SRI_NOT_ELIGIBLE = 2153382090,
        NS_ERROR_SRI_UNEXPECTED_HASH_TYPE = 2153382091,
        NS_ERROR_SRI_IMPORT = 2153382092,
        NS_ERROR_CMS_VERIFY_NOT_SIGNED = 2153382912,
        NS_ERROR_CMS_VERIFY_NO_CONTENT_INFO = 2153382913,
        NS_ERROR_CMS_VERIFY_BAD_DIGEST = 2153382914,
        NS_ERROR_CMS_VERIFY_NOCERT = 2153382916,
        NS_ERROR_CMS_VERIFY_UNTRUSTED = 2153382917,
        NS_ERROR_CMS_VERIFY_ERROR_UNVERIFIED = 2153382919,
        NS_ERROR_CMS_VERIFY_ERROR_PROCESSING = 2153382920,
        NS_ERROR_CMS_VERIFY_BAD_SIGNATURE = 2153382921,
        NS_ERROR_CMS_VERIFY_DIGEST_MISMATCH = 2153382922,
        NS_ERROR_CMS_VERIFY_UNKNOWN_ALGO = 2153382923,
        NS_ERROR_CMS_VERIFY_UNSUPPORTED_ALGO = 2153382924,
        NS_ERROR_CMS_VERIFY_MALFORMED_SIGNATURE = 2153382925,
        NS_ERROR_CMS_VERIFY_HEADER_MISMATCH = 2153382926,
        NS_ERROR_CMS_VERIFY_NOT_YET_ATTEMPTED = 2153382927,
        NS_ERROR_CMS_VERIFY_CERT_WITHOUT_ADDRESS = 2153382928,
        NS_ERROR_CMS_ENCRYPT_NO_BULK_ALG = 2153382944,
        NS_ERROR_CMS_ENCRYPT_INCOMPLETE = 2153382945,
        NS_ERROR_DOM_INVALID_EXPRESSION_ERR = 2153447475,
        NS_ERROR_DOM_TYPE_ERR = 2153447476,
        NS_ERROR_WONT_HANDLE_CONTENT = 2153578497,
        NS_ERROR_MALWARE_URI = 2153578526,
        NS_ERROR_PHISHING_URI = 2153578527,
        NS_ERROR_TRACKING_URI = 2153578530,
        NS_ERROR_UNWANTED_URI = 2153578531,
        NS_ERROR_BLOCKED_URI = 2153578533,
        NS_ERROR_HARMFUL_URI = 2153578534,
        NS_ERROR_MAYBE_TRACKING_URI = 2153578535,
        NS_ERROR_TRACKING_ANNOTATION_URI = 2153578536,
        NS_ERROR_FINGERPRINTING_URI = 2153578537,
        NS_ERROR_CRYPTOMINING_URI = 2153578538,
        NS_ERROR_SAVE_LINK_AS_TIMEOUT = 2153578528,
        NS_ERROR_PARSED_DATA_CACHED = 2153578529,
        NS_REFRESHURI_HEADER_FOUND = 6094850,
        NS_ERROR_CONTENT_BLOCKED = 2153644038,
        NS_ERROR_CONTENT_BLOCKED_SHOW_ALT = 2153644039,
        NS_PROPTABLE_PROP_NOT_THERE = 2153644042,
        NS_ERROR_XBL_BLOCKED = 2153644047,
        NS_ERROR_CONTENT_CRASHED = 2153644048,
        NS_ERROR_FRAME_CRASHED = 2153644046,
        NS_ERROR_BUILDID_MISMATCH = 2153644049,
        NS_PROPTABLE_PROP_OVERWRITTEN = 6160395,
        NS_FINDBROADCASTER_NOT_FOUND = 6160396,
        NS_FINDBROADCASTER_FOUND = 6160397,
        NS_ERROR_XSLT_PARSE_FAILURE = 2153775105,
        NS_ERROR_XPATH_PARSE_FAILURE = 2153775106,
        NS_ERROR_XSLT_ALREADY_SET = 2153775107,
        NS_ERROR_XSLT_EXECUTION_FAILURE = 2153775108,
        NS_ERROR_XPATH_UNKNOWN_FUNCTION = 2153775109,
        NS_ERROR_XSLT_BAD_RECURSION = 2153775110,
        NS_ERROR_XSLT_BAD_VALUE = 2153775111,
        NS_ERROR_XSLT_NODESET_EXPECTED = 2153775112,
        NS_ERROR_XSLT_ABORTED = 2153775113,
        NS_ERROR_XSLT_NETWORK_ERROR = 2153775114,
        NS_ERROR_XSLT_WRONG_MIME_TYPE = 2153775115,
        NS_ERROR_XSLT_LOAD_RECURSION = 2153775116,
        NS_ERROR_XPATH_BAD_ARGUMENT_COUNT = 2153775117,
        NS_ERROR_XPATH_BAD_EXTENSION_FUNCTION = 2153775118,
        NS_ERROR_XPATH_PAREN_EXPECTED = 2153775119,
        NS_ERROR_XPATH_INVALID_AXIS = 2153775120,
        NS_ERROR_XPATH_NO_NODE_TYPE_TEST = 2153775121,
        NS_ERROR_XPATH_BRACKET_EXPECTED = 2153775122,
        NS_ERROR_XPATH_INVALID_VAR_NAME = 2153775123,
        NS_ERROR_XPATH_UNEXPECTED_END = 2153775124,
        NS_ERROR_XPATH_OPERATOR_EXPECTED = 2153775125,
        NS_ERROR_XPATH_UNCLOSED_LITERAL = 2153775126,
        NS_ERROR_XPATH_BAD_COLON = 2153775127,
        NS_ERROR_XPATH_BAD_BANG = 2153775128,
        NS_ERROR_XPATH_ILLEGAL_CHAR = 2153775129,
        NS_ERROR_XPATH_BINARY_EXPECTED = 2153775130,
        NS_ERROR_XSLT_LOAD_BLOCKED_ERROR = 2153775131,
        NS_ERROR_XPATH_INVALID_EXPRESSION_EVALUATED = 2153775132,
        NS_ERROR_XPATH_UNBALANCED_CURLY_BRACE = 2153775133,
        NS_ERROR_XSLT_BAD_NODE_NAME = 2153775134,
        NS_ERROR_XSLT_VAR_ALREADY_SET = 2153775135,
        NS_ERROR_XSLT_CALL_TO_KEY_NOT_ALLOWED = 2153775136,
        NS_XSLT_GET_NEW_HANDLER = 6291457,
        NS_ERROR_TRANSPORT_INIT = 2153840641,
        NS_ERROR_DUPLICATE_HANDLE = 2153840642,
        NS_ERROR_BRIDGE_OPEN_PARENT = 2153840643,
        NS_ERROR_BRIDGE_OPEN_CHILD = 2153840644,
        NS_ERROR_DOM_SVG_WRONG_TYPE_ERR = 2153906176,
        NS_ERROR_DOM_SVG_MATRIX_NOT_INVERTABLE = 2153906178,
        NS_ERROR_STORAGE_BUSY = 2153971713,
        NS_ERROR_STORAGE_IOERR = 2153971714,
        NS_ERROR_STORAGE_CONSTRAINT = 2153971715,
        NS_ERROR_DOM_FILE_NOT_FOUND_ERR = 2154102784,
        NS_ERROR_DOM_FILE_NOT_READABLE_ERR = 2154102785,
        NS_ERROR_DOM_FILE_ABORT_ERR = 2154102786,
        NS_ERROR_DOM_INDEXEDDB_UNKNOWN_ERR = 2154168321,
        NS_ERROR_DOM_INDEXEDDB_NOT_FOUND_ERR = 2154168323,
        NS_ERROR_DOM_INDEXEDDB_CONSTRAINT_ERR = 2154168324,
        NS_ERROR_DOM_INDEXEDDB_DATA_ERR = 2154168325,
        NS_ERROR_DOM_INDEXEDDB_NOT_ALLOWED_ERR = 2154168326,
        NS_ERROR_DOM_INDEXEDDB_TRANSACTION_INACTIVE_ERR = 2154168327,
        NS_ERROR_DOM_INDEXEDDB_ABORT_ERR = 2154168328,
        NS_ERROR_DOM_INDEXEDDB_READ_ONLY_ERR = 2154168329,
        NS_ERROR_DOM_INDEXEDDB_TIMEOUT_ERR = 2154168330,
        NS_ERROR_DOM_INDEXEDDB_QUOTA_ERR = 2154168331,
        NS_ERROR_DOM_INDEXEDDB_VERSION_ERR = 2154168332,
        NS_ERROR_DOM_INDEXEDDB_RECOVERABLE_ERR = 2154169321,
        NS_ERROR_DOM_INDEXEDDB_KEY_ERR = 2154169322,
        NS_ERROR_DOM_INDEXEDDB_RENAME_OBJECT_STORE_ERR = 2154169323,
        NS_ERROR_DOM_INDEXEDDB_RENAME_INDEX_ERR = 2154169324,
        NS_ERROR_DOM_FILEHANDLE_UNKNOWN_ERR = 2154233857,
        NS_ERROR_DOM_FILEHANDLE_NOT_ALLOWED_ERR = 2154233858,
        NS_ERROR_DOM_FILEHANDLE_INACTIVE_ERR = 2154233859,
        NS_ERROR_DOM_FILEHANDLE_ABORT_ERR = 2154233860,
        NS_ERROR_DOM_FILEHANDLE_READ_ONLY_ERR = 2154233861,
        NS_ERROR_DOM_FILEHANDLE_QUOTA_ERR = 2154233862,
        NS_ERROR_SIGNED_JAR_NOT_SIGNED = 2154299393,
        NS_ERROR_SIGNED_JAR_MODIFIED_ENTRY = 2154299394,
        NS_ERROR_SIGNED_JAR_UNSIGNED_ENTRY = 2154299395,
        NS_ERROR_SIGNED_JAR_ENTRY_MISSING = 2154299396,
        NS_ERROR_SIGNED_JAR_WRONG_SIGNATURE = 2154299397,
        NS_ERROR_SIGNED_JAR_ENTRY_TOO_LARGE = 2154299398,
        NS_ERROR_SIGNED_JAR_ENTRY_INVALID = 2154299399,
        NS_ERROR_SIGNED_JAR_MANIFEST_INVALID = 2154299400,
        NS_ERROR_DOM_FILESYSTEM_INVALID_PATH_ERR = 2154364929,
        NS_ERROR_DOM_FILESYSTEM_INVALID_MODIFICATION_ERR = 2154364930,
        NS_ERROR_DOM_FILESYSTEM_NO_MODIFICATION_ALLOWED_ERR = 2154364931,
        NS_ERROR_DOM_FILESYSTEM_PATH_EXISTS_ERR = 2154364932,
        NS_ERROR_DOM_FILESYSTEM_TYPE_MISMATCH_ERR = 2154364933,
        NS_ERROR_DOM_FILESYSTEM_UNKNOWN_ERR = 2154364934,
        NS_ERROR_SIGNED_APP_MANIFEST_INVALID = 2154496001,
        NS_ERROR_DOM_ANIM_MISSING_PROPS_ERR = 2154561537,
        NS_ERROR_DOM_PUSH_INVALID_REGISTRATION_ERR = 2154627073,
        NS_ERROR_DOM_PUSH_DENIED_ERR = 2154627074,
        NS_ERROR_DOM_PUSH_ABORT_ERR = 2154627075,
        NS_ERROR_DOM_PUSH_SERVICE_UNREACHABLE = 2154627076,
        NS_ERROR_DOM_PUSH_INVALID_KEY_ERR = 2154627077,
        NS_ERROR_DOM_PUSH_MISMATCHED_KEY_ERR = 2154627078,
        NS_ERROR_DOM_PUSH_GCM_DISABLED = 2154627079,
        NS_ERROR_DOM_MEDIA_ABORT_ERR = 2154692609,
        NS_ERROR_DOM_MEDIA_NOT_ALLOWED_ERR = 2154692610,
        NS_ERROR_DOM_MEDIA_NOT_SUPPORTED_ERR = 2154692611,
        NS_ERROR_DOM_MEDIA_DECODE_ERR = 2154692612,
        NS_ERROR_DOM_MEDIA_FATAL_ERR = 2154692613,
        NS_ERROR_DOM_MEDIA_METADATA_ERR = 2154692614,
        NS_ERROR_DOM_MEDIA_OVERFLOW_ERR = 2154692615,
        NS_ERROR_DOM_MEDIA_END_OF_STREAM = 2154692616,
        NS_ERROR_DOM_MEDIA_WAITING_FOR_DATA = 2154692617,
        NS_ERROR_DOM_MEDIA_CANCELED = 2154692618,
        NS_ERROR_DOM_MEDIA_MEDIASINK_ERR = 2154692619,
        NS_ERROR_DOM_MEDIA_DEMUXER_ERR = 2154692620,
        NS_ERROR_DOM_MEDIA_CDM_ERR = 2154692621,
        NS_ERROR_DOM_MEDIA_NEED_NEW_DECODER = 2154692622,
        NS_ERROR_DOM_MEDIA_INITIALIZING_DECODER = 2154692623,
        NS_ERROR_DOM_MEDIA_CUBEB_INITIALIZATION_ERR = 2154692709,
        NS_ERROR_UC_UPDATE_UNKNOWN = 2154758145,
        NS_ERROR_UC_UPDATE_DUPLICATE_PREFIX = 2154758146,
        NS_ERROR_UC_UPDATE_INFINITE_LOOP = 2154758147,
        NS_ERROR_UC_UPDATE_WRONG_REMOVAL_INDICES = 2154758148,
        NS_ERROR_UC_UPDATE_CHECKSUM_MISMATCH = 2154758149,
        NS_ERROR_UC_UPDATE_MISSING_CHECKSUM = 2154758150,
        NS_ERROR_UC_UPDATE_SHUTDOWNING = 2154758151,
        NS_ERROR_UC_UPDATE_TABLE_NOT_FOUND = 2154758152,
        NS_ERROR_UC_UPDATE_BUILD_PREFIX_FAILURE = 2154758153,
        NS_ERROR_UC_UPDATE_FAIL_TO_WRITE_DISK = 2154758154,
        NS_ERROR_UC_UPDATE_UNEXPECTED_VERSION = 2154758155,
        NS_ERROR_UC_PARSER_MISSING_PARAM = 2154758156,
        NS_ERROR_UC_PARSER_DECODE_FAILURE = 2154758157,
        NS_ERROR_UC_PARSER_UNKNOWN_THREAT = 2154758158,
        NS_ERROR_UC_PARSER_MISSING_VALUE = 2154758159,
        NS_ERROR_INTERNAL_ERRORRESULT_JS_EXCEPTION = 2154823681,
        NS_ERROR_INTERNAL_ERRORRESULT_DOMEXCEPTION = 2154823682,
        NS_ERROR_INTERNAL_ERRORRESULT_EXCEPTION_ON_JSCONTEXT = 2154823683,
        NS_ERROR_INTERNAL_ERRORRESULT_TYPEERROR = 2154823684,
        NS_ERROR_INTERNAL_ERRORRESULT_RANGEERROR = 2154823685,
        NS_ERROR_DOWNLOAD_COMPLETE = 2155347969,
        NS_ERROR_DOWNLOAD_NOT_PARTIAL = 2155347970,
        NS_ERROR_UNORM_MOREOUTPUT = 2155348001,
        NS_ERROR_DOCSHELL_REQUEST_REJECTED = 2155348969,
        NS_ERROR_DOCUMENT_IS_PRINTMODE = 2155349969,
        NS_SUCCESS_DONT_FIXUP = 7864321,
        NS_ERROR_NOT_IN_TREE = 2155348006,
        NS_OK_NO_NAME_CLAUSE_HANDLED = 7864354,
        NS_ERROR_BLOCKED_BY_POLICY = 2155347971,
    }
    pub type nsrefcnt = root::MozRefCountType;
    #[repr(C)]
    #[derive(Debug)]
    pub struct RefPtr<T> {
        pub mRawPtr: *mut T,
        pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
    }
    pub type RefPtr_element_type<T> = T;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RefPtr_Proxy {
        pub _address: u8,
    }
    pub type RefPtr_Proxy_member_function = u8;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RefPtr_ConstRemovingRefPtrTraits {
        pub _address: u8,
    }
    pub type nsAutoString = [u64; 19usize];
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsCharTraits {
        pub _address: u8,
    }
    pub type nscoord = i32;
    pub type nscolor = u32;
    pub mod JS {
        #[allow(unused_imports)]
        use self::super::super::root;
        pub type Latin1Char = ::std::os::raw::c_uchar;
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct Realm {
            _unused: [u8; 0],
        }
        pub type RootedObject = [u64; 3usize];
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct DeletePolicy {
            pub _address: u8,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct FreePolicy {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_FreePolicy() {
            assert_eq!(
                ::std::mem::size_of::<FreePolicy>(),
                1usize,
                concat!("Size of: ", stringify!(FreePolicy))
            );
            assert_eq!(
                ::std::mem::align_of::<FreePolicy>(),
                1usize,
                concat!("Alignment of ", stringify!(FreePolicy))
            );
        }
        pub const ProfilingCategoryPair_IDLE: root::JS::ProfilingCategoryPair = 0;
        pub const ProfilingCategoryPair_OTHER: root::JS::ProfilingCategoryPair = 1;
        pub const ProfilingCategoryPair_LAYOUT: root::JS::ProfilingCategoryPair = 2;
        pub const ProfilingCategoryPair_LAYOUT_FrameConstruction: root::JS::ProfilingCategoryPair =
            3;
        pub const ProfilingCategoryPair_LAYOUT_Reflow: root::JS::ProfilingCategoryPair = 4;
        pub const ProfilingCategoryPair_LAYOUT_CSSParsing: root::JS::ProfilingCategoryPair = 5;
        pub const ProfilingCategoryPair_LAYOUT_SelectorQuery: root::JS::ProfilingCategoryPair = 6;
        pub const ProfilingCategoryPair_LAYOUT_StyleComputation: root::JS::ProfilingCategoryPair =
            7;
        pub const ProfilingCategoryPair_JS: root::JS::ProfilingCategoryPair = 8;
        pub const ProfilingCategoryPair_JS_Parsing: root::JS::ProfilingCategoryPair = 9;
        pub const ProfilingCategoryPair_JS_IonCompilation: root::JS::ProfilingCategoryPair = 10;
        pub const ProfilingCategoryPair_JS_BaselineCompilation: root::JS::ProfilingCategoryPair =
            11;
        pub const ProfilingCategoryPair_GCCC: root::JS::ProfilingCategoryPair = 12;
        pub const ProfilingCategoryPair_NETWORK: root::JS::ProfilingCategoryPair = 13;
        pub const ProfilingCategoryPair_GRAPHICS: root::JS::ProfilingCategoryPair = 14;
        pub const ProfilingCategoryPair_GRAPHICS_DisplayListBuilding:
            root::JS::ProfilingCategoryPair = 15;
        pub const ProfilingCategoryPair_GRAPHICS_DisplayListMerging:
            root::JS::ProfilingCategoryPair = 16;
        pub const ProfilingCategoryPair_GRAPHICS_LayerBuilding: root::JS::ProfilingCategoryPair =
            17;
        pub const ProfilingCategoryPair_GRAPHICS_TileAllocation: root::JS::ProfilingCategoryPair =
            18;
        pub const ProfilingCategoryPair_GRAPHICS_WRDisplayList: root::JS::ProfilingCategoryPair =
            19;
        pub const ProfilingCategoryPair_GRAPHICS_Rasterization: root::JS::ProfilingCategoryPair =
            20;
        pub const ProfilingCategoryPair_GRAPHICS_FlushingAsyncPaints:
            root::JS::ProfilingCategoryPair = 21;
        pub const ProfilingCategoryPair_GRAPHICS_ImageDecoding: root::JS::ProfilingCategoryPair =
            22;
        pub const ProfilingCategoryPair_DOM: root::JS::ProfilingCategoryPair = 23;
        pub const ProfilingCategoryPair_COUNT: root::JS::ProfilingCategoryPair = 24;
        pub const ProfilingCategoryPair_LAST: root::JS::ProfilingCategoryPair = 23;
        pub type ProfilingCategoryPair = u32;
        #[doc = " The Heap<T> class is a heap-stored reference to a JS GC thing for use outside"]
        #[doc = " the JS engine. All members of heap classes that refer to GC things should use"]
        #[doc = " Heap<T> (or possibly TenuredHeap<T>, described below)."]
        #[doc = ""]
        #[doc = " Heap<T> is an abstraction that hides some of the complexity required to"]
        #[doc = " maintain GC invariants for the contained reference. It uses operator"]
        #[doc = " overloading to provide a normal pointer interface, but adds barriers to"]
        #[doc = " notify the GC of changes."]
        #[doc = ""]
        #[doc = " Heap<T> implements the following barriers:"]
        #[doc = ""]
        #[doc = "  - Pre-write barrier (necessary for incremental GC)."]
        #[doc = "  - Post-write barrier (necessary for generational GC)."]
        #[doc = "  - Read barrier (necessary for cycle collector integration)."]
        #[doc = ""]
        #[doc = " Heap<T> may be moved or destroyed outside of GC finalization and hence may be"]
        #[doc = " used in dynamic storage such as a Vector."]
        #[doc = ""]
        #[doc = " Heap<T> instances must be traced when their containing object is traced to"]
        #[doc = " keep the pointed-to GC thing alive."]
        #[doc = ""]
        #[doc = " Heap<T> objects should only be used on the heap. GC references stored on the"]
        #[doc = " C/C++ stack must use Rooted/Handle/MutableHandle instead."]
        #[doc = ""]
        #[doc = " Type T must be a public GC pointer type."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct Heap<T> {
            pub ptr: T,
            pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
        }
        pub type Heap_ElementType<T> = T;
        #[doc = " The TenuredHeap<T> class is similar to the Heap<T> class above in that it"]
        #[doc = " encapsulates the GC concerns of an on-heap reference to a JS object. However,"]
        #[doc = " it has two important differences:"]
        #[doc = ""]
        #[doc = "  1) Pointers which are statically known to only reference \"tenured\" objects"]
        #[doc = "     can avoid the extra overhead of SpiderMonkey\'s write barriers."]
        #[doc = ""]
        #[doc = "  2) Objects in the \"tenured\" heap have stronger alignment restrictions than"]
        #[doc = "     those in the \"nursery\", so it is possible to store flags in the lower"]
        #[doc = "     bits of pointers known to be tenured. TenuredHeap wraps a normal tagged"]
        #[doc = "     pointer with a nice API for accessing the flag bits and adds various"]
        #[doc = "     assertions to ensure that it is not mis-used."]
        #[doc = ""]
        #[doc = " GC things are said to be \"tenured\" when they are located in the long-lived"]
        #[doc = " heap: e.g. they have gained tenure as an object by surviving past at least"]
        #[doc = " one GC. For performance, SpiderMonkey allocates some things which are known"]
        #[doc = " to normally be long lived directly into the tenured generation; for example,"]
        #[doc = " global objects. Additionally, SpiderMonkey does not visit individual objects"]
        #[doc = " when deleting non-tenured objects, so object with finalizers are also always"]
        #[doc = " tenured; for instance, this includes most DOM objects."]
        #[doc = ""]
        #[doc = " The considerations to keep in mind when using a TenuredHeap<T> vs a normal"]
        #[doc = " Heap<T> are:"]
        #[doc = ""]
        #[doc = "  - It is invalid for a TenuredHeap<T> to refer to a non-tenured thing."]
        #[doc = "  - It is however valid for a Heap<T> to refer to a tenured thing."]
        #[doc = "  - It is not possible to store flag bits in a Heap<T>."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct TenuredHeap {
            pub bits: usize,
        }
        pub type TenuredHeap_ElementType<T> = T;
        pub const TenuredHeap_maskBits: root::JS::TenuredHeap__bindgen_ty_1 = 0;
        pub const TenuredHeap_flagsMask: root::JS::TenuredHeap__bindgen_ty_1 = 0;
        pub type TenuredHeap__bindgen_ty_1 = i32;
        #[doc = " Local variable of type T whose value is always rooted. This is typically"]
        #[doc = " used for local variables, or for non-rooted values being passed to a"]
        #[doc = " function that requires a handle, e.g. Foo(Root<T>(cx, x))."]
        #[doc = ""]
        #[doc = " If you want to add additional methods to Rooted for a specific"]
        #[doc = " specialization, define a RootedBase<T> specialization containing them."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct Rooted {
            pub _address: u8,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct Rooted_CtorDispatcher {
            pub _address: u8,
        }
        pub type Rooted_ElementType<T> = T;
        pub mod dbg {
            #[allow(unused_imports)]
            use self::super::super::super::root;
            #[repr(C)]
            #[derive(Debug)]
            pub struct GarbageCollectionEvent {
                pub majorGCNumber_: u64,
                pub reason: *const ::std::os::raw::c_char,
                pub nonincrementalReason: *const ::std::os::raw::c_char,
                pub collections: [u64; 3usize],
            }
            #[repr(C)]
            #[derive(Debug, Copy, Clone)]
            pub struct GarbageCollectionEvent_Collection {
                pub startTimestamp: root::mozilla::TimeStamp,
                pub endTimestamp: root::mozilla::TimeStamp,
            }
            #[test]
            fn bindgen_test_layout_GarbageCollectionEvent_Collection() {
                assert_eq!(
                    ::std::mem::size_of::<GarbageCollectionEvent_Collection>(),
                    16usize,
                    concat!("Size of: ", stringify!(GarbageCollectionEvent_Collection))
                );
                assert_eq!(
                    ::std::mem::align_of::<GarbageCollectionEvent_Collection>(),
                    8usize,
                    concat!(
                        "Alignment of ",
                        stringify!(GarbageCollectionEvent_Collection)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<GarbageCollectionEvent_Collection>())).startTimestamp
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(GarbageCollectionEvent_Collection),
                        "::",
                        stringify!(startTimestamp)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<GarbageCollectionEvent_Collection>())).endTimestamp
                            as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(GarbageCollectionEvent_Collection),
                        "::",
                        stringify!(endTimestamp)
                    )
                );
            }
            pub type GarbageCollectionEvent_Ptr =
                root::mozilla::UniquePtr<root::JS::dbg::GarbageCollectionEvent>;
            #[test]
            fn bindgen_test_layout_GarbageCollectionEvent() {
                assert_eq!(
                    ::std::mem::size_of::<GarbageCollectionEvent>(),
                    48usize,
                    concat!("Size of: ", stringify!(GarbageCollectionEvent))
                );
                assert_eq!(
                    ::std::mem::align_of::<GarbageCollectionEvent>(),
                    8usize,
                    concat!("Alignment of ", stringify!(GarbageCollectionEvent))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<GarbageCollectionEvent>())).majorGCNumber_
                            as *const _ as usize
                    },
                    0usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(GarbageCollectionEvent),
                        "::",
                        stringify!(majorGCNumber_)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<GarbageCollectionEvent>())).reason as *const _
                            as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(GarbageCollectionEvent),
                        "::",
                        stringify!(reason)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<GarbageCollectionEvent>())).nonincrementalReason
                            as *const _ as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(GarbageCollectionEvent),
                        "::",
                        stringify!(nonincrementalReason)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<GarbageCollectionEvent>())).collections as *const _
                            as usize
                    },
                    24usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(GarbageCollectionEvent),
                        "::",
                        stringify!(collections)
                    )
                );
            }
            #[repr(C)]
            pub struct AutoEntryMonitor__bindgen_vtable(::std::os::raw::c_void);
            #[repr(C)]
            #[derive(Debug)]
            pub struct AutoEntryMonitor {
                pub vtable_: *const AutoEntryMonitor__bindgen_vtable,
                pub cx_: *mut root::JSContext,
                pub savedMonitor_: *mut root::JS::dbg::AutoEntryMonitor,
            }
            #[test]
            fn bindgen_test_layout_AutoEntryMonitor() {
                assert_eq!(
                    ::std::mem::size_of::<AutoEntryMonitor>(),
                    24usize,
                    concat!("Size of: ", stringify!(AutoEntryMonitor))
                );
                assert_eq!(
                    ::std::mem::align_of::<AutoEntryMonitor>(),
                    8usize,
                    concat!("Alignment of ", stringify!(AutoEntryMonitor))
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<AutoEntryMonitor>())).cx_ as *const _ as usize
                    },
                    8usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(AutoEntryMonitor),
                        "::",
                        stringify!(cx_)
                    )
                );
                assert_eq!(
                    unsafe {
                        &(*(::std::ptr::null::<AutoEntryMonitor>())).savedMonitor_ as *const _
                            as usize
                    },
                    16usize,
                    concat!(
                        "Offset of field: ",
                        stringify!(AutoEntryMonitor),
                        "::",
                        stringify!(savedMonitor_)
                    )
                );
            }
        }
        #[doc = " [SMDOC] JS::Value type"]
        #[doc = ""]
        #[doc = " JS::Value is the interface for a single JavaScript Engine value.  A few"]
        #[doc = " general notes on JS::Value:"]
        #[doc = ""]
        #[doc = " - JS::Value has setX() and isX() members for X in"]
        #[doc = ""]
        #[doc = "     { Int32, Double, String, Symbol, BigInt, Boolean, Undefined, Null,"]
        #[doc = "       Object, Magic }"]
        #[doc = ""]
        #[doc = "   JS::Value also contains toX() for each of the non-singleton types."]
        #[doc = ""]
        #[doc = " - Magic is a singleton type whose payload contains either a JSWhyMagic"]
        #[doc = "   \"reason\" for the magic value or a uint32_t value. By providing JSWhyMagic"]
        #[doc = "   values when creating and checking for magic values, it is possible to"]
        #[doc = "   assert, at runtime, that only magic values with the expected reason flow"]
        #[doc = "   through a particular value. For example, if cx->exception has a magic"]
        #[doc = "   value, the reason must be JS_GENERATOR_CLOSING."]
        #[doc = ""]
        #[doc = " - The JS::Value operations are preferred.  The JSVAL_* operations remain for"]
        #[doc = "   compatibility; they may be removed at some point.  These operations mostly"]
        #[doc = "   provide similar functionality.  But there are a few key differences.  One"]
        #[doc = "   is that JS::Value gives null a separate type."]
        #[doc = "   Also, to help prevent mistakenly boxing a nullable JSObject* as an object,"]
        #[doc = "   Value::setObject takes a JSObject&. (Conversely, Value::toObject returns a"]
        #[doc = "   JSObject&.)  A convenience member Value::setObjectOrNull is provided."]
        #[doc = ""]
        #[doc = " - Note that JS::Value is 8 bytes on 32 and 64-bit architectures. Thus, on"]
        #[doc = "   32-bit user code should avoid copying jsval/JS::Value as much as possible,"]
        #[doc = "   preferring to pass by const Value&."]
        #[doc = ""]
        #[doc = " Spectre mitigations"]
        #[doc = " ==================="]
        #[doc = " To mitigate Spectre attacks, we do the following:"]
        #[doc = ""]
        #[doc = " - On 64-bit platforms, when unboxing a Value, we XOR the bits with the"]
        #[doc = "   expected type tag (instead of masking the payload bits). This guarantees"]
        #[doc = "   that toString, toObject, toSymbol will return an invalid pointer (because"]
        #[doc = "   some high bits will be set) when called on a Value with a different type"]
        #[doc = "   tag."]
        #[doc = ""]
        #[doc = " - On 32-bit platforms,when unboxing an object/string/symbol Value, we use a"]
        #[doc = "   conditional move (not speculated) to zero the payload register if the type"]
        #[doc = "   doesn\'t match."]
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct Value {
            pub asBits_: root::__BindgenUnionField<u64>,
            pub asDouble_: root::__BindgenUnionField<f64>,
            pub debugView_: root::__BindgenUnionField<root::JS::Value__bindgen_ty_1>,
            pub s_: root::__BindgenUnionField<root::JS::Value__bindgen_ty_2>,
            pub bindgen_union_field: u64,
        }
        #[repr(C)]
        #[repr(align(8))]
        #[derive(Debug, Copy, Clone)]
        pub struct Value__bindgen_ty_1 {
            pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 8usize], u64>,
        }
        #[test]
        fn bindgen_test_layout_Value__bindgen_ty_1() {
            assert_eq!(
                ::std::mem::size_of::<Value__bindgen_ty_1>(),
                8usize,
                concat!("Size of: ", stringify!(Value__bindgen_ty_1))
            );
            assert_eq!(
                ::std::mem::align_of::<Value__bindgen_ty_1>(),
                8usize,
                concat!("Alignment of ", stringify!(Value__bindgen_ty_1))
            );
        }
        impl Value__bindgen_ty_1 {
            #[inline]
            pub fn payload47_(&self) -> u64 {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 47u8) as u64) }
            }
            #[inline]
            pub fn set_payload47_(&mut self, val: u64) {
                unsafe {
                    let val: u64 = ::std::mem::transmute(val);
                    self._bitfield_1.set(0usize, 47u8, val as u64)
                }
            }
            #[inline]
            pub fn tag_(&self) -> root::JSValueTag {
                unsafe { ::std::mem::transmute(self._bitfield_1.get(47usize, 17u8) as u32) }
            }
            #[inline]
            pub fn set_tag_(&mut self, val: root::JSValueTag) {
                unsafe {
                    let val: u32 = ::std::mem::transmute(val);
                    self._bitfield_1.set(47usize, 17u8, val as u64)
                }
            }
            #[inline]
            pub fn new_bitfield_1(
                payload47_: u64,
                tag_: root::JSValueTag,
            ) -> root::__BindgenBitfieldUnit<[u8; 8usize], u64> {
                let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 8usize], u64> =
                    Default::default();
                __bindgen_bitfield_unit.set(0usize, 47u8, {
                    let payload47_: u64 = unsafe { ::std::mem::transmute(payload47_) };
                    payload47_ as u64
                });
                __bindgen_bitfield_unit.set(47usize, 17u8, {
                    let tag_: u32 = unsafe { ::std::mem::transmute(tag_) };
                    tag_ as u64
                });
                __bindgen_bitfield_unit
            }
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct Value__bindgen_ty_2 {
            pub payload_: root::JS::Value__bindgen_ty_2__bindgen_ty_1,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct Value__bindgen_ty_2__bindgen_ty_1 {
            pub i32_: root::__BindgenUnionField<i32>,
            pub u32_: root::__BindgenUnionField<u32>,
            pub why_: root::__BindgenUnionField<root::JSWhyMagic>,
            pub bindgen_union_field: u32,
        }
        #[test]
        fn bindgen_test_layout_Value__bindgen_ty_2__bindgen_ty_1() {
            assert_eq!(
                ::std::mem::size_of::<Value__bindgen_ty_2__bindgen_ty_1>(),
                4usize,
                concat!("Size of: ", stringify!(Value__bindgen_ty_2__bindgen_ty_1))
            );
            assert_eq!(
                ::std::mem::align_of::<Value__bindgen_ty_2__bindgen_ty_1>(),
                4usize,
                concat!(
                    "Alignment of ",
                    stringify!(Value__bindgen_ty_2__bindgen_ty_1)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<Value__bindgen_ty_2__bindgen_ty_1>())).i32_ as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(Value__bindgen_ty_2__bindgen_ty_1),
                    "::",
                    stringify!(i32_)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<Value__bindgen_ty_2__bindgen_ty_1>())).u32_ as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(Value__bindgen_ty_2__bindgen_ty_1),
                    "::",
                    stringify!(u32_)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<Value__bindgen_ty_2__bindgen_ty_1>())).why_ as *const _
                        as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(Value__bindgen_ty_2__bindgen_ty_1),
                    "::",
                    stringify!(why_)
                )
            );
        }
        #[test]
        fn bindgen_test_layout_Value__bindgen_ty_2() {
            assert_eq!(
                ::std::mem::size_of::<Value__bindgen_ty_2>(),
                4usize,
                concat!("Size of: ", stringify!(Value__bindgen_ty_2))
            );
            assert_eq!(
                ::std::mem::align_of::<Value__bindgen_ty_2>(),
                4usize,
                concat!("Alignment of ", stringify!(Value__bindgen_ty_2))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<Value__bindgen_ty_2>())).payload_ as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(Value__bindgen_ty_2),
                    "::",
                    stringify!(payload_)
                )
            );
        }
        pub type Value_PayloadType = u64;
        #[test]
        fn bindgen_test_layout_Value() {
            assert_eq!(
                ::std::mem::size_of::<Value>(),
                8usize,
                concat!("Size of: ", stringify!(Value))
            );
            assert_eq!(
                ::std::mem::align_of::<Value>(),
                8usize,
                concat!("Alignment of ", stringify!(Value))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<Value>())).asBits_ as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(Value),
                    "::",
                    stringify!(asBits_)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<Value>())).asDouble_ as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(Value),
                    "::",
                    stringify!(asDouble_)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<Value>())).debugView_ as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(Value),
                    "::",
                    stringify!(debugView_)
                )
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<Value>())).s_ as *const _ as usize },
                0usize,
                concat!("Offset of field: ", stringify!(Value), "::", stringify!(s_))
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct ConstUTF8CharsZ {
            pub data_: *const ::std::os::raw::c_char,
        }
        pub type ConstUTF8CharsZ_CharT = ::std::os::raw::c_uchar;
        #[test]
        fn bindgen_test_layout_ConstUTF8CharsZ() {
            assert_eq!(
                ::std::mem::size_of::<ConstUTF8CharsZ>(),
                8usize,
                concat!("Size of: ", stringify!(ConstUTF8CharsZ))
            );
            assert_eq!(
                ::std::mem::align_of::<ConstUTF8CharsZ>(),
                8usize,
                concat!("Alignment of ", stringify!(ConstUTF8CharsZ))
            );
            assert_eq!(
                unsafe { &(*(::std::ptr::null::<ConstUTF8CharsZ>())).data_ as *const _ as usize },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ConstUTF8CharsZ),
                    "::",
                    stringify!(data_)
                )
            );
        }
        #[doc = " The ConsumeStreamCallback is called from an active JSContext, passing a"]
        #[doc = " StreamConsumer that wishes to consume the given host object as a stream of"]
        #[doc = " bytes with the given MIME type. On failure, the embedding must report the"]
        #[doc = " appropriate error on \'cx\'. On success, the embedding must call"]
        #[doc = " consumer->consumeChunk() repeatedly on any thread until exactly one of:"]
        #[doc = "  - consumeChunk() returns false"]
        #[doc = "  - the embedding calls consumer->streamEnd()"]
        #[doc = "  - the embedding calls consumer->streamError()"]
        #[doc = " before JS_DestroyContext(cx) or JS::ShutdownAsyncTasks(cx) is called."]
        #[doc = ""]
        #[doc = " Note: consumeChunk(), streamEnd() and streamError() may be called"]
        #[doc = " synchronously by ConsumeStreamCallback."]
        #[doc = ""]
        #[doc = " When streamEnd() is called, the embedding may optionally pass an"]
        #[doc = " OptimizedEncodingListener*, indicating that there is a cache entry associated"]
        #[doc = " with this stream that can store an optimized encoding of the bytes that were"]
        #[doc = " just streamed at some point in the future by having SpiderMonkey call"]
        #[doc = " storeOptimizedEncoding(). Until the optimized encoding is ready, SpiderMonkey"]
        #[doc = " will hold an outstanding refcount to keep the listener alive."]
        #[doc = ""]
        #[doc = " After storeOptimizedEncoding() is called, on cache hit, the embedding"]
        #[doc = " may call consumeOptimizedEncoding() instead of consumeChunk()/streamEnd()."]
        #[doc = " The embedding must ensure that the GetOptimizedEncodingBuildId() (see"]
        #[doc = " js/BuildId.h) at the time when an optimized encoding is created is the same"]
        #[doc = " as when it is later consumed."]
        pub type OptimizedEncodingBytes = u8;
        #[doc = " Supply an alternative stack to incorporate into captured SavedFrame"]
        #[doc = " backtraces as the imputed caller of asynchronous JavaScript calls, like async"]
        #[doc = " function resumptions and DOM callbacks."]
        #[doc = ""]
        #[doc = " When one async function awaits the result of another, it\'s natural to think"]
        #[doc = " of that as a sort of function call: just as execution resumes from an"]
        #[doc = " ordinary call expression when the callee returns, with the return value"]
        #[doc = " providing the value of the call expression, execution resumes from an \'await\'"]
        #[doc = " expression after the awaited asynchronous function call returns, passing the"]
        #[doc = " return value along."]
        #[doc = ""]
        #[doc = " Call the two async functions in such a situation the \'awaiter\' and the"]
        #[doc = " \'awaitee\'."]
        #[doc = ""]
        #[doc = " As an async function, the awaitee contains \'await\' expressions of its own."]
        #[doc = " Whenever it executes after its first \'await\', there are never any actual"]
        #[doc = " frames on the JavaScript stack under it; its awaiter is certainly not there."]
        #[doc = " An await expression\'s continuation is invoked as a promise callback, and"]
        #[doc = " those are always called directly from the event loop in their own microtick."]
        #[doc = " (Ignore unusual cases like nested event loops.)"]
        #[doc = ""]
        #[doc = " But because await expressions bear such a strong resemblance to calls (and"]
        #[doc = " deliberately so!), it would be unhelpful for stacks captured within the"]
        #[doc = " awaitee to be empty; instead, they should present the awaiter as the caller."]
        #[doc = ""]
        #[doc = " The AutoSetAsyncStackForNewCalls RAII class supplies a SavedFrame stack to"]
        #[doc = " treat as the caller of any JavaScript invocations that occur within its"]
        #[doc = " lifetime. Any SavedFrame stack captured during such an invocation uses the"]
        #[doc = " SavedFrame passed to the constructor\'s \'stack\' parameter as the \'asyncParent\'"]
        #[doc = " property of the SavedFrame for the invocation\'s oldest frame. Its \'parent\'"]
        #[doc = " property will be null, so stack-walking code can distinguish this"]
        #[doc = " awaiter/awaitee transition from an ordinary caller/callee transition."]
        #[doc = ""]
        #[doc = " The constructor\'s \'asyncCause\' parameter supplies a string explaining what"]
        #[doc = " sort of asynchronous call caused \'stack\' to be spliced into the backtrace;"]
        #[doc = " for example, async function resumptions use the string \"async\". This appears"]
        #[doc = " as the \'asyncCause\' property of the \'asyncParent\' SavedFrame."]
        #[doc = ""]
        #[doc = " Async callers are distinguished in the string form of a SavedFrame chain by"]
        #[doc = " including the \'asyncCause\' string in the frame. It appears before the"]
        #[doc = " function name, with the two separated by a \'*\'."]
        #[doc = ""]
        #[doc = " Note that, as each compartment has its own set of SavedFrames, the"]
        #[doc = " \'asyncParent\' may actually point to a copy of \'stack\', rather than the exact"]
        #[doc = " SavedFrame object passed."]
        #[doc = ""]
        #[doc = " The youngest frame of \'stack\' is not mutated to take the asyncCause string as"]
        #[doc = " its \'asyncCause\' property; SavedFrame objects are immutable. Rather, a fresh"]
        #[doc = " clone of the frame is created with the needed \'asyncCause\' property."]
        #[doc = ""]
        #[doc = " The \'kind\' argument specifies how aggressively \'stack\' supplants any"]
        #[doc = " JavaScript frames older than this AutoSetAsyncStackForNewCalls object. If"]
        #[doc = " \'kind\' is \'EXPLICIT\', then all captured SavedFrame chains take on \'stack\' as"]
        #[doc = " their \'asyncParent\' where the chain crosses this object\'s scope. If \'kind\' is"]
        #[doc = " \'IMPLICIT\', then \'stack\' is only included in captured chains if there are no"]
        #[doc = " other JavaScript frames on the stack --- that is, only if the stack would"]
        #[doc = " otherwise end at that point."]
        #[doc = ""]
        #[doc = " AutoSetAsyncStackForNewCalls affects only SavedFrame chains; it does not"]
        #[doc = " affect Debugger.Frame or js::FrameIter. SavedFrame chains are used for"]
        #[doc = " Error.stack, allocation profiling, Promise debugging, and so on."]
        #[doc = ""]
        #[doc = " See also `js/src/doc/SavedFrame/SavedFrame.md` for documentation on async"]
        #[doc = " stack frames."]
        #[repr(C)]
        #[derive(Debug)]
        pub struct AutoSetAsyncStackForNewCalls {
            pub cx: *mut root::JSContext,
            pub oldAsyncStack: root::JS::RootedObject,
            pub oldAsyncCause: *const ::std::os::raw::c_char,
            pub oldAsyncCallIsExplicit: bool,
        }
        pub const AutoSetAsyncStackForNewCalls_AsyncCallKind_IMPLICIT:
            root::JS::AutoSetAsyncStackForNewCalls_AsyncCallKind = 0;
        pub const AutoSetAsyncStackForNewCalls_AsyncCallKind_EXPLICIT:
            root::JS::AutoSetAsyncStackForNewCalls_AsyncCallKind = 1;
        pub type AutoSetAsyncStackForNewCalls_AsyncCallKind = i32;
        #[test]
        fn bindgen_test_layout_AutoSetAsyncStackForNewCalls() {
            assert_eq!(
                ::std::mem::size_of::<AutoSetAsyncStackForNewCalls>(),
                48usize,
                concat!("Size of: ", stringify!(AutoSetAsyncStackForNewCalls))
            );
            assert_eq!(
                ::std::mem::align_of::<AutoSetAsyncStackForNewCalls>(),
                8usize,
                concat!("Alignment of ", stringify!(AutoSetAsyncStackForNewCalls))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AutoSetAsyncStackForNewCalls>())).cx as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AutoSetAsyncStackForNewCalls),
                    "::",
                    stringify!(cx)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AutoSetAsyncStackForNewCalls>())).oldAsyncStack
                        as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AutoSetAsyncStackForNewCalls),
                    "::",
                    stringify!(oldAsyncStack)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AutoSetAsyncStackForNewCalls>())).oldAsyncCause
                        as *const _ as usize
                },
                32usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AutoSetAsyncStackForNewCalls),
                    "::",
                    stringify!(oldAsyncCause)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AutoSetAsyncStackForNewCalls>())).oldAsyncCallIsExplicit
                        as *const _ as usize
                },
                40usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AutoSetAsyncStackForNewCalls),
                    "::",
                    stringify!(oldAsyncCallIsExplicit)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct AutoHideScriptedCaller {
            pub mContext: *mut root::JSContext,
        }
        #[test]
        fn bindgen_test_layout_AutoHideScriptedCaller() {
            assert_eq!(
                ::std::mem::size_of::<AutoHideScriptedCaller>(),
                8usize,
                concat!("Size of: ", stringify!(AutoHideScriptedCaller))
            );
            assert_eq!(
                ::std::mem::align_of::<AutoHideScriptedCaller>(),
                8usize,
                concat!("Alignment of ", stringify!(AutoHideScriptedCaller))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AutoHideScriptedCaller>())).mContext as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AutoHideScriptedCaller),
                    "::",
                    stringify!(mContext)
                )
            );
        }
        pub type WarningReporter = ::std::option::Option<
            unsafe extern "C" fn(cx: *mut root::JSContext, report: *mut root::JSErrorReport),
        >;
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct JSContext {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct JSObject {
        _unused: [u8; 0],
    }
    pub mod js {
        #[allow(unused_imports)]
        use self::super::super::root;
        pub mod gc {
            #[allow(unused_imports)]
            use self::super::super::super::root;
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct AllocPolicyBase {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_AllocPolicyBase() {
            assert_eq!(
                ::std::mem::size_of::<AllocPolicyBase>(),
                1usize,
                concat!("Size of: ", stringify!(AllocPolicyBase))
            );
            assert_eq!(
                ::std::mem::align_of::<AllocPolicyBase>(),
                1usize,
                concat!("Alignment of ", stringify!(AllocPolicyBase))
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct SystemAllocPolicy {
            pub _address: u8,
        }
        #[test]
        fn bindgen_test_layout_SystemAllocPolicy() {
            assert_eq!(
                ::std::mem::size_of::<SystemAllocPolicy>(),
                1usize,
                concat!("Size of: ", stringify!(SystemAllocPolicy))
            );
            assert_eq!(
                ::std::mem::align_of::<SystemAllocPolicy>(),
                1usize,
                concat!("Alignment of ", stringify!(SystemAllocPolicy))
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct ProfilingStackFrame {
            pub label_: u64,
            pub dynamicString_: u64,
            pub spOrScript: u64,
            pub pcOffsetIfJS_: u32,
            pub flagsAndCategoryPair_: u32,
        }
        pub const ProfilingStackFrame_Flags_IS_LABEL_FRAME: root::js::ProfilingStackFrame_Flags = 1;
        pub const ProfilingStackFrame_Flags_IS_SP_MARKER_FRAME:
            root::js::ProfilingStackFrame_Flags = 2;
        pub const ProfilingStackFrame_Flags_IS_JS_FRAME: root::js::ProfilingStackFrame_Flags = 4;
        pub const ProfilingStackFrame_Flags_JS_OSR: root::js::ProfilingStackFrame_Flags = 8;
        pub const ProfilingStackFrame_Flags_STRING_TEMPLATE_METHOD:
            root::js::ProfilingStackFrame_Flags = 16;
        pub const ProfilingStackFrame_Flags_STRING_TEMPLATE_GETTER:
            root::js::ProfilingStackFrame_Flags = 32;
        pub const ProfilingStackFrame_Flags_STRING_TEMPLATE_SETTER:
            root::js::ProfilingStackFrame_Flags = 64;
        pub const ProfilingStackFrame_Flags_RELEVANT_FOR_JS: root::js::ProfilingStackFrame_Flags =
            128;
        pub const ProfilingStackFrame_Flags_LABEL_DETERMINED_BY_CATEGORY_PAIR:
            root::js::ProfilingStackFrame_Flags = 256;
        pub const ProfilingStackFrame_Flags_FLAGS_BITCOUNT: root::js::ProfilingStackFrame_Flags = 9;
        pub const ProfilingStackFrame_Flags_FLAGS_MASK: root::js::ProfilingStackFrame_Flags = 511;
        pub type ProfilingStackFrame_Flags = u32;
        pub const ProfilingStackFrame_NullPCOffset: i32 = -1;
        #[test]
        fn bindgen_test_layout_ProfilingStackFrame() {
            assert_eq!(
                ::std::mem::size_of::<ProfilingStackFrame>(),
                32usize,
                concat!("Size of: ", stringify!(ProfilingStackFrame))
            );
            assert_eq!(
                ::std::mem::align_of::<ProfilingStackFrame>(),
                8usize,
                concat!("Alignment of ", stringify!(ProfilingStackFrame))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ProfilingStackFrame>())).label_ as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ProfilingStackFrame),
                    "::",
                    stringify!(label_)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ProfilingStackFrame>())).dynamicString_ as *const _
                        as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ProfilingStackFrame),
                    "::",
                    stringify!(dynamicString_)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ProfilingStackFrame>())).spOrScript as *const _ as usize
                },
                16usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ProfilingStackFrame),
                    "::",
                    stringify!(spOrScript)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ProfilingStackFrame>())).pcOffsetIfJS_ as *const _
                        as usize
                },
                24usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ProfilingStackFrame),
                    "::",
                    stringify!(pcOffsetIfJS_)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ProfilingStackFrame>())).flagsAndCategoryPair_
                        as *const _ as usize
                },
                28usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ProfilingStackFrame),
                    "::",
                    stringify!(flagsAndCategoryPair_)
                )
            );
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct WrappedPtrOperations {
            pub _address: u8,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct MutableWrappedPtrOperations {
            pub _address: u8,
        }
        #[repr(C)]
        #[derive(Debug, Copy, Clone)]
        pub struct HeapBase {
            pub _address: u8,
        }
        #[repr(C)]
        #[derive(Debug)]
        pub struct ExpandoAndGeneration {
            pub expando: root::JS::Heap<root::JS::Value>,
            pub generation: u64,
        }
        #[test]
        fn bindgen_test_layout_ExpandoAndGeneration() {
            assert_eq!(
                ::std::mem::size_of::<ExpandoAndGeneration>(),
                16usize,
                concat!("Size of: ", stringify!(ExpandoAndGeneration))
            );
            assert_eq!(
                ::std::mem::align_of::<ExpandoAndGeneration>(),
                8usize,
                concat!("Alignment of ", stringify!(ExpandoAndGeneration))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ExpandoAndGeneration>())).expando as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ExpandoAndGeneration),
                    "::",
                    stringify!(expando)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<ExpandoAndGeneration>())).generation as *const _ as usize
                },
                8usize,
                concat!(
                    "Offset of field: ",
                    stringify!(ExpandoAndGeneration),
                    "::",
                    stringify!(generation)
                )
            );
        }
    }
    #[repr(C)]
    pub struct nsISupports__bindgen_vtable(::std::os::raw::c_void);
    #[doc = " Basic component object model interface. Objects which implement"]
    #[doc = " this interface support runtime interface discovery (QueryInterface)"]
    #[doc = " and a reference counted memory model (AddRef/Release). This is"]
    #[doc = " modelled after the win32 IUnknown API."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsISupports {
        pub vtable_: *const nsISupports__bindgen_vtable,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsISupports_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsISupports() {
        assert_eq!(
            ::std::mem::size_of::<nsISupports>(),
            8usize,
            concat!("Size of: ", stringify!(nsISupports))
        );
        assert_eq!(
            ::std::mem::align_of::<nsISupports>(),
            8usize,
            concat!("Alignment of ", stringify!(nsISupports))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct PRThread {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsCycleCollectingAutoRefCnt {
        pub mRefCntAndFlags: usize,
    }
    pub type nsCycleCollectingAutoRefCnt_Suspect = ::std::option::Option<
        unsafe extern "C" fn(
            aPtr: *mut ::std::os::raw::c_void,
            aCp: *mut root::nsCycleCollectionParticipant,
            aRefCnt: *mut root::nsCycleCollectingAutoRefCnt,
            aShouldDelete: *mut bool,
        ),
    >;
    #[test]
    fn bindgen_test_layout_nsCycleCollectingAutoRefCnt() {
        assert_eq!(
            ::std::mem::size_of::<nsCycleCollectingAutoRefCnt>(),
            8usize,
            concat!("Size of: ", stringify!(nsCycleCollectingAutoRefCnt))
        );
        assert_eq!(
            ::std::mem::align_of::<nsCycleCollectingAutoRefCnt>(),
            8usize,
            concat!("Alignment of ", stringify!(nsCycleCollectingAutoRefCnt))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsCycleCollectingAutoRefCnt>())).mRefCntAndFlags as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCycleCollectingAutoRefCnt),
                "::",
                stringify!(mRefCntAndFlags)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsAutoRefCnt {
        pub mValue: root::nsrefcnt,
    }
    pub const nsAutoRefCnt_isThreadSafe: bool = false;
    #[test]
    fn bindgen_test_layout_nsAutoRefCnt() {
        assert_eq!(
            ::std::mem::size_of::<nsAutoRefCnt>(),
            8usize,
            concat!("Size of: ", stringify!(nsAutoRefCnt))
        );
        assert_eq!(
            ::std::mem::align_of::<nsAutoRefCnt>(),
            8usize,
            concat!("Alignment of ", stringify!(nsAutoRefCnt))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsAutoRefCnt>())).mValue as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsAutoRefCnt),
                "::",
                stringify!(mValue)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsTArrayHeader {
        pub mLength: u32,
        pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 4usize], u32>,
    }
    #[test]
    fn bindgen_test_layout_nsTArrayHeader() {
        assert_eq!(
            ::std::mem::size_of::<nsTArrayHeader>(),
            8usize,
            concat!("Size of: ", stringify!(nsTArrayHeader))
        );
        assert_eq!(
            ::std::mem::align_of::<nsTArrayHeader>(),
            4usize,
            concat!("Alignment of ", stringify!(nsTArrayHeader))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsTArrayHeader>())).mLength as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsTArrayHeader),
                "::",
                stringify!(mLength)
            )
        );
    }
    impl nsTArrayHeader {
        #[inline]
        pub fn mCapacity(&self) -> u32 {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 31u8) as u32) }
        }
        #[inline]
        pub fn set_mCapacity(&mut self, val: u32) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(0usize, 31u8, val as u64)
            }
        }
        #[inline]
        pub fn mIsAutoArray(&self) -> u32 {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(31usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mIsAutoArray(&mut self, val: u32) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(31usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn new_bitfield_1(
            mCapacity: u32,
            mIsAutoArray: u32,
        ) -> root::__BindgenBitfieldUnit<[u8; 4usize], u32> {
            let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 4usize], u32> =
                Default::default();
            __bindgen_bitfield_unit.set(0usize, 31u8, {
                let mCapacity: u32 = unsafe { ::std::mem::transmute(mCapacity) };
                mCapacity as u64
            });
            __bindgen_bitfield_unit.set(31usize, 1u8, {
                let mIsAutoArray: u32 = unsafe { ::std::mem::transmute(mIsAutoArray) };
                mIsAutoArray as u64
            });
            __bindgen_bitfield_unit
        }
    }
    extern "C" {
        pub fn Gecko_EnsureTArrayCapacity(
            aArray: *mut ::std::os::raw::c_void,
            aCapacity: usize,
            aElementSize: usize,
        );
    }
    extern "C" {
        pub fn Gecko_ClearPODTArray(
            aArray: *mut ::std::os::raw::c_void,
            aElementSize: usize,
            aElementAlign: usize,
        );
    }
    pub type AutoTArray_self_type = u8;
    pub type AutoTArray_base_type<E> = root::nsTArray<E>;
    pub type AutoTArray_Header<E> = root::AutoTArray_base_type<E>;
    pub type AutoTArray_elem_type<E> = root::AutoTArray_base_type<E>;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct AutoTArray__bindgen_ty_1 {
        pub mAutoBuf: root::__BindgenUnionField<*mut ::std::os::raw::c_char>,
        pub mAlign: root::__BindgenUnionField<u8>,
        pub bindgen_union_field: u64,
    }
    pub type gfxSize = [u64; 2usize];
    pub type nsIntMargin = root::mozilla::gfx::IntMargin;
    #[doc = " @see nsTAString"]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsReadingIterator<CharT> {
        pub mStart: *const CharT,
        pub mEnd: *const CharT,
        pub mPosition: *const CharT,
        pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<CharT>>,
    }
    pub type nsReadingIterator_self_type<CharT> = root::nsReadingIterator<CharT>;
    pub type nsReadingIterator_difference_type = isize;
    pub type nsReadingIterator_size_type = usize;
    pub type nsReadingIterator_value_type<CharT> = CharT;
    pub type nsReadingIterator_pointer<CharT> = *const CharT;
    pub type nsReadingIterator_reference = u8;
    #[repr(C)]
    pub struct nsTStringComparator__bindgen_vtable(::std::os::raw::c_void);
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsTStringComparator {
        pub vtable_: *const nsTStringComparator__bindgen_vtable,
    }
    pub type nsTStringComparator_char_type<T> = T;
    #[doc = " nsTSubstring is an abstract string class. From an API perspective, this"]
    #[doc = " class is the root of the string class hierarchy. It represents a single"]
    #[doc = " contiguous array of characters, which may or may not be null-terminated."]
    #[doc = " This type is not instantiated directly. A sub-class is instantiated"]
    #[doc = " instead. For example, see nsTString."]
    #[doc = ""]
    #[doc = " NAMES:"]
    #[doc = "   nsAString for wide characters"]
    #[doc = "   nsACString for narrow characters"]
    #[doc = ""]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsTSubstring<T> {
        pub _base: root::mozilla::detail::nsTStringRepr<T>,
        pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
    }
    pub type nsTSubstring_self_type<T> = root::nsTSubstring<T>;
    pub type nsTSubstring_string_type<T> = root::nsTString<T>;
    pub type nsTSubstring_base_string_type<T> = root::mozilla::detail::nsTStringRepr<T>;
    pub type nsTSubstring_substring_type<T> = root::nsTSubstring_base_string_type<T>;
    pub type nsTSubstring_fallible_t<T> = root::nsTSubstring_base_string_type<T>;
    pub type nsTSubstring_char_type<T> = root::nsTSubstring_base_string_type<T>;
    pub type nsTSubstring_substring_tuple_type<T> = root::nsTSubstring_base_string_type<T>;
    pub type nsTSubstring_const_iterator<T> = root::nsTSubstring_base_string_type<T>;
    pub type nsTSubstring_iterator<T> = root::nsTSubstring_base_string_type<T>;
    pub type nsTSubstring_comparator_type<T> = root::nsTSubstring_base_string_type<T>;
    pub type nsTSubstring_const_char_iterator<T> = root::nsTSubstring_base_string_type<T>;
    pub type nsTSubstring_index_type<T> = root::nsTSubstring_base_string_type<T>;
    pub type nsTSubstring_size_type<T> = root::nsTSubstring_base_string_type<T>;
    pub type nsTSubstring_DataFlags<T> = root::nsTSubstring_base_string_type<T>;
    pub type nsTSubstring_ClassFlags<T> = root::nsTSubstring_base_string_type<T>;
    #[doc = " nsTSubstringTuple"]
    #[doc = ""]
    #[doc = " Represents a tuple of string fragments.  Built as a recursive binary tree."]
    #[doc = " It is used to implement the concatenation of two or more string objects."]
    #[doc = ""]
    #[doc = " NOTE: This class is a private implementation detail and should never be"]
    #[doc = " referenced outside the string code."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsTSubstringTuple<T> {
        pub mHead: *const root::nsTSubstringTuple_self_type<T>,
        pub mFragA: *const root::nsTSubstringTuple_base_string_type<T>,
        pub mFragB: *const root::nsTSubstringTuple_base_string_type<T>,
        pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
    }
    pub type nsTSubstringTuple_char_type<T> = T;
    pub type nsTSubstringTuple_self_type<T> = root::nsTSubstringTuple<T>;
    pub type nsTSubstringTuple_base_string_type<T> =
        root::mozilla::detail::nsTStringRepr<root::nsTSubstringTuple_char_type<T>>;
    pub type nsTSubstringTuple_size_type = u32;
    #[doc = " This is the canonical null-terminated string class.  All subclasses"]
    #[doc = " promise null-terminated storage.  Instances of this class allocate"]
    #[doc = " strings on the heap."]
    #[doc = ""]
    #[doc = " NAMES:"]
    #[doc = "   nsString for wide characters"]
    #[doc = "   nsCString for narrow characters"]
    #[doc = ""]
    #[doc = " This class is also known as nsAFlat[C]String, where \"flat\" is used"]
    #[doc = " to denote a null-terminated string."]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsTString<T> {
        pub _base: root::nsTSubstring<T>,
        pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
    }
    pub type nsTString_self_type<T> = root::nsTString<T>;
    pub type nsTString_fallible_t = [u8; 0usize];
    pub type nsTString_char_type = [u8; 0usize];
    pub type nsTString_substring_tuple_type = [u8; 0usize];
    pub type nsTString_const_iterator = [u8; 0usize];
    pub type nsTString_iterator = [u8; 0usize];
    pub type nsTString_comparator_type = [u8; 0usize];
    pub type nsTString_const_char_iterator = [u8; 0usize];
    pub type nsTString_index_type = [u8; 0usize];
    pub type nsTString_size_type = [u8; 0usize];
    pub type nsTString_DataFlags = [u8; 0usize];
    pub type nsTString_ClassFlags = [u8; 0usize];
    #[doc = " returns the null-terminated string"]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsTString_raw_type {
        pub _address: u8,
    }
    pub type nsTString_raw_type_type<U> = *const U;
    pub const nsTString_TrailingCharsPolicy_Disallow: root::nsTString_TrailingCharsPolicy = 0;
    pub const nsTString_TrailingCharsPolicy_Allow: root::nsTString_TrailingCharsPolicy = 0;
    pub type nsTString_TrailingCharsPolicy = i32;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsTString_Segment {
        pub mBegin: u32,
        pub mLength: u32,
    }
    pub type nsTAutoStringN_self_type = u8;
    pub type nsTAutoStringN_base_string_type<T> = root::nsTString<T>;
    pub type nsTAutoStringN_string_type<T> = root::nsTAutoStringN_base_string_type<T>;
    pub type nsTAutoStringN_char_type<T> = root::nsTAutoStringN_base_string_type<T>;
    pub type nsTAutoStringN_substring_type<T> = root::nsTAutoStringN_base_string_type<T>;
    pub type nsTAutoStringN_size_type<T> = root::nsTAutoStringN_base_string_type<T>;
    pub type nsTAutoStringN_substring_tuple_type<T> = root::nsTAutoStringN_base_string_type<T>;
    pub type nsTAutoStringN_DataFlags<T> = root::nsTAutoStringN_base_string_type<T>;
    pub type nsTAutoStringN_ClassFlags<T> = root::nsTAutoStringN_base_string_type<T>;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoFontFaceRule {
        _unused: [u8; 0],
    }
    #[repr(C)]
    pub struct nsFontFaceRuleContainer {
        pub mRule: root::RefPtr<root::RawServoFontFaceRule>,
        pub mOrigin: root::mozilla::StyleOrigin,
    }
    #[test]
    fn bindgen_test_layout_nsFontFaceRuleContainer() {
        assert_eq!(
            ::std::mem::size_of::<nsFontFaceRuleContainer>(),
            16usize,
            concat!("Size of: ", stringify!(nsFontFaceRuleContainer))
        );
        assert_eq!(
            ::std::mem::align_of::<nsFontFaceRuleContainer>(),
            8usize,
            concat!("Alignment of ", stringify!(nsFontFaceRuleContainer))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsFontFaceRuleContainer>())).mRule as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFontFaceRuleContainer),
                "::",
                stringify!(mRule)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsFontFaceRuleContainer>())).mOrigin as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFontFaceRuleContainer),
                "::",
                stringify!(mOrigin)
            )
        );
    }
    #[doc = " We want C++ to be able to read the style struct fields of ComputedValues"]
    #[doc = " so we define this type on the C++ side and use the bindgenned version"]
    #[doc = " on the Rust side."]
    #[repr(C)]
    pub struct ServoComputedData {
        pub Font: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoFont>,
        pub Color: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoColor>,
        pub List: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoList>,
        pub Text: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoText>,
        pub Visibility: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoVisibility>,
        pub UI: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoUI>,
        pub TableBorder: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoTableBorder>,
        pub SVG: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoSVG>,
        pub Background: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoBackground>,
        pub Position: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoPosition>,
        pub TextReset: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoTextReset>,
        pub Display: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoDisplay>,
        pub Content: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoContent>,
        pub UIReset: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoUIReset>,
        pub Table: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoTable>,
        pub Margin: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoMargin>,
        pub Padding: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoPadding>,
        pub Border: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoBorder>,
        pub Outline: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoOutline>,
        pub XUL: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoXUL>,
        pub SVGReset: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoSVGReset>,
        pub Column: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoColumn>,
        pub Effects: ::gecko_bindings::structs::ServoRawOffsetArc<root::mozilla::GeckoEffects>,
        pub custom_properties: ::gecko_bindings::structs::ServoCustomPropertiesMap,
        pub writing_mode: ::gecko_bindings::structs::ServoWritingMode,
        pub flags: ::gecko_bindings::structs::ServoComputedValueFlags,
        #[doc = " The rule node representing the ordered list of rules matched for this"]
        #[doc = " node.  Can be None for default values and text nodes.  This is"]
        #[doc = " essentially an optimization to avoid referencing the root rule node."]
        pub rules: ::gecko_bindings::structs::ServoRuleNode,
        #[doc = " The element\'s computed values if visited, only computed if there\'s a"]
        #[doc = " relevant link for this element. A element\'s \"relevant link\" is the"]
        #[doc = " element being matched if it is a link or the nearest ancestor link."]
        pub visited_style: ::gecko_bindings::structs::ServoVisitedStyle,
    }
    #[test]
    fn bindgen_test_layout_ServoComputedData() {
        assert_eq!(
            ::std::mem::size_of::<ServoComputedData>(),
            216usize,
            concat!("Size of: ", stringify!(ServoComputedData))
        );
        assert_eq!(
            ::std::mem::align_of::<ServoComputedData>(),
            8usize,
            concat!("Alignment of ", stringify!(ServoComputedData))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).Font as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(Font)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).Color as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(Color)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).List as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(List)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).Text as *const _ as usize },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(Text)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<ServoComputedData>())).Visibility as *const _ as usize
            },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(Visibility)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).UI as *const _ as usize },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(UI)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<ServoComputedData>())).TableBorder as *const _ as usize
            },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(TableBorder)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).SVG as *const _ as usize },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(SVG)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<ServoComputedData>())).Background as *const _ as usize
            },
            64usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(Background)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).Position as *const _ as usize },
            72usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(Position)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).TextReset as *const _ as usize },
            80usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(TextReset)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).Display as *const _ as usize },
            88usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(Display)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).Content as *const _ as usize },
            96usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(Content)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).UIReset as *const _ as usize },
            104usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(UIReset)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).Table as *const _ as usize },
            112usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(Table)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).Margin as *const _ as usize },
            120usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(Margin)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).Padding as *const _ as usize },
            128usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(Padding)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).Border as *const _ as usize },
            136usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(Border)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).Outline as *const _ as usize },
            144usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(Outline)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).XUL as *const _ as usize },
            152usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(XUL)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).SVGReset as *const _ as usize },
            160usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(SVGReset)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).Column as *const _ as usize },
            168usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(Column)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).Effects as *const _ as usize },
            176usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(Effects)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<ServoComputedData>())).custom_properties as *const _ as usize
            },
            184usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(custom_properties)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<ServoComputedData>())).writing_mode as *const _ as usize
            },
            192usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(writing_mode)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).flags as *const _ as usize },
            194usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(flags)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ServoComputedData>())).rules as *const _ as usize },
            200usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(rules)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<ServoComputedData>())).visited_style as *const _ as usize
            },
            208usize,
            concat!(
                "Offset of field: ",
                stringify!(ServoComputedData),
                "::",
                stringify!(visited_style)
            )
        );
    }
    #[doc = " Factors implementation for all template versions of nsCOMPtr."]
    #[doc = ""]
    #[doc = " Here\'s the way people normally do things like this:"]
    #[doc = ""]
    #[doc = "   template<class T> class Foo { ... };"]
    #[doc = "   template<> class Foo<void*> { ... };"]
    #[doc = "   template<class T> class Foo<T*> : private Foo<void*> { ... };"]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsCOMPtr_base {
        pub mRawPtr: *mut root::nsISupports,
    }
    #[test]
    fn bindgen_test_layout_nsCOMPtr_base() {
        assert_eq!(
            ::std::mem::size_of::<nsCOMPtr_base>(),
            8usize,
            concat!("Size of: ", stringify!(nsCOMPtr_base))
        );
        assert_eq!(
            ::std::mem::align_of::<nsCOMPtr_base>(),
            8usize,
            concat!("Alignment of ", stringify!(nsCOMPtr_base))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsCOMPtr_base>())).mRawPtr as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCOMPtr_base),
                "::",
                stringify!(mRawPtr)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsCOMPtr {
        pub _base: root::nsCOMPtr_base,
    }
    pub type nsCOMPtr_element_type<T> = T;
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsAutoPtr<T> {
        pub mRawPtr: *mut T,
        pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsAutoPtr_Ptr<T> {
        pub mPtr: *mut T,
        pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
    }
    pub type nsAutoPtr_element_type<T> = T;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsAutoPtr_Proxy {
        pub _address: u8,
    }
    pub type nsAutoPtr_Proxy_member_function = u8;
    pub type PLDHashNumber = root::mozilla::HashNumber;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct PLDHashEntryHdr {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_PLDHashEntryHdr() {
        assert_eq!(
            ::std::mem::size_of::<PLDHashEntryHdr>(),
            1usize,
            concat!("Size of: ", stringify!(PLDHashEntryHdr))
        );
        assert_eq!(
            ::std::mem::align_of::<PLDHashEntryHdr>(),
            1usize,
            concat!("Alignment of ", stringify!(PLDHashEntryHdr))
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct PLDHashTable {
        pub mOps: *const root::PLDHashTableOps,
        pub mEntryStore: root::PLDHashTable_EntryStore,
        pub mGeneration: u16,
        pub mHashShift: u8,
        pub mEntrySize: u8,
        pub mEntryCount: u32,
        pub mRemovedCount: u32,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct PLDHashTable_Slot {
        pub mEntry: *mut root::PLDHashEntryHdr,
        pub mKeyHash: *mut root::PLDHashNumber,
    }
    #[test]
    fn bindgen_test_layout_PLDHashTable_Slot() {
        assert_eq!(
            ::std::mem::size_of::<PLDHashTable_Slot>(),
            16usize,
            concat!("Size of: ", stringify!(PLDHashTable_Slot))
        );
        assert_eq!(
            ::std::mem::align_of::<PLDHashTable_Slot>(),
            8usize,
            concat!("Alignment of ", stringify!(PLDHashTable_Slot))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<PLDHashTable_Slot>())).mEntry as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTable_Slot),
                "::",
                stringify!(mEntry)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<PLDHashTable_Slot>())).mKeyHash as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTable_Slot),
                "::",
                stringify!(mKeyHash)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct PLDHashTable_EntryStore {
        pub mEntryStore: *mut ::std::os::raw::c_char,
    }
    #[test]
    fn bindgen_test_layout_PLDHashTable_EntryStore() {
        assert_eq!(
            ::std::mem::size_of::<PLDHashTable_EntryStore>(),
            8usize,
            concat!("Size of: ", stringify!(PLDHashTable_EntryStore))
        );
        assert_eq!(
            ::std::mem::align_of::<PLDHashTable_EntryStore>(),
            8usize,
            concat!("Alignment of ", stringify!(PLDHashTable_EntryStore))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<PLDHashTable_EntryStore>())).mEntryStore as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTable_EntryStore),
                "::",
                stringify!(mEntryStore)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct PLDHashTable_Iterator {
        pub mTable: *mut root::PLDHashTable,
        pub mCurrent: root::PLDHashTable_Slot,
        pub mNexts: u32,
        pub mNextsLimit: u32,
        pub mHaveRemoved: bool,
        pub mEntrySize: u8,
    }
    #[test]
    fn bindgen_test_layout_PLDHashTable_Iterator() {
        assert_eq!(
            ::std::mem::size_of::<PLDHashTable_Iterator>(),
            40usize,
            concat!("Size of: ", stringify!(PLDHashTable_Iterator))
        );
        assert_eq!(
            ::std::mem::align_of::<PLDHashTable_Iterator>(),
            8usize,
            concat!("Alignment of ", stringify!(PLDHashTable_Iterator))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<PLDHashTable_Iterator>())).mTable as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTable_Iterator),
                "::",
                stringify!(mTable)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<PLDHashTable_Iterator>())).mCurrent as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTable_Iterator),
                "::",
                stringify!(mCurrent)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<PLDHashTable_Iterator>())).mNexts as *const _ as usize
            },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTable_Iterator),
                "::",
                stringify!(mNexts)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<PLDHashTable_Iterator>())).mNextsLimit as *const _ as usize
            },
            28usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTable_Iterator),
                "::",
                stringify!(mNextsLimit)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<PLDHashTable_Iterator>())).mHaveRemoved as *const _ as usize
            },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTable_Iterator),
                "::",
                stringify!(mHaveRemoved)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<PLDHashTable_Iterator>())).mEntrySize as *const _ as usize
            },
            33usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTable_Iterator),
                "::",
                stringify!(mEntrySize)
            )
        );
    }
    pub const PLDHashTable_SearchReason_ForSearchOrRemove: root::PLDHashTable_SearchReason = 0;
    pub const PLDHashTable_SearchReason_ForAdd: root::PLDHashTable_SearchReason = 1;
    pub type PLDHashTable_SearchReason = u32;
    pub const PLDHashTable_kMaxCapacity: u32 = 67108864;
    pub const PLDHashTable_kMinCapacity: u32 = 8;
    pub const PLDHashTable_kMaxInitialLength: u32 = 33554432;
    pub const PLDHashTable_kDefaultInitialLength: u32 = 4;
    pub const PLDHashTable_kCollisionFlag: root::PLDHashNumber = 1;
    #[test]
    fn bindgen_test_layout_PLDHashTable() {
        assert_eq!(
            ::std::mem::size_of::<PLDHashTable>(),
            32usize,
            concat!("Size of: ", stringify!(PLDHashTable))
        );
        assert_eq!(
            ::std::mem::align_of::<PLDHashTable>(),
            8usize,
            concat!("Alignment of ", stringify!(PLDHashTable))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<PLDHashTable>())).mOps as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTable),
                "::",
                stringify!(mOps)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<PLDHashTable>())).mEntryStore as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTable),
                "::",
                stringify!(mEntryStore)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<PLDHashTable>())).mGeneration as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTable),
                "::",
                stringify!(mGeneration)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<PLDHashTable>())).mHashShift as *const _ as usize },
            18usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTable),
                "::",
                stringify!(mHashShift)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<PLDHashTable>())).mEntrySize as *const _ as usize },
            19usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTable),
                "::",
                stringify!(mEntrySize)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<PLDHashTable>())).mEntryCount as *const _ as usize },
            20usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTable),
                "::",
                stringify!(mEntryCount)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<PLDHashTable>())).mRemovedCount as *const _ as usize },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTable),
                "::",
                stringify!(mRemovedCount)
            )
        );
    }
    pub type PLDHashHashKey = ::std::option::Option<
        unsafe extern "C" fn(aKey: *const ::std::os::raw::c_void) -> root::PLDHashNumber,
    >;
    pub type PLDHashMatchEntry = ::std::option::Option<
        unsafe extern "C" fn(
            aEntry: *const root::PLDHashEntryHdr,
            aKey: *const ::std::os::raw::c_void,
        ) -> bool,
    >;
    pub type PLDHashMoveEntry = ::std::option::Option<
        unsafe extern "C" fn(
            aTable: *mut root::PLDHashTable,
            aFrom: *const root::PLDHashEntryHdr,
            aTo: *mut root::PLDHashEntryHdr,
        ),
    >;
    pub type PLDHashClearEntry = ::std::option::Option<
        unsafe extern "C" fn(aTable: *mut root::PLDHashTable, aEntry: *mut root::PLDHashEntryHdr),
    >;
    pub type PLDHashInitEntry = ::std::option::Option<
        unsafe extern "C" fn(
            aEntry: *mut root::PLDHashEntryHdr,
            aKey: *const ::std::os::raw::c_void,
        ),
    >;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct PLDHashTableOps {
        pub hashKey: root::PLDHashHashKey,
        pub matchEntry: root::PLDHashMatchEntry,
        pub moveEntry: root::PLDHashMoveEntry,
        pub clearEntry: root::PLDHashClearEntry,
        pub initEntry: root::PLDHashInitEntry,
    }
    #[test]
    fn bindgen_test_layout_PLDHashTableOps() {
        assert_eq!(
            ::std::mem::size_of::<PLDHashTableOps>(),
            40usize,
            concat!("Size of: ", stringify!(PLDHashTableOps))
        );
        assert_eq!(
            ::std::mem::align_of::<PLDHashTableOps>(),
            8usize,
            concat!("Alignment of ", stringify!(PLDHashTableOps))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<PLDHashTableOps>())).hashKey as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTableOps),
                "::",
                stringify!(hashKey)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<PLDHashTableOps>())).matchEntry as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTableOps),
                "::",
                stringify!(matchEntry)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<PLDHashTableOps>())).moveEntry as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTableOps),
                "::",
                stringify!(moveEntry)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<PLDHashTableOps>())).clearEntry as *const _ as usize },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTableOps),
                "::",
                stringify!(clearEntry)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<PLDHashTableOps>())).initEntry as *const _ as usize },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(PLDHashTableOps),
                "::",
                stringify!(initEntry)
            )
        );
    }
    #[doc = " hashkey wrapper using T* KeyType"]
    #[doc = ""]
    #[doc = " @see nsTHashtable::EntryType for specification"]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsPtrHashKey<T> {
        pub mKey: *mut T,
        pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
    }
    pub type nsPtrHashKey_KeyType<T> = *mut T;
    pub type nsPtrHashKey_KeyTypePointer<T> = *const T;
    pub const nsPtrHashKey_ALLOW_MEMMOVE: root::nsPtrHashKey__bindgen_ty_1 = 0;
    pub type nsPtrHashKey__bindgen_ty_1 = i32;
    #[doc = " hashkey wrapper using nsAString KeyType"]
    #[doc = ""]
    #[doc = " @see nsTHashtable::EntryType for specification"]
    #[repr(C)]
    pub struct nsStringHashKey {
        pub mStr: ::gecko_bindings::structs::nsString,
    }
    pub type nsStringHashKey_KeyType = *const ::gecko_bindings::structs::nsAString;
    pub type nsStringHashKey_KeyTypePointer = *const ::gecko_bindings::structs::nsAString;
    pub const nsStringHashKey_ALLOW_MEMMOVE: root::nsStringHashKey__bindgen_ty_1 = 1;
    pub type nsStringHashKey__bindgen_ty_1 = u32;
    #[test]
    fn bindgen_test_layout_nsStringHashKey() {
        assert_eq!(
            ::std::mem::size_of::<nsStringHashKey>(),
            16usize,
            concat!("Size of: ", stringify!(nsStringHashKey))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStringHashKey>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStringHashKey))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStringHashKey>())).mStr as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStringHashKey),
                "::",
                stringify!(mStr)
            )
        );
    }
    #[doc = " hashkey wrapper using nsACString KeyType"]
    #[doc = ""]
    #[doc = " @see nsTHashtable::EntryType for specification"]
    #[repr(C)]
    pub struct nsCStringHashKey {
        pub mStr: ::gecko_bindings::structs::nsCString,
    }
    pub type nsCStringHashKey_KeyType = *const ::gecko_bindings::structs::nsACString;
    pub type nsCStringHashKey_KeyTypePointer = *const ::gecko_bindings::structs::nsACString;
    pub const nsCStringHashKey_ALLOW_MEMMOVE: root::nsCStringHashKey__bindgen_ty_1 = 1;
    pub type nsCStringHashKey__bindgen_ty_1 = u32;
    #[test]
    fn bindgen_test_layout_nsCStringHashKey() {
        assert_eq!(
            ::std::mem::size_of::<nsCStringHashKey>(),
            16usize,
            concat!("Size of: ", stringify!(nsCStringHashKey))
        );
        assert_eq!(
            ::std::mem::align_of::<nsCStringHashKey>(),
            8usize,
            concat!("Alignment of ", stringify!(nsCStringHashKey))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsCStringHashKey>())).mStr as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCStringHashKey),
                "::",
                stringify!(mStr)
            )
        );
    }
    #[doc = " hashkey wrapper using uint32_t KeyType"]
    #[doc = ""]
    #[doc = " @see nsTHashtable::EntryType for specification"]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsUint32HashKey {
        pub mValue: u32,
    }
    pub type nsUint32HashKey_KeyType = *const u32;
    pub type nsUint32HashKey_KeyTypePointer = *const u32;
    pub const nsUint32HashKey_ALLOW_MEMMOVE: root::nsUint32HashKey__bindgen_ty_1 = 1;
    pub type nsUint32HashKey__bindgen_ty_1 = u32;
    #[test]
    fn bindgen_test_layout_nsUint32HashKey() {
        assert_eq!(
            ::std::mem::size_of::<nsUint32HashKey>(),
            4usize,
            concat!("Size of: ", stringify!(nsUint32HashKey))
        );
        assert_eq!(
            ::std::mem::align_of::<nsUint32HashKey>(),
            4usize,
            concat!("Alignment of ", stringify!(nsUint32HashKey))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsUint32HashKey>())).mValue as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsUint32HashKey),
                "::",
                stringify!(mValue)
            )
        );
    }
    #[doc = " hashkey wrapper using nsISupports* KeyType"]
    #[doc = ""]
    #[doc = " @see nsTHashtable::EntryType for specification"]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsISupportsHashKey {
        pub mSupports: root::nsCOMPtr,
    }
    pub type nsISupportsHashKey_KeyType = *mut root::nsISupports;
    pub type nsISupportsHashKey_KeyTypePointer = *const root::nsISupports;
    pub const nsISupportsHashKey_ALLOW_MEMMOVE: root::nsISupportsHashKey__bindgen_ty_1 = 1;
    pub type nsISupportsHashKey__bindgen_ty_1 = u32;
    #[test]
    fn bindgen_test_layout_nsISupportsHashKey() {
        assert_eq!(
            ::std::mem::size_of::<nsISupportsHashKey>(),
            8usize,
            concat!("Size of: ", stringify!(nsISupportsHashKey))
        );
        assert_eq!(
            ::std::mem::align_of::<nsISupportsHashKey>(),
            8usize,
            concat!("Alignment of ", stringify!(nsISupportsHashKey))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsISupportsHashKey>())).mSupports as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsISupportsHashKey),
                "::",
                stringify!(mSupports)
            )
        );
    }
    #[doc = " hashkey wrapper using refcounted * KeyType"]
    #[doc = ""]
    #[doc = " @see nsTHashtable::EntryType for specification"]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsRefPtrHashKey<T> {
        pub mKey: root::RefPtr<T>,
        pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
    }
    pub type nsRefPtrHashKey_KeyType<T> = *mut T;
    pub type nsRefPtrHashKey_KeyTypePointer<T> = *const T;
    pub const nsRefPtrHashKey_ALLOW_MEMMOVE: root::nsRefPtrHashKey__bindgen_ty_1 = 0;
    pub type nsRefPtrHashKey__bindgen_ty_1 = i32;
    #[repr(i32)]
    #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
    pub enum nsCSSPropertyID {
        eCSSProperty_UNKNOWN = -1,
        eCSSProperty_align_content = 0,
        eCSSProperty_align_items = 1,
        eCSSProperty_align_self = 2,
        eCSSProperty_backface_visibility = 3,
        eCSSProperty_border_collapse = 4,
        eCSSProperty_border_image_repeat = 5,
        eCSSProperty_box_decoration_break = 6,
        eCSSProperty_box_sizing = 7,
        eCSSProperty_break_inside = 8,
        eCSSProperty_caption_side = 9,
        eCSSProperty_clear = 10,
        eCSSProperty_color_adjust = 11,
        eCSSProperty_color_interpolation = 12,
        eCSSProperty_color_interpolation_filters = 13,
        eCSSProperty_column_count = 14,
        eCSSProperty_column_fill = 15,
        eCSSProperty_column_span = 16,
        eCSSProperty_contain = 17,
        eCSSProperty_direction = 18,
        eCSSProperty_display = 19,
        eCSSProperty_dominant_baseline = 20,
        eCSSProperty_empty_cells = 21,
        eCSSProperty_flex_direction = 22,
        eCSSProperty_flex_wrap = 23,
        eCSSProperty_float = 24,
        eCSSProperty_font_kerning = 25,
        eCSSProperty_font_optical_sizing = 26,
        eCSSProperty_font_size_adjust = 27,
        eCSSProperty_font_stretch = 28,
        eCSSProperty_font_style = 29,
        eCSSProperty_font_synthesis = 30,
        eCSSProperty_font_variant_caps = 31,
        eCSSProperty_font_variant_east_asian = 32,
        eCSSProperty_font_variant_ligatures = 33,
        eCSSProperty_font_variant_numeric = 34,
        eCSSProperty_font_variant_position = 35,
        eCSSProperty_font_weight = 36,
        eCSSProperty_grid_auto_flow = 37,
        eCSSProperty_hyphens = 38,
        eCSSProperty_image_orientation = 39,
        eCSSProperty_image_rendering = 40,
        eCSSProperty_ime_mode = 41,
        eCSSProperty_initial_letter = 42,
        eCSSProperty_isolation = 43,
        eCSSProperty_justify_content = 44,
        eCSSProperty_justify_items = 45,
        eCSSProperty_justify_self = 46,
        eCSSProperty_list_style_position = 47,
        eCSSProperty_mask_type = 48,
        eCSSProperty_mix_blend_mode = 49,
        eCSSProperty__moz_appearance = 50,
        eCSSProperty__moz_box_align = 51,
        eCSSProperty__moz_box_direction = 52,
        eCSSProperty__moz_box_orient = 53,
        eCSSProperty__moz_box_pack = 54,
        eCSSProperty__moz_control_character_visibility = 55,
        eCSSProperty__moz_float_edge = 56,
        eCSSProperty__moz_force_broken_image_icon = 57,
        eCSSProperty__moz_list_reversed = 58,
        eCSSProperty__moz_math_display = 59,
        eCSSProperty__moz_math_variant = 60,
        eCSSProperty__moz_min_font_size_ratio = 61,
        eCSSProperty__moz_orient = 62,
        eCSSProperty__moz_osx_font_smoothing = 63,
        eCSSProperty__moz_script_level = 64,
        eCSSProperty__moz_script_min_size = 65,
        eCSSProperty__moz_script_size_multiplier = 66,
        eCSSProperty__moz_stack_sizing = 67,
        eCSSProperty__moz_text_size_adjust = 68,
        eCSSProperty__moz_top_layer = 69,
        eCSSProperty__moz_user_focus = 70,
        eCSSProperty__moz_user_input = 71,
        eCSSProperty__moz_user_modify = 72,
        eCSSProperty__moz_user_select = 73,
        eCSSProperty__moz_window_dragging = 74,
        eCSSProperty__moz_window_shadow = 75,
        eCSSProperty_object_fit = 76,
        eCSSProperty_outline_style = 77,
        eCSSProperty_overflow_anchor = 78,
        eCSSProperty_overflow_wrap = 79,
        eCSSProperty_paint_order = 80,
        eCSSProperty_pointer_events = 81,
        eCSSProperty_position = 82,
        eCSSProperty_resize = 83,
        eCSSProperty_ruby_align = 84,
        eCSSProperty_ruby_position = 85,
        eCSSProperty_scroll_behavior = 86,
        eCSSProperty_scroll_snap_align = 87,
        eCSSProperty_scroll_snap_type = 88,
        eCSSProperty_scrollbar_width = 89,
        eCSSProperty_shape_rendering = 90,
        eCSSProperty_stroke_linecap = 91,
        eCSSProperty_stroke_linejoin = 92,
        eCSSProperty_table_layout = 93,
        eCSSProperty_text_align = 94,
        eCSSProperty_text_align_last = 95,
        eCSSProperty_text_anchor = 96,
        eCSSProperty_text_combine_upright = 97,
        eCSSProperty_text_decoration_line = 98,
        eCSSProperty_text_decoration_style = 99,
        eCSSProperty_text_emphasis_position = 100,
        eCSSProperty_text_justify = 101,
        eCSSProperty_text_orientation = 102,
        eCSSProperty_text_rendering = 103,
        eCSSProperty_text_transform = 104,
        eCSSProperty_touch_action = 105,
        eCSSProperty_transform_box = 106,
        eCSSProperty_transform_style = 107,
        eCSSProperty_unicode_bidi = 108,
        eCSSProperty_vector_effect = 109,
        eCSSProperty_visibility = 110,
        eCSSProperty__webkit_line_clamp = 111,
        eCSSProperty_white_space = 112,
        eCSSProperty_word_break = 113,
        eCSSProperty_writing_mode = 114,
        eCSSProperty__x_span = 115,
        eCSSProperty__x_text_zoom = 116,
        eCSSProperty_z_index = 117,
        eCSSProperty_break_after = 118,
        eCSSProperty_break_before = 119,
        eCSSProperty_clip_rule = 120,
        eCSSProperty_fill_rule = 121,
        eCSSProperty__moz_box_ordinal_group = 122,
        eCSSProperty_order = 123,
        eCSSProperty_overflow_x = 124,
        eCSSProperty_overflow_y = 125,
        eCSSProperty_overflow_clip_box_block = 126,
        eCSSProperty_overflow_clip_box_inline = 127,
        eCSSProperty_overscroll_behavior_x = 128,
        eCSSProperty_overscroll_behavior_y = 129,
        eCSSProperty_fill_opacity = 130,
        eCSSProperty_stroke_opacity = 131,
        eCSSProperty_flex_grow = 132,
        eCSSProperty_flex_shrink = 133,
        eCSSProperty__moz_box_flex = 134,
        eCSSProperty_stroke_miterlimit = 135,
        eCSSProperty_flood_opacity = 136,
        eCSSProperty__moz_window_opacity = 137,
        eCSSProperty_opacity = 138,
        eCSSProperty_shape_image_threshold = 139,
        eCSSProperty_stop_opacity = 140,
        eCSSProperty_border_block_end_style = 141,
        eCSSProperty_border_block_start_style = 142,
        eCSSProperty_border_bottom_style = 143,
        eCSSProperty_border_inline_end_style = 144,
        eCSSProperty_border_inline_start_style = 145,
        eCSSProperty_border_left_style = 146,
        eCSSProperty_border_right_style = 147,
        eCSSProperty_border_top_style = 148,
        eCSSProperty_column_rule_style = 149,
        eCSSProperty_animation_delay = 150,
        eCSSProperty_animation_direction = 151,
        eCSSProperty_animation_duration = 152,
        eCSSProperty_animation_fill_mode = 153,
        eCSSProperty_animation_iteration_count = 154,
        eCSSProperty_animation_name = 155,
        eCSSProperty_animation_play_state = 156,
        eCSSProperty_animation_timing_function = 157,
        eCSSProperty_background_attachment = 158,
        eCSSProperty_background_blend_mode = 159,
        eCSSProperty_background_clip = 160,
        eCSSProperty_background_image = 161,
        eCSSProperty_background_origin = 162,
        eCSSProperty_background_position_x = 163,
        eCSSProperty_background_position_y = 164,
        eCSSProperty_background_repeat = 165,
        eCSSProperty_background_size = 166,
        eCSSProperty_border_image_outset = 167,
        eCSSProperty_border_image_slice = 168,
        eCSSProperty_border_image_source = 169,
        eCSSProperty_border_image_width = 170,
        eCSSProperty_border_spacing = 171,
        eCSSProperty_box_shadow = 172,
        eCSSProperty_caret_color = 173,
        eCSSProperty_clip_path = 174,
        eCSSProperty_color = 175,
        eCSSProperty_column_width = 176,
        eCSSProperty_content = 177,
        eCSSProperty_counter_increment = 178,
        eCSSProperty_cursor = 179,
        eCSSProperty_filter = 180,
        eCSSProperty_flex_basis = 181,
        eCSSProperty_font_family = 182,
        eCSSProperty_font_feature_settings = 183,
        eCSSProperty_font_language_override = 184,
        eCSSProperty_font_size = 185,
        eCSSProperty_font_variant_alternates = 186,
        eCSSProperty_font_variation_settings = 187,
        eCSSProperty_grid_template_areas = 188,
        eCSSProperty_letter_spacing = 189,
        eCSSProperty_line_height = 190,
        eCSSProperty_list_style_image = 191,
        eCSSProperty_list_style_type = 192,
        eCSSProperty_mask_clip = 193,
        eCSSProperty_mask_composite = 194,
        eCSSProperty_mask_image = 195,
        eCSSProperty_mask_mode = 196,
        eCSSProperty_mask_origin = 197,
        eCSSProperty_mask_position_x = 198,
        eCSSProperty_mask_position_y = 199,
        eCSSProperty_mask_repeat = 200,
        eCSSProperty_mask_size = 201,
        eCSSProperty__moz_context_properties = 202,
        eCSSProperty__moz_font_smoothing_background_color = 203,
        eCSSProperty__moz_tab_size = 204,
        eCSSProperty_offset_path = 205,
        eCSSProperty_perspective = 206,
        eCSSProperty_quotes = 207,
        eCSSProperty_rotate = 208,
        eCSSProperty_scale = 209,
        eCSSProperty_scroll_snap_coordinate = 210,
        eCSSProperty_scrollbar_color = 211,
        eCSSProperty_shape_outside = 212,
        eCSSProperty_stroke_dasharray = 213,
        eCSSProperty_stroke_dashoffset = 214,
        eCSSProperty_stroke_width = 215,
        eCSSProperty_text_emphasis_style = 216,
        eCSSProperty_text_indent = 217,
        eCSSProperty_text_overflow = 218,
        eCSSProperty_text_shadow = 219,
        eCSSProperty_transition_delay = 220,
        eCSSProperty_transition_duration = 221,
        eCSSProperty_transition_property = 222,
        eCSSProperty_transition_timing_function = 223,
        eCSSProperty_translate = 224,
        eCSSProperty_vertical_align = 225,
        eCSSProperty_will_change = 226,
        eCSSProperty_word_spacing = 227,
        eCSSProperty__x_lang = 228,
        eCSSProperty_clip = 229,
        eCSSProperty__moz_image_region = 230,
        eCSSProperty_grid_template_columns = 231,
        eCSSProperty_grid_template_rows = 232,
        eCSSProperty_fill = 233,
        eCSSProperty_stroke = 234,
        eCSSProperty_grid_auto_columns = 235,
        eCSSProperty_grid_auto_rows = 236,
        eCSSProperty__moz_window_transform_origin = 237,
        eCSSProperty_transform_origin = 238,
        eCSSProperty_counter_reset = 239,
        eCSSProperty_counter_set = 240,
        eCSSProperty_scroll_snap_points_x = 241,
        eCSSProperty_scroll_snap_points_y = 242,
        eCSSProperty__moz_window_transform = 243,
        eCSSProperty_transform = 244,
        eCSSProperty_column_gap = 245,
        eCSSProperty_row_gap = 246,
        eCSSProperty_object_position = 247,
        eCSSProperty_perspective_origin = 248,
        eCSSProperty_scroll_snap_destination = 249,
        eCSSProperty_grid_column_end = 250,
        eCSSProperty_grid_column_start = 251,
        eCSSProperty_grid_row_end = 252,
        eCSSProperty_grid_row_start = 253,
        eCSSProperty_max_block_size = 254,
        eCSSProperty_max_height = 255,
        eCSSProperty_max_inline_size = 256,
        eCSSProperty_max_width = 257,
        eCSSProperty_marker_end = 258,
        eCSSProperty_marker_mid = 259,
        eCSSProperty_marker_start = 260,
        eCSSProperty__moz_binding = 261,
        eCSSProperty_scroll_padding_block_end = 262,
        eCSSProperty_scroll_padding_block_start = 263,
        eCSSProperty_scroll_padding_bottom = 264,
        eCSSProperty_scroll_padding_inline_end = 265,
        eCSSProperty_scroll_padding_inline_start = 266,
        eCSSProperty_scroll_padding_left = 267,
        eCSSProperty_scroll_padding_right = 268,
        eCSSProperty_scroll_padding_top = 269,
        eCSSProperty_block_size = 270,
        eCSSProperty_height = 271,
        eCSSProperty_inline_size = 272,
        eCSSProperty_min_block_size = 273,
        eCSSProperty_min_height = 274,
        eCSSProperty_min_inline_size = 275,
        eCSSProperty_min_width = 276,
        eCSSProperty_width = 277,
        eCSSProperty_outline_offset = 278,
        eCSSProperty_scroll_margin_block_end = 279,
        eCSSProperty_scroll_margin_block_start = 280,
        eCSSProperty_scroll_margin_bottom = 281,
        eCSSProperty_scroll_margin_inline_end = 282,
        eCSSProperty_scroll_margin_inline_start = 283,
        eCSSProperty_scroll_margin_left = 284,
        eCSSProperty_scroll_margin_right = 285,
        eCSSProperty_scroll_margin_top = 286,
        eCSSProperty_padding_block_end = 287,
        eCSSProperty_padding_block_start = 288,
        eCSSProperty_padding_bottom = 289,
        eCSSProperty_padding_inline_end = 290,
        eCSSProperty_padding_inline_start = 291,
        eCSSProperty_padding_left = 292,
        eCSSProperty_padding_right = 293,
        eCSSProperty_padding_top = 294,
        eCSSProperty_shape_margin = 295,
        eCSSProperty_border_block_end_width = 296,
        eCSSProperty_border_block_start_width = 297,
        eCSSProperty_border_bottom_width = 298,
        eCSSProperty_border_inline_end_width = 299,
        eCSSProperty_border_inline_start_width = 300,
        eCSSProperty_border_left_width = 301,
        eCSSProperty_border_right_width = 302,
        eCSSProperty_border_top_width = 303,
        eCSSProperty_column_rule_width = 304,
        eCSSProperty_outline_width = 305,
        eCSSProperty__webkit_text_stroke_width = 306,
        eCSSProperty_border_bottom_left_radius = 307,
        eCSSProperty_border_bottom_right_radius = 308,
        eCSSProperty_border_end_end_radius = 309,
        eCSSProperty_border_end_start_radius = 310,
        eCSSProperty_border_start_end_radius = 311,
        eCSSProperty_border_start_start_radius = 312,
        eCSSProperty_border_top_left_radius = 313,
        eCSSProperty_border_top_right_radius = 314,
        eCSSProperty__moz_outline_radius_bottomleft = 315,
        eCSSProperty__moz_outline_radius_bottomright = 316,
        eCSSProperty__moz_outline_radius_topleft = 317,
        eCSSProperty__moz_outline_radius_topright = 318,
        eCSSProperty_bottom = 319,
        eCSSProperty_inset_block_end = 320,
        eCSSProperty_inset_block_start = 321,
        eCSSProperty_inset_inline_end = 322,
        eCSSProperty_inset_inline_start = 323,
        eCSSProperty_left = 324,
        eCSSProperty_margin_block_end = 325,
        eCSSProperty_margin_block_start = 326,
        eCSSProperty_margin_bottom = 327,
        eCSSProperty_margin_inline_end = 328,
        eCSSProperty_margin_inline_start = 329,
        eCSSProperty_margin_left = 330,
        eCSSProperty_margin_right = 331,
        eCSSProperty_margin_top = 332,
        eCSSProperty_right = 333,
        eCSSProperty_top = 334,
        eCSSProperty_background_color = 335,
        eCSSProperty_border_block_end_color = 336,
        eCSSProperty_border_block_start_color = 337,
        eCSSProperty_border_bottom_color = 338,
        eCSSProperty_border_inline_end_color = 339,
        eCSSProperty_border_inline_start_color = 340,
        eCSSProperty_border_left_color = 341,
        eCSSProperty_border_right_color = 342,
        eCSSProperty_border_top_color = 343,
        eCSSProperty_column_rule_color = 344,
        eCSSProperty_flood_color = 345,
        eCSSProperty_lighting_color = 346,
        eCSSProperty_outline_color = 347,
        eCSSProperty_stop_color = 348,
        eCSSProperty_text_decoration_color = 349,
        eCSSProperty_text_emphasis_color = 350,
        eCSSProperty__webkit_text_fill_color = 351,
        eCSSProperty__webkit_text_stroke_color = 352,
        eCSSProperty_background = 353,
        eCSSProperty_background_position = 354,
        eCSSProperty_border_color = 355,
        eCSSProperty_border_style = 356,
        eCSSProperty_border_width = 357,
        eCSSProperty_border_top = 358,
        eCSSProperty_border_right = 359,
        eCSSProperty_border_bottom = 360,
        eCSSProperty_border_left = 361,
        eCSSProperty_border_block_start = 362,
        eCSSProperty_border_block_end = 363,
        eCSSProperty_border_inline_start = 364,
        eCSSProperty_border_inline_end = 365,
        eCSSProperty_border = 366,
        eCSSProperty_border_radius = 367,
        eCSSProperty_border_image = 368,
        eCSSProperty_border_block_width = 369,
        eCSSProperty_border_block_style = 370,
        eCSSProperty_border_block_color = 371,
        eCSSProperty_border_inline_width = 372,
        eCSSProperty_border_inline_style = 373,
        eCSSProperty_border_inline_color = 374,
        eCSSProperty_border_block = 375,
        eCSSProperty_border_inline = 376,
        eCSSProperty_overflow = 377,
        eCSSProperty_overflow_clip_box = 378,
        eCSSProperty_transition = 379,
        eCSSProperty_animation = 380,
        eCSSProperty_overscroll_behavior = 381,
        eCSSProperty_page_break_before = 382,
        eCSSProperty_page_break_after = 383,
        eCSSProperty_columns = 384,
        eCSSProperty_column_rule = 385,
        eCSSProperty_font = 386,
        eCSSProperty_font_variant = 387,
        eCSSProperty_text_emphasis = 388,
        eCSSProperty__webkit_text_stroke = 389,
        eCSSProperty_marker = 390,
        eCSSProperty_list_style = 391,
        eCSSProperty_margin = 392,
        eCSSProperty_margin_block = 393,
        eCSSProperty_margin_inline = 394,
        eCSSProperty_scroll_margin = 395,
        eCSSProperty_scroll_margin_block = 396,
        eCSSProperty_scroll_margin_inline = 397,
        eCSSProperty_outline = 398,
        eCSSProperty__moz_outline_radius = 399,
        eCSSProperty_padding = 400,
        eCSSProperty_padding_block = 401,
        eCSSProperty_padding_inline = 402,
        eCSSProperty_scroll_padding = 403,
        eCSSProperty_scroll_padding_block = 404,
        eCSSProperty_scroll_padding_inline = 405,
        eCSSProperty_flex_flow = 406,
        eCSSProperty_flex = 407,
        eCSSProperty_gap = 408,
        eCSSProperty_grid_row = 409,
        eCSSProperty_grid_column = 410,
        eCSSProperty_grid_area = 411,
        eCSSProperty_grid_template = 412,
        eCSSProperty_grid = 413,
        eCSSProperty_place_content = 414,
        eCSSProperty_place_self = 415,
        eCSSProperty_place_items = 416,
        eCSSProperty_inset = 417,
        eCSSProperty_inset_block = 418,
        eCSSProperty_inset_inline = 419,
        eCSSProperty_text_decoration = 420,
        eCSSProperty_mask = 421,
        eCSSProperty_mask_position = 422,
        eCSSProperty_all = 423,
        eCSSPropertyAlias__webkit_background_clip = 424,
        eCSSPropertyAlias__webkit_background_origin = 425,
        eCSSPropertyAlias__webkit_background_size = 426,
        eCSSPropertyAlias__moz_border_start_color = 427,
        eCSSPropertyAlias__moz_border_start_style = 428,
        eCSSPropertyAlias__moz_border_start_width = 429,
        eCSSPropertyAlias__moz_border_end_color = 430,
        eCSSPropertyAlias__moz_border_end_style = 431,
        eCSSPropertyAlias__moz_border_end_width = 432,
        eCSSPropertyAlias__webkit_border_top_left_radius = 433,
        eCSSPropertyAlias__webkit_border_top_right_radius = 434,
        eCSSPropertyAlias__webkit_border_bottom_right_radius = 435,
        eCSSPropertyAlias__webkit_border_bottom_left_radius = 436,
        eCSSPropertyAlias__moz_transition_duration = 437,
        eCSSPropertyAlias__webkit_transition_duration = 438,
        eCSSPropertyAlias__moz_transition_timing_function = 439,
        eCSSPropertyAlias__webkit_transition_timing_function = 440,
        eCSSPropertyAlias__moz_transition_property = 441,
        eCSSPropertyAlias__webkit_transition_property = 442,
        eCSSPropertyAlias__moz_transition_delay = 443,
        eCSSPropertyAlias__webkit_transition_delay = 444,
        eCSSPropertyAlias__moz_animation_name = 445,
        eCSSPropertyAlias__webkit_animation_name = 446,
        eCSSPropertyAlias__moz_animation_duration = 447,
        eCSSPropertyAlias__webkit_animation_duration = 448,
        eCSSPropertyAlias__moz_animation_timing_function = 449,
        eCSSPropertyAlias__webkit_animation_timing_function = 450,
        eCSSPropertyAlias__moz_animation_iteration_count = 451,
        eCSSPropertyAlias__webkit_animation_iteration_count = 452,
        eCSSPropertyAlias__moz_animation_direction = 453,
        eCSSPropertyAlias__webkit_animation_direction = 454,
        eCSSPropertyAlias__moz_animation_play_state = 455,
        eCSSPropertyAlias__webkit_animation_play_state = 456,
        eCSSPropertyAlias__moz_animation_fill_mode = 457,
        eCSSPropertyAlias__webkit_animation_fill_mode = 458,
        eCSSPropertyAlias__moz_animation_delay = 459,
        eCSSPropertyAlias__webkit_animation_delay = 460,
        eCSSPropertyAlias__moz_transform = 461,
        eCSSPropertyAlias__webkit_transform = 462,
        eCSSPropertyAlias_page_break_inside = 463,
        eCSSPropertyAlias__moz_perspective = 464,
        eCSSPropertyAlias__webkit_perspective = 465,
        eCSSPropertyAlias__moz_perspective_origin = 466,
        eCSSPropertyAlias__webkit_perspective_origin = 467,
        eCSSPropertyAlias__moz_backface_visibility = 468,
        eCSSPropertyAlias__webkit_backface_visibility = 469,
        eCSSPropertyAlias__moz_transform_style = 470,
        eCSSPropertyAlias__webkit_transform_style = 471,
        eCSSPropertyAlias__moz_transform_origin = 472,
        eCSSPropertyAlias__webkit_transform_origin = 473,
        eCSSPropertyAlias__webkit_appearance = 474,
        eCSSPropertyAlias__moz_column_width = 475,
        eCSSPropertyAlias__moz_column_count = 476,
        eCSSPropertyAlias__moz_column_fill = 477,
        eCSSPropertyAlias__moz_column_rule_width = 478,
        eCSSPropertyAlias__moz_column_rule_color = 479,
        eCSSPropertyAlias__moz_column_span = 480,
        eCSSPropertyAlias__moz_column_rule_style = 481,
        eCSSPropertyAlias__webkit_box_shadow = 482,
        eCSSPropertyAlias__webkit_filter = 483,
        eCSSPropertyAlias__moz_font_feature_settings = 484,
        eCSSPropertyAlias__moz_font_language_override = 485,
        eCSSPropertyAlias__moz_hyphens = 486,
        eCSSPropertyAlias__webkit_text_size_adjust = 487,
        eCSSPropertyAlias_word_wrap = 488,
        eCSSPropertyAlias__moz_margin_start = 489,
        eCSSPropertyAlias__moz_margin_end = 490,
        eCSSPropertyAlias__moz_padding_start = 491,
        eCSSPropertyAlias__moz_padding_end = 492,
        eCSSPropertyAlias_offset_block_start = 493,
        eCSSPropertyAlias_offset_block_end = 494,
        eCSSPropertyAlias_offset_inline_start = 495,
        eCSSPropertyAlias_offset_inline_end = 496,
        eCSSPropertyAlias__webkit_flex_direction = 497,
        eCSSPropertyAlias__webkit_flex_wrap = 498,
        eCSSPropertyAlias__webkit_justify_content = 499,
        eCSSPropertyAlias__webkit_align_content = 500,
        eCSSPropertyAlias__webkit_align_items = 501,
        eCSSPropertyAlias__webkit_flex_grow = 502,
        eCSSPropertyAlias__webkit_flex_shrink = 503,
        eCSSPropertyAlias__webkit_align_self = 504,
        eCSSPropertyAlias__webkit_order = 505,
        eCSSPropertyAlias__webkit_flex_basis = 506,
        eCSSPropertyAlias__moz_box_sizing = 507,
        eCSSPropertyAlias__webkit_box_sizing = 508,
        eCSSPropertyAlias_grid_column_gap = 509,
        eCSSPropertyAlias__moz_column_gap = 510,
        eCSSPropertyAlias_grid_row_gap = 511,
        eCSSPropertyAlias__webkit_user_select = 512,
        eCSSPropertyAlias__webkit_mask_repeat = 513,
        eCSSPropertyAlias__webkit_mask_position_x = 514,
        eCSSPropertyAlias__webkit_mask_position_y = 515,
        eCSSPropertyAlias__webkit_mask_clip = 516,
        eCSSPropertyAlias__webkit_mask_origin = 517,
        eCSSPropertyAlias__webkit_mask_size = 518,
        eCSSPropertyAlias__webkit_mask_composite = 519,
        eCSSPropertyAlias__webkit_mask_image = 520,
        eCSSPropertyAlias__webkit_box_align = 521,
        eCSSPropertyAlias__webkit_box_direction = 522,
        eCSSPropertyAlias__webkit_box_flex = 523,
        eCSSPropertyAlias__webkit_box_orient = 524,
        eCSSPropertyAlias__webkit_box_pack = 525,
        eCSSPropertyAlias__webkit_box_ordinal_group = 526,
        eCSSPropertyAlias__moz_border_start = 527,
        eCSSPropertyAlias__moz_border_end = 528,
        eCSSPropertyAlias__webkit_border_radius = 529,
        eCSSPropertyAlias__moz_border_image = 530,
        eCSSPropertyAlias__webkit_border_image = 531,
        eCSSPropertyAlias__moz_transition = 532,
        eCSSPropertyAlias__webkit_transition = 533,
        eCSSPropertyAlias__moz_animation = 534,
        eCSSPropertyAlias__webkit_animation = 535,
        eCSSPropertyAlias__moz_columns = 536,
        eCSSPropertyAlias__moz_column_rule = 537,
        eCSSPropertyAlias__webkit_flex_flow = 538,
        eCSSPropertyAlias__webkit_flex = 539,
        eCSSPropertyAlias_grid_gap = 540,
        eCSSPropertyAlias__webkit_mask = 541,
        eCSSPropertyAlias__webkit_mask_position = 542,
        eCSSPropertyExtra_no_properties = 543,
        eCSSPropertyExtra_all_properties = 544,
        eCSSPropertyExtra_variable = 545,
    }
    #[repr(i32)]
    #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
    pub enum nsCSSFontDesc {
        eCSSFontDesc_UNKNOWN = -1,
        eCSSFontDesc_Family = 0,
        eCSSFontDesc_Style = 1,
        eCSSFontDesc_Weight = 2,
        eCSSFontDesc_Stretch = 3,
        eCSSFontDesc_Src = 4,
        eCSSFontDesc_UnicodeRange = 5,
        eCSSFontDesc_FontFeatureSettings = 6,
        eCSSFontDesc_FontVariationSettings = 7,
        eCSSFontDesc_FontLanguageOverride = 8,
        eCSSFontDesc_Display = 9,
        eCSSFontDesc_COUNT = 10,
    }
    #[repr(i32)]
    #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
    pub enum nsCSSCounterDesc {
        eCSSCounterDesc_UNKNOWN = -1,
        eCSSCounterDesc_System = 0,
        eCSSCounterDesc_Symbols = 1,
        eCSSCounterDesc_AdditiveSymbols = 2,
        eCSSCounterDesc_Negative = 3,
        eCSSCounterDesc_Prefix = 4,
        eCSSCounterDesc_Suffix = 5,
        eCSSCounterDesc_Range = 6,
        eCSSCounterDesc_Pad = 7,
        eCSSCounterDesc_Fallback = 8,
        eCSSCounterDesc_SpeakAs = 9,
        eCSSCounterDesc_COUNT = 10,
    }
    #[doc = " An array of objects, similar to AutoTArray<T,1> but which is memmovable. It"]
    #[doc = " always has length >= 1."]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsStyleAutoArray<T> {
        pub mFirstElement: T,
        pub mOtherElements: root::nsTArray<T>,
        pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
    }
    pub const nsStyleAutoArray_WithSingleInitialElement_WITH_SINGLE_INITIAL_ELEMENT:
        root::nsStyleAutoArray_WithSingleInitialElement = 0;
    pub type nsStyleAutoArray_WithSingleInitialElement = i32;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct ServoCssRules {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoStyleSheetContents {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoDeclarationBlock {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoStyleRule {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoImportRule {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoAnimationValue {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoKeyframe {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoKeyframesRule {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoMediaList {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoMediaRule {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoNamespaceRule {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoPageRule {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoSupportsRule {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoMozDocumentRule {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoFontFeatureValuesRule {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoCounterStyleRule {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoCssUrlData {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoQuotes {
        _unused: [u8; 0],
    }
    extern "C" {
        pub fn Servo_CssRules_AddRef(arg1: *const root::ServoCssRules);
    }
    extern "C" {
        pub fn Servo_CssRules_Release(arg1: *const root::ServoCssRules);
    }
    extern "C" {
        pub fn Servo_StyleSheetContents_AddRef(arg1: *const root::RawServoStyleSheetContents);
    }
    extern "C" {
        pub fn Servo_StyleSheetContents_Release(arg1: *const root::RawServoStyleSheetContents);
    }
    extern "C" {
        pub fn Servo_DeclarationBlock_AddRef(arg1: *const root::RawServoDeclarationBlock);
    }
    extern "C" {
        pub fn Servo_DeclarationBlock_Release(arg1: *const root::RawServoDeclarationBlock);
    }
    extern "C" {
        pub fn Servo_StyleRule_AddRef(arg1: *const root::RawServoStyleRule);
    }
    extern "C" {
        pub fn Servo_StyleRule_Release(arg1: *const root::RawServoStyleRule);
    }
    extern "C" {
        pub fn Servo_ImportRule_AddRef(arg1: *const root::RawServoImportRule);
    }
    extern "C" {
        pub fn Servo_ImportRule_Release(arg1: *const root::RawServoImportRule);
    }
    extern "C" {
        pub fn Servo_AnimationValue_AddRef(arg1: *const root::RawServoAnimationValue);
    }
    extern "C" {
        pub fn Servo_AnimationValue_Release(arg1: *const root::RawServoAnimationValue);
    }
    extern "C" {
        pub fn Servo_Keyframe_AddRef(arg1: *const root::RawServoKeyframe);
    }
    extern "C" {
        pub fn Servo_Keyframe_Release(arg1: *const root::RawServoKeyframe);
    }
    extern "C" {
        pub fn Servo_KeyframesRule_AddRef(arg1: *const root::RawServoKeyframesRule);
    }
    extern "C" {
        pub fn Servo_KeyframesRule_Release(arg1: *const root::RawServoKeyframesRule);
    }
    extern "C" {
        pub fn Servo_MediaList_AddRef(arg1: *const root::RawServoMediaList);
    }
    extern "C" {
        pub fn Servo_MediaList_Release(arg1: *const root::RawServoMediaList);
    }
    extern "C" {
        pub fn Servo_MediaRule_AddRef(arg1: *const root::RawServoMediaRule);
    }
    extern "C" {
        pub fn Servo_MediaRule_Release(arg1: *const root::RawServoMediaRule);
    }
    extern "C" {
        pub fn Servo_NamespaceRule_AddRef(arg1: *const root::RawServoNamespaceRule);
    }
    extern "C" {
        pub fn Servo_NamespaceRule_Release(arg1: *const root::RawServoNamespaceRule);
    }
    extern "C" {
        pub fn Servo_PageRule_AddRef(arg1: *const root::RawServoPageRule);
    }
    extern "C" {
        pub fn Servo_PageRule_Release(arg1: *const root::RawServoPageRule);
    }
    extern "C" {
        pub fn Servo_SupportsRule_AddRef(arg1: *const root::RawServoSupportsRule);
    }
    extern "C" {
        pub fn Servo_SupportsRule_Release(arg1: *const root::RawServoSupportsRule);
    }
    extern "C" {
        pub fn Servo_DocumentRule_AddRef(arg1: *const root::RawServoMozDocumentRule);
    }
    extern "C" {
        pub fn Servo_DocumentRule_Release(arg1: *const root::RawServoMozDocumentRule);
    }
    extern "C" {
        pub fn Servo_FontFeatureValuesRule_AddRef(arg1: *const root::RawServoFontFeatureValuesRule);
    }
    extern "C" {
        pub fn Servo_FontFeatureValuesRule_Release(
            arg1: *const root::RawServoFontFeatureValuesRule,
        );
    }
    extern "C" {
        pub fn Servo_FontFaceRule_AddRef(arg1: *const root::RawServoFontFaceRule);
    }
    extern "C" {
        pub fn Servo_FontFaceRule_Release(arg1: *const root::RawServoFontFaceRule);
    }
    extern "C" {
        pub fn Servo_CounterStyleRule_AddRef(arg1: *const root::RawServoCounterStyleRule);
    }
    extern "C" {
        pub fn Servo_CounterStyleRule_Release(arg1: *const root::RawServoCounterStyleRule);
    }
    extern "C" {
        pub fn Servo_CssUrlData_AddRef(arg1: *const root::RawServoCssUrlData);
    }
    extern "C" {
        pub fn Servo_CssUrlData_Release(arg1: *const root::RawServoCssUrlData);
    }
    extern "C" {
        pub fn Servo_Quotes_AddRef(arg1: *const root::RawServoQuotes);
    }
    extern "C" {
        pub fn Servo_Quotes_Release(arg1: *const root::RawServoQuotes);
    }
    extern "C" {
        pub fn Servo_ComputedStyle_AddRef(arg1: *const root::mozilla::ComputedStyle);
    }
    extern "C" {
        pub fn Servo_ComputedStyle_Release(arg1: *const root::mozilla::ComputedStyle);
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoStyleSet {
        _unused: [u8; 0],
    }
    extern "C" {
        pub fn Servo_StyleSet_Drop(arg1: *mut root::RawServoStyleSet);
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoAuthorStyles {
        _unused: [u8; 0],
    }
    extern "C" {
        pub fn Servo_AuthorStyles_Drop(arg1: *mut root::RawServoAuthorStyles);
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoSelectorList {
        _unused: [u8; 0],
    }
    extern "C" {
        pub fn Servo_SelectorList_Drop(arg1: *mut root::RawServoSelectorList);
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoSharedMemoryBuilder {
        _unused: [u8; 0],
    }
    extern "C" {
        pub fn Servo_SharedMemoryBuilder_Drop(arg1: *mut root::RawServoSharedMemoryBuilder);
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoSourceSizeList {
        _unused: [u8; 0],
    }
    extern "C" {
        pub fn Servo_SourceSizeList_Drop(arg1: *mut root::RawServoSourceSizeList);
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct StyleUseCounters {
        _unused: [u8; 0],
    }
    extern "C" {
        pub fn Servo_UseCounters_Drop(arg1: *mut root::StyleUseCounters);
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoAnimationValueTable {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RawServoAnimationValueMap {
        _unused: [u8; 0],
    }
    #[repr(u32)]
    #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
    pub enum nsCompatibility {
        eCompatibility_FullStandards = 1,
        eCompatibility_AlmostStandards = 2,
        eCompatibility_NavQuirks = 3,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsSimpleContentList {
        _unused: [u8; 0],
    }
    pub type gfxFontVariation = root::mozilla::gfx::FontVariation;
    pub mod nsStyleTransformMatrix {
        #[allow(unused_imports)]
        use self::super::super::root;
        #[repr(u8)]
        #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
        pub enum MatrixTransformOperator {
            Interpolate = 0,
            Accumulate = 1,
        }
    }
    #[doc = " New rules of reflow:"]
    #[doc = " 1. you get a WillReflow() followed by a Reflow() followed by a DidReflow() in"]
    #[doc = "    order (no separate pass over the tree)"]
    #[doc = " 2. it\'s the parent frame\'s responsibility to size/position the child\'s view"]
    #[doc = "    (not the child frame\'s responsibility as it is today) during reflow (and"]
    #[doc = "    before sending the DidReflow() notification)"]
    #[doc = " 3. positioning of child frames (and their views) is done on the way down the"]
    #[doc = "    tree, and sizing of child frames (and their views) on the way back up"]
    #[doc = " 4. if you move a frame (outside of the reflow process, or after reflowing"]
    #[doc = "    it), then you must make sure that its view (or its child frame\'s views)"]
    #[doc = "    are re-positioned as well. It\'s reasonable to not position the view until"]
    #[doc = "    after all reflowing the entire line, for example, but the frame should"]
    #[doc = "    still be positioned and sized (and the view sized) during the reflow"]
    #[doc = "    (i.e., before sending the DidReflow() notification)"]
    #[doc = " 5. the view system handles moving of widgets, i.e., it\'s not our problem"]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsAtom {
        pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 4usize], u32>,
        pub mHash: u32,
    }
    pub type nsAtom_HasThreadSafeRefCnt = root::mozilla::TrueType;
    #[test]
    fn bindgen_test_layout_nsAtom() {
        assert_eq!(
            ::std::mem::size_of::<nsAtom>(),
            8usize,
            concat!("Size of: ", stringify!(nsAtom))
        );
        assert_eq!(
            ::std::mem::align_of::<nsAtom>(),
            4usize,
            concat!("Alignment of ", stringify!(nsAtom))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsAtom>())).mHash as *const _ as usize },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsAtom),
                "::",
                stringify!(mHash)
            )
        );
    }
    impl nsAtom {
        #[inline]
        pub fn mLength(&self) -> u32 {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 30u8) as u32) }
        }
        #[inline]
        pub fn set_mLength(&mut self, val: u32) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(0usize, 30u8, val as u64)
            }
        }
        #[inline]
        pub fn mIsStatic(&self) -> u32 {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(30usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mIsStatic(&mut self, val: u32) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(30usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mIsAsciiLowercase(&self) -> u32 {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(31usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mIsAsciiLowercase(&mut self, val: u32) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(31usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn new_bitfield_1(
            mLength: u32,
            mIsStatic: u32,
            mIsAsciiLowercase: u32,
        ) -> root::__BindgenBitfieldUnit<[u8; 4usize], u32> {
            let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 4usize], u32> =
                Default::default();
            __bindgen_bitfield_unit.set(0usize, 30u8, {
                let mLength: u32 = unsafe { ::std::mem::transmute(mLength) };
                mLength as u64
            });
            __bindgen_bitfield_unit.set(30usize, 1u8, {
                let mIsStatic: u32 = unsafe { ::std::mem::transmute(mIsStatic) };
                mIsStatic as u64
            });
            __bindgen_bitfield_unit.set(31usize, 1u8, {
                let mIsAsciiLowercase: u32 = unsafe { ::std::mem::transmute(mIsAsciiLowercase) };
                mIsAsciiLowercase as u64
            });
            __bindgen_bitfield_unit
        }
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsStaticAtom {
        pub _base: root::nsAtom,
        pub mStringOffset: u32,
    }
    #[test]
    fn bindgen_test_layout_nsStaticAtom() {
        assert_eq!(
            ::std::mem::size_of::<nsStaticAtom>(),
            12usize,
            concat!("Size of: ", stringify!(nsStaticAtom))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStaticAtom>(),
            4usize,
            concat!("Alignment of ", stringify!(nsStaticAtom))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStaticAtom>())).mStringOffset as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStaticAtom),
                "::",
                stringify!(mStringOffset)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsDynamicAtom {
        pub _base: root::nsAtom,
        pub mRefCnt: root::mozilla::ThreadSafeAutoRefCnt,
    }
    extern "C" {
        #[link_name = "\u{1}_ZN13nsDynamicAtom16gUnusedAtomCountE"]
        pub static mut nsDynamicAtom_gUnusedAtomCount: u32;
    }
    #[test]
    fn bindgen_test_layout_nsDynamicAtom() {
        assert_eq!(
            ::std::mem::size_of::<nsDynamicAtom>(),
            16usize,
            concat!("Size of: ", stringify!(nsDynamicAtom))
        );
        assert_eq!(
            ::std::mem::align_of::<nsDynamicAtom>(),
            8usize,
            concat!("Alignment of ", stringify!(nsDynamicAtom))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsDynamicAtom>())).mRefCnt as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDynamicAtom),
                "::",
                stringify!(mRefCnt)
            )
        );
    }
    #[doc = " a base class for templated hashtables."]
    #[doc = ""]
    #[doc = " Clients will rarely need to use this class directly. Check the derived"]
    #[doc = " classes first, to see if they will meet your needs."]
    #[doc = ""]
    #[doc = " @param EntryType  the templated entry-type class that is managed by the"]
    #[doc = "   hashtable. <code>EntryType</code> must extend the following declaration,"]
    #[doc = "   and <strong>must not declare any virtual functions or derive from classes"]
    #[doc = "   with virtual functions.</strong>  Any vtable pointer would break the"]
    #[doc = "   PLDHashTable code."]
    #[doc = "<pre>   class EntryType : public PLDHashEntryHdr"]
    #[doc = "   {"]
    #[doc = "   public: or friend nsTHashtable<EntryType>;"]
    #[doc = "     // KeyType is what we use when Get()ing or Put()ing this entry"]
    #[doc = "     // this should either be a simple datatype (uint32_t, nsISupports*) or"]
    #[doc = "     // a const reference (const nsAString&)"]
    #[doc = "     typedef something KeyType;"]
    #[doc = "     // KeyTypePointer is the pointer-version of KeyType, because"]
    #[doc = "     // PLDHashTable.h requires keys to cast to <code>const void*</code>"]
    #[doc = "     typedef const something* KeyTypePointer;"]
    #[doc = ""]
    #[doc = "     EntryType(KeyTypePointer aKey);"]
    #[doc = ""]
    #[doc = "     // A copy or C++11 Move constructor must be defined, even if"]
    #[doc = "     // AllowMemMove() == true, otherwise you will cause link errors."]
    #[doc = "     EntryType(const EntryType& aEnt);  // Either this..."]
    #[doc = "     EntryType(EntryType&& aEnt);       // ...or this"]
    #[doc = ""]
    #[doc = "     // the destructor must be defined... or you will cause link errors!"]
    #[doc = "     ~EntryType();"]
    #[doc = ""]
    #[doc = "     // KeyEquals(): does this entry match this key?"]
    #[doc = "     bool KeyEquals(KeyTypePointer aKey) const;"]
    #[doc = ""]
    #[doc = "     // KeyToPointer(): Convert KeyType to KeyTypePointer"]
    #[doc = "     static KeyTypePointer KeyToPointer(KeyType aKey);"]
    #[doc = ""]
    #[doc = "     // HashKey(): calculate the hash number"]
    #[doc = "     static PLDHashNumber HashKey(KeyTypePointer aKey);"]
    #[doc = ""]
    #[doc = "     // ALLOW_MEMMOVE can we move this class with memmove(), or do we have"]
    #[doc = "     // to use the copy constructor?"]
    #[doc = "     enum { ALLOW_MEMMOVE = true/false };"]
    #[doc = "   }</pre>"]
    #[doc = ""]
    #[doc = " @see nsInterfaceHashtable"]
    #[doc = " @see nsDataHashtable"]
    #[doc = " @see nsClassHashtable"]
    #[doc = " @author \"Benjamin Smedberg <bsmedberg@covad.net>\""]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsTHashtable {
        pub _address: u8,
    }
    pub type nsTHashtable_fallible_t = root::mozilla::fallible_t;
    #[doc = " KeyType is typedef\'ed for ease of use."]
    pub type nsTHashtable_KeyType = [u8; 0usize];
    #[doc = " KeyTypePointer is typedef\'ed for ease of use."]
    pub type nsTHashtable_KeyTypePointer = [u8; 0usize];
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsTHashtable_Iterator {
        pub _base: root::PLDHashTable_Iterator,
    }
    pub type nsTHashtable_Iterator_Base = root::PLDHashTable_Iterator;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct gfxFontFeature {
        pub mTag: u32,
        pub mValue: u32,
    }
    #[test]
    fn bindgen_test_layout_gfxFontFeature() {
        assert_eq!(
            ::std::mem::size_of::<gfxFontFeature>(),
            8usize,
            concat!("Size of: ", stringify!(gfxFontFeature))
        );
        assert_eq!(
            ::std::mem::align_of::<gfxFontFeature>(),
            4usize,
            concat!("Alignment of ", stringify!(gfxFontFeature))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<gfxFontFeature>())).mTag as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(gfxFontFeature),
                "::",
                stringify!(mTag)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<gfxFontFeature>())).mValue as *const _ as usize },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(gfxFontFeature),
                "::",
                stringify!(mValue)
            )
        );
    }
    #[repr(C)]
    pub struct gfxAlternateValue {
        pub alternate: u32,
        pub value: ::gecko_bindings::structs::nsString,
    }
    #[test]
    fn bindgen_test_layout_gfxAlternateValue() {
        assert_eq!(
            ::std::mem::size_of::<gfxAlternateValue>(),
            24usize,
            concat!("Size of: ", stringify!(gfxAlternateValue))
        );
        assert_eq!(
            ::std::mem::align_of::<gfxAlternateValue>(),
            8usize,
            concat!("Alignment of ", stringify!(gfxAlternateValue))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<gfxAlternateValue>())).alternate as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(gfxAlternateValue),
                "::",
                stringify!(alternate)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<gfxAlternateValue>())).value as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(gfxAlternateValue),
                "::",
                stringify!(value)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct gfxFontFeatureValueSet {
        pub mRefCnt: u64,
        pub mFontFeatureValues: [u64; 4usize],
    }
    pub type gfxFontFeatureValueSet_HasThreadSafeRefCnt = root::mozilla::TrueType;
    #[repr(C)]
    pub struct gfxFontFeatureValueSet_ValueList {
        pub name: ::gecko_bindings::structs::nsString,
        pub featureSelectors: root::nsTArray<u32>,
    }
    #[test]
    fn bindgen_test_layout_gfxFontFeatureValueSet_ValueList() {
        assert_eq!(
            ::std::mem::size_of::<gfxFontFeatureValueSet_ValueList>(),
            24usize,
            concat!("Size of: ", stringify!(gfxFontFeatureValueSet_ValueList))
        );
        assert_eq!(
            ::std::mem::align_of::<gfxFontFeatureValueSet_ValueList>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(gfxFontFeatureValueSet_ValueList)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<gfxFontFeatureValueSet_ValueList>())).name as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(gfxFontFeatureValueSet_ValueList),
                "::",
                stringify!(name)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<gfxFontFeatureValueSet_ValueList>())).featureSelectors
                    as *const _ as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(gfxFontFeatureValueSet_ValueList),
                "::",
                stringify!(featureSelectors)
            )
        );
    }
    #[repr(C)]
    pub struct gfxFontFeatureValueSet_FeatureValues {
        pub alternate: u32,
        pub valuelist: root::nsTArray<root::gfxFontFeatureValueSet_ValueList>,
    }
    #[test]
    fn bindgen_test_layout_gfxFontFeatureValueSet_FeatureValues() {
        assert_eq!(
            ::std::mem::size_of::<gfxFontFeatureValueSet_FeatureValues>(),
            16usize,
            concat!(
                "Size of: ",
                stringify!(gfxFontFeatureValueSet_FeatureValues)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<gfxFontFeatureValueSet_FeatureValues>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(gfxFontFeatureValueSet_FeatureValues)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<gfxFontFeatureValueSet_FeatureValues>())).alternate
                    as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(gfxFontFeatureValueSet_FeatureValues),
                "::",
                stringify!(alternate)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<gfxFontFeatureValueSet_FeatureValues>())).valuelist
                    as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(gfxFontFeatureValueSet_FeatureValues),
                "::",
                stringify!(valuelist)
            )
        );
    }
    #[repr(C)]
    pub struct gfxFontFeatureValueSet_FeatureValueHashKey {
        pub mFamily: ::gecko_bindings::structs::nsCString,
        pub mPropVal: u32,
        pub mName: ::gecko_bindings::structs::nsString,
    }
    #[test]
    fn bindgen_test_layout_gfxFontFeatureValueSet_FeatureValueHashKey() {
        assert_eq!(
            ::std::mem::size_of::<gfxFontFeatureValueSet_FeatureValueHashKey>(),
            40usize,
            concat!(
                "Size of: ",
                stringify!(gfxFontFeatureValueSet_FeatureValueHashKey)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<gfxFontFeatureValueSet_FeatureValueHashKey>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(gfxFontFeatureValueSet_FeatureValueHashKey)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<gfxFontFeatureValueSet_FeatureValueHashKey>())).mFamily
                    as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(gfxFontFeatureValueSet_FeatureValueHashKey),
                "::",
                stringify!(mFamily)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<gfxFontFeatureValueSet_FeatureValueHashKey>())).mPropVal
                    as *const _ as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(gfxFontFeatureValueSet_FeatureValueHashKey),
                "::",
                stringify!(mPropVal)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<gfxFontFeatureValueSet_FeatureValueHashKey>())).mName
                    as *const _ as usize
            },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(gfxFontFeatureValueSet_FeatureValueHashKey),
                "::",
                stringify!(mName)
            )
        );
    }
    #[repr(C)]
    pub struct gfxFontFeatureValueSet_FeatureValueHashEntry {
        pub mKey: root::gfxFontFeatureValueSet_FeatureValueHashKey,
        pub mValues: root::nsTArray<u32>,
    }
    pub type gfxFontFeatureValueSet_FeatureValueHashEntry_KeyType =
        *const root::gfxFontFeatureValueSet_FeatureValueHashKey;
    pub type gfxFontFeatureValueSet_FeatureValueHashEntry_KeyTypePointer =
        *const root::gfxFontFeatureValueSet_FeatureValueHashKey;
    pub const gfxFontFeatureValueSet_FeatureValueHashEntry_ALLOW_MEMMOVE:
        root::gfxFontFeatureValueSet_FeatureValueHashEntry__bindgen_ty_1 = 1;
    pub type gfxFontFeatureValueSet_FeatureValueHashEntry__bindgen_ty_1 = u32;
    #[test]
    fn bindgen_test_layout_gfxFontFeatureValueSet_FeatureValueHashEntry() {
        assert_eq!(
            ::std::mem::size_of::<gfxFontFeatureValueSet_FeatureValueHashEntry>(),
            48usize,
            concat!(
                "Size of: ",
                stringify!(gfxFontFeatureValueSet_FeatureValueHashEntry)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<gfxFontFeatureValueSet_FeatureValueHashEntry>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(gfxFontFeatureValueSet_FeatureValueHashEntry)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<gfxFontFeatureValueSet_FeatureValueHashEntry>())).mKey
                    as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(gfxFontFeatureValueSet_FeatureValueHashEntry),
                "::",
                stringify!(mKey)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<gfxFontFeatureValueSet_FeatureValueHashEntry>())).mValues
                    as *const _ as usize
            },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(gfxFontFeatureValueSet_FeatureValueHashEntry),
                "::",
                stringify!(mValues)
            )
        );
    }
    #[test]
    fn bindgen_test_layout_gfxFontFeatureValueSet() {
        assert_eq!(
            ::std::mem::size_of::<gfxFontFeatureValueSet>(),
            40usize,
            concat!("Size of: ", stringify!(gfxFontFeatureValueSet))
        );
        assert_eq!(
            ::std::mem::align_of::<gfxFontFeatureValueSet>(),
            8usize,
            concat!("Alignment of ", stringify!(gfxFontFeatureValueSet))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<gfxFontFeatureValueSet>())).mRefCnt as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(gfxFontFeatureValueSet),
                "::",
                stringify!(mRefCnt)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<gfxFontFeatureValueSet>())).mFontFeatureValues as *const _
                    as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(gfxFontFeatureValueSet),
                "::",
                stringify!(mFontFeatureValues)
            )
        );
    }
    #[repr(C)]
    pub struct nsFont {
        pub fontlist: root::mozilla::FontFamilyList,
        pub fontFeatureSettings: root::nsTArray<root::gfxFontFeature>,
        pub fontVariationSettings: root::nsTArray<root::gfxFontVariation>,
        pub alternateValues: root::nsTArray<root::gfxAlternateValue>,
        pub size: root::nscoord,
        pub sizeAdjust: f32,
        pub fontSmoothingBackgroundColor: root::mozilla::StyleRGBA,
        pub languageOverride: u32,
        pub style: root::nsFont_FontSlantStyle,
        pub weight: root::nsFont_FontWeight,
        pub stretch: root::nsFont_FontStretch,
        pub variantAlternates: u16,
        pub variantLigatures: u16,
        pub variantEastAsian: u16,
        pub variantCaps: u8,
        pub variantNumeric: u8,
        pub variantPosition: u8,
        pub variantWidth: u8,
        pub smoothing: u8,
        pub kerning: u8,
        pub opticalSizing: u8,
        pub synthesis: u8,
        pub systemFont: bool,
    }
    pub type nsFont_FontStretch = root::mozilla::FontStretch;
    pub type nsFont_FontSlantStyle = root::mozilla::FontSlantStyle;
    pub type nsFont_FontWeight = root::mozilla::FontWeight;
    pub const nsFont_MaxDifference_eNone: root::nsFont_MaxDifference = 0;
    pub const nsFont_MaxDifference_eVisual: root::nsFont_MaxDifference = 1;
    pub const nsFont_MaxDifference_eLayoutAffecting: root::nsFont_MaxDifference = 2;
    pub type nsFont_MaxDifference = u8;
    #[test]
    fn bindgen_test_layout_nsFont() {
        assert_eq!(
            ::std::mem::size_of::<nsFont>(),
            80usize,
            concat!("Size of: ", stringify!(nsFont))
        );
        assert_eq!(
            ::std::mem::align_of::<nsFont>(),
            8usize,
            concat!("Alignment of ", stringify!(nsFont))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).fontlist as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(fontlist)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).fontFeatureSettings as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(fontFeatureSettings)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsFont>())).fontVariationSettings as *const _ as usize
            },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(fontVariationSettings)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).alternateValues as *const _ as usize },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(alternateValues)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).size as *const _ as usize },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(size)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).sizeAdjust as *const _ as usize },
            44usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(sizeAdjust)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsFont>())).fontSmoothingBackgroundColor as *const _ as usize
            },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(fontSmoothingBackgroundColor)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).languageOverride as *const _ as usize },
            52usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(languageOverride)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).style as *const _ as usize },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(style)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).weight as *const _ as usize },
            58usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(weight)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).stretch as *const _ as usize },
            60usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(stretch)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).variantAlternates as *const _ as usize },
            62usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(variantAlternates)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).variantLigatures as *const _ as usize },
            64usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(variantLigatures)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).variantEastAsian as *const _ as usize },
            66usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(variantEastAsian)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).variantCaps as *const _ as usize },
            68usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(variantCaps)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).variantNumeric as *const _ as usize },
            69usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(variantNumeric)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).variantPosition as *const _ as usize },
            70usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(variantPosition)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).variantWidth as *const _ as usize },
            71usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(variantWidth)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).smoothing as *const _ as usize },
            72usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(smoothing)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).kerning as *const _ as usize },
            73usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(kerning)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).opticalSizing as *const _ as usize },
            74usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(opticalSizing)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).synthesis as *const _ as usize },
            75usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(synthesis)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFont>())).systemFont as *const _ as usize },
            76usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFont),
                "::",
                stringify!(systemFont)
            )
        );
    }
    impl root::nsStyleUnit {
        pub const eStyleUnit_MAX: root::nsStyleUnit = nsStyleUnit::eStyleUnit_Calc;
    }
    #[repr(u8)]
    #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
    pub enum nsStyleUnit {
        eStyleUnit_Null = 0,
        eStyleUnit_Normal = 1,
        eStyleUnit_Auto = 2,
        eStyleUnit_None = 3,
        eStyleUnit_Percent = 10,
        eStyleUnit_Factor = 11,
        eStyleUnit_Degree = 12,
        eStyleUnit_FlexFraction = 16,
        eStyleUnit_Coord = 20,
        eStyleUnit_Integer = 30,
        eStyleUnit_Enumerated = 32,
        eStyleUnit_Calc = 40,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsStyleUnion {
        pub mInt: root::__BindgenUnionField<i32>,
        pub mFloat: root::__BindgenUnionField<f32>,
        pub mPointer: root::__BindgenUnionField<*mut ::std::os::raw::c_void>,
        pub bindgen_union_field: u64,
    }
    #[test]
    fn bindgen_test_layout_nsStyleUnion() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleUnion>(),
            8usize,
            concat!("Size of: ", stringify!(nsStyleUnion))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleUnion>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleUnion))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleUnion>())).mInt as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUnion),
                "::",
                stringify!(mInt)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleUnion>())).mFloat as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUnion),
                "::",
                stringify!(mFloat)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleUnion>())).mPointer as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUnion),
                "::",
                stringify!(mPointer)
            )
        );
    }
    #[doc = " Class that hold a single size specification used by the style"]
    #[doc = " system.  The size specification consists of two parts -- a number"]
    #[doc = " and a unit.  The number is an integer, a floating point value, an"]
    #[doc = " nscoord, or undefined, and the unit is an nsStyleUnit.  Checking"]
    #[doc = " the unit is a must before asking for the value in any particular"]
    #[doc = " form."]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsStyleCoord {
        mUnit: root::nsStyleUnit,
        mValue: root::nsStyleUnion,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsStyleCoord_CalcValue {
        pub mLength: root::nscoord,
        pub mPercent: f32,
        pub mHasPercent: bool,
    }
    #[test]
    fn bindgen_test_layout_nsStyleCoord_CalcValue() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleCoord_CalcValue>(),
            12usize,
            concat!("Size of: ", stringify!(nsStyleCoord_CalcValue))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleCoord_CalcValue>(),
            4usize,
            concat!("Alignment of ", stringify!(nsStyleCoord_CalcValue))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleCoord_CalcValue>())).mLength as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleCoord_CalcValue),
                "::",
                stringify!(mLength)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleCoord_CalcValue>())).mPercent as *const _ as usize
            },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleCoord_CalcValue),
                "::",
                stringify!(mPercent)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleCoord_CalcValue>())).mHasPercent as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleCoord_CalcValue),
                "::",
                stringify!(mHasPercent)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsStyleCoord_Calc {
        pub _base: root::nsStyleCoord_CalcValue,
        pub mRefCnt: u64,
    }
    pub type nsStyleCoord_Calc_HasThreadSafeRefCnt = root::mozilla::TrueType;
    #[test]
    fn bindgen_test_layout_nsStyleCoord_Calc() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleCoord_Calc>(),
            24usize,
            concat!("Size of: ", stringify!(nsStyleCoord_Calc))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleCoord_Calc>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleCoord_Calc))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleCoord_Calc>())).mRefCnt as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleCoord_Calc),
                "::",
                stringify!(mRefCnt)
            )
        );
    }
    pub const nsStyleCoord_CoordConstructorType_CoordConstructor:
        root::nsStyleCoord_CoordConstructorType = 0;
    pub type nsStyleCoord_CoordConstructorType = u32;
    #[test]
    fn bindgen_test_layout_nsStyleCoord() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleCoord>(),
            16usize,
            concat!("Size of: ", stringify!(nsStyleCoord))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleCoord>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleCoord))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleCoord>())).mUnit as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleCoord),
                "::",
                stringify!(mUnit)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleCoord>())).mValue as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleCoord),
                "::",
                stringify!(mValue)
            )
        );
    }
    impl nsStyleCoord {
        #[inline]
        pub unsafe fn get_mUnit(&self) -> &root::nsStyleUnit {
            &self.mUnit
        }
        #[inline]
        pub unsafe fn get_mUnit_mut(&mut self) -> &mut root::nsStyleUnit {
            &mut self.mUnit
        }
        #[inline]
        pub unsafe fn get_mValue(&self) -> &root::nsStyleUnion {
            &self.mValue
        }
        #[inline]
        pub unsafe fn get_mValue_mut(&mut self) -> &mut root::nsStyleUnion {
            &mut self.mValue
        }
    }
    #[doc = " Class that represents a set of top/right/bottom/left nsStyleCoords."]
    #[doc = " This is commonly used to hold the widths of the borders, margins,"]
    #[doc = " or paddings of a box."]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsStyleSides {
        mUnits: [root::nsStyleUnit; 4usize],
        mValues: [root::nsStyleUnion; 4usize],
    }
    #[test]
    fn bindgen_test_layout_nsStyleSides() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleSides>(),
            40usize,
            concat!("Size of: ", stringify!(nsStyleSides))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleSides>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleSides))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSides>())).mUnits as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSides),
                "::",
                stringify!(mUnits)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSides>())).mValues as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSides),
                "::",
                stringify!(mValues)
            )
        );
    }
    impl nsStyleSides {
        #[inline]
        pub unsafe fn get_mUnits(&self) -> &[root::nsStyleUnit; 4usize] {
            &self.mUnits
        }
        #[inline]
        pub unsafe fn get_mUnits_mut(&mut self) -> &mut [root::nsStyleUnit; 4usize] {
            &mut self.mUnits
        }
        #[inline]
        pub unsafe fn get_mValues(&self) -> &[root::nsStyleUnion; 4usize] {
            &self.mValues
        }
        #[inline]
        pub unsafe fn get_mValues_mut(&mut self) -> &mut [root::nsStyleUnion; 4usize] {
            &mut self.mValues
        }
    }
    impl nsChangeHint {
        pub const nsChangeHint_Empty: root::nsChangeHint = root::nsChangeHint(0);
    }
    impl nsChangeHint {
        pub const nsChangeHint_RepaintFrame: root::nsChangeHint = root::nsChangeHint(1);
    }
    impl nsChangeHint {
        pub const nsChangeHint_NeedReflow: root::nsChangeHint = root::nsChangeHint(2);
    }
    impl nsChangeHint {
        pub const nsChangeHint_ClearAncestorIntrinsics: root::nsChangeHint = root::nsChangeHint(4);
    }
    impl nsChangeHint {
        pub const nsChangeHint_ClearDescendantIntrinsics: root::nsChangeHint =
            root::nsChangeHint(8);
    }
    impl nsChangeHint {
        pub const nsChangeHint_NeedDirtyReflow: root::nsChangeHint = root::nsChangeHint(16);
    }
    impl nsChangeHint {
        pub const nsChangeHint_SyncFrameView: root::nsChangeHint = root::nsChangeHint(32);
    }
    impl nsChangeHint {
        pub const nsChangeHint_UpdateCursor: root::nsChangeHint = root::nsChangeHint(64);
    }
    impl nsChangeHint {
        #[doc = " Used when the computed value (a URI) of one or more of an element\'s"]
        #[doc = " filter/mask/clip/etc CSS properties changes, causing the element\'s frame"]
        #[doc = " to start/stop referencing (or reference different) SVG resource elements."]
        #[doc = " (_Not_ used to handle changes to referenced resource elements.) Using this"]
        #[doc = " hint results in SVGObserverUtils::UpdateEffects being called on the"]
        #[doc = " element\'s frame."]
        pub const nsChangeHint_UpdateEffects: root::nsChangeHint = root::nsChangeHint(128);
    }
    impl nsChangeHint {
        #[doc = " Visual change only, but the change can be handled entirely by"]
        #[doc = " updating the layer(s) for the frame."]
        #[doc = " Updates all descendants (including following placeholders to out-of-flows)."]
        pub const nsChangeHint_UpdateOpacityLayer: root::nsChangeHint = root::nsChangeHint(256);
    }
    impl nsChangeHint {
        #[doc = " Updates all descendants. Any placeholder descendants\' out-of-flows"]
        #[doc = " are also descendants of the transformed frame, so they\'re updated."]
        pub const nsChangeHint_UpdateTransformLayer: root::nsChangeHint = root::nsChangeHint(512);
    }
    impl nsChangeHint {
        #[doc = " Change requires frame change (e.g., display:)."]
        #[doc = " Reconstructs all frame descendants, including following placeholders"]
        #[doc = " to out-of-flows."]
        #[doc = ""]
        #[doc = " Note that this subsumes all the other change hints. (see"]
        #[doc = " RestyleManager::ProcessRestyledFrames for details)."]
        pub const nsChangeHint_ReconstructFrame: root::nsChangeHint = root::nsChangeHint(1024);
    }
    impl nsChangeHint {
        #[doc = " The frame\'s overflow area has changed. Does not update any descendant"]
        #[doc = " frames."]
        pub const nsChangeHint_UpdateOverflow: root::nsChangeHint = root::nsChangeHint(2048);
    }
    impl nsChangeHint {
        #[doc = " The overflow area of the frame and all of its descendants has changed. This"]
        #[doc = " can happen through a text-decoration change."]
        pub const nsChangeHint_UpdateSubtreeOverflow: root::nsChangeHint = root::nsChangeHint(4096);
    }
    impl nsChangeHint {
        #[doc = " The frame\'s overflow area has changed, through a change in its transform."]
        #[doc = " In other words, the frame\'s pre-transform overflow is unchanged, but"]
        #[doc = " its post-transform overflow has changed, and thus its effect on its"]
        #[doc = " parent\'s overflow has changed.  If the pre-transform overflow has"]
        #[doc = " changed, see nsChangeHint_UpdateOverflow."]
        #[doc = " Does not update any descendant frames."]
        pub const nsChangeHint_UpdatePostTransformOverflow: root::nsChangeHint =
            root::nsChangeHint(8192);
    }
    impl nsChangeHint {
        #[doc = " This frame\'s effect on its parent\'s overflow area has changed."]
        #[doc = " (But neither its pre-transform nor post-transform overflow have"]
        #[doc = " changed; if those are the case, see"]
        #[doc = " nsChangeHint_UpdatePostTransformOverflow.)"]
        pub const nsChangeHint_UpdateParentOverflow: root::nsChangeHint = root::nsChangeHint(16384);
    }
    impl nsChangeHint {
        #[doc = " The children-only transform of an SVG frame changed, requiring overflows to"]
        #[doc = " be updated."]
        pub const nsChangeHint_ChildrenOnlyTransform: root::nsChangeHint =
            root::nsChangeHint(32768);
    }
    impl nsChangeHint {
        #[doc = " The frame\'s offsets have changed, while its dimensions might have"]
        #[doc = " changed as well.  This hint is used for positioned frames if their"]
        #[doc = " offset changes.  If we decide that the dimensions are likely to"]
        #[doc = " change, this will trigger a reflow."]
        #[doc = ""]
        #[doc = " Note that this should probably be used in combination with"]
        #[doc = " nsChangeHint_UpdateOverflow in order to get the overflow areas of"]
        #[doc = " the ancestors updated as well."]
        pub const nsChangeHint_RecomputePosition: root::nsChangeHint = root::nsChangeHint(65536);
    }
    impl nsChangeHint {
        #[doc = " Behaves like ReconstructFrame, but only if the frame has descendants"]
        #[doc = " that are absolutely or fixed position. Use this hint when a style change"]
        #[doc = " has changed whether the frame is a container for fixed-pos or abs-pos"]
        #[doc = " elements, but reframing is otherwise not needed."]
        #[doc = ""]
        #[doc = " Note that ComputedStyle::CalcStyleDifference adjusts results"]
        #[doc = " returned by style struct CalcDifference methods to return this hint"]
        #[doc = " only if there was a change to whether the element\'s overall style"]
        #[doc = " indicates that it establishes a containing block."]
        pub const nsChangeHint_UpdateContainingBlock: root::nsChangeHint =
            root::nsChangeHint(131072);
    }
    impl nsChangeHint {
        #[doc = " This change hint has *no* change handling behavior.  However, it"]
        #[doc = " exists to be a non-inherited hint, because when the border-style"]
        #[doc = " changes, and it\'s inherited by a child, that might require a reflow"]
        #[doc = " due to the border-width change on the child."]
        pub const nsChangeHint_BorderStyleNoneChange: root::nsChangeHint =
            root::nsChangeHint(262144);
    }
    impl nsChangeHint {
        #[doc = " SVG textPath needs to be recomputed because the path has changed."]
        #[doc = " This means that the glyph positions of the text need to be recomputed."]
        pub const nsChangeHint_UpdateTextPath: root::nsChangeHint = root::nsChangeHint(524288);
    }
    impl nsChangeHint {
        #[doc = " This will schedule an invalidating paint. This is useful if something"]
        #[doc = " has changed which will be invalidated by DLBI."]
        pub const nsChangeHint_SchedulePaint: root::nsChangeHint = root::nsChangeHint(1048576);
    }
    impl nsChangeHint {
        #[doc = " A hint reflecting that style data changed with no change handling"]
        #[doc = " behavior.  We need to return this, rather than nsChangeHint(0),"]
        #[doc = " so that certain optimizations that manipulate the style tree are"]
        #[doc = " correct."]
        #[doc = ""]
        #[doc = " nsChangeHint_NeutralChange must be returned by CalcDifference on a given"]
        #[doc = " style struct if the data in the style structs are meaningfully different"]
        #[doc = " and if no other change hints are returned.  If any other change hints are"]
        #[doc = " set, then nsChangeHint_NeutralChange need not also be included, but it is"]
        #[doc = " safe to do so.  (An example of style structs having non-meaningfully"]
        #[doc = " different data would be cached information that would be re-calculated"]
        #[doc = " to the same values, such as nsStyleBorder::mSubImages.)"]
        pub const nsChangeHint_NeutralChange: root::nsChangeHint = root::nsChangeHint(2097152);
    }
    impl nsChangeHint {
        #[doc = " This will cause rendering observers to be invalidated."]
        pub const nsChangeHint_InvalidateRenderingObservers: root::nsChangeHint =
            root::nsChangeHint(4194304);
    }
    impl nsChangeHint {
        #[doc = " Indicates that the reflow changes the size or position of the"]
        #[doc = " element, and thus the reflow must start from at least the frame\'s"]
        #[doc = " parent.  Must be not be set without also setting nsChangeHint_NeedReflow."]
        #[doc = " And consider adding nsChangeHint_ClearAncestorIntrinsics if needed."]
        pub const nsChangeHint_ReflowChangesSizeOrPosition: root::nsChangeHint =
            root::nsChangeHint(8388608);
    }
    impl nsChangeHint {
        #[doc = " Indicates that the style changes the computed BSize --- e.g. \'height\'."]
        #[doc = " Must not be set without also setting nsChangeHint_NeedReflow."]
        pub const nsChangeHint_UpdateComputedBSize: root::nsChangeHint =
            root::nsChangeHint(16777216);
    }
    impl nsChangeHint {
        #[doc = " Indicates that the \'opacity\' property changed between 1 and non-1."]
        #[doc = ""]
        #[doc = " Used as extra data for handling UpdateOpacityLayer hints."]
        #[doc = ""]
        #[doc = " Note that we do not send this hint if the non-1 value was 0.99 or"]
        #[doc = " greater, since in that case we send a RepaintFrame hint instead."]
        pub const nsChangeHint_UpdateUsesOpacity: root::nsChangeHint = root::nsChangeHint(33554432);
    }
    impl nsChangeHint {
        #[doc = " Indicates that the \'background-position\' property changed."]
        #[doc = " Regular frames can invalidate these changes using DLBI, but"]
        #[doc = " for some frame types we need to repaint the whole frame because"]
        #[doc = " the frame does not build individual background image display items"]
        #[doc = " for each background layer."]
        pub const nsChangeHint_UpdateBackgroundPosition: root::nsChangeHint =
            root::nsChangeHint(67108864);
    }
    impl nsChangeHint {
        #[doc = " Indicates that a frame has changed to or from having the CSS"]
        #[doc = " transform property set."]
        pub const nsChangeHint_AddOrRemoveTransform: root::nsChangeHint =
            root::nsChangeHint(134217728);
    }
    impl nsChangeHint {
        #[doc = " Indicates that the presence of scrollbars might have changed."]
        #[doc = ""]
        #[doc = " This happens when at least one of overflow-{x,y} properties changed."]
        #[doc = ""]
        #[doc = " In most cases, this is equivalent to nsChangeHint_ReconstructFrame. But"]
        #[doc = " in some special cases where the change is really targeting the viewport\'s"]
        #[doc = " scrollframe, this is instead equivalent to nsChangeHint_AllReflowHints"]
        #[doc = " (because the viewport always has an associated scrollframe)."]
        pub const nsChangeHint_ScrollbarChange: root::nsChangeHint = root::nsChangeHint(268435456);
    }
    impl nsChangeHint {
        #[doc = " Indicates that nsIFrame::UpdateWidgetProperties needs to be called."]
        #[doc = " This is used for -moz-window-* properties."]
        pub const nsChangeHint_UpdateWidgetProperties: root::nsChangeHint =
            root::nsChangeHint(536870912);
    }
    impl nsChangeHint {
        #[doc = "  Indicates that there has been a colspan or rowspan attribute change"]
        #[doc = "  on the cells of a table."]
        pub const nsChangeHint_UpdateTableCellSpans: root::nsChangeHint =
            root::nsChangeHint(1073741824);
    }
    impl nsChangeHint {
        #[doc = " Indicates that the visiblity property changed."]
        #[doc = " This change hint is used for skip restyling for animations on"]
        #[doc = " visibility:hidden elements in the case where the elements have no visible"]
        #[doc = " descendants."]
        pub const nsChangeHint_VisibilityChange: root::nsChangeHint =
            root::nsChangeHint(2147483648);
    }
    impl nsChangeHint {
        #[doc = " Dummy hint value for all hints. It exists for compile time check."]
        pub const nsChangeHint_AllHints: root::nsChangeHint = root::nsChangeHint(4294967295);
    }
    impl ::std::ops::BitOr<root::nsChangeHint> for root::nsChangeHint {
        type Output = Self;
        #[inline]
        fn bitor(self, other: Self) -> Self {
            nsChangeHint(self.0 | other.0)
        }
    }
    impl ::std::ops::BitOrAssign for root::nsChangeHint {
        #[inline]
        fn bitor_assign(&mut self, rhs: root::nsChangeHint) {
            self.0 |= rhs.0;
        }
    }
    impl ::std::ops::BitAnd<root::nsChangeHint> for root::nsChangeHint {
        type Output = Self;
        #[inline]
        fn bitand(self, other: Self) -> Self {
            nsChangeHint(self.0 & other.0)
        }
    }
    impl ::std::ops::BitAndAssign for root::nsChangeHint {
        #[inline]
        fn bitand_assign(&mut self, rhs: root::nsChangeHint) {
            self.0 &= rhs.0;
        }
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
    pub struct nsChangeHint(pub u32);
    #[repr(C)]
    pub struct nsTimingFunction {
        pub mTiming: root::mozilla::StyleComputedTimingFunction,
    }
    #[test]
    fn bindgen_test_layout_nsTimingFunction() {
        assert_eq!(
            ::std::mem::size_of::<nsTimingFunction>(),
            20usize,
            concat!("Size of: ", stringify!(nsTimingFunction))
        );
        assert_eq!(
            ::std::mem::align_of::<nsTimingFunction>(),
            4usize,
            concat!("Alignment of ", stringify!(nsTimingFunction))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsTimingFunction>())).mTiming as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsTimingFunction),
                "::",
                stringify!(mTiming)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct ProfilingStack {
        pub capacity: u32,
        pub frames: u64,
        pub stackPointer: u32,
    }
    #[test]
    fn bindgen_test_layout_ProfilingStack() {
        assert_eq!(
            ::std::mem::size_of::<ProfilingStack>(),
            24usize,
            concat!("Size of: ", stringify!(ProfilingStack))
        );
        assert_eq!(
            ::std::mem::align_of::<ProfilingStack>(),
            8usize,
            concat!("Alignment of ", stringify!(ProfilingStack))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ProfilingStack>())).capacity as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(ProfilingStack),
                "::",
                stringify!(capacity)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ProfilingStack>())).frames as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(ProfilingStack),
                "::",
                stringify!(frames)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<ProfilingStack>())).stackPointer as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(ProfilingStack),
                "::",
                stringify!(stackPointer)
            )
        );
    }
    pub const JSValueTag_JSVAL_TAG_MAX_DOUBLE: root::JSValueTag = 131056;
    pub const JSValueTag_JSVAL_TAG_INT32: root::JSValueTag = 131057;
    pub const JSValueTag_JSVAL_TAG_UNDEFINED: root::JSValueTag = 131059;
    pub const JSValueTag_JSVAL_TAG_NULL: root::JSValueTag = 131060;
    pub const JSValueTag_JSVAL_TAG_BOOLEAN: root::JSValueTag = 131058;
    pub const JSValueTag_JSVAL_TAG_MAGIC: root::JSValueTag = 131061;
    pub const JSValueTag_JSVAL_TAG_STRING: root::JSValueTag = 131062;
    pub const JSValueTag_JSVAL_TAG_SYMBOL: root::JSValueTag = 131063;
    pub const JSValueTag_JSVAL_TAG_PRIVATE_GCTHING: root::JSValueTag = 131064;
    pub const JSValueTag_JSVAL_TAG_BIGINT: root::JSValueTag = 131065;
    pub const JSValueTag_JSVAL_TAG_OBJECT: root::JSValueTag = 131068;
    pub type JSValueTag = u32;
    #[doc = " a hole in a native object\'s elements"]
    pub const JSWhyMagic_JS_ELEMENTS_HOLE: root::JSWhyMagic = 0;
    #[doc = " there is not a pending iterator value"]
    pub const JSWhyMagic_JS_NO_ITER_VALUE: root::JSWhyMagic = 1;
    #[doc = " exception value thrown when closing a generator"]
    pub const JSWhyMagic_JS_GENERATOR_CLOSING: root::JSWhyMagic = 2;
    #[doc = " used in debug builds to catch tracing errors"]
    pub const JSWhyMagic_JS_ARG_POISON: root::JSWhyMagic = 3;
    #[doc = " an empty subnode in the AST serializer"]
    pub const JSWhyMagic_JS_SERIALIZE_NO_NODE: root::JSWhyMagic = 4;
    #[doc = " optimized-away \'arguments\' value"]
    pub const JSWhyMagic_JS_OPTIMIZED_ARGUMENTS: root::JSWhyMagic = 5;
    #[doc = " magic value passed to natives to indicate construction"]
    pub const JSWhyMagic_JS_IS_CONSTRUCTING: root::JSWhyMagic = 6;
    #[doc = " see class js::HashableValue"]
    pub const JSWhyMagic_JS_HASH_KEY_EMPTY: root::JSWhyMagic = 7;
    #[doc = " error while running Ion code"]
    pub const JSWhyMagic_JS_ION_ERROR: root::JSWhyMagic = 8;
    #[doc = " missing recover instruction result"]
    pub const JSWhyMagic_JS_ION_BAILOUT: root::JSWhyMagic = 9;
    #[doc = " optimized out slot"]
    pub const JSWhyMagic_JS_OPTIMIZED_OUT: root::JSWhyMagic = 10;
    #[doc = " uninitialized lexical bindings that produce ReferenceError on touch."]
    pub const JSWhyMagic_JS_UNINITIALIZED_LEXICAL: root::JSWhyMagic = 11;
    #[doc = " standard constructors are not created for off-thread parsing."]
    pub const JSWhyMagic_JS_OFF_THREAD_CONSTRUCTOR: root::JSWhyMagic = 12;
    #[doc = " used in jit::TrySkipAwait"]
    pub const JSWhyMagic_JS_CANNOT_SKIP_AWAIT: root::JSWhyMagic = 13;
    #[doc = " for local use"]
    pub const JSWhyMagic_JS_GENERIC_MAGIC: root::JSWhyMagic = 14;
    #[doc = " for local use"]
    pub const JSWhyMagic_JS_WHY_MAGIC_COUNT: root::JSWhyMagic = 15;
    pub type JSWhyMagic = u32;
    #[repr(C)]
    pub struct nsCycleCollectionParticipant__bindgen_vtable(::std::os::raw::c_void);
    #[doc = " Participant implementation classes"]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsCycleCollectionParticipant {
        pub vtable_: *const nsCycleCollectionParticipant__bindgen_vtable,
        pub mMightSkip: bool,
        pub mTraverseShouldTrace: bool,
    }
    #[test]
    fn bindgen_test_layout_nsCycleCollectionParticipant() {
        assert_eq!(
            ::std::mem::size_of::<nsCycleCollectionParticipant>(),
            16usize,
            concat!("Size of: ", stringify!(nsCycleCollectionParticipant))
        );
        assert_eq!(
            ::std::mem::align_of::<nsCycleCollectionParticipant>(),
            8usize,
            concat!("Alignment of ", stringify!(nsCycleCollectionParticipant))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsCycleCollectionParticipant>())).mMightSkip as *const _
                    as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCycleCollectionParticipant),
                "::",
                stringify!(mMightSkip)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsCycleCollectionParticipant>())).mTraverseShouldTrace
                    as *const _ as usize
            },
            9usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCycleCollectionParticipant),
                "::",
                stringify!(mTraverseShouldTrace)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsScriptObjectTracer {
        pub _base: root::nsCycleCollectionParticipant,
    }
    #[test]
    fn bindgen_test_layout_nsScriptObjectTracer() {
        assert_eq!(
            ::std::mem::size_of::<nsScriptObjectTracer>(),
            16usize,
            concat!("Size of: ", stringify!(nsScriptObjectTracer))
        );
        assert_eq!(
            ::std::mem::align_of::<nsScriptObjectTracer>(),
            8usize,
            concat!("Alignment of ", stringify!(nsScriptObjectTracer))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsXPCOMCycleCollectionParticipant {
        pub _base: root::nsScriptObjectTracer,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsXPCOMCycleCollectionParticipant_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsXPCOMCycleCollectionParticipant() {
        assert_eq!(
            ::std::mem::size_of::<nsXPCOMCycleCollectionParticipant>(),
            16usize,
            concat!("Size of: ", stringify!(nsXPCOMCycleCollectionParticipant))
        );
        assert_eq!(
            ::std::mem::align_of::<nsXPCOMCycleCollectionParticipant>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(nsXPCOMCycleCollectionParticipant)
            )
        );
    }
    #[repr(C)]
    pub struct nsWrapperCache__bindgen_vtable(::std::os::raw::c_void);
    #[doc = " Class to store the wrapper for an object. This can only be used with objects"]
    #[doc = " that only have one non-security wrapper at a time (for an XPCWrappedNative"]
    #[doc = " this is usually ensured by setting an explicit parent in the PreCreate hook"]
    #[doc = " for the class)."]
    #[doc = ""]
    #[doc = " An instance of nsWrapperCache can be gotten from an object that implements"]
    #[doc = " a wrapper cache by calling QueryInterface on it. Note that this breaks XPCOM"]
    #[doc = " rules a bit (this object doesn\'t derive from nsISupports)."]
    #[doc = ""]
    #[doc = " The cache can store objects other than wrappers. We allow wrappers to use a"]
    #[doc = " separate JSObject to store their state (mostly expandos). If the wrapper is"]
    #[doc = " collected and we want to preserve this state we actually store the state"]
    #[doc = " object in the cache."]
    #[doc = ""]
    #[doc = " The cache can store 3 types of objects: a DOM binding object (regular JS"]
    #[doc = " object or proxy), an nsOuterWindowProxy or an XPCWrappedNative wrapper."]
    #[doc = ""]
    #[doc = " The finalizer for the wrapper clears the cache."]
    #[doc = ""]
    #[doc = " A compacting GC can move the wrapper object. Pointers to moved objects are"]
    #[doc = " usually found and updated by tracing the heap, however non-preserved wrappers"]
    #[doc = " are weak references and are not traced, so another approach is"]
    #[doc = " necessary. Instead a class hook (objectMovedOp) is provided that is called"]
    #[doc = " when an object is moved and is responsible for ensuring pointers are"]
    #[doc = " updated. It does this by calling UpdateWrapper() on the wrapper"]
    #[doc = " cache. SetWrapper() asserts that the hook is implemented for any wrapper set."]
    #[doc = ""]
    #[doc = " A number of the methods are implemented in nsWrapperCacheInlines.h because we"]
    #[doc = " have to include some JS headers that don\'t play nicely with the rest of the"]
    #[doc = " codebase. Include nsWrapperCacheInlines.h if you need to call those methods."]
    #[doc = ""]
    #[doc = " When recording or replaying an execution, wrapper caches are instrumented so"]
    #[doc = " that they behave consistently even if the GC executes at different points"]
    #[doc = " and collects different objects."]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsWrapperCache {
        pub vtable_: *const nsWrapperCache__bindgen_vtable,
        pub mWrapper: *mut root::JSObject,
        pub mFlags: root::nsWrapperCache_FlagsType,
        pub mBoolFlags: u32,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsWrapperCache_COMTypeInfo {
        pub _address: u8,
    }
    pub type nsWrapperCache_FlagsType = u32;
    pub const nsWrapperCache_WRAPPER_BIT_PRESERVED: root::nsWrapperCache__bindgen_ty_1 = 1;
    #[doc = " If this bit is set then we\'re preserving the wrapper, which in effect ties"]
    #[doc = " the lifetime of the JS object stored in the cache to the lifetime of the"]
    #[doc = " native object. We rely on the cycle collector to break the cycle that this"]
    #[doc = " causes between the native object and the JS object, so it is important that"]
    #[doc = " any native object that supports preserving of its wrapper"]
    #[doc = " traces/traverses/unlinks the cached JS object (see"]
    #[doc = " NS_IMPL_CYCLE_COLLECTION_TRACE_PRESERVED_WRAPPER and"]
    #[doc = " NS_IMPL_CYCLE_COLLECTION_UNLINK_PRESERVED_WRAPPER)."]
    pub type nsWrapperCache__bindgen_ty_1 = u32;
    pub const nsWrapperCache_kWrapperFlagsMask: root::nsWrapperCache__bindgen_ty_2 = 1;
    pub type nsWrapperCache__bindgen_ty_2 = u32;
    #[test]
    fn bindgen_test_layout_nsWrapperCache() {
        assert_eq!(
            ::std::mem::size_of::<nsWrapperCache>(),
            24usize,
            concat!("Size of: ", stringify!(nsWrapperCache))
        );
        assert_eq!(
            ::std::mem::align_of::<nsWrapperCache>(),
            8usize,
            concat!("Alignment of ", stringify!(nsWrapperCache))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsWrapperCache>())).mWrapper as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsWrapperCache),
                "::",
                stringify!(mWrapper)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsWrapperCache>())).mFlags as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsWrapperCache),
                "::",
                stringify!(mFlags)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsWrapperCache>())).mBoolFlags as *const _ as usize },
            20usize,
            concat!(
                "Offset of field: ",
                stringify!(nsWrapperCache),
                "::",
                stringify!(mBoolFlags)
            )
        );
    }
    pub type nsLoadFlags = u32;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIRequest {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIRequest_COMTypeInfo {
        pub _address: u8,
    }
    pub const nsIRequest_LOAD_REQUESTMASK: root::nsIRequest__bindgen_ty_1 = 65535;
    pub const nsIRequest_LOAD_NORMAL: root::nsIRequest__bindgen_ty_1 = 0;
    pub const nsIRequest_LOAD_BACKGROUND: root::nsIRequest__bindgen_ty_1 = 1;
    pub const nsIRequest_LOAD_HTML_OBJECT_DATA: root::nsIRequest__bindgen_ty_1 = 2;
    pub const nsIRequest_LOAD_DOCUMENT_NEEDS_COOKIE: root::nsIRequest__bindgen_ty_1 = 4;
    pub const nsIRequest_LOAD_DISABLE_TRR: root::nsIRequest__bindgen_ty_1 = 8;
    pub const nsIRequest_INHIBIT_CACHING: root::nsIRequest__bindgen_ty_1 = 128;
    pub const nsIRequest_INHIBIT_PERSISTENT_CACHING: root::nsIRequest__bindgen_ty_1 = 256;
    pub const nsIRequest_LOAD_BYPASS_CACHE: root::nsIRequest__bindgen_ty_1 = 512;
    pub const nsIRequest_LOAD_FROM_CACHE: root::nsIRequest__bindgen_ty_1 = 1024;
    pub const nsIRequest_VALIDATE_ALWAYS: root::nsIRequest__bindgen_ty_1 = 2048;
    pub const nsIRequest_VALIDATE_NEVER: root::nsIRequest__bindgen_ty_1 = 4096;
    pub const nsIRequest_VALIDATE_ONCE_PER_SESSION: root::nsIRequest__bindgen_ty_1 = 8192;
    pub const nsIRequest_LOAD_ANONYMOUS: root::nsIRequest__bindgen_ty_1 = 16384;
    pub const nsIRequest_LOAD_FRESH_CONNECTION: root::nsIRequest__bindgen_ty_1 = 32768;
    pub type nsIRequest__bindgen_ty_1 = u32;
    #[test]
    fn bindgen_test_layout_nsIRequest() {
        assert_eq!(
            ::std::mem::size_of::<nsIRequest>(),
            8usize,
            concat!("Size of: ", stringify!(nsIRequest))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIRequest>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIRequest))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIContentPolicy {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIContentPolicy_COMTypeInfo {
        pub _address: u8,
    }
    pub const nsIContentPolicy_TYPE_INVALID: root::nsIContentPolicy__bindgen_ty_1 = 0;
    pub const nsIContentPolicy_TYPE_OTHER: root::nsIContentPolicy__bindgen_ty_1 = 1;
    pub const nsIContentPolicy_TYPE_SCRIPT: root::nsIContentPolicy__bindgen_ty_1 = 2;
    pub const nsIContentPolicy_TYPE_IMAGE: root::nsIContentPolicy__bindgen_ty_1 = 3;
    pub const nsIContentPolicy_TYPE_STYLESHEET: root::nsIContentPolicy__bindgen_ty_1 = 4;
    pub const nsIContentPolicy_TYPE_OBJECT: root::nsIContentPolicy__bindgen_ty_1 = 5;
    pub const nsIContentPolicy_TYPE_DOCUMENT: root::nsIContentPolicy__bindgen_ty_1 = 6;
    pub const nsIContentPolicy_TYPE_SUBDOCUMENT: root::nsIContentPolicy__bindgen_ty_1 = 7;
    pub const nsIContentPolicy_TYPE_REFRESH: root::nsIContentPolicy__bindgen_ty_1 = 8;
    pub const nsIContentPolicy_TYPE_XBL: root::nsIContentPolicy__bindgen_ty_1 = 9;
    pub const nsIContentPolicy_TYPE_PING: root::nsIContentPolicy__bindgen_ty_1 = 10;
    pub const nsIContentPolicy_TYPE_XMLHTTPREQUEST: root::nsIContentPolicy__bindgen_ty_1 = 11;
    pub const nsIContentPolicy_TYPE_DATAREQUEST: root::nsIContentPolicy__bindgen_ty_1 = 11;
    pub const nsIContentPolicy_TYPE_OBJECT_SUBREQUEST: root::nsIContentPolicy__bindgen_ty_1 = 12;
    pub const nsIContentPolicy_TYPE_DTD: root::nsIContentPolicy__bindgen_ty_1 = 13;
    pub const nsIContentPolicy_TYPE_FONT: root::nsIContentPolicy__bindgen_ty_1 = 14;
    pub const nsIContentPolicy_TYPE_MEDIA: root::nsIContentPolicy__bindgen_ty_1 = 15;
    pub const nsIContentPolicy_TYPE_WEBSOCKET: root::nsIContentPolicy__bindgen_ty_1 = 16;
    pub const nsIContentPolicy_TYPE_CSP_REPORT: root::nsIContentPolicy__bindgen_ty_1 = 17;
    pub const nsIContentPolicy_TYPE_XSLT: root::nsIContentPolicy__bindgen_ty_1 = 18;
    pub const nsIContentPolicy_TYPE_BEACON: root::nsIContentPolicy__bindgen_ty_1 = 19;
    pub const nsIContentPolicy_TYPE_FETCH: root::nsIContentPolicy__bindgen_ty_1 = 20;
    pub const nsIContentPolicy_TYPE_IMAGESET: root::nsIContentPolicy__bindgen_ty_1 = 21;
    pub const nsIContentPolicy_TYPE_WEB_MANIFEST: root::nsIContentPolicy__bindgen_ty_1 = 22;
    pub const nsIContentPolicy_TYPE_INTERNAL_SCRIPT: root::nsIContentPolicy__bindgen_ty_1 = 23;
    pub const nsIContentPolicy_TYPE_INTERNAL_WORKER: root::nsIContentPolicy__bindgen_ty_1 = 24;
    pub const nsIContentPolicy_TYPE_INTERNAL_SHARED_WORKER: root::nsIContentPolicy__bindgen_ty_1 =
        25;
    pub const nsIContentPolicy_TYPE_INTERNAL_EMBED: root::nsIContentPolicy__bindgen_ty_1 = 26;
    pub const nsIContentPolicy_TYPE_INTERNAL_OBJECT: root::nsIContentPolicy__bindgen_ty_1 = 27;
    pub const nsIContentPolicy_TYPE_INTERNAL_FRAME: root::nsIContentPolicy__bindgen_ty_1 = 28;
    pub const nsIContentPolicy_TYPE_INTERNAL_IFRAME: root::nsIContentPolicy__bindgen_ty_1 = 29;
    pub const nsIContentPolicy_TYPE_INTERNAL_AUDIO: root::nsIContentPolicy__bindgen_ty_1 = 30;
    pub const nsIContentPolicy_TYPE_INTERNAL_VIDEO: root::nsIContentPolicy__bindgen_ty_1 = 31;
    pub const nsIContentPolicy_TYPE_INTERNAL_TRACK: root::nsIContentPolicy__bindgen_ty_1 = 32;
    pub const nsIContentPolicy_TYPE_INTERNAL_XMLHTTPREQUEST: root::nsIContentPolicy__bindgen_ty_1 =
        33;
    pub const nsIContentPolicy_TYPE_INTERNAL_EVENTSOURCE: root::nsIContentPolicy__bindgen_ty_1 = 34;
    pub const nsIContentPolicy_TYPE_INTERNAL_SERVICE_WORKER: root::nsIContentPolicy__bindgen_ty_1 =
        35;
    pub const nsIContentPolicy_TYPE_INTERNAL_SCRIPT_PRELOAD: root::nsIContentPolicy__bindgen_ty_1 =
        36;
    pub const nsIContentPolicy_TYPE_INTERNAL_IMAGE: root::nsIContentPolicy__bindgen_ty_1 = 37;
    pub const nsIContentPolicy_TYPE_INTERNAL_IMAGE_PRELOAD: root::nsIContentPolicy__bindgen_ty_1 =
        38;
    pub const nsIContentPolicy_TYPE_INTERNAL_STYLESHEET: root::nsIContentPolicy__bindgen_ty_1 = 39;
    pub const nsIContentPolicy_TYPE_INTERNAL_STYLESHEET_PRELOAD:
        root::nsIContentPolicy__bindgen_ty_1 = 40;
    pub const nsIContentPolicy_TYPE_INTERNAL_IMAGE_FAVICON: root::nsIContentPolicy__bindgen_ty_1 =
        41;
    pub const nsIContentPolicy_TYPE_INTERNAL_WORKER_IMPORT_SCRIPTS:
        root::nsIContentPolicy__bindgen_ty_1 = 42;
    pub const nsIContentPolicy_TYPE_SAVEAS_DOWNLOAD: root::nsIContentPolicy__bindgen_ty_1 = 43;
    pub const nsIContentPolicy_TYPE_SPECULATIVE: root::nsIContentPolicy__bindgen_ty_1 = 44;
    pub const nsIContentPolicy_TYPE_INTERNAL_MODULE: root::nsIContentPolicy__bindgen_ty_1 = 45;
    pub const nsIContentPolicy_TYPE_INTERNAL_MODULE_PRELOAD: root::nsIContentPolicy__bindgen_ty_1 =
        46;
    pub const nsIContentPolicy_REJECT_REQUEST: root::nsIContentPolicy__bindgen_ty_1 = -1;
    pub const nsIContentPolicy_REJECT_TYPE: root::nsIContentPolicy__bindgen_ty_1 = -2;
    pub const nsIContentPolicy_REJECT_SERVER: root::nsIContentPolicy__bindgen_ty_1 = -3;
    pub const nsIContentPolicy_REJECT_OTHER: root::nsIContentPolicy__bindgen_ty_1 = -4;
    pub const nsIContentPolicy_ACCEPT: root::nsIContentPolicy__bindgen_ty_1 = 1;
    pub type nsIContentPolicy__bindgen_ty_1 = i32;
    #[test]
    fn bindgen_test_layout_nsIContentPolicy() {
        assert_eq!(
            ::std::mem::size_of::<nsIContentPolicy>(),
            8usize,
            concat!("Size of: ", stringify!(nsIContentPolicy))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIContentPolicy>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIContentPolicy))
        );
    }
    #[doc = " Base class that implements parts shared by JSErrorReport and"]
    #[doc = " JSErrorNotes::Note."]
    #[repr(C)]
    #[derive(Debug)]
    pub struct JSErrorBase {
        pub message_: root::JS::ConstUTF8CharsZ,
        pub filename: *const ::std::os::raw::c_char,
        pub sourceId: ::std::os::raw::c_uint,
        pub lineno: ::std::os::raw::c_uint,
        pub column: ::std::os::raw::c_uint,
        pub errorNumber: ::std::os::raw::c_uint,
        pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 1usize], u8>,
        pub __bindgen_padding_0: [u8; 7usize],
    }
    #[test]
    fn bindgen_test_layout_JSErrorBase() {
        assert_eq!(
            ::std::mem::size_of::<JSErrorBase>(),
            40usize,
            concat!("Size of: ", stringify!(JSErrorBase))
        );
        assert_eq!(
            ::std::mem::align_of::<JSErrorBase>(),
            8usize,
            concat!("Alignment of ", stringify!(JSErrorBase))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<JSErrorBase>())).message_ as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(JSErrorBase),
                "::",
                stringify!(message_)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<JSErrorBase>())).filename as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(JSErrorBase),
                "::",
                stringify!(filename)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<JSErrorBase>())).sourceId as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(JSErrorBase),
                "::",
                stringify!(sourceId)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<JSErrorBase>())).lineno as *const _ as usize },
            20usize,
            concat!(
                "Offset of field: ",
                stringify!(JSErrorBase),
                "::",
                stringify!(lineno)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<JSErrorBase>())).column as *const _ as usize },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(JSErrorBase),
                "::",
                stringify!(column)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<JSErrorBase>())).errorNumber as *const _ as usize },
            28usize,
            concat!(
                "Offset of field: ",
                stringify!(JSErrorBase),
                "::",
                stringify!(errorNumber)
            )
        );
    }
    impl JSErrorBase {
        #[inline]
        pub fn ownsMessage_(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_ownsMessage_(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(0usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn new_bitfield_1(ownsMessage_: bool) -> root::__BindgenBitfieldUnit<[u8; 1usize], u8> {
            let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 1usize], u8> =
                Default::default();
            __bindgen_bitfield_unit.set(0usize, 1u8, {
                let ownsMessage_: u8 = unsafe { ::std::mem::transmute(ownsMessage_) };
                ownsMessage_ as u64
            });
            __bindgen_bitfield_unit
        }
    }
    #[doc = " Notes associated with JSErrorReport."]
    #[repr(C)]
    #[derive(Debug)]
    pub struct JSErrorNotes {
        pub notes_: [u64; 4usize],
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct JSErrorNotes_Note {
        pub _base: root::JSErrorBase,
    }
    #[test]
    fn bindgen_test_layout_JSErrorNotes_Note() {
        assert_eq!(
            ::std::mem::size_of::<JSErrorNotes_Note>(),
            40usize,
            concat!("Size of: ", stringify!(JSErrorNotes_Note))
        );
        assert_eq!(
            ::std::mem::align_of::<JSErrorNotes_Note>(),
            8usize,
            concat!("Alignment of ", stringify!(JSErrorNotes_Note))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct JSErrorNotes_iterator {
        pub note_: *mut root::mozilla::UniquePtr<root::JSErrorNotes_Note>,
    }
    pub type JSErrorNotes_iterator_iterator_category = root::std::input_iterator_tag;
    pub type JSErrorNotes_iterator_value_type = root::mozilla::UniquePtr<root::JSErrorNotes_Note>;
    pub type JSErrorNotes_iterator_difference_type = isize;
    pub type JSErrorNotes_iterator_pointer = *mut root::JSErrorNotes_iterator_value_type;
    pub type JSErrorNotes_iterator_reference = *mut root::JSErrorNotes_iterator_value_type;
    #[test]
    fn bindgen_test_layout_JSErrorNotes_iterator() {
        assert_eq!(
            ::std::mem::size_of::<JSErrorNotes_iterator>(),
            8usize,
            concat!("Size of: ", stringify!(JSErrorNotes_iterator))
        );
        assert_eq!(
            ::std::mem::align_of::<JSErrorNotes_iterator>(),
            8usize,
            concat!("Alignment of ", stringify!(JSErrorNotes_iterator))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<JSErrorNotes_iterator>())).note_ as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(JSErrorNotes_iterator),
                "::",
                stringify!(note_)
            )
        );
    }
    #[test]
    fn bindgen_test_layout_JSErrorNotes() {
        assert_eq!(
            ::std::mem::size_of::<JSErrorNotes>(),
            32usize,
            concat!("Size of: ", stringify!(JSErrorNotes))
        );
        assert_eq!(
            ::std::mem::align_of::<JSErrorNotes>(),
            8usize,
            concat!("Alignment of ", stringify!(JSErrorNotes))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<JSErrorNotes>())).notes_ as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(JSErrorNotes),
                "::",
                stringify!(notes_)
            )
        );
    }
    #[doc = " Describes a single error or warning that occurs in the execution of script."]
    #[repr(C)]
    #[derive(Debug)]
    pub struct JSErrorReport {
        pub _base: root::JSErrorBase,
        pub linebuf_: *const u16,
        pub linebufLength_: usize,
        pub tokenOffset_: usize,
        pub notes: root::mozilla::UniquePtr<root::JSErrorNotes>,
        pub flags: ::std::os::raw::c_uint,
        pub exnType: i16,
        pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 1usize], u8>,
        pub __bindgen_padding_0: u8,
    }
    #[test]
    fn bindgen_test_layout_JSErrorReport() {
        assert_eq!(
            ::std::mem::size_of::<JSErrorReport>(),
            80usize,
            concat!("Size of: ", stringify!(JSErrorReport))
        );
        assert_eq!(
            ::std::mem::align_of::<JSErrorReport>(),
            8usize,
            concat!("Alignment of ", stringify!(JSErrorReport))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<JSErrorReport>())).linebuf_ as *const _ as usize },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(JSErrorReport),
                "::",
                stringify!(linebuf_)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<JSErrorReport>())).linebufLength_ as *const _ as usize
            },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(JSErrorReport),
                "::",
                stringify!(linebufLength_)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<JSErrorReport>())).tokenOffset_ as *const _ as usize },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(JSErrorReport),
                "::",
                stringify!(tokenOffset_)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<JSErrorReport>())).notes as *const _ as usize },
            64usize,
            concat!(
                "Offset of field: ",
                stringify!(JSErrorReport),
                "::",
                stringify!(notes)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<JSErrorReport>())).flags as *const _ as usize },
            72usize,
            concat!(
                "Offset of field: ",
                stringify!(JSErrorReport),
                "::",
                stringify!(flags)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<JSErrorReport>())).exnType as *const _ as usize },
            76usize,
            concat!(
                "Offset of field: ",
                stringify!(JSErrorReport),
                "::",
                stringify!(exnType)
            )
        );
    }
    impl JSErrorReport {
        #[inline]
        pub fn isMuted(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_isMuted(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(0usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn ownsLinebuf_(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_ownsLinebuf_(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(1usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn new_bitfield_1(
            isMuted: bool,
            ownsLinebuf_: bool,
        ) -> root::__BindgenBitfieldUnit<[u8; 1usize], u8> {
            let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 1usize], u8> =
                Default::default();
            __bindgen_bitfield_unit.set(0usize, 1u8, {
                let isMuted: u8 = unsafe { ::std::mem::transmute(isMuted) };
                isMuted as u64
            });
            __bindgen_bitfield_unit.set(1usize, 1u8, {
                let ownsLinebuf_: u8 = unsafe { ::std::mem::transmute(ownsLinebuf_) };
                ownsLinebuf_ as u64
            });
            __bindgen_bitfield_unit
        }
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct JSAutoRealm {
        pub cx_: *mut root::JSContext,
        pub oldRealm_: *mut root::JS::Realm,
    }
    #[test]
    fn bindgen_test_layout_JSAutoRealm() {
        assert_eq!(
            ::std::mem::size_of::<JSAutoRealm>(),
            16usize,
            concat!("Size of: ", stringify!(JSAutoRealm))
        );
        assert_eq!(
            ::std::mem::align_of::<JSAutoRealm>(),
            8usize,
            concat!("Alignment of ", stringify!(JSAutoRealm))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<JSAutoRealm>())).cx_ as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(JSAutoRealm),
                "::",
                stringify!(cx_)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<JSAutoRealm>())).oldRealm_ as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(JSAutoRealm),
                "::",
                stringify!(oldRealm_)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct JSAutoNullableRealm {
        pub cx_: *mut root::JSContext,
        pub oldRealm_: *mut root::JS::Realm,
    }
    #[test]
    fn bindgen_test_layout_JSAutoNullableRealm() {
        assert_eq!(
            ::std::mem::size_of::<JSAutoNullableRealm>(),
            16usize,
            concat!("Size of: ", stringify!(JSAutoNullableRealm))
        );
        assert_eq!(
            ::std::mem::align_of::<JSAutoNullableRealm>(),
            8usize,
            concat!("Alignment of ", stringify!(JSAutoNullableRealm))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<JSAutoNullableRealm>())).cx_ as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(JSAutoNullableRealm),
                "::",
                stringify!(cx_)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<JSAutoNullableRealm>())).oldRealm_ as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(JSAutoNullableRealm),
                "::",
                stringify!(oldRealm_)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsISerializable {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsISerializable_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsISerializable() {
        assert_eq!(
            ::std::mem::size_of::<nsISerializable>(),
            8usize,
            concat!("Size of: ", stringify!(nsISerializable))
        );
        assert_eq!(
            ::std::mem::align_of::<nsISerializable>(),
            8usize,
            concat!("Alignment of ", stringify!(nsISerializable))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIPrincipal {
        pub _base: root::nsISerializable,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIPrincipal_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIPrincipal() {
        assert_eq!(
            ::std::mem::size_of::<nsIPrincipal>(),
            8usize,
            concat!("Size of: ", stringify!(nsIPrincipal))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIPrincipal>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIPrincipal))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct ProfilerBacktrace {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct ProfilerMarkerPayload {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct ProfilerBacktraceDestructor {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_ProfilerBacktraceDestructor() {
        assert_eq!(
            ::std::mem::size_of::<ProfilerBacktraceDestructor>(),
            1usize,
            concat!("Size of: ", stringify!(ProfilerBacktraceDestructor))
        );
        assert_eq!(
            ::std::mem::align_of::<ProfilerBacktraceDestructor>(),
            1usize,
            concat!("Alignment of ", stringify!(ProfilerBacktraceDestructor))
        );
    }
    pub type UniqueProfilerBacktrace = root::mozilla::UniquePtr<root::ProfilerBacktrace>;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIScriptSecurityManager {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIScriptSecurityManager_COMTypeInfo {
        pub _address: u8,
    }
    pub const nsIScriptSecurityManager_STANDARD: root::nsIScriptSecurityManager__bindgen_ty_1 = 0;
    pub const nsIScriptSecurityManager_LOAD_IS_AUTOMATIC_DOCUMENT_REPLACEMENT:
        root::nsIScriptSecurityManager__bindgen_ty_1 = 1;
    pub const nsIScriptSecurityManager_ALLOW_CHROME: root::nsIScriptSecurityManager__bindgen_ty_1 =
        2;
    pub const nsIScriptSecurityManager_DISALLOW_INHERIT_PRINCIPAL:
        root::nsIScriptSecurityManager__bindgen_ty_1 = 4;
    pub const nsIScriptSecurityManager_DISALLOW_SCRIPT_OR_DATA:
        root::nsIScriptSecurityManager__bindgen_ty_1 = 4;
    pub const nsIScriptSecurityManager_DISALLOW_SCRIPT:
        root::nsIScriptSecurityManager__bindgen_ty_1 = 8;
    pub const nsIScriptSecurityManager_DONT_REPORT_ERRORS:
        root::nsIScriptSecurityManager__bindgen_ty_1 = 16;
    pub type nsIScriptSecurityManager__bindgen_ty_1 = u32;
    pub const nsIScriptSecurityManager_DEFAULT_USER_CONTEXT_ID:
        root::nsIScriptSecurityManager__bindgen_ty_2 = 0;
    pub type nsIScriptSecurityManager__bindgen_ty_2 = u32;
    #[test]
    fn bindgen_test_layout_nsIScriptSecurityManager() {
        assert_eq!(
            ::std::mem::size_of::<nsIScriptSecurityManager>(),
            8usize,
            concat!("Size of: ", stringify!(nsIScriptSecurityManager))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIScriptSecurityManager>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIScriptSecurityManager))
        );
    }
    pub const nsILoadInfo_CrossOriginOpenerPolicy_OPENER_POLICY_NULL:
        root::nsILoadInfo_CrossOriginOpenerPolicy = 0;
    pub const nsILoadInfo_CrossOriginOpenerPolicy_OPENER_POLICY_SAME_ORIGIN:
        root::nsILoadInfo_CrossOriginOpenerPolicy = 1;
    pub const nsILoadInfo_CrossOriginOpenerPolicy_OPENER_POLICY_SAME_SITE:
        root::nsILoadInfo_CrossOriginOpenerPolicy = 2;
    pub const nsILoadInfo_CrossOriginOpenerPolicy_OPENER_POLICY_UNSAFE_ALLOW_OUTGOING_FLAG:
        root::nsILoadInfo_CrossOriginOpenerPolicy = 128;
    pub const nsILoadInfo_CrossOriginOpenerPolicy_OPENER_POLICY_SAME_ORIGIN_ALLOW_OUTGOING:
        root::nsILoadInfo_CrossOriginOpenerPolicy = 129;
    pub const nsILoadInfo_CrossOriginOpenerPolicy_OPENER_POLICY_SAME_SITE_ALLOW_OUTGOING:
        root::nsILoadInfo_CrossOriginOpenerPolicy = 130;
    pub type nsILoadInfo_CrossOriginOpenerPolicy = u8;
    pub const nsILoadInfo_CrossOriginPolicy_CROSS_ORIGIN_POLICY_NULL:
        root::nsILoadInfo_CrossOriginPolicy = 0;
    pub const nsILoadInfo_CrossOriginPolicy_CROSS_ORIGIN_POLICY_ANONYMOUS:
        root::nsILoadInfo_CrossOriginPolicy = 1;
    pub const nsILoadInfo_CrossOriginPolicy_CROSS_ORIGIN_POLICY_USE_CREDENTIALS:
        root::nsILoadInfo_CrossOriginPolicy = 2;
    pub type nsILoadInfo_CrossOriginPolicy = u8;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIChannel {
        pub _base: root::nsIRequest,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIChannel_COMTypeInfo {
        pub _address: u8,
    }
    pub const nsIChannel_LOAD_DOCUMENT_URI: root::nsIChannel__bindgen_ty_1 = 65536;
    pub const nsIChannel_LOAD_RETARGETED_DOCUMENT_URI: root::nsIChannel__bindgen_ty_1 = 131072;
    pub const nsIChannel_LOAD_REPLACE: root::nsIChannel__bindgen_ty_1 = 262144;
    pub const nsIChannel_LOAD_INITIAL_DOCUMENT_URI: root::nsIChannel__bindgen_ty_1 = 524288;
    pub const nsIChannel_LOAD_TARGETED: root::nsIChannel__bindgen_ty_1 = 1048576;
    pub const nsIChannel_LOAD_CALL_CONTENT_SNIFFERS: root::nsIChannel__bindgen_ty_1 = 2097152;
    pub const nsIChannel_LOAD_BYPASS_URL_CLASSIFIER: root::nsIChannel__bindgen_ty_1 = 4194304;
    pub const nsIChannel_LOAD_MEDIA_SNIFFER_OVERRIDES_CONTENT_TYPE: root::nsIChannel__bindgen_ty_1 =
        8388608;
    pub const nsIChannel_LOAD_EXPLICIT_CREDENTIALS: root::nsIChannel__bindgen_ty_1 = 16777216;
    pub const nsIChannel_LOAD_BYPASS_SERVICE_WORKER: root::nsIChannel__bindgen_ty_1 = 33554432;
    pub type nsIChannel__bindgen_ty_1 = u32;
    pub const nsIChannel_DISPOSITION_INLINE: root::nsIChannel__bindgen_ty_2 = 0;
    pub const nsIChannel_DISPOSITION_ATTACHMENT: root::nsIChannel__bindgen_ty_2 = 1;
    pub type nsIChannel__bindgen_ty_2 = u32;
    #[test]
    fn bindgen_test_layout_nsIChannel() {
        assert_eq!(
            ::std::mem::size_of::<nsIChannel>(),
            8usize,
            concat!("Size of: ", stringify!(nsIChannel))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIChannel>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIChannel))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIURI {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIURI_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIURI() {
        assert_eq!(
            ::std::mem::size_of::<nsIURI>(),
            8usize,
            concat!("Size of: ", stringify!(nsIURI))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIURI>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIURI))
        );
    }
    #[repr(i16)]
    #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
    pub enum nsCSSKeyword {
        eCSSKeyword_UNKNOWN = -1,
        eCSSKeyword__moz_available = 0,
        eCSSKeyword__moz_box = 1,
        eCSSKeyword__moz_center = 2,
        eCSSKeyword__moz_block_height = 3,
        eCSSKeyword__moz_deck = 4,
        eCSSKeyword__moz_fit_content = 5,
        eCSSKeyword__moz_grabbing = 6,
        eCSSKeyword__moz_grab = 7,
        eCSSKeyword__moz_grid_group = 8,
        eCSSKeyword__moz_grid_line = 9,
        eCSSKeyword__moz_grid = 10,
        eCSSKeyword__moz_groupbox = 11,
        eCSSKeyword__moz_inline_box = 12,
        eCSSKeyword__moz_inline_grid = 13,
        eCSSKeyword__moz_inline_stack = 14,
        eCSSKeyword__moz_left = 15,
        eCSSKeyword__moz_middle_with_baseline = 16,
        eCSSKeyword__moz_none = 17,
        eCSSKeyword__moz_popup = 18,
        eCSSKeyword__moz_right = 19,
        eCSSKeyword__moz_stack = 20,
        eCSSKeyword__moz_zoom_in = 21,
        eCSSKeyword__moz_zoom_out = 22,
        eCSSKeyword__webkit_box = 23,
        eCSSKeyword__webkit_flex = 24,
        eCSSKeyword__webkit_inline_box = 25,
        eCSSKeyword__webkit_inline_flex = 26,
        eCSSKeyword_alias = 27,
        eCSSKeyword_all = 28,
        eCSSKeyword_all_scroll = 29,
        eCSSKeyword_auto = 30,
        eCSSKeyword_baseline = 31,
        eCSSKeyword_blink = 32,
        eCSSKeyword_block = 33,
        eCSSKeyword_blur = 34,
        eCSSKeyword_bottom = 35,
        eCSSKeyword_brightness = 36,
        eCSSKeyword_cell = 37,
        eCSSKeyword_center = 38,
        eCSSKeyword_circle = 39,
        eCSSKeyword_clip = 40,
        eCSSKeyword_closest_side = 41,
        eCSSKeyword_col_resize = 42,
        eCSSKeyword_column = 43,
        eCSSKeyword_content = 44,
        eCSSKeyword_contents = 45,
        eCSSKeyword_context_fill = 46,
        eCSSKeyword_context_menu = 47,
        eCSSKeyword_context_stroke = 48,
        eCSSKeyword_contrast = 49,
        eCSSKeyword_copy = 50,
        eCSSKeyword_crosshair = 51,
        eCSSKeyword_dashed = 52,
        eCSSKeyword_dense = 53,
        eCSSKeyword_default = 54,
        eCSSKeyword_dot = 55,
        eCSSKeyword_dotted = 56,
        eCSSKeyword_double = 57,
        eCSSKeyword_double_circle = 58,
        eCSSKeyword_drop_shadow = 59,
        eCSSKeyword_e_resize = 60,
        eCSSKeyword_ellipse = 61,
        eCSSKeyword_ellipsis = 62,
        eCSSKeyword_end = 63,
        eCSSKeyword_ew_resize = 64,
        eCSSKeyword_farthest_side = 65,
        eCSSKeyword_fill = 66,
        eCSSKeyword_filled = 67,
        eCSSKeyword_flex = 68,
        eCSSKeyword_flex_end = 69,
        eCSSKeyword_flex_start = 70,
        eCSSKeyword_flow_root = 71,
        eCSSKeyword_grab = 72,
        eCSSKeyword_grabbing = 73,
        eCSSKeyword_grayscale = 74,
        eCSSKeyword_grid = 75,
        eCSSKeyword_help = 76,
        eCSSKeyword_hue_rotate = 77,
        eCSSKeyword_infinite = 78,
        eCSSKeyword_inline = 79,
        eCSSKeyword_inline_block = 80,
        eCSSKeyword_inline_flex = 81,
        eCSSKeyword_inline_grid = 82,
        eCSSKeyword_inline_table = 83,
        eCSSKeyword_inset = 84,
        eCSSKeyword_interpolatematrix = 85,
        eCSSKeyword_accumulatematrix = 86,
        eCSSKeyword_invert = 87,
        eCSSKeyword_justify = 88,
        eCSSKeyword_last_baseline = 89,
        eCSSKeyword_layout = 90,
        eCSSKeyword_left = 91,
        eCSSKeyword_line_through = 92,
        eCSSKeyword_list_item = 93,
        eCSSKeyword_manipulation = 94,
        eCSSKeyword_matrix = 95,
        eCSSKeyword_matrix3d = 96,
        eCSSKeyword_max_content = 97,
        eCSSKeyword_middle = 98,
        eCSSKeyword_min_content = 99,
        eCSSKeyword_move = 100,
        eCSSKeyword_n_resize = 101,
        eCSSKeyword_ne_resize = 102,
        eCSSKeyword_nesw_resize = 103,
        eCSSKeyword_no_drop = 104,
        eCSSKeyword_none = 105,
        eCSSKeyword_normal = 106,
        eCSSKeyword_not_allowed = 107,
        eCSSKeyword_ns_resize = 108,
        eCSSKeyword_nw_resize = 109,
        eCSSKeyword_nwse_resize = 110,
        eCSSKeyword_opacity = 111,
        eCSSKeyword_open = 112,
        eCSSKeyword_over = 113,
        eCSSKeyword_overline = 114,
        eCSSKeyword_paint = 115,
        eCSSKeyword_pan_x = 116,
        eCSSKeyword_pan_y = 117,
        eCSSKeyword_perspective = 118,
        eCSSKeyword_pointer = 119,
        eCSSKeyword_polygon = 120,
        eCSSKeyword_progress = 121,
        eCSSKeyword_right = 122,
        eCSSKeyword_rotate = 123,
        eCSSKeyword_rotate3d = 124,
        eCSSKeyword_rotatex = 125,
        eCSSKeyword_rotatey = 126,
        eCSSKeyword_rotatez = 127,
        eCSSKeyword_row = 128,
        eCSSKeyword_row_resize = 129,
        eCSSKeyword_ruby = 130,
        eCSSKeyword_ruby_base = 131,
        eCSSKeyword_ruby_base_container = 132,
        eCSSKeyword_ruby_text = 133,
        eCSSKeyword_ruby_text_container = 134,
        eCSSKeyword_s_resize = 135,
        eCSSKeyword_saturate = 136,
        eCSSKeyword_scale = 137,
        eCSSKeyword_scale3d = 138,
        eCSSKeyword_scalex = 139,
        eCSSKeyword_scaley = 140,
        eCSSKeyword_scalez = 141,
        eCSSKeyword_se_resize = 142,
        eCSSKeyword_self_end = 143,
        eCSSKeyword_self_start = 144,
        eCSSKeyword_sepia = 145,
        eCSSKeyword_sesame = 146,
        eCSSKeyword_size = 147,
        eCSSKeyword_skew = 148,
        eCSSKeyword_skewx = 149,
        eCSSKeyword_skewy = 150,
        eCSSKeyword_solid = 151,
        eCSSKeyword_space_around = 152,
        eCSSKeyword_space_between = 153,
        eCSSKeyword_space_evenly = 154,
        eCSSKeyword_span = 155,
        eCSSKeyword_start = 156,
        eCSSKeyword_stretch = 157,
        eCSSKeyword_strict = 158,
        eCSSKeyword_style = 159,
        eCSSKeyword_sub = 160,
        eCSSKeyword_subgrid = 161,
        eCSSKeyword_super = 162,
        eCSSKeyword_sw_resize = 163,
        eCSSKeyword_table = 164,
        eCSSKeyword_table_caption = 165,
        eCSSKeyword_table_cell = 166,
        eCSSKeyword_table_column = 167,
        eCSSKeyword_table_column_group = 168,
        eCSSKeyword_table_footer_group = 169,
        eCSSKeyword_table_header_group = 170,
        eCSSKeyword_table_row = 171,
        eCSSKeyword_table_row_group = 172,
        eCSSKeyword_text = 173,
        eCSSKeyword_text_bottom = 174,
        eCSSKeyword_text_top = 175,
        eCSSKeyword_top = 176,
        eCSSKeyword_translate = 177,
        eCSSKeyword_translate3d = 178,
        eCSSKeyword_translatex = 179,
        eCSSKeyword_translatey = 180,
        eCSSKeyword_translatez = 181,
        eCSSKeyword_triangle = 182,
        eCSSKeyword_under = 183,
        eCSSKeyword_underline = 184,
        eCSSKeyword_vertical_text = 185,
        eCSSKeyword_w_resize = 186,
        eCSSKeyword_wait = 187,
        eCSSKeyword_wavy = 188,
        eCSSKeyword_zoom_in = 189,
        eCSSKeyword_zoom_out = 190,
        eCSSKeyword_COUNT = 191,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIRunnable {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIRunnable_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIRunnable() {
        assert_eq!(
            ::std::mem::size_of::<nsIRunnable>(),
            8usize,
            concat!("Size of: ", stringify!(nsIRunnable))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIRunnable>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIRunnable))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIEventTarget {
        pub _base: root::nsISupports,
        pub mVirtualThread: *mut root::PRThread,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIEventTarget_COMTypeInfo {
        pub _address: u8,
    }
    pub const nsIEventTarget_DISPATCH_NORMAL: root::nsIEventTarget__bindgen_ty_1 = 0;
    pub const nsIEventTarget_DISPATCH_SYNC: root::nsIEventTarget__bindgen_ty_1 = 1;
    pub const nsIEventTarget_DISPATCH_AT_END: root::nsIEventTarget__bindgen_ty_1 = 2;
    pub type nsIEventTarget__bindgen_ty_1 = u32;
    #[test]
    fn bindgen_test_layout_nsIEventTarget() {
        assert_eq!(
            ::std::mem::size_of::<nsIEventTarget>(),
            16usize,
            concat!("Size of: ", stringify!(nsIEventTarget))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIEventTarget>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIEventTarget))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIEventTarget>())).mVirtualThread as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIEventTarget),
                "::",
                stringify!(mVirtualThread)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsISerialEventTarget {
        pub _base: root::nsIEventTarget,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsISerialEventTarget_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsISerialEventTarget() {
        assert_eq!(
            ::std::mem::size_of::<nsISerialEventTarget>(),
            16usize,
            concat!("Size of: ", stringify!(nsISerialEventTarget))
        );
        assert_eq!(
            ::std::mem::align_of::<nsISerialEventTarget>(),
            8usize,
            concat!("Alignment of ", stringify!(nsISerialEventTarget))
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsICancelableRunnable {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsICancelableRunnable_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsICancelableRunnable() {
        assert_eq!(
            ::std::mem::size_of::<nsICancelableRunnable>(),
            8usize,
            concat!("Size of: ", stringify!(nsICancelableRunnable))
        );
        assert_eq!(
            ::std::mem::align_of::<nsICancelableRunnable>(),
            8usize,
            concat!("Alignment of ", stringify!(nsICancelableRunnable))
        );
    }
    #[doc = " The signature of the timer callback function passed to initWithFuncCallback."]
    #[doc = " This is the function that will get called when the timer expires if the"]
    #[doc = " timer is initialized via initWithFuncCallback."]
    #[doc = ""]
    #[doc = " @param aTimer the timer which has expired"]
    #[doc = " @param aClosure opaque parameter passed to initWithFuncCallback"]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsITimer {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsITimer_COMTypeInfo {
        pub _address: u8,
    }
    pub const nsITimer_TYPE_ONE_SHOT: root::nsITimer__bindgen_ty_1 = 0;
    pub const nsITimer_TYPE_REPEATING_SLACK: root::nsITimer__bindgen_ty_1 = 1;
    pub const nsITimer_TYPE_REPEATING_PRECISE: root::nsITimer__bindgen_ty_1 = 2;
    pub const nsITimer_TYPE_REPEATING_PRECISE_CAN_SKIP: root::nsITimer__bindgen_ty_1 = 3;
    pub const nsITimer_TYPE_REPEATING_SLACK_LOW_PRIORITY: root::nsITimer__bindgen_ty_1 = 4;
    pub const nsITimer_TYPE_ONE_SHOT_LOW_PRIORITY: root::nsITimer__bindgen_ty_1 = 5;
    pub type nsITimer__bindgen_ty_1 = u32;
    #[test]
    fn bindgen_test_layout_nsITimer() {
        assert_eq!(
            ::std::mem::size_of::<nsITimer>(),
            8usize,
            concat!("Size of: ", stringify!(nsITimer))
        );
        assert_eq!(
            ::std::mem::align_of::<nsITimer>(),
            8usize,
            concat!("Alignment of ", stringify!(nsITimer))
        );
    }
    #[repr(C)]
    pub struct nsIGlobalObject {
        pub _base: root::nsISupports,
        pub _base_1: root::mozilla::dom::DispatcherTrait,
        pub mHostObjectURIs: root::nsTArray<::gecko_bindings::structs::nsCString>,
        pub mEventTargetObjects: root::mozilla::LinkedList,
        pub mIsDying: bool,
        pub mIsInnerWindow: bool,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIGlobalObject_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIGlobalObject() {
        assert_eq!(
            ::std::mem::size_of::<nsIGlobalObject>(),
            56usize,
            concat!("Size of: ", stringify!(nsIGlobalObject))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIGlobalObject>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIGlobalObject))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIObserver {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIObserver_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIObserver() {
        assert_eq!(
            ::std::mem::size_of::<nsIObserver>(),
            8usize,
            concat!("Size of: ", stringify!(nsIObserver))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIObserver>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIObserver))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIWeakReference {
        pub _base: root::nsISupports,
        pub mObject: *mut root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIWeakReference_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIWeakReference() {
        assert_eq!(
            ::std::mem::size_of::<nsIWeakReference>(),
            16usize,
            concat!("Size of: ", stringify!(nsIWeakReference))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIWeakReference>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIWeakReference))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIWeakReference>())).mObject as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWeakReference),
                "::",
                stringify!(mObject)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsISupportsWeakReference {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsISupportsWeakReference_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsISupportsWeakReference() {
        assert_eq!(
            ::std::mem::size_of::<nsISupportsWeakReference>(),
            8usize,
            concat!("Size of: ", stringify!(nsISupportsWeakReference))
        );
        assert_eq!(
            ::std::mem::align_of::<nsISupportsWeakReference>(),
            8usize,
            concat!("Alignment of ", stringify!(nsISupportsWeakReference))
        );
    }
    pub type nsWeakPtr = root::nsCOMPtr;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsWeakReference {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsSupportsWeakReference {
        pub _base: root::nsISupportsWeakReference,
        pub mProxy: *mut root::nsWeakReference,
    }
    #[test]
    fn bindgen_test_layout_nsSupportsWeakReference() {
        assert_eq!(
            ::std::mem::size_of::<nsSupportsWeakReference>(),
            16usize,
            concat!("Size of: ", stringify!(nsSupportsWeakReference))
        );
        assert_eq!(
            ::std::mem::align_of::<nsSupportsWeakReference>(),
            8usize,
            concat!("Alignment of ", stringify!(nsSupportsWeakReference))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsSupportsWeakReference>())).mProxy as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsSupportsWeakReference),
                "::",
                stringify!(mProxy)
            )
        );
    }
    pub mod xpc {
        #[allow(unused_imports)]
        use self::super::super::root;
        #[repr(C)]
        #[derive(Debug)]
        pub struct AutoScriptActivity {
            pub mActive: bool,
            pub mOldValue: bool,
        }
        #[test]
        fn bindgen_test_layout_AutoScriptActivity() {
            assert_eq!(
                ::std::mem::size_of::<AutoScriptActivity>(),
                2usize,
                concat!("Size of: ", stringify!(AutoScriptActivity))
            );
            assert_eq!(
                ::std::mem::align_of::<AutoScriptActivity>(),
                1usize,
                concat!("Alignment of ", stringify!(AutoScriptActivity))
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AutoScriptActivity>())).mActive as *const _ as usize
                },
                0usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AutoScriptActivity),
                    "::",
                    stringify!(mActive)
                )
            );
            assert_eq!(
                unsafe {
                    &(*(::std::ptr::null::<AutoScriptActivity>())).mOldValue as *const _ as usize
                },
                1usize,
                concat!(
                    "Offset of field: ",
                    stringify!(AutoScriptActivity),
                    "::",
                    stringify!(mOldValue)
                )
            );
        }
    }
    pub type nsRunnableMethod_BaseType = u8;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsRunnableMethod_ReturnTypeEnforcer {
        pub _address: u8,
    }
    pub type nsRunnableMethod_ReturnTypeEnforcer_ReturnTypeIsSafe = ::std::os::raw::c_int;
    pub type nsRunnableMethod_check = root::nsRunnableMethod_ReturnTypeEnforcer;
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsRevocableEventPtr<T> {
        pub mEvent: root::RefPtr<T>,
        pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
    }
    #[doc = " Class to safely handle main-thread-only pointers off the main thread."]
    #[doc = ""]
    #[doc = " Classes like XPCWrappedJS are main-thread-only, which means that it is"]
    #[doc = " forbidden to call methods on instances of these classes off the main thread."]
    #[doc = " For various reasons (see bug 771074), this restriction recently began to"]
    #[doc = " apply to AddRef/Release as well."]
    #[doc = ""]
    #[doc = " This presents a problem for consumers that wish to hold a callback alive"]
    #[doc = " on non-main-thread code. A common example of this is the proxy callback"]
    #[doc = " pattern, where non-main-thread code holds a strong-reference to the callback"]
    #[doc = " object, and dispatches new Runnables (also with a strong reference) to the"]
    #[doc = " main thread in order to execute the callback. This involves several AddRef"]
    #[doc = " and Release calls on the other thread, which is (now) verboten."]
    #[doc = ""]
    #[doc = " The basic idea of this class is to introduce a layer of indirection."]
    #[doc = " nsMainThreadPtrHolder is a threadsafe reference-counted class that internally"]
    #[doc = " maintains one strong reference to the main-thread-only object. It must be"]
    #[doc = " instantiated on the main thread (so that the AddRef of the underlying object"]
    #[doc = " happens on the main thread), but consumers may subsequently pass references"]
    #[doc = " to the holder anywhere they please. These references are meant to be opaque"]
    #[doc = " when accessed off-main-thread (assertions enforce this)."]
    #[doc = ""]
    #[doc = " The semantics of RefPtr<nsMainThreadPtrHolder<T> > would be cumbersome, so"]
    #[doc = " we also introduce nsMainThreadPtrHandle<T>, which is conceptually identical"]
    #[doc = " to the above (though it includes various convenience methods). The basic"]
    #[doc = " pattern is as follows."]
    #[doc = ""]
    #[doc = " // On the main thread:"]
    #[doc = " nsCOMPtr<nsIFooCallback> callback = ...;"]
    #[doc = " nsMainThreadPtrHandle<nsIFooCallback> callbackHandle ="]
    #[doc = "   new nsMainThreadPtrHolder<nsIFooCallback>(callback);"]
    #[doc = " // Pass callbackHandle to structs/classes that might be accessed on other"]
    #[doc = " // threads."]
    #[doc = ""]
    #[doc = " All structs and classes that might be accessed on other threads should store"]
    #[doc = " an nsMainThreadPtrHandle<T> rather than an nsCOMPtr<T>."]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsMainThreadPtrHolder<T> {
        pub mRefCnt: u64,
        pub mRawPtr: *mut T,
        pub mStrict: bool,
        pub mMainThreadEventTarget: root::nsCOMPtr,
        pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
    }
    pub type nsMainThreadPtrHolder_HasThreadSafeRefCnt = root::mozilla::TrueType;
    #[doc = " the private nsTHashtable::EntryType class used by nsBaseHashtable"]
    #[doc = " @see nsTHashtable for the specification of this class"]
    #[doc = " @see nsBaseHashtable for template parameters"]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsBaseHashtableET<KeyClass, DataType> {
        pub _base: KeyClass,
        pub mData: DataType,
        pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<KeyClass>>,
        pub _phantom_1: ::std::marker::PhantomData<::std::cell::UnsafeCell<DataType>>,
    }
    pub type nsBaseHashtableET_KeyType = [u8; 0usize];
    pub type nsBaseHashtableET_KeyTypePointer = [u8; 0usize];
    #[doc = " templated hashtable for simple data types"]
    #[doc = " This class manages simple data types that do not need construction or"]
    #[doc = " destruction."]
    #[doc = ""]
    #[doc = " @param KeyClass a wrapper-class for the hashtable key, see nsHashKeys.h"]
    #[doc = "   for a complete specification."]
    #[doc = " @param DataType the datatype stored in the hashtable,"]
    #[doc = "   for example, uint32_t or nsCOMPtr.  If UserDataType is not the same,"]
    #[doc = "   DataType must implicitly cast to UserDataType"]
    #[doc = " @param UserDataType the user sees, for example uint32_t or nsISupports*"]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsBaseHashtable {
        pub _address: u8,
    }
    pub type nsBaseHashtable_fallible_t = root::mozilla::fallible_t;
    pub type nsBaseHashtable_KeyType = [u8; 0usize];
    pub type nsBaseHashtable_EntryType<KeyClass, DataType> =
        root::nsBaseHashtableET<KeyClass, DataType>;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsBaseHashtable_LookupResult<KeyClass, DataType> {
        pub mEntry: *mut root::nsBaseHashtable_EntryType<KeyClass, DataType>,
        pub mTable: *mut u8,
        pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<KeyClass>>,
        pub _phantom_1: ::std::marker::PhantomData<::std::cell::UnsafeCell<DataType>>,
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsBaseHashtable_EntryPtr<KeyClass, DataType> {
        pub mEntry: *mut root::nsBaseHashtable_EntryType<KeyClass, DataType>,
        pub mExistingEntry: bool,
        pub mTable: *mut u8,
        pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<KeyClass>>,
        pub _phantom_1: ::std::marker::PhantomData<::std::cell::UnsafeCell<DataType>>,
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsBaseHashtable_Iterator {
        pub _base: root::PLDHashTable_Iterator,
    }
    pub type nsBaseHashtable_Iterator_Base = root::PLDHashTable_Iterator;
    #[doc = " templated hashtable class maps keys to reference pointers."]
    #[doc = " See nsBaseHashtable for complete declaration."]
    #[doc = " @param KeyClass a wrapper-class for the hashtable key, see nsHashKeys.h"]
    #[doc = "   for a complete specification."]
    #[doc = " @param PtrType the reference-type being wrapped"]
    #[doc = " @see nsDataHashtable, nsClassHashtable"]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsRefPtrHashtable {
        pub _address: u8,
    }
    pub type nsRefPtrHashtable_KeyType = [u8; 0usize];
    pub type nsRefPtrHashtable_UserDataType<PtrType> = *mut PtrType;
    pub type nsRefPtrHashtable_base_type = u8;
    extern "C" {
        pub fn Servo_CssUrlData_GetExtraData(
            arg1: *const root::RawServoCssUrlData,
        ) -> *mut root::mozilla::URLExtraData;
    }
    extern "C" {
        pub fn Servo_CssUrlData_IsLocalRef(url: *const root::RawServoCssUrlData) -> bool;
    }
    #[repr(u32)]
    #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
    pub enum nsCSSUnit {
        eCSSUnit_Null = 0,
        eCSSUnit_Integer = 70,
        eCSSUnit_Enumerated = 71,
        eCSSUnit_Percent = 100,
        eCSSUnit_Number = 101,
        eCSSUnit_EM = 800,
        eCSSUnit_XHeight = 801,
        eCSSUnit_Char = 802,
        eCSSUnit_RootEM = 803,
        eCSSUnit_Point = 900,
        eCSSUnit_Inch = 901,
        eCSSUnit_Millimeter = 902,
        eCSSUnit_Centimeter = 903,
        eCSSUnit_Pica = 904,
        eCSSUnit_Quarter = 905,
        eCSSUnit_Pixel = 906,
        eCSSUnit_Degree = 1000,
        eCSSUnit_Hertz = 2000,
        eCSSUnit_Kilohertz = 2001,
        eCSSUnit_Seconds = 3000,
        eCSSUnit_Milliseconds = 3001,
        eCSSUnit_FlexFraction = 4000,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsCSSValuePair_heap {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsCSSValueList {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsCSSValueList_heap {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsCSSValuePairList {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsCSSValuePairList_heap {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsCSSValue {
        pub mUnit: root::nsCSSUnit,
        pub mValue: root::nsCSSValue__bindgen_ty_1,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsCSSValue__bindgen_ty_1 {
        pub mInt: root::__BindgenUnionField<i32>,
        pub mFloat: root::__BindgenUnionField<f32>,
        pub bindgen_union_field: u32,
    }
    #[test]
    fn bindgen_test_layout_nsCSSValue__bindgen_ty_1() {
        assert_eq!(
            ::std::mem::size_of::<nsCSSValue__bindgen_ty_1>(),
            4usize,
            concat!("Size of: ", stringify!(nsCSSValue__bindgen_ty_1))
        );
        assert_eq!(
            ::std::mem::align_of::<nsCSSValue__bindgen_ty_1>(),
            4usize,
            concat!("Alignment of ", stringify!(nsCSSValue__bindgen_ty_1))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsCSSValue__bindgen_ty_1>())).mInt as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCSSValue__bindgen_ty_1),
                "::",
                stringify!(mInt)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsCSSValue__bindgen_ty_1>())).mFloat as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCSSValue__bindgen_ty_1),
                "::",
                stringify!(mFloat)
            )
        );
    }
    #[test]
    fn bindgen_test_layout_nsCSSValue() {
        assert_eq!(
            ::std::mem::size_of::<nsCSSValue>(),
            8usize,
            concat!("Size of: ", stringify!(nsCSSValue))
        );
        assert_eq!(
            ::std::mem::align_of::<nsCSSValue>(),
            4usize,
            concat!("Alignment of ", stringify!(nsCSSValue))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsCSSValue>())).mUnit as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCSSValue),
                "::",
                stringify!(mUnit)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsCSSValue>())).mValue as *const _ as usize },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCSSValue),
                "::",
                stringify!(mValue)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct imgIRequest {
        pub _base: root::nsIRequest,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct imgIRequest_COMTypeInfo {
        pub _address: u8,
    }
    pub const imgIRequest_STATUS_NONE: root::imgIRequest__bindgen_ty_1 = 0;
    pub const imgIRequest_STATUS_SIZE_AVAILABLE: root::imgIRequest__bindgen_ty_1 = 1;
    pub const imgIRequest_STATUS_LOAD_COMPLETE: root::imgIRequest__bindgen_ty_1 = 2;
    pub const imgIRequest_STATUS_ERROR: root::imgIRequest__bindgen_ty_1 = 4;
    pub const imgIRequest_STATUS_FRAME_COMPLETE: root::imgIRequest__bindgen_ty_1 = 8;
    pub const imgIRequest_STATUS_DECODE_COMPLETE: root::imgIRequest__bindgen_ty_1 = 16;
    pub const imgIRequest_STATUS_IS_ANIMATED: root::imgIRequest__bindgen_ty_1 = 32;
    pub const imgIRequest_STATUS_HAS_TRANSPARENCY: root::imgIRequest__bindgen_ty_1 = 64;
    pub type imgIRequest__bindgen_ty_1 = u32;
    pub const imgIRequest_CORS_NONE: root::imgIRequest__bindgen_ty_2 = 1;
    pub const imgIRequest_CORS_ANONYMOUS: root::imgIRequest__bindgen_ty_2 = 2;
    pub const imgIRequest_CORS_USE_CREDENTIALS: root::imgIRequest__bindgen_ty_2 = 3;
    pub type imgIRequest__bindgen_ty_2 = u32;
    pub const imgIRequest_CATEGORY_FRAME_INIT: root::imgIRequest__bindgen_ty_3 = 1;
    pub const imgIRequest_CATEGORY_FRAME_STYLE: root::imgIRequest__bindgen_ty_3 = 2;
    pub const imgIRequest_CATEGORY_SIZE_QUERY: root::imgIRequest__bindgen_ty_3 = 4;
    pub const imgIRequest_CATEGORY_DISPLAY: root::imgIRequest__bindgen_ty_3 = 8;
    pub type imgIRequest__bindgen_ty_3 = u32;
    #[test]
    fn bindgen_test_layout_imgIRequest() {
        assert_eq!(
            ::std::mem::size_of::<imgIRequest>(),
            8usize,
            concat!("Size of: ", stringify!(imgIRequest))
        );
        assert_eq!(
            ::std::mem::align_of::<imgIRequest>(),
            8usize,
            concat!("Alignment of ", stringify!(imgIRequest))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsILoadGroup {
        pub _base: root::nsIRequest,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsILoadGroup_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsILoadGroup() {
        assert_eq!(
            ::std::mem::size_of::<nsILoadGroup>(),
            8usize,
            concat!("Size of: ", stringify!(nsILoadGroup))
        );
        assert_eq!(
            ::std::mem::align_of::<nsILoadGroup>(),
            8usize,
            concat!("Alignment of ", stringify!(nsILoadGroup))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsISupportsPriority {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsISupportsPriority_COMTypeInfo {
        pub _address: u8,
    }
    pub const nsISupportsPriority_PRIORITY_HIGHEST: root::nsISupportsPriority__bindgen_ty_1 = -20;
    pub const nsISupportsPriority_PRIORITY_HIGH: root::nsISupportsPriority__bindgen_ty_1 = -10;
    pub const nsISupportsPriority_PRIORITY_NORMAL: root::nsISupportsPriority__bindgen_ty_1 = 0;
    pub const nsISupportsPriority_PRIORITY_LOW: root::nsISupportsPriority__bindgen_ty_1 = 10;
    pub const nsISupportsPriority_PRIORITY_LOWEST: root::nsISupportsPriority__bindgen_ty_1 = 20;
    pub type nsISupportsPriority__bindgen_ty_1 = i32;
    #[test]
    fn bindgen_test_layout_nsISupportsPriority() {
        assert_eq!(
            ::std::mem::size_of::<nsISupportsPriority>(),
            8usize,
            concat!("Size of: ", stringify!(nsISupportsPriority))
        );
        assert_eq!(
            ::std::mem::align_of::<nsISupportsPriority>(),
            8usize,
            concat!("Alignment of ", stringify!(nsISupportsPriority))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsITimedChannel {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsITimedChannel_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsITimedChannel() {
        assert_eq!(
            ::std::mem::size_of::<nsITimedChannel>(),
            8usize,
            concat!("Size of: ", stringify!(nsITimedChannel))
        );
        assert_eq!(
            ::std::mem::align_of::<nsITimedChannel>(),
            8usize,
            concat!("Alignment of ", stringify!(nsITimedChannel))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIChannelEventSink {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIChannelEventSink_COMTypeInfo {
        pub _address: u8,
    }
    pub const nsIChannelEventSink_REDIRECT_TEMPORARY: root::nsIChannelEventSink__bindgen_ty_1 = 1;
    pub const nsIChannelEventSink_REDIRECT_PERMANENT: root::nsIChannelEventSink__bindgen_ty_1 = 2;
    pub const nsIChannelEventSink_REDIRECT_INTERNAL: root::nsIChannelEventSink__bindgen_ty_1 = 4;
    pub const nsIChannelEventSink_REDIRECT_STS_UPGRADE: root::nsIChannelEventSink__bindgen_ty_1 = 8;
    pub type nsIChannelEventSink__bindgen_ty_1 = u32;
    #[test]
    fn bindgen_test_layout_nsIChannelEventSink() {
        assert_eq!(
            ::std::mem::size_of::<nsIChannelEventSink>(),
            8usize,
            concat!("Size of: ", stringify!(nsIChannelEventSink))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIChannelEventSink>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIChannelEventSink))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIInterfaceRequestor {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIInterfaceRequestor_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIInterfaceRequestor() {
        assert_eq!(
            ::std::mem::size_of::<nsIInterfaceRequestor>(),
            8usize,
            concat!("Size of: ", stringify!(nsIInterfaceRequestor))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIInterfaceRequestor>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIInterfaceRequestor))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIRequestObserver {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIRequestObserver_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIRequestObserver() {
        assert_eq!(
            ::std::mem::size_of::<nsIRequestObserver>(),
            8usize,
            concat!("Size of: ", stringify!(nsIRequestObserver))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIRequestObserver>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIRequestObserver))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIStreamListener {
        pub _base: root::nsIRequestObserver,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIStreamListener_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIStreamListener() {
        assert_eq!(
            ::std::mem::size_of::<nsIStreamListener>(),
            8usize,
            concat!("Size of: ", stringify!(nsIStreamListener))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIStreamListener>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIStreamListener))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct ProxyBehaviour {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct imgRequestProxy {
        pub _base: root::imgIRequest,
        pub _base_1: root::mozilla::image::IProgressObserver,
        pub _base_2: root::nsISupportsPriority,
        pub _base_3: root::nsITimedChannel,
        pub mRefCnt: root::nsAutoRefCnt,
        pub mBehaviour: root::mozilla::UniquePtr<root::ProxyBehaviour>,
        pub mURI: root::nsCOMPtr,
        pub mListener: *mut root::imgINotificationObserver,
        pub mLoadGroup: root::nsCOMPtr,
        pub mTabGroup: root::RefPtr<root::mozilla::dom::TabGroup>,
        pub mEventTarget: root::nsCOMPtr,
        pub mLoadFlags: root::nsLoadFlags,
        pub mLockCount: u32,
        pub mAnimationConsumers: u32,
        pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 2usize], u8>,
        pub __bindgen_padding_0: u16,
    }
    pub type imgRequestProxy_Document = root::mozilla::dom::Document;
    pub type imgRequestProxy_Image = root::mozilla::image::Image;
    pub type imgRequestProxy_ProgressTracker = root::mozilla::image::ProgressTracker;
    pub type imgRequestProxy_HasThreadSafeRefCnt = root::mozilla::FalseType;
    #[repr(C)]
    #[derive(Debug)]
    pub struct imgRequestProxy_imgCancelRunnable {
        pub _base: root::mozilla::Runnable,
        pub mOwner: root::RefPtr<root::imgRequestProxy>,
        pub mStatus: root::nsresult,
    }
    #[test]
    fn bindgen_test_layout_imgRequestProxy_imgCancelRunnable() {
        assert_eq!(
            ::std::mem::size_of::<imgRequestProxy_imgCancelRunnable>(),
            32usize,
            concat!("Size of: ", stringify!(imgRequestProxy_imgCancelRunnable))
        );
        assert_eq!(
            ::std::mem::align_of::<imgRequestProxy_imgCancelRunnable>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(imgRequestProxy_imgCancelRunnable)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<imgRequestProxy_imgCancelRunnable>())).mOwner as *const _
                    as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(imgRequestProxy_imgCancelRunnable),
                "::",
                stringify!(mOwner)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<imgRequestProxy_imgCancelRunnable>())).mStatus as *const _
                    as usize
            },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(imgRequestProxy_imgCancelRunnable),
                "::",
                stringify!(mStatus)
            )
        );
    }
    #[test]
    fn bindgen_test_layout_imgRequestProxy() {
        assert_eq!(
            ::std::mem::size_of::<imgRequestProxy>(),
            112usize,
            concat!("Size of: ", stringify!(imgRequestProxy))
        );
        assert_eq!(
            ::std::mem::align_of::<imgRequestProxy>(),
            8usize,
            concat!("Alignment of ", stringify!(imgRequestProxy))
        );
    }
    impl imgRequestProxy {
        #[inline]
        pub fn mCanceled(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mCanceled(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(0usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mIsInLoadGroup(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mIsInLoadGroup(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(1usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mForceDispatchLoadGroup(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mForceDispatchLoadGroup(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(2usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mListenerIsStrongRef(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mListenerIsStrongRef(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(3usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mDecodeRequested(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mDecodeRequested(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(4usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mPendingNotify(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mPendingNotify(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(5usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mValidating(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mValidating(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(6usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mHadListener(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mHadListener(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(7usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mHadDispatch(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mHadDispatch(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(8usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn new_bitfield_1(
            mCanceled: bool,
            mIsInLoadGroup: bool,
            mForceDispatchLoadGroup: bool,
            mListenerIsStrongRef: bool,
            mDecodeRequested: bool,
            mPendingNotify: bool,
            mValidating: bool,
            mHadListener: bool,
            mHadDispatch: bool,
        ) -> root::__BindgenBitfieldUnit<[u8; 2usize], u8> {
            let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 2usize], u8> =
                Default::default();
            __bindgen_bitfield_unit.set(0usize, 1u8, {
                let mCanceled: u8 = unsafe { ::std::mem::transmute(mCanceled) };
                mCanceled as u64
            });
            __bindgen_bitfield_unit.set(1usize, 1u8, {
                let mIsInLoadGroup: u8 = unsafe { ::std::mem::transmute(mIsInLoadGroup) };
                mIsInLoadGroup as u64
            });
            __bindgen_bitfield_unit.set(2usize, 1u8, {
                let mForceDispatchLoadGroup: u8 =
                    unsafe { ::std::mem::transmute(mForceDispatchLoadGroup) };
                mForceDispatchLoadGroup as u64
            });
            __bindgen_bitfield_unit.set(3usize, 1u8, {
                let mListenerIsStrongRef: u8 =
                    unsafe { ::std::mem::transmute(mListenerIsStrongRef) };
                mListenerIsStrongRef as u64
            });
            __bindgen_bitfield_unit.set(4usize, 1u8, {
                let mDecodeRequested: u8 = unsafe { ::std::mem::transmute(mDecodeRequested) };
                mDecodeRequested as u64
            });
            __bindgen_bitfield_unit.set(5usize, 1u8, {
                let mPendingNotify: u8 = unsafe { ::std::mem::transmute(mPendingNotify) };
                mPendingNotify as u64
            });
            __bindgen_bitfield_unit.set(6usize, 1u8, {
                let mValidating: u8 = unsafe { ::std::mem::transmute(mValidating) };
                mValidating as u64
            });
            __bindgen_bitfield_unit.set(7usize, 1u8, {
                let mHadListener: u8 = unsafe { ::std::mem::transmute(mHadListener) };
                mHadListener as u64
            });
            __bindgen_bitfield_unit.set(8usize, 1u8, {
                let mHadDispatch: u8 = unsafe { ::std::mem::transmute(mHadDispatch) };
                mHadDispatch as u64
            });
            __bindgen_bitfield_unit
        }
    }
    #[doc = " templated hashtable class maps keys to simple datatypes."]
    #[doc = " See nsBaseHashtable for complete declaration"]
    #[doc = " @param KeyClass a wrapper-class for the hashtable key, see nsHashKeys.h"]
    #[doc = "   for a complete specification."]
    #[doc = " @param DataType the simple datatype being wrapped"]
    #[doc = " @see nsInterfaceHashtable, nsClassHashtable"]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsDataHashtable {
        pub _address: u8,
    }
    pub type nsDataHashtable_BaseClass = u8;
    #[repr(C)]
    pub struct nsStyleFont {
        pub mFont: root::nsFont,
        pub mSize: root::nscoord,
        pub mFontSizeFactor: f32,
        pub mFontSizeOffset: root::nscoord,
        pub mFontSizeKeyword: u8,
        pub mGenericID: root::mozilla::StyleGenericFontFamily,
        pub mScriptLevel: i8,
        pub mMathVariant: u8,
        pub mMathDisplay: u8,
        pub mMinFontSizeRatio: u8,
        pub mExplicitLanguage: bool,
        pub mAllowZoom: bool,
        pub mScriptUnconstrainedSize: root::nscoord,
        pub mScriptMinSize: root::nscoord,
        pub mScriptSizeMultiplier: f32,
        pub mLanguage: root::RefPtr<root::nsAtom>,
    }
    pub const nsStyleFont_kHasTriggerImageLoads: bool = false;
    #[test]
    fn bindgen_test_layout_nsStyleFont() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleFont>(),
            120usize,
            concat!("Size of: ", stringify!(nsStyleFont))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleFont>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleFont))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleFont>())).mFont as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFont),
                "::",
                stringify!(mFont)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleFont>())).mSize as *const _ as usize },
            80usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFont),
                "::",
                stringify!(mSize)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleFont>())).mFontSizeFactor as *const _ as usize },
            84usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFont),
                "::",
                stringify!(mFontSizeFactor)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleFont>())).mFontSizeOffset as *const _ as usize },
            88usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFont),
                "::",
                stringify!(mFontSizeOffset)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleFont>())).mFontSizeKeyword as *const _ as usize
            },
            92usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFont),
                "::",
                stringify!(mFontSizeKeyword)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleFont>())).mGenericID as *const _ as usize },
            93usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFont),
                "::",
                stringify!(mGenericID)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleFont>())).mScriptLevel as *const _ as usize },
            94usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFont),
                "::",
                stringify!(mScriptLevel)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleFont>())).mMathVariant as *const _ as usize },
            95usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFont),
                "::",
                stringify!(mMathVariant)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleFont>())).mMathDisplay as *const _ as usize },
            96usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFont),
                "::",
                stringify!(mMathDisplay)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleFont>())).mMinFontSizeRatio as *const _ as usize
            },
            97usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFont),
                "::",
                stringify!(mMinFontSizeRatio)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleFont>())).mExplicitLanguage as *const _ as usize
            },
            98usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFont),
                "::",
                stringify!(mExplicitLanguage)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleFont>())).mAllowZoom as *const _ as usize },
            99usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFont),
                "::",
                stringify!(mAllowZoom)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleFont>())).mScriptUnconstrainedSize as *const _
                    as usize
            },
            100usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFont),
                "::",
                stringify!(mScriptUnconstrainedSize)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleFont>())).mScriptMinSize as *const _ as usize },
            104usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFont),
                "::",
                stringify!(mScriptMinSize)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleFont>())).mScriptSizeMultiplier as *const _ as usize
            },
            108usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFont),
                "::",
                stringify!(mScriptSizeMultiplier)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleFont>())).mLanguage as *const _ as usize },
            112usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFont),
                "::",
                stringify!(mLanguage)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleGradient {
        pub mShape: u8,
        pub mSize: u8,
        pub mRepeating: bool,
        pub mLegacySyntax: bool,
        pub mMozLegacySyntax: bool,
        pub mBgPosX: root::nsStyleCoord,
        pub mBgPosY: root::nsStyleCoord,
        pub mAngle: root::nsStyleCoord,
        pub mRadiusX: root::nsStyleCoord,
        pub mRadiusY: root::nsStyleCoord,
        pub mStops: root::nsTArray<root::mozilla::StyleGradientItem>,
        pub mRefCnt: u64,
    }
    pub type nsStyleGradient_HasThreadSafeRefCnt = root::mozilla::TrueType;
    #[test]
    fn bindgen_test_layout_nsStyleGradient() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleGradient>(),
            104usize,
            concat!("Size of: ", stringify!(nsStyleGradient))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleGradient>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleGradient))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleGradient>())).mShape as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGradient),
                "::",
                stringify!(mShape)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleGradient>())).mSize as *const _ as usize },
            1usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGradient),
                "::",
                stringify!(mSize)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleGradient>())).mRepeating as *const _ as usize },
            2usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGradient),
                "::",
                stringify!(mRepeating)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleGradient>())).mLegacySyntax as *const _ as usize
            },
            3usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGradient),
                "::",
                stringify!(mLegacySyntax)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleGradient>())).mMozLegacySyntax as *const _ as usize
            },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGradient),
                "::",
                stringify!(mMozLegacySyntax)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleGradient>())).mBgPosX as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGradient),
                "::",
                stringify!(mBgPosX)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleGradient>())).mBgPosY as *const _ as usize },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGradient),
                "::",
                stringify!(mBgPosY)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleGradient>())).mAngle as *const _ as usize },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGradient),
                "::",
                stringify!(mAngle)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleGradient>())).mRadiusX as *const _ as usize },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGradient),
                "::",
                stringify!(mRadiusX)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleGradient>())).mRadiusY as *const _ as usize },
            72usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGradient),
                "::",
                stringify!(mRadiusY)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleGradient>())).mStops as *const _ as usize },
            88usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGradient),
                "::",
                stringify!(mStops)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleGradient>())).mRefCnt as *const _ as usize },
            96usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGradient),
                "::",
                stringify!(mRefCnt)
            )
        );
    }
    #[doc = " A wrapper for an imgRequestProxy that supports off-main-thread creation"]
    #[doc = " and equality comparison."]
    #[doc = ""]
    #[doc = " An nsStyleImageRequest can be created using the constructor that takes the"]
    #[doc = " URL, base URI, referrer and principal that can be used to initiate an image"]
    #[doc = " load and produce an imgRequestProxy later."]
    #[doc = ""]
    #[doc = " This can be called from any thread.  The nsStyleImageRequest is not"]
    #[doc = " considered \"resolved\" at this point, and the Resolve() method must be called"]
    #[doc = " later to initiate the image load and make calls to get() valid."]
    #[doc = ""]
    #[doc = " Calls to TrackImage(), UntrackImage(), LockImage(), UnlockImage() and"]
    #[doc = " RequestDiscard() are made to the imgRequestProxy and ImageTracker as"]
    #[doc = " appropriate, according to the mode flags passed in to the constructor."]
    #[doc = ""]
    #[doc = " The constructor receives a css::URLValue to represent the url()"]
    #[doc = " information, which is held on to for the comparisons done in"]
    #[doc = " DefinitelyEquals()."]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsStyleImageRequest {
        pub mRefCnt: u64,
        pub mRequestProxy: root::RefPtr<root::imgRequestProxy>,
        pub mImageValue: root::RefPtr<root::mozilla::css::URLValue>,
        pub mImageTracker: root::RefPtr<root::mozilla::dom::ImageTracker>,
        pub mDocGroup: root::RefPtr<root::mozilla::dom::DocGroup>,
        pub mModeFlags: root::nsStyleImageRequest_Mode,
        pub mResolved: bool,
    }
    pub const nsStyleImageRequest_Mode_Track: root::nsStyleImageRequest_Mode = 1;
    pub const nsStyleImageRequest_Mode_Discard: root::nsStyleImageRequest_Mode = 2;
    pub type nsStyleImageRequest_Mode = u8;
    pub type nsStyleImageRequest_HasThreadSafeRefCnt = root::mozilla::TrueType;
    #[test]
    fn bindgen_test_layout_nsStyleImageRequest() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleImageRequest>(),
            48usize,
            concat!("Size of: ", stringify!(nsStyleImageRequest))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleImageRequest>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleImageRequest))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleImageRequest>())).mRefCnt as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageRequest),
                "::",
                stringify!(mRefCnt)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageRequest>())).mRequestProxy as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageRequest),
                "::",
                stringify!(mRequestProxy)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageRequest>())).mImageValue as *const _ as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageRequest),
                "::",
                stringify!(mImageValue)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageRequest>())).mImageTracker as *const _ as usize
            },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageRequest),
                "::",
                stringify!(mImageTracker)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageRequest>())).mDocGroup as *const _ as usize
            },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageRequest),
                "::",
                stringify!(mDocGroup)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageRequest>())).mModeFlags as *const _ as usize
            },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageRequest),
                "::",
                stringify!(mModeFlags)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageRequest>())).mResolved as *const _ as usize
            },
            41usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageRequest),
                "::",
                stringify!(mResolved)
            )
        );
    }
    #[repr(u32)]
    #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
    pub enum nsStyleImageType {
        eStyleImageType_Null = 0,
        eStyleImageType_Image = 1,
        eStyleImageType_Gradient = 2,
        eStyleImageType_Element = 3,
        eStyleImageType_URL = 4,
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct CachedBorderImageData {
        pub mCachedSVGViewportSize: [u32; 3usize],
        pub mSubImages: root::nsCOMArray,
    }
    #[test]
    fn bindgen_test_layout_CachedBorderImageData() {
        assert_eq!(
            ::std::mem::size_of::<CachedBorderImageData>(),
            24usize,
            concat!("Size of: ", stringify!(CachedBorderImageData))
        );
        assert_eq!(
            ::std::mem::align_of::<CachedBorderImageData>(),
            8usize,
            concat!("Alignment of ", stringify!(CachedBorderImageData))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<CachedBorderImageData>())).mCachedSVGViewportSize as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(CachedBorderImageData),
                "::",
                stringify!(mCachedSVGViewportSize)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<CachedBorderImageData>())).mSubImages as *const _ as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(CachedBorderImageData),
                "::",
                stringify!(mSubImages)
            )
        );
    }
    #[doc = " Represents a paintable image of one of the following types."]
    #[doc = " (1) A real image loaded from an external source."]
    #[doc = " (2) A CSS linear or radial gradient."]
    #[doc = " (3) An element within a document, or an <img>, <video>, or <canvas> element"]
    #[doc = "     not in a document."]
    #[doc = " (*) Optionally a crop rect can be set to paint a partial (rectangular)"]
    #[doc = " region of an image. (Currently, this feature is only supported with an"]
    #[doc = " image of type (1))."]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsStyleImage {
        pub mCachedBIData: root::mozilla::UniquePtr<root::CachedBorderImageData>,
        pub mType: root::nsStyleImageType,
        pub __bindgen_anon_1: root::nsStyleImage__bindgen_ty_1,
        pub mCropRect: root::mozilla::UniquePtr<root::nsStyleSides>,
    }
    pub type nsStyleImage_URLValue = root::mozilla::css::URLValue;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsStyleImage__bindgen_ty_1 {
        pub mImage: root::__BindgenUnionField<*mut root::nsStyleImageRequest>,
        pub mGradient: root::__BindgenUnionField<*mut root::nsStyleGradient>,
        pub mURLValue: root::__BindgenUnionField<*const root::nsStyleImage_URLValue>,
        pub mElementId: root::__BindgenUnionField<*mut root::nsAtom>,
        pub bindgen_union_field: u64,
    }
    #[test]
    fn bindgen_test_layout_nsStyleImage__bindgen_ty_1() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleImage__bindgen_ty_1>(),
            8usize,
            concat!("Size of: ", stringify!(nsStyleImage__bindgen_ty_1))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleImage__bindgen_ty_1>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleImage__bindgen_ty_1))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImage__bindgen_ty_1>())).mImage as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImage__bindgen_ty_1),
                "::",
                stringify!(mImage)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImage__bindgen_ty_1>())).mGradient as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImage__bindgen_ty_1),
                "::",
                stringify!(mGradient)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImage__bindgen_ty_1>())).mURLValue as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImage__bindgen_ty_1),
                "::",
                stringify!(mURLValue)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImage__bindgen_ty_1>())).mElementId as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImage__bindgen_ty_1),
                "::",
                stringify!(mElementId)
            )
        );
    }
    #[test]
    fn bindgen_test_layout_nsStyleImage() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleImage>(),
            32usize,
            concat!("Size of: ", stringify!(nsStyleImage))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleImage>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleImage))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleImage>())).mCachedBIData as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImage),
                "::",
                stringify!(mCachedBIData)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleImage>())).mType as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImage),
                "::",
                stringify!(mType)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleImage>())).mCropRect as *const _ as usize },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImage),
                "::",
                stringify!(mCropRect)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleColor {
        pub mColor: root::mozilla::StyleRGBA,
    }
    pub const nsStyleColor_kHasTriggerImageLoads: bool = false;
    #[test]
    fn bindgen_test_layout_nsStyleColor() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleColor>(),
            4usize,
            concat!("Size of: ", stringify!(nsStyleColor))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleColor>(),
            1usize,
            concat!("Alignment of ", stringify!(nsStyleColor))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleColor>())).mColor as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleColor),
                "::",
                stringify!(mColor)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleImageLayers {
        pub mAttachmentCount: u32,
        pub mClipCount: u32,
        pub mOriginCount: u32,
        pub mRepeatCount: u32,
        pub mPositionXCount: u32,
        pub mPositionYCount: u32,
        pub mImageCount: u32,
        pub mSizeCount: u32,
        pub mMaskModeCount: u32,
        pub mBlendModeCount: u32,
        pub mCompositeCount: u32,
        pub mLayers: root::nsStyleAutoArray<root::nsStyleImageLayers_Layer>,
    }
    pub const nsStyleImageLayers_shorthand: root::nsStyleImageLayers__bindgen_ty_1 = 0;
    pub const nsStyleImageLayers_color: root::nsStyleImageLayers__bindgen_ty_1 = 1;
    pub const nsStyleImageLayers_image: root::nsStyleImageLayers__bindgen_ty_1 = 2;
    pub const nsStyleImageLayers_repeat: root::nsStyleImageLayers__bindgen_ty_1 = 3;
    pub const nsStyleImageLayers_positionX: root::nsStyleImageLayers__bindgen_ty_1 = 4;
    pub const nsStyleImageLayers_positionY: root::nsStyleImageLayers__bindgen_ty_1 = 5;
    pub const nsStyleImageLayers_clip: root::nsStyleImageLayers__bindgen_ty_1 = 6;
    pub const nsStyleImageLayers_origin: root::nsStyleImageLayers__bindgen_ty_1 = 7;
    pub const nsStyleImageLayers_size: root::nsStyleImageLayers__bindgen_ty_1 = 8;
    pub const nsStyleImageLayers_attachment: root::nsStyleImageLayers__bindgen_ty_1 = 9;
    pub const nsStyleImageLayers_maskMode: root::nsStyleImageLayers__bindgen_ty_1 = 10;
    pub const nsStyleImageLayers_composite: root::nsStyleImageLayers__bindgen_ty_1 = 11;
    pub type nsStyleImageLayers__bindgen_ty_1 = u32;
    #[repr(u8)]
    #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
    pub enum nsStyleImageLayers_LayerType {
        Background = 0,
        Mask = 1,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsStyleImageLayers_Repeat {
        pub mXRepeat: root::mozilla::StyleImageLayerRepeat,
        pub mYRepeat: root::mozilla::StyleImageLayerRepeat,
    }
    #[test]
    fn bindgen_test_layout_nsStyleImageLayers_Repeat() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleImageLayers_Repeat>(),
            2usize,
            concat!("Size of: ", stringify!(nsStyleImageLayers_Repeat))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleImageLayers_Repeat>(),
            1usize,
            concat!("Alignment of ", stringify!(nsStyleImageLayers_Repeat))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers_Repeat>())).mXRepeat as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers_Repeat),
                "::",
                stringify!(mXRepeat)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers_Repeat>())).mYRepeat as *const _ as usize
            },
            1usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers_Repeat),
                "::",
                stringify!(mYRepeat)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleImageLayers_Layer {
        pub mImage: root::nsStyleImage,
        pub mPosition: root::mozilla::Position,
        pub mSize: root::nsStyleImageLayers_Layer_StyleBackgroundSize,
        pub mClip: root::nsStyleImageLayers_Layer_StyleGeometryBox,
        pub mOrigin: root::nsStyleImageLayers_Layer_StyleGeometryBox,
        pub mAttachment: root::nsStyleImageLayers_Layer_StyleImageLayerAttachment,
        pub mBlendMode: u8,
        pub mComposite: u8,
        pub mMaskMode: root::mozilla::StyleMaskMode,
        pub mRepeat: root::nsStyleImageLayers_Repeat,
    }
    pub use self::super::root::mozilla::StyleGeometryBox as nsStyleImageLayers_Layer_StyleGeometryBox;
    pub use self::super::root::mozilla::StyleImageLayerAttachment as nsStyleImageLayers_Layer_StyleImageLayerAttachment;
    pub type nsStyleImageLayers_Layer_StyleBackgroundSize = root::mozilla::StyleBackgroundSize;
    #[test]
    fn bindgen_test_layout_nsStyleImageLayers_Layer() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleImageLayers_Layer>(),
            104usize,
            concat!("Size of: ", stringify!(nsStyleImageLayers_Layer))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleImageLayers_Layer>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleImageLayers_Layer))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers_Layer>())).mImage as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers_Layer),
                "::",
                stringify!(mImage)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers_Layer>())).mPosition as *const _ as usize
            },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers_Layer),
                "::",
                stringify!(mPosition)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers_Layer>())).mSize as *const _ as usize
            },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers_Layer),
                "::",
                stringify!(mSize)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers_Layer>())).mClip as *const _ as usize
            },
            92usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers_Layer),
                "::",
                stringify!(mClip)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers_Layer>())).mOrigin as *const _ as usize
            },
            93usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers_Layer),
                "::",
                stringify!(mOrigin)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers_Layer>())).mAttachment as *const _
                    as usize
            },
            94usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers_Layer),
                "::",
                stringify!(mAttachment)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers_Layer>())).mBlendMode as *const _ as usize
            },
            95usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers_Layer),
                "::",
                stringify!(mBlendMode)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers_Layer>())).mComposite as *const _ as usize
            },
            96usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers_Layer),
                "::",
                stringify!(mComposite)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers_Layer>())).mMaskMode as *const _ as usize
            },
            97usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers_Layer),
                "::",
                stringify!(mMaskMode)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers_Layer>())).mRepeat as *const _ as usize
            },
            98usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers_Layer),
                "::",
                stringify!(mRepeat)
            )
        );
    }
    extern "C" {
        #[link_name = "\u{1}_ZN18nsStyleImageLayers21kBackgroundLayerTableE"]
        pub static mut nsStyleImageLayers_kBackgroundLayerTable: [root::nsCSSPropertyID; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN18nsStyleImageLayers15kMaskLayerTableE"]
        pub static mut nsStyleImageLayers_kMaskLayerTable: [root::nsCSSPropertyID; 0usize];
    }
    #[test]
    fn bindgen_test_layout_nsStyleImageLayers() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleImageLayers>(),
            160usize,
            concat!("Size of: ", stringify!(nsStyleImageLayers))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleImageLayers>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleImageLayers))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers>())).mAttachmentCount as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers),
                "::",
                stringify!(mAttachmentCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers>())).mClipCount as *const _ as usize
            },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers),
                "::",
                stringify!(mClipCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers>())).mOriginCount as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers),
                "::",
                stringify!(mOriginCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers>())).mRepeatCount as *const _ as usize
            },
            12usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers),
                "::",
                stringify!(mRepeatCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers>())).mPositionXCount as *const _ as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers),
                "::",
                stringify!(mPositionXCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers>())).mPositionYCount as *const _ as usize
            },
            20usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers),
                "::",
                stringify!(mPositionYCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers>())).mImageCount as *const _ as usize
            },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers),
                "::",
                stringify!(mImageCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers>())).mSizeCount as *const _ as usize
            },
            28usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers),
                "::",
                stringify!(mSizeCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers>())).mMaskModeCount as *const _ as usize
            },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers),
                "::",
                stringify!(mMaskModeCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers>())).mBlendModeCount as *const _ as usize
            },
            36usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers),
                "::",
                stringify!(mBlendModeCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleImageLayers>())).mCompositeCount as *const _ as usize
            },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers),
                "::",
                stringify!(mCompositeCount)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleImageLayers>())).mLayers as *const _ as usize },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleImageLayers),
                "::",
                stringify!(mLayers)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleBackground {
        pub mImage: root::nsStyleImageLayers,
        pub mBackgroundColor: root::mozilla::StyleColor,
    }
    pub const nsStyleBackground_kHasTriggerImageLoads: bool = true;
    #[test]
    fn bindgen_test_layout_nsStyleBackground() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleBackground>(),
            176usize,
            concat!("Size of: ", stringify!(nsStyleBackground))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleBackground>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleBackground))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleBackground>())).mImage as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBackground),
                "::",
                stringify!(mImage)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleBackground>())).mBackgroundColor as *const _ as usize
            },
            160usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBackground),
                "::",
                stringify!(mBackgroundColor)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleMargin {
        pub mMargin: root::mozilla::StyleRect<root::mozilla::LengthPercentageOrAuto>,
        pub mScrollMargin: root::mozilla::StyleRect<root::mozilla::StyleLength>,
    }
    pub const nsStyleMargin_kHasTriggerImageLoads: bool = false;
    #[test]
    fn bindgen_test_layout_nsStyleMargin() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleMargin>(),
            80usize,
            concat!("Size of: ", stringify!(nsStyleMargin))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleMargin>(),
            4usize,
            concat!("Alignment of ", stringify!(nsStyleMargin))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleMargin>())).mMargin as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleMargin),
                "::",
                stringify!(mMargin)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleMargin>())).mScrollMargin as *const _ as usize },
            64usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleMargin),
                "::",
                stringify!(mScrollMargin)
            )
        );
    }
    #[repr(C)]
    pub struct nsStylePadding {
        pub mPadding: root::mozilla::StyleRect<root::mozilla::NonNegativeLengthPercentage>,
        pub mScrollPadding:
            root::mozilla::StyleRect<root::mozilla::NonNegativeLengthPercentageOrAuto>,
    }
    pub const nsStylePadding_kHasTriggerImageLoads: bool = false;
    #[test]
    fn bindgen_test_layout_nsStylePadding() {
        assert_eq!(
            ::std::mem::size_of::<nsStylePadding>(),
            112usize,
            concat!("Size of: ", stringify!(nsStylePadding))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStylePadding>(),
            4usize,
            concat!("Alignment of ", stringify!(nsStylePadding))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePadding>())).mPadding as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePadding),
                "::",
                stringify!(mPadding)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePadding>())).mScrollPadding as *const _ as usize
            },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePadding),
                "::",
                stringify!(mScrollPadding)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleBorder {
        pub mBorderRadius: root::mozilla::StyleBorderRadius,
        pub mBorderImageSource: root::nsStyleImage,
        pub mBorderImageWidth: root::nsStyleSides,
        pub mBorderImageOutset: root::mozilla::StyleNonNegativeLengthOrNumberRect,
        pub mBorderImageSlice: root::mozilla::StyleBorderImageSlice,
        pub mBorderImageRepeatH: root::mozilla::StyleBorderImageRepeat,
        pub mBorderImageRepeatV: root::mozilla::StyleBorderImageRepeat,
        pub mFloatEdge: root::mozilla::StyleFloatEdge,
        pub mBoxDecorationBreak: root::mozilla::StyleBoxDecorationBreak,
        pub mBorderStyle: [root::mozilla::StyleBorderStyle; 4usize],
        pub mBorderTopColor: root::mozilla::StyleColor,
        pub mBorderRightColor: root::mozilla::StyleColor,
        pub mBorderBottomColor: root::mozilla::StyleColor,
        pub mBorderLeftColor: root::mozilla::StyleColor,
        pub mComputedBorder: root::nsMargin,
        pub mBorder: root::nsMargin,
        pub mTwipsPerPixel: root::nscoord,
    }
    pub const nsStyleBorder_kHasTriggerImageLoads: bool = true;
    #[test]
    fn bindgen_test_layout_nsStyleBorder() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleBorder>(),
            344usize,
            concat!("Size of: ", stringify!(nsStyleBorder))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleBorder>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleBorder))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleBorder>())).mBorderRadius as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBorder),
                "::",
                stringify!(mBorderRadius)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleBorder>())).mBorderImageSource as *const _ as usize
            },
            96usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBorder),
                "::",
                stringify!(mBorderImageSource)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleBorder>())).mBorderImageWidth as *const _ as usize
            },
            128usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBorder),
                "::",
                stringify!(mBorderImageWidth)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleBorder>())).mBorderImageOutset as *const _ as usize
            },
            168usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBorder),
                "::",
                stringify!(mBorderImageOutset)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleBorder>())).mBorderImageSlice as *const _ as usize
            },
            200usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBorder),
                "::",
                stringify!(mBorderImageSlice)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleBorder>())).mBorderImageRepeatH as *const _ as usize
            },
            236usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBorder),
                "::",
                stringify!(mBorderImageRepeatH)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleBorder>())).mBorderImageRepeatV as *const _ as usize
            },
            237usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBorder),
                "::",
                stringify!(mBorderImageRepeatV)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleBorder>())).mFloatEdge as *const _ as usize },
            238usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBorder),
                "::",
                stringify!(mFloatEdge)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleBorder>())).mBoxDecorationBreak as *const _ as usize
            },
            239usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBorder),
                "::",
                stringify!(mBoxDecorationBreak)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleBorder>())).mBorderStyle as *const _ as usize },
            240usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBorder),
                "::",
                stringify!(mBorderStyle)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleBorder>())).mBorderTopColor as *const _ as usize
            },
            244usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBorder),
                "::",
                stringify!(mBorderTopColor)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleBorder>())).mBorderRightColor as *const _ as usize
            },
            260usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBorder),
                "::",
                stringify!(mBorderRightColor)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleBorder>())).mBorderBottomColor as *const _ as usize
            },
            276usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBorder),
                "::",
                stringify!(mBorderBottomColor)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleBorder>())).mBorderLeftColor as *const _ as usize
            },
            292usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBorder),
                "::",
                stringify!(mBorderLeftColor)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleBorder>())).mComputedBorder as *const _ as usize
            },
            308usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBorder),
                "::",
                stringify!(mComputedBorder)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleBorder>())).mBorder as *const _ as usize },
            324usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBorder),
                "::",
                stringify!(mBorder)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleBorder>())).mTwipsPerPixel as *const _ as usize
            },
            340usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleBorder),
                "::",
                stringify!(mTwipsPerPixel)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleOutline {
        pub mOutlineRadius: root::mozilla::StyleBorderRadius,
        pub mOutlineWidth: root::nscoord,
        pub mOutlineOffset: root::mozilla::Length,
        pub mOutlineColor: root::mozilla::StyleColor,
        pub mOutlineStyle: root::mozilla::StyleOutlineStyle,
        pub mActualOutlineWidth: root::nscoord,
        pub mTwipsPerPixel: root::nscoord,
    }
    pub const nsStyleOutline_kHasTriggerImageLoads: bool = false;
    #[test]
    fn bindgen_test_layout_nsStyleOutline() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleOutline>(),
            132usize,
            concat!("Size of: ", stringify!(nsStyleOutline))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleOutline>(),
            4usize,
            concat!("Alignment of ", stringify!(nsStyleOutline))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleOutline>())).mOutlineRadius as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleOutline),
                "::",
                stringify!(mOutlineRadius)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleOutline>())).mOutlineWidth as *const _ as usize
            },
            96usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleOutline),
                "::",
                stringify!(mOutlineWidth)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleOutline>())).mOutlineOffset as *const _ as usize
            },
            100usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleOutline),
                "::",
                stringify!(mOutlineOffset)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleOutline>())).mOutlineColor as *const _ as usize
            },
            104usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleOutline),
                "::",
                stringify!(mOutlineColor)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleOutline>())).mOutlineStyle as *const _ as usize
            },
            120usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleOutline),
                "::",
                stringify!(mOutlineStyle)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleOutline>())).mActualOutlineWidth as *const _ as usize
            },
            124usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleOutline),
                "::",
                stringify!(mActualOutlineWidth)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleOutline>())).mTwipsPerPixel as *const _ as usize
            },
            128usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleOutline),
                "::",
                stringify!(mTwipsPerPixel)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleList {
        pub mListStylePosition: u8,
        pub mListStyleImage: root::RefPtr<root::nsStyleImageRequest>,
        pub mCounterStyle: root::mozilla::CounterStylePtr,
        pub mQuotes: root::mozilla::StyleQuotes,
        pub mImageRegion: root::nsRect,
        pub mMozListReversed: root::mozilla::StyleMozListReversed,
    }
    pub const nsStyleList_kHasTriggerImageLoads: bool = true;
    #[test]
    fn bindgen_test_layout_nsStyleList() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleList>(),
            56usize,
            concat!("Size of: ", stringify!(nsStyleList))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleList>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleList))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleList>())).mListStylePosition as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleList),
                "::",
                stringify!(mListStylePosition)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleList>())).mListStyleImage as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleList),
                "::",
                stringify!(mListStyleImage)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleList>())).mCounterStyle as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleList),
                "::",
                stringify!(mCounterStyle)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleList>())).mQuotes as *const _ as usize },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleList),
                "::",
                stringify!(mQuotes)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleList>())).mImageRegion as *const _ as usize },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleList),
                "::",
                stringify!(mImageRegion)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleList>())).mMozListReversed as *const _ as usize
            },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleList),
                "::",
                stringify!(mMozListReversed)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleGridLine {
        pub mHasSpan: bool,
        pub mInteger: i32,
        pub mLineName: ::gecko_bindings::structs::nsString,
    }
    pub const nsStyleGridLine_kMinLine: i32 = -10000;
    pub const nsStyleGridLine_kMaxLine: i32 = 10000;
    #[test]
    fn bindgen_test_layout_nsStyleGridLine() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleGridLine>(),
            24usize,
            concat!("Size of: ", stringify!(nsStyleGridLine))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleGridLine>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleGridLine))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleGridLine>())).mHasSpan as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGridLine),
                "::",
                stringify!(mHasSpan)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleGridLine>())).mInteger as *const _ as usize },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGridLine),
                "::",
                stringify!(mInteger)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleGridLine>())).mLineName as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGridLine),
                "::",
                stringify!(mLineName)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleGridTemplate {
        pub mLineNameLists: root::nsTArray<root::nsTArray<::gecko_bindings::structs::nsString>>,
        pub mMinTrackSizingFunctions: root::nsTArray<root::nsStyleCoord>,
        pub mMaxTrackSizingFunctions: root::nsTArray<root::nsStyleCoord>,
        pub mRepeatAutoLineNameListBefore: root::nsTArray<::gecko_bindings::structs::nsString>,
        pub mRepeatAutoLineNameListAfter: root::nsTArray<::gecko_bindings::structs::nsString>,
        pub mRepeatAutoIndex: i16,
        pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 1usize], u8>,
        pub __bindgen_padding_0: [u8; 5usize],
    }
    #[test]
    fn bindgen_test_layout_nsStyleGridTemplate() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleGridTemplate>(),
            48usize,
            concat!("Size of: ", stringify!(nsStyleGridTemplate))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleGridTemplate>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleGridTemplate))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleGridTemplate>())).mLineNameLists as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGridTemplate),
                "::",
                stringify!(mLineNameLists)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleGridTemplate>())).mMinTrackSizingFunctions as *const _
                    as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGridTemplate),
                "::",
                stringify!(mMinTrackSizingFunctions)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleGridTemplate>())).mMaxTrackSizingFunctions as *const _
                    as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGridTemplate),
                "::",
                stringify!(mMaxTrackSizingFunctions)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleGridTemplate>())).mRepeatAutoLineNameListBefore
                    as *const _ as usize
            },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGridTemplate),
                "::",
                stringify!(mRepeatAutoLineNameListBefore)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleGridTemplate>())).mRepeatAutoLineNameListAfter
                    as *const _ as usize
            },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGridTemplate),
                "::",
                stringify!(mRepeatAutoLineNameListAfter)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleGridTemplate>())).mRepeatAutoIndex as *const _
                    as usize
            },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleGridTemplate),
                "::",
                stringify!(mRepeatAutoIndex)
            )
        );
    }
    impl nsStyleGridTemplate {
        #[inline]
        pub fn mIsAutoFill(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mIsAutoFill(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(0usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mIsSubgrid(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mIsSubgrid(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(1usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn new_bitfield_1(
            mIsAutoFill: bool,
            mIsSubgrid: bool,
        ) -> root::__BindgenBitfieldUnit<[u8; 1usize], u8> {
            let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 1usize], u8> =
                Default::default();
            __bindgen_bitfield_unit.set(0usize, 1u8, {
                let mIsAutoFill: u8 = unsafe { ::std::mem::transmute(mIsAutoFill) };
                mIsAutoFill as u64
            });
            __bindgen_bitfield_unit.set(1usize, 1u8, {
                let mIsSubgrid: u8 = unsafe { ::std::mem::transmute(mIsSubgrid) };
                mIsSubgrid as u64
            });
            __bindgen_bitfield_unit
        }
    }
    #[repr(C)]
    pub struct nsStylePosition {
        pub mObjectPosition: root::nsStylePosition_Position,
        pub mOffset: root::mozilla::StyleRect<root::nsStylePosition_LengthPercentageOrAuto>,
        pub mWidth: root::nsStylePosition_StyleSize,
        pub mMinWidth: root::nsStylePosition_StyleSize,
        pub mMaxWidth: root::nsStylePosition_StyleMaxSize,
        pub mHeight: root::nsStylePosition_StyleSize,
        pub mMinHeight: root::nsStylePosition_StyleSize,
        pub mMaxHeight: root::nsStylePosition_StyleMaxSize,
        pub mFlexBasis: root::nsStylePosition_StyleFlexBasis,
        pub mGridAutoColumnsMin: root::nsStyleCoord,
        pub mGridAutoColumnsMax: root::nsStyleCoord,
        pub mGridAutoRowsMin: root::nsStyleCoord,
        pub mGridAutoRowsMax: root::nsStyleCoord,
        pub mGridAutoFlow: u8,
        pub mBoxSizing: root::mozilla::StyleBoxSizing,
        pub mAlignContent: u16,
        pub mAlignItems: u8,
        pub mAlignSelf: u8,
        pub mJustifyContent: u16,
        pub mSpecifiedJustifyItems: u8,
        pub mJustifyItems: u8,
        pub mJustifySelf: u8,
        pub mFlexDirection: root::mozilla::StyleFlexDirection,
        pub mFlexWrap: u8,
        pub mObjectFit: u8,
        pub mOrder: i32,
        pub mFlexGrow: f32,
        pub mFlexShrink: f32,
        pub mZIndex: root::mozilla::StyleZIndex,
        pub mGridTemplateColumns: root::mozilla::UniquePtr<root::nsStyleGridTemplate>,
        pub mGridTemplateRows: root::mozilla::UniquePtr<root::nsStyleGridTemplate>,
        pub mGridTemplateAreas: root::RefPtr<root::mozilla::css::GridTemplateAreasValue>,
        pub mGridColumnStart: root::nsStyleGridLine,
        pub mGridColumnEnd: root::nsStyleGridLine,
        pub mGridRowStart: root::nsStyleGridLine,
        pub mGridRowEnd: root::nsStyleGridLine,
        pub mColumnGap: root::mozilla::NonNegativeLengthPercentageOrNormal,
        pub mRowGap: root::mozilla::NonNegativeLengthPercentageOrNormal,
    }
    pub type nsStylePosition_LengthPercentageOrAuto = root::mozilla::LengthPercentageOrAuto;
    pub type nsStylePosition_Position = root::mozilla::Position;
    pub type nsStylePosition_StyleRect<T> = root::mozilla::StyleRect<T>;
    pub type nsStylePosition_StyleSize = root::mozilla::StyleSize;
    pub type nsStylePosition_StyleMaxSize = root::mozilla::StyleMaxSize;
    pub type nsStylePosition_StyleFlexBasis = root::mozilla::StyleFlexBasis;
    pub type nsStylePosition_WritingMode = root::mozilla::WritingMode;
    pub const nsStylePosition_kHasTriggerImageLoads: bool = false;
    #[test]
    fn bindgen_test_layout_nsStylePosition() {
        assert_eq!(
            ::std::mem::size_of::<nsStylePosition>(),
            464usize,
            concat!("Size of: ", stringify!(nsStylePosition))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStylePosition>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStylePosition))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePosition>())).mObjectPosition as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mObjectPosition)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mOffset as *const _ as usize },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mOffset)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mWidth as *const _ as usize },
            88usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mWidth)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mMinWidth as *const _ as usize },
            104usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mMinWidth)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mMaxWidth as *const _ as usize },
            120usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mMaxWidth)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mHeight as *const _ as usize },
            136usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mHeight)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mMinHeight as *const _ as usize },
            152usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mMinHeight)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mMaxHeight as *const _ as usize },
            168usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mMaxHeight)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mFlexBasis as *const _ as usize },
            184usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mFlexBasis)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePosition>())).mGridAutoColumnsMin as *const _ as usize
            },
            208usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mGridAutoColumnsMin)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePosition>())).mGridAutoColumnsMax as *const _ as usize
            },
            224usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mGridAutoColumnsMax)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePosition>())).mGridAutoRowsMin as *const _ as usize
            },
            240usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mGridAutoRowsMin)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePosition>())).mGridAutoRowsMax as *const _ as usize
            },
            256usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mGridAutoRowsMax)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePosition>())).mGridAutoFlow as *const _ as usize
            },
            272usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mGridAutoFlow)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mBoxSizing as *const _ as usize },
            273usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mBoxSizing)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePosition>())).mAlignContent as *const _ as usize
            },
            274usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mAlignContent)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mAlignItems as *const _ as usize },
            276usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mAlignItems)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mAlignSelf as *const _ as usize },
            277usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mAlignSelf)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePosition>())).mJustifyContent as *const _ as usize
            },
            278usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mJustifyContent)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePosition>())).mSpecifiedJustifyItems as *const _
                    as usize
            },
            280usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mSpecifiedJustifyItems)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePosition>())).mJustifyItems as *const _ as usize
            },
            281usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mJustifyItems)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePosition>())).mJustifySelf as *const _ as usize
            },
            282usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mJustifySelf)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePosition>())).mFlexDirection as *const _ as usize
            },
            283usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mFlexDirection)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mFlexWrap as *const _ as usize },
            284usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mFlexWrap)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mObjectFit as *const _ as usize },
            285usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mObjectFit)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mOrder as *const _ as usize },
            288usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mOrder)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mFlexGrow as *const _ as usize },
            292usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mFlexGrow)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mFlexShrink as *const _ as usize },
            296usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mFlexShrink)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mZIndex as *const _ as usize },
            300usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mZIndex)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePosition>())).mGridTemplateColumns as *const _
                    as usize
            },
            312usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mGridTemplateColumns)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePosition>())).mGridTemplateRows as *const _ as usize
            },
            320usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mGridTemplateRows)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePosition>())).mGridTemplateAreas as *const _ as usize
            },
            328usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mGridTemplateAreas)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePosition>())).mGridColumnStart as *const _ as usize
            },
            336usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mGridColumnStart)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePosition>())).mGridColumnEnd as *const _ as usize
            },
            360usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mGridColumnEnd)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStylePosition>())).mGridRowStart as *const _ as usize
            },
            384usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mGridRowStart)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mGridRowEnd as *const _ as usize },
            408usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mGridRowEnd)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mColumnGap as *const _ as usize },
            432usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mColumnGap)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStylePosition>())).mRowGap as *const _ as usize },
            448usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStylePosition),
                "::",
                stringify!(mRowGap)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleTextOverflowSide {
        pub mString: ::gecko_bindings::structs::nsString,
        pub mType: u8,
    }
    #[test]
    fn bindgen_test_layout_nsStyleTextOverflowSide() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleTextOverflowSide>(),
            24usize,
            concat!("Size of: ", stringify!(nsStyleTextOverflowSide))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleTextOverflowSide>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleTextOverflowSide))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleTextOverflowSide>())).mString as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTextOverflowSide),
                "::",
                stringify!(mString)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleTextOverflowSide>())).mType as *const _ as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTextOverflowSide),
                "::",
                stringify!(mType)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleTextOverflow {
        pub mLeft: root::nsStyleTextOverflowSide,
        pub mRight: root::nsStyleTextOverflowSide,
        pub mLogicalDirections: bool,
    }
    #[test]
    fn bindgen_test_layout_nsStyleTextOverflow() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleTextOverflow>(),
            56usize,
            concat!("Size of: ", stringify!(nsStyleTextOverflow))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleTextOverflow>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleTextOverflow))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleTextOverflow>())).mLeft as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTextOverflow),
                "::",
                stringify!(mLeft)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleTextOverflow>())).mRight as *const _ as usize },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTextOverflow),
                "::",
                stringify!(mRight)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleTextOverflow>())).mLogicalDirections as *const _
                    as usize
            },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTextOverflow),
                "::",
                stringify!(mLogicalDirections)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleTextReset {
        pub mTextOverflow: root::nsStyleTextOverflow,
        pub mTextDecorationLine: root::mozilla::StyleTextDecorationLine,
        pub mTextDecorationStyle: u8,
        pub mUnicodeBidi: u8,
        pub mInitialLetterSink: root::nscoord,
        pub mInitialLetterSize: f32,
        pub mTextDecorationColor: root::mozilla::StyleColor,
    }
    pub const nsStyleTextReset_kHasTriggerImageLoads: bool = false;
    #[test]
    fn bindgen_test_layout_nsStyleTextReset() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleTextReset>(),
            88usize,
            concat!("Size of: ", stringify!(nsStyleTextReset))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleTextReset>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleTextReset))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleTextReset>())).mTextOverflow as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTextReset),
                "::",
                stringify!(mTextOverflow)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleTextReset>())).mTextDecorationLine as *const _
                    as usize
            },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTextReset),
                "::",
                stringify!(mTextDecorationLine)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleTextReset>())).mTextDecorationStyle as *const _
                    as usize
            },
            57usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTextReset),
                "::",
                stringify!(mTextDecorationStyle)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleTextReset>())).mUnicodeBidi as *const _ as usize
            },
            58usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTextReset),
                "::",
                stringify!(mUnicodeBidi)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleTextReset>())).mInitialLetterSink as *const _ as usize
            },
            60usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTextReset),
                "::",
                stringify!(mInitialLetterSink)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleTextReset>())).mInitialLetterSize as *const _ as usize
            },
            64usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTextReset),
                "::",
                stringify!(mInitialLetterSize)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleTextReset>())).mTextDecorationColor as *const _
                    as usize
            },
            68usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTextReset),
                "::",
                stringify!(mTextDecorationColor)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleText {
        pub mTextTransform: root::mozilla::StyleTextTransform,
        pub mTextAlign: u8,
        pub mTextAlignLast: u8,
        pub mTextJustify: root::mozilla::StyleTextJustify,
        pub mWhiteSpace: root::mozilla::StyleWhiteSpace,
        pub mWordBreak: root::mozilla::StyleWordBreak,
        pub mOverflowWrap: root::mozilla::StyleOverflowWrap,
        pub mHyphens: root::mozilla::StyleHyphens,
        pub mRubyAlign: u8,
        pub mRubyPosition: u8,
        pub mTextSizeAdjust: u8,
        pub mTextCombineUpright: u8,
        pub mControlCharacterVisibility: u8,
        pub mTextEmphasisPosition: u8,
        pub mTextEmphasisStyle: u8,
        pub mTextRendering: root::mozilla::StyleTextRendering,
        pub mTextEmphasisColor: root::mozilla::StyleColor,
        pub mWebkitTextFillColor: root::mozilla::StyleColor,
        pub mWebkitTextStrokeColor: root::mozilla::StyleColor,
        pub mMozTabSize: root::mozilla::StyleNonNegativeLengthOrNumber,
        pub mWordSpacing: root::mozilla::LengthPercentage,
        pub mLetterSpacing: root::mozilla::StyleLetterSpacing,
        pub mLineHeight: root::mozilla::StyleLineHeight,
        pub mTextIndent: root::mozilla::LengthPercentage,
        pub mWebkitTextStrokeWidth: root::nscoord,
        pub mTextShadow: root::mozilla::StyleArcSlice<root::mozilla::StyleSimpleShadow>,
        pub mTextEmphasisStyleString: ::gecko_bindings::structs::nsString,
    }
    pub const nsStyleText_kHasTriggerImageLoads: bool = false;
    #[test]
    fn bindgen_test_layout_nsStyleText() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleText>(),
            144usize,
            concat!("Size of: ", stringify!(nsStyleText))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleText>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleText))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleText>())).mTextTransform as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mTextTransform)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleText>())).mTextAlign as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mTextAlign)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleText>())).mTextAlignLast as *const _ as usize },
            9usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mTextAlignLast)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleText>())).mTextJustify as *const _ as usize },
            10usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mTextJustify)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleText>())).mWhiteSpace as *const _ as usize },
            11usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mWhiteSpace)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleText>())).mWordBreak as *const _ as usize },
            12usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mWordBreak)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleText>())).mOverflowWrap as *const _ as usize },
            13usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mOverflowWrap)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleText>())).mHyphens as *const _ as usize },
            14usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mHyphens)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleText>())).mRubyAlign as *const _ as usize },
            15usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mRubyAlign)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleText>())).mRubyPosition as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mRubyPosition)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleText>())).mTextSizeAdjust as *const _ as usize },
            17usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mTextSizeAdjust)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleText>())).mTextCombineUpright as *const _ as usize
            },
            18usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mTextCombineUpright)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleText>())).mControlCharacterVisibility as *const _
                    as usize
            },
            19usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mControlCharacterVisibility)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleText>())).mTextEmphasisPosition as *const _ as usize
            },
            20usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mTextEmphasisPosition)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleText>())).mTextEmphasisStyle as *const _ as usize
            },
            21usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mTextEmphasisStyle)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleText>())).mTextRendering as *const _ as usize },
            22usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mTextRendering)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleText>())).mTextEmphasisColor as *const _ as usize
            },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mTextEmphasisColor)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleText>())).mWebkitTextFillColor as *const _ as usize
            },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mWebkitTextFillColor)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleText>())).mWebkitTextStrokeColor as *const _ as usize
            },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mWebkitTextStrokeColor)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleText>())).mMozTabSize as *const _ as usize },
            72usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mMozTabSize)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleText>())).mWordSpacing as *const _ as usize },
            80usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mWordSpacing)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleText>())).mLetterSpacing as *const _ as usize },
            92usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mLetterSpacing)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleText>())).mLineHeight as *const _ as usize },
            96usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mLineHeight)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleText>())).mTextIndent as *const _ as usize },
            104usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mTextIndent)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleText>())).mWebkitTextStrokeWidth as *const _ as usize
            },
            116usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mWebkitTextStrokeWidth)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleText>())).mTextShadow as *const _ as usize },
            120usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mTextShadow)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleText>())).mTextEmphasisStyleString as *const _
                    as usize
            },
            128usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleText),
                "::",
                stringify!(mTextEmphasisStyleString)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsStyleVisibility {
        pub mImageOrientation: root::mozilla::StyleImageOrientation,
        pub mDirection: u8,
        pub mVisible: u8,
        pub mImageRendering: u8,
        pub mWritingMode: u8,
        pub mTextOrientation: u8,
        pub mColorAdjust: root::mozilla::StyleColorAdjust,
    }
    pub const nsStyleVisibility_kHasTriggerImageLoads: bool = false;
    #[test]
    fn bindgen_test_layout_nsStyleVisibility() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleVisibility>(),
            7usize,
            concat!("Size of: ", stringify!(nsStyleVisibility))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleVisibility>(),
            1usize,
            concat!("Alignment of ", stringify!(nsStyleVisibility))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleVisibility>())).mImageOrientation as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleVisibility),
                "::",
                stringify!(mImageOrientation)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleVisibility>())).mDirection as *const _ as usize
            },
            1usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleVisibility),
                "::",
                stringify!(mDirection)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleVisibility>())).mVisible as *const _ as usize },
            2usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleVisibility),
                "::",
                stringify!(mVisible)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleVisibility>())).mImageRendering as *const _ as usize
            },
            3usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleVisibility),
                "::",
                stringify!(mImageRendering)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleVisibility>())).mWritingMode as *const _ as usize
            },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleVisibility),
                "::",
                stringify!(mWritingMode)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleVisibility>())).mTextOrientation as *const _ as usize
            },
            5usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleVisibility),
                "::",
                stringify!(mTextOrientation)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleVisibility>())).mColorAdjust as *const _ as usize
            },
            6usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleVisibility),
                "::",
                stringify!(mColorAdjust)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleDisplay {
        pub mBinding: root::RefPtr<root::mozilla::css::URLValue>,
        pub mDisplay: root::mozilla::StyleDisplay,
        pub mOriginalDisplay: root::mozilla::StyleDisplay,
        pub mContain: root::mozilla::StyleContain,
        pub mAppearance: root::mozilla::StyleAppearance,
        pub mPosition: u8,
        pub mFloat: root::mozilla::StyleFloat,
        pub mOriginalFloat: root::mozilla::StyleFloat,
        pub mBreakType: root::mozilla::StyleClear,
        pub mBreakInside: root::mozilla::StyleBreakWithin,
        pub mBreakBefore: root::mozilla::StyleBreakBetween,
        pub mBreakAfter: root::mozilla::StyleBreakBetween,
        pub mOverflowX: root::mozilla::StyleOverflow,
        pub mOverflowY: root::mozilla::StyleOverflow,
        pub mOverflowClipBoxBlock: root::mozilla::StyleOverflowClipBox,
        pub mOverflowClipBoxInline: root::mozilla::StyleOverflowClipBox,
        pub mResize: root::mozilla::StyleResize,
        pub mOrient: root::mozilla::StyleOrient,
        pub mIsolation: u8,
        pub mTopLayer: u8,
        pub mWillChange: root::mozilla::StyleWillChange,
        pub mTouchAction: root::mozilla::StyleTouchAction,
        pub mScrollBehavior: u8,
        pub mOverscrollBehaviorX: root::mozilla::StyleOverscrollBehavior,
        pub mOverscrollBehaviorY: root::mozilla::StyleOverscrollBehavior,
        pub mOverflowAnchor: root::mozilla::StyleOverflowAnchor,
        pub mScrollSnapAlign: root::mozilla::StyleScrollSnapAlign,
        pub mScrollSnapType: root::mozilla::StyleScrollSnapType,
        pub mScrollSnapPointsX: root::nsStyleCoord,
        pub mScrollSnapPointsY: root::nsStyleCoord,
        pub mScrollSnapDestination: root::mozilla::Position,
        pub mScrollSnapCoordinate: root::nsTArray<root::mozilla::Position>,
        pub mLineClamp: u32,
        pub mBackfaceVisibility: u8,
        pub mTransformStyle: u8,
        pub mTransformBox: root::nsStyleDisplay_StyleGeometryBox,
        pub mTransform: root::mozilla::StyleTransform,
        pub mRotate: root::mozilla::StyleRotate,
        pub mTranslate: root::mozilla::StyleTranslate,
        pub mScale: root::mozilla::StyleScale,
        pub mMotion: root::mozilla::UniquePtr<root::mozilla::StyleMotion>,
        pub mTransformOrigin: root::mozilla::StyleTransformOrigin,
        pub mChildPerspective: root::mozilla::StylePerspective,
        pub mPerspectiveOrigin: root::mozilla::Position,
        pub mVerticalAlign: root::mozilla::StyleVerticalAlign,
        pub mTransitions: root::nsStyleAutoArray<root::mozilla::StyleTransition>,
        pub mTransitionTimingFunctionCount: u32,
        pub mTransitionDurationCount: u32,
        pub mTransitionDelayCount: u32,
        pub mTransitionPropertyCount: u32,
        pub mAnimations: root::nsStyleAutoArray<root::mozilla::StyleAnimation>,
        pub mAnimationTimingFunctionCount: u32,
        pub mAnimationDurationCount: u32,
        pub mAnimationDelayCount: u32,
        pub mAnimationNameCount: u32,
        pub mAnimationDirectionCount: u32,
        pub mAnimationFillModeCount: u32,
        pub mAnimationPlayStateCount: u32,
        pub mAnimationIterationCountCount: u32,
        pub mShapeImageThreshold: f32,
        pub mShapeMargin: root::mozilla::NonNegativeLengthPercentage,
        pub mShapeOutside: root::mozilla::StyleShapeSource,
    }
    pub use self::super::root::mozilla::StyleGeometryBox as nsStyleDisplay_StyleGeometryBox;
    pub const nsStyleDisplay_kHasTriggerImageLoads: bool = true;
    #[test]
    fn bindgen_test_layout_nsStyleDisplay() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleDisplay>(),
            504usize,
            concat!("Size of: ", stringify!(nsStyleDisplay))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleDisplay>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleDisplay))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mBinding as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mBinding)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mDisplay as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mDisplay)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mOriginalDisplay as *const _ as usize
            },
            9usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mOriginalDisplay)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mContain as *const _ as usize },
            10usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mContain)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mAppearance as *const _ as usize },
            11usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mAppearance)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mPosition as *const _ as usize },
            12usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mPosition)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mFloat as *const _ as usize },
            13usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mFloat)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mOriginalFloat as *const _ as usize
            },
            14usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mOriginalFloat)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mBreakType as *const _ as usize },
            15usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mBreakType)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mBreakInside as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mBreakInside)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mBreakBefore as *const _ as usize },
            17usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mBreakBefore)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mBreakAfter as *const _ as usize },
            18usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mBreakAfter)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mOverflowX as *const _ as usize },
            19usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mOverflowX)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mOverflowY as *const _ as usize },
            20usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mOverflowY)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mOverflowClipBoxBlock as *const _
                    as usize
            },
            21usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mOverflowClipBoxBlock)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mOverflowClipBoxInline as *const _
                    as usize
            },
            22usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mOverflowClipBoxInline)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mResize as *const _ as usize },
            23usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mResize)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mOrient as *const _ as usize },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mOrient)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mIsolation as *const _ as usize },
            25usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mIsolation)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mTopLayer as *const _ as usize },
            26usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mTopLayer)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mWillChange as *const _ as usize },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mWillChange)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mTouchAction as *const _ as usize },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mTouchAction)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mScrollBehavior as *const _ as usize
            },
            57usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mScrollBehavior)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mOverscrollBehaviorX as *const _ as usize
            },
            58usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mOverscrollBehaviorX)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mOverscrollBehaviorY as *const _ as usize
            },
            59usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mOverscrollBehaviorY)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mOverflowAnchor as *const _ as usize
            },
            60usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mOverflowAnchor)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mScrollSnapAlign as *const _ as usize
            },
            61usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mScrollSnapAlign)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mScrollSnapType as *const _ as usize
            },
            63usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mScrollSnapType)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mScrollSnapPointsX as *const _ as usize
            },
            72usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mScrollSnapPointsX)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mScrollSnapPointsY as *const _ as usize
            },
            88usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mScrollSnapPointsY)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mScrollSnapDestination as *const _
                    as usize
            },
            104usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mScrollSnapDestination)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mScrollSnapCoordinate as *const _
                    as usize
            },
            128usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mScrollSnapCoordinate)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mLineClamp as *const _ as usize },
            136usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mLineClamp)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mBackfaceVisibility as *const _ as usize
            },
            140usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mBackfaceVisibility)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mTransformStyle as *const _ as usize
            },
            141usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mTransformStyle)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mTransformBox as *const _ as usize
            },
            142usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mTransformBox)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mTransform as *const _ as usize },
            144usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mTransform)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mRotate as *const _ as usize },
            160usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mRotate)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mTranslate as *const _ as usize },
            180usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mTranslate)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mScale as *const _ as usize },
            212usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mScale)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mMotion as *const _ as usize },
            232usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mMotion)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mTransformOrigin as *const _ as usize
            },
            240usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mTransformOrigin)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mChildPerspective as *const _ as usize
            },
            268usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mChildPerspective)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mPerspectiveOrigin as *const _ as usize
            },
            276usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mPerspectiveOrigin)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mVerticalAlign as *const _ as usize
            },
            300usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mVerticalAlign)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mTransitions as *const _ as usize },
            320usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mTransitions)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mTransitionTimingFunctionCount
                    as *const _ as usize
            },
            368usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mTransitionTimingFunctionCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mTransitionDurationCount as *const _
                    as usize
            },
            372usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mTransitionDurationCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mTransitionDelayCount as *const _
                    as usize
            },
            376usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mTransitionDelayCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mTransitionPropertyCount as *const _
                    as usize
            },
            380usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mTransitionPropertyCount)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mAnimations as *const _ as usize },
            384usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mAnimations)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mAnimationTimingFunctionCount as *const _
                    as usize
            },
            440usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mAnimationTimingFunctionCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mAnimationDurationCount as *const _
                    as usize
            },
            444usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mAnimationDurationCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mAnimationDelayCount as *const _ as usize
            },
            448usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mAnimationDelayCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mAnimationNameCount as *const _ as usize
            },
            452usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mAnimationNameCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mAnimationDirectionCount as *const _
                    as usize
            },
            456usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mAnimationDirectionCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mAnimationFillModeCount as *const _
                    as usize
            },
            460usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mAnimationFillModeCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mAnimationPlayStateCount as *const _
                    as usize
            },
            464usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mAnimationPlayStateCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mAnimationIterationCountCount as *const _
                    as usize
            },
            468usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mAnimationIterationCountCount)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mShapeImageThreshold as *const _ as usize
            },
            472usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mShapeImageThreshold)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleDisplay>())).mShapeMargin as *const _ as usize },
            476usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mShapeMargin)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleDisplay>())).mShapeOutside as *const _ as usize
            },
            488usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleDisplay),
                "::",
                stringify!(mShapeOutside)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsStyleTable {
        pub mLayoutStrategy: u8,
        pub mSpan: i32,
    }
    pub const nsStyleTable_kHasTriggerImageLoads: bool = false;
    #[test]
    fn bindgen_test_layout_nsStyleTable() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleTable>(),
            8usize,
            concat!("Size of: ", stringify!(nsStyleTable))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleTable>(),
            4usize,
            concat!("Alignment of ", stringify!(nsStyleTable))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleTable>())).mLayoutStrategy as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTable),
                "::",
                stringify!(mLayoutStrategy)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleTable>())).mSpan as *const _ as usize },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTable),
                "::",
                stringify!(mSpan)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsStyleTableBorder {
        pub mBorderSpacingCol: root::nscoord,
        pub mBorderSpacingRow: root::nscoord,
        pub mBorderCollapse: root::mozilla::StyleBorderCollapse,
        pub mCaptionSide: u8,
        pub mEmptyCells: u8,
    }
    pub const nsStyleTableBorder_kHasTriggerImageLoads: bool = false;
    #[test]
    fn bindgen_test_layout_nsStyleTableBorder() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleTableBorder>(),
            12usize,
            concat!("Size of: ", stringify!(nsStyleTableBorder))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleTableBorder>(),
            4usize,
            concat!("Alignment of ", stringify!(nsStyleTableBorder))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleTableBorder>())).mBorderSpacingCol as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTableBorder),
                "::",
                stringify!(mBorderSpacingCol)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleTableBorder>())).mBorderSpacingRow as *const _
                    as usize
            },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTableBorder),
                "::",
                stringify!(mBorderSpacingRow)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleTableBorder>())).mBorderCollapse as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTableBorder),
                "::",
                stringify!(mBorderCollapse)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleTableBorder>())).mCaptionSide as *const _ as usize
            },
            9usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTableBorder),
                "::",
                stringify!(mCaptionSide)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleTableBorder>())).mEmptyCells as *const _ as usize
            },
            10usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleTableBorder),
                "::",
                stringify!(mEmptyCells)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsStyleContentAttr {
        pub mName: root::RefPtr<root::nsAtom>,
        pub mNamespaceURL: root::RefPtr<root::nsAtom>,
    }
    #[test]
    fn bindgen_test_layout_nsStyleContentAttr() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleContentAttr>(),
            16usize,
            concat!("Size of: ", stringify!(nsStyleContentAttr))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleContentAttr>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleContentAttr))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleContentAttr>())).mName as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleContentAttr),
                "::",
                stringify!(mName)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleContentAttr>())).mNamespaceURL as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleContentAttr),
                "::",
                stringify!(mNamespaceURL)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsStyleContentData {
        pub mType: root::nsStyleContentData_StyleContentType,
        pub mContent: root::nsStyleContentData__bindgen_ty_1,
    }
    pub use self::super::root::mozilla::StyleContentType as nsStyleContentData_StyleContentType;
    #[repr(C)]
    pub struct nsStyleContentData_CounterFunction {
        pub mIdent: root::RefPtr<root::nsAtom>,
        pub mSeparator: ::gecko_bindings::structs::nsString,
        pub mCounterStyle: root::mozilla::CounterStylePtr,
        pub mRefCnt: u64,
    }
    pub type nsStyleContentData_CounterFunction_HasThreadSafeRefCnt = root::mozilla::TrueType;
    #[test]
    fn bindgen_test_layout_nsStyleContentData_CounterFunction() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleContentData_CounterFunction>(),
            40usize,
            concat!("Size of: ", stringify!(nsStyleContentData_CounterFunction))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleContentData_CounterFunction>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(nsStyleContentData_CounterFunction)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleContentData_CounterFunction>())).mIdent as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleContentData_CounterFunction),
                "::",
                stringify!(mIdent)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleContentData_CounterFunction>())).mSeparator
                    as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleContentData_CounterFunction),
                "::",
                stringify!(mSeparator)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleContentData_CounterFunction>())).mCounterStyle
                    as *const _ as usize
            },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleContentData_CounterFunction),
                "::",
                stringify!(mCounterStyle)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleContentData_CounterFunction>())).mRefCnt as *const _
                    as usize
            },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleContentData_CounterFunction),
                "::",
                stringify!(mRefCnt)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsStyleContentData__bindgen_ty_1 {
        pub mString: root::__BindgenUnionField<*mut u16>,
        pub mAttr: root::__BindgenUnionField<*mut root::nsStyleContentAttr>,
        pub mImage: root::__BindgenUnionField<*mut root::nsStyleImageRequest>,
        pub mCounters: root::__BindgenUnionField<*mut root::nsStyleContentData_CounterFunction>,
        pub bindgen_union_field: u64,
    }
    #[test]
    fn bindgen_test_layout_nsStyleContentData__bindgen_ty_1() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleContentData__bindgen_ty_1>(),
            8usize,
            concat!("Size of: ", stringify!(nsStyleContentData__bindgen_ty_1))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleContentData__bindgen_ty_1>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(nsStyleContentData__bindgen_ty_1)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleContentData__bindgen_ty_1>())).mString as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleContentData__bindgen_ty_1),
                "::",
                stringify!(mString)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleContentData__bindgen_ty_1>())).mAttr as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleContentData__bindgen_ty_1),
                "::",
                stringify!(mAttr)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleContentData__bindgen_ty_1>())).mImage as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleContentData__bindgen_ty_1),
                "::",
                stringify!(mImage)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleContentData__bindgen_ty_1>())).mCounters as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleContentData__bindgen_ty_1),
                "::",
                stringify!(mCounters)
            )
        );
    }
    #[test]
    fn bindgen_test_layout_nsStyleContentData() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleContentData>(),
            16usize,
            concat!("Size of: ", stringify!(nsStyleContentData))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleContentData>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleContentData))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleContentData>())).mType as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleContentData),
                "::",
                stringify!(mType)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleContentData>())).mContent as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleContentData),
                "::",
                stringify!(mContent)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsStyleCounterData {
        pub mCounter: root::RefPtr<root::nsAtom>,
        pub mValue: i32,
    }
    #[test]
    fn bindgen_test_layout_nsStyleCounterData() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleCounterData>(),
            16usize,
            concat!("Size of: ", stringify!(nsStyleCounterData))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleCounterData>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleCounterData))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleCounterData>())).mCounter as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleCounterData),
                "::",
                stringify!(mCounter)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleCounterData>())).mValue as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleCounterData),
                "::",
                stringify!(mValue)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsStyleContent {
        pub mContents: root::nsTArray<root::nsStyleContentData>,
        pub mIncrements: root::nsTArray<root::nsStyleCounterData>,
        pub mResets: root::nsTArray<root::nsStyleCounterData>,
        pub mSets: root::nsTArray<root::nsStyleCounterData>,
    }
    pub const nsStyleContent_kHasTriggerImageLoads: bool = true;
    #[test]
    fn bindgen_test_layout_nsStyleContent() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleContent>(),
            32usize,
            concat!("Size of: ", stringify!(nsStyleContent))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleContent>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleContent))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleContent>())).mContents as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleContent),
                "::",
                stringify!(mContents)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleContent>())).mIncrements as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleContent),
                "::",
                stringify!(mIncrements)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleContent>())).mResets as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleContent),
                "::",
                stringify!(mResets)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleContent>())).mSets as *const _ as usize },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleContent),
                "::",
                stringify!(mSets)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleUIReset {
        pub mUserSelect: root::mozilla::StyleUserSelect,
        pub mScrollbarWidth: root::mozilla::StyleScrollbarWidth,
        pub mForceBrokenImageIcon: u8,
        pub mIMEMode: u8,
        pub mWindowDragging: root::mozilla::StyleWindowDragging,
        pub mWindowShadow: u8,
        pub mWindowOpacity: f32,
        pub mMozWindowTransform: root::mozilla::StyleTransform,
        pub mWindowTransformOrigin: root::mozilla::StyleTransformOrigin,
    }
    pub const nsStyleUIReset_kHasTriggerImageLoads: bool = false;
    #[test]
    fn bindgen_test_layout_nsStyleUIReset() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleUIReset>(),
            64usize,
            concat!("Size of: ", stringify!(nsStyleUIReset))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleUIReset>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleUIReset))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleUIReset>())).mUserSelect as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUIReset),
                "::",
                stringify!(mUserSelect)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleUIReset>())).mScrollbarWidth as *const _ as usize
            },
            1usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUIReset),
                "::",
                stringify!(mScrollbarWidth)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleUIReset>())).mForceBrokenImageIcon as *const _
                    as usize
            },
            2usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUIReset),
                "::",
                stringify!(mForceBrokenImageIcon)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleUIReset>())).mIMEMode as *const _ as usize },
            3usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUIReset),
                "::",
                stringify!(mIMEMode)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleUIReset>())).mWindowDragging as *const _ as usize
            },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUIReset),
                "::",
                stringify!(mWindowDragging)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleUIReset>())).mWindowShadow as *const _ as usize
            },
            5usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUIReset),
                "::",
                stringify!(mWindowShadow)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleUIReset>())).mWindowOpacity as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUIReset),
                "::",
                stringify!(mWindowOpacity)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleUIReset>())).mMozWindowTransform as *const _ as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUIReset),
                "::",
                stringify!(mMozWindowTransform)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleUIReset>())).mWindowTransformOrigin as *const _
                    as usize
            },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUIReset),
                "::",
                stringify!(mWindowTransformOrigin)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsCursorImage {
        pub mHaveHotspot: bool,
        pub mHotspotX: f32,
        pub mHotspotY: f32,
        pub mImage: root::RefPtr<root::nsStyleImageRequest>,
    }
    #[test]
    fn bindgen_test_layout_nsCursorImage() {
        assert_eq!(
            ::std::mem::size_of::<nsCursorImage>(),
            24usize,
            concat!("Size of: ", stringify!(nsCursorImage))
        );
        assert_eq!(
            ::std::mem::align_of::<nsCursorImage>(),
            8usize,
            concat!("Alignment of ", stringify!(nsCursorImage))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsCursorImage>())).mHaveHotspot as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCursorImage),
                "::",
                stringify!(mHaveHotspot)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsCursorImage>())).mHotspotX as *const _ as usize },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCursorImage),
                "::",
                stringify!(mHotspotX)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsCursorImage>())).mHotspotY as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCursorImage),
                "::",
                stringify!(mHotspotY)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsCursorImage>())).mImage as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCursorImage),
                "::",
                stringify!(mImage)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleUI {
        pub mUserInput: root::mozilla::StyleUserInput,
        pub mUserModify: root::mozilla::StyleUserModify,
        pub mUserFocus: root::mozilla::StyleUserFocus,
        pub mPointerEvents: u8,
        pub mCursor: root::mozilla::StyleCursorKind,
        pub mCursorImages: root::nsTArray<root::nsCursorImage>,
        pub mCaretColor: root::mozilla::StyleColorOrAuto,
        pub mScrollbarColor: root::mozilla::StyleScrollbarColor,
    }
    pub const nsStyleUI_kHasTriggerImageLoads: bool = true;
    #[test]
    fn bindgen_test_layout_nsStyleUI() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleUI>(),
            72usize,
            concat!("Size of: ", stringify!(nsStyleUI))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleUI>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleUI))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleUI>())).mUserInput as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUI),
                "::",
                stringify!(mUserInput)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleUI>())).mUserModify as *const _ as usize },
            1usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUI),
                "::",
                stringify!(mUserModify)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleUI>())).mUserFocus as *const _ as usize },
            2usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUI),
                "::",
                stringify!(mUserFocus)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleUI>())).mPointerEvents as *const _ as usize },
            3usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUI),
                "::",
                stringify!(mPointerEvents)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleUI>())).mCursor as *const _ as usize },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUI),
                "::",
                stringify!(mCursor)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleUI>())).mCursorImages as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUI),
                "::",
                stringify!(mCursorImages)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleUI>())).mCaretColor as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUI),
                "::",
                stringify!(mCaretColor)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleUI>())).mScrollbarColor as *const _ as usize },
            36usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleUI),
                "::",
                stringify!(mScrollbarColor)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsStyleXUL {
        pub mBoxFlex: f32,
        pub mBoxOrdinal: u32,
        pub mBoxAlign: root::mozilla::StyleBoxAlign,
        pub mBoxDirection: root::mozilla::StyleBoxDirection,
        pub mBoxOrient: root::mozilla::StyleBoxOrient,
        pub mBoxPack: root::mozilla::StyleBoxPack,
        pub mStackSizing: root::mozilla::StyleStackSizing,
    }
    pub const nsStyleXUL_kHasTriggerImageLoads: bool = false;
    #[test]
    fn bindgen_test_layout_nsStyleXUL() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleXUL>(),
            16usize,
            concat!("Size of: ", stringify!(nsStyleXUL))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleXUL>(),
            4usize,
            concat!("Alignment of ", stringify!(nsStyleXUL))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleXUL>())).mBoxFlex as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleXUL),
                "::",
                stringify!(mBoxFlex)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleXUL>())).mBoxOrdinal as *const _ as usize },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleXUL),
                "::",
                stringify!(mBoxOrdinal)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleXUL>())).mBoxAlign as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleXUL),
                "::",
                stringify!(mBoxAlign)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleXUL>())).mBoxDirection as *const _ as usize },
            9usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleXUL),
                "::",
                stringify!(mBoxDirection)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleXUL>())).mBoxOrient as *const _ as usize },
            10usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleXUL),
                "::",
                stringify!(mBoxOrient)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleXUL>())).mBoxPack as *const _ as usize },
            11usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleXUL),
                "::",
                stringify!(mBoxPack)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleXUL>())).mStackSizing as *const _ as usize },
            12usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleXUL),
                "::",
                stringify!(mStackSizing)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleColumn {
        pub mColumnCount: u32,
        pub mColumnWidth: root::mozilla::NonNegativeLengthOrAuto,
        pub mColumnRuleColor: root::mozilla::StyleColor,
        pub mColumnRuleStyle: root::mozilla::StyleBorderStyle,
        pub mColumnFill: root::mozilla::StyleColumnFill,
        pub mColumnSpan: root::mozilla::StyleColumnSpan,
        pub mColumnRuleWidth: root::nscoord,
        pub mTwipsPerPixel: root::nscoord,
    }
    pub const nsStyleColumn_kHasTriggerImageLoads: bool = false;
    pub const nsStyleColumn_kMaxColumnCount: u32 = 1000;
    pub const nsStyleColumn_kColumnCountAuto: u32 = 0;
    #[test]
    fn bindgen_test_layout_nsStyleColumn() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleColumn>(),
            40usize,
            concat!("Size of: ", stringify!(nsStyleColumn))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleColumn>(),
            4usize,
            concat!("Alignment of ", stringify!(nsStyleColumn))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleColumn>())).mColumnCount as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleColumn),
                "::",
                stringify!(mColumnCount)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleColumn>())).mColumnWidth as *const _ as usize },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleColumn),
                "::",
                stringify!(mColumnWidth)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleColumn>())).mColumnRuleColor as *const _ as usize
            },
            12usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleColumn),
                "::",
                stringify!(mColumnRuleColor)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleColumn>())).mColumnRuleStyle as *const _ as usize
            },
            28usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleColumn),
                "::",
                stringify!(mColumnRuleStyle)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleColumn>())).mColumnFill as *const _ as usize },
            29usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleColumn),
                "::",
                stringify!(mColumnFill)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleColumn>())).mColumnSpan as *const _ as usize },
            30usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleColumn),
                "::",
                stringify!(mColumnSpan)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleColumn>())).mColumnRuleWidth as *const _ as usize
            },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleColumn),
                "::",
                stringify!(mColumnRuleWidth)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleColumn>())).mTwipsPerPixel as *const _ as usize
            },
            36usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleColumn),
                "::",
                stringify!(mTwipsPerPixel)
            )
        );
    }
    #[repr(u8)]
    #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
    pub enum nsStyleSVGPaintType {
        eStyleSVGPaintType_None = 1,
        eStyleSVGPaintType_Color = 2,
        eStyleSVGPaintType_Server = 3,
        eStyleSVGPaintType_ContextFill = 4,
        eStyleSVGPaintType_ContextStroke = 5,
    }
    #[repr(u8)]
    #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
    pub enum nsStyleSVGFallbackType {
        eStyleSVGFallbackType_NotSet = 0,
        eStyleSVGFallbackType_None = 1,
        eStyleSVGFallbackType_Color = 2,
    }
    #[repr(u8)]
    #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
    pub enum nsStyleSVGOpacitySource {
        eStyleSVGOpacitySource_Normal = 0,
        eStyleSVGOpacitySource_ContextFillOpacity = 1,
        eStyleSVGOpacitySource_ContextStrokeOpacity = 2,
    }
    #[repr(C)]
    pub struct nsStyleSVGPaint {
        pub mPaint: root::nsStyleSVGPaint_ColorOrPaintServer,
        pub mType: root::nsStyleSVGPaintType,
        pub mFallbackType: root::nsStyleSVGFallbackType,
        pub mFallbackColor: root::mozilla::StyleColor,
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsStyleSVGPaint_ColorOrPaintServer {
        pub mColor: root::__BindgenUnionField<root::mozilla::StyleColor>,
        pub mPaintServer: root::__BindgenUnionField<*mut root::mozilla::css::URLValue>,
        pub bindgen_union_field: [u64; 2usize],
    }
    #[test]
    fn bindgen_test_layout_nsStyleSVGPaint_ColorOrPaintServer() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleSVGPaint_ColorOrPaintServer>(),
            16usize,
            concat!("Size of: ", stringify!(nsStyleSVGPaint_ColorOrPaintServer))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleSVGPaint_ColorOrPaintServer>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(nsStyleSVGPaint_ColorOrPaintServer)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleSVGPaint_ColorOrPaintServer>())).mColor as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVGPaint_ColorOrPaintServer),
                "::",
                stringify!(mColor)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleSVGPaint_ColorOrPaintServer>())).mPaintServer
                    as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVGPaint_ColorOrPaintServer),
                "::",
                stringify!(mPaintServer)
            )
        );
    }
    #[test]
    fn bindgen_test_layout_nsStyleSVGPaint() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleSVGPaint>(),
            40usize,
            concat!("Size of: ", stringify!(nsStyleSVGPaint))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleSVGPaint>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleSVGPaint))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVGPaint>())).mPaint as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVGPaint),
                "::",
                stringify!(mPaint)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVGPaint>())).mType as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVGPaint),
                "::",
                stringify!(mType)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleSVGPaint>())).mFallbackType as *const _ as usize
            },
            17usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVGPaint),
                "::",
                stringify!(mFallbackType)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleSVGPaint>())).mFallbackColor as *const _ as usize
            },
            20usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVGPaint),
                "::",
                stringify!(mFallbackColor)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleSVG {
        pub mFill: root::nsStyleSVGPaint,
        pub mStroke: root::nsStyleSVGPaint,
        pub mMarkerEnd: root::RefPtr<root::mozilla::css::URLValue>,
        pub mMarkerMid: root::RefPtr<root::mozilla::css::URLValue>,
        pub mMarkerStart: root::RefPtr<root::mozilla::css::URLValue>,
        pub mStrokeDasharray: root::nsTArray<root::mozilla::NonNegativeLengthPercentage>,
        pub mMozContextProperties: root::mozilla::StyleMozContextProperties,
        pub mStrokeDashoffset: root::mozilla::LengthPercentage,
        pub mStrokeWidth: root::mozilla::NonNegativeLengthPercentage,
        pub mFillOpacity: f32,
        pub mStrokeMiterlimit: f32,
        pub mStrokeOpacity: f32,
        pub mClipRule: root::mozilla::StyleFillRule,
        pub mColorInterpolation: u8,
        pub mColorInterpolationFilters: u8,
        pub mFillRule: root::mozilla::StyleFillRule,
        pub mPaintOrder: u8,
        pub mShapeRendering: u8,
        pub mStrokeLinecap: u8,
        pub mStrokeLinejoin: u8,
        pub mTextAnchor: u8,
        pub mContextFlags: u8,
    }
    pub const nsStyleSVG_kHasTriggerImageLoads: bool = false;
    pub const nsStyleSVG_FILL_OPACITY_SOURCE_MASK: u8 = 3;
    pub const nsStyleSVG_STROKE_OPACITY_SOURCE_MASK: u8 = 12;
    pub const nsStyleSVG_STROKE_DASHARRAY_CONTEXT: u8 = 16;
    pub const nsStyleSVG_STROKE_DASHOFFSET_CONTEXT: u8 = 32;
    pub const nsStyleSVG_STROKE_WIDTH_CONTEXT: u8 = 64;
    pub const nsStyleSVG_FILL_OPACITY_SOURCE_SHIFT: u8 = 0;
    pub const nsStyleSVG_STROKE_OPACITY_SOURCE_SHIFT: u8 = 2;
    #[test]
    fn bindgen_test_layout_nsStyleSVG() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleSVG>(),
            176usize,
            concat!("Size of: ", stringify!(nsStyleSVG))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleSVG>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleSVG))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVG>())).mFill as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mFill)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVG>())).mStroke as *const _ as usize },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mStroke)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVG>())).mMarkerEnd as *const _ as usize },
            80usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mMarkerEnd)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVG>())).mMarkerMid as *const _ as usize },
            88usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mMarkerMid)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVG>())).mMarkerStart as *const _ as usize },
            96usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mMarkerStart)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVG>())).mStrokeDasharray as *const _ as usize },
            104usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mStrokeDasharray)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleSVG>())).mMozContextProperties as *const _ as usize
            },
            112usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mMozContextProperties)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleSVG>())).mStrokeDashoffset as *const _ as usize
            },
            128usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mStrokeDashoffset)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVG>())).mStrokeWidth as *const _ as usize },
            140usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mStrokeWidth)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVG>())).mFillOpacity as *const _ as usize },
            152usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mFillOpacity)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleSVG>())).mStrokeMiterlimit as *const _ as usize
            },
            156usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mStrokeMiterlimit)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVG>())).mStrokeOpacity as *const _ as usize },
            160usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mStrokeOpacity)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVG>())).mClipRule as *const _ as usize },
            164usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mClipRule)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleSVG>())).mColorInterpolation as *const _ as usize
            },
            165usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mColorInterpolation)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleSVG>())).mColorInterpolationFilters as *const _
                    as usize
            },
            166usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mColorInterpolationFilters)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVG>())).mFillRule as *const _ as usize },
            167usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mFillRule)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVG>())).mPaintOrder as *const _ as usize },
            168usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mPaintOrder)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVG>())).mShapeRendering as *const _ as usize },
            169usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mShapeRendering)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVG>())).mStrokeLinecap as *const _ as usize },
            170usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mStrokeLinecap)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVG>())).mStrokeLinejoin as *const _ as usize },
            171usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mStrokeLinejoin)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVG>())).mTextAnchor as *const _ as usize },
            172usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mTextAnchor)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVG>())).mContextFlags as *const _ as usize },
            173usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVG),
                "::",
                stringify!(mContextFlags)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsStyleFilter {
        pub mType: u32,
        pub mFilterParameter: root::nsStyleCoord,
        pub __bindgen_anon_1: root::nsStyleFilter__bindgen_ty_1,
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsStyleFilter__bindgen_ty_1 {
        pub mURL: root::__BindgenUnionField<*mut root::mozilla::css::URLValue>,
        pub mDropShadow: root::__BindgenUnionField<root::mozilla::StyleSimpleShadow>,
        pub bindgen_union_field: [u64; 4usize],
    }
    #[test]
    fn bindgen_test_layout_nsStyleFilter__bindgen_ty_1() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleFilter__bindgen_ty_1>(),
            32usize,
            concat!("Size of: ", stringify!(nsStyleFilter__bindgen_ty_1))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleFilter__bindgen_ty_1>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleFilter__bindgen_ty_1))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleFilter__bindgen_ty_1>())).mURL as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFilter__bindgen_ty_1),
                "::",
                stringify!(mURL)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleFilter__bindgen_ty_1>())).mDropShadow as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFilter__bindgen_ty_1),
                "::",
                stringify!(mDropShadow)
            )
        );
    }
    pub const nsStyleFilter_kHasTriggerImageLoads: bool = false;
    #[test]
    fn bindgen_test_layout_nsStyleFilter() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleFilter>(),
            56usize,
            concat!("Size of: ", stringify!(nsStyleFilter))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleFilter>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleFilter))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleFilter>())).mType as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFilter),
                "::",
                stringify!(mType)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleFilter>())).mFilterParameter as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleFilter),
                "::",
                stringify!(mFilterParameter)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleSVGReset {
        pub mMask: root::nsStyleImageLayers,
        pub mClipPath: root::mozilla::StyleShapeSource,
        pub mStopColor: root::mozilla::StyleColor,
        pub mFloodColor: root::mozilla::StyleColor,
        pub mLightingColor: root::mozilla::StyleColor,
        pub mStopOpacity: f32,
        pub mFloodOpacity: f32,
        pub mDominantBaseline: u8,
        pub mVectorEffect: u8,
        pub mMaskType: u8,
    }
    pub const nsStyleSVGReset_kHasTriggerImageLoads: bool = true;
    #[test]
    fn bindgen_test_layout_nsStyleSVGReset() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleSVGReset>(),
            240usize,
            concat!("Size of: ", stringify!(nsStyleSVGReset))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleSVGReset>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleSVGReset))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVGReset>())).mMask as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVGReset),
                "::",
                stringify!(mMask)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVGReset>())).mClipPath as *const _ as usize },
            160usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVGReset),
                "::",
                stringify!(mClipPath)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVGReset>())).mStopColor as *const _ as usize },
            176usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVGReset),
                "::",
                stringify!(mStopColor)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVGReset>())).mFloodColor as *const _ as usize },
            192usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVGReset),
                "::",
                stringify!(mFloodColor)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleSVGReset>())).mLightingColor as *const _ as usize
            },
            208usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVGReset),
                "::",
                stringify!(mLightingColor)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleSVGReset>())).mStopOpacity as *const _ as usize
            },
            224usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVGReset),
                "::",
                stringify!(mStopOpacity)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleSVGReset>())).mFloodOpacity as *const _ as usize
            },
            228usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVGReset),
                "::",
                stringify!(mFloodOpacity)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleSVGReset>())).mDominantBaseline as *const _ as usize
            },
            232usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVGReset),
                "::",
                stringify!(mDominantBaseline)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleSVGReset>())).mVectorEffect as *const _ as usize
            },
            233usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVGReset),
                "::",
                stringify!(mVectorEffect)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleSVGReset>())).mMaskType as *const _ as usize },
            234usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleSVGReset),
                "::",
                stringify!(mMaskType)
            )
        );
    }
    #[repr(C)]
    pub struct nsStyleEffects {
        pub mFilters: root::nsTArray<root::nsStyleFilter>,
        pub mBoxShadow: root::mozilla::StyleOwnedSlice<root::mozilla::StyleBoxShadow>,
        pub mClip: root::nsRect,
        pub mOpacity: f32,
        pub mClipFlags: u8,
        pub mMixBlendMode: u8,
    }
    pub const nsStyleEffects_kHasTriggerImageLoads: bool = false;
    #[test]
    fn bindgen_test_layout_nsStyleEffects() {
        assert_eq!(
            ::std::mem::size_of::<nsStyleEffects>(),
            48usize,
            concat!("Size of: ", stringify!(nsStyleEffects))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyleEffects>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyleEffects))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleEffects>())).mFilters as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleEffects),
                "::",
                stringify!(mFilters)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleEffects>())).mBoxShadow as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleEffects),
                "::",
                stringify!(mBoxShadow)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleEffects>())).mClip as *const _ as usize },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleEffects),
                "::",
                stringify!(mClip)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleEffects>())).mOpacity as *const _ as usize },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleEffects),
                "::",
                stringify!(mOpacity)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsStyleEffects>())).mClipFlags as *const _ as usize },
            44usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleEffects),
                "::",
                stringify!(mClipFlags)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsStyleEffects>())).mMixBlendMode as *const _ as usize
            },
            45usize,
            concat!(
                "Offset of field: ",
                stringify!(nsStyleEffects),
                "::",
                stringify!(mMixBlendMode)
            )
        );
    }
    #[doc = " These *_Simple types are used to map Gecko types to layout-equivalent but"]
    #[doc = " simpler Rust types, to aid Rust binding generation."]
    #[doc = ""]
    #[doc = " If something in this types or the assertions below needs to change, ask"]
    #[doc = " bholley, heycam or emilio before!"]
    #[doc = ""]
    #[doc = " <div rustbindgen=\"true\" replaces=\"nsPoint\">"]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsPoint {
        pub x: root::nscoord,
        pub y: root::nscoord,
    }
    #[test]
    fn bindgen_test_layout_nsPoint() {
        assert_eq!(
            ::std::mem::size_of::<nsPoint>(),
            8usize,
            concat!("Size of: ", stringify!(nsPoint))
        );
        assert_eq!(
            ::std::mem::align_of::<nsPoint>(),
            4usize,
            concat!("Alignment of ", stringify!(nsPoint))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPoint>())).x as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPoint),
                "::",
                stringify!(x)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPoint>())).y as *const _ as usize },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPoint),
                "::",
                stringify!(y)
            )
        );
    }
    #[doc = " <div rustbindgen=\"true\" replaces=\"nsMargin\">"]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsMargin {
        pub top: root::nscoord,
        pub right: root::nscoord,
        pub bottom: root::nscoord,
        pub left: root::nscoord,
    }
    #[test]
    fn bindgen_test_layout_nsMargin() {
        assert_eq!(
            ::std::mem::size_of::<nsMargin>(),
            16usize,
            concat!("Size of: ", stringify!(nsMargin))
        );
        assert_eq!(
            ::std::mem::align_of::<nsMargin>(),
            4usize,
            concat!("Alignment of ", stringify!(nsMargin))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsMargin>())).top as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsMargin),
                "::",
                stringify!(top)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsMargin>())).right as *const _ as usize },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsMargin),
                "::",
                stringify!(right)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsMargin>())).bottom as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsMargin),
                "::",
                stringify!(bottom)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsMargin>())).left as *const _ as usize },
            12usize,
            concat!(
                "Offset of field: ",
                stringify!(nsMargin),
                "::",
                stringify!(left)
            )
        );
    }
    #[doc = " <div rustbindgen=\"true\" replaces=\"nsRect\">"]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsRect {
        pub x: root::nscoord,
        pub y: root::nscoord,
        pub width: root::nscoord,
        pub height: root::nscoord,
    }
    #[test]
    fn bindgen_test_layout_nsRect() {
        assert_eq!(
            ::std::mem::size_of::<nsRect>(),
            16usize,
            concat!("Size of: ", stringify!(nsRect))
        );
        assert_eq!(
            ::std::mem::align_of::<nsRect>(),
            4usize,
            concat!("Alignment of ", stringify!(nsRect))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsRect>())).x as *const _ as usize },
            0usize,
            concat!("Offset of field: ", stringify!(nsRect), "::", stringify!(x))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsRect>())).y as *const _ as usize },
            4usize,
            concat!("Offset of field: ", stringify!(nsRect), "::", stringify!(y))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsRect>())).width as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsRect),
                "::",
                stringify!(width)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsRect>())).height as *const _ as usize },
            12usize,
            concat!(
                "Offset of field: ",
                stringify!(nsRect),
                "::",
                stringify!(height)
            )
        );
    }
    #[doc = " <div rustbindgen=\"true\" replaces=\"nsSize\">"]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsSize {
        pub width: root::nscoord,
        pub height: root::nscoord,
    }
    #[test]
    fn bindgen_test_layout_nsSize() {
        assert_eq!(
            ::std::mem::size_of::<nsSize>(),
            8usize,
            concat!("Size of: ", stringify!(nsSize))
        );
        assert_eq!(
            ::std::mem::align_of::<nsSize>(),
            4usize,
            concat!("Alignment of ", stringify!(nsSize))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsSize>())).width as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsSize),
                "::",
                stringify!(width)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsSize>())).height as *const _ as usize },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsSize),
                "::",
                stringify!(height)
            )
        );
    }
    #[doc = " <div rustbindgen replaces=\"nsTArray\"></div>"]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsTArray<T> {
        pub mBuffer: *mut T,
        pub _phantom_0: ::std::marker::PhantomData<::std::cell::UnsafeCell<T>>,
    }
    #[doc = " <div rustbindgen replaces=\"nsCOMArray\"></div>"]
    #[doc = ""]
    #[doc = " mozilla::ArrayIterator doesn\'t work well with bindgen."]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsCOMArray {
        pub mBuffer: root::nsTArray<*mut root::nsISupports>,
    }
    pub type nsTObserverArray_base_index_type = usize;
    pub type nsTObserverArray_base_size_type = usize;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsTObserverArray_base_Iterator_base {
        pub mPosition: root::nsTObserverArray_base_index_type,
        pub mNext: *mut root::nsTObserverArray_base_Iterator_base,
    }
    #[test]
    fn bindgen_test_layout_nsTObserverArray_base_Iterator_base() {
        assert_eq!(
            ::std::mem::size_of::<nsTObserverArray_base_Iterator_base>(),
            16usize,
            concat!("Size of: ", stringify!(nsTObserverArray_base_Iterator_base))
        );
        assert_eq!(
            ::std::mem::align_of::<nsTObserverArray_base_Iterator_base>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(nsTObserverArray_base_Iterator_base)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsTObserverArray_base_Iterator_base>())).mPosition
                    as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsTObserverArray_base_Iterator_base),
                "::",
                stringify!(mPosition)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsTObserverArray_base_Iterator_base>())).mNext as *const _
                    as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsTObserverArray_base_Iterator_base),
                "::",
                stringify!(mNext)
            )
        );
    }
    pub type nsAutoTObserverArray_elem_type<T> = T;
    pub type nsAutoTObserverArray_array_type<T> = root::nsTArray<T>;
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsAutoTObserverArray_Iterator {
        pub _base: root::nsTObserverArray_base_Iterator_base,
        pub mArray: *mut root::nsAutoTObserverArray_Iterator_array_type,
    }
    pub type nsAutoTObserverArray_Iterator_array_type = u8;
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsAutoTObserverArray_ForwardIterator {
        pub _base: root::nsAutoTObserverArray_Iterator,
    }
    pub type nsAutoTObserverArray_ForwardIterator_array_type = u8;
    pub type nsAutoTObserverArray_ForwardIterator_base_type = root::nsAutoTObserverArray_Iterator;
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsAutoTObserverArray_EndLimitedIterator {
        pub _base: root::nsAutoTObserverArray_ForwardIterator,
        pub mEnd: root::nsAutoTObserverArray_ForwardIterator,
    }
    pub type nsAutoTObserverArray_EndLimitedIterator_array_type = u8;
    pub type nsAutoTObserverArray_EndLimitedIterator_base_type =
        root::nsAutoTObserverArray_Iterator;
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsAutoTObserverArray_BackwardIterator {
        pub _base: root::nsAutoTObserverArray_Iterator,
    }
    pub type nsAutoTObserverArray_BackwardIterator_array_type = u8;
    pub type nsAutoTObserverArray_BackwardIterator_base_type = root::nsAutoTObserverArray_Iterator;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsTObserverArray {
        pub _address: u8,
    }
    pub type nsTObserverArray_base_type = u8;
    pub type nsTObserverArray_size_type = root::nsTObserverArray_base_size_type;
    #[doc = " Hashtable key class to use with nsTHashtable/nsBaseHashtable"]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsURIHashKey {
        pub mKey: root::nsCOMPtr,
    }
    pub type nsURIHashKey_KeyType = *mut root::nsIURI;
    pub type nsURIHashKey_KeyTypePointer = *const root::nsIURI;
    pub const nsURIHashKey_ALLOW_MEMMOVE: root::nsURIHashKey__bindgen_ty_1 = 1;
    pub type nsURIHashKey__bindgen_ty_1 = u32;
    #[test]
    fn bindgen_test_layout_nsURIHashKey() {
        assert_eq!(
            ::std::mem::size_of::<nsURIHashKey>(),
            8usize,
            concat!("Size of: ", stringify!(nsURIHashKey))
        );
        assert_eq!(
            ::std::mem::align_of::<nsURIHashKey>(),
            8usize,
            concat!("Alignment of ", stringify!(nsURIHashKey))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsURIHashKey>())).mKey as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsURIHashKey),
                "::",
                stringify!(mKey)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIConsoleReportCollector {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsLayoutStylesheetCacheShm {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsICSSLoaderObserver {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsICSSLoaderObserver_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsICSSLoaderObserver() {
        assert_eq!(
            ::std::mem::size_of::<nsICSSLoaderObserver>(),
            8usize,
            concat!("Size of: ", stringify!(nsICSSLoaderObserver))
        );
        assert_eq!(
            ::std::mem::align_of::<nsICSSLoaderObserver>(),
            8usize,
            concat!("Alignment of ", stringify!(nsICSSLoaderObserver))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIStyleSheetLinkingElement {
        pub _base: root::nsISupports,
    }
    pub const nsIStyleSheetLinkingElement_ForceUpdate_No:
        root::nsIStyleSheetLinkingElement_ForceUpdate = 0;
    pub const nsIStyleSheetLinkingElement_ForceUpdate_Yes:
        root::nsIStyleSheetLinkingElement_ForceUpdate = 1;
    pub type nsIStyleSheetLinkingElement_ForceUpdate = u8;
    pub const nsIStyleSheetLinkingElement_Completed_No:
        root::nsIStyleSheetLinkingElement_Completed = 0;
    pub const nsIStyleSheetLinkingElement_Completed_Yes:
        root::nsIStyleSheetLinkingElement_Completed = 1;
    pub type nsIStyleSheetLinkingElement_Completed = u8;
    pub const nsIStyleSheetLinkingElement_HasAlternateRel_No:
        root::nsIStyleSheetLinkingElement_HasAlternateRel = 0;
    pub const nsIStyleSheetLinkingElement_HasAlternateRel_Yes:
        root::nsIStyleSheetLinkingElement_HasAlternateRel = 1;
    pub type nsIStyleSheetLinkingElement_HasAlternateRel = u8;
    pub const nsIStyleSheetLinkingElement_IsAlternate_No:
        root::nsIStyleSheetLinkingElement_IsAlternate = 0;
    pub const nsIStyleSheetLinkingElement_IsAlternate_Yes:
        root::nsIStyleSheetLinkingElement_IsAlternate = 1;
    pub type nsIStyleSheetLinkingElement_IsAlternate = u8;
    pub const nsIStyleSheetLinkingElement_IsInline_No: root::nsIStyleSheetLinkingElement_IsInline =
        0;
    pub const nsIStyleSheetLinkingElement_IsInline_Yes: root::nsIStyleSheetLinkingElement_IsInline =
        1;
    pub type nsIStyleSheetLinkingElement_IsInline = u8;
    pub const nsIStyleSheetLinkingElement_IsExplicitlyEnabled_No:
        root::nsIStyleSheetLinkingElement_IsExplicitlyEnabled = 0;
    pub const nsIStyleSheetLinkingElement_IsExplicitlyEnabled_Yes:
        root::nsIStyleSheetLinkingElement_IsExplicitlyEnabled = 1;
    pub type nsIStyleSheetLinkingElement_IsExplicitlyEnabled = u8;
    pub const nsIStyleSheetLinkingElement_MediaMatched_Yes:
        root::nsIStyleSheetLinkingElement_MediaMatched = 0;
    pub const nsIStyleSheetLinkingElement_MediaMatched_No:
        root::nsIStyleSheetLinkingElement_MediaMatched = 1;
    pub type nsIStyleSheetLinkingElement_MediaMatched = u8;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIStyleSheetLinkingElement_Update {
        pub mWillNotify: bool,
        pub mIsAlternate: bool,
        pub mMediaMatched: bool,
    }
    #[test]
    fn bindgen_test_layout_nsIStyleSheetLinkingElement_Update() {
        assert_eq!(
            ::std::mem::size_of::<nsIStyleSheetLinkingElement_Update>(),
            3usize,
            concat!("Size of: ", stringify!(nsIStyleSheetLinkingElement_Update))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIStyleSheetLinkingElement_Update>(),
            1usize,
            concat!(
                "Alignment of ",
                stringify!(nsIStyleSheetLinkingElement_Update)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIStyleSheetLinkingElement_Update>())).mWillNotify
                    as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIStyleSheetLinkingElement_Update),
                "::",
                stringify!(mWillNotify)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIStyleSheetLinkingElement_Update>())).mIsAlternate
                    as *const _ as usize
            },
            1usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIStyleSheetLinkingElement_Update),
                "::",
                stringify!(mIsAlternate)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIStyleSheetLinkingElement_Update>())).mMediaMatched
                    as *const _ as usize
            },
            2usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIStyleSheetLinkingElement_Update),
                "::",
                stringify!(mMediaMatched)
            )
        );
    }
    #[repr(C)]
    pub struct nsIStyleSheetLinkingElement_SheetInfo {
        pub mContent: *mut root::nsIContent,
        pub mURI: root::nsCOMPtr,
        pub mTriggeringPrincipal: root::nsCOMPtr,
        pub mReferrerPolicy: root::mozilla::net::ReferrerPolicy,
        pub mCORSMode: root::mozilla::CORSMode,
        pub mTitle: ::gecko_bindings::structs::nsString,
        pub mMedia: ::gecko_bindings::structs::nsString,
        pub mIntegrity: ::gecko_bindings::structs::nsString,
        pub mHasAlternateRel: bool,
        pub mIsInline: bool,
        pub mIsExplicitlyEnabled: root::nsIStyleSheetLinkingElement_IsExplicitlyEnabled,
    }
    #[test]
    fn bindgen_test_layout_nsIStyleSheetLinkingElement_SheetInfo() {
        assert_eq!(
            ::std::mem::size_of::<nsIStyleSheetLinkingElement_SheetInfo>(),
            88usize,
            concat!(
                "Size of: ",
                stringify!(nsIStyleSheetLinkingElement_SheetInfo)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<nsIStyleSheetLinkingElement_SheetInfo>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(nsIStyleSheetLinkingElement_SheetInfo)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIStyleSheetLinkingElement_SheetInfo>())).mContent
                    as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIStyleSheetLinkingElement_SheetInfo),
                "::",
                stringify!(mContent)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIStyleSheetLinkingElement_SheetInfo>())).mURI as *const _
                    as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIStyleSheetLinkingElement_SheetInfo),
                "::",
                stringify!(mURI)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIStyleSheetLinkingElement_SheetInfo>()))
                    .mTriggeringPrincipal as *const _ as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIStyleSheetLinkingElement_SheetInfo),
                "::",
                stringify!(mTriggeringPrincipal)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIStyleSheetLinkingElement_SheetInfo>())).mReferrerPolicy
                    as *const _ as usize
            },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIStyleSheetLinkingElement_SheetInfo),
                "::",
                stringify!(mReferrerPolicy)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIStyleSheetLinkingElement_SheetInfo>())).mCORSMode
                    as *const _ as usize
            },
            28usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIStyleSheetLinkingElement_SheetInfo),
                "::",
                stringify!(mCORSMode)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIStyleSheetLinkingElement_SheetInfo>())).mTitle as *const _
                    as usize
            },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIStyleSheetLinkingElement_SheetInfo),
                "::",
                stringify!(mTitle)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIStyleSheetLinkingElement_SheetInfo>())).mMedia as *const _
                    as usize
            },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIStyleSheetLinkingElement_SheetInfo),
                "::",
                stringify!(mMedia)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIStyleSheetLinkingElement_SheetInfo>())).mIntegrity
                    as *const _ as usize
            },
            64usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIStyleSheetLinkingElement_SheetInfo),
                "::",
                stringify!(mIntegrity)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIStyleSheetLinkingElement_SheetInfo>())).mHasAlternateRel
                    as *const _ as usize
            },
            80usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIStyleSheetLinkingElement_SheetInfo),
                "::",
                stringify!(mHasAlternateRel)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIStyleSheetLinkingElement_SheetInfo>())).mIsInline
                    as *const _ as usize
            },
            81usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIStyleSheetLinkingElement_SheetInfo),
                "::",
                stringify!(mIsInline)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIStyleSheetLinkingElement_SheetInfo>()))
                    .mIsExplicitlyEnabled as *const _ as usize
            },
            82usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIStyleSheetLinkingElement_SheetInfo),
                "::",
                stringify!(mIsExplicitlyEnabled)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIStyleSheetLinkingElement_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIStyleSheetLinkingElement() {
        assert_eq!(
            ::std::mem::size_of::<nsIStyleSheetLinkingElement>(),
            8usize,
            concat!("Size of: ", stringify!(nsIStyleSheetLinkingElement))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIStyleSheetLinkingElement>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIStyleSheetLinkingElement))
        );
    }
    pub const kNameSpaceID_None: i32 = 0;
    pub mod xpt {
        #[allow(unused_imports)]
        use self::super::super::root;
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIVariant {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIVariant_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIVariant() {
        assert_eq!(
            ::std::mem::size_of::<nsIVariant>(),
            8usize,
            concat!("Size of: ", stringify!(nsIVariant))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIVariant>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIVariant))
        );
    }
    #[repr(C)]
    pub struct nsNodeInfoManager {
        pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
        pub mNodeInfoHash: [u64; 4usize],
        pub mDocument: *mut root::mozilla::dom::Document,
        pub mNonDocumentNodeInfos: u32,
        pub mPrincipal: root::nsCOMPtr,
        pub mDefaultPrincipal: root::nsCOMPtr,
        pub mTextNodeInfo: *mut root::mozilla::dom::NodeInfo,
        pub mCommentNodeInfo: *mut root::mozilla::dom::NodeInfo,
        pub mDocumentNodeInfo: *mut root::mozilla::dom::NodeInfo,
        pub mBindingManager: root::RefPtr<root::nsBindingManager>,
        pub mRecentlyUsedNodeInfos: root::nsNodeInfoManager_NodeInfoCache,
        pub mSVGEnabled: [u8; 2usize],
        pub mMathMLEnabled: [u8; 2usize],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsNodeInfoManager_cycleCollection {
        pub _base: root::nsCycleCollectionParticipant,
    }
    #[test]
    fn bindgen_test_layout_nsNodeInfoManager_cycleCollection() {
        assert_eq!(
            ::std::mem::size_of::<nsNodeInfoManager_cycleCollection>(),
            16usize,
            concat!("Size of: ", stringify!(nsNodeInfoManager_cycleCollection))
        );
        assert_eq!(
            ::std::mem::align_of::<nsNodeInfoManager_cycleCollection>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(nsNodeInfoManager_cycleCollection)
            )
        );
    }
    pub type nsNodeInfoManager_HasThreadSafeRefCnt = root::mozilla::FalseType;
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsNodeInfoManager_NodeInfoInnerKey {
        pub _base: root::nsPtrHashKey<root::mozilla::dom::NodeInfo_NodeInfoInner>,
    }
    #[test]
    fn bindgen_test_layout_nsNodeInfoManager_NodeInfoInnerKey() {
        assert_eq!(
            ::std::mem::size_of::<nsNodeInfoManager_NodeInfoInnerKey>(),
            8usize,
            concat!("Size of: ", stringify!(nsNodeInfoManager_NodeInfoInnerKey))
        );
        assert_eq!(
            ::std::mem::align_of::<nsNodeInfoManager_NodeInfoInnerKey>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(nsNodeInfoManager_NodeInfoInnerKey)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsNodeInfoManager_NodeInfoCache {
        pub _base: [u64; 31usize],
    }
    #[test]
    fn bindgen_test_layout_nsNodeInfoManager_NodeInfoCache() {
        assert_eq!(
            ::std::mem::size_of::<nsNodeInfoManager_NodeInfoCache>(),
            248usize,
            concat!("Size of: ", stringify!(nsNodeInfoManager_NodeInfoCache))
        );
        assert_eq!(
            ::std::mem::align_of::<nsNodeInfoManager_NodeInfoCache>(),
            8usize,
            concat!("Alignment of ", stringify!(nsNodeInfoManager_NodeInfoCache))
        );
    }
    extern "C" {
        #[link_name = "\u{1}_ZN17nsNodeInfoManager21_cycleCollectorGlobalE"]
        pub static mut nsNodeInfoManager__cycleCollectorGlobal:
            root::nsNodeInfoManager_cycleCollection;
    }
    #[test]
    fn bindgen_test_layout_nsNodeInfoManager() {
        assert_eq!(
            ::std::mem::size_of::<nsNodeInfoManager>(),
            360usize,
            concat!("Size of: ", stringify!(nsNodeInfoManager))
        );
        assert_eq!(
            ::std::mem::align_of::<nsNodeInfoManager>(),
            8usize,
            concat!("Alignment of ", stringify!(nsNodeInfoManager))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsNodeInfoManager>())).mRefCnt as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNodeInfoManager),
                "::",
                stringify!(mRefCnt)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsNodeInfoManager>())).mNodeInfoHash as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNodeInfoManager),
                "::",
                stringify!(mNodeInfoHash)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsNodeInfoManager>())).mDocument as *const _ as usize },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNodeInfoManager),
                "::",
                stringify!(mDocument)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsNodeInfoManager>())).mNonDocumentNodeInfos as *const _
                    as usize
            },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNodeInfoManager),
                "::",
                stringify!(mNonDocumentNodeInfos)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsNodeInfoManager>())).mPrincipal as *const _ as usize
            },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNodeInfoManager),
                "::",
                stringify!(mPrincipal)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsNodeInfoManager>())).mDefaultPrincipal as *const _ as usize
            },
            64usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNodeInfoManager),
                "::",
                stringify!(mDefaultPrincipal)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsNodeInfoManager>())).mTextNodeInfo as *const _ as usize
            },
            72usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNodeInfoManager),
                "::",
                stringify!(mTextNodeInfo)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsNodeInfoManager>())).mCommentNodeInfo as *const _ as usize
            },
            80usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNodeInfoManager),
                "::",
                stringify!(mCommentNodeInfo)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsNodeInfoManager>())).mDocumentNodeInfo as *const _ as usize
            },
            88usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNodeInfoManager),
                "::",
                stringify!(mDocumentNodeInfo)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsNodeInfoManager>())).mBindingManager as *const _ as usize
            },
            96usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNodeInfoManager),
                "::",
                stringify!(mBindingManager)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsNodeInfoManager>())).mRecentlyUsedNodeInfos as *const _
                    as usize
            },
            104usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNodeInfoManager),
                "::",
                stringify!(mRecentlyUsedNodeInfos)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsNodeInfoManager>())).mSVGEnabled as *const _ as usize
            },
            352usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNodeInfoManager),
                "::",
                stringify!(mSVGEnabled)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsNodeInfoManager>())).mMathMLEnabled as *const _ as usize
            },
            354usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNodeInfoManager),
                "::",
                stringify!(mMathMLEnabled)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsPropertyTable {
        pub mPropertyList: *mut root::nsPropertyTable_PropertyList,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsPropertyTable_PropertyList {
        _unused: [u8; 0],
    }
    #[test]
    fn bindgen_test_layout_nsPropertyTable() {
        assert_eq!(
            ::std::mem::size_of::<nsPropertyTable>(),
            8usize,
            concat!("Size of: ", stringify!(nsPropertyTable))
        );
        assert_eq!(
            ::std::mem::align_of::<nsPropertyTable>(),
            8usize,
            concat!("Alignment of ", stringify!(nsPropertyTable))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPropertyTable>())).mPropertyList as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPropertyTable),
                "::",
                stringify!(mPropertyList)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsAttrChildContentList {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsRange {
        _unused: [u8; 0],
    }
    pub const NODE_HAS_LISTENERMANAGER: root::_bindgen_ty_30 = 2;
    pub const NODE_HAS_PROPERTIES: root::_bindgen_ty_30 = 4;
    pub const NODE_IS_ANONYMOUS_ROOT: root::_bindgen_ty_30 = 8;
    pub const NODE_IS_IN_NATIVE_ANONYMOUS_SUBTREE: root::_bindgen_ty_30 = 16;
    pub const NODE_IS_NATIVE_ANONYMOUS_ROOT: root::_bindgen_ty_30 = 32;
    pub const NODE_MAY_BE_IN_BINDING_MNGR: root::_bindgen_ty_30 = 64;
    pub const NODE_IS_EDITABLE: root::_bindgen_ty_30 = 128;
    pub const NODE_IS_IN_SHADOW_TREE: root::_bindgen_ty_30 = 512;
    pub const NODE_HAS_EMPTY_SELECTOR: root::_bindgen_ty_30 = 1024;
    pub const NODE_HAS_SLOW_SELECTOR: root::_bindgen_ty_30 = 2048;
    pub const NODE_HAS_EDGE_CHILD_SELECTOR: root::_bindgen_ty_30 = 4096;
    pub const NODE_HAS_SLOW_SELECTOR_LATER_SIBLINGS: root::_bindgen_ty_30 = 8192;
    pub const NODE_ALL_SELECTOR_FLAGS: root::_bindgen_ty_30 = 15360;
    pub const NODE_NEEDS_FRAME: root::_bindgen_ty_30 = 16384;
    pub const NODE_DESCENDANTS_NEED_FRAMES: root::_bindgen_ty_30 = 32768;
    pub const NODE_HAS_ACCESSKEY: root::_bindgen_ty_30 = 65536;
    pub const NODE_HAS_DIRECTION_RTL: root::_bindgen_ty_30 = 131072;
    pub const NODE_HAS_DIRECTION_LTR: root::_bindgen_ty_30 = 262144;
    pub const NODE_ALL_DIRECTION_FLAGS: root::_bindgen_ty_30 = 393216;
    pub const NODE_HAS_BEEN_IN_UA_WIDGET: root::_bindgen_ty_30 = 524288;
    pub const NODE_TYPE_SPECIFIC_BITS_OFFSET: root::_bindgen_ty_30 = 19;
    pub type _bindgen_ty_30 = u32;
    #[doc = " A class that implements nsIWeakReference"]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsNodeWeakReference {
        pub _base: root::nsIWeakReference,
        pub mRefCnt: root::nsAutoRefCnt,
    }
    pub type nsNodeWeakReference_HasThreadSafeRefCnt = root::mozilla::FalseType;
    #[test]
    fn bindgen_test_layout_nsNodeWeakReference() {
        assert_eq!(
            ::std::mem::size_of::<nsNodeWeakReference>(),
            24usize,
            concat!("Size of: ", stringify!(nsNodeWeakReference))
        );
        assert_eq!(
            ::std::mem::align_of::<nsNodeWeakReference>(),
            8usize,
            concat!("Alignment of ", stringify!(nsNodeWeakReference))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsNodeWeakReference>())).mRefCnt as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNodeWeakReference),
                "::",
                stringify!(mRefCnt)
            )
        );
    }
    #[doc = " An internal interface that abstracts some DOMNode-related parts that both"]
    #[doc = " nsIContent and Document share.  An instance of this interface has a list"]
    #[doc = " of nsIContent children and provides access to them."]
    #[repr(C)]
    pub struct nsINode {
        pub _base: root::mozilla::dom::EventTarget,
        pub mNodeInfo: root::RefPtr<root::mozilla::dom::NodeInfo>,
        pub mParent: *mut root::nsINode,
        pub mChildCount: u32,
        pub mFirstChild: root::nsCOMPtr,
        pub mNextSibling: root::nsCOMPtr,
        pub mPreviousOrLastSibling: *mut root::nsIContent,
        pub __bindgen_anon_1: root::nsINode__bindgen_ty_2,
        pub mSlots: *mut root::nsINode_nsSlots,
    }
    pub type nsINode_BoxQuadOptions = root::mozilla::dom::BoxQuadOptions;
    pub type nsINode_ConvertCoordinateOptions = root::mozilla::dom::ConvertCoordinateOptions;
    pub type nsINode_DocGroup = root::mozilla::dom::DocGroup;
    pub type nsINode_Document = root::mozilla::dom::Document;
    pub type nsINode_DOMPoint = root::mozilla::dom::DOMPoint;
    pub type nsINode_DOMPointInit = root::mozilla::dom::DOMPointInit;
    pub type nsINode_DOMQuad = root::mozilla::dom::DOMQuad;
    pub type nsINode_DOMRectReadOnly = root::mozilla::dom::DOMRectReadOnly;
    pub type nsINode_OwningNodeOrString = root::mozilla::dom::OwningNodeOrString;
    pub type nsINode_TextOrElementOrDocument = root::mozilla::dom::TextOrElementOrDocument;
    pub use self::super::root::mozilla::dom::CallerType as nsINode_CallerType;
    pub type nsINode_ErrorResult = root::mozilla::ErrorResult;
    pub type nsINode_Sequence = u8;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsINode_COMTypeInfo {
        pub _address: u8,
    }
    #[doc = " form control elements"]
    pub const nsINode_eHTML_FORM_CONTROL: root::nsINode__bindgen_ty_1 = 64;
    #[doc = " animation elements"]
    pub const nsINode_eANIMATION: root::nsINode__bindgen_ty_1 = 1024;
    #[doc = " filter elements that implement SVGFilterPrimitiveStandardAttributes"]
    pub const nsINode_eFILTER: root::nsINode__bindgen_ty_1 = 2048;
    #[doc = " SVGGeometryElement"]
    pub const nsINode_eSHAPE: root::nsINode__bindgen_ty_1 = 4096;
    #[doc = " Bit-flags to pass (or\'ed together) to IsNodeOfType()"]
    pub type nsINode__bindgen_ty_1 = u32;
    pub const nsINode_FlattenedParentType_eNotForStyle: root::nsINode_FlattenedParentType = 0;
    pub const nsINode_FlattenedParentType_eForStyle: root::nsINode_FlattenedParentType = 1;
    pub type nsINode_FlattenedParentType = u32;
    #[repr(C)]
    pub struct nsINode_nsSlots__bindgen_vtable(::std::os::raw::c_void);
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsINode_nsSlots {
        pub vtable_: *const nsINode_nsSlots__bindgen_vtable,
        #[doc = " A list of mutation observers"]
        pub mMutationObservers: [u64; 4usize],
        #[doc = " An object implementing NodeList for this content (childNodes)"]
        #[doc = " @see NodeList"]
        #[doc = " @see nsGenericHTMLElement::GetChildNodes"]
        pub mChildNodes: root::RefPtr<root::nsAttrChildContentList>,
        #[doc = " Weak reference to this node.  This is cleared by the destructor of"]
        #[doc = " nsNodeWeakReference."]
        pub mWeakReference: *mut root::nsNodeWeakReference,
        #[doc = " A set of ranges which are in the selection and which have this node as"]
        #[doc = " their endpoints\' common ancestor.  This is a UniquePtr instead of just a"]
        #[doc = " LinkedList, because that prevents us from pushing DOMSlots up to the next"]
        #[doc = " allocation bucket size, at the cost of some complexity."]
        pub mCommonAncestorRanges: root::mozilla::UniquePtr<root::mozilla::LinkedList>,
    }
    #[test]
    fn bindgen_test_layout_nsINode_nsSlots() {
        assert_eq!(
            ::std::mem::size_of::<nsINode_nsSlots>(),
            64usize,
            concat!("Size of: ", stringify!(nsINode_nsSlots))
        );
        assert_eq!(
            ::std::mem::align_of::<nsINode_nsSlots>(),
            8usize,
            concat!("Alignment of ", stringify!(nsINode_nsSlots))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsINode_nsSlots>())).mMutationObservers as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsINode_nsSlots),
                "::",
                stringify!(mMutationObservers)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsINode_nsSlots>())).mChildNodes as *const _ as usize },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsINode_nsSlots),
                "::",
                stringify!(mChildNodes)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsINode_nsSlots>())).mWeakReference as *const _ as usize
            },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(nsINode_nsSlots),
                "::",
                stringify!(mWeakReference)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsINode_nsSlots>())).mCommonAncestorRanges as *const _
                    as usize
            },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(nsINode_nsSlots),
                "::",
                stringify!(mCommonAncestorRanges)
            )
        );
    }
    #[repr(u32)]
    #[doc = " Boolean flags"]
    #[derive(Debug, Copy, Clone, PartialEq, Eq, Hash)]
    pub enum nsINode_BooleanFlag {
        NodeHasRenderingObservers = 0,
        IsInDocument = 1,
        IsConnected = 2,
        ParentIsContent = 3,
        NodeIsElement = 4,
        ElementHasID = 5,
        ElementMayHaveClass = 6,
        ElementMayHaveStyle = 7,
        ElementHasName = 8,
        ElementMayHaveContentEditableAttr = 9,
        NodeIsCommonAncestorForRangeInSelection = 10,
        NodeIsDescendantOfCommonAncestorForRangeInSelection = 11,
        NodeIsCCMarkedRoot = 12,
        NodeIsCCBlackTree = 13,
        NodeIsPurpleRoot = 14,
        ElementHasLockedStyleStates = 15,
        ElementHasPointerLock = 16,
        NodeMayHaveDOMMutationObserver = 17,
        NodeIsContent = 18,
        ElementHasAnimations = 19,
        NodeHasValidDirAttribute = 20,
        NodeHasDirAutoSet = 21,
        NodeHasTextNodeDirectionalityMap = 22,
        NodeAncestorHasDirAuto = 23,
        NodeHandlingClick = 24,
        ElementHasWeirdParserInsertionMode = 25,
        ParserHasNotified = 26,
        MayBeApzAware = 27,
        ElementMayHaveAnonymousChildren = 28,
        ElementHasCustomElementData = 29,
        BooleanFlagCount = 30,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsINode__bindgen_ty_2 {
        pub mPrimaryFrame: root::__BindgenUnionField<*mut root::nsIFrame>,
        pub mSubtreeRoot: root::__BindgenUnionField<*mut root::nsINode>,
        pub bindgen_union_field: u64,
    }
    #[test]
    fn bindgen_test_layout_nsINode__bindgen_ty_2() {
        assert_eq!(
            ::std::mem::size_of::<nsINode__bindgen_ty_2>(),
            8usize,
            concat!("Size of: ", stringify!(nsINode__bindgen_ty_2))
        );
        assert_eq!(
            ::std::mem::align_of::<nsINode__bindgen_ty_2>(),
            8usize,
            concat!("Alignment of ", stringify!(nsINode__bindgen_ty_2))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsINode__bindgen_ty_2>())).mPrimaryFrame as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsINode__bindgen_ty_2),
                "::",
                stringify!(mPrimaryFrame)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsINode__bindgen_ty_2>())).mSubtreeRoot as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsINode__bindgen_ty_2),
                "::",
                stringify!(mSubtreeRoot)
            )
        );
    }
    pub const nsINode_ELEMENT_NODE: ::std::os::raw::c_ushort = 1;
    pub const nsINode_ATTRIBUTE_NODE: ::std::os::raw::c_ushort = 2;
    pub const nsINode_TEXT_NODE: ::std::os::raw::c_ushort = 3;
    pub const nsINode_CDATA_SECTION_NODE: ::std::os::raw::c_ushort = 4;
    pub const nsINode_ENTITY_REFERENCE_NODE: ::std::os::raw::c_ushort = 5;
    pub const nsINode_ENTITY_NODE: ::std::os::raw::c_ushort = 6;
    pub const nsINode_PROCESSING_INSTRUCTION_NODE: ::std::os::raw::c_ushort = 7;
    pub const nsINode_COMMENT_NODE: ::std::os::raw::c_ushort = 8;
    pub const nsINode_DOCUMENT_NODE: ::std::os::raw::c_ushort = 9;
    pub const nsINode_DOCUMENT_TYPE_NODE: ::std::os::raw::c_ushort = 10;
    pub const nsINode_DOCUMENT_FRAGMENT_NODE: ::std::os::raw::c_ushort = 11;
    pub const nsINode_NOTATION_NODE: ::std::os::raw::c_ushort = 12;
    #[test]
    fn bindgen_test_layout_nsINode() {
        assert_eq!(
            ::std::mem::size_of::<nsINode>(),
            96usize,
            concat!("Size of: ", stringify!(nsINode))
        );
        assert_eq!(
            ::std::mem::align_of::<nsINode>(),
            8usize,
            concat!("Alignment of ", stringify!(nsINode))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsINode>())).mNodeInfo as *const _ as usize },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsINode),
                "::",
                stringify!(mNodeInfo)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsINode>())).mParent as *const _ as usize },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsINode),
                "::",
                stringify!(mParent)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsINode>())).mChildCount as *const _ as usize },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(nsINode),
                "::",
                stringify!(mChildCount)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsINode>())).mFirstChild as *const _ as usize },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(nsINode),
                "::",
                stringify!(mFirstChild)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsINode>())).mNextSibling as *const _ as usize },
            64usize,
            concat!(
                "Offset of field: ",
                stringify!(nsINode),
                "::",
                stringify!(mNextSibling)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsINode>())).mPreviousOrLastSibling as *const _ as usize
            },
            72usize,
            concat!(
                "Offset of field: ",
                stringify!(nsINode),
                "::",
                stringify!(mPreviousOrLastSibling)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsINode>())).mSlots as *const _ as usize },
            88usize,
            concat!(
                "Offset of field: ",
                stringify!(nsINode),
                "::",
                stringify!(mSlots)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIThreadObserver {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIThreadObserver_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIThreadObserver() {
        assert_eq!(
            ::std::mem::size_of::<nsIThreadObserver>(),
            8usize,
            concat!("Size of: ", stringify!(nsIThreadObserver))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIThreadObserver>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIThreadObserver))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsHTMLCSSStyleSheet {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsAttrName {
        pub mBits: usize,
    }
    #[test]
    fn bindgen_test_layout_nsAttrName() {
        assert_eq!(
            ::std::mem::size_of::<nsAttrName>(),
            8usize,
            concat!("Size of: ", stringify!(nsAttrName))
        );
        assert_eq!(
            ::std::mem::align_of::<nsAttrName>(),
            8usize,
            concat!("Alignment of ", stringify!(nsAttrName))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsAttrName>())).mBits as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsAttrName),
                "::",
                stringify!(mBits)
            )
        );
    }
    pub const NS_ATTRVALUE_BASETYPE_MASK: usize = 3;
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsAttrValue {
        pub mBits: usize,
    }
    pub const nsAttrValue_ValueType_eString: root::nsAttrValue_ValueType = 0;
    pub const nsAttrValue_ValueType_eAtom: root::nsAttrValue_ValueType = 2;
    pub const nsAttrValue_ValueType_eInteger: root::nsAttrValue_ValueType = 3;
    pub const nsAttrValue_ValueType_eColor: root::nsAttrValue_ValueType = 7;
    pub const nsAttrValue_ValueType_eEnum: root::nsAttrValue_ValueType = 11;
    pub const nsAttrValue_ValueType_ePercent: root::nsAttrValue_ValueType = 15;
    pub const nsAttrValue_ValueType_eCSSDeclaration: root::nsAttrValue_ValueType = 16;
    pub const nsAttrValue_ValueType_eURL: root::nsAttrValue_ValueType = 17;
    pub const nsAttrValue_ValueType_eImage: root::nsAttrValue_ValueType = 18;
    pub const nsAttrValue_ValueType_eAtomArray: root::nsAttrValue_ValueType = 19;
    pub const nsAttrValue_ValueType_eDoubleValue: root::nsAttrValue_ValueType = 20;
    pub const nsAttrValue_ValueType_eIntMarginValue: root::nsAttrValue_ValueType = 21;
    pub const nsAttrValue_ValueType_eSVGIntegerPair: root::nsAttrValue_ValueType = 22;
    pub const nsAttrValue_ValueType_eSVGTypesBegin: root::nsAttrValue_ValueType = 22;
    pub const nsAttrValue_ValueType_eSVGOrient: root::nsAttrValue_ValueType = 23;
    pub const nsAttrValue_ValueType_eSVGLength: root::nsAttrValue_ValueType = 24;
    pub const nsAttrValue_ValueType_eSVGLengthList: root::nsAttrValue_ValueType = 25;
    pub const nsAttrValue_ValueType_eSVGNumberList: root::nsAttrValue_ValueType = 26;
    pub const nsAttrValue_ValueType_eSVGNumberPair: root::nsAttrValue_ValueType = 27;
    pub const nsAttrValue_ValueType_eSVGPathData: root::nsAttrValue_ValueType = 28;
    pub const nsAttrValue_ValueType_eSVGPointList: root::nsAttrValue_ValueType = 29;
    pub const nsAttrValue_ValueType_eSVGPreserveAspectRatio: root::nsAttrValue_ValueType = 30;
    pub const nsAttrValue_ValueType_eSVGStringList: root::nsAttrValue_ValueType = 31;
    pub const nsAttrValue_ValueType_eSVGTransformList: root::nsAttrValue_ValueType = 32;
    pub const nsAttrValue_ValueType_eSVGViewBox: root::nsAttrValue_ValueType = 33;
    pub const nsAttrValue_ValueType_eSVGTypesEnd: root::nsAttrValue_ValueType = 33;
    pub type nsAttrValue_ValueType = u32;
    #[doc = " Structure for a mapping from int (enum) values to strings.  When you use"]
    #[doc = " it you generally create an array of them."]
    #[doc = " Instantiate like this:"]
    #[doc = " EnumTable myTable[] = {"]
    #[doc = "   { \"string1\", 1 },"]
    #[doc = "   { \"string2\", 2 },"]
    #[doc = "   { nullptr, 0 }"]
    #[doc = " }"]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsAttrValue_EnumTable {
        #[doc = " The string the value maps to"]
        pub tag: *const ::std::os::raw::c_char,
        #[doc = " The enum value that maps to this string"]
        pub value: i16,
    }
    #[test]
    fn bindgen_test_layout_nsAttrValue_EnumTable() {
        assert_eq!(
            ::std::mem::size_of::<nsAttrValue_EnumTable>(),
            16usize,
            concat!("Size of: ", stringify!(nsAttrValue_EnumTable))
        );
        assert_eq!(
            ::std::mem::align_of::<nsAttrValue_EnumTable>(),
            8usize,
            concat!("Alignment of ", stringify!(nsAttrValue_EnumTable))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsAttrValue_EnumTable>())).tag as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsAttrValue_EnumTable),
                "::",
                stringify!(tag)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsAttrValue_EnumTable>())).value as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsAttrValue_EnumTable),
                "::",
                stringify!(value)
            )
        );
    }
    pub const nsAttrValue_ValueBaseType_eStringBase: root::nsAttrValue_ValueBaseType = 0;
    pub const nsAttrValue_ValueBaseType_eOtherBase: root::nsAttrValue_ValueBaseType = 1;
    pub const nsAttrValue_ValueBaseType_eAtomBase: root::nsAttrValue_ValueBaseType = 2;
    pub const nsAttrValue_ValueBaseType_eIntegerBase: root::nsAttrValue_ValueBaseType = 3;
    pub type nsAttrValue_ValueBaseType = u32;
    extern "C" {
        #[link_name = "\u{1}_ZN11nsAttrValue15sEnumTableArrayE"]
        pub static mut nsAttrValue_sEnumTableArray:
            *mut root::nsTArray<*const root::nsAttrValue_EnumTable>;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN11nsAttrValue19sMiscContainerCacheE"]
        pub static mut nsAttrValue_sMiscContainerCache: *mut root::MiscContainer;
    }
    #[test]
    fn bindgen_test_layout_nsAttrValue() {
        assert_eq!(
            ::std::mem::size_of::<nsAttrValue>(),
            8usize,
            concat!("Size of: ", stringify!(nsAttrValue))
        );
        assert_eq!(
            ::std::mem::align_of::<nsAttrValue>(),
            8usize,
            concat!("Alignment of ", stringify!(nsAttrValue))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsAttrValue>())).mBits as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsAttrValue),
                "::",
                stringify!(mBits)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsMappedAttributes {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsHTMLStyleSheet {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct AttrArray {
        pub mImpl: root::mozilla::UniquePtr<root::AttrArray_Impl>,
    }
    pub type AttrArray_BorrowedAttrInfo = root::mozilla::dom::BorrowedAttrInfo;
    #[repr(C)]
    #[derive(Debug)]
    pub struct AttrArray_InternalAttr {
        pub mName: root::nsAttrName,
        pub mValue: root::nsAttrValue,
    }
    #[test]
    fn bindgen_test_layout_AttrArray_InternalAttr() {
        assert_eq!(
            ::std::mem::size_of::<AttrArray_InternalAttr>(),
            16usize,
            concat!("Size of: ", stringify!(AttrArray_InternalAttr))
        );
        assert_eq!(
            ::std::mem::align_of::<AttrArray_InternalAttr>(),
            8usize,
            concat!("Alignment of ", stringify!(AttrArray_InternalAttr))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<AttrArray_InternalAttr>())).mName as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(AttrArray_InternalAttr),
                "::",
                stringify!(mName)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<AttrArray_InternalAttr>())).mValue as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(AttrArray_InternalAttr),
                "::",
                stringify!(mValue)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct AttrArray_Impl {
        pub mAttrCount: u32,
        pub mCapacity: u32,
        pub mMappedAttrs: *mut root::nsMappedAttributes,
        pub mBuffer: root::__IncompleteArrayField<root::AttrArray_InternalAttr>,
    }
    #[test]
    fn bindgen_test_layout_AttrArray_Impl() {
        assert_eq!(
            ::std::mem::size_of::<AttrArray_Impl>(),
            16usize,
            concat!("Size of: ", stringify!(AttrArray_Impl))
        );
        assert_eq!(
            ::std::mem::align_of::<AttrArray_Impl>(),
            8usize,
            concat!("Alignment of ", stringify!(AttrArray_Impl))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<AttrArray_Impl>())).mAttrCount as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(AttrArray_Impl),
                "::",
                stringify!(mAttrCount)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<AttrArray_Impl>())).mCapacity as *const _ as usize },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(AttrArray_Impl),
                "::",
                stringify!(mCapacity)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<AttrArray_Impl>())).mMappedAttrs as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(AttrArray_Impl),
                "::",
                stringify!(mMappedAttrs)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<AttrArray_Impl>())).mBuffer as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(AttrArray_Impl),
                "::",
                stringify!(mBuffer)
            )
        );
    }
    #[test]
    fn bindgen_test_layout_AttrArray() {
        assert_eq!(
            ::std::mem::size_of::<AttrArray>(),
            8usize,
            concat!("Size of: ", stringify!(AttrArray))
        );
        assert_eq!(
            ::std::mem::align_of::<AttrArray>(),
            8usize,
            concat!("Alignment of ", stringify!(AttrArray))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<AttrArray>())).mImpl as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(AttrArray),
                "::",
                stringify!(mImpl)
            )
        );
    }
    #[doc = " The global object which keeps a script context for each supported script"]
    #[doc = " language. This often used to store per-window global state."]
    #[doc = " This is a heavyweight interface implemented only by DOM globals, and"]
    #[doc = " it might go away some time in the future."]
    #[repr(C)]
    pub struct nsIScriptGlobalObject {
        pub _base: root::nsIGlobalObject,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIScriptGlobalObject_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIScriptGlobalObject() {
        assert_eq!(
            ::std::mem::size_of::<nsIScriptGlobalObject>(),
            56usize,
            concat!("Size of: ", stringify!(nsIScriptGlobalObject))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIScriptGlobalObject>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIScriptGlobalObject))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIXPConnectJSObjectHolder {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIXPConnectJSObjectHolder_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIXPConnectJSObjectHolder() {
        assert_eq!(
            ::std::mem::size_of::<nsIXPConnectJSObjectHolder>(),
            8usize,
            concat!("Size of: ", stringify!(nsIXPConnectJSObjectHolder))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIXPConnectJSObjectHolder>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIXPConnectJSObjectHolder))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIXPConnectWrappedJS {
        pub _base: root::nsIXPConnectJSObjectHolder,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIXPConnectWrappedJS_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIXPConnectWrappedJS() {
        assert_eq!(
            ::std::mem::size_of::<nsIXPConnectWrappedJS>(),
            8usize,
            concat!("Size of: ", stringify!(nsIXPConnectWrappedJS))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIXPConnectWrappedJS>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIXPConnectWrappedJS))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIXPConnect {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIXPConnect_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIXPConnect() {
        assert_eq!(
            ::std::mem::size_of::<nsIXPConnect>(),
            8usize,
            concat!("Size of: ", stringify!(nsIXPConnect))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIXPConnect>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIXPConnect))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsICookieSettings {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsICookieSettings_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsICookieSettings() {
        assert_eq!(
            ::std::mem::size_of::<nsICookieSettings>(),
            8usize,
            concat!("Size of: ", stringify!(nsICookieSettings))
        );
        assert_eq!(
            ::std::mem::align_of::<nsICookieSettings>(),
            8usize,
            concat!("Alignment of ", stringify!(nsICookieSettings))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIApplicationCache {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIApplicationCache_COMTypeInfo {
        pub _address: u8,
    }
    pub const nsIApplicationCache_ITEM_MANIFEST: root::nsIApplicationCache__bindgen_ty_1 = 1;
    pub const nsIApplicationCache_ITEM_EXPLICIT: root::nsIApplicationCache__bindgen_ty_1 = 2;
    pub const nsIApplicationCache_ITEM_IMPLICIT: root::nsIApplicationCache__bindgen_ty_1 = 4;
    pub const nsIApplicationCache_ITEM_DYNAMIC: root::nsIApplicationCache__bindgen_ty_1 = 8;
    pub const nsIApplicationCache_ITEM_FOREIGN: root::nsIApplicationCache__bindgen_ty_1 = 16;
    pub const nsIApplicationCache_ITEM_FALLBACK: root::nsIApplicationCache__bindgen_ty_1 = 32;
    pub const nsIApplicationCache_ITEM_OPPORTUNISTIC: root::nsIApplicationCache__bindgen_ty_1 = 64;
    pub type nsIApplicationCache__bindgen_ty_1 = u32;
    #[test]
    fn bindgen_test_layout_nsIApplicationCache() {
        assert_eq!(
            ::std::mem::size_of::<nsIApplicationCache>(),
            8usize,
            concat!("Size of: ", stringify!(nsIApplicationCache))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIApplicationCache>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIApplicationCache))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIApplicationCacheContainer {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIApplicationCacheContainer_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIApplicationCacheContainer() {
        assert_eq!(
            ::std::mem::size_of::<nsIApplicationCacheContainer>(),
            8usize,
            concat!("Size of: ", stringify!(nsIApplicationCacheContainer))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIApplicationCacheContainer>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIApplicationCacheContainer))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIPrintSettings {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIContentViewer {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIContentViewer_COMTypeInfo {
        pub _address: u8,
    }
    pub const nsIContentViewer_ePrompt: root::nsIContentViewer__bindgen_ty_1 = 0;
    pub const nsIContentViewer_eDontPromptAndDontUnload: root::nsIContentViewer__bindgen_ty_1 = 1;
    pub const nsIContentViewer_eDontPromptAndUnload: root::nsIContentViewer__bindgen_ty_1 = 2;
    pub type nsIContentViewer__bindgen_ty_1 = u32;
    pub const nsIContentViewer_eDelayResize: root::nsIContentViewer__bindgen_ty_2 = 1;
    pub type nsIContentViewer__bindgen_ty_2 = u32;
    #[test]
    fn bindgen_test_layout_nsIContentViewer() {
        assert_eq!(
            ::std::mem::size_of::<nsIContentViewer>(),
            8usize,
            concat!("Size of: ", stringify!(nsIContentViewer))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIContentViewer>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIContentViewer))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIControllers {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIDOMXULCommandDispatcher {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIDOMXULCommandDispatcher_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIDOMXULCommandDispatcher() {
        assert_eq!(
            ::std::mem::size_of::<nsIDOMXULCommandDispatcher>(),
            8usize,
            concat!("Size of: ", stringify!(nsIDOMXULCommandDispatcher))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIDOMXULCommandDispatcher>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIDOMXULCommandDispatcher))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsILoadContext {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsILoadContext_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsILoadContext() {
        assert_eq!(
            ::std::mem::size_of::<nsILoadContext>(),
            8usize,
            concat!("Size of: ", stringify!(nsILoadContext))
        );
        assert_eq!(
            ::std::mem::align_of::<nsILoadContext>(),
            8usize,
            concat!("Alignment of ", stringify!(nsILoadContext))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsParserBase {
        pub _base: root::nsISupports,
    }
    #[test]
    fn bindgen_test_layout_nsParserBase() {
        assert_eq!(
            ::std::mem::size_of::<nsParserBase>(),
            8usize,
            concat!("Size of: ", stringify!(nsParserBase))
        );
        assert_eq!(
            ::std::mem::align_of::<nsParserBase>(),
            8usize,
            concat!("Alignment of ", stringify!(nsParserBase))
        );
    }
    #[doc = " This GECKO-INTERNAL interface is on track to being REMOVED (or refactored"]
    #[doc = " to the point of being near-unrecognizable)."]
    #[doc = ""]
    #[doc = " Please DO NOT #include this file in comm-central code, in your XULRunner"]
    #[doc = " app or binary extensions."]
    #[doc = ""]
    #[doc = " Please DO NOT #include this into new files even inside Gecko. It is more"]
    #[doc = " likely than not that #including this header is the wrong thing to do."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIParser {
        pub _base: root::nsParserBase,
    }
    pub type nsIParser_Encoding = root::mozilla::Encoding;
    pub type nsIParser_NotNull<T> = root::mozilla::NotNull<T>;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIParser_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIParser() {
        assert_eq!(
            ::std::mem::size_of::<nsIParser>(),
            8usize,
            concat!("Size of: ", stringify!(nsIParser))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIParser>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIParser))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIProgressEventSink {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIProgressEventSink_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIProgressEventSink() {
        assert_eq!(
            ::std::mem::size_of::<nsIProgressEventSink>(),
            8usize,
            concat!("Size of: ", stringify!(nsIProgressEventSink))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIProgressEventSink>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIProgressEventSink))
        );
    }
    #[doc = " A container that has multiple radio groups in it, defined by name."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIRadioGroupContainer {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIRadioGroupContainer_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIRadioGroupContainer() {
        assert_eq!(
            ::std::mem::size_of::<nsIRadioGroupContainer>(),
            8usize,
            concat!("Size of: ", stringify!(nsIRadioGroupContainer))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIRadioGroupContainer>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIRadioGroupContainer))
        );
    }
    #[doc = " JS Object Principal information."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIScriptObjectPrincipal {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIScriptObjectPrincipal_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIScriptObjectPrincipal() {
        assert_eq!(
            ::std::mem::size_of::<nsIScriptObjectPrincipal>(),
            8usize,
            concat!("Size of: ", stringify!(nsIScriptObjectPrincipal))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIScriptObjectPrincipal>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIScriptObjectPrincipal))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIUUIDGenerator {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIUUIDGenerator_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIUUIDGenerator() {
        assert_eq!(
            ::std::mem::size_of::<nsIUUIDGenerator>(),
            8usize,
            concat!("Size of: ", stringify!(nsIUUIDGenerator))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIUUIDGenerator>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIUUIDGenerator))
        );
    }
    pub type DOMHighResTimeStamp = f64;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct mozIDOMWindow {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct mozIDOMWindow_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_mozIDOMWindow() {
        assert_eq!(
            ::std::mem::size_of::<mozIDOMWindow>(),
            8usize,
            concat!("Size of: ", stringify!(mozIDOMWindow))
        );
        assert_eq!(
            ::std::mem::align_of::<mozIDOMWindow>(),
            8usize,
            concat!("Alignment of ", stringify!(mozIDOMWindow))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct mozIDOMWindowProxy {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct mozIDOMWindowProxy_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_mozIDOMWindowProxy() {
        assert_eq!(
            ::std::mem::size_of::<mozIDOMWindowProxy>(),
            8usize,
            concat!("Size of: ", stringify!(mozIDOMWindowProxy))
        );
        assert_eq!(
            ::std::mem::align_of::<mozIDOMWindowProxy>(),
            8usize,
            concat!("Alignment of ", stringify!(mozIDOMWindowProxy))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsICSSDeclaration {
        _unused: [u8; 0],
    }
    pub type SuspendTypes = u32;
    #[repr(C)]
    pub struct nsPIDOMWindowInner {
        pub _base: root::mozIDOMWindow,
        pub mChromeEventHandler: root::nsCOMPtr,
        pub mDoc: root::RefPtr<root::nsPIDOMWindowInner_Document>,
        pub mDocumentURI: root::nsCOMPtr,
        pub mDocBaseURI: root::nsCOMPtr,
        pub mParentTarget: root::nsCOMPtr,
        pub mPerformance: root::RefPtr<root::mozilla::dom::Performance>,
        pub mTimeoutManager: root::mozilla::UniquePtr<root::mozilla::dom::TimeoutManager>,
        pub mNavigator: root::RefPtr<root::mozilla::dom::Navigator>,
        pub mMutationBits: u32,
        pub mActivePeerConnections: u32,
        pub mIsDocumentLoaded: bool,
        pub mIsHandlingResizeEvent: bool,
        pub mMayHavePaintEventListener: bool,
        pub mMayHaveTouchEventListener: bool,
        pub mMayHaveSelectionChangeEventListener: bool,
        pub mMayHaveMouseEnterLeaveEventListener: bool,
        pub mMayHavePointerEnterLeaveEventListener: bool,
        pub mMayHaveTextEventListenerInDefaultGroup: bool,
        pub mOuterWindow: root::nsCOMPtr,
        pub mFocusedElement: root::RefPtr<root::mozilla::dom::Element>,
        pub mAudioContexts: root::nsTArray<*mut root::mozilla::dom::AudioContext>,
        pub mTabGroup: root::RefPtr<root::mozilla::dom::TabGroup>,
        pub mWindowID: u64,
        pub mHasNotifiedGlobalCreated: bool,
        pub mMarkedCCGeneration: u32,
        pub mTopInnerWindow: root::nsCOMPtr,
        pub mHasTriedToCacheTopInnerWindow: bool,
        pub mNumOfIndexedDBDatabases: u32,
        pub mNumOfOpenWebSockets: u32,
        pub mEvent: *mut root::mozilla::dom::Event,
        pub mReportingObservers:
            root::nsTArray<root::RefPtr<root::mozilla::dom::ReportingObserver>>,
        pub mReportRecords: root::nsTArray<root::RefPtr<root::mozilla::dom::Report>>,
        pub mStorageAccessGranted: root::nsTArray<::gecko_bindings::structs::nsCString>,
        pub mWindowGlobalChild: root::RefPtr<root::mozilla::dom::WindowGlobalChild>,
        pub mAfterLoadRunners: root::nsTArray<root::nsCOMPtr>,
    }
    pub type nsPIDOMWindowInner_Document = root::mozilla::dom::Document;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsPIDOMWindowInner_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsPIDOMWindowInner() {
        assert_eq!(
            ::std::mem::size_of::<nsPIDOMWindowInner>(),
            208usize,
            concat!("Size of: ", stringify!(nsPIDOMWindowInner))
        );
        assert_eq!(
            ::std::mem::align_of::<nsPIDOMWindowInner>(),
            8usize,
            concat!("Alignment of ", stringify!(nsPIDOMWindowInner))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mChromeEventHandler as *const _
                    as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mChromeEventHandler)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mDoc as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mDoc)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mDocumentURI as *const _ as usize
            },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mDocumentURI)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mDocBaseURI as *const _ as usize
            },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mDocBaseURI)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mParentTarget as *const _ as usize
            },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mParentTarget)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mPerformance as *const _ as usize
            },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mPerformance)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mTimeoutManager as *const _ as usize
            },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mTimeoutManager)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mNavigator as *const _ as usize
            },
            64usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mNavigator)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mMutationBits as *const _ as usize
            },
            72usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mMutationBits)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mActivePeerConnections as *const _
                    as usize
            },
            76usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mActivePeerConnections)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mIsDocumentLoaded as *const _
                    as usize
            },
            80usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mIsDocumentLoaded)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mIsHandlingResizeEvent as *const _
                    as usize
            },
            81usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mIsHandlingResizeEvent)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mMayHavePaintEventListener
                    as *const _ as usize
            },
            82usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mMayHavePaintEventListener)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mMayHaveTouchEventListener
                    as *const _ as usize
            },
            83usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mMayHaveTouchEventListener)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mMayHaveSelectionChangeEventListener
                    as *const _ as usize
            },
            84usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mMayHaveSelectionChangeEventListener)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mMayHaveMouseEnterLeaveEventListener
                    as *const _ as usize
            },
            85usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mMayHaveMouseEnterLeaveEventListener)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>()))
                    .mMayHavePointerEnterLeaveEventListener as *const _ as usize
            },
            86usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mMayHavePointerEnterLeaveEventListener)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>()))
                    .mMayHaveTextEventListenerInDefaultGroup as *const _ as usize
            },
            87usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mMayHaveTextEventListenerInDefaultGroup)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mOuterWindow as *const _ as usize
            },
            88usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mOuterWindow)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mFocusedElement as *const _ as usize
            },
            96usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mFocusedElement)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mAudioContexts as *const _ as usize
            },
            104usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mAudioContexts)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mTabGroup as *const _ as usize
            },
            112usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mTabGroup)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mWindowID as *const _ as usize
            },
            120usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mWindowID)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mHasNotifiedGlobalCreated as *const _
                    as usize
            },
            128usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mHasNotifiedGlobalCreated)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mMarkedCCGeneration as *const _
                    as usize
            },
            132usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mMarkedCCGeneration)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mTopInnerWindow as *const _ as usize
            },
            136usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mTopInnerWindow)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mHasTriedToCacheTopInnerWindow
                    as *const _ as usize
            },
            144usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mHasTriedToCacheTopInnerWindow)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mNumOfIndexedDBDatabases as *const _
                    as usize
            },
            148usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mNumOfIndexedDBDatabases)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mNumOfOpenWebSockets as *const _
                    as usize
            },
            152usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mNumOfOpenWebSockets)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mEvent as *const _ as usize },
            160usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mEvent)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mReportingObservers as *const _
                    as usize
            },
            168usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mReportingObservers)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mReportRecords as *const _ as usize
            },
            176usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mReportRecords)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mStorageAccessGranted as *const _
                    as usize
            },
            184usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mStorageAccessGranted)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mWindowGlobalChild as *const _
                    as usize
            },
            192usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mWindowGlobalChild)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowInner>())).mAfterLoadRunners as *const _
                    as usize
            },
            200usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowInner),
                "::",
                stringify!(mAfterLoadRunners)
            )
        );
    }
    #[repr(C)]
    pub struct nsPIDOMWindowOuter {
        pub _base: root::mozIDOMWindowProxy,
        pub mChromeEventHandler: root::nsCOMPtr,
        pub mDoc: root::RefPtr<root::nsPIDOMWindowOuter_Document>,
        pub mDocumentURI: root::nsCOMPtr,
        pub mParentTarget: root::nsCOMPtr,
        pub mMessageManager: root::RefPtr<root::mozilla::dom::ContentFrameMessageManager>,
        pub mFrameElement: root::nsCOMPtr,
        pub mDocShell: root::nsCOMPtr,
        pub mBrowsingContext: root::RefPtr<root::mozilla::dom::BrowsingContext>,
        pub mModalStateDepth: u32,
        pub mIsActive: bool,
        pub mIsBackground: bool,
        #[doc = " The suspended types can be \"disposable\" or \"permanent\". This varable only"]
        #[doc = " stores the value about permanent suspend."]
        #[doc = " - disposable"]
        #[doc = " To pause all playing media in that window, but doesn\'t affect the media"]
        #[doc = " which starts after that."]
        #[doc = ""]
        #[doc = " - permanent"]
        #[doc = " To pause all media in that window, and also affect the media which starts"]
        #[doc = " after that."]
        pub mMediaSuspend: root::SuspendTypes,
        pub mAudioMuted: bool,
        pub mAudioVolume: f32,
        pub mDesktopModeViewport: bool,
        pub mIsRootOuterWindow: bool,
        pub mInnerWindow: *mut root::nsPIDOMWindowInner,
        pub mTabGroup: root::RefPtr<root::mozilla::dom::TabGroup>,
        pub mWindowID: u64,
        pub mMarkedCCGeneration: u32,
        pub mServiceWorkersTestingEnabled: bool,
        pub mLargeAllocStatus: root::mozilla::dom::LargeAllocStatus,
        pub mOpenerForInitialContentBrowser: root::RefPtr<root::mozilla::dom::BrowsingContext>,
    }
    pub type nsPIDOMWindowOuter_Document = root::mozilla::dom::Document;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsPIDOMWindowOuter_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsPIDOMWindowOuter() {
        assert_eq!(
            ::std::mem::size_of::<nsPIDOMWindowOuter>(),
            136usize,
            concat!("Size of: ", stringify!(nsPIDOMWindowOuter))
        );
        assert_eq!(
            ::std::mem::align_of::<nsPIDOMWindowOuter>(),
            8usize,
            concat!("Alignment of ", stringify!(nsPIDOMWindowOuter))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mChromeEventHandler as *const _
                    as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mChromeEventHandler)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mDoc as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mDoc)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mDocumentURI as *const _ as usize
            },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mDocumentURI)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mParentTarget as *const _ as usize
            },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mParentTarget)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mMessageManager as *const _ as usize
            },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mMessageManager)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mFrameElement as *const _ as usize
            },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mFrameElement)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mDocShell as *const _ as usize
            },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mDocShell)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mBrowsingContext as *const _ as usize
            },
            64usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mBrowsingContext)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mModalStateDepth as *const _ as usize
            },
            72usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mModalStateDepth)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mIsActive as *const _ as usize
            },
            76usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mIsActive)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mIsBackground as *const _ as usize
            },
            77usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mIsBackground)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mMediaSuspend as *const _ as usize
            },
            80usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mMediaSuspend)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mAudioMuted as *const _ as usize
            },
            84usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mAudioMuted)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mAudioVolume as *const _ as usize
            },
            88usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mAudioVolume)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mDesktopModeViewport as *const _
                    as usize
            },
            92usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mDesktopModeViewport)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mIsRootOuterWindow as *const _
                    as usize
            },
            93usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mIsRootOuterWindow)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mInnerWindow as *const _ as usize
            },
            96usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mInnerWindow)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mTabGroup as *const _ as usize
            },
            104usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mTabGroup)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mWindowID as *const _ as usize
            },
            112usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mWindowID)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mMarkedCCGeneration as *const _
                    as usize
            },
            120usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mMarkedCCGeneration)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mServiceWorkersTestingEnabled
                    as *const _ as usize
            },
            124usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mServiceWorkersTestingEnabled)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mLargeAllocStatus as *const _
                    as usize
            },
            125usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mLargeAllocStatus)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPIDOMWindowOuter>())).mOpenerForInitialContentBrowser
                    as *const _ as usize
            },
            128usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPIDOMWindowOuter),
                "::",
                stringify!(mOpenerForInitialContentBrowser)
            )
        );
    }
    #[doc = " Mutation observer interface"]
    #[doc = ""]
    #[doc = " See nsINode::AddMutationObserver, nsINode::RemoveMutationObserver for how to"]
    #[doc = " attach or remove your observers."]
    #[doc = ""]
    #[doc = " WARNING: During these notifications, you are not allowed to perform"]
    #[doc = " any mutations to the current or any other document, or start a"]
    #[doc = " network load.  If you need to perform such operations do that"]
    #[doc = " during the _last_ nsIDocumentObserver::EndUpdate notification.  The"]
    #[doc = " expection for this is ParentChainChanged, where mutations should be"]
    #[doc = " done from an async event, as the notification might not be"]
    #[doc = " surrounded by BeginUpdate/EndUpdate calls."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIMutationObserver {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIMutationObserver_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIMutationObserver() {
        assert_eq!(
            ::std::mem::size_of::<nsIMutationObserver>(),
            8usize,
            concat!("Size of: ", stringify!(nsIMutationObserver))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIMutationObserver>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIMutationObserver))
        );
    }
    #[doc = " There are two advantages to inheriting from nsStubMutationObserver"]
    #[doc = " rather than directly from nsIMutationObserver:"]
    #[doc = "  1. smaller compiled code size (since there\'s no need for the code"]
    #[doc = "     for the empty virtual function implementations for every"]
    #[doc = "     nsIMutationObserver implementation)"]
    #[doc = "  2. the performance of document\'s loop over observers benefits from"]
    #[doc = "     the fact that more of the functions called are the same (which"]
    #[doc = "     can reduce instruction cache misses and perhaps improve branch"]
    #[doc = "     prediction)"]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsStubMutationObserver {
        pub _base: root::nsIMutationObserver,
    }
    #[test]
    fn bindgen_test_layout_nsStubMutationObserver() {
        assert_eq!(
            ::std::mem::size_of::<nsStubMutationObserver>(),
            8usize,
            concat!("Size of: ", stringify!(nsStubMutationObserver))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStubMutationObserver>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStubMutationObserver))
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsLanguageAtomService {
        pub mLangToGroup: [u64; 4usize],
        pub mLocaleLanguage: root::RefPtr<root::nsAtom>,
    }
    pub type nsLanguageAtomService_Encoding = root::mozilla::Encoding;
    pub type nsLanguageAtomService_NotNull<T> = root::mozilla::NotNull<T>;
    #[test]
    fn bindgen_test_layout_nsLanguageAtomService() {
        assert_eq!(
            ::std::mem::size_of::<nsLanguageAtomService>(),
            40usize,
            concat!("Size of: ", stringify!(nsLanguageAtomService))
        );
        assert_eq!(
            ::std::mem::align_of::<nsLanguageAtomService>(),
            8usize,
            concat!("Alignment of ", stringify!(nsLanguageAtomService))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsLanguageAtomService>())).mLangToGroup as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsLanguageAtomService),
                "::",
                stringify!(mLangToGroup)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsLanguageAtomService>())).mLocaleLanguage as *const _
                    as usize
            },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsLanguageAtomService),
                "::",
                stringify!(mLocaleLanguage)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsContentList {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIIOService {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIStringBundleService {
        _unused: [u8; 0],
    }
    #[doc = " Data used to track the expiration state of an object. We promise that this"]
    #[doc = " is 32 bits so that objects that includes this as a field can pad and align"]
    #[doc = " efficiently."]
    #[repr(C)]
    #[repr(align(4))]
    #[derive(Debug, Copy, Clone)]
    pub struct nsExpirationState {
        pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 4usize], u32>,
    }
    pub const nsExpirationState_NOT_TRACKED: root::nsExpirationState__bindgen_ty_1 = 15;
    pub const nsExpirationState_MAX_INDEX_IN_GENERATION: root::nsExpirationState__bindgen_ty_1 =
        268435455;
    pub type nsExpirationState__bindgen_ty_1 = u32;
    #[test]
    fn bindgen_test_layout_nsExpirationState() {
        assert_eq!(
            ::std::mem::size_of::<nsExpirationState>(),
            4usize,
            concat!("Size of: ", stringify!(nsExpirationState))
        );
        assert_eq!(
            ::std::mem::align_of::<nsExpirationState>(),
            4usize,
            concat!("Alignment of ", stringify!(nsExpirationState))
        );
    }
    impl nsExpirationState {
        #[inline]
        pub fn mGeneration(&self) -> u32 {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 4u8) as u32) }
        }
        #[inline]
        pub fn set_mGeneration(&mut self, val: u32) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(0usize, 4u8, val as u64)
            }
        }
        #[inline]
        pub fn mIndexInGeneration(&self) -> u32 {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 28u8) as u32) }
        }
        #[inline]
        pub fn set_mIndexInGeneration(&mut self, val: u32) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(4usize, 28u8, val as u64)
            }
        }
        #[inline]
        pub fn new_bitfield_1(
            mGeneration: u32,
            mIndexInGeneration: u32,
        ) -> root::__BindgenBitfieldUnit<[u8; 4usize], u32> {
            let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 4usize], u32> =
                Default::default();
            __bindgen_bitfield_unit.set(0usize, 4u8, {
                let mGeneration: u32 = unsafe { ::std::mem::transmute(mGeneration) };
                mGeneration as u64
            });
            __bindgen_bitfield_unit.set(4usize, 28u8, {
                let mIndexInGeneration: u32 = unsafe { ::std::mem::transmute(mIndexInGeneration) };
                mIndexInGeneration as u64
            });
            __bindgen_bitfield_unit
        }
    }
    #[doc = " templated hashtable class maps keys to C++ object pointers."]
    #[doc = " See nsBaseHashtable for complete declaration."]
    #[doc = " @param KeyClass a wrapper-class for the hashtable key, see nsHashKeys.h"]
    #[doc = "   for a complete specification."]
    #[doc = " @param Class the class-type being wrapped"]
    #[doc = " @see nsInterfaceHashtable, nsClassHashtable"]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsClassHashtable {
        pub _address: u8,
    }
    pub type nsClassHashtable_KeyType = [u8; 0usize];
    pub type nsClassHashtable_UserDataType<T> = *mut T;
    pub type nsClassHashtable_base_type = u8;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIDocShellTreeItem {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIDocShellTreeItem_COMTypeInfo {
        pub _address: u8,
    }
    pub const nsIDocShellTreeItem_typeChrome: root::nsIDocShellTreeItem__bindgen_ty_1 = 0;
    pub const nsIDocShellTreeItem_typeContent: root::nsIDocShellTreeItem__bindgen_ty_1 = 1;
    pub const nsIDocShellTreeItem_typeContentWrapper: root::nsIDocShellTreeItem__bindgen_ty_1 = 2;
    pub const nsIDocShellTreeItem_typeChromeWrapper: root::nsIDocShellTreeItem__bindgen_ty_1 = 3;
    pub const nsIDocShellTreeItem_typeAll: root::nsIDocShellTreeItem__bindgen_ty_1 = 2147483647;
    pub type nsIDocShellTreeItem__bindgen_ty_1 = u32;
    #[test]
    fn bindgen_test_layout_nsIDocShellTreeItem() {
        assert_eq!(
            ::std::mem::size_of::<nsIDocShellTreeItem>(),
            8usize,
            concat!("Size of: ", stringify!(nsIDocShellTreeItem))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIDocShellTreeItem>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIDocShellTreeItem))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsILayoutHistoryState {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIStructuredCloneContainer {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIDocShell {
        pub _base: root::nsIDocShellTreeItem,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIDocShell_COMTypeInfo {
        pub _address: u8,
    }
    pub const nsIDocShell_DocShellEnumeratorDirection_ENUMERATE_FORWARDS:
        root::nsIDocShell_DocShellEnumeratorDirection = 0;
    pub const nsIDocShell_DocShellEnumeratorDirection_ENUMERATE_BACKWARDS:
        root::nsIDocShell_DocShellEnumeratorDirection = 1;
    pub type nsIDocShell_DocShellEnumeratorDirection = u8;
    pub const nsIDocShell_AppType_APP_TYPE_UNKNOWN: root::nsIDocShell_AppType = 0;
    pub const nsIDocShell_AppType_APP_TYPE_MAIL: root::nsIDocShell_AppType = 1;
    pub const nsIDocShell_AppType_APP_TYPE_EDITOR: root::nsIDocShell_AppType = 2;
    pub type nsIDocShell_AppType = u8;
    pub const nsIDocShell_BusyFlags_BUSY_FLAGS_NONE: root::nsIDocShell_BusyFlags = 0;
    pub const nsIDocShell_BusyFlags_BUSY_FLAGS_BUSY: root::nsIDocShell_BusyFlags = 1;
    pub const nsIDocShell_BusyFlags_BUSY_FLAGS_BEFORE_PAGE_LOAD: root::nsIDocShell_BusyFlags = 2;
    pub const nsIDocShell_BusyFlags_BUSY_FLAGS_PAGE_LOADING: root::nsIDocShell_BusyFlags = 4;
    pub type nsIDocShell_BusyFlags = u8;
    pub const nsIDocShell_LoadCommand_LOAD_CMD_NORMAL: root::nsIDocShell_LoadCommand = 1;
    pub const nsIDocShell_LoadCommand_LOAD_CMD_RELOAD: root::nsIDocShell_LoadCommand = 2;
    pub const nsIDocShell_LoadCommand_LOAD_CMD_HISTORY: root::nsIDocShell_LoadCommand = 4;
    pub const nsIDocShell_LoadCommand_LOAD_CMD_PUSHSTATE: root::nsIDocShell_LoadCommand = 8;
    pub type nsIDocShell_LoadCommand = u8;
    pub const nsIDocShell_FrameType_FRAME_TYPE_REGULAR: root::nsIDocShell_FrameType = 0;
    pub const nsIDocShell_FrameType_FRAME_TYPE_BROWSER: root::nsIDocShell_FrameType = 1;
    pub type nsIDocShell_FrameType = u8;
    pub const nsIDocShell_TouchEventsOverride_TOUCHEVENTS_OVERRIDE_DISABLED:
        root::nsIDocShell_TouchEventsOverride = 0;
    pub const nsIDocShell_TouchEventsOverride_TOUCHEVENTS_OVERRIDE_ENABLED:
        root::nsIDocShell_TouchEventsOverride = 1;
    pub const nsIDocShell_TouchEventsOverride_TOUCHEVENTS_OVERRIDE_NONE:
        root::nsIDocShell_TouchEventsOverride = 2;
    pub type nsIDocShell_TouchEventsOverride = u8;
    pub const nsIDocShell_MetaViewportOverride_META_VIEWPORT_OVERRIDE_DISABLED:
        root::nsIDocShell_MetaViewportOverride = 0;
    pub const nsIDocShell_MetaViewportOverride_META_VIEWPORT_OVERRIDE_ENABLED:
        root::nsIDocShell_MetaViewportOverride = 1;
    pub const nsIDocShell_MetaViewportOverride_META_VIEWPORT_OVERRIDE_NONE:
        root::nsIDocShell_MetaViewportOverride = 2;
    pub type nsIDocShell_MetaViewportOverride = u8;
    pub const nsIDocShell_DisplayMode_DISPLAY_MODE_BROWSER: root::nsIDocShell_DisplayMode = 0;
    pub const nsIDocShell_DisplayMode_DISPLAY_MODE_MINIMAL_UI: root::nsIDocShell_DisplayMode = 1;
    pub const nsIDocShell_DisplayMode_DISPLAY_MODE_STANDALONE: root::nsIDocShell_DisplayMode = 2;
    pub const nsIDocShell_DisplayMode_DISPLAY_MODE_FULLSCREEN: root::nsIDocShell_DisplayMode = 3;
    pub type nsIDocShell_DisplayMode = u8;
    #[test]
    fn bindgen_test_layout_nsIDocShell() {
        assert_eq!(
            ::std::mem::size_of::<nsIDocShell>(),
            8usize,
            concat!("Size of: ", stringify!(nsIDocShell))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIDocShell>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIDocShell))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsTabSizes {
        pub mDom: usize,
        pub mStyle: usize,
        pub mOther: usize,
    }
    pub const nsTabSizes_Kind_DOM: root::nsTabSizes_Kind = 0;
    pub const nsTabSizes_Kind_Style: root::nsTabSizes_Kind = 1;
    pub const nsTabSizes_Kind_Other: root::nsTabSizes_Kind = 2;
    pub type nsTabSizes_Kind = u32;
    #[test]
    fn bindgen_test_layout_nsTabSizes() {
        assert_eq!(
            ::std::mem::size_of::<nsTabSizes>(),
            24usize,
            concat!("Size of: ", stringify!(nsTabSizes))
        );
        assert_eq!(
            ::std::mem::align_of::<nsTabSizes>(),
            8usize,
            concat!("Alignment of ", stringify!(nsTabSizes))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsTabSizes>())).mDom as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsTabSizes),
                "::",
                stringify!(mDom)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsTabSizes>())).mStyle as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsTabSizes),
                "::",
                stringify!(mStyle)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsTabSizes>())).mOther as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsTabSizes),
                "::",
                stringify!(mOther)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsBaseContentList {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsDocShell {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsFrameLoader {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIBFCacheEntry {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIDocumentEncoder {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIObjectLoadingContent {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsViewManager {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsXULPrototypeDocument {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsXBLPrototypeBinding {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct MiscContainer {
        pub mType: root::MiscContainer_ValueType,
        pub mStringBits: u64,
        pub __bindgen_anon_1: root::MiscContainer__bindgen_ty_1,
    }
    pub use self::super::root::nsAttrValue_ValueType as MiscContainer_ValueType;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct MiscContainer__bindgen_ty_1 {
        pub mValue: root::__BindgenUnionField<root::MiscContainer__bindgen_ty_1__bindgen_ty_1>,
        pub mDoubleValue: root::__BindgenUnionField<f64>,
        pub bindgen_union_field: [u64; 2usize],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct MiscContainer__bindgen_ty_1__bindgen_ty_1 {
        pub __bindgen_anon_1: root::MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 4usize], u32>,
        pub __bindgen_padding_0: u32,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
        pub mInteger: root::__BindgenUnionField<i32>,
        pub mColor: root::__BindgenUnionField<root::nscolor>,
        pub mEnumValue: root::__BindgenUnionField<u32>,
        pub mPercent: root::__BindgenUnionField<i32>,
        pub mCSSDeclaration: root::__BindgenUnionField<*mut root::mozilla::DeclarationBlock>,
        pub mURL: root::__BindgenUnionField<*mut root::nsIURI>,
        pub mAtomArray: root::__BindgenUnionField<*mut root::mozilla::AtomArray>,
        pub mIntMargin: root::__BindgenUnionField<*mut root::nsIntMargin>,
        pub mSVGAnimatedIntegerPair:
            root::__BindgenUnionField<*const root::mozilla::SVGAnimatedIntegerPair>,
        pub mSVGLength: root::__BindgenUnionField<*const root::mozilla::SVGAnimatedLength>,
        pub mSVGAnimatedNumberPair:
            root::__BindgenUnionField<*const root::mozilla::SVGAnimatedNumberPair>,
        pub mSVGAnimatedOrient: root::__BindgenUnionField<*const root::mozilla::SVGAnimatedOrient>,
        pub mSVGAnimatedPreserveAspectRatio:
            root::__BindgenUnionField<*const root::mozilla::SVGAnimatedPreserveAspectRatio>,
        pub mSVGAnimatedViewBox:
            root::__BindgenUnionField<*const root::mozilla::SVGAnimatedViewBox>,
        pub mSVGLengthList: root::__BindgenUnionField<*const root::mozilla::SVGLengthList>,
        pub mSVGNumberList: root::__BindgenUnionField<*const root::mozilla::SVGNumberList>,
        pub mSVGPathData: root::__BindgenUnionField<*const root::mozilla::SVGPathData>,
        pub mSVGPointList: root::__BindgenUnionField<*const root::mozilla::SVGPointList>,
        pub mSVGStringList: root::__BindgenUnionField<*const root::mozilla::SVGStringList>,
        pub mSVGTransformList: root::__BindgenUnionField<*const root::mozilla::SVGTransformList>,
        pub bindgen_union_field: u64,
    }
    #[test]
    fn bindgen_test_layout_MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1() {
        assert_eq!(
            ::std::mem::size_of::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>(),
            8usize,
            concat!(
                "Size of: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mInteger as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mInteger)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mColor as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mColor)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mEnumValue as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mEnumValue)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mPercent as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mPercent)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mCSSDeclaration as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mCSSDeclaration)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mURL as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mURL)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mAtomArray as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mAtomArray)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mIntMargin as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mIntMargin)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mSVGAnimatedIntegerPair as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mSVGAnimatedIntegerPair)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mSVGLength as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mSVGLength)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mSVGAnimatedNumberPair as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mSVGAnimatedNumberPair)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mSVGAnimatedOrient as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mSVGAnimatedOrient)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mSVGAnimatedPreserveAspectRatio as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mSVGAnimatedPreserveAspectRatio)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mSVGAnimatedViewBox as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mSVGAnimatedViewBox)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mSVGLengthList as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mSVGLengthList)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mSVGNumberList as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mSVGNumberList)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mSVGPathData as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mSVGPathData)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mSVGPointList as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mSVGPointList)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mSVGStringList as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mSVGStringList)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()))
                    .mSVGTransformList as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1),
                "::",
                stringify!(mSVGTransformList)
            )
        );
    }
    #[test]
    fn bindgen_test_layout_MiscContainer__bindgen_ty_1__bindgen_ty_1() {
        assert_eq!(
            ::std::mem::size_of::<MiscContainer__bindgen_ty_1__bindgen_ty_1>(),
            16usize,
            concat!(
                "Size of: ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<MiscContainer__bindgen_ty_1__bindgen_ty_1>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(MiscContainer__bindgen_ty_1__bindgen_ty_1)
            )
        );
    }
    impl MiscContainer__bindgen_ty_1__bindgen_ty_1 {
        #[inline]
        pub fn mRefCount(&self) -> u32 {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 31u8) as u32) }
        }
        #[inline]
        pub fn set_mRefCount(&mut self, val: u32) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(0usize, 31u8, val as u64)
            }
        }
        #[inline]
        pub fn mCached(&self) -> u32 {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(31usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mCached(&mut self, val: u32) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(31usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn new_bitfield_1(
            mRefCount: u32,
            mCached: u32,
        ) -> root::__BindgenBitfieldUnit<[u8; 4usize], u32> {
            let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 4usize], u32> =
                Default::default();
            __bindgen_bitfield_unit.set(0usize, 31u8, {
                let mRefCount: u32 = unsafe { ::std::mem::transmute(mRefCount) };
                mRefCount as u64
            });
            __bindgen_bitfield_unit.set(31usize, 1u8, {
                let mCached: u32 = unsafe { ::std::mem::transmute(mCached) };
                mCached as u64
            });
            __bindgen_bitfield_unit
        }
    }
    #[test]
    fn bindgen_test_layout_MiscContainer__bindgen_ty_1() {
        assert_eq!(
            ::std::mem::size_of::<MiscContainer__bindgen_ty_1>(),
            16usize,
            concat!("Size of: ", stringify!(MiscContainer__bindgen_ty_1))
        );
        assert_eq!(
            ::std::mem::align_of::<MiscContainer__bindgen_ty_1>(),
            8usize,
            concat!("Alignment of ", stringify!(MiscContainer__bindgen_ty_1))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1>())).mValue as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1),
                "::",
                stringify!(mValue)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<MiscContainer__bindgen_ty_1>())).mDoubleValue as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer__bindgen_ty_1),
                "::",
                stringify!(mDoubleValue)
            )
        );
    }
    #[test]
    fn bindgen_test_layout_MiscContainer() {
        assert_eq!(
            ::std::mem::size_of::<MiscContainer>(),
            32usize,
            concat!("Size of: ", stringify!(MiscContainer))
        );
        assert_eq!(
            ::std::mem::align_of::<MiscContainer>(),
            8usize,
            concat!("Alignment of ", stringify!(MiscContainer))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<MiscContainer>())).mType as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer),
                "::",
                stringify!(mType)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<MiscContainer>())).mStringBits as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(MiscContainer),
                "::",
                stringify!(mStringBits)
            )
        );
    }
    pub const nsWindowType_eWindowType_toplevel: root::nsWindowType = 0;
    pub const nsWindowType_eWindowType_dialog: root::nsWindowType = 1;
    pub const nsWindowType_eWindowType_sheet: root::nsWindowType = 2;
    pub const nsWindowType_eWindowType_popup: root::nsWindowType = 3;
    pub const nsWindowType_eWindowType_child: root::nsWindowType = 4;
    pub const nsWindowType_eWindowType_invisible: root::nsWindowType = 5;
    pub const nsWindowType_eWindowType_plugin: root::nsWindowType = 6;
    pub const nsWindowType_eWindowType_plugin_ipc_chrome: root::nsWindowType = 7;
    pub const nsWindowType_eWindowType_plugin_ipc_content: root::nsWindowType = 8;
    #[doc = " Window types"]
    #[doc = ""]
    #[doc = " Don\'t alter previously encoded enum values - 3rd party apps may look at"]
    #[doc = " these."]
    pub type nsWindowType = u32;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsDeviceContext {
        _unused: [u8; 0],
    }
    #[doc = " nsITheme is a service that provides platform-specific native"]
    #[doc = " rendering for widgets.  In other words, it provides the necessary"]
    #[doc = " operations to draw a rendering object (an nsIFrame) as a native"]
    #[doc = " widget."]
    #[doc = ""]
    #[doc = " All the methods on nsITheme take a rendering context or device"]
    #[doc = " context, a frame (the rendering object), and a widget type (one of"]
    #[doc = " the constants in nsThemeConstants.h)."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsITheme {
        pub _base: root::nsISupports,
    }
    pub type nsITheme_LayoutDeviceIntMargin = root::mozilla::LayoutDeviceIntMargin;
    pub use self::super::root::mozilla::StyleAppearance as nsITheme_StyleAppearance;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsITheme_COMTypeInfo {
        pub _address: u8,
    }
    pub const nsITheme_Transparency_eOpaque: root::nsITheme_Transparency = 0;
    pub const nsITheme_Transparency_eTransparent: root::nsITheme_Transparency = 1;
    pub const nsITheme_Transparency_eUnknownTransparency: root::nsITheme_Transparency = 2;
    pub type nsITheme_Transparency = u32;
    #[doc = " ThemeGeometryType values are used for describing themed nsIFrames in"]
    #[doc = " calls to nsIWidget::UpdateThemeGeometries. We don\'t simply pass the"]
    #[doc = " -moz-appearance value (\"widget type\") of the frame because the widget may"]
    #[doc = " want to treat different frames with the same -moz-appearance differently"]
    #[doc = " based on other properties of the frame. So we give the theme a first look"]
    #[doc = " at the frame in nsITheme::ThemeGeometryTypeForWidget and pass the"]
    #[doc = " returned ThemeGeometryType along to the widget."]
    #[doc = " Each theme backend defines the ThemeGeometryType values it needs in its"]
    #[doc = " own nsITheme subclass. eThemeGeometryTypeUnknown is the only value that\'s"]
    #[doc = " shared between backends."]
    pub type nsITheme_ThemeGeometryType = u8;
    pub const nsITheme_eThemeGeometryTypeUnknown: root::nsITheme__bindgen_ty_1 = 0;
    pub type nsITheme__bindgen_ty_1 = u32;
    #[test]
    fn bindgen_test_layout_nsITheme() {
        assert_eq!(
            ::std::mem::size_of::<nsITheme>(),
            8usize,
            concat!("Size of: ", stringify!(nsITheme))
        );
        assert_eq!(
            ::std::mem::align_of::<nsITheme>(),
            8usize,
            concat!("Alignment of ", stringify!(nsITheme))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIBidiKeyboard {
        _unused: [u8; 0],
    }
    #[doc = " The base class for all the widgets. It provides the interface for"]
    #[doc = " all basic and necessary functionality."]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsIWidget {
        pub _base: root::nsISupports,
        pub mLongTapTouchPoint: root::mozilla::UniquePtr<root::nsIWidget_LongTapInfo>,
        pub mLongTapTimer: root::nsCOMPtr,
        pub mFirstChild: root::nsCOMPtr,
        pub mLastChild: *mut root::nsIWidget,
        pub mNextSibling: root::nsCOMPtr,
        pub mPrevSibling: *mut root::nsIWidget,
        pub mOnDestroyCalled: bool,
        pub mWindowType: root::nsWindowType,
        pub mZIndex: i32,
    }
    pub type nsIWidget_BrowserChild = root::mozilla::dom::BrowserChild;
    pub type nsIWidget_CompositorBridgeChild = root::mozilla::layers::CompositorBridgeChild;
    pub type nsIWidget_AsyncDragMetrics = root::mozilla::layers::AsyncDragMetrics;
    pub type nsIWidget_FrameMetrics = root::mozilla::layers::FrameMetrics;
    pub type nsIWidget_LayerManager = root::mozilla::layers::LayerManager;
    pub type nsIWidget_LayerManagerComposite = root::mozilla::layers::LayerManagerComposite;
    pub use self::super::root::mozilla::layers::LayersBackend as nsIWidget_LayersBackend;
    pub type nsIWidget_PLayerTransactionChild = root::mozilla::layers::PLayerTransactionChild;
    pub type nsIWidget_SLGuidAndRenderRoot = root::mozilla::layers::SLGuidAndRenderRoot;
    pub type nsIWidget_ScrollableLayerGuid = root::mozilla::layers::ScrollableLayerGuid;
    pub type nsIWidget_ZoomConstraints = root::mozilla::layers::ZoomConstraints;
    pub use self::super::root::mozilla::widget::IMEMessage as nsIWidget_IMEMessage;
    pub type nsIWidget_IMENotification = root::mozilla::widget::IMENotification;
    pub type nsIWidget_IMENotificationRequests = root::mozilla::widget::IMENotificationRequests;
    pub type nsIWidget_IMEState = root::mozilla::widget::IMEState;
    pub type nsIWidget_InputContext = root::mozilla::widget::InputContext;
    pub type nsIWidget_InputContextAction = root::mozilla::widget::InputContextAction;
    pub type nsIWidget_NativeIMEContext = root::mozilla::widget::NativeIMEContext;
    pub type nsIWidget_SizeConstraints = root::mozilla::widget::SizeConstraints;
    pub type nsIWidget_TextEventDispatcher = root::mozilla::widget::TextEventDispatcher;
    pub type nsIWidget_TextEventDispatcherListener =
        root::mozilla::widget::TextEventDispatcherListener;
    pub type nsIWidget_LayoutDeviceIntMargin = root::mozilla::LayoutDeviceIntMargin;
    pub type nsIWidget_LayoutDeviceIntPoint = root::mozilla::LayoutDeviceIntPoint;
    pub type nsIWidget_LayoutDeviceIntRect = root::mozilla::LayoutDeviceIntRect;
    pub type nsIWidget_LayoutDeviceIntRegion = root::mozilla::LayoutDeviceIntRegion;
    pub type nsIWidget_LayoutDeviceIntSize = root::mozilla::LayoutDeviceIntSize;
    pub type nsIWidget_ScreenIntPoint = root::mozilla::ScreenIntPoint;
    pub type nsIWidget_ScreenIntSize = root::mozilla::ScreenIntSize;
    pub type nsIWidget_ScreenPoint = root::mozilla::ScreenPoint;
    pub type nsIWidget_CSSToScreenScale = root::mozilla::CSSToScreenScale;
    pub type nsIWidget_DesktopIntRect = root::mozilla::DesktopIntRect;
    pub type nsIWidget_CSSPoint = root::mozilla::CSSPoint;
    pub type nsIWidget_CSSRect = root::mozilla::CSSRect;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIWidget_ThemeGeometry {
        pub mType: root::nsITheme_ThemeGeometryType,
        pub mRect: root::nsIWidget_LayoutDeviceIntRect,
    }
    #[test]
    fn bindgen_test_layout_nsIWidget_ThemeGeometry() {
        assert_eq!(
            ::std::mem::size_of::<nsIWidget_ThemeGeometry>(),
            20usize,
            concat!("Size of: ", stringify!(nsIWidget_ThemeGeometry))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIWidget_ThemeGeometry>(),
            4usize,
            concat!("Alignment of ", stringify!(nsIWidget_ThemeGeometry))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIWidget_ThemeGeometry>())).mType as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget_ThemeGeometry),
                "::",
                stringify!(mType)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIWidget_ThemeGeometry>())).mRect as *const _ as usize
            },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget_ThemeGeometry),
                "::",
                stringify!(mRect)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIWidget_COMTypeInfo {
        pub _address: u8,
    }
    #[doc = " This represents a command to set the bounds and clip region of"]
    #[doc = " a child widget."]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsIWidget_Configuration {
        pub mChild: root::nsCOMPtr,
        pub mWindowID: usize,
        pub mVisible: bool,
        pub mBounds: root::nsIWidget_LayoutDeviceIntRect,
        pub mClipRegion: root::nsTArray<root::nsIWidget_LayoutDeviceIntRect>,
    }
    #[test]
    fn bindgen_test_layout_nsIWidget_Configuration() {
        assert_eq!(
            ::std::mem::size_of::<nsIWidget_Configuration>(),
            48usize,
            concat!("Size of: ", stringify!(nsIWidget_Configuration))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIWidget_Configuration>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIWidget_Configuration))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIWidget_Configuration>())).mChild as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget_Configuration),
                "::",
                stringify!(mChild)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIWidget_Configuration>())).mWindowID as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget_Configuration),
                "::",
                stringify!(mWindowID)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIWidget_Configuration>())).mVisible as *const _ as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget_Configuration),
                "::",
                stringify!(mVisible)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIWidget_Configuration>())).mBounds as *const _ as usize
            },
            20usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget_Configuration),
                "::",
                stringify!(mBounds)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIWidget_Configuration>())).mClipRegion as *const _ as usize
            },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget_Configuration),
                "::",
                stringify!(mClipRegion)
            )
        );
    }
    pub const nsIWidget_WindowAnimationType_eGenericWindowAnimation:
        root::nsIWidget_WindowAnimationType = 0;
    pub const nsIWidget_WindowAnimationType_eDocumentWindowAnimation:
        root::nsIWidget_WindowAnimationType = 1;
    pub type nsIWidget_WindowAnimationType = u32;
    pub const nsIWidget_FullscreenTransitionStage_eBeforeFullscreenToggle:
        root::nsIWidget_FullscreenTransitionStage = 0;
    pub const nsIWidget_FullscreenTransitionStage_eAfterFullscreenToggle:
        root::nsIWidget_FullscreenTransitionStage = 1;
    pub type nsIWidget_FullscreenTransitionStage = u32;
    pub const nsIWidget_LayerManagerPersistence_LAYER_MANAGER_CURRENT:
        root::nsIWidget_LayerManagerPersistence = 0;
    pub const nsIWidget_LayerManagerPersistence_LAYER_MANAGER_PERSISTENT:
        root::nsIWidget_LayerManagerPersistence = 1;
    pub type nsIWidget_LayerManagerPersistence = u32;
    pub const nsIWidget_Modifiers_CAPS_LOCK: root::nsIWidget_Modifiers = 1;
    pub const nsIWidget_Modifiers_NUM_LOCK: root::nsIWidget_Modifiers = 2;
    pub const nsIWidget_Modifiers_SHIFT_L: root::nsIWidget_Modifiers = 256;
    pub const nsIWidget_Modifiers_SHIFT_R: root::nsIWidget_Modifiers = 512;
    pub const nsIWidget_Modifiers_CTRL_L: root::nsIWidget_Modifiers = 1024;
    pub const nsIWidget_Modifiers_CTRL_R: root::nsIWidget_Modifiers = 2048;
    pub const nsIWidget_Modifiers_ALT_L: root::nsIWidget_Modifiers = 4096;
    pub const nsIWidget_Modifiers_ALT_R: root::nsIWidget_Modifiers = 8192;
    pub const nsIWidget_Modifiers_COMMAND_L: root::nsIWidget_Modifiers = 16384;
    pub const nsIWidget_Modifiers_COMMAND_R: root::nsIWidget_Modifiers = 32768;
    pub const nsIWidget_Modifiers_HELP: root::nsIWidget_Modifiers = 65536;
    pub const nsIWidget_Modifiers_ALTGRAPH: root::nsIWidget_Modifiers = 131072;
    pub const nsIWidget_Modifiers_FUNCTION: root::nsIWidget_Modifiers = 1048576;
    pub const nsIWidget_Modifiers_NUMERIC_KEY_PAD: root::nsIWidget_Modifiers = 16777216;
    pub type nsIWidget_Modifiers = u32;
    pub const nsIWidget_TouchPointerState_TOUCH_HOVER: root::nsIWidget_TouchPointerState = 1;
    pub const nsIWidget_TouchPointerState_TOUCH_CONTACT: root::nsIWidget_TouchPointerState = 2;
    pub const nsIWidget_TouchPointerState_TOUCH_REMOVE: root::nsIWidget_TouchPointerState = 4;
    pub const nsIWidget_TouchPointerState_TOUCH_CANCEL: root::nsIWidget_TouchPointerState = 8;
    pub const nsIWidget_TouchPointerState_ALL_BITS: root::nsIWidget_TouchPointerState = 15;
    pub type nsIWidget_TouchPointerState = u32;
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsIWidget_LongTapInfo {
        pub mPointerId: i32,
        pub mPosition: root::nsIWidget_LayoutDeviceIntPoint,
        pub mDuration: root::mozilla::TimeDuration,
        pub mObserver: root::nsCOMPtr,
        pub mStamp: root::mozilla::TimeStamp,
    }
    #[test]
    fn bindgen_test_layout_nsIWidget_LongTapInfo() {
        assert_eq!(
            ::std::mem::size_of::<nsIWidget_LongTapInfo>(),
            40usize,
            concat!("Size of: ", stringify!(nsIWidget_LongTapInfo))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIWidget_LongTapInfo>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIWidget_LongTapInfo))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIWidget_LongTapInfo>())).mPointerId as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget_LongTapInfo),
                "::",
                stringify!(mPointerId)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIWidget_LongTapInfo>())).mPosition as *const _ as usize
            },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget_LongTapInfo),
                "::",
                stringify!(mPosition)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIWidget_LongTapInfo>())).mDuration as *const _ as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget_LongTapInfo),
                "::",
                stringify!(mDuration)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIWidget_LongTapInfo>())).mObserver as *const _ as usize
            },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget_LongTapInfo),
                "::",
                stringify!(mObserver)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIWidget_LongTapInfo>())).mStamp as *const _ as usize
            },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget_LongTapInfo),
                "::",
                stringify!(mStamp)
            )
        );
    }
    pub const nsIWidget_NativeKeyBindingsType_NativeKeyBindingsForSingleLineEditor:
        root::nsIWidget_NativeKeyBindingsType = 0;
    pub const nsIWidget_NativeKeyBindingsType_NativeKeyBindingsForMultiLineEditor:
        root::nsIWidget_NativeKeyBindingsType = 1;
    pub const nsIWidget_NativeKeyBindingsType_NativeKeyBindingsForRichTextEditor:
        root::nsIWidget_NativeKeyBindingsType = 2;
    #[doc = " Retrieve edit commands when the key combination of aEvent is used"]
    #[doc = " in platform native applications."]
    pub type nsIWidget_NativeKeyBindingsType = u8;
    extern "C" {
        #[link_name = "\u{1}_ZN9nsIWidget17sPointerIdCounterE"]
        pub static mut nsIWidget_sPointerIdCounter: i32;
    }
    #[test]
    fn bindgen_test_layout_nsIWidget() {
        assert_eq!(
            ::std::mem::size_of::<nsIWidget>(),
            72usize,
            concat!("Size of: ", stringify!(nsIWidget))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIWidget>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIWidget))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIWidget>())).mLongTapTouchPoint as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget),
                "::",
                stringify!(mLongTapTouchPoint)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIWidget>())).mLongTapTimer as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget),
                "::",
                stringify!(mLongTapTimer)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIWidget>())).mFirstChild as *const _ as usize },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget),
                "::",
                stringify!(mFirstChild)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIWidget>())).mLastChild as *const _ as usize },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget),
                "::",
                stringify!(mLastChild)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIWidget>())).mNextSibling as *const _ as usize },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget),
                "::",
                stringify!(mNextSibling)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIWidget>())).mPrevSibling as *const _ as usize },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget),
                "::",
                stringify!(mPrevSibling)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIWidget>())).mOnDestroyCalled as *const _ as usize },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget),
                "::",
                stringify!(mOnDestroyCalled)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIWidget>())).mWindowType as *const _ as usize },
            60usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget),
                "::",
                stringify!(mWindowType)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIWidget>())).mZIndex as *const _ as usize },
            64usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIWidget),
                "::",
                stringify!(mZIndex)
            )
        );
    }
    #[doc = " A node of content in a document\'s content model. This interface"]
    #[doc = " is supported by all content objects."]
    #[repr(C)]
    pub struct nsIContent {
        pub _base: root::nsINode,
        pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
    }
    pub type nsIContent_IMEState = root::mozilla::widget::IMEState;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIContent_COMTypeInfo {
        pub _address: u8,
    }
    pub type nsIContent_HasThreadSafeRefCnt = root::mozilla::FalseType;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIContent_cycleCollection {
        pub _base: root::nsXPCOMCycleCollectionParticipant,
    }
    #[test]
    fn bindgen_test_layout_nsIContent_cycleCollection() {
        assert_eq!(
            ::std::mem::size_of::<nsIContent_cycleCollection>(),
            16usize,
            concat!("Size of: ", stringify!(nsIContent_cycleCollection))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIContent_cycleCollection>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIContent_cycleCollection))
        );
    }
    #[doc = " All XBL flattened tree children of the node, as well as :before and"]
    #[doc = " :after anonymous content and native anonymous children."]
    #[doc = ""]
    #[doc = " @note the result children order is"]
    #[doc = "   1. :before generated node"]
    #[doc = "   2. XBL flattened tree children of this node"]
    #[doc = "   3. native anonymous nodes"]
    #[doc = "   4. :after generated node"]
    pub const nsIContent_eAllChildren: root::nsIContent__bindgen_ty_1 = 0;
    #[doc = " All XBL explicit children of the node (see"]
    #[doc = " http://www.w3.org/TR/xbl/#explicit3 ), as well as :before and :after"]
    #[doc = " anonymous content and native anonymous children."]
    #[doc = ""]
    #[doc = " @note the result children order is"]
    #[doc = "   1. :before generated node"]
    #[doc = "   2. XBL explicit children of the node"]
    #[doc = "   3. native anonymous nodes"]
    #[doc = "   4. :after generated node"]
    pub const nsIContent_eAllButXBL: root::nsIContent__bindgen_ty_1 = 1;
    #[doc = " Skip native anonymous content created for placeholder of HTML input,"]
    #[doc = " used in conjunction with eAllChildren or eAllButXBL."]
    pub const nsIContent_eSkipPlaceholderContent: root::nsIContent__bindgen_ty_1 = 2;
    #[doc = " Skip native anonymous content created by ancestor frames of the root"]
    #[doc = " element\'s primary frame, such as scrollbar elements created by the root"]
    #[doc = " scroll frame."]
    pub const nsIContent_eSkipDocumentLevelNativeAnonymousContent: root::nsIContent__bindgen_ty_1 =
        4;
    pub type nsIContent__bindgen_ty_1 = u32;
    #[repr(C)]
    pub struct nsIContent_nsExtendedContentSlots__bindgen_vtable(::std::os::raw::c_void);
    #[doc = " Lazily allocated extended slots to avoid"]
    #[doc = " that may only be instantiated when a content object is accessed"]
    #[doc = " through the DOM. Rather than burn actual slots in the content"]
    #[doc = " objects for each of these instance variables, we put them off"]
    #[doc = " in a side structure that\'s only allocated when the content is"]
    #[doc = " accessed through the DOM."]
    #[repr(C)]
    pub struct nsIContent_nsExtendedContentSlots {
        pub vtable_: *const nsIContent_nsExtendedContentSlots__bindgen_vtable,
        #[doc = " The nearest enclosing content node with a binding that created us."]
        #[doc = " TODO(emilio): This should be an Element*."]
        #[doc = ""]
        #[doc = " @see nsIContent::GetBindingParent"]
        pub mBindingParent: root::nsCOMPtr,
        #[doc = " @see nsIContent::GetXBLInsertionPoint"]
        pub mXBLInsertionPoint: root::nsCOMPtr,
        #[doc = " @see nsIContent::GetContainingShadow"]
        pub mContainingShadow: root::RefPtr<root::mozilla::dom::ShadowRoot>,
        #[doc = " @see nsIContent::GetAssignedSlot"]
        pub mAssignedSlot: root::RefPtr<root::mozilla::dom::HTMLSlotElement>,
    }
    #[test]
    fn bindgen_test_layout_nsIContent_nsExtendedContentSlots() {
        assert_eq!(
            ::std::mem::size_of::<nsIContent_nsExtendedContentSlots>(),
            40usize,
            concat!("Size of: ", stringify!(nsIContent_nsExtendedContentSlots))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIContent_nsExtendedContentSlots>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(nsIContent_nsExtendedContentSlots)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIContent_nsExtendedContentSlots>())).mBindingParent
                    as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIContent_nsExtendedContentSlots),
                "::",
                stringify!(mBindingParent)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIContent_nsExtendedContentSlots>())).mXBLInsertionPoint
                    as *const _ as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIContent_nsExtendedContentSlots),
                "::",
                stringify!(mXBLInsertionPoint)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIContent_nsExtendedContentSlots>())).mContainingShadow
                    as *const _ as usize
            },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIContent_nsExtendedContentSlots),
                "::",
                stringify!(mContainingShadow)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIContent_nsExtendedContentSlots>())).mAssignedSlot
                    as *const _ as usize
            },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIContent_nsExtendedContentSlots),
                "::",
                stringify!(mAssignedSlot)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsIContent_nsContentSlots {
        pub _base: root::nsINode_nsSlots,
        pub mExtendedSlots: usize,
    }
    pub const nsIContent_nsContentSlots_sNonOwningExtendedSlotsFlag: usize = 1;
    #[test]
    fn bindgen_test_layout_nsIContent_nsContentSlots() {
        assert_eq!(
            ::std::mem::size_of::<nsIContent_nsContentSlots>(),
            72usize,
            concat!("Size of: ", stringify!(nsIContent_nsContentSlots))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIContent_nsContentSlots>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIContent_nsContentSlots))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIContent_nsContentSlots>())).mExtendedSlots as *const _
                    as usize
            },
            64usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIContent_nsContentSlots),
                "::",
                stringify!(mExtendedSlots)
            )
        );
    }
    pub const nsIContent_ETabFocusType_eTabFocus_textControlsMask: root::nsIContent_ETabFocusType =
        1;
    pub const nsIContent_ETabFocusType_eTabFocus_formElementsMask: root::nsIContent_ETabFocusType =
        2;
    pub const nsIContent_ETabFocusType_eTabFocus_linksMask: root::nsIContent_ETabFocusType = 4;
    pub const nsIContent_ETabFocusType_eTabFocus_any: root::nsIContent_ETabFocusType = 7;
    pub type nsIContent_ETabFocusType = u32;
    extern "C" {
        #[link_name = "\u{1}_ZN10nsIContent21_cycleCollectorGlobalE"]
        pub static mut nsIContent__cycleCollectorGlobal: root::nsIContent_cycleCollection;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsIContent14sTabFocusModelE"]
        pub static mut nsIContent_sTabFocusModel: i32;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsIContent26sTabFocusModelAppliesToXULE"]
        pub static mut nsIContent_sTabFocusModelAppliesToXUL: bool;
    }
    #[test]
    fn bindgen_test_layout_nsIContent() {
        assert_eq!(
            ::std::mem::size_of::<nsIContent>(),
            104usize,
            concat!("Size of: ", stringify!(nsIContent))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIContent>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIContent))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIContent>())).mRefCnt as *const _ as usize },
            96usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIContent),
                "::",
                stringify!(mRefCnt)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsHtml5StringParser {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIConsoleService {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIFragmentContentSink {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIStringBundle {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct EventNameMapping {
        pub mAtom: *mut root::nsAtom,
        pub mType: i32,
        pub mMessage: root::mozilla::EventMessage,
        pub mEventClassID: root::mozilla::EventClassID,
        pub mMaybeSpecialSVGorSMILEvent: bool,
    }
    #[test]
    fn bindgen_test_layout_EventNameMapping() {
        assert_eq!(
            ::std::mem::size_of::<EventNameMapping>(),
            16usize,
            concat!("Size of: ", stringify!(EventNameMapping))
        );
        assert_eq!(
            ::std::mem::align_of::<EventNameMapping>(),
            8usize,
            concat!("Alignment of ", stringify!(EventNameMapping))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<EventNameMapping>())).mAtom as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(EventNameMapping),
                "::",
                stringify!(mAtom)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<EventNameMapping>())).mType as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(EventNameMapping),
                "::",
                stringify!(mType)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<EventNameMapping>())).mMessage as *const _ as usize },
            12usize,
            concat!(
                "Offset of field: ",
                stringify!(EventNameMapping),
                "::",
                stringify!(mMessage)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<EventNameMapping>())).mEventClassID as *const _ as usize
            },
            14usize,
            concat!(
                "Offset of field: ",
                stringify!(EventNameMapping),
                "::",
                stringify!(mEventClassID)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<EventNameMapping>())).mMaybeSpecialSVGorSMILEvent as *const _
                    as usize
            },
            15usize,
            concat!(
                "Offset of field: ",
                stringify!(EventNameMapping),
                "::",
                stringify!(mMaybeSpecialSVGorSMILEvent)
            )
        );
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils10sXPConnectE"]
        pub static mut nsContentUtils_sXPConnect: *mut root::nsIXPConnect;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils16sSecurityManagerE"]
        pub static mut nsContentUtils_sSecurityManager: *mut root::nsIScriptSecurityManager;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils16sSystemPrincipalE"]
        pub static mut nsContentUtils_sSystemPrincipal: *mut root::nsIPrincipal;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils21sNullSubjectPrincipalE"]
        pub static mut nsContentUtils_sNullSubjectPrincipal: *mut root::nsIPrincipal;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils17sNameSpaceManagerE"]
        pub static mut nsContentUtils_sNameSpaceManager: *mut root::nsNameSpaceManager;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils10sIOServiceE"]
        pub static mut nsContentUtils_sIOService: *mut root::nsIIOService;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils14sUUIDGeneratorE"]
        pub static mut nsContentUtils_sUUIDGenerator: *mut root::nsIUUIDGenerator;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils15sConsoleServiceE"]
        pub static mut nsContentUtils_sConsoleService: *mut root::nsIConsoleService;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils15sAtomEventTableE"]
        pub static mut nsContentUtils_sAtomEventTable: *mut u8;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils17sStringEventTableE"]
        pub static mut nsContentUtils_sStringEventTable: *mut u8;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils18sUserDefinedEventsE"]
        pub static mut nsContentUtils_sUserDefinedEvents:
            *mut root::nsTArray<root::RefPtr<root::nsAtom>>;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils20sStringBundleServiceE"]
        pub static mut nsContentUtils_sStringBundleService: *mut root::nsIStringBundleService;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils14sStringBundlesE"]
        pub static mut nsContentUtils_sStringBundles: [*mut root::nsIStringBundle; 14usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils21sContentPolicyServiceE"]
        pub static mut nsContentUtils_sContentPolicyService: *mut root::nsIContentPolicy;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils24sTriedToGetContentPolicyE"]
        pub static mut nsContentUtils_sTriedToGetContentPolicy: bool;
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_LineBreaker_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::intl::LineBreaker>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::intl::LineBreaker>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::intl::LineBreaker>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::intl::LineBreaker>)
            )
        );
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils12sLineBreakerE"]
        pub static mut nsContentUtils_sLineBreaker: root::RefPtr<root::mozilla::intl::LineBreaker>;
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_WordBreaker_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::intl::WordBreaker>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::intl::WordBreaker>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::intl::WordBreaker>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::intl::WordBreaker>)
            )
        );
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils12sWordBreakerE"]
        pub static mut nsContentUtils_sWordBreaker: root::RefPtr<root::mozilla::intl::WordBreaker>;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils13sBidiKeyboardE"]
        pub static mut nsContentUtils_sBidiKeyboard:
            root::mozilla::StaticRefPtr<root::nsIBidiKeyboard>;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils12sInitializedE"]
        pub static mut nsContentUtils_sInitialized: bool;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils19sScriptBlockerCountE"]
        pub static mut nsContentUtils_sScriptBlockerCount: u32;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils28sDOMNodeRemovedSuppressCountE"]
        pub static mut nsContentUtils_sDOMNodeRemovedSuppressCount: u32;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils21sBlockedScriptRunnersE"]
        pub static mut nsContentUtils_sBlockedScriptRunners: *mut u8;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils27sRunnersCountAtFirstBlockerE"]
        pub static mut nsContentUtils_sRunnersCountAtFirstBlocker: u32;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils40sScriptBlockerCountWhereRunnersPreventedE"]
        pub static mut nsContentUtils_sScriptBlockerCountWhereRunnersPrevented: u32;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils18sSameOriginCheckerE"]
        pub static mut nsContentUtils_sSameOriginChecker: *mut root::nsIInterfaceRequestor;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils24sIsHandlingKeyBoardEventE"]
        pub static mut nsContentUtils_sIsHandlingKeyBoardEvent: bool;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils21sAllowXULXBL_for_fileE"]
        pub static mut nsContentUtils_sAllowXULXBL_for_file: bool;
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsContentUtils_UserInteractionObserver {
        _unused: [u8; 0],
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils24sUserInteractionObserverE"]
        pub static mut nsContentUtils_sUserInteractionObserver:
            *mut root::nsContentUtils_UserInteractionObserver;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils19sHTMLFragmentParserE"]
        pub static mut nsContentUtils_sHTMLFragmentParser: *mut root::nsHtml5StringParser;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils18sXMLFragmentParserE"]
        pub static mut nsContentUtils_sXMLFragmentParser: *mut root::nsIParser;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils16sXMLFragmentSinkE"]
        pub static mut nsContentUtils_sXMLFragmentSink: *mut root::nsIFragmentContentSink;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils22sFragmentParsingActiveE"]
        pub static mut nsContentUtils_sFragmentParsingActive: bool;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils10sShiftTextE"]
        pub static mut nsContentUtils_sShiftText: *mut ::gecko_bindings::structs::nsString;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils12sControlTextE"]
        pub static mut nsContentUtils_sControlText: *mut ::gecko_bindings::structs::nsString;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils9sMetaTextE"]
        pub static mut nsContentUtils_sMetaText: *mut ::gecko_bindings::structs::nsString;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils7sOSTextE"]
        pub static mut nsContentUtils_sOSText: *mut ::gecko_bindings::structs::nsString;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils8sAltTextE"]
        pub static mut nsContentUtils_sAltText: *mut ::gecko_bindings::structs::nsString;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils18sModifierSeparatorE"]
        pub static mut nsContentUtils_sModifierSeparator: *mut ::gecko_bindings::structs::nsString;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils19sJSBytecodeMimeTypeE"]
        pub static mut nsContentUtils_sJSBytecodeMimeType: *mut ::gecko_bindings::structs::nsCString;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils11sDOMDumpLogE"]
        pub static mut nsContentUtils_sDOMDumpLog: root::mozilla::LazyLogModule;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils24sInnerOrOuterWindowCountE"]
        pub static mut nsContentUtils_sInnerOrOuterWindowCount: i32;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN14nsContentUtils32sInnerOrOuterWindowSerialCounterE"]
        pub static mut nsContentUtils_sInnerOrOuterWindowSerialCounter: u32;
    }
    #[doc = " Structure used as a key for caching Attrs in nsDOMAttributeMap\'s"]
    #[doc = " mAttributeCache."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsAttrKey {
        #[doc = " The namespace of the attribute"]
        pub mNamespaceID: i32,
        #[doc = " The atom for attribute, stored as void*, to make sure that we only use it"]
        #[doc = " for the hashcode, and we can never dereference it."]
        pub mLocalName: *mut ::std::os::raw::c_void,
    }
    #[test]
    fn bindgen_test_layout_nsAttrKey() {
        assert_eq!(
            ::std::mem::size_of::<nsAttrKey>(),
            16usize,
            concat!("Size of: ", stringify!(nsAttrKey))
        );
        assert_eq!(
            ::std::mem::align_of::<nsAttrKey>(),
            8usize,
            concat!("Alignment of ", stringify!(nsAttrKey))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsAttrKey>())).mNamespaceID as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsAttrKey),
                "::",
                stringify!(mNamespaceID)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsAttrKey>())).mLocalName as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsAttrKey),
                "::",
                stringify!(mLocalName)
            )
        );
    }
    #[doc = " PLDHashEntryHdr implementation for nsAttrKey."]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsAttrHashKey {
        pub mKey: root::nsAttrKey,
    }
    pub type nsAttrHashKey_KeyType = *const root::nsAttrKey;
    pub type nsAttrHashKey_KeyTypePointer = *const root::nsAttrKey;
    pub const nsAttrHashKey_ALLOW_MEMMOVE: root::nsAttrHashKey__bindgen_ty_1 = 1;
    pub type nsAttrHashKey__bindgen_ty_1 = u32;
    #[test]
    fn bindgen_test_layout_nsAttrHashKey() {
        assert_eq!(
            ::std::mem::size_of::<nsAttrHashKey>(),
            16usize,
            concat!("Size of: ", stringify!(nsAttrHashKey))
        );
        assert_eq!(
            ::std::mem::align_of::<nsAttrHashKey>(),
            8usize,
            concat!("Alignment of ", stringify!(nsAttrHashKey))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsAttrHashKey>())).mKey as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsAttrHashKey),
                "::",
                stringify!(mKey)
            )
        );
    }
    #[repr(C)]
    pub struct nsDOMAttributeMap {
        pub _base: root::nsISupports,
        pub _base_1: root::nsWrapperCache,
        pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
        pub mContent: root::nsCOMPtr,
        #[doc = " Cache of Attrs."]
        pub mAttributeCache: root::nsDOMAttributeMap_AttrCache,
    }
    pub type nsDOMAttributeMap_Attr = root::mozilla::dom::Attr;
    pub type nsDOMAttributeMap_DocGroup = root::mozilla::dom::DocGroup;
    pub type nsDOMAttributeMap_Document = root::mozilla::dom::Document;
    pub type nsDOMAttributeMap_Element = root::mozilla::dom::Element;
    pub type nsDOMAttributeMap_ErrorResult = root::mozilla::ErrorResult;
    pub type nsDOMAttributeMap_HasThreadSafeRefCnt = root::mozilla::FalseType;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsDOMAttributeMap_cycleCollection {
        pub _base: root::nsXPCOMCycleCollectionParticipant,
    }
    #[test]
    fn bindgen_test_layout_nsDOMAttributeMap_cycleCollection() {
        assert_eq!(
            ::std::mem::size_of::<nsDOMAttributeMap_cycleCollection>(),
            16usize,
            concat!("Size of: ", stringify!(nsDOMAttributeMap_cycleCollection))
        );
        assert_eq!(
            ::std::mem::align_of::<nsDOMAttributeMap_cycleCollection>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(nsDOMAttributeMap_cycleCollection)
            )
        );
    }
    pub type nsDOMAttributeMap_AttrCache = [u64; 4usize];
    extern "C" {
        #[link_name = "\u{1}_ZN17nsDOMAttributeMap21_cycleCollectorGlobalE"]
        pub static mut nsDOMAttributeMap__cycleCollectorGlobal:
            root::nsDOMAttributeMap_cycleCollection;
    }
    #[test]
    fn bindgen_test_layout_nsDOMAttributeMap() {
        assert_eq!(
            ::std::mem::size_of::<nsDOMAttributeMap>(),
            80usize,
            concat!("Size of: ", stringify!(nsDOMAttributeMap))
        );
        assert_eq!(
            ::std::mem::align_of::<nsDOMAttributeMap>(),
            8usize,
            concat!("Alignment of ", stringify!(nsDOMAttributeMap))
        );
    }
    #[repr(C)]
    pub struct nsQueryFrame__bindgen_vtable(::std::os::raw::c_void);
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsQueryFrame {
        pub vtable_: *const nsQueryFrame__bindgen_vtable,
    }
    pub const nsQueryFrame_FrameIID_BRFrame_id: root::nsQueryFrame_FrameIID = 0;
    pub const nsQueryFrame_FrameIID_DetailsFrame_id: root::nsQueryFrame_FrameIID = 1;
    pub const nsQueryFrame_FrameIID_nsBCTableCellFrame_id: root::nsQueryFrame_FrameIID = 2;
    pub const nsQueryFrame_FrameIID_nsBackdropFrame_id: root::nsQueryFrame_FrameIID = 3;
    pub const nsQueryFrame_FrameIID_nsBlockFrame_id: root::nsQueryFrame_FrameIID = 4;
    pub const nsQueryFrame_FrameIID_nsBox_id: root::nsQueryFrame_FrameIID = 5;
    pub const nsQueryFrame_FrameIID_nsBoxFrame_id: root::nsQueryFrame_FrameIID = 6;
    pub const nsQueryFrame_FrameIID_nsBulletFrame_id: root::nsQueryFrame_FrameIID = 7;
    pub const nsQueryFrame_FrameIID_nsButtonBoxFrame_id: root::nsQueryFrame_FrameIID = 8;
    pub const nsQueryFrame_FrameIID_nsCanvasFrame_id: root::nsQueryFrame_FrameIID = 9;
    pub const nsQueryFrame_FrameIID_nsCheckboxRadioFrame_id: root::nsQueryFrame_FrameIID = 10;
    pub const nsQueryFrame_FrameIID_nsColorControlFrame_id: root::nsQueryFrame_FrameIID = 11;
    pub const nsQueryFrame_FrameIID_nsColumnSetFrame_id: root::nsQueryFrame_FrameIID = 12;
    pub const nsQueryFrame_FrameIID_ColumnSetWrapperFrame_id: root::nsQueryFrame_FrameIID = 13;
    pub const nsQueryFrame_FrameIID_nsComboboxControlFrame_id: root::nsQueryFrame_FrameIID = 14;
    pub const nsQueryFrame_FrameIID_nsComboboxDisplayFrame_id: root::nsQueryFrame_FrameIID = 15;
    pub const nsQueryFrame_FrameIID_nsContinuingTextFrame_id: root::nsQueryFrame_FrameIID = 16;
    pub const nsQueryFrame_FrameIID_nsDateTimeControlFrame_id: root::nsQueryFrame_FrameIID = 17;
    pub const nsQueryFrame_FrameIID_nsDeckFrame_id: root::nsQueryFrame_FrameIID = 18;
    pub const nsQueryFrame_FrameIID_nsDocElementBoxFrame_id: root::nsQueryFrame_FrameIID = 19;
    pub const nsQueryFrame_FrameIID_nsFieldSetFrame_id: root::nsQueryFrame_FrameIID = 20;
    pub const nsQueryFrame_FrameIID_nsFileControlFrame_id: root::nsQueryFrame_FrameIID = 21;
    pub const nsQueryFrame_FrameIID_nsFirstLetterFrame_id: root::nsQueryFrame_FrameIID = 22;
    pub const nsQueryFrame_FrameIID_nsFirstLineFrame_id: root::nsQueryFrame_FrameIID = 23;
    pub const nsQueryFrame_FrameIID_nsFlexContainerFrame_id: root::nsQueryFrame_FrameIID = 24;
    pub const nsQueryFrame_FrameIID_nsFrame_id: root::nsQueryFrame_FrameIID = 25;
    pub const nsQueryFrame_FrameIID_nsGfxButtonControlFrame_id: root::nsQueryFrame_FrameIID = 26;
    pub const nsQueryFrame_FrameIID_nsGridContainerFrame_id: root::nsQueryFrame_FrameIID = 27;
    pub const nsQueryFrame_FrameIID_nsGridRowGroupFrame_id: root::nsQueryFrame_FrameIID = 28;
    pub const nsQueryFrame_FrameIID_nsGridRowLeafFrame_id: root::nsQueryFrame_FrameIID = 29;
    pub const nsQueryFrame_FrameIID_nsGroupBoxFrame_id: root::nsQueryFrame_FrameIID = 30;
    pub const nsQueryFrame_FrameIID_nsHTMLButtonControlFrame_id: root::nsQueryFrame_FrameIID = 31;
    pub const nsQueryFrame_FrameIID_nsHTMLCanvasFrame_id: root::nsQueryFrame_FrameIID = 32;
    pub const nsQueryFrame_FrameIID_nsHTMLFramesetBlankFrame_id: root::nsQueryFrame_FrameIID = 33;
    pub const nsQueryFrame_FrameIID_nsHTMLFramesetBorderFrame_id: root::nsQueryFrame_FrameIID = 34;
    pub const nsQueryFrame_FrameIID_nsHTMLFramesetFrame_id: root::nsQueryFrame_FrameIID = 35;
    pub const nsQueryFrame_FrameIID_nsHTMLScrollFrame_id: root::nsQueryFrame_FrameIID = 36;
    pub const nsQueryFrame_FrameIID_nsImageBoxFrame_id: root::nsQueryFrame_FrameIID = 37;
    pub const nsQueryFrame_FrameIID_nsImageControlFrame_id: root::nsQueryFrame_FrameIID = 38;
    pub const nsQueryFrame_FrameIID_nsImageFrame_id: root::nsQueryFrame_FrameIID = 39;
    pub const nsQueryFrame_FrameIID_nsInlineFrame_id: root::nsQueryFrame_FrameIID = 40;
    pub const nsQueryFrame_FrameIID_nsLeafBoxFrame_id: root::nsQueryFrame_FrameIID = 41;
    pub const nsQueryFrame_FrameIID_nsLegendFrame_id: root::nsQueryFrame_FrameIID = 42;
    pub const nsQueryFrame_FrameIID_nsListControlFrame_id: root::nsQueryFrame_FrameIID = 43;
    pub const nsQueryFrame_FrameIID_nsMathMLFrame_id: root::nsQueryFrame_FrameIID = 44;
    pub const nsQueryFrame_FrameIID_nsMathMLmactionFrame_id: root::nsQueryFrame_FrameIID = 45;
    pub const nsQueryFrame_FrameIID_nsMathMLmathBlockFrame_id: root::nsQueryFrame_FrameIID = 46;
    pub const nsQueryFrame_FrameIID_nsMathMLmathInlineFrame_id: root::nsQueryFrame_FrameIID = 47;
    pub const nsQueryFrame_FrameIID_nsMathMLmencloseFrame_id: root::nsQueryFrame_FrameIID = 48;
    pub const nsQueryFrame_FrameIID_nsMathMLmfencedFrame_id: root::nsQueryFrame_FrameIID = 49;
    pub const nsQueryFrame_FrameIID_nsMathMLmfracFrame_id: root::nsQueryFrame_FrameIID = 50;
    pub const nsQueryFrame_FrameIID_nsMathMLmmultiscriptsFrame_id: root::nsQueryFrame_FrameIID = 51;
    pub const nsQueryFrame_FrameIID_nsMathMLmoFrame_id: root::nsQueryFrame_FrameIID = 52;
    pub const nsQueryFrame_FrameIID_nsMathMLmpaddedFrame_id: root::nsQueryFrame_FrameIID = 53;
    pub const nsQueryFrame_FrameIID_nsMathMLmrootFrame_id: root::nsQueryFrame_FrameIID = 54;
    pub const nsQueryFrame_FrameIID_nsMathMLmrowFrame_id: root::nsQueryFrame_FrameIID = 55;
    pub const nsQueryFrame_FrameIID_nsMathMLmspaceFrame_id: root::nsQueryFrame_FrameIID = 56;
    pub const nsQueryFrame_FrameIID_nsMathMLmsqrtFrame_id: root::nsQueryFrame_FrameIID = 57;
    pub const nsQueryFrame_FrameIID_nsMathMLmtableFrame_id: root::nsQueryFrame_FrameIID = 58;
    pub const nsQueryFrame_FrameIID_nsMathMLmtableWrapperFrame_id: root::nsQueryFrame_FrameIID = 59;
    pub const nsQueryFrame_FrameIID_nsMathMLmtdFrame_id: root::nsQueryFrame_FrameIID = 60;
    pub const nsQueryFrame_FrameIID_nsMathMLmtdInnerFrame_id: root::nsQueryFrame_FrameIID = 61;
    pub const nsQueryFrame_FrameIID_nsMathMLmtrFrame_id: root::nsQueryFrame_FrameIID = 62;
    pub const nsQueryFrame_FrameIID_nsMathMLmunderoverFrame_id: root::nsQueryFrame_FrameIID = 63;
    pub const nsQueryFrame_FrameIID_nsMathMLsemanticsFrame_id: root::nsQueryFrame_FrameIID = 64;
    pub const nsQueryFrame_FrameIID_nsMathMLTokenFrame_id: root::nsQueryFrame_FrameIID = 65;
    pub const nsQueryFrame_FrameIID_nsMenuBarFrame_id: root::nsQueryFrame_FrameIID = 66;
    pub const nsQueryFrame_FrameIID_nsMenuFrame_id: root::nsQueryFrame_FrameIID = 67;
    pub const nsQueryFrame_FrameIID_nsMenuPopupFrame_id: root::nsQueryFrame_FrameIID = 68;
    pub const nsQueryFrame_FrameIID_nsMeterFrame_id: root::nsQueryFrame_FrameIID = 69;
    pub const nsQueryFrame_FrameIID_nsNumberControlFrame_id: root::nsQueryFrame_FrameIID = 70;
    pub const nsQueryFrame_FrameIID_nsPluginFrame_id: root::nsQueryFrame_FrameIID = 71;
    pub const nsQueryFrame_FrameIID_nsPageBreakFrame_id: root::nsQueryFrame_FrameIID = 72;
    pub const nsQueryFrame_FrameIID_nsPageContentFrame_id: root::nsQueryFrame_FrameIID = 73;
    pub const nsQueryFrame_FrameIID_nsPageFrame_id: root::nsQueryFrame_FrameIID = 74;
    pub const nsQueryFrame_FrameIID_nsPlaceholderFrame_id: root::nsQueryFrame_FrameIID = 75;
    pub const nsQueryFrame_FrameIID_nsPopupSetFrame_id: root::nsQueryFrame_FrameIID = 76;
    pub const nsQueryFrame_FrameIID_nsProgressFrame_id: root::nsQueryFrame_FrameIID = 77;
    pub const nsQueryFrame_FrameIID_nsRangeFrame_id: root::nsQueryFrame_FrameIID = 78;
    pub const nsQueryFrame_FrameIID_nsResizerFrame_id: root::nsQueryFrame_FrameIID = 79;
    pub const nsQueryFrame_FrameIID_nsRootBoxFrame_id: root::nsQueryFrame_FrameIID = 80;
    pub const nsQueryFrame_FrameIID_nsRubyBaseContainerFrame_id: root::nsQueryFrame_FrameIID = 81;
    pub const nsQueryFrame_FrameIID_nsRubyBaseFrame_id: root::nsQueryFrame_FrameIID = 82;
    pub const nsQueryFrame_FrameIID_nsRubyFrame_id: root::nsQueryFrame_FrameIID = 83;
    pub const nsQueryFrame_FrameIID_nsRubyTextContainerFrame_id: root::nsQueryFrame_FrameIID = 84;
    pub const nsQueryFrame_FrameIID_nsRubyTextFrame_id: root::nsQueryFrame_FrameIID = 85;
    pub const nsQueryFrame_FrameIID_nsScrollbarButtonFrame_id: root::nsQueryFrame_FrameIID = 86;
    pub const nsQueryFrame_FrameIID_nsScrollbarFrame_id: root::nsQueryFrame_FrameIID = 87;
    pub const nsQueryFrame_FrameIID_nsSelectsAreaFrame_id: root::nsQueryFrame_FrameIID = 88;
    pub const nsQueryFrame_FrameIID_nsSimplePageSequenceFrame_id: root::nsQueryFrame_FrameIID = 89;
    pub const nsQueryFrame_FrameIID_nsSliderFrame_id: root::nsQueryFrame_FrameIID = 90;
    pub const nsQueryFrame_FrameIID_nsSplitterFrame_id: root::nsQueryFrame_FrameIID = 91;
    pub const nsQueryFrame_FrameIID_nsStackFrame_id: root::nsQueryFrame_FrameIID = 92;
    pub const nsQueryFrame_FrameIID_nsSubDocumentFrame_id: root::nsQueryFrame_FrameIID = 93;
    pub const nsQueryFrame_FrameIID_nsSVGAFrame_id: root::nsQueryFrame_FrameIID = 94;
    pub const nsQueryFrame_FrameIID_nsSVGClipPathFrame_id: root::nsQueryFrame_FrameIID = 95;
    pub const nsQueryFrame_FrameIID_nsSVGContainerFrame_id: root::nsQueryFrame_FrameIID = 96;
    pub const nsQueryFrame_FrameIID_SVGFEContainerFrame_id: root::nsQueryFrame_FrameIID = 97;
    pub const nsQueryFrame_FrameIID_SVGFEImageFrame_id: root::nsQueryFrame_FrameIID = 98;
    pub const nsQueryFrame_FrameIID_SVGFELeafFrame_id: root::nsQueryFrame_FrameIID = 99;
    pub const nsQueryFrame_FrameIID_SVGFEUnstyledLeafFrame_id: root::nsQueryFrame_FrameIID = 100;
    pub const nsQueryFrame_FrameIID_nsSVGFilterFrame_id: root::nsQueryFrame_FrameIID = 101;
    pub const nsQueryFrame_FrameIID_nsSVGForeignObjectFrame_id: root::nsQueryFrame_FrameIID = 102;
    pub const nsQueryFrame_FrameIID_nsSVGGenericContainerFrame_id: root::nsQueryFrame_FrameIID =
        103;
    pub const nsQueryFrame_FrameIID_nsSVGGFrame_id: root::nsQueryFrame_FrameIID = 104;
    pub const nsQueryFrame_FrameIID_nsSVGImageFrame_id: root::nsQueryFrame_FrameIID = 105;
    pub const nsQueryFrame_FrameIID_nsSVGInnerSVGFrame_id: root::nsQueryFrame_FrameIID = 106;
    pub const nsQueryFrame_FrameIID_nsSVGLinearGradientFrame_id: root::nsQueryFrame_FrameIID = 107;
    pub const nsQueryFrame_FrameIID_nsSVGMarkerFrame_id: root::nsQueryFrame_FrameIID = 108;
    pub const nsQueryFrame_FrameIID_nsSVGMarkerAnonChildFrame_id: root::nsQueryFrame_FrameIID = 109;
    pub const nsQueryFrame_FrameIID_nsSVGMaskFrame_id: root::nsQueryFrame_FrameIID = 110;
    pub const nsQueryFrame_FrameIID_nsSVGOuterSVGFrame_id: root::nsQueryFrame_FrameIID = 111;
    pub const nsQueryFrame_FrameIID_nsSVGOuterSVGAnonChildFrame_id: root::nsQueryFrame_FrameIID =
        112;
    pub const nsQueryFrame_FrameIID_SVGGeometryFrame_id: root::nsQueryFrame_FrameIID = 113;
    pub const nsQueryFrame_FrameIID_nsSVGPatternFrame_id: root::nsQueryFrame_FrameIID = 114;
    pub const nsQueryFrame_FrameIID_nsSVGRadialGradientFrame_id: root::nsQueryFrame_FrameIID = 115;
    pub const nsQueryFrame_FrameIID_nsSVGStopFrame_id: root::nsQueryFrame_FrameIID = 116;
    pub const nsQueryFrame_FrameIID_nsSVGSwitchFrame_id: root::nsQueryFrame_FrameIID = 117;
    pub const nsQueryFrame_FrameIID_nsSVGSymbolFrame_id: root::nsQueryFrame_FrameIID = 118;
    pub const nsQueryFrame_FrameIID_SVGTextFrame_id: root::nsQueryFrame_FrameIID = 119;
    pub const nsQueryFrame_FrameIID_nsSVGUseFrame_id: root::nsQueryFrame_FrameIID = 120;
    pub const nsQueryFrame_FrameIID_SVGViewFrame_id: root::nsQueryFrame_FrameIID = 121;
    pub const nsQueryFrame_FrameIID_nsTableCellFrame_id: root::nsQueryFrame_FrameIID = 122;
    pub const nsQueryFrame_FrameIID_nsTableColFrame_id: root::nsQueryFrame_FrameIID = 123;
    pub const nsQueryFrame_FrameIID_nsTableColGroupFrame_id: root::nsQueryFrame_FrameIID = 124;
    pub const nsQueryFrame_FrameIID_nsTableFrame_id: root::nsQueryFrame_FrameIID = 125;
    pub const nsQueryFrame_FrameIID_nsTableWrapperFrame_id: root::nsQueryFrame_FrameIID = 126;
    pub const nsQueryFrame_FrameIID_nsTableRowFrame_id: root::nsQueryFrame_FrameIID = 127;
    pub const nsQueryFrame_FrameIID_nsTableRowGroupFrame_id: root::nsQueryFrame_FrameIID = 128;
    pub const nsQueryFrame_FrameIID_nsTextBoxFrame_id: root::nsQueryFrame_FrameIID = 129;
    pub const nsQueryFrame_FrameIID_nsTextControlFrame_id: root::nsQueryFrame_FrameIID = 130;
    pub const nsQueryFrame_FrameIID_nsTextFrame_id: root::nsQueryFrame_FrameIID = 131;
    pub const nsQueryFrame_FrameIID_nsTitleBarFrame_id: root::nsQueryFrame_FrameIID = 132;
    pub const nsQueryFrame_FrameIID_nsTreeBodyFrame_id: root::nsQueryFrame_FrameIID = 133;
    pub const nsQueryFrame_FrameIID_nsTreeColFrame_id: root::nsQueryFrame_FrameIID = 134;
    pub const nsQueryFrame_FrameIID_nsVideoFrame_id: root::nsQueryFrame_FrameIID = 135;
    pub const nsQueryFrame_FrameIID_nsXULLabelFrame_id: root::nsQueryFrame_FrameIID = 136;
    pub const nsQueryFrame_FrameIID_nsXULScrollFrame_id: root::nsQueryFrame_FrameIID = 137;
    pub const nsQueryFrame_FrameIID_ViewportFrame_id: root::nsQueryFrame_FrameIID = 138;
    pub const nsQueryFrame_FrameIID_nsContainerFrame_id: root::nsQueryFrame_FrameIID = 139;
    pub const nsQueryFrame_FrameIID_nsIFrame_id: root::nsQueryFrame_FrameIID = 140;
    pub const nsQueryFrame_FrameIID_nsLeafFrame_id: root::nsQueryFrame_FrameIID = 141;
    pub const nsQueryFrame_FrameIID_nsMathMLContainerFrame_id: root::nsQueryFrame_FrameIID = 142;
    pub const nsQueryFrame_FrameIID_nsRubyContentFrame_id: root::nsQueryFrame_FrameIID = 143;
    pub const nsQueryFrame_FrameIID_nsSplittableFrame_id: root::nsQueryFrame_FrameIID = 144;
    pub const nsQueryFrame_FrameIID_nsSVGDisplayContainerFrame_id: root::nsQueryFrame_FrameIID =
        145;
    pub const nsQueryFrame_FrameIID_nsSVGGradientFrame_id: root::nsQueryFrame_FrameIID = 146;
    pub const nsQueryFrame_FrameIID_nsSVGPaintServerFrame_id: root::nsQueryFrame_FrameIID = 147;
    pub const nsQueryFrame_FrameIID_nsIAnonymousContentCreator_id: root::nsQueryFrame_FrameIID =
        148;
    pub const nsQueryFrame_FrameIID_nsIComboboxControlFrame_id: root::nsQueryFrame_FrameIID = 149;
    pub const nsQueryFrame_FrameIID_nsIFormControlFrame_id: root::nsQueryFrame_FrameIID = 150;
    pub const nsQueryFrame_FrameIID_nsIFrameFrame_id: root::nsQueryFrame_FrameIID = 151;
    pub const nsQueryFrame_FrameIID_nsIListControlFrame_id: root::nsQueryFrame_FrameIID = 152;
    pub const nsQueryFrame_FrameIID_nsIMathMLFrame_id: root::nsQueryFrame_FrameIID = 153;
    pub const nsQueryFrame_FrameIID_nsIMenuFrame_id: root::nsQueryFrame_FrameIID = 154;
    pub const nsQueryFrame_FrameIID_nsIObjectFrame_id: root::nsQueryFrame_FrameIID = 155;
    pub const nsQueryFrame_FrameIID_nsIPageSequenceFrame_id: root::nsQueryFrame_FrameIID = 156;
    pub const nsQueryFrame_FrameIID_nsIPercentBSizeObserver_id: root::nsQueryFrame_FrameIID = 157;
    pub const nsQueryFrame_FrameIID_nsIPopupContainer_id: root::nsQueryFrame_FrameIID = 158;
    pub const nsQueryFrame_FrameIID_nsIScrollableFrame_id: root::nsQueryFrame_FrameIID = 159;
    pub const nsQueryFrame_FrameIID_nsIScrollbarMediator_id: root::nsQueryFrame_FrameIID = 160;
    pub const nsQueryFrame_FrameIID_nsISelectControlFrame_id: root::nsQueryFrame_FrameIID = 161;
    pub const nsQueryFrame_FrameIID_nsISVGSVGFrame_id: root::nsQueryFrame_FrameIID = 162;
    pub const nsQueryFrame_FrameIID_nsIStatefulFrame_id: root::nsQueryFrame_FrameIID = 163;
    pub const nsQueryFrame_FrameIID_nsITableCellLayout_id: root::nsQueryFrame_FrameIID = 164;
    pub const nsQueryFrame_FrameIID_nsITableLayout_id: root::nsQueryFrame_FrameIID = 165;
    pub const nsQueryFrame_FrameIID_nsITextControlFrame_id: root::nsQueryFrame_FrameIID = 166;
    pub const nsQueryFrame_FrameIID_nsSVGDisplayableFrame_id: root::nsQueryFrame_FrameIID = 167;
    pub const nsQueryFrame_FrameIID_NON_FRAME_MARKER: root::nsQueryFrame_FrameIID = 168;
    pub type nsQueryFrame_FrameIID = u32;
    pub const nsQueryFrame_ClassID_BRFrame_id: root::nsQueryFrame_ClassID = 0;
    pub const nsQueryFrame_ClassID_DetailsFrame_id: root::nsQueryFrame_ClassID = 1;
    pub const nsQueryFrame_ClassID_nsBCTableCellFrame_id: root::nsQueryFrame_ClassID = 2;
    pub const nsQueryFrame_ClassID_nsBackdropFrame_id: root::nsQueryFrame_ClassID = 3;
    pub const nsQueryFrame_ClassID_nsBlockFrame_id: root::nsQueryFrame_ClassID = 4;
    pub const nsQueryFrame_ClassID_nsBox_id: root::nsQueryFrame_ClassID = 5;
    pub const nsQueryFrame_ClassID_nsBoxFrame_id: root::nsQueryFrame_ClassID = 6;
    pub const nsQueryFrame_ClassID_nsBulletFrame_id: root::nsQueryFrame_ClassID = 7;
    pub const nsQueryFrame_ClassID_nsButtonBoxFrame_id: root::nsQueryFrame_ClassID = 8;
    pub const nsQueryFrame_ClassID_nsCanvasFrame_id: root::nsQueryFrame_ClassID = 9;
    pub const nsQueryFrame_ClassID_nsCheckboxRadioFrame_id: root::nsQueryFrame_ClassID = 10;
    pub const nsQueryFrame_ClassID_nsColorControlFrame_id: root::nsQueryFrame_ClassID = 11;
    pub const nsQueryFrame_ClassID_nsColumnSetFrame_id: root::nsQueryFrame_ClassID = 12;
    pub const nsQueryFrame_ClassID_ColumnSetWrapperFrame_id: root::nsQueryFrame_ClassID = 13;
    pub const nsQueryFrame_ClassID_nsComboboxControlFrame_id: root::nsQueryFrame_ClassID = 14;
    pub const nsQueryFrame_ClassID_nsComboboxDisplayFrame_id: root::nsQueryFrame_ClassID = 15;
    pub const nsQueryFrame_ClassID_nsContinuingTextFrame_id: root::nsQueryFrame_ClassID = 16;
    pub const nsQueryFrame_ClassID_nsDateTimeControlFrame_id: root::nsQueryFrame_ClassID = 17;
    pub const nsQueryFrame_ClassID_nsDeckFrame_id: root::nsQueryFrame_ClassID = 18;
    pub const nsQueryFrame_ClassID_nsDocElementBoxFrame_id: root::nsQueryFrame_ClassID = 19;
    pub const nsQueryFrame_ClassID_nsFieldSetFrame_id: root::nsQueryFrame_ClassID = 20;
    pub const nsQueryFrame_ClassID_nsFileControlFrame_id: root::nsQueryFrame_ClassID = 21;
    pub const nsQueryFrame_ClassID_nsFirstLetterFrame_id: root::nsQueryFrame_ClassID = 22;
    pub const nsQueryFrame_ClassID_nsFirstLineFrame_id: root::nsQueryFrame_ClassID = 23;
    pub const nsQueryFrame_ClassID_nsFlexContainerFrame_id: root::nsQueryFrame_ClassID = 24;
    pub const nsQueryFrame_ClassID_nsFrame_id: root::nsQueryFrame_ClassID = 25;
    pub const nsQueryFrame_ClassID_nsGfxButtonControlFrame_id: root::nsQueryFrame_ClassID = 26;
    pub const nsQueryFrame_ClassID_nsGridContainerFrame_id: root::nsQueryFrame_ClassID = 27;
    pub const nsQueryFrame_ClassID_nsGridRowGroupFrame_id: root::nsQueryFrame_ClassID = 28;
    pub const nsQueryFrame_ClassID_nsGridRowLeafFrame_id: root::nsQueryFrame_ClassID = 29;
    pub const nsQueryFrame_ClassID_nsGroupBoxFrame_id: root::nsQueryFrame_ClassID = 30;
    pub const nsQueryFrame_ClassID_nsHTMLButtonControlFrame_id: root::nsQueryFrame_ClassID = 31;
    pub const nsQueryFrame_ClassID_nsHTMLCanvasFrame_id: root::nsQueryFrame_ClassID = 32;
    pub const nsQueryFrame_ClassID_nsHTMLFramesetBlankFrame_id: root::nsQueryFrame_ClassID = 33;
    pub const nsQueryFrame_ClassID_nsHTMLFramesetBorderFrame_id: root::nsQueryFrame_ClassID = 34;
    pub const nsQueryFrame_ClassID_nsHTMLFramesetFrame_id: root::nsQueryFrame_ClassID = 35;
    pub const nsQueryFrame_ClassID_nsHTMLScrollFrame_id: root::nsQueryFrame_ClassID = 36;
    pub const nsQueryFrame_ClassID_nsImageBoxFrame_id: root::nsQueryFrame_ClassID = 37;
    pub const nsQueryFrame_ClassID_nsImageControlFrame_id: root::nsQueryFrame_ClassID = 38;
    pub const nsQueryFrame_ClassID_nsImageFrame_id: root::nsQueryFrame_ClassID = 39;
    pub const nsQueryFrame_ClassID_nsInlineFrame_id: root::nsQueryFrame_ClassID = 40;
    pub const nsQueryFrame_ClassID_nsLeafBoxFrame_id: root::nsQueryFrame_ClassID = 41;
    pub const nsQueryFrame_ClassID_nsLegendFrame_id: root::nsQueryFrame_ClassID = 42;
    pub const nsQueryFrame_ClassID_nsListControlFrame_id: root::nsQueryFrame_ClassID = 43;
    pub const nsQueryFrame_ClassID_nsMathMLFrame_id: root::nsQueryFrame_ClassID = 44;
    pub const nsQueryFrame_ClassID_nsMathMLmactionFrame_id: root::nsQueryFrame_ClassID = 45;
    pub const nsQueryFrame_ClassID_nsMathMLmathBlockFrame_id: root::nsQueryFrame_ClassID = 46;
    pub const nsQueryFrame_ClassID_nsMathMLmathInlineFrame_id: root::nsQueryFrame_ClassID = 47;
    pub const nsQueryFrame_ClassID_nsMathMLmencloseFrame_id: root::nsQueryFrame_ClassID = 48;
    pub const nsQueryFrame_ClassID_nsMathMLmfencedFrame_id: root::nsQueryFrame_ClassID = 49;
    pub const nsQueryFrame_ClassID_nsMathMLmfracFrame_id: root::nsQueryFrame_ClassID = 50;
    pub const nsQueryFrame_ClassID_nsMathMLmmultiscriptsFrame_id: root::nsQueryFrame_ClassID = 51;
    pub const nsQueryFrame_ClassID_nsMathMLmoFrame_id: root::nsQueryFrame_ClassID = 52;
    pub const nsQueryFrame_ClassID_nsMathMLmpaddedFrame_id: root::nsQueryFrame_ClassID = 53;
    pub const nsQueryFrame_ClassID_nsMathMLmrootFrame_id: root::nsQueryFrame_ClassID = 54;
    pub const nsQueryFrame_ClassID_nsMathMLmrowFrame_id: root::nsQueryFrame_ClassID = 55;
    pub const nsQueryFrame_ClassID_nsMathMLmspaceFrame_id: root::nsQueryFrame_ClassID = 56;
    pub const nsQueryFrame_ClassID_nsMathMLmsqrtFrame_id: root::nsQueryFrame_ClassID = 57;
    pub const nsQueryFrame_ClassID_nsMathMLmtableFrame_id: root::nsQueryFrame_ClassID = 58;
    pub const nsQueryFrame_ClassID_nsMathMLmtableWrapperFrame_id: root::nsQueryFrame_ClassID = 59;
    pub const nsQueryFrame_ClassID_nsMathMLmtdFrame_id: root::nsQueryFrame_ClassID = 60;
    pub const nsQueryFrame_ClassID_nsMathMLmtdInnerFrame_id: root::nsQueryFrame_ClassID = 61;
    pub const nsQueryFrame_ClassID_nsMathMLmtrFrame_id: root::nsQueryFrame_ClassID = 62;
    pub const nsQueryFrame_ClassID_nsMathMLmunderoverFrame_id: root::nsQueryFrame_ClassID = 63;
    pub const nsQueryFrame_ClassID_nsMathMLsemanticsFrame_id: root::nsQueryFrame_ClassID = 64;
    pub const nsQueryFrame_ClassID_nsMathMLTokenFrame_id: root::nsQueryFrame_ClassID = 65;
    pub const nsQueryFrame_ClassID_nsMenuBarFrame_id: root::nsQueryFrame_ClassID = 66;
    pub const nsQueryFrame_ClassID_nsMenuFrame_id: root::nsQueryFrame_ClassID = 67;
    pub const nsQueryFrame_ClassID_nsMenuPopupFrame_id: root::nsQueryFrame_ClassID = 68;
    pub const nsQueryFrame_ClassID_nsMeterFrame_id: root::nsQueryFrame_ClassID = 69;
    pub const nsQueryFrame_ClassID_nsNumberControlFrame_id: root::nsQueryFrame_ClassID = 70;
    pub const nsQueryFrame_ClassID_nsPluginFrame_id: root::nsQueryFrame_ClassID = 71;
    pub const nsQueryFrame_ClassID_nsPageBreakFrame_id: root::nsQueryFrame_ClassID = 72;
    pub const nsQueryFrame_ClassID_nsPageContentFrame_id: root::nsQueryFrame_ClassID = 73;
    pub const nsQueryFrame_ClassID_nsPageFrame_id: root::nsQueryFrame_ClassID = 74;
    pub const nsQueryFrame_ClassID_nsPlaceholderFrame_id: root::nsQueryFrame_ClassID = 75;
    pub const nsQueryFrame_ClassID_nsPopupSetFrame_id: root::nsQueryFrame_ClassID = 76;
    pub const nsQueryFrame_ClassID_nsProgressFrame_id: root::nsQueryFrame_ClassID = 77;
    pub const nsQueryFrame_ClassID_nsRangeFrame_id: root::nsQueryFrame_ClassID = 78;
    pub const nsQueryFrame_ClassID_nsResizerFrame_id: root::nsQueryFrame_ClassID = 79;
    pub const nsQueryFrame_ClassID_nsRootBoxFrame_id: root::nsQueryFrame_ClassID = 80;
    pub const nsQueryFrame_ClassID_nsRubyBaseContainerFrame_id: root::nsQueryFrame_ClassID = 81;
    pub const nsQueryFrame_ClassID_nsRubyBaseFrame_id: root::nsQueryFrame_ClassID = 82;
    pub const nsQueryFrame_ClassID_nsRubyFrame_id: root::nsQueryFrame_ClassID = 83;
    pub const nsQueryFrame_ClassID_nsRubyTextContainerFrame_id: root::nsQueryFrame_ClassID = 84;
    pub const nsQueryFrame_ClassID_nsRubyTextFrame_id: root::nsQueryFrame_ClassID = 85;
    pub const nsQueryFrame_ClassID_nsScrollbarButtonFrame_id: root::nsQueryFrame_ClassID = 86;
    pub const nsQueryFrame_ClassID_nsScrollbarFrame_id: root::nsQueryFrame_ClassID = 87;
    pub const nsQueryFrame_ClassID_nsSelectsAreaFrame_id: root::nsQueryFrame_ClassID = 88;
    pub const nsQueryFrame_ClassID_nsSimplePageSequenceFrame_id: root::nsQueryFrame_ClassID = 89;
    pub const nsQueryFrame_ClassID_nsSliderFrame_id: root::nsQueryFrame_ClassID = 90;
    pub const nsQueryFrame_ClassID_nsSplitterFrame_id: root::nsQueryFrame_ClassID = 91;
    pub const nsQueryFrame_ClassID_nsStackFrame_id: root::nsQueryFrame_ClassID = 92;
    pub const nsQueryFrame_ClassID_nsSubDocumentFrame_id: root::nsQueryFrame_ClassID = 93;
    pub const nsQueryFrame_ClassID_nsSVGAFrame_id: root::nsQueryFrame_ClassID = 94;
    pub const nsQueryFrame_ClassID_nsSVGClipPathFrame_id: root::nsQueryFrame_ClassID = 95;
    pub const nsQueryFrame_ClassID_nsSVGContainerFrame_id: root::nsQueryFrame_ClassID = 96;
    pub const nsQueryFrame_ClassID_SVGFEContainerFrame_id: root::nsQueryFrame_ClassID = 97;
    pub const nsQueryFrame_ClassID_SVGFEImageFrame_id: root::nsQueryFrame_ClassID = 98;
    pub const nsQueryFrame_ClassID_SVGFELeafFrame_id: root::nsQueryFrame_ClassID = 99;
    pub const nsQueryFrame_ClassID_SVGFEUnstyledLeafFrame_id: root::nsQueryFrame_ClassID = 100;
    pub const nsQueryFrame_ClassID_nsSVGFilterFrame_id: root::nsQueryFrame_ClassID = 101;
    pub const nsQueryFrame_ClassID_nsSVGForeignObjectFrame_id: root::nsQueryFrame_ClassID = 102;
    pub const nsQueryFrame_ClassID_nsSVGGenericContainerFrame_id: root::nsQueryFrame_ClassID = 103;
    pub const nsQueryFrame_ClassID_nsSVGGFrame_id: root::nsQueryFrame_ClassID = 104;
    pub const nsQueryFrame_ClassID_nsSVGImageFrame_id: root::nsQueryFrame_ClassID = 105;
    pub const nsQueryFrame_ClassID_nsSVGInnerSVGFrame_id: root::nsQueryFrame_ClassID = 106;
    pub const nsQueryFrame_ClassID_nsSVGLinearGradientFrame_id: root::nsQueryFrame_ClassID = 107;
    pub const nsQueryFrame_ClassID_nsSVGMarkerFrame_id: root::nsQueryFrame_ClassID = 108;
    pub const nsQueryFrame_ClassID_nsSVGMarkerAnonChildFrame_id: root::nsQueryFrame_ClassID = 109;
    pub const nsQueryFrame_ClassID_nsSVGMaskFrame_id: root::nsQueryFrame_ClassID = 110;
    pub const nsQueryFrame_ClassID_nsSVGOuterSVGFrame_id: root::nsQueryFrame_ClassID = 111;
    pub const nsQueryFrame_ClassID_nsSVGOuterSVGAnonChildFrame_id: root::nsQueryFrame_ClassID = 112;
    pub const nsQueryFrame_ClassID_SVGGeometryFrame_id: root::nsQueryFrame_ClassID = 113;
    pub const nsQueryFrame_ClassID_nsSVGPatternFrame_id: root::nsQueryFrame_ClassID = 114;
    pub const nsQueryFrame_ClassID_nsSVGRadialGradientFrame_id: root::nsQueryFrame_ClassID = 115;
    pub const nsQueryFrame_ClassID_nsSVGStopFrame_id: root::nsQueryFrame_ClassID = 116;
    pub const nsQueryFrame_ClassID_nsSVGSwitchFrame_id: root::nsQueryFrame_ClassID = 117;
    pub const nsQueryFrame_ClassID_nsSVGSymbolFrame_id: root::nsQueryFrame_ClassID = 118;
    pub const nsQueryFrame_ClassID_SVGTextFrame_id: root::nsQueryFrame_ClassID = 119;
    pub const nsQueryFrame_ClassID_nsSVGUseFrame_id: root::nsQueryFrame_ClassID = 120;
    pub const nsQueryFrame_ClassID_SVGViewFrame_id: root::nsQueryFrame_ClassID = 121;
    pub const nsQueryFrame_ClassID_nsTableCellFrame_id: root::nsQueryFrame_ClassID = 122;
    pub const nsQueryFrame_ClassID_nsTableColFrame_id: root::nsQueryFrame_ClassID = 123;
    pub const nsQueryFrame_ClassID_nsTableColGroupFrame_id: root::nsQueryFrame_ClassID = 124;
    pub const nsQueryFrame_ClassID_nsTableFrame_id: root::nsQueryFrame_ClassID = 125;
    pub const nsQueryFrame_ClassID_nsTableWrapperFrame_id: root::nsQueryFrame_ClassID = 126;
    pub const nsQueryFrame_ClassID_nsTableRowFrame_id: root::nsQueryFrame_ClassID = 127;
    pub const nsQueryFrame_ClassID_nsTableRowGroupFrame_id: root::nsQueryFrame_ClassID = 128;
    pub const nsQueryFrame_ClassID_nsTextBoxFrame_id: root::nsQueryFrame_ClassID = 129;
    pub const nsQueryFrame_ClassID_nsTextControlFrame_id: root::nsQueryFrame_ClassID = 130;
    pub const nsQueryFrame_ClassID_nsTextFrame_id: root::nsQueryFrame_ClassID = 131;
    pub const nsQueryFrame_ClassID_nsTitleBarFrame_id: root::nsQueryFrame_ClassID = 132;
    pub const nsQueryFrame_ClassID_nsTreeBodyFrame_id: root::nsQueryFrame_ClassID = 133;
    pub const nsQueryFrame_ClassID_nsTreeColFrame_id: root::nsQueryFrame_ClassID = 134;
    pub const nsQueryFrame_ClassID_nsVideoFrame_id: root::nsQueryFrame_ClassID = 135;
    pub const nsQueryFrame_ClassID_nsXULLabelFrame_id: root::nsQueryFrame_ClassID = 136;
    pub const nsQueryFrame_ClassID_nsXULScrollFrame_id: root::nsQueryFrame_ClassID = 137;
    pub const nsQueryFrame_ClassID_ViewportFrame_id: root::nsQueryFrame_ClassID = 138;
    pub type nsQueryFrame_ClassID = u8;
    #[test]
    fn bindgen_test_layout_nsQueryFrame() {
        assert_eq!(
            ::std::mem::size_of::<nsQueryFrame>(),
            8usize,
            concat!("Size of: ", stringify!(nsQueryFrame))
        );
        assert_eq!(
            ::std::mem::align_of::<nsQueryFrame>(),
            8usize,
            concat!("Alignment of ", stringify!(nsQueryFrame))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIScrollbarMediator {
        pub _base: root::nsQueryFrame,
    }
    pub type nsIScrollbarMediator_Has_NS_DECL_QUERYFRAME_TARGET = root::nsIScrollbarMediator;
    pub const nsIScrollbarMediator_ScrollSnapMode_DEFAULT:
        root::nsIScrollbarMediator_ScrollSnapMode = 0;
    pub const nsIScrollbarMediator_ScrollSnapMode_DISABLE_SNAP:
        root::nsIScrollbarMediator_ScrollSnapMode = 1;
    pub const nsIScrollbarMediator_ScrollSnapMode_ENABLE_SNAP:
        root::nsIScrollbarMediator_ScrollSnapMode = 2;
    #[doc = " When set to ENABLE_SNAP, additional scrolling will be performed after the"]
    #[doc = " scroll operation to maintain the constraints set by CSS Scroll snapping."]
    #[doc = " The additional scrolling may include asynchronous smooth scrolls that"]
    #[doc = " continue to animate after the initial scroll position has been set."]
    #[doc = " In case of DEFAULT, it means ENABLE_SNAP for CSS scroll snap v1,"]
    #[doc = " DISABLE_SNAP for the old scroll snap."]
    pub type nsIScrollbarMediator_ScrollSnapMode = u32;
    extern "C" {
        #[link_name = "\u{1}_ZN20nsIScrollbarMediator9kFrameIIDE"]
        pub static nsIScrollbarMediator_kFrameIID: root::nsQueryFrame_FrameIID;
    }
    #[test]
    fn bindgen_test_layout_nsIScrollbarMediator() {
        assert_eq!(
            ::std::mem::size_of::<nsIScrollbarMediator>(),
            8usize,
            concat!("Size of: ", stringify!(nsIScrollbarMediator))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIScrollbarMediator>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIScrollbarMediator))
        );
    }
    #[doc = " Interface for frames that are scrollable. This interface exposes"]
    #[doc = " APIs for examining scroll state, observing changes to scroll state,"]
    #[doc = " and triggering scrolling."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIScrollableFrame {
        pub _base: root::nsIScrollbarMediator,
    }
    pub type nsIScrollableFrame_CSSIntPoint = root::mozilla::CSSIntPoint;
    pub type nsIScrollableFrame_ContainerLayerParameters = root::mozilla::ContainerLayerParameters;
    pub type nsIScrollableFrame_ScrollSnapInfo = root::mozilla::layers::ScrollSnapInfo;
    pub type nsIScrollableFrame_ScrollAnchorContainer =
        root::mozilla::layout::ScrollAnchorContainer;
    pub use self::super::root::mozilla::ScrollMode as nsIScrollableFrame_ScrollMode;
    pub type nsIScrollableFrame_Has_NS_DECL_QUERYFRAME_TARGET = root::nsIScrollableFrame;
    pub const nsIScrollableFrame_HORIZONTAL: root::nsIScrollableFrame__bindgen_ty_1 = 1;
    pub const nsIScrollableFrame_VERTICAL: root::nsIScrollableFrame__bindgen_ty_1 = 2;
    pub type nsIScrollableFrame__bindgen_ty_1 = u32;
    pub const nsIScrollableFrame_ScrollMomentum_NOT_MOMENTUM:
        root::nsIScrollableFrame_ScrollMomentum = 0;
    pub const nsIScrollableFrame_ScrollMomentum_SYNTHESIZED_MOMENTUM_EVENT:
        root::nsIScrollableFrame_ScrollMomentum = 1;
    #[doc = " Some platforms (OSX) may generate additional scrolling events even"]
    #[doc = " after the user has stopped scrolling, simulating a momentum scrolling"]
    #[doc = " effect resulting from fling gestures."]
    #[doc = " SYNTHESIZED_MOMENTUM_EVENT indicates that the scrolling is being requested"]
    #[doc = " by such a synthesized event and may be ignored if another scroll has"]
    #[doc = " been started since the last actual user input."]
    pub type nsIScrollableFrame_ScrollMomentum = u32;
    pub const nsIScrollableFrame_ScrollUnit_DEVICE_PIXELS: root::nsIScrollableFrame_ScrollUnit = 0;
    pub const nsIScrollableFrame_ScrollUnit_LINES: root::nsIScrollableFrame_ScrollUnit = 1;
    pub const nsIScrollableFrame_ScrollUnit_PAGES: root::nsIScrollableFrame_ScrollUnit = 2;
    pub const nsIScrollableFrame_ScrollUnit_WHOLE: root::nsIScrollableFrame_ScrollUnit = 3;
    #[doc = " When scrolling by a relative amount, we can choose various units."]
    pub type nsIScrollableFrame_ScrollUnit = u32;
    extern "C" {
        #[link_name = "\u{1}_ZN18nsIScrollableFrame9kFrameIIDE"]
        pub static nsIScrollableFrame_kFrameIID: root::nsQueryFrame_FrameIID;
    }
    #[test]
    fn bindgen_test_layout_nsIScrollableFrame() {
        assert_eq!(
            ::std::mem::size_of::<nsIScrollableFrame>(),
            8usize,
            concat!("Size of: ", stringify!(nsIScrollableFrame))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIScrollableFrame>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIScrollableFrame))
        );
    }
    pub type gfxRect = root::mozilla::gfx::RectDouble;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsBidi {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct gfxTextPerfMetrics {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsCSSFrameConstructor {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsTransitionManager {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsAnimationManager {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct gfxMissingFontRecorder {
        _unused: [u8; 0],
    }
    pub const kPresContext_DefaultVariableFont_ID: u8 = 0;
    pub const kPresContext_DefaultFixedFont_ID: u8 = 1;
    #[repr(C)]
    pub struct nsPresContext {
        pub _base: root::nsISupports,
        pub _base_1: u64,
        pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
        pub mType: root::nsPresContext_nsPresContextType,
        pub mPresShell: *mut root::mozilla::PresShell,
        pub mDocument: root::RefPtr<root::mozilla::dom::Document>,
        pub mDeviceContext: root::RefPtr<root::nsDeviceContext>,
        pub mEventManager: root::RefPtr<root::mozilla::EventStateManager>,
        pub mRefreshDriver: root::RefPtr<root::nsRefreshDriver>,
        pub mAnimationEventDispatcher: root::RefPtr<root::mozilla::AnimationEventDispatcher>,
        pub mEffectCompositor: root::RefPtr<root::mozilla::EffectCompositor>,
        pub mTransitionManager: root::mozilla::UniquePtr<root::nsTransitionManager>,
        pub mAnimationManager: root::mozilla::UniquePtr<root::nsAnimationManager>,
        pub mRestyleManager: root::mozilla::UniquePtr<root::mozilla::RestyleManager>,
        pub mCounterStyleManager: root::RefPtr<root::mozilla::CounterStyleManager>,
        pub mMedium: *mut root::nsAtom,
        pub mMediaEmulated: root::RefPtr<root::nsAtom>,
        pub mFontFeatureValuesLookup: root::RefPtr<root::gfxFontFeatureValueSet>,
        pub mInflationDisabledForShrinkWrap: bool,
        pub mSystemFontScale: f32,
        pub mTextZoom: f32,
        pub mEffectiveTextZoom: f32,
        pub mFullZoom: f32,
        pub mOverrideDPPX: f32,
        pub mLastFontInflationScreenSize: root::gfxSize,
        pub mCurAppUnitsPerDevPixel: i32,
        pub mAutoQualityMinFontSizePixelsPref: i32,
        pub mTheme: root::nsCOMPtr,
        pub mPrintSettings: root::nsCOMPtr,
        pub mBidiEngine: root::mozilla::UniquePtr<root::nsBidi>,
        pub mTransactions: [u64; 14usize],
        pub mTextPerf: root::mozilla::UniquePtr<root::gfxTextPerfMetrics>,
        pub mMissingFonts: root::mozilla::UniquePtr<root::gfxMissingFontRecorder>,
        pub mVisibleArea: root::nsRect,
        pub mPageSize: root::nsSize,
        pub mPageScale: f32,
        pub mPPScale: f32,
        pub mViewportScrollOverrideElement: *mut root::mozilla::dom::Element,
        pub mViewportScrollStyles: root::nsPresContext_ScrollStyles,
        pub mExistThrottledUpdates: bool,
        pub mImageAnimationMode: u16,
        pub mImageAnimationModePref: u16,
        pub mInterruptChecksToSkip: u32,
        pub mNextFrameRateMultiplier: u32,
        pub mElementsRestyled: u64,
        pub mFramesConstructed: u64,
        pub mFramesReflowed: u64,
        pub mReflowStartTime: root::mozilla::TimeStamp,
        pub mFirstContentfulPaintTransactionId: [u64; 2usize],
        pub mFirstNonBlankPaintTime: root::mozilla::TimeStamp,
        pub mFirstClickTime: root::mozilla::TimeStamp,
        pub mFirstKeyTime: root::mozilla::TimeStamp,
        pub mFirstMouseMoveTime: root::mozilla::TimeStamp,
        pub mFirstScrollTime: root::mozilla::TimeStamp,
        pub mInteractionTimeEnabled: bool,
        pub mLastStyleUpdateForAllAnimations: root::mozilla::TimeStamp,
        pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 5usize], u8>,
        pub mPendingMediaFeatureValuesChange: [u32; 4usize],
    }
    pub type nsPresContext_Encoding = root::mozilla::Encoding;
    pub type nsPresContext_NotNull<T> = root::mozilla::NotNull<T>;
    pub type nsPresContext_ScrollStyles = root::mozilla::ScrollStyles;
    pub type nsPresContext_StaticPresData = root::mozilla::StaticPresData;
    pub type nsPresContext_TransactionId = root::mozilla::layers::TransactionId;
    pub type nsPresContext_HasThreadSafeRefCnt = root::mozilla::FalseType;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsPresContext_cycleCollection {
        pub _base: root::nsXPCOMCycleCollectionParticipant,
    }
    #[test]
    fn bindgen_test_layout_nsPresContext_cycleCollection() {
        assert_eq!(
            ::std::mem::size_of::<nsPresContext_cycleCollection>(),
            16usize,
            concat!("Size of: ", stringify!(nsPresContext_cycleCollection))
        );
        assert_eq!(
            ::std::mem::align_of::<nsPresContext_cycleCollection>(),
            8usize,
            concat!("Alignment of ", stringify!(nsPresContext_cycleCollection))
        );
    }
    pub const nsPresContext_nsPresContextType_eContext_Galley:
        root::nsPresContext_nsPresContextType = 0;
    pub const nsPresContext_nsPresContextType_eContext_PrintPreview:
        root::nsPresContext_nsPresContextType = 1;
    pub const nsPresContext_nsPresContextType_eContext_Print:
        root::nsPresContext_nsPresContextType = 2;
    pub const nsPresContext_nsPresContextType_eContext_PageLayout:
        root::nsPresContext_nsPresContextType = 3;
    pub type nsPresContext_nsPresContextType = u32;
    pub const nsPresContext_InteractionType_ClickInteraction: root::nsPresContext_InteractionType =
        0;
    pub const nsPresContext_InteractionType_KeyInteraction: root::nsPresContext_InteractionType = 1;
    pub const nsPresContext_InteractionType_MouseMoveInteraction:
        root::nsPresContext_InteractionType = 2;
    pub const nsPresContext_InteractionType_ScrollInteraction: root::nsPresContext_InteractionType =
        3;
    pub type nsPresContext_InteractionType = u32;
    #[doc = " A class that can be used to temporarily disable reflow interruption."]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsPresContext_InterruptPreventer {
        pub mCtx: *mut root::nsPresContext,
        pub mInterruptsEnabled: bool,
        pub mHasPendingInterrupt: bool,
    }
    #[test]
    fn bindgen_test_layout_nsPresContext_InterruptPreventer() {
        assert_eq!(
            ::std::mem::size_of::<nsPresContext_InterruptPreventer>(),
            16usize,
            concat!("Size of: ", stringify!(nsPresContext_InterruptPreventer))
        );
        assert_eq!(
            ::std::mem::align_of::<nsPresContext_InterruptPreventer>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(nsPresContext_InterruptPreventer)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext_InterruptPreventer>())).mCtx as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext_InterruptPreventer),
                "::",
                stringify!(mCtx)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext_InterruptPreventer>())).mInterruptsEnabled
                    as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext_InterruptPreventer),
                "::",
                stringify!(mInterruptsEnabled)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext_InterruptPreventer>())).mHasPendingInterrupt
                    as *const _ as usize
            },
            9usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext_InterruptPreventer),
                "::",
                stringify!(mHasPendingInterrupt)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsPresContext_TransactionInvalidations {
        pub mTransactionId: root::nsPresContext_TransactionId,
        pub mInvalidations: root::nsTArray<root::nsRect>,
        pub mIsWaitingForPreviousTransaction: bool,
    }
    #[test]
    fn bindgen_test_layout_nsPresContext_TransactionInvalidations() {
        assert_eq!(
            ::std::mem::size_of::<nsPresContext_TransactionInvalidations>(),
            24usize,
            concat!(
                "Size of: ",
                stringify!(nsPresContext_TransactionInvalidations)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<nsPresContext_TransactionInvalidations>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(nsPresContext_TransactionInvalidations)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext_TransactionInvalidations>())).mTransactionId
                    as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext_TransactionInvalidations),
                "::",
                stringify!(mTransactionId)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext_TransactionInvalidations>())).mInvalidations
                    as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext_TransactionInvalidations),
                "::",
                stringify!(mInvalidations)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext_TransactionInvalidations>()))
                    .mIsWaitingForPreviousTransaction as *const _ as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext_TransactionInvalidations),
                "::",
                stringify!(mIsWaitingForPreviousTransaction)
            )
        );
    }
    extern "C" {
        #[link_name = "\u{1}_ZN13nsPresContext21_cycleCollectorGlobalE"]
        pub static mut nsPresContext__cycleCollectorGlobal: root::nsPresContext_cycleCollection;
    }
    #[test]
    fn bindgen_test_layout_nsPresContext() {
        assert_eq!(
            ::std::mem::size_of::<nsPresContext>(),
            592usize,
            concat!("Size of: ", stringify!(nsPresContext))
        );
        assert_eq!(
            ::std::mem::align_of::<nsPresContext>(),
            8usize,
            concat!("Alignment of ", stringify!(nsPresContext))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mRefCnt as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mRefCnt)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mType as *const _ as usize },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mType)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mPresShell as *const _ as usize },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mPresShell)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mDocument as *const _ as usize },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mDocument)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mDeviceContext as *const _ as usize
            },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mDeviceContext)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mEventManager as *const _ as usize },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mEventManager)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mRefreshDriver as *const _ as usize
            },
            64usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mRefreshDriver)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mAnimationEventDispatcher as *const _
                    as usize
            },
            72usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mAnimationEventDispatcher)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mEffectCompositor as *const _ as usize
            },
            80usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mEffectCompositor)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mTransitionManager as *const _ as usize
            },
            88usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mTransitionManager)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mAnimationManager as *const _ as usize
            },
            96usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mAnimationManager)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mRestyleManager as *const _ as usize
            },
            104usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mRestyleManager)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mCounterStyleManager as *const _ as usize
            },
            112usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mCounterStyleManager)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mMedium as *const _ as usize },
            120usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mMedium)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mMediaEmulated as *const _ as usize
            },
            128usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mMediaEmulated)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mFontFeatureValuesLookup as *const _
                    as usize
            },
            136usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mFontFeatureValuesLookup)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mInflationDisabledForShrinkWrap
                    as *const _ as usize
            },
            144usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mInflationDisabledForShrinkWrap)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mSystemFontScale as *const _ as usize
            },
            148usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mSystemFontScale)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mTextZoom as *const _ as usize },
            152usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mTextZoom)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mEffectiveTextZoom as *const _ as usize
            },
            156usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mEffectiveTextZoom)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mFullZoom as *const _ as usize },
            160usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mFullZoom)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mOverrideDPPX as *const _ as usize },
            164usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mOverrideDPPX)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mLastFontInflationScreenSize as *const _
                    as usize
            },
            168usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mLastFontInflationScreenSize)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mCurAppUnitsPerDevPixel as *const _
                    as usize
            },
            184usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mCurAppUnitsPerDevPixel)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mAutoQualityMinFontSizePixelsPref
                    as *const _ as usize
            },
            188usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mAutoQualityMinFontSizePixelsPref)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mTheme as *const _ as usize },
            192usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mTheme)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mPrintSettings as *const _ as usize
            },
            200usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mPrintSettings)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mBidiEngine as *const _ as usize },
            208usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mBidiEngine)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mTransactions as *const _ as usize },
            216usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mTransactions)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mTextPerf as *const _ as usize },
            328usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mTextPerf)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mMissingFonts as *const _ as usize },
            336usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mMissingFonts)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mVisibleArea as *const _ as usize },
            344usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mVisibleArea)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mPageSize as *const _ as usize },
            360usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mPageSize)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mPageScale as *const _ as usize },
            368usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mPageScale)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mPPScale as *const _ as usize },
            372usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mPPScale)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mViewportScrollOverrideElement as *const _
                    as usize
            },
            376usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mViewportScrollOverrideElement)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mViewportScrollStyles as *const _ as usize
            },
            384usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mViewportScrollStyles)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mExistThrottledUpdates as *const _
                    as usize
            },
            448usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mExistThrottledUpdates)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mImageAnimationMode as *const _ as usize
            },
            450usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mImageAnimationMode)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mImageAnimationModePref as *const _
                    as usize
            },
            452usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mImageAnimationModePref)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mInterruptChecksToSkip as *const _
                    as usize
            },
            456usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mInterruptChecksToSkip)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mNextFrameRateMultiplier as *const _
                    as usize
            },
            460usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mNextFrameRateMultiplier)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mElementsRestyled as *const _ as usize
            },
            464usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mElementsRestyled)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mFramesConstructed as *const _ as usize
            },
            472usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mFramesConstructed)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mFramesReflowed as *const _ as usize
            },
            480usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mFramesReflowed)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mReflowStartTime as *const _ as usize
            },
            488usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mReflowStartTime)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mFirstContentfulPaintTransactionId
                    as *const _ as usize
            },
            496usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mFirstContentfulPaintTransactionId)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mFirstNonBlankPaintTime as *const _
                    as usize
            },
            512usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mFirstNonBlankPaintTime)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mFirstClickTime as *const _ as usize
            },
            520usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mFirstClickTime)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsPresContext>())).mFirstKeyTime as *const _ as usize },
            528usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mFirstKeyTime)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mFirstMouseMoveTime as *const _ as usize
            },
            536usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mFirstMouseMoveTime)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mFirstScrollTime as *const _ as usize
            },
            544usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mFirstScrollTime)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mInteractionTimeEnabled as *const _
                    as usize
            },
            552usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mInteractionTimeEnabled)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mLastStyleUpdateForAllAnimations
                    as *const _ as usize
            },
            560usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mLastStyleUpdateForAllAnimations)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsPresContext>())).mPendingMediaFeatureValuesChange
                    as *const _ as usize
            },
            576usize,
            concat!(
                "Offset of field: ",
                stringify!(nsPresContext),
                "::",
                stringify!(mPendingMediaFeatureValuesChange)
            )
        );
    }
    impl nsPresContext {
        #[inline]
        pub fn mHasPendingInterrupt(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mHasPendingInterrupt(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(0usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mPendingInterruptFromTest(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mPendingInterruptFromTest(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(1usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mInterruptsEnabled(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mInterruptsEnabled(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(2usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mSendAfterPaintToContent(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mSendAfterPaintToContent(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(3usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mDrawImageBackground(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mDrawImageBackground(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(4usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mDrawColorBackground(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mDrawColorBackground(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(5usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mNeverAnimate(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mNeverAnimate(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(6usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mPaginated(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mPaginated(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(7usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mCanPaginatedScroll(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mCanPaginatedScroll(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(8usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mDoScaledTwips(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(9usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mDoScaledTwips(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(9usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mIsRootPaginatedDocument(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(10usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mIsRootPaginatedDocument(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(10usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mPrefBidiDirection(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(11usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mPrefBidiDirection(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(11usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mPrefScrollbarSide(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(12usize, 2u8) as u32) }
        }
        #[inline]
        pub fn set_mPrefScrollbarSide(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(12usize, 2u8, val as u64)
            }
        }
        #[inline]
        pub fn mPendingSysColorChanged(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(14usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mPendingSysColorChanged(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(14usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mPendingThemeChanged(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(15usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mPendingThemeChanged(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(15usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mPendingUIResolutionChanged(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(16usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mPendingUIResolutionChanged(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(16usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mPrefChangePendingNeedsReflow(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(17usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mPrefChangePendingNeedsReflow(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(17usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mPostedPrefChangedRunnable(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(18usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mPostedPrefChangedRunnable(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(18usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mIsEmulatingMedia(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(19usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mIsEmulatingMedia(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(19usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mIsGlyph(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(20usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mIsGlyph(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(20usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mUsesRootEMUnits(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(21usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mUsesRootEMUnits(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(21usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mUsesExChUnits(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(22usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mUsesExChUnits(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(22usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mCounterStylesDirty(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(23usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mCounterStylesDirty(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(23usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mFontFeatureValuesDirty(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(24usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mFontFeatureValuesDirty(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(24usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mSuppressResizeReflow(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(25usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mSuppressResizeReflow(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(25usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mIsVisual(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(26usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mIsVisual(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(26usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mPaintFlashing(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(27usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mPaintFlashing(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(27usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mPaintFlashingInitialized(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(28usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mPaintFlashingInitialized(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(28usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mHasWarnedAboutPositionedTableParts(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(29usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mHasWarnedAboutPositionedTableParts(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(29usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mHasWarnedAboutTooLargeDashedOrDottedRadius(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(30usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mHasWarnedAboutTooLargeDashedOrDottedRadius(
            &mut self,
            val: ::std::os::raw::c_uint,
        ) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(30usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mQuirkSheetAdded(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(31usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mQuirkSheetAdded(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(31usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mHadNonBlankPaint(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(32usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mHadNonBlankPaint(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(32usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mHadContentfulPaint(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(33usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mHadContentfulPaint(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(33usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mHadContentfulPaintComposite(&self) -> ::std::os::raw::c_uint {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(34usize, 1u8) as u32) }
        }
        #[inline]
        pub fn set_mHadContentfulPaintComposite(&mut self, val: ::std::os::raw::c_uint) {
            unsafe {
                let val: u32 = ::std::mem::transmute(val);
                self._bitfield_1.set(34usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn new_bitfield_1(
            mHasPendingInterrupt: ::std::os::raw::c_uint,
            mPendingInterruptFromTest: ::std::os::raw::c_uint,
            mInterruptsEnabled: ::std::os::raw::c_uint,
            mSendAfterPaintToContent: ::std::os::raw::c_uint,
            mDrawImageBackground: ::std::os::raw::c_uint,
            mDrawColorBackground: ::std::os::raw::c_uint,
            mNeverAnimate: ::std::os::raw::c_uint,
            mPaginated: ::std::os::raw::c_uint,
            mCanPaginatedScroll: ::std::os::raw::c_uint,
            mDoScaledTwips: ::std::os::raw::c_uint,
            mIsRootPaginatedDocument: ::std::os::raw::c_uint,
            mPrefBidiDirection: ::std::os::raw::c_uint,
            mPrefScrollbarSide: ::std::os::raw::c_uint,
            mPendingSysColorChanged: ::std::os::raw::c_uint,
            mPendingThemeChanged: ::std::os::raw::c_uint,
            mPendingUIResolutionChanged: ::std::os::raw::c_uint,
            mPrefChangePendingNeedsReflow: ::std::os::raw::c_uint,
            mPostedPrefChangedRunnable: ::std::os::raw::c_uint,
            mIsEmulatingMedia: ::std::os::raw::c_uint,
            mIsGlyph: ::std::os::raw::c_uint,
            mUsesRootEMUnits: ::std::os::raw::c_uint,
            mUsesExChUnits: ::std::os::raw::c_uint,
            mCounterStylesDirty: ::std::os::raw::c_uint,
            mFontFeatureValuesDirty: ::std::os::raw::c_uint,
            mSuppressResizeReflow: ::std::os::raw::c_uint,
            mIsVisual: ::std::os::raw::c_uint,
            mPaintFlashing: ::std::os::raw::c_uint,
            mPaintFlashingInitialized: ::std::os::raw::c_uint,
            mHasWarnedAboutPositionedTableParts: ::std::os::raw::c_uint,
            mHasWarnedAboutTooLargeDashedOrDottedRadius: ::std::os::raw::c_uint,
            mQuirkSheetAdded: ::std::os::raw::c_uint,
            mHadNonBlankPaint: ::std::os::raw::c_uint,
            mHadContentfulPaint: ::std::os::raw::c_uint,
            mHadContentfulPaintComposite: ::std::os::raw::c_uint,
        ) -> root::__BindgenBitfieldUnit<[u8; 5usize], u8> {
            let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 5usize], u8> =
                Default::default();
            __bindgen_bitfield_unit.set(0usize, 1u8, {
                let mHasPendingInterrupt: u32 =
                    unsafe { ::std::mem::transmute(mHasPendingInterrupt) };
                mHasPendingInterrupt as u64
            });
            __bindgen_bitfield_unit.set(1usize, 1u8, {
                let mPendingInterruptFromTest: u32 =
                    unsafe { ::std::mem::transmute(mPendingInterruptFromTest) };
                mPendingInterruptFromTest as u64
            });
            __bindgen_bitfield_unit.set(2usize, 1u8, {
                let mInterruptsEnabled: u32 = unsafe { ::std::mem::transmute(mInterruptsEnabled) };
                mInterruptsEnabled as u64
            });
            __bindgen_bitfield_unit.set(3usize, 1u8, {
                let mSendAfterPaintToContent: u32 =
                    unsafe { ::std::mem::transmute(mSendAfterPaintToContent) };
                mSendAfterPaintToContent as u64
            });
            __bindgen_bitfield_unit.set(4usize, 1u8, {
                let mDrawImageBackground: u32 =
                    unsafe { ::std::mem::transmute(mDrawImageBackground) };
                mDrawImageBackground as u64
            });
            __bindgen_bitfield_unit.set(5usize, 1u8, {
                let mDrawColorBackground: u32 =
                    unsafe { ::std::mem::transmute(mDrawColorBackground) };
                mDrawColorBackground as u64
            });
            __bindgen_bitfield_unit.set(6usize, 1u8, {
                let mNeverAnimate: u32 = unsafe { ::std::mem::transmute(mNeverAnimate) };
                mNeverAnimate as u64
            });
            __bindgen_bitfield_unit.set(7usize, 1u8, {
                let mPaginated: u32 = unsafe { ::std::mem::transmute(mPaginated) };
                mPaginated as u64
            });
            __bindgen_bitfield_unit.set(8usize, 1u8, {
                let mCanPaginatedScroll: u32 =
                    unsafe { ::std::mem::transmute(mCanPaginatedScroll) };
                mCanPaginatedScroll as u64
            });
            __bindgen_bitfield_unit.set(9usize, 1u8, {
                let mDoScaledTwips: u32 = unsafe { ::std::mem::transmute(mDoScaledTwips) };
                mDoScaledTwips as u64
            });
            __bindgen_bitfield_unit.set(10usize, 1u8, {
                let mIsRootPaginatedDocument: u32 =
                    unsafe { ::std::mem::transmute(mIsRootPaginatedDocument) };
                mIsRootPaginatedDocument as u64
            });
            __bindgen_bitfield_unit.set(11usize, 1u8, {
                let mPrefBidiDirection: u32 = unsafe { ::std::mem::transmute(mPrefBidiDirection) };
                mPrefBidiDirection as u64
            });
            __bindgen_bitfield_unit.set(12usize, 2u8, {
                let mPrefScrollbarSide: u32 = unsafe { ::std::mem::transmute(mPrefScrollbarSide) };
                mPrefScrollbarSide as u64
            });
            __bindgen_bitfield_unit.set(14usize, 1u8, {
                let mPendingSysColorChanged: u32 =
                    unsafe { ::std::mem::transmute(mPendingSysColorChanged) };
                mPendingSysColorChanged as u64
            });
            __bindgen_bitfield_unit.set(15usize, 1u8, {
                let mPendingThemeChanged: u32 =
                    unsafe { ::std::mem::transmute(mPendingThemeChanged) };
                mPendingThemeChanged as u64
            });
            __bindgen_bitfield_unit.set(16usize, 1u8, {
                let mPendingUIResolutionChanged: u32 =
                    unsafe { ::std::mem::transmute(mPendingUIResolutionChanged) };
                mPendingUIResolutionChanged as u64
            });
            __bindgen_bitfield_unit.set(17usize, 1u8, {
                let mPrefChangePendingNeedsReflow: u32 =
                    unsafe { ::std::mem::transmute(mPrefChangePendingNeedsReflow) };
                mPrefChangePendingNeedsReflow as u64
            });
            __bindgen_bitfield_unit.set(18usize, 1u8, {
                let mPostedPrefChangedRunnable: u32 =
                    unsafe { ::std::mem::transmute(mPostedPrefChangedRunnable) };
                mPostedPrefChangedRunnable as u64
            });
            __bindgen_bitfield_unit.set(19usize, 1u8, {
                let mIsEmulatingMedia: u32 = unsafe { ::std::mem::transmute(mIsEmulatingMedia) };
                mIsEmulatingMedia as u64
            });
            __bindgen_bitfield_unit.set(20usize, 1u8, {
                let mIsGlyph: u32 = unsafe { ::std::mem::transmute(mIsGlyph) };
                mIsGlyph as u64
            });
            __bindgen_bitfield_unit.set(21usize, 1u8, {
                let mUsesRootEMUnits: u32 = unsafe { ::std::mem::transmute(mUsesRootEMUnits) };
                mUsesRootEMUnits as u64
            });
            __bindgen_bitfield_unit.set(22usize, 1u8, {
                let mUsesExChUnits: u32 = unsafe { ::std::mem::transmute(mUsesExChUnits) };
                mUsesExChUnits as u64
            });
            __bindgen_bitfield_unit.set(23usize, 1u8, {
                let mCounterStylesDirty: u32 =
                    unsafe { ::std::mem::transmute(mCounterStylesDirty) };
                mCounterStylesDirty as u64
            });
            __bindgen_bitfield_unit.set(24usize, 1u8, {
                let mFontFeatureValuesDirty: u32 =
                    unsafe { ::std::mem::transmute(mFontFeatureValuesDirty) };
                mFontFeatureValuesDirty as u64
            });
            __bindgen_bitfield_unit.set(25usize, 1u8, {
                let mSuppressResizeReflow: u32 =
                    unsafe { ::std::mem::transmute(mSuppressResizeReflow) };
                mSuppressResizeReflow as u64
            });
            __bindgen_bitfield_unit.set(26usize, 1u8, {
                let mIsVisual: u32 = unsafe { ::std::mem::transmute(mIsVisual) };
                mIsVisual as u64
            });
            __bindgen_bitfield_unit.set(27usize, 1u8, {
                let mPaintFlashing: u32 = unsafe { ::std::mem::transmute(mPaintFlashing) };
                mPaintFlashing as u64
            });
            __bindgen_bitfield_unit.set(28usize, 1u8, {
                let mPaintFlashingInitialized: u32 =
                    unsafe { ::std::mem::transmute(mPaintFlashingInitialized) };
                mPaintFlashingInitialized as u64
            });
            __bindgen_bitfield_unit.set(29usize, 1u8, {
                let mHasWarnedAboutPositionedTableParts: u32 =
                    unsafe { ::std::mem::transmute(mHasWarnedAboutPositionedTableParts) };
                mHasWarnedAboutPositionedTableParts as u64
            });
            __bindgen_bitfield_unit.set(30usize, 1u8, {
                let mHasWarnedAboutTooLargeDashedOrDottedRadius: u32 =
                    unsafe { ::std::mem::transmute(mHasWarnedAboutTooLargeDashedOrDottedRadius) };
                mHasWarnedAboutTooLargeDashedOrDottedRadius as u64
            });
            __bindgen_bitfield_unit.set(31usize, 1u8, {
                let mQuirkSheetAdded: u32 = unsafe { ::std::mem::transmute(mQuirkSheetAdded) };
                mQuirkSheetAdded as u64
            });
            __bindgen_bitfield_unit.set(32usize, 1u8, {
                let mHadNonBlankPaint: u32 = unsafe { ::std::mem::transmute(mHadNonBlankPaint) };
                mHadNonBlankPaint as u64
            });
            __bindgen_bitfield_unit.set(33usize, 1u8, {
                let mHadContentfulPaint: u32 =
                    unsafe { ::std::mem::transmute(mHadContentfulPaint) };
                mHadContentfulPaint as u64
            });
            __bindgen_bitfield_unit.set(34usize, 1u8, {
                let mHadContentfulPaintComposite: u32 =
                    unsafe { ::std::mem::transmute(mHadContentfulPaintComposite) };
                mHadContentfulPaintComposite as u64
            });
            __bindgen_bitfield_unit
        }
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIDOMEventListener {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIDOMEventListener_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIDOMEventListener() {
        assert_eq!(
            ::std::mem::size_of::<nsIDOMEventListener>(),
            8usize,
            concat!("Size of: ", stringify!(nsIDOMEventListener))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIDOMEventListener>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIDOMEventListener))
        );
    }
    #[repr(C)]
    pub struct ZoomConstraintsClient {
        pub _base: root::nsIDOMEventListener,
        pub _base_1: root::nsIObserver,
        pub mRefCnt: root::nsAutoRefCnt,
        pub mDocument: root::RefPtr<root::mozilla::dom::Document>,
        pub mPresShell: *mut root::mozilla::PresShell,
        pub mEventTarget: root::nsCOMPtr,
        pub mGuid: [u64; 4usize],
    }
    pub type ZoomConstraintsClient_HasThreadSafeRefCnt = root::mozilla::FalseType;
    #[test]
    fn bindgen_test_layout_ZoomConstraintsClient() {
        assert_eq!(
            ::std::mem::size_of::<ZoomConstraintsClient>(),
            80usize,
            concat!("Size of: ", stringify!(ZoomConstraintsClient))
        );
        assert_eq!(
            ::std::mem::align_of::<ZoomConstraintsClient>(),
            8usize,
            concat!("Alignment of ", stringify!(ZoomConstraintsClient))
        );
    }
    pub const nsCSSAnonBoxes_NonInheriting_oofPlaceholder: root::nsCSSAnonBoxes_NonInheriting = 0;
    pub const nsCSSAnonBoxes_NonInheriting_horizontalFramesetBorder:
        root::nsCSSAnonBoxes_NonInheriting = 1;
    pub const nsCSSAnonBoxes_NonInheriting_verticalFramesetBorder:
        root::nsCSSAnonBoxes_NonInheriting = 2;
    pub const nsCSSAnonBoxes_NonInheriting_framesetBlank: root::nsCSSAnonBoxes_NonInheriting = 3;
    pub const nsCSSAnonBoxes_NonInheriting_tableColGroup: root::nsCSSAnonBoxes_NonInheriting = 4;
    pub const nsCSSAnonBoxes_NonInheriting_tableCol: root::nsCSSAnonBoxes_NonInheriting = 5;
    pub const nsCSSAnonBoxes_NonInheriting_pageBreak: root::nsCSSAnonBoxes_NonInheriting = 6;
    pub const nsCSSAnonBoxes_NonInheriting_columnSpanWrapper: root::nsCSSAnonBoxes_NonInheriting =
        7;
    pub const nsCSSAnonBoxes_NonInheriting__Count: root::nsCSSAnonBoxes_NonInheriting = 8;
    pub type nsCSSAnonBoxes_NonInheriting = u8;
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsDOMNavigationTiming {
        pub _base: root::mozilla::RelativeTimeline,
        pub mRefCnt: root::nsAutoRefCnt,
        pub mDocShell: u64,
        pub mUnloadedURI: root::nsCOMPtr,
        pub mLoadedURI: root::nsCOMPtr,
        pub mTTITimer: root::nsCOMPtr,
        pub mNavigationType: root::nsDOMNavigationTiming_Type,
        pub mNavigationStartHighRes: root::DOMHighResTimeStamp,
        pub mNavigationStart: root::mozilla::TimeStamp,
        pub mNonBlankPaint: root::mozilla::TimeStamp,
        pub mContentfulPaint: root::mozilla::TimeStamp,
        pub mDOMContentFlushed: root::mozilla::TimeStamp,
        pub mBeforeUnloadStart: root::mozilla::TimeStamp,
        pub mUnloadStart: root::mozilla::TimeStamp,
        pub mUnloadEnd: root::mozilla::TimeStamp,
        pub mLoadEventStart: root::mozilla::TimeStamp,
        pub mLoadEventEnd: root::mozilla::TimeStamp,
        pub mDOMLoading: root::mozilla::TimeStamp,
        pub mDOMInteractive: root::mozilla::TimeStamp,
        pub mDOMContentLoadedEventStart: root::mozilla::TimeStamp,
        pub mDOMContentLoadedEventEnd: root::mozilla::TimeStamp,
        pub mDOMComplete: root::mozilla::TimeStamp,
        pub mTTFI: root::mozilla::TimeStamp,
        pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 1usize], u8>,
        pub __bindgen_padding_0: [u8; 7usize],
    }
    pub const nsDOMNavigationTiming_Type_TYPE_NAVIGATE: root::nsDOMNavigationTiming_Type = 0;
    pub const nsDOMNavigationTiming_Type_TYPE_RELOAD: root::nsDOMNavigationTiming_Type = 1;
    pub const nsDOMNavigationTiming_Type_TYPE_BACK_FORWARD: root::nsDOMNavigationTiming_Type = 2;
    pub const nsDOMNavigationTiming_Type_TYPE_RESERVED: root::nsDOMNavigationTiming_Type = 255;
    pub type nsDOMNavigationTiming_Type = u32;
    pub type nsDOMNavigationTiming_HasThreadSafeRefCnt = root::mozilla::FalseType;
    pub const nsDOMNavigationTiming_DocShellState_eActive:
        root::nsDOMNavigationTiming_DocShellState = 0;
    pub const nsDOMNavigationTiming_DocShellState_eInactive:
        root::nsDOMNavigationTiming_DocShellState = 1;
    pub type nsDOMNavigationTiming_DocShellState = u8;
    #[test]
    fn bindgen_test_layout_nsDOMNavigationTiming() {
        assert_eq!(
            ::std::mem::size_of::<nsDOMNavigationTiming>(),
            192usize,
            concat!("Size of: ", stringify!(nsDOMNavigationTiming))
        );
        assert_eq!(
            ::std::mem::align_of::<nsDOMNavigationTiming>(),
            8usize,
            concat!("Alignment of ", stringify!(nsDOMNavigationTiming))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mRefCnt as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mRefCnt)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mDocShell as *const _ as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mDocShell)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mUnloadedURI as *const _ as usize
            },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mUnloadedURI)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mLoadedURI as *const _ as usize
            },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mLoadedURI)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mTTITimer as *const _ as usize
            },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mTTITimer)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mNavigationType as *const _
                    as usize
            },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mNavigationType)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mNavigationStartHighRes
                    as *const _ as usize
            },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mNavigationStartHighRes)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mNavigationStart as *const _
                    as usize
            },
            64usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mNavigationStart)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mNonBlankPaint as *const _
                    as usize
            },
            72usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mNonBlankPaint)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mContentfulPaint as *const _
                    as usize
            },
            80usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mContentfulPaint)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mDOMContentFlushed as *const _
                    as usize
            },
            88usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mDOMContentFlushed)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mBeforeUnloadStart as *const _
                    as usize
            },
            96usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mBeforeUnloadStart)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mUnloadStart as *const _ as usize
            },
            104usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mUnloadStart)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mUnloadEnd as *const _ as usize
            },
            112usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mUnloadEnd)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mLoadEventStart as *const _
                    as usize
            },
            120usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mLoadEventStart)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mLoadEventEnd as *const _ as usize
            },
            128usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mLoadEventEnd)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mDOMLoading as *const _ as usize
            },
            136usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mDOMLoading)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mDOMInteractive as *const _
                    as usize
            },
            144usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mDOMInteractive)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mDOMContentLoadedEventStart
                    as *const _ as usize
            },
            152usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mDOMContentLoadedEventStart)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mDOMContentLoadedEventEnd
                    as *const _ as usize
            },
            160usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mDOMContentLoadedEventEnd)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mDOMComplete as *const _ as usize
            },
            168usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mDOMComplete)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsDOMNavigationTiming>())).mTTFI as *const _ as usize },
            176usize,
            concat!(
                "Offset of field: ",
                stringify!(nsDOMNavigationTiming),
                "::",
                stringify!(mTTFI)
            )
        );
    }
    impl nsDOMNavigationTiming {
        #[inline]
        pub fn mDocShellHasBeenActiveSinceNavigationStart(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mDocShellHasBeenActiveSinceNavigationStart(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(0usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn new_bitfield_1(
            mDocShellHasBeenActiveSinceNavigationStart: bool,
        ) -> root::__BindgenBitfieldUnit<[u8; 1usize], u8> {
            let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 1usize], u8> =
                Default::default();
            __bindgen_bitfield_unit.set(0usize, 1u8, {
                let mDocShellHasBeenActiveSinceNavigationStart: u8 =
                    unsafe { ::std::mem::transmute(mDocShellHasBeenActiveSinceNavigationStart) };
                mDocShellHasBeenActiveSinceNavigationStart as u64
            });
            __bindgen_bitfield_unit
        }
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsContainerFrame {
        _unused: [u8; 0],
    }
    #[doc = " A class for managing a list of frames."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsFrameList {
        pub mFirstChild: *mut root::nsIFrame,
        pub mLastChild: *mut root::nsIFrame,
    }
    #[doc = " A class representing a slice of a frame list."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsFrameList_Slice {
        pub mStart: *mut root::nsIFrame,
        pub mEnd: *const root::nsIFrame,
    }
    #[test]
    fn bindgen_test_layout_nsFrameList_Slice() {
        assert_eq!(
            ::std::mem::size_of::<nsFrameList_Slice>(),
            16usize,
            concat!("Size of: ", stringify!(nsFrameList_Slice))
        );
        assert_eq!(
            ::std::mem::align_of::<nsFrameList_Slice>(),
            8usize,
            concat!("Alignment of ", stringify!(nsFrameList_Slice))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFrameList_Slice>())).mStart as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFrameList_Slice),
                "::",
                stringify!(mStart)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFrameList_Slice>())).mEnd as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFrameList_Slice),
                "::",
                stringify!(mEnd)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsFrameList_Enumerator {
        pub mFrame: *mut root::nsIFrame,
        pub mEnd: *const root::nsIFrame,
    }
    #[test]
    fn bindgen_test_layout_nsFrameList_Enumerator() {
        assert_eq!(
            ::std::mem::size_of::<nsFrameList_Enumerator>(),
            16usize,
            concat!("Size of: ", stringify!(nsFrameList_Enumerator))
        );
        assert_eq!(
            ::std::mem::align_of::<nsFrameList_Enumerator>(),
            8usize,
            concat!("Alignment of ", stringify!(nsFrameList_Enumerator))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsFrameList_Enumerator>())).mFrame as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFrameList_Enumerator),
                "::",
                stringify!(mFrame)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFrameList_Enumerator>())).mEnd as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFrameList_Enumerator),
                "::",
                stringify!(mEnd)
            )
        );
    }
    #[doc = " A class that can be used to enumerate links between frames.  When created"]
    #[doc = " from an nsFrameList, it points to the \"link\" immediately before the first"]
    #[doc = " frame.  It can then be advanced until it points to the \"link\" immediately"]
    #[doc = " after the last frame.  At any position, PrevFrame() and NextFrame() are"]
    #[doc = " the frames before and after the given link.  This means PrevFrame() is"]
    #[doc = " null when the enumerator is at the beginning of the list and NextFrame()"]
    #[doc = " is null when it\'s AtEnd()."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsFrameList_FrameLinkEnumerator {
        pub _base: root::nsFrameList_Enumerator,
        pub mPrev: *mut root::nsIFrame,
    }
    #[test]
    fn bindgen_test_layout_nsFrameList_FrameLinkEnumerator() {
        assert_eq!(
            ::std::mem::size_of::<nsFrameList_FrameLinkEnumerator>(),
            24usize,
            concat!("Size of: ", stringify!(nsFrameList_FrameLinkEnumerator))
        );
        assert_eq!(
            ::std::mem::align_of::<nsFrameList_FrameLinkEnumerator>(),
            8usize,
            concat!("Alignment of ", stringify!(nsFrameList_FrameLinkEnumerator))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsFrameList_FrameLinkEnumerator>())).mPrev as *const _
                    as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFrameList_FrameLinkEnumerator),
                "::",
                stringify!(mPrev)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsFrameList_Iterator {
        pub mList: *const root::nsFrameList,
        pub mCurrent: *mut root::nsIFrame,
    }
    #[test]
    fn bindgen_test_layout_nsFrameList_Iterator() {
        assert_eq!(
            ::std::mem::size_of::<nsFrameList_Iterator>(),
            16usize,
            concat!("Size of: ", stringify!(nsFrameList_Iterator))
        );
        assert_eq!(
            ::std::mem::align_of::<nsFrameList_Iterator>(),
            8usize,
            concat!("Alignment of ", stringify!(nsFrameList_Iterator))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFrameList_Iterator>())).mList as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFrameList_Iterator),
                "::",
                stringify!(mList)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsFrameList_Iterator>())).mCurrent as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFrameList_Iterator),
                "::",
                stringify!(mCurrent)
            )
        );
    }
    pub type nsFrameList_iterator = root::nsFrameList_Iterator;
    pub type nsFrameList_const_iterator = root::nsFrameList_Iterator;
    pub type nsFrameList_reverse_iterator =
        root::mozilla::ReverseIterator<root::nsFrameList_Iterator>;
    pub type nsFrameList_const_reverse_iterator =
        root::mozilla::ReverseIterator<root::nsFrameList_Iterator>;
    #[test]
    fn bindgen_test_layout_nsFrameList() {
        assert_eq!(
            ::std::mem::size_of::<nsFrameList>(),
            16usize,
            concat!("Size of: ", stringify!(nsFrameList))
        );
        assert_eq!(
            ::std::mem::align_of::<nsFrameList>(),
            8usize,
            concat!("Alignment of ", stringify!(nsFrameList))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFrameList>())).mFirstChild as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFrameList),
                "::",
                stringify!(mFirstChild)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFrameList>())).mLastChild as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFrameList),
                "::",
                stringify!(mLastChild)
            )
        );
    }
    #[doc = " Frame manager interface. The frame manager serves one purpose:"]
    #[doc = " <li>handles structural modifications to the frame model. If the frame model"]
    #[doc = " lock can be acquired, then the changes are processed immediately; otherwise,"]
    #[doc = " they\'re queued and processed later."]
    #[doc = ""]
    #[doc = " FIXME(emilio): The comment above doesn\'t make any sense, there\'s no \"frame"]
    #[doc = " model lock\" of any sort afaict."]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsFrameManager {
        pub mPresShell: *mut root::nsFrameManager_PresShell,
        pub mRootFrame: *mut root::nsIFrame,
    }
    pub type nsFrameManager_PresShell = root::mozilla::PresShell;
    pub use self::super::root::mozilla::layout::FrameChildListID as nsFrameManager_ChildListID;
    #[test]
    fn bindgen_test_layout_nsFrameManager() {
        assert_eq!(
            ::std::mem::size_of::<nsFrameManager>(),
            16usize,
            concat!("Size of: ", stringify!(nsFrameManager))
        );
        assert_eq!(
            ::std::mem::align_of::<nsFrameManager>(),
            8usize,
            concat!("Alignment of ", stringify!(nsFrameManager))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFrameManager>())).mPresShell as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFrameManager),
                "::",
                stringify!(mPresShell)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsFrameManager>())).mRootFrame as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsFrameManager),
                "::",
                stringify!(mRootFrame)
            )
        );
    }
    pub type nsFrameState_size_t = u64;
    pub const nsFrameState_NS_FRAME_IN_REFLOW: root::nsFrameState = 1;
    pub const nsFrameState_NS_FRAME_FIRST_REFLOW: root::nsFrameState = 2;
    pub const nsFrameState_NS_FRAME_IS_FLUID_CONTINUATION: root::nsFrameState = 4;
    pub const nsFrameState_NS_FRAME_ANONYMOUSCONTENTCREATOR_CONTENT: root::nsFrameState = 8;
    pub const nsFrameState_NS_FRAME_EXTERNAL_REFERENCE: root::nsFrameState = 16;
    pub const nsFrameState_NS_FRAME_CONTAINS_RELATIVE_BSIZE: root::nsFrameState = 32;
    pub const nsFrameState_NS_FRAME_GENERATED_CONTENT: root::nsFrameState = 64;
    pub const nsFrameState_NS_FRAME_IS_OVERFLOW_CONTAINER: root::nsFrameState = 128;
    pub const nsFrameState_NS_FRAME_OUT_OF_FLOW: root::nsFrameState = 256;
    pub const nsFrameState_NS_FRAME_CAN_HAVE_ABSPOS_CHILDREN: root::nsFrameState = 512;
    pub const nsFrameState_NS_FRAME_IS_DIRTY: root::nsFrameState = 1024;
    pub const nsFrameState_NS_FRAME_TOO_DEEP_IN_FRAME_TREE: root::nsFrameState = 2048;
    pub const nsFrameState_NS_FRAME_HAS_DIRTY_CHILDREN: root::nsFrameState = 4096;
    pub const nsFrameState_NS_FRAME_HAS_VIEW: root::nsFrameState = 8192;
    pub const nsFrameState_NS_FRAME_INDEPENDENT_SELECTION: root::nsFrameState = 16384;
    pub const nsFrameState_NS_FRAME_PART_OF_IBSPLIT: root::nsFrameState = 32768;
    pub const nsFrameState_NS_FRAME_MAY_BE_TRANSFORMED: root::nsFrameState = 65536;
    pub const nsFrameState_NS_FRAME_IS_BIDI: root::nsFrameState = 131072;
    pub const nsFrameState_NS_FRAME_HAS_CHILD_WITH_VIEW: root::nsFrameState = 262144;
    pub const nsFrameState_NS_FRAME_REFLOW_ROOT: root::nsFrameState = 524288;
    pub const nsFrameState_NS_FRAME_IS_PUSHED_FLOAT: root::nsFrameState = 4294967296;
    pub const nsFrameState_NS_FRAME_DRAWING_AS_PAINTSERVER: root::nsFrameState = 8589934592;
    pub const nsFrameState_NS_FRAME_DESCENDANT_INTRINSIC_ISIZE_DEPENDS_ON_BSIZE:
        root::nsFrameState = 17179869184;
    pub const nsFrameState_NS_FRAME_SIMPLE_EVENT_REGIONS: root::nsFrameState = 34359738368;
    pub const nsFrameState_NS_FRAME_UPDATE_LAYER_TREE: root::nsFrameState = 68719476736;
    pub const nsFrameState_NS_FRAME_HAS_ABSPOS_CHILDREN: root::nsFrameState = 137438953472;
    pub const nsFrameState_NS_FRAME_PAINTED_THEBES: root::nsFrameState = 274877906944;
    pub const nsFrameState_NS_FRAME_IN_CONSTRAINED_BSIZE: root::nsFrameState = 549755813888;
    pub const nsFrameState_NS_FRAME_FORCE_DISPLAY_LIST_DESCEND_INTO: root::nsFrameState =
        1099511627776;
    pub const nsFrameState_NS_FRAME_FONT_INFLATION_CONTAINER: root::nsFrameState = 2199023255552;
    pub const nsFrameState_NS_FRAME_FONT_INFLATION_FLOW_ROOT: root::nsFrameState = 4398046511104;
    pub const nsFrameState_NS_FRAME_SVG_LAYOUT: root::nsFrameState = 8796093022208;
    pub const nsFrameState_NS_FRAME_HAS_MULTI_COLUMN_ANCESTOR: root::nsFrameState = 17592186044416;
    pub const nsFrameState_NS_FRAME_DYNAMIC_REFLOW_ROOT: root::nsFrameState = 35184372088832;
    pub const nsFrameState_NS_FRAME_VISIBILITY_IS_TRACKED: root::nsFrameState = 70368744177664;
    pub const nsFrameState_NS_FRAME_IS_SVG_TEXT: root::nsFrameState = 140737488355328;
    pub const nsFrameState_NS_FRAME_NEEDS_PAINT: root::nsFrameState = 281474976710656;
    pub const nsFrameState_NS_FRAME_DESCENDANT_NEEDS_PAINT: root::nsFrameState = 562949953421312;
    pub const nsFrameState_NS_FRAME_IN_POPUP: root::nsFrameState = 1125899906842624;
    pub const nsFrameState_NS_FRAME_ALL_DESCENDANTS_NEED_PAINT: root::nsFrameState =
        2251799813685248;
    pub const nsFrameState_NS_FRAME_HAS_INVALID_RECT: root::nsFrameState = 4503599627370496;
    pub const nsFrameState_NS_FRAME_IS_NONDISPLAY: root::nsFrameState = 9007199254740992;
    pub const nsFrameState_NS_FRAME_HAS_LAYER_ACTIVITY_PROPERTY: root::nsFrameState =
        18014398509481984;
    pub const nsFrameState_NS_FRAME_OWNS_ANON_BOXES: root::nsFrameState = 36028797018963968;
    pub const nsFrameState_NS_FRAME_HAS_CSS_COUNTER_STYLE: root::nsFrameState = 72057594037927936;
    pub const nsFrameState_NS_FRAME_SIMPLE_DISPLAYLIST: root::nsFrameState = 144115188075855872;
    pub const nsFrameState_NS_FRAME_MATHML_SCRIPT_DESCENDANT: root::nsFrameState =
        288230376151711744;
    pub const nsFrameState_NS_FRAME_IS_IN_SINGLE_CHAR_MI: root::nsFrameState = 576460752303423488;
    pub const nsFrameState_NS_STATE_BOX_CHILD_RESERVED: root::nsFrameState = 1048576;
    pub const nsFrameState_NS_STATE_STACK_NOT_POSITIONED: root::nsFrameState = 2097152;
    pub const nsFrameState_NS_STATE_IS_HORIZONTAL: root::nsFrameState = 4194304;
    pub const nsFrameState_NS_STATE_AUTO_STRETCH: root::nsFrameState = 8388608;
    pub const nsFrameState_NS_STATE_IS_ROOT: root::nsFrameState = 16777216;
    pub const nsFrameState_NS_STATE_MENU_HAS_POPUP_LIST: root::nsFrameState = 268435456;
    pub const nsFrameState_NS_STATE_BOX_WRAPS_KIDS_IN_BLOCK: root::nsFrameState = 536870912;
    pub const nsFrameState_NS_STATE_EQUAL_SIZE: root::nsFrameState = 1073741824;
    pub const nsFrameState_NS_STATE_IS_DIRECTION_NORMAL: root::nsFrameState = 2147483648;
    pub const nsFrameState_NS_FRAME_MOUSE_THROUGH_ALWAYS: root::nsFrameState = 1152921504606846976;
    pub const nsFrameState_NS_FRAME_MOUSE_THROUGH_NEVER: root::nsFrameState = 2305843009213693952;
    pub const nsFrameState_NS_STATE_FLEX_NORMAL_FLOW_CHILDREN_IN_CSS_ORDER: root::nsFrameState =
        1048576;
    pub const nsFrameState_NS_STATE_FLEX_IS_EMULATING_LEGACY_BOX: root::nsFrameState = 2097152;
    pub const nsFrameState_NS_STATE_FLEX_GENERATE_COMPUTED_VALUES: root::nsFrameState = 4194304;
    pub const nsFrameState_NS_STATE_FLEX_SYNTHESIZE_BASELINE: root::nsFrameState = 8388608;
    pub const nsFrameState_NS_STATE_FLEX_HAS_LINE_CLAMP_ELLIPSIS: root::nsFrameState = 16777216;
    pub const nsFrameState_NS_STATE_GRID_NORMAL_FLOW_CHILDREN_IN_CSS_ORDER: root::nsFrameState =
        1048576;
    pub const nsFrameState_NS_STATE_GRID_DID_PUSH_ITEMS: root::nsFrameState = 2097152;
    pub const nsFrameState_NS_STATE_GRID_GENERATE_COMPUTED_VALUES: root::nsFrameState = 4194304;
    pub const nsFrameState_NS_STATE_GRID_SYNTHESIZE_BASELINE: root::nsFrameState = 8388608;
    pub const nsFrameState_NS_STATE_GRID_IS_COL_SUBGRID: root::nsFrameState = 16777216;
    pub const nsFrameState_NS_STATE_GRID_IS_ROW_SUBGRID: root::nsFrameState = 33554432;
    pub const nsFrameState_NS_STATE_GRID_HAS_COL_SUBGRID_ITEM: root::nsFrameState = 67108864;
    pub const nsFrameState_NS_STATE_GRID_HAS_ROW_SUBGRID_ITEM: root::nsFrameState = 134217728;
    pub const nsFrameState_NS_STATE_GRID_HAS_CHILD_NIFS: root::nsFrameState = 268435456;
    pub const nsFrameState_NS_STATE_SVG_CLIPPATH_CHILD: root::nsFrameState = 1048576;
    pub const nsFrameState_NS_STATE_SVG_POSITIONING_DIRTY: root::nsFrameState = 2097152;
    pub const nsFrameState_NS_STATE_SVG_POSITIONING_MAY_USE_PERCENTAGES: root::nsFrameState =
        4194304;
    pub const nsFrameState_NS_STATE_SVG_TEXT_IN_REFLOW: root::nsFrameState = 8388608;
    pub const nsFrameState_NS_STATE_SVG_TEXT_CORRESPONDENCE_DIRTY: root::nsFrameState = 16777216;
    pub const nsFrameState_TEXT_FIRST_LETTER: root::nsFrameState = 1048576;
    pub const nsFrameState_TEXT_START_OF_LINE: root::nsFrameState = 2097152;
    pub const nsFrameState_TEXT_END_OF_LINE: root::nsFrameState = 4194304;
    pub const nsFrameState_TEXT_HYPHEN_BREAK: root::nsFrameState = 8388608;
    pub const nsFrameState_TEXT_TRIMMED_TRAILING_WHITESPACE: root::nsFrameState = 16777216;
    pub const nsFrameState_TEXT_JUSTIFICATION_ENABLED: root::nsFrameState = 33554432;
    pub const nsFrameState_TEXT_SELECTION_UNDERLINE_OVERFLOWED: root::nsFrameState = 67108864;
    pub const nsFrameState_TEXT_IS_ONLY_WHITESPACE: root::nsFrameState = 134217728;
    pub const nsFrameState_TEXT_ISNOT_ONLY_WHITESPACE: root::nsFrameState = 268435456;
    pub const nsFrameState_TEXT_IN_TEXTRUN_USER_DATA: root::nsFrameState = 536870912;
    pub const nsFrameState_TEXT_OFFSETS_NEED_FIXING: root::nsFrameState = 1073741824;
    pub const nsFrameState_TEXT_HAS_NONCOLLAPSED_CHARACTERS: root::nsFrameState = 2147483648;
    pub const nsFrameState_TEXT_IS_IN_TOKEN_MATHML: root::nsFrameState = 4294967296;
    pub const nsFrameState_TEXT_IN_UNINFLATED_TEXTRUN_USER_DATA: root::nsFrameState =
        1152921504606846976;
    pub const nsFrameState_TEXT_HAS_FONT_INFLATION: root::nsFrameState = 2305843009213693952;
    pub const nsFrameState_TEXT_NO_RENDERED_GLYPHS: root::nsFrameState = 4611686018427387904;
    pub const nsFrameState_TEXT_IN_OFFSET_CACHE: root::nsFrameState = 9223372036854775808;
    pub const nsFrameState_NS_BLOCK_NEEDS_BIDI_RESOLUTION: root::nsFrameState = 1048576;
    pub const nsFrameState_NS_BLOCK_HAS_PUSHED_FLOATS: root::nsFrameState = 2097152;
    pub const nsFrameState_NS_BLOCK_MARGIN_ROOT: root::nsFrameState = 4194304;
    pub const nsFrameState_NS_BLOCK_FLOAT_MGR: root::nsFrameState = 8388608;
    pub const nsFrameState_NS_BLOCK_HAS_LINE_CURSOR: root::nsFrameState = 16777216;
    pub const nsFrameState_NS_BLOCK_HAS_OVERFLOW_LINES: root::nsFrameState = 33554432;
    pub const nsFrameState_NS_BLOCK_HAS_OVERFLOW_OUT_OF_FLOWS: root::nsFrameState = 67108864;
    pub const nsFrameState_NS_BLOCK_HAS_CLEAR_CHILDREN: root::nsFrameState = 134217728;
    pub const nsFrameState_NS_BLOCK_CLIP_PAGINATED_OVERFLOW: root::nsFrameState = 268435456;
    pub const nsFrameState_NS_BLOCK_HAS_FIRST_LETTER_STYLE: root::nsFrameState = 536870912;
    pub const nsFrameState_NS_BLOCK_FRAME_HAS_OUTSIDE_MARKER: root::nsFrameState = 1073741824;
    pub const nsFrameState_NS_BLOCK_FRAME_HAS_INSIDE_MARKER: root::nsFrameState = 2147483648;
    pub const nsFrameState_NS_BLOCK_HAS_LINE_CLAMP_ELLIPSIS: root::nsFrameState =
        1152921504606846976;
    pub const nsFrameState_NS_BLOCK_LOOK_FOR_DIRTY_FRAMES: root::nsFrameState = 2305843009213693952;
    pub const nsFrameState_NS_BLOCK_FRAME_INTRINSICS_INFLATED: root::nsFrameState =
        4611686018427387904;
    pub const nsFrameState_NS_BLOCK_HAS_FIRST_LETTER_CHILD: root::nsFrameState =
        9223372036854775808;
    pub const nsFrameState_BULLET_FRAME_HAS_FONT_INFLATION: root::nsFrameState =
        4611686018427387904;
    pub const nsFrameState_BULLET_FRAME_IMAGE_LOADING: root::nsFrameState = 9223372036854775808;
    pub const nsFrameState_IMAGE_SIZECONSTRAINED: root::nsFrameState = 1048576;
    pub const nsFrameState_NS_INLINE_FRAME_BIDI_VISUAL_STATE_IS_SET: root::nsFrameState = 2097152;
    pub const nsFrameState_NS_INLINE_FRAME_BIDI_VISUAL_IS_FIRST: root::nsFrameState = 4194304;
    pub const nsFrameState_NS_INLINE_FRAME_BIDI_VISUAL_IS_LAST: root::nsFrameState = 8388608;
    pub const nsFrameState_NS_RUBY_TEXT_FRAME_AUTOHIDE: root::nsFrameState = 16777216;
    pub const nsFrameState_NS_RUBY_TEXT_CONTAINER_IS_SPAN: root::nsFrameState = 1048576;
    pub const nsFrameState_PLACEHOLDER_FOR_FLOAT: root::nsFrameState = 1048576;
    pub const nsFrameState_PLACEHOLDER_FOR_ABSPOS: root::nsFrameState = 2097152;
    pub const nsFrameState_PLACEHOLDER_FOR_FIXEDPOS: root::nsFrameState = 4194304;
    pub const nsFrameState_PLACEHOLDER_FOR_POPUP: root::nsFrameState = 8388608;
    pub const nsFrameState_PLACEHOLDER_FOR_TOPLAYER: root::nsFrameState = 16777216;
    pub const nsFrameState_PLACEHOLDER_STATICPOS_NEEDS_CSSALIGN: root::nsFrameState = 33554432;
    pub const nsFrameState_PLACEHOLDER_LINE_IS_EMPTY_SO_FAR: root::nsFrameState = 67108864;
    pub const nsFrameState_PLACEHOLDER_HAVE_LINE_IS_EMPTY_SO_FAR: root::nsFrameState = 134217728;
    pub const nsFrameState_NS_TABLE_CELL_HAS_PCT_OVER_BSIZE: root::nsFrameState = 268435456;
    pub const nsFrameState_NS_TABLE_CELL_HAD_SPECIAL_REFLOW: root::nsFrameState = 536870912;
    pub const nsFrameState_NS_TABLE_CELL_CONTENT_EMPTY: root::nsFrameState = 2147483648;
    pub const nsFrameState_NS_REPEATED_ROW_OR_ROWGROUP: root::nsFrameState = 268435456;
    pub const nsFrameState_NS_ROW_HAS_CELL_WITH_STYLE_BSIZE: root::nsFrameState = 536870912;
    pub const nsFrameState_NS_TABLE_ROW_HAS_UNPAGINATED_BSIZE: root::nsFrameState = 1073741824;
    pub const nsFrameState_NS_ROWGROUP_HAS_ROW_CURSOR: root::nsFrameState = 134217728;
    pub const nsFrameState_NS_ROWGROUP_HAS_STYLE_BSIZE: root::nsFrameState = 1073741824;
    pub const nsFrameState_NS_ROWGROUP_REPEATABLE: root::nsFrameState = 2147483648;
    pub const nsFrameState_NS_TABLE_PART_HAS_FIXED_BACKGROUND: root::nsFrameState = 268435456;
    pub type nsFrameState = u64;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct imgINotificationObserver {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct imgINotificationObserver_COMTypeInfo {
        pub _address: u8,
    }
    pub const imgINotificationObserver_SIZE_AVAILABLE:
        root::imgINotificationObserver__bindgen_ty_1 = 1;
    pub const imgINotificationObserver_FRAME_UPDATE: root::imgINotificationObserver__bindgen_ty_1 =
        2;
    pub const imgINotificationObserver_FRAME_COMPLETE:
        root::imgINotificationObserver__bindgen_ty_1 = 3;
    pub const imgINotificationObserver_LOAD_COMPLETE: root::imgINotificationObserver__bindgen_ty_1 =
        4;
    pub const imgINotificationObserver_DECODE_COMPLETE:
        root::imgINotificationObserver__bindgen_ty_1 = 5;
    pub const imgINotificationObserver_DISCARD: root::imgINotificationObserver__bindgen_ty_1 = 6;
    pub const imgINotificationObserver_UNLOCKED_DRAW: root::imgINotificationObserver__bindgen_ty_1 =
        7;
    pub const imgINotificationObserver_IS_ANIMATED: root::imgINotificationObserver__bindgen_ty_1 =
        8;
    pub const imgINotificationObserver_HAS_TRANSPARENCY:
        root::imgINotificationObserver__bindgen_ty_1 = 9;
    pub type imgINotificationObserver__bindgen_ty_1 = u32;
    #[test]
    fn bindgen_test_layout_imgINotificationObserver() {
        assert_eq!(
            ::std::mem::size_of::<imgINotificationObserver>(),
            8usize,
            concat!("Size of: ", stringify!(imgINotificationObserver))
        );
        assert_eq!(
            ::std::mem::align_of::<imgINotificationObserver>(),
            8usize,
            concat!("Alignment of ", stringify!(imgINotificationObserver))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsISelectionDisplay {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsISelectionDisplay_COMTypeInfo {
        pub _address: u8,
    }
    pub const nsISelectionDisplay_DISPLAY_TEXT: root::nsISelectionDisplay__bindgen_ty_1 = 1;
    pub const nsISelectionDisplay_DISPLAY_IMAGES: root::nsISelectionDisplay__bindgen_ty_1 = 2;
    pub const nsISelectionDisplay_DISPLAY_FRAMES: root::nsISelectionDisplay__bindgen_ty_1 = 4;
    pub const nsISelectionDisplay_DISPLAY_ALL: root::nsISelectionDisplay__bindgen_ty_1 = 7;
    pub type nsISelectionDisplay__bindgen_ty_1 = u32;
    #[test]
    fn bindgen_test_layout_nsISelectionDisplay() {
        assert_eq!(
            ::std::mem::size_of::<nsISelectionDisplay>(),
            8usize,
            concat!("Size of: ", stringify!(nsISelectionDisplay))
        );
        assert_eq!(
            ::std::mem::align_of::<nsISelectionDisplay>(),
            8usize,
            concat!("Alignment of ", stringify!(nsISelectionDisplay))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsISelectionController {
        pub _base: root::nsISelectionDisplay,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsISelectionController_COMTypeInfo {
        pub _address: u8,
    }
    pub const nsISelectionController_SELECTION_NONE: root::nsISelectionController__bindgen_ty_1 = 0;
    pub const nsISelectionController_SELECTION_NORMAL: root::nsISelectionController__bindgen_ty_1 =
        1;
    pub const nsISelectionController_SELECTION_SPELLCHECK:
        root::nsISelectionController__bindgen_ty_1 = 2;
    pub const nsISelectionController_SELECTION_IME_RAWINPUT:
        root::nsISelectionController__bindgen_ty_1 = 3;
    pub const nsISelectionController_SELECTION_IME_SELECTEDRAWTEXT:
        root::nsISelectionController__bindgen_ty_1 = 4;
    pub const nsISelectionController_SELECTION_IME_CONVERTEDTEXT:
        root::nsISelectionController__bindgen_ty_1 = 5;
    pub const nsISelectionController_SELECTION_IME_SELECTEDCONVERTEDTEXT:
        root::nsISelectionController__bindgen_ty_1 = 6;
    pub const nsISelectionController_SELECTION_ACCESSIBILITY:
        root::nsISelectionController__bindgen_ty_1 = 7;
    pub const nsISelectionController_SELECTION_FIND: root::nsISelectionController__bindgen_ty_1 = 8;
    pub const nsISelectionController_SELECTION_URLSECONDARY:
        root::nsISelectionController__bindgen_ty_1 = 9;
    pub const nsISelectionController_SELECTION_URLSTRIKEOUT:
        root::nsISelectionController__bindgen_ty_1 = 10;
    pub const nsISelectionController_NUM_SELECTIONTYPES:
        root::nsISelectionController__bindgen_ty_1 = 11;
    pub const nsISelectionController_SELECTION_ANCHOR_REGION:
        root::nsISelectionController__bindgen_ty_1 = 0;
    pub const nsISelectionController_SELECTION_FOCUS_REGION:
        root::nsISelectionController__bindgen_ty_1 = 1;
    pub const nsISelectionController_SELECTION_WHOLE_SELECTION:
        root::nsISelectionController__bindgen_ty_1 = 2;
    pub const nsISelectionController_NUM_SELECTION_REGIONS:
        root::nsISelectionController__bindgen_ty_1 = 3;
    pub const nsISelectionController_SELECTION_OFF: root::nsISelectionController__bindgen_ty_1 = 0;
    pub const nsISelectionController_SELECTION_HIDDEN: root::nsISelectionController__bindgen_ty_1 =
        1;
    pub const nsISelectionController_SELECTION_ON: root::nsISelectionController__bindgen_ty_1 = 2;
    pub const nsISelectionController_SELECTION_DISABLED:
        root::nsISelectionController__bindgen_ty_1 = 3;
    pub const nsISelectionController_SELECTION_ATTENTION:
        root::nsISelectionController__bindgen_ty_1 = 4;
    pub type nsISelectionController__bindgen_ty_1 = u32;
    pub const nsISelectionController_SCROLL_SYNCHRONOUS:
        root::nsISelectionController__bindgen_ty_2 = 2;
    pub const nsISelectionController_SCROLL_FIRST_ANCESTOR_ONLY:
        root::nsISelectionController__bindgen_ty_2 = 4;
    pub const nsISelectionController_SCROLL_CENTER_VERTICALLY:
        root::nsISelectionController__bindgen_ty_2 = 16;
    pub const nsISelectionController_SCROLL_OVERFLOW_HIDDEN:
        root::nsISelectionController__bindgen_ty_2 = 32;
    pub const nsISelectionController_SCROLL_FOR_CARET_MOVE:
        root::nsISelectionController__bindgen_ty_2 = 64;
    pub type nsISelectionController__bindgen_ty_2 = u32;
    pub const nsISelectionController_MOVE_LEFT: root::nsISelectionController__bindgen_ty_3 = 0;
    pub const nsISelectionController_MOVE_RIGHT: root::nsISelectionController__bindgen_ty_3 = 1;
    pub const nsISelectionController_MOVE_UP: root::nsISelectionController__bindgen_ty_3 = 2;
    pub const nsISelectionController_MOVE_DOWN: root::nsISelectionController__bindgen_ty_3 = 3;
    pub type nsISelectionController__bindgen_ty_3 = u32;
    #[test]
    fn bindgen_test_layout_nsISelectionController() {
        assert_eq!(
            ::std::mem::size_of::<nsISelectionController>(),
            8usize,
            concat!("Size of: ", stringify!(nsISelectionController))
        );
        assert_eq!(
            ::std::mem::align_of::<nsISelectionController>(),
            8usize,
            concat!("Alignment of ", stringify!(nsISelectionController))
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsPresArena_FreeList {
        pub mEntries: root::nsTArray<*mut ::std::os::raw::c_void>,
        pub mEntrySize: usize,
        pub mEntriesEverAllocated: usize,
    }
    #[repr(C)]
    pub struct nsARefreshObserver__bindgen_vtable(::std::os::raw::c_void);
    #[doc = " An abstract base class to be implemented by callers wanting to be"]
    #[doc = " notified at refresh times.  When nothing needs to be painted, callers"]
    #[doc = " may not be notified."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsARefreshObserver {
        pub vtable_: *const nsARefreshObserver__bindgen_vtable,
    }
    #[test]
    fn bindgen_test_layout_nsARefreshObserver() {
        assert_eq!(
            ::std::mem::size_of::<nsARefreshObserver>(),
            8usize,
            concat!("Size of: ", stringify!(nsARefreshObserver))
        );
        assert_eq!(
            ::std::mem::align_of::<nsARefreshObserver>(),
            8usize,
            concat!("Alignment of ", stringify!(nsARefreshObserver))
        );
    }
    #[repr(C)]
    pub struct nsATimerAdjustmentObserver__bindgen_vtable(::std::os::raw::c_void);
    #[doc = " An abstract base class to be implemented by callers wanting to be notified"]
    #[doc = " when the observing refresh driver updated mMostRecentRefresh due to active"]
    #[doc = " timer changes. Callers must ensure an observer is removed before it is"]
    #[doc = " destroyed."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsATimerAdjustmentObserver {
        pub vtable_: *const nsATimerAdjustmentObserver__bindgen_vtable,
    }
    #[test]
    fn bindgen_test_layout_nsATimerAdjustmentObserver() {
        assert_eq!(
            ::std::mem::size_of::<nsATimerAdjustmentObserver>(),
            8usize,
            concat!("Size of: ", stringify!(nsATimerAdjustmentObserver))
        );
        assert_eq!(
            ::std::mem::align_of::<nsATimerAdjustmentObserver>(),
            8usize,
            concat!("Alignment of ", stringify!(nsATimerAdjustmentObserver))
        );
    }
    #[repr(C)]
    pub struct nsAPostRefreshObserver__bindgen_vtable(::std::os::raw::c_void);
    #[doc = " An abstract base class to be implemented by callers wanting to be notified"]
    #[doc = " that a refresh has occurred. Callers must ensure an observer is removed"]
    #[doc = " before it is destroyed."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsAPostRefreshObserver {
        pub vtable_: *const nsAPostRefreshObserver__bindgen_vtable,
    }
    #[test]
    fn bindgen_test_layout_nsAPostRefreshObserver() {
        assert_eq!(
            ::std::mem::size_of::<nsAPostRefreshObserver>(),
            8usize,
            concat!("Size of: ", stringify!(nsAPostRefreshObserver))
        );
        assert_eq!(
            ::std::mem::align_of::<nsAPostRefreshObserver>(),
            8usize,
            concat!("Alignment of ", stringify!(nsAPostRefreshObserver))
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsRefreshDriver {
        pub _base: root::mozilla::layers::TransactionIdAllocator,
        pub _base_1: root::nsARefreshObserver,
        pub mActiveTimer: *mut root::mozilla::RefreshDriverTimer,
        pub mPresContext: u64,
        pub mRootRefresh: root::RefPtr<root::nsRefreshDriver>,
        pub mNextTransactionId: root::nsRefreshDriver_TransactionId,
        pub mOutstandingTransactionId: root::nsRefreshDriver_TransactionId,
        pub mCompletedTransaction: root::nsRefreshDriver_TransactionId,
        pub mFreezeCount: u32,
        pub mThrottledFrameRequestInterval: root::mozilla::TimeDuration,
        pub mMinRecomputeVisibilityInterval: root::mozilla::TimeDuration,
        pub mThrottled: bool,
        pub mNeedToRecomputeVisibility: bool,
        pub mTestControllingRefreshes: bool,
        pub mViewManagerFlushIsPending: bool,
        pub mHasScheduleFlush: bool,
        pub mInRefresh: bool,
        pub mWaitingForTransaction: bool,
        pub mSkippedPaints: bool,
        pub mResizeSuppressed: bool,
        pub mNotifyDOMContentFlushed: bool,
        pub mWarningThreshold: u64,
        pub mMostRecentRefresh: root::mozilla::TimeStamp,
        pub mTickStart: root::mozilla::TimeStamp,
        pub mTickVsyncId: root::mozilla::VsyncId,
        pub mTickVsyncTime: root::mozilla::TimeStamp,
        pub mNextThrottledFrameRequestTick: root::mozilla::TimeStamp,
        pub mNextRecomputeVisibilityTick: root::mozilla::TimeStamp,
        pub mInitialTimerRunningLimit: root::mozilla::TimeStamp,
        pub mObservers: [root::nsRefreshDriver_ObserverArray; 4usize],
        pub mTimerAdjustmentObservers: [u64; 2usize],
        pub mRequests: root::nsRefreshDriver_RequestTable,
        pub mStartTable: root::nsRefreshDriver_ImageStartTable,
        pub mEarlyRunners: [u64; 18usize],
        pub mVisualViewportResizeEvents: root::nsRefreshDriver_VisualViewportResizeEventArray,
        pub mScrollEvents: root::nsRefreshDriver_ScrollEventArray,
        pub mVisualViewportScrollEvents: root::nsRefreshDriver_VisualViewportScrollEventArray,
        pub mDelayedScrollEvents: root::nsRefreshDriver_ScrollEventArray,
        pub mResizeEventFlushObservers: [u64; 18usize],
        pub mDelayedResizeEventFlushObservers: [u64; 18usize],
        pub mStyleFlushObservers: [u64; 18usize],
        pub mLayoutFlushObservers: [u64; 18usize],
        pub mFrameRequestCallbackDocs: root::nsTArray<*mut root::nsRefreshDriver_Document>,
        pub mThrottledFrameRequestCallbackDocs: root::nsTArray<*mut root::nsRefreshDriver_Document>,
        pub mPostRefreshObservers: [u64; 2usize],
        pub mPendingFullscreenEvents:
            root::nsTArray<root::mozilla::UniquePtr<root::mozilla::PendingFullscreenEvent>>,
        pub mAnimationEventFlushObservers: [u64; 18usize],
    }
    pub type nsRefreshDriver_Document = root::mozilla::dom::Document;
    pub type nsRefreshDriver_TransactionId = root::mozilla::layers::TransactionId;
    pub type nsRefreshDriver_VVPResizeEvent =
        root::mozilla::dom::VisualViewport_VisualViewportResizeEvent;
    pub type nsRefreshDriver_VVPScrollEvent =
        root::mozilla::dom::VisualViewport_VisualViewportScrollEvent;
    pub type nsRefreshDriver_ObserverArray = [u64; 2usize];
    pub type nsRefreshDriver_VisualViewportResizeEventArray =
        root::nsTArray<root::RefPtr<root::nsRefreshDriver_VVPResizeEvent>>;
    pub type nsRefreshDriver_ScrollEventArray =
        root::nsTArray<root::RefPtr<root::mozilla::Runnable>>;
    pub type nsRefreshDriver_VisualViewportScrollEventArray =
        root::nsTArray<root::RefPtr<root::nsRefreshDriver_VVPScrollEvent>>;
    pub type nsRefreshDriver_RequestTable = [u64; 4usize];
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsRefreshDriver_ImageStartData {
        pub mStartTime: [u64; 2usize],
        pub mEntries: root::nsRefreshDriver_RequestTable,
    }
    #[test]
    fn bindgen_test_layout_nsRefreshDriver_ImageStartData() {
        assert_eq!(
            ::std::mem::size_of::<nsRefreshDriver_ImageStartData>(),
            48usize,
            concat!("Size of: ", stringify!(nsRefreshDriver_ImageStartData))
        );
        assert_eq!(
            ::std::mem::align_of::<nsRefreshDriver_ImageStartData>(),
            8usize,
            concat!("Alignment of ", stringify!(nsRefreshDriver_ImageStartData))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsRefreshDriver_ImageStartData>())).mStartTime as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsRefreshDriver_ImageStartData),
                "::",
                stringify!(mStartTime)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsRefreshDriver_ImageStartData>())).mEntries as *const _
                    as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsRefreshDriver_ImageStartData),
                "::",
                stringify!(mEntries)
            )
        );
    }
    pub type nsRefreshDriver_ImageStartTable = [u64; 4usize];
    pub const nsRefreshDriver_EnsureTimerStartedFlags_eNone:
        root::nsRefreshDriver_EnsureTimerStartedFlags = 0;
    pub const nsRefreshDriver_EnsureTimerStartedFlags_eForceAdjustTimer:
        root::nsRefreshDriver_EnsureTimerStartedFlags = 1;
    pub const nsRefreshDriver_EnsureTimerStartedFlags_eAllowTimeToGoBackwards:
        root::nsRefreshDriver_EnsureTimerStartedFlags = 2;
    pub const nsRefreshDriver_EnsureTimerStartedFlags_eNeverAdjustTimer:
        root::nsRefreshDriver_EnsureTimerStartedFlags = 4;
    pub type nsRefreshDriver_EnsureTimerStartedFlags = u32;
    #[test]
    fn bindgen_test_layout_nsRefreshDriver() {
        assert_eq!(
            ::std::mem::size_of::<nsRefreshDriver>(),
            1256usize,
            concat!("Size of: ", stringify!(nsRefreshDriver))
        );
        assert_eq!(
            ::std::mem::align_of::<nsRefreshDriver>(),
            8usize,
            concat!("Alignment of ", stringify!(nsRefreshDriver))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIDocumentObserver {
        pub _base: root::nsIMutationObserver,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIDocumentObserver_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIDocumentObserver() {
        assert_eq!(
            ::std::mem::size_of::<nsIDocumentObserver>(),
            8usize,
            concat!("Size of: ", stringify!(nsIDocumentObserver))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIDocumentObserver>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIDocumentObserver))
        );
    }
    #[doc = " There are two advantages to inheriting from nsStubDocumentObserver"]
    #[doc = " rather than directly from nsIDocumentObserver:"]
    #[doc = "  1. smaller compiled code size (since there\'s no need for the code"]
    #[doc = "     for the empty virtual function implementations for every"]
    #[doc = "     nsIDocumentObserver implementation)"]
    #[doc = "  2. the performance of document\'s loop over observers benefits from"]
    #[doc = "     the fact that more of the functions called are the same (which"]
    #[doc = "     can reduce instruction cache misses and perhaps improve branch"]
    #[doc = "     prediction)"]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsStubDocumentObserver {
        pub _base: root::nsIDocumentObserver,
    }
    #[test]
    fn bindgen_test_layout_nsStubDocumentObserver() {
        assert_eq!(
            ::std::mem::size_of::<nsStubDocumentObserver>(),
            8usize,
            concat!("Size of: ", stringify!(nsStubDocumentObserver))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStubDocumentObserver>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStubDocumentObserver))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct MobileViewportManager {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsCaret {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsFrameSelection {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct RangePaintInfo {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsCallbackEventRequest {
        _unused: [u8; 0],
    }
    #[doc = " An internal interface"]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIHTMLCollection {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIHTMLCollection_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIHTMLCollection() {
        assert_eq!(
            ::std::mem::size_of::<nsIHTMLCollection>(),
            8usize,
            concat!("Size of: ", stringify!(nsIHTMLCollection))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIHTMLCollection>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIHTMLCollection))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsXBLDocumentInfo {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsAnonymousContentList {
        _unused: [u8; 0],
    }
    #[repr(C)]
    pub struct nsXBLBinding {
        pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
        pub mMarkedForDeath: bool,
        pub mPrototypeBinding: *mut root::nsXBLPrototypeBinding,
        pub mContent: root::nsCOMPtr,
        pub mNextBinding: root::RefPtr<root::nsXBLBinding>,
        pub mBoundElement: *mut root::mozilla::dom::Element,
        pub mDefaultInsertionPoint: root::RefPtr<root::mozilla::dom::XBLChildrenElement>,
        pub mInsertionPoints: root::nsTArray<root::RefPtr<root::mozilla::dom::XBLChildrenElement>>,
        pub mAnonymousContentList: root::RefPtr<root::nsAnonymousContentList>,
    }
    pub type nsXBLBinding_HasThreadSafeRefCnt = root::mozilla::FalseType;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsXBLBinding_cycleCollection {
        pub _base: root::nsCycleCollectionParticipant,
    }
    #[test]
    fn bindgen_test_layout_nsXBLBinding_cycleCollection() {
        assert_eq!(
            ::std::mem::size_of::<nsXBLBinding_cycleCollection>(),
            16usize,
            concat!("Size of: ", stringify!(nsXBLBinding_cycleCollection))
        );
        assert_eq!(
            ::std::mem::align_of::<nsXBLBinding_cycleCollection>(),
            8usize,
            concat!("Alignment of ", stringify!(nsXBLBinding_cycleCollection))
        );
    }
    extern "C" {
        #[link_name = "\u{1}_ZN12nsXBLBinding21_cycleCollectorGlobalE"]
        pub static mut nsXBLBinding__cycleCollectorGlobal: root::nsXBLBinding_cycleCollection;
    }
    #[test]
    fn bindgen_test_layout_nsXBLBinding() {
        assert_eq!(
            ::std::mem::size_of::<nsXBLBinding>(),
            72usize,
            concat!("Size of: ", stringify!(nsXBLBinding))
        );
        assert_eq!(
            ::std::mem::align_of::<nsXBLBinding>(),
            8usize,
            concat!("Alignment of ", stringify!(nsXBLBinding))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsXBLBinding>())).mRefCnt as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsXBLBinding),
                "::",
                stringify!(mRefCnt)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsXBLBinding>())).mMarkedForDeath as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsXBLBinding),
                "::",
                stringify!(mMarkedForDeath)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsXBLBinding>())).mPrototypeBinding as *const _ as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsXBLBinding),
                "::",
                stringify!(mPrototypeBinding)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsXBLBinding>())).mContent as *const _ as usize },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsXBLBinding),
                "::",
                stringify!(mContent)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsXBLBinding>())).mNextBinding as *const _ as usize },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsXBLBinding),
                "::",
                stringify!(mNextBinding)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsXBLBinding>())).mBoundElement as *const _ as usize },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsXBLBinding),
                "::",
                stringify!(mBoundElement)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsXBLBinding>())).mDefaultInsertionPoint as *const _ as usize
            },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(nsXBLBinding),
                "::",
                stringify!(mDefaultInsertionPoint)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsXBLBinding>())).mInsertionPoints as *const _ as usize
            },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(nsXBLBinding),
                "::",
                stringify!(mInsertionPoints)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsXBLBinding>())).mAnonymousContentList as *const _ as usize
            },
            64usize,
            concat!(
                "Offset of field: ",
                stringify!(nsXBLBinding),
                "::",
                stringify!(mAnonymousContentList)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsLabelsNodeList {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsDOMTokenList {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsDOMCSSAttributeDeclaration {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsDOMStringMap {
        _unused: [u8; 0],
    }
    extern "C" {
        pub fn Servo_Element_IsDisplayContents(arg1: *const root::mozilla::dom::Element) -> bool;
    }
    pub const ELEMENT_HAS_DIRTY_DESCENDANTS_FOR_SERVO: root::_bindgen_ty_31 = 1048576;
    pub const ELEMENT_HAS_ANIMATION_ONLY_DIRTY_DESCENDANTS_FOR_SERVO: root::_bindgen_ty_31 =
        2097152;
    pub const ELEMENT_HAS_SNAPSHOT: root::_bindgen_ty_31 = 4194304;
    pub const ELEMENT_HANDLED_SNAPSHOT: root::_bindgen_ty_31 = 8388608;
    pub const ELEMENT_TYPE_SPECIFIC_BITS_OFFSET: root::_bindgen_ty_31 = 23;
    pub type _bindgen_ty_31 = u32;
    pub type nsStyledElementBase = root::mozilla::dom::Element;
    #[repr(C)]
    pub struct nsStyledElement {
        pub _base: root::nsStyledElementBase,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsStyledElement_COMTypeInfo {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsStyledElement() {
        assert_eq!(
            ::std::mem::size_of::<nsStyledElement>(),
            128usize,
            concat!("Size of: ", stringify!(nsStyledElement))
        );
        assert_eq!(
            ::std::mem::align_of::<nsStyledElement>(),
            8usize,
            concat!("Alignment of ", stringify!(nsStyledElement))
        );
    }
    pub type nsMappedAttributeElementBase = root::nsStyledElement;
    #[repr(C)]
    pub struct nsMappedAttributeElement {
        pub _base: root::nsMappedAttributeElementBase,
    }
    #[test]
    fn bindgen_test_layout_nsMappedAttributeElement() {
        assert_eq!(
            ::std::mem::size_of::<nsMappedAttributeElement>(),
            128usize,
            concat!("Size of: ", stringify!(nsMappedAttributeElement))
        );
        assert_eq!(
            ::std::mem::align_of::<nsMappedAttributeElement>(),
            8usize,
            concat!("Alignment of ", stringify!(nsMappedAttributeElement))
        );
    }
    #[repr(C)]
    pub struct nsNameSpaceManager__bindgen_vtable(::std::os::raw::c_void);
    #[doc = " The Name Space Manager tracks the association between a NameSpace"]
    #[doc = " URI and the int32_t runtime id. Mappings between NameSpaces and"]
    #[doc = " NameSpace prefixes are managed by nsINameSpaces."]
    #[doc = ""]
    #[doc = " All NameSpace URIs are stored in a global table so that IDs are"]
    #[doc = " consistent accross the app. NameSpace IDs are only consistent at runtime"]
    #[doc = " ie: they are not guaranteed to be consistent accross app sessions."]
    #[doc = ""]
    #[doc = " The nsNameSpaceManager needs to have a live reference for as long as"]
    #[doc = " the NameSpace IDs are needed."]
    #[doc = ""]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsNameSpaceManager {
        pub vtable_: *const nsNameSpaceManager__bindgen_vtable,
        pub mRefCnt: root::nsAutoRefCnt,
        pub mMathMLDisabled: bool,
        pub mSVGDisabled: bool,
        pub mURIToIDTable: [u64; 4usize],
        pub mDisabledURIToIDTable: [u64; 4usize],
        pub mURIArray: root::nsTArray<root::RefPtr<root::nsAtom>>,
    }
    pub type nsNameSpaceManager_HasThreadSafeRefCnt = root::mozilla::FalseType;
    extern "C" {
        #[link_name = "\u{1}_ZN18nsNameSpaceManager9sInstanceE"]
        pub static mut nsNameSpaceManager_sInstance:
            root::mozilla::StaticRefPtr<root::nsNameSpaceManager>;
    }
    #[test]
    fn bindgen_test_layout_nsNameSpaceManager() {
        assert_eq!(
            ::std::mem::size_of::<nsNameSpaceManager>(),
            96usize,
            concat!("Size of: ", stringify!(nsNameSpaceManager))
        );
        assert_eq!(
            ::std::mem::align_of::<nsNameSpaceManager>(),
            8usize,
            concat!("Alignment of ", stringify!(nsNameSpaceManager))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsNameSpaceManager>())).mRefCnt as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNameSpaceManager),
                "::",
                stringify!(mRefCnt)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsNameSpaceManager>())).mMathMLDisabled as *const _ as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNameSpaceManager),
                "::",
                stringify!(mMathMLDisabled)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsNameSpaceManager>())).mSVGDisabled as *const _ as usize
            },
            17usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNameSpaceManager),
                "::",
                stringify!(mSVGDisabled)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsNameSpaceManager>())).mURIToIDTable as *const _ as usize
            },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNameSpaceManager),
                "::",
                stringify!(mURIToIDTable)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsNameSpaceManager>())).mDisabledURIToIDTable as *const _
                    as usize
            },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNameSpaceManager),
                "::",
                stringify!(mDisabledURIToIDTable)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsNameSpaceManager>())).mURIArray as *const _ as usize
            },
            88usize,
            concat!(
                "Offset of field: ",
                stringify!(nsNameSpaceManager),
                "::",
                stringify!(mURIArray)
            )
        );
    }
    pub type nsGenericHTMLElementBase = root::nsMappedAttributeElement;
    #[doc = " A common superclass for HTML elements"]
    #[repr(C)]
    pub struct nsGenericHTMLElement {
        pub _base: root::nsGenericHTMLElementBase,
    }
    pub const nsGenericHTMLElement_PresContextFor_eForComposedDoc:
        root::nsGenericHTMLElement_PresContextFor = 0;
    pub const nsGenericHTMLElement_PresContextFor_eForUncomposedDoc:
        root::nsGenericHTMLElement_PresContextFor = 1;
    #[doc = " Get the presentation context for this content node."]
    #[doc = " @return the presentation context"]
    pub type nsGenericHTMLElement_PresContextFor = u32;
    pub const nsGenericHTMLElement_ContentEditableTristate_eInherit:
        root::nsGenericHTMLElement_ContentEditableTristate = -1;
    pub const nsGenericHTMLElement_ContentEditableTristate_eFalse:
        root::nsGenericHTMLElement_ContentEditableTristate = 0;
    pub const nsGenericHTMLElement_ContentEditableTristate_eTrue:
        root::nsGenericHTMLElement_ContentEditableTristate = 1;
    pub type nsGenericHTMLElement_ContentEditableTristate = i32;
    extern "C" {
        #[link_name = "\u{1}_ZN20nsGenericHTMLElement19sCommonAttributeMapE"]
        pub static mut nsGenericHTMLElement_sCommonAttributeMap:
            [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN20nsGenericHTMLElement28sImageMarginSizeAttributeMapE"]
        pub static mut nsGenericHTMLElement_sImageMarginSizeAttributeMap:
            [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN20nsGenericHTMLElement24sImageBorderAttributeMapE"]
        pub static mut nsGenericHTMLElement_sImageBorderAttributeMap:
            [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN20nsGenericHTMLElement23sImageAlignAttributeMapE"]
        pub static mut nsGenericHTMLElement_sImageAlignAttributeMap:
            [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN20nsGenericHTMLElement21sDivAlignAttributeMapE"]
        pub static mut nsGenericHTMLElement_sDivAlignAttributeMap:
            [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN20nsGenericHTMLElement23sBackgroundAttributeMapE"]
        pub static mut nsGenericHTMLElement_sBackgroundAttributeMap:
            [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN20nsGenericHTMLElement28sBackgroundColorAttributeMapE"]
        pub static mut nsGenericHTMLElement_sBackgroundColorAttributeMap:
            [root::mozilla::dom::Element_MappedAttributeEntry; 0usize];
    }
    #[test]
    fn bindgen_test_layout_nsGenericHTMLElement() {
        assert_eq!(
            ::std::mem::size_of::<nsGenericHTMLElement>(),
            128usize,
            concat!("Size of: ", stringify!(nsGenericHTMLElement))
        );
        assert_eq!(
            ::std::mem::align_of::<nsGenericHTMLElement>(),
            8usize,
            concat!("Alignment of ", stringify!(nsGenericHTMLElement))
        );
    }
    #[doc = " templated hashtable class maps keys to interface pointers."]
    #[doc = " See nsBaseHashtable for complete declaration."]
    #[doc = " @param KeyClass a wrapper-class for the hashtable key, see nsHashKeys.h"]
    #[doc = "   for a complete specification."]
    #[doc = " @param Interface the interface-type being wrapped"]
    #[doc = " @see nsDataHashtable, nsClassHashtable"]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsInterfaceHashtable {
        pub _address: u8,
    }
    pub type nsInterfaceHashtable_KeyType = [u8; 0usize];
    pub type nsInterfaceHashtable_UserDataType<Interface> = *mut Interface;
    pub type nsInterfaceHashtable_base_type = u8;
    pub type nsBindingList = root::nsTArray<root::RefPtr<root::nsXBLBinding>>;
    #[repr(C)]
    pub struct nsBindingManager {
        pub _base: root::nsStubMutationObserver,
        pub mRefCnt: root::nsCycleCollectingAutoRefCnt,
        pub mBoundContentSet: u64,
        pub mWrapperTable: root::nsAutoPtr<root::nsBindingManager_WrapperHashtable>,
        pub mDocumentTable: u64,
        pub mLoadingDocTable: u64,
        pub mAttachedStack: root::nsBindingList,
        pub mProcessingAttachedStack: bool,
        pub mDestroyed: bool,
        pub mAttachedStackSizeOnOutermost: u32,
        pub mProcessAttachedQueueEvent: u64,
        pub mDocument: *mut root::mozilla::dom::Document,
    }
    pub type nsBindingManager_HasThreadSafeRefCnt = root::mozilla::FalseType;
    pub const nsBindingManager_DestructorHandling_eRunDtor:
        root::nsBindingManager_DestructorHandling = 0;
    pub const nsBindingManager_DestructorHandling_eDoNotRunDtor:
        root::nsBindingManager_DestructorHandling = 1;
    #[doc = " Notify the binding manager that an element"]
    #[doc = " has been removed from its document,"]
    #[doc = " so that it can update any bindings or"]
    #[doc = " nsIAnonymousContentCreator-created anonymous"]
    #[doc = " content that may depend on the document."]
    #[doc = " @param aContent the element that\'s being moved"]
    #[doc = " @param aOldDocument the old document in which the"]
    #[doc = "   content resided."]
    #[doc = " @param aDestructorHandling whether or not to run the possible XBL"]
    #[doc = "        destructor."]
    pub type nsBindingManager_DestructorHandling = u32;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsBindingManager_cycleCollection {
        pub _base: root::nsXPCOMCycleCollectionParticipant,
    }
    #[test]
    fn bindgen_test_layout_nsBindingManager_cycleCollection() {
        assert_eq!(
            ::std::mem::size_of::<nsBindingManager_cycleCollection>(),
            16usize,
            concat!("Size of: ", stringify!(nsBindingManager_cycleCollection))
        );
        assert_eq!(
            ::std::mem::align_of::<nsBindingManager_cycleCollection>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(nsBindingManager_cycleCollection)
            )
        );
    }
    pub type nsBindingManager_WrapperHashtable = u8;
    extern "C" {
        #[link_name = "\u{1}_ZN16nsBindingManager21_cycleCollectorGlobalE"]
        pub static mut nsBindingManager__cycleCollectorGlobal:
            root::nsBindingManager_cycleCollection;
    }
    #[test]
    fn bindgen_test_layout_nsBindingManager() {
        assert_eq!(
            ::std::mem::size_of::<nsBindingManager>(),
            80usize,
            concat!("Size of: ", stringify!(nsBindingManager))
        );
        assert_eq!(
            ::std::mem::align_of::<nsBindingManager>(),
            8usize,
            concat!("Alignment of ", stringify!(nsBindingManager))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsBindingManager>())).mRefCnt as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsBindingManager),
                "::",
                stringify!(mRefCnt)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsBindingManager>())).mBoundContentSet as *const _ as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsBindingManager),
                "::",
                stringify!(mBoundContentSet)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsBindingManager>())).mWrapperTable as *const _ as usize
            },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsBindingManager),
                "::",
                stringify!(mWrapperTable)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsBindingManager>())).mDocumentTable as *const _ as usize
            },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsBindingManager),
                "::",
                stringify!(mDocumentTable)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsBindingManager>())).mLoadingDocTable as *const _ as usize
            },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsBindingManager),
                "::",
                stringify!(mLoadingDocTable)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsBindingManager>())).mAttachedStack as *const _ as usize
            },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(nsBindingManager),
                "::",
                stringify!(mAttachedStack)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsBindingManager>())).mProcessingAttachedStack as *const _
                    as usize
            },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(nsBindingManager),
                "::",
                stringify!(mProcessingAttachedStack)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsBindingManager>())).mDestroyed as *const _ as usize },
            57usize,
            concat!(
                "Offset of field: ",
                stringify!(nsBindingManager),
                "::",
                stringify!(mDestroyed)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsBindingManager>())).mAttachedStackSizeOnOutermost
                    as *const _ as usize
            },
            60usize,
            concat!(
                "Offset of field: ",
                stringify!(nsBindingManager),
                "::",
                stringify!(mAttachedStackSizeOnOutermost)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsBindingManager>())).mProcessAttachedQueueEvent as *const _
                    as usize
            },
            64usize,
            concat!(
                "Offset of field: ",
                stringify!(nsBindingManager),
                "::",
                stringify!(mProcessAttachedQueueEvent)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsBindingManager>())).mDocument as *const _ as usize },
            72usize,
            concat!(
                "Offset of field: ",
                stringify!(nsBindingManager),
                "::",
                stringify!(mDocument)
            )
        );
    }
    extern "C" {
        pub fn Gecko_ComputedStyle_Destroy(arg1: *mut root::mozilla::ComputedStyle);
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsBoundingMetrics {
        #[doc = ""]
        pub leftBearing: root::nscoord,
        pub rightBearing: root::nscoord,
        pub ascent: root::nscoord,
        pub descent: root::nscoord,
        pub width: root::nscoord,
    }
    #[test]
    fn bindgen_test_layout_nsBoundingMetrics() {
        assert_eq!(
            ::std::mem::size_of::<nsBoundingMetrics>(),
            20usize,
            concat!("Size of: ", stringify!(nsBoundingMetrics))
        );
        assert_eq!(
            ::std::mem::align_of::<nsBoundingMetrics>(),
            4usize,
            concat!("Alignment of ", stringify!(nsBoundingMetrics))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsBoundingMetrics>())).leftBearing as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsBoundingMetrics),
                "::",
                stringify!(leftBearing)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsBoundingMetrics>())).rightBearing as *const _ as usize
            },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsBoundingMetrics),
                "::",
                stringify!(rightBearing)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsBoundingMetrics>())).ascent as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsBoundingMetrics),
                "::",
                stringify!(ascent)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsBoundingMetrics>())).descent as *const _ as usize },
            12usize,
            concat!(
                "Offset of field: ",
                stringify!(nsBoundingMetrics),
                "::",
                stringify!(descent)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsBoundingMetrics>())).width as *const _ as usize },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsBoundingMetrics),
                "::",
                stringify!(width)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsOverflowAreas {
        pub mRects: [root::nsRect; 2usize],
    }
    #[test]
    fn bindgen_test_layout_nsOverflowAreas() {
        assert_eq!(
            ::std::mem::size_of::<nsOverflowAreas>(),
            32usize,
            concat!("Size of: ", stringify!(nsOverflowAreas))
        );
        assert_eq!(
            ::std::mem::align_of::<nsOverflowAreas>(),
            4usize,
            concat!("Alignment of ", stringify!(nsOverflowAreas))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsOverflowAreas>())).mRects as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsOverflowAreas),
                "::",
                stringify!(mRects)
            )
        );
    }
    #[doc = " An nsCollapsingMargin represents a vertical collapsing margin between"]
    #[doc = " blocks as described in section 8.3.1 of CSS2,"]
    #[doc = " <URL: http://www.w3.org/TR/REC-CSS2/box.html#collapsing-margins >."]
    #[doc = ""]
    #[doc = " All adjacent vertical margins collapse, and the resulting margin is"]
    #[doc = " the sum of the largest positive margin included and the smallest (most"]
    #[doc = " negative) negative margin included."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsCollapsingMargin {
        pub mMostPos: root::nscoord,
        pub mMostNeg: root::nscoord,
    }
    #[test]
    fn bindgen_test_layout_nsCollapsingMargin() {
        assert_eq!(
            ::std::mem::size_of::<nsCollapsingMargin>(),
            8usize,
            concat!("Size of: ", stringify!(nsCollapsingMargin))
        );
        assert_eq!(
            ::std::mem::align_of::<nsCollapsingMargin>(),
            4usize,
            concat!("Alignment of ", stringify!(nsCollapsingMargin))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsCollapsingMargin>())).mMostPos as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCollapsingMargin),
                "::",
                stringify!(mMostPos)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsCollapsingMargin>())).mMostNeg as *const _ as usize },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCollapsingMargin),
                "::",
                stringify!(mMostNeg)
            )
        );
    }
    extern "C" {
        pub fn Servo_ResolveLogicalProperty(
            arg1: root::nsCSSPropertyID,
            arg2: *const root::mozilla::ComputedStyle,
        ) -> root::nsCSSPropertyID;
    }
    extern "C" {
        pub fn Servo_Property_LookupEnabledForAllContent(
            arg1: *const ::gecko_bindings::structs::nsACString,
        ) -> root::nsCSSPropertyID;
    }
    extern "C" {
        pub fn Servo_Property_GetName(arg1: root::nsCSSPropertyID, aLength: *mut u32) -> *const u8;
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsCSSKTableEntry {
        pub mKeyword: root::nsCSSKeyword,
        pub mValue: i16,
    }
    #[test]
    fn bindgen_test_layout_nsCSSKTableEntry() {
        assert_eq!(
            ::std::mem::size_of::<nsCSSKTableEntry>(),
            4usize,
            concat!("Size of: ", stringify!(nsCSSKTableEntry))
        );
        assert_eq!(
            ::std::mem::align_of::<nsCSSKTableEntry>(),
            2usize,
            concat!("Alignment of ", stringify!(nsCSSKTableEntry))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsCSSKTableEntry>())).mKeyword as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCSSKTableEntry),
                "::",
                stringify!(mKeyword)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsCSSKTableEntry>())).mValue as *const _ as usize },
            2usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCSSKTableEntry),
                "::",
                stringify!(mValue)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsCSSProps {
        pub _address: u8,
    }
    pub use self::super::root::mozilla::CSSEnabledState as nsCSSProps_EnabledState;
    pub use self::super::root::mozilla::CSSPropFlags as nsCSSProps_Flags;
    pub type nsCSSProps_KTableEntry = root::nsCSSKTableEntry;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsCSSProps_PropertyPref {
        pub mPropID: root::nsCSSPropertyID,
        pub mPref: *const ::std::os::raw::c_char,
    }
    #[test]
    fn bindgen_test_layout_nsCSSProps_PropertyPref() {
        assert_eq!(
            ::std::mem::size_of::<nsCSSProps_PropertyPref>(),
            16usize,
            concat!("Size of: ", stringify!(nsCSSProps_PropertyPref))
        );
        assert_eq!(
            ::std::mem::align_of::<nsCSSProps_PropertyPref>(),
            8usize,
            concat!("Alignment of ", stringify!(nsCSSProps_PropertyPref))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsCSSProps_PropertyPref>())).mPropID as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCSSProps_PropertyPref),
                "::",
                stringify!(mPropID)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsCSSProps_PropertyPref>())).mPref as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCSSProps_PropertyPref),
                "::",
                stringify!(mPref)
            )
        );
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps11kFlagsTableE"]
        pub static mut nsCSSProps_kFlagsTable: [root::nsCSSProps_Flags; 424usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps17kSubpropertyTableE"]
        pub static mut nsCSSProps_kSubpropertyTable: [*const root::nsCSSPropertyID; 71usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps16gPropertyEnabledE"]
        pub static mut nsCSSProps_gPropertyEnabled: [bool; 543usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps13kIDLNameTableE"]
        pub static mut nsCSSProps_kIDLNameTable: [*const ::std::os::raw::c_char; 424usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps25kIDLNameSortPositionTableE"]
        pub static mut nsCSSProps_kIDLNameSortPositionTable: [i32; 424usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps19gPropertyUseCounterE"]
        pub static mut nsCSSProps_gPropertyUseCounter: [root::mozilla::UseCounter; 353usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps18kPropertyPrefTableE"]
        pub static mut nsCSSProps_kPropertyPrefTable: [root::nsCSSProps_PropertyPref; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps18kShapeRadiusKTableE"]
        pub static mut nsCSSProps_kShapeRadiusKTable: [root::nsCSSProps_KTableEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps21kFilterFunctionKTableE"]
        pub static mut nsCSSProps_kFilterFunctionKTable: [root::nsCSSProps_KTableEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps20kBoxShadowTypeKTableE"]
        pub static mut nsCSSProps_kBoxShadowTypeKTable: [root::nsCSSProps_KTableEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps13kCursorKTableE"]
        pub static mut nsCSSProps_kCursorKTable: [root::nsCSSProps_KTableEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps14kDisplayKTableE"]
        pub static mut nsCSSProps_kDisplayKTable: [root::nsCSSProps_KTableEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps31kAutoCompletionAlignJustifySelfE"]
        pub static mut nsCSSProps_kAutoCompletionAlignJustifySelf:
            [root::nsCSSProps_KTableEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps25kAutoCompletionAlignItemsE"]
        pub static mut nsCSSProps_kAutoCompletionAlignItems: [root::nsCSSProps_KTableEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps34kAutoCompletionAlignJustifyContentE"]
        pub static mut nsCSSProps_kAutoCompletionAlignJustifyContent:
            [root::nsCSSProps_KTableEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps20kFontSmoothingKTableE"]
        pub static mut nsCSSProps_kFontSmoothingKTable: [root::nsCSSProps_KTableEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps19kGridAutoFlowKTableE"]
        pub static mut nsCSSProps_kGridAutoFlowKTable: [root::nsCSSProps_KTableEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps23kGridTrackBreadthKTableE"]
        pub static mut nsCSSProps_kGridTrackBreadthKTable: [root::nsCSSProps_KTableEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps17kLineHeightKTableE"]
        pub static mut nsCSSProps_kLineHeightKTable: [root::nsCSSProps_KTableEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps16kTextAlignKTableE"]
        pub static mut nsCSSProps_kTextAlignKTable: [root::nsCSSProps_KTableEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps26kTextDecorationStyleKTableE"]
        pub static mut nsCSSProps_kTextDecorationStyleKTable:
            [root::nsCSSProps_KTableEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps29kTextEmphasisStyleShapeKTableE"]
        pub static mut nsCSSProps_kTextEmphasisStyleShapeKTable:
            [root::nsCSSProps_KTableEntry; 0usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN10nsCSSProps19kTextOverflowKTableE"]
        pub static mut nsCSSProps_kTextOverflowKTable: [root::nsCSSProps_KTableEntry; 0usize];
    }
    #[test]
    fn bindgen_test_layout_nsCSSProps() {
        assert_eq!(
            ::std::mem::size_of::<nsCSSProps>(),
            1usize,
            concat!("Size of: ", stringify!(nsCSSProps))
        );
        assert_eq!(
            ::std::mem::align_of::<nsCSSProps>(),
            1usize,
            concat!("Alignment of ", stringify!(nsCSSProps))
        );
    }
    #[doc = " nsCSSPropertyIDSet maintains a set of non-shorthand CSS properties.  In"]
    #[doc = " other words, for each longhand CSS property we support, it has a bit"]
    #[doc = " for whether that property is in the set."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsCSSPropertyIDSet {
        pub mProperties: [root::nsCSSPropertyIDSet_property_set_type; 6usize],
    }
    pub type nsCSSPropertyIDSet_property_set_type = ::std::os::raw::c_ulong;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsCSSPropertyIDSet_Iterator {
        pub mPropertySet: *const root::nsCSSPropertyIDSet,
        pub mChunk: usize,
        pub mBit: usize,
    }
    #[test]
    fn bindgen_test_layout_nsCSSPropertyIDSet_Iterator() {
        assert_eq!(
            ::std::mem::size_of::<nsCSSPropertyIDSet_Iterator>(),
            24usize,
            concat!("Size of: ", stringify!(nsCSSPropertyIDSet_Iterator))
        );
        assert_eq!(
            ::std::mem::align_of::<nsCSSPropertyIDSet_Iterator>(),
            8usize,
            concat!("Alignment of ", stringify!(nsCSSPropertyIDSet_Iterator))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsCSSPropertyIDSet_Iterator>())).mPropertySet as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCSSPropertyIDSet_Iterator),
                "::",
                stringify!(mPropertySet)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsCSSPropertyIDSet_Iterator>())).mChunk as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCSSPropertyIDSet_Iterator),
                "::",
                stringify!(mChunk)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsCSSPropertyIDSet_Iterator>())).mBit as *const _ as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCSSPropertyIDSet_Iterator),
                "::",
                stringify!(mBit)
            )
        );
    }
    pub const nsCSSPropertyIDSet_kBitsInChunk: usize = 64;
    pub const nsCSSPropertyIDSet_kChunkCount: usize = 6;
    #[test]
    fn bindgen_test_layout_nsCSSPropertyIDSet() {
        assert_eq!(
            ::std::mem::size_of::<nsCSSPropertyIDSet>(),
            48usize,
            concat!("Size of: ", stringify!(nsCSSPropertyIDSet))
        );
        assert_eq!(
            ::std::mem::align_of::<nsCSSPropertyIDSet>(),
            8usize,
            concat!("Alignment of ", stringify!(nsCSSPropertyIDSet))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsCSSPropertyIDSet>())).mProperties as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsCSSPropertyIDSet),
                "::",
                stringify!(mProperties)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct imgIContainer {
        pub _base: root::nsISupports,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct imgIContainer_COMTypeInfo {
        pub _address: u8,
    }
    pub const imgIContainer_TYPE_RASTER: root::imgIContainer__bindgen_ty_1 = 0;
    pub const imgIContainer_TYPE_VECTOR: root::imgIContainer__bindgen_ty_1 = 1;
    pub type imgIContainer__bindgen_ty_1 = u32;
    pub const imgIContainer_FLAG_NONE: root::imgIContainer__bindgen_ty_2 = 0;
    pub const imgIContainer_FLAG_SYNC_DECODE: root::imgIContainer__bindgen_ty_2 = 1;
    pub const imgIContainer_FLAG_SYNC_DECODE_IF_FAST: root::imgIContainer__bindgen_ty_2 = 2;
    pub const imgIContainer_FLAG_ASYNC_NOTIFY: root::imgIContainer__bindgen_ty_2 = 4;
    pub const imgIContainer_FLAG_DECODE_NO_PREMULTIPLY_ALPHA: root::imgIContainer__bindgen_ty_2 = 8;
    pub const imgIContainer_FLAG_DECODE_NO_COLORSPACE_CONVERSION:
        root::imgIContainer__bindgen_ty_2 = 16;
    pub const imgIContainer_FLAG_CLAMP: root::imgIContainer__bindgen_ty_2 = 32;
    pub const imgIContainer_FLAG_HIGH_QUALITY_SCALING: root::imgIContainer__bindgen_ty_2 = 64;
    pub const imgIContainer_FLAG_WANT_DATA_SURFACE: root::imgIContainer__bindgen_ty_2 = 128;
    pub const imgIContainer_FLAG_BYPASS_SURFACE_CACHE: root::imgIContainer__bindgen_ty_2 = 256;
    pub const imgIContainer_FLAG_FORCE_PRESERVEASPECTRATIO_NONE: root::imgIContainer__bindgen_ty_2 =
        512;
    pub const imgIContainer_FLAG_FORCE_UNIFORM_SCALING: root::imgIContainer__bindgen_ty_2 = 1024;
    pub const imgIContainer_FLAG_AVOID_REDECODE_FOR_SIZE: root::imgIContainer__bindgen_ty_2 = 2048;
    pub const imgIContainer_DECODE_FLAGS_DEFAULT: root::imgIContainer__bindgen_ty_2 = 0;
    pub const imgIContainer_FRAME_FIRST: root::imgIContainer__bindgen_ty_2 = 0;
    pub const imgIContainer_FRAME_CURRENT: root::imgIContainer__bindgen_ty_2 = 1;
    pub const imgIContainer_FRAME_MAX_VALUE: root::imgIContainer__bindgen_ty_2 = 1;
    pub type imgIContainer__bindgen_ty_2 = u32;
    pub const imgIContainer_kNormalAnimMode: root::imgIContainer__bindgen_ty_3 = 0;
    pub const imgIContainer_kDontAnimMode: root::imgIContainer__bindgen_ty_3 = 1;
    pub const imgIContainer_kLoopOnceAnimMode: root::imgIContainer__bindgen_ty_3 = 2;
    pub type imgIContainer__bindgen_ty_3 = u32;
    #[test]
    fn bindgen_test_layout_imgIContainer() {
        assert_eq!(
            ::std::mem::size_of::<imgIContainer>(),
            8usize,
            concat!("Size of: ", stringify!(imgIContainer))
        );
        assert_eq!(
            ::std::mem::align_of::<imgIContainer>(),
            8usize,
            concat!("Alignment of ", stringify!(imgIContainer))
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsDisplayItemBase {
        _unused: [u8; 0],
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsLineList_iterator {
        _unused: [u8; 0],
    }
    #[doc = " A frame in the layout model. This interface is supported by all frame"]
    #[doc = " objects."]
    #[doc = ""]
    #[doc = " Frames can have multiple child lists: the default child list"]
    #[doc = " (referred to as the <i>principal</i> child list, and additional named"]
    #[doc = " child lists. There is an ordering of frames within a child list, but"]
    #[doc = " there is no order defined between frames in different child lists of"]
    #[doc = " the same parent frame."]
    #[doc = ""]
    #[doc = " Frames are NOT reference counted. Use the Destroy() member function"]
    #[doc = " to destroy a frame. The lifetime of the frame hierarchy is bounded by the"]
    #[doc = " lifetime of the presentation shell which owns the frames."]
    #[doc = ""]
    #[doc = " nsIFrame is a private Gecko interface. If you are not Gecko then you"]
    #[doc = " should not use it. If you\'re not in layout, then you won\'t be able to"]
    #[doc = " link to many of the functions defined here. Too bad."]
    #[doc = ""]
    #[doc = " If you\'re not in layout but you must call functions in here, at least"]
    #[doc = " restrict yourself to calling virtual methods, which won\'t hurt you as badly."]
    #[repr(C)]
    pub struct nsIFrame {
        pub _base: root::nsQueryFrame,
        pub mRect: root::nsRect,
        pub mContent: root::nsCOMPtr,
        pub mComputedStyle: root::RefPtr<root::nsIFrame_ComputedStyle>,
        pub mPresContext: *mut root::nsPresContext,
        pub mParent: *mut root::nsContainerFrame,
        pub mNextSibling: *mut root::nsIFrame,
        pub mPrevSibling: *mut root::nsIFrame,
        pub mDisplayItemData: root::nsIFrame_DisplayItemDataArray,
        pub mState: root::nsFrameState,
        #[doc = " List of properties attached to the frame."]
        pub mProperties: root::nsIFrame_FrameProperties,
        pub mOverflow: root::nsIFrame__bindgen_ty_8,
        #[doc = " @see GetWritingMode()"]
        pub mWritingMode: root::mozilla::WritingMode,
        #[doc = " The ClassID of the concrete class of this instance."]
        pub mClass: root::nsIFrame_ClassID,
        pub _bitfield_1: root::__BindgenBitfieldUnit<[u8; 2usize], u8>,
    }
    pub use self::super::root::mozilla::AlignmentContext as nsIFrame_AlignmentContext;
    pub use self::super::root::mozilla::BaselineSharingGroup as nsIFrame_BaselineSharingGroup;
    pub type nsIFrame_Maybe = u8;
    pub type nsIFrame_Nothing = root::mozilla::Nothing;
    pub use self::super::root::mozilla::OnNonvisible as nsIFrame_OnNonvisible;
    pub type nsIFrame_PropertyDescriptor = *const root::mozilla::FramePropertyDescriptor;
    pub type nsIFrame_ReflowInput = root::mozilla::ReflowInput;
    pub type nsIFrame_ReflowOutput = root::mozilla::ReflowOutput;
    pub use self::super::root::mozilla::Visibility as nsIFrame_Visibility;
    pub type nsIFrame_StyleFlexBasis = root::mozilla::StyleFlexBasis;
    pub type nsIFrame_StyleSize = root::mozilla::StyleSize;
    pub type nsIFrame_LengthPercentage = root::mozilla::LengthPercentage;
    pub use self::super::root::mozilla::StyleExtremumLength as nsIFrame_StyleExtremumLength;
    pub type nsIFrame_ComputedStyle = root::mozilla::ComputedStyle;
    pub type nsIFrame_FrameProperties = root::mozilla::FrameProperties;
    pub type nsIFrame_Layer = root::mozilla::layers::Layer;
    pub type nsIFrame_LayerManager = root::mozilla::layers::LayerManager;
    pub type nsIFrame_ChildList = root::mozilla::layout::FrameChildList;
    pub use self::super::root::mozilla::layout::FrameChildListID as nsIFrame_ChildListID;
    pub type nsIFrame_ChildListIDs = root::mozilla::layout::FrameChildListIDs;
    pub type nsIFrame_ChildListIterator = root::mozilla::layout::FrameChildListIterator;
    pub type nsIFrame_ChildListArrayIterator = root::mozilla::layout::FrameChildListArrayIterator;
    pub type nsIFrame_DrawTarget = root::mozilla::gfx::DrawTarget;
    pub type nsIFrame_Matrix = root::mozilla::gfx::Matrix;
    pub type nsIFrame_Matrix4x4 = root::mozilla::gfx::Matrix4x4;
    pub type nsIFrame_Matrix4x4Flagged = root::mozilla::gfx::Matrix4x4Flagged;
    pub type nsIFrame_Sides = root::mozilla::Sides;
    pub type nsIFrame_LogicalSides = root::mozilla::LogicalSides;
    pub type nsIFrame_DisplayItemDataArray = [u64; 2usize];
    pub use self::super::root::nsQueryFrame_ClassID as nsIFrame_ClassID;
    pub type nsIFrame_Has_NS_DECL_QUERYFRAME_TARGET = root::nsIFrame;
    pub type nsIFrame_PostDestroyData = root::mozilla::layout::PostFrameDestroyData;
    #[repr(C)]
    pub struct nsIFrame_AutoPostDestroyData {
        pub mPresContext: *mut root::nsPresContext,
        pub mData: root::nsIFrame_PostDestroyData,
    }
    #[test]
    fn bindgen_test_layout_nsIFrame_AutoPostDestroyData() {
        assert_eq!(
            ::std::mem::size_of::<nsIFrame_AutoPostDestroyData>(),
            824usize,
            concat!("Size of: ", stringify!(nsIFrame_AutoPostDestroyData))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIFrame_AutoPostDestroyData>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIFrame_AutoPostDestroyData))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_AutoPostDestroyData>())).mPresContext as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_AutoPostDestroyData),
                "::",
                stringify!(mPresContext)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_AutoPostDestroyData>())).mData as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_AutoPostDestroyData),
                "::",
                stringify!(mData)
            )
        );
    }
    pub const nsIFrame_FrameSearchResult_FOUND: root::nsIFrame_FrameSearchResult = 0;
    pub const nsIFrame_FrameSearchResult_CONTINUE: root::nsIFrame_FrameSearchResult = 1;
    pub const nsIFrame_FrameSearchResult_CONTINUE_EMPTY: root::nsIFrame_FrameSearchResult = 3;
    pub const nsIFrame_FrameSearchResult_CONTINUE_UNSELECTABLE: root::nsIFrame_FrameSearchResult =
        5;
    #[doc = " Flags for PeekOffsetCharacter, PeekOffsetNoAmount, PeekOffsetWord return"]
    #[doc = " values."]
    pub type nsIFrame_FrameSearchResult = u32;
    #[doc = " Options for PeekOffsetCharacter()."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIFrame_PeekOffsetCharacterOptions {
        pub mRespectClusters: bool,
        pub mIgnoreUserStyleAll: bool,
    }
    #[test]
    fn bindgen_test_layout_nsIFrame_PeekOffsetCharacterOptions() {
        assert_eq!(
            ::std::mem::size_of::<nsIFrame_PeekOffsetCharacterOptions>(),
            2usize,
            concat!("Size of: ", stringify!(nsIFrame_PeekOffsetCharacterOptions))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIFrame_PeekOffsetCharacterOptions>(),
            1usize,
            concat!(
                "Alignment of ",
                stringify!(nsIFrame_PeekOffsetCharacterOptions)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_PeekOffsetCharacterOptions>())).mRespectClusters
                    as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_PeekOffsetCharacterOptions),
                "::",
                stringify!(mRespectClusters)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_PeekOffsetCharacterOptions>())).mIgnoreUserStyleAll
                    as *const _ as usize
            },
            1usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_PeekOffsetCharacterOptions),
                "::",
                stringify!(mIgnoreUserStyleAll)
            )
        );
    }
    pub type nsIFrame_DisplayItemArray = [u64; 6usize];
    pub const nsIFrame_DISPLAY_CHILD_FORCE_PSEUDO_STACKING_CONTEXT: root::nsIFrame__bindgen_ty_1 =
        1;
    pub const nsIFrame_DISPLAY_CHILD_FORCE_STACKING_CONTEXT: root::nsIFrame__bindgen_ty_1 = 2;
    pub const nsIFrame_DISPLAY_CHILD_INLINE: root::nsIFrame__bindgen_ty_1 = 4;
    pub type nsIFrame__bindgen_ty_1 = u32;
    #[repr(C)]
    pub struct nsIFrame_ContentOffsets {
        pub content: root::nsCOMPtr,
        pub offset: i32,
        pub secondaryOffset: i32,
        pub associate: root::mozilla::CaretAssociationHint,
    }
    #[test]
    fn bindgen_test_layout_nsIFrame_ContentOffsets() {
        assert_eq!(
            ::std::mem::size_of::<nsIFrame_ContentOffsets>(),
            24usize,
            concat!("Size of: ", stringify!(nsIFrame_ContentOffsets))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIFrame_ContentOffsets>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIFrame_ContentOffsets))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_ContentOffsets>())).content as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_ContentOffsets),
                "::",
                stringify!(content)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_ContentOffsets>())).offset as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_ContentOffsets),
                "::",
                stringify!(offset)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_ContentOffsets>())).secondaryOffset as *const _
                    as usize
            },
            12usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_ContentOffsets),
                "::",
                stringify!(secondaryOffset)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_ContentOffsets>())).associate as *const _ as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_ContentOffsets),
                "::",
                stringify!(associate)
            )
        );
    }
    pub const nsIFrame_IGNORE_SELECTION_STYLE: root::nsIFrame__bindgen_ty_2 = 1;
    pub const nsIFrame_SKIP_HIDDEN: root::nsIFrame__bindgen_ty_2 = 2;
    pub type nsIFrame__bindgen_ty_2 = u32;
    pub const nsIFrame_AllowCustomCursorImage_No: root::nsIFrame_AllowCustomCursorImage = 0;
    pub const nsIFrame_AllowCustomCursorImage_Yes: root::nsIFrame_AllowCustomCursorImage = 1;
    pub type nsIFrame_AllowCustomCursorImage = i32;
    #[doc = " This structure holds information about a cursor. AllowCustomCursorImage"]
    #[doc = " is `No`, then no cursor image should be loaded from the style specified on"]
    #[doc = " `mStyle`, or the frame\'s style."]
    #[doc = ""]
    #[doc = " The `mStyle` member is used for `<area>` elements."]
    #[repr(C)]
    pub struct nsIFrame_Cursor {
        pub mCursor: root::mozilla::StyleCursorKind,
        pub mAllowCustomCursor: root::nsIFrame_AllowCustomCursorImage,
        pub mStyle: root::RefPtr<root::mozilla::ComputedStyle>,
    }
    #[test]
    fn bindgen_test_layout_nsIFrame_Cursor() {
        assert_eq!(
            ::std::mem::size_of::<nsIFrame_Cursor>(),
            16usize,
            concat!("Size of: ", stringify!(nsIFrame_Cursor))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIFrame_Cursor>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIFrame_Cursor))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIFrame_Cursor>())).mCursor as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_Cursor),
                "::",
                stringify!(mCursor)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_Cursor>())).mAllowCustomCursor as *const _ as usize
            },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_Cursor),
                "::",
                stringify!(mAllowCustomCursor)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIFrame_Cursor>())).mStyle as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_Cursor),
                "::",
                stringify!(mStyle)
            )
        );
    }
    #[doc = " |InlineIntrinsicISize| represents the intrinsic width information"]
    #[doc = " in inline layout.  Code that determines the intrinsic width of a"]
    #[doc = " region of inline layout accumulates the result into this structure."]
    #[doc = " This pattern is needed because we need to maintain state"]
    #[doc = " information about whitespace (for both collapsing and trimming)."]
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsIFrame_InlineIntrinsicISizeData {
        pub mLine: *const root::nsLineList_iterator,
        pub mLineContainer: *mut root::nsIFrame,
        pub mPrevLines: root::nscoord,
        pub mCurrentLine: root::nscoord,
        pub mTrailingWhitespace: root::nscoord,
        pub mSkipWhitespace: bool,
        pub mFloats: root::nsTArray<root::nsIFrame_InlineIntrinsicISizeData_FloatInfo>,
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIFrame_InlineIntrinsicISizeData_FloatInfo {
        pub mFrame: *const root::nsIFrame,
        pub mWidth: root::nscoord,
    }
    #[test]
    fn bindgen_test_layout_nsIFrame_InlineIntrinsicISizeData_FloatInfo() {
        assert_eq!(
            ::std::mem::size_of::<nsIFrame_InlineIntrinsicISizeData_FloatInfo>(),
            16usize,
            concat!(
                "Size of: ",
                stringify!(nsIFrame_InlineIntrinsicISizeData_FloatInfo)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<nsIFrame_InlineIntrinsicISizeData_FloatInfo>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(nsIFrame_InlineIntrinsicISizeData_FloatInfo)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_InlineIntrinsicISizeData_FloatInfo>())).mFrame
                    as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_InlineIntrinsicISizeData_FloatInfo),
                "::",
                stringify!(mFrame)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_InlineIntrinsicISizeData_FloatInfo>())).mWidth
                    as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_InlineIntrinsicISizeData_FloatInfo),
                "::",
                stringify!(mWidth)
            )
        );
    }
    #[test]
    fn bindgen_test_layout_nsIFrame_InlineIntrinsicISizeData() {
        assert_eq!(
            ::std::mem::size_of::<nsIFrame_InlineIntrinsicISizeData>(),
            40usize,
            concat!("Size of: ", stringify!(nsIFrame_InlineIntrinsicISizeData))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIFrame_InlineIntrinsicISizeData>(),
            8usize,
            concat!(
                "Alignment of ",
                stringify!(nsIFrame_InlineIntrinsicISizeData)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_InlineIntrinsicISizeData>())).mLine as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_InlineIntrinsicISizeData),
                "::",
                stringify!(mLine)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_InlineIntrinsicISizeData>())).mLineContainer
                    as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_InlineIntrinsicISizeData),
                "::",
                stringify!(mLineContainer)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_InlineIntrinsicISizeData>())).mPrevLines as *const _
                    as usize
            },
            16usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_InlineIntrinsicISizeData),
                "::",
                stringify!(mPrevLines)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_InlineIntrinsicISizeData>())).mCurrentLine
                    as *const _ as usize
            },
            20usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_InlineIntrinsicISizeData),
                "::",
                stringify!(mCurrentLine)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_InlineIntrinsicISizeData>())).mTrailingWhitespace
                    as *const _ as usize
            },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_InlineIntrinsicISizeData),
                "::",
                stringify!(mTrailingWhitespace)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_InlineIntrinsicISizeData>())).mSkipWhitespace
                    as *const _ as usize
            },
            28usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_InlineIntrinsicISizeData),
                "::",
                stringify!(mSkipWhitespace)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_InlineIntrinsicISizeData>())).mFloats as *const _
                    as usize
            },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_InlineIntrinsicISizeData),
                "::",
                stringify!(mFloats)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsIFrame_InlineMinISizeData {
        pub _base: root::nsIFrame_InlineIntrinsicISizeData,
        pub mAtStartOfLine: bool,
    }
    #[test]
    fn bindgen_test_layout_nsIFrame_InlineMinISizeData() {
        assert_eq!(
            ::std::mem::size_of::<nsIFrame_InlineMinISizeData>(),
            48usize,
            concat!("Size of: ", stringify!(nsIFrame_InlineMinISizeData))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIFrame_InlineMinISizeData>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIFrame_InlineMinISizeData))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_InlineMinISizeData>())).mAtStartOfLine as *const _
                    as usize
            },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_InlineMinISizeData),
                "::",
                stringify!(mAtStartOfLine)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct nsIFrame_InlinePrefISizeData {
        pub _base: root::nsIFrame_InlineIntrinsicISizeData,
        pub mLineIsEmpty: bool,
    }
    pub use self::super::root::mozilla::StyleClear as nsIFrame_InlinePrefISizeData_StyleClear;
    #[test]
    fn bindgen_test_layout_nsIFrame_InlinePrefISizeData() {
        assert_eq!(
            ::std::mem::size_of::<nsIFrame_InlinePrefISizeData>(),
            48usize,
            concat!("Size of: ", stringify!(nsIFrame_InlinePrefISizeData))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIFrame_InlinePrefISizeData>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIFrame_InlinePrefISizeData))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_InlinePrefISizeData>())).mLineIsEmpty as *const _
                    as usize
            },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_InlinePrefISizeData),
                "::",
                stringify!(mLineIsEmpty)
            )
        );
    }
    #[doc = " Return the horizontal components of padding, border, and margin"]
    #[doc = " that contribute to the intrinsic width that applies to the parent."]
    #[doc = " @param aPercentageBasis the percentage basis to use for padding/margin -"]
    #[doc = "   i.e. the Containing Block\'s inline-size"]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIFrame_IntrinsicISizeOffsetData {
        pub hPadding: root::nscoord,
        pub hBorder: root::nscoord,
        pub hMargin: root::nscoord,
    }
    #[test]
    fn bindgen_test_layout_nsIFrame_IntrinsicISizeOffsetData() {
        assert_eq!(
            ::std::mem::size_of::<nsIFrame_IntrinsicISizeOffsetData>(),
            12usize,
            concat!("Size of: ", stringify!(nsIFrame_IntrinsicISizeOffsetData))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIFrame_IntrinsicISizeOffsetData>(),
            4usize,
            concat!(
                "Alignment of ",
                stringify!(nsIFrame_IntrinsicISizeOffsetData)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_IntrinsicISizeOffsetData>())).hPadding as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_IntrinsicISizeOffsetData),
                "::",
                stringify!(hPadding)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_IntrinsicISizeOffsetData>())).hBorder as *const _
                    as usize
            },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_IntrinsicISizeOffsetData),
                "::",
                stringify!(hBorder)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_IntrinsicISizeOffsetData>())).hMargin as *const _
                    as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_IntrinsicISizeOffsetData),
                "::",
                stringify!(hMargin)
            )
        );
    }
    pub const nsIFrame_ComputeSizeFlags_eDefault: root::nsIFrame_ComputeSizeFlags = 0;
    #[doc = " Set if the frame is in a context where non-replaced blocks should"]
    #[doc = " shrink-wrap (e.g., it\'s floating, absolutely positioned, or"]
    #[doc = " inline-block)."]
    pub const nsIFrame_ComputeSizeFlags_eShrinkWrap: root::nsIFrame_ComputeSizeFlags = 1;
    #[doc = " Set if we\'d like to compute our \'auto\' bsize, regardless of our actual"]
    #[doc = " corresponding computed value. (e.g. to get an intrinsic height for flex"]
    #[doc = " items with \"min-height: auto\" to use during flexbox layout.)"]
    pub const nsIFrame_ComputeSizeFlags_eUseAutoBSize: root::nsIFrame_ComputeSizeFlags = 2;
    #[doc = " Indicates that we should clamp the margin-box min-size to the given CB"]
    #[doc = " size.  This is used for implementing the grid area clamping here:"]
    #[doc = " https://drafts.csswg.org/css-grid/#min-size-auto"]
    pub const nsIFrame_ComputeSizeFlags_eIClampMarginBoxMinSize: root::nsIFrame_ComputeSizeFlags =
        4;
    #[doc = " Indicates that we should clamp the margin-box min-size to the given CB"]
    #[doc = " size.  This is used for implementing the grid area clamping here:"]
    #[doc = " https://drafts.csswg.org/css-grid/#min-size-auto"]
    pub const nsIFrame_ComputeSizeFlags_eBClampMarginBoxMinSize: root::nsIFrame_ComputeSizeFlags =
        8;
    #[doc = " The frame is stretching (per CSS Box Alignment) and doesn\'t have an"]
    #[doc = " Automatic Minimum Size in the indicated axis."]
    #[doc = " (may be used for both flex/grid items, but currently only used for Grid)"]
    #[doc = " https://drafts.csswg.org/css-grid/#min-size-auto"]
    #[doc = " https://drafts.csswg.org/css-align-3/#valdef-justify-self-stretch"]
    pub const nsIFrame_ComputeSizeFlags_eIApplyAutoMinSize: root::nsIFrame_ComputeSizeFlags = 16;
    #[doc = " Bit-flags to pass to ComputeSize in |aFlags| parameter."]
    pub type nsIFrame_ComputeSizeFlags = u32;
    #[doc = " Computes an approximation of the rendered text of the frame and its"]
    #[doc = " continuations. Returns nothing for non-text frames."]
    #[doc = " The appended text will often not contain all the whitespace from source,"]
    #[doc = " depending on CSS white-space processing."]
    #[doc = " if aEndOffset goes past end, use the text up to the string\'s end."]
    #[doc = " Call this on the primary frame for a text node."]
    #[doc = " aStartOffset and aEndOffset can be content offsets or offsets in the"]
    #[doc = " rendered text, depending on aOffsetType."]
    #[doc = " Returns a string, as well as offsets identifying the start of the text"]
    #[doc = " within the rendered text for the whole node, and within the text content"]
    #[doc = " of the node."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIFrame_RenderedText {
        pub mString: root::nsAutoString,
        pub mOffsetWithinNodeRenderedText: u32,
        pub mOffsetWithinNodeText: i32,
    }
    #[test]
    fn bindgen_test_layout_nsIFrame_RenderedText() {
        assert_eq!(
            ::std::mem::size_of::<nsIFrame_RenderedText>(),
            160usize,
            concat!("Size of: ", stringify!(nsIFrame_RenderedText))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIFrame_RenderedText>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIFrame_RenderedText))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_RenderedText>())).mString as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_RenderedText),
                "::",
                stringify!(mString)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_RenderedText>())).mOffsetWithinNodeRenderedText
                    as *const _ as usize
            },
            152usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_RenderedText),
                "::",
                stringify!(mOffsetWithinNodeRenderedText)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_RenderedText>())).mOffsetWithinNodeText as *const _
                    as usize
            },
            156usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_RenderedText),
                "::",
                stringify!(mOffsetWithinNodeText)
            )
        );
    }
    pub const nsIFrame_TextOffsetType_OffsetsInContentText: root::nsIFrame_TextOffsetType = 0;
    pub const nsIFrame_TextOffsetType_OffsetsInRenderedText: root::nsIFrame_TextOffsetType = 1;
    pub type nsIFrame_TextOffsetType = i32;
    pub const nsIFrame_TrailingWhitespace_Trim: root::nsIFrame_TrailingWhitespace = 0;
    pub const nsIFrame_TrailingWhitespace_DontTrim: root::nsIFrame_TrailingWhitespace = 1;
    pub type nsIFrame_TrailingWhitespace = i32;
    pub const nsIFrame_IN_CSS_UNITS: root::nsIFrame__bindgen_ty_3 = 1;
    pub const nsIFrame_STOP_AT_STACKING_CONTEXT_AND_DISPLAY_PORT: root::nsIFrame__bindgen_ty_3 = 2;
    #[doc = " Returns a transformation matrix that converts points in this frame\'s"]
    #[doc = " coordinate space to points in some ancestor frame\'s coordinate space."]
    #[doc = " The frame decides which ancestor it will use as a reference point."]
    #[doc = " If this frame has no ancestor, aOutAncestor will be set to null."]
    #[doc = ""]
    #[doc = " @param aStopAtAncestor don\'t look further than aStopAtAncestor. If null,"]
    #[doc = "   all ancestors (including across documents) will be traversed."]
    #[doc = " @param aOutAncestor [out] The ancestor frame the frame has chosen.  If"]
    #[doc = "   this frame has no ancestor, *aOutAncestor will be set to null. If"]
    #[doc = " this frame is not a root frame, then *aOutAncestor will be in the same"]
    #[doc = " document as this frame. If this frame IsTransformed(), then *aOutAncestor"]
    #[doc = " will be the parent frame (if not preserve-3d) or the nearest"]
    #[doc = " non-transformed ancestor (if preserve-3d)."]
    #[doc = " @return A Matrix4x4 that converts points in this frame\'s coordinate space"]
    #[doc = "   into points in aOutAncestor\'s coordinate space."]
    pub type nsIFrame__bindgen_ty_3 = u32;
    pub const nsIFrame_eMathML: root::nsIFrame__bindgen_ty_4 = 1;
    pub const nsIFrame_eSVG: root::nsIFrame__bindgen_ty_4 = 2;
    pub const nsIFrame_eSVGForeignObject: root::nsIFrame__bindgen_ty_4 = 4;
    pub const nsIFrame_eSVGContainer: root::nsIFrame__bindgen_ty_4 = 8;
    pub const nsIFrame_eSVGGeometry: root::nsIFrame__bindgen_ty_4 = 16;
    pub const nsIFrame_eSVGPaintServer: root::nsIFrame__bindgen_ty_4 = 32;
    pub const nsIFrame_eBidiInlineContainer: root::nsIFrame__bindgen_ty_4 = 64;
    pub const nsIFrame_eReplaced: root::nsIFrame__bindgen_ty_4 = 128;
    pub const nsIFrame_eReplacedContainsBlock: root::nsIFrame__bindgen_ty_4 = 256;
    pub const nsIFrame_eLineParticipant: root::nsIFrame__bindgen_ty_4 = 512;
    pub const nsIFrame_eXULBox: root::nsIFrame__bindgen_ty_4 = 1024;
    pub const nsIFrame_eCanContainOverflowContainers: root::nsIFrame__bindgen_ty_4 = 2048;
    pub const nsIFrame_eTablePart: root::nsIFrame__bindgen_ty_4 = 4096;
    pub const nsIFrame_eExcludesIgnorableWhitespace: root::nsIFrame__bindgen_ty_4 = 8192;
    pub const nsIFrame_eSupportsCSSTransforms: root::nsIFrame__bindgen_ty_4 = 16384;
    pub const nsIFrame_eReplacedSizing: root::nsIFrame__bindgen_ty_4 = 32768;
    pub const nsIFrame_eSupportsContainLayoutAndPaint: root::nsIFrame__bindgen_ty_4 = 65536;
    pub const nsIFrame_eDEBUGAllFrames: root::nsIFrame__bindgen_ty_4 = 1073741824;
    pub const nsIFrame_eDEBUGNoFrames: root::nsIFrame__bindgen_ty_4 = -2147483648;
    #[doc = " Bit-flags to pass to IsFrameOfType()"]
    pub type nsIFrame__bindgen_ty_4 = i32;
    pub const nsIFrame_SKIP_SCROLLED_FRAME: root::nsIFrame__bindgen_ty_5 = 1;
    #[doc = " Get this frame\'s CSS containing block."]
    #[doc = ""]
    #[doc = " The algorithm is defined in"]
    #[doc = " http://www.w3.org/TR/CSS2/visudet.html#containing-block-details."]
    #[doc = ""]
    #[doc = " NOTE: This is guaranteed to return a non-null pointer when invoked on any"]
    #[doc = " frame other than the root frame."]
    #[doc = ""]
    #[doc = " Requires SKIP_SCROLLED_FRAME to get behaviour matching the spec, otherwise"]
    #[doc = " it can return anonymous inner scrolled frames. Bug 1204044 is filed for"]
    #[doc = " investigating whether any of the callers actually require the default"]
    #[doc = " behaviour."]
    pub type nsIFrame__bindgen_ty_5 = u32;
    pub const nsIFrame_PaintType_PAINT_DEFAULT: root::nsIFrame_PaintType = 0;
    pub const nsIFrame_PaintType_PAINT_COMPOSITE_ONLY: root::nsIFrame_PaintType = 1;
    pub const nsIFrame_PaintType_PAINT_DELAYED_COMPRESS: root::nsIFrame_PaintType = 2;
    #[doc = " Ensures that the refresh driver is running, and schedules a view"]
    #[doc = " manager flush on the next tick."]
    #[doc = ""]
    #[doc = " The view manager flush will update the layer tree, repaint any"]
    #[doc = " invalid areas in the layer tree and schedule a layer tree"]
    #[doc = " composite operation to display the layer tree."]
    #[doc = ""]
    #[doc = " In general it is not necessary for frames to call this when they change."]
    #[doc = " For example, changes that result in a reflow will have this called for"]
    #[doc = " them by PresContext::DoReflow when the reflow begins. Style changes that"]
    #[doc = " do not trigger a reflow should have this called for them by"]
    #[doc = " DoApplyRenderingChangeToTree."]
    #[doc = ""]
    #[doc = " @param aType PAINT_COMPOSITE_ONLY : No changes have been made"]
    #[doc = " that require a layer tree update, so only schedule a layer"]
    #[doc = " tree composite."]
    #[doc = " PAINT_DELAYED_COMPRESS : Schedule a paint to be executed after a delay, and"]
    #[doc = " put FrameLayerBuilder in \'compressed\' mode that avoids short cut"]
    #[doc = " optimizations."]
    pub type nsIFrame_PaintType = u32;
    pub const nsIFrame_UPDATE_IS_ASYNC: root::nsIFrame__bindgen_ty_6 = 1;
    #[doc = " Checks if the layer tree includes a dedicated layer for this"]
    #[doc = " frame/display item key pair, and invalidates at least aDamageRect"]
    #[doc = " area within that layer."]
    #[doc = ""]
    #[doc = " If no layer is found, calls InvalidateFrame() instead."]
    #[doc = ""]
    #[doc = " @param aDamageRect Area of the layer to invalidate."]
    #[doc = " @param aFrameDamageRect If no layer is found, the area of the frame to"]
    #[doc = "                         invalidate. If null, the entire frame will be"]
    #[doc = "                         invalidated."]
    #[doc = " @param aDisplayItemKey Display item type."]
    #[doc = " @param aFlags UPDATE_IS_ASYNC : Will skip the invalidation"]
    #[doc = " if the found layer is being composited by a remote"]
    #[doc = " compositor."]
    #[doc = " @return Layer, if found, nullptr otherwise."]
    pub type nsIFrame__bindgen_ty_6 = u32;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIFrame_OwnedAnonBox {
        pub mAnonBoxFrame: *mut root::nsIFrame,
        pub mUpdateStyleFn: root::nsIFrame_OwnedAnonBox_UpdateStyleFn,
    }
    pub type nsIFrame_OwnedAnonBox_UpdateStyleFn = ::std::option::Option<
        unsafe extern "C" fn(
            aOwningFrame: *mut root::nsIFrame,
            aAnonBox: *mut root::nsIFrame,
            aRestyleState: *mut root::mozilla::ServoRestyleState,
        ),
    >;
    #[test]
    fn bindgen_test_layout_nsIFrame_OwnedAnonBox() {
        assert_eq!(
            ::std::mem::size_of::<nsIFrame_OwnedAnonBox>(),
            16usize,
            concat!("Size of: ", stringify!(nsIFrame_OwnedAnonBox))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIFrame_OwnedAnonBox>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIFrame_OwnedAnonBox))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_OwnedAnonBox>())).mAnonBoxFrame as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_OwnedAnonBox),
                "::",
                stringify!(mAnonBoxFrame)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_OwnedAnonBox>())).mUpdateStyleFn as *const _
                    as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_OwnedAnonBox),
                "::",
                stringify!(mUpdateStyleFn)
            )
        );
    }
    pub const nsIFrame_Halignment_hAlign_Left: root::nsIFrame_Halignment = 0;
    pub const nsIFrame_Halignment_hAlign_Right: root::nsIFrame_Halignment = 1;
    pub const nsIFrame_Halignment_hAlign_Center: root::nsIFrame_Halignment = 2;
    pub type nsIFrame_Halignment = u32;
    pub const nsIFrame_Valignment_vAlign_Top: root::nsIFrame_Valignment = 0;
    pub const nsIFrame_Valignment_vAlign_Middle: root::nsIFrame_Valignment = 1;
    pub const nsIFrame_Valignment_vAlign_BaseLine: root::nsIFrame_Valignment = 2;
    pub const nsIFrame_Valignment_vAlign_Bottom: root::nsIFrame_Valignment = 3;
    pub type nsIFrame_Valignment = u32;
    #[repr(C)]
    pub struct nsIFrame_CaretPosition {
        pub mResultContent: root::nsCOMPtr,
        pub mContentOffset: i32,
    }
    #[test]
    fn bindgen_test_layout_nsIFrame_CaretPosition() {
        assert_eq!(
            ::std::mem::size_of::<nsIFrame_CaretPosition>(),
            16usize,
            concat!("Size of: ", stringify!(nsIFrame_CaretPosition))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIFrame_CaretPosition>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIFrame_CaretPosition))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_CaretPosition>())).mResultContent as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_CaretPosition),
                "::",
                stringify!(mResultContent)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_CaretPosition>())).mContentOffset as *const _
                    as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_CaretPosition),
                "::",
                stringify!(mContentOffset)
            )
        );
    }
    pub const nsIFrame_VISIBILITY_CROSS_CHROME_CONTENT_BOUNDARY: root::nsIFrame__bindgen_ty_7 = 1;
    pub type nsIFrame__bindgen_ty_7 = u32;
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIFrame_FrameWithDistance {
        pub mFrame: *mut root::nsIFrame,
        pub mXDistance: root::nscoord,
        pub mYDistance: root::nscoord,
    }
    #[test]
    fn bindgen_test_layout_nsIFrame_FrameWithDistance() {
        assert_eq!(
            ::std::mem::size_of::<nsIFrame_FrameWithDistance>(),
            16usize,
            concat!("Size of: ", stringify!(nsIFrame_FrameWithDistance))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIFrame_FrameWithDistance>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIFrame_FrameWithDistance))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_FrameWithDistance>())).mFrame as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_FrameWithDistance),
                "::",
                stringify!(mFrame)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_FrameWithDistance>())).mXDistance as *const _
                    as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_FrameWithDistance),
                "::",
                stringify!(mXDistance)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_FrameWithDistance>())).mYDistance as *const _
                    as usize
            },
            12usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_FrameWithDistance),
                "::",
                stringify!(mYDistance)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIFrame_VisualDeltas {
        pub mLeft: u8,
        pub mTop: u8,
        pub mRight: u8,
        pub mBottom: u8,
    }
    #[test]
    fn bindgen_test_layout_nsIFrame_VisualDeltas() {
        assert_eq!(
            ::std::mem::size_of::<nsIFrame_VisualDeltas>(),
            4usize,
            concat!("Size of: ", stringify!(nsIFrame_VisualDeltas))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIFrame_VisualDeltas>(),
            1usize,
            concat!("Alignment of ", stringify!(nsIFrame_VisualDeltas))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIFrame_VisualDeltas>())).mLeft as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_VisualDeltas),
                "::",
                stringify!(mLeft)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIFrame_VisualDeltas>())).mTop as *const _ as usize },
            1usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_VisualDeltas),
                "::",
                stringify!(mTop)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_VisualDeltas>())).mRight as *const _ as usize
            },
            2usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_VisualDeltas),
                "::",
                stringify!(mRight)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_VisualDeltas>())).mBottom as *const _ as usize
            },
            3usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_VisualDeltas),
                "::",
                stringify!(mBottom)
            )
        );
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIFrame__bindgen_ty_8 {
        pub mType: root::__BindgenUnionField<u32>,
        pub mVisualDeltas: root::__BindgenUnionField<root::nsIFrame_VisualDeltas>,
        pub bindgen_union_field: u32,
    }
    #[test]
    fn bindgen_test_layout_nsIFrame__bindgen_ty_8() {
        assert_eq!(
            ::std::mem::size_of::<nsIFrame__bindgen_ty_8>(),
            4usize,
            concat!("Size of: ", stringify!(nsIFrame__bindgen_ty_8))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIFrame__bindgen_ty_8>(),
            4usize,
            concat!("Alignment of ", stringify!(nsIFrame__bindgen_ty_8))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame__bindgen_ty_8>())).mType as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame__bindgen_ty_8),
                "::",
                stringify!(mType)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame__bindgen_ty_8>())).mVisualDeltas as *const _
                    as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame__bindgen_ty_8),
                "::",
                stringify!(mVisualDeltas)
            )
        );
    }
    #[doc = " Search the frame for the next word boundary"]
    #[doc = " @param  aForward [in] Are we moving forward (or backward) in content order."]
    #[doc = " @param  aWordSelectEatSpace [in] true: look for non-whitespace following"]
    #[doc = "         whitespace (in the direction of movement)."]
    #[doc = "         false: look for whitespace following non-whitespace (in the"]
    #[doc = "         direction  of movement)."]
    #[doc = " @param  aIsKeyboardSelect [in] Was the action initiated by a keyboard"]
    #[doc = " operation? If true, punctuation immediately following a word is considered"]
    #[doc = " part of that word. Otherwise, a sequence of punctuation is always"]
    #[doc = " considered as a word on its own."]
    #[doc = " @param  aOffset [in/out] At what offset into the frame to start looking."]
    #[doc = "         on output - what offset was reached (whether or not we found a"]
    #[doc = " place to stop)."]
    #[doc = " @param  aState [in/out] the state that is carried from frame to frame"]
    #[doc = " @return true: An appropriate offset was found within this frame,"]
    #[doc = "         and is given by aOffset."]
    #[doc = "         false: Not found within this frame, need to try the next frame."]
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsIFrame_PeekWordState {
        pub mAtStart: bool,
        pub mSawBeforeType: bool,
        pub mLastCharWasPunctuation: bool,
        pub mLastCharWasWhitespace: bool,
        pub mSeenNonPunctuationSinceWhitespace: bool,
        pub mContext: root::nsAutoString,
    }
    #[test]
    fn bindgen_test_layout_nsIFrame_PeekWordState() {
        assert_eq!(
            ::std::mem::size_of::<nsIFrame_PeekWordState>(),
            160usize,
            concat!("Size of: ", stringify!(nsIFrame_PeekWordState))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIFrame_PeekWordState>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIFrame_PeekWordState))
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_PeekWordState>())).mAtStart as *const _ as usize
            },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_PeekWordState),
                "::",
                stringify!(mAtStart)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_PeekWordState>())).mSawBeforeType as *const _
                    as usize
            },
            1usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_PeekWordState),
                "::",
                stringify!(mSawBeforeType)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_PeekWordState>())).mLastCharWasPunctuation
                    as *const _ as usize
            },
            2usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_PeekWordState),
                "::",
                stringify!(mLastCharWasPunctuation)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_PeekWordState>())).mLastCharWasWhitespace
                    as *const _ as usize
            },
            3usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_PeekWordState),
                "::",
                stringify!(mLastCharWasWhitespace)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_PeekWordState>()))
                    .mSeenNonPunctuationSinceWhitespace as *const _ as usize
            },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_PeekWordState),
                "::",
                stringify!(mSeenNonPunctuationSinceWhitespace)
            )
        );
        assert_eq!(
            unsafe {
                &(*(::std::ptr::null::<nsIFrame_PeekWordState>())).mContext as *const _ as usize
            },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame_PeekWordState),
                "::",
                stringify!(mContext)
            )
        );
    }
    pub const nsIFrame_FrameClassBits_eFrameClassBitsNone: root::nsIFrame_FrameClassBits = 0;
    pub const nsIFrame_FrameClassBits_eFrameClassBitsLeaf: root::nsIFrame_FrameClassBits = 1;
    pub const nsIFrame_FrameClassBits_eFrameClassBitsDynamicLeaf: root::nsIFrame_FrameClassBits = 2;
    pub type nsIFrame_FrameClassBits = u32;
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame9kFrameIIDE"]
        pub static nsIFrame_kFrameIID: root::nsQueryFrame_FrameIID;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame14kPrincipalListE"]
        pub static nsIFrame_kPrincipalList: root::nsIFrame_ChildListID;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame13kAbsoluteListE"]
        pub static nsIFrame_kAbsoluteList: root::nsIFrame_ChildListID;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame11kBulletListE"]
        pub static nsIFrame_kBulletList: root::nsIFrame_ChildListID;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame12kCaptionListE"]
        pub static nsIFrame_kCaptionList: root::nsIFrame_ChildListID;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame13kColGroupListE"]
        pub static nsIFrame_kColGroupList: root::nsIFrame_ChildListID;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame29kExcessOverflowContainersListE"]
        pub static nsIFrame_kExcessOverflowContainersList: root::nsIFrame_ChildListID;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame10kFixedListE"]
        pub static nsIFrame_kFixedList: root::nsIFrame_ChildListID;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame10kFloatListE"]
        pub static nsIFrame_kFloatList: root::nsIFrame_ChildListID;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame23kOverflowContainersListE"]
        pub static nsIFrame_kOverflowContainersList: root::nsIFrame_ChildListID;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame13kOverflowListE"]
        pub static nsIFrame_kOverflowList: root::nsIFrame_ChildListID;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame22kOverflowOutOfFlowListE"]
        pub static nsIFrame_kOverflowOutOfFlowList: root::nsIFrame_ChildListID;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame10kPopupListE"]
        pub static nsIFrame_kPopupList: root::nsIFrame_ChildListID;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame17kPushedFloatsListE"]
        pub static nsIFrame_kPushedFloatsList: root::nsIFrame_ChildListID;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame16kSelectPopupListE"]
        pub static nsIFrame_kSelectPopupList: root::nsIFrame_ChildListID;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame13kBackdropListE"]
        pub static nsIFrame_kBackdropList: root::nsIFrame_ChildListID;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame22kNoReflowPrincipalListE"]
        pub static nsIFrame_kNoReflowPrincipalList: root::nsIFrame_ChildListID;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame26sLayerIsPrerenderedDataKeyE"]
        pub static mut nsIFrame_sLayerIsPrerenderedDataKey: u8;
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame17sLayoutFrameTypesE"]
        pub static mut nsIFrame_sLayoutFrameTypes: [root::mozilla::LayoutFrameType; 139usize];
    }
    extern "C" {
        #[link_name = "\u{1}_ZN8nsIFrame15sFrameClassBitsE"]
        pub static mut nsIFrame_sFrameClassBits: [root::nsIFrame_FrameClassBits; 139usize];
    }
    #[test]
    fn bindgen_test_layout_nsIFrame() {
        assert_eq!(
            ::std::mem::size_of::<nsIFrame>(),
            112usize,
            concat!("Size of: ", stringify!(nsIFrame))
        );
        assert_eq!(
            ::std::mem::align_of::<nsIFrame>(),
            8usize,
            concat!("Alignment of ", stringify!(nsIFrame))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIFrame>())).mRect as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame),
                "::",
                stringify!(mRect)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIFrame>())).mContent as *const _ as usize },
            24usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame),
                "::",
                stringify!(mContent)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIFrame>())).mComputedStyle as *const _ as usize },
            32usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame),
                "::",
                stringify!(mComputedStyle)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIFrame>())).mPresContext as *const _ as usize },
            40usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame),
                "::",
                stringify!(mPresContext)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIFrame>())).mParent as *const _ as usize },
            48usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame),
                "::",
                stringify!(mParent)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIFrame>())).mNextSibling as *const _ as usize },
            56usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame),
                "::",
                stringify!(mNextSibling)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIFrame>())).mPrevSibling as *const _ as usize },
            64usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame),
                "::",
                stringify!(mPrevSibling)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIFrame>())).mDisplayItemData as *const _ as usize },
            72usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame),
                "::",
                stringify!(mDisplayItemData)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIFrame>())).mState as *const _ as usize },
            88usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame),
                "::",
                stringify!(mState)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIFrame>())).mProperties as *const _ as usize },
            96usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame),
                "::",
                stringify!(mProperties)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIFrame>())).mOverflow as *const _ as usize },
            104usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame),
                "::",
                stringify!(mOverflow)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIFrame>())).mWritingMode as *const _ as usize },
            108usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame),
                "::",
                stringify!(mWritingMode)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<nsIFrame>())).mClass as *const _ as usize },
            109usize,
            concat!(
                "Offset of field: ",
                stringify!(nsIFrame),
                "::",
                stringify!(mClass)
            )
        );
    }
    impl nsIFrame {
        #[inline]
        pub fn mMayHaveRoundedCorners(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mMayHaveRoundedCorners(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(0usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mHasImageRequest(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mHasImageRequest(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(1usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mHasFirstLetterChild(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mHasFirstLetterChild(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(2usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mParentIsWrapperAnonBox(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mParentIsWrapperAnonBox(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(3usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mIsWrapperBoxNeedingRestyle(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mIsWrapperBoxNeedingRestyle(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(4usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mReflowRequestedForCharDataChange(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mReflowRequestedForCharDataChange(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(5usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mForceDescendIntoIfVisible(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mForceDescendIntoIfVisible(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(6usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mBuiltDisplayList(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mBuiltDisplayList(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(7usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mFrameIsModified(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mFrameIsModified(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(8usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mHasOverrideDirtyRegion(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(9usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mHasOverrideDirtyRegion(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(9usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mMayHaveWillChangeBudget(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(10usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mMayHaveWillChangeBudget(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(10usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mIsPrimaryFrame(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(11usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mIsPrimaryFrame(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(11usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mMayHaveTransformAnimation(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(12usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mMayHaveTransformAnimation(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(12usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mMayHaveOpacityAnimation(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(13usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mMayHaveOpacityAnimation(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(13usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mAllDescendantsAreInvisible(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(14usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mAllDescendantsAreInvisible(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(14usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn mInScrollAnchorChain(&self) -> bool {
            unsafe { ::std::mem::transmute(self._bitfield_1.get(15usize, 1u8) as u8) }
        }
        #[inline]
        pub fn set_mInScrollAnchorChain(&mut self, val: bool) {
            unsafe {
                let val: u8 = ::std::mem::transmute(val);
                self._bitfield_1.set(15usize, 1u8, val as u64)
            }
        }
        #[inline]
        pub fn new_bitfield_1(
            mMayHaveRoundedCorners: bool,
            mHasImageRequest: bool,
            mHasFirstLetterChild: bool,
            mParentIsWrapperAnonBox: bool,
            mIsWrapperBoxNeedingRestyle: bool,
            mReflowRequestedForCharDataChange: bool,
            mForceDescendIntoIfVisible: bool,
            mBuiltDisplayList: bool,
            mFrameIsModified: bool,
            mHasOverrideDirtyRegion: bool,
            mMayHaveWillChangeBudget: bool,
            mIsPrimaryFrame: bool,
            mMayHaveTransformAnimation: bool,
            mMayHaveOpacityAnimation: bool,
            mAllDescendantsAreInvisible: bool,
            mInScrollAnchorChain: bool,
        ) -> root::__BindgenBitfieldUnit<[u8; 2usize], u8> {
            let mut __bindgen_bitfield_unit: root::__BindgenBitfieldUnit<[u8; 2usize], u8> =
                Default::default();
            __bindgen_bitfield_unit.set(0usize, 1u8, {
                let mMayHaveRoundedCorners: u8 =
                    unsafe { ::std::mem::transmute(mMayHaveRoundedCorners) };
                mMayHaveRoundedCorners as u64
            });
            __bindgen_bitfield_unit.set(1usize, 1u8, {
                let mHasImageRequest: u8 = unsafe { ::std::mem::transmute(mHasImageRequest) };
                mHasImageRequest as u64
            });
            __bindgen_bitfield_unit.set(2usize, 1u8, {
                let mHasFirstLetterChild: u8 =
                    unsafe { ::std::mem::transmute(mHasFirstLetterChild) };
                mHasFirstLetterChild as u64
            });
            __bindgen_bitfield_unit.set(3usize, 1u8, {
                let mParentIsWrapperAnonBox: u8 =
                    unsafe { ::std::mem::transmute(mParentIsWrapperAnonBox) };
                mParentIsWrapperAnonBox as u64
            });
            __bindgen_bitfield_unit.set(4usize, 1u8, {
                let mIsWrapperBoxNeedingRestyle: u8 =
                    unsafe { ::std::mem::transmute(mIsWrapperBoxNeedingRestyle) };
                mIsWrapperBoxNeedingRestyle as u64
            });
            __bindgen_bitfield_unit.set(5usize, 1u8, {
                let mReflowRequestedForCharDataChange: u8 =
                    unsafe { ::std::mem::transmute(mReflowRequestedForCharDataChange) };
                mReflowRequestedForCharDataChange as u64
            });
            __bindgen_bitfield_unit.set(6usize, 1u8, {
                let mForceDescendIntoIfVisible: u8 =
                    unsafe { ::std::mem::transmute(mForceDescendIntoIfVisible) };
                mForceDescendIntoIfVisible as u64
            });
            __bindgen_bitfield_unit.set(7usize, 1u8, {
                let mBuiltDisplayList: u8 = unsafe { ::std::mem::transmute(mBuiltDisplayList) };
                mBuiltDisplayList as u64
            });
            __bindgen_bitfield_unit.set(8usize, 1u8, {
                let mFrameIsModified: u8 = unsafe { ::std::mem::transmute(mFrameIsModified) };
                mFrameIsModified as u64
            });
            __bindgen_bitfield_unit.set(9usize, 1u8, {
                let mHasOverrideDirtyRegion: u8 =
                    unsafe { ::std::mem::transmute(mHasOverrideDirtyRegion) };
                mHasOverrideDirtyRegion as u64
            });
            __bindgen_bitfield_unit.set(10usize, 1u8, {
                let mMayHaveWillChangeBudget: u8 =
                    unsafe { ::std::mem::transmute(mMayHaveWillChangeBudget) };
                mMayHaveWillChangeBudget as u64
            });
            __bindgen_bitfield_unit.set(11usize, 1u8, {
                let mIsPrimaryFrame: u8 = unsafe { ::std::mem::transmute(mIsPrimaryFrame) };
                mIsPrimaryFrame as u64
            });
            __bindgen_bitfield_unit.set(12usize, 1u8, {
                let mMayHaveTransformAnimation: u8 =
                    unsafe { ::std::mem::transmute(mMayHaveTransformAnimation) };
                mMayHaveTransformAnimation as u64
            });
            __bindgen_bitfield_unit.set(13usize, 1u8, {
                let mMayHaveOpacityAnimation: u8 =
                    unsafe { ::std::mem::transmute(mMayHaveOpacityAnimation) };
                mMayHaveOpacityAnimation as u64
            });
            __bindgen_bitfield_unit.set(14usize, 1u8, {
                let mAllDescendantsAreInvisible: u8 =
                    unsafe { ::std::mem::transmute(mAllDescendantsAreInvisible) };
                mAllDescendantsAreInvisible as u64
            });
            __bindgen_bitfield_unit.set(15usize, 1u8, {
                let mInScrollAnchorChain: u8 =
                    unsafe { ::std::mem::transmute(mInScrollAnchorChain) };
                mInScrollAnchorChain as u64
            });
            __bindgen_bitfield_unit
        }
    }
    #[repr(C)]
    #[derive(Debug)]
    pub struct AutoWeakFrame {
        pub mPrev: *mut root::AutoWeakFrame,
        pub mFrame: *mut root::nsIFrame,
    }
    #[test]
    fn bindgen_test_layout_AutoWeakFrame() {
        assert_eq!(
            ::std::mem::size_of::<AutoWeakFrame>(),
            16usize,
            concat!("Size of: ", stringify!(AutoWeakFrame))
        );
        assert_eq!(
            ::std::mem::align_of::<AutoWeakFrame>(),
            8usize,
            concat!("Alignment of ", stringify!(AutoWeakFrame))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<AutoWeakFrame>())).mPrev as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(AutoWeakFrame),
                "::",
                stringify!(mPrev)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<AutoWeakFrame>())).mFrame as *const _ as usize },
            8usize,
            concat!(
                "Offset of field: ",
                stringify!(AutoWeakFrame),
                "::",
                stringify!(mFrame)
            )
        );
    }
    #[doc = " @see AutoWeakFrame"]
    #[repr(C)]
    #[derive(Debug)]
    pub struct WeakFrame {
        pub mFrame: *mut root::nsIFrame,
    }
    #[test]
    fn bindgen_test_layout_WeakFrame() {
        assert_eq!(
            ::std::mem::size_of::<WeakFrame>(),
            8usize,
            concat!("Size of: ", stringify!(WeakFrame))
        );
        assert_eq!(
            ::std::mem::align_of::<WeakFrame>(),
            8usize,
            concat!("Alignment of ", stringify!(WeakFrame))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<WeakFrame>())).mFrame as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(WeakFrame),
                "::",
                stringify!(mFrame)
            )
        );
    }
    pub const GECKO_IS_NIGHTLY: bool = false;
    extern "C" {
        pub fn Gecko_Element_DebugListAttributes(
            arg1: *const root::mozilla::dom::Element,
            arg2: *mut ::gecko_bindings::structs::nsCString,
        );
    }
    extern "C" {
        pub fn Gecko_Snapshot_DebugListAttributes(
            arg1: *const root::mozilla::ServoElementSnapshot,
            arg2: *mut ::gecko_bindings::structs::nsCString,
        );
    }
    extern "C" {
        pub fn Gecko_IsSignificantChild(
            arg1: *const root::nsINode,
            whitespace_is_significant: bool,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_GetLastChild(arg1: *const root::nsINode) -> *const root::nsINode;
    }
    extern "C" {
        pub fn Gecko_GetPreviousSibling(arg1: *const root::nsINode) -> *const root::nsINode;
    }
    extern "C" {
        pub fn Gecko_GetFlattenedTreeParentNode(arg1: *const root::nsINode)
            -> *const root::nsINode;
    }
    extern "C" {
        pub fn Gecko_GetBeforeOrAfterPseudo(
            arg1: *const root::mozilla::dom::Element,
            is_before: bool,
        ) -> *const root::mozilla::dom::Element;
    }
    extern "C" {
        pub fn Gecko_GetMarkerPseudo(
            arg1: *const root::mozilla::dom::Element,
        ) -> *const root::mozilla::dom::Element;
    }
    extern "C" {
        pub fn Gecko_GetAnonymousContentForElement(
            arg1: *const root::mozilla::dom::Element,
        ) -> *mut root::nsTArray<*mut root::nsIContent>;
    }
    extern "C" {
        pub fn Gecko_DestroyAnonymousContentList(
            anon_content: *mut root::nsTArray<*mut root::nsIContent>,
        );
    }
    extern "C" {
        pub fn Gecko_GetAssignedNodes(
            arg1: *const root::mozilla::dom::Element,
        ) -> *const root::nsTArray<root::RefPtr<root::nsINode>>;
    }
    extern "C" {
        pub fn Gecko_ComputedStyle_Init(
            context: *mut root::mozilla::ComputedStyle,
            values: *const root::ServoComputedData,
            pseudo_type: root::mozilla::PseudoStyleType,
        );
    }
    extern "C" {
        pub fn Gecko_ConstructStyleChildrenIterator(
            arg1: *const root::mozilla::dom::Element,
            arg2: *mut root::mozilla::dom::StyleChildrenIterator,
        );
    }
    extern "C" {
        pub fn Gecko_DestroyStyleChildrenIterator(
            arg1: *mut root::mozilla::dom::StyleChildrenIterator,
        );
    }
    extern "C" {
        pub fn Gecko_GetNextStyleChild(
            arg1: *mut root::mozilla::dom::StyleChildrenIterator,
        ) -> *const root::nsINode;
    }
    extern "C" {
        pub fn Gecko_AddRefSheetLoadDataHolderArbitraryThread(
            aPtr: *mut root::mozilla::css::SheetLoadDataHolder,
        );
    }
    extern "C" {
        pub fn Gecko_ReleaseSheetLoadDataHolderArbitraryThread(
            aPtr: *mut root::mozilla::css::SheetLoadDataHolder,
        );
    }
    extern "C" {
        pub fn Gecko_StyleSheet_FinishAsyncParse(
            data: *mut root::mozilla::css::SheetLoadDataHolder,
            sheet_contents: root::mozilla::StyleStrong<root::RawServoStyleSheetContents>,
            use_counters: root::mozilla::StyleOwnedOrNull<root::StyleUseCounters>,
        );
    }
    extern "C" {
        pub fn Gecko_LoadStyleSheet(
            loader: *mut root::mozilla::css::Loader,
            parent: *mut root::mozilla::StyleSheet,
            parent_load_data: *mut root::mozilla::css::SheetLoadData,
            reusable_sheets: *mut root::mozilla::css::LoaderReusableStyleSheets,
            url: root::mozilla::StyleStrong<root::RawServoCssUrlData>,
            media_list: root::mozilla::StyleStrong<root::RawServoMediaList>,
        ) -> *mut root::mozilla::StyleSheet;
    }
    extern "C" {
        pub fn Gecko_LoadStyleSheetAsync(
            parent_data: *mut root::mozilla::css::SheetLoadDataHolder,
            arg1: root::mozilla::StyleStrong<root::RawServoCssUrlData>,
            arg2: root::mozilla::StyleStrong<root::RawServoMediaList>,
            arg3: root::mozilla::StyleStrong<root::RawServoImportRule>,
        );
    }
    extern "C" {
        pub fn Gecko_ElementState(arg1: *const root::mozilla::dom::Element) -> u64;
    }
    extern "C" {
        pub fn Gecko_IsRootElement(arg1: *const root::mozilla::dom::Element) -> bool;
    }
    extern "C" {
        pub fn Gecko_MatchLang(
            arg1: *const root::mozilla::dom::Element,
            override_lang: *mut root::nsAtom,
            has_override_lang: bool,
            value: *const u16,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_GetXMLLangValue(arg1: *const root::mozilla::dom::Element)
            -> *mut root::nsAtom;
    }
    extern "C" {
        pub fn Gecko_GetDocumentLWTheme(
            arg1: *const root::mozilla::dom::Document,
        ) -> root::mozilla::dom::Document_DocumentTheme;
    }
    extern "C" {
        pub fn Gecko_GetPrefSheetPrefs(
            arg1: *const root::mozilla::dom::Document,
        ) -> *const root::mozilla::PreferenceSheet_Prefs;
    }
    extern "C" {
        pub fn Gecko_IsTableBorderNonzero(element: *const root::mozilla::dom::Element) -> bool;
    }
    extern "C" {
        pub fn Gecko_IsBrowserFrame(element: *const root::mozilla::dom::Element) -> bool;
    }
    extern "C" {
        pub fn Gecko_AssertClassAttrValueIsSane(arg1: *const root::nsAttrValue) -> bool;
    }
    extern "C" {
        pub fn Gecko_GetSVGAnimatedClass(
            arg1: *const root::mozilla::dom::Element,
        ) -> *const root::nsAttrValue;
    }
    extern "C" {
        pub fn Gecko_LangValue(element: *const root::mozilla::dom::Element) -> *mut root::nsAtom;
    }
    extern "C" {
        pub fn Gecko_HasAttr(
            element: *const root::mozilla::dom::Element,
            ns: *mut root::nsAtom,
            name: *mut root::nsAtom,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_AttrEquals(
            element: *const root::mozilla::dom::Element,
            ns: *mut root::nsAtom,
            name: *mut root::nsAtom,
            str: *mut root::nsAtom,
            ignoreCase: bool,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_AttrDashEquals(
            element: *const root::mozilla::dom::Element,
            ns: *mut root::nsAtom,
            name: *mut root::nsAtom,
            str: *mut root::nsAtom,
            ignore_case: bool,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_AttrIncludes(
            element: *const root::mozilla::dom::Element,
            ns: *mut root::nsAtom,
            name: *mut root::nsAtom,
            str: *mut root::nsAtom,
            ignore_case: bool,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_AttrHasSubstring(
            element: *const root::mozilla::dom::Element,
            ns: *mut root::nsAtom,
            name: *mut root::nsAtom,
            str: *mut root::nsAtom,
            ignore_case: bool,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_AttrHasPrefix(
            element: *const root::mozilla::dom::Element,
            ns: *mut root::nsAtom,
            name: *mut root::nsAtom,
            str: *mut root::nsAtom,
            ignore_case: bool,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_AttrHasSuffix(
            element: *const root::mozilla::dom::Element,
            ns: *mut root::nsAtom,
            name: *mut root::nsAtom,
            str: *mut root::nsAtom,
            ignore_case: bool,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_SnapshotLangValue(
            element: *const root::mozilla::ServoElementSnapshot,
        ) -> *mut root::nsAtom;
    }
    extern "C" {
        pub fn Gecko_SnapshotHasAttr(
            element: *const root::mozilla::ServoElementSnapshot,
            ns: *mut root::nsAtom,
            name: *mut root::nsAtom,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_SnapshotAttrEquals(
            element: *const root::mozilla::ServoElementSnapshot,
            ns: *mut root::nsAtom,
            name: *mut root::nsAtom,
            str: *mut root::nsAtom,
            ignoreCase: bool,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_SnapshotAttrDashEquals(
            element: *const root::mozilla::ServoElementSnapshot,
            ns: *mut root::nsAtom,
            name: *mut root::nsAtom,
            str: *mut root::nsAtom,
            ignore_case: bool,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_SnapshotAttrIncludes(
            element: *const root::mozilla::ServoElementSnapshot,
            ns: *mut root::nsAtom,
            name: *mut root::nsAtom,
            str: *mut root::nsAtom,
            ignore_case: bool,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_SnapshotAttrHasSubstring(
            element: *const root::mozilla::ServoElementSnapshot,
            ns: *mut root::nsAtom,
            name: *mut root::nsAtom,
            str: *mut root::nsAtom,
            ignore_case: bool,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_SnapshotAttrHasPrefix(
            element: *const root::mozilla::ServoElementSnapshot,
            ns: *mut root::nsAtom,
            name: *mut root::nsAtom,
            str: *mut root::nsAtom,
            ignore_case: bool,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_SnapshotAttrHasSuffix(
            element: *const root::mozilla::ServoElementSnapshot,
            ns: *mut root::nsAtom,
            name: *mut root::nsAtom,
            str: *mut root::nsAtom,
            ignore_case: bool,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_GetStyleAttrDeclarationBlock(
            element: *const root::mozilla::dom::Element,
        ) -> *const root::mozilla::StyleStrong<root::RawServoDeclarationBlock>;
    }
    extern "C" {
        pub fn Gecko_UnsetDirtyStyleAttr(element: *const root::mozilla::dom::Element);
    }
    extern "C" {
        pub fn Gecko_GetHTMLPresentationAttrDeclarationBlock(
            element: *const root::mozilla::dom::Element,
        ) -> *const root::mozilla::StyleStrong<root::RawServoDeclarationBlock>;
    }
    extern "C" {
        pub fn Gecko_GetExtraContentStyleDeclarations(
            element: *const root::mozilla::dom::Element,
        ) -> *const root::mozilla::StyleStrong<root::RawServoDeclarationBlock>;
    }
    extern "C" {
        pub fn Gecko_GetUnvisitedLinkAttrDeclarationBlock(
            element: *const root::mozilla::dom::Element,
        ) -> *const root::mozilla::StyleStrong<root::RawServoDeclarationBlock>;
    }
    extern "C" {
        pub fn Gecko_GetVisitedLinkAttrDeclarationBlock(
            element: *const root::mozilla::dom::Element,
        ) -> *const root::mozilla::StyleStrong<root::RawServoDeclarationBlock>;
    }
    extern "C" {
        pub fn Gecko_GetActiveLinkAttrDeclarationBlock(
            element: *const root::mozilla::dom::Element,
        ) -> *const root::mozilla::StyleStrong<root::RawServoDeclarationBlock>;
    }
    extern "C" {
        pub fn Gecko_VisitedStylesEnabled(arg1: *const root::mozilla::dom::Document) -> bool;
    }
    extern "C" {
        pub fn Gecko_GetAnimationRule(
            aElementOrPseudo: *const root::mozilla::dom::Element,
            aCascadeLevel: root::mozilla::EffectCompositor_CascadeLevel,
            aAnimationValues: *mut root::RawServoAnimationValueMap,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_StyleAnimationsEquals(
            arg1: *const root::nsStyleAutoArray<root::mozilla::StyleAnimation>,
            arg2: *const root::nsStyleAutoArray<root::mozilla::StyleAnimation>,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_CopyAnimationNames(
            aDest: *mut root::nsStyleAutoArray<root::mozilla::StyleAnimation>,
            aSrc: *const root::nsStyleAutoArray<root::mozilla::StyleAnimation>,
        );
    }
    extern "C" {
        pub fn Gecko_SetAnimationName(
            aStyleAnimation: *mut root::mozilla::StyleAnimation,
            aAtom: *mut root::nsAtom,
        );
    }
    extern "C" {
        pub fn Gecko_UpdateAnimations(
            aElementOrPseudo: *const root::mozilla::dom::Element,
            aOldComputedValues: *const root::mozilla::ComputedStyle,
            aComputedValues: *const root::mozilla::ComputedStyle,
            aTasks: root::mozilla::UpdateAnimationsTasks,
        );
    }
    extern "C" {
        pub fn Gecko_GetAnimationEffectCount(
            aElementOrPseudo: *const root::mozilla::dom::Element,
        ) -> usize;
    }
    extern "C" {
        pub fn Gecko_ElementHasAnimations(
            aElementOrPseudo: *const root::mozilla::dom::Element,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_ElementHasCSSAnimations(
            aElementOrPseudo: *const root::mozilla::dom::Element,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_ElementHasCSSTransitions(
            aElementOrPseudo: *const root::mozilla::dom::Element,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_ElementHasWebAnimations(
            aElementOrPseudo: *const root::mozilla::dom::Element,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_ElementTransitions_Length(
            aElementOrPseudo: *const root::mozilla::dom::Element,
        ) -> usize;
    }
    extern "C" {
        pub fn Gecko_ElementTransitions_PropertyAt(
            aElementOrPseudo: *const root::mozilla::dom::Element,
            aIndex: usize,
        ) -> root::nsCSSPropertyID;
    }
    extern "C" {
        pub fn Gecko_ElementTransitions_EndValueAt(
            aElementOrPseudo: *const root::mozilla::dom::Element,
            aIndex: usize,
        ) -> *const root::RawServoAnimationValue;
    }
    extern "C" {
        pub fn Gecko_GetProgressFromComputedTiming(
            arg1: *const root::mozilla::ComputedTiming,
        ) -> f64;
    }
    extern "C" {
        pub fn Gecko_GetPositionInSegment(
            arg1: *const root::mozilla::AnimationPropertySegment,
            aProgress: f64,
            aBeforeFlag: root::mozilla::ComputedTimingFunction_BeforeFlag,
        ) -> f64;
    }
    extern "C" {
        pub fn Gecko_AnimationGetBaseStyle(
            aBaseStyles: *const root::RawServoAnimationValueTable,
            aProperty: root::nsCSSPropertyID,
        ) -> *const root::RawServoAnimationValue;
    }
    extern "C" {
        pub fn Gecko_StyleTransition_SetUnsupportedProperty(
            aTransition: *mut root::mozilla::StyleTransition,
            aAtom: *mut root::nsAtom,
        );
    }
    extern "C" {
        pub fn Gecko_Atomize(
            aString: *const ::std::os::raw::c_char,
            aLength: u32,
        ) -> *mut root::nsAtom;
    }
    extern "C" {
        pub fn Gecko_Atomize16(aString: *const ::gecko_bindings::structs::nsAString) -> *mut root::nsAtom;
    }
    extern "C" {
        pub fn Gecko_AddRefAtom(aAtom: *mut root::nsAtom);
    }
    extern "C" {
        pub fn Gecko_ReleaseAtom(aAtom: *mut root::nsAtom);
    }
    extern "C" {
        pub fn Gecko_CopyFontFamilyFrom(dst: *mut root::nsFont, src: *const root::nsFont);
    }
    extern "C" {
        pub fn Gecko_nsTArray_FontFamilyName_AppendNamed(
            aNames: *mut root::nsTArray<root::mozilla::FontFamilyName>,
            aName: *mut root::nsAtom,
            arg1: root::mozilla::StyleFontFamilyNameSyntax,
        );
    }
    extern "C" {
        pub fn Gecko_nsTArray_FontFamilyName_AppendGeneric(
            aNames: *mut root::nsTArray<root::mozilla::FontFamilyName>,
            arg1: root::mozilla::StyleGenericFontFamily,
        );
    }
    extern "C" {
        pub fn Gecko_SharedFontList_Create() -> *mut root::mozilla::SharedFontList;
    }
    extern "C" {
        pub fn Gecko_SharedFontList_SizeOfIncludingThis(
            fontlist: *mut root::mozilla::SharedFontList,
        ) -> usize;
    }
    extern "C" {
        pub fn Gecko_SharedFontList_SizeOfIncludingThisIfUnshared(
            fontlist: *mut root::mozilla::SharedFontList,
        ) -> usize;
    }
    extern "C" {
        pub fn Gecko_AddRefSharedFontListArbitraryThread(aPtr: *mut root::mozilla::SharedFontList);
    }
    extern "C" {
        pub fn Gecko_ReleaseSharedFontListArbitraryThread(aPtr: *mut root::mozilla::SharedFontList);
    }
    extern "C" {
        pub fn Gecko_nsFont_InitSystem(
            dst: *mut root::nsFont,
            font_id: i32,
            font: *const root::nsStyleFont,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_nsFont_Destroy(dst: *mut root::nsFont);
    }
    extern "C" {
        pub fn Gecko_ConstructFontFeatureValueSet() -> *mut root::gfxFontFeatureValueSet;
    }
    extern "C" {
        pub fn Gecko_AppendFeatureValueHashEntry(
            value_set: *mut root::gfxFontFeatureValueSet,
            family: *mut root::nsAtom,
            alternate: u32,
            name: *mut root::nsAtom,
        ) -> *mut root::nsTArray<::std::os::raw::c_uint>;
    }
    extern "C" {
        pub fn Gecko_ClearAlternateValues(font: *mut root::nsFont, length: usize);
    }
    extern "C" {
        pub fn Gecko_AppendAlternateValues(
            font: *mut root::nsFont,
            alternate_name: u32,
            atom: *mut root::nsAtom,
        );
    }
    extern "C" {
        pub fn Gecko_CopyAlternateValuesFrom(dest: *mut root::nsFont, src: *const root::nsFont);
    }
    extern "C" {
        pub fn Gecko_SetImageOrientation(
            aVisibility: *mut root::nsStyleVisibility,
            aOrientation: u8,
            aFlip: bool,
        );
    }
    extern "C" {
        pub fn Gecko_SetImageOrientationAsFromImage(aVisibility: *mut root::nsStyleVisibility);
    }
    extern "C" {
        pub fn Gecko_CopyImageOrientationFrom(
            aDst: *mut root::nsStyleVisibility,
            aSrc: *const root::nsStyleVisibility,
        );
    }
    extern "C" {
        pub fn Gecko_SetCounterStyleToName(
            ptr: *mut root::mozilla::CounterStylePtr,
            name: *mut root::nsAtom,
        );
    }
    extern "C" {
        pub fn Gecko_SetCounterStyleToSymbols(
            ptr: *mut root::mozilla::CounterStylePtr,
            symbols_type: u8,
            symbols: *const *const ::gecko_bindings::structs::nsACString,
            symbols_count: u32,
        );
    }
    extern "C" {
        pub fn Gecko_SetCounterStyleToString(
            ptr: *mut root::mozilla::CounterStylePtr,
            symbol: *const ::gecko_bindings::structs::nsACString,
        );
    }
    extern "C" {
        pub fn Gecko_CopyCounterStyle(
            dst: *mut root::mozilla::CounterStylePtr,
            src: *const root::mozilla::CounterStylePtr,
        );
    }
    extern "C" {
        pub fn Gecko_CounterStyle_GetName(
            ptr: *const root::mozilla::CounterStylePtr,
        ) -> *mut root::nsAtom;
    }
    extern "C" {
        pub fn Gecko_CounterStyle_GetAnonymous(
            ptr: *const root::mozilla::CounterStylePtr,
        ) -> *const root::mozilla::AnonymousCounterStyle;
    }
    extern "C" {
        pub fn Gecko_SetNullImageValue(image: *mut root::nsStyleImage);
    }
    extern "C" {
        pub fn Gecko_SetGradientImageValue(
            image: *mut root::nsStyleImage,
            gradient: *mut root::nsStyleGradient,
        );
    }
    extern "C" {
        pub fn Gecko_SetLayerImageImageValue(
            image: *mut root::nsStyleImage,
            image_value: *mut root::mozilla::css::URLValue,
        );
    }
    extern "C" {
        pub fn Gecko_SetImageElement(image: *mut root::nsStyleImage, atom: *mut root::nsAtom);
    }
    extern "C" {
        pub fn Gecko_CopyImageValueFrom(
            image: *mut root::nsStyleImage,
            other: *const root::nsStyleImage,
        );
    }
    extern "C" {
        pub fn Gecko_InitializeImageCropRect(image: *mut root::nsStyleImage);
    }
    extern "C" {
        pub fn Gecko_CreateGradient(
            shape: u8,
            size: u8,
            repeating: bool,
            legacy_syntax: bool,
            moz_legacy_syntax: bool,
            stops: u32,
        ) -> *mut root::nsStyleGradient;
    }
    extern "C" {
        pub fn Gecko_GetImageRequest(
            image: *const root::nsStyleImage,
        ) -> *const root::nsStyleImageRequest;
    }
    extern "C" {
        pub fn Gecko_GetImageElement(image: *const root::nsStyleImage) -> *mut root::nsAtom;
    }
    extern "C" {
        pub fn Gecko_GetGradientImageValue(
            image: *const root::nsStyleImage,
        ) -> *const root::nsStyleGradient;
    }
    extern "C" {
        pub fn Gecko_SetListStyleImageNone(style_struct: *mut root::nsStyleList);
    }
    extern "C" {
        pub fn Gecko_SetListStyleImageImageValue(
            style_struct: *mut root::nsStyleList,
            aImageValue: *mut root::mozilla::css::URLValue,
        );
    }
    extern "C" {
        pub fn Gecko_CopyListStyleImageFrom(
            dest: *mut root::nsStyleList,
            src: *const root::nsStyleList,
        );
    }
    extern "C" {
        pub fn Gecko_SetCursorArrayLength(ui: *mut root::nsStyleUI, len: usize);
    }
    extern "C" {
        pub fn Gecko_SetCursorImageValue(
            aCursor: *mut root::nsCursorImage,
            aImageValue: *mut root::mozilla::css::URLValue,
        );
    }
    extern "C" {
        pub fn Gecko_CopyCursorArrayFrom(dest: *mut root::nsStyleUI, src: *const root::nsStyleUI);
    }
    extern "C" {
        pub fn Gecko_SetContentDataImageValue(
            aList: *mut root::nsStyleContentData,
            aImageValue: *mut root::mozilla::css::URLValue,
        );
    }
    extern "C" {
        pub fn Gecko_SetCounterFunction(
            content_data: *mut root::nsStyleContentData,
            arg1: root::mozilla::StyleContentType,
        ) -> *mut root::nsStyleContentData_CounterFunction;
    }
    extern "C" {
        pub fn Gecko_SetNodeFlags(node: *const root::nsINode, flags: u32);
    }
    extern "C" {
        pub fn Gecko_UnsetNodeFlags(node: *const root::nsINode, flags: u32);
    }
    extern "C" {
        pub fn Gecko_NoteDirtyElement(arg1: *const root::mozilla::dom::Element);
    }
    extern "C" {
        pub fn Gecko_NoteDirtySubtreeForInvalidation(arg1: *const root::mozilla::dom::Element);
    }
    extern "C" {
        pub fn Gecko_NoteAnimationOnlyDirtyElement(arg1: *const root::mozilla::dom::Element);
    }
    extern "C" {
        pub fn Gecko_AnimationNameMayBeReferencedFromStyle(
            arg1: *const root::nsPresContext,
            name: *mut root::nsAtom,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_GetImplementedPseudo(
            arg1: *const root::mozilla::dom::Element,
        ) -> root::mozilla::PseudoStyleType;
    }
    extern "C" {
        pub fn Gecko_CalcStyleDifference(
            old_style: *const root::mozilla::ComputedStyle,
            new_style: *const root::mozilla::ComputedStyle,
            any_style_struct_changed: *mut bool,
            reset_only_changed: *mut bool,
        ) -> u32;
    }
    extern "C" {
        pub fn Gecko_GetElementSnapshot(
            table: *const root::mozilla::ServoElementSnapshotTable,
            arg1: *const root::mozilla::dom::Element,
        ) -> *const root::mozilla::ServoElementSnapshot;
    }
    extern "C" {
        pub fn Gecko_HaveSeenPtr(
            table: *mut root::mozilla::SeenPtrs,
            ptr: *const ::std::os::raw::c_void,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_ResizeTArrayForStrings(
            array: *mut root::nsTArray<::gecko_bindings::structs::nsString>,
            length: u32,
        );
    }
    extern "C" {
        pub fn Gecko_SetStyleGridTemplate(
            grid_template: *mut root::mozilla::UniquePtr<root::nsStyleGridTemplate>,
            value: *mut root::nsStyleGridTemplate,
        );
    }
    extern "C" {
        pub fn Gecko_CreateStyleGridTemplate(
            track_sizes: u32,
            name_size: u32,
        ) -> *mut root::nsStyleGridTemplate;
    }
    extern "C" {
        pub fn Gecko_CopyStyleGridTemplateValues(
            grid_template: *mut root::mozilla::UniquePtr<root::nsStyleGridTemplate>,
            other: *const root::nsStyleGridTemplate,
        );
    }
    extern "C" {
        pub fn Gecko_NewGridTemplateAreasValue(
            areas: u32,
            templates: u32,
            columns: u32,
        ) -> *mut root::mozilla::css::GridTemplateAreasValue;
    }
    extern "C" {
        pub fn Gecko_AddRefGridTemplateAreasValueArbitraryThread(
            aPtr: *mut root::mozilla::css::GridTemplateAreasValue,
        );
    }
    extern "C" {
        pub fn Gecko_ReleaseGridTemplateAreasValueArbitraryThread(
            aPtr: *mut root::mozilla::css::GridTemplateAreasValue,
        );
    }
    extern "C" {
        pub fn Gecko_ClearAndResizeStyleContents(content: *mut root::nsStyleContent, how_many: u32);
    }
    extern "C" {
        pub fn Gecko_ClearAndResizeCounterIncrements(
            content: *mut root::nsStyleContent,
            how_many: u32,
        );
    }
    extern "C" {
        pub fn Gecko_ClearAndResizeCounterResets(content: *mut root::nsStyleContent, how_many: u32);
    }
    extern "C" {
        pub fn Gecko_ClearAndResizeCounterSets(content: *mut root::nsStyleContent, how_many: u32);
    }
    extern "C" {
        pub fn Gecko_CopyStyleContentsFrom(
            content: *mut root::nsStyleContent,
            other: *const root::nsStyleContent,
        );
    }
    extern "C" {
        pub fn Gecko_CopyCounterResetsFrom(
            content: *mut root::nsStyleContent,
            other: *const root::nsStyleContent,
        );
    }
    extern "C" {
        pub fn Gecko_CopyCounterSetsFrom(
            content: *mut root::nsStyleContent,
            other: *const root::nsStyleContent,
        );
    }
    extern "C" {
        pub fn Gecko_CopyCounterIncrementsFrom(
            content: *mut root::nsStyleContent,
            other: *const root::nsStyleContent,
        );
    }
    extern "C" {
        pub fn Gecko_EnsureImageLayersLength(
            layers: *mut root::nsStyleImageLayers,
            len: usize,
            layer_type: root::nsStyleImageLayers_LayerType,
        );
    }
    extern "C" {
        pub fn Gecko_EnsureStyleAnimationArrayLength(
            array: *mut ::std::os::raw::c_void,
            len: usize,
        );
    }
    extern "C" {
        pub fn Gecko_EnsureStyleTransitionArrayLength(
            array: *mut ::std::os::raw::c_void,
            len: usize,
        );
    }
    extern "C" {
        pub fn Gecko_GetOrCreateKeyframeAtStart(
            keyframes: *mut root::nsTArray<root::mozilla::Keyframe>,
            offset: f32,
            timingFunction: *const root::nsTimingFunction,
        ) -> *mut root::mozilla::Keyframe;
    }
    extern "C" {
        pub fn Gecko_GetOrCreateInitialKeyframe(
            keyframes: *mut root::nsTArray<root::mozilla::Keyframe>,
            timingFunction: *const root::nsTimingFunction,
        ) -> *mut root::mozilla::Keyframe;
    }
    extern "C" {
        pub fn Gecko_GetOrCreateFinalKeyframe(
            keyframes: *mut root::nsTArray<root::mozilla::Keyframe>,
            timingFunction: *const root::nsTimingFunction,
        ) -> *mut root::mozilla::Keyframe;
    }
    extern "C" {
        pub fn Gecko_AppendPropertyValuePair(
            arg1: *mut root::nsTArray<root::mozilla::PropertyValuePair>,
            aProperty: root::nsCSSPropertyID,
        ) -> *mut root::mozilla::PropertyValuePair;
    }
    extern "C" {
        pub fn Gecko_ResetStyleCoord(unit: *mut root::nsStyleUnit, value: *mut root::nsStyleUnion);
    }
    extern "C" {
        pub fn Gecko_SetStyleCoordCalcValue(
            unit: *mut root::nsStyleUnit,
            value: *mut root::nsStyleUnion,
            calc: root::nsStyleCoord_CalcValue,
        );
    }
    extern "C" {
        pub fn Gecko_CopyShapeSourceFrom(
            dst: *mut root::mozilla::StyleShapeSource,
            src: *const root::mozilla::StyleShapeSource,
        );
    }
    extern "C" {
        pub fn Gecko_DestroyShapeSource(shape: *mut root::mozilla::StyleShapeSource);
    }
    extern "C" {
        pub fn Gecko_NewShapeImage(shape: *mut root::mozilla::StyleShapeSource);
    }
    extern "C" {
        pub fn Gecko_StyleShapeSource_SetURLValue(
            shape: *mut root::mozilla::StyleShapeSource,
            uri: *mut root::mozilla::css::URLValue,
        );
    }
    extern "C" {
        pub fn Gecko_SetToSVGPath(
            shape: *mut root::mozilla::StyleShapeSource,
            arg1: root::mozilla::StyleForgottenArcSlicePtr<root::mozilla::StylePathCommand>,
            arg2: root::mozilla::StyleFillRule,
        );
    }
    extern "C" {
        pub fn Gecko_SetStyleMotion(
            aMotion: *mut root::mozilla::UniquePtr<root::mozilla::StyleMotion>,
            aValue: *mut root::mozilla::StyleMotion,
        );
    }
    extern "C" {
        pub fn Gecko_NewStyleMotion() -> *mut root::mozilla::StyleMotion;
    }
    extern "C" {
        pub fn Gecko_CopyStyleMotions(
            motion: *mut root::mozilla::UniquePtr<root::mozilla::StyleMotion>,
            other: *const root::mozilla::StyleMotion,
        );
    }
    extern "C" {
        pub fn Gecko_ResetFilters(effects: *mut root::nsStyleEffects, new_len: usize);
    }
    extern "C" {
        pub fn Gecko_CopyFiltersFrom(
            aSrc: *mut root::nsStyleEffects,
            aDest: *mut root::nsStyleEffects,
        );
    }
    extern "C" {
        pub fn Gecko_nsStyleFilter_SetURLValue(
            effects: *mut root::nsStyleFilter,
            uri: *mut root::mozilla::css::URLValue,
        );
    }
    extern "C" {
        pub fn Gecko_nsStyleSVGPaint_CopyFrom(
            dest: *mut root::nsStyleSVGPaint,
            src: *const root::nsStyleSVGPaint,
        );
    }
    extern "C" {
        pub fn Gecko_nsStyleSVGPaint_SetURLValue(
            paint: *mut root::nsStyleSVGPaint,
            uri: *mut root::mozilla::css::URLValue,
        );
    }
    extern "C" {
        pub fn Gecko_nsStyleSVGPaint_Reset(paint: *mut root::nsStyleSVGPaint);
    }
    extern "C" {
        pub fn Gecko_nsStyleSVG_SetDashArrayLength(svg: *mut root::nsStyleSVG, len: u32);
    }
    extern "C" {
        pub fn Gecko_nsStyleSVG_CopyDashArray(
            dst: *mut root::nsStyleSVG,
            src: *const root::nsStyleSVG,
        );
    }
    extern "C" {
        pub fn Gecko_nsStyleSVG_SetContextPropertiesLength(svg: *mut root::nsStyleSVG, len: u32);
    }
    extern "C" {
        pub fn Gecko_nsStyleSVG_CopyContextProperties(
            dst: *mut root::nsStyleSVG,
            src: *const root::nsStyleSVG,
        );
    }
    extern "C" {
        pub fn Gecko_URLValue_Create(
            url: root::mozilla::StyleStrong<root::RawServoCssUrlData>,
            aCORSMode: root::mozilla::CORSMode,
        ) -> *mut root::mozilla::css::URLValue;
    }
    extern "C" {
        pub fn Gecko_URLValue_SizeOfIncludingThis(url: *mut root::mozilla::css::URLValue) -> usize;
    }
    extern "C" {
        pub fn Gecko_GetComputedURLSpec(
            url: *const root::mozilla::css::URLValue,
            spec: *mut ::gecko_bindings::structs::nsCString,
        );
    }
    extern "C" {
        pub fn Gecko_GetComputedImageURLSpec(
            url: *const root::mozilla::css::URLValue,
            spec: *mut ::gecko_bindings::structs::nsCString,
        );
    }
    extern "C" {
        pub fn Gecko_nsIURI_Debug(arg1: *mut root::nsIURI, spec: *mut ::gecko_bindings::structs::nsCString);
    }
    extern "C" {
        pub fn Gecko_AddRefCSSURLValueArbitraryThread(aPtr: *mut root::mozilla::css::URLValue);
    }
    extern "C" {
        pub fn Gecko_ReleaseCSSURLValueArbitraryThread(aPtr: *mut root::mozilla::css::URLValue);
    }
    extern "C" {
        pub fn Gecko_AddRefURLExtraDataArbitraryThread(aPtr: *mut root::mozilla::URLExtraData);
    }
    extern "C" {
        pub fn Gecko_ReleaseURLExtraDataArbitraryThread(aPtr: *mut root::mozilla::URLExtraData);
    }
    extern "C" {
        pub fn Gecko_FillAllImageLayers(layers: *mut root::nsStyleImageLayers, max_len: u32);
    }
    extern "C" {
        pub fn Gecko_AddRefCalcArbitraryThread(aPtr: *mut root::nsStyleCoord_Calc);
    }
    extern "C" {
        pub fn Gecko_ReleaseCalcArbitraryThread(aPtr: *mut root::nsStyleCoord_Calc);
    }
    extern "C" {
        pub fn Gecko_FontStretch_ToFloat(aStretch: root::mozilla::FontStretch) -> f32;
    }
    extern "C" {
        pub fn Gecko_FontStretch_SetFloat(
            aStretch: *mut root::mozilla::FontStretch,
            aFloatValue: f32,
        );
    }
    extern "C" {
        pub fn Gecko_FontSlantStyle_ToFloat(aStyle: root::mozilla::FontSlantStyle) -> f32;
    }
    extern "C" {
        pub fn Gecko_FontSlantStyle_SetNormal(arg1: *mut root::mozilla::FontSlantStyle);
    }
    extern "C" {
        pub fn Gecko_FontSlantStyle_SetItalic(arg1: *mut root::mozilla::FontSlantStyle);
    }
    extern "C" {
        pub fn Gecko_FontSlantStyle_SetOblique(
            arg1: *mut root::mozilla::FontSlantStyle,
            angle_degrees: f32,
        );
    }
    extern "C" {
        pub fn Gecko_FontSlantStyle_Get(
            arg1: root::mozilla::FontSlantStyle,
            normal: *mut bool,
            italic: *mut bool,
            oblique_angle: *mut f32,
        );
    }
    extern "C" {
        pub fn Gecko_FontWeight_ToFloat(aWeight: root::mozilla::FontWeight) -> f32;
    }
    extern "C" {
        pub fn Gecko_FontWeight_SetFloat(aWeight: *mut root::mozilla::FontWeight, aFloatValue: f32);
    }
    extern "C" {
        pub fn Gecko_nsStyleFont_SetLang(font: *mut root::nsStyleFont, atom: *mut root::nsAtom);
    }
    extern "C" {
        pub fn Gecko_nsStyleFont_CopyLangFrom(
            aFont: *mut root::nsStyleFont,
            aSource: *const root::nsStyleFont,
        );
    }
    extern "C" {
        pub fn Gecko_nsStyleFont_PrioritizeUserFonts(
            font: *mut root::nsStyleFont,
            aDefaultGeneric: root::mozilla::StyleGenericFontFamily,
        );
    }
    extern "C" {
        pub fn Gecko_nsStyleFont_ComputeMinSize(
            arg1: *const root::nsStyleFont,
            arg2: *const root::mozilla::dom::Document,
        ) -> root::nscoord;
    }
    extern "C" {
        pub fn Gecko_nsStyleFont_ComputeDefaultFontType(
            arg1: *const root::mozilla::dom::Document,
            generic_family: root::mozilla::StyleGenericFontFamily,
            language: *mut root::nsAtom,
        ) -> root::mozilla::StyleGenericFontFamily;
    }
    extern "C" {
        pub fn Gecko_GetBaseSize(lang: *mut root::nsAtom) -> root::mozilla::FontSizePrefs;
    }
    extern "C" {
        pub fn Gecko_GetBindingParent(
            arg1: *const root::mozilla::dom::Element,
        ) -> *const root::mozilla::dom::Element;
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct GeckoFontMetrics {
        pub mChSize: root::nscoord,
        pub mXSize: root::nscoord,
    }
    #[test]
    fn bindgen_test_layout_GeckoFontMetrics() {
        assert_eq!(
            ::std::mem::size_of::<GeckoFontMetrics>(),
            8usize,
            concat!("Size of: ", stringify!(GeckoFontMetrics))
        );
        assert_eq!(
            ::std::mem::align_of::<GeckoFontMetrics>(),
            4usize,
            concat!("Alignment of ", stringify!(GeckoFontMetrics))
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<GeckoFontMetrics>())).mChSize as *const _ as usize },
            0usize,
            concat!(
                "Offset of field: ",
                stringify!(GeckoFontMetrics),
                "::",
                stringify!(mChSize)
            )
        );
        assert_eq!(
            unsafe { &(*(::std::ptr::null::<GeckoFontMetrics>())).mXSize as *const _ as usize },
            4usize,
            concat!(
                "Offset of field: ",
                stringify!(GeckoFontMetrics),
                "::",
                stringify!(mXSize)
            )
        );
    }
    extern "C" {
        pub fn Gecko_GetFontMetrics(
            arg1: *const root::nsPresContext,
            is_vertical: bool,
            font: *const root::nsStyleFont,
            font_size: root::nscoord,
            use_user_font_set: bool,
        ) -> root::GeckoFontMetrics;
    }
    extern "C" {
        pub fn Gecko_StyleSheet_Clone(
            aSheet: *const root::mozilla::StyleSheet,
            aNewParentSheet: *const root::mozilla::StyleSheet,
        ) -> *mut root::mozilla::StyleSheet;
    }
    extern "C" {
        pub fn Gecko_StyleSheet_AddRef(aSheet: *const root::mozilla::StyleSheet);
    }
    extern "C" {
        pub fn Gecko_StyleSheet_Release(aSheet: *const root::mozilla::StyleSheet);
    }
    extern "C" {
        pub fn Gecko_LookupCSSKeyword(string: *const u8, len: u32) -> root::nsCSSKeyword;
    }
    extern "C" {
        pub fn Gecko_CSSKeywordString(
            keyword: root::nsCSSKeyword,
            len: *mut u32,
        ) -> *const ::std::os::raw::c_char;
    }
    extern "C" {
        pub fn Gecko_IsDocumentBody(element: *const root::mozilla::dom::Element) -> bool;
    }
    extern "C" {
        pub fn Gecko_GetLookAndFeelSystemColor(
            color_id: i32,
            arg1: *const root::mozilla::dom::Document,
        ) -> root::nscolor;
    }
    extern "C" {
        pub fn Gecko_AddPropertyToSet(
            arg1: *mut root::nsCSSPropertyIDSet,
            arg2: root::nsCSSPropertyID,
        );
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleFont(
            ptr: *mut root::nsStyleFont,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleFont(
            ptr: *mut root::nsStyleFont,
            other: *const root::nsStyleFont,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleFont(ptr: *mut root::nsStyleFont);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleColor(
            ptr: *mut root::nsStyleColor,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleColor(
            ptr: *mut root::nsStyleColor,
            other: *const root::nsStyleColor,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleColor(ptr: *mut root::nsStyleColor);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleList(
            ptr: *mut root::nsStyleList,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleList(
            ptr: *mut root::nsStyleList,
            other: *const root::nsStyleList,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleList(ptr: *mut root::nsStyleList);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleText(
            ptr: *mut root::nsStyleText,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleText(
            ptr: *mut root::nsStyleText,
            other: *const root::nsStyleText,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleText(ptr: *mut root::nsStyleText);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleVisibility(
            ptr: *mut root::nsStyleVisibility,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleVisibility(
            ptr: *mut root::nsStyleVisibility,
            other: *const root::nsStyleVisibility,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleVisibility(ptr: *mut root::nsStyleVisibility);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleUI(
            ptr: *mut root::nsStyleUI,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleUI(
            ptr: *mut root::nsStyleUI,
            other: *const root::nsStyleUI,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleUI(ptr: *mut root::nsStyleUI);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleTableBorder(
            ptr: *mut root::nsStyleTableBorder,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleTableBorder(
            ptr: *mut root::nsStyleTableBorder,
            other: *const root::nsStyleTableBorder,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleTableBorder(ptr: *mut root::nsStyleTableBorder);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleSVG(
            ptr: *mut root::nsStyleSVG,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleSVG(
            ptr: *mut root::nsStyleSVG,
            other: *const root::nsStyleSVG,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleSVG(ptr: *mut root::nsStyleSVG);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleBackground(
            ptr: *mut root::nsStyleBackground,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleBackground(
            ptr: *mut root::nsStyleBackground,
            other: *const root::nsStyleBackground,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleBackground(ptr: *mut root::nsStyleBackground);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStylePosition(
            ptr: *mut root::nsStylePosition,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStylePosition(
            ptr: *mut root::nsStylePosition,
            other: *const root::nsStylePosition,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStylePosition(ptr: *mut root::nsStylePosition);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleTextReset(
            ptr: *mut root::nsStyleTextReset,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleTextReset(
            ptr: *mut root::nsStyleTextReset,
            other: *const root::nsStyleTextReset,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleTextReset(ptr: *mut root::nsStyleTextReset);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleDisplay(
            ptr: *mut root::nsStyleDisplay,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleDisplay(
            ptr: *mut root::nsStyleDisplay,
            other: *const root::nsStyleDisplay,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleDisplay(ptr: *mut root::nsStyleDisplay);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleContent(
            ptr: *mut root::nsStyleContent,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleContent(
            ptr: *mut root::nsStyleContent,
            other: *const root::nsStyleContent,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleContent(ptr: *mut root::nsStyleContent);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleUIReset(
            ptr: *mut root::nsStyleUIReset,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleUIReset(
            ptr: *mut root::nsStyleUIReset,
            other: *const root::nsStyleUIReset,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleUIReset(ptr: *mut root::nsStyleUIReset);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleTable(
            ptr: *mut root::nsStyleTable,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleTable(
            ptr: *mut root::nsStyleTable,
            other: *const root::nsStyleTable,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleTable(ptr: *mut root::nsStyleTable);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleMargin(
            ptr: *mut root::nsStyleMargin,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleMargin(
            ptr: *mut root::nsStyleMargin,
            other: *const root::nsStyleMargin,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleMargin(ptr: *mut root::nsStyleMargin);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStylePadding(
            ptr: *mut root::nsStylePadding,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStylePadding(
            ptr: *mut root::nsStylePadding,
            other: *const root::nsStylePadding,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStylePadding(ptr: *mut root::nsStylePadding);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleBorder(
            ptr: *mut root::nsStyleBorder,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleBorder(
            ptr: *mut root::nsStyleBorder,
            other: *const root::nsStyleBorder,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleBorder(ptr: *mut root::nsStyleBorder);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleOutline(
            ptr: *mut root::nsStyleOutline,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleOutline(
            ptr: *mut root::nsStyleOutline,
            other: *const root::nsStyleOutline,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleOutline(ptr: *mut root::nsStyleOutline);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleXUL(
            ptr: *mut root::nsStyleXUL,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleXUL(
            ptr: *mut root::nsStyleXUL,
            other: *const root::nsStyleXUL,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleXUL(ptr: *mut root::nsStyleXUL);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleSVGReset(
            ptr: *mut root::nsStyleSVGReset,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleSVGReset(
            ptr: *mut root::nsStyleSVGReset,
            other: *const root::nsStyleSVGReset,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleSVGReset(ptr: *mut root::nsStyleSVGReset);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleColumn(
            ptr: *mut root::nsStyleColumn,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleColumn(
            ptr: *mut root::nsStyleColumn,
            other: *const root::nsStyleColumn,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleColumn(ptr: *mut root::nsStyleColumn);
    }
    extern "C" {
        pub fn Gecko_Construct_Default_nsStyleEffects(
            ptr: *mut root::nsStyleEffects,
            arg1: *const root::mozilla::dom::Document,
        );
    }
    extern "C" {
        pub fn Gecko_CopyConstruct_nsStyleEffects(
            ptr: *mut root::nsStyleEffects,
            other: *const root::nsStyleEffects,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_nsStyleEffects(ptr: *mut root::nsStyleEffects);
    }
    extern "C" {
        pub fn Gecko_RegisterProfilerThread(name: *const ::std::os::raw::c_char);
    }
    extern "C" {
        pub fn Gecko_UnregisterProfilerThread();
    }
    extern "C" {
        pub fn Gecko_Construct_AutoProfilerLabel(
            arg1: *mut root::mozilla::AutoProfilerLabel,
            arg2: root::JS::ProfilingCategoryPair,
        );
    }
    extern "C" {
        pub fn Gecko_Destroy_AutoProfilerLabel(arg1: *mut root::mozilla::AutoProfilerLabel);
    }
    extern "C" {
        pub fn Gecko_DocumentRule_UseForPresentation(
            arg1: *const root::mozilla::dom::Document,
            aPattern: *const ::gecko_bindings::structs::nsACString,
            arg2: root::mozilla::css::DocumentMatchingFunction,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_SetJemallocThreadLocalArena(enabled: bool);
    }
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_after: u32 = 129;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_before: u32 = 129;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_marker: u32 = 0;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_backdrop: u32 = 0;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_cue: u32 = 68;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_firstLetter: u32 = 3;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_firstLine: u32 = 3;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_selection: u32 = 2;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_mozFocusInner: u32 = 0;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_mozFocusOuter: u32 = 0;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_mozMathAnonymous: u32 = 16;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_mozNumberWrapper: u32 = 56;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_mozNumberText: u32 = 56;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_mozNumberSpinBox: u32 = 56;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_mozNumberSpinUp: u32 = 56;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_mozNumberSpinDown: u32 = 56;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_mozProgressBar: u32 = 8;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_mozRangeTrack: u32 = 8;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_mozRangeProgress: u32 = 8;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_mozRangeThumb: u32 = 8;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_mozMeterBar: u32 = 8;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_placeholder: u32 = 8;
    pub const SERVO_CSS_PSEUDO_ELEMENT_FLAGS_mozColorSwatch: u32 = 12;
    extern "C" {
        pub fn Gecko_ErrorReportingEnabled(
            sheet: *const root::mozilla::StyleSheet,
            loader: *const root::mozilla::css::Loader,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_ReportUnexpectedCSSError(
            sheet: *const root::mozilla::StyleSheet,
            loader: *const root::mozilla::css::Loader,
            uri: *mut root::nsIURI,
            message: *const ::std::os::raw::c_char,
            param: *const ::std::os::raw::c_char,
            paramLen: u32,
            prefix: *const ::std::os::raw::c_char,
            prefixParam: *const ::std::os::raw::c_char,
            prefixParamLen: u32,
            suffix: *const ::std::os::raw::c_char,
            source: *const ::std::os::raw::c_char,
            sourceLen: u32,
            selectors: *const ::std::os::raw::c_char,
            selectorsLen: u32,
            lineNumber: u32,
            colNumber: u32,
        );
    }
    extern "C" {
        pub fn Gecko_ContentList_AppendAll(
            aContentList: *mut root::nsSimpleContentList,
            aElements: *mut *const root::mozilla::dom::Element,
            aLength: usize,
        );
    }
    extern "C" {
        pub fn Gecko_Document_GetElementsWithId(
            arg1: *const root::mozilla::dom::Document,
            aId: *mut root::nsAtom,
        ) -> *const root::nsTArray<*mut root::mozilla::dom::Element>;
    }
    extern "C" {
        pub fn Gecko_ShadowRoot_GetElementsWithId(
            arg1: *const root::mozilla::dom::ShadowRoot,
            aId: *mut root::nsAtom,
        ) -> *const root::nsTArray<*mut root::mozilla::dom::Element>;
    }
    extern "C" {
        pub fn Gecko_GetBoolPrefValue(pref_name: *const ::std::os::raw::c_char) -> bool;
    }
    extern "C" {
        pub fn Gecko_IsInServoTraversal() -> bool;
    }
    extern "C" {
        pub fn Gecko_IsMainThread() -> bool;
    }
    extern "C" {
        pub fn Gecko_MediaFeatures_GetDisplayMode(
            arg1: *const root::mozilla::dom::Document,
        ) -> root::mozilla::StyleDisplayMode;
    }
    extern "C" {
        pub fn Gecko_MediaFeatures_GetColorDepth(arg1: *const root::mozilla::dom::Document) -> u32;
    }
    extern "C" {
        pub fn Gecko_MediaFeatures_GetDeviceSize(
            arg1: *const root::mozilla::dom::Document,
            width: *mut root::nscoord,
            height: *mut root::nscoord,
        );
    }
    extern "C" {
        pub fn Gecko_MediaFeatures_GetResolution(arg1: *const root::mozilla::dom::Document) -> f32;
    }
    extern "C" {
        pub fn Gecko_MediaFeatures_PrefersReducedMotion(
            arg1: *const root::mozilla::dom::Document,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_MediaFeatures_PrefersColorScheme(
            arg1: *const root::mozilla::dom::Document,
        ) -> root::mozilla::StylePrefersColorScheme;
    }
    extern "C" {
        pub fn Gecko_MediaFeatures_PrimaryPointerCapabilities(
            arg1: *const root::mozilla::dom::Document,
        ) -> root::mozilla::PointerCapabilities;
    }
    extern "C" {
        pub fn Gecko_MediaFeatures_AllPointerCapabilities(
            arg1: *const root::mozilla::dom::Document,
        ) -> root::mozilla::PointerCapabilities;
    }
    extern "C" {
        pub fn Gecko_MediaFeatures_GetDevicePixelRatio(
            arg1: *const root::mozilla::dom::Document,
        ) -> f32;
    }
    extern "C" {
        pub fn Gecko_MediaFeatures_HasSystemMetric(
            arg1: *const root::mozilla::dom::Document,
            metric: *mut root::nsAtom,
            is_accessible_from_content: bool,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_MediaFeatures_IsResourceDocument(
            arg1: *const root::mozilla::dom::Document,
        ) -> bool;
    }
    extern "C" {
        pub fn Gecko_MediaFeatures_GetOperatingSystemVersion(
            arg1: *const root::mozilla::dom::Document,
        ) -> *mut root::nsAtom;
    }
    #[repr(C)]
    #[derive(Debug, Copy, Clone)]
    pub struct nsMediaFeatures {
        pub _address: u8,
    }
    #[test]
    fn bindgen_test_layout_nsMediaFeatures() {
        assert_eq!(
            ::std::mem::size_of::<nsMediaFeatures>(),
            1usize,
            concat!("Size of: ", stringify!(nsMediaFeatures))
        );
        assert_eq!(
            ::std::mem::align_of::<nsMediaFeatures>(),
            1usize,
            concat!("Alignment of ", stringify!(nsMediaFeatures))
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTSubstring_open0_char16_t_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTSubstring<u16>>(),
            16usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTSubstring<u16>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTSubstring<u16>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTSubstring<u16>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTString_open0_char16_t_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTString<u16>>(),
            16usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTString<u16>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTString<u16>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTString<u16>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTSubstring_open0_char_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTSubstring<::std::os::raw::c_char>>(),
            16usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTSubstring<::std::os::raw::c_char>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTSubstring<::std::os::raw::c_char>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTSubstring<::std::os::raw::c_char>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTString_open0_char_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTString<::std::os::raw::c_char>>(),
            16usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTString<::std::os::raw::c_char>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTString<::std::os::raw::c_char>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTString<::std::os::raw::c_char>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_nsAtom_close1_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::RefPtr<root::nsAtom>>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsAtom>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::RefPtr<root::nsAtom>>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsAtom>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_RawServoFontFaceRule_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::RawServoFontFaceRule>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::RawServoFontFaceRule>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::RawServoFontFaceRule>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::RawServoFontFaceRule>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsISupports_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_StyleGenericPosition_open0_StyleHorizontalPosition_StyleVerticalPosition_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<
                root::mozilla::StyleGenericPosition<
                    root::mozilla::StyleHorizontalPosition,
                    root::mozilla::StyleVerticalPosition,
                >,
            >(),
            24usize,
            concat!(
                "Size of template specialization: ",
                stringify ! ( root :: mozilla :: StyleGenericPosition < root :: mozilla :: StyleHorizontalPosition , root :: mozilla :: StyleVerticalPosition > )
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::mozilla::StyleGenericPosition<
                    root::mozilla::StyleHorizontalPosition,
                    root::mozilla::StyleVerticalPosition,
                >,
            >(),
            4usize,
            concat!(
                "Alignment of template specialization: ",
                stringify ! ( root :: mozilla :: StyleGenericPosition < root :: mozilla :: StyleHorizontalPosition , root :: mozilla :: StyleVerticalPosition > )
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_StyleGenericBorderImageSlice_open0_StyleNonNegativeNumberOrPercentage_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<
                root::mozilla::StyleGenericBorderImageSlice<
                    root::mozilla::StyleNonNegativeNumberOrPercentage,
                >,
            >(),
            36usize,
            concat!(
                "Size of template specialization: ",
                stringify!(
                    root::mozilla::StyleGenericBorderImageSlice<
                        root::mozilla::StyleNonNegativeNumberOrPercentage,
                    >
                )
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::mozilla::StyleGenericBorderImageSlice<
                    root::mozilla::StyleNonNegativeNumberOrPercentage,
                >,
            >(),
            4usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(
                    root::mozilla::StyleGenericBorderImageSlice<
                        root::mozilla::StyleNonNegativeNumberOrPercentage,
                    >
                )
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_StyleGenericTransformOrigin_open0_StyleLengthPercentage_StyleLengthPercentage_StyleLength_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<
                root::mozilla::StyleGenericTransformOrigin<
                    root::mozilla::StyleLengthPercentage,
                    root::mozilla::StyleLengthPercentage,
                    root::mozilla::StyleLength,
                >,
            >(),
            28usize,
            concat!(
                "Size of template specialization: ",
                stringify ! ( root :: mozilla :: StyleGenericTransformOrigin < root :: mozilla :: StyleLengthPercentage , root :: mozilla :: StyleLengthPercentage , root :: mozilla :: StyleLength > )
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::mozilla::StyleGenericTransformOrigin<
                    root::mozilla::StyleLengthPercentage,
                    root::mozilla::StyleLengthPercentage,
                    root::mozilla::StyleLength,
                >,
            >(),
            4usize,
            concat!(
                "Alignment of template specialization: ",
                stringify ! ( root :: mozilla :: StyleGenericTransformOrigin < root :: mozilla :: StyleLengthPercentage , root :: mozilla :: StyleLengthPercentage , root :: mozilla :: StyleLength > )
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_StyleGenericShapeRadius_open0_StyleNonNegativeLengthPercentage_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<
                root::mozilla::StyleGenericShapeRadius<
                    root::mozilla::StyleNonNegativeLengthPercentage,
                >,
            >(),
            16usize,
            concat!(
                "Size of template specialization: ",
                stringify!(
                    root::mozilla::StyleGenericShapeRadius<
                        root::mozilla::StyleNonNegativeLengthPercentage,
                    >
                )
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::mozilla::StyleGenericShapeRadius<
                    root::mozilla::StyleNonNegativeLengthPercentage,
                >,
            >(),
            4usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(
                    root::mozilla::StyleGenericShapeRadius<
                        root::mozilla::StyleNonNegativeLengthPercentage,
                    >
                )
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_BaseTimeDuration_open0_TimeDurationValueCalculator_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::BaseTimeDuration>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::BaseTimeDuration)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::BaseTimeDuration>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::BaseTimeDuration)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_FontFamilyName_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::mozilla::FontFamilyName>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::FontFamilyName>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::mozilla::FontFamilyName>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::FontFamilyName>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_NotNull_open0_RefPtr_open1_SharedFontList_close1_close0_instantiation()
    {
        assert_eq!(
            ::std::mem::size_of::<
                root::mozilla::NotNull<root::RefPtr<root::mozilla::SharedFontList>>,
            >(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::NotNull<root::RefPtr<root::mozilla::SharedFontList>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::mozilla::NotNull<root::RefPtr<root::mozilla::SharedFontList>>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::NotNull<root::RefPtr<root::mozilla::SharedFontList>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_SharedFontList_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::SharedFontList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::SharedFontList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::SharedFontList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::SharedFontList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_uint32_t_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<u32>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<u32>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<u32>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<u32>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_gfxFontFeatureValueSet_ValueList_close0_instantiation()
    {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::gfxFontFeatureValueSet_ValueList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::gfxFontFeatureValueSet_ValueList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::gfxFontFeatureValueSet_ValueList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::gfxFontFeatureValueSet_ValueList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_uint32_t_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<u32>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<u32>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<u32>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<u32>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_gfxFontFeature_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::gfxFontFeature>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::gfxFontFeature>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::gfxFontFeature>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::gfxFontFeature>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_gfxFontVariation_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::gfxFontVariation>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::gfxFontVariation>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::gfxFontVariation>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::gfxFontVariation>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_gfxAlternateValue_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::gfxAlternateValue>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::gfxAlternateValue>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::gfxAlternateValue>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::gfxAlternateValue>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_TErrorResult_open0_AssertAndSuppressCleanupPolicy_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::binding_danger::TErrorResult>(),
            16usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::binding_danger::TErrorResult)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::binding_danger::TErrorResult>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::binding_danger::TErrorResult)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_TErrorResult_open0_AssertAndSuppressCleanupPolicy_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::binding_danger::TErrorResult>(),
            16usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::binding_danger::TErrorResult)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::binding_danger::TErrorResult>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::binding_danger::TErrorResult)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_URLParams_Param_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::mozilla::dom::URLParams_Param>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::dom::URLParams_Param>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::mozilla::dom::URLParams_Param>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::dom::URLParams_Param>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_URLParams_DefaultDelete_open1_URLParams_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::dom::URLParams>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::dom::URLParams>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::dom::URLParams>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::dom::URLParams>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_URLParams_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_JSErrorNotes_Note_DeletePolicy_open1_JSErrorNotes_Note_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::JSErrorNotes_Note>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::JSErrorNotes_Note>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::JSErrorNotes_Note>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::JSErrorNotes_Note>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DeletePolicy_open0_JSErrorNotes_Note_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::JS::DeletePolicy>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::JS::DeletePolicy)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::JS::DeletePolicy>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::JS::DeletePolicy)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_JSErrorNotes_DeletePolicy_open1_JSErrorNotes_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::JSErrorNotes>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::JSErrorNotes>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::JSErrorNotes>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::JSErrorNotes>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DeletePolicy_open0_JSErrorNotes_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::JS::DeletePolicy>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::JS::DeletePolicy)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::JS::DeletePolicy>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::JS::DeletePolicy)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_JSErrorNotes_Note_DeletePolicy_open1_JSErrorNotes_Note_close1_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::JSErrorNotes_Note>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::JSErrorNotes_Note>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::JSErrorNotes_Note>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::JSErrorNotes_Note>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DeletePolicy_open0_JSErrorNotes_Note_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::JS::DeletePolicy>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::JS::DeletePolicy)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::JS::DeletePolicy>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::JS::DeletePolicy)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_JSErrorNotes_Note_DeletePolicy_open1_JSErrorNotes_Note_close1_close0_instantiation_2(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::JSErrorNotes_Note>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::JSErrorNotes_Note>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::JSErrorNotes_Note>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::JSErrorNotes_Note>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DeletePolicy_open0_JSErrorNotes_Note_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::JS::DeletePolicy>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::JS::DeletePolicy)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::JS::DeletePolicy>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::JS::DeletePolicy)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_JSErrorNotes_Note_DeletePolicy_open1_JSErrorNotes_Note_close1_close0_instantiation_3(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::JSErrorNotes_Note>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::JSErrorNotes_Note>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::JSErrorNotes_Note>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::JSErrorNotes_Note>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DeletePolicy_open0_JSErrorNotes_Note_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::JS::DeletePolicy>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::JS::DeletePolicy)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::JS::DeletePolicy>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::JS::DeletePolicy)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_JSErrorNotes_DeletePolicy_open1_JSErrorNotes_close1_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::JSErrorNotes>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::JSErrorNotes>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::JSErrorNotes>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::JSErrorNotes>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DeletePolicy_open0_JSErrorNotes_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::JS::DeletePolicy>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::JS::DeletePolicy)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::JS::DeletePolicy>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::JS::DeletePolicy)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_ProfilerBacktrace_ProfilerBacktraceDestructor_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::ProfilerBacktrace>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::ProfilerBacktrace>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::ProfilerBacktrace>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::ProfilerBacktrace>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIPrincipal_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_Heap_open0_Value_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::JS::Heap<root::JS::Value>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::JS::Heap<root::JS::Value>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::JS::Heap<root::JS::Value>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::JS::Heap<root::JS::Value>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_IPCClientInfo_DefaultDelete_open1_IPCClientInfo_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::dom::IPCClientInfo>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::dom::IPCClientInfo>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::dom::IPCClientInfo>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::dom::IPCClientInfo>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_IPCClientInfo_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_IPCServiceWorkerDescriptor_DefaultDelete_open1_IPCServiceWorkerDescriptor_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<
                root::mozilla::UniquePtr<root::mozilla::dom::IPCServiceWorkerDescriptor>,
            >(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(
                    root::mozilla::UniquePtr<root::mozilla::dom::IPCServiceWorkerDescriptor>
                )
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::mozilla::UniquePtr<root::mozilla::dom::IPCServiceWorkerDescriptor>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(
                    root::mozilla::UniquePtr<root::mozilla::dom::IPCServiceWorkerDescriptor>
                )
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_IPCServiceWorkerDescriptor_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsCString_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<::gecko_bindings::structs::nsCString>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsCString>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<::gecko_bindings::structs::nsCString>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsCString>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_LinkedList_open0_DOMEventTargetHelper_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::LinkedList>(),
            24usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::LinkedList)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::LinkedList>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::LinkedList)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIWeakReference_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIEventTarget_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_RawServoCssUrlData_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::RawServoCssUrlData>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::RawServoCssUrlData>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::RawServoCssUrlData>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::RawServoCssUrlData>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_GridNamedArea_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::mozilla::css::GridNamedArea>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::css::GridNamedArea>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::mozilla::css::GridNamedArea>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::css::GridNamedArea>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsString_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<::gecko_bindings::structs::nsString>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsString>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<::gecko_bindings::structs::nsString>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsString>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_imgRequestProxy_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::imgRequestProxy>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::imgRequestProxy>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::imgRequestProxy>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::imgRequestProxy>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_ProxyBehaviour_DefaultDelete_open1_ProxyBehaviour_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::ProxyBehaviour>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::ProxyBehaviour>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::ProxyBehaviour>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::ProxyBehaviour>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_ProxyBehaviour_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsILoadGroup_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_TabGroup_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::TabGroup>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::TabGroup>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::TabGroup>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::TabGroup>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIEventTarget_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsString_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<::gecko_bindings::structs::nsString>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsString>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<::gecko_bindings::structs::nsString>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsString>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsRefPtrHashKey_open0_nsAtom_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsRefPtrHashKey<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsRefPtrHashKey<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsRefPtrHashKey<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsRefPtrHashKey<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_ptr_CounterStyle_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<*mut root::mozilla::CounterStyle>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<*mut root::mozilla::CounterStyle>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<*mut root::mozilla::CounterStyle>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<*mut root::mozilla::CounterStyle>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_StyleGradientItem_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::mozilla::StyleGradientItem>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::StyleGradientItem>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::mozilla::StyleGradientItem>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::StyleGradientItem>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_imgRequestProxy_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::imgRequestProxy>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::imgRequestProxy>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::imgRequestProxy>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::imgRequestProxy>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_URLValue_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::css::URLValue>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::URLValue>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::css::URLValue>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::URLValue>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_ImageTracker_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::ImageTracker>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::ImageTracker>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::ImageTracker>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::ImageTracker>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_DocGroup_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::DocGroup>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DocGroup>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::DocGroup>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DocGroup>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMArray_open0_imgIContainer_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMArray>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMArray)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMArray>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMArray)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_nsStyleSides_DefaultDelete_open1_nsStyleSides_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::nsStyleSides>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsStyleSides>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::nsStyleSides>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsStyleSides>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_nsStyleSides_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_nsStyleSides_DefaultDelete_open1_nsStyleSides_close1_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::nsStyleSides>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsStyleSides>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::nsStyleSides>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsStyleSides>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_nsStyleSides_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_CachedBorderImageData_DefaultDelete_open1_CachedBorderImageData_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::CachedBorderImageData>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::CachedBorderImageData>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::CachedBorderImageData>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::CachedBorderImageData>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_CachedBorderImageData_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_nsStyleSides_DefaultDelete_open1_nsStyleSides_close1_close0_instantiation_2(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::nsStyleSides>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsStyleSides>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::nsStyleSides>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsStyleSides>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_nsStyleSides_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsStyleAutoArray_open0_nsStyleImageLayers_Layer_close0_instantiation()
    {
        assert_eq!(
            ::std::mem::size_of::<root::nsStyleAutoArray<root::nsStyleImageLayers_Layer>>(),
            112usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsStyleAutoArray<root::nsStyleImageLayers_Layer>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsStyleAutoArray<root::nsStyleImageLayers_Layer>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsStyleAutoArray<root::nsStyleImageLayers_Layer>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsStyleImageRequest_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsStyleImageRequest>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsStyleImageRequest>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsStyleImageRequest>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsStyleImageRequest>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsTArray_open1_nsString_close1_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nsTArray<::gecko_bindings::structs::nsString>>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nsTArray<::gecko_bindings::structs::nsString>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nsTArray<::gecko_bindings::structs::nsString>>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nsTArray<::gecko_bindings::structs::nsString>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsString_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<::gecko_bindings::structs::nsString>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsString>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<::gecko_bindings::structs::nsString>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsString>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsStyleCoord_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nsStyleCoord>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nsStyleCoord>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nsStyleCoord>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nsStyleCoord>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsStyleCoord_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nsStyleCoord>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nsStyleCoord>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nsStyleCoord>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nsStyleCoord>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsString_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<::gecko_bindings::structs::nsString>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsString>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<::gecko_bindings::structs::nsString>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsString>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsString_close0_instantiation_4() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<::gecko_bindings::structs::nsString>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsString>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<::gecko_bindings::structs::nsString>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsString>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_nsStyleGridTemplate_DefaultDelete_open1_nsStyleGridTemplate_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::nsStyleGridTemplate>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsStyleGridTemplate>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::nsStyleGridTemplate>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsStyleGridTemplate>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_nsStyleGridTemplate_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_nsStyleGridTemplate_DefaultDelete_open1_nsStyleGridTemplate_close1_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::nsStyleGridTemplate>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsStyleGridTemplate>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::nsStyleGridTemplate>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsStyleGridTemplate>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_nsStyleGridTemplate_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_GridTemplateAreasValue_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::css::GridTemplateAreasValue>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::GridTemplateAreasValue>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::css::GridTemplateAreasValue>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::GridTemplateAreasValue>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_4() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_nsStyleImage_DefaultDelete_open1_nsStyleImage_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::nsStyleImage>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsStyleImage>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::nsStyleImage>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsStyleImage>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_nsStyleImage_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_StyleBasicShape_DefaultDelete_open1_StyleGenericBasicShape_open2_StyleLengthPercentage_StyleLengthPercentage_StyleLengthPercentage_StyleLengthPercentage_close2_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::StyleBasicShape>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::StyleBasicShape>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::StyleBasicShape>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::StyleBasicShape>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_StyleGenericBasicShape_open1_StyleLengthPercentage_StyleLengthPercentage_StyleLengthPercentage_StyleLengthPercentage_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_StyleSVGPath_DefaultDelete_open1_StyleSVGPath_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::StyleSVGPath>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::StyleSVGPath>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::StyleSVGPath>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::StyleSVGPath>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_StyleSVGPath_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_StyleBasicShape_DefaultDelete_open1_StyleGenericBasicShape_open2_StyleLengthPercentage_StyleLengthPercentage_StyleLengthPercentage_StyleLengthPercentage_close2_close1_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::StyleBasicShape>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::StyleBasicShape>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::StyleBasicShape>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::StyleBasicShape>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_StyleGenericBasicShape_open1_StyleLengthPercentage_StyleLengthPercentage_StyleLengthPercentage_StyleLengthPercentage_close1_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_nsStyleImage_DefaultDelete_open1_nsStyleImage_close1_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::nsStyleImage>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsStyleImage>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::nsStyleImage>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsStyleImage>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_nsStyleImage_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_StyleSVGPath_DefaultDelete_open1_StyleSVGPath_close1_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::StyleSVGPath>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::StyleSVGPath>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::StyleSVGPath>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::StyleSVGPath>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_StyleSVGPath_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_URLValue_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::css::URLValue>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::URLValue>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::css::URLValue>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::URLValue>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_Position_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::mozilla::Position>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::Position>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::mozilla::Position>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::Position>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_StyleMotion_DefaultDelete_open1_StyleMotion_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::StyleMotion>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::StyleMotion>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::StyleMotion>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::StyleMotion>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_StyleMotion_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsStyleAutoArray_open0_StyleTransition_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsStyleAutoArray<root::mozilla::StyleTransition>>(),
            48usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsStyleAutoArray<root::mozilla::StyleTransition>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsStyleAutoArray<root::mozilla::StyleTransition>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsStyleAutoArray<root::mozilla::StyleTransition>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsStyleAutoArray_open0_StyleAnimation_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsStyleAutoArray<root::mozilla::StyleAnimation>>(),
            56usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsStyleAutoArray<root::mozilla::StyleAnimation>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsStyleAutoArray<root::mozilla::StyleAnimation>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsStyleAutoArray<root::mozilla::StyleAnimation>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_5() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_6() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_7() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_8() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsStyleContentData_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nsStyleContentData>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nsStyleContentData>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nsStyleContentData>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nsStyleContentData>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsStyleCounterData_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nsStyleCounterData>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nsStyleCounterData>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nsStyleCounterData>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nsStyleCounterData>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsStyleCounterData_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nsStyleCounterData>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nsStyleCounterData>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nsStyleCounterData>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nsStyleCounterData>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsStyleCounterData_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nsStyleCounterData>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nsStyleCounterData>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nsStyleCounterData>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nsStyleCounterData>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsStyleImageRequest_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsStyleImageRequest>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsStyleImageRequest>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsStyleImageRequest>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsStyleImageRequest>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsCursorImage_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nsCursorImage>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nsCursorImage>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nsCursorImage>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nsCursorImage>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_URLValue_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::css::URLValue>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::URLValue>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::css::URLValue>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::URLValue>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_URLValue_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::css::URLValue>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::URLValue>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::css::URLValue>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::URLValue>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_URLValue_close0_instantiation_4() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::css::URLValue>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::URLValue>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::css::URLValue>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::URLValue>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_NonNegativeLengthPercentage_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::mozilla::NonNegativeLengthPercentage>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::NonNegativeLengthPercentage>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::mozilla::NonNegativeLengthPercentage>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::NonNegativeLengthPercentage>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsStyleFilter_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nsStyleFilter>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nsStyleFilter>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nsStyleFilter>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nsStyleFilter>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_ptr_nsISupports_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<*mut root::nsISupports>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<*mut root::nsISupports>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<*mut root::nsISupports>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<*mut root::nsISupports>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_RawServoAnimationValue_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::RawServoAnimationValue>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::RawServoAnimationValue>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::RawServoAnimationValue>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::RawServoAnimationValue>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_4() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsCString_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<::gecko_bindings::structs::nsCString>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsCString>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<::gecko_bindings::structs::nsCString>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsCString>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsISerialEventTarget_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_5() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_6() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_7() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIPrincipal_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_StyleSheet_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::StyleSheet>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::StyleSheet>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::StyleSheet>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::StyleSheet>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_RawServoStyleSheetContents_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::RawServoStyleSheetContents>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::RawServoStyleSheetContents>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::RawServoStyleSheetContents>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::RawServoStyleSheetContents>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsLayoutStylesheetCacheShm_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsLayoutStylesheetCacheShm>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsLayoutStylesheetCacheShm>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsLayoutStylesheetCacheShm>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsLayoutStylesheetCacheShm>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_URLExtraData_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::URLExtraData>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::URLExtraData>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::URLExtraData>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::URLExtraData>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_StyleSheet_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::StyleSheet>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::StyleSheet>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::StyleSheet>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::StyleSheet>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_MediaList_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::MediaList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::MediaList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::MediaList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::MediaList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_StyleSheet_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::StyleSheet>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::StyleSheet>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::StyleSheet>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::StyleSheet>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_ptr_ServoStyleSet_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<*mut root::mozilla::ServoStyleSet>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<*mut root::mozilla::ServoStyleSet>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<*mut root::mozilla::ServoStyleSet>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<*mut root::mozilla::ServoStyleSet>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_ServoCSSRuleList_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::ServoCSSRuleList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::ServoCSSRuleList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::ServoCSSRuleList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::ServoCSSRuleList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_MozPromiseHolder_open0_StyleSheetParsePromise_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<
                root::mozilla::MozPromiseHolder<root::mozilla::StyleSheetParsePromise>,
            >(),
            16usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::MozPromiseHolder<root::mozilla::StyleSheetParsePromise>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::mozilla::MozPromiseHolder<root::mozilla::StyleSheetParsePromise>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::MozPromiseHolder<root::mozilla::StyleSheetParsePromise>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_8() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIPrincipal_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsNodeInfoManager_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsNodeInfoManager>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsNodeInfoManager>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsNodeInfoManager>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsNodeInfoManager>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsPtrHashKey_open0_NodeInfo_NodeInfoInner_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsPtrHashKey<root::mozilla::dom::NodeInfo_NodeInfoInner>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsPtrHashKey<root::mozilla::dom::NodeInfo_NodeInfoInner>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsPtrHashKey<root::mozilla::dom::NodeInfo_NodeInfoInner>>(
            ),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsPtrHashKey<root::mozilla::dom::NodeInfo_NodeInfoInner>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIPrincipal_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIPrincipal_close0_instantiation_4() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsBindingManager_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsBindingManager>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsBindingManager>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsBindingManager>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsBindingManager>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAttrChildContentList_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAttrChildContentList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAttrChildContentList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAttrChildContentList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAttrChildContentList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_LinkedList_open1_nsRange_close1_DefaultDelete_open1_LinkedList_open2_nsRange_close2_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::LinkedList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::LinkedList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::LinkedList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::LinkedList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_LinkedList_open1_nsRange_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_LinkedList_open1_nsRange_close1_DefaultDelete_open1_LinkedList_open2_nsRange_close2_close1_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::LinkedList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::LinkedList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::LinkedList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::LinkedList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_LinkedList_open1_nsRange_close1_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_NodeInfo_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::NodeInfo>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::NodeInfo>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::NodeInfo>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::NodeInfo>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIContent_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIContent_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIPrincipal_close0_instantiation_5() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_StyleSheet_close1_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::RefPtr<root::mozilla::StyleSheet>>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::StyleSheet>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::RefPtr<root::mozilla::StyleSheet>>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::StyleSheet>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_StyleSheet_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::StyleSheet>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::StyleSheet>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::StyleSheet>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::StyleSheet>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_SheetLoadData_close1_close0_instantiation()
    {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::RefPtr<root::mozilla::css::SheetLoadData>>>(
            ),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::css::SheetLoadData>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::RefPtr<root::mozilla::css::SheetLoadData>>>(
            ),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::css::SheetLoadData>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_SheetLoadData_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::css::SheetLoadData>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::SheetLoadData>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::css::SheetLoadData>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::SheetLoadData>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_StyleSheet_close0_instantiation_4() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::StyleSheet>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::StyleSheet>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::StyleSheet>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::StyleSheet>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_Loader_Sheets_DefaultDelete_open1_Loader_Sheets_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::css::Loader_Sheets>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::css::Loader_Sheets>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::css::Loader_Sheets>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::css::Loader_Sheets>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_Loader_Sheets_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsICSSLoaderObserver_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_DocGroup_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::DocGroup>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DocGroup>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::DocGroup>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DocGroup>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIConsoleReportCollector_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_Decoder_DefaultDelete_open1_Decoder_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::Decoder>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::Decoder>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::Decoder>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::Decoder>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_Decoder_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_Decoder_DefaultDelete_open1_Decoder_close1_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::Decoder>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::Decoder>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::Decoder>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::Decoder>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_Decoder_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_Decoder_DefaultDelete_open1_Decoder_close1_close0_instantiation_2(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::Decoder>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::Decoder>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::Decoder>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::Decoder>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_Decoder_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_Encoder_DefaultDelete_open1_Encoder_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::Encoder>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::Encoder>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::Encoder>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::Encoder>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_Encoder_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Loader_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::css::Loader>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::Loader>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::css::Loader>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::Loader>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_9() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_StyleSheet_close0_instantiation_5() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::StyleSheet>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::StyleSheet>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::StyleSheet>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::StyleSheet>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_SheetLoadData_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::css::SheetLoadData>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::SheetLoadData>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::css::SheetLoadData>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::SheetLoadData>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIStyleSheetLinkingElement_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsICSSLoaderObserver_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIPrincipal_close0_instantiation_6() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsINode_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_RawServoDeclarationBlock_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::RawServoDeclarationBlock>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::RawServoDeclarationBlock>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::RawServoDeclarationBlock>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::RawServoDeclarationBlock>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_AttrArray_Impl_DefaultDelete_open1_AttrArray_Impl_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::AttrArray_Impl>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::AttrArray_Impl>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::AttrArray_Impl>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::AttrArray_Impl>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_AttrArray_Impl_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIGlobalObject_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_CallbackObject_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::CallbackObject>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::CallbackObject>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::CallbackObject>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::CallbackObject>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_Heap_open0_ptr_JSObject_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::JS::Heap<*mut root::JSObject>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::JS::Heap<*mut root::JSObject>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::JS::Heap<*mut root::JSObject>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::JS::Heap<*mut root::JSObject>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_Heap_open0_ptr_JSObject_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::JS::Heap<*mut root::JSObject>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::JS::Heap<*mut root::JSObject>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::JS::Heap<*mut root::JSObject>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::JS::Heap<*mut root::JSObject>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_Heap_open0_ptr_JSObject_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::JS::Heap<*mut root::JSObject>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::JS::Heap<*mut root::JSObject>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::JS::Heap<*mut root::JSObject>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::JS::Heap<*mut root::JSObject>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIGlobalObject_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_TenuredHeap_open0_ptr_JSObject_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::JS::TenuredHeap>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::JS::TenuredHeap)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::JS::TenuredHeap>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::JS::TenuredHeap)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_EventTarget_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsPIDOMWindowInner_Document_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsPIDOMWindowInner_Document>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsPIDOMWindowInner_Document>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsPIDOMWindowInner_Document>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsPIDOMWindowInner_Document>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_10() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_11() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_EventTarget_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Performance_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Performance>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Performance>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Performance>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Performance>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_TimeoutManager_DefaultDelete_open1_TimeoutManager_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::dom::TimeoutManager>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::dom::TimeoutManager>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::dom::TimeoutManager>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::dom::TimeoutManager>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_TimeoutManager_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Navigator_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Navigator>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Navigator>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Navigator>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Navigator>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsPIDOMWindowOuter_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Element_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Element>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Element>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_ptr_AudioContext_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<*mut root::mozilla::dom::AudioContext>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<*mut root::mozilla::dom::AudioContext>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<*mut root::mozilla::dom::AudioContext>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<*mut root::mozilla::dom::AudioContext>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_TabGroup_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::TabGroup>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::TabGroup>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::TabGroup>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::TabGroup>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsPIDOMWindowInner_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_ReportingObserver_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<
                root::nsTArray<root::RefPtr<root::mozilla::dom::ReportingObserver>>,
            >(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::dom::ReportingObserver>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::nsTArray<root::RefPtr<root::mozilla::dom::ReportingObserver>>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::dom::ReportingObserver>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_Report_close1_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::RefPtr<root::mozilla::dom::Report>>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::dom::Report>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::RefPtr<root::mozilla::dom::Report>>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::dom::Report>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsCString_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<::gecko_bindings::structs::nsCString>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsCString>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<::gecko_bindings::structs::nsCString>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsCString>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_WindowGlobalChild_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::WindowGlobalChild>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::WindowGlobalChild>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::WindowGlobalChild>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::WindowGlobalChild>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsCOMPtr_open1_nsIRunnable_close1_close0_instantiation()
    {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nsCOMPtr>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nsCOMPtr>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nsCOMPtr>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nsCOMPtr>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIRunnable_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_EventTarget_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsPIDOMWindowOuter_Document_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsPIDOMWindowOuter_Document>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsPIDOMWindowOuter_Document>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsPIDOMWindowOuter_Document>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsPIDOMWindowOuter_Document>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_12() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_EventTarget_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_ContentFrameMessageManager_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::ContentFrameMessageManager>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::ContentFrameMessageManager>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::ContentFrameMessageManager>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::ContentFrameMessageManager>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_Element_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIDocShell_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_BrowsingContext_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::BrowsingContext>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::BrowsingContext>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::BrowsingContext>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::BrowsingContext>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_TabGroup_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::TabGroup>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::TabGroup>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::TabGroup>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::TabGroup>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_BrowsingContext_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::BrowsingContext>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::BrowsingContext>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::BrowsingContext>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::BrowsingContext>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsRefPtrHashKey_open0_nsAtom_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsRefPtrHashKey<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsRefPtrHashKey<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsRefPtrHashKey<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsRefPtrHashKey<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_9() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_LangGroupFontPrefs_DefaultDelete_open1_LangGroupFontPrefs_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::LangGroupFontPrefs>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::LangGroupFontPrefs>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::LangGroupFontPrefs>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::LangGroupFontPrefs>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_LangGroupFontPrefs_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_BrowsingContext_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::RefPtr<root::mozilla::dom::BrowsingContext>>>(
            ),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::dom::BrowsingContext>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::RefPtr<root::mozilla::dom::BrowsingContext>>>(
            ),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::dom::BrowsingContext>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_BrowsingContext_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::BrowsingContext>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::BrowsingContext>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::BrowsingContext>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::BrowsingContext>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_BrowsingContextGroup_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::BrowsingContextGroup>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::BrowsingContextGroup>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::BrowsingContextGroup>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::BrowsingContextGroup>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_BrowsingContext_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::BrowsingContext>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::BrowsingContext>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::BrowsingContext>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::BrowsingContext>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIDocShell_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Element_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Element>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Element>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_Heap_open0_ptr_JSObject_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::JS::Heap<*mut root::JSObject>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::JS::Heap<*mut root::JSObject>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::JS::Heap<*mut root::JSObject>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::JS::Heap<*mut root::JSObject>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_JSONWriteFunc_DefaultDelete_open1_JSONWriteFunc_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::JSONWriteFunc>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::JSONWriteFunc>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::JSONWriteFunc>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::JSONWriteFunc>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_JSONWriteFunc_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_JSONWriteFunc_DefaultDelete_open1_JSONWriteFunc_close1_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::JSONWriteFunc>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::JSONWriteFunc>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::JSONWriteFunc>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::JSONWriteFunc>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_JSONWriteFunc_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsCString_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<::gecko_bindings::structs::nsCString>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsCString>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<::gecko_bindings::structs::nsCString>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsCString>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_ContentBlockingLog_LogEntry_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::mozilla::dom::ContentBlockingLog_LogEntry>>(
            ),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::dom::ContentBlockingLog_LogEntry>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::mozilla::dom::ContentBlockingLog_LogEntry>>(
            ),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::dom::ContentBlockingLog_LogEntry>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_ContentBlockingLog_OriginDataEntry_DefaultDelete_open1_ContentBlockingLog_OriginDataEntry_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<
                root::mozilla::UniquePtr<root::mozilla::dom::ContentBlockingLog_OriginDataEntry>,
            >(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(
                    root::mozilla::UniquePtr<
                        root::mozilla::dom::ContentBlockingLog_OriginDataEntry,
                    >
                )
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::mozilla::UniquePtr<root::mozilla::dom::ContentBlockingLog_OriginDataEntry>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(
                    root::mozilla::UniquePtr<
                        root::mozilla::dom::ContentBlockingLog_OriginDataEntry,
                    >
                )
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_ContentBlockingLog_OriginDataEntry_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_ContentBlockingLog_OriginEntry_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::mozilla::dom::ContentBlockingLog_OriginEntry>>(
            ),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::dom::ContentBlockingLog_OriginEntry>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::nsTArray<root::mozilla::dom::ContentBlockingLog_OriginEntry>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::dom::ContentBlockingLog_OriginEntry>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_10() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_TreeOrderedArray_open0_IdentifierMapEntry_Element_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::dom::TreeOrderedArray>(),
            24usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::dom::TreeOrderedArray)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::dom::TreeOrderedArray>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::dom::TreeOrderedArray)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsBaseContentList_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsBaseContentList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsBaseContentList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsBaseContentList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsBaseContentList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsAutoPtr_open0_nsTHashtable_open1_IdentifierMapEntry_ChangeCallbackEntry_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<u64>(),
            8usize,
            concat!("Size of template specialization: ", stringify!(u64))
        );
        assert_eq!(
            ::std::mem::align_of::<u64>(),
            8usize,
            concat!("Alignment of template specialization: ", stringify!(u64))
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_IdentifierMapEntry_Element_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::IdentifierMapEntry_Element>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::IdentifierMapEntry_Element>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::IdentifierMapEntry_Element>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::IdentifierMapEntry_Element>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_StyleSheet_close1_close0_instantiation_1()
    {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::RefPtr<root::mozilla::StyleSheet>>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::StyleSheet>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::RefPtr<root::mozilla::StyleSheet>>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::StyleSheet>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_StyleSheet_close0_instantiation_6() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::StyleSheet>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::StyleSheet>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::StyleSheet>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::StyleSheet>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_StyleSheetList_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::StyleSheetList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::StyleSheetList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::StyleSheetList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::StyleSheetList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_11() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIObserver_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Document_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIContentViewer_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsILoadGroup_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Document_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIStreamListener_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_13() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIInterfaceRequestor_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIInterfaceRequestor_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsILoadContext_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIInterfaceRequestor_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIProgressEventSink_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIInterfaceRequestor_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIChannelEventSink_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIInterfaceRequestor_close0_instantiation_4() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIApplicationCacheContainer_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Document_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_RawServoSelectorList_DefaultDelete_open1_RawServoSelectorList_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::RawServoSelectorList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::RawServoSelectorList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::RawServoSelectorList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::RawServoSelectorList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_RawServoSelectorList_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_FrameRequestCallback_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::FrameRequestCallback>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::FrameRequestCallback>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::FrameRequestCallback>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::FrameRequestCallback>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsPtrHashKey_open0_ShadowRoot_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsPtrHashKey<root::mozilla::dom::ShadowRoot>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsPtrHashKey<root::mozilla::dom::ShadowRoot>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsPtrHashKey<root::mozilla::dom::ShadowRoot>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsPtrHashKey<root::mozilla::dom::ShadowRoot>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_DocumentL10n_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::DocumentL10n>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DocumentL10n>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::DocumentL10n>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DocumentL10n>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsString_close0_instantiation_5() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<::gecko_bindings::structs::nsString>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsString>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<::gecko_bindings::structs::nsString>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsString>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIApplicationCache_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_Document_SelectorCache_DefaultDelete_open1_Document_SelectorCache_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<
                root::mozilla::UniquePtr<root::mozilla::dom::Document_SelectorCache>,
            >(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::dom::Document_SelectorCache>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::mozilla::UniquePtr<root::mozilla::dom::Document_SelectorCache>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::dom::Document_SelectorCache>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_Document_SelectorCache_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_ServoStyleSet_DefaultDelete_open1_ServoStyleSet_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::ServoStyleSet>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::ServoStyleSet>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::ServoStyleSet>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::ServoStyleSet>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_ServoStyleSet_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_14() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_15() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_16() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_17() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_18() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_URLExtraData_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::URLExtraData>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::URLExtraData>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::URLExtraData>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::URLExtraData>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_NotNull_open0_ptr_const_mozilla__Encoding_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::NotNull<*const root::mozilla::Encoding>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::NotNull<*const root::mozilla::Encoding>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::NotNull<*const root::mozilla::Encoding>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::NotNull<*const root::mozilla::Encoding>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Loader_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::css::Loader>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::Loader>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::css::Loader>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::Loader>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_ImageLoader_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::css::ImageLoader>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::ImageLoader>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::css::ImageLoader>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::css::ImageLoader>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsHTMLStyleSheet_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsHTMLStyleSheet>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsHTMLStyleSheet>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsHTMLStyleSheet>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsHTMLStyleSheet>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsHTMLCSSStyleSheet_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsHTMLCSSStyleSheet>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsHTMLCSSStyleSheet>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsHTMLCSSStyleSheet>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsHTMLCSSStyleSheet>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_ImageTracker_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::ImageTracker>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::ImageTracker>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::ImageTracker>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::ImageTracker>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsPtrHashKey_open0_SVGUseElement_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsPtrHashKey<root::mozilla::dom::SVGUseElement>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsPtrHashKey<root::mozilla::dom::SVGUseElement>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsPtrHashKey<root::mozilla::dom::SVGUseElement>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsPtrHashKey<root::mozilla::dom::SVGUseElement>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsAutoPtr_open0_nsTHashtable_open1_nsPtrHashKey_open2_nsISupports_close2_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<u64>(),
            8usize,
            concat!("Size of template specialization: ", stringify!(u64))
        );
        assert_eq!(
            ::std::mem::align_of::<u64>(),
            8usize,
            concat!("Alignment of template specialization: ", stringify!(u64))
        );
    }
    #[test]
    fn __bindgen_test_layout_nsPtrHashKey_open0_Link_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsPtrHashKey<root::mozilla::dom::Link>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsPtrHashKey<root::mozilla::dom::Link>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsPtrHashKey<root::mozilla::dom::Link>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsPtrHashKey<root::mozilla::dom::Link>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_Link_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_SMILAnimationController_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::SMILAnimationController>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::SMILAnimationController>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::SMILAnimationController>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::SMILAnimationController>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIHTMLCollection_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsContentList_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsContentList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsContentList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsContentList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsContentList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsContentList_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsContentList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsContentList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsContentList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsContentList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsContentList_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsContentList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsContentList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsContentList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsContentList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsContentList_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsContentList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsContentList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsContentList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsContentList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsContentList_close0_instantiation_4() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsContentList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsContentList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsContentList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsContentList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIHTMLCollection_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsContentList_close0_instantiation_5() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsContentList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsContentList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsContentList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsContentList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_FontFaceSet_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::FontFaceSet>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::FontFaceSet>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::FontFaceSet>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::FontFaceSet>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Promise_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Promise>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Promise>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Promise>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Promise>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_FeaturePolicy_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::FeaturePolicy>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::FeaturePolicy>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::FeaturePolicy>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::FeaturePolicy>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_ResizeObserverController_DefaultDelete_open1_ResizeObserverController_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<
                root::mozilla::UniquePtr<root::mozilla::dom::ResizeObserverController>,
            >(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::dom::ResizeObserverController>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::mozilla::UniquePtr<root::mozilla::dom::ResizeObserverController>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::dom::ResizeObserverController>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_ResizeObserverController_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIScriptGlobalObject_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Document_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIChannel_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsISupports_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIChannel_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMArray_open0_nsINode_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMArray>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMArray)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMArray>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMArray)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Document_close0_instantiation_4() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_ChannelEventQueue_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<
                root::nsTArray<root::RefPtr<root::mozilla::net::ChannelEventQueue>>,
            >(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::net::ChannelEventQueue>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::nsTArray<root::RefPtr<root::mozilla::net::ChannelEventQueue>>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::net::ChannelEventQueue>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_EventListener_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::EventListener>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::EventListener>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::EventListener>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::EventListener>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsWeakPtr_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nsWeakPtr>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nsWeakPtr>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nsWeakPtr>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nsWeakPtr>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIDocumentEncoder_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_Document_FrameRequest_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::mozilla::dom::Document_FrameRequest>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::dom::Document_FrameRequest>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::mozilla::dom::Document_FrameRequest>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::dom::Document_FrameRequest>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultHasher_open0_int_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultHasher>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultHasher)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultHasher>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultHasher)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIStructuredCloneContainer_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIVariant_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_XPathEvaluator_DefaultDelete_open1_XPathEvaluator_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::dom::XPathEvaluator>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::dom::XPathEvaluator>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::dom::XPathEvaluator>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::dom::XPathEvaluator>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_XPathEvaluator_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_AnonymousContent_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::RefPtr<root::mozilla::dom::AnonymousContent>>>(
            ),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::dom::AnonymousContent>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::nsTArray<root::RefPtr<root::mozilla::dom::AnonymousContent>>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::dom::AnonymousContent>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_LinkedList_open0_MediaQueryList_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::LinkedList>(),
            24usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::LinkedList)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::LinkedList>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::LinkedList)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_StyleUseCounters_DefaultDelete_open1_StyleUseCounters_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::StyleUseCounters>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::StyleUseCounters>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::StyleUseCounters>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::StyleUseCounters>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_StyleUseCounters_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsINode_DocGroup_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsINode_DocGroup>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsINode_DocGroup>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsINode_DocGroup>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsINode_DocGroup>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsCOMPtr_open1_nsIPrincipal_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nsCOMPtr>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nsCOMPtr>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nsCOMPtr>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nsCOMPtr>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIPrincipal_close0_instantiation_7() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_uint64_t_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<u64>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<u64>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<u64>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<u64>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIParser_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsXULPrototypeDocument_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsXULPrototypeDocument>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsXULPrototypeDocument>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsXULPrototypeDocument>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsXULPrototypeDocument>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsRevocableEventPtr_open0_nsRunnableMethod_open1_Document_void_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<u64>(),
            8usize,
            concat!("Size of template specialization: ", stringify!(u64))
        );
        assert_eq!(
            ::std::mem::align_of::<u64>(),
            8usize,
            concat!("Alignment of template specialization: ", stringify!(u64))
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsDOMNavigationTiming_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsDOMNavigationTiming>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsDOMNavigationTiming>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsDOMNavigationTiming>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsDOMNavigationTiming>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsPtrHashKey_open0_DOMIntersectionObserver_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsPtrHashKey<root::mozilla::dom::DOMIntersectionObserver>>(
            ),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsPtrHashKey<root::mozilla::dom::DOMIntersectionObserver>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsPtrHashKey<root::mozilla::dom::DOMIntersectionObserver>>(
            ),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsPtrHashKey<root::mozilla::dom::DOMIntersectionObserver>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsWeakPtr_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nsWeakPtr>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nsWeakPtr>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nsWeakPtr>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nsWeakPtr>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_DOMImplementation_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::DOMImplementation>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DOMImplementation>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::DOMImplementation>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DOMImplementation>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsContentList_close0_instantiation_6() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsContentList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsContentList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsContentList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsContentList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsPtrHashKey_open0_HTMLImageElement_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsPtrHashKey<root::mozilla::dom::HTMLImageElement>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsPtrHashKey<root::mozilla::dom::HTMLImageElement>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsPtrHashKey<root::mozilla::dom::HTMLImageElement>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsPtrHashKey<root::mozilla::dom::HTMLImageElement>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsPtrHashKey_open0_nsIObjectLoadingContent_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsPtrHashKey<root::nsIObjectLoadingContent>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsPtrHashKey<root::nsIObjectLoadingContent>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsPtrHashKey<root::nsIObjectLoadingContent>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsPtrHashKey<root::nsIObjectLoadingContent>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_DocumentTimeline_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::DocumentTimeline>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DocumentTimeline>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::DocumentTimeline>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DocumentTimeline>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_LinkedList_open0_DocumentTimeline_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::LinkedList>(),
            24usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::LinkedList)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::LinkedList>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::LinkedList)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_ScriptLoader_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::ScriptLoader>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::ScriptLoader>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::ScriptLoader>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::ScriptLoader>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_PendingAnimationTracker_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::PendingAnimationTracker>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::PendingAnimationTracker>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::PendingAnimationTracker>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::PendingAnimationTracker>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Document_close0_instantiation_5() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Promise_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Promise>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Promise>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Promise>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Promise>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_nsFrameLoader_close1_close0_instantiation()
    {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::RefPtr<root::nsFrameLoader>>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsFrameLoader>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::RefPtr<root::nsFrameLoader>>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsFrameLoader>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsCOMPtr_open1_nsIRunnable_close1_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nsCOMPtr>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nsCOMPtr>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nsCOMPtr>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nsCOMPtr>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIRunnable_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsRunnableMethod_open1_Document_void_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<u64>(),
            8usize,
            concat!("Size of template specialization: ", stringify!(u64))
        );
        assert_eq!(
            ::std::mem::align_of::<u64>(),
            8usize,
            concat!("Alignment of template specialization: ", stringify!(u64))
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsILayoutHistoryState_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_EventListenerManager_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::EventListenerManager>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::EventListenerManager>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::EventListenerManager>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::EventListenerManager>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIRunnable_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIRequest_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_StyleSheet_close1_close0_instantiation_2()
    {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::RefPtr<root::mozilla::StyleSheet>>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::StyleSheet>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::RefPtr<root::mozilla::StyleSheet>>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::StyleSheet>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_StyleSheet_close0_instantiation_7() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::StyleSheet>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::StyleSheet>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::StyleSheet>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::StyleSheet>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_DOMStyleSheetSetList_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::DOMStyleSheetSetList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DOMStyleSheetSetList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::DOMStyleSheetSetList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DOMStyleSheetSetList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsPtrHashKey_open0_SVGElement_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsPtrHashKey<root::mozilla::dom::SVGElement>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsPtrHashKey<root::mozilla::dom::SVGElement>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsPtrHashKey<root::mozilla::dom::SVGElement>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsPtrHashKey<root::mozilla::dom::SVGElement>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsRefPtrHashKey_open0_nsAtom_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::nsRefPtrHashKey<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsRefPtrHashKey<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsRefPtrHashKey<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsRefPtrHashKey<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_12() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsINode_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIDOMXULCommandDispatcher_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_XULBroadcastManager_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::XULBroadcastManager>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::XULBroadcastManager>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::XULBroadcastManager>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::XULBroadcastManager>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_XULPersist_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::XULPersist>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::XULPersist>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::XULPersist>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::XULPersist>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsICookieSettings_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIPrincipal_close0_instantiation_8() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsISupports_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_DOMRect_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::DOMRect>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DOMRect>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::DOMRect>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DOMRect>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_DOMRect_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::DOMRect>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DOMRect>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::DOMRect>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DOMRect>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_DOMRect_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::DOMRect>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DOMRect>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::DOMRect>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DOMRect>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Element_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Element>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Element>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsPIDOMWindowInner_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Document_close0_instantiation_6() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_IntersectionCallback_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::IntersectionCallback>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::IntersectionCallback>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::IntersectionCallback>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::IntersectionCallback>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Element_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Element>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Element>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_double_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<f64>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<f64>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<f64>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<f64>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_ptr_Element_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<*mut root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<*mut root::mozilla::dom::Element>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<*mut root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<*mut root::mozilla::dom::Element>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_DOMIntersectionObserverEntry_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<
                root::nsTArray<root::RefPtr<root::mozilla::dom::DOMIntersectionObserverEntry>>,
            >(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(
                    root::nsTArray<root::RefPtr<root::mozilla::dom::DOMIntersectionObserverEntry>>
                )
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::nsTArray<root::RefPtr<root::mozilla::dom::DOMIntersectionObserverEntry>>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(
                    root::nsTArray<root::RefPtr<root::mozilla::dom::DOMIntersectionObserverEntry>>
                )
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_DOMIntersectionObserverEntry_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::DOMIntersectionObserverEntry>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DOMIntersectionObserverEntry>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::DOMIntersectionObserverEntry>>(
            ),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::DOMIntersectionObserverEntry>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_BaseTransactionId_open0_TransactionIdType_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::layers::BaseTransactionId>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::layers::BaseTransactionId)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::layers::BaseTransactionId>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::layers::BaseTransactionId)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_const_char_FreePolicy_open1_const_char_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<::std::os::raw::c_char>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<::std::os::raw::c_char>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<::std::os::raw::c_char>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<::std::os::raw::c_char>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_FreePolicy_open0_const_char_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::detail::FreePolicy>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::detail::FreePolicy)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::detail::FreePolicy>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::detail::FreePolicy)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIWidget_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsIWidget_LayoutDeviceIntRect_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nsIWidget_LayoutDeviceIntRect>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nsIWidget_LayoutDeviceIntRect>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nsIWidget_LayoutDeviceIntRect>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nsIWidget_LayoutDeviceIntRect>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIObserver_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_nsIWidget_LongTapInfo_DefaultDelete_open1_nsIWidget_LongTapInfo_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::nsIWidget_LongTapInfo>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsIWidget_LongTapInfo>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::nsIWidget_LongTapInfo>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsIWidget_LongTapInfo>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_nsIWidget_LongTapInfo_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsITimer_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIWidget_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIWidget_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_13() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_EventTarget_close0_instantiation_4() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_EventTarget_close0_instantiation_5() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_EventTarget_close0_instantiation_6() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_EventTarget_close0_instantiation_7() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_EventTarget_close0_instantiation_8() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_uint8_t_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<u8>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<u8>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<u8>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<u8>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIWidget_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIContent_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIContent_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_ShadowRoot_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::ShadowRoot>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::ShadowRoot>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::ShadowRoot>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::ShadowRoot>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_HTMLSlotElement_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::HTMLSlotElement>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::HTMLSlotElement>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::HTMLSlotElement>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::HTMLSlotElement>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsRefPtrHashKey_open0_nsAtom_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::nsRefPtrHashKey<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsRefPtrHashKey<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsRefPtrHashKey<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsRefPtrHashKey<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_nsAtom_close1_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::RefPtr<root::nsAtom>>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsAtom>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::RefPtr<root::nsAtom>>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsAtom>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_14() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIRunnable_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsDOMAttributeMap_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsDOMAttributeMap>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsDOMAttributeMap>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsDOMAttributeMap>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsDOMAttributeMap>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsDOMAttributeMap_Element_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsPoint_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nsPoint>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nsPoint>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nsPoint>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nsPoint>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nscoord_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nscoord>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nscoord>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nscoord>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nscoord>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nscoord_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nscoord>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nscoord>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nscoord>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nscoord>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_ScrollSnapInfo_ScrollSnapRange_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<
                root::nsTArray<root::mozilla::layers::ScrollSnapInfo_ScrollSnapRange>,
            >(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::layers::ScrollSnapInfo_ScrollSnapRange>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::nsTArray<root::mozilla::layers::ScrollSnapInfo_ScrollSnapRange>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::layers::ScrollSnapInfo_ScrollSnapRange>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_ScrollSnapInfo_ScrollSnapRange_close0_instantiation_1()
    {
        assert_eq!(
            ::std::mem::size_of::<
                root::nsTArray<root::mozilla::layers::ScrollSnapInfo_ScrollSnapRange>,
            >(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::layers::ScrollSnapInfo_ScrollSnapRange>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::nsTArray<root::mozilla::layers::ScrollSnapInfo_ScrollSnapRange>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::layers::ScrollSnapInfo_ScrollSnapRange>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsRect_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nsRect>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nsRect>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nsRect>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nsRect>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Document_close0_instantiation_7() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsDeviceContext_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsDeviceContext>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsDeviceContext>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsDeviceContext>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsDeviceContext>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_EventStateManager_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::EventStateManager>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::EventStateManager>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::EventStateManager>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::EventStateManager>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsRefreshDriver_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsRefreshDriver>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsRefreshDriver>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsRefreshDriver>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsRefreshDriver>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_AnimationEventDispatcher_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::AnimationEventDispatcher>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::AnimationEventDispatcher>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::AnimationEventDispatcher>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::AnimationEventDispatcher>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_EffectCompositor_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::EffectCompositor>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::EffectCompositor>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::EffectCompositor>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::EffectCompositor>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_nsTransitionManager_DefaultDelete_open1_nsTransitionManager_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::nsTransitionManager>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsTransitionManager>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::nsTransitionManager>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsTransitionManager>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_nsTransitionManager_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_nsAnimationManager_DefaultDelete_open1_nsAnimationManager_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::nsAnimationManager>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsAnimationManager>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::nsAnimationManager>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsAnimationManager>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_nsAnimationManager_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_RestyleManager_DefaultDelete_open1_RestyleManager_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::RestyleManager>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::RestyleManager>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::RestyleManager>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::RestyleManager>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_RestyleManager_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_CounterStyleManager_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::CounterStyleManager>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::CounterStyleManager>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::CounterStyleManager>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::CounterStyleManager>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_15() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_gfxFontFeatureValueSet_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::gfxFontFeatureValueSet>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::gfxFontFeatureValueSet>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::gfxFontFeatureValueSet>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::gfxFontFeatureValueSet>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsITheme_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIPrintSettings_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_nsBidi_DefaultDelete_open1_nsBidi_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::nsBidi>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsBidi>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::nsBidi>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsBidi>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_nsBidi_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_gfxTextPerfMetrics_DefaultDelete_open1_gfxTextPerfMetrics_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::gfxTextPerfMetrics>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::gfxTextPerfMetrics>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::gfxTextPerfMetrics>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::gfxTextPerfMetrics>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_gfxTextPerfMetrics_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_gfxMissingFontRecorder_DefaultDelete_open1_gfxMissingFontRecorder_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::gfxMissingFontRecorder>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::gfxMissingFontRecorder>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::gfxMissingFontRecorder>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::gfxMissingFontRecorder>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_gfxMissingFontRecorder_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_WidgetPointerEvent_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::mozilla::WidgetPointerEvent>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::WidgetPointerEvent>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::mozilla::WidgetPointerEvent>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::WidgetPointerEvent>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_WidgetPointerEventHolder_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::WidgetPointerEventHolder>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::WidgetPointerEventHolder>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::WidgetPointerEventHolder>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::WidgetPointerEventHolder>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_EventTarget_close0_instantiation_9() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_EventTarget_close0_instantiation_10() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_EventTarget_close0_instantiation_11() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_PresShell_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::PresShell>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::PresShell>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::PresShell>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::PresShell>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Document_close0_instantiation_8() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Touch_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Touch>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Touch>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Touch>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Touch>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIContent_close0_instantiation_4() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Document_close0_instantiation_9() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Document>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Document>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_EventTarget_close0_instantiation_12() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_RawServoStyleSet_DefaultDelete_open1_RawServoStyleSet_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::RawServoStyleSet>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::RawServoStyleSet>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::RawServoStyleSet>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::RawServoStyleSet>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_RawServoStyleSet_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_ServoStyleRuleMap_DefaultDelete_open1_ServoStyleRuleMap_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::ServoStyleRuleMap>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::ServoStyleRuleMap>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::ServoStyleRuleMap>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::ServoStyleRuleMap>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_ServoStyleRuleMap_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_PostTraversalTask_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::mozilla::PostTraversalTask>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::PostTraversalTask>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::mozilla::PostTraversalTask>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::PostTraversalTask>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_ComputedStyle_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::ComputedStyle>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::ComputedStyle>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::ComputedStyle>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::ComputedStyle>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_Variant_open0_LayersId_FocusTarget_ScrollTargets_FocusTarget_NoFocusTarget_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::Variant>(),
            40usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::Variant)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::Variant>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::Variant)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_19() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIURI_close0_instantiation_20() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsITimer_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsIContent_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsIContent>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsIContent>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsIContent>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsIContent>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_ReverseIterator_open0_nsFrameList_Iterator_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::ReverseIterator<root::nsFrameList_Iterator>>(),
            16usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::ReverseIterator<root::nsFrameList_Iterator>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::ReverseIterator<root::nsFrameList_Iterator>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::ReverseIterator<root::nsFrameList_Iterator>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_ReverseIterator_open0_nsFrameList_Iterator_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::ReverseIterator<root::nsFrameList_Iterator>>(),
            16usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::ReverseIterator<root::nsFrameList_Iterator>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::ReverseIterator<root::nsFrameList_Iterator>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::ReverseIterator<root::nsFrameList_Iterator>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_ptr_void_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<*mut ::std::os::raw::c_void>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<*mut ::std::os::raw::c_void>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<*mut ::std::os::raw::c_void>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<*mut ::std::os::raw::c_void>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_CallbackObjectHolder_open0_EventListener_nsIDOMEventListener_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::dom::CallbackObjectHolder>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::dom::CallbackObjectHolder)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::dom::CallbackObjectHolder>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::dom::CallbackObjectHolder)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_16() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_17() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_LinkedListElement_open0_DOMEventTargetHelper_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::LinkedListElement>(),
            24usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::LinkedListElement)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::LinkedListElement>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::LinkedListElement)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_EventListenerManager_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::EventListenerManager>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::EventListenerManager>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::EventListenerManager>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::EventListenerManager>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsString_close0_instantiation_6() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<::gecko_bindings::structs::nsString>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsString>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<::gecko_bindings::structs::nsString>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsString>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_nsAtom_close1_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::RefPtr<root::nsAtom>>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsAtom>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::RefPtr<root::nsAtom>>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsAtom>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_18() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_VisualViewport_VisualViewportResizeEvent_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<
                root::RefPtr<root::mozilla::dom::VisualViewport_VisualViewportResizeEvent>,
            >(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(
                    root::RefPtr<root::mozilla::dom::VisualViewport_VisualViewportResizeEvent>
                )
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::RefPtr<root::mozilla::dom::VisualViewport_VisualViewportResizeEvent>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(
                    root::RefPtr<root::mozilla::dom::VisualViewport_VisualViewportResizeEvent>
                )
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_VisualViewport_VisualViewportScrollEvent_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<
                root::RefPtr<root::mozilla::dom::VisualViewport_VisualViewportScrollEvent>,
            >(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(
                    root::RefPtr<root::mozilla::dom::VisualViewport_VisualViewportScrollEvent>
                )
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::RefPtr<root::mozilla::dom::VisualViewport_VisualViewportScrollEvent>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(
                    root::RefPtr<root::mozilla::dom::VisualViewport_VisualViewportScrollEvent>
                )
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_BaseTransactionId_open0_VsyncIdType_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::layers::BaseTransactionId>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::layers::BaseTransactionId)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::layers::BaseTransactionId>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::layers::BaseTransactionId)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_nsRefreshDriver_VVPResizeEvent_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::RefPtr<root::nsRefreshDriver_VVPResizeEvent>>>(
            ),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsRefreshDriver_VVPResizeEvent>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::nsTArray<root::RefPtr<root::nsRefreshDriver_VVPResizeEvent>>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsRefreshDriver_VVPResizeEvent>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsRefreshDriver_VVPResizeEvent_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsRefreshDriver_VVPResizeEvent>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsRefreshDriver_VVPResizeEvent>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsRefreshDriver_VVPResizeEvent>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsRefreshDriver_VVPResizeEvent>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_Runnable_close1_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::RefPtr<root::mozilla::Runnable>>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::Runnable>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::RefPtr<root::mozilla::Runnable>>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::Runnable>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_nsRefreshDriver_VVPScrollEvent_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::RefPtr<root::nsRefreshDriver_VVPScrollEvent>>>(
            ),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsRefreshDriver_VVPScrollEvent>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::nsTArray<root::RefPtr<root::nsRefreshDriver_VVPScrollEvent>>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsRefreshDriver_VVPScrollEvent>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsRefreshDriver_VVPScrollEvent_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsRefreshDriver_VVPScrollEvent>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsRefreshDriver_VVPScrollEvent>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsRefreshDriver_VVPScrollEvent>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsRefreshDriver_VVPScrollEvent>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsRefreshDriver_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsRefreshDriver>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsRefreshDriver>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsRefreshDriver>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsRefreshDriver>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIRunnable_close0_instantiation_4() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_ptr_Document_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<*mut root::nsRefreshDriver_Document>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<*mut root::nsRefreshDriver_Document>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<*mut root::nsRefreshDriver_Document>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<*mut root::nsRefreshDriver_Document>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_ptr_Document_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<*mut root::nsRefreshDriver_Document>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<*mut root::nsRefreshDriver_Document>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<*mut root::nsRefreshDriver_Document>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<*mut root::nsRefreshDriver_Document>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_UniquePtr_open1_PendingFullscreenEvent_DefaultDelete_open2_PendingFullscreenEvent_close2_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<
                root::nsTArray<root::mozilla::UniquePtr<root::mozilla::PendingFullscreenEvent>>,
            >(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(
                    root::nsTArray<root::mozilla::UniquePtr<root::mozilla::PendingFullscreenEvent>>
                )
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::nsTArray<root::mozilla::UniquePtr<root::mozilla::PendingFullscreenEvent>>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(
                    root::nsTArray<root::mozilla::UniquePtr<root::mozilla::PendingFullscreenEvent>>
                )
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsPtrHashKey_open0_nsIFrame_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsPtrHashKey<root::nsIFrame>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsPtrHashKey<root::nsIFrame>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsPtrHashKey<root::nsIFrame>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsPtrHashKey<root::nsIFrame>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_PresShell_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::PresShell>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::PresShell>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::PresShell>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::PresShell>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIContent_close0_instantiation_5() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIContent_close0_instantiation_6() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_PresShell_DelayedEvent_DefaultDelete_open1_PresShell_DelayedEvent_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::PresShell_DelayedEvent>>(
            ),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::PresShell_DelayedEvent>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::PresShell_DelayedEvent>>(
            ),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::PresShell_DelayedEvent>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_PresShell_DelayedEvent_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_OwningNonNull_open0_PresShell_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::OwningNonNull<root::mozilla::PresShell>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::OwningNonNull<root::mozilla::PresShell>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::OwningNonNull<root::mozilla::PresShell>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::OwningNonNull<root::mozilla::PresShell>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsRevocableEventPtr_open0_nsRunnableMethod_open1_PresShell_void_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<u64>(),
            8usize,
            concat!("Size of template specialization: ", stringify!(u64))
        );
        assert_eq!(
            ::std::mem::align_of::<u64>(),
            8usize,
            concat!("Alignment of template specialization: ", stringify!(u64))
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_PresShell_Document_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::PresShell_Document>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::PresShell_Document>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::PresShell_Document>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::PresShell_Document>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsPresContext_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsPresContext>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsPresContext>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsPresContext>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsPresContext>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_StyleSheet_close0_instantiation_8() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::StyleSheet>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::StyleSheet>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::StyleSheet>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::StyleSheet>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_nsCSSFrameConstructor_DefaultDelete_open1_nsCSSFrameConstructor_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::nsCSSFrameConstructor>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsCSSFrameConstructor>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::nsCSSFrameConstructor>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsCSSFrameConstructor>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_nsCSSFrameConstructor_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsFrameSelection_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsFrameSelection>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsFrameSelection>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsFrameSelection>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsFrameSelection>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsCaret_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsCaret>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsCaret>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsCaret>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsCaret>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsCaret_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsCaret>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsCaret>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsCaret>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsCaret>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_AccessibleCaretEventHub_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::AccessibleCaretEventHub>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::AccessibleCaretEventHub>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::AccessibleCaretEventHub>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::AccessibleCaretEventHub>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsITimer_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsPtrHashKey_open0_WeakFrame_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsPtrHashKey<root::WeakFrame>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsPtrHashKey<root::WeakFrame>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsPtrHashKey<root::WeakFrame>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsPtrHashKey<root::WeakFrame>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_PresShell_DirtyRootsList_FrameAndDepth_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<
                root::nsTArray<root::mozilla::PresShell_DirtyRootsList_FrameAndDepth>,
            >(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::PresShell_DirtyRootsList_FrameAndDepth>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::nsTArray<root::mozilla::PresShell_DirtyRootsList_FrameAndDepth>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::PresShell_DirtyRootsList_FrameAndDepth>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_UniquePtr_open1_PresShell_DelayedEvent_DefaultDelete_open2_PresShell_DelayedEvent_close2_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<
                root::nsTArray<root::mozilla::UniquePtr<root::mozilla::PresShell_DelayedEvent>>,
            >(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(
                    root::nsTArray<root::mozilla::UniquePtr<root::mozilla::PresShell_DelayedEvent>>
                )
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::nsTArray<root::mozilla::UniquePtr<root::mozilla::PresShell_DelayedEvent>>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(
                    root::nsTArray<root::mozilla::UniquePtr<root::mozilla::PresShell_DelayedEvent>>
                )
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_PresShell_DelayedEvent_DefaultDelete_open1_PresShell_DelayedEvent_close1_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::PresShell_DelayedEvent>>(
            ),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::PresShell_DelayedEvent>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::PresShell_DelayedEvent>>(
            ),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::PresShell_DelayedEvent>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_PresShell_DelayedEvent_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsRevocableEventPtr_open0_PresShell_nsSynthMouseMoveEvent_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<
                root::nsRevocableEventPtr<root::mozilla::PresShell_nsSynthMouseMoveEvent>,
            >(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(
                    root::nsRevocableEventPtr<root::mozilla::PresShell_nsSynthMouseMoveEvent>
                )
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::nsRevocableEventPtr<root::mozilla::PresShell_nsSynthMouseMoveEvent>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(
                    root::nsRevocableEventPtr<root::mozilla::PresShell_nsSynthMouseMoveEvent>
                )
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_ZoomConstraintsClient_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::ZoomConstraintsClient>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::ZoomConstraintsClient>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::ZoomConstraintsClient>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::ZoomConstraintsClient>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_GeckoMVMContext_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::GeckoMVMContext>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::GeckoMVMContext>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::GeckoMVMContext>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::GeckoMVMContext>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_MobileViewportManager_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::MobileViewportManager>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::MobileViewportManager>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::MobileViewportManager>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::MobileViewportManager>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsITimer_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsITimer_close0_instantiation_4() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIContent_close0_instantiation_7() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIContent_close0_instantiation_8() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIContent_close0_instantiation_9() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIContent_close0_instantiation_10() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_ptr_nsIFrame_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<*mut root::nsIFrame>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<*mut root::nsIFrame>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<*mut root::nsIFrame>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<*mut root::nsIFrame>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMArray_open0_nsIContent_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMArray>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMArray)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMArray>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMArray)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsPtrHashKey_open0_nsIFrame_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsPtrHashKey<root::nsIFrame>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsPtrHashKey<root::nsIFrame>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsPtrHashKey<root::nsIFrame>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsPtrHashKey<root::nsIFrame>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsPtrHashKey_open0_nsIScrollableFrame_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsPtrHashKey<root::nsIScrollableFrame>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsPtrHashKey<root::nsIScrollableFrame>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsPtrHashKey<root::nsIScrollableFrame>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsPtrHashKey<root::nsIScrollableFrame>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsPtrHashKey_open0_nsIScrollableFrame_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsPtrHashKey<root::nsIScrollableFrame>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsPtrHashKey<root::nsIScrollableFrame>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsPtrHashKey<root::nsIScrollableFrame>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsPtrHashKey<root::nsIScrollableFrame>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_StaticRefPtr_open0_nsIContent_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::StaticRefPtr<root::nsIContent>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::StaticRefPtr<root::nsIContent>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::StaticRefPtr<root::nsIContent>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::StaticRefPtr<root::nsIContent>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIContent_close0_instantiation_11() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsXBLBinding_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsXBLBinding>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsXBLBinding>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsXBLBinding>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsXBLBinding>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_XBLChildrenElement_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::XBLChildrenElement>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::XBLChildrenElement>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::XBLChildrenElement>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::XBLChildrenElement>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_XBLChildrenElement_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<
                root::nsTArray<root::RefPtr<root::mozilla::dom::XBLChildrenElement>>,
            >(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::dom::XBLChildrenElement>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<
                root::nsTArray<root::RefPtr<root::mozilla::dom::XBLChildrenElement>>,
            >(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::mozilla::dom::XBLChildrenElement>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_XBLChildrenElement_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::XBLChildrenElement>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::XBLChildrenElement>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::XBLChildrenElement>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::XBLChildrenElement>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAnonymousContentList_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAnonymousContentList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAnonymousContentList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAnonymousContentList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAnonymousContentList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsDOMCSSAttributeDeclaration_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsDOMCSSAttributeDeclaration>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsDOMCSSAttributeDeclaration>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsDOMCSSAttributeDeclaration>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsDOMCSSAttributeDeclaration>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_DeclarationBlock_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::DeclarationBlock>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::DeclarationBlock>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::DeclarationBlock>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::DeclarationBlock>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIControllers_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsLabelsNodeList_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsLabelsNodeList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsLabelsNodeList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsLabelsNodeList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsLabelsNodeList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_ShadowRoot_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::ShadowRoot>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::ShadowRoot>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::ShadowRoot>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::ShadowRoot>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsXBLBinding_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsXBLBinding>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsXBLBinding>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsXBLBinding>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsXBLBinding>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_CustomElementData_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::CustomElementData>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::CustomElementData>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::CustomElementData>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::CustomElementData>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsICSSDeclaration_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsDOMAttributeMap_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsDOMAttributeMap>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsDOMAttributeMap>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsDOMAttributeMap>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsDOMAttributeMap>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsContentList_close0_instantiation_7() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsContentList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsContentList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsContentList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsContentList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsDOMTokenList_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsDOMTokenList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsDOMTokenList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsDOMTokenList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsDOMTokenList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsISupports_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_SMILAttr_DefaultDelete_open1_SMILAttr_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::SMILAttr>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::SMILAttr>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::SMILAttr>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::SMILAttr>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_SMILAttr_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsRefPtrHashKey_open0_nsAtom_close0_instantiation_4() {
        assert_eq!(
            ::std::mem::size_of::<root::nsRefPtrHashKey<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsRefPtrHashKey<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsRefPtrHashKey<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsRefPtrHashKey<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsRefPtrHashKey_open0_nsAtom_close0_instantiation_5() {
        assert_eq!(
            ::std::mem::size_of::<root::nsRefPtrHashKey<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsRefPtrHashKey<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsRefPtrHashKey<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsRefPtrHashKey<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_nsAtom_close1_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::RefPtr<root::nsAtom>>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsAtom>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::RefPtr<root::nsAtom>>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsAtom>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsAtom_close0_instantiation_19() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsAtom>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsAtom>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_nsINode_close1_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::RefPtr<root::nsINode>>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsINode>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::RefPtr<root::nsINode>>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsINode>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsINode_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsINode>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsINode>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsINode>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsINode>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_RawServoMediaList_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::RawServoMediaList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::RawServoMediaList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::RawServoMediaList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::RawServoMediaList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Element_close0_instantiation_4() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Element>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Element>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_RawServoAuthorStyles_DefaultDelete_open1_RawServoAuthorStyles_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::RawServoAuthorStyles>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::RawServoAuthorStyles>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::RawServoAuthorStyles>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::RawServoAuthorStyles>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_RawServoAuthorStyles_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_ServoStyleRuleMap_DefaultDelete_open1_ServoStyleRuleMap_close1_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::ServoStyleRuleMap>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::ServoStyleRuleMap>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::ServoStyleRuleMap>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::ServoStyleRuleMap>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_ServoStyleRuleMap_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_BaseTimeDuration_open0_StickyTimeDurationValueCalculator_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::BaseTimeDuration>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::BaseTimeDuration)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::BaseTimeDuration>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::BaseTimeDuration)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_RawServoDeclarationBlock_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::RawServoDeclarationBlock>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::RawServoDeclarationBlock>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::RawServoDeclarationBlock>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::RawServoDeclarationBlock>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_PropertyValuePair_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::mozilla::PropertyValuePair>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::PropertyValuePair>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::mozilla::PropertyValuePair>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::PropertyValuePair>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_AttrArray_InternalAttr_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::AttrArray_InternalAttr>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::AttrArray_InternalAttr>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::AttrArray_InternalAttr>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::AttrArray_InternalAttr>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsRefPtrHashKey_open0_Element_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsRefPtrHashKey<root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsRefPtrHashKey<root::mozilla::dom::Element>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsRefPtrHashKey<root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsRefPtrHashKey<root::mozilla::dom::Element>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_nsXBLBinding_close1_close0_instantiation()
    {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::RefPtr<root::nsXBLBinding>>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsXBLBinding>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::RefPtr<root::nsXBLBinding>>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsXBLBinding>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsXBLBinding_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsXBLBinding>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsXBLBinding>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsXBLBinding>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsXBLBinding>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsAutoPtr_open0_nsTHashtable_open1_nsRefPtrHashKey_open2_nsIContent_close2_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<u64>(),
            8usize,
            concat!("Size of template specialization: ", stringify!(u64))
        );
        assert_eq!(
            ::std::mem::align_of::<u64>(),
            8usize,
            concat!("Alignment of template specialization: ", stringify!(u64))
        );
    }
    #[test]
    fn __bindgen_test_layout_nsRefPtrHashKey_open0_nsIContent_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsRefPtrHashKey<root::nsIContent>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsRefPtrHashKey<root::nsIContent>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsRefPtrHashKey<root::nsIContent>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsRefPtrHashKey<root::nsIContent>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsAutoPtr_open0_nsBindingManager_WrapperHashtable_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::nsAutoPtr<root::nsBindingManager_WrapperHashtable>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsAutoPtr<root::nsBindingManager_WrapperHashtable>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsAutoPtr<root::nsBindingManager_WrapperHashtable>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsAutoPtr<root::nsBindingManager_WrapperHashtable>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsAutoPtr_open0_nsRefPtrHashtable_open1_nsURIHashKey_nsXBLDocumentInfo_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<u64>(),
            8usize,
            concat!("Size of template specialization: ", stringify!(u64))
        );
        assert_eq!(
            ::std::mem::align_of::<u64>(),
            8usize,
            concat!("Alignment of template specialization: ", stringify!(u64))
        );
    }
    #[test]
    fn __bindgen_test_layout_nsAutoPtr_open0_nsInterfaceHashtable_open1_nsURIHashKey_nsIStreamListener_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<u64>(),
            8usize,
            concat!("Size of template specialization: ", stringify!(u64))
        );
        assert_eq!(
            ::std::mem::align_of::<u64>(),
            8usize,
            concat!("Alignment of template specialization: ", stringify!(u64))
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsRunnableMethod_open1_nsBindingManager_void_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<u64>(),
            8usize,
            concat!("Size of template specialization: ", stringify!(u64))
        );
        assert_eq!(
            ::std::mem::align_of::<u64>(),
            8usize,
            concat!("Alignment of template specialization: ", stringify!(u64))
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_FrameProperties_PropertyValue_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::mozilla::FrameProperties_PropertyValue>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::FrameProperties_PropertyValue>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::mozilla::FrameProperties_PropertyValue>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::FrameProperties_PropertyValue>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_EnumSet_open0_FrameChildListID_unsigned_int_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::EnumSet<::std::os::raw::c_uint>>(),
            4usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::EnumSet<::std::os::raw::c_uint>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::EnumSet<::std::os::raw::c_uint>>(),
            4usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::EnumSet<::std::os::raw::c_uint>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_FrameChildList_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::mozilla::layout::FrameChildList>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::layout::FrameChildList>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::mozilla::layout::FrameChildList>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::layout::FrameChildList>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_ComputedStyle_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::ComputedStyle>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::ComputedStyle>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::ComputedStyle>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::ComputedStyle>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_uint8_t_DefaultDelete_open1_unsigned_char_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<u8>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<u8>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<u8>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<u8>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_unsigned_char_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_uint8_t_DefaultDelete_open1_unsigned_char_close1_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<u8>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<u8>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<u8>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<u8>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_unsigned_char_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_gfxRect_DefaultDelete_open1_RectTyped_open2_UnknownUnits_double_close2_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::gfxRect>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::gfxRect>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::gfxRect>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::gfxRect>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_RectTyped_open1_UnknownUnits_double_close1_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_SMILAttr_DefaultDelete_open1_SMILAttr_close1_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::SMILAttr>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::SMILAttr>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::SMILAttr>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::SMILAttr>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_SMILAttr_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsAutoPtr_open0_nsString_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsAutoPtr<::gecko_bindings::structs::nsString>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsAutoPtr<::gecko_bindings::structs::nsString>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsAutoPtr<::gecko_bindings::structs::nsString>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsAutoPtr<::gecko_bindings::structs::nsString>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_SMILAttr_DefaultDelete_open1_SMILAttr_close1_close0_instantiation_2(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::SMILAttr>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::SMILAttr>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::SMILAttr>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::SMILAttr>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_SMILAttr_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsAutoPtr_open0_nsAttrValue_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsAutoPtr<root::nsAttrValue>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsAutoPtr<root::nsAttrValue>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsAutoPtr<root::nsAttrValue>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsAutoPtr<root::nsAttrValue>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_DeclarationBlock_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::DeclarationBlock>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::DeclarationBlock>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::DeclarationBlock>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::DeclarationBlock>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIContent_close0_instantiation_12() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_ComputedStyle_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::ComputedStyle>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::ComputedStyle>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::ComputedStyle>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::ComputedStyle>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsIFrame_InlineIntrinsicISizeData_FloatInfo_close0_instantiation(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::nsIFrame_InlineIntrinsicISizeData_FloatInfo>>(
            ),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::nsIFrame_InlineIntrinsicISizeData_FloatInfo>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::nsIFrame_InlineIntrinsicISizeData_FloatInfo>>(
            ),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::nsIFrame_InlineIntrinsicISizeData_FloatInfo>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIContent_close0_instantiation_13() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsCOMPtr_open0_nsIContent_close0_instantiation_14() {
        assert_eq!(
            ::std::mem::size_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsCOMPtr>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsCOMPtr)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsIFrame_ComputedStyle_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsIFrame_ComputedStyle>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsIFrame_ComputedStyle>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsIFrame_ComputedStyle>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsIFrame_ComputedStyle>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_ptr_nsIContent_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<*mut root::nsIContent>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<*mut root::nsIContent>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<*mut root::nsIContent>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<*mut root::nsIContent>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_Element_close0_instantiation_5() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Element>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::mozilla::dom::Element>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_ptr_nsIContent_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<*mut root::nsIContent>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<*mut root::nsIContent>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<*mut root::nsIContent>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<*mut root::nsIContent>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_ptr_nsIContent_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<*mut root::nsIContent>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<*mut root::nsIContent>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<*mut root::nsIContent>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<*mut root::nsIContent>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_RefPtr_open1_nsINode_close1_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::RefPtr<root::nsINode>>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsINode>>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::RefPtr<root::nsINode>>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::RefPtr<root::nsINode>>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_RefPtr_open0_nsINode_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::RefPtr<root::nsINode>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::RefPtr<root::nsINode>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::RefPtr<root::nsINode>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::RefPtr<root::nsINode>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsStyleAutoArray_open0_StyleAnimation_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsStyleAutoArray<root::mozilla::StyleAnimation>>(),
            56usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsStyleAutoArray<root::mozilla::StyleAnimation>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsStyleAutoArray<root::mozilla::StyleAnimation>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsStyleAutoArray<root::mozilla::StyleAnimation>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsStyleAutoArray_open0_StyleAnimation_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::nsStyleAutoArray<root::mozilla::StyleAnimation>>(),
            56usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsStyleAutoArray<root::mozilla::StyleAnimation>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsStyleAutoArray<root::mozilla::StyleAnimation>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsStyleAutoArray<root::mozilla::StyleAnimation>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsStyleAutoArray_open0_StyleAnimation_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::nsStyleAutoArray<root::mozilla::StyleAnimation>>(),
            56usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsStyleAutoArray<root::mozilla::StyleAnimation>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsStyleAutoArray<root::mozilla::StyleAnimation>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsStyleAutoArray<root::mozilla::StyleAnimation>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsStyleAutoArray_open0_StyleAnimation_close0_instantiation_4() {
        assert_eq!(
            ::std::mem::size_of::<root::nsStyleAutoArray<root::mozilla::StyleAnimation>>(),
            56usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsStyleAutoArray<root::mozilla::StyleAnimation>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsStyleAutoArray<root::mozilla::StyleAnimation>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsStyleAutoArray<root::mozilla::StyleAnimation>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_FontFamilyName_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::mozilla::FontFamilyName>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::FontFamilyName>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::mozilla::FontFamilyName>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::FontFamilyName>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_FontFamilyName_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::mozilla::FontFamilyName>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::FontFamilyName>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::mozilla::FontFamilyName>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::FontFamilyName>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_unsigned_int_close0_instantiation() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<::std::os::raw::c_uint>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<::std::os::raw::c_uint>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<::std::os::raw::c_uint>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<::std::os::raw::c_uint>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_nsString_close0_instantiation_7() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<::gecko_bindings::structs::nsString>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsString>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<::gecko_bindings::structs::nsString>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<::gecko_bindings::structs::nsString>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_nsStyleGridTemplate_DefaultDelete_open1_nsStyleGridTemplate_close1_close0_instantiation_2(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::nsStyleGridTemplate>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsStyleGridTemplate>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::nsStyleGridTemplate>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsStyleGridTemplate>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_nsStyleGridTemplate_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_nsStyleGridTemplate_DefaultDelete_open1_nsStyleGridTemplate_close1_close0_instantiation_3(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::nsStyleGridTemplate>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsStyleGridTemplate>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::nsStyleGridTemplate>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::nsStyleGridTemplate>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_nsStyleGridTemplate_close0_instantiation_3() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_PropertyValuePair_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<root::mozilla::PropertyValuePair>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::PropertyValuePair>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<root::mozilla::PropertyValuePair>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<root::mozilla::PropertyValuePair>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_StyleMotion_DefaultDelete_open1_StyleMotion_close1_close0_instantiation_1(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::StyleMotion>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::StyleMotion>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::StyleMotion>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::StyleMotion>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_StyleMotion_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_UniquePtr_open0_StyleMotion_DefaultDelete_open1_StyleMotion_close1_close0_instantiation_2(
    ) {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::UniquePtr<root::mozilla::StyleMotion>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::StyleMotion>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::UniquePtr<root::mozilla::StyleMotion>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::UniquePtr<root::mozilla::StyleMotion>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_DefaultDelete_open0_StyleMotion_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::mozilla::DefaultDelete>(),
            1usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::mozilla::DefaultDelete)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_ptr_Element_close0_instantiation_1() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<*mut root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<*mut root::mozilla::dom::Element>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<*mut root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<*mut root::mozilla::dom::Element>)
            )
        );
    }
    #[test]
    fn __bindgen_test_layout_nsTArray_open0_ptr_Element_close0_instantiation_2() {
        assert_eq!(
            ::std::mem::size_of::<root::nsTArray<*mut root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Size of template specialization: ",
                stringify!(root::nsTArray<*mut root::mozilla::dom::Element>)
            )
        );
        assert_eq!(
            ::std::mem::align_of::<root::nsTArray<*mut root::mozilla::dom::Element>>(),
            8usize,
            concat!(
                "Alignment of template specialization: ",
                stringify!(root::nsTArray<*mut root::mozilla::dom::Element>)
            )
        );
    }
}
