/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/. */

// `data` comes from components/style/properties.mako.rs; see build.rs for more details.




use crate::Atom;
use app_units::Au;
use crate::custom_properties::CustomPropertiesMap;
use crate::gecko_bindings::bindings;
use crate::gecko_bindings::structs::nsStyleBackground;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleBackground;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleBackground;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleBackground;
use crate::gecko_bindings::structs::nsStyleBorder;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleBorder;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleBorder;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleBorder;
use crate::gecko_bindings::structs::nsStyleDisplay;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleDisplay;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleDisplay;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleDisplay;
use crate::gecko_bindings::structs::nsStyleColor;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleColor;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleColor;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleColor;
use crate::gecko_bindings::structs::nsStyleColumn;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleColumn;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleColumn;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleColumn;
use crate::gecko_bindings::structs::nsStyleContent;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleContent;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleContent;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleContent;
use crate::gecko_bindings::structs::nsStyleEffects;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleEffects;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleEffects;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleEffects;
use crate::gecko_bindings::structs::nsStyleFont;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleFont;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleFont;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleFont;
use crate::gecko_bindings::structs::nsStyleVisibility;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleVisibility;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleVisibility;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleVisibility;
use crate::gecko_bindings::structs::nsStyleTableBorder;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleTableBorder;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleTableBorder;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleTableBorder;
use crate::gecko_bindings::structs::nsStyleText;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleText;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleText;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleText;
use crate::gecko_bindings::structs::nsStyleUI;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleUI;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleUI;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleUI;
use crate::gecko_bindings::structs::nsStyleSVG;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleSVG;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleSVG;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleSVG;
use crate::gecko_bindings::structs::nsStyleList;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleList;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleList;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleList;
use crate::gecko_bindings::structs::nsStyleMargin;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleMargin;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleMargin;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleMargin;
use crate::gecko_bindings::structs::nsStyleOutline;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleOutline;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleOutline;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleOutline;
use crate::gecko_bindings::structs::nsStylePadding;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStylePadding;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStylePadding;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStylePadding;
use crate::gecko_bindings::structs::nsStylePosition;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStylePosition;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStylePosition;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStylePosition;
use crate::gecko_bindings::structs::nsStyleTable;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleTable;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleTable;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleTable;
use crate::gecko_bindings::structs::nsStyleTextReset;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleTextReset;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleTextReset;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleTextReset;
use crate::gecko_bindings::structs::nsStyleUIReset;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleUIReset;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleUIReset;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleUIReset;
use crate::gecko_bindings::structs::nsStyleSVGReset;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleSVGReset;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleSVGReset;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleSVGReset;
use crate::gecko_bindings::structs::nsStyleXUL;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleXUL;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleXUL;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleXUL;
use crate::gecko_bindings::bindings::Gecko_CopyCounterStyle;
use crate::gecko_bindings::bindings::Gecko_CopyCursorArrayFrom;
use crate::gecko_bindings::bindings::Gecko_CopyFontFamilyFrom;
use crate::gecko_bindings::bindings::Gecko_CopyImageValueFrom;
use crate::gecko_bindings::bindings::Gecko_CopyListStyleImageFrom;
use crate::gecko_bindings::bindings::Gecko_EnsureImageLayersLength;
use crate::gecko_bindings::bindings::Gecko_SetCursorArrayLength;
use crate::gecko_bindings::bindings::Gecko_SetCursorImageValue;
use crate::gecko_bindings::bindings::Gecko_nsStyleFont_SetLang;
use crate::gecko_bindings::bindings::Gecko_nsStyleFont_CopyLangFrom;
use crate::gecko_bindings::bindings::Gecko_SetListStyleImageNone;
use crate::gecko_bindings::bindings::Gecko_SetListStyleImageImageValue;
use crate::gecko_bindings::bindings::Gecko_SetNullImageValue;
use crate::gecko_bindings::bindings::{Gecko_ResetFilters, Gecko_CopyFiltersFrom};
use crate::gecko_bindings::structs;
use crate::gecko_bindings::structs::nsCSSPropertyID;
use crate::gecko_bindings::structs::mozilla::PseudoStyleType;
use crate::gecko_bindings::sugar::ns_style_coord::{CoordDataValue, CoordDataMut};
use crate::gecko_bindings::sugar::refptr::RefPtr;
use crate::gecko::values::GeckoStyleCoordConvertible;
use crate::gecko::values::round_border_to_device_pixels;
use crate::logical_geometry::WritingMode;
use crate::media_queries::Device;
use crate::properties::computed_value_flags::*;
use crate::properties::longhands;
use crate::rule_tree::StrongRuleNode;
use crate::selector_parser::PseudoElement;
use servo_arc::{Arc, RawOffsetArc};
use std::marker::PhantomData;
use std::mem::{forget, uninitialized, zeroed, ManuallyDrop};
use std::{cmp, ops, ptr};
use crate::values::{self, CustomIdent, Either, KeyframesName, None_};
use crate::values::computed::{NonNegativeLength, Percentage, TransitionProperty};
use crate::values::computed::BorderStyle;
use crate::values::computed::font::FontSize;
use crate::values::computed::effects::Filter;
use crate::values::generics::column::ColumnCount;
use crate::values::generics::transform::TransformStyle;
use crate::values::generics::url::UrlOrNone;

pub mod style_structs {
    pub use super::GeckoBackground as Background;

    unsafe impl Send for Background {}
    unsafe impl Sync for Background {}
    pub use super::GeckoBorder as Border;

    unsafe impl Send for Border {}
    unsafe impl Sync for Border {}
    pub use super::GeckoBox as Box;

    unsafe impl Send for Box {}
    unsafe impl Sync for Box {}
    pub use super::GeckoColor as Color;

    unsafe impl Send for Color {}
    unsafe impl Sync for Color {}
    pub use super::GeckoColumn as Column;

    unsafe impl Send for Column {}
    unsafe impl Sync for Column {}
    pub use super::GeckoCounters as Counters;

    unsafe impl Send for Counters {}
    unsafe impl Sync for Counters {}
    pub use super::GeckoEffects as Effects;

    unsafe impl Send for Effects {}
    unsafe impl Sync for Effects {}
    pub use super::GeckoFont as Font;

    unsafe impl Send for Font {}
    unsafe impl Sync for Font {}
    pub use super::GeckoInheritedBox as InheritedBox;

    unsafe impl Send for InheritedBox {}
    unsafe impl Sync for InheritedBox {}
    pub use super::GeckoInheritedTable as InheritedTable;

    unsafe impl Send for InheritedTable {}
    unsafe impl Sync for InheritedTable {}
    pub use super::GeckoInheritedText as InheritedText;

    unsafe impl Send for InheritedText {}
    unsafe impl Sync for InheritedText {}
    pub use super::GeckoInheritedUI as InheritedUI;

    unsafe impl Send for InheritedUI {}
    unsafe impl Sync for InheritedUI {}
    pub use super::GeckoInheritedSVG as InheritedSVG;

    unsafe impl Send for InheritedSVG {}
    unsafe impl Sync for InheritedSVG {}
    pub use super::GeckoList as List;

    unsafe impl Send for List {}
    unsafe impl Sync for List {}
    pub use super::GeckoMargin as Margin;

    unsafe impl Send for Margin {}
    unsafe impl Sync for Margin {}
    pub use super::GeckoOutline as Outline;

    unsafe impl Send for Outline {}
    unsafe impl Sync for Outline {}
    pub use super::GeckoPadding as Padding;

    unsafe impl Send for Padding {}
    unsafe impl Sync for Padding {}
    pub use super::GeckoPosition as Position;

    unsafe impl Send for Position {}
    unsafe impl Sync for Position {}
    pub use super::GeckoTable as Table;

    unsafe impl Send for Table {}
    unsafe impl Sync for Table {}
    pub use super::GeckoText as Text;

    unsafe impl Send for Text {}
    unsafe impl Sync for Text {}
    pub use super::GeckoUI as UI;

    unsafe impl Send for UI {}
    unsafe impl Sync for UI {}
    pub use super::GeckoSVG as SVG;

    unsafe impl Send for SVG {}
    unsafe impl Sync for SVG {}
    pub use super::GeckoXUL as XUL;

    unsafe impl Send for XUL {}
    unsafe impl Sync for XUL {}

}

/// FIXME(emilio): This is completely duplicated with the other properties code.
pub type ComputedValuesInner = structs::ServoComputedData;

#[repr(C)]
pub struct ComputedValues(structs::mozilla::ComputedStyle);

impl ComputedValues {
    #[inline]
    pub (crate) fn as_gecko_computed_style(&self) -> &structs::ComputedStyle {
        &self.0
    }

    pub fn new(
        pseudo: Option<&PseudoElement>,
        custom_properties: Option<Arc<CustomPropertiesMap>>,
        writing_mode: WritingMode,
        flags: ComputedValueFlags,
        rules: Option<StrongRuleNode>,
        visited_style: Option<Arc<ComputedValues>>,
        background: Arc<style_structs::Background>,
        border: Arc<style_structs::Border>,
        box_: Arc<style_structs::Box>,
        color: Arc<style_structs::Color>,
        column: Arc<style_structs::Column>,
        counters: Arc<style_structs::Counters>,
        effects: Arc<style_structs::Effects>,
        font: Arc<style_structs::Font>,
        inherited_box: Arc<style_structs::InheritedBox>,
        inherited_table: Arc<style_structs::InheritedTable>,
        inherited_text: Arc<style_structs::InheritedText>,
        inherited_ui: Arc<style_structs::InheritedUI>,
        inherited_svg: Arc<style_structs::InheritedSVG>,
        list: Arc<style_structs::List>,
        margin: Arc<style_structs::Margin>,
        outline: Arc<style_structs::Outline>,
        padding: Arc<style_structs::Padding>,
        position: Arc<style_structs::Position>,
        table: Arc<style_structs::Table>,
        text: Arc<style_structs::Text>,
        ui: Arc<style_structs::UI>,
        svg: Arc<style_structs::SVG>,
        xul: Arc<style_structs::XUL>,
    ) -> Arc<Self> {
        ComputedValuesInner::new(
            custom_properties,
            writing_mode,
            flags,
            rules,
            visited_style,
            background,
            border,
            box_,
            color,
            column,
            counters,
            effects,
            font,
            inherited_box,
            inherited_table,
            inherited_text,
            inherited_ui,
            inherited_svg,
            list,
            margin,
            outline,
            padding,
            position,
            table,
            text,
            ui,
            svg,
            xul,
        ).to_outer(pseudo)
    }

    pub fn default_values(doc: &structs::Document) -> Arc<Self> {
        ComputedValuesInner::new(
            /* custom_properties = */ None,
            /* writing_mode = */ WritingMode::empty(), // FIXME(bz): This seems dubious
            ComputedValueFlags::empty(),
            /* rules = */ None,
            /* visited_style = */ None,
            style_structs::Background::default(doc),
            style_structs::Border::default(doc),
            style_structs::Box::default(doc),
            style_structs::Color::default(doc),
            style_structs::Column::default(doc),
            style_structs::Counters::default(doc),
            style_structs::Effects::default(doc),
            style_structs::Font::default(doc),
            style_structs::InheritedBox::default(doc),
            style_structs::InheritedTable::default(doc),
            style_structs::InheritedText::default(doc),
            style_structs::InheritedUI::default(doc),
            style_structs::InheritedSVG::default(doc),
            style_structs::List::default(doc),
            style_structs::Margin::default(doc),
            style_structs::Outline::default(doc),
            style_structs::Padding::default(doc),
            style_structs::Position::default(doc),
            style_structs::Table::default(doc),
            style_structs::Text::default(doc),
            style_structs::UI::default(doc),
            style_structs::SVG::default(doc),
            style_structs::XUL::default(doc),
        ).to_outer(None)
    }

    #[inline]
    pub fn pseudo(&self) -> Option<PseudoElement> {
        if self.0.mPseudoType == PseudoStyleType::NotPseudo {
            return None;
        }
        PseudoElement::from_pseudo_type(self.0.mPseudoType)
    }

    #[inline]
    pub fn is_first_line_style(&self) -> bool {
        self.pseudo() == Some(PseudoElement::FirstLine)
    }

    /// Returns true if the display property is changed from 'none' to others.
    pub fn is_display_property_changed_from_none(
        &self,
        old_values: Option<&ComputedValues>
    ) -> bool {
        use crate::properties::longhands::display::computed_value::T as Display;

        old_values.map_or(false, |old| {
            let old_display_style = old.get_box().clone_display();
            let new_display_style = self.get_box().clone_display();
            old_display_style == Display::None &&
            new_display_style != Display::None
        })
    }

}

impl Drop for ComputedValues {
    fn drop(&mut self) {
        unsafe {
            bindings::Gecko_ComputedStyle_Destroy(&mut self.0);
        }
    }
}

unsafe impl Sync for ComputedValues {}
unsafe impl Send for ComputedValues {}

impl Clone for ComputedValues {
    fn clone(&self) -> Self {
        unreachable!()
    }
}

impl Clone for ComputedValuesInner {
    fn clone(&self) -> Self {
        ComputedValuesInner {
                Background: self.Background.clone(),
                Border: self.Border.clone(),
                Display: self.Display.clone(),
                Color: self.Color.clone(),
                Column: self.Column.clone(),
                Content: self.Content.clone(),
                Effects: self.Effects.clone(),
                Font: self.Font.clone(),
                Visibility: self.Visibility.clone(),
                TableBorder: self.TableBorder.clone(),
                Text: self.Text.clone(),
                UI: self.UI.clone(),
                SVG: self.SVG.clone(),
                List: self.List.clone(),
                Margin: self.Margin.clone(),
                Outline: self.Outline.clone(),
                Padding: self.Padding.clone(),
                Position: self.Position.clone(),
                Table: self.Table.clone(),
                TextReset: self.TextReset.clone(),
                UIReset: self.UIReset.clone(),
                SVGReset: self.SVGReset.clone(),
                XUL: self.XUL.clone(),
            custom_properties: self.custom_properties.clone(),
            writing_mode: self.writing_mode.clone(),
            flags: self.flags.clone(),
            rules: self.rules.clone(),
            visited_style: self.visited_style.clone(),
        }
    }
}

impl ComputedValuesInner {
    pub fn new(
        custom_properties: Option<Arc<CustomPropertiesMap>>,
        writing_mode: WritingMode,
        flags: ComputedValueFlags,
        rules: Option<StrongRuleNode>,
        visited_style: Option<Arc<ComputedValues>>,
        background: Arc<style_structs::Background>,
        border: Arc<style_structs::Border>,
        box_: Arc<style_structs::Box>,
        color: Arc<style_structs::Color>,
        column: Arc<style_structs::Column>,
        counters: Arc<style_structs::Counters>,
        effects: Arc<style_structs::Effects>,
        font: Arc<style_structs::Font>,
        inherited_box: Arc<style_structs::InheritedBox>,
        inherited_table: Arc<style_structs::InheritedTable>,
        inherited_text: Arc<style_structs::InheritedText>,
        inherited_ui: Arc<style_structs::InheritedUI>,
        inherited_svg: Arc<style_structs::InheritedSVG>,
        list: Arc<style_structs::List>,
        margin: Arc<style_structs::Margin>,
        outline: Arc<style_structs::Outline>,
        padding: Arc<style_structs::Padding>,
        position: Arc<style_structs::Position>,
        table: Arc<style_structs::Table>,
        text: Arc<style_structs::Text>,
        ui: Arc<style_structs::UI>,
        svg: Arc<style_structs::SVG>,
        xul: Arc<style_structs::XUL>,
    ) -> Self {
        Self {
            custom_properties,
            writing_mode,
            rules,
            visited_style: visited_style.map(Arc::into_raw_offset),
            flags,
            Background: Arc::into_raw_offset(background),
            Border: Arc::into_raw_offset(border),
            Display: Arc::into_raw_offset(box_),
            Color: Arc::into_raw_offset(color),
            Column: Arc::into_raw_offset(column),
            Content: Arc::into_raw_offset(counters),
            Effects: Arc::into_raw_offset(effects),
            Font: Arc::into_raw_offset(font),
            Visibility: Arc::into_raw_offset(inherited_box),
            TableBorder: Arc::into_raw_offset(inherited_table),
            Text: Arc::into_raw_offset(inherited_text),
            UI: Arc::into_raw_offset(inherited_ui),
            SVG: Arc::into_raw_offset(inherited_svg),
            List: Arc::into_raw_offset(list),
            Margin: Arc::into_raw_offset(margin),
            Outline: Arc::into_raw_offset(outline),
            Padding: Arc::into_raw_offset(padding),
            Position: Arc::into_raw_offset(position),
            Table: Arc::into_raw_offset(table),
            TextReset: Arc::into_raw_offset(text),
            UIReset: Arc::into_raw_offset(ui),
            SVGReset: Arc::into_raw_offset(svg),
            XUL: Arc::into_raw_offset(xul),
        }
    }

    fn to_outer(
        self,
        pseudo: Option<&PseudoElement>,
    ) -> Arc<ComputedValues> {
        let pseudo_ty = match pseudo {
            Some(p) => p.pseudo_type(),
            None => structs::PseudoStyleType::NotPseudo,
        };
        let arc = unsafe {
            let arc: Arc<ComputedValues> = Arc::new(uninitialized());
            bindings::Gecko_ComputedStyle_Init(
                &arc.0 as *const _ as *mut _,
                &self,
                pseudo_ty,
            );
            // We're simulating a move by having C++ do a memcpy and then forgetting
            // it on this end.
            forget(self);
            arc
        };
        arc
    }
}

impl ops::Deref for ComputedValues {
    type Target = ComputedValuesInner;
    fn deref(&self) -> &ComputedValuesInner {
        &self.0.mSource
    }
}

impl ops::DerefMut for ComputedValues {
    fn deref_mut(&mut self) -> &mut ComputedValuesInner {
        &mut self.0.mSource
    }
}

impl ComputedValuesInner {
    /// Returns true if the value of the `content` property would make a
    /// pseudo-element not rendered.
    #[inline]
    pub fn ineffective_content_property(&self) -> bool {
        self.get_counters().ineffective_content_property()
    }

    #[inline]
    pub fn clone_background(&self) -> Arc<style_structs::Background> {
        Arc::from_raw_offset(self.Background.clone())
    }
    #[inline]
    pub fn get_background(&self) -> &style_structs::Background {
        &self.Background
    }


    pub fn background_arc(&self) -> &RawOffsetArc<style_structs::Background> {
        &self.Background
    }

    #[inline]
    pub fn mutate_background(&mut self) -> &mut style_structs::Background {
        RawOffsetArc::make_mut(&mut self.Background)
    }
    #[inline]
    pub fn clone_border(&self) -> Arc<style_structs::Border> {
        Arc::from_raw_offset(self.Border.clone())
    }
    #[inline]
    pub fn get_border(&self) -> &style_structs::Border {
        &self.Border
    }


    pub fn border_arc(&self) -> &RawOffsetArc<style_structs::Border> {
        &self.Border
    }

    #[inline]
    pub fn mutate_border(&mut self) -> &mut style_structs::Border {
        RawOffsetArc::make_mut(&mut self.Border)
    }
    #[inline]
    pub fn clone_box(&self) -> Arc<style_structs::Box> {
        Arc::from_raw_offset(self.Display.clone())
    }
    #[inline]
    pub fn get_box(&self) -> &style_structs::Box {
        &self.Display
    }


    pub fn box_arc(&self) -> &RawOffsetArc<style_structs::Box> {
        &self.Display
    }

    #[inline]
    pub fn mutate_box(&mut self) -> &mut style_structs::Box {
        RawOffsetArc::make_mut(&mut self.Display)
    }
    #[inline]
    pub fn clone_color(&self) -> Arc<style_structs::Color> {
        Arc::from_raw_offset(self.Color.clone())
    }
    #[inline]
    pub fn get_color(&self) -> &style_structs::Color {
        &self.Color
    }


    pub fn color_arc(&self) -> &RawOffsetArc<style_structs::Color> {
        &self.Color
    }

    #[inline]
    pub fn mutate_color(&mut self) -> &mut style_structs::Color {
        RawOffsetArc::make_mut(&mut self.Color)
    }
    #[inline]
    pub fn clone_column(&self) -> Arc<style_structs::Column> {
        Arc::from_raw_offset(self.Column.clone())
    }
    #[inline]
    pub fn get_column(&self) -> &style_structs::Column {
        &self.Column
    }


    pub fn column_arc(&self) -> &RawOffsetArc<style_structs::Column> {
        &self.Column
    }

    #[inline]
    pub fn mutate_column(&mut self) -> &mut style_structs::Column {
        RawOffsetArc::make_mut(&mut self.Column)
    }
    #[inline]
    pub fn clone_counters(&self) -> Arc<style_structs::Counters> {
        Arc::from_raw_offset(self.Content.clone())
    }
    #[inline]
    pub fn get_counters(&self) -> &style_structs::Counters {
        &self.Content
    }


    pub fn counters_arc(&self) -> &RawOffsetArc<style_structs::Counters> {
        &self.Content
    }

    #[inline]
    pub fn mutate_counters(&mut self) -> &mut style_structs::Counters {
        RawOffsetArc::make_mut(&mut self.Content)
    }
    #[inline]
    pub fn clone_effects(&self) -> Arc<style_structs::Effects> {
        Arc::from_raw_offset(self.Effects.clone())
    }
    #[inline]
    pub fn get_effects(&self) -> &style_structs::Effects {
        &self.Effects
    }


    pub fn effects_arc(&self) -> &RawOffsetArc<style_structs::Effects> {
        &self.Effects
    }

    #[inline]
    pub fn mutate_effects(&mut self) -> &mut style_structs::Effects {
        RawOffsetArc::make_mut(&mut self.Effects)
    }
    #[inline]
    pub fn clone_font(&self) -> Arc<style_structs::Font> {
        Arc::from_raw_offset(self.Font.clone())
    }
    #[inline]
    pub fn get_font(&self) -> &style_structs::Font {
        &self.Font
    }


    pub fn font_arc(&self) -> &RawOffsetArc<style_structs::Font> {
        &self.Font
    }

    #[inline]
    pub fn mutate_font(&mut self) -> &mut style_structs::Font {
        RawOffsetArc::make_mut(&mut self.Font)
    }
    #[inline]
    pub fn clone_inherited_box(&self) -> Arc<style_structs::InheritedBox> {
        Arc::from_raw_offset(self.Visibility.clone())
    }
    #[inline]
    pub fn get_inherited_box(&self) -> &style_structs::InheritedBox {
        &self.Visibility
    }


    pub fn inherited_box_arc(&self) -> &RawOffsetArc<style_structs::InheritedBox> {
        &self.Visibility
    }

    #[inline]
    pub fn mutate_inherited_box(&mut self) -> &mut style_structs::InheritedBox {
        RawOffsetArc::make_mut(&mut self.Visibility)
    }
    #[inline]
    pub fn clone_inherited_table(&self) -> Arc<style_structs::InheritedTable> {
        Arc::from_raw_offset(self.TableBorder.clone())
    }
    #[inline]
    pub fn get_inherited_table(&self) -> &style_structs::InheritedTable {
        &self.TableBorder
    }


    pub fn inherited_table_arc(&self) -> &RawOffsetArc<style_structs::InheritedTable> {
        &self.TableBorder
    }

    #[inline]
    pub fn mutate_inherited_table(&mut self) -> &mut style_structs::InheritedTable {
        RawOffsetArc::make_mut(&mut self.TableBorder)
    }
    #[inline]
    pub fn clone_inherited_text(&self) -> Arc<style_structs::InheritedText> {
        Arc::from_raw_offset(self.Text.clone())
    }
    #[inline]
    pub fn get_inherited_text(&self) -> &style_structs::InheritedText {
        &self.Text
    }


    pub fn inherited_text_arc(&self) -> &RawOffsetArc<style_structs::InheritedText> {
        &self.Text
    }

    #[inline]
    pub fn mutate_inherited_text(&mut self) -> &mut style_structs::InheritedText {
        RawOffsetArc::make_mut(&mut self.Text)
    }
    #[inline]
    pub fn clone_inherited_ui(&self) -> Arc<style_structs::InheritedUI> {
        Arc::from_raw_offset(self.UI.clone())
    }
    #[inline]
    pub fn get_inherited_ui(&self) -> &style_structs::InheritedUI {
        &self.UI
    }


    pub fn inherited_ui_arc(&self) -> &RawOffsetArc<style_structs::InheritedUI> {
        &self.UI
    }

    #[inline]
    pub fn mutate_inherited_ui(&mut self) -> &mut style_structs::InheritedUI {
        RawOffsetArc::make_mut(&mut self.UI)
    }
    #[inline]
    pub fn clone_inherited_svg(&self) -> Arc<style_structs::InheritedSVG> {
        Arc::from_raw_offset(self.SVG.clone())
    }
    #[inline]
    pub fn get_inherited_svg(&self) -> &style_structs::InheritedSVG {
        &self.SVG
    }


    pub fn inherited_svg_arc(&self) -> &RawOffsetArc<style_structs::InheritedSVG> {
        &self.SVG
    }

    #[inline]
    pub fn mutate_inherited_svg(&mut self) -> &mut style_structs::InheritedSVG {
        RawOffsetArc::make_mut(&mut self.SVG)
    }
    #[inline]
    pub fn clone_list(&self) -> Arc<style_structs::List> {
        Arc::from_raw_offset(self.List.clone())
    }
    #[inline]
    pub fn get_list(&self) -> &style_structs::List {
        &self.List
    }


    pub fn list_arc(&self) -> &RawOffsetArc<style_structs::List> {
        &self.List
    }

    #[inline]
    pub fn mutate_list(&mut self) -> &mut style_structs::List {
        RawOffsetArc::make_mut(&mut self.List)
    }
    #[inline]
    pub fn clone_margin(&self) -> Arc<style_structs::Margin> {
        Arc::from_raw_offset(self.Margin.clone())
    }
    #[inline]
    pub fn get_margin(&self) -> &style_structs::Margin {
        &self.Margin
    }


    pub fn margin_arc(&self) -> &RawOffsetArc<style_structs::Margin> {
        &self.Margin
    }

    #[inline]
    pub fn mutate_margin(&mut self) -> &mut style_structs::Margin {
        RawOffsetArc::make_mut(&mut self.Margin)
    }
    #[inline]
    pub fn clone_outline(&self) -> Arc<style_structs::Outline> {
        Arc::from_raw_offset(self.Outline.clone())
    }
    #[inline]
    pub fn get_outline(&self) -> &style_structs::Outline {
        &self.Outline
    }


    pub fn outline_arc(&self) -> &RawOffsetArc<style_structs::Outline> {
        &self.Outline
    }

    #[inline]
    pub fn mutate_outline(&mut self) -> &mut style_structs::Outline {
        RawOffsetArc::make_mut(&mut self.Outline)
    }
    #[inline]
    pub fn clone_padding(&self) -> Arc<style_structs::Padding> {
        Arc::from_raw_offset(self.Padding.clone())
    }
    #[inline]
    pub fn get_padding(&self) -> &style_structs::Padding {
        &self.Padding
    }


    pub fn padding_arc(&self) -> &RawOffsetArc<style_structs::Padding> {
        &self.Padding
    }

    #[inline]
    pub fn mutate_padding(&mut self) -> &mut style_structs::Padding {
        RawOffsetArc::make_mut(&mut self.Padding)
    }
    #[inline]
    pub fn clone_position(&self) -> Arc<style_structs::Position> {
        Arc::from_raw_offset(self.Position.clone())
    }
    #[inline]
    pub fn get_position(&self) -> &style_structs::Position {
        &self.Position
    }


    pub fn position_arc(&self) -> &RawOffsetArc<style_structs::Position> {
        &self.Position
    }

    #[inline]
    pub fn mutate_position(&mut self) -> &mut style_structs::Position {
        RawOffsetArc::make_mut(&mut self.Position)
    }
    #[inline]
    pub fn clone_table(&self) -> Arc<style_structs::Table> {
        Arc::from_raw_offset(self.Table.clone())
    }
    #[inline]
    pub fn get_table(&self) -> &style_structs::Table {
        &self.Table
    }


    pub fn table_arc(&self) -> &RawOffsetArc<style_structs::Table> {
        &self.Table
    }

    #[inline]
    pub fn mutate_table(&mut self) -> &mut style_structs::Table {
        RawOffsetArc::make_mut(&mut self.Table)
    }
    #[inline]
    pub fn clone_text(&self) -> Arc<style_structs::Text> {
        Arc::from_raw_offset(self.TextReset.clone())
    }
    #[inline]
    pub fn get_text(&self) -> &style_structs::Text {
        &self.TextReset
    }


    pub fn text_arc(&self) -> &RawOffsetArc<style_structs::Text> {
        &self.TextReset
    }

    #[inline]
    pub fn mutate_text(&mut self) -> &mut style_structs::Text {
        RawOffsetArc::make_mut(&mut self.TextReset)
    }
    #[inline]
    pub fn clone_ui(&self) -> Arc<style_structs::UI> {
        Arc::from_raw_offset(self.UIReset.clone())
    }
    #[inline]
    pub fn get_ui(&self) -> &style_structs::UI {
        &self.UIReset
    }


    pub fn ui_arc(&self) -> &RawOffsetArc<style_structs::UI> {
        &self.UIReset
    }

    #[inline]
    pub fn mutate_ui(&mut self) -> &mut style_structs::UI {
        RawOffsetArc::make_mut(&mut self.UIReset)
    }
    #[inline]
    pub fn clone_svg(&self) -> Arc<style_structs::SVG> {
        Arc::from_raw_offset(self.SVGReset.clone())
    }
    #[inline]
    pub fn get_svg(&self) -> &style_structs::SVG {
        &self.SVGReset
    }


    pub fn svg_arc(&self) -> &RawOffsetArc<style_structs::SVG> {
        &self.SVGReset
    }

    #[inline]
    pub fn mutate_svg(&mut self) -> &mut style_structs::SVG {
        RawOffsetArc::make_mut(&mut self.SVGReset)
    }
    #[inline]
    pub fn clone_xul(&self) -> Arc<style_structs::XUL> {
        Arc::from_raw_offset(self.XUL.clone())
    }
    #[inline]
    pub fn get_xul(&self) -> &style_structs::XUL {
        &self.XUL
    }


    pub fn xul_arc(&self) -> &RawOffsetArc<style_structs::XUL> {
        &self.XUL
    }

    #[inline]
    pub fn mutate_xul(&mut self) -> &mut style_structs::XUL {
        RawOffsetArc::make_mut(&mut self.XUL)
    }

    /// Gets the raw visited style. Useful for memory reporting.
    pub fn get_raw_visited_style(&self) -> &Option<RawOffsetArc<ComputedValues>> {
        &self.visited_style
    }

    #[allow(non_snake_case)]
    pub fn has_moz_binding(&self) -> bool {
        !self.get_box().gecko.mBinding.mRawPtr.is_null()
    }
}























































#[allow(dead_code)]
fn static_assert() {
    // Note: using the above technique with an enum hits a rust bug when |structs| is in a different crate.
    { const DETAIL: u32 = [0][(structs::Side::eSideTop as usize != 0) as usize]; let _ = DETAIL; }
    { const DETAIL: u32 = [0][(structs::Side::eSideRight as usize != 1) as usize]; let _ = DETAIL; }
    { const DETAIL: u32 = [0][(structs::Side::eSideBottom as usize != 2) as usize]; let _ = DETAIL; }
    { const DETAIL: u32 = [0][(structs::Side::eSideLeft as usize != 3) as usize]; let _ = DETAIL; }
}






impl GeckoBorder {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn set_border_top_style(&mut self, v: BorderStyle) {
        self.gecko.mBorderStyle[0] = v;

        // This is needed because the initial mComputedBorder value is set to
        // zero.
        //
        // In order to compute stuff, we start from the initial struct, and keep
        // going down the tree applying properties.
        //
        // That means, effectively, that when we set border-style to something
        // non-hidden, we should use the initial border instead.
        //
        // Servo stores the initial border-width in the initial struct, and then
        // adjusts as needed in the fixup phase. This means that the initial
        // struct is technically not valid without fixups, and that you lose
        // pretty much any sharing of the initial struct, which is kind of
        // unfortunate.
        //
        // Gecko has two fields for this, one that stores the "specified"
        // border, and other that stores the actual computed one. That means
        // that when we set border-style, border-width may change and we need to
        // sync back to the specified one. This is what this function does.
        //
        // Note that this doesn't impose any dependency in the order of
        // computation of the properties. This is only relevant if border-style
        // is specified, but border-width isn't. If border-width is specified at
        // some point, the two mBorder and mComputedBorder fields would be the
        // same already.
        //
        // Once we're here, we know that we'll run style fixups, so it's fine to
        // just copy the specified border here, we'll adjust it if it's
        // incorrect later.
        self.gecko.mComputedBorder.top = self.gecko.mBorder.top;
    }

    pub fn copy_border_top_style_from(&mut self, other: &Self) {
        self.gecko.mBorderStyle[0] = other.gecko.mBorderStyle[0];
        self.gecko.mComputedBorder.top = self.gecko.mBorder.top;
    }

    pub fn reset_border_top_style(&mut self, other: &Self) {
        self.copy_border_top_style_from(other);
    }

    #[inline]
    pub fn clone_border_top_style(&self) -> BorderStyle {
        self.gecko.mBorderStyle[0]
    }

    

    #[allow(non_snake_case)]
    pub fn set_border_top_color(&mut self, v: longhands::border_top_color::computed_value::T) {
        self.gecko.mBorderTopColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_top_color_from(&mut self, other: &Self) {
        self.gecko.mBorderTopColor = other.gecko.mBorderTopColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_top_color(&mut self, other: &Self) {
        self.copy_border_top_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_top_color(&self) -> longhands::border_top_color::computed_value::T {
        From::from(self.gecko.mBorderTopColor.clone())
    }



    
    #[allow(non_snake_case)]
    pub fn set_border_top_width(&mut self, v: longhands::border_top_width::computed_value::T) {
        let value = {
            let au_per_device_px = Au(self.gecko.mTwipsPerPixel);
            round_border_to_device_pixels(Au::from(v), au_per_device_px).0
        };

        self.gecko.mBorder.top = value;
        self.gecko.mComputedBorder.top = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_border_top_width_from(&mut self, other: &Self) {
        self.gecko.mBorder.top = other.gecko.mBorder.top;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.gecko.mComputedBorder.top = other.gecko.mBorder.top;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_top_width(&mut self, other: &Self) {
        self.copy_border_top_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_top_width(&self) -> longhands::border_top_width::computed_value::T {
        Au(self.gecko.mComputedBorder.top).into()
    }


    pub fn border_top_has_nonzero_width(&self) -> bool {
        self.gecko.mComputedBorder.top != 0
    }
    pub fn set_border_right_style(&mut self, v: BorderStyle) {
        self.gecko.mBorderStyle[1] = v;

        // This is needed because the initial mComputedBorder value is set to
        // zero.
        //
        // In order to compute stuff, we start from the initial struct, and keep
        // going down the tree applying properties.
        //
        // That means, effectively, that when we set border-style to something
        // non-hidden, we should use the initial border instead.
        //
        // Servo stores the initial border-width in the initial struct, and then
        // adjusts as needed in the fixup phase. This means that the initial
        // struct is technically not valid without fixups, and that you lose
        // pretty much any sharing of the initial struct, which is kind of
        // unfortunate.
        //
        // Gecko has two fields for this, one that stores the "specified"
        // border, and other that stores the actual computed one. That means
        // that when we set border-style, border-width may change and we need to
        // sync back to the specified one. This is what this function does.
        //
        // Note that this doesn't impose any dependency in the order of
        // computation of the properties. This is only relevant if border-style
        // is specified, but border-width isn't. If border-width is specified at
        // some point, the two mBorder and mComputedBorder fields would be the
        // same already.
        //
        // Once we're here, we know that we'll run style fixups, so it's fine to
        // just copy the specified border here, we'll adjust it if it's
        // incorrect later.
        self.gecko.mComputedBorder.right = self.gecko.mBorder.right;
    }

    pub fn copy_border_right_style_from(&mut self, other: &Self) {
        self.gecko.mBorderStyle[1] = other.gecko.mBorderStyle[1];
        self.gecko.mComputedBorder.right = self.gecko.mBorder.right;
    }

    pub fn reset_border_right_style(&mut self, other: &Self) {
        self.copy_border_right_style_from(other);
    }

    #[inline]
    pub fn clone_border_right_style(&self) -> BorderStyle {
        self.gecko.mBorderStyle[1]
    }

    

    #[allow(non_snake_case)]
    pub fn set_border_right_color(&mut self, v: longhands::border_right_color::computed_value::T) {
        self.gecko.mBorderRightColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_right_color_from(&mut self, other: &Self) {
        self.gecko.mBorderRightColor = other.gecko.mBorderRightColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_right_color(&mut self, other: &Self) {
        self.copy_border_right_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_right_color(&self) -> longhands::border_right_color::computed_value::T {
        From::from(self.gecko.mBorderRightColor.clone())
    }



    
    #[allow(non_snake_case)]
    pub fn set_border_right_width(&mut self, v: longhands::border_right_width::computed_value::T) {
        let value = {
            let au_per_device_px = Au(self.gecko.mTwipsPerPixel);
            round_border_to_device_pixels(Au::from(v), au_per_device_px).0
        };

        self.gecko.mBorder.right = value;
        self.gecko.mComputedBorder.right = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_border_right_width_from(&mut self, other: &Self) {
        self.gecko.mBorder.right = other.gecko.mBorder.right;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.gecko.mComputedBorder.right = other.gecko.mBorder.right;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_right_width(&mut self, other: &Self) {
        self.copy_border_right_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_right_width(&self) -> longhands::border_right_width::computed_value::T {
        Au(self.gecko.mComputedBorder.right).into()
    }


    pub fn border_right_has_nonzero_width(&self) -> bool {
        self.gecko.mComputedBorder.right != 0
    }
    pub fn set_border_bottom_style(&mut self, v: BorderStyle) {
        self.gecko.mBorderStyle[2] = v;

        // This is needed because the initial mComputedBorder value is set to
        // zero.
        //
        // In order to compute stuff, we start from the initial struct, and keep
        // going down the tree applying properties.
        //
        // That means, effectively, that when we set border-style to something
        // non-hidden, we should use the initial border instead.
        //
        // Servo stores the initial border-width in the initial struct, and then
        // adjusts as needed in the fixup phase. This means that the initial
        // struct is technically not valid without fixups, and that you lose
        // pretty much any sharing of the initial struct, which is kind of
        // unfortunate.
        //
        // Gecko has two fields for this, one that stores the "specified"
        // border, and other that stores the actual computed one. That means
        // that when we set border-style, border-width may change and we need to
        // sync back to the specified one. This is what this function does.
        //
        // Note that this doesn't impose any dependency in the order of
        // computation of the properties. This is only relevant if border-style
        // is specified, but border-width isn't. If border-width is specified at
        // some point, the two mBorder and mComputedBorder fields would be the
        // same already.
        //
        // Once we're here, we know that we'll run style fixups, so it's fine to
        // just copy the specified border here, we'll adjust it if it's
        // incorrect later.
        self.gecko.mComputedBorder.bottom = self.gecko.mBorder.bottom;
    }

    pub fn copy_border_bottom_style_from(&mut self, other: &Self) {
        self.gecko.mBorderStyle[2] = other.gecko.mBorderStyle[2];
        self.gecko.mComputedBorder.bottom = self.gecko.mBorder.bottom;
    }

    pub fn reset_border_bottom_style(&mut self, other: &Self) {
        self.copy_border_bottom_style_from(other);
    }

    #[inline]
    pub fn clone_border_bottom_style(&self) -> BorderStyle {
        self.gecko.mBorderStyle[2]
    }

    

    #[allow(non_snake_case)]
    pub fn set_border_bottom_color(&mut self, v: longhands::border_bottom_color::computed_value::T) {
        self.gecko.mBorderBottomColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_bottom_color_from(&mut self, other: &Self) {
        self.gecko.mBorderBottomColor = other.gecko.mBorderBottomColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_bottom_color(&mut self, other: &Self) {
        self.copy_border_bottom_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_bottom_color(&self) -> longhands::border_bottom_color::computed_value::T {
        From::from(self.gecko.mBorderBottomColor.clone())
    }



    
    #[allow(non_snake_case)]
    pub fn set_border_bottom_width(&mut self, v: longhands::border_bottom_width::computed_value::T) {
        let value = {
            let au_per_device_px = Au(self.gecko.mTwipsPerPixel);
            round_border_to_device_pixels(Au::from(v), au_per_device_px).0
        };

        self.gecko.mBorder.bottom = value;
        self.gecko.mComputedBorder.bottom = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_border_bottom_width_from(&mut self, other: &Self) {
        self.gecko.mBorder.bottom = other.gecko.mBorder.bottom;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.gecko.mComputedBorder.bottom = other.gecko.mBorder.bottom;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_bottom_width(&mut self, other: &Self) {
        self.copy_border_bottom_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_bottom_width(&self) -> longhands::border_bottom_width::computed_value::T {
        Au(self.gecko.mComputedBorder.bottom).into()
    }


    pub fn border_bottom_has_nonzero_width(&self) -> bool {
        self.gecko.mComputedBorder.bottom != 0
    }
    pub fn set_border_left_style(&mut self, v: BorderStyle) {
        self.gecko.mBorderStyle[3] = v;

        // This is needed because the initial mComputedBorder value is set to
        // zero.
        //
        // In order to compute stuff, we start from the initial struct, and keep
        // going down the tree applying properties.
        //
        // That means, effectively, that when we set border-style to something
        // non-hidden, we should use the initial border instead.
        //
        // Servo stores the initial border-width in the initial struct, and then
        // adjusts as needed in the fixup phase. This means that the initial
        // struct is technically not valid without fixups, and that you lose
        // pretty much any sharing of the initial struct, which is kind of
        // unfortunate.
        //
        // Gecko has two fields for this, one that stores the "specified"
        // border, and other that stores the actual computed one. That means
        // that when we set border-style, border-width may change and we need to
        // sync back to the specified one. This is what this function does.
        //
        // Note that this doesn't impose any dependency in the order of
        // computation of the properties. This is only relevant if border-style
        // is specified, but border-width isn't. If border-width is specified at
        // some point, the two mBorder and mComputedBorder fields would be the
        // same already.
        //
        // Once we're here, we know that we'll run style fixups, so it's fine to
        // just copy the specified border here, we'll adjust it if it's
        // incorrect later.
        self.gecko.mComputedBorder.left = self.gecko.mBorder.left;
    }

    pub fn copy_border_left_style_from(&mut self, other: &Self) {
        self.gecko.mBorderStyle[3] = other.gecko.mBorderStyle[3];
        self.gecko.mComputedBorder.left = self.gecko.mBorder.left;
    }

    pub fn reset_border_left_style(&mut self, other: &Self) {
        self.copy_border_left_style_from(other);
    }

    #[inline]
    pub fn clone_border_left_style(&self) -> BorderStyle {
        self.gecko.mBorderStyle[3]
    }

    

    #[allow(non_snake_case)]
    pub fn set_border_left_color(&mut self, v: longhands::border_left_color::computed_value::T) {
        self.gecko.mBorderLeftColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_left_color_from(&mut self, other: &Self) {
        self.gecko.mBorderLeftColor = other.gecko.mBorderLeftColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_left_color(&mut self, other: &Self) {
        self.copy_border_left_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_left_color(&self) -> longhands::border_left_color::computed_value::T {
        From::from(self.gecko.mBorderLeftColor.clone())
    }



    
    #[allow(non_snake_case)]
    pub fn set_border_left_width(&mut self, v: longhands::border_left_width::computed_value::T) {
        let value = {
            let au_per_device_px = Au(self.gecko.mTwipsPerPixel);
            round_border_to_device_pixels(Au::from(v), au_per_device_px).0
        };

        self.gecko.mBorder.left = value;
        self.gecko.mComputedBorder.left = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_border_left_width_from(&mut self, other: &Self) {
        self.gecko.mBorder.left = other.gecko.mBorder.left;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.gecko.mComputedBorder.left = other.gecko.mBorder.left;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_left_width(&mut self, other: &Self) {
        self.copy_border_left_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_left_width(&self) -> longhands::border_left_width::computed_value::T {
        Au(self.gecko.mComputedBorder.left).into()
    }


    pub fn border_left_has_nonzero_width(&self) -> bool {
        self.gecko.mComputedBorder.left != 0
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_top_left_radius(&mut self, v: longhands::border_top_left_radius::computed_value::T) {
        self.gecko.mBorderRadius.top_left = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_border_top_left_radius_from(&mut self, other: &Self) {
        self.gecko.mBorderRadius.top_left =
            other.gecko.mBorderRadius.top_left;
    }
    #[allow(non_snake_case)]
    pub fn reset_border_top_left_radius(&mut self, other: &Self) {
        self.copy_border_top_left_radius_from(other)
    }
    #[allow(non_snake_case)]
    pub fn clone_border_top_left_radius(&self) -> longhands::border_top_left_radius::computed_value::T {
        self.gecko.mBorderRadius.top_left
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_top_right_radius(&mut self, v: longhands::border_top_right_radius::computed_value::T) {
        self.gecko.mBorderRadius.top_right = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_border_top_right_radius_from(&mut self, other: &Self) {
        self.gecko.mBorderRadius.top_right =
            other.gecko.mBorderRadius.top_right;
    }
    #[allow(non_snake_case)]
    pub fn reset_border_top_right_radius(&mut self, other: &Self) {
        self.copy_border_top_right_radius_from(other)
    }
    #[allow(non_snake_case)]
    pub fn clone_border_top_right_radius(&self) -> longhands::border_top_right_radius::computed_value::T {
        self.gecko.mBorderRadius.top_right
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_bottom_right_radius(&mut self, v: longhands::border_bottom_right_radius::computed_value::T) {
        self.gecko.mBorderRadius.bottom_right = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_border_bottom_right_radius_from(&mut self, other: &Self) {
        self.gecko.mBorderRadius.bottom_right =
            other.gecko.mBorderRadius.bottom_right;
    }
    #[allow(non_snake_case)]
    pub fn reset_border_bottom_right_radius(&mut self, other: &Self) {
        self.copy_border_bottom_right_radius_from(other)
    }
    #[allow(non_snake_case)]
    pub fn clone_border_bottom_right_radius(&self) -> longhands::border_bottom_right_radius::computed_value::T {
        self.gecko.mBorderRadius.bottom_right
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_bottom_left_radius(&mut self, v: longhands::border_bottom_left_radius::computed_value::T) {
        self.gecko.mBorderRadius.bottom_left = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_border_bottom_left_radius_from(&mut self, other: &Self) {
        self.gecko.mBorderRadius.bottom_left =
            other.gecko.mBorderRadius.bottom_left;
    }
    #[allow(non_snake_case)]
    pub fn reset_border_bottom_left_radius(&mut self, other: &Self) {
        self.copy_border_bottom_left_radius_from(other)
    }
    #[allow(non_snake_case)]
    pub fn clone_border_bottom_left_radius(&self) -> longhands::border_bottom_left_radius::computed_value::T {
        self.gecko.mBorderRadius.bottom_left
    }


    pub fn set_border_image_source(&mut self, image: longhands::border_image_source::computed_value::T) {
        unsafe {
            // Prevent leaking of the last elements we did set
            Gecko_SetNullImageValue(&mut self.gecko.mBorderImageSource);
        }

        if let Either::Second(image) = image {
            self.gecko.mBorderImageSource.set(image);
        }
    }

    pub fn copy_border_image_source_from(&mut self, other: &Self) {
        unsafe {
            Gecko_CopyImageValueFrom(&mut self.gecko.mBorderImageSource,
                                     &other.gecko.mBorderImageSource);
        }
    }

    pub fn reset_border_image_source(&mut self, other: &Self) {
        self.copy_border_image_source_from(other)
    }

    pub fn clone_border_image_source(&self) -> longhands::border_image_source::computed_value::T {
        use crate::values::None_;

        match unsafe { self.gecko.mBorderImageSource.into_image() } {
            Some(image) => Either::Second(image),
            None => Either::First(None_),
        }
    }

    

    pub fn set_border_image_repeat(&mut self, v: longhands::border_image_repeat::computed_value::T) {
        use crate::values::specified::border::BorderImageRepeatKeyword;
        use crate::gecko_bindings::structs::StyleBorderImageRepeat;

            self.gecko.mBorderImageRepeatH = match v.0 {
                BorderImageRepeatKeyword::Stretch => StyleBorderImageRepeat::Stretch,
                BorderImageRepeatKeyword::Repeat => StyleBorderImageRepeat::Repeat,
                BorderImageRepeatKeyword::Round => StyleBorderImageRepeat::Round,
                BorderImageRepeatKeyword::Space => StyleBorderImageRepeat::Space,
            };
            self.gecko.mBorderImageRepeatV = match v.1 {
                BorderImageRepeatKeyword::Stretch => StyleBorderImageRepeat::Stretch,
                BorderImageRepeatKeyword::Repeat => StyleBorderImageRepeat::Repeat,
                BorderImageRepeatKeyword::Round => StyleBorderImageRepeat::Round,
                BorderImageRepeatKeyword::Space => StyleBorderImageRepeat::Space,
            };
    }

    pub fn copy_border_image_repeat_from(&mut self, other: &Self) {
        self.gecko.mBorderImageRepeatH = other.gecko.mBorderImageRepeatH;
        self.gecko.mBorderImageRepeatV = other.gecko.mBorderImageRepeatV;
    }

    pub fn reset_border_image_repeat(&mut self, other: &Self) {
        self.copy_border_image_repeat_from(other)
    }

    pub fn clone_border_image_repeat(&self) -> longhands::border_image_repeat::computed_value::T {
        use crate::values::specified::border::BorderImageRepeatKeyword;
        use crate::gecko_bindings::structs::StyleBorderImageRepeat;

        let servo_h = match self.gecko.mBorderImageRepeatH {
            StyleBorderImageRepeat::Stretch => BorderImageRepeatKeyword::Stretch,
            StyleBorderImageRepeat::Repeat => BorderImageRepeatKeyword::Repeat,
            StyleBorderImageRepeat::Round => BorderImageRepeatKeyword::Round,
            StyleBorderImageRepeat::Space => BorderImageRepeatKeyword::Space,
        };
        let servo_v = match self.gecko.mBorderImageRepeatV {
            StyleBorderImageRepeat::Stretch => BorderImageRepeatKeyword::Stretch,
            StyleBorderImageRepeat::Repeat => BorderImageRepeatKeyword::Repeat,
            StyleBorderImageRepeat::Round => BorderImageRepeatKeyword::Round,
            StyleBorderImageRepeat::Space => BorderImageRepeatKeyword::Space,
        };
        longhands::border_image_repeat::computed_value::T(servo_h, servo_v)
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_border_image_width(&mut self, v: longhands::border_image_width::computed_value::T) {
        v.to_gecko_rect(&mut self.gecko.mBorderImageWidth);
    }

    
    
    #[allow(non_snake_case)]
    pub fn copy_border_image_width_from(&mut self, other: &Self) {
            self.gecko.mBorderImageWidth.data_at_mut(0)
                .copy_from(&other.gecko.mBorderImageWidth.data_at(0));
            self.gecko.mBorderImageWidth.data_at_mut(1)
                .copy_from(&other.gecko.mBorderImageWidth.data_at(1));
            self.gecko.mBorderImageWidth.data_at_mut(2)
                .copy_from(&other.gecko.mBorderImageWidth.data_at(2));
            self.gecko.mBorderImageWidth.data_at_mut(3)
                .copy_from(&other.gecko.mBorderImageWidth.data_at(3));
        
    }

    #[allow(non_snake_case)]
    pub fn reset_border_image_width(&mut self, other: &Self) {
        self.copy_border_image_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_image_width(&self) -> longhands::border_image_width::computed_value::T {
        longhands::border_image_width::computed_value::T::from_gecko_rect(&self.gecko.mBorderImageWidth)
            .expect("clone for border_image_width failed")
    }



    /*
     * Auto-Generated Methods.
     */
    
    
    /// Set the appropriate physical property for border-block-start-color given a writing mode.
    pub fn set_border_block_start_color(&mut self,
                                      v: longhands::border_block_start_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-color
    /// given a writing mode.
    pub fn copy_border_block_start_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-color
    /// given a writing mode.
    pub fn reset_border_block_start_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_start_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-start-color given a writing mode.
    pub fn clone_border_block_start_color(&self, wm: WritingMode)
        -> longhands::border_block_start_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-start-style given a writing mode.
    pub fn set_border_block_start_style(&mut self,
                                      v: longhands::border_block_start_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-style
    /// given a writing mode.
    pub fn copy_border_block_start_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-style
    /// given a writing mode.
    pub fn reset_border_block_start_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_start_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-start-style given a writing mode.
    pub fn clone_border_block_start_style(&self, wm: WritingMode)
        -> longhands::border_block_start_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-start-width given a writing mode.
    pub fn set_border_block_start_width(&mut self,
                                      v: longhands::border_block_start_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-width
    /// given a writing mode.
    pub fn copy_border_block_start_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-width
    /// given a writing mode.
    pub fn reset_border_block_start_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_start_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-start-width given a writing mode.
    pub fn clone_border_block_start_width(&self, wm: WritingMode)
        -> longhands::border_block_start_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-end-color given a writing mode.
    pub fn set_border_block_end_color(&mut self,
                                      v: longhands::border_block_end_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-color
    /// given a writing mode.
    pub fn copy_border_block_end_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-color
    /// given a writing mode.
    pub fn reset_border_block_end_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_end_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-end-color given a writing mode.
    pub fn clone_border_block_end_color(&self, wm: WritingMode)
        -> longhands::border_block_end_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-end-style given a writing mode.
    pub fn set_border_block_end_style(&mut self,
                                      v: longhands::border_block_end_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-style
    /// given a writing mode.
    pub fn copy_border_block_end_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-style
    /// given a writing mode.
    pub fn reset_border_block_end_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_end_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-end-style given a writing mode.
    pub fn clone_border_block_end_style(&self, wm: WritingMode)
        -> longhands::border_block_end_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-end-width given a writing mode.
    pub fn set_border_block_end_width(&mut self,
                                      v: longhands::border_block_end_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-width
    /// given a writing mode.
    pub fn copy_border_block_end_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-width
    /// given a writing mode.
    pub fn reset_border_block_end_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_end_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-end-width given a writing mode.
    pub fn clone_border_block_end_width(&self, wm: WritingMode)
        -> longhands::border_block_end_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-start-color given a writing mode.
    pub fn set_border_inline_start_color(&mut self,
                                      v: longhands::border_inline_start_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-color
    /// given a writing mode.
    pub fn copy_border_inline_start_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-color
    /// given a writing mode.
    pub fn reset_border_inline_start_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_start_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-start-color given a writing mode.
    pub fn clone_border_inline_start_color(&self, wm: WritingMode)
        -> longhands::border_inline_start_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-start-style given a writing mode.
    pub fn set_border_inline_start_style(&mut self,
                                      v: longhands::border_inline_start_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-style
    /// given a writing mode.
    pub fn copy_border_inline_start_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-style
    /// given a writing mode.
    pub fn reset_border_inline_start_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_start_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-start-style given a writing mode.
    pub fn clone_border_inline_start_style(&self, wm: WritingMode)
        -> longhands::border_inline_start_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-start-width given a writing mode.
    pub fn set_border_inline_start_width(&mut self,
                                      v: longhands::border_inline_start_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-width
    /// given a writing mode.
    pub fn copy_border_inline_start_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-width
    /// given a writing mode.
    pub fn reset_border_inline_start_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_start_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-start-width given a writing mode.
    pub fn clone_border_inline_start_width(&self, wm: WritingMode)
        -> longhands::border_inline_start_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-end-color given a writing mode.
    pub fn set_border_inline_end_color(&mut self,
                                      v: longhands::border_inline_end_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-color
    /// given a writing mode.
    pub fn copy_border_inline_end_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-color
    /// given a writing mode.
    pub fn reset_border_inline_end_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_end_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-end-color given a writing mode.
    pub fn clone_border_inline_end_color(&self, wm: WritingMode)
        -> longhands::border_inline_end_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-end-style given a writing mode.
    pub fn set_border_inline_end_style(&mut self,
                                      v: longhands::border_inline_end_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-style
    /// given a writing mode.
    pub fn copy_border_inline_end_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-style
    /// given a writing mode.
    pub fn reset_border_inline_end_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_end_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-end-style given a writing mode.
    pub fn clone_border_inline_end_style(&self, wm: WritingMode)
        -> longhands::border_inline_end_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-end-width given a writing mode.
    pub fn set_border_inline_end_width(&mut self,
                                      v: longhands::border_inline_end_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-width
    /// given a writing mode.
    pub fn copy_border_inline_end_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-width
    /// given a writing mode.
    pub fn reset_border_inline_end_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_end_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-end-width given a writing mode.
    pub fn clone_border_inline_end_width(&self, wm: WritingMode)
        -> longhands::border_inline_end_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-start-start-radius given a writing mode.
    pub fn set_border_start_start_radius(&mut self,
                                      v: longhands::border_start_start_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-start-radius
    /// given a writing mode.
    pub fn copy_border_start_start_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-start-radius
    /// given a writing mode.
    pub fn reset_border_start_start_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_start_start_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-start-start-radius given a writing mode.
    pub fn clone_border_start_start_radius(&self, wm: WritingMode)
        -> longhands::border_start_start_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-start-end-radius given a writing mode.
    pub fn set_border_start_end_radius(&mut self,
                                      v: longhands::border_start_end_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-end-radius
    /// given a writing mode.
    pub fn copy_border_start_end_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-end-radius
    /// given a writing mode.
    pub fn reset_border_start_end_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_start_end_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-start-end-radius given a writing mode.
    pub fn clone_border_start_end_radius(&self, wm: WritingMode)
        -> longhands::border_start_end_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-end-start-radius given a writing mode.
    pub fn set_border_end_start_radius(&mut self,
                                      v: longhands::border_end_start_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-start-radius
    /// given a writing mode.
    pub fn copy_border_end_start_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-start-radius
    /// given a writing mode.
    pub fn reset_border_end_start_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_end_start_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-end-start-radius given a writing mode.
    pub fn clone_border_end_start_radius(&self, wm: WritingMode)
        -> longhands::border_end_start_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-end-end-radius given a writing mode.
    pub fn set_border_end_end_radius(&mut self,
                                      v: longhands::border_end_end_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-end-radius
    /// given a writing mode.
    pub fn copy_border_end_end_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-end-radius
    /// given a writing mode.
    pub fn reset_border_end_end_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_end_end_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-end-end-radius given a writing mode.
    pub fn clone_border_end_end_radius(&self, wm: WritingMode)
        -> longhands::border_end_end_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }



    #[allow(non_snake_case)]
    pub fn set_box_decoration_break(&mut self, v: longhands::box_decoration_break::computed_value::T) {
        use crate::properties::longhands::box_decoration_break::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Slice =>
                    structs::StyleBoxDecorationBreak::Slice ,
                Keyword::Clone =>
                    structs::StyleBoxDecorationBreak::Clone ,
        };
        self.gecko.mBoxDecorationBreak = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_box_decoration_break_from(&mut self, other: &Self) {
        self.gecko.mBoxDecorationBreak = other.gecko.mBoxDecorationBreak.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_box_decoration_break(&mut self, other: &Self) {
        self.copy_box_decoration_break_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_box_decoration_break(&self) -> longhands::box_decoration_break::computed_value::T {
        use crate::properties::longhands::box_decoration_break::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBoxDecorationBreak {
            structs::StyleBoxDecorationBreak::Slice => Keyword::Slice,
            structs::StyleBoxDecorationBreak::Clone => Keyword::Clone,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_float_edge(&mut self, v: longhands::_moz_float_edge::computed_value::T) {
        use crate::properties::longhands::_moz_float_edge::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::ContentBox =>
                    structs::StyleFloatEdge::ContentBox ,
                Keyword::MarginBox =>
                    structs::StyleFloatEdge::MarginBox ,
        };
        self.gecko.mFloatEdge = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_float_edge_from(&mut self, other: &Self) {
        self.gecko.mFloatEdge = other.gecko.mFloatEdge.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_float_edge(&mut self, other: &Self) {
        self.copy__moz_float_edge_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_float_edge(&self) -> longhands::_moz_float_edge::computed_value::T {
        use crate::properties::longhands::_moz_float_edge::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mFloatEdge {
            structs::StyleFloatEdge::ContentBox => Keyword::ContentBox,
            structs::StyleFloatEdge::MarginBox => Keyword::MarginBox,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_border_image_outset(&mut self, v: longhands::border_image_outset::computed_value::T) {
        self.gecko.mBorderImageOutset = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_image_outset_from(&mut self, other: &Self) {
        self.gecko.mBorderImageOutset = other.gecko.mBorderImageOutset.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_image_outset(&mut self, other: &Self) {
        self.copy_border_image_outset_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_image_outset(&self) -> longhands::border_image_outset::computed_value::T {
        From::from(self.gecko.mBorderImageOutset.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_border_image_slice(&mut self, v: longhands::border_image_slice::computed_value::T) {
        self.gecko.mBorderImageSlice = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_image_slice_from(&mut self, other: &Self) {
        self.gecko.mBorderImageSlice = other.gecko.mBorderImageSlice.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_image_slice(&mut self, other: &Self) {
        self.copy_border_image_slice_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_image_slice(&self) -> longhands::border_image_slice::computed_value::T {
        From::from(self.gecko.mBorderImageSlice.clone())
    }


}






impl GeckoMargin {
    /*
     * Manually-Implemented Methods.
     */
    

    
    #[allow(non_snake_case)]
    pub fn set_margin_top(&mut self, v: longhands::margin_top::computed_value::T) {
        self.gecko.mMargin.0 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_margin_top_from(&mut self, other: &Self) {
        self.gecko.mMargin.0 =
            other.gecko.mMargin.0;
    }
    #[allow(non_snake_case)]
    pub fn reset_margin_top(&mut self, other: &Self) {
        self.copy_margin_top_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_margin_top(&self) -> longhands::margin_top::computed_value::T {
        self.gecko.mMargin.0
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_top(&mut self, v: longhands::scroll_margin_top::computed_value::T) {
        self.gecko.mScrollMargin.0 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_margin_top_from(&mut self, other: &Self) {
        self.gecko.mScrollMargin.0 =
            other.gecko.mScrollMargin.0;
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_margin_top(&mut self, other: &Self) {
        self.copy_scroll_margin_top_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_top(&self) -> longhands::scroll_margin_top::computed_value::T {
        self.gecko.mScrollMargin.0
    }

    
    #[allow(non_snake_case)]
    pub fn set_margin_right(&mut self, v: longhands::margin_right::computed_value::T) {
        self.gecko.mMargin.1 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_margin_right_from(&mut self, other: &Self) {
        self.gecko.mMargin.1 =
            other.gecko.mMargin.1;
    }
    #[allow(non_snake_case)]
    pub fn reset_margin_right(&mut self, other: &Self) {
        self.copy_margin_right_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_margin_right(&self) -> longhands::margin_right::computed_value::T {
        self.gecko.mMargin.1
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_right(&mut self, v: longhands::scroll_margin_right::computed_value::T) {
        self.gecko.mScrollMargin.1 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_margin_right_from(&mut self, other: &Self) {
        self.gecko.mScrollMargin.1 =
            other.gecko.mScrollMargin.1;
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_margin_right(&mut self, other: &Self) {
        self.copy_scroll_margin_right_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_right(&self) -> longhands::scroll_margin_right::computed_value::T {
        self.gecko.mScrollMargin.1
    }

    
    #[allow(non_snake_case)]
    pub fn set_margin_bottom(&mut self, v: longhands::margin_bottom::computed_value::T) {
        self.gecko.mMargin.2 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_margin_bottom_from(&mut self, other: &Self) {
        self.gecko.mMargin.2 =
            other.gecko.mMargin.2;
    }
    #[allow(non_snake_case)]
    pub fn reset_margin_bottom(&mut self, other: &Self) {
        self.copy_margin_bottom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_margin_bottom(&self) -> longhands::margin_bottom::computed_value::T {
        self.gecko.mMargin.2
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_bottom(&mut self, v: longhands::scroll_margin_bottom::computed_value::T) {
        self.gecko.mScrollMargin.2 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_margin_bottom_from(&mut self, other: &Self) {
        self.gecko.mScrollMargin.2 =
            other.gecko.mScrollMargin.2;
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_margin_bottom(&mut self, other: &Self) {
        self.copy_scroll_margin_bottom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_bottom(&self) -> longhands::scroll_margin_bottom::computed_value::T {
        self.gecko.mScrollMargin.2
    }

    
    #[allow(non_snake_case)]
    pub fn set_margin_left(&mut self, v: longhands::margin_left::computed_value::T) {
        self.gecko.mMargin.3 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_margin_left_from(&mut self, other: &Self) {
        self.gecko.mMargin.3 =
            other.gecko.mMargin.3;
    }
    #[allow(non_snake_case)]
    pub fn reset_margin_left(&mut self, other: &Self) {
        self.copy_margin_left_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_margin_left(&self) -> longhands::margin_left::computed_value::T {
        self.gecko.mMargin.3
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_left(&mut self, v: longhands::scroll_margin_left::computed_value::T) {
        self.gecko.mScrollMargin.3 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_margin_left_from(&mut self, other: &Self) {
        self.gecko.mScrollMargin.3 =
            other.gecko.mScrollMargin.3;
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_margin_left(&mut self, other: &Self) {
        self.copy_scroll_margin_left_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_left(&self) -> longhands::scroll_margin_left::computed_value::T {
        self.gecko.mScrollMargin.3
    }



    /*
     * Auto-Generated Methods.
     */
    
    
    /// Set the appropriate physical property for margin-block-start given a writing mode.
    pub fn set_margin_block_start(&mut self,
                                      v: longhands::margin_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-start
    /// given a writing mode.
    pub fn copy_margin_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-start
    /// given a writing mode.
    pub fn reset_margin_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-block-start given a writing mode.
    pub fn clone_margin_block_start(&self, wm: WritingMode)
        -> longhands::margin_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for margin-block-end given a writing mode.
    pub fn set_margin_block_end(&mut self,
                                      v: longhands::margin_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-end
    /// given a writing mode.
    pub fn copy_margin_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-end
    /// given a writing mode.
    pub fn reset_margin_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-block-end given a writing mode.
    pub fn clone_margin_block_end(&self, wm: WritingMode)
        -> longhands::margin_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for margin-inline-start given a writing mode.
    pub fn set_margin_inline_start(&mut self,
                                      v: longhands::margin_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-start
    /// given a writing mode.
    pub fn copy_margin_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-start
    /// given a writing mode.
    pub fn reset_margin_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-inline-start given a writing mode.
    pub fn clone_margin_inline_start(&self, wm: WritingMode)
        -> longhands::margin_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for margin-inline-end given a writing mode.
    pub fn set_margin_inline_end(&mut self,
                                      v: longhands::margin_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-end
    /// given a writing mode.
    pub fn copy_margin_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-end
    /// given a writing mode.
    pub fn reset_margin_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-inline-end given a writing mode.
    pub fn clone_margin_inline_end(&self, wm: WritingMode)
        -> longhands::margin_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-margin-block-start given a writing mode.
    pub fn set_scroll_margin_block_start(&mut self,
                                      v: longhands::scroll_margin_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-block-start
    /// given a writing mode.
    pub fn copy_scroll_margin_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-block-start
    /// given a writing mode.
    pub fn reset_scroll_margin_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_margin_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-margin-block-start given a writing mode.
    pub fn clone_scroll_margin_block_start(&self, wm: WritingMode)
        -> longhands::scroll_margin_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-margin-block-end given a writing mode.
    pub fn set_scroll_margin_block_end(&mut self,
                                      v: longhands::scroll_margin_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-block-end
    /// given a writing mode.
    pub fn copy_scroll_margin_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-block-end
    /// given a writing mode.
    pub fn reset_scroll_margin_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_margin_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-margin-block-end given a writing mode.
    pub fn clone_scroll_margin_block_end(&self, wm: WritingMode)
        -> longhands::scroll_margin_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-margin-inline-start given a writing mode.
    pub fn set_scroll_margin_inline_start(&mut self,
                                      v: longhands::scroll_margin_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-inline-start
    /// given a writing mode.
    pub fn copy_scroll_margin_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-inline-start
    /// given a writing mode.
    pub fn reset_scroll_margin_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_margin_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-margin-inline-start given a writing mode.
    pub fn clone_scroll_margin_inline_start(&self, wm: WritingMode)
        -> longhands::scroll_margin_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-margin-inline-end given a writing mode.
    pub fn set_scroll_margin_inline_end(&mut self,
                                      v: longhands::scroll_margin_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-inline-end
    /// given a writing mode.
    pub fn copy_scroll_margin_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-inline-end
    /// given a writing mode.
    pub fn reset_scroll_margin_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_margin_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-margin-inline-end given a writing mode.
    pub fn clone_scroll_margin_inline_end(&self, wm: WritingMode)
        -> longhands::scroll_margin_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_margin_left()
        
                }
        }

    }


}






impl GeckoPadding {
    /*
     * Manually-Implemented Methods.
     */
    

    
    #[allow(non_snake_case)]
    pub fn set_padding_top(&mut self, v: longhands::padding_top::computed_value::T) {
        self.gecko.mPadding.0 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_padding_top_from(&mut self, other: &Self) {
        self.gecko.mPadding.0 =
            other.gecko.mPadding.0;
    }
    #[allow(non_snake_case)]
    pub fn reset_padding_top(&mut self, other: &Self) {
        self.copy_padding_top_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_padding_top(&self) -> longhands::padding_top::computed_value::T {
        self.gecko.mPadding.0
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_top(&mut self, v: longhands::scroll_padding_top::computed_value::T) {
        self.gecko.mScrollPadding.0 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_padding_top_from(&mut self, other: &Self) {
        self.gecko.mScrollPadding.0 =
            other.gecko.mScrollPadding.0;
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_padding_top(&mut self, other: &Self) {
        self.copy_scroll_padding_top_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_top(&self) -> longhands::scroll_padding_top::computed_value::T {
        self.gecko.mScrollPadding.0
    }

    
    #[allow(non_snake_case)]
    pub fn set_padding_right(&mut self, v: longhands::padding_right::computed_value::T) {
        self.gecko.mPadding.1 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_padding_right_from(&mut self, other: &Self) {
        self.gecko.mPadding.1 =
            other.gecko.mPadding.1;
    }
    #[allow(non_snake_case)]
    pub fn reset_padding_right(&mut self, other: &Self) {
        self.copy_padding_right_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_padding_right(&self) -> longhands::padding_right::computed_value::T {
        self.gecko.mPadding.1
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_right(&mut self, v: longhands::scroll_padding_right::computed_value::T) {
        self.gecko.mScrollPadding.1 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_padding_right_from(&mut self, other: &Self) {
        self.gecko.mScrollPadding.1 =
            other.gecko.mScrollPadding.1;
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_padding_right(&mut self, other: &Self) {
        self.copy_scroll_padding_right_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_right(&self) -> longhands::scroll_padding_right::computed_value::T {
        self.gecko.mScrollPadding.1
    }

    
    #[allow(non_snake_case)]
    pub fn set_padding_bottom(&mut self, v: longhands::padding_bottom::computed_value::T) {
        self.gecko.mPadding.2 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_padding_bottom_from(&mut self, other: &Self) {
        self.gecko.mPadding.2 =
            other.gecko.mPadding.2;
    }
    #[allow(non_snake_case)]
    pub fn reset_padding_bottom(&mut self, other: &Self) {
        self.copy_padding_bottom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_padding_bottom(&self) -> longhands::padding_bottom::computed_value::T {
        self.gecko.mPadding.2
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_bottom(&mut self, v: longhands::scroll_padding_bottom::computed_value::T) {
        self.gecko.mScrollPadding.2 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_padding_bottom_from(&mut self, other: &Self) {
        self.gecko.mScrollPadding.2 =
            other.gecko.mScrollPadding.2;
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_padding_bottom(&mut self, other: &Self) {
        self.copy_scroll_padding_bottom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_bottom(&self) -> longhands::scroll_padding_bottom::computed_value::T {
        self.gecko.mScrollPadding.2
    }

    
    #[allow(non_snake_case)]
    pub fn set_padding_left(&mut self, v: longhands::padding_left::computed_value::T) {
        self.gecko.mPadding.3 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_padding_left_from(&mut self, other: &Self) {
        self.gecko.mPadding.3 =
            other.gecko.mPadding.3;
    }
    #[allow(non_snake_case)]
    pub fn reset_padding_left(&mut self, other: &Self) {
        self.copy_padding_left_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_padding_left(&self) -> longhands::padding_left::computed_value::T {
        self.gecko.mPadding.3
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_left(&mut self, v: longhands::scroll_padding_left::computed_value::T) {
        self.gecko.mScrollPadding.3 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_padding_left_from(&mut self, other: &Self) {
        self.gecko.mScrollPadding.3 =
            other.gecko.mScrollPadding.3;
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_padding_left(&mut self, other: &Self) {
        self.copy_scroll_padding_left_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_left(&self) -> longhands::scroll_padding_left::computed_value::T {
        self.gecko.mScrollPadding.3
    }



    /*
     * Auto-Generated Methods.
     */
    
    
    /// Set the appropriate physical property for padding-block-start given a writing mode.
    pub fn set_padding_block_start(&mut self,
                                      v: longhands::padding_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-start
    /// given a writing mode.
    pub fn copy_padding_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-start
    /// given a writing mode.
    pub fn reset_padding_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-block-start given a writing mode.
    pub fn clone_padding_block_start(&self, wm: WritingMode)
        -> longhands::padding_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for padding-block-end given a writing mode.
    pub fn set_padding_block_end(&mut self,
                                      v: longhands::padding_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-end
    /// given a writing mode.
    pub fn copy_padding_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-end
    /// given a writing mode.
    pub fn reset_padding_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-block-end given a writing mode.
    pub fn clone_padding_block_end(&self, wm: WritingMode)
        -> longhands::padding_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for padding-inline-start given a writing mode.
    pub fn set_padding_inline_start(&mut self,
                                      v: longhands::padding_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-start
    /// given a writing mode.
    pub fn copy_padding_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-start
    /// given a writing mode.
    pub fn reset_padding_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-inline-start given a writing mode.
    pub fn clone_padding_inline_start(&self, wm: WritingMode)
        -> longhands::padding_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for padding-inline-end given a writing mode.
    pub fn set_padding_inline_end(&mut self,
                                      v: longhands::padding_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-end
    /// given a writing mode.
    pub fn copy_padding_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-end
    /// given a writing mode.
    pub fn reset_padding_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-inline-end given a writing mode.
    pub fn clone_padding_inline_end(&self, wm: WritingMode)
        -> longhands::padding_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-padding-block-start given a writing mode.
    pub fn set_scroll_padding_block_start(&mut self,
                                      v: longhands::scroll_padding_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-block-start
    /// given a writing mode.
    pub fn copy_scroll_padding_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-block-start
    /// given a writing mode.
    pub fn reset_scroll_padding_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_padding_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-padding-block-start given a writing mode.
    pub fn clone_scroll_padding_block_start(&self, wm: WritingMode)
        -> longhands::scroll_padding_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-padding-block-end given a writing mode.
    pub fn set_scroll_padding_block_end(&mut self,
                                      v: longhands::scroll_padding_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-block-end
    /// given a writing mode.
    pub fn copy_scroll_padding_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-block-end
    /// given a writing mode.
    pub fn reset_scroll_padding_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_padding_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-padding-block-end given a writing mode.
    pub fn clone_scroll_padding_block_end(&self, wm: WritingMode)
        -> longhands::scroll_padding_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-padding-inline-start given a writing mode.
    pub fn set_scroll_padding_inline_start(&mut self,
                                      v: longhands::scroll_padding_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-inline-start
    /// given a writing mode.
    pub fn copy_scroll_padding_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-inline-start
    /// given a writing mode.
    pub fn reset_scroll_padding_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_padding_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-padding-inline-start given a writing mode.
    pub fn clone_scroll_padding_inline_start(&self, wm: WritingMode)
        -> longhands::scroll_padding_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-padding-inline-end given a writing mode.
    pub fn set_scroll_padding_inline_end(&mut self,
                                      v: longhands::scroll_padding_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-inline-end
    /// given a writing mode.
    pub fn copy_scroll_padding_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-inline-end
    /// given a writing mode.
    pub fn reset_scroll_padding_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_padding_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-padding-inline-end given a writing mode.
    pub fn clone_scroll_padding_inline_end(&self, wm: WritingMode)
        -> longhands::scroll_padding_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_padding_left()
        
                }
        }

    }


}





impl GeckoPosition {
    /*
     * Manually-Implemented Methods.
     */
    
    
    #[allow(non_snake_case)]
    pub fn set_top(&mut self, v: longhands::top::computed_value::T) {
        self.gecko.mOffset.0 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_top_from(&mut self, other: &Self) {
        self.gecko.mOffset.0 =
            other.gecko.mOffset.0;
    }
    #[allow(non_snake_case)]
    pub fn reset_top(&mut self, other: &Self) {
        self.copy_top_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_top(&self) -> longhands::top::computed_value::T {
        self.gecko.mOffset.0
    }

    
    #[allow(non_snake_case)]
    pub fn set_right(&mut self, v: longhands::right::computed_value::T) {
        self.gecko.mOffset.1 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_right_from(&mut self, other: &Self) {
        self.gecko.mOffset.1 =
            other.gecko.mOffset.1;
    }
    #[allow(non_snake_case)]
    pub fn reset_right(&mut self, other: &Self) {
        self.copy_right_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_right(&self) -> longhands::right::computed_value::T {
        self.gecko.mOffset.1
    }

    
    #[allow(non_snake_case)]
    pub fn set_bottom(&mut self, v: longhands::bottom::computed_value::T) {
        self.gecko.mOffset.2 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_bottom_from(&mut self, other: &Self) {
        self.gecko.mOffset.2 =
            other.gecko.mOffset.2;
    }
    #[allow(non_snake_case)]
    pub fn reset_bottom(&mut self, other: &Self) {
        self.copy_bottom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_bottom(&self) -> longhands::bottom::computed_value::T {
        self.gecko.mOffset.2
    }

    
    #[allow(non_snake_case)]
    pub fn set_left(&mut self, v: longhands::left::computed_value::T) {
        self.gecko.mOffset.3 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_left_from(&mut self, other: &Self) {
        self.gecko.mOffset.3 =
            other.gecko.mOffset.3;
    }
    #[allow(non_snake_case)]
    pub fn reset_left(&mut self, other: &Self) {
        self.copy_left_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_left(&self) -> longhands::left::computed_value::T {
        self.gecko.mOffset.3
    }


    
    

    #[allow(non_snake_case)]
    pub fn set_align_content(&mut self, v: longhands::align_content::computed_value::T) {
        self.gecko.mAlignContent = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_align_content_from(&mut self, other: &Self) {
        self.gecko.mAlignContent = other.gecko.mAlignContent.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_align_content(&mut self, other: &Self) {
        self.copy_align_content_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_align_content(&self) -> longhands::align_content::computed_value::T {
        From::from(self.gecko.mAlignContent)
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_align_self(&mut self, v: longhands::align_self::computed_value::T) {
        self.gecko.mAlignSelf = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_align_self_from(&mut self, other: &Self) {
        self.gecko.mAlignSelf = other.gecko.mAlignSelf.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_align_self(&mut self, other: &Self) {
        self.copy_align_self_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_align_self(&self) -> longhands::align_self::computed_value::T {
        From::from(self.gecko.mAlignSelf)
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_justify_content(&mut self, v: longhands::justify_content::computed_value::T) {
        self.gecko.mJustifyContent = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_justify_content_from(&mut self, other: &Self) {
        self.gecko.mJustifyContent = other.gecko.mJustifyContent.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_justify_content(&mut self, other: &Self) {
        self.copy_justify_content_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_justify_content(&self) -> longhands::justify_content::computed_value::T {
        From::from(self.gecko.mJustifyContent)
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_justify_self(&mut self, v: longhands::justify_self::computed_value::T) {
        self.gecko.mJustifySelf = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_justify_self_from(&mut self, other: &Self) {
        self.gecko.mJustifySelf = other.gecko.mJustifySelf.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_justify_self(&mut self, other: &Self) {
        self.copy_justify_self_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_justify_self(&self) -> longhands::justify_self::computed_value::T {
        From::from(self.gecko.mJustifySelf)
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_align_items(&mut self, v: longhands::align_items::computed_value::T) {
        self.gecko.mAlignItems = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_align_items_from(&mut self, other: &Self) {
        self.gecko.mAlignItems = other.gecko.mAlignItems.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_align_items(&mut self, other: &Self) {
        self.copy_align_items_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_align_items(&self) -> longhands::align_items::computed_value::T {
        From::from(self.gecko.mAlignItems)
    }


    pub fn set_justify_items(&mut self, v: longhands::justify_items::computed_value::T) {
        self.gecko.mSpecifiedJustifyItems = v.specified.into();
        self.set_computed_justify_items(v.computed);
    }

    pub fn set_computed_justify_items(&mut self, v: values::specified::JustifyItems) {
        debug_assert_ne!(v.0, crate::values::specified::align::AlignFlags::LEGACY);
        self.gecko.mJustifyItems = v.into();
    }

    pub fn reset_justify_items(&mut self, reset_style: &Self) {
        self.gecko.mJustifyItems = reset_style.gecko.mJustifyItems;
        self.gecko.mSpecifiedJustifyItems = reset_style.gecko.mSpecifiedJustifyItems;
    }

    pub fn copy_justify_items_from(&mut self, other: &Self) {
        self.gecko.mJustifyItems = other.gecko.mJustifyItems;
        self.gecko.mSpecifiedJustifyItems = other.gecko.mJustifyItems;
    }

    pub fn clone_justify_items(&self) -> longhands::justify_items::computed_value::T {
        longhands::justify_items::computed_value::T {
            computed: self.gecko.mJustifyItems.into(),
            specified: self.gecko.mSpecifiedJustifyItems.into(),
        }
    }

    pub fn set_order(&mut self, v: longhands::order::computed_value::T) {
        self.gecko.mOrder = v;
    }

    pub fn clone_order(&self) -> longhands::order::computed_value::T {
        self.gecko.mOrder
    }

    
    #[allow(non_snake_case)]
    pub fn copy_order_from(&mut self, other: &Self) {
        self.gecko.mOrder = other.gecko.mOrder.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_order(&mut self, other: &Self) {
        self.copy_order_from(other)
    }


    pub fn set_grid_row_start(&mut self, v: longhands::grid_row_start::computed_value::T) {
        use crate::gecko_bindings::structs::{nsStyleGridLine_kMinLine, nsStyleGridLine_kMaxLine};

        let ident = v.ident.as_ref().map_or(&[] as &[_], |ident| ident.0.as_slice());
        self.gecko.mGridRowStart.mLineName.assign(ident);
        self.gecko.mGridRowStart.mHasSpan = v.is_span;
        if let Some(integer) = v.line_num {
            // clamping the integer between a range
            self.gecko.mGridRowStart.mInteger = cmp::max(nsStyleGridLine_kMinLine,
                cmp::min(integer, nsStyleGridLine_kMaxLine));
        }
    }

    pub fn copy_grid_row_start_from(&mut self, other: &Self) {
        self.gecko.mGridRowStart.mHasSpan = other.gecko.mGridRowStart.mHasSpan;
        self.gecko.mGridRowStart.mInteger = other.gecko.mGridRowStart.mInteger;
        self.gecko.mGridRowStart.mLineName.assign(&*other.gecko.mGridRowStart.mLineName);
    }

    pub fn reset_grid_row_start(&mut self, other: &Self) {
        self.copy_grid_row_start_from(other)
    }

    pub fn clone_grid_row_start(&self) -> longhands::grid_row_start::computed_value::T {
        use crate::gecko_bindings::structs::{nsStyleGridLine_kMinLine, nsStyleGridLine_kMaxLine};

        longhands::grid_row_start::computed_value::T {
            is_span: self.gecko.mGridRowStart.mHasSpan,
            ident: {
                let name = self.gecko.mGridRowStart.mLineName.to_string();
                if name.len() == 0 {
                    None
                } else {
                    Some(CustomIdent(Atom::from(name)))
                }
            },
            line_num:
                if self.gecko.mGridRowStart.mInteger == 0 {
                    None
                } else {
                    debug_assert!(nsStyleGridLine_kMinLine <= self.gecko.mGridRowStart.mInteger);
                    debug_assert!(self.gecko.mGridRowStart.mInteger <= nsStyleGridLine_kMaxLine);
                    Some(self.gecko.mGridRowStart.mInteger)
                },
        }
    }
    pub fn set_grid_row_end(&mut self, v: longhands::grid_row_end::computed_value::T) {
        use crate::gecko_bindings::structs::{nsStyleGridLine_kMinLine, nsStyleGridLine_kMaxLine};

        let ident = v.ident.as_ref().map_or(&[] as &[_], |ident| ident.0.as_slice());
        self.gecko.mGridRowEnd.mLineName.assign(ident);
        self.gecko.mGridRowEnd.mHasSpan = v.is_span;
        if let Some(integer) = v.line_num {
            // clamping the integer between a range
            self.gecko.mGridRowEnd.mInteger = cmp::max(nsStyleGridLine_kMinLine,
                cmp::min(integer, nsStyleGridLine_kMaxLine));
        }
    }

    pub fn copy_grid_row_end_from(&mut self, other: &Self) {
        self.gecko.mGridRowEnd.mHasSpan = other.gecko.mGridRowEnd.mHasSpan;
        self.gecko.mGridRowEnd.mInteger = other.gecko.mGridRowEnd.mInteger;
        self.gecko.mGridRowEnd.mLineName.assign(&*other.gecko.mGridRowEnd.mLineName);
    }

    pub fn reset_grid_row_end(&mut self, other: &Self) {
        self.copy_grid_row_end_from(other)
    }

    pub fn clone_grid_row_end(&self) -> longhands::grid_row_end::computed_value::T {
        use crate::gecko_bindings::structs::{nsStyleGridLine_kMinLine, nsStyleGridLine_kMaxLine};

        longhands::grid_row_end::computed_value::T {
            is_span: self.gecko.mGridRowEnd.mHasSpan,
            ident: {
                let name = self.gecko.mGridRowEnd.mLineName.to_string();
                if name.len() == 0 {
                    None
                } else {
                    Some(CustomIdent(Atom::from(name)))
                }
            },
            line_num:
                if self.gecko.mGridRowEnd.mInteger == 0 {
                    None
                } else {
                    debug_assert!(nsStyleGridLine_kMinLine <= self.gecko.mGridRowEnd.mInteger);
                    debug_assert!(self.gecko.mGridRowEnd.mInteger <= nsStyleGridLine_kMaxLine);
                    Some(self.gecko.mGridRowEnd.mInteger)
                },
        }
    }
    pub fn set_grid_column_start(&mut self, v: longhands::grid_column_start::computed_value::T) {
        use crate::gecko_bindings::structs::{nsStyleGridLine_kMinLine, nsStyleGridLine_kMaxLine};

        let ident = v.ident.as_ref().map_or(&[] as &[_], |ident| ident.0.as_slice());
        self.gecko.mGridColumnStart.mLineName.assign(ident);
        self.gecko.mGridColumnStart.mHasSpan = v.is_span;
        if let Some(integer) = v.line_num {
            // clamping the integer between a range
            self.gecko.mGridColumnStart.mInteger = cmp::max(nsStyleGridLine_kMinLine,
                cmp::min(integer, nsStyleGridLine_kMaxLine));
        }
    }

    pub fn copy_grid_column_start_from(&mut self, other: &Self) {
        self.gecko.mGridColumnStart.mHasSpan = other.gecko.mGridColumnStart.mHasSpan;
        self.gecko.mGridColumnStart.mInteger = other.gecko.mGridColumnStart.mInteger;
        self.gecko.mGridColumnStart.mLineName.assign(&*other.gecko.mGridColumnStart.mLineName);
    }

    pub fn reset_grid_column_start(&mut self, other: &Self) {
        self.copy_grid_column_start_from(other)
    }

    pub fn clone_grid_column_start(&self) -> longhands::grid_column_start::computed_value::T {
        use crate::gecko_bindings::structs::{nsStyleGridLine_kMinLine, nsStyleGridLine_kMaxLine};

        longhands::grid_column_start::computed_value::T {
            is_span: self.gecko.mGridColumnStart.mHasSpan,
            ident: {
                let name = self.gecko.mGridColumnStart.mLineName.to_string();
                if name.len() == 0 {
                    None
                } else {
                    Some(CustomIdent(Atom::from(name)))
                }
            },
            line_num:
                if self.gecko.mGridColumnStart.mInteger == 0 {
                    None
                } else {
                    debug_assert!(nsStyleGridLine_kMinLine <= self.gecko.mGridColumnStart.mInteger);
                    debug_assert!(self.gecko.mGridColumnStart.mInteger <= nsStyleGridLine_kMaxLine);
                    Some(self.gecko.mGridColumnStart.mInteger)
                },
        }
    }
    pub fn set_grid_column_end(&mut self, v: longhands::grid_column_end::computed_value::T) {
        use crate::gecko_bindings::structs::{nsStyleGridLine_kMinLine, nsStyleGridLine_kMaxLine};

        let ident = v.ident.as_ref().map_or(&[] as &[_], |ident| ident.0.as_slice());
        self.gecko.mGridColumnEnd.mLineName.assign(ident);
        self.gecko.mGridColumnEnd.mHasSpan = v.is_span;
        if let Some(integer) = v.line_num {
            // clamping the integer between a range
            self.gecko.mGridColumnEnd.mInteger = cmp::max(nsStyleGridLine_kMinLine,
                cmp::min(integer, nsStyleGridLine_kMaxLine));
        }
    }

    pub fn copy_grid_column_end_from(&mut self, other: &Self) {
        self.gecko.mGridColumnEnd.mHasSpan = other.gecko.mGridColumnEnd.mHasSpan;
        self.gecko.mGridColumnEnd.mInteger = other.gecko.mGridColumnEnd.mInteger;
        self.gecko.mGridColumnEnd.mLineName.assign(&*other.gecko.mGridColumnEnd.mLineName);
    }

    pub fn reset_grid_column_end(&mut self, other: &Self) {
        self.copy_grid_column_end_from(other)
    }

    pub fn clone_grid_column_end(&self) -> longhands::grid_column_end::computed_value::T {
        use crate::gecko_bindings::structs::{nsStyleGridLine_kMinLine, nsStyleGridLine_kMaxLine};

        longhands::grid_column_end::computed_value::T {
            is_span: self.gecko.mGridColumnEnd.mHasSpan,
            ident: {
                let name = self.gecko.mGridColumnEnd.mLineName.to_string();
                if name.len() == 0 {
                    None
                } else {
                    Some(CustomIdent(Atom::from(name)))
                }
            },
            line_num:
                if self.gecko.mGridColumnEnd.mInteger == 0 {
                    None
                } else {
                    debug_assert!(nsStyleGridLine_kMinLine <= self.gecko.mGridColumnEnd.mInteger);
                    debug_assert!(self.gecko.mGridColumnEnd.mInteger <= nsStyleGridLine_kMaxLine);
                    Some(self.gecko.mGridColumnEnd.mInteger)
                },
        }
    }

    pub fn set_grid_auto_rows(&mut self, v: longhands::grid_auto_rows::computed_value::T) {
        let gecko = &mut *self.gecko;
        v.to_gecko_style_coords(&mut gecko.mGridAutoRowsMin,
                                &mut gecko.mGridAutoRowsMax)
    }

    pub fn copy_grid_auto_rows_from(&mut self, other: &Self) {
        self.gecko.mGridAutoRowsMin.copy_from(&other.gecko.mGridAutoRowsMin);
        self.gecko.mGridAutoRowsMax.copy_from(&other.gecko.mGridAutoRowsMax);
    }

    pub fn reset_grid_auto_rows(&mut self, other: &Self) {
        self.copy_grid_auto_rows_from(other)
    }

    pub fn clone_grid_auto_rows(&self) -> longhands::grid_auto_rows::computed_value::T {
        crate::values::generics::grid::TrackSize::from_gecko_style_coords(&self.gecko.mGridAutoRowsMin,
                                                                     &self.gecko.mGridAutoRowsMax)
    }

    pub fn set_grid_template_rows(&mut self, v: longhands::grid_template_rows::computed_value::T) {
        
        use crate::gecko_bindings::structs::{nsTArray, nsStyleGridLine_kMaxLine};
        use nsstring::nsString;
        use std::usize;
        use crate::values::CustomIdent;
        use crate::values::generics::grid::TrackListType::Auto;
        use crate::values::generics::grid::{GridTemplateComponent, RepeatCount};

        #[inline]
        fn set_line_names(servo_names: &[CustomIdent], gecko_names: &mut nsTArray<nsString>) {
            unsafe {
                bindings::Gecko_ResizeTArrayForStrings(gecko_names, servo_names.len() as u32);
            }

            for (servo_name, gecko_name) in servo_names.iter().zip(gecko_names.iter_mut()) {
                gecko_name.assign(servo_name.0.as_slice());
            }
        }

        let max_lines = nsStyleGridLine_kMaxLine as usize - 1;      // for accounting the final <line-names>

        let result = match v {
            GridTemplateComponent::None => ptr::null_mut(),
            GridTemplateComponent::TrackList(track) => {
                let mut num_values = track.values.len();
                if let Auto(_) = track.list_type {
                    num_values += 1;
                }

                num_values = cmp::min(num_values, max_lines);
                let value = unsafe {
                    bindings::Gecko_CreateStyleGridTemplate(num_values as u32,
                                                            (num_values + 1) as u32).as_mut().unwrap()
                };

                let mut auto_idx = usize::MAX;
                let mut auto_track_size = None;
                if let Auto(idx) = track.list_type {
                    auto_idx = idx as usize;
                    let auto_repeat = track.auto_repeat.as_ref().expect("expected <auto-track-repeat> value");

                    if auto_repeat.count == RepeatCount::AutoFill {
                        value.set_mIsAutoFill(true);
                    }

                    value.mRepeatAutoIndex = idx as i16;
                    // NOTE: Gecko supports only one set of values in <auto-repeat>
                    // i.e., it can only take repeat(auto-fill, [a] 10px [b]), and no more.
                    set_line_names(&auto_repeat.line_names[0], &mut value.mRepeatAutoLineNameListBefore);
                    set_line_names(&auto_repeat.line_names[1], &mut value.mRepeatAutoLineNameListAfter);
                    auto_track_size = Some(auto_repeat.track_sizes.get(0).unwrap().clone());
                } else {
                    unsafe {
                        bindings::Gecko_ResizeTArrayForStrings(
                            &mut value.mRepeatAutoLineNameListBefore, 0);
                        bindings::Gecko_ResizeTArrayForStrings(
                            &mut value.mRepeatAutoLineNameListAfter, 0);
                    }
                }

                let mut line_names = track.line_names.into_iter();
                let mut values_iter = track.values.into_iter();
                {
                    let min_max_iter = value.mMinTrackSizingFunctions.iter_mut()
                                            .zip(value.mMaxTrackSizingFunctions.iter_mut());
                    for (i, (gecko_min, gecko_max)) in min_max_iter.enumerate().take(max_lines) {
                        let name_list = line_names.next().expect("expected line-names");
                        set_line_names(&name_list, &mut value.mLineNameLists[i]);
                        if i == auto_idx {
                            let track_size = auto_track_size.take()
                                .expect("expected <track-size> for <auto-track-repeat>");
                            track_size.to_gecko_style_coords(gecko_min, gecko_max);
                            continue
                        }

                        let track_size = values_iter.next().expect("expected <track-size> value");
                        track_size.to_gecko_style_coords(gecko_min, gecko_max);
                    }
                }

                let final_names = line_names.next().unwrap();
                set_line_names(&final_names, value.mLineNameLists.last_mut().unwrap());

                value
            },
            GridTemplateComponent::Subgrid(list) => {
                let names_length = match list.fill_idx {
                    Some(_) => list.names.len() - 1,
                    None => list.names.len(),
                };
                let num_values = cmp::min(names_length, max_lines + 1);
                let value = unsafe {
                    bindings::Gecko_CreateStyleGridTemplate(0, num_values as u32).as_mut().unwrap()
                };
                value.set_mIsSubgrid(true);

                let mut names = list.names.into_vec();
                if let Some(idx) = list.fill_idx {
                    value.set_mIsAutoFill(true);
                    value.mRepeatAutoIndex = idx as i16;
                    set_line_names(&names.swap_remove(idx as usize),
                                   &mut value.mRepeatAutoLineNameListBefore);
                }

                for (servo_names, gecko_names) in names.iter().zip(value.mLineNameLists.iter_mut()) {
                    set_line_names(servo_names, gecko_names);
                }

                value
            },
        };

        unsafe { bindings::Gecko_SetStyleGridTemplate(&mut self.gecko.mGridTemplateRows, result); }
    }

    pub fn copy_grid_template_rows_from(&mut self, other: &Self) {
        unsafe {
            bindings::Gecko_CopyStyleGridTemplateValues(&mut self.gecko.mGridTemplateRows,
                                                        other.gecko.mGridTemplateRows.mPtr);
        }
    }

    pub fn reset_grid_template_rows(&mut self, other: &Self) {
        self.copy_grid_template_rows_from(other)
    }

    pub fn clone_grid_template_rows(&self) -> longhands::grid_template_rows::computed_value::T {
        
        use crate::gecko_bindings::structs::nsTArray;
        use nsstring::nsString;
        use crate::values::CustomIdent;
        use crate::values::generics::grid::{GridTemplateComponent, LineNameList, RepeatCount};
        use crate::values::generics::grid::{TrackList, TrackListType, TrackListValue, TrackRepeat, TrackSize};

        let value = match unsafe { self.gecko.mGridTemplateRows.mPtr.as_ref() } {
            None => return GridTemplateComponent::None,
            Some(value) => value,
        };

        #[inline]
        fn to_boxed_customident_slice(gecko_names: &nsTArray<nsString>) -> Box<[CustomIdent]> {
            let idents: Vec<CustomIdent> = gecko_names.iter().map(|gecko_name| {
                CustomIdent(Atom::from(gecko_name.to_string()))
            }).collect();
            idents.into_boxed_slice()
        }

        #[inline]
        fn to_line_names_vec(gecko_line_names: &nsTArray<nsTArray<nsString>>)
            -> Vec<Box<[CustomIdent]>> {
            gecko_line_names.iter().map(|gecko_names| {
                to_boxed_customident_slice(gecko_names)
            }).collect()
        }

        let repeat_auto_index = value.mRepeatAutoIndex as usize;
        if value.mIsSubgrid() {
            let mut names_vec = to_line_names_vec(&value.mLineNameLists);
            let fill_idx = if value.mIsAutoFill() {
                names_vec.insert(
                    repeat_auto_index,
                    to_boxed_customident_slice(&value.mRepeatAutoLineNameListBefore));
                Some(repeat_auto_index as u32)
            } else {
                None
            };
            let names = names_vec.into_boxed_slice();

            GridTemplateComponent::Subgrid(LineNameList{names, fill_idx})
        } else {
            let mut auto_repeat = None;
            let mut list_type = TrackListType::Normal;
            let line_names = to_line_names_vec(&value.mLineNameLists).into_boxed_slice();
            let mut values = Vec::with_capacity(value.mMinTrackSizingFunctions.len());

            let min_max_iter = value.mMinTrackSizingFunctions.iter()
                .zip(value.mMaxTrackSizingFunctions.iter());
            for (i, (gecko_min, gecko_max)) in min_max_iter.enumerate() {
                let track_size = TrackSize::from_gecko_style_coords(gecko_min, gecko_max);

                if i == repeat_auto_index {
                    list_type = TrackListType::Auto(repeat_auto_index as u16);

                    let count = if value.mIsAutoFill() {
                        RepeatCount::AutoFill
                    } else {
                        RepeatCount::AutoFit
                    };

                    let line_names = {
                        let mut vec: Vec<Box<[CustomIdent]>> = Vec::with_capacity(2);
                        vec.push(to_boxed_customident_slice(
                            &value.mRepeatAutoLineNameListBefore));
                        vec.push(to_boxed_customident_slice(
                            &value.mRepeatAutoLineNameListAfter));
                        vec.into_boxed_slice()
                    };

                    let track_sizes = vec!(track_size);

                    auto_repeat = Some(TrackRepeat{count, line_names, track_sizes});
                } else {
                    values.push(TrackListValue::TrackSize(track_size));
                }
            }

            GridTemplateComponent::TrackList(TrackList{list_type, values, line_names, auto_repeat})
        }
    }
    pub fn set_grid_auto_columns(&mut self, v: longhands::grid_auto_columns::computed_value::T) {
        let gecko = &mut *self.gecko;
        v.to_gecko_style_coords(&mut gecko.mGridAutoColumnsMin,
                                &mut gecko.mGridAutoColumnsMax)
    }

    pub fn copy_grid_auto_columns_from(&mut self, other: &Self) {
        self.gecko.mGridAutoColumnsMin.copy_from(&other.gecko.mGridAutoColumnsMin);
        self.gecko.mGridAutoColumnsMax.copy_from(&other.gecko.mGridAutoColumnsMax);
    }

    pub fn reset_grid_auto_columns(&mut self, other: &Self) {
        self.copy_grid_auto_columns_from(other)
    }

    pub fn clone_grid_auto_columns(&self) -> longhands::grid_auto_columns::computed_value::T {
        crate::values::generics::grid::TrackSize::from_gecko_style_coords(&self.gecko.mGridAutoColumnsMin,
                                                                     &self.gecko.mGridAutoColumnsMax)
    }

    pub fn set_grid_template_columns(&mut self, v: longhands::grid_template_columns::computed_value::T) {
        
        use crate::gecko_bindings::structs::{nsTArray, nsStyleGridLine_kMaxLine};
        use nsstring::nsString;
        use std::usize;
        use crate::values::CustomIdent;
        use crate::values::generics::grid::TrackListType::Auto;
        use crate::values::generics::grid::{GridTemplateComponent, RepeatCount};

        #[inline]
        fn set_line_names(servo_names: &[CustomIdent], gecko_names: &mut nsTArray<nsString>) {
            unsafe {
                bindings::Gecko_ResizeTArrayForStrings(gecko_names, servo_names.len() as u32);
            }

            for (servo_name, gecko_name) in servo_names.iter().zip(gecko_names.iter_mut()) {
                gecko_name.assign(servo_name.0.as_slice());
            }
        }

        let max_lines = nsStyleGridLine_kMaxLine as usize - 1;      // for accounting the final <line-names>

        let result = match v {
            GridTemplateComponent::None => ptr::null_mut(),
            GridTemplateComponent::TrackList(track) => {
                let mut num_values = track.values.len();
                if let Auto(_) = track.list_type {
                    num_values += 1;
                }

                num_values = cmp::min(num_values, max_lines);
                let value = unsafe {
                    bindings::Gecko_CreateStyleGridTemplate(num_values as u32,
                                                            (num_values + 1) as u32).as_mut().unwrap()
                };

                let mut auto_idx = usize::MAX;
                let mut auto_track_size = None;
                if let Auto(idx) = track.list_type {
                    auto_idx = idx as usize;
                    let auto_repeat = track.auto_repeat.as_ref().expect("expected <auto-track-repeat> value");

                    if auto_repeat.count == RepeatCount::AutoFill {
                        value.set_mIsAutoFill(true);
                    }

                    value.mRepeatAutoIndex = idx as i16;
                    // NOTE: Gecko supports only one set of values in <auto-repeat>
                    // i.e., it can only take repeat(auto-fill, [a] 10px [b]), and no more.
                    set_line_names(&auto_repeat.line_names[0], &mut value.mRepeatAutoLineNameListBefore);
                    set_line_names(&auto_repeat.line_names[1], &mut value.mRepeatAutoLineNameListAfter);
                    auto_track_size = Some(auto_repeat.track_sizes.get(0).unwrap().clone());
                } else {
                    unsafe {
                        bindings::Gecko_ResizeTArrayForStrings(
                            &mut value.mRepeatAutoLineNameListBefore, 0);
                        bindings::Gecko_ResizeTArrayForStrings(
                            &mut value.mRepeatAutoLineNameListAfter, 0);
                    }
                }

                let mut line_names = track.line_names.into_iter();
                let mut values_iter = track.values.into_iter();
                {
                    let min_max_iter = value.mMinTrackSizingFunctions.iter_mut()
                                            .zip(value.mMaxTrackSizingFunctions.iter_mut());
                    for (i, (gecko_min, gecko_max)) in min_max_iter.enumerate().take(max_lines) {
                        let name_list = line_names.next().expect("expected line-names");
                        set_line_names(&name_list, &mut value.mLineNameLists[i]);
                        if i == auto_idx {
                            let track_size = auto_track_size.take()
                                .expect("expected <track-size> for <auto-track-repeat>");
                            track_size.to_gecko_style_coords(gecko_min, gecko_max);
                            continue
                        }

                        let track_size = values_iter.next().expect("expected <track-size> value");
                        track_size.to_gecko_style_coords(gecko_min, gecko_max);
                    }
                }

                let final_names = line_names.next().unwrap();
                set_line_names(&final_names, value.mLineNameLists.last_mut().unwrap());

                value
            },
            GridTemplateComponent::Subgrid(list) => {
                let names_length = match list.fill_idx {
                    Some(_) => list.names.len() - 1,
                    None => list.names.len(),
                };
                let num_values = cmp::min(names_length, max_lines + 1);
                let value = unsafe {
                    bindings::Gecko_CreateStyleGridTemplate(0, num_values as u32).as_mut().unwrap()
                };
                value.set_mIsSubgrid(true);

                let mut names = list.names.into_vec();
                if let Some(idx) = list.fill_idx {
                    value.set_mIsAutoFill(true);
                    value.mRepeatAutoIndex = idx as i16;
                    set_line_names(&names.swap_remove(idx as usize),
                                   &mut value.mRepeatAutoLineNameListBefore);
                }

                for (servo_names, gecko_names) in names.iter().zip(value.mLineNameLists.iter_mut()) {
                    set_line_names(servo_names, gecko_names);
                }

                value
            },
        };

        unsafe { bindings::Gecko_SetStyleGridTemplate(&mut self.gecko.mGridTemplateColumns, result); }
    }

    pub fn copy_grid_template_columns_from(&mut self, other: &Self) {
        unsafe {
            bindings::Gecko_CopyStyleGridTemplateValues(&mut self.gecko.mGridTemplateColumns,
                                                        other.gecko.mGridTemplateColumns.mPtr);
        }
    }

    pub fn reset_grid_template_columns(&mut self, other: &Self) {
        self.copy_grid_template_columns_from(other)
    }

    pub fn clone_grid_template_columns(&self) -> longhands::grid_template_columns::computed_value::T {
        
        use crate::gecko_bindings::structs::nsTArray;
        use nsstring::nsString;
        use crate::values::CustomIdent;
        use crate::values::generics::grid::{GridTemplateComponent, LineNameList, RepeatCount};
        use crate::values::generics::grid::{TrackList, TrackListType, TrackListValue, TrackRepeat, TrackSize};

        let value = match unsafe { self.gecko.mGridTemplateColumns.mPtr.as_ref() } {
            None => return GridTemplateComponent::None,
            Some(value) => value,
        };

        #[inline]
        fn to_boxed_customident_slice(gecko_names: &nsTArray<nsString>) -> Box<[CustomIdent]> {
            let idents: Vec<CustomIdent> = gecko_names.iter().map(|gecko_name| {
                CustomIdent(Atom::from(gecko_name.to_string()))
            }).collect();
            idents.into_boxed_slice()
        }

        #[inline]
        fn to_line_names_vec(gecko_line_names: &nsTArray<nsTArray<nsString>>)
            -> Vec<Box<[CustomIdent]>> {
            gecko_line_names.iter().map(|gecko_names| {
                to_boxed_customident_slice(gecko_names)
            }).collect()
        }

        let repeat_auto_index = value.mRepeatAutoIndex as usize;
        if value.mIsSubgrid() {
            let mut names_vec = to_line_names_vec(&value.mLineNameLists);
            let fill_idx = if value.mIsAutoFill() {
                names_vec.insert(
                    repeat_auto_index,
                    to_boxed_customident_slice(&value.mRepeatAutoLineNameListBefore));
                Some(repeat_auto_index as u32)
            } else {
                None
            };
            let names = names_vec.into_boxed_slice();

            GridTemplateComponent::Subgrid(LineNameList{names, fill_idx})
        } else {
            let mut auto_repeat = None;
            let mut list_type = TrackListType::Normal;
            let line_names = to_line_names_vec(&value.mLineNameLists).into_boxed_slice();
            let mut values = Vec::with_capacity(value.mMinTrackSizingFunctions.len());

            let min_max_iter = value.mMinTrackSizingFunctions.iter()
                .zip(value.mMaxTrackSizingFunctions.iter());
            for (i, (gecko_min, gecko_max)) in min_max_iter.enumerate() {
                let track_size = TrackSize::from_gecko_style_coords(gecko_min, gecko_max);

                if i == repeat_auto_index {
                    list_type = TrackListType::Auto(repeat_auto_index as u16);

                    let count = if value.mIsAutoFill() {
                        RepeatCount::AutoFill
                    } else {
                        RepeatCount::AutoFit
                    };

                    let line_names = {
                        let mut vec: Vec<Box<[CustomIdent]>> = Vec::with_capacity(2);
                        vec.push(to_boxed_customident_slice(
                            &value.mRepeatAutoLineNameListBefore));
                        vec.push(to_boxed_customident_slice(
                            &value.mRepeatAutoLineNameListAfter));
                        vec.into_boxed_slice()
                    };

                    let track_sizes = vec!(track_size);

                    auto_repeat = Some(TrackRepeat{count, line_names, track_sizes});
                } else {
                    values.push(TrackListValue::TrackSize(track_size));
                }
            }

            GridTemplateComponent::TrackList(TrackList{list_type, values, line_names, auto_repeat})
        }
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_grid_auto_flow(&mut self, v: longhands::grid_auto_flow::computed_value::T) {
        self.gecko.mGridAutoFlow = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_grid_auto_flow_from(&mut self, other: &Self) {
        self.gecko.mGridAutoFlow = other.gecko.mGridAutoFlow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_auto_flow(&mut self, other: &Self) {
        self.copy_grid_auto_flow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_auto_flow(&self) -> longhands::grid_auto_flow::computed_value::T {
        From::from(self.gecko.mGridAutoFlow)
    }


    pub fn set_grid_template_areas(&mut self, v: values::computed::position::GridTemplateAreas) {
        use crate::gecko_bindings::bindings::Gecko_NewGridTemplateAreasValue;
        use crate::gecko_bindings::sugar::refptr::UniqueRefPtr;

        let v = match v {
            Either::First(areas) => areas,
            Either::Second(_) => {
                unsafe { self.gecko.mGridTemplateAreas.clear() }
                return;
            },
        };

        let mut refptr = unsafe {
            UniqueRefPtr::from_addrefed(
                Gecko_NewGridTemplateAreasValue(v.0.areas.len() as u32, v.0.strings.len() as u32, v.0.width))
        };

        for (servo, gecko) in v.0.areas.into_iter().zip(refptr.mNamedAreas.iter_mut()) {
            gecko.mName.assign_str(&*servo.name);
            gecko.mColumnStart = servo.columns.start;
            gecko.mColumnEnd = servo.columns.end;
            gecko.mRowStart = servo.rows.start;
            gecko.mRowEnd = servo.rows.end;
        }

        for (servo, gecko) in v.0.strings.into_iter().zip(refptr.mTemplates.iter_mut()) {
            gecko.assign_str(&*servo);
        }

        self.gecko.mGridTemplateAreas.set_move(refptr.get())
    }

    pub fn copy_grid_template_areas_from(&mut self, other: &Self) {
        unsafe { self.gecko.mGridTemplateAreas.set(&other.gecko.mGridTemplateAreas) }
    }

    pub fn reset_grid_template_areas(&mut self, other: &Self) {
        self.copy_grid_template_areas_from(other)
    }

    pub fn clone_grid_template_areas(&self) -> values::computed::position::GridTemplateAreas {
        use std::ops::Range;
        use crate::values::None_;
        use crate::values::specified::position::{NamedArea, TemplateAreas, TemplateAreasArc};

        if self.gecko.mGridTemplateAreas.mRawPtr.is_null() {
            return Either::Second(None_);
        }

        let gecko_grid_template_areas = self.gecko.mGridTemplateAreas.mRawPtr;
        let areas = unsafe {
            let vec: Vec<NamedArea> =
                (*gecko_grid_template_areas).mNamedAreas.iter().map(|gecko_name_area| {
                    let name = gecko_name_area.mName.to_string().into_boxed_str();
                    let rows = Range {
                        start: gecko_name_area.mRowStart,
                        end: gecko_name_area.mRowEnd
                    };
                    let columns = Range {
                        start: gecko_name_area.mColumnStart,
                        end: gecko_name_area.mColumnEnd
                    };
                    NamedArea{ name, rows, columns }
                }).collect();
            vec.into_boxed_slice()
        };

        let strings = unsafe {
            let vec: Vec<Box<str>> =
                (*gecko_grid_template_areas).mTemplates.iter().map(|gecko_template| {
                    gecko_template.to_string().into_boxed_str()
                }).collect();
            vec.into_boxed_slice()
        };

        let width = unsafe {
            (*gecko_grid_template_areas).mNColumns
        };

        Either::First(TemplateAreasArc(Arc::new(TemplateAreas{ areas, strings, width })))
    }



    /*
     * Auto-Generated Methods.
     */
    
    
    /// Set the appropriate physical property for inset-block-start given a writing mode.
    pub fn set_inset_block_start(&mut self,
                                      v: longhands::inset_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-start
    /// given a writing mode.
    pub fn copy_inset_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-start
    /// given a writing mode.
    pub fn reset_inset_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-block-start given a writing mode.
    pub fn clone_inset_block_start(&self, wm: WritingMode)
        -> longhands::inset_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for inset-block-end given a writing mode.
    pub fn set_inset_block_end(&mut self,
                                      v: longhands::inset_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-end
    /// given a writing mode.
    pub fn copy_inset_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-end
    /// given a writing mode.
    pub fn reset_inset_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-block-end given a writing mode.
    pub fn clone_inset_block_end(&self, wm: WritingMode)
        -> longhands::inset_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for inset-inline-start given a writing mode.
    pub fn set_inset_inline_start(&mut self,
                                      v: longhands::inset_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-start
    /// given a writing mode.
    pub fn copy_inset_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-start
    /// given a writing mode.
    pub fn reset_inset_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-inline-start given a writing mode.
    pub fn clone_inset_inline_start(&self, wm: WritingMode)
        -> longhands::inset_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for inset-inline-end given a writing mode.
    pub fn set_inset_inline_end(&mut self,
                                      v: longhands::inset_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-end
    /// given a writing mode.
    pub fn copy_inset_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-end
    /// given a writing mode.
    pub fn reset_inset_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-inline-end given a writing mode.
    pub fn clone_inset_inline_end(&self, wm: WritingMode)
        -> longhands::inset_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }



    #[allow(non_snake_case)]
    pub fn set_z_index(&mut self, v: longhands::z_index::computed_value::T) {
        self.gecko.mZIndex = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_z_index_from(&mut self, other: &Self) {
        self.gecko.mZIndex = other.gecko.mZIndex.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_z_index(&mut self, other: &Self) {
        self.copy_z_index_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_z_index(&self) -> longhands::z_index::computed_value::T {
        From::from(self.gecko.mZIndex.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_flex_direction(&mut self, v: longhands::flex_direction::computed_value::T) {
        use crate::properties::longhands::flex_direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Row =>
                    structs::StyleFlexDirection::Row ,
                Keyword::RowReverse =>
                    structs::StyleFlexDirection::RowReverse ,
                Keyword::Column =>
                    structs::StyleFlexDirection::Column ,
                Keyword::ColumnReverse =>
                    structs::StyleFlexDirection::ColumnReverse ,
        };
        self.gecko.mFlexDirection = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_direction_from(&mut self, other: &Self) {
        self.gecko.mFlexDirection = other.gecko.mFlexDirection.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_direction(&mut self, other: &Self) {
        self.copy_flex_direction_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_flex_direction(&self) -> longhands::flex_direction::computed_value::T {
        use crate::properties::longhands::flex_direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mFlexDirection {
            structs::StyleFlexDirection::Row => Keyword::Row,
            structs::StyleFlexDirection::RowReverse => Keyword::RowReverse,
            structs::StyleFlexDirection::Column => Keyword::Column,
            structs::StyleFlexDirection::ColumnReverse => Keyword::ColumnReverse,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_flex_wrap(&mut self, v: longhands::flex_wrap::computed_value::T) {
        use crate::properties::longhands::flex_wrap::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Nowrap =>
                    structs::NS_STYLE_FLEX_WRAP_NOWRAP as u8,
                Keyword::Wrap =>
                    structs::NS_STYLE_FLEX_WRAP_WRAP as u8,
                Keyword::WrapReverse =>
                    structs::NS_STYLE_FLEX_WRAP_WRAP_REVERSE as u8,
        };
        self.gecko.mFlexWrap = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_wrap_from(&mut self, other: &Self) {
        self.gecko.mFlexWrap = other.gecko.mFlexWrap.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_wrap(&mut self, other: &Self) {
        self.copy_flex_wrap_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_flex_wrap(&self) -> longhands::flex_wrap::computed_value::T {
        use crate::properties::longhands::flex_wrap::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_FLEX_WRAP_NOWRAP : u8 =
            structs::NS_STYLE_FLEX_WRAP_NOWRAP as u8;
        const U8_NS_STYLE_FLEX_WRAP_WRAP : u8 =
            structs::NS_STYLE_FLEX_WRAP_WRAP as u8;
        const U8_NS_STYLE_FLEX_WRAP_WRAP_REVERSE : u8 =
            structs::NS_STYLE_FLEX_WRAP_WRAP_REVERSE as u8;

        match self.gecko.mFlexWrap as u8 {
            U8_NS_STYLE_FLEX_WRAP_NOWRAP => Keyword::Nowrap,
            U8_NS_STYLE_FLEX_WRAP_WRAP => Keyword::Wrap,
            U8_NS_STYLE_FLEX_WRAP_WRAP_REVERSE => Keyword::WrapReverse,
            _ => panic!("Found unexpected value in style struct for flex_wrap property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_flex_grow(&mut self, v: longhands::flex_grow::computed_value::T) {
        self.gecko.mFlexGrow = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_grow_from(&mut self, other: &Self) {
        self.gecko.mFlexGrow = other.gecko.mFlexGrow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_grow(&mut self, other: &Self) {
        self.copy_flex_grow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flex_grow(&self) -> longhands::flex_grow::computed_value::T {
        From::from(self.gecko.mFlexGrow.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_flex_shrink(&mut self, v: longhands::flex_shrink::computed_value::T) {
        self.gecko.mFlexShrink = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_shrink_from(&mut self, other: &Self) {
        self.gecko.mFlexShrink = other.gecko.mFlexShrink.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_shrink(&mut self, other: &Self) {
        self.copy_flex_shrink_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flex_shrink(&self) -> longhands::flex_shrink::computed_value::T {
        From::from(self.gecko.mFlexShrink.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_flex_basis(&mut self, v: longhands::flex_basis::computed_value::T) {
        self.gecko.mFlexBasis = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_basis_from(&mut self, other: &Self) {
        self.gecko.mFlexBasis = other.gecko.mFlexBasis.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_basis(&mut self, other: &Self) {
        self.copy_flex_basis_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flex_basis(&self) -> longhands::flex_basis::computed_value::T {
        From::from(self.gecko.mFlexBasis.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_width(&mut self, v: longhands::width::computed_value::T) {
        self.gecko.mWidth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_width_from(&mut self, other: &Self) {
        self.gecko.mWidth = other.gecko.mWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_width(&mut self, other: &Self) {
        self.copy_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_width(&self) -> longhands::width::computed_value::T {
        From::from(self.gecko.mWidth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_min_width(&mut self, v: longhands::min_width::computed_value::T) {
        self.gecko.mMinWidth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_min_width_from(&mut self, other: &Self) {
        self.gecko.mMinWidth = other.gecko.mMinWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_min_width(&mut self, other: &Self) {
        self.copy_min_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_min_width(&self) -> longhands::min_width::computed_value::T {
        From::from(self.gecko.mMinWidth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_max_width(&mut self, v: longhands::max_width::computed_value::T) {
        self.gecko.mMaxWidth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_max_width_from(&mut self, other: &Self) {
        self.gecko.mMaxWidth = other.gecko.mMaxWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_max_width(&mut self, other: &Self) {
        self.copy_max_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_max_width(&self) -> longhands::max_width::computed_value::T {
        From::from(self.gecko.mMaxWidth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_height(&mut self, v: longhands::height::computed_value::T) {
        self.gecko.mHeight = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_height_from(&mut self, other: &Self) {
        self.gecko.mHeight = other.gecko.mHeight.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_height(&mut self, other: &Self) {
        self.copy_height_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_height(&self) -> longhands::height::computed_value::T {
        From::from(self.gecko.mHeight.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_min_height(&mut self, v: longhands::min_height::computed_value::T) {
        self.gecko.mMinHeight = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_min_height_from(&mut self, other: &Self) {
        self.gecko.mMinHeight = other.gecko.mMinHeight.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_min_height(&mut self, other: &Self) {
        self.copy_min_height_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_min_height(&self) -> longhands::min_height::computed_value::T {
        From::from(self.gecko.mMinHeight.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_max_height(&mut self, v: longhands::max_height::computed_value::T) {
        self.gecko.mMaxHeight = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_max_height_from(&mut self, other: &Self) {
        self.gecko.mMaxHeight = other.gecko.mMaxHeight.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_max_height(&mut self, other: &Self) {
        self.copy_max_height_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_max_height(&self) -> longhands::max_height::computed_value::T {
        From::from(self.gecko.mMaxHeight.clone())
    }


    
    /// Set the appropriate physical property for block-size given a writing mode.
    pub fn set_block_size(&mut self,
                                      v: longhands::block_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_width(v)
            
        } else {
            
                self.set_height(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for block-size
    /// given a writing mode.
    pub fn copy_block_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_width_from(other)
            
        } else {
            
                self.copy_height_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for block-size
    /// given a writing mode.
    pub fn reset_block_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_block_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// block-size given a writing mode.
    pub fn clone_block_size(&self, wm: WritingMode)
        -> longhands::block_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_width()
        
        } else {
            
            self.clone_height()
        
        }

    }


    
    /// Set the appropriate physical property for min-block-size given a writing mode.
    pub fn set_min_block_size(&mut self,
                                      v: longhands::min_block_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_min_width(v)
            
        } else {
            
                self.set_min_height(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-block-size
    /// given a writing mode.
    pub fn copy_min_block_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_min_width_from(other)
            
        } else {
            
                self.copy_min_height_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-block-size
    /// given a writing mode.
    pub fn reset_min_block_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_min_block_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// min-block-size given a writing mode.
    pub fn clone_min_block_size(&self, wm: WritingMode)
        -> longhands::min_block_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_min_width()
        
        } else {
            
            self.clone_min_height()
        
        }

    }


    
    /// Set the appropriate physical property for max-block-size given a writing mode.
    pub fn set_max_block_size(&mut self,
                                      v: longhands::max_block_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_max_width(v)
            
        } else {
            
                self.set_max_height(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-block-size
    /// given a writing mode.
    pub fn copy_max_block_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_max_width_from(other)
            
        } else {
            
                self.copy_max_height_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-block-size
    /// given a writing mode.
    pub fn reset_max_block_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_max_block_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// max-block-size given a writing mode.
    pub fn clone_max_block_size(&self, wm: WritingMode)
        -> longhands::max_block_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_max_width()
        
        } else {
            
            self.clone_max_height()
        
        }

    }


    
    /// Set the appropriate physical property for inline-size given a writing mode.
    pub fn set_inline_size(&mut self,
                                      v: longhands::inline_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_height(v)
            
        } else {
            
                self.set_width(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for inline-size
    /// given a writing mode.
    pub fn copy_inline_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_height_from(other)
            
        } else {
            
                self.copy_width_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for inline-size
    /// given a writing mode.
    pub fn reset_inline_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inline_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inline-size given a writing mode.
    pub fn clone_inline_size(&self, wm: WritingMode)
        -> longhands::inline_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_height()
        
        } else {
            
            self.clone_width()
        
        }

    }


    
    /// Set the appropriate physical property for min-inline-size given a writing mode.
    pub fn set_min_inline_size(&mut self,
                                      v: longhands::min_inline_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_min_height(v)
            
        } else {
            
                self.set_min_width(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-inline-size
    /// given a writing mode.
    pub fn copy_min_inline_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_min_height_from(other)
            
        } else {
            
                self.copy_min_width_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-inline-size
    /// given a writing mode.
    pub fn reset_min_inline_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_min_inline_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// min-inline-size given a writing mode.
    pub fn clone_min_inline_size(&self, wm: WritingMode)
        -> longhands::min_inline_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_min_height()
        
        } else {
            
            self.clone_min_width()
        
        }

    }


    
    /// Set the appropriate physical property for max-inline-size given a writing mode.
    pub fn set_max_inline_size(&mut self,
                                      v: longhands::max_inline_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_max_height(v)
            
        } else {
            
                self.set_max_width(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-inline-size
    /// given a writing mode.
    pub fn copy_max_inline_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_max_height_from(other)
            
        } else {
            
                self.copy_max_width_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-inline-size
    /// given a writing mode.
    pub fn reset_max_inline_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_max_inline_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// max-inline-size given a writing mode.
    pub fn clone_max_inline_size(&self, wm: WritingMode)
        -> longhands::max_inline_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_max_height()
        
        } else {
            
            self.clone_max_width()
        
        }

    }



    #[allow(non_snake_case)]
    pub fn set_box_sizing(&mut self, v: longhands::box_sizing::computed_value::T) {
        use crate::properties::longhands::box_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::ContentBox =>
                    structs::StyleBoxSizing::Content ,
                Keyword::BorderBox =>
                    structs::StyleBoxSizing::Border ,
        };
        self.gecko.mBoxSizing = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_box_sizing_from(&mut self, other: &Self) {
        self.gecko.mBoxSizing = other.gecko.mBoxSizing.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_box_sizing(&mut self, other: &Self) {
        self.copy_box_sizing_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_box_sizing(&self) -> longhands::box_sizing::computed_value::T {
        use crate::properties::longhands::box_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBoxSizing {
            structs::StyleBoxSizing::Content => Keyword::ContentBox,
            structs::StyleBoxSizing::Border => Keyword::BorderBox,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_object_fit(&mut self, v: longhands::object_fit::computed_value::T) {
        use crate::properties::longhands::object_fit::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Fill =>
                    structs::NS_STYLE_OBJECT_FIT_FILL as u8,
                Keyword::Contain =>
                    structs::NS_STYLE_OBJECT_FIT_CONTAIN as u8,
                Keyword::Cover =>
                    structs::NS_STYLE_OBJECT_FIT_COVER as u8,
                Keyword::None =>
                    structs::NS_STYLE_OBJECT_FIT_NONE as u8,
                Keyword::ScaleDown =>
                    structs::NS_STYLE_OBJECT_FIT_SCALE_DOWN as u8,
        };
        self.gecko.mObjectFit = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_object_fit_from(&mut self, other: &Self) {
        self.gecko.mObjectFit = other.gecko.mObjectFit.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_object_fit(&mut self, other: &Self) {
        self.copy_object_fit_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_object_fit(&self) -> longhands::object_fit::computed_value::T {
        use crate::properties::longhands::object_fit::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_OBJECT_FIT_FILL : u8 =
            structs::NS_STYLE_OBJECT_FIT_FILL as u8;
        const U8_NS_STYLE_OBJECT_FIT_CONTAIN : u8 =
            structs::NS_STYLE_OBJECT_FIT_CONTAIN as u8;
        const U8_NS_STYLE_OBJECT_FIT_COVER : u8 =
            structs::NS_STYLE_OBJECT_FIT_COVER as u8;
        const U8_NS_STYLE_OBJECT_FIT_NONE : u8 =
            structs::NS_STYLE_OBJECT_FIT_NONE as u8;
        const U8_NS_STYLE_OBJECT_FIT_SCALE_DOWN : u8 =
            structs::NS_STYLE_OBJECT_FIT_SCALE_DOWN as u8;

        match self.gecko.mObjectFit as u8 {
            U8_NS_STYLE_OBJECT_FIT_FILL => Keyword::Fill,
            U8_NS_STYLE_OBJECT_FIT_CONTAIN => Keyword::Contain,
            U8_NS_STYLE_OBJECT_FIT_COVER => Keyword::Cover,
            U8_NS_STYLE_OBJECT_FIT_NONE => Keyword::None,
            U8_NS_STYLE_OBJECT_FIT_SCALE_DOWN => Keyword::ScaleDown,
            _ => panic!("Found unexpected value in style struct for object_fit property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_object_position(&mut self, v: longhands::object_position::computed_value::T) {
        self.gecko.mObjectPosition = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_object_position_from(&mut self, other: &Self) {
        self.gecko.mObjectPosition = other.gecko.mObjectPosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_object_position(&mut self, other: &Self) {
        self.copy_object_position_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_object_position(&self) -> longhands::object_position::computed_value::T {
        From::from(self.gecko.mObjectPosition.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_column_gap(&mut self, v: longhands::column_gap::computed_value::T) {
        self.gecko.mColumnGap = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_column_gap_from(&mut self, other: &Self) {
        self.gecko.mColumnGap = other.gecko.mColumnGap.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_gap(&mut self, other: &Self) {
        self.copy_column_gap_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_column_gap(&self) -> longhands::column_gap::computed_value::T {
        From::from(self.gecko.mColumnGap.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_row_gap(&mut self, v: longhands::row_gap::computed_value::T) {
        self.gecko.mRowGap = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_row_gap_from(&mut self, other: &Self) {
        self.gecko.mRowGap = other.gecko.mRowGap.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_row_gap(&mut self, other: &Self) {
        self.copy_row_gap_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_row_gap(&self) -> longhands::row_gap::computed_value::T {
        From::from(self.gecko.mRowGap.clone())
    }


}





impl GeckoOutline {
    /*
     * Manually-Implemented Methods.
     */
    

    pub fn set_outline_style(&mut self, v: longhands::outline_style::computed_value::T) {
        self.gecko.mOutlineStyle = v;
        // NB: This is needed to correctly handling the initial value of
        // outline-width when outline-style changes, see the
        // update_border_left comment for more details.
        self.gecko.mActualOutlineWidth = self.gecko.mOutlineWidth;
    }

    pub fn copy_outline_style_from(&mut self, other: &Self) {
        // FIXME(emilio): Why doesn't this need to reset mActualOutlineWidth?
        // Looks fishy.
        self.gecko.mOutlineStyle = other.gecko.mOutlineStyle;
    }

    pub fn reset_outline_style(&mut self, other: &Self) {
        self.copy_outline_style_from(other)
    }

    pub fn clone_outline_style(&self) -> longhands::outline_style::computed_value::T {
        self.gecko.mOutlineStyle.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_outline_width(&mut self, v: longhands::outline_width::computed_value::T) {
        let value = {
            let au_per_device_px = Au(self.gecko.mTwipsPerPixel);
            round_border_to_device_pixels(Au::from(v), au_per_device_px).0
        };

        self.gecko.mOutlineWidth = value;
        self.gecko.mActualOutlineWidth = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_outline_width_from(&mut self, other: &Self) {
        self.gecko.mOutlineWidth = other.gecko.mOutlineWidth;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.gecko.mActualOutlineWidth = other.gecko.mOutlineWidth;
    }

    #[allow(non_snake_case)]
    pub fn reset_outline_width(&mut self, other: &Self) {
        self.copy_outline_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_outline_width(&self) -> longhands::outline_width::computed_value::T {
        Au(self.gecko.mActualOutlineWidth).into()
    }


    
    #[allow(non_snake_case)]
    pub fn set__moz_outline_radius_topleft(&mut self, v: longhands::_moz_outline_radius_topleft::computed_value::T) {
        self.gecko.mOutlineRadius.top_left = v;
    }
    #[allow(non_snake_case)]
    pub fn copy__moz_outline_radius_topleft_from(&mut self, other: &Self) {
        self.gecko.mOutlineRadius.top_left =
            other.gecko.mOutlineRadius.top_left;
    }
    #[allow(non_snake_case)]
    pub fn reset__moz_outline_radius_topleft(&mut self, other: &Self) {
        self.copy__moz_outline_radius_topleft_from(other)
    }
    #[allow(non_snake_case)]
    pub fn clone__moz_outline_radius_topleft(&self) -> longhands::_moz_outline_radius_topleft::computed_value::T {
        self.gecko.mOutlineRadius.top_left
    }

    
    #[allow(non_snake_case)]
    pub fn set__moz_outline_radius_topright(&mut self, v: longhands::_moz_outline_radius_topright::computed_value::T) {
        self.gecko.mOutlineRadius.top_right = v;
    }
    #[allow(non_snake_case)]
    pub fn copy__moz_outline_radius_topright_from(&mut self, other: &Self) {
        self.gecko.mOutlineRadius.top_right =
            other.gecko.mOutlineRadius.top_right;
    }
    #[allow(non_snake_case)]
    pub fn reset__moz_outline_radius_topright(&mut self, other: &Self) {
        self.copy__moz_outline_radius_topright_from(other)
    }
    #[allow(non_snake_case)]
    pub fn clone__moz_outline_radius_topright(&self) -> longhands::_moz_outline_radius_topright::computed_value::T {
        self.gecko.mOutlineRadius.top_right
    }

    
    #[allow(non_snake_case)]
    pub fn set__moz_outline_radius_bottomright(&mut self, v: longhands::_moz_outline_radius_bottomright::computed_value::T) {
        self.gecko.mOutlineRadius.bottom_right = v;
    }
    #[allow(non_snake_case)]
    pub fn copy__moz_outline_radius_bottomright_from(&mut self, other: &Self) {
        self.gecko.mOutlineRadius.bottom_right =
            other.gecko.mOutlineRadius.bottom_right;
    }
    #[allow(non_snake_case)]
    pub fn reset__moz_outline_radius_bottomright(&mut self, other: &Self) {
        self.copy__moz_outline_radius_bottomright_from(other)
    }
    #[allow(non_snake_case)]
    pub fn clone__moz_outline_radius_bottomright(&self) -> longhands::_moz_outline_radius_bottomright::computed_value::T {
        self.gecko.mOutlineRadius.bottom_right
    }

    
    #[allow(non_snake_case)]
    pub fn set__moz_outline_radius_bottomleft(&mut self, v: longhands::_moz_outline_radius_bottomleft::computed_value::T) {
        self.gecko.mOutlineRadius.bottom_left = v;
    }
    #[allow(non_snake_case)]
    pub fn copy__moz_outline_radius_bottomleft_from(&mut self, other: &Self) {
        self.gecko.mOutlineRadius.bottom_left =
            other.gecko.mOutlineRadius.bottom_left;
    }
    #[allow(non_snake_case)]
    pub fn reset__moz_outline_radius_bottomleft(&mut self, other: &Self) {
        self.copy__moz_outline_radius_bottomleft_from(other)
    }
    #[allow(non_snake_case)]
    pub fn clone__moz_outline_radius_bottomleft(&self) -> longhands::_moz_outline_radius_bottomleft::computed_value::T {
        self.gecko.mOutlineRadius.bottom_left
    }


    pub fn outline_has_nonzero_width(&self) -> bool {
        self.gecko.mActualOutlineWidth != 0
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_outline_color(&mut self, v: longhands::outline_color::computed_value::T) {
        self.gecko.mOutlineColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_outline_color_from(&mut self, other: &Self) {
        self.gecko.mOutlineColor = other.gecko.mOutlineColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_outline_color(&mut self, other: &Self) {
        self.copy_outline_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_outline_color(&self) -> longhands::outline_color::computed_value::T {
        From::from(self.gecko.mOutlineColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_outline_offset(&mut self, v: longhands::outline_offset::computed_value::T) {
        self.gecko.mOutlineOffset = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_outline_offset_from(&mut self, other: &Self) {
        self.gecko.mOutlineOffset = other.gecko.mOutlineOffset.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_outline_offset(&mut self, other: &Self) {
        self.copy_outline_offset_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_outline_offset(&self) -> longhands::outline_offset::computed_value::T {
        From::from(self.gecko.mOutlineOffset.clone())
    }


}





impl GeckoFont {
    /*
     * Manually-Implemented Methods.
     */
    

    // Negative numbers are invalid at parse time, but <integer> is still an
    // i32.
    
    

    pub fn set_font_feature_settings(&mut self, v: longhands::font_feature_settings::computed_value::T) {
        let iter = v.0.iter().map(|other| structs::gfxFontFeature {
            mTag: other.tag.0,
            mValue: other.value as u32,
        });
        self.gecko.mFont.fontFeatureSettings.assign_from_iter_pod(iter);
    }

    pub fn copy_font_feature_settings_from(&mut self, other: &Self) {
        let iter = other.gecko.mFont.fontFeatureSettings.iter().map(|s| *s);
        self.gecko.mFont.fontFeatureSettings.assign_from_iter_pod(iter);
    }

    pub fn reset_font_feature_settings(&mut self, other: &Self) {
        self.copy_font_feature_settings_from(other)
    }

    pub fn clone_font_feature_settings(&self) -> longhands::font_feature_settings::computed_value::T {
        use crate::values::generics::font::{FontSettings, FontTag, FeatureTagValue};

        FontSettings(
            self.gecko.mFont.fontFeatureSettings.iter().map(|gecko_font_setting| {
                FeatureTagValue {
                    tag: FontTag(gecko_font_setting.mTag),
                    value: gecko_font_setting.mValue as i32,
                }
            }).collect::<Vec<_>>().into_boxed_slice()
        )
    }

    
    

    pub fn set_font_variation_settings(&mut self, v: longhands::font_variation_settings::computed_value::T) {
        let iter = v.0.iter().map(|other| structs::gfxFontVariation {
            mTag: other.tag.0,
            mValue: other.value as f32,
        });
        self.gecko.mFont.fontVariationSettings.assign_from_iter_pod(iter);
    }

    pub fn copy_font_variation_settings_from(&mut self, other: &Self) {
        let iter = other.gecko.mFont.fontVariationSettings.iter().map(|s| *s);
        self.gecko.mFont.fontVariationSettings.assign_from_iter_pod(iter);
    }

    pub fn reset_font_variation_settings(&mut self, other: &Self) {
        self.copy_font_variation_settings_from(other)
    }

    pub fn clone_font_variation_settings(&self) -> longhands::font_variation_settings::computed_value::T {
        use crate::values::generics::font::{FontSettings, FontTag, VariationValue};

        FontSettings(
            self.gecko.mFont.fontVariationSettings.iter().map(|gecko_font_setting| {
                VariationValue {
                    tag: FontTag(gecko_font_setting.mTag),
                    value: gecko_font_setting.mValue as f32,
                }
            }).collect::<Vec<_>>().into_boxed_slice()
        )
    }


    pub fn set_font_family(&mut self, v: longhands::font_family::computed_value::T) {
        use crate::values::computed::font::GenericFontFamily;

        let is_system_font = v.is_system_font;
        self.gecko.mFont.systemFont = is_system_font;
        self.gecko.mGenericID = if is_system_font {
            GenericFontFamily::None
        } else {
            v.families.single_generic().unwrap_or(GenericFontFamily::None)
        };
        self.gecko.mFont.fontlist.mFontlist.mBasePtr.set_move(
            v.families.shared_font_list().clone()
        );
        // Fixed-up if needed in Cascade::fixup_font_stuff.
        self.gecko.mFont.fontlist.mDefaultFontType = GenericFontFamily::None;
    }

    pub fn copy_font_family_from(&mut self, other: &Self) {
        unsafe { Gecko_CopyFontFamilyFrom(&mut self.gecko.mFont, &other.gecko.mFont); }
        self.gecko.mGenericID = other.gecko.mGenericID;
        self.gecko.mFont.systemFont = other.gecko.mFont.systemFont;
    }

    pub fn reset_font_family(&mut self, other: &Self) {
        self.copy_font_family_from(other)
    }

    pub fn clone_font_family(&self) -> longhands::font_family::computed_value::T {
        use crate::values::computed::font::{FontFamily, SingleFontFamily, FontFamilyList};

        let fontlist = &self.gecko.mFont.fontlist;
        let shared_fontlist = unsafe { fontlist.mFontlist.mBasePtr.to_safe() };

        let families = if shared_fontlist.mNames.is_empty() {
            let default = SingleFontFamily::Generic(fontlist.mDefaultFontType);
            FontFamilyList::new(Box::new([default]))
        } else {
            FontFamilyList::SharedFontList(shared_fontlist)
        };

        FontFamily {
            families,
            is_system_font: self.gecko.mFont.systemFont,
        }
    }

    pub fn unzoom_fonts(&mut self, device: &Device) {
        self.gecko.mSize = device.unzoom_text(Au(self.gecko.mSize)).0;
        self.gecko.mScriptUnconstrainedSize = device.unzoom_text(Au(self.gecko.mScriptUnconstrainedSize)).0;
        self.gecko.mFont.size = device.unzoom_text(Au(self.gecko.mFont.size)).0;
    }

    pub fn copy_font_size_from(&mut self, other: &Self) {
        self.gecko.mScriptUnconstrainedSize = other.gecko.mScriptUnconstrainedSize;

        self.gecko.mSize = other.gecko.mScriptUnconstrainedSize;
        self.gecko.mFont.size = other.gecko.mSize;
        self.gecko.mFontSizeKeyword = other.gecko.mFontSizeKeyword;

        // TODO(emilio): Should we really copy over these two?
        self.gecko.mFontSizeFactor = other.gecko.mFontSizeFactor;
        self.gecko.mFontSizeOffset = other.gecko.mFontSizeOffset;
    }

    pub fn reset_font_size(&mut self, other: &Self) {
        self.copy_font_size_from(other)
    }

    pub fn set_font_size(&mut self, v: FontSize) {
        use crate::values::generics::font::KeywordSize;

        let size = v.size();
        self.gecko.mScriptUnconstrainedSize = size.0;

        // These two may be changed from Cascade::fixup_font_stuff.
        self.gecko.mSize = size.0;
        self.gecko.mFont.size = size.0;

        if let Some(info) = v.keyword_info {
            self.gecko.mFontSizeKeyword = match info.kw {
                KeywordSize::XXSmall => structs::NS_STYLE_FONT_SIZE_XXSMALL,
                KeywordSize::XSmall => structs::NS_STYLE_FONT_SIZE_XSMALL,
                KeywordSize::Small => structs::NS_STYLE_FONT_SIZE_SMALL,
                KeywordSize::Medium => structs::NS_STYLE_FONT_SIZE_MEDIUM,
                KeywordSize::Large => structs::NS_STYLE_FONT_SIZE_LARGE,
                KeywordSize::XLarge => structs::NS_STYLE_FONT_SIZE_XLARGE,
                KeywordSize::XXLarge => structs::NS_STYLE_FONT_SIZE_XXLARGE,
                KeywordSize::XXXLarge => structs::NS_STYLE_FONT_SIZE_XXXLARGE,
            } as u8;
            self.gecko.mFontSizeFactor = info.factor;
            self.gecko.mFontSizeOffset = info.offset.0.to_i32_au();
        } else {
            self.gecko.mFontSizeKeyword = structs::NS_STYLE_FONT_SIZE_NO_KEYWORD as u8;
            self.gecko.mFontSizeFactor = 1.;
            self.gecko.mFontSizeOffset = 0;
        }
    }

    pub fn clone_font_size(&self) -> FontSize {
        use crate::values::generics::font::{KeywordInfo, KeywordSize};
        let size = Au(self.gecko.mSize).into();
        let kw = match self.gecko.mFontSizeKeyword as u32 {
            structs::NS_STYLE_FONT_SIZE_XXSMALL => KeywordSize::XXSmall,
            structs::NS_STYLE_FONT_SIZE_XSMALL => KeywordSize::XSmall,
            structs::NS_STYLE_FONT_SIZE_SMALL => KeywordSize::Small,
            structs::NS_STYLE_FONT_SIZE_MEDIUM => KeywordSize::Medium,
            structs::NS_STYLE_FONT_SIZE_LARGE => KeywordSize::Large,
            structs::NS_STYLE_FONT_SIZE_XLARGE => KeywordSize::XLarge,
            structs::NS_STYLE_FONT_SIZE_XXLARGE => KeywordSize::XXLarge,
            structs::NS_STYLE_FONT_SIZE_XXXLARGE => KeywordSize::XXXLarge,
            structs::NS_STYLE_FONT_SIZE_NO_KEYWORD => {
                return FontSize {
                    size,
                    keyword_info: None,
                }
            }
            _ => unreachable!("mFontSizeKeyword should be an absolute keyword or NO_KEYWORD")
        };
        FontSize {
            size,
            keyword_info: Some(KeywordInfo {
                kw,
                factor: self.gecko.mFontSizeFactor,
                offset: Au(self.gecko.mFontSizeOffset).into()
            })
        }
    }

    pub fn set_font_weight(&mut self, v: longhands::font_weight::computed_value::T) {
        unsafe { bindings::Gecko_FontWeight_SetFloat(&mut self.gecko.mFont.weight, v.0) };
    }
    
    #[allow(non_snake_case)]
    pub fn copy_font_weight_from(&mut self, other: &Self) {
        self.gecko.mFont.weight = other.gecko.mFont.weight.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_weight(&mut self, other: &Self) {
        self.copy_font_weight_from(other)
    }


    pub fn clone_font_weight(&self) -> longhands::font_weight::computed_value::T {
        let weight: f32 = unsafe {
            bindings::Gecko_FontWeight_ToFloat(self.gecko.mFont.weight)
        };
        longhands::font_weight::computed_value::T(weight)
    }

    pub fn set_font_stretch(&mut self, v: longhands::font_stretch::computed_value::T) {
        unsafe {
            bindings::Gecko_FontStretch_SetFloat(
                &mut self.gecko.mFont.stretch,
                v.value(),
            )
        };
    }
    
    #[allow(non_snake_case)]
    pub fn copy_font_stretch_from(&mut self, other: &Self) {
        self.gecko.mFont.stretch = other.gecko.mFont.stretch.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_stretch(&mut self, other: &Self) {
        self.copy_font_stretch_from(other)
    }

    pub fn clone_font_stretch(&self) -> longhands::font_stretch::computed_value::T {
        use crate::values::computed::font::FontStretch;
        use crate::values::computed::Percentage;
        use crate::values::generics::NonNegative;

        let stretch =
            unsafe { bindings::Gecko_FontStretch_ToFloat(self.gecko.mFont.stretch) };
        debug_assert!(stretch >= 0.);

        FontStretch(NonNegative(Percentage(stretch)))
    }

    pub fn set_font_style(&mut self, v: longhands::font_style::computed_value::T) {
        use crate::values::generics::font::FontStyle;
        let s = &mut self.gecko.mFont.style;
        unsafe {
            match v {
                FontStyle::Normal => bindings::Gecko_FontSlantStyle_SetNormal(s),
                FontStyle::Italic => bindings::Gecko_FontSlantStyle_SetItalic(s),
                FontStyle::Oblique(ref angle) => {
                    bindings::Gecko_FontSlantStyle_SetOblique(s, angle.0.degrees())
                }
            }
        }
    }
    
    #[allow(non_snake_case)]
    pub fn copy_font_style_from(&mut self, other: &Self) {
        self.gecko.mFont.style = other.gecko.mFont.style.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_style(&mut self, other: &Self) {
        self.copy_font_style_from(other)
    }

    pub fn clone_font_style(&self) -> longhands::font_style::computed_value::T {
        use crate::values::computed::font::FontStyle;
        FontStyle::from_gecko(self.gecko.mFont.style)
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_font_synthesis(&mut self, v: longhands::font_synthesis::computed_value::T) {
        self.gecko.mFont.synthesis = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_synthesis_from(&mut self, other: &Self) {
        self.gecko.mFont.synthesis = other.gecko.mFont.synthesis.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_synthesis(&mut self, other: &Self) {
        self.copy_font_synthesis_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_synthesis(&self) -> longhands::font_synthesis::computed_value::T {
        From::from(self.gecko.mFont.synthesis)
    }


    pub fn set_font_size_adjust(&mut self, v: longhands::font_size_adjust::computed_value::T) {
        use crate::properties::longhands::font_size_adjust::computed_value::T;
        match v {
            T::None => self.gecko.mFont.sizeAdjust = -1.0 as f32,
            T::Number(n) => self.gecko.mFont.sizeAdjust = n,
        }
    }

    pub fn copy_font_size_adjust_from(&mut self, other: &Self) {
        self.gecko.mFont.sizeAdjust = other.gecko.mFont.sizeAdjust;
    }

    pub fn reset_font_size_adjust(&mut self, other: &Self) {
        self.copy_font_size_adjust_from(other)
    }

    pub fn clone_font_size_adjust(&self) -> longhands::font_size_adjust::computed_value::T {
        use crate::properties::longhands::font_size_adjust::computed_value::T;
        T::from_gecko_adjust(self.gecko.mFont.sizeAdjust)
    }

    #[allow(non_snake_case)]
    pub fn set__x_lang(&mut self, v: longhands::_x_lang::computed_value::T) {
        let ptr = v.0.as_ptr();
        forget(v);
        unsafe {
            Gecko_nsStyleFont_SetLang(&mut *self.gecko, ptr);
        }
    }

    #[allow(non_snake_case)]
    pub fn copy__x_lang_from(&mut self, other: &Self) {
        unsafe {
            Gecko_nsStyleFont_CopyLangFrom(&mut *self.gecko, &*other.gecko);
        }
    }

    #[allow(non_snake_case)]
    pub fn reset__x_lang(&mut self, other: &Self) {
        self.copy__x_lang_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__x_lang(&self) -> longhands::_x_lang::computed_value::T {
        longhands::_x_lang::computed_value::T(unsafe {
            Atom::from_raw(self.gecko.mLanguage.mRawPtr)
        })
    }

    #[allow(non_snake_case)]
    pub fn set__x_text_zoom(&mut self, v: longhands::_x_text_zoom::computed_value::T) {
        self.gecko.mAllowZoom = v.0;
    }

    #[allow(non_snake_case)]
    pub fn copy__x_text_zoom_from(&mut self, other: &Self) {
        self.gecko.mAllowZoom = other.gecko.mAllowZoom;
    }

    #[allow(non_snake_case)]
    pub fn reset__x_text_zoom(&mut self, other: &Self) {
        self.copy__x_text_zoom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__x_text_zoom(&self) -> longhands::_x_text_zoom::computed_value::T {
        longhands::_x_text_zoom::computed_value::T(self.gecko.mAllowZoom)
    }

    

    #[allow(non_snake_case)]
    pub fn set__moz_script_level(&mut self, v: longhands::_moz_script_level::computed_value::T) {
        self.gecko.mScriptLevel = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_script_level_from(&mut self, other: &Self) {
        self.gecko.mScriptLevel = other.gecko.mScriptLevel.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_script_level(&mut self, other: &Self) {
        self.copy__moz_script_level_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_script_level(&self) -> longhands::_moz_script_level::computed_value::T {
        From::from(self.gecko.mScriptLevel.clone())
    }


    
    

    #[allow(non_snake_case)]
    pub fn set_font_language_override(&mut self, v: longhands::font_language_override::computed_value::T) {
        self.gecko.mFont.languageOverride = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_language_override_from(&mut self, other: &Self) {
        self.gecko.mFont.languageOverride = other.gecko.mFont.languageOverride.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_language_override(&mut self, other: &Self) {
        self.copy_font_language_override_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_language_override(&self) -> longhands::font_language_override::computed_value::T {
        From::from(self.gecko.mFont.languageOverride)
    }


    pub fn set_font_variant_alternates(
        &mut self,
        v: values::computed::font::FontVariantAlternates,
    ) {
        use crate::gecko_bindings::bindings::{Gecko_ClearAlternateValues, Gecko_AppendAlternateValues};
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_NORMAL;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_SWASH;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_STYLISTIC;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_ORNAMENTS;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_ANNOTATION;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_STYLESET;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_CHARACTER_VARIANT;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_HISTORICAL;
        use crate::values::specified::font::VariantAlternates;

        unsafe {
            Gecko_ClearAlternateValues(&mut self.gecko.mFont, v.len());
        }

        if v.0.is_empty() {
            self.gecko.mFont.variantAlternates = NS_FONT_VARIANT_ALTERNATES_NORMAL as u16;
            return;
        }

        for val in v.0.iter() {
            match *val {
                    VariantAlternates::Swash(ref ident) => {
                        self.gecko.mFont.variantAlternates |= NS_FONT_VARIANT_ALTERNATES_SWASH as u16;
                        unsafe {
                            Gecko_AppendAlternateValues(&mut self.gecko.mFont,
                                                        NS_FONT_VARIANT_ALTERNATES_SWASH,
                                                        ident.0.as_ptr());
                        }
                    },
                    VariantAlternates::Stylistic(ref ident) => {
                        self.gecko.mFont.variantAlternates |= NS_FONT_VARIANT_ALTERNATES_STYLISTIC as u16;
                        unsafe {
                            Gecko_AppendAlternateValues(&mut self.gecko.mFont,
                                                        NS_FONT_VARIANT_ALTERNATES_STYLISTIC,
                                                        ident.0.as_ptr());
                        }
                    },
                    VariantAlternates::Ornaments(ref ident) => {
                        self.gecko.mFont.variantAlternates |= NS_FONT_VARIANT_ALTERNATES_ORNAMENTS as u16;
                        unsafe {
                            Gecko_AppendAlternateValues(&mut self.gecko.mFont,
                                                        NS_FONT_VARIANT_ALTERNATES_ORNAMENTS,
                                                        ident.0.as_ptr());
                        }
                    },
                    VariantAlternates::Annotation(ref ident) => {
                        self.gecko.mFont.variantAlternates |= NS_FONT_VARIANT_ALTERNATES_ANNOTATION as u16;
                        unsafe {
                            Gecko_AppendAlternateValues(&mut self.gecko.mFont,
                                                        NS_FONT_VARIANT_ALTERNATES_ANNOTATION,
                                                        ident.0.as_ptr());
                        }
                    },
                    VariantAlternates::Styleset(ref slice) => {
                        self.gecko.mFont.variantAlternates |= NS_FONT_VARIANT_ALTERNATES_STYLESET as u16;
                        for ident in slice.iter() {
                            unsafe {
                                Gecko_AppendAlternateValues(&mut self.gecko.mFont,
                                                            NS_FONT_VARIANT_ALTERNATES_STYLESET,
                                                            ident.0.as_ptr());
                            }
                        }
                    },
                    VariantAlternates::CharacterVariant(ref slice) => {
                        self.gecko.mFont.variantAlternates |= NS_FONT_VARIANT_ALTERNATES_CHARACTER_VARIANT as u16;
                        for ident in slice.iter() {
                            unsafe {
                                Gecko_AppendAlternateValues(&mut self.gecko.mFont,
                                                            NS_FONT_VARIANT_ALTERNATES_CHARACTER_VARIANT,
                                                            ident.0.as_ptr());
                            }
                        }
                    },
                VariantAlternates::HistoricalForms => {
                    self.gecko.mFont.variantAlternates |= NS_FONT_VARIANT_ALTERNATES_HISTORICAL as u16;
                }
            }
        }
    }

    #[allow(non_snake_case)]
    pub fn copy_font_variant_alternates_from(&mut self, other: &Self) {
        use crate::gecko_bindings::bindings::Gecko_CopyAlternateValuesFrom;

        self.gecko.mFont.variantAlternates = other.gecko.mFont.variantAlternates;
        unsafe {
            Gecko_CopyAlternateValuesFrom(&mut self.gecko.mFont, &other.gecko.mFont);
        }
    }

    pub fn reset_font_variant_alternates(&mut self, other: &Self) {
        self.copy_font_variant_alternates_from(other)
    }

    pub fn clone_font_variant_alternates(&self) -> values::computed::font::FontVariantAlternates {
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_NORMAL;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_SWASH;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_STYLISTIC;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_ORNAMENTS;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_ANNOTATION;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_STYLESET;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_CHARACTER_VARIANT;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_HISTORICAL;
        use crate::values::specified::font::VariantAlternates;
        use crate::values::specified::font::VariantAlternatesList;
        use crate::values::CustomIdent;

        if self.gecko.mFont.variantAlternates == NS_FONT_VARIANT_ALTERNATES_NORMAL as u16 {
            return VariantAlternatesList(vec![].into_boxed_slice());
        }

        let mut alternates = Vec::with_capacity(self.gecko.mFont.alternateValues.len());
        if self.gecko.mFont.variantAlternates & (NS_FONT_VARIANT_ALTERNATES_HISTORICAL as u16) != 0 {
            alternates.push(VariantAlternates::HistoricalForms);
        }

        
            let mut styleset_list = Vec::new();
            let mut character_variant_list = Vec::new();

        for gecko_alternate_value in self.gecko.mFont.alternateValues.iter() {
            let ident = Atom::from(gecko_alternate_value.value.to_string());
            match gecko_alternate_value.alternate {
                    NS_FONT_VARIANT_ALTERNATES_SWASH => {
                        alternates.push(VariantAlternates::Swash(CustomIdent(ident)));
                    },
                    NS_FONT_VARIANT_ALTERNATES_STYLISTIC => {
                        alternates.push(VariantAlternates::Stylistic(CustomIdent(ident)));
                    },
                    NS_FONT_VARIANT_ALTERNATES_ORNAMENTS => {
                        alternates.push(VariantAlternates::Ornaments(CustomIdent(ident)));
                    },
                    NS_FONT_VARIANT_ALTERNATES_ANNOTATION => {
                        alternates.push(VariantAlternates::Annotation(CustomIdent(ident)));
                    },
                    NS_FONT_VARIANT_ALTERNATES_STYLESET => {
                        styleset_list.push(CustomIdent(ident));
                    },
                    NS_FONT_VARIANT_ALTERNATES_CHARACTER_VARIANT => {
                        character_variant_list.push(CustomIdent(ident));
                    },
                _ => {
                    panic!("Found unexpected value for font-variant-alternates");
                }
            }
        }

            if !styleset_list.is_empty() {
                alternates.push(VariantAlternates::Styleset(styleset_list.into_boxed_slice()));
            }
            if !character_variant_list.is_empty() {
                alternates.push(VariantAlternates::CharacterVariant(character_variant_list.into_boxed_slice()));
            }

        VariantAlternatesList(alternates.into_boxed_slice())
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_font_variant_ligatures(&mut self, v: longhands::font_variant_ligatures::computed_value::T) {
        self.gecko.mFont.variantLigatures = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_variant_ligatures_from(&mut self, other: &Self) {
        self.gecko.mFont.variantLigatures = other.gecko.mFont.variantLigatures.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_ligatures(&mut self, other: &Self) {
        self.copy_font_variant_ligatures_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_ligatures(&self) -> longhands::font_variant_ligatures::computed_value::T {
        From::from(self.gecko.mFont.variantLigatures)
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_font_variant_east_asian(&mut self, v: longhands::font_variant_east_asian::computed_value::T) {
        self.gecko.mFont.variantEastAsian = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_variant_east_asian_from(&mut self, other: &Self) {
        self.gecko.mFont.variantEastAsian = other.gecko.mFont.variantEastAsian.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_east_asian(&mut self, other: &Self) {
        self.copy_font_variant_east_asian_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_east_asian(&self) -> longhands::font_variant_east_asian::computed_value::T {
        From::from(self.gecko.mFont.variantEastAsian)
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_font_variant_numeric(&mut self, v: longhands::font_variant_numeric::computed_value::T) {
        self.gecko.mFont.variantNumeric = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_variant_numeric_from(&mut self, other: &Self) {
        self.gecko.mFont.variantNumeric = other.gecko.mFont.variantNumeric.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_numeric(&mut self, other: &Self) {
        self.copy_font_variant_numeric_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_numeric(&self) -> longhands::font_variant_numeric::computed_value::T {
        From::from(self.gecko.mFont.variantNumeric)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_min_font_size_ratio(
        &self,
    ) -> longhands::_moz_min_font_size_ratio::computed_value::T {
        Percentage(self.gecko.mMinFontSizeRatio as f32 / 100.)
    }

    #[allow(non_snake_case)]
    pub fn set__moz_min_font_size_ratio(&mut self, v: longhands::_moz_min_font_size_ratio::computed_value::T) {
        let scaled = v.0 * 100.;
        let percentage = if scaled > 255. {
            255.
        } else if scaled < 0. {
            0.
        } else {
            scaled
        };

        self.gecko.mMinFontSizeRatio = percentage as u8;
    }

    
    #[allow(non_snake_case)]
    pub fn copy__moz_min_font_size_ratio_from(&mut self, other: &Self) {
        self.gecko.mMinFontSizeRatio = other.gecko.mMinFontSizeRatio.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_min_font_size_ratio(&mut self, other: &Self) {
        self.copy__moz_min_font_size_ratio_from(other)
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_font_variant_caps(&mut self, v: longhands::font_variant_caps::computed_value::T) {
        use crate::properties::longhands::font_variant_caps::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::NS_FONT_VARIANT_CAPS_NORMAL as u8,
                Keyword::SmallCaps =>
                    structs::NS_FONT_VARIANT_CAPS_SMALLCAPS as u8,
                Keyword::AllSmallCaps =>
                    structs::NS_FONT_VARIANT_CAPS_ALLSMALL as u8,
                Keyword::PetiteCaps =>
                    structs::NS_FONT_VARIANT_CAPS_PETITECAPS as u8,
                Keyword::AllPetiteCaps =>
                    structs::NS_FONT_VARIANT_CAPS_ALLPETITE as u8,
                Keyword::Unicase =>
                    structs::NS_FONT_VARIANT_CAPS_UNICASE as u8,
                Keyword::TitlingCaps =>
                    structs::NS_FONT_VARIANT_CAPS_TITLING as u8,
        };
        self.gecko.mFont.variantCaps = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_font_variant_caps_from(&mut self, other: &Self) {
        self.gecko.mFont.variantCaps = other.gecko.mFont.variantCaps.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_caps(&mut self, other: &Self) {
        self.copy_font_variant_caps_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_font_variant_caps(&self) -> longhands::font_variant_caps::computed_value::T {
        use crate::properties::longhands::font_variant_caps::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_VARIANT_CAPS_NORMAL : u8 =
            structs::NS_FONT_VARIANT_CAPS_NORMAL as u8;
        const U8_NS_FONT_VARIANT_CAPS_SMALLCAPS : u8 =
            structs::NS_FONT_VARIANT_CAPS_SMALLCAPS as u8;
        const U8_NS_FONT_VARIANT_CAPS_ALLSMALL : u8 =
            structs::NS_FONT_VARIANT_CAPS_ALLSMALL as u8;
        const U8_NS_FONT_VARIANT_CAPS_PETITECAPS : u8 =
            structs::NS_FONT_VARIANT_CAPS_PETITECAPS as u8;
        const U8_NS_FONT_VARIANT_CAPS_ALLPETITE : u8 =
            structs::NS_FONT_VARIANT_CAPS_ALLPETITE as u8;
        const U8_NS_FONT_VARIANT_CAPS_UNICASE : u8 =
            structs::NS_FONT_VARIANT_CAPS_UNICASE as u8;
        const U8_NS_FONT_VARIANT_CAPS_TITLING : u8 =
            structs::NS_FONT_VARIANT_CAPS_TITLING as u8;

        match self.gecko.mFont.variantCaps as u8 {
            U8_NS_FONT_VARIANT_CAPS_NORMAL => Keyword::Normal,
            U8_NS_FONT_VARIANT_CAPS_SMALLCAPS => Keyword::SmallCaps,
            U8_NS_FONT_VARIANT_CAPS_ALLSMALL => Keyword::AllSmallCaps,
            U8_NS_FONT_VARIANT_CAPS_PETITECAPS => Keyword::PetiteCaps,
            U8_NS_FONT_VARIANT_CAPS_ALLPETITE => Keyword::AllPetiteCaps,
            U8_NS_FONT_VARIANT_CAPS_UNICASE => Keyword::Unicase,
            U8_NS_FONT_VARIANT_CAPS_TITLING => Keyword::TitlingCaps,
            _ => panic!("Found unexpected value in style struct for font_variant_caps property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_font_kerning(&mut self, v: longhands::font_kerning::computed_value::T) {
        use crate::properties::longhands::font_kerning::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_FONT_KERNING_AUTO as u8,
                Keyword::None =>
                    structs::NS_FONT_KERNING_NONE as u8,
                Keyword::Normal =>
                    structs::NS_FONT_KERNING_NORMAL as u8,
        };
        self.gecko.mFont.kerning = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_font_kerning_from(&mut self, other: &Self) {
        self.gecko.mFont.kerning = other.gecko.mFont.kerning.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_kerning(&mut self, other: &Self) {
        self.copy_font_kerning_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_font_kerning(&self) -> longhands::font_kerning::computed_value::T {
        use crate::properties::longhands::font_kerning::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_KERNING_AUTO : u8 =
            structs::NS_FONT_KERNING_AUTO as u8;
        const U8_NS_FONT_KERNING_NONE : u8 =
            structs::NS_FONT_KERNING_NONE as u8;
        const U8_NS_FONT_KERNING_NORMAL : u8 =
            structs::NS_FONT_KERNING_NORMAL as u8;

        match self.gecko.mFont.kerning as u8 {
            U8_NS_FONT_KERNING_AUTO => Keyword::Auto,
            U8_NS_FONT_KERNING_NONE => Keyword::None,
            U8_NS_FONT_KERNING_NORMAL => Keyword::Normal,
            _ => panic!("Found unexpected value in style struct for font_kerning property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_font_variant_position(&mut self, v: longhands::font_variant_position::computed_value::T) {
        use crate::properties::longhands::font_variant_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::NS_FONT_VARIANT_POSITION_NORMAL as u8,
                Keyword::Sub =>
                    structs::NS_FONT_VARIANT_POSITION_SUB as u8,
                Keyword::Super =>
                    structs::NS_FONT_VARIANT_POSITION_SUPER as u8,
        };
        self.gecko.mFont.variantPosition = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_font_variant_position_from(&mut self, other: &Self) {
        self.gecko.mFont.variantPosition = other.gecko.mFont.variantPosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_position(&mut self, other: &Self) {
        self.copy_font_variant_position_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_font_variant_position(&self) -> longhands::font_variant_position::computed_value::T {
        use crate::properties::longhands::font_variant_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_VARIANT_POSITION_NORMAL : u8 =
            structs::NS_FONT_VARIANT_POSITION_NORMAL as u8;
        const U8_NS_FONT_VARIANT_POSITION_SUB : u8 =
            structs::NS_FONT_VARIANT_POSITION_SUB as u8;
        const U8_NS_FONT_VARIANT_POSITION_SUPER : u8 =
            structs::NS_FONT_VARIANT_POSITION_SUPER as u8;

        match self.gecko.mFont.variantPosition as u8 {
            U8_NS_FONT_VARIANT_POSITION_NORMAL => Keyword::Normal,
            U8_NS_FONT_VARIANT_POSITION_SUB => Keyword::Sub,
            U8_NS_FONT_VARIANT_POSITION_SUPER => Keyword::Super,
            _ => panic!("Found unexpected value in style struct for font_variant_position property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_font_optical_sizing(&mut self, v: longhands::font_optical_sizing::computed_value::T) {
        use crate::properties::longhands::font_optical_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_FONT_OPTICAL_SIZING_AUTO as u8,
                Keyword::None =>
                    structs::NS_FONT_OPTICAL_SIZING_NONE as u8,
        };
        self.gecko.mFont.opticalSizing = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_font_optical_sizing_from(&mut self, other: &Self) {
        self.gecko.mFont.opticalSizing = other.gecko.mFont.opticalSizing.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_optical_sizing(&mut self, other: &Self) {
        self.copy_font_optical_sizing_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_font_optical_sizing(&self) -> longhands::font_optical_sizing::computed_value::T {
        use crate::properties::longhands::font_optical_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_OPTICAL_SIZING_AUTO : u8 =
            structs::NS_FONT_OPTICAL_SIZING_AUTO as u8;
        const U8_NS_FONT_OPTICAL_SIZING_NONE : u8 =
            structs::NS_FONT_OPTICAL_SIZING_NONE as u8;

        match self.gecko.mFont.opticalSizing as u8 {
            U8_NS_FONT_OPTICAL_SIZING_AUTO => Keyword::Auto,
            U8_NS_FONT_OPTICAL_SIZING_NONE => Keyword::None,
            _ => panic!("Found unexpected value in style struct for font_optical_sizing property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_script_size_multiplier(&mut self, v: longhands::_moz_script_size_multiplier::computed_value::T) {
        self.gecko.mScriptSizeMultiplier = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_script_size_multiplier_from(&mut self, other: &Self) {
        self.gecko.mScriptSizeMultiplier = other.gecko.mScriptSizeMultiplier.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_script_size_multiplier(&mut self, other: &Self) {
        self.copy__moz_script_size_multiplier_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_script_size_multiplier(&self) -> longhands::_moz_script_size_multiplier::computed_value::T {
        From::from(self.gecko.mScriptSizeMultiplier.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_math_display(&mut self, v: longhands::_moz_math_display::computed_value::T) {
        use crate::properties::longhands::_moz_math_display::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Inline =>
                    structs::NS_MATHML_DISPLAYSTYLE_INLINE as u8,
                Keyword::Block =>
                    structs::NS_MATHML_DISPLAYSTYLE_BLOCK as u8,
        };
        self.gecko.mMathDisplay = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_math_display_from(&mut self, other: &Self) {
        self.gecko.mMathDisplay = other.gecko.mMathDisplay.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_math_display(&mut self, other: &Self) {
        self.copy__moz_math_display_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_math_display(&self) -> longhands::_moz_math_display::computed_value::T {
        use crate::properties::longhands::_moz_math_display::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_MATHML_DISPLAYSTYLE_INLINE : u8 =
            structs::NS_MATHML_DISPLAYSTYLE_INLINE as u8;
        const U8_NS_MATHML_DISPLAYSTYLE_BLOCK : u8 =
            structs::NS_MATHML_DISPLAYSTYLE_BLOCK as u8;

        match self.gecko.mMathDisplay as u8 {
            U8_NS_MATHML_DISPLAYSTYLE_INLINE => Keyword::Inline,
            U8_NS_MATHML_DISPLAYSTYLE_BLOCK => Keyword::Block,
            _ => panic!("Found unexpected value in style struct for _moz_math_display property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_math_variant(&mut self, v: longhands::_moz_math_variant::computed_value::T) {
        use crate::properties::longhands::_moz_math_variant::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::NS_MATHML_MATHVARIANT_NONE as u8,
                Keyword::Normal =>
                    structs::NS_MATHML_MATHVARIANT_NORMAL as u8,
                Keyword::Bold =>
                    structs::NS_MATHML_MATHVARIANT_BOLD as u8,
                Keyword::Italic =>
                    structs::NS_MATHML_MATHVARIANT_ITALIC as u8,
                Keyword::BoldItalic =>
                    structs::NS_MATHML_MATHVARIANT_BOLD_ITALIC as u8,
                Keyword::Script =>
                    structs::NS_MATHML_MATHVARIANT_SCRIPT as u8,
                Keyword::BoldScript =>
                    structs::NS_MATHML_MATHVARIANT_BOLD_SCRIPT as u8,
                Keyword::Fraktur =>
                    structs::NS_MATHML_MATHVARIANT_FRAKTUR as u8,
                Keyword::DoubleStruck =>
                    structs::NS_MATHML_MATHVARIANT_DOUBLE_STRUCK as u8,
                Keyword::BoldFraktur =>
                    structs::NS_MATHML_MATHVARIANT_BOLD_FRAKTUR as u8,
                Keyword::SansSerif =>
                    structs::NS_MATHML_MATHVARIANT_SANS_SERIF as u8,
                Keyword::BoldSansSerif =>
                    structs::NS_MATHML_MATHVARIANT_BOLD_SANS_SERIF as u8,
                Keyword::SansSerifItalic =>
                    structs::NS_MATHML_MATHVARIANT_SANS_SERIF_ITALIC as u8,
                Keyword::SansSerifBoldItalic =>
                    structs::NS_MATHML_MATHVARIANT_SANS_SERIF_BOLD_ITALIC as u8,
                Keyword::Monospace =>
                    structs::NS_MATHML_MATHVARIANT_MONOSPACE as u8,
                Keyword::Initial =>
                    structs::NS_MATHML_MATHVARIANT_INITIAL as u8,
                Keyword::Tailed =>
                    structs::NS_MATHML_MATHVARIANT_TAILED as u8,
                Keyword::Looped =>
                    structs::NS_MATHML_MATHVARIANT_LOOPED as u8,
                Keyword::Stretched =>
                    structs::NS_MATHML_MATHVARIANT_STRETCHED as u8,
        };
        self.gecko.mMathVariant = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_math_variant_from(&mut self, other: &Self) {
        self.gecko.mMathVariant = other.gecko.mMathVariant.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_math_variant(&mut self, other: &Self) {
        self.copy__moz_math_variant_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_math_variant(&self) -> longhands::_moz_math_variant::computed_value::T {
        use crate::properties::longhands::_moz_math_variant::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_MATHML_MATHVARIANT_NONE : u8 =
            structs::NS_MATHML_MATHVARIANT_NONE as u8;
        const U8_NS_MATHML_MATHVARIANT_NORMAL : u8 =
            structs::NS_MATHML_MATHVARIANT_NORMAL as u8;
        const U8_NS_MATHML_MATHVARIANT_BOLD : u8 =
            structs::NS_MATHML_MATHVARIANT_BOLD as u8;
        const U8_NS_MATHML_MATHVARIANT_ITALIC : u8 =
            structs::NS_MATHML_MATHVARIANT_ITALIC as u8;
        const U8_NS_MATHML_MATHVARIANT_BOLD_ITALIC : u8 =
            structs::NS_MATHML_MATHVARIANT_BOLD_ITALIC as u8;
        const U8_NS_MATHML_MATHVARIANT_SCRIPT : u8 =
            structs::NS_MATHML_MATHVARIANT_SCRIPT as u8;
        const U8_NS_MATHML_MATHVARIANT_BOLD_SCRIPT : u8 =
            structs::NS_MATHML_MATHVARIANT_BOLD_SCRIPT as u8;
        const U8_NS_MATHML_MATHVARIANT_FRAKTUR : u8 =
            structs::NS_MATHML_MATHVARIANT_FRAKTUR as u8;
        const U8_NS_MATHML_MATHVARIANT_DOUBLE_STRUCK : u8 =
            structs::NS_MATHML_MATHVARIANT_DOUBLE_STRUCK as u8;
        const U8_NS_MATHML_MATHVARIANT_BOLD_FRAKTUR : u8 =
            structs::NS_MATHML_MATHVARIANT_BOLD_FRAKTUR as u8;
        const U8_NS_MATHML_MATHVARIANT_SANS_SERIF : u8 =
            structs::NS_MATHML_MATHVARIANT_SANS_SERIF as u8;
        const U8_NS_MATHML_MATHVARIANT_BOLD_SANS_SERIF : u8 =
            structs::NS_MATHML_MATHVARIANT_BOLD_SANS_SERIF as u8;
        const U8_NS_MATHML_MATHVARIANT_SANS_SERIF_ITALIC : u8 =
            structs::NS_MATHML_MATHVARIANT_SANS_SERIF_ITALIC as u8;
        const U8_NS_MATHML_MATHVARIANT_SANS_SERIF_BOLD_ITALIC : u8 =
            structs::NS_MATHML_MATHVARIANT_SANS_SERIF_BOLD_ITALIC as u8;
        const U8_NS_MATHML_MATHVARIANT_MONOSPACE : u8 =
            structs::NS_MATHML_MATHVARIANT_MONOSPACE as u8;
        const U8_NS_MATHML_MATHVARIANT_INITIAL : u8 =
            structs::NS_MATHML_MATHVARIANT_INITIAL as u8;
        const U8_NS_MATHML_MATHVARIANT_TAILED : u8 =
            structs::NS_MATHML_MATHVARIANT_TAILED as u8;
        const U8_NS_MATHML_MATHVARIANT_LOOPED : u8 =
            structs::NS_MATHML_MATHVARIANT_LOOPED as u8;
        const U8_NS_MATHML_MATHVARIANT_STRETCHED : u8 =
            structs::NS_MATHML_MATHVARIANT_STRETCHED as u8;

        match self.gecko.mMathVariant as u8 {
            U8_NS_MATHML_MATHVARIANT_NONE => Keyword::None,
            U8_NS_MATHML_MATHVARIANT_NORMAL => Keyword::Normal,
            U8_NS_MATHML_MATHVARIANT_BOLD => Keyword::Bold,
            U8_NS_MATHML_MATHVARIANT_ITALIC => Keyword::Italic,
            U8_NS_MATHML_MATHVARIANT_BOLD_ITALIC => Keyword::BoldItalic,
            U8_NS_MATHML_MATHVARIANT_SCRIPT => Keyword::Script,
            U8_NS_MATHML_MATHVARIANT_BOLD_SCRIPT => Keyword::BoldScript,
            U8_NS_MATHML_MATHVARIANT_FRAKTUR => Keyword::Fraktur,
            U8_NS_MATHML_MATHVARIANT_DOUBLE_STRUCK => Keyword::DoubleStruck,
            U8_NS_MATHML_MATHVARIANT_BOLD_FRAKTUR => Keyword::BoldFraktur,
            U8_NS_MATHML_MATHVARIANT_SANS_SERIF => Keyword::SansSerif,
            U8_NS_MATHML_MATHVARIANT_BOLD_SANS_SERIF => Keyword::BoldSansSerif,
            U8_NS_MATHML_MATHVARIANT_SANS_SERIF_ITALIC => Keyword::SansSerifItalic,
            U8_NS_MATHML_MATHVARIANT_SANS_SERIF_BOLD_ITALIC => Keyword::SansSerifBoldItalic,
            U8_NS_MATHML_MATHVARIANT_MONOSPACE => Keyword::Monospace,
            U8_NS_MATHML_MATHVARIANT_INITIAL => Keyword::Initial,
            U8_NS_MATHML_MATHVARIANT_TAILED => Keyword::Tailed,
            U8_NS_MATHML_MATHVARIANT_LOOPED => Keyword::Looped,
            U8_NS_MATHML_MATHVARIANT_STRETCHED => Keyword::Stretched,
            _ => panic!("Found unexpected value in style struct for _moz_math_variant property"),
        }
    }


    #[allow(non_snake_case)]
    pub fn set__moz_script_min_size(&mut self, v: longhands::_moz_script_min_size::computed_value::T) {
        self.gecko.mScriptMinSize = v.to_i32_au();
    }
    
    #[allow(non_snake_case)]
    pub fn copy__moz_script_min_size_from(&mut self, other: &Self) {
        self.gecko.mScriptMinSize = other.gecko.mScriptMinSize.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_script_min_size(&mut self, other: &Self) {
        self.copy__moz_script_min_size_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__moz_script_min_size(&self) -> longhands::_moz_script_min_size::computed_value::T {
        Au(self.gecko.mScriptMinSize).into()
    }


    #[allow(non_snake_case)]
    pub fn set__moz_osx_font_smoothing(&mut self, v: longhands::_moz_osx_font_smoothing::computed_value::T) {
        use crate::properties::longhands::_moz_osx_font_smoothing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_FONT_SMOOTHING_AUTO as u8,
                Keyword::Grayscale =>
                    structs::NS_FONT_SMOOTHING_GRAYSCALE as u8,
        };
        self.gecko.mFont.smoothing = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_osx_font_smoothing_from(&mut self, other: &Self) {
        self.gecko.mFont.smoothing = other.gecko.mFont.smoothing.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_osx_font_smoothing(&mut self, other: &Self) {
        self.copy__moz_osx_font_smoothing_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_osx_font_smoothing(&self) -> longhands::_moz_osx_font_smoothing::computed_value::T {
        use crate::properties::longhands::_moz_osx_font_smoothing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_SMOOTHING_AUTO : u8 =
            structs::NS_FONT_SMOOTHING_AUTO as u8;
        const U8_NS_FONT_SMOOTHING_GRAYSCALE : u8 =
            structs::NS_FONT_SMOOTHING_GRAYSCALE as u8;

        match self.gecko.mFont.smoothing as u8 {
            U8_NS_FONT_SMOOTHING_AUTO => Keyword::Auto,
            U8_NS_FONT_SMOOTHING_GRAYSCALE => Keyword::Grayscale,
            _ => panic!("Found unexpected value in style struct for _moz_osx_font_smoothing property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_font_smoothing_background_color(&mut self, v: longhands::_moz_font_smoothing_background_color::computed_value::T) {
        self.gecko.mFont.fontSmoothingBackgroundColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_font_smoothing_background_color_from(&mut self, other: &Self) {
        self.gecko.mFont.fontSmoothingBackgroundColor = other.gecko.mFont.fontSmoothingBackgroundColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_font_smoothing_background_color(&mut self, other: &Self) {
        self.copy__moz_font_smoothing_background_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_font_smoothing_background_color(&self) -> longhands::_moz_font_smoothing_background_color::computed_value::T {
        From::from(self.gecko.mFont.fontSmoothingBackgroundColor.clone())
    }


}





























impl GeckoBox {
    /*
     * Manually-Implemented Methods.
     */
    
    #[inline]
    pub fn set_display(&mut self, v: longhands::display::computed_value::T) {
        self.gecko.mDisplay = v;
        self.gecko.mOriginalDisplay = v;
    }

    #[inline]
    pub fn copy_display_from(&mut self, other: &Self) {
        self.gecko.mDisplay = other.gecko.mDisplay;
        self.gecko.mOriginalDisplay = other.gecko.mDisplay;
    }

    #[inline]
    pub fn reset_display(&mut self, other: &Self) {
        self.copy_display_from(other)
    }

    #[inline]
    pub fn set_adjusted_display(
        &mut self,
        v: longhands::display::computed_value::T,
        _is_item_or_root: bool
    ) {
        self.gecko.mDisplay = v;
    }

    #[inline]
    pub fn clone_display(&self) -> longhands::display::computed_value::T {
        self.gecko.mDisplay
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_clear(&mut self, v: longhands::clear::computed_value::T) {
        use crate::properties::longhands::clear::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Left =>
                    structs::StyleClear::Left ,
                Keyword::Right =>
                    structs::StyleClear::Right ,
                Keyword::None =>
                    structs::StyleClear::None ,
                Keyword::Both =>
                    structs::StyleClear::Both ,
        };
        self.gecko.mBreakType = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_clear_from(&mut self, other: &Self) {
        self.gecko.mBreakType = other.gecko.mBreakType.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_clear(&mut self, other: &Self) {
        self.copy_clear_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_clear(&self) -> longhands::clear::computed_value::T {
        use crate::properties::longhands::clear::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBreakType {
            structs::StyleClear::Left => Keyword::Left,
            structs::StyleClear::Right => Keyword::Right,
            structs::StyleClear::None => Keyword::None,
            structs::StyleClear::Both => Keyword::Both,
            _ => panic!("Found unexpected value in style struct for clear property"),
        }
    }



    
    #[allow(non_snake_case)]
    pub fn set_scroll_snap_points_x(&mut self, v: longhands::scroll_snap_points_x::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mScrollSnapPointsX);
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_snap_points_x_from(&mut self, other: &Self) {
        self.gecko.mScrollSnapPointsX.copy_from(&other.gecko.mScrollSnapPointsX);
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_snap_points_x(&mut self, other: &Self) {
        self.copy_scroll_snap_points_x_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_points_x(&self) -> longhands::scroll_snap_points_x::computed_value::T {
        use crate::properties::longhands::scroll_snap_points_x::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mScrollSnapPointsX)
            .expect("clone for scroll_snap_points_x failed")
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_snap_points_y(&mut self, v: longhands::scroll_snap_points_y::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mScrollSnapPointsY);
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_snap_points_y_from(&mut self, other: &Self) {
        self.gecko.mScrollSnapPointsY.copy_from(&other.gecko.mScrollSnapPointsY);
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_snap_points_y(&mut self, other: &Self) {
        self.copy_scroll_snap_points_y_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_points_y(&self) -> longhands::scroll_snap_points_y::computed_value::T {
        use crate::properties::longhands::scroll_snap_points_y::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mScrollSnapPointsY)
            .expect("clone for scroll_snap_points_y failed")
    }


    pub fn set_scroll_snap_coordinate<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::scroll_snap_coordinate::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        self.gecko.mScrollSnapCoordinate.assign_from_iter_pod(v.into_iter());
    }

    pub fn copy_scroll_snap_coordinate_from(&mut self, other: &Self) {
        let iter = other.gecko.mScrollSnapCoordinate.iter().map(|c| *c);
        self.gecko.mScrollSnapCoordinate.assign_from_iter_pod(iter);
    }

    pub fn reset_scroll_snap_coordinate(&mut self, other: &Self) {
        self.copy_scroll_snap_coordinate_from(other)
    }

    pub fn clone_scroll_snap_coordinate(&self) -> longhands::scroll_snap_coordinate::computed_value::T {
        let vec = self.gecko.mScrollSnapCoordinate.iter().cloned().collect();
        longhands::scroll_snap_coordinate::computed_value::List(vec)
    }

    
    #[allow(non_snake_case)]
    pub fn set__moz_binding(&mut self, v: longhands::_moz_binding::computed_value::T) {
        match v {
            UrlOrNone::Url(ref url) => {
                self.gecko.mBinding.set_move(url.clone_url_value())
            }
            UrlOrNone::None => {
                unsafe {
                    self.gecko.mBinding.clear();
                }
            }
        }
    }
    #[allow(non_snake_case)]
    pub fn copy__moz_binding_from(&mut self, other: &Self) {
        unsafe {
            self.gecko.mBinding.set(&other.gecko.mBinding);
        }
    }
    #[allow(non_snake_case)]
    pub fn reset__moz_binding(&mut self, other: &Self) {
        self.copy__moz_binding_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__moz_binding(&self) -> longhands::_moz_binding::computed_value::T {
        use crate::values::computed::url::ComputedUrl;

        if self.gecko.mBinding.mRawPtr.is_null() {
            return UrlOrNone::none()
        }

        UrlOrNone::Url(unsafe {
            ComputedUrl::from_url_value(self.gecko.mBinding.to_safe())
        })
    }


    
    
    #[allow(non_snake_case)]
    pub fn set_transition_delay<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::transition_delay::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mTransitions.ensure_len(input_len);

        self.gecko.mTransitionDelayCount = input_len as u32;
        for (gecko, servo) in self.gecko.mTransitions.iter_mut().take(input_len as usize).zip(v) {
            gecko.mDelay = servo.seconds() * 1000.;
        }
    }
    #[allow(non_snake_case)]
    pub fn transition_delay_at(&self, index: usize)
        -> longhands::transition_delay::computed_value::SingleComputedValue {
        use crate::values::computed::Time;
        Time::from_seconds(self.gecko.mTransitions[index].mDelay / 1000.)
    }
    
    #[allow(non_snake_case)]
    pub fn transition_delay_count(&self) -> usize {
        self.gecko.mTransitionDelayCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn copy_transition_delay_from(&mut self, other: &Self) {
        self.gecko.mTransitions.ensure_len(other.gecko.mTransitions.len());

        let count = other.gecko.mTransitionDelayCount;
        self.gecko.mTransitionDelayCount = count;

        let iter = self.gecko.mTransitions.iter_mut().take(count as usize).zip(
            other.gecko.mTransitions.iter()
        );

        for (ours, others) in iter {
            ours.mDelay = others.mDelay;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_transition_delay(&mut self, other: &Self) {
        self.copy_transition_delay_from(other)
    }



    
    
    #[allow(non_snake_case)]
    pub fn set_transition_duration<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::transition_duration::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mTransitions.ensure_len(input_len);

        self.gecko.mTransitionDurationCount = input_len as u32;
        for (gecko, servo) in self.gecko.mTransitions.iter_mut().take(input_len as usize).zip(v) {
            gecko.mDuration = servo.seconds() * 1000.;
        }
    }
    #[allow(non_snake_case)]
    pub fn transition_duration_at(&self, index: usize)
        -> longhands::transition_duration::computed_value::SingleComputedValue {
        use crate::values::computed::Time;
        Time::from_seconds(self.gecko.mTransitions[index].mDuration / 1000.)
    }
    
    #[allow(non_snake_case)]
    pub fn transition_duration_count(&self) -> usize {
        self.gecko.mTransitionDurationCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn copy_transition_duration_from(&mut self, other: &Self) {
        self.gecko.mTransitions.ensure_len(other.gecko.mTransitions.len());

        let count = other.gecko.mTransitionDurationCount;
        self.gecko.mTransitionDurationCount = count;

        let iter = self.gecko.mTransitions.iter_mut().take(count as usize).zip(
            other.gecko.mTransitions.iter()
        );

        for (ours, others) in iter {
            ours.mDuration = others.mDuration;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_transition_duration(&mut self, other: &Self) {
        self.copy_transition_duration_from(other)
    }



    
    
    pub fn set_transition_timing_function<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::transition_timing_function::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mTransitions.ensure_len(input_len);

        self.gecko.mTransitionTimingFunctionCount = input_len as u32;
        for (gecko, servo) in self.gecko.mTransitions.iter_mut().take(input_len as usize).zip(v) {
            gecko.mTimingFunction.mTiming = servo;
        }
    }
    
    #[allow(non_snake_case)]
    pub fn transition_timing_function_count(&self) -> usize {
        self.gecko.mTransitionTimingFunctionCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn copy_transition_timing_function_from(&mut self, other: &Self) {
        self.gecko.mTransitions.ensure_len(other.gecko.mTransitions.len());

        let count = other.gecko.mTransitionTimingFunctionCount;
        self.gecko.mTransitionTimingFunctionCount = count;

        let iter = self.gecko.mTransitions.iter_mut().take(count as usize).zip(
            other.gecko.mTransitions.iter()
        );

        for (ours, others) in iter {
            ours.mTimingFunction.mTiming = others.mTimingFunction.mTiming;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_transition_timing_function(&mut self, other: &Self) {
        self.copy_transition_timing_function_from(other)
    }

    pub fn transition_timing_function_at(&self, index: usize)
        -> longhands::transition_timing_function::computed_value::SingleComputedValue {
        self.gecko.mTransitions[index].mTimingFunction.mTiming
    }



    pub fn transition_combined_duration_at(&self, index: usize) -> f32 {
        // https://drafts.csswg.org/css-transitions/#transition-combined-duration
        self.gecko.mTransitions[index % self.gecko.mTransitionDurationCount as usize].mDuration.max(0.0)
            + self.gecko.mTransitions[index % self.gecko.mTransitionDelayCount as usize].mDelay
    }

    pub fn set_transition_property<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::transition_property::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_no_properties;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_variable;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSProperty_UNKNOWN;

        let v = v.into_iter();

        if v.len() != 0 {
            self.gecko.mTransitions.ensure_len(v.len());
            self.gecko.mTransitionPropertyCount = v.len() as u32;
            for (servo, gecko) in v.zip(self.gecko.mTransitions.iter_mut()) {
                unsafe { gecko.mUnknownProperty.clear() };

                match servo {
                    TransitionProperty::Unsupported(ident) => {
                        gecko.mProperty = eCSSProperty_UNKNOWN;
                        gecko.mUnknownProperty.mRawPtr = ident.0.into_addrefed();
                    },
                    TransitionProperty::Custom(name) => {
                        gecko.mProperty = eCSSPropertyExtra_variable;
                        gecko.mUnknownProperty.mRawPtr = name.into_addrefed();
                    }
                    _ => gecko.mProperty = servo.to_nscsspropertyid().unwrap(),
                }
            }
        } else {
            // In gecko |none| is represented by eCSSPropertyExtra_no_properties.
            self.gecko.mTransitionPropertyCount = 1;
            self.gecko.mTransitions[0].mProperty = eCSSPropertyExtra_no_properties;
        }
    }

    /// Returns whether there are any transitions specified.
    pub fn specifies_transitions(&self) -> bool {
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_all_properties;
        if self.gecko.mTransitionPropertyCount == 1 &&
            self.gecko.mTransitions[0].mProperty == eCSSPropertyExtra_all_properties &&
            self.transition_combined_duration_at(0) <= 0.0f32 {
            return false;
        }

        self.gecko.mTransitionPropertyCount > 0
    }

    pub fn transition_property_at(&self, index: usize)
        -> longhands::transition_property::computed_value::SingleComputedValue {
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_no_properties;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_variable;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSProperty_UNKNOWN;

        let property = self.gecko.mTransitions[index].mProperty;
        if property == eCSSProperty_UNKNOWN {
            let atom = self.gecko.mTransitions[index].mUnknownProperty.mRawPtr;
            debug_assert!(!atom.is_null());
            TransitionProperty::Unsupported(CustomIdent(unsafe{
                Atom::from_raw(atom)
            }))
        } else if property == eCSSPropertyExtra_variable {
            let atom = self.gecko.mTransitions[index].mUnknownProperty.mRawPtr;
            debug_assert!(!atom.is_null());
            TransitionProperty::Custom(unsafe{
                Atom::from_raw(atom)
            })
        } else if property == eCSSPropertyExtra_no_properties {
            // Actually, we don't expect TransitionProperty::Unsupported also
            // represents "none", but if the caller wants to convert it, it is
            // fine. Please use it carefully.
            //
            // FIXME(emilio): This is a hack, is this reachable?
            TransitionProperty::Unsupported(CustomIdent(atom!("none")))
        } else {
            property.into()
        }
    }

    pub fn transition_nscsspropertyid_at(&self, index: usize) -> nsCSSPropertyID {
        self.gecko.mTransitions[index].mProperty
    }

    pub fn copy_transition_property_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_variable;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSProperty_UNKNOWN;
        self.gecko.mTransitions.ensure_len(other.gecko.mTransitions.len());

        let count = other.gecko.mTransitionPropertyCount;
        self.gecko.mTransitionPropertyCount = count;

        for (index, transition) in self.gecko.mTransitions.iter_mut().enumerate().take(count as usize) {
            transition.mProperty = other.gecko.mTransitions[index].mProperty;
            unsafe { transition.mUnknownProperty.clear() };
            if transition.mProperty == eCSSProperty_UNKNOWN ||
               transition.mProperty == eCSSPropertyExtra_variable {
                let atom = other.gecko.mTransitions[index].mUnknownProperty.mRawPtr;
                debug_assert!(!atom.is_null());
                transition.mUnknownProperty.mRawPtr = unsafe { Atom::from_raw(atom) }.into_addrefed();
            }
        }
    }

    pub fn reset_transition_property(&mut self, other: &Self) {
        self.copy_transition_property_from(other)
    }

    // Hand-written because the Mako helpers transform `Preserve3d` into `PRESERVE3D`.
    pub fn set_transform_style(&mut self, v: TransformStyle) {
        self.gecko.mTransformStyle = match v {
            TransformStyle::Flat => structs::NS_STYLE_TRANSFORM_STYLE_FLAT as u8,
            TransformStyle::Preserve3d => structs::NS_STYLE_TRANSFORM_STYLE_PRESERVE_3D as u8,
        };
    }

    // Hand-written because the Mako helpers transform `Preserve3d` into `PRESERVE3D`.
    pub fn clone_transform_style(&self) -> TransformStyle {
        match self.gecko.mTransformStyle as u32 {
            structs::NS_STYLE_TRANSFORM_STYLE_FLAT => TransformStyle::Flat,
            structs::NS_STYLE_TRANSFORM_STYLE_PRESERVE_3D => TransformStyle::Preserve3d,
            _ => panic!("illegal transform style"),
        }
    }

    
    #[allow(non_snake_case)]
    pub fn copy_transform_style_from(&mut self, other: &Self) {
        self.gecko.mTransformStyle = other.gecko.mTransformStyle.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_transform_style(&mut self, other: &Self) {
        self.copy_transform_style_from(other)
    }


    
    
    #[allow(non_snake_case)]
    pub fn transition_property_count(&self) -> usize {
        self.gecko.mTransitionPropertyCount as usize
    }



    pub fn animations_equals(&self, other: &Self) -> bool {
        return self.gecko.mAnimationNameCount == other.gecko.mAnimationNameCount
            && self.gecko.mAnimationDelayCount == other.gecko.mAnimationDelayCount
            && self.gecko.mAnimationDirectionCount == other.gecko.mAnimationDirectionCount
            && self.gecko.mAnimationDurationCount == other.gecko.mAnimationDurationCount
            && self.gecko.mAnimationFillModeCount == other.gecko.mAnimationFillModeCount
            && self.gecko.mAnimationIterationCountCount == other.gecko.mAnimationIterationCountCount
            && self.gecko.mAnimationPlayStateCount == other.gecko.mAnimationPlayStateCount
            && self.gecko.mAnimationTimingFunctionCount == other.gecko.mAnimationTimingFunctionCount
            && unsafe { bindings::Gecko_StyleAnimationsEquals(&self.gecko.mAnimations, &other.gecko.mAnimations) }
    }

    pub fn set_animation_name<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_name::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        self.gecko.mAnimations.ensure_len(v.len());

        self.gecko.mAnimationNameCount = v.len() as u32;
        for (servo, gecko) in v.zip(self.gecko.mAnimations.iter_mut()) {
            let atom = match servo.0 {
                None => atom!(""),
                Some(ref name) => name.as_atom().clone(),
            };
            unsafe { bindings::Gecko_SetAnimationName(gecko, atom.into_addrefed()); }
        }
    }
    pub fn animation_name_at(&self, index: usize)
        -> longhands::animation_name::computed_value::SingleComputedValue {
        use crate::properties::longhands::animation_name::single_value::SpecifiedValue as AnimationName;

        let atom = self.gecko.mAnimations[index].mName.mRawPtr;
        if atom == atom!("").as_ptr() {
            return AnimationName(None)
        }
        AnimationName(Some(KeyframesName::from_atom(unsafe { Atom::from_raw(atom) })))
    }
    pub fn copy_animation_name_from(&mut self, other: &Self) {
        self.gecko.mAnimationNameCount = other.gecko.mAnimationNameCount;
        unsafe { bindings::Gecko_CopyAnimationNames(&mut self.gecko.mAnimations, &other.gecko.mAnimations); }
    }

    pub fn reset_animation_name(&mut self, other: &Self) {
        self.copy_animation_name_from(other)
    }

    
    
    #[allow(non_snake_case)]
    pub fn animation_name_count(&self) -> usize {
        self.gecko.mAnimationNameCount as usize
    }



    
    
    #[allow(non_snake_case)]
    pub fn set_animation_delay<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_delay::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationDelayCount = input_len as u32;
        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            gecko.mDelay = servo.seconds() * 1000.;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_delay_at(&self, index: usize)
        -> longhands::animation_delay::computed_value::SingleComputedValue {
        use crate::values::computed::Time;
        Time::from_seconds(self.gecko.mAnimations[index].mDelay / 1000.)
    }
    
    #[allow(non_snake_case)]
    pub fn animation_delay_count(&self) -> usize {
        self.gecko.mAnimationDelayCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn copy_animation_delay_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationDelayCount;
        self.gecko.mAnimationDelayCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mDelay = others.mDelay;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_delay(&mut self, other: &Self) {
        self.copy_animation_delay_from(other)
    }



    
    
    #[allow(non_snake_case)]
    pub fn set_animation_duration<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_duration::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationDurationCount = input_len as u32;
        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            gecko.mDuration = servo.seconds() * 1000.;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_duration_at(&self, index: usize)
        -> longhands::animation_duration::computed_value::SingleComputedValue {
        use crate::values::computed::Time;
        Time::from_seconds(self.gecko.mAnimations[index].mDuration / 1000.)
    }
    
    #[allow(non_snake_case)]
    pub fn animation_duration_count(&self) -> usize {
        self.gecko.mAnimationDurationCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn copy_animation_duration_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationDurationCount;
        self.gecko.mAnimationDurationCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mDuration = others.mDuration;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_duration(&mut self, other: &Self) {
        self.copy_animation_duration_from(other)
    }




    
    #[allow(non_snake_case)]
    pub fn set_animation_direction<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_direction::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        use crate::properties::longhands::animation_direction::single_value::computed_value::T as Keyword;

        let v = v.into_iter();

        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationDirectionCount = input_len as u32;

        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            let result = match servo {
                    Keyword::Normal =>
                        structs::PlaybackDirection::Normal ,
                    Keyword::Reverse =>
                        structs::PlaybackDirection::Reverse ,
                    Keyword::Alternate =>
                        structs::PlaybackDirection::Alternate ,
                    Keyword::AlternateReverse =>
                        structs::PlaybackDirection::Alternate_reverse ,
            };
            gecko.mDirection = result;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_direction_at(&self, index: usize)
        -> longhands::animation_direction::computed_value::SingleComputedValue {
        use crate::properties::longhands::animation_direction::single_value::computed_value::T as Keyword;
        match self.gecko.mAnimations[index].mDirection  {
                structs::PlaybackDirection::Normal => Keyword::Normal,
                structs::PlaybackDirection::Reverse => Keyword::Reverse,
                structs::PlaybackDirection::Alternate => Keyword::Alternate,
                structs::PlaybackDirection::Alternate_reverse => Keyword::AlternateReverse,
            _ => panic!("Found unexpected value for animation-direction"),
        }
    }
    
    
    #[allow(non_snake_case)]
    pub fn animation_direction_count(&self) -> usize {
        self.gecko.mAnimationDirectionCount as usize
    }


    
    
    #[allow(non_snake_case)]
    pub fn copy_animation_direction_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationDirectionCount;
        self.gecko.mAnimationDirectionCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mDirection = others.mDirection;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_direction(&mut self, other: &Self) {
        self.copy_animation_direction_from(other)
    }



    
    #[allow(non_snake_case)]
    pub fn set_animation_fill_mode<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_fill_mode::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        use crate::properties::longhands::animation_fill_mode::single_value::computed_value::T as Keyword;

        let v = v.into_iter();

        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationFillModeCount = input_len as u32;

        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            let result = match servo {
                    Keyword::None =>
                        structs::FillMode::None ,
                    Keyword::Forwards =>
                        structs::FillMode::Forwards ,
                    Keyword::Backwards =>
                        structs::FillMode::Backwards ,
                    Keyword::Both =>
                        structs::FillMode::Both ,
            };
            gecko.mFillMode = result;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_fill_mode_at(&self, index: usize)
        -> longhands::animation_fill_mode::computed_value::SingleComputedValue {
        use crate::properties::longhands::animation_fill_mode::single_value::computed_value::T as Keyword;
        match self.gecko.mAnimations[index].mFillMode  {
                structs::FillMode::None => Keyword::None,
                structs::FillMode::Forwards => Keyword::Forwards,
                structs::FillMode::Backwards => Keyword::Backwards,
                structs::FillMode::Both => Keyword::Both,
            _ => panic!("Found unexpected value for animation-fill_mode"),
        }
    }
    
    
    #[allow(non_snake_case)]
    pub fn animation_fill_mode_count(&self) -> usize {
        self.gecko.mAnimationFillModeCount as usize
    }


    
    
    #[allow(non_snake_case)]
    pub fn copy_animation_fill_mode_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationFillModeCount;
        self.gecko.mAnimationFillModeCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mFillMode = others.mFillMode;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_fill_mode(&mut self, other: &Self) {
        self.copy_animation_fill_mode_from(other)
    }



    
    #[allow(non_snake_case)]
    pub fn set_animation_play_state<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_play_state::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        use crate::properties::longhands::animation_play_state::single_value::computed_value::T as Keyword;

        let v = v.into_iter();

        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationPlayStateCount = input_len as u32;

        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            let result = match servo {
                    Keyword::Running =>
                        structs::StyleAnimationPlayState::Running ,
                    Keyword::Paused =>
                        structs::StyleAnimationPlayState::Paused ,
            };
            gecko.mPlayState = result;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_play_state_at(&self, index: usize)
        -> longhands::animation_play_state::computed_value::SingleComputedValue {
        use crate::properties::longhands::animation_play_state::single_value::computed_value::T as Keyword;
        match self.gecko.mAnimations[index].mPlayState  {
                structs::StyleAnimationPlayState::Running => Keyword::Running,
                structs::StyleAnimationPlayState::Paused => Keyword::Paused,
        }
    }
    
    
    #[allow(non_snake_case)]
    pub fn animation_play_state_count(&self) -> usize {
        self.gecko.mAnimationPlayStateCount as usize
    }


    
    
    #[allow(non_snake_case)]
    pub fn copy_animation_play_state_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationPlayStateCount;
        self.gecko.mAnimationPlayStateCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mPlayState = others.mPlayState;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_play_state(&mut self, other: &Self) {
        self.copy_animation_play_state_from(other)
    }




    pub fn set_animation_iteration_count<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = values::computed::AnimationIterationCount>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        use std::f32;
        use crate::values::generics::box_::AnimationIterationCount;

        let v = v.into_iter();

        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationIterationCountCount = input_len as u32;
        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            match servo {
                AnimationIterationCount::Number(n) => gecko.mIterationCount = n,
                AnimationIterationCount::Infinite => gecko.mIterationCount = f32::INFINITY,
            }
        }
    }

    pub fn animation_iteration_count_at(
        &self,
        index: usize,
    ) -> values::computed::AnimationIterationCount {
        use crate::values::generics::box_::AnimationIterationCount;

        if self.gecko.mAnimations[index].mIterationCount.is_infinite() {
            AnimationIterationCount::Infinite
        } else {
            AnimationIterationCount::Number(self.gecko.mAnimations[index].mIterationCount)
        }
    }

    
    
    #[allow(non_snake_case)]
    pub fn animation_iteration_count_count(&self) -> usize {
        self.gecko.mAnimationIterationCountCount as usize
    }


    
    
    #[allow(non_snake_case)]
    pub fn copy_animation_iteration_count_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationIterationCountCount;
        self.gecko.mAnimationIterationCountCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mIterationCount = others.mIterationCount;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_iteration_count(&mut self, other: &Self) {
        self.copy_animation_iteration_count_from(other)
    }



    
    
    pub fn set_animation_timing_function<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_timing_function::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationTimingFunctionCount = input_len as u32;
        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            gecko.mTimingFunction.mTiming = servo;
        }
    }
    
    #[allow(non_snake_case)]
    pub fn animation_timing_function_count(&self) -> usize {
        self.gecko.mAnimationTimingFunctionCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn copy_animation_timing_function_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationTimingFunctionCount;
        self.gecko.mAnimationTimingFunctionCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mTimingFunction.mTiming = others.mTimingFunction.mTiming;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_timing_function(&mut self, other: &Self) {
        self.copy_animation_timing_function_from(other)
    }

    pub fn animation_timing_function_at(&self, index: usize)
        -> longhands::animation_timing_function::computed_value::SingleComputedValue {
        self.gecko.mAnimations[index].mTimingFunction.mTiming
    }



    
    pub fn set_shape_outside(&mut self, v: longhands::shape_outside::computed_value::T) {
        use crate::values::generics::basic_shape::ShapeSource;
        use crate::gecko_bindings::structs::StyleShapeSourceType;
        use crate::gecko_bindings::structs::StyleGeometryBox;

        let ref mut shape_outside = self.gecko.mShapeOutside;

        // clean up existing struct.
        unsafe { bindings::Gecko_DestroyShapeSource(shape_outside) };

        shape_outside.mType = StyleShapeSourceType::None;

        match v {
            ShapeSource::ImageOrUrl(image) => {
                unsafe {
                    bindings::Gecko_NewShapeImage(shape_outside);
                    let style_image = &mut *shape_outside.__bindgen_anon_1.mShapeImage.as_mut().mPtr;
                    style_image.set(image);
                }
            }
            ShapeSource::None => {} // don't change the type
            ShapeSource::Box(reference) => {
                shape_outside.mReferenceBox = reference.into();
                shape_outside.mType = StyleShapeSourceType::Box;
            }
            ShapeSource::Path(p) => set_style_svg_path(shape_outside, p.path, p.fill),
            ShapeSource::Shape(servo_shape, maybe_box) => {
                unsafe {
                    shape_outside.__bindgen_anon_1.mBasicShape.as_mut().mPtr =
                        Box::into_raw(servo_shape);
                }
                shape_outside.mReferenceBox =
                    maybe_box.map(Into::into).unwrap_or(StyleGeometryBox::NoBox);
                shape_outside.mType = StyleShapeSourceType::Shape;
            }
        }

    }

    pub fn clone_shape_outside(&self) -> longhands::shape_outside::computed_value::T {
        (&self.gecko.mShapeOutside).into()
    }

    pub fn copy_shape_outside_from(&mut self, other: &Self) {
        use crate::gecko_bindings::bindings::Gecko_CopyShapeSourceFrom;
        unsafe {
            Gecko_CopyShapeSourceFrom(&mut self.gecko.mShapeOutside, &other.gecko.mShapeOutside);
        }
    }

    pub fn reset_shape_outside(&mut self, other: &Self) {
        self.copy_shape_outside_from(other)
    }


    pub fn set_offset_path(&mut self, v: longhands::offset_path::computed_value::T) {
        use crate::gecko_bindings::bindings::{Gecko_NewStyleMotion, Gecko_SetStyleMotion};
        use crate::gecko_bindings::structs::StyleShapeSourceType;
        use crate::values::generics::basic_shape::FillRule;
        use crate::values::specified::OffsetPath;

        let motion = unsafe { Gecko_NewStyleMotion().as_mut().unwrap() };
        match v {
            OffsetPath::None => motion.mOffsetPath.mType = StyleShapeSourceType::None,
            OffsetPath::Path(p) => {
                set_style_svg_path(&mut motion.mOffsetPath, p, FillRule::Nonzero)
            },
        }
        unsafe { Gecko_SetStyleMotion(&mut self.gecko.mMotion, motion) };
    }

    pub fn clone_offset_path(&self) -> longhands::offset_path::computed_value::T {
        use crate::values::specified::OffsetPath;
        match unsafe { self.gecko.mMotion.mPtr.as_ref() } {
            None => OffsetPath::none(),
            Some(v) => (&v.mOffsetPath).into()
        }
    }

    pub fn copy_offset_path_from(&mut self, other: &Self) {
        use crate::gecko_bindings::bindings::Gecko_CopyStyleMotions;
        unsafe { Gecko_CopyStyleMotions(&mut self.gecko.mMotion, other.gecko.mMotion.mPtr) };
    }

    pub fn reset_offset_path(&mut self, other: &Self) {
        self.copy_offset_path_from(other);
    }

    #[allow(non_snake_case)]
    pub fn set__webkit_line_clamp(&mut self, v: longhands::_webkit_line_clamp::computed_value::T) {
        self.gecko.mLineClamp = match v {
            Either::First(n) => n.0 as u32,
            Either::Second(None_) => 0,
        };
    }

    
    #[allow(non_snake_case)]
    pub fn copy__webkit_line_clamp_from(&mut self, other: &Self) {
        self.gecko.mLineClamp = other.gecko.mLineClamp.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__webkit_line_clamp(&mut self, other: &Self) {
        self.copy__webkit_line_clamp_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__webkit_line_clamp(&self) -> longhands::_webkit_line_clamp::computed_value::T {
        match self.gecko.mLineClamp {
            0 => Either::Second(None_),
            n => {
                debug_assert!(n <= std::i32::MAX as u32);
                Either::First((n as i32).into())
            }
        }
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set__moz_top_layer(&mut self, v: longhands::_moz_top_layer::computed_value::T) {
        use crate::properties::longhands::_moz_top_layer::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::NS_STYLE_TOP_LAYER_NONE as u8,
                Keyword::Top =>
                    structs::NS_STYLE_TOP_LAYER_TOP as u8,
        };
        self.gecko.mTopLayer = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_top_layer_from(&mut self, other: &Self) {
        self.gecko.mTopLayer = other.gecko.mTopLayer.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_top_layer(&mut self, other: &Self) {
        self.copy__moz_top_layer_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_top_layer(&self) -> longhands::_moz_top_layer::computed_value::T {
        use crate::properties::longhands::_moz_top_layer::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TOP_LAYER_NONE : u8 =
            structs::NS_STYLE_TOP_LAYER_NONE as u8;
        const U8_NS_STYLE_TOP_LAYER_TOP : u8 =
            structs::NS_STYLE_TOP_LAYER_TOP as u8;

        match self.gecko.mTopLayer as u8 {
            U8_NS_STYLE_TOP_LAYER_NONE => Keyword::None,
            U8_NS_STYLE_TOP_LAYER_TOP => Keyword::Top,
            _ => panic!("Found unexpected value in style struct for _moz_top_layer property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_position(&mut self, v: longhands::position::computed_value::T) {
        use crate::properties::longhands::position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Static =>
                    structs::NS_STYLE_POSITION_STATIC as u8,
                Keyword::Absolute =>
                    structs::NS_STYLE_POSITION_ABSOLUTE as u8,
                Keyword::Relative =>
                    structs::NS_STYLE_POSITION_RELATIVE as u8,
                Keyword::Fixed =>
                    structs::NS_STYLE_POSITION_FIXED as u8,
                Keyword::Sticky =>
                    structs::NS_STYLE_POSITION_STICKY as u8,
        };
        self.gecko.mPosition = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_position_from(&mut self, other: &Self) {
        self.gecko.mPosition = other.gecko.mPosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_position(&mut self, other: &Self) {
        self.copy_position_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_position(&self) -> longhands::position::computed_value::T {
        use crate::properties::longhands::position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_POSITION_STATIC : u8 =
            structs::NS_STYLE_POSITION_STATIC as u8;
        const U8_NS_STYLE_POSITION_ABSOLUTE : u8 =
            structs::NS_STYLE_POSITION_ABSOLUTE as u8;
        const U8_NS_STYLE_POSITION_RELATIVE : u8 =
            structs::NS_STYLE_POSITION_RELATIVE as u8;
        const U8_NS_STYLE_POSITION_FIXED : u8 =
            structs::NS_STYLE_POSITION_FIXED as u8;
        const U8_NS_STYLE_POSITION_STICKY : u8 =
            structs::NS_STYLE_POSITION_STICKY as u8;

        match self.gecko.mPosition as u8 {
            U8_NS_STYLE_POSITION_STATIC => Keyword::Static,
            U8_NS_STYLE_POSITION_ABSOLUTE => Keyword::Absolute,
            U8_NS_STYLE_POSITION_RELATIVE => Keyword::Relative,
            U8_NS_STYLE_POSITION_FIXED => Keyword::Fixed,
            U8_NS_STYLE_POSITION_STICKY => Keyword::Sticky,
            _ => panic!("Found unexpected value in style struct for position property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_float(&mut self, v: longhands::float::computed_value::T) {
        self.gecko.mFloat = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_float_from(&mut self, other: &Self) {
        self.gecko.mFloat = other.gecko.mFloat.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_float(&mut self, other: &Self) {
        self.copy_float_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_float(&self) -> longhands::float::computed_value::T {
        From::from(self.gecko.mFloat.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_vertical_align(&mut self, v: longhands::vertical_align::computed_value::T) {
        self.gecko.mVerticalAlign = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_vertical_align_from(&mut self, other: &Self) {
        self.gecko.mVerticalAlign = other.gecko.mVerticalAlign.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_vertical_align(&mut self, other: &Self) {
        self.copy_vertical_align_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_vertical_align(&self) -> longhands::vertical_align::computed_value::T {
        From::from(self.gecko.mVerticalAlign.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_clip_box_inline(&mut self, v: longhands::overflow_clip_box_inline::computed_value::T) {
        self.gecko.mOverflowClipBoxInline = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_clip_box_inline_from(&mut self, other: &Self) {
        self.gecko.mOverflowClipBoxInline = other.gecko.mOverflowClipBoxInline.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_clip_box_inline(&mut self, other: &Self) {
        self.copy_overflow_clip_box_inline_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_clip_box_inline(&self) -> longhands::overflow_clip_box_inline::computed_value::T {
        From::from(self.gecko.mOverflowClipBoxInline.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_clip_box_block(&mut self, v: longhands::overflow_clip_box_block::computed_value::T) {
        self.gecko.mOverflowClipBoxBlock = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_clip_box_block_from(&mut self, other: &Self) {
        self.gecko.mOverflowClipBoxBlock = other.gecko.mOverflowClipBoxBlock.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_clip_box_block(&mut self, other: &Self) {
        self.copy_overflow_clip_box_block_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_clip_box_block(&self) -> longhands::overflow_clip_box_block::computed_value::T {
        From::from(self.gecko.mOverflowClipBoxBlock.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_x(&mut self, v: longhands::overflow_x::computed_value::T) {
        self.gecko.mOverflowX = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_x_from(&mut self, other: &Self) {
        self.gecko.mOverflowX = other.gecko.mOverflowX.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_x(&mut self, other: &Self) {
        self.copy_overflow_x_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_x(&self) -> longhands::overflow_x::computed_value::T {
        From::from(self.gecko.mOverflowX.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_y(&mut self, v: longhands::overflow_y::computed_value::T) {
        self.gecko.mOverflowY = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_y_from(&mut self, other: &Self) {
        self.gecko.mOverflowY = other.gecko.mOverflowY.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_y(&mut self, other: &Self) {
        self.copy_overflow_y_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_y(&self) -> longhands::overflow_y::computed_value::T {
        From::from(self.gecko.mOverflowY.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_anchor(&mut self, v: longhands::overflow_anchor::computed_value::T) {
        self.gecko.mOverflowAnchor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_anchor_from(&mut self, other: &Self) {
        self.gecko.mOverflowAnchor = other.gecko.mOverflowAnchor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_anchor(&mut self, other: &Self) {
        self.copy_overflow_anchor_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_anchor(&self) -> longhands::overflow_anchor::computed_value::T {
        From::from(self.gecko.mOverflowAnchor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_scroll_snap_destination(&mut self, v: longhands::scroll_snap_destination::computed_value::T) {
        self.gecko.mScrollSnapDestination = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_scroll_snap_destination_from(&mut self, other: &Self) {
        self.gecko.mScrollSnapDestination = other.gecko.mScrollSnapDestination.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scroll_snap_destination(&mut self, other: &Self) {
        self.copy_scroll_snap_destination_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_destination(&self) -> longhands::scroll_snap_destination::computed_value::T {
        From::from(self.gecko.mScrollSnapDestination.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_transform(&mut self, v: longhands::transform::computed_value::T) {
        self.gecko.mTransform = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_transform_from(&mut self, other: &Self) {
        self.gecko.mTransform = other.gecko.mTransform.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_transform(&mut self, other: &Self) {
        self.copy_transform_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_transform(&self) -> longhands::transform::computed_value::T {
        From::from(self.gecko.mTransform.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_rotate(&mut self, v: longhands::rotate::computed_value::T) {
        self.gecko.mRotate = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_rotate_from(&mut self, other: &Self) {
        self.gecko.mRotate = other.gecko.mRotate.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_rotate(&mut self, other: &Self) {
        self.copy_rotate_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_rotate(&self) -> longhands::rotate::computed_value::T {
        From::from(self.gecko.mRotate.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_scale(&mut self, v: longhands::scale::computed_value::T) {
        self.gecko.mScale = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_scale_from(&mut self, other: &Self) {
        self.gecko.mScale = other.gecko.mScale.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scale(&mut self, other: &Self) {
        self.copy_scale_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scale(&self) -> longhands::scale::computed_value::T {
        From::from(self.gecko.mScale.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_translate(&mut self, v: longhands::translate::computed_value::T) {
        self.gecko.mTranslate = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_translate_from(&mut self, other: &Self) {
        self.gecko.mTranslate = other.gecko.mTranslate.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_translate(&mut self, other: &Self) {
        self.copy_translate_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_translate(&self) -> longhands::translate::computed_value::T {
        From::from(self.gecko.mTranslate.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_scroll_behavior(&mut self, v: longhands::scroll_behavior::computed_value::T) {
        use crate::properties::longhands::scroll_behavior::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_SCROLL_BEHAVIOR_AUTO as u8,
                Keyword::Smooth =>
                    structs::NS_STYLE_SCROLL_BEHAVIOR_SMOOTH as u8,
        };
        self.gecko.mScrollBehavior = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_scroll_behavior_from(&mut self, other: &Self) {
        self.gecko.mScrollBehavior = other.gecko.mScrollBehavior.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scroll_behavior(&mut self, other: &Self) {
        self.copy_scroll_behavior_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_scroll_behavior(&self) -> longhands::scroll_behavior::computed_value::T {
        use crate::properties::longhands::scroll_behavior::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_SCROLL_BEHAVIOR_AUTO : u8 =
            structs::NS_STYLE_SCROLL_BEHAVIOR_AUTO as u8;
        const U8_NS_STYLE_SCROLL_BEHAVIOR_SMOOTH : u8 =
            structs::NS_STYLE_SCROLL_BEHAVIOR_SMOOTH as u8;

        match self.gecko.mScrollBehavior as u8 {
            U8_NS_STYLE_SCROLL_BEHAVIOR_AUTO => Keyword::Auto,
            U8_NS_STYLE_SCROLL_BEHAVIOR_SMOOTH => Keyword::Smooth,
            _ => panic!("Found unexpected value in style struct for scroll_behavior property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_scroll_snap_align(&mut self, v: longhands::scroll_snap_align::computed_value::T) {
        self.gecko.mScrollSnapAlign = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_scroll_snap_align_from(&mut self, other: &Self) {
        self.gecko.mScrollSnapAlign = other.gecko.mScrollSnapAlign.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scroll_snap_align(&mut self, other: &Self) {
        self.copy_scroll_snap_align_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_align(&self) -> longhands::scroll_snap_align::computed_value::T {
        From::from(self.gecko.mScrollSnapAlign.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_scroll_snap_type(&mut self, v: longhands::scroll_snap_type::computed_value::T) {
        self.gecko.mScrollSnapType = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_scroll_snap_type_from(&mut self, other: &Self) {
        self.gecko.mScrollSnapType = other.gecko.mScrollSnapType.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scroll_snap_type(&mut self, other: &Self) {
        self.copy_scroll_snap_type_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_type(&self) -> longhands::scroll_snap_type::computed_value::T {
        From::from(self.gecko.mScrollSnapType.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overscroll_behavior_x(&mut self, v: longhands::overscroll_behavior_x::computed_value::T) {
        self.gecko.mOverscrollBehaviorX = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overscroll_behavior_x_from(&mut self, other: &Self) {
        self.gecko.mOverscrollBehaviorX = other.gecko.mOverscrollBehaviorX.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overscroll_behavior_x(&mut self, other: &Self) {
        self.copy_overscroll_behavior_x_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overscroll_behavior_x(&self) -> longhands::overscroll_behavior_x::computed_value::T {
        From::from(self.gecko.mOverscrollBehaviorX.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overscroll_behavior_y(&mut self, v: longhands::overscroll_behavior_y::computed_value::T) {
        self.gecko.mOverscrollBehaviorY = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overscroll_behavior_y_from(&mut self, other: &Self) {
        self.gecko.mOverscrollBehaviorY = other.gecko.mOverscrollBehaviorY.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overscroll_behavior_y(&mut self, other: &Self) {
        self.copy_overscroll_behavior_y_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overscroll_behavior_y(&self) -> longhands::overscroll_behavior_y::computed_value::T {
        From::from(self.gecko.mOverscrollBehaviorY.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_isolation(&mut self, v: longhands::isolation::computed_value::T) {
        use crate::properties::longhands::isolation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_ISOLATION_AUTO as u8,
                Keyword::Isolate =>
                    structs::NS_STYLE_ISOLATION_ISOLATE as u8,
        };
        self.gecko.mIsolation = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_isolation_from(&mut self, other: &Self) {
        self.gecko.mIsolation = other.gecko.mIsolation.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_isolation(&mut self, other: &Self) {
        self.copy_isolation_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_isolation(&self) -> longhands::isolation::computed_value::T {
        use crate::properties::longhands::isolation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_ISOLATION_AUTO : u8 =
            structs::NS_STYLE_ISOLATION_AUTO as u8;
        const U8_NS_STYLE_ISOLATION_ISOLATE : u8 =
            structs::NS_STYLE_ISOLATION_ISOLATE as u8;

        match self.gecko.mIsolation as u8 {
            U8_NS_STYLE_ISOLATION_AUTO => Keyword::Auto,
            U8_NS_STYLE_ISOLATION_ISOLATE => Keyword::Isolate,
            _ => panic!("Found unexpected value in style struct for isolation property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_break_after(&mut self, v: longhands::break_after::computed_value::T) {
        self.gecko.mBreakAfter = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_break_after_from(&mut self, other: &Self) {
        self.gecko.mBreakAfter = other.gecko.mBreakAfter.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_break_after(&mut self, other: &Self) {
        self.copy_break_after_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_break_after(&self) -> longhands::break_after::computed_value::T {
        From::from(self.gecko.mBreakAfter.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_break_before(&mut self, v: longhands::break_before::computed_value::T) {
        self.gecko.mBreakBefore = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_break_before_from(&mut self, other: &Self) {
        self.gecko.mBreakBefore = other.gecko.mBreakBefore.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_break_before(&mut self, other: &Self) {
        self.copy_break_before_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_break_before(&self) -> longhands::break_before::computed_value::T {
        From::from(self.gecko.mBreakBefore.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_break_inside(&mut self, v: longhands::break_inside::computed_value::T) {
        self.gecko.mBreakInside = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_break_inside_from(&mut self, other: &Self) {
        self.gecko.mBreakInside = other.gecko.mBreakInside.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_break_inside(&mut self, other: &Self) {
        self.copy_break_inside_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_break_inside(&self) -> longhands::break_inside::computed_value::T {
        From::from(self.gecko.mBreakInside.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_resize(&mut self, v: longhands::resize::computed_value::T) {
        self.gecko.mResize = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_resize_from(&mut self, other: &Self) {
        self.gecko.mResize = other.gecko.mResize.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_resize(&mut self, other: &Self) {
        self.copy_resize_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_resize(&self) -> longhands::resize::computed_value::T {
        From::from(self.gecko.mResize.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_perspective(&mut self, v: longhands::perspective::computed_value::T) {
        self.gecko.mChildPerspective = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_perspective_from(&mut self, other: &Self) {
        self.gecko.mChildPerspective = other.gecko.mChildPerspective.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_perspective(&mut self, other: &Self) {
        self.copy_perspective_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_perspective(&self) -> longhands::perspective::computed_value::T {
        From::from(self.gecko.mChildPerspective.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_perspective_origin(&mut self, v: longhands::perspective_origin::computed_value::T) {
        self.gecko.mPerspectiveOrigin = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_perspective_origin_from(&mut self, other: &Self) {
        self.gecko.mPerspectiveOrigin = other.gecko.mPerspectiveOrigin.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_perspective_origin(&mut self, other: &Self) {
        self.copy_perspective_origin_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_perspective_origin(&self) -> longhands::perspective_origin::computed_value::T {
        From::from(self.gecko.mPerspectiveOrigin.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_backface_visibility(&mut self, v: longhands::backface_visibility::computed_value::T) {
        use crate::properties::longhands::backface_visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Visible =>
                    structs::NS_STYLE_BACKFACE_VISIBILITY_VISIBLE as u8,
                Keyword::Hidden =>
                    structs::NS_STYLE_BACKFACE_VISIBILITY_HIDDEN as u8,
        };
        self.gecko.mBackfaceVisibility = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_backface_visibility_from(&mut self, other: &Self) {
        self.gecko.mBackfaceVisibility = other.gecko.mBackfaceVisibility.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_backface_visibility(&mut self, other: &Self) {
        self.copy_backface_visibility_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_backface_visibility(&self) -> longhands::backface_visibility::computed_value::T {
        use crate::properties::longhands::backface_visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_BACKFACE_VISIBILITY_VISIBLE : u8 =
            structs::NS_STYLE_BACKFACE_VISIBILITY_VISIBLE as u8;
        const U8_NS_STYLE_BACKFACE_VISIBILITY_HIDDEN : u8 =
            structs::NS_STYLE_BACKFACE_VISIBILITY_HIDDEN as u8;

        match self.gecko.mBackfaceVisibility as u8 {
            U8_NS_STYLE_BACKFACE_VISIBILITY_VISIBLE => Keyword::Visible,
            U8_NS_STYLE_BACKFACE_VISIBILITY_HIDDEN => Keyword::Hidden,
            _ => panic!("Found unexpected value in style struct for backface_visibility property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_transform_box(&mut self, v: longhands::transform_box::computed_value::T) {
        use crate::properties::longhands::transform_box::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::BorderBox =>
                    structs::StyleGeometryBox::BorderBox ,
                Keyword::FillBox =>
                    structs::StyleGeometryBox::FillBox ,
                Keyword::ViewBox =>
                    structs::StyleGeometryBox::ViewBox ,
        };
        self.gecko.mTransformBox = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_transform_box_from(&mut self, other: &Self) {
        self.gecko.mTransformBox = other.gecko.mTransformBox.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_transform_box(&mut self, other: &Self) {
        self.copy_transform_box_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_transform_box(&self) -> longhands::transform_box::computed_value::T {
        use crate::properties::longhands::transform_box::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mTransformBox {
            structs::StyleGeometryBox::BorderBox => Keyword::BorderBox,
            structs::StyleGeometryBox::FillBox => Keyword::FillBox,
            structs::StyleGeometryBox::ViewBox => Keyword::ViewBox,
            _ => panic!("Found unexpected value in style struct for transform_box property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_transform_origin(&mut self, v: longhands::transform_origin::computed_value::T) {
        self.gecko.mTransformOrigin = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_transform_origin_from(&mut self, other: &Self) {
        self.gecko.mTransformOrigin = other.gecko.mTransformOrigin.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_transform_origin(&mut self, other: &Self) {
        self.copy_transform_origin_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_transform_origin(&self) -> longhands::transform_origin::computed_value::T {
        From::from(self.gecko.mTransformOrigin.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_contain(&mut self, v: longhands::contain::computed_value::T) {
        self.gecko.mContain = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_contain_from(&mut self, other: &Self) {
        self.gecko.mContain = other.gecko.mContain.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_contain(&mut self, other: &Self) {
        self.copy_contain_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_contain(&self) -> longhands::contain::computed_value::T {
        From::from(self.gecko.mContain.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_appearance(&mut self, v: longhands::_moz_appearance::computed_value::T) {
        self.gecko.mAppearance = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_appearance_from(&mut self, other: &Self) {
        self.gecko.mAppearance = other.gecko.mAppearance.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_appearance(&mut self, other: &Self) {
        self.copy__moz_appearance_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_appearance(&self) -> longhands::_moz_appearance::computed_value::T {
        From::from(self.gecko.mAppearance.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_orient(&mut self, v: longhands::_moz_orient::computed_value::T) {
        use crate::properties::longhands::_moz_orient::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Inline =>
                    structs::StyleOrient::Inline ,
                Keyword::Block =>
                    structs::StyleOrient::Block ,
                Keyword::Horizontal =>
                    structs::StyleOrient::Horizontal ,
                Keyword::Vertical =>
                    structs::StyleOrient::Vertical ,
        };
        self.gecko.mOrient = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_orient_from(&mut self, other: &Self) {
        self.gecko.mOrient = other.gecko.mOrient.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_orient(&mut self, other: &Self) {
        self.copy__moz_orient_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_orient(&self) -> longhands::_moz_orient::computed_value::T {
        use crate::properties::longhands::_moz_orient::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mOrient {
            structs::StyleOrient::Inline => Keyword::Inline,
            structs::StyleOrient::Block => Keyword::Block,
            structs::StyleOrient::Horizontal => Keyword::Horizontal,
            structs::StyleOrient::Vertical => Keyword::Vertical,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_will_change(&mut self, v: longhands::will_change::computed_value::T) {
        self.gecko.mWillChange = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_will_change_from(&mut self, other: &Self) {
        self.gecko.mWillChange = other.gecko.mWillChange.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_will_change(&mut self, other: &Self) {
        self.copy_will_change_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_will_change(&self) -> longhands::will_change::computed_value::T {
        From::from(self.gecko.mWillChange.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_shape_image_threshold(&mut self, v: longhands::shape_image_threshold::computed_value::T) {
        self.gecko.mShapeImageThreshold = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_shape_image_threshold_from(&mut self, other: &Self) {
        self.gecko.mShapeImageThreshold = other.gecko.mShapeImageThreshold.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_shape_image_threshold(&mut self, other: &Self) {
        self.copy_shape_image_threshold_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_shape_image_threshold(&self) -> longhands::shape_image_threshold::computed_value::T {
        From::from(self.gecko.mShapeImageThreshold.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_shape_margin(&mut self, v: longhands::shape_margin::computed_value::T) {
        self.gecko.mShapeMargin = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_shape_margin_from(&mut self, other: &Self) {
        self.gecko.mShapeMargin = other.gecko.mShapeMargin.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_shape_margin(&mut self, other: &Self) {
        self.copy_shape_margin_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_shape_margin(&self) -> longhands::shape_margin::computed_value::T {
        From::from(self.gecko.mShapeMargin.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_touch_action(&mut self, v: longhands::touch_action::computed_value::T) {
        self.gecko.mTouchAction = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_touch_action_from(&mut self, other: &Self) {
        self.gecko.mTouchAction = other.gecko.mTouchAction.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_touch_action(&mut self, other: &Self) {
        self.copy_touch_action_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_touch_action(&self) -> longhands::touch_action::computed_value::T {
        From::from(self.gecko.mTouchAction.clone())
    }


}










// TODO: Gecko accepts lists in most background-related properties. We just use
// the first element (which is the common case), but at some point we want to
// add support for parsing these lists in servo and pushing to nsTArray's.



impl GeckoBackground {
    /*
     * Manually-Implemented Methods.
     */
    

    
    

    
    
    pub fn copy_background_repeat_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mRepeatCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mRepeat = other.mRepeat;
        }
        self.gecko.mImage.mRepeatCount = count;
    }

    pub fn reset_background_repeat(&mut self, other: &Self) {
        self.copy_background_repeat_from(other)
    }


    pub fn set_background_repeat<I>(&mut self, v: I)
        where I: IntoIterator<Item=longhands::background_repeat::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mRepeatCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage.mLayers.iter_mut()) {
            geckolayer.mRepeat = {
                
        use crate::values::specified::background::BackgroundRepeatKeyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_Repeat;
        use crate::gecko_bindings::structs::StyleImageLayerRepeat;

        fn to_ns(repeat: BackgroundRepeatKeyword) -> StyleImageLayerRepeat {
            match repeat {
                BackgroundRepeatKeyword::Repeat => StyleImageLayerRepeat::Repeat,
                BackgroundRepeatKeyword::Space => StyleImageLayerRepeat::Space,
                BackgroundRepeatKeyword::Round => StyleImageLayerRepeat::Round,
                BackgroundRepeatKeyword::NoRepeat => StyleImageLayerRepeat::NoRepeat,
            }
        }

        let repeat_x = to_ns(servo.0);
        let repeat_y = to_ns(servo.1);
        nsStyleImageLayers_Repeat {
              mXRepeat: repeat_x,
              mYRepeat: repeat_y,
        }
    
            };
        }
    }


    pub fn clone_background_repeat(&self) -> longhands::background_repeat::computed_value::T {
        use crate::properties::longhands::background_repeat::single_value::computed_value::T;
        use crate::values::specified::background::BackgroundRepeatKeyword;
        use crate::gecko_bindings::structs::StyleImageLayerRepeat;

        fn to_servo(repeat: StyleImageLayerRepeat) -> BackgroundRepeatKeyword {
            match repeat {
                StyleImageLayerRepeat::Repeat => BackgroundRepeatKeyword::Repeat,
                StyleImageLayerRepeat::Space => BackgroundRepeatKeyword::Space,
                StyleImageLayerRepeat::Round => BackgroundRepeatKeyword::Round,
                StyleImageLayerRepeat::NoRepeat => BackgroundRepeatKeyword::NoRepeat,
                _ => panic!("Found unexpected value in style struct for background_repeat property"),
            }
        }

        longhands::background_repeat::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mRepeatCount as usize)
                .map(|ref layer| {
                    T(to_servo(layer.mRepeat.mXRepeat), to_servo(layer.mRepeat.mYRepeat))
                }).collect()
        )
    }

    
    

    
    pub fn copy_background_clip_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mClipCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mClip = other.mClip;
        }
        self.gecko.mImage.mClipCount = count;
    }

    pub fn reset_background_clip(&mut self, other: &Self) {
        self.copy_background_clip_from(other)
    }


    pub fn set_background_clip<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::background_clip::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::background_clip::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mClipCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage.mLayers.iter_mut()) {
            geckolayer.mClip = {
                match servo {
                    Keyword::BorderBox =>
                        structs::StyleGeometryBox::BorderBox ,
                    Keyword::PaddingBox =>
                        structs::StyleGeometryBox::PaddingBox ,
                    Keyword::ContentBox =>
                        structs::StyleGeometryBox::ContentBox ,
                    Keyword::Text =>
                        structs::StyleGeometryBox::Text ,
                }
            };
        }
    }

    pub fn clone_background_clip(&self) -> longhands::background_clip::computed_value::T {
        use crate::properties::longhands::background_clip::single_value::computed_value::T as Keyword;


        longhands::background_clip::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mClipCount as usize)
                .map(|ref layer| {
                    match layer.mClip {
                        structs::StyleGeometryBox::BorderBox
                            => Keyword::BorderBox,
                        structs::StyleGeometryBox::PaddingBox
                            => Keyword::PaddingBox,
                        structs::StyleGeometryBox::ContentBox
                            => Keyword::ContentBox,
                        structs::StyleGeometryBox::Text
                            => Keyword::Text,
                        _ => panic!("Found unexpected value in style struct for background_clip property"),
                    }
                }).collect()
        )
    }

    
    

    
    pub fn copy_background_origin_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mOriginCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mOrigin = other.mOrigin;
        }
        self.gecko.mImage.mOriginCount = count;
    }

    pub fn reset_background_origin(&mut self, other: &Self) {
        self.copy_background_origin_from(other)
    }


    pub fn set_background_origin<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::background_origin::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::background_origin::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mOriginCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage.mLayers.iter_mut()) {
            geckolayer.mOrigin = {
                match servo {
                    Keyword::PaddingBox =>
                        structs::StyleGeometryBox::PaddingBox ,
                    Keyword::BorderBox =>
                        structs::StyleGeometryBox::BorderBox ,
                    Keyword::ContentBox =>
                        structs::StyleGeometryBox::ContentBox ,
                }
            };
        }
    }

    pub fn clone_background_origin(&self) -> longhands::background_origin::computed_value::T {
        use crate::properties::longhands::background_origin::single_value::computed_value::T as Keyword;


        longhands::background_origin::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mOriginCount as usize)
                .map(|ref layer| {
                    match layer.mOrigin {
                        structs::StyleGeometryBox::PaddingBox
                            => Keyword::PaddingBox,
                        structs::StyleGeometryBox::BorderBox
                            => Keyword::BorderBox,
                        structs::StyleGeometryBox::ContentBox
                            => Keyword::ContentBox,
                        _ => panic!("Found unexpected value in style struct for background_origin property"),
                    }
                }).collect()
        )
    }


    pub fn copy_background_position_x_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mPositionXCount;

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }

        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mPosition.horizontal = other.mPosition.horizontal;
        }
        self.gecko.mImage.mPositionXCount = count;
    }

    pub fn reset_background_position_x(&mut self, other: &Self) {
        self.copy_background_position_x_from(other)
    }

    pub fn clone_background_position_x(&self)
        -> longhands::background_position_x::computed_value::T {
        longhands::background_position_x::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mPositionXCount as usize)
                .map(|position| position.mPosition.horizontal)
                .collect()
        )
    }

    pub fn set_background_position_x<I>(&mut self,
                                     v: I)
        where I: IntoIterator<Item = longhands::background_position_x
                                              ::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mPositionXCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage
                                                           .mLayers.iter_mut()) {
            geckolayer.mPosition.horizontal = servo;
        }
    }
    pub fn copy_background_position_y_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mPositionYCount;

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }

        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mPosition.vertical = other.mPosition.vertical;
        }
        self.gecko.mImage.mPositionYCount = count;
    }

    pub fn reset_background_position_y(&mut self, other: &Self) {
        self.copy_background_position_y_from(other)
    }

    pub fn clone_background_position_y(&self)
        -> longhands::background_position_y::computed_value::T {
        longhands::background_position_y::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mPositionYCount as usize)
                .map(|position| position.mPosition.vertical)
                .collect()
        )
    }

    pub fn set_background_position_y<I>(&mut self,
                                     v: I)
        where I: IntoIterator<Item = longhands::background_position_y
                                              ::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mPositionYCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage
                                                           .mLayers.iter_mut()) {
            geckolayer.mPosition.vertical = servo;
        }
    }

    
    
    pub fn copy_background_size_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mSizeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mSize = other.mSize;
        }
        self.gecko.mImage.mSizeCount = count;
    }

    pub fn reset_background_size(&mut self, other: &Self) {
        self.copy_background_size_from(other)
    }


    pub fn set_background_size<I>(&mut self, v: I)
        where I: IntoIterator<Item=longhands::background_size::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mSizeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage.mLayers.iter_mut()) {
            geckolayer.mSize = {
                
        servo
    
            };
        }
    }


    pub fn clone_background_size(&self) -> longhands::background_size::computed_value::T {
        longhands::background_size::computed_value::List(
            self.gecko.mImage.mLayers.iter().map(|layer| layer.mSize).collect()
        )
    }

    pub fn copy_background_image_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        unsafe {
            let count = other.gecko.mImage.mImageCount;
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);

            for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                      .zip(other.gecko.mImage.mLayers.iter())
                                      .take(count as usize) {
                Gecko_CopyImageValueFrom(&mut layer.mImage, &other.mImage);
            }
            self.gecko.mImage.mImageCount = count;
        }
    }

    pub fn reset_background_image(&mut self, other: &Self) {
        self.copy_background_image_from(other)
    }

    #[allow(unused_variables)]
    pub fn set_background_image<I>(&mut self, images: I)
        where I: IntoIterator<Item = longhands::background_image::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let images = images.into_iter();

        unsafe {
            // Prevent leaking of the last elements we did set
            for image in &mut self.gecko.mImage.mLayers {
                Gecko_SetNullImageValue(&mut image.mImage)
            }
            // XXXManishearth clear mSourceURI for masks
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, images.len(),
                                          LayerType::Background);
        }

        self.gecko.mImage.mImageCount = images.len() as u32;

        for (image, geckoimage) in images.zip(self.gecko.mImage
                                                  .mLayers.iter_mut()) {
            if let Either::Second(image) = image {
                geckoimage.mImage.set(image)
            }
        }
    }

    pub fn clone_background_image(&self) -> longhands::background_image::computed_value::T {
        use crate::values::None_;

        longhands::background_image::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mImageCount as usize)
                .map(|ref layer| {
                    match unsafe { layer.mImage.into_image() } {
                        Some(image) => Either::Second(image),
                        None => Either::First(None_),
                    }
            }).collect()
        )
    }

    
    pub fn fill_arrays(&mut self) {
        use crate::gecko_bindings::bindings::Gecko_FillAllImageLayers;
        use std::cmp;
        let mut max_len = 1;
            max_len = cmp::max(max_len, self.gecko.mImage.mRepeatCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mClipCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mOriginCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mPositionXCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mPositionYCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mImageCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mSizeCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mAttachmentCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mBlendModeCount);
        unsafe {
            // While we could do this manually, we'd need to also manually
            // run all the copy constructors, so we just delegate to gecko
            Gecko_FillAllImageLayers(&mut self.gecko.mImage, max_len);
        }
    }

    
    

    
    pub fn copy_background_attachment_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mAttachmentCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mAttachment = other.mAttachment;
        }
        self.gecko.mImage.mAttachmentCount = count;
    }

    pub fn reset_background_attachment(&mut self, other: &Self) {
        self.copy_background_attachment_from(other)
    }


    pub fn set_background_attachment<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::background_attachment::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::background_attachment::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mAttachmentCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage.mLayers.iter_mut()) {
            geckolayer.mAttachment = {
                match servo {
                    Keyword::Scroll =>
                        structs::StyleImageLayerAttachment::Scroll ,
                    Keyword::Fixed =>
                        structs::StyleImageLayerAttachment::Fixed ,
                    Keyword::Local =>
                        structs::StyleImageLayerAttachment::Local ,
                }
            };
        }
    }

    pub fn clone_background_attachment(&self) -> longhands::background_attachment::computed_value::T {
        use crate::properties::longhands::background_attachment::single_value::computed_value::T as Keyword;


        longhands::background_attachment::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mAttachmentCount as usize)
                .map(|ref layer| {
                    match layer.mAttachment {
                        structs::StyleImageLayerAttachment::Scroll
                            => Keyword::Scroll,
                        structs::StyleImageLayerAttachment::Fixed
                            => Keyword::Fixed,
                        structs::StyleImageLayerAttachment::Local
                            => Keyword::Local,
                    }
                }).collect()
        )
    }

    
    

    
    pub fn copy_background_blend_mode_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mBlendModeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mBlendMode = other.mBlendMode;
        }
        self.gecko.mImage.mBlendModeCount = count;
    }

    pub fn reset_background_blend_mode(&mut self, other: &Self) {
        self.copy_background_blend_mode_from(other)
    }


    pub fn set_background_blend_mode<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::background_blend_mode::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::background_blend_mode::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mBlendModeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage.mLayers.iter_mut()) {
            geckolayer.mBlendMode = {
                match servo {
                    Keyword::Normal =>
                        structs::NS_STYLE_BLEND_NORMAL as u8,
                    Keyword::Multiply =>
                        structs::NS_STYLE_BLEND_MULTIPLY as u8,
                    Keyword::Screen =>
                        structs::NS_STYLE_BLEND_SCREEN as u8,
                    Keyword::Overlay =>
                        structs::NS_STYLE_BLEND_OVERLAY as u8,
                    Keyword::Darken =>
                        structs::NS_STYLE_BLEND_DARKEN as u8,
                    Keyword::Lighten =>
                        structs::NS_STYLE_BLEND_LIGHTEN as u8,
                    Keyword::ColorDodge =>
                        structs::NS_STYLE_BLEND_COLOR_DODGE as u8,
                    Keyword::ColorBurn =>
                        structs::NS_STYLE_BLEND_COLOR_BURN as u8,
                    Keyword::HardLight =>
                        structs::NS_STYLE_BLEND_HARD_LIGHT as u8,
                    Keyword::SoftLight =>
                        structs::NS_STYLE_BLEND_SOFT_LIGHT as u8,
                    Keyword::Difference =>
                        structs::NS_STYLE_BLEND_DIFFERENCE as u8,
                    Keyword::Exclusion =>
                        structs::NS_STYLE_BLEND_EXCLUSION as u8,
                    Keyword::Hue =>
                        structs::NS_STYLE_BLEND_HUE as u8,
                    Keyword::Saturation =>
                        structs::NS_STYLE_BLEND_SATURATION as u8,
                    Keyword::Color =>
                        structs::NS_STYLE_BLEND_COLOR as u8,
                    Keyword::Luminosity =>
                        structs::NS_STYLE_BLEND_LUMINOSITY as u8,
                }
            };
        }
    }

    pub fn clone_background_blend_mode(&self) -> longhands::background_blend_mode::computed_value::T {
        use crate::properties::longhands::background_blend_mode::single_value::computed_value::T as Keyword;

        const U8_NS_STYLE_BLEND_NORMAL : u8 =
            structs::NS_STYLE_BLEND_NORMAL as u8;
        const U8_NS_STYLE_BLEND_MULTIPLY : u8 =
            structs::NS_STYLE_BLEND_MULTIPLY as u8;
        const U8_NS_STYLE_BLEND_SCREEN : u8 =
            structs::NS_STYLE_BLEND_SCREEN as u8;
        const U8_NS_STYLE_BLEND_OVERLAY : u8 =
            structs::NS_STYLE_BLEND_OVERLAY as u8;
        const U8_NS_STYLE_BLEND_DARKEN : u8 =
            structs::NS_STYLE_BLEND_DARKEN as u8;
        const U8_NS_STYLE_BLEND_LIGHTEN : u8 =
            structs::NS_STYLE_BLEND_LIGHTEN as u8;
        const U8_NS_STYLE_BLEND_COLOR_DODGE : u8 =
            structs::NS_STYLE_BLEND_COLOR_DODGE as u8;
        const U8_NS_STYLE_BLEND_COLOR_BURN : u8 =
            structs::NS_STYLE_BLEND_COLOR_BURN as u8;
        const U8_NS_STYLE_BLEND_HARD_LIGHT : u8 =
            structs::NS_STYLE_BLEND_HARD_LIGHT as u8;
        const U8_NS_STYLE_BLEND_SOFT_LIGHT : u8 =
            structs::NS_STYLE_BLEND_SOFT_LIGHT as u8;
        const U8_NS_STYLE_BLEND_DIFFERENCE : u8 =
            structs::NS_STYLE_BLEND_DIFFERENCE as u8;
        const U8_NS_STYLE_BLEND_EXCLUSION : u8 =
            structs::NS_STYLE_BLEND_EXCLUSION as u8;
        const U8_NS_STYLE_BLEND_HUE : u8 =
            structs::NS_STYLE_BLEND_HUE as u8;
        const U8_NS_STYLE_BLEND_SATURATION : u8 =
            structs::NS_STYLE_BLEND_SATURATION as u8;
        const U8_NS_STYLE_BLEND_COLOR : u8 =
            structs::NS_STYLE_BLEND_COLOR as u8;
        const U8_NS_STYLE_BLEND_LUMINOSITY : u8 =
            structs::NS_STYLE_BLEND_LUMINOSITY as u8;

        longhands::background_blend_mode::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mBlendModeCount as usize)
                .map(|ref layer| {
                    match layer.mBlendMode {
                        U8_NS_STYLE_BLEND_NORMAL
                            => Keyword::Normal,
                        U8_NS_STYLE_BLEND_MULTIPLY
                            => Keyword::Multiply,
                        U8_NS_STYLE_BLEND_SCREEN
                            => Keyword::Screen,
                        U8_NS_STYLE_BLEND_OVERLAY
                            => Keyword::Overlay,
                        U8_NS_STYLE_BLEND_DARKEN
                            => Keyword::Darken,
                        U8_NS_STYLE_BLEND_LIGHTEN
                            => Keyword::Lighten,
                        U8_NS_STYLE_BLEND_COLOR_DODGE
                            => Keyword::ColorDodge,
                        U8_NS_STYLE_BLEND_COLOR_BURN
                            => Keyword::ColorBurn,
                        U8_NS_STYLE_BLEND_HARD_LIGHT
                            => Keyword::HardLight,
                        U8_NS_STYLE_BLEND_SOFT_LIGHT
                            => Keyword::SoftLight,
                        U8_NS_STYLE_BLEND_DIFFERENCE
                            => Keyword::Difference,
                        U8_NS_STYLE_BLEND_EXCLUSION
                            => Keyword::Exclusion,
                        U8_NS_STYLE_BLEND_HUE
                            => Keyword::Hue,
                        U8_NS_STYLE_BLEND_SATURATION
                            => Keyword::Saturation,
                        U8_NS_STYLE_BLEND_COLOR
                            => Keyword::Color,
                        U8_NS_STYLE_BLEND_LUMINOSITY
                            => Keyword::Luminosity,
                        _ => panic!("Found unexpected value in style struct for background_blend_mode property"),
                    }
                }).collect()
        )
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_background_color(&mut self, v: longhands::background_color::computed_value::T) {
        self.gecko.mBackgroundColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_background_color_from(&mut self, other: &Self) {
        self.gecko.mBackgroundColor = other.gecko.mBackgroundColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_background_color(&mut self, other: &Self) {
        self.copy_background_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_background_color(&self) -> longhands::background_color::computed_value::T {
        From::from(self.gecko.mBackgroundColor.clone())
    }


}




impl GeckoList {
    /*
     * Manually-Implemented Methods.
     */
    

    pub fn set_list_style_image(&mut self, image: longhands::list_style_image::computed_value::T) {
        match image {
            UrlOrNone::None => {
                unsafe {
                    Gecko_SetListStyleImageNone(&mut *self.gecko);
                }
            }
            UrlOrNone::Url(ref url) => {
                unsafe {
                    Gecko_SetListStyleImageImageValue(
                        &mut *self.gecko,
                        url.url_value_ptr(),
                    );
                }
            }
        }
    }

    pub fn copy_list_style_image_from(&mut self, other: &Self) {
        unsafe { Gecko_CopyListStyleImageFrom(&mut *self.gecko, &*other.gecko); }
    }

    pub fn reset_list_style_image(&mut self, other: &Self) {
        self.copy_list_style_image_from(other)
    }

    pub fn clone_list_style_image(&self) -> longhands::list_style_image::computed_value::T {
        use crate::values::computed::url::ComputedImageUrl;

        if self.gecko.mListStyleImage.mRawPtr.is_null() {
            return UrlOrNone::None;
        }

        unsafe {
            let ref gecko_image_request = *self.gecko.mListStyleImage.mRawPtr;
            UrlOrNone::Url(ComputedImageUrl::from_image_request(gecko_image_request))
        }
    }

    pub fn set_list_style_type(&mut self, v: longhands::list_style_type::computed_value::T) {
        use crate::gecko_bindings::bindings::Gecko_SetCounterStyleToString;
        use nsstring::{nsACString, nsCStr};
        use self::longhands::list_style_type::computed_value::T;
        match v {
            T::CounterStyle(s) => s.to_gecko_value(&mut self.gecko.mCounterStyle),
            T::String(s) => unsafe {
                Gecko_SetCounterStyleToString(&mut self.gecko.mCounterStyle,
                                              &nsCStr::from(&s) as &nsACString)
            }
        }
    }

    pub fn copy_list_style_type_from(&mut self, other: &Self) {
        unsafe {
            Gecko_CopyCounterStyle(&mut self.gecko.mCounterStyle, &other.gecko.mCounterStyle);
        }
    }

    pub fn reset_list_style_type(&mut self, other: &Self) {
        self.copy_list_style_type_from(other)
    }

    pub fn clone_list_style_type(&self) -> longhands::list_style_type::computed_value::T {
        use self::longhands::list_style_type::computed_value::T;
        use crate::values::Either;
        use crate::values::generics::CounterStyleOrNone;

        let result = CounterStyleOrNone::from_gecko_value(&self.gecko.mCounterStyle);
        match result {
            Either::First(counter_style) => T::CounterStyle(counter_style),
            Either::Second(string) => T::String(string),
        }
    }

    #[allow(non_snake_case)]
    pub fn set__moz_image_region(&mut self, v: longhands::_moz_image_region::computed_value::T) {
        use crate::values::Either;
        use crate::values::generics::length::LengthPercentageOrAuto::*;

        match v {
            Either::Second(_auto) => {
                self.gecko.mImageRegion.x = 0;
                self.gecko.mImageRegion.y = 0;
                self.gecko.mImageRegion.width = 0;
                self.gecko.mImageRegion.height = 0;
            }
            Either::First(rect) => {
                self.gecko.mImageRegion.x = match rect.left {
                    LengthPercentage(v) => v.to_i32_au(),
                    Auto => 0,
                };
                self.gecko.mImageRegion.y = match rect.top {
                    LengthPercentage(v) => v.to_i32_au(),
                    Auto => 0,
                };
                self.gecko.mImageRegion.height = match rect.bottom {
                    LengthPercentage(value) => (Au::from(value) - Au(self.gecko.mImageRegion.y)).0,
                    Auto => 0,
                };
                self.gecko.mImageRegion.width = match rect.right {
                    LengthPercentage(value) => (Au::from(value) - Au(self.gecko.mImageRegion.x)).0,
                    Auto => 0,
                };
            }
        }
    }

    #[allow(non_snake_case)]
    pub fn clone__moz_image_region(&self) -> longhands::_moz_image_region::computed_value::T {
        use crate::values::{Auto, Either};
        use crate::values::generics::length::LengthPercentageOrAuto::*;
        use crate::values::computed::ClipRect;

        // There is no ideal way to detect auto type for structs::nsRect and its components, so
        // if all components are zero, we use Auto.
        if self.gecko.mImageRegion.x == 0 &&
           self.gecko.mImageRegion.y == 0 &&
           self.gecko.mImageRegion.width == 0 &&
           self.gecko.mImageRegion.height == 0 {
           return Either::Second(Auto);
        }

        Either::First(ClipRect {
            top: LengthPercentage(Au(self.gecko.mImageRegion.y).into()),
            right: LengthPercentage(Au(self.gecko.mImageRegion.width + self.gecko.mImageRegion.x).into()),
            bottom: LengthPercentage(Au(self.gecko.mImageRegion.height + self.gecko.mImageRegion.y).into()),
            left: LengthPercentage(Au(self.gecko.mImageRegion.x).into()),
        })
    }

    
    #[allow(non_snake_case)]
    pub fn copy__moz_image_region_from(&mut self, other: &Self) {
        self.gecko.mImageRegion = other.gecko.mImageRegion.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_image_region(&mut self, other: &Self) {
        self.copy__moz_image_region_from(other)
    }




    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_list_style_position(&mut self, v: longhands::list_style_position::computed_value::T) {
        use crate::properties::longhands::list_style_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Outside =>
                    structs::NS_STYLE_LIST_STYLE_POSITION_OUTSIDE as u8,
                Keyword::Inside =>
                    structs::NS_STYLE_LIST_STYLE_POSITION_INSIDE as u8,
        };
        self.gecko.mListStylePosition = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_list_style_position_from(&mut self, other: &Self) {
        self.gecko.mListStylePosition = other.gecko.mListStylePosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_list_style_position(&mut self, other: &Self) {
        self.copy_list_style_position_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_list_style_position(&self) -> longhands::list_style_position::computed_value::T {
        use crate::properties::longhands::list_style_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_LIST_STYLE_POSITION_OUTSIDE : u8 =
            structs::NS_STYLE_LIST_STYLE_POSITION_OUTSIDE as u8;
        const U8_NS_STYLE_LIST_STYLE_POSITION_INSIDE : u8 =
            structs::NS_STYLE_LIST_STYLE_POSITION_INSIDE as u8;

        match self.gecko.mListStylePosition as u8 {
            U8_NS_STYLE_LIST_STYLE_POSITION_OUTSIDE => Keyword::Outside,
            U8_NS_STYLE_LIST_STYLE_POSITION_INSIDE => Keyword::Inside,
            _ => panic!("Found unexpected value in style struct for list_style_position property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_quotes(&mut self, v: longhands::quotes::computed_value::T) {
        self.gecko.mQuotes = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_quotes_from(&mut self, other: &Self) {
        self.gecko.mQuotes = other.gecko.mQuotes.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_quotes(&mut self, other: &Self) {
        self.copy_quotes_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_quotes(&self) -> longhands::quotes::computed_value::T {
        From::from(self.gecko.mQuotes.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_list_reversed(&mut self, v: longhands::_moz_list_reversed::computed_value::T) {
        self.gecko.mMozListReversed = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_list_reversed_from(&mut self, other: &Self) {
        self.gecko.mMozListReversed = other.gecko.mMozListReversed.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_list_reversed(&mut self, other: &Self) {
        self.copy__moz_list_reversed_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_list_reversed(&self) -> longhands::_moz_list_reversed::computed_value::T {
        From::from(self.gecko.mMozListReversed.clone())
    }


}




impl GeckoTable {
    /*
     * Manually-Implemented Methods.
     */
    
    #[allow(non_snake_case)]
    pub fn set__x_span(&mut self, v: longhands::_x_span::computed_value::T) {
        self.gecko.mSpan = v.0
    }

    #[allow(non_snake_case)]
    pub fn clone__x_span(&self) -> longhands::_x_span::computed_value::T {
        longhands::_x_span::computed_value::T(
            self.gecko.mSpan
        )
    }

    
    #[allow(non_snake_case)]
    pub fn copy__x_span_from(&mut self, other: &Self) {
        self.gecko.mSpan = other.gecko.mSpan.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__x_span(&mut self, other: &Self) {
        self.copy__x_span_from(other)
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_table_layout(&mut self, v: longhands::table_layout::computed_value::T) {
        use crate::properties::longhands::table_layout::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_TABLE_LAYOUT_AUTO as u8,
                Keyword::Fixed =>
                    structs::NS_STYLE_TABLE_LAYOUT_FIXED as u8,
        };
        self.gecko.mLayoutStrategy = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_table_layout_from(&mut self, other: &Self) {
        self.gecko.mLayoutStrategy = other.gecko.mLayoutStrategy.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_table_layout(&mut self, other: &Self) {
        self.copy_table_layout_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_table_layout(&self) -> longhands::table_layout::computed_value::T {
        use crate::properties::longhands::table_layout::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TABLE_LAYOUT_AUTO : u8 =
            structs::NS_STYLE_TABLE_LAYOUT_AUTO as u8;
        const U8_NS_STYLE_TABLE_LAYOUT_FIXED : u8 =
            structs::NS_STYLE_TABLE_LAYOUT_FIXED as u8;

        match self.gecko.mLayoutStrategy as u8 {
            U8_NS_STYLE_TABLE_LAYOUT_AUTO => Keyword::Auto,
            U8_NS_STYLE_TABLE_LAYOUT_FIXED => Keyword::Fixed,
            _ => panic!("Found unexpected value in style struct for table_layout property"),
        }
    }


}




impl GeckoEffects {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn set_clip(&mut self, v: longhands::clip::computed_value::T) {
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_AUTO;
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_RECT;
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_LEFT_AUTO;
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_TOP_AUTO;
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_RIGHT_AUTO;
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_BOTTOM_AUTO;
        use crate::values::generics::length::LengthPercentageOrAuto::*;
        use crate::values::Either;

        match v {
            Either::First(rect) => {
                self.gecko.mClipFlags = NS_STYLE_CLIP_RECT as u8;
                self.gecko.mClip.x = match rect.left {
                    LengthPercentage(l) => l.to_i32_au(),
                    Auto => {
                        self.gecko.mClipFlags |= NS_STYLE_CLIP_LEFT_AUTO as u8;
                        0
                    }
                };

                self.gecko.mClip.y = match rect.top {
                    LengthPercentage(l) => l.to_i32_au(),
                    Auto => {
                        self.gecko.mClipFlags |= NS_STYLE_CLIP_TOP_AUTO as u8;
                        0
                    }
                };

                self.gecko.mClip.height = match rect.bottom {
                    LengthPercentage(l) => (Au::from(l) - Au(self.gecko.mClip.y)).0,
                    Auto => {
                        self.gecko.mClipFlags |= NS_STYLE_CLIP_BOTTOM_AUTO as u8;
                        1 << 30 // NS_MAXSIZE
                    }
                };

                self.gecko.mClip.width = match rect.right {
                    LengthPercentage(l) => (Au::from(l) - Au(self.gecko.mClip.x)).0,
                    Auto => {
                        self.gecko.mClipFlags |= NS_STYLE_CLIP_RIGHT_AUTO as u8;
                        1 << 30 // NS_MAXSIZE
                    }
                };
            },
            Either::Second(_auto) => {
                self.gecko.mClipFlags = NS_STYLE_CLIP_AUTO as u8;
                self.gecko.mClip.x = 0;
                self.gecko.mClip.y = 0;
                self.gecko.mClip.width = 0;
                self.gecko.mClip.height = 0;
            }
        }
    }

    pub fn copy_clip_from(&mut self, other: &Self) {
        self.gecko.mClip = other.gecko.mClip;
        self.gecko.mClipFlags = other.gecko.mClipFlags;
    }

    pub fn reset_clip(&mut self, other: &Self) {
        self.copy_clip_from(other)
    }

    pub fn clone_clip(&self) -> longhands::clip::computed_value::T {
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_AUTO;
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_BOTTOM_AUTO;
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_LEFT_AUTO;
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_RIGHT_AUTO;
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_TOP_AUTO;
        use crate::values::generics::length::LengthPercentageOrAuto::*;
        use crate::values::computed::{ClipRect, ClipRectOrAuto};
        use crate::values::Either;

        if self.gecko.mClipFlags == NS_STYLE_CLIP_AUTO as u8 {
            return ClipRectOrAuto::auto()
        }
        let left = if self.gecko.mClipFlags & NS_STYLE_CLIP_LEFT_AUTO as u8 != 0 {
            debug_assert_eq!(self.gecko.mClip.x, 0);
            Auto
        } else {
            LengthPercentage(Au(self.gecko.mClip.x).into())
        };

        let top = if self.gecko.mClipFlags & NS_STYLE_CLIP_TOP_AUTO as u8 != 0 {
            debug_assert_eq!(self.gecko.mClip.y, 0);
            Auto
        } else {
            LengthPercentage(Au(self.gecko.mClip.y).into())
        };

        let bottom = if self.gecko.mClipFlags & NS_STYLE_CLIP_BOTTOM_AUTO as u8 != 0 {
            debug_assert_eq!(self.gecko.mClip.height, 1 << 30); // NS_MAXSIZE
            Auto
        } else {
            LengthPercentage(Au(self.gecko.mClip.y + self.gecko.mClip.height).into())
        };

        let right = if self.gecko.mClipFlags & NS_STYLE_CLIP_RIGHT_AUTO as u8 != 0 {
            debug_assert_eq!(self.gecko.mClip.width, 1 << 30); // NS_MAXSIZE
            Auto
        } else {
            LengthPercentage(Au(self.gecko.mClip.x + self.gecko.mClip.width).into())
        };

        Either::First(ClipRect { top, right, bottom, left })
    }

    

    pub fn set_filter<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = Filter>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::values::generics::effects::Filter::*;
        use crate::gecko_bindings::structs::nsStyleFilter;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_BLUR;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_BRIGHTNESS;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_CONTRAST;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_GRAYSCALE;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_INVERT;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_OPACITY;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_SATURATE;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_SEPIA;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_HUE_ROTATE;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_DROP_SHADOW;

        fn fill_filter(m_type: u32, value: CoordDataValue, gecko_filter: &mut nsStyleFilter){
            gecko_filter.mType = m_type;
            gecko_filter.mFilterParameter.set_value(value);
        }

        let v = v.into_iter();
        unsafe {
            Gecko_ResetFilters(&mut *self.gecko, v.len());
        }
        debug_assert_eq!(v.len(), self.gecko.mFilters.len());

        for (servo, gecko_filter) in v.zip(self.gecko.mFilters.iter_mut()) {
            match servo {
                Brightness(factor) => fill_filter(NS_STYLE_FILTER_BRIGHTNESS,
                                               CoordDataValue::Factor(factor.0),
                                               gecko_filter),
                Contrast(factor) => fill_filter(NS_STYLE_FILTER_CONTRAST,
                                               CoordDataValue::Factor(factor.0),
                                               gecko_filter),
                Grayscale(factor) => fill_filter(NS_STYLE_FILTER_GRAYSCALE,
                                               CoordDataValue::Factor(factor.0),
                                               gecko_filter),
                Invert(factor) => fill_filter(NS_STYLE_FILTER_INVERT,
                                               CoordDataValue::Factor(factor.0),
                                               gecko_filter),
                Opacity(factor) => fill_filter(NS_STYLE_FILTER_OPACITY,
                                               CoordDataValue::Factor(factor.0),
                                               gecko_filter),
                Saturate(factor) => fill_filter(NS_STYLE_FILTER_SATURATE,
                                               CoordDataValue::Factor(factor.0),
                                               gecko_filter),
                Sepia(factor) => fill_filter(NS_STYLE_FILTER_SEPIA,
                                               CoordDataValue::Factor(factor.0),
                                               gecko_filter),
                Blur(length) => fill_filter(NS_STYLE_FILTER_BLUR,
                                            CoordDataValue::Coord(length.0.to_i32_au()),
                                            gecko_filter),

                HueRotate(angle) => fill_filter(NS_STYLE_FILTER_HUE_ROTATE,
                                                CoordDataValue::from(angle),
                                                gecko_filter),

                DropShadow(shadow) => {
                    gecko_filter.mType = NS_STYLE_FILTER_DROP_SHADOW;
                    unsafe {
                        let ref mut union = gecko_filter.__bindgen_anon_1;
                        ptr::write(union.mDropShadow.as_mut(), shadow);
                    }
                },
                Url(ref url) => {
                    unsafe {
                        bindings::Gecko_nsStyleFilter_SetURLValue(gecko_filter, url.url_value_ptr());
                    }
                },
            }
        }
    }

    pub fn copy_filter_from(&mut self, other: &Self) {
        unsafe {
            Gecko_CopyFiltersFrom(&other.gecko as *const _ as *mut _, &mut *self.gecko);
        }
    }

    pub fn reset_filter(&mut self, other: &Self) {
        self.copy_filter_from(other)
    }

    pub fn clone_filter(&self) -> longhands::filter::computed_value::T {
        use crate::values::generics::effects::Filter;
        use crate::values::computed::url::ComputedUrl;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_BLUR;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_BRIGHTNESS;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_CONTRAST;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_GRAYSCALE;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_INVERT;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_OPACITY;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_SATURATE;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_SEPIA;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_HUE_ROTATE;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_DROP_SHADOW;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_URL;

        longhands::filter::computed_value::List(self.gecko.mFilters.iter().map(|filter| {
            match filter.mType {
                NS_STYLE_FILTER_BRIGHTNESS => {
                    Filter::Brightness(
                        GeckoStyleCoordConvertible::from_gecko_style_coord(
                            &filter.mFilterParameter
                        ).unwrap()
                    )
                },
                NS_STYLE_FILTER_CONTRAST => {
                    Filter::Contrast(
                        GeckoStyleCoordConvertible::from_gecko_style_coord(
                            &filter.mFilterParameter
                        ).unwrap()
                    )
                },
                NS_STYLE_FILTER_GRAYSCALE => {
                    Filter::Grayscale(
                        GeckoStyleCoordConvertible::from_gecko_style_coord(
                            &filter.mFilterParameter
                        ).unwrap()
                    )
                },
                NS_STYLE_FILTER_INVERT => {
                    Filter::Invert(
                        GeckoStyleCoordConvertible::from_gecko_style_coord(
                            &filter.mFilterParameter
                        ).unwrap()
                    )
                },
                NS_STYLE_FILTER_OPACITY => {
                    Filter::Opacity(
                        GeckoStyleCoordConvertible::from_gecko_style_coord(
                            &filter.mFilterParameter
                        ).unwrap()
                    )
                },
                NS_STYLE_FILTER_SATURATE => {
                    Filter::Saturate(
                        GeckoStyleCoordConvertible::from_gecko_style_coord(
                            &filter.mFilterParameter
                        ).unwrap()
                    )
                },
                NS_STYLE_FILTER_SEPIA => {
                    Filter::Sepia(
                        GeckoStyleCoordConvertible::from_gecko_style_coord(
                            &filter.mFilterParameter
                        ).unwrap()
                    )
                },
                NS_STYLE_FILTER_BLUR => {
                    Filter::Blur(NonNegativeLength::from_gecko_style_coord(
                        &filter.mFilterParameter
                    ).unwrap())
                },
                NS_STYLE_FILTER_HUE_ROTATE => {
                    Filter::HueRotate(GeckoStyleCoordConvertible::from_gecko_style_coord(
                        &filter.mFilterParameter,
                    ).unwrap())
                },
                NS_STYLE_FILTER_DROP_SHADOW => {
                    Filter::DropShadow(unsafe {
                        (*filter.__bindgen_anon_1.mDropShadow.as_ref()).clone()
                    })
                },
                NS_STYLE_FILTER_URL => {
                    Filter::Url(unsafe {
                        let url = RefPtr::new(*filter.__bindgen_anon_1.mURL.as_ref());
                        ComputedUrl::from_url_value(url)
                    })
                }
                _ => unreachable!("Unknown filter function?"),
            }
        }).collect())
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_opacity(&mut self, v: longhands::opacity::computed_value::T) {
        self.gecko.mOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_opacity_from(&mut self, other: &Self) {
        self.gecko.mOpacity = other.gecko.mOpacity.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_opacity(&mut self, other: &Self) {
        self.copy_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_opacity(&self) -> longhands::opacity::computed_value::T {
        From::from(self.gecko.mOpacity.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_box_shadow(&mut self, v: longhands::box_shadow::computed_value::T) {
        self.gecko.mBoxShadow = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_box_shadow_from(&mut self, other: &Self) {
        self.gecko.mBoxShadow = other.gecko.mBoxShadow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_box_shadow(&mut self, other: &Self) {
        self.copy_box_shadow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_box_shadow(&self) -> longhands::box_shadow::computed_value::T {
        From::from(self.gecko.mBoxShadow.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_mix_blend_mode(&mut self, v: longhands::mix_blend_mode::computed_value::T) {
        use crate::properties::longhands::mix_blend_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::NS_STYLE_BLEND_NORMAL as u8,
                Keyword::Multiply =>
                    structs::NS_STYLE_BLEND_MULTIPLY as u8,
                Keyword::Screen =>
                    structs::NS_STYLE_BLEND_SCREEN as u8,
                Keyword::Overlay =>
                    structs::NS_STYLE_BLEND_OVERLAY as u8,
                Keyword::Darken =>
                    structs::NS_STYLE_BLEND_DARKEN as u8,
                Keyword::Lighten =>
                    structs::NS_STYLE_BLEND_LIGHTEN as u8,
                Keyword::ColorDodge =>
                    structs::NS_STYLE_BLEND_COLOR_DODGE as u8,
                Keyword::ColorBurn =>
                    structs::NS_STYLE_BLEND_COLOR_BURN as u8,
                Keyword::HardLight =>
                    structs::NS_STYLE_BLEND_HARD_LIGHT as u8,
                Keyword::SoftLight =>
                    structs::NS_STYLE_BLEND_SOFT_LIGHT as u8,
                Keyword::Difference =>
                    structs::NS_STYLE_BLEND_DIFFERENCE as u8,
                Keyword::Exclusion =>
                    structs::NS_STYLE_BLEND_EXCLUSION as u8,
                Keyword::Hue =>
                    structs::NS_STYLE_BLEND_HUE as u8,
                Keyword::Saturation =>
                    structs::NS_STYLE_BLEND_SATURATION as u8,
                Keyword::Color =>
                    structs::NS_STYLE_BLEND_COLOR as u8,
                Keyword::Luminosity =>
                    structs::NS_STYLE_BLEND_LUMINOSITY as u8,
        };
        self.gecko.mMixBlendMode = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_mix_blend_mode_from(&mut self, other: &Self) {
        self.gecko.mMixBlendMode = other.gecko.mMixBlendMode.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_mix_blend_mode(&mut self, other: &Self) {
        self.copy_mix_blend_mode_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_mix_blend_mode(&self) -> longhands::mix_blend_mode::computed_value::T {
        use crate::properties::longhands::mix_blend_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_BLEND_NORMAL : u8 =
            structs::NS_STYLE_BLEND_NORMAL as u8;
        const U8_NS_STYLE_BLEND_MULTIPLY : u8 =
            structs::NS_STYLE_BLEND_MULTIPLY as u8;
        const U8_NS_STYLE_BLEND_SCREEN : u8 =
            structs::NS_STYLE_BLEND_SCREEN as u8;
        const U8_NS_STYLE_BLEND_OVERLAY : u8 =
            structs::NS_STYLE_BLEND_OVERLAY as u8;
        const U8_NS_STYLE_BLEND_DARKEN : u8 =
            structs::NS_STYLE_BLEND_DARKEN as u8;
        const U8_NS_STYLE_BLEND_LIGHTEN : u8 =
            structs::NS_STYLE_BLEND_LIGHTEN as u8;
        const U8_NS_STYLE_BLEND_COLOR_DODGE : u8 =
            structs::NS_STYLE_BLEND_COLOR_DODGE as u8;
        const U8_NS_STYLE_BLEND_COLOR_BURN : u8 =
            structs::NS_STYLE_BLEND_COLOR_BURN as u8;
        const U8_NS_STYLE_BLEND_HARD_LIGHT : u8 =
            structs::NS_STYLE_BLEND_HARD_LIGHT as u8;
        const U8_NS_STYLE_BLEND_SOFT_LIGHT : u8 =
            structs::NS_STYLE_BLEND_SOFT_LIGHT as u8;
        const U8_NS_STYLE_BLEND_DIFFERENCE : u8 =
            structs::NS_STYLE_BLEND_DIFFERENCE as u8;
        const U8_NS_STYLE_BLEND_EXCLUSION : u8 =
            structs::NS_STYLE_BLEND_EXCLUSION as u8;
        const U8_NS_STYLE_BLEND_HUE : u8 =
            structs::NS_STYLE_BLEND_HUE as u8;
        const U8_NS_STYLE_BLEND_SATURATION : u8 =
            structs::NS_STYLE_BLEND_SATURATION as u8;
        const U8_NS_STYLE_BLEND_COLOR : u8 =
            structs::NS_STYLE_BLEND_COLOR as u8;
        const U8_NS_STYLE_BLEND_LUMINOSITY : u8 =
            structs::NS_STYLE_BLEND_LUMINOSITY as u8;

        match self.gecko.mMixBlendMode as u8 {
            U8_NS_STYLE_BLEND_NORMAL => Keyword::Normal,
            U8_NS_STYLE_BLEND_MULTIPLY => Keyword::Multiply,
            U8_NS_STYLE_BLEND_SCREEN => Keyword::Screen,
            U8_NS_STYLE_BLEND_OVERLAY => Keyword::Overlay,
            U8_NS_STYLE_BLEND_DARKEN => Keyword::Darken,
            U8_NS_STYLE_BLEND_LIGHTEN => Keyword::Lighten,
            U8_NS_STYLE_BLEND_COLOR_DODGE => Keyword::ColorDodge,
            U8_NS_STYLE_BLEND_COLOR_BURN => Keyword::ColorBurn,
            U8_NS_STYLE_BLEND_HARD_LIGHT => Keyword::HardLight,
            U8_NS_STYLE_BLEND_SOFT_LIGHT => Keyword::SoftLight,
            U8_NS_STYLE_BLEND_DIFFERENCE => Keyword::Difference,
            U8_NS_STYLE_BLEND_EXCLUSION => Keyword::Exclusion,
            U8_NS_STYLE_BLEND_HUE => Keyword::Hue,
            U8_NS_STYLE_BLEND_SATURATION => Keyword::Saturation,
            U8_NS_STYLE_BLEND_COLOR => Keyword::Color,
            U8_NS_STYLE_BLEND_LUMINOSITY => Keyword::Luminosity,
            _ => panic!("Found unexpected value in style struct for mix_blend_mode property"),
        }
    }


}




impl GeckoInheritedBox {
    /*
     * Manually-Implemented Methods.
     */
    


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_visibility(&mut self, v: longhands::visibility::computed_value::T) {
        use crate::properties::longhands::visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Visible =>
                    structs::NS_STYLE_VISIBILITY_VISIBLE as u8,
                Keyword::Hidden =>
                    structs::NS_STYLE_VISIBILITY_HIDDEN as u8,
                Keyword::Collapse =>
                    structs::NS_STYLE_VISIBILITY_COLLAPSE as u8,
        };
        self.gecko.mVisible = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_visibility_from(&mut self, other: &Self) {
        self.gecko.mVisible = other.gecko.mVisible.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_visibility(&mut self, other: &Self) {
        self.copy_visibility_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_visibility(&self) -> longhands::visibility::computed_value::T {
        use crate::properties::longhands::visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_VISIBILITY_VISIBLE : u8 =
            structs::NS_STYLE_VISIBILITY_VISIBLE as u8;
        const U8_NS_STYLE_VISIBILITY_HIDDEN : u8 =
            structs::NS_STYLE_VISIBILITY_HIDDEN as u8;
        const U8_NS_STYLE_VISIBILITY_COLLAPSE : u8 =
            structs::NS_STYLE_VISIBILITY_COLLAPSE as u8;

        match self.gecko.mVisible as u8 {
            U8_NS_STYLE_VISIBILITY_VISIBLE => Keyword::Visible,
            U8_NS_STYLE_VISIBILITY_HIDDEN => Keyword::Hidden,
            U8_NS_STYLE_VISIBILITY_COLLAPSE => Keyword::Collapse,
            _ => panic!("Found unexpected value in style struct for visibility property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_writing_mode(&mut self, v: longhands::writing_mode::computed_value::T) {
        use crate::properties::longhands::writing_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::HorizontalTb =>
                    structs::NS_STYLE_WRITING_MODE_HORIZONTAL_TB as u8,
                Keyword::VerticalRl =>
                    structs::NS_STYLE_WRITING_MODE_VERTICAL_RL as u8,
                Keyword::VerticalLr =>
                    structs::NS_STYLE_WRITING_MODE_VERTICAL_LR as u8,
                Keyword::SidewaysRl =>
                    structs::NS_STYLE_WRITING_MODE_SIDEWAYS_RL as u8,
                Keyword::SidewaysLr =>
                    structs::NS_STYLE_WRITING_MODE_SIDEWAYS_LR as u8,
        };
        self.gecko.mWritingMode = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_writing_mode_from(&mut self, other: &Self) {
        self.gecko.mWritingMode = other.gecko.mWritingMode.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_writing_mode(&mut self, other: &Self) {
        self.copy_writing_mode_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_writing_mode(&self) -> longhands::writing_mode::computed_value::T {
        use crate::properties::longhands::writing_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_WRITING_MODE_HORIZONTAL_TB : u8 =
            structs::NS_STYLE_WRITING_MODE_HORIZONTAL_TB as u8;
        const U8_NS_STYLE_WRITING_MODE_VERTICAL_RL : u8 =
            structs::NS_STYLE_WRITING_MODE_VERTICAL_RL as u8;
        const U8_NS_STYLE_WRITING_MODE_VERTICAL_LR : u8 =
            structs::NS_STYLE_WRITING_MODE_VERTICAL_LR as u8;
        const U8_NS_STYLE_WRITING_MODE_SIDEWAYS_RL : u8 =
            structs::NS_STYLE_WRITING_MODE_SIDEWAYS_RL as u8;
        const U8_NS_STYLE_WRITING_MODE_SIDEWAYS_LR : u8 =
            structs::NS_STYLE_WRITING_MODE_SIDEWAYS_LR as u8;

        match self.gecko.mWritingMode as u8 {
            U8_NS_STYLE_WRITING_MODE_HORIZONTAL_TB => Keyword::HorizontalTb,
            U8_NS_STYLE_WRITING_MODE_VERTICAL_RL => Keyword::VerticalRl,
            U8_NS_STYLE_WRITING_MODE_VERTICAL_LR => Keyword::VerticalLr,
            U8_NS_STYLE_WRITING_MODE_SIDEWAYS_RL => Keyword::SidewaysRl,
            U8_NS_STYLE_WRITING_MODE_SIDEWAYS_LR => Keyword::SidewaysLr,
            _ => panic!("Found unexpected value in style struct for writing_mode property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_direction(&mut self, v: longhands::direction::computed_value::T) {
        use crate::properties::longhands::direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Ltr =>
                    structs::NS_STYLE_DIRECTION_LTR as u8,
                Keyword::Rtl =>
                    structs::NS_STYLE_DIRECTION_RTL as u8,
        };
        self.gecko.mDirection = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_direction_from(&mut self, other: &Self) {
        self.gecko.mDirection = other.gecko.mDirection.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_direction(&mut self, other: &Self) {
        self.copy_direction_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_direction(&self) -> longhands::direction::computed_value::T {
        use crate::properties::longhands::direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_DIRECTION_LTR : u8 =
            structs::NS_STYLE_DIRECTION_LTR as u8;
        const U8_NS_STYLE_DIRECTION_RTL : u8 =
            structs::NS_STYLE_DIRECTION_RTL as u8;

        match self.gecko.mDirection as u8 {
            U8_NS_STYLE_DIRECTION_LTR => Keyword::Ltr,
            U8_NS_STYLE_DIRECTION_RTL => Keyword::Rtl,
            _ => panic!("Found unexpected value in style struct for direction property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_orientation(&mut self, v: longhands::text_orientation::computed_value::T) {
        use crate::properties::longhands::text_orientation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Mixed =>
                    structs::NS_STYLE_TEXT_ORIENTATION_MIXED as u8,
                Keyword::Upright =>
                    structs::NS_STYLE_TEXT_ORIENTATION_UPRIGHT as u8,
                Keyword::Sideways =>
                    structs::NS_STYLE_TEXT_ORIENTATION_SIDEWAYS as u8,
        };
        self.gecko.mTextOrientation = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_orientation_from(&mut self, other: &Self) {
        self.gecko.mTextOrientation = other.gecko.mTextOrientation.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_orientation(&mut self, other: &Self) {
        self.copy_text_orientation_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_text_orientation(&self) -> longhands::text_orientation::computed_value::T {
        use crate::properties::longhands::text_orientation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TEXT_ORIENTATION_MIXED : u8 =
            structs::NS_STYLE_TEXT_ORIENTATION_MIXED as u8;
        const U8_NS_STYLE_TEXT_ORIENTATION_UPRIGHT : u8 =
            structs::NS_STYLE_TEXT_ORIENTATION_UPRIGHT as u8;
        const U8_NS_STYLE_TEXT_ORIENTATION_SIDEWAYS : u8 =
            structs::NS_STYLE_TEXT_ORIENTATION_SIDEWAYS as u8;

        match self.gecko.mTextOrientation as u8 {
            U8_NS_STYLE_TEXT_ORIENTATION_MIXED => Keyword::Mixed,
            U8_NS_STYLE_TEXT_ORIENTATION_UPRIGHT => Keyword::Upright,
            U8_NS_STYLE_TEXT_ORIENTATION_SIDEWAYS => Keyword::Sideways,
            _ => panic!("Found unexpected value in style struct for text_orientation property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_color_adjust(&mut self, v: longhands::color_adjust::computed_value::T) {
        use crate::properties::longhands::color_adjust::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Economy =>
                    structs::StyleColorAdjust::Economy ,
                Keyword::Exact =>
                    structs::StyleColorAdjust::Exact ,
        };
        self.gecko.mColorAdjust = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_color_adjust_from(&mut self, other: &Self) {
        self.gecko.mColorAdjust = other.gecko.mColorAdjust.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_color_adjust(&mut self, other: &Self) {
        self.copy_color_adjust_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_color_adjust(&self) -> longhands::color_adjust::computed_value::T {
        use crate::properties::longhands::color_adjust::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mColorAdjust {
            structs::StyleColorAdjust::Economy => Keyword::Economy,
            structs::StyleColorAdjust::Exact => Keyword::Exact,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_image_rendering(&mut self, v: longhands::image_rendering::computed_value::T) {
        use crate::properties::longhands::image_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_IMAGE_RENDERING_AUTO as u8,
                Keyword::CrispEdges =>
                    structs::NS_STYLE_IMAGE_RENDERING_CRISP_EDGES as u8,
                Keyword::Optimizespeed =>
                    structs::NS_STYLE_IMAGE_RENDERING_OPTIMIZESPEED as u8,
                Keyword::Optimizequality =>
                    structs::NS_STYLE_IMAGE_RENDERING_OPTIMIZEQUALITY as u8,
        };
        self.gecko.mImageRendering = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_image_rendering_from(&mut self, other: &Self) {
        self.gecko.mImageRendering = other.gecko.mImageRendering.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_image_rendering(&mut self, other: &Self) {
        self.copy_image_rendering_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_image_rendering(&self) -> longhands::image_rendering::computed_value::T {
        use crate::properties::longhands::image_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_IMAGE_RENDERING_AUTO : u8 =
            structs::NS_STYLE_IMAGE_RENDERING_AUTO as u8;
        const U8_NS_STYLE_IMAGE_RENDERING_CRISP_EDGES : u8 =
            structs::NS_STYLE_IMAGE_RENDERING_CRISP_EDGES as u8;
        const U8_NS_STYLE_IMAGE_RENDERING_OPTIMIZESPEED : u8 =
            structs::NS_STYLE_IMAGE_RENDERING_OPTIMIZESPEED as u8;
        const U8_NS_STYLE_IMAGE_RENDERING_OPTIMIZEQUALITY : u8 =
            structs::NS_STYLE_IMAGE_RENDERING_OPTIMIZEQUALITY as u8;

        match self.gecko.mImageRendering as u8 {
            U8_NS_STYLE_IMAGE_RENDERING_AUTO => Keyword::Auto,
            U8_NS_STYLE_IMAGE_RENDERING_CRISP_EDGES => Keyword::CrispEdges,
            U8_NS_STYLE_IMAGE_RENDERING_OPTIMIZESPEED => Keyword::Optimizespeed,
            U8_NS_STYLE_IMAGE_RENDERING_OPTIMIZEQUALITY => Keyword::Optimizequality,
            _ => panic!("Found unexpected value in style struct for image_rendering property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_image_orientation(&mut self, v: longhands::image_orientation::computed_value::T) {
        use crate::properties::longhands::image_orientation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleImageOrientation::None ,
                Keyword::FromImage =>
                    structs::StyleImageOrientation::FromImage ,
        };
        self.gecko.mImageOrientation = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_image_orientation_from(&mut self, other: &Self) {
        self.gecko.mImageOrientation = other.gecko.mImageOrientation.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_image_orientation(&mut self, other: &Self) {
        self.copy_image_orientation_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_image_orientation(&self) -> longhands::image_orientation::computed_value::T {
        use crate::properties::longhands::image_orientation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mImageOrientation {
            structs::StyleImageOrientation::None => Keyword::None,
            structs::StyleImageOrientation::FromImage => Keyword::FromImage,
        }
    }


}




impl GeckoInheritedTable {
    /*
     * Manually-Implemented Methods.
     */
    

    pub fn set_border_spacing(&mut self, v: longhands::border_spacing::computed_value::T) {
        self.gecko.mBorderSpacingCol = v.horizontal().0;
        self.gecko.mBorderSpacingRow = v.vertical().0;
    }

    pub fn copy_border_spacing_from(&mut self, other: &Self) {
        self.gecko.mBorderSpacingCol = other.gecko.mBorderSpacingCol;
        self.gecko.mBorderSpacingRow = other.gecko.mBorderSpacingRow;
    }

    pub fn reset_border_spacing(&mut self, other: &Self) {
        self.copy_border_spacing_from(other)
    }

    pub fn clone_border_spacing(&self) -> longhands::border_spacing::computed_value::T {
        longhands::border_spacing::computed_value::T::new(
            Au(self.gecko.mBorderSpacingCol).into(),
            Au(self.gecko.mBorderSpacingRow).into()
        )
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_border_collapse(&mut self, v: longhands::border_collapse::computed_value::T) {
        use crate::properties::longhands::border_collapse::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Separate =>
                    structs::StyleBorderCollapse::Separate ,
                Keyword::Collapse =>
                    structs::StyleBorderCollapse::Collapse ,
        };
        self.gecko.mBorderCollapse = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_border_collapse_from(&mut self, other: &Self) {
        self.gecko.mBorderCollapse = other.gecko.mBorderCollapse.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_collapse(&mut self, other: &Self) {
        self.copy_border_collapse_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_border_collapse(&self) -> longhands::border_collapse::computed_value::T {
        use crate::properties::longhands::border_collapse::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBorderCollapse {
            structs::StyleBorderCollapse::Separate => Keyword::Separate,
            structs::StyleBorderCollapse::Collapse => Keyword::Collapse,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_empty_cells(&mut self, v: longhands::empty_cells::computed_value::T) {
        use crate::properties::longhands::empty_cells::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Show =>
                    structs::NS_STYLE_TABLE_EMPTY_CELLS_SHOW as u8,
                Keyword::Hide =>
                    structs::NS_STYLE_TABLE_EMPTY_CELLS_HIDE as u8,
        };
        self.gecko.mEmptyCells = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_empty_cells_from(&mut self, other: &Self) {
        self.gecko.mEmptyCells = other.gecko.mEmptyCells.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_empty_cells(&mut self, other: &Self) {
        self.copy_empty_cells_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_empty_cells(&self) -> longhands::empty_cells::computed_value::T {
        use crate::properties::longhands::empty_cells::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TABLE_EMPTY_CELLS_SHOW : u8 =
            structs::NS_STYLE_TABLE_EMPTY_CELLS_SHOW as u8;
        const U8_NS_STYLE_TABLE_EMPTY_CELLS_HIDE : u8 =
            structs::NS_STYLE_TABLE_EMPTY_CELLS_HIDE as u8;

        match self.gecko.mEmptyCells as u8 {
            U8_NS_STYLE_TABLE_EMPTY_CELLS_SHOW => Keyword::Show,
            U8_NS_STYLE_TABLE_EMPTY_CELLS_HIDE => Keyword::Hide,
            _ => panic!("Found unexpected value in style struct for empty_cells property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_caption_side(&mut self, v: longhands::caption_side::computed_value::T) {
        use crate::properties::longhands::caption_side::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Top =>
                    structs::NS_STYLE_CAPTION_SIDE_TOP as u8,
                Keyword::Bottom =>
                    structs::NS_STYLE_CAPTION_SIDE_BOTTOM as u8,
                Keyword::Right =>
                    structs::NS_STYLE_CAPTION_SIDE_RIGHT as u8,
                Keyword::Left =>
                    structs::NS_STYLE_CAPTION_SIDE_LEFT as u8,
                Keyword::TopOutside =>
                    structs::NS_STYLE_CAPTION_SIDE_TOP_OUTSIDE as u8,
                Keyword::BottomOutside =>
                    structs::NS_STYLE_CAPTION_SIDE_BOTTOM_OUTSIDE as u8,
        };
        self.gecko.mCaptionSide = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_caption_side_from(&mut self, other: &Self) {
        self.gecko.mCaptionSide = other.gecko.mCaptionSide.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_caption_side(&mut self, other: &Self) {
        self.copy_caption_side_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_caption_side(&self) -> longhands::caption_side::computed_value::T {
        use crate::properties::longhands::caption_side::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_CAPTION_SIDE_TOP : u8 =
            structs::NS_STYLE_CAPTION_SIDE_TOP as u8;
        const U8_NS_STYLE_CAPTION_SIDE_BOTTOM : u8 =
            structs::NS_STYLE_CAPTION_SIDE_BOTTOM as u8;
        const U8_NS_STYLE_CAPTION_SIDE_RIGHT : u8 =
            structs::NS_STYLE_CAPTION_SIDE_RIGHT as u8;
        const U8_NS_STYLE_CAPTION_SIDE_LEFT : u8 =
            structs::NS_STYLE_CAPTION_SIDE_LEFT as u8;
        const U8_NS_STYLE_CAPTION_SIDE_TOP_OUTSIDE : u8 =
            structs::NS_STYLE_CAPTION_SIDE_TOP_OUTSIDE as u8;
        const U8_NS_STYLE_CAPTION_SIDE_BOTTOM_OUTSIDE : u8 =
            structs::NS_STYLE_CAPTION_SIDE_BOTTOM_OUTSIDE as u8;

        match self.gecko.mCaptionSide as u8 {
            U8_NS_STYLE_CAPTION_SIDE_TOP => Keyword::Top,
            U8_NS_STYLE_CAPTION_SIDE_BOTTOM => Keyword::Bottom,
            U8_NS_STYLE_CAPTION_SIDE_RIGHT => Keyword::Right,
            U8_NS_STYLE_CAPTION_SIDE_LEFT => Keyword::Left,
            U8_NS_STYLE_CAPTION_SIDE_TOP_OUTSIDE => Keyword::TopOutside,
            U8_NS_STYLE_CAPTION_SIDE_BOTTOM_OUTSIDE => Keyword::BottomOutside,
            _ => panic!("Found unexpected value in style struct for caption_side property"),
        }
    }


}





impl GeckoInheritedText {
    /*
     * Manually-Implemented Methods.
     */
    

    
    

    #[allow(non_snake_case)]
    pub fn set_text_align(&mut self, v: longhands::text_align::computed_value::T) {
        use crate::properties::longhands::text_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Start =>
                    structs::NS_STYLE_TEXT_ALIGN_START as u8,
                Keyword::End =>
                    structs::NS_STYLE_TEXT_ALIGN_END as u8,
                Keyword::Left =>
                    structs::NS_STYLE_TEXT_ALIGN_LEFT as u8,
                Keyword::Right =>
                    structs::NS_STYLE_TEXT_ALIGN_RIGHT as u8,
                Keyword::Center =>
                    structs::NS_STYLE_TEXT_ALIGN_CENTER as u8,
                Keyword::Justify =>
                    structs::NS_STYLE_TEXT_ALIGN_JUSTIFY as u8,
                Keyword::MozCenter =>
                    structs::NS_STYLE_TEXT_ALIGN_MOZ_CENTER as u8,
                Keyword::MozLeft =>
                    structs::NS_STYLE_TEXT_ALIGN_MOZ_LEFT as u8,
                Keyword::MozRight =>
                    structs::NS_STYLE_TEXT_ALIGN_MOZ_RIGHT as u8,
                Keyword::Char =>
                    structs::NS_STYLE_TEXT_ALIGN_CHAR as u8,
        };
        self.gecko.mTextAlign = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_align_from(&mut self, other: &Self) {
        self.gecko.mTextAlign = other.gecko.mTextAlign.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_align(&mut self, other: &Self) {
        self.copy_text_align_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_text_align(&self) -> longhands::text_align::computed_value::T {
        use crate::properties::longhands::text_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TEXT_ALIGN_START : u8 =
            structs::NS_STYLE_TEXT_ALIGN_START as u8;
        const U8_NS_STYLE_TEXT_ALIGN_END : u8 =
            structs::NS_STYLE_TEXT_ALIGN_END as u8;
        const U8_NS_STYLE_TEXT_ALIGN_LEFT : u8 =
            structs::NS_STYLE_TEXT_ALIGN_LEFT as u8;
        const U8_NS_STYLE_TEXT_ALIGN_RIGHT : u8 =
            structs::NS_STYLE_TEXT_ALIGN_RIGHT as u8;
        const U8_NS_STYLE_TEXT_ALIGN_CENTER : u8 =
            structs::NS_STYLE_TEXT_ALIGN_CENTER as u8;
        const U8_NS_STYLE_TEXT_ALIGN_JUSTIFY : u8 =
            structs::NS_STYLE_TEXT_ALIGN_JUSTIFY as u8;
        const U8_NS_STYLE_TEXT_ALIGN_MOZ_CENTER : u8 =
            structs::NS_STYLE_TEXT_ALIGN_MOZ_CENTER as u8;
        const U8_NS_STYLE_TEXT_ALIGN_MOZ_LEFT : u8 =
            structs::NS_STYLE_TEXT_ALIGN_MOZ_LEFT as u8;
        const U8_NS_STYLE_TEXT_ALIGN_MOZ_RIGHT : u8 =
            structs::NS_STYLE_TEXT_ALIGN_MOZ_RIGHT as u8;
        const U8_NS_STYLE_TEXT_ALIGN_CHAR : u8 =
            structs::NS_STYLE_TEXT_ALIGN_CHAR as u8;

        match self.gecko.mTextAlign as u8 {
            U8_NS_STYLE_TEXT_ALIGN_START => Keyword::Start,
            U8_NS_STYLE_TEXT_ALIGN_END => Keyword::End,
            U8_NS_STYLE_TEXT_ALIGN_LEFT => Keyword::Left,
            U8_NS_STYLE_TEXT_ALIGN_RIGHT => Keyword::Right,
            U8_NS_STYLE_TEXT_ALIGN_CENTER => Keyword::Center,
            U8_NS_STYLE_TEXT_ALIGN_JUSTIFY => Keyword::Justify,
            U8_NS_STYLE_TEXT_ALIGN_MOZ_CENTER => Keyword::MozCenter,
            U8_NS_STYLE_TEXT_ALIGN_MOZ_LEFT => Keyword::MozLeft,
            U8_NS_STYLE_TEXT_ALIGN_MOZ_RIGHT => Keyword::MozRight,
            U8_NS_STYLE_TEXT_ALIGN_CHAR => Keyword::Char,
            _ => panic!("Found unexpected value in style struct for text_align property"),
        }
    }



    fn clear_text_emphasis_style_if_string(&mut self) {
        if self.gecko.mTextEmphasisStyle == structs::NS_STYLE_TEXT_EMPHASIS_STYLE_STRING as u8 {
            self.gecko.mTextEmphasisStyleString.truncate();
            self.gecko.mTextEmphasisStyle = structs::NS_STYLE_TEXT_EMPHASIS_STYLE_NONE as u8;
        }
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_text_emphasis_position(&mut self, v: longhands::text_emphasis_position::computed_value::T) {
        self.gecko.mTextEmphasisPosition = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_text_emphasis_position_from(&mut self, other: &Self) {
        self.gecko.mTextEmphasisPosition = other.gecko.mTextEmphasisPosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_emphasis_position(&mut self, other: &Self) {
        self.copy_text_emphasis_position_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_emphasis_position(&self) -> longhands::text_emphasis_position::computed_value::T {
        From::from(self.gecko.mTextEmphasisPosition)
    }


    pub fn set_text_emphasis_style(&mut self, v: values::computed::TextEmphasisStyle) {
        use crate::values::computed::TextEmphasisStyle;
        use crate::values::specified::text::{TextEmphasisFillMode, TextEmphasisShapeKeyword};

        self.clear_text_emphasis_style_if_string();
        let (te, s) = match v {
            TextEmphasisStyle::None => (structs::NS_STYLE_TEXT_EMPHASIS_STYLE_NONE, ""),
            TextEmphasisStyle::Keyword(ref keyword) => {
                let fill = match keyword.fill {
                    TextEmphasisFillMode::Filled => structs::NS_STYLE_TEXT_EMPHASIS_STYLE_FILLED,
                    TextEmphasisFillMode::Open => structs::NS_STYLE_TEXT_EMPHASIS_STYLE_OPEN,
                };
                let shape = match keyword.shape {
                    TextEmphasisShapeKeyword::Dot => structs::NS_STYLE_TEXT_EMPHASIS_STYLE_DOT,
                    TextEmphasisShapeKeyword::Circle => structs::NS_STYLE_TEXT_EMPHASIS_STYLE_CIRCLE,
                    TextEmphasisShapeKeyword::DoubleCircle => structs::NS_STYLE_TEXT_EMPHASIS_STYLE_DOUBLE_CIRCLE,
                    TextEmphasisShapeKeyword::Triangle => structs::NS_STYLE_TEXT_EMPHASIS_STYLE_TRIANGLE,
                    TextEmphasisShapeKeyword::Sesame => structs::NS_STYLE_TEXT_EMPHASIS_STYLE_SESAME,
                };

                (shape | fill, keyword.shape.char(keyword.fill))
            },
            TextEmphasisStyle::String(ref s) => {
                (structs::NS_STYLE_TEXT_EMPHASIS_STYLE_STRING, &**s)
            },
        };
        self.gecko.mTextEmphasisStyleString.assign_str(s);
        self.gecko.mTextEmphasisStyle = te as u8;
    }

    pub fn copy_text_emphasis_style_from(&mut self, other: &Self) {
        self.clear_text_emphasis_style_if_string();
        if other.gecko.mTextEmphasisStyle == structs::NS_STYLE_TEXT_EMPHASIS_STYLE_STRING as u8 {
            self.gecko.mTextEmphasisStyleString
                      .assign(&*other.gecko.mTextEmphasisStyleString)
        }
        self.gecko.mTextEmphasisStyle = other.gecko.mTextEmphasisStyle;
    }

    pub fn reset_text_emphasis_style(&mut self, other: &Self) {
        self.copy_text_emphasis_style_from(other)
    }

    pub fn clone_text_emphasis_style(&self) -> values::computed::TextEmphasisStyle {
        use crate::values::computed::TextEmphasisStyle;
        use crate::values::computed::text::TextEmphasisKeywordValue;
        use crate::values::specified::text::{TextEmphasisFillMode, TextEmphasisShapeKeyword};

        if self.gecko.mTextEmphasisStyle == structs::NS_STYLE_TEXT_EMPHASIS_STYLE_NONE as u8 {
            return TextEmphasisStyle::None;
        }

        if self.gecko.mTextEmphasisStyle == structs::NS_STYLE_TEXT_EMPHASIS_STYLE_STRING as u8 {
            return TextEmphasisStyle::String(self.gecko.mTextEmphasisStyleString.to_string());
        }

        let fill =
            self.gecko.mTextEmphasisStyle & structs::NS_STYLE_TEXT_EMPHASIS_STYLE_OPEN as u8 == 0;

        let fill = if fill { TextEmphasisFillMode::Filled } else { TextEmphasisFillMode::Open };

        let shape =
            match self.gecko.mTextEmphasisStyle as u32 & !structs::NS_STYLE_TEXT_EMPHASIS_STYLE_OPEN {
                structs::NS_STYLE_TEXT_EMPHASIS_STYLE_DOT => TextEmphasisShapeKeyword::Dot,
                structs::NS_STYLE_TEXT_EMPHASIS_STYLE_CIRCLE => TextEmphasisShapeKeyword::Circle,
                structs::NS_STYLE_TEXT_EMPHASIS_STYLE_DOUBLE_CIRCLE => TextEmphasisShapeKeyword::DoubleCircle,
                structs::NS_STYLE_TEXT_EMPHASIS_STYLE_TRIANGLE => TextEmphasisShapeKeyword::Triangle,
                structs::NS_STYLE_TEXT_EMPHASIS_STYLE_SESAME => TextEmphasisShapeKeyword::Sesame,
                _ => panic!("Unexpected value in style struct for text-emphasis-style property")
            };

        TextEmphasisStyle::Keyword(TextEmphasisKeywordValue { fill, shape })
    }

    
    #[allow(non_snake_case)]
    pub fn set__webkit_text_stroke_width(&mut self, v: longhands::_webkit_text_stroke_width::computed_value::T) {
        let value = {
            v.0.to_i32_au()
        };

        self.gecko.mWebkitTextStrokeWidth = value;
    }

    #[allow(non_snake_case)]
    pub fn copy__webkit_text_stroke_width_from(&mut self, other: &Self) {
        self.gecko.mWebkitTextStrokeWidth = other.gecko.mWebkitTextStrokeWidth;
    }

    #[allow(non_snake_case)]
    pub fn reset__webkit_text_stroke_width(&mut self, other: &Self) {
        self.copy__webkit_text_stroke_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__webkit_text_stroke_width(&self) -> longhands::_webkit_text_stroke_width::computed_value::T {
        Au(self.gecko.mWebkitTextStrokeWidth).into()
    }




    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_line_height(&mut self, v: longhands::line_height::computed_value::T) {
        self.gecko.mLineHeight = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_line_height_from(&mut self, other: &Self) {
        self.gecko.mLineHeight = other.gecko.mLineHeight.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_line_height(&mut self, other: &Self) {
        self.copy_line_height_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_line_height(&self) -> longhands::line_height::computed_value::T {
        From::from(self.gecko.mLineHeight.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_transform(&mut self, v: longhands::text_transform::computed_value::T) {
        self.gecko.mTextTransform = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_transform_from(&mut self, other: &Self) {
        self.gecko.mTextTransform = other.gecko.mTextTransform.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_transform(&mut self, other: &Self) {
        self.copy_text_transform_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_transform(&self) -> longhands::text_transform::computed_value::T {
        From::from(self.gecko.mTextTransform.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_hyphens(&mut self, v: longhands::hyphens::computed_value::T) {
        use crate::properties::longhands::hyphens::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Manual =>
                    structs::StyleHyphens::Manual ,
                Keyword::None =>
                    structs::StyleHyphens::None ,
                Keyword::Auto =>
                    structs::StyleHyphens::Auto ,
        };
        self.gecko.mHyphens = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_hyphens_from(&mut self, other: &Self) {
        self.gecko.mHyphens = other.gecko.mHyphens.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_hyphens(&mut self, other: &Self) {
        self.copy_hyphens_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_hyphens(&self) -> longhands::hyphens::computed_value::T {
        use crate::properties::longhands::hyphens::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mHyphens {
            structs::StyleHyphens::Manual => Keyword::Manual,
            structs::StyleHyphens::None => Keyword::None,
            structs::StyleHyphens::Auto => Keyword::Auto,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_text_size_adjust(&mut self, v: longhands::_moz_text_size_adjust::computed_value::T) {
        use crate::properties::longhands::_moz_text_size_adjust::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_TEXT_SIZE_ADJUST_AUTO as u8,
                Keyword::None =>
                    structs::NS_STYLE_TEXT_SIZE_ADJUST_NONE as u8,
        };
        self.gecko.mTextSizeAdjust = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_text_size_adjust_from(&mut self, other: &Self) {
        self.gecko.mTextSizeAdjust = other.gecko.mTextSizeAdjust.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_text_size_adjust(&mut self, other: &Self) {
        self.copy__moz_text_size_adjust_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_text_size_adjust(&self) -> longhands::_moz_text_size_adjust::computed_value::T {
        use crate::properties::longhands::_moz_text_size_adjust::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TEXT_SIZE_ADJUST_AUTO : u8 =
            structs::NS_STYLE_TEXT_SIZE_ADJUST_AUTO as u8;
        const U8_NS_STYLE_TEXT_SIZE_ADJUST_NONE : u8 =
            structs::NS_STYLE_TEXT_SIZE_ADJUST_NONE as u8;

        match self.gecko.mTextSizeAdjust as u8 {
            U8_NS_STYLE_TEXT_SIZE_ADJUST_AUTO => Keyword::Auto,
            U8_NS_STYLE_TEXT_SIZE_ADJUST_NONE => Keyword::None,
            _ => panic!("Found unexpected value in style struct for _moz_text_size_adjust property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_indent(&mut self, v: longhands::text_indent::computed_value::T) {
        self.gecko.mTextIndent = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_indent_from(&mut self, other: &Self) {
        self.gecko.mTextIndent = other.gecko.mTextIndent.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_indent(&mut self, other: &Self) {
        self.copy_text_indent_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_indent(&self) -> longhands::text_indent::computed_value::T {
        From::from(self.gecko.mTextIndent.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_wrap(&mut self, v: longhands::overflow_wrap::computed_value::T) {
        self.gecko.mOverflowWrap = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_wrap_from(&mut self, other: &Self) {
        self.gecko.mOverflowWrap = other.gecko.mOverflowWrap.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_wrap(&mut self, other: &Self) {
        self.copy_overflow_wrap_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_wrap(&self) -> longhands::overflow_wrap::computed_value::T {
        From::from(self.gecko.mOverflowWrap.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_word_break(&mut self, v: longhands::word_break::computed_value::T) {
        self.gecko.mWordBreak = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_word_break_from(&mut self, other: &Self) {
        self.gecko.mWordBreak = other.gecko.mWordBreak.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_word_break(&mut self, other: &Self) {
        self.copy_word_break_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_word_break(&self) -> longhands::word_break::computed_value::T {
        From::from(self.gecko.mWordBreak.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_justify(&mut self, v: longhands::text_justify::computed_value::T) {
        use crate::properties::longhands::text_justify::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleTextJustify::Auto ,
                Keyword::None =>
                    structs::StyleTextJustify::None ,
                Keyword::InterWord =>
                    structs::StyleTextJustify::InterWord ,
                Keyword::InterCharacter =>
                    structs::StyleTextJustify::InterCharacter ,
        };
        self.gecko.mTextJustify = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_justify_from(&mut self, other: &Self) {
        self.gecko.mTextJustify = other.gecko.mTextJustify.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_justify(&mut self, other: &Self) {
        self.copy_text_justify_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_text_justify(&self) -> longhands::text_justify::computed_value::T {
        use crate::properties::longhands::text_justify::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mTextJustify {
            structs::StyleTextJustify::Auto => Keyword::Auto,
            structs::StyleTextJustify::None => Keyword::None,
            structs::StyleTextJustify::InterWord => Keyword::InterWord,
            structs::StyleTextJustify::InterCharacter => Keyword::InterCharacter,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_align_last(&mut self, v: longhands::text_align_last::computed_value::T) {
        use crate::properties::longhands::text_align_last::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_TEXT_ALIGN_AUTO as u8,
                Keyword::Start =>
                    structs::NS_STYLE_TEXT_ALIGN_START as u8,
                Keyword::End =>
                    structs::NS_STYLE_TEXT_ALIGN_END as u8,
                Keyword::Left =>
                    structs::NS_STYLE_TEXT_ALIGN_LEFT as u8,
                Keyword::Right =>
                    structs::NS_STYLE_TEXT_ALIGN_RIGHT as u8,
                Keyword::Center =>
                    structs::NS_STYLE_TEXT_ALIGN_CENTER as u8,
                Keyword::Justify =>
                    structs::NS_STYLE_TEXT_ALIGN_JUSTIFY as u8,
        };
        self.gecko.mTextAlignLast = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_align_last_from(&mut self, other: &Self) {
        self.gecko.mTextAlignLast = other.gecko.mTextAlignLast.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_align_last(&mut self, other: &Self) {
        self.copy_text_align_last_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_text_align_last(&self) -> longhands::text_align_last::computed_value::T {
        use crate::properties::longhands::text_align_last::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TEXT_ALIGN_AUTO : u8 =
            structs::NS_STYLE_TEXT_ALIGN_AUTO as u8;
        const U8_NS_STYLE_TEXT_ALIGN_START : u8 =
            structs::NS_STYLE_TEXT_ALIGN_START as u8;
        const U8_NS_STYLE_TEXT_ALIGN_END : u8 =
            structs::NS_STYLE_TEXT_ALIGN_END as u8;
        const U8_NS_STYLE_TEXT_ALIGN_LEFT : u8 =
            structs::NS_STYLE_TEXT_ALIGN_LEFT as u8;
        const U8_NS_STYLE_TEXT_ALIGN_RIGHT : u8 =
            structs::NS_STYLE_TEXT_ALIGN_RIGHT as u8;
        const U8_NS_STYLE_TEXT_ALIGN_CENTER : u8 =
            structs::NS_STYLE_TEXT_ALIGN_CENTER as u8;
        const U8_NS_STYLE_TEXT_ALIGN_JUSTIFY : u8 =
            structs::NS_STYLE_TEXT_ALIGN_JUSTIFY as u8;

        match self.gecko.mTextAlignLast as u8 {
            U8_NS_STYLE_TEXT_ALIGN_AUTO => Keyword::Auto,
            U8_NS_STYLE_TEXT_ALIGN_START => Keyword::Start,
            U8_NS_STYLE_TEXT_ALIGN_END => Keyword::End,
            U8_NS_STYLE_TEXT_ALIGN_LEFT => Keyword::Left,
            U8_NS_STYLE_TEXT_ALIGN_RIGHT => Keyword::Right,
            U8_NS_STYLE_TEXT_ALIGN_CENTER => Keyword::Center,
            U8_NS_STYLE_TEXT_ALIGN_JUSTIFY => Keyword::Justify,
            _ => panic!("Found unexpected value in style struct for text_align_last property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_letter_spacing(&mut self, v: longhands::letter_spacing::computed_value::T) {
        self.gecko.mLetterSpacing = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_letter_spacing_from(&mut self, other: &Self) {
        self.gecko.mLetterSpacing = other.gecko.mLetterSpacing.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_letter_spacing(&mut self, other: &Self) {
        self.copy_letter_spacing_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_letter_spacing(&self) -> longhands::letter_spacing::computed_value::T {
        From::from(self.gecko.mLetterSpacing.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_word_spacing(&mut self, v: longhands::word_spacing::computed_value::T) {
        self.gecko.mWordSpacing = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_word_spacing_from(&mut self, other: &Self) {
        self.gecko.mWordSpacing = other.gecko.mWordSpacing.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_word_spacing(&mut self, other: &Self) {
        self.copy_word_spacing_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_word_spacing(&self) -> longhands::word_spacing::computed_value::T {
        From::from(self.gecko.mWordSpacing.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_white_space(&mut self, v: longhands::white_space::computed_value::T) {
        use crate::properties::longhands::white_space::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::StyleWhiteSpace::Normal ,
                Keyword::Pre =>
                    structs::StyleWhiteSpace::Pre ,
                Keyword::Nowrap =>
                    structs::StyleWhiteSpace::Nowrap ,
                Keyword::PreWrap =>
                    structs::StyleWhiteSpace::PreWrap ,
                Keyword::PreLine =>
                    structs::StyleWhiteSpace::PreLine ,
                Keyword::MozPreSpace =>
                    structs::StyleWhiteSpace::PreSpace ,
        };
        self.gecko.mWhiteSpace = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_white_space_from(&mut self, other: &Self) {
        self.gecko.mWhiteSpace = other.gecko.mWhiteSpace.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_white_space(&mut self, other: &Self) {
        self.copy_white_space_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_white_space(&self) -> longhands::white_space::computed_value::T {
        use crate::properties::longhands::white_space::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mWhiteSpace {
            structs::StyleWhiteSpace::Normal => Keyword::Normal,
            structs::StyleWhiteSpace::Pre => Keyword::Pre,
            structs::StyleWhiteSpace::Nowrap => Keyword::Nowrap,
            structs::StyleWhiteSpace::PreWrap => Keyword::PreWrap,
            structs::StyleWhiteSpace::PreLine => Keyword::PreLine,
            structs::StyleWhiteSpace::PreSpace => Keyword::MozPreSpace,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_shadow(&mut self, v: longhands::text_shadow::computed_value::T) {
        self.gecko.mTextShadow = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_shadow_from(&mut self, other: &Self) {
        self.gecko.mTextShadow = other.gecko.mTextShadow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_shadow(&mut self, other: &Self) {
        self.copy_text_shadow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_shadow(&self) -> longhands::text_shadow::computed_value::T {
        From::from(self.gecko.mTextShadow.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_emphasis_color(&mut self, v: longhands::text_emphasis_color::computed_value::T) {
        self.gecko.mTextEmphasisColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_emphasis_color_from(&mut self, other: &Self) {
        self.gecko.mTextEmphasisColor = other.gecko.mTextEmphasisColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_emphasis_color(&mut self, other: &Self) {
        self.copy_text_emphasis_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_emphasis_color(&self) -> longhands::text_emphasis_color::computed_value::T {
        From::from(self.gecko.mTextEmphasisColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_tab_size(&mut self, v: longhands::_moz_tab_size::computed_value::T) {
        self.gecko.mMozTabSize = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_tab_size_from(&mut self, other: &Self) {
        self.gecko.mMozTabSize = other.gecko.mMozTabSize.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_tab_size(&mut self, other: &Self) {
        self.copy__moz_tab_size_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_tab_size(&self) -> longhands::_moz_tab_size::computed_value::T {
        From::from(self.gecko.mMozTabSize.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__webkit_text_fill_color(&mut self, v: longhands::_webkit_text_fill_color::computed_value::T) {
        self.gecko.mWebkitTextFillColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__webkit_text_fill_color_from(&mut self, other: &Self) {
        self.gecko.mWebkitTextFillColor = other.gecko.mWebkitTextFillColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__webkit_text_fill_color(&mut self, other: &Self) {
        self.copy__webkit_text_fill_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__webkit_text_fill_color(&self) -> longhands::_webkit_text_fill_color::computed_value::T {
        From::from(self.gecko.mWebkitTextFillColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__webkit_text_stroke_color(&mut self, v: longhands::_webkit_text_stroke_color::computed_value::T) {
        self.gecko.mWebkitTextStrokeColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__webkit_text_stroke_color_from(&mut self, other: &Self) {
        self.gecko.mWebkitTextStrokeColor = other.gecko.mWebkitTextStrokeColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__webkit_text_stroke_color(&mut self, other: &Self) {
        self.copy__webkit_text_stroke_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__webkit_text_stroke_color(&self) -> longhands::_webkit_text_stroke_color::computed_value::T {
        From::from(self.gecko.mWebkitTextStrokeColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_ruby_align(&mut self, v: longhands::ruby_align::computed_value::T) {
        use crate::properties::longhands::ruby_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::SpaceAround =>
                    structs::NS_STYLE_RUBY_ALIGN_SPACE_AROUND as u8,
                Keyword::Start =>
                    structs::NS_STYLE_RUBY_ALIGN_START as u8,
                Keyword::Center =>
                    structs::NS_STYLE_RUBY_ALIGN_CENTER as u8,
                Keyword::SpaceBetween =>
                    structs::NS_STYLE_RUBY_ALIGN_SPACE_BETWEEN as u8,
        };
        self.gecko.mRubyAlign = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_ruby_align_from(&mut self, other: &Self) {
        self.gecko.mRubyAlign = other.gecko.mRubyAlign.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_ruby_align(&mut self, other: &Self) {
        self.copy_ruby_align_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_ruby_align(&self) -> longhands::ruby_align::computed_value::T {
        use crate::properties::longhands::ruby_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_RUBY_ALIGN_SPACE_AROUND : u8 =
            structs::NS_STYLE_RUBY_ALIGN_SPACE_AROUND as u8;
        const U8_NS_STYLE_RUBY_ALIGN_START : u8 =
            structs::NS_STYLE_RUBY_ALIGN_START as u8;
        const U8_NS_STYLE_RUBY_ALIGN_CENTER : u8 =
            structs::NS_STYLE_RUBY_ALIGN_CENTER as u8;
        const U8_NS_STYLE_RUBY_ALIGN_SPACE_BETWEEN : u8 =
            structs::NS_STYLE_RUBY_ALIGN_SPACE_BETWEEN as u8;

        match self.gecko.mRubyAlign as u8 {
            U8_NS_STYLE_RUBY_ALIGN_SPACE_AROUND => Keyword::SpaceAround,
            U8_NS_STYLE_RUBY_ALIGN_START => Keyword::Start,
            U8_NS_STYLE_RUBY_ALIGN_CENTER => Keyword::Center,
            U8_NS_STYLE_RUBY_ALIGN_SPACE_BETWEEN => Keyword::SpaceBetween,
            _ => panic!("Found unexpected value in style struct for ruby_align property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_ruby_position(&mut self, v: longhands::ruby_position::computed_value::T) {
        use crate::properties::longhands::ruby_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Over =>
                    structs::NS_STYLE_RUBY_POSITION_OVER as u8,
                Keyword::Under =>
                    structs::NS_STYLE_RUBY_POSITION_UNDER as u8,
        };
        self.gecko.mRubyPosition = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_ruby_position_from(&mut self, other: &Self) {
        self.gecko.mRubyPosition = other.gecko.mRubyPosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_ruby_position(&mut self, other: &Self) {
        self.copy_ruby_position_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_ruby_position(&self) -> longhands::ruby_position::computed_value::T {
        use crate::properties::longhands::ruby_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_RUBY_POSITION_OVER : u8 =
            structs::NS_STYLE_RUBY_POSITION_OVER as u8;
        const U8_NS_STYLE_RUBY_POSITION_UNDER : u8 =
            structs::NS_STYLE_RUBY_POSITION_UNDER as u8;

        match self.gecko.mRubyPosition as u8 {
            U8_NS_STYLE_RUBY_POSITION_OVER => Keyword::Over,
            U8_NS_STYLE_RUBY_POSITION_UNDER => Keyword::Under,
            _ => panic!("Found unexpected value in style struct for ruby_position property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_combine_upright(&mut self, v: longhands::text_combine_upright::computed_value::T) {
        use crate::properties::longhands::text_combine_upright::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::NS_STYLE_TEXT_COMBINE_UPRIGHT_NONE as u8,
                Keyword::All =>
                    structs::NS_STYLE_TEXT_COMBINE_UPRIGHT_ALL as u8,
        };
        self.gecko.mTextCombineUpright = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_combine_upright_from(&mut self, other: &Self) {
        self.gecko.mTextCombineUpright = other.gecko.mTextCombineUpright.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_combine_upright(&mut self, other: &Self) {
        self.copy_text_combine_upright_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_text_combine_upright(&self) -> longhands::text_combine_upright::computed_value::T {
        use crate::properties::longhands::text_combine_upright::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TEXT_COMBINE_UPRIGHT_NONE : u8 =
            structs::NS_STYLE_TEXT_COMBINE_UPRIGHT_NONE as u8;
        const U8_NS_STYLE_TEXT_COMBINE_UPRIGHT_ALL : u8 =
            structs::NS_STYLE_TEXT_COMBINE_UPRIGHT_ALL as u8;

        match self.gecko.mTextCombineUpright as u8 {
            U8_NS_STYLE_TEXT_COMBINE_UPRIGHT_NONE => Keyword::None,
            U8_NS_STYLE_TEXT_COMBINE_UPRIGHT_ALL => Keyword::All,
            _ => panic!("Found unexpected value in style struct for text_combine_upright property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_rendering(&mut self, v: longhands::text_rendering::computed_value::T) {
        use crate::properties::longhands::text_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleTextRendering::Auto ,
                Keyword::Optimizespeed =>
                    structs::StyleTextRendering::Optimizespeed ,
                Keyword::Optimizelegibility =>
                    structs::StyleTextRendering::Optimizelegibility ,
                Keyword::Geometricprecision =>
                    structs::StyleTextRendering::Geometricprecision ,
        };
        self.gecko.mTextRendering = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_rendering_from(&mut self, other: &Self) {
        self.gecko.mTextRendering = other.gecko.mTextRendering.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_rendering(&mut self, other: &Self) {
        self.copy_text_rendering_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_text_rendering(&self) -> longhands::text_rendering::computed_value::T {
        use crate::properties::longhands::text_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mTextRendering {
            structs::StyleTextRendering::Auto => Keyword::Auto,
            structs::StyleTextRendering::Optimizespeed => Keyword::Optimizespeed,
            structs::StyleTextRendering::Optimizelegibility => Keyword::Optimizelegibility,
            structs::StyleTextRendering::Geometricprecision => Keyword::Geometricprecision,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_control_character_visibility(&mut self, v: longhands::_moz_control_character_visibility::computed_value::T) {
        use crate::properties::longhands::_moz_control_character_visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Hidden =>
                    structs::NS_STYLE_CONTROL_CHARACTER_VISIBILITY_HIDDEN as u8,
                Keyword::Visible =>
                    structs::NS_STYLE_CONTROL_CHARACTER_VISIBILITY_VISIBLE as u8,
        };
        self.gecko.mControlCharacterVisibility = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_control_character_visibility_from(&mut self, other: &Self) {
        self.gecko.mControlCharacterVisibility = other.gecko.mControlCharacterVisibility.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_control_character_visibility(&mut self, other: &Self) {
        self.copy__moz_control_character_visibility_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_control_character_visibility(&self) -> longhands::_moz_control_character_visibility::computed_value::T {
        use crate::properties::longhands::_moz_control_character_visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_CONTROL_CHARACTER_VISIBILITY_HIDDEN : u8 =
            structs::NS_STYLE_CONTROL_CHARACTER_VISIBILITY_HIDDEN as u8;
        const U8_NS_STYLE_CONTROL_CHARACTER_VISIBILITY_VISIBLE : u8 =
            structs::NS_STYLE_CONTROL_CHARACTER_VISIBILITY_VISIBLE as u8;

        match self.gecko.mControlCharacterVisibility as u8 {
            U8_NS_STYLE_CONTROL_CHARACTER_VISIBILITY_HIDDEN => Keyword::Hidden,
            U8_NS_STYLE_CONTROL_CHARACTER_VISIBILITY_VISIBLE => Keyword::Visible,
            _ => panic!("Found unexpected value in style struct for _moz_control_character_visibility property"),
        }
    }


}




impl GeckoText {
    /*
     * Manually-Implemented Methods.
     */
    

    fn clear_overflow_sides_if_string(&mut self) {
        use crate::gecko_bindings::structs::nsStyleTextOverflowSide;
        fn clear_if_string(side: &mut nsStyleTextOverflowSide) {
            if side.mType == structs::NS_STYLE_TEXT_OVERFLOW_STRING as u8 {
                side.mString.truncate();
                side.mType = structs::NS_STYLE_TEXT_OVERFLOW_CLIP as u8;
            }
        }
        clear_if_string(&mut self.gecko.mTextOverflow.mLeft);
        clear_if_string(&mut self.gecko.mTextOverflow.mRight);
    }

    pub fn set_text_overflow(&mut self, v: longhands::text_overflow::computed_value::T) {
        use crate::gecko_bindings::structs::nsStyleTextOverflowSide;
        use crate::values::specified::text::TextOverflowSide;

        fn set(side: &mut nsStyleTextOverflowSide, value: &TextOverflowSide) {
            let ty = match *value {
                TextOverflowSide::Clip => structs::NS_STYLE_TEXT_OVERFLOW_CLIP,
                TextOverflowSide::Ellipsis => structs::NS_STYLE_TEXT_OVERFLOW_ELLIPSIS,
                TextOverflowSide::String(ref s) => {
                    side.mString.assign_str(s);
                    structs::NS_STYLE_TEXT_OVERFLOW_STRING
                }
            };
            side.mType = ty as u8;
        }

        self.clear_overflow_sides_if_string();
        self.gecko.mTextOverflow.mLogicalDirections = v.sides_are_logical;

        set(&mut self.gecko.mTextOverflow.mLeft, &v.first);
        set(&mut self.gecko.mTextOverflow.mRight, &v.second);
    }

    pub fn copy_text_overflow_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleTextOverflowSide;
        fn set(side: &mut nsStyleTextOverflowSide, other: &nsStyleTextOverflowSide) {
            if other.mType == structs::NS_STYLE_TEXT_OVERFLOW_STRING as u8 {
                side.mString.assign(&*other.mString)
            }
            side.mType = other.mType
        }
        self.clear_overflow_sides_if_string();
        set(&mut self.gecko.mTextOverflow.mLeft, &other.gecko.mTextOverflow.mLeft);
        set(&mut self.gecko.mTextOverflow.mRight, &other.gecko.mTextOverflow.mRight);
        self.gecko.mTextOverflow.mLogicalDirections = other.gecko.mTextOverflow.mLogicalDirections;
    }

    pub fn reset_text_overflow(&mut self, other: &Self) {
        self.copy_text_overflow_from(other)
    }

    pub fn clone_text_overflow(&self) -> longhands::text_overflow::computed_value::T {
        use crate::gecko_bindings::structs::nsStyleTextOverflowSide;
        use crate::values::specified::text::TextOverflowSide;

        fn to_servo(side: &nsStyleTextOverflowSide) -> TextOverflowSide {
            match side.mType as u32 {
                structs::NS_STYLE_TEXT_OVERFLOW_CLIP => TextOverflowSide::Clip,
                structs::NS_STYLE_TEXT_OVERFLOW_ELLIPSIS => TextOverflowSide::Ellipsis,
                structs::NS_STYLE_TEXT_OVERFLOW_STRING =>
                    TextOverflowSide::String(side.mString.to_string().into_boxed_str()),
                _ => panic!("Found unexpected value in style struct for text_overflow property"),
            }
        }

        longhands::text_overflow::computed_value::T {
            first: to_servo(&self.gecko.mTextOverflow.mLeft),
            second: to_servo(&self.gecko.mTextOverflow.mRight),
            sides_are_logical: self.gecko.mTextOverflow.mLogicalDirections
        }
    }

    pub fn set_initial_letter(&mut self, v: longhands::initial_letter::computed_value::T) {
        use crate::values::generics::text::InitialLetter;
        match v {
            InitialLetter::Normal => {
                self.gecko.mInitialLetterSize = 0.;
                self.gecko.mInitialLetterSink = 0;
            },
            InitialLetter::Specified(size, sink) => {
                self.gecko.mInitialLetterSize = size;
                if let Some(sink) = sink {
                    self.gecko.mInitialLetterSink = sink;
                } else {
                    self.gecko.mInitialLetterSink = size.floor() as i32;
                }
            }
        }
    }

    pub fn copy_initial_letter_from(&mut self, other: &Self) {
        self.gecko.mInitialLetterSize = other.gecko.mInitialLetterSize;
        self.gecko.mInitialLetterSink = other.gecko.mInitialLetterSink;
    }

    pub fn reset_initial_letter(&mut self, other: &Self) {
        self.copy_initial_letter_from(other)
    }

    pub fn clone_initial_letter(&self) -> longhands::initial_letter::computed_value::T {
        use crate::values::generics::text::InitialLetter;

        if self.gecko.mInitialLetterSize == 0. && self.gecko.mInitialLetterSink == 0 {
            InitialLetter::Normal
        } else if self.gecko.mInitialLetterSize.floor() as i32 == self.gecko.mInitialLetterSink {
            InitialLetter::Specified(self.gecko.mInitialLetterSize, None)
        } else {
            InitialLetter::Specified(self.gecko.mInitialLetterSize, Some(self.gecko.mInitialLetterSink))
        }
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_unicode_bidi(&mut self, v: longhands::unicode_bidi::computed_value::T) {
        use crate::properties::longhands::unicode_bidi::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::NS_STYLE_UNICODE_BIDI_NORMAL as u8,
                Keyword::Embed =>
                    structs::NS_STYLE_UNICODE_BIDI_EMBED as u8,
                Keyword::Isolate =>
                    structs::NS_STYLE_UNICODE_BIDI_ISOLATE as u8,
                Keyword::BidiOverride =>
                    structs::NS_STYLE_UNICODE_BIDI_BIDI_OVERRIDE as u8,
                Keyword::IsolateOverride =>
                    structs::NS_STYLE_UNICODE_BIDI_ISOLATE_OVERRIDE as u8,
                Keyword::Plaintext =>
                    structs::NS_STYLE_UNICODE_BIDI_PLAINTEXT as u8,
        };
        self.gecko.mUnicodeBidi = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_unicode_bidi_from(&mut self, other: &Self) {
        self.gecko.mUnicodeBidi = other.gecko.mUnicodeBidi.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_unicode_bidi(&mut self, other: &Self) {
        self.copy_unicode_bidi_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_unicode_bidi(&self) -> longhands::unicode_bidi::computed_value::T {
        use crate::properties::longhands::unicode_bidi::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_UNICODE_BIDI_NORMAL : u8 =
            structs::NS_STYLE_UNICODE_BIDI_NORMAL as u8;
        const U8_NS_STYLE_UNICODE_BIDI_EMBED : u8 =
            structs::NS_STYLE_UNICODE_BIDI_EMBED as u8;
        const U8_NS_STYLE_UNICODE_BIDI_ISOLATE : u8 =
            structs::NS_STYLE_UNICODE_BIDI_ISOLATE as u8;
        const U8_NS_STYLE_UNICODE_BIDI_BIDI_OVERRIDE : u8 =
            structs::NS_STYLE_UNICODE_BIDI_BIDI_OVERRIDE as u8;
        const U8_NS_STYLE_UNICODE_BIDI_ISOLATE_OVERRIDE : u8 =
            structs::NS_STYLE_UNICODE_BIDI_ISOLATE_OVERRIDE as u8;
        const U8_NS_STYLE_UNICODE_BIDI_PLAINTEXT : u8 =
            structs::NS_STYLE_UNICODE_BIDI_PLAINTEXT as u8;

        match self.gecko.mUnicodeBidi as u8 {
            U8_NS_STYLE_UNICODE_BIDI_NORMAL => Keyword::Normal,
            U8_NS_STYLE_UNICODE_BIDI_EMBED => Keyword::Embed,
            U8_NS_STYLE_UNICODE_BIDI_ISOLATE => Keyword::Isolate,
            U8_NS_STYLE_UNICODE_BIDI_BIDI_OVERRIDE => Keyword::BidiOverride,
            U8_NS_STYLE_UNICODE_BIDI_ISOLATE_OVERRIDE => Keyword::IsolateOverride,
            U8_NS_STYLE_UNICODE_BIDI_PLAINTEXT => Keyword::Plaintext,
            _ => panic!("Found unexpected value in style struct for unicode_bidi property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_decoration_line(&mut self, v: longhands::text_decoration_line::computed_value::T) {
        self.gecko.mTextDecorationLine = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_decoration_line_from(&mut self, other: &Self) {
        self.gecko.mTextDecorationLine = other.gecko.mTextDecorationLine.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_decoration_line(&mut self, other: &Self) {
        self.copy_text_decoration_line_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_decoration_line(&self) -> longhands::text_decoration_line::computed_value::T {
        From::from(self.gecko.mTextDecorationLine.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_decoration_style(&mut self, v: longhands::text_decoration_style::computed_value::T) {
        use crate::properties::longhands::text_decoration_style::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Solid =>
                    structs::NS_STYLE_TEXT_DECORATION_STYLE_SOLID as u8,
                Keyword::Double =>
                    structs::NS_STYLE_TEXT_DECORATION_STYLE_DOUBLE as u8,
                Keyword::Dotted =>
                    structs::NS_STYLE_TEXT_DECORATION_STYLE_DOTTED as u8,
                Keyword::Dashed =>
                    structs::NS_STYLE_TEXT_DECORATION_STYLE_DASHED as u8,
                Keyword::Wavy =>
                    structs::NS_STYLE_TEXT_DECORATION_STYLE_WAVY as u8,
                Keyword::MozNone =>
                    structs::NS_STYLE_TEXT_DECORATION_STYLE_NONE as u8,
        };
        self.gecko.mTextDecorationStyle = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_decoration_style_from(&mut self, other: &Self) {
        self.gecko.mTextDecorationStyle = other.gecko.mTextDecorationStyle.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_decoration_style(&mut self, other: &Self) {
        self.copy_text_decoration_style_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_text_decoration_style(&self) -> longhands::text_decoration_style::computed_value::T {
        use crate::properties::longhands::text_decoration_style::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TEXT_DECORATION_STYLE_SOLID : u8 =
            structs::NS_STYLE_TEXT_DECORATION_STYLE_SOLID as u8;
        const U8_NS_STYLE_TEXT_DECORATION_STYLE_DOUBLE : u8 =
            structs::NS_STYLE_TEXT_DECORATION_STYLE_DOUBLE as u8;
        const U8_NS_STYLE_TEXT_DECORATION_STYLE_DOTTED : u8 =
            structs::NS_STYLE_TEXT_DECORATION_STYLE_DOTTED as u8;
        const U8_NS_STYLE_TEXT_DECORATION_STYLE_DASHED : u8 =
            structs::NS_STYLE_TEXT_DECORATION_STYLE_DASHED as u8;
        const U8_NS_STYLE_TEXT_DECORATION_STYLE_WAVY : u8 =
            structs::NS_STYLE_TEXT_DECORATION_STYLE_WAVY as u8;
        const U8_NS_STYLE_TEXT_DECORATION_STYLE_NONE : u8 =
            structs::NS_STYLE_TEXT_DECORATION_STYLE_NONE as u8;

        match self.gecko.mTextDecorationStyle as u8 {
            U8_NS_STYLE_TEXT_DECORATION_STYLE_SOLID => Keyword::Solid,
            U8_NS_STYLE_TEXT_DECORATION_STYLE_DOUBLE => Keyword::Double,
            U8_NS_STYLE_TEXT_DECORATION_STYLE_DOTTED => Keyword::Dotted,
            U8_NS_STYLE_TEXT_DECORATION_STYLE_DASHED => Keyword::Dashed,
            U8_NS_STYLE_TEXT_DECORATION_STYLE_WAVY => Keyword::Wavy,
            U8_NS_STYLE_TEXT_DECORATION_STYLE_NONE => Keyword::MozNone,
            _ => panic!("Found unexpected value in style struct for text_decoration_style property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_decoration_color(&mut self, v: longhands::text_decoration_color::computed_value::T) {
        self.gecko.mTextDecorationColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_decoration_color_from(&mut self, other: &Self) {
        self.gecko.mTextDecorationColor = other.gecko.mTextDecorationColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_decoration_color(&mut self, other: &Self) {
        self.copy_text_decoration_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_decoration_color(&self) -> longhands::text_decoration_color::computed_value::T {
        From::from(self.gecko.mTextDecorationColor.clone())
    }


}


// Set SVGPathData to StyleShapeSource.
fn set_style_svg_path(
    shape_source: &mut structs::mozilla::StyleShapeSource,
    servo_path: values::specified::svg_path::SVGPathData,
    fill: values::generics::basic_shape::FillRule,
) {
    // Setup path.
    unsafe {
        bindings::Gecko_SetToSVGPath(
            shape_source,
            servo_path.0.forget(),
            fill,
        );
    }
}






impl GeckoSVG {
    /*
     * Manually-Implemented Methods.
     */
    

    
    

    
    
    pub fn copy_mask_repeat_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mRepeatCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mRepeat = other.mRepeat;
        }
        self.gecko.mMask.mRepeatCount = count;
    }

    pub fn reset_mask_repeat(&mut self, other: &Self) {
        self.copy_mask_repeat_from(other)
    }


    pub fn set_mask_repeat<I>(&mut self, v: I)
        where I: IntoIterator<Item=longhands::mask_repeat::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mRepeatCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask.mLayers.iter_mut()) {
            geckolayer.mRepeat = {
                
        use crate::values::specified::background::BackgroundRepeatKeyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_Repeat;
        use crate::gecko_bindings::structs::StyleImageLayerRepeat;

        fn to_ns(repeat: BackgroundRepeatKeyword) -> StyleImageLayerRepeat {
            match repeat {
                BackgroundRepeatKeyword::Repeat => StyleImageLayerRepeat::Repeat,
                BackgroundRepeatKeyword::Space => StyleImageLayerRepeat::Space,
                BackgroundRepeatKeyword::Round => StyleImageLayerRepeat::Round,
                BackgroundRepeatKeyword::NoRepeat => StyleImageLayerRepeat::NoRepeat,
            }
        }

        let repeat_x = to_ns(servo.0);
        let repeat_y = to_ns(servo.1);
        nsStyleImageLayers_Repeat {
              mXRepeat: repeat_x,
              mYRepeat: repeat_y,
        }
    
            };
        }
    }


    pub fn clone_mask_repeat(&self) -> longhands::mask_repeat::computed_value::T {
        use crate::properties::longhands::mask_repeat::single_value::computed_value::T;
        use crate::values::specified::background::BackgroundRepeatKeyword;
        use crate::gecko_bindings::structs::StyleImageLayerRepeat;

        fn to_servo(repeat: StyleImageLayerRepeat) -> BackgroundRepeatKeyword {
            match repeat {
                StyleImageLayerRepeat::Repeat => BackgroundRepeatKeyword::Repeat,
                StyleImageLayerRepeat::Space => BackgroundRepeatKeyword::Space,
                StyleImageLayerRepeat::Round => BackgroundRepeatKeyword::Round,
                StyleImageLayerRepeat::NoRepeat => BackgroundRepeatKeyword::NoRepeat,
                _ => panic!("Found unexpected value in style struct for mask_repeat property"),
            }
        }

        longhands::mask_repeat::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mRepeatCount as usize)
                .map(|ref layer| {
                    T(to_servo(layer.mRepeat.mXRepeat), to_servo(layer.mRepeat.mYRepeat))
                }).collect()
        )
    }

    
    

    
    pub fn copy_mask_clip_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mClipCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mClip = other.mClip;
        }
        self.gecko.mMask.mClipCount = count;
    }

    pub fn reset_mask_clip(&mut self, other: &Self) {
        self.copy_mask_clip_from(other)
    }


    pub fn set_mask_clip<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::mask_clip::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::mask_clip::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mClipCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask.mLayers.iter_mut()) {
            geckolayer.mClip = {
                match servo {
                    Keyword::BorderBox =>
                        structs::StyleGeometryBox::BorderBox ,
                    Keyword::ContentBox =>
                        structs::StyleGeometryBox::ContentBox ,
                    Keyword::PaddingBox =>
                        structs::StyleGeometryBox::PaddingBox ,
                    Keyword::FillBox =>
                        structs::StyleGeometryBox::FillBox ,
                    Keyword::StrokeBox =>
                        structs::StyleGeometryBox::StrokeBox ,
                    Keyword::ViewBox =>
                        structs::StyleGeometryBox::ViewBox ,
                    Keyword::NoClip =>
                        structs::StyleGeometryBox::NoClip ,
                }
            };
        }
    }

    pub fn clone_mask_clip(&self) -> longhands::mask_clip::computed_value::T {
        use crate::properties::longhands::mask_clip::single_value::computed_value::T as Keyword;


        longhands::mask_clip::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mClipCount as usize)
                .map(|ref layer| {
                    match layer.mClip {
                        structs::StyleGeometryBox::BorderBox
                            => Keyword::BorderBox,
                        structs::StyleGeometryBox::ContentBox
                            => Keyword::ContentBox,
                        structs::StyleGeometryBox::PaddingBox
                            => Keyword::PaddingBox,
                        structs::StyleGeometryBox::FillBox
                            => Keyword::FillBox,
                        structs::StyleGeometryBox::StrokeBox
                            => Keyword::StrokeBox,
                        structs::StyleGeometryBox::ViewBox
                            => Keyword::ViewBox,
                        structs::StyleGeometryBox::NoClip
                            => Keyword::NoClip,
                        _ => panic!("Found unexpected value in style struct for mask_clip property"),
                    }
                }).collect()
        )
    }

    
    

    
    pub fn copy_mask_origin_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mOriginCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mOrigin = other.mOrigin;
        }
        self.gecko.mMask.mOriginCount = count;
    }

    pub fn reset_mask_origin(&mut self, other: &Self) {
        self.copy_mask_origin_from(other)
    }


    pub fn set_mask_origin<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::mask_origin::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::mask_origin::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mOriginCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask.mLayers.iter_mut()) {
            geckolayer.mOrigin = {
                match servo {
                    Keyword::BorderBox =>
                        structs::StyleGeometryBox::BorderBox ,
                    Keyword::ContentBox =>
                        structs::StyleGeometryBox::ContentBox ,
                    Keyword::PaddingBox =>
                        structs::StyleGeometryBox::PaddingBox ,
                    Keyword::FillBox =>
                        structs::StyleGeometryBox::FillBox ,
                    Keyword::StrokeBox =>
                        structs::StyleGeometryBox::StrokeBox ,
                    Keyword::ViewBox =>
                        structs::StyleGeometryBox::ViewBox ,
                }
            };
        }
    }

    pub fn clone_mask_origin(&self) -> longhands::mask_origin::computed_value::T {
        use crate::properties::longhands::mask_origin::single_value::computed_value::T as Keyword;


        longhands::mask_origin::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mOriginCount as usize)
                .map(|ref layer| {
                    match layer.mOrigin {
                        structs::StyleGeometryBox::BorderBox
                            => Keyword::BorderBox,
                        structs::StyleGeometryBox::ContentBox
                            => Keyword::ContentBox,
                        structs::StyleGeometryBox::PaddingBox
                            => Keyword::PaddingBox,
                        structs::StyleGeometryBox::FillBox
                            => Keyword::FillBox,
                        structs::StyleGeometryBox::StrokeBox
                            => Keyword::StrokeBox,
                        structs::StyleGeometryBox::ViewBox
                            => Keyword::ViewBox,
                        _ => panic!("Found unexpected value in style struct for mask_origin property"),
                    }
                }).collect()
        )
    }


    pub fn copy_mask_position_x_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mPositionXCount;

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }

        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mPosition.horizontal = other.mPosition.horizontal;
        }
        self.gecko.mMask.mPositionXCount = count;
    }

    pub fn reset_mask_position_x(&mut self, other: &Self) {
        self.copy_mask_position_x_from(other)
    }

    pub fn clone_mask_position_x(&self)
        -> longhands::mask_position_x::computed_value::T {
        longhands::mask_position_x::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mPositionXCount as usize)
                .map(|position| position.mPosition.horizontal)
                .collect()
        )
    }

    pub fn set_mask_position_x<I>(&mut self,
                                     v: I)
        where I: IntoIterator<Item = longhands::mask_position_x
                                              ::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mPositionXCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask
                                                           .mLayers.iter_mut()) {
            geckolayer.mPosition.horizontal = servo;
        }
    }
    pub fn copy_mask_position_y_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mPositionYCount;

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }

        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mPosition.vertical = other.mPosition.vertical;
        }
        self.gecko.mMask.mPositionYCount = count;
    }

    pub fn reset_mask_position_y(&mut self, other: &Self) {
        self.copy_mask_position_y_from(other)
    }

    pub fn clone_mask_position_y(&self)
        -> longhands::mask_position_y::computed_value::T {
        longhands::mask_position_y::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mPositionYCount as usize)
                .map(|position| position.mPosition.vertical)
                .collect()
        )
    }

    pub fn set_mask_position_y<I>(&mut self,
                                     v: I)
        where I: IntoIterator<Item = longhands::mask_position_y
                                              ::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mPositionYCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask
                                                           .mLayers.iter_mut()) {
            geckolayer.mPosition.vertical = servo;
        }
    }

    
    
    pub fn copy_mask_size_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mSizeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mSize = other.mSize;
        }
        self.gecko.mMask.mSizeCount = count;
    }

    pub fn reset_mask_size(&mut self, other: &Self) {
        self.copy_mask_size_from(other)
    }


    pub fn set_mask_size<I>(&mut self, v: I)
        where I: IntoIterator<Item=longhands::mask_size::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mSizeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask.mLayers.iter_mut()) {
            geckolayer.mSize = {
                
        servo
    
            };
        }
    }


    pub fn clone_mask_size(&self) -> longhands::mask_size::computed_value::T {
        longhands::mask_size::computed_value::List(
            self.gecko.mMask.mLayers.iter().map(|layer| layer.mSize).collect()
        )
    }

    pub fn copy_mask_image_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        unsafe {
            let count = other.gecko.mMask.mImageCount;
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);

            for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                      .zip(other.gecko.mMask.mLayers.iter())
                                      .take(count as usize) {
                Gecko_CopyImageValueFrom(&mut layer.mImage, &other.mImage);
            }
            self.gecko.mMask.mImageCount = count;
        }
    }

    pub fn reset_mask_image(&mut self, other: &Self) {
        self.copy_mask_image_from(other)
    }

    #[allow(unused_variables)]
    pub fn set_mask_image<I>(&mut self, images: I)
        where I: IntoIterator<Item = longhands::mask_image::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let images = images.into_iter();

        unsafe {
            // Prevent leaking of the last elements we did set
            for image in &mut self.gecko.mMask.mLayers {
                Gecko_SetNullImageValue(&mut image.mImage)
            }
            // XXXManishearth clear mSourceURI for masks
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, images.len(),
                                          LayerType::Mask);
        }

        self.gecko.mMask.mImageCount = images.len() as u32;

        for (image, geckoimage) in images.zip(self.gecko.mMask
                                                  .mLayers.iter_mut()) {
            if let Either::Second(image) = image {
                geckoimage.mImage.set(image)
            }
        }
    }

    pub fn clone_mask_image(&self) -> longhands::mask_image::computed_value::T {
        use crate::values::None_;

        longhands::mask_image::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mImageCount as usize)
                .map(|ref layer| {
                    match unsafe { layer.mImage.into_image() } {
                        Some(image) => Either::Second(image),
                        None => Either::First(None_),
                    }
            }).collect()
        )
    }

    
    pub fn fill_arrays(&mut self) {
        use crate::gecko_bindings::bindings::Gecko_FillAllImageLayers;
        use std::cmp;
        let mut max_len = 1;
            max_len = cmp::max(max_len, self.gecko.mMask.mRepeatCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mClipCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mOriginCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mPositionXCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mPositionYCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mImageCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mSizeCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mMaskModeCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mCompositeCount);
        unsafe {
            // While we could do this manually, we'd need to also manually
            // run all the copy constructors, so we just delegate to gecko
            Gecko_FillAllImageLayers(&mut self.gecko.mMask, max_len);
        }
    }

    
    

    
    pub fn copy_mask_mode_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mMaskModeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mMaskMode = other.mMaskMode;
        }
        self.gecko.mMask.mMaskModeCount = count;
    }

    pub fn reset_mask_mode(&mut self, other: &Self) {
        self.copy_mask_mode_from(other)
    }


    pub fn set_mask_mode<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::mask_mode::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::mask_mode::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mMaskModeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask.mLayers.iter_mut()) {
            geckolayer.mMaskMode = {
                match servo {
                    Keyword::MatchSource =>
                        structs::StyleMaskMode::MatchSource ,
                    Keyword::Alpha =>
                        structs::StyleMaskMode::Alpha ,
                    Keyword::Luminance =>
                        structs::StyleMaskMode::Luminance ,
                }
            };
        }
    }

    pub fn clone_mask_mode(&self) -> longhands::mask_mode::computed_value::T {
        use crate::properties::longhands::mask_mode::single_value::computed_value::T as Keyword;


        longhands::mask_mode::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mMaskModeCount as usize)
                .map(|ref layer| {
                    match layer.mMaskMode {
                        structs::StyleMaskMode::MatchSource
                            => Keyword::MatchSource,
                        structs::StyleMaskMode::Alpha
                            => Keyword::Alpha,
                        structs::StyleMaskMode::Luminance
                            => Keyword::Luminance,
                    }
                }).collect()
        )
    }

    
    

    
    pub fn copy_mask_composite_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mCompositeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mComposite = other.mComposite;
        }
        self.gecko.mMask.mCompositeCount = count;
    }

    pub fn reset_mask_composite(&mut self, other: &Self) {
        self.copy_mask_composite_from(other)
    }


    pub fn set_mask_composite<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::mask_composite::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::mask_composite::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mCompositeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask.mLayers.iter_mut()) {
            geckolayer.mComposite = {
                match servo {
                    Keyword::Add =>
                        structs::NS_STYLE_MASK_COMPOSITE_ADD as u8,
                    Keyword::Subtract =>
                        structs::NS_STYLE_MASK_COMPOSITE_SUBTRACT as u8,
                    Keyword::Intersect =>
                        structs::NS_STYLE_MASK_COMPOSITE_INTERSECT as u8,
                    Keyword::Exclude =>
                        structs::NS_STYLE_MASK_COMPOSITE_EXCLUDE as u8,
                }
            };
        }
    }

    pub fn clone_mask_composite(&self) -> longhands::mask_composite::computed_value::T {
        use crate::properties::longhands::mask_composite::single_value::computed_value::T as Keyword;

        const U8_NS_STYLE_MASK_COMPOSITE_ADD : u8 =
            structs::NS_STYLE_MASK_COMPOSITE_ADD as u8;
        const U8_NS_STYLE_MASK_COMPOSITE_SUBTRACT : u8 =
            structs::NS_STYLE_MASK_COMPOSITE_SUBTRACT as u8;
        const U8_NS_STYLE_MASK_COMPOSITE_INTERSECT : u8 =
            structs::NS_STYLE_MASK_COMPOSITE_INTERSECT as u8;
        const U8_NS_STYLE_MASK_COMPOSITE_EXCLUDE : u8 =
            structs::NS_STYLE_MASK_COMPOSITE_EXCLUDE as u8;

        longhands::mask_composite::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mCompositeCount as usize)
                .map(|ref layer| {
                    match layer.mComposite {
                        U8_NS_STYLE_MASK_COMPOSITE_ADD
                            => Keyword::Add,
                        U8_NS_STYLE_MASK_COMPOSITE_SUBTRACT
                            => Keyword::Subtract,
                        U8_NS_STYLE_MASK_COMPOSITE_INTERSECT
                            => Keyword::Intersect,
                        U8_NS_STYLE_MASK_COMPOSITE_EXCLUDE
                            => Keyword::Exclude,
                        _ => panic!("Found unexpected value in style struct for mask_composite property"),
                    }
                }).collect()
        )
    }

    
    pub fn set_clip_path(&mut self, v: longhands::clip_path::computed_value::T) {
        use crate::values::generics::basic_shape::ShapeSource;
        use crate::gecko_bindings::structs::StyleShapeSourceType;
        use crate::gecko_bindings::structs::StyleGeometryBox;

        let ref mut clip_path = self.gecko.mClipPath;

        // clean up existing struct.
        unsafe { bindings::Gecko_DestroyShapeSource(clip_path) };

        clip_path.mType = StyleShapeSourceType::None;

        match v {
            ShapeSource::ImageOrUrl(ref url) => {
                unsafe {
                    bindings::Gecko_StyleShapeSource_SetURLValue(clip_path, url.url_value_ptr())
                }
            }
            ShapeSource::None => {} // don't change the type
            ShapeSource::Box(reference) => {
                clip_path.mReferenceBox = reference.into();
                clip_path.mType = StyleShapeSourceType::Box;
            }
            ShapeSource::Path(p) => set_style_svg_path(clip_path, p.path, p.fill),
            ShapeSource::Shape(servo_shape, maybe_box) => {
                unsafe {
                    clip_path.__bindgen_anon_1.mBasicShape.as_mut().mPtr =
                        Box::into_raw(servo_shape);
                }
                clip_path.mReferenceBox =
                    maybe_box.map(Into::into).unwrap_or(StyleGeometryBox::NoBox);
                clip_path.mType = StyleShapeSourceType::Shape;
            }
        }

    }

    pub fn clone_clip_path(&self) -> longhands::clip_path::computed_value::T {
        (&self.gecko.mClipPath).into()
    }

    pub fn copy_clip_path_from(&mut self, other: &Self) {
        use crate::gecko_bindings::bindings::Gecko_CopyShapeSourceFrom;
        unsafe {
            Gecko_CopyShapeSourceFrom(&mut self.gecko.mClipPath, &other.gecko.mClipPath);
        }
    }

    pub fn reset_clip_path(&mut self, other: &Self) {
        self.copy_clip_path_from(other)
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_dominant_baseline(&mut self, v: longhands::dominant_baseline::computed_value::T) {
        use crate::properties::longhands::dominant_baseline::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_DOMINANT_BASELINE_AUTO as u8,
                Keyword::UseScript =>
                    structs::NS_STYLE_DOMINANT_BASELINE_USE_SCRIPT as u8,
                Keyword::NoChange =>
                    structs::NS_STYLE_DOMINANT_BASELINE_NO_CHANGE as u8,
                Keyword::ResetSize =>
                    structs::NS_STYLE_DOMINANT_BASELINE_RESET_SIZE as u8,
                Keyword::Ideographic =>
                    structs::NS_STYLE_DOMINANT_BASELINE_IDEOGRAPHIC as u8,
                Keyword::Alphabetic =>
                    structs::NS_STYLE_DOMINANT_BASELINE_ALPHABETIC as u8,
                Keyword::Hanging =>
                    structs::NS_STYLE_DOMINANT_BASELINE_HANGING as u8,
                Keyword::Mathematical =>
                    structs::NS_STYLE_DOMINANT_BASELINE_MATHEMATICAL as u8,
                Keyword::Central =>
                    structs::NS_STYLE_DOMINANT_BASELINE_CENTRAL as u8,
                Keyword::Middle =>
                    structs::NS_STYLE_DOMINANT_BASELINE_MIDDLE as u8,
                Keyword::TextAfterEdge =>
                    structs::NS_STYLE_DOMINANT_BASELINE_TEXT_AFTER_EDGE as u8,
                Keyword::TextBeforeEdge =>
                    structs::NS_STYLE_DOMINANT_BASELINE_TEXT_BEFORE_EDGE as u8,
        };
        self.gecko.mDominantBaseline = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_dominant_baseline_from(&mut self, other: &Self) {
        self.gecko.mDominantBaseline = other.gecko.mDominantBaseline.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_dominant_baseline(&mut self, other: &Self) {
        self.copy_dominant_baseline_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_dominant_baseline(&self) -> longhands::dominant_baseline::computed_value::T {
        use crate::properties::longhands::dominant_baseline::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_DOMINANT_BASELINE_AUTO : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_AUTO as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_USE_SCRIPT : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_USE_SCRIPT as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_NO_CHANGE : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_NO_CHANGE as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_RESET_SIZE : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_RESET_SIZE as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_IDEOGRAPHIC : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_IDEOGRAPHIC as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_ALPHABETIC : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_ALPHABETIC as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_HANGING : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_HANGING as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_MATHEMATICAL : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_MATHEMATICAL as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_CENTRAL : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_CENTRAL as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_MIDDLE : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_MIDDLE as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_TEXT_AFTER_EDGE : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_TEXT_AFTER_EDGE as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_TEXT_BEFORE_EDGE : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_TEXT_BEFORE_EDGE as u8;

        match self.gecko.mDominantBaseline as u8 {
            U8_NS_STYLE_DOMINANT_BASELINE_AUTO => Keyword::Auto,
            U8_NS_STYLE_DOMINANT_BASELINE_USE_SCRIPT => Keyword::UseScript,
            U8_NS_STYLE_DOMINANT_BASELINE_NO_CHANGE => Keyword::NoChange,
            U8_NS_STYLE_DOMINANT_BASELINE_RESET_SIZE => Keyword::ResetSize,
            U8_NS_STYLE_DOMINANT_BASELINE_IDEOGRAPHIC => Keyword::Ideographic,
            U8_NS_STYLE_DOMINANT_BASELINE_ALPHABETIC => Keyword::Alphabetic,
            U8_NS_STYLE_DOMINANT_BASELINE_HANGING => Keyword::Hanging,
            U8_NS_STYLE_DOMINANT_BASELINE_MATHEMATICAL => Keyword::Mathematical,
            U8_NS_STYLE_DOMINANT_BASELINE_CENTRAL => Keyword::Central,
            U8_NS_STYLE_DOMINANT_BASELINE_MIDDLE => Keyword::Middle,
            U8_NS_STYLE_DOMINANT_BASELINE_TEXT_AFTER_EDGE => Keyword::TextAfterEdge,
            U8_NS_STYLE_DOMINANT_BASELINE_TEXT_BEFORE_EDGE => Keyword::TextBeforeEdge,
            _ => panic!("Found unexpected value in style struct for dominant_baseline property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_vector_effect(&mut self, v: longhands::vector_effect::computed_value::T) {
        use crate::properties::longhands::vector_effect::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::NS_STYLE_VECTOR_EFFECT_NONE as u8,
                Keyword::NonScalingStroke =>
                    structs::NS_STYLE_VECTOR_EFFECT_NON_SCALING_STROKE as u8,
        };
        self.gecko.mVectorEffect = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_vector_effect_from(&mut self, other: &Self) {
        self.gecko.mVectorEffect = other.gecko.mVectorEffect.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_vector_effect(&mut self, other: &Self) {
        self.copy_vector_effect_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_vector_effect(&self) -> longhands::vector_effect::computed_value::T {
        use crate::properties::longhands::vector_effect::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_VECTOR_EFFECT_NONE : u8 =
            structs::NS_STYLE_VECTOR_EFFECT_NONE as u8;
        const U8_NS_STYLE_VECTOR_EFFECT_NON_SCALING_STROKE : u8 =
            structs::NS_STYLE_VECTOR_EFFECT_NON_SCALING_STROKE as u8;

        match self.gecko.mVectorEffect as u8 {
            U8_NS_STYLE_VECTOR_EFFECT_NONE => Keyword::None,
            U8_NS_STYLE_VECTOR_EFFECT_NON_SCALING_STROKE => Keyword::NonScalingStroke,
            _ => panic!("Found unexpected value in style struct for vector_effect property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_stop_color(&mut self, v: longhands::stop_color::computed_value::T) {
        self.gecko.mStopColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stop_color_from(&mut self, other: &Self) {
        self.gecko.mStopColor = other.gecko.mStopColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stop_color(&mut self, other: &Self) {
        self.copy_stop_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stop_color(&self) -> longhands::stop_color::computed_value::T {
        From::from(self.gecko.mStopColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_stop_opacity(&mut self, v: longhands::stop_opacity::computed_value::T) {
        self.gecko.mStopOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stop_opacity_from(&mut self, other: &Self) {
        self.gecko.mStopOpacity = other.gecko.mStopOpacity.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stop_opacity(&mut self, other: &Self) {
        self.copy_stop_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stop_opacity(&self) -> longhands::stop_opacity::computed_value::T {
        From::from(self.gecko.mStopOpacity.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_flood_color(&mut self, v: longhands::flood_color::computed_value::T) {
        self.gecko.mFloodColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_flood_color_from(&mut self, other: &Self) {
        self.gecko.mFloodColor = other.gecko.mFloodColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flood_color(&mut self, other: &Self) {
        self.copy_flood_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flood_color(&self) -> longhands::flood_color::computed_value::T {
        From::from(self.gecko.mFloodColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_flood_opacity(&mut self, v: longhands::flood_opacity::computed_value::T) {
        self.gecko.mFloodOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_flood_opacity_from(&mut self, other: &Self) {
        self.gecko.mFloodOpacity = other.gecko.mFloodOpacity.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flood_opacity(&mut self, other: &Self) {
        self.copy_flood_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flood_opacity(&self) -> longhands::flood_opacity::computed_value::T {
        From::from(self.gecko.mFloodOpacity.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_lighting_color(&mut self, v: longhands::lighting_color::computed_value::T) {
        self.gecko.mLightingColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_lighting_color_from(&mut self, other: &Self) {
        self.gecko.mLightingColor = other.gecko.mLightingColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_lighting_color(&mut self, other: &Self) {
        self.copy_lighting_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_lighting_color(&self) -> longhands::lighting_color::computed_value::T {
        From::from(self.gecko.mLightingColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_mask_type(&mut self, v: longhands::mask_type::computed_value::T) {
        use crate::properties::longhands::mask_type::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Luminance =>
                    structs::NS_STYLE_MASK_TYPE_LUMINANCE as u8,
                Keyword::Alpha =>
                    structs::NS_STYLE_MASK_TYPE_ALPHA as u8,
        };
        self.gecko.mMaskType = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_mask_type_from(&mut self, other: &Self) {
        self.gecko.mMaskType = other.gecko.mMaskType.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_mask_type(&mut self, other: &Self) {
        self.copy_mask_type_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_mask_type(&self) -> longhands::mask_type::computed_value::T {
        use crate::properties::longhands::mask_type::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_MASK_TYPE_LUMINANCE : u8 =
            structs::NS_STYLE_MASK_TYPE_LUMINANCE as u8;
        const U8_NS_STYLE_MASK_TYPE_ALPHA : u8 =
            structs::NS_STYLE_MASK_TYPE_ALPHA as u8;

        match self.gecko.mMaskType as u8 {
            U8_NS_STYLE_MASK_TYPE_LUMINANCE => Keyword::Luminance,
            U8_NS_STYLE_MASK_TYPE_ALPHA => Keyword::Alpha,
            _ => panic!("Found unexpected value in style struct for mask_type property"),
        }
    }


}




impl GeckoInheritedSVG {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn set_paint_order(&mut self, v: longhands::paint_order::computed_value::T) {
        self.gecko.mPaintOrder = v.0;
    }

    
    #[allow(non_snake_case)]
    pub fn copy_paint_order_from(&mut self, other: &Self) {
        self.gecko.mPaintOrder = other.gecko.mPaintOrder.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_paint_order(&mut self, other: &Self) {
        self.copy_paint_order_from(other)
    }


    pub fn clone_paint_order(&self) -> longhands::paint_order::computed_value::T {
        use crate::properties::longhands::paint_order::computed_value::T;
        T(self.gecko.mPaintOrder)
    }

    pub fn set_stroke_dasharray(&mut self, v: longhands::stroke_dasharray::computed_value::T) {
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_DASHARRAY_CONTEXT as CONTEXT_VALUE;
        use crate::values::generics::svg::SVGStrokeDashArray;

        match v {
            SVGStrokeDashArray::Values(v) => {
                let v = v.into_iter();
                self.gecko.mContextFlags &= !CONTEXT_VALUE;
                unsafe {
                    bindings::Gecko_nsStyleSVG_SetDashArrayLength(&mut *self.gecko, v.len() as u32);
                }
                for (gecko, servo) in self.gecko.mStrokeDasharray.iter_mut().zip(v) {
                    *gecko = servo;
                }
            }
            SVGStrokeDashArray::ContextValue => {
                self.gecko.mContextFlags |= CONTEXT_VALUE;
                unsafe {
                    bindings::Gecko_nsStyleSVG_SetDashArrayLength(&mut *self.gecko, 0);
                }
            }
        }
    }

    pub fn copy_stroke_dasharray_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_DASHARRAY_CONTEXT as CONTEXT_VALUE;
        unsafe {
            bindings::Gecko_nsStyleSVG_CopyDashArray(&mut *self.gecko, &*other.gecko);
        }
        self.gecko.mContextFlags =
            (self.gecko.mContextFlags & !CONTEXT_VALUE) |
            (other.gecko.mContextFlags & CONTEXT_VALUE);
    }

    pub fn reset_stroke_dasharray(&mut self, other: &Self) {
        self.copy_stroke_dasharray_from(other)
    }

    pub fn clone_stroke_dasharray(&self) -> longhands::stroke_dasharray::computed_value::T {
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_DASHARRAY_CONTEXT as CONTEXT_VALUE;
        use crate::values::generics::svg::SVGStrokeDashArray;

        if self.gecko.mContextFlags & CONTEXT_VALUE != 0 {
            debug_assert_eq!(self.gecko.mStrokeDasharray.len(), 0);
            return SVGStrokeDashArray::ContextValue;
        }
        SVGStrokeDashArray::Values(self.gecko.mStrokeDasharray.iter().cloned().collect())
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_text_anchor(&mut self, v: longhands::text_anchor::computed_value::T) {
        use crate::properties::longhands::text_anchor::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Start =>
                    structs::NS_STYLE_TEXT_ANCHOR_START as u8,
                Keyword::Middle =>
                    structs::NS_STYLE_TEXT_ANCHOR_MIDDLE as u8,
                Keyword::End =>
                    structs::NS_STYLE_TEXT_ANCHOR_END as u8,
        };
        self.gecko.mTextAnchor = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_anchor_from(&mut self, other: &Self) {
        self.gecko.mTextAnchor = other.gecko.mTextAnchor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_anchor(&mut self, other: &Self) {
        self.copy_text_anchor_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_text_anchor(&self) -> longhands::text_anchor::computed_value::T {
        use crate::properties::longhands::text_anchor::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TEXT_ANCHOR_START : u8 =
            structs::NS_STYLE_TEXT_ANCHOR_START as u8;
        const U8_NS_STYLE_TEXT_ANCHOR_MIDDLE : u8 =
            structs::NS_STYLE_TEXT_ANCHOR_MIDDLE as u8;
        const U8_NS_STYLE_TEXT_ANCHOR_END : u8 =
            structs::NS_STYLE_TEXT_ANCHOR_END as u8;

        match self.gecko.mTextAnchor as u8 {
            U8_NS_STYLE_TEXT_ANCHOR_START => Keyword::Start,
            U8_NS_STYLE_TEXT_ANCHOR_MIDDLE => Keyword::Middle,
            U8_NS_STYLE_TEXT_ANCHOR_END => Keyword::End,
            _ => panic!("Found unexpected value in style struct for text_anchor property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_color_interpolation(&mut self, v: longhands::color_interpolation::computed_value::T) {
        use crate::properties::longhands::color_interpolation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Srgb =>
                    structs::NS_STYLE_COLOR_INTERPOLATION_SRGB as u8,
                Keyword::Auto =>
                    structs::NS_STYLE_COLOR_INTERPOLATION_AUTO as u8,
                Keyword::Linearrgb =>
                    structs::NS_STYLE_COLOR_INTERPOLATION_LINEARRGB as u8,
        };
        self.gecko.mColorInterpolation = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_color_interpolation_from(&mut self, other: &Self) {
        self.gecko.mColorInterpolation = other.gecko.mColorInterpolation.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_color_interpolation(&mut self, other: &Self) {
        self.copy_color_interpolation_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_color_interpolation(&self) -> longhands::color_interpolation::computed_value::T {
        use crate::properties::longhands::color_interpolation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_COLOR_INTERPOLATION_SRGB : u8 =
            structs::NS_STYLE_COLOR_INTERPOLATION_SRGB as u8;
        const U8_NS_STYLE_COLOR_INTERPOLATION_AUTO : u8 =
            structs::NS_STYLE_COLOR_INTERPOLATION_AUTO as u8;
        const U8_NS_STYLE_COLOR_INTERPOLATION_LINEARRGB : u8 =
            structs::NS_STYLE_COLOR_INTERPOLATION_LINEARRGB as u8;

        match self.gecko.mColorInterpolation as u8 {
            U8_NS_STYLE_COLOR_INTERPOLATION_SRGB => Keyword::Srgb,
            U8_NS_STYLE_COLOR_INTERPOLATION_AUTO => Keyword::Auto,
            U8_NS_STYLE_COLOR_INTERPOLATION_LINEARRGB => Keyword::Linearrgb,
            _ => panic!("Found unexpected value in style struct for color_interpolation property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_color_interpolation_filters(&mut self, v: longhands::color_interpolation_filters::computed_value::T) {
        use crate::properties::longhands::color_interpolation_filters::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Linearrgb =>
                    structs::NS_STYLE_COLOR_INTERPOLATION_LINEARRGB as u8,
                Keyword::Auto =>
                    structs::NS_STYLE_COLOR_INTERPOLATION_AUTO as u8,
                Keyword::Srgb =>
                    structs::NS_STYLE_COLOR_INTERPOLATION_SRGB as u8,
        };
        self.gecko.mColorInterpolationFilters = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_color_interpolation_filters_from(&mut self, other: &Self) {
        self.gecko.mColorInterpolationFilters = other.gecko.mColorInterpolationFilters.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_color_interpolation_filters(&mut self, other: &Self) {
        self.copy_color_interpolation_filters_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_color_interpolation_filters(&self) -> longhands::color_interpolation_filters::computed_value::T {
        use crate::properties::longhands::color_interpolation_filters::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_COLOR_INTERPOLATION_LINEARRGB : u8 =
            structs::NS_STYLE_COLOR_INTERPOLATION_LINEARRGB as u8;
        const U8_NS_STYLE_COLOR_INTERPOLATION_AUTO : u8 =
            structs::NS_STYLE_COLOR_INTERPOLATION_AUTO as u8;
        const U8_NS_STYLE_COLOR_INTERPOLATION_SRGB : u8 =
            structs::NS_STYLE_COLOR_INTERPOLATION_SRGB as u8;

        match self.gecko.mColorInterpolationFilters as u8 {
            U8_NS_STYLE_COLOR_INTERPOLATION_LINEARRGB => Keyword::Linearrgb,
            U8_NS_STYLE_COLOR_INTERPOLATION_AUTO => Keyword::Auto,
            U8_NS_STYLE_COLOR_INTERPOLATION_SRGB => Keyword::Srgb,
            _ => panic!("Found unexpected value in style struct for color_interpolation_filters property"),
        }
    }


    #[allow(non_snake_case)]
    pub fn set_fill(&mut self, mut v: longhands::fill::computed_value::T) {
        use crate::values::generics::svg::SVGPaintKind;
        use self::structs::nsStyleSVGPaintType;
        use self::structs::nsStyleSVGFallbackType;

        let ref mut paint = self.gecko.mFill;
        unsafe {
            bindings::Gecko_nsStyleSVGPaint_Reset(paint);
        }
        let fallback = v.fallback.take();
        match v.kind {
            SVGPaintKind::None => return,
            SVGPaintKind::ContextFill => {
                paint.mType = nsStyleSVGPaintType::eStyleSVGPaintType_ContextFill;
            }
            SVGPaintKind::ContextStroke => {
                paint.mType = nsStyleSVGPaintType::eStyleSVGPaintType_ContextStroke;
            }
            SVGPaintKind::PaintServer(url) => {
                unsafe {
                    bindings::Gecko_nsStyleSVGPaint_SetURLValue(
                        paint,
                        url.url_value_ptr(),
                    )
                }
            }
            SVGPaintKind::Color(color) => {
                paint.mType = nsStyleSVGPaintType::eStyleSVGPaintType_Color;
                unsafe {
                    *paint.mPaint.mColor.as_mut() = color.into();
                }
            }
        }

        paint.mFallbackType = match fallback {
            Some(Either::First(color)) => {
                paint.mFallbackColor = color.into();
                nsStyleSVGFallbackType::eStyleSVGFallbackType_Color
            },
            Some(Either::Second(_)) => {
                nsStyleSVGFallbackType::eStyleSVGFallbackType_None
            },
            None => nsStyleSVGFallbackType::eStyleSVGFallbackType_NotSet
        };
    }

    #[allow(non_snake_case)]
    pub fn copy_fill_from(&mut self, other: &Self) {
        unsafe {
            bindings::Gecko_nsStyleSVGPaint_CopyFrom(
                &mut self.gecko.mFill,
                & other.gecko.mFill
            );
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_fill(&mut self, other: &Self) {
        self.copy_fill_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_fill(&self) -> longhands::fill::computed_value::T {
        use crate::values::computed::url::ComputedUrl;
        use crate::values::generics::svg::{SVGPaint, SVGPaintKind};
        use self::structs::nsStyleSVGPaintType;
        use self::structs::nsStyleSVGFallbackType;
        let ref paint = self.gecko.mFill;

        let fallback = match paint.mFallbackType {
            nsStyleSVGFallbackType::eStyleSVGFallbackType_Color => {
                Some(Either::First(paint.mFallbackColor.into()))
            },
            nsStyleSVGFallbackType::eStyleSVGFallbackType_None => {
                Some(Either::Second(None_))
            },
            nsStyleSVGFallbackType::eStyleSVGFallbackType_NotSet => None,
        };

        let kind = match paint.mType {
            nsStyleSVGPaintType::eStyleSVGPaintType_None => SVGPaintKind::None,
            nsStyleSVGPaintType::eStyleSVGPaintType_ContextFill => SVGPaintKind::ContextFill,
            nsStyleSVGPaintType::eStyleSVGPaintType_ContextStroke => SVGPaintKind::ContextStroke,
            nsStyleSVGPaintType::eStyleSVGPaintType_Server => {
                SVGPaintKind::PaintServer(unsafe {
                    let url = RefPtr::new(*paint.mPaint.mPaintServer.as_ref());
                    ComputedUrl::from_url_value(url)
                })
            }
            nsStyleSVGPaintType::eStyleSVGPaintType_Color => {
                let col = unsafe { *paint.mPaint.mColor.as_ref() };
                SVGPaintKind::Color(col.into())
            }
        };
        SVGPaint {
            kind: kind,
            fallback: fallback,
        }
    }

    

    pub fn set_fill_opacity(&mut self, v: longhands::fill_opacity::computed_value::T) {
        use crate::gecko_bindings::structs::nsStyleSVG_FILL_OPACITY_SOURCE_MASK as MASK;
        use crate::gecko_bindings::structs::nsStyleSVG_FILL_OPACITY_SOURCE_SHIFT as SHIFT;
        use crate::gecko_bindings::structs::nsStyleSVGOpacitySource::*;
        use crate::values::generics::svg::SVGOpacity;
        self.gecko.mContextFlags &= !MASK;
        match v {
            SVGOpacity::Opacity(opacity) => {
                self.gecko.mContextFlags |=
                    (eStyleSVGOpacitySource_Normal as u8) << SHIFT;
                self.gecko.mFillOpacity = opacity;
            }
            SVGOpacity::ContextFillOpacity => {
                self.gecko.mContextFlags |=
                    (eStyleSVGOpacitySource_ContextFillOpacity as u8) << SHIFT;
                self.gecko.mFillOpacity = 1.;
            }
            SVGOpacity::ContextStrokeOpacity => {
                self.gecko.mContextFlags |=
                    (eStyleSVGOpacitySource_ContextStrokeOpacity as u8) << SHIFT;
                self.gecko.mFillOpacity = 1.;
            }
        }
    }

    pub fn copy_fill_opacity_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleSVG_FILL_OPACITY_SOURCE_MASK as MASK;
        self.gecko.mFillOpacity = other.gecko.mFillOpacity;
        self.gecko.mContextFlags =
            (self.gecko.mContextFlags & !MASK) |
            (other.gecko.mContextFlags & MASK);
    }

    pub fn reset_fill_opacity(&mut self, other: &Self) {
        self.copy_fill_opacity_from(other)
    }

    pub fn clone_fill_opacity(&self) -> longhands::fill_opacity::computed_value::T {
        use crate::gecko_bindings::structs::nsStyleSVG_FILL_OPACITY_SOURCE_MASK as MASK;
        use crate::gecko_bindings::structs::nsStyleSVG_FILL_OPACITY_SOURCE_SHIFT as SHIFT;
        use crate::gecko_bindings::structs::nsStyleSVGOpacitySource::*;
        use crate::values::generics::svg::SVGOpacity;

        let source = (self.gecko.mContextFlags & MASK) >> SHIFT;
        if source == eStyleSVGOpacitySource_Normal as u8 {
            return SVGOpacity::Opacity(self.gecko.mFillOpacity);
        } else {
            debug_assert_eq!(self.gecko.mFillOpacity, 1.0);
            if source == eStyleSVGOpacitySource_ContextFillOpacity as u8 {
                SVGOpacity::ContextFillOpacity
            } else {
                debug_assert_eq!(source, eStyleSVGOpacitySource_ContextStrokeOpacity as u8);
                SVGOpacity::ContextStrokeOpacity
            }
        }
    }


    #[allow(non_snake_case)]
    pub fn set_fill_rule(&mut self, v: longhands::fill_rule::computed_value::T) {
        self.gecko.mFillRule = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_fill_rule_from(&mut self, other: &Self) {
        self.gecko.mFillRule = other.gecko.mFillRule.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_fill_rule(&mut self, other: &Self) {
        self.copy_fill_rule_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_fill_rule(&self) -> longhands::fill_rule::computed_value::T {
        From::from(self.gecko.mFillRule.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_shape_rendering(&mut self, v: longhands::shape_rendering::computed_value::T) {
        use crate::properties::longhands::shape_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_SHAPE_RENDERING_AUTO as u8,
                Keyword::Optimizespeed =>
                    structs::NS_STYLE_SHAPE_RENDERING_OPTIMIZESPEED as u8,
                Keyword::Crispedges =>
                    structs::NS_STYLE_SHAPE_RENDERING_CRISPEDGES as u8,
                Keyword::Geometricprecision =>
                    structs::NS_STYLE_SHAPE_RENDERING_GEOMETRICPRECISION as u8,
        };
        self.gecko.mShapeRendering = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_shape_rendering_from(&mut self, other: &Self) {
        self.gecko.mShapeRendering = other.gecko.mShapeRendering.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_shape_rendering(&mut self, other: &Self) {
        self.copy_shape_rendering_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_shape_rendering(&self) -> longhands::shape_rendering::computed_value::T {
        use crate::properties::longhands::shape_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_SHAPE_RENDERING_AUTO : u8 =
            structs::NS_STYLE_SHAPE_RENDERING_AUTO as u8;
        const U8_NS_STYLE_SHAPE_RENDERING_OPTIMIZESPEED : u8 =
            structs::NS_STYLE_SHAPE_RENDERING_OPTIMIZESPEED as u8;
        const U8_NS_STYLE_SHAPE_RENDERING_CRISPEDGES : u8 =
            structs::NS_STYLE_SHAPE_RENDERING_CRISPEDGES as u8;
        const U8_NS_STYLE_SHAPE_RENDERING_GEOMETRICPRECISION : u8 =
            structs::NS_STYLE_SHAPE_RENDERING_GEOMETRICPRECISION as u8;

        match self.gecko.mShapeRendering as u8 {
            U8_NS_STYLE_SHAPE_RENDERING_AUTO => Keyword::Auto,
            U8_NS_STYLE_SHAPE_RENDERING_OPTIMIZESPEED => Keyword::Optimizespeed,
            U8_NS_STYLE_SHAPE_RENDERING_CRISPEDGES => Keyword::Crispedges,
            U8_NS_STYLE_SHAPE_RENDERING_GEOMETRICPRECISION => Keyword::Geometricprecision,
            _ => panic!("Found unexpected value in style struct for shape_rendering property"),
        }
    }


    #[allow(non_snake_case)]
    pub fn set_stroke(&mut self, mut v: longhands::stroke::computed_value::T) {
        use crate::values::generics::svg::SVGPaintKind;
        use self::structs::nsStyleSVGPaintType;
        use self::structs::nsStyleSVGFallbackType;

        let ref mut paint = self.gecko.mStroke;
        unsafe {
            bindings::Gecko_nsStyleSVGPaint_Reset(paint);
        }
        let fallback = v.fallback.take();
        match v.kind {
            SVGPaintKind::None => return,
            SVGPaintKind::ContextFill => {
                paint.mType = nsStyleSVGPaintType::eStyleSVGPaintType_ContextFill;
            }
            SVGPaintKind::ContextStroke => {
                paint.mType = nsStyleSVGPaintType::eStyleSVGPaintType_ContextStroke;
            }
            SVGPaintKind::PaintServer(url) => {
                unsafe {
                    bindings::Gecko_nsStyleSVGPaint_SetURLValue(
                        paint,
                        url.url_value_ptr(),
                    )
                }
            }
            SVGPaintKind::Color(color) => {
                paint.mType = nsStyleSVGPaintType::eStyleSVGPaintType_Color;
                unsafe {
                    *paint.mPaint.mColor.as_mut() = color.into();
                }
            }
        }

        paint.mFallbackType = match fallback {
            Some(Either::First(color)) => {
                paint.mFallbackColor = color.into();
                nsStyleSVGFallbackType::eStyleSVGFallbackType_Color
            },
            Some(Either::Second(_)) => {
                nsStyleSVGFallbackType::eStyleSVGFallbackType_None
            },
            None => nsStyleSVGFallbackType::eStyleSVGFallbackType_NotSet
        };
    }

    #[allow(non_snake_case)]
    pub fn copy_stroke_from(&mut self, other: &Self) {
        unsafe {
            bindings::Gecko_nsStyleSVGPaint_CopyFrom(
                &mut self.gecko.mStroke,
                & other.gecko.mStroke
            );
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke(&mut self, other: &Self) {
        self.copy_stroke_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_stroke(&self) -> longhands::stroke::computed_value::T {
        use crate::values::computed::url::ComputedUrl;
        use crate::values::generics::svg::{SVGPaint, SVGPaintKind};
        use self::structs::nsStyleSVGPaintType;
        use self::structs::nsStyleSVGFallbackType;
        let ref paint = self.gecko.mStroke;

        let fallback = match paint.mFallbackType {
            nsStyleSVGFallbackType::eStyleSVGFallbackType_Color => {
                Some(Either::First(paint.mFallbackColor.into()))
            },
            nsStyleSVGFallbackType::eStyleSVGFallbackType_None => {
                Some(Either::Second(None_))
            },
            nsStyleSVGFallbackType::eStyleSVGFallbackType_NotSet => None,
        };

        let kind = match paint.mType {
            nsStyleSVGPaintType::eStyleSVGPaintType_None => SVGPaintKind::None,
            nsStyleSVGPaintType::eStyleSVGPaintType_ContextFill => SVGPaintKind::ContextFill,
            nsStyleSVGPaintType::eStyleSVGPaintType_ContextStroke => SVGPaintKind::ContextStroke,
            nsStyleSVGPaintType::eStyleSVGPaintType_Server => {
                SVGPaintKind::PaintServer(unsafe {
                    let url = RefPtr::new(*paint.mPaint.mPaintServer.as_ref());
                    ComputedUrl::from_url_value(url)
                })
            }
            nsStyleSVGPaintType::eStyleSVGPaintType_Color => {
                let col = unsafe { *paint.mPaint.mColor.as_ref() };
                SVGPaintKind::Color(col.into())
            }
        };
        SVGPaint {
            kind: kind,
            fallback: fallback,
        }
    }

    // When context-value is used on an SVG length, the corresponding flag is
    // set on mContextFlags, and the length field is set to the initial value.

    pub fn set_stroke_width(&mut self, v: longhands::stroke_width::computed_value::T) {
        use crate::values::generics::svg::SVGLength;
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_WIDTH_CONTEXT as CONTEXT_VALUE;
        let length = match v {
            SVGLength::LengthPercentage(length) => {
                self.gecko.mContextFlags &= !CONTEXT_VALUE;
                length
            }
            SVGLength::ContextValue => {
                self.gecko.mContextFlags |= CONTEXT_VALUE;
                match longhands::stroke_width::get_initial_value() {
                    SVGLength::LengthPercentage(length) => length,
                    _ => unreachable!("Initial value should not be context-value"),
                }
            }
        };
        self.gecko.mStrokeWidth = length;
    }

    pub fn copy_stroke_width_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_WIDTH_CONTEXT as CONTEXT_VALUE;
        self.gecko.mStrokeWidth = other.gecko.mStrokeWidth;
        self.gecko.mContextFlags =
            (self.gecko.mContextFlags & !CONTEXT_VALUE) |
            (other.gecko.mContextFlags & CONTEXT_VALUE);
    }

    pub fn reset_stroke_width(&mut self, other: &Self) {
        self.copy_stroke_width_from(other)
    }

    pub fn clone_stroke_width(&self) -> longhands::stroke_width::computed_value::T {
        use crate::values::generics::svg::SVGLength;
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_WIDTH_CONTEXT as CONTEXT_VALUE;
        if (self.gecko.mContextFlags & CONTEXT_VALUE) != 0 {
            return SVGLength::ContextValue;
        }
        SVGLength::LengthPercentage(self.gecko.mStrokeWidth)
    }


    #[allow(non_snake_case)]
    pub fn set_stroke_linecap(&mut self, v: longhands::stroke_linecap::computed_value::T) {
        use crate::properties::longhands::stroke_linecap::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Butt =>
                    structs::NS_STYLE_STROKE_LINECAP_BUTT as u8,
                Keyword::Round =>
                    structs::NS_STYLE_STROKE_LINECAP_ROUND as u8,
                Keyword::Square =>
                    structs::NS_STYLE_STROKE_LINECAP_SQUARE as u8,
        };
        self.gecko.mStrokeLinecap = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_linecap_from(&mut self, other: &Self) {
        self.gecko.mStrokeLinecap = other.gecko.mStrokeLinecap.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_linecap(&mut self, other: &Self) {
        self.copy_stroke_linecap_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_stroke_linecap(&self) -> longhands::stroke_linecap::computed_value::T {
        use crate::properties::longhands::stroke_linecap::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_STROKE_LINECAP_BUTT : u8 =
            structs::NS_STYLE_STROKE_LINECAP_BUTT as u8;
        const U8_NS_STYLE_STROKE_LINECAP_ROUND : u8 =
            structs::NS_STYLE_STROKE_LINECAP_ROUND as u8;
        const U8_NS_STYLE_STROKE_LINECAP_SQUARE : u8 =
            structs::NS_STYLE_STROKE_LINECAP_SQUARE as u8;

        match self.gecko.mStrokeLinecap as u8 {
            U8_NS_STYLE_STROKE_LINECAP_BUTT => Keyword::Butt,
            U8_NS_STYLE_STROKE_LINECAP_ROUND => Keyword::Round,
            U8_NS_STYLE_STROKE_LINECAP_SQUARE => Keyword::Square,
            _ => panic!("Found unexpected value in style struct for stroke_linecap property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_stroke_linejoin(&mut self, v: longhands::stroke_linejoin::computed_value::T) {
        use crate::properties::longhands::stroke_linejoin::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Miter =>
                    structs::NS_STYLE_STROKE_LINEJOIN_MITER as u8,
                Keyword::Round =>
                    structs::NS_STYLE_STROKE_LINEJOIN_ROUND as u8,
                Keyword::Bevel =>
                    structs::NS_STYLE_STROKE_LINEJOIN_BEVEL as u8,
        };
        self.gecko.mStrokeLinejoin = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_linejoin_from(&mut self, other: &Self) {
        self.gecko.mStrokeLinejoin = other.gecko.mStrokeLinejoin.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_linejoin(&mut self, other: &Self) {
        self.copy_stroke_linejoin_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_stroke_linejoin(&self) -> longhands::stroke_linejoin::computed_value::T {
        use crate::properties::longhands::stroke_linejoin::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_STROKE_LINEJOIN_MITER : u8 =
            structs::NS_STYLE_STROKE_LINEJOIN_MITER as u8;
        const U8_NS_STYLE_STROKE_LINEJOIN_ROUND : u8 =
            structs::NS_STYLE_STROKE_LINEJOIN_ROUND as u8;
        const U8_NS_STYLE_STROKE_LINEJOIN_BEVEL : u8 =
            structs::NS_STYLE_STROKE_LINEJOIN_BEVEL as u8;

        match self.gecko.mStrokeLinejoin as u8 {
            U8_NS_STYLE_STROKE_LINEJOIN_MITER => Keyword::Miter,
            U8_NS_STYLE_STROKE_LINEJOIN_ROUND => Keyword::Round,
            U8_NS_STYLE_STROKE_LINEJOIN_BEVEL => Keyword::Bevel,
            _ => panic!("Found unexpected value in style struct for stroke_linejoin property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_stroke_miterlimit(&mut self, v: longhands::stroke_miterlimit::computed_value::T) {
        self.gecko.mStrokeMiterlimit = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_miterlimit_from(&mut self, other: &Self) {
        self.gecko.mStrokeMiterlimit = other.gecko.mStrokeMiterlimit.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_miterlimit(&mut self, other: &Self) {
        self.copy_stroke_miterlimit_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stroke_miterlimit(&self) -> longhands::stroke_miterlimit::computed_value::T {
        From::from(self.gecko.mStrokeMiterlimit.clone())
    }


    

    pub fn set_stroke_opacity(&mut self, v: longhands::stroke_opacity::computed_value::T) {
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_OPACITY_SOURCE_MASK as MASK;
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_OPACITY_SOURCE_SHIFT as SHIFT;
        use crate::gecko_bindings::structs::nsStyleSVGOpacitySource::*;
        use crate::values::generics::svg::SVGOpacity;
        self.gecko.mContextFlags &= !MASK;
        match v {
            SVGOpacity::Opacity(opacity) => {
                self.gecko.mContextFlags |=
                    (eStyleSVGOpacitySource_Normal as u8) << SHIFT;
                self.gecko.mStrokeOpacity = opacity;
            }
            SVGOpacity::ContextFillOpacity => {
                self.gecko.mContextFlags |=
                    (eStyleSVGOpacitySource_ContextFillOpacity as u8) << SHIFT;
                self.gecko.mStrokeOpacity = 1.;
            }
            SVGOpacity::ContextStrokeOpacity => {
                self.gecko.mContextFlags |=
                    (eStyleSVGOpacitySource_ContextStrokeOpacity as u8) << SHIFT;
                self.gecko.mStrokeOpacity = 1.;
            }
        }
    }

    pub fn copy_stroke_opacity_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_OPACITY_SOURCE_MASK as MASK;
        self.gecko.mStrokeOpacity = other.gecko.mStrokeOpacity;
        self.gecko.mContextFlags =
            (self.gecko.mContextFlags & !MASK) |
            (other.gecko.mContextFlags & MASK);
    }

    pub fn reset_stroke_opacity(&mut self, other: &Self) {
        self.copy_stroke_opacity_from(other)
    }

    pub fn clone_stroke_opacity(&self) -> longhands::stroke_opacity::computed_value::T {
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_OPACITY_SOURCE_MASK as MASK;
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_OPACITY_SOURCE_SHIFT as SHIFT;
        use crate::gecko_bindings::structs::nsStyleSVGOpacitySource::*;
        use crate::values::generics::svg::SVGOpacity;

        let source = (self.gecko.mContextFlags & MASK) >> SHIFT;
        if source == eStyleSVGOpacitySource_Normal as u8 {
            return SVGOpacity::Opacity(self.gecko.mStrokeOpacity);
        } else {
            debug_assert_eq!(self.gecko.mStrokeOpacity, 1.0);
            if source == eStyleSVGOpacitySource_ContextFillOpacity as u8 {
                SVGOpacity::ContextFillOpacity
            } else {
                debug_assert_eq!(source, eStyleSVGOpacitySource_ContextStrokeOpacity as u8);
                SVGOpacity::ContextStrokeOpacity
            }
        }
    }

    // When context-value is used on an SVG length, the corresponding flag is
    // set on mContextFlags, and the length field is set to the initial value.

    pub fn set_stroke_dashoffset(&mut self, v: longhands::stroke_dashoffset::computed_value::T) {
        use crate::values::generics::svg::SVGLength;
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_DASHOFFSET_CONTEXT as CONTEXT_VALUE;
        let length = match v {
            SVGLength::LengthPercentage(length) => {
                self.gecko.mContextFlags &= !CONTEXT_VALUE;
                length
            }
            SVGLength::ContextValue => {
                self.gecko.mContextFlags |= CONTEXT_VALUE;
                match longhands::stroke_dashoffset::get_initial_value() {
                    SVGLength::LengthPercentage(length) => length,
                    _ => unreachable!("Initial value should not be context-value"),
                }
            }
        };
        self.gecko.mStrokeDashoffset = length;
    }

    pub fn copy_stroke_dashoffset_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_DASHOFFSET_CONTEXT as CONTEXT_VALUE;
        self.gecko.mStrokeDashoffset = other.gecko.mStrokeDashoffset;
        self.gecko.mContextFlags =
            (self.gecko.mContextFlags & !CONTEXT_VALUE) |
            (other.gecko.mContextFlags & CONTEXT_VALUE);
    }

    pub fn reset_stroke_dashoffset(&mut self, other: &Self) {
        self.copy_stroke_dashoffset_from(other)
    }

    pub fn clone_stroke_dashoffset(&self) -> longhands::stroke_dashoffset::computed_value::T {
        use crate::values::generics::svg::SVGLength;
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_DASHOFFSET_CONTEXT as CONTEXT_VALUE;
        if (self.gecko.mContextFlags & CONTEXT_VALUE) != 0 {
            return SVGLength::ContextValue;
        }
        SVGLength::LengthPercentage(self.gecko.mStrokeDashoffset)
    }


    #[allow(non_snake_case)]
    pub fn set_clip_rule(&mut self, v: longhands::clip_rule::computed_value::T) {
        self.gecko.mClipRule = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_clip_rule_from(&mut self, other: &Self) {
        self.gecko.mClipRule = other.gecko.mClipRule.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_clip_rule(&mut self, other: &Self) {
        self.copy_clip_rule_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_clip_rule(&self) -> longhands::clip_rule::computed_value::T {
        From::from(self.gecko.mClipRule.clone())
    }


    #[allow(non_snake_case)]
    pub fn set_marker_start(&mut self, v: longhands::marker_start::computed_value::T) {
        match v {
            UrlOrNone::Url(ref url) => {
                self.gecko.mMarkerStart.set_move(url.clone_url_value())
            }
            UrlOrNone::None => {
                unsafe {
                    self.gecko.mMarkerStart.clear();
                }
            }
        }
    }
    #[allow(non_snake_case)]
    pub fn copy_marker_start_from(&mut self, other: &Self) {
        unsafe {
            self.gecko.mMarkerStart.set(&other.gecko.mMarkerStart);
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_marker_start(&mut self, other: &Self) {
        self.copy_marker_start_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_marker_start(&self) -> longhands::marker_start::computed_value::T {
        use crate::values::computed::url::ComputedUrl;

        if self.gecko.mMarkerStart.mRawPtr.is_null() {
            return UrlOrNone::none()
        }

        UrlOrNone::Url(unsafe {
            ComputedUrl::from_url_value(self.gecko.mMarkerStart.to_safe())
        })
    }

    #[allow(non_snake_case)]
    pub fn set_marker_mid(&mut self, v: longhands::marker_mid::computed_value::T) {
        match v {
            UrlOrNone::Url(ref url) => {
                self.gecko.mMarkerMid.set_move(url.clone_url_value())
            }
            UrlOrNone::None => {
                unsafe {
                    self.gecko.mMarkerMid.clear();
                }
            }
        }
    }
    #[allow(non_snake_case)]
    pub fn copy_marker_mid_from(&mut self, other: &Self) {
        unsafe {
            self.gecko.mMarkerMid.set(&other.gecko.mMarkerMid);
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_marker_mid(&mut self, other: &Self) {
        self.copy_marker_mid_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_marker_mid(&self) -> longhands::marker_mid::computed_value::T {
        use crate::values::computed::url::ComputedUrl;

        if self.gecko.mMarkerMid.mRawPtr.is_null() {
            return UrlOrNone::none()
        }

        UrlOrNone::Url(unsafe {
            ComputedUrl::from_url_value(self.gecko.mMarkerMid.to_safe())
        })
    }

    #[allow(non_snake_case)]
    pub fn set_marker_end(&mut self, v: longhands::marker_end::computed_value::T) {
        match v {
            UrlOrNone::Url(ref url) => {
                self.gecko.mMarkerEnd.set_move(url.clone_url_value())
            }
            UrlOrNone::None => {
                unsafe {
                    self.gecko.mMarkerEnd.clear();
                }
            }
        }
    }
    #[allow(non_snake_case)]
    pub fn copy_marker_end_from(&mut self, other: &Self) {
        unsafe {
            self.gecko.mMarkerEnd.set(&other.gecko.mMarkerEnd);
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_marker_end(&mut self, other: &Self) {
        self.copy_marker_end_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_marker_end(&self) -> longhands::marker_end::computed_value::T {
        use crate::values::computed::url::ComputedUrl;

        if self.gecko.mMarkerEnd.mRawPtr.is_null() {
            return UrlOrNone::none()
        }

        UrlOrNone::Url(unsafe {
            ComputedUrl::from_url_value(self.gecko.mMarkerEnd.to_safe())
        })
    }


    #[allow(non_snake_case)]
    pub fn set__moz_context_properties(&mut self, v: longhands::_moz_context_properties::computed_value::T) {
        self.gecko.mMozContextProperties = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_context_properties_from(&mut self, other: &Self) {
        self.gecko.mMozContextProperties = other.gecko.mMozContextProperties.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_context_properties(&mut self, other: &Self) {
        self.copy__moz_context_properties_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_context_properties(&self) -> longhands::_moz_context_properties::computed_value::T {
        From::from(self.gecko.mMozContextProperties.clone())
    }


}




impl GeckoColor {
    /*
     * Manually-Implemented Methods.
     */
    


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_color(&mut self, v: longhands::color::computed_value::T) {
        self.gecko.mColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_color_from(&mut self, other: &Self) {
        self.gecko.mColor = other.gecko.mColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_color(&mut self, other: &Self) {
        self.copy_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_color(&self) -> longhands::color::computed_value::T {
        From::from(self.gecko.mColor.clone())
    }


}




impl GeckoInheritedUI {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn set_cursor(&mut self, v: longhands::cursor::computed_value::T) {
        self.gecko.mCursor = v.keyword;
        unsafe {
            Gecko_SetCursorArrayLength(&mut *self.gecko, v.images.len());
        }
        for i in 0..v.images.len() {
            unsafe {
                Gecko_SetCursorImageValue(
                    &mut self.gecko.mCursorImages[i],
                    v.images[i].url.url_value_ptr(),
                );
            }

            match v.images[i].hotspot {
                Some((x, y)) => {
                    self.gecko.mCursorImages[i].mHaveHotspot = true;
                    self.gecko.mCursorImages[i].mHotspotX = x;
                    self.gecko.mCursorImages[i].mHotspotY = y;
                },
                _ => {
                    self.gecko.mCursorImages[i].mHaveHotspot = false;
                }
            }
        }
    }

    pub fn copy_cursor_from(&mut self, other: &Self) {
        self.gecko.mCursor = other.gecko.mCursor;
        unsafe {
            Gecko_CopyCursorArrayFrom(&mut *self.gecko, &*other.gecko);
        }
    }

    pub fn reset_cursor(&mut self, other: &Self) {
        self.copy_cursor_from(other)
    }

    pub fn clone_cursor(&self) -> longhands::cursor::computed_value::T {
        use crate::values::computed::ui::CursorImage;
        use crate::values::computed::url::ComputedImageUrl;

        let keyword = self.gecko.mCursor;

        let images = self.gecko.mCursorImages.iter().map(|gecko_cursor_image| {
            let url = unsafe {
                let gecko_image_request = gecko_cursor_image.mImage.mRawPtr.as_ref().unwrap();
                ComputedImageUrl::from_image_request(&gecko_image_request)
            };

            let hotspot =
                if gecko_cursor_image.mHaveHotspot {
                    Some((gecko_cursor_image.mHotspotX, gecko_cursor_image.mHotspotY))
                } else {
                    None
                };

            CursorImage { url, hotspot }
        }).collect::<Vec<_>>().into_boxed_slice();

        longhands::cursor::computed_value::T { images, keyword }
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_pointer_events(&mut self, v: longhands::pointer_events::computed_value::T) {
        use crate::properties::longhands::pointer_events::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_POINTER_EVENTS_AUTO as u8,
                Keyword::None =>
                    structs::NS_STYLE_POINTER_EVENTS_NONE as u8,
                Keyword::Visiblepainted =>
                    structs::NS_STYLE_POINTER_EVENTS_VISIBLEPAINTED as u8,
                Keyword::Visiblefill =>
                    structs::NS_STYLE_POINTER_EVENTS_VISIBLEFILL as u8,
                Keyword::Visiblestroke =>
                    structs::NS_STYLE_POINTER_EVENTS_VISIBLESTROKE as u8,
                Keyword::Visible =>
                    structs::NS_STYLE_POINTER_EVENTS_VISIBLE as u8,
                Keyword::Painted =>
                    structs::NS_STYLE_POINTER_EVENTS_PAINTED as u8,
                Keyword::Fill =>
                    structs::NS_STYLE_POINTER_EVENTS_FILL as u8,
                Keyword::Stroke =>
                    structs::NS_STYLE_POINTER_EVENTS_STROKE as u8,
                Keyword::All =>
                    structs::NS_STYLE_POINTER_EVENTS_ALL as u8,
        };
        self.gecko.mPointerEvents = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_pointer_events_from(&mut self, other: &Self) {
        self.gecko.mPointerEvents = other.gecko.mPointerEvents.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_pointer_events(&mut self, other: &Self) {
        self.copy_pointer_events_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_pointer_events(&self) -> longhands::pointer_events::computed_value::T {
        use crate::properties::longhands::pointer_events::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_POINTER_EVENTS_AUTO : u8 =
            structs::NS_STYLE_POINTER_EVENTS_AUTO as u8;
        const U8_NS_STYLE_POINTER_EVENTS_NONE : u8 =
            structs::NS_STYLE_POINTER_EVENTS_NONE as u8;
        const U8_NS_STYLE_POINTER_EVENTS_VISIBLEPAINTED : u8 =
            structs::NS_STYLE_POINTER_EVENTS_VISIBLEPAINTED as u8;
        const U8_NS_STYLE_POINTER_EVENTS_VISIBLEFILL : u8 =
            structs::NS_STYLE_POINTER_EVENTS_VISIBLEFILL as u8;
        const U8_NS_STYLE_POINTER_EVENTS_VISIBLESTROKE : u8 =
            structs::NS_STYLE_POINTER_EVENTS_VISIBLESTROKE as u8;
        const U8_NS_STYLE_POINTER_EVENTS_VISIBLE : u8 =
            structs::NS_STYLE_POINTER_EVENTS_VISIBLE as u8;
        const U8_NS_STYLE_POINTER_EVENTS_PAINTED : u8 =
            structs::NS_STYLE_POINTER_EVENTS_PAINTED as u8;
        const U8_NS_STYLE_POINTER_EVENTS_FILL : u8 =
            structs::NS_STYLE_POINTER_EVENTS_FILL as u8;
        const U8_NS_STYLE_POINTER_EVENTS_STROKE : u8 =
            structs::NS_STYLE_POINTER_EVENTS_STROKE as u8;
        const U8_NS_STYLE_POINTER_EVENTS_ALL : u8 =
            structs::NS_STYLE_POINTER_EVENTS_ALL as u8;

        match self.gecko.mPointerEvents as u8 {
            U8_NS_STYLE_POINTER_EVENTS_AUTO => Keyword::Auto,
            U8_NS_STYLE_POINTER_EVENTS_NONE => Keyword::None,
            U8_NS_STYLE_POINTER_EVENTS_VISIBLEPAINTED => Keyword::Visiblepainted,
            U8_NS_STYLE_POINTER_EVENTS_VISIBLEFILL => Keyword::Visiblefill,
            U8_NS_STYLE_POINTER_EVENTS_VISIBLESTROKE => Keyword::Visiblestroke,
            U8_NS_STYLE_POINTER_EVENTS_VISIBLE => Keyword::Visible,
            U8_NS_STYLE_POINTER_EVENTS_PAINTED => Keyword::Painted,
            U8_NS_STYLE_POINTER_EVENTS_FILL => Keyword::Fill,
            U8_NS_STYLE_POINTER_EVENTS_STROKE => Keyword::Stroke,
            U8_NS_STYLE_POINTER_EVENTS_ALL => Keyword::All,
            _ => panic!("Found unexpected value in style struct for pointer_events property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_user_input(&mut self, v: longhands::_moz_user_input::computed_value::T) {
        use crate::properties::longhands::_moz_user_input::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleUserInput::Auto ,
                Keyword::None =>
                    structs::StyleUserInput::None ,
        };
        self.gecko.mUserInput = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_user_input_from(&mut self, other: &Self) {
        self.gecko.mUserInput = other.gecko.mUserInput.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_user_input(&mut self, other: &Self) {
        self.copy__moz_user_input_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_user_input(&self) -> longhands::_moz_user_input::computed_value::T {
        use crate::properties::longhands::_moz_user_input::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mUserInput {
            structs::StyleUserInput::Auto => Keyword::Auto,
            structs::StyleUserInput::None => Keyword::None,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_user_modify(&mut self, v: longhands::_moz_user_modify::computed_value::T) {
        use crate::properties::longhands::_moz_user_modify::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::ReadOnly =>
                    structs::StyleUserModify::ReadOnly ,
                Keyword::ReadWrite =>
                    structs::StyleUserModify::ReadWrite ,
                Keyword::WriteOnly =>
                    structs::StyleUserModify::WriteOnly ,
        };
        self.gecko.mUserModify = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_user_modify_from(&mut self, other: &Self) {
        self.gecko.mUserModify = other.gecko.mUserModify.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_user_modify(&mut self, other: &Self) {
        self.copy__moz_user_modify_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_user_modify(&self) -> longhands::_moz_user_modify::computed_value::T {
        use crate::properties::longhands::_moz_user_modify::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mUserModify {
            structs::StyleUserModify::ReadOnly => Keyword::ReadOnly,
            structs::StyleUserModify::ReadWrite => Keyword::ReadWrite,
            structs::StyleUserModify::WriteOnly => Keyword::WriteOnly,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_user_focus(&mut self, v: longhands::_moz_user_focus::computed_value::T) {
        use crate::properties::longhands::_moz_user_focus::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleUserFocus::None ,
                Keyword::Ignore =>
                    structs::StyleUserFocus::Ignore ,
                Keyword::Normal =>
                    structs::StyleUserFocus::Normal ,
                Keyword::SelectAfter =>
                    structs::StyleUserFocus::SelectAfter ,
                Keyword::SelectBefore =>
                    structs::StyleUserFocus::SelectBefore ,
                Keyword::SelectMenu =>
                    structs::StyleUserFocus::SelectMenu ,
                Keyword::SelectSame =>
                    structs::StyleUserFocus::SelectSame ,
                Keyword::SelectAll =>
                    structs::StyleUserFocus::SelectAll ,
        };
        self.gecko.mUserFocus = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_user_focus_from(&mut self, other: &Self) {
        self.gecko.mUserFocus = other.gecko.mUserFocus.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_user_focus(&mut self, other: &Self) {
        self.copy__moz_user_focus_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_user_focus(&self) -> longhands::_moz_user_focus::computed_value::T {
        use crate::properties::longhands::_moz_user_focus::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mUserFocus {
            structs::StyleUserFocus::None => Keyword::None,
            structs::StyleUserFocus::Ignore => Keyword::Ignore,
            structs::StyleUserFocus::Normal => Keyword::Normal,
            structs::StyleUserFocus::SelectAfter => Keyword::SelectAfter,
            structs::StyleUserFocus::SelectBefore => Keyword::SelectBefore,
            structs::StyleUserFocus::SelectMenu => Keyword::SelectMenu,
            structs::StyleUserFocus::SelectSame => Keyword::SelectSame,
            structs::StyleUserFocus::SelectAll => Keyword::SelectAll,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_caret_color(&mut self, v: longhands::caret_color::computed_value::T) {
        self.gecko.mCaretColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_caret_color_from(&mut self, other: &Self) {
        self.gecko.mCaretColor = other.gecko.mCaretColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_caret_color(&mut self, other: &Self) {
        self.copy_caret_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_caret_color(&self) -> longhands::caret_color::computed_value::T {
        From::from(self.gecko.mCaretColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_scrollbar_color(&mut self, v: longhands::scrollbar_color::computed_value::T) {
        self.gecko.mScrollbarColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_scrollbar_color_from(&mut self, other: &Self) {
        self.gecko.mScrollbarColor = other.gecko.mScrollbarColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scrollbar_color(&mut self, other: &Self) {
        self.copy_scrollbar_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scrollbar_color(&self) -> longhands::scrollbar_color::computed_value::T {
        From::from(self.gecko.mScrollbarColor.clone())
    }


}




impl GeckoColumn {
    /*
     * Manually-Implemented Methods.
     */
    

    #[allow(unused_unsafe)]
    pub fn set_column_count(&mut self, v: longhands::column_count::computed_value::T) {
        use crate::gecko_bindings::structs::{nsStyleColumn_kColumnCountAuto, nsStyleColumn_kMaxColumnCount};

        self.gecko.mColumnCount = match v {
            ColumnCount::Integer(integer) => {
                cmp::min(integer.0 as u32, unsafe { nsStyleColumn_kMaxColumnCount })
            },
            ColumnCount::Auto => nsStyleColumn_kColumnCountAuto
        };
    }

    
    #[allow(non_snake_case)]
    pub fn copy_column_count_from(&mut self, other: &Self) {
        self.gecko.mColumnCount = other.gecko.mColumnCount.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_count(&mut self, other: &Self) {
        self.copy_column_count_from(other)
    }


    pub fn clone_column_count(&self) -> longhands::column_count::computed_value::T {
        use crate::gecko_bindings::structs::{nsStyleColumn_kColumnCountAuto, nsStyleColumn_kMaxColumnCount};
        if self.gecko.mColumnCount != nsStyleColumn_kColumnCountAuto {
            debug_assert!(self.gecko.mColumnCount >= 1 &&
                          self.gecko.mColumnCount <= nsStyleColumn_kMaxColumnCount);
            ColumnCount::Integer((self.gecko.mColumnCount as i32).into())
        } else {
            ColumnCount::Auto
        }
    }

    
    #[allow(non_snake_case)]
    pub fn set_column_rule_width(&mut self, v: longhands::column_rule_width::computed_value::T) {
        let value = {
            let au_per_device_px = Au(self.gecko.mTwipsPerPixel);
            round_border_to_device_pixels(Au::from(v), au_per_device_px).0
        };

        self.gecko.mColumnRuleWidth = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_column_rule_width_from(&mut self, other: &Self) {
        self.gecko.mColumnRuleWidth = other.gecko.mColumnRuleWidth;
    }

    #[allow(non_snake_case)]
    pub fn reset_column_rule_width(&mut self, other: &Self) {
        self.copy_column_rule_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_column_rule_width(&self) -> longhands::column_rule_width::computed_value::T {
        Au(self.gecko.mColumnRuleWidth).into()
    }

    

    #[allow(non_snake_case)]
    pub fn set_column_rule_style(&mut self, v: longhands::column_rule_style::computed_value::T) {
        self.gecko.mColumnRuleStyle = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_column_rule_style_from(&mut self, other: &Self) {
        self.gecko.mColumnRuleStyle = other.gecko.mColumnRuleStyle.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_rule_style(&mut self, other: &Self) {
        self.copy_column_rule_style_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_column_rule_style(&self) -> longhands::column_rule_style::computed_value::T {
        From::from(self.gecko.mColumnRuleStyle.clone())
    }




    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_column_width(&mut self, v: longhands::column_width::computed_value::T) {
        self.gecko.mColumnWidth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_column_width_from(&mut self, other: &Self) {
        self.gecko.mColumnWidth = other.gecko.mColumnWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_width(&mut self, other: &Self) {
        self.copy_column_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_column_width(&self) -> longhands::column_width::computed_value::T {
        From::from(self.gecko.mColumnWidth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_column_fill(&mut self, v: longhands::column_fill::computed_value::T) {
        use crate::properties::longhands::column_fill::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Balance =>
                    structs::StyleColumnFill::Balance ,
                Keyword::Auto =>
                    structs::StyleColumnFill::Auto ,
        };
        self.gecko.mColumnFill = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_column_fill_from(&mut self, other: &Self) {
        self.gecko.mColumnFill = other.gecko.mColumnFill.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_fill(&mut self, other: &Self) {
        self.copy_column_fill_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_column_fill(&self) -> longhands::column_fill::computed_value::T {
        use crate::properties::longhands::column_fill::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mColumnFill {
            structs::StyleColumnFill::Balance => Keyword::Balance,
            structs::StyleColumnFill::Auto => Keyword::Auto,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_column_rule_color(&mut self, v: longhands::column_rule_color::computed_value::T) {
        self.gecko.mColumnRuleColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_column_rule_color_from(&mut self, other: &Self) {
        self.gecko.mColumnRuleColor = other.gecko.mColumnRuleColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_rule_color(&mut self, other: &Self) {
        self.copy_column_rule_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_column_rule_color(&self) -> longhands::column_rule_color::computed_value::T {
        From::from(self.gecko.mColumnRuleColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_column_span(&mut self, v: longhands::column_span::computed_value::T) {
        use crate::properties::longhands::column_span::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleColumnSpan::None ,
                Keyword::All =>
                    structs::StyleColumnSpan::All ,
        };
        self.gecko.mColumnSpan = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_column_span_from(&mut self, other: &Self) {
        self.gecko.mColumnSpan = other.gecko.mColumnSpan.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_span(&mut self, other: &Self) {
        self.copy_column_span_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_column_span(&self) -> longhands::column_span::computed_value::T {
        use crate::properties::longhands::column_span::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mColumnSpan {
            structs::StyleColumnSpan::None => Keyword::None,
            structs::StyleColumnSpan::All => Keyword::All,
        }
    }


}




impl GeckoCounters {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn ineffective_content_property(&self) -> bool {
        self.gecko.mContents.is_empty()
    }

    pub fn set_content(&mut self, v: longhands::content::computed_value::T) {
        use crate::values::CustomIdent;
        use crate::values::generics::counters::{Content, ContentItem};
        use crate::values::generics::CounterStyleOrNone;
        use crate::gecko_bindings::structs::nsStyleContentData;
        use crate::gecko_bindings::structs::nsStyleContentAttr;
        use crate::gecko_bindings::structs::StyleContentType;
        use crate::gecko_bindings::bindings::Gecko_ClearAndResizeStyleContents;

        // Converts a string as utf16, and returns an owned, zero-terminated raw buffer.
        fn as_utf16_and_forget(s: &str) -> *mut u16 {
            use std::mem;
            let mut vec = s.encode_utf16().collect::<Vec<_>>();
            vec.push(0u16);
            let ptr = vec.as_mut_ptr();
            mem::forget(vec);
            ptr
        }

        fn set_counter_function(
            data: &mut nsStyleContentData,
            content_type: StyleContentType,
            name: CustomIdent,
            sep: &str,
            style: CounterStyleOrNone,
        ) {
            debug_assert!(content_type == StyleContentType::Counter ||
                          content_type == StyleContentType::Counters);
            let counter_func = unsafe {
                bindings::Gecko_SetCounterFunction(data, content_type).as_mut().unwrap()
            };
            counter_func.mIdent.set_move(unsafe {
                RefPtr::from_addrefed(name.0.into_addrefed())
            });
            if content_type == StyleContentType::Counters {
                counter_func.mSeparator.assign_str(sep);
            }
            style.to_gecko_value(&mut counter_func.mCounterStyle);
        }

        match v {
            Content::None |
            Content::Normal => {
                // Ensure destructors run, otherwise we could leak.
                if !self.gecko.mContents.is_empty() {
                    unsafe {
                        Gecko_ClearAndResizeStyleContents(&mut *self.gecko, 0);
                    }
                }
            },
            Content::MozAltContent => {
                unsafe {
                    Gecko_ClearAndResizeStyleContents(&mut *self.gecko, 1);
                    *self.gecko.mContents[0].mContent.mString.as_mut() = ptr::null_mut();
                }
                self.gecko.mContents[0].mType = StyleContentType::AltContent;
            },
            Content::Items(items) => {
                unsafe {
                    Gecko_ClearAndResizeStyleContents(&mut *self.gecko,
                                                      items.len() as u32);
                }
                for (i, item) in items.into_vec().into_iter().enumerate() {
                    // NB: Gecko compares the mString value if type is not image
                    // or URI independently of whatever gets there. In the quote
                    // cases, they set it to null, so do the same here.
                    unsafe {
                        *self.gecko.mContents[i].mContent.mString.as_mut() = ptr::null_mut();
                    }
                    match item {
                        ContentItem::String(ref value) => {
                            self.gecko.mContents[i].mType = StyleContentType::String;
                            unsafe {
                                // NB: we share allocators, so doing this is fine.
                                *self.gecko.mContents[i].mContent.mString.as_mut() =
                                    as_utf16_and_forget(&value);
                            }
                        }
                        ContentItem::Attr(ref attr) => {
                            self.gecko.mContents[i].mType = StyleContentType::Attr;
                            unsafe {
                                // NB: we share allocators, so doing this is fine.
                                let maybe_ns = attr.namespace.clone();
                                let attr_struct = Box::new(nsStyleContentAttr {
                                    mName: structs::RefPtr {
                                        mRawPtr: attr.attribute.clone().into_addrefed(),
                                        _phantom_0: PhantomData,
                                    },
                                    mNamespaceURL: structs::RefPtr {
                                        mRawPtr: maybe_ns.map_or(ptr::null_mut(), |x| (x.1).0.into_addrefed()),
                                        _phantom_0: PhantomData,
                                    },
                                });
                                *self.gecko.mContents[i].mContent.mAttr.as_mut() =
                                    Box::into_raw(attr_struct);
                            }
                        }
                        ContentItem::OpenQuote
                            => self.gecko.mContents[i].mType = StyleContentType::OpenQuote,
                        ContentItem::CloseQuote
                            => self.gecko.mContents[i].mType = StyleContentType::CloseQuote,
                        ContentItem::NoOpenQuote
                            => self.gecko.mContents[i].mType = StyleContentType::NoOpenQuote,
                        ContentItem::NoCloseQuote
                            => self.gecko.mContents[i].mType = StyleContentType::NoCloseQuote,
                        ContentItem::Counter(name, style) => {
                            set_counter_function(
                                &mut self.gecko.mContents[i],
                                StyleContentType::Counter,
                                name,
                                "",
                                style,
                            );
                        }
                        ContentItem::Counters(name, sep, style) => {
                            set_counter_function(
                                &mut self.gecko.mContents[i],
                                StyleContentType::Counters,
                                name,
                                &sep,
                                style,
                            );
                        }
                        ContentItem::Url(ref url) => {
                            unsafe {
                                bindings::Gecko_SetContentDataImageValue(
                                    &mut self.gecko.mContents[i],
                                    url.url_value_ptr(),
                                )
                            }
                        }
                    }
                }
            }
        }
    }

    pub fn copy_content_from(&mut self, other: &Self) {
        use crate::gecko_bindings::bindings::Gecko_CopyStyleContentsFrom;
        unsafe {
            Gecko_CopyStyleContentsFrom(&mut *self.gecko, &*other.gecko)
        }
    }

    pub fn reset_content(&mut self, other: &Self) {
        self.copy_content_from(other)
    }

    pub fn clone_content(&self) -> longhands::content::computed_value::T {
        use {Atom, Namespace};
        use crate::gecko::conversions::string_from_chars_pointer;
        use crate::gecko_bindings::structs::StyleContentType;
        use crate::values::generics::counters::{Content, ContentItem};
        use crate::values::computed::url::ComputedImageUrl;
        use crate::values::{CustomIdent, Either};
        use crate::values::generics::CounterStyleOrNone;
        use crate::values::specified::Attr;

        if self.gecko.mContents.is_empty() {
            return Content::None;
        }

        if self.gecko.mContents.len() == 1 &&
           self.gecko.mContents[0].mType == StyleContentType::AltContent {
            return Content::MozAltContent;
        }

        Content::Items(
            self.gecko.mContents.iter().map(|gecko_content| {
                match gecko_content.mType {
                    StyleContentType::OpenQuote => ContentItem::OpenQuote,
                    StyleContentType::CloseQuote => ContentItem::CloseQuote,
                    StyleContentType::NoOpenQuote => ContentItem::NoOpenQuote,
                    StyleContentType::NoCloseQuote => ContentItem::NoCloseQuote,
                    StyleContentType::String => {
                        let gecko_chars = unsafe { gecko_content.mContent.mString.as_ref() };
                        let string = unsafe { string_from_chars_pointer(*gecko_chars) };
                        ContentItem::String(string.into_boxed_str())
                    },
                    StyleContentType::Attr => {
                        let (namespace, attribute) = unsafe {
                            let s = &**gecko_content.mContent.mAttr.as_ref();
                            let ns = if s.mNamespaceURL.mRawPtr.is_null() {
                                None
                            } else {
                                // FIXME(bholley): We don't have any way to get the prefix here. :-(
                                let prefix = atom!("");
                                Some((prefix, Namespace(Atom::from_raw(s.mNamespaceURL.mRawPtr))))
                            };
                            (ns, Atom::from_raw(s.mName.mRawPtr))
                        };
                        ContentItem::Attr(Attr { namespace, attribute })
                    },
                    StyleContentType::Counter | StyleContentType::Counters => {
                        let gecko_function =
                            unsafe { &**gecko_content.mContent.mCounters.as_ref() };
                        let ident = CustomIdent(unsafe {
                            Atom::from_raw(gecko_function.mIdent.mRawPtr)
                        });
                        let style =
                            CounterStyleOrNone::from_gecko_value(&gecko_function.mCounterStyle);
                        let style = match style {
                            Either::First(counter_style) => counter_style,
                            Either::Second(_) =>
                                unreachable!("counter function shouldn't have single string type"),
                        };
                        if gecko_content.mType == StyleContentType::Counter {
                            ContentItem::Counter(ident, style)
                        } else {
                            let separator = gecko_function.mSeparator.to_string();
                            ContentItem::Counters(ident, separator.into_boxed_str(), style)
                        }
                    },
                    StyleContentType::Image => {
                        unsafe {
                            let gecko_image_request =
                                &**gecko_content.mContent.mImage.as_ref();
                            ContentItem::Url(
                                ComputedImageUrl::from_image_request(gecko_image_request)
                            )
                        }
                    },
                    _ => panic!("Found unexpected value in style struct for content property"),
                }
            }).collect::<Vec<_>>().into_boxed_slice()
        )
    }

        pub fn set_counter_increment(
            &mut self,
            v: longhands::counter_increment::computed_value::T
        ) {
            unsafe {
                bindings::Gecko_ClearAndResizeCounterIncrements(&mut *self.gecko, v.len() as u32);
                for (i, pair) in v.0.into_vec().into_iter().enumerate() {
                    self.gecko.mIncrements[i].mCounter.set_move(
                        RefPtr::from_addrefed(pair.name.0.into_addrefed())
                    );
                    self.gecko.mIncrements[i].mValue = pair.value;
                }
            }
        }

        pub fn copy_counter_increment_from(&mut self, other: &Self) {
            unsafe {
                bindings::Gecko_CopyCounterIncrementsFrom(&mut *self.gecko, &*other.gecko)
            }
        }

        pub fn reset_counter_increment(&mut self, other: &Self) {
            self.copy_counter_increment_from(other)
        }

        pub fn clone_counter_increment(
            &self
        ) -> longhands::counter_increment::computed_value::T {
            use crate::values::generics::counters::CounterPair;
            use crate::values::CustomIdent;

            longhands::counter_increment::computed_value::T::new(
                self.gecko.mIncrements.iter().map(|ref gecko_counter| {
                    CounterPair {
                        name: CustomIdent(unsafe {
                            Atom::from_raw(gecko_counter.mCounter.mRawPtr)
                        }),
                        value: gecko_counter.mValue,
                    }
                }).collect()
            )
        }
        pub fn set_counter_reset(
            &mut self,
            v: longhands::counter_reset::computed_value::T
        ) {
            unsafe {
                bindings::Gecko_ClearAndResizeCounterResets(&mut *self.gecko, v.len() as u32);
                for (i, pair) in v.0.into_vec().into_iter().enumerate() {
                    self.gecko.mResets[i].mCounter.set_move(
                        RefPtr::from_addrefed(pair.name.0.into_addrefed())
                    );
                    self.gecko.mResets[i].mValue = pair.value;
                }
            }
        }

        pub fn copy_counter_reset_from(&mut self, other: &Self) {
            unsafe {
                bindings::Gecko_CopyCounterResetsFrom(&mut *self.gecko, &*other.gecko)
            }
        }

        pub fn reset_counter_reset(&mut self, other: &Self) {
            self.copy_counter_reset_from(other)
        }

        pub fn clone_counter_reset(
            &self
        ) -> longhands::counter_reset::computed_value::T {
            use crate::values::generics::counters::CounterPair;
            use crate::values::CustomIdent;

            longhands::counter_reset::computed_value::T::new(
                self.gecko.mResets.iter().map(|ref gecko_counter| {
                    CounterPair {
                        name: CustomIdent(unsafe {
                            Atom::from_raw(gecko_counter.mCounter.mRawPtr)
                        }),
                        value: gecko_counter.mValue,
                    }
                }).collect()
            )
        }
        pub fn set_counter_set(
            &mut self,
            v: longhands::counter_set::computed_value::T
        ) {
            unsafe {
                bindings::Gecko_ClearAndResizeCounterSets(&mut *self.gecko, v.len() as u32);
                for (i, pair) in v.0.into_vec().into_iter().enumerate() {
                    self.gecko.mSets[i].mCounter.set_move(
                        RefPtr::from_addrefed(pair.name.0.into_addrefed())
                    );
                    self.gecko.mSets[i].mValue = pair.value;
                }
            }
        }

        pub fn copy_counter_set_from(&mut self, other: &Self) {
            unsafe {
                bindings::Gecko_CopyCounterSetsFrom(&mut *self.gecko, &*other.gecko)
            }
        }

        pub fn reset_counter_set(&mut self, other: &Self) {
            self.copy_counter_set_from(other)
        }

        pub fn clone_counter_set(
            &self
        ) -> longhands::counter_set::computed_value::T {
            use crate::values::generics::counters::CounterPair;
            use crate::values::CustomIdent;

            longhands::counter_set::computed_value::T::new(
                self.gecko.mSets.iter().map(|ref gecko_counter| {
                    CounterPair {
                        name: CustomIdent(unsafe {
                            Atom::from_raw(gecko_counter.mCounter.mRawPtr)
                        }),
                        value: gecko_counter.mValue,
                    }
                }).collect()
            )
        }


    /*
     * Auto-Generated Methods.
     */
    
}




impl GeckoUI {
    /*
     * Manually-Implemented Methods.
     */
    
    
    

    #[allow(non_snake_case)]
    pub fn set__moz_force_broken_image_icon(&mut self, v: longhands::_moz_force_broken_image_icon::computed_value::T) {
        self.gecko.mForceBrokenImageIcon = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy__moz_force_broken_image_icon_from(&mut self, other: &Self) {
        self.gecko.mForceBrokenImageIcon = other.gecko.mForceBrokenImageIcon.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_force_broken_image_icon(&mut self, other: &Self) {
        self.copy__moz_force_broken_image_icon_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_force_broken_image_icon(&self) -> longhands::_moz_force_broken_image_icon::computed_value::T {
        From::from(self.gecko.mForceBrokenImageIcon)
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_ime_mode(&mut self, v: longhands::ime_mode::computed_value::T) {
        use crate::properties::longhands::ime_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_IME_MODE_AUTO as u8,
                Keyword::Normal =>
                    structs::NS_STYLE_IME_MODE_NORMAL as u8,
                Keyword::Active =>
                    structs::NS_STYLE_IME_MODE_ACTIVE as u8,
                Keyword::Disabled =>
                    structs::NS_STYLE_IME_MODE_DISABLED as u8,
                Keyword::Inactive =>
                    structs::NS_STYLE_IME_MODE_INACTIVE as u8,
        };
        self.gecko.mIMEMode = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_ime_mode_from(&mut self, other: &Self) {
        self.gecko.mIMEMode = other.gecko.mIMEMode.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_ime_mode(&mut self, other: &Self) {
        self.copy_ime_mode_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_ime_mode(&self) -> longhands::ime_mode::computed_value::T {
        use crate::properties::longhands::ime_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_IME_MODE_AUTO : u8 =
            structs::NS_STYLE_IME_MODE_AUTO as u8;
        const U8_NS_STYLE_IME_MODE_NORMAL : u8 =
            structs::NS_STYLE_IME_MODE_NORMAL as u8;
        const U8_NS_STYLE_IME_MODE_ACTIVE : u8 =
            structs::NS_STYLE_IME_MODE_ACTIVE as u8;
        const U8_NS_STYLE_IME_MODE_DISABLED : u8 =
            structs::NS_STYLE_IME_MODE_DISABLED as u8;
        const U8_NS_STYLE_IME_MODE_INACTIVE : u8 =
            structs::NS_STYLE_IME_MODE_INACTIVE as u8;

        match self.gecko.mIMEMode as u8 {
            U8_NS_STYLE_IME_MODE_AUTO => Keyword::Auto,
            U8_NS_STYLE_IME_MODE_NORMAL => Keyword::Normal,
            U8_NS_STYLE_IME_MODE_ACTIVE => Keyword::Active,
            U8_NS_STYLE_IME_MODE_DISABLED => Keyword::Disabled,
            U8_NS_STYLE_IME_MODE_INACTIVE => Keyword::Inactive,
            _ => panic!("Found unexpected value in style struct for ime_mode property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_scrollbar_width(&mut self, v: longhands::scrollbar_width::computed_value::T) {
        use crate::properties::longhands::scrollbar_width::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleScrollbarWidth::Auto ,
                Keyword::Thin =>
                    structs::StyleScrollbarWidth::Thin ,
                Keyword::None =>
                    structs::StyleScrollbarWidth::None ,
        };
        self.gecko.mScrollbarWidth = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_scrollbar_width_from(&mut self, other: &Self) {
        self.gecko.mScrollbarWidth = other.gecko.mScrollbarWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scrollbar_width(&mut self, other: &Self) {
        self.copy_scrollbar_width_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_scrollbar_width(&self) -> longhands::scrollbar_width::computed_value::T {
        use crate::properties::longhands::scrollbar_width::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mScrollbarWidth {
            structs::StyleScrollbarWidth::Auto => Keyword::Auto,
            structs::StyleScrollbarWidth::Thin => Keyword::Thin,
            structs::StyleScrollbarWidth::None => Keyword::None,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_user_select(&mut self, v: longhands::_moz_user_select::computed_value::T) {
        self.gecko.mUserSelect = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_user_select_from(&mut self, other: &Self) {
        self.gecko.mUserSelect = other.gecko.mUserSelect.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_user_select(&mut self, other: &Self) {
        self.copy__moz_user_select_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_user_select(&self) -> longhands::_moz_user_select::computed_value::T {
        From::from(self.gecko.mUserSelect.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_dragging(&mut self, v: longhands::_moz_window_dragging::computed_value::T) {
        use crate::properties::longhands::_moz_window_dragging::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Default =>
                    structs::StyleWindowDragging::Default ,
                Keyword::Drag =>
                    structs::StyleWindowDragging::Drag ,
                Keyword::NoDrag =>
                    structs::StyleWindowDragging::NoDrag ,
        };
        self.gecko.mWindowDragging = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_dragging_from(&mut self, other: &Self) {
        self.gecko.mWindowDragging = other.gecko.mWindowDragging.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_dragging(&mut self, other: &Self) {
        self.copy__moz_window_dragging_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_window_dragging(&self) -> longhands::_moz_window_dragging::computed_value::T {
        use crate::properties::longhands::_moz_window_dragging::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mWindowDragging {
            structs::StyleWindowDragging::Default => Keyword::Default,
            structs::StyleWindowDragging::Drag => Keyword::Drag,
            structs::StyleWindowDragging::NoDrag => Keyword::NoDrag,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_shadow(&mut self, v: longhands::_moz_window_shadow::computed_value::T) {
        use crate::properties::longhands::_moz_window_shadow::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::NS_STYLE_WINDOW_SHADOW_NONE as u8,
                Keyword::Default =>
                    structs::NS_STYLE_WINDOW_SHADOW_DEFAULT as u8,
                Keyword::Menu =>
                    structs::NS_STYLE_WINDOW_SHADOW_MENU as u8,
                Keyword::Tooltip =>
                    structs::NS_STYLE_WINDOW_SHADOW_TOOLTIP as u8,
                Keyword::Sheet =>
                    structs::NS_STYLE_WINDOW_SHADOW_SHEET as u8,
        };
        self.gecko.mWindowShadow = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_shadow_from(&mut self, other: &Self) {
        self.gecko.mWindowShadow = other.gecko.mWindowShadow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_shadow(&mut self, other: &Self) {
        self.copy__moz_window_shadow_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_window_shadow(&self) -> longhands::_moz_window_shadow::computed_value::T {
        use crate::properties::longhands::_moz_window_shadow::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_WINDOW_SHADOW_NONE : u8 =
            structs::NS_STYLE_WINDOW_SHADOW_NONE as u8;
        const U8_NS_STYLE_WINDOW_SHADOW_DEFAULT : u8 =
            structs::NS_STYLE_WINDOW_SHADOW_DEFAULT as u8;
        const U8_NS_STYLE_WINDOW_SHADOW_MENU : u8 =
            structs::NS_STYLE_WINDOW_SHADOW_MENU as u8;
        const U8_NS_STYLE_WINDOW_SHADOW_TOOLTIP : u8 =
            structs::NS_STYLE_WINDOW_SHADOW_TOOLTIP as u8;
        const U8_NS_STYLE_WINDOW_SHADOW_SHEET : u8 =
            structs::NS_STYLE_WINDOW_SHADOW_SHEET as u8;

        match self.gecko.mWindowShadow as u8 {
            U8_NS_STYLE_WINDOW_SHADOW_NONE => Keyword::None,
            U8_NS_STYLE_WINDOW_SHADOW_DEFAULT => Keyword::Default,
            U8_NS_STYLE_WINDOW_SHADOW_MENU => Keyword::Menu,
            U8_NS_STYLE_WINDOW_SHADOW_TOOLTIP => Keyword::Tooltip,
            U8_NS_STYLE_WINDOW_SHADOW_SHEET => Keyword::Sheet,
            _ => panic!("Found unexpected value in style struct for _moz_window_shadow property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_opacity(&mut self, v: longhands::_moz_window_opacity::computed_value::T) {
        self.gecko.mWindowOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_opacity_from(&mut self, other: &Self) {
        self.gecko.mWindowOpacity = other.gecko.mWindowOpacity.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_opacity(&mut self, other: &Self) {
        self.copy__moz_window_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_window_opacity(&self) -> longhands::_moz_window_opacity::computed_value::T {
        From::from(self.gecko.mWindowOpacity.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_transform(&mut self, v: longhands::_moz_window_transform::computed_value::T) {
        self.gecko.mMozWindowTransform = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_transform_from(&mut self, other: &Self) {
        self.gecko.mMozWindowTransform = other.gecko.mMozWindowTransform.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_transform(&mut self, other: &Self) {
        self.copy__moz_window_transform_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_window_transform(&self) -> longhands::_moz_window_transform::computed_value::T {
        From::from(self.gecko.mMozWindowTransform.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_transform_origin(&mut self, v: longhands::_moz_window_transform_origin::computed_value::T) {
        self.gecko.mWindowTransformOrigin = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_transform_origin_from(&mut self, other: &Self) {
        self.gecko.mWindowTransformOrigin = other.gecko.mWindowTransformOrigin.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_transform_origin(&mut self, other: &Self) {
        self.copy__moz_window_transform_origin_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_window_transform_origin(&self) -> longhands::_moz_window_transform_origin::computed_value::T {
        From::from(self.gecko.mWindowTransformOrigin.clone())
    }


}




impl GeckoXUL {
    /*
     * Manually-Implemented Methods.
     */
    
    #[allow(non_snake_case)]
    pub fn set__moz_box_ordinal_group(&mut self, v: i32) {
        self.gecko.mBoxOrdinal = v as u32;
    }

    
    #[allow(non_snake_case)]
    pub fn copy__moz_box_ordinal_group_from(&mut self, other: &Self) {
        self.gecko.mBoxOrdinal = other.gecko.mBoxOrdinal.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_ordinal_group(&mut self, other: &Self) {
        self.copy__moz_box_ordinal_group_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_box_ordinal_group(&self) -> i32 {
        self.gecko.mBoxOrdinal as i32
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set__moz_box_align(&mut self, v: longhands::_moz_box_align::computed_value::T) {
        use crate::properties::longhands::_moz_box_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Stretch =>
                    structs::StyleBoxAlign::Stretch ,
                Keyword::Start =>
                    structs::StyleBoxAlign::Start ,
                Keyword::Center =>
                    structs::StyleBoxAlign::Center ,
                Keyword::Baseline =>
                    structs::StyleBoxAlign::Baseline ,
                Keyword::End =>
                    structs::StyleBoxAlign::End ,
        };
        self.gecko.mBoxAlign = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_align_from(&mut self, other: &Self) {
        self.gecko.mBoxAlign = other.gecko.mBoxAlign.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_align(&mut self, other: &Self) {
        self.copy__moz_box_align_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_box_align(&self) -> longhands::_moz_box_align::computed_value::T {
        use crate::properties::longhands::_moz_box_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBoxAlign {
            structs::StyleBoxAlign::Stretch => Keyword::Stretch,
            structs::StyleBoxAlign::Start => Keyword::Start,
            structs::StyleBoxAlign::Center => Keyword::Center,
            structs::StyleBoxAlign::Baseline => Keyword::Baseline,
            structs::StyleBoxAlign::End => Keyword::End,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_direction(&mut self, v: longhands::_moz_box_direction::computed_value::T) {
        use crate::properties::longhands::_moz_box_direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::StyleBoxDirection::Normal ,
                Keyword::Reverse =>
                    structs::StyleBoxDirection::Reverse ,
        };
        self.gecko.mBoxDirection = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_direction_from(&mut self, other: &Self) {
        self.gecko.mBoxDirection = other.gecko.mBoxDirection.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_direction(&mut self, other: &Self) {
        self.copy__moz_box_direction_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_box_direction(&self) -> longhands::_moz_box_direction::computed_value::T {
        use crate::properties::longhands::_moz_box_direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBoxDirection {
            structs::StyleBoxDirection::Normal => Keyword::Normal,
            structs::StyleBoxDirection::Reverse => Keyword::Reverse,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_flex(&mut self, v: longhands::_moz_box_flex::computed_value::T) {
        self.gecko.mBoxFlex = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_flex_from(&mut self, other: &Self) {
        self.gecko.mBoxFlex = other.gecko.mBoxFlex.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_flex(&mut self, other: &Self) {
        self.copy__moz_box_flex_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_box_flex(&self) -> longhands::_moz_box_flex::computed_value::T {
        From::from(self.gecko.mBoxFlex.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_orient(&mut self, v: longhands::_moz_box_orient::computed_value::T) {
        use crate::properties::longhands::_moz_box_orient::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Horizontal =>
                    structs::StyleBoxOrient::Horizontal ,
                Keyword::Vertical =>
                    structs::StyleBoxOrient::Vertical ,
        };
        self.gecko.mBoxOrient = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_orient_from(&mut self, other: &Self) {
        self.gecko.mBoxOrient = other.gecko.mBoxOrient.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_orient(&mut self, other: &Self) {
        self.copy__moz_box_orient_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_box_orient(&self) -> longhands::_moz_box_orient::computed_value::T {
        use crate::properties::longhands::_moz_box_orient::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBoxOrient {
            structs::StyleBoxOrient::Horizontal => Keyword::Horizontal,
            structs::StyleBoxOrient::Vertical => Keyword::Vertical,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_pack(&mut self, v: longhands::_moz_box_pack::computed_value::T) {
        use crate::properties::longhands::_moz_box_pack::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Start =>
                    structs::StyleBoxPack::Start ,
                Keyword::Center =>
                    structs::StyleBoxPack::Center ,
                Keyword::End =>
                    structs::StyleBoxPack::End ,
                Keyword::Justify =>
                    structs::StyleBoxPack::Justify ,
        };
        self.gecko.mBoxPack = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_pack_from(&mut self, other: &Self) {
        self.gecko.mBoxPack = other.gecko.mBoxPack.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_pack(&mut self, other: &Self) {
        self.copy__moz_box_pack_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_box_pack(&self) -> longhands::_moz_box_pack::computed_value::T {
        use crate::properties::longhands::_moz_box_pack::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBoxPack {
            structs::StyleBoxPack::Start => Keyword::Start,
            structs::StyleBoxPack::Center => Keyword::Center,
            structs::StyleBoxPack::End => Keyword::End,
            structs::StyleBoxPack::Justify => Keyword::Justify,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_stack_sizing(&mut self, v: longhands::_moz_stack_sizing::computed_value::T) {
        use crate::properties::longhands::_moz_stack_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::StretchToFit =>
                    structs::StyleStackSizing::StretchToFit ,
                Keyword::Ignore =>
                    structs::StyleStackSizing::Ignore ,
                Keyword::IgnoreHorizontal =>
                    structs::StyleStackSizing::IgnoreHorizontal ,
                Keyword::IgnoreVertical =>
                    structs::StyleStackSizing::IgnoreVertical ,
        };
        self.gecko.mStackSizing = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_stack_sizing_from(&mut self, other: &Self) {
        self.gecko.mStackSizing = other.gecko.mStackSizing.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_stack_sizing(&mut self, other: &Self) {
        self.copy__moz_stack_sizing_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_stack_sizing(&self) -> longhands::_moz_stack_sizing::computed_value::T {
        use crate::properties::longhands::_moz_stack_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mStackSizing {
            structs::StyleStackSizing::StretchToFit => Keyword::StretchToFit,
            structs::StyleStackSizing::Ignore => Keyword::Ignore,
            structs::StyleStackSizing::IgnoreHorizontal => Keyword::IgnoreHorizontal,
            structs::StyleStackSizing::IgnoreVertical => Keyword::IgnoreVertical,
        }
    }


}



pub use crate::gecko_bindings::structs::mozilla::GeckoBackground as GeckoBackground;
impl GeckoBackground {
    pub fn gecko(&self) -> &nsStyleBackground {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleBackground {
        &mut self.gecko
    }
}


impl GeckoBackground {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoBackground { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleBackground(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoBackground {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleBackground(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoBackground {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoBackground { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleBackground(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoBorder as GeckoBorder;
impl GeckoBorder {
    pub fn gecko(&self) -> &nsStyleBorder {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleBorder {
        &mut self.gecko
    }
}


impl GeckoBorder {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoBorder { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleBorder(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoBorder {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleBorder(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoBorder {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoBorder { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleBorder(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoDisplay as GeckoBox;
impl GeckoBox {
    pub fn gecko(&self) -> &nsStyleDisplay {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleDisplay {
        &mut self.gecko
    }
}


impl GeckoBox {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoBox { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleDisplay(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoBox {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleDisplay(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoBox {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoBox { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleDisplay(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoColor as GeckoColor;
impl GeckoColor {
    pub fn gecko(&self) -> &nsStyleColor {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleColor {
        &mut self.gecko
    }
}


impl GeckoColor {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoColor { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleColor(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoColor {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleColor(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoColor {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoColor { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleColor(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoColumn as GeckoColumn;
impl GeckoColumn {
    pub fn gecko(&self) -> &nsStyleColumn {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleColumn {
        &mut self.gecko
    }
}


impl GeckoColumn {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoColumn { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleColumn(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoColumn {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleColumn(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoColumn {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoColumn { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleColumn(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoContent as GeckoCounters;
impl GeckoCounters {
    pub fn gecko(&self) -> &nsStyleContent {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleContent {
        &mut self.gecko
    }
}


impl GeckoCounters {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoCounters { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleContent(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoCounters {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleContent(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoCounters {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoCounters { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleContent(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoEffects as GeckoEffects;
impl GeckoEffects {
    pub fn gecko(&self) -> &nsStyleEffects {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleEffects {
        &mut self.gecko
    }
}


impl GeckoEffects {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoEffects { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleEffects(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoEffects {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleEffects(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoEffects {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoEffects { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleEffects(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoFont as GeckoFont;
impl GeckoFont {
    pub fn gecko(&self) -> &nsStyleFont {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleFont {
        &mut self.gecko
    }
}


impl GeckoFont {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoFont { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleFont(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoFont {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleFont(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoFont {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoFont { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleFont(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoVisibility as GeckoInheritedBox;
impl GeckoInheritedBox {
    pub fn gecko(&self) -> &nsStyleVisibility {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleVisibility {
        &mut self.gecko
    }
}


impl GeckoInheritedBox {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoInheritedBox { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleVisibility(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoInheritedBox {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleVisibility(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoInheritedBox {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoInheritedBox { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleVisibility(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoTableBorder as GeckoInheritedTable;
impl GeckoInheritedTable {
    pub fn gecko(&self) -> &nsStyleTableBorder {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleTableBorder {
        &mut self.gecko
    }
}


impl GeckoInheritedTable {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoInheritedTable { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleTableBorder(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoInheritedTable {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleTableBorder(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoInheritedTable {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoInheritedTable { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleTableBorder(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoText as GeckoInheritedText;
impl GeckoInheritedText {
    pub fn gecko(&self) -> &nsStyleText {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleText {
        &mut self.gecko
    }
}


impl GeckoInheritedText {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoInheritedText { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleText(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoInheritedText {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleText(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoInheritedText {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoInheritedText { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleText(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoUI as GeckoInheritedUI;
impl GeckoInheritedUI {
    pub fn gecko(&self) -> &nsStyleUI {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleUI {
        &mut self.gecko
    }
}


impl GeckoInheritedUI {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoInheritedUI { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleUI(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoInheritedUI {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleUI(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoInheritedUI {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoInheritedUI { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleUI(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoSVG as GeckoInheritedSVG;
impl GeckoInheritedSVG {
    pub fn gecko(&self) -> &nsStyleSVG {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleSVG {
        &mut self.gecko
    }
}


impl GeckoInheritedSVG {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoInheritedSVG { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleSVG(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoInheritedSVG {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleSVG(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoInheritedSVG {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoInheritedSVG { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleSVG(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoList as GeckoList;
impl GeckoList {
    pub fn gecko(&self) -> &nsStyleList {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleList {
        &mut self.gecko
    }
}


impl GeckoList {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoList { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleList(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoList {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleList(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoList {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoList { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleList(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoMargin as GeckoMargin;
impl GeckoMargin {
    pub fn gecko(&self) -> &nsStyleMargin {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleMargin {
        &mut self.gecko
    }
}


impl GeckoMargin {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoMargin { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleMargin(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoMargin {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleMargin(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoMargin {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoMargin { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleMargin(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoOutline as GeckoOutline;
impl GeckoOutline {
    pub fn gecko(&self) -> &nsStyleOutline {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleOutline {
        &mut self.gecko
    }
}


impl GeckoOutline {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoOutline { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleOutline(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoOutline {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleOutline(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoOutline {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoOutline { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleOutline(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoPadding as GeckoPadding;
impl GeckoPadding {
    pub fn gecko(&self) -> &nsStylePadding {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStylePadding {
        &mut self.gecko
    }
}


impl GeckoPadding {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoPadding { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStylePadding(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoPadding {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStylePadding(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoPadding {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoPadding { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStylePadding(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoPosition as GeckoPosition;
impl GeckoPosition {
    pub fn gecko(&self) -> &nsStylePosition {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStylePosition {
        &mut self.gecko
    }
}


impl GeckoPosition {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoPosition { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStylePosition(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoPosition {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStylePosition(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoPosition {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoPosition { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStylePosition(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoTable as GeckoTable;
impl GeckoTable {
    pub fn gecko(&self) -> &nsStyleTable {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleTable {
        &mut self.gecko
    }
}


impl GeckoTable {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoTable { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleTable(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoTable {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleTable(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoTable {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoTable { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleTable(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoTextReset as GeckoText;
impl GeckoText {
    pub fn gecko(&self) -> &nsStyleTextReset {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleTextReset {
        &mut self.gecko
    }
}


impl GeckoText {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoText { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleTextReset(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoText {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleTextReset(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoText {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoText { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleTextReset(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoUIReset as GeckoUI;
impl GeckoUI {
    pub fn gecko(&self) -> &nsStyleUIReset {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleUIReset {
        &mut self.gecko
    }
}


impl GeckoUI {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoUI { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleUIReset(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoUI {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleUIReset(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoUI {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoUI { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleUIReset(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoSVGReset as GeckoSVG;
impl GeckoSVG {
    pub fn gecko(&self) -> &nsStyleSVGReset {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleSVGReset {
        &mut self.gecko
    }
}


impl GeckoSVG {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoSVG { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleSVGReset(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoSVG {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleSVGReset(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoSVG {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoSVG { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleSVGReset(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoXUL as GeckoXUL;
impl GeckoXUL {
    pub fn gecko(&self) -> &nsStyleXUL {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleXUL {
        &mut self.gecko
    }
}


impl GeckoXUL {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        let mut result = Arc::new(GeckoXUL { gecko: ManuallyDrop::new(unsafe { zeroed() }) });
        unsafe {
            Gecko_Construct_Default_nsStyleXUL(
                &mut *Arc::get_mut(&mut result).unwrap().gecko,
                document,
            );
        }
        result
    }
}
impl Drop for GeckoXUL {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleXUL(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoXUL {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoXUL { gecko: ManuallyDrop::new(zeroed()) };
            Gecko_CopyConstruct_nsStyleXUL(&mut *result.gecko, &*self.gecko);
            result
        }
    }
}


