/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/. */

// This file is a Mako template: http://www.makotemplates.org/

// Please note that valid Rust syntax may be mangled by the Mako parser.
// For example, Vec&Foo> will be mangled as Vec&Foo>. To work around these issues, the code
// can be escaped. In the above example, Vec<&Foo> or Vec< &Foo> achieves the desired result of Vec&Foo>.



#[cfg(feature = "servo")]
use app_units::Au;
use arrayvec::{ArrayVec, Drain as ArrayVecDrain};
use servo_arc::{Arc, UniqueArc};
use std::borrow::Cow;
use std::{ops, ptr};
use std::fmt::{self, Write};
use std::mem::{self, ManuallyDrop};

use cssparser::{Parser, RGBA, TokenSerializationType};
use cssparser::ParserInput;
#[cfg(feature = "servo")] use euclid::SideOffsets2D;
use crate::context::QuirksMode;
#[cfg(feature = "gecko")] use crate::gecko_bindings::structs::{self, nsCSSPropertyID};
#[cfg(feature = "servo")] use crate::logical_geometry::LogicalMargin;
#[cfg(feature = "servo")] use crate::computed_values;
use crate::logical_geometry::WritingMode;
use malloc_size_of::{MallocSizeOf, MallocSizeOfOps};
use crate::media_queries::Device;
use crate::parser::ParserContext;
use crate::properties::longhands::system_font::SystemFont;
use crate::selector_parser::PseudoElement;
use selectors::parser::SelectorParseErrorKind;
#[cfg(feature = "servo")] use servo_config::prefs;
use style_traits::{CssWriter, KeywordsCollectFn, ParseError, ParsingMode};
use style_traits::{SpecifiedValueInfo, StyleParseErrorKind, ToCss};
use to_shmem::impl_trivial_to_shmem;
use crate::stylesheets::{CssRuleType, Origin, UrlExtraData};
use crate::values::generics::text::LineHeight;
use crate::values::{computed, resolved};
use crate::values::computed::NonNegativeLength;
use crate::values::serialize_atom_name;
use crate::rule_tree::StrongRuleNode;
use crate::Zero;
use self::computed_value_flags::*;
use crate::str::{CssString, CssStringBorrow, CssStringWriter};
use std::cell::Cell;

pub use self::declaration_block::*;
pub use self::cascade::*;



#[path="/builddir/build/BUILD/firefox-68.6.0/servo/components/style/properties/computed_value_flags.rs"]
pub mod computed_value_flags;
#[path="/builddir/build/BUILD/firefox-68.6.0/servo/components/style/properties/declaration_block.rs"]
pub mod declaration_block;
#[path="/builddir/build/BUILD/firefox-68.6.0/servo/components/style/properties/cascade.rs"]
pub mod cascade;

/// Conversion with fewer impls than From/Into
pub trait MaybeBoxed<Out> {
    /// Convert
    fn maybe_boxed(self) -> Out;
}

impl<T> MaybeBoxed<T> for T {
    #[inline]
    fn maybe_boxed(self) -> T { self }
}

impl<T> MaybeBoxed<Box<T>> for T {
    #[inline]
    fn maybe_boxed(self) -> Box<T> { Box::new(self) }
}

macro_rules! expanded {
    ( $( $name: ident: $value: expr ),+ ) => {
        expanded!( $( $name: $value, )+ )
    };
    ( $( $name: ident: $value: expr, )+ ) => {
        Longhands {
            $(
                $name: MaybeBoxed::maybe_boxed($value),
            )+
        }
    }
}

/// A module with all the code for longhand properties.
#[allow(missing_docs)]
pub mod longhands {
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/background.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/border.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/box.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/color.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/column.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/counters.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/effects.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/font.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/inherited_box.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/inherited_table.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/inherited_text.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/inherited_ui.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/inherited_svg.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/list.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/margin.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/outline.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/padding.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/position.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/table.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/text.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/ui.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/svg.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/longhands/xul.rs");
    pub const ANIMATABLE_PROPERTY_COUNT: usize = 317;
}

macro_rules! unwrap_or_initial {
    ($prop: ident) => (unwrap_or_initial!($prop, $prop));
    ($prop: ident, $expr: expr) =>
        ($expr.unwrap_or_else(|| $prop::get_initial_specified_value()));
}

/// A module with code for all the shorthand css properties, and a few
/// serialization helpers.
#[allow(missing_docs)]
pub mod shorthands {
    use cssparser::Parser;
    use crate::parser::{Parse, ParserContext};
    use style_traits::{ParseError, StyleParseErrorKind};
    use crate::values::specified;

    use style_traits::{CssWriter, ToCss};
    use crate::values::specified::{BorderStyle, Color};
    use std::fmt::{self, Write};

    fn serialize_directional_border<W, I,>(
        dest: &mut CssWriter<W>,
        width: &I,
        style: &BorderStyle,
        color: &Color,
    ) -> fmt::Result
    where
        W: Write,
        I: ToCss,
    {
        width.to_css(dest)?;
        // FIXME(emilio): Should we really serialize the border style if it's
        // `solid`?
        dest.write_str(" ")?;
        style.to_css(dest)?;
        if *color != Color::CurrentColor {
            dest.write_str(" ")?;
            color.to_css(dest)?;
        }
        Ok(())
    }

    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/background.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/border.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/box.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/color.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/column.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/counters.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/effects.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/font.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/inherited_box.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/inherited_table.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/inherited_text.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/inherited_ui.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/inherited_svg.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/list.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/margin.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/outline.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/padding.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/position.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/table.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/text.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/ui.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/svg.rs");
    include!("/builddir/build/BUILD/firefox-68.6.0/objdir/x86_64-unknown-linux-gnu/release/build/style-b2f95423e0b8a5b4/out/shorthands/xul.rs");

    // We didn't define the 'all' shorthand using the regular helpers:shorthand
    // mechanism, since it causes some very large types to be generated.
    //
    // Also, make sure logical properties appear before its physical
    // counter-parts, in order to prevent bugs like:
    //
    //   https://bugzilla.mozilla.org/show_bug.cgi?id=1410028
    //
    // FIXME(emilio): Adopt the resolution from:
    //
    //   https://github.com/w3c/csswg-drafts/issues/1898
    //
    // when there is one, whatever that is.
    

    /// The max amount of longhands that the `all` shorthand will ever contain.
    pub const ALL_SHORTHAND_MAX_LEN: usize = 335;
}



// WARNING: It is *really* important for the variants of `LonghandId`
// and `PropertyDeclaration` to be defined in the exact same order,
// with the exception of `CSSWideKeyword`, `WithVariables` and `Custom`,
// which don't exist in `LonghandId`.



/// Servo's representation for a property declaration.
#[derive(ToShmem)]
#[repr(u16)]
pub enum PropertyDeclaration {
    /// `align-content`
    AlignContent(crate::values::specified::AlignContent),
    /// `align-items`
    AlignItems(crate::values::specified::AlignItems),
    /// `align-self`
    AlignSelf(crate::values::specified::AlignSelf),
    /// `backface-visibility`
    BackfaceVisibility(longhands::backface_visibility::SpecifiedValue),
    /// `border-collapse`
    BorderCollapse(longhands::border_collapse::SpecifiedValue),
    /// `border-image-repeat`
    BorderImageRepeat(crate::values::specified::BorderImageRepeat),
    /// `box-decoration-break`
    BoxDecorationBreak(longhands::box_decoration_break::SpecifiedValue),
    /// `box-sizing`
    BoxSizing(longhands::box_sizing::SpecifiedValue),
    /// `break-inside`
    BreakInside(crate::values::specified::BreakWithin),
    /// `caption-side`
    CaptionSide(longhands::caption_side::SpecifiedValue),
    /// `clear`
    Clear(crate::values::specified::Clear),
    /// `color-adjust`
    ColorAdjust(longhands::color_adjust::SpecifiedValue),
    /// `color-interpolation`
    ColorInterpolation(longhands::color_interpolation::SpecifiedValue),
    /// `color-interpolation-filters`
    ColorInterpolationFilters(longhands::color_interpolation_filters::SpecifiedValue),
    /// `column-count`
    ColumnCount(crate::values::specified::ColumnCount),
    /// `column-fill`
    ColumnFill(longhands::column_fill::SpecifiedValue),
    /// `column-span`
    ColumnSpan(longhands::column_span::SpecifiedValue),
    /// `contain`
    Contain(crate::values::specified::Contain),
    /// `direction`
    Direction(longhands::direction::SpecifiedValue),
    /// `display`
    Display(crate::values::specified::Display),
    /// `dominant-baseline`
    DominantBaseline(longhands::dominant_baseline::SpecifiedValue),
    /// `empty-cells`
    EmptyCells(longhands::empty_cells::SpecifiedValue),
    /// `flex-direction`
    FlexDirection(longhands::flex_direction::SpecifiedValue),
    /// `flex-wrap`
    FlexWrap(longhands::flex_wrap::SpecifiedValue),
    /// `float`
    Float(crate::values::specified::Float),
    /// `font-kerning`
    FontKerning(longhands::font_kerning::SpecifiedValue),
    /// `font-optical-sizing`
    FontOpticalSizing(longhands::font_optical_sizing::SpecifiedValue),
    /// `font-size-adjust`
    FontSizeAdjust(crate::values::specified::FontSizeAdjust),
    /// `font-stretch`
    FontStretch(crate::values::specified::FontStretch),
    /// `font-style`
    FontStyle(crate::values::specified::FontStyle),
    /// `font-synthesis`
    FontSynthesis(crate::values::specified::FontSynthesis),
    /// `font-variant-caps`
    FontVariantCaps(longhands::font_variant_caps::SpecifiedValue),
    /// `font-variant-east-asian`
    FontVariantEastAsian(crate::values::specified::FontVariantEastAsian),
    /// `font-variant-ligatures`
    FontVariantLigatures(crate::values::specified::FontVariantLigatures),
    /// `font-variant-numeric`
    FontVariantNumeric(crate::values::specified::FontVariantNumeric),
    /// `font-variant-position`
    FontVariantPosition(longhands::font_variant_position::SpecifiedValue),
    /// `font-weight`
    FontWeight(crate::values::specified::FontWeight),
    /// `grid-auto-flow`
    GridAutoFlow(crate::values::specified::GridAutoFlow),
    /// `hyphens`
    Hyphens(longhands::hyphens::SpecifiedValue),
    /// `image-orientation`
    ImageOrientation(longhands::image_orientation::SpecifiedValue),
    /// `image-rendering`
    ImageRendering(longhands::image_rendering::SpecifiedValue),
    /// `ime-mode`
    ImeMode(longhands::ime_mode::SpecifiedValue),
    /// `initial-letter`
    InitialLetter(crate::values::specified::InitialLetter),
    /// `isolation`
    Isolation(longhands::isolation::SpecifiedValue),
    /// `justify-content`
    JustifyContent(crate::values::specified::JustifyContent),
    /// `justify-items`
    JustifyItems(crate::values::specified::JustifyItems),
    /// `justify-self`
    JustifySelf(crate::values::specified::JustifySelf),
    /// `list-style-position`
    ListStylePosition(longhands::list_style_position::SpecifiedValue),
    /// `mask-type`
    MaskType(longhands::mask_type::SpecifiedValue),
    /// `mix-blend-mode`
    MixBlendMode(longhands::mix_blend_mode::SpecifiedValue),
    /// `-moz-appearance`
    MozAppearance(crate::values::specified::Appearance),
    /// `-moz-box-align`
    MozBoxAlign(longhands::_moz_box_align::SpecifiedValue),
    /// `-moz-box-direction`
    MozBoxDirection(longhands::_moz_box_direction::SpecifiedValue),
    /// `-moz-box-orient`
    MozBoxOrient(longhands::_moz_box_orient::SpecifiedValue),
    /// `-moz-box-pack`
    MozBoxPack(longhands::_moz_box_pack::SpecifiedValue),
    /// `-moz-control-character-visibility`
    MozControlCharacterVisibility(longhands::_moz_control_character_visibility::SpecifiedValue),
    /// `-moz-float-edge`
    MozFloatEdge(longhands::_moz_float_edge::SpecifiedValue),
    /// `-moz-force-broken-image-icon`
    MozForceBrokenImageIcon(crate::values::specified::MozForceBrokenImageIcon),
    /// `-moz-list-reversed`
    MozListReversed(crate::values::specified::MozListReversed),
    /// `-moz-math-display`
    MozMathDisplay(longhands::_moz_math_display::SpecifiedValue),
    /// `-moz-math-variant`
    MozMathVariant(longhands::_moz_math_variant::SpecifiedValue),
    /// `-moz-min-font-size-ratio`
    MozMinFontSizeRatio(crate::values::specified::Percentage),
    /// `-moz-orient`
    MozOrient(longhands::_moz_orient::SpecifiedValue),
    /// `-moz-osx-font-smoothing`
    MozOsxFontSmoothing(longhands::_moz_osx_font_smoothing::SpecifiedValue),
    /// `-moz-script-level`
    MozScriptLevel(crate::values::specified::MozScriptLevel),
    /// `-moz-script-min-size`
    MozScriptMinSize(crate::values::specified::MozScriptMinSize),
    /// `-moz-script-size-multiplier`
    MozScriptSizeMultiplier(crate::values::specified::MozScriptSizeMultiplier),
    /// `-moz-stack-sizing`
    MozStackSizing(longhands::_moz_stack_sizing::SpecifiedValue),
    /// `-moz-text-size-adjust`
    MozTextSizeAdjust(longhands::_moz_text_size_adjust::SpecifiedValue),
    /// `-moz-top-layer`
    MozTopLayer(longhands::_moz_top_layer::SpecifiedValue),
    /// `-moz-user-focus`
    MozUserFocus(longhands::_moz_user_focus::SpecifiedValue),
    /// `-moz-user-input`
    MozUserInput(longhands::_moz_user_input::SpecifiedValue),
    /// `-moz-user-modify`
    MozUserModify(longhands::_moz_user_modify::SpecifiedValue),
    /// `-moz-user-select`
    MozUserSelect(crate::values::specified::UserSelect),
    /// `-moz-window-dragging`
    MozWindowDragging(longhands::_moz_window_dragging::SpecifiedValue),
    /// `-moz-window-shadow`
    MozWindowShadow(longhands::_moz_window_shadow::SpecifiedValue),
    /// `object-fit`
    ObjectFit(longhands::object_fit::SpecifiedValue),
    /// `outline-style`
    OutlineStyle(crate::values::specified::OutlineStyle),
    /// `overflow-anchor`
    OverflowAnchor(crate::values::specified::OverflowAnchor),
    /// `overflow-wrap`
    OverflowWrap(crate::values::specified::OverflowWrap),
    /// `paint-order`
    PaintOrder(crate::values::specified::SVGPaintOrder),
    /// `pointer-events`
    PointerEvents(longhands::pointer_events::SpecifiedValue),
    /// `position`
    Position(longhands::position::SpecifiedValue),
    /// `resize`
    Resize(crate::values::specified::Resize),
    /// `ruby-align`
    RubyAlign(longhands::ruby_align::SpecifiedValue),
    /// `ruby-position`
    RubyPosition(longhands::ruby_position::SpecifiedValue),
    /// `scroll-behavior`
    ScrollBehavior(longhands::scroll_behavior::SpecifiedValue),
    /// `scroll-snap-align`
    ScrollSnapAlign(crate::values::specified::ScrollSnapAlign),
    /// `scroll-snap-type`
    ScrollSnapType(crate::values::specified::ScrollSnapType),
    /// `scrollbar-width`
    ScrollbarWidth(longhands::scrollbar_width::SpecifiedValue),
    /// `shape-rendering`
    ShapeRendering(longhands::shape_rendering::SpecifiedValue),
    /// `stroke-linecap`
    StrokeLinecap(longhands::stroke_linecap::SpecifiedValue),
    /// `stroke-linejoin`
    StrokeLinejoin(longhands::stroke_linejoin::SpecifiedValue),
    /// `table-layout`
    TableLayout(longhands::table_layout::SpecifiedValue),
    /// `text-align`
    TextAlign(crate::values::specified::TextAlign),
    /// `text-align-last`
    TextAlignLast(longhands::text_align_last::SpecifiedValue),
    /// `text-anchor`
    TextAnchor(longhands::text_anchor::SpecifiedValue),
    /// `text-combine-upright`
    TextCombineUpright(longhands::text_combine_upright::SpecifiedValue),
    /// `text-decoration-line`
    TextDecorationLine(crate::values::specified::TextDecorationLine),
    /// `text-decoration-style`
    TextDecorationStyle(longhands::text_decoration_style::SpecifiedValue),
    /// `text-emphasis-position`
    TextEmphasisPosition(crate::values::specified::TextEmphasisPosition),
    /// `text-justify`
    TextJustify(longhands::text_justify::SpecifiedValue),
    /// `text-orientation`
    TextOrientation(longhands::text_orientation::SpecifiedValue),
    /// `text-rendering`
    TextRendering(longhands::text_rendering::SpecifiedValue),
    /// `text-transform`
    TextTransform(crate::values::specified::TextTransform),
    /// `touch-action`
    TouchAction(crate::values::specified::TouchAction),
    /// `transform-box`
    TransformBox(longhands::transform_box::SpecifiedValue),
    /// `transform-style`
    TransformStyle(crate::values::specified::TransformStyle),
    /// `unicode-bidi`
    UnicodeBidi(longhands::unicode_bidi::SpecifiedValue),
    /// `vector-effect`
    VectorEffect(longhands::vector_effect::SpecifiedValue),
    /// `visibility`
    Visibility(longhands::visibility::SpecifiedValue),
    /// `-webkit-line-clamp`
    WebkitLineClamp(crate::values::specified::PositiveIntegerOrNone),
    /// `white-space`
    WhiteSpace(longhands::white_space::SpecifiedValue),
    /// `word-break`
    WordBreak(crate::values::specified::WordBreak),
    /// `writing-mode`
    WritingMode(longhands::writing_mode::SpecifiedValue),
    /// `-x-span`
    XSpan(crate::values::specified::XSpan),
    /// `-x-text-zoom`
    XTextZoom(crate::values::specified::XTextZoom),
    /// `z-index`
    ZIndex(crate::values::specified::ZIndex),
    /// `break-after`
    BreakAfter(crate::values::specified::BreakBetween),
    /// `break-before`
    BreakBefore(crate::values::specified::BreakBetween),
    /// `clip-rule`
    ClipRule(crate::values::specified::FillRule),
    /// `fill-rule`
    FillRule(crate::values::specified::FillRule),
    /// `-moz-box-ordinal-group`
    MozBoxOrdinalGroup(crate::values::specified::Integer),
    /// `order`
    Order(crate::values::specified::Integer),
    /// `overflow-x`
    OverflowX(crate::values::specified::Overflow),
    /// `overflow-y`
    OverflowY(crate::values::specified::Overflow),
    /// `overflow-clip-box-block`
    OverflowClipBoxBlock(crate::values::specified::OverflowClipBox),
    /// `overflow-clip-box-inline`
    OverflowClipBoxInline(crate::values::specified::OverflowClipBox),
    /// `overscroll-behavior-x`
    OverscrollBehaviorX(crate::values::specified::OverscrollBehavior),
    /// `overscroll-behavior-y`
    OverscrollBehaviorY(crate::values::specified::OverscrollBehavior),
    /// `fill-opacity`
    FillOpacity(crate::values::specified::SVGOpacity),
    /// `stroke-opacity`
    StrokeOpacity(crate::values::specified::SVGOpacity),
    /// `flex-grow`
    FlexGrow(crate::values::specified::NonNegativeNumber),
    /// `flex-shrink`
    FlexShrink(crate::values::specified::NonNegativeNumber),
    /// `-moz-box-flex`
    MozBoxFlex(crate::values::specified::NonNegativeNumber),
    /// `stroke-miterlimit`
    StrokeMiterlimit(crate::values::specified::NonNegativeNumber),
    /// `flood-opacity`
    FloodOpacity(crate::values::specified::Opacity),
    /// `-moz-window-opacity`
    MozWindowOpacity(crate::values::specified::Opacity),
    /// `opacity`
    Opacity(crate::values::specified::Opacity),
    /// `shape-image-threshold`
    ShapeImageThreshold(crate::values::specified::Opacity),
    /// `stop-opacity`
    StopOpacity(crate::values::specified::Opacity),
    /// `border-block-end-style`
    BorderBlockEndStyle(crate::values::specified::BorderStyle),
    /// `border-block-start-style`
    BorderBlockStartStyle(crate::values::specified::BorderStyle),
    /// `border-bottom-style`
    BorderBottomStyle(crate::values::specified::BorderStyle),
    /// `border-inline-end-style`
    BorderInlineEndStyle(crate::values::specified::BorderStyle),
    /// `border-inline-start-style`
    BorderInlineStartStyle(crate::values::specified::BorderStyle),
    /// `border-left-style`
    BorderLeftStyle(crate::values::specified::BorderStyle),
    /// `border-right-style`
    BorderRightStyle(crate::values::specified::BorderStyle),
    /// `border-top-style`
    BorderTopStyle(crate::values::specified::BorderStyle),
    /// `column-rule-style`
    ColumnRuleStyle(crate::values::specified::BorderStyle),
    /// `animation-delay`
    AnimationDelay(longhands::animation_delay::SpecifiedValue),
    /// `animation-direction`
    AnimationDirection(longhands::animation_direction::SpecifiedValue),
    /// `animation-duration`
    AnimationDuration(longhands::animation_duration::SpecifiedValue),
    /// `animation-fill-mode`
    AnimationFillMode(longhands::animation_fill_mode::SpecifiedValue),
    /// `animation-iteration-count`
    AnimationIterationCount(longhands::animation_iteration_count::SpecifiedValue),
    /// `animation-name`
    AnimationName(longhands::animation_name::SpecifiedValue),
    /// `animation-play-state`
    AnimationPlayState(longhands::animation_play_state::SpecifiedValue),
    /// `animation-timing-function`
    AnimationTimingFunction(longhands::animation_timing_function::SpecifiedValue),
    /// `background-attachment`
    BackgroundAttachment(longhands::background_attachment::SpecifiedValue),
    /// `background-blend-mode`
    BackgroundBlendMode(longhands::background_blend_mode::SpecifiedValue),
    /// `background-clip`
    BackgroundClip(longhands::background_clip::SpecifiedValue),
    /// `background-image`
    BackgroundImage(longhands::background_image::SpecifiedValue),
    /// `background-origin`
    BackgroundOrigin(longhands::background_origin::SpecifiedValue),
    /// `background-position-x`
    BackgroundPositionX(longhands::background_position_x::SpecifiedValue),
    /// `background-position-y`
    BackgroundPositionY(longhands::background_position_y::SpecifiedValue),
    /// `background-repeat`
    BackgroundRepeat(longhands::background_repeat::SpecifiedValue),
    /// `background-size`
    BackgroundSize(longhands::background_size::SpecifiedValue),
    /// `border-image-outset`
    BorderImageOutset(Box<crate::values::specified::NonNegativeLengthOrNumberRect>),
    /// `border-image-slice`
    BorderImageSlice(Box<crate::values::specified::BorderImageSlice>),
    /// `border-image-source`
    BorderImageSource(crate::values::specified::ImageLayer),
    /// `border-image-width`
    BorderImageWidth(Box<crate::values::specified::BorderImageWidth>),
    /// `border-spacing`
    BorderSpacing(Box<crate::values::specified::BorderSpacing>),
    /// `box-shadow`
    BoxShadow(longhands::box_shadow::SpecifiedValue),
    /// `caret-color`
    CaretColor(Box<crate::values::specified::ColorOrAuto>),
    /// `clip-path`
    ClipPath(crate::values::specified::basic_shape::ClippingShape),
    /// `color`
    Color(crate::values::specified::ColorPropertyValue),
    /// `column-width`
    ColumnWidth(crate::values::specified::length::NonNegativeLengthOrAuto),
    /// `content`
    Content(crate::values::specified::Content),
    /// `counter-increment`
    CounterIncrement(crate::values::specified::CounterIncrement),
    /// `cursor`
    Cursor(crate::values::specified::Cursor),
    /// `filter`
    Filter(longhands::filter::SpecifiedValue),
    /// `flex-basis`
    FlexBasis(Box<crate::values::specified::FlexBasis>),
    /// `font-family`
    FontFamily(crate::values::specified::FontFamily),
    /// `font-feature-settings`
    FontFeatureSettings(crate::values::specified::FontFeatureSettings),
    /// `font-language-override`
    FontLanguageOverride(crate::values::specified::FontLanguageOverride),
    /// `font-size`
    FontSize(crate::values::specified::FontSize),
    /// `font-variant-alternates`
    FontVariantAlternates(crate::values::specified::FontVariantAlternates),
    /// `font-variation-settings`
    FontVariationSettings(crate::values::specified::FontVariationSettings),
    /// `grid-template-areas`
    GridTemplateAreas(crate::values::specified::GridTemplateAreas),
    /// `letter-spacing`
    LetterSpacing(crate::values::specified::LetterSpacing),
    /// `line-height`
    LineHeight(crate::values::specified::LineHeight),
    /// `list-style-image`
    ListStyleImage(crate::values::specified::url::ImageUrlOrNone),
    /// `list-style-type`
    ListStyleType(Box<crate::values::specified::ListStyleType>),
    /// `mask-clip`
    MaskClip(longhands::mask_clip::SpecifiedValue),
    /// `mask-composite`
    MaskComposite(longhands::mask_composite::SpecifiedValue),
    /// `mask-image`
    MaskImage(longhands::mask_image::SpecifiedValue),
    /// `mask-mode`
    MaskMode(longhands::mask_mode::SpecifiedValue),
    /// `mask-origin`
    MaskOrigin(longhands::mask_origin::SpecifiedValue),
    /// `mask-position-x`
    MaskPositionX(longhands::mask_position_x::SpecifiedValue),
    /// `mask-position-y`
    MaskPositionY(longhands::mask_position_y::SpecifiedValue),
    /// `mask-repeat`
    MaskRepeat(longhands::mask_repeat::SpecifiedValue),
    /// `mask-size`
    MaskSize(longhands::mask_size::SpecifiedValue),
    /// `-moz-context-properties`
    MozContextProperties(crate::values::specified::MozContextProperties),
    /// `-moz-font-smoothing-background-color`
    MozFontSmoothingBackgroundColor(crate::values::specified::color::MozFontSmoothingBackgroundColor),
    /// `-moz-tab-size`
    MozTabSize(crate::values::specified::NonNegativeLengthOrNumber),
    /// `offset-path`
    OffsetPath(crate::values::specified::OffsetPath),
    /// `perspective`
    Perspective(crate::values::specified::Perspective),
    /// `quotes`
    Quotes(crate::values::specified::Quotes),
    /// `rotate`
    Rotate(Box<crate::values::specified::Rotate>),
    /// `scale`
    Scale(Box<crate::values::specified::Scale>),
    /// `scroll-snap-coordinate`
    ScrollSnapCoordinate(longhands::scroll_snap_coordinate::SpecifiedValue),
    /// `scrollbar-color`
    ScrollbarColor(Box<crate::values::specified::ui::ScrollbarColor>),
    /// `shape-outside`
    ShapeOutside(Box<crate::values::specified::basic_shape::FloatAreaShape>),
    /// `stroke-dasharray`
    StrokeDasharray(crate::values::specified::SVGStrokeDashArray),
    /// `stroke-dashoffset`
    StrokeDashoffset(crate::values::specified::SVGLength),
    /// `stroke-width`
    StrokeWidth(crate::values::specified::SVGWidth),
    /// `text-emphasis-style`
    TextEmphasisStyle(Box<crate::values::specified::TextEmphasisStyle>),
    /// `text-indent`
    TextIndent(crate::values::specified::LengthPercentage),
    /// `text-overflow`
    TextOverflow(Box<crate::values::specified::TextOverflow>),
    /// `text-shadow`
    TextShadow(longhands::text_shadow::SpecifiedValue),
    /// `transition-delay`
    TransitionDelay(longhands::transition_delay::SpecifiedValue),
    /// `transition-duration`
    TransitionDuration(longhands::transition_duration::SpecifiedValue),
    /// `transition-property`
    TransitionProperty(longhands::transition_property::SpecifiedValue),
    /// `transition-timing-function`
    TransitionTimingFunction(longhands::transition_timing_function::SpecifiedValue),
    /// `translate`
    Translate(Box<crate::values::specified::Translate>),
    /// `vertical-align`
    VerticalAlign(crate::values::specified::VerticalAlign),
    /// `will-change`
    WillChange(crate::values::specified::WillChange),
    /// `word-spacing`
    WordSpacing(crate::values::specified::WordSpacing),
    /// `-x-lang`
    XLang(crate::values::specified::XLang),
    /// `clip`
    Clip(Box<crate::values::specified::ClipRectOrAuto>),
    /// `-moz-image-region`
    MozImageRegion(Box<crate::values::specified::ClipRectOrAuto>),
    /// `grid-template-columns`
    GridTemplateColumns(Box<crate::values::specified::GridTemplateComponent>),
    /// `grid-template-rows`
    GridTemplateRows(Box<crate::values::specified::GridTemplateComponent>),
    /// `fill`
    Fill(Box<crate::values::specified::SVGPaint>),
    /// `stroke`
    Stroke(Box<crate::values::specified::SVGPaint>),
    /// `grid-auto-columns`
    GridAutoColumns(Box<crate::values::specified::TrackSize>),
    /// `grid-auto-rows`
    GridAutoRows(Box<crate::values::specified::TrackSize>),
    /// `-moz-window-transform-origin`
    MozWindowTransformOrigin(Box<crate::values::specified::TransformOrigin>),
    /// `transform-origin`
    TransformOrigin(Box<crate::values::specified::TransformOrigin>),
    /// `counter-reset`
    CounterReset(crate::values::specified::CounterSetOrReset),
    /// `counter-set`
    CounterSet(crate::values::specified::CounterSetOrReset),
    /// `scroll-snap-points-x`
    ScrollSnapPointsX(crate::values::specified::ScrollSnapPoint),
    /// `scroll-snap-points-y`
    ScrollSnapPointsY(crate::values::specified::ScrollSnapPoint),
    /// `-moz-window-transform`
    MozWindowTransform(crate::values::specified::Transform),
    /// `transform`
    Transform(crate::values::specified::Transform),
    /// `column-gap`
    ColumnGap(crate::values::specified::length::NonNegativeLengthPercentageOrNormal),
    /// `row-gap`
    RowGap(crate::values::specified::length::NonNegativeLengthPercentageOrNormal),
    /// `object-position`
    ObjectPosition(Box<crate::values::specified::Position>),
    /// `perspective-origin`
    PerspectiveOrigin(Box<crate::values::specified::Position>),
    /// `scroll-snap-destination`
    ScrollSnapDestination(Box<crate::values::specified::Position>),
    /// `grid-column-end`
    GridColumnEnd(Box<crate::values::specified::GridLine>),
    /// `grid-column-start`
    GridColumnStart(Box<crate::values::specified::GridLine>),
    /// `grid-row-end`
    GridRowEnd(Box<crate::values::specified::GridLine>),
    /// `grid-row-start`
    GridRowStart(Box<crate::values::specified::GridLine>),
    /// `max-block-size`
    MaxBlockSize(crate::values::specified::MaxSize),
    /// `max-height`
    MaxHeight(crate::values::specified::MaxSize),
    /// `max-inline-size`
    MaxInlineSize(crate::values::specified::MaxSize),
    /// `max-width`
    MaxWidth(crate::values::specified::MaxSize),
    /// `marker-end`
    MarkerEnd(crate::values::specified::url::UrlOrNone),
    /// `marker-mid`
    MarkerMid(crate::values::specified::url::UrlOrNone),
    /// `marker-start`
    MarkerStart(crate::values::specified::url::UrlOrNone),
    /// `-moz-binding`
    MozBinding(crate::values::specified::url::UrlOrNone),
    /// `scroll-padding-block-end`
    ScrollPaddingBlockEnd(crate::values::specified::NonNegativeLengthPercentageOrAuto),
    /// `scroll-padding-block-start`
    ScrollPaddingBlockStart(crate::values::specified::NonNegativeLengthPercentageOrAuto),
    /// `scroll-padding-bottom`
    ScrollPaddingBottom(crate::values::specified::NonNegativeLengthPercentageOrAuto),
    /// `scroll-padding-inline-end`
    ScrollPaddingInlineEnd(crate::values::specified::NonNegativeLengthPercentageOrAuto),
    /// `scroll-padding-inline-start`
    ScrollPaddingInlineStart(crate::values::specified::NonNegativeLengthPercentageOrAuto),
    /// `scroll-padding-left`
    ScrollPaddingLeft(crate::values::specified::NonNegativeLengthPercentageOrAuto),
    /// `scroll-padding-right`
    ScrollPaddingRight(crate::values::specified::NonNegativeLengthPercentageOrAuto),
    /// `scroll-padding-top`
    ScrollPaddingTop(crate::values::specified::NonNegativeLengthPercentageOrAuto),
    /// `block-size`
    BlockSize(crate::values::specified::Size),
    /// `height`
    Height(crate::values::specified::Size),
    /// `inline-size`
    InlineSize(crate::values::specified::Size),
    /// `min-block-size`
    MinBlockSize(crate::values::specified::Size),
    /// `min-height`
    MinHeight(crate::values::specified::Size),
    /// `min-inline-size`
    MinInlineSize(crate::values::specified::Size),
    /// `min-width`
    MinWidth(crate::values::specified::Size),
    /// `width`
    Width(crate::values::specified::Size),
    /// `outline-offset`
    OutlineOffset(crate::values::specified::Length),
    /// `scroll-margin-block-end`
    ScrollMarginBlockEnd(crate::values::specified::Length),
    /// `scroll-margin-block-start`
    ScrollMarginBlockStart(crate::values::specified::Length),
    /// `scroll-margin-bottom`
    ScrollMarginBottom(crate::values::specified::Length),
    /// `scroll-margin-inline-end`
    ScrollMarginInlineEnd(crate::values::specified::Length),
    /// `scroll-margin-inline-start`
    ScrollMarginInlineStart(crate::values::specified::Length),
    /// `scroll-margin-left`
    ScrollMarginLeft(crate::values::specified::Length),
    /// `scroll-margin-right`
    ScrollMarginRight(crate::values::specified::Length),
    /// `scroll-margin-top`
    ScrollMarginTop(crate::values::specified::Length),
    /// `padding-block-end`
    PaddingBlockEnd(crate::values::specified::NonNegativeLengthPercentage),
    /// `padding-block-start`
    PaddingBlockStart(crate::values::specified::NonNegativeLengthPercentage),
    /// `padding-bottom`
    PaddingBottom(crate::values::specified::NonNegativeLengthPercentage),
    /// `padding-inline-end`
    PaddingInlineEnd(crate::values::specified::NonNegativeLengthPercentage),
    /// `padding-inline-start`
    PaddingInlineStart(crate::values::specified::NonNegativeLengthPercentage),
    /// `padding-left`
    PaddingLeft(crate::values::specified::NonNegativeLengthPercentage),
    /// `padding-right`
    PaddingRight(crate::values::specified::NonNegativeLengthPercentage),
    /// `padding-top`
    PaddingTop(crate::values::specified::NonNegativeLengthPercentage),
    /// `shape-margin`
    ShapeMargin(crate::values::specified::NonNegativeLengthPercentage),
    /// `border-block-end-width`
    BorderBlockEndWidth(crate::values::specified::BorderSideWidth),
    /// `border-block-start-width`
    BorderBlockStartWidth(crate::values::specified::BorderSideWidth),
    /// `border-bottom-width`
    BorderBottomWidth(crate::values::specified::BorderSideWidth),
    /// `border-inline-end-width`
    BorderInlineEndWidth(crate::values::specified::BorderSideWidth),
    /// `border-inline-start-width`
    BorderInlineStartWidth(crate::values::specified::BorderSideWidth),
    /// `border-left-width`
    BorderLeftWidth(crate::values::specified::BorderSideWidth),
    /// `border-right-width`
    BorderRightWidth(crate::values::specified::BorderSideWidth),
    /// `border-top-width`
    BorderTopWidth(crate::values::specified::BorderSideWidth),
    /// `column-rule-width`
    ColumnRuleWidth(crate::values::specified::BorderSideWidth),
    /// `outline-width`
    OutlineWidth(crate::values::specified::BorderSideWidth),
    /// `-webkit-text-stroke-width`
    WebkitTextStrokeWidth(crate::values::specified::BorderSideWidth),
    /// `border-bottom-left-radius`
    BorderBottomLeftRadius(Box<crate::values::specified::BorderCornerRadius>),
    /// `border-bottom-right-radius`
    BorderBottomRightRadius(Box<crate::values::specified::BorderCornerRadius>),
    /// `border-end-end-radius`
    BorderEndEndRadius(Box<crate::values::specified::BorderCornerRadius>),
    /// `border-end-start-radius`
    BorderEndStartRadius(Box<crate::values::specified::BorderCornerRadius>),
    /// `border-start-end-radius`
    BorderStartEndRadius(Box<crate::values::specified::BorderCornerRadius>),
    /// `border-start-start-radius`
    BorderStartStartRadius(Box<crate::values::specified::BorderCornerRadius>),
    /// `border-top-left-radius`
    BorderTopLeftRadius(Box<crate::values::specified::BorderCornerRadius>),
    /// `border-top-right-radius`
    BorderTopRightRadius(Box<crate::values::specified::BorderCornerRadius>),
    /// `-moz-outline-radius-bottomleft`
    MozOutlineRadiusBottomleft(Box<crate::values::specified::BorderCornerRadius>),
    /// `-moz-outline-radius-bottomright`
    MozOutlineRadiusBottomright(Box<crate::values::specified::BorderCornerRadius>),
    /// `-moz-outline-radius-topleft`
    MozOutlineRadiusTopleft(Box<crate::values::specified::BorderCornerRadius>),
    /// `-moz-outline-radius-topright`
    MozOutlineRadiusTopright(Box<crate::values::specified::BorderCornerRadius>),
    /// `bottom`
    Bottom(crate::values::specified::LengthPercentageOrAuto),
    /// `inset-block-end`
    InsetBlockEnd(crate::values::specified::LengthPercentageOrAuto),
    /// `inset-block-start`
    InsetBlockStart(crate::values::specified::LengthPercentageOrAuto),
    /// `inset-inline-end`
    InsetInlineEnd(crate::values::specified::LengthPercentageOrAuto),
    /// `inset-inline-start`
    InsetInlineStart(crate::values::specified::LengthPercentageOrAuto),
    /// `left`
    Left(crate::values::specified::LengthPercentageOrAuto),
    /// `margin-block-end`
    MarginBlockEnd(crate::values::specified::LengthPercentageOrAuto),
    /// `margin-block-start`
    MarginBlockStart(crate::values::specified::LengthPercentageOrAuto),
    /// `margin-bottom`
    MarginBottom(crate::values::specified::LengthPercentageOrAuto),
    /// `margin-inline-end`
    MarginInlineEnd(crate::values::specified::LengthPercentageOrAuto),
    /// `margin-inline-start`
    MarginInlineStart(crate::values::specified::LengthPercentageOrAuto),
    /// `margin-left`
    MarginLeft(crate::values::specified::LengthPercentageOrAuto),
    /// `margin-right`
    MarginRight(crate::values::specified::LengthPercentageOrAuto),
    /// `margin-top`
    MarginTop(crate::values::specified::LengthPercentageOrAuto),
    /// `right`
    Right(crate::values::specified::LengthPercentageOrAuto),
    /// `top`
    Top(crate::values::specified::LengthPercentageOrAuto),
    /// `background-color`
    BackgroundColor(crate::values::specified::Color),
    /// `border-block-end-color`
    BorderBlockEndColor(crate::values::specified::Color),
    /// `border-block-start-color`
    BorderBlockStartColor(crate::values::specified::Color),
    /// `border-bottom-color`
    BorderBottomColor(crate::values::specified::Color),
    /// `border-inline-end-color`
    BorderInlineEndColor(crate::values::specified::Color),
    /// `border-inline-start-color`
    BorderInlineStartColor(crate::values::specified::Color),
    /// `border-left-color`
    BorderLeftColor(crate::values::specified::Color),
    /// `border-right-color`
    BorderRightColor(crate::values::specified::Color),
    /// `border-top-color`
    BorderTopColor(crate::values::specified::Color),
    /// `column-rule-color`
    ColumnRuleColor(crate::values::specified::Color),
    /// `flood-color`
    FloodColor(crate::values::specified::Color),
    /// `lighting-color`
    LightingColor(crate::values::specified::Color),
    /// `outline-color`
    OutlineColor(crate::values::specified::Color),
    /// `stop-color`
    StopColor(crate::values::specified::Color),
    /// `text-decoration-color`
    TextDecorationColor(crate::values::specified::Color),
    /// `text-emphasis-color`
    TextEmphasisColor(crate::values::specified::Color),
    /// `-webkit-text-fill-color`
    WebkitTextFillColor(crate::values::specified::Color),
    /// `-webkit-text-stroke-color`
    WebkitTextStrokeColor(crate::values::specified::Color),
    /// A CSS-wide keyword.
    CSSWideKeyword(WideKeywordDeclaration),
    /// An unparsed declaration.
    WithVariables(VariableDeclaration),
    /// A custom property declaration.
    Custom(CustomDeclaration),
}

#[repr(C)]
struct PropertyDeclarationVariantRepr<T> {
    tag: u16,
    value: T
}

impl Clone for PropertyDeclaration {
    #[inline]
    fn clone(&self) -> Self {
        use self::PropertyDeclaration::*;

        

        let self_tag = unsafe {
            (*(self as *const _ as *const PropertyDeclarationVariantRepr<()>)).tag
        };
        if self_tag <= LonghandId::ColumnRuleStyle as u16 {
            #[derive(Clone, Copy)]
            #[repr(u16)]
            enum CopyVariants {
                _AlignContent(crate::values::specified::AlignContent),
                _AlignItems(crate::values::specified::AlignItems),
                _AlignSelf(crate::values::specified::AlignSelf),
                _BackfaceVisibility(longhands::backface_visibility::SpecifiedValue),
                _BorderCollapse(longhands::border_collapse::SpecifiedValue),
                _BorderImageRepeat(crate::values::specified::BorderImageRepeat),
                _BoxDecorationBreak(longhands::box_decoration_break::SpecifiedValue),
                _BoxSizing(longhands::box_sizing::SpecifiedValue),
                _BreakInside(crate::values::specified::BreakWithin),
                _CaptionSide(longhands::caption_side::SpecifiedValue),
                _Clear(crate::values::specified::Clear),
                _ColorAdjust(longhands::color_adjust::SpecifiedValue),
                _ColorInterpolation(longhands::color_interpolation::SpecifiedValue),
                _ColorInterpolationFilters(longhands::color_interpolation_filters::SpecifiedValue),
                _ColumnCount(crate::values::specified::ColumnCount),
                _ColumnFill(longhands::column_fill::SpecifiedValue),
                _ColumnSpan(longhands::column_span::SpecifiedValue),
                _Contain(crate::values::specified::Contain),
                _Direction(longhands::direction::SpecifiedValue),
                _Display(crate::values::specified::Display),
                _DominantBaseline(longhands::dominant_baseline::SpecifiedValue),
                _EmptyCells(longhands::empty_cells::SpecifiedValue),
                _FlexDirection(longhands::flex_direction::SpecifiedValue),
                _FlexWrap(longhands::flex_wrap::SpecifiedValue),
                _Float(crate::values::specified::Float),
                _FontKerning(longhands::font_kerning::SpecifiedValue),
                _FontOpticalSizing(longhands::font_optical_sizing::SpecifiedValue),
                _FontSizeAdjust(crate::values::specified::FontSizeAdjust),
                _FontStretch(crate::values::specified::FontStretch),
                _FontStyle(crate::values::specified::FontStyle),
                _FontSynthesis(crate::values::specified::FontSynthesis),
                _FontVariantCaps(longhands::font_variant_caps::SpecifiedValue),
                _FontVariantEastAsian(crate::values::specified::FontVariantEastAsian),
                _FontVariantLigatures(crate::values::specified::FontVariantLigatures),
                _FontVariantNumeric(crate::values::specified::FontVariantNumeric),
                _FontVariantPosition(longhands::font_variant_position::SpecifiedValue),
                _FontWeight(crate::values::specified::FontWeight),
                _GridAutoFlow(crate::values::specified::GridAutoFlow),
                _Hyphens(longhands::hyphens::SpecifiedValue),
                _ImageOrientation(longhands::image_orientation::SpecifiedValue),
                _ImageRendering(longhands::image_rendering::SpecifiedValue),
                _ImeMode(longhands::ime_mode::SpecifiedValue),
                _InitialLetter(crate::values::specified::InitialLetter),
                _Isolation(longhands::isolation::SpecifiedValue),
                _JustifyContent(crate::values::specified::JustifyContent),
                _JustifyItems(crate::values::specified::JustifyItems),
                _JustifySelf(crate::values::specified::JustifySelf),
                _ListStylePosition(longhands::list_style_position::SpecifiedValue),
                _MaskType(longhands::mask_type::SpecifiedValue),
                _MixBlendMode(longhands::mix_blend_mode::SpecifiedValue),
                _MozAppearance(crate::values::specified::Appearance),
                _MozBoxAlign(longhands::_moz_box_align::SpecifiedValue),
                _MozBoxDirection(longhands::_moz_box_direction::SpecifiedValue),
                _MozBoxOrient(longhands::_moz_box_orient::SpecifiedValue),
                _MozBoxPack(longhands::_moz_box_pack::SpecifiedValue),
                _MozControlCharacterVisibility(longhands::_moz_control_character_visibility::SpecifiedValue),
                _MozFloatEdge(longhands::_moz_float_edge::SpecifiedValue),
                _MozForceBrokenImageIcon(crate::values::specified::MozForceBrokenImageIcon),
                _MozListReversed(crate::values::specified::MozListReversed),
                _MozMathDisplay(longhands::_moz_math_display::SpecifiedValue),
                _MozMathVariant(longhands::_moz_math_variant::SpecifiedValue),
                _MozMinFontSizeRatio(crate::values::specified::Percentage),
                _MozOrient(longhands::_moz_orient::SpecifiedValue),
                _MozOsxFontSmoothing(longhands::_moz_osx_font_smoothing::SpecifiedValue),
                _MozScriptLevel(crate::values::specified::MozScriptLevel),
                _MozScriptMinSize(crate::values::specified::MozScriptMinSize),
                _MozScriptSizeMultiplier(crate::values::specified::MozScriptSizeMultiplier),
                _MozStackSizing(longhands::_moz_stack_sizing::SpecifiedValue),
                _MozTextSizeAdjust(longhands::_moz_text_size_adjust::SpecifiedValue),
                _MozTopLayer(longhands::_moz_top_layer::SpecifiedValue),
                _MozUserFocus(longhands::_moz_user_focus::SpecifiedValue),
                _MozUserInput(longhands::_moz_user_input::SpecifiedValue),
                _MozUserModify(longhands::_moz_user_modify::SpecifiedValue),
                _MozUserSelect(crate::values::specified::UserSelect),
                _MozWindowDragging(longhands::_moz_window_dragging::SpecifiedValue),
                _MozWindowShadow(longhands::_moz_window_shadow::SpecifiedValue),
                _ObjectFit(longhands::object_fit::SpecifiedValue),
                _OutlineStyle(crate::values::specified::OutlineStyle),
                _OverflowAnchor(crate::values::specified::OverflowAnchor),
                _OverflowWrap(crate::values::specified::OverflowWrap),
                _PaintOrder(crate::values::specified::SVGPaintOrder),
                _PointerEvents(longhands::pointer_events::SpecifiedValue),
                _Position(longhands::position::SpecifiedValue),
                _Resize(crate::values::specified::Resize),
                _RubyAlign(longhands::ruby_align::SpecifiedValue),
                _RubyPosition(longhands::ruby_position::SpecifiedValue),
                _ScrollBehavior(longhands::scroll_behavior::SpecifiedValue),
                _ScrollSnapAlign(crate::values::specified::ScrollSnapAlign),
                _ScrollSnapType(crate::values::specified::ScrollSnapType),
                _ScrollbarWidth(longhands::scrollbar_width::SpecifiedValue),
                _ShapeRendering(longhands::shape_rendering::SpecifiedValue),
                _StrokeLinecap(longhands::stroke_linecap::SpecifiedValue),
                _StrokeLinejoin(longhands::stroke_linejoin::SpecifiedValue),
                _TableLayout(longhands::table_layout::SpecifiedValue),
                _TextAlign(crate::values::specified::TextAlign),
                _TextAlignLast(longhands::text_align_last::SpecifiedValue),
                _TextAnchor(longhands::text_anchor::SpecifiedValue),
                _TextCombineUpright(longhands::text_combine_upright::SpecifiedValue),
                _TextDecorationLine(crate::values::specified::TextDecorationLine),
                _TextDecorationStyle(longhands::text_decoration_style::SpecifiedValue),
                _TextEmphasisPosition(crate::values::specified::TextEmphasisPosition),
                _TextJustify(longhands::text_justify::SpecifiedValue),
                _TextOrientation(longhands::text_orientation::SpecifiedValue),
                _TextRendering(longhands::text_rendering::SpecifiedValue),
                _TextTransform(crate::values::specified::TextTransform),
                _TouchAction(crate::values::specified::TouchAction),
                _TransformBox(longhands::transform_box::SpecifiedValue),
                _TransformStyle(crate::values::specified::TransformStyle),
                _UnicodeBidi(longhands::unicode_bidi::SpecifiedValue),
                _VectorEffect(longhands::vector_effect::SpecifiedValue),
                _Visibility(longhands::visibility::SpecifiedValue),
                _WebkitLineClamp(crate::values::specified::PositiveIntegerOrNone),
                _WhiteSpace(longhands::white_space::SpecifiedValue),
                _WordBreak(crate::values::specified::WordBreak),
                _WritingMode(longhands::writing_mode::SpecifiedValue),
                _XSpan(crate::values::specified::XSpan),
                _XTextZoom(crate::values::specified::XTextZoom),
                _ZIndex(crate::values::specified::ZIndex),
                _BreakAfter(crate::values::specified::BreakBetween),
                _BreakBefore(crate::values::specified::BreakBetween),
                _ClipRule(crate::values::specified::FillRule),
                _FillRule(crate::values::specified::FillRule),
                _MozBoxOrdinalGroup(crate::values::specified::Integer),
                _Order(crate::values::specified::Integer),
                _OverflowX(crate::values::specified::Overflow),
                _OverflowY(crate::values::specified::Overflow),
                _OverflowClipBoxBlock(crate::values::specified::OverflowClipBox),
                _OverflowClipBoxInline(crate::values::specified::OverflowClipBox),
                _OverscrollBehaviorX(crate::values::specified::OverscrollBehavior),
                _OverscrollBehaviorY(crate::values::specified::OverscrollBehavior),
                _FillOpacity(crate::values::specified::SVGOpacity),
                _StrokeOpacity(crate::values::specified::SVGOpacity),
                _FlexGrow(crate::values::specified::NonNegativeNumber),
                _FlexShrink(crate::values::specified::NonNegativeNumber),
                _MozBoxFlex(crate::values::specified::NonNegativeNumber),
                _StrokeMiterlimit(crate::values::specified::NonNegativeNumber),
                _FloodOpacity(crate::values::specified::Opacity),
                _MozWindowOpacity(crate::values::specified::Opacity),
                _Opacity(crate::values::specified::Opacity),
                _ShapeImageThreshold(crate::values::specified::Opacity),
                _StopOpacity(crate::values::specified::Opacity),
                _BorderBlockEndStyle(crate::values::specified::BorderStyle),
                _BorderBlockStartStyle(crate::values::specified::BorderStyle),
                _BorderBottomStyle(crate::values::specified::BorderStyle),
                _BorderInlineEndStyle(crate::values::specified::BorderStyle),
                _BorderInlineStartStyle(crate::values::specified::BorderStyle),
                _BorderLeftStyle(crate::values::specified::BorderStyle),
                _BorderRightStyle(crate::values::specified::BorderStyle),
                _BorderTopStyle(crate::values::specified::BorderStyle),
                _ColumnRuleStyle(crate::values::specified::BorderStyle),
            }

            unsafe {
                let mut out = mem::uninitialized();
                ptr::write(
                    &mut out as *mut _ as *mut CopyVariants,
                    *(self as *const _ as *const CopyVariants),
                );
                return out;
            }
        }

        // This function ensures that all properties not handled above
        // do not have a specified value implements Copy. If you hit
        // compile error here, you may want to add the type name into
        // Longhand.specified_is_copy in data.py.
        fn _static_assert_others_are_not_copy() {
            struct Helper<T>(T);
            trait AssertCopy { fn assert() {} }
            trait AssertNotCopy { fn assert() {} }
            impl<T: Copy> AssertCopy for Helper<T> {}
            impl AssertNotCopy for Helper<Box<crate::values::specified::BorderImageSlice>> {}
            Helper::<Box<crate::values::specified::BorderImageSlice>>::assert();
            impl AssertNotCopy for Helper<longhands::mask_position_x::SpecifiedValue> {}
            Helper::<longhands::mask_position_x::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::length::NonNegativeLengthPercentageOrNormal> {}
            Helper::<crate::values::specified::length::NonNegativeLengthPercentageOrNormal>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::Color> {}
            Helper::<crate::values::specified::Color>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::FontVariationSettings> {}
            Helper::<crate::values::specified::FontVariationSettings>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::TextOverflow>> {}
            Helper::<Box<crate::values::specified::TextOverflow>>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::Cursor> {}
            Helper::<crate::values::specified::Cursor>::assert();
            impl AssertNotCopy for Helper<longhands::background_attachment::SpecifiedValue> {}
            Helper::<longhands::background_attachment::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<longhands::background_repeat::SpecifiedValue> {}
            Helper::<longhands::background_repeat::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::SVGStrokeDashArray> {}
            Helper::<crate::values::specified::SVGStrokeDashArray>::assert();
            impl AssertNotCopy for Helper<longhands::animation_direction::SpecifiedValue> {}
            Helper::<longhands::animation_direction::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::FontFeatureSettings> {}
            Helper::<crate::values::specified::FontFeatureSettings>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::CounterSetOrReset> {}
            Helper::<crate::values::specified::CounterSetOrReset>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::FontSize> {}
            Helper::<crate::values::specified::FontSize>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::Transform> {}
            Helper::<crate::values::specified::Transform>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::Perspective> {}
            Helper::<crate::values::specified::Perspective>::assert();
            impl AssertNotCopy for Helper<longhands::transition_duration::SpecifiedValue> {}
            Helper::<longhands::transition_duration::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::ColorPropertyValue> {}
            Helper::<crate::values::specified::ColorPropertyValue>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::GridLine>> {}
            Helper::<Box<crate::values::specified::GridLine>>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::FontLanguageOverride> {}
            Helper::<crate::values::specified::FontLanguageOverride>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::MaxSize> {}
            Helper::<crate::values::specified::MaxSize>::assert();
            impl AssertNotCopy for Helper<longhands::mask_image::SpecifiedValue> {}
            Helper::<longhands::mask_image::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<longhands::mask_composite::SpecifiedValue> {}
            Helper::<longhands::mask_composite::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::WordSpacing> {}
            Helper::<crate::values::specified::WordSpacing>::assert();
            impl AssertNotCopy for Helper<longhands::background_blend_mode::SpecifiedValue> {}
            Helper::<longhands::background_blend_mode::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<longhands::background_image::SpecifiedValue> {}
            Helper::<longhands::background_image::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::FontFamily> {}
            Helper::<crate::values::specified::FontFamily>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::TrackSize>> {}
            Helper::<Box<crate::values::specified::TrackSize>>::assert();
            impl AssertNotCopy for Helper<longhands::mask_size::SpecifiedValue> {}
            Helper::<longhands::mask_size::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<longhands::text_shadow::SpecifiedValue> {}
            Helper::<longhands::text_shadow::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<longhands::background_clip::SpecifiedValue> {}
            Helper::<longhands::background_clip::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::VerticalAlign> {}
            Helper::<crate::values::specified::VerticalAlign>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::BorderCornerRadius>> {}
            Helper::<Box<crate::values::specified::BorderCornerRadius>>::assert();
            impl AssertNotCopy for Helper<longhands::background_position_y::SpecifiedValue> {}
            Helper::<longhands::background_position_y::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::color::MozFontSmoothingBackgroundColor> {}
            Helper::<crate::values::specified::color::MozFontSmoothingBackgroundColor>::assert();
            impl AssertNotCopy for Helper<CustomDeclaration> {}
            Helper::<CustomDeclaration>::assert();
            impl AssertNotCopy for Helper<longhands::animation_iteration_count::SpecifiedValue> {}
            Helper::<longhands::animation_iteration_count::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<longhands::mask_mode::SpecifiedValue> {}
            Helper::<longhands::mask_mode::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::url::UrlOrNone> {}
            Helper::<crate::values::specified::url::UrlOrNone>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::FlexBasis>> {}
            Helper::<Box<crate::values::specified::FlexBasis>>::assert();
            impl AssertNotCopy for Helper<longhands::background_origin::SpecifiedValue> {}
            Helper::<longhands::background_origin::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<longhands::transition_timing_function::SpecifiedValue> {}
            Helper::<longhands::transition_timing_function::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::ClipRectOrAuto>> {}
            Helper::<Box<crate::values::specified::ClipRectOrAuto>>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::Position>> {}
            Helper::<Box<crate::values::specified::Position>>::assert();
            impl AssertNotCopy for Helper<longhands::background_position_x::SpecifiedValue> {}
            Helper::<longhands::background_position_x::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::GridTemplateComponent>> {}
            Helper::<Box<crate::values::specified::GridTemplateComponent>>::assert();
            impl AssertNotCopy for Helper<longhands::transition_delay::SpecifiedValue> {}
            Helper::<longhands::transition_delay::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::basic_shape::FloatAreaShape>> {}
            Helper::<Box<crate::values::specified::basic_shape::FloatAreaShape>>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::FontVariantAlternates> {}
            Helper::<crate::values::specified::FontVariantAlternates>::assert();
            impl AssertNotCopy for Helper<longhands::animation_name::SpecifiedValue> {}
            Helper::<longhands::animation_name::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::Quotes> {}
            Helper::<crate::values::specified::Quotes>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::NonNegativeLengthOrNumber> {}
            Helper::<crate::values::specified::NonNegativeLengthOrNumber>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::ColorOrAuto>> {}
            Helper::<Box<crate::values::specified::ColorOrAuto>>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::LineHeight> {}
            Helper::<crate::values::specified::LineHeight>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::Size> {}
            Helper::<crate::values::specified::Size>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::WillChange> {}
            Helper::<crate::values::specified::WillChange>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::length::NonNegativeLengthOrAuto> {}
            Helper::<crate::values::specified::length::NonNegativeLengthOrAuto>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::url::ImageUrlOrNone> {}
            Helper::<crate::values::specified::url::ImageUrlOrNone>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::ui::ScrollbarColor>> {}
            Helper::<Box<crate::values::specified::ui::ScrollbarColor>>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::ListStyleType>> {}
            Helper::<Box<crate::values::specified::ListStyleType>>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::LengthPercentageOrAuto> {}
            Helper::<crate::values::specified::LengthPercentageOrAuto>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::TextEmphasisStyle>> {}
            Helper::<Box<crate::values::specified::TextEmphasisStyle>>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::BorderSpacing>> {}
            Helper::<Box<crate::values::specified::BorderSpacing>>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::TransformOrigin>> {}
            Helper::<Box<crate::values::specified::TransformOrigin>>::assert();
            impl AssertNotCopy for Helper<longhands::animation_fill_mode::SpecifiedValue> {}
            Helper::<longhands::animation_fill_mode::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::BorderSideWidth> {}
            Helper::<crate::values::specified::BorderSideWidth>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::SVGPaint>> {}
            Helper::<Box<crate::values::specified::SVGPaint>>::assert();
            impl AssertNotCopy for Helper<VariableDeclaration> {}
            Helper::<VariableDeclaration>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::ScrollSnapPoint> {}
            Helper::<crate::values::specified::ScrollSnapPoint>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::basic_shape::ClippingShape> {}
            Helper::<crate::values::specified::basic_shape::ClippingShape>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::XLang> {}
            Helper::<crate::values::specified::XLang>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::LetterSpacing> {}
            Helper::<crate::values::specified::LetterSpacing>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::CounterIncrement> {}
            Helper::<crate::values::specified::CounterIncrement>::assert();
            impl AssertNotCopy for Helper<longhands::scroll_snap_coordinate::SpecifiedValue> {}
            Helper::<longhands::scroll_snap_coordinate::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<longhands::transition_property::SpecifiedValue> {}
            Helper::<longhands::transition_property::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<longhands::animation_delay::SpecifiedValue> {}
            Helper::<longhands::animation_delay::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::Translate>> {}
            Helper::<Box<crate::values::specified::Translate>>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::Content> {}
            Helper::<crate::values::specified::Content>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::ImageLayer> {}
            Helper::<crate::values::specified::ImageLayer>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::NonNegativeLengthOrNumberRect>> {}
            Helper::<Box<crate::values::specified::NonNegativeLengthOrNumberRect>>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::NonNegativeLengthPercentageOrAuto> {}
            Helper::<crate::values::specified::NonNegativeLengthPercentageOrAuto>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::BorderImageWidth>> {}
            Helper::<Box<crate::values::specified::BorderImageWidth>>::assert();
            impl AssertNotCopy for Helper<longhands::box_shadow::SpecifiedValue> {}
            Helper::<longhands::box_shadow::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<longhands::filter::SpecifiedValue> {}
            Helper::<longhands::filter::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::GridTemplateAreas> {}
            Helper::<crate::values::specified::GridTemplateAreas>::assert();
            impl AssertNotCopy for Helper<longhands::animation_duration::SpecifiedValue> {}
            Helper::<longhands::animation_duration::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::Length> {}
            Helper::<crate::values::specified::Length>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::SVGWidth> {}
            Helper::<crate::values::specified::SVGWidth>::assert();
            impl AssertNotCopy for Helper<WideKeywordDeclaration> {}
            Helper::<WideKeywordDeclaration>::assert();
            impl AssertNotCopy for Helper<longhands::mask_clip::SpecifiedValue> {}
            Helper::<longhands::mask_clip::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::LengthPercentage> {}
            Helper::<crate::values::specified::LengthPercentage>::assert();
            impl AssertNotCopy for Helper<longhands::mask_repeat::SpecifiedValue> {}
            Helper::<longhands::mask_repeat::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::Rotate>> {}
            Helper::<Box<crate::values::specified::Rotate>>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::NonNegativeLengthPercentage> {}
            Helper::<crate::values::specified::NonNegativeLengthPercentage>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::OffsetPath> {}
            Helper::<crate::values::specified::OffsetPath>::assert();
            impl AssertNotCopy for Helper<longhands::animation_play_state::SpecifiedValue> {}
            Helper::<longhands::animation_play_state::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<longhands::background_size::SpecifiedValue> {}
            Helper::<longhands::background_size::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<longhands::mask_position_y::SpecifiedValue> {}
            Helper::<longhands::mask_position_y::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<longhands::mask_origin::SpecifiedValue> {}
            Helper::<longhands::mask_origin::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::SVGLength> {}
            Helper::<crate::values::specified::SVGLength>::assert();
            impl AssertNotCopy for Helper<Box<crate::values::specified::Scale>> {}
            Helper::<Box<crate::values::specified::Scale>>::assert();
            impl AssertNotCopy for Helper<longhands::animation_timing_function::SpecifiedValue> {}
            Helper::<longhands::animation_timing_function::SpecifiedValue>::assert();
            impl AssertNotCopy for Helper<crate::values::specified::MozContextProperties> {}
            Helper::<crate::values::specified::MozContextProperties>::assert();
        }

        match *self {
            AlignContent(..) |
AlignItems(..) |
AlignSelf(..) |
BackfaceVisibility(..) |
BorderCollapse(..) |
BorderImageRepeat(..) |
BoxDecorationBreak(..) |
BoxSizing(..) |
BreakInside(..) |
CaptionSide(..) |
Clear(..) |
ColorAdjust(..) |
ColorInterpolation(..) |
ColorInterpolationFilters(..) |
ColumnCount(..) |
ColumnFill(..) |
ColumnSpan(..) |
Contain(..) |
Direction(..) |
Display(..) |
DominantBaseline(..) |
EmptyCells(..) |
FlexDirection(..) |
FlexWrap(..) |
Float(..) |
FontKerning(..) |
FontOpticalSizing(..) |
FontSizeAdjust(..) |
FontStretch(..) |
FontStyle(..) |
FontSynthesis(..) |
FontVariantCaps(..) |
FontVariantEastAsian(..) |
FontVariantLigatures(..) |
FontVariantNumeric(..) |
FontVariantPosition(..) |
FontWeight(..) |
GridAutoFlow(..) |
Hyphens(..) |
ImageOrientation(..) |
ImageRendering(..) |
ImeMode(..) |
InitialLetter(..) |
Isolation(..) |
JustifyContent(..) |
JustifyItems(..) |
JustifySelf(..) |
ListStylePosition(..) |
MaskType(..) |
MixBlendMode(..) |
MozAppearance(..) |
MozBoxAlign(..) |
MozBoxDirection(..) |
MozBoxOrient(..) |
MozBoxPack(..) |
MozControlCharacterVisibility(..) |
MozFloatEdge(..) |
MozForceBrokenImageIcon(..) |
MozListReversed(..) |
MozMathDisplay(..) |
MozMathVariant(..) |
MozMinFontSizeRatio(..) |
MozOrient(..) |
MozOsxFontSmoothing(..) |
MozScriptLevel(..) |
MozScriptMinSize(..) |
MozScriptSizeMultiplier(..) |
MozStackSizing(..) |
MozTextSizeAdjust(..) |
MozTopLayer(..) |
MozUserFocus(..) |
MozUserInput(..) |
MozUserModify(..) |
MozUserSelect(..) |
MozWindowDragging(..) |
MozWindowShadow(..) |
ObjectFit(..) |
OutlineStyle(..) |
OverflowAnchor(..) |
OverflowWrap(..) |
PaintOrder(..) |
PointerEvents(..) |
Position(..) |
Resize(..) |
RubyAlign(..) |
RubyPosition(..) |
ScrollBehavior(..) |
ScrollSnapAlign(..) |
ScrollSnapType(..) |
ScrollbarWidth(..) |
ShapeRendering(..) |
StrokeLinecap(..) |
StrokeLinejoin(..) |
TableLayout(..) |
TextAlign(..) |
TextAlignLast(..) |
TextAnchor(..) |
TextCombineUpright(..) |
TextDecorationLine(..) |
TextDecorationStyle(..) |
TextEmphasisPosition(..) |
TextJustify(..) |
TextOrientation(..) |
TextRendering(..) |
TextTransform(..) |
TouchAction(..) |
TransformBox(..) |
TransformStyle(..) |
UnicodeBidi(..) |
VectorEffect(..) |
Visibility(..) |
WebkitLineClamp(..) |
WhiteSpace(..) |
WordBreak(..) |
WritingMode(..) |
XSpan(..) |
XTextZoom(..) |
ZIndex(..) |
BreakAfter(..) |
BreakBefore(..) |
ClipRule(..) |
FillRule(..) |
MozBoxOrdinalGroup(..) |
Order(..) |
OverflowX(..) |
OverflowY(..) |
OverflowClipBoxBlock(..) |
OverflowClipBoxInline(..) |
OverscrollBehaviorX(..) |
OverscrollBehaviorY(..) |
FillOpacity(..) |
StrokeOpacity(..) |
FlexGrow(..) |
FlexShrink(..) |
MozBoxFlex(..) |
StrokeMiterlimit(..) |
FloodOpacity(..) |
MozWindowOpacity(..) |
Opacity(..) |
ShapeImageThreshold(..) |
StopOpacity(..) |
BorderBlockEndStyle(..) |
BorderBlockStartStyle(..) |
BorderBottomStyle(..) |
BorderInlineEndStyle(..) |
BorderInlineStartStyle(..) |
BorderLeftStyle(..) |
BorderRightStyle(..) |
BorderTopStyle(..) |
ColumnRuleStyle(..) => {
                unsafe { debug_unreachable!() }
            }
            
            AnimationDelay(ref value) => {
                AnimationDelay(value.clone())
            }
            
            AnimationDirection(ref value) => {
                AnimationDirection(value.clone())
            }
            
            AnimationDuration(ref value) => {
                AnimationDuration(value.clone())
            }
            
            AnimationFillMode(ref value) => {
                AnimationFillMode(value.clone())
            }
            
            AnimationIterationCount(ref value) => {
                AnimationIterationCount(value.clone())
            }
            
            AnimationName(ref value) => {
                AnimationName(value.clone())
            }
            
            AnimationPlayState(ref value) => {
                AnimationPlayState(value.clone())
            }
            
            AnimationTimingFunction(ref value) => {
                AnimationTimingFunction(value.clone())
            }
            
            BackgroundAttachment(ref value) => {
                BackgroundAttachment(value.clone())
            }
            
            BackgroundBlendMode(ref value) => {
                BackgroundBlendMode(value.clone())
            }
            
            BackgroundClip(ref value) => {
                BackgroundClip(value.clone())
            }
            
            BackgroundImage(ref value) => {
                BackgroundImage(value.clone())
            }
            
            BackgroundOrigin(ref value) => {
                BackgroundOrigin(value.clone())
            }
            
            BackgroundPositionX(ref value) => {
                BackgroundPositionX(value.clone())
            }
            
            BackgroundPositionY(ref value) => {
                BackgroundPositionY(value.clone())
            }
            
            BackgroundRepeat(ref value) => {
                BackgroundRepeat(value.clone())
            }
            
            BackgroundSize(ref value) => {
                BackgroundSize(value.clone())
            }
            
            BorderImageOutset(ref value) => {
                BorderImageOutset(value.clone())
            }
            
            BorderImageSlice(ref value) => {
                BorderImageSlice(value.clone())
            }
            
            BorderImageSource(ref value) => {
                BorderImageSource(value.clone())
            }
            
            BorderImageWidth(ref value) => {
                BorderImageWidth(value.clone())
            }
            
            BorderSpacing(ref value) => {
                BorderSpacing(value.clone())
            }
            
            BoxShadow(ref value) => {
                BoxShadow(value.clone())
            }
            
            CaretColor(ref value) => {
                CaretColor(value.clone())
            }
            
            ClipPath(ref value) => {
                ClipPath(value.clone())
            }
            
            Color(ref value) => {
                Color(value.clone())
            }
            
            ColumnWidth(ref value) => {
                ColumnWidth(value.clone())
            }
            
            Content(ref value) => {
                Content(value.clone())
            }
            
            CounterIncrement(ref value) => {
                CounterIncrement(value.clone())
            }
            
            Cursor(ref value) => {
                Cursor(value.clone())
            }
            
            Filter(ref value) => {
                Filter(value.clone())
            }
            
            FlexBasis(ref value) => {
                FlexBasis(value.clone())
            }
            
            FontFamily(ref value) => {
                FontFamily(value.clone())
            }
            
            FontFeatureSettings(ref value) => {
                FontFeatureSettings(value.clone())
            }
            
            FontLanguageOverride(ref value) => {
                FontLanguageOverride(value.clone())
            }
            
            FontSize(ref value) => {
                FontSize(value.clone())
            }
            
            FontVariantAlternates(ref value) => {
                FontVariantAlternates(value.clone())
            }
            
            FontVariationSettings(ref value) => {
                FontVariationSettings(value.clone())
            }
            
            GridTemplateAreas(ref value) => {
                GridTemplateAreas(value.clone())
            }
            
            LetterSpacing(ref value) => {
                LetterSpacing(value.clone())
            }
            
            LineHeight(ref value) => {
                LineHeight(value.clone())
            }
            
            ListStyleImage(ref value) => {
                ListStyleImage(value.clone())
            }
            
            ListStyleType(ref value) => {
                ListStyleType(value.clone())
            }
            
            MaskClip(ref value) => {
                MaskClip(value.clone())
            }
            
            MaskComposite(ref value) => {
                MaskComposite(value.clone())
            }
            
            MaskImage(ref value) => {
                MaskImage(value.clone())
            }
            
            MaskMode(ref value) => {
                MaskMode(value.clone())
            }
            
            MaskOrigin(ref value) => {
                MaskOrigin(value.clone())
            }
            
            MaskPositionX(ref value) => {
                MaskPositionX(value.clone())
            }
            
            MaskPositionY(ref value) => {
                MaskPositionY(value.clone())
            }
            
            MaskRepeat(ref value) => {
                MaskRepeat(value.clone())
            }
            
            MaskSize(ref value) => {
                MaskSize(value.clone())
            }
            
            MozContextProperties(ref value) => {
                MozContextProperties(value.clone())
            }
            
            MozFontSmoothingBackgroundColor(ref value) => {
                MozFontSmoothingBackgroundColor(value.clone())
            }
            
            MozTabSize(ref value) => {
                MozTabSize(value.clone())
            }
            
            OffsetPath(ref value) => {
                OffsetPath(value.clone())
            }
            
            Perspective(ref value) => {
                Perspective(value.clone())
            }
            
            Quotes(ref value) => {
                Quotes(value.clone())
            }
            
            Rotate(ref value) => {
                Rotate(value.clone())
            }
            
            Scale(ref value) => {
                Scale(value.clone())
            }
            
            ScrollSnapCoordinate(ref value) => {
                ScrollSnapCoordinate(value.clone())
            }
            
            ScrollbarColor(ref value) => {
                ScrollbarColor(value.clone())
            }
            
            ShapeOutside(ref value) => {
                ShapeOutside(value.clone())
            }
            
            StrokeDasharray(ref value) => {
                StrokeDasharray(value.clone())
            }
            
            StrokeDashoffset(ref value) => {
                StrokeDashoffset(value.clone())
            }
            
            StrokeWidth(ref value) => {
                StrokeWidth(value.clone())
            }
            
            TextEmphasisStyle(ref value) => {
                TextEmphasisStyle(value.clone())
            }
            
            TextIndent(ref value) => {
                TextIndent(value.clone())
            }
            
            TextOverflow(ref value) => {
                TextOverflow(value.clone())
            }
            
            TextShadow(ref value) => {
                TextShadow(value.clone())
            }
            
            TransitionDelay(ref value) => {
                TransitionDelay(value.clone())
            }
            
            TransitionDuration(ref value) => {
                TransitionDuration(value.clone())
            }
            
            TransitionProperty(ref value) => {
                TransitionProperty(value.clone())
            }
            
            TransitionTimingFunction(ref value) => {
                TransitionTimingFunction(value.clone())
            }
            
            Translate(ref value) => {
                Translate(value.clone())
            }
            
            VerticalAlign(ref value) => {
                VerticalAlign(value.clone())
            }
            
            WillChange(ref value) => {
                WillChange(value.clone())
            }
            
            WordSpacing(ref value) => {
                WordSpacing(value.clone())
            }
            
            XLang(ref value) => {
                XLang(value.clone())
            }
            
            Clip(ref value) |
MozImageRegion(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<Box<crate::values::specified::ClipRectOrAuto>>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            GridTemplateColumns(ref value) |
GridTemplateRows(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<Box<crate::values::specified::GridTemplateComponent>>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            Fill(ref value) |
Stroke(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<Box<crate::values::specified::SVGPaint>>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            GridAutoColumns(ref value) |
GridAutoRows(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<Box<crate::values::specified::TrackSize>>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            MozWindowTransformOrigin(ref value) |
TransformOrigin(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<Box<crate::values::specified::TransformOrigin>>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            CounterReset(ref value) |
CounterSet(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::CounterSetOrReset>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            ScrollSnapPointsX(ref value) |
ScrollSnapPointsY(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::ScrollSnapPoint>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            MozWindowTransform(ref value) |
Transform(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::Transform>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            ColumnGap(ref value) |
RowGap(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::length::NonNegativeLengthPercentageOrNormal>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            ObjectPosition(ref value) |
PerspectiveOrigin(ref value) |
ScrollSnapDestination(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<Box<crate::values::specified::Position>>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            GridColumnEnd(ref value) |
GridColumnStart(ref value) |
GridRowEnd(ref value) |
GridRowStart(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<Box<crate::values::specified::GridLine>>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            MaxBlockSize(ref value) |
MaxHeight(ref value) |
MaxInlineSize(ref value) |
MaxWidth(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::MaxSize>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            MarkerEnd(ref value) |
MarkerMid(ref value) |
MarkerStart(ref value) |
MozBinding(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::url::UrlOrNone>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            ScrollPaddingBlockEnd(ref value) |
ScrollPaddingBlockStart(ref value) |
ScrollPaddingBottom(ref value) |
ScrollPaddingInlineEnd(ref value) |
ScrollPaddingInlineStart(ref value) |
ScrollPaddingLeft(ref value) |
ScrollPaddingRight(ref value) |
ScrollPaddingTop(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::NonNegativeLengthPercentageOrAuto>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            BlockSize(ref value) |
Height(ref value) |
InlineSize(ref value) |
MinBlockSize(ref value) |
MinHeight(ref value) |
MinInlineSize(ref value) |
MinWidth(ref value) |
Width(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::Size>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            OutlineOffset(ref value) |
ScrollMarginBlockEnd(ref value) |
ScrollMarginBlockStart(ref value) |
ScrollMarginBottom(ref value) |
ScrollMarginInlineEnd(ref value) |
ScrollMarginInlineStart(ref value) |
ScrollMarginLeft(ref value) |
ScrollMarginRight(ref value) |
ScrollMarginTop(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::Length>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            PaddingBlockEnd(ref value) |
PaddingBlockStart(ref value) |
PaddingBottom(ref value) |
PaddingInlineEnd(ref value) |
PaddingInlineStart(ref value) |
PaddingLeft(ref value) |
PaddingRight(ref value) |
PaddingTop(ref value) |
ShapeMargin(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::NonNegativeLengthPercentage>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            BorderBlockEndWidth(ref value) |
BorderBlockStartWidth(ref value) |
BorderBottomWidth(ref value) |
BorderInlineEndWidth(ref value) |
BorderInlineStartWidth(ref value) |
BorderLeftWidth(ref value) |
BorderRightWidth(ref value) |
BorderTopWidth(ref value) |
ColumnRuleWidth(ref value) |
OutlineWidth(ref value) |
WebkitTextStrokeWidth(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::BorderSideWidth>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            BorderBottomLeftRadius(ref value) |
BorderBottomRightRadius(ref value) |
BorderEndEndRadius(ref value) |
BorderEndStartRadius(ref value) |
BorderStartEndRadius(ref value) |
BorderStartStartRadius(ref value) |
BorderTopLeftRadius(ref value) |
BorderTopRightRadius(ref value) |
MozOutlineRadiusBottomleft(ref value) |
MozOutlineRadiusBottomright(ref value) |
MozOutlineRadiusTopleft(ref value) |
MozOutlineRadiusTopright(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<Box<crate::values::specified::BorderCornerRadius>>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            Bottom(ref value) |
InsetBlockEnd(ref value) |
InsetBlockStart(ref value) |
InsetInlineEnd(ref value) |
InsetInlineStart(ref value) |
Left(ref value) |
MarginBlockEnd(ref value) |
MarginBlockStart(ref value) |
MarginBottom(ref value) |
MarginInlineEnd(ref value) |
MarginInlineStart(ref value) |
MarginLeft(ref value) |
MarginRight(ref value) |
MarginTop(ref value) |
Right(ref value) |
Top(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::LengthPercentageOrAuto>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            BackgroundColor(ref value) |
BorderBlockEndColor(ref value) |
BorderBlockStartColor(ref value) |
BorderBottomColor(ref value) |
BorderInlineEndColor(ref value) |
BorderInlineStartColor(ref value) |
BorderLeftColor(ref value) |
BorderRightColor(ref value) |
BorderTopColor(ref value) |
ColumnRuleColor(ref value) |
FloodColor(ref value) |
LightingColor(ref value) |
OutlineColor(ref value) |
StopColor(ref value) |
TextDecorationColor(ref value) |
TextEmphasisColor(ref value) |
WebkitTextFillColor(ref value) |
WebkitTextStrokeColor(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::Color>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            CSSWideKeyword(ref value) => {
                CSSWideKeyword(value.clone())
            }
            
            WithVariables(ref value) => {
                WithVariables(value.clone())
            }
            
            Custom(ref value) => {
                Custom(value.clone())
            }
        }
    }
}

impl PartialEq for PropertyDeclaration {
    #[inline]
    fn eq(&self, other: &Self) -> bool {
        use self::PropertyDeclaration::*;

        unsafe {
            let this_repr =
                &*(self as *const _ as *const PropertyDeclarationVariantRepr<()>);
            let other_repr =
                &*(other as *const _ as *const PropertyDeclarationVariantRepr<()>);
            if this_repr.tag != other_repr.tag {
                return false;
            }
            match *self {
                AlignContent(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::AlignContent>);
                    *this == other_repr.value
                }
                AlignItems(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::AlignItems>);
                    *this == other_repr.value
                }
                AlignSelf(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::AlignSelf>);
                    *this == other_repr.value
                }
                BackfaceVisibility(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::backface_visibility::SpecifiedValue>);
                    *this == other_repr.value
                }
                BorderCollapse(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::border_collapse::SpecifiedValue>);
                    *this == other_repr.value
                }
                BorderImageRepeat(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::BorderImageRepeat>);
                    *this == other_repr.value
                }
                BoxDecorationBreak(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::box_decoration_break::SpecifiedValue>);
                    *this == other_repr.value
                }
                BoxSizing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::box_sizing::SpecifiedValue>);
                    *this == other_repr.value
                }
                BreakInside(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::BreakWithin>);
                    *this == other_repr.value
                }
                CaptionSide(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::caption_side::SpecifiedValue>);
                    *this == other_repr.value
                }
                Clear(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Clear>);
                    *this == other_repr.value
                }
                ColorAdjust(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::color_adjust::SpecifiedValue>);
                    *this == other_repr.value
                }
                ColorInterpolation(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::color_interpolation::SpecifiedValue>);
                    *this == other_repr.value
                }
                ColorInterpolationFilters(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::color_interpolation_filters::SpecifiedValue>);
                    *this == other_repr.value
                }
                ColumnCount(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::ColumnCount>);
                    *this == other_repr.value
                }
                ColumnFill(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::column_fill::SpecifiedValue>);
                    *this == other_repr.value
                }
                ColumnSpan(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::column_span::SpecifiedValue>);
                    *this == other_repr.value
                }
                Contain(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Contain>);
                    *this == other_repr.value
                }
                Direction(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::direction::SpecifiedValue>);
                    *this == other_repr.value
                }
                Display(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Display>);
                    *this == other_repr.value
                }
                DominantBaseline(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::dominant_baseline::SpecifiedValue>);
                    *this == other_repr.value
                }
                EmptyCells(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::empty_cells::SpecifiedValue>);
                    *this == other_repr.value
                }
                FlexDirection(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::flex_direction::SpecifiedValue>);
                    *this == other_repr.value
                }
                FlexWrap(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::flex_wrap::SpecifiedValue>);
                    *this == other_repr.value
                }
                Float(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Float>);
                    *this == other_repr.value
                }
                FontKerning(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::font_kerning::SpecifiedValue>);
                    *this == other_repr.value
                }
                FontOpticalSizing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::font_optical_sizing::SpecifiedValue>);
                    *this == other_repr.value
                }
                FontSizeAdjust(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontSizeAdjust>);
                    *this == other_repr.value
                }
                FontStretch(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontStretch>);
                    *this == other_repr.value
                }
                FontStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontStyle>);
                    *this == other_repr.value
                }
                FontSynthesis(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontSynthesis>);
                    *this == other_repr.value
                }
                FontVariantCaps(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::font_variant_caps::SpecifiedValue>);
                    *this == other_repr.value
                }
                FontVariantEastAsian(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontVariantEastAsian>);
                    *this == other_repr.value
                }
                FontVariantLigatures(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontVariantLigatures>);
                    *this == other_repr.value
                }
                FontVariantNumeric(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontVariantNumeric>);
                    *this == other_repr.value
                }
                FontVariantPosition(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::font_variant_position::SpecifiedValue>);
                    *this == other_repr.value
                }
                FontWeight(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontWeight>);
                    *this == other_repr.value
                }
                GridAutoFlow(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::GridAutoFlow>);
                    *this == other_repr.value
                }
                Hyphens(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::hyphens::SpecifiedValue>);
                    *this == other_repr.value
                }
                ImageOrientation(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::image_orientation::SpecifiedValue>);
                    *this == other_repr.value
                }
                ImageRendering(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::image_rendering::SpecifiedValue>);
                    *this == other_repr.value
                }
                ImeMode(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::ime_mode::SpecifiedValue>);
                    *this == other_repr.value
                }
                InitialLetter(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::InitialLetter>);
                    *this == other_repr.value
                }
                Isolation(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::isolation::SpecifiedValue>);
                    *this == other_repr.value
                }
                JustifyContent(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::JustifyContent>);
                    *this == other_repr.value
                }
                JustifyItems(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::JustifyItems>);
                    *this == other_repr.value
                }
                JustifySelf(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::JustifySelf>);
                    *this == other_repr.value
                }
                ListStylePosition(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::list_style_position::SpecifiedValue>);
                    *this == other_repr.value
                }
                MaskType(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_type::SpecifiedValue>);
                    *this == other_repr.value
                }
                MixBlendMode(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::mix_blend_mode::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozAppearance(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Appearance>);
                    *this == other_repr.value
                }
                MozBoxAlign(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_box_align::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozBoxDirection(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_box_direction::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozBoxOrient(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_box_orient::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozBoxPack(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_box_pack::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozControlCharacterVisibility(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_control_character_visibility::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozFloatEdge(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_float_edge::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozForceBrokenImageIcon(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::MozForceBrokenImageIcon>);
                    *this == other_repr.value
                }
                MozListReversed(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::MozListReversed>);
                    *this == other_repr.value
                }
                MozMathDisplay(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_math_display::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozMathVariant(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_math_variant::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozMinFontSizeRatio(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Percentage>);
                    *this == other_repr.value
                }
                MozOrient(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_orient::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozOsxFontSmoothing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_osx_font_smoothing::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozScriptLevel(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::MozScriptLevel>);
                    *this == other_repr.value
                }
                MozScriptMinSize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::MozScriptMinSize>);
                    *this == other_repr.value
                }
                MozScriptSizeMultiplier(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::MozScriptSizeMultiplier>);
                    *this == other_repr.value
                }
                MozStackSizing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_stack_sizing::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozTextSizeAdjust(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_text_size_adjust::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozTopLayer(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_top_layer::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozUserFocus(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_user_focus::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozUserInput(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_user_input::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozUserModify(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_user_modify::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozUserSelect(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::UserSelect>);
                    *this == other_repr.value
                }
                MozWindowDragging(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_window_dragging::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozWindowShadow(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_window_shadow::SpecifiedValue>);
                    *this == other_repr.value
                }
                ObjectFit(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::object_fit::SpecifiedValue>);
                    *this == other_repr.value
                }
                OutlineStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::OutlineStyle>);
                    *this == other_repr.value
                }
                OverflowAnchor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::OverflowAnchor>);
                    *this == other_repr.value
                }
                OverflowWrap(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::OverflowWrap>);
                    *this == other_repr.value
                }
                PaintOrder(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::SVGPaintOrder>);
                    *this == other_repr.value
                }
                PointerEvents(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::pointer_events::SpecifiedValue>);
                    *this == other_repr.value
                }
                Position(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::position::SpecifiedValue>);
                    *this == other_repr.value
                }
                Resize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Resize>);
                    *this == other_repr.value
                }
                RubyAlign(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::ruby_align::SpecifiedValue>);
                    *this == other_repr.value
                }
                RubyPosition(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::ruby_position::SpecifiedValue>);
                    *this == other_repr.value
                }
                ScrollBehavior(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::scroll_behavior::SpecifiedValue>);
                    *this == other_repr.value
                }
                ScrollSnapAlign(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::ScrollSnapAlign>);
                    *this == other_repr.value
                }
                ScrollSnapType(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::ScrollSnapType>);
                    *this == other_repr.value
                }
                ScrollbarWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::scrollbar_width::SpecifiedValue>);
                    *this == other_repr.value
                }
                ShapeRendering(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::shape_rendering::SpecifiedValue>);
                    *this == other_repr.value
                }
                StrokeLinecap(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::stroke_linecap::SpecifiedValue>);
                    *this == other_repr.value
                }
                StrokeLinejoin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::stroke_linejoin::SpecifiedValue>);
                    *this == other_repr.value
                }
                TableLayout(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::table_layout::SpecifiedValue>);
                    *this == other_repr.value
                }
                TextAlign(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::TextAlign>);
                    *this == other_repr.value
                }
                TextAlignLast(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::text_align_last::SpecifiedValue>);
                    *this == other_repr.value
                }
                TextAnchor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::text_anchor::SpecifiedValue>);
                    *this == other_repr.value
                }
                TextCombineUpright(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::text_combine_upright::SpecifiedValue>);
                    *this == other_repr.value
                }
                TextDecorationLine(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::TextDecorationLine>);
                    *this == other_repr.value
                }
                TextDecorationStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::text_decoration_style::SpecifiedValue>);
                    *this == other_repr.value
                }
                TextEmphasisPosition(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::TextEmphasisPosition>);
                    *this == other_repr.value
                }
                TextJustify(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::text_justify::SpecifiedValue>);
                    *this == other_repr.value
                }
                TextOrientation(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::text_orientation::SpecifiedValue>);
                    *this == other_repr.value
                }
                TextRendering(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::text_rendering::SpecifiedValue>);
                    *this == other_repr.value
                }
                TextTransform(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::TextTransform>);
                    *this == other_repr.value
                }
                TouchAction(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::TouchAction>);
                    *this == other_repr.value
                }
                TransformBox(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::transform_box::SpecifiedValue>);
                    *this == other_repr.value
                }
                TransformStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::TransformStyle>);
                    *this == other_repr.value
                }
                UnicodeBidi(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::unicode_bidi::SpecifiedValue>);
                    *this == other_repr.value
                }
                VectorEffect(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::vector_effect::SpecifiedValue>);
                    *this == other_repr.value
                }
                Visibility(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::visibility::SpecifiedValue>);
                    *this == other_repr.value
                }
                WebkitLineClamp(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::PositiveIntegerOrNone>);
                    *this == other_repr.value
                }
                WhiteSpace(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::white_space::SpecifiedValue>);
                    *this == other_repr.value
                }
                WordBreak(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::WordBreak>);
                    *this == other_repr.value
                }
                WritingMode(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::writing_mode::SpecifiedValue>);
                    *this == other_repr.value
                }
                XSpan(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::XSpan>);
                    *this == other_repr.value
                }
                XTextZoom(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::XTextZoom>);
                    *this == other_repr.value
                }
                ZIndex(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::ZIndex>);
                    *this == other_repr.value
                }
                BreakAfter(ref this) |
BreakBefore(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::BreakBetween>);
                    *this == other_repr.value
                }
                ClipRule(ref this) |
FillRule(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FillRule>);
                    *this == other_repr.value
                }
                MozBoxOrdinalGroup(ref this) |
Order(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Integer>);
                    *this == other_repr.value
                }
                OverflowX(ref this) |
OverflowY(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Overflow>);
                    *this == other_repr.value
                }
                OverflowClipBoxBlock(ref this) |
OverflowClipBoxInline(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::OverflowClipBox>);
                    *this == other_repr.value
                }
                OverscrollBehaviorX(ref this) |
OverscrollBehaviorY(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::OverscrollBehavior>);
                    *this == other_repr.value
                }
                FillOpacity(ref this) |
StrokeOpacity(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::SVGOpacity>);
                    *this == other_repr.value
                }
                FlexGrow(ref this) |
FlexShrink(ref this) |
MozBoxFlex(ref this) |
StrokeMiterlimit(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::NonNegativeNumber>);
                    *this == other_repr.value
                }
                FloodOpacity(ref this) |
MozWindowOpacity(ref this) |
Opacity(ref this) |
ShapeImageThreshold(ref this) |
StopOpacity(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Opacity>);
                    *this == other_repr.value
                }
                BorderBlockEndStyle(ref this) |
BorderBlockStartStyle(ref this) |
BorderBottomStyle(ref this) |
BorderInlineEndStyle(ref this) |
BorderInlineStartStyle(ref this) |
BorderLeftStyle(ref this) |
BorderRightStyle(ref this) |
BorderTopStyle(ref this) |
ColumnRuleStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::BorderStyle>);
                    *this == other_repr.value
                }
                AnimationDelay(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::animation_delay::SpecifiedValue>);
                    *this == other_repr.value
                }
                AnimationDirection(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::animation_direction::SpecifiedValue>);
                    *this == other_repr.value
                }
                AnimationDuration(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::animation_duration::SpecifiedValue>);
                    *this == other_repr.value
                }
                AnimationFillMode(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::animation_fill_mode::SpecifiedValue>);
                    *this == other_repr.value
                }
                AnimationIterationCount(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::animation_iteration_count::SpecifiedValue>);
                    *this == other_repr.value
                }
                AnimationName(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::animation_name::SpecifiedValue>);
                    *this == other_repr.value
                }
                AnimationPlayState(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::animation_play_state::SpecifiedValue>);
                    *this == other_repr.value
                }
                AnimationTimingFunction(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::animation_timing_function::SpecifiedValue>);
                    *this == other_repr.value
                }
                BackgroundAttachment(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::background_attachment::SpecifiedValue>);
                    *this == other_repr.value
                }
                BackgroundBlendMode(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::background_blend_mode::SpecifiedValue>);
                    *this == other_repr.value
                }
                BackgroundClip(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::background_clip::SpecifiedValue>);
                    *this == other_repr.value
                }
                BackgroundImage(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::background_image::SpecifiedValue>);
                    *this == other_repr.value
                }
                BackgroundOrigin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::background_origin::SpecifiedValue>);
                    *this == other_repr.value
                }
                BackgroundPositionX(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::background_position_x::SpecifiedValue>);
                    *this == other_repr.value
                }
                BackgroundPositionY(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::background_position_y::SpecifiedValue>);
                    *this == other_repr.value
                }
                BackgroundRepeat(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::background_repeat::SpecifiedValue>);
                    *this == other_repr.value
                }
                BackgroundSize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::background_size::SpecifiedValue>);
                    *this == other_repr.value
                }
                BorderImageOutset(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::NonNegativeLengthOrNumberRect>>);
                    *this == other_repr.value
                }
                BorderImageSlice(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::BorderImageSlice>>);
                    *this == other_repr.value
                }
                BorderImageSource(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::ImageLayer>);
                    *this == other_repr.value
                }
                BorderImageWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::BorderImageWidth>>);
                    *this == other_repr.value
                }
                BorderSpacing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::BorderSpacing>>);
                    *this == other_repr.value
                }
                BoxShadow(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::box_shadow::SpecifiedValue>);
                    *this == other_repr.value
                }
                CaretColor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::ColorOrAuto>>);
                    *this == other_repr.value
                }
                ClipPath(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::basic_shape::ClippingShape>);
                    *this == other_repr.value
                }
                Color(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::ColorPropertyValue>);
                    *this == other_repr.value
                }
                ColumnWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::length::NonNegativeLengthOrAuto>);
                    *this == other_repr.value
                }
                Content(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Content>);
                    *this == other_repr.value
                }
                CounterIncrement(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::CounterIncrement>);
                    *this == other_repr.value
                }
                Cursor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Cursor>);
                    *this == other_repr.value
                }
                Filter(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::filter::SpecifiedValue>);
                    *this == other_repr.value
                }
                FlexBasis(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::FlexBasis>>);
                    *this == other_repr.value
                }
                FontFamily(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontFamily>);
                    *this == other_repr.value
                }
                FontFeatureSettings(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontFeatureSettings>);
                    *this == other_repr.value
                }
                FontLanguageOverride(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontLanguageOverride>);
                    *this == other_repr.value
                }
                FontSize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontSize>);
                    *this == other_repr.value
                }
                FontVariantAlternates(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontVariantAlternates>);
                    *this == other_repr.value
                }
                FontVariationSettings(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontVariationSettings>);
                    *this == other_repr.value
                }
                GridTemplateAreas(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::GridTemplateAreas>);
                    *this == other_repr.value
                }
                LetterSpacing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::LetterSpacing>);
                    *this == other_repr.value
                }
                LineHeight(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::LineHeight>);
                    *this == other_repr.value
                }
                ListStyleImage(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::url::ImageUrlOrNone>);
                    *this == other_repr.value
                }
                ListStyleType(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::ListStyleType>>);
                    *this == other_repr.value
                }
                MaskClip(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_clip::SpecifiedValue>);
                    *this == other_repr.value
                }
                MaskComposite(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_composite::SpecifiedValue>);
                    *this == other_repr.value
                }
                MaskImage(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_image::SpecifiedValue>);
                    *this == other_repr.value
                }
                MaskMode(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_mode::SpecifiedValue>);
                    *this == other_repr.value
                }
                MaskOrigin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_origin::SpecifiedValue>);
                    *this == other_repr.value
                }
                MaskPositionX(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_position_x::SpecifiedValue>);
                    *this == other_repr.value
                }
                MaskPositionY(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_position_y::SpecifiedValue>);
                    *this == other_repr.value
                }
                MaskRepeat(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_repeat::SpecifiedValue>);
                    *this == other_repr.value
                }
                MaskSize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_size::SpecifiedValue>);
                    *this == other_repr.value
                }
                MozContextProperties(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::MozContextProperties>);
                    *this == other_repr.value
                }
                MozFontSmoothingBackgroundColor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::color::MozFontSmoothingBackgroundColor>);
                    *this == other_repr.value
                }
                MozTabSize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::NonNegativeLengthOrNumber>);
                    *this == other_repr.value
                }
                OffsetPath(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::OffsetPath>);
                    *this == other_repr.value
                }
                Perspective(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Perspective>);
                    *this == other_repr.value
                }
                Quotes(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Quotes>);
                    *this == other_repr.value
                }
                Rotate(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::Rotate>>);
                    *this == other_repr.value
                }
                Scale(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::Scale>>);
                    *this == other_repr.value
                }
                ScrollSnapCoordinate(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::scroll_snap_coordinate::SpecifiedValue>);
                    *this == other_repr.value
                }
                ScrollbarColor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::ui::ScrollbarColor>>);
                    *this == other_repr.value
                }
                ShapeOutside(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::basic_shape::FloatAreaShape>>);
                    *this == other_repr.value
                }
                StrokeDasharray(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::SVGStrokeDashArray>);
                    *this == other_repr.value
                }
                StrokeDashoffset(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::SVGLength>);
                    *this == other_repr.value
                }
                StrokeWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::SVGWidth>);
                    *this == other_repr.value
                }
                TextEmphasisStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::TextEmphasisStyle>>);
                    *this == other_repr.value
                }
                TextIndent(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::LengthPercentage>);
                    *this == other_repr.value
                }
                TextOverflow(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::TextOverflow>>);
                    *this == other_repr.value
                }
                TextShadow(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::text_shadow::SpecifiedValue>);
                    *this == other_repr.value
                }
                TransitionDelay(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::transition_delay::SpecifiedValue>);
                    *this == other_repr.value
                }
                TransitionDuration(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::transition_duration::SpecifiedValue>);
                    *this == other_repr.value
                }
                TransitionProperty(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::transition_property::SpecifiedValue>);
                    *this == other_repr.value
                }
                TransitionTimingFunction(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<longhands::transition_timing_function::SpecifiedValue>);
                    *this == other_repr.value
                }
                Translate(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::Translate>>);
                    *this == other_repr.value
                }
                VerticalAlign(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::VerticalAlign>);
                    *this == other_repr.value
                }
                WillChange(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::WillChange>);
                    *this == other_repr.value
                }
                WordSpacing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::WordSpacing>);
                    *this == other_repr.value
                }
                XLang(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::XLang>);
                    *this == other_repr.value
                }
                Clip(ref this) |
MozImageRegion(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::ClipRectOrAuto>>);
                    *this == other_repr.value
                }
                GridTemplateColumns(ref this) |
GridTemplateRows(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::GridTemplateComponent>>);
                    *this == other_repr.value
                }
                Fill(ref this) |
Stroke(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::SVGPaint>>);
                    *this == other_repr.value
                }
                GridAutoColumns(ref this) |
GridAutoRows(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::TrackSize>>);
                    *this == other_repr.value
                }
                MozWindowTransformOrigin(ref this) |
TransformOrigin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::TransformOrigin>>);
                    *this == other_repr.value
                }
                CounterReset(ref this) |
CounterSet(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::CounterSetOrReset>);
                    *this == other_repr.value
                }
                ScrollSnapPointsX(ref this) |
ScrollSnapPointsY(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::ScrollSnapPoint>);
                    *this == other_repr.value
                }
                MozWindowTransform(ref this) |
Transform(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Transform>);
                    *this == other_repr.value
                }
                ColumnGap(ref this) |
RowGap(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::length::NonNegativeLengthPercentageOrNormal>);
                    *this == other_repr.value
                }
                ObjectPosition(ref this) |
PerspectiveOrigin(ref this) |
ScrollSnapDestination(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::Position>>);
                    *this == other_repr.value
                }
                GridColumnEnd(ref this) |
GridColumnStart(ref this) |
GridRowEnd(ref this) |
GridRowStart(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::GridLine>>);
                    *this == other_repr.value
                }
                MaxBlockSize(ref this) |
MaxHeight(ref this) |
MaxInlineSize(ref this) |
MaxWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::MaxSize>);
                    *this == other_repr.value
                }
                MarkerEnd(ref this) |
MarkerMid(ref this) |
MarkerStart(ref this) |
MozBinding(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::url::UrlOrNone>);
                    *this == other_repr.value
                }
                ScrollPaddingBlockEnd(ref this) |
ScrollPaddingBlockStart(ref this) |
ScrollPaddingBottom(ref this) |
ScrollPaddingInlineEnd(ref this) |
ScrollPaddingInlineStart(ref this) |
ScrollPaddingLeft(ref this) |
ScrollPaddingRight(ref this) |
ScrollPaddingTop(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::NonNegativeLengthPercentageOrAuto>);
                    *this == other_repr.value
                }
                BlockSize(ref this) |
Height(ref this) |
InlineSize(ref this) |
MinBlockSize(ref this) |
MinHeight(ref this) |
MinInlineSize(ref this) |
MinWidth(ref this) |
Width(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Size>);
                    *this == other_repr.value
                }
                OutlineOffset(ref this) |
ScrollMarginBlockEnd(ref this) |
ScrollMarginBlockStart(ref this) |
ScrollMarginBottom(ref this) |
ScrollMarginInlineEnd(ref this) |
ScrollMarginInlineStart(ref this) |
ScrollMarginLeft(ref this) |
ScrollMarginRight(ref this) |
ScrollMarginTop(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Length>);
                    *this == other_repr.value
                }
                PaddingBlockEnd(ref this) |
PaddingBlockStart(ref this) |
PaddingBottom(ref this) |
PaddingInlineEnd(ref this) |
PaddingInlineStart(ref this) |
PaddingLeft(ref this) |
PaddingRight(ref this) |
PaddingTop(ref this) |
ShapeMargin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::NonNegativeLengthPercentage>);
                    *this == other_repr.value
                }
                BorderBlockEndWidth(ref this) |
BorderBlockStartWidth(ref this) |
BorderBottomWidth(ref this) |
BorderInlineEndWidth(ref this) |
BorderInlineStartWidth(ref this) |
BorderLeftWidth(ref this) |
BorderRightWidth(ref this) |
BorderTopWidth(ref this) |
ColumnRuleWidth(ref this) |
OutlineWidth(ref this) |
WebkitTextStrokeWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::BorderSideWidth>);
                    *this == other_repr.value
                }
                BorderBottomLeftRadius(ref this) |
BorderBottomRightRadius(ref this) |
BorderEndEndRadius(ref this) |
BorderEndStartRadius(ref this) |
BorderStartEndRadius(ref this) |
BorderStartStartRadius(ref this) |
BorderTopLeftRadius(ref this) |
BorderTopRightRadius(ref this) |
MozOutlineRadiusBottomleft(ref this) |
MozOutlineRadiusBottomright(ref this) |
MozOutlineRadiusTopleft(ref this) |
MozOutlineRadiusTopright(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::BorderCornerRadius>>);
                    *this == other_repr.value
                }
                Bottom(ref this) |
InsetBlockEnd(ref this) |
InsetBlockStart(ref this) |
InsetInlineEnd(ref this) |
InsetInlineStart(ref this) |
Left(ref this) |
MarginBlockEnd(ref this) |
MarginBlockStart(ref this) |
MarginBottom(ref this) |
MarginInlineEnd(ref this) |
MarginInlineStart(ref this) |
MarginLeft(ref this) |
MarginRight(ref this) |
MarginTop(ref this) |
Right(ref this) |
Top(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::LengthPercentageOrAuto>);
                    *this == other_repr.value
                }
                BackgroundColor(ref this) |
BorderBlockEndColor(ref this) |
BorderBlockStartColor(ref this) |
BorderBottomColor(ref this) |
BorderInlineEndColor(ref this) |
BorderInlineStartColor(ref this) |
BorderLeftColor(ref this) |
BorderRightColor(ref this) |
BorderTopColor(ref this) |
ColumnRuleColor(ref this) |
FloodColor(ref this) |
LightingColor(ref this) |
OutlineColor(ref this) |
StopColor(ref this) |
TextDecorationColor(ref this) |
TextEmphasisColor(ref this) |
WebkitTextFillColor(ref this) |
WebkitTextStrokeColor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Color>);
                    *this == other_repr.value
                }
                CSSWideKeyword(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<WideKeywordDeclaration>);
                    *this == other_repr.value
                }
                WithVariables(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<VariableDeclaration>);
                    *this == other_repr.value
                }
                Custom(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const PropertyDeclarationVariantRepr<CustomDeclaration>);
                    *this == other_repr.value
                }
            }
        }
    }
}

impl MallocSizeOf for PropertyDeclaration {
    #[inline]
    fn size_of(&self, ops: &mut MallocSizeOfOps) -> usize {
        use self::PropertyDeclaration::*;

        match *self {
            AlignContent(ref value) => {
                value.size_of(ops)
            }
            AlignItems(ref value) => {
                value.size_of(ops)
            }
            AlignSelf(ref value) => {
                value.size_of(ops)
            }
            BackfaceVisibility(ref value) => {
                value.size_of(ops)
            }
            BorderCollapse(ref value) => {
                value.size_of(ops)
            }
            BorderImageRepeat(ref value) => {
                value.size_of(ops)
            }
            BoxDecorationBreak(ref value) => {
                value.size_of(ops)
            }
            BoxSizing(ref value) => {
                value.size_of(ops)
            }
            BreakInside(ref value) => {
                value.size_of(ops)
            }
            CaptionSide(ref value) => {
                value.size_of(ops)
            }
            Clear(ref value) => {
                value.size_of(ops)
            }
            ColorAdjust(ref value) => {
                value.size_of(ops)
            }
            ColorInterpolation(ref value) => {
                value.size_of(ops)
            }
            ColorInterpolationFilters(ref value) => {
                value.size_of(ops)
            }
            ColumnCount(ref value) => {
                value.size_of(ops)
            }
            ColumnFill(ref value) => {
                value.size_of(ops)
            }
            ColumnSpan(ref value) => {
                value.size_of(ops)
            }
            Contain(ref value) => {
                value.size_of(ops)
            }
            Direction(ref value) => {
                value.size_of(ops)
            }
            Display(ref value) => {
                value.size_of(ops)
            }
            DominantBaseline(ref value) => {
                value.size_of(ops)
            }
            EmptyCells(ref value) => {
                value.size_of(ops)
            }
            FlexDirection(ref value) => {
                value.size_of(ops)
            }
            FlexWrap(ref value) => {
                value.size_of(ops)
            }
            Float(ref value) => {
                value.size_of(ops)
            }
            FontKerning(ref value) => {
                value.size_of(ops)
            }
            FontOpticalSizing(ref value) => {
                value.size_of(ops)
            }
            FontSizeAdjust(ref value) => {
                value.size_of(ops)
            }
            FontStretch(ref value) => {
                value.size_of(ops)
            }
            FontStyle(ref value) => {
                value.size_of(ops)
            }
            FontSynthesis(ref value) => {
                value.size_of(ops)
            }
            FontVariantCaps(ref value) => {
                value.size_of(ops)
            }
            FontVariantEastAsian(ref value) => {
                value.size_of(ops)
            }
            FontVariantLigatures(ref value) => {
                value.size_of(ops)
            }
            FontVariantNumeric(ref value) => {
                value.size_of(ops)
            }
            FontVariantPosition(ref value) => {
                value.size_of(ops)
            }
            FontWeight(ref value) => {
                value.size_of(ops)
            }
            GridAutoFlow(ref value) => {
                value.size_of(ops)
            }
            Hyphens(ref value) => {
                value.size_of(ops)
            }
            ImageOrientation(ref value) => {
                value.size_of(ops)
            }
            ImageRendering(ref value) => {
                value.size_of(ops)
            }
            ImeMode(ref value) => {
                value.size_of(ops)
            }
            InitialLetter(ref value) => {
                value.size_of(ops)
            }
            Isolation(ref value) => {
                value.size_of(ops)
            }
            JustifyContent(ref value) => {
                value.size_of(ops)
            }
            JustifyItems(ref value) => {
                value.size_of(ops)
            }
            JustifySelf(ref value) => {
                value.size_of(ops)
            }
            ListStylePosition(ref value) => {
                value.size_of(ops)
            }
            MaskType(ref value) => {
                value.size_of(ops)
            }
            MixBlendMode(ref value) => {
                value.size_of(ops)
            }
            MozAppearance(ref value) => {
                value.size_of(ops)
            }
            MozBoxAlign(ref value) => {
                value.size_of(ops)
            }
            MozBoxDirection(ref value) => {
                value.size_of(ops)
            }
            MozBoxOrient(ref value) => {
                value.size_of(ops)
            }
            MozBoxPack(ref value) => {
                value.size_of(ops)
            }
            MozControlCharacterVisibility(ref value) => {
                value.size_of(ops)
            }
            MozFloatEdge(ref value) => {
                value.size_of(ops)
            }
            MozForceBrokenImageIcon(ref value) => {
                value.size_of(ops)
            }
            MozListReversed(ref value) => {
                value.size_of(ops)
            }
            MozMathDisplay(ref value) => {
                value.size_of(ops)
            }
            MozMathVariant(ref value) => {
                value.size_of(ops)
            }
            MozMinFontSizeRatio(ref value) => {
                value.size_of(ops)
            }
            MozOrient(ref value) => {
                value.size_of(ops)
            }
            MozOsxFontSmoothing(ref value) => {
                value.size_of(ops)
            }
            MozScriptLevel(ref value) => {
                value.size_of(ops)
            }
            MozScriptMinSize(ref value) => {
                value.size_of(ops)
            }
            MozScriptSizeMultiplier(ref value) => {
                value.size_of(ops)
            }
            MozStackSizing(ref value) => {
                value.size_of(ops)
            }
            MozTextSizeAdjust(ref value) => {
                value.size_of(ops)
            }
            MozTopLayer(ref value) => {
                value.size_of(ops)
            }
            MozUserFocus(ref value) => {
                value.size_of(ops)
            }
            MozUserInput(ref value) => {
                value.size_of(ops)
            }
            MozUserModify(ref value) => {
                value.size_of(ops)
            }
            MozUserSelect(ref value) => {
                value.size_of(ops)
            }
            MozWindowDragging(ref value) => {
                value.size_of(ops)
            }
            MozWindowShadow(ref value) => {
                value.size_of(ops)
            }
            ObjectFit(ref value) => {
                value.size_of(ops)
            }
            OutlineStyle(ref value) => {
                value.size_of(ops)
            }
            OverflowAnchor(ref value) => {
                value.size_of(ops)
            }
            OverflowWrap(ref value) => {
                value.size_of(ops)
            }
            PaintOrder(ref value) => {
                value.size_of(ops)
            }
            PointerEvents(ref value) => {
                value.size_of(ops)
            }
            Position(ref value) => {
                value.size_of(ops)
            }
            Resize(ref value) => {
                value.size_of(ops)
            }
            RubyAlign(ref value) => {
                value.size_of(ops)
            }
            RubyPosition(ref value) => {
                value.size_of(ops)
            }
            ScrollBehavior(ref value) => {
                value.size_of(ops)
            }
            ScrollSnapAlign(ref value) => {
                value.size_of(ops)
            }
            ScrollSnapType(ref value) => {
                value.size_of(ops)
            }
            ScrollbarWidth(ref value) => {
                value.size_of(ops)
            }
            ShapeRendering(ref value) => {
                value.size_of(ops)
            }
            StrokeLinecap(ref value) => {
                value.size_of(ops)
            }
            StrokeLinejoin(ref value) => {
                value.size_of(ops)
            }
            TableLayout(ref value) => {
                value.size_of(ops)
            }
            TextAlign(ref value) => {
                value.size_of(ops)
            }
            TextAlignLast(ref value) => {
                value.size_of(ops)
            }
            TextAnchor(ref value) => {
                value.size_of(ops)
            }
            TextCombineUpright(ref value) => {
                value.size_of(ops)
            }
            TextDecorationLine(ref value) => {
                value.size_of(ops)
            }
            TextDecorationStyle(ref value) => {
                value.size_of(ops)
            }
            TextEmphasisPosition(ref value) => {
                value.size_of(ops)
            }
            TextJustify(ref value) => {
                value.size_of(ops)
            }
            TextOrientation(ref value) => {
                value.size_of(ops)
            }
            TextRendering(ref value) => {
                value.size_of(ops)
            }
            TextTransform(ref value) => {
                value.size_of(ops)
            }
            TouchAction(ref value) => {
                value.size_of(ops)
            }
            TransformBox(ref value) => {
                value.size_of(ops)
            }
            TransformStyle(ref value) => {
                value.size_of(ops)
            }
            UnicodeBidi(ref value) => {
                value.size_of(ops)
            }
            VectorEffect(ref value) => {
                value.size_of(ops)
            }
            Visibility(ref value) => {
                value.size_of(ops)
            }
            WebkitLineClamp(ref value) => {
                value.size_of(ops)
            }
            WhiteSpace(ref value) => {
                value.size_of(ops)
            }
            WordBreak(ref value) => {
                value.size_of(ops)
            }
            WritingMode(ref value) => {
                value.size_of(ops)
            }
            XSpan(ref value) => {
                value.size_of(ops)
            }
            XTextZoom(ref value) => {
                value.size_of(ops)
            }
            ZIndex(ref value) => {
                value.size_of(ops)
            }
            BreakAfter(ref value) | BreakBefore(ref value) => {
                value.size_of(ops)
            }
            ClipRule(ref value) | FillRule(ref value) => {
                value.size_of(ops)
            }
            MozBoxOrdinalGroup(ref value) | Order(ref value) => {
                value.size_of(ops)
            }
            OverflowX(ref value) | OverflowY(ref value) => {
                value.size_of(ops)
            }
            OverflowClipBoxBlock(ref value) | OverflowClipBoxInline(ref value) => {
                value.size_of(ops)
            }
            OverscrollBehaviorX(ref value) | OverscrollBehaviorY(ref value) => {
                value.size_of(ops)
            }
            FillOpacity(ref value) | StrokeOpacity(ref value) => {
                value.size_of(ops)
            }
            FlexGrow(ref value) | FlexShrink(ref value) | MozBoxFlex(ref value) | StrokeMiterlimit(ref value) => {
                value.size_of(ops)
            }
            FloodOpacity(ref value) | MozWindowOpacity(ref value) | Opacity(ref value) | ShapeImageThreshold(ref value) | StopOpacity(ref value) => {
                value.size_of(ops)
            }
            BorderBlockEndStyle(ref value) | BorderBlockStartStyle(ref value) | BorderBottomStyle(ref value) | BorderInlineEndStyle(ref value) | BorderInlineStartStyle(ref value) | BorderLeftStyle(ref value) | BorderRightStyle(ref value) | BorderTopStyle(ref value) | ColumnRuleStyle(ref value) => {
                value.size_of(ops)
            }
            AnimationDelay(ref value) => {
                value.size_of(ops)
            }
            AnimationDirection(ref value) => {
                value.size_of(ops)
            }
            AnimationDuration(ref value) => {
                value.size_of(ops)
            }
            AnimationFillMode(ref value) => {
                value.size_of(ops)
            }
            AnimationIterationCount(ref value) => {
                value.size_of(ops)
            }
            AnimationName(ref value) => {
                value.size_of(ops)
            }
            AnimationPlayState(ref value) => {
                value.size_of(ops)
            }
            AnimationTimingFunction(ref value) => {
                value.size_of(ops)
            }
            BackgroundAttachment(ref value) => {
                value.size_of(ops)
            }
            BackgroundBlendMode(ref value) => {
                value.size_of(ops)
            }
            BackgroundClip(ref value) => {
                value.size_of(ops)
            }
            BackgroundImage(ref value) => {
                value.size_of(ops)
            }
            BackgroundOrigin(ref value) => {
                value.size_of(ops)
            }
            BackgroundPositionX(ref value) => {
                value.size_of(ops)
            }
            BackgroundPositionY(ref value) => {
                value.size_of(ops)
            }
            BackgroundRepeat(ref value) => {
                value.size_of(ops)
            }
            BackgroundSize(ref value) => {
                value.size_of(ops)
            }
            BorderImageOutset(ref value) => {
                value.size_of(ops)
            }
            BorderImageSlice(ref value) => {
                value.size_of(ops)
            }
            BorderImageSource(ref value) => {
                value.size_of(ops)
            }
            BorderImageWidth(ref value) => {
                value.size_of(ops)
            }
            BorderSpacing(ref value) => {
                value.size_of(ops)
            }
            BoxShadow(ref value) => {
                value.size_of(ops)
            }
            CaretColor(ref value) => {
                value.size_of(ops)
            }
            ClipPath(ref value) => {
                value.size_of(ops)
            }
            Color(ref value) => {
                value.size_of(ops)
            }
            ColumnWidth(ref value) => {
                value.size_of(ops)
            }
            Content(ref value) => {
                value.size_of(ops)
            }
            CounterIncrement(ref value) => {
                value.size_of(ops)
            }
            Cursor(ref value) => {
                value.size_of(ops)
            }
            Filter(ref value) => {
                value.size_of(ops)
            }
            FlexBasis(ref value) => {
                value.size_of(ops)
            }
            FontFamily(ref value) => {
                value.size_of(ops)
            }
            FontFeatureSettings(ref value) => {
                value.size_of(ops)
            }
            FontLanguageOverride(ref value) => {
                value.size_of(ops)
            }
            FontSize(ref value) => {
                value.size_of(ops)
            }
            FontVariantAlternates(ref value) => {
                value.size_of(ops)
            }
            FontVariationSettings(ref value) => {
                value.size_of(ops)
            }
            GridTemplateAreas(ref value) => {
                value.size_of(ops)
            }
            LetterSpacing(ref value) => {
                value.size_of(ops)
            }
            LineHeight(ref value) => {
                value.size_of(ops)
            }
            ListStyleImage(ref value) => {
                value.size_of(ops)
            }
            ListStyleType(ref value) => {
                value.size_of(ops)
            }
            MaskClip(ref value) => {
                value.size_of(ops)
            }
            MaskComposite(ref value) => {
                value.size_of(ops)
            }
            MaskImage(ref value) => {
                value.size_of(ops)
            }
            MaskMode(ref value) => {
                value.size_of(ops)
            }
            MaskOrigin(ref value) => {
                value.size_of(ops)
            }
            MaskPositionX(ref value) => {
                value.size_of(ops)
            }
            MaskPositionY(ref value) => {
                value.size_of(ops)
            }
            MaskRepeat(ref value) => {
                value.size_of(ops)
            }
            MaskSize(ref value) => {
                value.size_of(ops)
            }
            MozContextProperties(ref value) => {
                value.size_of(ops)
            }
            MozFontSmoothingBackgroundColor(ref value) => {
                value.size_of(ops)
            }
            MozTabSize(ref value) => {
                value.size_of(ops)
            }
            OffsetPath(ref value) => {
                value.size_of(ops)
            }
            Perspective(ref value) => {
                value.size_of(ops)
            }
            Quotes(ref value) => {
                value.size_of(ops)
            }
            Rotate(ref value) => {
                value.size_of(ops)
            }
            Scale(ref value) => {
                value.size_of(ops)
            }
            ScrollSnapCoordinate(ref value) => {
                value.size_of(ops)
            }
            ScrollbarColor(ref value) => {
                value.size_of(ops)
            }
            ShapeOutside(ref value) => {
                value.size_of(ops)
            }
            StrokeDasharray(ref value) => {
                value.size_of(ops)
            }
            StrokeDashoffset(ref value) => {
                value.size_of(ops)
            }
            StrokeWidth(ref value) => {
                value.size_of(ops)
            }
            TextEmphasisStyle(ref value) => {
                value.size_of(ops)
            }
            TextIndent(ref value) => {
                value.size_of(ops)
            }
            TextOverflow(ref value) => {
                value.size_of(ops)
            }
            TextShadow(ref value) => {
                value.size_of(ops)
            }
            TransitionDelay(ref value) => {
                value.size_of(ops)
            }
            TransitionDuration(ref value) => {
                value.size_of(ops)
            }
            TransitionProperty(ref value) => {
                value.size_of(ops)
            }
            TransitionTimingFunction(ref value) => {
                value.size_of(ops)
            }
            Translate(ref value) => {
                value.size_of(ops)
            }
            VerticalAlign(ref value) => {
                value.size_of(ops)
            }
            WillChange(ref value) => {
                value.size_of(ops)
            }
            WordSpacing(ref value) => {
                value.size_of(ops)
            }
            XLang(ref value) => {
                value.size_of(ops)
            }
            Clip(ref value) | MozImageRegion(ref value) => {
                value.size_of(ops)
            }
            GridTemplateColumns(ref value) | GridTemplateRows(ref value) => {
                value.size_of(ops)
            }
            Fill(ref value) | Stroke(ref value) => {
                value.size_of(ops)
            }
            GridAutoColumns(ref value) | GridAutoRows(ref value) => {
                value.size_of(ops)
            }
            MozWindowTransformOrigin(ref value) | TransformOrigin(ref value) => {
                value.size_of(ops)
            }
            CounterReset(ref value) | CounterSet(ref value) => {
                value.size_of(ops)
            }
            ScrollSnapPointsX(ref value) | ScrollSnapPointsY(ref value) => {
                value.size_of(ops)
            }
            MozWindowTransform(ref value) | Transform(ref value) => {
                value.size_of(ops)
            }
            ColumnGap(ref value) | RowGap(ref value) => {
                value.size_of(ops)
            }
            ObjectPosition(ref value) | PerspectiveOrigin(ref value) | ScrollSnapDestination(ref value) => {
                value.size_of(ops)
            }
            GridColumnEnd(ref value) | GridColumnStart(ref value) | GridRowEnd(ref value) | GridRowStart(ref value) => {
                value.size_of(ops)
            }
            MaxBlockSize(ref value) | MaxHeight(ref value) | MaxInlineSize(ref value) | MaxWidth(ref value) => {
                value.size_of(ops)
            }
            MarkerEnd(ref value) | MarkerMid(ref value) | MarkerStart(ref value) | MozBinding(ref value) => {
                value.size_of(ops)
            }
            ScrollPaddingBlockEnd(ref value) | ScrollPaddingBlockStart(ref value) | ScrollPaddingBottom(ref value) | ScrollPaddingInlineEnd(ref value) | ScrollPaddingInlineStart(ref value) | ScrollPaddingLeft(ref value) | ScrollPaddingRight(ref value) | ScrollPaddingTop(ref value) => {
                value.size_of(ops)
            }
            BlockSize(ref value) | Height(ref value) | InlineSize(ref value) | MinBlockSize(ref value) | MinHeight(ref value) | MinInlineSize(ref value) | MinWidth(ref value) | Width(ref value) => {
                value.size_of(ops)
            }
            OutlineOffset(ref value) | ScrollMarginBlockEnd(ref value) | ScrollMarginBlockStart(ref value) | ScrollMarginBottom(ref value) | ScrollMarginInlineEnd(ref value) | ScrollMarginInlineStart(ref value) | ScrollMarginLeft(ref value) | ScrollMarginRight(ref value) | ScrollMarginTop(ref value) => {
                value.size_of(ops)
            }
            PaddingBlockEnd(ref value) | PaddingBlockStart(ref value) | PaddingBottom(ref value) | PaddingInlineEnd(ref value) | PaddingInlineStart(ref value) | PaddingLeft(ref value) | PaddingRight(ref value) | PaddingTop(ref value) | ShapeMargin(ref value) => {
                value.size_of(ops)
            }
            BorderBlockEndWidth(ref value) | BorderBlockStartWidth(ref value) | BorderBottomWidth(ref value) | BorderInlineEndWidth(ref value) | BorderInlineStartWidth(ref value) | BorderLeftWidth(ref value) | BorderRightWidth(ref value) | BorderTopWidth(ref value) | ColumnRuleWidth(ref value) | OutlineWidth(ref value) | WebkitTextStrokeWidth(ref value) => {
                value.size_of(ops)
            }
            BorderBottomLeftRadius(ref value) | BorderBottomRightRadius(ref value) | BorderEndEndRadius(ref value) | BorderEndStartRadius(ref value) | BorderStartEndRadius(ref value) | BorderStartStartRadius(ref value) | BorderTopLeftRadius(ref value) | BorderTopRightRadius(ref value) | MozOutlineRadiusBottomleft(ref value) | MozOutlineRadiusBottomright(ref value) | MozOutlineRadiusTopleft(ref value) | MozOutlineRadiusTopright(ref value) => {
                value.size_of(ops)
            }
            Bottom(ref value) | InsetBlockEnd(ref value) | InsetBlockStart(ref value) | InsetInlineEnd(ref value) | InsetInlineStart(ref value) | Left(ref value) | MarginBlockEnd(ref value) | MarginBlockStart(ref value) | MarginBottom(ref value) | MarginInlineEnd(ref value) | MarginInlineStart(ref value) | MarginLeft(ref value) | MarginRight(ref value) | MarginTop(ref value) | Right(ref value) | Top(ref value) => {
                value.size_of(ops)
            }
            BackgroundColor(ref value) | BorderBlockEndColor(ref value) | BorderBlockStartColor(ref value) | BorderBottomColor(ref value) | BorderInlineEndColor(ref value) | BorderInlineStartColor(ref value) | BorderLeftColor(ref value) | BorderRightColor(ref value) | BorderTopColor(ref value) | ColumnRuleColor(ref value) | FloodColor(ref value) | LightingColor(ref value) | OutlineColor(ref value) | StopColor(ref value) | TextDecorationColor(ref value) | TextEmphasisColor(ref value) | WebkitTextFillColor(ref value) | WebkitTextStrokeColor(ref value) => {
                value.size_of(ops)
            }
            CSSWideKeyword(ref value) => {
                value.size_of(ops)
            }
            WithVariables(ref value) => {
                value.size_of(ops)
            }
            Custom(ref value) => {
                value.size_of(ops)
            }
        }
    }
}


impl PropertyDeclaration {
    /// Like the method on ToCss, but without the type parameter to avoid
    /// accidentally monomorphizing this large function multiple times for
    /// different writers.
    pub fn to_css(&self, dest: &mut CssStringWriter) -> fmt::Result {
        use self::PropertyDeclaration::*;

        let mut dest = CssWriter::new(dest);
        match *self {
            AlignContent(ref value) => {
                value.to_css(&mut dest)
            }
            AlignItems(ref value) => {
                value.to_css(&mut dest)
            }
            AlignSelf(ref value) => {
                value.to_css(&mut dest)
            }
            BackfaceVisibility(ref value) => {
                value.to_css(&mut dest)
            }
            BorderCollapse(ref value) => {
                value.to_css(&mut dest)
            }
            BorderImageRepeat(ref value) => {
                value.to_css(&mut dest)
            }
            BoxDecorationBreak(ref value) => {
                value.to_css(&mut dest)
            }
            BoxSizing(ref value) => {
                value.to_css(&mut dest)
            }
            BreakInside(ref value) => {
                value.to_css(&mut dest)
            }
            CaptionSide(ref value) => {
                value.to_css(&mut dest)
            }
            Clear(ref value) => {
                value.to_css(&mut dest)
            }
            ColorAdjust(ref value) => {
                value.to_css(&mut dest)
            }
            ColorInterpolation(ref value) => {
                value.to_css(&mut dest)
            }
            ColorInterpolationFilters(ref value) => {
                value.to_css(&mut dest)
            }
            ColumnCount(ref value) => {
                value.to_css(&mut dest)
            }
            ColumnFill(ref value) => {
                value.to_css(&mut dest)
            }
            ColumnSpan(ref value) => {
                value.to_css(&mut dest)
            }
            Contain(ref value) => {
                value.to_css(&mut dest)
            }
            Direction(ref value) => {
                value.to_css(&mut dest)
            }
            Display(ref value) => {
                value.to_css(&mut dest)
            }
            DominantBaseline(ref value) => {
                value.to_css(&mut dest)
            }
            EmptyCells(ref value) => {
                value.to_css(&mut dest)
            }
            FlexDirection(ref value) => {
                value.to_css(&mut dest)
            }
            FlexWrap(ref value) => {
                value.to_css(&mut dest)
            }
            Float(ref value) => {
                value.to_css(&mut dest)
            }
            FontKerning(ref value) => {
                value.to_css(&mut dest)
            }
            FontOpticalSizing(ref value) => {
                value.to_css(&mut dest)
            }
            FontSizeAdjust(ref value) => {
                value.to_css(&mut dest)
            }
            FontStretch(ref value) => {
                value.to_css(&mut dest)
            }
            FontStyle(ref value) => {
                value.to_css(&mut dest)
            }
            FontSynthesis(ref value) => {
                value.to_css(&mut dest)
            }
            FontVariantCaps(ref value) => {
                value.to_css(&mut dest)
            }
            FontVariantEastAsian(ref value) => {
                value.to_css(&mut dest)
            }
            FontVariantLigatures(ref value) => {
                value.to_css(&mut dest)
            }
            FontVariantNumeric(ref value) => {
                value.to_css(&mut dest)
            }
            FontVariantPosition(ref value) => {
                value.to_css(&mut dest)
            }
            FontWeight(ref value) => {
                value.to_css(&mut dest)
            }
            GridAutoFlow(ref value) => {
                value.to_css(&mut dest)
            }
            Hyphens(ref value) => {
                value.to_css(&mut dest)
            }
            ImageOrientation(ref value) => {
                value.to_css(&mut dest)
            }
            ImageRendering(ref value) => {
                value.to_css(&mut dest)
            }
            ImeMode(ref value) => {
                value.to_css(&mut dest)
            }
            InitialLetter(ref value) => {
                value.to_css(&mut dest)
            }
            Isolation(ref value) => {
                value.to_css(&mut dest)
            }
            JustifyContent(ref value) => {
                value.to_css(&mut dest)
            }
            JustifyItems(ref value) => {
                value.to_css(&mut dest)
            }
            JustifySelf(ref value) => {
                value.to_css(&mut dest)
            }
            ListStylePosition(ref value) => {
                value.to_css(&mut dest)
            }
            MaskType(ref value) => {
                value.to_css(&mut dest)
            }
            MixBlendMode(ref value) => {
                value.to_css(&mut dest)
            }
            MozAppearance(ref value) => {
                value.to_css(&mut dest)
            }
            MozBoxAlign(ref value) => {
                value.to_css(&mut dest)
            }
            MozBoxDirection(ref value) => {
                value.to_css(&mut dest)
            }
            MozBoxOrient(ref value) => {
                value.to_css(&mut dest)
            }
            MozBoxPack(ref value) => {
                value.to_css(&mut dest)
            }
            MozControlCharacterVisibility(ref value) => {
                value.to_css(&mut dest)
            }
            MozFloatEdge(ref value) => {
                value.to_css(&mut dest)
            }
            MozForceBrokenImageIcon(ref value) => {
                value.to_css(&mut dest)
            }
            MozListReversed(ref value) => {
                value.to_css(&mut dest)
            }
            MozMathDisplay(ref value) => {
                value.to_css(&mut dest)
            }
            MozMathVariant(ref value) => {
                value.to_css(&mut dest)
            }
            MozMinFontSizeRatio(ref value) => {
                value.to_css(&mut dest)
            }
            MozOrient(ref value) => {
                value.to_css(&mut dest)
            }
            MozOsxFontSmoothing(ref value) => {
                value.to_css(&mut dest)
            }
            MozScriptLevel(ref value) => {
                value.to_css(&mut dest)
            }
            MozScriptMinSize(ref value) => {
                value.to_css(&mut dest)
            }
            MozScriptSizeMultiplier(ref value) => {
                value.to_css(&mut dest)
            }
            MozStackSizing(ref value) => {
                value.to_css(&mut dest)
            }
            MozTextSizeAdjust(ref value) => {
                value.to_css(&mut dest)
            }
            MozTopLayer(ref value) => {
                value.to_css(&mut dest)
            }
            MozUserFocus(ref value) => {
                value.to_css(&mut dest)
            }
            MozUserInput(ref value) => {
                value.to_css(&mut dest)
            }
            MozUserModify(ref value) => {
                value.to_css(&mut dest)
            }
            MozUserSelect(ref value) => {
                value.to_css(&mut dest)
            }
            MozWindowDragging(ref value) => {
                value.to_css(&mut dest)
            }
            MozWindowShadow(ref value) => {
                value.to_css(&mut dest)
            }
            ObjectFit(ref value) => {
                value.to_css(&mut dest)
            }
            OutlineStyle(ref value) => {
                value.to_css(&mut dest)
            }
            OverflowAnchor(ref value) => {
                value.to_css(&mut dest)
            }
            OverflowWrap(ref value) => {
                value.to_css(&mut dest)
            }
            PaintOrder(ref value) => {
                value.to_css(&mut dest)
            }
            PointerEvents(ref value) => {
                value.to_css(&mut dest)
            }
            Position(ref value) => {
                value.to_css(&mut dest)
            }
            Resize(ref value) => {
                value.to_css(&mut dest)
            }
            RubyAlign(ref value) => {
                value.to_css(&mut dest)
            }
            RubyPosition(ref value) => {
                value.to_css(&mut dest)
            }
            ScrollBehavior(ref value) => {
                value.to_css(&mut dest)
            }
            ScrollSnapAlign(ref value) => {
                value.to_css(&mut dest)
            }
            ScrollSnapType(ref value) => {
                value.to_css(&mut dest)
            }
            ScrollbarWidth(ref value) => {
                value.to_css(&mut dest)
            }
            ShapeRendering(ref value) => {
                value.to_css(&mut dest)
            }
            StrokeLinecap(ref value) => {
                value.to_css(&mut dest)
            }
            StrokeLinejoin(ref value) => {
                value.to_css(&mut dest)
            }
            TableLayout(ref value) => {
                value.to_css(&mut dest)
            }
            TextAlign(ref value) => {
                value.to_css(&mut dest)
            }
            TextAlignLast(ref value) => {
                value.to_css(&mut dest)
            }
            TextAnchor(ref value) => {
                value.to_css(&mut dest)
            }
            TextCombineUpright(ref value) => {
                value.to_css(&mut dest)
            }
            TextDecorationLine(ref value) => {
                value.to_css(&mut dest)
            }
            TextDecorationStyle(ref value) => {
                value.to_css(&mut dest)
            }
            TextEmphasisPosition(ref value) => {
                value.to_css(&mut dest)
            }
            TextJustify(ref value) => {
                value.to_css(&mut dest)
            }
            TextOrientation(ref value) => {
                value.to_css(&mut dest)
            }
            TextRendering(ref value) => {
                value.to_css(&mut dest)
            }
            TextTransform(ref value) => {
                value.to_css(&mut dest)
            }
            TouchAction(ref value) => {
                value.to_css(&mut dest)
            }
            TransformBox(ref value) => {
                value.to_css(&mut dest)
            }
            TransformStyle(ref value) => {
                value.to_css(&mut dest)
            }
            UnicodeBidi(ref value) => {
                value.to_css(&mut dest)
            }
            VectorEffect(ref value) => {
                value.to_css(&mut dest)
            }
            Visibility(ref value) => {
                value.to_css(&mut dest)
            }
            WebkitLineClamp(ref value) => {
                value.to_css(&mut dest)
            }
            WhiteSpace(ref value) => {
                value.to_css(&mut dest)
            }
            WordBreak(ref value) => {
                value.to_css(&mut dest)
            }
            WritingMode(ref value) => {
                value.to_css(&mut dest)
            }
            XSpan(ref value) => {
                value.to_css(&mut dest)
            }
            XTextZoom(ref value) => {
                value.to_css(&mut dest)
            }
            ZIndex(ref value) => {
                value.to_css(&mut dest)
            }
            BreakAfter(ref value) | BreakBefore(ref value) => {
                value.to_css(&mut dest)
            }
            ClipRule(ref value) | FillRule(ref value) => {
                value.to_css(&mut dest)
            }
            MozBoxOrdinalGroup(ref value) | Order(ref value) => {
                value.to_css(&mut dest)
            }
            OverflowX(ref value) | OverflowY(ref value) => {
                value.to_css(&mut dest)
            }
            OverflowClipBoxBlock(ref value) | OverflowClipBoxInline(ref value) => {
                value.to_css(&mut dest)
            }
            OverscrollBehaviorX(ref value) | OverscrollBehaviorY(ref value) => {
                value.to_css(&mut dest)
            }
            FillOpacity(ref value) | StrokeOpacity(ref value) => {
                value.to_css(&mut dest)
            }
            FlexGrow(ref value) | FlexShrink(ref value) | MozBoxFlex(ref value) | StrokeMiterlimit(ref value) => {
                value.to_css(&mut dest)
            }
            FloodOpacity(ref value) | MozWindowOpacity(ref value) | Opacity(ref value) | ShapeImageThreshold(ref value) | StopOpacity(ref value) => {
                value.to_css(&mut dest)
            }
            BorderBlockEndStyle(ref value) | BorderBlockStartStyle(ref value) | BorderBottomStyle(ref value) | BorderInlineEndStyle(ref value) | BorderInlineStartStyle(ref value) | BorderLeftStyle(ref value) | BorderRightStyle(ref value) | BorderTopStyle(ref value) | ColumnRuleStyle(ref value) => {
                value.to_css(&mut dest)
            }
            AnimationDelay(ref value) => {
                value.to_css(&mut dest)
            }
            AnimationDirection(ref value) => {
                value.to_css(&mut dest)
            }
            AnimationDuration(ref value) => {
                value.to_css(&mut dest)
            }
            AnimationFillMode(ref value) => {
                value.to_css(&mut dest)
            }
            AnimationIterationCount(ref value) => {
                value.to_css(&mut dest)
            }
            AnimationName(ref value) => {
                value.to_css(&mut dest)
            }
            AnimationPlayState(ref value) => {
                value.to_css(&mut dest)
            }
            AnimationTimingFunction(ref value) => {
                value.to_css(&mut dest)
            }
            BackgroundAttachment(ref value) => {
                value.to_css(&mut dest)
            }
            BackgroundBlendMode(ref value) => {
                value.to_css(&mut dest)
            }
            BackgroundClip(ref value) => {
                value.to_css(&mut dest)
            }
            BackgroundImage(ref value) => {
                value.to_css(&mut dest)
            }
            BackgroundOrigin(ref value) => {
                value.to_css(&mut dest)
            }
            BackgroundPositionX(ref value) => {
                value.to_css(&mut dest)
            }
            BackgroundPositionY(ref value) => {
                value.to_css(&mut dest)
            }
            BackgroundRepeat(ref value) => {
                value.to_css(&mut dest)
            }
            BackgroundSize(ref value) => {
                value.to_css(&mut dest)
            }
            BorderImageOutset(ref value) => {
                value.to_css(&mut dest)
            }
            BorderImageSlice(ref value) => {
                value.to_css(&mut dest)
            }
            BorderImageSource(ref value) => {
                value.to_css(&mut dest)
            }
            BorderImageWidth(ref value) => {
                value.to_css(&mut dest)
            }
            BorderSpacing(ref value) => {
                value.to_css(&mut dest)
            }
            BoxShadow(ref value) => {
                value.to_css(&mut dest)
            }
            CaretColor(ref value) => {
                value.to_css(&mut dest)
            }
            ClipPath(ref value) => {
                value.to_css(&mut dest)
            }
            Color(ref value) => {
                value.to_css(&mut dest)
            }
            ColumnWidth(ref value) => {
                value.to_css(&mut dest)
            }
            Content(ref value) => {
                value.to_css(&mut dest)
            }
            CounterIncrement(ref value) => {
                value.to_css(&mut dest)
            }
            Cursor(ref value) => {
                value.to_css(&mut dest)
            }
            Filter(ref value) => {
                value.to_css(&mut dest)
            }
            FlexBasis(ref value) => {
                value.to_css(&mut dest)
            }
            FontFamily(ref value) => {
                value.to_css(&mut dest)
            }
            FontFeatureSettings(ref value) => {
                value.to_css(&mut dest)
            }
            FontLanguageOverride(ref value) => {
                value.to_css(&mut dest)
            }
            FontSize(ref value) => {
                value.to_css(&mut dest)
            }
            FontVariantAlternates(ref value) => {
                value.to_css(&mut dest)
            }
            FontVariationSettings(ref value) => {
                value.to_css(&mut dest)
            }
            GridTemplateAreas(ref value) => {
                value.to_css(&mut dest)
            }
            LetterSpacing(ref value) => {
                value.to_css(&mut dest)
            }
            LineHeight(ref value) => {
                value.to_css(&mut dest)
            }
            ListStyleImage(ref value) => {
                value.to_css(&mut dest)
            }
            ListStyleType(ref value) => {
                value.to_css(&mut dest)
            }
            MaskClip(ref value) => {
                value.to_css(&mut dest)
            }
            MaskComposite(ref value) => {
                value.to_css(&mut dest)
            }
            MaskImage(ref value) => {
                value.to_css(&mut dest)
            }
            MaskMode(ref value) => {
                value.to_css(&mut dest)
            }
            MaskOrigin(ref value) => {
                value.to_css(&mut dest)
            }
            MaskPositionX(ref value) => {
                value.to_css(&mut dest)
            }
            MaskPositionY(ref value) => {
                value.to_css(&mut dest)
            }
            MaskRepeat(ref value) => {
                value.to_css(&mut dest)
            }
            MaskSize(ref value) => {
                value.to_css(&mut dest)
            }
            MozContextProperties(ref value) => {
                value.to_css(&mut dest)
            }
            MozFontSmoothingBackgroundColor(ref value) => {
                value.to_css(&mut dest)
            }
            MozTabSize(ref value) => {
                value.to_css(&mut dest)
            }
            OffsetPath(ref value) => {
                value.to_css(&mut dest)
            }
            Perspective(ref value) => {
                value.to_css(&mut dest)
            }
            Quotes(ref value) => {
                value.to_css(&mut dest)
            }
            Rotate(ref value) => {
                value.to_css(&mut dest)
            }
            Scale(ref value) => {
                value.to_css(&mut dest)
            }
            ScrollSnapCoordinate(ref value) => {
                value.to_css(&mut dest)
            }
            ScrollbarColor(ref value) => {
                value.to_css(&mut dest)
            }
            ShapeOutside(ref value) => {
                value.to_css(&mut dest)
            }
            StrokeDasharray(ref value) => {
                value.to_css(&mut dest)
            }
            StrokeDashoffset(ref value) => {
                value.to_css(&mut dest)
            }
            StrokeWidth(ref value) => {
                value.to_css(&mut dest)
            }
            TextEmphasisStyle(ref value) => {
                value.to_css(&mut dest)
            }
            TextIndent(ref value) => {
                value.to_css(&mut dest)
            }
            TextOverflow(ref value) => {
                value.to_css(&mut dest)
            }
            TextShadow(ref value) => {
                value.to_css(&mut dest)
            }
            TransitionDelay(ref value) => {
                value.to_css(&mut dest)
            }
            TransitionDuration(ref value) => {
                value.to_css(&mut dest)
            }
            TransitionProperty(ref value) => {
                value.to_css(&mut dest)
            }
            TransitionTimingFunction(ref value) => {
                value.to_css(&mut dest)
            }
            Translate(ref value) => {
                value.to_css(&mut dest)
            }
            VerticalAlign(ref value) => {
                value.to_css(&mut dest)
            }
            WillChange(ref value) => {
                value.to_css(&mut dest)
            }
            WordSpacing(ref value) => {
                value.to_css(&mut dest)
            }
            XLang(ref value) => {
                value.to_css(&mut dest)
            }
            Clip(ref value) | MozImageRegion(ref value) => {
                value.to_css(&mut dest)
            }
            GridTemplateColumns(ref value) | GridTemplateRows(ref value) => {
                value.to_css(&mut dest)
            }
            Fill(ref value) | Stroke(ref value) => {
                value.to_css(&mut dest)
            }
            GridAutoColumns(ref value) | GridAutoRows(ref value) => {
                value.to_css(&mut dest)
            }
            MozWindowTransformOrigin(ref value) | TransformOrigin(ref value) => {
                value.to_css(&mut dest)
            }
            CounterReset(ref value) | CounterSet(ref value) => {
                value.to_css(&mut dest)
            }
            ScrollSnapPointsX(ref value) | ScrollSnapPointsY(ref value) => {
                value.to_css(&mut dest)
            }
            MozWindowTransform(ref value) | Transform(ref value) => {
                value.to_css(&mut dest)
            }
            ColumnGap(ref value) | RowGap(ref value) => {
                value.to_css(&mut dest)
            }
            ObjectPosition(ref value) | PerspectiveOrigin(ref value) | ScrollSnapDestination(ref value) => {
                value.to_css(&mut dest)
            }
            GridColumnEnd(ref value) | GridColumnStart(ref value) | GridRowEnd(ref value) | GridRowStart(ref value) => {
                value.to_css(&mut dest)
            }
            MaxBlockSize(ref value) | MaxHeight(ref value) | MaxInlineSize(ref value) | MaxWidth(ref value) => {
                value.to_css(&mut dest)
            }
            MarkerEnd(ref value) | MarkerMid(ref value) | MarkerStart(ref value) | MozBinding(ref value) => {
                value.to_css(&mut dest)
            }
            ScrollPaddingBlockEnd(ref value) | ScrollPaddingBlockStart(ref value) | ScrollPaddingBottom(ref value) | ScrollPaddingInlineEnd(ref value) | ScrollPaddingInlineStart(ref value) | ScrollPaddingLeft(ref value) | ScrollPaddingRight(ref value) | ScrollPaddingTop(ref value) => {
                value.to_css(&mut dest)
            }
            BlockSize(ref value) | Height(ref value) | InlineSize(ref value) | MinBlockSize(ref value) | MinHeight(ref value) | MinInlineSize(ref value) | MinWidth(ref value) | Width(ref value) => {
                value.to_css(&mut dest)
            }
            OutlineOffset(ref value) | ScrollMarginBlockEnd(ref value) | ScrollMarginBlockStart(ref value) | ScrollMarginBottom(ref value) | ScrollMarginInlineEnd(ref value) | ScrollMarginInlineStart(ref value) | ScrollMarginLeft(ref value) | ScrollMarginRight(ref value) | ScrollMarginTop(ref value) => {
                value.to_css(&mut dest)
            }
            PaddingBlockEnd(ref value) | PaddingBlockStart(ref value) | PaddingBottom(ref value) | PaddingInlineEnd(ref value) | PaddingInlineStart(ref value) | PaddingLeft(ref value) | PaddingRight(ref value) | PaddingTop(ref value) | ShapeMargin(ref value) => {
                value.to_css(&mut dest)
            }
            BorderBlockEndWidth(ref value) | BorderBlockStartWidth(ref value) | BorderBottomWidth(ref value) | BorderInlineEndWidth(ref value) | BorderInlineStartWidth(ref value) | BorderLeftWidth(ref value) | BorderRightWidth(ref value) | BorderTopWidth(ref value) | ColumnRuleWidth(ref value) | OutlineWidth(ref value) | WebkitTextStrokeWidth(ref value) => {
                value.to_css(&mut dest)
            }
            BorderBottomLeftRadius(ref value) | BorderBottomRightRadius(ref value) | BorderEndEndRadius(ref value) | BorderEndStartRadius(ref value) | BorderStartEndRadius(ref value) | BorderStartStartRadius(ref value) | BorderTopLeftRadius(ref value) | BorderTopRightRadius(ref value) | MozOutlineRadiusBottomleft(ref value) | MozOutlineRadiusBottomright(ref value) | MozOutlineRadiusTopleft(ref value) | MozOutlineRadiusTopright(ref value) => {
                value.to_css(&mut dest)
            }
            Bottom(ref value) | InsetBlockEnd(ref value) | InsetBlockStart(ref value) | InsetInlineEnd(ref value) | InsetInlineStart(ref value) | Left(ref value) | MarginBlockEnd(ref value) | MarginBlockStart(ref value) | MarginBottom(ref value) | MarginInlineEnd(ref value) | MarginInlineStart(ref value) | MarginLeft(ref value) | MarginRight(ref value) | MarginTop(ref value) | Right(ref value) | Top(ref value) => {
                value.to_css(&mut dest)
            }
            BackgroundColor(ref value) | BorderBlockEndColor(ref value) | BorderBlockStartColor(ref value) | BorderBottomColor(ref value) | BorderInlineEndColor(ref value) | BorderInlineStartColor(ref value) | BorderLeftColor(ref value) | BorderRightColor(ref value) | BorderTopColor(ref value) | ColumnRuleColor(ref value) | FloodColor(ref value) | LightingColor(ref value) | OutlineColor(ref value) | StopColor(ref value) | TextDecorationColor(ref value) | TextEmphasisColor(ref value) | WebkitTextFillColor(ref value) | WebkitTextStrokeColor(ref value) => {
                value.to_css(&mut dest)
            }
            CSSWideKeyword(ref value) => {
                value.to_css(&mut dest)
            }
            WithVariables(ref value) => {
                value.to_css(&mut dest)
            }
            Custom(ref value) => {
                value.to_css(&mut dest)
            }
        }
    }
}

/// A module with all the code related to animated properties.
///
/// This needs to be "included" by mako at least after all longhand modules,
/// given they populate the global data.
pub mod animated_properties {
    /* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/. */





#[cfg(feature = "gecko")] use crate::gecko_bindings::structs::RawServoAnimationValueMap;
#[cfg(feature = "gecko")] use crate::gecko_bindings::structs::nsCSSPropertyID;
#[cfg(feature = "gecko")] use crate::gecko_bindings::sugar::ownership::{HasFFI, HasSimpleFFI};
use itertools::{EitherOrBoth, Itertools};
use crate::properties::{CSSWideKeyword, PropertyDeclaration};
use crate::properties::longhands;
use crate::properties::longhands::visibility::computed_value::T as Visibility;
use crate::properties::LonghandId;
use servo_arc::Arc;
use smallvec::SmallVec;
use std::ptr;
use std::mem::{self, ManuallyDrop};
use crate::hash::FxHashMap;
use super::ComputedValues;
use crate::values::animated::{Animate, Procedure, ToAnimatedValue, ToAnimatedZero};
use crate::values::animated::effects::Filter as AnimatedFilter;
#[cfg(feature = "gecko")] use crate::values::computed::TransitionProperty;
use crate::values::computed::{ClipRect, Context};
use crate::values::computed::ToComputedValue;
use crate::values::distance::{ComputeSquaredDistance, SquaredDistance};
use crate::values::generics::effects::Filter;
use void::{self, Void};

/// Convert nsCSSPropertyID to TransitionProperty
#[cfg(feature = "gecko")]
#[allow(non_upper_case_globals)]
impl From<nsCSSPropertyID> for TransitionProperty {
    fn from(property: nsCSSPropertyID) -> TransitionProperty {
        use properties::ShorthandId;
        match property {
            nsCSSPropertyID::eCSSProperty_align_content => {
                TransitionProperty::Longhand(LonghandId::AlignContent)
            }
            nsCSSPropertyID::eCSSProperty_align_items => {
                TransitionProperty::Longhand(LonghandId::AlignItems)
            }
            nsCSSPropertyID::eCSSProperty_align_self => {
                TransitionProperty::Longhand(LonghandId::AlignSelf)
            }
            nsCSSPropertyID::eCSSProperty_backface_visibility => {
                TransitionProperty::Longhand(LonghandId::BackfaceVisibility)
            }
            nsCSSPropertyID::eCSSProperty_border_collapse => {
                TransitionProperty::Longhand(LonghandId::BorderCollapse)
            }
            nsCSSPropertyID::eCSSProperty_border_image_repeat => {
                TransitionProperty::Longhand(LonghandId::BorderImageRepeat)
            }
            nsCSSPropertyID::eCSSProperty_box_decoration_break => {
                TransitionProperty::Longhand(LonghandId::BoxDecorationBreak)
            }
            nsCSSPropertyID::eCSSProperty_box_sizing => {
                TransitionProperty::Longhand(LonghandId::BoxSizing)
            }
            nsCSSPropertyID::eCSSProperty_break_inside => {
                TransitionProperty::Longhand(LonghandId::BreakInside)
            }
            nsCSSPropertyID::eCSSProperty_caption_side => {
                TransitionProperty::Longhand(LonghandId::CaptionSide)
            }
            nsCSSPropertyID::eCSSProperty_clear => {
                TransitionProperty::Longhand(LonghandId::Clear)
            }
            nsCSSPropertyID::eCSSProperty_color_adjust => {
                TransitionProperty::Longhand(LonghandId::ColorAdjust)
            }
            nsCSSPropertyID::eCSSProperty_color_interpolation => {
                TransitionProperty::Longhand(LonghandId::ColorInterpolation)
            }
            nsCSSPropertyID::eCSSProperty_color_interpolation_filters => {
                TransitionProperty::Longhand(LonghandId::ColorInterpolationFilters)
            }
            nsCSSPropertyID::eCSSProperty_column_count => {
                TransitionProperty::Longhand(LonghandId::ColumnCount)
            }
            nsCSSPropertyID::eCSSProperty_column_fill => {
                TransitionProperty::Longhand(LonghandId::ColumnFill)
            }
            nsCSSPropertyID::eCSSProperty_column_span => {
                TransitionProperty::Longhand(LonghandId::ColumnSpan)
            }
            nsCSSPropertyID::eCSSProperty_contain => {
                TransitionProperty::Longhand(LonghandId::Contain)
            }
            nsCSSPropertyID::eCSSProperty_direction => {
                TransitionProperty::Longhand(LonghandId::Direction)
            }
            nsCSSPropertyID::eCSSProperty_display => {
                TransitionProperty::Longhand(LonghandId::Display)
            }
            nsCSSPropertyID::eCSSProperty_dominant_baseline => {
                TransitionProperty::Longhand(LonghandId::DominantBaseline)
            }
            nsCSSPropertyID::eCSSProperty_empty_cells => {
                TransitionProperty::Longhand(LonghandId::EmptyCells)
            }
            nsCSSPropertyID::eCSSProperty_flex_direction => {
                TransitionProperty::Longhand(LonghandId::FlexDirection)
            }
            nsCSSPropertyID::eCSSProperty_flex_wrap => {
                TransitionProperty::Longhand(LonghandId::FlexWrap)
            }
            nsCSSPropertyID::eCSSProperty_float => {
                TransitionProperty::Longhand(LonghandId::Float)
            }
            nsCSSPropertyID::eCSSProperty_font_kerning => {
                TransitionProperty::Longhand(LonghandId::FontKerning)
            }
            nsCSSPropertyID::eCSSProperty_font_optical_sizing => {
                TransitionProperty::Longhand(LonghandId::FontOpticalSizing)
            }
            nsCSSPropertyID::eCSSProperty_font_size_adjust => {
                TransitionProperty::Longhand(LonghandId::FontSizeAdjust)
            }
            nsCSSPropertyID::eCSSProperty_font_stretch => {
                TransitionProperty::Longhand(LonghandId::FontStretch)
            }
            nsCSSPropertyID::eCSSProperty_font_style => {
                TransitionProperty::Longhand(LonghandId::FontStyle)
            }
            nsCSSPropertyID::eCSSProperty_font_synthesis => {
                TransitionProperty::Longhand(LonghandId::FontSynthesis)
            }
            nsCSSPropertyID::eCSSProperty_font_variant_caps => {
                TransitionProperty::Longhand(LonghandId::FontVariantCaps)
            }
            nsCSSPropertyID::eCSSProperty_font_variant_east_asian => {
                TransitionProperty::Longhand(LonghandId::FontVariantEastAsian)
            }
            nsCSSPropertyID::eCSSProperty_font_variant_ligatures => {
                TransitionProperty::Longhand(LonghandId::FontVariantLigatures)
            }
            nsCSSPropertyID::eCSSProperty_font_variant_numeric => {
                TransitionProperty::Longhand(LonghandId::FontVariantNumeric)
            }
            nsCSSPropertyID::eCSSProperty_font_variant_position => {
                TransitionProperty::Longhand(LonghandId::FontVariantPosition)
            }
            nsCSSPropertyID::eCSSProperty_font_weight => {
                TransitionProperty::Longhand(LonghandId::FontWeight)
            }
            nsCSSPropertyID::eCSSProperty_grid_auto_flow => {
                TransitionProperty::Longhand(LonghandId::GridAutoFlow)
            }
            nsCSSPropertyID::eCSSProperty_hyphens => {
                TransitionProperty::Longhand(LonghandId::Hyphens)
            }
            nsCSSPropertyID::eCSSProperty_image_orientation => {
                TransitionProperty::Longhand(LonghandId::ImageOrientation)
            }
            nsCSSPropertyID::eCSSProperty_image_rendering => {
                TransitionProperty::Longhand(LonghandId::ImageRendering)
            }
            nsCSSPropertyID::eCSSProperty_ime_mode => {
                TransitionProperty::Longhand(LonghandId::ImeMode)
            }
            nsCSSPropertyID::eCSSProperty_initial_letter => {
                TransitionProperty::Longhand(LonghandId::InitialLetter)
            }
            nsCSSPropertyID::eCSSProperty_isolation => {
                TransitionProperty::Longhand(LonghandId::Isolation)
            }
            nsCSSPropertyID::eCSSProperty_justify_content => {
                TransitionProperty::Longhand(LonghandId::JustifyContent)
            }
            nsCSSPropertyID::eCSSProperty_justify_items => {
                TransitionProperty::Longhand(LonghandId::JustifyItems)
            }
            nsCSSPropertyID::eCSSProperty_justify_self => {
                TransitionProperty::Longhand(LonghandId::JustifySelf)
            }
            nsCSSPropertyID::eCSSProperty_list_style_position => {
                TransitionProperty::Longhand(LonghandId::ListStylePosition)
            }
            nsCSSPropertyID::eCSSProperty_mask_type => {
                TransitionProperty::Longhand(LonghandId::MaskType)
            }
            nsCSSPropertyID::eCSSProperty_mix_blend_mode => {
                TransitionProperty::Longhand(LonghandId::MixBlendMode)
            }
            nsCSSPropertyID::eCSSProperty__moz_appearance => {
                TransitionProperty::Longhand(LonghandId::MozAppearance)
            }
            nsCSSPropertyID::eCSSProperty__moz_box_align => {
                TransitionProperty::Longhand(LonghandId::MozBoxAlign)
            }
            nsCSSPropertyID::eCSSProperty__moz_box_direction => {
                TransitionProperty::Longhand(LonghandId::MozBoxDirection)
            }
            nsCSSPropertyID::eCSSProperty__moz_box_orient => {
                TransitionProperty::Longhand(LonghandId::MozBoxOrient)
            }
            nsCSSPropertyID::eCSSProperty__moz_box_pack => {
                TransitionProperty::Longhand(LonghandId::MozBoxPack)
            }
            nsCSSPropertyID::eCSSProperty__moz_control_character_visibility => {
                TransitionProperty::Longhand(LonghandId::MozControlCharacterVisibility)
            }
            nsCSSPropertyID::eCSSProperty__moz_float_edge => {
                TransitionProperty::Longhand(LonghandId::MozFloatEdge)
            }
            nsCSSPropertyID::eCSSProperty__moz_force_broken_image_icon => {
                TransitionProperty::Longhand(LonghandId::MozForceBrokenImageIcon)
            }
            nsCSSPropertyID::eCSSProperty__moz_list_reversed => {
                TransitionProperty::Longhand(LonghandId::MozListReversed)
            }
            nsCSSPropertyID::eCSSProperty__moz_math_display => {
                TransitionProperty::Longhand(LonghandId::MozMathDisplay)
            }
            nsCSSPropertyID::eCSSProperty__moz_math_variant => {
                TransitionProperty::Longhand(LonghandId::MozMathVariant)
            }
            nsCSSPropertyID::eCSSProperty__moz_min_font_size_ratio => {
                TransitionProperty::Longhand(LonghandId::MozMinFontSizeRatio)
            }
            nsCSSPropertyID::eCSSProperty__moz_orient => {
                TransitionProperty::Longhand(LonghandId::MozOrient)
            }
            nsCSSPropertyID::eCSSProperty__moz_osx_font_smoothing => {
                TransitionProperty::Longhand(LonghandId::MozOsxFontSmoothing)
            }
            nsCSSPropertyID::eCSSProperty__moz_script_level => {
                TransitionProperty::Longhand(LonghandId::MozScriptLevel)
            }
            nsCSSPropertyID::eCSSProperty__moz_script_min_size => {
                TransitionProperty::Longhand(LonghandId::MozScriptMinSize)
            }
            nsCSSPropertyID::eCSSProperty__moz_script_size_multiplier => {
                TransitionProperty::Longhand(LonghandId::MozScriptSizeMultiplier)
            }
            nsCSSPropertyID::eCSSProperty__moz_stack_sizing => {
                TransitionProperty::Longhand(LonghandId::MozStackSizing)
            }
            nsCSSPropertyID::eCSSProperty__moz_text_size_adjust => {
                TransitionProperty::Longhand(LonghandId::MozTextSizeAdjust)
            }
            nsCSSPropertyID::eCSSProperty__moz_top_layer => {
                TransitionProperty::Longhand(LonghandId::MozTopLayer)
            }
            nsCSSPropertyID::eCSSProperty__moz_user_focus => {
                TransitionProperty::Longhand(LonghandId::MozUserFocus)
            }
            nsCSSPropertyID::eCSSProperty__moz_user_input => {
                TransitionProperty::Longhand(LonghandId::MozUserInput)
            }
            nsCSSPropertyID::eCSSProperty__moz_user_modify => {
                TransitionProperty::Longhand(LonghandId::MozUserModify)
            }
            nsCSSPropertyID::eCSSProperty__moz_user_select => {
                TransitionProperty::Longhand(LonghandId::MozUserSelect)
            }
            nsCSSPropertyID::eCSSProperty__moz_window_dragging => {
                TransitionProperty::Longhand(LonghandId::MozWindowDragging)
            }
            nsCSSPropertyID::eCSSProperty__moz_window_shadow => {
                TransitionProperty::Longhand(LonghandId::MozWindowShadow)
            }
            nsCSSPropertyID::eCSSProperty_object_fit => {
                TransitionProperty::Longhand(LonghandId::ObjectFit)
            }
            nsCSSPropertyID::eCSSProperty_outline_style => {
                TransitionProperty::Longhand(LonghandId::OutlineStyle)
            }
            nsCSSPropertyID::eCSSProperty_overflow_anchor => {
                TransitionProperty::Longhand(LonghandId::OverflowAnchor)
            }
            nsCSSPropertyID::eCSSProperty_overflow_wrap => {
                TransitionProperty::Longhand(LonghandId::OverflowWrap)
            }
            nsCSSPropertyID::eCSSProperty_paint_order => {
                TransitionProperty::Longhand(LonghandId::PaintOrder)
            }
            nsCSSPropertyID::eCSSProperty_pointer_events => {
                TransitionProperty::Longhand(LonghandId::PointerEvents)
            }
            nsCSSPropertyID::eCSSProperty_position => {
                TransitionProperty::Longhand(LonghandId::Position)
            }
            nsCSSPropertyID::eCSSProperty_resize => {
                TransitionProperty::Longhand(LonghandId::Resize)
            }
            nsCSSPropertyID::eCSSProperty_ruby_align => {
                TransitionProperty::Longhand(LonghandId::RubyAlign)
            }
            nsCSSPropertyID::eCSSProperty_ruby_position => {
                TransitionProperty::Longhand(LonghandId::RubyPosition)
            }
            nsCSSPropertyID::eCSSProperty_scroll_behavior => {
                TransitionProperty::Longhand(LonghandId::ScrollBehavior)
            }
            nsCSSPropertyID::eCSSProperty_scroll_snap_align => {
                TransitionProperty::Longhand(LonghandId::ScrollSnapAlign)
            }
            nsCSSPropertyID::eCSSProperty_scroll_snap_type => {
                TransitionProperty::Longhand(LonghandId::ScrollSnapType)
            }
            nsCSSPropertyID::eCSSProperty_scrollbar_width => {
                TransitionProperty::Longhand(LonghandId::ScrollbarWidth)
            }
            nsCSSPropertyID::eCSSProperty_shape_rendering => {
                TransitionProperty::Longhand(LonghandId::ShapeRendering)
            }
            nsCSSPropertyID::eCSSProperty_stroke_linecap => {
                TransitionProperty::Longhand(LonghandId::StrokeLinecap)
            }
            nsCSSPropertyID::eCSSProperty_stroke_linejoin => {
                TransitionProperty::Longhand(LonghandId::StrokeLinejoin)
            }
            nsCSSPropertyID::eCSSProperty_table_layout => {
                TransitionProperty::Longhand(LonghandId::TableLayout)
            }
            nsCSSPropertyID::eCSSProperty_text_align => {
                TransitionProperty::Longhand(LonghandId::TextAlign)
            }
            nsCSSPropertyID::eCSSProperty_text_align_last => {
                TransitionProperty::Longhand(LonghandId::TextAlignLast)
            }
            nsCSSPropertyID::eCSSProperty_text_anchor => {
                TransitionProperty::Longhand(LonghandId::TextAnchor)
            }
            nsCSSPropertyID::eCSSProperty_text_combine_upright => {
                TransitionProperty::Longhand(LonghandId::TextCombineUpright)
            }
            nsCSSPropertyID::eCSSProperty_text_decoration_line => {
                TransitionProperty::Longhand(LonghandId::TextDecorationLine)
            }
            nsCSSPropertyID::eCSSProperty_text_decoration_style => {
                TransitionProperty::Longhand(LonghandId::TextDecorationStyle)
            }
            nsCSSPropertyID::eCSSProperty_text_emphasis_position => {
                TransitionProperty::Longhand(LonghandId::TextEmphasisPosition)
            }
            nsCSSPropertyID::eCSSProperty_text_justify => {
                TransitionProperty::Longhand(LonghandId::TextJustify)
            }
            nsCSSPropertyID::eCSSProperty_text_orientation => {
                TransitionProperty::Longhand(LonghandId::TextOrientation)
            }
            nsCSSPropertyID::eCSSProperty_text_rendering => {
                TransitionProperty::Longhand(LonghandId::TextRendering)
            }
            nsCSSPropertyID::eCSSProperty_text_transform => {
                TransitionProperty::Longhand(LonghandId::TextTransform)
            }
            nsCSSPropertyID::eCSSProperty_touch_action => {
                TransitionProperty::Longhand(LonghandId::TouchAction)
            }
            nsCSSPropertyID::eCSSProperty_transform_box => {
                TransitionProperty::Longhand(LonghandId::TransformBox)
            }
            nsCSSPropertyID::eCSSProperty_transform_style => {
                TransitionProperty::Longhand(LonghandId::TransformStyle)
            }
            nsCSSPropertyID::eCSSProperty_unicode_bidi => {
                TransitionProperty::Longhand(LonghandId::UnicodeBidi)
            }
            nsCSSPropertyID::eCSSProperty_vector_effect => {
                TransitionProperty::Longhand(LonghandId::VectorEffect)
            }
            nsCSSPropertyID::eCSSProperty_visibility => {
                TransitionProperty::Longhand(LonghandId::Visibility)
            }
            nsCSSPropertyID::eCSSProperty__webkit_line_clamp => {
                TransitionProperty::Longhand(LonghandId::WebkitLineClamp)
            }
            nsCSSPropertyID::eCSSProperty_white_space => {
                TransitionProperty::Longhand(LonghandId::WhiteSpace)
            }
            nsCSSPropertyID::eCSSProperty_word_break => {
                TransitionProperty::Longhand(LonghandId::WordBreak)
            }
            nsCSSPropertyID::eCSSProperty_writing_mode => {
                TransitionProperty::Longhand(LonghandId::WritingMode)
            }
            nsCSSPropertyID::eCSSProperty__x_span => {
                TransitionProperty::Longhand(LonghandId::XSpan)
            }
            nsCSSPropertyID::eCSSProperty__x_text_zoom => {
                TransitionProperty::Longhand(LonghandId::XTextZoom)
            }
            nsCSSPropertyID::eCSSProperty_z_index => {
                TransitionProperty::Longhand(LonghandId::ZIndex)
            }
            nsCSSPropertyID::eCSSProperty_break_after => {
                TransitionProperty::Longhand(LonghandId::BreakAfter)
            }
            nsCSSPropertyID::eCSSProperty_break_before => {
                TransitionProperty::Longhand(LonghandId::BreakBefore)
            }
            nsCSSPropertyID::eCSSProperty_clip_rule => {
                TransitionProperty::Longhand(LonghandId::ClipRule)
            }
            nsCSSPropertyID::eCSSProperty_fill_rule => {
                TransitionProperty::Longhand(LonghandId::FillRule)
            }
            nsCSSPropertyID::eCSSProperty__moz_box_ordinal_group => {
                TransitionProperty::Longhand(LonghandId::MozBoxOrdinalGroup)
            }
            nsCSSPropertyID::eCSSProperty_order => {
                TransitionProperty::Longhand(LonghandId::Order)
            }
            nsCSSPropertyID::eCSSProperty_overflow_x => {
                TransitionProperty::Longhand(LonghandId::OverflowX)
            }
            nsCSSPropertyID::eCSSProperty_overflow_y => {
                TransitionProperty::Longhand(LonghandId::OverflowY)
            }
            nsCSSPropertyID::eCSSProperty_overflow_clip_box_block => {
                TransitionProperty::Longhand(LonghandId::OverflowClipBoxBlock)
            }
            nsCSSPropertyID::eCSSProperty_overflow_clip_box_inline => {
                TransitionProperty::Longhand(LonghandId::OverflowClipBoxInline)
            }
            nsCSSPropertyID::eCSSProperty_overscroll_behavior_x => {
                TransitionProperty::Longhand(LonghandId::OverscrollBehaviorX)
            }
            nsCSSPropertyID::eCSSProperty_overscroll_behavior_y => {
                TransitionProperty::Longhand(LonghandId::OverscrollBehaviorY)
            }
            nsCSSPropertyID::eCSSProperty_fill_opacity => {
                TransitionProperty::Longhand(LonghandId::FillOpacity)
            }
            nsCSSPropertyID::eCSSProperty_stroke_opacity => {
                TransitionProperty::Longhand(LonghandId::StrokeOpacity)
            }
            nsCSSPropertyID::eCSSProperty_flex_grow => {
                TransitionProperty::Longhand(LonghandId::FlexGrow)
            }
            nsCSSPropertyID::eCSSProperty_flex_shrink => {
                TransitionProperty::Longhand(LonghandId::FlexShrink)
            }
            nsCSSPropertyID::eCSSProperty__moz_box_flex => {
                TransitionProperty::Longhand(LonghandId::MozBoxFlex)
            }
            nsCSSPropertyID::eCSSProperty_stroke_miterlimit => {
                TransitionProperty::Longhand(LonghandId::StrokeMiterlimit)
            }
            nsCSSPropertyID::eCSSProperty_flood_opacity => {
                TransitionProperty::Longhand(LonghandId::FloodOpacity)
            }
            nsCSSPropertyID::eCSSProperty__moz_window_opacity => {
                TransitionProperty::Longhand(LonghandId::MozWindowOpacity)
            }
            nsCSSPropertyID::eCSSProperty_opacity => {
                TransitionProperty::Longhand(LonghandId::Opacity)
            }
            nsCSSPropertyID::eCSSProperty_shape_image_threshold => {
                TransitionProperty::Longhand(LonghandId::ShapeImageThreshold)
            }
            nsCSSPropertyID::eCSSProperty_stop_opacity => {
                TransitionProperty::Longhand(LonghandId::StopOpacity)
            }
            nsCSSPropertyID::eCSSProperty_border_block_end_style => {
                TransitionProperty::Longhand(LonghandId::BorderBlockEndStyle)
            }
            nsCSSPropertyID::eCSSProperty_border_block_start_style => {
                TransitionProperty::Longhand(LonghandId::BorderBlockStartStyle)
            }
            nsCSSPropertyID::eCSSProperty_border_bottom_style => {
                TransitionProperty::Longhand(LonghandId::BorderBottomStyle)
            }
            nsCSSPropertyID::eCSSProperty_border_inline_end_style => {
                TransitionProperty::Longhand(LonghandId::BorderInlineEndStyle)
            }
            nsCSSPropertyID::eCSSProperty_border_inline_start_style => {
                TransitionProperty::Longhand(LonghandId::BorderInlineStartStyle)
            }
            nsCSSPropertyID::eCSSProperty_border_left_style => {
                TransitionProperty::Longhand(LonghandId::BorderLeftStyle)
            }
            nsCSSPropertyID::eCSSProperty_border_right_style => {
                TransitionProperty::Longhand(LonghandId::BorderRightStyle)
            }
            nsCSSPropertyID::eCSSProperty_border_top_style => {
                TransitionProperty::Longhand(LonghandId::BorderTopStyle)
            }
            nsCSSPropertyID::eCSSProperty_column_rule_style => {
                TransitionProperty::Longhand(LonghandId::ColumnRuleStyle)
            }
            nsCSSPropertyID::eCSSProperty_animation_delay => {
                TransitionProperty::Longhand(LonghandId::AnimationDelay)
            }
            nsCSSPropertyID::eCSSProperty_animation_direction => {
                TransitionProperty::Longhand(LonghandId::AnimationDirection)
            }
            nsCSSPropertyID::eCSSProperty_animation_duration => {
                TransitionProperty::Longhand(LonghandId::AnimationDuration)
            }
            nsCSSPropertyID::eCSSProperty_animation_fill_mode => {
                TransitionProperty::Longhand(LonghandId::AnimationFillMode)
            }
            nsCSSPropertyID::eCSSProperty_animation_iteration_count => {
                TransitionProperty::Longhand(LonghandId::AnimationIterationCount)
            }
            nsCSSPropertyID::eCSSProperty_animation_name => {
                TransitionProperty::Longhand(LonghandId::AnimationName)
            }
            nsCSSPropertyID::eCSSProperty_animation_play_state => {
                TransitionProperty::Longhand(LonghandId::AnimationPlayState)
            }
            nsCSSPropertyID::eCSSProperty_animation_timing_function => {
                TransitionProperty::Longhand(LonghandId::AnimationTimingFunction)
            }
            nsCSSPropertyID::eCSSProperty_background_attachment => {
                TransitionProperty::Longhand(LonghandId::BackgroundAttachment)
            }
            nsCSSPropertyID::eCSSProperty_background_blend_mode => {
                TransitionProperty::Longhand(LonghandId::BackgroundBlendMode)
            }
            nsCSSPropertyID::eCSSProperty_background_clip => {
                TransitionProperty::Longhand(LonghandId::BackgroundClip)
            }
            nsCSSPropertyID::eCSSProperty_background_image => {
                TransitionProperty::Longhand(LonghandId::BackgroundImage)
            }
            nsCSSPropertyID::eCSSProperty_background_origin => {
                TransitionProperty::Longhand(LonghandId::BackgroundOrigin)
            }
            nsCSSPropertyID::eCSSProperty_background_position_x => {
                TransitionProperty::Longhand(LonghandId::BackgroundPositionX)
            }
            nsCSSPropertyID::eCSSProperty_background_position_y => {
                TransitionProperty::Longhand(LonghandId::BackgroundPositionY)
            }
            nsCSSPropertyID::eCSSProperty_background_repeat => {
                TransitionProperty::Longhand(LonghandId::BackgroundRepeat)
            }
            nsCSSPropertyID::eCSSProperty_background_size => {
                TransitionProperty::Longhand(LonghandId::BackgroundSize)
            }
            nsCSSPropertyID::eCSSProperty_border_image_outset => {
                TransitionProperty::Longhand(LonghandId::BorderImageOutset)
            }
            nsCSSPropertyID::eCSSProperty_border_image_slice => {
                TransitionProperty::Longhand(LonghandId::BorderImageSlice)
            }
            nsCSSPropertyID::eCSSProperty_border_image_source => {
                TransitionProperty::Longhand(LonghandId::BorderImageSource)
            }
            nsCSSPropertyID::eCSSProperty_border_image_width => {
                TransitionProperty::Longhand(LonghandId::BorderImageWidth)
            }
            nsCSSPropertyID::eCSSProperty_border_spacing => {
                TransitionProperty::Longhand(LonghandId::BorderSpacing)
            }
            nsCSSPropertyID::eCSSProperty_box_shadow => {
                TransitionProperty::Longhand(LonghandId::BoxShadow)
            }
            nsCSSPropertyID::eCSSProperty_caret_color => {
                TransitionProperty::Longhand(LonghandId::CaretColor)
            }
            nsCSSPropertyID::eCSSProperty_clip_path => {
                TransitionProperty::Longhand(LonghandId::ClipPath)
            }
            nsCSSPropertyID::eCSSProperty_color => {
                TransitionProperty::Longhand(LonghandId::Color)
            }
            nsCSSPropertyID::eCSSProperty_column_width => {
                TransitionProperty::Longhand(LonghandId::ColumnWidth)
            }
            nsCSSPropertyID::eCSSProperty_content => {
                TransitionProperty::Longhand(LonghandId::Content)
            }
            nsCSSPropertyID::eCSSProperty_counter_increment => {
                TransitionProperty::Longhand(LonghandId::CounterIncrement)
            }
            nsCSSPropertyID::eCSSProperty_cursor => {
                TransitionProperty::Longhand(LonghandId::Cursor)
            }
            nsCSSPropertyID::eCSSProperty_filter => {
                TransitionProperty::Longhand(LonghandId::Filter)
            }
            nsCSSPropertyID::eCSSProperty_flex_basis => {
                TransitionProperty::Longhand(LonghandId::FlexBasis)
            }
            nsCSSPropertyID::eCSSProperty_font_family => {
                TransitionProperty::Longhand(LonghandId::FontFamily)
            }
            nsCSSPropertyID::eCSSProperty_font_feature_settings => {
                TransitionProperty::Longhand(LonghandId::FontFeatureSettings)
            }
            nsCSSPropertyID::eCSSProperty_font_language_override => {
                TransitionProperty::Longhand(LonghandId::FontLanguageOverride)
            }
            nsCSSPropertyID::eCSSProperty_font_size => {
                TransitionProperty::Longhand(LonghandId::FontSize)
            }
            nsCSSPropertyID::eCSSProperty_font_variant_alternates => {
                TransitionProperty::Longhand(LonghandId::FontVariantAlternates)
            }
            nsCSSPropertyID::eCSSProperty_font_variation_settings => {
                TransitionProperty::Longhand(LonghandId::FontVariationSettings)
            }
            nsCSSPropertyID::eCSSProperty_grid_template_areas => {
                TransitionProperty::Longhand(LonghandId::GridTemplateAreas)
            }
            nsCSSPropertyID::eCSSProperty_letter_spacing => {
                TransitionProperty::Longhand(LonghandId::LetterSpacing)
            }
            nsCSSPropertyID::eCSSProperty_line_height => {
                TransitionProperty::Longhand(LonghandId::LineHeight)
            }
            nsCSSPropertyID::eCSSProperty_list_style_image => {
                TransitionProperty::Longhand(LonghandId::ListStyleImage)
            }
            nsCSSPropertyID::eCSSProperty_list_style_type => {
                TransitionProperty::Longhand(LonghandId::ListStyleType)
            }
            nsCSSPropertyID::eCSSProperty_mask_clip => {
                TransitionProperty::Longhand(LonghandId::MaskClip)
            }
            nsCSSPropertyID::eCSSProperty_mask_composite => {
                TransitionProperty::Longhand(LonghandId::MaskComposite)
            }
            nsCSSPropertyID::eCSSProperty_mask_image => {
                TransitionProperty::Longhand(LonghandId::MaskImage)
            }
            nsCSSPropertyID::eCSSProperty_mask_mode => {
                TransitionProperty::Longhand(LonghandId::MaskMode)
            }
            nsCSSPropertyID::eCSSProperty_mask_origin => {
                TransitionProperty::Longhand(LonghandId::MaskOrigin)
            }
            nsCSSPropertyID::eCSSProperty_mask_position_x => {
                TransitionProperty::Longhand(LonghandId::MaskPositionX)
            }
            nsCSSPropertyID::eCSSProperty_mask_position_y => {
                TransitionProperty::Longhand(LonghandId::MaskPositionY)
            }
            nsCSSPropertyID::eCSSProperty_mask_repeat => {
                TransitionProperty::Longhand(LonghandId::MaskRepeat)
            }
            nsCSSPropertyID::eCSSProperty_mask_size => {
                TransitionProperty::Longhand(LonghandId::MaskSize)
            }
            nsCSSPropertyID::eCSSProperty__moz_context_properties => {
                TransitionProperty::Longhand(LonghandId::MozContextProperties)
            }
            nsCSSPropertyID::eCSSProperty__moz_font_smoothing_background_color => {
                TransitionProperty::Longhand(LonghandId::MozFontSmoothingBackgroundColor)
            }
            nsCSSPropertyID::eCSSProperty__moz_tab_size => {
                TransitionProperty::Longhand(LonghandId::MozTabSize)
            }
            nsCSSPropertyID::eCSSProperty_offset_path => {
                TransitionProperty::Longhand(LonghandId::OffsetPath)
            }
            nsCSSPropertyID::eCSSProperty_perspective => {
                TransitionProperty::Longhand(LonghandId::Perspective)
            }
            nsCSSPropertyID::eCSSProperty_quotes => {
                TransitionProperty::Longhand(LonghandId::Quotes)
            }
            nsCSSPropertyID::eCSSProperty_rotate => {
                TransitionProperty::Longhand(LonghandId::Rotate)
            }
            nsCSSPropertyID::eCSSProperty_scale => {
                TransitionProperty::Longhand(LonghandId::Scale)
            }
            nsCSSPropertyID::eCSSProperty_scroll_snap_coordinate => {
                TransitionProperty::Longhand(LonghandId::ScrollSnapCoordinate)
            }
            nsCSSPropertyID::eCSSProperty_scrollbar_color => {
                TransitionProperty::Longhand(LonghandId::ScrollbarColor)
            }
            nsCSSPropertyID::eCSSProperty_shape_outside => {
                TransitionProperty::Longhand(LonghandId::ShapeOutside)
            }
            nsCSSPropertyID::eCSSProperty_stroke_dasharray => {
                TransitionProperty::Longhand(LonghandId::StrokeDasharray)
            }
            nsCSSPropertyID::eCSSProperty_stroke_dashoffset => {
                TransitionProperty::Longhand(LonghandId::StrokeDashoffset)
            }
            nsCSSPropertyID::eCSSProperty_stroke_width => {
                TransitionProperty::Longhand(LonghandId::StrokeWidth)
            }
            nsCSSPropertyID::eCSSProperty_text_emphasis_style => {
                TransitionProperty::Longhand(LonghandId::TextEmphasisStyle)
            }
            nsCSSPropertyID::eCSSProperty_text_indent => {
                TransitionProperty::Longhand(LonghandId::TextIndent)
            }
            nsCSSPropertyID::eCSSProperty_text_overflow => {
                TransitionProperty::Longhand(LonghandId::TextOverflow)
            }
            nsCSSPropertyID::eCSSProperty_text_shadow => {
                TransitionProperty::Longhand(LonghandId::TextShadow)
            }
            nsCSSPropertyID::eCSSProperty_transition_delay => {
                TransitionProperty::Longhand(LonghandId::TransitionDelay)
            }
            nsCSSPropertyID::eCSSProperty_transition_duration => {
                TransitionProperty::Longhand(LonghandId::TransitionDuration)
            }
            nsCSSPropertyID::eCSSProperty_transition_property => {
                TransitionProperty::Longhand(LonghandId::TransitionProperty)
            }
            nsCSSPropertyID::eCSSProperty_transition_timing_function => {
                TransitionProperty::Longhand(LonghandId::TransitionTimingFunction)
            }
            nsCSSPropertyID::eCSSProperty_translate => {
                TransitionProperty::Longhand(LonghandId::Translate)
            }
            nsCSSPropertyID::eCSSProperty_vertical_align => {
                TransitionProperty::Longhand(LonghandId::VerticalAlign)
            }
            nsCSSPropertyID::eCSSProperty_will_change => {
                TransitionProperty::Longhand(LonghandId::WillChange)
            }
            nsCSSPropertyID::eCSSProperty_word_spacing => {
                TransitionProperty::Longhand(LonghandId::WordSpacing)
            }
            nsCSSPropertyID::eCSSProperty__x_lang => {
                TransitionProperty::Longhand(LonghandId::XLang)
            }
            nsCSSPropertyID::eCSSProperty_clip => {
                TransitionProperty::Longhand(LonghandId::Clip)
            }
            nsCSSPropertyID::eCSSProperty__moz_image_region => {
                TransitionProperty::Longhand(LonghandId::MozImageRegion)
            }
            nsCSSPropertyID::eCSSProperty_grid_template_columns => {
                TransitionProperty::Longhand(LonghandId::GridTemplateColumns)
            }
            nsCSSPropertyID::eCSSProperty_grid_template_rows => {
                TransitionProperty::Longhand(LonghandId::GridTemplateRows)
            }
            nsCSSPropertyID::eCSSProperty_fill => {
                TransitionProperty::Longhand(LonghandId::Fill)
            }
            nsCSSPropertyID::eCSSProperty_stroke => {
                TransitionProperty::Longhand(LonghandId::Stroke)
            }
            nsCSSPropertyID::eCSSProperty_grid_auto_columns => {
                TransitionProperty::Longhand(LonghandId::GridAutoColumns)
            }
            nsCSSPropertyID::eCSSProperty_grid_auto_rows => {
                TransitionProperty::Longhand(LonghandId::GridAutoRows)
            }
            nsCSSPropertyID::eCSSProperty__moz_window_transform_origin => {
                TransitionProperty::Longhand(LonghandId::MozWindowTransformOrigin)
            }
            nsCSSPropertyID::eCSSProperty_transform_origin => {
                TransitionProperty::Longhand(LonghandId::TransformOrigin)
            }
            nsCSSPropertyID::eCSSProperty_counter_reset => {
                TransitionProperty::Longhand(LonghandId::CounterReset)
            }
            nsCSSPropertyID::eCSSProperty_counter_set => {
                TransitionProperty::Longhand(LonghandId::CounterSet)
            }
            nsCSSPropertyID::eCSSProperty_scroll_snap_points_x => {
                TransitionProperty::Longhand(LonghandId::ScrollSnapPointsX)
            }
            nsCSSPropertyID::eCSSProperty_scroll_snap_points_y => {
                TransitionProperty::Longhand(LonghandId::ScrollSnapPointsY)
            }
            nsCSSPropertyID::eCSSProperty__moz_window_transform => {
                TransitionProperty::Longhand(LonghandId::MozWindowTransform)
            }
            nsCSSPropertyID::eCSSProperty_transform => {
                TransitionProperty::Longhand(LonghandId::Transform)
            }
            nsCSSPropertyID::eCSSProperty_column_gap => {
                TransitionProperty::Longhand(LonghandId::ColumnGap)
            }
            nsCSSPropertyID::eCSSProperty_row_gap => {
                TransitionProperty::Longhand(LonghandId::RowGap)
            }
            nsCSSPropertyID::eCSSProperty_object_position => {
                TransitionProperty::Longhand(LonghandId::ObjectPosition)
            }
            nsCSSPropertyID::eCSSProperty_perspective_origin => {
                TransitionProperty::Longhand(LonghandId::PerspectiveOrigin)
            }
            nsCSSPropertyID::eCSSProperty_scroll_snap_destination => {
                TransitionProperty::Longhand(LonghandId::ScrollSnapDestination)
            }
            nsCSSPropertyID::eCSSProperty_grid_column_end => {
                TransitionProperty::Longhand(LonghandId::GridColumnEnd)
            }
            nsCSSPropertyID::eCSSProperty_grid_column_start => {
                TransitionProperty::Longhand(LonghandId::GridColumnStart)
            }
            nsCSSPropertyID::eCSSProperty_grid_row_end => {
                TransitionProperty::Longhand(LonghandId::GridRowEnd)
            }
            nsCSSPropertyID::eCSSProperty_grid_row_start => {
                TransitionProperty::Longhand(LonghandId::GridRowStart)
            }
            nsCSSPropertyID::eCSSProperty_max_block_size => {
                TransitionProperty::Longhand(LonghandId::MaxBlockSize)
            }
            nsCSSPropertyID::eCSSProperty_max_height => {
                TransitionProperty::Longhand(LonghandId::MaxHeight)
            }
            nsCSSPropertyID::eCSSProperty_max_inline_size => {
                TransitionProperty::Longhand(LonghandId::MaxInlineSize)
            }
            nsCSSPropertyID::eCSSProperty_max_width => {
                TransitionProperty::Longhand(LonghandId::MaxWidth)
            }
            nsCSSPropertyID::eCSSProperty_marker_end => {
                TransitionProperty::Longhand(LonghandId::MarkerEnd)
            }
            nsCSSPropertyID::eCSSProperty_marker_mid => {
                TransitionProperty::Longhand(LonghandId::MarkerMid)
            }
            nsCSSPropertyID::eCSSProperty_marker_start => {
                TransitionProperty::Longhand(LonghandId::MarkerStart)
            }
            nsCSSPropertyID::eCSSProperty__moz_binding => {
                TransitionProperty::Longhand(LonghandId::MozBinding)
            }
            nsCSSPropertyID::eCSSProperty_scroll_padding_block_end => {
                TransitionProperty::Longhand(LonghandId::ScrollPaddingBlockEnd)
            }
            nsCSSPropertyID::eCSSProperty_scroll_padding_block_start => {
                TransitionProperty::Longhand(LonghandId::ScrollPaddingBlockStart)
            }
            nsCSSPropertyID::eCSSProperty_scroll_padding_bottom => {
                TransitionProperty::Longhand(LonghandId::ScrollPaddingBottom)
            }
            nsCSSPropertyID::eCSSProperty_scroll_padding_inline_end => {
                TransitionProperty::Longhand(LonghandId::ScrollPaddingInlineEnd)
            }
            nsCSSPropertyID::eCSSProperty_scroll_padding_inline_start => {
                TransitionProperty::Longhand(LonghandId::ScrollPaddingInlineStart)
            }
            nsCSSPropertyID::eCSSProperty_scroll_padding_left => {
                TransitionProperty::Longhand(LonghandId::ScrollPaddingLeft)
            }
            nsCSSPropertyID::eCSSProperty_scroll_padding_right => {
                TransitionProperty::Longhand(LonghandId::ScrollPaddingRight)
            }
            nsCSSPropertyID::eCSSProperty_scroll_padding_top => {
                TransitionProperty::Longhand(LonghandId::ScrollPaddingTop)
            }
            nsCSSPropertyID::eCSSProperty_block_size => {
                TransitionProperty::Longhand(LonghandId::BlockSize)
            }
            nsCSSPropertyID::eCSSProperty_height => {
                TransitionProperty::Longhand(LonghandId::Height)
            }
            nsCSSPropertyID::eCSSProperty_inline_size => {
                TransitionProperty::Longhand(LonghandId::InlineSize)
            }
            nsCSSPropertyID::eCSSProperty_min_block_size => {
                TransitionProperty::Longhand(LonghandId::MinBlockSize)
            }
            nsCSSPropertyID::eCSSProperty_min_height => {
                TransitionProperty::Longhand(LonghandId::MinHeight)
            }
            nsCSSPropertyID::eCSSProperty_min_inline_size => {
                TransitionProperty::Longhand(LonghandId::MinInlineSize)
            }
            nsCSSPropertyID::eCSSProperty_min_width => {
                TransitionProperty::Longhand(LonghandId::MinWidth)
            }
            nsCSSPropertyID::eCSSProperty_width => {
                TransitionProperty::Longhand(LonghandId::Width)
            }
            nsCSSPropertyID::eCSSProperty_outline_offset => {
                TransitionProperty::Longhand(LonghandId::OutlineOffset)
            }
            nsCSSPropertyID::eCSSProperty_scroll_margin_block_end => {
                TransitionProperty::Longhand(LonghandId::ScrollMarginBlockEnd)
            }
            nsCSSPropertyID::eCSSProperty_scroll_margin_block_start => {
                TransitionProperty::Longhand(LonghandId::ScrollMarginBlockStart)
            }
            nsCSSPropertyID::eCSSProperty_scroll_margin_bottom => {
                TransitionProperty::Longhand(LonghandId::ScrollMarginBottom)
            }
            nsCSSPropertyID::eCSSProperty_scroll_margin_inline_end => {
                TransitionProperty::Longhand(LonghandId::ScrollMarginInlineEnd)
            }
            nsCSSPropertyID::eCSSProperty_scroll_margin_inline_start => {
                TransitionProperty::Longhand(LonghandId::ScrollMarginInlineStart)
            }
            nsCSSPropertyID::eCSSProperty_scroll_margin_left => {
                TransitionProperty::Longhand(LonghandId::ScrollMarginLeft)
            }
            nsCSSPropertyID::eCSSProperty_scroll_margin_right => {
                TransitionProperty::Longhand(LonghandId::ScrollMarginRight)
            }
            nsCSSPropertyID::eCSSProperty_scroll_margin_top => {
                TransitionProperty::Longhand(LonghandId::ScrollMarginTop)
            }
            nsCSSPropertyID::eCSSProperty_padding_block_end => {
                TransitionProperty::Longhand(LonghandId::PaddingBlockEnd)
            }
            nsCSSPropertyID::eCSSProperty_padding_block_start => {
                TransitionProperty::Longhand(LonghandId::PaddingBlockStart)
            }
            nsCSSPropertyID::eCSSProperty_padding_bottom => {
                TransitionProperty::Longhand(LonghandId::PaddingBottom)
            }
            nsCSSPropertyID::eCSSProperty_padding_inline_end => {
                TransitionProperty::Longhand(LonghandId::PaddingInlineEnd)
            }
            nsCSSPropertyID::eCSSProperty_padding_inline_start => {
                TransitionProperty::Longhand(LonghandId::PaddingInlineStart)
            }
            nsCSSPropertyID::eCSSProperty_padding_left => {
                TransitionProperty::Longhand(LonghandId::PaddingLeft)
            }
            nsCSSPropertyID::eCSSProperty_padding_right => {
                TransitionProperty::Longhand(LonghandId::PaddingRight)
            }
            nsCSSPropertyID::eCSSProperty_padding_top => {
                TransitionProperty::Longhand(LonghandId::PaddingTop)
            }
            nsCSSPropertyID::eCSSProperty_shape_margin => {
                TransitionProperty::Longhand(LonghandId::ShapeMargin)
            }
            nsCSSPropertyID::eCSSProperty_border_block_end_width => {
                TransitionProperty::Longhand(LonghandId::BorderBlockEndWidth)
            }
            nsCSSPropertyID::eCSSProperty_border_block_start_width => {
                TransitionProperty::Longhand(LonghandId::BorderBlockStartWidth)
            }
            nsCSSPropertyID::eCSSProperty_border_bottom_width => {
                TransitionProperty::Longhand(LonghandId::BorderBottomWidth)
            }
            nsCSSPropertyID::eCSSProperty_border_inline_end_width => {
                TransitionProperty::Longhand(LonghandId::BorderInlineEndWidth)
            }
            nsCSSPropertyID::eCSSProperty_border_inline_start_width => {
                TransitionProperty::Longhand(LonghandId::BorderInlineStartWidth)
            }
            nsCSSPropertyID::eCSSProperty_border_left_width => {
                TransitionProperty::Longhand(LonghandId::BorderLeftWidth)
            }
            nsCSSPropertyID::eCSSProperty_border_right_width => {
                TransitionProperty::Longhand(LonghandId::BorderRightWidth)
            }
            nsCSSPropertyID::eCSSProperty_border_top_width => {
                TransitionProperty::Longhand(LonghandId::BorderTopWidth)
            }
            nsCSSPropertyID::eCSSProperty_column_rule_width => {
                TransitionProperty::Longhand(LonghandId::ColumnRuleWidth)
            }
            nsCSSPropertyID::eCSSProperty_outline_width => {
                TransitionProperty::Longhand(LonghandId::OutlineWidth)
            }
            nsCSSPropertyID::eCSSProperty__webkit_text_stroke_width => {
                TransitionProperty::Longhand(LonghandId::WebkitTextStrokeWidth)
            }
            nsCSSPropertyID::eCSSProperty_border_bottom_left_radius => {
                TransitionProperty::Longhand(LonghandId::BorderBottomLeftRadius)
            }
            nsCSSPropertyID::eCSSProperty_border_bottom_right_radius => {
                TransitionProperty::Longhand(LonghandId::BorderBottomRightRadius)
            }
            nsCSSPropertyID::eCSSProperty_border_end_end_radius => {
                TransitionProperty::Longhand(LonghandId::BorderEndEndRadius)
            }
            nsCSSPropertyID::eCSSProperty_border_end_start_radius => {
                TransitionProperty::Longhand(LonghandId::BorderEndStartRadius)
            }
            nsCSSPropertyID::eCSSProperty_border_start_end_radius => {
                TransitionProperty::Longhand(LonghandId::BorderStartEndRadius)
            }
            nsCSSPropertyID::eCSSProperty_border_start_start_radius => {
                TransitionProperty::Longhand(LonghandId::BorderStartStartRadius)
            }
            nsCSSPropertyID::eCSSProperty_border_top_left_radius => {
                TransitionProperty::Longhand(LonghandId::BorderTopLeftRadius)
            }
            nsCSSPropertyID::eCSSProperty_border_top_right_radius => {
                TransitionProperty::Longhand(LonghandId::BorderTopRightRadius)
            }
            nsCSSPropertyID::eCSSProperty__moz_outline_radius_bottomleft => {
                TransitionProperty::Longhand(LonghandId::MozOutlineRadiusBottomleft)
            }
            nsCSSPropertyID::eCSSProperty__moz_outline_radius_bottomright => {
                TransitionProperty::Longhand(LonghandId::MozOutlineRadiusBottomright)
            }
            nsCSSPropertyID::eCSSProperty__moz_outline_radius_topleft => {
                TransitionProperty::Longhand(LonghandId::MozOutlineRadiusTopleft)
            }
            nsCSSPropertyID::eCSSProperty__moz_outline_radius_topright => {
                TransitionProperty::Longhand(LonghandId::MozOutlineRadiusTopright)
            }
            nsCSSPropertyID::eCSSProperty_bottom => {
                TransitionProperty::Longhand(LonghandId::Bottom)
            }
            nsCSSPropertyID::eCSSProperty_inset_block_end => {
                TransitionProperty::Longhand(LonghandId::InsetBlockEnd)
            }
            nsCSSPropertyID::eCSSProperty_inset_block_start => {
                TransitionProperty::Longhand(LonghandId::InsetBlockStart)
            }
            nsCSSPropertyID::eCSSProperty_inset_inline_end => {
                TransitionProperty::Longhand(LonghandId::InsetInlineEnd)
            }
            nsCSSPropertyID::eCSSProperty_inset_inline_start => {
                TransitionProperty::Longhand(LonghandId::InsetInlineStart)
            }
            nsCSSPropertyID::eCSSProperty_left => {
                TransitionProperty::Longhand(LonghandId::Left)
            }
            nsCSSPropertyID::eCSSProperty_margin_block_end => {
                TransitionProperty::Longhand(LonghandId::MarginBlockEnd)
            }
            nsCSSPropertyID::eCSSProperty_margin_block_start => {
                TransitionProperty::Longhand(LonghandId::MarginBlockStart)
            }
            nsCSSPropertyID::eCSSProperty_margin_bottom => {
                TransitionProperty::Longhand(LonghandId::MarginBottom)
            }
            nsCSSPropertyID::eCSSProperty_margin_inline_end => {
                TransitionProperty::Longhand(LonghandId::MarginInlineEnd)
            }
            nsCSSPropertyID::eCSSProperty_margin_inline_start => {
                TransitionProperty::Longhand(LonghandId::MarginInlineStart)
            }
            nsCSSPropertyID::eCSSProperty_margin_left => {
                TransitionProperty::Longhand(LonghandId::MarginLeft)
            }
            nsCSSPropertyID::eCSSProperty_margin_right => {
                TransitionProperty::Longhand(LonghandId::MarginRight)
            }
            nsCSSPropertyID::eCSSProperty_margin_top => {
                TransitionProperty::Longhand(LonghandId::MarginTop)
            }
            nsCSSPropertyID::eCSSProperty_right => {
                TransitionProperty::Longhand(LonghandId::Right)
            }
            nsCSSPropertyID::eCSSProperty_top => {
                TransitionProperty::Longhand(LonghandId::Top)
            }
            nsCSSPropertyID::eCSSProperty_background_color => {
                TransitionProperty::Longhand(LonghandId::BackgroundColor)
            }
            nsCSSPropertyID::eCSSProperty_border_block_end_color => {
                TransitionProperty::Longhand(LonghandId::BorderBlockEndColor)
            }
            nsCSSPropertyID::eCSSProperty_border_block_start_color => {
                TransitionProperty::Longhand(LonghandId::BorderBlockStartColor)
            }
            nsCSSPropertyID::eCSSProperty_border_bottom_color => {
                TransitionProperty::Longhand(LonghandId::BorderBottomColor)
            }
            nsCSSPropertyID::eCSSProperty_border_inline_end_color => {
                TransitionProperty::Longhand(LonghandId::BorderInlineEndColor)
            }
            nsCSSPropertyID::eCSSProperty_border_inline_start_color => {
                TransitionProperty::Longhand(LonghandId::BorderInlineStartColor)
            }
            nsCSSPropertyID::eCSSProperty_border_left_color => {
                TransitionProperty::Longhand(LonghandId::BorderLeftColor)
            }
            nsCSSPropertyID::eCSSProperty_border_right_color => {
                TransitionProperty::Longhand(LonghandId::BorderRightColor)
            }
            nsCSSPropertyID::eCSSProperty_border_top_color => {
                TransitionProperty::Longhand(LonghandId::BorderTopColor)
            }
            nsCSSPropertyID::eCSSProperty_column_rule_color => {
                TransitionProperty::Longhand(LonghandId::ColumnRuleColor)
            }
            nsCSSPropertyID::eCSSProperty_flood_color => {
                TransitionProperty::Longhand(LonghandId::FloodColor)
            }
            nsCSSPropertyID::eCSSProperty_lighting_color => {
                TransitionProperty::Longhand(LonghandId::LightingColor)
            }
            nsCSSPropertyID::eCSSProperty_outline_color => {
                TransitionProperty::Longhand(LonghandId::OutlineColor)
            }
            nsCSSPropertyID::eCSSProperty_stop_color => {
                TransitionProperty::Longhand(LonghandId::StopColor)
            }
            nsCSSPropertyID::eCSSProperty_text_decoration_color => {
                TransitionProperty::Longhand(LonghandId::TextDecorationColor)
            }
            nsCSSPropertyID::eCSSProperty_text_emphasis_color => {
                TransitionProperty::Longhand(LonghandId::TextEmphasisColor)
            }
            nsCSSPropertyID::eCSSProperty__webkit_text_fill_color => {
                TransitionProperty::Longhand(LonghandId::WebkitTextFillColor)
            }
            nsCSSPropertyID::eCSSProperty__webkit_text_stroke_color => {
                TransitionProperty::Longhand(LonghandId::WebkitTextStrokeColor)
            }
            nsCSSPropertyID::eCSSProperty_background => {
                TransitionProperty::Shorthand(ShorthandId::Background)
            }
            nsCSSPropertyID::eCSSProperty_background_position => {
                TransitionProperty::Shorthand(ShorthandId::BackgroundPosition)
            }
            nsCSSPropertyID::eCSSProperty_border_color => {
                TransitionProperty::Shorthand(ShorthandId::BorderColor)
            }
            nsCSSPropertyID::eCSSProperty_border_style => {
                TransitionProperty::Shorthand(ShorthandId::BorderStyle)
            }
            nsCSSPropertyID::eCSSProperty_border_width => {
                TransitionProperty::Shorthand(ShorthandId::BorderWidth)
            }
            nsCSSPropertyID::eCSSProperty_border_top => {
                TransitionProperty::Shorthand(ShorthandId::BorderTop)
            }
            nsCSSPropertyID::eCSSProperty_border_right => {
                TransitionProperty::Shorthand(ShorthandId::BorderRight)
            }
            nsCSSPropertyID::eCSSProperty_border_bottom => {
                TransitionProperty::Shorthand(ShorthandId::BorderBottom)
            }
            nsCSSPropertyID::eCSSProperty_border_left => {
                TransitionProperty::Shorthand(ShorthandId::BorderLeft)
            }
            nsCSSPropertyID::eCSSProperty_border_block_start => {
                TransitionProperty::Shorthand(ShorthandId::BorderBlockStart)
            }
            nsCSSPropertyID::eCSSProperty_border_block_end => {
                TransitionProperty::Shorthand(ShorthandId::BorderBlockEnd)
            }
            nsCSSPropertyID::eCSSProperty_border_inline_start => {
                TransitionProperty::Shorthand(ShorthandId::BorderInlineStart)
            }
            nsCSSPropertyID::eCSSProperty_border_inline_end => {
                TransitionProperty::Shorthand(ShorthandId::BorderInlineEnd)
            }
            nsCSSPropertyID::eCSSProperty_border => {
                TransitionProperty::Shorthand(ShorthandId::Border)
            }
            nsCSSPropertyID::eCSSProperty_border_radius => {
                TransitionProperty::Shorthand(ShorthandId::BorderRadius)
            }
            nsCSSPropertyID::eCSSProperty_border_image => {
                TransitionProperty::Shorthand(ShorthandId::BorderImage)
            }
            nsCSSPropertyID::eCSSProperty_border_block_width => {
                TransitionProperty::Shorthand(ShorthandId::BorderBlockWidth)
            }
            nsCSSPropertyID::eCSSProperty_border_block_style => {
                TransitionProperty::Shorthand(ShorthandId::BorderBlockStyle)
            }
            nsCSSPropertyID::eCSSProperty_border_block_color => {
                TransitionProperty::Shorthand(ShorthandId::BorderBlockColor)
            }
            nsCSSPropertyID::eCSSProperty_border_inline_width => {
                TransitionProperty::Shorthand(ShorthandId::BorderInlineWidth)
            }
            nsCSSPropertyID::eCSSProperty_border_inline_style => {
                TransitionProperty::Shorthand(ShorthandId::BorderInlineStyle)
            }
            nsCSSPropertyID::eCSSProperty_border_inline_color => {
                TransitionProperty::Shorthand(ShorthandId::BorderInlineColor)
            }
            nsCSSPropertyID::eCSSProperty_border_block => {
                TransitionProperty::Shorthand(ShorthandId::BorderBlock)
            }
            nsCSSPropertyID::eCSSProperty_border_inline => {
                TransitionProperty::Shorthand(ShorthandId::BorderInline)
            }
            nsCSSPropertyID::eCSSProperty_overflow => {
                TransitionProperty::Shorthand(ShorthandId::Overflow)
            }
            nsCSSPropertyID::eCSSProperty_overflow_clip_box => {
                TransitionProperty::Shorthand(ShorthandId::OverflowClipBox)
            }
            nsCSSPropertyID::eCSSProperty_transition => {
                TransitionProperty::Shorthand(ShorthandId::Transition)
            }
            nsCSSPropertyID::eCSSProperty_animation => {
                TransitionProperty::Shorthand(ShorthandId::Animation)
            }
            nsCSSPropertyID::eCSSProperty_overscroll_behavior => {
                TransitionProperty::Shorthand(ShorthandId::OverscrollBehavior)
            }
            nsCSSPropertyID::eCSSProperty_page_break_before => {
                TransitionProperty::Shorthand(ShorthandId::PageBreakBefore)
            }
            nsCSSPropertyID::eCSSProperty_page_break_after => {
                TransitionProperty::Shorthand(ShorthandId::PageBreakAfter)
            }
            nsCSSPropertyID::eCSSProperty_columns => {
                TransitionProperty::Shorthand(ShorthandId::Columns)
            }
            nsCSSPropertyID::eCSSProperty_column_rule => {
                TransitionProperty::Shorthand(ShorthandId::ColumnRule)
            }
            nsCSSPropertyID::eCSSProperty_font => {
                TransitionProperty::Shorthand(ShorthandId::Font)
            }
            nsCSSPropertyID::eCSSProperty_font_variant => {
                TransitionProperty::Shorthand(ShorthandId::FontVariant)
            }
            nsCSSPropertyID::eCSSProperty_text_emphasis => {
                TransitionProperty::Shorthand(ShorthandId::TextEmphasis)
            }
            nsCSSPropertyID::eCSSProperty__webkit_text_stroke => {
                TransitionProperty::Shorthand(ShorthandId::WebkitTextStroke)
            }
            nsCSSPropertyID::eCSSProperty_marker => {
                TransitionProperty::Shorthand(ShorthandId::Marker)
            }
            nsCSSPropertyID::eCSSProperty_list_style => {
                TransitionProperty::Shorthand(ShorthandId::ListStyle)
            }
            nsCSSPropertyID::eCSSProperty_margin => {
                TransitionProperty::Shorthand(ShorthandId::Margin)
            }
            nsCSSPropertyID::eCSSProperty_margin_block => {
                TransitionProperty::Shorthand(ShorthandId::MarginBlock)
            }
            nsCSSPropertyID::eCSSProperty_margin_inline => {
                TransitionProperty::Shorthand(ShorthandId::MarginInline)
            }
            nsCSSPropertyID::eCSSProperty_scroll_margin => {
                TransitionProperty::Shorthand(ShorthandId::ScrollMargin)
            }
            nsCSSPropertyID::eCSSProperty_scroll_margin_block => {
                TransitionProperty::Shorthand(ShorthandId::ScrollMarginBlock)
            }
            nsCSSPropertyID::eCSSProperty_scroll_margin_inline => {
                TransitionProperty::Shorthand(ShorthandId::ScrollMarginInline)
            }
            nsCSSPropertyID::eCSSProperty_outline => {
                TransitionProperty::Shorthand(ShorthandId::Outline)
            }
            nsCSSPropertyID::eCSSProperty__moz_outline_radius => {
                TransitionProperty::Shorthand(ShorthandId::MozOutlineRadius)
            }
            nsCSSPropertyID::eCSSProperty_padding => {
                TransitionProperty::Shorthand(ShorthandId::Padding)
            }
            nsCSSPropertyID::eCSSProperty_padding_block => {
                TransitionProperty::Shorthand(ShorthandId::PaddingBlock)
            }
            nsCSSPropertyID::eCSSProperty_padding_inline => {
                TransitionProperty::Shorthand(ShorthandId::PaddingInline)
            }
            nsCSSPropertyID::eCSSProperty_scroll_padding => {
                TransitionProperty::Shorthand(ShorthandId::ScrollPadding)
            }
            nsCSSPropertyID::eCSSProperty_scroll_padding_block => {
                TransitionProperty::Shorthand(ShorthandId::ScrollPaddingBlock)
            }
            nsCSSPropertyID::eCSSProperty_scroll_padding_inline => {
                TransitionProperty::Shorthand(ShorthandId::ScrollPaddingInline)
            }
            nsCSSPropertyID::eCSSProperty_flex_flow => {
                TransitionProperty::Shorthand(ShorthandId::FlexFlow)
            }
            nsCSSPropertyID::eCSSProperty_flex => {
                TransitionProperty::Shorthand(ShorthandId::Flex)
            }
            nsCSSPropertyID::eCSSProperty_gap => {
                TransitionProperty::Shorthand(ShorthandId::Gap)
            }
            nsCSSPropertyID::eCSSProperty_grid_row => {
                TransitionProperty::Shorthand(ShorthandId::GridRow)
            }
            nsCSSPropertyID::eCSSProperty_grid_column => {
                TransitionProperty::Shorthand(ShorthandId::GridColumn)
            }
            nsCSSPropertyID::eCSSProperty_grid_area => {
                TransitionProperty::Shorthand(ShorthandId::GridArea)
            }
            nsCSSPropertyID::eCSSProperty_grid_template => {
                TransitionProperty::Shorthand(ShorthandId::GridTemplate)
            }
            nsCSSPropertyID::eCSSProperty_grid => {
                TransitionProperty::Shorthand(ShorthandId::Grid)
            }
            nsCSSPropertyID::eCSSProperty_place_content => {
                TransitionProperty::Shorthand(ShorthandId::PlaceContent)
            }
            nsCSSPropertyID::eCSSProperty_place_self => {
                TransitionProperty::Shorthand(ShorthandId::PlaceSelf)
            }
            nsCSSPropertyID::eCSSProperty_place_items => {
                TransitionProperty::Shorthand(ShorthandId::PlaceItems)
            }
            nsCSSPropertyID::eCSSProperty_inset => {
                TransitionProperty::Shorthand(ShorthandId::Inset)
            }
            nsCSSPropertyID::eCSSProperty_inset_block => {
                TransitionProperty::Shorthand(ShorthandId::InsetBlock)
            }
            nsCSSPropertyID::eCSSProperty_inset_inline => {
                TransitionProperty::Shorthand(ShorthandId::InsetInline)
            }
            nsCSSPropertyID::eCSSProperty_text_decoration => {
                TransitionProperty::Shorthand(ShorthandId::TextDecoration)
            }
            nsCSSPropertyID::eCSSProperty_mask => {
                TransitionProperty::Shorthand(ShorthandId::Mask)
            }
            nsCSSPropertyID::eCSSProperty_mask_position => {
                TransitionProperty::Shorthand(ShorthandId::MaskPosition)
            }
            nsCSSPropertyID::eCSSPropertyExtra_all_properties => {
                TransitionProperty::Shorthand(ShorthandId::All)
            }
            _ => {
                panic!("non-convertible nsCSSPropertyID")
            }
        }
    }
}

/// An animated property interpolation between two computed values for that
/// property.
#[derive(Clone, Debug, PartialEq)]
#[cfg_attr(feature = "servo", derive(MallocSizeOf))]
pub enum AnimatedProperty {
            
            /// align-content
            AlignContent(longhands::align_content::computed_value::T, longhands::align_content::computed_value::T),
            
            /// align-items
            AlignItems(longhands::align_items::computed_value::T, longhands::align_items::computed_value::T),
            
            /// align-self
            AlignSelf(longhands::align_self::computed_value::T, longhands::align_self::computed_value::T),
            
            /// backface-visibility
            BackfaceVisibility(longhands::backface_visibility::computed_value::T, longhands::backface_visibility::computed_value::T),
            
            /// border-collapse
            BorderCollapse(longhands::border_collapse::computed_value::T, longhands::border_collapse::computed_value::T),
            
            /// border-image-repeat
            BorderImageRepeat(longhands::border_image_repeat::computed_value::T, longhands::border_image_repeat::computed_value::T),
            
            /// box-decoration-break
            BoxDecorationBreak(longhands::box_decoration_break::computed_value::T, longhands::box_decoration_break::computed_value::T),
            
            /// box-sizing
            BoxSizing(longhands::box_sizing::computed_value::T, longhands::box_sizing::computed_value::T),
            
            /// break-inside
            BreakInside(longhands::break_inside::computed_value::T, longhands::break_inside::computed_value::T),
            
            /// caption-side
            CaptionSide(longhands::caption_side::computed_value::T, longhands::caption_side::computed_value::T),
            
            /// clear
            Clear(longhands::clear::computed_value::T, longhands::clear::computed_value::T),
            
            /// color-adjust
            ColorAdjust(longhands::color_adjust::computed_value::T, longhands::color_adjust::computed_value::T),
            
            /// color-interpolation
            ColorInterpolation(longhands::color_interpolation::computed_value::T, longhands::color_interpolation::computed_value::T),
            
            /// color-interpolation-filters
            ColorInterpolationFilters(longhands::color_interpolation_filters::computed_value::T, longhands::color_interpolation_filters::computed_value::T),
            
            /// column-count
            ColumnCount(<longhands::column_count::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::column_count::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// column-fill
            ColumnFill(longhands::column_fill::computed_value::T, longhands::column_fill::computed_value::T),
            
            /// column-span
            ColumnSpan(longhands::column_span::computed_value::T, longhands::column_span::computed_value::T),
            
            /// display
            Display(longhands::display::computed_value::T, longhands::display::computed_value::T),
            
            /// dominant-baseline
            DominantBaseline(longhands::dominant_baseline::computed_value::T, longhands::dominant_baseline::computed_value::T),
            
            /// empty-cells
            EmptyCells(longhands::empty_cells::computed_value::T, longhands::empty_cells::computed_value::T),
            
            /// flex-direction
            FlexDirection(longhands::flex_direction::computed_value::T, longhands::flex_direction::computed_value::T),
            
            /// flex-wrap
            FlexWrap(longhands::flex_wrap::computed_value::T, longhands::flex_wrap::computed_value::T),
            
            /// float
            Float(longhands::float::computed_value::T, longhands::float::computed_value::T),
            
            /// font-kerning
            FontKerning(longhands::font_kerning::computed_value::T, longhands::font_kerning::computed_value::T),
            
            /// font-optical-sizing
            FontOpticalSizing(longhands::font_optical_sizing::computed_value::T, longhands::font_optical_sizing::computed_value::T),
            
            /// font-size-adjust
            FontSizeAdjust(longhands::font_size_adjust::computed_value::T, longhands::font_size_adjust::computed_value::T),
            
            /// font-stretch
            FontStretch(<longhands::font_stretch::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::font_stretch::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// font-style
            FontStyle(<longhands::font_style::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::font_style::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// font-synthesis
            FontSynthesis(longhands::font_synthesis::computed_value::T, longhands::font_synthesis::computed_value::T),
            
            /// font-variant-caps
            FontVariantCaps(longhands::font_variant_caps::computed_value::T, longhands::font_variant_caps::computed_value::T),
            
            /// font-variant-east-asian
            FontVariantEastAsian(longhands::font_variant_east_asian::computed_value::T, longhands::font_variant_east_asian::computed_value::T),
            
            /// font-variant-ligatures
            FontVariantLigatures(longhands::font_variant_ligatures::computed_value::T, longhands::font_variant_ligatures::computed_value::T),
            
            /// font-variant-numeric
            FontVariantNumeric(longhands::font_variant_numeric::computed_value::T, longhands::font_variant_numeric::computed_value::T),
            
            /// font-variant-position
            FontVariantPosition(longhands::font_variant_position::computed_value::T, longhands::font_variant_position::computed_value::T),
            
            /// font-weight
            FontWeight(<longhands::font_weight::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::font_weight::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// grid-auto-flow
            GridAutoFlow(longhands::grid_auto_flow::computed_value::T, longhands::grid_auto_flow::computed_value::T),
            
            /// hyphens
            Hyphens(longhands::hyphens::computed_value::T, longhands::hyphens::computed_value::T),
            
            /// image-orientation
            ImageOrientation(longhands::image_orientation::computed_value::T, longhands::image_orientation::computed_value::T),
            
            /// image-rendering
            ImageRendering(longhands::image_rendering::computed_value::T, longhands::image_rendering::computed_value::T),
            
            /// ime-mode
            ImeMode(longhands::ime_mode::computed_value::T, longhands::ime_mode::computed_value::T),
            
            /// initial-letter
            InitialLetter(longhands::initial_letter::computed_value::T, longhands::initial_letter::computed_value::T),
            
            /// isolation
            Isolation(longhands::isolation::computed_value::T, longhands::isolation::computed_value::T),
            
            /// justify-content
            JustifyContent(longhands::justify_content::computed_value::T, longhands::justify_content::computed_value::T),
            
            /// justify-items
            JustifyItems(longhands::justify_items::computed_value::T, longhands::justify_items::computed_value::T),
            
            /// justify-self
            JustifySelf(longhands::justify_self::computed_value::T, longhands::justify_self::computed_value::T),
            
            /// list-style-position
            ListStylePosition(longhands::list_style_position::computed_value::T, longhands::list_style_position::computed_value::T),
            
            /// mask-type
            MaskType(longhands::mask_type::computed_value::T, longhands::mask_type::computed_value::T),
            
            /// mix-blend-mode
            MixBlendMode(longhands::mix_blend_mode::computed_value::T, longhands::mix_blend_mode::computed_value::T),
            
            /// -moz-appearance
            MozAppearance(longhands::_moz_appearance::computed_value::T, longhands::_moz_appearance::computed_value::T),
            
            /// -moz-box-align
            MozBoxAlign(longhands::_moz_box_align::computed_value::T, longhands::_moz_box_align::computed_value::T),
            
            /// -moz-box-direction
            MozBoxDirection(longhands::_moz_box_direction::computed_value::T, longhands::_moz_box_direction::computed_value::T),
            
            /// -moz-box-orient
            MozBoxOrient(longhands::_moz_box_orient::computed_value::T, longhands::_moz_box_orient::computed_value::T),
            
            /// -moz-box-pack
            MozBoxPack(longhands::_moz_box_pack::computed_value::T, longhands::_moz_box_pack::computed_value::T),
            
            /// -moz-float-edge
            MozFloatEdge(longhands::_moz_float_edge::computed_value::T, longhands::_moz_float_edge::computed_value::T),
            
            /// -moz-force-broken-image-icon
            MozForceBrokenImageIcon(longhands::_moz_force_broken_image_icon::computed_value::T, longhands::_moz_force_broken_image_icon::computed_value::T),
            
            /// -moz-list-reversed
            MozListReversed(longhands::_moz_list_reversed::computed_value::T, longhands::_moz_list_reversed::computed_value::T),
            
            /// -moz-orient
            MozOrient(longhands::_moz_orient::computed_value::T, longhands::_moz_orient::computed_value::T),
            
            /// -moz-osx-font-smoothing
            MozOsxFontSmoothing(longhands::_moz_osx_font_smoothing::computed_value::T, longhands::_moz_osx_font_smoothing::computed_value::T),
            
            /// -moz-stack-sizing
            MozStackSizing(longhands::_moz_stack_sizing::computed_value::T, longhands::_moz_stack_sizing::computed_value::T),
            
            /// -moz-text-size-adjust
            MozTextSizeAdjust(longhands::_moz_text_size_adjust::computed_value::T, longhands::_moz_text_size_adjust::computed_value::T),
            
            /// -moz-user-focus
            MozUserFocus(longhands::_moz_user_focus::computed_value::T, longhands::_moz_user_focus::computed_value::T),
            
            /// -moz-user-input
            MozUserInput(longhands::_moz_user_input::computed_value::T, longhands::_moz_user_input::computed_value::T),
            
            /// -moz-user-modify
            MozUserModify(longhands::_moz_user_modify::computed_value::T, longhands::_moz_user_modify::computed_value::T),
            
            /// -moz-user-select
            MozUserSelect(longhands::_moz_user_select::computed_value::T, longhands::_moz_user_select::computed_value::T),
            
            /// -moz-window-dragging
            MozWindowDragging(longhands::_moz_window_dragging::computed_value::T, longhands::_moz_window_dragging::computed_value::T),
            
            /// -moz-window-shadow
            MozWindowShadow(longhands::_moz_window_shadow::computed_value::T, longhands::_moz_window_shadow::computed_value::T),
            
            /// object-fit
            ObjectFit(longhands::object_fit::computed_value::T, longhands::object_fit::computed_value::T),
            
            /// outline-style
            OutlineStyle(longhands::outline_style::computed_value::T, longhands::outline_style::computed_value::T),
            
            /// overflow-anchor
            OverflowAnchor(longhands::overflow_anchor::computed_value::T, longhands::overflow_anchor::computed_value::T),
            
            /// overflow-wrap
            OverflowWrap(longhands::overflow_wrap::computed_value::T, longhands::overflow_wrap::computed_value::T),
            
            /// paint-order
            PaintOrder(longhands::paint_order::computed_value::T, longhands::paint_order::computed_value::T),
            
            /// pointer-events
            PointerEvents(longhands::pointer_events::computed_value::T, longhands::pointer_events::computed_value::T),
            
            /// position
            Position(longhands::position::computed_value::T, longhands::position::computed_value::T),
            
            /// resize
            Resize(longhands::resize::computed_value::T, longhands::resize::computed_value::T),
            
            /// ruby-align
            RubyAlign(longhands::ruby_align::computed_value::T, longhands::ruby_align::computed_value::T),
            
            /// ruby-position
            RubyPosition(longhands::ruby_position::computed_value::T, longhands::ruby_position::computed_value::T),
            
            /// scroll-behavior
            ScrollBehavior(longhands::scroll_behavior::computed_value::T, longhands::scroll_behavior::computed_value::T),
            
            /// scroll-snap-align
            ScrollSnapAlign(longhands::scroll_snap_align::computed_value::T, longhands::scroll_snap_align::computed_value::T),
            
            /// scroll-snap-type
            ScrollSnapType(longhands::scroll_snap_type::computed_value::T, longhands::scroll_snap_type::computed_value::T),
            
            /// scrollbar-width
            ScrollbarWidth(longhands::scrollbar_width::computed_value::T, longhands::scrollbar_width::computed_value::T),
            
            /// shape-rendering
            ShapeRendering(longhands::shape_rendering::computed_value::T, longhands::shape_rendering::computed_value::T),
            
            /// stroke-linecap
            StrokeLinecap(longhands::stroke_linecap::computed_value::T, longhands::stroke_linecap::computed_value::T),
            
            /// stroke-linejoin
            StrokeLinejoin(longhands::stroke_linejoin::computed_value::T, longhands::stroke_linejoin::computed_value::T),
            
            /// table-layout
            TableLayout(longhands::table_layout::computed_value::T, longhands::table_layout::computed_value::T),
            
            /// text-align
            TextAlign(longhands::text_align::computed_value::T, longhands::text_align::computed_value::T),
            
            /// text-align-last
            TextAlignLast(longhands::text_align_last::computed_value::T, longhands::text_align_last::computed_value::T),
            
            /// text-anchor
            TextAnchor(longhands::text_anchor::computed_value::T, longhands::text_anchor::computed_value::T),
            
            /// text-combine-upright
            TextCombineUpright(longhands::text_combine_upright::computed_value::T, longhands::text_combine_upright::computed_value::T),
            
            /// text-decoration-line
            TextDecorationLine(longhands::text_decoration_line::computed_value::T, longhands::text_decoration_line::computed_value::T),
            
            /// text-decoration-style
            TextDecorationStyle(longhands::text_decoration_style::computed_value::T, longhands::text_decoration_style::computed_value::T),
            
            /// text-emphasis-position
            TextEmphasisPosition(longhands::text_emphasis_position::computed_value::T, longhands::text_emphasis_position::computed_value::T),
            
            /// text-justify
            TextJustify(longhands::text_justify::computed_value::T, longhands::text_justify::computed_value::T),
            
            /// text-rendering
            TextRendering(longhands::text_rendering::computed_value::T, longhands::text_rendering::computed_value::T),
            
            /// text-transform
            TextTransform(longhands::text_transform::computed_value::T, longhands::text_transform::computed_value::T),
            
            /// touch-action
            TouchAction(longhands::touch_action::computed_value::T, longhands::touch_action::computed_value::T),
            
            /// transform-box
            TransformBox(longhands::transform_box::computed_value::T, longhands::transform_box::computed_value::T),
            
            /// transform-style
            TransformStyle(longhands::transform_style::computed_value::T, longhands::transform_style::computed_value::T),
            
            /// vector-effect
            VectorEffect(longhands::vector_effect::computed_value::T, longhands::vector_effect::computed_value::T),
            
            /// visibility
            Visibility(longhands::visibility::computed_value::T, longhands::visibility::computed_value::T),
            
            /// -webkit-line-clamp
            WebkitLineClamp(<longhands::_webkit_line_clamp::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::_webkit_line_clamp::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// white-space
            WhiteSpace(longhands::white_space::computed_value::T, longhands::white_space::computed_value::T),
            
            /// word-break
            WordBreak(longhands::word_break::computed_value::T, longhands::word_break::computed_value::T),
            
            /// z-index
            ZIndex(longhands::z_index::computed_value::T, longhands::z_index::computed_value::T),
            
            /// break-after
            BreakAfter(longhands::break_after::computed_value::T, longhands::break_after::computed_value::T),
            
            /// break-before
            BreakBefore(longhands::break_before::computed_value::T, longhands::break_before::computed_value::T),
            
            /// clip-rule
            ClipRule(longhands::clip_rule::computed_value::T, longhands::clip_rule::computed_value::T),
            
            /// fill-rule
            FillRule(longhands::fill_rule::computed_value::T, longhands::fill_rule::computed_value::T),
            
            /// -moz-box-ordinal-group
            MozBoxOrdinalGroup(longhands::_moz_box_ordinal_group::computed_value::T, longhands::_moz_box_ordinal_group::computed_value::T),
            
            /// order
            Order(longhands::order::computed_value::T, longhands::order::computed_value::T),
            
            /// overflow-x
            OverflowX(longhands::overflow_x::computed_value::T, longhands::overflow_x::computed_value::T),
            
            /// overflow-y
            OverflowY(longhands::overflow_y::computed_value::T, longhands::overflow_y::computed_value::T),
            
            /// overflow-clip-box-block
            OverflowClipBoxBlock(longhands::overflow_clip_box_block::computed_value::T, longhands::overflow_clip_box_block::computed_value::T),
            
            /// overflow-clip-box-inline
            OverflowClipBoxInline(longhands::overflow_clip_box_inline::computed_value::T, longhands::overflow_clip_box_inline::computed_value::T),
            
            /// overscroll-behavior-x
            OverscrollBehaviorX(longhands::overscroll_behavior_x::computed_value::T, longhands::overscroll_behavior_x::computed_value::T),
            
            /// overscroll-behavior-y
            OverscrollBehaviorY(longhands::overscroll_behavior_y::computed_value::T, longhands::overscroll_behavior_y::computed_value::T),
            
            /// fill-opacity
            FillOpacity(longhands::fill_opacity::computed_value::T, longhands::fill_opacity::computed_value::T),
            
            /// stroke-opacity
            StrokeOpacity(longhands::stroke_opacity::computed_value::T, longhands::stroke_opacity::computed_value::T),
            
            /// flex-grow
            FlexGrow(<longhands::flex_grow::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::flex_grow::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// flex-shrink
            FlexShrink(<longhands::flex_shrink::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::flex_shrink::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// -moz-box-flex
            MozBoxFlex(<longhands::_moz_box_flex::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::_moz_box_flex::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// stroke-miterlimit
            StrokeMiterlimit(<longhands::stroke_miterlimit::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::stroke_miterlimit::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// flood-opacity
            FloodOpacity(longhands::flood_opacity::computed_value::T, longhands::flood_opacity::computed_value::T),
            
            /// -moz-window-opacity
            MozWindowOpacity(longhands::_moz_window_opacity::computed_value::T, longhands::_moz_window_opacity::computed_value::T),
            
            /// opacity
            Opacity(longhands::opacity::computed_value::T, longhands::opacity::computed_value::T),
            
            /// shape-image-threshold
            ShapeImageThreshold(longhands::shape_image_threshold::computed_value::T, longhands::shape_image_threshold::computed_value::T),
            
            /// stop-opacity
            StopOpacity(longhands::stop_opacity::computed_value::T, longhands::stop_opacity::computed_value::T),
            
            /// border-bottom-style
            BorderBottomStyle(longhands::border_bottom_style::computed_value::T, longhands::border_bottom_style::computed_value::T),
            
            /// border-left-style
            BorderLeftStyle(longhands::border_left_style::computed_value::T, longhands::border_left_style::computed_value::T),
            
            /// border-right-style
            BorderRightStyle(longhands::border_right_style::computed_value::T, longhands::border_right_style::computed_value::T),
            
            /// border-top-style
            BorderTopStyle(longhands::border_top_style::computed_value::T, longhands::border_top_style::computed_value::T),
            
            /// column-rule-style
            ColumnRuleStyle(longhands::column_rule_style::computed_value::T, longhands::column_rule_style::computed_value::T),
            
            /// background-attachment
            BackgroundAttachment(longhands::background_attachment::computed_value::T, longhands::background_attachment::computed_value::T),
            
            /// background-blend-mode
            BackgroundBlendMode(longhands::background_blend_mode::computed_value::T, longhands::background_blend_mode::computed_value::T),
            
            /// background-clip
            BackgroundClip(longhands::background_clip::computed_value::T, longhands::background_clip::computed_value::T),
            
            /// background-image
            BackgroundImage(longhands::background_image::computed_value::T, longhands::background_image::computed_value::T),
            
            /// background-origin
            BackgroundOrigin(longhands::background_origin::computed_value::T, longhands::background_origin::computed_value::T),
            
            /// background-position-x
            BackgroundPositionX(longhands::background_position_x::computed_value::T, longhands::background_position_x::computed_value::T),
            
            /// background-position-y
            BackgroundPositionY(longhands::background_position_y::computed_value::T, longhands::background_position_y::computed_value::T),
            
            /// background-repeat
            BackgroundRepeat(longhands::background_repeat::computed_value::T, longhands::background_repeat::computed_value::T),
            
            /// background-size
            BackgroundSize(<longhands::background_size::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::background_size::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// border-image-outset
            BorderImageOutset(longhands::border_image_outset::computed_value::T, longhands::border_image_outset::computed_value::T),
            
            /// border-image-slice
            BorderImageSlice(longhands::border_image_slice::computed_value::T, longhands::border_image_slice::computed_value::T),
            
            /// border-image-source
            BorderImageSource(longhands::border_image_source::computed_value::T, longhands::border_image_source::computed_value::T),
            
            /// border-image-width
            BorderImageWidth(longhands::border_image_width::computed_value::T, longhands::border_image_width::computed_value::T),
            
            /// border-spacing
            BorderSpacing(<longhands::border_spacing::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::border_spacing::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// box-shadow
            BoxShadow(<longhands::box_shadow::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::box_shadow::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// caret-color
            CaretColor(<longhands::caret_color::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::caret_color::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// clip-path
            ClipPath(<longhands::clip_path::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::clip_path::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// color
            Color(<longhands::color::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::color::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// column-width
            ColumnWidth(<longhands::column_width::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::column_width::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// content
            Content(longhands::content::computed_value::T, longhands::content::computed_value::T),
            
            /// counter-increment
            CounterIncrement(longhands::counter_increment::computed_value::T, longhands::counter_increment::computed_value::T),
            
            /// cursor
            Cursor(longhands::cursor::computed_value::T, longhands::cursor::computed_value::T),
            
            /// filter
            Filter(<longhands::filter::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::filter::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// flex-basis
            FlexBasis(<longhands::flex_basis::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::flex_basis::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// font-family
            FontFamily(longhands::font_family::computed_value::T, longhands::font_family::computed_value::T),
            
            /// font-feature-settings
            FontFeatureSettings(longhands::font_feature_settings::computed_value::T, longhands::font_feature_settings::computed_value::T),
            
            /// font-language-override
            FontLanguageOverride(longhands::font_language_override::computed_value::T, longhands::font_language_override::computed_value::T),
            
            /// font-size
            FontSize(<longhands::font_size::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::font_size::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// font-variant-alternates
            FontVariantAlternates(longhands::font_variant_alternates::computed_value::T, longhands::font_variant_alternates::computed_value::T),
            
            /// font-variation-settings
            FontVariationSettings(longhands::font_variation_settings::computed_value::T, longhands::font_variation_settings::computed_value::T),
            
            /// grid-template-areas
            GridTemplateAreas(longhands::grid_template_areas::computed_value::T, longhands::grid_template_areas::computed_value::T),
            
            /// letter-spacing
            LetterSpacing(longhands::letter_spacing::computed_value::T, longhands::letter_spacing::computed_value::T),
            
            /// line-height
            LineHeight(<longhands::line_height::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::line_height::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// list-style-image
            ListStyleImage(longhands::list_style_image::computed_value::T, longhands::list_style_image::computed_value::T),
            
            /// list-style-type
            ListStyleType(longhands::list_style_type::computed_value::T, longhands::list_style_type::computed_value::T),
            
            /// mask-clip
            MaskClip(longhands::mask_clip::computed_value::T, longhands::mask_clip::computed_value::T),
            
            /// mask-composite
            MaskComposite(longhands::mask_composite::computed_value::T, longhands::mask_composite::computed_value::T),
            
            /// mask-image
            MaskImage(longhands::mask_image::computed_value::T, longhands::mask_image::computed_value::T),
            
            /// mask-mode
            MaskMode(longhands::mask_mode::computed_value::T, longhands::mask_mode::computed_value::T),
            
            /// mask-origin
            MaskOrigin(longhands::mask_origin::computed_value::T, longhands::mask_origin::computed_value::T),
            
            /// mask-position-x
            MaskPositionX(longhands::mask_position_x::computed_value::T, longhands::mask_position_x::computed_value::T),
            
            /// mask-position-y
            MaskPositionY(longhands::mask_position_y::computed_value::T, longhands::mask_position_y::computed_value::T),
            
            /// mask-repeat
            MaskRepeat(longhands::mask_repeat::computed_value::T, longhands::mask_repeat::computed_value::T),
            
            /// mask-size
            MaskSize(<longhands::mask_size::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::mask_size::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// -moz-tab-size
            MozTabSize(<longhands::_moz_tab_size::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::_moz_tab_size::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// offset-path
            OffsetPath(longhands::offset_path::computed_value::T, longhands::offset_path::computed_value::T),
            
            /// perspective
            Perspective(<longhands::perspective::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::perspective::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// quotes
            Quotes(longhands::quotes::computed_value::T, longhands::quotes::computed_value::T),
            
            /// rotate
            Rotate(longhands::rotate::computed_value::T, longhands::rotate::computed_value::T),
            
            /// scale
            Scale(longhands::scale::computed_value::T, longhands::scale::computed_value::T),
            
            /// scroll-snap-coordinate
            ScrollSnapCoordinate(longhands::scroll_snap_coordinate::computed_value::T, longhands::scroll_snap_coordinate::computed_value::T),
            
            /// scrollbar-color
            ScrollbarColor(<longhands::scrollbar_color::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::scrollbar_color::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// shape-outside
            ShapeOutside(<longhands::shape_outside::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::shape_outside::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// stroke-dasharray
            StrokeDasharray(<longhands::stroke_dasharray::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::stroke_dasharray::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// stroke-dashoffset
            StrokeDashoffset(longhands::stroke_dashoffset::computed_value::T, longhands::stroke_dashoffset::computed_value::T),
            
            /// stroke-width
            StrokeWidth(<longhands::stroke_width::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::stroke_width::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// text-emphasis-style
            TextEmphasisStyle(longhands::text_emphasis_style::computed_value::T, longhands::text_emphasis_style::computed_value::T),
            
            /// text-indent
            TextIndent(longhands::text_indent::computed_value::T, longhands::text_indent::computed_value::T),
            
            /// text-overflow
            TextOverflow(longhands::text_overflow::computed_value::T, longhands::text_overflow::computed_value::T),
            
            /// text-shadow
            TextShadow(<longhands::text_shadow::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::text_shadow::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// translate
            Translate(longhands::translate::computed_value::T, longhands::translate::computed_value::T),
            
            /// vertical-align
            VerticalAlign(longhands::vertical_align::computed_value::T, longhands::vertical_align::computed_value::T),
            
            /// word-spacing
            WordSpacing(longhands::word_spacing::computed_value::T, longhands::word_spacing::computed_value::T),
            
            /// clip
            Clip(longhands::clip::computed_value::T, longhands::clip::computed_value::T),
            
            /// -moz-image-region
            MozImageRegion(longhands::_moz_image_region::computed_value::T, longhands::_moz_image_region::computed_value::T),
            
            /// grid-template-columns
            GridTemplateColumns(longhands::grid_template_columns::computed_value::T, longhands::grid_template_columns::computed_value::T),
            
            /// grid-template-rows
            GridTemplateRows(longhands::grid_template_rows::computed_value::T, longhands::grid_template_rows::computed_value::T),
            
            /// fill
            Fill(<longhands::fill::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::fill::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// stroke
            Stroke(<longhands::stroke::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::stroke::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// grid-auto-columns
            GridAutoColumns(longhands::grid_auto_columns::computed_value::T, longhands::grid_auto_columns::computed_value::T),
            
            /// grid-auto-rows
            GridAutoRows(longhands::grid_auto_rows::computed_value::T, longhands::grid_auto_rows::computed_value::T),
            
            /// -moz-window-transform-origin
            MozWindowTransformOrigin(longhands::_moz_window_transform_origin::computed_value::T, longhands::_moz_window_transform_origin::computed_value::T),
            
            /// transform-origin
            TransformOrigin(longhands::transform_origin::computed_value::T, longhands::transform_origin::computed_value::T),
            
            /// counter-reset
            CounterReset(longhands::counter_reset::computed_value::T, longhands::counter_reset::computed_value::T),
            
            /// counter-set
            CounterSet(longhands::counter_set::computed_value::T, longhands::counter_set::computed_value::T),
            
            /// scroll-snap-points-x
            ScrollSnapPointsX(longhands::scroll_snap_points_x::computed_value::T, longhands::scroll_snap_points_x::computed_value::T),
            
            /// scroll-snap-points-y
            ScrollSnapPointsY(longhands::scroll_snap_points_y::computed_value::T, longhands::scroll_snap_points_y::computed_value::T),
            
            /// -moz-window-transform
            MozWindowTransform(longhands::_moz_window_transform::computed_value::T, longhands::_moz_window_transform::computed_value::T),
            
            /// transform
            Transform(longhands::transform::computed_value::T, longhands::transform::computed_value::T),
            
            /// column-gap
            ColumnGap(<longhands::column_gap::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::column_gap::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// row-gap
            RowGap(<longhands::row_gap::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::row_gap::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// object-position
            ObjectPosition(longhands::object_position::computed_value::T, longhands::object_position::computed_value::T),
            
            /// perspective-origin
            PerspectiveOrigin(longhands::perspective_origin::computed_value::T, longhands::perspective_origin::computed_value::T),
            
            /// scroll-snap-destination
            ScrollSnapDestination(longhands::scroll_snap_destination::computed_value::T, longhands::scroll_snap_destination::computed_value::T),
            
            /// grid-column-end
            GridColumnEnd(longhands::grid_column_end::computed_value::T, longhands::grid_column_end::computed_value::T),
            
            /// grid-column-start
            GridColumnStart(longhands::grid_column_start::computed_value::T, longhands::grid_column_start::computed_value::T),
            
            /// grid-row-end
            GridRowEnd(longhands::grid_row_end::computed_value::T, longhands::grid_row_end::computed_value::T),
            
            /// grid-row-start
            GridRowStart(longhands::grid_row_start::computed_value::T, longhands::grid_row_start::computed_value::T),
            
            /// max-height
            MaxHeight(<longhands::max_height::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::max_height::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// max-width
            MaxWidth(<longhands::max_width::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::max_width::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// marker-end
            MarkerEnd(longhands::marker_end::computed_value::T, longhands::marker_end::computed_value::T),
            
            /// marker-mid
            MarkerMid(longhands::marker_mid::computed_value::T, longhands::marker_mid::computed_value::T),
            
            /// marker-start
            MarkerStart(longhands::marker_start::computed_value::T, longhands::marker_start::computed_value::T),
            
            /// scroll-padding-bottom
            ScrollPaddingBottom(<longhands::scroll_padding_bottom::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::scroll_padding_bottom::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// scroll-padding-left
            ScrollPaddingLeft(<longhands::scroll_padding_left::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::scroll_padding_left::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// scroll-padding-right
            ScrollPaddingRight(<longhands::scroll_padding_right::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::scroll_padding_right::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// scroll-padding-top
            ScrollPaddingTop(<longhands::scroll_padding_top::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::scroll_padding_top::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// height
            Height(<longhands::height::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::height::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// min-height
            MinHeight(<longhands::min_height::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::min_height::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// min-width
            MinWidth(<longhands::min_width::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::min_width::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// width
            Width(<longhands::width::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::width::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// outline-offset
            OutlineOffset(longhands::outline_offset::computed_value::T, longhands::outline_offset::computed_value::T),
            
            /// scroll-margin-bottom
            ScrollMarginBottom(longhands::scroll_margin_bottom::computed_value::T, longhands::scroll_margin_bottom::computed_value::T),
            
            /// scroll-margin-left
            ScrollMarginLeft(longhands::scroll_margin_left::computed_value::T, longhands::scroll_margin_left::computed_value::T),
            
            /// scroll-margin-right
            ScrollMarginRight(longhands::scroll_margin_right::computed_value::T, longhands::scroll_margin_right::computed_value::T),
            
            /// scroll-margin-top
            ScrollMarginTop(longhands::scroll_margin_top::computed_value::T, longhands::scroll_margin_top::computed_value::T),
            
            /// padding-bottom
            PaddingBottom(<longhands::padding_bottom::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::padding_bottom::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// padding-left
            PaddingLeft(<longhands::padding_left::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::padding_left::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// padding-right
            PaddingRight(<longhands::padding_right::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::padding_right::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// padding-top
            PaddingTop(<longhands::padding_top::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::padding_top::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// shape-margin
            ShapeMargin(<longhands::shape_margin::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::shape_margin::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// border-bottom-width
            BorderBottomWidth(<longhands::border_bottom_width::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::border_bottom_width::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// border-left-width
            BorderLeftWidth(<longhands::border_left_width::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::border_left_width::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// border-right-width
            BorderRightWidth(<longhands::border_right_width::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::border_right_width::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// border-top-width
            BorderTopWidth(<longhands::border_top_width::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::border_top_width::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// column-rule-width
            ColumnRuleWidth(<longhands::column_rule_width::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::column_rule_width::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// outline-width
            OutlineWidth(<longhands::outline_width::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::outline_width::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// -webkit-text-stroke-width
            WebkitTextStrokeWidth(longhands::_webkit_text_stroke_width::computed_value::T, longhands::_webkit_text_stroke_width::computed_value::T),
            
            /// border-bottom-left-radius
            BorderBottomLeftRadius(<longhands::border_bottom_left_radius::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::border_bottom_left_radius::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// border-bottom-right-radius
            BorderBottomRightRadius(<longhands::border_bottom_right_radius::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::border_bottom_right_radius::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// border-top-left-radius
            BorderTopLeftRadius(<longhands::border_top_left_radius::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::border_top_left_radius::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// border-top-right-radius
            BorderTopRightRadius(<longhands::border_top_right_radius::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::border_top_right_radius::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// -moz-outline-radius-bottomleft
            MozOutlineRadiusBottomleft(<longhands::_moz_outline_radius_bottomleft::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::_moz_outline_radius_bottomleft::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// -moz-outline-radius-bottomright
            MozOutlineRadiusBottomright(<longhands::_moz_outline_radius_bottomright::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::_moz_outline_radius_bottomright::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// -moz-outline-radius-topleft
            MozOutlineRadiusTopleft(<longhands::_moz_outline_radius_topleft::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::_moz_outline_radius_topleft::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// -moz-outline-radius-topright
            MozOutlineRadiusTopright(<longhands::_moz_outline_radius_topright::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::_moz_outline_radius_topright::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// bottom
            Bottom(longhands::bottom::computed_value::T, longhands::bottom::computed_value::T),
            
            /// left
            Left(longhands::left::computed_value::T, longhands::left::computed_value::T),
            
            /// margin-bottom
            MarginBottom(longhands::margin_bottom::computed_value::T, longhands::margin_bottom::computed_value::T),
            
            /// margin-left
            MarginLeft(longhands::margin_left::computed_value::T, longhands::margin_left::computed_value::T),
            
            /// margin-right
            MarginRight(longhands::margin_right::computed_value::T, longhands::margin_right::computed_value::T),
            
            /// margin-top
            MarginTop(longhands::margin_top::computed_value::T, longhands::margin_top::computed_value::T),
            
            /// right
            Right(longhands::right::computed_value::T, longhands::right::computed_value::T),
            
            /// top
            Top(longhands::top::computed_value::T, longhands::top::computed_value::T),
            
            /// background-color
            BackgroundColor(<longhands::background_color::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::background_color::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// border-bottom-color
            BorderBottomColor(<longhands::border_bottom_color::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::border_bottom_color::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// border-left-color
            BorderLeftColor(<longhands::border_left_color::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::border_left_color::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// border-right-color
            BorderRightColor(<longhands::border_right_color::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::border_right_color::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// border-top-color
            BorderTopColor(<longhands::border_top_color::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::border_top_color::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// column-rule-color
            ColumnRuleColor(<longhands::column_rule_color::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::column_rule_color::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// flood-color
            FloodColor(<longhands::flood_color::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::flood_color::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// lighting-color
            LightingColor(<longhands::lighting_color::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::lighting_color::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// outline-color
            OutlineColor(<longhands::outline_color::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::outline_color::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// stop-color
            StopColor(<longhands::stop_color::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::stop_color::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// text-decoration-color
            TextDecorationColor(<longhands::text_decoration_color::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::text_decoration_color::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// text-emphasis-color
            TextEmphasisColor(<longhands::text_emphasis_color::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::text_emphasis_color::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// -webkit-text-fill-color
            WebkitTextFillColor(<longhands::_webkit_text_fill_color::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::_webkit_text_fill_color::computed_value::T as ToAnimatedValue>::AnimatedValue),
            
            /// -webkit-text-stroke-color
            WebkitTextStrokeColor(<longhands::_webkit_text_stroke_color::computed_value::T as ToAnimatedValue>::AnimatedValue, <longhands::_webkit_text_stroke_color::computed_value::T as ToAnimatedValue>::AnimatedValue),
}

impl AnimatedProperty {
    /// Get the id of the property we're animating.
    pub fn id(&self) -> LonghandId {
        match *self {
            AnimatedProperty::AlignContent(..) => LonghandId::AlignContent,
            AnimatedProperty::AlignItems(..) => LonghandId::AlignItems,
            AnimatedProperty::AlignSelf(..) => LonghandId::AlignSelf,
            AnimatedProperty::BackfaceVisibility(..) => LonghandId::BackfaceVisibility,
            AnimatedProperty::BorderCollapse(..) => LonghandId::BorderCollapse,
            AnimatedProperty::BorderImageRepeat(..) => LonghandId::BorderImageRepeat,
            AnimatedProperty::BoxDecorationBreak(..) => LonghandId::BoxDecorationBreak,
            AnimatedProperty::BoxSizing(..) => LonghandId::BoxSizing,
            AnimatedProperty::BreakInside(..) => LonghandId::BreakInside,
            AnimatedProperty::CaptionSide(..) => LonghandId::CaptionSide,
            AnimatedProperty::Clear(..) => LonghandId::Clear,
            AnimatedProperty::ColorAdjust(..) => LonghandId::ColorAdjust,
            AnimatedProperty::ColorInterpolation(..) => LonghandId::ColorInterpolation,
            AnimatedProperty::ColorInterpolationFilters(..) => LonghandId::ColorInterpolationFilters,
            AnimatedProperty::ColumnCount(..) => LonghandId::ColumnCount,
            AnimatedProperty::ColumnFill(..) => LonghandId::ColumnFill,
            AnimatedProperty::ColumnSpan(..) => LonghandId::ColumnSpan,
            AnimatedProperty::Display(..) => LonghandId::Display,
            AnimatedProperty::DominantBaseline(..) => LonghandId::DominantBaseline,
            AnimatedProperty::EmptyCells(..) => LonghandId::EmptyCells,
            AnimatedProperty::FlexDirection(..) => LonghandId::FlexDirection,
            AnimatedProperty::FlexWrap(..) => LonghandId::FlexWrap,
            AnimatedProperty::Float(..) => LonghandId::Float,
            AnimatedProperty::FontKerning(..) => LonghandId::FontKerning,
            AnimatedProperty::FontOpticalSizing(..) => LonghandId::FontOpticalSizing,
            AnimatedProperty::FontSizeAdjust(..) => LonghandId::FontSizeAdjust,
            AnimatedProperty::FontStretch(..) => LonghandId::FontStretch,
            AnimatedProperty::FontStyle(..) => LonghandId::FontStyle,
            AnimatedProperty::FontSynthesis(..) => LonghandId::FontSynthesis,
            AnimatedProperty::FontVariantCaps(..) => LonghandId::FontVariantCaps,
            AnimatedProperty::FontVariantEastAsian(..) => LonghandId::FontVariantEastAsian,
            AnimatedProperty::FontVariantLigatures(..) => LonghandId::FontVariantLigatures,
            AnimatedProperty::FontVariantNumeric(..) => LonghandId::FontVariantNumeric,
            AnimatedProperty::FontVariantPosition(..) => LonghandId::FontVariantPosition,
            AnimatedProperty::FontWeight(..) => LonghandId::FontWeight,
            AnimatedProperty::GridAutoFlow(..) => LonghandId::GridAutoFlow,
            AnimatedProperty::Hyphens(..) => LonghandId::Hyphens,
            AnimatedProperty::ImageOrientation(..) => LonghandId::ImageOrientation,
            AnimatedProperty::ImageRendering(..) => LonghandId::ImageRendering,
            AnimatedProperty::ImeMode(..) => LonghandId::ImeMode,
            AnimatedProperty::InitialLetter(..) => LonghandId::InitialLetter,
            AnimatedProperty::Isolation(..) => LonghandId::Isolation,
            AnimatedProperty::JustifyContent(..) => LonghandId::JustifyContent,
            AnimatedProperty::JustifyItems(..) => LonghandId::JustifyItems,
            AnimatedProperty::JustifySelf(..) => LonghandId::JustifySelf,
            AnimatedProperty::ListStylePosition(..) => LonghandId::ListStylePosition,
            AnimatedProperty::MaskType(..) => LonghandId::MaskType,
            AnimatedProperty::MixBlendMode(..) => LonghandId::MixBlendMode,
            AnimatedProperty::MozAppearance(..) => LonghandId::MozAppearance,
            AnimatedProperty::MozBoxAlign(..) => LonghandId::MozBoxAlign,
            AnimatedProperty::MozBoxDirection(..) => LonghandId::MozBoxDirection,
            AnimatedProperty::MozBoxOrient(..) => LonghandId::MozBoxOrient,
            AnimatedProperty::MozBoxPack(..) => LonghandId::MozBoxPack,
            AnimatedProperty::MozFloatEdge(..) => LonghandId::MozFloatEdge,
            AnimatedProperty::MozForceBrokenImageIcon(..) => LonghandId::MozForceBrokenImageIcon,
            AnimatedProperty::MozListReversed(..) => LonghandId::MozListReversed,
            AnimatedProperty::MozOrient(..) => LonghandId::MozOrient,
            AnimatedProperty::MozOsxFontSmoothing(..) => LonghandId::MozOsxFontSmoothing,
            AnimatedProperty::MozStackSizing(..) => LonghandId::MozStackSizing,
            AnimatedProperty::MozTextSizeAdjust(..) => LonghandId::MozTextSizeAdjust,
            AnimatedProperty::MozUserFocus(..) => LonghandId::MozUserFocus,
            AnimatedProperty::MozUserInput(..) => LonghandId::MozUserInput,
            AnimatedProperty::MozUserModify(..) => LonghandId::MozUserModify,
            AnimatedProperty::MozUserSelect(..) => LonghandId::MozUserSelect,
            AnimatedProperty::MozWindowDragging(..) => LonghandId::MozWindowDragging,
            AnimatedProperty::MozWindowShadow(..) => LonghandId::MozWindowShadow,
            AnimatedProperty::ObjectFit(..) => LonghandId::ObjectFit,
            AnimatedProperty::OutlineStyle(..) => LonghandId::OutlineStyle,
            AnimatedProperty::OverflowAnchor(..) => LonghandId::OverflowAnchor,
            AnimatedProperty::OverflowWrap(..) => LonghandId::OverflowWrap,
            AnimatedProperty::PaintOrder(..) => LonghandId::PaintOrder,
            AnimatedProperty::PointerEvents(..) => LonghandId::PointerEvents,
            AnimatedProperty::Position(..) => LonghandId::Position,
            AnimatedProperty::Resize(..) => LonghandId::Resize,
            AnimatedProperty::RubyAlign(..) => LonghandId::RubyAlign,
            AnimatedProperty::RubyPosition(..) => LonghandId::RubyPosition,
            AnimatedProperty::ScrollBehavior(..) => LonghandId::ScrollBehavior,
            AnimatedProperty::ScrollSnapAlign(..) => LonghandId::ScrollSnapAlign,
            AnimatedProperty::ScrollSnapType(..) => LonghandId::ScrollSnapType,
            AnimatedProperty::ScrollbarWidth(..) => LonghandId::ScrollbarWidth,
            AnimatedProperty::ShapeRendering(..) => LonghandId::ShapeRendering,
            AnimatedProperty::StrokeLinecap(..) => LonghandId::StrokeLinecap,
            AnimatedProperty::StrokeLinejoin(..) => LonghandId::StrokeLinejoin,
            AnimatedProperty::TableLayout(..) => LonghandId::TableLayout,
            AnimatedProperty::TextAlign(..) => LonghandId::TextAlign,
            AnimatedProperty::TextAlignLast(..) => LonghandId::TextAlignLast,
            AnimatedProperty::TextAnchor(..) => LonghandId::TextAnchor,
            AnimatedProperty::TextCombineUpright(..) => LonghandId::TextCombineUpright,
            AnimatedProperty::TextDecorationLine(..) => LonghandId::TextDecorationLine,
            AnimatedProperty::TextDecorationStyle(..) => LonghandId::TextDecorationStyle,
            AnimatedProperty::TextEmphasisPosition(..) => LonghandId::TextEmphasisPosition,
            AnimatedProperty::TextJustify(..) => LonghandId::TextJustify,
            AnimatedProperty::TextRendering(..) => LonghandId::TextRendering,
            AnimatedProperty::TextTransform(..) => LonghandId::TextTransform,
            AnimatedProperty::TouchAction(..) => LonghandId::TouchAction,
            AnimatedProperty::TransformBox(..) => LonghandId::TransformBox,
            AnimatedProperty::TransformStyle(..) => LonghandId::TransformStyle,
            AnimatedProperty::VectorEffect(..) => LonghandId::VectorEffect,
            AnimatedProperty::Visibility(..) => LonghandId::Visibility,
            AnimatedProperty::WebkitLineClamp(..) => LonghandId::WebkitLineClamp,
            AnimatedProperty::WhiteSpace(..) => LonghandId::WhiteSpace,
            AnimatedProperty::WordBreak(..) => LonghandId::WordBreak,
            AnimatedProperty::ZIndex(..) => LonghandId::ZIndex,
            AnimatedProperty::BreakAfter(..) => LonghandId::BreakAfter,
            AnimatedProperty::BreakBefore(..) => LonghandId::BreakBefore,
            AnimatedProperty::ClipRule(..) => LonghandId::ClipRule,
            AnimatedProperty::FillRule(..) => LonghandId::FillRule,
            AnimatedProperty::MozBoxOrdinalGroup(..) => LonghandId::MozBoxOrdinalGroup,
            AnimatedProperty::Order(..) => LonghandId::Order,
            AnimatedProperty::OverflowX(..) => LonghandId::OverflowX,
            AnimatedProperty::OverflowY(..) => LonghandId::OverflowY,
            AnimatedProperty::OverflowClipBoxBlock(..) => LonghandId::OverflowClipBoxBlock,
            AnimatedProperty::OverflowClipBoxInline(..) => LonghandId::OverflowClipBoxInline,
            AnimatedProperty::OverscrollBehaviorX(..) => LonghandId::OverscrollBehaviorX,
            AnimatedProperty::OverscrollBehaviorY(..) => LonghandId::OverscrollBehaviorY,
            AnimatedProperty::FillOpacity(..) => LonghandId::FillOpacity,
            AnimatedProperty::StrokeOpacity(..) => LonghandId::StrokeOpacity,
            AnimatedProperty::FlexGrow(..) => LonghandId::FlexGrow,
            AnimatedProperty::FlexShrink(..) => LonghandId::FlexShrink,
            AnimatedProperty::MozBoxFlex(..) => LonghandId::MozBoxFlex,
            AnimatedProperty::StrokeMiterlimit(..) => LonghandId::StrokeMiterlimit,
            AnimatedProperty::FloodOpacity(..) => LonghandId::FloodOpacity,
            AnimatedProperty::MozWindowOpacity(..) => LonghandId::MozWindowOpacity,
            AnimatedProperty::Opacity(..) => LonghandId::Opacity,
            AnimatedProperty::ShapeImageThreshold(..) => LonghandId::ShapeImageThreshold,
            AnimatedProperty::StopOpacity(..) => LonghandId::StopOpacity,
            AnimatedProperty::BorderBottomStyle(..) => LonghandId::BorderBottomStyle,
            AnimatedProperty::BorderLeftStyle(..) => LonghandId::BorderLeftStyle,
            AnimatedProperty::BorderRightStyle(..) => LonghandId::BorderRightStyle,
            AnimatedProperty::BorderTopStyle(..) => LonghandId::BorderTopStyle,
            AnimatedProperty::ColumnRuleStyle(..) => LonghandId::ColumnRuleStyle,
            AnimatedProperty::BackgroundAttachment(..) => LonghandId::BackgroundAttachment,
            AnimatedProperty::BackgroundBlendMode(..) => LonghandId::BackgroundBlendMode,
            AnimatedProperty::BackgroundClip(..) => LonghandId::BackgroundClip,
            AnimatedProperty::BackgroundImage(..) => LonghandId::BackgroundImage,
            AnimatedProperty::BackgroundOrigin(..) => LonghandId::BackgroundOrigin,
            AnimatedProperty::BackgroundPositionX(..) => LonghandId::BackgroundPositionX,
            AnimatedProperty::BackgroundPositionY(..) => LonghandId::BackgroundPositionY,
            AnimatedProperty::BackgroundRepeat(..) => LonghandId::BackgroundRepeat,
            AnimatedProperty::BackgroundSize(..) => LonghandId::BackgroundSize,
            AnimatedProperty::BorderImageOutset(..) => LonghandId::BorderImageOutset,
            AnimatedProperty::BorderImageSlice(..) => LonghandId::BorderImageSlice,
            AnimatedProperty::BorderImageSource(..) => LonghandId::BorderImageSource,
            AnimatedProperty::BorderImageWidth(..) => LonghandId::BorderImageWidth,
            AnimatedProperty::BorderSpacing(..) => LonghandId::BorderSpacing,
            AnimatedProperty::BoxShadow(..) => LonghandId::BoxShadow,
            AnimatedProperty::CaretColor(..) => LonghandId::CaretColor,
            AnimatedProperty::ClipPath(..) => LonghandId::ClipPath,
            AnimatedProperty::Color(..) => LonghandId::Color,
            AnimatedProperty::ColumnWidth(..) => LonghandId::ColumnWidth,
            AnimatedProperty::Content(..) => LonghandId::Content,
            AnimatedProperty::CounterIncrement(..) => LonghandId::CounterIncrement,
            AnimatedProperty::Cursor(..) => LonghandId::Cursor,
            AnimatedProperty::Filter(..) => LonghandId::Filter,
            AnimatedProperty::FlexBasis(..) => LonghandId::FlexBasis,
            AnimatedProperty::FontFamily(..) => LonghandId::FontFamily,
            AnimatedProperty::FontFeatureSettings(..) => LonghandId::FontFeatureSettings,
            AnimatedProperty::FontLanguageOverride(..) => LonghandId::FontLanguageOverride,
            AnimatedProperty::FontSize(..) => LonghandId::FontSize,
            AnimatedProperty::FontVariantAlternates(..) => LonghandId::FontVariantAlternates,
            AnimatedProperty::FontVariationSettings(..) => LonghandId::FontVariationSettings,
            AnimatedProperty::GridTemplateAreas(..) => LonghandId::GridTemplateAreas,
            AnimatedProperty::LetterSpacing(..) => LonghandId::LetterSpacing,
            AnimatedProperty::LineHeight(..) => LonghandId::LineHeight,
            AnimatedProperty::ListStyleImage(..) => LonghandId::ListStyleImage,
            AnimatedProperty::ListStyleType(..) => LonghandId::ListStyleType,
            AnimatedProperty::MaskClip(..) => LonghandId::MaskClip,
            AnimatedProperty::MaskComposite(..) => LonghandId::MaskComposite,
            AnimatedProperty::MaskImage(..) => LonghandId::MaskImage,
            AnimatedProperty::MaskMode(..) => LonghandId::MaskMode,
            AnimatedProperty::MaskOrigin(..) => LonghandId::MaskOrigin,
            AnimatedProperty::MaskPositionX(..) => LonghandId::MaskPositionX,
            AnimatedProperty::MaskPositionY(..) => LonghandId::MaskPositionY,
            AnimatedProperty::MaskRepeat(..) => LonghandId::MaskRepeat,
            AnimatedProperty::MaskSize(..) => LonghandId::MaskSize,
            AnimatedProperty::MozTabSize(..) => LonghandId::MozTabSize,
            AnimatedProperty::OffsetPath(..) => LonghandId::OffsetPath,
            AnimatedProperty::Perspective(..) => LonghandId::Perspective,
            AnimatedProperty::Quotes(..) => LonghandId::Quotes,
            AnimatedProperty::Rotate(..) => LonghandId::Rotate,
            AnimatedProperty::Scale(..) => LonghandId::Scale,
            AnimatedProperty::ScrollSnapCoordinate(..) => LonghandId::ScrollSnapCoordinate,
            AnimatedProperty::ScrollbarColor(..) => LonghandId::ScrollbarColor,
            AnimatedProperty::ShapeOutside(..) => LonghandId::ShapeOutside,
            AnimatedProperty::StrokeDasharray(..) => LonghandId::StrokeDasharray,
            AnimatedProperty::StrokeDashoffset(..) => LonghandId::StrokeDashoffset,
            AnimatedProperty::StrokeWidth(..) => LonghandId::StrokeWidth,
            AnimatedProperty::TextEmphasisStyle(..) => LonghandId::TextEmphasisStyle,
            AnimatedProperty::TextIndent(..) => LonghandId::TextIndent,
            AnimatedProperty::TextOverflow(..) => LonghandId::TextOverflow,
            AnimatedProperty::TextShadow(..) => LonghandId::TextShadow,
            AnimatedProperty::Translate(..) => LonghandId::Translate,
            AnimatedProperty::VerticalAlign(..) => LonghandId::VerticalAlign,
            AnimatedProperty::WordSpacing(..) => LonghandId::WordSpacing,
            AnimatedProperty::Clip(..) => LonghandId::Clip,
            AnimatedProperty::MozImageRegion(..) => LonghandId::MozImageRegion,
            AnimatedProperty::GridTemplateColumns(..) => LonghandId::GridTemplateColumns,
            AnimatedProperty::GridTemplateRows(..) => LonghandId::GridTemplateRows,
            AnimatedProperty::Fill(..) => LonghandId::Fill,
            AnimatedProperty::Stroke(..) => LonghandId::Stroke,
            AnimatedProperty::GridAutoColumns(..) => LonghandId::GridAutoColumns,
            AnimatedProperty::GridAutoRows(..) => LonghandId::GridAutoRows,
            AnimatedProperty::MozWindowTransformOrigin(..) => LonghandId::MozWindowTransformOrigin,
            AnimatedProperty::TransformOrigin(..) => LonghandId::TransformOrigin,
            AnimatedProperty::CounterReset(..) => LonghandId::CounterReset,
            AnimatedProperty::CounterSet(..) => LonghandId::CounterSet,
            AnimatedProperty::ScrollSnapPointsX(..) => LonghandId::ScrollSnapPointsX,
            AnimatedProperty::ScrollSnapPointsY(..) => LonghandId::ScrollSnapPointsY,
            AnimatedProperty::MozWindowTransform(..) => LonghandId::MozWindowTransform,
            AnimatedProperty::Transform(..) => LonghandId::Transform,
            AnimatedProperty::ColumnGap(..) => LonghandId::ColumnGap,
            AnimatedProperty::RowGap(..) => LonghandId::RowGap,
            AnimatedProperty::ObjectPosition(..) => LonghandId::ObjectPosition,
            AnimatedProperty::PerspectiveOrigin(..) => LonghandId::PerspectiveOrigin,
            AnimatedProperty::ScrollSnapDestination(..) => LonghandId::ScrollSnapDestination,
            AnimatedProperty::GridColumnEnd(..) => LonghandId::GridColumnEnd,
            AnimatedProperty::GridColumnStart(..) => LonghandId::GridColumnStart,
            AnimatedProperty::GridRowEnd(..) => LonghandId::GridRowEnd,
            AnimatedProperty::GridRowStart(..) => LonghandId::GridRowStart,
            AnimatedProperty::MaxHeight(..) => LonghandId::MaxHeight,
            AnimatedProperty::MaxWidth(..) => LonghandId::MaxWidth,
            AnimatedProperty::MarkerEnd(..) => LonghandId::MarkerEnd,
            AnimatedProperty::MarkerMid(..) => LonghandId::MarkerMid,
            AnimatedProperty::MarkerStart(..) => LonghandId::MarkerStart,
            AnimatedProperty::ScrollPaddingBottom(..) => LonghandId::ScrollPaddingBottom,
            AnimatedProperty::ScrollPaddingLeft(..) => LonghandId::ScrollPaddingLeft,
            AnimatedProperty::ScrollPaddingRight(..) => LonghandId::ScrollPaddingRight,
            AnimatedProperty::ScrollPaddingTop(..) => LonghandId::ScrollPaddingTop,
            AnimatedProperty::Height(..) => LonghandId::Height,
            AnimatedProperty::MinHeight(..) => LonghandId::MinHeight,
            AnimatedProperty::MinWidth(..) => LonghandId::MinWidth,
            AnimatedProperty::Width(..) => LonghandId::Width,
            AnimatedProperty::OutlineOffset(..) => LonghandId::OutlineOffset,
            AnimatedProperty::ScrollMarginBottom(..) => LonghandId::ScrollMarginBottom,
            AnimatedProperty::ScrollMarginLeft(..) => LonghandId::ScrollMarginLeft,
            AnimatedProperty::ScrollMarginRight(..) => LonghandId::ScrollMarginRight,
            AnimatedProperty::ScrollMarginTop(..) => LonghandId::ScrollMarginTop,
            AnimatedProperty::PaddingBottom(..) => LonghandId::PaddingBottom,
            AnimatedProperty::PaddingLeft(..) => LonghandId::PaddingLeft,
            AnimatedProperty::PaddingRight(..) => LonghandId::PaddingRight,
            AnimatedProperty::PaddingTop(..) => LonghandId::PaddingTop,
            AnimatedProperty::ShapeMargin(..) => LonghandId::ShapeMargin,
            AnimatedProperty::BorderBottomWidth(..) => LonghandId::BorderBottomWidth,
            AnimatedProperty::BorderLeftWidth(..) => LonghandId::BorderLeftWidth,
            AnimatedProperty::BorderRightWidth(..) => LonghandId::BorderRightWidth,
            AnimatedProperty::BorderTopWidth(..) => LonghandId::BorderTopWidth,
            AnimatedProperty::ColumnRuleWidth(..) => LonghandId::ColumnRuleWidth,
            AnimatedProperty::OutlineWidth(..) => LonghandId::OutlineWidth,
            AnimatedProperty::WebkitTextStrokeWidth(..) => LonghandId::WebkitTextStrokeWidth,
            AnimatedProperty::BorderBottomLeftRadius(..) => LonghandId::BorderBottomLeftRadius,
            AnimatedProperty::BorderBottomRightRadius(..) => LonghandId::BorderBottomRightRadius,
            AnimatedProperty::BorderTopLeftRadius(..) => LonghandId::BorderTopLeftRadius,
            AnimatedProperty::BorderTopRightRadius(..) => LonghandId::BorderTopRightRadius,
            AnimatedProperty::MozOutlineRadiusBottomleft(..) => LonghandId::MozOutlineRadiusBottomleft,
            AnimatedProperty::MozOutlineRadiusBottomright(..) => LonghandId::MozOutlineRadiusBottomright,
            AnimatedProperty::MozOutlineRadiusTopleft(..) => LonghandId::MozOutlineRadiusTopleft,
            AnimatedProperty::MozOutlineRadiusTopright(..) => LonghandId::MozOutlineRadiusTopright,
            AnimatedProperty::Bottom(..) => LonghandId::Bottom,
            AnimatedProperty::Left(..) => LonghandId::Left,
            AnimatedProperty::MarginBottom(..) => LonghandId::MarginBottom,
            AnimatedProperty::MarginLeft(..) => LonghandId::MarginLeft,
            AnimatedProperty::MarginRight(..) => LonghandId::MarginRight,
            AnimatedProperty::MarginTop(..) => LonghandId::MarginTop,
            AnimatedProperty::Right(..) => LonghandId::Right,
            AnimatedProperty::Top(..) => LonghandId::Top,
            AnimatedProperty::BackgroundColor(..) => LonghandId::BackgroundColor,
            AnimatedProperty::BorderBottomColor(..) => LonghandId::BorderBottomColor,
            AnimatedProperty::BorderLeftColor(..) => LonghandId::BorderLeftColor,
            AnimatedProperty::BorderRightColor(..) => LonghandId::BorderRightColor,
            AnimatedProperty::BorderTopColor(..) => LonghandId::BorderTopColor,
            AnimatedProperty::ColumnRuleColor(..) => LonghandId::ColumnRuleColor,
            AnimatedProperty::FloodColor(..) => LonghandId::FloodColor,
            AnimatedProperty::LightingColor(..) => LonghandId::LightingColor,
            AnimatedProperty::OutlineColor(..) => LonghandId::OutlineColor,
            AnimatedProperty::StopColor(..) => LonghandId::StopColor,
            AnimatedProperty::TextDecorationColor(..) => LonghandId::TextDecorationColor,
            AnimatedProperty::TextEmphasisColor(..) => LonghandId::TextEmphasisColor,
            AnimatedProperty::WebkitTextFillColor(..) => LonghandId::WebkitTextFillColor,
            AnimatedProperty::WebkitTextStrokeColor(..) => LonghandId::WebkitTextStrokeColor,
        }
    }

    /// Get the name of this property.
    pub fn name(&self) -> &'static str {
        self.id().name()
    }

    /// Whether this interpolation does animate, that is, whether the start and
    /// end values are different.
    pub fn does_animate(&self) -> bool {
        match *self {
                    AnimatedProperty::AlignContent(ref from, ref to) => from != to,
                    AnimatedProperty::AlignItems(ref from, ref to) => from != to,
                    AnimatedProperty::AlignSelf(ref from, ref to) => from != to,
                    AnimatedProperty::BackfaceVisibility(ref from, ref to) => from != to,
                    AnimatedProperty::BorderCollapse(ref from, ref to) => from != to,
                    AnimatedProperty::BorderImageRepeat(ref from, ref to) => from != to,
                    AnimatedProperty::BoxDecorationBreak(ref from, ref to) => from != to,
                    AnimatedProperty::BoxSizing(ref from, ref to) => from != to,
                    AnimatedProperty::BreakInside(ref from, ref to) => from != to,
                    AnimatedProperty::CaptionSide(ref from, ref to) => from != to,
                    AnimatedProperty::Clear(ref from, ref to) => from != to,
                    AnimatedProperty::ColorAdjust(ref from, ref to) => from != to,
                    AnimatedProperty::ColorInterpolation(ref from, ref to) => from != to,
                    AnimatedProperty::ColorInterpolationFilters(ref from, ref to) => from != to,
                    AnimatedProperty::ColumnCount(ref from, ref to) => from != to,
                    AnimatedProperty::ColumnFill(ref from, ref to) => from != to,
                    AnimatedProperty::ColumnSpan(ref from, ref to) => from != to,
                    AnimatedProperty::Display(ref from, ref to) => from != to,
                    AnimatedProperty::DominantBaseline(ref from, ref to) => from != to,
                    AnimatedProperty::EmptyCells(ref from, ref to) => from != to,
                    AnimatedProperty::FlexDirection(ref from, ref to) => from != to,
                    AnimatedProperty::FlexWrap(ref from, ref to) => from != to,
                    AnimatedProperty::Float(ref from, ref to) => from != to,
                    AnimatedProperty::FontKerning(ref from, ref to) => from != to,
                    AnimatedProperty::FontOpticalSizing(ref from, ref to) => from != to,
                    AnimatedProperty::FontSizeAdjust(ref from, ref to) => from != to,
                    AnimatedProperty::FontStretch(ref from, ref to) => from != to,
                    AnimatedProperty::FontStyle(ref from, ref to) => from != to,
                    AnimatedProperty::FontSynthesis(ref from, ref to) => from != to,
                    AnimatedProperty::FontVariantCaps(ref from, ref to) => from != to,
                    AnimatedProperty::FontVariantEastAsian(ref from, ref to) => from != to,
                    AnimatedProperty::FontVariantLigatures(ref from, ref to) => from != to,
                    AnimatedProperty::FontVariantNumeric(ref from, ref to) => from != to,
                    AnimatedProperty::FontVariantPosition(ref from, ref to) => from != to,
                    AnimatedProperty::FontWeight(ref from, ref to) => from != to,
                    AnimatedProperty::GridAutoFlow(ref from, ref to) => from != to,
                    AnimatedProperty::Hyphens(ref from, ref to) => from != to,
                    AnimatedProperty::ImageOrientation(ref from, ref to) => from != to,
                    AnimatedProperty::ImageRendering(ref from, ref to) => from != to,
                    AnimatedProperty::ImeMode(ref from, ref to) => from != to,
                    AnimatedProperty::InitialLetter(ref from, ref to) => from != to,
                    AnimatedProperty::Isolation(ref from, ref to) => from != to,
                    AnimatedProperty::JustifyContent(ref from, ref to) => from != to,
                    AnimatedProperty::JustifyItems(ref from, ref to) => from != to,
                    AnimatedProperty::JustifySelf(ref from, ref to) => from != to,
                    AnimatedProperty::ListStylePosition(ref from, ref to) => from != to,
                    AnimatedProperty::MaskType(ref from, ref to) => from != to,
                    AnimatedProperty::MixBlendMode(ref from, ref to) => from != to,
                    AnimatedProperty::MozAppearance(ref from, ref to) => from != to,
                    AnimatedProperty::MozBoxAlign(ref from, ref to) => from != to,
                    AnimatedProperty::MozBoxDirection(ref from, ref to) => from != to,
                    AnimatedProperty::MozBoxOrient(ref from, ref to) => from != to,
                    AnimatedProperty::MozBoxPack(ref from, ref to) => from != to,
                    AnimatedProperty::MozFloatEdge(ref from, ref to) => from != to,
                    AnimatedProperty::MozForceBrokenImageIcon(ref from, ref to) => from != to,
                    AnimatedProperty::MozListReversed(ref from, ref to) => from != to,
                    AnimatedProperty::MozOrient(ref from, ref to) => from != to,
                    AnimatedProperty::MozOsxFontSmoothing(ref from, ref to) => from != to,
                    AnimatedProperty::MozStackSizing(ref from, ref to) => from != to,
                    AnimatedProperty::MozTextSizeAdjust(ref from, ref to) => from != to,
                    AnimatedProperty::MozUserFocus(ref from, ref to) => from != to,
                    AnimatedProperty::MozUserInput(ref from, ref to) => from != to,
                    AnimatedProperty::MozUserModify(ref from, ref to) => from != to,
                    AnimatedProperty::MozUserSelect(ref from, ref to) => from != to,
                    AnimatedProperty::MozWindowDragging(ref from, ref to) => from != to,
                    AnimatedProperty::MozWindowShadow(ref from, ref to) => from != to,
                    AnimatedProperty::ObjectFit(ref from, ref to) => from != to,
                    AnimatedProperty::OutlineStyle(ref from, ref to) => from != to,
                    AnimatedProperty::OverflowAnchor(ref from, ref to) => from != to,
                    AnimatedProperty::OverflowWrap(ref from, ref to) => from != to,
                    AnimatedProperty::PaintOrder(ref from, ref to) => from != to,
                    AnimatedProperty::PointerEvents(ref from, ref to) => from != to,
                    AnimatedProperty::Position(ref from, ref to) => from != to,
                    AnimatedProperty::Resize(ref from, ref to) => from != to,
                    AnimatedProperty::RubyAlign(ref from, ref to) => from != to,
                    AnimatedProperty::RubyPosition(ref from, ref to) => from != to,
                    AnimatedProperty::ScrollBehavior(ref from, ref to) => from != to,
                    AnimatedProperty::ScrollSnapAlign(ref from, ref to) => from != to,
                    AnimatedProperty::ScrollSnapType(ref from, ref to) => from != to,
                    AnimatedProperty::ScrollbarWidth(ref from, ref to) => from != to,
                    AnimatedProperty::ShapeRendering(ref from, ref to) => from != to,
                    AnimatedProperty::StrokeLinecap(ref from, ref to) => from != to,
                    AnimatedProperty::StrokeLinejoin(ref from, ref to) => from != to,
                    AnimatedProperty::TableLayout(ref from, ref to) => from != to,
                    AnimatedProperty::TextAlign(ref from, ref to) => from != to,
                    AnimatedProperty::TextAlignLast(ref from, ref to) => from != to,
                    AnimatedProperty::TextAnchor(ref from, ref to) => from != to,
                    AnimatedProperty::TextCombineUpright(ref from, ref to) => from != to,
                    AnimatedProperty::TextDecorationLine(ref from, ref to) => from != to,
                    AnimatedProperty::TextDecorationStyle(ref from, ref to) => from != to,
                    AnimatedProperty::TextEmphasisPosition(ref from, ref to) => from != to,
                    AnimatedProperty::TextJustify(ref from, ref to) => from != to,
                    AnimatedProperty::TextRendering(ref from, ref to) => from != to,
                    AnimatedProperty::TextTransform(ref from, ref to) => from != to,
                    AnimatedProperty::TouchAction(ref from, ref to) => from != to,
                    AnimatedProperty::TransformBox(ref from, ref to) => from != to,
                    AnimatedProperty::TransformStyle(ref from, ref to) => from != to,
                    AnimatedProperty::VectorEffect(ref from, ref to) => from != to,
                    AnimatedProperty::Visibility(ref from, ref to) => from != to,
                    AnimatedProperty::WebkitLineClamp(ref from, ref to) => from != to,
                    AnimatedProperty::WhiteSpace(ref from, ref to) => from != to,
                    AnimatedProperty::WordBreak(ref from, ref to) => from != to,
                    AnimatedProperty::ZIndex(ref from, ref to) => from != to,
                    AnimatedProperty::BreakAfter(ref from, ref to) => from != to,
                    AnimatedProperty::BreakBefore(ref from, ref to) => from != to,
                    AnimatedProperty::ClipRule(ref from, ref to) => from != to,
                    AnimatedProperty::FillRule(ref from, ref to) => from != to,
                    AnimatedProperty::MozBoxOrdinalGroup(ref from, ref to) => from != to,
                    AnimatedProperty::Order(ref from, ref to) => from != to,
                    AnimatedProperty::OverflowX(ref from, ref to) => from != to,
                    AnimatedProperty::OverflowY(ref from, ref to) => from != to,
                    AnimatedProperty::OverflowClipBoxBlock(ref from, ref to) => from != to,
                    AnimatedProperty::OverflowClipBoxInline(ref from, ref to) => from != to,
                    AnimatedProperty::OverscrollBehaviorX(ref from, ref to) => from != to,
                    AnimatedProperty::OverscrollBehaviorY(ref from, ref to) => from != to,
                    AnimatedProperty::FillOpacity(ref from, ref to) => from != to,
                    AnimatedProperty::StrokeOpacity(ref from, ref to) => from != to,
                    AnimatedProperty::FlexGrow(ref from, ref to) => from != to,
                    AnimatedProperty::FlexShrink(ref from, ref to) => from != to,
                    AnimatedProperty::MozBoxFlex(ref from, ref to) => from != to,
                    AnimatedProperty::StrokeMiterlimit(ref from, ref to) => from != to,
                    AnimatedProperty::FloodOpacity(ref from, ref to) => from != to,
                    AnimatedProperty::MozWindowOpacity(ref from, ref to) => from != to,
                    AnimatedProperty::Opacity(ref from, ref to) => from != to,
                    AnimatedProperty::ShapeImageThreshold(ref from, ref to) => from != to,
                    AnimatedProperty::StopOpacity(ref from, ref to) => from != to,
                    AnimatedProperty::BorderBottomStyle(ref from, ref to) => from != to,
                    AnimatedProperty::BorderLeftStyle(ref from, ref to) => from != to,
                    AnimatedProperty::BorderRightStyle(ref from, ref to) => from != to,
                    AnimatedProperty::BorderTopStyle(ref from, ref to) => from != to,
                    AnimatedProperty::ColumnRuleStyle(ref from, ref to) => from != to,
                    AnimatedProperty::BackgroundAttachment(ref from, ref to) => from != to,
                    AnimatedProperty::BackgroundBlendMode(ref from, ref to) => from != to,
                    AnimatedProperty::BackgroundClip(ref from, ref to) => from != to,
                    AnimatedProperty::BackgroundImage(ref from, ref to) => from != to,
                    AnimatedProperty::BackgroundOrigin(ref from, ref to) => from != to,
                    AnimatedProperty::BackgroundPositionX(ref from, ref to) => from != to,
                    AnimatedProperty::BackgroundPositionY(ref from, ref to) => from != to,
                    AnimatedProperty::BackgroundRepeat(ref from, ref to) => from != to,
                    AnimatedProperty::BackgroundSize(ref from, ref to) => from != to,
                    AnimatedProperty::BorderImageOutset(ref from, ref to) => from != to,
                    AnimatedProperty::BorderImageSlice(ref from, ref to) => from != to,
                    AnimatedProperty::BorderImageSource(ref from, ref to) => from != to,
                    AnimatedProperty::BorderImageWidth(ref from, ref to) => from != to,
                    AnimatedProperty::BorderSpacing(ref from, ref to) => from != to,
                    AnimatedProperty::BoxShadow(ref from, ref to) => from != to,
                    AnimatedProperty::CaretColor(ref from, ref to) => from != to,
                    AnimatedProperty::ClipPath(ref from, ref to) => from != to,
                    AnimatedProperty::Color(ref from, ref to) => from != to,
                    AnimatedProperty::ColumnWidth(ref from, ref to) => from != to,
                    AnimatedProperty::Content(ref from, ref to) => from != to,
                    AnimatedProperty::CounterIncrement(ref from, ref to) => from != to,
                    AnimatedProperty::Cursor(ref from, ref to) => from != to,
                    AnimatedProperty::Filter(ref from, ref to) => from != to,
                    AnimatedProperty::FlexBasis(ref from, ref to) => from != to,
                    AnimatedProperty::FontFamily(ref from, ref to) => from != to,
                    AnimatedProperty::FontFeatureSettings(ref from, ref to) => from != to,
                    AnimatedProperty::FontLanguageOverride(ref from, ref to) => from != to,
                    AnimatedProperty::FontSize(ref from, ref to) => from != to,
                    AnimatedProperty::FontVariantAlternates(ref from, ref to) => from != to,
                    AnimatedProperty::FontVariationSettings(ref from, ref to) => from != to,
                    AnimatedProperty::GridTemplateAreas(ref from, ref to) => from != to,
                    AnimatedProperty::LetterSpacing(ref from, ref to) => from != to,
                    AnimatedProperty::LineHeight(ref from, ref to) => from != to,
                    AnimatedProperty::ListStyleImage(ref from, ref to) => from != to,
                    AnimatedProperty::ListStyleType(ref from, ref to) => from != to,
                    AnimatedProperty::MaskClip(ref from, ref to) => from != to,
                    AnimatedProperty::MaskComposite(ref from, ref to) => from != to,
                    AnimatedProperty::MaskImage(ref from, ref to) => from != to,
                    AnimatedProperty::MaskMode(ref from, ref to) => from != to,
                    AnimatedProperty::MaskOrigin(ref from, ref to) => from != to,
                    AnimatedProperty::MaskPositionX(ref from, ref to) => from != to,
                    AnimatedProperty::MaskPositionY(ref from, ref to) => from != to,
                    AnimatedProperty::MaskRepeat(ref from, ref to) => from != to,
                    AnimatedProperty::MaskSize(ref from, ref to) => from != to,
                    AnimatedProperty::MozTabSize(ref from, ref to) => from != to,
                    AnimatedProperty::OffsetPath(ref from, ref to) => from != to,
                    AnimatedProperty::Perspective(ref from, ref to) => from != to,
                    AnimatedProperty::Quotes(ref from, ref to) => from != to,
                    AnimatedProperty::Rotate(ref from, ref to) => from != to,
                    AnimatedProperty::Scale(ref from, ref to) => from != to,
                    AnimatedProperty::ScrollSnapCoordinate(ref from, ref to) => from != to,
                    AnimatedProperty::ScrollbarColor(ref from, ref to) => from != to,
                    AnimatedProperty::ShapeOutside(ref from, ref to) => from != to,
                    AnimatedProperty::StrokeDasharray(ref from, ref to) => from != to,
                    AnimatedProperty::StrokeDashoffset(ref from, ref to) => from != to,
                    AnimatedProperty::StrokeWidth(ref from, ref to) => from != to,
                    AnimatedProperty::TextEmphasisStyle(ref from, ref to) => from != to,
                    AnimatedProperty::TextIndent(ref from, ref to) => from != to,
                    AnimatedProperty::TextOverflow(ref from, ref to) => from != to,
                    AnimatedProperty::TextShadow(ref from, ref to) => from != to,
                    AnimatedProperty::Translate(ref from, ref to) => from != to,
                    AnimatedProperty::VerticalAlign(ref from, ref to) => from != to,
                    AnimatedProperty::WordSpacing(ref from, ref to) => from != to,
                    AnimatedProperty::Clip(ref from, ref to) => from != to,
                    AnimatedProperty::MozImageRegion(ref from, ref to) => from != to,
                    AnimatedProperty::GridTemplateColumns(ref from, ref to) => from != to,
                    AnimatedProperty::GridTemplateRows(ref from, ref to) => from != to,
                    AnimatedProperty::Fill(ref from, ref to) => from != to,
                    AnimatedProperty::Stroke(ref from, ref to) => from != to,
                    AnimatedProperty::GridAutoColumns(ref from, ref to) => from != to,
                    AnimatedProperty::GridAutoRows(ref from, ref to) => from != to,
                    AnimatedProperty::MozWindowTransformOrigin(ref from, ref to) => from != to,
                    AnimatedProperty::TransformOrigin(ref from, ref to) => from != to,
                    AnimatedProperty::CounterReset(ref from, ref to) => from != to,
                    AnimatedProperty::CounterSet(ref from, ref to) => from != to,
                    AnimatedProperty::ScrollSnapPointsX(ref from, ref to) => from != to,
                    AnimatedProperty::ScrollSnapPointsY(ref from, ref to) => from != to,
                    AnimatedProperty::MozWindowTransform(ref from, ref to) => from != to,
                    AnimatedProperty::Transform(ref from, ref to) => from != to,
                    AnimatedProperty::ColumnGap(ref from, ref to) => from != to,
                    AnimatedProperty::RowGap(ref from, ref to) => from != to,
                    AnimatedProperty::ObjectPosition(ref from, ref to) => from != to,
                    AnimatedProperty::PerspectiveOrigin(ref from, ref to) => from != to,
                    AnimatedProperty::ScrollSnapDestination(ref from, ref to) => from != to,
                    AnimatedProperty::GridColumnEnd(ref from, ref to) => from != to,
                    AnimatedProperty::GridColumnStart(ref from, ref to) => from != to,
                    AnimatedProperty::GridRowEnd(ref from, ref to) => from != to,
                    AnimatedProperty::GridRowStart(ref from, ref to) => from != to,
                    AnimatedProperty::MaxHeight(ref from, ref to) => from != to,
                    AnimatedProperty::MaxWidth(ref from, ref to) => from != to,
                    AnimatedProperty::MarkerEnd(ref from, ref to) => from != to,
                    AnimatedProperty::MarkerMid(ref from, ref to) => from != to,
                    AnimatedProperty::MarkerStart(ref from, ref to) => from != to,
                    AnimatedProperty::ScrollPaddingBottom(ref from, ref to) => from != to,
                    AnimatedProperty::ScrollPaddingLeft(ref from, ref to) => from != to,
                    AnimatedProperty::ScrollPaddingRight(ref from, ref to) => from != to,
                    AnimatedProperty::ScrollPaddingTop(ref from, ref to) => from != to,
                    AnimatedProperty::Height(ref from, ref to) => from != to,
                    AnimatedProperty::MinHeight(ref from, ref to) => from != to,
                    AnimatedProperty::MinWidth(ref from, ref to) => from != to,
                    AnimatedProperty::Width(ref from, ref to) => from != to,
                    AnimatedProperty::OutlineOffset(ref from, ref to) => from != to,
                    AnimatedProperty::ScrollMarginBottom(ref from, ref to) => from != to,
                    AnimatedProperty::ScrollMarginLeft(ref from, ref to) => from != to,
                    AnimatedProperty::ScrollMarginRight(ref from, ref to) => from != to,
                    AnimatedProperty::ScrollMarginTop(ref from, ref to) => from != to,
                    AnimatedProperty::PaddingBottom(ref from, ref to) => from != to,
                    AnimatedProperty::PaddingLeft(ref from, ref to) => from != to,
                    AnimatedProperty::PaddingRight(ref from, ref to) => from != to,
                    AnimatedProperty::PaddingTop(ref from, ref to) => from != to,
                    AnimatedProperty::ShapeMargin(ref from, ref to) => from != to,
                    AnimatedProperty::BorderBottomWidth(ref from, ref to) => from != to,
                    AnimatedProperty::BorderLeftWidth(ref from, ref to) => from != to,
                    AnimatedProperty::BorderRightWidth(ref from, ref to) => from != to,
                    AnimatedProperty::BorderTopWidth(ref from, ref to) => from != to,
                    AnimatedProperty::ColumnRuleWidth(ref from, ref to) => from != to,
                    AnimatedProperty::OutlineWidth(ref from, ref to) => from != to,
                    AnimatedProperty::WebkitTextStrokeWidth(ref from, ref to) => from != to,
                    AnimatedProperty::BorderBottomLeftRadius(ref from, ref to) => from != to,
                    AnimatedProperty::BorderBottomRightRadius(ref from, ref to) => from != to,
                    AnimatedProperty::BorderTopLeftRadius(ref from, ref to) => from != to,
                    AnimatedProperty::BorderTopRightRadius(ref from, ref to) => from != to,
                    AnimatedProperty::MozOutlineRadiusBottomleft(ref from, ref to) => from != to,
                    AnimatedProperty::MozOutlineRadiusBottomright(ref from, ref to) => from != to,
                    AnimatedProperty::MozOutlineRadiusTopleft(ref from, ref to) => from != to,
                    AnimatedProperty::MozOutlineRadiusTopright(ref from, ref to) => from != to,
                    AnimatedProperty::Bottom(ref from, ref to) => from != to,
                    AnimatedProperty::Left(ref from, ref to) => from != to,
                    AnimatedProperty::MarginBottom(ref from, ref to) => from != to,
                    AnimatedProperty::MarginLeft(ref from, ref to) => from != to,
                    AnimatedProperty::MarginRight(ref from, ref to) => from != to,
                    AnimatedProperty::MarginTop(ref from, ref to) => from != to,
                    AnimatedProperty::Right(ref from, ref to) => from != to,
                    AnimatedProperty::Top(ref from, ref to) => from != to,
                    AnimatedProperty::BackgroundColor(ref from, ref to) => from != to,
                    AnimatedProperty::BorderBottomColor(ref from, ref to) => from != to,
                    AnimatedProperty::BorderLeftColor(ref from, ref to) => from != to,
                    AnimatedProperty::BorderRightColor(ref from, ref to) => from != to,
                    AnimatedProperty::BorderTopColor(ref from, ref to) => from != to,
                    AnimatedProperty::ColumnRuleColor(ref from, ref to) => from != to,
                    AnimatedProperty::FloodColor(ref from, ref to) => from != to,
                    AnimatedProperty::LightingColor(ref from, ref to) => from != to,
                    AnimatedProperty::OutlineColor(ref from, ref to) => from != to,
                    AnimatedProperty::StopColor(ref from, ref to) => from != to,
                    AnimatedProperty::TextDecorationColor(ref from, ref to) => from != to,
                    AnimatedProperty::TextEmphasisColor(ref from, ref to) => from != to,
                    AnimatedProperty::WebkitTextFillColor(ref from, ref to) => from != to,
                    AnimatedProperty::WebkitTextStrokeColor(ref from, ref to) => from != to,
        }
    }

    /// Whether an animated property has the same end value as another.
    pub fn has_the_same_end_value_as(&self, other: &Self) -> bool {
        match (self, other) {
                    (&AnimatedProperty::AlignContent(_, ref this_end_value),
                     &AnimatedProperty::AlignContent(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::AlignItems(_, ref this_end_value),
                     &AnimatedProperty::AlignItems(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::AlignSelf(_, ref this_end_value),
                     &AnimatedProperty::AlignSelf(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BackfaceVisibility(_, ref this_end_value),
                     &AnimatedProperty::BackfaceVisibility(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderCollapse(_, ref this_end_value),
                     &AnimatedProperty::BorderCollapse(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderImageRepeat(_, ref this_end_value),
                     &AnimatedProperty::BorderImageRepeat(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BoxDecorationBreak(_, ref this_end_value),
                     &AnimatedProperty::BoxDecorationBreak(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BoxSizing(_, ref this_end_value),
                     &AnimatedProperty::BoxSizing(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BreakInside(_, ref this_end_value),
                     &AnimatedProperty::BreakInside(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::CaptionSide(_, ref this_end_value),
                     &AnimatedProperty::CaptionSide(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Clear(_, ref this_end_value),
                     &AnimatedProperty::Clear(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ColorAdjust(_, ref this_end_value),
                     &AnimatedProperty::ColorAdjust(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ColorInterpolation(_, ref this_end_value),
                     &AnimatedProperty::ColorInterpolation(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ColorInterpolationFilters(_, ref this_end_value),
                     &AnimatedProperty::ColorInterpolationFilters(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ColumnCount(_, ref this_end_value),
                     &AnimatedProperty::ColumnCount(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ColumnFill(_, ref this_end_value),
                     &AnimatedProperty::ColumnFill(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ColumnSpan(_, ref this_end_value),
                     &AnimatedProperty::ColumnSpan(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Display(_, ref this_end_value),
                     &AnimatedProperty::Display(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::DominantBaseline(_, ref this_end_value),
                     &AnimatedProperty::DominantBaseline(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::EmptyCells(_, ref this_end_value),
                     &AnimatedProperty::EmptyCells(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FlexDirection(_, ref this_end_value),
                     &AnimatedProperty::FlexDirection(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FlexWrap(_, ref this_end_value),
                     &AnimatedProperty::FlexWrap(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Float(_, ref this_end_value),
                     &AnimatedProperty::Float(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FontKerning(_, ref this_end_value),
                     &AnimatedProperty::FontKerning(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FontOpticalSizing(_, ref this_end_value),
                     &AnimatedProperty::FontOpticalSizing(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FontSizeAdjust(_, ref this_end_value),
                     &AnimatedProperty::FontSizeAdjust(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FontStretch(_, ref this_end_value),
                     &AnimatedProperty::FontStretch(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FontStyle(_, ref this_end_value),
                     &AnimatedProperty::FontStyle(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FontSynthesis(_, ref this_end_value),
                     &AnimatedProperty::FontSynthesis(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FontVariantCaps(_, ref this_end_value),
                     &AnimatedProperty::FontVariantCaps(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FontVariantEastAsian(_, ref this_end_value),
                     &AnimatedProperty::FontVariantEastAsian(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FontVariantLigatures(_, ref this_end_value),
                     &AnimatedProperty::FontVariantLigatures(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FontVariantNumeric(_, ref this_end_value),
                     &AnimatedProperty::FontVariantNumeric(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FontVariantPosition(_, ref this_end_value),
                     &AnimatedProperty::FontVariantPosition(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FontWeight(_, ref this_end_value),
                     &AnimatedProperty::FontWeight(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::GridAutoFlow(_, ref this_end_value),
                     &AnimatedProperty::GridAutoFlow(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Hyphens(_, ref this_end_value),
                     &AnimatedProperty::Hyphens(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ImageOrientation(_, ref this_end_value),
                     &AnimatedProperty::ImageOrientation(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ImageRendering(_, ref this_end_value),
                     &AnimatedProperty::ImageRendering(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ImeMode(_, ref this_end_value),
                     &AnimatedProperty::ImeMode(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::InitialLetter(_, ref this_end_value),
                     &AnimatedProperty::InitialLetter(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Isolation(_, ref this_end_value),
                     &AnimatedProperty::Isolation(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::JustifyContent(_, ref this_end_value),
                     &AnimatedProperty::JustifyContent(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::JustifyItems(_, ref this_end_value),
                     &AnimatedProperty::JustifyItems(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::JustifySelf(_, ref this_end_value),
                     &AnimatedProperty::JustifySelf(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ListStylePosition(_, ref this_end_value),
                     &AnimatedProperty::ListStylePosition(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MaskType(_, ref this_end_value),
                     &AnimatedProperty::MaskType(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MixBlendMode(_, ref this_end_value),
                     &AnimatedProperty::MixBlendMode(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozAppearance(_, ref this_end_value),
                     &AnimatedProperty::MozAppearance(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozBoxAlign(_, ref this_end_value),
                     &AnimatedProperty::MozBoxAlign(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozBoxDirection(_, ref this_end_value),
                     &AnimatedProperty::MozBoxDirection(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozBoxOrient(_, ref this_end_value),
                     &AnimatedProperty::MozBoxOrient(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozBoxPack(_, ref this_end_value),
                     &AnimatedProperty::MozBoxPack(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozFloatEdge(_, ref this_end_value),
                     &AnimatedProperty::MozFloatEdge(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozForceBrokenImageIcon(_, ref this_end_value),
                     &AnimatedProperty::MozForceBrokenImageIcon(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozListReversed(_, ref this_end_value),
                     &AnimatedProperty::MozListReversed(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozOrient(_, ref this_end_value),
                     &AnimatedProperty::MozOrient(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozOsxFontSmoothing(_, ref this_end_value),
                     &AnimatedProperty::MozOsxFontSmoothing(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozStackSizing(_, ref this_end_value),
                     &AnimatedProperty::MozStackSizing(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozTextSizeAdjust(_, ref this_end_value),
                     &AnimatedProperty::MozTextSizeAdjust(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozUserFocus(_, ref this_end_value),
                     &AnimatedProperty::MozUserFocus(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozUserInput(_, ref this_end_value),
                     &AnimatedProperty::MozUserInput(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozUserModify(_, ref this_end_value),
                     &AnimatedProperty::MozUserModify(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozUserSelect(_, ref this_end_value),
                     &AnimatedProperty::MozUserSelect(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozWindowDragging(_, ref this_end_value),
                     &AnimatedProperty::MozWindowDragging(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozWindowShadow(_, ref this_end_value),
                     &AnimatedProperty::MozWindowShadow(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ObjectFit(_, ref this_end_value),
                     &AnimatedProperty::ObjectFit(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::OutlineStyle(_, ref this_end_value),
                     &AnimatedProperty::OutlineStyle(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::OverflowAnchor(_, ref this_end_value),
                     &AnimatedProperty::OverflowAnchor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::OverflowWrap(_, ref this_end_value),
                     &AnimatedProperty::OverflowWrap(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::PaintOrder(_, ref this_end_value),
                     &AnimatedProperty::PaintOrder(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::PointerEvents(_, ref this_end_value),
                     &AnimatedProperty::PointerEvents(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Position(_, ref this_end_value),
                     &AnimatedProperty::Position(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Resize(_, ref this_end_value),
                     &AnimatedProperty::Resize(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::RubyAlign(_, ref this_end_value),
                     &AnimatedProperty::RubyAlign(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::RubyPosition(_, ref this_end_value),
                     &AnimatedProperty::RubyPosition(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ScrollBehavior(_, ref this_end_value),
                     &AnimatedProperty::ScrollBehavior(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ScrollSnapAlign(_, ref this_end_value),
                     &AnimatedProperty::ScrollSnapAlign(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ScrollSnapType(_, ref this_end_value),
                     &AnimatedProperty::ScrollSnapType(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ScrollbarWidth(_, ref this_end_value),
                     &AnimatedProperty::ScrollbarWidth(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ShapeRendering(_, ref this_end_value),
                     &AnimatedProperty::ShapeRendering(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::StrokeLinecap(_, ref this_end_value),
                     &AnimatedProperty::StrokeLinecap(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::StrokeLinejoin(_, ref this_end_value),
                     &AnimatedProperty::StrokeLinejoin(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TableLayout(_, ref this_end_value),
                     &AnimatedProperty::TableLayout(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TextAlign(_, ref this_end_value),
                     &AnimatedProperty::TextAlign(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TextAlignLast(_, ref this_end_value),
                     &AnimatedProperty::TextAlignLast(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TextAnchor(_, ref this_end_value),
                     &AnimatedProperty::TextAnchor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TextCombineUpright(_, ref this_end_value),
                     &AnimatedProperty::TextCombineUpright(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TextDecorationLine(_, ref this_end_value),
                     &AnimatedProperty::TextDecorationLine(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TextDecorationStyle(_, ref this_end_value),
                     &AnimatedProperty::TextDecorationStyle(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TextEmphasisPosition(_, ref this_end_value),
                     &AnimatedProperty::TextEmphasisPosition(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TextJustify(_, ref this_end_value),
                     &AnimatedProperty::TextJustify(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TextRendering(_, ref this_end_value),
                     &AnimatedProperty::TextRendering(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TextTransform(_, ref this_end_value),
                     &AnimatedProperty::TextTransform(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TouchAction(_, ref this_end_value),
                     &AnimatedProperty::TouchAction(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TransformBox(_, ref this_end_value),
                     &AnimatedProperty::TransformBox(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TransformStyle(_, ref this_end_value),
                     &AnimatedProperty::TransformStyle(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::VectorEffect(_, ref this_end_value),
                     &AnimatedProperty::VectorEffect(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Visibility(_, ref this_end_value),
                     &AnimatedProperty::Visibility(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::WebkitLineClamp(_, ref this_end_value),
                     &AnimatedProperty::WebkitLineClamp(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::WhiteSpace(_, ref this_end_value),
                     &AnimatedProperty::WhiteSpace(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::WordBreak(_, ref this_end_value),
                     &AnimatedProperty::WordBreak(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ZIndex(_, ref this_end_value),
                     &AnimatedProperty::ZIndex(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BreakAfter(_, ref this_end_value),
                     &AnimatedProperty::BreakAfter(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BreakBefore(_, ref this_end_value),
                     &AnimatedProperty::BreakBefore(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ClipRule(_, ref this_end_value),
                     &AnimatedProperty::ClipRule(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FillRule(_, ref this_end_value),
                     &AnimatedProperty::FillRule(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozBoxOrdinalGroup(_, ref this_end_value),
                     &AnimatedProperty::MozBoxOrdinalGroup(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Order(_, ref this_end_value),
                     &AnimatedProperty::Order(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::OverflowX(_, ref this_end_value),
                     &AnimatedProperty::OverflowX(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::OverflowY(_, ref this_end_value),
                     &AnimatedProperty::OverflowY(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::OverflowClipBoxBlock(_, ref this_end_value),
                     &AnimatedProperty::OverflowClipBoxBlock(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::OverflowClipBoxInline(_, ref this_end_value),
                     &AnimatedProperty::OverflowClipBoxInline(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::OverscrollBehaviorX(_, ref this_end_value),
                     &AnimatedProperty::OverscrollBehaviorX(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::OverscrollBehaviorY(_, ref this_end_value),
                     &AnimatedProperty::OverscrollBehaviorY(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FillOpacity(_, ref this_end_value),
                     &AnimatedProperty::FillOpacity(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::StrokeOpacity(_, ref this_end_value),
                     &AnimatedProperty::StrokeOpacity(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FlexGrow(_, ref this_end_value),
                     &AnimatedProperty::FlexGrow(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FlexShrink(_, ref this_end_value),
                     &AnimatedProperty::FlexShrink(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozBoxFlex(_, ref this_end_value),
                     &AnimatedProperty::MozBoxFlex(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::StrokeMiterlimit(_, ref this_end_value),
                     &AnimatedProperty::StrokeMiterlimit(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FloodOpacity(_, ref this_end_value),
                     &AnimatedProperty::FloodOpacity(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozWindowOpacity(_, ref this_end_value),
                     &AnimatedProperty::MozWindowOpacity(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Opacity(_, ref this_end_value),
                     &AnimatedProperty::Opacity(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ShapeImageThreshold(_, ref this_end_value),
                     &AnimatedProperty::ShapeImageThreshold(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::StopOpacity(_, ref this_end_value),
                     &AnimatedProperty::StopOpacity(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderBottomStyle(_, ref this_end_value),
                     &AnimatedProperty::BorderBottomStyle(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderLeftStyle(_, ref this_end_value),
                     &AnimatedProperty::BorderLeftStyle(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderRightStyle(_, ref this_end_value),
                     &AnimatedProperty::BorderRightStyle(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderTopStyle(_, ref this_end_value),
                     &AnimatedProperty::BorderTopStyle(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ColumnRuleStyle(_, ref this_end_value),
                     &AnimatedProperty::ColumnRuleStyle(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BackgroundAttachment(_, ref this_end_value),
                     &AnimatedProperty::BackgroundAttachment(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BackgroundBlendMode(_, ref this_end_value),
                     &AnimatedProperty::BackgroundBlendMode(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BackgroundClip(_, ref this_end_value),
                     &AnimatedProperty::BackgroundClip(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BackgroundImage(_, ref this_end_value),
                     &AnimatedProperty::BackgroundImage(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BackgroundOrigin(_, ref this_end_value),
                     &AnimatedProperty::BackgroundOrigin(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BackgroundPositionX(_, ref this_end_value),
                     &AnimatedProperty::BackgroundPositionX(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BackgroundPositionY(_, ref this_end_value),
                     &AnimatedProperty::BackgroundPositionY(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BackgroundRepeat(_, ref this_end_value),
                     &AnimatedProperty::BackgroundRepeat(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BackgroundSize(_, ref this_end_value),
                     &AnimatedProperty::BackgroundSize(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderImageOutset(_, ref this_end_value),
                     &AnimatedProperty::BorderImageOutset(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderImageSlice(_, ref this_end_value),
                     &AnimatedProperty::BorderImageSlice(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderImageSource(_, ref this_end_value),
                     &AnimatedProperty::BorderImageSource(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderImageWidth(_, ref this_end_value),
                     &AnimatedProperty::BorderImageWidth(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderSpacing(_, ref this_end_value),
                     &AnimatedProperty::BorderSpacing(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BoxShadow(_, ref this_end_value),
                     &AnimatedProperty::BoxShadow(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::CaretColor(_, ref this_end_value),
                     &AnimatedProperty::CaretColor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ClipPath(_, ref this_end_value),
                     &AnimatedProperty::ClipPath(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Color(_, ref this_end_value),
                     &AnimatedProperty::Color(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ColumnWidth(_, ref this_end_value),
                     &AnimatedProperty::ColumnWidth(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Content(_, ref this_end_value),
                     &AnimatedProperty::Content(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::CounterIncrement(_, ref this_end_value),
                     &AnimatedProperty::CounterIncrement(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Cursor(_, ref this_end_value),
                     &AnimatedProperty::Cursor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Filter(_, ref this_end_value),
                     &AnimatedProperty::Filter(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FlexBasis(_, ref this_end_value),
                     &AnimatedProperty::FlexBasis(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FontFamily(_, ref this_end_value),
                     &AnimatedProperty::FontFamily(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FontFeatureSettings(_, ref this_end_value),
                     &AnimatedProperty::FontFeatureSettings(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FontLanguageOverride(_, ref this_end_value),
                     &AnimatedProperty::FontLanguageOverride(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FontSize(_, ref this_end_value),
                     &AnimatedProperty::FontSize(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FontVariantAlternates(_, ref this_end_value),
                     &AnimatedProperty::FontVariantAlternates(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FontVariationSettings(_, ref this_end_value),
                     &AnimatedProperty::FontVariationSettings(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::GridTemplateAreas(_, ref this_end_value),
                     &AnimatedProperty::GridTemplateAreas(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::LetterSpacing(_, ref this_end_value),
                     &AnimatedProperty::LetterSpacing(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::LineHeight(_, ref this_end_value),
                     &AnimatedProperty::LineHeight(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ListStyleImage(_, ref this_end_value),
                     &AnimatedProperty::ListStyleImage(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ListStyleType(_, ref this_end_value),
                     &AnimatedProperty::ListStyleType(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MaskClip(_, ref this_end_value),
                     &AnimatedProperty::MaskClip(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MaskComposite(_, ref this_end_value),
                     &AnimatedProperty::MaskComposite(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MaskImage(_, ref this_end_value),
                     &AnimatedProperty::MaskImage(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MaskMode(_, ref this_end_value),
                     &AnimatedProperty::MaskMode(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MaskOrigin(_, ref this_end_value),
                     &AnimatedProperty::MaskOrigin(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MaskPositionX(_, ref this_end_value),
                     &AnimatedProperty::MaskPositionX(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MaskPositionY(_, ref this_end_value),
                     &AnimatedProperty::MaskPositionY(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MaskRepeat(_, ref this_end_value),
                     &AnimatedProperty::MaskRepeat(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MaskSize(_, ref this_end_value),
                     &AnimatedProperty::MaskSize(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozTabSize(_, ref this_end_value),
                     &AnimatedProperty::MozTabSize(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::OffsetPath(_, ref this_end_value),
                     &AnimatedProperty::OffsetPath(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Perspective(_, ref this_end_value),
                     &AnimatedProperty::Perspective(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Quotes(_, ref this_end_value),
                     &AnimatedProperty::Quotes(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Rotate(_, ref this_end_value),
                     &AnimatedProperty::Rotate(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Scale(_, ref this_end_value),
                     &AnimatedProperty::Scale(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ScrollSnapCoordinate(_, ref this_end_value),
                     &AnimatedProperty::ScrollSnapCoordinate(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ScrollbarColor(_, ref this_end_value),
                     &AnimatedProperty::ScrollbarColor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ShapeOutside(_, ref this_end_value),
                     &AnimatedProperty::ShapeOutside(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::StrokeDasharray(_, ref this_end_value),
                     &AnimatedProperty::StrokeDasharray(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::StrokeDashoffset(_, ref this_end_value),
                     &AnimatedProperty::StrokeDashoffset(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::StrokeWidth(_, ref this_end_value),
                     &AnimatedProperty::StrokeWidth(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TextEmphasisStyle(_, ref this_end_value),
                     &AnimatedProperty::TextEmphasisStyle(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TextIndent(_, ref this_end_value),
                     &AnimatedProperty::TextIndent(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TextOverflow(_, ref this_end_value),
                     &AnimatedProperty::TextOverflow(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TextShadow(_, ref this_end_value),
                     &AnimatedProperty::TextShadow(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Translate(_, ref this_end_value),
                     &AnimatedProperty::Translate(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::VerticalAlign(_, ref this_end_value),
                     &AnimatedProperty::VerticalAlign(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::WordSpacing(_, ref this_end_value),
                     &AnimatedProperty::WordSpacing(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Clip(_, ref this_end_value),
                     &AnimatedProperty::Clip(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozImageRegion(_, ref this_end_value),
                     &AnimatedProperty::MozImageRegion(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::GridTemplateColumns(_, ref this_end_value),
                     &AnimatedProperty::GridTemplateColumns(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::GridTemplateRows(_, ref this_end_value),
                     &AnimatedProperty::GridTemplateRows(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Fill(_, ref this_end_value),
                     &AnimatedProperty::Fill(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Stroke(_, ref this_end_value),
                     &AnimatedProperty::Stroke(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::GridAutoColumns(_, ref this_end_value),
                     &AnimatedProperty::GridAutoColumns(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::GridAutoRows(_, ref this_end_value),
                     &AnimatedProperty::GridAutoRows(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozWindowTransformOrigin(_, ref this_end_value),
                     &AnimatedProperty::MozWindowTransformOrigin(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TransformOrigin(_, ref this_end_value),
                     &AnimatedProperty::TransformOrigin(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::CounterReset(_, ref this_end_value),
                     &AnimatedProperty::CounterReset(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::CounterSet(_, ref this_end_value),
                     &AnimatedProperty::CounterSet(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ScrollSnapPointsX(_, ref this_end_value),
                     &AnimatedProperty::ScrollSnapPointsX(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ScrollSnapPointsY(_, ref this_end_value),
                     &AnimatedProperty::ScrollSnapPointsY(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozWindowTransform(_, ref this_end_value),
                     &AnimatedProperty::MozWindowTransform(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Transform(_, ref this_end_value),
                     &AnimatedProperty::Transform(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ColumnGap(_, ref this_end_value),
                     &AnimatedProperty::ColumnGap(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::RowGap(_, ref this_end_value),
                     &AnimatedProperty::RowGap(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ObjectPosition(_, ref this_end_value),
                     &AnimatedProperty::ObjectPosition(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::PerspectiveOrigin(_, ref this_end_value),
                     &AnimatedProperty::PerspectiveOrigin(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ScrollSnapDestination(_, ref this_end_value),
                     &AnimatedProperty::ScrollSnapDestination(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::GridColumnEnd(_, ref this_end_value),
                     &AnimatedProperty::GridColumnEnd(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::GridColumnStart(_, ref this_end_value),
                     &AnimatedProperty::GridColumnStart(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::GridRowEnd(_, ref this_end_value),
                     &AnimatedProperty::GridRowEnd(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::GridRowStart(_, ref this_end_value),
                     &AnimatedProperty::GridRowStart(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MaxHeight(_, ref this_end_value),
                     &AnimatedProperty::MaxHeight(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MaxWidth(_, ref this_end_value),
                     &AnimatedProperty::MaxWidth(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MarkerEnd(_, ref this_end_value),
                     &AnimatedProperty::MarkerEnd(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MarkerMid(_, ref this_end_value),
                     &AnimatedProperty::MarkerMid(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MarkerStart(_, ref this_end_value),
                     &AnimatedProperty::MarkerStart(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ScrollPaddingBottom(_, ref this_end_value),
                     &AnimatedProperty::ScrollPaddingBottom(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ScrollPaddingLeft(_, ref this_end_value),
                     &AnimatedProperty::ScrollPaddingLeft(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ScrollPaddingRight(_, ref this_end_value),
                     &AnimatedProperty::ScrollPaddingRight(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ScrollPaddingTop(_, ref this_end_value),
                     &AnimatedProperty::ScrollPaddingTop(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Height(_, ref this_end_value),
                     &AnimatedProperty::Height(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MinHeight(_, ref this_end_value),
                     &AnimatedProperty::MinHeight(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MinWidth(_, ref this_end_value),
                     &AnimatedProperty::MinWidth(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Width(_, ref this_end_value),
                     &AnimatedProperty::Width(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::OutlineOffset(_, ref this_end_value),
                     &AnimatedProperty::OutlineOffset(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ScrollMarginBottom(_, ref this_end_value),
                     &AnimatedProperty::ScrollMarginBottom(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ScrollMarginLeft(_, ref this_end_value),
                     &AnimatedProperty::ScrollMarginLeft(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ScrollMarginRight(_, ref this_end_value),
                     &AnimatedProperty::ScrollMarginRight(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ScrollMarginTop(_, ref this_end_value),
                     &AnimatedProperty::ScrollMarginTop(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::PaddingBottom(_, ref this_end_value),
                     &AnimatedProperty::PaddingBottom(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::PaddingLeft(_, ref this_end_value),
                     &AnimatedProperty::PaddingLeft(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::PaddingRight(_, ref this_end_value),
                     &AnimatedProperty::PaddingRight(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::PaddingTop(_, ref this_end_value),
                     &AnimatedProperty::PaddingTop(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ShapeMargin(_, ref this_end_value),
                     &AnimatedProperty::ShapeMargin(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderBottomWidth(_, ref this_end_value),
                     &AnimatedProperty::BorderBottomWidth(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderLeftWidth(_, ref this_end_value),
                     &AnimatedProperty::BorderLeftWidth(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderRightWidth(_, ref this_end_value),
                     &AnimatedProperty::BorderRightWidth(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderTopWidth(_, ref this_end_value),
                     &AnimatedProperty::BorderTopWidth(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ColumnRuleWidth(_, ref this_end_value),
                     &AnimatedProperty::ColumnRuleWidth(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::OutlineWidth(_, ref this_end_value),
                     &AnimatedProperty::OutlineWidth(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::WebkitTextStrokeWidth(_, ref this_end_value),
                     &AnimatedProperty::WebkitTextStrokeWidth(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderBottomLeftRadius(_, ref this_end_value),
                     &AnimatedProperty::BorderBottomLeftRadius(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderBottomRightRadius(_, ref this_end_value),
                     &AnimatedProperty::BorderBottomRightRadius(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderTopLeftRadius(_, ref this_end_value),
                     &AnimatedProperty::BorderTopLeftRadius(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderTopRightRadius(_, ref this_end_value),
                     &AnimatedProperty::BorderTopRightRadius(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozOutlineRadiusBottomleft(_, ref this_end_value),
                     &AnimatedProperty::MozOutlineRadiusBottomleft(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozOutlineRadiusBottomright(_, ref this_end_value),
                     &AnimatedProperty::MozOutlineRadiusBottomright(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozOutlineRadiusTopleft(_, ref this_end_value),
                     &AnimatedProperty::MozOutlineRadiusTopleft(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MozOutlineRadiusTopright(_, ref this_end_value),
                     &AnimatedProperty::MozOutlineRadiusTopright(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Bottom(_, ref this_end_value),
                     &AnimatedProperty::Bottom(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Left(_, ref this_end_value),
                     &AnimatedProperty::Left(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MarginBottom(_, ref this_end_value),
                     &AnimatedProperty::MarginBottom(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MarginLeft(_, ref this_end_value),
                     &AnimatedProperty::MarginLeft(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MarginRight(_, ref this_end_value),
                     &AnimatedProperty::MarginRight(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::MarginTop(_, ref this_end_value),
                     &AnimatedProperty::MarginTop(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Right(_, ref this_end_value),
                     &AnimatedProperty::Right(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::Top(_, ref this_end_value),
                     &AnimatedProperty::Top(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BackgroundColor(_, ref this_end_value),
                     &AnimatedProperty::BackgroundColor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderBottomColor(_, ref this_end_value),
                     &AnimatedProperty::BorderBottomColor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderLeftColor(_, ref this_end_value),
                     &AnimatedProperty::BorderLeftColor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderRightColor(_, ref this_end_value),
                     &AnimatedProperty::BorderRightColor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::BorderTopColor(_, ref this_end_value),
                     &AnimatedProperty::BorderTopColor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::ColumnRuleColor(_, ref this_end_value),
                     &AnimatedProperty::ColumnRuleColor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::FloodColor(_, ref this_end_value),
                     &AnimatedProperty::FloodColor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::LightingColor(_, ref this_end_value),
                     &AnimatedProperty::LightingColor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::OutlineColor(_, ref this_end_value),
                     &AnimatedProperty::OutlineColor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::StopColor(_, ref this_end_value),
                     &AnimatedProperty::StopColor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TextDecorationColor(_, ref this_end_value),
                     &AnimatedProperty::TextDecorationColor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::TextEmphasisColor(_, ref this_end_value),
                     &AnimatedProperty::TextEmphasisColor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::WebkitTextFillColor(_, ref this_end_value),
                     &AnimatedProperty::WebkitTextFillColor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
                    (&AnimatedProperty::WebkitTextStrokeColor(_, ref this_end_value),
                     &AnimatedProperty::WebkitTextStrokeColor(_, ref other_end_value)) => {
                        this_end_value == other_end_value
                    }
            _ => false,
        }
    }

    /// Update `style` with the proper computed style corresponding to this
    /// animation at `progress`.
    #[cfg_attr(feature = "gecko", allow(unused))]
    pub fn update(&self, style: &mut ComputedValues, progress: f64) {
        #[cfg(feature = "servo")]
        {
            match *self {
                    AnimatedProperty::AlignContent(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_position().set_align_content(value);
                    }
                    AnimatedProperty::AlignItems(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_position().set_align_items(value);
                    }
                    AnimatedProperty::AlignSelf(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_position().set_align_self(value);
                    }
                    AnimatedProperty::BackfaceVisibility(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_backface_visibility(value);
                    }
                    AnimatedProperty::BorderCollapse(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_table().set_border_collapse(value);
                    }
                    AnimatedProperty::BorderImageRepeat(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_border().set_border_image_repeat(value);
                    }
                    AnimatedProperty::BoxDecorationBreak(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_border().set_box_decoration_break(value);
                    }
                    AnimatedProperty::BoxSizing(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_position().set_box_sizing(value);
                    }
                    AnimatedProperty::BreakInside(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_break_inside(value);
                    }
                    AnimatedProperty::CaptionSide(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_table().set_caption_side(value);
                    }
                    AnimatedProperty::Clear(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_clear(value);
                    }
                    AnimatedProperty::ColorAdjust(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_box().set_color_adjust(value);
                    }
                    AnimatedProperty::ColorInterpolation(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_svg().set_color_interpolation(value);
                    }
                    AnimatedProperty::ColorInterpolationFilters(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_svg().set_color_interpolation_filters(value);
                    }
                    AnimatedProperty::ColumnCount(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::column_count::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_column().set_column_count(value);
                    }
                    AnimatedProperty::ColumnFill(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_column().set_column_fill(value);
                    }
                    AnimatedProperty::ColumnSpan(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_column().set_column_span(value);
                    }
                    AnimatedProperty::Display(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_display(value);
                    }
                    AnimatedProperty::DominantBaseline(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_svg().set_dominant_baseline(value);
                    }
                    AnimatedProperty::EmptyCells(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_table().set_empty_cells(value);
                    }
                    AnimatedProperty::FlexDirection(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_position().set_flex_direction(value);
                    }
                    AnimatedProperty::FlexWrap(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_position().set_flex_wrap(value);
                    }
                    AnimatedProperty::Float(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_float(value);
                    }
                    AnimatedProperty::FontKerning(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_font().set_font_kerning(value);
                    }
                    AnimatedProperty::FontOpticalSizing(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_font().set_font_optical_sizing(value);
                    }
                    AnimatedProperty::FontSizeAdjust(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_font().set_font_size_adjust(value);
                    }
                    AnimatedProperty::FontStretch(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::font_stretch::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_font().set_font_stretch(value);
                    }
                    AnimatedProperty::FontStyle(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::font_style::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_font().set_font_style(value);
                    }
                    AnimatedProperty::FontSynthesis(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_font().set_font_synthesis(value);
                    }
                    AnimatedProperty::FontVariantCaps(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_font().set_font_variant_caps(value);
                    }
                    AnimatedProperty::FontVariantEastAsian(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_font().set_font_variant_east_asian(value);
                    }
                    AnimatedProperty::FontVariantLigatures(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_font().set_font_variant_ligatures(value);
                    }
                    AnimatedProperty::FontVariantNumeric(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_font().set_font_variant_numeric(value);
                    }
                    AnimatedProperty::FontVariantPosition(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_font().set_font_variant_position(value);
                    }
                    AnimatedProperty::FontWeight(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::font_weight::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_font().set_font_weight(value);
                    }
                    AnimatedProperty::GridAutoFlow(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_position().set_grid_auto_flow(value);
                    }
                    AnimatedProperty::Hyphens(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_text().set_hyphens(value);
                    }
                    AnimatedProperty::ImageOrientation(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_box().set_image_orientation(value);
                    }
                    AnimatedProperty::ImageRendering(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_box().set_image_rendering(value);
                    }
                    AnimatedProperty::ImeMode(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_ui().set_ime_mode(value);
                    }
                    AnimatedProperty::InitialLetter(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_text().set_initial_letter(value);
                    }
                    AnimatedProperty::Isolation(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_isolation(value);
                    }
                    AnimatedProperty::JustifyContent(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_position().set_justify_content(value);
                    }
                    AnimatedProperty::JustifyItems(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_position().set_justify_items(value);
                    }
                    AnimatedProperty::JustifySelf(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_position().set_justify_self(value);
                    }
                    AnimatedProperty::ListStylePosition(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_list().set_list_style_position(value);
                    }
                    AnimatedProperty::MaskType(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_svg().set_mask_type(value);
                    }
                    AnimatedProperty::MixBlendMode(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_effects().set_mix_blend_mode(value);
                    }
                    AnimatedProperty::MozAppearance(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set__moz_appearance(value);
                    }
                    AnimatedProperty::MozBoxAlign(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_xul().set__moz_box_align(value);
                    }
                    AnimatedProperty::MozBoxDirection(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_xul().set__moz_box_direction(value);
                    }
                    AnimatedProperty::MozBoxOrient(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_xul().set__moz_box_orient(value);
                    }
                    AnimatedProperty::MozBoxPack(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_xul().set__moz_box_pack(value);
                    }
                    AnimatedProperty::MozFloatEdge(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_border().set__moz_float_edge(value);
                    }
                    AnimatedProperty::MozForceBrokenImageIcon(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_ui().set__moz_force_broken_image_icon(value);
                    }
                    AnimatedProperty::MozListReversed(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_list().set__moz_list_reversed(value);
                    }
                    AnimatedProperty::MozOrient(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set__moz_orient(value);
                    }
                    AnimatedProperty::MozOsxFontSmoothing(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_font().set__moz_osx_font_smoothing(value);
                    }
                    AnimatedProperty::MozStackSizing(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_xul().set__moz_stack_sizing(value);
                    }
                    AnimatedProperty::MozTextSizeAdjust(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_text().set__moz_text_size_adjust(value);
                    }
                    AnimatedProperty::MozUserFocus(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_ui().set__moz_user_focus(value);
                    }
                    AnimatedProperty::MozUserInput(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_ui().set__moz_user_input(value);
                    }
                    AnimatedProperty::MozUserModify(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_ui().set__moz_user_modify(value);
                    }
                    AnimatedProperty::MozUserSelect(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_ui().set__moz_user_select(value);
                    }
                    AnimatedProperty::MozWindowDragging(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_ui().set__moz_window_dragging(value);
                    }
                    AnimatedProperty::MozWindowShadow(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_ui().set__moz_window_shadow(value);
                    }
                    AnimatedProperty::ObjectFit(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_position().set_object_fit(value);
                    }
                    AnimatedProperty::OutlineStyle(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_outline().set_outline_style(value);
                    }
                    AnimatedProperty::OverflowAnchor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_overflow_anchor(value);
                    }
                    AnimatedProperty::OverflowWrap(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_text().set_overflow_wrap(value);
                    }
                    AnimatedProperty::PaintOrder(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_svg().set_paint_order(value);
                    }
                    AnimatedProperty::PointerEvents(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_ui().set_pointer_events(value);
                    }
                    AnimatedProperty::Position(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_position(value);
                    }
                    AnimatedProperty::Resize(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_resize(value);
                    }
                    AnimatedProperty::RubyAlign(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_text().set_ruby_align(value);
                    }
                    AnimatedProperty::RubyPosition(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_text().set_ruby_position(value);
                    }
                    AnimatedProperty::ScrollBehavior(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_scroll_behavior(value);
                    }
                    AnimatedProperty::ScrollSnapAlign(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_scroll_snap_align(value);
                    }
                    AnimatedProperty::ScrollSnapType(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_scroll_snap_type(value);
                    }
                    AnimatedProperty::ScrollbarWidth(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_ui().set_scrollbar_width(value);
                    }
                    AnimatedProperty::ShapeRendering(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_svg().set_shape_rendering(value);
                    }
                    AnimatedProperty::StrokeLinecap(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_svg().set_stroke_linecap(value);
                    }
                    AnimatedProperty::StrokeLinejoin(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_svg().set_stroke_linejoin(value);
                    }
                    AnimatedProperty::TableLayout(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_table().set_table_layout(value);
                    }
                    AnimatedProperty::TextAlign(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_text().set_text_align(value);
                    }
                    AnimatedProperty::TextAlignLast(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_text().set_text_align_last(value);
                    }
                    AnimatedProperty::TextAnchor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_svg().set_text_anchor(value);
                    }
                    AnimatedProperty::TextCombineUpright(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_text().set_text_combine_upright(value);
                    }
                    AnimatedProperty::TextDecorationLine(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_text().set_text_decoration_line(value);
                    }
                    AnimatedProperty::TextDecorationStyle(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_text().set_text_decoration_style(value);
                    }
                    AnimatedProperty::TextEmphasisPosition(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_text().set_text_emphasis_position(value);
                    }
                    AnimatedProperty::TextJustify(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_text().set_text_justify(value);
                    }
                    AnimatedProperty::TextRendering(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_text().set_text_rendering(value);
                    }
                    AnimatedProperty::TextTransform(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_text().set_text_transform(value);
                    }
                    AnimatedProperty::TouchAction(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_touch_action(value);
                    }
                    AnimatedProperty::TransformBox(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_transform_box(value);
                    }
                    AnimatedProperty::TransformStyle(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_transform_style(value);
                    }
                    AnimatedProperty::VectorEffect(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_svg().set_vector_effect(value);
                    }
                    AnimatedProperty::Visibility(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_inherited_box().set_visibility(value);
                    }
                    AnimatedProperty::WebkitLineClamp(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::_webkit_line_clamp::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_box().set__webkit_line_clamp(value);
                    }
                    AnimatedProperty::WhiteSpace(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_text().set_white_space(value);
                    }
                    AnimatedProperty::WordBreak(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_text().set_word_break(value);
                    }
                    AnimatedProperty::ZIndex(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_position().set_z_index(value);
                    }
                    AnimatedProperty::BreakAfter(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_break_after(value);
                    }
                    AnimatedProperty::BreakBefore(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_break_before(value);
                    }
                    AnimatedProperty::ClipRule(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_svg().set_clip_rule(value);
                    }
                    AnimatedProperty::FillRule(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_svg().set_fill_rule(value);
                    }
                    AnimatedProperty::MozBoxOrdinalGroup(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_xul().set__moz_box_ordinal_group(value);
                    }
                    AnimatedProperty::Order(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_position().set_order(value);
                    }
                    AnimatedProperty::OverflowX(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_overflow_x(value);
                    }
                    AnimatedProperty::OverflowY(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_overflow_y(value);
                    }
                    AnimatedProperty::OverflowClipBoxBlock(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_overflow_clip_box_block(value);
                    }
                    AnimatedProperty::OverflowClipBoxInline(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_overflow_clip_box_inline(value);
                    }
                    AnimatedProperty::OverscrollBehaviorX(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_overscroll_behavior_x(value);
                    }
                    AnimatedProperty::OverscrollBehaviorY(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_overscroll_behavior_y(value);
                    }
                    AnimatedProperty::FillOpacity(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_inherited_svg().set_fill_opacity(value);
                    }
                    AnimatedProperty::StrokeOpacity(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_inherited_svg().set_stroke_opacity(value);
                    }
                    AnimatedProperty::FlexGrow(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::flex_grow::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_position().set_flex_grow(value);
                    }
                    AnimatedProperty::FlexShrink(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::flex_shrink::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_position().set_flex_shrink(value);
                    }
                    AnimatedProperty::MozBoxFlex(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::_moz_box_flex::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_xul().set__moz_box_flex(value);
                    }
                    AnimatedProperty::StrokeMiterlimit(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::stroke_miterlimit::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_inherited_svg().set_stroke_miterlimit(value);
                    }
                    AnimatedProperty::FloodOpacity(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_svg().set_flood_opacity(value);
                    }
                    AnimatedProperty::MozWindowOpacity(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_ui().set__moz_window_opacity(value);
                    }
                    AnimatedProperty::Opacity(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_effects().set_opacity(value);
                    }
                    AnimatedProperty::ShapeImageThreshold(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_box().set_shape_image_threshold(value);
                    }
                    AnimatedProperty::StopOpacity(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_svg().set_stop_opacity(value);
                    }
                    AnimatedProperty::BorderBottomStyle(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_border().set_border_bottom_style(value);
                    }
                    AnimatedProperty::BorderLeftStyle(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_border().set_border_left_style(value);
                    }
                    AnimatedProperty::BorderRightStyle(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_border().set_border_right_style(value);
                    }
                    AnimatedProperty::BorderTopStyle(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_border().set_border_top_style(value);
                    }
                    AnimatedProperty::ColumnRuleStyle(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_column().set_column_rule_style(value);
                    }
                    AnimatedProperty::BackgroundAttachment(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_background().set_background_attachment(value);
                    }
                    AnimatedProperty::BackgroundBlendMode(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_background().set_background_blend_mode(value);
                    }
                    AnimatedProperty::BackgroundClip(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_background().set_background_clip(value);
                    }
                    AnimatedProperty::BackgroundImage(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_background().set_background_image(value);
                    }
                    AnimatedProperty::BackgroundOrigin(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_background().set_background_origin(value);
                    }
                    AnimatedProperty::BackgroundPositionX(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_background().set_background_position_x(value);
                    }
                    AnimatedProperty::BackgroundPositionY(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_background().set_background_position_y(value);
                    }
                    AnimatedProperty::BackgroundRepeat(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_background().set_background_repeat(value);
                    }
                    AnimatedProperty::BackgroundSize(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::background_size::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_background().set_background_size(value);
                    }
                    AnimatedProperty::BorderImageOutset(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_border().set_border_image_outset(value);
                    }
                    AnimatedProperty::BorderImageSlice(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_border().set_border_image_slice(value);
                    }
                    AnimatedProperty::BorderImageSource(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_border().set_border_image_source(value);
                    }
                    AnimatedProperty::BorderImageWidth(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_border().set_border_image_width(value);
                    }
                    AnimatedProperty::BorderSpacing(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::border_spacing::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_inherited_table().set_border_spacing(value);
                    }
                    AnimatedProperty::BoxShadow(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::box_shadow::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_effects().set_box_shadow(value);
                    }
                    AnimatedProperty::CaretColor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::caret_color::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_inherited_ui().set_caret_color(value);
                    }
                    AnimatedProperty::ClipPath(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::clip_path::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_svg().set_clip_path(value);
                    }
                    AnimatedProperty::Color(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::color::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_color().set_color(value);
                    }
                    AnimatedProperty::ColumnWidth(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::column_width::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_column().set_column_width(value);
                    }
                    AnimatedProperty::Content(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_counters().set_content(value);
                    }
                    AnimatedProperty::CounterIncrement(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_counters().set_counter_increment(value);
                    }
                    AnimatedProperty::Cursor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_ui().set_cursor(value);
                    }
                    AnimatedProperty::Filter(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::filter::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_effects().set_filter(value);
                    }
                    AnimatedProperty::FlexBasis(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::flex_basis::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_position().set_flex_basis(value);
                    }
                    AnimatedProperty::FontFamily(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_font().set_font_family(value);
                    }
                    AnimatedProperty::FontFeatureSettings(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_font().set_font_feature_settings(value);
                    }
                    AnimatedProperty::FontLanguageOverride(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_font().set_font_language_override(value);
                    }
                    AnimatedProperty::FontSize(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::font_size::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_font().set_font_size(value);
                    }
                    AnimatedProperty::FontVariantAlternates(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_font().set_font_variant_alternates(value);
                    }
                    AnimatedProperty::FontVariationSettings(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_font().set_font_variation_settings(value);
                    }
                    AnimatedProperty::GridTemplateAreas(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_position().set_grid_template_areas(value);
                    }
                    AnimatedProperty::LetterSpacing(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_inherited_text().set_letter_spacing(value);
                    }
                    AnimatedProperty::LineHeight(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::line_height::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_inherited_text().set_line_height(value);
                    }
                    AnimatedProperty::ListStyleImage(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_list().set_list_style_image(value);
                    }
                    AnimatedProperty::ListStyleType(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_list().set_list_style_type(value);
                    }
                    AnimatedProperty::MaskClip(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_svg().set_mask_clip(value);
                    }
                    AnimatedProperty::MaskComposite(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_svg().set_mask_composite(value);
                    }
                    AnimatedProperty::MaskImage(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_svg().set_mask_image(value);
                    }
                    AnimatedProperty::MaskMode(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_svg().set_mask_mode(value);
                    }
                    AnimatedProperty::MaskOrigin(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_svg().set_mask_origin(value);
                    }
                    AnimatedProperty::MaskPositionX(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_svg().set_mask_position_x(value);
                    }
                    AnimatedProperty::MaskPositionY(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_svg().set_mask_position_y(value);
                    }
                    AnimatedProperty::MaskRepeat(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_svg().set_mask_repeat(value);
                    }
                    AnimatedProperty::MaskSize(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::mask_size::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_svg().set_mask_size(value);
                    }
                    AnimatedProperty::MozTabSize(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::_moz_tab_size::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_inherited_text().set__moz_tab_size(value);
                    }
                    AnimatedProperty::OffsetPath(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_box().set_offset_path(value);
                    }
                    AnimatedProperty::Perspective(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::perspective::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_box().set_perspective(value);
                    }
                    AnimatedProperty::Quotes(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_list().set_quotes(value);
                    }
                    AnimatedProperty::Rotate(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_box().set_rotate(value);
                    }
                    AnimatedProperty::Scale(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_box().set_scale(value);
                    }
                    AnimatedProperty::ScrollSnapCoordinate(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_scroll_snap_coordinate(value);
                    }
                    AnimatedProperty::ScrollbarColor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::scrollbar_color::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_inherited_ui().set_scrollbar_color(value);
                    }
                    AnimatedProperty::ShapeOutside(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::shape_outside::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_box().set_shape_outside(value);
                    }
                    AnimatedProperty::StrokeDasharray(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::stroke_dasharray::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_inherited_svg().set_stroke_dasharray(value);
                    }
                    AnimatedProperty::StrokeDashoffset(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_inherited_svg().set_stroke_dashoffset(value);
                    }
                    AnimatedProperty::StrokeWidth(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::stroke_width::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_inherited_svg().set_stroke_width(value);
                    }
                    AnimatedProperty::TextEmphasisStyle(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_text().set_text_emphasis_style(value);
                    }
                    AnimatedProperty::TextIndent(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_inherited_text().set_text_indent(value);
                    }
                    AnimatedProperty::TextOverflow(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_text().set_text_overflow(value);
                    }
                    AnimatedProperty::TextShadow(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::text_shadow::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_inherited_text().set_text_shadow(value);
                    }
                    AnimatedProperty::Translate(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_box().set_translate(value);
                    }
                    AnimatedProperty::VerticalAlign(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_box().set_vertical_align(value);
                    }
                    AnimatedProperty::WordSpacing(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_inherited_text().set_word_spacing(value);
                    }
                    AnimatedProperty::Clip(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_effects().set_clip(value);
                    }
                    AnimatedProperty::MozImageRegion(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_list().set__moz_image_region(value);
                    }
                    AnimatedProperty::GridTemplateColumns(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_position().set_grid_template_columns(value);
                    }
                    AnimatedProperty::GridTemplateRows(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_position().set_grid_template_rows(value);
                    }
                    AnimatedProperty::Fill(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::fill::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_inherited_svg().set_fill(value);
                    }
                    AnimatedProperty::Stroke(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::stroke::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_inherited_svg().set_stroke(value);
                    }
                    AnimatedProperty::GridAutoColumns(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_position().set_grid_auto_columns(value);
                    }
                    AnimatedProperty::GridAutoRows(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_position().set_grid_auto_rows(value);
                    }
                    AnimatedProperty::MozWindowTransformOrigin(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_ui().set__moz_window_transform_origin(value);
                    }
                    AnimatedProperty::TransformOrigin(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_box().set_transform_origin(value);
                    }
                    AnimatedProperty::CounterReset(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_counters().set_counter_reset(value);
                    }
                    AnimatedProperty::CounterSet(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_counters().set_counter_set(value);
                    }
                    AnimatedProperty::ScrollSnapPointsX(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_scroll_snap_points_x(value);
                    }
                    AnimatedProperty::ScrollSnapPointsY(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_scroll_snap_points_y(value);
                    }
                    AnimatedProperty::MozWindowTransform(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_ui().set__moz_window_transform(value);
                    }
                    AnimatedProperty::Transform(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_box().set_transform(value);
                    }
                    AnimatedProperty::ColumnGap(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::column_gap::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_position().set_column_gap(value);
                    }
                    AnimatedProperty::RowGap(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::row_gap::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_position().set_row_gap(value);
                    }
                    AnimatedProperty::ObjectPosition(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_position().set_object_position(value);
                    }
                    AnimatedProperty::PerspectiveOrigin(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_box().set_perspective_origin(value);
                    }
                    AnimatedProperty::ScrollSnapDestination(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_box().set_scroll_snap_destination(value);
                    }
                    AnimatedProperty::GridColumnEnd(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_position().set_grid_column_end(value);
                    }
                    AnimatedProperty::GridColumnStart(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_position().set_grid_column_start(value);
                    }
                    AnimatedProperty::GridRowEnd(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_position().set_grid_row_end(value);
                    }
                    AnimatedProperty::GridRowStart(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_position().set_grid_row_start(value);
                    }
                    AnimatedProperty::MaxHeight(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::max_height::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_position().set_max_height(value);
                    }
                    AnimatedProperty::MaxWidth(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::max_width::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_position().set_max_width(value);
                    }
                    AnimatedProperty::MarkerEnd(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_svg().set_marker_end(value);
                    }
                    AnimatedProperty::MarkerMid(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_svg().set_marker_mid(value);
                    }
                    AnimatedProperty::MarkerStart(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_svg().set_marker_start(value);
                    }
                    AnimatedProperty::ScrollPaddingBottom(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::scroll_padding_bottom::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_padding().set_scroll_padding_bottom(value);
                    }
                    AnimatedProperty::ScrollPaddingLeft(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::scroll_padding_left::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_padding().set_scroll_padding_left(value);
                    }
                    AnimatedProperty::ScrollPaddingRight(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::scroll_padding_right::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_padding().set_scroll_padding_right(value);
                    }
                    AnimatedProperty::ScrollPaddingTop(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::scroll_padding_top::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_padding().set_scroll_padding_top(value);
                    }
                    AnimatedProperty::Height(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::height::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_position().set_height(value);
                    }
                    AnimatedProperty::MinHeight(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::min_height::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_position().set_min_height(value);
                    }
                    AnimatedProperty::MinWidth(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::min_width::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_position().set_min_width(value);
                    }
                    AnimatedProperty::Width(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::width::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_position().set_width(value);
                    }
                    AnimatedProperty::OutlineOffset(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_outline().set_outline_offset(value);
                    }
                    AnimatedProperty::ScrollMarginBottom(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_margin().set_scroll_margin_bottom(value);
                    }
                    AnimatedProperty::ScrollMarginLeft(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_margin().set_scroll_margin_left(value);
                    }
                    AnimatedProperty::ScrollMarginRight(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_margin().set_scroll_margin_right(value);
                    }
                    AnimatedProperty::ScrollMarginTop(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_margin().set_scroll_margin_top(value);
                    }
                    AnimatedProperty::PaddingBottom(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::padding_bottom::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_padding().set_padding_bottom(value);
                    }
                    AnimatedProperty::PaddingLeft(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::padding_left::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_padding().set_padding_left(value);
                    }
                    AnimatedProperty::PaddingRight(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::padding_right::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_padding().set_padding_right(value);
                    }
                    AnimatedProperty::PaddingTop(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::padding_top::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_padding().set_padding_top(value);
                    }
                    AnimatedProperty::ShapeMargin(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::shape_margin::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_box().set_shape_margin(value);
                    }
                    AnimatedProperty::BorderBottomWidth(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::border_bottom_width::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_border().set_border_bottom_width(value);
                    }
                    AnimatedProperty::BorderLeftWidth(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::border_left_width::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_border().set_border_left_width(value);
                    }
                    AnimatedProperty::BorderRightWidth(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::border_right_width::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_border().set_border_right_width(value);
                    }
                    AnimatedProperty::BorderTopWidth(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::border_top_width::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_border().set_border_top_width(value);
                    }
                    AnimatedProperty::ColumnRuleWidth(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::column_rule_width::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_column().set_column_rule_width(value);
                    }
                    AnimatedProperty::OutlineWidth(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::outline_width::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_outline().set_outline_width(value);
                    }
                    AnimatedProperty::WebkitTextStrokeWidth(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = if progress < 0.5 { from.clone() } else { to.clone() };
                        style.mutate_inherited_text().set__webkit_text_stroke_width(value);
                    }
                    AnimatedProperty::BorderBottomLeftRadius(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::border_bottom_left_radius::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_border().set_border_bottom_left_radius(value);
                    }
                    AnimatedProperty::BorderBottomRightRadius(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::border_bottom_right_radius::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_border().set_border_bottom_right_radius(value);
                    }
                    AnimatedProperty::BorderTopLeftRadius(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::border_top_left_radius::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_border().set_border_top_left_radius(value);
                    }
                    AnimatedProperty::BorderTopRightRadius(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::border_top_right_radius::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_border().set_border_top_right_radius(value);
                    }
                    AnimatedProperty::MozOutlineRadiusBottomleft(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::_moz_outline_radius_bottomleft::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_outline().set__moz_outline_radius_bottomleft(value);
                    }
                    AnimatedProperty::MozOutlineRadiusBottomright(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::_moz_outline_radius_bottomright::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_outline().set__moz_outline_radius_bottomright(value);
                    }
                    AnimatedProperty::MozOutlineRadiusTopleft(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::_moz_outline_radius_topleft::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_outline().set__moz_outline_radius_topleft(value);
                    }
                    AnimatedProperty::MozOutlineRadiusTopright(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::_moz_outline_radius_topright::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_outline().set__moz_outline_radius_topright(value);
                    }
                    AnimatedProperty::Bottom(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_position().set_bottom(value);
                    }
                    AnimatedProperty::Left(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_position().set_left(value);
                    }
                    AnimatedProperty::MarginBottom(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_margin().set_margin_bottom(value);
                    }
                    AnimatedProperty::MarginLeft(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_margin().set_margin_left(value);
                    }
                    AnimatedProperty::MarginRight(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_margin().set_margin_right(value);
                    }
                    AnimatedProperty::MarginTop(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_margin().set_margin_top(value);
                    }
                    AnimatedProperty::Right(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_position().set_right(value);
                    }
                    AnimatedProperty::Top(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                        style.mutate_position().set_top(value);
                    }
                    AnimatedProperty::BackgroundColor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::background_color::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_background().set_background_color(value);
                    }
                    AnimatedProperty::BorderBottomColor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::border_bottom_color::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_border().set_border_bottom_color(value);
                    }
                    AnimatedProperty::BorderLeftColor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::border_left_color::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_border().set_border_left_color(value);
                    }
                    AnimatedProperty::BorderRightColor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::border_right_color::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_border().set_border_right_color(value);
                    }
                    AnimatedProperty::BorderTopColor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::border_top_color::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_border().set_border_top_color(value);
                    }
                    AnimatedProperty::ColumnRuleColor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::column_rule_color::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_column().set_column_rule_color(value);
                    }
                    AnimatedProperty::FloodColor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::flood_color::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_svg().set_flood_color(value);
                    }
                    AnimatedProperty::LightingColor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::lighting_color::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_svg().set_lighting_color(value);
                    }
                    AnimatedProperty::OutlineColor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::outline_color::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_outline().set_outline_color(value);
                    }
                    AnimatedProperty::StopColor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::stop_color::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_svg().set_stop_color(value);
                    }
                    AnimatedProperty::TextDecorationColor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::text_decoration_color::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_text().set_text_decoration_color(value);
                    }
                    AnimatedProperty::TextEmphasisColor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::text_emphasis_color::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_inherited_text().set_text_emphasis_color(value);
                    }
                    AnimatedProperty::WebkitTextFillColor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::_webkit_text_fill_color::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_inherited_text().set__webkit_text_fill_color(value);
                    }
                    AnimatedProperty::WebkitTextStrokeColor(ref from, ref to) => {
                        // https://drafts.csswg.org/web-animations/#discrete-animation-type
                            let value = match from.animate(to, Procedure::Interpolate { progress }) {
                                Ok(value) => value,
                                Err(()) => return,
                            };
                            let value: longhands::_webkit_text_stroke_color::computed_value::T =
                                ToAnimatedValue::from_animated_value(value);
                        style.mutate_inherited_text().set__webkit_text_stroke_color(value);
                    }
            }
        }
    }

    /// Get an animatable value from a transition-property, an old style, and a
    /// new style.
    pub fn from_longhand(
        property: LonghandId,
        old_style: &ComputedValues,
        new_style: &ComputedValues,
    ) -> Option<AnimatedProperty> {
        // FIXME(emilio): Handle the case where old_style and new_style's
        // writing mode differ.
        let property = property.to_physical(new_style.writing_mode);
        Some(match property {
                LonghandId::AlignContent => {
                    let old_computed = old_style.clone_align_content();
                    let new_computed = new_style.clone_align_content();
                    AnimatedProperty::AlignContent(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::AlignItems => {
                    let old_computed = old_style.clone_align_items();
                    let new_computed = new_style.clone_align_items();
                    AnimatedProperty::AlignItems(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::AlignSelf => {
                    let old_computed = old_style.clone_align_self();
                    let new_computed = new_style.clone_align_self();
                    AnimatedProperty::AlignSelf(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BackfaceVisibility => {
                    let old_computed = old_style.clone_backface_visibility();
                    let new_computed = new_style.clone_backface_visibility();
                    AnimatedProperty::BackfaceVisibility(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BorderCollapse => {
                    let old_computed = old_style.clone_border_collapse();
                    let new_computed = new_style.clone_border_collapse();
                    AnimatedProperty::BorderCollapse(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BorderImageRepeat => {
                    let old_computed = old_style.clone_border_image_repeat();
                    let new_computed = new_style.clone_border_image_repeat();
                    AnimatedProperty::BorderImageRepeat(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BoxDecorationBreak => {
                    let old_computed = old_style.clone_box_decoration_break();
                    let new_computed = new_style.clone_box_decoration_break();
                    AnimatedProperty::BoxDecorationBreak(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BoxSizing => {
                    let old_computed = old_style.clone_box_sizing();
                    let new_computed = new_style.clone_box_sizing();
                    AnimatedProperty::BoxSizing(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BreakInside => {
                    let old_computed = old_style.clone_break_inside();
                    let new_computed = new_style.clone_break_inside();
                    AnimatedProperty::BreakInside(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::CaptionSide => {
                    let old_computed = old_style.clone_caption_side();
                    let new_computed = new_style.clone_caption_side();
                    AnimatedProperty::CaptionSide(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Clear => {
                    let old_computed = old_style.clone_clear();
                    let new_computed = new_style.clone_clear();
                    AnimatedProperty::Clear(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ColorAdjust => {
                    let old_computed = old_style.clone_color_adjust();
                    let new_computed = new_style.clone_color_adjust();
                    AnimatedProperty::ColorAdjust(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ColorInterpolation => {
                    let old_computed = old_style.clone_color_interpolation();
                    let new_computed = new_style.clone_color_interpolation();
                    AnimatedProperty::ColorInterpolation(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ColorInterpolationFilters => {
                    let old_computed = old_style.clone_color_interpolation_filters();
                    let new_computed = new_style.clone_color_interpolation_filters();
                    AnimatedProperty::ColorInterpolationFilters(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ColumnCount => {
                    let old_computed = old_style.clone_column_count();
                    let new_computed = new_style.clone_column_count();
                    AnimatedProperty::ColumnCount(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::ColumnFill => {
                    let old_computed = old_style.clone_column_fill();
                    let new_computed = new_style.clone_column_fill();
                    AnimatedProperty::ColumnFill(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ColumnSpan => {
                    let old_computed = old_style.clone_column_span();
                    let new_computed = new_style.clone_column_span();
                    AnimatedProperty::ColumnSpan(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Display => {
                    let old_computed = old_style.clone_display();
                    let new_computed = new_style.clone_display();
                    AnimatedProperty::Display(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::DominantBaseline => {
                    let old_computed = old_style.clone_dominant_baseline();
                    let new_computed = new_style.clone_dominant_baseline();
                    AnimatedProperty::DominantBaseline(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::EmptyCells => {
                    let old_computed = old_style.clone_empty_cells();
                    let new_computed = new_style.clone_empty_cells();
                    AnimatedProperty::EmptyCells(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FlexDirection => {
                    let old_computed = old_style.clone_flex_direction();
                    let new_computed = new_style.clone_flex_direction();
                    AnimatedProperty::FlexDirection(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FlexWrap => {
                    let old_computed = old_style.clone_flex_wrap();
                    let new_computed = new_style.clone_flex_wrap();
                    AnimatedProperty::FlexWrap(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Float => {
                    let old_computed = old_style.clone_float();
                    let new_computed = new_style.clone_float();
                    AnimatedProperty::Float(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FontKerning => {
                    let old_computed = old_style.clone_font_kerning();
                    let new_computed = new_style.clone_font_kerning();
                    AnimatedProperty::FontKerning(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FontOpticalSizing => {
                    let old_computed = old_style.clone_font_optical_sizing();
                    let new_computed = new_style.clone_font_optical_sizing();
                    AnimatedProperty::FontOpticalSizing(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FontSizeAdjust => {
                    let old_computed = old_style.clone_font_size_adjust();
                    let new_computed = new_style.clone_font_size_adjust();
                    AnimatedProperty::FontSizeAdjust(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FontStretch => {
                    let old_computed = old_style.clone_font_stretch();
                    let new_computed = new_style.clone_font_stretch();
                    AnimatedProperty::FontStretch(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::FontStyle => {
                    let old_computed = old_style.clone_font_style();
                    let new_computed = new_style.clone_font_style();
                    AnimatedProperty::FontStyle(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::FontSynthesis => {
                    let old_computed = old_style.clone_font_synthesis();
                    let new_computed = new_style.clone_font_synthesis();
                    AnimatedProperty::FontSynthesis(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FontVariantCaps => {
                    let old_computed = old_style.clone_font_variant_caps();
                    let new_computed = new_style.clone_font_variant_caps();
                    AnimatedProperty::FontVariantCaps(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FontVariantEastAsian => {
                    let old_computed = old_style.clone_font_variant_east_asian();
                    let new_computed = new_style.clone_font_variant_east_asian();
                    AnimatedProperty::FontVariantEastAsian(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FontVariantLigatures => {
                    let old_computed = old_style.clone_font_variant_ligatures();
                    let new_computed = new_style.clone_font_variant_ligatures();
                    AnimatedProperty::FontVariantLigatures(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FontVariantNumeric => {
                    let old_computed = old_style.clone_font_variant_numeric();
                    let new_computed = new_style.clone_font_variant_numeric();
                    AnimatedProperty::FontVariantNumeric(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FontVariantPosition => {
                    let old_computed = old_style.clone_font_variant_position();
                    let new_computed = new_style.clone_font_variant_position();
                    AnimatedProperty::FontVariantPosition(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FontWeight => {
                    let old_computed = old_style.clone_font_weight();
                    let new_computed = new_style.clone_font_weight();
                    AnimatedProperty::FontWeight(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::GridAutoFlow => {
                    let old_computed = old_style.clone_grid_auto_flow();
                    let new_computed = new_style.clone_grid_auto_flow();
                    AnimatedProperty::GridAutoFlow(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Hyphens => {
                    let old_computed = old_style.clone_hyphens();
                    let new_computed = new_style.clone_hyphens();
                    AnimatedProperty::Hyphens(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ImageOrientation => {
                    let old_computed = old_style.clone_image_orientation();
                    let new_computed = new_style.clone_image_orientation();
                    AnimatedProperty::ImageOrientation(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ImageRendering => {
                    let old_computed = old_style.clone_image_rendering();
                    let new_computed = new_style.clone_image_rendering();
                    AnimatedProperty::ImageRendering(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ImeMode => {
                    let old_computed = old_style.clone_ime_mode();
                    let new_computed = new_style.clone_ime_mode();
                    AnimatedProperty::ImeMode(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::InitialLetter => {
                    let old_computed = old_style.clone_initial_letter();
                    let new_computed = new_style.clone_initial_letter();
                    AnimatedProperty::InitialLetter(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Isolation => {
                    let old_computed = old_style.clone_isolation();
                    let new_computed = new_style.clone_isolation();
                    AnimatedProperty::Isolation(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::JustifyContent => {
                    let old_computed = old_style.clone_justify_content();
                    let new_computed = new_style.clone_justify_content();
                    AnimatedProperty::JustifyContent(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::JustifyItems => {
                    let old_computed = old_style.clone_justify_items();
                    let new_computed = new_style.clone_justify_items();
                    AnimatedProperty::JustifyItems(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::JustifySelf => {
                    let old_computed = old_style.clone_justify_self();
                    let new_computed = new_style.clone_justify_self();
                    AnimatedProperty::JustifySelf(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ListStylePosition => {
                    let old_computed = old_style.clone_list_style_position();
                    let new_computed = new_style.clone_list_style_position();
                    AnimatedProperty::ListStylePosition(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MaskType => {
                    let old_computed = old_style.clone_mask_type();
                    let new_computed = new_style.clone_mask_type();
                    AnimatedProperty::MaskType(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MixBlendMode => {
                    let old_computed = old_style.clone_mix_blend_mode();
                    let new_computed = new_style.clone_mix_blend_mode();
                    AnimatedProperty::MixBlendMode(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozAppearance => {
                    let old_computed = old_style.clone__moz_appearance();
                    let new_computed = new_style.clone__moz_appearance();
                    AnimatedProperty::MozAppearance(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozBoxAlign => {
                    let old_computed = old_style.clone__moz_box_align();
                    let new_computed = new_style.clone__moz_box_align();
                    AnimatedProperty::MozBoxAlign(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozBoxDirection => {
                    let old_computed = old_style.clone__moz_box_direction();
                    let new_computed = new_style.clone__moz_box_direction();
                    AnimatedProperty::MozBoxDirection(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozBoxOrient => {
                    let old_computed = old_style.clone__moz_box_orient();
                    let new_computed = new_style.clone__moz_box_orient();
                    AnimatedProperty::MozBoxOrient(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozBoxPack => {
                    let old_computed = old_style.clone__moz_box_pack();
                    let new_computed = new_style.clone__moz_box_pack();
                    AnimatedProperty::MozBoxPack(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozFloatEdge => {
                    let old_computed = old_style.clone__moz_float_edge();
                    let new_computed = new_style.clone__moz_float_edge();
                    AnimatedProperty::MozFloatEdge(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozForceBrokenImageIcon => {
                    let old_computed = old_style.clone__moz_force_broken_image_icon();
                    let new_computed = new_style.clone__moz_force_broken_image_icon();
                    AnimatedProperty::MozForceBrokenImageIcon(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozListReversed => {
                    let old_computed = old_style.clone__moz_list_reversed();
                    let new_computed = new_style.clone__moz_list_reversed();
                    AnimatedProperty::MozListReversed(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozOrient => {
                    let old_computed = old_style.clone__moz_orient();
                    let new_computed = new_style.clone__moz_orient();
                    AnimatedProperty::MozOrient(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozOsxFontSmoothing => {
                    let old_computed = old_style.clone__moz_osx_font_smoothing();
                    let new_computed = new_style.clone__moz_osx_font_smoothing();
                    AnimatedProperty::MozOsxFontSmoothing(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozStackSizing => {
                    let old_computed = old_style.clone__moz_stack_sizing();
                    let new_computed = new_style.clone__moz_stack_sizing();
                    AnimatedProperty::MozStackSizing(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozTextSizeAdjust => {
                    let old_computed = old_style.clone__moz_text_size_adjust();
                    let new_computed = new_style.clone__moz_text_size_adjust();
                    AnimatedProperty::MozTextSizeAdjust(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozUserFocus => {
                    let old_computed = old_style.clone__moz_user_focus();
                    let new_computed = new_style.clone__moz_user_focus();
                    AnimatedProperty::MozUserFocus(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozUserInput => {
                    let old_computed = old_style.clone__moz_user_input();
                    let new_computed = new_style.clone__moz_user_input();
                    AnimatedProperty::MozUserInput(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozUserModify => {
                    let old_computed = old_style.clone__moz_user_modify();
                    let new_computed = new_style.clone__moz_user_modify();
                    AnimatedProperty::MozUserModify(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozUserSelect => {
                    let old_computed = old_style.clone__moz_user_select();
                    let new_computed = new_style.clone__moz_user_select();
                    AnimatedProperty::MozUserSelect(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozWindowDragging => {
                    let old_computed = old_style.clone__moz_window_dragging();
                    let new_computed = new_style.clone__moz_window_dragging();
                    AnimatedProperty::MozWindowDragging(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozWindowShadow => {
                    let old_computed = old_style.clone__moz_window_shadow();
                    let new_computed = new_style.clone__moz_window_shadow();
                    AnimatedProperty::MozWindowShadow(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ObjectFit => {
                    let old_computed = old_style.clone_object_fit();
                    let new_computed = new_style.clone_object_fit();
                    AnimatedProperty::ObjectFit(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::OutlineStyle => {
                    let old_computed = old_style.clone_outline_style();
                    let new_computed = new_style.clone_outline_style();
                    AnimatedProperty::OutlineStyle(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::OverflowAnchor => {
                    let old_computed = old_style.clone_overflow_anchor();
                    let new_computed = new_style.clone_overflow_anchor();
                    AnimatedProperty::OverflowAnchor(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::OverflowWrap => {
                    let old_computed = old_style.clone_overflow_wrap();
                    let new_computed = new_style.clone_overflow_wrap();
                    AnimatedProperty::OverflowWrap(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::PaintOrder => {
                    let old_computed = old_style.clone_paint_order();
                    let new_computed = new_style.clone_paint_order();
                    AnimatedProperty::PaintOrder(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::PointerEvents => {
                    let old_computed = old_style.clone_pointer_events();
                    let new_computed = new_style.clone_pointer_events();
                    AnimatedProperty::PointerEvents(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Position => {
                    let old_computed = old_style.clone_position();
                    let new_computed = new_style.clone_position();
                    AnimatedProperty::Position(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Resize => {
                    let old_computed = old_style.clone_resize();
                    let new_computed = new_style.clone_resize();
                    AnimatedProperty::Resize(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::RubyAlign => {
                    let old_computed = old_style.clone_ruby_align();
                    let new_computed = new_style.clone_ruby_align();
                    AnimatedProperty::RubyAlign(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::RubyPosition => {
                    let old_computed = old_style.clone_ruby_position();
                    let new_computed = new_style.clone_ruby_position();
                    AnimatedProperty::RubyPosition(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ScrollBehavior => {
                    let old_computed = old_style.clone_scroll_behavior();
                    let new_computed = new_style.clone_scroll_behavior();
                    AnimatedProperty::ScrollBehavior(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ScrollSnapAlign => {
                    let old_computed = old_style.clone_scroll_snap_align();
                    let new_computed = new_style.clone_scroll_snap_align();
                    AnimatedProperty::ScrollSnapAlign(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ScrollSnapType => {
                    let old_computed = old_style.clone_scroll_snap_type();
                    let new_computed = new_style.clone_scroll_snap_type();
                    AnimatedProperty::ScrollSnapType(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ScrollbarWidth => {
                    let old_computed = old_style.clone_scrollbar_width();
                    let new_computed = new_style.clone_scrollbar_width();
                    AnimatedProperty::ScrollbarWidth(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ShapeRendering => {
                    let old_computed = old_style.clone_shape_rendering();
                    let new_computed = new_style.clone_shape_rendering();
                    AnimatedProperty::ShapeRendering(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::StrokeLinecap => {
                    let old_computed = old_style.clone_stroke_linecap();
                    let new_computed = new_style.clone_stroke_linecap();
                    AnimatedProperty::StrokeLinecap(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::StrokeLinejoin => {
                    let old_computed = old_style.clone_stroke_linejoin();
                    let new_computed = new_style.clone_stroke_linejoin();
                    AnimatedProperty::StrokeLinejoin(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::TableLayout => {
                    let old_computed = old_style.clone_table_layout();
                    let new_computed = new_style.clone_table_layout();
                    AnimatedProperty::TableLayout(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::TextAlign => {
                    let old_computed = old_style.clone_text_align();
                    let new_computed = new_style.clone_text_align();
                    AnimatedProperty::TextAlign(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::TextAlignLast => {
                    let old_computed = old_style.clone_text_align_last();
                    let new_computed = new_style.clone_text_align_last();
                    AnimatedProperty::TextAlignLast(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::TextAnchor => {
                    let old_computed = old_style.clone_text_anchor();
                    let new_computed = new_style.clone_text_anchor();
                    AnimatedProperty::TextAnchor(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::TextCombineUpright => {
                    let old_computed = old_style.clone_text_combine_upright();
                    let new_computed = new_style.clone_text_combine_upright();
                    AnimatedProperty::TextCombineUpright(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::TextDecorationLine => {
                    let old_computed = old_style.clone_text_decoration_line();
                    let new_computed = new_style.clone_text_decoration_line();
                    AnimatedProperty::TextDecorationLine(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::TextDecorationStyle => {
                    let old_computed = old_style.clone_text_decoration_style();
                    let new_computed = new_style.clone_text_decoration_style();
                    AnimatedProperty::TextDecorationStyle(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::TextEmphasisPosition => {
                    let old_computed = old_style.clone_text_emphasis_position();
                    let new_computed = new_style.clone_text_emphasis_position();
                    AnimatedProperty::TextEmphasisPosition(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::TextJustify => {
                    let old_computed = old_style.clone_text_justify();
                    let new_computed = new_style.clone_text_justify();
                    AnimatedProperty::TextJustify(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::TextRendering => {
                    let old_computed = old_style.clone_text_rendering();
                    let new_computed = new_style.clone_text_rendering();
                    AnimatedProperty::TextRendering(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::TextTransform => {
                    let old_computed = old_style.clone_text_transform();
                    let new_computed = new_style.clone_text_transform();
                    AnimatedProperty::TextTransform(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::TouchAction => {
                    let old_computed = old_style.clone_touch_action();
                    let new_computed = new_style.clone_touch_action();
                    AnimatedProperty::TouchAction(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::TransformBox => {
                    let old_computed = old_style.clone_transform_box();
                    let new_computed = new_style.clone_transform_box();
                    AnimatedProperty::TransformBox(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::TransformStyle => {
                    let old_computed = old_style.clone_transform_style();
                    let new_computed = new_style.clone_transform_style();
                    AnimatedProperty::TransformStyle(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::VectorEffect => {
                    let old_computed = old_style.clone_vector_effect();
                    let new_computed = new_style.clone_vector_effect();
                    AnimatedProperty::VectorEffect(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Visibility => {
                    let old_computed = old_style.clone_visibility();
                    let new_computed = new_style.clone_visibility();
                    AnimatedProperty::Visibility(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::WebkitLineClamp => {
                    let old_computed = old_style.clone__webkit_line_clamp();
                    let new_computed = new_style.clone__webkit_line_clamp();
                    AnimatedProperty::WebkitLineClamp(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::WhiteSpace => {
                    let old_computed = old_style.clone_white_space();
                    let new_computed = new_style.clone_white_space();
                    AnimatedProperty::WhiteSpace(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::WordBreak => {
                    let old_computed = old_style.clone_word_break();
                    let new_computed = new_style.clone_word_break();
                    AnimatedProperty::WordBreak(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ZIndex => {
                    let old_computed = old_style.clone_z_index();
                    let new_computed = new_style.clone_z_index();
                    AnimatedProperty::ZIndex(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BreakAfter => {
                    let old_computed = old_style.clone_break_after();
                    let new_computed = new_style.clone_break_after();
                    AnimatedProperty::BreakAfter(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BreakBefore => {
                    let old_computed = old_style.clone_break_before();
                    let new_computed = new_style.clone_break_before();
                    AnimatedProperty::BreakBefore(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ClipRule => {
                    let old_computed = old_style.clone_clip_rule();
                    let new_computed = new_style.clone_clip_rule();
                    AnimatedProperty::ClipRule(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FillRule => {
                    let old_computed = old_style.clone_fill_rule();
                    let new_computed = new_style.clone_fill_rule();
                    AnimatedProperty::FillRule(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozBoxOrdinalGroup => {
                    let old_computed = old_style.clone__moz_box_ordinal_group();
                    let new_computed = new_style.clone__moz_box_ordinal_group();
                    AnimatedProperty::MozBoxOrdinalGroup(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Order => {
                    let old_computed = old_style.clone_order();
                    let new_computed = new_style.clone_order();
                    AnimatedProperty::Order(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::OverflowX => {
                    let old_computed = old_style.clone_overflow_x();
                    let new_computed = new_style.clone_overflow_x();
                    AnimatedProperty::OverflowX(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::OverflowY => {
                    let old_computed = old_style.clone_overflow_y();
                    let new_computed = new_style.clone_overflow_y();
                    AnimatedProperty::OverflowY(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::OverflowClipBoxBlock => {
                    let old_computed = old_style.clone_overflow_clip_box_block();
                    let new_computed = new_style.clone_overflow_clip_box_block();
                    AnimatedProperty::OverflowClipBoxBlock(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::OverflowClipBoxInline => {
                    let old_computed = old_style.clone_overflow_clip_box_inline();
                    let new_computed = new_style.clone_overflow_clip_box_inline();
                    AnimatedProperty::OverflowClipBoxInline(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::OverscrollBehaviorX => {
                    let old_computed = old_style.clone_overscroll_behavior_x();
                    let new_computed = new_style.clone_overscroll_behavior_x();
                    AnimatedProperty::OverscrollBehaviorX(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::OverscrollBehaviorY => {
                    let old_computed = old_style.clone_overscroll_behavior_y();
                    let new_computed = new_style.clone_overscroll_behavior_y();
                    AnimatedProperty::OverscrollBehaviorY(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FillOpacity => {
                    let old_computed = old_style.clone_fill_opacity();
                    let new_computed = new_style.clone_fill_opacity();
                    AnimatedProperty::FillOpacity(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::StrokeOpacity => {
                    let old_computed = old_style.clone_stroke_opacity();
                    let new_computed = new_style.clone_stroke_opacity();
                    AnimatedProperty::StrokeOpacity(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FlexGrow => {
                    let old_computed = old_style.clone_flex_grow();
                    let new_computed = new_style.clone_flex_grow();
                    AnimatedProperty::FlexGrow(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::FlexShrink => {
                    let old_computed = old_style.clone_flex_shrink();
                    let new_computed = new_style.clone_flex_shrink();
                    AnimatedProperty::FlexShrink(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::MozBoxFlex => {
                    let old_computed = old_style.clone__moz_box_flex();
                    let new_computed = new_style.clone__moz_box_flex();
                    AnimatedProperty::MozBoxFlex(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::StrokeMiterlimit => {
                    let old_computed = old_style.clone_stroke_miterlimit();
                    let new_computed = new_style.clone_stroke_miterlimit();
                    AnimatedProperty::StrokeMiterlimit(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::FloodOpacity => {
                    let old_computed = old_style.clone_flood_opacity();
                    let new_computed = new_style.clone_flood_opacity();
                    AnimatedProperty::FloodOpacity(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozWindowOpacity => {
                    let old_computed = old_style.clone__moz_window_opacity();
                    let new_computed = new_style.clone__moz_window_opacity();
                    AnimatedProperty::MozWindowOpacity(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Opacity => {
                    let old_computed = old_style.clone_opacity();
                    let new_computed = new_style.clone_opacity();
                    AnimatedProperty::Opacity(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ShapeImageThreshold => {
                    let old_computed = old_style.clone_shape_image_threshold();
                    let new_computed = new_style.clone_shape_image_threshold();
                    AnimatedProperty::ShapeImageThreshold(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::StopOpacity => {
                    let old_computed = old_style.clone_stop_opacity();
                    let new_computed = new_style.clone_stop_opacity();
                    AnimatedProperty::StopOpacity(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BorderBottomStyle => {
                    let old_computed = old_style.clone_border_bottom_style();
                    let new_computed = new_style.clone_border_bottom_style();
                    AnimatedProperty::BorderBottomStyle(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BorderLeftStyle => {
                    let old_computed = old_style.clone_border_left_style();
                    let new_computed = new_style.clone_border_left_style();
                    AnimatedProperty::BorderLeftStyle(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BorderRightStyle => {
                    let old_computed = old_style.clone_border_right_style();
                    let new_computed = new_style.clone_border_right_style();
                    AnimatedProperty::BorderRightStyle(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BorderTopStyle => {
                    let old_computed = old_style.clone_border_top_style();
                    let new_computed = new_style.clone_border_top_style();
                    AnimatedProperty::BorderTopStyle(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ColumnRuleStyle => {
                    let old_computed = old_style.clone_column_rule_style();
                    let new_computed = new_style.clone_column_rule_style();
                    AnimatedProperty::ColumnRuleStyle(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BackgroundAttachment => {
                    let old_computed = old_style.clone_background_attachment();
                    let new_computed = new_style.clone_background_attachment();
                    AnimatedProperty::BackgroundAttachment(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BackgroundBlendMode => {
                    let old_computed = old_style.clone_background_blend_mode();
                    let new_computed = new_style.clone_background_blend_mode();
                    AnimatedProperty::BackgroundBlendMode(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BackgroundClip => {
                    let old_computed = old_style.clone_background_clip();
                    let new_computed = new_style.clone_background_clip();
                    AnimatedProperty::BackgroundClip(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BackgroundImage => {
                    let old_computed = old_style.clone_background_image();
                    let new_computed = new_style.clone_background_image();
                    AnimatedProperty::BackgroundImage(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BackgroundOrigin => {
                    let old_computed = old_style.clone_background_origin();
                    let new_computed = new_style.clone_background_origin();
                    AnimatedProperty::BackgroundOrigin(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BackgroundPositionX => {
                    let old_computed = old_style.clone_background_position_x();
                    let new_computed = new_style.clone_background_position_x();
                    AnimatedProperty::BackgroundPositionX(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BackgroundPositionY => {
                    let old_computed = old_style.clone_background_position_y();
                    let new_computed = new_style.clone_background_position_y();
                    AnimatedProperty::BackgroundPositionY(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BackgroundRepeat => {
                    let old_computed = old_style.clone_background_repeat();
                    let new_computed = new_style.clone_background_repeat();
                    AnimatedProperty::BackgroundRepeat(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BackgroundSize => {
                    let old_computed = old_style.clone_background_size();
                    let new_computed = new_style.clone_background_size();
                    AnimatedProperty::BackgroundSize(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::BorderImageOutset => {
                    let old_computed = old_style.clone_border_image_outset();
                    let new_computed = new_style.clone_border_image_outset();
                    AnimatedProperty::BorderImageOutset(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BorderImageSlice => {
                    let old_computed = old_style.clone_border_image_slice();
                    let new_computed = new_style.clone_border_image_slice();
                    AnimatedProperty::BorderImageSlice(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BorderImageSource => {
                    let old_computed = old_style.clone_border_image_source();
                    let new_computed = new_style.clone_border_image_source();
                    AnimatedProperty::BorderImageSource(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BorderImageWidth => {
                    let old_computed = old_style.clone_border_image_width();
                    let new_computed = new_style.clone_border_image_width();
                    AnimatedProperty::BorderImageWidth(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BorderSpacing => {
                    let old_computed = old_style.clone_border_spacing();
                    let new_computed = new_style.clone_border_spacing();
                    AnimatedProperty::BorderSpacing(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::BoxShadow => {
                    let old_computed = old_style.clone_box_shadow();
                    let new_computed = new_style.clone_box_shadow();
                    AnimatedProperty::BoxShadow(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::CaretColor => {
                    let old_computed = old_style.clone_caret_color();
                    let new_computed = new_style.clone_caret_color();
                    AnimatedProperty::CaretColor(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::ClipPath => {
                    let old_computed = old_style.clone_clip_path();
                    let new_computed = new_style.clone_clip_path();
                    AnimatedProperty::ClipPath(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::Color => {
                    let old_computed = old_style.clone_color();
                    let new_computed = new_style.clone_color();
                    AnimatedProperty::Color(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::ColumnWidth => {
                    let old_computed = old_style.clone_column_width();
                    let new_computed = new_style.clone_column_width();
                    AnimatedProperty::ColumnWidth(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::Content => {
                    let old_computed = old_style.clone_content();
                    let new_computed = new_style.clone_content();
                    AnimatedProperty::Content(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::CounterIncrement => {
                    let old_computed = old_style.clone_counter_increment();
                    let new_computed = new_style.clone_counter_increment();
                    AnimatedProperty::CounterIncrement(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Cursor => {
                    let old_computed = old_style.clone_cursor();
                    let new_computed = new_style.clone_cursor();
                    AnimatedProperty::Cursor(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Filter => {
                    let old_computed = old_style.clone_filter();
                    let new_computed = new_style.clone_filter();
                    AnimatedProperty::Filter(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::FlexBasis => {
                    let old_computed = old_style.clone_flex_basis();
                    let new_computed = new_style.clone_flex_basis();
                    AnimatedProperty::FlexBasis(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::FontFamily => {
                    let old_computed = old_style.clone_font_family();
                    let new_computed = new_style.clone_font_family();
                    AnimatedProperty::FontFamily(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FontFeatureSettings => {
                    let old_computed = old_style.clone_font_feature_settings();
                    let new_computed = new_style.clone_font_feature_settings();
                    AnimatedProperty::FontFeatureSettings(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FontLanguageOverride => {
                    let old_computed = old_style.clone_font_language_override();
                    let new_computed = new_style.clone_font_language_override();
                    AnimatedProperty::FontLanguageOverride(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FontSize => {
                    let old_computed = old_style.clone_font_size();
                    let new_computed = new_style.clone_font_size();
                    AnimatedProperty::FontSize(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::FontVariantAlternates => {
                    let old_computed = old_style.clone_font_variant_alternates();
                    let new_computed = new_style.clone_font_variant_alternates();
                    AnimatedProperty::FontVariantAlternates(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::FontVariationSettings => {
                    let old_computed = old_style.clone_font_variation_settings();
                    let new_computed = new_style.clone_font_variation_settings();
                    AnimatedProperty::FontVariationSettings(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::GridTemplateAreas => {
                    let old_computed = old_style.clone_grid_template_areas();
                    let new_computed = new_style.clone_grid_template_areas();
                    AnimatedProperty::GridTemplateAreas(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::LetterSpacing => {
                    let old_computed = old_style.clone_letter_spacing();
                    let new_computed = new_style.clone_letter_spacing();
                    AnimatedProperty::LetterSpacing(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::LineHeight => {
                    let old_computed = old_style.clone_line_height();
                    let new_computed = new_style.clone_line_height();
                    AnimatedProperty::LineHeight(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::ListStyleImage => {
                    let old_computed = old_style.clone_list_style_image();
                    let new_computed = new_style.clone_list_style_image();
                    AnimatedProperty::ListStyleImage(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ListStyleType => {
                    let old_computed = old_style.clone_list_style_type();
                    let new_computed = new_style.clone_list_style_type();
                    AnimatedProperty::ListStyleType(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MaskClip => {
                    let old_computed = old_style.clone_mask_clip();
                    let new_computed = new_style.clone_mask_clip();
                    AnimatedProperty::MaskClip(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MaskComposite => {
                    let old_computed = old_style.clone_mask_composite();
                    let new_computed = new_style.clone_mask_composite();
                    AnimatedProperty::MaskComposite(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MaskImage => {
                    let old_computed = old_style.clone_mask_image();
                    let new_computed = new_style.clone_mask_image();
                    AnimatedProperty::MaskImage(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MaskMode => {
                    let old_computed = old_style.clone_mask_mode();
                    let new_computed = new_style.clone_mask_mode();
                    AnimatedProperty::MaskMode(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MaskOrigin => {
                    let old_computed = old_style.clone_mask_origin();
                    let new_computed = new_style.clone_mask_origin();
                    AnimatedProperty::MaskOrigin(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MaskPositionX => {
                    let old_computed = old_style.clone_mask_position_x();
                    let new_computed = new_style.clone_mask_position_x();
                    AnimatedProperty::MaskPositionX(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MaskPositionY => {
                    let old_computed = old_style.clone_mask_position_y();
                    let new_computed = new_style.clone_mask_position_y();
                    AnimatedProperty::MaskPositionY(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MaskRepeat => {
                    let old_computed = old_style.clone_mask_repeat();
                    let new_computed = new_style.clone_mask_repeat();
                    AnimatedProperty::MaskRepeat(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MaskSize => {
                    let old_computed = old_style.clone_mask_size();
                    let new_computed = new_style.clone_mask_size();
                    AnimatedProperty::MaskSize(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::MozTabSize => {
                    let old_computed = old_style.clone__moz_tab_size();
                    let new_computed = new_style.clone__moz_tab_size();
                    AnimatedProperty::MozTabSize(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::OffsetPath => {
                    let old_computed = old_style.clone_offset_path();
                    let new_computed = new_style.clone_offset_path();
                    AnimatedProperty::OffsetPath(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Perspective => {
                    let old_computed = old_style.clone_perspective();
                    let new_computed = new_style.clone_perspective();
                    AnimatedProperty::Perspective(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::Quotes => {
                    let old_computed = old_style.clone_quotes();
                    let new_computed = new_style.clone_quotes();
                    AnimatedProperty::Quotes(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Rotate => {
                    let old_computed = old_style.clone_rotate();
                    let new_computed = new_style.clone_rotate();
                    AnimatedProperty::Rotate(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Scale => {
                    let old_computed = old_style.clone_scale();
                    let new_computed = new_style.clone_scale();
                    AnimatedProperty::Scale(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ScrollSnapCoordinate => {
                    let old_computed = old_style.clone_scroll_snap_coordinate();
                    let new_computed = new_style.clone_scroll_snap_coordinate();
                    AnimatedProperty::ScrollSnapCoordinate(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ScrollbarColor => {
                    let old_computed = old_style.clone_scrollbar_color();
                    let new_computed = new_style.clone_scrollbar_color();
                    AnimatedProperty::ScrollbarColor(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::ShapeOutside => {
                    let old_computed = old_style.clone_shape_outside();
                    let new_computed = new_style.clone_shape_outside();
                    AnimatedProperty::ShapeOutside(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::StrokeDasharray => {
                    let old_computed = old_style.clone_stroke_dasharray();
                    let new_computed = new_style.clone_stroke_dasharray();
                    AnimatedProperty::StrokeDasharray(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::StrokeDashoffset => {
                    let old_computed = old_style.clone_stroke_dashoffset();
                    let new_computed = new_style.clone_stroke_dashoffset();
                    AnimatedProperty::StrokeDashoffset(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::StrokeWidth => {
                    let old_computed = old_style.clone_stroke_width();
                    let new_computed = new_style.clone_stroke_width();
                    AnimatedProperty::StrokeWidth(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::TextEmphasisStyle => {
                    let old_computed = old_style.clone_text_emphasis_style();
                    let new_computed = new_style.clone_text_emphasis_style();
                    AnimatedProperty::TextEmphasisStyle(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::TextIndent => {
                    let old_computed = old_style.clone_text_indent();
                    let new_computed = new_style.clone_text_indent();
                    AnimatedProperty::TextIndent(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::TextOverflow => {
                    let old_computed = old_style.clone_text_overflow();
                    let new_computed = new_style.clone_text_overflow();
                    AnimatedProperty::TextOverflow(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::TextShadow => {
                    let old_computed = old_style.clone_text_shadow();
                    let new_computed = new_style.clone_text_shadow();
                    AnimatedProperty::TextShadow(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::Translate => {
                    let old_computed = old_style.clone_translate();
                    let new_computed = new_style.clone_translate();
                    AnimatedProperty::Translate(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::VerticalAlign => {
                    let old_computed = old_style.clone_vertical_align();
                    let new_computed = new_style.clone_vertical_align();
                    AnimatedProperty::VerticalAlign(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::WordSpacing => {
                    let old_computed = old_style.clone_word_spacing();
                    let new_computed = new_style.clone_word_spacing();
                    AnimatedProperty::WordSpacing(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Clip => {
                    let old_computed = old_style.clone_clip();
                    let new_computed = new_style.clone_clip();
                    AnimatedProperty::Clip(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozImageRegion => {
                    let old_computed = old_style.clone__moz_image_region();
                    let new_computed = new_style.clone__moz_image_region();
                    AnimatedProperty::MozImageRegion(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::GridTemplateColumns => {
                    let old_computed = old_style.clone_grid_template_columns();
                    let new_computed = new_style.clone_grid_template_columns();
                    AnimatedProperty::GridTemplateColumns(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::GridTemplateRows => {
                    let old_computed = old_style.clone_grid_template_rows();
                    let new_computed = new_style.clone_grid_template_rows();
                    AnimatedProperty::GridTemplateRows(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Fill => {
                    let old_computed = old_style.clone_fill();
                    let new_computed = new_style.clone_fill();
                    AnimatedProperty::Fill(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::Stroke => {
                    let old_computed = old_style.clone_stroke();
                    let new_computed = new_style.clone_stroke();
                    AnimatedProperty::Stroke(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::GridAutoColumns => {
                    let old_computed = old_style.clone_grid_auto_columns();
                    let new_computed = new_style.clone_grid_auto_columns();
                    AnimatedProperty::GridAutoColumns(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::GridAutoRows => {
                    let old_computed = old_style.clone_grid_auto_rows();
                    let new_computed = new_style.clone_grid_auto_rows();
                    AnimatedProperty::GridAutoRows(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozWindowTransformOrigin => {
                    let old_computed = old_style.clone__moz_window_transform_origin();
                    let new_computed = new_style.clone__moz_window_transform_origin();
                    AnimatedProperty::MozWindowTransformOrigin(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::TransformOrigin => {
                    let old_computed = old_style.clone_transform_origin();
                    let new_computed = new_style.clone_transform_origin();
                    AnimatedProperty::TransformOrigin(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::CounterReset => {
                    let old_computed = old_style.clone_counter_reset();
                    let new_computed = new_style.clone_counter_reset();
                    AnimatedProperty::CounterReset(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::CounterSet => {
                    let old_computed = old_style.clone_counter_set();
                    let new_computed = new_style.clone_counter_set();
                    AnimatedProperty::CounterSet(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ScrollSnapPointsX => {
                    let old_computed = old_style.clone_scroll_snap_points_x();
                    let new_computed = new_style.clone_scroll_snap_points_x();
                    AnimatedProperty::ScrollSnapPointsX(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ScrollSnapPointsY => {
                    let old_computed = old_style.clone_scroll_snap_points_y();
                    let new_computed = new_style.clone_scroll_snap_points_y();
                    AnimatedProperty::ScrollSnapPointsY(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MozWindowTransform => {
                    let old_computed = old_style.clone__moz_window_transform();
                    let new_computed = new_style.clone__moz_window_transform();
                    AnimatedProperty::MozWindowTransform(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Transform => {
                    let old_computed = old_style.clone_transform();
                    let new_computed = new_style.clone_transform();
                    AnimatedProperty::Transform(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ColumnGap => {
                    let old_computed = old_style.clone_column_gap();
                    let new_computed = new_style.clone_column_gap();
                    AnimatedProperty::ColumnGap(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::RowGap => {
                    let old_computed = old_style.clone_row_gap();
                    let new_computed = new_style.clone_row_gap();
                    AnimatedProperty::RowGap(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::ObjectPosition => {
                    let old_computed = old_style.clone_object_position();
                    let new_computed = new_style.clone_object_position();
                    AnimatedProperty::ObjectPosition(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::PerspectiveOrigin => {
                    let old_computed = old_style.clone_perspective_origin();
                    let new_computed = new_style.clone_perspective_origin();
                    AnimatedProperty::PerspectiveOrigin(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ScrollSnapDestination => {
                    let old_computed = old_style.clone_scroll_snap_destination();
                    let new_computed = new_style.clone_scroll_snap_destination();
                    AnimatedProperty::ScrollSnapDestination(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::GridColumnEnd => {
                    let old_computed = old_style.clone_grid_column_end();
                    let new_computed = new_style.clone_grid_column_end();
                    AnimatedProperty::GridColumnEnd(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::GridColumnStart => {
                    let old_computed = old_style.clone_grid_column_start();
                    let new_computed = new_style.clone_grid_column_start();
                    AnimatedProperty::GridColumnStart(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::GridRowEnd => {
                    let old_computed = old_style.clone_grid_row_end();
                    let new_computed = new_style.clone_grid_row_end();
                    AnimatedProperty::GridRowEnd(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::GridRowStart => {
                    let old_computed = old_style.clone_grid_row_start();
                    let new_computed = new_style.clone_grid_row_start();
                    AnimatedProperty::GridRowStart(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MaxHeight => {
                    let old_computed = old_style.clone_max_height();
                    let new_computed = new_style.clone_max_height();
                    AnimatedProperty::MaxHeight(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::MaxWidth => {
                    let old_computed = old_style.clone_max_width();
                    let new_computed = new_style.clone_max_width();
                    AnimatedProperty::MaxWidth(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::MarkerEnd => {
                    let old_computed = old_style.clone_marker_end();
                    let new_computed = new_style.clone_marker_end();
                    AnimatedProperty::MarkerEnd(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MarkerMid => {
                    let old_computed = old_style.clone_marker_mid();
                    let new_computed = new_style.clone_marker_mid();
                    AnimatedProperty::MarkerMid(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MarkerStart => {
                    let old_computed = old_style.clone_marker_start();
                    let new_computed = new_style.clone_marker_start();
                    AnimatedProperty::MarkerStart(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ScrollPaddingBottom => {
                    let old_computed = old_style.clone_scroll_padding_bottom();
                    let new_computed = new_style.clone_scroll_padding_bottom();
                    AnimatedProperty::ScrollPaddingBottom(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::ScrollPaddingLeft => {
                    let old_computed = old_style.clone_scroll_padding_left();
                    let new_computed = new_style.clone_scroll_padding_left();
                    AnimatedProperty::ScrollPaddingLeft(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::ScrollPaddingRight => {
                    let old_computed = old_style.clone_scroll_padding_right();
                    let new_computed = new_style.clone_scroll_padding_right();
                    AnimatedProperty::ScrollPaddingRight(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::ScrollPaddingTop => {
                    let old_computed = old_style.clone_scroll_padding_top();
                    let new_computed = new_style.clone_scroll_padding_top();
                    AnimatedProperty::ScrollPaddingTop(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::Height => {
                    let old_computed = old_style.clone_height();
                    let new_computed = new_style.clone_height();
                    AnimatedProperty::Height(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::MinHeight => {
                    let old_computed = old_style.clone_min_height();
                    let new_computed = new_style.clone_min_height();
                    AnimatedProperty::MinHeight(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::MinWidth => {
                    let old_computed = old_style.clone_min_width();
                    let new_computed = new_style.clone_min_width();
                    AnimatedProperty::MinWidth(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::Width => {
                    let old_computed = old_style.clone_width();
                    let new_computed = new_style.clone_width();
                    AnimatedProperty::Width(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::OutlineOffset => {
                    let old_computed = old_style.clone_outline_offset();
                    let new_computed = new_style.clone_outline_offset();
                    AnimatedProperty::OutlineOffset(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ScrollMarginBottom => {
                    let old_computed = old_style.clone_scroll_margin_bottom();
                    let new_computed = new_style.clone_scroll_margin_bottom();
                    AnimatedProperty::ScrollMarginBottom(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ScrollMarginLeft => {
                    let old_computed = old_style.clone_scroll_margin_left();
                    let new_computed = new_style.clone_scroll_margin_left();
                    AnimatedProperty::ScrollMarginLeft(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ScrollMarginRight => {
                    let old_computed = old_style.clone_scroll_margin_right();
                    let new_computed = new_style.clone_scroll_margin_right();
                    AnimatedProperty::ScrollMarginRight(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::ScrollMarginTop => {
                    let old_computed = old_style.clone_scroll_margin_top();
                    let new_computed = new_style.clone_scroll_margin_top();
                    AnimatedProperty::ScrollMarginTop(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::PaddingBottom => {
                    let old_computed = old_style.clone_padding_bottom();
                    let new_computed = new_style.clone_padding_bottom();
                    AnimatedProperty::PaddingBottom(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::PaddingLeft => {
                    let old_computed = old_style.clone_padding_left();
                    let new_computed = new_style.clone_padding_left();
                    AnimatedProperty::PaddingLeft(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::PaddingRight => {
                    let old_computed = old_style.clone_padding_right();
                    let new_computed = new_style.clone_padding_right();
                    AnimatedProperty::PaddingRight(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::PaddingTop => {
                    let old_computed = old_style.clone_padding_top();
                    let new_computed = new_style.clone_padding_top();
                    AnimatedProperty::PaddingTop(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::ShapeMargin => {
                    let old_computed = old_style.clone_shape_margin();
                    let new_computed = new_style.clone_shape_margin();
                    AnimatedProperty::ShapeMargin(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::BorderBottomWidth => {
                    let old_computed = old_style.clone_border_bottom_width();
                    let new_computed = new_style.clone_border_bottom_width();
                    AnimatedProperty::BorderBottomWidth(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::BorderLeftWidth => {
                    let old_computed = old_style.clone_border_left_width();
                    let new_computed = new_style.clone_border_left_width();
                    AnimatedProperty::BorderLeftWidth(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::BorderRightWidth => {
                    let old_computed = old_style.clone_border_right_width();
                    let new_computed = new_style.clone_border_right_width();
                    AnimatedProperty::BorderRightWidth(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::BorderTopWidth => {
                    let old_computed = old_style.clone_border_top_width();
                    let new_computed = new_style.clone_border_top_width();
                    AnimatedProperty::BorderTopWidth(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::ColumnRuleWidth => {
                    let old_computed = old_style.clone_column_rule_width();
                    let new_computed = new_style.clone_column_rule_width();
                    AnimatedProperty::ColumnRuleWidth(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::OutlineWidth => {
                    let old_computed = old_style.clone_outline_width();
                    let new_computed = new_style.clone_outline_width();
                    AnimatedProperty::OutlineWidth(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::WebkitTextStrokeWidth => {
                    let old_computed = old_style.clone__webkit_text_stroke_width();
                    let new_computed = new_style.clone__webkit_text_stroke_width();
                    AnimatedProperty::WebkitTextStrokeWidth(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BorderBottomLeftRadius => {
                    let old_computed = old_style.clone_border_bottom_left_radius();
                    let new_computed = new_style.clone_border_bottom_left_radius();
                    AnimatedProperty::BorderBottomLeftRadius(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::BorderBottomRightRadius => {
                    let old_computed = old_style.clone_border_bottom_right_radius();
                    let new_computed = new_style.clone_border_bottom_right_radius();
                    AnimatedProperty::BorderBottomRightRadius(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::BorderTopLeftRadius => {
                    let old_computed = old_style.clone_border_top_left_radius();
                    let new_computed = new_style.clone_border_top_left_radius();
                    AnimatedProperty::BorderTopLeftRadius(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::BorderTopRightRadius => {
                    let old_computed = old_style.clone_border_top_right_radius();
                    let new_computed = new_style.clone_border_top_right_radius();
                    AnimatedProperty::BorderTopRightRadius(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::MozOutlineRadiusBottomleft => {
                    let old_computed = old_style.clone__moz_outline_radius_bottomleft();
                    let new_computed = new_style.clone__moz_outline_radius_bottomleft();
                    AnimatedProperty::MozOutlineRadiusBottomleft(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::MozOutlineRadiusBottomright => {
                    let old_computed = old_style.clone__moz_outline_radius_bottomright();
                    let new_computed = new_style.clone__moz_outline_radius_bottomright();
                    AnimatedProperty::MozOutlineRadiusBottomright(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::MozOutlineRadiusTopleft => {
                    let old_computed = old_style.clone__moz_outline_radius_topleft();
                    let new_computed = new_style.clone__moz_outline_radius_topleft();
                    AnimatedProperty::MozOutlineRadiusTopleft(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::MozOutlineRadiusTopright => {
                    let old_computed = old_style.clone__moz_outline_radius_topright();
                    let new_computed = new_style.clone__moz_outline_radius_topright();
                    AnimatedProperty::MozOutlineRadiusTopright(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::Bottom => {
                    let old_computed = old_style.clone_bottom();
                    let new_computed = new_style.clone_bottom();
                    AnimatedProperty::Bottom(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Left => {
                    let old_computed = old_style.clone_left();
                    let new_computed = new_style.clone_left();
                    AnimatedProperty::Left(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MarginBottom => {
                    let old_computed = old_style.clone_margin_bottom();
                    let new_computed = new_style.clone_margin_bottom();
                    AnimatedProperty::MarginBottom(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MarginLeft => {
                    let old_computed = old_style.clone_margin_left();
                    let new_computed = new_style.clone_margin_left();
                    AnimatedProperty::MarginLeft(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MarginRight => {
                    let old_computed = old_style.clone_margin_right();
                    let new_computed = new_style.clone_margin_right();
                    AnimatedProperty::MarginRight(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::MarginTop => {
                    let old_computed = old_style.clone_margin_top();
                    let new_computed = new_style.clone_margin_top();
                    AnimatedProperty::MarginTop(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Right => {
                    let old_computed = old_style.clone_right();
                    let new_computed = new_style.clone_right();
                    AnimatedProperty::Right(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::Top => {
                    let old_computed = old_style.clone_top();
                    let new_computed = new_style.clone_top();
                    AnimatedProperty::Top(
                        old_computed,
                        new_computed,
                    )
                }
                LonghandId::BackgroundColor => {
                    let old_computed = old_style.clone_background_color();
                    let new_computed = new_style.clone_background_color();
                    AnimatedProperty::BackgroundColor(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::BorderBottomColor => {
                    let old_computed = old_style.clone_border_bottom_color();
                    let new_computed = new_style.clone_border_bottom_color();
                    AnimatedProperty::BorderBottomColor(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::BorderLeftColor => {
                    let old_computed = old_style.clone_border_left_color();
                    let new_computed = new_style.clone_border_left_color();
                    AnimatedProperty::BorderLeftColor(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::BorderRightColor => {
                    let old_computed = old_style.clone_border_right_color();
                    let new_computed = new_style.clone_border_right_color();
                    AnimatedProperty::BorderRightColor(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::BorderTopColor => {
                    let old_computed = old_style.clone_border_top_color();
                    let new_computed = new_style.clone_border_top_color();
                    AnimatedProperty::BorderTopColor(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::ColumnRuleColor => {
                    let old_computed = old_style.clone_column_rule_color();
                    let new_computed = new_style.clone_column_rule_color();
                    AnimatedProperty::ColumnRuleColor(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::FloodColor => {
                    let old_computed = old_style.clone_flood_color();
                    let new_computed = new_style.clone_flood_color();
                    AnimatedProperty::FloodColor(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::LightingColor => {
                    let old_computed = old_style.clone_lighting_color();
                    let new_computed = new_style.clone_lighting_color();
                    AnimatedProperty::LightingColor(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::OutlineColor => {
                    let old_computed = old_style.clone_outline_color();
                    let new_computed = new_style.clone_outline_color();
                    AnimatedProperty::OutlineColor(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::StopColor => {
                    let old_computed = old_style.clone_stop_color();
                    let new_computed = new_style.clone_stop_color();
                    AnimatedProperty::StopColor(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::TextDecorationColor => {
                    let old_computed = old_style.clone_text_decoration_color();
                    let new_computed = new_style.clone_text_decoration_color();
                    AnimatedProperty::TextDecorationColor(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::TextEmphasisColor => {
                    let old_computed = old_style.clone_text_emphasis_color();
                    let new_computed = new_style.clone_text_emphasis_color();
                    AnimatedProperty::TextEmphasisColor(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::WebkitTextFillColor => {
                    let old_computed = old_style.clone__webkit_text_fill_color();
                    let new_computed = new_style.clone__webkit_text_fill_color();
                    AnimatedProperty::WebkitTextFillColor(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
                LonghandId::WebkitTextStrokeColor => {
                    let old_computed = old_style.clone__webkit_text_stroke_color();
                    let new_computed = new_style.clone__webkit_text_stroke_color();
                    AnimatedProperty::WebkitTextStrokeColor(
                        old_computed.to_animated_value(),
                        new_computed.to_animated_value(),
                    )
                }
            _ => return None,
        })
    }
}

/// A collection of AnimationValue that were composed on an element.
/// This HashMap stores the values that are the last AnimationValue to be
/// composed for each TransitionProperty.
pub type AnimationValueMap = FxHashMap<LonghandId, AnimationValue>;

#[cfg(feature = "gecko")]
unsafe impl HasFFI for AnimationValueMap {
    type FFIType = RawServoAnimationValueMap;
}
#[cfg(feature = "gecko")]
unsafe impl HasSimpleFFI for AnimationValueMap {}

/// An enum to represent a single computed value belonging to an animated
/// property in order to be interpolated with another one. When interpolating,
/// both values need to belong to the same property.
///
/// This is different to AnimatedProperty in the sense that AnimatedProperty
/// also knows the final value to be used during the animation.
///
/// This is to be used in Gecko integration code.
///
/// FIXME: We need to add a path for custom properties, but that's trivial after
/// this (is a similar path to that of PropertyDeclaration).
#[cfg_attr(feature = "servo", derive(MallocSizeOf))]
#[derive(Debug)]
#[repr(u16)]
pub enum AnimationValue {
    /// `align-content`
    AlignContent(<crate::values::specified::AlignContent as ToComputedValue>::ComputedValue),
    /// `align-items`
    AlignItems(<crate::values::specified::AlignItems as ToComputedValue>::ComputedValue),
    /// `align-self`
    AlignSelf(<crate::values::specified::AlignSelf as ToComputedValue>::ComputedValue),
    /// `backface-visibility`
    BackfaceVisibility(<longhands::backface_visibility::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `border-collapse`
    BorderCollapse(<longhands::border_collapse::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `border-image-repeat`
    BorderImageRepeat(<crate::values::specified::BorderImageRepeat as ToComputedValue>::ComputedValue),
    /// `box-decoration-break`
    BoxDecorationBreak(<longhands::box_decoration_break::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `box-sizing`
    BoxSizing(<longhands::box_sizing::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `break-inside`
    BreakInside(<crate::values::specified::BreakWithin as ToComputedValue>::ComputedValue),
    /// `caption-side`
    CaptionSide(<longhands::caption_side::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `clear`
    Clear(<crate::values::specified::Clear as ToComputedValue>::ComputedValue),
    /// `color-adjust`
    ColorAdjust(<longhands::color_adjust::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `color-interpolation`
    ColorInterpolation(<longhands::color_interpolation::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `color-interpolation-filters`
    ColorInterpolationFilters(<longhands::color_interpolation_filters::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `column-count`
    ColumnCount(<<crate::values::specified::ColumnCount as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `column-fill`
    ColumnFill(<longhands::column_fill::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `column-span`
    ColumnSpan(<longhands::column_span::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `contain`
    Contain(Void),
    /// `direction`
    Direction(Void),
    /// `display`
    Display(<crate::values::specified::Display as ToComputedValue>::ComputedValue),
    /// `dominant-baseline`
    DominantBaseline(<longhands::dominant_baseline::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `empty-cells`
    EmptyCells(<longhands::empty_cells::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `flex-direction`
    FlexDirection(<longhands::flex_direction::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `flex-wrap`
    FlexWrap(<longhands::flex_wrap::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `float`
    Float(<crate::values::specified::Float as ToComputedValue>::ComputedValue),
    /// `font-kerning`
    FontKerning(<longhands::font_kerning::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `font-optical-sizing`
    FontOpticalSizing(<longhands::font_optical_sizing::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `font-size-adjust`
    FontSizeAdjust(<crate::values::specified::FontSizeAdjust as ToComputedValue>::ComputedValue),
    /// `font-stretch`
    FontStretch(<<crate::values::specified::FontStretch as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `font-style`
    FontStyle(<<crate::values::specified::FontStyle as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `font-synthesis`
    FontSynthesis(<crate::values::specified::FontSynthesis as ToComputedValue>::ComputedValue),
    /// `font-variant-caps`
    FontVariantCaps(<longhands::font_variant_caps::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `font-variant-east-asian`
    FontVariantEastAsian(<crate::values::specified::FontVariantEastAsian as ToComputedValue>::ComputedValue),
    /// `font-variant-ligatures`
    FontVariantLigatures(<crate::values::specified::FontVariantLigatures as ToComputedValue>::ComputedValue),
    /// `font-variant-numeric`
    FontVariantNumeric(<crate::values::specified::FontVariantNumeric as ToComputedValue>::ComputedValue),
    /// `font-variant-position`
    FontVariantPosition(<longhands::font_variant_position::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `font-weight`
    FontWeight(<<crate::values::specified::FontWeight as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `grid-auto-flow`
    GridAutoFlow(<crate::values::specified::GridAutoFlow as ToComputedValue>::ComputedValue),
    /// `hyphens`
    Hyphens(<longhands::hyphens::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `image-orientation`
    ImageOrientation(<longhands::image_orientation::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `image-rendering`
    ImageRendering(<longhands::image_rendering::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `ime-mode`
    ImeMode(<longhands::ime_mode::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `initial-letter`
    InitialLetter(<crate::values::specified::InitialLetter as ToComputedValue>::ComputedValue),
    /// `isolation`
    Isolation(<longhands::isolation::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `justify-content`
    JustifyContent(<crate::values::specified::JustifyContent as ToComputedValue>::ComputedValue),
    /// `justify-items`
    JustifyItems(<crate::values::specified::JustifyItems as ToComputedValue>::ComputedValue),
    /// `justify-self`
    JustifySelf(<crate::values::specified::JustifySelf as ToComputedValue>::ComputedValue),
    /// `list-style-position`
    ListStylePosition(<longhands::list_style_position::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `mask-type`
    MaskType(<longhands::mask_type::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `mix-blend-mode`
    MixBlendMode(<longhands::mix_blend_mode::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `-moz-appearance`
    MozAppearance(<crate::values::specified::Appearance as ToComputedValue>::ComputedValue),
    /// `-moz-box-align`
    MozBoxAlign(<longhands::_moz_box_align::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `-moz-box-direction`
    MozBoxDirection(<longhands::_moz_box_direction::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `-moz-box-orient`
    MozBoxOrient(<longhands::_moz_box_orient::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `-moz-box-pack`
    MozBoxPack(<longhands::_moz_box_pack::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `-moz-control-character-visibility`
    MozControlCharacterVisibility(Void),
    /// `-moz-float-edge`
    MozFloatEdge(<longhands::_moz_float_edge::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `-moz-force-broken-image-icon`
    MozForceBrokenImageIcon(<crate::values::specified::MozForceBrokenImageIcon as ToComputedValue>::ComputedValue),
    /// `-moz-list-reversed`
    MozListReversed(<crate::values::specified::MozListReversed as ToComputedValue>::ComputedValue),
    /// `-moz-math-display`
    MozMathDisplay(Void),
    /// `-moz-math-variant`
    MozMathVariant(Void),
    /// `-moz-min-font-size-ratio`
    MozMinFontSizeRatio(Void),
    /// `-moz-orient`
    MozOrient(<longhands::_moz_orient::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `-moz-osx-font-smoothing`
    MozOsxFontSmoothing(<longhands::_moz_osx_font_smoothing::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `-moz-script-level`
    MozScriptLevel(Void),
    /// `-moz-script-min-size`
    MozScriptMinSize(Void),
    /// `-moz-script-size-multiplier`
    MozScriptSizeMultiplier(Void),
    /// `-moz-stack-sizing`
    MozStackSizing(<longhands::_moz_stack_sizing::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `-moz-text-size-adjust`
    MozTextSizeAdjust(<longhands::_moz_text_size_adjust::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `-moz-top-layer`
    MozTopLayer(Void),
    /// `-moz-user-focus`
    MozUserFocus(<longhands::_moz_user_focus::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `-moz-user-input`
    MozUserInput(<longhands::_moz_user_input::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `-moz-user-modify`
    MozUserModify(<longhands::_moz_user_modify::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `-moz-user-select`
    MozUserSelect(<crate::values::specified::UserSelect as ToComputedValue>::ComputedValue),
    /// `-moz-window-dragging`
    MozWindowDragging(<longhands::_moz_window_dragging::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `-moz-window-shadow`
    MozWindowShadow(<longhands::_moz_window_shadow::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `object-fit`
    ObjectFit(<longhands::object_fit::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `outline-style`
    OutlineStyle(<crate::values::specified::OutlineStyle as ToComputedValue>::ComputedValue),
    /// `overflow-anchor`
    OverflowAnchor(<crate::values::specified::OverflowAnchor as ToComputedValue>::ComputedValue),
    /// `overflow-wrap`
    OverflowWrap(<crate::values::specified::OverflowWrap as ToComputedValue>::ComputedValue),
    /// `paint-order`
    PaintOrder(<crate::values::specified::SVGPaintOrder as ToComputedValue>::ComputedValue),
    /// `pointer-events`
    PointerEvents(<longhands::pointer_events::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `position`
    Position(<longhands::position::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `resize`
    Resize(<crate::values::specified::Resize as ToComputedValue>::ComputedValue),
    /// `ruby-align`
    RubyAlign(<longhands::ruby_align::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `ruby-position`
    RubyPosition(<longhands::ruby_position::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `scroll-behavior`
    ScrollBehavior(<longhands::scroll_behavior::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `scroll-snap-align`
    ScrollSnapAlign(<crate::values::specified::ScrollSnapAlign as ToComputedValue>::ComputedValue),
    /// `scroll-snap-type`
    ScrollSnapType(<crate::values::specified::ScrollSnapType as ToComputedValue>::ComputedValue),
    /// `scrollbar-width`
    ScrollbarWidth(<longhands::scrollbar_width::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `shape-rendering`
    ShapeRendering(<longhands::shape_rendering::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `stroke-linecap`
    StrokeLinecap(<longhands::stroke_linecap::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `stroke-linejoin`
    StrokeLinejoin(<longhands::stroke_linejoin::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `table-layout`
    TableLayout(<longhands::table_layout::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `text-align`
    TextAlign(<crate::values::specified::TextAlign as ToComputedValue>::ComputedValue),
    /// `text-align-last`
    TextAlignLast(<longhands::text_align_last::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `text-anchor`
    TextAnchor(<longhands::text_anchor::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `text-combine-upright`
    TextCombineUpright(<longhands::text_combine_upright::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `text-decoration-line`
    TextDecorationLine(<crate::values::specified::TextDecorationLine as ToComputedValue>::ComputedValue),
    /// `text-decoration-style`
    TextDecorationStyle(<longhands::text_decoration_style::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `text-emphasis-position`
    TextEmphasisPosition(<crate::values::specified::TextEmphasisPosition as ToComputedValue>::ComputedValue),
    /// `text-justify`
    TextJustify(<longhands::text_justify::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `text-orientation`
    TextOrientation(Void),
    /// `text-rendering`
    TextRendering(<longhands::text_rendering::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `text-transform`
    TextTransform(<crate::values::specified::TextTransform as ToComputedValue>::ComputedValue),
    /// `touch-action`
    TouchAction(<crate::values::specified::TouchAction as ToComputedValue>::ComputedValue),
    /// `transform-box`
    TransformBox(<longhands::transform_box::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `transform-style`
    TransformStyle(<crate::values::specified::TransformStyle as ToComputedValue>::ComputedValue),
    /// `unicode-bidi`
    UnicodeBidi(Void),
    /// `vector-effect`
    VectorEffect(<longhands::vector_effect::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `visibility`
    Visibility(<longhands::visibility::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `-webkit-line-clamp`
    WebkitLineClamp(<<crate::values::specified::PositiveIntegerOrNone as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `white-space`
    WhiteSpace(<longhands::white_space::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `word-break`
    WordBreak(<crate::values::specified::WordBreak as ToComputedValue>::ComputedValue),
    /// `writing-mode`
    WritingMode(Void),
    /// `-x-span`
    XSpan(Void),
    /// `-x-text-zoom`
    XTextZoom(Void),
    /// `z-index`
    ZIndex(<crate::values::specified::ZIndex as ToComputedValue>::ComputedValue),
    /// `break-after`
    BreakAfter(<crate::values::specified::BreakBetween as ToComputedValue>::ComputedValue),
    /// `break-before`
    BreakBefore(<crate::values::specified::BreakBetween as ToComputedValue>::ComputedValue),
    /// `clip-rule`
    ClipRule(<crate::values::specified::FillRule as ToComputedValue>::ComputedValue),
    /// `fill-rule`
    FillRule(<crate::values::specified::FillRule as ToComputedValue>::ComputedValue),
    /// `-moz-box-ordinal-group`
    MozBoxOrdinalGroup(<crate::values::specified::Integer as ToComputedValue>::ComputedValue),
    /// `order`
    Order(<crate::values::specified::Integer as ToComputedValue>::ComputedValue),
    /// `overflow-x`
    OverflowX(<crate::values::specified::Overflow as ToComputedValue>::ComputedValue),
    /// `overflow-y`
    OverflowY(<crate::values::specified::Overflow as ToComputedValue>::ComputedValue),
    /// `overflow-clip-box-block`
    OverflowClipBoxBlock(<crate::values::specified::OverflowClipBox as ToComputedValue>::ComputedValue),
    /// `overflow-clip-box-inline`
    OverflowClipBoxInline(<crate::values::specified::OverflowClipBox as ToComputedValue>::ComputedValue),
    /// `overscroll-behavior-x`
    OverscrollBehaviorX(<crate::values::specified::OverscrollBehavior as ToComputedValue>::ComputedValue),
    /// `overscroll-behavior-y`
    OverscrollBehaviorY(<crate::values::specified::OverscrollBehavior as ToComputedValue>::ComputedValue),
    /// `fill-opacity`
    FillOpacity(<crate::values::specified::SVGOpacity as ToComputedValue>::ComputedValue),
    /// `stroke-opacity`
    StrokeOpacity(<crate::values::specified::SVGOpacity as ToComputedValue>::ComputedValue),
    /// `flex-grow`
    FlexGrow(<<crate::values::specified::NonNegativeNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `flex-shrink`
    FlexShrink(<<crate::values::specified::NonNegativeNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `-moz-box-flex`
    MozBoxFlex(<<crate::values::specified::NonNegativeNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `stroke-miterlimit`
    StrokeMiterlimit(<<crate::values::specified::NonNegativeNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `flood-opacity`
    FloodOpacity(<crate::values::specified::Opacity as ToComputedValue>::ComputedValue),
    /// `-moz-window-opacity`
    MozWindowOpacity(<crate::values::specified::Opacity as ToComputedValue>::ComputedValue),
    /// `opacity`
    Opacity(<crate::values::specified::Opacity as ToComputedValue>::ComputedValue),
    /// `shape-image-threshold`
    ShapeImageThreshold(<crate::values::specified::Opacity as ToComputedValue>::ComputedValue),
    /// `stop-opacity`
    StopOpacity(<crate::values::specified::Opacity as ToComputedValue>::ComputedValue),
    /// `border-block-end-style`
    BorderBlockEndStyle(Void),
    /// `border-block-start-style`
    BorderBlockStartStyle(Void),
    /// `border-bottom-style`
    BorderBottomStyle(<crate::values::specified::BorderStyle as ToComputedValue>::ComputedValue),
    /// `border-inline-end-style`
    BorderInlineEndStyle(Void),
    /// `border-inline-start-style`
    BorderInlineStartStyle(Void),
    /// `border-left-style`
    BorderLeftStyle(<crate::values::specified::BorderStyle as ToComputedValue>::ComputedValue),
    /// `border-right-style`
    BorderRightStyle(<crate::values::specified::BorderStyle as ToComputedValue>::ComputedValue),
    /// `border-top-style`
    BorderTopStyle(<crate::values::specified::BorderStyle as ToComputedValue>::ComputedValue),
    /// `column-rule-style`
    ColumnRuleStyle(<crate::values::specified::BorderStyle as ToComputedValue>::ComputedValue),
    /// `animation-delay`
    AnimationDelay(Void),
    /// `animation-direction`
    AnimationDirection(Void),
    /// `animation-duration`
    AnimationDuration(Void),
    /// `animation-fill-mode`
    AnimationFillMode(Void),
    /// `animation-iteration-count`
    AnimationIterationCount(Void),
    /// `animation-name`
    AnimationName(Void),
    /// `animation-play-state`
    AnimationPlayState(Void),
    /// `animation-timing-function`
    AnimationTimingFunction(Void),
    /// `background-attachment`
    BackgroundAttachment(<longhands::background_attachment::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `background-blend-mode`
    BackgroundBlendMode(<longhands::background_blend_mode::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `background-clip`
    BackgroundClip(<longhands::background_clip::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `background-image`
    BackgroundImage(<longhands::background_image::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `background-origin`
    BackgroundOrigin(<longhands::background_origin::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `background-position-x`
    BackgroundPositionX(<longhands::background_position_x::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `background-position-y`
    BackgroundPositionY(<longhands::background_position_y::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `background-repeat`
    BackgroundRepeat(<longhands::background_repeat::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `background-size`
    BackgroundSize(<<longhands::background_size::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `border-image-outset`
    BorderImageOutset(<crate::values::specified::NonNegativeLengthOrNumberRect as ToComputedValue>::ComputedValue),
    /// `border-image-slice`
    BorderImageSlice(<crate::values::specified::BorderImageSlice as ToComputedValue>::ComputedValue),
    /// `border-image-source`
    BorderImageSource(<crate::values::specified::ImageLayer as ToComputedValue>::ComputedValue),
    /// `border-image-width`
    BorderImageWidth(<crate::values::specified::BorderImageWidth as ToComputedValue>::ComputedValue),
    /// `border-spacing`
    BorderSpacing(<<crate::values::specified::BorderSpacing as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `box-shadow`
    BoxShadow(<<longhands::box_shadow::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `caret-color`
    CaretColor(<<crate::values::specified::ColorOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `clip-path`
    ClipPath(<<crate::values::specified::basic_shape::ClippingShape as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `color`
    Color(<<crate::values::specified::ColorPropertyValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `column-width`
    ColumnWidth(<<crate::values::specified::length::NonNegativeLengthOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `content`
    Content(<crate::values::specified::Content as ToComputedValue>::ComputedValue),
    /// `counter-increment`
    CounterIncrement(<crate::values::specified::CounterIncrement as ToComputedValue>::ComputedValue),
    /// `cursor`
    Cursor(<crate::values::specified::Cursor as ToComputedValue>::ComputedValue),
    /// `filter`
    Filter(<<longhands::filter::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `flex-basis`
    FlexBasis(<<crate::values::specified::FlexBasis as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `font-family`
    FontFamily(<crate::values::specified::FontFamily as ToComputedValue>::ComputedValue),
    /// `font-feature-settings`
    FontFeatureSettings(<crate::values::specified::FontFeatureSettings as ToComputedValue>::ComputedValue),
    /// `font-language-override`
    FontLanguageOverride(<crate::values::specified::FontLanguageOverride as ToComputedValue>::ComputedValue),
    /// `font-size`
    FontSize(<<crate::values::specified::FontSize as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `font-variant-alternates`
    FontVariantAlternates(<crate::values::specified::FontVariantAlternates as ToComputedValue>::ComputedValue),
    /// `font-variation-settings`
    FontVariationSettings(<crate::values::specified::FontVariationSettings as ToComputedValue>::ComputedValue),
    /// `grid-template-areas`
    GridTemplateAreas(<crate::values::specified::GridTemplateAreas as ToComputedValue>::ComputedValue),
    /// `letter-spacing`
    LetterSpacing(<crate::values::specified::LetterSpacing as ToComputedValue>::ComputedValue),
    /// `line-height`
    LineHeight(<<crate::values::specified::LineHeight as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `list-style-image`
    ListStyleImage(<crate::values::specified::url::ImageUrlOrNone as ToComputedValue>::ComputedValue),
    /// `list-style-type`
    ListStyleType(<crate::values::specified::ListStyleType as ToComputedValue>::ComputedValue),
    /// `mask-clip`
    MaskClip(<longhands::mask_clip::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `mask-composite`
    MaskComposite(<longhands::mask_composite::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `mask-image`
    MaskImage(<longhands::mask_image::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `mask-mode`
    MaskMode(<longhands::mask_mode::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `mask-origin`
    MaskOrigin(<longhands::mask_origin::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `mask-position-x`
    MaskPositionX(<longhands::mask_position_x::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `mask-position-y`
    MaskPositionY(<longhands::mask_position_y::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `mask-repeat`
    MaskRepeat(<longhands::mask_repeat::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `mask-size`
    MaskSize(<<longhands::mask_size::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `-moz-context-properties`
    MozContextProperties(Void),
    /// `-moz-font-smoothing-background-color`
    MozFontSmoothingBackgroundColor(Void),
    /// `-moz-tab-size`
    MozTabSize(<<crate::values::specified::NonNegativeLengthOrNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `offset-path`
    OffsetPath(<crate::values::specified::OffsetPath as ToComputedValue>::ComputedValue),
    /// `perspective`
    Perspective(<<crate::values::specified::Perspective as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `quotes`
    Quotes(<crate::values::specified::Quotes as ToComputedValue>::ComputedValue),
    /// `rotate`
    Rotate(<crate::values::specified::Rotate as ToComputedValue>::ComputedValue),
    /// `scale`
    Scale(<crate::values::specified::Scale as ToComputedValue>::ComputedValue),
    /// `scroll-snap-coordinate`
    ScrollSnapCoordinate(<longhands::scroll_snap_coordinate::SpecifiedValue as ToComputedValue>::ComputedValue),
    /// `scrollbar-color`
    ScrollbarColor(<<crate::values::specified::ui::ScrollbarColor as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `shape-outside`
    ShapeOutside(<<crate::values::specified::basic_shape::FloatAreaShape as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `stroke-dasharray`
    StrokeDasharray(<<crate::values::specified::SVGStrokeDashArray as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `stroke-dashoffset`
    StrokeDashoffset(<crate::values::specified::SVGLength as ToComputedValue>::ComputedValue),
    /// `stroke-width`
    StrokeWidth(<<crate::values::specified::SVGWidth as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `text-emphasis-style`
    TextEmphasisStyle(<crate::values::specified::TextEmphasisStyle as ToComputedValue>::ComputedValue),
    /// `text-indent`
    TextIndent(<crate::values::specified::LengthPercentage as ToComputedValue>::ComputedValue),
    /// `text-overflow`
    TextOverflow(<crate::values::specified::TextOverflow as ToComputedValue>::ComputedValue),
    /// `text-shadow`
    TextShadow(<<longhands::text_shadow::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `transition-delay`
    TransitionDelay(Void),
    /// `transition-duration`
    TransitionDuration(Void),
    /// `transition-property`
    TransitionProperty(Void),
    /// `transition-timing-function`
    TransitionTimingFunction(Void),
    /// `translate`
    Translate(<crate::values::specified::Translate as ToComputedValue>::ComputedValue),
    /// `vertical-align`
    VerticalAlign(<crate::values::specified::VerticalAlign as ToComputedValue>::ComputedValue),
    /// `will-change`
    WillChange(Void),
    /// `word-spacing`
    WordSpacing(<crate::values::specified::WordSpacing as ToComputedValue>::ComputedValue),
    /// `-x-lang`
    XLang(Void),
    /// `clip`
    Clip(<crate::values::specified::ClipRectOrAuto as ToComputedValue>::ComputedValue),
    /// `-moz-image-region`
    MozImageRegion(<crate::values::specified::ClipRectOrAuto as ToComputedValue>::ComputedValue),
    /// `grid-template-columns`
    GridTemplateColumns(<crate::values::specified::GridTemplateComponent as ToComputedValue>::ComputedValue),
    /// `grid-template-rows`
    GridTemplateRows(<crate::values::specified::GridTemplateComponent as ToComputedValue>::ComputedValue),
    /// `fill`
    Fill(<<crate::values::specified::SVGPaint as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `stroke`
    Stroke(<<crate::values::specified::SVGPaint as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `grid-auto-columns`
    GridAutoColumns(<crate::values::specified::TrackSize as ToComputedValue>::ComputedValue),
    /// `grid-auto-rows`
    GridAutoRows(<crate::values::specified::TrackSize as ToComputedValue>::ComputedValue),
    /// `-moz-window-transform-origin`
    MozWindowTransformOrigin(<crate::values::specified::TransformOrigin as ToComputedValue>::ComputedValue),
    /// `transform-origin`
    TransformOrigin(<crate::values::specified::TransformOrigin as ToComputedValue>::ComputedValue),
    /// `counter-reset`
    CounterReset(<crate::values::specified::CounterSetOrReset as ToComputedValue>::ComputedValue),
    /// `counter-set`
    CounterSet(<crate::values::specified::CounterSetOrReset as ToComputedValue>::ComputedValue),
    /// `scroll-snap-points-x`
    ScrollSnapPointsX(<crate::values::specified::ScrollSnapPoint as ToComputedValue>::ComputedValue),
    /// `scroll-snap-points-y`
    ScrollSnapPointsY(<crate::values::specified::ScrollSnapPoint as ToComputedValue>::ComputedValue),
    /// `-moz-window-transform`
    MozWindowTransform(<crate::values::specified::Transform as ToComputedValue>::ComputedValue),
    /// `transform`
    Transform(<crate::values::specified::Transform as ToComputedValue>::ComputedValue),
    /// `column-gap`
    ColumnGap(<<crate::values::specified::length::NonNegativeLengthPercentageOrNormal as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `row-gap`
    RowGap(<<crate::values::specified::length::NonNegativeLengthPercentageOrNormal as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `object-position`
    ObjectPosition(<crate::values::specified::Position as ToComputedValue>::ComputedValue),
    /// `perspective-origin`
    PerspectiveOrigin(<crate::values::specified::Position as ToComputedValue>::ComputedValue),
    /// `scroll-snap-destination`
    ScrollSnapDestination(<crate::values::specified::Position as ToComputedValue>::ComputedValue),
    /// `grid-column-end`
    GridColumnEnd(<crate::values::specified::GridLine as ToComputedValue>::ComputedValue),
    /// `grid-column-start`
    GridColumnStart(<crate::values::specified::GridLine as ToComputedValue>::ComputedValue),
    /// `grid-row-end`
    GridRowEnd(<crate::values::specified::GridLine as ToComputedValue>::ComputedValue),
    /// `grid-row-start`
    GridRowStart(<crate::values::specified::GridLine as ToComputedValue>::ComputedValue),
    /// `max-block-size`
    MaxBlockSize(Void),
    /// `max-height`
    MaxHeight(<<crate::values::specified::MaxSize as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `max-inline-size`
    MaxInlineSize(Void),
    /// `max-width`
    MaxWidth(<<crate::values::specified::MaxSize as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `marker-end`
    MarkerEnd(<crate::values::specified::url::UrlOrNone as ToComputedValue>::ComputedValue),
    /// `marker-mid`
    MarkerMid(<crate::values::specified::url::UrlOrNone as ToComputedValue>::ComputedValue),
    /// `marker-start`
    MarkerStart(<crate::values::specified::url::UrlOrNone as ToComputedValue>::ComputedValue),
    /// `-moz-binding`
    MozBinding(Void),
    /// `scroll-padding-block-end`
    ScrollPaddingBlockEnd(Void),
    /// `scroll-padding-block-start`
    ScrollPaddingBlockStart(Void),
    /// `scroll-padding-bottom`
    ScrollPaddingBottom(<<crate::values::specified::NonNegativeLengthPercentageOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `scroll-padding-inline-end`
    ScrollPaddingInlineEnd(Void),
    /// `scroll-padding-inline-start`
    ScrollPaddingInlineStart(Void),
    /// `scroll-padding-left`
    ScrollPaddingLeft(<<crate::values::specified::NonNegativeLengthPercentageOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `scroll-padding-right`
    ScrollPaddingRight(<<crate::values::specified::NonNegativeLengthPercentageOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `scroll-padding-top`
    ScrollPaddingTop(<<crate::values::specified::NonNegativeLengthPercentageOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `block-size`
    BlockSize(Void),
    /// `height`
    Height(<<crate::values::specified::Size as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `inline-size`
    InlineSize(Void),
    /// `min-block-size`
    MinBlockSize(Void),
    /// `min-height`
    MinHeight(<<crate::values::specified::Size as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `min-inline-size`
    MinInlineSize(Void),
    /// `min-width`
    MinWidth(<<crate::values::specified::Size as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `width`
    Width(<<crate::values::specified::Size as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `outline-offset`
    OutlineOffset(<crate::values::specified::Length as ToComputedValue>::ComputedValue),
    /// `scroll-margin-block-end`
    ScrollMarginBlockEnd(Void),
    /// `scroll-margin-block-start`
    ScrollMarginBlockStart(Void),
    /// `scroll-margin-bottom`
    ScrollMarginBottom(<crate::values::specified::Length as ToComputedValue>::ComputedValue),
    /// `scroll-margin-inline-end`
    ScrollMarginInlineEnd(Void),
    /// `scroll-margin-inline-start`
    ScrollMarginInlineStart(Void),
    /// `scroll-margin-left`
    ScrollMarginLeft(<crate::values::specified::Length as ToComputedValue>::ComputedValue),
    /// `scroll-margin-right`
    ScrollMarginRight(<crate::values::specified::Length as ToComputedValue>::ComputedValue),
    /// `scroll-margin-top`
    ScrollMarginTop(<crate::values::specified::Length as ToComputedValue>::ComputedValue),
    /// `padding-block-end`
    PaddingBlockEnd(Void),
    /// `padding-block-start`
    PaddingBlockStart(Void),
    /// `padding-bottom`
    PaddingBottom(<<crate::values::specified::NonNegativeLengthPercentage as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `padding-inline-end`
    PaddingInlineEnd(Void),
    /// `padding-inline-start`
    PaddingInlineStart(Void),
    /// `padding-left`
    PaddingLeft(<<crate::values::specified::NonNegativeLengthPercentage as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `padding-right`
    PaddingRight(<<crate::values::specified::NonNegativeLengthPercentage as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `padding-top`
    PaddingTop(<<crate::values::specified::NonNegativeLengthPercentage as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `shape-margin`
    ShapeMargin(<<crate::values::specified::NonNegativeLengthPercentage as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `border-block-end-width`
    BorderBlockEndWidth(Void),
    /// `border-block-start-width`
    BorderBlockStartWidth(Void),
    /// `border-bottom-width`
    BorderBottomWidth(<<crate::values::specified::BorderSideWidth as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `border-inline-end-width`
    BorderInlineEndWidth(Void),
    /// `border-inline-start-width`
    BorderInlineStartWidth(Void),
    /// `border-left-width`
    BorderLeftWidth(<<crate::values::specified::BorderSideWidth as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `border-right-width`
    BorderRightWidth(<<crate::values::specified::BorderSideWidth as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `border-top-width`
    BorderTopWidth(<<crate::values::specified::BorderSideWidth as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `column-rule-width`
    ColumnRuleWidth(<<crate::values::specified::BorderSideWidth as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `outline-width`
    OutlineWidth(<<crate::values::specified::BorderSideWidth as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `-webkit-text-stroke-width`
    WebkitTextStrokeWidth(<crate::values::specified::BorderSideWidth as ToComputedValue>::ComputedValue),
    /// `border-bottom-left-radius`
    BorderBottomLeftRadius(<<crate::values::specified::BorderCornerRadius as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `border-bottom-right-radius`
    BorderBottomRightRadius(<<crate::values::specified::BorderCornerRadius as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `border-end-end-radius`
    BorderEndEndRadius(Void),
    /// `border-end-start-radius`
    BorderEndStartRadius(Void),
    /// `border-start-end-radius`
    BorderStartEndRadius(Void),
    /// `border-start-start-radius`
    BorderStartStartRadius(Void),
    /// `border-top-left-radius`
    BorderTopLeftRadius(<<crate::values::specified::BorderCornerRadius as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `border-top-right-radius`
    BorderTopRightRadius(<<crate::values::specified::BorderCornerRadius as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `-moz-outline-radius-bottomleft`
    MozOutlineRadiusBottomleft(<<crate::values::specified::BorderCornerRadius as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `-moz-outline-radius-bottomright`
    MozOutlineRadiusBottomright(<<crate::values::specified::BorderCornerRadius as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `-moz-outline-radius-topleft`
    MozOutlineRadiusTopleft(<<crate::values::specified::BorderCornerRadius as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `-moz-outline-radius-topright`
    MozOutlineRadiusTopright(<<crate::values::specified::BorderCornerRadius as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `bottom`
    Bottom(<crate::values::specified::LengthPercentageOrAuto as ToComputedValue>::ComputedValue),
    /// `inset-block-end`
    InsetBlockEnd(Void),
    /// `inset-block-start`
    InsetBlockStart(Void),
    /// `inset-inline-end`
    InsetInlineEnd(Void),
    /// `inset-inline-start`
    InsetInlineStart(Void),
    /// `left`
    Left(<crate::values::specified::LengthPercentageOrAuto as ToComputedValue>::ComputedValue),
    /// `margin-block-end`
    MarginBlockEnd(Void),
    /// `margin-block-start`
    MarginBlockStart(Void),
    /// `margin-bottom`
    MarginBottom(<crate::values::specified::LengthPercentageOrAuto as ToComputedValue>::ComputedValue),
    /// `margin-inline-end`
    MarginInlineEnd(Void),
    /// `margin-inline-start`
    MarginInlineStart(Void),
    /// `margin-left`
    MarginLeft(<crate::values::specified::LengthPercentageOrAuto as ToComputedValue>::ComputedValue),
    /// `margin-right`
    MarginRight(<crate::values::specified::LengthPercentageOrAuto as ToComputedValue>::ComputedValue),
    /// `margin-top`
    MarginTop(<crate::values::specified::LengthPercentageOrAuto as ToComputedValue>::ComputedValue),
    /// `right`
    Right(<crate::values::specified::LengthPercentageOrAuto as ToComputedValue>::ComputedValue),
    /// `top`
    Top(<crate::values::specified::LengthPercentageOrAuto as ToComputedValue>::ComputedValue),
    /// `background-color`
    BackgroundColor(<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `border-block-end-color`
    BorderBlockEndColor(Void),
    /// `border-block-start-color`
    BorderBlockStartColor(Void),
    /// `border-bottom-color`
    BorderBottomColor(<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `border-inline-end-color`
    BorderInlineEndColor(Void),
    /// `border-inline-start-color`
    BorderInlineStartColor(Void),
    /// `border-left-color`
    BorderLeftColor(<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `border-right-color`
    BorderRightColor(<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `border-top-color`
    BorderTopColor(<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `column-rule-color`
    ColumnRuleColor(<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `flood-color`
    FloodColor(<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `lighting-color`
    LightingColor(<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `outline-color`
    OutlineColor(<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `stop-color`
    StopColor(<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `text-decoration-color`
    TextDecorationColor(<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `text-emphasis-color`
    TextEmphasisColor(<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `-webkit-text-fill-color`
    WebkitTextFillColor(<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
    /// `-webkit-text-stroke-color`
    WebkitTextStrokeColor(<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
}



#[repr(C)]
struct AnimationValueVariantRepr<T> {
    tag: u16,
    value: T
}

impl Clone for AnimationValue {
    #[inline]
    fn clone(&self) -> Self {
        use self::AnimationValue::*;

        

        let self_tag = unsafe { *(self as *const _ as *const u16) };
        if self_tag <= LonghandId::ColumnRuleStyle as u16 {
            #[derive(Clone, Copy)]
            #[repr(u16)]
            enum CopyVariants {
                _AlignContent(<crate::values::specified::AlignContent as ToComputedValue>::ComputedValue),
                _AlignItems(<crate::values::specified::AlignItems as ToComputedValue>::ComputedValue),
                _AlignSelf(<crate::values::specified::AlignSelf as ToComputedValue>::ComputedValue),
                _BackfaceVisibility(<longhands::backface_visibility::SpecifiedValue as ToComputedValue>::ComputedValue),
                _BorderCollapse(<longhands::border_collapse::SpecifiedValue as ToComputedValue>::ComputedValue),
                _BorderImageRepeat(<crate::values::specified::BorderImageRepeat as ToComputedValue>::ComputedValue),
                _BoxDecorationBreak(<longhands::box_decoration_break::SpecifiedValue as ToComputedValue>::ComputedValue),
                _BoxSizing(<longhands::box_sizing::SpecifiedValue as ToComputedValue>::ComputedValue),
                _BreakInside(<crate::values::specified::BreakWithin as ToComputedValue>::ComputedValue),
                _CaptionSide(<longhands::caption_side::SpecifiedValue as ToComputedValue>::ComputedValue),
                _Clear(<crate::values::specified::Clear as ToComputedValue>::ComputedValue),
                _ColorAdjust(<longhands::color_adjust::SpecifiedValue as ToComputedValue>::ComputedValue),
                _ColorInterpolation(<longhands::color_interpolation::SpecifiedValue as ToComputedValue>::ComputedValue),
                _ColorInterpolationFilters(<longhands::color_interpolation_filters::SpecifiedValue as ToComputedValue>::ComputedValue),
                _ColumnCount(<<crate::values::specified::ColumnCount as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
                _ColumnFill(<longhands::column_fill::SpecifiedValue as ToComputedValue>::ComputedValue),
                _ColumnSpan(<longhands::column_span::SpecifiedValue as ToComputedValue>::ComputedValue),
                _Display(<crate::values::specified::Display as ToComputedValue>::ComputedValue),
                _DominantBaseline(<longhands::dominant_baseline::SpecifiedValue as ToComputedValue>::ComputedValue),
                _EmptyCells(<longhands::empty_cells::SpecifiedValue as ToComputedValue>::ComputedValue),
                _FlexDirection(<longhands::flex_direction::SpecifiedValue as ToComputedValue>::ComputedValue),
                _FlexWrap(<longhands::flex_wrap::SpecifiedValue as ToComputedValue>::ComputedValue),
                _Float(<crate::values::specified::Float as ToComputedValue>::ComputedValue),
                _FontKerning(<longhands::font_kerning::SpecifiedValue as ToComputedValue>::ComputedValue),
                _FontOpticalSizing(<longhands::font_optical_sizing::SpecifiedValue as ToComputedValue>::ComputedValue),
                _FontSizeAdjust(<crate::values::specified::FontSizeAdjust as ToComputedValue>::ComputedValue),
                _FontStretch(<<crate::values::specified::FontStretch as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
                _FontStyle(<<crate::values::specified::FontStyle as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
                _FontSynthesis(<crate::values::specified::FontSynthesis as ToComputedValue>::ComputedValue),
                _FontVariantCaps(<longhands::font_variant_caps::SpecifiedValue as ToComputedValue>::ComputedValue),
                _FontVariantEastAsian(<crate::values::specified::FontVariantEastAsian as ToComputedValue>::ComputedValue),
                _FontVariantLigatures(<crate::values::specified::FontVariantLigatures as ToComputedValue>::ComputedValue),
                _FontVariantNumeric(<crate::values::specified::FontVariantNumeric as ToComputedValue>::ComputedValue),
                _FontVariantPosition(<longhands::font_variant_position::SpecifiedValue as ToComputedValue>::ComputedValue),
                _FontWeight(<<crate::values::specified::FontWeight as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
                _GridAutoFlow(<crate::values::specified::GridAutoFlow as ToComputedValue>::ComputedValue),
                _Hyphens(<longhands::hyphens::SpecifiedValue as ToComputedValue>::ComputedValue),
                _ImageOrientation(<longhands::image_orientation::SpecifiedValue as ToComputedValue>::ComputedValue),
                _ImageRendering(<longhands::image_rendering::SpecifiedValue as ToComputedValue>::ComputedValue),
                _ImeMode(<longhands::ime_mode::SpecifiedValue as ToComputedValue>::ComputedValue),
                _InitialLetter(<crate::values::specified::InitialLetter as ToComputedValue>::ComputedValue),
                _Isolation(<longhands::isolation::SpecifiedValue as ToComputedValue>::ComputedValue),
                _JustifyContent(<crate::values::specified::JustifyContent as ToComputedValue>::ComputedValue),
                _JustifyItems(<crate::values::specified::JustifyItems as ToComputedValue>::ComputedValue),
                _JustifySelf(<crate::values::specified::JustifySelf as ToComputedValue>::ComputedValue),
                _ListStylePosition(<longhands::list_style_position::SpecifiedValue as ToComputedValue>::ComputedValue),
                _MaskType(<longhands::mask_type::SpecifiedValue as ToComputedValue>::ComputedValue),
                _MixBlendMode(<longhands::mix_blend_mode::SpecifiedValue as ToComputedValue>::ComputedValue),
                _MozAppearance(<crate::values::specified::Appearance as ToComputedValue>::ComputedValue),
                _MozBoxAlign(<longhands::_moz_box_align::SpecifiedValue as ToComputedValue>::ComputedValue),
                _MozBoxDirection(<longhands::_moz_box_direction::SpecifiedValue as ToComputedValue>::ComputedValue),
                _MozBoxOrient(<longhands::_moz_box_orient::SpecifiedValue as ToComputedValue>::ComputedValue),
                _MozBoxPack(<longhands::_moz_box_pack::SpecifiedValue as ToComputedValue>::ComputedValue),
                _MozFloatEdge(<longhands::_moz_float_edge::SpecifiedValue as ToComputedValue>::ComputedValue),
                _MozForceBrokenImageIcon(<crate::values::specified::MozForceBrokenImageIcon as ToComputedValue>::ComputedValue),
                _MozListReversed(<crate::values::specified::MozListReversed as ToComputedValue>::ComputedValue),
                _MozOrient(<longhands::_moz_orient::SpecifiedValue as ToComputedValue>::ComputedValue),
                _MozOsxFontSmoothing(<longhands::_moz_osx_font_smoothing::SpecifiedValue as ToComputedValue>::ComputedValue),
                _MozStackSizing(<longhands::_moz_stack_sizing::SpecifiedValue as ToComputedValue>::ComputedValue),
                _MozTextSizeAdjust(<longhands::_moz_text_size_adjust::SpecifiedValue as ToComputedValue>::ComputedValue),
                _MozUserFocus(<longhands::_moz_user_focus::SpecifiedValue as ToComputedValue>::ComputedValue),
                _MozUserInput(<longhands::_moz_user_input::SpecifiedValue as ToComputedValue>::ComputedValue),
                _MozUserModify(<longhands::_moz_user_modify::SpecifiedValue as ToComputedValue>::ComputedValue),
                _MozUserSelect(<crate::values::specified::UserSelect as ToComputedValue>::ComputedValue),
                _MozWindowDragging(<longhands::_moz_window_dragging::SpecifiedValue as ToComputedValue>::ComputedValue),
                _MozWindowShadow(<longhands::_moz_window_shadow::SpecifiedValue as ToComputedValue>::ComputedValue),
                _ObjectFit(<longhands::object_fit::SpecifiedValue as ToComputedValue>::ComputedValue),
                _OutlineStyle(<crate::values::specified::OutlineStyle as ToComputedValue>::ComputedValue),
                _OverflowAnchor(<crate::values::specified::OverflowAnchor as ToComputedValue>::ComputedValue),
                _OverflowWrap(<crate::values::specified::OverflowWrap as ToComputedValue>::ComputedValue),
                _PaintOrder(<crate::values::specified::SVGPaintOrder as ToComputedValue>::ComputedValue),
                _PointerEvents(<longhands::pointer_events::SpecifiedValue as ToComputedValue>::ComputedValue),
                _Position(<longhands::position::SpecifiedValue as ToComputedValue>::ComputedValue),
                _Resize(<crate::values::specified::Resize as ToComputedValue>::ComputedValue),
                _RubyAlign(<longhands::ruby_align::SpecifiedValue as ToComputedValue>::ComputedValue),
                _RubyPosition(<longhands::ruby_position::SpecifiedValue as ToComputedValue>::ComputedValue),
                _ScrollBehavior(<longhands::scroll_behavior::SpecifiedValue as ToComputedValue>::ComputedValue),
                _ScrollSnapAlign(<crate::values::specified::ScrollSnapAlign as ToComputedValue>::ComputedValue),
                _ScrollSnapType(<crate::values::specified::ScrollSnapType as ToComputedValue>::ComputedValue),
                _ScrollbarWidth(<longhands::scrollbar_width::SpecifiedValue as ToComputedValue>::ComputedValue),
                _ShapeRendering(<longhands::shape_rendering::SpecifiedValue as ToComputedValue>::ComputedValue),
                _StrokeLinecap(<longhands::stroke_linecap::SpecifiedValue as ToComputedValue>::ComputedValue),
                _StrokeLinejoin(<longhands::stroke_linejoin::SpecifiedValue as ToComputedValue>::ComputedValue),
                _TableLayout(<longhands::table_layout::SpecifiedValue as ToComputedValue>::ComputedValue),
                _TextAlign(<crate::values::specified::TextAlign as ToComputedValue>::ComputedValue),
                _TextAlignLast(<longhands::text_align_last::SpecifiedValue as ToComputedValue>::ComputedValue),
                _TextAnchor(<longhands::text_anchor::SpecifiedValue as ToComputedValue>::ComputedValue),
                _TextCombineUpright(<longhands::text_combine_upright::SpecifiedValue as ToComputedValue>::ComputedValue),
                _TextDecorationLine(<crate::values::specified::TextDecorationLine as ToComputedValue>::ComputedValue),
                _TextDecorationStyle(<longhands::text_decoration_style::SpecifiedValue as ToComputedValue>::ComputedValue),
                _TextEmphasisPosition(<crate::values::specified::TextEmphasisPosition as ToComputedValue>::ComputedValue),
                _TextJustify(<longhands::text_justify::SpecifiedValue as ToComputedValue>::ComputedValue),
                _TextRendering(<longhands::text_rendering::SpecifiedValue as ToComputedValue>::ComputedValue),
                _TextTransform(<crate::values::specified::TextTransform as ToComputedValue>::ComputedValue),
                _TouchAction(<crate::values::specified::TouchAction as ToComputedValue>::ComputedValue),
                _TransformBox(<longhands::transform_box::SpecifiedValue as ToComputedValue>::ComputedValue),
                _TransformStyle(<crate::values::specified::TransformStyle as ToComputedValue>::ComputedValue),
                _VectorEffect(<longhands::vector_effect::SpecifiedValue as ToComputedValue>::ComputedValue),
                _Visibility(<longhands::visibility::SpecifiedValue as ToComputedValue>::ComputedValue),
                _WebkitLineClamp(<<crate::values::specified::PositiveIntegerOrNone as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
                _WhiteSpace(<longhands::white_space::SpecifiedValue as ToComputedValue>::ComputedValue),
                _WordBreak(<crate::values::specified::WordBreak as ToComputedValue>::ComputedValue),
                _ZIndex(<crate::values::specified::ZIndex as ToComputedValue>::ComputedValue),
                _BreakAfter(<crate::values::specified::BreakBetween as ToComputedValue>::ComputedValue),
                _BreakBefore(<crate::values::specified::BreakBetween as ToComputedValue>::ComputedValue),
                _ClipRule(<crate::values::specified::FillRule as ToComputedValue>::ComputedValue),
                _FillRule(<crate::values::specified::FillRule as ToComputedValue>::ComputedValue),
                _MozBoxOrdinalGroup(<crate::values::specified::Integer as ToComputedValue>::ComputedValue),
                _Order(<crate::values::specified::Integer as ToComputedValue>::ComputedValue),
                _OverflowX(<crate::values::specified::Overflow as ToComputedValue>::ComputedValue),
                _OverflowY(<crate::values::specified::Overflow as ToComputedValue>::ComputedValue),
                _OverflowClipBoxBlock(<crate::values::specified::OverflowClipBox as ToComputedValue>::ComputedValue),
                _OverflowClipBoxInline(<crate::values::specified::OverflowClipBox as ToComputedValue>::ComputedValue),
                _OverscrollBehaviorX(<crate::values::specified::OverscrollBehavior as ToComputedValue>::ComputedValue),
                _OverscrollBehaviorY(<crate::values::specified::OverscrollBehavior as ToComputedValue>::ComputedValue),
                _FillOpacity(<crate::values::specified::SVGOpacity as ToComputedValue>::ComputedValue),
                _StrokeOpacity(<crate::values::specified::SVGOpacity as ToComputedValue>::ComputedValue),
                _FlexGrow(<<crate::values::specified::NonNegativeNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
                _FlexShrink(<<crate::values::specified::NonNegativeNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
                _MozBoxFlex(<<crate::values::specified::NonNegativeNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
                _StrokeMiterlimit(<<crate::values::specified::NonNegativeNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue),
                _FloodOpacity(<crate::values::specified::Opacity as ToComputedValue>::ComputedValue),
                _MozWindowOpacity(<crate::values::specified::Opacity as ToComputedValue>::ComputedValue),
                _Opacity(<crate::values::specified::Opacity as ToComputedValue>::ComputedValue),
                _ShapeImageThreshold(<crate::values::specified::Opacity as ToComputedValue>::ComputedValue),
                _StopOpacity(<crate::values::specified::Opacity as ToComputedValue>::ComputedValue),
                _BorderBottomStyle(<crate::values::specified::BorderStyle as ToComputedValue>::ComputedValue),
                _BorderLeftStyle(<crate::values::specified::BorderStyle as ToComputedValue>::ComputedValue),
                _BorderRightStyle(<crate::values::specified::BorderStyle as ToComputedValue>::ComputedValue),
                _BorderTopStyle(<crate::values::specified::BorderStyle as ToComputedValue>::ComputedValue),
                _ColumnRuleStyle(<crate::values::specified::BorderStyle as ToComputedValue>::ComputedValue),
            }

            unsafe {
                let mut out = mem::uninitialized();
                ptr::write(
                    &mut out as *mut _ as *mut CopyVariants,
                    *(self as *const _ as *const CopyVariants),
                );
                return out;
            }
        }

        match *self {
            
            BackgroundAttachment(ref value) => {
                BackgroundAttachment(value.clone())
            }
            
            BackgroundBlendMode(ref value) => {
                BackgroundBlendMode(value.clone())
            }
            
            BackgroundClip(ref value) => {
                BackgroundClip(value.clone())
            }
            
            BackgroundImage(ref value) => {
                BackgroundImage(value.clone())
            }
            
            BackgroundOrigin(ref value) => {
                BackgroundOrigin(value.clone())
            }
            
            BackgroundPositionX(ref value) => {
                BackgroundPositionX(value.clone())
            }
            
            BackgroundPositionY(ref value) => {
                BackgroundPositionY(value.clone())
            }
            
            BackgroundRepeat(ref value) => {
                BackgroundRepeat(value.clone())
            }
            
            BackgroundSize(ref value) => {
                BackgroundSize(value.clone())
            }
            
            BorderImageOutset(ref value) => {
                BorderImageOutset(value.clone())
            }
            
            BorderImageSlice(ref value) => {
                BorderImageSlice(value.clone())
            }
            
            BorderImageSource(ref value) => {
                BorderImageSource(value.clone())
            }
            
            BorderImageWidth(ref value) => {
                BorderImageWidth(value.clone())
            }
            
            BorderSpacing(ref value) => {
                BorderSpacing(value.clone())
            }
            
            BoxShadow(ref value) => {
                BoxShadow(value.clone())
            }
            
            CaretColor(ref value) => {
                CaretColor(value.clone())
            }
            
            ClipPath(ref value) => {
                ClipPath(value.clone())
            }
            
            Color(ref value) => {
                Color(value.clone())
            }
            
            ColumnWidth(ref value) => {
                ColumnWidth(value.clone())
            }
            
            Content(ref value) => {
                Content(value.clone())
            }
            
            CounterIncrement(ref value) => {
                CounterIncrement(value.clone())
            }
            
            Cursor(ref value) => {
                Cursor(value.clone())
            }
            
            Filter(ref value) => {
                Filter(value.clone())
            }
            
            FlexBasis(ref value) => {
                FlexBasis(value.clone())
            }
            
            FontFamily(ref value) => {
                FontFamily(value.clone())
            }
            
            FontFeatureSettings(ref value) => {
                FontFeatureSettings(value.clone())
            }
            
            FontLanguageOverride(ref value) => {
                FontLanguageOverride(value.clone())
            }
            
            FontSize(ref value) => {
                FontSize(value.clone())
            }
            
            FontVariantAlternates(ref value) => {
                FontVariantAlternates(value.clone())
            }
            
            FontVariationSettings(ref value) => {
                FontVariationSettings(value.clone())
            }
            
            GridTemplateAreas(ref value) => {
                GridTemplateAreas(value.clone())
            }
            
            LetterSpacing(ref value) => {
                LetterSpacing(value.clone())
            }
            
            LineHeight(ref value) => {
                LineHeight(value.clone())
            }
            
            ListStyleImage(ref value) => {
                ListStyleImage(value.clone())
            }
            
            ListStyleType(ref value) => {
                ListStyleType(value.clone())
            }
            
            MaskClip(ref value) => {
                MaskClip(value.clone())
            }
            
            MaskComposite(ref value) => {
                MaskComposite(value.clone())
            }
            
            MaskImage(ref value) => {
                MaskImage(value.clone())
            }
            
            MaskMode(ref value) => {
                MaskMode(value.clone())
            }
            
            MaskOrigin(ref value) => {
                MaskOrigin(value.clone())
            }
            
            MaskPositionX(ref value) => {
                MaskPositionX(value.clone())
            }
            
            MaskPositionY(ref value) => {
                MaskPositionY(value.clone())
            }
            
            MaskRepeat(ref value) => {
                MaskRepeat(value.clone())
            }
            
            MaskSize(ref value) => {
                MaskSize(value.clone())
            }
            
            MozTabSize(ref value) => {
                MozTabSize(value.clone())
            }
            
            OffsetPath(ref value) => {
                OffsetPath(value.clone())
            }
            
            Perspective(ref value) => {
                Perspective(value.clone())
            }
            
            Quotes(ref value) => {
                Quotes(value.clone())
            }
            
            Rotate(ref value) => {
                Rotate(value.clone())
            }
            
            Scale(ref value) => {
                Scale(value.clone())
            }
            
            ScrollSnapCoordinate(ref value) => {
                ScrollSnapCoordinate(value.clone())
            }
            
            ScrollbarColor(ref value) => {
                ScrollbarColor(value.clone())
            }
            
            ShapeOutside(ref value) => {
                ShapeOutside(value.clone())
            }
            
            StrokeDasharray(ref value) => {
                StrokeDasharray(value.clone())
            }
            
            StrokeDashoffset(ref value) => {
                StrokeDashoffset(value.clone())
            }
            
            StrokeWidth(ref value) => {
                StrokeWidth(value.clone())
            }
            
            TextEmphasisStyle(ref value) => {
                TextEmphasisStyle(value.clone())
            }
            
            TextIndent(ref value) => {
                TextIndent(value.clone())
            }
            
            TextOverflow(ref value) => {
                TextOverflow(value.clone())
            }
            
            TextShadow(ref value) => {
                TextShadow(value.clone())
            }
            
            Translate(ref value) => {
                Translate(value.clone())
            }
            
            VerticalAlign(ref value) => {
                VerticalAlign(value.clone())
            }
            
            WordSpacing(ref value) => {
                WordSpacing(value.clone())
            }
            
            Clip(ref value) |
MozImageRegion(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::ClipRectOrAuto as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            GridTemplateColumns(ref value) |
GridTemplateRows(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::GridTemplateComponent as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            Fill(ref value) |
Stroke(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::SVGPaint as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            GridAutoColumns(ref value) |
GridAutoRows(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TrackSize as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            MozWindowTransformOrigin(ref value) |
TransformOrigin(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TransformOrigin as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            CounterReset(ref value) |
CounterSet(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::CounterSetOrReset as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            ScrollSnapPointsX(ref value) |
ScrollSnapPointsY(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::ScrollSnapPoint as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            MozWindowTransform(ref value) |
Transform(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Transform as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            ColumnGap(ref value) |
RowGap(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::length::NonNegativeLengthPercentageOrNormal as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            ObjectPosition(ref value) |
PerspectiveOrigin(ref value) |
ScrollSnapDestination(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Position as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            GridColumnEnd(ref value) |
GridColumnStart(ref value) |
GridRowEnd(ref value) |
GridRowStart(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::GridLine as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            MaxHeight(ref value) |
MaxWidth(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::MaxSize as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            MarkerEnd(ref value) |
MarkerMid(ref value) |
MarkerStart(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::url::UrlOrNone as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            ScrollPaddingBottom(ref value) |
ScrollPaddingLeft(ref value) |
ScrollPaddingRight(ref value) |
ScrollPaddingTop(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::NonNegativeLengthPercentageOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            Height(ref value) |
MinHeight(ref value) |
MinWidth(ref value) |
Width(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::Size as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            OutlineOffset(ref value) |
ScrollMarginBottom(ref value) |
ScrollMarginLeft(ref value) |
ScrollMarginRight(ref value) |
ScrollMarginTop(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Length as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            PaddingBottom(ref value) |
PaddingLeft(ref value) |
PaddingRight(ref value) |
PaddingTop(ref value) |
ShapeMargin(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::NonNegativeLengthPercentage as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            BorderBottomWidth(ref value) |
BorderLeftWidth(ref value) |
BorderRightWidth(ref value) |
BorderTopWidth(ref value) |
ColumnRuleWidth(ref value) |
OutlineWidth(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::BorderSideWidth as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            WebkitTextStrokeWidth(ref value) => {
                WebkitTextStrokeWidth(value.clone())
            }
            
            BorderBottomLeftRadius(ref value) |
BorderBottomRightRadius(ref value) |
BorderTopLeftRadius(ref value) |
BorderTopRightRadius(ref value) |
MozOutlineRadiusBottomleft(ref value) |
MozOutlineRadiusBottomright(ref value) |
MozOutlineRadiusTopleft(ref value) |
MozOutlineRadiusTopright(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::BorderCornerRadius as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            Bottom(ref value) |
Left(ref value) |
MarginBottom(ref value) |
MarginLeft(ref value) |
MarginRight(ref value) |
MarginTop(ref value) |
Right(ref value) |
Top(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::LengthPercentageOrAuto as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            
            BackgroundColor(ref value) |
BorderBottomColor(ref value) |
BorderLeftColor(ref value) |
BorderRightColor(ref value) |
BorderTopColor(ref value) |
ColumnRuleColor(ref value) |
FloodColor(ref value) |
LightingColor(ref value) |
OutlineColor(ref value) |
StopColor(ref value) |
TextDecorationColor(ref value) |
TextEmphasisColor(ref value) |
WebkitTextFillColor(ref value) |
WebkitTextStrokeColor(ref value) => {
                unsafe {
                    let mut out = ManuallyDrop::new(mem::uninitialized());
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value: value.clone(),
                        },
                    );
                    ManuallyDrop::into_inner(out)
                }
            }
            _ => unsafe { debug_unreachable!() }
        }
    }
}

impl PartialEq for AnimationValue {
    #[inline]
    fn eq(&self, other: &Self) -> bool {
        use self::AnimationValue::*;

        unsafe {
            let this_tag = *(self as *const _ as *const u16);
            let other_tag = *(other as *const _ as *const u16);
            if this_tag != other_tag {
                return false;
            }

            match *self {
                AlignContent(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::AlignContent as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                AlignItems(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::AlignItems as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                AlignSelf(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::AlignSelf as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BackfaceVisibility(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::backface_visibility::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BorderCollapse(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::border_collapse::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BorderImageRepeat(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::BorderImageRepeat as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BoxDecorationBreak(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::box_decoration_break::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BoxSizing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::box_sizing::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BreakInside(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::BreakWithin as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                CaptionSide(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::caption_side::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                Clear(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Clear as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ColorAdjust(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::color_adjust::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ColorInterpolation(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::color_interpolation::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ColorInterpolationFilters(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::color_interpolation_filters::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ColumnCount(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::ColumnCount as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                ColumnFill(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::column_fill::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ColumnSpan(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::column_span::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                Display(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Display as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                DominantBaseline(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::dominant_baseline::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                EmptyCells(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::empty_cells::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                FlexDirection(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::flex_direction::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                FlexWrap(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::flex_wrap::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                Float(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Float as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                FontKerning(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::font_kerning::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                FontOpticalSizing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::font_optical_sizing::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                FontSizeAdjust(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontSizeAdjust as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                FontStretch(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::FontStretch as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                FontStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::FontStyle as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                FontSynthesis(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontSynthesis as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                FontVariantCaps(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::font_variant_caps::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                FontVariantEastAsian(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontVariantEastAsian as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                FontVariantLigatures(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontVariantLigatures as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                FontVariantNumeric(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontVariantNumeric as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                FontVariantPosition(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::font_variant_position::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                FontWeight(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::FontWeight as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                GridAutoFlow(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::GridAutoFlow as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                Hyphens(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::hyphens::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ImageOrientation(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::image_orientation::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ImageRendering(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::image_rendering::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ImeMode(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::ime_mode::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                InitialLetter(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::InitialLetter as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                Isolation(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::isolation::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                JustifyContent(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::JustifyContent as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                JustifyItems(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::JustifyItems as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                JustifySelf(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::JustifySelf as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ListStylePosition(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::list_style_position::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MaskType(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_type::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MixBlendMode(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mix_blend_mode::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozAppearance(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Appearance as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozBoxAlign(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_box_align::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozBoxDirection(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_box_direction::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozBoxOrient(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_box_orient::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozBoxPack(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_box_pack::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozFloatEdge(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_float_edge::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozForceBrokenImageIcon(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::MozForceBrokenImageIcon as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozListReversed(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::MozListReversed as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozOrient(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_orient::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozOsxFontSmoothing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_osx_font_smoothing::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozStackSizing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_stack_sizing::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozTextSizeAdjust(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_text_size_adjust::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozUserFocus(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_user_focus::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozUserInput(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_user_input::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozUserModify(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_user_modify::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozUserSelect(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::UserSelect as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozWindowDragging(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_window_dragging::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozWindowShadow(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_window_shadow::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ObjectFit(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::object_fit::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                OutlineStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::OutlineStyle as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                OverflowAnchor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::OverflowAnchor as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                OverflowWrap(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::OverflowWrap as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                PaintOrder(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::SVGPaintOrder as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                PointerEvents(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::pointer_events::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                Position(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::position::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                Resize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Resize as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                RubyAlign(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::ruby_align::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                RubyPosition(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::ruby_position::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ScrollBehavior(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::scroll_behavior::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ScrollSnapAlign(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::ScrollSnapAlign as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ScrollSnapType(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::ScrollSnapType as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ScrollbarWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::scrollbar_width::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ShapeRendering(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::shape_rendering::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                StrokeLinecap(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::stroke_linecap::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                StrokeLinejoin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::stroke_linejoin::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                TableLayout(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::table_layout::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                TextAlign(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TextAlign as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                TextAlignLast(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::text_align_last::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                TextAnchor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::text_anchor::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                TextCombineUpright(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::text_combine_upright::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                TextDecorationLine(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TextDecorationLine as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                TextDecorationStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::text_decoration_style::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                TextEmphasisPosition(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TextEmphasisPosition as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                TextJustify(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::text_justify::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                TextRendering(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::text_rendering::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                TextTransform(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TextTransform as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                TouchAction(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TouchAction as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                TransformBox(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::transform_box::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                TransformStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TransformStyle as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                VectorEffect(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::vector_effect::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                Visibility(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::visibility::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                WebkitLineClamp(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::PositiveIntegerOrNone as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                WhiteSpace(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::white_space::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                WordBreak(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::WordBreak as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ZIndex(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::ZIndex as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BreakAfter(ref this) |
BreakBefore(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::BreakBetween as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ClipRule(ref this) |
FillRule(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FillRule as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozBoxOrdinalGroup(ref this) |
Order(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Integer as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                OverflowX(ref this) |
OverflowY(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Overflow as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                OverflowClipBoxBlock(ref this) |
OverflowClipBoxInline(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::OverflowClipBox as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                OverscrollBehaviorX(ref this) |
OverscrollBehaviorY(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::OverscrollBehavior as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                FillOpacity(ref this) |
StrokeOpacity(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::SVGOpacity as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                FlexGrow(ref this) |
FlexShrink(ref this) |
MozBoxFlex(ref this) |
StrokeMiterlimit(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::NonNegativeNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                FloodOpacity(ref this) |
MozWindowOpacity(ref this) |
Opacity(ref this) |
ShapeImageThreshold(ref this) |
StopOpacity(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Opacity as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BorderBottomStyle(ref this) |
BorderLeftStyle(ref this) |
BorderRightStyle(ref this) |
BorderTopStyle(ref this) |
ColumnRuleStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::BorderStyle as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BackgroundAttachment(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::background_attachment::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BackgroundBlendMode(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::background_blend_mode::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BackgroundClip(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::background_clip::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BackgroundImage(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::background_image::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BackgroundOrigin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::background_origin::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BackgroundPositionX(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::background_position_x::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BackgroundPositionY(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::background_position_y::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BackgroundRepeat(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::background_repeat::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BackgroundSize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<longhands::background_size::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                BorderImageOutset(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::NonNegativeLengthOrNumberRect as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BorderImageSlice(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::BorderImageSlice as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BorderImageSource(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::ImageLayer as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BorderImageWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::BorderImageWidth as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BorderSpacing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::BorderSpacing as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                BoxShadow(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<longhands::box_shadow::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                CaretColor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::ColorOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                ClipPath(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::basic_shape::ClippingShape as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                Color(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::ColorPropertyValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                ColumnWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::length::NonNegativeLengthOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                Content(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Content as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                CounterIncrement(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::CounterIncrement as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                Cursor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Cursor as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                Filter(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<longhands::filter::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                FlexBasis(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::FlexBasis as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                FontFamily(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontFamily as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                FontFeatureSettings(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontFeatureSettings as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                FontLanguageOverride(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontLanguageOverride as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                FontSize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::FontSize as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                FontVariantAlternates(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontVariantAlternates as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                FontVariationSettings(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontVariationSettings as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                GridTemplateAreas(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::GridTemplateAreas as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                LetterSpacing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::LetterSpacing as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                LineHeight(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::LineHeight as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                ListStyleImage(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::url::ImageUrlOrNone as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ListStyleType(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::ListStyleType as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MaskClip(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_clip::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MaskComposite(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_composite::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MaskImage(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_image::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MaskMode(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_mode::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MaskOrigin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_origin::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MaskPositionX(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_position_x::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MaskPositionY(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_position_y::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MaskRepeat(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_repeat::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MaskSize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<longhands::mask_size::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                MozTabSize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::NonNegativeLengthOrNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                OffsetPath(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::OffsetPath as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                Perspective(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::Perspective as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                Quotes(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Quotes as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                Rotate(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Rotate as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                Scale(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Scale as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ScrollSnapCoordinate(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::scroll_snap_coordinate::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ScrollbarColor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::ui::ScrollbarColor as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                ShapeOutside(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::basic_shape::FloatAreaShape as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                StrokeDasharray(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::SVGStrokeDashArray as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                StrokeDashoffset(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::SVGLength as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                StrokeWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::SVGWidth as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                TextEmphasisStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TextEmphasisStyle as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                TextIndent(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::LengthPercentage as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                TextOverflow(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TextOverflow as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                TextShadow(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<longhands::text_shadow::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                Translate(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Translate as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                VerticalAlign(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::VerticalAlign as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                WordSpacing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::WordSpacing as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                Clip(ref this) |
MozImageRegion(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::ClipRectOrAuto as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                GridTemplateColumns(ref this) |
GridTemplateRows(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::GridTemplateComponent as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                Fill(ref this) |
Stroke(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::SVGPaint as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                GridAutoColumns(ref this) |
GridAutoRows(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TrackSize as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozWindowTransformOrigin(ref this) |
TransformOrigin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TransformOrigin as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                CounterReset(ref this) |
CounterSet(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::CounterSetOrReset as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ScrollSnapPointsX(ref this) |
ScrollSnapPointsY(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::ScrollSnapPoint as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MozWindowTransform(ref this) |
Transform(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Transform as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ColumnGap(ref this) |
RowGap(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::length::NonNegativeLengthPercentageOrNormal as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                ObjectPosition(ref this) |
PerspectiveOrigin(ref this) |
ScrollSnapDestination(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Position as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                GridColumnEnd(ref this) |
GridColumnStart(ref this) |
GridRowEnd(ref this) |
GridRowStart(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::GridLine as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                MaxHeight(ref this) |
MaxWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::MaxSize as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                MarkerEnd(ref this) |
MarkerMid(ref this) |
MarkerStart(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::url::UrlOrNone as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                ScrollPaddingBottom(ref this) |
ScrollPaddingLeft(ref this) |
ScrollPaddingRight(ref this) |
ScrollPaddingTop(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::NonNegativeLengthPercentageOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                Height(ref this) |
MinHeight(ref this) |
MinWidth(ref this) |
Width(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::Size as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                OutlineOffset(ref this) |
ScrollMarginBottom(ref this) |
ScrollMarginLeft(ref this) |
ScrollMarginRight(ref this) |
ScrollMarginTop(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Length as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                PaddingBottom(ref this) |
PaddingLeft(ref this) |
PaddingRight(ref this) |
PaddingTop(ref this) |
ShapeMargin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::NonNegativeLengthPercentage as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                BorderBottomWidth(ref this) |
BorderLeftWidth(ref this) |
BorderRightWidth(ref this) |
BorderTopWidth(ref this) |
ColumnRuleWidth(ref this) |
OutlineWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::BorderSideWidth as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                WebkitTextStrokeWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::BorderSideWidth as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BorderBottomLeftRadius(ref this) |
BorderBottomRightRadius(ref this) |
BorderTopLeftRadius(ref this) |
BorderTopRightRadius(ref this) |
MozOutlineRadiusBottomleft(ref this) |
MozOutlineRadiusBottomright(ref this) |
MozOutlineRadiusTopleft(ref this) |
MozOutlineRadiusTopright(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::BorderCornerRadius as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                Bottom(ref this) |
Left(ref this) |
MarginBottom(ref this) |
MarginLeft(ref this) |
MarginRight(ref this) |
MarginTop(ref this) |
Right(ref this) |
Top(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::LengthPercentageOrAuto as ToComputedValue>::ComputedValue>);
                    *this == other_repr.value
                }
                BackgroundColor(ref this) |
BorderBottomColor(ref this) |
BorderLeftColor(ref this) |
BorderRightColor(ref this) |
BorderTopColor(ref this) |
ColumnRuleColor(ref this) |
FloodColor(ref this) |
LightingColor(ref this) |
OutlineColor(ref this) |
StopColor(ref this) |
TextDecorationColor(ref this) |
TextEmphasisColor(ref this) |
WebkitTextFillColor(ref this) |
WebkitTextStrokeColor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    *this == other_repr.value
                }
                Contain(void) |
Direction(void) |
MozControlCharacterVisibility(void) |
MozMathDisplay(void) |
MozMathVariant(void) |
MozMinFontSizeRatio(void) |
MozScriptLevel(void) |
MozScriptMinSize(void) |
MozScriptSizeMultiplier(void) |
MozTopLayer(void) |
TextOrientation(void) |
UnicodeBidi(void) |
WritingMode(void) |
XSpan(void) |
XTextZoom(void) |
BorderBlockEndStyle(void) |
BorderBlockStartStyle(void) |
BorderInlineEndStyle(void) |
BorderInlineStartStyle(void) |
AnimationDelay(void) |
AnimationDirection(void) |
AnimationDuration(void) |
AnimationFillMode(void) |
AnimationIterationCount(void) |
AnimationName(void) |
AnimationPlayState(void) |
AnimationTimingFunction(void) |
MozContextProperties(void) |
MozFontSmoothingBackgroundColor(void) |
TransitionDelay(void) |
TransitionDuration(void) |
TransitionProperty(void) |
TransitionTimingFunction(void) |
WillChange(void) |
XLang(void) |
MaxBlockSize(void) |
MaxInlineSize(void) |
MozBinding(void) |
ScrollPaddingBlockEnd(void) |
ScrollPaddingBlockStart(void) |
ScrollPaddingInlineEnd(void) |
ScrollPaddingInlineStart(void) |
BlockSize(void) |
InlineSize(void) |
MinBlockSize(void) |
MinInlineSize(void) |
ScrollMarginBlockEnd(void) |
ScrollMarginBlockStart(void) |
ScrollMarginInlineEnd(void) |
ScrollMarginInlineStart(void) |
PaddingBlockEnd(void) |
PaddingBlockStart(void) |
PaddingInlineEnd(void) |
PaddingInlineStart(void) |
BorderBlockEndWidth(void) |
BorderBlockStartWidth(void) |
BorderInlineEndWidth(void) |
BorderInlineStartWidth(void) |
BorderEndEndRadius(void) |
BorderEndStartRadius(void) |
BorderStartEndRadius(void) |
BorderStartStartRadius(void) |
InsetBlockEnd(void) |
InsetBlockStart(void) |
InsetInlineEnd(void) |
InsetInlineStart(void) |
MarginBlockEnd(void) |
MarginBlockStart(void) |
MarginInlineEnd(void) |
MarginInlineStart(void) |
BorderBlockEndColor(void) |
BorderBlockStartColor(void) |
BorderInlineEndColor(void) |
BorderInlineStartColor(void) => {
                    void::unreachable(void)
                }
            }
        }
    }
}

impl AnimationValue {
    /// Returns the longhand id this animated value corresponds to.
    #[inline]
    pub fn id(&self) -> LonghandId {
        let id = unsafe { *(self as *const _ as *const LonghandId) };
        debug_assert_eq!(id, match *self {
            AnimationValue::AlignContent(..) => LonghandId::AlignContent,
            AnimationValue::AlignItems(..) => LonghandId::AlignItems,
            AnimationValue::AlignSelf(..) => LonghandId::AlignSelf,
            AnimationValue::BackfaceVisibility(..) => LonghandId::BackfaceVisibility,
            AnimationValue::BorderCollapse(..) => LonghandId::BorderCollapse,
            AnimationValue::BorderImageRepeat(..) => LonghandId::BorderImageRepeat,
            AnimationValue::BoxDecorationBreak(..) => LonghandId::BoxDecorationBreak,
            AnimationValue::BoxSizing(..) => LonghandId::BoxSizing,
            AnimationValue::BreakInside(..) => LonghandId::BreakInside,
            AnimationValue::CaptionSide(..) => LonghandId::CaptionSide,
            AnimationValue::Clear(..) => LonghandId::Clear,
            AnimationValue::ColorAdjust(..) => LonghandId::ColorAdjust,
            AnimationValue::ColorInterpolation(..) => LonghandId::ColorInterpolation,
            AnimationValue::ColorInterpolationFilters(..) => LonghandId::ColorInterpolationFilters,
            AnimationValue::ColumnCount(..) => LonghandId::ColumnCount,
            AnimationValue::ColumnFill(..) => LonghandId::ColumnFill,
            AnimationValue::ColumnSpan(..) => LonghandId::ColumnSpan,
            AnimationValue::Contain(void) => void::unreachable(void),
            AnimationValue::Direction(void) => void::unreachable(void),
            AnimationValue::Display(..) => LonghandId::Display,
            AnimationValue::DominantBaseline(..) => LonghandId::DominantBaseline,
            AnimationValue::EmptyCells(..) => LonghandId::EmptyCells,
            AnimationValue::FlexDirection(..) => LonghandId::FlexDirection,
            AnimationValue::FlexWrap(..) => LonghandId::FlexWrap,
            AnimationValue::Float(..) => LonghandId::Float,
            AnimationValue::FontKerning(..) => LonghandId::FontKerning,
            AnimationValue::FontOpticalSizing(..) => LonghandId::FontOpticalSizing,
            AnimationValue::FontSizeAdjust(..) => LonghandId::FontSizeAdjust,
            AnimationValue::FontStretch(..) => LonghandId::FontStretch,
            AnimationValue::FontStyle(..) => LonghandId::FontStyle,
            AnimationValue::FontSynthesis(..) => LonghandId::FontSynthesis,
            AnimationValue::FontVariantCaps(..) => LonghandId::FontVariantCaps,
            AnimationValue::FontVariantEastAsian(..) => LonghandId::FontVariantEastAsian,
            AnimationValue::FontVariantLigatures(..) => LonghandId::FontVariantLigatures,
            AnimationValue::FontVariantNumeric(..) => LonghandId::FontVariantNumeric,
            AnimationValue::FontVariantPosition(..) => LonghandId::FontVariantPosition,
            AnimationValue::FontWeight(..) => LonghandId::FontWeight,
            AnimationValue::GridAutoFlow(..) => LonghandId::GridAutoFlow,
            AnimationValue::Hyphens(..) => LonghandId::Hyphens,
            AnimationValue::ImageOrientation(..) => LonghandId::ImageOrientation,
            AnimationValue::ImageRendering(..) => LonghandId::ImageRendering,
            AnimationValue::ImeMode(..) => LonghandId::ImeMode,
            AnimationValue::InitialLetter(..) => LonghandId::InitialLetter,
            AnimationValue::Isolation(..) => LonghandId::Isolation,
            AnimationValue::JustifyContent(..) => LonghandId::JustifyContent,
            AnimationValue::JustifyItems(..) => LonghandId::JustifyItems,
            AnimationValue::JustifySelf(..) => LonghandId::JustifySelf,
            AnimationValue::ListStylePosition(..) => LonghandId::ListStylePosition,
            AnimationValue::MaskType(..) => LonghandId::MaskType,
            AnimationValue::MixBlendMode(..) => LonghandId::MixBlendMode,
            AnimationValue::MozAppearance(..) => LonghandId::MozAppearance,
            AnimationValue::MozBoxAlign(..) => LonghandId::MozBoxAlign,
            AnimationValue::MozBoxDirection(..) => LonghandId::MozBoxDirection,
            AnimationValue::MozBoxOrient(..) => LonghandId::MozBoxOrient,
            AnimationValue::MozBoxPack(..) => LonghandId::MozBoxPack,
            AnimationValue::MozControlCharacterVisibility(void) => void::unreachable(void),
            AnimationValue::MozFloatEdge(..) => LonghandId::MozFloatEdge,
            AnimationValue::MozForceBrokenImageIcon(..) => LonghandId::MozForceBrokenImageIcon,
            AnimationValue::MozListReversed(..) => LonghandId::MozListReversed,
            AnimationValue::MozMathDisplay(void) => void::unreachable(void),
            AnimationValue::MozMathVariant(void) => void::unreachable(void),
            AnimationValue::MozMinFontSizeRatio(void) => void::unreachable(void),
            AnimationValue::MozOrient(..) => LonghandId::MozOrient,
            AnimationValue::MozOsxFontSmoothing(..) => LonghandId::MozOsxFontSmoothing,
            AnimationValue::MozScriptLevel(void) => void::unreachable(void),
            AnimationValue::MozScriptMinSize(void) => void::unreachable(void),
            AnimationValue::MozScriptSizeMultiplier(void) => void::unreachable(void),
            AnimationValue::MozStackSizing(..) => LonghandId::MozStackSizing,
            AnimationValue::MozTextSizeAdjust(..) => LonghandId::MozTextSizeAdjust,
            AnimationValue::MozTopLayer(void) => void::unreachable(void),
            AnimationValue::MozUserFocus(..) => LonghandId::MozUserFocus,
            AnimationValue::MozUserInput(..) => LonghandId::MozUserInput,
            AnimationValue::MozUserModify(..) => LonghandId::MozUserModify,
            AnimationValue::MozUserSelect(..) => LonghandId::MozUserSelect,
            AnimationValue::MozWindowDragging(..) => LonghandId::MozWindowDragging,
            AnimationValue::MozWindowShadow(..) => LonghandId::MozWindowShadow,
            AnimationValue::ObjectFit(..) => LonghandId::ObjectFit,
            AnimationValue::OutlineStyle(..) => LonghandId::OutlineStyle,
            AnimationValue::OverflowAnchor(..) => LonghandId::OverflowAnchor,
            AnimationValue::OverflowWrap(..) => LonghandId::OverflowWrap,
            AnimationValue::PaintOrder(..) => LonghandId::PaintOrder,
            AnimationValue::PointerEvents(..) => LonghandId::PointerEvents,
            AnimationValue::Position(..) => LonghandId::Position,
            AnimationValue::Resize(..) => LonghandId::Resize,
            AnimationValue::RubyAlign(..) => LonghandId::RubyAlign,
            AnimationValue::RubyPosition(..) => LonghandId::RubyPosition,
            AnimationValue::ScrollBehavior(..) => LonghandId::ScrollBehavior,
            AnimationValue::ScrollSnapAlign(..) => LonghandId::ScrollSnapAlign,
            AnimationValue::ScrollSnapType(..) => LonghandId::ScrollSnapType,
            AnimationValue::ScrollbarWidth(..) => LonghandId::ScrollbarWidth,
            AnimationValue::ShapeRendering(..) => LonghandId::ShapeRendering,
            AnimationValue::StrokeLinecap(..) => LonghandId::StrokeLinecap,
            AnimationValue::StrokeLinejoin(..) => LonghandId::StrokeLinejoin,
            AnimationValue::TableLayout(..) => LonghandId::TableLayout,
            AnimationValue::TextAlign(..) => LonghandId::TextAlign,
            AnimationValue::TextAlignLast(..) => LonghandId::TextAlignLast,
            AnimationValue::TextAnchor(..) => LonghandId::TextAnchor,
            AnimationValue::TextCombineUpright(..) => LonghandId::TextCombineUpright,
            AnimationValue::TextDecorationLine(..) => LonghandId::TextDecorationLine,
            AnimationValue::TextDecorationStyle(..) => LonghandId::TextDecorationStyle,
            AnimationValue::TextEmphasisPosition(..) => LonghandId::TextEmphasisPosition,
            AnimationValue::TextJustify(..) => LonghandId::TextJustify,
            AnimationValue::TextOrientation(void) => void::unreachable(void),
            AnimationValue::TextRendering(..) => LonghandId::TextRendering,
            AnimationValue::TextTransform(..) => LonghandId::TextTransform,
            AnimationValue::TouchAction(..) => LonghandId::TouchAction,
            AnimationValue::TransformBox(..) => LonghandId::TransformBox,
            AnimationValue::TransformStyle(..) => LonghandId::TransformStyle,
            AnimationValue::UnicodeBidi(void) => void::unreachable(void),
            AnimationValue::VectorEffect(..) => LonghandId::VectorEffect,
            AnimationValue::Visibility(..) => LonghandId::Visibility,
            AnimationValue::WebkitLineClamp(..) => LonghandId::WebkitLineClamp,
            AnimationValue::WhiteSpace(..) => LonghandId::WhiteSpace,
            AnimationValue::WordBreak(..) => LonghandId::WordBreak,
            AnimationValue::WritingMode(void) => void::unreachable(void),
            AnimationValue::XSpan(void) => void::unreachable(void),
            AnimationValue::XTextZoom(void) => void::unreachable(void),
            AnimationValue::ZIndex(..) => LonghandId::ZIndex,
            AnimationValue::BreakAfter(..) => LonghandId::BreakAfter,
            AnimationValue::BreakBefore(..) => LonghandId::BreakBefore,
            AnimationValue::ClipRule(..) => LonghandId::ClipRule,
            AnimationValue::FillRule(..) => LonghandId::FillRule,
            AnimationValue::MozBoxOrdinalGroup(..) => LonghandId::MozBoxOrdinalGroup,
            AnimationValue::Order(..) => LonghandId::Order,
            AnimationValue::OverflowX(..) => LonghandId::OverflowX,
            AnimationValue::OverflowY(..) => LonghandId::OverflowY,
            AnimationValue::OverflowClipBoxBlock(..) => LonghandId::OverflowClipBoxBlock,
            AnimationValue::OverflowClipBoxInline(..) => LonghandId::OverflowClipBoxInline,
            AnimationValue::OverscrollBehaviorX(..) => LonghandId::OverscrollBehaviorX,
            AnimationValue::OverscrollBehaviorY(..) => LonghandId::OverscrollBehaviorY,
            AnimationValue::FillOpacity(..) => LonghandId::FillOpacity,
            AnimationValue::StrokeOpacity(..) => LonghandId::StrokeOpacity,
            AnimationValue::FlexGrow(..) => LonghandId::FlexGrow,
            AnimationValue::FlexShrink(..) => LonghandId::FlexShrink,
            AnimationValue::MozBoxFlex(..) => LonghandId::MozBoxFlex,
            AnimationValue::StrokeMiterlimit(..) => LonghandId::StrokeMiterlimit,
            AnimationValue::FloodOpacity(..) => LonghandId::FloodOpacity,
            AnimationValue::MozWindowOpacity(..) => LonghandId::MozWindowOpacity,
            AnimationValue::Opacity(..) => LonghandId::Opacity,
            AnimationValue::ShapeImageThreshold(..) => LonghandId::ShapeImageThreshold,
            AnimationValue::StopOpacity(..) => LonghandId::StopOpacity,
            AnimationValue::BorderBlockEndStyle(void) => void::unreachable(void),
            AnimationValue::BorderBlockStartStyle(void) => void::unreachable(void),
            AnimationValue::BorderBottomStyle(..) => LonghandId::BorderBottomStyle,
            AnimationValue::BorderInlineEndStyle(void) => void::unreachable(void),
            AnimationValue::BorderInlineStartStyle(void) => void::unreachable(void),
            AnimationValue::BorderLeftStyle(..) => LonghandId::BorderLeftStyle,
            AnimationValue::BorderRightStyle(..) => LonghandId::BorderRightStyle,
            AnimationValue::BorderTopStyle(..) => LonghandId::BorderTopStyle,
            AnimationValue::ColumnRuleStyle(..) => LonghandId::ColumnRuleStyle,
            AnimationValue::AnimationDelay(void) => void::unreachable(void),
            AnimationValue::AnimationDirection(void) => void::unreachable(void),
            AnimationValue::AnimationDuration(void) => void::unreachable(void),
            AnimationValue::AnimationFillMode(void) => void::unreachable(void),
            AnimationValue::AnimationIterationCount(void) => void::unreachable(void),
            AnimationValue::AnimationName(void) => void::unreachable(void),
            AnimationValue::AnimationPlayState(void) => void::unreachable(void),
            AnimationValue::AnimationTimingFunction(void) => void::unreachable(void),
            AnimationValue::BackgroundAttachment(..) => LonghandId::BackgroundAttachment,
            AnimationValue::BackgroundBlendMode(..) => LonghandId::BackgroundBlendMode,
            AnimationValue::BackgroundClip(..) => LonghandId::BackgroundClip,
            AnimationValue::BackgroundImage(..) => LonghandId::BackgroundImage,
            AnimationValue::BackgroundOrigin(..) => LonghandId::BackgroundOrigin,
            AnimationValue::BackgroundPositionX(..) => LonghandId::BackgroundPositionX,
            AnimationValue::BackgroundPositionY(..) => LonghandId::BackgroundPositionY,
            AnimationValue::BackgroundRepeat(..) => LonghandId::BackgroundRepeat,
            AnimationValue::BackgroundSize(..) => LonghandId::BackgroundSize,
            AnimationValue::BorderImageOutset(..) => LonghandId::BorderImageOutset,
            AnimationValue::BorderImageSlice(..) => LonghandId::BorderImageSlice,
            AnimationValue::BorderImageSource(..) => LonghandId::BorderImageSource,
            AnimationValue::BorderImageWidth(..) => LonghandId::BorderImageWidth,
            AnimationValue::BorderSpacing(..) => LonghandId::BorderSpacing,
            AnimationValue::BoxShadow(..) => LonghandId::BoxShadow,
            AnimationValue::CaretColor(..) => LonghandId::CaretColor,
            AnimationValue::ClipPath(..) => LonghandId::ClipPath,
            AnimationValue::Color(..) => LonghandId::Color,
            AnimationValue::ColumnWidth(..) => LonghandId::ColumnWidth,
            AnimationValue::Content(..) => LonghandId::Content,
            AnimationValue::CounterIncrement(..) => LonghandId::CounterIncrement,
            AnimationValue::Cursor(..) => LonghandId::Cursor,
            AnimationValue::Filter(..) => LonghandId::Filter,
            AnimationValue::FlexBasis(..) => LonghandId::FlexBasis,
            AnimationValue::FontFamily(..) => LonghandId::FontFamily,
            AnimationValue::FontFeatureSettings(..) => LonghandId::FontFeatureSettings,
            AnimationValue::FontLanguageOverride(..) => LonghandId::FontLanguageOverride,
            AnimationValue::FontSize(..) => LonghandId::FontSize,
            AnimationValue::FontVariantAlternates(..) => LonghandId::FontVariantAlternates,
            AnimationValue::FontVariationSettings(..) => LonghandId::FontVariationSettings,
            AnimationValue::GridTemplateAreas(..) => LonghandId::GridTemplateAreas,
            AnimationValue::LetterSpacing(..) => LonghandId::LetterSpacing,
            AnimationValue::LineHeight(..) => LonghandId::LineHeight,
            AnimationValue::ListStyleImage(..) => LonghandId::ListStyleImage,
            AnimationValue::ListStyleType(..) => LonghandId::ListStyleType,
            AnimationValue::MaskClip(..) => LonghandId::MaskClip,
            AnimationValue::MaskComposite(..) => LonghandId::MaskComposite,
            AnimationValue::MaskImage(..) => LonghandId::MaskImage,
            AnimationValue::MaskMode(..) => LonghandId::MaskMode,
            AnimationValue::MaskOrigin(..) => LonghandId::MaskOrigin,
            AnimationValue::MaskPositionX(..) => LonghandId::MaskPositionX,
            AnimationValue::MaskPositionY(..) => LonghandId::MaskPositionY,
            AnimationValue::MaskRepeat(..) => LonghandId::MaskRepeat,
            AnimationValue::MaskSize(..) => LonghandId::MaskSize,
            AnimationValue::MozContextProperties(void) => void::unreachable(void),
            AnimationValue::MozFontSmoothingBackgroundColor(void) => void::unreachable(void),
            AnimationValue::MozTabSize(..) => LonghandId::MozTabSize,
            AnimationValue::OffsetPath(..) => LonghandId::OffsetPath,
            AnimationValue::Perspective(..) => LonghandId::Perspective,
            AnimationValue::Quotes(..) => LonghandId::Quotes,
            AnimationValue::Rotate(..) => LonghandId::Rotate,
            AnimationValue::Scale(..) => LonghandId::Scale,
            AnimationValue::ScrollSnapCoordinate(..) => LonghandId::ScrollSnapCoordinate,
            AnimationValue::ScrollbarColor(..) => LonghandId::ScrollbarColor,
            AnimationValue::ShapeOutside(..) => LonghandId::ShapeOutside,
            AnimationValue::StrokeDasharray(..) => LonghandId::StrokeDasharray,
            AnimationValue::StrokeDashoffset(..) => LonghandId::StrokeDashoffset,
            AnimationValue::StrokeWidth(..) => LonghandId::StrokeWidth,
            AnimationValue::TextEmphasisStyle(..) => LonghandId::TextEmphasisStyle,
            AnimationValue::TextIndent(..) => LonghandId::TextIndent,
            AnimationValue::TextOverflow(..) => LonghandId::TextOverflow,
            AnimationValue::TextShadow(..) => LonghandId::TextShadow,
            AnimationValue::TransitionDelay(void) => void::unreachable(void),
            AnimationValue::TransitionDuration(void) => void::unreachable(void),
            AnimationValue::TransitionProperty(void) => void::unreachable(void),
            AnimationValue::TransitionTimingFunction(void) => void::unreachable(void),
            AnimationValue::Translate(..) => LonghandId::Translate,
            AnimationValue::VerticalAlign(..) => LonghandId::VerticalAlign,
            AnimationValue::WillChange(void) => void::unreachable(void),
            AnimationValue::WordSpacing(..) => LonghandId::WordSpacing,
            AnimationValue::XLang(void) => void::unreachable(void),
            AnimationValue::Clip(..) => LonghandId::Clip,
            AnimationValue::MozImageRegion(..) => LonghandId::MozImageRegion,
            AnimationValue::GridTemplateColumns(..) => LonghandId::GridTemplateColumns,
            AnimationValue::GridTemplateRows(..) => LonghandId::GridTemplateRows,
            AnimationValue::Fill(..) => LonghandId::Fill,
            AnimationValue::Stroke(..) => LonghandId::Stroke,
            AnimationValue::GridAutoColumns(..) => LonghandId::GridAutoColumns,
            AnimationValue::GridAutoRows(..) => LonghandId::GridAutoRows,
            AnimationValue::MozWindowTransformOrigin(..) => LonghandId::MozWindowTransformOrigin,
            AnimationValue::TransformOrigin(..) => LonghandId::TransformOrigin,
            AnimationValue::CounterReset(..) => LonghandId::CounterReset,
            AnimationValue::CounterSet(..) => LonghandId::CounterSet,
            AnimationValue::ScrollSnapPointsX(..) => LonghandId::ScrollSnapPointsX,
            AnimationValue::ScrollSnapPointsY(..) => LonghandId::ScrollSnapPointsY,
            AnimationValue::MozWindowTransform(..) => LonghandId::MozWindowTransform,
            AnimationValue::Transform(..) => LonghandId::Transform,
            AnimationValue::ColumnGap(..) => LonghandId::ColumnGap,
            AnimationValue::RowGap(..) => LonghandId::RowGap,
            AnimationValue::ObjectPosition(..) => LonghandId::ObjectPosition,
            AnimationValue::PerspectiveOrigin(..) => LonghandId::PerspectiveOrigin,
            AnimationValue::ScrollSnapDestination(..) => LonghandId::ScrollSnapDestination,
            AnimationValue::GridColumnEnd(..) => LonghandId::GridColumnEnd,
            AnimationValue::GridColumnStart(..) => LonghandId::GridColumnStart,
            AnimationValue::GridRowEnd(..) => LonghandId::GridRowEnd,
            AnimationValue::GridRowStart(..) => LonghandId::GridRowStart,
            AnimationValue::MaxBlockSize(void) => void::unreachable(void),
            AnimationValue::MaxHeight(..) => LonghandId::MaxHeight,
            AnimationValue::MaxInlineSize(void) => void::unreachable(void),
            AnimationValue::MaxWidth(..) => LonghandId::MaxWidth,
            AnimationValue::MarkerEnd(..) => LonghandId::MarkerEnd,
            AnimationValue::MarkerMid(..) => LonghandId::MarkerMid,
            AnimationValue::MarkerStart(..) => LonghandId::MarkerStart,
            AnimationValue::MozBinding(void) => void::unreachable(void),
            AnimationValue::ScrollPaddingBlockEnd(void) => void::unreachable(void),
            AnimationValue::ScrollPaddingBlockStart(void) => void::unreachable(void),
            AnimationValue::ScrollPaddingBottom(..) => LonghandId::ScrollPaddingBottom,
            AnimationValue::ScrollPaddingInlineEnd(void) => void::unreachable(void),
            AnimationValue::ScrollPaddingInlineStart(void) => void::unreachable(void),
            AnimationValue::ScrollPaddingLeft(..) => LonghandId::ScrollPaddingLeft,
            AnimationValue::ScrollPaddingRight(..) => LonghandId::ScrollPaddingRight,
            AnimationValue::ScrollPaddingTop(..) => LonghandId::ScrollPaddingTop,
            AnimationValue::BlockSize(void) => void::unreachable(void),
            AnimationValue::Height(..) => LonghandId::Height,
            AnimationValue::InlineSize(void) => void::unreachable(void),
            AnimationValue::MinBlockSize(void) => void::unreachable(void),
            AnimationValue::MinHeight(..) => LonghandId::MinHeight,
            AnimationValue::MinInlineSize(void) => void::unreachable(void),
            AnimationValue::MinWidth(..) => LonghandId::MinWidth,
            AnimationValue::Width(..) => LonghandId::Width,
            AnimationValue::OutlineOffset(..) => LonghandId::OutlineOffset,
            AnimationValue::ScrollMarginBlockEnd(void) => void::unreachable(void),
            AnimationValue::ScrollMarginBlockStart(void) => void::unreachable(void),
            AnimationValue::ScrollMarginBottom(..) => LonghandId::ScrollMarginBottom,
            AnimationValue::ScrollMarginInlineEnd(void) => void::unreachable(void),
            AnimationValue::ScrollMarginInlineStart(void) => void::unreachable(void),
            AnimationValue::ScrollMarginLeft(..) => LonghandId::ScrollMarginLeft,
            AnimationValue::ScrollMarginRight(..) => LonghandId::ScrollMarginRight,
            AnimationValue::ScrollMarginTop(..) => LonghandId::ScrollMarginTop,
            AnimationValue::PaddingBlockEnd(void) => void::unreachable(void),
            AnimationValue::PaddingBlockStart(void) => void::unreachable(void),
            AnimationValue::PaddingBottom(..) => LonghandId::PaddingBottom,
            AnimationValue::PaddingInlineEnd(void) => void::unreachable(void),
            AnimationValue::PaddingInlineStart(void) => void::unreachable(void),
            AnimationValue::PaddingLeft(..) => LonghandId::PaddingLeft,
            AnimationValue::PaddingRight(..) => LonghandId::PaddingRight,
            AnimationValue::PaddingTop(..) => LonghandId::PaddingTop,
            AnimationValue::ShapeMargin(..) => LonghandId::ShapeMargin,
            AnimationValue::BorderBlockEndWidth(void) => void::unreachable(void),
            AnimationValue::BorderBlockStartWidth(void) => void::unreachable(void),
            AnimationValue::BorderBottomWidth(..) => LonghandId::BorderBottomWidth,
            AnimationValue::BorderInlineEndWidth(void) => void::unreachable(void),
            AnimationValue::BorderInlineStartWidth(void) => void::unreachable(void),
            AnimationValue::BorderLeftWidth(..) => LonghandId::BorderLeftWidth,
            AnimationValue::BorderRightWidth(..) => LonghandId::BorderRightWidth,
            AnimationValue::BorderTopWidth(..) => LonghandId::BorderTopWidth,
            AnimationValue::ColumnRuleWidth(..) => LonghandId::ColumnRuleWidth,
            AnimationValue::OutlineWidth(..) => LonghandId::OutlineWidth,
            AnimationValue::WebkitTextStrokeWidth(..) => LonghandId::WebkitTextStrokeWidth,
            AnimationValue::BorderBottomLeftRadius(..) => LonghandId::BorderBottomLeftRadius,
            AnimationValue::BorderBottomRightRadius(..) => LonghandId::BorderBottomRightRadius,
            AnimationValue::BorderEndEndRadius(void) => void::unreachable(void),
            AnimationValue::BorderEndStartRadius(void) => void::unreachable(void),
            AnimationValue::BorderStartEndRadius(void) => void::unreachable(void),
            AnimationValue::BorderStartStartRadius(void) => void::unreachable(void),
            AnimationValue::BorderTopLeftRadius(..) => LonghandId::BorderTopLeftRadius,
            AnimationValue::BorderTopRightRadius(..) => LonghandId::BorderTopRightRadius,
            AnimationValue::MozOutlineRadiusBottomleft(..) => LonghandId::MozOutlineRadiusBottomleft,
            AnimationValue::MozOutlineRadiusBottomright(..) => LonghandId::MozOutlineRadiusBottomright,
            AnimationValue::MozOutlineRadiusTopleft(..) => LonghandId::MozOutlineRadiusTopleft,
            AnimationValue::MozOutlineRadiusTopright(..) => LonghandId::MozOutlineRadiusTopright,
            AnimationValue::Bottom(..) => LonghandId::Bottom,
            AnimationValue::InsetBlockEnd(void) => void::unreachable(void),
            AnimationValue::InsetBlockStart(void) => void::unreachable(void),
            AnimationValue::InsetInlineEnd(void) => void::unreachable(void),
            AnimationValue::InsetInlineStart(void) => void::unreachable(void),
            AnimationValue::Left(..) => LonghandId::Left,
            AnimationValue::MarginBlockEnd(void) => void::unreachable(void),
            AnimationValue::MarginBlockStart(void) => void::unreachable(void),
            AnimationValue::MarginBottom(..) => LonghandId::MarginBottom,
            AnimationValue::MarginInlineEnd(void) => void::unreachable(void),
            AnimationValue::MarginInlineStart(void) => void::unreachable(void),
            AnimationValue::MarginLeft(..) => LonghandId::MarginLeft,
            AnimationValue::MarginRight(..) => LonghandId::MarginRight,
            AnimationValue::MarginTop(..) => LonghandId::MarginTop,
            AnimationValue::Right(..) => LonghandId::Right,
            AnimationValue::Top(..) => LonghandId::Top,
            AnimationValue::BackgroundColor(..) => LonghandId::BackgroundColor,
            AnimationValue::BorderBlockEndColor(void) => void::unreachable(void),
            AnimationValue::BorderBlockStartColor(void) => void::unreachable(void),
            AnimationValue::BorderBottomColor(..) => LonghandId::BorderBottomColor,
            AnimationValue::BorderInlineEndColor(void) => void::unreachable(void),
            AnimationValue::BorderInlineStartColor(void) => void::unreachable(void),
            AnimationValue::BorderLeftColor(..) => LonghandId::BorderLeftColor,
            AnimationValue::BorderRightColor(..) => LonghandId::BorderRightColor,
            AnimationValue::BorderTopColor(..) => LonghandId::BorderTopColor,
            AnimationValue::ColumnRuleColor(..) => LonghandId::ColumnRuleColor,
            AnimationValue::FloodColor(..) => LonghandId::FloodColor,
            AnimationValue::LightingColor(..) => LonghandId::LightingColor,
            AnimationValue::OutlineColor(..) => LonghandId::OutlineColor,
            AnimationValue::StopColor(..) => LonghandId::StopColor,
            AnimationValue::TextDecorationColor(..) => LonghandId::TextDecorationColor,
            AnimationValue::TextEmphasisColor(..) => LonghandId::TextEmphasisColor,
            AnimationValue::WebkitTextFillColor(..) => LonghandId::WebkitTextFillColor,
            AnimationValue::WebkitTextStrokeColor(..) => LonghandId::WebkitTextStrokeColor,
        });
        id
    }

    /// "Uncompute" this animation value in order to be used inside the CSS
    /// cascade.
    pub fn uncompute(&self) -> PropertyDeclaration {
        use crate::properties::longhands;
        use self::AnimationValue::*;

        use super::PropertyDeclarationVariantRepr;

        match *self {
            
            
            AlignContent(ref value) => {
                let value = crate::values::specified::AlignContent::from_computed_value(&value);
                PropertyDeclaration::AlignContent(value)
            }
            
            AlignItems(ref value) => {
                let value = crate::values::specified::AlignItems::from_computed_value(&value);
                PropertyDeclaration::AlignItems(value)
            }
            
            AlignSelf(ref value) => {
                let value = crate::values::specified::AlignSelf::from_computed_value(&value);
                PropertyDeclaration::AlignSelf(value)
            }
            
            BackfaceVisibility(ref value) => {
                let value = longhands::backface_visibility::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::BackfaceVisibility(value)
            }
            
            BorderCollapse(ref value) => {
                let value = longhands::border_collapse::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::BorderCollapse(value)
            }
            
            BorderImageRepeat(ref value) => {
                let value = crate::values::specified::BorderImageRepeat::from_computed_value(&value);
                PropertyDeclaration::BorderImageRepeat(value)
            }
            
            BoxDecorationBreak(ref value) => {
                let value = longhands::box_decoration_break::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::BoxDecorationBreak(value)
            }
            
            BoxSizing(ref value) => {
                let value = longhands::box_sizing::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::BoxSizing(value)
            }
            
            BreakInside(ref value) => {
                let value = crate::values::specified::BreakWithin::from_computed_value(&value);
                PropertyDeclaration::BreakInside(value)
            }
            
            CaptionSide(ref value) => {
                let value = longhands::caption_side::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::CaptionSide(value)
            }
            
            Clear(ref value) => {
                let value = crate::values::specified::Clear::from_computed_value(&value);
                PropertyDeclaration::Clear(value)
            }
            
            ColorAdjust(ref value) => {
                let value = longhands::color_adjust::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::ColorAdjust(value)
            }
            
            ColorInterpolation(ref value) => {
                let value = longhands::color_interpolation::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::ColorInterpolation(value)
            }
            
            ColorInterpolationFilters(ref value) => {
                let value = longhands::color_interpolation_filters::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::ColorInterpolationFilters(value)
            }
            
            ColumnCount(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::ColumnCount::from_computed_value(&value);
                PropertyDeclaration::ColumnCount(value)
            }
            
            ColumnFill(ref value) => {
                let value = longhands::column_fill::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::ColumnFill(value)
            }
            
            ColumnSpan(ref value) => {
                let value = longhands::column_span::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::ColumnSpan(value)
            }
            
            Display(ref value) => {
                let value = crate::values::specified::Display::from_computed_value(&value);
                PropertyDeclaration::Display(value)
            }
            
            DominantBaseline(ref value) => {
                let value = longhands::dominant_baseline::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::DominantBaseline(value)
            }
            
            EmptyCells(ref value) => {
                let value = longhands::empty_cells::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::EmptyCells(value)
            }
            
            FlexDirection(ref value) => {
                let value = longhands::flex_direction::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::FlexDirection(value)
            }
            
            FlexWrap(ref value) => {
                let value = longhands::flex_wrap::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::FlexWrap(value)
            }
            
            Float(ref value) => {
                let value = crate::values::specified::Float::from_computed_value(&value);
                PropertyDeclaration::Float(value)
            }
            
            FontKerning(ref value) => {
                let value = longhands::font_kerning::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::FontKerning(value)
            }
            
            FontOpticalSizing(ref value) => {
                let value = longhands::font_optical_sizing::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::FontOpticalSizing(value)
            }
            
            FontSizeAdjust(ref value) => {
                let value = crate::values::specified::FontSizeAdjust::from_computed_value(&value);
                PropertyDeclaration::FontSizeAdjust(value)
            }
            
            FontStretch(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::FontStretch::from_computed_value(&value);
                PropertyDeclaration::FontStretch(value)
            }
            
            FontStyle(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::FontStyle::from_computed_value(&value);
                PropertyDeclaration::FontStyle(value)
            }
            
            FontSynthesis(ref value) => {
                let value = crate::values::specified::FontSynthesis::from_computed_value(&value);
                PropertyDeclaration::FontSynthesis(value)
            }
            
            FontVariantCaps(ref value) => {
                let value = longhands::font_variant_caps::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::FontVariantCaps(value)
            }
            
            FontVariantEastAsian(ref value) => {
                let value = crate::values::specified::FontVariantEastAsian::from_computed_value(&value);
                PropertyDeclaration::FontVariantEastAsian(value)
            }
            
            FontVariantLigatures(ref value) => {
                let value = crate::values::specified::FontVariantLigatures::from_computed_value(&value);
                PropertyDeclaration::FontVariantLigatures(value)
            }
            
            FontVariantNumeric(ref value) => {
                let value = crate::values::specified::FontVariantNumeric::from_computed_value(&value);
                PropertyDeclaration::FontVariantNumeric(value)
            }
            
            FontVariantPosition(ref value) => {
                let value = longhands::font_variant_position::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::FontVariantPosition(value)
            }
            
            FontWeight(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::FontWeight::from_computed_value(&value);
                PropertyDeclaration::FontWeight(value)
            }
            
            GridAutoFlow(ref value) => {
                let value = crate::values::specified::GridAutoFlow::from_computed_value(&value);
                PropertyDeclaration::GridAutoFlow(value)
            }
            
            Hyphens(ref value) => {
                let value = longhands::hyphens::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::Hyphens(value)
            }
            
            ImageOrientation(ref value) => {
                let value = longhands::image_orientation::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::ImageOrientation(value)
            }
            
            ImageRendering(ref value) => {
                let value = longhands::image_rendering::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::ImageRendering(value)
            }
            
            ImeMode(ref value) => {
                let value = longhands::ime_mode::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::ImeMode(value)
            }
            
            InitialLetter(ref value) => {
                let value = crate::values::specified::InitialLetter::from_computed_value(&value);
                PropertyDeclaration::InitialLetter(value)
            }
            
            Isolation(ref value) => {
                let value = longhands::isolation::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::Isolation(value)
            }
            
            JustifyContent(ref value) => {
                let value = crate::values::specified::JustifyContent::from_computed_value(&value);
                PropertyDeclaration::JustifyContent(value)
            }
            
            JustifyItems(ref value) => {
                let value = crate::values::specified::JustifyItems::from_computed_value(&value);
                PropertyDeclaration::JustifyItems(value)
            }
            
            JustifySelf(ref value) => {
                let value = crate::values::specified::JustifySelf::from_computed_value(&value);
                PropertyDeclaration::JustifySelf(value)
            }
            
            ListStylePosition(ref value) => {
                let value = longhands::list_style_position::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::ListStylePosition(value)
            }
            
            MaskType(ref value) => {
                let value = longhands::mask_type::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MaskType(value)
            }
            
            MixBlendMode(ref value) => {
                let value = longhands::mix_blend_mode::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MixBlendMode(value)
            }
            
            MozAppearance(ref value) => {
                let value = crate::values::specified::Appearance::from_computed_value(&value);
                PropertyDeclaration::MozAppearance(value)
            }
            
            MozBoxAlign(ref value) => {
                let value = longhands::_moz_box_align::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MozBoxAlign(value)
            }
            
            MozBoxDirection(ref value) => {
                let value = longhands::_moz_box_direction::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MozBoxDirection(value)
            }
            
            MozBoxOrient(ref value) => {
                let value = longhands::_moz_box_orient::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MozBoxOrient(value)
            }
            
            MozBoxPack(ref value) => {
                let value = longhands::_moz_box_pack::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MozBoxPack(value)
            }
            
            MozFloatEdge(ref value) => {
                let value = longhands::_moz_float_edge::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MozFloatEdge(value)
            }
            
            MozForceBrokenImageIcon(ref value) => {
                let value = crate::values::specified::MozForceBrokenImageIcon::from_computed_value(&value);
                PropertyDeclaration::MozForceBrokenImageIcon(value)
            }
            
            MozListReversed(ref value) => {
                let value = crate::values::specified::MozListReversed::from_computed_value(&value);
                PropertyDeclaration::MozListReversed(value)
            }
            
            MozOrient(ref value) => {
                let value = longhands::_moz_orient::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MozOrient(value)
            }
            
            MozOsxFontSmoothing(ref value) => {
                let value = longhands::_moz_osx_font_smoothing::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MozOsxFontSmoothing(value)
            }
            
            MozStackSizing(ref value) => {
                let value = longhands::_moz_stack_sizing::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MozStackSizing(value)
            }
            
            MozTextSizeAdjust(ref value) => {
                let value = longhands::_moz_text_size_adjust::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MozTextSizeAdjust(value)
            }
            
            MozUserFocus(ref value) => {
                let value = longhands::_moz_user_focus::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MozUserFocus(value)
            }
            
            MozUserInput(ref value) => {
                let value = longhands::_moz_user_input::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MozUserInput(value)
            }
            
            MozUserModify(ref value) => {
                let value = longhands::_moz_user_modify::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MozUserModify(value)
            }
            
            MozUserSelect(ref value) => {
                let value = crate::values::specified::UserSelect::from_computed_value(&value);
                PropertyDeclaration::MozUserSelect(value)
            }
            
            MozWindowDragging(ref value) => {
                let value = longhands::_moz_window_dragging::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MozWindowDragging(value)
            }
            
            MozWindowShadow(ref value) => {
                let value = longhands::_moz_window_shadow::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MozWindowShadow(value)
            }
            
            ObjectFit(ref value) => {
                let value = longhands::object_fit::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::ObjectFit(value)
            }
            
            OutlineStyle(ref value) => {
                let value = crate::values::specified::OutlineStyle::from_computed_value(&value);
                PropertyDeclaration::OutlineStyle(value)
            }
            
            OverflowAnchor(ref value) => {
                let value = crate::values::specified::OverflowAnchor::from_computed_value(&value);
                PropertyDeclaration::OverflowAnchor(value)
            }
            
            OverflowWrap(ref value) => {
                let value = crate::values::specified::OverflowWrap::from_computed_value(&value);
                PropertyDeclaration::OverflowWrap(value)
            }
            
            PaintOrder(ref value) => {
                let value = crate::values::specified::SVGPaintOrder::from_computed_value(&value);
                PropertyDeclaration::PaintOrder(value)
            }
            
            PointerEvents(ref value) => {
                let value = longhands::pointer_events::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::PointerEvents(value)
            }
            
            Position(ref value) => {
                let value = longhands::position::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::Position(value)
            }
            
            Resize(ref value) => {
                let value = crate::values::specified::Resize::from_computed_value(&value);
                PropertyDeclaration::Resize(value)
            }
            
            RubyAlign(ref value) => {
                let value = longhands::ruby_align::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::RubyAlign(value)
            }
            
            RubyPosition(ref value) => {
                let value = longhands::ruby_position::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::RubyPosition(value)
            }
            
            ScrollBehavior(ref value) => {
                let value = longhands::scroll_behavior::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::ScrollBehavior(value)
            }
            
            ScrollSnapAlign(ref value) => {
                let value = crate::values::specified::ScrollSnapAlign::from_computed_value(&value);
                PropertyDeclaration::ScrollSnapAlign(value)
            }
            
            ScrollSnapType(ref value) => {
                let value = crate::values::specified::ScrollSnapType::from_computed_value(&value);
                PropertyDeclaration::ScrollSnapType(value)
            }
            
            ScrollbarWidth(ref value) => {
                let value = longhands::scrollbar_width::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::ScrollbarWidth(value)
            }
            
            ShapeRendering(ref value) => {
                let value = longhands::shape_rendering::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::ShapeRendering(value)
            }
            
            StrokeLinecap(ref value) => {
                let value = longhands::stroke_linecap::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::StrokeLinecap(value)
            }
            
            StrokeLinejoin(ref value) => {
                let value = longhands::stroke_linejoin::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::StrokeLinejoin(value)
            }
            
            TableLayout(ref value) => {
                let value = longhands::table_layout::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::TableLayout(value)
            }
            
            TextAlign(ref value) => {
                let value = crate::values::specified::TextAlign::from_computed_value(&value);
                PropertyDeclaration::TextAlign(value)
            }
            
            TextAlignLast(ref value) => {
                let value = longhands::text_align_last::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::TextAlignLast(value)
            }
            
            TextAnchor(ref value) => {
                let value = longhands::text_anchor::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::TextAnchor(value)
            }
            
            TextCombineUpright(ref value) => {
                let value = longhands::text_combine_upright::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::TextCombineUpright(value)
            }
            
            TextDecorationLine(ref value) => {
                let value = crate::values::specified::TextDecorationLine::from_computed_value(&value);
                PropertyDeclaration::TextDecorationLine(value)
            }
            
            TextDecorationStyle(ref value) => {
                let value = longhands::text_decoration_style::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::TextDecorationStyle(value)
            }
            
            TextEmphasisPosition(ref value) => {
                let value = crate::values::specified::TextEmphasisPosition::from_computed_value(&value);
                PropertyDeclaration::TextEmphasisPosition(value)
            }
            
            TextJustify(ref value) => {
                let value = longhands::text_justify::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::TextJustify(value)
            }
            
            TextRendering(ref value) => {
                let value = longhands::text_rendering::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::TextRendering(value)
            }
            
            TextTransform(ref value) => {
                let value = crate::values::specified::TextTransform::from_computed_value(&value);
                PropertyDeclaration::TextTransform(value)
            }
            
            TouchAction(ref value) => {
                let value = crate::values::specified::TouchAction::from_computed_value(&value);
                PropertyDeclaration::TouchAction(value)
            }
            
            TransformBox(ref value) => {
                let value = longhands::transform_box::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::TransformBox(value)
            }
            
            TransformStyle(ref value) => {
                let value = crate::values::specified::TransformStyle::from_computed_value(&value);
                PropertyDeclaration::TransformStyle(value)
            }
            
            VectorEffect(ref value) => {
                let value = longhands::vector_effect::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::VectorEffect(value)
            }
            
            Visibility(ref value) => {
                let value = longhands::visibility::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::Visibility(value)
            }
            
            WebkitLineClamp(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::PositiveIntegerOrNone::from_computed_value(&value);
                PropertyDeclaration::WebkitLineClamp(value)
            }
            
            WhiteSpace(ref value) => {
                let value = longhands::white_space::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::WhiteSpace(value)
            }
            
            WordBreak(ref value) => {
                let value = crate::values::specified::WordBreak::from_computed_value(&value);
                PropertyDeclaration::WordBreak(value)
            }
            
            ZIndex(ref value) => {
                let value = crate::values::specified::ZIndex::from_computed_value(&value);
                PropertyDeclaration::ZIndex(value)
            }
            
            BreakAfter(ref value) |
BreakBefore(ref value) => {
                let value = crate::values::specified::BreakBetween::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::BreakBetween>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            ClipRule(ref value) |
FillRule(ref value) => {
                let value = crate::values::specified::FillRule::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::FillRule>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            MozBoxOrdinalGroup(ref value) |
Order(ref value) => {
                let value = crate::values::specified::Integer::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::Integer>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            OverflowX(ref value) |
OverflowY(ref value) => {
                let value = crate::values::specified::Overflow::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::Overflow>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            OverflowClipBoxBlock(ref value) |
OverflowClipBoxInline(ref value) => {
                let value = crate::values::specified::OverflowClipBox::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::OverflowClipBox>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            OverscrollBehaviorX(ref value) |
OverscrollBehaviorY(ref value) => {
                let value = crate::values::specified::OverscrollBehavior::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::OverscrollBehavior>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            FillOpacity(ref value) |
StrokeOpacity(ref value) => {
                let value = crate::values::specified::SVGOpacity::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::SVGOpacity>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            FlexGrow(ref value) |
FlexShrink(ref value) |
MozBoxFlex(ref value) |
StrokeMiterlimit(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::NonNegativeNumber::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::NonNegativeNumber>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            FloodOpacity(ref value) |
MozWindowOpacity(ref value) |
Opacity(ref value) |
ShapeImageThreshold(ref value) |
StopOpacity(ref value) => {
                let value = crate::values::specified::Opacity::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::Opacity>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            BorderBottomStyle(ref value) |
BorderLeftStyle(ref value) |
BorderRightStyle(ref value) |
BorderTopStyle(ref value) |
ColumnRuleStyle(ref value) => {
                let value = crate::values::specified::BorderStyle::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::BorderStyle>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            BackgroundAttachment(ref value) => {
                let value = longhands::background_attachment::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::BackgroundAttachment(value)
            }
            
            BackgroundBlendMode(ref value) => {
                let value = longhands::background_blend_mode::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::BackgroundBlendMode(value)
            }
            
            BackgroundClip(ref value) => {
                let value = longhands::background_clip::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::BackgroundClip(value)
            }
            
            BackgroundImage(ref value) => {
                let value = longhands::background_image::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::BackgroundImage(value)
            }
            
            BackgroundOrigin(ref value) => {
                let value = longhands::background_origin::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::BackgroundOrigin(value)
            }
            
            BackgroundPositionX(ref value) => {
                let value = longhands::background_position_x::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::BackgroundPositionX(value)
            }
            
            BackgroundPositionY(ref value) => {
                let value = longhands::background_position_y::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::BackgroundPositionY(value)
            }
            
            BackgroundRepeat(ref value) => {
                let value = longhands::background_repeat::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::BackgroundRepeat(value)
            }
            
            BackgroundSize(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = longhands::background_size::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::BackgroundSize(value)
            }
            
            BorderImageOutset(ref value) => {
                let value = crate::values::specified::NonNegativeLengthOrNumberRect::from_computed_value(&value);
                let value = Box::new(value);
                PropertyDeclaration::BorderImageOutset(value)
            }
            
            BorderImageSlice(ref value) => {
                let value = crate::values::specified::BorderImageSlice::from_computed_value(&value);
                let value = Box::new(value);
                PropertyDeclaration::BorderImageSlice(value)
            }
            
            BorderImageSource(ref value) => {
                let value = crate::values::specified::ImageLayer::from_computed_value(&value);
                PropertyDeclaration::BorderImageSource(value)
            }
            
            BorderImageWidth(ref value) => {
                let value = crate::values::specified::BorderImageWidth::from_computed_value(&value);
                let value = Box::new(value);
                PropertyDeclaration::BorderImageWidth(value)
            }
            
            BorderSpacing(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::BorderSpacing::from_computed_value(&value);
                let value = Box::new(value);
                PropertyDeclaration::BorderSpacing(value)
            }
            
            BoxShadow(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = longhands::box_shadow::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::BoxShadow(value)
            }
            
            CaretColor(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::ColorOrAuto::from_computed_value(&value);
                let value = Box::new(value);
                PropertyDeclaration::CaretColor(value)
            }
            
            ClipPath(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::basic_shape::ClippingShape::from_computed_value(&value);
                PropertyDeclaration::ClipPath(value)
            }
            
            Color(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::ColorPropertyValue::from_computed_value(&value);
                PropertyDeclaration::Color(value)
            }
            
            ColumnWidth(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::length::NonNegativeLengthOrAuto::from_computed_value(&value);
                PropertyDeclaration::ColumnWidth(value)
            }
            
            Content(ref value) => {
                let value = crate::values::specified::Content::from_computed_value(&value);
                PropertyDeclaration::Content(value)
            }
            
            CounterIncrement(ref value) => {
                let value = crate::values::specified::CounterIncrement::from_computed_value(&value);
                PropertyDeclaration::CounterIncrement(value)
            }
            
            Cursor(ref value) => {
                let value = crate::values::specified::Cursor::from_computed_value(&value);
                PropertyDeclaration::Cursor(value)
            }
            
            Filter(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = longhands::filter::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::Filter(value)
            }
            
            FlexBasis(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::FlexBasis::from_computed_value(&value);
                let value = Box::new(value);
                PropertyDeclaration::FlexBasis(value)
            }
            
            FontFamily(ref value) => {
                let value = crate::values::specified::FontFamily::from_computed_value(&value);
                PropertyDeclaration::FontFamily(value)
            }
            
            FontFeatureSettings(ref value) => {
                let value = crate::values::specified::FontFeatureSettings::from_computed_value(&value);
                PropertyDeclaration::FontFeatureSettings(value)
            }
            
            FontLanguageOverride(ref value) => {
                let value = crate::values::specified::FontLanguageOverride::from_computed_value(&value);
                PropertyDeclaration::FontLanguageOverride(value)
            }
            
            FontSize(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::FontSize::from_computed_value(&value);
                PropertyDeclaration::FontSize(value)
            }
            
            FontVariantAlternates(ref value) => {
                let value = crate::values::specified::FontVariantAlternates::from_computed_value(&value);
                PropertyDeclaration::FontVariantAlternates(value)
            }
            
            FontVariationSettings(ref value) => {
                let value = crate::values::specified::FontVariationSettings::from_computed_value(&value);
                PropertyDeclaration::FontVariationSettings(value)
            }
            
            GridTemplateAreas(ref value) => {
                let value = crate::values::specified::GridTemplateAreas::from_computed_value(&value);
                PropertyDeclaration::GridTemplateAreas(value)
            }
            
            LetterSpacing(ref value) => {
                let value = crate::values::specified::LetterSpacing::from_computed_value(&value);
                PropertyDeclaration::LetterSpacing(value)
            }
            
            LineHeight(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::LineHeight::from_computed_value(&value);
                PropertyDeclaration::LineHeight(value)
            }
            
            ListStyleImage(ref value) => {
                let value = crate::values::specified::url::ImageUrlOrNone::from_computed_value(&value);
                PropertyDeclaration::ListStyleImage(value)
            }
            
            ListStyleType(ref value) => {
                let value = crate::values::specified::ListStyleType::from_computed_value(&value);
                let value = Box::new(value);
                PropertyDeclaration::ListStyleType(value)
            }
            
            MaskClip(ref value) => {
                let value = longhands::mask_clip::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MaskClip(value)
            }
            
            MaskComposite(ref value) => {
                let value = longhands::mask_composite::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MaskComposite(value)
            }
            
            MaskImage(ref value) => {
                let value = longhands::mask_image::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MaskImage(value)
            }
            
            MaskMode(ref value) => {
                let value = longhands::mask_mode::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MaskMode(value)
            }
            
            MaskOrigin(ref value) => {
                let value = longhands::mask_origin::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MaskOrigin(value)
            }
            
            MaskPositionX(ref value) => {
                let value = longhands::mask_position_x::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MaskPositionX(value)
            }
            
            MaskPositionY(ref value) => {
                let value = longhands::mask_position_y::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MaskPositionY(value)
            }
            
            MaskRepeat(ref value) => {
                let value = longhands::mask_repeat::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MaskRepeat(value)
            }
            
            MaskSize(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = longhands::mask_size::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::MaskSize(value)
            }
            
            MozTabSize(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::NonNegativeLengthOrNumber::from_computed_value(&value);
                PropertyDeclaration::MozTabSize(value)
            }
            
            OffsetPath(ref value) => {
                let value = crate::values::specified::OffsetPath::from_computed_value(&value);
                PropertyDeclaration::OffsetPath(value)
            }
            
            Perspective(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::Perspective::from_computed_value(&value);
                PropertyDeclaration::Perspective(value)
            }
            
            Quotes(ref value) => {
                let value = crate::values::specified::Quotes::from_computed_value(&value);
                PropertyDeclaration::Quotes(value)
            }
            
            Rotate(ref value) => {
                let value = crate::values::specified::Rotate::from_computed_value(&value);
                let value = Box::new(value);
                PropertyDeclaration::Rotate(value)
            }
            
            Scale(ref value) => {
                let value = crate::values::specified::Scale::from_computed_value(&value);
                let value = Box::new(value);
                PropertyDeclaration::Scale(value)
            }
            
            ScrollSnapCoordinate(ref value) => {
                let value = longhands::scroll_snap_coordinate::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::ScrollSnapCoordinate(value)
            }
            
            ScrollbarColor(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::ui::ScrollbarColor::from_computed_value(&value);
                let value = Box::new(value);
                PropertyDeclaration::ScrollbarColor(value)
            }
            
            ShapeOutside(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::basic_shape::FloatAreaShape::from_computed_value(&value);
                let value = Box::new(value);
                PropertyDeclaration::ShapeOutside(value)
            }
            
            StrokeDasharray(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::SVGStrokeDashArray::from_computed_value(&value);
                PropertyDeclaration::StrokeDasharray(value)
            }
            
            StrokeDashoffset(ref value) => {
                let value = crate::values::specified::SVGLength::from_computed_value(&value);
                PropertyDeclaration::StrokeDashoffset(value)
            }
            
            StrokeWidth(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::SVGWidth::from_computed_value(&value);
                PropertyDeclaration::StrokeWidth(value)
            }
            
            TextEmphasisStyle(ref value) => {
                let value = crate::values::specified::TextEmphasisStyle::from_computed_value(&value);
                let value = Box::new(value);
                PropertyDeclaration::TextEmphasisStyle(value)
            }
            
            TextIndent(ref value) => {
                let value = crate::values::specified::LengthPercentage::from_computed_value(&value);
                PropertyDeclaration::TextIndent(value)
            }
            
            TextOverflow(ref value) => {
                let value = crate::values::specified::TextOverflow::from_computed_value(&value);
                let value = Box::new(value);
                PropertyDeclaration::TextOverflow(value)
            }
            
            TextShadow(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = longhands::text_shadow::SpecifiedValue::from_computed_value(&value);
                PropertyDeclaration::TextShadow(value)
            }
            
            Translate(ref value) => {
                let value = crate::values::specified::Translate::from_computed_value(&value);
                let value = Box::new(value);
                PropertyDeclaration::Translate(value)
            }
            
            VerticalAlign(ref value) => {
                let value = crate::values::specified::VerticalAlign::from_computed_value(&value);
                PropertyDeclaration::VerticalAlign(value)
            }
            
            WordSpacing(ref value) => {
                let value = crate::values::specified::WordSpacing::from_computed_value(&value);
                PropertyDeclaration::WordSpacing(value)
            }
            
            Clip(ref value) |
MozImageRegion(ref value) => {
                let value = crate::values::specified::ClipRectOrAuto::from_computed_value(&value);
                let value = Box::new(value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<Box<crate::values::specified::ClipRectOrAuto>>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            GridTemplateColumns(ref value) |
GridTemplateRows(ref value) => {
                let value = crate::values::specified::GridTemplateComponent::from_computed_value(&value);
                let value = Box::new(value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<Box<crate::values::specified::GridTemplateComponent>>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            Fill(ref value) |
Stroke(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::SVGPaint::from_computed_value(&value);
                let value = Box::new(value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<Box<crate::values::specified::SVGPaint>>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            GridAutoColumns(ref value) |
GridAutoRows(ref value) => {
                let value = crate::values::specified::TrackSize::from_computed_value(&value);
                let value = Box::new(value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<Box<crate::values::specified::TrackSize>>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            MozWindowTransformOrigin(ref value) |
TransformOrigin(ref value) => {
                let value = crate::values::specified::TransformOrigin::from_computed_value(&value);
                let value = Box::new(value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<Box<crate::values::specified::TransformOrigin>>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            CounterReset(ref value) |
CounterSet(ref value) => {
                let value = crate::values::specified::CounterSetOrReset::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::CounterSetOrReset>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            ScrollSnapPointsX(ref value) |
ScrollSnapPointsY(ref value) => {
                let value = crate::values::specified::ScrollSnapPoint::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::ScrollSnapPoint>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            MozWindowTransform(ref value) |
Transform(ref value) => {
                let value = crate::values::specified::Transform::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::Transform>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            ColumnGap(ref value) |
RowGap(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::length::NonNegativeLengthPercentageOrNormal::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::length::NonNegativeLengthPercentageOrNormal>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            ObjectPosition(ref value) |
PerspectiveOrigin(ref value) |
ScrollSnapDestination(ref value) => {
                let value = crate::values::specified::Position::from_computed_value(&value);
                let value = Box::new(value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<Box<crate::values::specified::Position>>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            GridColumnEnd(ref value) |
GridColumnStart(ref value) |
GridRowEnd(ref value) |
GridRowStart(ref value) => {
                let value = crate::values::specified::GridLine::from_computed_value(&value);
                let value = Box::new(value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<Box<crate::values::specified::GridLine>>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            MaxHeight(ref value) |
MaxWidth(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::MaxSize::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::MaxSize>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            MarkerEnd(ref value) |
MarkerMid(ref value) |
MarkerStart(ref value) => {
                let value = crate::values::specified::url::UrlOrNone::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::url::UrlOrNone>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            ScrollPaddingBottom(ref value) |
ScrollPaddingLeft(ref value) |
ScrollPaddingRight(ref value) |
ScrollPaddingTop(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::NonNegativeLengthPercentageOrAuto::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::NonNegativeLengthPercentageOrAuto>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            Height(ref value) |
MinHeight(ref value) |
MinWidth(ref value) |
Width(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::Size::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::Size>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            OutlineOffset(ref value) |
ScrollMarginBottom(ref value) |
ScrollMarginLeft(ref value) |
ScrollMarginRight(ref value) |
ScrollMarginTop(ref value) => {
                let value = crate::values::specified::Length::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::Length>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            PaddingBottom(ref value) |
PaddingLeft(ref value) |
PaddingRight(ref value) |
PaddingTop(ref value) |
ShapeMargin(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::NonNegativeLengthPercentage::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::NonNegativeLengthPercentage>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            BorderBottomWidth(ref value) |
BorderLeftWidth(ref value) |
BorderRightWidth(ref value) |
BorderTopWidth(ref value) |
ColumnRuleWidth(ref value) |
OutlineWidth(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::BorderSideWidth::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::BorderSideWidth>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            WebkitTextStrokeWidth(ref value) => {
                let value = crate::values::specified::BorderSideWidth::from_computed_value(&value);
                PropertyDeclaration::WebkitTextStrokeWidth(value)
            }
            
            BorderBottomLeftRadius(ref value) |
BorderBottomRightRadius(ref value) |
BorderTopLeftRadius(ref value) |
BorderTopRightRadius(ref value) |
MozOutlineRadiusBottomleft(ref value) |
MozOutlineRadiusBottomright(ref value) |
MozOutlineRadiusTopleft(ref value) |
MozOutlineRadiusTopright(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::BorderCornerRadius::from_computed_value(&value);
                let value = Box::new(value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<Box<crate::values::specified::BorderCornerRadius>>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            Bottom(ref value) |
Left(ref value) |
MarginBottom(ref value) |
MarginLeft(ref value) |
MarginRight(ref value) |
MarginTop(ref value) |
Right(ref value) |
Top(ref value) => {
                let value = crate::values::specified::LengthPercentageOrAuto::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::LengthPercentageOrAuto>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            
            BackgroundColor(ref value) |
BorderBottomColor(ref value) |
BorderLeftColor(ref value) |
BorderRightColor(ref value) |
BorderTopColor(ref value) |
ColumnRuleColor(ref value) |
FloodColor(ref value) |
LightingColor(ref value) |
OutlineColor(ref value) |
StopColor(ref value) |
TextDecorationColor(ref value) |
TextEmphasisColor(ref value) |
WebkitTextFillColor(ref value) |
WebkitTextStrokeColor(ref value) => {
                let ref value = ToAnimatedValue::from_animated_value(value.clone());
                let value = crate::values::specified::Color::from_computed_value(&value);
                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut PropertyDeclarationVariantRepr<crate::values::specified::Color>,
                        PropertyDeclarationVariantRepr {
                            tag: *(self as *const _ as *const u16),
                            value,
                        },
                    );
                    out
                }
            }
            Contain(void) |
Direction(void) |
MozControlCharacterVisibility(void) |
MozMathDisplay(void) |
MozMathVariant(void) |
MozMinFontSizeRatio(void) |
MozScriptLevel(void) |
MozScriptMinSize(void) |
MozScriptSizeMultiplier(void) |
MozTopLayer(void) |
TextOrientation(void) |
UnicodeBidi(void) |
WritingMode(void) |
XSpan(void) |
XTextZoom(void) |
BorderBlockEndStyle(void) |
BorderBlockStartStyle(void) |
BorderInlineEndStyle(void) |
BorderInlineStartStyle(void) |
AnimationDelay(void) |
AnimationDirection(void) |
AnimationDuration(void) |
AnimationFillMode(void) |
AnimationIterationCount(void) |
AnimationName(void) |
AnimationPlayState(void) |
AnimationTimingFunction(void) |
MozContextProperties(void) |
MozFontSmoothingBackgroundColor(void) |
TransitionDelay(void) |
TransitionDuration(void) |
TransitionProperty(void) |
TransitionTimingFunction(void) |
WillChange(void) |
XLang(void) |
MaxBlockSize(void) |
MaxInlineSize(void) |
MozBinding(void) |
ScrollPaddingBlockEnd(void) |
ScrollPaddingBlockStart(void) |
ScrollPaddingInlineEnd(void) |
ScrollPaddingInlineStart(void) |
BlockSize(void) |
InlineSize(void) |
MinBlockSize(void) |
MinInlineSize(void) |
ScrollMarginBlockEnd(void) |
ScrollMarginBlockStart(void) |
ScrollMarginInlineEnd(void) |
ScrollMarginInlineStart(void) |
PaddingBlockEnd(void) |
PaddingBlockStart(void) |
PaddingInlineEnd(void) |
PaddingInlineStart(void) |
BorderBlockEndWidth(void) |
BorderBlockStartWidth(void) |
BorderInlineEndWidth(void) |
BorderInlineStartWidth(void) |
BorderEndEndRadius(void) |
BorderEndStartRadius(void) |
BorderStartEndRadius(void) |
BorderStartStartRadius(void) |
InsetBlockEnd(void) |
InsetBlockStart(void) |
InsetInlineEnd(void) |
InsetInlineStart(void) |
MarginBlockEnd(void) |
MarginBlockStart(void) |
MarginInlineEnd(void) |
MarginInlineStart(void) |
BorderBlockEndColor(void) |
BorderBlockStartColor(void) |
BorderInlineEndColor(void) |
BorderInlineStartColor(void) => {
                void::unreachable(void)
            }
        }
    }

    /// Construct an AnimationValue from a property declaration.
    pub fn from_declaration(
        decl: &PropertyDeclaration,
        context: &mut Context,
        extra_custom_properties: Option<&Arc<crate::custom_properties::CustomPropertiesMap>>,
        initial: &ComputedValues
    ) -> Option<Self> {
        use super::PropertyDeclarationVariantRepr;

        

        let animatable = match *decl {
            PropertyDeclaration::AlignContent(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::AlignContent>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::AlignContent as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::AlignItems(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::AlignItems>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::AlignItems as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::AlignSelf(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::AlignSelf>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::AlignSelf as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BackfaceVisibility(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::backface_visibility::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::backface_visibility::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BorderCollapse(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::border_collapse::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::border_collapse::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BorderImageRepeat(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::BorderImageRepeat>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::BorderImageRepeat as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BoxDecorationBreak(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::box_decoration_break::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::box_decoration_break::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BoxSizing(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::box_sizing::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::box_sizing::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BreakInside(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::BreakWithin>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::BreakWithin as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::CaptionSide(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::caption_side::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::caption_side::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Clear(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Clear>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Clear as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ColorAdjust(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::color_adjust::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::color_adjust::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ColorInterpolation(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::color_interpolation::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::color_interpolation::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ColorInterpolationFilters(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::color_interpolation_filters::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::color_interpolation_filters::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ColumnCount(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::ColumnCount>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::ColumnCount as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ColumnFill(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::column_fill::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::column_fill::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ColumnSpan(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::column_span::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::column_span::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Display(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Display>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Display as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::DominantBaseline(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::dominant_baseline::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::dominant_baseline::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::EmptyCells(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::empty_cells::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::empty_cells::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FlexDirection(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::flex_direction::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::flex_direction::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FlexWrap(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::flex_wrap::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::flex_wrap::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Float(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Float>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Float as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FontKerning(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::font_kerning::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                if let Some(sf) = value.get_system() {
                    longhands::system_font::resolve_system_font(sf, context)
                }
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::font_kerning::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FontOpticalSizing(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::font_optical_sizing::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                if let Some(sf) = value.get_system() {
                    longhands::system_font::resolve_system_font(sf, context)
                }
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::font_optical_sizing::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FontSizeAdjust(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontSizeAdjust>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                if let Some(sf) = value.get_system() {
                    longhands::system_font::resolve_system_font(sf, context)
                }
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontSizeAdjust as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FontStretch(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontStretch>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                if let Some(sf) = value.get_system() {
                    longhands::system_font::resolve_system_font(sf, context)
                }
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::FontStretch as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FontStyle(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontStyle>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                if let Some(sf) = value.get_system() {
                    longhands::system_font::resolve_system_font(sf, context)
                }
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::FontStyle as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FontSynthesis(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontSynthesis>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontSynthesis as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FontVariantCaps(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::font_variant_caps::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                if let Some(sf) = value.get_system() {
                    longhands::system_font::resolve_system_font(sf, context)
                }
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::font_variant_caps::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FontVariantEastAsian(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontVariantEastAsian>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                if let Some(sf) = value.get_system() {
                    longhands::system_font::resolve_system_font(sf, context)
                }
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontVariantEastAsian as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FontVariantLigatures(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontVariantLigatures>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                if let Some(sf) = value.get_system() {
                    longhands::system_font::resolve_system_font(sf, context)
                }
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontVariantLigatures as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FontVariantNumeric(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontVariantNumeric>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                if let Some(sf) = value.get_system() {
                    longhands::system_font::resolve_system_font(sf, context)
                }
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontVariantNumeric as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FontVariantPosition(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::font_variant_position::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                if let Some(sf) = value.get_system() {
                    longhands::system_font::resolve_system_font(sf, context)
                }
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::font_variant_position::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FontWeight(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontWeight>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                if let Some(sf) = value.get_system() {
                    longhands::system_font::resolve_system_font(sf, context)
                }
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::FontWeight as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::GridAutoFlow(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::GridAutoFlow>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::GridAutoFlow as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Hyphens(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::hyphens::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::hyphens::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ImageOrientation(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::image_orientation::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::image_orientation::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ImageRendering(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::image_rendering::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::image_rendering::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ImeMode(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::ime_mode::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::ime_mode::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::InitialLetter(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::InitialLetter>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::InitialLetter as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Isolation(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::isolation::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::isolation::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::JustifyContent(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::JustifyContent>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::JustifyContent as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::JustifyItems(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::JustifyItems>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::JustifyItems as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::JustifySelf(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::JustifySelf>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::JustifySelf as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ListStylePosition(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::list_style_position::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::list_style_position::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MaskType(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_type::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mask_type::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MixBlendMode(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::mix_blend_mode::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mix_blend_mode::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozAppearance(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Appearance>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Appearance as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozBoxAlign(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_box_align::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_box_align::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozBoxDirection(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_box_direction::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_box_direction::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozBoxOrient(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_box_orient::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_box_orient::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozBoxPack(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_box_pack::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_box_pack::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozFloatEdge(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_float_edge::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_float_edge::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozForceBrokenImageIcon(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::MozForceBrokenImageIcon>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::MozForceBrokenImageIcon as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozListReversed(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::MozListReversed>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::MozListReversed as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozOrient(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_orient::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_orient::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozOsxFontSmoothing(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_osx_font_smoothing::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_osx_font_smoothing::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozStackSizing(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_stack_sizing::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_stack_sizing::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozTextSizeAdjust(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_text_size_adjust::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_text_size_adjust::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozUserFocus(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_user_focus::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_user_focus::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozUserInput(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_user_input::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_user_input::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozUserModify(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_user_modify::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_user_modify::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozUserSelect(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::UserSelect>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::UserSelect as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozWindowDragging(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_window_dragging::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_window_dragging::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozWindowShadow(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::_moz_window_shadow::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_window_shadow::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ObjectFit(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::object_fit::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::object_fit::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::OutlineStyle(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::OutlineStyle>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::OutlineStyle as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::OverflowAnchor(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::OverflowAnchor>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::OverflowAnchor as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::OverflowWrap(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::OverflowWrap>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::OverflowWrap as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::PaintOrder(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::SVGPaintOrder>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::SVGPaintOrder as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::PointerEvents(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::pointer_events::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::pointer_events::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Position(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::position::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::position::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Resize(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Resize>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Resize as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::RubyAlign(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::ruby_align::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::ruby_align::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::RubyPosition(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::ruby_position::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::ruby_position::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ScrollBehavior(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::scroll_behavior::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::scroll_behavior::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ScrollSnapAlign(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::ScrollSnapAlign>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::ScrollSnapAlign as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ScrollSnapType(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::ScrollSnapType>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::ScrollSnapType as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ScrollbarWidth(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::scrollbar_width::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::scrollbar_width::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ShapeRendering(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::shape_rendering::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::shape_rendering::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::StrokeLinecap(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::stroke_linecap::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::stroke_linecap::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::StrokeLinejoin(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::stroke_linejoin::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::stroke_linejoin::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TableLayout(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::table_layout::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::table_layout::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TextAlign(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::TextAlign>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TextAlign as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TextAlignLast(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::text_align_last::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::text_align_last::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TextAnchor(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::text_anchor::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::text_anchor::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TextCombineUpright(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::text_combine_upright::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::text_combine_upright::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TextDecorationLine(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::TextDecorationLine>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TextDecorationLine as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TextDecorationStyle(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::text_decoration_style::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::text_decoration_style::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TextEmphasisPosition(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::TextEmphasisPosition>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TextEmphasisPosition as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TextJustify(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::text_justify::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::text_justify::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TextRendering(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::text_rendering::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::text_rendering::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TextTransform(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::TextTransform>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TextTransform as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TouchAction(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::TouchAction>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TouchAction as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TransformBox(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::transform_box::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::transform_box::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TransformStyle(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::TransformStyle>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TransformStyle as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::VectorEffect(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::vector_effect::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::vector_effect::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Visibility(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::visibility::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::visibility::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::WebkitLineClamp(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::PositiveIntegerOrNone>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::PositiveIntegerOrNone as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::WhiteSpace(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::white_space::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::white_space::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::WordBreak(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::WordBreak>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::WordBreak as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ZIndex(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::ZIndex>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::ZIndex as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BreakAfter(ref value) |
PropertyDeclaration::BreakBefore(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::BreakBetween>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::BreakBetween as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ClipRule(ref value) |
PropertyDeclaration::FillRule(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FillRule>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FillRule as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozBoxOrdinalGroup(ref value) |
PropertyDeclaration::Order(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Integer>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Integer as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::OverflowX(ref value) |
PropertyDeclaration::OverflowY(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Overflow>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Overflow as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::OverflowClipBoxBlock(ref value) |
PropertyDeclaration::OverflowClipBoxInline(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::OverflowClipBox>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::OverflowClipBox as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::OverscrollBehaviorX(ref value) |
PropertyDeclaration::OverscrollBehaviorY(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::OverscrollBehavior>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::OverscrollBehavior as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FillOpacity(ref value) |
PropertyDeclaration::StrokeOpacity(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::SVGOpacity>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::SVGOpacity as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FlexGrow(ref value) |
PropertyDeclaration::FlexShrink(ref value) |
PropertyDeclaration::MozBoxFlex(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::NonNegativeNumber>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::NonNegativeNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::StrokeMiterlimit(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::NonNegativeNumber>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::NonNegativeNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FloodOpacity(ref value) |
PropertyDeclaration::MozWindowOpacity(ref value) |
PropertyDeclaration::Opacity(ref value) |
PropertyDeclaration::ShapeImageThreshold(ref value) |
PropertyDeclaration::StopOpacity(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Opacity>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Opacity as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BorderBottomStyle(ref value) |
PropertyDeclaration::BorderLeftStyle(ref value) |
PropertyDeclaration::BorderRightStyle(ref value) |
PropertyDeclaration::BorderTopStyle(ref value) |
PropertyDeclaration::ColumnRuleStyle(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::BorderStyle>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::BorderStyle as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BackgroundAttachment(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::background_attachment::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::background_attachment::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BackgroundBlendMode(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::background_blend_mode::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::background_blend_mode::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BackgroundClip(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::background_clip::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::background_clip::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BackgroundImage(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::background_image::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::background_image::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BackgroundOrigin(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::background_origin::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::background_origin::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BackgroundPositionX(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::background_position_x::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::background_position_x::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BackgroundPositionY(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::background_position_y::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::background_position_y::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BackgroundRepeat(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::background_repeat::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::background_repeat::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BackgroundSize(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::background_size::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<longhands::background_size::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BorderImageOutset(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::NonNegativeLengthOrNumberRect>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = (**value).to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::NonNegativeLengthOrNumberRect as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BorderImageSlice(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::BorderImageSlice>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = (**value).to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::BorderImageSlice as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BorderImageSource(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::ImageLayer>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::ImageLayer as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BorderImageWidth(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::BorderImageWidth>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = (**value).to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::BorderImageWidth as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BorderSpacing(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::BorderSpacing>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = (**value).to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::BorderSpacing as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BoxShadow(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::box_shadow::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<longhands::box_shadow::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::CaretColor(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::ColorOrAuto>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = (**value).to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::ColorOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ClipPath(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::basic_shape::ClippingShape>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::basic_shape::ClippingShape as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Color(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::ColorPropertyValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::ColorPropertyValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ColumnWidth(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::length::NonNegativeLengthOrAuto>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::length::NonNegativeLengthOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Content(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Content>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Content as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::CounterIncrement(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::CounterIncrement>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::CounterIncrement as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Cursor(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Cursor>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Cursor as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Filter(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::filter::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<longhands::filter::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FlexBasis(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::FlexBasis>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = (**value).to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::FlexBasis as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FontFamily(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontFamily>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                if let Some(sf) = value.get_system() {
                    longhands::system_font::resolve_system_font(sf, context)
                }
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontFamily as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FontFeatureSettings(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontFeatureSettings>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                if let Some(sf) = value.get_system() {
                    longhands::system_font::resolve_system_font(sf, context)
                }
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontFeatureSettings as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FontLanguageOverride(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontLanguageOverride>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                if let Some(sf) = value.get_system() {
                    longhands::system_font::resolve_system_font(sf, context)
                }
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontLanguageOverride as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FontSize(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontSize>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                if let Some(sf) = value.get_system() {
                    longhands::system_font::resolve_system_font(sf, context)
                }
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::FontSize as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FontVariantAlternates(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontVariantAlternates>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                if let Some(sf) = value.get_system() {
                    longhands::system_font::resolve_system_font(sf, context)
                }
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontVariantAlternates as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::FontVariationSettings(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::FontVariationSettings>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                if let Some(sf) = value.get_system() {
                    longhands::system_font::resolve_system_font(sf, context)
                }
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontVariationSettings as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::GridTemplateAreas(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::GridTemplateAreas>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::GridTemplateAreas as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::LetterSpacing(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::LetterSpacing>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::LetterSpacing as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::LineHeight(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::LineHeight>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::LineHeight as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ListStyleImage(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::url::ImageUrlOrNone>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::url::ImageUrlOrNone as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ListStyleType(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::ListStyleType>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = (**value).to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::ListStyleType as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MaskClip(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_clip::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mask_clip::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MaskComposite(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_composite::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mask_composite::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MaskImage(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_image::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mask_image::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MaskMode(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_mode::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mask_mode::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MaskOrigin(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_origin::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mask_origin::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MaskPositionX(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_position_x::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mask_position_x::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MaskPositionY(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_position_y::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mask_position_y::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MaskRepeat(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_repeat::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mask_repeat::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MaskSize(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::mask_size::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<longhands::mask_size::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozTabSize(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::NonNegativeLengthOrNumber>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::NonNegativeLengthOrNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::OffsetPath(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::OffsetPath>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::OffsetPath as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Perspective(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Perspective>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::Perspective as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Quotes(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Quotes>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Quotes as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Rotate(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::Rotate>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = (**value).to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Rotate as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Scale(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::Scale>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = (**value).to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Scale as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ScrollSnapCoordinate(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::scroll_snap_coordinate::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::scroll_snap_coordinate::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ScrollbarColor(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::ui::ScrollbarColor>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = (**value).to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::ui::ScrollbarColor as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ShapeOutside(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::basic_shape::FloatAreaShape>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = (**value).to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::basic_shape::FloatAreaShape as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::StrokeDasharray(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::SVGStrokeDashArray>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::SVGStrokeDashArray as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::StrokeDashoffset(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::SVGLength>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::SVGLength as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::StrokeWidth(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::SVGWidth>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::SVGWidth as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TextEmphasisStyle(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::TextEmphasisStyle>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = (**value).to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TextEmphasisStyle as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TextIndent(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::LengthPercentage>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::LengthPercentage as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TextOverflow(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::TextOverflow>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = (**value).to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TextOverflow as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TextShadow(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<longhands::text_shadow::SpecifiedValue>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<longhands::text_shadow::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Translate(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::Translate>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = (**value).to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Translate as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::VerticalAlign(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::VerticalAlign>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::VerticalAlign as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::WordSpacing(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::WordSpacing>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::WordSpacing as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Clip(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::ClipRectOrAuto>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = (**value).to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::ClipRectOrAuto as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozImageRegion(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::ClipRectOrAuto>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = (**value).to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::ClipRectOrAuto as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::GridTemplateColumns(ref value) |
PropertyDeclaration::GridTemplateRows(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::GridTemplateComponent>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = (**value).to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::GridTemplateComponent as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Fill(ref value) |
PropertyDeclaration::Stroke(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::SVGPaint>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = (**value).to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::SVGPaint as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::GridAutoColumns(ref value) |
PropertyDeclaration::GridAutoRows(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::TrackSize>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = (**value).to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TrackSize as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozWindowTransformOrigin(ref value) |
PropertyDeclaration::TransformOrigin(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::TransformOrigin>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = (**value).to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TransformOrigin as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::CounterReset(ref value) |
PropertyDeclaration::CounterSet(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::CounterSetOrReset>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::CounterSetOrReset as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ScrollSnapPointsX(ref value) |
PropertyDeclaration::ScrollSnapPointsY(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::ScrollSnapPoint>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::ScrollSnapPoint as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MozWindowTransform(ref value) |
PropertyDeclaration::Transform(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Transform>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Transform as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ColumnGap(ref value) |
PropertyDeclaration::RowGap(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::length::NonNegativeLengthPercentageOrNormal>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::length::NonNegativeLengthPercentageOrNormal as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ObjectPosition(ref value) |
PropertyDeclaration::PerspectiveOrigin(ref value) |
PropertyDeclaration::ScrollSnapDestination(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::Position>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = (**value).to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Position as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::GridColumnEnd(ref value) |
PropertyDeclaration::GridColumnStart(ref value) |
PropertyDeclaration::GridRowEnd(ref value) |
PropertyDeclaration::GridRowStart(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::GridLine>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = (**value).to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::GridLine as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MaxBlockSize(ref value) |
PropertyDeclaration::MaxHeight(ref value) |
PropertyDeclaration::MaxInlineSize(ref value) |
PropertyDeclaration::MaxWidth(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::MaxSize>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::MaxSize as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::MarkerEnd(ref value) |
PropertyDeclaration::MarkerMid(ref value) |
PropertyDeclaration::MarkerStart(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::url::UrlOrNone>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::url::UrlOrNone as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::ScrollPaddingBlockEnd(ref value) |
PropertyDeclaration::ScrollPaddingBlockStart(ref value) |
PropertyDeclaration::ScrollPaddingBottom(ref value) |
PropertyDeclaration::ScrollPaddingInlineEnd(ref value) |
PropertyDeclaration::ScrollPaddingInlineStart(ref value) |
PropertyDeclaration::ScrollPaddingLeft(ref value) |
PropertyDeclaration::ScrollPaddingRight(ref value) |
PropertyDeclaration::ScrollPaddingTop(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::NonNegativeLengthPercentageOrAuto>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::NonNegativeLengthPercentageOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BlockSize(ref value) |
PropertyDeclaration::Height(ref value) |
PropertyDeclaration::InlineSize(ref value) |
PropertyDeclaration::MinBlockSize(ref value) |
PropertyDeclaration::MinHeight(ref value) |
PropertyDeclaration::MinInlineSize(ref value) |
PropertyDeclaration::MinWidth(ref value) |
PropertyDeclaration::Width(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Size>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::Size as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::OutlineOffset(ref value) |
PropertyDeclaration::ScrollMarginBlockEnd(ref value) |
PropertyDeclaration::ScrollMarginBlockStart(ref value) |
PropertyDeclaration::ScrollMarginBottom(ref value) |
PropertyDeclaration::ScrollMarginInlineEnd(ref value) |
PropertyDeclaration::ScrollMarginInlineStart(ref value) |
PropertyDeclaration::ScrollMarginLeft(ref value) |
PropertyDeclaration::ScrollMarginRight(ref value) |
PropertyDeclaration::ScrollMarginTop(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Length>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Length as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::PaddingBlockEnd(ref value) |
PropertyDeclaration::PaddingBlockStart(ref value) |
PropertyDeclaration::PaddingBottom(ref value) |
PropertyDeclaration::PaddingInlineEnd(ref value) |
PropertyDeclaration::PaddingInlineStart(ref value) |
PropertyDeclaration::PaddingLeft(ref value) |
PropertyDeclaration::PaddingRight(ref value) |
PropertyDeclaration::PaddingTop(ref value) |
PropertyDeclaration::ShapeMargin(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::NonNegativeLengthPercentage>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::NonNegativeLengthPercentage as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BorderBlockEndWidth(ref value) |
PropertyDeclaration::BorderBlockStartWidth(ref value) |
PropertyDeclaration::BorderBottomWidth(ref value) |
PropertyDeclaration::BorderInlineEndWidth(ref value) |
PropertyDeclaration::BorderInlineStartWidth(ref value) |
PropertyDeclaration::BorderLeftWidth(ref value) |
PropertyDeclaration::BorderRightWidth(ref value) |
PropertyDeclaration::BorderTopWidth(ref value) |
PropertyDeclaration::ColumnRuleWidth(ref value) |
PropertyDeclaration::OutlineWidth(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::BorderSideWidth>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::BorderSideWidth as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::WebkitTextStrokeWidth(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::BorderSideWidth>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::BorderSideWidth as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BorderBottomLeftRadius(ref value) |
PropertyDeclaration::BorderBottomRightRadius(ref value) |
PropertyDeclaration::BorderEndEndRadius(ref value) |
PropertyDeclaration::BorderEndStartRadius(ref value) |
PropertyDeclaration::BorderStartEndRadius(ref value) |
PropertyDeclaration::BorderStartStartRadius(ref value) |
PropertyDeclaration::BorderTopLeftRadius(ref value) |
PropertyDeclaration::BorderTopRightRadius(ref value) |
PropertyDeclaration::MozOutlineRadiusBottomleft(ref value) |
PropertyDeclaration::MozOutlineRadiusBottomright(ref value) |
PropertyDeclaration::MozOutlineRadiusTopleft(ref value) |
PropertyDeclaration::MozOutlineRadiusTopright(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<Box<crate::values::specified::BorderCornerRadius>>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = (**value).to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::BorderCornerRadius as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::Bottom(ref value) |
PropertyDeclaration::InsetBlockEnd(ref value) |
PropertyDeclaration::InsetBlockStart(ref value) |
PropertyDeclaration::InsetInlineEnd(ref value) |
PropertyDeclaration::InsetInlineStart(ref value) |
PropertyDeclaration::Left(ref value) |
PropertyDeclaration::MarginBlockEnd(ref value) |
PropertyDeclaration::MarginBlockStart(ref value) |
PropertyDeclaration::MarginBottom(ref value) |
PropertyDeclaration::MarginInlineEnd(ref value) |
PropertyDeclaration::MarginInlineStart(ref value) |
PropertyDeclaration::MarginLeft(ref value) |
PropertyDeclaration::MarginRight(ref value) |
PropertyDeclaration::MarginTop(ref value) |
PropertyDeclaration::Right(ref value) |
PropertyDeclaration::Top(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::LengthPercentageOrAuto>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::LengthPercentageOrAuto as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::BackgroundColor(ref value) |
PropertyDeclaration::BorderBlockEndColor(ref value) |
PropertyDeclaration::BorderBlockStartColor(ref value) |
PropertyDeclaration::BorderBottomColor(ref value) |
PropertyDeclaration::BorderInlineEndColor(ref value) |
PropertyDeclaration::BorderInlineStartColor(ref value) |
PropertyDeclaration::BorderLeftColor(ref value) |
PropertyDeclaration::BorderRightColor(ref value) |
PropertyDeclaration::BorderTopColor(ref value) |
PropertyDeclaration::ColumnRuleColor(ref value) |
PropertyDeclaration::FloodColor(ref value) |
PropertyDeclaration::LightingColor(ref value) |
PropertyDeclaration::OutlineColor(ref value) |
PropertyDeclaration::StopColor(ref value) |
PropertyDeclaration::TextDecorationColor(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Color>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = Some(longhand_id);
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::TextEmphasisColor(ref value) |
PropertyDeclaration::WebkitTextFillColor(ref value) |
PropertyDeclaration::WebkitTextStrokeColor(ref value) => {
                let decl_repr = unsafe {
                    &*(decl as *const _ as *const PropertyDeclarationVariantRepr<crate::values::specified::Color>)
                };
                let longhand_id = unsafe {
                    *(&decl_repr.tag as *const u16 as *const LonghandId)
                };
                context.for_non_inherited_property = None;
                let value = value.to_computed_value(context);
                let value = value.to_animated_value();

                unsafe {
                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: longhand_id.to_physical(context.builder.writing_mode) as u16,
                            value,
                        },
                    );
                    out
                }
            }
            PropertyDeclaration::CSSWideKeyword(ref declaration) => {
                match declaration.id {
                    // We put all the animatable properties first in the hopes
                    // that it might increase match locality.
                    LonghandId::AlignContent => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_align_content();


                            AnimationValue::AlignContent(computed)
                    },
                    LonghandId::AlignItems => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_align_items();


                            AnimationValue::AlignItems(computed)
                    },
                    LonghandId::AlignSelf => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_align_self();


                            AnimationValue::AlignSelf(computed)
                    },
                    LonghandId::BackfaceVisibility => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_backface_visibility();


                            AnimationValue::BackfaceVisibility(computed)
                    },
                    LonghandId::BorderCollapse => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_table()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_table()
                            },
                        };
                        let computed = style_struct
                            .clone_border_collapse();


                            AnimationValue::BorderCollapse(computed)
                    },
                    LonghandId::BorderImageRepeat => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_image_repeat();


                            AnimationValue::BorderImageRepeat(computed)
                    },
                    LonghandId::BoxDecorationBreak => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_box_decoration_break();


                            AnimationValue::BoxDecorationBreak(computed)
                    },
                    LonghandId::BoxSizing => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_box_sizing();


                            AnimationValue::BoxSizing(computed)
                    },
                    LonghandId::BreakInside => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_break_inside();


                            AnimationValue::BreakInside(computed)
                    },
                    LonghandId::CaptionSide => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_table()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_table()
                            },
                        };
                        let computed = style_struct
                            .clone_caption_side();


                            AnimationValue::CaptionSide(computed)
                    },
                    LonghandId::Clear => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_clear();


                            AnimationValue::Clear(computed)
                    },
                    LonghandId::ColorAdjust => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_box()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_box()
                            },
                        };
                        let computed = style_struct
                            .clone_color_adjust();


                            AnimationValue::ColorAdjust(computed)
                    },
                    LonghandId::ColorInterpolation => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_color_interpolation();


                            AnimationValue::ColorInterpolation(computed)
                    },
                    LonghandId::ColorInterpolationFilters => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_color_interpolation_filters();


                            AnimationValue::ColorInterpolationFilters(computed)
                    },
                    LonghandId::ColumnCount => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_column()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_column()
                            },
                        };
                        let computed = style_struct
                            .clone_column_count();

                        let computed = computed.to_animated_value();

                            AnimationValue::ColumnCount(computed)
                    },
                    LonghandId::ColumnFill => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_column()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_column()
                            },
                        };
                        let computed = style_struct
                            .clone_column_fill();


                            AnimationValue::ColumnFill(computed)
                    },
                    LonghandId::ColumnSpan => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_column()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_column()
                            },
                        };
                        let computed = style_struct
                            .clone_column_span();


                            AnimationValue::ColumnSpan(computed)
                    },
                    LonghandId::Display => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_display();


                            AnimationValue::Display(computed)
                    },
                    LonghandId::DominantBaseline => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_svg()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_dominant_baseline();


                            AnimationValue::DominantBaseline(computed)
                    },
                    LonghandId::EmptyCells => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_table()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_table()
                            },
                        };
                        let computed = style_struct
                            .clone_empty_cells();


                            AnimationValue::EmptyCells(computed)
                    },
                    LonghandId::FlexDirection => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_flex_direction();


                            AnimationValue::FlexDirection(computed)
                    },
                    LonghandId::FlexWrap => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_flex_wrap();


                            AnimationValue::FlexWrap(computed)
                    },
                    LonghandId::Float => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_float();


                            AnimationValue::Float(computed)
                    },
                    LonghandId::FontKerning => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone_font_kerning();


                            AnimationValue::FontKerning(computed)
                    },
                    LonghandId::FontOpticalSizing => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone_font_optical_sizing();


                            AnimationValue::FontOpticalSizing(computed)
                    },
                    LonghandId::FontSizeAdjust => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone_font_size_adjust();


                            AnimationValue::FontSizeAdjust(computed)
                    },
                    LonghandId::FontStretch => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone_font_stretch();

                        let computed = computed.to_animated_value();

                            AnimationValue::FontStretch(computed)
                    },
                    LonghandId::FontStyle => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone_font_style();

                        let computed = computed.to_animated_value();

                            AnimationValue::FontStyle(computed)
                    },
                    LonghandId::FontSynthesis => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone_font_synthesis();


                            AnimationValue::FontSynthesis(computed)
                    },
                    LonghandId::FontVariantCaps => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone_font_variant_caps();


                            AnimationValue::FontVariantCaps(computed)
                    },
                    LonghandId::FontVariantEastAsian => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone_font_variant_east_asian();


                            AnimationValue::FontVariantEastAsian(computed)
                    },
                    LonghandId::FontVariantLigatures => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone_font_variant_ligatures();


                            AnimationValue::FontVariantLigatures(computed)
                    },
                    LonghandId::FontVariantNumeric => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone_font_variant_numeric();


                            AnimationValue::FontVariantNumeric(computed)
                    },
                    LonghandId::FontVariantPosition => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone_font_variant_position();


                            AnimationValue::FontVariantPosition(computed)
                    },
                    LonghandId::FontWeight => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone_font_weight();

                        let computed = computed.to_animated_value();

                            AnimationValue::FontWeight(computed)
                    },
                    LonghandId::GridAutoFlow => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_grid_auto_flow();


                            AnimationValue::GridAutoFlow(computed)
                    },
                    LonghandId::Hyphens => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_hyphens();


                            AnimationValue::Hyphens(computed)
                    },
                    LonghandId::ImageOrientation => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_box()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_box()
                            },
                        };
                        let computed = style_struct
                            .clone_image_orientation();


                            AnimationValue::ImageOrientation(computed)
                    },
                    LonghandId::ImageRendering => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_box()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_box()
                            },
                        };
                        let computed = style_struct
                            .clone_image_rendering();


                            AnimationValue::ImageRendering(computed)
                    },
                    LonghandId::ImeMode => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_ui()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_ui()
                            },
                        };
                        let computed = style_struct
                            .clone_ime_mode();


                            AnimationValue::ImeMode(computed)
                    },
                    LonghandId::InitialLetter => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_text()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_text()
                            },
                        };
                        let computed = style_struct
                            .clone_initial_letter();


                            AnimationValue::InitialLetter(computed)
                    },
                    LonghandId::Isolation => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_isolation();


                            AnimationValue::Isolation(computed)
                    },
                    LonghandId::JustifyContent => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_justify_content();


                            AnimationValue::JustifyContent(computed)
                    },
                    LonghandId::JustifyItems => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_justify_items();


                            AnimationValue::JustifyItems(computed)
                    },
                    LonghandId::JustifySelf => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_justify_self();


                            AnimationValue::JustifySelf(computed)
                    },
                    LonghandId::ListStylePosition => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_list()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_list()
                            },
                        };
                        let computed = style_struct
                            .clone_list_style_position();


                            AnimationValue::ListStylePosition(computed)
                    },
                    LonghandId::MaskType => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_svg()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_mask_type();


                            AnimationValue::MaskType(computed)
                    },
                    LonghandId::MixBlendMode => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_effects()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_effects()
                            },
                        };
                        let computed = style_struct
                            .clone_mix_blend_mode();


                            AnimationValue::MixBlendMode(computed)
                    },
                    LonghandId::MozAppearance => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_appearance();


                            AnimationValue::MozAppearance(computed)
                    },
                    LonghandId::MozBoxAlign => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_xul()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_xul()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_box_align();


                            AnimationValue::MozBoxAlign(computed)
                    },
                    LonghandId::MozBoxDirection => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_xul()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_xul()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_box_direction();


                            AnimationValue::MozBoxDirection(computed)
                    },
                    LonghandId::MozBoxOrient => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_xul()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_xul()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_box_orient();


                            AnimationValue::MozBoxOrient(computed)
                    },
                    LonghandId::MozBoxPack => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_xul()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_xul()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_box_pack();


                            AnimationValue::MozBoxPack(computed)
                    },
                    LonghandId::MozFloatEdge => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_float_edge();


                            AnimationValue::MozFloatEdge(computed)
                    },
                    LonghandId::MozForceBrokenImageIcon => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_ui()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_ui()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_force_broken_image_icon();


                            AnimationValue::MozForceBrokenImageIcon(computed)
                    },
                    LonghandId::MozListReversed => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_list()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_list()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_list_reversed();


                            AnimationValue::MozListReversed(computed)
                    },
                    LonghandId::MozOrient => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_orient();


                            AnimationValue::MozOrient(computed)
                    },
                    LonghandId::MozOsxFontSmoothing => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_osx_font_smoothing();


                            AnimationValue::MozOsxFontSmoothing(computed)
                    },
                    LonghandId::MozStackSizing => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_xul()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_xul()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_stack_sizing();


                            AnimationValue::MozStackSizing(computed)
                    },
                    LonghandId::MozTextSizeAdjust => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_text_size_adjust();


                            AnimationValue::MozTextSizeAdjust(computed)
                    },
                    LonghandId::MozUserFocus => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_ui()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_ui()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_user_focus();


                            AnimationValue::MozUserFocus(computed)
                    },
                    LonghandId::MozUserInput => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_ui()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_ui()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_user_input();


                            AnimationValue::MozUserInput(computed)
                    },
                    LonghandId::MozUserModify => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_ui()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_ui()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_user_modify();


                            AnimationValue::MozUserModify(computed)
                    },
                    LonghandId::MozUserSelect => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_ui()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_ui()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_user_select();


                            AnimationValue::MozUserSelect(computed)
                    },
                    LonghandId::MozWindowDragging => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_ui()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_ui()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_window_dragging();


                            AnimationValue::MozWindowDragging(computed)
                    },
                    LonghandId::MozWindowShadow => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_ui()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_ui()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_window_shadow();


                            AnimationValue::MozWindowShadow(computed)
                    },
                    LonghandId::ObjectFit => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_object_fit();


                            AnimationValue::ObjectFit(computed)
                    },
                    LonghandId::OutlineStyle => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_outline()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_outline()
                            },
                        };
                        let computed = style_struct
                            .clone_outline_style();


                            AnimationValue::OutlineStyle(computed)
                    },
                    LonghandId::OverflowAnchor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_overflow_anchor();


                            AnimationValue::OverflowAnchor(computed)
                    },
                    LonghandId::OverflowWrap => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_overflow_wrap();


                            AnimationValue::OverflowWrap(computed)
                    },
                    LonghandId::PaintOrder => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_paint_order();


                            AnimationValue::PaintOrder(computed)
                    },
                    LonghandId::PointerEvents => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_ui()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_ui()
                            },
                        };
                        let computed = style_struct
                            .clone_pointer_events();


                            AnimationValue::PointerEvents(computed)
                    },
                    LonghandId::Position => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_position();


                            AnimationValue::Position(computed)
                    },
                    LonghandId::Resize => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_resize();


                            AnimationValue::Resize(computed)
                    },
                    LonghandId::RubyAlign => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_ruby_align();


                            AnimationValue::RubyAlign(computed)
                    },
                    LonghandId::RubyPosition => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_ruby_position();


                            AnimationValue::RubyPosition(computed)
                    },
                    LonghandId::ScrollBehavior => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_behavior();


                            AnimationValue::ScrollBehavior(computed)
                    },
                    LonghandId::ScrollSnapAlign => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_snap_align();


                            AnimationValue::ScrollSnapAlign(computed)
                    },
                    LonghandId::ScrollSnapType => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_snap_type();


                            AnimationValue::ScrollSnapType(computed)
                    },
                    LonghandId::ScrollbarWidth => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_ui()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_ui()
                            },
                        };
                        let computed = style_struct
                            .clone_scrollbar_width();


                            AnimationValue::ScrollbarWidth(computed)
                    },
                    LonghandId::ShapeRendering => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_shape_rendering();


                            AnimationValue::ShapeRendering(computed)
                    },
                    LonghandId::StrokeLinecap => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_stroke_linecap();


                            AnimationValue::StrokeLinecap(computed)
                    },
                    LonghandId::StrokeLinejoin => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_stroke_linejoin();


                            AnimationValue::StrokeLinejoin(computed)
                    },
                    LonghandId::TableLayout => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_table()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_table()
                            },
                        };
                        let computed = style_struct
                            .clone_table_layout();


                            AnimationValue::TableLayout(computed)
                    },
                    LonghandId::TextAlign => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_text_align();


                            AnimationValue::TextAlign(computed)
                    },
                    LonghandId::TextAlignLast => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_text_align_last();


                            AnimationValue::TextAlignLast(computed)
                    },
                    LonghandId::TextAnchor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_text_anchor();


                            AnimationValue::TextAnchor(computed)
                    },
                    LonghandId::TextCombineUpright => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_text_combine_upright();


                            AnimationValue::TextCombineUpright(computed)
                    },
                    LonghandId::TextDecorationLine => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_text()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_text()
                            },
                        };
                        let computed = style_struct
                            .clone_text_decoration_line();


                            AnimationValue::TextDecorationLine(computed)
                    },
                    LonghandId::TextDecorationStyle => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_text()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_text()
                            },
                        };
                        let computed = style_struct
                            .clone_text_decoration_style();


                            AnimationValue::TextDecorationStyle(computed)
                    },
                    LonghandId::TextEmphasisPosition => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_text_emphasis_position();


                            AnimationValue::TextEmphasisPosition(computed)
                    },
                    LonghandId::TextJustify => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_text_justify();


                            AnimationValue::TextJustify(computed)
                    },
                    LonghandId::TextRendering => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_text_rendering();


                            AnimationValue::TextRendering(computed)
                    },
                    LonghandId::TextTransform => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_text_transform();


                            AnimationValue::TextTransform(computed)
                    },
                    LonghandId::TouchAction => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_touch_action();


                            AnimationValue::TouchAction(computed)
                    },
                    LonghandId::TransformBox => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_transform_box();


                            AnimationValue::TransformBox(computed)
                    },
                    LonghandId::TransformStyle => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_transform_style();


                            AnimationValue::TransformStyle(computed)
                    },
                    LonghandId::VectorEffect => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_svg()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_vector_effect();


                            AnimationValue::VectorEffect(computed)
                    },
                    LonghandId::Visibility => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_box()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_box()
                            },
                        };
                        let computed = style_struct
                            .clone_visibility();


                            AnimationValue::Visibility(computed)
                    },
                    LonghandId::WebkitLineClamp => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone__webkit_line_clamp();

                        let computed = computed.to_animated_value();

                            AnimationValue::WebkitLineClamp(computed)
                    },
                    LonghandId::WhiteSpace => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_white_space();


                            AnimationValue::WhiteSpace(computed)
                    },
                    LonghandId::WordBreak => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_word_break();


                            AnimationValue::WordBreak(computed)
                    },
                    LonghandId::ZIndex => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_z_index();


                            AnimationValue::ZIndex(computed)
                    },
                    LonghandId::BreakAfter => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_break_after();


                            AnimationValue::BreakAfter(computed)
                    },
                    LonghandId::BreakBefore => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_break_before();


                            AnimationValue::BreakBefore(computed)
                    },
                    LonghandId::ClipRule => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_clip_rule();


                            AnimationValue::ClipRule(computed)
                    },
                    LonghandId::FillRule => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_fill_rule();


                            AnimationValue::FillRule(computed)
                    },
                    LonghandId::MozBoxOrdinalGroup => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_xul()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_xul()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_box_ordinal_group();


                            AnimationValue::MozBoxOrdinalGroup(computed)
                    },
                    LonghandId::Order => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_order();


                            AnimationValue::Order(computed)
                    },
                    LonghandId::OverflowX => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_overflow_x();


                            AnimationValue::OverflowX(computed)
                    },
                    LonghandId::OverflowY => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_overflow_y();


                            AnimationValue::OverflowY(computed)
                    },
                    LonghandId::OverflowClipBoxBlock => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_overflow_clip_box_block();


                            AnimationValue::OverflowClipBoxBlock(computed)
                    },
                    LonghandId::OverflowClipBoxInline => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_overflow_clip_box_inline();


                            AnimationValue::OverflowClipBoxInline(computed)
                    },
                    LonghandId::OverscrollBehaviorX => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_overscroll_behavior_x();


                            AnimationValue::OverscrollBehaviorX(computed)
                    },
                    LonghandId::OverscrollBehaviorY => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_overscroll_behavior_y();


                            AnimationValue::OverscrollBehaviorY(computed)
                    },
                    LonghandId::FillOpacity => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_fill_opacity();


                            AnimationValue::FillOpacity(computed)
                    },
                    LonghandId::StrokeOpacity => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_stroke_opacity();


                            AnimationValue::StrokeOpacity(computed)
                    },
                    LonghandId::FlexGrow => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_flex_grow();

                        let computed = computed.to_animated_value();

                            AnimationValue::FlexGrow(computed)
                    },
                    LonghandId::FlexShrink => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_flex_shrink();

                        let computed = computed.to_animated_value();

                            AnimationValue::FlexShrink(computed)
                    },
                    LonghandId::MozBoxFlex => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_xul()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_xul()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_box_flex();

                        let computed = computed.to_animated_value();

                            AnimationValue::MozBoxFlex(computed)
                    },
                    LonghandId::StrokeMiterlimit => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_stroke_miterlimit();

                        let computed = computed.to_animated_value();

                            AnimationValue::StrokeMiterlimit(computed)
                    },
                    LonghandId::FloodOpacity => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_svg()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_flood_opacity();


                            AnimationValue::FloodOpacity(computed)
                    },
                    LonghandId::MozWindowOpacity => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_ui()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_ui()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_window_opacity();


                            AnimationValue::MozWindowOpacity(computed)
                    },
                    LonghandId::Opacity => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_effects()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_effects()
                            },
                        };
                        let computed = style_struct
                            .clone_opacity();


                            AnimationValue::Opacity(computed)
                    },
                    LonghandId::ShapeImageThreshold => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_shape_image_threshold();


                            AnimationValue::ShapeImageThreshold(computed)
                    },
                    LonghandId::StopOpacity => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_svg()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_stop_opacity();


                            AnimationValue::StopOpacity(computed)
                    },
                    LonghandId::BorderBottomStyle => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_bottom_style();


                            AnimationValue::BorderBottomStyle(computed)
                    },
                    LonghandId::BorderLeftStyle => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_left_style();


                            AnimationValue::BorderLeftStyle(computed)
                    },
                    LonghandId::BorderRightStyle => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_right_style();


                            AnimationValue::BorderRightStyle(computed)
                    },
                    LonghandId::BorderTopStyle => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_top_style();


                            AnimationValue::BorderTopStyle(computed)
                    },
                    LonghandId::ColumnRuleStyle => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_column()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_column()
                            },
                        };
                        let computed = style_struct
                            .clone_column_rule_style();


                            AnimationValue::ColumnRuleStyle(computed)
                    },
                    LonghandId::BackgroundAttachment => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_background()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_background()
                            },
                        };
                        let computed = style_struct
                            .clone_background_attachment();


                            AnimationValue::BackgroundAttachment(computed)
                    },
                    LonghandId::BackgroundBlendMode => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_background()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_background()
                            },
                        };
                        let computed = style_struct
                            .clone_background_blend_mode();


                            AnimationValue::BackgroundBlendMode(computed)
                    },
                    LonghandId::BackgroundClip => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_background()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_background()
                            },
                        };
                        let computed = style_struct
                            .clone_background_clip();


                            AnimationValue::BackgroundClip(computed)
                    },
                    LonghandId::BackgroundImage => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_background()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_background()
                            },
                        };
                        let computed = style_struct
                            .clone_background_image();


                            AnimationValue::BackgroundImage(computed)
                    },
                    LonghandId::BackgroundOrigin => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_background()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_background()
                            },
                        };
                        let computed = style_struct
                            .clone_background_origin();


                            AnimationValue::BackgroundOrigin(computed)
                    },
                    LonghandId::BackgroundPositionX => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_background()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_background()
                            },
                        };
                        let computed = style_struct
                            .clone_background_position_x();


                            AnimationValue::BackgroundPositionX(computed)
                    },
                    LonghandId::BackgroundPositionY => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_background()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_background()
                            },
                        };
                        let computed = style_struct
                            .clone_background_position_y();


                            AnimationValue::BackgroundPositionY(computed)
                    },
                    LonghandId::BackgroundRepeat => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_background()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_background()
                            },
                        };
                        let computed = style_struct
                            .clone_background_repeat();


                            AnimationValue::BackgroundRepeat(computed)
                    },
                    LonghandId::BackgroundSize => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_background()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_background()
                            },
                        };
                        let computed = style_struct
                            .clone_background_size();

                        let computed = computed.to_animated_value();

                            AnimationValue::BackgroundSize(computed)
                    },
                    LonghandId::BorderImageOutset => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_image_outset();


                            AnimationValue::BorderImageOutset(computed)
                    },
                    LonghandId::BorderImageSlice => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_image_slice();


                            AnimationValue::BorderImageSlice(computed)
                    },
                    LonghandId::BorderImageSource => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_image_source();


                            AnimationValue::BorderImageSource(computed)
                    },
                    LonghandId::BorderImageWidth => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_image_width();


                            AnimationValue::BorderImageWidth(computed)
                    },
                    LonghandId::BorderSpacing => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_table()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_table()
                            },
                        };
                        let computed = style_struct
                            .clone_border_spacing();

                        let computed = computed.to_animated_value();

                            AnimationValue::BorderSpacing(computed)
                    },
                    LonghandId::BoxShadow => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_effects()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_effects()
                            },
                        };
                        let computed = style_struct
                            .clone_box_shadow();

                        let computed = computed.to_animated_value();

                            AnimationValue::BoxShadow(computed)
                    },
                    LonghandId::CaretColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_ui()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_ui()
                            },
                        };
                        let computed = style_struct
                            .clone_caret_color();

                        let computed = computed.to_animated_value();

                            AnimationValue::CaretColor(computed)
                    },
                    LonghandId::ClipPath => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_svg()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_clip_path();

                        let computed = computed.to_animated_value();

                            AnimationValue::ClipPath(computed)
                    },
                    LonghandId::Color => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_color()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_color()
                            },
                        };
                        let computed = style_struct
                            .clone_color();

                        let computed = computed.to_animated_value();

                            AnimationValue::Color(computed)
                    },
                    LonghandId::ColumnWidth => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_column()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_column()
                            },
                        };
                        let computed = style_struct
                            .clone_column_width();

                        let computed = computed.to_animated_value();

                            AnimationValue::ColumnWidth(computed)
                    },
                    LonghandId::Content => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_counters()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_counters()
                            },
                        };
                        let computed = style_struct
                            .clone_content();


                            AnimationValue::Content(computed)
                    },
                    LonghandId::CounterIncrement => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_counters()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_counters()
                            },
                        };
                        let computed = style_struct
                            .clone_counter_increment();


                            AnimationValue::CounterIncrement(computed)
                    },
                    LonghandId::Cursor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_ui()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_ui()
                            },
                        };
                        let computed = style_struct
                            .clone_cursor();


                            AnimationValue::Cursor(computed)
                    },
                    LonghandId::Filter => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_effects()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_effects()
                            },
                        };
                        let computed = style_struct
                            .clone_filter();

                        let computed = computed.to_animated_value();

                            AnimationValue::Filter(computed)
                    },
                    LonghandId::FlexBasis => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_flex_basis();

                        let computed = computed.to_animated_value();

                            AnimationValue::FlexBasis(computed)
                    },
                    LonghandId::FontFamily => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone_font_family();


                            AnimationValue::FontFamily(computed)
                    },
                    LonghandId::FontFeatureSettings => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone_font_feature_settings();


                            AnimationValue::FontFeatureSettings(computed)
                    },
                    LonghandId::FontLanguageOverride => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone_font_language_override();


                            AnimationValue::FontLanguageOverride(computed)
                    },
                    LonghandId::FontSize => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone_font_size();

                        let computed = computed.to_animated_value();

                            AnimationValue::FontSize(computed)
                    },
                    LonghandId::FontVariantAlternates => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone_font_variant_alternates();


                            AnimationValue::FontVariantAlternates(computed)
                    },
                    LonghandId::FontVariationSettings => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_font()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_font()
                            },
                        };
                        let computed = style_struct
                            .clone_font_variation_settings();


                            AnimationValue::FontVariationSettings(computed)
                    },
                    LonghandId::GridTemplateAreas => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_grid_template_areas();


                            AnimationValue::GridTemplateAreas(computed)
                    },
                    LonghandId::LetterSpacing => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_letter_spacing();


                            AnimationValue::LetterSpacing(computed)
                    },
                    LonghandId::LineHeight => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_line_height();

                        let computed = computed.to_animated_value();

                            AnimationValue::LineHeight(computed)
                    },
                    LonghandId::ListStyleImage => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_list()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_list()
                            },
                        };
                        let computed = style_struct
                            .clone_list_style_image();


                            AnimationValue::ListStyleImage(computed)
                    },
                    LonghandId::ListStyleType => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_list()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_list()
                            },
                        };
                        let computed = style_struct
                            .clone_list_style_type();


                            AnimationValue::ListStyleType(computed)
                    },
                    LonghandId::MaskClip => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_svg()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_mask_clip();


                            AnimationValue::MaskClip(computed)
                    },
                    LonghandId::MaskComposite => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_svg()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_mask_composite();


                            AnimationValue::MaskComposite(computed)
                    },
                    LonghandId::MaskImage => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_svg()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_mask_image();


                            AnimationValue::MaskImage(computed)
                    },
                    LonghandId::MaskMode => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_svg()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_mask_mode();


                            AnimationValue::MaskMode(computed)
                    },
                    LonghandId::MaskOrigin => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_svg()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_mask_origin();


                            AnimationValue::MaskOrigin(computed)
                    },
                    LonghandId::MaskPositionX => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_svg()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_mask_position_x();


                            AnimationValue::MaskPositionX(computed)
                    },
                    LonghandId::MaskPositionY => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_svg()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_mask_position_y();


                            AnimationValue::MaskPositionY(computed)
                    },
                    LonghandId::MaskRepeat => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_svg()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_mask_repeat();


                            AnimationValue::MaskRepeat(computed)
                    },
                    LonghandId::MaskSize => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_svg()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_mask_size();

                        let computed = computed.to_animated_value();

                            AnimationValue::MaskSize(computed)
                    },
                    LonghandId::MozTabSize => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_tab_size();

                        let computed = computed.to_animated_value();

                            AnimationValue::MozTabSize(computed)
                    },
                    LonghandId::OffsetPath => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_offset_path();


                            AnimationValue::OffsetPath(computed)
                    },
                    LonghandId::Perspective => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_perspective();

                        let computed = computed.to_animated_value();

                            AnimationValue::Perspective(computed)
                    },
                    LonghandId::Quotes => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_list()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_list()
                            },
                        };
                        let computed = style_struct
                            .clone_quotes();


                            AnimationValue::Quotes(computed)
                    },
                    LonghandId::Rotate => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_rotate();


                            AnimationValue::Rotate(computed)
                    },
                    LonghandId::Scale => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_scale();


                            AnimationValue::Scale(computed)
                    },
                    LonghandId::ScrollSnapCoordinate => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_snap_coordinate();


                            AnimationValue::ScrollSnapCoordinate(computed)
                    },
                    LonghandId::ScrollbarColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_ui()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_ui()
                            },
                        };
                        let computed = style_struct
                            .clone_scrollbar_color();

                        let computed = computed.to_animated_value();

                            AnimationValue::ScrollbarColor(computed)
                    },
                    LonghandId::ShapeOutside => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_shape_outside();

                        let computed = computed.to_animated_value();

                            AnimationValue::ShapeOutside(computed)
                    },
                    LonghandId::StrokeDasharray => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_stroke_dasharray();

                        let computed = computed.to_animated_value();

                            AnimationValue::StrokeDasharray(computed)
                    },
                    LonghandId::StrokeDashoffset => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_stroke_dashoffset();


                            AnimationValue::StrokeDashoffset(computed)
                    },
                    LonghandId::StrokeWidth => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_stroke_width();

                        let computed = computed.to_animated_value();

                            AnimationValue::StrokeWidth(computed)
                    },
                    LonghandId::TextEmphasisStyle => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_text_emphasis_style();


                            AnimationValue::TextEmphasisStyle(computed)
                    },
                    LonghandId::TextIndent => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_text_indent();


                            AnimationValue::TextIndent(computed)
                    },
                    LonghandId::TextOverflow => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_text()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_text()
                            },
                        };
                        let computed = style_struct
                            .clone_text_overflow();


                            AnimationValue::TextOverflow(computed)
                    },
                    LonghandId::TextShadow => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_text_shadow();

                        let computed = computed.to_animated_value();

                            AnimationValue::TextShadow(computed)
                    },
                    LonghandId::Translate => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_translate();


                            AnimationValue::Translate(computed)
                    },
                    LonghandId::VerticalAlign => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_vertical_align();


                            AnimationValue::VerticalAlign(computed)
                    },
                    LonghandId::WordSpacing => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_word_spacing();


                            AnimationValue::WordSpacing(computed)
                    },
                    LonghandId::Clip => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_effects()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_effects()
                            },
                        };
                        let computed = style_struct
                            .clone_clip();


                            AnimationValue::Clip(computed)
                    },
                    LonghandId::MozImageRegion => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_list()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_list()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_image_region();


                            AnimationValue::MozImageRegion(computed)
                    },
                    LonghandId::GridTemplateColumns => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_grid_template_columns();


                            AnimationValue::GridTemplateColumns(computed)
                    },
                    LonghandId::GridTemplateRows => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_grid_template_rows();


                            AnimationValue::GridTemplateRows(computed)
                    },
                    LonghandId::Fill => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_fill();

                        let computed = computed.to_animated_value();

                            AnimationValue::Fill(computed)
                    },
                    LonghandId::Stroke => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_stroke();

                        let computed = computed.to_animated_value();

                            AnimationValue::Stroke(computed)
                    },
                    LonghandId::GridAutoColumns => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_grid_auto_columns();


                            AnimationValue::GridAutoColumns(computed)
                    },
                    LonghandId::GridAutoRows => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_grid_auto_rows();


                            AnimationValue::GridAutoRows(computed)
                    },
                    LonghandId::MozWindowTransformOrigin => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_ui()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_ui()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_window_transform_origin();


                            AnimationValue::MozWindowTransformOrigin(computed)
                    },
                    LonghandId::TransformOrigin => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_transform_origin();


                            AnimationValue::TransformOrigin(computed)
                    },
                    LonghandId::CounterReset => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_counters()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_counters()
                            },
                        };
                        let computed = style_struct
                            .clone_counter_reset();


                            AnimationValue::CounterReset(computed)
                    },
                    LonghandId::CounterSet => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_counters()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_counters()
                            },
                        };
                        let computed = style_struct
                            .clone_counter_set();


                            AnimationValue::CounterSet(computed)
                    },
                    LonghandId::ScrollSnapPointsX => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_snap_points_x();


                            AnimationValue::ScrollSnapPointsX(computed)
                    },
                    LonghandId::ScrollSnapPointsY => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_snap_points_y();


                            AnimationValue::ScrollSnapPointsY(computed)
                    },
                    LonghandId::MozWindowTransform => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_ui()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_ui()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_window_transform();


                            AnimationValue::MozWindowTransform(computed)
                    },
                    LonghandId::Transform => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_transform();


                            AnimationValue::Transform(computed)
                    },
                    LonghandId::ColumnGap => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_column_gap();

                        let computed = computed.to_animated_value();

                            AnimationValue::ColumnGap(computed)
                    },
                    LonghandId::RowGap => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_row_gap();

                        let computed = computed.to_animated_value();

                            AnimationValue::RowGap(computed)
                    },
                    LonghandId::ObjectPosition => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_object_position();


                            AnimationValue::ObjectPosition(computed)
                    },
                    LonghandId::PerspectiveOrigin => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_perspective_origin();


                            AnimationValue::PerspectiveOrigin(computed)
                    },
                    LonghandId::ScrollSnapDestination => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_snap_destination();


                            AnimationValue::ScrollSnapDestination(computed)
                    },
                    LonghandId::GridColumnEnd => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_grid_column_end();


                            AnimationValue::GridColumnEnd(computed)
                    },
                    LonghandId::GridColumnStart => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_grid_column_start();


                            AnimationValue::GridColumnStart(computed)
                    },
                    LonghandId::GridRowEnd => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_grid_row_end();


                            AnimationValue::GridRowEnd(computed)
                    },
                    LonghandId::GridRowStart => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_grid_row_start();


                            AnimationValue::GridRowStart(computed)
                    },
                    LonghandId::MaxBlockSize => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_max_block_size(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        
        if wm.is_vertical() {
            
                            AnimationValue::MaxWidth(computed)
                        
        } else {
            
                            AnimationValue::MaxHeight(computed)
                        
        }

                    },
                    LonghandId::MaxHeight => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_max_height();

                        let computed = computed.to_animated_value();

                            AnimationValue::MaxHeight(computed)
                    },
                    LonghandId::MaxInlineSize => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_max_inline_size(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        
        if wm.is_vertical() {
            
                            AnimationValue::MaxHeight(computed)
                        
        } else {
            
                            AnimationValue::MaxWidth(computed)
                        
        }

                    },
                    LonghandId::MaxWidth => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_max_width();

                        let computed = computed.to_animated_value();

                            AnimationValue::MaxWidth(computed)
                    },
                    LonghandId::MarkerEnd => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_marker_end();


                            AnimationValue::MarkerEnd(computed)
                    },
                    LonghandId::MarkerMid => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_marker_mid();


                            AnimationValue::MarkerMid(computed)
                    },
                    LonghandId::MarkerStart => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_svg()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_marker_start();


                            AnimationValue::MarkerStart(computed)
                    },
                    LonghandId::ScrollPaddingBlockEnd => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_padding()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_padding()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_padding_block_end(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::ScrollPaddingTop(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::ScrollPaddingRight(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::ScrollPaddingBottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::ScrollPaddingLeft(computed)
                        
                }
        }

                    },
                    LonghandId::ScrollPaddingBlockStart => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_padding()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_padding()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_padding_block_start(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::ScrollPaddingTop(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::ScrollPaddingRight(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::ScrollPaddingBottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::ScrollPaddingLeft(computed)
                        
                }
        }

                    },
                    LonghandId::ScrollPaddingBottom => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_padding()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_padding()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_padding_bottom();

                        let computed = computed.to_animated_value();

                            AnimationValue::ScrollPaddingBottom(computed)
                    },
                    LonghandId::ScrollPaddingInlineEnd => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_padding()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_padding()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_padding_inline_end(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::ScrollPaddingTop(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::ScrollPaddingRight(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::ScrollPaddingBottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::ScrollPaddingLeft(computed)
                        
                }
        }

                    },
                    LonghandId::ScrollPaddingInlineStart => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_padding()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_padding()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_padding_inline_start(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::ScrollPaddingTop(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::ScrollPaddingRight(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::ScrollPaddingBottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::ScrollPaddingLeft(computed)
                        
                }
        }

                    },
                    LonghandId::ScrollPaddingLeft => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_padding()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_padding()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_padding_left();

                        let computed = computed.to_animated_value();

                            AnimationValue::ScrollPaddingLeft(computed)
                    },
                    LonghandId::ScrollPaddingRight => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_padding()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_padding()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_padding_right();

                        let computed = computed.to_animated_value();

                            AnimationValue::ScrollPaddingRight(computed)
                    },
                    LonghandId::ScrollPaddingTop => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_padding()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_padding()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_padding_top();

                        let computed = computed.to_animated_value();

                            AnimationValue::ScrollPaddingTop(computed)
                    },
                    LonghandId::BlockSize => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_block_size(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        
        if wm.is_vertical() {
            
                            AnimationValue::Width(computed)
                        
        } else {
            
                            AnimationValue::Height(computed)
                        
        }

                    },
                    LonghandId::Height => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_height();

                        let computed = computed.to_animated_value();

                            AnimationValue::Height(computed)
                    },
                    LonghandId::InlineSize => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_inline_size(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        
        if wm.is_vertical() {
            
                            AnimationValue::Height(computed)
                        
        } else {
            
                            AnimationValue::Width(computed)
                        
        }

                    },
                    LonghandId::MinBlockSize => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_min_block_size(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        
        if wm.is_vertical() {
            
                            AnimationValue::MinWidth(computed)
                        
        } else {
            
                            AnimationValue::MinHeight(computed)
                        
        }

                    },
                    LonghandId::MinHeight => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_min_height();

                        let computed = computed.to_animated_value();

                            AnimationValue::MinHeight(computed)
                    },
                    LonghandId::MinInlineSize => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_min_inline_size(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        
        if wm.is_vertical() {
            
                            AnimationValue::MinHeight(computed)
                        
        } else {
            
                            AnimationValue::MinWidth(computed)
                        
        }

                    },
                    LonghandId::MinWidth => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_min_width();

                        let computed = computed.to_animated_value();

                            AnimationValue::MinWidth(computed)
                    },
                    LonghandId::Width => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_width();

                        let computed = computed.to_animated_value();

                            AnimationValue::Width(computed)
                    },
                    LonghandId::OutlineOffset => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_outline()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_outline()
                            },
                        };
                        let computed = style_struct
                            .clone_outline_offset();


                            AnimationValue::OutlineOffset(computed)
                    },
                    LonghandId::ScrollMarginBlockEnd => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_margin()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_margin()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_margin_block_end(context.builder.writing_mode);


                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::ScrollMarginTop(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::ScrollMarginRight(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::ScrollMarginBottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::ScrollMarginLeft(computed)
                        
                }
        }

                    },
                    LonghandId::ScrollMarginBlockStart => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_margin()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_margin()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_margin_block_start(context.builder.writing_mode);


                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::ScrollMarginTop(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::ScrollMarginRight(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::ScrollMarginBottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::ScrollMarginLeft(computed)
                        
                }
        }

                    },
                    LonghandId::ScrollMarginBottom => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_margin()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_margin()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_margin_bottom();


                            AnimationValue::ScrollMarginBottom(computed)
                    },
                    LonghandId::ScrollMarginInlineEnd => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_margin()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_margin()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_margin_inline_end(context.builder.writing_mode);


                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::ScrollMarginTop(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::ScrollMarginRight(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::ScrollMarginBottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::ScrollMarginLeft(computed)
                        
                }
        }

                    },
                    LonghandId::ScrollMarginInlineStart => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_margin()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_margin()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_margin_inline_start(context.builder.writing_mode);


                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::ScrollMarginTop(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::ScrollMarginRight(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::ScrollMarginBottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::ScrollMarginLeft(computed)
                        
                }
        }

                    },
                    LonghandId::ScrollMarginLeft => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_margin()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_margin()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_margin_left();


                            AnimationValue::ScrollMarginLeft(computed)
                    },
                    LonghandId::ScrollMarginRight => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_margin()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_margin()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_margin_right();


                            AnimationValue::ScrollMarginRight(computed)
                    },
                    LonghandId::ScrollMarginTop => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_margin()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_margin()
                            },
                        };
                        let computed = style_struct
                            .clone_scroll_margin_top();


                            AnimationValue::ScrollMarginTop(computed)
                    },
                    LonghandId::PaddingBlockEnd => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_padding()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_padding()
                            },
                        };
                        let computed = style_struct
                            .clone_padding_block_end(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::PaddingTop(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::PaddingRight(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::PaddingBottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::PaddingLeft(computed)
                        
                }
        }

                    },
                    LonghandId::PaddingBlockStart => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_padding()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_padding()
                            },
                        };
                        let computed = style_struct
                            .clone_padding_block_start(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::PaddingTop(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::PaddingRight(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::PaddingBottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::PaddingLeft(computed)
                        
                }
        }

                    },
                    LonghandId::PaddingBottom => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_padding()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_padding()
                            },
                        };
                        let computed = style_struct
                            .clone_padding_bottom();

                        let computed = computed.to_animated_value();

                            AnimationValue::PaddingBottom(computed)
                    },
                    LonghandId::PaddingInlineEnd => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_padding()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_padding()
                            },
                        };
                        let computed = style_struct
                            .clone_padding_inline_end(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::PaddingTop(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::PaddingRight(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::PaddingBottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::PaddingLeft(computed)
                        
                }
        }

                    },
                    LonghandId::PaddingInlineStart => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_padding()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_padding()
                            },
                        };
                        let computed = style_struct
                            .clone_padding_inline_start(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::PaddingTop(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::PaddingRight(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::PaddingBottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::PaddingLeft(computed)
                        
                }
        }

                    },
                    LonghandId::PaddingLeft => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_padding()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_padding()
                            },
                        };
                        let computed = style_struct
                            .clone_padding_left();

                        let computed = computed.to_animated_value();

                            AnimationValue::PaddingLeft(computed)
                    },
                    LonghandId::PaddingRight => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_padding()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_padding()
                            },
                        };
                        let computed = style_struct
                            .clone_padding_right();

                        let computed = computed.to_animated_value();

                            AnimationValue::PaddingRight(computed)
                    },
                    LonghandId::PaddingTop => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_padding()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_padding()
                            },
                        };
                        let computed = style_struct
                            .clone_padding_top();

                        let computed = computed.to_animated_value();

                            AnimationValue::PaddingTop(computed)
                    },
                    LonghandId::ShapeMargin => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_box()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_box()
                            },
                        };
                        let computed = style_struct
                            .clone_shape_margin();

                        let computed = computed.to_animated_value();

                            AnimationValue::ShapeMargin(computed)
                    },
                    LonghandId::BorderBlockEndWidth => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_block_end_width(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::BorderTopWidth(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::BorderRightWidth(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::BorderBottomWidth(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::BorderLeftWidth(computed)
                        
                }
        }

                    },
                    LonghandId::BorderBlockStartWidth => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_block_start_width(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::BorderTopWidth(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::BorderRightWidth(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::BorderBottomWidth(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::BorderLeftWidth(computed)
                        
                }
        }

                    },
                    LonghandId::BorderBottomWidth => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_bottom_width();

                        let computed = computed.to_animated_value();

                            AnimationValue::BorderBottomWidth(computed)
                    },
                    LonghandId::BorderInlineEndWidth => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_inline_end_width(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::BorderTopWidth(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::BorderRightWidth(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::BorderBottomWidth(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::BorderLeftWidth(computed)
                        
                }
        }

                    },
                    LonghandId::BorderInlineStartWidth => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_inline_start_width(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::BorderTopWidth(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::BorderRightWidth(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::BorderBottomWidth(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::BorderLeftWidth(computed)
                        
                }
        }

                    },
                    LonghandId::BorderLeftWidth => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_left_width();

                        let computed = computed.to_animated_value();

                            AnimationValue::BorderLeftWidth(computed)
                    },
                    LonghandId::BorderRightWidth => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_right_width();

                        let computed = computed.to_animated_value();

                            AnimationValue::BorderRightWidth(computed)
                    },
                    LonghandId::BorderTopWidth => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_top_width();

                        let computed = computed.to_animated_value();

                            AnimationValue::BorderTopWidth(computed)
                    },
                    LonghandId::ColumnRuleWidth => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_column()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_column()
                            },
                        };
                        let computed = style_struct
                            .clone_column_rule_width();

                        let computed = computed.to_animated_value();

                            AnimationValue::ColumnRuleWidth(computed)
                    },
                    LonghandId::OutlineWidth => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_outline()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_outline()
                            },
                        };
                        let computed = style_struct
                            .clone_outline_width();

                        let computed = computed.to_animated_value();

                            AnimationValue::OutlineWidth(computed)
                    },
                    LonghandId::WebkitTextStrokeWidth => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone__webkit_text_stroke_width();


                            AnimationValue::WebkitTextStrokeWidth(computed)
                    },
                    LonghandId::BorderBottomLeftRadius => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_bottom_left_radius();

                        let computed = computed.to_animated_value();

                            AnimationValue::BorderBottomLeftRadius(computed)
                    },
                    LonghandId::BorderBottomRightRadius => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_bottom_right_radius();

                        let computed = computed.to_animated_value();

                            AnimationValue::BorderBottomRightRadius(computed)
                    },
                    LonghandId::BorderEndEndRadius => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_end_end_radius(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                            AnimationValue::BorderTopLeftRadius(computed)
                        
                }
                PhysicalCorner::TopRight => {
                    
                            AnimationValue::BorderTopRightRadius(computed)
                        
                }
                PhysicalCorner::BottomRight => {
                    
                            AnimationValue::BorderBottomRightRadius(computed)
                        
                }
                PhysicalCorner::BottomLeft => {
                    
                            AnimationValue::BorderBottomLeftRadius(computed)
                        
                }
        }

                    },
                    LonghandId::BorderEndStartRadius => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_end_start_radius(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                            AnimationValue::BorderTopLeftRadius(computed)
                        
                }
                PhysicalCorner::TopRight => {
                    
                            AnimationValue::BorderTopRightRadius(computed)
                        
                }
                PhysicalCorner::BottomRight => {
                    
                            AnimationValue::BorderBottomRightRadius(computed)
                        
                }
                PhysicalCorner::BottomLeft => {
                    
                            AnimationValue::BorderBottomLeftRadius(computed)
                        
                }
        }

                    },
                    LonghandId::BorderStartEndRadius => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_start_end_radius(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                            AnimationValue::BorderTopLeftRadius(computed)
                        
                }
                PhysicalCorner::TopRight => {
                    
                            AnimationValue::BorderTopRightRadius(computed)
                        
                }
                PhysicalCorner::BottomRight => {
                    
                            AnimationValue::BorderBottomRightRadius(computed)
                        
                }
                PhysicalCorner::BottomLeft => {
                    
                            AnimationValue::BorderBottomLeftRadius(computed)
                        
                }
        }

                    },
                    LonghandId::BorderStartStartRadius => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_start_start_radius(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                            AnimationValue::BorderTopLeftRadius(computed)
                        
                }
                PhysicalCorner::TopRight => {
                    
                            AnimationValue::BorderTopRightRadius(computed)
                        
                }
                PhysicalCorner::BottomRight => {
                    
                            AnimationValue::BorderBottomRightRadius(computed)
                        
                }
                PhysicalCorner::BottomLeft => {
                    
                            AnimationValue::BorderBottomLeftRadius(computed)
                        
                }
        }

                    },
                    LonghandId::BorderTopLeftRadius => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_top_left_radius();

                        let computed = computed.to_animated_value();

                            AnimationValue::BorderTopLeftRadius(computed)
                    },
                    LonghandId::BorderTopRightRadius => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_top_right_radius();

                        let computed = computed.to_animated_value();

                            AnimationValue::BorderTopRightRadius(computed)
                    },
                    LonghandId::MozOutlineRadiusBottomleft => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_outline()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_outline()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_outline_radius_bottomleft();

                        let computed = computed.to_animated_value();

                            AnimationValue::MozOutlineRadiusBottomleft(computed)
                    },
                    LonghandId::MozOutlineRadiusBottomright => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_outline()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_outline()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_outline_radius_bottomright();

                        let computed = computed.to_animated_value();

                            AnimationValue::MozOutlineRadiusBottomright(computed)
                    },
                    LonghandId::MozOutlineRadiusTopleft => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_outline()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_outline()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_outline_radius_topleft();

                        let computed = computed.to_animated_value();

                            AnimationValue::MozOutlineRadiusTopleft(computed)
                    },
                    LonghandId::MozOutlineRadiusTopright => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_outline()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_outline()
                            },
                        };
                        let computed = style_struct
                            .clone__moz_outline_radius_topright();

                        let computed = computed.to_animated_value();

                            AnimationValue::MozOutlineRadiusTopright(computed)
                    },
                    LonghandId::Bottom => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_bottom();


                            AnimationValue::Bottom(computed)
                    },
                    LonghandId::InsetBlockEnd => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_inset_block_end(context.builder.writing_mode);


                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::Top(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::Right(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::Bottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::Left(computed)
                        
                }
        }

                    },
                    LonghandId::InsetBlockStart => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_inset_block_start(context.builder.writing_mode);


                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::Top(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::Right(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::Bottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::Left(computed)
                        
                }
        }

                    },
                    LonghandId::InsetInlineEnd => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_inset_inline_end(context.builder.writing_mode);


                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::Top(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::Right(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::Bottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::Left(computed)
                        
                }
        }

                    },
                    LonghandId::InsetInlineStart => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_inset_inline_start(context.builder.writing_mode);


                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::Top(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::Right(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::Bottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::Left(computed)
                        
                }
        }

                    },
                    LonghandId::Left => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_left();


                            AnimationValue::Left(computed)
                    },
                    LonghandId::MarginBlockEnd => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_margin()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_margin()
                            },
                        };
                        let computed = style_struct
                            .clone_margin_block_end(context.builder.writing_mode);


                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::MarginTop(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::MarginRight(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::MarginBottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::MarginLeft(computed)
                        
                }
        }

                    },
                    LonghandId::MarginBlockStart => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_margin()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_margin()
                            },
                        };
                        let computed = style_struct
                            .clone_margin_block_start(context.builder.writing_mode);


                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::MarginTop(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::MarginRight(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::MarginBottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::MarginLeft(computed)
                        
                }
        }

                    },
                    LonghandId::MarginBottom => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_margin()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_margin()
                            },
                        };
                        let computed = style_struct
                            .clone_margin_bottom();


                            AnimationValue::MarginBottom(computed)
                    },
                    LonghandId::MarginInlineEnd => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_margin()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_margin()
                            },
                        };
                        let computed = style_struct
                            .clone_margin_inline_end(context.builder.writing_mode);


                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::MarginTop(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::MarginRight(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::MarginBottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::MarginLeft(computed)
                        
                }
        }

                    },
                    LonghandId::MarginInlineStart => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_margin()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_margin()
                            },
                        };
                        let computed = style_struct
                            .clone_margin_inline_start(context.builder.writing_mode);


                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::MarginTop(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::MarginRight(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::MarginBottom(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::MarginLeft(computed)
                        
                }
        }

                    },
                    LonghandId::MarginLeft => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_margin()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_margin()
                            },
                        };
                        let computed = style_struct
                            .clone_margin_left();


                            AnimationValue::MarginLeft(computed)
                    },
                    LonghandId::MarginRight => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_margin()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_margin()
                            },
                        };
                        let computed = style_struct
                            .clone_margin_right();


                            AnimationValue::MarginRight(computed)
                    },
                    LonghandId::MarginTop => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_margin()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_margin()
                            },
                        };
                        let computed = style_struct
                            .clone_margin_top();


                            AnimationValue::MarginTop(computed)
                    },
                    LonghandId::Right => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_right();


                            AnimationValue::Right(computed)
                    },
                    LonghandId::Top => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_position()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_position()
                            },
                        };
                        let computed = style_struct
                            .clone_top();


                            AnimationValue::Top(computed)
                    },
                    LonghandId::BackgroundColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_background()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_background()
                            },
                        };
                        let computed = style_struct
                            .clone_background_color();

                        let computed = computed.to_animated_value();

                            AnimationValue::BackgroundColor(computed)
                    },
                    LonghandId::BorderBlockEndColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_block_end_color(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::BorderTopColor(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::BorderRightColor(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::BorderBottomColor(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::BorderLeftColor(computed)
                        
                }
        }

                    },
                    LonghandId::BorderBlockStartColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_block_start_color(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::BorderTopColor(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::BorderRightColor(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::BorderBottomColor(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::BorderLeftColor(computed)
                        
                }
        }

                    },
                    LonghandId::BorderBottomColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_bottom_color();

                        let computed = computed.to_animated_value();

                            AnimationValue::BorderBottomColor(computed)
                    },
                    LonghandId::BorderInlineEndColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_inline_end_color(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::BorderTopColor(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::BorderRightColor(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::BorderBottomColor(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::BorderLeftColor(computed)
                        
                }
        }

                    },
                    LonghandId::BorderInlineStartColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_inline_start_color(context.builder.writing_mode);

                        let computed = computed.to_animated_value();

                        let wm = context.builder.writing_mode;
                        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                            AnimationValue::BorderTopColor(computed)
                        
                }
                PhysicalSide::Right => {
                    
                            AnimationValue::BorderRightColor(computed)
                        
                }
                PhysicalSide::Bottom => {
                    
                            AnimationValue::BorderBottomColor(computed)
                        
                }
                PhysicalSide::Left => {
                    
                            AnimationValue::BorderLeftColor(computed)
                        
                }
        }

                    },
                    LonghandId::BorderLeftColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_left_color();

                        let computed = computed.to_animated_value();

                            AnimationValue::BorderLeftColor(computed)
                    },
                    LonghandId::BorderRightColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_right_color();

                        let computed = computed.to_animated_value();

                            AnimationValue::BorderRightColor(computed)
                    },
                    LonghandId::BorderTopColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_border()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_border()
                            },
                        };
                        let computed = style_struct
                            .clone_border_top_color();

                        let computed = computed.to_animated_value();

                            AnimationValue::BorderTopColor(computed)
                    },
                    LonghandId::ColumnRuleColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_column()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_column()
                            },
                        };
                        let computed = style_struct
                            .clone_column_rule_color();

                        let computed = computed.to_animated_value();

                            AnimationValue::ColumnRuleColor(computed)
                    },
                    LonghandId::FloodColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_svg()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_flood_color();

                        let computed = computed.to_animated_value();

                            AnimationValue::FloodColor(computed)
                    },
                    LonghandId::LightingColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_svg()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_lighting_color();

                        let computed = computed.to_animated_value();

                            AnimationValue::LightingColor(computed)
                    },
                    LonghandId::OutlineColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_outline()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_outline()
                            },
                        };
                        let computed = style_struct
                            .clone_outline_color();

                        let computed = computed.to_animated_value();

                            AnimationValue::OutlineColor(computed)
                    },
                    LonghandId::StopColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_svg()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_svg()
                            },
                        };
                        let computed = style_struct
                            .clone_stop_color();

                        let computed = computed.to_animated_value();

                            AnimationValue::StopColor(computed)
                    },
                    LonghandId::TextDecorationColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Initial => {
                                initial.get_text()
                            },
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_text()
                            },
                        };
                        let computed = style_struct
                            .clone_text_decoration_color();

                        let computed = computed.to_animated_value();

                            AnimationValue::TextDecorationColor(computed)
                    },
                    LonghandId::TextEmphasisColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone_text_emphasis_color();

                        let computed = computed.to_animated_value();

                            AnimationValue::TextEmphasisColor(computed)
                    },
                    LonghandId::WebkitTextFillColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone__webkit_text_fill_color();

                        let computed = computed.to_animated_value();

                            AnimationValue::WebkitTextFillColor(computed)
                    },
                    LonghandId::WebkitTextStrokeColor => {
                        // FIXME(emilio, bug 1533327): I think
                        // CSSWideKeyword::Revert handling is not fine here, but
                        // what to do instead?
                        //
                        // Seems we'd need the computed value as if it was
                        // revert, somehow. Treating it as `unset` seems fine
                        // for now...
                        let style_struct = match declaration.keyword {
                            CSSWideKeyword::Initial => {
                                initial.get_inherited_text()
                            },
                            CSSWideKeyword::Revert |
                            CSSWideKeyword::Unset |
                            CSSWideKeyword::Inherit => {
                                context.builder
                                       .get_parent_inherited_text()
                            },
                        };
                        let computed = style_struct
                            .clone__webkit_text_stroke_color();

                        let computed = computed.to_animated_value();

                            AnimationValue::WebkitTextStrokeColor(computed)
                    },
                    LonghandId::Contain => return None,
                    LonghandId::Direction => return None,
                    LonghandId::MozControlCharacterVisibility => return None,
                    LonghandId::MozMathDisplay => return None,
                    LonghandId::MozMathVariant => return None,
                    LonghandId::MozMinFontSizeRatio => return None,
                    LonghandId::MozScriptLevel => return None,
                    LonghandId::MozScriptMinSize => return None,
                    LonghandId::MozScriptSizeMultiplier => return None,
                    LonghandId::MozTopLayer => return None,
                    LonghandId::TextOrientation => return None,
                    LonghandId::UnicodeBidi => return None,
                    LonghandId::WritingMode => return None,
                    LonghandId::XSpan => return None,
                    LonghandId::XTextZoom => return None,
                    LonghandId::BorderBlockEndStyle => return None,
                    LonghandId::BorderBlockStartStyle => return None,
                    LonghandId::BorderInlineEndStyle => return None,
                    LonghandId::BorderInlineStartStyle => return None,
                    LonghandId::AnimationDelay => return None,
                    LonghandId::AnimationDirection => return None,
                    LonghandId::AnimationDuration => return None,
                    LonghandId::AnimationFillMode => return None,
                    LonghandId::AnimationIterationCount => return None,
                    LonghandId::AnimationName => return None,
                    LonghandId::AnimationPlayState => return None,
                    LonghandId::AnimationTimingFunction => return None,
                    LonghandId::MozContextProperties => return None,
                    LonghandId::MozFontSmoothingBackgroundColor => return None,
                    LonghandId::TransitionDelay => return None,
                    LonghandId::TransitionDuration => return None,
                    LonghandId::TransitionProperty => return None,
                    LonghandId::TransitionTimingFunction => return None,
                    LonghandId::WillChange => return None,
                    LonghandId::XLang => return None,
                    LonghandId::MozBinding => return None,
                }
            },
            PropertyDeclaration::WithVariables(ref declaration) => {
                let substituted = {
                    let custom_properties =
                        extra_custom_properties.or_else(|| context.style().custom_properties());

                    declaration.value.substitute_variables(
                        declaration.id,
                        custom_properties,
                        context.quirks_mode,
                        context.device().environment(),
                    )
                };
                return AnimationValue::from_declaration(
                    &substituted,
                    context,
                    extra_custom_properties,
                    initial,
                )
            },
            _ => return None // non animatable properties will get included because of shorthands. ignore.
        };
        Some(animatable)
    }

    /// Get an AnimationValue for an AnimatableLonghand from a given computed values.
    pub fn from_computed_values(
        property: LonghandId,
        style: &ComputedValues,
    ) -> Option<Self> {
        let property = property.to_physical(style.writing_mode);
        Some(match property {
            LonghandId::AlignContent => {
                let computed = style.clone_align_content();
                AnimationValue::AlignContent(
                    computed
                )
            }
            LonghandId::AlignItems => {
                let computed = style.clone_align_items();
                AnimationValue::AlignItems(
                    computed
                )
            }
            LonghandId::AlignSelf => {
                let computed = style.clone_align_self();
                AnimationValue::AlignSelf(
                    computed
                )
            }
            LonghandId::BackfaceVisibility => {
                let computed = style.clone_backface_visibility();
                AnimationValue::BackfaceVisibility(
                    computed
                )
            }
            LonghandId::BorderCollapse => {
                let computed = style.clone_border_collapse();
                AnimationValue::BorderCollapse(
                    computed
                )
            }
            LonghandId::BorderImageRepeat => {
                let computed = style.clone_border_image_repeat();
                AnimationValue::BorderImageRepeat(
                    computed
                )
            }
            LonghandId::BoxDecorationBreak => {
                let computed = style.clone_box_decoration_break();
                AnimationValue::BoxDecorationBreak(
                    computed
                )
            }
            LonghandId::BoxSizing => {
                let computed = style.clone_box_sizing();
                AnimationValue::BoxSizing(
                    computed
                )
            }
            LonghandId::BreakInside => {
                let computed = style.clone_break_inside();
                AnimationValue::BreakInside(
                    computed
                )
            }
            LonghandId::CaptionSide => {
                let computed = style.clone_caption_side();
                AnimationValue::CaptionSide(
                    computed
                )
            }
            LonghandId::Clear => {
                let computed = style.clone_clear();
                AnimationValue::Clear(
                    computed
                )
            }
            LonghandId::ColorAdjust => {
                let computed = style.clone_color_adjust();
                AnimationValue::ColorAdjust(
                    computed
                )
            }
            LonghandId::ColorInterpolation => {
                let computed = style.clone_color_interpolation();
                AnimationValue::ColorInterpolation(
                    computed
                )
            }
            LonghandId::ColorInterpolationFilters => {
                let computed = style.clone_color_interpolation_filters();
                AnimationValue::ColorInterpolationFilters(
                    computed
                )
            }
            LonghandId::ColumnCount => {
                let computed = style.clone_column_count();
                AnimationValue::ColumnCount(
                    computed.to_animated_value()
                )
            }
            LonghandId::ColumnFill => {
                let computed = style.clone_column_fill();
                AnimationValue::ColumnFill(
                    computed
                )
            }
            LonghandId::ColumnSpan => {
                let computed = style.clone_column_span();
                AnimationValue::ColumnSpan(
                    computed
                )
            }
            LonghandId::Display => {
                let computed = style.clone_display();
                AnimationValue::Display(
                    computed
                )
            }
            LonghandId::DominantBaseline => {
                let computed = style.clone_dominant_baseline();
                AnimationValue::DominantBaseline(
                    computed
                )
            }
            LonghandId::EmptyCells => {
                let computed = style.clone_empty_cells();
                AnimationValue::EmptyCells(
                    computed
                )
            }
            LonghandId::FlexDirection => {
                let computed = style.clone_flex_direction();
                AnimationValue::FlexDirection(
                    computed
                )
            }
            LonghandId::FlexWrap => {
                let computed = style.clone_flex_wrap();
                AnimationValue::FlexWrap(
                    computed
                )
            }
            LonghandId::Float => {
                let computed = style.clone_float();
                AnimationValue::Float(
                    computed
                )
            }
            LonghandId::FontKerning => {
                let computed = style.clone_font_kerning();
                AnimationValue::FontKerning(
                    computed
                )
            }
            LonghandId::FontOpticalSizing => {
                let computed = style.clone_font_optical_sizing();
                AnimationValue::FontOpticalSizing(
                    computed
                )
            }
            LonghandId::FontSizeAdjust => {
                let computed = style.clone_font_size_adjust();
                AnimationValue::FontSizeAdjust(
                    computed
                )
            }
            LonghandId::FontStretch => {
                let computed = style.clone_font_stretch();
                AnimationValue::FontStretch(
                    computed.to_animated_value()
                )
            }
            LonghandId::FontStyle => {
                let computed = style.clone_font_style();
                AnimationValue::FontStyle(
                    computed.to_animated_value()
                )
            }
            LonghandId::FontSynthesis => {
                let computed = style.clone_font_synthesis();
                AnimationValue::FontSynthesis(
                    computed
                )
            }
            LonghandId::FontVariantCaps => {
                let computed = style.clone_font_variant_caps();
                AnimationValue::FontVariantCaps(
                    computed
                )
            }
            LonghandId::FontVariantEastAsian => {
                let computed = style.clone_font_variant_east_asian();
                AnimationValue::FontVariantEastAsian(
                    computed
                )
            }
            LonghandId::FontVariantLigatures => {
                let computed = style.clone_font_variant_ligatures();
                AnimationValue::FontVariantLigatures(
                    computed
                )
            }
            LonghandId::FontVariantNumeric => {
                let computed = style.clone_font_variant_numeric();
                AnimationValue::FontVariantNumeric(
                    computed
                )
            }
            LonghandId::FontVariantPosition => {
                let computed = style.clone_font_variant_position();
                AnimationValue::FontVariantPosition(
                    computed
                )
            }
            LonghandId::FontWeight => {
                let computed = style.clone_font_weight();
                AnimationValue::FontWeight(
                    computed.to_animated_value()
                )
            }
            LonghandId::GridAutoFlow => {
                let computed = style.clone_grid_auto_flow();
                AnimationValue::GridAutoFlow(
                    computed
                )
            }
            LonghandId::Hyphens => {
                let computed = style.clone_hyphens();
                AnimationValue::Hyphens(
                    computed
                )
            }
            LonghandId::ImageOrientation => {
                let computed = style.clone_image_orientation();
                AnimationValue::ImageOrientation(
                    computed
                )
            }
            LonghandId::ImageRendering => {
                let computed = style.clone_image_rendering();
                AnimationValue::ImageRendering(
                    computed
                )
            }
            LonghandId::ImeMode => {
                let computed = style.clone_ime_mode();
                AnimationValue::ImeMode(
                    computed
                )
            }
            LonghandId::InitialLetter => {
                let computed = style.clone_initial_letter();
                AnimationValue::InitialLetter(
                    computed
                )
            }
            LonghandId::Isolation => {
                let computed = style.clone_isolation();
                AnimationValue::Isolation(
                    computed
                )
            }
            LonghandId::JustifyContent => {
                let computed = style.clone_justify_content();
                AnimationValue::JustifyContent(
                    computed
                )
            }
            LonghandId::JustifyItems => {
                let computed = style.clone_justify_items();
                AnimationValue::JustifyItems(
                    computed
                )
            }
            LonghandId::JustifySelf => {
                let computed = style.clone_justify_self();
                AnimationValue::JustifySelf(
                    computed
                )
            }
            LonghandId::ListStylePosition => {
                let computed = style.clone_list_style_position();
                AnimationValue::ListStylePosition(
                    computed
                )
            }
            LonghandId::MaskType => {
                let computed = style.clone_mask_type();
                AnimationValue::MaskType(
                    computed
                )
            }
            LonghandId::MixBlendMode => {
                let computed = style.clone_mix_blend_mode();
                AnimationValue::MixBlendMode(
                    computed
                )
            }
            LonghandId::MozAppearance => {
                let computed = style.clone__moz_appearance();
                AnimationValue::MozAppearance(
                    computed
                )
            }
            LonghandId::MozBoxAlign => {
                let computed = style.clone__moz_box_align();
                AnimationValue::MozBoxAlign(
                    computed
                )
            }
            LonghandId::MozBoxDirection => {
                let computed = style.clone__moz_box_direction();
                AnimationValue::MozBoxDirection(
                    computed
                )
            }
            LonghandId::MozBoxOrient => {
                let computed = style.clone__moz_box_orient();
                AnimationValue::MozBoxOrient(
                    computed
                )
            }
            LonghandId::MozBoxPack => {
                let computed = style.clone__moz_box_pack();
                AnimationValue::MozBoxPack(
                    computed
                )
            }
            LonghandId::MozFloatEdge => {
                let computed = style.clone__moz_float_edge();
                AnimationValue::MozFloatEdge(
                    computed
                )
            }
            LonghandId::MozForceBrokenImageIcon => {
                let computed = style.clone__moz_force_broken_image_icon();
                AnimationValue::MozForceBrokenImageIcon(
                    computed
                )
            }
            LonghandId::MozListReversed => {
                let computed = style.clone__moz_list_reversed();
                AnimationValue::MozListReversed(
                    computed
                )
            }
            LonghandId::MozOrient => {
                let computed = style.clone__moz_orient();
                AnimationValue::MozOrient(
                    computed
                )
            }
            LonghandId::MozOsxFontSmoothing => {
                let computed = style.clone__moz_osx_font_smoothing();
                AnimationValue::MozOsxFontSmoothing(
                    computed
                )
            }
            LonghandId::MozStackSizing => {
                let computed = style.clone__moz_stack_sizing();
                AnimationValue::MozStackSizing(
                    computed
                )
            }
            LonghandId::MozTextSizeAdjust => {
                let computed = style.clone__moz_text_size_adjust();
                AnimationValue::MozTextSizeAdjust(
                    computed
                )
            }
            LonghandId::MozUserFocus => {
                let computed = style.clone__moz_user_focus();
                AnimationValue::MozUserFocus(
                    computed
                )
            }
            LonghandId::MozUserInput => {
                let computed = style.clone__moz_user_input();
                AnimationValue::MozUserInput(
                    computed
                )
            }
            LonghandId::MozUserModify => {
                let computed = style.clone__moz_user_modify();
                AnimationValue::MozUserModify(
                    computed
                )
            }
            LonghandId::MozUserSelect => {
                let computed = style.clone__moz_user_select();
                AnimationValue::MozUserSelect(
                    computed
                )
            }
            LonghandId::MozWindowDragging => {
                let computed = style.clone__moz_window_dragging();
                AnimationValue::MozWindowDragging(
                    computed
                )
            }
            LonghandId::MozWindowShadow => {
                let computed = style.clone__moz_window_shadow();
                AnimationValue::MozWindowShadow(
                    computed
                )
            }
            LonghandId::ObjectFit => {
                let computed = style.clone_object_fit();
                AnimationValue::ObjectFit(
                    computed
                )
            }
            LonghandId::OutlineStyle => {
                let computed = style.clone_outline_style();
                AnimationValue::OutlineStyle(
                    computed
                )
            }
            LonghandId::OverflowAnchor => {
                let computed = style.clone_overflow_anchor();
                AnimationValue::OverflowAnchor(
                    computed
                )
            }
            LonghandId::OverflowWrap => {
                let computed = style.clone_overflow_wrap();
                AnimationValue::OverflowWrap(
                    computed
                )
            }
            LonghandId::PaintOrder => {
                let computed = style.clone_paint_order();
                AnimationValue::PaintOrder(
                    computed
                )
            }
            LonghandId::PointerEvents => {
                let computed = style.clone_pointer_events();
                AnimationValue::PointerEvents(
                    computed
                )
            }
            LonghandId::Position => {
                let computed = style.clone_position();
                AnimationValue::Position(
                    computed
                )
            }
            LonghandId::Resize => {
                let computed = style.clone_resize();
                AnimationValue::Resize(
                    computed
                )
            }
            LonghandId::RubyAlign => {
                let computed = style.clone_ruby_align();
                AnimationValue::RubyAlign(
                    computed
                )
            }
            LonghandId::RubyPosition => {
                let computed = style.clone_ruby_position();
                AnimationValue::RubyPosition(
                    computed
                )
            }
            LonghandId::ScrollBehavior => {
                let computed = style.clone_scroll_behavior();
                AnimationValue::ScrollBehavior(
                    computed
                )
            }
            LonghandId::ScrollSnapAlign => {
                let computed = style.clone_scroll_snap_align();
                AnimationValue::ScrollSnapAlign(
                    computed
                )
            }
            LonghandId::ScrollSnapType => {
                let computed = style.clone_scroll_snap_type();
                AnimationValue::ScrollSnapType(
                    computed
                )
            }
            LonghandId::ScrollbarWidth => {
                let computed = style.clone_scrollbar_width();
                AnimationValue::ScrollbarWidth(
                    computed
                )
            }
            LonghandId::ShapeRendering => {
                let computed = style.clone_shape_rendering();
                AnimationValue::ShapeRendering(
                    computed
                )
            }
            LonghandId::StrokeLinecap => {
                let computed = style.clone_stroke_linecap();
                AnimationValue::StrokeLinecap(
                    computed
                )
            }
            LonghandId::StrokeLinejoin => {
                let computed = style.clone_stroke_linejoin();
                AnimationValue::StrokeLinejoin(
                    computed
                )
            }
            LonghandId::TableLayout => {
                let computed = style.clone_table_layout();
                AnimationValue::TableLayout(
                    computed
                )
            }
            LonghandId::TextAlign => {
                let computed = style.clone_text_align();
                AnimationValue::TextAlign(
                    computed
                )
            }
            LonghandId::TextAlignLast => {
                let computed = style.clone_text_align_last();
                AnimationValue::TextAlignLast(
                    computed
                )
            }
            LonghandId::TextAnchor => {
                let computed = style.clone_text_anchor();
                AnimationValue::TextAnchor(
                    computed
                )
            }
            LonghandId::TextCombineUpright => {
                let computed = style.clone_text_combine_upright();
                AnimationValue::TextCombineUpright(
                    computed
                )
            }
            LonghandId::TextDecorationLine => {
                let computed = style.clone_text_decoration_line();
                AnimationValue::TextDecorationLine(
                    computed
                )
            }
            LonghandId::TextDecorationStyle => {
                let computed = style.clone_text_decoration_style();
                AnimationValue::TextDecorationStyle(
                    computed
                )
            }
            LonghandId::TextEmphasisPosition => {
                let computed = style.clone_text_emphasis_position();
                AnimationValue::TextEmphasisPosition(
                    computed
                )
            }
            LonghandId::TextJustify => {
                let computed = style.clone_text_justify();
                AnimationValue::TextJustify(
                    computed
                )
            }
            LonghandId::TextRendering => {
                let computed = style.clone_text_rendering();
                AnimationValue::TextRendering(
                    computed
                )
            }
            LonghandId::TextTransform => {
                let computed = style.clone_text_transform();
                AnimationValue::TextTransform(
                    computed
                )
            }
            LonghandId::TouchAction => {
                let computed = style.clone_touch_action();
                AnimationValue::TouchAction(
                    computed
                )
            }
            LonghandId::TransformBox => {
                let computed = style.clone_transform_box();
                AnimationValue::TransformBox(
                    computed
                )
            }
            LonghandId::TransformStyle => {
                let computed = style.clone_transform_style();
                AnimationValue::TransformStyle(
                    computed
                )
            }
            LonghandId::VectorEffect => {
                let computed = style.clone_vector_effect();
                AnimationValue::VectorEffect(
                    computed
                )
            }
            LonghandId::Visibility => {
                let computed = style.clone_visibility();
                AnimationValue::Visibility(
                    computed
                )
            }
            LonghandId::WebkitLineClamp => {
                let computed = style.clone__webkit_line_clamp();
                AnimationValue::WebkitLineClamp(
                    computed.to_animated_value()
                )
            }
            LonghandId::WhiteSpace => {
                let computed = style.clone_white_space();
                AnimationValue::WhiteSpace(
                    computed
                )
            }
            LonghandId::WordBreak => {
                let computed = style.clone_word_break();
                AnimationValue::WordBreak(
                    computed
                )
            }
            LonghandId::ZIndex => {
                let computed = style.clone_z_index();
                AnimationValue::ZIndex(
                    computed
                )
            }
            LonghandId::BreakAfter => {
                let computed = style.clone_break_after();
                AnimationValue::BreakAfter(
                    computed
                )
            }
            LonghandId::BreakBefore => {
                let computed = style.clone_break_before();
                AnimationValue::BreakBefore(
                    computed
                )
            }
            LonghandId::ClipRule => {
                let computed = style.clone_clip_rule();
                AnimationValue::ClipRule(
                    computed
                )
            }
            LonghandId::FillRule => {
                let computed = style.clone_fill_rule();
                AnimationValue::FillRule(
                    computed
                )
            }
            LonghandId::MozBoxOrdinalGroup => {
                let computed = style.clone__moz_box_ordinal_group();
                AnimationValue::MozBoxOrdinalGroup(
                    computed
                )
            }
            LonghandId::Order => {
                let computed = style.clone_order();
                AnimationValue::Order(
                    computed
                )
            }
            LonghandId::OverflowX => {
                let computed = style.clone_overflow_x();
                AnimationValue::OverflowX(
                    computed
                )
            }
            LonghandId::OverflowY => {
                let computed = style.clone_overflow_y();
                AnimationValue::OverflowY(
                    computed
                )
            }
            LonghandId::OverflowClipBoxBlock => {
                let computed = style.clone_overflow_clip_box_block();
                AnimationValue::OverflowClipBoxBlock(
                    computed
                )
            }
            LonghandId::OverflowClipBoxInline => {
                let computed = style.clone_overflow_clip_box_inline();
                AnimationValue::OverflowClipBoxInline(
                    computed
                )
            }
            LonghandId::OverscrollBehaviorX => {
                let computed = style.clone_overscroll_behavior_x();
                AnimationValue::OverscrollBehaviorX(
                    computed
                )
            }
            LonghandId::OverscrollBehaviorY => {
                let computed = style.clone_overscroll_behavior_y();
                AnimationValue::OverscrollBehaviorY(
                    computed
                )
            }
            LonghandId::FillOpacity => {
                let computed = style.clone_fill_opacity();
                AnimationValue::FillOpacity(
                    computed
                )
            }
            LonghandId::StrokeOpacity => {
                let computed = style.clone_stroke_opacity();
                AnimationValue::StrokeOpacity(
                    computed
                )
            }
            LonghandId::FlexGrow => {
                let computed = style.clone_flex_grow();
                AnimationValue::FlexGrow(
                    computed.to_animated_value()
                )
            }
            LonghandId::FlexShrink => {
                let computed = style.clone_flex_shrink();
                AnimationValue::FlexShrink(
                    computed.to_animated_value()
                )
            }
            LonghandId::MozBoxFlex => {
                let computed = style.clone__moz_box_flex();
                AnimationValue::MozBoxFlex(
                    computed.to_animated_value()
                )
            }
            LonghandId::StrokeMiterlimit => {
                let computed = style.clone_stroke_miterlimit();
                AnimationValue::StrokeMiterlimit(
                    computed.to_animated_value()
                )
            }
            LonghandId::FloodOpacity => {
                let computed = style.clone_flood_opacity();
                AnimationValue::FloodOpacity(
                    computed
                )
            }
            LonghandId::MozWindowOpacity => {
                let computed = style.clone__moz_window_opacity();
                AnimationValue::MozWindowOpacity(
                    computed
                )
            }
            LonghandId::Opacity => {
                let computed = style.clone_opacity();
                AnimationValue::Opacity(
                    computed
                )
            }
            LonghandId::ShapeImageThreshold => {
                let computed = style.clone_shape_image_threshold();
                AnimationValue::ShapeImageThreshold(
                    computed
                )
            }
            LonghandId::StopOpacity => {
                let computed = style.clone_stop_opacity();
                AnimationValue::StopOpacity(
                    computed
                )
            }
            LonghandId::BorderBottomStyle => {
                let computed = style.clone_border_bottom_style();
                AnimationValue::BorderBottomStyle(
                    computed
                )
            }
            LonghandId::BorderLeftStyle => {
                let computed = style.clone_border_left_style();
                AnimationValue::BorderLeftStyle(
                    computed
                )
            }
            LonghandId::BorderRightStyle => {
                let computed = style.clone_border_right_style();
                AnimationValue::BorderRightStyle(
                    computed
                )
            }
            LonghandId::BorderTopStyle => {
                let computed = style.clone_border_top_style();
                AnimationValue::BorderTopStyle(
                    computed
                )
            }
            LonghandId::ColumnRuleStyle => {
                let computed = style.clone_column_rule_style();
                AnimationValue::ColumnRuleStyle(
                    computed
                )
            }
            LonghandId::BackgroundAttachment => {
                let computed = style.clone_background_attachment();
                AnimationValue::BackgroundAttachment(
                    computed
                )
            }
            LonghandId::BackgroundBlendMode => {
                let computed = style.clone_background_blend_mode();
                AnimationValue::BackgroundBlendMode(
                    computed
                )
            }
            LonghandId::BackgroundClip => {
                let computed = style.clone_background_clip();
                AnimationValue::BackgroundClip(
                    computed
                )
            }
            LonghandId::BackgroundImage => {
                let computed = style.clone_background_image();
                AnimationValue::BackgroundImage(
                    computed
                )
            }
            LonghandId::BackgroundOrigin => {
                let computed = style.clone_background_origin();
                AnimationValue::BackgroundOrigin(
                    computed
                )
            }
            LonghandId::BackgroundPositionX => {
                let computed = style.clone_background_position_x();
                AnimationValue::BackgroundPositionX(
                    computed
                )
            }
            LonghandId::BackgroundPositionY => {
                let computed = style.clone_background_position_y();
                AnimationValue::BackgroundPositionY(
                    computed
                )
            }
            LonghandId::BackgroundRepeat => {
                let computed = style.clone_background_repeat();
                AnimationValue::BackgroundRepeat(
                    computed
                )
            }
            LonghandId::BackgroundSize => {
                let computed = style.clone_background_size();
                AnimationValue::BackgroundSize(
                    computed.to_animated_value()
                )
            }
            LonghandId::BorderImageOutset => {
                let computed = style.clone_border_image_outset();
                AnimationValue::BorderImageOutset(
                    computed
                )
            }
            LonghandId::BorderImageSlice => {
                let computed = style.clone_border_image_slice();
                AnimationValue::BorderImageSlice(
                    computed
                )
            }
            LonghandId::BorderImageSource => {
                let computed = style.clone_border_image_source();
                AnimationValue::BorderImageSource(
                    computed
                )
            }
            LonghandId::BorderImageWidth => {
                let computed = style.clone_border_image_width();
                AnimationValue::BorderImageWidth(
                    computed
                )
            }
            LonghandId::BorderSpacing => {
                let computed = style.clone_border_spacing();
                AnimationValue::BorderSpacing(
                    computed.to_animated_value()
                )
            }
            LonghandId::BoxShadow => {
                let computed = style.clone_box_shadow();
                AnimationValue::BoxShadow(
                    computed.to_animated_value()
                )
            }
            LonghandId::CaretColor => {
                let computed = style.clone_caret_color();
                AnimationValue::CaretColor(
                    computed.to_animated_value()
                )
            }
            LonghandId::ClipPath => {
                let computed = style.clone_clip_path();
                AnimationValue::ClipPath(
                    computed.to_animated_value()
                )
            }
            LonghandId::Color => {
                let computed = style.clone_color();
                AnimationValue::Color(
                    computed.to_animated_value()
                )
            }
            LonghandId::ColumnWidth => {
                let computed = style.clone_column_width();
                AnimationValue::ColumnWidth(
                    computed.to_animated_value()
                )
            }
            LonghandId::Content => {
                let computed = style.clone_content();
                AnimationValue::Content(
                    computed
                )
            }
            LonghandId::CounterIncrement => {
                let computed = style.clone_counter_increment();
                AnimationValue::CounterIncrement(
                    computed
                )
            }
            LonghandId::Cursor => {
                let computed = style.clone_cursor();
                AnimationValue::Cursor(
                    computed
                )
            }
            LonghandId::Filter => {
                let computed = style.clone_filter();
                AnimationValue::Filter(
                    computed.to_animated_value()
                )
            }
            LonghandId::FlexBasis => {
                let computed = style.clone_flex_basis();
                AnimationValue::FlexBasis(
                    computed.to_animated_value()
                )
            }
            LonghandId::FontFamily => {
                let computed = style.clone_font_family();
                AnimationValue::FontFamily(
                    computed
                )
            }
            LonghandId::FontFeatureSettings => {
                let computed = style.clone_font_feature_settings();
                AnimationValue::FontFeatureSettings(
                    computed
                )
            }
            LonghandId::FontLanguageOverride => {
                let computed = style.clone_font_language_override();
                AnimationValue::FontLanguageOverride(
                    computed
                )
            }
            LonghandId::FontSize => {
                let computed = style.clone_font_size();
                AnimationValue::FontSize(
                    computed.to_animated_value()
                )
            }
            LonghandId::FontVariantAlternates => {
                let computed = style.clone_font_variant_alternates();
                AnimationValue::FontVariantAlternates(
                    computed
                )
            }
            LonghandId::FontVariationSettings => {
                let computed = style.clone_font_variation_settings();
                AnimationValue::FontVariationSettings(
                    computed
                )
            }
            LonghandId::GridTemplateAreas => {
                let computed = style.clone_grid_template_areas();
                AnimationValue::GridTemplateAreas(
                    computed
                )
            }
            LonghandId::LetterSpacing => {
                let computed = style.clone_letter_spacing();
                AnimationValue::LetterSpacing(
                    computed
                )
            }
            LonghandId::LineHeight => {
                let computed = style.clone_line_height();
                AnimationValue::LineHeight(
                    computed.to_animated_value()
                )
            }
            LonghandId::ListStyleImage => {
                let computed = style.clone_list_style_image();
                AnimationValue::ListStyleImage(
                    computed
                )
            }
            LonghandId::ListStyleType => {
                let computed = style.clone_list_style_type();
                AnimationValue::ListStyleType(
                    computed
                )
            }
            LonghandId::MaskClip => {
                let computed = style.clone_mask_clip();
                AnimationValue::MaskClip(
                    computed
                )
            }
            LonghandId::MaskComposite => {
                let computed = style.clone_mask_composite();
                AnimationValue::MaskComposite(
                    computed
                )
            }
            LonghandId::MaskImage => {
                let computed = style.clone_mask_image();
                AnimationValue::MaskImage(
                    computed
                )
            }
            LonghandId::MaskMode => {
                let computed = style.clone_mask_mode();
                AnimationValue::MaskMode(
                    computed
                )
            }
            LonghandId::MaskOrigin => {
                let computed = style.clone_mask_origin();
                AnimationValue::MaskOrigin(
                    computed
                )
            }
            LonghandId::MaskPositionX => {
                let computed = style.clone_mask_position_x();
                AnimationValue::MaskPositionX(
                    computed
                )
            }
            LonghandId::MaskPositionY => {
                let computed = style.clone_mask_position_y();
                AnimationValue::MaskPositionY(
                    computed
                )
            }
            LonghandId::MaskRepeat => {
                let computed = style.clone_mask_repeat();
                AnimationValue::MaskRepeat(
                    computed
                )
            }
            LonghandId::MaskSize => {
                let computed = style.clone_mask_size();
                AnimationValue::MaskSize(
                    computed.to_animated_value()
                )
            }
            LonghandId::MozTabSize => {
                let computed = style.clone__moz_tab_size();
                AnimationValue::MozTabSize(
                    computed.to_animated_value()
                )
            }
            LonghandId::OffsetPath => {
                let computed = style.clone_offset_path();
                AnimationValue::OffsetPath(
                    computed
                )
            }
            LonghandId::Perspective => {
                let computed = style.clone_perspective();
                AnimationValue::Perspective(
                    computed.to_animated_value()
                )
            }
            LonghandId::Quotes => {
                let computed = style.clone_quotes();
                AnimationValue::Quotes(
                    computed
                )
            }
            LonghandId::Rotate => {
                let computed = style.clone_rotate();
                AnimationValue::Rotate(
                    computed
                )
            }
            LonghandId::Scale => {
                let computed = style.clone_scale();
                AnimationValue::Scale(
                    computed
                )
            }
            LonghandId::ScrollSnapCoordinate => {
                let computed = style.clone_scroll_snap_coordinate();
                AnimationValue::ScrollSnapCoordinate(
                    computed
                )
            }
            LonghandId::ScrollbarColor => {
                let computed = style.clone_scrollbar_color();
                AnimationValue::ScrollbarColor(
                    computed.to_animated_value()
                )
            }
            LonghandId::ShapeOutside => {
                let computed = style.clone_shape_outside();
                AnimationValue::ShapeOutside(
                    computed.to_animated_value()
                )
            }
            LonghandId::StrokeDasharray => {
                let computed = style.clone_stroke_dasharray();
                AnimationValue::StrokeDasharray(
                    computed.to_animated_value()
                )
            }
            LonghandId::StrokeDashoffset => {
                let computed = style.clone_stroke_dashoffset();
                AnimationValue::StrokeDashoffset(
                    computed
                )
            }
            LonghandId::StrokeWidth => {
                let computed = style.clone_stroke_width();
                AnimationValue::StrokeWidth(
                    computed.to_animated_value()
                )
            }
            LonghandId::TextEmphasisStyle => {
                let computed = style.clone_text_emphasis_style();
                AnimationValue::TextEmphasisStyle(
                    computed
                )
            }
            LonghandId::TextIndent => {
                let computed = style.clone_text_indent();
                AnimationValue::TextIndent(
                    computed
                )
            }
            LonghandId::TextOverflow => {
                let computed = style.clone_text_overflow();
                AnimationValue::TextOverflow(
                    computed
                )
            }
            LonghandId::TextShadow => {
                let computed = style.clone_text_shadow();
                AnimationValue::TextShadow(
                    computed.to_animated_value()
                )
            }
            LonghandId::Translate => {
                let computed = style.clone_translate();
                AnimationValue::Translate(
                    computed
                )
            }
            LonghandId::VerticalAlign => {
                let computed = style.clone_vertical_align();
                AnimationValue::VerticalAlign(
                    computed
                )
            }
            LonghandId::WordSpacing => {
                let computed = style.clone_word_spacing();
                AnimationValue::WordSpacing(
                    computed
                )
            }
            LonghandId::Clip => {
                let computed = style.clone_clip();
                AnimationValue::Clip(
                    computed
                )
            }
            LonghandId::MozImageRegion => {
                let computed = style.clone__moz_image_region();
                AnimationValue::MozImageRegion(
                    computed
                )
            }
            LonghandId::GridTemplateColumns => {
                let computed = style.clone_grid_template_columns();
                AnimationValue::GridTemplateColumns(
                    computed
                )
            }
            LonghandId::GridTemplateRows => {
                let computed = style.clone_grid_template_rows();
                AnimationValue::GridTemplateRows(
                    computed
                )
            }
            LonghandId::Fill => {
                let computed = style.clone_fill();
                AnimationValue::Fill(
                    computed.to_animated_value()
                )
            }
            LonghandId::Stroke => {
                let computed = style.clone_stroke();
                AnimationValue::Stroke(
                    computed.to_animated_value()
                )
            }
            LonghandId::GridAutoColumns => {
                let computed = style.clone_grid_auto_columns();
                AnimationValue::GridAutoColumns(
                    computed
                )
            }
            LonghandId::GridAutoRows => {
                let computed = style.clone_grid_auto_rows();
                AnimationValue::GridAutoRows(
                    computed
                )
            }
            LonghandId::MozWindowTransformOrigin => {
                let computed = style.clone__moz_window_transform_origin();
                AnimationValue::MozWindowTransformOrigin(
                    computed
                )
            }
            LonghandId::TransformOrigin => {
                let computed = style.clone_transform_origin();
                AnimationValue::TransformOrigin(
                    computed
                )
            }
            LonghandId::CounterReset => {
                let computed = style.clone_counter_reset();
                AnimationValue::CounterReset(
                    computed
                )
            }
            LonghandId::CounterSet => {
                let computed = style.clone_counter_set();
                AnimationValue::CounterSet(
                    computed
                )
            }
            LonghandId::ScrollSnapPointsX => {
                let computed = style.clone_scroll_snap_points_x();
                AnimationValue::ScrollSnapPointsX(
                    computed
                )
            }
            LonghandId::ScrollSnapPointsY => {
                let computed = style.clone_scroll_snap_points_y();
                AnimationValue::ScrollSnapPointsY(
                    computed
                )
            }
            LonghandId::MozWindowTransform => {
                let computed = style.clone__moz_window_transform();
                AnimationValue::MozWindowTransform(
                    computed
                )
            }
            LonghandId::Transform => {
                let computed = style.clone_transform();
                AnimationValue::Transform(
                    computed
                )
            }
            LonghandId::ColumnGap => {
                let computed = style.clone_column_gap();
                AnimationValue::ColumnGap(
                    computed.to_animated_value()
                )
            }
            LonghandId::RowGap => {
                let computed = style.clone_row_gap();
                AnimationValue::RowGap(
                    computed.to_animated_value()
                )
            }
            LonghandId::ObjectPosition => {
                let computed = style.clone_object_position();
                AnimationValue::ObjectPosition(
                    computed
                )
            }
            LonghandId::PerspectiveOrigin => {
                let computed = style.clone_perspective_origin();
                AnimationValue::PerspectiveOrigin(
                    computed
                )
            }
            LonghandId::ScrollSnapDestination => {
                let computed = style.clone_scroll_snap_destination();
                AnimationValue::ScrollSnapDestination(
                    computed
                )
            }
            LonghandId::GridColumnEnd => {
                let computed = style.clone_grid_column_end();
                AnimationValue::GridColumnEnd(
                    computed
                )
            }
            LonghandId::GridColumnStart => {
                let computed = style.clone_grid_column_start();
                AnimationValue::GridColumnStart(
                    computed
                )
            }
            LonghandId::GridRowEnd => {
                let computed = style.clone_grid_row_end();
                AnimationValue::GridRowEnd(
                    computed
                )
            }
            LonghandId::GridRowStart => {
                let computed = style.clone_grid_row_start();
                AnimationValue::GridRowStart(
                    computed
                )
            }
            LonghandId::MaxHeight => {
                let computed = style.clone_max_height();
                AnimationValue::MaxHeight(
                    computed.to_animated_value()
                )
            }
            LonghandId::MaxWidth => {
                let computed = style.clone_max_width();
                AnimationValue::MaxWidth(
                    computed.to_animated_value()
                )
            }
            LonghandId::MarkerEnd => {
                let computed = style.clone_marker_end();
                AnimationValue::MarkerEnd(
                    computed
                )
            }
            LonghandId::MarkerMid => {
                let computed = style.clone_marker_mid();
                AnimationValue::MarkerMid(
                    computed
                )
            }
            LonghandId::MarkerStart => {
                let computed = style.clone_marker_start();
                AnimationValue::MarkerStart(
                    computed
                )
            }
            LonghandId::ScrollPaddingBottom => {
                let computed = style.clone_scroll_padding_bottom();
                AnimationValue::ScrollPaddingBottom(
                    computed.to_animated_value()
                )
            }
            LonghandId::ScrollPaddingLeft => {
                let computed = style.clone_scroll_padding_left();
                AnimationValue::ScrollPaddingLeft(
                    computed.to_animated_value()
                )
            }
            LonghandId::ScrollPaddingRight => {
                let computed = style.clone_scroll_padding_right();
                AnimationValue::ScrollPaddingRight(
                    computed.to_animated_value()
                )
            }
            LonghandId::ScrollPaddingTop => {
                let computed = style.clone_scroll_padding_top();
                AnimationValue::ScrollPaddingTop(
                    computed.to_animated_value()
                )
            }
            LonghandId::Height => {
                let computed = style.clone_height();
                AnimationValue::Height(
                    computed.to_animated_value()
                )
            }
            LonghandId::MinHeight => {
                let computed = style.clone_min_height();
                AnimationValue::MinHeight(
                    computed.to_animated_value()
                )
            }
            LonghandId::MinWidth => {
                let computed = style.clone_min_width();
                AnimationValue::MinWidth(
                    computed.to_animated_value()
                )
            }
            LonghandId::Width => {
                let computed = style.clone_width();
                AnimationValue::Width(
                    computed.to_animated_value()
                )
            }
            LonghandId::OutlineOffset => {
                let computed = style.clone_outline_offset();
                AnimationValue::OutlineOffset(
                    computed
                )
            }
            LonghandId::ScrollMarginBottom => {
                let computed = style.clone_scroll_margin_bottom();
                AnimationValue::ScrollMarginBottom(
                    computed
                )
            }
            LonghandId::ScrollMarginLeft => {
                let computed = style.clone_scroll_margin_left();
                AnimationValue::ScrollMarginLeft(
                    computed
                )
            }
            LonghandId::ScrollMarginRight => {
                let computed = style.clone_scroll_margin_right();
                AnimationValue::ScrollMarginRight(
                    computed
                )
            }
            LonghandId::ScrollMarginTop => {
                let computed = style.clone_scroll_margin_top();
                AnimationValue::ScrollMarginTop(
                    computed
                )
            }
            LonghandId::PaddingBottom => {
                let computed = style.clone_padding_bottom();
                AnimationValue::PaddingBottom(
                    computed.to_animated_value()
                )
            }
            LonghandId::PaddingLeft => {
                let computed = style.clone_padding_left();
                AnimationValue::PaddingLeft(
                    computed.to_animated_value()
                )
            }
            LonghandId::PaddingRight => {
                let computed = style.clone_padding_right();
                AnimationValue::PaddingRight(
                    computed.to_animated_value()
                )
            }
            LonghandId::PaddingTop => {
                let computed = style.clone_padding_top();
                AnimationValue::PaddingTop(
                    computed.to_animated_value()
                )
            }
            LonghandId::ShapeMargin => {
                let computed = style.clone_shape_margin();
                AnimationValue::ShapeMargin(
                    computed.to_animated_value()
                )
            }
            LonghandId::BorderBottomWidth => {
                let computed = style.clone_border_bottom_width();
                AnimationValue::BorderBottomWidth(
                    computed.to_animated_value()
                )
            }
            LonghandId::BorderLeftWidth => {
                let computed = style.clone_border_left_width();
                AnimationValue::BorderLeftWidth(
                    computed.to_animated_value()
                )
            }
            LonghandId::BorderRightWidth => {
                let computed = style.clone_border_right_width();
                AnimationValue::BorderRightWidth(
                    computed.to_animated_value()
                )
            }
            LonghandId::BorderTopWidth => {
                let computed = style.clone_border_top_width();
                AnimationValue::BorderTopWidth(
                    computed.to_animated_value()
                )
            }
            LonghandId::ColumnRuleWidth => {
                let computed = style.clone_column_rule_width();
                AnimationValue::ColumnRuleWidth(
                    computed.to_animated_value()
                )
            }
            LonghandId::OutlineWidth => {
                let computed = style.clone_outline_width();
                AnimationValue::OutlineWidth(
                    computed.to_animated_value()
                )
            }
            LonghandId::WebkitTextStrokeWidth => {
                let computed = style.clone__webkit_text_stroke_width();
                AnimationValue::WebkitTextStrokeWidth(
                    computed
                )
            }
            LonghandId::BorderBottomLeftRadius => {
                let computed = style.clone_border_bottom_left_radius();
                AnimationValue::BorderBottomLeftRadius(
                    computed.to_animated_value()
                )
            }
            LonghandId::BorderBottomRightRadius => {
                let computed = style.clone_border_bottom_right_radius();
                AnimationValue::BorderBottomRightRadius(
                    computed.to_animated_value()
                )
            }
            LonghandId::BorderTopLeftRadius => {
                let computed = style.clone_border_top_left_radius();
                AnimationValue::BorderTopLeftRadius(
                    computed.to_animated_value()
                )
            }
            LonghandId::BorderTopRightRadius => {
                let computed = style.clone_border_top_right_radius();
                AnimationValue::BorderTopRightRadius(
                    computed.to_animated_value()
                )
            }
            LonghandId::MozOutlineRadiusBottomleft => {
                let computed = style.clone__moz_outline_radius_bottomleft();
                AnimationValue::MozOutlineRadiusBottomleft(
                    computed.to_animated_value()
                )
            }
            LonghandId::MozOutlineRadiusBottomright => {
                let computed = style.clone__moz_outline_radius_bottomright();
                AnimationValue::MozOutlineRadiusBottomright(
                    computed.to_animated_value()
                )
            }
            LonghandId::MozOutlineRadiusTopleft => {
                let computed = style.clone__moz_outline_radius_topleft();
                AnimationValue::MozOutlineRadiusTopleft(
                    computed.to_animated_value()
                )
            }
            LonghandId::MozOutlineRadiusTopright => {
                let computed = style.clone__moz_outline_radius_topright();
                AnimationValue::MozOutlineRadiusTopright(
                    computed.to_animated_value()
                )
            }
            LonghandId::Bottom => {
                let computed = style.clone_bottom();
                AnimationValue::Bottom(
                    computed
                )
            }
            LonghandId::Left => {
                let computed = style.clone_left();
                AnimationValue::Left(
                    computed
                )
            }
            LonghandId::MarginBottom => {
                let computed = style.clone_margin_bottom();
                AnimationValue::MarginBottom(
                    computed
                )
            }
            LonghandId::MarginLeft => {
                let computed = style.clone_margin_left();
                AnimationValue::MarginLeft(
                    computed
                )
            }
            LonghandId::MarginRight => {
                let computed = style.clone_margin_right();
                AnimationValue::MarginRight(
                    computed
                )
            }
            LonghandId::MarginTop => {
                let computed = style.clone_margin_top();
                AnimationValue::MarginTop(
                    computed
                )
            }
            LonghandId::Right => {
                let computed = style.clone_right();
                AnimationValue::Right(
                    computed
                )
            }
            LonghandId::Top => {
                let computed = style.clone_top();
                AnimationValue::Top(
                    computed
                )
            }
            LonghandId::BackgroundColor => {
                let computed = style.clone_background_color();
                AnimationValue::BackgroundColor(
                    computed.to_animated_value()
                )
            }
            LonghandId::BorderBottomColor => {
                let computed = style.clone_border_bottom_color();
                AnimationValue::BorderBottomColor(
                    computed.to_animated_value()
                )
            }
            LonghandId::BorderLeftColor => {
                let computed = style.clone_border_left_color();
                AnimationValue::BorderLeftColor(
                    computed.to_animated_value()
                )
            }
            LonghandId::BorderRightColor => {
                let computed = style.clone_border_right_color();
                AnimationValue::BorderRightColor(
                    computed.to_animated_value()
                )
            }
            LonghandId::BorderTopColor => {
                let computed = style.clone_border_top_color();
                AnimationValue::BorderTopColor(
                    computed.to_animated_value()
                )
            }
            LonghandId::ColumnRuleColor => {
                let computed = style.clone_column_rule_color();
                AnimationValue::ColumnRuleColor(
                    computed.to_animated_value()
                )
            }
            LonghandId::FloodColor => {
                let computed = style.clone_flood_color();
                AnimationValue::FloodColor(
                    computed.to_animated_value()
                )
            }
            LonghandId::LightingColor => {
                let computed = style.clone_lighting_color();
                AnimationValue::LightingColor(
                    computed.to_animated_value()
                )
            }
            LonghandId::OutlineColor => {
                let computed = style.clone_outline_color();
                AnimationValue::OutlineColor(
                    computed.to_animated_value()
                )
            }
            LonghandId::StopColor => {
                let computed = style.clone_stop_color();
                AnimationValue::StopColor(
                    computed.to_animated_value()
                )
            }
            LonghandId::TextDecorationColor => {
                let computed = style.clone_text_decoration_color();
                AnimationValue::TextDecorationColor(
                    computed.to_animated_value()
                )
            }
            LonghandId::TextEmphasisColor => {
                let computed = style.clone_text_emphasis_color();
                AnimationValue::TextEmphasisColor(
                    computed.to_animated_value()
                )
            }
            LonghandId::WebkitTextFillColor => {
                let computed = style.clone__webkit_text_fill_color();
                AnimationValue::WebkitTextFillColor(
                    computed.to_animated_value()
                )
            }
            LonghandId::WebkitTextStrokeColor => {
                let computed = style.clone__webkit_text_stroke_color();
                AnimationValue::WebkitTextStrokeColor(
                    computed.to_animated_value()
                )
            }
            _ => return None,
        })
    }
}

fn animate_discrete<T: Clone>(this: &T, other: &T, procedure: Procedure) -> Result<T, ()> {
    if let Procedure::Interpolate { progress } = procedure {
        Ok(if progress < 0.5 { this.clone() } else { other.clone() })
    } else {
        Err(())
    }
}

impl Animate for AnimationValue {
    fn animate(&self, other: &Self, procedure: Procedure) -> Result<Self, ()> {
        Ok(unsafe {
            use self::AnimationValue::*;

            let this_tag = *(self as *const _ as *const u16);
            let other_tag = *(other as *const _ as *const u16);
            if this_tag != other_tag {
                panic!("Unexpected AnimationValue::animate call");
            }

            match *self {
                
                AlignContent(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::AlignContent as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::AlignContent as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                AlignItems(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::AlignItems as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::AlignItems as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                AlignSelf(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::AlignSelf as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::AlignSelf as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BackfaceVisibility(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::backface_visibility::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::backface_visibility::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BorderCollapse(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::border_collapse::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::border_collapse::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BorderImageRepeat(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::BorderImageRepeat as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::BorderImageRepeat as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BoxDecorationBreak(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::box_decoration_break::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::box_decoration_break::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BoxSizing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::box_sizing::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::box_sizing::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BreakInside(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::BreakWithin as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::BreakWithin as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                CaptionSide(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::caption_side::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::caption_side::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Clear(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Clear as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Clear as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ColorAdjust(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::color_adjust::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::color_adjust::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ColorInterpolation(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::color_interpolation::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::color_interpolation::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ColorInterpolationFilters(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::color_interpolation_filters::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::color_interpolation_filters::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ColumnCount(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::ColumnCount as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::ColumnCount as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ColumnFill(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::column_fill::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::column_fill::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ColumnSpan(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::column_span::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::column_span::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Display(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Display as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Display as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                DominantBaseline(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::dominant_baseline::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::dominant_baseline::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                EmptyCells(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::empty_cells::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::empty_cells::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FlexDirection(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::flex_direction::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::flex_direction::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FlexWrap(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::flex_wrap::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::flex_wrap::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Float(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Float as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Float as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FontKerning(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::font_kerning::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::font_kerning::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FontOpticalSizing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::font_optical_sizing::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::font_optical_sizing::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FontSizeAdjust(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontSizeAdjust as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontSizeAdjust as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FontStretch(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::FontStretch as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::FontStretch as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FontStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::FontStyle as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::FontStyle as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FontSynthesis(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontSynthesis as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontSynthesis as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FontVariantCaps(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::font_variant_caps::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::font_variant_caps::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FontVariantEastAsian(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontVariantEastAsian as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontVariantEastAsian as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FontVariantLigatures(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontVariantLigatures as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontVariantLigatures as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FontVariantNumeric(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontVariantNumeric as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontVariantNumeric as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FontVariantPosition(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::font_variant_position::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::font_variant_position::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FontWeight(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::FontWeight as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::FontWeight as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                GridAutoFlow(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::GridAutoFlow as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::GridAutoFlow as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Hyphens(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::hyphens::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::hyphens::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ImageOrientation(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::image_orientation::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::image_orientation::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ImageRendering(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::image_rendering::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::image_rendering::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ImeMode(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::ime_mode::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::ime_mode::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                InitialLetter(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::InitialLetter as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::InitialLetter as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Isolation(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::isolation::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::isolation::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                JustifyContent(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::JustifyContent as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::JustifyContent as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                JustifyItems(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::JustifyItems as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::JustifyItems as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                JustifySelf(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::JustifySelf as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::JustifySelf as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ListStylePosition(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::list_style_position::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::list_style_position::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MaskType(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_type::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mask_type::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MixBlendMode(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mix_blend_mode::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mix_blend_mode::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozAppearance(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Appearance as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Appearance as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozBoxAlign(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_box_align::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_box_align::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozBoxDirection(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_box_direction::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_box_direction::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozBoxOrient(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_box_orient::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_box_orient::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozBoxPack(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_box_pack::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_box_pack::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozFloatEdge(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_float_edge::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_float_edge::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozForceBrokenImageIcon(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::MozForceBrokenImageIcon as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::MozForceBrokenImageIcon as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozListReversed(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::MozListReversed as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::MozListReversed as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozOrient(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_orient::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_orient::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozOsxFontSmoothing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_osx_font_smoothing::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_osx_font_smoothing::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozStackSizing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_stack_sizing::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_stack_sizing::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozTextSizeAdjust(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_text_size_adjust::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_text_size_adjust::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozUserFocus(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_user_focus::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_user_focus::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozUserInput(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_user_input::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_user_input::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozUserModify(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_user_modify::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_user_modify::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozUserSelect(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::UserSelect as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::UserSelect as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozWindowDragging(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_window_dragging::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_window_dragging::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozWindowShadow(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::_moz_window_shadow::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::_moz_window_shadow::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ObjectFit(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::object_fit::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::object_fit::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                OutlineStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::OutlineStyle as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::OutlineStyle as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                OverflowAnchor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::OverflowAnchor as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::OverflowAnchor as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                OverflowWrap(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::OverflowWrap as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::OverflowWrap as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                PaintOrder(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::SVGPaintOrder as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::SVGPaintOrder as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                PointerEvents(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::pointer_events::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::pointer_events::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Position(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::position::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::position::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Resize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Resize as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Resize as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                RubyAlign(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::ruby_align::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::ruby_align::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                RubyPosition(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::ruby_position::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::ruby_position::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ScrollBehavior(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::scroll_behavior::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::scroll_behavior::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ScrollSnapAlign(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::ScrollSnapAlign as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::ScrollSnapAlign as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ScrollSnapType(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::ScrollSnapType as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::ScrollSnapType as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ScrollbarWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::scrollbar_width::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::scrollbar_width::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ShapeRendering(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::shape_rendering::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::shape_rendering::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                StrokeLinecap(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::stroke_linecap::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::stroke_linecap::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                StrokeLinejoin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::stroke_linejoin::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::stroke_linejoin::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                TableLayout(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::table_layout::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::table_layout::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                TextAlign(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TextAlign as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TextAlign as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                TextAlignLast(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::text_align_last::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::text_align_last::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                TextAnchor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::text_anchor::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::text_anchor::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                TextCombineUpright(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::text_combine_upright::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::text_combine_upright::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                TextDecorationLine(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TextDecorationLine as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TextDecorationLine as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                TextDecorationStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::text_decoration_style::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::text_decoration_style::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                TextEmphasisPosition(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TextEmphasisPosition as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TextEmphasisPosition as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                TextJustify(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::text_justify::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::text_justify::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                TextRendering(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::text_rendering::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::text_rendering::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                TextTransform(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TextTransform as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TextTransform as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                TouchAction(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TouchAction as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TouchAction as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                TransformBox(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::transform_box::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::transform_box::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                TransformStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TransformStyle as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TransformStyle as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                VectorEffect(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::vector_effect::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::vector_effect::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Visibility(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::visibility::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::visibility::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                WebkitLineClamp(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::PositiveIntegerOrNone as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::PositiveIntegerOrNone as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                WhiteSpace(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::white_space::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::white_space::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                WordBreak(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::WordBreak as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::WordBreak as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ZIndex(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::ZIndex as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::ZIndex as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BreakAfter(ref this) |
BreakBefore(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::BreakBetween as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::BreakBetween as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ClipRule(ref this) |
FillRule(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FillRule as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FillRule as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozBoxOrdinalGroup(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Integer as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Integer as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Order(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Integer as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Integer as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                OverflowX(ref this) |
OverflowY(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Overflow as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Overflow as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                OverflowClipBoxBlock(ref this) |
OverflowClipBoxInline(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::OverflowClipBox as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::OverflowClipBox as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                OverscrollBehaviorX(ref this) |
OverscrollBehaviorY(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::OverscrollBehavior as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::OverscrollBehavior as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FillOpacity(ref this) |
StrokeOpacity(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::SVGOpacity as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::SVGOpacity as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FlexGrow(ref this) |
FlexShrink(ref this) |
MozBoxFlex(ref this) |
StrokeMiterlimit(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::NonNegativeNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::NonNegativeNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FloodOpacity(ref this) |
MozWindowOpacity(ref this) |
Opacity(ref this) |
ShapeImageThreshold(ref this) |
StopOpacity(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Opacity as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Opacity as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BorderBottomStyle(ref this) |
BorderLeftStyle(ref this) |
BorderRightStyle(ref this) |
BorderTopStyle(ref this) |
ColumnRuleStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::BorderStyle as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::BorderStyle as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BackgroundAttachment(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::background_attachment::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::background_attachment::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BackgroundBlendMode(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::background_blend_mode::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::background_blend_mode::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BackgroundClip(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::background_clip::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::background_clip::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BackgroundImage(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::background_image::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::background_image::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BackgroundOrigin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::background_origin::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::background_origin::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BackgroundPositionX(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::background_position_x::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::background_position_x::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BackgroundPositionY(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::background_position_y::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::background_position_y::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BackgroundRepeat(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::background_repeat::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::background_repeat::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BackgroundSize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<longhands::background_size::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<longhands::background_size::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BorderImageOutset(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::NonNegativeLengthOrNumberRect as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::NonNegativeLengthOrNumberRect as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BorderImageSlice(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::BorderImageSlice as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::BorderImageSlice as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BorderImageSource(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::ImageLayer as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::ImageLayer as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BorderImageWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::BorderImageWidth as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::BorderImageWidth as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BorderSpacing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::BorderSpacing as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::BorderSpacing as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BoxShadow(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<longhands::box_shadow::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<longhands::box_shadow::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                CaretColor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::ColorOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::ColorOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ClipPath(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::basic_shape::ClippingShape as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::basic_shape::ClippingShape as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Color(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::ColorPropertyValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::ColorPropertyValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ColumnWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::length::NonNegativeLengthOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::length::NonNegativeLengthOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Content(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Content as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Content as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                CounterIncrement(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::CounterIncrement as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::CounterIncrement as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Cursor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Cursor as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Cursor as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Filter(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<longhands::filter::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<longhands::filter::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FlexBasis(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::FlexBasis as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::FlexBasis as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FontFamily(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontFamily as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontFamily as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FontFeatureSettings(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontFeatureSettings as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontFeatureSettings as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FontLanguageOverride(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontLanguageOverride as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontLanguageOverride as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FontSize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::FontSize as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::FontSize as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FontVariantAlternates(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontVariantAlternates as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontVariantAlternates as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                FontVariationSettings(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontVariationSettings as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::FontVariationSettings as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                GridTemplateAreas(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::GridTemplateAreas as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::GridTemplateAreas as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                LetterSpacing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::LetterSpacing as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::LetterSpacing as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                LineHeight(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::LineHeight as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::LineHeight as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ListStyleImage(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::url::ImageUrlOrNone as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::url::ImageUrlOrNone as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ListStyleType(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::ListStyleType as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::ListStyleType as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MaskClip(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_clip::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mask_clip::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MaskComposite(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_composite::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mask_composite::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MaskImage(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_image::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mask_image::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MaskMode(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_mode::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mask_mode::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MaskOrigin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_origin::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mask_origin::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MaskPositionX(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_position_x::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mask_position_x::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MaskPositionY(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_position_y::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mask_position_y::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MaskRepeat(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_repeat::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::mask_repeat::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MaskSize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<longhands::mask_size::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<longhands::mask_size::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozTabSize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::NonNegativeLengthOrNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::NonNegativeLengthOrNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                OffsetPath(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::OffsetPath as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::OffsetPath as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Perspective(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::Perspective as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::Perspective as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Quotes(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Quotes as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Quotes as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Rotate(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Rotate as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Rotate as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Scale(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Scale as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Scale as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ScrollSnapCoordinate(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::scroll_snap_coordinate::SpecifiedValue as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<longhands::scroll_snap_coordinate::SpecifiedValue as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ScrollbarColor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::ui::ScrollbarColor as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::ui::ScrollbarColor as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ShapeOutside(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::basic_shape::FloatAreaShape as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::basic_shape::FloatAreaShape as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                StrokeDasharray(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::SVGStrokeDashArray as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::SVGStrokeDashArray as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                StrokeDashoffset(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::SVGLength as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::SVGLength as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                StrokeWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::SVGWidth as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::SVGWidth as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                TextEmphasisStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TextEmphasisStyle as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TextEmphasisStyle as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                TextIndent(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::LengthPercentage as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::LengthPercentage as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                TextOverflow(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TextOverflow as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TextOverflow as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                TextShadow(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<longhands::text_shadow::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<longhands::text_shadow::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Translate(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Translate as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Translate as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                VerticalAlign(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::VerticalAlign as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::VerticalAlign as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                WordSpacing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::WordSpacing as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::WordSpacing as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Clip(ref this) |
MozImageRegion(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::ClipRectOrAuto as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::ClipRectOrAuto as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                GridTemplateColumns(ref this) |
GridTemplateRows(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::GridTemplateComponent as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::GridTemplateComponent as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Fill(ref this) |
Stroke(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::SVGPaint as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::SVGPaint as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                GridAutoColumns(ref this) |
GridAutoRows(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TrackSize as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TrackSize as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozWindowTransformOrigin(ref this) |
TransformOrigin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TransformOrigin as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::TransformOrigin as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                CounterReset(ref this) |
CounterSet(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::CounterSetOrReset as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::CounterSetOrReset as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ScrollSnapPointsX(ref this) |
ScrollSnapPointsY(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::ScrollSnapPoint as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::ScrollSnapPoint as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MozWindowTransform(ref this) |
Transform(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Transform as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Transform as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ColumnGap(ref this) |
RowGap(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::length::NonNegativeLengthPercentageOrNormal as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::length::NonNegativeLengthPercentageOrNormal as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ObjectPosition(ref this) |
PerspectiveOrigin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Position as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Position as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ScrollSnapDestination(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Position as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Position as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                GridColumnEnd(ref this) |
GridColumnStart(ref this) |
GridRowEnd(ref this) |
GridRowStart(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::GridLine as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::GridLine as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MaxHeight(ref this) |
MaxWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::MaxSize as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::MaxSize as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                MarkerEnd(ref this) |
MarkerMid(ref this) |
MarkerStart(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::url::UrlOrNone as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::url::UrlOrNone as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                ScrollPaddingBottom(ref this) |
ScrollPaddingLeft(ref this) |
ScrollPaddingRight(ref this) |
ScrollPaddingTop(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::NonNegativeLengthPercentageOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::NonNegativeLengthPercentageOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Height(ref this) |
MinHeight(ref this) |
MinWidth(ref this) |
Width(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::Size as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::Size as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                OutlineOffset(ref this) |
ScrollMarginBottom(ref this) |
ScrollMarginLeft(ref this) |
ScrollMarginRight(ref this) |
ScrollMarginTop(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Length as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::Length as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                PaddingBottom(ref this) |
PaddingLeft(ref this) |
PaddingRight(ref this) |
PaddingTop(ref this) |
ShapeMargin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::NonNegativeLengthPercentage as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::NonNegativeLengthPercentage as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BorderBottomWidth(ref this) |
BorderLeftWidth(ref this) |
BorderRightWidth(ref this) |
BorderTopWidth(ref this) |
ColumnRuleWidth(ref this) |
OutlineWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::BorderSideWidth as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::BorderSideWidth as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                WebkitTextStrokeWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::BorderSideWidth as ToComputedValue>::ComputedValue>);
                    let value = animate_discrete(this, &other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::BorderSideWidth as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BorderBottomLeftRadius(ref this) |
BorderBottomRightRadius(ref this) |
BorderTopLeftRadius(ref this) |
BorderTopRightRadius(ref this) |
MozOutlineRadiusBottomleft(ref this) |
MozOutlineRadiusBottomright(ref this) |
MozOutlineRadiusTopleft(ref this) |
MozOutlineRadiusTopright(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::BorderCornerRadius as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::BorderCornerRadius as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Bottom(ref this) |
Left(ref this) |
MarginBottom(ref this) |
MarginLeft(ref this) |
MarginRight(ref this) |
MarginTop(ref this) |
Right(ref this) |
Top(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::LengthPercentageOrAuto as ToComputedValue>::ComputedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<crate::values::specified::LengthPercentageOrAuto as ToComputedValue>::ComputedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                BackgroundColor(ref this) |
BorderBottomColor(ref this) |
BorderLeftColor(ref this) |
BorderRightColor(ref this) |
BorderTopColor(ref this) |
ColumnRuleColor(ref this) |
FloodColor(ref this) |
LightingColor(ref this) |
OutlineColor(ref this) |
StopColor(ref this) |
TextDecorationColor(ref this) |
TextEmphasisColor(ref this) |
WebkitTextFillColor(ref this) |
WebkitTextStrokeColor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);
                    let value = this.animate(&other_repr.value, procedure)?;

                    let mut out = mem::uninitialized();
                    ptr::write(
                        &mut out as *mut _ as *mut AnimationValueVariantRepr<<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>,
                        AnimationValueVariantRepr {
                            tag: this_tag,
                            value,
                        },
                    );
                    out
                }
                Contain(void) |
Direction(void) |
MozControlCharacterVisibility(void) |
MozMathDisplay(void) |
MozMathVariant(void) |
MozMinFontSizeRatio(void) |
MozScriptLevel(void) |
MozScriptMinSize(void) |
MozScriptSizeMultiplier(void) |
MozTopLayer(void) |
TextOrientation(void) |
UnicodeBidi(void) |
WritingMode(void) |
XSpan(void) |
XTextZoom(void) |
BorderBlockEndStyle(void) |
BorderBlockStartStyle(void) |
BorderInlineEndStyle(void) |
BorderInlineStartStyle(void) |
AnimationDelay(void) |
AnimationDirection(void) |
AnimationDuration(void) |
AnimationFillMode(void) |
AnimationIterationCount(void) |
AnimationName(void) |
AnimationPlayState(void) |
AnimationTimingFunction(void) |
MozContextProperties(void) |
MozFontSmoothingBackgroundColor(void) |
TransitionDelay(void) |
TransitionDuration(void) |
TransitionProperty(void) |
TransitionTimingFunction(void) |
WillChange(void) |
XLang(void) |
MaxBlockSize(void) |
MaxInlineSize(void) |
MozBinding(void) |
ScrollPaddingBlockEnd(void) |
ScrollPaddingBlockStart(void) |
ScrollPaddingInlineEnd(void) |
ScrollPaddingInlineStart(void) |
BlockSize(void) |
InlineSize(void) |
MinBlockSize(void) |
MinInlineSize(void) |
ScrollMarginBlockEnd(void) |
ScrollMarginBlockStart(void) |
ScrollMarginInlineEnd(void) |
ScrollMarginInlineStart(void) |
PaddingBlockEnd(void) |
PaddingBlockStart(void) |
PaddingInlineEnd(void) |
PaddingInlineStart(void) |
BorderBlockEndWidth(void) |
BorderBlockStartWidth(void) |
BorderInlineEndWidth(void) |
BorderInlineStartWidth(void) |
BorderEndEndRadius(void) |
BorderEndStartRadius(void) |
BorderStartEndRadius(void) |
BorderStartStartRadius(void) |
InsetBlockEnd(void) |
InsetBlockStart(void) |
InsetInlineEnd(void) |
InsetInlineStart(void) |
MarginBlockEnd(void) |
MarginBlockStart(void) |
MarginInlineEnd(void) |
MarginInlineStart(void) |
BorderBlockEndColor(void) |
BorderBlockStartColor(void) |
BorderInlineEndColor(void) |
BorderInlineStartColor(void) => {
                    void::unreachable(void)
                }
            }
        })
    }
}



impl ComputeSquaredDistance for AnimationValue {
    fn compute_squared_distance(&self, other: &Self) -> Result<SquaredDistance, ()> {
        unsafe {
            use self::AnimationValue::*;

            let this_tag = *(self as *const _ as *const u16);
            let other_tag = *(other as *const _ as *const u16);
            if this_tag != other_tag {
                panic!("Unexpected AnimationValue::compute_squared_distance call");
            }

            match *self {
                ColumnCount(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::ColumnCount as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                FontSizeAdjust(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontSizeAdjust as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                FontStretch(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::FontStretch as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                FontStyle(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::FontStyle as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                FontWeight(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::FontWeight as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                Visibility(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::visibility::SpecifiedValue as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                WebkitLineClamp(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::PositiveIntegerOrNone as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                ZIndex(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::ZIndex as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                Order(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Integer as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                FillOpacity(ref this) |
StrokeOpacity(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::SVGOpacity as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                FlexGrow(ref this) |
FlexShrink(ref this) |
MozBoxFlex(ref this) |
StrokeMiterlimit(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::NonNegativeNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                FloodOpacity(ref this) |
MozWindowOpacity(ref this) |
Opacity(ref this) |
ShapeImageThreshold(ref this) |
StopOpacity(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Opacity as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                BackgroundPositionX(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::background_position_x::SpecifiedValue as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                BackgroundPositionY(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::background_position_y::SpecifiedValue as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                BackgroundSize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<longhands::background_size::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                BorderSpacing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::BorderSpacing as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                BoxShadow(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<longhands::box_shadow::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                CaretColor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::ColorOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                ClipPath(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::basic_shape::ClippingShape as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                Color(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::ColorPropertyValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                ColumnWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::length::NonNegativeLengthOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                Filter(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<longhands::filter::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                FlexBasis(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::FlexBasis as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                FontSize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::FontSize as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                FontVariationSettings(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::FontVariationSettings as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                LetterSpacing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::LetterSpacing as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                LineHeight(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::LineHeight as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                MaskPositionX(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_position_x::SpecifiedValue as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                MaskPositionY(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<longhands::mask_position_y::SpecifiedValue as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                MaskSize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<longhands::mask_size::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                MozTabSize(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::NonNegativeLengthOrNumber as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                OffsetPath(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::OffsetPath as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                Perspective(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::Perspective as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                Rotate(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Rotate as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                Scale(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Scale as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                ScrollbarColor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::ui::ScrollbarColor as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                ShapeOutside(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::basic_shape::FloatAreaShape as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                StrokeDasharray(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::SVGStrokeDashArray as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                StrokeDashoffset(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::SVGLength as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                StrokeWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::SVGWidth as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                TextIndent(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::LengthPercentage as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                TextShadow(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<longhands::text_shadow::SpecifiedValue as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                Translate(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Translate as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                VerticalAlign(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::VerticalAlign as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                WordSpacing(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::WordSpacing as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                Clip(ref this) |
MozImageRegion(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::ClipRectOrAuto as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                GridTemplateColumns(ref this) |
GridTemplateRows(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::GridTemplateComponent as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                Fill(ref this) |
Stroke(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::SVGPaint as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                MozWindowTransformOrigin(ref this) |
TransformOrigin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::TransformOrigin as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                MozWindowTransform(ref this) |
Transform(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Transform as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                ColumnGap(ref this) |
RowGap(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::length::NonNegativeLengthPercentageOrNormal as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                ObjectPosition(ref this) |
PerspectiveOrigin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Position as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                MaxHeight(ref this) |
MaxWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::MaxSize as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                ScrollPaddingBottom(ref this) |
ScrollPaddingLeft(ref this) |
ScrollPaddingRight(ref this) |
ScrollPaddingTop(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::NonNegativeLengthPercentageOrAuto as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                Height(ref this) |
MinHeight(ref this) |
MinWidth(ref this) |
Width(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::Size as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                OutlineOffset(ref this) |
ScrollMarginBottom(ref this) |
ScrollMarginLeft(ref this) |
ScrollMarginRight(ref this) |
ScrollMarginTop(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::Length as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                PaddingBottom(ref this) |
PaddingLeft(ref this) |
PaddingRight(ref this) |
PaddingTop(ref this) |
ShapeMargin(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::NonNegativeLengthPercentage as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                BorderBottomWidth(ref this) |
BorderLeftWidth(ref this) |
BorderRightWidth(ref this) |
BorderTopWidth(ref this) |
ColumnRuleWidth(ref this) |
OutlineWidth(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::BorderSideWidth as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                BorderBottomLeftRadius(ref this) |
BorderBottomRightRadius(ref this) |
BorderTopLeftRadius(ref this) |
BorderTopRightRadius(ref this) |
MozOutlineRadiusBottomleft(ref this) |
MozOutlineRadiusBottomright(ref this) |
MozOutlineRadiusTopleft(ref this) |
MozOutlineRadiusTopright(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::BorderCornerRadius as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                Bottom(ref this) |
Left(ref this) |
MarginBottom(ref this) |
MarginLeft(ref this) |
MarginRight(ref this) |
MarginTop(ref this) |
Right(ref this) |
Top(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<crate::values::specified::LengthPercentageOrAuto as ToComputedValue>::ComputedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                BackgroundColor(ref this) |
BorderBottomColor(ref this) |
BorderLeftColor(ref this) |
BorderRightColor(ref this) |
BorderTopColor(ref this) |
ColumnRuleColor(ref this) |
FloodColor(ref this) |
LightingColor(ref this) |
OutlineColor(ref this) |
StopColor(ref this) |
TextDecorationColor(ref this) |
TextEmphasisColor(ref this) |
WebkitTextFillColor(ref this) |
WebkitTextStrokeColor(ref this) => {
                    let other_repr =
                        &*(other as *const _ as *const AnimationValueVariantRepr<<<crate::values::specified::Color as ToComputedValue>::ComputedValue as ToAnimatedValue>::AnimatedValue>);

                    this.compute_squared_distance(&other_repr.value)
                }
                _ => Err(()),
            }
        }
    }
}

impl ToAnimatedZero for AnimationValue {
    #[inline]
    fn to_animated_zero(&self) -> Result<Self, ()> {
        match *self {
            AnimationValue::ColumnCount(ref base) => {
                Ok(AnimationValue::ColumnCount(base.to_animated_zero()?))
            },
            AnimationValue::FontSizeAdjust(ref base) => {
                Ok(AnimationValue::FontSizeAdjust(base.to_animated_zero()?))
            },
            AnimationValue::FontStretch(ref base) => {
                Ok(AnimationValue::FontStretch(base.to_animated_zero()?))
            },
            AnimationValue::FontStyle(ref base) => {
                Ok(AnimationValue::FontStyle(base.to_animated_zero()?))
            },
            AnimationValue::FontWeight(ref base) => {
                Ok(AnimationValue::FontWeight(base.to_animated_zero()?))
            },
            AnimationValue::Visibility(ref base) => {
                Ok(AnimationValue::Visibility(base.to_animated_zero()?))
            },
            AnimationValue::WebkitLineClamp(ref base) => {
                Ok(AnimationValue::WebkitLineClamp(base.to_animated_zero()?))
            },
            AnimationValue::ZIndex(ref base) => {
                Ok(AnimationValue::ZIndex(base.to_animated_zero()?))
            },
            AnimationValue::Order(ref base) => {
                Ok(AnimationValue::Order(base.to_animated_zero()?))
            },
            AnimationValue::FillOpacity(ref base) => {
                Ok(AnimationValue::FillOpacity(base.to_animated_zero()?))
            },
            AnimationValue::StrokeOpacity(ref base) => {
                Ok(AnimationValue::StrokeOpacity(base.to_animated_zero()?))
            },
            AnimationValue::FlexGrow(ref base) => {
                Ok(AnimationValue::FlexGrow(base.to_animated_zero()?))
            },
            AnimationValue::FlexShrink(ref base) => {
                Ok(AnimationValue::FlexShrink(base.to_animated_zero()?))
            },
            AnimationValue::MozBoxFlex(ref base) => {
                Ok(AnimationValue::MozBoxFlex(base.to_animated_zero()?))
            },
            AnimationValue::StrokeMiterlimit(ref base) => {
                Ok(AnimationValue::StrokeMiterlimit(base.to_animated_zero()?))
            },
            AnimationValue::FloodOpacity(ref base) => {
                Ok(AnimationValue::FloodOpacity(base.to_animated_zero()?))
            },
            AnimationValue::MozWindowOpacity(ref base) => {
                Ok(AnimationValue::MozWindowOpacity(base.to_animated_zero()?))
            },
            AnimationValue::Opacity(ref base) => {
                Ok(AnimationValue::Opacity(base.to_animated_zero()?))
            },
            AnimationValue::ShapeImageThreshold(ref base) => {
                Ok(AnimationValue::ShapeImageThreshold(base.to_animated_zero()?))
            },
            AnimationValue::StopOpacity(ref base) => {
                Ok(AnimationValue::StopOpacity(base.to_animated_zero()?))
            },
            AnimationValue::BackgroundPositionX(ref base) => {
                Ok(AnimationValue::BackgroundPositionX(base.to_animated_zero()?))
            },
            AnimationValue::BackgroundPositionY(ref base) => {
                Ok(AnimationValue::BackgroundPositionY(base.to_animated_zero()?))
            },
            AnimationValue::BackgroundSize(ref base) => {
                Ok(AnimationValue::BackgroundSize(base.to_animated_zero()?))
            },
            AnimationValue::BorderSpacing(ref base) => {
                Ok(AnimationValue::BorderSpacing(base.to_animated_zero()?))
            },
            AnimationValue::BoxShadow(ref base) => {
                Ok(AnimationValue::BoxShadow(base.to_animated_zero()?))
            },
            AnimationValue::CaretColor(ref base) => {
                Ok(AnimationValue::CaretColor(base.to_animated_zero()?))
            },
            AnimationValue::ClipPath(ref base) => {
                Ok(AnimationValue::ClipPath(base.to_animated_zero()?))
            },
            AnimationValue::Color(ref base) => {
                Ok(AnimationValue::Color(base.to_animated_zero()?))
            },
            AnimationValue::ColumnWidth(ref base) => {
                Ok(AnimationValue::ColumnWidth(base.to_animated_zero()?))
            },
            AnimationValue::Filter(ref base) => {
                Ok(AnimationValue::Filter(base.to_animated_zero()?))
            },
            AnimationValue::FlexBasis(ref base) => {
                Ok(AnimationValue::FlexBasis(base.to_animated_zero()?))
            },
            AnimationValue::FontSize(ref base) => {
                Ok(AnimationValue::FontSize(base.to_animated_zero()?))
            },
            AnimationValue::FontVariationSettings(ref base) => {
                Ok(AnimationValue::FontVariationSettings(base.to_animated_zero()?))
            },
            AnimationValue::LetterSpacing(ref base) => {
                Ok(AnimationValue::LetterSpacing(base.to_animated_zero()?))
            },
            AnimationValue::LineHeight(ref base) => {
                Ok(AnimationValue::LineHeight(base.to_animated_zero()?))
            },
            AnimationValue::MaskPositionX(ref base) => {
                Ok(AnimationValue::MaskPositionX(base.to_animated_zero()?))
            },
            AnimationValue::MaskPositionY(ref base) => {
                Ok(AnimationValue::MaskPositionY(base.to_animated_zero()?))
            },
            AnimationValue::MaskSize(ref base) => {
                Ok(AnimationValue::MaskSize(base.to_animated_zero()?))
            },
            AnimationValue::MozTabSize(ref base) => {
                Ok(AnimationValue::MozTabSize(base.to_animated_zero()?))
            },
            AnimationValue::OffsetPath(ref base) => {
                Ok(AnimationValue::OffsetPath(base.to_animated_zero()?))
            },
            AnimationValue::Perspective(ref base) => {
                Ok(AnimationValue::Perspective(base.to_animated_zero()?))
            },
            AnimationValue::Rotate(ref base) => {
                Ok(AnimationValue::Rotate(base.to_animated_zero()?))
            },
            AnimationValue::Scale(ref base) => {
                Ok(AnimationValue::Scale(base.to_animated_zero()?))
            },
            AnimationValue::ScrollbarColor(ref base) => {
                Ok(AnimationValue::ScrollbarColor(base.to_animated_zero()?))
            },
            AnimationValue::ShapeOutside(ref base) => {
                Ok(AnimationValue::ShapeOutside(base.to_animated_zero()?))
            },
            AnimationValue::StrokeDasharray(ref base) => {
                Ok(AnimationValue::StrokeDasharray(base.to_animated_zero()?))
            },
            AnimationValue::StrokeDashoffset(ref base) => {
                Ok(AnimationValue::StrokeDashoffset(base.to_animated_zero()?))
            },
            AnimationValue::StrokeWidth(ref base) => {
                Ok(AnimationValue::StrokeWidth(base.to_animated_zero()?))
            },
            AnimationValue::TextIndent(ref base) => {
                Ok(AnimationValue::TextIndent(base.to_animated_zero()?))
            },
            AnimationValue::TextShadow(ref base) => {
                Ok(AnimationValue::TextShadow(base.to_animated_zero()?))
            },
            AnimationValue::Translate(ref base) => {
                Ok(AnimationValue::Translate(base.to_animated_zero()?))
            },
            AnimationValue::VerticalAlign(ref base) => {
                Ok(AnimationValue::VerticalAlign(base.to_animated_zero()?))
            },
            AnimationValue::WordSpacing(ref base) => {
                Ok(AnimationValue::WordSpacing(base.to_animated_zero()?))
            },
            AnimationValue::Clip(ref base) => {
                Ok(AnimationValue::Clip(base.to_animated_zero()?))
            },
            AnimationValue::MozImageRegion(ref base) => {
                Ok(AnimationValue::MozImageRegion(base.to_animated_zero()?))
            },
            AnimationValue::GridTemplateColumns(ref base) => {
                Ok(AnimationValue::GridTemplateColumns(base.to_animated_zero()?))
            },
            AnimationValue::GridTemplateRows(ref base) => {
                Ok(AnimationValue::GridTemplateRows(base.to_animated_zero()?))
            },
            AnimationValue::Fill(ref base) => {
                Ok(AnimationValue::Fill(base.to_animated_zero()?))
            },
            AnimationValue::Stroke(ref base) => {
                Ok(AnimationValue::Stroke(base.to_animated_zero()?))
            },
            AnimationValue::MozWindowTransformOrigin(ref base) => {
                Ok(AnimationValue::MozWindowTransformOrigin(base.to_animated_zero()?))
            },
            AnimationValue::TransformOrigin(ref base) => {
                Ok(AnimationValue::TransformOrigin(base.to_animated_zero()?))
            },
            AnimationValue::MozWindowTransform(ref base) => {
                Ok(AnimationValue::MozWindowTransform(base.to_animated_zero()?))
            },
            AnimationValue::Transform(ref base) => {
                Ok(AnimationValue::Transform(base.to_animated_zero()?))
            },
            AnimationValue::ColumnGap(ref base) => {
                Ok(AnimationValue::ColumnGap(base.to_animated_zero()?))
            },
            AnimationValue::RowGap(ref base) => {
                Ok(AnimationValue::RowGap(base.to_animated_zero()?))
            },
            AnimationValue::ObjectPosition(ref base) => {
                Ok(AnimationValue::ObjectPosition(base.to_animated_zero()?))
            },
            AnimationValue::PerspectiveOrigin(ref base) => {
                Ok(AnimationValue::PerspectiveOrigin(base.to_animated_zero()?))
            },
            AnimationValue::MaxHeight(ref base) => {
                Ok(AnimationValue::MaxHeight(base.to_animated_zero()?))
            },
            AnimationValue::MaxWidth(ref base) => {
                Ok(AnimationValue::MaxWidth(base.to_animated_zero()?))
            },
            AnimationValue::ScrollPaddingBottom(ref base) => {
                Ok(AnimationValue::ScrollPaddingBottom(base.to_animated_zero()?))
            },
            AnimationValue::ScrollPaddingLeft(ref base) => {
                Ok(AnimationValue::ScrollPaddingLeft(base.to_animated_zero()?))
            },
            AnimationValue::ScrollPaddingRight(ref base) => {
                Ok(AnimationValue::ScrollPaddingRight(base.to_animated_zero()?))
            },
            AnimationValue::ScrollPaddingTop(ref base) => {
                Ok(AnimationValue::ScrollPaddingTop(base.to_animated_zero()?))
            },
            AnimationValue::Height(ref base) => {
                Ok(AnimationValue::Height(base.to_animated_zero()?))
            },
            AnimationValue::MinHeight(ref base) => {
                Ok(AnimationValue::MinHeight(base.to_animated_zero()?))
            },
            AnimationValue::MinWidth(ref base) => {
                Ok(AnimationValue::MinWidth(base.to_animated_zero()?))
            },
            AnimationValue::Width(ref base) => {
                Ok(AnimationValue::Width(base.to_animated_zero()?))
            },
            AnimationValue::OutlineOffset(ref base) => {
                Ok(AnimationValue::OutlineOffset(base.to_animated_zero()?))
            },
            AnimationValue::ScrollMarginBottom(ref base) => {
                Ok(AnimationValue::ScrollMarginBottom(base.to_animated_zero()?))
            },
            AnimationValue::ScrollMarginLeft(ref base) => {
                Ok(AnimationValue::ScrollMarginLeft(base.to_animated_zero()?))
            },
            AnimationValue::ScrollMarginRight(ref base) => {
                Ok(AnimationValue::ScrollMarginRight(base.to_animated_zero()?))
            },
            AnimationValue::ScrollMarginTop(ref base) => {
                Ok(AnimationValue::ScrollMarginTop(base.to_animated_zero()?))
            },
            AnimationValue::PaddingBottom(ref base) => {
                Ok(AnimationValue::PaddingBottom(base.to_animated_zero()?))
            },
            AnimationValue::PaddingLeft(ref base) => {
                Ok(AnimationValue::PaddingLeft(base.to_animated_zero()?))
            },
            AnimationValue::PaddingRight(ref base) => {
                Ok(AnimationValue::PaddingRight(base.to_animated_zero()?))
            },
            AnimationValue::PaddingTop(ref base) => {
                Ok(AnimationValue::PaddingTop(base.to_animated_zero()?))
            },
            AnimationValue::ShapeMargin(ref base) => {
                Ok(AnimationValue::ShapeMargin(base.to_animated_zero()?))
            },
            AnimationValue::BorderBottomWidth(ref base) => {
                Ok(AnimationValue::BorderBottomWidth(base.to_animated_zero()?))
            },
            AnimationValue::BorderLeftWidth(ref base) => {
                Ok(AnimationValue::BorderLeftWidth(base.to_animated_zero()?))
            },
            AnimationValue::BorderRightWidth(ref base) => {
                Ok(AnimationValue::BorderRightWidth(base.to_animated_zero()?))
            },
            AnimationValue::BorderTopWidth(ref base) => {
                Ok(AnimationValue::BorderTopWidth(base.to_animated_zero()?))
            },
            AnimationValue::ColumnRuleWidth(ref base) => {
                Ok(AnimationValue::ColumnRuleWidth(base.to_animated_zero()?))
            },
            AnimationValue::OutlineWidth(ref base) => {
                Ok(AnimationValue::OutlineWidth(base.to_animated_zero()?))
            },
            AnimationValue::BorderBottomLeftRadius(ref base) => {
                Ok(AnimationValue::BorderBottomLeftRadius(base.to_animated_zero()?))
            },
            AnimationValue::BorderBottomRightRadius(ref base) => {
                Ok(AnimationValue::BorderBottomRightRadius(base.to_animated_zero()?))
            },
            AnimationValue::BorderTopLeftRadius(ref base) => {
                Ok(AnimationValue::BorderTopLeftRadius(base.to_animated_zero()?))
            },
            AnimationValue::BorderTopRightRadius(ref base) => {
                Ok(AnimationValue::BorderTopRightRadius(base.to_animated_zero()?))
            },
            AnimationValue::MozOutlineRadiusBottomleft(ref base) => {
                Ok(AnimationValue::MozOutlineRadiusBottomleft(base.to_animated_zero()?))
            },
            AnimationValue::MozOutlineRadiusBottomright(ref base) => {
                Ok(AnimationValue::MozOutlineRadiusBottomright(base.to_animated_zero()?))
            },
            AnimationValue::MozOutlineRadiusTopleft(ref base) => {
                Ok(AnimationValue::MozOutlineRadiusTopleft(base.to_animated_zero()?))
            },
            AnimationValue::MozOutlineRadiusTopright(ref base) => {
                Ok(AnimationValue::MozOutlineRadiusTopright(base.to_animated_zero()?))
            },
            AnimationValue::Bottom(ref base) => {
                Ok(AnimationValue::Bottom(base.to_animated_zero()?))
            },
            AnimationValue::Left(ref base) => {
                Ok(AnimationValue::Left(base.to_animated_zero()?))
            },
            AnimationValue::MarginBottom(ref base) => {
                Ok(AnimationValue::MarginBottom(base.to_animated_zero()?))
            },
            AnimationValue::MarginLeft(ref base) => {
                Ok(AnimationValue::MarginLeft(base.to_animated_zero()?))
            },
            AnimationValue::MarginRight(ref base) => {
                Ok(AnimationValue::MarginRight(base.to_animated_zero()?))
            },
            AnimationValue::MarginTop(ref base) => {
                Ok(AnimationValue::MarginTop(base.to_animated_zero()?))
            },
            AnimationValue::Right(ref base) => {
                Ok(AnimationValue::Right(base.to_animated_zero()?))
            },
            AnimationValue::Top(ref base) => {
                Ok(AnimationValue::Top(base.to_animated_zero()?))
            },
            AnimationValue::BackgroundColor(ref base) => {
                Ok(AnimationValue::BackgroundColor(base.to_animated_zero()?))
            },
            AnimationValue::BorderBottomColor(ref base) => {
                Ok(AnimationValue::BorderBottomColor(base.to_animated_zero()?))
            },
            AnimationValue::BorderLeftColor(ref base) => {
                Ok(AnimationValue::BorderLeftColor(base.to_animated_zero()?))
            },
            AnimationValue::BorderRightColor(ref base) => {
                Ok(AnimationValue::BorderRightColor(base.to_animated_zero()?))
            },
            AnimationValue::BorderTopColor(ref base) => {
                Ok(AnimationValue::BorderTopColor(base.to_animated_zero()?))
            },
            AnimationValue::ColumnRuleColor(ref base) => {
                Ok(AnimationValue::ColumnRuleColor(base.to_animated_zero()?))
            },
            AnimationValue::FloodColor(ref base) => {
                Ok(AnimationValue::FloodColor(base.to_animated_zero()?))
            },
            AnimationValue::LightingColor(ref base) => {
                Ok(AnimationValue::LightingColor(base.to_animated_zero()?))
            },
            AnimationValue::OutlineColor(ref base) => {
                Ok(AnimationValue::OutlineColor(base.to_animated_zero()?))
            },
            AnimationValue::StopColor(ref base) => {
                Ok(AnimationValue::StopColor(base.to_animated_zero()?))
            },
            AnimationValue::TextDecorationColor(ref base) => {
                Ok(AnimationValue::TextDecorationColor(base.to_animated_zero()?))
            },
            AnimationValue::TextEmphasisColor(ref base) => {
                Ok(AnimationValue::TextEmphasisColor(base.to_animated_zero()?))
            },
            AnimationValue::WebkitTextFillColor(ref base) => {
                Ok(AnimationValue::WebkitTextFillColor(base.to_animated_zero()?))
            },
            AnimationValue::WebkitTextStrokeColor(ref base) => {
                Ok(AnimationValue::WebkitTextStrokeColor(base.to_animated_zero()?))
            },
            _ => Err(()),
        }
    }
}

/// A trait to abstract away the different kind of animations over a list that
/// there may be.
pub trait ListAnimation<T> : Sized {
    /// <https://drafts.csswg.org/css-transitions/#animtype-repeatable-list>
    fn animate_repeatable_list(&self, other: &Self, procedure: Procedure) -> Result<Self, ()>
    where
        T: Animate;

    /// <https://drafts.csswg.org/css-transitions/#animtype-repeatable-list>
    fn squared_distance_repeatable_list(&self, other: &Self) -> Result<SquaredDistance, ()>
    where
        T: ComputeSquaredDistance;

    /// This is the animation used for some of the types like shadows and
    /// filters, where the interpolation happens with the zero value if one of
    /// the sides is not present.
    fn animate_with_zero(&self, other: &Self, procedure: Procedure) -> Result<Self, ()>
    where
        T: Animate + Clone + ToAnimatedZero;

    /// This is the animation used for some of the types like shadows and
    /// filters, where the interpolation happens with the zero value if one of
    /// the sides is not present.
    fn squared_distance_with_zero(&self, other: &Self) -> Result<SquaredDistance, ()>
    where
        T: ToAnimatedZero + ComputeSquaredDistance;
}

macro_rules! animated_list_impl {
    (<$t:ident> for $ty:ty) => {
        impl<$t> ListAnimation<$t> for $ty {
            fn animate_repeatable_list(
                &self,
                other: &Self,
                procedure: Procedure,
            ) -> Result<Self, ()>
            where
                T: Animate,
            {
                // If the length of either list is zero, the least common multiple is undefined.
                if self.is_empty() || other.is_empty() {
                    return Err(());
                }
                use num_integer::lcm;
                let len = lcm(self.len(), other.len());
                self.iter().cycle().zip(other.iter().cycle()).take(len).map(|(this, other)| {
                    this.animate(other, procedure)
                }).collect()
            }

            fn squared_distance_repeatable_list(
                &self,
                other: &Self,
            ) -> Result<SquaredDistance, ()>
            where
                T: ComputeSquaredDistance,
            {
                if self.is_empty() || other.is_empty() {
                    return Err(());
                }
                use num_integer::lcm;
                let len = lcm(self.len(), other.len());
                self.iter().cycle().zip(other.iter().cycle()).take(len).map(|(this, other)| {
                    this.compute_squared_distance(other)
                }).sum()
            }

            fn animate_with_zero(
                &self,
                other: &Self,
                procedure: Procedure,
            ) -> Result<Self, ()>
            where
                T: Animate + Clone + ToAnimatedZero
            {
                if procedure == Procedure::Add {
                    return Ok(
                        self.iter().chain(other.iter()).cloned().collect()
                    );
                }
                self.iter().zip_longest(other.iter()).map(|it| {
                    match it {
                        EitherOrBoth::Both(this, other) => {
                            this.animate(other, procedure)
                        },
                        EitherOrBoth::Left(this) => {
                            this.animate(&this.to_animated_zero()?, procedure)
                        },
                        EitherOrBoth::Right(other) => {
                            other.to_animated_zero()?.animate(other, procedure)
                        }
                    }
                }).collect()
            }

            fn squared_distance_with_zero(
                &self,
                other: &Self,
            ) -> Result<SquaredDistance, ()>
            where
                T: ToAnimatedZero + ComputeSquaredDistance
            {
                self.iter().zip_longest(other.iter()).map(|it| {
                    match it {
                        EitherOrBoth::Both(this, other) => {
                            this.compute_squared_distance(other)
                        },
                        EitherOrBoth::Left(list) | EitherOrBoth::Right(list) => {
                            list.to_animated_zero()?.compute_squared_distance(list)
                        },
                    }
                }).sum()
            }
        }
    }
}

animated_list_impl!(<T> for crate::OwnedSlice<T>);
animated_list_impl!(<T> for SmallVec<[T; 1]>);
animated_list_impl!(<T> for Vec<T>);

/// <https://drafts.csswg.org/css-transitions/#animtype-visibility>
impl Animate for Visibility {
    #[inline]
    fn animate(&self, other: &Self, procedure: Procedure) -> Result<Self, ()> {
        let (this_weight, other_weight) = procedure.weights();
        match (*self, *other) {
            (Visibility::Visible, _) => {
                Ok(if this_weight > 0.0 { *self } else { *other })
            },
            (_, Visibility::Visible) => {
                Ok(if other_weight > 0.0 { *other } else { *self })
            },
            _ => Err(()),
        }
    }
}

impl ComputeSquaredDistance for Visibility {
    #[inline]
    fn compute_squared_distance(&self, other: &Self) -> Result<SquaredDistance, ()> {
        Ok(SquaredDistance::from_sqrt(if *self == *other { 0. } else { 1. }))
    }
}

impl ToAnimatedZero for Visibility {
    #[inline]
    fn to_animated_zero(&self) -> Result<Self, ()> {
        Err(())
    }
}

/// <https://drafts.csswg.org/css-transitions/#animtype-rect>
impl Animate for ClipRect {
    #[inline]
    fn animate(&self, other: &Self, procedure: Procedure) -> Result<Self, ()> {
        use crate::values::computed::LengthOrAuto;
        let animate_component = |this: &LengthOrAuto, other: &LengthOrAuto| {
            let result = this.animate(other, procedure)?;
            if let Procedure::Interpolate { .. } = procedure {
                return Ok(result);
            }
            if result.is_auto() {
                // FIXME(emilio): Why? A couple SMIL tests fail without this,
                // but it seems extremely fishy.
                return Err(());
            }
            Ok(result)
        };

        Ok(ClipRect {
            top: animate_component(&self.top, &other.top)?,
            right: animate_component(&self.right, &other.right)?,
            bottom: animate_component(&self.bottom, &other.bottom)?,
            left: animate_component(&self.left, &other.left)?,
        })
    }
}



/// <https://drafts.fxtf.org/filters/#animation-of-filters>
impl Animate for AnimatedFilter {
    fn animate(
        &self,
        other: &Self,
        procedure: Procedure,
    ) -> Result<Self, ()> {
        use crate::values::animated::animate_multiplicative_factor;
        match (self, other) {
            (&Filter::Blur(ref this), &Filter::Blur(ref other)) => {
                Ok(Filter::Blur(this.animate(other, procedure)?))
            },
            (&Filter::Grayscale(ref this), &Filter::Grayscale(ref other)) => {
                Ok(Filter::Grayscale(this.animate(other, procedure)?))
            },
            (&Filter::HueRotate(ref this), &Filter::HueRotate(ref other)) => {
                Ok(Filter::HueRotate(this.animate(other, procedure)?))
            },
            (&Filter::Invert(ref this), &Filter::Invert(ref other)) => {
                Ok(Filter::Invert(this.animate(other, procedure)?))
            },
            (&Filter::Sepia(ref this), &Filter::Sepia(ref other)) => {
                Ok(Filter::Sepia(this.animate(other, procedure)?))
            },
            (&Filter::Brightness(this), &Filter::Brightness(other)) => {
                Ok(Filter::Brightness(animate_multiplicative_factor(this, other, procedure)?))
            },
            (&Filter::Contrast(this), &Filter::Contrast(other)) => {
                Ok(Filter::Contrast(animate_multiplicative_factor(this, other, procedure)?))
            },
            (&Filter::Opacity(this), &Filter::Opacity(other)) => {
                Ok(Filter::Opacity(animate_multiplicative_factor(this, other, procedure)?))
            },
            (&Filter::Saturate(this), &Filter::Saturate(other)) => {
                Ok(Filter::Saturate(animate_multiplicative_factor(this, other, procedure)?))
            },
            (&Filter::DropShadow(ref this), &Filter::DropShadow(ref other)) => {
                Ok(Filter::DropShadow(this.animate(other, procedure)?))
            },
            _ => Err(()),
        }
    }
}

/// <http://dev.w3.org/csswg/css-transforms/#none-transform-animation>
impl ToAnimatedZero for AnimatedFilter {
    fn to_animated_zero(&self) -> Result<Self, ()> {
        match *self {
            Filter::Blur(ref this) => Ok(Filter::Blur(this.to_animated_zero()?)),
            Filter::Grayscale(ref this) => Ok(Filter::Grayscale(this.to_animated_zero()?)),
            Filter::HueRotate(ref this) => Ok(Filter::HueRotate(this.to_animated_zero()?)),
            Filter::Invert(ref this) => Ok(Filter::Invert(this.to_animated_zero()?)),
            Filter::Sepia(ref this) => Ok(Filter::Sepia(this.to_animated_zero()?)),
            Filter::Brightness(_) => Ok(Filter::Brightness(1.)),
            Filter::Contrast(_) => Ok(Filter::Contrast(1.)),
            Filter::Opacity(_) => Ok(Filter::Opacity(1.)),
            Filter::Saturate(_) => Ok(Filter::Saturate(1.)),
            Filter::DropShadow(ref this) => Ok(Filter::DropShadow(this.to_animated_zero()?)),
            _ => Err(()),
        }
    }
}

}

/// A longhand or shorthand property.
#[derive(Clone, Copy, Debug)]
pub struct NonCustomPropertyId(usize);

/// The length of all the non-custom properties.
pub const NON_CUSTOM_PROPERTY_ID_COUNT: usize =
    543;

#[allow(dead_code)]
unsafe fn static_assert_nscsspropertyid() {
    std::mem::transmute::<[u8; 0], [u8; nsCSSPropertyID::eCSSProperty_align_content as usize]>([0; 0]); // align-content
    std::mem::transmute::<[u8; 1], [u8; nsCSSPropertyID::eCSSProperty_align_items as usize]>([0; 1]); // align-items
    std::mem::transmute::<[u8; 2], [u8; nsCSSPropertyID::eCSSProperty_align_self as usize]>([0; 2]); // align-self
    std::mem::transmute::<[u8; 3], [u8; nsCSSPropertyID::eCSSProperty_backface_visibility as usize]>([0; 3]); // backface-visibility
    std::mem::transmute::<[u8; 4], [u8; nsCSSPropertyID::eCSSProperty_border_collapse as usize]>([0; 4]); // border-collapse
    std::mem::transmute::<[u8; 5], [u8; nsCSSPropertyID::eCSSProperty_border_image_repeat as usize]>([0; 5]); // border-image-repeat
    std::mem::transmute::<[u8; 6], [u8; nsCSSPropertyID::eCSSProperty_box_decoration_break as usize]>([0; 6]); // box-decoration-break
    std::mem::transmute::<[u8; 7], [u8; nsCSSPropertyID::eCSSProperty_box_sizing as usize]>([0; 7]); // box-sizing
    std::mem::transmute::<[u8; 8], [u8; nsCSSPropertyID::eCSSProperty_break_inside as usize]>([0; 8]); // break-inside
    std::mem::transmute::<[u8; 9], [u8; nsCSSPropertyID::eCSSProperty_caption_side as usize]>([0; 9]); // caption-side
    std::mem::transmute::<[u8; 10], [u8; nsCSSPropertyID::eCSSProperty_clear as usize]>([0; 10]); // clear
    std::mem::transmute::<[u8; 11], [u8; nsCSSPropertyID::eCSSProperty_color_adjust as usize]>([0; 11]); // color-adjust
    std::mem::transmute::<[u8; 12], [u8; nsCSSPropertyID::eCSSProperty_color_interpolation as usize]>([0; 12]); // color-interpolation
    std::mem::transmute::<[u8; 13], [u8; nsCSSPropertyID::eCSSProperty_color_interpolation_filters as usize]>([0; 13]); // color-interpolation-filters
    std::mem::transmute::<[u8; 14], [u8; nsCSSPropertyID::eCSSProperty_column_count as usize]>([0; 14]); // column-count
    std::mem::transmute::<[u8; 15], [u8; nsCSSPropertyID::eCSSProperty_column_fill as usize]>([0; 15]); // column-fill
    std::mem::transmute::<[u8; 16], [u8; nsCSSPropertyID::eCSSProperty_column_span as usize]>([0; 16]); // column-span
    std::mem::transmute::<[u8; 17], [u8; nsCSSPropertyID::eCSSProperty_contain as usize]>([0; 17]); // contain
    std::mem::transmute::<[u8; 18], [u8; nsCSSPropertyID::eCSSProperty_direction as usize]>([0; 18]); // direction
    std::mem::transmute::<[u8; 19], [u8; nsCSSPropertyID::eCSSProperty_display as usize]>([0; 19]); // display
    std::mem::transmute::<[u8; 20], [u8; nsCSSPropertyID::eCSSProperty_dominant_baseline as usize]>([0; 20]); // dominant-baseline
    std::mem::transmute::<[u8; 21], [u8; nsCSSPropertyID::eCSSProperty_empty_cells as usize]>([0; 21]); // empty-cells
    std::mem::transmute::<[u8; 22], [u8; nsCSSPropertyID::eCSSProperty_flex_direction as usize]>([0; 22]); // flex-direction
    std::mem::transmute::<[u8; 23], [u8; nsCSSPropertyID::eCSSProperty_flex_wrap as usize]>([0; 23]); // flex-wrap
    std::mem::transmute::<[u8; 24], [u8; nsCSSPropertyID::eCSSProperty_float as usize]>([0; 24]); // float
    std::mem::transmute::<[u8; 25], [u8; nsCSSPropertyID::eCSSProperty_font_kerning as usize]>([0; 25]); // font-kerning
    std::mem::transmute::<[u8; 26], [u8; nsCSSPropertyID::eCSSProperty_font_optical_sizing as usize]>([0; 26]); // font-optical-sizing
    std::mem::transmute::<[u8; 27], [u8; nsCSSPropertyID::eCSSProperty_font_size_adjust as usize]>([0; 27]); // font-size-adjust
    std::mem::transmute::<[u8; 28], [u8; nsCSSPropertyID::eCSSProperty_font_stretch as usize]>([0; 28]); // font-stretch
    std::mem::transmute::<[u8; 29], [u8; nsCSSPropertyID::eCSSProperty_font_style as usize]>([0; 29]); // font-style
    std::mem::transmute::<[u8; 30], [u8; nsCSSPropertyID::eCSSProperty_font_synthesis as usize]>([0; 30]); // font-synthesis
    std::mem::transmute::<[u8; 31], [u8; nsCSSPropertyID::eCSSProperty_font_variant_caps as usize]>([0; 31]); // font-variant-caps
    std::mem::transmute::<[u8; 32], [u8; nsCSSPropertyID::eCSSProperty_font_variant_east_asian as usize]>([0; 32]); // font-variant-east-asian
    std::mem::transmute::<[u8; 33], [u8; nsCSSPropertyID::eCSSProperty_font_variant_ligatures as usize]>([0; 33]); // font-variant-ligatures
    std::mem::transmute::<[u8; 34], [u8; nsCSSPropertyID::eCSSProperty_font_variant_numeric as usize]>([0; 34]); // font-variant-numeric
    std::mem::transmute::<[u8; 35], [u8; nsCSSPropertyID::eCSSProperty_font_variant_position as usize]>([0; 35]); // font-variant-position
    std::mem::transmute::<[u8; 36], [u8; nsCSSPropertyID::eCSSProperty_font_weight as usize]>([0; 36]); // font-weight
    std::mem::transmute::<[u8; 37], [u8; nsCSSPropertyID::eCSSProperty_grid_auto_flow as usize]>([0; 37]); // grid-auto-flow
    std::mem::transmute::<[u8; 38], [u8; nsCSSPropertyID::eCSSProperty_hyphens as usize]>([0; 38]); // hyphens
    std::mem::transmute::<[u8; 39], [u8; nsCSSPropertyID::eCSSProperty_image_orientation as usize]>([0; 39]); // image-orientation
    std::mem::transmute::<[u8; 40], [u8; nsCSSPropertyID::eCSSProperty_image_rendering as usize]>([0; 40]); // image-rendering
    std::mem::transmute::<[u8; 41], [u8; nsCSSPropertyID::eCSSProperty_ime_mode as usize]>([0; 41]); // ime-mode
    std::mem::transmute::<[u8; 42], [u8; nsCSSPropertyID::eCSSProperty_initial_letter as usize]>([0; 42]); // initial-letter
    std::mem::transmute::<[u8; 43], [u8; nsCSSPropertyID::eCSSProperty_isolation as usize]>([0; 43]); // isolation
    std::mem::transmute::<[u8; 44], [u8; nsCSSPropertyID::eCSSProperty_justify_content as usize]>([0; 44]); // justify-content
    std::mem::transmute::<[u8; 45], [u8; nsCSSPropertyID::eCSSProperty_justify_items as usize]>([0; 45]); // justify-items
    std::mem::transmute::<[u8; 46], [u8; nsCSSPropertyID::eCSSProperty_justify_self as usize]>([0; 46]); // justify-self
    std::mem::transmute::<[u8; 47], [u8; nsCSSPropertyID::eCSSProperty_list_style_position as usize]>([0; 47]); // list-style-position
    std::mem::transmute::<[u8; 48], [u8; nsCSSPropertyID::eCSSProperty_mask_type as usize]>([0; 48]); // mask-type
    std::mem::transmute::<[u8; 49], [u8; nsCSSPropertyID::eCSSProperty_mix_blend_mode as usize]>([0; 49]); // mix-blend-mode
    std::mem::transmute::<[u8; 50], [u8; nsCSSPropertyID::eCSSProperty__moz_appearance as usize]>([0; 50]); // -moz-appearance
    std::mem::transmute::<[u8; 51], [u8; nsCSSPropertyID::eCSSProperty__moz_box_align as usize]>([0; 51]); // -moz-box-align
    std::mem::transmute::<[u8; 52], [u8; nsCSSPropertyID::eCSSProperty__moz_box_direction as usize]>([0; 52]); // -moz-box-direction
    std::mem::transmute::<[u8; 53], [u8; nsCSSPropertyID::eCSSProperty__moz_box_orient as usize]>([0; 53]); // -moz-box-orient
    std::mem::transmute::<[u8; 54], [u8; nsCSSPropertyID::eCSSProperty__moz_box_pack as usize]>([0; 54]); // -moz-box-pack
    std::mem::transmute::<[u8; 55], [u8; nsCSSPropertyID::eCSSProperty__moz_control_character_visibility as usize]>([0; 55]); // -moz-control-character-visibility
    std::mem::transmute::<[u8; 56], [u8; nsCSSPropertyID::eCSSProperty__moz_float_edge as usize]>([0; 56]); // -moz-float-edge
    std::mem::transmute::<[u8; 57], [u8; nsCSSPropertyID::eCSSProperty__moz_force_broken_image_icon as usize]>([0; 57]); // -moz-force-broken-image-icon
    std::mem::transmute::<[u8; 58], [u8; nsCSSPropertyID::eCSSProperty__moz_list_reversed as usize]>([0; 58]); // -moz-list-reversed
    std::mem::transmute::<[u8; 59], [u8; nsCSSPropertyID::eCSSProperty__moz_math_display as usize]>([0; 59]); // -moz-math-display
    std::mem::transmute::<[u8; 60], [u8; nsCSSPropertyID::eCSSProperty__moz_math_variant as usize]>([0; 60]); // -moz-math-variant
    std::mem::transmute::<[u8; 61], [u8; nsCSSPropertyID::eCSSProperty__moz_min_font_size_ratio as usize]>([0; 61]); // -moz-min-font-size-ratio
    std::mem::transmute::<[u8; 62], [u8; nsCSSPropertyID::eCSSProperty__moz_orient as usize]>([0; 62]); // -moz-orient
    std::mem::transmute::<[u8; 63], [u8; nsCSSPropertyID::eCSSProperty__moz_osx_font_smoothing as usize]>([0; 63]); // -moz-osx-font-smoothing
    std::mem::transmute::<[u8; 64], [u8; nsCSSPropertyID::eCSSProperty__moz_script_level as usize]>([0; 64]); // -moz-script-level
    std::mem::transmute::<[u8; 65], [u8; nsCSSPropertyID::eCSSProperty__moz_script_min_size as usize]>([0; 65]); // -moz-script-min-size
    std::mem::transmute::<[u8; 66], [u8; nsCSSPropertyID::eCSSProperty__moz_script_size_multiplier as usize]>([0; 66]); // -moz-script-size-multiplier
    std::mem::transmute::<[u8; 67], [u8; nsCSSPropertyID::eCSSProperty__moz_stack_sizing as usize]>([0; 67]); // -moz-stack-sizing
    std::mem::transmute::<[u8; 68], [u8; nsCSSPropertyID::eCSSProperty__moz_text_size_adjust as usize]>([0; 68]); // -moz-text-size-adjust
    std::mem::transmute::<[u8; 69], [u8; nsCSSPropertyID::eCSSProperty__moz_top_layer as usize]>([0; 69]); // -moz-top-layer
    std::mem::transmute::<[u8; 70], [u8; nsCSSPropertyID::eCSSProperty__moz_user_focus as usize]>([0; 70]); // -moz-user-focus
    std::mem::transmute::<[u8; 71], [u8; nsCSSPropertyID::eCSSProperty__moz_user_input as usize]>([0; 71]); // -moz-user-input
    std::mem::transmute::<[u8; 72], [u8; nsCSSPropertyID::eCSSProperty__moz_user_modify as usize]>([0; 72]); // -moz-user-modify
    std::mem::transmute::<[u8; 73], [u8; nsCSSPropertyID::eCSSProperty__moz_user_select as usize]>([0; 73]); // -moz-user-select
    std::mem::transmute::<[u8; 74], [u8; nsCSSPropertyID::eCSSProperty__moz_window_dragging as usize]>([0; 74]); // -moz-window-dragging
    std::mem::transmute::<[u8; 75], [u8; nsCSSPropertyID::eCSSProperty__moz_window_shadow as usize]>([0; 75]); // -moz-window-shadow
    std::mem::transmute::<[u8; 76], [u8; nsCSSPropertyID::eCSSProperty_object_fit as usize]>([0; 76]); // object-fit
    std::mem::transmute::<[u8; 77], [u8; nsCSSPropertyID::eCSSProperty_outline_style as usize]>([0; 77]); // outline-style
    std::mem::transmute::<[u8; 78], [u8; nsCSSPropertyID::eCSSProperty_overflow_anchor as usize]>([0; 78]); // overflow-anchor
    std::mem::transmute::<[u8; 79], [u8; nsCSSPropertyID::eCSSProperty_overflow_wrap as usize]>([0; 79]); // overflow-wrap
    std::mem::transmute::<[u8; 80], [u8; nsCSSPropertyID::eCSSProperty_paint_order as usize]>([0; 80]); // paint-order
    std::mem::transmute::<[u8; 81], [u8; nsCSSPropertyID::eCSSProperty_pointer_events as usize]>([0; 81]); // pointer-events
    std::mem::transmute::<[u8; 82], [u8; nsCSSPropertyID::eCSSProperty_position as usize]>([0; 82]); // position
    std::mem::transmute::<[u8; 83], [u8; nsCSSPropertyID::eCSSProperty_resize as usize]>([0; 83]); // resize
    std::mem::transmute::<[u8; 84], [u8; nsCSSPropertyID::eCSSProperty_ruby_align as usize]>([0; 84]); // ruby-align
    std::mem::transmute::<[u8; 85], [u8; nsCSSPropertyID::eCSSProperty_ruby_position as usize]>([0; 85]); // ruby-position
    std::mem::transmute::<[u8; 86], [u8; nsCSSPropertyID::eCSSProperty_scroll_behavior as usize]>([0; 86]); // scroll-behavior
    std::mem::transmute::<[u8; 87], [u8; nsCSSPropertyID::eCSSProperty_scroll_snap_align as usize]>([0; 87]); // scroll-snap-align
    std::mem::transmute::<[u8; 88], [u8; nsCSSPropertyID::eCSSProperty_scroll_snap_type as usize]>([0; 88]); // scroll-snap-type
    std::mem::transmute::<[u8; 89], [u8; nsCSSPropertyID::eCSSProperty_scrollbar_width as usize]>([0; 89]); // scrollbar-width
    std::mem::transmute::<[u8; 90], [u8; nsCSSPropertyID::eCSSProperty_shape_rendering as usize]>([0; 90]); // shape-rendering
    std::mem::transmute::<[u8; 91], [u8; nsCSSPropertyID::eCSSProperty_stroke_linecap as usize]>([0; 91]); // stroke-linecap
    std::mem::transmute::<[u8; 92], [u8; nsCSSPropertyID::eCSSProperty_stroke_linejoin as usize]>([0; 92]); // stroke-linejoin
    std::mem::transmute::<[u8; 93], [u8; nsCSSPropertyID::eCSSProperty_table_layout as usize]>([0; 93]); // table-layout
    std::mem::transmute::<[u8; 94], [u8; nsCSSPropertyID::eCSSProperty_text_align as usize]>([0; 94]); // text-align
    std::mem::transmute::<[u8; 95], [u8; nsCSSPropertyID::eCSSProperty_text_align_last as usize]>([0; 95]); // text-align-last
    std::mem::transmute::<[u8; 96], [u8; nsCSSPropertyID::eCSSProperty_text_anchor as usize]>([0; 96]); // text-anchor
    std::mem::transmute::<[u8; 97], [u8; nsCSSPropertyID::eCSSProperty_text_combine_upright as usize]>([0; 97]); // text-combine-upright
    std::mem::transmute::<[u8; 98], [u8; nsCSSPropertyID::eCSSProperty_text_decoration_line as usize]>([0; 98]); // text-decoration-line
    std::mem::transmute::<[u8; 99], [u8; nsCSSPropertyID::eCSSProperty_text_decoration_style as usize]>([0; 99]); // text-decoration-style
    std::mem::transmute::<[u8; 100], [u8; nsCSSPropertyID::eCSSProperty_text_emphasis_position as usize]>([0; 100]); // text-emphasis-position
    std::mem::transmute::<[u8; 101], [u8; nsCSSPropertyID::eCSSProperty_text_justify as usize]>([0; 101]); // text-justify
    std::mem::transmute::<[u8; 102], [u8; nsCSSPropertyID::eCSSProperty_text_orientation as usize]>([0; 102]); // text-orientation
    std::mem::transmute::<[u8; 103], [u8; nsCSSPropertyID::eCSSProperty_text_rendering as usize]>([0; 103]); // text-rendering
    std::mem::transmute::<[u8; 104], [u8; nsCSSPropertyID::eCSSProperty_text_transform as usize]>([0; 104]); // text-transform
    std::mem::transmute::<[u8; 105], [u8; nsCSSPropertyID::eCSSProperty_touch_action as usize]>([0; 105]); // touch-action
    std::mem::transmute::<[u8; 106], [u8; nsCSSPropertyID::eCSSProperty_transform_box as usize]>([0; 106]); // transform-box
    std::mem::transmute::<[u8; 107], [u8; nsCSSPropertyID::eCSSProperty_transform_style as usize]>([0; 107]); // transform-style
    std::mem::transmute::<[u8; 108], [u8; nsCSSPropertyID::eCSSProperty_unicode_bidi as usize]>([0; 108]); // unicode-bidi
    std::mem::transmute::<[u8; 109], [u8; nsCSSPropertyID::eCSSProperty_vector_effect as usize]>([0; 109]); // vector-effect
    std::mem::transmute::<[u8; 110], [u8; nsCSSPropertyID::eCSSProperty_visibility as usize]>([0; 110]); // visibility
    std::mem::transmute::<[u8; 111], [u8; nsCSSPropertyID::eCSSProperty__webkit_line_clamp as usize]>([0; 111]); // -webkit-line-clamp
    std::mem::transmute::<[u8; 112], [u8; nsCSSPropertyID::eCSSProperty_white_space as usize]>([0; 112]); // white-space
    std::mem::transmute::<[u8; 113], [u8; nsCSSPropertyID::eCSSProperty_word_break as usize]>([0; 113]); // word-break
    std::mem::transmute::<[u8; 114], [u8; nsCSSPropertyID::eCSSProperty_writing_mode as usize]>([0; 114]); // writing-mode
    std::mem::transmute::<[u8; 115], [u8; nsCSSPropertyID::eCSSProperty__x_span as usize]>([0; 115]); // -x-span
    std::mem::transmute::<[u8; 116], [u8; nsCSSPropertyID::eCSSProperty__x_text_zoom as usize]>([0; 116]); // -x-text-zoom
    std::mem::transmute::<[u8; 117], [u8; nsCSSPropertyID::eCSSProperty_z_index as usize]>([0; 117]); // z-index
    std::mem::transmute::<[u8; 118], [u8; nsCSSPropertyID::eCSSProperty_break_after as usize]>([0; 118]); // break-after
    std::mem::transmute::<[u8; 119], [u8; nsCSSPropertyID::eCSSProperty_break_before as usize]>([0; 119]); // break-before
    std::mem::transmute::<[u8; 120], [u8; nsCSSPropertyID::eCSSProperty_clip_rule as usize]>([0; 120]); // clip-rule
    std::mem::transmute::<[u8; 121], [u8; nsCSSPropertyID::eCSSProperty_fill_rule as usize]>([0; 121]); // fill-rule
    std::mem::transmute::<[u8; 122], [u8; nsCSSPropertyID::eCSSProperty__moz_box_ordinal_group as usize]>([0; 122]); // -moz-box-ordinal-group
    std::mem::transmute::<[u8; 123], [u8; nsCSSPropertyID::eCSSProperty_order as usize]>([0; 123]); // order
    std::mem::transmute::<[u8; 124], [u8; nsCSSPropertyID::eCSSProperty_overflow_x as usize]>([0; 124]); // overflow-x
    std::mem::transmute::<[u8; 125], [u8; nsCSSPropertyID::eCSSProperty_overflow_y as usize]>([0; 125]); // overflow-y
    std::mem::transmute::<[u8; 126], [u8; nsCSSPropertyID::eCSSProperty_overflow_clip_box_block as usize]>([0; 126]); // overflow-clip-box-block
    std::mem::transmute::<[u8; 127], [u8; nsCSSPropertyID::eCSSProperty_overflow_clip_box_inline as usize]>([0; 127]); // overflow-clip-box-inline
    std::mem::transmute::<[u8; 128], [u8; nsCSSPropertyID::eCSSProperty_overscroll_behavior_x as usize]>([0; 128]); // overscroll-behavior-x
    std::mem::transmute::<[u8; 129], [u8; nsCSSPropertyID::eCSSProperty_overscroll_behavior_y as usize]>([0; 129]); // overscroll-behavior-y
    std::mem::transmute::<[u8; 130], [u8; nsCSSPropertyID::eCSSProperty_fill_opacity as usize]>([0; 130]); // fill-opacity
    std::mem::transmute::<[u8; 131], [u8; nsCSSPropertyID::eCSSProperty_stroke_opacity as usize]>([0; 131]); // stroke-opacity
    std::mem::transmute::<[u8; 132], [u8; nsCSSPropertyID::eCSSProperty_flex_grow as usize]>([0; 132]); // flex-grow
    std::mem::transmute::<[u8; 133], [u8; nsCSSPropertyID::eCSSProperty_flex_shrink as usize]>([0; 133]); // flex-shrink
    std::mem::transmute::<[u8; 134], [u8; nsCSSPropertyID::eCSSProperty__moz_box_flex as usize]>([0; 134]); // -moz-box-flex
    std::mem::transmute::<[u8; 135], [u8; nsCSSPropertyID::eCSSProperty_stroke_miterlimit as usize]>([0; 135]); // stroke-miterlimit
    std::mem::transmute::<[u8; 136], [u8; nsCSSPropertyID::eCSSProperty_flood_opacity as usize]>([0; 136]); // flood-opacity
    std::mem::transmute::<[u8; 137], [u8; nsCSSPropertyID::eCSSProperty__moz_window_opacity as usize]>([0; 137]); // -moz-window-opacity
    std::mem::transmute::<[u8; 138], [u8; nsCSSPropertyID::eCSSProperty_opacity as usize]>([0; 138]); // opacity
    std::mem::transmute::<[u8; 139], [u8; nsCSSPropertyID::eCSSProperty_shape_image_threshold as usize]>([0; 139]); // shape-image-threshold
    std::mem::transmute::<[u8; 140], [u8; nsCSSPropertyID::eCSSProperty_stop_opacity as usize]>([0; 140]); // stop-opacity
    std::mem::transmute::<[u8; 141], [u8; nsCSSPropertyID::eCSSProperty_border_block_end_style as usize]>([0; 141]); // border-block-end-style
    std::mem::transmute::<[u8; 142], [u8; nsCSSPropertyID::eCSSProperty_border_block_start_style as usize]>([0; 142]); // border-block-start-style
    std::mem::transmute::<[u8; 143], [u8; nsCSSPropertyID::eCSSProperty_border_bottom_style as usize]>([0; 143]); // border-bottom-style
    std::mem::transmute::<[u8; 144], [u8; nsCSSPropertyID::eCSSProperty_border_inline_end_style as usize]>([0; 144]); // border-inline-end-style
    std::mem::transmute::<[u8; 145], [u8; nsCSSPropertyID::eCSSProperty_border_inline_start_style as usize]>([0; 145]); // border-inline-start-style
    std::mem::transmute::<[u8; 146], [u8; nsCSSPropertyID::eCSSProperty_border_left_style as usize]>([0; 146]); // border-left-style
    std::mem::transmute::<[u8; 147], [u8; nsCSSPropertyID::eCSSProperty_border_right_style as usize]>([0; 147]); // border-right-style
    std::mem::transmute::<[u8; 148], [u8; nsCSSPropertyID::eCSSProperty_border_top_style as usize]>([0; 148]); // border-top-style
    std::mem::transmute::<[u8; 149], [u8; nsCSSPropertyID::eCSSProperty_column_rule_style as usize]>([0; 149]); // column-rule-style
    std::mem::transmute::<[u8; 150], [u8; nsCSSPropertyID::eCSSProperty_animation_delay as usize]>([0; 150]); // animation-delay
    std::mem::transmute::<[u8; 151], [u8; nsCSSPropertyID::eCSSProperty_animation_direction as usize]>([0; 151]); // animation-direction
    std::mem::transmute::<[u8; 152], [u8; nsCSSPropertyID::eCSSProperty_animation_duration as usize]>([0; 152]); // animation-duration
    std::mem::transmute::<[u8; 153], [u8; nsCSSPropertyID::eCSSProperty_animation_fill_mode as usize]>([0; 153]); // animation-fill-mode
    std::mem::transmute::<[u8; 154], [u8; nsCSSPropertyID::eCSSProperty_animation_iteration_count as usize]>([0; 154]); // animation-iteration-count
    std::mem::transmute::<[u8; 155], [u8; nsCSSPropertyID::eCSSProperty_animation_name as usize]>([0; 155]); // animation-name
    std::mem::transmute::<[u8; 156], [u8; nsCSSPropertyID::eCSSProperty_animation_play_state as usize]>([0; 156]); // animation-play-state
    std::mem::transmute::<[u8; 157], [u8; nsCSSPropertyID::eCSSProperty_animation_timing_function as usize]>([0; 157]); // animation-timing-function
    std::mem::transmute::<[u8; 158], [u8; nsCSSPropertyID::eCSSProperty_background_attachment as usize]>([0; 158]); // background-attachment
    std::mem::transmute::<[u8; 159], [u8; nsCSSPropertyID::eCSSProperty_background_blend_mode as usize]>([0; 159]); // background-blend-mode
    std::mem::transmute::<[u8; 160], [u8; nsCSSPropertyID::eCSSProperty_background_clip as usize]>([0; 160]); // background-clip
    std::mem::transmute::<[u8; 161], [u8; nsCSSPropertyID::eCSSProperty_background_image as usize]>([0; 161]); // background-image
    std::mem::transmute::<[u8; 162], [u8; nsCSSPropertyID::eCSSProperty_background_origin as usize]>([0; 162]); // background-origin
    std::mem::transmute::<[u8; 163], [u8; nsCSSPropertyID::eCSSProperty_background_position_x as usize]>([0; 163]); // background-position-x
    std::mem::transmute::<[u8; 164], [u8; nsCSSPropertyID::eCSSProperty_background_position_y as usize]>([0; 164]); // background-position-y
    std::mem::transmute::<[u8; 165], [u8; nsCSSPropertyID::eCSSProperty_background_repeat as usize]>([0; 165]); // background-repeat
    std::mem::transmute::<[u8; 166], [u8; nsCSSPropertyID::eCSSProperty_background_size as usize]>([0; 166]); // background-size
    std::mem::transmute::<[u8; 167], [u8; nsCSSPropertyID::eCSSProperty_border_image_outset as usize]>([0; 167]); // border-image-outset
    std::mem::transmute::<[u8; 168], [u8; nsCSSPropertyID::eCSSProperty_border_image_slice as usize]>([0; 168]); // border-image-slice
    std::mem::transmute::<[u8; 169], [u8; nsCSSPropertyID::eCSSProperty_border_image_source as usize]>([0; 169]); // border-image-source
    std::mem::transmute::<[u8; 170], [u8; nsCSSPropertyID::eCSSProperty_border_image_width as usize]>([0; 170]); // border-image-width
    std::mem::transmute::<[u8; 171], [u8; nsCSSPropertyID::eCSSProperty_border_spacing as usize]>([0; 171]); // border-spacing
    std::mem::transmute::<[u8; 172], [u8; nsCSSPropertyID::eCSSProperty_box_shadow as usize]>([0; 172]); // box-shadow
    std::mem::transmute::<[u8; 173], [u8; nsCSSPropertyID::eCSSProperty_caret_color as usize]>([0; 173]); // caret-color
    std::mem::transmute::<[u8; 174], [u8; nsCSSPropertyID::eCSSProperty_clip_path as usize]>([0; 174]); // clip-path
    std::mem::transmute::<[u8; 175], [u8; nsCSSPropertyID::eCSSProperty_color as usize]>([0; 175]); // color
    std::mem::transmute::<[u8; 176], [u8; nsCSSPropertyID::eCSSProperty_column_width as usize]>([0; 176]); // column-width
    std::mem::transmute::<[u8; 177], [u8; nsCSSPropertyID::eCSSProperty_content as usize]>([0; 177]); // content
    std::mem::transmute::<[u8; 178], [u8; nsCSSPropertyID::eCSSProperty_counter_increment as usize]>([0; 178]); // counter-increment
    std::mem::transmute::<[u8; 179], [u8; nsCSSPropertyID::eCSSProperty_cursor as usize]>([0; 179]); // cursor
    std::mem::transmute::<[u8; 180], [u8; nsCSSPropertyID::eCSSProperty_filter as usize]>([0; 180]); // filter
    std::mem::transmute::<[u8; 181], [u8; nsCSSPropertyID::eCSSProperty_flex_basis as usize]>([0; 181]); // flex-basis
    std::mem::transmute::<[u8; 182], [u8; nsCSSPropertyID::eCSSProperty_font_family as usize]>([0; 182]); // font-family
    std::mem::transmute::<[u8; 183], [u8; nsCSSPropertyID::eCSSProperty_font_feature_settings as usize]>([0; 183]); // font-feature-settings
    std::mem::transmute::<[u8; 184], [u8; nsCSSPropertyID::eCSSProperty_font_language_override as usize]>([0; 184]); // font-language-override
    std::mem::transmute::<[u8; 185], [u8; nsCSSPropertyID::eCSSProperty_font_size as usize]>([0; 185]); // font-size
    std::mem::transmute::<[u8; 186], [u8; nsCSSPropertyID::eCSSProperty_font_variant_alternates as usize]>([0; 186]); // font-variant-alternates
    std::mem::transmute::<[u8; 187], [u8; nsCSSPropertyID::eCSSProperty_font_variation_settings as usize]>([0; 187]); // font-variation-settings
    std::mem::transmute::<[u8; 188], [u8; nsCSSPropertyID::eCSSProperty_grid_template_areas as usize]>([0; 188]); // grid-template-areas
    std::mem::transmute::<[u8; 189], [u8; nsCSSPropertyID::eCSSProperty_letter_spacing as usize]>([0; 189]); // letter-spacing
    std::mem::transmute::<[u8; 190], [u8; nsCSSPropertyID::eCSSProperty_line_height as usize]>([0; 190]); // line-height
    std::mem::transmute::<[u8; 191], [u8; nsCSSPropertyID::eCSSProperty_list_style_image as usize]>([0; 191]); // list-style-image
    std::mem::transmute::<[u8; 192], [u8; nsCSSPropertyID::eCSSProperty_list_style_type as usize]>([0; 192]); // list-style-type
    std::mem::transmute::<[u8; 193], [u8; nsCSSPropertyID::eCSSProperty_mask_clip as usize]>([0; 193]); // mask-clip
    std::mem::transmute::<[u8; 194], [u8; nsCSSPropertyID::eCSSProperty_mask_composite as usize]>([0; 194]); // mask-composite
    std::mem::transmute::<[u8; 195], [u8; nsCSSPropertyID::eCSSProperty_mask_image as usize]>([0; 195]); // mask-image
    std::mem::transmute::<[u8; 196], [u8; nsCSSPropertyID::eCSSProperty_mask_mode as usize]>([0; 196]); // mask-mode
    std::mem::transmute::<[u8; 197], [u8; nsCSSPropertyID::eCSSProperty_mask_origin as usize]>([0; 197]); // mask-origin
    std::mem::transmute::<[u8; 198], [u8; nsCSSPropertyID::eCSSProperty_mask_position_x as usize]>([0; 198]); // mask-position-x
    std::mem::transmute::<[u8; 199], [u8; nsCSSPropertyID::eCSSProperty_mask_position_y as usize]>([0; 199]); // mask-position-y
    std::mem::transmute::<[u8; 200], [u8; nsCSSPropertyID::eCSSProperty_mask_repeat as usize]>([0; 200]); // mask-repeat
    std::mem::transmute::<[u8; 201], [u8; nsCSSPropertyID::eCSSProperty_mask_size as usize]>([0; 201]); // mask-size
    std::mem::transmute::<[u8; 202], [u8; nsCSSPropertyID::eCSSProperty__moz_context_properties as usize]>([0; 202]); // -moz-context-properties
    std::mem::transmute::<[u8; 203], [u8; nsCSSPropertyID::eCSSProperty__moz_font_smoothing_background_color as usize]>([0; 203]); // -moz-font-smoothing-background-color
    std::mem::transmute::<[u8; 204], [u8; nsCSSPropertyID::eCSSProperty__moz_tab_size as usize]>([0; 204]); // -moz-tab-size
    std::mem::transmute::<[u8; 205], [u8; nsCSSPropertyID::eCSSProperty_offset_path as usize]>([0; 205]); // offset-path
    std::mem::transmute::<[u8; 206], [u8; nsCSSPropertyID::eCSSProperty_perspective as usize]>([0; 206]); // perspective
    std::mem::transmute::<[u8; 207], [u8; nsCSSPropertyID::eCSSProperty_quotes as usize]>([0; 207]); // quotes
    std::mem::transmute::<[u8; 208], [u8; nsCSSPropertyID::eCSSProperty_rotate as usize]>([0; 208]); // rotate
    std::mem::transmute::<[u8; 209], [u8; nsCSSPropertyID::eCSSProperty_scale as usize]>([0; 209]); // scale
    std::mem::transmute::<[u8; 210], [u8; nsCSSPropertyID::eCSSProperty_scroll_snap_coordinate as usize]>([0; 210]); // scroll-snap-coordinate
    std::mem::transmute::<[u8; 211], [u8; nsCSSPropertyID::eCSSProperty_scrollbar_color as usize]>([0; 211]); // scrollbar-color
    std::mem::transmute::<[u8; 212], [u8; nsCSSPropertyID::eCSSProperty_shape_outside as usize]>([0; 212]); // shape-outside
    std::mem::transmute::<[u8; 213], [u8; nsCSSPropertyID::eCSSProperty_stroke_dasharray as usize]>([0; 213]); // stroke-dasharray
    std::mem::transmute::<[u8; 214], [u8; nsCSSPropertyID::eCSSProperty_stroke_dashoffset as usize]>([0; 214]); // stroke-dashoffset
    std::mem::transmute::<[u8; 215], [u8; nsCSSPropertyID::eCSSProperty_stroke_width as usize]>([0; 215]); // stroke-width
    std::mem::transmute::<[u8; 216], [u8; nsCSSPropertyID::eCSSProperty_text_emphasis_style as usize]>([0; 216]); // text-emphasis-style
    std::mem::transmute::<[u8; 217], [u8; nsCSSPropertyID::eCSSProperty_text_indent as usize]>([0; 217]); // text-indent
    std::mem::transmute::<[u8; 218], [u8; nsCSSPropertyID::eCSSProperty_text_overflow as usize]>([0; 218]); // text-overflow
    std::mem::transmute::<[u8; 219], [u8; nsCSSPropertyID::eCSSProperty_text_shadow as usize]>([0; 219]); // text-shadow
    std::mem::transmute::<[u8; 220], [u8; nsCSSPropertyID::eCSSProperty_transition_delay as usize]>([0; 220]); // transition-delay
    std::mem::transmute::<[u8; 221], [u8; nsCSSPropertyID::eCSSProperty_transition_duration as usize]>([0; 221]); // transition-duration
    std::mem::transmute::<[u8; 222], [u8; nsCSSPropertyID::eCSSProperty_transition_property as usize]>([0; 222]); // transition-property
    std::mem::transmute::<[u8; 223], [u8; nsCSSPropertyID::eCSSProperty_transition_timing_function as usize]>([0; 223]); // transition-timing-function
    std::mem::transmute::<[u8; 224], [u8; nsCSSPropertyID::eCSSProperty_translate as usize]>([0; 224]); // translate
    std::mem::transmute::<[u8; 225], [u8; nsCSSPropertyID::eCSSProperty_vertical_align as usize]>([0; 225]); // vertical-align
    std::mem::transmute::<[u8; 226], [u8; nsCSSPropertyID::eCSSProperty_will_change as usize]>([0; 226]); // will-change
    std::mem::transmute::<[u8; 227], [u8; nsCSSPropertyID::eCSSProperty_word_spacing as usize]>([0; 227]); // word-spacing
    std::mem::transmute::<[u8; 228], [u8; nsCSSPropertyID::eCSSProperty__x_lang as usize]>([0; 228]); // -x-lang
    std::mem::transmute::<[u8; 229], [u8; nsCSSPropertyID::eCSSProperty_clip as usize]>([0; 229]); // clip
    std::mem::transmute::<[u8; 230], [u8; nsCSSPropertyID::eCSSProperty__moz_image_region as usize]>([0; 230]); // -moz-image-region
    std::mem::transmute::<[u8; 231], [u8; nsCSSPropertyID::eCSSProperty_grid_template_columns as usize]>([0; 231]); // grid-template-columns
    std::mem::transmute::<[u8; 232], [u8; nsCSSPropertyID::eCSSProperty_grid_template_rows as usize]>([0; 232]); // grid-template-rows
    std::mem::transmute::<[u8; 233], [u8; nsCSSPropertyID::eCSSProperty_fill as usize]>([0; 233]); // fill
    std::mem::transmute::<[u8; 234], [u8; nsCSSPropertyID::eCSSProperty_stroke as usize]>([0; 234]); // stroke
    std::mem::transmute::<[u8; 235], [u8; nsCSSPropertyID::eCSSProperty_grid_auto_columns as usize]>([0; 235]); // grid-auto-columns
    std::mem::transmute::<[u8; 236], [u8; nsCSSPropertyID::eCSSProperty_grid_auto_rows as usize]>([0; 236]); // grid-auto-rows
    std::mem::transmute::<[u8; 237], [u8; nsCSSPropertyID::eCSSProperty__moz_window_transform_origin as usize]>([0; 237]); // -moz-window-transform-origin
    std::mem::transmute::<[u8; 238], [u8; nsCSSPropertyID::eCSSProperty_transform_origin as usize]>([0; 238]); // transform-origin
    std::mem::transmute::<[u8; 239], [u8; nsCSSPropertyID::eCSSProperty_counter_reset as usize]>([0; 239]); // counter-reset
    std::mem::transmute::<[u8; 240], [u8; nsCSSPropertyID::eCSSProperty_counter_set as usize]>([0; 240]); // counter-set
    std::mem::transmute::<[u8; 241], [u8; nsCSSPropertyID::eCSSProperty_scroll_snap_points_x as usize]>([0; 241]); // scroll-snap-points-x
    std::mem::transmute::<[u8; 242], [u8; nsCSSPropertyID::eCSSProperty_scroll_snap_points_y as usize]>([0; 242]); // scroll-snap-points-y
    std::mem::transmute::<[u8; 243], [u8; nsCSSPropertyID::eCSSProperty__moz_window_transform as usize]>([0; 243]); // -moz-window-transform
    std::mem::transmute::<[u8; 244], [u8; nsCSSPropertyID::eCSSProperty_transform as usize]>([0; 244]); // transform
    std::mem::transmute::<[u8; 245], [u8; nsCSSPropertyID::eCSSProperty_column_gap as usize]>([0; 245]); // column-gap
    std::mem::transmute::<[u8; 246], [u8; nsCSSPropertyID::eCSSProperty_row_gap as usize]>([0; 246]); // row-gap
    std::mem::transmute::<[u8; 247], [u8; nsCSSPropertyID::eCSSProperty_object_position as usize]>([0; 247]); // object-position
    std::mem::transmute::<[u8; 248], [u8; nsCSSPropertyID::eCSSProperty_perspective_origin as usize]>([0; 248]); // perspective-origin
    std::mem::transmute::<[u8; 249], [u8; nsCSSPropertyID::eCSSProperty_scroll_snap_destination as usize]>([0; 249]); // scroll-snap-destination
    std::mem::transmute::<[u8; 250], [u8; nsCSSPropertyID::eCSSProperty_grid_column_end as usize]>([0; 250]); // grid-column-end
    std::mem::transmute::<[u8; 251], [u8; nsCSSPropertyID::eCSSProperty_grid_column_start as usize]>([0; 251]); // grid-column-start
    std::mem::transmute::<[u8; 252], [u8; nsCSSPropertyID::eCSSProperty_grid_row_end as usize]>([0; 252]); // grid-row-end
    std::mem::transmute::<[u8; 253], [u8; nsCSSPropertyID::eCSSProperty_grid_row_start as usize]>([0; 253]); // grid-row-start
    std::mem::transmute::<[u8; 254], [u8; nsCSSPropertyID::eCSSProperty_max_block_size as usize]>([0; 254]); // max-block-size
    std::mem::transmute::<[u8; 255], [u8; nsCSSPropertyID::eCSSProperty_max_height as usize]>([0; 255]); // max-height
    std::mem::transmute::<[u8; 256], [u8; nsCSSPropertyID::eCSSProperty_max_inline_size as usize]>([0; 256]); // max-inline-size
    std::mem::transmute::<[u8; 257], [u8; nsCSSPropertyID::eCSSProperty_max_width as usize]>([0; 257]); // max-width
    std::mem::transmute::<[u8; 258], [u8; nsCSSPropertyID::eCSSProperty_marker_end as usize]>([0; 258]); // marker-end
    std::mem::transmute::<[u8; 259], [u8; nsCSSPropertyID::eCSSProperty_marker_mid as usize]>([0; 259]); // marker-mid
    std::mem::transmute::<[u8; 260], [u8; nsCSSPropertyID::eCSSProperty_marker_start as usize]>([0; 260]); // marker-start
    std::mem::transmute::<[u8; 261], [u8; nsCSSPropertyID::eCSSProperty__moz_binding as usize]>([0; 261]); // -moz-binding
    std::mem::transmute::<[u8; 262], [u8; nsCSSPropertyID::eCSSProperty_scroll_padding_block_end as usize]>([0; 262]); // scroll-padding-block-end
    std::mem::transmute::<[u8; 263], [u8; nsCSSPropertyID::eCSSProperty_scroll_padding_block_start as usize]>([0; 263]); // scroll-padding-block-start
    std::mem::transmute::<[u8; 264], [u8; nsCSSPropertyID::eCSSProperty_scroll_padding_bottom as usize]>([0; 264]); // scroll-padding-bottom
    std::mem::transmute::<[u8; 265], [u8; nsCSSPropertyID::eCSSProperty_scroll_padding_inline_end as usize]>([0; 265]); // scroll-padding-inline-end
    std::mem::transmute::<[u8; 266], [u8; nsCSSPropertyID::eCSSProperty_scroll_padding_inline_start as usize]>([0; 266]); // scroll-padding-inline-start
    std::mem::transmute::<[u8; 267], [u8; nsCSSPropertyID::eCSSProperty_scroll_padding_left as usize]>([0; 267]); // scroll-padding-left
    std::mem::transmute::<[u8; 268], [u8; nsCSSPropertyID::eCSSProperty_scroll_padding_right as usize]>([0; 268]); // scroll-padding-right
    std::mem::transmute::<[u8; 269], [u8; nsCSSPropertyID::eCSSProperty_scroll_padding_top as usize]>([0; 269]); // scroll-padding-top
    std::mem::transmute::<[u8; 270], [u8; nsCSSPropertyID::eCSSProperty_block_size as usize]>([0; 270]); // block-size
    std::mem::transmute::<[u8; 271], [u8; nsCSSPropertyID::eCSSProperty_height as usize]>([0; 271]); // height
    std::mem::transmute::<[u8; 272], [u8; nsCSSPropertyID::eCSSProperty_inline_size as usize]>([0; 272]); // inline-size
    std::mem::transmute::<[u8; 273], [u8; nsCSSPropertyID::eCSSProperty_min_block_size as usize]>([0; 273]); // min-block-size
    std::mem::transmute::<[u8; 274], [u8; nsCSSPropertyID::eCSSProperty_min_height as usize]>([0; 274]); // min-height
    std::mem::transmute::<[u8; 275], [u8; nsCSSPropertyID::eCSSProperty_min_inline_size as usize]>([0; 275]); // min-inline-size
    std::mem::transmute::<[u8; 276], [u8; nsCSSPropertyID::eCSSProperty_min_width as usize]>([0; 276]); // min-width
    std::mem::transmute::<[u8; 277], [u8; nsCSSPropertyID::eCSSProperty_width as usize]>([0; 277]); // width
    std::mem::transmute::<[u8; 278], [u8; nsCSSPropertyID::eCSSProperty_outline_offset as usize]>([0; 278]); // outline-offset
    std::mem::transmute::<[u8; 279], [u8; nsCSSPropertyID::eCSSProperty_scroll_margin_block_end as usize]>([0; 279]); // scroll-margin-block-end
    std::mem::transmute::<[u8; 280], [u8; nsCSSPropertyID::eCSSProperty_scroll_margin_block_start as usize]>([0; 280]); // scroll-margin-block-start
    std::mem::transmute::<[u8; 281], [u8; nsCSSPropertyID::eCSSProperty_scroll_margin_bottom as usize]>([0; 281]); // scroll-margin-bottom
    std::mem::transmute::<[u8; 282], [u8; nsCSSPropertyID::eCSSProperty_scroll_margin_inline_end as usize]>([0; 282]); // scroll-margin-inline-end
    std::mem::transmute::<[u8; 283], [u8; nsCSSPropertyID::eCSSProperty_scroll_margin_inline_start as usize]>([0; 283]); // scroll-margin-inline-start
    std::mem::transmute::<[u8; 284], [u8; nsCSSPropertyID::eCSSProperty_scroll_margin_left as usize]>([0; 284]); // scroll-margin-left
    std::mem::transmute::<[u8; 285], [u8; nsCSSPropertyID::eCSSProperty_scroll_margin_right as usize]>([0; 285]); // scroll-margin-right
    std::mem::transmute::<[u8; 286], [u8; nsCSSPropertyID::eCSSProperty_scroll_margin_top as usize]>([0; 286]); // scroll-margin-top
    std::mem::transmute::<[u8; 287], [u8; nsCSSPropertyID::eCSSProperty_padding_block_end as usize]>([0; 287]); // padding-block-end
    std::mem::transmute::<[u8; 288], [u8; nsCSSPropertyID::eCSSProperty_padding_block_start as usize]>([0; 288]); // padding-block-start
    std::mem::transmute::<[u8; 289], [u8; nsCSSPropertyID::eCSSProperty_padding_bottom as usize]>([0; 289]); // padding-bottom
    std::mem::transmute::<[u8; 290], [u8; nsCSSPropertyID::eCSSProperty_padding_inline_end as usize]>([0; 290]); // padding-inline-end
    std::mem::transmute::<[u8; 291], [u8; nsCSSPropertyID::eCSSProperty_padding_inline_start as usize]>([0; 291]); // padding-inline-start
    std::mem::transmute::<[u8; 292], [u8; nsCSSPropertyID::eCSSProperty_padding_left as usize]>([0; 292]); // padding-left
    std::mem::transmute::<[u8; 293], [u8; nsCSSPropertyID::eCSSProperty_padding_right as usize]>([0; 293]); // padding-right
    std::mem::transmute::<[u8; 294], [u8; nsCSSPropertyID::eCSSProperty_padding_top as usize]>([0; 294]); // padding-top
    std::mem::transmute::<[u8; 295], [u8; nsCSSPropertyID::eCSSProperty_shape_margin as usize]>([0; 295]); // shape-margin
    std::mem::transmute::<[u8; 296], [u8; nsCSSPropertyID::eCSSProperty_border_block_end_width as usize]>([0; 296]); // border-block-end-width
    std::mem::transmute::<[u8; 297], [u8; nsCSSPropertyID::eCSSProperty_border_block_start_width as usize]>([0; 297]); // border-block-start-width
    std::mem::transmute::<[u8; 298], [u8; nsCSSPropertyID::eCSSProperty_border_bottom_width as usize]>([0; 298]); // border-bottom-width
    std::mem::transmute::<[u8; 299], [u8; nsCSSPropertyID::eCSSProperty_border_inline_end_width as usize]>([0; 299]); // border-inline-end-width
    std::mem::transmute::<[u8; 300], [u8; nsCSSPropertyID::eCSSProperty_border_inline_start_width as usize]>([0; 300]); // border-inline-start-width
    std::mem::transmute::<[u8; 301], [u8; nsCSSPropertyID::eCSSProperty_border_left_width as usize]>([0; 301]); // border-left-width
    std::mem::transmute::<[u8; 302], [u8; nsCSSPropertyID::eCSSProperty_border_right_width as usize]>([0; 302]); // border-right-width
    std::mem::transmute::<[u8; 303], [u8; nsCSSPropertyID::eCSSProperty_border_top_width as usize]>([0; 303]); // border-top-width
    std::mem::transmute::<[u8; 304], [u8; nsCSSPropertyID::eCSSProperty_column_rule_width as usize]>([0; 304]); // column-rule-width
    std::mem::transmute::<[u8; 305], [u8; nsCSSPropertyID::eCSSProperty_outline_width as usize]>([0; 305]); // outline-width
    std::mem::transmute::<[u8; 306], [u8; nsCSSPropertyID::eCSSProperty__webkit_text_stroke_width as usize]>([0; 306]); // -webkit-text-stroke-width
    std::mem::transmute::<[u8; 307], [u8; nsCSSPropertyID::eCSSProperty_border_bottom_left_radius as usize]>([0; 307]); // border-bottom-left-radius
    std::mem::transmute::<[u8; 308], [u8; nsCSSPropertyID::eCSSProperty_border_bottom_right_radius as usize]>([0; 308]); // border-bottom-right-radius
    std::mem::transmute::<[u8; 309], [u8; nsCSSPropertyID::eCSSProperty_border_end_end_radius as usize]>([0; 309]); // border-end-end-radius
    std::mem::transmute::<[u8; 310], [u8; nsCSSPropertyID::eCSSProperty_border_end_start_radius as usize]>([0; 310]); // border-end-start-radius
    std::mem::transmute::<[u8; 311], [u8; nsCSSPropertyID::eCSSProperty_border_start_end_radius as usize]>([0; 311]); // border-start-end-radius
    std::mem::transmute::<[u8; 312], [u8; nsCSSPropertyID::eCSSProperty_border_start_start_radius as usize]>([0; 312]); // border-start-start-radius
    std::mem::transmute::<[u8; 313], [u8; nsCSSPropertyID::eCSSProperty_border_top_left_radius as usize]>([0; 313]); // border-top-left-radius
    std::mem::transmute::<[u8; 314], [u8; nsCSSPropertyID::eCSSProperty_border_top_right_radius as usize]>([0; 314]); // border-top-right-radius
    std::mem::transmute::<[u8; 315], [u8; nsCSSPropertyID::eCSSProperty__moz_outline_radius_bottomleft as usize]>([0; 315]); // -moz-outline-radius-bottomleft
    std::mem::transmute::<[u8; 316], [u8; nsCSSPropertyID::eCSSProperty__moz_outline_radius_bottomright as usize]>([0; 316]); // -moz-outline-radius-bottomright
    std::mem::transmute::<[u8; 317], [u8; nsCSSPropertyID::eCSSProperty__moz_outline_radius_topleft as usize]>([0; 317]); // -moz-outline-radius-topleft
    std::mem::transmute::<[u8; 318], [u8; nsCSSPropertyID::eCSSProperty__moz_outline_radius_topright as usize]>([0; 318]); // -moz-outline-radius-topright
    std::mem::transmute::<[u8; 319], [u8; nsCSSPropertyID::eCSSProperty_bottom as usize]>([0; 319]); // bottom
    std::mem::transmute::<[u8; 320], [u8; nsCSSPropertyID::eCSSProperty_inset_block_end as usize]>([0; 320]); // inset-block-end
    std::mem::transmute::<[u8; 321], [u8; nsCSSPropertyID::eCSSProperty_inset_block_start as usize]>([0; 321]); // inset-block-start
    std::mem::transmute::<[u8; 322], [u8; nsCSSPropertyID::eCSSProperty_inset_inline_end as usize]>([0; 322]); // inset-inline-end
    std::mem::transmute::<[u8; 323], [u8; nsCSSPropertyID::eCSSProperty_inset_inline_start as usize]>([0; 323]); // inset-inline-start
    std::mem::transmute::<[u8; 324], [u8; nsCSSPropertyID::eCSSProperty_left as usize]>([0; 324]); // left
    std::mem::transmute::<[u8; 325], [u8; nsCSSPropertyID::eCSSProperty_margin_block_end as usize]>([0; 325]); // margin-block-end
    std::mem::transmute::<[u8; 326], [u8; nsCSSPropertyID::eCSSProperty_margin_block_start as usize]>([0; 326]); // margin-block-start
    std::mem::transmute::<[u8; 327], [u8; nsCSSPropertyID::eCSSProperty_margin_bottom as usize]>([0; 327]); // margin-bottom
    std::mem::transmute::<[u8; 328], [u8; nsCSSPropertyID::eCSSProperty_margin_inline_end as usize]>([0; 328]); // margin-inline-end
    std::mem::transmute::<[u8; 329], [u8; nsCSSPropertyID::eCSSProperty_margin_inline_start as usize]>([0; 329]); // margin-inline-start
    std::mem::transmute::<[u8; 330], [u8; nsCSSPropertyID::eCSSProperty_margin_left as usize]>([0; 330]); // margin-left
    std::mem::transmute::<[u8; 331], [u8; nsCSSPropertyID::eCSSProperty_margin_right as usize]>([0; 331]); // margin-right
    std::mem::transmute::<[u8; 332], [u8; nsCSSPropertyID::eCSSProperty_margin_top as usize]>([0; 332]); // margin-top
    std::mem::transmute::<[u8; 333], [u8; nsCSSPropertyID::eCSSProperty_right as usize]>([0; 333]); // right
    std::mem::transmute::<[u8; 334], [u8; nsCSSPropertyID::eCSSProperty_top as usize]>([0; 334]); // top
    std::mem::transmute::<[u8; 335], [u8; nsCSSPropertyID::eCSSProperty_background_color as usize]>([0; 335]); // background-color
    std::mem::transmute::<[u8; 336], [u8; nsCSSPropertyID::eCSSProperty_border_block_end_color as usize]>([0; 336]); // border-block-end-color
    std::mem::transmute::<[u8; 337], [u8; nsCSSPropertyID::eCSSProperty_border_block_start_color as usize]>([0; 337]); // border-block-start-color
    std::mem::transmute::<[u8; 338], [u8; nsCSSPropertyID::eCSSProperty_border_bottom_color as usize]>([0; 338]); // border-bottom-color
    std::mem::transmute::<[u8; 339], [u8; nsCSSPropertyID::eCSSProperty_border_inline_end_color as usize]>([0; 339]); // border-inline-end-color
    std::mem::transmute::<[u8; 340], [u8; nsCSSPropertyID::eCSSProperty_border_inline_start_color as usize]>([0; 340]); // border-inline-start-color
    std::mem::transmute::<[u8; 341], [u8; nsCSSPropertyID::eCSSProperty_border_left_color as usize]>([0; 341]); // border-left-color
    std::mem::transmute::<[u8; 342], [u8; nsCSSPropertyID::eCSSProperty_border_right_color as usize]>([0; 342]); // border-right-color
    std::mem::transmute::<[u8; 343], [u8; nsCSSPropertyID::eCSSProperty_border_top_color as usize]>([0; 343]); // border-top-color
    std::mem::transmute::<[u8; 344], [u8; nsCSSPropertyID::eCSSProperty_column_rule_color as usize]>([0; 344]); // column-rule-color
    std::mem::transmute::<[u8; 345], [u8; nsCSSPropertyID::eCSSProperty_flood_color as usize]>([0; 345]); // flood-color
    std::mem::transmute::<[u8; 346], [u8; nsCSSPropertyID::eCSSProperty_lighting_color as usize]>([0; 346]); // lighting-color
    std::mem::transmute::<[u8; 347], [u8; nsCSSPropertyID::eCSSProperty_outline_color as usize]>([0; 347]); // outline-color
    std::mem::transmute::<[u8; 348], [u8; nsCSSPropertyID::eCSSProperty_stop_color as usize]>([0; 348]); // stop-color
    std::mem::transmute::<[u8; 349], [u8; nsCSSPropertyID::eCSSProperty_text_decoration_color as usize]>([0; 349]); // text-decoration-color
    std::mem::transmute::<[u8; 350], [u8; nsCSSPropertyID::eCSSProperty_text_emphasis_color as usize]>([0; 350]); // text-emphasis-color
    std::mem::transmute::<[u8; 351], [u8; nsCSSPropertyID::eCSSProperty__webkit_text_fill_color as usize]>([0; 351]); // -webkit-text-fill-color
    std::mem::transmute::<[u8; 352], [u8; nsCSSPropertyID::eCSSProperty__webkit_text_stroke_color as usize]>([0; 352]); // -webkit-text-stroke-color
    std::mem::transmute::<[u8; 353], [u8; nsCSSPropertyID::eCSSProperty_background as usize]>([0; 353]); // background
    std::mem::transmute::<[u8; 354], [u8; nsCSSPropertyID::eCSSProperty_background_position as usize]>([0; 354]); // background-position
    std::mem::transmute::<[u8; 355], [u8; nsCSSPropertyID::eCSSProperty_border_color as usize]>([0; 355]); // border-color
    std::mem::transmute::<[u8; 356], [u8; nsCSSPropertyID::eCSSProperty_border_style as usize]>([0; 356]); // border-style
    std::mem::transmute::<[u8; 357], [u8; nsCSSPropertyID::eCSSProperty_border_width as usize]>([0; 357]); // border-width
    std::mem::transmute::<[u8; 358], [u8; nsCSSPropertyID::eCSSProperty_border_top as usize]>([0; 358]); // border-top
    std::mem::transmute::<[u8; 359], [u8; nsCSSPropertyID::eCSSProperty_border_right as usize]>([0; 359]); // border-right
    std::mem::transmute::<[u8; 360], [u8; nsCSSPropertyID::eCSSProperty_border_bottom as usize]>([0; 360]); // border-bottom
    std::mem::transmute::<[u8; 361], [u8; nsCSSPropertyID::eCSSProperty_border_left as usize]>([0; 361]); // border-left
    std::mem::transmute::<[u8; 362], [u8; nsCSSPropertyID::eCSSProperty_border_block_start as usize]>([0; 362]); // border-block-start
    std::mem::transmute::<[u8; 363], [u8; nsCSSPropertyID::eCSSProperty_border_block_end as usize]>([0; 363]); // border-block-end
    std::mem::transmute::<[u8; 364], [u8; nsCSSPropertyID::eCSSProperty_border_inline_start as usize]>([0; 364]); // border-inline-start
    std::mem::transmute::<[u8; 365], [u8; nsCSSPropertyID::eCSSProperty_border_inline_end as usize]>([0; 365]); // border-inline-end
    std::mem::transmute::<[u8; 366], [u8; nsCSSPropertyID::eCSSProperty_border as usize]>([0; 366]); // border
    std::mem::transmute::<[u8; 367], [u8; nsCSSPropertyID::eCSSProperty_border_radius as usize]>([0; 367]); // border-radius
    std::mem::transmute::<[u8; 368], [u8; nsCSSPropertyID::eCSSProperty_border_image as usize]>([0; 368]); // border-image
    std::mem::transmute::<[u8; 369], [u8; nsCSSPropertyID::eCSSProperty_border_block_width as usize]>([0; 369]); // border-block-width
    std::mem::transmute::<[u8; 370], [u8; nsCSSPropertyID::eCSSProperty_border_block_style as usize]>([0; 370]); // border-block-style
    std::mem::transmute::<[u8; 371], [u8; nsCSSPropertyID::eCSSProperty_border_block_color as usize]>([0; 371]); // border-block-color
    std::mem::transmute::<[u8; 372], [u8; nsCSSPropertyID::eCSSProperty_border_inline_width as usize]>([0; 372]); // border-inline-width
    std::mem::transmute::<[u8; 373], [u8; nsCSSPropertyID::eCSSProperty_border_inline_style as usize]>([0; 373]); // border-inline-style
    std::mem::transmute::<[u8; 374], [u8; nsCSSPropertyID::eCSSProperty_border_inline_color as usize]>([0; 374]); // border-inline-color
    std::mem::transmute::<[u8; 375], [u8; nsCSSPropertyID::eCSSProperty_border_block as usize]>([0; 375]); // border-block
    std::mem::transmute::<[u8; 376], [u8; nsCSSPropertyID::eCSSProperty_border_inline as usize]>([0; 376]); // border-inline
    std::mem::transmute::<[u8; 377], [u8; nsCSSPropertyID::eCSSProperty_overflow as usize]>([0; 377]); // overflow
    std::mem::transmute::<[u8; 378], [u8; nsCSSPropertyID::eCSSProperty_overflow_clip_box as usize]>([0; 378]); // overflow-clip-box
    std::mem::transmute::<[u8; 379], [u8; nsCSSPropertyID::eCSSProperty_transition as usize]>([0; 379]); // transition
    std::mem::transmute::<[u8; 380], [u8; nsCSSPropertyID::eCSSProperty_animation as usize]>([0; 380]); // animation
    std::mem::transmute::<[u8; 381], [u8; nsCSSPropertyID::eCSSProperty_overscroll_behavior as usize]>([0; 381]); // overscroll-behavior
    std::mem::transmute::<[u8; 382], [u8; nsCSSPropertyID::eCSSProperty_page_break_before as usize]>([0; 382]); // page-break-before
    std::mem::transmute::<[u8; 383], [u8; nsCSSPropertyID::eCSSProperty_page_break_after as usize]>([0; 383]); // page-break-after
    std::mem::transmute::<[u8; 384], [u8; nsCSSPropertyID::eCSSProperty_columns as usize]>([0; 384]); // columns
    std::mem::transmute::<[u8; 385], [u8; nsCSSPropertyID::eCSSProperty_column_rule as usize]>([0; 385]); // column-rule
    std::mem::transmute::<[u8; 386], [u8; nsCSSPropertyID::eCSSProperty_font as usize]>([0; 386]); // font
    std::mem::transmute::<[u8; 387], [u8; nsCSSPropertyID::eCSSProperty_font_variant as usize]>([0; 387]); // font-variant
    std::mem::transmute::<[u8; 388], [u8; nsCSSPropertyID::eCSSProperty_text_emphasis as usize]>([0; 388]); // text-emphasis
    std::mem::transmute::<[u8; 389], [u8; nsCSSPropertyID::eCSSProperty__webkit_text_stroke as usize]>([0; 389]); // -webkit-text-stroke
    std::mem::transmute::<[u8; 390], [u8; nsCSSPropertyID::eCSSProperty_marker as usize]>([0; 390]); // marker
    std::mem::transmute::<[u8; 391], [u8; nsCSSPropertyID::eCSSProperty_list_style as usize]>([0; 391]); // list-style
    std::mem::transmute::<[u8; 392], [u8; nsCSSPropertyID::eCSSProperty_margin as usize]>([0; 392]); // margin
    std::mem::transmute::<[u8; 393], [u8; nsCSSPropertyID::eCSSProperty_margin_block as usize]>([0; 393]); // margin-block
    std::mem::transmute::<[u8; 394], [u8; nsCSSPropertyID::eCSSProperty_margin_inline as usize]>([0; 394]); // margin-inline
    std::mem::transmute::<[u8; 395], [u8; nsCSSPropertyID::eCSSProperty_scroll_margin as usize]>([0; 395]); // scroll-margin
    std::mem::transmute::<[u8; 396], [u8; nsCSSPropertyID::eCSSProperty_scroll_margin_block as usize]>([0; 396]); // scroll-margin-block
    std::mem::transmute::<[u8; 397], [u8; nsCSSPropertyID::eCSSProperty_scroll_margin_inline as usize]>([0; 397]); // scroll-margin-inline
    std::mem::transmute::<[u8; 398], [u8; nsCSSPropertyID::eCSSProperty_outline as usize]>([0; 398]); // outline
    std::mem::transmute::<[u8; 399], [u8; nsCSSPropertyID::eCSSProperty__moz_outline_radius as usize]>([0; 399]); // -moz-outline-radius
    std::mem::transmute::<[u8; 400], [u8; nsCSSPropertyID::eCSSProperty_padding as usize]>([0; 400]); // padding
    std::mem::transmute::<[u8; 401], [u8; nsCSSPropertyID::eCSSProperty_padding_block as usize]>([0; 401]); // padding-block
    std::mem::transmute::<[u8; 402], [u8; nsCSSPropertyID::eCSSProperty_padding_inline as usize]>([0; 402]); // padding-inline
    std::mem::transmute::<[u8; 403], [u8; nsCSSPropertyID::eCSSProperty_scroll_padding as usize]>([0; 403]); // scroll-padding
    std::mem::transmute::<[u8; 404], [u8; nsCSSPropertyID::eCSSProperty_scroll_padding_block as usize]>([0; 404]); // scroll-padding-block
    std::mem::transmute::<[u8; 405], [u8; nsCSSPropertyID::eCSSProperty_scroll_padding_inline as usize]>([0; 405]); // scroll-padding-inline
    std::mem::transmute::<[u8; 406], [u8; nsCSSPropertyID::eCSSProperty_flex_flow as usize]>([0; 406]); // flex-flow
    std::mem::transmute::<[u8; 407], [u8; nsCSSPropertyID::eCSSProperty_flex as usize]>([0; 407]); // flex
    std::mem::transmute::<[u8; 408], [u8; nsCSSPropertyID::eCSSProperty_gap as usize]>([0; 408]); // gap
    std::mem::transmute::<[u8; 409], [u8; nsCSSPropertyID::eCSSProperty_grid_row as usize]>([0; 409]); // grid-row
    std::mem::transmute::<[u8; 410], [u8; nsCSSPropertyID::eCSSProperty_grid_column as usize]>([0; 410]); // grid-column
    std::mem::transmute::<[u8; 411], [u8; nsCSSPropertyID::eCSSProperty_grid_area as usize]>([0; 411]); // grid-area
    std::mem::transmute::<[u8; 412], [u8; nsCSSPropertyID::eCSSProperty_grid_template as usize]>([0; 412]); // grid-template
    std::mem::transmute::<[u8; 413], [u8; nsCSSPropertyID::eCSSProperty_grid as usize]>([0; 413]); // grid
    std::mem::transmute::<[u8; 414], [u8; nsCSSPropertyID::eCSSProperty_place_content as usize]>([0; 414]); // place-content
    std::mem::transmute::<[u8; 415], [u8; nsCSSPropertyID::eCSSProperty_place_self as usize]>([0; 415]); // place-self
    std::mem::transmute::<[u8; 416], [u8; nsCSSPropertyID::eCSSProperty_place_items as usize]>([0; 416]); // place-items
    std::mem::transmute::<[u8; 417], [u8; nsCSSPropertyID::eCSSProperty_inset as usize]>([0; 417]); // inset
    std::mem::transmute::<[u8; 418], [u8; nsCSSPropertyID::eCSSProperty_inset_block as usize]>([0; 418]); // inset-block
    std::mem::transmute::<[u8; 419], [u8; nsCSSPropertyID::eCSSProperty_inset_inline as usize]>([0; 419]); // inset-inline
    std::mem::transmute::<[u8; 420], [u8; nsCSSPropertyID::eCSSProperty_text_decoration as usize]>([0; 420]); // text-decoration
    std::mem::transmute::<[u8; 421], [u8; nsCSSPropertyID::eCSSProperty_mask as usize]>([0; 421]); // mask
    std::mem::transmute::<[u8; 422], [u8; nsCSSPropertyID::eCSSProperty_mask_position as usize]>([0; 422]); // mask-position
    std::mem::transmute::<[u8; 423], [u8; nsCSSPropertyID::eCSSProperty_all as usize]>([0; 423]); // all
    std::mem::transmute::<[u8; 424], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_background_clip as usize]>([0; 424]); // -webkit-background-clip
    std::mem::transmute::<[u8; 425], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_background_origin as usize]>([0; 425]); // -webkit-background-origin
    std::mem::transmute::<[u8; 426], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_background_size as usize]>([0; 426]); // -webkit-background-size
    std::mem::transmute::<[u8; 427], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_border_start_color as usize]>([0; 427]); // -moz-border-start-color
    std::mem::transmute::<[u8; 428], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_border_start_style as usize]>([0; 428]); // -moz-border-start-style
    std::mem::transmute::<[u8; 429], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_border_start_width as usize]>([0; 429]); // -moz-border-start-width
    std::mem::transmute::<[u8; 430], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_border_end_color as usize]>([0; 430]); // -moz-border-end-color
    std::mem::transmute::<[u8; 431], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_border_end_style as usize]>([0; 431]); // -moz-border-end-style
    std::mem::transmute::<[u8; 432], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_border_end_width as usize]>([0; 432]); // -moz-border-end-width
    std::mem::transmute::<[u8; 433], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_border_top_left_radius as usize]>([0; 433]); // -webkit-border-top-left-radius
    std::mem::transmute::<[u8; 434], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_border_top_right_radius as usize]>([0; 434]); // -webkit-border-top-right-radius
    std::mem::transmute::<[u8; 435], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_border_bottom_right_radius as usize]>([0; 435]); // -webkit-border-bottom-right-radius
    std::mem::transmute::<[u8; 436], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_border_bottom_left_radius as usize]>([0; 436]); // -webkit-border-bottom-left-radius
    std::mem::transmute::<[u8; 437], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_transition_duration as usize]>([0; 437]); // -moz-transition-duration
    std::mem::transmute::<[u8; 438], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_transition_duration as usize]>([0; 438]); // -webkit-transition-duration
    std::mem::transmute::<[u8; 439], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_transition_timing_function as usize]>([0; 439]); // -moz-transition-timing-function
    std::mem::transmute::<[u8; 440], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_transition_timing_function as usize]>([0; 440]); // -webkit-transition-timing-function
    std::mem::transmute::<[u8; 441], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_transition_property as usize]>([0; 441]); // -moz-transition-property
    std::mem::transmute::<[u8; 442], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_transition_property as usize]>([0; 442]); // -webkit-transition-property
    std::mem::transmute::<[u8; 443], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_transition_delay as usize]>([0; 443]); // -moz-transition-delay
    std::mem::transmute::<[u8; 444], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_transition_delay as usize]>([0; 444]); // -webkit-transition-delay
    std::mem::transmute::<[u8; 445], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_animation_name as usize]>([0; 445]); // -moz-animation-name
    std::mem::transmute::<[u8; 446], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_animation_name as usize]>([0; 446]); // -webkit-animation-name
    std::mem::transmute::<[u8; 447], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_animation_duration as usize]>([0; 447]); // -moz-animation-duration
    std::mem::transmute::<[u8; 448], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_animation_duration as usize]>([0; 448]); // -webkit-animation-duration
    std::mem::transmute::<[u8; 449], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_animation_timing_function as usize]>([0; 449]); // -moz-animation-timing-function
    std::mem::transmute::<[u8; 450], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_animation_timing_function as usize]>([0; 450]); // -webkit-animation-timing-function
    std::mem::transmute::<[u8; 451], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_animation_iteration_count as usize]>([0; 451]); // -moz-animation-iteration-count
    std::mem::transmute::<[u8; 452], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_animation_iteration_count as usize]>([0; 452]); // -webkit-animation-iteration-count
    std::mem::transmute::<[u8; 453], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_animation_direction as usize]>([0; 453]); // -moz-animation-direction
    std::mem::transmute::<[u8; 454], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_animation_direction as usize]>([0; 454]); // -webkit-animation-direction
    std::mem::transmute::<[u8; 455], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_animation_play_state as usize]>([0; 455]); // -moz-animation-play-state
    std::mem::transmute::<[u8; 456], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_animation_play_state as usize]>([0; 456]); // -webkit-animation-play-state
    std::mem::transmute::<[u8; 457], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_animation_fill_mode as usize]>([0; 457]); // -moz-animation-fill-mode
    std::mem::transmute::<[u8; 458], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_animation_fill_mode as usize]>([0; 458]); // -webkit-animation-fill-mode
    std::mem::transmute::<[u8; 459], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_animation_delay as usize]>([0; 459]); // -moz-animation-delay
    std::mem::transmute::<[u8; 460], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_animation_delay as usize]>([0; 460]); // -webkit-animation-delay
    std::mem::transmute::<[u8; 461], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_transform as usize]>([0; 461]); // -moz-transform
    std::mem::transmute::<[u8; 462], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_transform as usize]>([0; 462]); // -webkit-transform
    std::mem::transmute::<[u8; 463], [u8; nsCSSPropertyID::eCSSPropertyAlias_page_break_inside as usize]>([0; 463]); // page-break-inside
    std::mem::transmute::<[u8; 464], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_perspective as usize]>([0; 464]); // -moz-perspective
    std::mem::transmute::<[u8; 465], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_perspective as usize]>([0; 465]); // -webkit-perspective
    std::mem::transmute::<[u8; 466], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_perspective_origin as usize]>([0; 466]); // -moz-perspective-origin
    std::mem::transmute::<[u8; 467], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_perspective_origin as usize]>([0; 467]); // -webkit-perspective-origin
    std::mem::transmute::<[u8; 468], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_backface_visibility as usize]>([0; 468]); // -moz-backface-visibility
    std::mem::transmute::<[u8; 469], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_backface_visibility as usize]>([0; 469]); // -webkit-backface-visibility
    std::mem::transmute::<[u8; 470], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_transform_style as usize]>([0; 470]); // -moz-transform-style
    std::mem::transmute::<[u8; 471], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_transform_style as usize]>([0; 471]); // -webkit-transform-style
    std::mem::transmute::<[u8; 472], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_transform_origin as usize]>([0; 472]); // -moz-transform-origin
    std::mem::transmute::<[u8; 473], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_transform_origin as usize]>([0; 473]); // -webkit-transform-origin
    std::mem::transmute::<[u8; 474], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_appearance as usize]>([0; 474]); // -webkit-appearance
    std::mem::transmute::<[u8; 475], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_column_width as usize]>([0; 475]); // -moz-column-width
    std::mem::transmute::<[u8; 476], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_column_count as usize]>([0; 476]); // -moz-column-count
    std::mem::transmute::<[u8; 477], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_column_fill as usize]>([0; 477]); // -moz-column-fill
    std::mem::transmute::<[u8; 478], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_column_rule_width as usize]>([0; 478]); // -moz-column-rule-width
    std::mem::transmute::<[u8; 479], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_column_rule_color as usize]>([0; 479]); // -moz-column-rule-color
    std::mem::transmute::<[u8; 480], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_column_span as usize]>([0; 480]); // -moz-column-span
    std::mem::transmute::<[u8; 481], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_column_rule_style as usize]>([0; 481]); // -moz-column-rule-style
    std::mem::transmute::<[u8; 482], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_box_shadow as usize]>([0; 482]); // -webkit-box-shadow
    std::mem::transmute::<[u8; 483], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_filter as usize]>([0; 483]); // -webkit-filter
    std::mem::transmute::<[u8; 484], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_font_feature_settings as usize]>([0; 484]); // -moz-font-feature-settings
    std::mem::transmute::<[u8; 485], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_font_language_override as usize]>([0; 485]); // -moz-font-language-override
    std::mem::transmute::<[u8; 486], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_hyphens as usize]>([0; 486]); // -moz-hyphens
    std::mem::transmute::<[u8; 487], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_text_size_adjust as usize]>([0; 487]); // -webkit-text-size-adjust
    std::mem::transmute::<[u8; 488], [u8; nsCSSPropertyID::eCSSPropertyAlias_word_wrap as usize]>([0; 488]); // word-wrap
    std::mem::transmute::<[u8; 489], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_margin_start as usize]>([0; 489]); // -moz-margin-start
    std::mem::transmute::<[u8; 490], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_margin_end as usize]>([0; 490]); // -moz-margin-end
    std::mem::transmute::<[u8; 491], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_padding_start as usize]>([0; 491]); // -moz-padding-start
    std::mem::transmute::<[u8; 492], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_padding_end as usize]>([0; 492]); // -moz-padding-end
    std::mem::transmute::<[u8; 493], [u8; nsCSSPropertyID::eCSSPropertyAlias_offset_block_start as usize]>([0; 493]); // offset-block-start
    std::mem::transmute::<[u8; 494], [u8; nsCSSPropertyID::eCSSPropertyAlias_offset_block_end as usize]>([0; 494]); // offset-block-end
    std::mem::transmute::<[u8; 495], [u8; nsCSSPropertyID::eCSSPropertyAlias_offset_inline_start as usize]>([0; 495]); // offset-inline-start
    std::mem::transmute::<[u8; 496], [u8; nsCSSPropertyID::eCSSPropertyAlias_offset_inline_end as usize]>([0; 496]); // offset-inline-end
    std::mem::transmute::<[u8; 497], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_flex_direction as usize]>([0; 497]); // -webkit-flex-direction
    std::mem::transmute::<[u8; 498], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_flex_wrap as usize]>([0; 498]); // -webkit-flex-wrap
    std::mem::transmute::<[u8; 499], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_justify_content as usize]>([0; 499]); // -webkit-justify-content
    std::mem::transmute::<[u8; 500], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_align_content as usize]>([0; 500]); // -webkit-align-content
    std::mem::transmute::<[u8; 501], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_align_items as usize]>([0; 501]); // -webkit-align-items
    std::mem::transmute::<[u8; 502], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_flex_grow as usize]>([0; 502]); // -webkit-flex-grow
    std::mem::transmute::<[u8; 503], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_flex_shrink as usize]>([0; 503]); // -webkit-flex-shrink
    std::mem::transmute::<[u8; 504], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_align_self as usize]>([0; 504]); // -webkit-align-self
    std::mem::transmute::<[u8; 505], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_order as usize]>([0; 505]); // -webkit-order
    std::mem::transmute::<[u8; 506], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_flex_basis as usize]>([0; 506]); // -webkit-flex-basis
    std::mem::transmute::<[u8; 507], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_box_sizing as usize]>([0; 507]); // -moz-box-sizing
    std::mem::transmute::<[u8; 508], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_box_sizing as usize]>([0; 508]); // -webkit-box-sizing
    std::mem::transmute::<[u8; 509], [u8; nsCSSPropertyID::eCSSPropertyAlias_grid_column_gap as usize]>([0; 509]); // grid-column-gap
    std::mem::transmute::<[u8; 510], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_column_gap as usize]>([0; 510]); // -moz-column-gap
    std::mem::transmute::<[u8; 511], [u8; nsCSSPropertyID::eCSSPropertyAlias_grid_row_gap as usize]>([0; 511]); // grid-row-gap
    std::mem::transmute::<[u8; 512], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_user_select as usize]>([0; 512]); // -webkit-user-select
    std::mem::transmute::<[u8; 513], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_mask_repeat as usize]>([0; 513]); // -webkit-mask-repeat
    std::mem::transmute::<[u8; 514], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_mask_position_x as usize]>([0; 514]); // -webkit-mask-position-x
    std::mem::transmute::<[u8; 515], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_mask_position_y as usize]>([0; 515]); // -webkit-mask-position-y
    std::mem::transmute::<[u8; 516], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_mask_clip as usize]>([0; 516]); // -webkit-mask-clip
    std::mem::transmute::<[u8; 517], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_mask_origin as usize]>([0; 517]); // -webkit-mask-origin
    std::mem::transmute::<[u8; 518], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_mask_size as usize]>([0; 518]); // -webkit-mask-size
    std::mem::transmute::<[u8; 519], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_mask_composite as usize]>([0; 519]); // -webkit-mask-composite
    std::mem::transmute::<[u8; 520], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_mask_image as usize]>([0; 520]); // -webkit-mask-image
    std::mem::transmute::<[u8; 521], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_box_align as usize]>([0; 521]); // -webkit-box-align
    std::mem::transmute::<[u8; 522], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_box_direction as usize]>([0; 522]); // -webkit-box-direction
    std::mem::transmute::<[u8; 523], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_box_flex as usize]>([0; 523]); // -webkit-box-flex
    std::mem::transmute::<[u8; 524], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_box_orient as usize]>([0; 524]); // -webkit-box-orient
    std::mem::transmute::<[u8; 525], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_box_pack as usize]>([0; 525]); // -webkit-box-pack
    std::mem::transmute::<[u8; 526], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_box_ordinal_group as usize]>([0; 526]); // -webkit-box-ordinal-group
    std::mem::transmute::<[u8; 527], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_border_start as usize]>([0; 527]); // -moz-border-start
    std::mem::transmute::<[u8; 528], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_border_end as usize]>([0; 528]); // -moz-border-end
    std::mem::transmute::<[u8; 529], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_border_radius as usize]>([0; 529]); // -webkit-border-radius
    std::mem::transmute::<[u8; 530], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_border_image as usize]>([0; 530]); // -moz-border-image
    std::mem::transmute::<[u8; 531], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_border_image as usize]>([0; 531]); // -webkit-border-image
    std::mem::transmute::<[u8; 532], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_transition as usize]>([0; 532]); // -moz-transition
    std::mem::transmute::<[u8; 533], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_transition as usize]>([0; 533]); // -webkit-transition
    std::mem::transmute::<[u8; 534], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_animation as usize]>([0; 534]); // -moz-animation
    std::mem::transmute::<[u8; 535], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_animation as usize]>([0; 535]); // -webkit-animation
    std::mem::transmute::<[u8; 536], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_columns as usize]>([0; 536]); // -moz-columns
    std::mem::transmute::<[u8; 537], [u8; nsCSSPropertyID::eCSSPropertyAlias__moz_column_rule as usize]>([0; 537]); // -moz-column-rule
    std::mem::transmute::<[u8; 538], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_flex_flow as usize]>([0; 538]); // -webkit-flex-flow
    std::mem::transmute::<[u8; 539], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_flex as usize]>([0; 539]); // -webkit-flex
    std::mem::transmute::<[u8; 540], [u8; nsCSSPropertyID::eCSSPropertyAlias_grid_gap as usize]>([0; 540]); // grid-gap
    std::mem::transmute::<[u8; 541], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_mask as usize]>([0; 541]); // -webkit-mask
    std::mem::transmute::<[u8; 542], [u8; nsCSSPropertyID::eCSSPropertyAlias__webkit_mask_position as usize]>([0; 542]); // -webkit-mask-position
}

impl NonCustomPropertyId {
    /// Returns the underlying index, used for use counter.
    pub fn bit(self) -> usize {
        self.0
    }

    #[cfg(feature = "gecko")]
    #[inline]
    fn to_nscsspropertyid(self) -> nsCSSPropertyID {
        // unsafe: guaranteed by static_assert_nscsspropertyid above.
        unsafe { std::mem::transmute(self.0 as i32) }
    }

    /// Convert an `nsCSSPropertyID` into a `NonCustomPropertyId`.
    #[cfg(feature = "gecko")]
    #[inline]
    pub fn from_nscsspropertyid(prop: nsCSSPropertyID) -> Result<Self, ()> {
        let prop = prop as i32;
        if prop < 0 {
            return Err(());
        }
        if prop >= NON_CUSTOM_PROPERTY_ID_COUNT as i32 {
            return Err(());
        }
        // unsafe: guaranteed by static_assert_nscsspropertyid above.
        Ok(unsafe { std::mem::transmute(prop as usize) })
    }

    /// Get the property name.
    #[inline]
    pub fn name(self) -> &'static str {
        static MAP: [&'static str; NON_CUSTOM_PROPERTY_ID_COUNT] = [
            "align-content",
            "align-items",
            "align-self",
            "backface-visibility",
            "border-collapse",
            "border-image-repeat",
            "box-decoration-break",
            "box-sizing",
            "break-inside",
            "caption-side",
            "clear",
            "color-adjust",
            "color-interpolation",
            "color-interpolation-filters",
            "column-count",
            "column-fill",
            "column-span",
            "contain",
            "direction",
            "display",
            "dominant-baseline",
            "empty-cells",
            "flex-direction",
            "flex-wrap",
            "float",
            "font-kerning",
            "font-optical-sizing",
            "font-size-adjust",
            "font-stretch",
            "font-style",
            "font-synthesis",
            "font-variant-caps",
            "font-variant-east-asian",
            "font-variant-ligatures",
            "font-variant-numeric",
            "font-variant-position",
            "font-weight",
            "grid-auto-flow",
            "hyphens",
            "image-orientation",
            "image-rendering",
            "ime-mode",
            "initial-letter",
            "isolation",
            "justify-content",
            "justify-items",
            "justify-self",
            "list-style-position",
            "mask-type",
            "mix-blend-mode",
            "-moz-appearance",
            "-moz-box-align",
            "-moz-box-direction",
            "-moz-box-orient",
            "-moz-box-pack",
            "-moz-control-character-visibility",
            "-moz-float-edge",
            "-moz-force-broken-image-icon",
            "-moz-list-reversed",
            "-moz-math-display",
            "-moz-math-variant",
            "-moz-min-font-size-ratio",
            "-moz-orient",
            "-moz-osx-font-smoothing",
            "-moz-script-level",
            "-moz-script-min-size",
            "-moz-script-size-multiplier",
            "-moz-stack-sizing",
            "-moz-text-size-adjust",
            "-moz-top-layer",
            "-moz-user-focus",
            "-moz-user-input",
            "-moz-user-modify",
            "-moz-user-select",
            "-moz-window-dragging",
            "-moz-window-shadow",
            "object-fit",
            "outline-style",
            "overflow-anchor",
            "overflow-wrap",
            "paint-order",
            "pointer-events",
            "position",
            "resize",
            "ruby-align",
            "ruby-position",
            "scroll-behavior",
            "scroll-snap-align",
            "scroll-snap-type",
            "scrollbar-width",
            "shape-rendering",
            "stroke-linecap",
            "stroke-linejoin",
            "table-layout",
            "text-align",
            "text-align-last",
            "text-anchor",
            "text-combine-upright",
            "text-decoration-line",
            "text-decoration-style",
            "text-emphasis-position",
            "text-justify",
            "text-orientation",
            "text-rendering",
            "text-transform",
            "touch-action",
            "transform-box",
            "transform-style",
            "unicode-bidi",
            "vector-effect",
            "visibility",
            "-webkit-line-clamp",
            "white-space",
            "word-break",
            "writing-mode",
            "-x-span",
            "-x-text-zoom",
            "z-index",
            "break-after",
            "break-before",
            "clip-rule",
            "fill-rule",
            "-moz-box-ordinal-group",
            "order",
            "overflow-x",
            "overflow-y",
            "overflow-clip-box-block",
            "overflow-clip-box-inline",
            "overscroll-behavior-x",
            "overscroll-behavior-y",
            "fill-opacity",
            "stroke-opacity",
            "flex-grow",
            "flex-shrink",
            "-moz-box-flex",
            "stroke-miterlimit",
            "flood-opacity",
            "-moz-window-opacity",
            "opacity",
            "shape-image-threshold",
            "stop-opacity",
            "border-block-end-style",
            "border-block-start-style",
            "border-bottom-style",
            "border-inline-end-style",
            "border-inline-start-style",
            "border-left-style",
            "border-right-style",
            "border-top-style",
            "column-rule-style",
            "animation-delay",
            "animation-direction",
            "animation-duration",
            "animation-fill-mode",
            "animation-iteration-count",
            "animation-name",
            "animation-play-state",
            "animation-timing-function",
            "background-attachment",
            "background-blend-mode",
            "background-clip",
            "background-image",
            "background-origin",
            "background-position-x",
            "background-position-y",
            "background-repeat",
            "background-size",
            "border-image-outset",
            "border-image-slice",
            "border-image-source",
            "border-image-width",
            "border-spacing",
            "box-shadow",
            "caret-color",
            "clip-path",
            "color",
            "column-width",
            "content",
            "counter-increment",
            "cursor",
            "filter",
            "flex-basis",
            "font-family",
            "font-feature-settings",
            "font-language-override",
            "font-size",
            "font-variant-alternates",
            "font-variation-settings",
            "grid-template-areas",
            "letter-spacing",
            "line-height",
            "list-style-image",
            "list-style-type",
            "mask-clip",
            "mask-composite",
            "mask-image",
            "mask-mode",
            "mask-origin",
            "mask-position-x",
            "mask-position-y",
            "mask-repeat",
            "mask-size",
            "-moz-context-properties",
            "-moz-font-smoothing-background-color",
            "-moz-tab-size",
            "offset-path",
            "perspective",
            "quotes",
            "rotate",
            "scale",
            "scroll-snap-coordinate",
            "scrollbar-color",
            "shape-outside",
            "stroke-dasharray",
            "stroke-dashoffset",
            "stroke-width",
            "text-emphasis-style",
            "text-indent",
            "text-overflow",
            "text-shadow",
            "transition-delay",
            "transition-duration",
            "transition-property",
            "transition-timing-function",
            "translate",
            "vertical-align",
            "will-change",
            "word-spacing",
            "-x-lang",
            "clip",
            "-moz-image-region",
            "grid-template-columns",
            "grid-template-rows",
            "fill",
            "stroke",
            "grid-auto-columns",
            "grid-auto-rows",
            "-moz-window-transform-origin",
            "transform-origin",
            "counter-reset",
            "counter-set",
            "scroll-snap-points-x",
            "scroll-snap-points-y",
            "-moz-window-transform",
            "transform",
            "column-gap",
            "row-gap",
            "object-position",
            "perspective-origin",
            "scroll-snap-destination",
            "grid-column-end",
            "grid-column-start",
            "grid-row-end",
            "grid-row-start",
            "max-block-size",
            "max-height",
            "max-inline-size",
            "max-width",
            "marker-end",
            "marker-mid",
            "marker-start",
            "-moz-binding",
            "scroll-padding-block-end",
            "scroll-padding-block-start",
            "scroll-padding-bottom",
            "scroll-padding-inline-end",
            "scroll-padding-inline-start",
            "scroll-padding-left",
            "scroll-padding-right",
            "scroll-padding-top",
            "block-size",
            "height",
            "inline-size",
            "min-block-size",
            "min-height",
            "min-inline-size",
            "min-width",
            "width",
            "outline-offset",
            "scroll-margin-block-end",
            "scroll-margin-block-start",
            "scroll-margin-bottom",
            "scroll-margin-inline-end",
            "scroll-margin-inline-start",
            "scroll-margin-left",
            "scroll-margin-right",
            "scroll-margin-top",
            "padding-block-end",
            "padding-block-start",
            "padding-bottom",
            "padding-inline-end",
            "padding-inline-start",
            "padding-left",
            "padding-right",
            "padding-top",
            "shape-margin",
            "border-block-end-width",
            "border-block-start-width",
            "border-bottom-width",
            "border-inline-end-width",
            "border-inline-start-width",
            "border-left-width",
            "border-right-width",
            "border-top-width",
            "column-rule-width",
            "outline-width",
            "-webkit-text-stroke-width",
            "border-bottom-left-radius",
            "border-bottom-right-radius",
            "border-end-end-radius",
            "border-end-start-radius",
            "border-start-end-radius",
            "border-start-start-radius",
            "border-top-left-radius",
            "border-top-right-radius",
            "-moz-outline-radius-bottomleft",
            "-moz-outline-radius-bottomright",
            "-moz-outline-radius-topleft",
            "-moz-outline-radius-topright",
            "bottom",
            "inset-block-end",
            "inset-block-start",
            "inset-inline-end",
            "inset-inline-start",
            "left",
            "margin-block-end",
            "margin-block-start",
            "margin-bottom",
            "margin-inline-end",
            "margin-inline-start",
            "margin-left",
            "margin-right",
            "margin-top",
            "right",
            "top",
            "background-color",
            "border-block-end-color",
            "border-block-start-color",
            "border-bottom-color",
            "border-inline-end-color",
            "border-inline-start-color",
            "border-left-color",
            "border-right-color",
            "border-top-color",
            "column-rule-color",
            "flood-color",
            "lighting-color",
            "outline-color",
            "stop-color",
            "text-decoration-color",
            "text-emphasis-color",
            "-webkit-text-fill-color",
            "-webkit-text-stroke-color",
            "background",
            "background-position",
            "border-color",
            "border-style",
            "border-width",
            "border-top",
            "border-right",
            "border-bottom",
            "border-left",
            "border-block-start",
            "border-block-end",
            "border-inline-start",
            "border-inline-end",
            "border",
            "border-radius",
            "border-image",
            "border-block-width",
            "border-block-style",
            "border-block-color",
            "border-inline-width",
            "border-inline-style",
            "border-inline-color",
            "border-block",
            "border-inline",
            "overflow",
            "overflow-clip-box",
            "transition",
            "animation",
            "overscroll-behavior",
            "page-break-before",
            "page-break-after",
            "columns",
            "column-rule",
            "font",
            "font-variant",
            "text-emphasis",
            "-webkit-text-stroke",
            "marker",
            "list-style",
            "margin",
            "margin-block",
            "margin-inline",
            "scroll-margin",
            "scroll-margin-block",
            "scroll-margin-inline",
            "outline",
            "-moz-outline-radius",
            "padding",
            "padding-block",
            "padding-inline",
            "scroll-padding",
            "scroll-padding-block",
            "scroll-padding-inline",
            "flex-flow",
            "flex",
            "gap",
            "grid-row",
            "grid-column",
            "grid-area",
            "grid-template",
            "grid",
            "place-content",
            "place-self",
            "place-items",
            "inset",
            "inset-block",
            "inset-inline",
            "text-decoration",
            "mask",
            "mask-position",
            "all",
            "-webkit-background-clip",
            "-webkit-background-origin",
            "-webkit-background-size",
            "-moz-border-start-color",
            "-moz-border-start-style",
            "-moz-border-start-width",
            "-moz-border-end-color",
            "-moz-border-end-style",
            "-moz-border-end-width",
            "-webkit-border-top-left-radius",
            "-webkit-border-top-right-radius",
            "-webkit-border-bottom-right-radius",
            "-webkit-border-bottom-left-radius",
            "-moz-transition-duration",
            "-webkit-transition-duration",
            "-moz-transition-timing-function",
            "-webkit-transition-timing-function",
            "-moz-transition-property",
            "-webkit-transition-property",
            "-moz-transition-delay",
            "-webkit-transition-delay",
            "-moz-animation-name",
            "-webkit-animation-name",
            "-moz-animation-duration",
            "-webkit-animation-duration",
            "-moz-animation-timing-function",
            "-webkit-animation-timing-function",
            "-moz-animation-iteration-count",
            "-webkit-animation-iteration-count",
            "-moz-animation-direction",
            "-webkit-animation-direction",
            "-moz-animation-play-state",
            "-webkit-animation-play-state",
            "-moz-animation-fill-mode",
            "-webkit-animation-fill-mode",
            "-moz-animation-delay",
            "-webkit-animation-delay",
            "-moz-transform",
            "-webkit-transform",
            "page-break-inside",
            "-moz-perspective",
            "-webkit-perspective",
            "-moz-perspective-origin",
            "-webkit-perspective-origin",
            "-moz-backface-visibility",
            "-webkit-backface-visibility",
            "-moz-transform-style",
            "-webkit-transform-style",
            "-moz-transform-origin",
            "-webkit-transform-origin",
            "-webkit-appearance",
            "-moz-column-width",
            "-moz-column-count",
            "-moz-column-fill",
            "-moz-column-rule-width",
            "-moz-column-rule-color",
            "-moz-column-span",
            "-moz-column-rule-style",
            "-webkit-box-shadow",
            "-webkit-filter",
            "-moz-font-feature-settings",
            "-moz-font-language-override",
            "-moz-hyphens",
            "-webkit-text-size-adjust",
            "word-wrap",
            "-moz-margin-start",
            "-moz-margin-end",
            "-moz-padding-start",
            "-moz-padding-end",
            "offset-block-start",
            "offset-block-end",
            "offset-inline-start",
            "offset-inline-end",
            "-webkit-flex-direction",
            "-webkit-flex-wrap",
            "-webkit-justify-content",
            "-webkit-align-content",
            "-webkit-align-items",
            "-webkit-flex-grow",
            "-webkit-flex-shrink",
            "-webkit-align-self",
            "-webkit-order",
            "-webkit-flex-basis",
            "-moz-box-sizing",
            "-webkit-box-sizing",
            "grid-column-gap",
            "-moz-column-gap",
            "grid-row-gap",
            "-webkit-user-select",
            "-webkit-mask-repeat",
            "-webkit-mask-position-x",
            "-webkit-mask-position-y",
            "-webkit-mask-clip",
            "-webkit-mask-origin",
            "-webkit-mask-size",
            "-webkit-mask-composite",
            "-webkit-mask-image",
            "-webkit-box-align",
            "-webkit-box-direction",
            "-webkit-box-flex",
            "-webkit-box-orient",
            "-webkit-box-pack",
            "-webkit-box-ordinal-group",
            "-moz-border-start",
            "-moz-border-end",
            "-webkit-border-radius",
            "-moz-border-image",
            "-webkit-border-image",
            "-moz-transition",
            "-webkit-transition",
            "-moz-animation",
            "-webkit-animation",
            "-moz-columns",
            "-moz-column-rule",
            "-webkit-flex-flow",
            "-webkit-flex",
            "grid-gap",
            "-webkit-mask",
            "-webkit-mask-position",
        ];
        MAP[self.0]
    }

    /// Returns whether this property is transitionable.
    #[inline]
    pub fn is_transitionable(self) -> bool {
        
static TRANSITIONABLE: NonCustomPropertyIdSet = NonCustomPropertyIdSet {
    
    storage: [0x38004000, 0x10, 0x0, 0x820c000, 0x1ffc, 0x6a31f858, 0xafb72c0, 0xc1f867eb, 0xffffffc3, 0xfffbffff, 0xffffffff, 0x1daffef, 0x31bfff37, 0x1f6cfe, 0xdb0f6000, 0xe6c1fe0c, 0x7b03884c]
};

        TRANSITIONABLE.contains(self)
    }

    /// Returns whether this property is animatable.
    #[inline]
    pub fn is_animatable(self) -> bool {
        
static ANIMATABLE: NonCustomPropertyIdSet = NonCustomPropertyIdSet {
    
    storage: [0xfff9ffff, 0xc77fffff, 0xffffffd8, 0xffe3efbf, 0xc03c9fff, 0xffffffff, 0xffff3ff, 0xffffffeb, 0xffffffdf, 0xffffffff, 0xffffffff, 0xe7dbffff, 0xffffffff, 0x1f6fff, 0xffffe000, 0xffffffff, 0x7f0fffff]
};

        ANIMATABLE.contains(self)
    }

    #[inline]
    fn enabled_for_all_content(self) -> bool {
        
static EXPERIMENTAL: NonCustomPropertyIdSet = NonCustomPropertyIdSet {
    
    storage: [0x4030000, 0x80000400, 0x2804000, 0xc0008620, 0x3, 0x8000000, 0xf2000, 0x2060001, 0x7f803fe0, 0x40000, 0x80000000, 0x24000001, 0x383820, 0xfffe0700, 0x7ff7fff, 0x1fffe0bd, 0x6cfe7fff]
};


        
static ALWAYS_ENABLED: NonCustomPropertyIdSet = NonCustomPropertyIdSet {
    
    storage: [0xfbfcffff, 0x43fffbff, 0xfd7fb7d8, 0x3fe779df, 0xfffffdfc, 0xf7ffffff, 0xfff0d7ff, 0xfdf1dfee, 0x807fc01f, 0xfffbffff, 0x7fffffff, 0xdbfffffe, 0xffc7c7df, 0x1f8ff, 0xf8008000, 0xe0001f42, 0x13018000]
};


        let passes_pref_check = || {
                unsafe { structs::nsCSSProps_gPropertyEnabled[self.0] }
        };

        if ALWAYS_ENABLED.contains(self) {
            return true
        }

        if EXPERIMENTAL.contains(self) && passes_pref_check() {
            return true
        }

        false
    }

    fn allowed_in(self, context: &ParserContext) -> bool {
        debug_assert!(
            matches!(
                context.rule_type(),
                CssRuleType::Keyframe | CssRuleType::Page | CssRuleType::Style
            ),
            "Declarations are only expected inside a keyframe, page, or style rule."
        );

        
static DISALLOWED_IN_KEYFRAME_BLOCK: NonCustomPropertyIdSet = NonCustomPropertyIdSet {
    
    storage: [0x0, 0x0, 0x0, 0x0, 0x1ec00000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10000000, 0x0, 0x60000000, 0x1ff8, 0x0, 0xc00000]
};

        
static DISALLOWED_IN_PAGE_RULE: NonCustomPropertyIdSet = NonCustomPropertyIdSet {
    
    storage: [0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffe01f, 0xffffffff, 0xfffffeff, 0xffffffff, 0xffffffff, 0xfffff9ff, 0x7fffffff]
};

        match context.rule_type() {
            CssRuleType::Keyframe if DISALLOWED_IN_KEYFRAME_BLOCK.contains(self) => {
                return false;
            }
            CssRuleType::Page if DISALLOWED_IN_PAGE_RULE.contains(self) => {
                return false;
            }
            _ => {}
        }

        self.allowed_in_ignoring_rule_type(context)
    }


    fn allowed_in_ignoring_rule_type(self, context: &ParserContext) -> bool {
        // The semantics of these are kinda hard to reason about, what follows
        // is a description of the different combinations that can happen with
        // these three sets.
        //
        // Experimental properties are generally controlled by prefs, but an
        // experimental property explicitly enabled in certain context (UA or
        // chrome sheets) is always usable in the context regardless of the
        // pref value.
        //
        // Non-experimental properties are either normal properties which are
        // usable everywhere, or internal-only properties which are only usable
        // in certain context they are explicitly enabled in.
        if self.enabled_for_all_content() {
            return true;
        }

        
static ENABLED_IN_UA_SHEETS: NonCustomPropertyIdSet = NonCustomPropertyIdSet {
    
    storage: [0x30000, 0x2c000000, 0x2000821, 0xc0000000, 0x200, 0x0, 0x80800, 0x82000, 0x20, 0x0, 0x0, 0x4000000, 0x0, 0x0, 0x0, 0x1, 0x0]
};

        
static ENABLED_IN_CHROME: NonCustomPropertyIdSet = NonCustomPropertyIdSet {
    
    storage: [0x20000, 0x0, 0x2000800, 0x0, 0x200, 0x0, 0x80800, 0x82000, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0]
};


        if context.stylesheet_origin == Origin::UserAgent &&
            ENABLED_IN_UA_SHEETS.contains(self)
        {
            return true
        }

        if context.chrome_rules_enabled() && ENABLED_IN_CHROME.contains(self) {
            return true
        }

        false
    }

    /// The supported types of this property. The return value should be
    /// style_traits::CssType when it can become a bitflags type.
    fn supported_types(&self) -> u8 {
        const SUPPORTED_TYPES: [u8; 424] = [
                <crate::values::specified::AlignContent as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::AlignItems as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::AlignSelf as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::backface_visibility::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::border_collapse::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderImageRepeat as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::box_decoration_break::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::box_sizing::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BreakWithin as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::caption_side::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Clear as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::color_adjust::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::color_interpolation::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::color_interpolation_filters::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::ColumnCount as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::column_fill::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::column_span::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Contain as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::direction::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Display as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::dominant_baseline::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::empty_cells::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::flex_direction::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::flex_wrap::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Float as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::font_kerning::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::font_optical_sizing::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::FontSizeAdjust as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::FontStretch as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::FontStyle as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::FontSynthesis as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::font_variant_caps::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::FontVariantEastAsian as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::FontVariantLigatures as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::FontVariantNumeric as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::font_variant_position::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::FontWeight as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::GridAutoFlow as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::hyphens::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::image_orientation::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::image_rendering::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::ime_mode::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::InitialLetter as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::isolation::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::JustifyContent as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::JustifyItems as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::JustifySelf as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::list_style_position::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::mask_type::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::mix_blend_mode::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Appearance as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::_moz_box_align::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::_moz_box_direction::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::_moz_box_orient::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::_moz_box_pack::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::_moz_control_character_visibility::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::_moz_float_edge::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::MozForceBrokenImageIcon as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::MozListReversed as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::_moz_math_display::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::_moz_math_variant::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Percentage as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::_moz_orient::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::_moz_osx_font_smoothing::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::MozScriptLevel as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::MozScriptMinSize as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::MozScriptSizeMultiplier as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::_moz_stack_sizing::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::_moz_text_size_adjust::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::_moz_top_layer::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::_moz_user_focus::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::_moz_user_input::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::_moz_user_modify::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::UserSelect as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::_moz_window_dragging::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::_moz_window_shadow::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::object_fit::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::OutlineStyle as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::OverflowAnchor as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::OverflowWrap as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::SVGPaintOrder as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::pointer_events::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::position::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Resize as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::ruby_align::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::ruby_position::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::scroll_behavior::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::ScrollSnapAlign as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::ScrollSnapType as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::scrollbar_width::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::shape_rendering::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::stroke_linecap::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::stroke_linejoin::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::table_layout::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::TextAlign as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::text_align_last::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::text_anchor::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::text_combine_upright::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::TextDecorationLine as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::text_decoration_style::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::TextEmphasisPosition as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::text_justify::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::text_orientation::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::text_rendering::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::TextTransform as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::TouchAction as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::transform_box::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::TransformStyle as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::unicode_bidi::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::vector_effect::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::visibility::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::PositiveIntegerOrNone as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::white_space::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::WordBreak as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::writing_mode::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::XSpan as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::XTextZoom as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::ZIndex as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BreakBetween as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BreakBetween as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::FillRule as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::FillRule as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Integer as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Integer as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Overflow as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Overflow as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::OverflowClipBox as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::OverflowClipBox as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::OverscrollBehavior as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::OverscrollBehavior as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::SVGOpacity as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::SVGOpacity as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeNumber as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeNumber as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeNumber as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeNumber as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Opacity as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Opacity as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Opacity as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Opacity as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Opacity as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderStyle as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderStyle as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderStyle as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderStyle as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderStyle as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderStyle as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderStyle as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderStyle as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderStyle as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::animation_delay::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::animation_direction::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::animation_duration::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::animation_fill_mode::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::animation_iteration_count::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::animation_name::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::animation_play_state::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::animation_timing_function::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::background_attachment::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::background_blend_mode::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::background_clip::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::background_image::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::background_origin::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::background_position_x::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::background_position_y::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::background_repeat::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::background_size::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::NonNegativeLengthOrNumberRect> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::BorderImageSlice> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::ImageLayer as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::BorderImageWidth> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::BorderSpacing> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::box_shadow::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::ColorOrAuto> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::basic_shape::ClippingShape as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::ColorPropertyValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::length::NonNegativeLengthOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Content as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::CounterIncrement as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Cursor as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::filter::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::FlexBasis> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::FontFamily as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::FontFeatureSettings as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::FontLanguageOverride as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::FontSize as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::FontVariantAlternates as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::FontVariationSettings as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::GridTemplateAreas as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LetterSpacing as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LineHeight as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::url::ImageUrlOrNone as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::ListStyleType> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::mask_clip::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::mask_composite::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::mask_image::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::mask_mode::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::mask_origin::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::mask_position_x::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::mask_position_y::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::mask_repeat::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::mask_size::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::MozContextProperties as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::color::MozFontSmoothingBackgroundColor as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeLengthOrNumber as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::OffsetPath as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Perspective as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Quotes as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::Rotate> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::Scale> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::scroll_snap_coordinate::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::ui::ScrollbarColor> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::basic_shape::FloatAreaShape> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::SVGStrokeDashArray as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::SVGLength as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::SVGWidth as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::TextEmphasisStyle> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LengthPercentage as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::TextOverflow> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::text_shadow::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::transition_delay::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::transition_duration::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::transition_property::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <longhands::transition_timing_function::SpecifiedValue as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::Translate> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::VerticalAlign as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::WillChange as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::WordSpacing as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::XLang as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::ClipRectOrAuto> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::ClipRectOrAuto> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::GridTemplateComponent> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::GridTemplateComponent> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::SVGPaint> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::SVGPaint> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::TrackSize> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::TrackSize> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::TransformOrigin> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::TransformOrigin> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::CounterSetOrReset as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::CounterSetOrReset as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::ScrollSnapPoint as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::ScrollSnapPoint as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Transform as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Transform as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::length::NonNegativeLengthPercentageOrNormal as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::length::NonNegativeLengthPercentageOrNormal as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::Position> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::Position> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::Position> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::GridLine> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::GridLine> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::GridLine> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::GridLine> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::MaxSize as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::MaxSize as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::MaxSize as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::MaxSize as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::url::UrlOrNone as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::url::UrlOrNone as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::url::UrlOrNone as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::url::UrlOrNone as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeLengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeLengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeLengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeLengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeLengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeLengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeLengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeLengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Size as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Size as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Size as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Size as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Size as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Size as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Size as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Size as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Length as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Length as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Length as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Length as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Length as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Length as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Length as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Length as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Length as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeLengthPercentage as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeLengthPercentage as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeLengthPercentage as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeLengthPercentage as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeLengthPercentage as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeLengthPercentage as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeLengthPercentage as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeLengthPercentage as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::NonNegativeLengthPercentage as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Color as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Color as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Color as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Color as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Color as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Color as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Color as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Color as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Color as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Color as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Color as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Color as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Color as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Color as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Color as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Color as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Color as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <crate::values::specified::Color as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::background::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::background_position::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_color::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_style::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_width::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_top::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_right::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_bottom::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_left::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_block_start::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_block_end::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_inline_start::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_inline_end::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_radius::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_image::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_block_width::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_block_style::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_block_color::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_inline_width::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_inline_style::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_inline_color::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_block::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::border_inline::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::overflow::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::overflow_clip_box::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::transition::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::animation::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::overscroll_behavior::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::page_break_before::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::page_break_after::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::columns::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::column_rule::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::font::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::font_variant::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::text_emphasis::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::_webkit_text_stroke::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::marker::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::list_style::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::margin::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::margin_block::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::margin_inline::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::scroll_margin::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::scroll_margin_block::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::scroll_margin_inline::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::outline::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::_moz_outline_radius::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::padding::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::padding_block::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::padding_inline::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::scroll_padding::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::scroll_padding_block::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::scroll_padding_inline::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::flex_flow::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::flex::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::gap::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::grid_row::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::grid_column::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::grid_area::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::grid_template::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::grid::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::place_content::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::place_self::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::place_items::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::inset::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::inset_block::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::inset_inline::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::text_decoration::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::mask::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                <shorthands::mask_position::Longhands as SpecifiedValueInfo>::SUPPORTED_TYPES,
                0, // 'all' accepts no value other than CSS-wide keywords
        ];
        SUPPORTED_TYPES[self.0]
    }

    /// See PropertyId::collect_property_completion_keywords.
    fn collect_property_completion_keywords(&self, f: KeywordsCollectFn) {
        fn do_nothing(_: KeywordsCollectFn) {}
        const COLLECT_FUNCTIONS: [fn(KeywordsCollectFn);
                                  424] = [
                <crate::values::specified::AlignContent as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::AlignItems as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::AlignSelf as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::backface_visibility::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::border_collapse::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderImageRepeat as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::box_decoration_break::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::box_sizing::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BreakWithin as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::caption_side::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Clear as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::color_adjust::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::color_interpolation::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::color_interpolation_filters::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::ColumnCount as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::column_fill::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::column_span::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Contain as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::direction::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Display as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::dominant_baseline::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::empty_cells::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::flex_direction::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::flex_wrap::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Float as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::font_kerning::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::font_optical_sizing::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::FontSizeAdjust as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::FontStretch as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::FontStyle as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::FontSynthesis as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::font_variant_caps::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::FontVariantEastAsian as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::FontVariantLigatures as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::FontVariantNumeric as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::font_variant_position::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::FontWeight as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::GridAutoFlow as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::hyphens::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::image_orientation::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::image_rendering::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::ime_mode::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::InitialLetter as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::isolation::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::JustifyContent as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::JustifyItems as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::JustifySelf as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::list_style_position::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::mask_type::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::mix_blend_mode::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Appearance as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::_moz_box_align::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::_moz_box_direction::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::_moz_box_orient::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::_moz_box_pack::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::_moz_control_character_visibility::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::_moz_float_edge::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::MozForceBrokenImageIcon as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::MozListReversed as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::_moz_math_display::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::_moz_math_variant::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Percentage as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::_moz_orient::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::_moz_osx_font_smoothing::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::MozScriptLevel as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::MozScriptMinSize as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::MozScriptSizeMultiplier as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::_moz_stack_sizing::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::_moz_text_size_adjust::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::_moz_top_layer::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::_moz_user_focus::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::_moz_user_input::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::_moz_user_modify::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::UserSelect as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::_moz_window_dragging::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::_moz_window_shadow::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::object_fit::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::OutlineStyle as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::OverflowAnchor as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::OverflowWrap as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::SVGPaintOrder as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::pointer_events::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::position::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Resize as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::ruby_align::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::ruby_position::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::scroll_behavior::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::ScrollSnapAlign as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::ScrollSnapType as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::scrollbar_width::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::shape_rendering::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::stroke_linecap::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::stroke_linejoin::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::table_layout::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::TextAlign as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::text_align_last::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::text_anchor::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::text_combine_upright::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::TextDecorationLine as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::text_decoration_style::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::TextEmphasisPosition as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::text_justify::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::text_orientation::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::text_rendering::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::TextTransform as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::TouchAction as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::transform_box::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::TransformStyle as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::unicode_bidi::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::vector_effect::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::visibility::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::PositiveIntegerOrNone as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::white_space::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::WordBreak as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::writing_mode::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::XSpan as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::XTextZoom as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::ZIndex as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BreakBetween as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BreakBetween as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::FillRule as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::FillRule as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Integer as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Integer as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Overflow as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Overflow as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::OverflowClipBox as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::OverflowClipBox as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::OverscrollBehavior as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::OverscrollBehavior as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::SVGOpacity as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::SVGOpacity as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeNumber as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeNumber as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeNumber as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeNumber as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Opacity as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Opacity as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Opacity as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Opacity as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Opacity as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderStyle as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderStyle as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderStyle as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderStyle as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderStyle as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderStyle as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderStyle as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderStyle as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderStyle as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::animation_delay::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::animation_direction::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::animation_duration::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::animation_fill_mode::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::animation_iteration_count::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::animation_name::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::animation_play_state::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::animation_timing_function::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::background_attachment::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::background_blend_mode::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::background_clip::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::background_image::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::background_origin::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::background_position_x::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::background_position_y::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::background_repeat::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::background_size::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::NonNegativeLengthOrNumberRect> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::BorderImageSlice> as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::ImageLayer as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::BorderImageWidth> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::BorderSpacing> as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::box_shadow::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::ColorOrAuto> as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::basic_shape::ClippingShape as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::ColorPropertyValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::length::NonNegativeLengthOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Content as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::CounterIncrement as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Cursor as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::filter::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::FlexBasis> as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::FontFamily as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::FontFeatureSettings as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::FontLanguageOverride as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::FontSize as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::FontVariantAlternates as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::FontVariationSettings as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::GridTemplateAreas as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LetterSpacing as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LineHeight as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::url::ImageUrlOrNone as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::ListStyleType> as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::mask_clip::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::mask_composite::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::mask_image::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::mask_mode::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::mask_origin::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::mask_position_x::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::mask_position_y::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::mask_repeat::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::mask_size::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::MozContextProperties as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::color::MozFontSmoothingBackgroundColor as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeLengthOrNumber as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::OffsetPath as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Perspective as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Quotes as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::Rotate> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::Scale> as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::scroll_snap_coordinate::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::ui::ScrollbarColor> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::basic_shape::FloatAreaShape> as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::SVGStrokeDashArray as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::SVGLength as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::SVGWidth as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::TextEmphasisStyle> as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LengthPercentage as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::TextOverflow> as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::text_shadow::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::transition_delay::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::transition_duration::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::transition_property::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <longhands::transition_timing_function::SpecifiedValue as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::Translate> as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::VerticalAlign as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::WillChange as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::WordSpacing as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::XLang as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::ClipRectOrAuto> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::ClipRectOrAuto> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::GridTemplateComponent> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::GridTemplateComponent> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::SVGPaint> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::SVGPaint> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::TrackSize> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::TrackSize> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::TransformOrigin> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::TransformOrigin> as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::CounterSetOrReset as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::CounterSetOrReset as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::ScrollSnapPoint as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::ScrollSnapPoint as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Transform as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Transform as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::length::NonNegativeLengthPercentageOrNormal as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::length::NonNegativeLengthPercentageOrNormal as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::Position> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::Position> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::Position> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::GridLine> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::GridLine> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::GridLine> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::GridLine> as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::MaxSize as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::MaxSize as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::MaxSize as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::MaxSize as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::url::UrlOrNone as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::url::UrlOrNone as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::url::UrlOrNone as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::url::UrlOrNone as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeLengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeLengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeLengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeLengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeLengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeLengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeLengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeLengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Size as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Size as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Size as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Size as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Size as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Size as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Size as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Size as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Length as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Length as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Length as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Length as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Length as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Length as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Length as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Length as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Length as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeLengthPercentage as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeLengthPercentage as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeLengthPercentage as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeLengthPercentage as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeLengthPercentage as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeLengthPercentage as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeLengthPercentage as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeLengthPercentage as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::NonNegativeLengthPercentage as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::BorderSideWidth as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::collect_completion_keywords,
                <Box<crate::values::specified::BorderCornerRadius> as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::LengthPercentageOrAuto as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Color as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Color as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Color as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Color as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Color as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Color as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Color as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Color as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Color as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Color as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Color as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Color as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Color as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Color as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Color as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Color as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Color as SpecifiedValueInfo>::collect_completion_keywords,
                <crate::values::specified::Color as SpecifiedValueInfo>::collect_completion_keywords,
                <shorthands::background::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::background_position::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_color::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_style::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_width::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_top::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_right::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_bottom::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_left::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_block_start::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_block_end::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_inline_start::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_inline_end::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_radius::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_image::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_block_width::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_block_style::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_block_color::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_inline_width::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_inline_style::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_inline_color::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_block::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::border_inline::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::overflow::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::overflow_clip_box::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::transition::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::animation::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::overscroll_behavior::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::page_break_before::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::page_break_after::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::columns::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::column_rule::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::font::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::font_variant::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::text_emphasis::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::_webkit_text_stroke::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::marker::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::list_style::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::margin::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::margin_block::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::margin_inline::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::scroll_margin::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::scroll_margin_block::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::scroll_margin_inline::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::outline::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::_moz_outline_radius::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::padding::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::padding_block::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::padding_inline::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::scroll_padding::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::scroll_padding_block::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::scroll_padding_inline::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::flex_flow::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::flex::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::gap::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::grid_row::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::grid_column::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::grid_area::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::grid_template::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::grid::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::place_content::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::place_self::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::place_items::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::inset::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::inset_block::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::inset_inline::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::text_decoration::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::mask::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                <shorthands::mask_position::Longhands as SpecifiedValueInfo>::
                    collect_completion_keywords,
                do_nothing, // 'all' accepts no value other than CSS-wide keywords
        ];
        COLLECT_FUNCTIONS[self.0](f);
    }

    /// Turns this `NonCustomPropertyId` into a `PropertyId`.
    #[inline]
    pub fn to_property_id(self) -> PropertyId {
        use std::mem::transmute;
        if self.0 < 353 {
            return unsafe {
                PropertyId::Longhand(transmute(self.0 as u16))
            }
        }
        if self.0 < 424 {
            return unsafe {
                PropertyId::Shorthand(transmute((self.0 - 353) as u16))
            }
        }
        assert!(self.0 < NON_CUSTOM_PROPERTY_ID_COUNT);
        let alias_id: AliasId = unsafe {
            transmute((self.0 - 424) as u16)
        };

        match alias_id.aliased_property() {
            AliasedPropertyId::Longhand(longhand) => PropertyId::LonghandAlias(longhand, alias_id),
            AliasedPropertyId::Shorthand(shorthand) => PropertyId::ShorthandAlias(shorthand, alias_id),
        }
    }
}

impl From<LonghandId> for NonCustomPropertyId {
    #[inline]
    fn from(id: LonghandId) -> Self {
        NonCustomPropertyId(id as usize)
    }
}

impl From<ShorthandId> for NonCustomPropertyId {
    #[inline]
    fn from(id: ShorthandId) -> Self {
        NonCustomPropertyId((id as usize) + 353)
    }
}

impl From<AliasId> for NonCustomPropertyId {
    #[inline]
    fn from(id: AliasId) -> Self {
        NonCustomPropertyId(id as usize + 424)
    }
}

/// A set of all properties
#[derive(Clone, PartialEq)]
pub struct NonCustomPropertyIdSet {
    storage: [u32; (NON_CUSTOM_PROPERTY_ID_COUNT - 1 + 32) / 32]
}

impl NonCustomPropertyIdSet {
    /// Creates an empty `NonCustomPropertyIdSet`.
    pub fn new() -> Self {
        Self {
            storage: Default::default(),
        }
    }

    /// Insert a non-custom-property in the set.
    #[inline]
    pub fn insert(&mut self, id: NonCustomPropertyId) {
        let bit = id.0;
        self.storage[bit / 32] |= 1 << (bit % 32);
    }

    /// Return whether the given property is in the set
    #[inline]
    pub fn contains(&self, id: NonCustomPropertyId) -> bool {
        let bit = id.0;
        (self.storage[bit / 32] & (1 << (bit % 32))) != 0
    }
}





/// A set of longhand properties
#[derive(Clone, Copy, Debug, Default, MallocSizeOf, PartialEq)]
pub struct LonghandIdSet {
    storage: [u32; (353 - 1 + 32) / 32]
}

impl_trivial_to_shmem!(LonghandIdSet);

/// An iterator over a set of longhand ids.
pub struct LonghandIdSetIterator<'a> {
    longhands: &'a LonghandIdSet,
    cur: usize,
}

impl<'a> Iterator for LonghandIdSetIterator<'a> {
    type Item = LonghandId;

    fn next(&mut self) -> Option<Self::Item> {
        use std::mem;

        loop {
            if self.cur >= 353 {
                return None;
            }

            let id: LonghandId = unsafe { mem::transmute(self.cur as u16) };
            self.cur += 1;

            if self.longhands.contains(id) {
                return Some(id);
            }
        }
    }
}

impl LonghandIdSet {
    #[inline]
    fn reset() -> &'static Self {
        
static RESET: LonghandIdSet = LonghandIdSet {
    
    storage: [0x1dbc5ef, 0x437f7e20, 0x23cc7e28, 0xfce8be0c, 0xffffff73, 0x103757ff, 0xf41763fe, 0xfffff9a7, 0xffffffe3, 0xfffbffff, 0x3fffffff, 0x0]
};

        &RESET
    }

    #[inline]
    fn animatable() -> &'static Self {
        
static ANIMATABLE: LonghandIdSet = LonghandIdSet {
    
    storage: [0xfff9ffff, 0xc77fffff, 0xffffffd8, 0xffe3efbf, 0xc03c9fff, 0xffffffff, 0xffff3ff, 0xffffffeb, 0xffffffdf, 0xffffffff, 0xffffffff, 0x1]
};

        &ANIMATABLE
    }

    #[inline]
    fn discrete_animatable() -> &'static Self {
        
static DISCRETE_ANIMATABLE: LonghandIdSet = LonghandIdSet {
    
    storage: [0xc7f9bfff, 0xc77fffef, 0xffffffd8, 0xf7c32fbf, 0xc03c8003, 0x95ce07a7, 0x504813f, 0x3e079800, 0x1c, 0x40000, 0x0, 0x0]
};

        &DISCRETE_ANIMATABLE
    }

    #[inline]
    fn logical() -> &'static Self {
        
static LOGICAL: LonghandIdSet = LonghandIdSet {
    
    storage: [0x0, 0x0, 0x0, 0x0, 0x36000, 0x0, 0x0, 0x40000000, 0x8d8b46c1, 0x1e01b0d, 0x1b036f, 0x0]
};

        &LOGICAL
    }

    /// Returns the set of longhands that are ignored when document colors are
    /// disabled.
    #[inline]
    pub fn ignored_when_colors_disabled() -> &'static Self {
        
static IGNORED_WHEN_COLORS_DISABLED: LonghandIdSet = LonghandIdSet {
    
    storage: [0x0, 0x0, 0x0, 0x0, 0x0, 0xb202, 0x8080000, 0x0, 0x0, 0x0, 0xe9ff8000, 0x1]
};

        &IGNORED_WHEN_COLORS_DISABLED
    }

    /// Iterate over the current longhand id set.
    pub fn iter(&self) -> LonghandIdSetIterator {
        LonghandIdSetIterator { longhands: self, cur: 0, }
    }

    /// Returns whether this set contains at least every longhand that `other`
    /// also contains.
    pub fn contains_all(&self, other: &Self) -> bool {
        for (self_cell, other_cell) in self.storage.iter().zip(other.storage.iter()) {
            if (*self_cell & *other_cell) != *other_cell {
                return false;
            }
        }
        true
    }

    /// Returns whether this set contains any longhand that `other` also contains.
    pub fn contains_any(&self, other: &Self) -> bool {
        for (self_cell, other_cell) in self.storage.iter().zip(other.storage.iter()) {
            if (*self_cell & *other_cell) != 0 {
                return true;
            }
        }
        false
    }

    /// Remove all the given properties from the set.
    #[inline]
    pub fn remove_all(&mut self, other: &Self) {
        for (self_cell, other_cell) in self.storage.iter_mut().zip(other.storage.iter()) {
            *self_cell &= !*other_cell;
        }
    }

    /// Create an empty set
    #[inline]
    pub fn new() -> LonghandIdSet {
        LonghandIdSet { storage: [0; (353 - 1 + 32) / 32] }
    }

    /// Return whether the given property is in the set
    #[inline]
    pub fn contains(&self, id: LonghandId) -> bool {
        let bit = id as usize;
        (self.storage[bit / 32] & (1 << (bit % 32))) != 0
    }

    /// Return whether this set contains any reset longhand.
    #[inline]
    pub fn contains_any_reset(&self) -> bool {
        self.contains_any(Self::reset())
    }

    /// Add the given property to the set
    #[inline]
    pub fn insert(&mut self, id: LonghandId) {
        let bit = id as usize;
        self.storage[bit / 32] |= 1 << (bit % 32);
    }

    /// Remove the given property from the set
    #[inline]
    pub fn remove(&mut self, id: LonghandId) {
        let bit = id as usize;
        self.storage[bit / 32] &= !(1 << (bit % 32));
    }

    /// Clear all bits
    #[inline]
    pub fn clear(&mut self) {
        for cell in &mut self.storage {
            *cell = 0
        }
    }

    /// Returns whether the set is empty.
    #[inline]
    pub fn is_empty(&self) -> bool {
        self.storage.iter().all(|c| *c == 0)
    }
}

/// An enum to represent a CSS Wide keyword.
#[derive(Clone, Copy, Debug, Eq, MallocSizeOf, PartialEq, SpecifiedValueInfo,
         ToCss, ToShmem)]
pub enum CSSWideKeyword {
    /// The `initial` keyword.
    Initial,
    /// The `inherit` keyword.
    Inherit,
    /// The `unset` keyword.
    Unset,
    /// The `revert` keyword.
    Revert,
}

impl CSSWideKeyword {
    fn to_str(&self) -> &'static str {
        match *self {
            CSSWideKeyword::Initial => "initial",
            CSSWideKeyword::Inherit => "inherit",
            CSSWideKeyword::Unset => "unset",
            CSSWideKeyword::Revert => "revert",
        }
    }
}

impl CSSWideKeyword {
    fn parse(input: &mut Parser) -> Result<Self, ()> {
        let keyword = {
            let ident = input.expect_ident().map_err(|_| ())?;
            match_ignore_ascii_case! { ident,
                // If modifying this set of keyword, also update values::CustomIdent::from_ident
                "initial" => CSSWideKeyword::Initial,
                "inherit" => CSSWideKeyword::Inherit,
                "unset" => CSSWideKeyword::Unset,
                "revert" => CSSWideKeyword::Revert,
                _ => return Err(()),
            }
        };
        input.expect_exhausted().map_err(|_| ())?;
        Ok(keyword)
    }
}

bitflags! {
    /// A set of flags for properties.
    pub struct PropertyFlags: u8 {
        /// This property requires a stacking context.
        const CREATES_STACKING_CONTEXT = 1 << 0;
        /// This property has values that can establish a containing block for
        /// fixed positioned and absolutely positioned elements.
        const FIXPOS_CB = 1 << 1;
        /// This property has values that can establish a containing block for
        /// absolutely positioned elements.
        const ABSPOS_CB = 1 << 2;
        /// This longhand property applies to ::first-letter.
        const APPLIES_TO_FIRST_LETTER = 1 << 3;
        /// This longhand property applies to ::first-line.
        const APPLIES_TO_FIRST_LINE = 1 << 4;
        /// This longhand property applies to ::placeholder.
        const APPLIES_TO_PLACEHOLDER = 1 << 5;
        /// This property's getComputedStyle implementation requires layout
        /// to be flushed.
        const GETCS_NEEDS_LAYOUT_FLUSH = 1 << 6;
        /// This property is a legacy shorthand.
        ///
        /// https://drafts.csswg.org/css-cascade/#legacy-shorthand
        const IS_LEGACY_SHORTHAND = 1 << 7;

        /* The following flags are currently not used in Rust code, they
         * only need to be listed in corresponding properties so that
         * they can be checked in the C++ side via ServoCSSPropList.h. */
        /// This property can be animated on the compositor.
        const CAN_ANIMATE_ON_COMPOSITOR = 0;
        /// This shorthand property is accessible from getComputedStyle.
        const SHORTHAND_IN_GETCS = 0;
    }
}



/// A group for properties which may override each other
/// via logical resolution.
#[derive(Clone, Copy, Eq, Hash, PartialEq)]
pub enum LogicalGroup {
    /// border-radius
    BorderRadius,
    /// padding
    Padding,
    /// scroll-margin
    ScrollMargin,
    /// scroll-padding
    ScrollPadding,
    /// border-color
    BorderColor,
    /// border-width
    BorderWidth,
    /// max-size
    MaxSize,
    /// border-style
    BorderStyle,
    /// inset
    Inset,
    /// margin
    Margin,
    /// min-size
    MinSize,
    /// size
    Size,
}

/// An identifier for a given longhand property.
#[derive(Clone, Copy, Eq, Hash, MallocSizeOf, PartialEq, ToShmem)]
#[repr(u16)]
pub enum LonghandId {
        /// align-content
        AlignContent = 0,
        /// align-items
        AlignItems = 1,
        /// align-self
        AlignSelf = 2,
        /// backface-visibility
        BackfaceVisibility = 3,
        /// border-collapse
        BorderCollapse = 4,
        /// border-image-repeat
        BorderImageRepeat = 5,
        /// box-decoration-break
        BoxDecorationBreak = 6,
        /// box-sizing
        BoxSizing = 7,
        /// break-inside
        BreakInside = 8,
        /// caption-side
        CaptionSide = 9,
        /// clear
        Clear = 10,
        /// color-adjust
        ColorAdjust = 11,
        /// color-interpolation
        ColorInterpolation = 12,
        /// color-interpolation-filters
        ColorInterpolationFilters = 13,
        /// column-count
        ColumnCount = 14,
        /// column-fill
        ColumnFill = 15,
        /// column-span
        ColumnSpan = 16,
        /// contain
        Contain = 17,
        /// direction
        Direction = 18,
        /// display
        Display = 19,
        /// dominant-baseline
        DominantBaseline = 20,
        /// empty-cells
        EmptyCells = 21,
        /// flex-direction
        FlexDirection = 22,
        /// flex-wrap
        FlexWrap = 23,
        /// float
        Float = 24,
        /// font-kerning
        FontKerning = 25,
        /// font-optical-sizing
        FontOpticalSizing = 26,
        /// font-size-adjust
        FontSizeAdjust = 27,
        /// font-stretch
        FontStretch = 28,
        /// font-style
        FontStyle = 29,
        /// font-synthesis
        FontSynthesis = 30,
        /// font-variant-caps
        FontVariantCaps = 31,
        /// font-variant-east-asian
        FontVariantEastAsian = 32,
        /// font-variant-ligatures
        FontVariantLigatures = 33,
        /// font-variant-numeric
        FontVariantNumeric = 34,
        /// font-variant-position
        FontVariantPosition = 35,
        /// font-weight
        FontWeight = 36,
        /// grid-auto-flow
        GridAutoFlow = 37,
        /// hyphens
        Hyphens = 38,
        /// image-orientation
        ImageOrientation = 39,
        /// image-rendering
        ImageRendering = 40,
        /// ime-mode
        ImeMode = 41,
        /// initial-letter
        InitialLetter = 42,
        /// isolation
        Isolation = 43,
        /// justify-content
        JustifyContent = 44,
        /// justify-items
        JustifyItems = 45,
        /// justify-self
        JustifySelf = 46,
        /// list-style-position
        ListStylePosition = 47,
        /// mask-type
        MaskType = 48,
        /// mix-blend-mode
        MixBlendMode = 49,
        /// -moz-appearance
        MozAppearance = 50,
        /// -moz-box-align
        MozBoxAlign = 51,
        /// -moz-box-direction
        MozBoxDirection = 52,
        /// -moz-box-orient
        MozBoxOrient = 53,
        /// -moz-box-pack
        MozBoxPack = 54,
        /// -moz-control-character-visibility
        MozControlCharacterVisibility = 55,
        /// -moz-float-edge
        MozFloatEdge = 56,
        /// -moz-force-broken-image-icon
        MozForceBrokenImageIcon = 57,
        /// -moz-list-reversed
        MozListReversed = 58,
        /// -moz-math-display
        MozMathDisplay = 59,
        /// -moz-math-variant
        MozMathVariant = 60,
        /// -moz-min-font-size-ratio
        MozMinFontSizeRatio = 61,
        /// -moz-orient
        MozOrient = 62,
        /// -moz-osx-font-smoothing
        MozOsxFontSmoothing = 63,
        /// -moz-script-level
        MozScriptLevel = 64,
        /// -moz-script-min-size
        MozScriptMinSize = 65,
        /// -moz-script-size-multiplier
        MozScriptSizeMultiplier = 66,
        /// -moz-stack-sizing
        MozStackSizing = 67,
        /// -moz-text-size-adjust
        MozTextSizeAdjust = 68,
        /// -moz-top-layer
        MozTopLayer = 69,
        /// -moz-user-focus
        MozUserFocus = 70,
        /// -moz-user-input
        MozUserInput = 71,
        /// -moz-user-modify
        MozUserModify = 72,
        /// -moz-user-select
        MozUserSelect = 73,
        /// -moz-window-dragging
        MozWindowDragging = 74,
        /// -moz-window-shadow
        MozWindowShadow = 75,
        /// object-fit
        ObjectFit = 76,
        /// outline-style
        OutlineStyle = 77,
        /// overflow-anchor
        OverflowAnchor = 78,
        /// overflow-wrap
        OverflowWrap = 79,
        /// paint-order
        PaintOrder = 80,
        /// pointer-events
        PointerEvents = 81,
        /// position
        Position = 82,
        /// resize
        Resize = 83,
        /// ruby-align
        RubyAlign = 84,
        /// ruby-position
        RubyPosition = 85,
        /// scroll-behavior
        ScrollBehavior = 86,
        /// scroll-snap-align
        ScrollSnapAlign = 87,
        /// scroll-snap-type
        ScrollSnapType = 88,
        /// scrollbar-width
        ScrollbarWidth = 89,
        /// shape-rendering
        ShapeRendering = 90,
        /// stroke-linecap
        StrokeLinecap = 91,
        /// stroke-linejoin
        StrokeLinejoin = 92,
        /// table-layout
        TableLayout = 93,
        /// text-align
        TextAlign = 94,
        /// text-align-last
        TextAlignLast = 95,
        /// text-anchor
        TextAnchor = 96,
        /// text-combine-upright
        TextCombineUpright = 97,
        /// text-decoration-line
        TextDecorationLine = 98,
        /// text-decoration-style
        TextDecorationStyle = 99,
        /// text-emphasis-position
        TextEmphasisPosition = 100,
        /// text-justify
        TextJustify = 101,
        /// text-orientation
        TextOrientation = 102,
        /// text-rendering
        TextRendering = 103,
        /// text-transform
        TextTransform = 104,
        /// touch-action
        TouchAction = 105,
        /// transform-box
        TransformBox = 106,
        /// transform-style
        TransformStyle = 107,
        /// unicode-bidi
        UnicodeBidi = 108,
        /// vector-effect
        VectorEffect = 109,
        /// visibility
        Visibility = 110,
        /// -webkit-line-clamp
        WebkitLineClamp = 111,
        /// white-space
        WhiteSpace = 112,
        /// word-break
        WordBreak = 113,
        /// writing-mode
        WritingMode = 114,
        /// -x-span
        XSpan = 115,
        /// -x-text-zoom
        XTextZoom = 116,
        /// z-index
        ZIndex = 117,
        /// break-after
        BreakAfter = 118,
        /// break-before
        BreakBefore = 119,
        /// clip-rule
        ClipRule = 120,
        /// fill-rule
        FillRule = 121,
        /// -moz-box-ordinal-group
        MozBoxOrdinalGroup = 122,
        /// order
        Order = 123,
        /// overflow-x
        OverflowX = 124,
        /// overflow-y
        OverflowY = 125,
        /// overflow-clip-box-block
        OverflowClipBoxBlock = 126,
        /// overflow-clip-box-inline
        OverflowClipBoxInline = 127,
        /// overscroll-behavior-x
        OverscrollBehaviorX = 128,
        /// overscroll-behavior-y
        OverscrollBehaviorY = 129,
        /// fill-opacity
        FillOpacity = 130,
        /// stroke-opacity
        StrokeOpacity = 131,
        /// flex-grow
        FlexGrow = 132,
        /// flex-shrink
        FlexShrink = 133,
        /// -moz-box-flex
        MozBoxFlex = 134,
        /// stroke-miterlimit
        StrokeMiterlimit = 135,
        /// flood-opacity
        FloodOpacity = 136,
        /// -moz-window-opacity
        MozWindowOpacity = 137,
        /// opacity
        Opacity = 138,
        /// shape-image-threshold
        ShapeImageThreshold = 139,
        /// stop-opacity
        StopOpacity = 140,
        /// border-block-end-style
        BorderBlockEndStyle = 141,
        /// border-block-start-style
        BorderBlockStartStyle = 142,
        /// border-bottom-style
        BorderBottomStyle = 143,
        /// border-inline-end-style
        BorderInlineEndStyle = 144,
        /// border-inline-start-style
        BorderInlineStartStyle = 145,
        /// border-left-style
        BorderLeftStyle = 146,
        /// border-right-style
        BorderRightStyle = 147,
        /// border-top-style
        BorderTopStyle = 148,
        /// column-rule-style
        ColumnRuleStyle = 149,
        /// animation-delay
        AnimationDelay = 150,
        /// animation-direction
        AnimationDirection = 151,
        /// animation-duration
        AnimationDuration = 152,
        /// animation-fill-mode
        AnimationFillMode = 153,
        /// animation-iteration-count
        AnimationIterationCount = 154,
        /// animation-name
        AnimationName = 155,
        /// animation-play-state
        AnimationPlayState = 156,
        /// animation-timing-function
        AnimationTimingFunction = 157,
        /// background-attachment
        BackgroundAttachment = 158,
        /// background-blend-mode
        BackgroundBlendMode = 159,
        /// background-clip
        BackgroundClip = 160,
        /// background-image
        BackgroundImage = 161,
        /// background-origin
        BackgroundOrigin = 162,
        /// background-position-x
        BackgroundPositionX = 163,
        /// background-position-y
        BackgroundPositionY = 164,
        /// background-repeat
        BackgroundRepeat = 165,
        /// background-size
        BackgroundSize = 166,
        /// border-image-outset
        BorderImageOutset = 167,
        /// border-image-slice
        BorderImageSlice = 168,
        /// border-image-source
        BorderImageSource = 169,
        /// border-image-width
        BorderImageWidth = 170,
        /// border-spacing
        BorderSpacing = 171,
        /// box-shadow
        BoxShadow = 172,
        /// caret-color
        CaretColor = 173,
        /// clip-path
        ClipPath = 174,
        /// color
        Color = 175,
        /// column-width
        ColumnWidth = 176,
        /// content
        Content = 177,
        /// counter-increment
        CounterIncrement = 178,
        /// cursor
        Cursor = 179,
        /// filter
        Filter = 180,
        /// flex-basis
        FlexBasis = 181,
        /// font-family
        FontFamily = 182,
        /// font-feature-settings
        FontFeatureSettings = 183,
        /// font-language-override
        FontLanguageOverride = 184,
        /// font-size
        FontSize = 185,
        /// font-variant-alternates
        FontVariantAlternates = 186,
        /// font-variation-settings
        FontVariationSettings = 187,
        /// grid-template-areas
        GridTemplateAreas = 188,
        /// letter-spacing
        LetterSpacing = 189,
        /// line-height
        LineHeight = 190,
        /// list-style-image
        ListStyleImage = 191,
        /// list-style-type
        ListStyleType = 192,
        /// mask-clip
        MaskClip = 193,
        /// mask-composite
        MaskComposite = 194,
        /// mask-image
        MaskImage = 195,
        /// mask-mode
        MaskMode = 196,
        /// mask-origin
        MaskOrigin = 197,
        /// mask-position-x
        MaskPositionX = 198,
        /// mask-position-y
        MaskPositionY = 199,
        /// mask-repeat
        MaskRepeat = 200,
        /// mask-size
        MaskSize = 201,
        /// -moz-context-properties
        MozContextProperties = 202,
        /// -moz-font-smoothing-background-color
        MozFontSmoothingBackgroundColor = 203,
        /// -moz-tab-size
        MozTabSize = 204,
        /// offset-path
        OffsetPath = 205,
        /// perspective
        Perspective = 206,
        /// quotes
        Quotes = 207,
        /// rotate
        Rotate = 208,
        /// scale
        Scale = 209,
        /// scroll-snap-coordinate
        ScrollSnapCoordinate = 210,
        /// scrollbar-color
        ScrollbarColor = 211,
        /// shape-outside
        ShapeOutside = 212,
        /// stroke-dasharray
        StrokeDasharray = 213,
        /// stroke-dashoffset
        StrokeDashoffset = 214,
        /// stroke-width
        StrokeWidth = 215,
        /// text-emphasis-style
        TextEmphasisStyle = 216,
        /// text-indent
        TextIndent = 217,
        /// text-overflow
        TextOverflow = 218,
        /// text-shadow
        TextShadow = 219,
        /// transition-delay
        TransitionDelay = 220,
        /// transition-duration
        TransitionDuration = 221,
        /// transition-property
        TransitionProperty = 222,
        /// transition-timing-function
        TransitionTimingFunction = 223,
        /// translate
        Translate = 224,
        /// vertical-align
        VerticalAlign = 225,
        /// will-change
        WillChange = 226,
        /// word-spacing
        WordSpacing = 227,
        /// -x-lang
        XLang = 228,
        /// clip
        Clip = 229,
        /// -moz-image-region
        MozImageRegion = 230,
        /// grid-template-columns
        GridTemplateColumns = 231,
        /// grid-template-rows
        GridTemplateRows = 232,
        /// fill
        Fill = 233,
        /// stroke
        Stroke = 234,
        /// grid-auto-columns
        GridAutoColumns = 235,
        /// grid-auto-rows
        GridAutoRows = 236,
        /// -moz-window-transform-origin
        MozWindowTransformOrigin = 237,
        /// transform-origin
        TransformOrigin = 238,
        /// counter-reset
        CounterReset = 239,
        /// counter-set
        CounterSet = 240,
        /// scroll-snap-points-x
        ScrollSnapPointsX = 241,
        /// scroll-snap-points-y
        ScrollSnapPointsY = 242,
        /// -moz-window-transform
        MozWindowTransform = 243,
        /// transform
        Transform = 244,
        /// column-gap
        ColumnGap = 245,
        /// row-gap
        RowGap = 246,
        /// object-position
        ObjectPosition = 247,
        /// perspective-origin
        PerspectiveOrigin = 248,
        /// scroll-snap-destination
        ScrollSnapDestination = 249,
        /// grid-column-end
        GridColumnEnd = 250,
        /// grid-column-start
        GridColumnStart = 251,
        /// grid-row-end
        GridRowEnd = 252,
        /// grid-row-start
        GridRowStart = 253,
        /// max-block-size
        MaxBlockSize = 254,
        /// max-height
        MaxHeight = 255,
        /// max-inline-size
        MaxInlineSize = 256,
        /// max-width
        MaxWidth = 257,
        /// marker-end
        MarkerEnd = 258,
        /// marker-mid
        MarkerMid = 259,
        /// marker-start
        MarkerStart = 260,
        /// -moz-binding
        MozBinding = 261,
        /// scroll-padding-block-end
        ScrollPaddingBlockEnd = 262,
        /// scroll-padding-block-start
        ScrollPaddingBlockStart = 263,
        /// scroll-padding-bottom
        ScrollPaddingBottom = 264,
        /// scroll-padding-inline-end
        ScrollPaddingInlineEnd = 265,
        /// scroll-padding-inline-start
        ScrollPaddingInlineStart = 266,
        /// scroll-padding-left
        ScrollPaddingLeft = 267,
        /// scroll-padding-right
        ScrollPaddingRight = 268,
        /// scroll-padding-top
        ScrollPaddingTop = 269,
        /// block-size
        BlockSize = 270,
        /// height
        Height = 271,
        /// inline-size
        InlineSize = 272,
        /// min-block-size
        MinBlockSize = 273,
        /// min-height
        MinHeight = 274,
        /// min-inline-size
        MinInlineSize = 275,
        /// min-width
        MinWidth = 276,
        /// width
        Width = 277,
        /// outline-offset
        OutlineOffset = 278,
        /// scroll-margin-block-end
        ScrollMarginBlockEnd = 279,
        /// scroll-margin-block-start
        ScrollMarginBlockStart = 280,
        /// scroll-margin-bottom
        ScrollMarginBottom = 281,
        /// scroll-margin-inline-end
        ScrollMarginInlineEnd = 282,
        /// scroll-margin-inline-start
        ScrollMarginInlineStart = 283,
        /// scroll-margin-left
        ScrollMarginLeft = 284,
        /// scroll-margin-right
        ScrollMarginRight = 285,
        /// scroll-margin-top
        ScrollMarginTop = 286,
        /// padding-block-end
        PaddingBlockEnd = 287,
        /// padding-block-start
        PaddingBlockStart = 288,
        /// padding-bottom
        PaddingBottom = 289,
        /// padding-inline-end
        PaddingInlineEnd = 290,
        /// padding-inline-start
        PaddingInlineStart = 291,
        /// padding-left
        PaddingLeft = 292,
        /// padding-right
        PaddingRight = 293,
        /// padding-top
        PaddingTop = 294,
        /// shape-margin
        ShapeMargin = 295,
        /// border-block-end-width
        BorderBlockEndWidth = 296,
        /// border-block-start-width
        BorderBlockStartWidth = 297,
        /// border-bottom-width
        BorderBottomWidth = 298,
        /// border-inline-end-width
        BorderInlineEndWidth = 299,
        /// border-inline-start-width
        BorderInlineStartWidth = 300,
        /// border-left-width
        BorderLeftWidth = 301,
        /// border-right-width
        BorderRightWidth = 302,
        /// border-top-width
        BorderTopWidth = 303,
        /// column-rule-width
        ColumnRuleWidth = 304,
        /// outline-width
        OutlineWidth = 305,
        /// -webkit-text-stroke-width
        WebkitTextStrokeWidth = 306,
        /// border-bottom-left-radius
        BorderBottomLeftRadius = 307,
        /// border-bottom-right-radius
        BorderBottomRightRadius = 308,
        /// border-end-end-radius
        BorderEndEndRadius = 309,
        /// border-end-start-radius
        BorderEndStartRadius = 310,
        /// border-start-end-radius
        BorderStartEndRadius = 311,
        /// border-start-start-radius
        BorderStartStartRadius = 312,
        /// border-top-left-radius
        BorderTopLeftRadius = 313,
        /// border-top-right-radius
        BorderTopRightRadius = 314,
        /// -moz-outline-radius-bottomleft
        MozOutlineRadiusBottomleft = 315,
        /// -moz-outline-radius-bottomright
        MozOutlineRadiusBottomright = 316,
        /// -moz-outline-radius-topleft
        MozOutlineRadiusTopleft = 317,
        /// -moz-outline-radius-topright
        MozOutlineRadiusTopright = 318,
        /// bottom
        Bottom = 319,
        /// inset-block-end
        InsetBlockEnd = 320,
        /// inset-block-start
        InsetBlockStart = 321,
        /// inset-inline-end
        InsetInlineEnd = 322,
        /// inset-inline-start
        InsetInlineStart = 323,
        /// left
        Left = 324,
        /// margin-block-end
        MarginBlockEnd = 325,
        /// margin-block-start
        MarginBlockStart = 326,
        /// margin-bottom
        MarginBottom = 327,
        /// margin-inline-end
        MarginInlineEnd = 328,
        /// margin-inline-start
        MarginInlineStart = 329,
        /// margin-left
        MarginLeft = 330,
        /// margin-right
        MarginRight = 331,
        /// margin-top
        MarginTop = 332,
        /// right
        Right = 333,
        /// top
        Top = 334,
        /// background-color
        BackgroundColor = 335,
        /// border-block-end-color
        BorderBlockEndColor = 336,
        /// border-block-start-color
        BorderBlockStartColor = 337,
        /// border-bottom-color
        BorderBottomColor = 338,
        /// border-inline-end-color
        BorderInlineEndColor = 339,
        /// border-inline-start-color
        BorderInlineStartColor = 340,
        /// border-left-color
        BorderLeftColor = 341,
        /// border-right-color
        BorderRightColor = 342,
        /// border-top-color
        BorderTopColor = 343,
        /// column-rule-color
        ColumnRuleColor = 344,
        /// flood-color
        FloodColor = 345,
        /// lighting-color
        LightingColor = 346,
        /// outline-color
        OutlineColor = 347,
        /// stop-color
        StopColor = 348,
        /// text-decoration-color
        TextDecorationColor = 349,
        /// text-emphasis-color
        TextEmphasisColor = 350,
        /// -webkit-text-fill-color
        WebkitTextFillColor = 351,
        /// -webkit-text-stroke-color
        WebkitTextStrokeColor = 352,
}

impl ToCss for LonghandId {
    #[inline]
    fn to_css<W>(&self, dest: &mut CssWriter<W>) -> fmt::Result
    where
        W: Write,
    {
        dest.write_str(self.name())
    }
}

impl fmt::Debug for LonghandId {
    fn fmt(&self, formatter: &mut fmt::Formatter) -> fmt::Result {
        formatter.write_str(self.name())
    }
}

impl LonghandId {
    /// Get the name of this longhand property.
    #[inline]
    pub fn name(&self) -> &'static str {
        NonCustomPropertyId::from(*self).name()
    }

    /// Returns whether the longhand property is inherited by default.
    #[inline]
    pub fn inherited(self) -> bool {
        !LonghandIdSet::reset().contains(self)
    }

    fn shorthands(&self) -> NonCustomPropertyIterator<ShorthandId> {
        // first generate longhand to shorthands lookup map
        //
        // NOTE(emilio): This currently doesn't exclude the "all" shorthand. It
        // could potentially do so, which would speed up serialization
        // algorithms and what not, I guess.
        

        // based on lookup results for each longhand, create result arrays
            static ALIGN_CONTENT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::PlaceContent,
            ];
            static ALIGN_ITEMS: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::PlaceItems,
            ];
            static ALIGN_SELF: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::PlaceSelf,
            ];
            static BACKFACE_VISIBILITY: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static BORDER_COLLAPSE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static BORDER_IMAGE_REPEAT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Border,
                    ShorthandId::BorderImage,
            ];
            static BOX_DECORATION_BREAK: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static BOX_SIZING: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static BREAK_INSIDE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static CAPTION_SIDE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static CLEAR: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static COLOR_ADJUST: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static COLOR_INTERPOLATION: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static COLOR_INTERPOLATION_FILTERS: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static COLUMN_COUNT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Columns,
            ];
            static COLUMN_FILL: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static COLUMN_SPAN: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static CONTAIN: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static DIRECTION: &'static [ShorthandId] = &[
            ];
            static DISPLAY: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static DOMINANT_BASELINE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static EMPTY_CELLS: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static FLEX_DIRECTION: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::FlexFlow,
            ];
            static FLEX_WRAP: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::FlexFlow,
            ];
            static FLOAT: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static FONT_KERNING: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Font,
            ];
            static FONT_OPTICAL_SIZING: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Font,
            ];
            static FONT_SIZE_ADJUST: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Font,
            ];
            static FONT_STRETCH: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Font,
            ];
            static FONT_STYLE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Font,
            ];
            static FONT_SYNTHESIS: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static FONT_VARIANT_CAPS: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Font,
                    ShorthandId::FontVariant,
            ];
            static FONT_VARIANT_EAST_ASIAN: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Font,
                    ShorthandId::FontVariant,
            ];
            static FONT_VARIANT_LIGATURES: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Font,
                    ShorthandId::FontVariant,
            ];
            static FONT_VARIANT_NUMERIC: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Font,
                    ShorthandId::FontVariant,
            ];
            static FONT_VARIANT_POSITION: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Font,
                    ShorthandId::FontVariant,
            ];
            static FONT_WEIGHT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Font,
            ];
            static GRID_AUTO_FLOW: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Grid,
            ];
            static HYPHENS: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static IMAGE_ORIENTATION: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static IMAGE_RENDERING: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static IME_MODE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static INITIAL_LETTER: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static ISOLATION: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static JUSTIFY_CONTENT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::PlaceContent,
            ];
            static JUSTIFY_ITEMS: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::PlaceItems,
            ];
            static JUSTIFY_SELF: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::PlaceSelf,
            ];
            static LIST_STYLE_POSITION: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ListStyle,
            ];
            static MASK_TYPE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static MIX_BLEND_MODE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_APPEARANCE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_BOX_ALIGN: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_BOX_DIRECTION: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_BOX_ORIENT: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_BOX_PACK: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_CONTROL_CHARACTER_VISIBILITY: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_FLOAT_EDGE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_FORCE_BROKEN_IMAGE_ICON: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_LIST_REVERSED: &'static [ShorthandId] = &[
            ];
            static _MOZ_MATH_DISPLAY: &'static [ShorthandId] = &[
            ];
            static _MOZ_MATH_VARIANT: &'static [ShorthandId] = &[
            ];
            static _MOZ_MIN_FONT_SIZE_RATIO: &'static [ShorthandId] = &[
            ];
            static _MOZ_ORIENT: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_OSX_FONT_SMOOTHING: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_SCRIPT_LEVEL: &'static [ShorthandId] = &[
            ];
            static _MOZ_SCRIPT_MIN_SIZE: &'static [ShorthandId] = &[
            ];
            static _MOZ_SCRIPT_SIZE_MULTIPLIER: &'static [ShorthandId] = &[
            ];
            static _MOZ_STACK_SIZING: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_TEXT_SIZE_ADJUST: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_TOP_LAYER: &'static [ShorthandId] = &[
            ];
            static _MOZ_USER_FOCUS: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_USER_INPUT: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_USER_MODIFY: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_USER_SELECT: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_WINDOW_DRAGGING: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_WINDOW_SHADOW: &'static [ShorthandId] = &[
            ];
            static OBJECT_FIT: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static OUTLINE_STYLE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Outline,
            ];
            static OVERFLOW_ANCHOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static OVERFLOW_WRAP: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static PAINT_ORDER: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static POINTER_EVENTS: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static POSITION: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static RESIZE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static RUBY_ALIGN: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static RUBY_POSITION: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static SCROLL_BEHAVIOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static SCROLL_SNAP_ALIGN: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static SCROLL_SNAP_TYPE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static SCROLLBAR_WIDTH: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static SHAPE_RENDERING: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static STROKE_LINECAP: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static STROKE_LINEJOIN: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static TABLE_LAYOUT: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static TEXT_ALIGN: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static TEXT_ALIGN_LAST: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static TEXT_ANCHOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static TEXT_COMBINE_UPRIGHT: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static TEXT_DECORATION_LINE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::TextDecoration,
            ];
            static TEXT_DECORATION_STYLE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::TextDecoration,
            ];
            static TEXT_EMPHASIS_POSITION: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static TEXT_JUSTIFY: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static TEXT_ORIENTATION: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static TEXT_RENDERING: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static TEXT_TRANSFORM: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static TOUCH_ACTION: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static TRANSFORM_BOX: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static TRANSFORM_STYLE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static UNICODE_BIDI: &'static [ShorthandId] = &[
            ];
            static VECTOR_EFFECT: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static VISIBILITY: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _WEBKIT_LINE_CLAMP: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static WHITE_SPACE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static WORD_BREAK: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static WRITING_MODE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _X_SPAN: &'static [ShorthandId] = &[
            ];
            static _X_TEXT_ZOOM: &'static [ShorthandId] = &[
            ];
            static Z_INDEX: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static BREAK_AFTER: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::PageBreakAfter,
            ];
            static BREAK_BEFORE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::PageBreakBefore,
            ];
            static CLIP_RULE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static FILL_RULE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_BOX_ORDINAL_GROUP: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static ORDER: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static OVERFLOW_X: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Overflow,
            ];
            static OVERFLOW_Y: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Overflow,
            ];
            static OVERFLOW_CLIP_BOX_BLOCK: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::OverflowClipBox,
            ];
            static OVERFLOW_CLIP_BOX_INLINE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::OverflowClipBox,
            ];
            static OVERSCROLL_BEHAVIOR_X: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::OverscrollBehavior,
            ];
            static OVERSCROLL_BEHAVIOR_Y: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::OverscrollBehavior,
            ];
            static FILL_OPACITY: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static STROKE_OPACITY: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static FLEX_GROW: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Flex,
            ];
            static FLEX_SHRINK: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Flex,
            ];
            static _MOZ_BOX_FLEX: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static STROKE_MITERLIMIT: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static FLOOD_OPACITY: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_WINDOW_OPACITY: &'static [ShorthandId] = &[
            ];
            static OPACITY: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static SHAPE_IMAGE_THRESHOLD: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static STOP_OPACITY: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static BORDER_BLOCK_END_STYLE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::BorderBlock,
                    ShorthandId::BorderBlockEnd,
                    ShorthandId::BorderBlockStyle,
            ];
            static BORDER_BLOCK_START_STYLE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::BorderBlock,
                    ShorthandId::BorderBlockStart,
                    ShorthandId::BorderBlockStyle,
            ];
            static BORDER_BOTTOM_STYLE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Border,
                    ShorthandId::BorderStyle,
                    ShorthandId::BorderBottom,
            ];
            static BORDER_INLINE_END_STYLE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::BorderInline,
                    ShorthandId::BorderInlineEnd,
                    ShorthandId::BorderInlineStyle,
            ];
            static BORDER_INLINE_START_STYLE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::BorderInline,
                    ShorthandId::BorderInlineStart,
                    ShorthandId::BorderInlineStyle,
            ];
            static BORDER_LEFT_STYLE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Border,
                    ShorthandId::BorderStyle,
                    ShorthandId::BorderLeft,
            ];
            static BORDER_RIGHT_STYLE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Border,
                    ShorthandId::BorderStyle,
                    ShorthandId::BorderRight,
            ];
            static BORDER_TOP_STYLE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Border,
                    ShorthandId::BorderStyle,
                    ShorthandId::BorderTop,
            ];
            static COLUMN_RULE_STYLE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ColumnRule,
            ];
            static ANIMATION_DELAY: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Animation,
            ];
            static ANIMATION_DIRECTION: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Animation,
            ];
            static ANIMATION_DURATION: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Animation,
            ];
            static ANIMATION_FILL_MODE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Animation,
            ];
            static ANIMATION_ITERATION_COUNT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Animation,
            ];
            static ANIMATION_NAME: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Animation,
            ];
            static ANIMATION_PLAY_STATE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Animation,
            ];
            static ANIMATION_TIMING_FUNCTION: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Animation,
            ];
            static BACKGROUND_ATTACHMENT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Background,
            ];
            static BACKGROUND_BLEND_MODE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static BACKGROUND_CLIP: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Background,
            ];
            static BACKGROUND_IMAGE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Background,
            ];
            static BACKGROUND_ORIGIN: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Background,
            ];
            static BACKGROUND_POSITION_X: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Background,
                    ShorthandId::BackgroundPosition,
            ];
            static BACKGROUND_POSITION_Y: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Background,
                    ShorthandId::BackgroundPosition,
            ];
            static BACKGROUND_REPEAT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Background,
            ];
            static BACKGROUND_SIZE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Background,
            ];
            static BORDER_IMAGE_OUTSET: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Border,
                    ShorthandId::BorderImage,
            ];
            static BORDER_IMAGE_SLICE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Border,
                    ShorthandId::BorderImage,
            ];
            static BORDER_IMAGE_SOURCE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Border,
                    ShorthandId::BorderImage,
            ];
            static BORDER_IMAGE_WIDTH: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Border,
                    ShorthandId::BorderImage,
            ];
            static BORDER_SPACING: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static BOX_SHADOW: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static CARET_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static CLIP_PATH: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static COLUMN_WIDTH: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Columns,
            ];
            static CONTENT: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static COUNTER_INCREMENT: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static CURSOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static FILTER: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static FLEX_BASIS: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Flex,
            ];
            static FONT_FAMILY: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Font,
            ];
            static FONT_FEATURE_SETTINGS: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Font,
            ];
            static FONT_LANGUAGE_OVERRIDE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Font,
            ];
            static FONT_SIZE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Font,
            ];
            static FONT_VARIANT_ALTERNATES: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Font,
                    ShorthandId::FontVariant,
            ];
            static FONT_VARIATION_SETTINGS: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Font,
            ];
            static GRID_TEMPLATE_AREAS: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Grid,
                    ShorthandId::GridTemplate,
            ];
            static LETTER_SPACING: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static LINE_HEIGHT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Font,
            ];
            static LIST_STYLE_IMAGE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ListStyle,
            ];
            static LIST_STYLE_TYPE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ListStyle,
            ];
            static MASK_CLIP: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Mask,
            ];
            static MASK_COMPOSITE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Mask,
            ];
            static MASK_IMAGE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Mask,
            ];
            static MASK_MODE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Mask,
            ];
            static MASK_ORIGIN: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Mask,
            ];
            static MASK_POSITION_X: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Mask,
                    ShorthandId::MaskPosition,
            ];
            static MASK_POSITION_Y: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Mask,
                    ShorthandId::MaskPosition,
            ];
            static MASK_REPEAT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Mask,
            ];
            static MASK_SIZE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Mask,
            ];
            static _MOZ_CONTEXT_PROPERTIES: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_FONT_SMOOTHING_BACKGROUND_COLOR: &'static [ShorthandId] = &[
            ];
            static _MOZ_TAB_SIZE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static OFFSET_PATH: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static PERSPECTIVE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static QUOTES: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static ROTATE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static SCALE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static SCROLL_SNAP_COORDINATE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static SCROLLBAR_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static SHAPE_OUTSIDE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static STROKE_DASHARRAY: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static STROKE_DASHOFFSET: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static STROKE_WIDTH: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static TEXT_EMPHASIS_STYLE: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::TextEmphasis,
            ];
            static TEXT_INDENT: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static TEXT_OVERFLOW: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static TEXT_SHADOW: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static TRANSITION_DELAY: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Transition,
            ];
            static TRANSITION_DURATION: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Transition,
            ];
            static TRANSITION_PROPERTY: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Transition,
            ];
            static TRANSITION_TIMING_FUNCTION: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Transition,
            ];
            static TRANSLATE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static VERTICAL_ALIGN: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static WILL_CHANGE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static WORD_SPACING: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _X_LANG: &'static [ShorthandId] = &[
            ];
            static CLIP: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_IMAGE_REGION: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static GRID_TEMPLATE_COLUMNS: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Grid,
                    ShorthandId::GridTemplate,
            ];
            static GRID_TEMPLATE_ROWS: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Grid,
                    ShorthandId::GridTemplate,
            ];
            static FILL: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static STROKE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static GRID_AUTO_COLUMNS: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Grid,
            ];
            static GRID_AUTO_ROWS: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Grid,
            ];
            static _MOZ_WINDOW_TRANSFORM_ORIGIN: &'static [ShorthandId] = &[
            ];
            static TRANSFORM_ORIGIN: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static COUNTER_RESET: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static COUNTER_SET: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static SCROLL_SNAP_POINTS_X: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static SCROLL_SNAP_POINTS_Y: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _MOZ_WINDOW_TRANSFORM: &'static [ShorthandId] = &[
            ];
            static TRANSFORM: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static COLUMN_GAP: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Gap,
            ];
            static ROW_GAP: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Gap,
            ];
            static OBJECT_POSITION: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static PERSPECTIVE_ORIGIN: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static SCROLL_SNAP_DESTINATION: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static GRID_COLUMN_END: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::GridArea,
                    ShorthandId::GridColumn,
            ];
            static GRID_COLUMN_START: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::GridArea,
                    ShorthandId::GridColumn,
            ];
            static GRID_ROW_END: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::GridArea,
                    ShorthandId::GridRow,
            ];
            static GRID_ROW_START: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::GridArea,
                    ShorthandId::GridRow,
            ];
            static MAX_BLOCK_SIZE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static MAX_HEIGHT: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static MAX_INLINE_SIZE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static MAX_WIDTH: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static MARKER_END: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Marker,
            ];
            static MARKER_MID: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Marker,
            ];
            static MARKER_START: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Marker,
            ];
            static _MOZ_BINDING: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static SCROLL_PADDING_BLOCK_END: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ScrollPaddingBlock,
            ];
            static SCROLL_PADDING_BLOCK_START: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ScrollPaddingBlock,
            ];
            static SCROLL_PADDING_BOTTOM: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ScrollPadding,
            ];
            static SCROLL_PADDING_INLINE_END: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ScrollPaddingInline,
            ];
            static SCROLL_PADDING_INLINE_START: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ScrollPaddingInline,
            ];
            static SCROLL_PADDING_LEFT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ScrollPadding,
            ];
            static SCROLL_PADDING_RIGHT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ScrollPadding,
            ];
            static SCROLL_PADDING_TOP: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ScrollPadding,
            ];
            static BLOCK_SIZE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static HEIGHT: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static INLINE_SIZE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static MIN_BLOCK_SIZE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static MIN_HEIGHT: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static MIN_INLINE_SIZE: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static MIN_WIDTH: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static WIDTH: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static OUTLINE_OFFSET: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static SCROLL_MARGIN_BLOCK_END: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ScrollMarginBlock,
            ];
            static SCROLL_MARGIN_BLOCK_START: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ScrollMarginBlock,
            ];
            static SCROLL_MARGIN_BOTTOM: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ScrollMargin,
            ];
            static SCROLL_MARGIN_INLINE_END: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ScrollMarginInline,
            ];
            static SCROLL_MARGIN_INLINE_START: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ScrollMarginInline,
            ];
            static SCROLL_MARGIN_LEFT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ScrollMargin,
            ];
            static SCROLL_MARGIN_RIGHT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ScrollMargin,
            ];
            static SCROLL_MARGIN_TOP: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ScrollMargin,
            ];
            static PADDING_BLOCK_END: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::PaddingBlock,
            ];
            static PADDING_BLOCK_START: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::PaddingBlock,
            ];
            static PADDING_BOTTOM: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Padding,
            ];
            static PADDING_INLINE_END: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::PaddingInline,
            ];
            static PADDING_INLINE_START: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::PaddingInline,
            ];
            static PADDING_LEFT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Padding,
            ];
            static PADDING_RIGHT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Padding,
            ];
            static PADDING_TOP: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Padding,
            ];
            static SHAPE_MARGIN: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static BORDER_BLOCK_END_WIDTH: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::BorderBlock,
                    ShorthandId::BorderBlockEnd,
                    ShorthandId::BorderBlockWidth,
            ];
            static BORDER_BLOCK_START_WIDTH: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::BorderBlock,
                    ShorthandId::BorderBlockStart,
                    ShorthandId::BorderBlockWidth,
            ];
            static BORDER_BOTTOM_WIDTH: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Border,
                    ShorthandId::BorderWidth,
                    ShorthandId::BorderBottom,
            ];
            static BORDER_INLINE_END_WIDTH: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::BorderInline,
                    ShorthandId::BorderInlineEnd,
                    ShorthandId::BorderInlineWidth,
            ];
            static BORDER_INLINE_START_WIDTH: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::BorderInline,
                    ShorthandId::BorderInlineStart,
                    ShorthandId::BorderInlineWidth,
            ];
            static BORDER_LEFT_WIDTH: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Border,
                    ShorthandId::BorderWidth,
                    ShorthandId::BorderLeft,
            ];
            static BORDER_RIGHT_WIDTH: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Border,
                    ShorthandId::BorderWidth,
                    ShorthandId::BorderRight,
            ];
            static BORDER_TOP_WIDTH: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Border,
                    ShorthandId::BorderWidth,
                    ShorthandId::BorderTop,
            ];
            static COLUMN_RULE_WIDTH: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ColumnRule,
            ];
            static OUTLINE_WIDTH: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Outline,
            ];
            static _WEBKIT_TEXT_STROKE_WIDTH: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::WebkitTextStroke,
            ];
            static BORDER_BOTTOM_LEFT_RADIUS: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::BorderRadius,
            ];
            static BORDER_BOTTOM_RIGHT_RADIUS: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::BorderRadius,
            ];
            static BORDER_END_END_RADIUS: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static BORDER_END_START_RADIUS: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static BORDER_START_END_RADIUS: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static BORDER_START_START_RADIUS: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static BORDER_TOP_LEFT_RADIUS: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::BorderRadius,
            ];
            static BORDER_TOP_RIGHT_RADIUS: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::BorderRadius,
            ];
            static _MOZ_OUTLINE_RADIUS_BOTTOMLEFT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::MozOutlineRadius,
            ];
            static _MOZ_OUTLINE_RADIUS_BOTTOMRIGHT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::MozOutlineRadius,
            ];
            static _MOZ_OUTLINE_RADIUS_TOPLEFT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::MozOutlineRadius,
            ];
            static _MOZ_OUTLINE_RADIUS_TOPRIGHT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::MozOutlineRadius,
            ];
            static BOTTOM: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Inset,
            ];
            static INSET_BLOCK_END: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::InsetBlock,
            ];
            static INSET_BLOCK_START: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::InsetBlock,
            ];
            static INSET_INLINE_END: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::InsetInline,
            ];
            static INSET_INLINE_START: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::InsetInline,
            ];
            static LEFT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Inset,
            ];
            static MARGIN_BLOCK_END: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::MarginBlock,
            ];
            static MARGIN_BLOCK_START: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::MarginBlock,
            ];
            static MARGIN_BOTTOM: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Margin,
            ];
            static MARGIN_INLINE_END: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::MarginInline,
            ];
            static MARGIN_INLINE_START: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::MarginInline,
            ];
            static MARGIN_LEFT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Margin,
            ];
            static MARGIN_RIGHT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Margin,
            ];
            static MARGIN_TOP: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Margin,
            ];
            static RIGHT: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Inset,
            ];
            static TOP: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Inset,
            ];
            static BACKGROUND_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Background,
            ];
            static BORDER_BLOCK_END_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::BorderBlock,
                    ShorthandId::BorderBlockEnd,
                    ShorthandId::BorderBlockColor,
            ];
            static BORDER_BLOCK_START_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::BorderBlock,
                    ShorthandId::BorderBlockStart,
                    ShorthandId::BorderBlockColor,
            ];
            static BORDER_BOTTOM_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Border,
                    ShorthandId::BorderColor,
                    ShorthandId::BorderBottom,
            ];
            static BORDER_INLINE_END_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::BorderInline,
                    ShorthandId::BorderInlineEnd,
                    ShorthandId::BorderInlineColor,
            ];
            static BORDER_INLINE_START_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::BorderInline,
                    ShorthandId::BorderInlineStart,
                    ShorthandId::BorderInlineColor,
            ];
            static BORDER_LEFT_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Border,
                    ShorthandId::BorderColor,
                    ShorthandId::BorderLeft,
            ];
            static BORDER_RIGHT_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Border,
                    ShorthandId::BorderColor,
                    ShorthandId::BorderRight,
            ];
            static BORDER_TOP_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Border,
                    ShorthandId::BorderColor,
                    ShorthandId::BorderTop,
            ];
            static COLUMN_RULE_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::ColumnRule,
            ];
            static FLOOD_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static LIGHTING_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static OUTLINE_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::Outline,
            ];
            static STOP_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static TEXT_DECORATION_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::TextDecoration,
            ];
            static TEXT_EMPHASIS_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::TextEmphasis,
            ];
            static _WEBKIT_TEXT_FILL_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
            ];
            static _WEBKIT_TEXT_STROKE_COLOR: &'static [ShorthandId] = &[
                    ShorthandId::All,
                    ShorthandId::WebkitTextStroke,
            ];

        NonCustomPropertyIterator {
            filter: NonCustomPropertyId::from(*self).enabled_for_all_content(),
            iter: match *self {
                    LonghandId::AlignContent => ALIGN_CONTENT,
                    LonghandId::AlignItems => ALIGN_ITEMS,
                    LonghandId::AlignSelf => ALIGN_SELF,
                    LonghandId::BackfaceVisibility => BACKFACE_VISIBILITY,
                    LonghandId::BorderCollapse => BORDER_COLLAPSE,
                    LonghandId::BorderImageRepeat => BORDER_IMAGE_REPEAT,
                    LonghandId::BoxDecorationBreak => BOX_DECORATION_BREAK,
                    LonghandId::BoxSizing => BOX_SIZING,
                    LonghandId::BreakInside => BREAK_INSIDE,
                    LonghandId::CaptionSide => CAPTION_SIDE,
                    LonghandId::Clear => CLEAR,
                    LonghandId::ColorAdjust => COLOR_ADJUST,
                    LonghandId::ColorInterpolation => COLOR_INTERPOLATION,
                    LonghandId::ColorInterpolationFilters => COLOR_INTERPOLATION_FILTERS,
                    LonghandId::ColumnCount => COLUMN_COUNT,
                    LonghandId::ColumnFill => COLUMN_FILL,
                    LonghandId::ColumnSpan => COLUMN_SPAN,
                    LonghandId::Contain => CONTAIN,
                    LonghandId::Direction => DIRECTION,
                    LonghandId::Display => DISPLAY,
                    LonghandId::DominantBaseline => DOMINANT_BASELINE,
                    LonghandId::EmptyCells => EMPTY_CELLS,
                    LonghandId::FlexDirection => FLEX_DIRECTION,
                    LonghandId::FlexWrap => FLEX_WRAP,
                    LonghandId::Float => FLOAT,
                    LonghandId::FontKerning => FONT_KERNING,
                    LonghandId::FontOpticalSizing => FONT_OPTICAL_SIZING,
                    LonghandId::FontSizeAdjust => FONT_SIZE_ADJUST,
                    LonghandId::FontStretch => FONT_STRETCH,
                    LonghandId::FontStyle => FONT_STYLE,
                    LonghandId::FontSynthesis => FONT_SYNTHESIS,
                    LonghandId::FontVariantCaps => FONT_VARIANT_CAPS,
                    LonghandId::FontVariantEastAsian => FONT_VARIANT_EAST_ASIAN,
                    LonghandId::FontVariantLigatures => FONT_VARIANT_LIGATURES,
                    LonghandId::FontVariantNumeric => FONT_VARIANT_NUMERIC,
                    LonghandId::FontVariantPosition => FONT_VARIANT_POSITION,
                    LonghandId::FontWeight => FONT_WEIGHT,
                    LonghandId::GridAutoFlow => GRID_AUTO_FLOW,
                    LonghandId::Hyphens => HYPHENS,
                    LonghandId::ImageOrientation => IMAGE_ORIENTATION,
                    LonghandId::ImageRendering => IMAGE_RENDERING,
                    LonghandId::ImeMode => IME_MODE,
                    LonghandId::InitialLetter => INITIAL_LETTER,
                    LonghandId::Isolation => ISOLATION,
                    LonghandId::JustifyContent => JUSTIFY_CONTENT,
                    LonghandId::JustifyItems => JUSTIFY_ITEMS,
                    LonghandId::JustifySelf => JUSTIFY_SELF,
                    LonghandId::ListStylePosition => LIST_STYLE_POSITION,
                    LonghandId::MaskType => MASK_TYPE,
                    LonghandId::MixBlendMode => MIX_BLEND_MODE,
                    LonghandId::MozAppearance => _MOZ_APPEARANCE,
                    LonghandId::MozBoxAlign => _MOZ_BOX_ALIGN,
                    LonghandId::MozBoxDirection => _MOZ_BOX_DIRECTION,
                    LonghandId::MozBoxOrient => _MOZ_BOX_ORIENT,
                    LonghandId::MozBoxPack => _MOZ_BOX_PACK,
                    LonghandId::MozControlCharacterVisibility => _MOZ_CONTROL_CHARACTER_VISIBILITY,
                    LonghandId::MozFloatEdge => _MOZ_FLOAT_EDGE,
                    LonghandId::MozForceBrokenImageIcon => _MOZ_FORCE_BROKEN_IMAGE_ICON,
                    LonghandId::MozListReversed => _MOZ_LIST_REVERSED,
                    LonghandId::MozMathDisplay => _MOZ_MATH_DISPLAY,
                    LonghandId::MozMathVariant => _MOZ_MATH_VARIANT,
                    LonghandId::MozMinFontSizeRatio => _MOZ_MIN_FONT_SIZE_RATIO,
                    LonghandId::MozOrient => _MOZ_ORIENT,
                    LonghandId::MozOsxFontSmoothing => _MOZ_OSX_FONT_SMOOTHING,
                    LonghandId::MozScriptLevel => _MOZ_SCRIPT_LEVEL,
                    LonghandId::MozScriptMinSize => _MOZ_SCRIPT_MIN_SIZE,
                    LonghandId::MozScriptSizeMultiplier => _MOZ_SCRIPT_SIZE_MULTIPLIER,
                    LonghandId::MozStackSizing => _MOZ_STACK_SIZING,
                    LonghandId::MozTextSizeAdjust => _MOZ_TEXT_SIZE_ADJUST,
                    LonghandId::MozTopLayer => _MOZ_TOP_LAYER,
                    LonghandId::MozUserFocus => _MOZ_USER_FOCUS,
                    LonghandId::MozUserInput => _MOZ_USER_INPUT,
                    LonghandId::MozUserModify => _MOZ_USER_MODIFY,
                    LonghandId::MozUserSelect => _MOZ_USER_SELECT,
                    LonghandId::MozWindowDragging => _MOZ_WINDOW_DRAGGING,
                    LonghandId::MozWindowShadow => _MOZ_WINDOW_SHADOW,
                    LonghandId::ObjectFit => OBJECT_FIT,
                    LonghandId::OutlineStyle => OUTLINE_STYLE,
                    LonghandId::OverflowAnchor => OVERFLOW_ANCHOR,
                    LonghandId::OverflowWrap => OVERFLOW_WRAP,
                    LonghandId::PaintOrder => PAINT_ORDER,
                    LonghandId::PointerEvents => POINTER_EVENTS,
                    LonghandId::Position => POSITION,
                    LonghandId::Resize => RESIZE,
                    LonghandId::RubyAlign => RUBY_ALIGN,
                    LonghandId::RubyPosition => RUBY_POSITION,
                    LonghandId::ScrollBehavior => SCROLL_BEHAVIOR,
                    LonghandId::ScrollSnapAlign => SCROLL_SNAP_ALIGN,
                    LonghandId::ScrollSnapType => SCROLL_SNAP_TYPE,
                    LonghandId::ScrollbarWidth => SCROLLBAR_WIDTH,
                    LonghandId::ShapeRendering => SHAPE_RENDERING,
                    LonghandId::StrokeLinecap => STROKE_LINECAP,
                    LonghandId::StrokeLinejoin => STROKE_LINEJOIN,
                    LonghandId::TableLayout => TABLE_LAYOUT,
                    LonghandId::TextAlign => TEXT_ALIGN,
                    LonghandId::TextAlignLast => TEXT_ALIGN_LAST,
                    LonghandId::TextAnchor => TEXT_ANCHOR,
                    LonghandId::TextCombineUpright => TEXT_COMBINE_UPRIGHT,
                    LonghandId::TextDecorationLine => TEXT_DECORATION_LINE,
                    LonghandId::TextDecorationStyle => TEXT_DECORATION_STYLE,
                    LonghandId::TextEmphasisPosition => TEXT_EMPHASIS_POSITION,
                    LonghandId::TextJustify => TEXT_JUSTIFY,
                    LonghandId::TextOrientation => TEXT_ORIENTATION,
                    LonghandId::TextRendering => TEXT_RENDERING,
                    LonghandId::TextTransform => TEXT_TRANSFORM,
                    LonghandId::TouchAction => TOUCH_ACTION,
                    LonghandId::TransformBox => TRANSFORM_BOX,
                    LonghandId::TransformStyle => TRANSFORM_STYLE,
                    LonghandId::UnicodeBidi => UNICODE_BIDI,
                    LonghandId::VectorEffect => VECTOR_EFFECT,
                    LonghandId::Visibility => VISIBILITY,
                    LonghandId::WebkitLineClamp => _WEBKIT_LINE_CLAMP,
                    LonghandId::WhiteSpace => WHITE_SPACE,
                    LonghandId::WordBreak => WORD_BREAK,
                    LonghandId::WritingMode => WRITING_MODE,
                    LonghandId::XSpan => _X_SPAN,
                    LonghandId::XTextZoom => _X_TEXT_ZOOM,
                    LonghandId::ZIndex => Z_INDEX,
                    LonghandId::BreakAfter => BREAK_AFTER,
                    LonghandId::BreakBefore => BREAK_BEFORE,
                    LonghandId::ClipRule => CLIP_RULE,
                    LonghandId::FillRule => FILL_RULE,
                    LonghandId::MozBoxOrdinalGroup => _MOZ_BOX_ORDINAL_GROUP,
                    LonghandId::Order => ORDER,
                    LonghandId::OverflowX => OVERFLOW_X,
                    LonghandId::OverflowY => OVERFLOW_Y,
                    LonghandId::OverflowClipBoxBlock => OVERFLOW_CLIP_BOX_BLOCK,
                    LonghandId::OverflowClipBoxInline => OVERFLOW_CLIP_BOX_INLINE,
                    LonghandId::OverscrollBehaviorX => OVERSCROLL_BEHAVIOR_X,
                    LonghandId::OverscrollBehaviorY => OVERSCROLL_BEHAVIOR_Y,
                    LonghandId::FillOpacity => FILL_OPACITY,
                    LonghandId::StrokeOpacity => STROKE_OPACITY,
                    LonghandId::FlexGrow => FLEX_GROW,
                    LonghandId::FlexShrink => FLEX_SHRINK,
                    LonghandId::MozBoxFlex => _MOZ_BOX_FLEX,
                    LonghandId::StrokeMiterlimit => STROKE_MITERLIMIT,
                    LonghandId::FloodOpacity => FLOOD_OPACITY,
                    LonghandId::MozWindowOpacity => _MOZ_WINDOW_OPACITY,
                    LonghandId::Opacity => OPACITY,
                    LonghandId::ShapeImageThreshold => SHAPE_IMAGE_THRESHOLD,
                    LonghandId::StopOpacity => STOP_OPACITY,
                    LonghandId::BorderBlockEndStyle => BORDER_BLOCK_END_STYLE,
                    LonghandId::BorderBlockStartStyle => BORDER_BLOCK_START_STYLE,
                    LonghandId::BorderBottomStyle => BORDER_BOTTOM_STYLE,
                    LonghandId::BorderInlineEndStyle => BORDER_INLINE_END_STYLE,
                    LonghandId::BorderInlineStartStyle => BORDER_INLINE_START_STYLE,
                    LonghandId::BorderLeftStyle => BORDER_LEFT_STYLE,
                    LonghandId::BorderRightStyle => BORDER_RIGHT_STYLE,
                    LonghandId::BorderTopStyle => BORDER_TOP_STYLE,
                    LonghandId::ColumnRuleStyle => COLUMN_RULE_STYLE,
                    LonghandId::AnimationDelay => ANIMATION_DELAY,
                    LonghandId::AnimationDirection => ANIMATION_DIRECTION,
                    LonghandId::AnimationDuration => ANIMATION_DURATION,
                    LonghandId::AnimationFillMode => ANIMATION_FILL_MODE,
                    LonghandId::AnimationIterationCount => ANIMATION_ITERATION_COUNT,
                    LonghandId::AnimationName => ANIMATION_NAME,
                    LonghandId::AnimationPlayState => ANIMATION_PLAY_STATE,
                    LonghandId::AnimationTimingFunction => ANIMATION_TIMING_FUNCTION,
                    LonghandId::BackgroundAttachment => BACKGROUND_ATTACHMENT,
                    LonghandId::BackgroundBlendMode => BACKGROUND_BLEND_MODE,
                    LonghandId::BackgroundClip => BACKGROUND_CLIP,
                    LonghandId::BackgroundImage => BACKGROUND_IMAGE,
                    LonghandId::BackgroundOrigin => BACKGROUND_ORIGIN,
                    LonghandId::BackgroundPositionX => BACKGROUND_POSITION_X,
                    LonghandId::BackgroundPositionY => BACKGROUND_POSITION_Y,
                    LonghandId::BackgroundRepeat => BACKGROUND_REPEAT,
                    LonghandId::BackgroundSize => BACKGROUND_SIZE,
                    LonghandId::BorderImageOutset => BORDER_IMAGE_OUTSET,
                    LonghandId::BorderImageSlice => BORDER_IMAGE_SLICE,
                    LonghandId::BorderImageSource => BORDER_IMAGE_SOURCE,
                    LonghandId::BorderImageWidth => BORDER_IMAGE_WIDTH,
                    LonghandId::BorderSpacing => BORDER_SPACING,
                    LonghandId::BoxShadow => BOX_SHADOW,
                    LonghandId::CaretColor => CARET_COLOR,
                    LonghandId::ClipPath => CLIP_PATH,
                    LonghandId::Color => COLOR,
                    LonghandId::ColumnWidth => COLUMN_WIDTH,
                    LonghandId::Content => CONTENT,
                    LonghandId::CounterIncrement => COUNTER_INCREMENT,
                    LonghandId::Cursor => CURSOR,
                    LonghandId::Filter => FILTER,
                    LonghandId::FlexBasis => FLEX_BASIS,
                    LonghandId::FontFamily => FONT_FAMILY,
                    LonghandId::FontFeatureSettings => FONT_FEATURE_SETTINGS,
                    LonghandId::FontLanguageOverride => FONT_LANGUAGE_OVERRIDE,
                    LonghandId::FontSize => FONT_SIZE,
                    LonghandId::FontVariantAlternates => FONT_VARIANT_ALTERNATES,
                    LonghandId::FontVariationSettings => FONT_VARIATION_SETTINGS,
                    LonghandId::GridTemplateAreas => GRID_TEMPLATE_AREAS,
                    LonghandId::LetterSpacing => LETTER_SPACING,
                    LonghandId::LineHeight => LINE_HEIGHT,
                    LonghandId::ListStyleImage => LIST_STYLE_IMAGE,
                    LonghandId::ListStyleType => LIST_STYLE_TYPE,
                    LonghandId::MaskClip => MASK_CLIP,
                    LonghandId::MaskComposite => MASK_COMPOSITE,
                    LonghandId::MaskImage => MASK_IMAGE,
                    LonghandId::MaskMode => MASK_MODE,
                    LonghandId::MaskOrigin => MASK_ORIGIN,
                    LonghandId::MaskPositionX => MASK_POSITION_X,
                    LonghandId::MaskPositionY => MASK_POSITION_Y,
                    LonghandId::MaskRepeat => MASK_REPEAT,
                    LonghandId::MaskSize => MASK_SIZE,
                    LonghandId::MozContextProperties => _MOZ_CONTEXT_PROPERTIES,
                    LonghandId::MozFontSmoothingBackgroundColor => _MOZ_FONT_SMOOTHING_BACKGROUND_COLOR,
                    LonghandId::MozTabSize => _MOZ_TAB_SIZE,
                    LonghandId::OffsetPath => OFFSET_PATH,
                    LonghandId::Perspective => PERSPECTIVE,
                    LonghandId::Quotes => QUOTES,
                    LonghandId::Rotate => ROTATE,
                    LonghandId::Scale => SCALE,
                    LonghandId::ScrollSnapCoordinate => SCROLL_SNAP_COORDINATE,
                    LonghandId::ScrollbarColor => SCROLLBAR_COLOR,
                    LonghandId::ShapeOutside => SHAPE_OUTSIDE,
                    LonghandId::StrokeDasharray => STROKE_DASHARRAY,
                    LonghandId::StrokeDashoffset => STROKE_DASHOFFSET,
                    LonghandId::StrokeWidth => STROKE_WIDTH,
                    LonghandId::TextEmphasisStyle => TEXT_EMPHASIS_STYLE,
                    LonghandId::TextIndent => TEXT_INDENT,
                    LonghandId::TextOverflow => TEXT_OVERFLOW,
                    LonghandId::TextShadow => TEXT_SHADOW,
                    LonghandId::TransitionDelay => TRANSITION_DELAY,
                    LonghandId::TransitionDuration => TRANSITION_DURATION,
                    LonghandId::TransitionProperty => TRANSITION_PROPERTY,
                    LonghandId::TransitionTimingFunction => TRANSITION_TIMING_FUNCTION,
                    LonghandId::Translate => TRANSLATE,
                    LonghandId::VerticalAlign => VERTICAL_ALIGN,
                    LonghandId::WillChange => WILL_CHANGE,
                    LonghandId::WordSpacing => WORD_SPACING,
                    LonghandId::XLang => _X_LANG,
                    LonghandId::Clip => CLIP,
                    LonghandId::MozImageRegion => _MOZ_IMAGE_REGION,
                    LonghandId::GridTemplateColumns => GRID_TEMPLATE_COLUMNS,
                    LonghandId::GridTemplateRows => GRID_TEMPLATE_ROWS,
                    LonghandId::Fill => FILL,
                    LonghandId::Stroke => STROKE,
                    LonghandId::GridAutoColumns => GRID_AUTO_COLUMNS,
                    LonghandId::GridAutoRows => GRID_AUTO_ROWS,
                    LonghandId::MozWindowTransformOrigin => _MOZ_WINDOW_TRANSFORM_ORIGIN,
                    LonghandId::TransformOrigin => TRANSFORM_ORIGIN,
                    LonghandId::CounterReset => COUNTER_RESET,
                    LonghandId::CounterSet => COUNTER_SET,
                    LonghandId::ScrollSnapPointsX => SCROLL_SNAP_POINTS_X,
                    LonghandId::ScrollSnapPointsY => SCROLL_SNAP_POINTS_Y,
                    LonghandId::MozWindowTransform => _MOZ_WINDOW_TRANSFORM,
                    LonghandId::Transform => TRANSFORM,
                    LonghandId::ColumnGap => COLUMN_GAP,
                    LonghandId::RowGap => ROW_GAP,
                    LonghandId::ObjectPosition => OBJECT_POSITION,
                    LonghandId::PerspectiveOrigin => PERSPECTIVE_ORIGIN,
                    LonghandId::ScrollSnapDestination => SCROLL_SNAP_DESTINATION,
                    LonghandId::GridColumnEnd => GRID_COLUMN_END,
                    LonghandId::GridColumnStart => GRID_COLUMN_START,
                    LonghandId::GridRowEnd => GRID_ROW_END,
                    LonghandId::GridRowStart => GRID_ROW_START,
                    LonghandId::MaxBlockSize => MAX_BLOCK_SIZE,
                    LonghandId::MaxHeight => MAX_HEIGHT,
                    LonghandId::MaxInlineSize => MAX_INLINE_SIZE,
                    LonghandId::MaxWidth => MAX_WIDTH,
                    LonghandId::MarkerEnd => MARKER_END,
                    LonghandId::MarkerMid => MARKER_MID,
                    LonghandId::MarkerStart => MARKER_START,
                    LonghandId::MozBinding => _MOZ_BINDING,
                    LonghandId::ScrollPaddingBlockEnd => SCROLL_PADDING_BLOCK_END,
                    LonghandId::ScrollPaddingBlockStart => SCROLL_PADDING_BLOCK_START,
                    LonghandId::ScrollPaddingBottom => SCROLL_PADDING_BOTTOM,
                    LonghandId::ScrollPaddingInlineEnd => SCROLL_PADDING_INLINE_END,
                    LonghandId::ScrollPaddingInlineStart => SCROLL_PADDING_INLINE_START,
                    LonghandId::ScrollPaddingLeft => SCROLL_PADDING_LEFT,
                    LonghandId::ScrollPaddingRight => SCROLL_PADDING_RIGHT,
                    LonghandId::ScrollPaddingTop => SCROLL_PADDING_TOP,
                    LonghandId::BlockSize => BLOCK_SIZE,
                    LonghandId::Height => HEIGHT,
                    LonghandId::InlineSize => INLINE_SIZE,
                    LonghandId::MinBlockSize => MIN_BLOCK_SIZE,
                    LonghandId::MinHeight => MIN_HEIGHT,
                    LonghandId::MinInlineSize => MIN_INLINE_SIZE,
                    LonghandId::MinWidth => MIN_WIDTH,
                    LonghandId::Width => WIDTH,
                    LonghandId::OutlineOffset => OUTLINE_OFFSET,
                    LonghandId::ScrollMarginBlockEnd => SCROLL_MARGIN_BLOCK_END,
                    LonghandId::ScrollMarginBlockStart => SCROLL_MARGIN_BLOCK_START,
                    LonghandId::ScrollMarginBottom => SCROLL_MARGIN_BOTTOM,
                    LonghandId::ScrollMarginInlineEnd => SCROLL_MARGIN_INLINE_END,
                    LonghandId::ScrollMarginInlineStart => SCROLL_MARGIN_INLINE_START,
                    LonghandId::ScrollMarginLeft => SCROLL_MARGIN_LEFT,
                    LonghandId::ScrollMarginRight => SCROLL_MARGIN_RIGHT,
                    LonghandId::ScrollMarginTop => SCROLL_MARGIN_TOP,
                    LonghandId::PaddingBlockEnd => PADDING_BLOCK_END,
                    LonghandId::PaddingBlockStart => PADDING_BLOCK_START,
                    LonghandId::PaddingBottom => PADDING_BOTTOM,
                    LonghandId::PaddingInlineEnd => PADDING_INLINE_END,
                    LonghandId::PaddingInlineStart => PADDING_INLINE_START,
                    LonghandId::PaddingLeft => PADDING_LEFT,
                    LonghandId::PaddingRight => PADDING_RIGHT,
                    LonghandId::PaddingTop => PADDING_TOP,
                    LonghandId::ShapeMargin => SHAPE_MARGIN,
                    LonghandId::BorderBlockEndWidth => BORDER_BLOCK_END_WIDTH,
                    LonghandId::BorderBlockStartWidth => BORDER_BLOCK_START_WIDTH,
                    LonghandId::BorderBottomWidth => BORDER_BOTTOM_WIDTH,
                    LonghandId::BorderInlineEndWidth => BORDER_INLINE_END_WIDTH,
                    LonghandId::BorderInlineStartWidth => BORDER_INLINE_START_WIDTH,
                    LonghandId::BorderLeftWidth => BORDER_LEFT_WIDTH,
                    LonghandId::BorderRightWidth => BORDER_RIGHT_WIDTH,
                    LonghandId::BorderTopWidth => BORDER_TOP_WIDTH,
                    LonghandId::ColumnRuleWidth => COLUMN_RULE_WIDTH,
                    LonghandId::OutlineWidth => OUTLINE_WIDTH,
                    LonghandId::WebkitTextStrokeWidth => _WEBKIT_TEXT_STROKE_WIDTH,
                    LonghandId::BorderBottomLeftRadius => BORDER_BOTTOM_LEFT_RADIUS,
                    LonghandId::BorderBottomRightRadius => BORDER_BOTTOM_RIGHT_RADIUS,
                    LonghandId::BorderEndEndRadius => BORDER_END_END_RADIUS,
                    LonghandId::BorderEndStartRadius => BORDER_END_START_RADIUS,
                    LonghandId::BorderStartEndRadius => BORDER_START_END_RADIUS,
                    LonghandId::BorderStartStartRadius => BORDER_START_START_RADIUS,
                    LonghandId::BorderTopLeftRadius => BORDER_TOP_LEFT_RADIUS,
                    LonghandId::BorderTopRightRadius => BORDER_TOP_RIGHT_RADIUS,
                    LonghandId::MozOutlineRadiusBottomleft => _MOZ_OUTLINE_RADIUS_BOTTOMLEFT,
                    LonghandId::MozOutlineRadiusBottomright => _MOZ_OUTLINE_RADIUS_BOTTOMRIGHT,
                    LonghandId::MozOutlineRadiusTopleft => _MOZ_OUTLINE_RADIUS_TOPLEFT,
                    LonghandId::MozOutlineRadiusTopright => _MOZ_OUTLINE_RADIUS_TOPRIGHT,
                    LonghandId::Bottom => BOTTOM,
                    LonghandId::InsetBlockEnd => INSET_BLOCK_END,
                    LonghandId::InsetBlockStart => INSET_BLOCK_START,
                    LonghandId::InsetInlineEnd => INSET_INLINE_END,
                    LonghandId::InsetInlineStart => INSET_INLINE_START,
                    LonghandId::Left => LEFT,
                    LonghandId::MarginBlockEnd => MARGIN_BLOCK_END,
                    LonghandId::MarginBlockStart => MARGIN_BLOCK_START,
                    LonghandId::MarginBottom => MARGIN_BOTTOM,
                    LonghandId::MarginInlineEnd => MARGIN_INLINE_END,
                    LonghandId::MarginInlineStart => MARGIN_INLINE_START,
                    LonghandId::MarginLeft => MARGIN_LEFT,
                    LonghandId::MarginRight => MARGIN_RIGHT,
                    LonghandId::MarginTop => MARGIN_TOP,
                    LonghandId::Right => RIGHT,
                    LonghandId::Top => TOP,
                    LonghandId::BackgroundColor => BACKGROUND_COLOR,
                    LonghandId::BorderBlockEndColor => BORDER_BLOCK_END_COLOR,
                    LonghandId::BorderBlockStartColor => BORDER_BLOCK_START_COLOR,
                    LonghandId::BorderBottomColor => BORDER_BOTTOM_COLOR,
                    LonghandId::BorderInlineEndColor => BORDER_INLINE_END_COLOR,
                    LonghandId::BorderInlineStartColor => BORDER_INLINE_START_COLOR,
                    LonghandId::BorderLeftColor => BORDER_LEFT_COLOR,
                    LonghandId::BorderRightColor => BORDER_RIGHT_COLOR,
                    LonghandId::BorderTopColor => BORDER_TOP_COLOR,
                    LonghandId::ColumnRuleColor => COLUMN_RULE_COLOR,
                    LonghandId::FloodColor => FLOOD_COLOR,
                    LonghandId::LightingColor => LIGHTING_COLOR,
                    LonghandId::OutlineColor => OUTLINE_COLOR,
                    LonghandId::StopColor => STOP_COLOR,
                    LonghandId::TextDecorationColor => TEXT_DECORATION_COLOR,
                    LonghandId::TextEmphasisColor => TEXT_EMPHASIS_COLOR,
                    LonghandId::WebkitTextFillColor => _WEBKIT_TEXT_FILL_COLOR,
                    LonghandId::WebkitTextStrokeColor => _WEBKIT_TEXT_STROKE_COLOR,
            }.iter(),
        }
    }

    // TODO(emilio): Should we use a function table like CASCADE_PROPERTY does
    // to avoid blowing up code-size here?
    fn parse_value<'i, 't>(
        &self,
        context: &ParserContext,
        input: &mut Parser<'i, 't>,
    ) -> Result<PropertyDeclaration, ParseError<'i>> {
        match *self {
                LonghandId::AlignContent => {
                    longhands::align_content::parse_declared(context, input)
                }
                LonghandId::AlignItems => {
                    longhands::align_items::parse_declared(context, input)
                }
                LonghandId::AlignSelf => {
                    longhands::align_self::parse_declared(context, input)
                }
                LonghandId::BackfaceVisibility => {
                    longhands::backface_visibility::parse_declared(context, input)
                }
                LonghandId::BorderCollapse => {
                    longhands::border_collapse::parse_declared(context, input)
                }
                LonghandId::BorderImageRepeat => {
                    longhands::border_image_repeat::parse_declared(context, input)
                }
                LonghandId::BoxDecorationBreak => {
                    longhands::box_decoration_break::parse_declared(context, input)
                }
                LonghandId::BoxSizing => {
                    longhands::box_sizing::parse_declared(context, input)
                }
                LonghandId::BreakInside => {
                    longhands::break_inside::parse_declared(context, input)
                }
                LonghandId::CaptionSide => {
                    longhands::caption_side::parse_declared(context, input)
                }
                LonghandId::Clear => {
                    longhands::clear::parse_declared(context, input)
                }
                LonghandId::ColorAdjust => {
                    longhands::color_adjust::parse_declared(context, input)
                }
                LonghandId::ColorInterpolation => {
                    longhands::color_interpolation::parse_declared(context, input)
                }
                LonghandId::ColorInterpolationFilters => {
                    longhands::color_interpolation_filters::parse_declared(context, input)
                }
                LonghandId::ColumnCount => {
                    longhands::column_count::parse_declared(context, input)
                }
                LonghandId::ColumnFill => {
                    longhands::column_fill::parse_declared(context, input)
                }
                LonghandId::ColumnSpan => {
                    longhands::column_span::parse_declared(context, input)
                }
                LonghandId::Contain => {
                    longhands::contain::parse_declared(context, input)
                }
                LonghandId::Direction => {
                    longhands::direction::parse_declared(context, input)
                }
                LonghandId::Display => {
                    longhands::display::parse_declared(context, input)
                }
                LonghandId::DominantBaseline => {
                    longhands::dominant_baseline::parse_declared(context, input)
                }
                LonghandId::EmptyCells => {
                    longhands::empty_cells::parse_declared(context, input)
                }
                LonghandId::FlexDirection => {
                    longhands::flex_direction::parse_declared(context, input)
                }
                LonghandId::FlexWrap => {
                    longhands::flex_wrap::parse_declared(context, input)
                }
                LonghandId::Float => {
                    longhands::float::parse_declared(context, input)
                }
                LonghandId::FontKerning => {
                    longhands::font_kerning::parse_declared(context, input)
                }
                LonghandId::FontOpticalSizing => {
                    longhands::font_optical_sizing::parse_declared(context, input)
                }
                LonghandId::FontSizeAdjust => {
                    longhands::font_size_adjust::parse_declared(context, input)
                }
                LonghandId::FontStretch => {
                    longhands::font_stretch::parse_declared(context, input)
                }
                LonghandId::FontStyle => {
                    longhands::font_style::parse_declared(context, input)
                }
                LonghandId::FontSynthesis => {
                    longhands::font_synthesis::parse_declared(context, input)
                }
                LonghandId::FontVariantCaps => {
                    longhands::font_variant_caps::parse_declared(context, input)
                }
                LonghandId::FontVariantEastAsian => {
                    longhands::font_variant_east_asian::parse_declared(context, input)
                }
                LonghandId::FontVariantLigatures => {
                    longhands::font_variant_ligatures::parse_declared(context, input)
                }
                LonghandId::FontVariantNumeric => {
                    longhands::font_variant_numeric::parse_declared(context, input)
                }
                LonghandId::FontVariantPosition => {
                    longhands::font_variant_position::parse_declared(context, input)
                }
                LonghandId::FontWeight => {
                    longhands::font_weight::parse_declared(context, input)
                }
                LonghandId::GridAutoFlow => {
                    longhands::grid_auto_flow::parse_declared(context, input)
                }
                LonghandId::Hyphens => {
                    longhands::hyphens::parse_declared(context, input)
                }
                LonghandId::ImageOrientation => {
                    longhands::image_orientation::parse_declared(context, input)
                }
                LonghandId::ImageRendering => {
                    longhands::image_rendering::parse_declared(context, input)
                }
                LonghandId::ImeMode => {
                    longhands::ime_mode::parse_declared(context, input)
                }
                LonghandId::InitialLetter => {
                    longhands::initial_letter::parse_declared(context, input)
                }
                LonghandId::Isolation => {
                    longhands::isolation::parse_declared(context, input)
                }
                LonghandId::JustifyContent => {
                    longhands::justify_content::parse_declared(context, input)
                }
                LonghandId::JustifyItems => {
                    longhands::justify_items::parse_declared(context, input)
                }
                LonghandId::JustifySelf => {
                    longhands::justify_self::parse_declared(context, input)
                }
                LonghandId::ListStylePosition => {
                    longhands::list_style_position::parse_declared(context, input)
                }
                LonghandId::MaskType => {
                    longhands::mask_type::parse_declared(context, input)
                }
                LonghandId::MixBlendMode => {
                    longhands::mix_blend_mode::parse_declared(context, input)
                }
                LonghandId::MozAppearance => {
                    longhands::_moz_appearance::parse_declared(context, input)
                }
                LonghandId::MozBoxAlign => {
                    longhands::_moz_box_align::parse_declared(context, input)
                }
                LonghandId::MozBoxDirection => {
                    longhands::_moz_box_direction::parse_declared(context, input)
                }
                LonghandId::MozBoxOrient => {
                    longhands::_moz_box_orient::parse_declared(context, input)
                }
                LonghandId::MozBoxPack => {
                    longhands::_moz_box_pack::parse_declared(context, input)
                }
                LonghandId::MozControlCharacterVisibility => {
                    longhands::_moz_control_character_visibility::parse_declared(context, input)
                }
                LonghandId::MozFloatEdge => {
                    longhands::_moz_float_edge::parse_declared(context, input)
                }
                LonghandId::MozForceBrokenImageIcon => {
                    longhands::_moz_force_broken_image_icon::parse_declared(context, input)
                }
                LonghandId::MozListReversed => {
                    longhands::_moz_list_reversed::parse_declared(context, input)
                }
                LonghandId::MozMathDisplay => {
                    longhands::_moz_math_display::parse_declared(context, input)
                }
                LonghandId::MozMathVariant => {
                    longhands::_moz_math_variant::parse_declared(context, input)
                }
                LonghandId::MozMinFontSizeRatio => {
                    longhands::_moz_min_font_size_ratio::parse_declared(context, input)
                }
                LonghandId::MozOrient => {
                    longhands::_moz_orient::parse_declared(context, input)
                }
                LonghandId::MozOsxFontSmoothing => {
                    longhands::_moz_osx_font_smoothing::parse_declared(context, input)
                }
                LonghandId::MozScriptLevel => {
                    longhands::_moz_script_level::parse_declared(context, input)
                }
                LonghandId::MozScriptMinSize => {
                    longhands::_moz_script_min_size::parse_declared(context, input)
                }
                LonghandId::MozScriptSizeMultiplier => {
                    longhands::_moz_script_size_multiplier::parse_declared(context, input)
                }
                LonghandId::MozStackSizing => {
                    longhands::_moz_stack_sizing::parse_declared(context, input)
                }
                LonghandId::MozTextSizeAdjust => {
                    longhands::_moz_text_size_adjust::parse_declared(context, input)
                }
                LonghandId::MozTopLayer => {
                    longhands::_moz_top_layer::parse_declared(context, input)
                }
                LonghandId::MozUserFocus => {
                    longhands::_moz_user_focus::parse_declared(context, input)
                }
                LonghandId::MozUserInput => {
                    longhands::_moz_user_input::parse_declared(context, input)
                }
                LonghandId::MozUserModify => {
                    longhands::_moz_user_modify::parse_declared(context, input)
                }
                LonghandId::MozUserSelect => {
                    longhands::_moz_user_select::parse_declared(context, input)
                }
                LonghandId::MozWindowDragging => {
                    longhands::_moz_window_dragging::parse_declared(context, input)
                }
                LonghandId::MozWindowShadow => {
                    longhands::_moz_window_shadow::parse_declared(context, input)
                }
                LonghandId::ObjectFit => {
                    longhands::object_fit::parse_declared(context, input)
                }
                LonghandId::OutlineStyle => {
                    longhands::outline_style::parse_declared(context, input)
                }
                LonghandId::OverflowAnchor => {
                    longhands::overflow_anchor::parse_declared(context, input)
                }
                LonghandId::OverflowWrap => {
                    longhands::overflow_wrap::parse_declared(context, input)
                }
                LonghandId::PaintOrder => {
                    longhands::paint_order::parse_declared(context, input)
                }
                LonghandId::PointerEvents => {
                    longhands::pointer_events::parse_declared(context, input)
                }
                LonghandId::Position => {
                    longhands::position::parse_declared(context, input)
                }
                LonghandId::Resize => {
                    longhands::resize::parse_declared(context, input)
                }
                LonghandId::RubyAlign => {
                    longhands::ruby_align::parse_declared(context, input)
                }
                LonghandId::RubyPosition => {
                    longhands::ruby_position::parse_declared(context, input)
                }
                LonghandId::ScrollBehavior => {
                    longhands::scroll_behavior::parse_declared(context, input)
                }
                LonghandId::ScrollSnapAlign => {
                    longhands::scroll_snap_align::parse_declared(context, input)
                }
                LonghandId::ScrollSnapType => {
                    longhands::scroll_snap_type::parse_declared(context, input)
                }
                LonghandId::ScrollbarWidth => {
                    longhands::scrollbar_width::parse_declared(context, input)
                }
                LonghandId::ShapeRendering => {
                    longhands::shape_rendering::parse_declared(context, input)
                }
                LonghandId::StrokeLinecap => {
                    longhands::stroke_linecap::parse_declared(context, input)
                }
                LonghandId::StrokeLinejoin => {
                    longhands::stroke_linejoin::parse_declared(context, input)
                }
                LonghandId::TableLayout => {
                    longhands::table_layout::parse_declared(context, input)
                }
                LonghandId::TextAlign => {
                    longhands::text_align::parse_declared(context, input)
                }
                LonghandId::TextAlignLast => {
                    longhands::text_align_last::parse_declared(context, input)
                }
                LonghandId::TextAnchor => {
                    longhands::text_anchor::parse_declared(context, input)
                }
                LonghandId::TextCombineUpright => {
                    longhands::text_combine_upright::parse_declared(context, input)
                }
                LonghandId::TextDecorationLine => {
                    longhands::text_decoration_line::parse_declared(context, input)
                }
                LonghandId::TextDecorationStyle => {
                    longhands::text_decoration_style::parse_declared(context, input)
                }
                LonghandId::TextEmphasisPosition => {
                    longhands::text_emphasis_position::parse_declared(context, input)
                }
                LonghandId::TextJustify => {
                    longhands::text_justify::parse_declared(context, input)
                }
                LonghandId::TextOrientation => {
                    longhands::text_orientation::parse_declared(context, input)
                }
                LonghandId::TextRendering => {
                    longhands::text_rendering::parse_declared(context, input)
                }
                LonghandId::TextTransform => {
                    longhands::text_transform::parse_declared(context, input)
                }
                LonghandId::TouchAction => {
                    longhands::touch_action::parse_declared(context, input)
                }
                LonghandId::TransformBox => {
                    longhands::transform_box::parse_declared(context, input)
                }
                LonghandId::TransformStyle => {
                    longhands::transform_style::parse_declared(context, input)
                }
                LonghandId::UnicodeBidi => {
                    longhands::unicode_bidi::parse_declared(context, input)
                }
                LonghandId::VectorEffect => {
                    longhands::vector_effect::parse_declared(context, input)
                }
                LonghandId::Visibility => {
                    longhands::visibility::parse_declared(context, input)
                }
                LonghandId::WebkitLineClamp => {
                    longhands::_webkit_line_clamp::parse_declared(context, input)
                }
                LonghandId::WhiteSpace => {
                    longhands::white_space::parse_declared(context, input)
                }
                LonghandId::WordBreak => {
                    longhands::word_break::parse_declared(context, input)
                }
                LonghandId::WritingMode => {
                    longhands::writing_mode::parse_declared(context, input)
                }
                LonghandId::XSpan => {
                    longhands::_x_span::parse_declared(context, input)
                }
                LonghandId::XTextZoom => {
                    longhands::_x_text_zoom::parse_declared(context, input)
                }
                LonghandId::ZIndex => {
                    longhands::z_index::parse_declared(context, input)
                }
                LonghandId::BreakAfter => {
                    longhands::break_after::parse_declared(context, input)
                }
                LonghandId::BreakBefore => {
                    longhands::break_before::parse_declared(context, input)
                }
                LonghandId::ClipRule => {
                    longhands::clip_rule::parse_declared(context, input)
                }
                LonghandId::FillRule => {
                    longhands::fill_rule::parse_declared(context, input)
                }
                LonghandId::MozBoxOrdinalGroup => {
                    longhands::_moz_box_ordinal_group::parse_declared(context, input)
                }
                LonghandId::Order => {
                    longhands::order::parse_declared(context, input)
                }
                LonghandId::OverflowX => {
                    longhands::overflow_x::parse_declared(context, input)
                }
                LonghandId::OverflowY => {
                    longhands::overflow_y::parse_declared(context, input)
                }
                LonghandId::OverflowClipBoxBlock => {
                    longhands::overflow_clip_box_block::parse_declared(context, input)
                }
                LonghandId::OverflowClipBoxInline => {
                    longhands::overflow_clip_box_inline::parse_declared(context, input)
                }
                LonghandId::OverscrollBehaviorX => {
                    longhands::overscroll_behavior_x::parse_declared(context, input)
                }
                LonghandId::OverscrollBehaviorY => {
                    longhands::overscroll_behavior_y::parse_declared(context, input)
                }
                LonghandId::FillOpacity => {
                    longhands::fill_opacity::parse_declared(context, input)
                }
                LonghandId::StrokeOpacity => {
                    longhands::stroke_opacity::parse_declared(context, input)
                }
                LonghandId::FlexGrow => {
                    longhands::flex_grow::parse_declared(context, input)
                }
                LonghandId::FlexShrink => {
                    longhands::flex_shrink::parse_declared(context, input)
                }
                LonghandId::MozBoxFlex => {
                    longhands::_moz_box_flex::parse_declared(context, input)
                }
                LonghandId::StrokeMiterlimit => {
                    longhands::stroke_miterlimit::parse_declared(context, input)
                }
                LonghandId::FloodOpacity => {
                    longhands::flood_opacity::parse_declared(context, input)
                }
                LonghandId::MozWindowOpacity => {
                    longhands::_moz_window_opacity::parse_declared(context, input)
                }
                LonghandId::Opacity => {
                    longhands::opacity::parse_declared(context, input)
                }
                LonghandId::ShapeImageThreshold => {
                    longhands::shape_image_threshold::parse_declared(context, input)
                }
                LonghandId::StopOpacity => {
                    longhands::stop_opacity::parse_declared(context, input)
                }
                LonghandId::BorderBlockEndStyle => {
                    longhands::border_block_end_style::parse_declared(context, input)
                }
                LonghandId::BorderBlockStartStyle => {
                    longhands::border_block_start_style::parse_declared(context, input)
                }
                LonghandId::BorderBottomStyle => {
                    longhands::border_bottom_style::parse_declared(context, input)
                }
                LonghandId::BorderInlineEndStyle => {
                    longhands::border_inline_end_style::parse_declared(context, input)
                }
                LonghandId::BorderInlineStartStyle => {
                    longhands::border_inline_start_style::parse_declared(context, input)
                }
                LonghandId::BorderLeftStyle => {
                    longhands::border_left_style::parse_declared(context, input)
                }
                LonghandId::BorderRightStyle => {
                    longhands::border_right_style::parse_declared(context, input)
                }
                LonghandId::BorderTopStyle => {
                    longhands::border_top_style::parse_declared(context, input)
                }
                LonghandId::ColumnRuleStyle => {
                    longhands::column_rule_style::parse_declared(context, input)
                }
                LonghandId::AnimationDelay => {
                    longhands::animation_delay::parse_declared(context, input)
                }
                LonghandId::AnimationDirection => {
                    longhands::animation_direction::parse_declared(context, input)
                }
                LonghandId::AnimationDuration => {
                    longhands::animation_duration::parse_declared(context, input)
                }
                LonghandId::AnimationFillMode => {
                    longhands::animation_fill_mode::parse_declared(context, input)
                }
                LonghandId::AnimationIterationCount => {
                    longhands::animation_iteration_count::parse_declared(context, input)
                }
                LonghandId::AnimationName => {
                    longhands::animation_name::parse_declared(context, input)
                }
                LonghandId::AnimationPlayState => {
                    longhands::animation_play_state::parse_declared(context, input)
                }
                LonghandId::AnimationTimingFunction => {
                    longhands::animation_timing_function::parse_declared(context, input)
                }
                LonghandId::BackgroundAttachment => {
                    longhands::background_attachment::parse_declared(context, input)
                }
                LonghandId::BackgroundBlendMode => {
                    longhands::background_blend_mode::parse_declared(context, input)
                }
                LonghandId::BackgroundClip => {
                    longhands::background_clip::parse_declared(context, input)
                }
                LonghandId::BackgroundImage => {
                    longhands::background_image::parse_declared(context, input)
                }
                LonghandId::BackgroundOrigin => {
                    longhands::background_origin::parse_declared(context, input)
                }
                LonghandId::BackgroundPositionX => {
                    longhands::background_position_x::parse_declared(context, input)
                }
                LonghandId::BackgroundPositionY => {
                    longhands::background_position_y::parse_declared(context, input)
                }
                LonghandId::BackgroundRepeat => {
                    longhands::background_repeat::parse_declared(context, input)
                }
                LonghandId::BackgroundSize => {
                    longhands::background_size::parse_declared(context, input)
                }
                LonghandId::BorderImageOutset => {
                    longhands::border_image_outset::parse_declared(context, input)
                }
                LonghandId::BorderImageSlice => {
                    longhands::border_image_slice::parse_declared(context, input)
                }
                LonghandId::BorderImageSource => {
                    longhands::border_image_source::parse_declared(context, input)
                }
                LonghandId::BorderImageWidth => {
                    longhands::border_image_width::parse_declared(context, input)
                }
                LonghandId::BorderSpacing => {
                    longhands::border_spacing::parse_declared(context, input)
                }
                LonghandId::BoxShadow => {
                    longhands::box_shadow::parse_declared(context, input)
                }
                LonghandId::CaretColor => {
                    longhands::caret_color::parse_declared(context, input)
                }
                LonghandId::ClipPath => {
                    longhands::clip_path::parse_declared(context, input)
                }
                LonghandId::Color => {
                    longhands::color::parse_declared(context, input)
                }
                LonghandId::ColumnWidth => {
                    longhands::column_width::parse_declared(context, input)
                }
                LonghandId::Content => {
                    longhands::content::parse_declared(context, input)
                }
                LonghandId::CounterIncrement => {
                    longhands::counter_increment::parse_declared(context, input)
                }
                LonghandId::Cursor => {
                    longhands::cursor::parse_declared(context, input)
                }
                LonghandId::Filter => {
                    longhands::filter::parse_declared(context, input)
                }
                LonghandId::FlexBasis => {
                    longhands::flex_basis::parse_declared(context, input)
                }
                LonghandId::FontFamily => {
                    longhands::font_family::parse_declared(context, input)
                }
                LonghandId::FontFeatureSettings => {
                    longhands::font_feature_settings::parse_declared(context, input)
                }
                LonghandId::FontLanguageOverride => {
                    longhands::font_language_override::parse_declared(context, input)
                }
                LonghandId::FontSize => {
                    longhands::font_size::parse_declared(context, input)
                }
                LonghandId::FontVariantAlternates => {
                    longhands::font_variant_alternates::parse_declared(context, input)
                }
                LonghandId::FontVariationSettings => {
                    longhands::font_variation_settings::parse_declared(context, input)
                }
                LonghandId::GridTemplateAreas => {
                    longhands::grid_template_areas::parse_declared(context, input)
                }
                LonghandId::LetterSpacing => {
                    longhands::letter_spacing::parse_declared(context, input)
                }
                LonghandId::LineHeight => {
                    longhands::line_height::parse_declared(context, input)
                }
                LonghandId::ListStyleImage => {
                    longhands::list_style_image::parse_declared(context, input)
                }
                LonghandId::ListStyleType => {
                    longhands::list_style_type::parse_declared(context, input)
                }
                LonghandId::MaskClip => {
                    longhands::mask_clip::parse_declared(context, input)
                }
                LonghandId::MaskComposite => {
                    longhands::mask_composite::parse_declared(context, input)
                }
                LonghandId::MaskImage => {
                    longhands::mask_image::parse_declared(context, input)
                }
                LonghandId::MaskMode => {
                    longhands::mask_mode::parse_declared(context, input)
                }
                LonghandId::MaskOrigin => {
                    longhands::mask_origin::parse_declared(context, input)
                }
                LonghandId::MaskPositionX => {
                    longhands::mask_position_x::parse_declared(context, input)
                }
                LonghandId::MaskPositionY => {
                    longhands::mask_position_y::parse_declared(context, input)
                }
                LonghandId::MaskRepeat => {
                    longhands::mask_repeat::parse_declared(context, input)
                }
                LonghandId::MaskSize => {
                    longhands::mask_size::parse_declared(context, input)
                }
                LonghandId::MozContextProperties => {
                    longhands::_moz_context_properties::parse_declared(context, input)
                }
                LonghandId::MozFontSmoothingBackgroundColor => {
                    longhands::_moz_font_smoothing_background_color::parse_declared(context, input)
                }
                LonghandId::MozTabSize => {
                    longhands::_moz_tab_size::parse_declared(context, input)
                }
                LonghandId::OffsetPath => {
                    longhands::offset_path::parse_declared(context, input)
                }
                LonghandId::Perspective => {
                    longhands::perspective::parse_declared(context, input)
                }
                LonghandId::Quotes => {
                    longhands::quotes::parse_declared(context, input)
                }
                LonghandId::Rotate => {
                    longhands::rotate::parse_declared(context, input)
                }
                LonghandId::Scale => {
                    longhands::scale::parse_declared(context, input)
                }
                LonghandId::ScrollSnapCoordinate => {
                    longhands::scroll_snap_coordinate::parse_declared(context, input)
                }
                LonghandId::ScrollbarColor => {
                    longhands::scrollbar_color::parse_declared(context, input)
                }
                LonghandId::ShapeOutside => {
                    longhands::shape_outside::parse_declared(context, input)
                }
                LonghandId::StrokeDasharray => {
                    longhands::stroke_dasharray::parse_declared(context, input)
                }
                LonghandId::StrokeDashoffset => {
                    longhands::stroke_dashoffset::parse_declared(context, input)
                }
                LonghandId::StrokeWidth => {
                    longhands::stroke_width::parse_declared(context, input)
                }
                LonghandId::TextEmphasisStyle => {
                    longhands::text_emphasis_style::parse_declared(context, input)
                }
                LonghandId::TextIndent => {
                    longhands::text_indent::parse_declared(context, input)
                }
                LonghandId::TextOverflow => {
                    longhands::text_overflow::parse_declared(context, input)
                }
                LonghandId::TextShadow => {
                    longhands::text_shadow::parse_declared(context, input)
                }
                LonghandId::TransitionDelay => {
                    longhands::transition_delay::parse_declared(context, input)
                }
                LonghandId::TransitionDuration => {
                    longhands::transition_duration::parse_declared(context, input)
                }
                LonghandId::TransitionProperty => {
                    longhands::transition_property::parse_declared(context, input)
                }
                LonghandId::TransitionTimingFunction => {
                    longhands::transition_timing_function::parse_declared(context, input)
                }
                LonghandId::Translate => {
                    longhands::translate::parse_declared(context, input)
                }
                LonghandId::VerticalAlign => {
                    longhands::vertical_align::parse_declared(context, input)
                }
                LonghandId::WillChange => {
                    longhands::will_change::parse_declared(context, input)
                }
                LonghandId::WordSpacing => {
                    longhands::word_spacing::parse_declared(context, input)
                }
                LonghandId::XLang => {
                    longhands::_x_lang::parse_declared(context, input)
                }
                LonghandId::Clip => {
                    longhands::clip::parse_declared(context, input)
                }
                LonghandId::MozImageRegion => {
                    longhands::_moz_image_region::parse_declared(context, input)
                }
                LonghandId::GridTemplateColumns => {
                    longhands::grid_template_columns::parse_declared(context, input)
                }
                LonghandId::GridTemplateRows => {
                    longhands::grid_template_rows::parse_declared(context, input)
                }
                LonghandId::Fill => {
                    longhands::fill::parse_declared(context, input)
                }
                LonghandId::Stroke => {
                    longhands::stroke::parse_declared(context, input)
                }
                LonghandId::GridAutoColumns => {
                    longhands::grid_auto_columns::parse_declared(context, input)
                }
                LonghandId::GridAutoRows => {
                    longhands::grid_auto_rows::parse_declared(context, input)
                }
                LonghandId::MozWindowTransformOrigin => {
                    longhands::_moz_window_transform_origin::parse_declared(context, input)
                }
                LonghandId::TransformOrigin => {
                    longhands::transform_origin::parse_declared(context, input)
                }
                LonghandId::CounterReset => {
                    longhands::counter_reset::parse_declared(context, input)
                }
                LonghandId::CounterSet => {
                    longhands::counter_set::parse_declared(context, input)
                }
                LonghandId::ScrollSnapPointsX => {
                    longhands::scroll_snap_points_x::parse_declared(context, input)
                }
                LonghandId::ScrollSnapPointsY => {
                    longhands::scroll_snap_points_y::parse_declared(context, input)
                }
                LonghandId::MozWindowTransform => {
                    longhands::_moz_window_transform::parse_declared(context, input)
                }
                LonghandId::Transform => {
                    longhands::transform::parse_declared(context, input)
                }
                LonghandId::ColumnGap => {
                    longhands::column_gap::parse_declared(context, input)
                }
                LonghandId::RowGap => {
                    longhands::row_gap::parse_declared(context, input)
                }
                LonghandId::ObjectPosition => {
                    longhands::object_position::parse_declared(context, input)
                }
                LonghandId::PerspectiveOrigin => {
                    longhands::perspective_origin::parse_declared(context, input)
                }
                LonghandId::ScrollSnapDestination => {
                    longhands::scroll_snap_destination::parse_declared(context, input)
                }
                LonghandId::GridColumnEnd => {
                    longhands::grid_column_end::parse_declared(context, input)
                }
                LonghandId::GridColumnStart => {
                    longhands::grid_column_start::parse_declared(context, input)
                }
                LonghandId::GridRowEnd => {
                    longhands::grid_row_end::parse_declared(context, input)
                }
                LonghandId::GridRowStart => {
                    longhands::grid_row_start::parse_declared(context, input)
                }
                LonghandId::MaxBlockSize => {
                    longhands::max_block_size::parse_declared(context, input)
                }
                LonghandId::MaxHeight => {
                    longhands::max_height::parse_declared(context, input)
                }
                LonghandId::MaxInlineSize => {
                    longhands::max_inline_size::parse_declared(context, input)
                }
                LonghandId::MaxWidth => {
                    longhands::max_width::parse_declared(context, input)
                }
                LonghandId::MarkerEnd => {
                    longhands::marker_end::parse_declared(context, input)
                }
                LonghandId::MarkerMid => {
                    longhands::marker_mid::parse_declared(context, input)
                }
                LonghandId::MarkerStart => {
                    longhands::marker_start::parse_declared(context, input)
                }
                LonghandId::MozBinding => {
                    longhands::_moz_binding::parse_declared(context, input)
                }
                LonghandId::ScrollPaddingBlockEnd => {
                    longhands::scroll_padding_block_end::parse_declared(context, input)
                }
                LonghandId::ScrollPaddingBlockStart => {
                    longhands::scroll_padding_block_start::parse_declared(context, input)
                }
                LonghandId::ScrollPaddingBottom => {
                    longhands::scroll_padding_bottom::parse_declared(context, input)
                }
                LonghandId::ScrollPaddingInlineEnd => {
                    longhands::scroll_padding_inline_end::parse_declared(context, input)
                }
                LonghandId::ScrollPaddingInlineStart => {
                    longhands::scroll_padding_inline_start::parse_declared(context, input)
                }
                LonghandId::ScrollPaddingLeft => {
                    longhands::scroll_padding_left::parse_declared(context, input)
                }
                LonghandId::ScrollPaddingRight => {
                    longhands::scroll_padding_right::parse_declared(context, input)
                }
                LonghandId::ScrollPaddingTop => {
                    longhands::scroll_padding_top::parse_declared(context, input)
                }
                LonghandId::BlockSize => {
                    longhands::block_size::parse_declared(context, input)
                }
                LonghandId::Height => {
                    longhands::height::parse_declared(context, input)
                }
                LonghandId::InlineSize => {
                    longhands::inline_size::parse_declared(context, input)
                }
                LonghandId::MinBlockSize => {
                    longhands::min_block_size::parse_declared(context, input)
                }
                LonghandId::MinHeight => {
                    longhands::min_height::parse_declared(context, input)
                }
                LonghandId::MinInlineSize => {
                    longhands::min_inline_size::parse_declared(context, input)
                }
                LonghandId::MinWidth => {
                    longhands::min_width::parse_declared(context, input)
                }
                LonghandId::Width => {
                    longhands::width::parse_declared(context, input)
                }
                LonghandId::OutlineOffset => {
                    longhands::outline_offset::parse_declared(context, input)
                }
                LonghandId::ScrollMarginBlockEnd => {
                    longhands::scroll_margin_block_end::parse_declared(context, input)
                }
                LonghandId::ScrollMarginBlockStart => {
                    longhands::scroll_margin_block_start::parse_declared(context, input)
                }
                LonghandId::ScrollMarginBottom => {
                    longhands::scroll_margin_bottom::parse_declared(context, input)
                }
                LonghandId::ScrollMarginInlineEnd => {
                    longhands::scroll_margin_inline_end::parse_declared(context, input)
                }
                LonghandId::ScrollMarginInlineStart => {
                    longhands::scroll_margin_inline_start::parse_declared(context, input)
                }
                LonghandId::ScrollMarginLeft => {
                    longhands::scroll_margin_left::parse_declared(context, input)
                }
                LonghandId::ScrollMarginRight => {
                    longhands::scroll_margin_right::parse_declared(context, input)
                }
                LonghandId::ScrollMarginTop => {
                    longhands::scroll_margin_top::parse_declared(context, input)
                }
                LonghandId::PaddingBlockEnd => {
                    longhands::padding_block_end::parse_declared(context, input)
                }
                LonghandId::PaddingBlockStart => {
                    longhands::padding_block_start::parse_declared(context, input)
                }
                LonghandId::PaddingBottom => {
                    longhands::padding_bottom::parse_declared(context, input)
                }
                LonghandId::PaddingInlineEnd => {
                    longhands::padding_inline_end::parse_declared(context, input)
                }
                LonghandId::PaddingInlineStart => {
                    longhands::padding_inline_start::parse_declared(context, input)
                }
                LonghandId::PaddingLeft => {
                    longhands::padding_left::parse_declared(context, input)
                }
                LonghandId::PaddingRight => {
                    longhands::padding_right::parse_declared(context, input)
                }
                LonghandId::PaddingTop => {
                    longhands::padding_top::parse_declared(context, input)
                }
                LonghandId::ShapeMargin => {
                    longhands::shape_margin::parse_declared(context, input)
                }
                LonghandId::BorderBlockEndWidth => {
                    longhands::border_block_end_width::parse_declared(context, input)
                }
                LonghandId::BorderBlockStartWidth => {
                    longhands::border_block_start_width::parse_declared(context, input)
                }
                LonghandId::BorderBottomWidth => {
                    longhands::border_bottom_width::parse_declared(context, input)
                }
                LonghandId::BorderInlineEndWidth => {
                    longhands::border_inline_end_width::parse_declared(context, input)
                }
                LonghandId::BorderInlineStartWidth => {
                    longhands::border_inline_start_width::parse_declared(context, input)
                }
                LonghandId::BorderLeftWidth => {
                    longhands::border_left_width::parse_declared(context, input)
                }
                LonghandId::BorderRightWidth => {
                    longhands::border_right_width::parse_declared(context, input)
                }
                LonghandId::BorderTopWidth => {
                    longhands::border_top_width::parse_declared(context, input)
                }
                LonghandId::ColumnRuleWidth => {
                    longhands::column_rule_width::parse_declared(context, input)
                }
                LonghandId::OutlineWidth => {
                    longhands::outline_width::parse_declared(context, input)
                }
                LonghandId::WebkitTextStrokeWidth => {
                    longhands::_webkit_text_stroke_width::parse_declared(context, input)
                }
                LonghandId::BorderBottomLeftRadius => {
                    longhands::border_bottom_left_radius::parse_declared(context, input)
                }
                LonghandId::BorderBottomRightRadius => {
                    longhands::border_bottom_right_radius::parse_declared(context, input)
                }
                LonghandId::BorderEndEndRadius => {
                    longhands::border_end_end_radius::parse_declared(context, input)
                }
                LonghandId::BorderEndStartRadius => {
                    longhands::border_end_start_radius::parse_declared(context, input)
                }
                LonghandId::BorderStartEndRadius => {
                    longhands::border_start_end_radius::parse_declared(context, input)
                }
                LonghandId::BorderStartStartRadius => {
                    longhands::border_start_start_radius::parse_declared(context, input)
                }
                LonghandId::BorderTopLeftRadius => {
                    longhands::border_top_left_radius::parse_declared(context, input)
                }
                LonghandId::BorderTopRightRadius => {
                    longhands::border_top_right_radius::parse_declared(context, input)
                }
                LonghandId::MozOutlineRadiusBottomleft => {
                    longhands::_moz_outline_radius_bottomleft::parse_declared(context, input)
                }
                LonghandId::MozOutlineRadiusBottomright => {
                    longhands::_moz_outline_radius_bottomright::parse_declared(context, input)
                }
                LonghandId::MozOutlineRadiusTopleft => {
                    longhands::_moz_outline_radius_topleft::parse_declared(context, input)
                }
                LonghandId::MozOutlineRadiusTopright => {
                    longhands::_moz_outline_radius_topright::parse_declared(context, input)
                }
                LonghandId::Bottom => {
                    longhands::bottom::parse_declared(context, input)
                }
                LonghandId::InsetBlockEnd => {
                    longhands::inset_block_end::parse_declared(context, input)
                }
                LonghandId::InsetBlockStart => {
                    longhands::inset_block_start::parse_declared(context, input)
                }
                LonghandId::InsetInlineEnd => {
                    longhands::inset_inline_end::parse_declared(context, input)
                }
                LonghandId::InsetInlineStart => {
                    longhands::inset_inline_start::parse_declared(context, input)
                }
                LonghandId::Left => {
                    longhands::left::parse_declared(context, input)
                }
                LonghandId::MarginBlockEnd => {
                    longhands::margin_block_end::parse_declared(context, input)
                }
                LonghandId::MarginBlockStart => {
                    longhands::margin_block_start::parse_declared(context, input)
                }
                LonghandId::MarginBottom => {
                    longhands::margin_bottom::parse_declared(context, input)
                }
                LonghandId::MarginInlineEnd => {
                    longhands::margin_inline_end::parse_declared(context, input)
                }
                LonghandId::MarginInlineStart => {
                    longhands::margin_inline_start::parse_declared(context, input)
                }
                LonghandId::MarginLeft => {
                    longhands::margin_left::parse_declared(context, input)
                }
                LonghandId::MarginRight => {
                    longhands::margin_right::parse_declared(context, input)
                }
                LonghandId::MarginTop => {
                    longhands::margin_top::parse_declared(context, input)
                }
                LonghandId::Right => {
                    longhands::right::parse_declared(context, input)
                }
                LonghandId::Top => {
                    longhands::top::parse_declared(context, input)
                }
                LonghandId::BackgroundColor => {
                    longhands::background_color::parse_declared(context, input)
                }
                LonghandId::BorderBlockEndColor => {
                    longhands::border_block_end_color::parse_declared(context, input)
                }
                LonghandId::BorderBlockStartColor => {
                    longhands::border_block_start_color::parse_declared(context, input)
                }
                LonghandId::BorderBottomColor => {
                    longhands::border_bottom_color::parse_declared(context, input)
                }
                LonghandId::BorderInlineEndColor => {
                    longhands::border_inline_end_color::parse_declared(context, input)
                }
                LonghandId::BorderInlineStartColor => {
                    longhands::border_inline_start_color::parse_declared(context, input)
                }
                LonghandId::BorderLeftColor => {
                    longhands::border_left_color::parse_declared(context, input)
                }
                LonghandId::BorderRightColor => {
                    longhands::border_right_color::parse_declared(context, input)
                }
                LonghandId::BorderTopColor => {
                    longhands::border_top_color::parse_declared(context, input)
                }
                LonghandId::ColumnRuleColor => {
                    longhands::column_rule_color::parse_declared(context, input)
                }
                LonghandId::FloodColor => {
                    longhands::flood_color::parse_declared(context, input)
                }
                LonghandId::LightingColor => {
                    longhands::lighting_color::parse_declared(context, input)
                }
                LonghandId::OutlineColor => {
                    longhands::outline_color::parse_declared(context, input)
                }
                LonghandId::StopColor => {
                    longhands::stop_color::parse_declared(context, input)
                }
                LonghandId::TextDecorationColor => {
                    longhands::text_decoration_color::parse_declared(context, input)
                }
                LonghandId::TextEmphasisColor => {
                    longhands::text_emphasis_color::parse_declared(context, input)
                }
                LonghandId::WebkitTextFillColor => {
                    longhands::_webkit_text_fill_color::parse_declared(context, input)
                }
                LonghandId::WebkitTextStrokeColor => {
                    longhands::_webkit_text_stroke_color::parse_declared(context, input)
                }
        }
    }

    /// Returns whether this property is animatable.
    #[inline]
    pub fn is_animatable(self) -> bool {
        LonghandIdSet::animatable().contains(self)
    }

    /// Returns whether this property is animatable in a discrete way.
    #[inline]
    pub fn is_discrete_animatable(self) -> bool {
        LonghandIdSet::discrete_animatable().contains(self)
    }

    /// Converts from a LonghandId to an adequate nsCSSPropertyID.
    #[cfg(feature = "gecko")]
    #[inline]
    pub fn to_nscsspropertyid(self) -> nsCSSPropertyID {
        NonCustomPropertyId::from(self).to_nscsspropertyid()
    }

    #[cfg(feature = "gecko")]
    #[allow(non_upper_case_globals)]
    /// Returns a longhand id from Gecko's nsCSSPropertyID.
    pub fn from_nscsspropertyid(id: nsCSSPropertyID) -> Result<Self, ()> {
        match PropertyId::from_nscsspropertyid(id) {
            Ok(PropertyId::Longhand(id)) |
            Ok(PropertyId::LonghandAlias(id, _)) => Ok(id),
            _ => Err(()),
        }
    }

    /// Return whether this property is logical.
    #[inline]
    pub fn is_logical(self) -> bool {
        LonghandIdSet::logical().contains(self)
    }

    /// If this is a logical property, return the corresponding physical one in
    /// the given writing mode.
    ///
    /// Otherwise, return unchanged.
    #[inline]
    pub fn to_physical(&self, wm: WritingMode) -> Self {
        match *self {
                
                LonghandId::BorderBlockEndStyle => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::BorderTopStyle
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::BorderRightStyle
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::BorderBottomStyle
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::BorderLeftStyle
                    
                }
        }

                }
                
                LonghandId::BorderBlockStartStyle => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::BorderTopStyle
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::BorderRightStyle
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::BorderBottomStyle
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::BorderLeftStyle
                    
                }
        }

                }
                
                LonghandId::BorderInlineEndStyle => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::BorderTopStyle
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::BorderRightStyle
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::BorderBottomStyle
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::BorderLeftStyle
                    
                }
        }

                }
                
                LonghandId::BorderInlineStartStyle => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::BorderTopStyle
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::BorderRightStyle
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::BorderBottomStyle
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::BorderLeftStyle
                    
                }
        }

                }
                
                LonghandId::MaxBlockSize => {
                    
    
        
        if wm.is_vertical() {
            
                        
                        LonghandId::MaxWidth
                    
        } else {
            
                        
                        LonghandId::MaxHeight
                    
        }

                }
                
                LonghandId::MaxInlineSize => {
                    
    
        
        if wm.is_vertical() {
            
                        
                        LonghandId::MaxHeight
                    
        } else {
            
                        
                        LonghandId::MaxWidth
                    
        }

                }
                
                LonghandId::ScrollPaddingBlockEnd => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::ScrollPaddingTop
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::ScrollPaddingRight
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::ScrollPaddingBottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::ScrollPaddingLeft
                    
                }
        }

                }
                
                LonghandId::ScrollPaddingBlockStart => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::ScrollPaddingTop
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::ScrollPaddingRight
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::ScrollPaddingBottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::ScrollPaddingLeft
                    
                }
        }

                }
                
                LonghandId::ScrollPaddingInlineEnd => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::ScrollPaddingTop
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::ScrollPaddingRight
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::ScrollPaddingBottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::ScrollPaddingLeft
                    
                }
        }

                }
                
                LonghandId::ScrollPaddingInlineStart => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::ScrollPaddingTop
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::ScrollPaddingRight
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::ScrollPaddingBottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::ScrollPaddingLeft
                    
                }
        }

                }
                
                LonghandId::BlockSize => {
                    
    
        
        if wm.is_vertical() {
            
                        
                        LonghandId::Width
                    
        } else {
            
                        
                        LonghandId::Height
                    
        }

                }
                
                LonghandId::InlineSize => {
                    
    
        
        if wm.is_vertical() {
            
                        
                        LonghandId::Height
                    
        } else {
            
                        
                        LonghandId::Width
                    
        }

                }
                
                LonghandId::MinBlockSize => {
                    
    
        
        if wm.is_vertical() {
            
                        
                        LonghandId::MinWidth
                    
        } else {
            
                        
                        LonghandId::MinHeight
                    
        }

                }
                
                LonghandId::MinInlineSize => {
                    
    
        
        if wm.is_vertical() {
            
                        
                        LonghandId::MinHeight
                    
        } else {
            
                        
                        LonghandId::MinWidth
                    
        }

                }
                
                LonghandId::ScrollMarginBlockEnd => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::ScrollMarginTop
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::ScrollMarginRight
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::ScrollMarginBottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::ScrollMarginLeft
                    
                }
        }

                }
                
                LonghandId::ScrollMarginBlockStart => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::ScrollMarginTop
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::ScrollMarginRight
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::ScrollMarginBottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::ScrollMarginLeft
                    
                }
        }

                }
                
                LonghandId::ScrollMarginInlineEnd => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::ScrollMarginTop
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::ScrollMarginRight
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::ScrollMarginBottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::ScrollMarginLeft
                    
                }
        }

                }
                
                LonghandId::ScrollMarginInlineStart => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::ScrollMarginTop
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::ScrollMarginRight
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::ScrollMarginBottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::ScrollMarginLeft
                    
                }
        }

                }
                
                LonghandId::PaddingBlockEnd => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::PaddingTop
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::PaddingRight
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::PaddingBottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::PaddingLeft
                    
                }
        }

                }
                
                LonghandId::PaddingBlockStart => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::PaddingTop
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::PaddingRight
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::PaddingBottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::PaddingLeft
                    
                }
        }

                }
                
                LonghandId::PaddingInlineEnd => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::PaddingTop
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::PaddingRight
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::PaddingBottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::PaddingLeft
                    
                }
        }

                }
                
                LonghandId::PaddingInlineStart => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::PaddingTop
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::PaddingRight
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::PaddingBottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::PaddingLeft
                    
                }
        }

                }
                
                LonghandId::BorderBlockEndWidth => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::BorderTopWidth
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::BorderRightWidth
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::BorderBottomWidth
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::BorderLeftWidth
                    
                }
        }

                }
                
                LonghandId::BorderBlockStartWidth => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::BorderTopWidth
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::BorderRightWidth
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::BorderBottomWidth
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::BorderLeftWidth
                    
                }
        }

                }
                
                LonghandId::BorderInlineEndWidth => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::BorderTopWidth
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::BorderRightWidth
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::BorderBottomWidth
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::BorderLeftWidth
                    
                }
        }

                }
                
                LonghandId::BorderInlineStartWidth => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::BorderTopWidth
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::BorderRightWidth
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::BorderBottomWidth
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::BorderLeftWidth
                    
                }
        }

                }
                
                LonghandId::BorderEndEndRadius => {
                    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                        
                        LonghandId::BorderTopLeftRadius
                    
                }
                PhysicalCorner::TopRight => {
                    
                        
                        LonghandId::BorderTopRightRadius
                    
                }
                PhysicalCorner::BottomRight => {
                    
                        
                        LonghandId::BorderBottomRightRadius
                    
                }
                PhysicalCorner::BottomLeft => {
                    
                        
                        LonghandId::BorderBottomLeftRadius
                    
                }
        }

                }
                
                LonghandId::BorderEndStartRadius => {
                    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                        
                        LonghandId::BorderTopLeftRadius
                    
                }
                PhysicalCorner::TopRight => {
                    
                        
                        LonghandId::BorderTopRightRadius
                    
                }
                PhysicalCorner::BottomRight => {
                    
                        
                        LonghandId::BorderBottomRightRadius
                    
                }
                PhysicalCorner::BottomLeft => {
                    
                        
                        LonghandId::BorderBottomLeftRadius
                    
                }
        }

                }
                
                LonghandId::BorderStartEndRadius => {
                    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                        
                        LonghandId::BorderTopLeftRadius
                    
                }
                PhysicalCorner::TopRight => {
                    
                        
                        LonghandId::BorderTopRightRadius
                    
                }
                PhysicalCorner::BottomRight => {
                    
                        
                        LonghandId::BorderBottomRightRadius
                    
                }
                PhysicalCorner::BottomLeft => {
                    
                        
                        LonghandId::BorderBottomLeftRadius
                    
                }
        }

                }
                
                LonghandId::BorderStartStartRadius => {
                    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                        
                        LonghandId::BorderTopLeftRadius
                    
                }
                PhysicalCorner::TopRight => {
                    
                        
                        LonghandId::BorderTopRightRadius
                    
                }
                PhysicalCorner::BottomRight => {
                    
                        
                        LonghandId::BorderBottomRightRadius
                    
                }
                PhysicalCorner::BottomLeft => {
                    
                        
                        LonghandId::BorderBottomLeftRadius
                    
                }
        }

                }
                
                LonghandId::InsetBlockEnd => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::Top
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::Right
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::Bottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::Left
                    
                }
        }

                }
                
                LonghandId::InsetBlockStart => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::Top
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::Right
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::Bottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::Left
                    
                }
        }

                }
                
                LonghandId::InsetInlineEnd => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::Top
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::Right
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::Bottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::Left
                    
                }
        }

                }
                
                LonghandId::InsetInlineStart => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::Top
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::Right
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::Bottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::Left
                    
                }
        }

                }
                
                LonghandId::MarginBlockEnd => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::MarginTop
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::MarginRight
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::MarginBottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::MarginLeft
                    
                }
        }

                }
                
                LonghandId::MarginBlockStart => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::MarginTop
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::MarginRight
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::MarginBottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::MarginLeft
                    
                }
        }

                }
                
                LonghandId::MarginInlineEnd => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::MarginTop
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::MarginRight
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::MarginBottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::MarginLeft
                    
                }
        }

                }
                
                LonghandId::MarginInlineStart => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::MarginTop
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::MarginRight
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::MarginBottom
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::MarginLeft
                    
                }
        }

                }
                
                LonghandId::BorderBlockEndColor => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::BorderTopColor
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::BorderRightColor
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::BorderBottomColor
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::BorderLeftColor
                    
                }
        }

                }
                
                LonghandId::BorderBlockStartColor => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::BorderTopColor
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::BorderRightColor
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::BorderBottomColor
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::BorderLeftColor
                    
                }
        }

                }
                
                LonghandId::BorderInlineEndColor => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::BorderTopColor
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::BorderRightColor
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::BorderBottomColor
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::BorderLeftColor
                    
                }
        }

                }
                
                LonghandId::BorderInlineStartColor => {
                    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                        
                        LonghandId::BorderTopColor
                    
                }
                PhysicalSide::Right => {
                    
                        
                        LonghandId::BorderRightColor
                    
                }
                PhysicalSide::Bottom => {
                    
                        
                        LonghandId::BorderBottomColor
                    
                }
                PhysicalSide::Left => {
                    
                        
                        LonghandId::BorderLeftColor
                    
                }
        }

                }
            _ => *self
        }
    }

    /// Return the logical group of this longhand property.
    pub fn logical_group(&self) -> Option<LogicalGroup> {
        const LOGICAL_GROUPS: [Option<LogicalGroup>; 353] = [
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            Some(LogicalGroup::BorderStyle),
            Some(LogicalGroup::BorderStyle),
            Some(LogicalGroup::BorderStyle),
            Some(LogicalGroup::BorderStyle),
            Some(LogicalGroup::BorderStyle),
            Some(LogicalGroup::BorderStyle),
            Some(LogicalGroup::BorderStyle),
            Some(LogicalGroup::BorderStyle),
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            Some(LogicalGroup::MaxSize),
            Some(LogicalGroup::MaxSize),
            Some(LogicalGroup::MaxSize),
            Some(LogicalGroup::MaxSize),
            None,
            None,
            None,
            None,
            Some(LogicalGroup::ScrollPadding),
            Some(LogicalGroup::ScrollPadding),
            Some(LogicalGroup::ScrollPadding),
            Some(LogicalGroup::ScrollPadding),
            Some(LogicalGroup::ScrollPadding),
            Some(LogicalGroup::ScrollPadding),
            Some(LogicalGroup::ScrollPadding),
            Some(LogicalGroup::ScrollPadding),
            Some(LogicalGroup::Size),
            Some(LogicalGroup::Size),
            Some(LogicalGroup::Size),
            Some(LogicalGroup::MinSize),
            Some(LogicalGroup::MinSize),
            Some(LogicalGroup::MinSize),
            Some(LogicalGroup::MinSize),
            Some(LogicalGroup::Size),
            None,
            Some(LogicalGroup::ScrollMargin),
            Some(LogicalGroup::ScrollMargin),
            Some(LogicalGroup::ScrollMargin),
            Some(LogicalGroup::ScrollMargin),
            Some(LogicalGroup::ScrollMargin),
            Some(LogicalGroup::ScrollMargin),
            Some(LogicalGroup::ScrollMargin),
            Some(LogicalGroup::ScrollMargin),
            Some(LogicalGroup::Padding),
            Some(LogicalGroup::Padding),
            Some(LogicalGroup::Padding),
            Some(LogicalGroup::Padding),
            Some(LogicalGroup::Padding),
            Some(LogicalGroup::Padding),
            Some(LogicalGroup::Padding),
            Some(LogicalGroup::Padding),
            None,
            Some(LogicalGroup::BorderWidth),
            Some(LogicalGroup::BorderWidth),
            Some(LogicalGroup::BorderWidth),
            Some(LogicalGroup::BorderWidth),
            Some(LogicalGroup::BorderWidth),
            Some(LogicalGroup::BorderWidth),
            Some(LogicalGroup::BorderWidth),
            Some(LogicalGroup::BorderWidth),
            None,
            None,
            None,
            Some(LogicalGroup::BorderRadius),
            Some(LogicalGroup::BorderRadius),
            Some(LogicalGroup::BorderRadius),
            Some(LogicalGroup::BorderRadius),
            Some(LogicalGroup::BorderRadius),
            Some(LogicalGroup::BorderRadius),
            Some(LogicalGroup::BorderRadius),
            Some(LogicalGroup::BorderRadius),
            None,
            None,
            None,
            None,
            Some(LogicalGroup::Inset),
            Some(LogicalGroup::Inset),
            Some(LogicalGroup::Inset),
            Some(LogicalGroup::Inset),
            Some(LogicalGroup::Inset),
            Some(LogicalGroup::Inset),
            Some(LogicalGroup::Margin),
            Some(LogicalGroup::Margin),
            Some(LogicalGroup::Margin),
            Some(LogicalGroup::Margin),
            Some(LogicalGroup::Margin),
            Some(LogicalGroup::Margin),
            Some(LogicalGroup::Margin),
            Some(LogicalGroup::Margin),
            Some(LogicalGroup::Inset),
            Some(LogicalGroup::Inset),
            None,
            Some(LogicalGroup::BorderColor),
            Some(LogicalGroup::BorderColor),
            Some(LogicalGroup::BorderColor),
            Some(LogicalGroup::BorderColor),
            Some(LogicalGroup::BorderColor),
            Some(LogicalGroup::BorderColor),
            Some(LogicalGroup::BorderColor),
            Some(LogicalGroup::BorderColor),
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
            None,
        ];
        LOGICAL_GROUPS[*self as usize]
    }

    /// Returns PropertyFlags for given longhand property.
    #[inline(always)]
    pub fn flags(self) -> PropertyFlags {
        // TODO(emilio): This can be simplified further as Rust gains more
        // constant expression support.
        const FLAGS: [u8; 353] = [
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::CREATES_STACKING_CONTEXT.bits |
                    PropertyFlags::FIXPOS_CB.bits |
                0,
                0,
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::CREATES_STACKING_CONTEXT.bits |
                0,
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::CREATES_STACKING_CONTEXT.bits |
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::CREATES_STACKING_CONTEXT.bits |
                    PropertyFlags::ABSPOS_CB.bits |
                0,
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                0,
                0,
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                0,
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                0,
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                0,
                0,
                    PropertyFlags::CREATES_STACKING_CONTEXT.bits |
                    PropertyFlags::FIXPOS_CB.bits |
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::CREATES_STACKING_CONTEXT.bits |
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::CREATES_STACKING_CONTEXT.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                    PropertyFlags::CAN_ANIMATE_ON_COMPOSITOR.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                0,
                    PropertyFlags::CREATES_STACKING_CONTEXT.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::CREATES_STACKING_CONTEXT.bits |
                    PropertyFlags::FIXPOS_CB.bits |
                0,
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::CREATES_STACKING_CONTEXT.bits |
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::CREATES_STACKING_CONTEXT.bits |
                    PropertyFlags::FIXPOS_CB.bits |
                0,
                    PropertyFlags::CREATES_STACKING_CONTEXT.bits |
                    PropertyFlags::FIXPOS_CB.bits |
                0,
                0,
                    PropertyFlags::CREATES_STACKING_CONTEXT.bits |
                    PropertyFlags::FIXPOS_CB.bits |
                    PropertyFlags::CAN_ANIMATE_ON_COMPOSITOR.bits |
                0,
                    PropertyFlags::CREATES_STACKING_CONTEXT.bits |
                    PropertyFlags::FIXPOS_CB.bits |
                    PropertyFlags::CAN_ANIMATE_ON_COMPOSITOR.bits |
                0,
                0,
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::CREATES_STACKING_CONTEXT.bits |
                    PropertyFlags::FIXPOS_CB.bits |
                    PropertyFlags::CAN_ANIMATE_ON_COMPOSITOR.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                0,
                0,
                0,
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::CREATES_STACKING_CONTEXT.bits |
                    PropertyFlags::FIXPOS_CB.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                    PropertyFlags::CAN_ANIMATE_ON_COMPOSITOR.bits |
                0,
                0,
                0,
                0,
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                0,
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::GETCS_NEEDS_LAYOUT_FLUSH.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                    PropertyFlags::CAN_ANIMATE_ON_COMPOSITOR.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                0,
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
                    PropertyFlags::APPLIES_TO_FIRST_LETTER.bits |
                    PropertyFlags::APPLIES_TO_FIRST_LINE.bits |
                    PropertyFlags::APPLIES_TO_PLACEHOLDER.bits |
                0,
        ];
        PropertyFlags::from_bits_truncate(FLAGS[self as usize])
    }

    /// Only a few properties are allowed to depend on the visited state of
    /// links. When cascading visited styles, we can save time by only
    /// processing these properties.
    fn is_visited_dependent(&self) -> bool {
        matches!(*self,
            LonghandId::ColumnRuleColor |
            LonghandId::TextEmphasisColor |
            LonghandId::WebkitTextFillColor |
            LonghandId::WebkitTextStrokeColor |
            LonghandId::TextDecorationColor |
            LonghandId::Fill |
            LonghandId::Stroke |
            LonghandId::CaretColor |
            LonghandId::Color |
            LonghandId::BackgroundColor |
            LonghandId::BorderTopColor |
            LonghandId::BorderRightColor |
            LonghandId::BorderBottomColor |
            LonghandId::BorderLeftColor |
            LonghandId::OutlineColor
        )
    }

    /// Returns true if the property is one that is ignored when document
    /// colors are disabled.
    #[inline]
    fn ignored_when_document_colors_disabled(self) -> bool {
        LonghandIdSet::ignored_when_colors_disabled().contains(self)
    }

    /// The computed value of some properties depends on the (sometimes
    /// computed) value of *other* properties.
    ///
    /// So we classify properties into "early" and "other", such that the only
    /// dependencies can be from "other" to "early".
    ///
    /// Unfortunately, it’s not easy to check that this classification is
    /// correct.
    fn is_early_property(&self) -> bool {
        matches!(*self,

            // Needed to properly compute the writing mode, to resolve logical
            // properties, and similar stuff. In this block instead of along
            // `WritingMode` and `Direction` just for convenience, since it's
            // Gecko-only (for now at least).
            //
            // see WritingMode::new.
            LonghandId::TextOrientation |

            // Needed to properly compute the zoomed font-size.
            //
            // FIXME(emilio): This could probably just be a cascade flag like
            // IN_SVG_SUBTREE or such, and we could nuke this property.
            LonghandId::XTextZoom |

            // Needed to do font-size computation in a language-dependent way.
            LonghandId::XLang |
            // Needed for ruby to respect language-dependent min-font-size
            // preferences properly, see bug 1165538.
            LonghandId::MozMinFontSizeRatio |

            // Needed to do font-size for MathML. :(
            LonghandId::MozScriptLevel |

            // Needed to compute the first available font, in order to
            // compute font-relative units correctly.
            LonghandId::FontSize |
            LonghandId::FontWeight |
            LonghandId::FontStretch |
            LonghandId::FontStyle |
            LonghandId::FontFamily |

            // Needed to properly compute the writing mode, to resolve logical
            // properties, and similar stuff.
            LonghandId::WritingMode |
            LonghandId::Direction
        )
    }
}

/// An iterator over all the property ids that are enabled for a given
/// shorthand, if that shorthand is enabled for all content too.
pub struct NonCustomPropertyIterator<Item: 'static> {
    filter: bool,
    iter: std::slice::Iter<'static, Item>,
}

impl<Item> Iterator for NonCustomPropertyIterator<Item>
where
    Item: 'static + Copy + Into<NonCustomPropertyId>,
{
    type Item = Item;

    fn next(&mut self) -> Option<Self::Item> {
        loop {
            let id = *self.iter.next()?;
            if !self.filter || id.into().enabled_for_all_content() {
                return Some(id)
            }
        }
    }
}

/// An identifier for a given shorthand property.
#[derive(Clone, Copy, Debug, Eq, Hash, MallocSizeOf, PartialEq, ToShmem)]
#[repr(u16)]
pub enum ShorthandId {
        /// background
        Background = 0,
        /// background-position
        BackgroundPosition = 1,
        /// border-color
        BorderColor = 2,
        /// border-style
        BorderStyle = 3,
        /// border-width
        BorderWidth = 4,
        /// border-top
        BorderTop = 5,
        /// border-right
        BorderRight = 6,
        /// border-bottom
        BorderBottom = 7,
        /// border-left
        BorderLeft = 8,
        /// border-block-start
        BorderBlockStart = 9,
        /// border-block-end
        BorderBlockEnd = 10,
        /// border-inline-start
        BorderInlineStart = 11,
        /// border-inline-end
        BorderInlineEnd = 12,
        /// border
        Border = 13,
        /// border-radius
        BorderRadius = 14,
        /// border-image
        BorderImage = 15,
        /// border-block-width
        BorderBlockWidth = 16,
        /// border-block-style
        BorderBlockStyle = 17,
        /// border-block-color
        BorderBlockColor = 18,
        /// border-inline-width
        BorderInlineWidth = 19,
        /// border-inline-style
        BorderInlineStyle = 20,
        /// border-inline-color
        BorderInlineColor = 21,
        /// border-block
        BorderBlock = 22,
        /// border-inline
        BorderInline = 23,
        /// overflow
        Overflow = 24,
        /// overflow-clip-box
        OverflowClipBox = 25,
        /// transition
        Transition = 26,
        /// animation
        Animation = 27,
        /// overscroll-behavior
        OverscrollBehavior = 28,
        /// page-break-before
        PageBreakBefore = 29,
        /// page-break-after
        PageBreakAfter = 30,
        /// columns
        Columns = 31,
        /// column-rule
        ColumnRule = 32,
        /// font
        Font = 33,
        /// font-variant
        FontVariant = 34,
        /// text-emphasis
        TextEmphasis = 35,
        /// -webkit-text-stroke
        WebkitTextStroke = 36,
        /// marker
        Marker = 37,
        /// list-style
        ListStyle = 38,
        /// margin
        Margin = 39,
        /// margin-block
        MarginBlock = 40,
        /// margin-inline
        MarginInline = 41,
        /// scroll-margin
        ScrollMargin = 42,
        /// scroll-margin-block
        ScrollMarginBlock = 43,
        /// scroll-margin-inline
        ScrollMarginInline = 44,
        /// outline
        Outline = 45,
        /// -moz-outline-radius
        MozOutlineRadius = 46,
        /// padding
        Padding = 47,
        /// padding-block
        PaddingBlock = 48,
        /// padding-inline
        PaddingInline = 49,
        /// scroll-padding
        ScrollPadding = 50,
        /// scroll-padding-block
        ScrollPaddingBlock = 51,
        /// scroll-padding-inline
        ScrollPaddingInline = 52,
        /// flex-flow
        FlexFlow = 53,
        /// flex
        Flex = 54,
        /// gap
        Gap = 55,
        /// grid-row
        GridRow = 56,
        /// grid-column
        GridColumn = 57,
        /// grid-area
        GridArea = 58,
        /// grid-template
        GridTemplate = 59,
        /// grid
        Grid = 60,
        /// place-content
        PlaceContent = 61,
        /// place-self
        PlaceSelf = 62,
        /// place-items
        PlaceItems = 63,
        /// inset
        Inset = 64,
        /// inset-block
        InsetBlock = 65,
        /// inset-inline
        InsetInline = 66,
        /// text-decoration
        TextDecoration = 67,
        /// mask
        Mask = 68,
        /// mask-position
        MaskPosition = 69,
        /// all
        All = 70,
}

impl ToCss for ShorthandId {
    #[inline]
    fn to_css<W>(&self, dest: &mut CssWriter<W>) -> fmt::Result
    where
        W: Write,
    {
        dest.write_str(self.name())
    }
}

impl ShorthandId {
    /// Get the name for this shorthand property.
    #[inline]
    pub fn name(&self) -> &'static str {
        NonCustomPropertyId::from(*self).name()
    }

    /// Converts from a ShorthandId to an adequate nsCSSPropertyID.
    #[cfg(feature = "gecko")]
    #[inline]
    pub fn to_nscsspropertyid(self) -> nsCSSPropertyID {
        NonCustomPropertyId::from(self).to_nscsspropertyid()
    }

    /// Converts from a nsCSSPropertyID to a ShorthandId.
    #[cfg(feature = "gecko")]
    #[inline]
    pub fn from_nscsspropertyid(prop: nsCSSPropertyID) -> Result<Self, ()> {
        PropertyId::from_nscsspropertyid(prop)?.as_shorthand().map_err(|_| ())
    }

    /// Get the longhand ids that form this shorthand.
    pub fn longhands(&self) -> NonCustomPropertyIterator<LonghandId> {
            static BACKGROUND: &'static [LonghandId] = &[
                    LonghandId::BackgroundColor,
                    LonghandId::BackgroundPositionX,
                    LonghandId::BackgroundPositionY,
                    LonghandId::BackgroundRepeat,
                    LonghandId::BackgroundAttachment,
                    LonghandId::BackgroundImage,
                    LonghandId::BackgroundSize,
                    LonghandId::BackgroundOrigin,
                    LonghandId::BackgroundClip,
            ];
            static BACKGROUND_POSITION: &'static [LonghandId] = &[
                    LonghandId::BackgroundPositionX,
                    LonghandId::BackgroundPositionY,
            ];
            static BORDER_COLOR: &'static [LonghandId] = &[
                    LonghandId::BorderTopColor,
                    LonghandId::BorderRightColor,
                    LonghandId::BorderBottomColor,
                    LonghandId::BorderLeftColor,
            ];
            static BORDER_STYLE: &'static [LonghandId] = &[
                    LonghandId::BorderTopStyle,
                    LonghandId::BorderRightStyle,
                    LonghandId::BorderBottomStyle,
                    LonghandId::BorderLeftStyle,
            ];
            static BORDER_WIDTH: &'static [LonghandId] = &[
                    LonghandId::BorderTopWidth,
                    LonghandId::BorderRightWidth,
                    LonghandId::BorderBottomWidth,
                    LonghandId::BorderLeftWidth,
            ];
            static BORDER_TOP: &'static [LonghandId] = &[
                    LonghandId::BorderTopColor,
                    LonghandId::BorderTopStyle,
                    LonghandId::BorderTopWidth,
            ];
            static BORDER_RIGHT: &'static [LonghandId] = &[
                    LonghandId::BorderRightColor,
                    LonghandId::BorderRightStyle,
                    LonghandId::BorderRightWidth,
            ];
            static BORDER_BOTTOM: &'static [LonghandId] = &[
                    LonghandId::BorderBottomColor,
                    LonghandId::BorderBottomStyle,
                    LonghandId::BorderBottomWidth,
            ];
            static BORDER_LEFT: &'static [LonghandId] = &[
                    LonghandId::BorderLeftColor,
                    LonghandId::BorderLeftStyle,
                    LonghandId::BorderLeftWidth,
            ];
            static BORDER_BLOCK_START: &'static [LonghandId] = &[
                    LonghandId::BorderBlockStartColor,
                    LonghandId::BorderBlockStartStyle,
                    LonghandId::BorderBlockStartWidth,
            ];
            static BORDER_BLOCK_END: &'static [LonghandId] = &[
                    LonghandId::BorderBlockEndColor,
                    LonghandId::BorderBlockEndStyle,
                    LonghandId::BorderBlockEndWidth,
            ];
            static BORDER_INLINE_START: &'static [LonghandId] = &[
                    LonghandId::BorderInlineStartColor,
                    LonghandId::BorderInlineStartStyle,
                    LonghandId::BorderInlineStartWidth,
            ];
            static BORDER_INLINE_END: &'static [LonghandId] = &[
                    LonghandId::BorderInlineEndColor,
                    LonghandId::BorderInlineEndStyle,
                    LonghandId::BorderInlineEndWidth,
            ];
            static BORDER: &'static [LonghandId] = &[
                    LonghandId::BorderTopColor,
                    LonghandId::BorderTopStyle,
                    LonghandId::BorderTopWidth,
                    LonghandId::BorderRightColor,
                    LonghandId::BorderRightStyle,
                    LonghandId::BorderRightWidth,
                    LonghandId::BorderBottomColor,
                    LonghandId::BorderBottomStyle,
                    LonghandId::BorderBottomWidth,
                    LonghandId::BorderLeftColor,
                    LonghandId::BorderLeftStyle,
                    LonghandId::BorderLeftWidth,
                    LonghandId::BorderImageOutset,
                    LonghandId::BorderImageRepeat,
                    LonghandId::BorderImageSlice,
                    LonghandId::BorderImageSource,
                    LonghandId::BorderImageWidth,
            ];
            static BORDER_RADIUS: &'static [LonghandId] = &[
                    LonghandId::BorderTopLeftRadius,
                    LonghandId::BorderTopRightRadius,
                    LonghandId::BorderBottomRightRadius,
                    LonghandId::BorderBottomLeftRadius,
            ];
            static BORDER_IMAGE: &'static [LonghandId] = &[
                    LonghandId::BorderImageOutset,
                    LonghandId::BorderImageRepeat,
                    LonghandId::BorderImageSlice,
                    LonghandId::BorderImageSource,
                    LonghandId::BorderImageWidth,
            ];
            static BORDER_BLOCK_WIDTH: &'static [LonghandId] = &[
                    LonghandId::BorderBlockStartWidth,
                    LonghandId::BorderBlockEndWidth,
            ];
            static BORDER_BLOCK_STYLE: &'static [LonghandId] = &[
                    LonghandId::BorderBlockStartStyle,
                    LonghandId::BorderBlockEndStyle,
            ];
            static BORDER_BLOCK_COLOR: &'static [LonghandId] = &[
                    LonghandId::BorderBlockStartColor,
                    LonghandId::BorderBlockEndColor,
            ];
            static BORDER_INLINE_WIDTH: &'static [LonghandId] = &[
                    LonghandId::BorderInlineStartWidth,
                    LonghandId::BorderInlineEndWidth,
            ];
            static BORDER_INLINE_STYLE: &'static [LonghandId] = &[
                    LonghandId::BorderInlineStartStyle,
                    LonghandId::BorderInlineEndStyle,
            ];
            static BORDER_INLINE_COLOR: &'static [LonghandId] = &[
                    LonghandId::BorderInlineStartColor,
                    LonghandId::BorderInlineEndColor,
            ];
            static BORDER_BLOCK: &'static [LonghandId] = &[
                    LonghandId::BorderBlockStartWidth,
                    LonghandId::BorderBlockEndWidth,
                    LonghandId::BorderBlockStartStyle,
                    LonghandId::BorderBlockEndStyle,
                    LonghandId::BorderBlockStartColor,
                    LonghandId::BorderBlockEndColor,
            ];
            static BORDER_INLINE: &'static [LonghandId] = &[
                    LonghandId::BorderInlineStartWidth,
                    LonghandId::BorderInlineEndWidth,
                    LonghandId::BorderInlineStartStyle,
                    LonghandId::BorderInlineEndStyle,
                    LonghandId::BorderInlineStartColor,
                    LonghandId::BorderInlineEndColor,
            ];
            static OVERFLOW: &'static [LonghandId] = &[
                    LonghandId::OverflowX,
                    LonghandId::OverflowY,
            ];
            static OVERFLOW_CLIP_BOX: &'static [LonghandId] = &[
                    LonghandId::OverflowClipBoxBlock,
                    LonghandId::OverflowClipBoxInline,
            ];
            static TRANSITION: &'static [LonghandId] = &[
                    LonghandId::TransitionProperty,
                    LonghandId::TransitionDuration,
                    LonghandId::TransitionTimingFunction,
                    LonghandId::TransitionDelay,
            ];
            static ANIMATION: &'static [LonghandId] = &[
                    LonghandId::AnimationName,
                    LonghandId::AnimationDuration,
                    LonghandId::AnimationTimingFunction,
                    LonghandId::AnimationDelay,
                    LonghandId::AnimationIterationCount,
                    LonghandId::AnimationDirection,
                    LonghandId::AnimationFillMode,
                    LonghandId::AnimationPlayState,
            ];
            static OVERSCROLL_BEHAVIOR: &'static [LonghandId] = &[
                    LonghandId::OverscrollBehaviorX,
                    LonghandId::OverscrollBehaviorY,
            ];
            static PAGE_BREAK_BEFORE: &'static [LonghandId] = &[
                    LonghandId::BreakBefore,
            ];
            static PAGE_BREAK_AFTER: &'static [LonghandId] = &[
                    LonghandId::BreakAfter,
            ];
            static COLUMNS: &'static [LonghandId] = &[
                    LonghandId::ColumnWidth,
                    LonghandId::ColumnCount,
            ];
            static COLUMN_RULE: &'static [LonghandId] = &[
                    LonghandId::ColumnRuleWidth,
                    LonghandId::ColumnRuleStyle,
                    LonghandId::ColumnRuleColor,
            ];
            static FONT: &'static [LonghandId] = &[
                    LonghandId::FontStyle,
                    LonghandId::FontVariantCaps,
                    LonghandId::FontWeight,
                    LonghandId::FontStretch,
                    LonghandId::FontSize,
                    LonghandId::LineHeight,
                    LonghandId::FontFamily,
                    LonghandId::FontSizeAdjust,
                    LonghandId::FontKerning,
                    LonghandId::FontOpticalSizing,
                    LonghandId::FontVariantAlternates,
                    LonghandId::FontVariantEastAsian,
                    LonghandId::FontVariantLigatures,
                    LonghandId::FontVariantNumeric,
                    LonghandId::FontVariantPosition,
                    LonghandId::FontLanguageOverride,
                    LonghandId::FontFeatureSettings,
                    LonghandId::FontVariationSettings,
            ];
            static FONT_VARIANT: &'static [LonghandId] = &[
                    LonghandId::FontVariantCaps,
                    LonghandId::FontVariantAlternates,
                    LonghandId::FontVariantEastAsian,
                    LonghandId::FontVariantLigatures,
                    LonghandId::FontVariantNumeric,
                    LonghandId::FontVariantPosition,
            ];
            static TEXT_EMPHASIS: &'static [LonghandId] = &[
                    LonghandId::TextEmphasisStyle,
                    LonghandId::TextEmphasisColor,
            ];
            static _WEBKIT_TEXT_STROKE: &'static [LonghandId] = &[
                    LonghandId::WebkitTextStrokeWidth,
                    LonghandId::WebkitTextStrokeColor,
            ];
            static MARKER: &'static [LonghandId] = &[
                    LonghandId::MarkerStart,
                    LonghandId::MarkerEnd,
                    LonghandId::MarkerMid,
            ];
            static LIST_STYLE: &'static [LonghandId] = &[
                    LonghandId::ListStylePosition,
                    LonghandId::ListStyleImage,
                    LonghandId::ListStyleType,
            ];
            static MARGIN: &'static [LonghandId] = &[
                    LonghandId::MarginTop,
                    LonghandId::MarginRight,
                    LonghandId::MarginBottom,
                    LonghandId::MarginLeft,
            ];
            static MARGIN_BLOCK: &'static [LonghandId] = &[
                    LonghandId::MarginBlockStart,
                    LonghandId::MarginBlockEnd,
            ];
            static MARGIN_INLINE: &'static [LonghandId] = &[
                    LonghandId::MarginInlineStart,
                    LonghandId::MarginInlineEnd,
            ];
            static SCROLL_MARGIN: &'static [LonghandId] = &[
                    LonghandId::ScrollMarginTop,
                    LonghandId::ScrollMarginRight,
                    LonghandId::ScrollMarginBottom,
                    LonghandId::ScrollMarginLeft,
            ];
            static SCROLL_MARGIN_BLOCK: &'static [LonghandId] = &[
                    LonghandId::ScrollMarginBlockStart,
                    LonghandId::ScrollMarginBlockEnd,
            ];
            static SCROLL_MARGIN_INLINE: &'static [LonghandId] = &[
                    LonghandId::ScrollMarginInlineStart,
                    LonghandId::ScrollMarginInlineEnd,
            ];
            static OUTLINE: &'static [LonghandId] = &[
                    LonghandId::OutlineColor,
                    LonghandId::OutlineStyle,
                    LonghandId::OutlineWidth,
            ];
            static _MOZ_OUTLINE_RADIUS: &'static [LonghandId] = &[
                    LonghandId::MozOutlineRadiusTopleft,
                    LonghandId::MozOutlineRadiusTopright,
                    LonghandId::MozOutlineRadiusBottomright,
                    LonghandId::MozOutlineRadiusBottomleft,
            ];
            static PADDING: &'static [LonghandId] = &[
                    LonghandId::PaddingTop,
                    LonghandId::PaddingRight,
                    LonghandId::PaddingBottom,
                    LonghandId::PaddingLeft,
            ];
            static PADDING_BLOCK: &'static [LonghandId] = &[
                    LonghandId::PaddingBlockStart,
                    LonghandId::PaddingBlockEnd,
            ];
            static PADDING_INLINE: &'static [LonghandId] = &[
                    LonghandId::PaddingInlineStart,
                    LonghandId::PaddingInlineEnd,
            ];
            static SCROLL_PADDING: &'static [LonghandId] = &[
                    LonghandId::ScrollPaddingTop,
                    LonghandId::ScrollPaddingRight,
                    LonghandId::ScrollPaddingBottom,
                    LonghandId::ScrollPaddingLeft,
            ];
            static SCROLL_PADDING_BLOCK: &'static [LonghandId] = &[
                    LonghandId::ScrollPaddingBlockStart,
                    LonghandId::ScrollPaddingBlockEnd,
            ];
            static SCROLL_PADDING_INLINE: &'static [LonghandId] = &[
                    LonghandId::ScrollPaddingInlineStart,
                    LonghandId::ScrollPaddingInlineEnd,
            ];
            static FLEX_FLOW: &'static [LonghandId] = &[
                    LonghandId::FlexDirection,
                    LonghandId::FlexWrap,
            ];
            static FLEX: &'static [LonghandId] = &[
                    LonghandId::FlexGrow,
                    LonghandId::FlexShrink,
                    LonghandId::FlexBasis,
            ];
            static GAP: &'static [LonghandId] = &[
                    LonghandId::RowGap,
                    LonghandId::ColumnGap,
            ];
            static GRID_ROW: &'static [LonghandId] = &[
                    LonghandId::GridRowStart,
                    LonghandId::GridRowEnd,
            ];
            static GRID_COLUMN: &'static [LonghandId] = &[
                    LonghandId::GridColumnStart,
                    LonghandId::GridColumnEnd,
            ];
            static GRID_AREA: &'static [LonghandId] = &[
                    LonghandId::GridRowStart,
                    LonghandId::GridRowEnd,
                    LonghandId::GridColumnStart,
                    LonghandId::GridColumnEnd,
            ];
            static GRID_TEMPLATE: &'static [LonghandId] = &[
                    LonghandId::GridTemplateRows,
                    LonghandId::GridTemplateColumns,
                    LonghandId::GridTemplateAreas,
            ];
            static GRID: &'static [LonghandId] = &[
                    LonghandId::GridTemplateRows,
                    LonghandId::GridTemplateColumns,
                    LonghandId::GridTemplateAreas,
                    LonghandId::GridAutoRows,
                    LonghandId::GridAutoColumns,
                    LonghandId::GridAutoFlow,
            ];
            static PLACE_CONTENT: &'static [LonghandId] = &[
                    LonghandId::AlignContent,
                    LonghandId::JustifyContent,
            ];
            static PLACE_SELF: &'static [LonghandId] = &[
                    LonghandId::AlignSelf,
                    LonghandId::JustifySelf,
            ];
            static PLACE_ITEMS: &'static [LonghandId] = &[
                    LonghandId::AlignItems,
                    LonghandId::JustifyItems,
            ];
            static INSET: &'static [LonghandId] = &[
                    LonghandId::Top,
                    LonghandId::Right,
                    LonghandId::Bottom,
                    LonghandId::Left,
            ];
            static INSET_BLOCK: &'static [LonghandId] = &[
                    LonghandId::InsetBlockStart,
                    LonghandId::InsetBlockEnd,
            ];
            static INSET_INLINE: &'static [LonghandId] = &[
                    LonghandId::InsetInlineStart,
                    LonghandId::InsetInlineEnd,
            ];
            static TEXT_DECORATION: &'static [LonghandId] = &[
                    LonghandId::TextDecorationLine,
                    LonghandId::TextDecorationStyle,
                    LonghandId::TextDecorationColor,
            ];
            static MASK: &'static [LonghandId] = &[
                    LonghandId::MaskMode,
                    LonghandId::MaskRepeat,
                    LonghandId::MaskClip,
                    LonghandId::MaskOrigin,
                    LonghandId::MaskComposite,
                    LonghandId::MaskPositionX,
                    LonghandId::MaskPositionY,
                    LonghandId::MaskSize,
                    LonghandId::MaskImage,
            ];
            static MASK_POSITION: &'static [LonghandId] = &[
                    LonghandId::MaskPositionX,
                    LonghandId::MaskPositionY,
            ];
            static ALL: &'static [LonghandId] = &[
                    LonghandId::BorderBlockStartColor,
                    LonghandId::BorderBlockStartStyle,
                    LonghandId::BorderBlockStartWidth,
                    LonghandId::BorderBlockEndColor,
                    LonghandId::BorderBlockEndStyle,
                    LonghandId::BorderBlockEndWidth,
                    LonghandId::BorderInlineStartColor,
                    LonghandId::BorderInlineStartStyle,
                    LonghandId::BorderInlineStartWidth,
                    LonghandId::BorderInlineEndColor,
                    LonghandId::BorderInlineEndStyle,
                    LonghandId::BorderInlineEndWidth,
                    LonghandId::BorderStartStartRadius,
                    LonghandId::BorderStartEndRadius,
                    LonghandId::BorderEndStartRadius,
                    LonghandId::BorderEndEndRadius,
                    LonghandId::MarginBlockStart,
                    LonghandId::MarginBlockEnd,
                    LonghandId::MarginInlineStart,
                    LonghandId::MarginInlineEnd,
                    LonghandId::ScrollMarginBlockStart,
                    LonghandId::ScrollMarginBlockEnd,
                    LonghandId::ScrollMarginInlineStart,
                    LonghandId::ScrollMarginInlineEnd,
                    LonghandId::PaddingBlockStart,
                    LonghandId::PaddingBlockEnd,
                    LonghandId::PaddingInlineStart,
                    LonghandId::PaddingInlineEnd,
                    LonghandId::ScrollPaddingBlockStart,
                    LonghandId::ScrollPaddingBlockEnd,
                    LonghandId::ScrollPaddingInlineStart,
                    LonghandId::ScrollPaddingInlineEnd,
                    LonghandId::InsetBlockStart,
                    LonghandId::InsetBlockEnd,
                    LonghandId::InsetInlineStart,
                    LonghandId::InsetInlineEnd,
                    LonghandId::BlockSize,
                    LonghandId::MinBlockSize,
                    LonghandId::MaxBlockSize,
                    LonghandId::InlineSize,
                    LonghandId::MinInlineSize,
                    LonghandId::MaxInlineSize,
                    LonghandId::BackgroundColor,
                    LonghandId::BackgroundImage,
                    LonghandId::BackgroundPositionX,
                    LonghandId::BackgroundPositionY,
                    LonghandId::BackgroundRepeat,
                    LonghandId::BackgroundAttachment,
                    LonghandId::BackgroundClip,
                    LonghandId::BackgroundOrigin,
                    LonghandId::BackgroundSize,
                    LonghandId::BackgroundBlendMode,
                    LonghandId::BorderTopColor,
                    LonghandId::BorderTopStyle,
                    LonghandId::BorderTopWidth,
                    LonghandId::BorderRightColor,
                    LonghandId::BorderRightStyle,
                    LonghandId::BorderRightWidth,
                    LonghandId::BorderBottomColor,
                    LonghandId::BorderBottomStyle,
                    LonghandId::BorderBottomWidth,
                    LonghandId::BorderLeftColor,
                    LonghandId::BorderLeftStyle,
                    LonghandId::BorderLeftWidth,
                    LonghandId::BorderTopLeftRadius,
                    LonghandId::BorderTopRightRadius,
                    LonghandId::BorderBottomRightRadius,
                    LonghandId::BorderBottomLeftRadius,
                    LonghandId::BoxDecorationBreak,
                    LonghandId::MozFloatEdge,
                    LonghandId::BorderImageSource,
                    LonghandId::BorderImageOutset,
                    LonghandId::BorderImageRepeat,
                    LonghandId::BorderImageWidth,
                    LonghandId::BorderImageSlice,
                    LonghandId::Display,
                    LonghandId::Position,
                    LonghandId::Float,
                    LonghandId::Clear,
                    LonghandId::VerticalAlign,
                    LonghandId::OverflowClipBoxInline,
                    LonghandId::OverflowClipBoxBlock,
                    LonghandId::OverflowX,
                    LonghandId::OverflowY,
                    LonghandId::OverflowAnchor,
                    LonghandId::TransitionDuration,
                    LonghandId::TransitionTimingFunction,
                    LonghandId::TransitionProperty,
                    LonghandId::TransitionDelay,
                    LonghandId::AnimationName,
                    LonghandId::AnimationDuration,
                    LonghandId::AnimationTimingFunction,
                    LonghandId::AnimationIterationCount,
                    LonghandId::AnimationDirection,
                    LonghandId::AnimationPlayState,
                    LonghandId::AnimationFillMode,
                    LonghandId::AnimationDelay,
                    LonghandId::ScrollSnapPointsX,
                    LonghandId::ScrollSnapPointsY,
                    LonghandId::ScrollSnapDestination,
                    LonghandId::ScrollSnapCoordinate,
                    LonghandId::Transform,
                    LonghandId::Rotate,
                    LonghandId::Scale,
                    LonghandId::Translate,
                    LonghandId::OffsetPath,
                    LonghandId::ScrollBehavior,
                    LonghandId::ScrollSnapAlign,
                    LonghandId::ScrollSnapType,
                    LonghandId::OverscrollBehaviorX,
                    LonghandId::OverscrollBehaviorY,
                    LonghandId::Isolation,
                    LonghandId::BreakAfter,
                    LonghandId::BreakBefore,
                    LonghandId::BreakInside,
                    LonghandId::Resize,
                    LonghandId::Perspective,
                    LonghandId::PerspectiveOrigin,
                    LonghandId::BackfaceVisibility,
                    LonghandId::TransformBox,
                    LonghandId::TransformStyle,
                    LonghandId::TransformOrigin,
                    LonghandId::Contain,
                    LonghandId::MozAppearance,
                    LonghandId::MozBinding,
                    LonghandId::MozOrient,
                    LonghandId::WillChange,
                    LonghandId::ShapeImageThreshold,
                    LonghandId::ShapeMargin,
                    LonghandId::ShapeOutside,
                    LonghandId::TouchAction,
                    LonghandId::WebkitLineClamp,
                    LonghandId::Color,
                    LonghandId::ColumnWidth,
                    LonghandId::ColumnCount,
                    LonghandId::ColumnFill,
                    LonghandId::ColumnRuleWidth,
                    LonghandId::ColumnRuleColor,
                    LonghandId::ColumnSpan,
                    LonghandId::ColumnRuleStyle,
                    LonghandId::Content,
                    LonghandId::CounterIncrement,
                    LonghandId::CounterReset,
                    LonghandId::CounterSet,
                    LonghandId::Opacity,
                    LonghandId::BoxShadow,
                    LonghandId::Clip,
                    LonghandId::Filter,
                    LonghandId::MixBlendMode,
                    LonghandId::FontFamily,
                    LonghandId::FontStyle,
                    LonghandId::FontVariantCaps,
                    LonghandId::FontWeight,
                    LonghandId::FontSize,
                    LonghandId::FontSizeAdjust,
                    LonghandId::FontSynthesis,
                    LonghandId::FontStretch,
                    LonghandId::FontKerning,
                    LonghandId::FontVariantAlternates,
                    LonghandId::FontVariantEastAsian,
                    LonghandId::FontVariantLigatures,
                    LonghandId::FontVariantNumeric,
                    LonghandId::FontVariantPosition,
                    LonghandId::FontFeatureSettings,
                    LonghandId::FontVariationSettings,
                    LonghandId::FontLanguageOverride,
                    LonghandId::FontOpticalSizing,
                    LonghandId::MozOsxFontSmoothing,
                    LonghandId::Visibility,
                    LonghandId::WritingMode,
                    LonghandId::TextOrientation,
                    LonghandId::ColorAdjust,
                    LonghandId::ImageRendering,
                    LonghandId::ImageOrientation,
                    LonghandId::BorderCollapse,
                    LonghandId::EmptyCells,
                    LonghandId::CaptionSide,
                    LonghandId::BorderSpacing,
                    LonghandId::LineHeight,
                    LonghandId::TextTransform,
                    LonghandId::Hyphens,
                    LonghandId::MozTextSizeAdjust,
                    LonghandId::TextIndent,
                    LonghandId::OverflowWrap,
                    LonghandId::WordBreak,
                    LonghandId::TextJustify,
                    LonghandId::TextAlignLast,
                    LonghandId::TextAlign,
                    LonghandId::LetterSpacing,
                    LonghandId::WordSpacing,
                    LonghandId::WhiteSpace,
                    LonghandId::TextShadow,
                    LonghandId::TextEmphasisStyle,
                    LonghandId::TextEmphasisPosition,
                    LonghandId::TextEmphasisColor,
                    LonghandId::MozTabSize,
                    LonghandId::WebkitTextFillColor,
                    LonghandId::WebkitTextStrokeColor,
                    LonghandId::WebkitTextStrokeWidth,
                    LonghandId::RubyAlign,
                    LonghandId::RubyPosition,
                    LonghandId::TextCombineUpright,
                    LonghandId::TextRendering,
                    LonghandId::MozControlCharacterVisibility,
                    LonghandId::Cursor,
                    LonghandId::PointerEvents,
                    LonghandId::MozUserInput,
                    LonghandId::MozUserModify,
                    LonghandId::MozUserFocus,
                    LonghandId::CaretColor,
                    LonghandId::ScrollbarColor,
                    LonghandId::TextAnchor,
                    LonghandId::ColorInterpolation,
                    LonghandId::ColorInterpolationFilters,
                    LonghandId::Fill,
                    LonghandId::FillOpacity,
                    LonghandId::FillRule,
                    LonghandId::ShapeRendering,
                    LonghandId::Stroke,
                    LonghandId::StrokeWidth,
                    LonghandId::StrokeLinecap,
                    LonghandId::StrokeLinejoin,
                    LonghandId::StrokeMiterlimit,
                    LonghandId::StrokeOpacity,
                    LonghandId::StrokeDasharray,
                    LonghandId::StrokeDashoffset,
                    LonghandId::ClipRule,
                    LonghandId::MarkerStart,
                    LonghandId::MarkerMid,
                    LonghandId::MarkerEnd,
                    LonghandId::PaintOrder,
                    LonghandId::MozContextProperties,
                    LonghandId::ListStylePosition,
                    LonghandId::ListStyleType,
                    LonghandId::ListStyleImage,
                    LonghandId::Quotes,
                    LonghandId::MozImageRegion,
                    LonghandId::MarginTop,
                    LonghandId::MarginRight,
                    LonghandId::MarginBottom,
                    LonghandId::MarginLeft,
                    LonghandId::ScrollMarginTop,
                    LonghandId::ScrollMarginRight,
                    LonghandId::ScrollMarginBottom,
                    LonghandId::ScrollMarginLeft,
                    LonghandId::OutlineColor,
                    LonghandId::OutlineStyle,
                    LonghandId::OutlineWidth,
                    LonghandId::MozOutlineRadiusTopleft,
                    LonghandId::MozOutlineRadiusTopright,
                    LonghandId::MozOutlineRadiusBottomright,
                    LonghandId::MozOutlineRadiusBottomleft,
                    LonghandId::OutlineOffset,
                    LonghandId::PaddingTop,
                    LonghandId::PaddingRight,
                    LonghandId::PaddingBottom,
                    LonghandId::PaddingLeft,
                    LonghandId::ScrollPaddingTop,
                    LonghandId::ScrollPaddingRight,
                    LonghandId::ScrollPaddingBottom,
                    LonghandId::ScrollPaddingLeft,
                    LonghandId::Top,
                    LonghandId::Right,
                    LonghandId::Bottom,
                    LonghandId::Left,
                    LonghandId::ZIndex,
                    LonghandId::FlexDirection,
                    LonghandId::FlexWrap,
                    LonghandId::JustifyContent,
                    LonghandId::AlignContent,
                    LonghandId::AlignItems,
                    LonghandId::JustifyItems,
                    LonghandId::FlexGrow,
                    LonghandId::FlexShrink,
                    LonghandId::AlignSelf,
                    LonghandId::JustifySelf,
                    LonghandId::Order,
                    LonghandId::FlexBasis,
                    LonghandId::Width,
                    LonghandId::MinWidth,
                    LonghandId::MaxWidth,
                    LonghandId::Height,
                    LonghandId::MinHeight,
                    LonghandId::MaxHeight,
                    LonghandId::BoxSizing,
                    LonghandId::ObjectFit,
                    LonghandId::ObjectPosition,
                    LonghandId::GridRowStart,
                    LonghandId::GridRowEnd,
                    LonghandId::GridAutoRows,
                    LonghandId::GridTemplateRows,
                    LonghandId::GridColumnStart,
                    LonghandId::GridColumnEnd,
                    LonghandId::GridAutoColumns,
                    LonghandId::GridTemplateColumns,
                    LonghandId::GridAutoFlow,
                    LonghandId::GridTemplateAreas,
                    LonghandId::ColumnGap,
                    LonghandId::RowGap,
                    LonghandId::TableLayout,
                    LonghandId::TextOverflow,
                    LonghandId::TextDecorationLine,
                    LonghandId::TextDecorationStyle,
                    LonghandId::TextDecorationColor,
                    LonghandId::InitialLetter,
                    LonghandId::ImeMode,
                    LonghandId::ScrollbarWidth,
                    LonghandId::MozUserSelect,
                    LonghandId::MozWindowDragging,
                    LonghandId::MozForceBrokenImageIcon,
                    LonghandId::DominantBaseline,
                    LonghandId::VectorEffect,
                    LonghandId::StopColor,
                    LonghandId::StopOpacity,
                    LonghandId::FloodColor,
                    LonghandId::FloodOpacity,
                    LonghandId::LightingColor,
                    LonghandId::MaskType,
                    LonghandId::ClipPath,
                    LonghandId::MaskMode,
                    LonghandId::MaskRepeat,
                    LonghandId::MaskPositionX,
                    LonghandId::MaskPositionY,
                    LonghandId::MaskClip,
                    LonghandId::MaskOrigin,
                    LonghandId::MaskSize,
                    LonghandId::MaskComposite,
                    LonghandId::MaskImage,
                    LonghandId::MozBoxAlign,
                    LonghandId::MozBoxDirection,
                    LonghandId::MozBoxFlex,
                    LonghandId::MozBoxOrient,
                    LonghandId::MozBoxPack,
                    LonghandId::MozStackSizing,
                    LonghandId::MozBoxOrdinalGroup,
            ];
        NonCustomPropertyIterator {
            filter: NonCustomPropertyId::from(*self).enabled_for_all_content(),
            iter: match *self {
                    ShorthandId::Background => BACKGROUND,
                    ShorthandId::BackgroundPosition => BACKGROUND_POSITION,
                    ShorthandId::BorderColor => BORDER_COLOR,
                    ShorthandId::BorderStyle => BORDER_STYLE,
                    ShorthandId::BorderWidth => BORDER_WIDTH,
                    ShorthandId::BorderTop => BORDER_TOP,
                    ShorthandId::BorderRight => BORDER_RIGHT,
                    ShorthandId::BorderBottom => BORDER_BOTTOM,
                    ShorthandId::BorderLeft => BORDER_LEFT,
                    ShorthandId::BorderBlockStart => BORDER_BLOCK_START,
                    ShorthandId::BorderBlockEnd => BORDER_BLOCK_END,
                    ShorthandId::BorderInlineStart => BORDER_INLINE_START,
                    ShorthandId::BorderInlineEnd => BORDER_INLINE_END,
                    ShorthandId::Border => BORDER,
                    ShorthandId::BorderRadius => BORDER_RADIUS,
                    ShorthandId::BorderImage => BORDER_IMAGE,
                    ShorthandId::BorderBlockWidth => BORDER_BLOCK_WIDTH,
                    ShorthandId::BorderBlockStyle => BORDER_BLOCK_STYLE,
                    ShorthandId::BorderBlockColor => BORDER_BLOCK_COLOR,
                    ShorthandId::BorderInlineWidth => BORDER_INLINE_WIDTH,
                    ShorthandId::BorderInlineStyle => BORDER_INLINE_STYLE,
                    ShorthandId::BorderInlineColor => BORDER_INLINE_COLOR,
                    ShorthandId::BorderBlock => BORDER_BLOCK,
                    ShorthandId::BorderInline => BORDER_INLINE,
                    ShorthandId::Overflow => OVERFLOW,
                    ShorthandId::OverflowClipBox => OVERFLOW_CLIP_BOX,
                    ShorthandId::Transition => TRANSITION,
                    ShorthandId::Animation => ANIMATION,
                    ShorthandId::OverscrollBehavior => OVERSCROLL_BEHAVIOR,
                    ShorthandId::PageBreakBefore => PAGE_BREAK_BEFORE,
                    ShorthandId::PageBreakAfter => PAGE_BREAK_AFTER,
                    ShorthandId::Columns => COLUMNS,
                    ShorthandId::ColumnRule => COLUMN_RULE,
                    ShorthandId::Font => FONT,
                    ShorthandId::FontVariant => FONT_VARIANT,
                    ShorthandId::TextEmphasis => TEXT_EMPHASIS,
                    ShorthandId::WebkitTextStroke => _WEBKIT_TEXT_STROKE,
                    ShorthandId::Marker => MARKER,
                    ShorthandId::ListStyle => LIST_STYLE,
                    ShorthandId::Margin => MARGIN,
                    ShorthandId::MarginBlock => MARGIN_BLOCK,
                    ShorthandId::MarginInline => MARGIN_INLINE,
                    ShorthandId::ScrollMargin => SCROLL_MARGIN,
                    ShorthandId::ScrollMarginBlock => SCROLL_MARGIN_BLOCK,
                    ShorthandId::ScrollMarginInline => SCROLL_MARGIN_INLINE,
                    ShorthandId::Outline => OUTLINE,
                    ShorthandId::MozOutlineRadius => _MOZ_OUTLINE_RADIUS,
                    ShorthandId::Padding => PADDING,
                    ShorthandId::PaddingBlock => PADDING_BLOCK,
                    ShorthandId::PaddingInline => PADDING_INLINE,
                    ShorthandId::ScrollPadding => SCROLL_PADDING,
                    ShorthandId::ScrollPaddingBlock => SCROLL_PADDING_BLOCK,
                    ShorthandId::ScrollPaddingInline => SCROLL_PADDING_INLINE,
                    ShorthandId::FlexFlow => FLEX_FLOW,
                    ShorthandId::Flex => FLEX,
                    ShorthandId::Gap => GAP,
                    ShorthandId::GridRow => GRID_ROW,
                    ShorthandId::GridColumn => GRID_COLUMN,
                    ShorthandId::GridArea => GRID_AREA,
                    ShorthandId::GridTemplate => GRID_TEMPLATE,
                    ShorthandId::Grid => GRID,
                    ShorthandId::PlaceContent => PLACE_CONTENT,
                    ShorthandId::PlaceSelf => PLACE_SELF,
                    ShorthandId::PlaceItems => PLACE_ITEMS,
                    ShorthandId::Inset => INSET,
                    ShorthandId::InsetBlock => INSET_BLOCK,
                    ShorthandId::InsetInline => INSET_INLINE,
                    ShorthandId::TextDecoration => TEXT_DECORATION,
                    ShorthandId::Mask => MASK,
                    ShorthandId::MaskPosition => MASK_POSITION,
                    ShorthandId::All => ALL,
            }.iter()
        }
    }

    /// Try to serialize the given declarations as this shorthand.
    ///
    /// Returns an error if writing to the stream fails, or if the declarations
    /// do not map to a shorthand.
    pub fn longhands_to_css<'a, W, I>(
        &self,
        declarations: I,
        dest: &mut CssWriter<W>,
    ) -> fmt::Result
    where
        W: Write,
        I: Iterator<Item=&'a PropertyDeclaration>,
    {
        match *self {
            ShorthandId::All => {
                // No need to try to serialize the declarations as the 'all'
                // shorthand, since it only accepts CSS-wide keywords (and
                // variable references), which will be handled in
                // get_shorthand_appendable_value.
                Err(fmt::Error)
            }
                ShorthandId::Background => {
                    match shorthands::background::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BackgroundPosition => {
                    match shorthands::background_position::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderColor => {
                    match shorthands::border_color::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderStyle => {
                    match shorthands::border_style::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderWidth => {
                    match shorthands::border_width::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderTop => {
                    match shorthands::border_top::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderRight => {
                    match shorthands::border_right::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderBottom => {
                    match shorthands::border_bottom::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderLeft => {
                    match shorthands::border_left::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderBlockStart => {
                    match shorthands::border_block_start::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderBlockEnd => {
                    match shorthands::border_block_end::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderInlineStart => {
                    match shorthands::border_inline_start::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderInlineEnd => {
                    match shorthands::border_inline_end::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::Border => {
                    match shorthands::border::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderRadius => {
                    match shorthands::border_radius::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderImage => {
                    match shorthands::border_image::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderBlockWidth => {
                    match shorthands::border_block_width::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderBlockStyle => {
                    match shorthands::border_block_style::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderBlockColor => {
                    match shorthands::border_block_color::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderInlineWidth => {
                    match shorthands::border_inline_width::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderInlineStyle => {
                    match shorthands::border_inline_style::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderInlineColor => {
                    match shorthands::border_inline_color::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderBlock => {
                    match shorthands::border_block::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::BorderInline => {
                    match shorthands::border_inline::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::Overflow => {
                    match shorthands::overflow::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::OverflowClipBox => {
                    match shorthands::overflow_clip_box::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::Transition => {
                    match shorthands::transition::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::Animation => {
                    match shorthands::animation::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::OverscrollBehavior => {
                    match shorthands::overscroll_behavior::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::PageBreakBefore => {
                    match shorthands::page_break_before::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::PageBreakAfter => {
                    match shorthands::page_break_after::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::Columns => {
                    match shorthands::columns::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::ColumnRule => {
                    match shorthands::column_rule::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::Font => {
                    match shorthands::font::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::FontVariant => {
                    match shorthands::font_variant::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::TextEmphasis => {
                    match shorthands::text_emphasis::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::WebkitTextStroke => {
                    match shorthands::_webkit_text_stroke::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::Marker => {
                    match shorthands::marker::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::ListStyle => {
                    match shorthands::list_style::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::Margin => {
                    match shorthands::margin::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::MarginBlock => {
                    match shorthands::margin_block::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::MarginInline => {
                    match shorthands::margin_inline::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::ScrollMargin => {
                    match shorthands::scroll_margin::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::ScrollMarginBlock => {
                    match shorthands::scroll_margin_block::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::ScrollMarginInline => {
                    match shorthands::scroll_margin_inline::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::Outline => {
                    match shorthands::outline::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::MozOutlineRadius => {
                    match shorthands::_moz_outline_radius::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::Padding => {
                    match shorthands::padding::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::PaddingBlock => {
                    match shorthands::padding_block::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::PaddingInline => {
                    match shorthands::padding_inline::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::ScrollPadding => {
                    match shorthands::scroll_padding::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::ScrollPaddingBlock => {
                    match shorthands::scroll_padding_block::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::ScrollPaddingInline => {
                    match shorthands::scroll_padding_inline::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::FlexFlow => {
                    match shorthands::flex_flow::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::Flex => {
                    match shorthands::flex::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::Gap => {
                    match shorthands::gap::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::GridRow => {
                    match shorthands::grid_row::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::GridColumn => {
                    match shorthands::grid_column::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::GridArea => {
                    match shorthands::grid_area::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::GridTemplate => {
                    match shorthands::grid_template::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::Grid => {
                    match shorthands::grid::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::PlaceContent => {
                    match shorthands::place_content::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::PlaceSelf => {
                    match shorthands::place_self::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::PlaceItems => {
                    match shorthands::place_items::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::Inset => {
                    match shorthands::inset::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::InsetBlock => {
                    match shorthands::inset_block::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::InsetInline => {
                    match shorthands::inset_inline::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::TextDecoration => {
                    match shorthands::text_decoration::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::Mask => {
                    match shorthands::mask::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
                ShorthandId::MaskPosition => {
                    match shorthands::mask_position::LonghandsToSerialize::from_iter(declarations) {
                        Ok(longhands) => longhands.to_css(dest),
                        Err(_) => Err(fmt::Error)
                    }
                },
        }
    }

    /// Finds and returns an appendable value for the given declarations.
    ///
    /// Returns the optional appendable value.
    pub fn get_shorthand_appendable_value<'a, I>(
        self,
        declarations: I,
    ) -> Option<AppendableValue<'a, I::IntoIter>>
    where
        I: IntoIterator<Item=&'a PropertyDeclaration>,
        I::IntoIter: Clone,
    {
        let declarations = declarations.into_iter();

        // Only cloning iterators (a few pointers each) not declarations.
        let mut declarations2 = declarations.clone();
        let mut declarations3 = declarations.clone();

        let first_declaration = declarations2.next()?;

        // https://drafts.csswg.org/css-variables/#variables-in-shorthands
        if let Some(css) = first_declaration.with_variables_from_shorthand(self) {
            if declarations2.all(|d| d.with_variables_from_shorthand(self) == Some(css)) {
               return Some(AppendableValue::Css {
                   css: CssStringBorrow::from(css),
                   with_variables: true,
               });
            }
            return None;
        }

        // Check whether they are all the same CSS-wide keyword.
        if let Some(keyword) = first_declaration.get_css_wide_keyword() {
            if declarations2.all(|d| d.get_css_wide_keyword() == Some(keyword)) {
                return Some(AppendableValue::Css {
                    css: CssStringBorrow::from(keyword.to_str()),
                    with_variables: false,
                });
            }
            return None;
        }

        // Check whether all declarations can be serialized as part of shorthand.
        if declarations3.all(|d| d.may_serialize_as_part_of_shorthand()) {
            return Some(AppendableValue::DeclarationsForShorthand(self, declarations));
        }

        None
    }

    /// Returns PropertyFlags for the given shorthand property.
    #[inline]
    pub fn flags(self) -> PropertyFlags {
        const FLAGS: [u8; 71] = [
                0,
                    PropertyFlags::SHORTHAND_IN_GETCS.bits |
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::SHORTHAND_IN_GETCS.bits |
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::SHORTHAND_IN_GETCS.bits |
                    PropertyFlags::IS_LEGACY_SHORTHAND.bits |
                0,
                    PropertyFlags::SHORTHAND_IN_GETCS.bits |
                    PropertyFlags::IS_LEGACY_SHORTHAND.bits |
                0,
                0,
                0,
                0,
                    PropertyFlags::SHORTHAND_IN_GETCS.bits |
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                    PropertyFlags::SHORTHAND_IN_GETCS.bits |
                0,
                    PropertyFlags::SHORTHAND_IN_GETCS.bits |
                0,
                    PropertyFlags::SHORTHAND_IN_GETCS.bits |
                0,
                0,
        ];
        PropertyFlags::from_bits_truncate(FLAGS[self as usize])
    }

    /// Returns whether this property is a legacy shorthand.
    #[inline]
    pub fn is_legacy_shorthand(self) -> bool {
        self.flags().contains(PropertyFlags::IS_LEGACY_SHORTHAND)
    }

    /// Returns the order in which this property appears relative to other
    /// shorthands in idl-name-sorting order.
    #[inline]
    pub fn idl_name_sort_order(self) -> u32 {
        
        static IDL_NAME_SORT_ORDER: [u32; 71] = [
            4,
            5,
            14,
            25,
            27,
            26,
            24,
            13,
            22,
            10,
            9,
            19,
            18,
            6,
            23,
            15,
            12,
            11,
            8,
            21,
            20,
            17,
            7,
            16,
            51,
            52,
            70,
            3,
            53,
            58,
            57,
            29,
            28,
            32,
            33,
            69,
            1,
            47,
            43,
            44,
            45,
            46,
            62,
            63,
            64,
            50,
            0,
            54,
            55,
            56,
            65,
            66,
            67,
            31,
            30,
            34,
            38,
            37,
            36,
            39,
            35,
            59,
            61,
            60,
            40,
            41,
            42,
            68,
            48,
            49,
            2,
        ];
        IDL_NAME_SORT_ORDER[self as usize]
    }

    fn parse_into<'i, 't>(
        &self,
        declarations: &mut SourcePropertyDeclaration,
        context: &ParserContext,
        input: &mut Parser<'i, 't>,
    ) -> Result<(), ParseError<'i>> {
        match *self {
                ShorthandId::Background => {
                    shorthands::background::parse_into(declarations, context, input)
                }
                ShorthandId::BackgroundPosition => {
                    shorthands::background_position::parse_into(declarations, context, input)
                }
                ShorthandId::BorderColor => {
                    shorthands::border_color::parse_into(declarations, context, input)
                }
                ShorthandId::BorderStyle => {
                    shorthands::border_style::parse_into(declarations, context, input)
                }
                ShorthandId::BorderWidth => {
                    shorthands::border_width::parse_into(declarations, context, input)
                }
                ShorthandId::BorderTop => {
                    shorthands::border_top::parse_into(declarations, context, input)
                }
                ShorthandId::BorderRight => {
                    shorthands::border_right::parse_into(declarations, context, input)
                }
                ShorthandId::BorderBottom => {
                    shorthands::border_bottom::parse_into(declarations, context, input)
                }
                ShorthandId::BorderLeft => {
                    shorthands::border_left::parse_into(declarations, context, input)
                }
                ShorthandId::BorderBlockStart => {
                    shorthands::border_block_start::parse_into(declarations, context, input)
                }
                ShorthandId::BorderBlockEnd => {
                    shorthands::border_block_end::parse_into(declarations, context, input)
                }
                ShorthandId::BorderInlineStart => {
                    shorthands::border_inline_start::parse_into(declarations, context, input)
                }
                ShorthandId::BorderInlineEnd => {
                    shorthands::border_inline_end::parse_into(declarations, context, input)
                }
                ShorthandId::Border => {
                    shorthands::border::parse_into(declarations, context, input)
                }
                ShorthandId::BorderRadius => {
                    shorthands::border_radius::parse_into(declarations, context, input)
                }
                ShorthandId::BorderImage => {
                    shorthands::border_image::parse_into(declarations, context, input)
                }
                ShorthandId::BorderBlockWidth => {
                    shorthands::border_block_width::parse_into(declarations, context, input)
                }
                ShorthandId::BorderBlockStyle => {
                    shorthands::border_block_style::parse_into(declarations, context, input)
                }
                ShorthandId::BorderBlockColor => {
                    shorthands::border_block_color::parse_into(declarations, context, input)
                }
                ShorthandId::BorderInlineWidth => {
                    shorthands::border_inline_width::parse_into(declarations, context, input)
                }
                ShorthandId::BorderInlineStyle => {
                    shorthands::border_inline_style::parse_into(declarations, context, input)
                }
                ShorthandId::BorderInlineColor => {
                    shorthands::border_inline_color::parse_into(declarations, context, input)
                }
                ShorthandId::BorderBlock => {
                    shorthands::border_block::parse_into(declarations, context, input)
                }
                ShorthandId::BorderInline => {
                    shorthands::border_inline::parse_into(declarations, context, input)
                }
                ShorthandId::Overflow => {
                    shorthands::overflow::parse_into(declarations, context, input)
                }
                ShorthandId::OverflowClipBox => {
                    shorthands::overflow_clip_box::parse_into(declarations, context, input)
                }
                ShorthandId::Transition => {
                    shorthands::transition::parse_into(declarations, context, input)
                }
                ShorthandId::Animation => {
                    shorthands::animation::parse_into(declarations, context, input)
                }
                ShorthandId::OverscrollBehavior => {
                    shorthands::overscroll_behavior::parse_into(declarations, context, input)
                }
                ShorthandId::PageBreakBefore => {
                    shorthands::page_break_before::parse_into(declarations, context, input)
                }
                ShorthandId::PageBreakAfter => {
                    shorthands::page_break_after::parse_into(declarations, context, input)
                }
                ShorthandId::Columns => {
                    shorthands::columns::parse_into(declarations, context, input)
                }
                ShorthandId::ColumnRule => {
                    shorthands::column_rule::parse_into(declarations, context, input)
                }
                ShorthandId::Font => {
                    shorthands::font::parse_into(declarations, context, input)
                }
                ShorthandId::FontVariant => {
                    shorthands::font_variant::parse_into(declarations, context, input)
                }
                ShorthandId::TextEmphasis => {
                    shorthands::text_emphasis::parse_into(declarations, context, input)
                }
                ShorthandId::WebkitTextStroke => {
                    shorthands::_webkit_text_stroke::parse_into(declarations, context, input)
                }
                ShorthandId::Marker => {
                    shorthands::marker::parse_into(declarations, context, input)
                }
                ShorthandId::ListStyle => {
                    shorthands::list_style::parse_into(declarations, context, input)
                }
                ShorthandId::Margin => {
                    shorthands::margin::parse_into(declarations, context, input)
                }
                ShorthandId::MarginBlock => {
                    shorthands::margin_block::parse_into(declarations, context, input)
                }
                ShorthandId::MarginInline => {
                    shorthands::margin_inline::parse_into(declarations, context, input)
                }
                ShorthandId::ScrollMargin => {
                    shorthands::scroll_margin::parse_into(declarations, context, input)
                }
                ShorthandId::ScrollMarginBlock => {
                    shorthands::scroll_margin_block::parse_into(declarations, context, input)
                }
                ShorthandId::ScrollMarginInline => {
                    shorthands::scroll_margin_inline::parse_into(declarations, context, input)
                }
                ShorthandId::Outline => {
                    shorthands::outline::parse_into(declarations, context, input)
                }
                ShorthandId::MozOutlineRadius => {
                    shorthands::_moz_outline_radius::parse_into(declarations, context, input)
                }
                ShorthandId::Padding => {
                    shorthands::padding::parse_into(declarations, context, input)
                }
                ShorthandId::PaddingBlock => {
                    shorthands::padding_block::parse_into(declarations, context, input)
                }
                ShorthandId::PaddingInline => {
                    shorthands::padding_inline::parse_into(declarations, context, input)
                }
                ShorthandId::ScrollPadding => {
                    shorthands::scroll_padding::parse_into(declarations, context, input)
                }
                ShorthandId::ScrollPaddingBlock => {
                    shorthands::scroll_padding_block::parse_into(declarations, context, input)
                }
                ShorthandId::ScrollPaddingInline => {
                    shorthands::scroll_padding_inline::parse_into(declarations, context, input)
                }
                ShorthandId::FlexFlow => {
                    shorthands::flex_flow::parse_into(declarations, context, input)
                }
                ShorthandId::Flex => {
                    shorthands::flex::parse_into(declarations, context, input)
                }
                ShorthandId::Gap => {
                    shorthands::gap::parse_into(declarations, context, input)
                }
                ShorthandId::GridRow => {
                    shorthands::grid_row::parse_into(declarations, context, input)
                }
                ShorthandId::GridColumn => {
                    shorthands::grid_column::parse_into(declarations, context, input)
                }
                ShorthandId::GridArea => {
                    shorthands::grid_area::parse_into(declarations, context, input)
                }
                ShorthandId::GridTemplate => {
                    shorthands::grid_template::parse_into(declarations, context, input)
                }
                ShorthandId::Grid => {
                    shorthands::grid::parse_into(declarations, context, input)
                }
                ShorthandId::PlaceContent => {
                    shorthands::place_content::parse_into(declarations, context, input)
                }
                ShorthandId::PlaceSelf => {
                    shorthands::place_self::parse_into(declarations, context, input)
                }
                ShorthandId::PlaceItems => {
                    shorthands::place_items::parse_into(declarations, context, input)
                }
                ShorthandId::Inset => {
                    shorthands::inset::parse_into(declarations, context, input)
                }
                ShorthandId::InsetBlock => {
                    shorthands::inset_block::parse_into(declarations, context, input)
                }
                ShorthandId::InsetInline => {
                    shorthands::inset_inline::parse_into(declarations, context, input)
                }
                ShorthandId::TextDecoration => {
                    shorthands::text_decoration::parse_into(declarations, context, input)
                }
                ShorthandId::Mask => {
                    shorthands::mask::parse_into(declarations, context, input)
                }
                ShorthandId::MaskPosition => {
                    shorthands::mask_position::parse_into(declarations, context, input)
                }
            // 'all' accepts no value other than CSS-wide keywords
            ShorthandId::All => Err(input.new_custom_error(StyleParseErrorKind::UnspecifiedError))
        }
    }
}

/// An unparsed property value that contains `var()` functions.
#[derive(Debug, Eq, PartialEq, ToShmem)]
pub struct UnparsedValue {
    /// The css serialization for this value.
    css: String,
    /// The first token type for this serialization.
    first_token_type: TokenSerializationType,
    /// The url data for resolving url values.
    url_data: UrlExtraData,
    /// The shorthand this came from.
    from_shorthand: Option<ShorthandId>,
}

impl ToCss for UnparsedValue {
    fn to_css<W>(&self, dest: &mut CssWriter<W>) -> fmt::Result
    where
        W: Write,
    {
        // https://drafts.csswg.org/css-variables/#variables-in-shorthands
        if self.from_shorthand.is_none() {
            dest.write_str(&*self.css)?;
        }
        Ok(())
    }
}

impl UnparsedValue {
    fn substitute_variables(
        &self,
        longhand_id: LonghandId,
        custom_properties: Option<&Arc<crate::custom_properties::CustomPropertiesMap>>,
        quirks_mode: QuirksMode,
        environment: &::custom_properties::CssEnvironment,
    ) -> PropertyDeclaration {
        let invalid_at_computed_value_time = || {
            let keyword = if longhand_id.inherited() {
                CSSWideKeyword::Inherit
            } else {
                CSSWideKeyword::Initial
            };
            PropertyDeclaration::CSSWideKeyword(WideKeywordDeclaration {
                id: longhand_id,
                keyword,
            })
        };

        let css = match crate::custom_properties::substitute(
            &self.css,
            self.first_token_type,
            custom_properties,
            environment,
        ) {
            Ok(css) => css,
            Err(..) => return invalid_at_computed_value_time(),
        };

        // As of this writing, only the base URL is used for property
        // values.
        //
        // NOTE(emilio): we intentionally pase `None` as the rule type here.
        // If something starts depending on it, it's probably a bug, since
        // it'd change how values are parsed depending on whether we're in a
        // @keyframes rule or not, for example... So think twice about
        // whether you want to do this!
        //
        // FIXME(emilio): ParsingMode is slightly fishy...
        let context = ParserContext::new(
            Origin::Author,
            &self.url_data,
            None,
            ParsingMode::DEFAULT,
            quirks_mode,
            None,
            None,
        );

        let mut input = ParserInput::new(&css);
        let mut input = Parser::new(&mut input);
        input.skip_whitespace();  // Unnecessary for correctness, but may help try() rewind less.
        if let Ok(keyword) = input.try(CSSWideKeyword::parse) {
            return PropertyDeclaration::CSSWideKeyword(WideKeywordDeclaration {
                id: longhand_id,
                keyword,
            });
        }

        let declaration = input.parse_entirely(|input| {
            match self.from_shorthand {
                None => longhand_id.parse_value(&context, input),
                Some(ShorthandId::All) => {
                    // No need to parse the 'all' shorthand as anything other
                    // than a CSS-wide keyword, after variable substitution.
                    Err(input.new_custom_error(SelectorParseErrorKind::UnexpectedIdent("all".into())))
                }
                Some(ShorthandId::Background) => {
                    shorthands::background::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BackgroundColor => {
                                PropertyDeclaration::BackgroundColor(
                                    longhands.background_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BackgroundPositionX => {
                                PropertyDeclaration::BackgroundPositionX(
                                    longhands.background_position_x
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BackgroundPositionY => {
                                PropertyDeclaration::BackgroundPositionY(
                                    longhands.background_position_y
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BackgroundRepeat => {
                                PropertyDeclaration::BackgroundRepeat(
                                    longhands.background_repeat
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BackgroundAttachment => {
                                PropertyDeclaration::BackgroundAttachment(
                                    longhands.background_attachment
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BackgroundImage => {
                                PropertyDeclaration::BackgroundImage(
                                    longhands.background_image
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BackgroundSize => {
                                PropertyDeclaration::BackgroundSize(
                                    longhands.background_size
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BackgroundOrigin => {
                                PropertyDeclaration::BackgroundOrigin(
                                    longhands.background_origin
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BackgroundClip => {
                                PropertyDeclaration::BackgroundClip(
                                    longhands.background_clip
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BackgroundPosition) => {
                    shorthands::background_position::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BackgroundPositionX => {
                                PropertyDeclaration::BackgroundPositionX(
                                    longhands.background_position_x
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BackgroundPositionY => {
                                PropertyDeclaration::BackgroundPositionY(
                                    longhands.background_position_y
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderColor) => {
                    shorthands::border_color::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderTopColor => {
                                PropertyDeclaration::BorderTopColor(
                                    longhands.border_top_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderRightColor => {
                                PropertyDeclaration::BorderRightColor(
                                    longhands.border_right_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBottomColor => {
                                PropertyDeclaration::BorderBottomColor(
                                    longhands.border_bottom_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderLeftColor => {
                                PropertyDeclaration::BorderLeftColor(
                                    longhands.border_left_color
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderStyle) => {
                    shorthands::border_style::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderTopStyle => {
                                PropertyDeclaration::BorderTopStyle(
                                    longhands.border_top_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderRightStyle => {
                                PropertyDeclaration::BorderRightStyle(
                                    longhands.border_right_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBottomStyle => {
                                PropertyDeclaration::BorderBottomStyle(
                                    longhands.border_bottom_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderLeftStyle => {
                                PropertyDeclaration::BorderLeftStyle(
                                    longhands.border_left_style
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderWidth) => {
                    shorthands::border_width::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderTopWidth => {
                                PropertyDeclaration::BorderTopWidth(
                                    longhands.border_top_width
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderRightWidth => {
                                PropertyDeclaration::BorderRightWidth(
                                    longhands.border_right_width
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBottomWidth => {
                                PropertyDeclaration::BorderBottomWidth(
                                    longhands.border_bottom_width
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderLeftWidth => {
                                PropertyDeclaration::BorderLeftWidth(
                                    longhands.border_left_width
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderTop) => {
                    shorthands::border_top::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderTopColor => {
                                PropertyDeclaration::BorderTopColor(
                                    longhands.border_top_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderTopStyle => {
                                PropertyDeclaration::BorderTopStyle(
                                    longhands.border_top_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderTopWidth => {
                                PropertyDeclaration::BorderTopWidth(
                                    longhands.border_top_width
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderRight) => {
                    shorthands::border_right::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderRightColor => {
                                PropertyDeclaration::BorderRightColor(
                                    longhands.border_right_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderRightStyle => {
                                PropertyDeclaration::BorderRightStyle(
                                    longhands.border_right_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderRightWidth => {
                                PropertyDeclaration::BorderRightWidth(
                                    longhands.border_right_width
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderBottom) => {
                    shorthands::border_bottom::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBottomColor => {
                                PropertyDeclaration::BorderBottomColor(
                                    longhands.border_bottom_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBottomStyle => {
                                PropertyDeclaration::BorderBottomStyle(
                                    longhands.border_bottom_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBottomWidth => {
                                PropertyDeclaration::BorderBottomWidth(
                                    longhands.border_bottom_width
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderLeft) => {
                    shorthands::border_left::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderLeftColor => {
                                PropertyDeclaration::BorderLeftColor(
                                    longhands.border_left_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderLeftStyle => {
                                PropertyDeclaration::BorderLeftStyle(
                                    longhands.border_left_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderLeftWidth => {
                                PropertyDeclaration::BorderLeftWidth(
                                    longhands.border_left_width
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderBlockStart) => {
                    shorthands::border_block_start::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBlockStartColor => {
                                PropertyDeclaration::BorderBlockStartColor(
                                    longhands.border_block_start_color
                                )
                            }
                            
                            LonghandId::BorderTopColor => {
                                PropertyDeclaration::BorderTopColor(
                                    longhands.border_block_start_color
                                )
                            }
                            
                            LonghandId::BorderRightColor => {
                                PropertyDeclaration::BorderRightColor(
                                    longhands.border_block_start_color
                                )
                            }
                            
                            LonghandId::BorderBottomColor => {
                                PropertyDeclaration::BorderBottomColor(
                                    longhands.border_block_start_color
                                )
                            }
                            
                            LonghandId::BorderLeftColor => {
                                PropertyDeclaration::BorderLeftColor(
                                    longhands.border_block_start_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBlockStartStyle => {
                                PropertyDeclaration::BorderBlockStartStyle(
                                    longhands.border_block_start_style
                                )
                            }
                            
                            LonghandId::BorderTopStyle => {
                                PropertyDeclaration::BorderTopStyle(
                                    longhands.border_block_start_style
                                )
                            }
                            
                            LonghandId::BorderRightStyle => {
                                PropertyDeclaration::BorderRightStyle(
                                    longhands.border_block_start_style
                                )
                            }
                            
                            LonghandId::BorderBottomStyle => {
                                PropertyDeclaration::BorderBottomStyle(
                                    longhands.border_block_start_style
                                )
                            }
                            
                            LonghandId::BorderLeftStyle => {
                                PropertyDeclaration::BorderLeftStyle(
                                    longhands.border_block_start_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBlockStartWidth => {
                                PropertyDeclaration::BorderBlockStartWidth(
                                    longhands.border_block_start_width
                                )
                            }
                            
                            LonghandId::BorderTopWidth => {
                                PropertyDeclaration::BorderTopWidth(
                                    longhands.border_block_start_width
                                )
                            }
                            
                            LonghandId::BorderRightWidth => {
                                PropertyDeclaration::BorderRightWidth(
                                    longhands.border_block_start_width
                                )
                            }
                            
                            LonghandId::BorderBottomWidth => {
                                PropertyDeclaration::BorderBottomWidth(
                                    longhands.border_block_start_width
                                )
                            }
                            
                            LonghandId::BorderLeftWidth => {
                                PropertyDeclaration::BorderLeftWidth(
                                    longhands.border_block_start_width
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderBlockEnd) => {
                    shorthands::border_block_end::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBlockEndColor => {
                                PropertyDeclaration::BorderBlockEndColor(
                                    longhands.border_block_end_color
                                )
                            }
                            
                            LonghandId::BorderTopColor => {
                                PropertyDeclaration::BorderTopColor(
                                    longhands.border_block_end_color
                                )
                            }
                            
                            LonghandId::BorderRightColor => {
                                PropertyDeclaration::BorderRightColor(
                                    longhands.border_block_end_color
                                )
                            }
                            
                            LonghandId::BorderBottomColor => {
                                PropertyDeclaration::BorderBottomColor(
                                    longhands.border_block_end_color
                                )
                            }
                            
                            LonghandId::BorderLeftColor => {
                                PropertyDeclaration::BorderLeftColor(
                                    longhands.border_block_end_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBlockEndStyle => {
                                PropertyDeclaration::BorderBlockEndStyle(
                                    longhands.border_block_end_style
                                )
                            }
                            
                            LonghandId::BorderTopStyle => {
                                PropertyDeclaration::BorderTopStyle(
                                    longhands.border_block_end_style
                                )
                            }
                            
                            LonghandId::BorderRightStyle => {
                                PropertyDeclaration::BorderRightStyle(
                                    longhands.border_block_end_style
                                )
                            }
                            
                            LonghandId::BorderBottomStyle => {
                                PropertyDeclaration::BorderBottomStyle(
                                    longhands.border_block_end_style
                                )
                            }
                            
                            LonghandId::BorderLeftStyle => {
                                PropertyDeclaration::BorderLeftStyle(
                                    longhands.border_block_end_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBlockEndWidth => {
                                PropertyDeclaration::BorderBlockEndWidth(
                                    longhands.border_block_end_width
                                )
                            }
                            
                            LonghandId::BorderTopWidth => {
                                PropertyDeclaration::BorderTopWidth(
                                    longhands.border_block_end_width
                                )
                            }
                            
                            LonghandId::BorderRightWidth => {
                                PropertyDeclaration::BorderRightWidth(
                                    longhands.border_block_end_width
                                )
                            }
                            
                            LonghandId::BorderBottomWidth => {
                                PropertyDeclaration::BorderBottomWidth(
                                    longhands.border_block_end_width
                                )
                            }
                            
                            LonghandId::BorderLeftWidth => {
                                PropertyDeclaration::BorderLeftWidth(
                                    longhands.border_block_end_width
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderInlineStart) => {
                    shorthands::border_inline_start::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderInlineStartColor => {
                                PropertyDeclaration::BorderInlineStartColor(
                                    longhands.border_inline_start_color
                                )
                            }
                            
                            LonghandId::BorderTopColor => {
                                PropertyDeclaration::BorderTopColor(
                                    longhands.border_inline_start_color
                                )
                            }
                            
                            LonghandId::BorderRightColor => {
                                PropertyDeclaration::BorderRightColor(
                                    longhands.border_inline_start_color
                                )
                            }
                            
                            LonghandId::BorderBottomColor => {
                                PropertyDeclaration::BorderBottomColor(
                                    longhands.border_inline_start_color
                                )
                            }
                            
                            LonghandId::BorderLeftColor => {
                                PropertyDeclaration::BorderLeftColor(
                                    longhands.border_inline_start_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderInlineStartStyle => {
                                PropertyDeclaration::BorderInlineStartStyle(
                                    longhands.border_inline_start_style
                                )
                            }
                            
                            LonghandId::BorderTopStyle => {
                                PropertyDeclaration::BorderTopStyle(
                                    longhands.border_inline_start_style
                                )
                            }
                            
                            LonghandId::BorderRightStyle => {
                                PropertyDeclaration::BorderRightStyle(
                                    longhands.border_inline_start_style
                                )
                            }
                            
                            LonghandId::BorderBottomStyle => {
                                PropertyDeclaration::BorderBottomStyle(
                                    longhands.border_inline_start_style
                                )
                            }
                            
                            LonghandId::BorderLeftStyle => {
                                PropertyDeclaration::BorderLeftStyle(
                                    longhands.border_inline_start_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderInlineStartWidth => {
                                PropertyDeclaration::BorderInlineStartWidth(
                                    longhands.border_inline_start_width
                                )
                            }
                            
                            LonghandId::BorderTopWidth => {
                                PropertyDeclaration::BorderTopWidth(
                                    longhands.border_inline_start_width
                                )
                            }
                            
                            LonghandId::BorderRightWidth => {
                                PropertyDeclaration::BorderRightWidth(
                                    longhands.border_inline_start_width
                                )
                            }
                            
                            LonghandId::BorderBottomWidth => {
                                PropertyDeclaration::BorderBottomWidth(
                                    longhands.border_inline_start_width
                                )
                            }
                            
                            LonghandId::BorderLeftWidth => {
                                PropertyDeclaration::BorderLeftWidth(
                                    longhands.border_inline_start_width
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderInlineEnd) => {
                    shorthands::border_inline_end::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderInlineEndColor => {
                                PropertyDeclaration::BorderInlineEndColor(
                                    longhands.border_inline_end_color
                                )
                            }
                            
                            LonghandId::BorderTopColor => {
                                PropertyDeclaration::BorderTopColor(
                                    longhands.border_inline_end_color
                                )
                            }
                            
                            LonghandId::BorderRightColor => {
                                PropertyDeclaration::BorderRightColor(
                                    longhands.border_inline_end_color
                                )
                            }
                            
                            LonghandId::BorderBottomColor => {
                                PropertyDeclaration::BorderBottomColor(
                                    longhands.border_inline_end_color
                                )
                            }
                            
                            LonghandId::BorderLeftColor => {
                                PropertyDeclaration::BorderLeftColor(
                                    longhands.border_inline_end_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderInlineEndStyle => {
                                PropertyDeclaration::BorderInlineEndStyle(
                                    longhands.border_inline_end_style
                                )
                            }
                            
                            LonghandId::BorderTopStyle => {
                                PropertyDeclaration::BorderTopStyle(
                                    longhands.border_inline_end_style
                                )
                            }
                            
                            LonghandId::BorderRightStyle => {
                                PropertyDeclaration::BorderRightStyle(
                                    longhands.border_inline_end_style
                                )
                            }
                            
                            LonghandId::BorderBottomStyle => {
                                PropertyDeclaration::BorderBottomStyle(
                                    longhands.border_inline_end_style
                                )
                            }
                            
                            LonghandId::BorderLeftStyle => {
                                PropertyDeclaration::BorderLeftStyle(
                                    longhands.border_inline_end_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderInlineEndWidth => {
                                PropertyDeclaration::BorderInlineEndWidth(
                                    longhands.border_inline_end_width
                                )
                            }
                            
                            LonghandId::BorderTopWidth => {
                                PropertyDeclaration::BorderTopWidth(
                                    longhands.border_inline_end_width
                                )
                            }
                            
                            LonghandId::BorderRightWidth => {
                                PropertyDeclaration::BorderRightWidth(
                                    longhands.border_inline_end_width
                                )
                            }
                            
                            LonghandId::BorderBottomWidth => {
                                PropertyDeclaration::BorderBottomWidth(
                                    longhands.border_inline_end_width
                                )
                            }
                            
                            LonghandId::BorderLeftWidth => {
                                PropertyDeclaration::BorderLeftWidth(
                                    longhands.border_inline_end_width
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::Border) => {
                    shorthands::border::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderTopColor => {
                                PropertyDeclaration::BorderTopColor(
                                    longhands.border_top_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderTopStyle => {
                                PropertyDeclaration::BorderTopStyle(
                                    longhands.border_top_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderTopWidth => {
                                PropertyDeclaration::BorderTopWidth(
                                    longhands.border_top_width
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderRightColor => {
                                PropertyDeclaration::BorderRightColor(
                                    longhands.border_right_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderRightStyle => {
                                PropertyDeclaration::BorderRightStyle(
                                    longhands.border_right_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderRightWidth => {
                                PropertyDeclaration::BorderRightWidth(
                                    longhands.border_right_width
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBottomColor => {
                                PropertyDeclaration::BorderBottomColor(
                                    longhands.border_bottom_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBottomStyle => {
                                PropertyDeclaration::BorderBottomStyle(
                                    longhands.border_bottom_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBottomWidth => {
                                PropertyDeclaration::BorderBottomWidth(
                                    longhands.border_bottom_width
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderLeftColor => {
                                PropertyDeclaration::BorderLeftColor(
                                    longhands.border_left_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderLeftStyle => {
                                PropertyDeclaration::BorderLeftStyle(
                                    longhands.border_left_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderLeftWidth => {
                                PropertyDeclaration::BorderLeftWidth(
                                    longhands.border_left_width
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderImageOutset => {
                                PropertyDeclaration::BorderImageOutset(
                                    longhands.border_image_outset
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderImageRepeat => {
                                PropertyDeclaration::BorderImageRepeat(
                                    longhands.border_image_repeat
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderImageSlice => {
                                PropertyDeclaration::BorderImageSlice(
                                    longhands.border_image_slice
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderImageSource => {
                                PropertyDeclaration::BorderImageSource(
                                    longhands.border_image_source
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderImageWidth => {
                                PropertyDeclaration::BorderImageWidth(
                                    longhands.border_image_width
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderRadius) => {
                    shorthands::border_radius::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderTopLeftRadius => {
                                PropertyDeclaration::BorderTopLeftRadius(
                                    longhands.border_top_left_radius
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderTopRightRadius => {
                                PropertyDeclaration::BorderTopRightRadius(
                                    longhands.border_top_right_radius
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBottomRightRadius => {
                                PropertyDeclaration::BorderBottomRightRadius(
                                    longhands.border_bottom_right_radius
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBottomLeftRadius => {
                                PropertyDeclaration::BorderBottomLeftRadius(
                                    longhands.border_bottom_left_radius
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderImage) => {
                    shorthands::border_image::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderImageOutset => {
                                PropertyDeclaration::BorderImageOutset(
                                    longhands.border_image_outset
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderImageRepeat => {
                                PropertyDeclaration::BorderImageRepeat(
                                    longhands.border_image_repeat
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderImageSlice => {
                                PropertyDeclaration::BorderImageSlice(
                                    longhands.border_image_slice
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderImageSource => {
                                PropertyDeclaration::BorderImageSource(
                                    longhands.border_image_source
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderImageWidth => {
                                PropertyDeclaration::BorderImageWidth(
                                    longhands.border_image_width
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderBlockWidth) => {
                    shorthands::border_block_width::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBlockStartWidth => {
                                PropertyDeclaration::BorderBlockStartWidth(
                                    longhands.border_block_start_width
                                )
                            }
                            
                            LonghandId::BorderTopWidth => {
                                PropertyDeclaration::BorderTopWidth(
                                    longhands.border_block_start_width
                                )
                            }
                            
                            LonghandId::BorderRightWidth => {
                                PropertyDeclaration::BorderRightWidth(
                                    longhands.border_block_start_width
                                )
                            }
                            
                            LonghandId::BorderBottomWidth => {
                                PropertyDeclaration::BorderBottomWidth(
                                    longhands.border_block_start_width
                                )
                            }
                            
                            LonghandId::BorderLeftWidth => {
                                PropertyDeclaration::BorderLeftWidth(
                                    longhands.border_block_start_width
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBlockEndWidth => {
                                PropertyDeclaration::BorderBlockEndWidth(
                                    longhands.border_block_end_width
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderBlockStyle) => {
                    shorthands::border_block_style::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBlockStartStyle => {
                                PropertyDeclaration::BorderBlockStartStyle(
                                    longhands.border_block_start_style
                                )
                            }
                            
                            LonghandId::BorderTopStyle => {
                                PropertyDeclaration::BorderTopStyle(
                                    longhands.border_block_start_style
                                )
                            }
                            
                            LonghandId::BorderRightStyle => {
                                PropertyDeclaration::BorderRightStyle(
                                    longhands.border_block_start_style
                                )
                            }
                            
                            LonghandId::BorderBottomStyle => {
                                PropertyDeclaration::BorderBottomStyle(
                                    longhands.border_block_start_style
                                )
                            }
                            
                            LonghandId::BorderLeftStyle => {
                                PropertyDeclaration::BorderLeftStyle(
                                    longhands.border_block_start_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBlockEndStyle => {
                                PropertyDeclaration::BorderBlockEndStyle(
                                    longhands.border_block_end_style
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderBlockColor) => {
                    shorthands::border_block_color::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBlockStartColor => {
                                PropertyDeclaration::BorderBlockStartColor(
                                    longhands.border_block_start_color
                                )
                            }
                            
                            LonghandId::BorderTopColor => {
                                PropertyDeclaration::BorderTopColor(
                                    longhands.border_block_start_color
                                )
                            }
                            
                            LonghandId::BorderRightColor => {
                                PropertyDeclaration::BorderRightColor(
                                    longhands.border_block_start_color
                                )
                            }
                            
                            LonghandId::BorderBottomColor => {
                                PropertyDeclaration::BorderBottomColor(
                                    longhands.border_block_start_color
                                )
                            }
                            
                            LonghandId::BorderLeftColor => {
                                PropertyDeclaration::BorderLeftColor(
                                    longhands.border_block_start_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBlockEndColor => {
                                PropertyDeclaration::BorderBlockEndColor(
                                    longhands.border_block_end_color
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderInlineWidth) => {
                    shorthands::border_inline_width::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderInlineStartWidth => {
                                PropertyDeclaration::BorderInlineStartWidth(
                                    longhands.border_inline_start_width
                                )
                            }
                            
                            LonghandId::BorderTopWidth => {
                                PropertyDeclaration::BorderTopWidth(
                                    longhands.border_inline_start_width
                                )
                            }
                            
                            LonghandId::BorderRightWidth => {
                                PropertyDeclaration::BorderRightWidth(
                                    longhands.border_inline_start_width
                                )
                            }
                            
                            LonghandId::BorderBottomWidth => {
                                PropertyDeclaration::BorderBottomWidth(
                                    longhands.border_inline_start_width
                                )
                            }
                            
                            LonghandId::BorderLeftWidth => {
                                PropertyDeclaration::BorderLeftWidth(
                                    longhands.border_inline_start_width
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderInlineEndWidth => {
                                PropertyDeclaration::BorderInlineEndWidth(
                                    longhands.border_inline_end_width
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderInlineStyle) => {
                    shorthands::border_inline_style::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderInlineStartStyle => {
                                PropertyDeclaration::BorderInlineStartStyle(
                                    longhands.border_inline_start_style
                                )
                            }
                            
                            LonghandId::BorderTopStyle => {
                                PropertyDeclaration::BorderTopStyle(
                                    longhands.border_inline_start_style
                                )
                            }
                            
                            LonghandId::BorderRightStyle => {
                                PropertyDeclaration::BorderRightStyle(
                                    longhands.border_inline_start_style
                                )
                            }
                            
                            LonghandId::BorderBottomStyle => {
                                PropertyDeclaration::BorderBottomStyle(
                                    longhands.border_inline_start_style
                                )
                            }
                            
                            LonghandId::BorderLeftStyle => {
                                PropertyDeclaration::BorderLeftStyle(
                                    longhands.border_inline_start_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderInlineEndStyle => {
                                PropertyDeclaration::BorderInlineEndStyle(
                                    longhands.border_inline_end_style
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderInlineColor) => {
                    shorthands::border_inline_color::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderInlineStartColor => {
                                PropertyDeclaration::BorderInlineStartColor(
                                    longhands.border_inline_start_color
                                )
                            }
                            
                            LonghandId::BorderTopColor => {
                                PropertyDeclaration::BorderTopColor(
                                    longhands.border_inline_start_color
                                )
                            }
                            
                            LonghandId::BorderRightColor => {
                                PropertyDeclaration::BorderRightColor(
                                    longhands.border_inline_start_color
                                )
                            }
                            
                            LonghandId::BorderBottomColor => {
                                PropertyDeclaration::BorderBottomColor(
                                    longhands.border_inline_start_color
                                )
                            }
                            
                            LonghandId::BorderLeftColor => {
                                PropertyDeclaration::BorderLeftColor(
                                    longhands.border_inline_start_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderInlineEndColor => {
                                PropertyDeclaration::BorderInlineEndColor(
                                    longhands.border_inline_end_color
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderBlock) => {
                    shorthands::border_block::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBlockStartWidth => {
                                PropertyDeclaration::BorderBlockStartWidth(
                                    longhands.border_block_start_width
                                )
                            }
                            
                            LonghandId::BorderTopWidth => {
                                PropertyDeclaration::BorderTopWidth(
                                    longhands.border_block_start_width
                                )
                            }
                            
                            LonghandId::BorderRightWidth => {
                                PropertyDeclaration::BorderRightWidth(
                                    longhands.border_block_start_width
                                )
                            }
                            
                            LonghandId::BorderBottomWidth => {
                                PropertyDeclaration::BorderBottomWidth(
                                    longhands.border_block_start_width
                                )
                            }
                            
                            LonghandId::BorderLeftWidth => {
                                PropertyDeclaration::BorderLeftWidth(
                                    longhands.border_block_start_width
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBlockEndWidth => {
                                PropertyDeclaration::BorderBlockEndWidth(
                                    longhands.border_block_end_width
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBlockStartStyle => {
                                PropertyDeclaration::BorderBlockStartStyle(
                                    longhands.border_block_start_style
                                )
                            }
                            
                            LonghandId::BorderTopStyle => {
                                PropertyDeclaration::BorderTopStyle(
                                    longhands.border_block_start_style
                                )
                            }
                            
                            LonghandId::BorderRightStyle => {
                                PropertyDeclaration::BorderRightStyle(
                                    longhands.border_block_start_style
                                )
                            }
                            
                            LonghandId::BorderBottomStyle => {
                                PropertyDeclaration::BorderBottomStyle(
                                    longhands.border_block_start_style
                                )
                            }
                            
                            LonghandId::BorderLeftStyle => {
                                PropertyDeclaration::BorderLeftStyle(
                                    longhands.border_block_start_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBlockEndStyle => {
                                PropertyDeclaration::BorderBlockEndStyle(
                                    longhands.border_block_end_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBlockStartColor => {
                                PropertyDeclaration::BorderBlockStartColor(
                                    longhands.border_block_start_color
                                )
                            }
                            
                            LonghandId::BorderTopColor => {
                                PropertyDeclaration::BorderTopColor(
                                    longhands.border_block_start_color
                                )
                            }
                            
                            LonghandId::BorderRightColor => {
                                PropertyDeclaration::BorderRightColor(
                                    longhands.border_block_start_color
                                )
                            }
                            
                            LonghandId::BorderBottomColor => {
                                PropertyDeclaration::BorderBottomColor(
                                    longhands.border_block_start_color
                                )
                            }
                            
                            LonghandId::BorderLeftColor => {
                                PropertyDeclaration::BorderLeftColor(
                                    longhands.border_block_start_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderBlockEndColor => {
                                PropertyDeclaration::BorderBlockEndColor(
                                    longhands.border_block_end_color
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::BorderInline) => {
                    shorthands::border_inline::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderInlineStartWidth => {
                                PropertyDeclaration::BorderInlineStartWidth(
                                    longhands.border_inline_start_width
                                )
                            }
                            
                            LonghandId::BorderTopWidth => {
                                PropertyDeclaration::BorderTopWidth(
                                    longhands.border_inline_start_width
                                )
                            }
                            
                            LonghandId::BorderRightWidth => {
                                PropertyDeclaration::BorderRightWidth(
                                    longhands.border_inline_start_width
                                )
                            }
                            
                            LonghandId::BorderBottomWidth => {
                                PropertyDeclaration::BorderBottomWidth(
                                    longhands.border_inline_start_width
                                )
                            }
                            
                            LonghandId::BorderLeftWidth => {
                                PropertyDeclaration::BorderLeftWidth(
                                    longhands.border_inline_start_width
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderInlineEndWidth => {
                                PropertyDeclaration::BorderInlineEndWidth(
                                    longhands.border_inline_end_width
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderInlineStartStyle => {
                                PropertyDeclaration::BorderInlineStartStyle(
                                    longhands.border_inline_start_style
                                )
                            }
                            
                            LonghandId::BorderTopStyle => {
                                PropertyDeclaration::BorderTopStyle(
                                    longhands.border_inline_start_style
                                )
                            }
                            
                            LonghandId::BorderRightStyle => {
                                PropertyDeclaration::BorderRightStyle(
                                    longhands.border_inline_start_style
                                )
                            }
                            
                            LonghandId::BorderBottomStyle => {
                                PropertyDeclaration::BorderBottomStyle(
                                    longhands.border_inline_start_style
                                )
                            }
                            
                            LonghandId::BorderLeftStyle => {
                                PropertyDeclaration::BorderLeftStyle(
                                    longhands.border_inline_start_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderInlineEndStyle => {
                                PropertyDeclaration::BorderInlineEndStyle(
                                    longhands.border_inline_end_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderInlineStartColor => {
                                PropertyDeclaration::BorderInlineStartColor(
                                    longhands.border_inline_start_color
                                )
                            }
                            
                            LonghandId::BorderTopColor => {
                                PropertyDeclaration::BorderTopColor(
                                    longhands.border_inline_start_color
                                )
                            }
                            
                            LonghandId::BorderRightColor => {
                                PropertyDeclaration::BorderRightColor(
                                    longhands.border_inline_start_color
                                )
                            }
                            
                            LonghandId::BorderBottomColor => {
                                PropertyDeclaration::BorderBottomColor(
                                    longhands.border_inline_start_color
                                )
                            }
                            
                            LonghandId::BorderLeftColor => {
                                PropertyDeclaration::BorderLeftColor(
                                    longhands.border_inline_start_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BorderInlineEndColor => {
                                PropertyDeclaration::BorderInlineEndColor(
                                    longhands.border_inline_end_color
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::Overflow) => {
                    shorthands::overflow::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::OverflowX => {
                                PropertyDeclaration::OverflowX(
                                    longhands.overflow_x
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::OverflowY => {
                                PropertyDeclaration::OverflowY(
                                    longhands.overflow_y
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::OverflowClipBox) => {
                    shorthands::overflow_clip_box::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::OverflowClipBoxBlock => {
                                PropertyDeclaration::OverflowClipBoxBlock(
                                    longhands.overflow_clip_box_block
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::OverflowClipBoxInline => {
                                PropertyDeclaration::OverflowClipBoxInline(
                                    longhands.overflow_clip_box_inline
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::Transition) => {
                    shorthands::transition::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::TransitionProperty => {
                                PropertyDeclaration::TransitionProperty(
                                    longhands.transition_property
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::TransitionDuration => {
                                PropertyDeclaration::TransitionDuration(
                                    longhands.transition_duration
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::TransitionTimingFunction => {
                                PropertyDeclaration::TransitionTimingFunction(
                                    longhands.transition_timing_function
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::TransitionDelay => {
                                PropertyDeclaration::TransitionDelay(
                                    longhands.transition_delay
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::Animation) => {
                    shorthands::animation::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::AnimationName => {
                                PropertyDeclaration::AnimationName(
                                    longhands.animation_name
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::AnimationDuration => {
                                PropertyDeclaration::AnimationDuration(
                                    longhands.animation_duration
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::AnimationTimingFunction => {
                                PropertyDeclaration::AnimationTimingFunction(
                                    longhands.animation_timing_function
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::AnimationDelay => {
                                PropertyDeclaration::AnimationDelay(
                                    longhands.animation_delay
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::AnimationIterationCount => {
                                PropertyDeclaration::AnimationIterationCount(
                                    longhands.animation_iteration_count
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::AnimationDirection => {
                                PropertyDeclaration::AnimationDirection(
                                    longhands.animation_direction
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::AnimationFillMode => {
                                PropertyDeclaration::AnimationFillMode(
                                    longhands.animation_fill_mode
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::AnimationPlayState => {
                                PropertyDeclaration::AnimationPlayState(
                                    longhands.animation_play_state
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::OverscrollBehavior) => {
                    shorthands::overscroll_behavior::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::OverscrollBehaviorX => {
                                PropertyDeclaration::OverscrollBehaviorX(
                                    longhands.overscroll_behavior_x
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::OverscrollBehaviorY => {
                                PropertyDeclaration::OverscrollBehaviorY(
                                    longhands.overscroll_behavior_y
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::PageBreakBefore) => {
                    shorthands::page_break_before::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BreakBefore => {
                                PropertyDeclaration::BreakBefore(
                                    longhands.break_before
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::PageBreakAfter) => {
                    shorthands::page_break_after::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::BreakAfter => {
                                PropertyDeclaration::BreakAfter(
                                    longhands.break_after
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::Columns) => {
                    shorthands::columns::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ColumnWidth => {
                                PropertyDeclaration::ColumnWidth(
                                    longhands.column_width
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ColumnCount => {
                                PropertyDeclaration::ColumnCount(
                                    longhands.column_count
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::ColumnRule) => {
                    shorthands::column_rule::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ColumnRuleWidth => {
                                PropertyDeclaration::ColumnRuleWidth(
                                    longhands.column_rule_width
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ColumnRuleStyle => {
                                PropertyDeclaration::ColumnRuleStyle(
                                    longhands.column_rule_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ColumnRuleColor => {
                                PropertyDeclaration::ColumnRuleColor(
                                    longhands.column_rule_color
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::Font) => {
                    shorthands::font::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontStyle => {
                                PropertyDeclaration::FontStyle(
                                    longhands.font_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontVariantCaps => {
                                PropertyDeclaration::FontVariantCaps(
                                    longhands.font_variant_caps
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontWeight => {
                                PropertyDeclaration::FontWeight(
                                    longhands.font_weight
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontStretch => {
                                PropertyDeclaration::FontStretch(
                                    longhands.font_stretch
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontSize => {
                                PropertyDeclaration::FontSize(
                                    longhands.font_size
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::LineHeight => {
                                PropertyDeclaration::LineHeight(
                                    longhands.line_height
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontFamily => {
                                PropertyDeclaration::FontFamily(
                                    longhands.font_family
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontSizeAdjust => {
                                PropertyDeclaration::FontSizeAdjust(
                                    longhands.font_size_adjust
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontKerning => {
                                PropertyDeclaration::FontKerning(
                                    longhands.font_kerning
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontOpticalSizing => {
                                PropertyDeclaration::FontOpticalSizing(
                                    longhands.font_optical_sizing
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontVariantAlternates => {
                                PropertyDeclaration::FontVariantAlternates(
                                    longhands.font_variant_alternates
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontVariantEastAsian => {
                                PropertyDeclaration::FontVariantEastAsian(
                                    longhands.font_variant_east_asian
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontVariantLigatures => {
                                PropertyDeclaration::FontVariantLigatures(
                                    longhands.font_variant_ligatures
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontVariantNumeric => {
                                PropertyDeclaration::FontVariantNumeric(
                                    longhands.font_variant_numeric
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontVariantPosition => {
                                PropertyDeclaration::FontVariantPosition(
                                    longhands.font_variant_position
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontLanguageOverride => {
                                PropertyDeclaration::FontLanguageOverride(
                                    longhands.font_language_override
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontFeatureSettings => {
                                PropertyDeclaration::FontFeatureSettings(
                                    longhands.font_feature_settings
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontVariationSettings => {
                                PropertyDeclaration::FontVariationSettings(
                                    longhands.font_variation_settings
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::FontVariant) => {
                    shorthands::font_variant::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontVariantCaps => {
                                PropertyDeclaration::FontVariantCaps(
                                    longhands.font_variant_caps
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontVariantAlternates => {
                                PropertyDeclaration::FontVariantAlternates(
                                    longhands.font_variant_alternates
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontVariantEastAsian => {
                                PropertyDeclaration::FontVariantEastAsian(
                                    longhands.font_variant_east_asian
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontVariantLigatures => {
                                PropertyDeclaration::FontVariantLigatures(
                                    longhands.font_variant_ligatures
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontVariantNumeric => {
                                PropertyDeclaration::FontVariantNumeric(
                                    longhands.font_variant_numeric
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FontVariantPosition => {
                                PropertyDeclaration::FontVariantPosition(
                                    longhands.font_variant_position
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::TextEmphasis) => {
                    shorthands::text_emphasis::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::TextEmphasisStyle => {
                                PropertyDeclaration::TextEmphasisStyle(
                                    longhands.text_emphasis_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::TextEmphasisColor => {
                                PropertyDeclaration::TextEmphasisColor(
                                    longhands.text_emphasis_color
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::WebkitTextStroke) => {
                    shorthands::_webkit_text_stroke::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::WebkitTextStrokeWidth => {
                                PropertyDeclaration::WebkitTextStrokeWidth(
                                    longhands._webkit_text_stroke_width
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::WebkitTextStrokeColor => {
                                PropertyDeclaration::WebkitTextStrokeColor(
                                    longhands._webkit_text_stroke_color
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::Marker) => {
                    shorthands::marker::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MarkerStart => {
                                PropertyDeclaration::MarkerStart(
                                    longhands.marker_start
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MarkerEnd => {
                                PropertyDeclaration::MarkerEnd(
                                    longhands.marker_end
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MarkerMid => {
                                PropertyDeclaration::MarkerMid(
                                    longhands.marker_mid
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::ListStyle) => {
                    shorthands::list_style::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ListStylePosition => {
                                PropertyDeclaration::ListStylePosition(
                                    longhands.list_style_position
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ListStyleImage => {
                                PropertyDeclaration::ListStyleImage(
                                    longhands.list_style_image
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ListStyleType => {
                                PropertyDeclaration::ListStyleType(
                                    longhands.list_style_type
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::Margin) => {
                    shorthands::margin::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MarginTop => {
                                PropertyDeclaration::MarginTop(
                                    longhands.margin_top
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MarginRight => {
                                PropertyDeclaration::MarginRight(
                                    longhands.margin_right
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MarginBottom => {
                                PropertyDeclaration::MarginBottom(
                                    longhands.margin_bottom
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MarginLeft => {
                                PropertyDeclaration::MarginLeft(
                                    longhands.margin_left
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::MarginBlock) => {
                    shorthands::margin_block::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MarginBlockStart => {
                                PropertyDeclaration::MarginBlockStart(
                                    longhands.margin_block_start
                                )
                            }
                            
                            LonghandId::MarginTop => {
                                PropertyDeclaration::MarginTop(
                                    longhands.margin_block_start
                                )
                            }
                            
                            LonghandId::MarginRight => {
                                PropertyDeclaration::MarginRight(
                                    longhands.margin_block_start
                                )
                            }
                            
                            LonghandId::MarginBottom => {
                                PropertyDeclaration::MarginBottom(
                                    longhands.margin_block_start
                                )
                            }
                            
                            LonghandId::MarginLeft => {
                                PropertyDeclaration::MarginLeft(
                                    longhands.margin_block_start
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MarginBlockEnd => {
                                PropertyDeclaration::MarginBlockEnd(
                                    longhands.margin_block_end
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::MarginInline) => {
                    shorthands::margin_inline::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MarginInlineStart => {
                                PropertyDeclaration::MarginInlineStart(
                                    longhands.margin_inline_start
                                )
                            }
                            
                            LonghandId::MarginTop => {
                                PropertyDeclaration::MarginTop(
                                    longhands.margin_inline_start
                                )
                            }
                            
                            LonghandId::MarginRight => {
                                PropertyDeclaration::MarginRight(
                                    longhands.margin_inline_start
                                )
                            }
                            
                            LonghandId::MarginBottom => {
                                PropertyDeclaration::MarginBottom(
                                    longhands.margin_inline_start
                                )
                            }
                            
                            LonghandId::MarginLeft => {
                                PropertyDeclaration::MarginLeft(
                                    longhands.margin_inline_start
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MarginInlineEnd => {
                                PropertyDeclaration::MarginInlineEnd(
                                    longhands.margin_inline_end
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::ScrollMargin) => {
                    shorthands::scroll_margin::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ScrollMarginTop => {
                                PropertyDeclaration::ScrollMarginTop(
                                    longhands.scroll_margin_top
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ScrollMarginRight => {
                                PropertyDeclaration::ScrollMarginRight(
                                    longhands.scroll_margin_right
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ScrollMarginBottom => {
                                PropertyDeclaration::ScrollMarginBottom(
                                    longhands.scroll_margin_bottom
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ScrollMarginLeft => {
                                PropertyDeclaration::ScrollMarginLeft(
                                    longhands.scroll_margin_left
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::ScrollMarginBlock) => {
                    shorthands::scroll_margin_block::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ScrollMarginBlockStart => {
                                PropertyDeclaration::ScrollMarginBlockStart(
                                    longhands.scroll_margin_block_start
                                )
                            }
                            
                            LonghandId::ScrollMarginTop => {
                                PropertyDeclaration::ScrollMarginTop(
                                    longhands.scroll_margin_block_start
                                )
                            }
                            
                            LonghandId::ScrollMarginRight => {
                                PropertyDeclaration::ScrollMarginRight(
                                    longhands.scroll_margin_block_start
                                )
                            }
                            
                            LonghandId::ScrollMarginBottom => {
                                PropertyDeclaration::ScrollMarginBottom(
                                    longhands.scroll_margin_block_start
                                )
                            }
                            
                            LonghandId::ScrollMarginLeft => {
                                PropertyDeclaration::ScrollMarginLeft(
                                    longhands.scroll_margin_block_start
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ScrollMarginBlockEnd => {
                                PropertyDeclaration::ScrollMarginBlockEnd(
                                    longhands.scroll_margin_block_end
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::ScrollMarginInline) => {
                    shorthands::scroll_margin_inline::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ScrollMarginInlineStart => {
                                PropertyDeclaration::ScrollMarginInlineStart(
                                    longhands.scroll_margin_inline_start
                                )
                            }
                            
                            LonghandId::ScrollMarginTop => {
                                PropertyDeclaration::ScrollMarginTop(
                                    longhands.scroll_margin_inline_start
                                )
                            }
                            
                            LonghandId::ScrollMarginRight => {
                                PropertyDeclaration::ScrollMarginRight(
                                    longhands.scroll_margin_inline_start
                                )
                            }
                            
                            LonghandId::ScrollMarginBottom => {
                                PropertyDeclaration::ScrollMarginBottom(
                                    longhands.scroll_margin_inline_start
                                )
                            }
                            
                            LonghandId::ScrollMarginLeft => {
                                PropertyDeclaration::ScrollMarginLeft(
                                    longhands.scroll_margin_inline_start
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ScrollMarginInlineEnd => {
                                PropertyDeclaration::ScrollMarginInlineEnd(
                                    longhands.scroll_margin_inline_end
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::Outline) => {
                    shorthands::outline::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::OutlineColor => {
                                PropertyDeclaration::OutlineColor(
                                    longhands.outline_color
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::OutlineStyle => {
                                PropertyDeclaration::OutlineStyle(
                                    longhands.outline_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::OutlineWidth => {
                                PropertyDeclaration::OutlineWidth(
                                    longhands.outline_width
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::MozOutlineRadius) => {
                    shorthands::_moz_outline_radius::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MozOutlineRadiusTopleft => {
                                PropertyDeclaration::MozOutlineRadiusTopleft(
                                    longhands._moz_outline_radius_topleft
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MozOutlineRadiusTopright => {
                                PropertyDeclaration::MozOutlineRadiusTopright(
                                    longhands._moz_outline_radius_topright
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MozOutlineRadiusBottomright => {
                                PropertyDeclaration::MozOutlineRadiusBottomright(
                                    longhands._moz_outline_radius_bottomright
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MozOutlineRadiusBottomleft => {
                                PropertyDeclaration::MozOutlineRadiusBottomleft(
                                    longhands._moz_outline_radius_bottomleft
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::Padding) => {
                    shorthands::padding::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::PaddingTop => {
                                PropertyDeclaration::PaddingTop(
                                    longhands.padding_top
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::PaddingRight => {
                                PropertyDeclaration::PaddingRight(
                                    longhands.padding_right
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::PaddingBottom => {
                                PropertyDeclaration::PaddingBottom(
                                    longhands.padding_bottom
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::PaddingLeft => {
                                PropertyDeclaration::PaddingLeft(
                                    longhands.padding_left
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::PaddingBlock) => {
                    shorthands::padding_block::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::PaddingBlockStart => {
                                PropertyDeclaration::PaddingBlockStart(
                                    longhands.padding_block_start
                                )
                            }
                            
                            LonghandId::PaddingTop => {
                                PropertyDeclaration::PaddingTop(
                                    longhands.padding_block_start
                                )
                            }
                            
                            LonghandId::PaddingRight => {
                                PropertyDeclaration::PaddingRight(
                                    longhands.padding_block_start
                                )
                            }
                            
                            LonghandId::PaddingBottom => {
                                PropertyDeclaration::PaddingBottom(
                                    longhands.padding_block_start
                                )
                            }
                            
                            LonghandId::PaddingLeft => {
                                PropertyDeclaration::PaddingLeft(
                                    longhands.padding_block_start
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::PaddingBlockEnd => {
                                PropertyDeclaration::PaddingBlockEnd(
                                    longhands.padding_block_end
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::PaddingInline) => {
                    shorthands::padding_inline::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::PaddingInlineStart => {
                                PropertyDeclaration::PaddingInlineStart(
                                    longhands.padding_inline_start
                                )
                            }
                            
                            LonghandId::PaddingTop => {
                                PropertyDeclaration::PaddingTop(
                                    longhands.padding_inline_start
                                )
                            }
                            
                            LonghandId::PaddingRight => {
                                PropertyDeclaration::PaddingRight(
                                    longhands.padding_inline_start
                                )
                            }
                            
                            LonghandId::PaddingBottom => {
                                PropertyDeclaration::PaddingBottom(
                                    longhands.padding_inline_start
                                )
                            }
                            
                            LonghandId::PaddingLeft => {
                                PropertyDeclaration::PaddingLeft(
                                    longhands.padding_inline_start
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::PaddingInlineEnd => {
                                PropertyDeclaration::PaddingInlineEnd(
                                    longhands.padding_inline_end
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::ScrollPadding) => {
                    shorthands::scroll_padding::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ScrollPaddingTop => {
                                PropertyDeclaration::ScrollPaddingTop(
                                    longhands.scroll_padding_top
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ScrollPaddingRight => {
                                PropertyDeclaration::ScrollPaddingRight(
                                    longhands.scroll_padding_right
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ScrollPaddingBottom => {
                                PropertyDeclaration::ScrollPaddingBottom(
                                    longhands.scroll_padding_bottom
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ScrollPaddingLeft => {
                                PropertyDeclaration::ScrollPaddingLeft(
                                    longhands.scroll_padding_left
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::ScrollPaddingBlock) => {
                    shorthands::scroll_padding_block::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ScrollPaddingBlockStart => {
                                PropertyDeclaration::ScrollPaddingBlockStart(
                                    longhands.scroll_padding_block_start
                                )
                            }
                            
                            LonghandId::ScrollPaddingTop => {
                                PropertyDeclaration::ScrollPaddingTop(
                                    longhands.scroll_padding_block_start
                                )
                            }
                            
                            LonghandId::ScrollPaddingRight => {
                                PropertyDeclaration::ScrollPaddingRight(
                                    longhands.scroll_padding_block_start
                                )
                            }
                            
                            LonghandId::ScrollPaddingBottom => {
                                PropertyDeclaration::ScrollPaddingBottom(
                                    longhands.scroll_padding_block_start
                                )
                            }
                            
                            LonghandId::ScrollPaddingLeft => {
                                PropertyDeclaration::ScrollPaddingLeft(
                                    longhands.scroll_padding_block_start
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ScrollPaddingBlockEnd => {
                                PropertyDeclaration::ScrollPaddingBlockEnd(
                                    longhands.scroll_padding_block_end
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::ScrollPaddingInline) => {
                    shorthands::scroll_padding_inline::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ScrollPaddingInlineStart => {
                                PropertyDeclaration::ScrollPaddingInlineStart(
                                    longhands.scroll_padding_inline_start
                                )
                            }
                            
                            LonghandId::ScrollPaddingTop => {
                                PropertyDeclaration::ScrollPaddingTop(
                                    longhands.scroll_padding_inline_start
                                )
                            }
                            
                            LonghandId::ScrollPaddingRight => {
                                PropertyDeclaration::ScrollPaddingRight(
                                    longhands.scroll_padding_inline_start
                                )
                            }
                            
                            LonghandId::ScrollPaddingBottom => {
                                PropertyDeclaration::ScrollPaddingBottom(
                                    longhands.scroll_padding_inline_start
                                )
                            }
                            
                            LonghandId::ScrollPaddingLeft => {
                                PropertyDeclaration::ScrollPaddingLeft(
                                    longhands.scroll_padding_inline_start
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ScrollPaddingInlineEnd => {
                                PropertyDeclaration::ScrollPaddingInlineEnd(
                                    longhands.scroll_padding_inline_end
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::FlexFlow) => {
                    shorthands::flex_flow::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FlexDirection => {
                                PropertyDeclaration::FlexDirection(
                                    longhands.flex_direction
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FlexWrap => {
                                PropertyDeclaration::FlexWrap(
                                    longhands.flex_wrap
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::Flex) => {
                    shorthands::flex::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FlexGrow => {
                                PropertyDeclaration::FlexGrow(
                                    longhands.flex_grow
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FlexShrink => {
                                PropertyDeclaration::FlexShrink(
                                    longhands.flex_shrink
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::FlexBasis => {
                                PropertyDeclaration::FlexBasis(
                                    longhands.flex_basis
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::Gap) => {
                    shorthands::gap::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::RowGap => {
                                PropertyDeclaration::RowGap(
                                    longhands.row_gap
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::ColumnGap => {
                                PropertyDeclaration::ColumnGap(
                                    longhands.column_gap
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::GridRow) => {
                    shorthands::grid_row::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::GridRowStart => {
                                PropertyDeclaration::GridRowStart(
                                    longhands.grid_row_start
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::GridRowEnd => {
                                PropertyDeclaration::GridRowEnd(
                                    longhands.grid_row_end
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::GridColumn) => {
                    shorthands::grid_column::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::GridColumnStart => {
                                PropertyDeclaration::GridColumnStart(
                                    longhands.grid_column_start
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::GridColumnEnd => {
                                PropertyDeclaration::GridColumnEnd(
                                    longhands.grid_column_end
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::GridArea) => {
                    shorthands::grid_area::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::GridRowStart => {
                                PropertyDeclaration::GridRowStart(
                                    longhands.grid_row_start
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::GridRowEnd => {
                                PropertyDeclaration::GridRowEnd(
                                    longhands.grid_row_end
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::GridColumnStart => {
                                PropertyDeclaration::GridColumnStart(
                                    longhands.grid_column_start
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::GridColumnEnd => {
                                PropertyDeclaration::GridColumnEnd(
                                    longhands.grid_column_end
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::GridTemplate) => {
                    shorthands::grid_template::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::GridTemplateRows => {
                                PropertyDeclaration::GridTemplateRows(
                                    longhands.grid_template_rows
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::GridTemplateColumns => {
                                PropertyDeclaration::GridTemplateColumns(
                                    longhands.grid_template_columns
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::GridTemplateAreas => {
                                PropertyDeclaration::GridTemplateAreas(
                                    longhands.grid_template_areas
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::Grid) => {
                    shorthands::grid::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::GridTemplateRows => {
                                PropertyDeclaration::GridTemplateRows(
                                    longhands.grid_template_rows
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::GridTemplateColumns => {
                                PropertyDeclaration::GridTemplateColumns(
                                    longhands.grid_template_columns
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::GridTemplateAreas => {
                                PropertyDeclaration::GridTemplateAreas(
                                    longhands.grid_template_areas
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::GridAutoRows => {
                                PropertyDeclaration::GridAutoRows(
                                    longhands.grid_auto_rows
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::GridAutoColumns => {
                                PropertyDeclaration::GridAutoColumns(
                                    longhands.grid_auto_columns
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::GridAutoFlow => {
                                PropertyDeclaration::GridAutoFlow(
                                    longhands.grid_auto_flow
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::PlaceContent) => {
                    shorthands::place_content::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::AlignContent => {
                                PropertyDeclaration::AlignContent(
                                    longhands.align_content
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::JustifyContent => {
                                PropertyDeclaration::JustifyContent(
                                    longhands.justify_content
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::PlaceSelf) => {
                    shorthands::place_self::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::AlignSelf => {
                                PropertyDeclaration::AlignSelf(
                                    longhands.align_self
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::JustifySelf => {
                                PropertyDeclaration::JustifySelf(
                                    longhands.justify_self
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::PlaceItems) => {
                    shorthands::place_items::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::AlignItems => {
                                PropertyDeclaration::AlignItems(
                                    longhands.align_items
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::JustifyItems => {
                                PropertyDeclaration::JustifyItems(
                                    longhands.justify_items
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::Inset) => {
                    shorthands::inset::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::Top => {
                                PropertyDeclaration::Top(
                                    longhands.top
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::Right => {
                                PropertyDeclaration::Right(
                                    longhands.right
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::Bottom => {
                                PropertyDeclaration::Bottom(
                                    longhands.bottom
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::Left => {
                                PropertyDeclaration::Left(
                                    longhands.left
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::InsetBlock) => {
                    shorthands::inset_block::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::InsetBlockStart => {
                                PropertyDeclaration::InsetBlockStart(
                                    longhands.inset_block_start
                                )
                            }
                            
                            LonghandId::Top => {
                                PropertyDeclaration::Top(
                                    longhands.inset_block_start
                                )
                            }
                            
                            LonghandId::Right => {
                                PropertyDeclaration::Right(
                                    longhands.inset_block_start
                                )
                            }
                            
                            LonghandId::Bottom => {
                                PropertyDeclaration::Bottom(
                                    longhands.inset_block_start
                                )
                            }
                            
                            LonghandId::Left => {
                                PropertyDeclaration::Left(
                                    longhands.inset_block_start
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::InsetBlockEnd => {
                                PropertyDeclaration::InsetBlockEnd(
                                    longhands.inset_block_end
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::InsetInline) => {
                    shorthands::inset_inline::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::InsetInlineStart => {
                                PropertyDeclaration::InsetInlineStart(
                                    longhands.inset_inline_start
                                )
                            }
                            
                            LonghandId::Top => {
                                PropertyDeclaration::Top(
                                    longhands.inset_inline_start
                                )
                            }
                            
                            LonghandId::Right => {
                                PropertyDeclaration::Right(
                                    longhands.inset_inline_start
                                )
                            }
                            
                            LonghandId::Bottom => {
                                PropertyDeclaration::Bottom(
                                    longhands.inset_inline_start
                                )
                            }
                            
                            LonghandId::Left => {
                                PropertyDeclaration::Left(
                                    longhands.inset_inline_start
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::InsetInlineEnd => {
                                PropertyDeclaration::InsetInlineEnd(
                                    longhands.inset_inline_end
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::TextDecoration) => {
                    shorthands::text_decoration::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::TextDecorationLine => {
                                PropertyDeclaration::TextDecorationLine(
                                    longhands.text_decoration_line
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::TextDecorationStyle => {
                                PropertyDeclaration::TextDecorationStyle(
                                    longhands.text_decoration_style
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::TextDecorationColor => {
                                PropertyDeclaration::TextDecorationColor(
                                    longhands.text_decoration_color
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::Mask) => {
                    shorthands::mask::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MaskMode => {
                                PropertyDeclaration::MaskMode(
                                    longhands.mask_mode
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MaskRepeat => {
                                PropertyDeclaration::MaskRepeat(
                                    longhands.mask_repeat
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MaskClip => {
                                PropertyDeclaration::MaskClip(
                                    longhands.mask_clip
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MaskOrigin => {
                                PropertyDeclaration::MaskOrigin(
                                    longhands.mask_origin
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MaskComposite => {
                                PropertyDeclaration::MaskComposite(
                                    longhands.mask_composite
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MaskPositionX => {
                                PropertyDeclaration::MaskPositionX(
                                    longhands.mask_position_x
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MaskPositionY => {
                                PropertyDeclaration::MaskPositionY(
                                    longhands.mask_position_y
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MaskSize => {
                                PropertyDeclaration::MaskSize(
                                    longhands.mask_size
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MaskImage => {
                                PropertyDeclaration::MaskImage(
                                    longhands.mask_image
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
                Some(ShorthandId::MaskPosition) => {
                    shorthands::mask_position::parse_value(&context, input)
                    .map(|longhands| {
                        match longhand_id {
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MaskPositionX => {
                                PropertyDeclaration::MaskPositionX(
                                    longhands.mask_position_x
                                )
                            }
                            
                            // When animating logical properties, we end up
                            // physicalizing the value during the animation, but
                            // the value still comes from the logical shorthand.
                            //
                            // So we need to handle the physical properties too.
                            LonghandId::MaskPositionY => {
                                PropertyDeclaration::MaskPositionY(
                                    longhands.mask_position_y
                                )
                            }
                            
                            
                            _ => unreachable!()
                        }
                    })
                }
            }
        });

        match declaration {
            Ok(decl) => decl,
            Err(..) => invalid_at_computed_value_time(),
        }
    }
}

/// An identifier for a given property declaration, which can be either a
/// longhand or a custom property.
#[derive(Clone, Copy, Debug, PartialEq)]
#[cfg_attr(feature = "servo", derive(MallocSizeOf))]
pub enum PropertyDeclarationId<'a> {
    /// A longhand.
    Longhand(LonghandId),
    /// A custom property declaration.
    Custom(&'a crate::custom_properties::Name),
}

impl<'a> ToCss for PropertyDeclarationId<'a> {
    fn to_css<W>(&self, dest: &mut CssWriter<W>) -> fmt::Result
    where
        W: Write,
    {
        match *self {
            PropertyDeclarationId::Longhand(id) => dest.write_str(id.name()),
            PropertyDeclarationId::Custom(ref name) => {
                dest.write_str("--")?;
                serialize_atom_name(name, dest)
            }
        }
    }
}

impl<'a> PropertyDeclarationId<'a> {
    /// Whether a given declaration id is either the same as `other`, or a
    /// longhand of it.
    pub fn is_or_is_longhand_of(&self, other: &PropertyId) -> bool {
        match *self {
            PropertyDeclarationId::Longhand(id) => {
                match *other {
                    PropertyId::Longhand(other_id) |
                    PropertyId::LonghandAlias(other_id, _) => id == other_id,
                    PropertyId::Shorthand(shorthand) |
                    PropertyId::ShorthandAlias(shorthand, _) => self.is_longhand_of(shorthand),
                    PropertyId::Custom(_) => false,
                }
            }
            PropertyDeclarationId::Custom(name) => {
                matches!(*other, PropertyId::Custom(ref other_name) if name == other_name)
            }
        }
    }

    /// Whether a given declaration id is a longhand belonging to this
    /// shorthand.
    pub fn is_longhand_of(&self, shorthand: ShorthandId) -> bool {
        match *self {
            PropertyDeclarationId::Longhand(ref id) => id.shorthands().any(|s| s == shorthand),
            _ => false,
        }
    }

    /// Returns the name of the property without CSS escaping.
    pub fn name(&self) -> Cow<'static, str> {
        match *self {
            PropertyDeclarationId::Longhand(id) => id.name().into(),
            PropertyDeclarationId::Custom(name) => {
                let mut s = String::new();
                write!(&mut s, "--{}", name).unwrap();
                s.into()
            }
        }
    }

    /// Returns longhand id if it is, None otherwise.
    #[inline]
    pub fn as_longhand(&self) -> Option<LonghandId> {
        match *self {
            PropertyDeclarationId::Longhand(id) => Some(id),
            _ => None,
        }
    }
}

/// Servo's representation of a CSS property, that is, either a longhand, a
/// shorthand, or a custom property.
#[derive(Clone, Eq, PartialEq)]
pub enum PropertyId {
    /// A longhand property.
    Longhand(LonghandId),
    /// A shorthand property.
    Shorthand(ShorthandId),
    /// An alias for a longhand property.
    LonghandAlias(LonghandId, AliasId),
    /// An alias for a shorthand property.
    ShorthandAlias(ShorthandId, AliasId),
    /// A custom property.
    Custom(crate::custom_properties::Name),
}

impl fmt::Debug for PropertyId {
    fn fmt(&self, formatter: &mut fmt::Formatter) -> fmt::Result {
        self.to_css(&mut CssWriter::new(formatter))
    }
}

impl ToCss for PropertyId {
    fn to_css<W>(&self, dest: &mut CssWriter<W>) -> fmt::Result
    where
        W: Write,
    {
        match *self {
            PropertyId::Longhand(id) => dest.write_str(id.name()),
            PropertyId::Shorthand(id) => dest.write_str(id.name()),
            PropertyId::LonghandAlias(id, _) => dest.write_str(id.name()),
            PropertyId::ShorthandAlias(id, _) => dest.write_str(id.name()),
            PropertyId::Custom(ref name) => {
                dest.write_str("--")?;
                serialize_atom_name(name, dest)
            }
        }
    }
}

impl PropertyId {
    /// Return the longhand id that this property id represents.
    #[inline]
    pub fn longhand_id(&self) -> Option<LonghandId> {
        Some(match *self {
            PropertyId::Longhand(id) => id,
            PropertyId::LonghandAlias(id, _) => id,
            _ => return None,
        })
    }

    /// Returns a given property from the string `s`.
    ///
    /// Returns Err(()) for unknown non-custom properties.
    fn parse_unchecked(property_name: &str) -> Result<Self, ()> {
        ascii_case_insensitive_phf_map! {
            property_id -> PropertyId = {
                "align-content" => PropertyId::Longhand(LonghandId::AlignContent),
                "-webkit-align-content" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AlignContent,
                        AliasId::WebkitAlignContent,
                    )
                },
                "align-items" => PropertyId::Longhand(LonghandId::AlignItems),
                "-webkit-align-items" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AlignItems,
                        AliasId::WebkitAlignItems,
                    )
                },
                "align-self" => PropertyId::Longhand(LonghandId::AlignSelf),
                "-webkit-align-self" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AlignSelf,
                        AliasId::WebkitAlignSelf,
                    )
                },
                "backface-visibility" => PropertyId::Longhand(LonghandId::BackfaceVisibility),
                "-moz-backface-visibility" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BackfaceVisibility,
                        AliasId::MozBackfaceVisibility,
                    )
                },
                "-webkit-backface-visibility" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BackfaceVisibility,
                        AliasId::WebkitBackfaceVisibility,
                    )
                },
                "border-collapse" => PropertyId::Longhand(LonghandId::BorderCollapse),
                "border-image-repeat" => PropertyId::Longhand(LonghandId::BorderImageRepeat),
                "box-decoration-break" => PropertyId::Longhand(LonghandId::BoxDecorationBreak),
                "box-sizing" => PropertyId::Longhand(LonghandId::BoxSizing),
                "-moz-box-sizing" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BoxSizing,
                        AliasId::MozBoxSizing,
                    )
                },
                "-webkit-box-sizing" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BoxSizing,
                        AliasId::WebkitBoxSizing,
                    )
                },
                "break-inside" => PropertyId::Longhand(LonghandId::BreakInside),
                "page-break-inside" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BreakInside,
                        AliasId::PageBreakInside,
                    )
                },
                "caption-side" => PropertyId::Longhand(LonghandId::CaptionSide),
                "clear" => PropertyId::Longhand(LonghandId::Clear),
                "color-adjust" => PropertyId::Longhand(LonghandId::ColorAdjust),
                "color-interpolation" => PropertyId::Longhand(LonghandId::ColorInterpolation),
                "color-interpolation-filters" => PropertyId::Longhand(LonghandId::ColorInterpolationFilters),
                "column-count" => PropertyId::Longhand(LonghandId::ColumnCount),
                "-moz-column-count" => {
                    PropertyId::LonghandAlias(
                        LonghandId::ColumnCount,
                        AliasId::MozColumnCount,
                    )
                },
                "column-fill" => PropertyId::Longhand(LonghandId::ColumnFill),
                "-moz-column-fill" => {
                    PropertyId::LonghandAlias(
                        LonghandId::ColumnFill,
                        AliasId::MozColumnFill,
                    )
                },
                "column-span" => PropertyId::Longhand(LonghandId::ColumnSpan),
                "-moz-column-span" => {
                    PropertyId::LonghandAlias(
                        LonghandId::ColumnSpan,
                        AliasId::MozColumnSpan,
                    )
                },
                "contain" => PropertyId::Longhand(LonghandId::Contain),
                "direction" => PropertyId::Longhand(LonghandId::Direction),
                "display" => PropertyId::Longhand(LonghandId::Display),
                "dominant-baseline" => PropertyId::Longhand(LonghandId::DominantBaseline),
                "empty-cells" => PropertyId::Longhand(LonghandId::EmptyCells),
                "flex-direction" => PropertyId::Longhand(LonghandId::FlexDirection),
                "-webkit-flex-direction" => {
                    PropertyId::LonghandAlias(
                        LonghandId::FlexDirection,
                        AliasId::WebkitFlexDirection,
                    )
                },
                "flex-wrap" => PropertyId::Longhand(LonghandId::FlexWrap),
                "-webkit-flex-wrap" => {
                    PropertyId::LonghandAlias(
                        LonghandId::FlexWrap,
                        AliasId::WebkitFlexWrap,
                    )
                },
                "float" => PropertyId::Longhand(LonghandId::Float),
                "font-kerning" => PropertyId::Longhand(LonghandId::FontKerning),
                "font-optical-sizing" => PropertyId::Longhand(LonghandId::FontOpticalSizing),
                "font-size-adjust" => PropertyId::Longhand(LonghandId::FontSizeAdjust),
                "font-stretch" => PropertyId::Longhand(LonghandId::FontStretch),
                "font-style" => PropertyId::Longhand(LonghandId::FontStyle),
                "font-synthesis" => PropertyId::Longhand(LonghandId::FontSynthesis),
                "font-variant-caps" => PropertyId::Longhand(LonghandId::FontVariantCaps),
                "font-variant-east-asian" => PropertyId::Longhand(LonghandId::FontVariantEastAsian),
                "font-variant-ligatures" => PropertyId::Longhand(LonghandId::FontVariantLigatures),
                "font-variant-numeric" => PropertyId::Longhand(LonghandId::FontVariantNumeric),
                "font-variant-position" => PropertyId::Longhand(LonghandId::FontVariantPosition),
                "font-weight" => PropertyId::Longhand(LonghandId::FontWeight),
                "grid-auto-flow" => PropertyId::Longhand(LonghandId::GridAutoFlow),
                "hyphens" => PropertyId::Longhand(LonghandId::Hyphens),
                "-moz-hyphens" => {
                    PropertyId::LonghandAlias(
                        LonghandId::Hyphens,
                        AliasId::MozHyphens,
                    )
                },
                "image-orientation" => PropertyId::Longhand(LonghandId::ImageOrientation),
                "image-rendering" => PropertyId::Longhand(LonghandId::ImageRendering),
                "ime-mode" => PropertyId::Longhand(LonghandId::ImeMode),
                "initial-letter" => PropertyId::Longhand(LonghandId::InitialLetter),
                "isolation" => PropertyId::Longhand(LonghandId::Isolation),
                "justify-content" => PropertyId::Longhand(LonghandId::JustifyContent),
                "-webkit-justify-content" => {
                    PropertyId::LonghandAlias(
                        LonghandId::JustifyContent,
                        AliasId::WebkitJustifyContent,
                    )
                },
                "justify-items" => PropertyId::Longhand(LonghandId::JustifyItems),
                "justify-self" => PropertyId::Longhand(LonghandId::JustifySelf),
                "list-style-position" => PropertyId::Longhand(LonghandId::ListStylePosition),
                "mask-type" => PropertyId::Longhand(LonghandId::MaskType),
                "mix-blend-mode" => PropertyId::Longhand(LonghandId::MixBlendMode),
                "-moz-appearance" => PropertyId::Longhand(LonghandId::MozAppearance),
                "-webkit-appearance" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MozAppearance,
                        AliasId::WebkitAppearance,
                    )
                },
                "-moz-box-align" => PropertyId::Longhand(LonghandId::MozBoxAlign),
                "-webkit-box-align" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MozBoxAlign,
                        AliasId::WebkitBoxAlign,
                    )
                },
                "-moz-box-direction" => PropertyId::Longhand(LonghandId::MozBoxDirection),
                "-webkit-box-direction" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MozBoxDirection,
                        AliasId::WebkitBoxDirection,
                    )
                },
                "-moz-box-orient" => PropertyId::Longhand(LonghandId::MozBoxOrient),
                "-webkit-box-orient" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MozBoxOrient,
                        AliasId::WebkitBoxOrient,
                    )
                },
                "-moz-box-pack" => PropertyId::Longhand(LonghandId::MozBoxPack),
                "-webkit-box-pack" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MozBoxPack,
                        AliasId::WebkitBoxPack,
                    )
                },
                "-moz-control-character-visibility" => PropertyId::Longhand(LonghandId::MozControlCharacterVisibility),
                "-moz-float-edge" => PropertyId::Longhand(LonghandId::MozFloatEdge),
                "-moz-force-broken-image-icon" => PropertyId::Longhand(LonghandId::MozForceBrokenImageIcon),
                "-moz-list-reversed" => PropertyId::Longhand(LonghandId::MozListReversed),
                "-moz-math-display" => PropertyId::Longhand(LonghandId::MozMathDisplay),
                "-moz-math-variant" => PropertyId::Longhand(LonghandId::MozMathVariant),
                "-moz-min-font-size-ratio" => PropertyId::Longhand(LonghandId::MozMinFontSizeRatio),
                "-moz-orient" => PropertyId::Longhand(LonghandId::MozOrient),
                "-moz-osx-font-smoothing" => PropertyId::Longhand(LonghandId::MozOsxFontSmoothing),
                "-moz-script-level" => PropertyId::Longhand(LonghandId::MozScriptLevel),
                "-moz-script-min-size" => PropertyId::Longhand(LonghandId::MozScriptMinSize),
                "-moz-script-size-multiplier" => PropertyId::Longhand(LonghandId::MozScriptSizeMultiplier),
                "-moz-stack-sizing" => PropertyId::Longhand(LonghandId::MozStackSizing),
                "-moz-text-size-adjust" => PropertyId::Longhand(LonghandId::MozTextSizeAdjust),
                "-webkit-text-size-adjust" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MozTextSizeAdjust,
                        AliasId::WebkitTextSizeAdjust,
                    )
                },
                "-moz-top-layer" => PropertyId::Longhand(LonghandId::MozTopLayer),
                "-moz-user-focus" => PropertyId::Longhand(LonghandId::MozUserFocus),
                "-moz-user-input" => PropertyId::Longhand(LonghandId::MozUserInput),
                "-moz-user-modify" => PropertyId::Longhand(LonghandId::MozUserModify),
                "-moz-user-select" => PropertyId::Longhand(LonghandId::MozUserSelect),
                "-webkit-user-select" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MozUserSelect,
                        AliasId::WebkitUserSelect,
                    )
                },
                "-moz-window-dragging" => PropertyId::Longhand(LonghandId::MozWindowDragging),
                "-moz-window-shadow" => PropertyId::Longhand(LonghandId::MozWindowShadow),
                "object-fit" => PropertyId::Longhand(LonghandId::ObjectFit),
                "outline-style" => PropertyId::Longhand(LonghandId::OutlineStyle),
                "overflow-anchor" => PropertyId::Longhand(LonghandId::OverflowAnchor),
                "overflow-wrap" => PropertyId::Longhand(LonghandId::OverflowWrap),
                "word-wrap" => {
                    PropertyId::LonghandAlias(
                        LonghandId::OverflowWrap,
                        AliasId::WordWrap,
                    )
                },
                "paint-order" => PropertyId::Longhand(LonghandId::PaintOrder),
                "pointer-events" => PropertyId::Longhand(LonghandId::PointerEvents),
                "position" => PropertyId::Longhand(LonghandId::Position),
                "resize" => PropertyId::Longhand(LonghandId::Resize),
                "ruby-align" => PropertyId::Longhand(LonghandId::RubyAlign),
                "ruby-position" => PropertyId::Longhand(LonghandId::RubyPosition),
                "scroll-behavior" => PropertyId::Longhand(LonghandId::ScrollBehavior),
                "scroll-snap-align" => PropertyId::Longhand(LonghandId::ScrollSnapAlign),
                "scroll-snap-type" => PropertyId::Longhand(LonghandId::ScrollSnapType),
                "scrollbar-width" => PropertyId::Longhand(LonghandId::ScrollbarWidth),
                "shape-rendering" => PropertyId::Longhand(LonghandId::ShapeRendering),
                "stroke-linecap" => PropertyId::Longhand(LonghandId::StrokeLinecap),
                "stroke-linejoin" => PropertyId::Longhand(LonghandId::StrokeLinejoin),
                "table-layout" => PropertyId::Longhand(LonghandId::TableLayout),
                "text-align" => PropertyId::Longhand(LonghandId::TextAlign),
                "text-align-last" => PropertyId::Longhand(LonghandId::TextAlignLast),
                "text-anchor" => PropertyId::Longhand(LonghandId::TextAnchor),
                "text-combine-upright" => PropertyId::Longhand(LonghandId::TextCombineUpright),
                "text-decoration-line" => PropertyId::Longhand(LonghandId::TextDecorationLine),
                "text-decoration-style" => PropertyId::Longhand(LonghandId::TextDecorationStyle),
                "text-emphasis-position" => PropertyId::Longhand(LonghandId::TextEmphasisPosition),
                "text-justify" => PropertyId::Longhand(LonghandId::TextJustify),
                "text-orientation" => PropertyId::Longhand(LonghandId::TextOrientation),
                "text-rendering" => PropertyId::Longhand(LonghandId::TextRendering),
                "text-transform" => PropertyId::Longhand(LonghandId::TextTransform),
                "touch-action" => PropertyId::Longhand(LonghandId::TouchAction),
                "transform-box" => PropertyId::Longhand(LonghandId::TransformBox),
                "transform-style" => PropertyId::Longhand(LonghandId::TransformStyle),
                "-moz-transform-style" => {
                    PropertyId::LonghandAlias(
                        LonghandId::TransformStyle,
                        AliasId::MozTransformStyle,
                    )
                },
                "-webkit-transform-style" => {
                    PropertyId::LonghandAlias(
                        LonghandId::TransformStyle,
                        AliasId::WebkitTransformStyle,
                    )
                },
                "unicode-bidi" => PropertyId::Longhand(LonghandId::UnicodeBidi),
                "vector-effect" => PropertyId::Longhand(LonghandId::VectorEffect),
                "visibility" => PropertyId::Longhand(LonghandId::Visibility),
                "-webkit-line-clamp" => PropertyId::Longhand(LonghandId::WebkitLineClamp),
                "white-space" => PropertyId::Longhand(LonghandId::WhiteSpace),
                "word-break" => PropertyId::Longhand(LonghandId::WordBreak),
                "writing-mode" => PropertyId::Longhand(LonghandId::WritingMode),
                "-x-span" => PropertyId::Longhand(LonghandId::XSpan),
                "-x-text-zoom" => PropertyId::Longhand(LonghandId::XTextZoom),
                "z-index" => PropertyId::Longhand(LonghandId::ZIndex),
                "break-after" => PropertyId::Longhand(LonghandId::BreakAfter),
                "break-before" => PropertyId::Longhand(LonghandId::BreakBefore),
                "clip-rule" => PropertyId::Longhand(LonghandId::ClipRule),
                "fill-rule" => PropertyId::Longhand(LonghandId::FillRule),
                "-moz-box-ordinal-group" => PropertyId::Longhand(LonghandId::MozBoxOrdinalGroup),
                "-webkit-box-ordinal-group" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MozBoxOrdinalGroup,
                        AliasId::WebkitBoxOrdinalGroup,
                    )
                },
                "order" => PropertyId::Longhand(LonghandId::Order),
                "-webkit-order" => {
                    PropertyId::LonghandAlias(
                        LonghandId::Order,
                        AliasId::WebkitOrder,
                    )
                },
                "overflow-x" => PropertyId::Longhand(LonghandId::OverflowX),
                "overflow-y" => PropertyId::Longhand(LonghandId::OverflowY),
                "overflow-clip-box-block" => PropertyId::Longhand(LonghandId::OverflowClipBoxBlock),
                "overflow-clip-box-inline" => PropertyId::Longhand(LonghandId::OverflowClipBoxInline),
                "overscroll-behavior-x" => PropertyId::Longhand(LonghandId::OverscrollBehaviorX),
                "overscroll-behavior-y" => PropertyId::Longhand(LonghandId::OverscrollBehaviorY),
                "fill-opacity" => PropertyId::Longhand(LonghandId::FillOpacity),
                "stroke-opacity" => PropertyId::Longhand(LonghandId::StrokeOpacity),
                "flex-grow" => PropertyId::Longhand(LonghandId::FlexGrow),
                "-webkit-flex-grow" => {
                    PropertyId::LonghandAlias(
                        LonghandId::FlexGrow,
                        AliasId::WebkitFlexGrow,
                    )
                },
                "flex-shrink" => PropertyId::Longhand(LonghandId::FlexShrink),
                "-webkit-flex-shrink" => {
                    PropertyId::LonghandAlias(
                        LonghandId::FlexShrink,
                        AliasId::WebkitFlexShrink,
                    )
                },
                "-moz-box-flex" => PropertyId::Longhand(LonghandId::MozBoxFlex),
                "-webkit-box-flex" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MozBoxFlex,
                        AliasId::WebkitBoxFlex,
                    )
                },
                "stroke-miterlimit" => PropertyId::Longhand(LonghandId::StrokeMiterlimit),
                "flood-opacity" => PropertyId::Longhand(LonghandId::FloodOpacity),
                "-moz-window-opacity" => PropertyId::Longhand(LonghandId::MozWindowOpacity),
                "opacity" => PropertyId::Longhand(LonghandId::Opacity),
                "shape-image-threshold" => PropertyId::Longhand(LonghandId::ShapeImageThreshold),
                "stop-opacity" => PropertyId::Longhand(LonghandId::StopOpacity),
                "border-block-end-style" => PropertyId::Longhand(LonghandId::BorderBlockEndStyle),
                "border-block-start-style" => PropertyId::Longhand(LonghandId::BorderBlockStartStyle),
                "border-bottom-style" => PropertyId::Longhand(LonghandId::BorderBottomStyle),
                "border-inline-end-style" => PropertyId::Longhand(LonghandId::BorderInlineEndStyle),
                "-moz-border-end-style" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BorderInlineEndStyle,
                        AliasId::MozBorderEndStyle,
                    )
                },
                "border-inline-start-style" => PropertyId::Longhand(LonghandId::BorderInlineStartStyle),
                "-moz-border-start-style" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BorderInlineStartStyle,
                        AliasId::MozBorderStartStyle,
                    )
                },
                "border-left-style" => PropertyId::Longhand(LonghandId::BorderLeftStyle),
                "border-right-style" => PropertyId::Longhand(LonghandId::BorderRightStyle),
                "border-top-style" => PropertyId::Longhand(LonghandId::BorderTopStyle),
                "column-rule-style" => PropertyId::Longhand(LonghandId::ColumnRuleStyle),
                "-moz-column-rule-style" => {
                    PropertyId::LonghandAlias(
                        LonghandId::ColumnRuleStyle,
                        AliasId::MozColumnRuleStyle,
                    )
                },
                "animation-delay" => PropertyId::Longhand(LonghandId::AnimationDelay),
                "-moz-animation-delay" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AnimationDelay,
                        AliasId::MozAnimationDelay,
                    )
                },
                "-webkit-animation-delay" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AnimationDelay,
                        AliasId::WebkitAnimationDelay,
                    )
                },
                "animation-direction" => PropertyId::Longhand(LonghandId::AnimationDirection),
                "-moz-animation-direction" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AnimationDirection,
                        AliasId::MozAnimationDirection,
                    )
                },
                "-webkit-animation-direction" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AnimationDirection,
                        AliasId::WebkitAnimationDirection,
                    )
                },
                "animation-duration" => PropertyId::Longhand(LonghandId::AnimationDuration),
                "-moz-animation-duration" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AnimationDuration,
                        AliasId::MozAnimationDuration,
                    )
                },
                "-webkit-animation-duration" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AnimationDuration,
                        AliasId::WebkitAnimationDuration,
                    )
                },
                "animation-fill-mode" => PropertyId::Longhand(LonghandId::AnimationFillMode),
                "-moz-animation-fill-mode" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AnimationFillMode,
                        AliasId::MozAnimationFillMode,
                    )
                },
                "-webkit-animation-fill-mode" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AnimationFillMode,
                        AliasId::WebkitAnimationFillMode,
                    )
                },
                "animation-iteration-count" => PropertyId::Longhand(LonghandId::AnimationIterationCount),
                "-moz-animation-iteration-count" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AnimationIterationCount,
                        AliasId::MozAnimationIterationCount,
                    )
                },
                "-webkit-animation-iteration-count" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AnimationIterationCount,
                        AliasId::WebkitAnimationIterationCount,
                    )
                },
                "animation-name" => PropertyId::Longhand(LonghandId::AnimationName),
                "-moz-animation-name" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AnimationName,
                        AliasId::MozAnimationName,
                    )
                },
                "-webkit-animation-name" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AnimationName,
                        AliasId::WebkitAnimationName,
                    )
                },
                "animation-play-state" => PropertyId::Longhand(LonghandId::AnimationPlayState),
                "-moz-animation-play-state" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AnimationPlayState,
                        AliasId::MozAnimationPlayState,
                    )
                },
                "-webkit-animation-play-state" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AnimationPlayState,
                        AliasId::WebkitAnimationPlayState,
                    )
                },
                "animation-timing-function" => PropertyId::Longhand(LonghandId::AnimationTimingFunction),
                "-moz-animation-timing-function" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AnimationTimingFunction,
                        AliasId::MozAnimationTimingFunction,
                    )
                },
                "-webkit-animation-timing-function" => {
                    PropertyId::LonghandAlias(
                        LonghandId::AnimationTimingFunction,
                        AliasId::WebkitAnimationTimingFunction,
                    )
                },
                "background-attachment" => PropertyId::Longhand(LonghandId::BackgroundAttachment),
                "background-blend-mode" => PropertyId::Longhand(LonghandId::BackgroundBlendMode),
                "background-clip" => PropertyId::Longhand(LonghandId::BackgroundClip),
                "-webkit-background-clip" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BackgroundClip,
                        AliasId::WebkitBackgroundClip,
                    )
                },
                "background-image" => PropertyId::Longhand(LonghandId::BackgroundImage),
                "background-origin" => PropertyId::Longhand(LonghandId::BackgroundOrigin),
                "-webkit-background-origin" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BackgroundOrigin,
                        AliasId::WebkitBackgroundOrigin,
                    )
                },
                "background-position-x" => PropertyId::Longhand(LonghandId::BackgroundPositionX),
                "background-position-y" => PropertyId::Longhand(LonghandId::BackgroundPositionY),
                "background-repeat" => PropertyId::Longhand(LonghandId::BackgroundRepeat),
                "background-size" => PropertyId::Longhand(LonghandId::BackgroundSize),
                "-webkit-background-size" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BackgroundSize,
                        AliasId::WebkitBackgroundSize,
                    )
                },
                "border-image-outset" => PropertyId::Longhand(LonghandId::BorderImageOutset),
                "border-image-slice" => PropertyId::Longhand(LonghandId::BorderImageSlice),
                "border-image-source" => PropertyId::Longhand(LonghandId::BorderImageSource),
                "border-image-width" => PropertyId::Longhand(LonghandId::BorderImageWidth),
                "border-spacing" => PropertyId::Longhand(LonghandId::BorderSpacing),
                "box-shadow" => PropertyId::Longhand(LonghandId::BoxShadow),
                "-webkit-box-shadow" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BoxShadow,
                        AliasId::WebkitBoxShadow,
                    )
                },
                "caret-color" => PropertyId::Longhand(LonghandId::CaretColor),
                "clip-path" => PropertyId::Longhand(LonghandId::ClipPath),
                "color" => PropertyId::Longhand(LonghandId::Color),
                "column-width" => PropertyId::Longhand(LonghandId::ColumnWidth),
                "-moz-column-width" => {
                    PropertyId::LonghandAlias(
                        LonghandId::ColumnWidth,
                        AliasId::MozColumnWidth,
                    )
                },
                "content" => PropertyId::Longhand(LonghandId::Content),
                "counter-increment" => PropertyId::Longhand(LonghandId::CounterIncrement),
                "cursor" => PropertyId::Longhand(LonghandId::Cursor),
                "filter" => PropertyId::Longhand(LonghandId::Filter),
                "-webkit-filter" => {
                    PropertyId::LonghandAlias(
                        LonghandId::Filter,
                        AliasId::WebkitFilter,
                    )
                },
                "flex-basis" => PropertyId::Longhand(LonghandId::FlexBasis),
                "-webkit-flex-basis" => {
                    PropertyId::LonghandAlias(
                        LonghandId::FlexBasis,
                        AliasId::WebkitFlexBasis,
                    )
                },
                "font-family" => PropertyId::Longhand(LonghandId::FontFamily),
                "font-feature-settings" => PropertyId::Longhand(LonghandId::FontFeatureSettings),
                "-moz-font-feature-settings" => {
                    PropertyId::LonghandAlias(
                        LonghandId::FontFeatureSettings,
                        AliasId::MozFontFeatureSettings,
                    )
                },
                "font-language-override" => PropertyId::Longhand(LonghandId::FontLanguageOverride),
                "-moz-font-language-override" => {
                    PropertyId::LonghandAlias(
                        LonghandId::FontLanguageOverride,
                        AliasId::MozFontLanguageOverride,
                    )
                },
                "font-size" => PropertyId::Longhand(LonghandId::FontSize),
                "font-variant-alternates" => PropertyId::Longhand(LonghandId::FontVariantAlternates),
                "font-variation-settings" => PropertyId::Longhand(LonghandId::FontVariationSettings),
                "grid-template-areas" => PropertyId::Longhand(LonghandId::GridTemplateAreas),
                "letter-spacing" => PropertyId::Longhand(LonghandId::LetterSpacing),
                "line-height" => PropertyId::Longhand(LonghandId::LineHeight),
                "list-style-image" => PropertyId::Longhand(LonghandId::ListStyleImage),
                "list-style-type" => PropertyId::Longhand(LonghandId::ListStyleType),
                "mask-clip" => PropertyId::Longhand(LonghandId::MaskClip),
                "-webkit-mask-clip" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MaskClip,
                        AliasId::WebkitMaskClip,
                    )
                },
                "mask-composite" => PropertyId::Longhand(LonghandId::MaskComposite),
                "-webkit-mask-composite" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MaskComposite,
                        AliasId::WebkitMaskComposite,
                    )
                },
                "mask-image" => PropertyId::Longhand(LonghandId::MaskImage),
                "-webkit-mask-image" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MaskImage,
                        AliasId::WebkitMaskImage,
                    )
                },
                "mask-mode" => PropertyId::Longhand(LonghandId::MaskMode),
                "mask-origin" => PropertyId::Longhand(LonghandId::MaskOrigin),
                "-webkit-mask-origin" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MaskOrigin,
                        AliasId::WebkitMaskOrigin,
                    )
                },
                "mask-position-x" => PropertyId::Longhand(LonghandId::MaskPositionX),
                "-webkit-mask-position-x" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MaskPositionX,
                        AliasId::WebkitMaskPositionX,
                    )
                },
                "mask-position-y" => PropertyId::Longhand(LonghandId::MaskPositionY),
                "-webkit-mask-position-y" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MaskPositionY,
                        AliasId::WebkitMaskPositionY,
                    )
                },
                "mask-repeat" => PropertyId::Longhand(LonghandId::MaskRepeat),
                "-webkit-mask-repeat" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MaskRepeat,
                        AliasId::WebkitMaskRepeat,
                    )
                },
                "mask-size" => PropertyId::Longhand(LonghandId::MaskSize),
                "-webkit-mask-size" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MaskSize,
                        AliasId::WebkitMaskSize,
                    )
                },
                "-moz-context-properties" => PropertyId::Longhand(LonghandId::MozContextProperties),
                "-moz-font-smoothing-background-color" => PropertyId::Longhand(LonghandId::MozFontSmoothingBackgroundColor),
                "-moz-tab-size" => PropertyId::Longhand(LonghandId::MozTabSize),
                "offset-path" => PropertyId::Longhand(LonghandId::OffsetPath),
                "perspective" => PropertyId::Longhand(LonghandId::Perspective),
                "-moz-perspective" => {
                    PropertyId::LonghandAlias(
                        LonghandId::Perspective,
                        AliasId::MozPerspective,
                    )
                },
                "-webkit-perspective" => {
                    PropertyId::LonghandAlias(
                        LonghandId::Perspective,
                        AliasId::WebkitPerspective,
                    )
                },
                "quotes" => PropertyId::Longhand(LonghandId::Quotes),
                "rotate" => PropertyId::Longhand(LonghandId::Rotate),
                "scale" => PropertyId::Longhand(LonghandId::Scale),
                "scroll-snap-coordinate" => PropertyId::Longhand(LonghandId::ScrollSnapCoordinate),
                "scrollbar-color" => PropertyId::Longhand(LonghandId::ScrollbarColor),
                "shape-outside" => PropertyId::Longhand(LonghandId::ShapeOutside),
                "stroke-dasharray" => PropertyId::Longhand(LonghandId::StrokeDasharray),
                "stroke-dashoffset" => PropertyId::Longhand(LonghandId::StrokeDashoffset),
                "stroke-width" => PropertyId::Longhand(LonghandId::StrokeWidth),
                "text-emphasis-style" => PropertyId::Longhand(LonghandId::TextEmphasisStyle),
                "text-indent" => PropertyId::Longhand(LonghandId::TextIndent),
                "text-overflow" => PropertyId::Longhand(LonghandId::TextOverflow),
                "text-shadow" => PropertyId::Longhand(LonghandId::TextShadow),
                "transition-delay" => PropertyId::Longhand(LonghandId::TransitionDelay),
                "-moz-transition-delay" => {
                    PropertyId::LonghandAlias(
                        LonghandId::TransitionDelay,
                        AliasId::MozTransitionDelay,
                    )
                },
                "-webkit-transition-delay" => {
                    PropertyId::LonghandAlias(
                        LonghandId::TransitionDelay,
                        AliasId::WebkitTransitionDelay,
                    )
                },
                "transition-duration" => PropertyId::Longhand(LonghandId::TransitionDuration),
                "-moz-transition-duration" => {
                    PropertyId::LonghandAlias(
                        LonghandId::TransitionDuration,
                        AliasId::MozTransitionDuration,
                    )
                },
                "-webkit-transition-duration" => {
                    PropertyId::LonghandAlias(
                        LonghandId::TransitionDuration,
                        AliasId::WebkitTransitionDuration,
                    )
                },
                "transition-property" => PropertyId::Longhand(LonghandId::TransitionProperty),
                "-moz-transition-property" => {
                    PropertyId::LonghandAlias(
                        LonghandId::TransitionProperty,
                        AliasId::MozTransitionProperty,
                    )
                },
                "-webkit-transition-property" => {
                    PropertyId::LonghandAlias(
                        LonghandId::TransitionProperty,
                        AliasId::WebkitTransitionProperty,
                    )
                },
                "transition-timing-function" => PropertyId::Longhand(LonghandId::TransitionTimingFunction),
                "-moz-transition-timing-function" => {
                    PropertyId::LonghandAlias(
                        LonghandId::TransitionTimingFunction,
                        AliasId::MozTransitionTimingFunction,
                    )
                },
                "-webkit-transition-timing-function" => {
                    PropertyId::LonghandAlias(
                        LonghandId::TransitionTimingFunction,
                        AliasId::WebkitTransitionTimingFunction,
                    )
                },
                "translate" => PropertyId::Longhand(LonghandId::Translate),
                "vertical-align" => PropertyId::Longhand(LonghandId::VerticalAlign),
                "will-change" => PropertyId::Longhand(LonghandId::WillChange),
                "word-spacing" => PropertyId::Longhand(LonghandId::WordSpacing),
                "-x-lang" => PropertyId::Longhand(LonghandId::XLang),
                "clip" => PropertyId::Longhand(LonghandId::Clip),
                "-moz-image-region" => PropertyId::Longhand(LonghandId::MozImageRegion),
                "grid-template-columns" => PropertyId::Longhand(LonghandId::GridTemplateColumns),
                "grid-template-rows" => PropertyId::Longhand(LonghandId::GridTemplateRows),
                "fill" => PropertyId::Longhand(LonghandId::Fill),
                "stroke" => PropertyId::Longhand(LonghandId::Stroke),
                "grid-auto-columns" => PropertyId::Longhand(LonghandId::GridAutoColumns),
                "grid-auto-rows" => PropertyId::Longhand(LonghandId::GridAutoRows),
                "-moz-window-transform-origin" => PropertyId::Longhand(LonghandId::MozWindowTransformOrigin),
                "transform-origin" => PropertyId::Longhand(LonghandId::TransformOrigin),
                "-moz-transform-origin" => {
                    PropertyId::LonghandAlias(
                        LonghandId::TransformOrigin,
                        AliasId::MozTransformOrigin,
                    )
                },
                "-webkit-transform-origin" => {
                    PropertyId::LonghandAlias(
                        LonghandId::TransformOrigin,
                        AliasId::WebkitTransformOrigin,
                    )
                },
                "counter-reset" => PropertyId::Longhand(LonghandId::CounterReset),
                "counter-set" => PropertyId::Longhand(LonghandId::CounterSet),
                "scroll-snap-points-x" => PropertyId::Longhand(LonghandId::ScrollSnapPointsX),
                "scroll-snap-points-y" => PropertyId::Longhand(LonghandId::ScrollSnapPointsY),
                "-moz-window-transform" => PropertyId::Longhand(LonghandId::MozWindowTransform),
                "transform" => PropertyId::Longhand(LonghandId::Transform),
                "-moz-transform" => {
                    PropertyId::LonghandAlias(
                        LonghandId::Transform,
                        AliasId::MozTransform,
                    )
                },
                "-webkit-transform" => {
                    PropertyId::LonghandAlias(
                        LonghandId::Transform,
                        AliasId::WebkitTransform,
                    )
                },
                "column-gap" => PropertyId::Longhand(LonghandId::ColumnGap),
                "grid-column-gap" => {
                    PropertyId::LonghandAlias(
                        LonghandId::ColumnGap,
                        AliasId::GridColumnGap,
                    )
                },
                "-moz-column-gap" => {
                    PropertyId::LonghandAlias(
                        LonghandId::ColumnGap,
                        AliasId::MozColumnGap,
                    )
                },
                "row-gap" => PropertyId::Longhand(LonghandId::RowGap),
                "grid-row-gap" => {
                    PropertyId::LonghandAlias(
                        LonghandId::RowGap,
                        AliasId::GridRowGap,
                    )
                },
                "object-position" => PropertyId::Longhand(LonghandId::ObjectPosition),
                "perspective-origin" => PropertyId::Longhand(LonghandId::PerspectiveOrigin),
                "-moz-perspective-origin" => {
                    PropertyId::LonghandAlias(
                        LonghandId::PerspectiveOrigin,
                        AliasId::MozPerspectiveOrigin,
                    )
                },
                "-webkit-perspective-origin" => {
                    PropertyId::LonghandAlias(
                        LonghandId::PerspectiveOrigin,
                        AliasId::WebkitPerspectiveOrigin,
                    )
                },
                "scroll-snap-destination" => PropertyId::Longhand(LonghandId::ScrollSnapDestination),
                "grid-column-end" => PropertyId::Longhand(LonghandId::GridColumnEnd),
                "grid-column-start" => PropertyId::Longhand(LonghandId::GridColumnStart),
                "grid-row-end" => PropertyId::Longhand(LonghandId::GridRowEnd),
                "grid-row-start" => PropertyId::Longhand(LonghandId::GridRowStart),
                "max-block-size" => PropertyId::Longhand(LonghandId::MaxBlockSize),
                "max-height" => PropertyId::Longhand(LonghandId::MaxHeight),
                "max-inline-size" => PropertyId::Longhand(LonghandId::MaxInlineSize),
                "max-width" => PropertyId::Longhand(LonghandId::MaxWidth),
                "marker-end" => PropertyId::Longhand(LonghandId::MarkerEnd),
                "marker-mid" => PropertyId::Longhand(LonghandId::MarkerMid),
                "marker-start" => PropertyId::Longhand(LonghandId::MarkerStart),
                "-moz-binding" => PropertyId::Longhand(LonghandId::MozBinding),
                "scroll-padding-block-end" => PropertyId::Longhand(LonghandId::ScrollPaddingBlockEnd),
                "scroll-padding-block-start" => PropertyId::Longhand(LonghandId::ScrollPaddingBlockStart),
                "scroll-padding-bottom" => PropertyId::Longhand(LonghandId::ScrollPaddingBottom),
                "scroll-padding-inline-end" => PropertyId::Longhand(LonghandId::ScrollPaddingInlineEnd),
                "scroll-padding-inline-start" => PropertyId::Longhand(LonghandId::ScrollPaddingInlineStart),
                "scroll-padding-left" => PropertyId::Longhand(LonghandId::ScrollPaddingLeft),
                "scroll-padding-right" => PropertyId::Longhand(LonghandId::ScrollPaddingRight),
                "scroll-padding-top" => PropertyId::Longhand(LonghandId::ScrollPaddingTop),
                "block-size" => PropertyId::Longhand(LonghandId::BlockSize),
                "height" => PropertyId::Longhand(LonghandId::Height),
                "inline-size" => PropertyId::Longhand(LonghandId::InlineSize),
                "min-block-size" => PropertyId::Longhand(LonghandId::MinBlockSize),
                "min-height" => PropertyId::Longhand(LonghandId::MinHeight),
                "min-inline-size" => PropertyId::Longhand(LonghandId::MinInlineSize),
                "min-width" => PropertyId::Longhand(LonghandId::MinWidth),
                "width" => PropertyId::Longhand(LonghandId::Width),
                "outline-offset" => PropertyId::Longhand(LonghandId::OutlineOffset),
                "scroll-margin-block-end" => PropertyId::Longhand(LonghandId::ScrollMarginBlockEnd),
                "scroll-margin-block-start" => PropertyId::Longhand(LonghandId::ScrollMarginBlockStart),
                "scroll-margin-bottom" => PropertyId::Longhand(LonghandId::ScrollMarginBottom),
                "scroll-margin-inline-end" => PropertyId::Longhand(LonghandId::ScrollMarginInlineEnd),
                "scroll-margin-inline-start" => PropertyId::Longhand(LonghandId::ScrollMarginInlineStart),
                "scroll-margin-left" => PropertyId::Longhand(LonghandId::ScrollMarginLeft),
                "scroll-margin-right" => PropertyId::Longhand(LonghandId::ScrollMarginRight),
                "scroll-margin-top" => PropertyId::Longhand(LonghandId::ScrollMarginTop),
                "padding-block-end" => PropertyId::Longhand(LonghandId::PaddingBlockEnd),
                "padding-block-start" => PropertyId::Longhand(LonghandId::PaddingBlockStart),
                "padding-bottom" => PropertyId::Longhand(LonghandId::PaddingBottom),
                "padding-inline-end" => PropertyId::Longhand(LonghandId::PaddingInlineEnd),
                "-moz-padding-end" => {
                    PropertyId::LonghandAlias(
                        LonghandId::PaddingInlineEnd,
                        AliasId::MozPaddingEnd,
                    )
                },
                "padding-inline-start" => PropertyId::Longhand(LonghandId::PaddingInlineStart),
                "-moz-padding-start" => {
                    PropertyId::LonghandAlias(
                        LonghandId::PaddingInlineStart,
                        AliasId::MozPaddingStart,
                    )
                },
                "padding-left" => PropertyId::Longhand(LonghandId::PaddingLeft),
                "padding-right" => PropertyId::Longhand(LonghandId::PaddingRight),
                "padding-top" => PropertyId::Longhand(LonghandId::PaddingTop),
                "shape-margin" => PropertyId::Longhand(LonghandId::ShapeMargin),
                "border-block-end-width" => PropertyId::Longhand(LonghandId::BorderBlockEndWidth),
                "border-block-start-width" => PropertyId::Longhand(LonghandId::BorderBlockStartWidth),
                "border-bottom-width" => PropertyId::Longhand(LonghandId::BorderBottomWidth),
                "border-inline-end-width" => PropertyId::Longhand(LonghandId::BorderInlineEndWidth),
                "-moz-border-end-width" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BorderInlineEndWidth,
                        AliasId::MozBorderEndWidth,
                    )
                },
                "border-inline-start-width" => PropertyId::Longhand(LonghandId::BorderInlineStartWidth),
                "-moz-border-start-width" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BorderInlineStartWidth,
                        AliasId::MozBorderStartWidth,
                    )
                },
                "border-left-width" => PropertyId::Longhand(LonghandId::BorderLeftWidth),
                "border-right-width" => PropertyId::Longhand(LonghandId::BorderRightWidth),
                "border-top-width" => PropertyId::Longhand(LonghandId::BorderTopWidth),
                "column-rule-width" => PropertyId::Longhand(LonghandId::ColumnRuleWidth),
                "-moz-column-rule-width" => {
                    PropertyId::LonghandAlias(
                        LonghandId::ColumnRuleWidth,
                        AliasId::MozColumnRuleWidth,
                    )
                },
                "outline-width" => PropertyId::Longhand(LonghandId::OutlineWidth),
                "-webkit-text-stroke-width" => PropertyId::Longhand(LonghandId::WebkitTextStrokeWidth),
                "border-bottom-left-radius" => PropertyId::Longhand(LonghandId::BorderBottomLeftRadius),
                "-webkit-border-bottom-left-radius" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BorderBottomLeftRadius,
                        AliasId::WebkitBorderBottomLeftRadius,
                    )
                },
                "border-bottom-right-radius" => PropertyId::Longhand(LonghandId::BorderBottomRightRadius),
                "-webkit-border-bottom-right-radius" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BorderBottomRightRadius,
                        AliasId::WebkitBorderBottomRightRadius,
                    )
                },
                "border-end-end-radius" => PropertyId::Longhand(LonghandId::BorderEndEndRadius),
                "border-end-start-radius" => PropertyId::Longhand(LonghandId::BorderEndStartRadius),
                "border-start-end-radius" => PropertyId::Longhand(LonghandId::BorderStartEndRadius),
                "border-start-start-radius" => PropertyId::Longhand(LonghandId::BorderStartStartRadius),
                "border-top-left-radius" => PropertyId::Longhand(LonghandId::BorderTopLeftRadius),
                "-webkit-border-top-left-radius" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BorderTopLeftRadius,
                        AliasId::WebkitBorderTopLeftRadius,
                    )
                },
                "border-top-right-radius" => PropertyId::Longhand(LonghandId::BorderTopRightRadius),
                "-webkit-border-top-right-radius" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BorderTopRightRadius,
                        AliasId::WebkitBorderTopRightRadius,
                    )
                },
                "-moz-outline-radius-bottomleft" => PropertyId::Longhand(LonghandId::MozOutlineRadiusBottomleft),
                "-moz-outline-radius-bottomright" => PropertyId::Longhand(LonghandId::MozOutlineRadiusBottomright),
                "-moz-outline-radius-topleft" => PropertyId::Longhand(LonghandId::MozOutlineRadiusTopleft),
                "-moz-outline-radius-topright" => PropertyId::Longhand(LonghandId::MozOutlineRadiusTopright),
                "bottom" => PropertyId::Longhand(LonghandId::Bottom),
                "inset-block-end" => PropertyId::Longhand(LonghandId::InsetBlockEnd),
                "offset-block-end" => {
                    PropertyId::LonghandAlias(
                        LonghandId::InsetBlockEnd,
                        AliasId::OffsetBlockEnd,
                    )
                },
                "inset-block-start" => PropertyId::Longhand(LonghandId::InsetBlockStart),
                "offset-block-start" => {
                    PropertyId::LonghandAlias(
                        LonghandId::InsetBlockStart,
                        AliasId::OffsetBlockStart,
                    )
                },
                "inset-inline-end" => PropertyId::Longhand(LonghandId::InsetInlineEnd),
                "offset-inline-end" => {
                    PropertyId::LonghandAlias(
                        LonghandId::InsetInlineEnd,
                        AliasId::OffsetInlineEnd,
                    )
                },
                "inset-inline-start" => PropertyId::Longhand(LonghandId::InsetInlineStart),
                "offset-inline-start" => {
                    PropertyId::LonghandAlias(
                        LonghandId::InsetInlineStart,
                        AliasId::OffsetInlineStart,
                    )
                },
                "left" => PropertyId::Longhand(LonghandId::Left),
                "margin-block-end" => PropertyId::Longhand(LonghandId::MarginBlockEnd),
                "margin-block-start" => PropertyId::Longhand(LonghandId::MarginBlockStart),
                "margin-bottom" => PropertyId::Longhand(LonghandId::MarginBottom),
                "margin-inline-end" => PropertyId::Longhand(LonghandId::MarginInlineEnd),
                "-moz-margin-end" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MarginInlineEnd,
                        AliasId::MozMarginEnd,
                    )
                },
                "margin-inline-start" => PropertyId::Longhand(LonghandId::MarginInlineStart),
                "-moz-margin-start" => {
                    PropertyId::LonghandAlias(
                        LonghandId::MarginInlineStart,
                        AliasId::MozMarginStart,
                    )
                },
                "margin-left" => PropertyId::Longhand(LonghandId::MarginLeft),
                "margin-right" => PropertyId::Longhand(LonghandId::MarginRight),
                "margin-top" => PropertyId::Longhand(LonghandId::MarginTop),
                "right" => PropertyId::Longhand(LonghandId::Right),
                "top" => PropertyId::Longhand(LonghandId::Top),
                "background-color" => PropertyId::Longhand(LonghandId::BackgroundColor),
                "border-block-end-color" => PropertyId::Longhand(LonghandId::BorderBlockEndColor),
                "border-block-start-color" => PropertyId::Longhand(LonghandId::BorderBlockStartColor),
                "border-bottom-color" => PropertyId::Longhand(LonghandId::BorderBottomColor),
                "border-inline-end-color" => PropertyId::Longhand(LonghandId::BorderInlineEndColor),
                "-moz-border-end-color" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BorderInlineEndColor,
                        AliasId::MozBorderEndColor,
                    )
                },
                "border-inline-start-color" => PropertyId::Longhand(LonghandId::BorderInlineStartColor),
                "-moz-border-start-color" => {
                    PropertyId::LonghandAlias(
                        LonghandId::BorderInlineStartColor,
                        AliasId::MozBorderStartColor,
                    )
                },
                "border-left-color" => PropertyId::Longhand(LonghandId::BorderLeftColor),
                "border-right-color" => PropertyId::Longhand(LonghandId::BorderRightColor),
                "border-top-color" => PropertyId::Longhand(LonghandId::BorderTopColor),
                "column-rule-color" => PropertyId::Longhand(LonghandId::ColumnRuleColor),
                "-moz-column-rule-color" => {
                    PropertyId::LonghandAlias(
                        LonghandId::ColumnRuleColor,
                        AliasId::MozColumnRuleColor,
                    )
                },
                "flood-color" => PropertyId::Longhand(LonghandId::FloodColor),
                "lighting-color" => PropertyId::Longhand(LonghandId::LightingColor),
                "outline-color" => PropertyId::Longhand(LonghandId::OutlineColor),
                "stop-color" => PropertyId::Longhand(LonghandId::StopColor),
                "text-decoration-color" => PropertyId::Longhand(LonghandId::TextDecorationColor),
                "text-emphasis-color" => PropertyId::Longhand(LonghandId::TextEmphasisColor),
                "-webkit-text-fill-color" => PropertyId::Longhand(LonghandId::WebkitTextFillColor),
                "-webkit-text-stroke-color" => PropertyId::Longhand(LonghandId::WebkitTextStrokeColor),
                "background" => PropertyId::Shorthand(ShorthandId::Background),
                "background-position" => PropertyId::Shorthand(ShorthandId::BackgroundPosition),
                "border-color" => PropertyId::Shorthand(ShorthandId::BorderColor),
                "border-style" => PropertyId::Shorthand(ShorthandId::BorderStyle),
                "border-width" => PropertyId::Shorthand(ShorthandId::BorderWidth),
                "border-top" => PropertyId::Shorthand(ShorthandId::BorderTop),
                "border-right" => PropertyId::Shorthand(ShorthandId::BorderRight),
                "border-bottom" => PropertyId::Shorthand(ShorthandId::BorderBottom),
                "border-left" => PropertyId::Shorthand(ShorthandId::BorderLeft),
                "border-block-start" => PropertyId::Shorthand(ShorthandId::BorderBlockStart),
                "border-block-end" => PropertyId::Shorthand(ShorthandId::BorderBlockEnd),
                "border-inline-start" => PropertyId::Shorthand(ShorthandId::BorderInlineStart),
                "-moz-border-start" => {
                    PropertyId::ShorthandAlias(
                        ShorthandId::BorderInlineStart,
                        AliasId::MozBorderStart,
                    )
                },
                "border-inline-end" => PropertyId::Shorthand(ShorthandId::BorderInlineEnd),
                "-moz-border-end" => {
                    PropertyId::ShorthandAlias(
                        ShorthandId::BorderInlineEnd,
                        AliasId::MozBorderEnd,
                    )
                },
                "border" => PropertyId::Shorthand(ShorthandId::Border),
                "border-radius" => PropertyId::Shorthand(ShorthandId::BorderRadius),
                "-webkit-border-radius" => {
                    PropertyId::ShorthandAlias(
                        ShorthandId::BorderRadius,
                        AliasId::WebkitBorderRadius,
                    )
                },
                "border-image" => PropertyId::Shorthand(ShorthandId::BorderImage),
                "-moz-border-image" => {
                    PropertyId::ShorthandAlias(
                        ShorthandId::BorderImage,
                        AliasId::MozBorderImage,
                    )
                },
                "-webkit-border-image" => {
                    PropertyId::ShorthandAlias(
                        ShorthandId::BorderImage,
                        AliasId::WebkitBorderImage,
                    )
                },
                "border-block-width" => PropertyId::Shorthand(ShorthandId::BorderBlockWidth),
                "border-block-style" => PropertyId::Shorthand(ShorthandId::BorderBlockStyle),
                "border-block-color" => PropertyId::Shorthand(ShorthandId::BorderBlockColor),
                "border-inline-width" => PropertyId::Shorthand(ShorthandId::BorderInlineWidth),
                "border-inline-style" => PropertyId::Shorthand(ShorthandId::BorderInlineStyle),
                "border-inline-color" => PropertyId::Shorthand(ShorthandId::BorderInlineColor),
                "border-block" => PropertyId::Shorthand(ShorthandId::BorderBlock),
                "border-inline" => PropertyId::Shorthand(ShorthandId::BorderInline),
                "overflow" => PropertyId::Shorthand(ShorthandId::Overflow),
                "overflow-clip-box" => PropertyId::Shorthand(ShorthandId::OverflowClipBox),
                "transition" => PropertyId::Shorthand(ShorthandId::Transition),
                "-moz-transition" => {
                    PropertyId::ShorthandAlias(
                        ShorthandId::Transition,
                        AliasId::MozTransition,
                    )
                },
                "-webkit-transition" => {
                    PropertyId::ShorthandAlias(
                        ShorthandId::Transition,
                        AliasId::WebkitTransition,
                    )
                },
                "animation" => PropertyId::Shorthand(ShorthandId::Animation),
                "-moz-animation" => {
                    PropertyId::ShorthandAlias(
                        ShorthandId::Animation,
                        AliasId::MozAnimation,
                    )
                },
                "-webkit-animation" => {
                    PropertyId::ShorthandAlias(
                        ShorthandId::Animation,
                        AliasId::WebkitAnimation,
                    )
                },
                "overscroll-behavior" => PropertyId::Shorthand(ShorthandId::OverscrollBehavior),
                "page-break-before" => PropertyId::Shorthand(ShorthandId::PageBreakBefore),
                "page-break-after" => PropertyId::Shorthand(ShorthandId::PageBreakAfter),
                "columns" => PropertyId::Shorthand(ShorthandId::Columns),
                "-moz-columns" => {
                    PropertyId::ShorthandAlias(
                        ShorthandId::Columns,
                        AliasId::MozColumns,
                    )
                },
                "column-rule" => PropertyId::Shorthand(ShorthandId::ColumnRule),
                "-moz-column-rule" => {
                    PropertyId::ShorthandAlias(
                        ShorthandId::ColumnRule,
                        AliasId::MozColumnRule,
                    )
                },
                "font" => PropertyId::Shorthand(ShorthandId::Font),
                "font-variant" => PropertyId::Shorthand(ShorthandId::FontVariant),
                "text-emphasis" => PropertyId::Shorthand(ShorthandId::TextEmphasis),
                "-webkit-text-stroke" => PropertyId::Shorthand(ShorthandId::WebkitTextStroke),
                "marker" => PropertyId::Shorthand(ShorthandId::Marker),
                "list-style" => PropertyId::Shorthand(ShorthandId::ListStyle),
                "margin" => PropertyId::Shorthand(ShorthandId::Margin),
                "margin-block" => PropertyId::Shorthand(ShorthandId::MarginBlock),
                "margin-inline" => PropertyId::Shorthand(ShorthandId::MarginInline),
                "scroll-margin" => PropertyId::Shorthand(ShorthandId::ScrollMargin),
                "scroll-margin-block" => PropertyId::Shorthand(ShorthandId::ScrollMarginBlock),
                "scroll-margin-inline" => PropertyId::Shorthand(ShorthandId::ScrollMarginInline),
                "outline" => PropertyId::Shorthand(ShorthandId::Outline),
                "-moz-outline-radius" => PropertyId::Shorthand(ShorthandId::MozOutlineRadius),
                "padding" => PropertyId::Shorthand(ShorthandId::Padding),
                "padding-block" => PropertyId::Shorthand(ShorthandId::PaddingBlock),
                "padding-inline" => PropertyId::Shorthand(ShorthandId::PaddingInline),
                "scroll-padding" => PropertyId::Shorthand(ShorthandId::ScrollPadding),
                "scroll-padding-block" => PropertyId::Shorthand(ShorthandId::ScrollPaddingBlock),
                "scroll-padding-inline" => PropertyId::Shorthand(ShorthandId::ScrollPaddingInline),
                "flex-flow" => PropertyId::Shorthand(ShorthandId::FlexFlow),
                "-webkit-flex-flow" => {
                    PropertyId::ShorthandAlias(
                        ShorthandId::FlexFlow,
                        AliasId::WebkitFlexFlow,
                    )
                },
                "flex" => PropertyId::Shorthand(ShorthandId::Flex),
                "-webkit-flex" => {
                    PropertyId::ShorthandAlias(
                        ShorthandId::Flex,
                        AliasId::WebkitFlex,
                    )
                },
                "gap" => PropertyId::Shorthand(ShorthandId::Gap),
                "grid-gap" => {
                    PropertyId::ShorthandAlias(
                        ShorthandId::Gap,
                        AliasId::GridGap,
                    )
                },
                "grid-row" => PropertyId::Shorthand(ShorthandId::GridRow),
                "grid-column" => PropertyId::Shorthand(ShorthandId::GridColumn),
                "grid-area" => PropertyId::Shorthand(ShorthandId::GridArea),
                "grid-template" => PropertyId::Shorthand(ShorthandId::GridTemplate),
                "grid" => PropertyId::Shorthand(ShorthandId::Grid),
                "place-content" => PropertyId::Shorthand(ShorthandId::PlaceContent),
                "place-self" => PropertyId::Shorthand(ShorthandId::PlaceSelf),
                "place-items" => PropertyId::Shorthand(ShorthandId::PlaceItems),
                "inset" => PropertyId::Shorthand(ShorthandId::Inset),
                "inset-block" => PropertyId::Shorthand(ShorthandId::InsetBlock),
                "inset-inline" => PropertyId::Shorthand(ShorthandId::InsetInline),
                "text-decoration" => PropertyId::Shorthand(ShorthandId::TextDecoration),
                "mask" => PropertyId::Shorthand(ShorthandId::Mask),
                "-webkit-mask" => {
                    PropertyId::ShorthandAlias(
                        ShorthandId::Mask,
                        AliasId::WebkitMask,
                    )
                },
                "mask-position" => PropertyId::Shorthand(ShorthandId::MaskPosition),
                "-webkit-mask-position" => {
                    PropertyId::ShorthandAlias(
                        ShorthandId::MaskPosition,
                        AliasId::WebkitMaskPosition,
                    )
                },
                "all" => PropertyId::Shorthand(ShorthandId::All),
            }
        }

        if let Some(id) = property_id(property_name) {
            return Ok(id.clone())
        }

        let name = crate::custom_properties::parse_name(property_name)?;
        Ok(PropertyId::Custom(crate::custom_properties::Name::from(name)))
    }

    /// Parses a property name, and returns an error if it's unknown or isn't
    /// enabled for all content.
    #[inline]
    pub fn parse_enabled_for_all_content(name: &str) -> Result<Self, ()> {
        let id = Self::parse_unchecked(name)?;

        if !id.enabled_for_all_content() {
            return Err(());
        }

        Ok(id)
    }


    /// Parses a property name, and returns an error if it's unknown or isn't
    /// allowed in this context.
    #[inline]
    pub fn parse(name: &str, context: &ParserContext) -> Result<Self, ()> {
        let id = Self::parse_unchecked(name)?;

        if !id.allowed_in(context) {
            return Err(());
        }

        Ok(id)
    }

    /// Parses a property name, and returns an error if it's unknown or isn't
    /// allowed in this context, ignoring the rule_type checks.
    ///
    /// This is useful for parsing stuff from CSS values, for example.
    #[inline]
    pub fn parse_ignoring_rule_type(
        name: &str,
        context: &ParserContext,
    ) -> Result<Self, ()> {
        let id = Self::parse_unchecked(name)?;

        if !id.allowed_in_ignoring_rule_type(context) {
            return Err(());
        }

        Ok(id)
    }

    /// Returns a property id from Gecko's nsCSSPropertyID.
    #[cfg(feature = "gecko")]
    #[allow(non_upper_case_globals)]
    #[inline]
    pub fn from_nscsspropertyid(id: nsCSSPropertyID) -> Result<Self, ()> {
        Ok(NonCustomPropertyId::from_nscsspropertyid(id)?.to_property_id())
    }

    /// Returns true if the property is a shorthand or shorthand alias.
    #[inline]
    pub fn is_shorthand(&self) -> bool {
        self.as_shorthand().is_ok()
    }

    /// Given this property id, get it either as a shorthand or as a
    /// `PropertyDeclarationId`.
    pub fn as_shorthand(&self) -> Result<ShorthandId, PropertyDeclarationId> {
        match *self {
            PropertyId::ShorthandAlias(id, _) |
            PropertyId::Shorthand(id) => Ok(id),
            PropertyId::LonghandAlias(id, _) |
            PropertyId::Longhand(id) => Err(PropertyDeclarationId::Longhand(id)),
            PropertyId::Custom(ref name) => Err(PropertyDeclarationId::Custom(name)),
        }
    }

    /// Returns the `NonCustomPropertyId` corresponding to this property id.
    pub fn non_custom_id(&self) -> Option<NonCustomPropertyId> {
        Some(match *self {
            PropertyId::Custom(_) => return None,
            PropertyId::Shorthand(shorthand_id) => shorthand_id.into(),
            PropertyId::Longhand(longhand_id) => longhand_id.into(),
            PropertyId::ShorthandAlias(_, alias_id) => alias_id.into(),
            PropertyId::LonghandAlias(_, alias_id) => alias_id.into(),
        })
    }

    /// Returns non-alias NonCustomPropertyId corresponding to this
    /// property id.
    fn non_custom_non_alias_id(&self) -> Option<NonCustomPropertyId> {
        Some(match *self {
            PropertyId::Custom(_) => return None,
            PropertyId::Shorthand(id) => id.into(),
            PropertyId::Longhand(id) => id.into(),
            PropertyId::ShorthandAlias(id, _) => id.into(),
            PropertyId::LonghandAlias(id, _) => id.into(),
        })
    }

    /// Whether the property is enabled for all content regardless of the
    /// stylesheet it was declared on (that is, in practice only checks prefs).
    #[inline]
    pub fn enabled_for_all_content(&self) -> bool {
        let id = match self.non_custom_id() {
            // Custom properties are allowed everywhere
            None => return true,
            Some(id) => id,
        };

        id.enabled_for_all_content()
    }

    /// Converts this PropertyId in nsCSSPropertyID, resolving aliases to the
    /// resolved property, and returning eCSSPropertyExtra_variable for custom
    /// properties.
    #[cfg(feature = "gecko")]
    #[inline]
    pub fn to_nscsspropertyid_resolving_aliases(&self) -> nsCSSPropertyID {
        match self.non_custom_non_alias_id() {
            Some(id) => id.to_nscsspropertyid(),
            None => nsCSSPropertyID::eCSSPropertyExtra_variable,
        }
    }

    fn allowed_in(&self, context: &ParserContext) -> bool {
        let id = match self.non_custom_id() {
            // Custom properties are allowed everywhere
            None => return true,
            Some(id) => id,
        };
        id.allowed_in(context)
    }

    #[inline]
    fn allowed_in_ignoring_rule_type(&self, context: &ParserContext) -> bool {
        let id = match self.non_custom_id() {
            // Custom properties are allowed everywhere
            None => return true,
            Some(id) => id,
        };
        id.allowed_in_ignoring_rule_type(context)
    }

    /// Whether the property supports the given CSS type.
    /// `ty` should a bitflags of constants in style_traits::CssType.
    pub fn supports_type(&self, ty: u8) -> bool {
        let id = self.non_custom_non_alias_id();
        id.map_or(0, |id| id.supported_types()) & ty != 0
    }

    /// Collect supported starting word of values of this property.
    ///
    /// See style_traits::SpecifiedValueInfo::collect_completion_keywords for more
    /// details.
    pub fn collect_property_completion_keywords(&self, f: KeywordsCollectFn) {
        if let Some(id) = self.non_custom_non_alias_id() {
            id.collect_property_completion_keywords(f);
        }
        CSSWideKeyword::collect_completion_keywords(f);
    }
}

/// A declaration using a CSS-wide keyword.
#[cfg_attr(feature = "gecko", derive(MallocSizeOf))]
#[derive(Clone, PartialEq, ToCss, ToShmem)]
pub struct WideKeywordDeclaration {
    #[css(skip)]
    id: LonghandId,
    keyword: CSSWideKeyword,
}

/// An unparsed declaration that contains `var()` functions.
#[cfg_attr(feature = "gecko", derive(MallocSizeOf))]
#[derive(Clone, PartialEq, ToCss, ToShmem)]
pub struct VariableDeclaration {
    #[css(skip)]
    id: LonghandId,
    #[cfg_attr(feature = "gecko", ignore_malloc_size_of = "XXX: how to handle this?")]
    value: Arc<UnparsedValue>,
}

/// A custom property declaration value is either an unparsed value or a CSS
/// wide-keyword.
#[derive(Clone, PartialEq, ToCss, ToShmem)]
pub enum CustomDeclarationValue {
    /// A value.
    Value(Arc<crate::custom_properties::SpecifiedValue>),
    /// A wide keyword.
    CSSWideKeyword(CSSWideKeyword),
}

/// A custom property declaration with the property name and the declared value.
#[cfg_attr(feature = "gecko", derive(MallocSizeOf))]
#[derive(Clone, PartialEq, ToCss, ToShmem)]
pub struct CustomDeclaration {
    /// The name of the custom property.
    #[css(skip)]
    pub name: crate::custom_properties::Name,
    /// The value of the custom property.
    #[cfg_attr(feature = "gecko", ignore_malloc_size_of = "XXX: how to handle this?")]
    pub value: CustomDeclarationValue,
}

impl fmt::Debug for PropertyDeclaration {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        self.id().to_css(&mut CssWriter::new(f))?;
        f.write_str(": ")?;

        // Because PropertyDeclaration::to_css requires CssStringWriter, we can't write
        // it directly to f, and need to allocate an intermediate string. This is
        // fine for debug-only code.
        let mut s = CssString::new();
        self.to_css(&mut s)?;
        write!(f, "{}", s)
    }
}

impl PropertyDeclaration {
    /// Given a property declaration, return the property declaration id.
    #[inline]
    pub fn id(&self) -> PropertyDeclarationId {
        match *self {
            PropertyDeclaration::Custom(ref declaration) => {
                return PropertyDeclarationId::Custom(&declaration.name)
            }
            PropertyDeclaration::CSSWideKeyword(ref declaration) => {
                return PropertyDeclarationId::Longhand(declaration.id);
            }
            PropertyDeclaration::WithVariables(ref declaration) => {
                return PropertyDeclarationId::Longhand(declaration.id);
            }
            _ => {}
        }
        // This is just fine because PropertyDeclaration and LonghandId
        // have corresponding discriminants.
        let id = unsafe { *(self as *const _ as *const LonghandId) };
        debug_assert_eq!(id, match *self {
            PropertyDeclaration::AlignContent(..) => LonghandId::AlignContent,
            PropertyDeclaration::AlignItems(..) => LonghandId::AlignItems,
            PropertyDeclaration::AlignSelf(..) => LonghandId::AlignSelf,
            PropertyDeclaration::BackfaceVisibility(..) => LonghandId::BackfaceVisibility,
            PropertyDeclaration::BorderCollapse(..) => LonghandId::BorderCollapse,
            PropertyDeclaration::BorderImageRepeat(..) => LonghandId::BorderImageRepeat,
            PropertyDeclaration::BoxDecorationBreak(..) => LonghandId::BoxDecorationBreak,
            PropertyDeclaration::BoxSizing(..) => LonghandId::BoxSizing,
            PropertyDeclaration::BreakInside(..) => LonghandId::BreakInside,
            PropertyDeclaration::CaptionSide(..) => LonghandId::CaptionSide,
            PropertyDeclaration::Clear(..) => LonghandId::Clear,
            PropertyDeclaration::ColorAdjust(..) => LonghandId::ColorAdjust,
            PropertyDeclaration::ColorInterpolation(..) => LonghandId::ColorInterpolation,
            PropertyDeclaration::ColorInterpolationFilters(..) => LonghandId::ColorInterpolationFilters,
            PropertyDeclaration::ColumnCount(..) => LonghandId::ColumnCount,
            PropertyDeclaration::ColumnFill(..) => LonghandId::ColumnFill,
            PropertyDeclaration::ColumnSpan(..) => LonghandId::ColumnSpan,
            PropertyDeclaration::Contain(..) => LonghandId::Contain,
            PropertyDeclaration::Direction(..) => LonghandId::Direction,
            PropertyDeclaration::Display(..) => LonghandId::Display,
            PropertyDeclaration::DominantBaseline(..) => LonghandId::DominantBaseline,
            PropertyDeclaration::EmptyCells(..) => LonghandId::EmptyCells,
            PropertyDeclaration::FlexDirection(..) => LonghandId::FlexDirection,
            PropertyDeclaration::FlexWrap(..) => LonghandId::FlexWrap,
            PropertyDeclaration::Float(..) => LonghandId::Float,
            PropertyDeclaration::FontKerning(..) => LonghandId::FontKerning,
            PropertyDeclaration::FontOpticalSizing(..) => LonghandId::FontOpticalSizing,
            PropertyDeclaration::FontSizeAdjust(..) => LonghandId::FontSizeAdjust,
            PropertyDeclaration::FontStretch(..) => LonghandId::FontStretch,
            PropertyDeclaration::FontStyle(..) => LonghandId::FontStyle,
            PropertyDeclaration::FontSynthesis(..) => LonghandId::FontSynthesis,
            PropertyDeclaration::FontVariantCaps(..) => LonghandId::FontVariantCaps,
            PropertyDeclaration::FontVariantEastAsian(..) => LonghandId::FontVariantEastAsian,
            PropertyDeclaration::FontVariantLigatures(..) => LonghandId::FontVariantLigatures,
            PropertyDeclaration::FontVariantNumeric(..) => LonghandId::FontVariantNumeric,
            PropertyDeclaration::FontVariantPosition(..) => LonghandId::FontVariantPosition,
            PropertyDeclaration::FontWeight(..) => LonghandId::FontWeight,
            PropertyDeclaration::GridAutoFlow(..) => LonghandId::GridAutoFlow,
            PropertyDeclaration::Hyphens(..) => LonghandId::Hyphens,
            PropertyDeclaration::ImageOrientation(..) => LonghandId::ImageOrientation,
            PropertyDeclaration::ImageRendering(..) => LonghandId::ImageRendering,
            PropertyDeclaration::ImeMode(..) => LonghandId::ImeMode,
            PropertyDeclaration::InitialLetter(..) => LonghandId::InitialLetter,
            PropertyDeclaration::Isolation(..) => LonghandId::Isolation,
            PropertyDeclaration::JustifyContent(..) => LonghandId::JustifyContent,
            PropertyDeclaration::JustifyItems(..) => LonghandId::JustifyItems,
            PropertyDeclaration::JustifySelf(..) => LonghandId::JustifySelf,
            PropertyDeclaration::ListStylePosition(..) => LonghandId::ListStylePosition,
            PropertyDeclaration::MaskType(..) => LonghandId::MaskType,
            PropertyDeclaration::MixBlendMode(..) => LonghandId::MixBlendMode,
            PropertyDeclaration::MozAppearance(..) => LonghandId::MozAppearance,
            PropertyDeclaration::MozBoxAlign(..) => LonghandId::MozBoxAlign,
            PropertyDeclaration::MozBoxDirection(..) => LonghandId::MozBoxDirection,
            PropertyDeclaration::MozBoxOrient(..) => LonghandId::MozBoxOrient,
            PropertyDeclaration::MozBoxPack(..) => LonghandId::MozBoxPack,
            PropertyDeclaration::MozControlCharacterVisibility(..) => LonghandId::MozControlCharacterVisibility,
            PropertyDeclaration::MozFloatEdge(..) => LonghandId::MozFloatEdge,
            PropertyDeclaration::MozForceBrokenImageIcon(..) => LonghandId::MozForceBrokenImageIcon,
            PropertyDeclaration::MozListReversed(..) => LonghandId::MozListReversed,
            PropertyDeclaration::MozMathDisplay(..) => LonghandId::MozMathDisplay,
            PropertyDeclaration::MozMathVariant(..) => LonghandId::MozMathVariant,
            PropertyDeclaration::MozMinFontSizeRatio(..) => LonghandId::MozMinFontSizeRatio,
            PropertyDeclaration::MozOrient(..) => LonghandId::MozOrient,
            PropertyDeclaration::MozOsxFontSmoothing(..) => LonghandId::MozOsxFontSmoothing,
            PropertyDeclaration::MozScriptLevel(..) => LonghandId::MozScriptLevel,
            PropertyDeclaration::MozScriptMinSize(..) => LonghandId::MozScriptMinSize,
            PropertyDeclaration::MozScriptSizeMultiplier(..) => LonghandId::MozScriptSizeMultiplier,
            PropertyDeclaration::MozStackSizing(..) => LonghandId::MozStackSizing,
            PropertyDeclaration::MozTextSizeAdjust(..) => LonghandId::MozTextSizeAdjust,
            PropertyDeclaration::MozTopLayer(..) => LonghandId::MozTopLayer,
            PropertyDeclaration::MozUserFocus(..) => LonghandId::MozUserFocus,
            PropertyDeclaration::MozUserInput(..) => LonghandId::MozUserInput,
            PropertyDeclaration::MozUserModify(..) => LonghandId::MozUserModify,
            PropertyDeclaration::MozUserSelect(..) => LonghandId::MozUserSelect,
            PropertyDeclaration::MozWindowDragging(..) => LonghandId::MozWindowDragging,
            PropertyDeclaration::MozWindowShadow(..) => LonghandId::MozWindowShadow,
            PropertyDeclaration::ObjectFit(..) => LonghandId::ObjectFit,
            PropertyDeclaration::OutlineStyle(..) => LonghandId::OutlineStyle,
            PropertyDeclaration::OverflowAnchor(..) => LonghandId::OverflowAnchor,
            PropertyDeclaration::OverflowWrap(..) => LonghandId::OverflowWrap,
            PropertyDeclaration::PaintOrder(..) => LonghandId::PaintOrder,
            PropertyDeclaration::PointerEvents(..) => LonghandId::PointerEvents,
            PropertyDeclaration::Position(..) => LonghandId::Position,
            PropertyDeclaration::Resize(..) => LonghandId::Resize,
            PropertyDeclaration::RubyAlign(..) => LonghandId::RubyAlign,
            PropertyDeclaration::RubyPosition(..) => LonghandId::RubyPosition,
            PropertyDeclaration::ScrollBehavior(..) => LonghandId::ScrollBehavior,
            PropertyDeclaration::ScrollSnapAlign(..) => LonghandId::ScrollSnapAlign,
            PropertyDeclaration::ScrollSnapType(..) => LonghandId::ScrollSnapType,
            PropertyDeclaration::ScrollbarWidth(..) => LonghandId::ScrollbarWidth,
            PropertyDeclaration::ShapeRendering(..) => LonghandId::ShapeRendering,
            PropertyDeclaration::StrokeLinecap(..) => LonghandId::StrokeLinecap,
            PropertyDeclaration::StrokeLinejoin(..) => LonghandId::StrokeLinejoin,
            PropertyDeclaration::TableLayout(..) => LonghandId::TableLayout,
            PropertyDeclaration::TextAlign(..) => LonghandId::TextAlign,
            PropertyDeclaration::TextAlignLast(..) => LonghandId::TextAlignLast,
            PropertyDeclaration::TextAnchor(..) => LonghandId::TextAnchor,
            PropertyDeclaration::TextCombineUpright(..) => LonghandId::TextCombineUpright,
            PropertyDeclaration::TextDecorationLine(..) => LonghandId::TextDecorationLine,
            PropertyDeclaration::TextDecorationStyle(..) => LonghandId::TextDecorationStyle,
            PropertyDeclaration::TextEmphasisPosition(..) => LonghandId::TextEmphasisPosition,
            PropertyDeclaration::TextJustify(..) => LonghandId::TextJustify,
            PropertyDeclaration::TextOrientation(..) => LonghandId::TextOrientation,
            PropertyDeclaration::TextRendering(..) => LonghandId::TextRendering,
            PropertyDeclaration::TextTransform(..) => LonghandId::TextTransform,
            PropertyDeclaration::TouchAction(..) => LonghandId::TouchAction,
            PropertyDeclaration::TransformBox(..) => LonghandId::TransformBox,
            PropertyDeclaration::TransformStyle(..) => LonghandId::TransformStyle,
            PropertyDeclaration::UnicodeBidi(..) => LonghandId::UnicodeBidi,
            PropertyDeclaration::VectorEffect(..) => LonghandId::VectorEffect,
            PropertyDeclaration::Visibility(..) => LonghandId::Visibility,
            PropertyDeclaration::WebkitLineClamp(..) => LonghandId::WebkitLineClamp,
            PropertyDeclaration::WhiteSpace(..) => LonghandId::WhiteSpace,
            PropertyDeclaration::WordBreak(..) => LonghandId::WordBreak,
            PropertyDeclaration::WritingMode(..) => LonghandId::WritingMode,
            PropertyDeclaration::XSpan(..) => LonghandId::XSpan,
            PropertyDeclaration::XTextZoom(..) => LonghandId::XTextZoom,
            PropertyDeclaration::ZIndex(..) => LonghandId::ZIndex,
            PropertyDeclaration::BreakAfter(..) => LonghandId::BreakAfter,
            PropertyDeclaration::BreakBefore(..) => LonghandId::BreakBefore,
            PropertyDeclaration::ClipRule(..) => LonghandId::ClipRule,
            PropertyDeclaration::FillRule(..) => LonghandId::FillRule,
            PropertyDeclaration::MozBoxOrdinalGroup(..) => LonghandId::MozBoxOrdinalGroup,
            PropertyDeclaration::Order(..) => LonghandId::Order,
            PropertyDeclaration::OverflowX(..) => LonghandId::OverflowX,
            PropertyDeclaration::OverflowY(..) => LonghandId::OverflowY,
            PropertyDeclaration::OverflowClipBoxBlock(..) => LonghandId::OverflowClipBoxBlock,
            PropertyDeclaration::OverflowClipBoxInline(..) => LonghandId::OverflowClipBoxInline,
            PropertyDeclaration::OverscrollBehaviorX(..) => LonghandId::OverscrollBehaviorX,
            PropertyDeclaration::OverscrollBehaviorY(..) => LonghandId::OverscrollBehaviorY,
            PropertyDeclaration::FillOpacity(..) => LonghandId::FillOpacity,
            PropertyDeclaration::StrokeOpacity(..) => LonghandId::StrokeOpacity,
            PropertyDeclaration::FlexGrow(..) => LonghandId::FlexGrow,
            PropertyDeclaration::FlexShrink(..) => LonghandId::FlexShrink,
            PropertyDeclaration::MozBoxFlex(..) => LonghandId::MozBoxFlex,
            PropertyDeclaration::StrokeMiterlimit(..) => LonghandId::StrokeMiterlimit,
            PropertyDeclaration::FloodOpacity(..) => LonghandId::FloodOpacity,
            PropertyDeclaration::MozWindowOpacity(..) => LonghandId::MozWindowOpacity,
            PropertyDeclaration::Opacity(..) => LonghandId::Opacity,
            PropertyDeclaration::ShapeImageThreshold(..) => LonghandId::ShapeImageThreshold,
            PropertyDeclaration::StopOpacity(..) => LonghandId::StopOpacity,
            PropertyDeclaration::BorderBlockEndStyle(..) => LonghandId::BorderBlockEndStyle,
            PropertyDeclaration::BorderBlockStartStyle(..) => LonghandId::BorderBlockStartStyle,
            PropertyDeclaration::BorderBottomStyle(..) => LonghandId::BorderBottomStyle,
            PropertyDeclaration::BorderInlineEndStyle(..) => LonghandId::BorderInlineEndStyle,
            PropertyDeclaration::BorderInlineStartStyle(..) => LonghandId::BorderInlineStartStyle,
            PropertyDeclaration::BorderLeftStyle(..) => LonghandId::BorderLeftStyle,
            PropertyDeclaration::BorderRightStyle(..) => LonghandId::BorderRightStyle,
            PropertyDeclaration::BorderTopStyle(..) => LonghandId::BorderTopStyle,
            PropertyDeclaration::ColumnRuleStyle(..) => LonghandId::ColumnRuleStyle,
            PropertyDeclaration::AnimationDelay(..) => LonghandId::AnimationDelay,
            PropertyDeclaration::AnimationDirection(..) => LonghandId::AnimationDirection,
            PropertyDeclaration::AnimationDuration(..) => LonghandId::AnimationDuration,
            PropertyDeclaration::AnimationFillMode(..) => LonghandId::AnimationFillMode,
            PropertyDeclaration::AnimationIterationCount(..) => LonghandId::AnimationIterationCount,
            PropertyDeclaration::AnimationName(..) => LonghandId::AnimationName,
            PropertyDeclaration::AnimationPlayState(..) => LonghandId::AnimationPlayState,
            PropertyDeclaration::AnimationTimingFunction(..) => LonghandId::AnimationTimingFunction,
            PropertyDeclaration::BackgroundAttachment(..) => LonghandId::BackgroundAttachment,
            PropertyDeclaration::BackgroundBlendMode(..) => LonghandId::BackgroundBlendMode,
            PropertyDeclaration::BackgroundClip(..) => LonghandId::BackgroundClip,
            PropertyDeclaration::BackgroundImage(..) => LonghandId::BackgroundImage,
            PropertyDeclaration::BackgroundOrigin(..) => LonghandId::BackgroundOrigin,
            PropertyDeclaration::BackgroundPositionX(..) => LonghandId::BackgroundPositionX,
            PropertyDeclaration::BackgroundPositionY(..) => LonghandId::BackgroundPositionY,
            PropertyDeclaration::BackgroundRepeat(..) => LonghandId::BackgroundRepeat,
            PropertyDeclaration::BackgroundSize(..) => LonghandId::BackgroundSize,
            PropertyDeclaration::BorderImageOutset(..) => LonghandId::BorderImageOutset,
            PropertyDeclaration::BorderImageSlice(..) => LonghandId::BorderImageSlice,
            PropertyDeclaration::BorderImageSource(..) => LonghandId::BorderImageSource,
            PropertyDeclaration::BorderImageWidth(..) => LonghandId::BorderImageWidth,
            PropertyDeclaration::BorderSpacing(..) => LonghandId::BorderSpacing,
            PropertyDeclaration::BoxShadow(..) => LonghandId::BoxShadow,
            PropertyDeclaration::CaretColor(..) => LonghandId::CaretColor,
            PropertyDeclaration::ClipPath(..) => LonghandId::ClipPath,
            PropertyDeclaration::Color(..) => LonghandId::Color,
            PropertyDeclaration::ColumnWidth(..) => LonghandId::ColumnWidth,
            PropertyDeclaration::Content(..) => LonghandId::Content,
            PropertyDeclaration::CounterIncrement(..) => LonghandId::CounterIncrement,
            PropertyDeclaration::Cursor(..) => LonghandId::Cursor,
            PropertyDeclaration::Filter(..) => LonghandId::Filter,
            PropertyDeclaration::FlexBasis(..) => LonghandId::FlexBasis,
            PropertyDeclaration::FontFamily(..) => LonghandId::FontFamily,
            PropertyDeclaration::FontFeatureSettings(..) => LonghandId::FontFeatureSettings,
            PropertyDeclaration::FontLanguageOverride(..) => LonghandId::FontLanguageOverride,
            PropertyDeclaration::FontSize(..) => LonghandId::FontSize,
            PropertyDeclaration::FontVariantAlternates(..) => LonghandId::FontVariantAlternates,
            PropertyDeclaration::FontVariationSettings(..) => LonghandId::FontVariationSettings,
            PropertyDeclaration::GridTemplateAreas(..) => LonghandId::GridTemplateAreas,
            PropertyDeclaration::LetterSpacing(..) => LonghandId::LetterSpacing,
            PropertyDeclaration::LineHeight(..) => LonghandId::LineHeight,
            PropertyDeclaration::ListStyleImage(..) => LonghandId::ListStyleImage,
            PropertyDeclaration::ListStyleType(..) => LonghandId::ListStyleType,
            PropertyDeclaration::MaskClip(..) => LonghandId::MaskClip,
            PropertyDeclaration::MaskComposite(..) => LonghandId::MaskComposite,
            PropertyDeclaration::MaskImage(..) => LonghandId::MaskImage,
            PropertyDeclaration::MaskMode(..) => LonghandId::MaskMode,
            PropertyDeclaration::MaskOrigin(..) => LonghandId::MaskOrigin,
            PropertyDeclaration::MaskPositionX(..) => LonghandId::MaskPositionX,
            PropertyDeclaration::MaskPositionY(..) => LonghandId::MaskPositionY,
            PropertyDeclaration::MaskRepeat(..) => LonghandId::MaskRepeat,
            PropertyDeclaration::MaskSize(..) => LonghandId::MaskSize,
            PropertyDeclaration::MozContextProperties(..) => LonghandId::MozContextProperties,
            PropertyDeclaration::MozFontSmoothingBackgroundColor(..) => LonghandId::MozFontSmoothingBackgroundColor,
            PropertyDeclaration::MozTabSize(..) => LonghandId::MozTabSize,
            PropertyDeclaration::OffsetPath(..) => LonghandId::OffsetPath,
            PropertyDeclaration::Perspective(..) => LonghandId::Perspective,
            PropertyDeclaration::Quotes(..) => LonghandId::Quotes,
            PropertyDeclaration::Rotate(..) => LonghandId::Rotate,
            PropertyDeclaration::Scale(..) => LonghandId::Scale,
            PropertyDeclaration::ScrollSnapCoordinate(..) => LonghandId::ScrollSnapCoordinate,
            PropertyDeclaration::ScrollbarColor(..) => LonghandId::ScrollbarColor,
            PropertyDeclaration::ShapeOutside(..) => LonghandId::ShapeOutside,
            PropertyDeclaration::StrokeDasharray(..) => LonghandId::StrokeDasharray,
            PropertyDeclaration::StrokeDashoffset(..) => LonghandId::StrokeDashoffset,
            PropertyDeclaration::StrokeWidth(..) => LonghandId::StrokeWidth,
            PropertyDeclaration::TextEmphasisStyle(..) => LonghandId::TextEmphasisStyle,
            PropertyDeclaration::TextIndent(..) => LonghandId::TextIndent,
            PropertyDeclaration::TextOverflow(..) => LonghandId::TextOverflow,
            PropertyDeclaration::TextShadow(..) => LonghandId::TextShadow,
            PropertyDeclaration::TransitionDelay(..) => LonghandId::TransitionDelay,
            PropertyDeclaration::TransitionDuration(..) => LonghandId::TransitionDuration,
            PropertyDeclaration::TransitionProperty(..) => LonghandId::TransitionProperty,
            PropertyDeclaration::TransitionTimingFunction(..) => LonghandId::TransitionTimingFunction,
            PropertyDeclaration::Translate(..) => LonghandId::Translate,
            PropertyDeclaration::VerticalAlign(..) => LonghandId::VerticalAlign,
            PropertyDeclaration::WillChange(..) => LonghandId::WillChange,
            PropertyDeclaration::WordSpacing(..) => LonghandId::WordSpacing,
            PropertyDeclaration::XLang(..) => LonghandId::XLang,
            PropertyDeclaration::Clip(..) => LonghandId::Clip,
            PropertyDeclaration::MozImageRegion(..) => LonghandId::MozImageRegion,
            PropertyDeclaration::GridTemplateColumns(..) => LonghandId::GridTemplateColumns,
            PropertyDeclaration::GridTemplateRows(..) => LonghandId::GridTemplateRows,
            PropertyDeclaration::Fill(..) => LonghandId::Fill,
            PropertyDeclaration::Stroke(..) => LonghandId::Stroke,
            PropertyDeclaration::GridAutoColumns(..) => LonghandId::GridAutoColumns,
            PropertyDeclaration::GridAutoRows(..) => LonghandId::GridAutoRows,
            PropertyDeclaration::MozWindowTransformOrigin(..) => LonghandId::MozWindowTransformOrigin,
            PropertyDeclaration::TransformOrigin(..) => LonghandId::TransformOrigin,
            PropertyDeclaration::CounterReset(..) => LonghandId::CounterReset,
            PropertyDeclaration::CounterSet(..) => LonghandId::CounterSet,
            PropertyDeclaration::ScrollSnapPointsX(..) => LonghandId::ScrollSnapPointsX,
            PropertyDeclaration::ScrollSnapPointsY(..) => LonghandId::ScrollSnapPointsY,
            PropertyDeclaration::MozWindowTransform(..) => LonghandId::MozWindowTransform,
            PropertyDeclaration::Transform(..) => LonghandId::Transform,
            PropertyDeclaration::ColumnGap(..) => LonghandId::ColumnGap,
            PropertyDeclaration::RowGap(..) => LonghandId::RowGap,
            PropertyDeclaration::ObjectPosition(..) => LonghandId::ObjectPosition,
            PropertyDeclaration::PerspectiveOrigin(..) => LonghandId::PerspectiveOrigin,
            PropertyDeclaration::ScrollSnapDestination(..) => LonghandId::ScrollSnapDestination,
            PropertyDeclaration::GridColumnEnd(..) => LonghandId::GridColumnEnd,
            PropertyDeclaration::GridColumnStart(..) => LonghandId::GridColumnStart,
            PropertyDeclaration::GridRowEnd(..) => LonghandId::GridRowEnd,
            PropertyDeclaration::GridRowStart(..) => LonghandId::GridRowStart,
            PropertyDeclaration::MaxBlockSize(..) => LonghandId::MaxBlockSize,
            PropertyDeclaration::MaxHeight(..) => LonghandId::MaxHeight,
            PropertyDeclaration::MaxInlineSize(..) => LonghandId::MaxInlineSize,
            PropertyDeclaration::MaxWidth(..) => LonghandId::MaxWidth,
            PropertyDeclaration::MarkerEnd(..) => LonghandId::MarkerEnd,
            PropertyDeclaration::MarkerMid(..) => LonghandId::MarkerMid,
            PropertyDeclaration::MarkerStart(..) => LonghandId::MarkerStart,
            PropertyDeclaration::MozBinding(..) => LonghandId::MozBinding,
            PropertyDeclaration::ScrollPaddingBlockEnd(..) => LonghandId::ScrollPaddingBlockEnd,
            PropertyDeclaration::ScrollPaddingBlockStart(..) => LonghandId::ScrollPaddingBlockStart,
            PropertyDeclaration::ScrollPaddingBottom(..) => LonghandId::ScrollPaddingBottom,
            PropertyDeclaration::ScrollPaddingInlineEnd(..) => LonghandId::ScrollPaddingInlineEnd,
            PropertyDeclaration::ScrollPaddingInlineStart(..) => LonghandId::ScrollPaddingInlineStart,
            PropertyDeclaration::ScrollPaddingLeft(..) => LonghandId::ScrollPaddingLeft,
            PropertyDeclaration::ScrollPaddingRight(..) => LonghandId::ScrollPaddingRight,
            PropertyDeclaration::ScrollPaddingTop(..) => LonghandId::ScrollPaddingTop,
            PropertyDeclaration::BlockSize(..) => LonghandId::BlockSize,
            PropertyDeclaration::Height(..) => LonghandId::Height,
            PropertyDeclaration::InlineSize(..) => LonghandId::InlineSize,
            PropertyDeclaration::MinBlockSize(..) => LonghandId::MinBlockSize,
            PropertyDeclaration::MinHeight(..) => LonghandId::MinHeight,
            PropertyDeclaration::MinInlineSize(..) => LonghandId::MinInlineSize,
            PropertyDeclaration::MinWidth(..) => LonghandId::MinWidth,
            PropertyDeclaration::Width(..) => LonghandId::Width,
            PropertyDeclaration::OutlineOffset(..) => LonghandId::OutlineOffset,
            PropertyDeclaration::ScrollMarginBlockEnd(..) => LonghandId::ScrollMarginBlockEnd,
            PropertyDeclaration::ScrollMarginBlockStart(..) => LonghandId::ScrollMarginBlockStart,
            PropertyDeclaration::ScrollMarginBottom(..) => LonghandId::ScrollMarginBottom,
            PropertyDeclaration::ScrollMarginInlineEnd(..) => LonghandId::ScrollMarginInlineEnd,
            PropertyDeclaration::ScrollMarginInlineStart(..) => LonghandId::ScrollMarginInlineStart,
            PropertyDeclaration::ScrollMarginLeft(..) => LonghandId::ScrollMarginLeft,
            PropertyDeclaration::ScrollMarginRight(..) => LonghandId::ScrollMarginRight,
            PropertyDeclaration::ScrollMarginTop(..) => LonghandId::ScrollMarginTop,
            PropertyDeclaration::PaddingBlockEnd(..) => LonghandId::PaddingBlockEnd,
            PropertyDeclaration::PaddingBlockStart(..) => LonghandId::PaddingBlockStart,
            PropertyDeclaration::PaddingBottom(..) => LonghandId::PaddingBottom,
            PropertyDeclaration::PaddingInlineEnd(..) => LonghandId::PaddingInlineEnd,
            PropertyDeclaration::PaddingInlineStart(..) => LonghandId::PaddingInlineStart,
            PropertyDeclaration::PaddingLeft(..) => LonghandId::PaddingLeft,
            PropertyDeclaration::PaddingRight(..) => LonghandId::PaddingRight,
            PropertyDeclaration::PaddingTop(..) => LonghandId::PaddingTop,
            PropertyDeclaration::ShapeMargin(..) => LonghandId::ShapeMargin,
            PropertyDeclaration::BorderBlockEndWidth(..) => LonghandId::BorderBlockEndWidth,
            PropertyDeclaration::BorderBlockStartWidth(..) => LonghandId::BorderBlockStartWidth,
            PropertyDeclaration::BorderBottomWidth(..) => LonghandId::BorderBottomWidth,
            PropertyDeclaration::BorderInlineEndWidth(..) => LonghandId::BorderInlineEndWidth,
            PropertyDeclaration::BorderInlineStartWidth(..) => LonghandId::BorderInlineStartWidth,
            PropertyDeclaration::BorderLeftWidth(..) => LonghandId::BorderLeftWidth,
            PropertyDeclaration::BorderRightWidth(..) => LonghandId::BorderRightWidth,
            PropertyDeclaration::BorderTopWidth(..) => LonghandId::BorderTopWidth,
            PropertyDeclaration::ColumnRuleWidth(..) => LonghandId::ColumnRuleWidth,
            PropertyDeclaration::OutlineWidth(..) => LonghandId::OutlineWidth,
            PropertyDeclaration::WebkitTextStrokeWidth(..) => LonghandId::WebkitTextStrokeWidth,
            PropertyDeclaration::BorderBottomLeftRadius(..) => LonghandId::BorderBottomLeftRadius,
            PropertyDeclaration::BorderBottomRightRadius(..) => LonghandId::BorderBottomRightRadius,
            PropertyDeclaration::BorderEndEndRadius(..) => LonghandId::BorderEndEndRadius,
            PropertyDeclaration::BorderEndStartRadius(..) => LonghandId::BorderEndStartRadius,
            PropertyDeclaration::BorderStartEndRadius(..) => LonghandId::BorderStartEndRadius,
            PropertyDeclaration::BorderStartStartRadius(..) => LonghandId::BorderStartStartRadius,
            PropertyDeclaration::BorderTopLeftRadius(..) => LonghandId::BorderTopLeftRadius,
            PropertyDeclaration::BorderTopRightRadius(..) => LonghandId::BorderTopRightRadius,
            PropertyDeclaration::MozOutlineRadiusBottomleft(..) => LonghandId::MozOutlineRadiusBottomleft,
            PropertyDeclaration::MozOutlineRadiusBottomright(..) => LonghandId::MozOutlineRadiusBottomright,
            PropertyDeclaration::MozOutlineRadiusTopleft(..) => LonghandId::MozOutlineRadiusTopleft,
            PropertyDeclaration::MozOutlineRadiusTopright(..) => LonghandId::MozOutlineRadiusTopright,
            PropertyDeclaration::Bottom(..) => LonghandId::Bottom,
            PropertyDeclaration::InsetBlockEnd(..) => LonghandId::InsetBlockEnd,
            PropertyDeclaration::InsetBlockStart(..) => LonghandId::InsetBlockStart,
            PropertyDeclaration::InsetInlineEnd(..) => LonghandId::InsetInlineEnd,
            PropertyDeclaration::InsetInlineStart(..) => LonghandId::InsetInlineStart,
            PropertyDeclaration::Left(..) => LonghandId::Left,
            PropertyDeclaration::MarginBlockEnd(..) => LonghandId::MarginBlockEnd,
            PropertyDeclaration::MarginBlockStart(..) => LonghandId::MarginBlockStart,
            PropertyDeclaration::MarginBottom(..) => LonghandId::MarginBottom,
            PropertyDeclaration::MarginInlineEnd(..) => LonghandId::MarginInlineEnd,
            PropertyDeclaration::MarginInlineStart(..) => LonghandId::MarginInlineStart,
            PropertyDeclaration::MarginLeft(..) => LonghandId::MarginLeft,
            PropertyDeclaration::MarginRight(..) => LonghandId::MarginRight,
            PropertyDeclaration::MarginTop(..) => LonghandId::MarginTop,
            PropertyDeclaration::Right(..) => LonghandId::Right,
            PropertyDeclaration::Top(..) => LonghandId::Top,
            PropertyDeclaration::BackgroundColor(..) => LonghandId::BackgroundColor,
            PropertyDeclaration::BorderBlockEndColor(..) => LonghandId::BorderBlockEndColor,
            PropertyDeclaration::BorderBlockStartColor(..) => LonghandId::BorderBlockStartColor,
            PropertyDeclaration::BorderBottomColor(..) => LonghandId::BorderBottomColor,
            PropertyDeclaration::BorderInlineEndColor(..) => LonghandId::BorderInlineEndColor,
            PropertyDeclaration::BorderInlineStartColor(..) => LonghandId::BorderInlineStartColor,
            PropertyDeclaration::BorderLeftColor(..) => LonghandId::BorderLeftColor,
            PropertyDeclaration::BorderRightColor(..) => LonghandId::BorderRightColor,
            PropertyDeclaration::BorderTopColor(..) => LonghandId::BorderTopColor,
            PropertyDeclaration::ColumnRuleColor(..) => LonghandId::ColumnRuleColor,
            PropertyDeclaration::FloodColor(..) => LonghandId::FloodColor,
            PropertyDeclaration::LightingColor(..) => LonghandId::LightingColor,
            PropertyDeclaration::OutlineColor(..) => LonghandId::OutlineColor,
            PropertyDeclaration::StopColor(..) => LonghandId::StopColor,
            PropertyDeclaration::TextDecorationColor(..) => LonghandId::TextDecorationColor,
            PropertyDeclaration::TextEmphasisColor(..) => LonghandId::TextEmphasisColor,
            PropertyDeclaration::WebkitTextFillColor(..) => LonghandId::WebkitTextFillColor,
            PropertyDeclaration::WebkitTextStrokeColor(..) => LonghandId::WebkitTextStrokeColor,
            _ => id,
        });
        PropertyDeclarationId::Longhand(id)
    }

    /// Given a declaration, convert it into a declaration for a corresponding
    /// physical property.
    #[inline]
    pub fn to_physical(&self, wm: WritingMode) -> Self {
        match *self {
            PropertyDeclaration::WithVariables(VariableDeclaration {
                id,
                ref value,
            }) => {
                return PropertyDeclaration::WithVariables(VariableDeclaration {
                    id: id.to_physical(wm),
                    value: value.clone(),
                })
            }
            PropertyDeclaration::CSSWideKeyword(WideKeywordDeclaration {
                id,
                keyword,
            }) => {
                return PropertyDeclaration::CSSWideKeyword(WideKeywordDeclaration {
                    id: id.to_physical(wm),
                    keyword,
                })
            }
            PropertyDeclaration::Custom(..) => return self.clone(),
            PropertyDeclaration::AlignContent(..) => {},
            PropertyDeclaration::AlignItems(..) => {},
            PropertyDeclaration::AlignSelf(..) => {},
            PropertyDeclaration::BackfaceVisibility(..) => {},
            PropertyDeclaration::BorderCollapse(..) => {},
            PropertyDeclaration::BorderImageRepeat(..) => {},
            PropertyDeclaration::BoxDecorationBreak(..) => {},
            PropertyDeclaration::BoxSizing(..) => {},
            PropertyDeclaration::BreakInside(..) => {},
            PropertyDeclaration::CaptionSide(..) => {},
            PropertyDeclaration::Clear(..) => {},
            PropertyDeclaration::ColorAdjust(..) => {},
            PropertyDeclaration::ColorInterpolation(..) => {},
            PropertyDeclaration::ColorInterpolationFilters(..) => {},
            PropertyDeclaration::ColumnCount(..) => {},
            PropertyDeclaration::ColumnFill(..) => {},
            PropertyDeclaration::ColumnSpan(..) => {},
            PropertyDeclaration::Contain(..) => {},
            PropertyDeclaration::Direction(..) => {},
            PropertyDeclaration::Display(..) => {},
            PropertyDeclaration::DominantBaseline(..) => {},
            PropertyDeclaration::EmptyCells(..) => {},
            PropertyDeclaration::FlexDirection(..) => {},
            PropertyDeclaration::FlexWrap(..) => {},
            PropertyDeclaration::Float(..) => {},
            PropertyDeclaration::FontKerning(..) => {},
            PropertyDeclaration::FontOpticalSizing(..) => {},
            PropertyDeclaration::FontSizeAdjust(..) => {},
            PropertyDeclaration::FontStretch(..) => {},
            PropertyDeclaration::FontStyle(..) => {},
            PropertyDeclaration::FontSynthesis(..) => {},
            PropertyDeclaration::FontVariantCaps(..) => {},
            PropertyDeclaration::FontVariantEastAsian(..) => {},
            PropertyDeclaration::FontVariantLigatures(..) => {},
            PropertyDeclaration::FontVariantNumeric(..) => {},
            PropertyDeclaration::FontVariantPosition(..) => {},
            PropertyDeclaration::FontWeight(..) => {},
            PropertyDeclaration::GridAutoFlow(..) => {},
            PropertyDeclaration::Hyphens(..) => {},
            PropertyDeclaration::ImageOrientation(..) => {},
            PropertyDeclaration::ImageRendering(..) => {},
            PropertyDeclaration::ImeMode(..) => {},
            PropertyDeclaration::InitialLetter(..) => {},
            PropertyDeclaration::Isolation(..) => {},
            PropertyDeclaration::JustifyContent(..) => {},
            PropertyDeclaration::JustifyItems(..) => {},
            PropertyDeclaration::JustifySelf(..) => {},
            PropertyDeclaration::ListStylePosition(..) => {},
            PropertyDeclaration::MaskType(..) => {},
            PropertyDeclaration::MixBlendMode(..) => {},
            PropertyDeclaration::MozAppearance(..) => {},
            PropertyDeclaration::MozBoxAlign(..) => {},
            PropertyDeclaration::MozBoxDirection(..) => {},
            PropertyDeclaration::MozBoxOrient(..) => {},
            PropertyDeclaration::MozBoxPack(..) => {},
            PropertyDeclaration::MozControlCharacterVisibility(..) => {},
            PropertyDeclaration::MozFloatEdge(..) => {},
            PropertyDeclaration::MozForceBrokenImageIcon(..) => {},
            PropertyDeclaration::MozListReversed(..) => {},
            PropertyDeclaration::MozMathDisplay(..) => {},
            PropertyDeclaration::MozMathVariant(..) => {},
            PropertyDeclaration::MozMinFontSizeRatio(..) => {},
            PropertyDeclaration::MozOrient(..) => {},
            PropertyDeclaration::MozOsxFontSmoothing(..) => {},
            PropertyDeclaration::MozScriptLevel(..) => {},
            PropertyDeclaration::MozScriptMinSize(..) => {},
            PropertyDeclaration::MozScriptSizeMultiplier(..) => {},
            PropertyDeclaration::MozStackSizing(..) => {},
            PropertyDeclaration::MozTextSizeAdjust(..) => {},
            PropertyDeclaration::MozTopLayer(..) => {},
            PropertyDeclaration::MozUserFocus(..) => {},
            PropertyDeclaration::MozUserInput(..) => {},
            PropertyDeclaration::MozUserModify(..) => {},
            PropertyDeclaration::MozUserSelect(..) => {},
            PropertyDeclaration::MozWindowDragging(..) => {},
            PropertyDeclaration::MozWindowShadow(..) => {},
            PropertyDeclaration::ObjectFit(..) => {},
            PropertyDeclaration::OutlineStyle(..) => {},
            PropertyDeclaration::OverflowAnchor(..) => {},
            PropertyDeclaration::OverflowWrap(..) => {},
            PropertyDeclaration::PaintOrder(..) => {},
            PropertyDeclaration::PointerEvents(..) => {},
            PropertyDeclaration::Position(..) => {},
            PropertyDeclaration::Resize(..) => {},
            PropertyDeclaration::RubyAlign(..) => {},
            PropertyDeclaration::RubyPosition(..) => {},
            PropertyDeclaration::ScrollBehavior(..) => {},
            PropertyDeclaration::ScrollSnapAlign(..) => {},
            PropertyDeclaration::ScrollSnapType(..) => {},
            PropertyDeclaration::ScrollbarWidth(..) => {},
            PropertyDeclaration::ShapeRendering(..) => {},
            PropertyDeclaration::StrokeLinecap(..) => {},
            PropertyDeclaration::StrokeLinejoin(..) => {},
            PropertyDeclaration::TableLayout(..) => {},
            PropertyDeclaration::TextAlign(..) => {},
            PropertyDeclaration::TextAlignLast(..) => {},
            PropertyDeclaration::TextAnchor(..) => {},
            PropertyDeclaration::TextCombineUpright(..) => {},
            PropertyDeclaration::TextDecorationLine(..) => {},
            PropertyDeclaration::TextDecorationStyle(..) => {},
            PropertyDeclaration::TextEmphasisPosition(..) => {},
            PropertyDeclaration::TextJustify(..) => {},
            PropertyDeclaration::TextOrientation(..) => {},
            PropertyDeclaration::TextRendering(..) => {},
            PropertyDeclaration::TextTransform(..) => {},
            PropertyDeclaration::TouchAction(..) => {},
            PropertyDeclaration::TransformBox(..) => {},
            PropertyDeclaration::TransformStyle(..) => {},
            PropertyDeclaration::UnicodeBidi(..) => {},
            PropertyDeclaration::VectorEffect(..) => {},
            PropertyDeclaration::Visibility(..) => {},
            PropertyDeclaration::WebkitLineClamp(..) => {},
            PropertyDeclaration::WhiteSpace(..) => {},
            PropertyDeclaration::WordBreak(..) => {},
            PropertyDeclaration::WritingMode(..) => {},
            PropertyDeclaration::XSpan(..) => {},
            PropertyDeclaration::XTextZoom(..) => {},
            PropertyDeclaration::ZIndex(..) => {},
            PropertyDeclaration::BreakAfter(..) => {},
            PropertyDeclaration::BreakBefore(..) => {},
            PropertyDeclaration::ClipRule(..) => {},
            PropertyDeclaration::FillRule(..) => {},
            PropertyDeclaration::MozBoxOrdinalGroup(..) => {},
            PropertyDeclaration::Order(..) => {},
            PropertyDeclaration::OverflowX(..) => {},
            PropertyDeclaration::OverflowY(..) => {},
            PropertyDeclaration::OverflowClipBoxBlock(..) => {},
            PropertyDeclaration::OverflowClipBoxInline(..) => {},
            PropertyDeclaration::OverscrollBehaviorX(..) => {},
            PropertyDeclaration::OverscrollBehaviorY(..) => {},
            PropertyDeclaration::FillOpacity(..) => {},
            PropertyDeclaration::StrokeOpacity(..) => {},
            PropertyDeclaration::FlexGrow(..) => {},
            PropertyDeclaration::FlexShrink(..) => {},
            PropertyDeclaration::MozBoxFlex(..) => {},
            PropertyDeclaration::StrokeMiterlimit(..) => {},
            PropertyDeclaration::FloodOpacity(..) => {},
            PropertyDeclaration::MozWindowOpacity(..) => {},
            PropertyDeclaration::Opacity(..) => {},
            PropertyDeclaration::ShapeImageThreshold(..) => {},
            PropertyDeclaration::StopOpacity(..) => {},
            PropertyDeclaration::BorderBlockEndStyle(..) => {},
            PropertyDeclaration::BorderBlockStartStyle(..) => {},
            PropertyDeclaration::BorderBottomStyle(..) => {},
            PropertyDeclaration::BorderInlineEndStyle(..) => {},
            PropertyDeclaration::BorderInlineStartStyle(..) => {},
            PropertyDeclaration::BorderLeftStyle(..) => {},
            PropertyDeclaration::BorderRightStyle(..) => {},
            PropertyDeclaration::BorderTopStyle(..) => {},
            PropertyDeclaration::ColumnRuleStyle(..) => {},
            PropertyDeclaration::AnimationDelay(..) => {},
            PropertyDeclaration::AnimationDirection(..) => {},
            PropertyDeclaration::AnimationDuration(..) => {},
            PropertyDeclaration::AnimationFillMode(..) => {},
            PropertyDeclaration::AnimationIterationCount(..) => {},
            PropertyDeclaration::AnimationName(..) => {},
            PropertyDeclaration::AnimationPlayState(..) => {},
            PropertyDeclaration::AnimationTimingFunction(..) => {},
            PropertyDeclaration::BackgroundAttachment(..) => {},
            PropertyDeclaration::BackgroundBlendMode(..) => {},
            PropertyDeclaration::BackgroundClip(..) => {},
            PropertyDeclaration::BackgroundImage(..) => {},
            PropertyDeclaration::BackgroundOrigin(..) => {},
            PropertyDeclaration::BackgroundPositionX(..) => {},
            PropertyDeclaration::BackgroundPositionY(..) => {},
            PropertyDeclaration::BackgroundRepeat(..) => {},
            PropertyDeclaration::BackgroundSize(..) => {},
            PropertyDeclaration::BorderImageOutset(..) => {},
            PropertyDeclaration::BorderImageSlice(..) => {},
            PropertyDeclaration::BorderImageSource(..) => {},
            PropertyDeclaration::BorderImageWidth(..) => {},
            PropertyDeclaration::BorderSpacing(..) => {},
            PropertyDeclaration::BoxShadow(..) => {},
            PropertyDeclaration::CaretColor(..) => {},
            PropertyDeclaration::ClipPath(..) => {},
            PropertyDeclaration::Color(..) => {},
            PropertyDeclaration::ColumnWidth(..) => {},
            PropertyDeclaration::Content(..) => {},
            PropertyDeclaration::CounterIncrement(..) => {},
            PropertyDeclaration::Cursor(..) => {},
            PropertyDeclaration::Filter(..) => {},
            PropertyDeclaration::FlexBasis(..) => {},
            PropertyDeclaration::FontFamily(..) => {},
            PropertyDeclaration::FontFeatureSettings(..) => {},
            PropertyDeclaration::FontLanguageOverride(..) => {},
            PropertyDeclaration::FontSize(..) => {},
            PropertyDeclaration::FontVariantAlternates(..) => {},
            PropertyDeclaration::FontVariationSettings(..) => {},
            PropertyDeclaration::GridTemplateAreas(..) => {},
            PropertyDeclaration::LetterSpacing(..) => {},
            PropertyDeclaration::LineHeight(..) => {},
            PropertyDeclaration::ListStyleImage(..) => {},
            PropertyDeclaration::ListStyleType(..) => {},
            PropertyDeclaration::MaskClip(..) => {},
            PropertyDeclaration::MaskComposite(..) => {},
            PropertyDeclaration::MaskImage(..) => {},
            PropertyDeclaration::MaskMode(..) => {},
            PropertyDeclaration::MaskOrigin(..) => {},
            PropertyDeclaration::MaskPositionX(..) => {},
            PropertyDeclaration::MaskPositionY(..) => {},
            PropertyDeclaration::MaskRepeat(..) => {},
            PropertyDeclaration::MaskSize(..) => {},
            PropertyDeclaration::MozContextProperties(..) => {},
            PropertyDeclaration::MozFontSmoothingBackgroundColor(..) => {},
            PropertyDeclaration::MozTabSize(..) => {},
            PropertyDeclaration::OffsetPath(..) => {},
            PropertyDeclaration::Perspective(..) => {},
            PropertyDeclaration::Quotes(..) => {},
            PropertyDeclaration::Rotate(..) => {},
            PropertyDeclaration::Scale(..) => {},
            PropertyDeclaration::ScrollSnapCoordinate(..) => {},
            PropertyDeclaration::ScrollbarColor(..) => {},
            PropertyDeclaration::ShapeOutside(..) => {},
            PropertyDeclaration::StrokeDasharray(..) => {},
            PropertyDeclaration::StrokeDashoffset(..) => {},
            PropertyDeclaration::StrokeWidth(..) => {},
            PropertyDeclaration::TextEmphasisStyle(..) => {},
            PropertyDeclaration::TextIndent(..) => {},
            PropertyDeclaration::TextOverflow(..) => {},
            PropertyDeclaration::TextShadow(..) => {},
            PropertyDeclaration::TransitionDelay(..) => {},
            PropertyDeclaration::TransitionDuration(..) => {},
            PropertyDeclaration::TransitionProperty(..) => {},
            PropertyDeclaration::TransitionTimingFunction(..) => {},
            PropertyDeclaration::Translate(..) => {},
            PropertyDeclaration::VerticalAlign(..) => {},
            PropertyDeclaration::WillChange(..) => {},
            PropertyDeclaration::WordSpacing(..) => {},
            PropertyDeclaration::XLang(..) => {},
            PropertyDeclaration::Clip(..) => {},
            PropertyDeclaration::MozImageRegion(..) => {},
            PropertyDeclaration::GridTemplateColumns(..) => {},
            PropertyDeclaration::GridTemplateRows(..) => {},
            PropertyDeclaration::Fill(..) => {},
            PropertyDeclaration::Stroke(..) => {},
            PropertyDeclaration::GridAutoColumns(..) => {},
            PropertyDeclaration::GridAutoRows(..) => {},
            PropertyDeclaration::MozWindowTransformOrigin(..) => {},
            PropertyDeclaration::TransformOrigin(..) => {},
            PropertyDeclaration::CounterReset(..) => {},
            PropertyDeclaration::CounterSet(..) => {},
            PropertyDeclaration::ScrollSnapPointsX(..) => {},
            PropertyDeclaration::ScrollSnapPointsY(..) => {},
            PropertyDeclaration::MozWindowTransform(..) => {},
            PropertyDeclaration::Transform(..) => {},
            PropertyDeclaration::ColumnGap(..) => {},
            PropertyDeclaration::RowGap(..) => {},
            PropertyDeclaration::ObjectPosition(..) => {},
            PropertyDeclaration::PerspectiveOrigin(..) => {},
            PropertyDeclaration::ScrollSnapDestination(..) => {},
            PropertyDeclaration::GridColumnEnd(..) => {},
            PropertyDeclaration::GridColumnStart(..) => {},
            PropertyDeclaration::GridRowEnd(..) => {},
            PropertyDeclaration::GridRowStart(..) => {},
            PropertyDeclaration::MaxBlockSize(..) => {},
            PropertyDeclaration::MaxHeight(..) => {},
            PropertyDeclaration::MaxInlineSize(..) => {},
            PropertyDeclaration::MaxWidth(..) => {},
            PropertyDeclaration::MarkerEnd(..) => {},
            PropertyDeclaration::MarkerMid(..) => {},
            PropertyDeclaration::MarkerStart(..) => {},
            PropertyDeclaration::MozBinding(..) => {},
            PropertyDeclaration::ScrollPaddingBlockEnd(..) => {},
            PropertyDeclaration::ScrollPaddingBlockStart(..) => {},
            PropertyDeclaration::ScrollPaddingBottom(..) => {},
            PropertyDeclaration::ScrollPaddingInlineEnd(..) => {},
            PropertyDeclaration::ScrollPaddingInlineStart(..) => {},
            PropertyDeclaration::ScrollPaddingLeft(..) => {},
            PropertyDeclaration::ScrollPaddingRight(..) => {},
            PropertyDeclaration::ScrollPaddingTop(..) => {},
            PropertyDeclaration::BlockSize(..) => {},
            PropertyDeclaration::Height(..) => {},
            PropertyDeclaration::InlineSize(..) => {},
            PropertyDeclaration::MinBlockSize(..) => {},
            PropertyDeclaration::MinHeight(..) => {},
            PropertyDeclaration::MinInlineSize(..) => {},
            PropertyDeclaration::MinWidth(..) => {},
            PropertyDeclaration::Width(..) => {},
            PropertyDeclaration::OutlineOffset(..) => {},
            PropertyDeclaration::ScrollMarginBlockEnd(..) => {},
            PropertyDeclaration::ScrollMarginBlockStart(..) => {},
            PropertyDeclaration::ScrollMarginBottom(..) => {},
            PropertyDeclaration::ScrollMarginInlineEnd(..) => {},
            PropertyDeclaration::ScrollMarginInlineStart(..) => {},
            PropertyDeclaration::ScrollMarginLeft(..) => {},
            PropertyDeclaration::ScrollMarginRight(..) => {},
            PropertyDeclaration::ScrollMarginTop(..) => {},
            PropertyDeclaration::PaddingBlockEnd(..) => {},
            PropertyDeclaration::PaddingBlockStart(..) => {},
            PropertyDeclaration::PaddingBottom(..) => {},
            PropertyDeclaration::PaddingInlineEnd(..) => {},
            PropertyDeclaration::PaddingInlineStart(..) => {},
            PropertyDeclaration::PaddingLeft(..) => {},
            PropertyDeclaration::PaddingRight(..) => {},
            PropertyDeclaration::PaddingTop(..) => {},
            PropertyDeclaration::ShapeMargin(..) => {},
            PropertyDeclaration::BorderBlockEndWidth(..) => {},
            PropertyDeclaration::BorderBlockStartWidth(..) => {},
            PropertyDeclaration::BorderBottomWidth(..) => {},
            PropertyDeclaration::BorderInlineEndWidth(..) => {},
            PropertyDeclaration::BorderInlineStartWidth(..) => {},
            PropertyDeclaration::BorderLeftWidth(..) => {},
            PropertyDeclaration::BorderRightWidth(..) => {},
            PropertyDeclaration::BorderTopWidth(..) => {},
            PropertyDeclaration::ColumnRuleWidth(..) => {},
            PropertyDeclaration::OutlineWidth(..) => {},
            PropertyDeclaration::WebkitTextStrokeWidth(..) => {},
            PropertyDeclaration::BorderBottomLeftRadius(..) => {},
            PropertyDeclaration::BorderBottomRightRadius(..) => {},
            PropertyDeclaration::BorderEndEndRadius(..) => {},
            PropertyDeclaration::BorderEndStartRadius(..) => {},
            PropertyDeclaration::BorderStartEndRadius(..) => {},
            PropertyDeclaration::BorderStartStartRadius(..) => {},
            PropertyDeclaration::BorderTopLeftRadius(..) => {},
            PropertyDeclaration::BorderTopRightRadius(..) => {},
            PropertyDeclaration::MozOutlineRadiusBottomleft(..) => {},
            PropertyDeclaration::MozOutlineRadiusBottomright(..) => {},
            PropertyDeclaration::MozOutlineRadiusTopleft(..) => {},
            PropertyDeclaration::MozOutlineRadiusTopright(..) => {},
            PropertyDeclaration::Bottom(..) => {},
            PropertyDeclaration::InsetBlockEnd(..) => {},
            PropertyDeclaration::InsetBlockStart(..) => {},
            PropertyDeclaration::InsetInlineEnd(..) => {},
            PropertyDeclaration::InsetInlineStart(..) => {},
            PropertyDeclaration::Left(..) => {},
            PropertyDeclaration::MarginBlockEnd(..) => {},
            PropertyDeclaration::MarginBlockStart(..) => {},
            PropertyDeclaration::MarginBottom(..) => {},
            PropertyDeclaration::MarginInlineEnd(..) => {},
            PropertyDeclaration::MarginInlineStart(..) => {},
            PropertyDeclaration::MarginLeft(..) => {},
            PropertyDeclaration::MarginRight(..) => {},
            PropertyDeclaration::MarginTop(..) => {},
            PropertyDeclaration::Right(..) => {},
            PropertyDeclaration::Top(..) => {},
            PropertyDeclaration::BackgroundColor(..) => {},
            PropertyDeclaration::BorderBlockEndColor(..) => {},
            PropertyDeclaration::BorderBlockStartColor(..) => {},
            PropertyDeclaration::BorderBottomColor(..) => {},
            PropertyDeclaration::BorderInlineEndColor(..) => {},
            PropertyDeclaration::BorderInlineStartColor(..) => {},
            PropertyDeclaration::BorderLeftColor(..) => {},
            PropertyDeclaration::BorderRightColor(..) => {},
            PropertyDeclaration::BorderTopColor(..) => {},
            PropertyDeclaration::ColumnRuleColor(..) => {},
            PropertyDeclaration::FloodColor(..) => {},
            PropertyDeclaration::LightingColor(..) => {},
            PropertyDeclaration::OutlineColor(..) => {},
            PropertyDeclaration::StopColor(..) => {},
            PropertyDeclaration::TextDecorationColor(..) => {},
            PropertyDeclaration::TextEmphasisColor(..) => {},
            PropertyDeclaration::WebkitTextFillColor(..) => {},
            PropertyDeclaration::WebkitTextStrokeColor(..) => {},
        }

        let mut ret = self.clone();


        unsafe {
            let longhand_id = *(&mut ret as *mut _ as *mut LonghandId);

            debug_assert_eq!(
                PropertyDeclarationId::Longhand(longhand_id),
                ret.id()
            );

            // This is just fine because PropertyDeclaration and LonghandId
            // have corresponding discriminants.
            *(&mut ret as *mut _ as *mut LonghandId) = longhand_id.to_physical(wm);

            debug_assert_eq!(
                PropertyDeclarationId::Longhand(longhand_id.to_physical(wm)),
                ret.id()
            );
        }

        ret
    }

    fn with_variables_from_shorthand(&self, shorthand: ShorthandId) -> Option< &str> {
        match *self {
            PropertyDeclaration::WithVariables(ref declaration) => {
                let s = declaration.value.from_shorthand?;
                if s != shorthand {
                    return None;
                }
                Some(&*declaration.value.css)
            },
            _ => None,
        }
    }

    /// Returns a CSS-wide keyword if the declaration's value is one.
    #[inline]
    pub fn get_css_wide_keyword(&self) -> Option<CSSWideKeyword> {
        match *self {
            PropertyDeclaration::CSSWideKeyword(ref declaration) => {
                Some(declaration.keyword)
            },
            _ => None,
        }
    }

    /// Returns whether or not the property is set by a system font
    pub fn get_system(&self) -> Option<SystemFont> {
        match *self {
                PropertyDeclaration::FontFamily(ref prop) => {
                    prop.get_system()
                }
                PropertyDeclaration::FontSize(ref prop) => {
                    prop.get_system()
                }
                PropertyDeclaration::FontStyle(ref prop) => {
                    prop.get_system()
                }
                PropertyDeclaration::FontVariantCaps(ref prop) => {
                    prop.get_system()
                }
                PropertyDeclaration::FontStretch(ref prop) => {
                    prop.get_system()
                }
                PropertyDeclaration::FontKerning(ref prop) => {
                    prop.get_system()
                }
                PropertyDeclaration::FontVariantPosition(ref prop) => {
                    prop.get_system()
                }
                PropertyDeclaration::FontWeight(ref prop) => {
                    prop.get_system()
                }
                PropertyDeclaration::FontSizeAdjust(ref prop) => {
                    prop.get_system()
                }
                PropertyDeclaration::FontVariantAlternates(ref prop) => {
                    prop.get_system()
                }
                PropertyDeclaration::FontVariantLigatures(ref prop) => {
                    prop.get_system()
                }
                PropertyDeclaration::FontVariantEastAsian(ref prop) => {
                    prop.get_system()
                }
                PropertyDeclaration::FontVariantNumeric(ref prop) => {
                    prop.get_system()
                }
                PropertyDeclaration::FontLanguageOverride(ref prop) => {
                    prop.get_system()
                }
                PropertyDeclaration::FontFeatureSettings(ref prop) => {
                    prop.get_system()
                }
                PropertyDeclaration::FontVariationSettings(ref prop) => {
                    prop.get_system()
                }
                PropertyDeclaration::FontOpticalSizing(ref prop) => {
                    prop.get_system()
                }
            _ => None,
        }
    }

    /// Is it the default value of line-height?
    pub fn is_default_line_height(&self) -> bool {
        match *self {
            PropertyDeclaration::LineHeight(LineHeight::Normal) => true,
            _ => false
        }
    }

    /// Returns whether the declaration may be serialized as part of a shorthand.
    ///
    /// This method returns false if this declaration contains variable or has a
    /// CSS-wide keyword value, since these values cannot be serialized as part
    /// of a shorthand.
    ///
    /// Caller should check `with_variables_from_shorthand()` and whether all
    /// needed declarations has the same CSS-wide keyword first.
    ///
    /// Note that, serialization of a shorthand may still fail because of other
    /// property-specific requirement even when this method returns true for all
    /// the longhand declarations.
    pub fn may_serialize_as_part_of_shorthand(&self) -> bool {
        match *self {
            PropertyDeclaration::CSSWideKeyword(..) |
            PropertyDeclaration::WithVariables(..) => false,
            PropertyDeclaration::Custom(..) =>
                unreachable!("Serializing a custom property as part of shorthand?"),
            _ => true,
        }
    }

    /// Return whether the value is stored as it was in the CSS source,
    /// preserving whitespace (as opposed to being parsed into a more abstract
    /// data structure).
    ///
    /// This is the case of custom properties and values that contain
    /// unsubstituted variables.
    pub fn value_is_unparsed(&self) -> bool {
        match *self {
            PropertyDeclaration::WithVariables(..) => true,
            PropertyDeclaration::Custom(ref declaration) => {
                matches!(declaration.value, CustomDeclarationValue::Value(..))
            }
            _ => false,
        }
    }

    /// Returns true if this property declaration is for one of the animatable
    /// properties.
    pub fn is_animatable(&self) -> bool {
        match self.id() {
            PropertyDeclarationId::Longhand(id) => id.is_animatable(),
            PropertyDeclarationId::Custom(..) => false,
        }
    }

    /// Returns true if this property is a custom property, false
    /// otherwise.
    pub fn is_custom(&self) -> bool {
        matches!(*self, PropertyDeclaration::Custom(..))
    }

    /// The `context` parameter controls this:
    ///
    /// <https://drafts.csswg.org/css-animations/#keyframes>
    /// > The <declaration-list> inside of <keyframe-block> accepts any CSS property
    /// > except those defined in this specification,
    /// > but does accept the `animation-play-state` property and interprets it specially.
    ///
    /// This will not actually parse Importance values, and will always set things
    /// to Importance::Normal. Parsing Importance values is the job of PropertyDeclarationParser,
    /// we only set them here so that we don't have to reallocate
    pub fn parse_into<'i, 't>(
        declarations: &mut SourcePropertyDeclaration,
        id: PropertyId,
        context: &ParserContext,
        input: &mut Parser<'i, 't>,
    ) -> Result<(), ParseError<'i>> {
        assert!(declarations.is_empty());
        debug_assert!(id.allowed_in(context), "{:?}", id);

        let non_custom_id = id.non_custom_id();
        let start = input.state();
        match id {
            PropertyId::Custom(property_name) => {
                // FIXME: fully implement https://github.com/w3c/csswg-drafts/issues/774
                // before adding skip_whitespace here.
                // This probably affects some test results.
                let value = match input.try(CSSWideKeyword::parse) {
                    Ok(keyword) => CustomDeclarationValue::CSSWideKeyword(keyword),
                    Err(()) => CustomDeclarationValue::Value(
                        crate::custom_properties::SpecifiedValue::parse(input)?
                    ),
                };
                declarations.push(PropertyDeclaration::Custom(CustomDeclaration {
                    name: property_name,
                    value,
                }));
                return Ok(());
            }
            PropertyId::LonghandAlias(id, _) |
            PropertyId::Longhand(id) => {
                input.skip_whitespace();  // Unnecessary for correctness, but may help try() rewind less.
                input.try(CSSWideKeyword::parse).map(|keyword| {
                    PropertyDeclaration::CSSWideKeyword(
                        WideKeywordDeclaration { id, keyword },
                    )
                }).or_else(|()| {
                    input.look_for_var_or_env_functions();
                    input.parse_entirely(|input| id.parse_value(context, input))
                    .or_else(|err| {
                        while let Ok(_) = input.next() {}  // Look for var() after the error.
                        if !input.seen_var_or_env_functions() {
                            return Err(err);
                        }
                        input.reset(&start);
                        let (first_token_type, css) =
                            crate::custom_properties::parse_non_custom_with_var(input)?;
                        Ok(PropertyDeclaration::WithVariables(VariableDeclaration {
                            id,
                            value: Arc::new(UnparsedValue {
                                css: css.into_owned(),
                                first_token_type: first_token_type,
                                url_data: context.url_data.clone(),
                                from_shorthand: None,
                            }),
                        }))
                    })
                }).map(|declaration| {
                    declarations.push(declaration)
                })?;
            }
            PropertyId::ShorthandAlias(id, _) |
            PropertyId::Shorthand(id) => {
                input.skip_whitespace();  // Unnecessary for correctness, but may help try() rewind less.
                if let Ok(keyword) = input.try(CSSWideKeyword::parse) {
                    if id == ShorthandId::All {
                        declarations.all_shorthand = AllShorthand::CSSWideKeyword(keyword)
                    } else {
                        for longhand in id.longhands() {
                            declarations.push(PropertyDeclaration::CSSWideKeyword(
                                WideKeywordDeclaration {
                                    id: longhand,
                                    keyword,
                                },
                            ))
                        }
                    }
                } else {
                    input.look_for_var_or_env_functions();
                    // Not using parse_entirely here: each
                    // mask_position::parse_into function needs to do so
                    // *before* pushing to `declarations`.
                    id.parse_into(declarations, context, input).or_else(|err| {
                        while let Ok(_) = input.next() {}  // Look for var() after the error.
                        if !input.seen_var_or_env_functions() {
                            return Err(err);
                        }

                        input.reset(&start);
                        let (first_token_type, css) =
                            crate::custom_properties::parse_non_custom_with_var(input)?;
                        let unparsed = Arc::new(UnparsedValue {
                            css: css.into_owned(),
                            first_token_type: first_token_type,
                            url_data: context.url_data.clone(),
                            from_shorthand: Some(id),
                        });
                        if id == ShorthandId::All {
                            declarations.all_shorthand = AllShorthand::WithVariables(unparsed)
                        } else {
                            for id in id.longhands() {
                                declarations.push(
                                    PropertyDeclaration::WithVariables(VariableDeclaration {
                                        id,
                                        value: unparsed.clone(),
                                    })
                                )
                            }
                        }
                        Ok(())
                    })?;
                }
            }
        }
        debug_assert!(non_custom_id.is_some(), "Custom properties should've returned earlier");
        if let Some(use_counters) = context.use_counters {
            use_counters.non_custom_properties.record(non_custom_id.unwrap());
        }
        Ok(())
    }
}

type SubpropertiesArray<T> =
    [T; 18];

type SubpropertiesVec<T> = ArrayVec<SubpropertiesArray<T>>;

/// A stack-allocated vector of `PropertyDeclaration`
/// large enough to parse one CSS `key: value` declaration.
/// (Shorthands expand to multiple `PropertyDeclaration`s.)
pub struct SourcePropertyDeclaration {
    declarations: SubpropertiesVec<PropertyDeclaration>,

    /// Stored separately to keep SubpropertiesVec smaller.
    all_shorthand: AllShorthand,
}

impl SourcePropertyDeclaration {
    /// Create one. It’s big, try not to move it around.
    #[inline]
    pub fn new() -> Self {
        SourcePropertyDeclaration {
            declarations: ::arrayvec::ArrayVec::new(),
            all_shorthand: AllShorthand::NotSet,
        }
    }

    /// Similar to Vec::drain: leaves this empty when the return value is dropped.
    pub fn drain(&mut self) -> SourcePropertyDeclarationDrain {
        SourcePropertyDeclarationDrain {
            declarations: self.declarations.drain(..),
            all_shorthand: mem::replace(&mut self.all_shorthand, AllShorthand::NotSet),
        }
    }

    /// Reset to initial state
    pub fn clear(&mut self) {
        self.declarations.clear();
        self.all_shorthand = AllShorthand::NotSet;
    }

    fn is_empty(&self) -> bool {
        self.declarations.is_empty() && matches!(self.all_shorthand, AllShorthand::NotSet)
    }

    fn push(&mut self, declaration: PropertyDeclaration) {
        let _result = self.declarations.try_push(declaration);
        debug_assert!(_result.is_ok());
    }
}

/// Return type of SourcePropertyDeclaration::drain
pub struct SourcePropertyDeclarationDrain<'a> {
    declarations: ArrayVecDrain<'a, SubpropertiesArray<PropertyDeclaration>>,
    all_shorthand: AllShorthand,
}

enum AllShorthand {
    NotSet,
    CSSWideKeyword(CSSWideKeyword),
    WithVariables(Arc<UnparsedValue>)
}

impl AllShorthand {
    /// Iterates property declarations from the given all shorthand value.
    #[inline]
    fn declarations(&self) -> AllShorthandDeclarationIterator {
        AllShorthandDeclarationIterator {
            all_shorthand: self,
            longhands: ShorthandId::All.longhands(),
        }
    }
}

struct AllShorthandDeclarationIterator<'a> {
    all_shorthand: &'a AllShorthand,
    longhands: NonCustomPropertyIterator<LonghandId>,
}

impl<'a> Iterator for AllShorthandDeclarationIterator<'a> {
    type Item = PropertyDeclaration;

    #[inline]
    fn next(&mut self) -> Option<Self::Item> {
        match *self.all_shorthand {
            AllShorthand::NotSet => None,
            AllShorthand::CSSWideKeyword(ref keyword) => {
                Some(PropertyDeclaration::CSSWideKeyword(
                    WideKeywordDeclaration {
                        id: self.longhands.next()?,
                        keyword: *keyword
                    }
                ))
            }
            AllShorthand::WithVariables(ref unparsed) => {
                Some(PropertyDeclaration::WithVariables(
                    VariableDeclaration {
                        id: self.longhands.next()?,
                        value: unparsed.clone()
                    }
                ))
            }
        }
    }
}

#[cfg(feature = "gecko")]
pub use crate::gecko_properties::style_structs;

/// The module where all the style structs are defined.
#[cfg(feature = "servo")]
pub mod style_structs {
    use fxhash::FxHasher;
    use super::longhands;
    use std::hash::{Hash, Hasher};
    use crate::logical_geometry::WritingMode;
    use crate::media_queries::Device;
    use crate::values::computed::NonNegativeLength;

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The Background style struct.
        pub struct Background {
                /// The background-color computed value.
                pub background_color: longhands::background_color::computed_value::T,
                /// The background-image computed value.
                pub background_image: longhands::background_image::computed_value::T,
                /// The background-position-x computed value.
                pub background_position_x: longhands::background_position_x::computed_value::T,
                /// The background-position-y computed value.
                pub background_position_y: longhands::background_position_y::computed_value::T,
                /// The background-repeat computed value.
                pub background_repeat: longhands::background_repeat::computed_value::T,
                /// The background-attachment computed value.
                pub background_attachment: longhands::background_attachment::computed_value::T,
                /// The background-clip computed value.
                pub background_clip: longhands::background_clip::computed_value::T,
                /// The background-origin computed value.
                pub background_origin: longhands::background_origin::computed_value::T,
                /// The background-size computed value.
                pub background_size: longhands::background_size::computed_value::T,
                /// The background-blend-mode computed value.
                pub background_blend_mode: longhands::background_blend_mode::computed_value::T,
        }

        impl Background {
                        /// Set background-color.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_background_color(&mut self, v: longhands::background_color::computed_value::T) {
                            self.background_color = v;
                        }
                        /// Set background-color from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_background_color_from(&mut self, other: &Self) {
                            self.background_color = other.background_color.clone();
                        }
                    /// Reset background-color from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_background_color(&mut self, other: &Self) {
                        self.copy_background_color_from(other)
                    }

                    /// Get the computed value for background-color.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_background_color(&self) -> longhands::background_color::computed_value::T {
                        self.background_color.clone()
                    }
                        /// Set background-image.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_background_image<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::background_image
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.background_image = longhands::background_image::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set background-image from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_background_image_from(&mut self, other: &Self) {
                            self.background_image = other.background_image.clone();
                        }
                    /// Reset background-image from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_background_image(&mut self, other: &Self) {
                        self.copy_background_image_from(other)
                    }

                    /// Get the computed value for background-image.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_background_image(&self) -> longhands::background_image::computed_value::T {
                        self.background_image.clone()
                    }
                        /// Set background-position-x.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_background_position_x<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::background_position_x
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.background_position_x = longhands::background_position_x::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set background-position-x from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_background_position_x_from(&mut self, other: &Self) {
                            self.background_position_x = other.background_position_x.clone();
                        }
                    /// Reset background-position-x from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_background_position_x(&mut self, other: &Self) {
                        self.copy_background_position_x_from(other)
                    }

                    /// Get the computed value for background-position-x.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_background_position_x(&self) -> longhands::background_position_x::computed_value::T {
                        self.background_position_x.clone()
                    }
                        /// Set background-position-y.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_background_position_y<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::background_position_y
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.background_position_y = longhands::background_position_y::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set background-position-y from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_background_position_y_from(&mut self, other: &Self) {
                            self.background_position_y = other.background_position_y.clone();
                        }
                    /// Reset background-position-y from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_background_position_y(&mut self, other: &Self) {
                        self.copy_background_position_y_from(other)
                    }

                    /// Get the computed value for background-position-y.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_background_position_y(&self) -> longhands::background_position_y::computed_value::T {
                        self.background_position_y.clone()
                    }
                        /// Set background-repeat.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_background_repeat<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::background_repeat
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.background_repeat = longhands::background_repeat::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set background-repeat from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_background_repeat_from(&mut self, other: &Self) {
                            self.background_repeat = other.background_repeat.clone();
                        }
                    /// Reset background-repeat from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_background_repeat(&mut self, other: &Self) {
                        self.copy_background_repeat_from(other)
                    }

                    /// Get the computed value for background-repeat.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_background_repeat(&self) -> longhands::background_repeat::computed_value::T {
                        self.background_repeat.clone()
                    }
                        /// Set background-attachment.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_background_attachment<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::background_attachment
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.background_attachment = longhands::background_attachment::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set background-attachment from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_background_attachment_from(&mut self, other: &Self) {
                            self.background_attachment = other.background_attachment.clone();
                        }
                    /// Reset background-attachment from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_background_attachment(&mut self, other: &Self) {
                        self.copy_background_attachment_from(other)
                    }

                    /// Get the computed value for background-attachment.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_background_attachment(&self) -> longhands::background_attachment::computed_value::T {
                        self.background_attachment.clone()
                    }
                        /// Set background-clip.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_background_clip<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::background_clip
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.background_clip = longhands::background_clip::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set background-clip from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_background_clip_from(&mut self, other: &Self) {
                            self.background_clip = other.background_clip.clone();
                        }
                    /// Reset background-clip from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_background_clip(&mut self, other: &Self) {
                        self.copy_background_clip_from(other)
                    }

                    /// Get the computed value for background-clip.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_background_clip(&self) -> longhands::background_clip::computed_value::T {
                        self.background_clip.clone()
                    }
                        /// Set background-origin.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_background_origin<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::background_origin
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.background_origin = longhands::background_origin::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set background-origin from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_background_origin_from(&mut self, other: &Self) {
                            self.background_origin = other.background_origin.clone();
                        }
                    /// Reset background-origin from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_background_origin(&mut self, other: &Self) {
                        self.copy_background_origin_from(other)
                    }

                    /// Get the computed value for background-origin.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_background_origin(&self) -> longhands::background_origin::computed_value::T {
                        self.background_origin.clone()
                    }
                        /// Set background-size.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_background_size<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::background_size
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.background_size = longhands::background_size::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set background-size from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_background_size_from(&mut self, other: &Self) {
                            self.background_size = other.background_size.clone();
                        }
                    /// Reset background-size from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_background_size(&mut self, other: &Self) {
                        self.copy_background_size_from(other)
                    }

                    /// Get the computed value for background-size.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_background_size(&self) -> longhands::background_size::computed_value::T {
                        self.background_size.clone()
                    }
                        /// Set background-blend-mode.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_background_blend_mode<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::background_blend_mode
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.background_blend_mode = longhands::background_blend_mode::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set background-blend-mode from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_background_blend_mode_from(&mut self, other: &Self) {
                            self.background_blend_mode = other.background_blend_mode.clone();
                        }
                    /// Reset background-blend-mode from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_background_blend_mode(&mut self, other: &Self) {
                        self.copy_background_blend_mode_from(other)
                    }

                    /// Get the computed value for background-blend-mode.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_background_blend_mode(&self) -> longhands::background_blend_mode::computed_value::T {
                        self.background_blend_mode.clone()
                    }
        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The Border style struct.
        pub struct Border {
                /// The border-top-color computed value.
                pub border_top_color: longhands::border_top_color::computed_value::T,
                /// The border-top-style computed value.
                pub border_top_style: longhands::border_top_style::computed_value::T,
                /// The border-top-width computed value.
                pub border_top_width: longhands::border_top_width::computed_value::T,
                /// The border-right-color computed value.
                pub border_right_color: longhands::border_right_color::computed_value::T,
                /// The border-right-style computed value.
                pub border_right_style: longhands::border_right_style::computed_value::T,
                /// The border-right-width computed value.
                pub border_right_width: longhands::border_right_width::computed_value::T,
                /// The border-bottom-color computed value.
                pub border_bottom_color: longhands::border_bottom_color::computed_value::T,
                /// The border-bottom-style computed value.
                pub border_bottom_style: longhands::border_bottom_style::computed_value::T,
                /// The border-bottom-width computed value.
                pub border_bottom_width: longhands::border_bottom_width::computed_value::T,
                /// The border-left-color computed value.
                pub border_left_color: longhands::border_left_color::computed_value::T,
                /// The border-left-style computed value.
                pub border_left_style: longhands::border_left_style::computed_value::T,
                /// The border-left-width computed value.
                pub border_left_width: longhands::border_left_width::computed_value::T,
                /// The border-block-start-color computed value.
                pub border_block_start_color: longhands::border_block_start_color::computed_value::T,
                /// The border-block-start-style computed value.
                pub border_block_start_style: longhands::border_block_start_style::computed_value::T,
                /// The border-block-start-width computed value.
                pub border_block_start_width: longhands::border_block_start_width::computed_value::T,
                /// The border-block-end-color computed value.
                pub border_block_end_color: longhands::border_block_end_color::computed_value::T,
                /// The border-block-end-style computed value.
                pub border_block_end_style: longhands::border_block_end_style::computed_value::T,
                /// The border-block-end-width computed value.
                pub border_block_end_width: longhands::border_block_end_width::computed_value::T,
                /// The border-inline-start-color computed value.
                pub border_inline_start_color: longhands::border_inline_start_color::computed_value::T,
                /// The border-inline-start-style computed value.
                pub border_inline_start_style: longhands::border_inline_start_style::computed_value::T,
                /// The border-inline-start-width computed value.
                pub border_inline_start_width: longhands::border_inline_start_width::computed_value::T,
                /// The border-inline-end-color computed value.
                pub border_inline_end_color: longhands::border_inline_end_color::computed_value::T,
                /// The border-inline-end-style computed value.
                pub border_inline_end_style: longhands::border_inline_end_style::computed_value::T,
                /// The border-inline-end-width computed value.
                pub border_inline_end_width: longhands::border_inline_end_width::computed_value::T,
                /// The border-top-left-radius computed value.
                pub border_top_left_radius: longhands::border_top_left_radius::computed_value::T,
                /// The border-top-right-radius computed value.
                pub border_top_right_radius: longhands::border_top_right_radius::computed_value::T,
                /// The border-bottom-right-radius computed value.
                pub border_bottom_right_radius: longhands::border_bottom_right_radius::computed_value::T,
                /// The border-bottom-left-radius computed value.
                pub border_bottom_left_radius: longhands::border_bottom_left_radius::computed_value::T,
                /// The border-start-start-radius computed value.
                pub border_start_start_radius: longhands::border_start_start_radius::computed_value::T,
                /// The border-start-end-radius computed value.
                pub border_start_end_radius: longhands::border_start_end_radius::computed_value::T,
                /// The border-end-start-radius computed value.
                pub border_end_start_radius: longhands::border_end_start_radius::computed_value::T,
                /// The border-end-end-radius computed value.
                pub border_end_end_radius: longhands::border_end_end_radius::computed_value::T,
                /// The box-decoration-break computed value.
                pub box_decoration_break: longhands::box_decoration_break::computed_value::T,
                /// The -moz-float-edge computed value.
                pub _moz_float_edge: longhands::_moz_float_edge::computed_value::T,
                /// The border-image-source computed value.
                pub border_image_source: longhands::border_image_source::computed_value::T,
                /// The border-image-outset computed value.
                pub border_image_outset: longhands::border_image_outset::computed_value::T,
                /// The border-image-repeat computed value.
                pub border_image_repeat: longhands::border_image_repeat::computed_value::T,
                /// The border-image-width computed value.
                pub border_image_width: longhands::border_image_width::computed_value::T,
                /// The border-image-slice computed value.
                pub border_image_slice: longhands::border_image_slice::computed_value::T,
        }

        impl Border {
                        /// Set border-top-color.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_top_color(&mut self, v: longhands::border_top_color::computed_value::T) {
                            self.border_top_color = v;
                        }
                        /// Set border-top-color from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_top_color_from(&mut self, other: &Self) {
                            self.border_top_color = other.border_top_color.clone();
                        }
                    /// Reset border-top-color from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_top_color(&mut self, other: &Self) {
                        self.copy_border_top_color_from(other)
                    }

                    /// Get the computed value for border-top-color.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_top_color(&self) -> longhands::border_top_color::computed_value::T {
                        self.border_top_color.clone()
                    }
                        /// Set border-top-style.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_top_style(&mut self, v: longhands::border_top_style::computed_value::T) {
                            self.border_top_style = v;
                        }
                        /// Set border-top-style from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_top_style_from(&mut self, other: &Self) {
                            self.border_top_style = other.border_top_style.clone();
                        }
                    /// Reset border-top-style from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_top_style(&mut self, other: &Self) {
                        self.copy_border_top_style_from(other)
                    }

                    /// Get the computed value for border-top-style.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_top_style(&self) -> longhands::border_top_style::computed_value::T {
                        self.border_top_style.clone()
                    }
                        /// Set border-top-width.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_top_width(&mut self, v: longhands::border_top_width::computed_value::T) {
                            self.border_top_width = v;
                        }
                        /// Set border-top-width from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_top_width_from(&mut self, other: &Self) {
                            self.border_top_width = other.border_top_width.clone();
                        }
                    /// Reset border-top-width from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_top_width(&mut self, other: &Self) {
                        self.copy_border_top_width_from(other)
                    }

                    /// Get the computed value for border-top-width.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_top_width(&self) -> longhands::border_top_width::computed_value::T {
                        self.border_top_width.clone()
                    }
                        /// Set border-right-color.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_right_color(&mut self, v: longhands::border_right_color::computed_value::T) {
                            self.border_right_color = v;
                        }
                        /// Set border-right-color from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_right_color_from(&mut self, other: &Self) {
                            self.border_right_color = other.border_right_color.clone();
                        }
                    /// Reset border-right-color from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_right_color(&mut self, other: &Self) {
                        self.copy_border_right_color_from(other)
                    }

                    /// Get the computed value for border-right-color.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_right_color(&self) -> longhands::border_right_color::computed_value::T {
                        self.border_right_color.clone()
                    }
                        /// Set border-right-style.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_right_style(&mut self, v: longhands::border_right_style::computed_value::T) {
                            self.border_right_style = v;
                        }
                        /// Set border-right-style from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_right_style_from(&mut self, other: &Self) {
                            self.border_right_style = other.border_right_style.clone();
                        }
                    /// Reset border-right-style from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_right_style(&mut self, other: &Self) {
                        self.copy_border_right_style_from(other)
                    }

                    /// Get the computed value for border-right-style.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_right_style(&self) -> longhands::border_right_style::computed_value::T {
                        self.border_right_style.clone()
                    }
                        /// Set border-right-width.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_right_width(&mut self, v: longhands::border_right_width::computed_value::T) {
                            self.border_right_width = v;
                        }
                        /// Set border-right-width from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_right_width_from(&mut self, other: &Self) {
                            self.border_right_width = other.border_right_width.clone();
                        }
                    /// Reset border-right-width from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_right_width(&mut self, other: &Self) {
                        self.copy_border_right_width_from(other)
                    }

                    /// Get the computed value for border-right-width.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_right_width(&self) -> longhands::border_right_width::computed_value::T {
                        self.border_right_width.clone()
                    }
                        /// Set border-bottom-color.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_bottom_color(&mut self, v: longhands::border_bottom_color::computed_value::T) {
                            self.border_bottom_color = v;
                        }
                        /// Set border-bottom-color from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_bottom_color_from(&mut self, other: &Self) {
                            self.border_bottom_color = other.border_bottom_color.clone();
                        }
                    /// Reset border-bottom-color from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_bottom_color(&mut self, other: &Self) {
                        self.copy_border_bottom_color_from(other)
                    }

                    /// Get the computed value for border-bottom-color.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_bottom_color(&self) -> longhands::border_bottom_color::computed_value::T {
                        self.border_bottom_color.clone()
                    }
                        /// Set border-bottom-style.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_bottom_style(&mut self, v: longhands::border_bottom_style::computed_value::T) {
                            self.border_bottom_style = v;
                        }
                        /// Set border-bottom-style from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_bottom_style_from(&mut self, other: &Self) {
                            self.border_bottom_style = other.border_bottom_style.clone();
                        }
                    /// Reset border-bottom-style from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_bottom_style(&mut self, other: &Self) {
                        self.copy_border_bottom_style_from(other)
                    }

                    /// Get the computed value for border-bottom-style.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_bottom_style(&self) -> longhands::border_bottom_style::computed_value::T {
                        self.border_bottom_style.clone()
                    }
                        /// Set border-bottom-width.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_bottom_width(&mut self, v: longhands::border_bottom_width::computed_value::T) {
                            self.border_bottom_width = v;
                        }
                        /// Set border-bottom-width from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_bottom_width_from(&mut self, other: &Self) {
                            self.border_bottom_width = other.border_bottom_width.clone();
                        }
                    /// Reset border-bottom-width from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_bottom_width(&mut self, other: &Self) {
                        self.copy_border_bottom_width_from(other)
                    }

                    /// Get the computed value for border-bottom-width.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_bottom_width(&self) -> longhands::border_bottom_width::computed_value::T {
                        self.border_bottom_width.clone()
                    }
                        /// Set border-left-color.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_left_color(&mut self, v: longhands::border_left_color::computed_value::T) {
                            self.border_left_color = v;
                        }
                        /// Set border-left-color from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_left_color_from(&mut self, other: &Self) {
                            self.border_left_color = other.border_left_color.clone();
                        }
                    /// Reset border-left-color from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_left_color(&mut self, other: &Self) {
                        self.copy_border_left_color_from(other)
                    }

                    /// Get the computed value for border-left-color.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_left_color(&self) -> longhands::border_left_color::computed_value::T {
                        self.border_left_color.clone()
                    }
                        /// Set border-left-style.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_left_style(&mut self, v: longhands::border_left_style::computed_value::T) {
                            self.border_left_style = v;
                        }
                        /// Set border-left-style from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_left_style_from(&mut self, other: &Self) {
                            self.border_left_style = other.border_left_style.clone();
                        }
                    /// Reset border-left-style from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_left_style(&mut self, other: &Self) {
                        self.copy_border_left_style_from(other)
                    }

                    /// Get the computed value for border-left-style.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_left_style(&self) -> longhands::border_left_style::computed_value::T {
                        self.border_left_style.clone()
                    }
                        /// Set border-left-width.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_left_width(&mut self, v: longhands::border_left_width::computed_value::T) {
                            self.border_left_width = v;
                        }
                        /// Set border-left-width from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_left_width_from(&mut self, other: &Self) {
                            self.border_left_width = other.border_left_width.clone();
                        }
                    /// Reset border-left-width from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_left_width(&mut self, other: &Self) {
                        self.copy_border_left_width_from(other)
                    }

                    /// Get the computed value for border-left-width.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_left_width(&self) -> longhands::border_left_width::computed_value::T {
                        self.border_left_width.clone()
                    }
                    
    /// Set the appropriate physical property for border-block-start-color given a writing mode.
    pub fn set_border_block_start_color(&mut self,
                                      v: longhands::border_block_start_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-color
    /// given a writing mode.
    pub fn copy_border_block_start_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-color
    /// given a writing mode.
    pub fn reset_border_block_start_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_start_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-start-color given a writing mode.
    pub fn clone_border_block_start_color(&self, wm: WritingMode)
        -> longhands::border_block_start_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for border-block-start-style given a writing mode.
    pub fn set_border_block_start_style(&mut self,
                                      v: longhands::border_block_start_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-style
    /// given a writing mode.
    pub fn copy_border_block_start_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-style
    /// given a writing mode.
    pub fn reset_border_block_start_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_start_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-start-style given a writing mode.
    pub fn clone_border_block_start_style(&self, wm: WritingMode)
        -> longhands::border_block_start_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for border-block-start-width given a writing mode.
    pub fn set_border_block_start_width(&mut self,
                                      v: longhands::border_block_start_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-width
    /// given a writing mode.
    pub fn copy_border_block_start_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-width
    /// given a writing mode.
    pub fn reset_border_block_start_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_start_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-start-width given a writing mode.
    pub fn clone_border_block_start_width(&self, wm: WritingMode)
        -> longhands::border_block_start_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for border-block-end-color given a writing mode.
    pub fn set_border_block_end_color(&mut self,
                                      v: longhands::border_block_end_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-color
    /// given a writing mode.
    pub fn copy_border_block_end_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-color
    /// given a writing mode.
    pub fn reset_border_block_end_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_end_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-end-color given a writing mode.
    pub fn clone_border_block_end_color(&self, wm: WritingMode)
        -> longhands::border_block_end_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for border-block-end-style given a writing mode.
    pub fn set_border_block_end_style(&mut self,
                                      v: longhands::border_block_end_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-style
    /// given a writing mode.
    pub fn copy_border_block_end_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-style
    /// given a writing mode.
    pub fn reset_border_block_end_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_end_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-end-style given a writing mode.
    pub fn clone_border_block_end_style(&self, wm: WritingMode)
        -> longhands::border_block_end_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for border-block-end-width given a writing mode.
    pub fn set_border_block_end_width(&mut self,
                                      v: longhands::border_block_end_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-width
    /// given a writing mode.
    pub fn copy_border_block_end_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-width
    /// given a writing mode.
    pub fn reset_border_block_end_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_end_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-end-width given a writing mode.
    pub fn clone_border_block_end_width(&self, wm: WritingMode)
        -> longhands::border_block_end_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for border-inline-start-color given a writing mode.
    pub fn set_border_inline_start_color(&mut self,
                                      v: longhands::border_inline_start_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-color
    /// given a writing mode.
    pub fn copy_border_inline_start_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-color
    /// given a writing mode.
    pub fn reset_border_inline_start_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_start_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-start-color given a writing mode.
    pub fn clone_border_inline_start_color(&self, wm: WritingMode)
        -> longhands::border_inline_start_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for border-inline-start-style given a writing mode.
    pub fn set_border_inline_start_style(&mut self,
                                      v: longhands::border_inline_start_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-style
    /// given a writing mode.
    pub fn copy_border_inline_start_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-style
    /// given a writing mode.
    pub fn reset_border_inline_start_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_start_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-start-style given a writing mode.
    pub fn clone_border_inline_start_style(&self, wm: WritingMode)
        -> longhands::border_inline_start_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for border-inline-start-width given a writing mode.
    pub fn set_border_inline_start_width(&mut self,
                                      v: longhands::border_inline_start_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-width
    /// given a writing mode.
    pub fn copy_border_inline_start_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-width
    /// given a writing mode.
    pub fn reset_border_inline_start_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_start_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-start-width given a writing mode.
    pub fn clone_border_inline_start_width(&self, wm: WritingMode)
        -> longhands::border_inline_start_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for border-inline-end-color given a writing mode.
    pub fn set_border_inline_end_color(&mut self,
                                      v: longhands::border_inline_end_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-color
    /// given a writing mode.
    pub fn copy_border_inline_end_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-color
    /// given a writing mode.
    pub fn reset_border_inline_end_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_end_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-end-color given a writing mode.
    pub fn clone_border_inline_end_color(&self, wm: WritingMode)
        -> longhands::border_inline_end_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for border-inline-end-style given a writing mode.
    pub fn set_border_inline_end_style(&mut self,
                                      v: longhands::border_inline_end_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-style
    /// given a writing mode.
    pub fn copy_border_inline_end_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-style
    /// given a writing mode.
    pub fn reset_border_inline_end_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_end_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-end-style given a writing mode.
    pub fn clone_border_inline_end_style(&self, wm: WritingMode)
        -> longhands::border_inline_end_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for border-inline-end-width given a writing mode.
    pub fn set_border_inline_end_width(&mut self,
                                      v: longhands::border_inline_end_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-width
    /// given a writing mode.
    pub fn copy_border_inline_end_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-width
    /// given a writing mode.
    pub fn reset_border_inline_end_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_end_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-end-width given a writing mode.
    pub fn clone_border_inline_end_width(&self, wm: WritingMode)
        -> longhands::border_inline_end_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }

                        /// Set border-top-left-radius.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_top_left_radius(&mut self, v: longhands::border_top_left_radius::computed_value::T) {
                            self.border_top_left_radius = v;
                        }
                        /// Set border-top-left-radius from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_top_left_radius_from(&mut self, other: &Self) {
                            self.border_top_left_radius = other.border_top_left_radius.clone();
                        }
                    /// Reset border-top-left-radius from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_top_left_radius(&mut self, other: &Self) {
                        self.copy_border_top_left_radius_from(other)
                    }

                    /// Get the computed value for border-top-left-radius.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_top_left_radius(&self) -> longhands::border_top_left_radius::computed_value::T {
                        self.border_top_left_radius.clone()
                    }
                        /// Set border-top-right-radius.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_top_right_radius(&mut self, v: longhands::border_top_right_radius::computed_value::T) {
                            self.border_top_right_radius = v;
                        }
                        /// Set border-top-right-radius from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_top_right_radius_from(&mut self, other: &Self) {
                            self.border_top_right_radius = other.border_top_right_radius.clone();
                        }
                    /// Reset border-top-right-radius from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_top_right_radius(&mut self, other: &Self) {
                        self.copy_border_top_right_radius_from(other)
                    }

                    /// Get the computed value for border-top-right-radius.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_top_right_radius(&self) -> longhands::border_top_right_radius::computed_value::T {
                        self.border_top_right_radius.clone()
                    }
                        /// Set border-bottom-right-radius.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_bottom_right_radius(&mut self, v: longhands::border_bottom_right_radius::computed_value::T) {
                            self.border_bottom_right_radius = v;
                        }
                        /// Set border-bottom-right-radius from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_bottom_right_radius_from(&mut self, other: &Self) {
                            self.border_bottom_right_radius = other.border_bottom_right_radius.clone();
                        }
                    /// Reset border-bottom-right-radius from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_bottom_right_radius(&mut self, other: &Self) {
                        self.copy_border_bottom_right_radius_from(other)
                    }

                    /// Get the computed value for border-bottom-right-radius.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_bottom_right_radius(&self) -> longhands::border_bottom_right_radius::computed_value::T {
                        self.border_bottom_right_radius.clone()
                    }
                        /// Set border-bottom-left-radius.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_bottom_left_radius(&mut self, v: longhands::border_bottom_left_radius::computed_value::T) {
                            self.border_bottom_left_radius = v;
                        }
                        /// Set border-bottom-left-radius from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_bottom_left_radius_from(&mut self, other: &Self) {
                            self.border_bottom_left_radius = other.border_bottom_left_radius.clone();
                        }
                    /// Reset border-bottom-left-radius from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_bottom_left_radius(&mut self, other: &Self) {
                        self.copy_border_bottom_left_radius_from(other)
                    }

                    /// Get the computed value for border-bottom-left-radius.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_bottom_left_radius(&self) -> longhands::border_bottom_left_radius::computed_value::T {
                        self.border_bottom_left_radius.clone()
                    }
                    
    /// Set the appropriate physical property for border-start-start-radius given a writing mode.
    pub fn set_border_start_start_radius(&mut self,
                                      v: longhands::border_start_start_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-start-radius
    /// given a writing mode.
    pub fn copy_border_start_start_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-start-radius
    /// given a writing mode.
    pub fn reset_border_start_start_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_start_start_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-start-start-radius given a writing mode.
    pub fn clone_border_start_start_radius(&self, wm: WritingMode)
        -> longhands::border_start_start_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for border-start-end-radius given a writing mode.
    pub fn set_border_start_end_radius(&mut self,
                                      v: longhands::border_start_end_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-end-radius
    /// given a writing mode.
    pub fn copy_border_start_end_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-end-radius
    /// given a writing mode.
    pub fn reset_border_start_end_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_start_end_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-start-end-radius given a writing mode.
    pub fn clone_border_start_end_radius(&self, wm: WritingMode)
        -> longhands::border_start_end_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for border-end-start-radius given a writing mode.
    pub fn set_border_end_start_radius(&mut self,
                                      v: longhands::border_end_start_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-start-radius
    /// given a writing mode.
    pub fn copy_border_end_start_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-start-radius
    /// given a writing mode.
    pub fn reset_border_end_start_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_end_start_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-end-start-radius given a writing mode.
    pub fn clone_border_end_start_radius(&self, wm: WritingMode)
        -> longhands::border_end_start_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for border-end-end-radius given a writing mode.
    pub fn set_border_end_end_radius(&mut self,
                                      v: longhands::border_end_end_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-end-radius
    /// given a writing mode.
    pub fn copy_border_end_end_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-end-radius
    /// given a writing mode.
    pub fn reset_border_end_end_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_end_end_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-end-end-radius given a writing mode.
    pub fn clone_border_end_end_radius(&self, wm: WritingMode)
        -> longhands::border_end_end_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }

                        /// Set box-decoration-break.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_box_decoration_break(&mut self, v: longhands::box_decoration_break::computed_value::T) {
                            self.box_decoration_break = v;
                        }
                        /// Set box-decoration-break from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_box_decoration_break_from(&mut self, other: &Self) {
                            self.box_decoration_break = other.box_decoration_break.clone();
                        }
                    /// Reset box-decoration-break from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_box_decoration_break(&mut self, other: &Self) {
                        self.copy_box_decoration_break_from(other)
                    }

                    /// Get the computed value for box-decoration-break.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_box_decoration_break(&self) -> longhands::box_decoration_break::computed_value::T {
                        self.box_decoration_break.clone()
                    }
                        /// Set -moz-float-edge.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_float_edge(&mut self, v: longhands::_moz_float_edge::computed_value::T) {
                            self._moz_float_edge = v;
                        }
                        /// Set -moz-float-edge from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_float_edge_from(&mut self, other: &Self) {
                            self._moz_float_edge = other._moz_float_edge.clone();
                        }
                    /// Reset -moz-float-edge from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_float_edge(&mut self, other: &Self) {
                        self.copy__moz_float_edge_from(other)
                    }

                    /// Get the computed value for -moz-float-edge.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_float_edge(&self) -> longhands::_moz_float_edge::computed_value::T {
                        self._moz_float_edge.clone()
                    }
                        /// Set border-image-source.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_image_source(&mut self, v: longhands::border_image_source::computed_value::T) {
                            self.border_image_source = v;
                        }
                        /// Set border-image-source from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_image_source_from(&mut self, other: &Self) {
                            self.border_image_source = other.border_image_source.clone();
                        }
                    /// Reset border-image-source from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_image_source(&mut self, other: &Self) {
                        self.copy_border_image_source_from(other)
                    }

                    /// Get the computed value for border-image-source.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_image_source(&self) -> longhands::border_image_source::computed_value::T {
                        self.border_image_source.clone()
                    }
                        /// Set border-image-outset.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_image_outset(&mut self, v: longhands::border_image_outset::computed_value::T) {
                            self.border_image_outset = v;
                        }
                        /// Set border-image-outset from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_image_outset_from(&mut self, other: &Self) {
                            self.border_image_outset = other.border_image_outset.clone();
                        }
                    /// Reset border-image-outset from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_image_outset(&mut self, other: &Self) {
                        self.copy_border_image_outset_from(other)
                    }

                    /// Get the computed value for border-image-outset.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_image_outset(&self) -> longhands::border_image_outset::computed_value::T {
                        self.border_image_outset.clone()
                    }
                        /// Set border-image-repeat.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_image_repeat(&mut self, v: longhands::border_image_repeat::computed_value::T) {
                            self.border_image_repeat = v;
                        }
                        /// Set border-image-repeat from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_image_repeat_from(&mut self, other: &Self) {
                            self.border_image_repeat = other.border_image_repeat.clone();
                        }
                    /// Reset border-image-repeat from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_image_repeat(&mut self, other: &Self) {
                        self.copy_border_image_repeat_from(other)
                    }

                    /// Get the computed value for border-image-repeat.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_image_repeat(&self) -> longhands::border_image_repeat::computed_value::T {
                        self.border_image_repeat.clone()
                    }
                        /// Set border-image-width.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_image_width(&mut self, v: longhands::border_image_width::computed_value::T) {
                            self.border_image_width = v;
                        }
                        /// Set border-image-width from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_image_width_from(&mut self, other: &Self) {
                            self.border_image_width = other.border_image_width.clone();
                        }
                    /// Reset border-image-width from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_image_width(&mut self, other: &Self) {
                        self.copy_border_image_width_from(other)
                    }

                    /// Get the computed value for border-image-width.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_image_width(&self) -> longhands::border_image_width::computed_value::T {
                        self.border_image_width.clone()
                    }
                        /// Set border-image-slice.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_image_slice(&mut self, v: longhands::border_image_slice::computed_value::T) {
                            self.border_image_slice = v;
                        }
                        /// Set border-image-slice from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_image_slice_from(&mut self, other: &Self) {
                            self.border_image_slice = other.border_image_slice.clone();
                        }
                    /// Reset border-image-slice from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_image_slice(&mut self, other: &Self) {
                        self.copy_border_image_slice_from(other)
                    }

                    /// Get the computed value for border-image-slice.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_image_slice(&self) -> longhands::border_image_slice::computed_value::T {
                        self.border_image_slice.clone()
                    }
                    /// Whether the border-top property has nonzero width.
                    #[allow(non_snake_case)]
                    pub fn border_top_has_nonzero_width(&self) -> bool {
                        use crate::Zero;
                        !self.border_top_width.is_zero()
                    }
                    /// Whether the border-right property has nonzero width.
                    #[allow(non_snake_case)]
                    pub fn border_right_has_nonzero_width(&self) -> bool {
                        use crate::Zero;
                        !self.border_right_width.is_zero()
                    }
                    /// Whether the border-bottom property has nonzero width.
                    #[allow(non_snake_case)]
                    pub fn border_bottom_has_nonzero_width(&self) -> bool {
                        use crate::Zero;
                        !self.border_bottom_width.is_zero()
                    }
                    /// Whether the border-left property has nonzero width.
                    #[allow(non_snake_case)]
                    pub fn border_left_has_nonzero_width(&self) -> bool {
                        use crate::Zero;
                        !self.border_left_width.is_zero()
                    }
        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The Box style struct.
        pub struct Box {
                /// The display computed value.
                pub display: longhands::display::computed_value::T,
                /// The -moz-top-layer computed value.
                pub _moz_top_layer: longhands::_moz_top_layer::computed_value::T,
                /// The position computed value.
                pub position: longhands::position::computed_value::T,
                /// The float computed value.
                pub float: longhands::float::computed_value::T,
                /// The clear computed value.
                pub clear: longhands::clear::computed_value::T,
                /// The vertical-align computed value.
                pub vertical_align: longhands::vertical_align::computed_value::T,
                /// The overflow-clip-box-inline computed value.
                pub overflow_clip_box_inline: longhands::overflow_clip_box_inline::computed_value::T,
                /// The overflow-clip-box-block computed value.
                pub overflow_clip_box_block: longhands::overflow_clip_box_block::computed_value::T,
                /// The overflow-x computed value.
                pub overflow_x: longhands::overflow_x::computed_value::T,
                /// The overflow-y computed value.
                pub overflow_y: longhands::overflow_y::computed_value::T,
                /// The overflow-anchor computed value.
                pub overflow_anchor: longhands::overflow_anchor::computed_value::T,
                /// The transition-duration computed value.
                pub transition_duration: longhands::transition_duration::computed_value::T,
                /// The transition-timing-function computed value.
                pub transition_timing_function: longhands::transition_timing_function::computed_value::T,
                /// The transition-property computed value.
                pub transition_property: longhands::transition_property::computed_value::T,
                /// The transition-delay computed value.
                pub transition_delay: longhands::transition_delay::computed_value::T,
                /// The animation-name computed value.
                pub animation_name: longhands::animation_name::computed_value::T,
                /// The animation-duration computed value.
                pub animation_duration: longhands::animation_duration::computed_value::T,
                /// The animation-timing-function computed value.
                pub animation_timing_function: longhands::animation_timing_function::computed_value::T,
                /// The animation-iteration-count computed value.
                pub animation_iteration_count: longhands::animation_iteration_count::computed_value::T,
                /// The animation-direction computed value.
                pub animation_direction: longhands::animation_direction::computed_value::T,
                /// The animation-play-state computed value.
                pub animation_play_state: longhands::animation_play_state::computed_value::T,
                /// The animation-fill-mode computed value.
                pub animation_fill_mode: longhands::animation_fill_mode::computed_value::T,
                /// The animation-delay computed value.
                pub animation_delay: longhands::animation_delay::computed_value::T,
                /// The scroll-snap-points-x computed value.
                pub scroll_snap_points_x: longhands::scroll_snap_points_x::computed_value::T,
                /// The scroll-snap-points-y computed value.
                pub scroll_snap_points_y: longhands::scroll_snap_points_y::computed_value::T,
                /// The scroll-snap-destination computed value.
                pub scroll_snap_destination: longhands::scroll_snap_destination::computed_value::T,
                /// The scroll-snap-coordinate computed value.
                pub scroll_snap_coordinate: longhands::scroll_snap_coordinate::computed_value::T,
                /// The transform computed value.
                pub transform: longhands::transform::computed_value::T,
                /// The rotate computed value.
                pub rotate: longhands::rotate::computed_value::T,
                /// The scale computed value.
                pub scale: longhands::scale::computed_value::T,
                /// The translate computed value.
                pub translate: longhands::translate::computed_value::T,
                /// The offset-path computed value.
                pub offset_path: longhands::offset_path::computed_value::T,
                /// The scroll-behavior computed value.
                pub scroll_behavior: longhands::scroll_behavior::computed_value::T,
                /// The scroll-snap-align computed value.
                pub scroll_snap_align: longhands::scroll_snap_align::computed_value::T,
                /// The scroll-snap-type computed value.
                pub scroll_snap_type: longhands::scroll_snap_type::computed_value::T,
                /// The overscroll-behavior-x computed value.
                pub overscroll_behavior_x: longhands::overscroll_behavior_x::computed_value::T,
                /// The overscroll-behavior-y computed value.
                pub overscroll_behavior_y: longhands::overscroll_behavior_y::computed_value::T,
                /// The isolation computed value.
                pub isolation: longhands::isolation::computed_value::T,
                /// The break-after computed value.
                pub break_after: longhands::break_after::computed_value::T,
                /// The break-before computed value.
                pub break_before: longhands::break_before::computed_value::T,
                /// The break-inside computed value.
                pub break_inside: longhands::break_inside::computed_value::T,
                /// The resize computed value.
                pub resize: longhands::resize::computed_value::T,
                /// The perspective computed value.
                pub perspective: longhands::perspective::computed_value::T,
                /// The perspective-origin computed value.
                pub perspective_origin: longhands::perspective_origin::computed_value::T,
                /// The backface-visibility computed value.
                pub backface_visibility: longhands::backface_visibility::computed_value::T,
                /// The transform-box computed value.
                pub transform_box: longhands::transform_box::computed_value::T,
                /// The transform-style computed value.
                pub transform_style: longhands::transform_style::computed_value::T,
                /// The transform-origin computed value.
                pub transform_origin: longhands::transform_origin::computed_value::T,
                /// The contain computed value.
                pub contain: longhands::contain::computed_value::T,
                /// The -moz-appearance computed value.
                pub _moz_appearance: longhands::_moz_appearance::computed_value::T,
                /// The -moz-binding computed value.
                pub _moz_binding: longhands::_moz_binding::computed_value::T,
                /// The -moz-orient computed value.
                pub _moz_orient: longhands::_moz_orient::computed_value::T,
                /// The will-change computed value.
                pub will_change: longhands::will_change::computed_value::T,
                /// The shape-image-threshold computed value.
                pub shape_image_threshold: longhands::shape_image_threshold::computed_value::T,
                /// The shape-margin computed value.
                pub shape_margin: longhands::shape_margin::computed_value::T,
                /// The shape-outside computed value.
                pub shape_outside: longhands::shape_outside::computed_value::T,
                /// The touch-action computed value.
                pub touch_action: longhands::touch_action::computed_value::T,
                /// The -webkit-line-clamp computed value.
                pub _webkit_line_clamp: longhands::_webkit_line_clamp::computed_value::T,
                /// The display value specified by the CSS stylesheets (without any style adjustments),
                /// which is needed for hypothetical layout boxes.
                pub original_display: longhands::display::computed_value::T,
        }

        impl Box {
                        /// Set `display`.
                        ///
                        /// We need to keep track of the original display for hypothetical boxes,
                        /// so we need to special-case this.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_display(&mut self, v: longhands::display::computed_value::T) {
                            self.display = v;
                            self.original_display = v;
                        }
                        /// Set `display` from other struct.
                        ///
                        /// Same as `set_display` above.
                        /// Thus, we need to special-case this.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_display_from(&mut self, other: &Self) {
                            self.display = other.display.clone();
                            self.original_display = other.display.clone();
                        }
                    /// Reset display from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_display(&mut self, other: &Self) {
                        self.copy_display_from(other)
                    }

                    /// Get the computed value for display.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_display(&self) -> longhands::display::computed_value::T {
                        self.display.clone()
                    }
                        /// Set -moz-top-layer.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_top_layer(&mut self, v: longhands::_moz_top_layer::computed_value::T) {
                            self._moz_top_layer = v;
                        }
                        /// Set -moz-top-layer from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_top_layer_from(&mut self, other: &Self) {
                            self._moz_top_layer = other._moz_top_layer.clone();
                        }
                    /// Reset -moz-top-layer from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_top_layer(&mut self, other: &Self) {
                        self.copy__moz_top_layer_from(other)
                    }

                    /// Get the computed value for -moz-top-layer.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_top_layer(&self) -> longhands::_moz_top_layer::computed_value::T {
                        self._moz_top_layer.clone()
                    }
                        /// Set position.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_position(&mut self, v: longhands::position::computed_value::T) {
                            self.position = v;
                        }
                        /// Set position from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_position_from(&mut self, other: &Self) {
                            self.position = other.position.clone();
                        }
                    /// Reset position from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_position(&mut self, other: &Self) {
                        self.copy_position_from(other)
                    }

                    /// Get the computed value for position.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_position(&self) -> longhands::position::computed_value::T {
                        self.position.clone()
                    }
                        /// Set float.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_float(&mut self, v: longhands::float::computed_value::T) {
                            self.float = v;
                        }
                        /// Set float from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_float_from(&mut self, other: &Self) {
                            self.float = other.float.clone();
                        }
                    /// Reset float from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_float(&mut self, other: &Self) {
                        self.copy_float_from(other)
                    }

                    /// Get the computed value for float.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_float(&self) -> longhands::float::computed_value::T {
                        self.float.clone()
                    }
                        /// Set clear.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_clear(&mut self, v: longhands::clear::computed_value::T) {
                            self.clear = v;
                        }
                        /// Set clear from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_clear_from(&mut self, other: &Self) {
                            self.clear = other.clear.clone();
                        }
                    /// Reset clear from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_clear(&mut self, other: &Self) {
                        self.copy_clear_from(other)
                    }

                    /// Get the computed value for clear.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_clear(&self) -> longhands::clear::computed_value::T {
                        self.clear.clone()
                    }
                        /// Set vertical-align.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_vertical_align(&mut self, v: longhands::vertical_align::computed_value::T) {
                            self.vertical_align = v;
                        }
                        /// Set vertical-align from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_vertical_align_from(&mut self, other: &Self) {
                            self.vertical_align = other.vertical_align.clone();
                        }
                    /// Reset vertical-align from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_vertical_align(&mut self, other: &Self) {
                        self.copy_vertical_align_from(other)
                    }

                    /// Get the computed value for vertical-align.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_vertical_align(&self) -> longhands::vertical_align::computed_value::T {
                        self.vertical_align.clone()
                    }
                        /// Set overflow-clip-box-inline.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_overflow_clip_box_inline(&mut self, v: longhands::overflow_clip_box_inline::computed_value::T) {
                            self.overflow_clip_box_inline = v;
                        }
                        /// Set overflow-clip-box-inline from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_overflow_clip_box_inline_from(&mut self, other: &Self) {
                            self.overflow_clip_box_inline = other.overflow_clip_box_inline.clone();
                        }
                    /// Reset overflow-clip-box-inline from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_overflow_clip_box_inline(&mut self, other: &Self) {
                        self.copy_overflow_clip_box_inline_from(other)
                    }

                    /// Get the computed value for overflow-clip-box-inline.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_overflow_clip_box_inline(&self) -> longhands::overflow_clip_box_inline::computed_value::T {
                        self.overflow_clip_box_inline.clone()
                    }
                        /// Set overflow-clip-box-block.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_overflow_clip_box_block(&mut self, v: longhands::overflow_clip_box_block::computed_value::T) {
                            self.overflow_clip_box_block = v;
                        }
                        /// Set overflow-clip-box-block from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_overflow_clip_box_block_from(&mut self, other: &Self) {
                            self.overflow_clip_box_block = other.overflow_clip_box_block.clone();
                        }
                    /// Reset overflow-clip-box-block from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_overflow_clip_box_block(&mut self, other: &Self) {
                        self.copy_overflow_clip_box_block_from(other)
                    }

                    /// Get the computed value for overflow-clip-box-block.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_overflow_clip_box_block(&self) -> longhands::overflow_clip_box_block::computed_value::T {
                        self.overflow_clip_box_block.clone()
                    }
                        /// Set overflow-x.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_overflow_x(&mut self, v: longhands::overflow_x::computed_value::T) {
                            self.overflow_x = v;
                        }
                        /// Set overflow-x from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_overflow_x_from(&mut self, other: &Self) {
                            self.overflow_x = other.overflow_x.clone();
                        }
                    /// Reset overflow-x from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_overflow_x(&mut self, other: &Self) {
                        self.copy_overflow_x_from(other)
                    }

                    /// Get the computed value for overflow-x.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_overflow_x(&self) -> longhands::overflow_x::computed_value::T {
                        self.overflow_x.clone()
                    }
                        /// Set overflow-y.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_overflow_y(&mut self, v: longhands::overflow_y::computed_value::T) {
                            self.overflow_y = v;
                        }
                        /// Set overflow-y from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_overflow_y_from(&mut self, other: &Self) {
                            self.overflow_y = other.overflow_y.clone();
                        }
                    /// Reset overflow-y from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_overflow_y(&mut self, other: &Self) {
                        self.copy_overflow_y_from(other)
                    }

                    /// Get the computed value for overflow-y.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_overflow_y(&self) -> longhands::overflow_y::computed_value::T {
                        self.overflow_y.clone()
                    }
                        /// Set overflow-anchor.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_overflow_anchor(&mut self, v: longhands::overflow_anchor::computed_value::T) {
                            self.overflow_anchor = v;
                        }
                        /// Set overflow-anchor from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_overflow_anchor_from(&mut self, other: &Self) {
                            self.overflow_anchor = other.overflow_anchor.clone();
                        }
                    /// Reset overflow-anchor from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_overflow_anchor(&mut self, other: &Self) {
                        self.copy_overflow_anchor_from(other)
                    }

                    /// Get the computed value for overflow-anchor.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_overflow_anchor(&self) -> longhands::overflow_anchor::computed_value::T {
                        self.overflow_anchor.clone()
                    }
                        /// Set transition-duration.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_transition_duration<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::transition_duration
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.transition_duration = longhands::transition_duration::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set transition-duration from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_transition_duration_from(&mut self, other: &Self) {
                            self.transition_duration = other.transition_duration.clone();
                        }
                    /// Reset transition-duration from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_transition_duration(&mut self, other: &Self) {
                        self.copy_transition_duration_from(other)
                    }

                    /// Get the computed value for transition-duration.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_transition_duration(&self) -> longhands::transition_duration::computed_value::T {
                        self.transition_duration.clone()
                    }
                    /// If this longhand is indexed, get the number of elements.
                    #[allow(non_snake_case)]
                    pub fn transition_duration_count(&self) -> usize {
                        self.transition_duration.0.len()
                    }

                    /// If this longhand is indexed, get the element at given
                    /// index.
                    #[allow(non_snake_case)]
                    pub fn transition_duration_at(&self, index: usize)
                        -> longhands::transition_duration::computed_value::SingleComputedValue {
                        self.transition_duration.0[index].clone()
                    }
                        /// Set transition-timing-function.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_transition_timing_function<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::transition_timing_function
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.transition_timing_function = longhands::transition_timing_function::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set transition-timing-function from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_transition_timing_function_from(&mut self, other: &Self) {
                            self.transition_timing_function = other.transition_timing_function.clone();
                        }
                    /// Reset transition-timing-function from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_transition_timing_function(&mut self, other: &Self) {
                        self.copy_transition_timing_function_from(other)
                    }

                    /// Get the computed value for transition-timing-function.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_transition_timing_function(&self) -> longhands::transition_timing_function::computed_value::T {
                        self.transition_timing_function.clone()
                    }
                    /// If this longhand is indexed, get the number of elements.
                    #[allow(non_snake_case)]
                    pub fn transition_timing_function_count(&self) -> usize {
                        self.transition_timing_function.0.len()
                    }

                    /// If this longhand is indexed, get the element at given
                    /// index.
                    #[allow(non_snake_case)]
                    pub fn transition_timing_function_at(&self, index: usize)
                        -> longhands::transition_timing_function::computed_value::SingleComputedValue {
                        self.transition_timing_function.0[index].clone()
                    }
                        /// Set transition-property.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_transition_property<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::transition_property
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.transition_property = longhands::transition_property::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set transition-property from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_transition_property_from(&mut self, other: &Self) {
                            self.transition_property = other.transition_property.clone();
                        }
                    /// Reset transition-property from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_transition_property(&mut self, other: &Self) {
                        self.copy_transition_property_from(other)
                    }

                    /// Get the computed value for transition-property.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_transition_property(&self) -> longhands::transition_property::computed_value::T {
                        self.transition_property.clone()
                    }
                    /// If this longhand is indexed, get the number of elements.
                    #[allow(non_snake_case)]
                    pub fn transition_property_count(&self) -> usize {
                        self.transition_property.0.len()
                    }

                    /// If this longhand is indexed, get the element at given
                    /// index.
                    #[allow(non_snake_case)]
                    pub fn transition_property_at(&self, index: usize)
                        -> longhands::transition_property::computed_value::SingleComputedValue {
                        self.transition_property.0[index].clone()
                    }
                        /// Set transition-delay.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_transition_delay<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::transition_delay
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.transition_delay = longhands::transition_delay::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set transition-delay from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_transition_delay_from(&mut self, other: &Self) {
                            self.transition_delay = other.transition_delay.clone();
                        }
                    /// Reset transition-delay from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_transition_delay(&mut self, other: &Self) {
                        self.copy_transition_delay_from(other)
                    }

                    /// Get the computed value for transition-delay.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_transition_delay(&self) -> longhands::transition_delay::computed_value::T {
                        self.transition_delay.clone()
                    }
                    /// If this longhand is indexed, get the number of elements.
                    #[allow(non_snake_case)]
                    pub fn transition_delay_count(&self) -> usize {
                        self.transition_delay.0.len()
                    }

                    /// If this longhand is indexed, get the element at given
                    /// index.
                    #[allow(non_snake_case)]
                    pub fn transition_delay_at(&self, index: usize)
                        -> longhands::transition_delay::computed_value::SingleComputedValue {
                        self.transition_delay.0[index].clone()
                    }
                        /// Set animation-name.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_animation_name<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::animation_name
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.animation_name = longhands::animation_name::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set animation-name from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_animation_name_from(&mut self, other: &Self) {
                            self.animation_name = other.animation_name.clone();
                        }
                    /// Reset animation-name from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_animation_name(&mut self, other: &Self) {
                        self.copy_animation_name_from(other)
                    }

                    /// Get the computed value for animation-name.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_animation_name(&self) -> longhands::animation_name::computed_value::T {
                        self.animation_name.clone()
                    }
                    /// If this longhand is indexed, get the number of elements.
                    #[allow(non_snake_case)]
                    pub fn animation_name_count(&self) -> usize {
                        self.animation_name.0.len()
                    }

                    /// If this longhand is indexed, get the element at given
                    /// index.
                    #[allow(non_snake_case)]
                    pub fn animation_name_at(&self, index: usize)
                        -> longhands::animation_name::computed_value::SingleComputedValue {
                        self.animation_name.0[index].clone()
                    }
                        /// Set animation-duration.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_animation_duration<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::animation_duration
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.animation_duration = longhands::animation_duration::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set animation-duration from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_animation_duration_from(&mut self, other: &Self) {
                            self.animation_duration = other.animation_duration.clone();
                        }
                    /// Reset animation-duration from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_animation_duration(&mut self, other: &Self) {
                        self.copy_animation_duration_from(other)
                    }

                    /// Get the computed value for animation-duration.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_animation_duration(&self) -> longhands::animation_duration::computed_value::T {
                        self.animation_duration.clone()
                    }
                    /// If this longhand is indexed, get the number of elements.
                    #[allow(non_snake_case)]
                    pub fn animation_duration_count(&self) -> usize {
                        self.animation_duration.0.len()
                    }

                    /// If this longhand is indexed, get the element at given
                    /// index.
                    #[allow(non_snake_case)]
                    pub fn animation_duration_at(&self, index: usize)
                        -> longhands::animation_duration::computed_value::SingleComputedValue {
                        self.animation_duration.0[index].clone()
                    }
                        /// Set animation-timing-function.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_animation_timing_function<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::animation_timing_function
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.animation_timing_function = longhands::animation_timing_function::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set animation-timing-function from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_animation_timing_function_from(&mut self, other: &Self) {
                            self.animation_timing_function = other.animation_timing_function.clone();
                        }
                    /// Reset animation-timing-function from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_animation_timing_function(&mut self, other: &Self) {
                        self.copy_animation_timing_function_from(other)
                    }

                    /// Get the computed value for animation-timing-function.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_animation_timing_function(&self) -> longhands::animation_timing_function::computed_value::T {
                        self.animation_timing_function.clone()
                    }
                    /// If this longhand is indexed, get the number of elements.
                    #[allow(non_snake_case)]
                    pub fn animation_timing_function_count(&self) -> usize {
                        self.animation_timing_function.0.len()
                    }

                    /// If this longhand is indexed, get the element at given
                    /// index.
                    #[allow(non_snake_case)]
                    pub fn animation_timing_function_at(&self, index: usize)
                        -> longhands::animation_timing_function::computed_value::SingleComputedValue {
                        self.animation_timing_function.0[index].clone()
                    }
                        /// Set animation-iteration-count.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_animation_iteration_count<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::animation_iteration_count
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.animation_iteration_count = longhands::animation_iteration_count::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set animation-iteration-count from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_animation_iteration_count_from(&mut self, other: &Self) {
                            self.animation_iteration_count = other.animation_iteration_count.clone();
                        }
                    /// Reset animation-iteration-count from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_animation_iteration_count(&mut self, other: &Self) {
                        self.copy_animation_iteration_count_from(other)
                    }

                    /// Get the computed value for animation-iteration-count.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_animation_iteration_count(&self) -> longhands::animation_iteration_count::computed_value::T {
                        self.animation_iteration_count.clone()
                    }
                    /// If this longhand is indexed, get the number of elements.
                    #[allow(non_snake_case)]
                    pub fn animation_iteration_count_count(&self) -> usize {
                        self.animation_iteration_count.0.len()
                    }

                    /// If this longhand is indexed, get the element at given
                    /// index.
                    #[allow(non_snake_case)]
                    pub fn animation_iteration_count_at(&self, index: usize)
                        -> longhands::animation_iteration_count::computed_value::SingleComputedValue {
                        self.animation_iteration_count.0[index].clone()
                    }
                        /// Set animation-direction.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_animation_direction<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::animation_direction
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.animation_direction = longhands::animation_direction::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set animation-direction from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_animation_direction_from(&mut self, other: &Self) {
                            self.animation_direction = other.animation_direction.clone();
                        }
                    /// Reset animation-direction from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_animation_direction(&mut self, other: &Self) {
                        self.copy_animation_direction_from(other)
                    }

                    /// Get the computed value for animation-direction.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_animation_direction(&self) -> longhands::animation_direction::computed_value::T {
                        self.animation_direction.clone()
                    }
                    /// If this longhand is indexed, get the number of elements.
                    #[allow(non_snake_case)]
                    pub fn animation_direction_count(&self) -> usize {
                        self.animation_direction.0.len()
                    }

                    /// If this longhand is indexed, get the element at given
                    /// index.
                    #[allow(non_snake_case)]
                    pub fn animation_direction_at(&self, index: usize)
                        -> longhands::animation_direction::computed_value::SingleComputedValue {
                        self.animation_direction.0[index].clone()
                    }
                        /// Set animation-play-state.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_animation_play_state<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::animation_play_state
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.animation_play_state = longhands::animation_play_state::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set animation-play-state from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_animation_play_state_from(&mut self, other: &Self) {
                            self.animation_play_state = other.animation_play_state.clone();
                        }
                    /// Reset animation-play-state from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_animation_play_state(&mut self, other: &Self) {
                        self.copy_animation_play_state_from(other)
                    }

                    /// Get the computed value for animation-play-state.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_animation_play_state(&self) -> longhands::animation_play_state::computed_value::T {
                        self.animation_play_state.clone()
                    }
                    /// If this longhand is indexed, get the number of elements.
                    #[allow(non_snake_case)]
                    pub fn animation_play_state_count(&self) -> usize {
                        self.animation_play_state.0.len()
                    }

                    /// If this longhand is indexed, get the element at given
                    /// index.
                    #[allow(non_snake_case)]
                    pub fn animation_play_state_at(&self, index: usize)
                        -> longhands::animation_play_state::computed_value::SingleComputedValue {
                        self.animation_play_state.0[index].clone()
                    }
                        /// Set animation-fill-mode.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_animation_fill_mode<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::animation_fill_mode
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.animation_fill_mode = longhands::animation_fill_mode::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set animation-fill-mode from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_animation_fill_mode_from(&mut self, other: &Self) {
                            self.animation_fill_mode = other.animation_fill_mode.clone();
                        }
                    /// Reset animation-fill-mode from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_animation_fill_mode(&mut self, other: &Self) {
                        self.copy_animation_fill_mode_from(other)
                    }

                    /// Get the computed value for animation-fill-mode.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_animation_fill_mode(&self) -> longhands::animation_fill_mode::computed_value::T {
                        self.animation_fill_mode.clone()
                    }
                    /// If this longhand is indexed, get the number of elements.
                    #[allow(non_snake_case)]
                    pub fn animation_fill_mode_count(&self) -> usize {
                        self.animation_fill_mode.0.len()
                    }

                    /// If this longhand is indexed, get the element at given
                    /// index.
                    #[allow(non_snake_case)]
                    pub fn animation_fill_mode_at(&self, index: usize)
                        -> longhands::animation_fill_mode::computed_value::SingleComputedValue {
                        self.animation_fill_mode.0[index].clone()
                    }
                        /// Set animation-delay.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_animation_delay<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::animation_delay
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.animation_delay = longhands::animation_delay::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set animation-delay from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_animation_delay_from(&mut self, other: &Self) {
                            self.animation_delay = other.animation_delay.clone();
                        }
                    /// Reset animation-delay from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_animation_delay(&mut self, other: &Self) {
                        self.copy_animation_delay_from(other)
                    }

                    /// Get the computed value for animation-delay.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_animation_delay(&self) -> longhands::animation_delay::computed_value::T {
                        self.animation_delay.clone()
                    }
                    /// If this longhand is indexed, get the number of elements.
                    #[allow(non_snake_case)]
                    pub fn animation_delay_count(&self) -> usize {
                        self.animation_delay.0.len()
                    }

                    /// If this longhand is indexed, get the element at given
                    /// index.
                    #[allow(non_snake_case)]
                    pub fn animation_delay_at(&self, index: usize)
                        -> longhands::animation_delay::computed_value::SingleComputedValue {
                        self.animation_delay.0[index].clone()
                    }
                        /// Set scroll-snap-points-x.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_scroll_snap_points_x(&mut self, v: longhands::scroll_snap_points_x::computed_value::T) {
                            self.scroll_snap_points_x = v;
                        }
                        /// Set scroll-snap-points-x from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_scroll_snap_points_x_from(&mut self, other: &Self) {
                            self.scroll_snap_points_x = other.scroll_snap_points_x.clone();
                        }
                    /// Reset scroll-snap-points-x from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_scroll_snap_points_x(&mut self, other: &Self) {
                        self.copy_scroll_snap_points_x_from(other)
                    }

                    /// Get the computed value for scroll-snap-points-x.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_scroll_snap_points_x(&self) -> longhands::scroll_snap_points_x::computed_value::T {
                        self.scroll_snap_points_x.clone()
                    }
                        /// Set scroll-snap-points-y.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_scroll_snap_points_y(&mut self, v: longhands::scroll_snap_points_y::computed_value::T) {
                            self.scroll_snap_points_y = v;
                        }
                        /// Set scroll-snap-points-y from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_scroll_snap_points_y_from(&mut self, other: &Self) {
                            self.scroll_snap_points_y = other.scroll_snap_points_y.clone();
                        }
                    /// Reset scroll-snap-points-y from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_scroll_snap_points_y(&mut self, other: &Self) {
                        self.copy_scroll_snap_points_y_from(other)
                    }

                    /// Get the computed value for scroll-snap-points-y.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_scroll_snap_points_y(&self) -> longhands::scroll_snap_points_y::computed_value::T {
                        self.scroll_snap_points_y.clone()
                    }
                        /// Set scroll-snap-destination.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_scroll_snap_destination(&mut self, v: longhands::scroll_snap_destination::computed_value::T) {
                            self.scroll_snap_destination = v;
                        }
                        /// Set scroll-snap-destination from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_scroll_snap_destination_from(&mut self, other: &Self) {
                            self.scroll_snap_destination = other.scroll_snap_destination.clone();
                        }
                    /// Reset scroll-snap-destination from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_scroll_snap_destination(&mut self, other: &Self) {
                        self.copy_scroll_snap_destination_from(other)
                    }

                    /// Get the computed value for scroll-snap-destination.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_scroll_snap_destination(&self) -> longhands::scroll_snap_destination::computed_value::T {
                        self.scroll_snap_destination.clone()
                    }
                        /// Set scroll-snap-coordinate.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_scroll_snap_coordinate<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::scroll_snap_coordinate
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.scroll_snap_coordinate = longhands::scroll_snap_coordinate::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set scroll-snap-coordinate from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_scroll_snap_coordinate_from(&mut self, other: &Self) {
                            self.scroll_snap_coordinate = other.scroll_snap_coordinate.clone();
                        }
                    /// Reset scroll-snap-coordinate from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_scroll_snap_coordinate(&mut self, other: &Self) {
                        self.copy_scroll_snap_coordinate_from(other)
                    }

                    /// Get the computed value for scroll-snap-coordinate.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_scroll_snap_coordinate(&self) -> longhands::scroll_snap_coordinate::computed_value::T {
                        self.scroll_snap_coordinate.clone()
                    }
                        /// Set transform.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_transform(&mut self, v: longhands::transform::computed_value::T) {
                            self.transform = v;
                        }
                        /// Set transform from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_transform_from(&mut self, other: &Self) {
                            self.transform = other.transform.clone();
                        }
                    /// Reset transform from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_transform(&mut self, other: &Self) {
                        self.copy_transform_from(other)
                    }

                    /// Get the computed value for transform.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_transform(&self) -> longhands::transform::computed_value::T {
                        self.transform.clone()
                    }
                        /// Set rotate.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_rotate(&mut self, v: longhands::rotate::computed_value::T) {
                            self.rotate = v;
                        }
                        /// Set rotate from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_rotate_from(&mut self, other: &Self) {
                            self.rotate = other.rotate.clone();
                        }
                    /// Reset rotate from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_rotate(&mut self, other: &Self) {
                        self.copy_rotate_from(other)
                    }

                    /// Get the computed value for rotate.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_rotate(&self) -> longhands::rotate::computed_value::T {
                        self.rotate.clone()
                    }
                        /// Set scale.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_scale(&mut self, v: longhands::scale::computed_value::T) {
                            self.scale = v;
                        }
                        /// Set scale from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_scale_from(&mut self, other: &Self) {
                            self.scale = other.scale.clone();
                        }
                    /// Reset scale from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_scale(&mut self, other: &Self) {
                        self.copy_scale_from(other)
                    }

                    /// Get the computed value for scale.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_scale(&self) -> longhands::scale::computed_value::T {
                        self.scale.clone()
                    }
                        /// Set translate.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_translate(&mut self, v: longhands::translate::computed_value::T) {
                            self.translate = v;
                        }
                        /// Set translate from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_translate_from(&mut self, other: &Self) {
                            self.translate = other.translate.clone();
                        }
                    /// Reset translate from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_translate(&mut self, other: &Self) {
                        self.copy_translate_from(other)
                    }

                    /// Get the computed value for translate.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_translate(&self) -> longhands::translate::computed_value::T {
                        self.translate.clone()
                    }
                        /// Set offset-path.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_offset_path(&mut self, v: longhands::offset_path::computed_value::T) {
                            self.offset_path = v;
                        }
                        /// Set offset-path from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_offset_path_from(&mut self, other: &Self) {
                            self.offset_path = other.offset_path.clone();
                        }
                    /// Reset offset-path from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_offset_path(&mut self, other: &Self) {
                        self.copy_offset_path_from(other)
                    }

                    /// Get the computed value for offset-path.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_offset_path(&self) -> longhands::offset_path::computed_value::T {
                        self.offset_path.clone()
                    }
                        /// Set scroll-behavior.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_scroll_behavior(&mut self, v: longhands::scroll_behavior::computed_value::T) {
                            self.scroll_behavior = v;
                        }
                        /// Set scroll-behavior from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_scroll_behavior_from(&mut self, other: &Self) {
                            self.scroll_behavior = other.scroll_behavior.clone();
                        }
                    /// Reset scroll-behavior from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_scroll_behavior(&mut self, other: &Self) {
                        self.copy_scroll_behavior_from(other)
                    }

                    /// Get the computed value for scroll-behavior.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_scroll_behavior(&self) -> longhands::scroll_behavior::computed_value::T {
                        self.scroll_behavior.clone()
                    }
                        /// Set scroll-snap-align.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_scroll_snap_align(&mut self, v: longhands::scroll_snap_align::computed_value::T) {
                            self.scroll_snap_align = v;
                        }
                        /// Set scroll-snap-align from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_scroll_snap_align_from(&mut self, other: &Self) {
                            self.scroll_snap_align = other.scroll_snap_align.clone();
                        }
                    /// Reset scroll-snap-align from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_scroll_snap_align(&mut self, other: &Self) {
                        self.copy_scroll_snap_align_from(other)
                    }

                    /// Get the computed value for scroll-snap-align.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_scroll_snap_align(&self) -> longhands::scroll_snap_align::computed_value::T {
                        self.scroll_snap_align.clone()
                    }
                        /// Set scroll-snap-type.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_scroll_snap_type(&mut self, v: longhands::scroll_snap_type::computed_value::T) {
                            self.scroll_snap_type = v;
                        }
                        /// Set scroll-snap-type from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_scroll_snap_type_from(&mut self, other: &Self) {
                            self.scroll_snap_type = other.scroll_snap_type.clone();
                        }
                    /// Reset scroll-snap-type from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_scroll_snap_type(&mut self, other: &Self) {
                        self.copy_scroll_snap_type_from(other)
                    }

                    /// Get the computed value for scroll-snap-type.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_scroll_snap_type(&self) -> longhands::scroll_snap_type::computed_value::T {
                        self.scroll_snap_type.clone()
                    }
                        /// Set overscroll-behavior-x.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_overscroll_behavior_x(&mut self, v: longhands::overscroll_behavior_x::computed_value::T) {
                            self.overscroll_behavior_x = v;
                        }
                        /// Set overscroll-behavior-x from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_overscroll_behavior_x_from(&mut self, other: &Self) {
                            self.overscroll_behavior_x = other.overscroll_behavior_x.clone();
                        }
                    /// Reset overscroll-behavior-x from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_overscroll_behavior_x(&mut self, other: &Self) {
                        self.copy_overscroll_behavior_x_from(other)
                    }

                    /// Get the computed value for overscroll-behavior-x.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_overscroll_behavior_x(&self) -> longhands::overscroll_behavior_x::computed_value::T {
                        self.overscroll_behavior_x.clone()
                    }
                        /// Set overscroll-behavior-y.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_overscroll_behavior_y(&mut self, v: longhands::overscroll_behavior_y::computed_value::T) {
                            self.overscroll_behavior_y = v;
                        }
                        /// Set overscroll-behavior-y from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_overscroll_behavior_y_from(&mut self, other: &Self) {
                            self.overscroll_behavior_y = other.overscroll_behavior_y.clone();
                        }
                    /// Reset overscroll-behavior-y from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_overscroll_behavior_y(&mut self, other: &Self) {
                        self.copy_overscroll_behavior_y_from(other)
                    }

                    /// Get the computed value for overscroll-behavior-y.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_overscroll_behavior_y(&self) -> longhands::overscroll_behavior_y::computed_value::T {
                        self.overscroll_behavior_y.clone()
                    }
                        /// Set isolation.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_isolation(&mut self, v: longhands::isolation::computed_value::T) {
                            self.isolation = v;
                        }
                        /// Set isolation from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_isolation_from(&mut self, other: &Self) {
                            self.isolation = other.isolation.clone();
                        }
                    /// Reset isolation from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_isolation(&mut self, other: &Self) {
                        self.copy_isolation_from(other)
                    }

                    /// Get the computed value for isolation.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_isolation(&self) -> longhands::isolation::computed_value::T {
                        self.isolation.clone()
                    }
                        /// Set break-after.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_break_after(&mut self, v: longhands::break_after::computed_value::T) {
                            self.break_after = v;
                        }
                        /// Set break-after from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_break_after_from(&mut self, other: &Self) {
                            self.break_after = other.break_after.clone();
                        }
                    /// Reset break-after from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_break_after(&mut self, other: &Self) {
                        self.copy_break_after_from(other)
                    }

                    /// Get the computed value for break-after.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_break_after(&self) -> longhands::break_after::computed_value::T {
                        self.break_after.clone()
                    }
                        /// Set break-before.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_break_before(&mut self, v: longhands::break_before::computed_value::T) {
                            self.break_before = v;
                        }
                        /// Set break-before from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_break_before_from(&mut self, other: &Self) {
                            self.break_before = other.break_before.clone();
                        }
                    /// Reset break-before from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_break_before(&mut self, other: &Self) {
                        self.copy_break_before_from(other)
                    }

                    /// Get the computed value for break-before.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_break_before(&self) -> longhands::break_before::computed_value::T {
                        self.break_before.clone()
                    }
                        /// Set break-inside.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_break_inside(&mut self, v: longhands::break_inside::computed_value::T) {
                            self.break_inside = v;
                        }
                        /// Set break-inside from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_break_inside_from(&mut self, other: &Self) {
                            self.break_inside = other.break_inside.clone();
                        }
                    /// Reset break-inside from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_break_inside(&mut self, other: &Self) {
                        self.copy_break_inside_from(other)
                    }

                    /// Get the computed value for break-inside.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_break_inside(&self) -> longhands::break_inside::computed_value::T {
                        self.break_inside.clone()
                    }
                        /// Set resize.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_resize(&mut self, v: longhands::resize::computed_value::T) {
                            self.resize = v;
                        }
                        /// Set resize from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_resize_from(&mut self, other: &Self) {
                            self.resize = other.resize.clone();
                        }
                    /// Reset resize from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_resize(&mut self, other: &Self) {
                        self.copy_resize_from(other)
                    }

                    /// Get the computed value for resize.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_resize(&self) -> longhands::resize::computed_value::T {
                        self.resize.clone()
                    }
                        /// Set perspective.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_perspective(&mut self, v: longhands::perspective::computed_value::T) {
                            self.perspective = v;
                        }
                        /// Set perspective from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_perspective_from(&mut self, other: &Self) {
                            self.perspective = other.perspective.clone();
                        }
                    /// Reset perspective from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_perspective(&mut self, other: &Self) {
                        self.copy_perspective_from(other)
                    }

                    /// Get the computed value for perspective.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_perspective(&self) -> longhands::perspective::computed_value::T {
                        self.perspective.clone()
                    }
                        /// Set perspective-origin.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_perspective_origin(&mut self, v: longhands::perspective_origin::computed_value::T) {
                            self.perspective_origin = v;
                        }
                        /// Set perspective-origin from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_perspective_origin_from(&mut self, other: &Self) {
                            self.perspective_origin = other.perspective_origin.clone();
                        }
                    /// Reset perspective-origin from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_perspective_origin(&mut self, other: &Self) {
                        self.copy_perspective_origin_from(other)
                    }

                    /// Get the computed value for perspective-origin.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_perspective_origin(&self) -> longhands::perspective_origin::computed_value::T {
                        self.perspective_origin.clone()
                    }
                        /// Set backface-visibility.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_backface_visibility(&mut self, v: longhands::backface_visibility::computed_value::T) {
                            self.backface_visibility = v;
                        }
                        /// Set backface-visibility from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_backface_visibility_from(&mut self, other: &Self) {
                            self.backface_visibility = other.backface_visibility.clone();
                        }
                    /// Reset backface-visibility from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_backface_visibility(&mut self, other: &Self) {
                        self.copy_backface_visibility_from(other)
                    }

                    /// Get the computed value for backface-visibility.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_backface_visibility(&self) -> longhands::backface_visibility::computed_value::T {
                        self.backface_visibility.clone()
                    }
                        /// Set transform-box.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_transform_box(&mut self, v: longhands::transform_box::computed_value::T) {
                            self.transform_box = v;
                        }
                        /// Set transform-box from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_transform_box_from(&mut self, other: &Self) {
                            self.transform_box = other.transform_box.clone();
                        }
                    /// Reset transform-box from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_transform_box(&mut self, other: &Self) {
                        self.copy_transform_box_from(other)
                    }

                    /// Get the computed value for transform-box.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_transform_box(&self) -> longhands::transform_box::computed_value::T {
                        self.transform_box.clone()
                    }
                        /// Set transform-style.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_transform_style(&mut self, v: longhands::transform_style::computed_value::T) {
                            self.transform_style = v;
                        }
                        /// Set transform-style from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_transform_style_from(&mut self, other: &Self) {
                            self.transform_style = other.transform_style.clone();
                        }
                    /// Reset transform-style from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_transform_style(&mut self, other: &Self) {
                        self.copy_transform_style_from(other)
                    }

                    /// Get the computed value for transform-style.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_transform_style(&self) -> longhands::transform_style::computed_value::T {
                        self.transform_style.clone()
                    }
                        /// Set transform-origin.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_transform_origin(&mut self, v: longhands::transform_origin::computed_value::T) {
                            self.transform_origin = v;
                        }
                        /// Set transform-origin from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_transform_origin_from(&mut self, other: &Self) {
                            self.transform_origin = other.transform_origin.clone();
                        }
                    /// Reset transform-origin from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_transform_origin(&mut self, other: &Self) {
                        self.copy_transform_origin_from(other)
                    }

                    /// Get the computed value for transform-origin.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_transform_origin(&self) -> longhands::transform_origin::computed_value::T {
                        self.transform_origin.clone()
                    }
                        /// Set contain.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_contain(&mut self, v: longhands::contain::computed_value::T) {
                            self.contain = v;
                        }
                        /// Set contain from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_contain_from(&mut self, other: &Self) {
                            self.contain = other.contain.clone();
                        }
                    /// Reset contain from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_contain(&mut self, other: &Self) {
                        self.copy_contain_from(other)
                    }

                    /// Get the computed value for contain.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_contain(&self) -> longhands::contain::computed_value::T {
                        self.contain.clone()
                    }
                        /// Set -moz-appearance.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_appearance(&mut self, v: longhands::_moz_appearance::computed_value::T) {
                            self._moz_appearance = v;
                        }
                        /// Set -moz-appearance from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_appearance_from(&mut self, other: &Self) {
                            self._moz_appearance = other._moz_appearance.clone();
                        }
                    /// Reset -moz-appearance from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_appearance(&mut self, other: &Self) {
                        self.copy__moz_appearance_from(other)
                    }

                    /// Get the computed value for -moz-appearance.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_appearance(&self) -> longhands::_moz_appearance::computed_value::T {
                        self._moz_appearance.clone()
                    }
                        /// Set -moz-binding.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_binding(&mut self, v: longhands::_moz_binding::computed_value::T) {
                            self._moz_binding = v;
                        }
                        /// Set -moz-binding from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_binding_from(&mut self, other: &Self) {
                            self._moz_binding = other._moz_binding.clone();
                        }
                    /// Reset -moz-binding from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_binding(&mut self, other: &Self) {
                        self.copy__moz_binding_from(other)
                    }

                    /// Get the computed value for -moz-binding.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_binding(&self) -> longhands::_moz_binding::computed_value::T {
                        self._moz_binding.clone()
                    }
                        /// Set -moz-orient.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_orient(&mut self, v: longhands::_moz_orient::computed_value::T) {
                            self._moz_orient = v;
                        }
                        /// Set -moz-orient from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_orient_from(&mut self, other: &Self) {
                            self._moz_orient = other._moz_orient.clone();
                        }
                    /// Reset -moz-orient from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_orient(&mut self, other: &Self) {
                        self.copy__moz_orient_from(other)
                    }

                    /// Get the computed value for -moz-orient.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_orient(&self) -> longhands::_moz_orient::computed_value::T {
                        self._moz_orient.clone()
                    }
                        /// Set will-change.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_will_change(&mut self, v: longhands::will_change::computed_value::T) {
                            self.will_change = v;
                        }
                        /// Set will-change from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_will_change_from(&mut self, other: &Self) {
                            self.will_change = other.will_change.clone();
                        }
                    /// Reset will-change from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_will_change(&mut self, other: &Self) {
                        self.copy_will_change_from(other)
                    }

                    /// Get the computed value for will-change.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_will_change(&self) -> longhands::will_change::computed_value::T {
                        self.will_change.clone()
                    }
                        /// Set shape-image-threshold.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_shape_image_threshold(&mut self, v: longhands::shape_image_threshold::computed_value::T) {
                            self.shape_image_threshold = v;
                        }
                        /// Set shape-image-threshold from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_shape_image_threshold_from(&mut self, other: &Self) {
                            self.shape_image_threshold = other.shape_image_threshold.clone();
                        }
                    /// Reset shape-image-threshold from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_shape_image_threshold(&mut self, other: &Self) {
                        self.copy_shape_image_threshold_from(other)
                    }

                    /// Get the computed value for shape-image-threshold.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_shape_image_threshold(&self) -> longhands::shape_image_threshold::computed_value::T {
                        self.shape_image_threshold.clone()
                    }
                        /// Set shape-margin.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_shape_margin(&mut self, v: longhands::shape_margin::computed_value::T) {
                            self.shape_margin = v;
                        }
                        /// Set shape-margin from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_shape_margin_from(&mut self, other: &Self) {
                            self.shape_margin = other.shape_margin.clone();
                        }
                    /// Reset shape-margin from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_shape_margin(&mut self, other: &Self) {
                        self.copy_shape_margin_from(other)
                    }

                    /// Get the computed value for shape-margin.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_shape_margin(&self) -> longhands::shape_margin::computed_value::T {
                        self.shape_margin.clone()
                    }
                        /// Set shape-outside.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_shape_outside(&mut self, v: longhands::shape_outside::computed_value::T) {
                            self.shape_outside = v;
                        }
                        /// Set shape-outside from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_shape_outside_from(&mut self, other: &Self) {
                            self.shape_outside = other.shape_outside.clone();
                        }
                    /// Reset shape-outside from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_shape_outside(&mut self, other: &Self) {
                        self.copy_shape_outside_from(other)
                    }

                    /// Get the computed value for shape-outside.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_shape_outside(&self) -> longhands::shape_outside::computed_value::T {
                        self.shape_outside.clone()
                    }
                        /// Set touch-action.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_touch_action(&mut self, v: longhands::touch_action::computed_value::T) {
                            self.touch_action = v;
                        }
                        /// Set touch-action from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_touch_action_from(&mut self, other: &Self) {
                            self.touch_action = other.touch_action.clone();
                        }
                    /// Reset touch-action from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_touch_action(&mut self, other: &Self) {
                        self.copy_touch_action_from(other)
                    }

                    /// Get the computed value for touch-action.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_touch_action(&self) -> longhands::touch_action::computed_value::T {
                        self.touch_action.clone()
                    }
                        /// Set -webkit-line-clamp.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__webkit_line_clamp(&mut self, v: longhands::_webkit_line_clamp::computed_value::T) {
                            self._webkit_line_clamp = v;
                        }
                        /// Set -webkit-line-clamp from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__webkit_line_clamp_from(&mut self, other: &Self) {
                            self._webkit_line_clamp = other._webkit_line_clamp.clone();
                        }
                    /// Reset -webkit-line-clamp from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__webkit_line_clamp(&mut self, other: &Self) {
                        self.copy__webkit_line_clamp_from(other)
                    }

                    /// Get the computed value for -webkit-line-clamp.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__webkit_line_clamp(&self) -> longhands::_webkit_line_clamp::computed_value::T {
                        self._webkit_line_clamp.clone()
                    }
                /// Sets the display property, but without touching original_display,
                /// except when the adjustment comes from root or item display fixups.
                pub fn set_adjusted_display(
                    &mut self,
                    dpy: longhands::display::computed_value::T,
                    is_item_or_root: bool
                ) {
                    self.display = dpy;
                    if is_item_or_root {
                        self.original_display = dpy;
                    }
                }
        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The Color style struct.
        pub struct Color {
                /// The color computed value.
                pub color: longhands::color::computed_value::T,
        }

        impl Color {
                        /// Set color.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_color(&mut self, v: longhands::color::computed_value::T) {
                            self.color = v;
                        }
                        /// Set color from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_color_from(&mut self, other: &Self) {
                            self.color = other.color.clone();
                        }
                    /// Reset color from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_color(&mut self, other: &Self) {
                        self.copy_color_from(other)
                    }

                    /// Get the computed value for color.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_color(&self) -> longhands::color::computed_value::T {
                        self.color.clone()
                    }
        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The Column style struct.
        pub struct Column {
                /// The column-width computed value.
                pub column_width: longhands::column_width::computed_value::T,
                /// The column-count computed value.
                pub column_count: longhands::column_count::computed_value::T,
                /// The column-fill computed value.
                pub column_fill: longhands::column_fill::computed_value::T,
                /// The column-rule-width computed value.
                pub column_rule_width: longhands::column_rule_width::computed_value::T,
                /// The column-rule-color computed value.
                pub column_rule_color: longhands::column_rule_color::computed_value::T,
                /// The column-span computed value.
                pub column_span: longhands::column_span::computed_value::T,
                /// The column-rule-style computed value.
                pub column_rule_style: longhands::column_rule_style::computed_value::T,
        }

        impl Column {
                        /// Set column-width.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_column_width(&mut self, v: longhands::column_width::computed_value::T) {
                            self.column_width = v;
                        }
                        /// Set column-width from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_column_width_from(&mut self, other: &Self) {
                            self.column_width = other.column_width.clone();
                        }
                    /// Reset column-width from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_column_width(&mut self, other: &Self) {
                        self.copy_column_width_from(other)
                    }

                    /// Get the computed value for column-width.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_column_width(&self) -> longhands::column_width::computed_value::T {
                        self.column_width.clone()
                    }
                        /// Set column-count.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_column_count(&mut self, v: longhands::column_count::computed_value::T) {
                            self.column_count = v;
                        }
                        /// Set column-count from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_column_count_from(&mut self, other: &Self) {
                            self.column_count = other.column_count.clone();
                        }
                    /// Reset column-count from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_column_count(&mut self, other: &Self) {
                        self.copy_column_count_from(other)
                    }

                    /// Get the computed value for column-count.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_column_count(&self) -> longhands::column_count::computed_value::T {
                        self.column_count.clone()
                    }
                        /// Set column-fill.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_column_fill(&mut self, v: longhands::column_fill::computed_value::T) {
                            self.column_fill = v;
                        }
                        /// Set column-fill from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_column_fill_from(&mut self, other: &Self) {
                            self.column_fill = other.column_fill.clone();
                        }
                    /// Reset column-fill from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_column_fill(&mut self, other: &Self) {
                        self.copy_column_fill_from(other)
                    }

                    /// Get the computed value for column-fill.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_column_fill(&self) -> longhands::column_fill::computed_value::T {
                        self.column_fill.clone()
                    }
                        /// Set column-rule-width.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_column_rule_width(&mut self, v: longhands::column_rule_width::computed_value::T) {
                            self.column_rule_width = v;
                        }
                        /// Set column-rule-width from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_column_rule_width_from(&mut self, other: &Self) {
                            self.column_rule_width = other.column_rule_width.clone();
                        }
                    /// Reset column-rule-width from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_column_rule_width(&mut self, other: &Self) {
                        self.copy_column_rule_width_from(other)
                    }

                    /// Get the computed value for column-rule-width.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_column_rule_width(&self) -> longhands::column_rule_width::computed_value::T {
                        self.column_rule_width.clone()
                    }
                        /// Set column-rule-color.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_column_rule_color(&mut self, v: longhands::column_rule_color::computed_value::T) {
                            self.column_rule_color = v;
                        }
                        /// Set column-rule-color from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_column_rule_color_from(&mut self, other: &Self) {
                            self.column_rule_color = other.column_rule_color.clone();
                        }
                    /// Reset column-rule-color from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_column_rule_color(&mut self, other: &Self) {
                        self.copy_column_rule_color_from(other)
                    }

                    /// Get the computed value for column-rule-color.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_column_rule_color(&self) -> longhands::column_rule_color::computed_value::T {
                        self.column_rule_color.clone()
                    }
                        /// Set column-span.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_column_span(&mut self, v: longhands::column_span::computed_value::T) {
                            self.column_span = v;
                        }
                        /// Set column-span from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_column_span_from(&mut self, other: &Self) {
                            self.column_span = other.column_span.clone();
                        }
                    /// Reset column-span from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_column_span(&mut self, other: &Self) {
                        self.copy_column_span_from(other)
                    }

                    /// Get the computed value for column-span.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_column_span(&self) -> longhands::column_span::computed_value::T {
                        self.column_span.clone()
                    }
                        /// Set column-rule-style.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_column_rule_style(&mut self, v: longhands::column_rule_style::computed_value::T) {
                            self.column_rule_style = v;
                        }
                        /// Set column-rule-style from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_column_rule_style_from(&mut self, other: &Self) {
                            self.column_rule_style = other.column_rule_style.clone();
                        }
                    /// Reset column-rule-style from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_column_rule_style(&mut self, other: &Self) {
                        self.copy_column_rule_style_from(other)
                    }

                    /// Get the computed value for column-rule-style.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_column_rule_style(&self) -> longhands::column_rule_style::computed_value::T {
                        self.column_rule_style.clone()
                    }
        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The Counters style struct.
        pub struct Counters {
                /// The content computed value.
                pub content: longhands::content::computed_value::T,
                /// The counter-increment computed value.
                pub counter_increment: longhands::counter_increment::computed_value::T,
                /// The counter-reset computed value.
                pub counter_reset: longhands::counter_reset::computed_value::T,
                /// The counter-set computed value.
                pub counter_set: longhands::counter_set::computed_value::T,
        }

        impl Counters {
                        /// Set content.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_content(&mut self, v: longhands::content::computed_value::T) {
                            self.content = v;
                        }
                        /// Set content from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_content_from(&mut self, other: &Self) {
                            self.content = other.content.clone();
                        }
                    /// Reset content from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_content(&mut self, other: &Self) {
                        self.copy_content_from(other)
                    }

                    /// Get the computed value for content.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_content(&self) -> longhands::content::computed_value::T {
                        self.content.clone()
                    }
                        /// Set counter-increment.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_counter_increment(&mut self, v: longhands::counter_increment::computed_value::T) {
                            self.counter_increment = v;
                        }
                        /// Set counter-increment from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_counter_increment_from(&mut self, other: &Self) {
                            self.counter_increment = other.counter_increment.clone();
                        }
                    /// Reset counter-increment from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_counter_increment(&mut self, other: &Self) {
                        self.copy_counter_increment_from(other)
                    }

                    /// Get the computed value for counter-increment.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_counter_increment(&self) -> longhands::counter_increment::computed_value::T {
                        self.counter_increment.clone()
                    }
                        /// Set counter-reset.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_counter_reset(&mut self, v: longhands::counter_reset::computed_value::T) {
                            self.counter_reset = v;
                        }
                        /// Set counter-reset from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_counter_reset_from(&mut self, other: &Self) {
                            self.counter_reset = other.counter_reset.clone();
                        }
                    /// Reset counter-reset from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_counter_reset(&mut self, other: &Self) {
                        self.copy_counter_reset_from(other)
                    }

                    /// Get the computed value for counter-reset.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_counter_reset(&self) -> longhands::counter_reset::computed_value::T {
                        self.counter_reset.clone()
                    }
                        /// Set counter-set.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_counter_set(&mut self, v: longhands::counter_set::computed_value::T) {
                            self.counter_set = v;
                        }
                        /// Set counter-set from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_counter_set_from(&mut self, other: &Self) {
                            self.counter_set = other.counter_set.clone();
                        }
                    /// Reset counter-set from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_counter_set(&mut self, other: &Self) {
                        self.copy_counter_set_from(other)
                    }

                    /// Get the computed value for counter-set.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_counter_set(&self) -> longhands::counter_set::computed_value::T {
                        self.counter_set.clone()
                    }
        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The Effects style struct.
        pub struct Effects {
                /// The opacity computed value.
                pub opacity: longhands::opacity::computed_value::T,
                /// The box-shadow computed value.
                pub box_shadow: longhands::box_shadow::computed_value::T,
                /// The clip computed value.
                pub clip: longhands::clip::computed_value::T,
                /// The filter computed value.
                pub filter: longhands::filter::computed_value::T,
                /// The mix-blend-mode computed value.
                pub mix_blend_mode: longhands::mix_blend_mode::computed_value::T,
        }

        impl Effects {
                        /// Set opacity.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_opacity(&mut self, v: longhands::opacity::computed_value::T) {
                            self.opacity = v;
                        }
                        /// Set opacity from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_opacity_from(&mut self, other: &Self) {
                            self.opacity = other.opacity.clone();
                        }
                    /// Reset opacity from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_opacity(&mut self, other: &Self) {
                        self.copy_opacity_from(other)
                    }

                    /// Get the computed value for opacity.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_opacity(&self) -> longhands::opacity::computed_value::T {
                        self.opacity.clone()
                    }
                        /// Set box-shadow.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_box_shadow<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::box_shadow
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.box_shadow = longhands::box_shadow::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set box-shadow from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_box_shadow_from(&mut self, other: &Self) {
                            self.box_shadow = other.box_shadow.clone();
                        }
                    /// Reset box-shadow from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_box_shadow(&mut self, other: &Self) {
                        self.copy_box_shadow_from(other)
                    }

                    /// Get the computed value for box-shadow.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_box_shadow(&self) -> longhands::box_shadow::computed_value::T {
                        self.box_shadow.clone()
                    }
                        /// Set clip.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_clip(&mut self, v: longhands::clip::computed_value::T) {
                            self.clip = v;
                        }
                        /// Set clip from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_clip_from(&mut self, other: &Self) {
                            self.clip = other.clip.clone();
                        }
                    /// Reset clip from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_clip(&mut self, other: &Self) {
                        self.copy_clip_from(other)
                    }

                    /// Get the computed value for clip.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_clip(&self) -> longhands::clip::computed_value::T {
                        self.clip.clone()
                    }
                        /// Set filter.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_filter<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::filter
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.filter = longhands::filter::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set filter from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_filter_from(&mut self, other: &Self) {
                            self.filter = other.filter.clone();
                        }
                    /// Reset filter from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_filter(&mut self, other: &Self) {
                        self.copy_filter_from(other)
                    }

                    /// Get the computed value for filter.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_filter(&self) -> longhands::filter::computed_value::T {
                        self.filter.clone()
                    }
                        /// Set mix-blend-mode.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_mix_blend_mode(&mut self, v: longhands::mix_blend_mode::computed_value::T) {
                            self.mix_blend_mode = v;
                        }
                        /// Set mix-blend-mode from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_mix_blend_mode_from(&mut self, other: &Self) {
                            self.mix_blend_mode = other.mix_blend_mode.clone();
                        }
                    /// Reset mix-blend-mode from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_mix_blend_mode(&mut self, other: &Self) {
                        self.copy_mix_blend_mode_from(other)
                    }

                    /// Get the computed value for mix-blend-mode.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_mix_blend_mode(&self) -> longhands::mix_blend_mode::computed_value::T {
                        self.mix_blend_mode.clone()
                    }
        }

        #[derive(Clone, Debug, MallocSizeOf)]
        /// The Font style struct.
        pub struct Font {
                /// The font-family computed value.
                pub font_family: longhands::font_family::computed_value::T,
                /// The font-style computed value.
                pub font_style: longhands::font_style::computed_value::T,
                /// The font-variant-caps computed value.
                pub font_variant_caps: longhands::font_variant_caps::computed_value::T,
                /// The font-weight computed value.
                pub font_weight: longhands::font_weight::computed_value::T,
                /// The font-size computed value.
                pub font_size: longhands::font_size::computed_value::T,
                /// The font-size-adjust computed value.
                pub font_size_adjust: longhands::font_size_adjust::computed_value::T,
                /// The font-synthesis computed value.
                pub font_synthesis: longhands::font_synthesis::computed_value::T,
                /// The font-stretch computed value.
                pub font_stretch: longhands::font_stretch::computed_value::T,
                /// The font-kerning computed value.
                pub font_kerning: longhands::font_kerning::computed_value::T,
                /// The font-variant-alternates computed value.
                pub font_variant_alternates: longhands::font_variant_alternates::computed_value::T,
                /// The font-variant-east-asian computed value.
                pub font_variant_east_asian: longhands::font_variant_east_asian::computed_value::T,
                /// The font-variant-ligatures computed value.
                pub font_variant_ligatures: longhands::font_variant_ligatures::computed_value::T,
                /// The font-variant-numeric computed value.
                pub font_variant_numeric: longhands::font_variant_numeric::computed_value::T,
                /// The font-variant-position computed value.
                pub font_variant_position: longhands::font_variant_position::computed_value::T,
                /// The font-feature-settings computed value.
                pub font_feature_settings: longhands::font_feature_settings::computed_value::T,
                /// The font-variation-settings computed value.
                pub font_variation_settings: longhands::font_variation_settings::computed_value::T,
                /// The font-language-override computed value.
                pub font_language_override: longhands::font_language_override::computed_value::T,
                /// The font-optical-sizing computed value.
                pub font_optical_sizing: longhands::font_optical_sizing::computed_value::T,
                /// The -x-lang computed value.
                pub _x_lang: longhands::_x_lang::computed_value::T,
                /// The -moz-script-size-multiplier computed value.
                pub _moz_script_size_multiplier: longhands::_moz_script_size_multiplier::computed_value::T,
                /// The -moz-script-level computed value.
                pub _moz_script_level: longhands::_moz_script_level::computed_value::T,
                /// The -moz-math-display computed value.
                pub _moz_math_display: longhands::_moz_math_display::computed_value::T,
                /// The -moz-math-variant computed value.
                pub _moz_math_variant: longhands::_moz_math_variant::computed_value::T,
                /// The -moz-script-min-size computed value.
                pub _moz_script_min_size: longhands::_moz_script_min_size::computed_value::T,
                /// The -x-text-zoom computed value.
                pub _x_text_zoom: longhands::_x_text_zoom::computed_value::T,
                /// The -moz-osx-font-smoothing computed value.
                pub _moz_osx_font_smoothing: longhands::_moz_osx_font_smoothing::computed_value::T,
                /// The -moz-font-smoothing-background-color computed value.
                pub _moz_font_smoothing_background_color: longhands::_moz_font_smoothing_background_color::computed_value::T,
                /// The -moz-min-font-size-ratio computed value.
                pub _moz_min_font_size_ratio: longhands::_moz_min_font_size_ratio::computed_value::T,
                /// The font hash, used for font caching.
                pub hash: u64,
        }
        impl PartialEq for Font {
            fn eq(&self, other: &Font) -> bool {
                self.hash == other.hash
                    && self.font_family == other.font_family
                    && self.font_style == other.font_style
                    && self.font_variant_caps == other.font_variant_caps
                    && self.font_weight == other.font_weight
                    && self.font_size == other.font_size
                    && self.font_size_adjust == other.font_size_adjust
                    && self.font_synthesis == other.font_synthesis
                    && self.font_stretch == other.font_stretch
                    && self.font_kerning == other.font_kerning
                    && self.font_variant_alternates == other.font_variant_alternates
                    && self.font_variant_east_asian == other.font_variant_east_asian
                    && self.font_variant_ligatures == other.font_variant_ligatures
                    && self.font_variant_numeric == other.font_variant_numeric
                    && self.font_variant_position == other.font_variant_position
                    && self.font_feature_settings == other.font_feature_settings
                    && self.font_variation_settings == other.font_variation_settings
                    && self.font_language_override == other.font_language_override
                    && self.font_optical_sizing == other.font_optical_sizing
                    && self._x_lang == other._x_lang
                    && self._moz_script_size_multiplier == other._moz_script_size_multiplier
                    && self._moz_script_level == other._moz_script_level
                    && self._moz_math_display == other._moz_math_display
                    && self._moz_math_variant == other._moz_math_variant
                    && self._moz_script_min_size == other._moz_script_min_size
                    && self._x_text_zoom == other._x_text_zoom
                    && self._moz_osx_font_smoothing == other._moz_osx_font_smoothing
                    && self._moz_font_smoothing_background_color == other._moz_font_smoothing_background_color
                    && self._moz_min_font_size_ratio == other._moz_min_font_size_ratio
            }
        }

        impl Font {
                        /// Set font-family.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_font_family(&mut self, v: longhands::font_family::computed_value::T) {
                            self.font_family = v;
                        }
                        /// Set font-family from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_font_family_from(&mut self, other: &Self) {
                            self.font_family = other.font_family.clone();
                        }
                    /// Reset font-family from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_font_family(&mut self, other: &Self) {
                        self.copy_font_family_from(other)
                    }

                    /// Get the computed value for font-family.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_font_family(&self) -> longhands::font_family::computed_value::T {
                        self.font_family.clone()
                    }
                        /// Set font-style.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_font_style(&mut self, v: longhands::font_style::computed_value::T) {
                            self.font_style = v;
                        }
                        /// Set font-style from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_font_style_from(&mut self, other: &Self) {
                            self.font_style = other.font_style.clone();
                        }
                    /// Reset font-style from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_font_style(&mut self, other: &Self) {
                        self.copy_font_style_from(other)
                    }

                    /// Get the computed value for font-style.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_font_style(&self) -> longhands::font_style::computed_value::T {
                        self.font_style.clone()
                    }
                        /// Set font-variant-caps.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_font_variant_caps(&mut self, v: longhands::font_variant_caps::computed_value::T) {
                            self.font_variant_caps = v;
                        }
                        /// Set font-variant-caps from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_font_variant_caps_from(&mut self, other: &Self) {
                            self.font_variant_caps = other.font_variant_caps.clone();
                        }
                    /// Reset font-variant-caps from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_font_variant_caps(&mut self, other: &Self) {
                        self.copy_font_variant_caps_from(other)
                    }

                    /// Get the computed value for font-variant-caps.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_font_variant_caps(&self) -> longhands::font_variant_caps::computed_value::T {
                        self.font_variant_caps.clone()
                    }
                        /// Set font-weight.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_font_weight(&mut self, v: longhands::font_weight::computed_value::T) {
                            self.font_weight = v;
                        }
                        /// Set font-weight from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_font_weight_from(&mut self, other: &Self) {
                            self.font_weight = other.font_weight.clone();
                        }
                    /// Reset font-weight from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_font_weight(&mut self, other: &Self) {
                        self.copy_font_weight_from(other)
                    }

                    /// Get the computed value for font-weight.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_font_weight(&self) -> longhands::font_weight::computed_value::T {
                        self.font_weight.clone()
                    }
                        /// Set font-size.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_font_size(&mut self, v: longhands::font_size::computed_value::T) {
                            self.font_size = v;
                        }
                        /// Set font-size from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_font_size_from(&mut self, other: &Self) {
                            self.font_size = other.font_size.clone();
                        }
                    /// Reset font-size from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_font_size(&mut self, other: &Self) {
                        self.copy_font_size_from(other)
                    }

                    /// Get the computed value for font-size.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_font_size(&self) -> longhands::font_size::computed_value::T {
                        self.font_size.clone()
                    }
                        /// Set font-size-adjust.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_font_size_adjust(&mut self, v: longhands::font_size_adjust::computed_value::T) {
                            self.font_size_adjust = v;
                        }
                        /// Set font-size-adjust from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_font_size_adjust_from(&mut self, other: &Self) {
                            self.font_size_adjust = other.font_size_adjust.clone();
                        }
                    /// Reset font-size-adjust from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_font_size_adjust(&mut self, other: &Self) {
                        self.copy_font_size_adjust_from(other)
                    }

                    /// Get the computed value for font-size-adjust.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_font_size_adjust(&self) -> longhands::font_size_adjust::computed_value::T {
                        self.font_size_adjust.clone()
                    }
                        /// Set font-synthesis.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_font_synthesis(&mut self, v: longhands::font_synthesis::computed_value::T) {
                            self.font_synthesis = v;
                        }
                        /// Set font-synthesis from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_font_synthesis_from(&mut self, other: &Self) {
                            self.font_synthesis = other.font_synthesis.clone();
                        }
                    /// Reset font-synthesis from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_font_synthesis(&mut self, other: &Self) {
                        self.copy_font_synthesis_from(other)
                    }

                    /// Get the computed value for font-synthesis.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_font_synthesis(&self) -> longhands::font_synthesis::computed_value::T {
                        self.font_synthesis.clone()
                    }
                        /// Set font-stretch.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_font_stretch(&mut self, v: longhands::font_stretch::computed_value::T) {
                            self.font_stretch = v;
                        }
                        /// Set font-stretch from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_font_stretch_from(&mut self, other: &Self) {
                            self.font_stretch = other.font_stretch.clone();
                        }
                    /// Reset font-stretch from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_font_stretch(&mut self, other: &Self) {
                        self.copy_font_stretch_from(other)
                    }

                    /// Get the computed value for font-stretch.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_font_stretch(&self) -> longhands::font_stretch::computed_value::T {
                        self.font_stretch.clone()
                    }
                        /// Set font-kerning.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_font_kerning(&mut self, v: longhands::font_kerning::computed_value::T) {
                            self.font_kerning = v;
                        }
                        /// Set font-kerning from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_font_kerning_from(&mut self, other: &Self) {
                            self.font_kerning = other.font_kerning.clone();
                        }
                    /// Reset font-kerning from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_font_kerning(&mut self, other: &Self) {
                        self.copy_font_kerning_from(other)
                    }

                    /// Get the computed value for font-kerning.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_font_kerning(&self) -> longhands::font_kerning::computed_value::T {
                        self.font_kerning.clone()
                    }
                        /// Set font-variant-alternates.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_font_variant_alternates(&mut self, v: longhands::font_variant_alternates::computed_value::T) {
                            self.font_variant_alternates = v;
                        }
                        /// Set font-variant-alternates from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_font_variant_alternates_from(&mut self, other: &Self) {
                            self.font_variant_alternates = other.font_variant_alternates.clone();
                        }
                    /// Reset font-variant-alternates from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_font_variant_alternates(&mut self, other: &Self) {
                        self.copy_font_variant_alternates_from(other)
                    }

                    /// Get the computed value for font-variant-alternates.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_font_variant_alternates(&self) -> longhands::font_variant_alternates::computed_value::T {
                        self.font_variant_alternates.clone()
                    }
                        /// Set font-variant-east-asian.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_font_variant_east_asian(&mut self, v: longhands::font_variant_east_asian::computed_value::T) {
                            self.font_variant_east_asian = v;
                        }
                        /// Set font-variant-east-asian from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_font_variant_east_asian_from(&mut self, other: &Self) {
                            self.font_variant_east_asian = other.font_variant_east_asian.clone();
                        }
                    /// Reset font-variant-east-asian from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_font_variant_east_asian(&mut self, other: &Self) {
                        self.copy_font_variant_east_asian_from(other)
                    }

                    /// Get the computed value for font-variant-east-asian.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_font_variant_east_asian(&self) -> longhands::font_variant_east_asian::computed_value::T {
                        self.font_variant_east_asian.clone()
                    }
                        /// Set font-variant-ligatures.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_font_variant_ligatures(&mut self, v: longhands::font_variant_ligatures::computed_value::T) {
                            self.font_variant_ligatures = v;
                        }
                        /// Set font-variant-ligatures from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_font_variant_ligatures_from(&mut self, other: &Self) {
                            self.font_variant_ligatures = other.font_variant_ligatures.clone();
                        }
                    /// Reset font-variant-ligatures from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_font_variant_ligatures(&mut self, other: &Self) {
                        self.copy_font_variant_ligatures_from(other)
                    }

                    /// Get the computed value for font-variant-ligatures.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_font_variant_ligatures(&self) -> longhands::font_variant_ligatures::computed_value::T {
                        self.font_variant_ligatures.clone()
                    }
                        /// Set font-variant-numeric.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_font_variant_numeric(&mut self, v: longhands::font_variant_numeric::computed_value::T) {
                            self.font_variant_numeric = v;
                        }
                        /// Set font-variant-numeric from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_font_variant_numeric_from(&mut self, other: &Self) {
                            self.font_variant_numeric = other.font_variant_numeric.clone();
                        }
                    /// Reset font-variant-numeric from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_font_variant_numeric(&mut self, other: &Self) {
                        self.copy_font_variant_numeric_from(other)
                    }

                    /// Get the computed value for font-variant-numeric.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_font_variant_numeric(&self) -> longhands::font_variant_numeric::computed_value::T {
                        self.font_variant_numeric.clone()
                    }
                        /// Set font-variant-position.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_font_variant_position(&mut self, v: longhands::font_variant_position::computed_value::T) {
                            self.font_variant_position = v;
                        }
                        /// Set font-variant-position from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_font_variant_position_from(&mut self, other: &Self) {
                            self.font_variant_position = other.font_variant_position.clone();
                        }
                    /// Reset font-variant-position from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_font_variant_position(&mut self, other: &Self) {
                        self.copy_font_variant_position_from(other)
                    }

                    /// Get the computed value for font-variant-position.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_font_variant_position(&self) -> longhands::font_variant_position::computed_value::T {
                        self.font_variant_position.clone()
                    }
                        /// Set font-feature-settings.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_font_feature_settings(&mut self, v: longhands::font_feature_settings::computed_value::T) {
                            self.font_feature_settings = v;
                        }
                        /// Set font-feature-settings from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_font_feature_settings_from(&mut self, other: &Self) {
                            self.font_feature_settings = other.font_feature_settings.clone();
                        }
                    /// Reset font-feature-settings from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_font_feature_settings(&mut self, other: &Self) {
                        self.copy_font_feature_settings_from(other)
                    }

                    /// Get the computed value for font-feature-settings.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_font_feature_settings(&self) -> longhands::font_feature_settings::computed_value::T {
                        self.font_feature_settings.clone()
                    }
                        /// Set font-variation-settings.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_font_variation_settings(&mut self, v: longhands::font_variation_settings::computed_value::T) {
                            self.font_variation_settings = v;
                        }
                        /// Set font-variation-settings from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_font_variation_settings_from(&mut self, other: &Self) {
                            self.font_variation_settings = other.font_variation_settings.clone();
                        }
                    /// Reset font-variation-settings from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_font_variation_settings(&mut self, other: &Self) {
                        self.copy_font_variation_settings_from(other)
                    }

                    /// Get the computed value for font-variation-settings.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_font_variation_settings(&self) -> longhands::font_variation_settings::computed_value::T {
                        self.font_variation_settings.clone()
                    }
                        /// Set font-language-override.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_font_language_override(&mut self, v: longhands::font_language_override::computed_value::T) {
                            self.font_language_override = v;
                        }
                        /// Set font-language-override from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_font_language_override_from(&mut self, other: &Self) {
                            self.font_language_override = other.font_language_override.clone();
                        }
                    /// Reset font-language-override from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_font_language_override(&mut self, other: &Self) {
                        self.copy_font_language_override_from(other)
                    }

                    /// Get the computed value for font-language-override.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_font_language_override(&self) -> longhands::font_language_override::computed_value::T {
                        self.font_language_override.clone()
                    }
                        /// Set font-optical-sizing.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_font_optical_sizing(&mut self, v: longhands::font_optical_sizing::computed_value::T) {
                            self.font_optical_sizing = v;
                        }
                        /// Set font-optical-sizing from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_font_optical_sizing_from(&mut self, other: &Self) {
                            self.font_optical_sizing = other.font_optical_sizing.clone();
                        }
                    /// Reset font-optical-sizing from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_font_optical_sizing(&mut self, other: &Self) {
                        self.copy_font_optical_sizing_from(other)
                    }

                    /// Get the computed value for font-optical-sizing.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_font_optical_sizing(&self) -> longhands::font_optical_sizing::computed_value::T {
                        self.font_optical_sizing.clone()
                    }
                        /// Set -x-lang.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__x_lang(&mut self, v: longhands::_x_lang::computed_value::T) {
                            self._x_lang = v;
                        }
                        /// Set -x-lang from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__x_lang_from(&mut self, other: &Self) {
                            self._x_lang = other._x_lang.clone();
                        }
                    /// Reset -x-lang from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__x_lang(&mut self, other: &Self) {
                        self.copy__x_lang_from(other)
                    }

                    /// Get the computed value for -x-lang.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__x_lang(&self) -> longhands::_x_lang::computed_value::T {
                        self._x_lang.clone()
                    }
                        /// Set -moz-script-size-multiplier.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_script_size_multiplier(&mut self, v: longhands::_moz_script_size_multiplier::computed_value::T) {
                            self._moz_script_size_multiplier = v;
                        }
                        /// Set -moz-script-size-multiplier from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_script_size_multiplier_from(&mut self, other: &Self) {
                            self._moz_script_size_multiplier = other._moz_script_size_multiplier.clone();
                        }
                    /// Reset -moz-script-size-multiplier from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_script_size_multiplier(&mut self, other: &Self) {
                        self.copy__moz_script_size_multiplier_from(other)
                    }

                    /// Get the computed value for -moz-script-size-multiplier.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_script_size_multiplier(&self) -> longhands::_moz_script_size_multiplier::computed_value::T {
                        self._moz_script_size_multiplier.clone()
                    }
                        /// Set -moz-script-level.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_script_level(&mut self, v: longhands::_moz_script_level::computed_value::T) {
                            self._moz_script_level = v;
                        }
                        /// Set -moz-script-level from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_script_level_from(&mut self, other: &Self) {
                            self._moz_script_level = other._moz_script_level.clone();
                        }
                    /// Reset -moz-script-level from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_script_level(&mut self, other: &Self) {
                        self.copy__moz_script_level_from(other)
                    }

                    /// Get the computed value for -moz-script-level.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_script_level(&self) -> longhands::_moz_script_level::computed_value::T {
                        self._moz_script_level.clone()
                    }
                        /// Set -moz-math-display.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_math_display(&mut self, v: longhands::_moz_math_display::computed_value::T) {
                            self._moz_math_display = v;
                        }
                        /// Set -moz-math-display from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_math_display_from(&mut self, other: &Self) {
                            self._moz_math_display = other._moz_math_display.clone();
                        }
                    /// Reset -moz-math-display from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_math_display(&mut self, other: &Self) {
                        self.copy__moz_math_display_from(other)
                    }

                    /// Get the computed value for -moz-math-display.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_math_display(&self) -> longhands::_moz_math_display::computed_value::T {
                        self._moz_math_display.clone()
                    }
                        /// Set -moz-math-variant.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_math_variant(&mut self, v: longhands::_moz_math_variant::computed_value::T) {
                            self._moz_math_variant = v;
                        }
                        /// Set -moz-math-variant from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_math_variant_from(&mut self, other: &Self) {
                            self._moz_math_variant = other._moz_math_variant.clone();
                        }
                    /// Reset -moz-math-variant from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_math_variant(&mut self, other: &Self) {
                        self.copy__moz_math_variant_from(other)
                    }

                    /// Get the computed value for -moz-math-variant.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_math_variant(&self) -> longhands::_moz_math_variant::computed_value::T {
                        self._moz_math_variant.clone()
                    }
                        /// Set -moz-script-min-size.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_script_min_size(&mut self, v: longhands::_moz_script_min_size::computed_value::T) {
                            self._moz_script_min_size = v;
                        }
                        /// Set -moz-script-min-size from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_script_min_size_from(&mut self, other: &Self) {
                            self._moz_script_min_size = other._moz_script_min_size.clone();
                        }
                    /// Reset -moz-script-min-size from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_script_min_size(&mut self, other: &Self) {
                        self.copy__moz_script_min_size_from(other)
                    }

                    /// Get the computed value for -moz-script-min-size.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_script_min_size(&self) -> longhands::_moz_script_min_size::computed_value::T {
                        self._moz_script_min_size.clone()
                    }
                        /// Set -x-text-zoom.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__x_text_zoom(&mut self, v: longhands::_x_text_zoom::computed_value::T) {
                            self._x_text_zoom = v;
                        }
                        /// Set -x-text-zoom from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__x_text_zoom_from(&mut self, other: &Self) {
                            self._x_text_zoom = other._x_text_zoom.clone();
                        }
                    /// Reset -x-text-zoom from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__x_text_zoom(&mut self, other: &Self) {
                        self.copy__x_text_zoom_from(other)
                    }

                    /// Get the computed value for -x-text-zoom.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__x_text_zoom(&self) -> longhands::_x_text_zoom::computed_value::T {
                        self._x_text_zoom.clone()
                    }
                        /// Set -moz-osx-font-smoothing.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_osx_font_smoothing(&mut self, v: longhands::_moz_osx_font_smoothing::computed_value::T) {
                            self._moz_osx_font_smoothing = v;
                        }
                        /// Set -moz-osx-font-smoothing from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_osx_font_smoothing_from(&mut self, other: &Self) {
                            self._moz_osx_font_smoothing = other._moz_osx_font_smoothing.clone();
                        }
                    /// Reset -moz-osx-font-smoothing from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_osx_font_smoothing(&mut self, other: &Self) {
                        self.copy__moz_osx_font_smoothing_from(other)
                    }

                    /// Get the computed value for -moz-osx-font-smoothing.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_osx_font_smoothing(&self) -> longhands::_moz_osx_font_smoothing::computed_value::T {
                        self._moz_osx_font_smoothing.clone()
                    }
                        /// Set -moz-font-smoothing-background-color.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_font_smoothing_background_color(&mut self, v: longhands::_moz_font_smoothing_background_color::computed_value::T) {
                            self._moz_font_smoothing_background_color = v;
                        }
                        /// Set -moz-font-smoothing-background-color from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_font_smoothing_background_color_from(&mut self, other: &Self) {
                            self._moz_font_smoothing_background_color = other._moz_font_smoothing_background_color.clone();
                        }
                    /// Reset -moz-font-smoothing-background-color from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_font_smoothing_background_color(&mut self, other: &Self) {
                        self.copy__moz_font_smoothing_background_color_from(other)
                    }

                    /// Get the computed value for -moz-font-smoothing-background-color.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_font_smoothing_background_color(&self) -> longhands::_moz_font_smoothing_background_color::computed_value::T {
                        self._moz_font_smoothing_background_color.clone()
                    }
                        /// Set -moz-min-font-size-ratio.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_min_font_size_ratio(&mut self, v: longhands::_moz_min_font_size_ratio::computed_value::T) {
                            self._moz_min_font_size_ratio = v;
                        }
                        /// Set -moz-min-font-size-ratio from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_min_font_size_ratio_from(&mut self, other: &Self) {
                            self._moz_min_font_size_ratio = other._moz_min_font_size_ratio.clone();
                        }
                    /// Reset -moz-min-font-size-ratio from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_min_font_size_ratio(&mut self, other: &Self) {
                        self.copy__moz_min_font_size_ratio_from(other)
                    }

                    /// Get the computed value for -moz-min-font-size-ratio.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_min_font_size_ratio(&self) -> longhands::_moz_min_font_size_ratio::computed_value::T {
                        self._moz_min_font_size_ratio.clone()
                    }
                /// Computes a font hash in order to be able to cache fonts
                /// effectively in GFX and layout.
                pub fn compute_font_hash(&mut self) {
                    // Corresponds to the fields in
                    // `gfx::font_template::FontTemplateDescriptor`.
                    let mut hasher: FxHasher = Default::default();
                    self.font_weight.hash(&mut hasher);
                    self.font_stretch.hash(&mut hasher);
                    self.font_style.hash(&mut hasher);
                    self.font_family.hash(&mut hasher);
                    self.hash = hasher.finish()
                }

                /// (Servo does not handle MathML, so this just calls copy_font_size_from)
                pub fn inherit_font_size_from(&mut self, parent: &Self,
                                              _: Option<NonNegativeLength>,
                                              _: &Device) {
                    self.copy_font_size_from(parent);
                }
                /// (Servo does not handle MathML, so this just calls set_font_size)
                pub fn apply_font_size(&mut self,
                                       v: longhands::font_size::computed_value::T,
                                       _: &Self,
                                       _: &Device) -> Option<NonNegativeLength> {
                    self.set_font_size(v);
                    None
                }
                /// (Servo does not handle MathML, so this does nothing)
                pub fn apply_unconstrained_font_size(&mut self, _: NonNegativeLength) {
                }

        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The InheritedBox style struct.
        pub struct InheritedBox {
                /// The visibility computed value.
                pub visibility: longhands::visibility::computed_value::T,
                /// The writing-mode computed value.
                pub writing_mode: longhands::writing_mode::computed_value::T,
                /// The direction computed value.
                pub direction: longhands::direction::computed_value::T,
                /// The text-orientation computed value.
                pub text_orientation: longhands::text_orientation::computed_value::T,
                /// The color-adjust computed value.
                pub color_adjust: longhands::color_adjust::computed_value::T,
                /// The image-rendering computed value.
                pub image_rendering: longhands::image_rendering::computed_value::T,
                /// The image-orientation computed value.
                pub image_orientation: longhands::image_orientation::computed_value::T,
        }

        impl InheritedBox {
                        /// Set visibility.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_visibility(&mut self, v: longhands::visibility::computed_value::T) {
                            self.visibility = v;
                        }
                        /// Set visibility from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_visibility_from(&mut self, other: &Self) {
                            self.visibility = other.visibility.clone();
                        }
                    /// Reset visibility from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_visibility(&mut self, other: &Self) {
                        self.copy_visibility_from(other)
                    }

                    /// Get the computed value for visibility.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_visibility(&self) -> longhands::visibility::computed_value::T {
                        self.visibility.clone()
                    }
                        /// Set writing-mode.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_writing_mode(&mut self, v: longhands::writing_mode::computed_value::T) {
                            self.writing_mode = v;
                        }
                        /// Set writing-mode from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_writing_mode_from(&mut self, other: &Self) {
                            self.writing_mode = other.writing_mode.clone();
                        }
                    /// Reset writing-mode from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_writing_mode(&mut self, other: &Self) {
                        self.copy_writing_mode_from(other)
                    }

                    /// Get the computed value for writing-mode.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_writing_mode(&self) -> longhands::writing_mode::computed_value::T {
                        self.writing_mode.clone()
                    }
                        /// Set direction.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_direction(&mut self, v: longhands::direction::computed_value::T) {
                            self.direction = v;
                        }
                        /// Set direction from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_direction_from(&mut self, other: &Self) {
                            self.direction = other.direction.clone();
                        }
                    /// Reset direction from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_direction(&mut self, other: &Self) {
                        self.copy_direction_from(other)
                    }

                    /// Get the computed value for direction.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_direction(&self) -> longhands::direction::computed_value::T {
                        self.direction.clone()
                    }
                        /// Set text-orientation.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_text_orientation(&mut self, v: longhands::text_orientation::computed_value::T) {
                            self.text_orientation = v;
                        }
                        /// Set text-orientation from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_text_orientation_from(&mut self, other: &Self) {
                            self.text_orientation = other.text_orientation.clone();
                        }
                    /// Reset text-orientation from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_text_orientation(&mut self, other: &Self) {
                        self.copy_text_orientation_from(other)
                    }

                    /// Get the computed value for text-orientation.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_text_orientation(&self) -> longhands::text_orientation::computed_value::T {
                        self.text_orientation.clone()
                    }
                        /// Set color-adjust.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_color_adjust(&mut self, v: longhands::color_adjust::computed_value::T) {
                            self.color_adjust = v;
                        }
                        /// Set color-adjust from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_color_adjust_from(&mut self, other: &Self) {
                            self.color_adjust = other.color_adjust.clone();
                        }
                    /// Reset color-adjust from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_color_adjust(&mut self, other: &Self) {
                        self.copy_color_adjust_from(other)
                    }

                    /// Get the computed value for color-adjust.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_color_adjust(&self) -> longhands::color_adjust::computed_value::T {
                        self.color_adjust.clone()
                    }
                        /// Set image-rendering.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_image_rendering(&mut self, v: longhands::image_rendering::computed_value::T) {
                            self.image_rendering = v;
                        }
                        /// Set image-rendering from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_image_rendering_from(&mut self, other: &Self) {
                            self.image_rendering = other.image_rendering.clone();
                        }
                    /// Reset image-rendering from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_image_rendering(&mut self, other: &Self) {
                        self.copy_image_rendering_from(other)
                    }

                    /// Get the computed value for image-rendering.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_image_rendering(&self) -> longhands::image_rendering::computed_value::T {
                        self.image_rendering.clone()
                    }
                        /// Set image-orientation.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_image_orientation(&mut self, v: longhands::image_orientation::computed_value::T) {
                            self.image_orientation = v;
                        }
                        /// Set image-orientation from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_image_orientation_from(&mut self, other: &Self) {
                            self.image_orientation = other.image_orientation.clone();
                        }
                    /// Reset image-orientation from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_image_orientation(&mut self, other: &Self) {
                        self.copy_image_orientation_from(other)
                    }

                    /// Get the computed value for image-orientation.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_image_orientation(&self) -> longhands::image_orientation::computed_value::T {
                        self.image_orientation.clone()
                    }
        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The InheritedTable style struct.
        pub struct InheritedTable {
                /// The border-collapse computed value.
                pub border_collapse: longhands::border_collapse::computed_value::T,
                /// The empty-cells computed value.
                pub empty_cells: longhands::empty_cells::computed_value::T,
                /// The caption-side computed value.
                pub caption_side: longhands::caption_side::computed_value::T,
                /// The border-spacing computed value.
                pub border_spacing: longhands::border_spacing::computed_value::T,
        }

        impl InheritedTable {
                        /// Set border-collapse.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_collapse(&mut self, v: longhands::border_collapse::computed_value::T) {
                            self.border_collapse = v;
                        }
                        /// Set border-collapse from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_collapse_from(&mut self, other: &Self) {
                            self.border_collapse = other.border_collapse.clone();
                        }
                    /// Reset border-collapse from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_collapse(&mut self, other: &Self) {
                        self.copy_border_collapse_from(other)
                    }

                    /// Get the computed value for border-collapse.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_collapse(&self) -> longhands::border_collapse::computed_value::T {
                        self.border_collapse.clone()
                    }
                        /// Set empty-cells.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_empty_cells(&mut self, v: longhands::empty_cells::computed_value::T) {
                            self.empty_cells = v;
                        }
                        /// Set empty-cells from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_empty_cells_from(&mut self, other: &Self) {
                            self.empty_cells = other.empty_cells.clone();
                        }
                    /// Reset empty-cells from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_empty_cells(&mut self, other: &Self) {
                        self.copy_empty_cells_from(other)
                    }

                    /// Get the computed value for empty-cells.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_empty_cells(&self) -> longhands::empty_cells::computed_value::T {
                        self.empty_cells.clone()
                    }
                        /// Set caption-side.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_caption_side(&mut self, v: longhands::caption_side::computed_value::T) {
                            self.caption_side = v;
                        }
                        /// Set caption-side from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_caption_side_from(&mut self, other: &Self) {
                            self.caption_side = other.caption_side.clone();
                        }
                    /// Reset caption-side from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_caption_side(&mut self, other: &Self) {
                        self.copy_caption_side_from(other)
                    }

                    /// Get the computed value for caption-side.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_caption_side(&self) -> longhands::caption_side::computed_value::T {
                        self.caption_side.clone()
                    }
                        /// Set border-spacing.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_border_spacing(&mut self, v: longhands::border_spacing::computed_value::T) {
                            self.border_spacing = v;
                        }
                        /// Set border-spacing from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_border_spacing_from(&mut self, other: &Self) {
                            self.border_spacing = other.border_spacing.clone();
                        }
                    /// Reset border-spacing from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_border_spacing(&mut self, other: &Self) {
                        self.copy_border_spacing_from(other)
                    }

                    /// Get the computed value for border-spacing.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_border_spacing(&self) -> longhands::border_spacing::computed_value::T {
                        self.border_spacing.clone()
                    }
        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The InheritedText style struct.
        pub struct InheritedText {
                /// The line-height computed value.
                pub line_height: longhands::line_height::computed_value::T,
                /// The text-transform computed value.
                pub text_transform: longhands::text_transform::computed_value::T,
                /// The hyphens computed value.
                pub hyphens: longhands::hyphens::computed_value::T,
                /// The -moz-text-size-adjust computed value.
                pub _moz_text_size_adjust: longhands::_moz_text_size_adjust::computed_value::T,
                /// The text-indent computed value.
                pub text_indent: longhands::text_indent::computed_value::T,
                /// The overflow-wrap computed value.
                pub overflow_wrap: longhands::overflow_wrap::computed_value::T,
                /// The word-break computed value.
                pub word_break: longhands::word_break::computed_value::T,
                /// The text-justify computed value.
                pub text_justify: longhands::text_justify::computed_value::T,
                /// The text-align-last computed value.
                pub text_align_last: longhands::text_align_last::computed_value::T,
                /// The text-align computed value.
                pub text_align: longhands::text_align::computed_value::T,
                /// The letter-spacing computed value.
                pub letter_spacing: longhands::letter_spacing::computed_value::T,
                /// The word-spacing computed value.
                pub word_spacing: longhands::word_spacing::computed_value::T,
                /// The white-space computed value.
                pub white_space: longhands::white_space::computed_value::T,
                /// The text-shadow computed value.
                pub text_shadow: longhands::text_shadow::computed_value::T,
                /// The text-emphasis-style computed value.
                pub text_emphasis_style: longhands::text_emphasis_style::computed_value::T,
                /// The text-emphasis-position computed value.
                pub text_emphasis_position: longhands::text_emphasis_position::computed_value::T,
                /// The text-emphasis-color computed value.
                pub text_emphasis_color: longhands::text_emphasis_color::computed_value::T,
                /// The -moz-tab-size computed value.
                pub _moz_tab_size: longhands::_moz_tab_size::computed_value::T,
                /// The -webkit-text-fill-color computed value.
                pub _webkit_text_fill_color: longhands::_webkit_text_fill_color::computed_value::T,
                /// The -webkit-text-stroke-color computed value.
                pub _webkit_text_stroke_color: longhands::_webkit_text_stroke_color::computed_value::T,
                /// The -webkit-text-stroke-width computed value.
                pub _webkit_text_stroke_width: longhands::_webkit_text_stroke_width::computed_value::T,
                /// The ruby-align computed value.
                pub ruby_align: longhands::ruby_align::computed_value::T,
                /// The ruby-position computed value.
                pub ruby_position: longhands::ruby_position::computed_value::T,
                /// The text-combine-upright computed value.
                pub text_combine_upright: longhands::text_combine_upright::computed_value::T,
                /// The text-rendering computed value.
                pub text_rendering: longhands::text_rendering::computed_value::T,
                /// The -moz-control-character-visibility computed value.
                pub _moz_control_character_visibility: longhands::_moz_control_character_visibility::computed_value::T,
                /// The "used" text-decorations that apply to this box.
                ///
                /// FIXME(emilio): This is technically a box-tree concept, and
                /// would be nice to move away from style.
                pub text_decorations_in_effect: crate::values::computed::text::TextDecorationsInEffect,
        }

        impl InheritedText {
                        /// Set line-height.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_line_height(&mut self, v: longhands::line_height::computed_value::T) {
                            self.line_height = v;
                        }
                        /// Set line-height from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_line_height_from(&mut self, other: &Self) {
                            self.line_height = other.line_height.clone();
                        }
                    /// Reset line-height from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_line_height(&mut self, other: &Self) {
                        self.copy_line_height_from(other)
                    }

                    /// Get the computed value for line-height.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_line_height(&self) -> longhands::line_height::computed_value::T {
                        self.line_height.clone()
                    }
                        /// Set text-transform.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_text_transform(&mut self, v: longhands::text_transform::computed_value::T) {
                            self.text_transform = v;
                        }
                        /// Set text-transform from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_text_transform_from(&mut self, other: &Self) {
                            self.text_transform = other.text_transform.clone();
                        }
                    /// Reset text-transform from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_text_transform(&mut self, other: &Self) {
                        self.copy_text_transform_from(other)
                    }

                    /// Get the computed value for text-transform.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_text_transform(&self) -> longhands::text_transform::computed_value::T {
                        self.text_transform.clone()
                    }
                        /// Set hyphens.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_hyphens(&mut self, v: longhands::hyphens::computed_value::T) {
                            self.hyphens = v;
                        }
                        /// Set hyphens from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_hyphens_from(&mut self, other: &Self) {
                            self.hyphens = other.hyphens.clone();
                        }
                    /// Reset hyphens from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_hyphens(&mut self, other: &Self) {
                        self.copy_hyphens_from(other)
                    }

                    /// Get the computed value for hyphens.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_hyphens(&self) -> longhands::hyphens::computed_value::T {
                        self.hyphens.clone()
                    }
                        /// Set -moz-text-size-adjust.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_text_size_adjust(&mut self, v: longhands::_moz_text_size_adjust::computed_value::T) {
                            self._moz_text_size_adjust = v;
                        }
                        /// Set -moz-text-size-adjust from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_text_size_adjust_from(&mut self, other: &Self) {
                            self._moz_text_size_adjust = other._moz_text_size_adjust.clone();
                        }
                    /// Reset -moz-text-size-adjust from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_text_size_adjust(&mut self, other: &Self) {
                        self.copy__moz_text_size_adjust_from(other)
                    }

                    /// Get the computed value for -moz-text-size-adjust.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_text_size_adjust(&self) -> longhands::_moz_text_size_adjust::computed_value::T {
                        self._moz_text_size_adjust.clone()
                    }
                        /// Set text-indent.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_text_indent(&mut self, v: longhands::text_indent::computed_value::T) {
                            self.text_indent = v;
                        }
                        /// Set text-indent from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_text_indent_from(&mut self, other: &Self) {
                            self.text_indent = other.text_indent.clone();
                        }
                    /// Reset text-indent from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_text_indent(&mut self, other: &Self) {
                        self.copy_text_indent_from(other)
                    }

                    /// Get the computed value for text-indent.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_text_indent(&self) -> longhands::text_indent::computed_value::T {
                        self.text_indent.clone()
                    }
                        /// Set overflow-wrap.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_overflow_wrap(&mut self, v: longhands::overflow_wrap::computed_value::T) {
                            self.overflow_wrap = v;
                        }
                        /// Set overflow-wrap from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_overflow_wrap_from(&mut self, other: &Self) {
                            self.overflow_wrap = other.overflow_wrap.clone();
                        }
                    /// Reset overflow-wrap from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_overflow_wrap(&mut self, other: &Self) {
                        self.copy_overflow_wrap_from(other)
                    }

                    /// Get the computed value for overflow-wrap.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_overflow_wrap(&self) -> longhands::overflow_wrap::computed_value::T {
                        self.overflow_wrap.clone()
                    }
                        /// Set word-break.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_word_break(&mut self, v: longhands::word_break::computed_value::T) {
                            self.word_break = v;
                        }
                        /// Set word-break from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_word_break_from(&mut self, other: &Self) {
                            self.word_break = other.word_break.clone();
                        }
                    /// Reset word-break from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_word_break(&mut self, other: &Self) {
                        self.copy_word_break_from(other)
                    }

                    /// Get the computed value for word-break.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_word_break(&self) -> longhands::word_break::computed_value::T {
                        self.word_break.clone()
                    }
                        /// Set text-justify.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_text_justify(&mut self, v: longhands::text_justify::computed_value::T) {
                            self.text_justify = v;
                        }
                        /// Set text-justify from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_text_justify_from(&mut self, other: &Self) {
                            self.text_justify = other.text_justify.clone();
                        }
                    /// Reset text-justify from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_text_justify(&mut self, other: &Self) {
                        self.copy_text_justify_from(other)
                    }

                    /// Get the computed value for text-justify.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_text_justify(&self) -> longhands::text_justify::computed_value::T {
                        self.text_justify.clone()
                    }
                        /// Set text-align-last.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_text_align_last(&mut self, v: longhands::text_align_last::computed_value::T) {
                            self.text_align_last = v;
                        }
                        /// Set text-align-last from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_text_align_last_from(&mut self, other: &Self) {
                            self.text_align_last = other.text_align_last.clone();
                        }
                    /// Reset text-align-last from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_text_align_last(&mut self, other: &Self) {
                        self.copy_text_align_last_from(other)
                    }

                    /// Get the computed value for text-align-last.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_text_align_last(&self) -> longhands::text_align_last::computed_value::T {
                        self.text_align_last.clone()
                    }
                        /// Set text-align.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_text_align(&mut self, v: longhands::text_align::computed_value::T) {
                            self.text_align = v;
                        }
                        /// Set text-align from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_text_align_from(&mut self, other: &Self) {
                            self.text_align = other.text_align.clone();
                        }
                    /// Reset text-align from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_text_align(&mut self, other: &Self) {
                        self.copy_text_align_from(other)
                    }

                    /// Get the computed value for text-align.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_text_align(&self) -> longhands::text_align::computed_value::T {
                        self.text_align.clone()
                    }
                        /// Set letter-spacing.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_letter_spacing(&mut self, v: longhands::letter_spacing::computed_value::T) {
                            self.letter_spacing = v;
                        }
                        /// Set letter-spacing from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_letter_spacing_from(&mut self, other: &Self) {
                            self.letter_spacing = other.letter_spacing.clone();
                        }
                    /// Reset letter-spacing from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_letter_spacing(&mut self, other: &Self) {
                        self.copy_letter_spacing_from(other)
                    }

                    /// Get the computed value for letter-spacing.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_letter_spacing(&self) -> longhands::letter_spacing::computed_value::T {
                        self.letter_spacing.clone()
                    }
                        /// Set word-spacing.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_word_spacing(&mut self, v: longhands::word_spacing::computed_value::T) {
                            self.word_spacing = v;
                        }
                        /// Set word-spacing from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_word_spacing_from(&mut self, other: &Self) {
                            self.word_spacing = other.word_spacing.clone();
                        }
                    /// Reset word-spacing from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_word_spacing(&mut self, other: &Self) {
                        self.copy_word_spacing_from(other)
                    }

                    /// Get the computed value for word-spacing.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_word_spacing(&self) -> longhands::word_spacing::computed_value::T {
                        self.word_spacing.clone()
                    }
                        /// Set white-space.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_white_space(&mut self, v: longhands::white_space::computed_value::T) {
                            self.white_space = v;
                        }
                        /// Set white-space from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_white_space_from(&mut self, other: &Self) {
                            self.white_space = other.white_space.clone();
                        }
                    /// Reset white-space from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_white_space(&mut self, other: &Self) {
                        self.copy_white_space_from(other)
                    }

                    /// Get the computed value for white-space.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_white_space(&self) -> longhands::white_space::computed_value::T {
                        self.white_space.clone()
                    }
                        /// Set text-shadow.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_text_shadow<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::text_shadow
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.text_shadow = longhands::text_shadow::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set text-shadow from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_text_shadow_from(&mut self, other: &Self) {
                            self.text_shadow = other.text_shadow.clone();
                        }
                    /// Reset text-shadow from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_text_shadow(&mut self, other: &Self) {
                        self.copy_text_shadow_from(other)
                    }

                    /// Get the computed value for text-shadow.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_text_shadow(&self) -> longhands::text_shadow::computed_value::T {
                        self.text_shadow.clone()
                    }
                        /// Set text-emphasis-style.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_text_emphasis_style(&mut self, v: longhands::text_emphasis_style::computed_value::T) {
                            self.text_emphasis_style = v;
                        }
                        /// Set text-emphasis-style from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_text_emphasis_style_from(&mut self, other: &Self) {
                            self.text_emphasis_style = other.text_emphasis_style.clone();
                        }
                    /// Reset text-emphasis-style from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_text_emphasis_style(&mut self, other: &Self) {
                        self.copy_text_emphasis_style_from(other)
                    }

                    /// Get the computed value for text-emphasis-style.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_text_emphasis_style(&self) -> longhands::text_emphasis_style::computed_value::T {
                        self.text_emphasis_style.clone()
                    }
                        /// Set text-emphasis-position.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_text_emphasis_position(&mut self, v: longhands::text_emphasis_position::computed_value::T) {
                            self.text_emphasis_position = v;
                        }
                        /// Set text-emphasis-position from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_text_emphasis_position_from(&mut self, other: &Self) {
                            self.text_emphasis_position = other.text_emphasis_position.clone();
                        }
                    /// Reset text-emphasis-position from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_text_emphasis_position(&mut self, other: &Self) {
                        self.copy_text_emphasis_position_from(other)
                    }

                    /// Get the computed value for text-emphasis-position.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_text_emphasis_position(&self) -> longhands::text_emphasis_position::computed_value::T {
                        self.text_emphasis_position.clone()
                    }
                        /// Set text-emphasis-color.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_text_emphasis_color(&mut self, v: longhands::text_emphasis_color::computed_value::T) {
                            self.text_emphasis_color = v;
                        }
                        /// Set text-emphasis-color from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_text_emphasis_color_from(&mut self, other: &Self) {
                            self.text_emphasis_color = other.text_emphasis_color.clone();
                        }
                    /// Reset text-emphasis-color from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_text_emphasis_color(&mut self, other: &Self) {
                        self.copy_text_emphasis_color_from(other)
                    }

                    /// Get the computed value for text-emphasis-color.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_text_emphasis_color(&self) -> longhands::text_emphasis_color::computed_value::T {
                        self.text_emphasis_color.clone()
                    }
                        /// Set -moz-tab-size.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_tab_size(&mut self, v: longhands::_moz_tab_size::computed_value::T) {
                            self._moz_tab_size = v;
                        }
                        /// Set -moz-tab-size from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_tab_size_from(&mut self, other: &Self) {
                            self._moz_tab_size = other._moz_tab_size.clone();
                        }
                    /// Reset -moz-tab-size from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_tab_size(&mut self, other: &Self) {
                        self.copy__moz_tab_size_from(other)
                    }

                    /// Get the computed value for -moz-tab-size.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_tab_size(&self) -> longhands::_moz_tab_size::computed_value::T {
                        self._moz_tab_size.clone()
                    }
                        /// Set -webkit-text-fill-color.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__webkit_text_fill_color(&mut self, v: longhands::_webkit_text_fill_color::computed_value::T) {
                            self._webkit_text_fill_color = v;
                        }
                        /// Set -webkit-text-fill-color from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__webkit_text_fill_color_from(&mut self, other: &Self) {
                            self._webkit_text_fill_color = other._webkit_text_fill_color.clone();
                        }
                    /// Reset -webkit-text-fill-color from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__webkit_text_fill_color(&mut self, other: &Self) {
                        self.copy__webkit_text_fill_color_from(other)
                    }

                    /// Get the computed value for -webkit-text-fill-color.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__webkit_text_fill_color(&self) -> longhands::_webkit_text_fill_color::computed_value::T {
                        self._webkit_text_fill_color.clone()
                    }
                        /// Set -webkit-text-stroke-color.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__webkit_text_stroke_color(&mut self, v: longhands::_webkit_text_stroke_color::computed_value::T) {
                            self._webkit_text_stroke_color = v;
                        }
                        /// Set -webkit-text-stroke-color from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__webkit_text_stroke_color_from(&mut self, other: &Self) {
                            self._webkit_text_stroke_color = other._webkit_text_stroke_color.clone();
                        }
                    /// Reset -webkit-text-stroke-color from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__webkit_text_stroke_color(&mut self, other: &Self) {
                        self.copy__webkit_text_stroke_color_from(other)
                    }

                    /// Get the computed value for -webkit-text-stroke-color.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__webkit_text_stroke_color(&self) -> longhands::_webkit_text_stroke_color::computed_value::T {
                        self._webkit_text_stroke_color.clone()
                    }
                        /// Set -webkit-text-stroke-width.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__webkit_text_stroke_width(&mut self, v: longhands::_webkit_text_stroke_width::computed_value::T) {
                            self._webkit_text_stroke_width = v;
                        }
                        /// Set -webkit-text-stroke-width from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__webkit_text_stroke_width_from(&mut self, other: &Self) {
                            self._webkit_text_stroke_width = other._webkit_text_stroke_width.clone();
                        }
                    /// Reset -webkit-text-stroke-width from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__webkit_text_stroke_width(&mut self, other: &Self) {
                        self.copy__webkit_text_stroke_width_from(other)
                    }

                    /// Get the computed value for -webkit-text-stroke-width.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__webkit_text_stroke_width(&self) -> longhands::_webkit_text_stroke_width::computed_value::T {
                        self._webkit_text_stroke_width.clone()
                    }
                        /// Set ruby-align.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_ruby_align(&mut self, v: longhands::ruby_align::computed_value::T) {
                            self.ruby_align = v;
                        }
                        /// Set ruby-align from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_ruby_align_from(&mut self, other: &Self) {
                            self.ruby_align = other.ruby_align.clone();
                        }
                    /// Reset ruby-align from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_ruby_align(&mut self, other: &Self) {
                        self.copy_ruby_align_from(other)
                    }

                    /// Get the computed value for ruby-align.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_ruby_align(&self) -> longhands::ruby_align::computed_value::T {
                        self.ruby_align.clone()
                    }
                        /// Set ruby-position.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_ruby_position(&mut self, v: longhands::ruby_position::computed_value::T) {
                            self.ruby_position = v;
                        }
                        /// Set ruby-position from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_ruby_position_from(&mut self, other: &Self) {
                            self.ruby_position = other.ruby_position.clone();
                        }
                    /// Reset ruby-position from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_ruby_position(&mut self, other: &Self) {
                        self.copy_ruby_position_from(other)
                    }

                    /// Get the computed value for ruby-position.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_ruby_position(&self) -> longhands::ruby_position::computed_value::T {
                        self.ruby_position.clone()
                    }
                        /// Set text-combine-upright.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_text_combine_upright(&mut self, v: longhands::text_combine_upright::computed_value::T) {
                            self.text_combine_upright = v;
                        }
                        /// Set text-combine-upright from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_text_combine_upright_from(&mut self, other: &Self) {
                            self.text_combine_upright = other.text_combine_upright.clone();
                        }
                    /// Reset text-combine-upright from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_text_combine_upright(&mut self, other: &Self) {
                        self.copy_text_combine_upright_from(other)
                    }

                    /// Get the computed value for text-combine-upright.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_text_combine_upright(&self) -> longhands::text_combine_upright::computed_value::T {
                        self.text_combine_upright.clone()
                    }
                        /// Set text-rendering.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_text_rendering(&mut self, v: longhands::text_rendering::computed_value::T) {
                            self.text_rendering = v;
                        }
                        /// Set text-rendering from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_text_rendering_from(&mut self, other: &Self) {
                            self.text_rendering = other.text_rendering.clone();
                        }
                    /// Reset text-rendering from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_text_rendering(&mut self, other: &Self) {
                        self.copy_text_rendering_from(other)
                    }

                    /// Get the computed value for text-rendering.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_text_rendering(&self) -> longhands::text_rendering::computed_value::T {
                        self.text_rendering.clone()
                    }
                        /// Set -moz-control-character-visibility.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_control_character_visibility(&mut self, v: longhands::_moz_control_character_visibility::computed_value::T) {
                            self._moz_control_character_visibility = v;
                        }
                        /// Set -moz-control-character-visibility from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_control_character_visibility_from(&mut self, other: &Self) {
                            self._moz_control_character_visibility = other._moz_control_character_visibility.clone();
                        }
                    /// Reset -moz-control-character-visibility from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_control_character_visibility(&mut self, other: &Self) {
                        self.copy__moz_control_character_visibility_from(other)
                    }

                    /// Get the computed value for -moz-control-character-visibility.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_control_character_visibility(&self) -> longhands::_moz_control_character_visibility::computed_value::T {
                        self._moz_control_character_visibility.clone()
                    }
        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The InheritedUI style struct.
        pub struct InheritedUI {
                /// The cursor computed value.
                pub cursor: longhands::cursor::computed_value::T,
                /// The pointer-events computed value.
                pub pointer_events: longhands::pointer_events::computed_value::T,
                /// The -moz-user-input computed value.
                pub _moz_user_input: longhands::_moz_user_input::computed_value::T,
                /// The -moz-user-modify computed value.
                pub _moz_user_modify: longhands::_moz_user_modify::computed_value::T,
                /// The -moz-user-focus computed value.
                pub _moz_user_focus: longhands::_moz_user_focus::computed_value::T,
                /// The caret-color computed value.
                pub caret_color: longhands::caret_color::computed_value::T,
                /// The scrollbar-color computed value.
                pub scrollbar_color: longhands::scrollbar_color::computed_value::T,
        }

        impl InheritedUI {
                        /// Set cursor.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_cursor(&mut self, v: longhands::cursor::computed_value::T) {
                            self.cursor = v;
                        }
                        /// Set cursor from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_cursor_from(&mut self, other: &Self) {
                            self.cursor = other.cursor.clone();
                        }
                    /// Reset cursor from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_cursor(&mut self, other: &Self) {
                        self.copy_cursor_from(other)
                    }

                    /// Get the computed value for cursor.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_cursor(&self) -> longhands::cursor::computed_value::T {
                        self.cursor.clone()
                    }
                        /// Set pointer-events.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_pointer_events(&mut self, v: longhands::pointer_events::computed_value::T) {
                            self.pointer_events = v;
                        }
                        /// Set pointer-events from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_pointer_events_from(&mut self, other: &Self) {
                            self.pointer_events = other.pointer_events.clone();
                        }
                    /// Reset pointer-events from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_pointer_events(&mut self, other: &Self) {
                        self.copy_pointer_events_from(other)
                    }

                    /// Get the computed value for pointer-events.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_pointer_events(&self) -> longhands::pointer_events::computed_value::T {
                        self.pointer_events.clone()
                    }
                        /// Set -moz-user-input.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_user_input(&mut self, v: longhands::_moz_user_input::computed_value::T) {
                            self._moz_user_input = v;
                        }
                        /// Set -moz-user-input from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_user_input_from(&mut self, other: &Self) {
                            self._moz_user_input = other._moz_user_input.clone();
                        }
                    /// Reset -moz-user-input from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_user_input(&mut self, other: &Self) {
                        self.copy__moz_user_input_from(other)
                    }

                    /// Get the computed value for -moz-user-input.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_user_input(&self) -> longhands::_moz_user_input::computed_value::T {
                        self._moz_user_input.clone()
                    }
                        /// Set -moz-user-modify.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_user_modify(&mut self, v: longhands::_moz_user_modify::computed_value::T) {
                            self._moz_user_modify = v;
                        }
                        /// Set -moz-user-modify from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_user_modify_from(&mut self, other: &Self) {
                            self._moz_user_modify = other._moz_user_modify.clone();
                        }
                    /// Reset -moz-user-modify from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_user_modify(&mut self, other: &Self) {
                        self.copy__moz_user_modify_from(other)
                    }

                    /// Get the computed value for -moz-user-modify.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_user_modify(&self) -> longhands::_moz_user_modify::computed_value::T {
                        self._moz_user_modify.clone()
                    }
                        /// Set -moz-user-focus.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_user_focus(&mut self, v: longhands::_moz_user_focus::computed_value::T) {
                            self._moz_user_focus = v;
                        }
                        /// Set -moz-user-focus from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_user_focus_from(&mut self, other: &Self) {
                            self._moz_user_focus = other._moz_user_focus.clone();
                        }
                    /// Reset -moz-user-focus from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_user_focus(&mut self, other: &Self) {
                        self.copy__moz_user_focus_from(other)
                    }

                    /// Get the computed value for -moz-user-focus.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_user_focus(&self) -> longhands::_moz_user_focus::computed_value::T {
                        self._moz_user_focus.clone()
                    }
                        /// Set caret-color.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_caret_color(&mut self, v: longhands::caret_color::computed_value::T) {
                            self.caret_color = v;
                        }
                        /// Set caret-color from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_caret_color_from(&mut self, other: &Self) {
                            self.caret_color = other.caret_color.clone();
                        }
                    /// Reset caret-color from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_caret_color(&mut self, other: &Self) {
                        self.copy_caret_color_from(other)
                    }

                    /// Get the computed value for caret-color.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_caret_color(&self) -> longhands::caret_color::computed_value::T {
                        self.caret_color.clone()
                    }
                        /// Set scrollbar-color.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_scrollbar_color(&mut self, v: longhands::scrollbar_color::computed_value::T) {
                            self.scrollbar_color = v;
                        }
                        /// Set scrollbar-color from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_scrollbar_color_from(&mut self, other: &Self) {
                            self.scrollbar_color = other.scrollbar_color.clone();
                        }
                    /// Reset scrollbar-color from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_scrollbar_color(&mut self, other: &Self) {
                        self.copy_scrollbar_color_from(other)
                    }

                    /// Get the computed value for scrollbar-color.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_scrollbar_color(&self) -> longhands::scrollbar_color::computed_value::T {
                        self.scrollbar_color.clone()
                    }
        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The InheritedSVG style struct.
        pub struct InheritedSVG {
                /// The text-anchor computed value.
                pub text_anchor: longhands::text_anchor::computed_value::T,
                /// The color-interpolation computed value.
                pub color_interpolation: longhands::color_interpolation::computed_value::T,
                /// The color-interpolation-filters computed value.
                pub color_interpolation_filters: longhands::color_interpolation_filters::computed_value::T,
                /// The fill computed value.
                pub fill: longhands::fill::computed_value::T,
                /// The fill-opacity computed value.
                pub fill_opacity: longhands::fill_opacity::computed_value::T,
                /// The fill-rule computed value.
                pub fill_rule: longhands::fill_rule::computed_value::T,
                /// The shape-rendering computed value.
                pub shape_rendering: longhands::shape_rendering::computed_value::T,
                /// The stroke computed value.
                pub stroke: longhands::stroke::computed_value::T,
                /// The stroke-width computed value.
                pub stroke_width: longhands::stroke_width::computed_value::T,
                /// The stroke-linecap computed value.
                pub stroke_linecap: longhands::stroke_linecap::computed_value::T,
                /// The stroke-linejoin computed value.
                pub stroke_linejoin: longhands::stroke_linejoin::computed_value::T,
                /// The stroke-miterlimit computed value.
                pub stroke_miterlimit: longhands::stroke_miterlimit::computed_value::T,
                /// The stroke-opacity computed value.
                pub stroke_opacity: longhands::stroke_opacity::computed_value::T,
                /// The stroke-dasharray computed value.
                pub stroke_dasharray: longhands::stroke_dasharray::computed_value::T,
                /// The stroke-dashoffset computed value.
                pub stroke_dashoffset: longhands::stroke_dashoffset::computed_value::T,
                /// The clip-rule computed value.
                pub clip_rule: longhands::clip_rule::computed_value::T,
                /// The marker-start computed value.
                pub marker_start: longhands::marker_start::computed_value::T,
                /// The marker-mid computed value.
                pub marker_mid: longhands::marker_mid::computed_value::T,
                /// The marker-end computed value.
                pub marker_end: longhands::marker_end::computed_value::T,
                /// The paint-order computed value.
                pub paint_order: longhands::paint_order::computed_value::T,
                /// The -moz-context-properties computed value.
                pub _moz_context_properties: longhands::_moz_context_properties::computed_value::T,
        }

        impl InheritedSVG {
                        /// Set text-anchor.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_text_anchor(&mut self, v: longhands::text_anchor::computed_value::T) {
                            self.text_anchor = v;
                        }
                        /// Set text-anchor from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_text_anchor_from(&mut self, other: &Self) {
                            self.text_anchor = other.text_anchor.clone();
                        }
                    /// Reset text-anchor from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_text_anchor(&mut self, other: &Self) {
                        self.copy_text_anchor_from(other)
                    }

                    /// Get the computed value for text-anchor.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_text_anchor(&self) -> longhands::text_anchor::computed_value::T {
                        self.text_anchor.clone()
                    }
                        /// Set color-interpolation.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_color_interpolation(&mut self, v: longhands::color_interpolation::computed_value::T) {
                            self.color_interpolation = v;
                        }
                        /// Set color-interpolation from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_color_interpolation_from(&mut self, other: &Self) {
                            self.color_interpolation = other.color_interpolation.clone();
                        }
                    /// Reset color-interpolation from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_color_interpolation(&mut self, other: &Self) {
                        self.copy_color_interpolation_from(other)
                    }

                    /// Get the computed value for color-interpolation.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_color_interpolation(&self) -> longhands::color_interpolation::computed_value::T {
                        self.color_interpolation.clone()
                    }
                        /// Set color-interpolation-filters.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_color_interpolation_filters(&mut self, v: longhands::color_interpolation_filters::computed_value::T) {
                            self.color_interpolation_filters = v;
                        }
                        /// Set color-interpolation-filters from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_color_interpolation_filters_from(&mut self, other: &Self) {
                            self.color_interpolation_filters = other.color_interpolation_filters.clone();
                        }
                    /// Reset color-interpolation-filters from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_color_interpolation_filters(&mut self, other: &Self) {
                        self.copy_color_interpolation_filters_from(other)
                    }

                    /// Get the computed value for color-interpolation-filters.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_color_interpolation_filters(&self) -> longhands::color_interpolation_filters::computed_value::T {
                        self.color_interpolation_filters.clone()
                    }
                        /// Set fill.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_fill(&mut self, v: longhands::fill::computed_value::T) {
                            self.fill = v;
                        }
                        /// Set fill from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_fill_from(&mut self, other: &Self) {
                            self.fill = other.fill.clone();
                        }
                    /// Reset fill from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_fill(&mut self, other: &Self) {
                        self.copy_fill_from(other)
                    }

                    /// Get the computed value for fill.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_fill(&self) -> longhands::fill::computed_value::T {
                        self.fill.clone()
                    }
                        /// Set fill-opacity.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_fill_opacity(&mut self, v: longhands::fill_opacity::computed_value::T) {
                            self.fill_opacity = v;
                        }
                        /// Set fill-opacity from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_fill_opacity_from(&mut self, other: &Self) {
                            self.fill_opacity = other.fill_opacity.clone();
                        }
                    /// Reset fill-opacity from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_fill_opacity(&mut self, other: &Self) {
                        self.copy_fill_opacity_from(other)
                    }

                    /// Get the computed value for fill-opacity.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_fill_opacity(&self) -> longhands::fill_opacity::computed_value::T {
                        self.fill_opacity.clone()
                    }
                        /// Set fill-rule.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_fill_rule(&mut self, v: longhands::fill_rule::computed_value::T) {
                            self.fill_rule = v;
                        }
                        /// Set fill-rule from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_fill_rule_from(&mut self, other: &Self) {
                            self.fill_rule = other.fill_rule.clone();
                        }
                    /// Reset fill-rule from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_fill_rule(&mut self, other: &Self) {
                        self.copy_fill_rule_from(other)
                    }

                    /// Get the computed value for fill-rule.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_fill_rule(&self) -> longhands::fill_rule::computed_value::T {
                        self.fill_rule.clone()
                    }
                        /// Set shape-rendering.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_shape_rendering(&mut self, v: longhands::shape_rendering::computed_value::T) {
                            self.shape_rendering = v;
                        }
                        /// Set shape-rendering from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_shape_rendering_from(&mut self, other: &Self) {
                            self.shape_rendering = other.shape_rendering.clone();
                        }
                    /// Reset shape-rendering from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_shape_rendering(&mut self, other: &Self) {
                        self.copy_shape_rendering_from(other)
                    }

                    /// Get the computed value for shape-rendering.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_shape_rendering(&self) -> longhands::shape_rendering::computed_value::T {
                        self.shape_rendering.clone()
                    }
                        /// Set stroke.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_stroke(&mut self, v: longhands::stroke::computed_value::T) {
                            self.stroke = v;
                        }
                        /// Set stroke from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_stroke_from(&mut self, other: &Self) {
                            self.stroke = other.stroke.clone();
                        }
                    /// Reset stroke from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_stroke(&mut self, other: &Self) {
                        self.copy_stroke_from(other)
                    }

                    /// Get the computed value for stroke.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_stroke(&self) -> longhands::stroke::computed_value::T {
                        self.stroke.clone()
                    }
                        /// Set stroke-width.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_stroke_width(&mut self, v: longhands::stroke_width::computed_value::T) {
                            self.stroke_width = v;
                        }
                        /// Set stroke-width from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_stroke_width_from(&mut self, other: &Self) {
                            self.stroke_width = other.stroke_width.clone();
                        }
                    /// Reset stroke-width from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_stroke_width(&mut self, other: &Self) {
                        self.copy_stroke_width_from(other)
                    }

                    /// Get the computed value for stroke-width.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_stroke_width(&self) -> longhands::stroke_width::computed_value::T {
                        self.stroke_width.clone()
                    }
                        /// Set stroke-linecap.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_stroke_linecap(&mut self, v: longhands::stroke_linecap::computed_value::T) {
                            self.stroke_linecap = v;
                        }
                        /// Set stroke-linecap from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_stroke_linecap_from(&mut self, other: &Self) {
                            self.stroke_linecap = other.stroke_linecap.clone();
                        }
                    /// Reset stroke-linecap from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_stroke_linecap(&mut self, other: &Self) {
                        self.copy_stroke_linecap_from(other)
                    }

                    /// Get the computed value for stroke-linecap.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_stroke_linecap(&self) -> longhands::stroke_linecap::computed_value::T {
                        self.stroke_linecap.clone()
                    }
                        /// Set stroke-linejoin.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_stroke_linejoin(&mut self, v: longhands::stroke_linejoin::computed_value::T) {
                            self.stroke_linejoin = v;
                        }
                        /// Set stroke-linejoin from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_stroke_linejoin_from(&mut self, other: &Self) {
                            self.stroke_linejoin = other.stroke_linejoin.clone();
                        }
                    /// Reset stroke-linejoin from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_stroke_linejoin(&mut self, other: &Self) {
                        self.copy_stroke_linejoin_from(other)
                    }

                    /// Get the computed value for stroke-linejoin.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_stroke_linejoin(&self) -> longhands::stroke_linejoin::computed_value::T {
                        self.stroke_linejoin.clone()
                    }
                        /// Set stroke-miterlimit.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_stroke_miterlimit(&mut self, v: longhands::stroke_miterlimit::computed_value::T) {
                            self.stroke_miterlimit = v;
                        }
                        /// Set stroke-miterlimit from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_stroke_miterlimit_from(&mut self, other: &Self) {
                            self.stroke_miterlimit = other.stroke_miterlimit.clone();
                        }
                    /// Reset stroke-miterlimit from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_stroke_miterlimit(&mut self, other: &Self) {
                        self.copy_stroke_miterlimit_from(other)
                    }

                    /// Get the computed value for stroke-miterlimit.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_stroke_miterlimit(&self) -> longhands::stroke_miterlimit::computed_value::T {
                        self.stroke_miterlimit.clone()
                    }
                        /// Set stroke-opacity.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_stroke_opacity(&mut self, v: longhands::stroke_opacity::computed_value::T) {
                            self.stroke_opacity = v;
                        }
                        /// Set stroke-opacity from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_stroke_opacity_from(&mut self, other: &Self) {
                            self.stroke_opacity = other.stroke_opacity.clone();
                        }
                    /// Reset stroke-opacity from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_stroke_opacity(&mut self, other: &Self) {
                        self.copy_stroke_opacity_from(other)
                    }

                    /// Get the computed value for stroke-opacity.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_stroke_opacity(&self) -> longhands::stroke_opacity::computed_value::T {
                        self.stroke_opacity.clone()
                    }
                        /// Set stroke-dasharray.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_stroke_dasharray(&mut self, v: longhands::stroke_dasharray::computed_value::T) {
                            self.stroke_dasharray = v;
                        }
                        /// Set stroke-dasharray from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_stroke_dasharray_from(&mut self, other: &Self) {
                            self.stroke_dasharray = other.stroke_dasharray.clone();
                        }
                    /// Reset stroke-dasharray from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_stroke_dasharray(&mut self, other: &Self) {
                        self.copy_stroke_dasharray_from(other)
                    }

                    /// Get the computed value for stroke-dasharray.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_stroke_dasharray(&self) -> longhands::stroke_dasharray::computed_value::T {
                        self.stroke_dasharray.clone()
                    }
                        /// Set stroke-dashoffset.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_stroke_dashoffset(&mut self, v: longhands::stroke_dashoffset::computed_value::T) {
                            self.stroke_dashoffset = v;
                        }
                        /// Set stroke-dashoffset from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_stroke_dashoffset_from(&mut self, other: &Self) {
                            self.stroke_dashoffset = other.stroke_dashoffset.clone();
                        }
                    /// Reset stroke-dashoffset from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_stroke_dashoffset(&mut self, other: &Self) {
                        self.copy_stroke_dashoffset_from(other)
                    }

                    /// Get the computed value for stroke-dashoffset.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_stroke_dashoffset(&self) -> longhands::stroke_dashoffset::computed_value::T {
                        self.stroke_dashoffset.clone()
                    }
                        /// Set clip-rule.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_clip_rule(&mut self, v: longhands::clip_rule::computed_value::T) {
                            self.clip_rule = v;
                        }
                        /// Set clip-rule from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_clip_rule_from(&mut self, other: &Self) {
                            self.clip_rule = other.clip_rule.clone();
                        }
                    /// Reset clip-rule from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_clip_rule(&mut self, other: &Self) {
                        self.copy_clip_rule_from(other)
                    }

                    /// Get the computed value for clip-rule.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_clip_rule(&self) -> longhands::clip_rule::computed_value::T {
                        self.clip_rule.clone()
                    }
                        /// Set marker-start.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_marker_start(&mut self, v: longhands::marker_start::computed_value::T) {
                            self.marker_start = v;
                        }
                        /// Set marker-start from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_marker_start_from(&mut self, other: &Self) {
                            self.marker_start = other.marker_start.clone();
                        }
                    /// Reset marker-start from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_marker_start(&mut self, other: &Self) {
                        self.copy_marker_start_from(other)
                    }

                    /// Get the computed value for marker-start.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_marker_start(&self) -> longhands::marker_start::computed_value::T {
                        self.marker_start.clone()
                    }
                        /// Set marker-mid.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_marker_mid(&mut self, v: longhands::marker_mid::computed_value::T) {
                            self.marker_mid = v;
                        }
                        /// Set marker-mid from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_marker_mid_from(&mut self, other: &Self) {
                            self.marker_mid = other.marker_mid.clone();
                        }
                    /// Reset marker-mid from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_marker_mid(&mut self, other: &Self) {
                        self.copy_marker_mid_from(other)
                    }

                    /// Get the computed value for marker-mid.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_marker_mid(&self) -> longhands::marker_mid::computed_value::T {
                        self.marker_mid.clone()
                    }
                        /// Set marker-end.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_marker_end(&mut self, v: longhands::marker_end::computed_value::T) {
                            self.marker_end = v;
                        }
                        /// Set marker-end from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_marker_end_from(&mut self, other: &Self) {
                            self.marker_end = other.marker_end.clone();
                        }
                    /// Reset marker-end from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_marker_end(&mut self, other: &Self) {
                        self.copy_marker_end_from(other)
                    }

                    /// Get the computed value for marker-end.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_marker_end(&self) -> longhands::marker_end::computed_value::T {
                        self.marker_end.clone()
                    }
                        /// Set paint-order.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_paint_order(&mut self, v: longhands::paint_order::computed_value::T) {
                            self.paint_order = v;
                        }
                        /// Set paint-order from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_paint_order_from(&mut self, other: &Self) {
                            self.paint_order = other.paint_order.clone();
                        }
                    /// Reset paint-order from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_paint_order(&mut self, other: &Self) {
                        self.copy_paint_order_from(other)
                    }

                    /// Get the computed value for paint-order.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_paint_order(&self) -> longhands::paint_order::computed_value::T {
                        self.paint_order.clone()
                    }
                        /// Set -moz-context-properties.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_context_properties(&mut self, v: longhands::_moz_context_properties::computed_value::T) {
                            self._moz_context_properties = v;
                        }
                        /// Set -moz-context-properties from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_context_properties_from(&mut self, other: &Self) {
                            self._moz_context_properties = other._moz_context_properties.clone();
                        }
                    /// Reset -moz-context-properties from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_context_properties(&mut self, other: &Self) {
                        self.copy__moz_context_properties_from(other)
                    }

                    /// Get the computed value for -moz-context-properties.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_context_properties(&self) -> longhands::_moz_context_properties::computed_value::T {
                        self._moz_context_properties.clone()
                    }
        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The List style struct.
        pub struct List {
                /// The list-style-position computed value.
                pub list_style_position: longhands::list_style_position::computed_value::T,
                /// The list-style-type computed value.
                pub list_style_type: longhands::list_style_type::computed_value::T,
                /// The list-style-image computed value.
                pub list_style_image: longhands::list_style_image::computed_value::T,
                /// The quotes computed value.
                pub quotes: longhands::quotes::computed_value::T,
                /// The -moz-image-region computed value.
                pub _moz_image_region: longhands::_moz_image_region::computed_value::T,
                /// The -moz-list-reversed computed value.
                pub _moz_list_reversed: longhands::_moz_list_reversed::computed_value::T,
        }

        impl List {
                        /// Set list-style-position.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_list_style_position(&mut self, v: longhands::list_style_position::computed_value::T) {
                            self.list_style_position = v;
                        }
                        /// Set list-style-position from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_list_style_position_from(&mut self, other: &Self) {
                            self.list_style_position = other.list_style_position.clone();
                        }
                    /// Reset list-style-position from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_list_style_position(&mut self, other: &Self) {
                        self.copy_list_style_position_from(other)
                    }

                    /// Get the computed value for list-style-position.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_list_style_position(&self) -> longhands::list_style_position::computed_value::T {
                        self.list_style_position.clone()
                    }
                        /// Set list-style-type.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_list_style_type(&mut self, v: longhands::list_style_type::computed_value::T) {
                            self.list_style_type = v;
                        }
                        /// Set list-style-type from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_list_style_type_from(&mut self, other: &Self) {
                            self.list_style_type = other.list_style_type.clone();
                        }
                    /// Reset list-style-type from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_list_style_type(&mut self, other: &Self) {
                        self.copy_list_style_type_from(other)
                    }

                    /// Get the computed value for list-style-type.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_list_style_type(&self) -> longhands::list_style_type::computed_value::T {
                        self.list_style_type.clone()
                    }
                        /// Set list-style-image.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_list_style_image(&mut self, v: longhands::list_style_image::computed_value::T) {
                            self.list_style_image = v;
                        }
                        /// Set list-style-image from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_list_style_image_from(&mut self, other: &Self) {
                            self.list_style_image = other.list_style_image.clone();
                        }
                    /// Reset list-style-image from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_list_style_image(&mut self, other: &Self) {
                        self.copy_list_style_image_from(other)
                    }

                    /// Get the computed value for list-style-image.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_list_style_image(&self) -> longhands::list_style_image::computed_value::T {
                        self.list_style_image.clone()
                    }
                        /// Set quotes.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_quotes(&mut self, v: longhands::quotes::computed_value::T) {
                            self.quotes = v;
                        }
                        /// Set quotes from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_quotes_from(&mut self, other: &Self) {
                            self.quotes = other.quotes.clone();
                        }
                    /// Reset quotes from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_quotes(&mut self, other: &Self) {
                        self.copy_quotes_from(other)
                    }

                    /// Get the computed value for quotes.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_quotes(&self) -> longhands::quotes::computed_value::T {
                        self.quotes.clone()
                    }
                        /// Set -moz-image-region.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_image_region(&mut self, v: longhands::_moz_image_region::computed_value::T) {
                            self._moz_image_region = v;
                        }
                        /// Set -moz-image-region from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_image_region_from(&mut self, other: &Self) {
                            self._moz_image_region = other._moz_image_region.clone();
                        }
                    /// Reset -moz-image-region from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_image_region(&mut self, other: &Self) {
                        self.copy__moz_image_region_from(other)
                    }

                    /// Get the computed value for -moz-image-region.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_image_region(&self) -> longhands::_moz_image_region::computed_value::T {
                        self._moz_image_region.clone()
                    }
                        /// Set -moz-list-reversed.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_list_reversed(&mut self, v: longhands::_moz_list_reversed::computed_value::T) {
                            self._moz_list_reversed = v;
                        }
                        /// Set -moz-list-reversed from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_list_reversed_from(&mut self, other: &Self) {
                            self._moz_list_reversed = other._moz_list_reversed.clone();
                        }
                    /// Reset -moz-list-reversed from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_list_reversed(&mut self, other: &Self) {
                        self.copy__moz_list_reversed_from(other)
                    }

                    /// Get the computed value for -moz-list-reversed.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_list_reversed(&self) -> longhands::_moz_list_reversed::computed_value::T {
                        self._moz_list_reversed.clone()
                    }
        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The Margin style struct.
        pub struct Margin {
                /// The margin-top computed value.
                pub margin_top: longhands::margin_top::computed_value::T,
                /// The margin-right computed value.
                pub margin_right: longhands::margin_right::computed_value::T,
                /// The margin-bottom computed value.
                pub margin_bottom: longhands::margin_bottom::computed_value::T,
                /// The margin-left computed value.
                pub margin_left: longhands::margin_left::computed_value::T,
                /// The margin-block-start computed value.
                pub margin_block_start: longhands::margin_block_start::computed_value::T,
                /// The margin-block-end computed value.
                pub margin_block_end: longhands::margin_block_end::computed_value::T,
                /// The margin-inline-start computed value.
                pub margin_inline_start: longhands::margin_inline_start::computed_value::T,
                /// The margin-inline-end computed value.
                pub margin_inline_end: longhands::margin_inline_end::computed_value::T,
                /// The scroll-margin-top computed value.
                pub scroll_margin_top: longhands::scroll_margin_top::computed_value::T,
                /// The scroll-margin-right computed value.
                pub scroll_margin_right: longhands::scroll_margin_right::computed_value::T,
                /// The scroll-margin-bottom computed value.
                pub scroll_margin_bottom: longhands::scroll_margin_bottom::computed_value::T,
                /// The scroll-margin-left computed value.
                pub scroll_margin_left: longhands::scroll_margin_left::computed_value::T,
                /// The scroll-margin-block-start computed value.
                pub scroll_margin_block_start: longhands::scroll_margin_block_start::computed_value::T,
                /// The scroll-margin-block-end computed value.
                pub scroll_margin_block_end: longhands::scroll_margin_block_end::computed_value::T,
                /// The scroll-margin-inline-start computed value.
                pub scroll_margin_inline_start: longhands::scroll_margin_inline_start::computed_value::T,
                /// The scroll-margin-inline-end computed value.
                pub scroll_margin_inline_end: longhands::scroll_margin_inline_end::computed_value::T,
        }

        impl Margin {
                        /// Set margin-top.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_margin_top(&mut self, v: longhands::margin_top::computed_value::T) {
                            self.margin_top = v;
                        }
                        /// Set margin-top from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_margin_top_from(&mut self, other: &Self) {
                            self.margin_top = other.margin_top.clone();
                        }
                    /// Reset margin-top from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_margin_top(&mut self, other: &Self) {
                        self.copy_margin_top_from(other)
                    }

                    /// Get the computed value for margin-top.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_margin_top(&self) -> longhands::margin_top::computed_value::T {
                        self.margin_top.clone()
                    }
                        /// Set margin-right.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_margin_right(&mut self, v: longhands::margin_right::computed_value::T) {
                            self.margin_right = v;
                        }
                        /// Set margin-right from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_margin_right_from(&mut self, other: &Self) {
                            self.margin_right = other.margin_right.clone();
                        }
                    /// Reset margin-right from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_margin_right(&mut self, other: &Self) {
                        self.copy_margin_right_from(other)
                    }

                    /// Get the computed value for margin-right.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_margin_right(&self) -> longhands::margin_right::computed_value::T {
                        self.margin_right.clone()
                    }
                        /// Set margin-bottom.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_margin_bottom(&mut self, v: longhands::margin_bottom::computed_value::T) {
                            self.margin_bottom = v;
                        }
                        /// Set margin-bottom from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_margin_bottom_from(&mut self, other: &Self) {
                            self.margin_bottom = other.margin_bottom.clone();
                        }
                    /// Reset margin-bottom from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_margin_bottom(&mut self, other: &Self) {
                        self.copy_margin_bottom_from(other)
                    }

                    /// Get the computed value for margin-bottom.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_margin_bottom(&self) -> longhands::margin_bottom::computed_value::T {
                        self.margin_bottom.clone()
                    }
                        /// Set margin-left.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_margin_left(&mut self, v: longhands::margin_left::computed_value::T) {
                            self.margin_left = v;
                        }
                        /// Set margin-left from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_margin_left_from(&mut self, other: &Self) {
                            self.margin_left = other.margin_left.clone();
                        }
                    /// Reset margin-left from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_margin_left(&mut self, other: &Self) {
                        self.copy_margin_left_from(other)
                    }

                    /// Get the computed value for margin-left.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_margin_left(&self) -> longhands::margin_left::computed_value::T {
                        self.margin_left.clone()
                    }
                    
    /// Set the appropriate physical property for margin-block-start given a writing mode.
    pub fn set_margin_block_start(&mut self,
                                      v: longhands::margin_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-start
    /// given a writing mode.
    pub fn copy_margin_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-start
    /// given a writing mode.
    pub fn reset_margin_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-block-start given a writing mode.
    pub fn clone_margin_block_start(&self, wm: WritingMode)
        -> longhands::margin_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for margin-block-end given a writing mode.
    pub fn set_margin_block_end(&mut self,
                                      v: longhands::margin_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-end
    /// given a writing mode.
    pub fn copy_margin_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-end
    /// given a writing mode.
    pub fn reset_margin_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-block-end given a writing mode.
    pub fn clone_margin_block_end(&self, wm: WritingMode)
        -> longhands::margin_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for margin-inline-start given a writing mode.
    pub fn set_margin_inline_start(&mut self,
                                      v: longhands::margin_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-start
    /// given a writing mode.
    pub fn copy_margin_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-start
    /// given a writing mode.
    pub fn reset_margin_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-inline-start given a writing mode.
    pub fn clone_margin_inline_start(&self, wm: WritingMode)
        -> longhands::margin_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for margin-inline-end given a writing mode.
    pub fn set_margin_inline_end(&mut self,
                                      v: longhands::margin_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-end
    /// given a writing mode.
    pub fn copy_margin_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-end
    /// given a writing mode.
    pub fn reset_margin_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-inline-end given a writing mode.
    pub fn clone_margin_inline_end(&self, wm: WritingMode)
        -> longhands::margin_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }

                        /// Set scroll-margin-top.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_scroll_margin_top(&mut self, v: longhands::scroll_margin_top::computed_value::T) {
                            self.scroll_margin_top = v;
                        }
                        /// Set scroll-margin-top from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_scroll_margin_top_from(&mut self, other: &Self) {
                            self.scroll_margin_top = other.scroll_margin_top.clone();
                        }
                    /// Reset scroll-margin-top from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_scroll_margin_top(&mut self, other: &Self) {
                        self.copy_scroll_margin_top_from(other)
                    }

                    /// Get the computed value for scroll-margin-top.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_scroll_margin_top(&self) -> longhands::scroll_margin_top::computed_value::T {
                        self.scroll_margin_top.clone()
                    }
                        /// Set scroll-margin-right.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_scroll_margin_right(&mut self, v: longhands::scroll_margin_right::computed_value::T) {
                            self.scroll_margin_right = v;
                        }
                        /// Set scroll-margin-right from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_scroll_margin_right_from(&mut self, other: &Self) {
                            self.scroll_margin_right = other.scroll_margin_right.clone();
                        }
                    /// Reset scroll-margin-right from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_scroll_margin_right(&mut self, other: &Self) {
                        self.copy_scroll_margin_right_from(other)
                    }

                    /// Get the computed value for scroll-margin-right.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_scroll_margin_right(&self) -> longhands::scroll_margin_right::computed_value::T {
                        self.scroll_margin_right.clone()
                    }
                        /// Set scroll-margin-bottom.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_scroll_margin_bottom(&mut self, v: longhands::scroll_margin_bottom::computed_value::T) {
                            self.scroll_margin_bottom = v;
                        }
                        /// Set scroll-margin-bottom from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_scroll_margin_bottom_from(&mut self, other: &Self) {
                            self.scroll_margin_bottom = other.scroll_margin_bottom.clone();
                        }
                    /// Reset scroll-margin-bottom from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_scroll_margin_bottom(&mut self, other: &Self) {
                        self.copy_scroll_margin_bottom_from(other)
                    }

                    /// Get the computed value for scroll-margin-bottom.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_scroll_margin_bottom(&self) -> longhands::scroll_margin_bottom::computed_value::T {
                        self.scroll_margin_bottom.clone()
                    }
                        /// Set scroll-margin-left.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_scroll_margin_left(&mut self, v: longhands::scroll_margin_left::computed_value::T) {
                            self.scroll_margin_left = v;
                        }
                        /// Set scroll-margin-left from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_scroll_margin_left_from(&mut self, other: &Self) {
                            self.scroll_margin_left = other.scroll_margin_left.clone();
                        }
                    /// Reset scroll-margin-left from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_scroll_margin_left(&mut self, other: &Self) {
                        self.copy_scroll_margin_left_from(other)
                    }

                    /// Get the computed value for scroll-margin-left.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_scroll_margin_left(&self) -> longhands::scroll_margin_left::computed_value::T {
                        self.scroll_margin_left.clone()
                    }
                    
    /// Set the appropriate physical property for scroll-margin-block-start given a writing mode.
    pub fn set_scroll_margin_block_start(&mut self,
                                      v: longhands::scroll_margin_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-block-start
    /// given a writing mode.
    pub fn copy_scroll_margin_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-block-start
    /// given a writing mode.
    pub fn reset_scroll_margin_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_margin_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-margin-block-start given a writing mode.
    pub fn clone_scroll_margin_block_start(&self, wm: WritingMode)
        -> longhands::scroll_margin_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_margin_left()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for scroll-margin-block-end given a writing mode.
    pub fn set_scroll_margin_block_end(&mut self,
                                      v: longhands::scroll_margin_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-block-end
    /// given a writing mode.
    pub fn copy_scroll_margin_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-block-end
    /// given a writing mode.
    pub fn reset_scroll_margin_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_margin_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-margin-block-end given a writing mode.
    pub fn clone_scroll_margin_block_end(&self, wm: WritingMode)
        -> longhands::scroll_margin_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_margin_left()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for scroll-margin-inline-start given a writing mode.
    pub fn set_scroll_margin_inline_start(&mut self,
                                      v: longhands::scroll_margin_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-inline-start
    /// given a writing mode.
    pub fn copy_scroll_margin_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-inline-start
    /// given a writing mode.
    pub fn reset_scroll_margin_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_margin_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-margin-inline-start given a writing mode.
    pub fn clone_scroll_margin_inline_start(&self, wm: WritingMode)
        -> longhands::scroll_margin_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_margin_left()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for scroll-margin-inline-end given a writing mode.
    pub fn set_scroll_margin_inline_end(&mut self,
                                      v: longhands::scroll_margin_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-inline-end
    /// given a writing mode.
    pub fn copy_scroll_margin_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-inline-end
    /// given a writing mode.
    pub fn reset_scroll_margin_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_margin_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-margin-inline-end given a writing mode.
    pub fn clone_scroll_margin_inline_end(&self, wm: WritingMode)
        -> longhands::scroll_margin_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_margin_left()
        
                }
        }

    }

        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The Outline style struct.
        pub struct Outline {
                /// The outline-color computed value.
                pub outline_color: longhands::outline_color::computed_value::T,
                /// The outline-style computed value.
                pub outline_style: longhands::outline_style::computed_value::T,
                /// The outline-width computed value.
                pub outline_width: longhands::outline_width::computed_value::T,
                /// The -moz-outline-radius-topleft computed value.
                pub _moz_outline_radius_topleft: longhands::_moz_outline_radius_topleft::computed_value::T,
                /// The -moz-outline-radius-topright computed value.
                pub _moz_outline_radius_topright: longhands::_moz_outline_radius_topright::computed_value::T,
                /// The -moz-outline-radius-bottomright computed value.
                pub _moz_outline_radius_bottomright: longhands::_moz_outline_radius_bottomright::computed_value::T,
                /// The -moz-outline-radius-bottomleft computed value.
                pub _moz_outline_radius_bottomleft: longhands::_moz_outline_radius_bottomleft::computed_value::T,
                /// The outline-offset computed value.
                pub outline_offset: longhands::outline_offset::computed_value::T,
        }

        impl Outline {
                        /// Set outline-color.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_outline_color(&mut self, v: longhands::outline_color::computed_value::T) {
                            self.outline_color = v;
                        }
                        /// Set outline-color from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_outline_color_from(&mut self, other: &Self) {
                            self.outline_color = other.outline_color.clone();
                        }
                    /// Reset outline-color from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_outline_color(&mut self, other: &Self) {
                        self.copy_outline_color_from(other)
                    }

                    /// Get the computed value for outline-color.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_outline_color(&self) -> longhands::outline_color::computed_value::T {
                        self.outline_color.clone()
                    }
                        /// Set outline-style.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_outline_style(&mut self, v: longhands::outline_style::computed_value::T) {
                            self.outline_style = v;
                        }
                        /// Set outline-style from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_outline_style_from(&mut self, other: &Self) {
                            self.outline_style = other.outline_style.clone();
                        }
                    /// Reset outline-style from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_outline_style(&mut self, other: &Self) {
                        self.copy_outline_style_from(other)
                    }

                    /// Get the computed value for outline-style.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_outline_style(&self) -> longhands::outline_style::computed_value::T {
                        self.outline_style.clone()
                    }
                        /// Set outline-width.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_outline_width(&mut self, v: longhands::outline_width::computed_value::T) {
                            self.outline_width = v;
                        }
                        /// Set outline-width from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_outline_width_from(&mut self, other: &Self) {
                            self.outline_width = other.outline_width.clone();
                        }
                    /// Reset outline-width from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_outline_width(&mut self, other: &Self) {
                        self.copy_outline_width_from(other)
                    }

                    /// Get the computed value for outline-width.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_outline_width(&self) -> longhands::outline_width::computed_value::T {
                        self.outline_width.clone()
                    }
                        /// Set -moz-outline-radius-topleft.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_outline_radius_topleft(&mut self, v: longhands::_moz_outline_radius_topleft::computed_value::T) {
                            self._moz_outline_radius_topleft = v;
                        }
                        /// Set -moz-outline-radius-topleft from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_outline_radius_topleft_from(&mut self, other: &Self) {
                            self._moz_outline_radius_topleft = other._moz_outline_radius_topleft.clone();
                        }
                    /// Reset -moz-outline-radius-topleft from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_outline_radius_topleft(&mut self, other: &Self) {
                        self.copy__moz_outline_radius_topleft_from(other)
                    }

                    /// Get the computed value for -moz-outline-radius-topleft.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_outline_radius_topleft(&self) -> longhands::_moz_outline_radius_topleft::computed_value::T {
                        self._moz_outline_radius_topleft.clone()
                    }
                        /// Set -moz-outline-radius-topright.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_outline_radius_topright(&mut self, v: longhands::_moz_outline_radius_topright::computed_value::T) {
                            self._moz_outline_radius_topright = v;
                        }
                        /// Set -moz-outline-radius-topright from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_outline_radius_topright_from(&mut self, other: &Self) {
                            self._moz_outline_radius_topright = other._moz_outline_radius_topright.clone();
                        }
                    /// Reset -moz-outline-radius-topright from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_outline_radius_topright(&mut self, other: &Self) {
                        self.copy__moz_outline_radius_topright_from(other)
                    }

                    /// Get the computed value for -moz-outline-radius-topright.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_outline_radius_topright(&self) -> longhands::_moz_outline_radius_topright::computed_value::T {
                        self._moz_outline_radius_topright.clone()
                    }
                        /// Set -moz-outline-radius-bottomright.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_outline_radius_bottomright(&mut self, v: longhands::_moz_outline_radius_bottomright::computed_value::T) {
                            self._moz_outline_radius_bottomright = v;
                        }
                        /// Set -moz-outline-radius-bottomright from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_outline_radius_bottomright_from(&mut self, other: &Self) {
                            self._moz_outline_radius_bottomright = other._moz_outline_radius_bottomright.clone();
                        }
                    /// Reset -moz-outline-radius-bottomright from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_outline_radius_bottomright(&mut self, other: &Self) {
                        self.copy__moz_outline_radius_bottomright_from(other)
                    }

                    /// Get the computed value for -moz-outline-radius-bottomright.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_outline_radius_bottomright(&self) -> longhands::_moz_outline_radius_bottomright::computed_value::T {
                        self._moz_outline_radius_bottomright.clone()
                    }
                        /// Set -moz-outline-radius-bottomleft.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_outline_radius_bottomleft(&mut self, v: longhands::_moz_outline_radius_bottomleft::computed_value::T) {
                            self._moz_outline_radius_bottomleft = v;
                        }
                        /// Set -moz-outline-radius-bottomleft from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_outline_radius_bottomleft_from(&mut self, other: &Self) {
                            self._moz_outline_radius_bottomleft = other._moz_outline_radius_bottomleft.clone();
                        }
                    /// Reset -moz-outline-radius-bottomleft from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_outline_radius_bottomleft(&mut self, other: &Self) {
                        self.copy__moz_outline_radius_bottomleft_from(other)
                    }

                    /// Get the computed value for -moz-outline-radius-bottomleft.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_outline_radius_bottomleft(&self) -> longhands::_moz_outline_radius_bottomleft::computed_value::T {
                        self._moz_outline_radius_bottomleft.clone()
                    }
                        /// Set outline-offset.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_outline_offset(&mut self, v: longhands::outline_offset::computed_value::T) {
                            self.outline_offset = v;
                        }
                        /// Set outline-offset from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_outline_offset_from(&mut self, other: &Self) {
                            self.outline_offset = other.outline_offset.clone();
                        }
                    /// Reset outline-offset from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_outline_offset(&mut self, other: &Self) {
                        self.copy_outline_offset_from(other)
                    }

                    /// Get the computed value for outline-offset.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_outline_offset(&self) -> longhands::outline_offset::computed_value::T {
                        self.outline_offset.clone()
                    }
                /// Whether the outline-width property is non-zero.
                #[inline]
                pub fn outline_has_nonzero_width(&self) -> bool {
                    use crate::Zero;
                    !self.outline_width.is_zero()
                }
        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The Padding style struct.
        pub struct Padding {
                /// The padding-top computed value.
                pub padding_top: longhands::padding_top::computed_value::T,
                /// The padding-right computed value.
                pub padding_right: longhands::padding_right::computed_value::T,
                /// The padding-bottom computed value.
                pub padding_bottom: longhands::padding_bottom::computed_value::T,
                /// The padding-left computed value.
                pub padding_left: longhands::padding_left::computed_value::T,
                /// The padding-block-start computed value.
                pub padding_block_start: longhands::padding_block_start::computed_value::T,
                /// The padding-block-end computed value.
                pub padding_block_end: longhands::padding_block_end::computed_value::T,
                /// The padding-inline-start computed value.
                pub padding_inline_start: longhands::padding_inline_start::computed_value::T,
                /// The padding-inline-end computed value.
                pub padding_inline_end: longhands::padding_inline_end::computed_value::T,
                /// The scroll-padding-top computed value.
                pub scroll_padding_top: longhands::scroll_padding_top::computed_value::T,
                /// The scroll-padding-right computed value.
                pub scroll_padding_right: longhands::scroll_padding_right::computed_value::T,
                /// The scroll-padding-bottom computed value.
                pub scroll_padding_bottom: longhands::scroll_padding_bottom::computed_value::T,
                /// The scroll-padding-left computed value.
                pub scroll_padding_left: longhands::scroll_padding_left::computed_value::T,
                /// The scroll-padding-block-start computed value.
                pub scroll_padding_block_start: longhands::scroll_padding_block_start::computed_value::T,
                /// The scroll-padding-block-end computed value.
                pub scroll_padding_block_end: longhands::scroll_padding_block_end::computed_value::T,
                /// The scroll-padding-inline-start computed value.
                pub scroll_padding_inline_start: longhands::scroll_padding_inline_start::computed_value::T,
                /// The scroll-padding-inline-end computed value.
                pub scroll_padding_inline_end: longhands::scroll_padding_inline_end::computed_value::T,
        }

        impl Padding {
                        /// Set padding-top.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_padding_top(&mut self, v: longhands::padding_top::computed_value::T) {
                            self.padding_top = v;
                        }
                        /// Set padding-top from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_padding_top_from(&mut self, other: &Self) {
                            self.padding_top = other.padding_top.clone();
                        }
                    /// Reset padding-top from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_padding_top(&mut self, other: &Self) {
                        self.copy_padding_top_from(other)
                    }

                    /// Get the computed value for padding-top.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_padding_top(&self) -> longhands::padding_top::computed_value::T {
                        self.padding_top.clone()
                    }
                        /// Set padding-right.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_padding_right(&mut self, v: longhands::padding_right::computed_value::T) {
                            self.padding_right = v;
                        }
                        /// Set padding-right from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_padding_right_from(&mut self, other: &Self) {
                            self.padding_right = other.padding_right.clone();
                        }
                    /// Reset padding-right from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_padding_right(&mut self, other: &Self) {
                        self.copy_padding_right_from(other)
                    }

                    /// Get the computed value for padding-right.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_padding_right(&self) -> longhands::padding_right::computed_value::T {
                        self.padding_right.clone()
                    }
                        /// Set padding-bottom.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_padding_bottom(&mut self, v: longhands::padding_bottom::computed_value::T) {
                            self.padding_bottom = v;
                        }
                        /// Set padding-bottom from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_padding_bottom_from(&mut self, other: &Self) {
                            self.padding_bottom = other.padding_bottom.clone();
                        }
                    /// Reset padding-bottom from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_padding_bottom(&mut self, other: &Self) {
                        self.copy_padding_bottom_from(other)
                    }

                    /// Get the computed value for padding-bottom.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_padding_bottom(&self) -> longhands::padding_bottom::computed_value::T {
                        self.padding_bottom.clone()
                    }
                        /// Set padding-left.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_padding_left(&mut self, v: longhands::padding_left::computed_value::T) {
                            self.padding_left = v;
                        }
                        /// Set padding-left from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_padding_left_from(&mut self, other: &Self) {
                            self.padding_left = other.padding_left.clone();
                        }
                    /// Reset padding-left from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_padding_left(&mut self, other: &Self) {
                        self.copy_padding_left_from(other)
                    }

                    /// Get the computed value for padding-left.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_padding_left(&self) -> longhands::padding_left::computed_value::T {
                        self.padding_left.clone()
                    }
                    
    /// Set the appropriate physical property for padding-block-start given a writing mode.
    pub fn set_padding_block_start(&mut self,
                                      v: longhands::padding_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-start
    /// given a writing mode.
    pub fn copy_padding_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-start
    /// given a writing mode.
    pub fn reset_padding_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-block-start given a writing mode.
    pub fn clone_padding_block_start(&self, wm: WritingMode)
        -> longhands::padding_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for padding-block-end given a writing mode.
    pub fn set_padding_block_end(&mut self,
                                      v: longhands::padding_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-end
    /// given a writing mode.
    pub fn copy_padding_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-end
    /// given a writing mode.
    pub fn reset_padding_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-block-end given a writing mode.
    pub fn clone_padding_block_end(&self, wm: WritingMode)
        -> longhands::padding_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for padding-inline-start given a writing mode.
    pub fn set_padding_inline_start(&mut self,
                                      v: longhands::padding_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-start
    /// given a writing mode.
    pub fn copy_padding_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-start
    /// given a writing mode.
    pub fn reset_padding_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-inline-start given a writing mode.
    pub fn clone_padding_inline_start(&self, wm: WritingMode)
        -> longhands::padding_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for padding-inline-end given a writing mode.
    pub fn set_padding_inline_end(&mut self,
                                      v: longhands::padding_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-end
    /// given a writing mode.
    pub fn copy_padding_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-end
    /// given a writing mode.
    pub fn reset_padding_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-inline-end given a writing mode.
    pub fn clone_padding_inline_end(&self, wm: WritingMode)
        -> longhands::padding_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }

                        /// Set scroll-padding-top.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_scroll_padding_top(&mut self, v: longhands::scroll_padding_top::computed_value::T) {
                            self.scroll_padding_top = v;
                        }
                        /// Set scroll-padding-top from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_scroll_padding_top_from(&mut self, other: &Self) {
                            self.scroll_padding_top = other.scroll_padding_top.clone();
                        }
                    /// Reset scroll-padding-top from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_scroll_padding_top(&mut self, other: &Self) {
                        self.copy_scroll_padding_top_from(other)
                    }

                    /// Get the computed value for scroll-padding-top.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_scroll_padding_top(&self) -> longhands::scroll_padding_top::computed_value::T {
                        self.scroll_padding_top.clone()
                    }
                        /// Set scroll-padding-right.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_scroll_padding_right(&mut self, v: longhands::scroll_padding_right::computed_value::T) {
                            self.scroll_padding_right = v;
                        }
                        /// Set scroll-padding-right from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_scroll_padding_right_from(&mut self, other: &Self) {
                            self.scroll_padding_right = other.scroll_padding_right.clone();
                        }
                    /// Reset scroll-padding-right from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_scroll_padding_right(&mut self, other: &Self) {
                        self.copy_scroll_padding_right_from(other)
                    }

                    /// Get the computed value for scroll-padding-right.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_scroll_padding_right(&self) -> longhands::scroll_padding_right::computed_value::T {
                        self.scroll_padding_right.clone()
                    }
                        /// Set scroll-padding-bottom.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_scroll_padding_bottom(&mut self, v: longhands::scroll_padding_bottom::computed_value::T) {
                            self.scroll_padding_bottom = v;
                        }
                        /// Set scroll-padding-bottom from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_scroll_padding_bottom_from(&mut self, other: &Self) {
                            self.scroll_padding_bottom = other.scroll_padding_bottom.clone();
                        }
                    /// Reset scroll-padding-bottom from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_scroll_padding_bottom(&mut self, other: &Self) {
                        self.copy_scroll_padding_bottom_from(other)
                    }

                    /// Get the computed value for scroll-padding-bottom.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_scroll_padding_bottom(&self) -> longhands::scroll_padding_bottom::computed_value::T {
                        self.scroll_padding_bottom.clone()
                    }
                        /// Set scroll-padding-left.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_scroll_padding_left(&mut self, v: longhands::scroll_padding_left::computed_value::T) {
                            self.scroll_padding_left = v;
                        }
                        /// Set scroll-padding-left from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_scroll_padding_left_from(&mut self, other: &Self) {
                            self.scroll_padding_left = other.scroll_padding_left.clone();
                        }
                    /// Reset scroll-padding-left from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_scroll_padding_left(&mut self, other: &Self) {
                        self.copy_scroll_padding_left_from(other)
                    }

                    /// Get the computed value for scroll-padding-left.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_scroll_padding_left(&self) -> longhands::scroll_padding_left::computed_value::T {
                        self.scroll_padding_left.clone()
                    }
                    
    /// Set the appropriate physical property for scroll-padding-block-start given a writing mode.
    pub fn set_scroll_padding_block_start(&mut self,
                                      v: longhands::scroll_padding_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-block-start
    /// given a writing mode.
    pub fn copy_scroll_padding_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-block-start
    /// given a writing mode.
    pub fn reset_scroll_padding_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_padding_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-padding-block-start given a writing mode.
    pub fn clone_scroll_padding_block_start(&self, wm: WritingMode)
        -> longhands::scroll_padding_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_padding_left()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for scroll-padding-block-end given a writing mode.
    pub fn set_scroll_padding_block_end(&mut self,
                                      v: longhands::scroll_padding_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-block-end
    /// given a writing mode.
    pub fn copy_scroll_padding_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-block-end
    /// given a writing mode.
    pub fn reset_scroll_padding_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_padding_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-padding-block-end given a writing mode.
    pub fn clone_scroll_padding_block_end(&self, wm: WritingMode)
        -> longhands::scroll_padding_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_padding_left()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for scroll-padding-inline-start given a writing mode.
    pub fn set_scroll_padding_inline_start(&mut self,
                                      v: longhands::scroll_padding_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-inline-start
    /// given a writing mode.
    pub fn copy_scroll_padding_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-inline-start
    /// given a writing mode.
    pub fn reset_scroll_padding_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_padding_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-padding-inline-start given a writing mode.
    pub fn clone_scroll_padding_inline_start(&self, wm: WritingMode)
        -> longhands::scroll_padding_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_padding_left()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for scroll-padding-inline-end given a writing mode.
    pub fn set_scroll_padding_inline_end(&mut self,
                                      v: longhands::scroll_padding_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-inline-end
    /// given a writing mode.
    pub fn copy_scroll_padding_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-inline-end
    /// given a writing mode.
    pub fn reset_scroll_padding_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_padding_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-padding-inline-end given a writing mode.
    pub fn clone_scroll_padding_inline_end(&self, wm: WritingMode)
        -> longhands::scroll_padding_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_padding_left()
        
                }
        }

    }

        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The Position style struct.
        pub struct Position {
                /// The top computed value.
                pub top: longhands::top::computed_value::T,
                /// The right computed value.
                pub right: longhands::right::computed_value::T,
                /// The bottom computed value.
                pub bottom: longhands::bottom::computed_value::T,
                /// The left computed value.
                pub left: longhands::left::computed_value::T,
                /// The inset-block-start computed value.
                pub inset_block_start: longhands::inset_block_start::computed_value::T,
                /// The inset-block-end computed value.
                pub inset_block_end: longhands::inset_block_end::computed_value::T,
                /// The inset-inline-start computed value.
                pub inset_inline_start: longhands::inset_inline_start::computed_value::T,
                /// The inset-inline-end computed value.
                pub inset_inline_end: longhands::inset_inline_end::computed_value::T,
                /// The z-index computed value.
                pub z_index: longhands::z_index::computed_value::T,
                /// The flex-direction computed value.
                pub flex_direction: longhands::flex_direction::computed_value::T,
                /// The flex-wrap computed value.
                pub flex_wrap: longhands::flex_wrap::computed_value::T,
                /// The justify-content computed value.
                pub justify_content: longhands::justify_content::computed_value::T,
                /// The align-content computed value.
                pub align_content: longhands::align_content::computed_value::T,
                /// The align-items computed value.
                pub align_items: longhands::align_items::computed_value::T,
                /// The justify-items computed value.
                pub justify_items: longhands::justify_items::computed_value::T,
                /// The flex-grow computed value.
                pub flex_grow: longhands::flex_grow::computed_value::T,
                /// The flex-shrink computed value.
                pub flex_shrink: longhands::flex_shrink::computed_value::T,
                /// The align-self computed value.
                pub align_self: longhands::align_self::computed_value::T,
                /// The justify-self computed value.
                pub justify_self: longhands::justify_self::computed_value::T,
                /// The order computed value.
                pub order: longhands::order::computed_value::T,
                /// The flex-basis computed value.
                pub flex_basis: longhands::flex_basis::computed_value::T,
                /// The width computed value.
                pub width: longhands::width::computed_value::T,
                /// The min-width computed value.
                pub min_width: longhands::min_width::computed_value::T,
                /// The max-width computed value.
                pub max_width: longhands::max_width::computed_value::T,
                /// The height computed value.
                pub height: longhands::height::computed_value::T,
                /// The min-height computed value.
                pub min_height: longhands::min_height::computed_value::T,
                /// The max-height computed value.
                pub max_height: longhands::max_height::computed_value::T,
                /// The block-size computed value.
                pub block_size: longhands::block_size::computed_value::T,
                /// The min-block-size computed value.
                pub min_block_size: longhands::min_block_size::computed_value::T,
                /// The max-block-size computed value.
                pub max_block_size: longhands::max_block_size::computed_value::T,
                /// The inline-size computed value.
                pub inline_size: longhands::inline_size::computed_value::T,
                /// The min-inline-size computed value.
                pub min_inline_size: longhands::min_inline_size::computed_value::T,
                /// The max-inline-size computed value.
                pub max_inline_size: longhands::max_inline_size::computed_value::T,
                /// The box-sizing computed value.
                pub box_sizing: longhands::box_sizing::computed_value::T,
                /// The object-fit computed value.
                pub object_fit: longhands::object_fit::computed_value::T,
                /// The object-position computed value.
                pub object_position: longhands::object_position::computed_value::T,
                /// The grid-row-start computed value.
                pub grid_row_start: longhands::grid_row_start::computed_value::T,
                /// The grid-row-end computed value.
                pub grid_row_end: longhands::grid_row_end::computed_value::T,
                /// The grid-auto-rows computed value.
                pub grid_auto_rows: longhands::grid_auto_rows::computed_value::T,
                /// The grid-template-rows computed value.
                pub grid_template_rows: longhands::grid_template_rows::computed_value::T,
                /// The grid-column-start computed value.
                pub grid_column_start: longhands::grid_column_start::computed_value::T,
                /// The grid-column-end computed value.
                pub grid_column_end: longhands::grid_column_end::computed_value::T,
                /// The grid-auto-columns computed value.
                pub grid_auto_columns: longhands::grid_auto_columns::computed_value::T,
                /// The grid-template-columns computed value.
                pub grid_template_columns: longhands::grid_template_columns::computed_value::T,
                /// The grid-auto-flow computed value.
                pub grid_auto_flow: longhands::grid_auto_flow::computed_value::T,
                /// The grid-template-areas computed value.
                pub grid_template_areas: longhands::grid_template_areas::computed_value::T,
                /// The column-gap computed value.
                pub column_gap: longhands::column_gap::computed_value::T,
                /// The row-gap computed value.
                pub row_gap: longhands::row_gap::computed_value::T,
        }

        impl Position {
                        /// Set top.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_top(&mut self, v: longhands::top::computed_value::T) {
                            self.top = v;
                        }
                        /// Set top from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_top_from(&mut self, other: &Self) {
                            self.top = other.top.clone();
                        }
                    /// Reset top from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_top(&mut self, other: &Self) {
                        self.copy_top_from(other)
                    }

                    /// Get the computed value for top.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_top(&self) -> longhands::top::computed_value::T {
                        self.top.clone()
                    }
                        /// Set right.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_right(&mut self, v: longhands::right::computed_value::T) {
                            self.right = v;
                        }
                        /// Set right from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_right_from(&mut self, other: &Self) {
                            self.right = other.right.clone();
                        }
                    /// Reset right from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_right(&mut self, other: &Self) {
                        self.copy_right_from(other)
                    }

                    /// Get the computed value for right.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_right(&self) -> longhands::right::computed_value::T {
                        self.right.clone()
                    }
                        /// Set bottom.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_bottom(&mut self, v: longhands::bottom::computed_value::T) {
                            self.bottom = v;
                        }
                        /// Set bottom from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_bottom_from(&mut self, other: &Self) {
                            self.bottom = other.bottom.clone();
                        }
                    /// Reset bottom from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_bottom(&mut self, other: &Self) {
                        self.copy_bottom_from(other)
                    }

                    /// Get the computed value for bottom.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_bottom(&self) -> longhands::bottom::computed_value::T {
                        self.bottom.clone()
                    }
                        /// Set left.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_left(&mut self, v: longhands::left::computed_value::T) {
                            self.left = v;
                        }
                        /// Set left from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_left_from(&mut self, other: &Self) {
                            self.left = other.left.clone();
                        }
                    /// Reset left from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_left(&mut self, other: &Self) {
                        self.copy_left_from(other)
                    }

                    /// Get the computed value for left.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_left(&self) -> longhands::left::computed_value::T {
                        self.left.clone()
                    }
                    
    /// Set the appropriate physical property for inset-block-start given a writing mode.
    pub fn set_inset_block_start(&mut self,
                                      v: longhands::inset_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-start
    /// given a writing mode.
    pub fn copy_inset_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-start
    /// given a writing mode.
    pub fn reset_inset_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-block-start given a writing mode.
    pub fn clone_inset_block_start(&self, wm: WritingMode)
        -> longhands::inset_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for inset-block-end given a writing mode.
    pub fn set_inset_block_end(&mut self,
                                      v: longhands::inset_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-end
    /// given a writing mode.
    pub fn copy_inset_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-end
    /// given a writing mode.
    pub fn reset_inset_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-block-end given a writing mode.
    pub fn clone_inset_block_end(&self, wm: WritingMode)
        -> longhands::inset_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for inset-inline-start given a writing mode.
    pub fn set_inset_inline_start(&mut self,
                                      v: longhands::inset_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-start
    /// given a writing mode.
    pub fn copy_inset_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-start
    /// given a writing mode.
    pub fn reset_inset_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-inline-start given a writing mode.
    pub fn clone_inset_inline_start(&self, wm: WritingMode)
        -> longhands::inset_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }

                    
    /// Set the appropriate physical property for inset-inline-end given a writing mode.
    pub fn set_inset_inline_end(&mut self,
                                      v: longhands::inset_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-end
    /// given a writing mode.
    pub fn copy_inset_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-end
    /// given a writing mode.
    pub fn reset_inset_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-inline-end given a writing mode.
    pub fn clone_inset_inline_end(&self, wm: WritingMode)
        -> longhands::inset_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }

                        /// Set z-index.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_z_index(&mut self, v: longhands::z_index::computed_value::T) {
                            self.z_index = v;
                        }
                        /// Set z-index from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_z_index_from(&mut self, other: &Self) {
                            self.z_index = other.z_index.clone();
                        }
                    /// Reset z-index from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_z_index(&mut self, other: &Self) {
                        self.copy_z_index_from(other)
                    }

                    /// Get the computed value for z-index.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_z_index(&self) -> longhands::z_index::computed_value::T {
                        self.z_index.clone()
                    }
                        /// Set flex-direction.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_flex_direction(&mut self, v: longhands::flex_direction::computed_value::T) {
                            self.flex_direction = v;
                        }
                        /// Set flex-direction from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_flex_direction_from(&mut self, other: &Self) {
                            self.flex_direction = other.flex_direction.clone();
                        }
                    /// Reset flex-direction from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_flex_direction(&mut self, other: &Self) {
                        self.copy_flex_direction_from(other)
                    }

                    /// Get the computed value for flex-direction.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_flex_direction(&self) -> longhands::flex_direction::computed_value::T {
                        self.flex_direction.clone()
                    }
                        /// Set flex-wrap.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_flex_wrap(&mut self, v: longhands::flex_wrap::computed_value::T) {
                            self.flex_wrap = v;
                        }
                        /// Set flex-wrap from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_flex_wrap_from(&mut self, other: &Self) {
                            self.flex_wrap = other.flex_wrap.clone();
                        }
                    /// Reset flex-wrap from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_flex_wrap(&mut self, other: &Self) {
                        self.copy_flex_wrap_from(other)
                    }

                    /// Get the computed value for flex-wrap.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_flex_wrap(&self) -> longhands::flex_wrap::computed_value::T {
                        self.flex_wrap.clone()
                    }
                        /// Set justify-content.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_justify_content(&mut self, v: longhands::justify_content::computed_value::T) {
                            self.justify_content = v;
                        }
                        /// Set justify-content from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_justify_content_from(&mut self, other: &Self) {
                            self.justify_content = other.justify_content.clone();
                        }
                    /// Reset justify-content from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_justify_content(&mut self, other: &Self) {
                        self.copy_justify_content_from(other)
                    }

                    /// Get the computed value for justify-content.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_justify_content(&self) -> longhands::justify_content::computed_value::T {
                        self.justify_content.clone()
                    }
                        /// Set align-content.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_align_content(&mut self, v: longhands::align_content::computed_value::T) {
                            self.align_content = v;
                        }
                        /// Set align-content from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_align_content_from(&mut self, other: &Self) {
                            self.align_content = other.align_content.clone();
                        }
                    /// Reset align-content from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_align_content(&mut self, other: &Self) {
                        self.copy_align_content_from(other)
                    }

                    /// Get the computed value for align-content.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_align_content(&self) -> longhands::align_content::computed_value::T {
                        self.align_content.clone()
                    }
                        /// Set align-items.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_align_items(&mut self, v: longhands::align_items::computed_value::T) {
                            self.align_items = v;
                        }
                        /// Set align-items from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_align_items_from(&mut self, other: &Self) {
                            self.align_items = other.align_items.clone();
                        }
                    /// Reset align-items from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_align_items(&mut self, other: &Self) {
                        self.copy_align_items_from(other)
                    }

                    /// Get the computed value for align-items.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_align_items(&self) -> longhands::align_items::computed_value::T {
                        self.align_items.clone()
                    }
                        /// Set justify-items.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_justify_items(&mut self, v: longhands::justify_items::computed_value::T) {
                            self.justify_items = v;
                        }
                        /// Set justify-items from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_justify_items_from(&mut self, other: &Self) {
                            self.justify_items = other.justify_items.clone();
                        }
                    /// Reset justify-items from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_justify_items(&mut self, other: &Self) {
                        self.copy_justify_items_from(other)
                    }

                    /// Get the computed value for justify-items.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_justify_items(&self) -> longhands::justify_items::computed_value::T {
                        self.justify_items.clone()
                    }
                        /// Set flex-grow.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_flex_grow(&mut self, v: longhands::flex_grow::computed_value::T) {
                            self.flex_grow = v;
                        }
                        /// Set flex-grow from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_flex_grow_from(&mut self, other: &Self) {
                            self.flex_grow = other.flex_grow.clone();
                        }
                    /// Reset flex-grow from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_flex_grow(&mut self, other: &Self) {
                        self.copy_flex_grow_from(other)
                    }

                    /// Get the computed value for flex-grow.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_flex_grow(&self) -> longhands::flex_grow::computed_value::T {
                        self.flex_grow.clone()
                    }
                        /// Set flex-shrink.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_flex_shrink(&mut self, v: longhands::flex_shrink::computed_value::T) {
                            self.flex_shrink = v;
                        }
                        /// Set flex-shrink from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_flex_shrink_from(&mut self, other: &Self) {
                            self.flex_shrink = other.flex_shrink.clone();
                        }
                    /// Reset flex-shrink from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_flex_shrink(&mut self, other: &Self) {
                        self.copy_flex_shrink_from(other)
                    }

                    /// Get the computed value for flex-shrink.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_flex_shrink(&self) -> longhands::flex_shrink::computed_value::T {
                        self.flex_shrink.clone()
                    }
                        /// Set align-self.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_align_self(&mut self, v: longhands::align_self::computed_value::T) {
                            self.align_self = v;
                        }
                        /// Set align-self from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_align_self_from(&mut self, other: &Self) {
                            self.align_self = other.align_self.clone();
                        }
                    /// Reset align-self from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_align_self(&mut self, other: &Self) {
                        self.copy_align_self_from(other)
                    }

                    /// Get the computed value for align-self.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_align_self(&self) -> longhands::align_self::computed_value::T {
                        self.align_self.clone()
                    }
                        /// Set justify-self.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_justify_self(&mut self, v: longhands::justify_self::computed_value::T) {
                            self.justify_self = v;
                        }
                        /// Set justify-self from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_justify_self_from(&mut self, other: &Self) {
                            self.justify_self = other.justify_self.clone();
                        }
                    /// Reset justify-self from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_justify_self(&mut self, other: &Self) {
                        self.copy_justify_self_from(other)
                    }

                    /// Get the computed value for justify-self.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_justify_self(&self) -> longhands::justify_self::computed_value::T {
                        self.justify_self.clone()
                    }
                        /// Set order.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_order(&mut self, v: longhands::order::computed_value::T) {
                            self.order = v;
                        }
                        /// Set order from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_order_from(&mut self, other: &Self) {
                            self.order = other.order.clone();
                        }
                    /// Reset order from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_order(&mut self, other: &Self) {
                        self.copy_order_from(other)
                    }

                    /// Get the computed value for order.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_order(&self) -> longhands::order::computed_value::T {
                        self.order.clone()
                    }
                        /// Set flex-basis.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_flex_basis(&mut self, v: longhands::flex_basis::computed_value::T) {
                            self.flex_basis = v;
                        }
                        /// Set flex-basis from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_flex_basis_from(&mut self, other: &Self) {
                            self.flex_basis = other.flex_basis.clone();
                        }
                    /// Reset flex-basis from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_flex_basis(&mut self, other: &Self) {
                        self.copy_flex_basis_from(other)
                    }

                    /// Get the computed value for flex-basis.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_flex_basis(&self) -> longhands::flex_basis::computed_value::T {
                        self.flex_basis.clone()
                    }
                        /// Set width.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_width(&mut self, v: longhands::width::computed_value::T) {
                            self.width = v;
                        }
                        /// Set width from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_width_from(&mut self, other: &Self) {
                            self.width = other.width.clone();
                        }
                    /// Reset width from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_width(&mut self, other: &Self) {
                        self.copy_width_from(other)
                    }

                    /// Get the computed value for width.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_width(&self) -> longhands::width::computed_value::T {
                        self.width.clone()
                    }
                        /// Set min-width.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_min_width(&mut self, v: longhands::min_width::computed_value::T) {
                            self.min_width = v;
                        }
                        /// Set min-width from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_min_width_from(&mut self, other: &Self) {
                            self.min_width = other.min_width.clone();
                        }
                    /// Reset min-width from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_min_width(&mut self, other: &Self) {
                        self.copy_min_width_from(other)
                    }

                    /// Get the computed value for min-width.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_min_width(&self) -> longhands::min_width::computed_value::T {
                        self.min_width.clone()
                    }
                        /// Set max-width.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_max_width(&mut self, v: longhands::max_width::computed_value::T) {
                            self.max_width = v;
                        }
                        /// Set max-width from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_max_width_from(&mut self, other: &Self) {
                            self.max_width = other.max_width.clone();
                        }
                    /// Reset max-width from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_max_width(&mut self, other: &Self) {
                        self.copy_max_width_from(other)
                    }

                    /// Get the computed value for max-width.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_max_width(&self) -> longhands::max_width::computed_value::T {
                        self.max_width.clone()
                    }
                        /// Set height.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_height(&mut self, v: longhands::height::computed_value::T) {
                            self.height = v;
                        }
                        /// Set height from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_height_from(&mut self, other: &Self) {
                            self.height = other.height.clone();
                        }
                    /// Reset height from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_height(&mut self, other: &Self) {
                        self.copy_height_from(other)
                    }

                    /// Get the computed value for height.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_height(&self) -> longhands::height::computed_value::T {
                        self.height.clone()
                    }
                        /// Set min-height.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_min_height(&mut self, v: longhands::min_height::computed_value::T) {
                            self.min_height = v;
                        }
                        /// Set min-height from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_min_height_from(&mut self, other: &Self) {
                            self.min_height = other.min_height.clone();
                        }
                    /// Reset min-height from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_min_height(&mut self, other: &Self) {
                        self.copy_min_height_from(other)
                    }

                    /// Get the computed value for min-height.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_min_height(&self) -> longhands::min_height::computed_value::T {
                        self.min_height.clone()
                    }
                        /// Set max-height.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_max_height(&mut self, v: longhands::max_height::computed_value::T) {
                            self.max_height = v;
                        }
                        /// Set max-height from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_max_height_from(&mut self, other: &Self) {
                            self.max_height = other.max_height.clone();
                        }
                    /// Reset max-height from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_max_height(&mut self, other: &Self) {
                        self.copy_max_height_from(other)
                    }

                    /// Get the computed value for max-height.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_max_height(&self) -> longhands::max_height::computed_value::T {
                        self.max_height.clone()
                    }
                    
    /// Set the appropriate physical property for block-size given a writing mode.
    pub fn set_block_size(&mut self,
                                      v: longhands::block_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_width(v)
            
        } else {
            
                self.set_height(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for block-size
    /// given a writing mode.
    pub fn copy_block_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_width_from(other)
            
        } else {
            
                self.copy_height_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for block-size
    /// given a writing mode.
    pub fn reset_block_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_block_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// block-size given a writing mode.
    pub fn clone_block_size(&self, wm: WritingMode)
        -> longhands::block_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_width()
        
        } else {
            
            self.clone_height()
        
        }

    }

                    
    /// Set the appropriate physical property for min-block-size given a writing mode.
    pub fn set_min_block_size(&mut self,
                                      v: longhands::min_block_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_min_width(v)
            
        } else {
            
                self.set_min_height(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-block-size
    /// given a writing mode.
    pub fn copy_min_block_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_min_width_from(other)
            
        } else {
            
                self.copy_min_height_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-block-size
    /// given a writing mode.
    pub fn reset_min_block_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_min_block_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// min-block-size given a writing mode.
    pub fn clone_min_block_size(&self, wm: WritingMode)
        -> longhands::min_block_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_min_width()
        
        } else {
            
            self.clone_min_height()
        
        }

    }

                    
    /// Set the appropriate physical property for max-block-size given a writing mode.
    pub fn set_max_block_size(&mut self,
                                      v: longhands::max_block_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_max_width(v)
            
        } else {
            
                self.set_max_height(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-block-size
    /// given a writing mode.
    pub fn copy_max_block_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_max_width_from(other)
            
        } else {
            
                self.copy_max_height_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-block-size
    /// given a writing mode.
    pub fn reset_max_block_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_max_block_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// max-block-size given a writing mode.
    pub fn clone_max_block_size(&self, wm: WritingMode)
        -> longhands::max_block_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_max_width()
        
        } else {
            
            self.clone_max_height()
        
        }

    }

                    
    /// Set the appropriate physical property for inline-size given a writing mode.
    pub fn set_inline_size(&mut self,
                                      v: longhands::inline_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_height(v)
            
        } else {
            
                self.set_width(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for inline-size
    /// given a writing mode.
    pub fn copy_inline_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_height_from(other)
            
        } else {
            
                self.copy_width_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for inline-size
    /// given a writing mode.
    pub fn reset_inline_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inline_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inline-size given a writing mode.
    pub fn clone_inline_size(&self, wm: WritingMode)
        -> longhands::inline_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_height()
        
        } else {
            
            self.clone_width()
        
        }

    }

                    
    /// Set the appropriate physical property for min-inline-size given a writing mode.
    pub fn set_min_inline_size(&mut self,
                                      v: longhands::min_inline_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_min_height(v)
            
        } else {
            
                self.set_min_width(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-inline-size
    /// given a writing mode.
    pub fn copy_min_inline_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_min_height_from(other)
            
        } else {
            
                self.copy_min_width_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-inline-size
    /// given a writing mode.
    pub fn reset_min_inline_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_min_inline_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// min-inline-size given a writing mode.
    pub fn clone_min_inline_size(&self, wm: WritingMode)
        -> longhands::min_inline_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_min_height()
        
        } else {
            
            self.clone_min_width()
        
        }

    }

                    
    /// Set the appropriate physical property for max-inline-size given a writing mode.
    pub fn set_max_inline_size(&mut self,
                                      v: longhands::max_inline_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_max_height(v)
            
        } else {
            
                self.set_max_width(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-inline-size
    /// given a writing mode.
    pub fn copy_max_inline_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_max_height_from(other)
            
        } else {
            
                self.copy_max_width_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-inline-size
    /// given a writing mode.
    pub fn reset_max_inline_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_max_inline_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// max-inline-size given a writing mode.
    pub fn clone_max_inline_size(&self, wm: WritingMode)
        -> longhands::max_inline_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_max_height()
        
        } else {
            
            self.clone_max_width()
        
        }

    }

                        /// Set box-sizing.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_box_sizing(&mut self, v: longhands::box_sizing::computed_value::T) {
                            self.box_sizing = v;
                        }
                        /// Set box-sizing from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_box_sizing_from(&mut self, other: &Self) {
                            self.box_sizing = other.box_sizing.clone();
                        }
                    /// Reset box-sizing from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_box_sizing(&mut self, other: &Self) {
                        self.copy_box_sizing_from(other)
                    }

                    /// Get the computed value for box-sizing.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_box_sizing(&self) -> longhands::box_sizing::computed_value::T {
                        self.box_sizing.clone()
                    }
                        /// Set object-fit.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_object_fit(&mut self, v: longhands::object_fit::computed_value::T) {
                            self.object_fit = v;
                        }
                        /// Set object-fit from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_object_fit_from(&mut self, other: &Self) {
                            self.object_fit = other.object_fit.clone();
                        }
                    /// Reset object-fit from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_object_fit(&mut self, other: &Self) {
                        self.copy_object_fit_from(other)
                    }

                    /// Get the computed value for object-fit.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_object_fit(&self) -> longhands::object_fit::computed_value::T {
                        self.object_fit.clone()
                    }
                        /// Set object-position.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_object_position(&mut self, v: longhands::object_position::computed_value::T) {
                            self.object_position = v;
                        }
                        /// Set object-position from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_object_position_from(&mut self, other: &Self) {
                            self.object_position = other.object_position.clone();
                        }
                    /// Reset object-position from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_object_position(&mut self, other: &Self) {
                        self.copy_object_position_from(other)
                    }

                    /// Get the computed value for object-position.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_object_position(&self) -> longhands::object_position::computed_value::T {
                        self.object_position.clone()
                    }
                        /// Set grid-row-start.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_grid_row_start(&mut self, v: longhands::grid_row_start::computed_value::T) {
                            self.grid_row_start = v;
                        }
                        /// Set grid-row-start from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_grid_row_start_from(&mut self, other: &Self) {
                            self.grid_row_start = other.grid_row_start.clone();
                        }
                    /// Reset grid-row-start from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_grid_row_start(&mut self, other: &Self) {
                        self.copy_grid_row_start_from(other)
                    }

                    /// Get the computed value for grid-row-start.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_grid_row_start(&self) -> longhands::grid_row_start::computed_value::T {
                        self.grid_row_start.clone()
                    }
                        /// Set grid-row-end.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_grid_row_end(&mut self, v: longhands::grid_row_end::computed_value::T) {
                            self.grid_row_end = v;
                        }
                        /// Set grid-row-end from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_grid_row_end_from(&mut self, other: &Self) {
                            self.grid_row_end = other.grid_row_end.clone();
                        }
                    /// Reset grid-row-end from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_grid_row_end(&mut self, other: &Self) {
                        self.copy_grid_row_end_from(other)
                    }

                    /// Get the computed value for grid-row-end.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_grid_row_end(&self) -> longhands::grid_row_end::computed_value::T {
                        self.grid_row_end.clone()
                    }
                        /// Set grid-auto-rows.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_grid_auto_rows(&mut self, v: longhands::grid_auto_rows::computed_value::T) {
                            self.grid_auto_rows = v;
                        }
                        /// Set grid-auto-rows from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_grid_auto_rows_from(&mut self, other: &Self) {
                            self.grid_auto_rows = other.grid_auto_rows.clone();
                        }
                    /// Reset grid-auto-rows from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_grid_auto_rows(&mut self, other: &Self) {
                        self.copy_grid_auto_rows_from(other)
                    }

                    /// Get the computed value for grid-auto-rows.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_grid_auto_rows(&self) -> longhands::grid_auto_rows::computed_value::T {
                        self.grid_auto_rows.clone()
                    }
                        /// Set grid-template-rows.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_grid_template_rows(&mut self, v: longhands::grid_template_rows::computed_value::T) {
                            self.grid_template_rows = v;
                        }
                        /// Set grid-template-rows from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_grid_template_rows_from(&mut self, other: &Self) {
                            self.grid_template_rows = other.grid_template_rows.clone();
                        }
                    /// Reset grid-template-rows from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_grid_template_rows(&mut self, other: &Self) {
                        self.copy_grid_template_rows_from(other)
                    }

                    /// Get the computed value for grid-template-rows.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_grid_template_rows(&self) -> longhands::grid_template_rows::computed_value::T {
                        self.grid_template_rows.clone()
                    }
                        /// Set grid-column-start.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_grid_column_start(&mut self, v: longhands::grid_column_start::computed_value::T) {
                            self.grid_column_start = v;
                        }
                        /// Set grid-column-start from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_grid_column_start_from(&mut self, other: &Self) {
                            self.grid_column_start = other.grid_column_start.clone();
                        }
                    /// Reset grid-column-start from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_grid_column_start(&mut self, other: &Self) {
                        self.copy_grid_column_start_from(other)
                    }

                    /// Get the computed value for grid-column-start.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_grid_column_start(&self) -> longhands::grid_column_start::computed_value::T {
                        self.grid_column_start.clone()
                    }
                        /// Set grid-column-end.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_grid_column_end(&mut self, v: longhands::grid_column_end::computed_value::T) {
                            self.grid_column_end = v;
                        }
                        /// Set grid-column-end from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_grid_column_end_from(&mut self, other: &Self) {
                            self.grid_column_end = other.grid_column_end.clone();
                        }
                    /// Reset grid-column-end from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_grid_column_end(&mut self, other: &Self) {
                        self.copy_grid_column_end_from(other)
                    }

                    /// Get the computed value for grid-column-end.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_grid_column_end(&self) -> longhands::grid_column_end::computed_value::T {
                        self.grid_column_end.clone()
                    }
                        /// Set grid-auto-columns.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_grid_auto_columns(&mut self, v: longhands::grid_auto_columns::computed_value::T) {
                            self.grid_auto_columns = v;
                        }
                        /// Set grid-auto-columns from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_grid_auto_columns_from(&mut self, other: &Self) {
                            self.grid_auto_columns = other.grid_auto_columns.clone();
                        }
                    /// Reset grid-auto-columns from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_grid_auto_columns(&mut self, other: &Self) {
                        self.copy_grid_auto_columns_from(other)
                    }

                    /// Get the computed value for grid-auto-columns.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_grid_auto_columns(&self) -> longhands::grid_auto_columns::computed_value::T {
                        self.grid_auto_columns.clone()
                    }
                        /// Set grid-template-columns.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_grid_template_columns(&mut self, v: longhands::grid_template_columns::computed_value::T) {
                            self.grid_template_columns = v;
                        }
                        /// Set grid-template-columns from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_grid_template_columns_from(&mut self, other: &Self) {
                            self.grid_template_columns = other.grid_template_columns.clone();
                        }
                    /// Reset grid-template-columns from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_grid_template_columns(&mut self, other: &Self) {
                        self.copy_grid_template_columns_from(other)
                    }

                    /// Get the computed value for grid-template-columns.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_grid_template_columns(&self) -> longhands::grid_template_columns::computed_value::T {
                        self.grid_template_columns.clone()
                    }
                        /// Set grid-auto-flow.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_grid_auto_flow(&mut self, v: longhands::grid_auto_flow::computed_value::T) {
                            self.grid_auto_flow = v;
                        }
                        /// Set grid-auto-flow from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_grid_auto_flow_from(&mut self, other: &Self) {
                            self.grid_auto_flow = other.grid_auto_flow.clone();
                        }
                    /// Reset grid-auto-flow from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_grid_auto_flow(&mut self, other: &Self) {
                        self.copy_grid_auto_flow_from(other)
                    }

                    /// Get the computed value for grid-auto-flow.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_grid_auto_flow(&self) -> longhands::grid_auto_flow::computed_value::T {
                        self.grid_auto_flow.clone()
                    }
                        /// Set grid-template-areas.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_grid_template_areas(&mut self, v: longhands::grid_template_areas::computed_value::T) {
                            self.grid_template_areas = v;
                        }
                        /// Set grid-template-areas from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_grid_template_areas_from(&mut self, other: &Self) {
                            self.grid_template_areas = other.grid_template_areas.clone();
                        }
                    /// Reset grid-template-areas from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_grid_template_areas(&mut self, other: &Self) {
                        self.copy_grid_template_areas_from(other)
                    }

                    /// Get the computed value for grid-template-areas.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_grid_template_areas(&self) -> longhands::grid_template_areas::computed_value::T {
                        self.grid_template_areas.clone()
                    }
                        /// Set column-gap.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_column_gap(&mut self, v: longhands::column_gap::computed_value::T) {
                            self.column_gap = v;
                        }
                        /// Set column-gap from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_column_gap_from(&mut self, other: &Self) {
                            self.column_gap = other.column_gap.clone();
                        }
                    /// Reset column-gap from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_column_gap(&mut self, other: &Self) {
                        self.copy_column_gap_from(other)
                    }

                    /// Get the computed value for column-gap.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_column_gap(&self) -> longhands::column_gap::computed_value::T {
                        self.column_gap.clone()
                    }
                        /// Set row-gap.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_row_gap(&mut self, v: longhands::row_gap::computed_value::T) {
                            self.row_gap = v;
                        }
                        /// Set row-gap from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_row_gap_from(&mut self, other: &Self) {
                            self.row_gap = other.row_gap.clone();
                        }
                    /// Reset row-gap from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_row_gap(&mut self, other: &Self) {
                        self.copy_row_gap_from(other)
                    }

                    /// Get the computed value for row-gap.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_row_gap(&self) -> longhands::row_gap::computed_value::T {
                        self.row_gap.clone()
                    }
        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The Table style struct.
        pub struct Table {
                /// The table-layout computed value.
                pub table_layout: longhands::table_layout::computed_value::T,
                /// The -x-span computed value.
                pub _x_span: longhands::_x_span::computed_value::T,
        }

        impl Table {
                        /// Set table-layout.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_table_layout(&mut self, v: longhands::table_layout::computed_value::T) {
                            self.table_layout = v;
                        }
                        /// Set table-layout from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_table_layout_from(&mut self, other: &Self) {
                            self.table_layout = other.table_layout.clone();
                        }
                    /// Reset table-layout from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_table_layout(&mut self, other: &Self) {
                        self.copy_table_layout_from(other)
                    }

                    /// Get the computed value for table-layout.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_table_layout(&self) -> longhands::table_layout::computed_value::T {
                        self.table_layout.clone()
                    }
                        /// Set -x-span.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__x_span(&mut self, v: longhands::_x_span::computed_value::T) {
                            self._x_span = v;
                        }
                        /// Set -x-span from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__x_span_from(&mut self, other: &Self) {
                            self._x_span = other._x_span.clone();
                        }
                    /// Reset -x-span from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__x_span(&mut self, other: &Self) {
                        self.copy__x_span_from(other)
                    }

                    /// Get the computed value for -x-span.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__x_span(&self) -> longhands::_x_span::computed_value::T {
                        self._x_span.clone()
                    }
        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The Text style struct.
        pub struct Text {
                /// The text-overflow computed value.
                pub text_overflow: longhands::text_overflow::computed_value::T,
                /// The unicode-bidi computed value.
                pub unicode_bidi: longhands::unicode_bidi::computed_value::T,
                /// The text-decoration-line computed value.
                pub text_decoration_line: longhands::text_decoration_line::computed_value::T,
                /// The text-decoration-style computed value.
                pub text_decoration_style: longhands::text_decoration_style::computed_value::T,
                /// The text-decoration-color computed value.
                pub text_decoration_color: longhands::text_decoration_color::computed_value::T,
                /// The initial-letter computed value.
                pub initial_letter: longhands::initial_letter::computed_value::T,
        }

        impl Text {
                        /// Set text-overflow.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_text_overflow(&mut self, v: longhands::text_overflow::computed_value::T) {
                            self.text_overflow = v;
                        }
                        /// Set text-overflow from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_text_overflow_from(&mut self, other: &Self) {
                            self.text_overflow = other.text_overflow.clone();
                        }
                    /// Reset text-overflow from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_text_overflow(&mut self, other: &Self) {
                        self.copy_text_overflow_from(other)
                    }

                    /// Get the computed value for text-overflow.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_text_overflow(&self) -> longhands::text_overflow::computed_value::T {
                        self.text_overflow.clone()
                    }
                        /// Set unicode-bidi.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_unicode_bidi(&mut self, v: longhands::unicode_bidi::computed_value::T) {
                            self.unicode_bidi = v;
                        }
                        /// Set unicode-bidi from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_unicode_bidi_from(&mut self, other: &Self) {
                            self.unicode_bidi = other.unicode_bidi.clone();
                        }
                    /// Reset unicode-bidi from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_unicode_bidi(&mut self, other: &Self) {
                        self.copy_unicode_bidi_from(other)
                    }

                    /// Get the computed value for unicode-bidi.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_unicode_bidi(&self) -> longhands::unicode_bidi::computed_value::T {
                        self.unicode_bidi.clone()
                    }
                        /// Set text-decoration-line.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_text_decoration_line(&mut self, v: longhands::text_decoration_line::computed_value::T) {
                            self.text_decoration_line = v;
                        }
                        /// Set text-decoration-line from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_text_decoration_line_from(&mut self, other: &Self) {
                            self.text_decoration_line = other.text_decoration_line.clone();
                        }
                    /// Reset text-decoration-line from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_text_decoration_line(&mut self, other: &Self) {
                        self.copy_text_decoration_line_from(other)
                    }

                    /// Get the computed value for text-decoration-line.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_text_decoration_line(&self) -> longhands::text_decoration_line::computed_value::T {
                        self.text_decoration_line.clone()
                    }
                        /// Set text-decoration-style.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_text_decoration_style(&mut self, v: longhands::text_decoration_style::computed_value::T) {
                            self.text_decoration_style = v;
                        }
                        /// Set text-decoration-style from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_text_decoration_style_from(&mut self, other: &Self) {
                            self.text_decoration_style = other.text_decoration_style.clone();
                        }
                    /// Reset text-decoration-style from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_text_decoration_style(&mut self, other: &Self) {
                        self.copy_text_decoration_style_from(other)
                    }

                    /// Get the computed value for text-decoration-style.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_text_decoration_style(&self) -> longhands::text_decoration_style::computed_value::T {
                        self.text_decoration_style.clone()
                    }
                        /// Set text-decoration-color.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_text_decoration_color(&mut self, v: longhands::text_decoration_color::computed_value::T) {
                            self.text_decoration_color = v;
                        }
                        /// Set text-decoration-color from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_text_decoration_color_from(&mut self, other: &Self) {
                            self.text_decoration_color = other.text_decoration_color.clone();
                        }
                    /// Reset text-decoration-color from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_text_decoration_color(&mut self, other: &Self) {
                        self.copy_text_decoration_color_from(other)
                    }

                    /// Get the computed value for text-decoration-color.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_text_decoration_color(&self) -> longhands::text_decoration_color::computed_value::T {
                        self.text_decoration_color.clone()
                    }
                        /// Set initial-letter.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_initial_letter(&mut self, v: longhands::initial_letter::computed_value::T) {
                            self.initial_letter = v;
                        }
                        /// Set initial-letter from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_initial_letter_from(&mut self, other: &Self) {
                            self.initial_letter = other.initial_letter.clone();
                        }
                    /// Reset initial-letter from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_initial_letter(&mut self, other: &Self) {
                        self.copy_initial_letter_from(other)
                    }

                    /// Get the computed value for initial-letter.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_initial_letter(&self) -> longhands::initial_letter::computed_value::T {
                        self.initial_letter.clone()
                    }
        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The UI style struct.
        pub struct UI {
                /// The ime-mode computed value.
                pub ime_mode: longhands::ime_mode::computed_value::T,
                /// The scrollbar-width computed value.
                pub scrollbar_width: longhands::scrollbar_width::computed_value::T,
                /// The -moz-user-select computed value.
                pub _moz_user_select: longhands::_moz_user_select::computed_value::T,
                /// The -moz-window-dragging computed value.
                pub _moz_window_dragging: longhands::_moz_window_dragging::computed_value::T,
                /// The -moz-window-shadow computed value.
                pub _moz_window_shadow: longhands::_moz_window_shadow::computed_value::T,
                /// The -moz-window-opacity computed value.
                pub _moz_window_opacity: longhands::_moz_window_opacity::computed_value::T,
                /// The -moz-window-transform computed value.
                pub _moz_window_transform: longhands::_moz_window_transform::computed_value::T,
                /// The -moz-window-transform-origin computed value.
                pub _moz_window_transform_origin: longhands::_moz_window_transform_origin::computed_value::T,
                /// The -moz-force-broken-image-icon computed value.
                pub _moz_force_broken_image_icon: longhands::_moz_force_broken_image_icon::computed_value::T,
        }

        impl UI {
                        /// Set ime-mode.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_ime_mode(&mut self, v: longhands::ime_mode::computed_value::T) {
                            self.ime_mode = v;
                        }
                        /// Set ime-mode from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_ime_mode_from(&mut self, other: &Self) {
                            self.ime_mode = other.ime_mode.clone();
                        }
                    /// Reset ime-mode from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_ime_mode(&mut self, other: &Self) {
                        self.copy_ime_mode_from(other)
                    }

                    /// Get the computed value for ime-mode.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_ime_mode(&self) -> longhands::ime_mode::computed_value::T {
                        self.ime_mode.clone()
                    }
                        /// Set scrollbar-width.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_scrollbar_width(&mut self, v: longhands::scrollbar_width::computed_value::T) {
                            self.scrollbar_width = v;
                        }
                        /// Set scrollbar-width from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_scrollbar_width_from(&mut self, other: &Self) {
                            self.scrollbar_width = other.scrollbar_width.clone();
                        }
                    /// Reset scrollbar-width from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_scrollbar_width(&mut self, other: &Self) {
                        self.copy_scrollbar_width_from(other)
                    }

                    /// Get the computed value for scrollbar-width.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_scrollbar_width(&self) -> longhands::scrollbar_width::computed_value::T {
                        self.scrollbar_width.clone()
                    }
                        /// Set -moz-user-select.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_user_select(&mut self, v: longhands::_moz_user_select::computed_value::T) {
                            self._moz_user_select = v;
                        }
                        /// Set -moz-user-select from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_user_select_from(&mut self, other: &Self) {
                            self._moz_user_select = other._moz_user_select.clone();
                        }
                    /// Reset -moz-user-select from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_user_select(&mut self, other: &Self) {
                        self.copy__moz_user_select_from(other)
                    }

                    /// Get the computed value for -moz-user-select.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_user_select(&self) -> longhands::_moz_user_select::computed_value::T {
                        self._moz_user_select.clone()
                    }
                        /// Set -moz-window-dragging.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_window_dragging(&mut self, v: longhands::_moz_window_dragging::computed_value::T) {
                            self._moz_window_dragging = v;
                        }
                        /// Set -moz-window-dragging from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_window_dragging_from(&mut self, other: &Self) {
                            self._moz_window_dragging = other._moz_window_dragging.clone();
                        }
                    /// Reset -moz-window-dragging from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_window_dragging(&mut self, other: &Self) {
                        self.copy__moz_window_dragging_from(other)
                    }

                    /// Get the computed value for -moz-window-dragging.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_window_dragging(&self) -> longhands::_moz_window_dragging::computed_value::T {
                        self._moz_window_dragging.clone()
                    }
                        /// Set -moz-window-shadow.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_window_shadow(&mut self, v: longhands::_moz_window_shadow::computed_value::T) {
                            self._moz_window_shadow = v;
                        }
                        /// Set -moz-window-shadow from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_window_shadow_from(&mut self, other: &Self) {
                            self._moz_window_shadow = other._moz_window_shadow.clone();
                        }
                    /// Reset -moz-window-shadow from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_window_shadow(&mut self, other: &Self) {
                        self.copy__moz_window_shadow_from(other)
                    }

                    /// Get the computed value for -moz-window-shadow.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_window_shadow(&self) -> longhands::_moz_window_shadow::computed_value::T {
                        self._moz_window_shadow.clone()
                    }
                        /// Set -moz-window-opacity.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_window_opacity(&mut self, v: longhands::_moz_window_opacity::computed_value::T) {
                            self._moz_window_opacity = v;
                        }
                        /// Set -moz-window-opacity from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_window_opacity_from(&mut self, other: &Self) {
                            self._moz_window_opacity = other._moz_window_opacity.clone();
                        }
                    /// Reset -moz-window-opacity from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_window_opacity(&mut self, other: &Self) {
                        self.copy__moz_window_opacity_from(other)
                    }

                    /// Get the computed value for -moz-window-opacity.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_window_opacity(&self) -> longhands::_moz_window_opacity::computed_value::T {
                        self._moz_window_opacity.clone()
                    }
                        /// Set -moz-window-transform.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_window_transform(&mut self, v: longhands::_moz_window_transform::computed_value::T) {
                            self._moz_window_transform = v;
                        }
                        /// Set -moz-window-transform from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_window_transform_from(&mut self, other: &Self) {
                            self._moz_window_transform = other._moz_window_transform.clone();
                        }
                    /// Reset -moz-window-transform from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_window_transform(&mut self, other: &Self) {
                        self.copy__moz_window_transform_from(other)
                    }

                    /// Get the computed value for -moz-window-transform.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_window_transform(&self) -> longhands::_moz_window_transform::computed_value::T {
                        self._moz_window_transform.clone()
                    }
                        /// Set -moz-window-transform-origin.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_window_transform_origin(&mut self, v: longhands::_moz_window_transform_origin::computed_value::T) {
                            self._moz_window_transform_origin = v;
                        }
                        /// Set -moz-window-transform-origin from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_window_transform_origin_from(&mut self, other: &Self) {
                            self._moz_window_transform_origin = other._moz_window_transform_origin.clone();
                        }
                    /// Reset -moz-window-transform-origin from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_window_transform_origin(&mut self, other: &Self) {
                        self.copy__moz_window_transform_origin_from(other)
                    }

                    /// Get the computed value for -moz-window-transform-origin.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_window_transform_origin(&self) -> longhands::_moz_window_transform_origin::computed_value::T {
                        self._moz_window_transform_origin.clone()
                    }
                        /// Set -moz-force-broken-image-icon.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_force_broken_image_icon(&mut self, v: longhands::_moz_force_broken_image_icon::computed_value::T) {
                            self._moz_force_broken_image_icon = v;
                        }
                        /// Set -moz-force-broken-image-icon from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_force_broken_image_icon_from(&mut self, other: &Self) {
                            self._moz_force_broken_image_icon = other._moz_force_broken_image_icon.clone();
                        }
                    /// Reset -moz-force-broken-image-icon from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_force_broken_image_icon(&mut self, other: &Self) {
                        self.copy__moz_force_broken_image_icon_from(other)
                    }

                    /// Get the computed value for -moz-force-broken-image-icon.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_force_broken_image_icon(&self) -> longhands::_moz_force_broken_image_icon::computed_value::T {
                        self._moz_force_broken_image_icon.clone()
                    }
        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The SVG style struct.
        pub struct SVG {
                /// The dominant-baseline computed value.
                pub dominant_baseline: longhands::dominant_baseline::computed_value::T,
                /// The vector-effect computed value.
                pub vector_effect: longhands::vector_effect::computed_value::T,
                /// The stop-color computed value.
                pub stop_color: longhands::stop_color::computed_value::T,
                /// The stop-opacity computed value.
                pub stop_opacity: longhands::stop_opacity::computed_value::T,
                /// The flood-color computed value.
                pub flood_color: longhands::flood_color::computed_value::T,
                /// The flood-opacity computed value.
                pub flood_opacity: longhands::flood_opacity::computed_value::T,
                /// The lighting-color computed value.
                pub lighting_color: longhands::lighting_color::computed_value::T,
                /// The mask-type computed value.
                pub mask_type: longhands::mask_type::computed_value::T,
                /// The clip-path computed value.
                pub clip_path: longhands::clip_path::computed_value::T,
                /// The mask-mode computed value.
                pub mask_mode: longhands::mask_mode::computed_value::T,
                /// The mask-repeat computed value.
                pub mask_repeat: longhands::mask_repeat::computed_value::T,
                /// The mask-position-x computed value.
                pub mask_position_x: longhands::mask_position_x::computed_value::T,
                /// The mask-position-y computed value.
                pub mask_position_y: longhands::mask_position_y::computed_value::T,
                /// The mask-clip computed value.
                pub mask_clip: longhands::mask_clip::computed_value::T,
                /// The mask-origin computed value.
                pub mask_origin: longhands::mask_origin::computed_value::T,
                /// The mask-size computed value.
                pub mask_size: longhands::mask_size::computed_value::T,
                /// The mask-composite computed value.
                pub mask_composite: longhands::mask_composite::computed_value::T,
                /// The mask-image computed value.
                pub mask_image: longhands::mask_image::computed_value::T,
        }

        impl SVG {
                        /// Set dominant-baseline.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_dominant_baseline(&mut self, v: longhands::dominant_baseline::computed_value::T) {
                            self.dominant_baseline = v;
                        }
                        /// Set dominant-baseline from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_dominant_baseline_from(&mut self, other: &Self) {
                            self.dominant_baseline = other.dominant_baseline.clone();
                        }
                    /// Reset dominant-baseline from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_dominant_baseline(&mut self, other: &Self) {
                        self.copy_dominant_baseline_from(other)
                    }

                    /// Get the computed value for dominant-baseline.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_dominant_baseline(&self) -> longhands::dominant_baseline::computed_value::T {
                        self.dominant_baseline.clone()
                    }
                        /// Set vector-effect.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_vector_effect(&mut self, v: longhands::vector_effect::computed_value::T) {
                            self.vector_effect = v;
                        }
                        /// Set vector-effect from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_vector_effect_from(&mut self, other: &Self) {
                            self.vector_effect = other.vector_effect.clone();
                        }
                    /// Reset vector-effect from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_vector_effect(&mut self, other: &Self) {
                        self.copy_vector_effect_from(other)
                    }

                    /// Get the computed value for vector-effect.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_vector_effect(&self) -> longhands::vector_effect::computed_value::T {
                        self.vector_effect.clone()
                    }
                        /// Set stop-color.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_stop_color(&mut self, v: longhands::stop_color::computed_value::T) {
                            self.stop_color = v;
                        }
                        /// Set stop-color from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_stop_color_from(&mut self, other: &Self) {
                            self.stop_color = other.stop_color.clone();
                        }
                    /// Reset stop-color from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_stop_color(&mut self, other: &Self) {
                        self.copy_stop_color_from(other)
                    }

                    /// Get the computed value for stop-color.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_stop_color(&self) -> longhands::stop_color::computed_value::T {
                        self.stop_color.clone()
                    }
                        /// Set stop-opacity.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_stop_opacity(&mut self, v: longhands::stop_opacity::computed_value::T) {
                            self.stop_opacity = v;
                        }
                        /// Set stop-opacity from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_stop_opacity_from(&mut self, other: &Self) {
                            self.stop_opacity = other.stop_opacity.clone();
                        }
                    /// Reset stop-opacity from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_stop_opacity(&mut self, other: &Self) {
                        self.copy_stop_opacity_from(other)
                    }

                    /// Get the computed value for stop-opacity.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_stop_opacity(&self) -> longhands::stop_opacity::computed_value::T {
                        self.stop_opacity.clone()
                    }
                        /// Set flood-color.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_flood_color(&mut self, v: longhands::flood_color::computed_value::T) {
                            self.flood_color = v;
                        }
                        /// Set flood-color from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_flood_color_from(&mut self, other: &Self) {
                            self.flood_color = other.flood_color.clone();
                        }
                    /// Reset flood-color from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_flood_color(&mut self, other: &Self) {
                        self.copy_flood_color_from(other)
                    }

                    /// Get the computed value for flood-color.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_flood_color(&self) -> longhands::flood_color::computed_value::T {
                        self.flood_color.clone()
                    }
                        /// Set flood-opacity.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_flood_opacity(&mut self, v: longhands::flood_opacity::computed_value::T) {
                            self.flood_opacity = v;
                        }
                        /// Set flood-opacity from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_flood_opacity_from(&mut self, other: &Self) {
                            self.flood_opacity = other.flood_opacity.clone();
                        }
                    /// Reset flood-opacity from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_flood_opacity(&mut self, other: &Self) {
                        self.copy_flood_opacity_from(other)
                    }

                    /// Get the computed value for flood-opacity.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_flood_opacity(&self) -> longhands::flood_opacity::computed_value::T {
                        self.flood_opacity.clone()
                    }
                        /// Set lighting-color.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_lighting_color(&mut self, v: longhands::lighting_color::computed_value::T) {
                            self.lighting_color = v;
                        }
                        /// Set lighting-color from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_lighting_color_from(&mut self, other: &Self) {
                            self.lighting_color = other.lighting_color.clone();
                        }
                    /// Reset lighting-color from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_lighting_color(&mut self, other: &Self) {
                        self.copy_lighting_color_from(other)
                    }

                    /// Get the computed value for lighting-color.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_lighting_color(&self) -> longhands::lighting_color::computed_value::T {
                        self.lighting_color.clone()
                    }
                        /// Set mask-type.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_mask_type(&mut self, v: longhands::mask_type::computed_value::T) {
                            self.mask_type = v;
                        }
                        /// Set mask-type from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_mask_type_from(&mut self, other: &Self) {
                            self.mask_type = other.mask_type.clone();
                        }
                    /// Reset mask-type from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_mask_type(&mut self, other: &Self) {
                        self.copy_mask_type_from(other)
                    }

                    /// Get the computed value for mask-type.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_mask_type(&self) -> longhands::mask_type::computed_value::T {
                        self.mask_type.clone()
                    }
                        /// Set clip-path.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_clip_path(&mut self, v: longhands::clip_path::computed_value::T) {
                            self.clip_path = v;
                        }
                        /// Set clip-path from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_clip_path_from(&mut self, other: &Self) {
                            self.clip_path = other.clip_path.clone();
                        }
                    /// Reset clip-path from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_clip_path(&mut self, other: &Self) {
                        self.copy_clip_path_from(other)
                    }

                    /// Get the computed value for clip-path.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_clip_path(&self) -> longhands::clip_path::computed_value::T {
                        self.clip_path.clone()
                    }
                        /// Set mask-mode.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_mask_mode<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::mask_mode
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.mask_mode = longhands::mask_mode::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set mask-mode from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_mask_mode_from(&mut self, other: &Self) {
                            self.mask_mode = other.mask_mode.clone();
                        }
                    /// Reset mask-mode from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_mask_mode(&mut self, other: &Self) {
                        self.copy_mask_mode_from(other)
                    }

                    /// Get the computed value for mask-mode.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_mask_mode(&self) -> longhands::mask_mode::computed_value::T {
                        self.mask_mode.clone()
                    }
                        /// Set mask-repeat.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_mask_repeat<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::mask_repeat
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.mask_repeat = longhands::mask_repeat::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set mask-repeat from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_mask_repeat_from(&mut self, other: &Self) {
                            self.mask_repeat = other.mask_repeat.clone();
                        }
                    /// Reset mask-repeat from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_mask_repeat(&mut self, other: &Self) {
                        self.copy_mask_repeat_from(other)
                    }

                    /// Get the computed value for mask-repeat.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_mask_repeat(&self) -> longhands::mask_repeat::computed_value::T {
                        self.mask_repeat.clone()
                    }
                        /// Set mask-position-x.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_mask_position_x<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::mask_position_x
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.mask_position_x = longhands::mask_position_x::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set mask-position-x from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_mask_position_x_from(&mut self, other: &Self) {
                            self.mask_position_x = other.mask_position_x.clone();
                        }
                    /// Reset mask-position-x from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_mask_position_x(&mut self, other: &Self) {
                        self.copy_mask_position_x_from(other)
                    }

                    /// Get the computed value for mask-position-x.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_mask_position_x(&self) -> longhands::mask_position_x::computed_value::T {
                        self.mask_position_x.clone()
                    }
                        /// Set mask-position-y.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_mask_position_y<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::mask_position_y
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.mask_position_y = longhands::mask_position_y::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set mask-position-y from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_mask_position_y_from(&mut self, other: &Self) {
                            self.mask_position_y = other.mask_position_y.clone();
                        }
                    /// Reset mask-position-y from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_mask_position_y(&mut self, other: &Self) {
                        self.copy_mask_position_y_from(other)
                    }

                    /// Get the computed value for mask-position-y.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_mask_position_y(&self) -> longhands::mask_position_y::computed_value::T {
                        self.mask_position_y.clone()
                    }
                        /// Set mask-clip.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_mask_clip<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::mask_clip
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.mask_clip = longhands::mask_clip::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set mask-clip from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_mask_clip_from(&mut self, other: &Self) {
                            self.mask_clip = other.mask_clip.clone();
                        }
                    /// Reset mask-clip from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_mask_clip(&mut self, other: &Self) {
                        self.copy_mask_clip_from(other)
                    }

                    /// Get the computed value for mask-clip.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_mask_clip(&self) -> longhands::mask_clip::computed_value::T {
                        self.mask_clip.clone()
                    }
                        /// Set mask-origin.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_mask_origin<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::mask_origin
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.mask_origin = longhands::mask_origin::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set mask-origin from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_mask_origin_from(&mut self, other: &Self) {
                            self.mask_origin = other.mask_origin.clone();
                        }
                    /// Reset mask-origin from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_mask_origin(&mut self, other: &Self) {
                        self.copy_mask_origin_from(other)
                    }

                    /// Get the computed value for mask-origin.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_mask_origin(&self) -> longhands::mask_origin::computed_value::T {
                        self.mask_origin.clone()
                    }
                        /// Set mask-size.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_mask_size<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::mask_size
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.mask_size = longhands::mask_size::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set mask-size from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_mask_size_from(&mut self, other: &Self) {
                            self.mask_size = other.mask_size.clone();
                        }
                    /// Reset mask-size from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_mask_size(&mut self, other: &Self) {
                        self.copy_mask_size_from(other)
                    }

                    /// Get the computed value for mask-size.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_mask_size(&self) -> longhands::mask_size::computed_value::T {
                        self.mask_size.clone()
                    }
                        /// Set mask-composite.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_mask_composite<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::mask_composite
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.mask_composite = longhands::mask_composite::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set mask-composite from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_mask_composite_from(&mut self, other: &Self) {
                            self.mask_composite = other.mask_composite.clone();
                        }
                    /// Reset mask-composite from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_mask_composite(&mut self, other: &Self) {
                        self.copy_mask_composite_from(other)
                    }

                    /// Get the computed value for mask-composite.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_mask_composite(&self) -> longhands::mask_composite::computed_value::T {
                        self.mask_composite.clone()
                    }
                        /// Set mask-image.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set_mask_image<I>(&mut self, v: I)
                        where
                            I: IntoIterator<Item = longhands::mask_image
                                                              ::computed_value::single_value::T>,
                            I::IntoIter: ExactSizeIterator
                        {
                            self.mask_image = longhands::mask_image::computed_value
                                                              ::List(v.into_iter().collect());
                        }
                        /// Set mask-image from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy_mask_image_from(&mut self, other: &Self) {
                            self.mask_image = other.mask_image.clone();
                        }
                    /// Reset mask-image from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset_mask_image(&mut self, other: &Self) {
                        self.copy_mask_image_from(other)
                    }

                    /// Get the computed value for mask-image.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone_mask_image(&self) -> longhands::mask_image::computed_value::T {
                        self.mask_image.clone()
                    }
        }

        #[derive(Clone, Debug, MallocSizeOf, PartialEq)]
        /// The XUL style struct.
        pub struct XUL {
                /// The -moz-box-align computed value.
                pub _moz_box_align: longhands::_moz_box_align::computed_value::T,
                /// The -moz-box-direction computed value.
                pub _moz_box_direction: longhands::_moz_box_direction::computed_value::T,
                /// The -moz-box-flex computed value.
                pub _moz_box_flex: longhands::_moz_box_flex::computed_value::T,
                /// The -moz-box-orient computed value.
                pub _moz_box_orient: longhands::_moz_box_orient::computed_value::T,
                /// The -moz-box-pack computed value.
                pub _moz_box_pack: longhands::_moz_box_pack::computed_value::T,
                /// The -moz-stack-sizing computed value.
                pub _moz_stack_sizing: longhands::_moz_stack_sizing::computed_value::T,
                /// The -moz-box-ordinal-group computed value.
                pub _moz_box_ordinal_group: longhands::_moz_box_ordinal_group::computed_value::T,
        }

        impl XUL {
                        /// Set -moz-box-align.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_box_align(&mut self, v: longhands::_moz_box_align::computed_value::T) {
                            self._moz_box_align = v;
                        }
                        /// Set -moz-box-align from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_box_align_from(&mut self, other: &Self) {
                            self._moz_box_align = other._moz_box_align.clone();
                        }
                    /// Reset -moz-box-align from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_box_align(&mut self, other: &Self) {
                        self.copy__moz_box_align_from(other)
                    }

                    /// Get the computed value for -moz-box-align.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_box_align(&self) -> longhands::_moz_box_align::computed_value::T {
                        self._moz_box_align.clone()
                    }
                        /// Set -moz-box-direction.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_box_direction(&mut self, v: longhands::_moz_box_direction::computed_value::T) {
                            self._moz_box_direction = v;
                        }
                        /// Set -moz-box-direction from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_box_direction_from(&mut self, other: &Self) {
                            self._moz_box_direction = other._moz_box_direction.clone();
                        }
                    /// Reset -moz-box-direction from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_box_direction(&mut self, other: &Self) {
                        self.copy__moz_box_direction_from(other)
                    }

                    /// Get the computed value for -moz-box-direction.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_box_direction(&self) -> longhands::_moz_box_direction::computed_value::T {
                        self._moz_box_direction.clone()
                    }
                        /// Set -moz-box-flex.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_box_flex(&mut self, v: longhands::_moz_box_flex::computed_value::T) {
                            self._moz_box_flex = v;
                        }
                        /// Set -moz-box-flex from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_box_flex_from(&mut self, other: &Self) {
                            self._moz_box_flex = other._moz_box_flex.clone();
                        }
                    /// Reset -moz-box-flex from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_box_flex(&mut self, other: &Self) {
                        self.copy__moz_box_flex_from(other)
                    }

                    /// Get the computed value for -moz-box-flex.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_box_flex(&self) -> longhands::_moz_box_flex::computed_value::T {
                        self._moz_box_flex.clone()
                    }
                        /// Set -moz-box-orient.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_box_orient(&mut self, v: longhands::_moz_box_orient::computed_value::T) {
                            self._moz_box_orient = v;
                        }
                        /// Set -moz-box-orient from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_box_orient_from(&mut self, other: &Self) {
                            self._moz_box_orient = other._moz_box_orient.clone();
                        }
                    /// Reset -moz-box-orient from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_box_orient(&mut self, other: &Self) {
                        self.copy__moz_box_orient_from(other)
                    }

                    /// Get the computed value for -moz-box-orient.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_box_orient(&self) -> longhands::_moz_box_orient::computed_value::T {
                        self._moz_box_orient.clone()
                    }
                        /// Set -moz-box-pack.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_box_pack(&mut self, v: longhands::_moz_box_pack::computed_value::T) {
                            self._moz_box_pack = v;
                        }
                        /// Set -moz-box-pack from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_box_pack_from(&mut self, other: &Self) {
                            self._moz_box_pack = other._moz_box_pack.clone();
                        }
                    /// Reset -moz-box-pack from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_box_pack(&mut self, other: &Self) {
                        self.copy__moz_box_pack_from(other)
                    }

                    /// Get the computed value for -moz-box-pack.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_box_pack(&self) -> longhands::_moz_box_pack::computed_value::T {
                        self._moz_box_pack.clone()
                    }
                        /// Set -moz-stack-sizing.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_stack_sizing(&mut self, v: longhands::_moz_stack_sizing::computed_value::T) {
                            self._moz_stack_sizing = v;
                        }
                        /// Set -moz-stack-sizing from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_stack_sizing_from(&mut self, other: &Self) {
                            self._moz_stack_sizing = other._moz_stack_sizing.clone();
                        }
                    /// Reset -moz-stack-sizing from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_stack_sizing(&mut self, other: &Self) {
                        self.copy__moz_stack_sizing_from(other)
                    }

                    /// Get the computed value for -moz-stack-sizing.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_stack_sizing(&self) -> longhands::_moz_stack_sizing::computed_value::T {
                        self._moz_stack_sizing.clone()
                    }
                        /// Set -moz-box-ordinal-group.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn set__moz_box_ordinal_group(&mut self, v: longhands::_moz_box_ordinal_group::computed_value::T) {
                            self._moz_box_ordinal_group = v;
                        }
                        /// Set -moz-box-ordinal-group from other struct.
                        #[allow(non_snake_case)]
                        #[inline]
                        pub fn copy__moz_box_ordinal_group_from(&mut self, other: &Self) {
                            self._moz_box_ordinal_group = other._moz_box_ordinal_group.clone();
                        }
                    /// Reset -moz-box-ordinal-group from the initial struct.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn reset__moz_box_ordinal_group(&mut self, other: &Self) {
                        self.copy__moz_box_ordinal_group_from(other)
                    }

                    /// Get the computed value for -moz-box-ordinal-group.
                    #[allow(non_snake_case)]
                    #[inline]
                    pub fn clone__moz_box_ordinal_group(&self) -> longhands::_moz_box_ordinal_group::computed_value::T {
                        self._moz_box_ordinal_group.clone()
                    }
        }

}

    impl style_structs::Background {

    }

    impl style_structs::Border {

    }

    impl style_structs::Box {
                /// Iterate over the values of transition-duration.
                #[allow(non_snake_case)]
                #[inline]
                pub fn transition_duration_iter(&self) -> TransitionDurationIter {
                    TransitionDurationIter {
                        style_struct: self,
                        current: 0,
                        max: self.transition_duration_count(),
                    }
                }

                /// Get a value mod `index` for the property transition-duration.
                #[allow(non_snake_case)]
                #[inline]
                pub fn transition_duration_mod(&self, index: usize)
                    -> longhands::transition_duration::computed_value::SingleComputedValue {
                    self.transition_duration_at(index % self.transition_duration_count())
                }

                /// Clone the computed value for the property.
                #[allow(non_snake_case)]
                #[inline]
                #[cfg(feature = "gecko")]
                pub fn clone_transition_duration(
                    &self,
                ) -> longhands::transition_duration::computed_value::T {
                    longhands::transition_duration::computed_value::List(
                        self.transition_duration_iter().collect()
                    )
                }
                /// Iterate over the values of transition-timing-function.
                #[allow(non_snake_case)]
                #[inline]
                pub fn transition_timing_function_iter(&self) -> TransitionTimingFunctionIter {
                    TransitionTimingFunctionIter {
                        style_struct: self,
                        current: 0,
                        max: self.transition_timing_function_count(),
                    }
                }

                /// Get a value mod `index` for the property transition-timing-function.
                #[allow(non_snake_case)]
                #[inline]
                pub fn transition_timing_function_mod(&self, index: usize)
                    -> longhands::transition_timing_function::computed_value::SingleComputedValue {
                    self.transition_timing_function_at(index % self.transition_timing_function_count())
                }

                /// Clone the computed value for the property.
                #[allow(non_snake_case)]
                #[inline]
                #[cfg(feature = "gecko")]
                pub fn clone_transition_timing_function(
                    &self,
                ) -> longhands::transition_timing_function::computed_value::T {
                    longhands::transition_timing_function::computed_value::List(
                        self.transition_timing_function_iter().collect()
                    )
                }
                /// Iterate over the values of transition-property.
                #[allow(non_snake_case)]
                #[inline]
                pub fn transition_property_iter(&self) -> TransitionPropertyIter {
                    TransitionPropertyIter {
                        style_struct: self,
                        current: 0,
                        max: self.transition_property_count(),
                    }
                }

                /// Get a value mod `index` for the property transition-property.
                #[allow(non_snake_case)]
                #[inline]
                pub fn transition_property_mod(&self, index: usize)
                    -> longhands::transition_property::computed_value::SingleComputedValue {
                    self.transition_property_at(index % self.transition_property_count())
                }

                /// Clone the computed value for the property.
                #[allow(non_snake_case)]
                #[inline]
                #[cfg(feature = "gecko")]
                pub fn clone_transition_property(
                    &self,
                ) -> longhands::transition_property::computed_value::T {
                    longhands::transition_property::computed_value::List(
                        self.transition_property_iter().collect()
                    )
                }
                /// Iterate over the values of transition-delay.
                #[allow(non_snake_case)]
                #[inline]
                pub fn transition_delay_iter(&self) -> TransitionDelayIter {
                    TransitionDelayIter {
                        style_struct: self,
                        current: 0,
                        max: self.transition_delay_count(),
                    }
                }

                /// Get a value mod `index` for the property transition-delay.
                #[allow(non_snake_case)]
                #[inline]
                pub fn transition_delay_mod(&self, index: usize)
                    -> longhands::transition_delay::computed_value::SingleComputedValue {
                    self.transition_delay_at(index % self.transition_delay_count())
                }

                /// Clone the computed value for the property.
                #[allow(non_snake_case)]
                #[inline]
                #[cfg(feature = "gecko")]
                pub fn clone_transition_delay(
                    &self,
                ) -> longhands::transition_delay::computed_value::T {
                    longhands::transition_delay::computed_value::List(
                        self.transition_delay_iter().collect()
                    )
                }
                /// Iterate over the values of animation-name.
                #[allow(non_snake_case)]
                #[inline]
                pub fn animation_name_iter(&self) -> AnimationNameIter {
                    AnimationNameIter {
                        style_struct: self,
                        current: 0,
                        max: self.animation_name_count(),
                    }
                }

                /// Get a value mod `index` for the property animation-name.
                #[allow(non_snake_case)]
                #[inline]
                pub fn animation_name_mod(&self, index: usize)
                    -> longhands::animation_name::computed_value::SingleComputedValue {
                    self.animation_name_at(index % self.animation_name_count())
                }

                /// Clone the computed value for the property.
                #[allow(non_snake_case)]
                #[inline]
                #[cfg(feature = "gecko")]
                pub fn clone_animation_name(
                    &self,
                ) -> longhands::animation_name::computed_value::T {
                    longhands::animation_name::computed_value::List(
                        self.animation_name_iter().collect()
                    )
                }
                /// Iterate over the values of animation-duration.
                #[allow(non_snake_case)]
                #[inline]
                pub fn animation_duration_iter(&self) -> AnimationDurationIter {
                    AnimationDurationIter {
                        style_struct: self,
                        current: 0,
                        max: self.animation_duration_count(),
                    }
                }

                /// Get a value mod `index` for the property animation-duration.
                #[allow(non_snake_case)]
                #[inline]
                pub fn animation_duration_mod(&self, index: usize)
                    -> longhands::animation_duration::computed_value::SingleComputedValue {
                    self.animation_duration_at(index % self.animation_duration_count())
                }

                /// Clone the computed value for the property.
                #[allow(non_snake_case)]
                #[inline]
                #[cfg(feature = "gecko")]
                pub fn clone_animation_duration(
                    &self,
                ) -> longhands::animation_duration::computed_value::T {
                    longhands::animation_duration::computed_value::List(
                        self.animation_duration_iter().collect()
                    )
                }
                /// Iterate over the values of animation-timing-function.
                #[allow(non_snake_case)]
                #[inline]
                pub fn animation_timing_function_iter(&self) -> AnimationTimingFunctionIter {
                    AnimationTimingFunctionIter {
                        style_struct: self,
                        current: 0,
                        max: self.animation_timing_function_count(),
                    }
                }

                /// Get a value mod `index` for the property animation-timing-function.
                #[allow(non_snake_case)]
                #[inline]
                pub fn animation_timing_function_mod(&self, index: usize)
                    -> longhands::animation_timing_function::computed_value::SingleComputedValue {
                    self.animation_timing_function_at(index % self.animation_timing_function_count())
                }

                /// Clone the computed value for the property.
                #[allow(non_snake_case)]
                #[inline]
                #[cfg(feature = "gecko")]
                pub fn clone_animation_timing_function(
                    &self,
                ) -> longhands::animation_timing_function::computed_value::T {
                    longhands::animation_timing_function::computed_value::List(
                        self.animation_timing_function_iter().collect()
                    )
                }
                /// Iterate over the values of animation-iteration-count.
                #[allow(non_snake_case)]
                #[inline]
                pub fn animation_iteration_count_iter(&self) -> AnimationIterationCountIter {
                    AnimationIterationCountIter {
                        style_struct: self,
                        current: 0,
                        max: self.animation_iteration_count_count(),
                    }
                }

                /// Get a value mod `index` for the property animation-iteration-count.
                #[allow(non_snake_case)]
                #[inline]
                pub fn animation_iteration_count_mod(&self, index: usize)
                    -> longhands::animation_iteration_count::computed_value::SingleComputedValue {
                    self.animation_iteration_count_at(index % self.animation_iteration_count_count())
                }

                /// Clone the computed value for the property.
                #[allow(non_snake_case)]
                #[inline]
                #[cfg(feature = "gecko")]
                pub fn clone_animation_iteration_count(
                    &self,
                ) -> longhands::animation_iteration_count::computed_value::T {
                    longhands::animation_iteration_count::computed_value::List(
                        self.animation_iteration_count_iter().collect()
                    )
                }
                /// Iterate over the values of animation-direction.
                #[allow(non_snake_case)]
                #[inline]
                pub fn animation_direction_iter(&self) -> AnimationDirectionIter {
                    AnimationDirectionIter {
                        style_struct: self,
                        current: 0,
                        max: self.animation_direction_count(),
                    }
                }

                /// Get a value mod `index` for the property animation-direction.
                #[allow(non_snake_case)]
                #[inline]
                pub fn animation_direction_mod(&self, index: usize)
                    -> longhands::animation_direction::computed_value::SingleComputedValue {
                    self.animation_direction_at(index % self.animation_direction_count())
                }

                /// Clone the computed value for the property.
                #[allow(non_snake_case)]
                #[inline]
                #[cfg(feature = "gecko")]
                pub fn clone_animation_direction(
                    &self,
                ) -> longhands::animation_direction::computed_value::T {
                    longhands::animation_direction::computed_value::List(
                        self.animation_direction_iter().collect()
                    )
                }
                /// Iterate over the values of animation-play-state.
                #[allow(non_snake_case)]
                #[inline]
                pub fn animation_play_state_iter(&self) -> AnimationPlayStateIter {
                    AnimationPlayStateIter {
                        style_struct: self,
                        current: 0,
                        max: self.animation_play_state_count(),
                    }
                }

                /// Get a value mod `index` for the property animation-play-state.
                #[allow(non_snake_case)]
                #[inline]
                pub fn animation_play_state_mod(&self, index: usize)
                    -> longhands::animation_play_state::computed_value::SingleComputedValue {
                    self.animation_play_state_at(index % self.animation_play_state_count())
                }

                /// Clone the computed value for the property.
                #[allow(non_snake_case)]
                #[inline]
                #[cfg(feature = "gecko")]
                pub fn clone_animation_play_state(
                    &self,
                ) -> longhands::animation_play_state::computed_value::T {
                    longhands::animation_play_state::computed_value::List(
                        self.animation_play_state_iter().collect()
                    )
                }
                /// Iterate over the values of animation-fill-mode.
                #[allow(non_snake_case)]
                #[inline]
                pub fn animation_fill_mode_iter(&self) -> AnimationFillModeIter {
                    AnimationFillModeIter {
                        style_struct: self,
                        current: 0,
                        max: self.animation_fill_mode_count(),
                    }
                }

                /// Get a value mod `index` for the property animation-fill-mode.
                #[allow(non_snake_case)]
                #[inline]
                pub fn animation_fill_mode_mod(&self, index: usize)
                    -> longhands::animation_fill_mode::computed_value::SingleComputedValue {
                    self.animation_fill_mode_at(index % self.animation_fill_mode_count())
                }

                /// Clone the computed value for the property.
                #[allow(non_snake_case)]
                #[inline]
                #[cfg(feature = "gecko")]
                pub fn clone_animation_fill_mode(
                    &self,
                ) -> longhands::animation_fill_mode::computed_value::T {
                    longhands::animation_fill_mode::computed_value::List(
                        self.animation_fill_mode_iter().collect()
                    )
                }
                /// Iterate over the values of animation-delay.
                #[allow(non_snake_case)]
                #[inline]
                pub fn animation_delay_iter(&self) -> AnimationDelayIter {
                    AnimationDelayIter {
                        style_struct: self,
                        current: 0,
                        max: self.animation_delay_count(),
                    }
                }

                /// Get a value mod `index` for the property animation-delay.
                #[allow(non_snake_case)]
                #[inline]
                pub fn animation_delay_mod(&self, index: usize)
                    -> longhands::animation_delay::computed_value::SingleComputedValue {
                    self.animation_delay_at(index % self.animation_delay_count())
                }

                /// Clone the computed value for the property.
                #[allow(non_snake_case)]
                #[inline]
                #[cfg(feature = "gecko")]
                pub fn clone_animation_delay(
                    &self,
                ) -> longhands::animation_delay::computed_value::T {
                    longhands::animation_delay::computed_value::List(
                        self.animation_delay_iter().collect()
                    )
                }

            /// Returns whether there is any animation specified with
            /// animation-name other than `none`.
            pub fn specifies_animations(&self) -> bool {
                self.animation_name_iter().any(|name| name.0.is_some())
            }

            /// Returns whether there are any transitions specified.
            #[cfg(feature = "servo")]
            pub fn specifies_transitions(&self) -> bool {
                self.transition_duration_iter()
                    .take(self.transition_property_count())
                    .any(|t| t.seconds() > 0.)
            }
    }

            /// An iterator over the values of the transition-duration properties.
            pub struct TransitionDurationIter<'a> {
                style_struct: &'a style_structs::Box,
                current: usize,
                max: usize,
            }

            impl<'a> Iterator for TransitionDurationIter<'a> {
                type Item = longhands::transition_duration::computed_value::SingleComputedValue;

                fn next(&mut self) -> Option<Self::Item> {
                    self.current += 1;
                    if self.current <= self.max {
                        Some(self.style_struct.transition_duration_at(self.current - 1))
                    } else {
                        None
                    }
                }
            }
            /// An iterator over the values of the transition-timing-function properties.
            pub struct TransitionTimingFunctionIter<'a> {
                style_struct: &'a style_structs::Box,
                current: usize,
                max: usize,
            }

            impl<'a> Iterator for TransitionTimingFunctionIter<'a> {
                type Item = longhands::transition_timing_function::computed_value::SingleComputedValue;

                fn next(&mut self) -> Option<Self::Item> {
                    self.current += 1;
                    if self.current <= self.max {
                        Some(self.style_struct.transition_timing_function_at(self.current - 1))
                    } else {
                        None
                    }
                }
            }
            /// An iterator over the values of the transition-property properties.
            pub struct TransitionPropertyIter<'a> {
                style_struct: &'a style_structs::Box,
                current: usize,
                max: usize,
            }

            impl<'a> Iterator for TransitionPropertyIter<'a> {
                type Item = longhands::transition_property::computed_value::SingleComputedValue;

                fn next(&mut self) -> Option<Self::Item> {
                    self.current += 1;
                    if self.current <= self.max {
                        Some(self.style_struct.transition_property_at(self.current - 1))
                    } else {
                        None
                    }
                }
            }
            /// An iterator over the values of the transition-delay properties.
            pub struct TransitionDelayIter<'a> {
                style_struct: &'a style_structs::Box,
                current: usize,
                max: usize,
            }

            impl<'a> Iterator for TransitionDelayIter<'a> {
                type Item = longhands::transition_delay::computed_value::SingleComputedValue;

                fn next(&mut self) -> Option<Self::Item> {
                    self.current += 1;
                    if self.current <= self.max {
                        Some(self.style_struct.transition_delay_at(self.current - 1))
                    } else {
                        None
                    }
                }
            }
            /// An iterator over the values of the animation-name properties.
            pub struct AnimationNameIter<'a> {
                style_struct: &'a style_structs::Box,
                current: usize,
                max: usize,
            }

            impl<'a> Iterator for AnimationNameIter<'a> {
                type Item = longhands::animation_name::computed_value::SingleComputedValue;

                fn next(&mut self) -> Option<Self::Item> {
                    self.current += 1;
                    if self.current <= self.max {
                        Some(self.style_struct.animation_name_at(self.current - 1))
                    } else {
                        None
                    }
                }
            }
            /// An iterator over the values of the animation-duration properties.
            pub struct AnimationDurationIter<'a> {
                style_struct: &'a style_structs::Box,
                current: usize,
                max: usize,
            }

            impl<'a> Iterator for AnimationDurationIter<'a> {
                type Item = longhands::animation_duration::computed_value::SingleComputedValue;

                fn next(&mut self) -> Option<Self::Item> {
                    self.current += 1;
                    if self.current <= self.max {
                        Some(self.style_struct.animation_duration_at(self.current - 1))
                    } else {
                        None
                    }
                }
            }
            /// An iterator over the values of the animation-timing-function properties.
            pub struct AnimationTimingFunctionIter<'a> {
                style_struct: &'a style_structs::Box,
                current: usize,
                max: usize,
            }

            impl<'a> Iterator for AnimationTimingFunctionIter<'a> {
                type Item = longhands::animation_timing_function::computed_value::SingleComputedValue;

                fn next(&mut self) -> Option<Self::Item> {
                    self.current += 1;
                    if self.current <= self.max {
                        Some(self.style_struct.animation_timing_function_at(self.current - 1))
                    } else {
                        None
                    }
                }
            }
            /// An iterator over the values of the animation-iteration-count properties.
            pub struct AnimationIterationCountIter<'a> {
                style_struct: &'a style_structs::Box,
                current: usize,
                max: usize,
            }

            impl<'a> Iterator for AnimationIterationCountIter<'a> {
                type Item = longhands::animation_iteration_count::computed_value::SingleComputedValue;

                fn next(&mut self) -> Option<Self::Item> {
                    self.current += 1;
                    if self.current <= self.max {
                        Some(self.style_struct.animation_iteration_count_at(self.current - 1))
                    } else {
                        None
                    }
                }
            }
            /// An iterator over the values of the animation-direction properties.
            pub struct AnimationDirectionIter<'a> {
                style_struct: &'a style_structs::Box,
                current: usize,
                max: usize,
            }

            impl<'a> Iterator for AnimationDirectionIter<'a> {
                type Item = longhands::animation_direction::computed_value::SingleComputedValue;

                fn next(&mut self) -> Option<Self::Item> {
                    self.current += 1;
                    if self.current <= self.max {
                        Some(self.style_struct.animation_direction_at(self.current - 1))
                    } else {
                        None
                    }
                }
            }
            /// An iterator over the values of the animation-play-state properties.
            pub struct AnimationPlayStateIter<'a> {
                style_struct: &'a style_structs::Box,
                current: usize,
                max: usize,
            }

            impl<'a> Iterator for AnimationPlayStateIter<'a> {
                type Item = longhands::animation_play_state::computed_value::SingleComputedValue;

                fn next(&mut self) -> Option<Self::Item> {
                    self.current += 1;
                    if self.current <= self.max {
                        Some(self.style_struct.animation_play_state_at(self.current - 1))
                    } else {
                        None
                    }
                }
            }
            /// An iterator over the values of the animation-fill-mode properties.
            pub struct AnimationFillModeIter<'a> {
                style_struct: &'a style_structs::Box,
                current: usize,
                max: usize,
            }

            impl<'a> Iterator for AnimationFillModeIter<'a> {
                type Item = longhands::animation_fill_mode::computed_value::SingleComputedValue;

                fn next(&mut self) -> Option<Self::Item> {
                    self.current += 1;
                    if self.current <= self.max {
                        Some(self.style_struct.animation_fill_mode_at(self.current - 1))
                    } else {
                        None
                    }
                }
            }
            /// An iterator over the values of the animation-delay properties.
            pub struct AnimationDelayIter<'a> {
                style_struct: &'a style_structs::Box,
                current: usize,
                max: usize,
            }

            impl<'a> Iterator for AnimationDelayIter<'a> {
                type Item = longhands::animation_delay::computed_value::SingleComputedValue;

                fn next(&mut self) -> Option<Self::Item> {
                    self.current += 1;
                    if self.current <= self.max {
                        Some(self.style_struct.animation_delay_at(self.current - 1))
                    } else {
                        None
                    }
                }
            }
    impl style_structs::Color {

    }

    impl style_structs::Column {

            /// Whether this is a multicol style.
            #[cfg(feature = "servo")]
            pub fn is_multicol(&self) -> bool {
                !self.column_width.is_auto() || !self.column_count.is_auto()
            }
    }

    impl style_structs::Counters {

    }

    impl style_structs::Effects {

    }

    impl style_structs::Font {

    }

    impl style_structs::InheritedBox {

    }

    impl style_structs::InheritedTable {

    }

    impl style_structs::InheritedText {

    }

    impl style_structs::InheritedUI {

    }

    impl style_structs::InheritedSVG {

    }

    impl style_structs::List {

    }

    impl style_structs::Margin {

    }

    impl style_structs::Outline {

    }

    impl style_structs::Padding {

    }

    impl style_structs::Position {

    }

    impl style_structs::Table {

    }

    impl style_structs::Text {

    }

    impl style_structs::UI {

    }

    impl style_structs::SVG {

    }

    impl style_structs::XUL {

    }



#[cfg(feature = "gecko")]
pub use crate::gecko_properties::{ComputedValues, ComputedValuesInner};

#[cfg(feature = "servo")]
#[cfg_attr(feature = "servo", derive(Clone, Debug))]
/// Actual data of ComputedValues, to match up with Gecko
pub struct ComputedValuesInner {
        background: Arc<style_structs::Background>,
        border: Arc<style_structs::Border>,
        box_: Arc<style_structs::Box>,
        color: Arc<style_structs::Color>,
        column: Arc<style_structs::Column>,
        counters: Arc<style_structs::Counters>,
        effects: Arc<style_structs::Effects>,
        font: Arc<style_structs::Font>,
        inherited_box: Arc<style_structs::InheritedBox>,
        inherited_table: Arc<style_structs::InheritedTable>,
        inherited_text: Arc<style_structs::InheritedText>,
        inherited_ui: Arc<style_structs::InheritedUI>,
        inherited_svg: Arc<style_structs::InheritedSVG>,
        list: Arc<style_structs::List>,
        margin: Arc<style_structs::Margin>,
        outline: Arc<style_structs::Outline>,
        padding: Arc<style_structs::Padding>,
        position: Arc<style_structs::Position>,
        table: Arc<style_structs::Table>,
        text: Arc<style_structs::Text>,
        ui: Arc<style_structs::UI>,
        svg: Arc<style_structs::SVG>,
        xul: Arc<style_structs::XUL>,
    custom_properties: Option<Arc<crate::custom_properties::CustomPropertiesMap>>,
    /// The writing mode of this computed values struct.
    pub writing_mode: WritingMode,

    /// A set of flags we use to store misc information regarding this style.
    pub flags: ComputedValueFlags,

    /// The rule node representing the ordered list of rules matched for this
    /// node.  Can be None for default values and text nodes.  This is
    /// essentially an optimization to avoid referencing the root rule node.
    pub rules: Option<StrongRuleNode>,

    /// The element's computed values if visited, only computed if there's a
    /// relevant link for this element. A element's "relevant link" is the
    /// element being matched if it is a link or the nearest ancestor link.
    visited_style: Option<Arc<ComputedValues>>,
}

/// The struct that Servo uses to represent computed values.
///
/// This struct contains an immutable atomically-reference-counted pointer to
/// every kind of style struct.
///
/// When needed, the structs may be copied in order to get mutated.
#[cfg(feature = "servo")]
#[cfg_attr(feature = "servo", derive(Clone, Debug))]
pub struct ComputedValues {
    /// The actual computed values
    ///
    /// In Gecko the outer ComputedValues is actually a ComputedStyle, whereas
    /// ComputedValuesInner is the core set of computed values.
    ///
    /// We maintain this distinction in servo to reduce the amount of special
    /// casing.
    inner: ComputedValuesInner,
}

impl ComputedValues {
    /// Returns whether this style's display value is equal to contents.
    pub fn is_display_contents(&self) -> bool {
        self.get_box().clone_display().is_contents()
    }

    /// Gets a reference to the rule node. Panic if no rule node exists.
    pub fn rules(&self) -> &StrongRuleNode {
        self.rules.as_ref().unwrap()
    }

    /// Returns the visited style, if any.
    pub fn visited_style(&self) -> Option<&ComputedValues> {
        self.visited_style.as_ref().map(|s| &**s)
    }

    /// Returns the visited rules, if applicable.
    pub fn visited_rules(&self) -> Option<&StrongRuleNode> {
        self.visited_style.as_ref().and_then(|s| s.rules.as_ref())
    }

    /// Gets a reference to the custom properties map (if one exists).
    pub fn custom_properties(&self) -> Option<&Arc<crate::custom_properties::CustomPropertiesMap>> {
        self.custom_properties.as_ref()
    }

    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_align_content(
        &self,
    ) -> longhands::align_content::computed_value::T {
        self.get_position()
            .clone_align_content()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_align_items(
        &self,
    ) -> longhands::align_items::computed_value::T {
        self.get_position()
            .clone_align_items()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_align_self(
        &self,
    ) -> longhands::align_self::computed_value::T {
        self.get_position()
            .clone_align_self()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_backface_visibility(
        &self,
    ) -> longhands::backface_visibility::computed_value::T {
        self.get_box()
            .clone_backface_visibility()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_collapse(
        &self,
    ) -> longhands::border_collapse::computed_value::T {
        self.get_inherited_table()
            .clone_border_collapse()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_image_repeat(
        &self,
    ) -> longhands::border_image_repeat::computed_value::T {
        self.get_border()
            .clone_border_image_repeat()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_box_decoration_break(
        &self,
    ) -> longhands::box_decoration_break::computed_value::T {
        self.get_border()
            .clone_box_decoration_break()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_box_sizing(
        &self,
    ) -> longhands::box_sizing::computed_value::T {
        self.get_position()
            .clone_box_sizing()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_break_inside(
        &self,
    ) -> longhands::break_inside::computed_value::T {
        self.get_box()
            .clone_break_inside()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_caption_side(
        &self,
    ) -> longhands::caption_side::computed_value::T {
        self.get_inherited_table()
            .clone_caption_side()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_clear(
        &self,
    ) -> longhands::clear::computed_value::T {
        self.get_box()
            .clone_clear()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_color_adjust(
        &self,
    ) -> longhands::color_adjust::computed_value::T {
        self.get_inherited_box()
            .clone_color_adjust()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_color_interpolation(
        &self,
    ) -> longhands::color_interpolation::computed_value::T {
        self.get_inherited_svg()
            .clone_color_interpolation()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_color_interpolation_filters(
        &self,
    ) -> longhands::color_interpolation_filters::computed_value::T {
        self.get_inherited_svg()
            .clone_color_interpolation_filters()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_column_count(
        &self,
    ) -> longhands::column_count::computed_value::T {
        self.get_column()
            .clone_column_count()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_column_fill(
        &self,
    ) -> longhands::column_fill::computed_value::T {
        self.get_column()
            .clone_column_fill()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_column_span(
        &self,
    ) -> longhands::column_span::computed_value::T {
        self.get_column()
            .clone_column_span()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_contain(
        &self,
    ) -> longhands::contain::computed_value::T {
        self.get_box()
            .clone_contain()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_direction(
        &self,
    ) -> longhands::direction::computed_value::T {
        self.get_inherited_box()
            .clone_direction()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_display(
        &self,
    ) -> longhands::display::computed_value::T {
        self.get_box()
            .clone_display()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_dominant_baseline(
        &self,
    ) -> longhands::dominant_baseline::computed_value::T {
        self.get_svg()
            .clone_dominant_baseline()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_empty_cells(
        &self,
    ) -> longhands::empty_cells::computed_value::T {
        self.get_inherited_table()
            .clone_empty_cells()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_flex_direction(
        &self,
    ) -> longhands::flex_direction::computed_value::T {
        self.get_position()
            .clone_flex_direction()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_flex_wrap(
        &self,
    ) -> longhands::flex_wrap::computed_value::T {
        self.get_position()
            .clone_flex_wrap()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_float(
        &self,
    ) -> longhands::float::computed_value::T {
        self.get_box()
            .clone_float()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_font_kerning(
        &self,
    ) -> longhands::font_kerning::computed_value::T {
        self.get_font()
            .clone_font_kerning()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_font_optical_sizing(
        &self,
    ) -> longhands::font_optical_sizing::computed_value::T {
        self.get_font()
            .clone_font_optical_sizing()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_font_size_adjust(
        &self,
    ) -> longhands::font_size_adjust::computed_value::T {
        self.get_font()
            .clone_font_size_adjust()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_font_stretch(
        &self,
    ) -> longhands::font_stretch::computed_value::T {
        self.get_font()
            .clone_font_stretch()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_font_style(
        &self,
    ) -> longhands::font_style::computed_value::T {
        self.get_font()
            .clone_font_style()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_font_synthesis(
        &self,
    ) -> longhands::font_synthesis::computed_value::T {
        self.get_font()
            .clone_font_synthesis()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_font_variant_caps(
        &self,
    ) -> longhands::font_variant_caps::computed_value::T {
        self.get_font()
            .clone_font_variant_caps()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_font_variant_east_asian(
        &self,
    ) -> longhands::font_variant_east_asian::computed_value::T {
        self.get_font()
            .clone_font_variant_east_asian()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_font_variant_ligatures(
        &self,
    ) -> longhands::font_variant_ligatures::computed_value::T {
        self.get_font()
            .clone_font_variant_ligatures()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_font_variant_numeric(
        &self,
    ) -> longhands::font_variant_numeric::computed_value::T {
        self.get_font()
            .clone_font_variant_numeric()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_font_variant_position(
        &self,
    ) -> longhands::font_variant_position::computed_value::T {
        self.get_font()
            .clone_font_variant_position()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_font_weight(
        &self,
    ) -> longhands::font_weight::computed_value::T {
        self.get_font()
            .clone_font_weight()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_grid_auto_flow(
        &self,
    ) -> longhands::grid_auto_flow::computed_value::T {
        self.get_position()
            .clone_grid_auto_flow()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_hyphens(
        &self,
    ) -> longhands::hyphens::computed_value::T {
        self.get_inherited_text()
            .clone_hyphens()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_image_orientation(
        &self,
    ) -> longhands::image_orientation::computed_value::T {
        self.get_inherited_box()
            .clone_image_orientation()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_image_rendering(
        &self,
    ) -> longhands::image_rendering::computed_value::T {
        self.get_inherited_box()
            .clone_image_rendering()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_ime_mode(
        &self,
    ) -> longhands::ime_mode::computed_value::T {
        self.get_ui()
            .clone_ime_mode()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_initial_letter(
        &self,
    ) -> longhands::initial_letter::computed_value::T {
        self.get_text()
            .clone_initial_letter()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_isolation(
        &self,
    ) -> longhands::isolation::computed_value::T {
        self.get_box()
            .clone_isolation()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_justify_content(
        &self,
    ) -> longhands::justify_content::computed_value::T {
        self.get_position()
            .clone_justify_content()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_justify_items(
        &self,
    ) -> longhands::justify_items::computed_value::T {
        self.get_position()
            .clone_justify_items()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_justify_self(
        &self,
    ) -> longhands::justify_self::computed_value::T {
        self.get_position()
            .clone_justify_self()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_list_style_position(
        &self,
    ) -> longhands::list_style_position::computed_value::T {
        self.get_list()
            .clone_list_style_position()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_mask_type(
        &self,
    ) -> longhands::mask_type::computed_value::T {
        self.get_svg()
            .clone_mask_type()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_mix_blend_mode(
        &self,
    ) -> longhands::mix_blend_mode::computed_value::T {
        self.get_effects()
            .clone_mix_blend_mode()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_appearance(
        &self,
    ) -> longhands::_moz_appearance::computed_value::T {
        self.get_box()
            .clone__moz_appearance()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_box_align(
        &self,
    ) -> longhands::_moz_box_align::computed_value::T {
        self.get_xul()
            .clone__moz_box_align()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_box_direction(
        &self,
    ) -> longhands::_moz_box_direction::computed_value::T {
        self.get_xul()
            .clone__moz_box_direction()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_box_orient(
        &self,
    ) -> longhands::_moz_box_orient::computed_value::T {
        self.get_xul()
            .clone__moz_box_orient()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_box_pack(
        &self,
    ) -> longhands::_moz_box_pack::computed_value::T {
        self.get_xul()
            .clone__moz_box_pack()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_control_character_visibility(
        &self,
    ) -> longhands::_moz_control_character_visibility::computed_value::T {
        self.get_inherited_text()
            .clone__moz_control_character_visibility()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_float_edge(
        &self,
    ) -> longhands::_moz_float_edge::computed_value::T {
        self.get_border()
            .clone__moz_float_edge()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_force_broken_image_icon(
        &self,
    ) -> longhands::_moz_force_broken_image_icon::computed_value::T {
        self.get_ui()
            .clone__moz_force_broken_image_icon()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_list_reversed(
        &self,
    ) -> longhands::_moz_list_reversed::computed_value::T {
        self.get_list()
            .clone__moz_list_reversed()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_math_display(
        &self,
    ) -> longhands::_moz_math_display::computed_value::T {
        self.get_font()
            .clone__moz_math_display()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_math_variant(
        &self,
    ) -> longhands::_moz_math_variant::computed_value::T {
        self.get_font()
            .clone__moz_math_variant()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_min_font_size_ratio(
        &self,
    ) -> longhands::_moz_min_font_size_ratio::computed_value::T {
        self.get_font()
            .clone__moz_min_font_size_ratio()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_orient(
        &self,
    ) -> longhands::_moz_orient::computed_value::T {
        self.get_box()
            .clone__moz_orient()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_osx_font_smoothing(
        &self,
    ) -> longhands::_moz_osx_font_smoothing::computed_value::T {
        self.get_font()
            .clone__moz_osx_font_smoothing()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_script_level(
        &self,
    ) -> longhands::_moz_script_level::computed_value::T {
        self.get_font()
            .clone__moz_script_level()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_script_min_size(
        &self,
    ) -> longhands::_moz_script_min_size::computed_value::T {
        self.get_font()
            .clone__moz_script_min_size()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_script_size_multiplier(
        &self,
    ) -> longhands::_moz_script_size_multiplier::computed_value::T {
        self.get_font()
            .clone__moz_script_size_multiplier()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_stack_sizing(
        &self,
    ) -> longhands::_moz_stack_sizing::computed_value::T {
        self.get_xul()
            .clone__moz_stack_sizing()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_text_size_adjust(
        &self,
    ) -> longhands::_moz_text_size_adjust::computed_value::T {
        self.get_inherited_text()
            .clone__moz_text_size_adjust()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_top_layer(
        &self,
    ) -> longhands::_moz_top_layer::computed_value::T {
        self.get_box()
            .clone__moz_top_layer()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_user_focus(
        &self,
    ) -> longhands::_moz_user_focus::computed_value::T {
        self.get_inherited_ui()
            .clone__moz_user_focus()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_user_input(
        &self,
    ) -> longhands::_moz_user_input::computed_value::T {
        self.get_inherited_ui()
            .clone__moz_user_input()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_user_modify(
        &self,
    ) -> longhands::_moz_user_modify::computed_value::T {
        self.get_inherited_ui()
            .clone__moz_user_modify()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_user_select(
        &self,
    ) -> longhands::_moz_user_select::computed_value::T {
        self.get_ui()
            .clone__moz_user_select()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_window_dragging(
        &self,
    ) -> longhands::_moz_window_dragging::computed_value::T {
        self.get_ui()
            .clone__moz_window_dragging()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_window_shadow(
        &self,
    ) -> longhands::_moz_window_shadow::computed_value::T {
        self.get_ui()
            .clone__moz_window_shadow()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_object_fit(
        &self,
    ) -> longhands::object_fit::computed_value::T {
        self.get_position()
            .clone_object_fit()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_outline_style(
        &self,
    ) -> longhands::outline_style::computed_value::T {
        self.get_outline()
            .clone_outline_style()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_overflow_anchor(
        &self,
    ) -> longhands::overflow_anchor::computed_value::T {
        self.get_box()
            .clone_overflow_anchor()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_overflow_wrap(
        &self,
    ) -> longhands::overflow_wrap::computed_value::T {
        self.get_inherited_text()
            .clone_overflow_wrap()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_paint_order(
        &self,
    ) -> longhands::paint_order::computed_value::T {
        self.get_inherited_svg()
            .clone_paint_order()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_pointer_events(
        &self,
    ) -> longhands::pointer_events::computed_value::T {
        self.get_inherited_ui()
            .clone_pointer_events()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_position(
        &self,
    ) -> longhands::position::computed_value::T {
        self.get_box()
            .clone_position()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_resize(
        &self,
    ) -> longhands::resize::computed_value::T {
        self.get_box()
            .clone_resize()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_ruby_align(
        &self,
    ) -> longhands::ruby_align::computed_value::T {
        self.get_inherited_text()
            .clone_ruby_align()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_ruby_position(
        &self,
    ) -> longhands::ruby_position::computed_value::T {
        self.get_inherited_text()
            .clone_ruby_position()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_behavior(
        &self,
    ) -> longhands::scroll_behavior::computed_value::T {
        self.get_box()
            .clone_scroll_behavior()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_align(
        &self,
    ) -> longhands::scroll_snap_align::computed_value::T {
        self.get_box()
            .clone_scroll_snap_align()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_type(
        &self,
    ) -> longhands::scroll_snap_type::computed_value::T {
        self.get_box()
            .clone_scroll_snap_type()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scrollbar_width(
        &self,
    ) -> longhands::scrollbar_width::computed_value::T {
        self.get_ui()
            .clone_scrollbar_width()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_shape_rendering(
        &self,
    ) -> longhands::shape_rendering::computed_value::T {
        self.get_inherited_svg()
            .clone_shape_rendering()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_stroke_linecap(
        &self,
    ) -> longhands::stroke_linecap::computed_value::T {
        self.get_inherited_svg()
            .clone_stroke_linecap()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_stroke_linejoin(
        &self,
    ) -> longhands::stroke_linejoin::computed_value::T {
        self.get_inherited_svg()
            .clone_stroke_linejoin()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_table_layout(
        &self,
    ) -> longhands::table_layout::computed_value::T {
        self.get_table()
            .clone_table_layout()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_text_align(
        &self,
    ) -> longhands::text_align::computed_value::T {
        self.get_inherited_text()
            .clone_text_align()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_text_align_last(
        &self,
    ) -> longhands::text_align_last::computed_value::T {
        self.get_inherited_text()
            .clone_text_align_last()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_text_anchor(
        &self,
    ) -> longhands::text_anchor::computed_value::T {
        self.get_inherited_svg()
            .clone_text_anchor()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_text_combine_upright(
        &self,
    ) -> longhands::text_combine_upright::computed_value::T {
        self.get_inherited_text()
            .clone_text_combine_upright()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_text_decoration_line(
        &self,
    ) -> longhands::text_decoration_line::computed_value::T {
        self.get_text()
            .clone_text_decoration_line()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_text_decoration_style(
        &self,
    ) -> longhands::text_decoration_style::computed_value::T {
        self.get_text()
            .clone_text_decoration_style()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_text_emphasis_position(
        &self,
    ) -> longhands::text_emphasis_position::computed_value::T {
        self.get_inherited_text()
            .clone_text_emphasis_position()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_text_justify(
        &self,
    ) -> longhands::text_justify::computed_value::T {
        self.get_inherited_text()
            .clone_text_justify()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_text_orientation(
        &self,
    ) -> longhands::text_orientation::computed_value::T {
        self.get_inherited_box()
            .clone_text_orientation()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_text_rendering(
        &self,
    ) -> longhands::text_rendering::computed_value::T {
        self.get_inherited_text()
            .clone_text_rendering()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_text_transform(
        &self,
    ) -> longhands::text_transform::computed_value::T {
        self.get_inherited_text()
            .clone_text_transform()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_touch_action(
        &self,
    ) -> longhands::touch_action::computed_value::T {
        self.get_box()
            .clone_touch_action()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_transform_box(
        &self,
    ) -> longhands::transform_box::computed_value::T {
        self.get_box()
            .clone_transform_box()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_transform_style(
        &self,
    ) -> longhands::transform_style::computed_value::T {
        self.get_box()
            .clone_transform_style()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_unicode_bidi(
        &self,
    ) -> longhands::unicode_bidi::computed_value::T {
        self.get_text()
            .clone_unicode_bidi()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_vector_effect(
        &self,
    ) -> longhands::vector_effect::computed_value::T {
        self.get_svg()
            .clone_vector_effect()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_visibility(
        &self,
    ) -> longhands::visibility::computed_value::T {
        self.get_inherited_box()
            .clone_visibility()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__webkit_line_clamp(
        &self,
    ) -> longhands::_webkit_line_clamp::computed_value::T {
        self.get_box()
            .clone__webkit_line_clamp()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_white_space(
        &self,
    ) -> longhands::white_space::computed_value::T {
        self.get_inherited_text()
            .clone_white_space()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_word_break(
        &self,
    ) -> longhands::word_break::computed_value::T {
        self.get_inherited_text()
            .clone_word_break()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_writing_mode(
        &self,
    ) -> longhands::writing_mode::computed_value::T {
        self.get_inherited_box()
            .clone_writing_mode()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__x_span(
        &self,
    ) -> longhands::_x_span::computed_value::T {
        self.get_table()
            .clone__x_span()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__x_text_zoom(
        &self,
    ) -> longhands::_x_text_zoom::computed_value::T {
        self.get_font()
            .clone__x_text_zoom()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_z_index(
        &self,
    ) -> longhands::z_index::computed_value::T {
        self.get_position()
            .clone_z_index()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_break_after(
        &self,
    ) -> longhands::break_after::computed_value::T {
        self.get_box()
            .clone_break_after()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_break_before(
        &self,
    ) -> longhands::break_before::computed_value::T {
        self.get_box()
            .clone_break_before()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_clip_rule(
        &self,
    ) -> longhands::clip_rule::computed_value::T {
        self.get_inherited_svg()
            .clone_clip_rule()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_fill_rule(
        &self,
    ) -> longhands::fill_rule::computed_value::T {
        self.get_inherited_svg()
            .clone_fill_rule()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_box_ordinal_group(
        &self,
    ) -> longhands::_moz_box_ordinal_group::computed_value::T {
        self.get_xul()
            .clone__moz_box_ordinal_group()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_order(
        &self,
    ) -> longhands::order::computed_value::T {
        self.get_position()
            .clone_order()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_overflow_x(
        &self,
    ) -> longhands::overflow_x::computed_value::T {
        self.get_box()
            .clone_overflow_x()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_overflow_y(
        &self,
    ) -> longhands::overflow_y::computed_value::T {
        self.get_box()
            .clone_overflow_y()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_overflow_clip_box_block(
        &self,
    ) -> longhands::overflow_clip_box_block::computed_value::T {
        self.get_box()
            .clone_overflow_clip_box_block()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_overflow_clip_box_inline(
        &self,
    ) -> longhands::overflow_clip_box_inline::computed_value::T {
        self.get_box()
            .clone_overflow_clip_box_inline()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_overscroll_behavior_x(
        &self,
    ) -> longhands::overscroll_behavior_x::computed_value::T {
        self.get_box()
            .clone_overscroll_behavior_x()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_overscroll_behavior_y(
        &self,
    ) -> longhands::overscroll_behavior_y::computed_value::T {
        self.get_box()
            .clone_overscroll_behavior_y()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_fill_opacity(
        &self,
    ) -> longhands::fill_opacity::computed_value::T {
        self.get_inherited_svg()
            .clone_fill_opacity()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_stroke_opacity(
        &self,
    ) -> longhands::stroke_opacity::computed_value::T {
        self.get_inherited_svg()
            .clone_stroke_opacity()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_flex_grow(
        &self,
    ) -> longhands::flex_grow::computed_value::T {
        self.get_position()
            .clone_flex_grow()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_flex_shrink(
        &self,
    ) -> longhands::flex_shrink::computed_value::T {
        self.get_position()
            .clone_flex_shrink()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_box_flex(
        &self,
    ) -> longhands::_moz_box_flex::computed_value::T {
        self.get_xul()
            .clone__moz_box_flex()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_stroke_miterlimit(
        &self,
    ) -> longhands::stroke_miterlimit::computed_value::T {
        self.get_inherited_svg()
            .clone_stroke_miterlimit()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_flood_opacity(
        &self,
    ) -> longhands::flood_opacity::computed_value::T {
        self.get_svg()
            .clone_flood_opacity()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_window_opacity(
        &self,
    ) -> longhands::_moz_window_opacity::computed_value::T {
        self.get_ui()
            .clone__moz_window_opacity()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_opacity(
        &self,
    ) -> longhands::opacity::computed_value::T {
        self.get_effects()
            .clone_opacity()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_shape_image_threshold(
        &self,
    ) -> longhands::shape_image_threshold::computed_value::T {
        self.get_box()
            .clone_shape_image_threshold()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_stop_opacity(
        &self,
    ) -> longhands::stop_opacity::computed_value::T {
        self.get_svg()
            .clone_stop_opacity()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_block_end_style(
        &self,
    ) -> longhands::border_block_end_style::computed_value::T {
        self.get_border()
            .clone_border_block_end_style(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_block_start_style(
        &self,
    ) -> longhands::border_block_start_style::computed_value::T {
        self.get_border()
            .clone_border_block_start_style(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_bottom_style(
        &self,
    ) -> longhands::border_bottom_style::computed_value::T {
        self.get_border()
            .clone_border_bottom_style()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_inline_end_style(
        &self,
    ) -> longhands::border_inline_end_style::computed_value::T {
        self.get_border()
            .clone_border_inline_end_style(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_inline_start_style(
        &self,
    ) -> longhands::border_inline_start_style::computed_value::T {
        self.get_border()
            .clone_border_inline_start_style(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_left_style(
        &self,
    ) -> longhands::border_left_style::computed_value::T {
        self.get_border()
            .clone_border_left_style()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_right_style(
        &self,
    ) -> longhands::border_right_style::computed_value::T {
        self.get_border()
            .clone_border_right_style()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_top_style(
        &self,
    ) -> longhands::border_top_style::computed_value::T {
        self.get_border()
            .clone_border_top_style()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_column_rule_style(
        &self,
    ) -> longhands::column_rule_style::computed_value::T {
        self.get_column()
            .clone_column_rule_style()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_animation_delay(
        &self,
    ) -> longhands::animation_delay::computed_value::T {
        self.get_box()
            .clone_animation_delay()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_animation_direction(
        &self,
    ) -> longhands::animation_direction::computed_value::T {
        self.get_box()
            .clone_animation_direction()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_animation_duration(
        &self,
    ) -> longhands::animation_duration::computed_value::T {
        self.get_box()
            .clone_animation_duration()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_animation_fill_mode(
        &self,
    ) -> longhands::animation_fill_mode::computed_value::T {
        self.get_box()
            .clone_animation_fill_mode()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_animation_iteration_count(
        &self,
    ) -> longhands::animation_iteration_count::computed_value::T {
        self.get_box()
            .clone_animation_iteration_count()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_animation_name(
        &self,
    ) -> longhands::animation_name::computed_value::T {
        self.get_box()
            .clone_animation_name()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_animation_play_state(
        &self,
    ) -> longhands::animation_play_state::computed_value::T {
        self.get_box()
            .clone_animation_play_state()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_animation_timing_function(
        &self,
    ) -> longhands::animation_timing_function::computed_value::T {
        self.get_box()
            .clone_animation_timing_function()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_background_attachment(
        &self,
    ) -> longhands::background_attachment::computed_value::T {
        self.get_background()
            .clone_background_attachment()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_background_blend_mode(
        &self,
    ) -> longhands::background_blend_mode::computed_value::T {
        self.get_background()
            .clone_background_blend_mode()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_background_clip(
        &self,
    ) -> longhands::background_clip::computed_value::T {
        self.get_background()
            .clone_background_clip()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_background_image(
        &self,
    ) -> longhands::background_image::computed_value::T {
        self.get_background()
            .clone_background_image()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_background_origin(
        &self,
    ) -> longhands::background_origin::computed_value::T {
        self.get_background()
            .clone_background_origin()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_background_position_x(
        &self,
    ) -> longhands::background_position_x::computed_value::T {
        self.get_background()
            .clone_background_position_x()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_background_position_y(
        &self,
    ) -> longhands::background_position_y::computed_value::T {
        self.get_background()
            .clone_background_position_y()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_background_repeat(
        &self,
    ) -> longhands::background_repeat::computed_value::T {
        self.get_background()
            .clone_background_repeat()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_background_size(
        &self,
    ) -> longhands::background_size::computed_value::T {
        self.get_background()
            .clone_background_size()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_image_outset(
        &self,
    ) -> longhands::border_image_outset::computed_value::T {
        self.get_border()
            .clone_border_image_outset()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_image_slice(
        &self,
    ) -> longhands::border_image_slice::computed_value::T {
        self.get_border()
            .clone_border_image_slice()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_image_source(
        &self,
    ) -> longhands::border_image_source::computed_value::T {
        self.get_border()
            .clone_border_image_source()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_image_width(
        &self,
    ) -> longhands::border_image_width::computed_value::T {
        self.get_border()
            .clone_border_image_width()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_spacing(
        &self,
    ) -> longhands::border_spacing::computed_value::T {
        self.get_inherited_table()
            .clone_border_spacing()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_box_shadow(
        &self,
    ) -> longhands::box_shadow::computed_value::T {
        self.get_effects()
            .clone_box_shadow()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_caret_color(
        &self,
    ) -> longhands::caret_color::computed_value::T {
        self.get_inherited_ui()
            .clone_caret_color()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_clip_path(
        &self,
    ) -> longhands::clip_path::computed_value::T {
        self.get_svg()
            .clone_clip_path()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_color(
        &self,
    ) -> longhands::color::computed_value::T {
        self.get_color()
            .clone_color()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_column_width(
        &self,
    ) -> longhands::column_width::computed_value::T {
        self.get_column()
            .clone_column_width()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_content(
        &self,
    ) -> longhands::content::computed_value::T {
        self.get_counters()
            .clone_content()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_counter_increment(
        &self,
    ) -> longhands::counter_increment::computed_value::T {
        self.get_counters()
            .clone_counter_increment()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_cursor(
        &self,
    ) -> longhands::cursor::computed_value::T {
        self.get_inherited_ui()
            .clone_cursor()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_filter(
        &self,
    ) -> longhands::filter::computed_value::T {
        self.get_effects()
            .clone_filter()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_flex_basis(
        &self,
    ) -> longhands::flex_basis::computed_value::T {
        self.get_position()
            .clone_flex_basis()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_font_family(
        &self,
    ) -> longhands::font_family::computed_value::T {
        self.get_font()
            .clone_font_family()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_font_feature_settings(
        &self,
    ) -> longhands::font_feature_settings::computed_value::T {
        self.get_font()
            .clone_font_feature_settings()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_font_language_override(
        &self,
    ) -> longhands::font_language_override::computed_value::T {
        self.get_font()
            .clone_font_language_override()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_font_size(
        &self,
    ) -> longhands::font_size::computed_value::T {
        self.get_font()
            .clone_font_size()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_font_variant_alternates(
        &self,
    ) -> longhands::font_variant_alternates::computed_value::T {
        self.get_font()
            .clone_font_variant_alternates()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_font_variation_settings(
        &self,
    ) -> longhands::font_variation_settings::computed_value::T {
        self.get_font()
            .clone_font_variation_settings()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_grid_template_areas(
        &self,
    ) -> longhands::grid_template_areas::computed_value::T {
        self.get_position()
            .clone_grid_template_areas()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_letter_spacing(
        &self,
    ) -> longhands::letter_spacing::computed_value::T {
        self.get_inherited_text()
            .clone_letter_spacing()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_line_height(
        &self,
    ) -> longhands::line_height::computed_value::T {
        self.get_inherited_text()
            .clone_line_height()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_list_style_image(
        &self,
    ) -> longhands::list_style_image::computed_value::T {
        self.get_list()
            .clone_list_style_image()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_list_style_type(
        &self,
    ) -> longhands::list_style_type::computed_value::T {
        self.get_list()
            .clone_list_style_type()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_mask_clip(
        &self,
    ) -> longhands::mask_clip::computed_value::T {
        self.get_svg()
            .clone_mask_clip()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_mask_composite(
        &self,
    ) -> longhands::mask_composite::computed_value::T {
        self.get_svg()
            .clone_mask_composite()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_mask_image(
        &self,
    ) -> longhands::mask_image::computed_value::T {
        self.get_svg()
            .clone_mask_image()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_mask_mode(
        &self,
    ) -> longhands::mask_mode::computed_value::T {
        self.get_svg()
            .clone_mask_mode()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_mask_origin(
        &self,
    ) -> longhands::mask_origin::computed_value::T {
        self.get_svg()
            .clone_mask_origin()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_mask_position_x(
        &self,
    ) -> longhands::mask_position_x::computed_value::T {
        self.get_svg()
            .clone_mask_position_x()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_mask_position_y(
        &self,
    ) -> longhands::mask_position_y::computed_value::T {
        self.get_svg()
            .clone_mask_position_y()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_mask_repeat(
        &self,
    ) -> longhands::mask_repeat::computed_value::T {
        self.get_svg()
            .clone_mask_repeat()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_mask_size(
        &self,
    ) -> longhands::mask_size::computed_value::T {
        self.get_svg()
            .clone_mask_size()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_context_properties(
        &self,
    ) -> longhands::_moz_context_properties::computed_value::T {
        self.get_inherited_svg()
            .clone__moz_context_properties()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_font_smoothing_background_color(
        &self,
    ) -> longhands::_moz_font_smoothing_background_color::computed_value::T {
        self.get_font()
            .clone__moz_font_smoothing_background_color()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_tab_size(
        &self,
    ) -> longhands::_moz_tab_size::computed_value::T {
        self.get_inherited_text()
            .clone__moz_tab_size()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_offset_path(
        &self,
    ) -> longhands::offset_path::computed_value::T {
        self.get_box()
            .clone_offset_path()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_perspective(
        &self,
    ) -> longhands::perspective::computed_value::T {
        self.get_box()
            .clone_perspective()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_quotes(
        &self,
    ) -> longhands::quotes::computed_value::T {
        self.get_list()
            .clone_quotes()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_rotate(
        &self,
    ) -> longhands::rotate::computed_value::T {
        self.get_box()
            .clone_rotate()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scale(
        &self,
    ) -> longhands::scale::computed_value::T {
        self.get_box()
            .clone_scale()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_coordinate(
        &self,
    ) -> longhands::scroll_snap_coordinate::computed_value::T {
        self.get_box()
            .clone_scroll_snap_coordinate()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scrollbar_color(
        &self,
    ) -> longhands::scrollbar_color::computed_value::T {
        self.get_inherited_ui()
            .clone_scrollbar_color()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_shape_outside(
        &self,
    ) -> longhands::shape_outside::computed_value::T {
        self.get_box()
            .clone_shape_outside()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_stroke_dasharray(
        &self,
    ) -> longhands::stroke_dasharray::computed_value::T {
        self.get_inherited_svg()
            .clone_stroke_dasharray()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_stroke_dashoffset(
        &self,
    ) -> longhands::stroke_dashoffset::computed_value::T {
        self.get_inherited_svg()
            .clone_stroke_dashoffset()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_stroke_width(
        &self,
    ) -> longhands::stroke_width::computed_value::T {
        self.get_inherited_svg()
            .clone_stroke_width()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_text_emphasis_style(
        &self,
    ) -> longhands::text_emphasis_style::computed_value::T {
        self.get_inherited_text()
            .clone_text_emphasis_style()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_text_indent(
        &self,
    ) -> longhands::text_indent::computed_value::T {
        self.get_inherited_text()
            .clone_text_indent()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_text_overflow(
        &self,
    ) -> longhands::text_overflow::computed_value::T {
        self.get_text()
            .clone_text_overflow()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_text_shadow(
        &self,
    ) -> longhands::text_shadow::computed_value::T {
        self.get_inherited_text()
            .clone_text_shadow()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_transition_delay(
        &self,
    ) -> longhands::transition_delay::computed_value::T {
        self.get_box()
            .clone_transition_delay()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_transition_duration(
        &self,
    ) -> longhands::transition_duration::computed_value::T {
        self.get_box()
            .clone_transition_duration()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_transition_property(
        &self,
    ) -> longhands::transition_property::computed_value::T {
        self.get_box()
            .clone_transition_property()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_transition_timing_function(
        &self,
    ) -> longhands::transition_timing_function::computed_value::T {
        self.get_box()
            .clone_transition_timing_function()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_translate(
        &self,
    ) -> longhands::translate::computed_value::T {
        self.get_box()
            .clone_translate()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_vertical_align(
        &self,
    ) -> longhands::vertical_align::computed_value::T {
        self.get_box()
            .clone_vertical_align()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_will_change(
        &self,
    ) -> longhands::will_change::computed_value::T {
        self.get_box()
            .clone_will_change()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_word_spacing(
        &self,
    ) -> longhands::word_spacing::computed_value::T {
        self.get_inherited_text()
            .clone_word_spacing()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__x_lang(
        &self,
    ) -> longhands::_x_lang::computed_value::T {
        self.get_font()
            .clone__x_lang()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_clip(
        &self,
    ) -> longhands::clip::computed_value::T {
        self.get_effects()
            .clone_clip()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_image_region(
        &self,
    ) -> longhands::_moz_image_region::computed_value::T {
        self.get_list()
            .clone__moz_image_region()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_grid_template_columns(
        &self,
    ) -> longhands::grid_template_columns::computed_value::T {
        self.get_position()
            .clone_grid_template_columns()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_grid_template_rows(
        &self,
    ) -> longhands::grid_template_rows::computed_value::T {
        self.get_position()
            .clone_grid_template_rows()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_fill(
        &self,
    ) -> longhands::fill::computed_value::T {
        self.get_inherited_svg()
            .clone_fill()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_stroke(
        &self,
    ) -> longhands::stroke::computed_value::T {
        self.get_inherited_svg()
            .clone_stroke()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_grid_auto_columns(
        &self,
    ) -> longhands::grid_auto_columns::computed_value::T {
        self.get_position()
            .clone_grid_auto_columns()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_grid_auto_rows(
        &self,
    ) -> longhands::grid_auto_rows::computed_value::T {
        self.get_position()
            .clone_grid_auto_rows()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_window_transform_origin(
        &self,
    ) -> longhands::_moz_window_transform_origin::computed_value::T {
        self.get_ui()
            .clone__moz_window_transform_origin()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_transform_origin(
        &self,
    ) -> longhands::transform_origin::computed_value::T {
        self.get_box()
            .clone_transform_origin()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_counter_reset(
        &self,
    ) -> longhands::counter_reset::computed_value::T {
        self.get_counters()
            .clone_counter_reset()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_counter_set(
        &self,
    ) -> longhands::counter_set::computed_value::T {
        self.get_counters()
            .clone_counter_set()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_points_x(
        &self,
    ) -> longhands::scroll_snap_points_x::computed_value::T {
        self.get_box()
            .clone_scroll_snap_points_x()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_points_y(
        &self,
    ) -> longhands::scroll_snap_points_y::computed_value::T {
        self.get_box()
            .clone_scroll_snap_points_y()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_window_transform(
        &self,
    ) -> longhands::_moz_window_transform::computed_value::T {
        self.get_ui()
            .clone__moz_window_transform()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_transform(
        &self,
    ) -> longhands::transform::computed_value::T {
        self.get_box()
            .clone_transform()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_column_gap(
        &self,
    ) -> longhands::column_gap::computed_value::T {
        self.get_position()
            .clone_column_gap()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_row_gap(
        &self,
    ) -> longhands::row_gap::computed_value::T {
        self.get_position()
            .clone_row_gap()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_object_position(
        &self,
    ) -> longhands::object_position::computed_value::T {
        self.get_position()
            .clone_object_position()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_perspective_origin(
        &self,
    ) -> longhands::perspective_origin::computed_value::T {
        self.get_box()
            .clone_perspective_origin()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_destination(
        &self,
    ) -> longhands::scroll_snap_destination::computed_value::T {
        self.get_box()
            .clone_scroll_snap_destination()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_grid_column_end(
        &self,
    ) -> longhands::grid_column_end::computed_value::T {
        self.get_position()
            .clone_grid_column_end()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_grid_column_start(
        &self,
    ) -> longhands::grid_column_start::computed_value::T {
        self.get_position()
            .clone_grid_column_start()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_grid_row_end(
        &self,
    ) -> longhands::grid_row_end::computed_value::T {
        self.get_position()
            .clone_grid_row_end()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_grid_row_start(
        &self,
    ) -> longhands::grid_row_start::computed_value::T {
        self.get_position()
            .clone_grid_row_start()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_max_block_size(
        &self,
    ) -> longhands::max_block_size::computed_value::T {
        self.get_position()
            .clone_max_block_size(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_max_height(
        &self,
    ) -> longhands::max_height::computed_value::T {
        self.get_position()
            .clone_max_height()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_max_inline_size(
        &self,
    ) -> longhands::max_inline_size::computed_value::T {
        self.get_position()
            .clone_max_inline_size(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_max_width(
        &self,
    ) -> longhands::max_width::computed_value::T {
        self.get_position()
            .clone_max_width()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_marker_end(
        &self,
    ) -> longhands::marker_end::computed_value::T {
        self.get_inherited_svg()
            .clone_marker_end()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_marker_mid(
        &self,
    ) -> longhands::marker_mid::computed_value::T {
        self.get_inherited_svg()
            .clone_marker_mid()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_marker_start(
        &self,
    ) -> longhands::marker_start::computed_value::T {
        self.get_inherited_svg()
            .clone_marker_start()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_binding(
        &self,
    ) -> longhands::_moz_binding::computed_value::T {
        self.get_box()
            .clone__moz_binding()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_block_end(
        &self,
    ) -> longhands::scroll_padding_block_end::computed_value::T {
        self.get_padding()
            .clone_scroll_padding_block_end(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_block_start(
        &self,
    ) -> longhands::scroll_padding_block_start::computed_value::T {
        self.get_padding()
            .clone_scroll_padding_block_start(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_bottom(
        &self,
    ) -> longhands::scroll_padding_bottom::computed_value::T {
        self.get_padding()
            .clone_scroll_padding_bottom()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_inline_end(
        &self,
    ) -> longhands::scroll_padding_inline_end::computed_value::T {
        self.get_padding()
            .clone_scroll_padding_inline_end(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_inline_start(
        &self,
    ) -> longhands::scroll_padding_inline_start::computed_value::T {
        self.get_padding()
            .clone_scroll_padding_inline_start(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_left(
        &self,
    ) -> longhands::scroll_padding_left::computed_value::T {
        self.get_padding()
            .clone_scroll_padding_left()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_right(
        &self,
    ) -> longhands::scroll_padding_right::computed_value::T {
        self.get_padding()
            .clone_scroll_padding_right()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_top(
        &self,
    ) -> longhands::scroll_padding_top::computed_value::T {
        self.get_padding()
            .clone_scroll_padding_top()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_block_size(
        &self,
    ) -> longhands::block_size::computed_value::T {
        self.get_position()
            .clone_block_size(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_height(
        &self,
    ) -> longhands::height::computed_value::T {
        self.get_position()
            .clone_height()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_inline_size(
        &self,
    ) -> longhands::inline_size::computed_value::T {
        self.get_position()
            .clone_inline_size(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_min_block_size(
        &self,
    ) -> longhands::min_block_size::computed_value::T {
        self.get_position()
            .clone_min_block_size(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_min_height(
        &self,
    ) -> longhands::min_height::computed_value::T {
        self.get_position()
            .clone_min_height()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_min_inline_size(
        &self,
    ) -> longhands::min_inline_size::computed_value::T {
        self.get_position()
            .clone_min_inline_size(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_min_width(
        &self,
    ) -> longhands::min_width::computed_value::T {
        self.get_position()
            .clone_min_width()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_width(
        &self,
    ) -> longhands::width::computed_value::T {
        self.get_position()
            .clone_width()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_outline_offset(
        &self,
    ) -> longhands::outline_offset::computed_value::T {
        self.get_outline()
            .clone_outline_offset()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_block_end(
        &self,
    ) -> longhands::scroll_margin_block_end::computed_value::T {
        self.get_margin()
            .clone_scroll_margin_block_end(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_block_start(
        &self,
    ) -> longhands::scroll_margin_block_start::computed_value::T {
        self.get_margin()
            .clone_scroll_margin_block_start(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_bottom(
        &self,
    ) -> longhands::scroll_margin_bottom::computed_value::T {
        self.get_margin()
            .clone_scroll_margin_bottom()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_inline_end(
        &self,
    ) -> longhands::scroll_margin_inline_end::computed_value::T {
        self.get_margin()
            .clone_scroll_margin_inline_end(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_inline_start(
        &self,
    ) -> longhands::scroll_margin_inline_start::computed_value::T {
        self.get_margin()
            .clone_scroll_margin_inline_start(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_left(
        &self,
    ) -> longhands::scroll_margin_left::computed_value::T {
        self.get_margin()
            .clone_scroll_margin_left()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_right(
        &self,
    ) -> longhands::scroll_margin_right::computed_value::T {
        self.get_margin()
            .clone_scroll_margin_right()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_top(
        &self,
    ) -> longhands::scroll_margin_top::computed_value::T {
        self.get_margin()
            .clone_scroll_margin_top()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_padding_block_end(
        &self,
    ) -> longhands::padding_block_end::computed_value::T {
        self.get_padding()
            .clone_padding_block_end(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_padding_block_start(
        &self,
    ) -> longhands::padding_block_start::computed_value::T {
        self.get_padding()
            .clone_padding_block_start(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_padding_bottom(
        &self,
    ) -> longhands::padding_bottom::computed_value::T {
        self.get_padding()
            .clone_padding_bottom()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_padding_inline_end(
        &self,
    ) -> longhands::padding_inline_end::computed_value::T {
        self.get_padding()
            .clone_padding_inline_end(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_padding_inline_start(
        &self,
    ) -> longhands::padding_inline_start::computed_value::T {
        self.get_padding()
            .clone_padding_inline_start(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_padding_left(
        &self,
    ) -> longhands::padding_left::computed_value::T {
        self.get_padding()
            .clone_padding_left()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_padding_right(
        &self,
    ) -> longhands::padding_right::computed_value::T {
        self.get_padding()
            .clone_padding_right()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_padding_top(
        &self,
    ) -> longhands::padding_top::computed_value::T {
        self.get_padding()
            .clone_padding_top()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_shape_margin(
        &self,
    ) -> longhands::shape_margin::computed_value::T {
        self.get_box()
            .clone_shape_margin()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_block_end_width(
        &self,
    ) -> longhands::border_block_end_width::computed_value::T {
        self.get_border()
            .clone_border_block_end_width(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_block_start_width(
        &self,
    ) -> longhands::border_block_start_width::computed_value::T {
        self.get_border()
            .clone_border_block_start_width(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_bottom_width(
        &self,
    ) -> longhands::border_bottom_width::computed_value::T {
        self.get_border()
            .clone_border_bottom_width()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_inline_end_width(
        &self,
    ) -> longhands::border_inline_end_width::computed_value::T {
        self.get_border()
            .clone_border_inline_end_width(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_inline_start_width(
        &self,
    ) -> longhands::border_inline_start_width::computed_value::T {
        self.get_border()
            .clone_border_inline_start_width(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_left_width(
        &self,
    ) -> longhands::border_left_width::computed_value::T {
        self.get_border()
            .clone_border_left_width()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_right_width(
        &self,
    ) -> longhands::border_right_width::computed_value::T {
        self.get_border()
            .clone_border_right_width()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_top_width(
        &self,
    ) -> longhands::border_top_width::computed_value::T {
        self.get_border()
            .clone_border_top_width()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_column_rule_width(
        &self,
    ) -> longhands::column_rule_width::computed_value::T {
        self.get_column()
            .clone_column_rule_width()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_outline_width(
        &self,
    ) -> longhands::outline_width::computed_value::T {
        self.get_outline()
            .clone_outline_width()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__webkit_text_stroke_width(
        &self,
    ) -> longhands::_webkit_text_stroke_width::computed_value::T {
        self.get_inherited_text()
            .clone__webkit_text_stroke_width()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_bottom_left_radius(
        &self,
    ) -> longhands::border_bottom_left_radius::computed_value::T {
        self.get_border()
            .clone_border_bottom_left_radius()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_bottom_right_radius(
        &self,
    ) -> longhands::border_bottom_right_radius::computed_value::T {
        self.get_border()
            .clone_border_bottom_right_radius()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_end_end_radius(
        &self,
    ) -> longhands::border_end_end_radius::computed_value::T {
        self.get_border()
            .clone_border_end_end_radius(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_end_start_radius(
        &self,
    ) -> longhands::border_end_start_radius::computed_value::T {
        self.get_border()
            .clone_border_end_start_radius(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_start_end_radius(
        &self,
    ) -> longhands::border_start_end_radius::computed_value::T {
        self.get_border()
            .clone_border_start_end_radius(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_start_start_radius(
        &self,
    ) -> longhands::border_start_start_radius::computed_value::T {
        self.get_border()
            .clone_border_start_start_radius(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_top_left_radius(
        &self,
    ) -> longhands::border_top_left_radius::computed_value::T {
        self.get_border()
            .clone_border_top_left_radius()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_top_right_radius(
        &self,
    ) -> longhands::border_top_right_radius::computed_value::T {
        self.get_border()
            .clone_border_top_right_radius()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_outline_radius_bottomleft(
        &self,
    ) -> longhands::_moz_outline_radius_bottomleft::computed_value::T {
        self.get_outline()
            .clone__moz_outline_radius_bottomleft()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_outline_radius_bottomright(
        &self,
    ) -> longhands::_moz_outline_radius_bottomright::computed_value::T {
        self.get_outline()
            .clone__moz_outline_radius_bottomright()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_outline_radius_topleft(
        &self,
    ) -> longhands::_moz_outline_radius_topleft::computed_value::T {
        self.get_outline()
            .clone__moz_outline_radius_topleft()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__moz_outline_radius_topright(
        &self,
    ) -> longhands::_moz_outline_radius_topright::computed_value::T {
        self.get_outline()
            .clone__moz_outline_radius_topright()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_bottom(
        &self,
    ) -> longhands::bottom::computed_value::T {
        self.get_position()
            .clone_bottom()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_inset_block_end(
        &self,
    ) -> longhands::inset_block_end::computed_value::T {
        self.get_position()
            .clone_inset_block_end(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_inset_block_start(
        &self,
    ) -> longhands::inset_block_start::computed_value::T {
        self.get_position()
            .clone_inset_block_start(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_inset_inline_end(
        &self,
    ) -> longhands::inset_inline_end::computed_value::T {
        self.get_position()
            .clone_inset_inline_end(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_inset_inline_start(
        &self,
    ) -> longhands::inset_inline_start::computed_value::T {
        self.get_position()
            .clone_inset_inline_start(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_left(
        &self,
    ) -> longhands::left::computed_value::T {
        self.get_position()
            .clone_left()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_margin_block_end(
        &self,
    ) -> longhands::margin_block_end::computed_value::T {
        self.get_margin()
            .clone_margin_block_end(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_margin_block_start(
        &self,
    ) -> longhands::margin_block_start::computed_value::T {
        self.get_margin()
            .clone_margin_block_start(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_margin_bottom(
        &self,
    ) -> longhands::margin_bottom::computed_value::T {
        self.get_margin()
            .clone_margin_bottom()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_margin_inline_end(
        &self,
    ) -> longhands::margin_inline_end::computed_value::T {
        self.get_margin()
            .clone_margin_inline_end(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_margin_inline_start(
        &self,
    ) -> longhands::margin_inline_start::computed_value::T {
        self.get_margin()
            .clone_margin_inline_start(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_margin_left(
        &self,
    ) -> longhands::margin_left::computed_value::T {
        self.get_margin()
            .clone_margin_left()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_margin_right(
        &self,
    ) -> longhands::margin_right::computed_value::T {
        self.get_margin()
            .clone_margin_right()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_margin_top(
        &self,
    ) -> longhands::margin_top::computed_value::T {
        self.get_margin()
            .clone_margin_top()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_right(
        &self,
    ) -> longhands::right::computed_value::T {
        self.get_position()
            .clone_right()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_top(
        &self,
    ) -> longhands::top::computed_value::T {
        self.get_position()
            .clone_top()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_background_color(
        &self,
    ) -> longhands::background_color::computed_value::T {
        self.get_background()
            .clone_background_color()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_block_end_color(
        &self,
    ) -> longhands::border_block_end_color::computed_value::T {
        self.get_border()
            .clone_border_block_end_color(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_block_start_color(
        &self,
    ) -> longhands::border_block_start_color::computed_value::T {
        self.get_border()
            .clone_border_block_start_color(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_bottom_color(
        &self,
    ) -> longhands::border_bottom_color::computed_value::T {
        self.get_border()
            .clone_border_bottom_color()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_inline_end_color(
        &self,
    ) -> longhands::border_inline_end_color::computed_value::T {
        self.get_border()
            .clone_border_inline_end_color(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_inline_start_color(
        &self,
    ) -> longhands::border_inline_start_color::computed_value::T {
        self.get_border()
            .clone_border_inline_start_color(self.writing_mode)
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_left_color(
        &self,
    ) -> longhands::border_left_color::computed_value::T {
        self.get_border()
            .clone_border_left_color()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_right_color(
        &self,
    ) -> longhands::border_right_color::computed_value::T {
        self.get_border()
            .clone_border_right_color()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_border_top_color(
        &self,
    ) -> longhands::border_top_color::computed_value::T {
        self.get_border()
            .clone_border_top_color()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_column_rule_color(
        &self,
    ) -> longhands::column_rule_color::computed_value::T {
        self.get_column()
            .clone_column_rule_color()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_flood_color(
        &self,
    ) -> longhands::flood_color::computed_value::T {
        self.get_svg()
            .clone_flood_color()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_lighting_color(
        &self,
    ) -> longhands::lighting_color::computed_value::T {
        self.get_svg()
            .clone_lighting_color()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_outline_color(
        &self,
    ) -> longhands::outline_color::computed_value::T {
        self.get_outline()
            .clone_outline_color()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_stop_color(
        &self,
    ) -> longhands::stop_color::computed_value::T {
        self.get_svg()
            .clone_stop_color()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_text_decoration_color(
        &self,
    ) -> longhands::text_decoration_color::computed_value::T {
        self.get_text()
            .clone_text_decoration_color()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone_text_emphasis_color(
        &self,
    ) -> longhands::text_emphasis_color::computed_value::T {
        self.get_inherited_text()
            .clone_text_emphasis_color()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__webkit_text_fill_color(
        &self,
    ) -> longhands::_webkit_text_fill_color::computed_value::T {
        self.get_inherited_text()
            .clone__webkit_text_fill_color()
    }
    /// Gets the computed value of a given property.
    #[inline(always)]
    #[allow(non_snake_case)]
    pub fn clone__webkit_text_stroke_color(
        &self,
    ) -> longhands::_webkit_text_stroke_color::computed_value::T {
        self.get_inherited_text()
            .clone__webkit_text_stroke_color()
    }

    /// Writes the value of the given longhand as a string in `dest`.
    ///
    /// Note that the value will usually be the computed value, except for
    /// colors, where it's resolved.
    pub fn get_longhand_property_value<W>(
        &self,
        property_id: LonghandId,
        dest: &mut CssWriter<W>
    ) -> fmt::Result
    where
        W: Write,
    {
        use crate::values::resolved::ToResolvedValue;

        let context = resolved::Context {
            style: self,
        };

        // TODO(emilio): Is it worth to merge branches here just like
        // PropertyDeclaration::to_css does?
        match property_id {
            LonghandId::AlignContent => {
                let value = self.clone_align_content();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::AlignItems => {
                let value = self.clone_align_items();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::AlignSelf => {
                let value = self.clone_align_self();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BackfaceVisibility => {
                let value = self.clone_backface_visibility();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderCollapse => {
                let value = self.clone_border_collapse();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderImageRepeat => {
                let value = self.clone_border_image_repeat();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BoxDecorationBreak => {
                let value = self.clone_box_decoration_break();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BoxSizing => {
                let value = self.clone_box_sizing();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BreakInside => {
                let value = self.clone_break_inside();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::CaptionSide => {
                let value = self.clone_caption_side();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Clear => {
                let value = self.clone_clear();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ColorAdjust => {
                let value = self.clone_color_adjust();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ColorInterpolation => {
                let value = self.clone_color_interpolation();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ColorInterpolationFilters => {
                let value = self.clone_color_interpolation_filters();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ColumnCount => {
                let value = self.clone_column_count();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ColumnFill => {
                let value = self.clone_column_fill();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ColumnSpan => {
                let value = self.clone_column_span();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Contain => {
                let value = self.clone_contain();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Direction => {
                let value = self.clone_direction();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Display => {
                let value = self.clone_display();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::DominantBaseline => {
                let value = self.clone_dominant_baseline();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::EmptyCells => {
                let value = self.clone_empty_cells();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FlexDirection => {
                let value = self.clone_flex_direction();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FlexWrap => {
                let value = self.clone_flex_wrap();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Float => {
                let value = self.clone_float();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FontKerning => {
                let value = self.clone_font_kerning();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FontOpticalSizing => {
                let value = self.clone_font_optical_sizing();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FontSizeAdjust => {
                let value = self.clone_font_size_adjust();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FontStretch => {
                let value = self.clone_font_stretch();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FontStyle => {
                let value = self.clone_font_style();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FontSynthesis => {
                let value = self.clone_font_synthesis();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FontVariantCaps => {
                let value = self.clone_font_variant_caps();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FontVariantEastAsian => {
                let value = self.clone_font_variant_east_asian();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FontVariantLigatures => {
                let value = self.clone_font_variant_ligatures();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FontVariantNumeric => {
                let value = self.clone_font_variant_numeric();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FontVariantPosition => {
                let value = self.clone_font_variant_position();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FontWeight => {
                let value = self.clone_font_weight();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::GridAutoFlow => {
                let value = self.clone_grid_auto_flow();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Hyphens => {
                let value = self.clone_hyphens();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ImageOrientation => {
                let value = self.clone_image_orientation();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ImageRendering => {
                let value = self.clone_image_rendering();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ImeMode => {
                let value = self.clone_ime_mode();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::InitialLetter => {
                let value = self.clone_initial_letter();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Isolation => {
                let value = self.clone_isolation();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::JustifyContent => {
                let value = self.clone_justify_content();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::JustifyItems => {
                let value = self.clone_justify_items();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::JustifySelf => {
                let value = self.clone_justify_self();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ListStylePosition => {
                let value = self.clone_list_style_position();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MaskType => {
                let value = self.clone_mask_type();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MixBlendMode => {
                let value = self.clone_mix_blend_mode();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozAppearance => {
                let value = self.clone__moz_appearance();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozBoxAlign => {
                let value = self.clone__moz_box_align();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozBoxDirection => {
                let value = self.clone__moz_box_direction();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozBoxOrient => {
                let value = self.clone__moz_box_orient();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozBoxPack => {
                let value = self.clone__moz_box_pack();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozControlCharacterVisibility => {
                let value = self.clone__moz_control_character_visibility();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozFloatEdge => {
                let value = self.clone__moz_float_edge();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozForceBrokenImageIcon => {
                let value = self.clone__moz_force_broken_image_icon();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozListReversed => {
                let value = self.clone__moz_list_reversed();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozMathDisplay => {
                let value = self.clone__moz_math_display();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozMathVariant => {
                let value = self.clone__moz_math_variant();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozMinFontSizeRatio => {
                let value = self.clone__moz_min_font_size_ratio();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozOrient => {
                let value = self.clone__moz_orient();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozOsxFontSmoothing => {
                let value = self.clone__moz_osx_font_smoothing();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozScriptLevel => {
                let value = self.clone__moz_script_level();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozScriptMinSize => {
                let value = self.clone__moz_script_min_size();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozScriptSizeMultiplier => {
                let value = self.clone__moz_script_size_multiplier();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozStackSizing => {
                let value = self.clone__moz_stack_sizing();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozTextSizeAdjust => {
                let value = self.clone__moz_text_size_adjust();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozTopLayer => {
                let value = self.clone__moz_top_layer();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozUserFocus => {
                let value = self.clone__moz_user_focus();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozUserInput => {
                let value = self.clone__moz_user_input();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozUserModify => {
                let value = self.clone__moz_user_modify();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozUserSelect => {
                let value = self.clone__moz_user_select();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozWindowDragging => {
                let value = self.clone__moz_window_dragging();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozWindowShadow => {
                let value = self.clone__moz_window_shadow();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ObjectFit => {
                let value = self.clone_object_fit();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::OutlineStyle => {
                let value = self.clone_outline_style();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::OverflowAnchor => {
                let value = self.clone_overflow_anchor();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::OverflowWrap => {
                let value = self.clone_overflow_wrap();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::PaintOrder => {
                let value = self.clone_paint_order();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::PointerEvents => {
                let value = self.clone_pointer_events();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Position => {
                let value = self.clone_position();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Resize => {
                let value = self.clone_resize();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::RubyAlign => {
                let value = self.clone_ruby_align();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::RubyPosition => {
                let value = self.clone_ruby_position();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollBehavior => {
                let value = self.clone_scroll_behavior();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollSnapAlign => {
                let value = self.clone_scroll_snap_align();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollSnapType => {
                let value = self.clone_scroll_snap_type();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollbarWidth => {
                let value = self.clone_scrollbar_width();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ShapeRendering => {
                let value = self.clone_shape_rendering();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::StrokeLinecap => {
                let value = self.clone_stroke_linecap();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::StrokeLinejoin => {
                let value = self.clone_stroke_linejoin();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TableLayout => {
                let value = self.clone_table_layout();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TextAlign => {
                let value = self.clone_text_align();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TextAlignLast => {
                let value = self.clone_text_align_last();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TextAnchor => {
                let value = self.clone_text_anchor();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TextCombineUpright => {
                let value = self.clone_text_combine_upright();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TextDecorationLine => {
                let value = self.clone_text_decoration_line();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TextDecorationStyle => {
                let value = self.clone_text_decoration_style();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TextEmphasisPosition => {
                let value = self.clone_text_emphasis_position();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TextJustify => {
                let value = self.clone_text_justify();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TextOrientation => {
                let value = self.clone_text_orientation();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TextRendering => {
                let value = self.clone_text_rendering();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TextTransform => {
                let value = self.clone_text_transform();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TouchAction => {
                let value = self.clone_touch_action();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TransformBox => {
                let value = self.clone_transform_box();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TransformStyle => {
                let value = self.clone_transform_style();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::UnicodeBidi => {
                let value = self.clone_unicode_bidi();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::VectorEffect => {
                let value = self.clone_vector_effect();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Visibility => {
                let value = self.clone_visibility();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::WebkitLineClamp => {
                let value = self.clone__webkit_line_clamp();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::WhiteSpace => {
                let value = self.clone_white_space();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::WordBreak => {
                let value = self.clone_word_break();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::WritingMode => {
                let value = self.clone_writing_mode();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::XSpan => {
                let value = self.clone__x_span();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::XTextZoom => {
                let value = self.clone__x_text_zoom();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ZIndex => {
                let value = self.clone_z_index();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BreakAfter => {
                let value = self.clone_break_after();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BreakBefore => {
                let value = self.clone_break_before();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ClipRule => {
                let value = self.clone_clip_rule();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FillRule => {
                let value = self.clone_fill_rule();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozBoxOrdinalGroup => {
                let value = self.clone__moz_box_ordinal_group();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Order => {
                let value = self.clone_order();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::OverflowX => {
                let value = self.clone_overflow_x();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::OverflowY => {
                let value = self.clone_overflow_y();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::OverflowClipBoxBlock => {
                let value = self.clone_overflow_clip_box_block();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::OverflowClipBoxInline => {
                let value = self.clone_overflow_clip_box_inline();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::OverscrollBehaviorX => {
                let value = self.clone_overscroll_behavior_x();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::OverscrollBehaviorY => {
                let value = self.clone_overscroll_behavior_y();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FillOpacity => {
                let value = self.clone_fill_opacity();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::StrokeOpacity => {
                let value = self.clone_stroke_opacity();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FlexGrow => {
                let value = self.clone_flex_grow();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FlexShrink => {
                let value = self.clone_flex_shrink();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozBoxFlex => {
                let value = self.clone__moz_box_flex();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::StrokeMiterlimit => {
                let value = self.clone_stroke_miterlimit();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FloodOpacity => {
                let value = self.clone_flood_opacity();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozWindowOpacity => {
                let value = self.clone__moz_window_opacity();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Opacity => {
                let value = self.clone_opacity();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ShapeImageThreshold => {
                let value = self.clone_shape_image_threshold();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::StopOpacity => {
                let value = self.clone_stop_opacity();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderBlockEndStyle => {
                let value = self.clone_border_block_end_style();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderBlockStartStyle => {
                let value = self.clone_border_block_start_style();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderBottomStyle => {
                let value = self.clone_border_bottom_style();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderInlineEndStyle => {
                let value = self.clone_border_inline_end_style();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderInlineStartStyle => {
                let value = self.clone_border_inline_start_style();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderLeftStyle => {
                let value = self.clone_border_left_style();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderRightStyle => {
                let value = self.clone_border_right_style();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderTopStyle => {
                let value = self.clone_border_top_style();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ColumnRuleStyle => {
                let value = self.clone_column_rule_style();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::AnimationDelay => {
                let value = self.clone_animation_delay();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::AnimationDirection => {
                let value = self.clone_animation_direction();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::AnimationDuration => {
                let value = self.clone_animation_duration();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::AnimationFillMode => {
                let value = self.clone_animation_fill_mode();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::AnimationIterationCount => {
                let value = self.clone_animation_iteration_count();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::AnimationName => {
                let value = self.clone_animation_name();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::AnimationPlayState => {
                let value = self.clone_animation_play_state();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::AnimationTimingFunction => {
                let value = self.clone_animation_timing_function();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BackgroundAttachment => {
                let value = self.clone_background_attachment();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BackgroundBlendMode => {
                let value = self.clone_background_blend_mode();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BackgroundClip => {
                let value = self.clone_background_clip();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BackgroundImage => {
                let value = self.clone_background_image();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BackgroundOrigin => {
                let value = self.clone_background_origin();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BackgroundPositionX => {
                let value = self.clone_background_position_x();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BackgroundPositionY => {
                let value = self.clone_background_position_y();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BackgroundRepeat => {
                let value = self.clone_background_repeat();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BackgroundSize => {
                let value = self.clone_background_size();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderImageOutset => {
                let value = self.clone_border_image_outset();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderImageSlice => {
                let value = self.clone_border_image_slice();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderImageSource => {
                let value = self.clone_border_image_source();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderImageWidth => {
                let value = self.clone_border_image_width();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderSpacing => {
                let value = self.clone_border_spacing();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BoxShadow => {
                let value = self.clone_box_shadow();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::CaretColor => {
                let value = self.clone_caret_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ClipPath => {
                let value = self.clone_clip_path();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Color => {
                let value = self.clone_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ColumnWidth => {
                let value = self.clone_column_width();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Content => {
                let value = self.clone_content();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::CounterIncrement => {
                let value = self.clone_counter_increment();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Cursor => {
                let value = self.clone_cursor();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Filter => {
                let value = self.clone_filter();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FlexBasis => {
                let value = self.clone_flex_basis();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FontFamily => {
                let value = self.clone_font_family();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FontFeatureSettings => {
                let value = self.clone_font_feature_settings();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FontLanguageOverride => {
                let value = self.clone_font_language_override();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FontSize => {
                let value = self.clone_font_size();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FontVariantAlternates => {
                let value = self.clone_font_variant_alternates();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FontVariationSettings => {
                let value = self.clone_font_variation_settings();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::GridTemplateAreas => {
                let value = self.clone_grid_template_areas();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::LetterSpacing => {
                let value = self.clone_letter_spacing();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::LineHeight => {
                let value = self.clone_line_height();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ListStyleImage => {
                let value = self.clone_list_style_image();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ListStyleType => {
                let value = self.clone_list_style_type();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MaskClip => {
                let value = self.clone_mask_clip();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MaskComposite => {
                let value = self.clone_mask_composite();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MaskImage => {
                let value = self.clone_mask_image();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MaskMode => {
                let value = self.clone_mask_mode();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MaskOrigin => {
                let value = self.clone_mask_origin();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MaskPositionX => {
                let value = self.clone_mask_position_x();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MaskPositionY => {
                let value = self.clone_mask_position_y();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MaskRepeat => {
                let value = self.clone_mask_repeat();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MaskSize => {
                let value = self.clone_mask_size();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozContextProperties => {
                let value = self.clone__moz_context_properties();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozFontSmoothingBackgroundColor => {
                let value = self.clone__moz_font_smoothing_background_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozTabSize => {
                let value = self.clone__moz_tab_size();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::OffsetPath => {
                let value = self.clone_offset_path();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Perspective => {
                let value = self.clone_perspective();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Quotes => {
                let value = self.clone_quotes();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Rotate => {
                let value = self.clone_rotate();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Scale => {
                let value = self.clone_scale();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollSnapCoordinate => {
                let value = self.clone_scroll_snap_coordinate();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollbarColor => {
                let value = self.clone_scrollbar_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ShapeOutside => {
                let value = self.clone_shape_outside();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::StrokeDasharray => {
                let value = self.clone_stroke_dasharray();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::StrokeDashoffset => {
                let value = self.clone_stroke_dashoffset();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::StrokeWidth => {
                let value = self.clone_stroke_width();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TextEmphasisStyle => {
                let value = self.clone_text_emphasis_style();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TextIndent => {
                let value = self.clone_text_indent();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TextOverflow => {
                let value = self.clone_text_overflow();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TextShadow => {
                let value = self.clone_text_shadow();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TransitionDelay => {
                let value = self.clone_transition_delay();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TransitionDuration => {
                let value = self.clone_transition_duration();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TransitionProperty => {
                let value = self.clone_transition_property();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TransitionTimingFunction => {
                let value = self.clone_transition_timing_function();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Translate => {
                let value = self.clone_translate();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::VerticalAlign => {
                let value = self.clone_vertical_align();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::WillChange => {
                let value = self.clone_will_change();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::WordSpacing => {
                let value = self.clone_word_spacing();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::XLang => {
                let value = self.clone__x_lang();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Clip => {
                let value = self.clone_clip();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozImageRegion => {
                let value = self.clone__moz_image_region();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::GridTemplateColumns => {
                let value = self.clone_grid_template_columns();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::GridTemplateRows => {
                let value = self.clone_grid_template_rows();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Fill => {
                let value = self.clone_fill();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Stroke => {
                let value = self.clone_stroke();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::GridAutoColumns => {
                let value = self.clone_grid_auto_columns();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::GridAutoRows => {
                let value = self.clone_grid_auto_rows();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozWindowTransformOrigin => {
                let value = self.clone__moz_window_transform_origin();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TransformOrigin => {
                let value = self.clone_transform_origin();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::CounterReset => {
                let value = self.clone_counter_reset();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::CounterSet => {
                let value = self.clone_counter_set();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollSnapPointsX => {
                let value = self.clone_scroll_snap_points_x();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollSnapPointsY => {
                let value = self.clone_scroll_snap_points_y();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozWindowTransform => {
                let value = self.clone__moz_window_transform();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Transform => {
                let value = self.clone_transform();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ColumnGap => {
                let value = self.clone_column_gap();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::RowGap => {
                let value = self.clone_row_gap();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ObjectPosition => {
                let value = self.clone_object_position();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::PerspectiveOrigin => {
                let value = self.clone_perspective_origin();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollSnapDestination => {
                let value = self.clone_scroll_snap_destination();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::GridColumnEnd => {
                let value = self.clone_grid_column_end();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::GridColumnStart => {
                let value = self.clone_grid_column_start();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::GridRowEnd => {
                let value = self.clone_grid_row_end();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::GridRowStart => {
                let value = self.clone_grid_row_start();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MaxBlockSize => {
                let value = self.clone_max_block_size();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MaxHeight => {
                let value = self.clone_max_height();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MaxInlineSize => {
                let value = self.clone_max_inline_size();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MaxWidth => {
                let value = self.clone_max_width();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MarkerEnd => {
                let value = self.clone_marker_end();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MarkerMid => {
                let value = self.clone_marker_mid();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MarkerStart => {
                let value = self.clone_marker_start();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozBinding => {
                let value = self.clone__moz_binding();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollPaddingBlockEnd => {
                let value = self.clone_scroll_padding_block_end();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollPaddingBlockStart => {
                let value = self.clone_scroll_padding_block_start();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollPaddingBottom => {
                let value = self.clone_scroll_padding_bottom();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollPaddingInlineEnd => {
                let value = self.clone_scroll_padding_inline_end();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollPaddingInlineStart => {
                let value = self.clone_scroll_padding_inline_start();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollPaddingLeft => {
                let value = self.clone_scroll_padding_left();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollPaddingRight => {
                let value = self.clone_scroll_padding_right();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollPaddingTop => {
                let value = self.clone_scroll_padding_top();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BlockSize => {
                let value = self.clone_block_size();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Height => {
                let value = self.clone_height();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::InlineSize => {
                let value = self.clone_inline_size();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MinBlockSize => {
                let value = self.clone_min_block_size();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MinHeight => {
                let value = self.clone_min_height();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MinInlineSize => {
                let value = self.clone_min_inline_size();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MinWidth => {
                let value = self.clone_min_width();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Width => {
                let value = self.clone_width();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::OutlineOffset => {
                let value = self.clone_outline_offset();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollMarginBlockEnd => {
                let value = self.clone_scroll_margin_block_end();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollMarginBlockStart => {
                let value = self.clone_scroll_margin_block_start();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollMarginBottom => {
                let value = self.clone_scroll_margin_bottom();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollMarginInlineEnd => {
                let value = self.clone_scroll_margin_inline_end();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollMarginInlineStart => {
                let value = self.clone_scroll_margin_inline_start();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollMarginLeft => {
                let value = self.clone_scroll_margin_left();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollMarginRight => {
                let value = self.clone_scroll_margin_right();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ScrollMarginTop => {
                let value = self.clone_scroll_margin_top();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::PaddingBlockEnd => {
                let value = self.clone_padding_block_end();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::PaddingBlockStart => {
                let value = self.clone_padding_block_start();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::PaddingBottom => {
                let value = self.clone_padding_bottom();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::PaddingInlineEnd => {
                let value = self.clone_padding_inline_end();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::PaddingInlineStart => {
                let value = self.clone_padding_inline_start();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::PaddingLeft => {
                let value = self.clone_padding_left();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::PaddingRight => {
                let value = self.clone_padding_right();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::PaddingTop => {
                let value = self.clone_padding_top();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ShapeMargin => {
                let value = self.clone_shape_margin();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderBlockEndWidth => {
                let value = self.clone_border_block_end_width();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderBlockStartWidth => {
                let value = self.clone_border_block_start_width();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderBottomWidth => {
                let value = self.clone_border_bottom_width();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderInlineEndWidth => {
                let value = self.clone_border_inline_end_width();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderInlineStartWidth => {
                let value = self.clone_border_inline_start_width();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderLeftWidth => {
                let value = self.clone_border_left_width();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderRightWidth => {
                let value = self.clone_border_right_width();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderTopWidth => {
                let value = self.clone_border_top_width();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ColumnRuleWidth => {
                let value = self.clone_column_rule_width();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::OutlineWidth => {
                let value = self.clone_outline_width();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::WebkitTextStrokeWidth => {
                let value = self.clone__webkit_text_stroke_width();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderBottomLeftRadius => {
                let value = self.clone_border_bottom_left_radius();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderBottomRightRadius => {
                let value = self.clone_border_bottom_right_radius();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderEndEndRadius => {
                let value = self.clone_border_end_end_radius();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderEndStartRadius => {
                let value = self.clone_border_end_start_radius();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderStartEndRadius => {
                let value = self.clone_border_start_end_radius();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderStartStartRadius => {
                let value = self.clone_border_start_start_radius();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderTopLeftRadius => {
                let value = self.clone_border_top_left_radius();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderTopRightRadius => {
                let value = self.clone_border_top_right_radius();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozOutlineRadiusBottomleft => {
                let value = self.clone__moz_outline_radius_bottomleft();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozOutlineRadiusBottomright => {
                let value = self.clone__moz_outline_radius_bottomright();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozOutlineRadiusTopleft => {
                let value = self.clone__moz_outline_radius_topleft();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MozOutlineRadiusTopright => {
                let value = self.clone__moz_outline_radius_topright();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Bottom => {
                let value = self.clone_bottom();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::InsetBlockEnd => {
                let value = self.clone_inset_block_end();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::InsetBlockStart => {
                let value = self.clone_inset_block_start();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::InsetInlineEnd => {
                let value = self.clone_inset_inline_end();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::InsetInlineStart => {
                let value = self.clone_inset_inline_start();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Left => {
                let value = self.clone_left();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MarginBlockEnd => {
                let value = self.clone_margin_block_end();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MarginBlockStart => {
                let value = self.clone_margin_block_start();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MarginBottom => {
                let value = self.clone_margin_bottom();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MarginInlineEnd => {
                let value = self.clone_margin_inline_end();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MarginInlineStart => {
                let value = self.clone_margin_inline_start();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MarginLeft => {
                let value = self.clone_margin_left();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MarginRight => {
                let value = self.clone_margin_right();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::MarginTop => {
                let value = self.clone_margin_top();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Right => {
                let value = self.clone_right();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::Top => {
                let value = self.clone_top();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BackgroundColor => {
                let value = self.clone_background_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderBlockEndColor => {
                let value = self.clone_border_block_end_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderBlockStartColor => {
                let value = self.clone_border_block_start_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderBottomColor => {
                let value = self.clone_border_bottom_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderInlineEndColor => {
                let value = self.clone_border_inline_end_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderInlineStartColor => {
                let value = self.clone_border_inline_start_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderLeftColor => {
                let value = self.clone_border_left_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderRightColor => {
                let value = self.clone_border_right_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::BorderTopColor => {
                let value = self.clone_border_top_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::ColumnRuleColor => {
                let value = self.clone_column_rule_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::FloodColor => {
                let value = self.clone_flood_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::LightingColor => {
                let value = self.clone_lighting_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::OutlineColor => {
                let value = self.clone_outline_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::StopColor => {
                let value = self.clone_stop_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TextDecorationColor => {
                let value = self.clone_text_decoration_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::TextEmphasisColor => {
                let value = self.clone_text_emphasis_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::WebkitTextFillColor => {
                let value = self.clone__webkit_text_fill_color();
                value.to_resolved_value(&context).to_css(dest)
            }
            LonghandId::WebkitTextStrokeColor => {
                let value = self.clone__webkit_text_stroke_color();
                value.to_resolved_value(&context).to_css(dest)
            }
        }
    }

    /// Resolves the currentColor keyword.
    ///
    /// Any color value from computed values (except for the 'color' property
    /// itself) should go through this method.
    ///
    /// Usage example:
    /// let top_color =
    ///   style.resolve_color(style.get_border().clone_border_top_color());
    #[inline]
    pub fn resolve_color(&self, color: computed::Color) -> RGBA {
        color.to_rgba(self.get_color().clone_color())
    }
}

#[cfg(feature = "servo")]
impl ComputedValues {
    /// Create a new refcounted `ComputedValues`
    pub fn new(
        _: Option<&PseudoElement>,
        custom_properties: Option<Arc<crate::custom_properties::CustomPropertiesMap>>,
        writing_mode: WritingMode,
        flags: ComputedValueFlags,
        rules: Option<StrongRuleNode>,
        visited_style: Option<Arc<ComputedValues>>,
        background: Arc<style_structs::Background>,
        border: Arc<style_structs::Border>,
        box_: Arc<style_structs::Box>,
        color: Arc<style_structs::Color>,
        column: Arc<style_structs::Column>,
        counters: Arc<style_structs::Counters>,
        effects: Arc<style_structs::Effects>,
        font: Arc<style_structs::Font>,
        inherited_box: Arc<style_structs::InheritedBox>,
        inherited_table: Arc<style_structs::InheritedTable>,
        inherited_text: Arc<style_structs::InheritedText>,
        inherited_ui: Arc<style_structs::InheritedUI>,
        inherited_svg: Arc<style_structs::InheritedSVG>,
        list: Arc<style_structs::List>,
        margin: Arc<style_structs::Margin>,
        outline: Arc<style_structs::Outline>,
        padding: Arc<style_structs::Padding>,
        position: Arc<style_structs::Position>,
        table: Arc<style_structs::Table>,
        text: Arc<style_structs::Text>,
        ui: Arc<style_structs::UI>,
        svg: Arc<style_structs::SVG>,
        xul: Arc<style_structs::XUL>,
    ) -> Arc<Self> {
        Arc::new(Self {
            inner: ComputedValuesInner {
                custom_properties,
                writing_mode,
                rules,
                visited_style,
                flags,
                background,
                border,
                box_,
                color,
                column,
                counters,
                effects,
                font,
                inherited_box,
                inherited_table,
                inherited_text,
                inherited_ui,
                inherited_svg,
                list,
                margin,
                outline,
                padding,
                position,
                table,
                text,
                ui,
                svg,
                xul,
            }
        })
    }

    /// Get the initial computed values.
    pub fn initial_values() -> &'static Self { &*INITIAL_SERVO_VALUES }

    /// Serializes the computed value of this property as a string.
    pub fn computed_value_to_string(&self, property: PropertyDeclarationId) -> String {
        match property {
            PropertyDeclarationId::Longhand(id) => {
                let mut s = String::new();
                self.get_longhand_property_value(
                    id,
                    &mut CssWriter::new(&mut s)
                ).unwrap();
                s
            }
            PropertyDeclarationId::Custom(name) => {
                self.custom_properties
                    .as_ref()
                    .and_then(|map| map.get(name))
                    .map_or(String::new(), |value| value.to_css_string())
            }
        }
    }
}

#[cfg(feature = "servo")]
impl ops::Deref for ComputedValues {
    type Target = ComputedValuesInner;
    fn deref(&self) -> &ComputedValuesInner {
        &self.inner
    }
}

#[cfg(feature = "servo")]
impl ops::DerefMut for ComputedValues {
    fn deref_mut(&mut self) -> &mut ComputedValuesInner {
        &mut self.inner
    }
}

#[cfg(feature = "servo")]
impl ComputedValuesInner {
        /// Clone the Background struct.
        #[inline]
        pub fn clone_background(&self) -> Arc<style_structs::Background> {
            self.background.clone()
        }

        /// Get a immutable reference to the Background struct.
        #[inline]
        pub fn get_background(&self) -> &style_structs::Background {
            &self.background
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `Background`.
        pub fn background_arc(&self) -> &Arc<style_structs::Background> {
            &self.background
        }

        /// Get a mutable reference to the Background struct.
        #[inline]
        pub fn mutate_background(&mut self) -> &mut style_structs::Background {
            Arc::make_mut(&mut self.background)
        }
        /// Clone the Border struct.
        #[inline]
        pub fn clone_border(&self) -> Arc<style_structs::Border> {
            self.border.clone()
        }

        /// Get a immutable reference to the Border struct.
        #[inline]
        pub fn get_border(&self) -> &style_structs::Border {
            &self.border
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `Border`.
        pub fn border_arc(&self) -> &Arc<style_structs::Border> {
            &self.border
        }

        /// Get a mutable reference to the Border struct.
        #[inline]
        pub fn mutate_border(&mut self) -> &mut style_structs::Border {
            Arc::make_mut(&mut self.border)
        }
        /// Clone the Box struct.
        #[inline]
        pub fn clone_box(&self) -> Arc<style_structs::Box> {
            self.box_.clone()
        }

        /// Get a immutable reference to the Box struct.
        #[inline]
        pub fn get_box(&self) -> &style_structs::Box {
            &self.box_
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `Box`.
        pub fn box_arc(&self) -> &Arc<style_structs::Box> {
            &self.box_
        }

        /// Get a mutable reference to the Box struct.
        #[inline]
        pub fn mutate_box(&mut self) -> &mut style_structs::Box {
            Arc::make_mut(&mut self.box_)
        }
        /// Clone the Color struct.
        #[inline]
        pub fn clone_color(&self) -> Arc<style_structs::Color> {
            self.color.clone()
        }

        /// Get a immutable reference to the Color struct.
        #[inline]
        pub fn get_color(&self) -> &style_structs::Color {
            &self.color
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `Color`.
        pub fn color_arc(&self) -> &Arc<style_structs::Color> {
            &self.color
        }

        /// Get a mutable reference to the Color struct.
        #[inline]
        pub fn mutate_color(&mut self) -> &mut style_structs::Color {
            Arc::make_mut(&mut self.color)
        }
        /// Clone the Column struct.
        #[inline]
        pub fn clone_column(&self) -> Arc<style_structs::Column> {
            self.column.clone()
        }

        /// Get a immutable reference to the Column struct.
        #[inline]
        pub fn get_column(&self) -> &style_structs::Column {
            &self.column
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `Column`.
        pub fn column_arc(&self) -> &Arc<style_structs::Column> {
            &self.column
        }

        /// Get a mutable reference to the Column struct.
        #[inline]
        pub fn mutate_column(&mut self) -> &mut style_structs::Column {
            Arc::make_mut(&mut self.column)
        }
        /// Clone the Counters struct.
        #[inline]
        pub fn clone_counters(&self) -> Arc<style_structs::Counters> {
            self.counters.clone()
        }

        /// Get a immutable reference to the Counters struct.
        #[inline]
        pub fn get_counters(&self) -> &style_structs::Counters {
            &self.counters
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `Counters`.
        pub fn counters_arc(&self) -> &Arc<style_structs::Counters> {
            &self.counters
        }

        /// Get a mutable reference to the Counters struct.
        #[inline]
        pub fn mutate_counters(&mut self) -> &mut style_structs::Counters {
            Arc::make_mut(&mut self.counters)
        }
        /// Clone the Effects struct.
        #[inline]
        pub fn clone_effects(&self) -> Arc<style_structs::Effects> {
            self.effects.clone()
        }

        /// Get a immutable reference to the Effects struct.
        #[inline]
        pub fn get_effects(&self) -> &style_structs::Effects {
            &self.effects
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `Effects`.
        pub fn effects_arc(&self) -> &Arc<style_structs::Effects> {
            &self.effects
        }

        /// Get a mutable reference to the Effects struct.
        #[inline]
        pub fn mutate_effects(&mut self) -> &mut style_structs::Effects {
            Arc::make_mut(&mut self.effects)
        }
        /// Clone the Font struct.
        #[inline]
        pub fn clone_font(&self) -> Arc<style_structs::Font> {
            self.font.clone()
        }

        /// Get a immutable reference to the Font struct.
        #[inline]
        pub fn get_font(&self) -> &style_structs::Font {
            &self.font
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `Font`.
        pub fn font_arc(&self) -> &Arc<style_structs::Font> {
            &self.font
        }

        /// Get a mutable reference to the Font struct.
        #[inline]
        pub fn mutate_font(&mut self) -> &mut style_structs::Font {
            Arc::make_mut(&mut self.font)
        }
        /// Clone the InheritedBox struct.
        #[inline]
        pub fn clone_inherited_box(&self) -> Arc<style_structs::InheritedBox> {
            self.inherited_box.clone()
        }

        /// Get a immutable reference to the InheritedBox struct.
        #[inline]
        pub fn get_inherited_box(&self) -> &style_structs::InheritedBox {
            &self.inherited_box
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `InheritedBox`.
        pub fn inherited_box_arc(&self) -> &Arc<style_structs::InheritedBox> {
            &self.inherited_box
        }

        /// Get a mutable reference to the InheritedBox struct.
        #[inline]
        pub fn mutate_inherited_box(&mut self) -> &mut style_structs::InheritedBox {
            Arc::make_mut(&mut self.inherited_box)
        }
        /// Clone the InheritedTable struct.
        #[inline]
        pub fn clone_inherited_table(&self) -> Arc<style_structs::InheritedTable> {
            self.inherited_table.clone()
        }

        /// Get a immutable reference to the InheritedTable struct.
        #[inline]
        pub fn get_inherited_table(&self) -> &style_structs::InheritedTable {
            &self.inherited_table
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `InheritedTable`.
        pub fn inherited_table_arc(&self) -> &Arc<style_structs::InheritedTable> {
            &self.inherited_table
        }

        /// Get a mutable reference to the InheritedTable struct.
        #[inline]
        pub fn mutate_inherited_table(&mut self) -> &mut style_structs::InheritedTable {
            Arc::make_mut(&mut self.inherited_table)
        }
        /// Clone the InheritedText struct.
        #[inline]
        pub fn clone_inherited_text(&self) -> Arc<style_structs::InheritedText> {
            self.inherited_text.clone()
        }

        /// Get a immutable reference to the InheritedText struct.
        #[inline]
        pub fn get_inherited_text(&self) -> &style_structs::InheritedText {
            &self.inherited_text
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `InheritedText`.
        pub fn inherited_text_arc(&self) -> &Arc<style_structs::InheritedText> {
            &self.inherited_text
        }

        /// Get a mutable reference to the InheritedText struct.
        #[inline]
        pub fn mutate_inherited_text(&mut self) -> &mut style_structs::InheritedText {
            Arc::make_mut(&mut self.inherited_text)
        }
        /// Clone the InheritedUI struct.
        #[inline]
        pub fn clone_inherited_ui(&self) -> Arc<style_structs::InheritedUI> {
            self.inherited_ui.clone()
        }

        /// Get a immutable reference to the InheritedUI struct.
        #[inline]
        pub fn get_inherited_ui(&self) -> &style_structs::InheritedUI {
            &self.inherited_ui
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `InheritedUI`.
        pub fn inherited_ui_arc(&self) -> &Arc<style_structs::InheritedUI> {
            &self.inherited_ui
        }

        /// Get a mutable reference to the InheritedUI struct.
        #[inline]
        pub fn mutate_inherited_ui(&mut self) -> &mut style_structs::InheritedUI {
            Arc::make_mut(&mut self.inherited_ui)
        }
        /// Clone the InheritedSVG struct.
        #[inline]
        pub fn clone_inherited_svg(&self) -> Arc<style_structs::InheritedSVG> {
            self.inherited_svg.clone()
        }

        /// Get a immutable reference to the InheritedSVG struct.
        #[inline]
        pub fn get_inherited_svg(&self) -> &style_structs::InheritedSVG {
            &self.inherited_svg
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `InheritedSVG`.
        pub fn inherited_svg_arc(&self) -> &Arc<style_structs::InheritedSVG> {
            &self.inherited_svg
        }

        /// Get a mutable reference to the InheritedSVG struct.
        #[inline]
        pub fn mutate_inherited_svg(&mut self) -> &mut style_structs::InheritedSVG {
            Arc::make_mut(&mut self.inherited_svg)
        }
        /// Clone the List struct.
        #[inline]
        pub fn clone_list(&self) -> Arc<style_structs::List> {
            self.list.clone()
        }

        /// Get a immutable reference to the List struct.
        #[inline]
        pub fn get_list(&self) -> &style_structs::List {
            &self.list
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `List`.
        pub fn list_arc(&self) -> &Arc<style_structs::List> {
            &self.list
        }

        /// Get a mutable reference to the List struct.
        #[inline]
        pub fn mutate_list(&mut self) -> &mut style_structs::List {
            Arc::make_mut(&mut self.list)
        }
        /// Clone the Margin struct.
        #[inline]
        pub fn clone_margin(&self) -> Arc<style_structs::Margin> {
            self.margin.clone()
        }

        /// Get a immutable reference to the Margin struct.
        #[inline]
        pub fn get_margin(&self) -> &style_structs::Margin {
            &self.margin
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `Margin`.
        pub fn margin_arc(&self) -> &Arc<style_structs::Margin> {
            &self.margin
        }

        /// Get a mutable reference to the Margin struct.
        #[inline]
        pub fn mutate_margin(&mut self) -> &mut style_structs::Margin {
            Arc::make_mut(&mut self.margin)
        }
        /// Clone the Outline struct.
        #[inline]
        pub fn clone_outline(&self) -> Arc<style_structs::Outline> {
            self.outline.clone()
        }

        /// Get a immutable reference to the Outline struct.
        #[inline]
        pub fn get_outline(&self) -> &style_structs::Outline {
            &self.outline
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `Outline`.
        pub fn outline_arc(&self) -> &Arc<style_structs::Outline> {
            &self.outline
        }

        /// Get a mutable reference to the Outline struct.
        #[inline]
        pub fn mutate_outline(&mut self) -> &mut style_structs::Outline {
            Arc::make_mut(&mut self.outline)
        }
        /// Clone the Padding struct.
        #[inline]
        pub fn clone_padding(&self) -> Arc<style_structs::Padding> {
            self.padding.clone()
        }

        /// Get a immutable reference to the Padding struct.
        #[inline]
        pub fn get_padding(&self) -> &style_structs::Padding {
            &self.padding
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `Padding`.
        pub fn padding_arc(&self) -> &Arc<style_structs::Padding> {
            &self.padding
        }

        /// Get a mutable reference to the Padding struct.
        #[inline]
        pub fn mutate_padding(&mut self) -> &mut style_structs::Padding {
            Arc::make_mut(&mut self.padding)
        }
        /// Clone the Position struct.
        #[inline]
        pub fn clone_position(&self) -> Arc<style_structs::Position> {
            self.position.clone()
        }

        /// Get a immutable reference to the Position struct.
        #[inline]
        pub fn get_position(&self) -> &style_structs::Position {
            &self.position
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `Position`.
        pub fn position_arc(&self) -> &Arc<style_structs::Position> {
            &self.position
        }

        /// Get a mutable reference to the Position struct.
        #[inline]
        pub fn mutate_position(&mut self) -> &mut style_structs::Position {
            Arc::make_mut(&mut self.position)
        }
        /// Clone the Table struct.
        #[inline]
        pub fn clone_table(&self) -> Arc<style_structs::Table> {
            self.table.clone()
        }

        /// Get a immutable reference to the Table struct.
        #[inline]
        pub fn get_table(&self) -> &style_structs::Table {
            &self.table
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `Table`.
        pub fn table_arc(&self) -> &Arc<style_structs::Table> {
            &self.table
        }

        /// Get a mutable reference to the Table struct.
        #[inline]
        pub fn mutate_table(&mut self) -> &mut style_structs::Table {
            Arc::make_mut(&mut self.table)
        }
        /// Clone the Text struct.
        #[inline]
        pub fn clone_text(&self) -> Arc<style_structs::Text> {
            self.text.clone()
        }

        /// Get a immutable reference to the Text struct.
        #[inline]
        pub fn get_text(&self) -> &style_structs::Text {
            &self.text
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `Text`.
        pub fn text_arc(&self) -> &Arc<style_structs::Text> {
            &self.text
        }

        /// Get a mutable reference to the Text struct.
        #[inline]
        pub fn mutate_text(&mut self) -> &mut style_structs::Text {
            Arc::make_mut(&mut self.text)
        }
        /// Clone the UI struct.
        #[inline]
        pub fn clone_ui(&self) -> Arc<style_structs::UI> {
            self.ui.clone()
        }

        /// Get a immutable reference to the UI struct.
        #[inline]
        pub fn get_ui(&self) -> &style_structs::UI {
            &self.ui
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `UI`.
        pub fn ui_arc(&self) -> &Arc<style_structs::UI> {
            &self.ui
        }

        /// Get a mutable reference to the UI struct.
        #[inline]
        pub fn mutate_ui(&mut self) -> &mut style_structs::UI {
            Arc::make_mut(&mut self.ui)
        }
        /// Clone the SVG struct.
        #[inline]
        pub fn clone_svg(&self) -> Arc<style_structs::SVG> {
            self.svg.clone()
        }

        /// Get a immutable reference to the SVG struct.
        #[inline]
        pub fn get_svg(&self) -> &style_structs::SVG {
            &self.svg
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `SVG`.
        pub fn svg_arc(&self) -> &Arc<style_structs::SVG> {
            &self.svg
        }

        /// Get a mutable reference to the SVG struct.
        #[inline]
        pub fn mutate_svg(&mut self) -> &mut style_structs::SVG {
            Arc::make_mut(&mut self.svg)
        }
        /// Clone the XUL struct.
        #[inline]
        pub fn clone_xul(&self) -> Arc<style_structs::XUL> {
            self.xul.clone()
        }

        /// Get a immutable reference to the XUL struct.
        #[inline]
        pub fn get_xul(&self) -> &style_structs::XUL {
            &self.xul
        }

        /// Gets an immutable reference to the refcounted value that wraps
        /// `XUL`.
        pub fn xul_arc(&self) -> &Arc<style_structs::XUL> {
            &self.xul
        }

        /// Get a mutable reference to the XUL struct.
        #[inline]
        pub fn mutate_xul(&mut self) -> &mut style_structs::XUL {
            Arc::make_mut(&mut self.xul)
        }

    /// Gets a reference to the rule node. Panic if no rule node exists.
    pub fn rules(&self) -> &StrongRuleNode {
        self.rules.as_ref().unwrap()
    }

    /// Whether this style has a -moz-binding value. This is always false for
    /// Servo for obvious reasons.
    pub fn has_moz_binding(&self) -> bool { false }

    #[inline]
    /// Returns whether the "content" property for the given style is completely
    /// ineffective, and would yield an empty `::before` or `::after`
    /// pseudo-element.
    pub fn ineffective_content_property(&self) -> bool {
        use crate::values::generics::counters::Content;
        match self.get_counters().content {
            Content::Normal | Content::None => true,
            Content::Items(ref items) => items.is_empty(),
        }
    }

    /// Whether the current style or any of its ancestors is multicolumn.
    #[inline]
    pub fn can_be_fragmented(&self) -> bool {
        self.flags.contains(ComputedValueFlags::CAN_BE_FRAGMENTED)
    }

    /// Whether the current style is multicolumn.
    #[inline]
    pub fn is_multicol(&self) -> bool {
        self.get_column().is_multicol()
    }

    /// Get the logical computed inline size.
    #[inline]
    pub fn content_inline_size(&self) -> computed::Size {
        let position_style = self.get_position();
        if self.writing_mode.is_vertical() {
            position_style.height
        } else {
            position_style.width
        }
    }

    /// Get the logical computed block size.
    #[inline]
    pub fn content_block_size(&self) -> computed::Size {
        let position_style = self.get_position();
        if self.writing_mode.is_vertical() { position_style.width } else { position_style.height }
    }

    /// Get the logical computed min inline size.
    #[inline]
    pub fn min_inline_size(&self) -> computed::Size {
        let position_style = self.get_position();
        if self.writing_mode.is_vertical() { position_style.min_height } else { position_style.min_width }
    }

    /// Get the logical computed min block size.
    #[inline]
    pub fn min_block_size(&self) -> computed::Size {
        let position_style = self.get_position();
        if self.writing_mode.is_vertical() { position_style.min_width } else { position_style.min_height }
    }

    /// Get the logical computed max inline size.
    #[inline]
    pub fn max_inline_size(&self) -> computed::MaxSize {
        let position_style = self.get_position();
        if self.writing_mode.is_vertical() { position_style.max_height } else { position_style.max_width }
    }

    /// Get the logical computed max block size.
    #[inline]
    pub fn max_block_size(&self) -> computed::MaxSize {
        let position_style = self.get_position();
        if self.writing_mode.is_vertical() { position_style.max_width } else { position_style.max_height }
    }

    /// Get the logical computed padding for this writing mode.
    #[inline]
    pub fn logical_padding(&self) -> LogicalMargin<computed::LengthPercentage> {
        let padding_style = self.get_padding();
        LogicalMargin::from_physical(self.writing_mode, SideOffsets2D::new(
            padding_style.padding_top.0,
            padding_style.padding_right.0,
            padding_style.padding_bottom.0,
            padding_style.padding_left.0,
        ))
    }

    /// Get the logical border width
    #[inline]
    pub fn border_width_for_writing_mode(&self, writing_mode: WritingMode) -> LogicalMargin<Au> {
        let border_style = self.get_border();
        LogicalMargin::from_physical(writing_mode, SideOffsets2D::new(
            Au::from(border_style.border_top_width),
            Au::from(border_style.border_right_width),
            Au::from(border_style.border_bottom_width),
            Au::from(border_style.border_left_width),
        ))
    }

    /// Gets the logical computed border widths for this style.
    #[inline]
    pub fn logical_border_width(&self) -> LogicalMargin<Au> {
        self.border_width_for_writing_mode(self.writing_mode)
    }

    /// Gets the logical computed margin from this style.
    #[inline]
    pub fn logical_margin(&self) -> LogicalMargin<computed::LengthPercentageOrAuto> {
        let margin_style = self.get_margin();
        LogicalMargin::from_physical(self.writing_mode, SideOffsets2D::new(
            margin_style.margin_top,
            margin_style.margin_right,
            margin_style.margin_bottom,
            margin_style.margin_left,
        ))
    }

    /// Gets the logical position from this style.
    #[inline]
    pub fn logical_position(&self) -> LogicalMargin<computed::LengthPercentageOrAuto> {
        // FIXME(SimonSapin): should be the writing mode of the containing block, maybe?
        let position_style = self.get_position();
        LogicalMargin::from_physical(self.writing_mode, SideOffsets2D::new(
            position_style.top,
            position_style.right,
            position_style.bottom,
            position_style.left,
        ))
    }

    /// Return true if the effects force the transform style to be Flat
    pub fn overrides_transform_style(&self) -> bool {
        use crate::computed_values::mix_blend_mode::T as MixBlendMode;

        let effects = self.get_effects();
        // TODO(gw): Add clip-path, isolation, mask-image, mask-border-source when supported.
        effects.opacity < 1.0 ||
           !effects.filter.0.is_empty() ||
           !effects.clip.is_auto() ||
           effects.mix_blend_mode != MixBlendMode::Normal
    }

    /// <https://drafts.csswg.org/css-transforms/#grouping-property-values>
    pub fn get_used_transform_style(&self) -> computed_values::transform_style::T {
        use crate::computed_values::transform_style::T as TransformStyle;

        let box_ = self.get_box();

        if self.overrides_transform_style() {
            TransformStyle::Flat
        } else {
            // Return the computed value if not overridden by the above exceptions
            box_.transform_style
        }
    }

    /// Whether given this transform value, the compositor would require a
    /// layer.
    pub fn transform_requires_layer(&self) -> bool {
        use crate::values::generics::transform::TransformOperation;
        // Check if the transform matrix is 2D or 3D
        for transform in &self.get_box().transform.0 {
            match *transform {
                TransformOperation::Perspective(..) => {
                    return true;
                }
                TransformOperation::Matrix3D(m) => {
                    // See http://dev.w3.org/csswg/css-transforms/#2d-matrix
                    if m.m31 != 0.0 || m.m32 != 0.0 ||
                       m.m13 != 0.0 || m.m23 != 0.0 ||
                       m.m43 != 0.0 || m.m14 != 0.0 ||
                       m.m24 != 0.0 || m.m34 != 0.0 ||
                       m.m33 != 1.0 || m.m44 != 1.0 {
                        return true;
                    }
                }
                TransformOperation::Translate3D(_, _, z) |
                TransformOperation::TranslateZ(z) => {
                    if z.px() != 0. {
                        return true;
                    }
                }
                _ => {}
            }
        }

        // Neither perspective nor transform present
        false
    }
}

    pub use crate::servo_arc::RawOffsetArc as BuilderArc;
    /// Clone an arc, returning a regular arc
    fn clone_arc<T: 'static>(x: &BuilderArc<T>) -> Arc<T> {
        Arc::from_raw_offset(x.clone())
    }

/// A reference to a style struct of the parent, or our own style struct.
pub enum StyleStructRef<'a, T: 'static> {
    /// A borrowed struct from the parent, for example, for inheriting style.
    Borrowed(&'a BuilderArc<T>),
    /// An owned struct, that we've already mutated.
    Owned(UniqueArc<T>),
    /// Temporarily vacated, will panic if accessed
    Vacated,
}

impl<'a, T: 'a> StyleStructRef<'a, T>
where
    T: Clone,
{
    /// Ensure a mutable reference of this value exists, either cloning the
    /// borrowed value, or returning the owned one.
    pub fn mutate(&mut self) -> &mut T {
        if let StyleStructRef::Borrowed(v) = *self {
            *self = StyleStructRef::Owned(UniqueArc::new((**v).clone()));
        }

        match *self {
            StyleStructRef::Owned(ref mut v) => v,
            StyleStructRef::Borrowed(..) => unreachable!(),
            StyleStructRef::Vacated => panic!("Accessed vacated style struct")
        }
    }

    /// Whether this is pointer-equal to the struct we're going to copy the
    /// value from.
    ///
    /// This is used to avoid allocations when people write stuff like `font:
    /// inherit` or such `all: initial`.
    #[inline]
    pub fn ptr_eq(&self, struct_to_copy_from: &T) -> bool {
        match *self {
            StyleStructRef::Owned(..) => false,
            StyleStructRef::Borrowed(arc) => {
                &**arc as *const T == struct_to_copy_from as *const T
            }
            StyleStructRef::Vacated => panic!("Accessed vacated style struct")
        }
    }

    /// Extract a unique Arc from this struct, vacating it.
    ///
    /// The vacated state is a transient one, please put the Arc back
    /// when done via `put()`. This function is to be used to separate
    /// the struct being mutated from the computed context
    pub fn take(&mut self) -> UniqueArc<T> {
        use std::mem::replace;
        let inner = replace(self, StyleStructRef::Vacated);

        match inner {
            StyleStructRef::Owned(arc) => arc,
            StyleStructRef::Borrowed(arc) => UniqueArc::new((**arc).clone()),
            StyleStructRef::Vacated => panic!("Accessed vacated style struct"),
        }
    }

    /// Replace vacated ref with an arc
    pub fn put(&mut self, arc: UniqueArc<T>) {
        debug_assert!(matches!(*self, StyleStructRef::Vacated));
        *self = StyleStructRef::Owned(arc);
    }

    /// Get a mutable reference to the owned struct, or `None` if the struct
    /// hasn't been mutated.
    pub fn get_if_mutated(&mut self) -> Option<&mut T> {
        match *self {
            StyleStructRef::Owned(ref mut v) => Some(v),
            StyleStructRef::Borrowed(..) => None,
            StyleStructRef::Vacated => panic!("Accessed vacated style struct")
        }
    }

    /// Returns an `Arc` to the internal struct, constructing one if
    /// appropriate.
    pub fn build(self) -> Arc<T> {
        match self {
            StyleStructRef::Owned(v) => v.shareable(),
            StyleStructRef::Borrowed(v) => clone_arc(v),
            StyleStructRef::Vacated => panic!("Accessed vacated style struct")
        }
    }
}

impl<'a, T: 'a> ops::Deref for StyleStructRef<'a, T> {
    type Target = T;

    fn deref(&self) -> &T {
        match *self {
            StyleStructRef::Owned(ref v) => &**v,
            StyleStructRef::Borrowed(v) => &**v,
            StyleStructRef::Vacated => panic!("Accessed vacated style struct")
        }
    }
}

/// A type used to compute a struct with minimal overhead.
///
/// This allows holding references to the parent/default computed values without
/// actually cloning them, until we either build the style, or mutate the
/// inherited value.
pub struct StyleBuilder<'a> {
    /// The device we're using to compute style.
    ///
    /// This provides access to viewport unit ratios, etc.
    pub device: &'a Device,

    /// The style we're inheriting from.
    ///
    /// This is effectively
    /// `parent_style.unwrap_or(device.default_computed_values())`.
    inherited_style: &'a ComputedValues,

    /// The style we're inheriting from for properties that don't inherit from
    /// ::first-line.  This is the same as inherited_style, unless
    /// inherited_style is a ::first-line style.
    inherited_style_ignoring_first_line: &'a ComputedValues,

    /// The style we're getting reset structs from.
    reset_style: &'a ComputedValues,

    /// The rule node representing the ordered list of rules matched for this
    /// node.
    pub rules: Option<StrongRuleNode>,

    custom_properties: Option<Arc<crate::custom_properties::CustomPropertiesMap>>,

    /// The pseudo-element this style will represent.
    pub pseudo: Option<&'a PseudoElement>,

    /// Whether we have mutated any reset structs since the the last time
    /// `clear_modified_reset` was called.  This is used to tell whether the
    /// `StyleAdjuster` did any work.
    modified_reset: bool,

    /// The writing mode flags.
    ///
    /// TODO(emilio): Make private.
    pub writing_mode: WritingMode,

    /// Flags for the computed value.
    pub flags: Cell<ComputedValueFlags>,

    /// The element's style if visited, only computed if there's a relevant link
    /// for this element.  A element's "relevant link" is the element being
    /// matched if it is a link or the nearest ancestor link.
    visited_style: Option<Arc<ComputedValues>>,
        background: StyleStructRef<'a, style_structs::Background>,
        border: StyleStructRef<'a, style_structs::Border>,
        box_: StyleStructRef<'a, style_structs::Box>,
        color: StyleStructRef<'a, style_structs::Color>,
        column: StyleStructRef<'a, style_structs::Column>,
        counters: StyleStructRef<'a, style_structs::Counters>,
        effects: StyleStructRef<'a, style_structs::Effects>,
        font: StyleStructRef<'a, style_structs::Font>,
        inherited_box: StyleStructRef<'a, style_structs::InheritedBox>,
        inherited_table: StyleStructRef<'a, style_structs::InheritedTable>,
        inherited_text: StyleStructRef<'a, style_structs::InheritedText>,
        inherited_ui: StyleStructRef<'a, style_structs::InheritedUI>,
        inherited_svg: StyleStructRef<'a, style_structs::InheritedSVG>,
        list: StyleStructRef<'a, style_structs::List>,
        margin: StyleStructRef<'a, style_structs::Margin>,
        outline: StyleStructRef<'a, style_structs::Outline>,
        padding: StyleStructRef<'a, style_structs::Padding>,
        position: StyleStructRef<'a, style_structs::Position>,
        table: StyleStructRef<'a, style_structs::Table>,
        text: StyleStructRef<'a, style_structs::Text>,
        ui: StyleStructRef<'a, style_structs::UI>,
        svg: StyleStructRef<'a, style_structs::SVG>,
        xul: StyleStructRef<'a, style_structs::XUL>,
}

impl<'a> StyleBuilder<'a> {
    /// Trivially construct a `StyleBuilder`.
    fn new(
        device: &'a Device,
        parent_style: Option<&'a ComputedValues>,
        parent_style_ignoring_first_line: Option<&'a ComputedValues>,
        pseudo: Option<&'a PseudoElement>,
        rules: Option<StrongRuleNode>,
        custom_properties: Option<Arc<crate::custom_properties::CustomPropertiesMap>>,
    ) -> Self {
        debug_assert_eq!(parent_style.is_some(), parent_style_ignoring_first_line.is_some());
        #[cfg(feature = "gecko")]
        debug_assert!(parent_style.is_none() ||
                      std::ptr::eq(parent_style.unwrap(),
                                     parent_style_ignoring_first_line.unwrap()) ||
                      parent_style.unwrap().is_first_line_style());
        let reset_style = device.default_computed_values();
        let inherited_style = parent_style.unwrap_or(reset_style);
        let inherited_style_ignoring_first_line = parent_style_ignoring_first_line.unwrap_or(reset_style);

        let flags = inherited_style.flags.inherited();

        StyleBuilder {
            device,
            inherited_style,
            inherited_style_ignoring_first_line,
            reset_style,
            pseudo,
            rules,
            modified_reset: false,
            custom_properties,
            writing_mode: inherited_style.writing_mode,
            flags: Cell::new(flags),
            visited_style: None,
            background: StyleStructRef::Borrowed(reset_style.background_arc()),
            border: StyleStructRef::Borrowed(reset_style.border_arc()),
            box_: StyleStructRef::Borrowed(reset_style.box_arc()),
            color: StyleStructRef::Borrowed(inherited_style.color_arc()),
            column: StyleStructRef::Borrowed(reset_style.column_arc()),
            counters: StyleStructRef::Borrowed(reset_style.counters_arc()),
            effects: StyleStructRef::Borrowed(reset_style.effects_arc()),
            font: StyleStructRef::Borrowed(inherited_style.font_arc()),
            inherited_box: StyleStructRef::Borrowed(inherited_style.inherited_box_arc()),
            inherited_table: StyleStructRef::Borrowed(inherited_style.inherited_table_arc()),
            inherited_text: StyleStructRef::Borrowed(inherited_style.inherited_text_arc()),
            inherited_ui: StyleStructRef::Borrowed(inherited_style.inherited_ui_arc()),
            inherited_svg: StyleStructRef::Borrowed(inherited_style.inherited_svg_arc()),
            list: StyleStructRef::Borrowed(inherited_style.list_arc()),
            margin: StyleStructRef::Borrowed(reset_style.margin_arc()),
            outline: StyleStructRef::Borrowed(reset_style.outline_arc()),
            padding: StyleStructRef::Borrowed(reset_style.padding_arc()),
            position: StyleStructRef::Borrowed(reset_style.position_arc()),
            table: StyleStructRef::Borrowed(reset_style.table_arc()),
            text: StyleStructRef::Borrowed(reset_style.text_arc()),
            ui: StyleStructRef::Borrowed(reset_style.ui_arc()),
            svg: StyleStructRef::Borrowed(reset_style.svg_arc()),
            xul: StyleStructRef::Borrowed(reset_style.xul_arc()),
        }
    }

    /// NOTE(emilio): This is done so we can compute relative units with respect
    /// to the parent style, but all the early properties / writing-mode / etc
    /// are already set to the right ones on the kid.
    ///
    /// Do _not_ actually call this to construct a style, this should mostly be
    /// used for animations.
    pub fn for_animation(
        device: &'a Device,
        style_to_derive_from: &'a ComputedValues,
        parent_style: Option<&'a ComputedValues>,
    ) -> Self {
        let reset_style = device.default_computed_values();
        let inherited_style = parent_style.unwrap_or(reset_style);
        #[cfg(feature = "gecko")]
        debug_assert!(parent_style.is_none() ||
                      !parent_style.unwrap().is_first_line_style());
        StyleBuilder {
            device,
            inherited_style,
            // None of our callers pass in ::first-line parent styles.
            inherited_style_ignoring_first_line: inherited_style,
            reset_style,
            pseudo: None,
            modified_reset: false,
            rules: None,
            custom_properties: style_to_derive_from.custom_properties().cloned(),
            writing_mode: style_to_derive_from.writing_mode,
            flags: Cell::new(style_to_derive_from.flags),
            visited_style: None,
            background: StyleStructRef::Borrowed(
                style_to_derive_from.background_arc()
            ),
            border: StyleStructRef::Borrowed(
                style_to_derive_from.border_arc()
            ),
            box_: StyleStructRef::Borrowed(
                style_to_derive_from.box_arc()
            ),
            color: StyleStructRef::Borrowed(
                style_to_derive_from.color_arc()
            ),
            column: StyleStructRef::Borrowed(
                style_to_derive_from.column_arc()
            ),
            counters: StyleStructRef::Borrowed(
                style_to_derive_from.counters_arc()
            ),
            effects: StyleStructRef::Borrowed(
                style_to_derive_from.effects_arc()
            ),
            font: StyleStructRef::Borrowed(
                style_to_derive_from.font_arc()
            ),
            inherited_box: StyleStructRef::Borrowed(
                style_to_derive_from.inherited_box_arc()
            ),
            inherited_table: StyleStructRef::Borrowed(
                style_to_derive_from.inherited_table_arc()
            ),
            inherited_text: StyleStructRef::Borrowed(
                style_to_derive_from.inherited_text_arc()
            ),
            inherited_ui: StyleStructRef::Borrowed(
                style_to_derive_from.inherited_ui_arc()
            ),
            inherited_svg: StyleStructRef::Borrowed(
                style_to_derive_from.inherited_svg_arc()
            ),
            list: StyleStructRef::Borrowed(
                style_to_derive_from.list_arc()
            ),
            margin: StyleStructRef::Borrowed(
                style_to_derive_from.margin_arc()
            ),
            outline: StyleStructRef::Borrowed(
                style_to_derive_from.outline_arc()
            ),
            padding: StyleStructRef::Borrowed(
                style_to_derive_from.padding_arc()
            ),
            position: StyleStructRef::Borrowed(
                style_to_derive_from.position_arc()
            ),
            table: StyleStructRef::Borrowed(
                style_to_derive_from.table_arc()
            ),
            text: StyleStructRef::Borrowed(
                style_to_derive_from.text_arc()
            ),
            ui: StyleStructRef::Borrowed(
                style_to_derive_from.ui_arc()
            ),
            svg: StyleStructRef::Borrowed(
                style_to_derive_from.svg_arc()
            ),
            xul: StyleStructRef::Borrowed(
                style_to_derive_from.xul_arc()
            ),
        }
    }

    /// Copy the reset properties from `style`.
    pub fn copy_reset_from(&mut self, style: &'a ComputedValues) {
        self.background =
            StyleStructRef::Borrowed(style.background_arc());
        self.border =
            StyleStructRef::Borrowed(style.border_arc());
        self.box_ =
            StyleStructRef::Borrowed(style.box_arc());
        self.column =
            StyleStructRef::Borrowed(style.column_arc());
        self.counters =
            StyleStructRef::Borrowed(style.counters_arc());
        self.effects =
            StyleStructRef::Borrowed(style.effects_arc());
        self.margin =
            StyleStructRef::Borrowed(style.margin_arc());
        self.outline =
            StyleStructRef::Borrowed(style.outline_arc());
        self.padding =
            StyleStructRef::Borrowed(style.padding_arc());
        self.position =
            StyleStructRef::Borrowed(style.position_arc());
        self.table =
            StyleStructRef::Borrowed(style.table_arc());
        self.text =
            StyleStructRef::Borrowed(style.text_arc());
        self.ui =
            StyleStructRef::Borrowed(style.ui_arc());
        self.svg =
            StyleStructRef::Borrowed(style.svg_arc());
        self.xul =
            StyleStructRef::Borrowed(style.xul_arc());
    }

    /// Inherit `align_content` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_align_content(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_align_content_from(
                inherited_struct,
            );
    }

    /// Set the `align_content` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_align_content(
        &mut self,
        value: longhands::align_content::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_align_content(
                value,
            );
    }
    /// Inherit `align_items` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_align_items(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_align_items_from(
                inherited_struct,
            );
    }

    /// Set the `align_items` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_align_items(
        &mut self,
        value: longhands::align_items::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_align_items(
                value,
            );
    }
    /// Inherit `align_self` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_align_self(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_align_self_from(
                inherited_struct,
            );
    }

    /// Set the `align_self` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_align_self(
        &mut self,
        value: longhands::align_self::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_align_self(
                value,
            );
    }
    /// Inherit `backface_visibility` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_backface_visibility(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_backface_visibility_from(
                inherited_struct,
            );
    }

    /// Set the `backface_visibility` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_backface_visibility(
        &mut self,
        value: longhands::backface_visibility::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_backface_visibility(
                value,
            );
    }
    /// Reset `border_collapse` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_border_collapse(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_table();

        if self.inherited_table.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_table.mutate()
            .reset_border_collapse(
                reset_struct,
            );
    }

    /// Set the `border_collapse` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_collapse(
        &mut self,
        value: longhands::border_collapse::computed_value::T
    ) {

        self.inherited_table.mutate()
            .set_border_collapse(
                value,
            );
    }
    /// Inherit `border_image_repeat` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_image_repeat(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_image_repeat_from(
                inherited_struct,
            );
    }

    /// Set the `border_image_repeat` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_image_repeat(
        &mut self,
        value: longhands::border_image_repeat::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_image_repeat(
                value,
            );
    }
    /// Inherit `box_decoration_break` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_box_decoration_break(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_box_decoration_break_from(
                inherited_struct,
            );
    }

    /// Set the `box_decoration_break` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_box_decoration_break(
        &mut self,
        value: longhands::box_decoration_break::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_box_decoration_break(
                value,
            );
    }
    /// Inherit `box_sizing` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_box_sizing(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_box_sizing_from(
                inherited_struct,
            );
    }

    /// Set the `box_sizing` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_box_sizing(
        &mut self,
        value: longhands::box_sizing::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_box_sizing(
                value,
            );
    }
    /// Inherit `break_inside` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_break_inside(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_break_inside_from(
                inherited_struct,
            );
    }

    /// Set the `break_inside` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_break_inside(
        &mut self,
        value: longhands::break_inside::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_break_inside(
                value,
            );
    }
    /// Reset `caption_side` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_caption_side(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_table();

        if self.inherited_table.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_table.mutate()
            .reset_caption_side(
                reset_struct,
            );
    }

    /// Set the `caption_side` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_caption_side(
        &mut self,
        value: longhands::caption_side::computed_value::T
    ) {

        self.inherited_table.mutate()
            .set_caption_side(
                value,
            );
    }
    /// Inherit `clear` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_clear(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_clear_from(
                inherited_struct,
            );
    }

    /// Set the `clear` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_clear(
        &mut self,
        value: longhands::clear::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_clear(
                value,
            );
    }
    /// Reset `color_adjust` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_color_adjust(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_box();

        if self.inherited_box.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_box.mutate()
            .reset_color_adjust(
                reset_struct,
            );
    }

    /// Set the `color_adjust` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_color_adjust(
        &mut self,
        value: longhands::color_adjust::computed_value::T
    ) {

        self.inherited_box.mutate()
            .set_color_adjust(
                value,
            );
    }
    /// Reset `color_interpolation` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_color_interpolation(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_color_interpolation(
                reset_struct,
            );
    }

    /// Set the `color_interpolation` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_color_interpolation(
        &mut self,
        value: longhands::color_interpolation::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_color_interpolation(
                value,
            );
    }
    /// Reset `color_interpolation_filters` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_color_interpolation_filters(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_color_interpolation_filters(
                reset_struct,
            );
    }

    /// Set the `color_interpolation_filters` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_color_interpolation_filters(
        &mut self,
        value: longhands::color_interpolation_filters::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_color_interpolation_filters(
                value,
            );
    }
    /// Inherit `column_count` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_column_count(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_column();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.column.ptr_eq(inherited_struct) {
            return;
        }

        self.column.mutate()
            .copy_column_count_from(
                inherited_struct,
            );
    }

    /// Set the `column_count` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_column_count(
        &mut self,
        value: longhands::column_count::computed_value::T
    ) {
        self.modified_reset = true;

        self.column.mutate()
            .set_column_count(
                value,
            );
    }
    /// Inherit `column_fill` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_column_fill(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_column();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.column.ptr_eq(inherited_struct) {
            return;
        }

        self.column.mutate()
            .copy_column_fill_from(
                inherited_struct,
            );
    }

    /// Set the `column_fill` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_column_fill(
        &mut self,
        value: longhands::column_fill::computed_value::T
    ) {
        self.modified_reset = true;

        self.column.mutate()
            .set_column_fill(
                value,
            );
    }
    /// Inherit `column_span` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_column_span(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_column();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.column.ptr_eq(inherited_struct) {
            return;
        }

        self.column.mutate()
            .copy_column_span_from(
                inherited_struct,
            );
    }

    /// Set the `column_span` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_column_span(
        &mut self,
        value: longhands::column_span::computed_value::T
    ) {
        self.modified_reset = true;

        self.column.mutate()
            .set_column_span(
                value,
            );
    }
    /// Inherit `contain` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_contain(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_contain_from(
                inherited_struct,
            );
    }

    /// Set the `contain` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_contain(
        &mut self,
        value: longhands::contain::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_contain(
                value,
            );
    }
    /// Reset `direction` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_direction(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_box();

        if self.inherited_box.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_box.mutate()
            .reset_direction(
                reset_struct,
            );
    }

    /// Set the `direction` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_direction(
        &mut self,
        value: longhands::direction::computed_value::T
    ) {

        self.inherited_box.mutate()
            .set_direction(
                value,
            );
    }
    /// Inherit `display` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_display(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);


        self.add_flags(ComputedValueFlags::INHERITS_DISPLAY);

        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_display_from(
                inherited_struct,
            );
    }

    /// Set the `display` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_display(
        &mut self,
        value: longhands::display::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_display(
                value,
            );
    }
    /// Inherit `dominant_baseline` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_dominant_baseline(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_svg();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.svg.ptr_eq(inherited_struct) {
            return;
        }

        self.svg.mutate()
            .copy_dominant_baseline_from(
                inherited_struct,
            );
    }

    /// Set the `dominant_baseline` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_dominant_baseline(
        &mut self,
        value: longhands::dominant_baseline::computed_value::T
    ) {
        self.modified_reset = true;

        self.svg.mutate()
            .set_dominant_baseline(
                value,
            );
    }
    /// Reset `empty_cells` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_empty_cells(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_table();

        if self.inherited_table.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_table.mutate()
            .reset_empty_cells(
                reset_struct,
            );
    }

    /// Set the `empty_cells` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_empty_cells(
        &mut self,
        value: longhands::empty_cells::computed_value::T
    ) {

        self.inherited_table.mutate()
            .set_empty_cells(
                value,
            );
    }
    /// Inherit `flex_direction` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_flex_direction(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_flex_direction_from(
                inherited_struct,
            );
    }

    /// Set the `flex_direction` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_flex_direction(
        &mut self,
        value: longhands::flex_direction::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_flex_direction(
                value,
            );
    }
    /// Inherit `flex_wrap` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_flex_wrap(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_flex_wrap_from(
                inherited_struct,
            );
    }

    /// Set the `flex_wrap` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_flex_wrap(
        &mut self,
        value: longhands::flex_wrap::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_flex_wrap(
                value,
            );
    }
    /// Inherit `float` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_float(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_float_from(
                inherited_struct,
            );
    }

    /// Set the `float` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_float(
        &mut self,
        value: longhands::float::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_float(
                value,
            );
    }
    /// Reset `font_kerning` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_font_kerning(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset_font_kerning(
                reset_struct,
            );
    }

    /// Set the `font_kerning` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_font_kerning(
        &mut self,
        value: longhands::font_kerning::computed_value::T
    ) {

        self.font.mutate()
            .set_font_kerning(
                value,
            );
    }
    /// Reset `font_optical_sizing` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_font_optical_sizing(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset_font_optical_sizing(
                reset_struct,
            );
    }

    /// Set the `font_optical_sizing` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_font_optical_sizing(
        &mut self,
        value: longhands::font_optical_sizing::computed_value::T
    ) {

        self.font.mutate()
            .set_font_optical_sizing(
                value,
            );
    }
    /// Reset `font_size_adjust` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_font_size_adjust(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset_font_size_adjust(
                reset_struct,
            );
    }

    /// Set the `font_size_adjust` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_font_size_adjust(
        &mut self,
        value: longhands::font_size_adjust::computed_value::T
    ) {

        self.font.mutate()
            .set_font_size_adjust(
                value,
            );
    }
    /// Reset `font_stretch` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_font_stretch(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset_font_stretch(
                reset_struct,
            );
    }

    /// Set the `font_stretch` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_font_stretch(
        &mut self,
        value: longhands::font_stretch::computed_value::T
    ) {

        self.font.mutate()
            .set_font_stretch(
                value,
            );
    }
    /// Reset `font_style` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_font_style(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset_font_style(
                reset_struct,
            );
    }

    /// Set the `font_style` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_font_style(
        &mut self,
        value: longhands::font_style::computed_value::T
    ) {

        self.font.mutate()
            .set_font_style(
                value,
            );
    }
    /// Reset `font_synthesis` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_font_synthesis(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset_font_synthesis(
                reset_struct,
            );
    }

    /// Set the `font_synthesis` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_font_synthesis(
        &mut self,
        value: longhands::font_synthesis::computed_value::T
    ) {

        self.font.mutate()
            .set_font_synthesis(
                value,
            );
    }
    /// Reset `font_variant_caps` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_font_variant_caps(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset_font_variant_caps(
                reset_struct,
            );
    }

    /// Set the `font_variant_caps` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_font_variant_caps(
        &mut self,
        value: longhands::font_variant_caps::computed_value::T
    ) {

        self.font.mutate()
            .set_font_variant_caps(
                value,
            );
    }
    /// Reset `font_variant_east_asian` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_font_variant_east_asian(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset_font_variant_east_asian(
                reset_struct,
            );
    }

    /// Set the `font_variant_east_asian` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_font_variant_east_asian(
        &mut self,
        value: longhands::font_variant_east_asian::computed_value::T
    ) {

        self.font.mutate()
            .set_font_variant_east_asian(
                value,
            );
    }
    /// Reset `font_variant_ligatures` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_font_variant_ligatures(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset_font_variant_ligatures(
                reset_struct,
            );
    }

    /// Set the `font_variant_ligatures` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_font_variant_ligatures(
        &mut self,
        value: longhands::font_variant_ligatures::computed_value::T
    ) {

        self.font.mutate()
            .set_font_variant_ligatures(
                value,
            );
    }
    /// Reset `font_variant_numeric` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_font_variant_numeric(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset_font_variant_numeric(
                reset_struct,
            );
    }

    /// Set the `font_variant_numeric` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_font_variant_numeric(
        &mut self,
        value: longhands::font_variant_numeric::computed_value::T
    ) {

        self.font.mutate()
            .set_font_variant_numeric(
                value,
            );
    }
    /// Reset `font_variant_position` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_font_variant_position(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset_font_variant_position(
                reset_struct,
            );
    }

    /// Set the `font_variant_position` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_font_variant_position(
        &mut self,
        value: longhands::font_variant_position::computed_value::T
    ) {

        self.font.mutate()
            .set_font_variant_position(
                value,
            );
    }
    /// Reset `font_weight` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_font_weight(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset_font_weight(
                reset_struct,
            );
    }

    /// Set the `font_weight` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_font_weight(
        &mut self,
        value: longhands::font_weight::computed_value::T
    ) {

        self.font.mutate()
            .set_font_weight(
                value,
            );
    }
    /// Inherit `grid_auto_flow` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_grid_auto_flow(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_grid_auto_flow_from(
                inherited_struct,
            );
    }

    /// Set the `grid_auto_flow` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_grid_auto_flow(
        &mut self,
        value: longhands::grid_auto_flow::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_grid_auto_flow(
                value,
            );
    }
    /// Reset `hyphens` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_hyphens(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_hyphens(
                reset_struct,
            );
    }

    /// Set the `hyphens` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_hyphens(
        &mut self,
        value: longhands::hyphens::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_hyphens(
                value,
            );
    }
    /// Reset `image_orientation` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_image_orientation(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_box();

        if self.inherited_box.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_box.mutate()
            .reset_image_orientation(
                reset_struct,
            );
    }

    /// Set the `image_orientation` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_image_orientation(
        &mut self,
        value: longhands::image_orientation::computed_value::T
    ) {

        self.inherited_box.mutate()
            .set_image_orientation(
                value,
            );
    }
    /// Reset `image_rendering` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_image_rendering(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_box();

        if self.inherited_box.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_box.mutate()
            .reset_image_rendering(
                reset_struct,
            );
    }

    /// Set the `image_rendering` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_image_rendering(
        &mut self,
        value: longhands::image_rendering::computed_value::T
    ) {

        self.inherited_box.mutate()
            .set_image_rendering(
                value,
            );
    }
    /// Inherit `ime_mode` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_ime_mode(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_ui();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.ui.ptr_eq(inherited_struct) {
            return;
        }

        self.ui.mutate()
            .copy_ime_mode_from(
                inherited_struct,
            );
    }

    /// Set the `ime_mode` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_ime_mode(
        &mut self,
        value: longhands::ime_mode::computed_value::T
    ) {
        self.modified_reset = true;

        self.ui.mutate()
            .set_ime_mode(
                value,
            );
    }
    /// Inherit `initial_letter` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_initial_letter(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_text();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.text.ptr_eq(inherited_struct) {
            return;
        }

        self.text.mutate()
            .copy_initial_letter_from(
                inherited_struct,
            );
    }

    /// Set the `initial_letter` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_initial_letter(
        &mut self,
        value: longhands::initial_letter::computed_value::T
    ) {
        self.modified_reset = true;

        self.text.mutate()
            .set_initial_letter(
                value,
            );
    }
    /// Inherit `isolation` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_isolation(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_isolation_from(
                inherited_struct,
            );
    }

    /// Set the `isolation` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_isolation(
        &mut self,
        value: longhands::isolation::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_isolation(
                value,
            );
    }
    /// Inherit `justify_content` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_justify_content(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_justify_content_from(
                inherited_struct,
            );
    }

    /// Set the `justify_content` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_justify_content(
        &mut self,
        value: longhands::justify_content::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_justify_content(
                value,
            );
    }
    /// Inherit `justify_items` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_justify_items(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_justify_items_from(
                inherited_struct,
            );
    }

    /// Set the `justify_items` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_justify_items(
        &mut self,
        value: longhands::justify_items::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_justify_items(
                value,
            );
    }
    /// Inherit `justify_self` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_justify_self(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_justify_self_from(
                inherited_struct,
            );
    }

    /// Set the `justify_self` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_justify_self(
        &mut self,
        value: longhands::justify_self::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_justify_self(
                value,
            );
    }
    /// Reset `list_style_position` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_list_style_position(&mut self) {
        let reset_struct =
            self.reset_style.get_list();

        if self.list.ptr_eq(reset_struct) {
            return;
        }

        self.list.mutate()
            .reset_list_style_position(
                reset_struct,
            );
    }

    /// Set the `list_style_position` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_list_style_position(
        &mut self,
        value: longhands::list_style_position::computed_value::T
    ) {

        self.list.mutate()
            .set_list_style_position(
                value,
            );
    }
    /// Inherit `mask_type` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_mask_type(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_svg();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.svg.ptr_eq(inherited_struct) {
            return;
        }

        self.svg.mutate()
            .copy_mask_type_from(
                inherited_struct,
            );
    }

    /// Set the `mask_type` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_mask_type(
        &mut self,
        value: longhands::mask_type::computed_value::T
    ) {
        self.modified_reset = true;

        self.svg.mutate()
            .set_mask_type(
                value,
            );
    }
    /// Inherit `mix_blend_mode` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_mix_blend_mode(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_effects();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.effects.ptr_eq(inherited_struct) {
            return;
        }

        self.effects.mutate()
            .copy_mix_blend_mode_from(
                inherited_struct,
            );
    }

    /// Set the `mix_blend_mode` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_mix_blend_mode(
        &mut self,
        value: longhands::mix_blend_mode::computed_value::T
    ) {
        self.modified_reset = true;

        self.effects.mutate()
            .set_mix_blend_mode(
                value,
            );
    }
    /// Inherit `_moz_appearance` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_appearance(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy__moz_appearance_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_appearance` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_appearance(
        &mut self,
        value: longhands::_moz_appearance::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set__moz_appearance(
                value,
            );
    }
    /// Inherit `_moz_box_align` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_box_align(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_xul();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.xul.ptr_eq(inherited_struct) {
            return;
        }

        self.xul.mutate()
            .copy__moz_box_align_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_box_align` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_box_align(
        &mut self,
        value: longhands::_moz_box_align::computed_value::T
    ) {
        self.modified_reset = true;

        self.xul.mutate()
            .set__moz_box_align(
                value,
            );
    }
    /// Inherit `_moz_box_direction` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_box_direction(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_xul();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.xul.ptr_eq(inherited_struct) {
            return;
        }

        self.xul.mutate()
            .copy__moz_box_direction_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_box_direction` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_box_direction(
        &mut self,
        value: longhands::_moz_box_direction::computed_value::T
    ) {
        self.modified_reset = true;

        self.xul.mutate()
            .set__moz_box_direction(
                value,
            );
    }
    /// Inherit `_moz_box_orient` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_box_orient(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_xul();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.xul.ptr_eq(inherited_struct) {
            return;
        }

        self.xul.mutate()
            .copy__moz_box_orient_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_box_orient` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_box_orient(
        &mut self,
        value: longhands::_moz_box_orient::computed_value::T
    ) {
        self.modified_reset = true;

        self.xul.mutate()
            .set__moz_box_orient(
                value,
            );
    }
    /// Inherit `_moz_box_pack` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_box_pack(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_xul();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.xul.ptr_eq(inherited_struct) {
            return;
        }

        self.xul.mutate()
            .copy__moz_box_pack_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_box_pack` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_box_pack(
        &mut self,
        value: longhands::_moz_box_pack::computed_value::T
    ) {
        self.modified_reset = true;

        self.xul.mutate()
            .set__moz_box_pack(
                value,
            );
    }
    /// Reset `_moz_control_character_visibility` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__moz_control_character_visibility(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset__moz_control_character_visibility(
                reset_struct,
            );
    }

    /// Set the `_moz_control_character_visibility` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_control_character_visibility(
        &mut self,
        value: longhands::_moz_control_character_visibility::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set__moz_control_character_visibility(
                value,
            );
    }
    /// Inherit `_moz_float_edge` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_float_edge(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy__moz_float_edge_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_float_edge` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_float_edge(
        &mut self,
        value: longhands::_moz_float_edge::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set__moz_float_edge(
                value,
            );
    }
    /// Inherit `_moz_force_broken_image_icon` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_force_broken_image_icon(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_ui();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.ui.ptr_eq(inherited_struct) {
            return;
        }

        self.ui.mutate()
            .copy__moz_force_broken_image_icon_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_force_broken_image_icon` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_force_broken_image_icon(
        &mut self,
        value: longhands::_moz_force_broken_image_icon::computed_value::T
    ) {
        self.modified_reset = true;

        self.ui.mutate()
            .set__moz_force_broken_image_icon(
                value,
            );
    }
    /// Reset `_moz_list_reversed` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__moz_list_reversed(&mut self) {
        let reset_struct =
            self.reset_style.get_list();

        if self.list.ptr_eq(reset_struct) {
            return;
        }

        self.list.mutate()
            .reset__moz_list_reversed(
                reset_struct,
            );
    }

    /// Set the `_moz_list_reversed` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_list_reversed(
        &mut self,
        value: longhands::_moz_list_reversed::computed_value::T
    ) {

        self.list.mutate()
            .set__moz_list_reversed(
                value,
            );
    }
    /// Reset `_moz_math_display` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__moz_math_display(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset__moz_math_display(
                reset_struct,
            );
    }

    /// Set the `_moz_math_display` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_math_display(
        &mut self,
        value: longhands::_moz_math_display::computed_value::T
    ) {

        self.font.mutate()
            .set__moz_math_display(
                value,
            );
    }
    /// Reset `_moz_math_variant` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__moz_math_variant(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset__moz_math_variant(
                reset_struct,
            );
    }

    /// Set the `_moz_math_variant` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_math_variant(
        &mut self,
        value: longhands::_moz_math_variant::computed_value::T
    ) {

        self.font.mutate()
            .set__moz_math_variant(
                value,
            );
    }
    /// Reset `_moz_min_font_size_ratio` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__moz_min_font_size_ratio(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset__moz_min_font_size_ratio(
                reset_struct,
            );
    }

    /// Set the `_moz_min_font_size_ratio` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_min_font_size_ratio(
        &mut self,
        value: longhands::_moz_min_font_size_ratio::computed_value::T
    ) {

        self.font.mutate()
            .set__moz_min_font_size_ratio(
                value,
            );
    }
    /// Inherit `_moz_orient` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_orient(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy__moz_orient_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_orient` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_orient(
        &mut self,
        value: longhands::_moz_orient::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set__moz_orient(
                value,
            );
    }
    /// Reset `_moz_osx_font_smoothing` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__moz_osx_font_smoothing(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset__moz_osx_font_smoothing(
                reset_struct,
            );
    }

    /// Set the `_moz_osx_font_smoothing` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_osx_font_smoothing(
        &mut self,
        value: longhands::_moz_osx_font_smoothing::computed_value::T
    ) {

        self.font.mutate()
            .set__moz_osx_font_smoothing(
                value,
            );
    }
    /// Reset `_moz_script_level` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__moz_script_level(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset__moz_script_level(
                reset_struct,
            );
    }

    /// Set the `_moz_script_level` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_script_level(
        &mut self,
        value: longhands::_moz_script_level::computed_value::T
    ) {

        self.font.mutate()
            .set__moz_script_level(
                value,
            );
    }
    /// Reset `_moz_script_min_size` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__moz_script_min_size(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset__moz_script_min_size(
                reset_struct,
            );
    }

    /// Set the `_moz_script_min_size` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_script_min_size(
        &mut self,
        value: longhands::_moz_script_min_size::computed_value::T
    ) {

        self.font.mutate()
            .set__moz_script_min_size(
                value,
            );
    }
    /// Reset `_moz_script_size_multiplier` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__moz_script_size_multiplier(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset__moz_script_size_multiplier(
                reset_struct,
            );
    }

    /// Set the `_moz_script_size_multiplier` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_script_size_multiplier(
        &mut self,
        value: longhands::_moz_script_size_multiplier::computed_value::T
    ) {

        self.font.mutate()
            .set__moz_script_size_multiplier(
                value,
            );
    }
    /// Inherit `_moz_stack_sizing` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_stack_sizing(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_xul();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.xul.ptr_eq(inherited_struct) {
            return;
        }

        self.xul.mutate()
            .copy__moz_stack_sizing_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_stack_sizing` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_stack_sizing(
        &mut self,
        value: longhands::_moz_stack_sizing::computed_value::T
    ) {
        self.modified_reset = true;

        self.xul.mutate()
            .set__moz_stack_sizing(
                value,
            );
    }
    /// Reset `_moz_text_size_adjust` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__moz_text_size_adjust(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset__moz_text_size_adjust(
                reset_struct,
            );
    }

    /// Set the `_moz_text_size_adjust` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_text_size_adjust(
        &mut self,
        value: longhands::_moz_text_size_adjust::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set__moz_text_size_adjust(
                value,
            );
    }
    /// Inherit `_moz_top_layer` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_top_layer(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy__moz_top_layer_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_top_layer` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_top_layer(
        &mut self,
        value: longhands::_moz_top_layer::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set__moz_top_layer(
                value,
            );
    }
    /// Reset `_moz_user_focus` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__moz_user_focus(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_ui();

        if self.inherited_ui.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_ui.mutate()
            .reset__moz_user_focus(
                reset_struct,
            );
    }

    /// Set the `_moz_user_focus` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_user_focus(
        &mut self,
        value: longhands::_moz_user_focus::computed_value::T
    ) {

        self.inherited_ui.mutate()
            .set__moz_user_focus(
                value,
            );
    }
    /// Reset `_moz_user_input` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__moz_user_input(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_ui();

        if self.inherited_ui.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_ui.mutate()
            .reset__moz_user_input(
                reset_struct,
            );
    }

    /// Set the `_moz_user_input` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_user_input(
        &mut self,
        value: longhands::_moz_user_input::computed_value::T
    ) {

        self.inherited_ui.mutate()
            .set__moz_user_input(
                value,
            );
    }
    /// Reset `_moz_user_modify` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__moz_user_modify(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_ui();

        if self.inherited_ui.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_ui.mutate()
            .reset__moz_user_modify(
                reset_struct,
            );
    }

    /// Set the `_moz_user_modify` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_user_modify(
        &mut self,
        value: longhands::_moz_user_modify::computed_value::T
    ) {

        self.inherited_ui.mutate()
            .set__moz_user_modify(
                value,
            );
    }
    /// Inherit `_moz_user_select` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_user_select(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_ui();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.ui.ptr_eq(inherited_struct) {
            return;
        }

        self.ui.mutate()
            .copy__moz_user_select_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_user_select` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_user_select(
        &mut self,
        value: longhands::_moz_user_select::computed_value::T
    ) {
        self.modified_reset = true;

        self.ui.mutate()
            .set__moz_user_select(
                value,
            );
    }
    /// Inherit `_moz_window_dragging` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_window_dragging(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_ui();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.ui.ptr_eq(inherited_struct) {
            return;
        }

        self.ui.mutate()
            .copy__moz_window_dragging_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_window_dragging` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_window_dragging(
        &mut self,
        value: longhands::_moz_window_dragging::computed_value::T
    ) {
        self.modified_reset = true;

        self.ui.mutate()
            .set__moz_window_dragging(
                value,
            );
    }
    /// Inherit `_moz_window_shadow` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_window_shadow(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_ui();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.ui.ptr_eq(inherited_struct) {
            return;
        }

        self.ui.mutate()
            .copy__moz_window_shadow_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_window_shadow` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_window_shadow(
        &mut self,
        value: longhands::_moz_window_shadow::computed_value::T
    ) {
        self.modified_reset = true;

        self.ui.mutate()
            .set__moz_window_shadow(
                value,
            );
    }
    /// Inherit `object_fit` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_object_fit(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_object_fit_from(
                inherited_struct,
            );
    }

    /// Set the `object_fit` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_object_fit(
        &mut self,
        value: longhands::object_fit::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_object_fit(
                value,
            );
    }
    /// Inherit `outline_style` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_outline_style(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_outline();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.outline.ptr_eq(inherited_struct) {
            return;
        }

        self.outline.mutate()
            .copy_outline_style_from(
                inherited_struct,
            );
    }

    /// Set the `outline_style` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_outline_style(
        &mut self,
        value: longhands::outline_style::computed_value::T
    ) {
        self.modified_reset = true;

        self.outline.mutate()
            .set_outline_style(
                value,
            );
    }
    /// Inherit `overflow_anchor` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_overflow_anchor(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_overflow_anchor_from(
                inherited_struct,
            );
    }

    /// Set the `overflow_anchor` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_overflow_anchor(
        &mut self,
        value: longhands::overflow_anchor::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_overflow_anchor(
                value,
            );
    }
    /// Reset `overflow_wrap` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_overflow_wrap(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_overflow_wrap(
                reset_struct,
            );
    }

    /// Set the `overflow_wrap` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_overflow_wrap(
        &mut self,
        value: longhands::overflow_wrap::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_overflow_wrap(
                value,
            );
    }
    /// Reset `paint_order` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_paint_order(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_paint_order(
                reset_struct,
            );
    }

    /// Set the `paint_order` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_paint_order(
        &mut self,
        value: longhands::paint_order::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_paint_order(
                value,
            );
    }
    /// Reset `pointer_events` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_pointer_events(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_ui();

        if self.inherited_ui.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_ui.mutate()
            .reset_pointer_events(
                reset_struct,
            );
    }

    /// Set the `pointer_events` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_pointer_events(
        &mut self,
        value: longhands::pointer_events::computed_value::T
    ) {

        self.inherited_ui.mutate()
            .set_pointer_events(
                value,
            );
    }
    /// Inherit `position` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_position(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_position_from(
                inherited_struct,
            );
    }

    /// Set the `position` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_position(
        &mut self,
        value: longhands::position::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_position(
                value,
            );
    }
    /// Inherit `resize` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_resize(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_resize_from(
                inherited_struct,
            );
    }

    /// Set the `resize` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_resize(
        &mut self,
        value: longhands::resize::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_resize(
                value,
            );
    }
    /// Reset `ruby_align` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_ruby_align(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_ruby_align(
                reset_struct,
            );
    }

    /// Set the `ruby_align` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_ruby_align(
        &mut self,
        value: longhands::ruby_align::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_ruby_align(
                value,
            );
    }
    /// Reset `ruby_position` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_ruby_position(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_ruby_position(
                reset_struct,
            );
    }

    /// Set the `ruby_position` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_ruby_position(
        &mut self,
        value: longhands::ruby_position::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_ruby_position(
                value,
            );
    }
    /// Inherit `scroll_behavior` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_behavior(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_scroll_behavior_from(
                inherited_struct,
            );
    }

    /// Set the `scroll_behavior` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_behavior(
        &mut self,
        value: longhands::scroll_behavior::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_scroll_behavior(
                value,
            );
    }
    /// Inherit `scroll_snap_align` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_snap_align(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_scroll_snap_align_from(
                inherited_struct,
            );
    }

    /// Set the `scroll_snap_align` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_snap_align(
        &mut self,
        value: longhands::scroll_snap_align::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_scroll_snap_align(
                value,
            );
    }
    /// Inherit `scroll_snap_type` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_snap_type(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_scroll_snap_type_from(
                inherited_struct,
            );
    }

    /// Set the `scroll_snap_type` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_snap_type(
        &mut self,
        value: longhands::scroll_snap_type::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_scroll_snap_type(
                value,
            );
    }
    /// Inherit `scrollbar_width` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scrollbar_width(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_ui();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.ui.ptr_eq(inherited_struct) {
            return;
        }

        self.ui.mutate()
            .copy_scrollbar_width_from(
                inherited_struct,
            );
    }

    /// Set the `scrollbar_width` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scrollbar_width(
        &mut self,
        value: longhands::scrollbar_width::computed_value::T
    ) {
        self.modified_reset = true;

        self.ui.mutate()
            .set_scrollbar_width(
                value,
            );
    }
    /// Reset `shape_rendering` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_shape_rendering(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_shape_rendering(
                reset_struct,
            );
    }

    /// Set the `shape_rendering` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_shape_rendering(
        &mut self,
        value: longhands::shape_rendering::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_shape_rendering(
                value,
            );
    }
    /// Reset `stroke_linecap` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_stroke_linecap(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_stroke_linecap(
                reset_struct,
            );
    }

    /// Set the `stroke_linecap` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_stroke_linecap(
        &mut self,
        value: longhands::stroke_linecap::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_stroke_linecap(
                value,
            );
    }
    /// Reset `stroke_linejoin` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_stroke_linejoin(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_stroke_linejoin(
                reset_struct,
            );
    }

    /// Set the `stroke_linejoin` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_stroke_linejoin(
        &mut self,
        value: longhands::stroke_linejoin::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_stroke_linejoin(
                value,
            );
    }
    /// Inherit `table_layout` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_table_layout(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_table();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.table.ptr_eq(inherited_struct) {
            return;
        }

        self.table.mutate()
            .copy_table_layout_from(
                inherited_struct,
            );
    }

    /// Set the `table_layout` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_table_layout(
        &mut self,
        value: longhands::table_layout::computed_value::T
    ) {
        self.modified_reset = true;

        self.table.mutate()
            .set_table_layout(
                value,
            );
    }
    /// Reset `text_align` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_text_align(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_text_align(
                reset_struct,
            );
    }

    /// Set the `text_align` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_text_align(
        &mut self,
        value: longhands::text_align::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_text_align(
                value,
            );
    }
    /// Reset `text_align_last` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_text_align_last(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_text_align_last(
                reset_struct,
            );
    }

    /// Set the `text_align_last` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_text_align_last(
        &mut self,
        value: longhands::text_align_last::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_text_align_last(
                value,
            );
    }
    /// Reset `text_anchor` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_text_anchor(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_text_anchor(
                reset_struct,
            );
    }

    /// Set the `text_anchor` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_text_anchor(
        &mut self,
        value: longhands::text_anchor::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_text_anchor(
                value,
            );
    }
    /// Reset `text_combine_upright` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_text_combine_upright(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_text_combine_upright(
                reset_struct,
            );
    }

    /// Set the `text_combine_upright` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_text_combine_upright(
        &mut self,
        value: longhands::text_combine_upright::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_text_combine_upright(
                value,
            );
    }
    /// Inherit `text_decoration_line` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_text_decoration_line(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_text();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.text.ptr_eq(inherited_struct) {
            return;
        }

        self.text.mutate()
            .copy_text_decoration_line_from(
                inherited_struct,
            );
    }

    /// Set the `text_decoration_line` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_text_decoration_line(
        &mut self,
        value: longhands::text_decoration_line::computed_value::T
    ) {
        self.modified_reset = true;

        self.text.mutate()
            .set_text_decoration_line(
                value,
            );
    }
    /// Inherit `text_decoration_style` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_text_decoration_style(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_text();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.text.ptr_eq(inherited_struct) {
            return;
        }

        self.text.mutate()
            .copy_text_decoration_style_from(
                inherited_struct,
            );
    }

    /// Set the `text_decoration_style` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_text_decoration_style(
        &mut self,
        value: longhands::text_decoration_style::computed_value::T
    ) {
        self.modified_reset = true;

        self.text.mutate()
            .set_text_decoration_style(
                value,
            );
    }
    /// Reset `text_emphasis_position` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_text_emphasis_position(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_text_emphasis_position(
                reset_struct,
            );
    }

    /// Set the `text_emphasis_position` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_text_emphasis_position(
        &mut self,
        value: longhands::text_emphasis_position::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_text_emphasis_position(
                value,
            );
    }
    /// Reset `text_justify` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_text_justify(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_text_justify(
                reset_struct,
            );
    }

    /// Set the `text_justify` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_text_justify(
        &mut self,
        value: longhands::text_justify::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_text_justify(
                value,
            );
    }
    /// Reset `text_orientation` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_text_orientation(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_box();

        if self.inherited_box.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_box.mutate()
            .reset_text_orientation(
                reset_struct,
            );
    }

    /// Set the `text_orientation` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_text_orientation(
        &mut self,
        value: longhands::text_orientation::computed_value::T
    ) {

        self.inherited_box.mutate()
            .set_text_orientation(
                value,
            );
    }
    /// Reset `text_rendering` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_text_rendering(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_text_rendering(
                reset_struct,
            );
    }

    /// Set the `text_rendering` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_text_rendering(
        &mut self,
        value: longhands::text_rendering::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_text_rendering(
                value,
            );
    }
    /// Reset `text_transform` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_text_transform(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_text_transform(
                reset_struct,
            );
    }

    /// Set the `text_transform` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_text_transform(
        &mut self,
        value: longhands::text_transform::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_text_transform(
                value,
            );
    }
    /// Inherit `touch_action` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_touch_action(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_touch_action_from(
                inherited_struct,
            );
    }

    /// Set the `touch_action` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_touch_action(
        &mut self,
        value: longhands::touch_action::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_touch_action(
                value,
            );
    }
    /// Inherit `transform_box` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_transform_box(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_transform_box_from(
                inherited_struct,
            );
    }

    /// Set the `transform_box` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_transform_box(
        &mut self,
        value: longhands::transform_box::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_transform_box(
                value,
            );
    }
    /// Inherit `transform_style` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_transform_style(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_transform_style_from(
                inherited_struct,
            );
    }

    /// Set the `transform_style` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_transform_style(
        &mut self,
        value: longhands::transform_style::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_transform_style(
                value,
            );
    }
    /// Inherit `unicode_bidi` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_unicode_bidi(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_text();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.text.ptr_eq(inherited_struct) {
            return;
        }

        self.text.mutate()
            .copy_unicode_bidi_from(
                inherited_struct,
            );
    }

    /// Set the `unicode_bidi` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_unicode_bidi(
        &mut self,
        value: longhands::unicode_bidi::computed_value::T
    ) {
        self.modified_reset = true;

        self.text.mutate()
            .set_unicode_bidi(
                value,
            );
    }
    /// Inherit `vector_effect` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_vector_effect(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_svg();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.svg.ptr_eq(inherited_struct) {
            return;
        }

        self.svg.mutate()
            .copy_vector_effect_from(
                inherited_struct,
            );
    }

    /// Set the `vector_effect` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_vector_effect(
        &mut self,
        value: longhands::vector_effect::computed_value::T
    ) {
        self.modified_reset = true;

        self.svg.mutate()
            .set_vector_effect(
                value,
            );
    }
    /// Reset `visibility` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_visibility(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_box();

        if self.inherited_box.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_box.mutate()
            .reset_visibility(
                reset_struct,
            );
    }

    /// Set the `visibility` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_visibility(
        &mut self,
        value: longhands::visibility::computed_value::T
    ) {

        self.inherited_box.mutate()
            .set_visibility(
                value,
            );
    }
    /// Inherit `_webkit_line_clamp` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__webkit_line_clamp(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy__webkit_line_clamp_from(
                inherited_struct,
            );
    }

    /// Set the `_webkit_line_clamp` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__webkit_line_clamp(
        &mut self,
        value: longhands::_webkit_line_clamp::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set__webkit_line_clamp(
                value,
            );
    }
    /// Reset `white_space` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_white_space(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_white_space(
                reset_struct,
            );
    }

    /// Set the `white_space` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_white_space(
        &mut self,
        value: longhands::white_space::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_white_space(
                value,
            );
    }
    /// Reset `word_break` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_word_break(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_word_break(
                reset_struct,
            );
    }

    /// Set the `word_break` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_word_break(
        &mut self,
        value: longhands::word_break::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_word_break(
                value,
            );
    }
    /// Reset `writing_mode` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_writing_mode(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_box();

        if self.inherited_box.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_box.mutate()
            .reset_writing_mode(
                reset_struct,
            );
    }

    /// Set the `writing_mode` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_writing_mode(
        &mut self,
        value: longhands::writing_mode::computed_value::T
    ) {

        self.inherited_box.mutate()
            .set_writing_mode(
                value,
            );
    }
    /// Inherit `_x_span` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__x_span(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_table();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.table.ptr_eq(inherited_struct) {
            return;
        }

        self.table.mutate()
            .copy__x_span_from(
                inherited_struct,
            );
    }

    /// Set the `_x_span` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__x_span(
        &mut self,
        value: longhands::_x_span::computed_value::T
    ) {
        self.modified_reset = true;

        self.table.mutate()
            .set__x_span(
                value,
            );
    }
    /// Reset `_x_text_zoom` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__x_text_zoom(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset__x_text_zoom(
                reset_struct,
            );
    }

    /// Set the `_x_text_zoom` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__x_text_zoom(
        &mut self,
        value: longhands::_x_text_zoom::computed_value::T
    ) {

        self.font.mutate()
            .set__x_text_zoom(
                value,
            );
    }
    /// Inherit `z_index` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_z_index(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_z_index_from(
                inherited_struct,
            );
    }

    /// Set the `z_index` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_z_index(
        &mut self,
        value: longhands::z_index::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_z_index(
                value,
            );
    }
    /// Inherit `break_after` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_break_after(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_break_after_from(
                inherited_struct,
            );
    }

    /// Set the `break_after` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_break_after(
        &mut self,
        value: longhands::break_after::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_break_after(
                value,
            );
    }
    /// Inherit `break_before` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_break_before(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_break_before_from(
                inherited_struct,
            );
    }

    /// Set the `break_before` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_break_before(
        &mut self,
        value: longhands::break_before::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_break_before(
                value,
            );
    }
    /// Reset `clip_rule` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_clip_rule(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_clip_rule(
                reset_struct,
            );
    }

    /// Set the `clip_rule` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_clip_rule(
        &mut self,
        value: longhands::clip_rule::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_clip_rule(
                value,
            );
    }
    /// Reset `fill_rule` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_fill_rule(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_fill_rule(
                reset_struct,
            );
    }

    /// Set the `fill_rule` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_fill_rule(
        &mut self,
        value: longhands::fill_rule::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_fill_rule(
                value,
            );
    }
    /// Inherit `_moz_box_ordinal_group` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_box_ordinal_group(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_xul();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.xul.ptr_eq(inherited_struct) {
            return;
        }

        self.xul.mutate()
            .copy__moz_box_ordinal_group_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_box_ordinal_group` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_box_ordinal_group(
        &mut self,
        value: longhands::_moz_box_ordinal_group::computed_value::T
    ) {
        self.modified_reset = true;

        self.xul.mutate()
            .set__moz_box_ordinal_group(
                value,
            );
    }
    /// Inherit `order` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_order(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_order_from(
                inherited_struct,
            );
    }

    /// Set the `order` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_order(
        &mut self,
        value: longhands::order::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_order(
                value,
            );
    }
    /// Inherit `overflow_x` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_overflow_x(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_overflow_x_from(
                inherited_struct,
            );
    }

    /// Set the `overflow_x` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_overflow_x(
        &mut self,
        value: longhands::overflow_x::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_overflow_x(
                value,
            );
    }
    /// Inherit `overflow_y` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_overflow_y(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_overflow_y_from(
                inherited_struct,
            );
    }

    /// Set the `overflow_y` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_overflow_y(
        &mut self,
        value: longhands::overflow_y::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_overflow_y(
                value,
            );
    }
    /// Inherit `overflow_clip_box_block` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_overflow_clip_box_block(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_overflow_clip_box_block_from(
                inherited_struct,
            );
    }

    /// Set the `overflow_clip_box_block` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_overflow_clip_box_block(
        &mut self,
        value: longhands::overflow_clip_box_block::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_overflow_clip_box_block(
                value,
            );
    }
    /// Inherit `overflow_clip_box_inline` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_overflow_clip_box_inline(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_overflow_clip_box_inline_from(
                inherited_struct,
            );
    }

    /// Set the `overflow_clip_box_inline` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_overflow_clip_box_inline(
        &mut self,
        value: longhands::overflow_clip_box_inline::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_overflow_clip_box_inline(
                value,
            );
    }
    /// Inherit `overscroll_behavior_x` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_overscroll_behavior_x(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_overscroll_behavior_x_from(
                inherited_struct,
            );
    }

    /// Set the `overscroll_behavior_x` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_overscroll_behavior_x(
        &mut self,
        value: longhands::overscroll_behavior_x::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_overscroll_behavior_x(
                value,
            );
    }
    /// Inherit `overscroll_behavior_y` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_overscroll_behavior_y(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_overscroll_behavior_y_from(
                inherited_struct,
            );
    }

    /// Set the `overscroll_behavior_y` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_overscroll_behavior_y(
        &mut self,
        value: longhands::overscroll_behavior_y::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_overscroll_behavior_y(
                value,
            );
    }
    /// Reset `fill_opacity` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_fill_opacity(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_fill_opacity(
                reset_struct,
            );
    }

    /// Set the `fill_opacity` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_fill_opacity(
        &mut self,
        value: longhands::fill_opacity::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_fill_opacity(
                value,
            );
    }
    /// Reset `stroke_opacity` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_stroke_opacity(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_stroke_opacity(
                reset_struct,
            );
    }

    /// Set the `stroke_opacity` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_stroke_opacity(
        &mut self,
        value: longhands::stroke_opacity::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_stroke_opacity(
                value,
            );
    }
    /// Inherit `flex_grow` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_flex_grow(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_flex_grow_from(
                inherited_struct,
            );
    }

    /// Set the `flex_grow` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_flex_grow(
        &mut self,
        value: longhands::flex_grow::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_flex_grow(
                value,
            );
    }
    /// Inherit `flex_shrink` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_flex_shrink(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_flex_shrink_from(
                inherited_struct,
            );
    }

    /// Set the `flex_shrink` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_flex_shrink(
        &mut self,
        value: longhands::flex_shrink::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_flex_shrink(
                value,
            );
    }
    /// Inherit `_moz_box_flex` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_box_flex(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_xul();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.xul.ptr_eq(inherited_struct) {
            return;
        }

        self.xul.mutate()
            .copy__moz_box_flex_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_box_flex` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_box_flex(
        &mut self,
        value: longhands::_moz_box_flex::computed_value::T
    ) {
        self.modified_reset = true;

        self.xul.mutate()
            .set__moz_box_flex(
                value,
            );
    }
    /// Reset `stroke_miterlimit` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_stroke_miterlimit(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_stroke_miterlimit(
                reset_struct,
            );
    }

    /// Set the `stroke_miterlimit` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_stroke_miterlimit(
        &mut self,
        value: longhands::stroke_miterlimit::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_stroke_miterlimit(
                value,
            );
    }
    /// Inherit `flood_opacity` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_flood_opacity(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_svg();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.svg.ptr_eq(inherited_struct) {
            return;
        }

        self.svg.mutate()
            .copy_flood_opacity_from(
                inherited_struct,
            );
    }

    /// Set the `flood_opacity` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_flood_opacity(
        &mut self,
        value: longhands::flood_opacity::computed_value::T
    ) {
        self.modified_reset = true;

        self.svg.mutate()
            .set_flood_opacity(
                value,
            );
    }
    /// Inherit `_moz_window_opacity` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_window_opacity(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_ui();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.ui.ptr_eq(inherited_struct) {
            return;
        }

        self.ui.mutate()
            .copy__moz_window_opacity_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_window_opacity` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_window_opacity(
        &mut self,
        value: longhands::_moz_window_opacity::computed_value::T
    ) {
        self.modified_reset = true;

        self.ui.mutate()
            .set__moz_window_opacity(
                value,
            );
    }
    /// Inherit `opacity` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_opacity(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_effects();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.effects.ptr_eq(inherited_struct) {
            return;
        }

        self.effects.mutate()
            .copy_opacity_from(
                inherited_struct,
            );
    }

    /// Set the `opacity` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_opacity(
        &mut self,
        value: longhands::opacity::computed_value::T
    ) {
        self.modified_reset = true;

        self.effects.mutate()
            .set_opacity(
                value,
            );
    }
    /// Inherit `shape_image_threshold` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_shape_image_threshold(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_shape_image_threshold_from(
                inherited_struct,
            );
    }

    /// Set the `shape_image_threshold` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_shape_image_threshold(
        &mut self,
        value: longhands::shape_image_threshold::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_shape_image_threshold(
                value,
            );
    }
    /// Inherit `stop_opacity` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_stop_opacity(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_svg();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.svg.ptr_eq(inherited_struct) {
            return;
        }

        self.svg.mutate()
            .copy_stop_opacity_from(
                inherited_struct,
            );
    }

    /// Set the `stop_opacity` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_stop_opacity(
        &mut self,
        value: longhands::stop_opacity::computed_value::T
    ) {
        self.modified_reset = true;

        self.svg.mutate()
            .set_stop_opacity(
                value,
            );
    }
    /// Inherit `border_block_end_style` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_block_end_style(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_block_end_style_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `border_block_end_style` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_block_end_style(
        &mut self,
        value: longhands::border_block_end_style::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_block_end_style(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `border_block_start_style` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_block_start_style(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_block_start_style_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `border_block_start_style` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_block_start_style(
        &mut self,
        value: longhands::border_block_start_style::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_block_start_style(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `border_bottom_style` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_bottom_style(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_bottom_style_from(
                inherited_struct,
            );
    }

    /// Set the `border_bottom_style` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_bottom_style(
        &mut self,
        value: longhands::border_bottom_style::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_bottom_style(
                value,
            );
    }
    /// Inherit `border_inline_end_style` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_inline_end_style(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_inline_end_style_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `border_inline_end_style` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_inline_end_style(
        &mut self,
        value: longhands::border_inline_end_style::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_inline_end_style(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `border_inline_start_style` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_inline_start_style(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_inline_start_style_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `border_inline_start_style` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_inline_start_style(
        &mut self,
        value: longhands::border_inline_start_style::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_inline_start_style(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `border_left_style` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_left_style(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_left_style_from(
                inherited_struct,
            );
    }

    /// Set the `border_left_style` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_left_style(
        &mut self,
        value: longhands::border_left_style::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_left_style(
                value,
            );
    }
    /// Inherit `border_right_style` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_right_style(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_right_style_from(
                inherited_struct,
            );
    }

    /// Set the `border_right_style` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_right_style(
        &mut self,
        value: longhands::border_right_style::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_right_style(
                value,
            );
    }
    /// Inherit `border_top_style` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_top_style(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_top_style_from(
                inherited_struct,
            );
    }

    /// Set the `border_top_style` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_top_style(
        &mut self,
        value: longhands::border_top_style::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_top_style(
                value,
            );
    }
    /// Inherit `column_rule_style` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_column_rule_style(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_column();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.column.ptr_eq(inherited_struct) {
            return;
        }

        self.column.mutate()
            .copy_column_rule_style_from(
                inherited_struct,
            );
    }

    /// Set the `column_rule_style` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_column_rule_style(
        &mut self,
        value: longhands::column_rule_style::computed_value::T
    ) {
        self.modified_reset = true;

        self.column.mutate()
            .set_column_rule_style(
                value,
            );
    }
    /// Inherit `animation_delay` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_animation_delay(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_animation_delay_from(
                inherited_struct,
            );
    }

    /// Inherit `animation_direction` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_animation_direction(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_animation_direction_from(
                inherited_struct,
            );
    }

    /// Inherit `animation_duration` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_animation_duration(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_animation_duration_from(
                inherited_struct,
            );
    }

    /// Inherit `animation_fill_mode` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_animation_fill_mode(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_animation_fill_mode_from(
                inherited_struct,
            );
    }

    /// Inherit `animation_iteration_count` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_animation_iteration_count(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_animation_iteration_count_from(
                inherited_struct,
            );
    }

    /// Inherit `animation_name` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_animation_name(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_animation_name_from(
                inherited_struct,
            );
    }

    /// Inherit `animation_play_state` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_animation_play_state(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_animation_play_state_from(
                inherited_struct,
            );
    }

    /// Inherit `animation_timing_function` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_animation_timing_function(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_animation_timing_function_from(
                inherited_struct,
            );
    }

    /// Inherit `background_attachment` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_background_attachment(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_background();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.background.ptr_eq(inherited_struct) {
            return;
        }

        self.background.mutate()
            .copy_background_attachment_from(
                inherited_struct,
            );
    }

    /// Inherit `background_blend_mode` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_background_blend_mode(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_background();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.background.ptr_eq(inherited_struct) {
            return;
        }

        self.background.mutate()
            .copy_background_blend_mode_from(
                inherited_struct,
            );
    }

    /// Inherit `background_clip` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_background_clip(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_background();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.background.ptr_eq(inherited_struct) {
            return;
        }

        self.background.mutate()
            .copy_background_clip_from(
                inherited_struct,
            );
    }

    /// Inherit `background_image` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_background_image(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_background();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.background.ptr_eq(inherited_struct) {
            return;
        }

        self.background.mutate()
            .copy_background_image_from(
                inherited_struct,
            );
    }

    /// Inherit `background_origin` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_background_origin(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_background();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.background.ptr_eq(inherited_struct) {
            return;
        }

        self.background.mutate()
            .copy_background_origin_from(
                inherited_struct,
            );
    }

    /// Inherit `background_position_x` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_background_position_x(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_background();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.background.ptr_eq(inherited_struct) {
            return;
        }

        self.background.mutate()
            .copy_background_position_x_from(
                inherited_struct,
            );
    }

    /// Inherit `background_position_y` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_background_position_y(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_background();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.background.ptr_eq(inherited_struct) {
            return;
        }

        self.background.mutate()
            .copy_background_position_y_from(
                inherited_struct,
            );
    }

    /// Inherit `background_repeat` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_background_repeat(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_background();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.background.ptr_eq(inherited_struct) {
            return;
        }

        self.background.mutate()
            .copy_background_repeat_from(
                inherited_struct,
            );
    }

    /// Inherit `background_size` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_background_size(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_background();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.background.ptr_eq(inherited_struct) {
            return;
        }

        self.background.mutate()
            .copy_background_size_from(
                inherited_struct,
            );
    }

    /// Inherit `border_image_outset` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_image_outset(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_image_outset_from(
                inherited_struct,
            );
    }

    /// Set the `border_image_outset` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_image_outset(
        &mut self,
        value: longhands::border_image_outset::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_image_outset(
                value,
            );
    }
    /// Inherit `border_image_slice` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_image_slice(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_image_slice_from(
                inherited_struct,
            );
    }

    /// Set the `border_image_slice` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_image_slice(
        &mut self,
        value: longhands::border_image_slice::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_image_slice(
                value,
            );
    }
    /// Inherit `border_image_source` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_image_source(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_image_source_from(
                inherited_struct,
            );
    }

    /// Set the `border_image_source` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_image_source(
        &mut self,
        value: longhands::border_image_source::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_image_source(
                value,
            );
    }
    /// Inherit `border_image_width` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_image_width(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_image_width_from(
                inherited_struct,
            );
    }

    /// Set the `border_image_width` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_image_width(
        &mut self,
        value: longhands::border_image_width::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_image_width(
                value,
            );
    }
    /// Reset `border_spacing` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_border_spacing(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_table();

        if self.inherited_table.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_table.mutate()
            .reset_border_spacing(
                reset_struct,
            );
    }

    /// Set the `border_spacing` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_spacing(
        &mut self,
        value: longhands::border_spacing::computed_value::T
    ) {

        self.inherited_table.mutate()
            .set_border_spacing(
                value,
            );
    }
    /// Inherit `box_shadow` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_box_shadow(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_effects();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.effects.ptr_eq(inherited_struct) {
            return;
        }

        self.effects.mutate()
            .copy_box_shadow_from(
                inherited_struct,
            );
    }

    /// Set the `box_shadow` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_box_shadow(
        &mut self,
        value: longhands::box_shadow::computed_value::T
    ) {
        self.modified_reset = true;

        self.effects.mutate()
            .set_box_shadow(
                value,
            );
    }
    /// Reset `caret_color` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_caret_color(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_ui();

        if self.inherited_ui.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_ui.mutate()
            .reset_caret_color(
                reset_struct,
            );
    }

    /// Set the `caret_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_caret_color(
        &mut self,
        value: longhands::caret_color::computed_value::T
    ) {

        self.inherited_ui.mutate()
            .set_caret_color(
                value,
            );
    }
    /// Inherit `clip_path` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_clip_path(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_svg();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.svg.ptr_eq(inherited_struct) {
            return;
        }

        self.svg.mutate()
            .copy_clip_path_from(
                inherited_struct,
            );
    }

    /// Set the `clip_path` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_clip_path(
        &mut self,
        value: longhands::clip_path::computed_value::T
    ) {
        self.modified_reset = true;

        self.svg.mutate()
            .set_clip_path(
                value,
            );
    }
    /// Reset `color` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_color(&mut self) {
        let reset_struct =
            self.reset_style.get_color();

        if self.color.ptr_eq(reset_struct) {
            return;
        }

        self.color.mutate()
            .reset_color(
                reset_struct,
            );
    }

    /// Set the `color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_color(
        &mut self,
        value: longhands::color::computed_value::T
    ) {

        self.color.mutate()
            .set_color(
                value,
            );
    }
    /// Inherit `column_width` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_column_width(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_column();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.column.ptr_eq(inherited_struct) {
            return;
        }

        self.column.mutate()
            .copy_column_width_from(
                inherited_struct,
            );
    }

    /// Set the `column_width` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_column_width(
        &mut self,
        value: longhands::column_width::computed_value::T
    ) {
        self.modified_reset = true;

        self.column.mutate()
            .set_column_width(
                value,
            );
    }
    /// Inherit `content` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_content(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_counters();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);

        self.add_flags(ComputedValueFlags::INHERITS_CONTENT);


        if self.counters.ptr_eq(inherited_struct) {
            return;
        }

        self.counters.mutate()
            .copy_content_from(
                inherited_struct,
            );
    }

    /// Set the `content` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_content(
        &mut self,
        value: longhands::content::computed_value::T
    ) {
        self.modified_reset = true;

        self.counters.mutate()
            .set_content(
                value,
            );
    }
    /// Inherit `counter_increment` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_counter_increment(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_counters();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.counters.ptr_eq(inherited_struct) {
            return;
        }

        self.counters.mutate()
            .copy_counter_increment_from(
                inherited_struct,
            );
    }

    /// Set the `counter_increment` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_counter_increment(
        &mut self,
        value: longhands::counter_increment::computed_value::T
    ) {
        self.modified_reset = true;

        self.counters.mutate()
            .set_counter_increment(
                value,
            );
    }
    /// Reset `cursor` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_cursor(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_ui();

        if self.inherited_ui.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_ui.mutate()
            .reset_cursor(
                reset_struct,
            );
    }

    /// Set the `cursor` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_cursor(
        &mut self,
        value: longhands::cursor::computed_value::T
    ) {

        self.inherited_ui.mutate()
            .set_cursor(
                value,
            );
    }
    /// Inherit `filter` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_filter(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_effects();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.effects.ptr_eq(inherited_struct) {
            return;
        }

        self.effects.mutate()
            .copy_filter_from(
                inherited_struct,
            );
    }

    /// Inherit `flex_basis` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_flex_basis(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_flex_basis_from(
                inherited_struct,
            );
    }

    /// Set the `flex_basis` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_flex_basis(
        &mut self,
        value: longhands::flex_basis::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_flex_basis(
                value,
            );
    }
    /// Reset `font_family` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_font_family(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset_font_family(
                reset_struct,
            );
    }

    /// Set the `font_family` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_font_family(
        &mut self,
        value: longhands::font_family::computed_value::T
    ) {

        self.font.mutate()
            .set_font_family(
                value,
            );
    }
    /// Reset `font_feature_settings` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_font_feature_settings(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset_font_feature_settings(
                reset_struct,
            );
    }

    /// Set the `font_feature_settings` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_font_feature_settings(
        &mut self,
        value: longhands::font_feature_settings::computed_value::T
    ) {

        self.font.mutate()
            .set_font_feature_settings(
                value,
            );
    }
    /// Reset `font_language_override` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_font_language_override(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset_font_language_override(
                reset_struct,
            );
    }

    /// Set the `font_language_override` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_font_language_override(
        &mut self,
        value: longhands::font_language_override::computed_value::T
    ) {

        self.font.mutate()
            .set_font_language_override(
                value,
            );
    }
    /// Reset `font_size` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_font_size(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset_font_size(
                reset_struct,
            );
    }

    /// Set the `font_size` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_font_size(
        &mut self,
        value: longhands::font_size::computed_value::T
    ) {

        self.font.mutate()
            .set_font_size(
                value,
            );
    }
    /// Reset `font_variant_alternates` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_font_variant_alternates(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset_font_variant_alternates(
                reset_struct,
            );
    }

    /// Set the `font_variant_alternates` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_font_variant_alternates(
        &mut self,
        value: longhands::font_variant_alternates::computed_value::T
    ) {

        self.font.mutate()
            .set_font_variant_alternates(
                value,
            );
    }
    /// Reset `font_variation_settings` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_font_variation_settings(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset_font_variation_settings(
                reset_struct,
            );
    }

    /// Set the `font_variation_settings` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_font_variation_settings(
        &mut self,
        value: longhands::font_variation_settings::computed_value::T
    ) {

        self.font.mutate()
            .set_font_variation_settings(
                value,
            );
    }
    /// Inherit `grid_template_areas` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_grid_template_areas(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_grid_template_areas_from(
                inherited_struct,
            );
    }

    /// Set the `grid_template_areas` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_grid_template_areas(
        &mut self,
        value: longhands::grid_template_areas::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_grid_template_areas(
                value,
            );
    }
    /// Reset `letter_spacing` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_letter_spacing(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_letter_spacing(
                reset_struct,
            );
    }

    /// Set the `letter_spacing` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_letter_spacing(
        &mut self,
        value: longhands::letter_spacing::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_letter_spacing(
                value,
            );
    }
    /// Reset `line_height` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_line_height(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_line_height(
                reset_struct,
            );
    }

    /// Set the `line_height` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_line_height(
        &mut self,
        value: longhands::line_height::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_line_height(
                value,
            );
    }
    /// Reset `list_style_image` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_list_style_image(&mut self) {
        let reset_struct =
            self.reset_style.get_list();

        if self.list.ptr_eq(reset_struct) {
            return;
        }

        self.list.mutate()
            .reset_list_style_image(
                reset_struct,
            );
    }

    /// Set the `list_style_image` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_list_style_image(
        &mut self,
        value: longhands::list_style_image::computed_value::T
    ) {

        self.list.mutate()
            .set_list_style_image(
                value,
            );
    }
    /// Reset `list_style_type` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_list_style_type(&mut self) {
        let reset_struct =
            self.reset_style.get_list();

        if self.list.ptr_eq(reset_struct) {
            return;
        }

        self.list.mutate()
            .reset_list_style_type(
                reset_struct,
            );
    }

    /// Set the `list_style_type` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_list_style_type(
        &mut self,
        value: longhands::list_style_type::computed_value::T
    ) {

        self.list.mutate()
            .set_list_style_type(
                value,
            );
    }
    /// Inherit `mask_clip` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_mask_clip(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_svg();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.svg.ptr_eq(inherited_struct) {
            return;
        }

        self.svg.mutate()
            .copy_mask_clip_from(
                inherited_struct,
            );
    }

    /// Inherit `mask_composite` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_mask_composite(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_svg();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.svg.ptr_eq(inherited_struct) {
            return;
        }

        self.svg.mutate()
            .copy_mask_composite_from(
                inherited_struct,
            );
    }

    /// Inherit `mask_image` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_mask_image(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_svg();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.svg.ptr_eq(inherited_struct) {
            return;
        }

        self.svg.mutate()
            .copy_mask_image_from(
                inherited_struct,
            );
    }

    /// Inherit `mask_mode` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_mask_mode(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_svg();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.svg.ptr_eq(inherited_struct) {
            return;
        }

        self.svg.mutate()
            .copy_mask_mode_from(
                inherited_struct,
            );
    }

    /// Inherit `mask_origin` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_mask_origin(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_svg();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.svg.ptr_eq(inherited_struct) {
            return;
        }

        self.svg.mutate()
            .copy_mask_origin_from(
                inherited_struct,
            );
    }

    /// Inherit `mask_position_x` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_mask_position_x(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_svg();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.svg.ptr_eq(inherited_struct) {
            return;
        }

        self.svg.mutate()
            .copy_mask_position_x_from(
                inherited_struct,
            );
    }

    /// Inherit `mask_position_y` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_mask_position_y(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_svg();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.svg.ptr_eq(inherited_struct) {
            return;
        }

        self.svg.mutate()
            .copy_mask_position_y_from(
                inherited_struct,
            );
    }

    /// Inherit `mask_repeat` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_mask_repeat(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_svg();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.svg.ptr_eq(inherited_struct) {
            return;
        }

        self.svg.mutate()
            .copy_mask_repeat_from(
                inherited_struct,
            );
    }

    /// Inherit `mask_size` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_mask_size(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_svg();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.svg.ptr_eq(inherited_struct) {
            return;
        }

        self.svg.mutate()
            .copy_mask_size_from(
                inherited_struct,
            );
    }

    /// Reset `_moz_context_properties` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__moz_context_properties(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset__moz_context_properties(
                reset_struct,
            );
    }

    /// Set the `_moz_context_properties` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_context_properties(
        &mut self,
        value: longhands::_moz_context_properties::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set__moz_context_properties(
                value,
            );
    }
    /// Reset `_moz_font_smoothing_background_color` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__moz_font_smoothing_background_color(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset__moz_font_smoothing_background_color(
                reset_struct,
            );
    }

    /// Set the `_moz_font_smoothing_background_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_font_smoothing_background_color(
        &mut self,
        value: longhands::_moz_font_smoothing_background_color::computed_value::T
    ) {

        self.font.mutate()
            .set__moz_font_smoothing_background_color(
                value,
            );
    }
    /// Reset `_moz_tab_size` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__moz_tab_size(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset__moz_tab_size(
                reset_struct,
            );
    }

    /// Set the `_moz_tab_size` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_tab_size(
        &mut self,
        value: longhands::_moz_tab_size::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set__moz_tab_size(
                value,
            );
    }
    /// Inherit `offset_path` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_offset_path(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_offset_path_from(
                inherited_struct,
            );
    }

    /// Set the `offset_path` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_offset_path(
        &mut self,
        value: longhands::offset_path::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_offset_path(
                value,
            );
    }
    /// Inherit `perspective` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_perspective(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_perspective_from(
                inherited_struct,
            );
    }

    /// Set the `perspective` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_perspective(
        &mut self,
        value: longhands::perspective::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_perspective(
                value,
            );
    }
    /// Reset `quotes` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_quotes(&mut self) {
        let reset_struct =
            self.reset_style.get_list();

        if self.list.ptr_eq(reset_struct) {
            return;
        }

        self.list.mutate()
            .reset_quotes(
                reset_struct,
            );
    }

    /// Set the `quotes` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_quotes(
        &mut self,
        value: longhands::quotes::computed_value::T
    ) {

        self.list.mutate()
            .set_quotes(
                value,
            );
    }
    /// Inherit `rotate` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_rotate(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_rotate_from(
                inherited_struct,
            );
    }

    /// Set the `rotate` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_rotate(
        &mut self,
        value: longhands::rotate::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_rotate(
                value,
            );
    }
    /// Inherit `scale` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scale(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_scale_from(
                inherited_struct,
            );
    }

    /// Set the `scale` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scale(
        &mut self,
        value: longhands::scale::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_scale(
                value,
            );
    }
    /// Inherit `scroll_snap_coordinate` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_snap_coordinate(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_scroll_snap_coordinate_from(
                inherited_struct,
            );
    }

    /// Reset `scrollbar_color` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_scrollbar_color(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_ui();

        if self.inherited_ui.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_ui.mutate()
            .reset_scrollbar_color(
                reset_struct,
            );
    }

    /// Set the `scrollbar_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scrollbar_color(
        &mut self,
        value: longhands::scrollbar_color::computed_value::T
    ) {

        self.inherited_ui.mutate()
            .set_scrollbar_color(
                value,
            );
    }
    /// Inherit `shape_outside` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_shape_outside(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_shape_outside_from(
                inherited_struct,
            );
    }

    /// Set the `shape_outside` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_shape_outside(
        &mut self,
        value: longhands::shape_outside::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_shape_outside(
                value,
            );
    }
    /// Reset `stroke_dasharray` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_stroke_dasharray(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_stroke_dasharray(
                reset_struct,
            );
    }

    /// Set the `stroke_dasharray` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_stroke_dasharray(
        &mut self,
        value: longhands::stroke_dasharray::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_stroke_dasharray(
                value,
            );
    }
    /// Reset `stroke_dashoffset` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_stroke_dashoffset(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_stroke_dashoffset(
                reset_struct,
            );
    }

    /// Set the `stroke_dashoffset` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_stroke_dashoffset(
        &mut self,
        value: longhands::stroke_dashoffset::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_stroke_dashoffset(
                value,
            );
    }
    /// Reset `stroke_width` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_stroke_width(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_stroke_width(
                reset_struct,
            );
    }

    /// Set the `stroke_width` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_stroke_width(
        &mut self,
        value: longhands::stroke_width::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_stroke_width(
                value,
            );
    }
    /// Reset `text_emphasis_style` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_text_emphasis_style(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_text_emphasis_style(
                reset_struct,
            );
    }

    /// Set the `text_emphasis_style` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_text_emphasis_style(
        &mut self,
        value: longhands::text_emphasis_style::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_text_emphasis_style(
                value,
            );
    }
    /// Reset `text_indent` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_text_indent(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_text_indent(
                reset_struct,
            );
    }

    /// Set the `text_indent` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_text_indent(
        &mut self,
        value: longhands::text_indent::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_text_indent(
                value,
            );
    }
    /// Inherit `text_overflow` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_text_overflow(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_text();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.text.ptr_eq(inherited_struct) {
            return;
        }

        self.text.mutate()
            .copy_text_overflow_from(
                inherited_struct,
            );
    }

    /// Set the `text_overflow` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_text_overflow(
        &mut self,
        value: longhands::text_overflow::computed_value::T
    ) {
        self.modified_reset = true;

        self.text.mutate()
            .set_text_overflow(
                value,
            );
    }
    /// Reset `text_shadow` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_text_shadow(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_text_shadow(
                reset_struct,
            );
    }

    /// Set the `text_shadow` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_text_shadow(
        &mut self,
        value: longhands::text_shadow::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_text_shadow(
                value,
            );
    }
    /// Inherit `transition_delay` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_transition_delay(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_transition_delay_from(
                inherited_struct,
            );
    }

    /// Inherit `transition_duration` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_transition_duration(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_transition_duration_from(
                inherited_struct,
            );
    }

    /// Inherit `transition_property` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_transition_property(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_transition_property_from(
                inherited_struct,
            );
    }

    /// Inherit `transition_timing_function` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_transition_timing_function(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_transition_timing_function_from(
                inherited_struct,
            );
    }

    /// Inherit `translate` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_translate(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_translate_from(
                inherited_struct,
            );
    }

    /// Set the `translate` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_translate(
        &mut self,
        value: longhands::translate::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_translate(
                value,
            );
    }
    /// Inherit `vertical_align` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_vertical_align(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_vertical_align_from(
                inherited_struct,
            );
    }

    /// Set the `vertical_align` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_vertical_align(
        &mut self,
        value: longhands::vertical_align::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_vertical_align(
                value,
            );
    }
    /// Inherit `will_change` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_will_change(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_will_change_from(
                inherited_struct,
            );
    }

    /// Set the `will_change` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_will_change(
        &mut self,
        value: longhands::will_change::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_will_change(
                value,
            );
    }
    /// Reset `word_spacing` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_word_spacing(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_word_spacing(
                reset_struct,
            );
    }

    /// Set the `word_spacing` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_word_spacing(
        &mut self,
        value: longhands::word_spacing::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_word_spacing(
                value,
            );
    }
    /// Reset `_x_lang` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__x_lang(&mut self) {
        let reset_struct =
            self.reset_style.get_font();

        if self.font.ptr_eq(reset_struct) {
            return;
        }

        self.font.mutate()
            .reset__x_lang(
                reset_struct,
            );
    }

    /// Set the `_x_lang` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__x_lang(
        &mut self,
        value: longhands::_x_lang::computed_value::T
    ) {

        self.font.mutate()
            .set__x_lang(
                value,
            );
    }
    /// Inherit `clip` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_clip(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_effects();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.effects.ptr_eq(inherited_struct) {
            return;
        }

        self.effects.mutate()
            .copy_clip_from(
                inherited_struct,
            );
    }

    /// Set the `clip` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_clip(
        &mut self,
        value: longhands::clip::computed_value::T
    ) {
        self.modified_reset = true;

        self.effects.mutate()
            .set_clip(
                value,
            );
    }
    /// Reset `_moz_image_region` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__moz_image_region(&mut self) {
        let reset_struct =
            self.reset_style.get_list();

        if self.list.ptr_eq(reset_struct) {
            return;
        }

        self.list.mutate()
            .reset__moz_image_region(
                reset_struct,
            );
    }

    /// Set the `_moz_image_region` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_image_region(
        &mut self,
        value: longhands::_moz_image_region::computed_value::T
    ) {

        self.list.mutate()
            .set__moz_image_region(
                value,
            );
    }
    /// Inherit `grid_template_columns` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_grid_template_columns(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_grid_template_columns_from(
                inherited_struct,
            );
    }

    /// Set the `grid_template_columns` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_grid_template_columns(
        &mut self,
        value: longhands::grid_template_columns::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_grid_template_columns(
                value,
            );
    }
    /// Inherit `grid_template_rows` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_grid_template_rows(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_grid_template_rows_from(
                inherited_struct,
            );
    }

    /// Set the `grid_template_rows` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_grid_template_rows(
        &mut self,
        value: longhands::grid_template_rows::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_grid_template_rows(
                value,
            );
    }
    /// Reset `fill` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_fill(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_fill(
                reset_struct,
            );
    }

    /// Set the `fill` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_fill(
        &mut self,
        value: longhands::fill::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_fill(
                value,
            );
    }
    /// Reset `stroke` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_stroke(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_stroke(
                reset_struct,
            );
    }

    /// Set the `stroke` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_stroke(
        &mut self,
        value: longhands::stroke::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_stroke(
                value,
            );
    }
    /// Inherit `grid_auto_columns` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_grid_auto_columns(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_grid_auto_columns_from(
                inherited_struct,
            );
    }

    /// Set the `grid_auto_columns` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_grid_auto_columns(
        &mut self,
        value: longhands::grid_auto_columns::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_grid_auto_columns(
                value,
            );
    }
    /// Inherit `grid_auto_rows` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_grid_auto_rows(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_grid_auto_rows_from(
                inherited_struct,
            );
    }

    /// Set the `grid_auto_rows` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_grid_auto_rows(
        &mut self,
        value: longhands::grid_auto_rows::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_grid_auto_rows(
                value,
            );
    }
    /// Inherit `_moz_window_transform_origin` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_window_transform_origin(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_ui();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.ui.ptr_eq(inherited_struct) {
            return;
        }

        self.ui.mutate()
            .copy__moz_window_transform_origin_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_window_transform_origin` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_window_transform_origin(
        &mut self,
        value: longhands::_moz_window_transform_origin::computed_value::T
    ) {
        self.modified_reset = true;

        self.ui.mutate()
            .set__moz_window_transform_origin(
                value,
            );
    }
    /// Inherit `transform_origin` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_transform_origin(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_transform_origin_from(
                inherited_struct,
            );
    }

    /// Set the `transform_origin` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_transform_origin(
        &mut self,
        value: longhands::transform_origin::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_transform_origin(
                value,
            );
    }
    /// Inherit `counter_reset` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_counter_reset(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_counters();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.counters.ptr_eq(inherited_struct) {
            return;
        }

        self.counters.mutate()
            .copy_counter_reset_from(
                inherited_struct,
            );
    }

    /// Set the `counter_reset` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_counter_reset(
        &mut self,
        value: longhands::counter_reset::computed_value::T
    ) {
        self.modified_reset = true;

        self.counters.mutate()
            .set_counter_reset(
                value,
            );
    }
    /// Inherit `counter_set` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_counter_set(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_counters();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.counters.ptr_eq(inherited_struct) {
            return;
        }

        self.counters.mutate()
            .copy_counter_set_from(
                inherited_struct,
            );
    }

    /// Set the `counter_set` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_counter_set(
        &mut self,
        value: longhands::counter_set::computed_value::T
    ) {
        self.modified_reset = true;

        self.counters.mutate()
            .set_counter_set(
                value,
            );
    }
    /// Inherit `scroll_snap_points_x` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_snap_points_x(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_scroll_snap_points_x_from(
                inherited_struct,
            );
    }

    /// Set the `scroll_snap_points_x` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_snap_points_x(
        &mut self,
        value: longhands::scroll_snap_points_x::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_scroll_snap_points_x(
                value,
            );
    }
    /// Inherit `scroll_snap_points_y` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_snap_points_y(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_scroll_snap_points_y_from(
                inherited_struct,
            );
    }

    /// Set the `scroll_snap_points_y` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_snap_points_y(
        &mut self,
        value: longhands::scroll_snap_points_y::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_scroll_snap_points_y(
                value,
            );
    }
    /// Inherit `_moz_window_transform` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_window_transform(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_ui();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.ui.ptr_eq(inherited_struct) {
            return;
        }

        self.ui.mutate()
            .copy__moz_window_transform_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_window_transform` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_window_transform(
        &mut self,
        value: longhands::_moz_window_transform::computed_value::T
    ) {
        self.modified_reset = true;

        self.ui.mutate()
            .set__moz_window_transform(
                value,
            );
    }
    /// Inherit `transform` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_transform(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_transform_from(
                inherited_struct,
            );
    }

    /// Set the `transform` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_transform(
        &mut self,
        value: longhands::transform::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_transform(
                value,
            );
    }
    /// Inherit `column_gap` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_column_gap(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_column_gap_from(
                inherited_struct,
            );
    }

    /// Set the `column_gap` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_column_gap(
        &mut self,
        value: longhands::column_gap::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_column_gap(
                value,
            );
    }
    /// Inherit `row_gap` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_row_gap(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_row_gap_from(
                inherited_struct,
            );
    }

    /// Set the `row_gap` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_row_gap(
        &mut self,
        value: longhands::row_gap::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_row_gap(
                value,
            );
    }
    /// Inherit `object_position` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_object_position(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_object_position_from(
                inherited_struct,
            );
    }

    /// Set the `object_position` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_object_position(
        &mut self,
        value: longhands::object_position::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_object_position(
                value,
            );
    }
    /// Inherit `perspective_origin` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_perspective_origin(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_perspective_origin_from(
                inherited_struct,
            );
    }

    /// Set the `perspective_origin` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_perspective_origin(
        &mut self,
        value: longhands::perspective_origin::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_perspective_origin(
                value,
            );
    }
    /// Inherit `scroll_snap_destination` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_snap_destination(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_scroll_snap_destination_from(
                inherited_struct,
            );
    }

    /// Set the `scroll_snap_destination` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_snap_destination(
        &mut self,
        value: longhands::scroll_snap_destination::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_scroll_snap_destination(
                value,
            );
    }
    /// Inherit `grid_column_end` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_grid_column_end(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_grid_column_end_from(
                inherited_struct,
            );
    }

    /// Set the `grid_column_end` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_grid_column_end(
        &mut self,
        value: longhands::grid_column_end::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_grid_column_end(
                value,
            );
    }
    /// Inherit `grid_column_start` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_grid_column_start(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_grid_column_start_from(
                inherited_struct,
            );
    }

    /// Set the `grid_column_start` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_grid_column_start(
        &mut self,
        value: longhands::grid_column_start::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_grid_column_start(
                value,
            );
    }
    /// Inherit `grid_row_end` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_grid_row_end(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_grid_row_end_from(
                inherited_struct,
            );
    }

    /// Set the `grid_row_end` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_grid_row_end(
        &mut self,
        value: longhands::grid_row_end::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_grid_row_end(
                value,
            );
    }
    /// Inherit `grid_row_start` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_grid_row_start(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_grid_row_start_from(
                inherited_struct,
            );
    }

    /// Set the `grid_row_start` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_grid_row_start(
        &mut self,
        value: longhands::grid_row_start::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_grid_row_start(
                value,
            );
    }
    /// Inherit `max_block_size` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_max_block_size(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_max_block_size_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `max_block_size` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_max_block_size(
        &mut self,
        value: longhands::max_block_size::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_max_block_size(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `max_height` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_max_height(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_max_height_from(
                inherited_struct,
            );
    }

    /// Set the `max_height` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_max_height(
        &mut self,
        value: longhands::max_height::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_max_height(
                value,
            );
    }
    /// Inherit `max_inline_size` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_max_inline_size(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_max_inline_size_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `max_inline_size` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_max_inline_size(
        &mut self,
        value: longhands::max_inline_size::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_max_inline_size(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `max_width` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_max_width(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_max_width_from(
                inherited_struct,
            );
    }

    /// Set the `max_width` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_max_width(
        &mut self,
        value: longhands::max_width::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_max_width(
                value,
            );
    }
    /// Reset `marker_end` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_marker_end(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_marker_end(
                reset_struct,
            );
    }

    /// Set the `marker_end` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_marker_end(
        &mut self,
        value: longhands::marker_end::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_marker_end(
                value,
            );
    }
    /// Reset `marker_mid` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_marker_mid(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_marker_mid(
                reset_struct,
            );
    }

    /// Set the `marker_mid` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_marker_mid(
        &mut self,
        value: longhands::marker_mid::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_marker_mid(
                value,
            );
    }
    /// Reset `marker_start` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_marker_start(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_svg();

        if self.inherited_svg.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_svg.mutate()
            .reset_marker_start(
                reset_struct,
            );
    }

    /// Set the `marker_start` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_marker_start(
        &mut self,
        value: longhands::marker_start::computed_value::T
    ) {

        self.inherited_svg.mutate()
            .set_marker_start(
                value,
            );
    }
    /// Inherit `_moz_binding` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_binding(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy__moz_binding_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_binding` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_binding(
        &mut self,
        value: longhands::_moz_binding::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set__moz_binding(
                value,
            );
    }
    /// Inherit `scroll_padding_block_end` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_padding_block_end(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_padding();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.padding.ptr_eq(inherited_struct) {
            return;
        }

        self.padding.mutate()
            .copy_scroll_padding_block_end_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `scroll_padding_block_end` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_block_end(
        &mut self,
        value: longhands::scroll_padding_block_end::computed_value::T
    ) {
        self.modified_reset = true;

        self.padding.mutate()
            .set_scroll_padding_block_end(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `scroll_padding_block_start` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_padding_block_start(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_padding();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.padding.ptr_eq(inherited_struct) {
            return;
        }

        self.padding.mutate()
            .copy_scroll_padding_block_start_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `scroll_padding_block_start` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_block_start(
        &mut self,
        value: longhands::scroll_padding_block_start::computed_value::T
    ) {
        self.modified_reset = true;

        self.padding.mutate()
            .set_scroll_padding_block_start(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `scroll_padding_bottom` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_padding_bottom(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_padding();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.padding.ptr_eq(inherited_struct) {
            return;
        }

        self.padding.mutate()
            .copy_scroll_padding_bottom_from(
                inherited_struct,
            );
    }

    /// Set the `scroll_padding_bottom` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_bottom(
        &mut self,
        value: longhands::scroll_padding_bottom::computed_value::T
    ) {
        self.modified_reset = true;

        self.padding.mutate()
            .set_scroll_padding_bottom(
                value,
            );
    }
    /// Inherit `scroll_padding_inline_end` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_padding_inline_end(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_padding();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.padding.ptr_eq(inherited_struct) {
            return;
        }

        self.padding.mutate()
            .copy_scroll_padding_inline_end_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `scroll_padding_inline_end` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_inline_end(
        &mut self,
        value: longhands::scroll_padding_inline_end::computed_value::T
    ) {
        self.modified_reset = true;

        self.padding.mutate()
            .set_scroll_padding_inline_end(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `scroll_padding_inline_start` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_padding_inline_start(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_padding();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.padding.ptr_eq(inherited_struct) {
            return;
        }

        self.padding.mutate()
            .copy_scroll_padding_inline_start_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `scroll_padding_inline_start` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_inline_start(
        &mut self,
        value: longhands::scroll_padding_inline_start::computed_value::T
    ) {
        self.modified_reset = true;

        self.padding.mutate()
            .set_scroll_padding_inline_start(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `scroll_padding_left` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_padding_left(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_padding();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.padding.ptr_eq(inherited_struct) {
            return;
        }

        self.padding.mutate()
            .copy_scroll_padding_left_from(
                inherited_struct,
            );
    }

    /// Set the `scroll_padding_left` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_left(
        &mut self,
        value: longhands::scroll_padding_left::computed_value::T
    ) {
        self.modified_reset = true;

        self.padding.mutate()
            .set_scroll_padding_left(
                value,
            );
    }
    /// Inherit `scroll_padding_right` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_padding_right(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_padding();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.padding.ptr_eq(inherited_struct) {
            return;
        }

        self.padding.mutate()
            .copy_scroll_padding_right_from(
                inherited_struct,
            );
    }

    /// Set the `scroll_padding_right` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_right(
        &mut self,
        value: longhands::scroll_padding_right::computed_value::T
    ) {
        self.modified_reset = true;

        self.padding.mutate()
            .set_scroll_padding_right(
                value,
            );
    }
    /// Inherit `scroll_padding_top` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_padding_top(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_padding();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.padding.ptr_eq(inherited_struct) {
            return;
        }

        self.padding.mutate()
            .copy_scroll_padding_top_from(
                inherited_struct,
            );
    }

    /// Set the `scroll_padding_top` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_top(
        &mut self,
        value: longhands::scroll_padding_top::computed_value::T
    ) {
        self.modified_reset = true;

        self.padding.mutate()
            .set_scroll_padding_top(
                value,
            );
    }
    /// Inherit `block_size` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_block_size(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_block_size_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `block_size` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_block_size(
        &mut self,
        value: longhands::block_size::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_block_size(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `height` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_height(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_height_from(
                inherited_struct,
            );
    }

    /// Set the `height` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_height(
        &mut self,
        value: longhands::height::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_height(
                value,
            );
    }
    /// Inherit `inline_size` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_inline_size(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_inline_size_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `inline_size` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_inline_size(
        &mut self,
        value: longhands::inline_size::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_inline_size(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `min_block_size` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_min_block_size(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_min_block_size_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `min_block_size` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_min_block_size(
        &mut self,
        value: longhands::min_block_size::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_min_block_size(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `min_height` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_min_height(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_min_height_from(
                inherited_struct,
            );
    }

    /// Set the `min_height` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_min_height(
        &mut self,
        value: longhands::min_height::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_min_height(
                value,
            );
    }
    /// Inherit `min_inline_size` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_min_inline_size(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_min_inline_size_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `min_inline_size` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_min_inline_size(
        &mut self,
        value: longhands::min_inline_size::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_min_inline_size(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `min_width` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_min_width(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_min_width_from(
                inherited_struct,
            );
    }

    /// Set the `min_width` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_min_width(
        &mut self,
        value: longhands::min_width::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_min_width(
                value,
            );
    }
    /// Inherit `width` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_width(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_width_from(
                inherited_struct,
            );
    }

    /// Set the `width` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_width(
        &mut self,
        value: longhands::width::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_width(
                value,
            );
    }
    /// Inherit `outline_offset` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_outline_offset(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_outline();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.outline.ptr_eq(inherited_struct) {
            return;
        }

        self.outline.mutate()
            .copy_outline_offset_from(
                inherited_struct,
            );
    }

    /// Set the `outline_offset` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_outline_offset(
        &mut self,
        value: longhands::outline_offset::computed_value::T
    ) {
        self.modified_reset = true;

        self.outline.mutate()
            .set_outline_offset(
                value,
            );
    }
    /// Inherit `scroll_margin_block_end` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_margin_block_end(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_margin();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.margin.ptr_eq(inherited_struct) {
            return;
        }

        self.margin.mutate()
            .copy_scroll_margin_block_end_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `scroll_margin_block_end` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_block_end(
        &mut self,
        value: longhands::scroll_margin_block_end::computed_value::T
    ) {
        self.modified_reset = true;

        self.margin.mutate()
            .set_scroll_margin_block_end(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `scroll_margin_block_start` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_margin_block_start(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_margin();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.margin.ptr_eq(inherited_struct) {
            return;
        }

        self.margin.mutate()
            .copy_scroll_margin_block_start_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `scroll_margin_block_start` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_block_start(
        &mut self,
        value: longhands::scroll_margin_block_start::computed_value::T
    ) {
        self.modified_reset = true;

        self.margin.mutate()
            .set_scroll_margin_block_start(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `scroll_margin_bottom` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_margin_bottom(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_margin();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.margin.ptr_eq(inherited_struct) {
            return;
        }

        self.margin.mutate()
            .copy_scroll_margin_bottom_from(
                inherited_struct,
            );
    }

    /// Set the `scroll_margin_bottom` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_bottom(
        &mut self,
        value: longhands::scroll_margin_bottom::computed_value::T
    ) {
        self.modified_reset = true;

        self.margin.mutate()
            .set_scroll_margin_bottom(
                value,
            );
    }
    /// Inherit `scroll_margin_inline_end` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_margin_inline_end(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_margin();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.margin.ptr_eq(inherited_struct) {
            return;
        }

        self.margin.mutate()
            .copy_scroll_margin_inline_end_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `scroll_margin_inline_end` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_inline_end(
        &mut self,
        value: longhands::scroll_margin_inline_end::computed_value::T
    ) {
        self.modified_reset = true;

        self.margin.mutate()
            .set_scroll_margin_inline_end(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `scroll_margin_inline_start` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_margin_inline_start(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_margin();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.margin.ptr_eq(inherited_struct) {
            return;
        }

        self.margin.mutate()
            .copy_scroll_margin_inline_start_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `scroll_margin_inline_start` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_inline_start(
        &mut self,
        value: longhands::scroll_margin_inline_start::computed_value::T
    ) {
        self.modified_reset = true;

        self.margin.mutate()
            .set_scroll_margin_inline_start(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `scroll_margin_left` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_margin_left(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_margin();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.margin.ptr_eq(inherited_struct) {
            return;
        }

        self.margin.mutate()
            .copy_scroll_margin_left_from(
                inherited_struct,
            );
    }

    /// Set the `scroll_margin_left` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_left(
        &mut self,
        value: longhands::scroll_margin_left::computed_value::T
    ) {
        self.modified_reset = true;

        self.margin.mutate()
            .set_scroll_margin_left(
                value,
            );
    }
    /// Inherit `scroll_margin_right` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_margin_right(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_margin();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.margin.ptr_eq(inherited_struct) {
            return;
        }

        self.margin.mutate()
            .copy_scroll_margin_right_from(
                inherited_struct,
            );
    }

    /// Set the `scroll_margin_right` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_right(
        &mut self,
        value: longhands::scroll_margin_right::computed_value::T
    ) {
        self.modified_reset = true;

        self.margin.mutate()
            .set_scroll_margin_right(
                value,
            );
    }
    /// Inherit `scroll_margin_top` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_scroll_margin_top(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_margin();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.margin.ptr_eq(inherited_struct) {
            return;
        }

        self.margin.mutate()
            .copy_scroll_margin_top_from(
                inherited_struct,
            );
    }

    /// Set the `scroll_margin_top` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_top(
        &mut self,
        value: longhands::scroll_margin_top::computed_value::T
    ) {
        self.modified_reset = true;

        self.margin.mutate()
            .set_scroll_margin_top(
                value,
            );
    }
    /// Inherit `padding_block_end` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_padding_block_end(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_padding();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.padding.ptr_eq(inherited_struct) {
            return;
        }

        self.padding.mutate()
            .copy_padding_block_end_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `padding_block_end` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_padding_block_end(
        &mut self,
        value: longhands::padding_block_end::computed_value::T
    ) {
        self.modified_reset = true;

        self.padding.mutate()
            .set_padding_block_end(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `padding_block_start` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_padding_block_start(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_padding();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.padding.ptr_eq(inherited_struct) {
            return;
        }

        self.padding.mutate()
            .copy_padding_block_start_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `padding_block_start` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_padding_block_start(
        &mut self,
        value: longhands::padding_block_start::computed_value::T
    ) {
        self.modified_reset = true;

        self.padding.mutate()
            .set_padding_block_start(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `padding_bottom` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_padding_bottom(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_padding();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.padding.ptr_eq(inherited_struct) {
            return;
        }

        self.padding.mutate()
            .copy_padding_bottom_from(
                inherited_struct,
            );
    }

    /// Set the `padding_bottom` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_padding_bottom(
        &mut self,
        value: longhands::padding_bottom::computed_value::T
    ) {
        self.modified_reset = true;

        self.padding.mutate()
            .set_padding_bottom(
                value,
            );
    }
    /// Inherit `padding_inline_end` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_padding_inline_end(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_padding();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.padding.ptr_eq(inherited_struct) {
            return;
        }

        self.padding.mutate()
            .copy_padding_inline_end_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `padding_inline_end` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_padding_inline_end(
        &mut self,
        value: longhands::padding_inline_end::computed_value::T
    ) {
        self.modified_reset = true;

        self.padding.mutate()
            .set_padding_inline_end(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `padding_inline_start` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_padding_inline_start(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_padding();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.padding.ptr_eq(inherited_struct) {
            return;
        }

        self.padding.mutate()
            .copy_padding_inline_start_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `padding_inline_start` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_padding_inline_start(
        &mut self,
        value: longhands::padding_inline_start::computed_value::T
    ) {
        self.modified_reset = true;

        self.padding.mutate()
            .set_padding_inline_start(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `padding_left` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_padding_left(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_padding();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.padding.ptr_eq(inherited_struct) {
            return;
        }

        self.padding.mutate()
            .copy_padding_left_from(
                inherited_struct,
            );
    }

    /// Set the `padding_left` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_padding_left(
        &mut self,
        value: longhands::padding_left::computed_value::T
    ) {
        self.modified_reset = true;

        self.padding.mutate()
            .set_padding_left(
                value,
            );
    }
    /// Inherit `padding_right` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_padding_right(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_padding();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.padding.ptr_eq(inherited_struct) {
            return;
        }

        self.padding.mutate()
            .copy_padding_right_from(
                inherited_struct,
            );
    }

    /// Set the `padding_right` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_padding_right(
        &mut self,
        value: longhands::padding_right::computed_value::T
    ) {
        self.modified_reset = true;

        self.padding.mutate()
            .set_padding_right(
                value,
            );
    }
    /// Inherit `padding_top` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_padding_top(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_padding();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.padding.ptr_eq(inherited_struct) {
            return;
        }

        self.padding.mutate()
            .copy_padding_top_from(
                inherited_struct,
            );
    }

    /// Set the `padding_top` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_padding_top(
        &mut self,
        value: longhands::padding_top::computed_value::T
    ) {
        self.modified_reset = true;

        self.padding.mutate()
            .set_padding_top(
                value,
            );
    }
    /// Inherit `shape_margin` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_shape_margin(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_box();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.box_.ptr_eq(inherited_struct) {
            return;
        }

        self.box_.mutate()
            .copy_shape_margin_from(
                inherited_struct,
            );
    }

    /// Set the `shape_margin` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_shape_margin(
        &mut self,
        value: longhands::shape_margin::computed_value::T
    ) {
        self.modified_reset = true;

        self.box_.mutate()
            .set_shape_margin(
                value,
            );
    }
    /// Inherit `border_block_end_width` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_block_end_width(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_block_end_width_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `border_block_end_width` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_block_end_width(
        &mut self,
        value: longhands::border_block_end_width::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_block_end_width(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `border_block_start_width` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_block_start_width(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_block_start_width_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `border_block_start_width` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_block_start_width(
        &mut self,
        value: longhands::border_block_start_width::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_block_start_width(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `border_bottom_width` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_bottom_width(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_bottom_width_from(
                inherited_struct,
            );
    }

    /// Set the `border_bottom_width` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_bottom_width(
        &mut self,
        value: longhands::border_bottom_width::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_bottom_width(
                value,
            );
    }
    /// Inherit `border_inline_end_width` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_inline_end_width(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_inline_end_width_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `border_inline_end_width` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_inline_end_width(
        &mut self,
        value: longhands::border_inline_end_width::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_inline_end_width(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `border_inline_start_width` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_inline_start_width(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_inline_start_width_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `border_inline_start_width` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_inline_start_width(
        &mut self,
        value: longhands::border_inline_start_width::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_inline_start_width(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `border_left_width` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_left_width(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_left_width_from(
                inherited_struct,
            );
    }

    /// Set the `border_left_width` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_left_width(
        &mut self,
        value: longhands::border_left_width::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_left_width(
                value,
            );
    }
    /// Inherit `border_right_width` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_right_width(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_right_width_from(
                inherited_struct,
            );
    }

    /// Set the `border_right_width` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_right_width(
        &mut self,
        value: longhands::border_right_width::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_right_width(
                value,
            );
    }
    /// Inherit `border_top_width` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_top_width(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_top_width_from(
                inherited_struct,
            );
    }

    /// Set the `border_top_width` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_top_width(
        &mut self,
        value: longhands::border_top_width::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_top_width(
                value,
            );
    }
    /// Inherit `column_rule_width` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_column_rule_width(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_column();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.column.ptr_eq(inherited_struct) {
            return;
        }

        self.column.mutate()
            .copy_column_rule_width_from(
                inherited_struct,
            );
    }

    /// Set the `column_rule_width` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_column_rule_width(
        &mut self,
        value: longhands::column_rule_width::computed_value::T
    ) {
        self.modified_reset = true;

        self.column.mutate()
            .set_column_rule_width(
                value,
            );
    }
    /// Inherit `outline_width` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_outline_width(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_outline();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.outline.ptr_eq(inherited_struct) {
            return;
        }

        self.outline.mutate()
            .copy_outline_width_from(
                inherited_struct,
            );
    }

    /// Set the `outline_width` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_outline_width(
        &mut self,
        value: longhands::outline_width::computed_value::T
    ) {
        self.modified_reset = true;

        self.outline.mutate()
            .set_outline_width(
                value,
            );
    }
    /// Reset `_webkit_text_stroke_width` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__webkit_text_stroke_width(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset__webkit_text_stroke_width(
                reset_struct,
            );
    }

    /// Set the `_webkit_text_stroke_width` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__webkit_text_stroke_width(
        &mut self,
        value: longhands::_webkit_text_stroke_width::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set__webkit_text_stroke_width(
                value,
            );
    }
    /// Inherit `border_bottom_left_radius` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_bottom_left_radius(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_bottom_left_radius_from(
                inherited_struct,
            );
    }

    /// Set the `border_bottom_left_radius` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_bottom_left_radius(
        &mut self,
        value: longhands::border_bottom_left_radius::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_bottom_left_radius(
                value,
            );
    }
    /// Inherit `border_bottom_right_radius` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_bottom_right_radius(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_bottom_right_radius_from(
                inherited_struct,
            );
    }

    /// Set the `border_bottom_right_radius` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_bottom_right_radius(
        &mut self,
        value: longhands::border_bottom_right_radius::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_bottom_right_radius(
                value,
            );
    }
    /// Inherit `border_end_end_radius` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_end_end_radius(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_end_end_radius_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `border_end_end_radius` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_end_end_radius(
        &mut self,
        value: longhands::border_end_end_radius::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_end_end_radius(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `border_end_start_radius` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_end_start_radius(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_end_start_radius_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `border_end_start_radius` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_end_start_radius(
        &mut self,
        value: longhands::border_end_start_radius::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_end_start_radius(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `border_start_end_radius` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_start_end_radius(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_start_end_radius_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `border_start_end_radius` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_start_end_radius(
        &mut self,
        value: longhands::border_start_end_radius::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_start_end_radius(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `border_start_start_radius` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_start_start_radius(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_start_start_radius_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `border_start_start_radius` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_start_start_radius(
        &mut self,
        value: longhands::border_start_start_radius::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_start_start_radius(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `border_top_left_radius` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_top_left_radius(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_top_left_radius_from(
                inherited_struct,
            );
    }

    /// Set the `border_top_left_radius` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_top_left_radius(
        &mut self,
        value: longhands::border_top_left_radius::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_top_left_radius(
                value,
            );
    }
    /// Inherit `border_top_right_radius` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_top_right_radius(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_top_right_radius_from(
                inherited_struct,
            );
    }

    /// Set the `border_top_right_radius` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_top_right_radius(
        &mut self,
        value: longhands::border_top_right_radius::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_top_right_radius(
                value,
            );
    }
    /// Inherit `_moz_outline_radius_bottomleft` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_outline_radius_bottomleft(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_outline();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.outline.ptr_eq(inherited_struct) {
            return;
        }

        self.outline.mutate()
            .copy__moz_outline_radius_bottomleft_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_outline_radius_bottomleft` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_outline_radius_bottomleft(
        &mut self,
        value: longhands::_moz_outline_radius_bottomleft::computed_value::T
    ) {
        self.modified_reset = true;

        self.outline.mutate()
            .set__moz_outline_radius_bottomleft(
                value,
            );
    }
    /// Inherit `_moz_outline_radius_bottomright` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_outline_radius_bottomright(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_outline();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.outline.ptr_eq(inherited_struct) {
            return;
        }

        self.outline.mutate()
            .copy__moz_outline_radius_bottomright_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_outline_radius_bottomright` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_outline_radius_bottomright(
        &mut self,
        value: longhands::_moz_outline_radius_bottomright::computed_value::T
    ) {
        self.modified_reset = true;

        self.outline.mutate()
            .set__moz_outline_radius_bottomright(
                value,
            );
    }
    /// Inherit `_moz_outline_radius_topleft` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_outline_radius_topleft(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_outline();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.outline.ptr_eq(inherited_struct) {
            return;
        }

        self.outline.mutate()
            .copy__moz_outline_radius_topleft_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_outline_radius_topleft` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_outline_radius_topleft(
        &mut self,
        value: longhands::_moz_outline_radius_topleft::computed_value::T
    ) {
        self.modified_reset = true;

        self.outline.mutate()
            .set__moz_outline_radius_topleft(
                value,
            );
    }
    /// Inherit `_moz_outline_radius_topright` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit__moz_outline_radius_topright(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_outline();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.outline.ptr_eq(inherited_struct) {
            return;
        }

        self.outline.mutate()
            .copy__moz_outline_radius_topright_from(
                inherited_struct,
            );
    }

    /// Set the `_moz_outline_radius_topright` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__moz_outline_radius_topright(
        &mut self,
        value: longhands::_moz_outline_radius_topright::computed_value::T
    ) {
        self.modified_reset = true;

        self.outline.mutate()
            .set__moz_outline_radius_topright(
                value,
            );
    }
    /// Inherit `bottom` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_bottom(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_bottom_from(
                inherited_struct,
            );
    }

    /// Set the `bottom` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_bottom(
        &mut self,
        value: longhands::bottom::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_bottom(
                value,
            );
    }
    /// Inherit `inset_block_end` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_inset_block_end(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_inset_block_end_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `inset_block_end` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_inset_block_end(
        &mut self,
        value: longhands::inset_block_end::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_inset_block_end(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `inset_block_start` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_inset_block_start(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_inset_block_start_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `inset_block_start` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_inset_block_start(
        &mut self,
        value: longhands::inset_block_start::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_inset_block_start(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `inset_inline_end` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_inset_inline_end(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_inset_inline_end_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `inset_inline_end` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_inset_inline_end(
        &mut self,
        value: longhands::inset_inline_end::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_inset_inline_end(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `inset_inline_start` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_inset_inline_start(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_inset_inline_start_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `inset_inline_start` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_inset_inline_start(
        &mut self,
        value: longhands::inset_inline_start::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_inset_inline_start(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `left` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_left(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_left_from(
                inherited_struct,
            );
    }

    /// Set the `left` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_left(
        &mut self,
        value: longhands::left::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_left(
                value,
            );
    }
    /// Inherit `margin_block_end` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_margin_block_end(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_margin();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.margin.ptr_eq(inherited_struct) {
            return;
        }

        self.margin.mutate()
            .copy_margin_block_end_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `margin_block_end` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_margin_block_end(
        &mut self,
        value: longhands::margin_block_end::computed_value::T
    ) {
        self.modified_reset = true;

        self.margin.mutate()
            .set_margin_block_end(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `margin_block_start` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_margin_block_start(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_margin();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.margin.ptr_eq(inherited_struct) {
            return;
        }

        self.margin.mutate()
            .copy_margin_block_start_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `margin_block_start` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_margin_block_start(
        &mut self,
        value: longhands::margin_block_start::computed_value::T
    ) {
        self.modified_reset = true;

        self.margin.mutate()
            .set_margin_block_start(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `margin_bottom` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_margin_bottom(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_margin();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.margin.ptr_eq(inherited_struct) {
            return;
        }

        self.margin.mutate()
            .copy_margin_bottom_from(
                inherited_struct,
            );
    }

    /// Set the `margin_bottom` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_margin_bottom(
        &mut self,
        value: longhands::margin_bottom::computed_value::T
    ) {
        self.modified_reset = true;

        self.margin.mutate()
            .set_margin_bottom(
                value,
            );
    }
    /// Inherit `margin_inline_end` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_margin_inline_end(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_margin();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.margin.ptr_eq(inherited_struct) {
            return;
        }

        self.margin.mutate()
            .copy_margin_inline_end_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `margin_inline_end` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_margin_inline_end(
        &mut self,
        value: longhands::margin_inline_end::computed_value::T
    ) {
        self.modified_reset = true;

        self.margin.mutate()
            .set_margin_inline_end(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `margin_inline_start` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_margin_inline_start(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_margin();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.margin.ptr_eq(inherited_struct) {
            return;
        }

        self.margin.mutate()
            .copy_margin_inline_start_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `margin_inline_start` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_margin_inline_start(
        &mut self,
        value: longhands::margin_inline_start::computed_value::T
    ) {
        self.modified_reset = true;

        self.margin.mutate()
            .set_margin_inline_start(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `margin_left` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_margin_left(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_margin();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.margin.ptr_eq(inherited_struct) {
            return;
        }

        self.margin.mutate()
            .copy_margin_left_from(
                inherited_struct,
            );
    }

    /// Set the `margin_left` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_margin_left(
        &mut self,
        value: longhands::margin_left::computed_value::T
    ) {
        self.modified_reset = true;

        self.margin.mutate()
            .set_margin_left(
                value,
            );
    }
    /// Inherit `margin_right` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_margin_right(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_margin();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.margin.ptr_eq(inherited_struct) {
            return;
        }

        self.margin.mutate()
            .copy_margin_right_from(
                inherited_struct,
            );
    }

    /// Set the `margin_right` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_margin_right(
        &mut self,
        value: longhands::margin_right::computed_value::T
    ) {
        self.modified_reset = true;

        self.margin.mutate()
            .set_margin_right(
                value,
            );
    }
    /// Inherit `margin_top` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_margin_top(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_margin();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.margin.ptr_eq(inherited_struct) {
            return;
        }

        self.margin.mutate()
            .copy_margin_top_from(
                inherited_struct,
            );
    }

    /// Set the `margin_top` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_margin_top(
        &mut self,
        value: longhands::margin_top::computed_value::T
    ) {
        self.modified_reset = true;

        self.margin.mutate()
            .set_margin_top(
                value,
            );
    }
    /// Inherit `right` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_right(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_right_from(
                inherited_struct,
            );
    }

    /// Set the `right` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_right(
        &mut self,
        value: longhands::right::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_right(
                value,
            );
    }
    /// Inherit `top` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_top(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_position();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.position.ptr_eq(inherited_struct) {
            return;
        }

        self.position.mutate()
            .copy_top_from(
                inherited_struct,
            );
    }

    /// Set the `top` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_top(
        &mut self,
        value: longhands::top::computed_value::T
    ) {
        self.modified_reset = true;

        self.position.mutate()
            .set_top(
                value,
            );
    }
    /// Inherit `background_color` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_background_color(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_background();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.background.ptr_eq(inherited_struct) {
            return;
        }

        self.background.mutate()
            .copy_background_color_from(
                inherited_struct,
            );
    }

    /// Set the `background_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_background_color(
        &mut self,
        value: longhands::background_color::computed_value::T
    ) {
        self.modified_reset = true;

        self.background.mutate()
            .set_background_color(
                value,
            );
    }
    /// Inherit `border_block_end_color` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_block_end_color(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_block_end_color_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `border_block_end_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_block_end_color(
        &mut self,
        value: longhands::border_block_end_color::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_block_end_color(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `border_block_start_color` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_block_start_color(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_block_start_color_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `border_block_start_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_block_start_color(
        &mut self,
        value: longhands::border_block_start_color::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_block_start_color(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `border_bottom_color` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_bottom_color(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_bottom_color_from(
                inherited_struct,
            );
    }

    /// Set the `border_bottom_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_bottom_color(
        &mut self,
        value: longhands::border_bottom_color::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_bottom_color(
                value,
            );
    }
    /// Inherit `border_inline_end_color` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_inline_end_color(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_inline_end_color_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `border_inline_end_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_inline_end_color(
        &mut self,
        value: longhands::border_inline_end_color::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_inline_end_color(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `border_inline_start_color` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_inline_start_color(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_inline_start_color_from(
                inherited_struct,
                self.writing_mode,
            );
    }

    /// Set the `border_inline_start_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_inline_start_color(
        &mut self,
        value: longhands::border_inline_start_color::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_inline_start_color(
                value,
                self.writing_mode,
            );
    }
    /// Inherit `border_left_color` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_left_color(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_left_color_from(
                inherited_struct,
            );
    }

    /// Set the `border_left_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_left_color(
        &mut self,
        value: longhands::border_left_color::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_left_color(
                value,
            );
    }
    /// Inherit `border_right_color` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_right_color(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_right_color_from(
                inherited_struct,
            );
    }

    /// Set the `border_right_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_right_color(
        &mut self,
        value: longhands::border_right_color::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_right_color(
                value,
            );
    }
    /// Inherit `border_top_color` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_border_top_color(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_border();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.border.ptr_eq(inherited_struct) {
            return;
        }

        self.border.mutate()
            .copy_border_top_color_from(
                inherited_struct,
            );
    }

    /// Set the `border_top_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_border_top_color(
        &mut self,
        value: longhands::border_top_color::computed_value::T
    ) {
        self.modified_reset = true;

        self.border.mutate()
            .set_border_top_color(
                value,
            );
    }
    /// Inherit `column_rule_color` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_column_rule_color(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_column();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.column.ptr_eq(inherited_struct) {
            return;
        }

        self.column.mutate()
            .copy_column_rule_color_from(
                inherited_struct,
            );
    }

    /// Set the `column_rule_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_column_rule_color(
        &mut self,
        value: longhands::column_rule_color::computed_value::T
    ) {
        self.modified_reset = true;

        self.column.mutate()
            .set_column_rule_color(
                value,
            );
    }
    /// Inherit `flood_color` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_flood_color(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_svg();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.svg.ptr_eq(inherited_struct) {
            return;
        }

        self.svg.mutate()
            .copy_flood_color_from(
                inherited_struct,
            );
    }

    /// Set the `flood_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_flood_color(
        &mut self,
        value: longhands::flood_color::computed_value::T
    ) {
        self.modified_reset = true;

        self.svg.mutate()
            .set_flood_color(
                value,
            );
    }
    /// Inherit `lighting_color` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_lighting_color(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_svg();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.svg.ptr_eq(inherited_struct) {
            return;
        }

        self.svg.mutate()
            .copy_lighting_color_from(
                inherited_struct,
            );
    }

    /// Set the `lighting_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_lighting_color(
        &mut self,
        value: longhands::lighting_color::computed_value::T
    ) {
        self.modified_reset = true;

        self.svg.mutate()
            .set_lighting_color(
                value,
            );
    }
    /// Inherit `outline_color` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_outline_color(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_outline();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.outline.ptr_eq(inherited_struct) {
            return;
        }

        self.outline.mutate()
            .copy_outline_color_from(
                inherited_struct,
            );
    }

    /// Set the `outline_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_outline_color(
        &mut self,
        value: longhands::outline_color::computed_value::T
    ) {
        self.modified_reset = true;

        self.outline.mutate()
            .set_outline_color(
                value,
            );
    }
    /// Inherit `stop_color` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_stop_color(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_svg();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.svg.ptr_eq(inherited_struct) {
            return;
        }

        self.svg.mutate()
            .copy_stop_color_from(
                inherited_struct,
            );
    }

    /// Set the `stop_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_stop_color(
        &mut self,
        value: longhands::stop_color::computed_value::T
    ) {
        self.modified_reset = true;

        self.svg.mutate()
            .set_stop_color(
                value,
            );
    }
    /// Inherit `text_decoration_color` from our parent style.
    #[allow(non_snake_case)]
    pub fn inherit_text_decoration_color(&mut self) {
        let inherited_struct =
            self.inherited_style_ignoring_first_line
                .get_text();

        self.modified_reset = true;
        self.add_flags(ComputedValueFlags::INHERITS_RESET_STYLE);



        if self.text.ptr_eq(inherited_struct) {
            return;
        }

        self.text.mutate()
            .copy_text_decoration_color_from(
                inherited_struct,
            );
    }

    /// Set the `text_decoration_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_text_decoration_color(
        &mut self,
        value: longhands::text_decoration_color::computed_value::T
    ) {
        self.modified_reset = true;

        self.text.mutate()
            .set_text_decoration_color(
                value,
            );
    }
    /// Reset `text_emphasis_color` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset_text_emphasis_color(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset_text_emphasis_color(
                reset_struct,
            );
    }

    /// Set the `text_emphasis_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set_text_emphasis_color(
        &mut self,
        value: longhands::text_emphasis_color::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set_text_emphasis_color(
                value,
            );
    }
    /// Reset `_webkit_text_fill_color` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__webkit_text_fill_color(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset__webkit_text_fill_color(
                reset_struct,
            );
    }

    /// Set the `_webkit_text_fill_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__webkit_text_fill_color(
        &mut self,
        value: longhands::_webkit_text_fill_color::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set__webkit_text_fill_color(
                value,
            );
    }
    /// Reset `_webkit_text_stroke_color` to the initial value.
    #[allow(non_snake_case)]
    pub fn reset__webkit_text_stroke_color(&mut self) {
        let reset_struct =
            self.reset_style.get_inherited_text();

        if self.inherited_text.ptr_eq(reset_struct) {
            return;
        }

        self.inherited_text.mutate()
            .reset__webkit_text_stroke_color(
                reset_struct,
            );
    }

    /// Set the `_webkit_text_stroke_color` to the computed value `value`.
    #[allow(non_snake_case)]
    pub fn set__webkit_text_stroke_color(
        &mut self,
        value: longhands::_webkit_text_stroke_color::computed_value::T
    ) {

        self.inherited_text.mutate()
            .set__webkit_text_stroke_color(
                value,
            );
    }
    

    /// Inherits style from the parent element, accounting for the default
    /// computed values that need to be provided as well.
    pub fn for_inheritance(
        device: &'a Device,
        parent: Option<&'a ComputedValues>,
        pseudo: Option<&'a PseudoElement>,
    ) -> Self {
        // Rebuild the visited style from the parent, ensuring that it will also
        // not have rules.  This matches the unvisited style that will be
        // produced by this builder.  This assumes that the caller doesn't need
        // to adjust or process visited style, so we can just build visited
        // style here for simplicity.
        let visited_style = parent.and_then(|parent| {
            parent.visited_style().map(|style| {
                Self::for_inheritance(
                    device,
                    Some(style),
                    pseudo,
                ).build()
            })
        });
        let mut ret = Self::new(
            device,
            parent,
            parent,
            pseudo,
            /* rules = */ None,
            parent.and_then(|p| p.custom_properties().cloned()),
        );
        ret.visited_style = visited_style;
        ret
    }

    /// Returns whether we have a visited style.
    pub fn has_visited_style(&self) -> bool {
        self.visited_style.is_some()
    }

    /// Returns whether we're a pseudo-elements style.
    pub fn is_pseudo_element(&self) -> bool {
        self.pseudo.map_or(false, |p| !p.is_anon_box())
    }

    /// Returns the style we're getting reset properties from.
    pub fn default_style(&self) -> &'a ComputedValues {
        self.reset_style
    }

        /// Gets an immutable view of the current `Background` style.
        pub fn get_background(&self) -> &style_structs::Background {
            &self.background
        }

        /// Gets a mutable view of the current `Background` style.
        pub fn mutate_background(&mut self) -> &mut style_structs::Background {
            self.modified_reset = true;
            self.background.mutate()
        }

        /// Gets a mutable view of the current `Background` style.
        pub fn take_background(&mut self) -> UniqueArc<style_structs::Background> {
            self.modified_reset = true;
            self.background.take()
        }

        /// Gets a mutable view of the current `Background` style.
        pub fn put_background(&mut self, s: UniqueArc<style_structs::Background>) {
            self.background.put(s)
        }

        /// Gets a mutable view of the current `Background` style,
        /// only if it's been mutated before.
        pub fn get_background_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::Background> {
            self.background.get_if_mutated()
        }

        /// Reset the current `Background` style to its default value.
        pub fn reset_background_struct(&mut self) {
            self.background =
                StyleStructRef::Borrowed(self.reset_style.background_arc());
        }
        /// Gets an immutable view of the current `Border` style.
        pub fn get_border(&self) -> &style_structs::Border {
            &self.border
        }

        /// Gets a mutable view of the current `Border` style.
        pub fn mutate_border(&mut self) -> &mut style_structs::Border {
            self.modified_reset = true;
            self.border.mutate()
        }

        /// Gets a mutable view of the current `Border` style.
        pub fn take_border(&mut self) -> UniqueArc<style_structs::Border> {
            self.modified_reset = true;
            self.border.take()
        }

        /// Gets a mutable view of the current `Border` style.
        pub fn put_border(&mut self, s: UniqueArc<style_structs::Border>) {
            self.border.put(s)
        }

        /// Gets a mutable view of the current `Border` style,
        /// only if it's been mutated before.
        pub fn get_border_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::Border> {
            self.border.get_if_mutated()
        }

        /// Reset the current `Border` style to its default value.
        pub fn reset_border_struct(&mut self) {
            self.border =
                StyleStructRef::Borrowed(self.reset_style.border_arc());
        }
        /// Gets an immutable view of the current `Box` style.
        pub fn get_box(&self) -> &style_structs::Box {
            &self.box_
        }

        /// Gets a mutable view of the current `Box` style.
        pub fn mutate_box(&mut self) -> &mut style_structs::Box {
            self.modified_reset = true;
            self.box_.mutate()
        }

        /// Gets a mutable view of the current `Box` style.
        pub fn take_box(&mut self) -> UniqueArc<style_structs::Box> {
            self.modified_reset = true;
            self.box_.take()
        }

        /// Gets a mutable view of the current `Box` style.
        pub fn put_box(&mut self, s: UniqueArc<style_structs::Box>) {
            self.box_.put(s)
        }

        /// Gets a mutable view of the current `Box` style,
        /// only if it's been mutated before.
        pub fn get_box_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::Box> {
            self.box_.get_if_mutated()
        }

        /// Reset the current `Box` style to its default value.
        pub fn reset_box_struct(&mut self) {
            self.box_ =
                StyleStructRef::Borrowed(self.reset_style.box_arc());
        }
        /// Gets an immutable view of the current `Color` style.
        pub fn get_color(&self) -> &style_structs::Color {
            &self.color
        }

        /// Gets a mutable view of the current `Color` style.
        pub fn mutate_color(&mut self) -> &mut style_structs::Color {
            self.color.mutate()
        }

        /// Gets a mutable view of the current `Color` style.
        pub fn take_color(&mut self) -> UniqueArc<style_structs::Color> {
            self.color.take()
        }

        /// Gets a mutable view of the current `Color` style.
        pub fn put_color(&mut self, s: UniqueArc<style_structs::Color>) {
            self.color.put(s)
        }

        /// Gets a mutable view of the current `Color` style,
        /// only if it's been mutated before.
        pub fn get_color_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::Color> {
            self.color.get_if_mutated()
        }

        /// Reset the current `Color` style to its default value.
        pub fn reset_color_struct(&mut self) {
            self.color =
                StyleStructRef::Borrowed(self.reset_style.color_arc());
        }
        /// Gets an immutable view of the current `Column` style.
        pub fn get_column(&self) -> &style_structs::Column {
            &self.column
        }

        /// Gets a mutable view of the current `Column` style.
        pub fn mutate_column(&mut self) -> &mut style_structs::Column {
            self.modified_reset = true;
            self.column.mutate()
        }

        /// Gets a mutable view of the current `Column` style.
        pub fn take_column(&mut self) -> UniqueArc<style_structs::Column> {
            self.modified_reset = true;
            self.column.take()
        }

        /// Gets a mutable view of the current `Column` style.
        pub fn put_column(&mut self, s: UniqueArc<style_structs::Column>) {
            self.column.put(s)
        }

        /// Gets a mutable view of the current `Column` style,
        /// only if it's been mutated before.
        pub fn get_column_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::Column> {
            self.column.get_if_mutated()
        }

        /// Reset the current `Column` style to its default value.
        pub fn reset_column_struct(&mut self) {
            self.column =
                StyleStructRef::Borrowed(self.reset_style.column_arc());
        }
        /// Gets an immutable view of the current `Counters` style.
        pub fn get_counters(&self) -> &style_structs::Counters {
            &self.counters
        }

        /// Gets a mutable view of the current `Counters` style.
        pub fn mutate_counters(&mut self) -> &mut style_structs::Counters {
            self.modified_reset = true;
            self.counters.mutate()
        }

        /// Gets a mutable view of the current `Counters` style.
        pub fn take_counters(&mut self) -> UniqueArc<style_structs::Counters> {
            self.modified_reset = true;
            self.counters.take()
        }

        /// Gets a mutable view of the current `Counters` style.
        pub fn put_counters(&mut self, s: UniqueArc<style_structs::Counters>) {
            self.counters.put(s)
        }

        /// Gets a mutable view of the current `Counters` style,
        /// only if it's been mutated before.
        pub fn get_counters_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::Counters> {
            self.counters.get_if_mutated()
        }

        /// Reset the current `Counters` style to its default value.
        pub fn reset_counters_struct(&mut self) {
            self.counters =
                StyleStructRef::Borrowed(self.reset_style.counters_arc());
        }
        /// Gets an immutable view of the current `Effects` style.
        pub fn get_effects(&self) -> &style_structs::Effects {
            &self.effects
        }

        /// Gets a mutable view of the current `Effects` style.
        pub fn mutate_effects(&mut self) -> &mut style_structs::Effects {
            self.modified_reset = true;
            self.effects.mutate()
        }

        /// Gets a mutable view of the current `Effects` style.
        pub fn take_effects(&mut self) -> UniqueArc<style_structs::Effects> {
            self.modified_reset = true;
            self.effects.take()
        }

        /// Gets a mutable view of the current `Effects` style.
        pub fn put_effects(&mut self, s: UniqueArc<style_structs::Effects>) {
            self.effects.put(s)
        }

        /// Gets a mutable view of the current `Effects` style,
        /// only if it's been mutated before.
        pub fn get_effects_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::Effects> {
            self.effects.get_if_mutated()
        }

        /// Reset the current `Effects` style to its default value.
        pub fn reset_effects_struct(&mut self) {
            self.effects =
                StyleStructRef::Borrowed(self.reset_style.effects_arc());
        }
        /// Gets an immutable view of the current `Font` style.
        pub fn get_font(&self) -> &style_structs::Font {
            &self.font
        }

        /// Gets a mutable view of the current `Font` style.
        pub fn mutate_font(&mut self) -> &mut style_structs::Font {
            self.font.mutate()
        }

        /// Gets a mutable view of the current `Font` style.
        pub fn take_font(&mut self) -> UniqueArc<style_structs::Font> {
            self.font.take()
        }

        /// Gets a mutable view of the current `Font` style.
        pub fn put_font(&mut self, s: UniqueArc<style_structs::Font>) {
            self.font.put(s)
        }

        /// Gets a mutable view of the current `Font` style,
        /// only if it's been mutated before.
        pub fn get_font_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::Font> {
            self.font.get_if_mutated()
        }

        /// Reset the current `Font` style to its default value.
        pub fn reset_font_struct(&mut self) {
            self.font =
                StyleStructRef::Borrowed(self.reset_style.font_arc());
        }
        /// Gets an immutable view of the current `InheritedBox` style.
        pub fn get_inherited_box(&self) -> &style_structs::InheritedBox {
            &self.inherited_box
        }

        /// Gets a mutable view of the current `InheritedBox` style.
        pub fn mutate_inherited_box(&mut self) -> &mut style_structs::InheritedBox {
            self.inherited_box.mutate()
        }

        /// Gets a mutable view of the current `InheritedBox` style.
        pub fn take_inherited_box(&mut self) -> UniqueArc<style_structs::InheritedBox> {
            self.inherited_box.take()
        }

        /// Gets a mutable view of the current `InheritedBox` style.
        pub fn put_inherited_box(&mut self, s: UniqueArc<style_structs::InheritedBox>) {
            self.inherited_box.put(s)
        }

        /// Gets a mutable view of the current `InheritedBox` style,
        /// only if it's been mutated before.
        pub fn get_inherited_box_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::InheritedBox> {
            self.inherited_box.get_if_mutated()
        }

        /// Reset the current `InheritedBox` style to its default value.
        pub fn reset_inherited_box_struct(&mut self) {
            self.inherited_box =
                StyleStructRef::Borrowed(self.reset_style.inherited_box_arc());
        }
        /// Gets an immutable view of the current `InheritedTable` style.
        pub fn get_inherited_table(&self) -> &style_structs::InheritedTable {
            &self.inherited_table
        }

        /// Gets a mutable view of the current `InheritedTable` style.
        pub fn mutate_inherited_table(&mut self) -> &mut style_structs::InheritedTable {
            self.inherited_table.mutate()
        }

        /// Gets a mutable view of the current `InheritedTable` style.
        pub fn take_inherited_table(&mut self) -> UniqueArc<style_structs::InheritedTable> {
            self.inherited_table.take()
        }

        /// Gets a mutable view of the current `InheritedTable` style.
        pub fn put_inherited_table(&mut self, s: UniqueArc<style_structs::InheritedTable>) {
            self.inherited_table.put(s)
        }

        /// Gets a mutable view of the current `InheritedTable` style,
        /// only if it's been mutated before.
        pub fn get_inherited_table_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::InheritedTable> {
            self.inherited_table.get_if_mutated()
        }

        /// Reset the current `InheritedTable` style to its default value.
        pub fn reset_inherited_table_struct(&mut self) {
            self.inherited_table =
                StyleStructRef::Borrowed(self.reset_style.inherited_table_arc());
        }
        /// Gets an immutable view of the current `InheritedText` style.
        pub fn get_inherited_text(&self) -> &style_structs::InheritedText {
            &self.inherited_text
        }

        /// Gets a mutable view of the current `InheritedText` style.
        pub fn mutate_inherited_text(&mut self) -> &mut style_structs::InheritedText {
            self.inherited_text.mutate()
        }

        /// Gets a mutable view of the current `InheritedText` style.
        pub fn take_inherited_text(&mut self) -> UniqueArc<style_structs::InheritedText> {
            self.inherited_text.take()
        }

        /// Gets a mutable view of the current `InheritedText` style.
        pub fn put_inherited_text(&mut self, s: UniqueArc<style_structs::InheritedText>) {
            self.inherited_text.put(s)
        }

        /// Gets a mutable view of the current `InheritedText` style,
        /// only if it's been mutated before.
        pub fn get_inherited_text_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::InheritedText> {
            self.inherited_text.get_if_mutated()
        }

        /// Reset the current `InheritedText` style to its default value.
        pub fn reset_inherited_text_struct(&mut self) {
            self.inherited_text =
                StyleStructRef::Borrowed(self.reset_style.inherited_text_arc());
        }
        /// Gets an immutable view of the current `InheritedUI` style.
        pub fn get_inherited_ui(&self) -> &style_structs::InheritedUI {
            &self.inherited_ui
        }

        /// Gets a mutable view of the current `InheritedUI` style.
        pub fn mutate_inherited_ui(&mut self) -> &mut style_structs::InheritedUI {
            self.inherited_ui.mutate()
        }

        /// Gets a mutable view of the current `InheritedUI` style.
        pub fn take_inherited_ui(&mut self) -> UniqueArc<style_structs::InheritedUI> {
            self.inherited_ui.take()
        }

        /// Gets a mutable view of the current `InheritedUI` style.
        pub fn put_inherited_ui(&mut self, s: UniqueArc<style_structs::InheritedUI>) {
            self.inherited_ui.put(s)
        }

        /// Gets a mutable view of the current `InheritedUI` style,
        /// only if it's been mutated before.
        pub fn get_inherited_ui_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::InheritedUI> {
            self.inherited_ui.get_if_mutated()
        }

        /// Reset the current `InheritedUI` style to its default value.
        pub fn reset_inherited_ui_struct(&mut self) {
            self.inherited_ui =
                StyleStructRef::Borrowed(self.reset_style.inherited_ui_arc());
        }
        /// Gets an immutable view of the current `InheritedSVG` style.
        pub fn get_inherited_svg(&self) -> &style_structs::InheritedSVG {
            &self.inherited_svg
        }

        /// Gets a mutable view of the current `InheritedSVG` style.
        pub fn mutate_inherited_svg(&mut self) -> &mut style_structs::InheritedSVG {
            self.inherited_svg.mutate()
        }

        /// Gets a mutable view of the current `InheritedSVG` style.
        pub fn take_inherited_svg(&mut self) -> UniqueArc<style_structs::InheritedSVG> {
            self.inherited_svg.take()
        }

        /// Gets a mutable view of the current `InheritedSVG` style.
        pub fn put_inherited_svg(&mut self, s: UniqueArc<style_structs::InheritedSVG>) {
            self.inherited_svg.put(s)
        }

        /// Gets a mutable view of the current `InheritedSVG` style,
        /// only if it's been mutated before.
        pub fn get_inherited_svg_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::InheritedSVG> {
            self.inherited_svg.get_if_mutated()
        }

        /// Reset the current `InheritedSVG` style to its default value.
        pub fn reset_inherited_svg_struct(&mut self) {
            self.inherited_svg =
                StyleStructRef::Borrowed(self.reset_style.inherited_svg_arc());
        }
        /// Gets an immutable view of the current `List` style.
        pub fn get_list(&self) -> &style_structs::List {
            &self.list
        }

        /// Gets a mutable view of the current `List` style.
        pub fn mutate_list(&mut self) -> &mut style_structs::List {
            self.list.mutate()
        }

        /// Gets a mutable view of the current `List` style.
        pub fn take_list(&mut self) -> UniqueArc<style_structs::List> {
            self.list.take()
        }

        /// Gets a mutable view of the current `List` style.
        pub fn put_list(&mut self, s: UniqueArc<style_structs::List>) {
            self.list.put(s)
        }

        /// Gets a mutable view of the current `List` style,
        /// only if it's been mutated before.
        pub fn get_list_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::List> {
            self.list.get_if_mutated()
        }

        /// Reset the current `List` style to its default value.
        pub fn reset_list_struct(&mut self) {
            self.list =
                StyleStructRef::Borrowed(self.reset_style.list_arc());
        }
        /// Gets an immutable view of the current `Margin` style.
        pub fn get_margin(&self) -> &style_structs::Margin {
            &self.margin
        }

        /// Gets a mutable view of the current `Margin` style.
        pub fn mutate_margin(&mut self) -> &mut style_structs::Margin {
            self.modified_reset = true;
            self.margin.mutate()
        }

        /// Gets a mutable view of the current `Margin` style.
        pub fn take_margin(&mut self) -> UniqueArc<style_structs::Margin> {
            self.modified_reset = true;
            self.margin.take()
        }

        /// Gets a mutable view of the current `Margin` style.
        pub fn put_margin(&mut self, s: UniqueArc<style_structs::Margin>) {
            self.margin.put(s)
        }

        /// Gets a mutable view of the current `Margin` style,
        /// only if it's been mutated before.
        pub fn get_margin_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::Margin> {
            self.margin.get_if_mutated()
        }

        /// Reset the current `Margin` style to its default value.
        pub fn reset_margin_struct(&mut self) {
            self.margin =
                StyleStructRef::Borrowed(self.reset_style.margin_arc());
        }
        /// Gets an immutable view of the current `Outline` style.
        pub fn get_outline(&self) -> &style_structs::Outline {
            &self.outline
        }

        /// Gets a mutable view of the current `Outline` style.
        pub fn mutate_outline(&mut self) -> &mut style_structs::Outline {
            self.modified_reset = true;
            self.outline.mutate()
        }

        /// Gets a mutable view of the current `Outline` style.
        pub fn take_outline(&mut self) -> UniqueArc<style_structs::Outline> {
            self.modified_reset = true;
            self.outline.take()
        }

        /// Gets a mutable view of the current `Outline` style.
        pub fn put_outline(&mut self, s: UniqueArc<style_structs::Outline>) {
            self.outline.put(s)
        }

        /// Gets a mutable view of the current `Outline` style,
        /// only if it's been mutated before.
        pub fn get_outline_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::Outline> {
            self.outline.get_if_mutated()
        }

        /// Reset the current `Outline` style to its default value.
        pub fn reset_outline_struct(&mut self) {
            self.outline =
                StyleStructRef::Borrowed(self.reset_style.outline_arc());
        }
        /// Gets an immutable view of the current `Padding` style.
        pub fn get_padding(&self) -> &style_structs::Padding {
            &self.padding
        }

        /// Gets a mutable view of the current `Padding` style.
        pub fn mutate_padding(&mut self) -> &mut style_structs::Padding {
            self.modified_reset = true;
            self.padding.mutate()
        }

        /// Gets a mutable view of the current `Padding` style.
        pub fn take_padding(&mut self) -> UniqueArc<style_structs::Padding> {
            self.modified_reset = true;
            self.padding.take()
        }

        /// Gets a mutable view of the current `Padding` style.
        pub fn put_padding(&mut self, s: UniqueArc<style_structs::Padding>) {
            self.padding.put(s)
        }

        /// Gets a mutable view of the current `Padding` style,
        /// only if it's been mutated before.
        pub fn get_padding_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::Padding> {
            self.padding.get_if_mutated()
        }

        /// Reset the current `Padding` style to its default value.
        pub fn reset_padding_struct(&mut self) {
            self.padding =
                StyleStructRef::Borrowed(self.reset_style.padding_arc());
        }
        /// Gets an immutable view of the current `Position` style.
        pub fn get_position(&self) -> &style_structs::Position {
            &self.position
        }

        /// Gets a mutable view of the current `Position` style.
        pub fn mutate_position(&mut self) -> &mut style_structs::Position {
            self.modified_reset = true;
            self.position.mutate()
        }

        /// Gets a mutable view of the current `Position` style.
        pub fn take_position(&mut self) -> UniqueArc<style_structs::Position> {
            self.modified_reset = true;
            self.position.take()
        }

        /// Gets a mutable view of the current `Position` style.
        pub fn put_position(&mut self, s: UniqueArc<style_structs::Position>) {
            self.position.put(s)
        }

        /// Gets a mutable view of the current `Position` style,
        /// only if it's been mutated before.
        pub fn get_position_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::Position> {
            self.position.get_if_mutated()
        }

        /// Reset the current `Position` style to its default value.
        pub fn reset_position_struct(&mut self) {
            self.position =
                StyleStructRef::Borrowed(self.reset_style.position_arc());
        }
        /// Gets an immutable view of the current `Table` style.
        pub fn get_table(&self) -> &style_structs::Table {
            &self.table
        }

        /// Gets a mutable view of the current `Table` style.
        pub fn mutate_table(&mut self) -> &mut style_structs::Table {
            self.modified_reset = true;
            self.table.mutate()
        }

        /// Gets a mutable view of the current `Table` style.
        pub fn take_table(&mut self) -> UniqueArc<style_structs::Table> {
            self.modified_reset = true;
            self.table.take()
        }

        /// Gets a mutable view of the current `Table` style.
        pub fn put_table(&mut self, s: UniqueArc<style_structs::Table>) {
            self.table.put(s)
        }

        /// Gets a mutable view of the current `Table` style,
        /// only if it's been mutated before.
        pub fn get_table_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::Table> {
            self.table.get_if_mutated()
        }

        /// Reset the current `Table` style to its default value.
        pub fn reset_table_struct(&mut self) {
            self.table =
                StyleStructRef::Borrowed(self.reset_style.table_arc());
        }
        /// Gets an immutable view of the current `Text` style.
        pub fn get_text(&self) -> &style_structs::Text {
            &self.text
        }

        /// Gets a mutable view of the current `Text` style.
        pub fn mutate_text(&mut self) -> &mut style_structs::Text {
            self.modified_reset = true;
            self.text.mutate()
        }

        /// Gets a mutable view of the current `Text` style.
        pub fn take_text(&mut self) -> UniqueArc<style_structs::Text> {
            self.modified_reset = true;
            self.text.take()
        }

        /// Gets a mutable view of the current `Text` style.
        pub fn put_text(&mut self, s: UniqueArc<style_structs::Text>) {
            self.text.put(s)
        }

        /// Gets a mutable view of the current `Text` style,
        /// only if it's been mutated before.
        pub fn get_text_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::Text> {
            self.text.get_if_mutated()
        }

        /// Reset the current `Text` style to its default value.
        pub fn reset_text_struct(&mut self) {
            self.text =
                StyleStructRef::Borrowed(self.reset_style.text_arc());
        }
        /// Gets an immutable view of the current `UI` style.
        pub fn get_ui(&self) -> &style_structs::UI {
            &self.ui
        }

        /// Gets a mutable view of the current `UI` style.
        pub fn mutate_ui(&mut self) -> &mut style_structs::UI {
            self.modified_reset = true;
            self.ui.mutate()
        }

        /// Gets a mutable view of the current `UI` style.
        pub fn take_ui(&mut self) -> UniqueArc<style_structs::UI> {
            self.modified_reset = true;
            self.ui.take()
        }

        /// Gets a mutable view of the current `UI` style.
        pub fn put_ui(&mut self, s: UniqueArc<style_structs::UI>) {
            self.ui.put(s)
        }

        /// Gets a mutable view of the current `UI` style,
        /// only if it's been mutated before.
        pub fn get_ui_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::UI> {
            self.ui.get_if_mutated()
        }

        /// Reset the current `UI` style to its default value.
        pub fn reset_ui_struct(&mut self) {
            self.ui =
                StyleStructRef::Borrowed(self.reset_style.ui_arc());
        }
        /// Gets an immutable view of the current `SVG` style.
        pub fn get_svg(&self) -> &style_structs::SVG {
            &self.svg
        }

        /// Gets a mutable view of the current `SVG` style.
        pub fn mutate_svg(&mut self) -> &mut style_structs::SVG {
            self.modified_reset = true;
            self.svg.mutate()
        }

        /// Gets a mutable view of the current `SVG` style.
        pub fn take_svg(&mut self) -> UniqueArc<style_structs::SVG> {
            self.modified_reset = true;
            self.svg.take()
        }

        /// Gets a mutable view of the current `SVG` style.
        pub fn put_svg(&mut self, s: UniqueArc<style_structs::SVG>) {
            self.svg.put(s)
        }

        /// Gets a mutable view of the current `SVG` style,
        /// only if it's been mutated before.
        pub fn get_svg_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::SVG> {
            self.svg.get_if_mutated()
        }

        /// Reset the current `SVG` style to its default value.
        pub fn reset_svg_struct(&mut self) {
            self.svg =
                StyleStructRef::Borrowed(self.reset_style.svg_arc());
        }
        /// Gets an immutable view of the current `XUL` style.
        pub fn get_xul(&self) -> &style_structs::XUL {
            &self.xul
        }

        /// Gets a mutable view of the current `XUL` style.
        pub fn mutate_xul(&mut self) -> &mut style_structs::XUL {
            self.modified_reset = true;
            self.xul.mutate()
        }

        /// Gets a mutable view of the current `XUL` style.
        pub fn take_xul(&mut self) -> UniqueArc<style_structs::XUL> {
            self.modified_reset = true;
            self.xul.take()
        }

        /// Gets a mutable view of the current `XUL` style.
        pub fn put_xul(&mut self, s: UniqueArc<style_structs::XUL>) {
            self.xul.put(s)
        }

        /// Gets a mutable view of the current `XUL` style,
        /// only if it's been mutated before.
        pub fn get_xul_if_mutated(&mut self)
                                                         -> Option<&mut style_structs::XUL> {
            self.xul.get_if_mutated()
        }

        /// Reset the current `XUL` style to its default value.
        pub fn reset_xul_struct(&mut self) {
            self.xul =
                StyleStructRef::Borrowed(self.reset_style.xul_arc());
        }
    

    /// Returns whether this computed style represents a floated object.
    pub fn floated(&self) -> bool {
        self.get_box().clone_float() != longhands::float::computed_value::T::None
    }

    /// Returns whether this computed style represents an out of flow-positioned
    /// object.
    pub fn out_of_flow_positioned(&self) -> bool {
        use crate::properties::longhands::position::computed_value::T as Position;
        matches!(self.get_box().clone_position(),
                 Position::Absolute | Position::Fixed)
    }

    /// Whether this style has a top-layer style.
    #[cfg(feature = "servo")]
    pub fn in_top_layer(&self) -> bool {
        matches!(self.get_box().clone__servo_top_layer(),
                 longhands::_servo_top_layer::computed_value::T::Top)
    }

    /// Whether this style has a top-layer style.
    #[cfg(feature = "gecko")]
    pub fn in_top_layer(&self) -> bool {
        matches!(self.get_box().clone__moz_top_layer(),
                 longhands::_moz_top_layer::computed_value::T::Top)
    }

    /// Clears the "have any reset structs been modified" flag.
    fn clear_modified_reset(&mut self) {
        self.modified_reset = false;
    }

    /// Returns whether we have mutated any reset structs since the the last
    /// time `clear_modified_reset` was called.
    fn modified_reset(&self) -> bool {
        self.modified_reset
    }

    /// Return the current flags.
    #[inline]
    pub fn flags(&self) -> ComputedValueFlags {
        self.flags.get()
    }

    /// Add a flag to the current builder.
    #[inline]
    pub fn add_flags(&self, flag: ComputedValueFlags) {
        let flags = self.flags() | flag;
        self.flags.set(flags);
    }

    /// Removes a flag to the current builder.
    #[inline]
    pub fn remove_flags(&self, flag: ComputedValueFlags) {
        let flags = self.flags() & !flag;
        self.flags.set(flags);
    }

    /// Turns this `StyleBuilder` into a proper `ComputedValues` instance.
    pub fn build(self) -> Arc<ComputedValues> {
        ComputedValues::new(
            self.pseudo,
            self.custom_properties,
            self.writing_mode,
            self.flags.get(),
            self.rules,
            self.visited_style,
            self.background.build(),
            self.border.build(),
            self.box_.build(),
            self.color.build(),
            self.column.build(),
            self.counters.build(),
            self.effects.build(),
            self.font.build(),
            self.inherited_box.build(),
            self.inherited_table.build(),
            self.inherited_text.build(),
            self.inherited_ui.build(),
            self.inherited_svg.build(),
            self.list.build(),
            self.margin.build(),
            self.outline.build(),
            self.padding.build(),
            self.position.build(),
            self.table.build(),
            self.text.build(),
            self.ui.build(),
            self.svg.build(),
            self.xul.build(),
        )
    }

    /// Get the custom properties map if necessary.
    ///
    /// Cloning the Arc here is fine because it only happens in the case where
    /// we have custom properties, and those are both rare and expensive.
    fn custom_properties(&self) -> Option<&Arc<crate::custom_properties::CustomPropertiesMap>> {
        self.custom_properties.as_ref()
    }

    /// Access to various information about our inherited styles.  We don't
    /// expose an inherited ComputedValues directly, because in the
    /// ::first-line case some of the inherited information needs to come from
    /// one ComputedValues instance and some from a different one.

    /// Inherited writing-mode.
    pub fn inherited_writing_mode(&self) -> &WritingMode {
        &self.inherited_style.writing_mode
    }

    /// The computed value flags of our parent.
    #[inline]
    pub fn get_parent_flags(&self) -> ComputedValueFlags {
        self.inherited_style.flags
    }

    /// And access to inherited style structs.
        /// Gets our inherited `Background`.  We don't name these
        /// accessors `inherited_background` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_background`
        /// instead.
        pub fn get_parent_background(&self) -> &style_structs::Background {
            self.inherited_style_ignoring_first_line.get_background()
        }
        /// Gets our inherited `Border`.  We don't name these
        /// accessors `inherited_border` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_border`
        /// instead.
        pub fn get_parent_border(&self) -> &style_structs::Border {
            self.inherited_style_ignoring_first_line.get_border()
        }
        /// Gets our inherited `Box`.  We don't name these
        /// accessors `inherited_box` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_box`
        /// instead.
        pub fn get_parent_box(&self) -> &style_structs::Box {
            self.inherited_style_ignoring_first_line.get_box()
        }
        /// Gets our inherited `Color`.  We don't name these
        /// accessors `inherited_color` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_color`
        /// instead.
        pub fn get_parent_color(&self) -> &style_structs::Color {
            self.inherited_style.get_color()
        }
        /// Gets our inherited `Column`.  We don't name these
        /// accessors `inherited_column` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_column`
        /// instead.
        pub fn get_parent_column(&self) -> &style_structs::Column {
            self.inherited_style_ignoring_first_line.get_column()
        }
        /// Gets our inherited `Counters`.  We don't name these
        /// accessors `inherited_counters` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_counters`
        /// instead.
        pub fn get_parent_counters(&self) -> &style_structs::Counters {
            self.inherited_style_ignoring_first_line.get_counters()
        }
        /// Gets our inherited `Effects`.  We don't name these
        /// accessors `inherited_effects` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_effects`
        /// instead.
        pub fn get_parent_effects(&self) -> &style_structs::Effects {
            self.inherited_style_ignoring_first_line.get_effects()
        }
        /// Gets our inherited `Font`.  We don't name these
        /// accessors `inherited_font` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_font`
        /// instead.
        pub fn get_parent_font(&self) -> &style_structs::Font {
            self.inherited_style.get_font()
        }
        /// Gets our inherited `InheritedBox`.  We don't name these
        /// accessors `inherited_inherited_box` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_inherited_box`
        /// instead.
        pub fn get_parent_inherited_box(&self) -> &style_structs::InheritedBox {
            self.inherited_style.get_inherited_box()
        }
        /// Gets our inherited `InheritedTable`.  We don't name these
        /// accessors `inherited_inherited_table` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_inherited_table`
        /// instead.
        pub fn get_parent_inherited_table(&self) -> &style_structs::InheritedTable {
            self.inherited_style.get_inherited_table()
        }
        /// Gets our inherited `InheritedText`.  We don't name these
        /// accessors `inherited_inherited_text` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_inherited_text`
        /// instead.
        pub fn get_parent_inherited_text(&self) -> &style_structs::InheritedText {
            self.inherited_style.get_inherited_text()
        }
        /// Gets our inherited `InheritedUI`.  We don't name these
        /// accessors `inherited_inherited_ui` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_inherited_ui`
        /// instead.
        pub fn get_parent_inherited_ui(&self) -> &style_structs::InheritedUI {
            self.inherited_style.get_inherited_ui()
        }
        /// Gets our inherited `InheritedSVG`.  We don't name these
        /// accessors `inherited_inherited_svg` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_inherited_svg`
        /// instead.
        pub fn get_parent_inherited_svg(&self) -> &style_structs::InheritedSVG {
            self.inherited_style.get_inherited_svg()
        }
        /// Gets our inherited `List`.  We don't name these
        /// accessors `inherited_list` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_list`
        /// instead.
        pub fn get_parent_list(&self) -> &style_structs::List {
            self.inherited_style.get_list()
        }
        /// Gets our inherited `Margin`.  We don't name these
        /// accessors `inherited_margin` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_margin`
        /// instead.
        pub fn get_parent_margin(&self) -> &style_structs::Margin {
            self.inherited_style_ignoring_first_line.get_margin()
        }
        /// Gets our inherited `Outline`.  We don't name these
        /// accessors `inherited_outline` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_outline`
        /// instead.
        pub fn get_parent_outline(&self) -> &style_structs::Outline {
            self.inherited_style_ignoring_first_line.get_outline()
        }
        /// Gets our inherited `Padding`.  We don't name these
        /// accessors `inherited_padding` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_padding`
        /// instead.
        pub fn get_parent_padding(&self) -> &style_structs::Padding {
            self.inherited_style_ignoring_first_line.get_padding()
        }
        /// Gets our inherited `Position`.  We don't name these
        /// accessors `inherited_position` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_position`
        /// instead.
        pub fn get_parent_position(&self) -> &style_structs::Position {
            self.inherited_style_ignoring_first_line.get_position()
        }
        /// Gets our inherited `Table`.  We don't name these
        /// accessors `inherited_table` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_table`
        /// instead.
        pub fn get_parent_table(&self) -> &style_structs::Table {
            self.inherited_style_ignoring_first_line.get_table()
        }
        /// Gets our inherited `Text`.  We don't name these
        /// accessors `inherited_text` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_text`
        /// instead.
        pub fn get_parent_text(&self) -> &style_structs::Text {
            self.inherited_style_ignoring_first_line.get_text()
        }
        /// Gets our inherited `UI`.  We don't name these
        /// accessors `inherited_ui` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_ui`
        /// instead.
        pub fn get_parent_ui(&self) -> &style_structs::UI {
            self.inherited_style_ignoring_first_line.get_ui()
        }
        /// Gets our inherited `SVG`.  We don't name these
        /// accessors `inherited_svg` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_svg`
        /// instead.
        pub fn get_parent_svg(&self) -> &style_structs::SVG {
            self.inherited_style_ignoring_first_line.get_svg()
        }
        /// Gets our inherited `XUL`.  We don't name these
        /// accessors `inherited_xul` because we already
        /// have things like "box" vs "inherited_box" as struct names.  Do the
        /// next-best thing and call them `parent_xul`
        /// instead.
        pub fn get_parent_xul(&self) -> &style_structs::XUL {
            self.inherited_style_ignoring_first_line.get_xul()
        }
}

#[cfg(feature = "servo")]
pub use self::lazy_static_module::INITIAL_SERVO_VALUES;

// Use a module to work around #[cfg] on lazy_static! not being applied to every generated item.
#[cfg(feature = "servo")]
#[allow(missing_docs)]
mod lazy_static_module {
    use crate::logical_geometry::WritingMode;
    use servo_arc::Arc;
    use super::{ComputedValues, ComputedValuesInner, longhands, style_structs};
    use super::computed_value_flags::ComputedValueFlags;

    lazy_static! {
        /// The initial values for all style structs as defined by the specification.
        pub static ref INITIAL_SERVO_VALUES: ComputedValues = ComputedValues {
            inner: ComputedValuesInner {
                    background: Arc::new(style_structs::Background {
                            background_color: longhands::background_color::get_initial_value(),
                            background_image: longhands::background_image::get_initial_value(),
                            background_position_x: longhands::background_position_x::get_initial_value(),
                            background_position_y: longhands::background_position_y::get_initial_value(),
                            background_repeat: longhands::background_repeat::get_initial_value(),
                            background_attachment: longhands::background_attachment::get_initial_value(),
                            background_clip: longhands::background_clip::get_initial_value(),
                            background_origin: longhands::background_origin::get_initial_value(),
                            background_size: longhands::background_size::get_initial_value(),
                            background_blend_mode: longhands::background_blend_mode::get_initial_value(),
                    }),
                    border: Arc::new(style_structs::Border {
                            border_top_color: longhands::border_top_color::get_initial_value(),
                            border_top_style: longhands::border_top_style::get_initial_value(),
                            border_top_width: longhands::border_top_width::get_initial_value(),
                            border_right_color: longhands::border_right_color::get_initial_value(),
                            border_right_style: longhands::border_right_style::get_initial_value(),
                            border_right_width: longhands::border_right_width::get_initial_value(),
                            border_bottom_color: longhands::border_bottom_color::get_initial_value(),
                            border_bottom_style: longhands::border_bottom_style::get_initial_value(),
                            border_bottom_width: longhands::border_bottom_width::get_initial_value(),
                            border_left_color: longhands::border_left_color::get_initial_value(),
                            border_left_style: longhands::border_left_style::get_initial_value(),
                            border_left_width: longhands::border_left_width::get_initial_value(),
                            border_block_start_color: longhands::border_block_start_color::get_initial_value(),
                            border_block_start_style: longhands::border_block_start_style::get_initial_value(),
                            border_block_start_width: longhands::border_block_start_width::get_initial_value(),
                            border_block_end_color: longhands::border_block_end_color::get_initial_value(),
                            border_block_end_style: longhands::border_block_end_style::get_initial_value(),
                            border_block_end_width: longhands::border_block_end_width::get_initial_value(),
                            border_inline_start_color: longhands::border_inline_start_color::get_initial_value(),
                            border_inline_start_style: longhands::border_inline_start_style::get_initial_value(),
                            border_inline_start_width: longhands::border_inline_start_width::get_initial_value(),
                            border_inline_end_color: longhands::border_inline_end_color::get_initial_value(),
                            border_inline_end_style: longhands::border_inline_end_style::get_initial_value(),
                            border_inline_end_width: longhands::border_inline_end_width::get_initial_value(),
                            border_top_left_radius: longhands::border_top_left_radius::get_initial_value(),
                            border_top_right_radius: longhands::border_top_right_radius::get_initial_value(),
                            border_bottom_right_radius: longhands::border_bottom_right_radius::get_initial_value(),
                            border_bottom_left_radius: longhands::border_bottom_left_radius::get_initial_value(),
                            border_start_start_radius: longhands::border_start_start_radius::get_initial_value(),
                            border_start_end_radius: longhands::border_start_end_radius::get_initial_value(),
                            border_end_start_radius: longhands::border_end_start_radius::get_initial_value(),
                            border_end_end_radius: longhands::border_end_end_radius::get_initial_value(),
                            box_decoration_break: longhands::box_decoration_break::get_initial_value(),
                            _moz_float_edge: longhands::_moz_float_edge::get_initial_value(),
                            border_image_source: longhands::border_image_source::get_initial_value(),
                            border_image_outset: longhands::border_image_outset::get_initial_value(),
                            border_image_repeat: longhands::border_image_repeat::get_initial_value(),
                            border_image_width: longhands::border_image_width::get_initial_value(),
                            border_image_slice: longhands::border_image_slice::get_initial_value(),
                    }),
                    box_: Arc::new(style_structs::Box {
                            display: longhands::display::get_initial_value(),
                            _moz_top_layer: longhands::_moz_top_layer::get_initial_value(),
                            position: longhands::position::get_initial_value(),
                            float: longhands::float::get_initial_value(),
                            clear: longhands::clear::get_initial_value(),
                            vertical_align: longhands::vertical_align::get_initial_value(),
                            overflow_clip_box_inline: longhands::overflow_clip_box_inline::get_initial_value(),
                            overflow_clip_box_block: longhands::overflow_clip_box_block::get_initial_value(),
                            overflow_x: longhands::overflow_x::get_initial_value(),
                            overflow_y: longhands::overflow_y::get_initial_value(),
                            overflow_anchor: longhands::overflow_anchor::get_initial_value(),
                            transition_duration: longhands::transition_duration::get_initial_value(),
                            transition_timing_function: longhands::transition_timing_function::get_initial_value(),
                            transition_property: longhands::transition_property::get_initial_value(),
                            transition_delay: longhands::transition_delay::get_initial_value(),
                            animation_name: longhands::animation_name::get_initial_value(),
                            animation_duration: longhands::animation_duration::get_initial_value(),
                            animation_timing_function: longhands::animation_timing_function::get_initial_value(),
                            animation_iteration_count: longhands::animation_iteration_count::get_initial_value(),
                            animation_direction: longhands::animation_direction::get_initial_value(),
                            animation_play_state: longhands::animation_play_state::get_initial_value(),
                            animation_fill_mode: longhands::animation_fill_mode::get_initial_value(),
                            animation_delay: longhands::animation_delay::get_initial_value(),
                            scroll_snap_points_x: longhands::scroll_snap_points_x::get_initial_value(),
                            scroll_snap_points_y: longhands::scroll_snap_points_y::get_initial_value(),
                            scroll_snap_destination: longhands::scroll_snap_destination::get_initial_value(),
                            scroll_snap_coordinate: longhands::scroll_snap_coordinate::get_initial_value(),
                            transform: longhands::transform::get_initial_value(),
                            rotate: longhands::rotate::get_initial_value(),
                            scale: longhands::scale::get_initial_value(),
                            translate: longhands::translate::get_initial_value(),
                            offset_path: longhands::offset_path::get_initial_value(),
                            scroll_behavior: longhands::scroll_behavior::get_initial_value(),
                            scroll_snap_align: longhands::scroll_snap_align::get_initial_value(),
                            scroll_snap_type: longhands::scroll_snap_type::get_initial_value(),
                            overscroll_behavior_x: longhands::overscroll_behavior_x::get_initial_value(),
                            overscroll_behavior_y: longhands::overscroll_behavior_y::get_initial_value(),
                            isolation: longhands::isolation::get_initial_value(),
                            break_after: longhands::break_after::get_initial_value(),
                            break_before: longhands::break_before::get_initial_value(),
                            break_inside: longhands::break_inside::get_initial_value(),
                            resize: longhands::resize::get_initial_value(),
                            perspective: longhands::perspective::get_initial_value(),
                            perspective_origin: longhands::perspective_origin::get_initial_value(),
                            backface_visibility: longhands::backface_visibility::get_initial_value(),
                            transform_box: longhands::transform_box::get_initial_value(),
                            transform_style: longhands::transform_style::get_initial_value(),
                            transform_origin: longhands::transform_origin::get_initial_value(),
                            contain: longhands::contain::get_initial_value(),
                            _moz_appearance: longhands::_moz_appearance::get_initial_value(),
                            _moz_binding: longhands::_moz_binding::get_initial_value(),
                            _moz_orient: longhands::_moz_orient::get_initial_value(),
                            will_change: longhands::will_change::get_initial_value(),
                            shape_image_threshold: longhands::shape_image_threshold::get_initial_value(),
                            shape_margin: longhands::shape_margin::get_initial_value(),
                            shape_outside: longhands::shape_outside::get_initial_value(),
                            touch_action: longhands::touch_action::get_initial_value(),
                            _webkit_line_clamp: longhands::_webkit_line_clamp::get_initial_value(),
                            original_display: longhands::display::get_initial_value(),
                    }),
                    color: Arc::new(style_structs::Color {
                            color: longhands::color::get_initial_value(),
                    }),
                    column: Arc::new(style_structs::Column {
                            column_width: longhands::column_width::get_initial_value(),
                            column_count: longhands::column_count::get_initial_value(),
                            column_fill: longhands::column_fill::get_initial_value(),
                            column_rule_width: longhands::column_rule_width::get_initial_value(),
                            column_rule_color: longhands::column_rule_color::get_initial_value(),
                            column_span: longhands::column_span::get_initial_value(),
                            column_rule_style: longhands::column_rule_style::get_initial_value(),
                    }),
                    counters: Arc::new(style_structs::Counters {
                            content: longhands::content::get_initial_value(),
                            counter_increment: longhands::counter_increment::get_initial_value(),
                            counter_reset: longhands::counter_reset::get_initial_value(),
                            counter_set: longhands::counter_set::get_initial_value(),
                    }),
                    effects: Arc::new(style_structs::Effects {
                            opacity: longhands::opacity::get_initial_value(),
                            box_shadow: longhands::box_shadow::get_initial_value(),
                            clip: longhands::clip::get_initial_value(),
                            filter: longhands::filter::get_initial_value(),
                            mix_blend_mode: longhands::mix_blend_mode::get_initial_value(),
                    }),
                    font: Arc::new(style_structs::Font {
                            font_family: longhands::font_family::get_initial_value(),
                            font_style: longhands::font_style::get_initial_value(),
                            font_variant_caps: longhands::font_variant_caps::get_initial_value(),
                            font_weight: longhands::font_weight::get_initial_value(),
                            font_size: longhands::font_size::get_initial_value(),
                            font_size_adjust: longhands::font_size_adjust::get_initial_value(),
                            font_synthesis: longhands::font_synthesis::get_initial_value(),
                            font_stretch: longhands::font_stretch::get_initial_value(),
                            font_kerning: longhands::font_kerning::get_initial_value(),
                            font_variant_alternates: longhands::font_variant_alternates::get_initial_value(),
                            font_variant_east_asian: longhands::font_variant_east_asian::get_initial_value(),
                            font_variant_ligatures: longhands::font_variant_ligatures::get_initial_value(),
                            font_variant_numeric: longhands::font_variant_numeric::get_initial_value(),
                            font_variant_position: longhands::font_variant_position::get_initial_value(),
                            font_feature_settings: longhands::font_feature_settings::get_initial_value(),
                            font_variation_settings: longhands::font_variation_settings::get_initial_value(),
                            font_language_override: longhands::font_language_override::get_initial_value(),
                            font_optical_sizing: longhands::font_optical_sizing::get_initial_value(),
                            _x_lang: longhands::_x_lang::get_initial_value(),
                            _moz_script_size_multiplier: longhands::_moz_script_size_multiplier::get_initial_value(),
                            _moz_script_level: longhands::_moz_script_level::get_initial_value(),
                            _moz_math_display: longhands::_moz_math_display::get_initial_value(),
                            _moz_math_variant: longhands::_moz_math_variant::get_initial_value(),
                            _moz_script_min_size: longhands::_moz_script_min_size::get_initial_value(),
                            _x_text_zoom: longhands::_x_text_zoom::get_initial_value(),
                            _moz_osx_font_smoothing: longhands::_moz_osx_font_smoothing::get_initial_value(),
                            _moz_font_smoothing_background_color: longhands::_moz_font_smoothing_background_color::get_initial_value(),
                            _moz_min_font_size_ratio: longhands::_moz_min_font_size_ratio::get_initial_value(),
                            hash: 0,
                    }),
                    inherited_box: Arc::new(style_structs::InheritedBox {
                            visibility: longhands::visibility::get_initial_value(),
                            writing_mode: longhands::writing_mode::get_initial_value(),
                            direction: longhands::direction::get_initial_value(),
                            text_orientation: longhands::text_orientation::get_initial_value(),
                            color_adjust: longhands::color_adjust::get_initial_value(),
                            image_rendering: longhands::image_rendering::get_initial_value(),
                            image_orientation: longhands::image_orientation::get_initial_value(),
                    }),
                    inherited_table: Arc::new(style_structs::InheritedTable {
                            border_collapse: longhands::border_collapse::get_initial_value(),
                            empty_cells: longhands::empty_cells::get_initial_value(),
                            caption_side: longhands::caption_side::get_initial_value(),
                            border_spacing: longhands::border_spacing::get_initial_value(),
                    }),
                    inherited_text: Arc::new(style_structs::InheritedText {
                            line_height: longhands::line_height::get_initial_value(),
                            text_transform: longhands::text_transform::get_initial_value(),
                            hyphens: longhands::hyphens::get_initial_value(),
                            _moz_text_size_adjust: longhands::_moz_text_size_adjust::get_initial_value(),
                            text_indent: longhands::text_indent::get_initial_value(),
                            overflow_wrap: longhands::overflow_wrap::get_initial_value(),
                            word_break: longhands::word_break::get_initial_value(),
                            text_justify: longhands::text_justify::get_initial_value(),
                            text_align_last: longhands::text_align_last::get_initial_value(),
                            text_align: longhands::text_align::get_initial_value(),
                            letter_spacing: longhands::letter_spacing::get_initial_value(),
                            word_spacing: longhands::word_spacing::get_initial_value(),
                            white_space: longhands::white_space::get_initial_value(),
                            text_shadow: longhands::text_shadow::get_initial_value(),
                            text_emphasis_style: longhands::text_emphasis_style::get_initial_value(),
                            text_emphasis_position: longhands::text_emphasis_position::get_initial_value(),
                            text_emphasis_color: longhands::text_emphasis_color::get_initial_value(),
                            _moz_tab_size: longhands::_moz_tab_size::get_initial_value(),
                            _webkit_text_fill_color: longhands::_webkit_text_fill_color::get_initial_value(),
                            _webkit_text_stroke_color: longhands::_webkit_text_stroke_color::get_initial_value(),
                            _webkit_text_stroke_width: longhands::_webkit_text_stroke_width::get_initial_value(),
                            ruby_align: longhands::ruby_align::get_initial_value(),
                            ruby_position: longhands::ruby_position::get_initial_value(),
                            text_combine_upright: longhands::text_combine_upright::get_initial_value(),
                            text_rendering: longhands::text_rendering::get_initial_value(),
                            _moz_control_character_visibility: longhands::_moz_control_character_visibility::get_initial_value(),
                            text_decorations_in_effect:
                                crate::values::computed::text::TextDecorationsInEffect::default(),
                    }),
                    inherited_ui: Arc::new(style_structs::InheritedUI {
                            cursor: longhands::cursor::get_initial_value(),
                            pointer_events: longhands::pointer_events::get_initial_value(),
                            _moz_user_input: longhands::_moz_user_input::get_initial_value(),
                            _moz_user_modify: longhands::_moz_user_modify::get_initial_value(),
                            _moz_user_focus: longhands::_moz_user_focus::get_initial_value(),
                            caret_color: longhands::caret_color::get_initial_value(),
                            scrollbar_color: longhands::scrollbar_color::get_initial_value(),
                    }),
                    inherited_svg: Arc::new(style_structs::InheritedSVG {
                            text_anchor: longhands::text_anchor::get_initial_value(),
                            color_interpolation: longhands::color_interpolation::get_initial_value(),
                            color_interpolation_filters: longhands::color_interpolation_filters::get_initial_value(),
                            fill: longhands::fill::get_initial_value(),
                            fill_opacity: longhands::fill_opacity::get_initial_value(),
                            fill_rule: longhands::fill_rule::get_initial_value(),
                            shape_rendering: longhands::shape_rendering::get_initial_value(),
                            stroke: longhands::stroke::get_initial_value(),
                            stroke_width: longhands::stroke_width::get_initial_value(),
                            stroke_linecap: longhands::stroke_linecap::get_initial_value(),
                            stroke_linejoin: longhands::stroke_linejoin::get_initial_value(),
                            stroke_miterlimit: longhands::stroke_miterlimit::get_initial_value(),
                            stroke_opacity: longhands::stroke_opacity::get_initial_value(),
                            stroke_dasharray: longhands::stroke_dasharray::get_initial_value(),
                            stroke_dashoffset: longhands::stroke_dashoffset::get_initial_value(),
                            clip_rule: longhands::clip_rule::get_initial_value(),
                            marker_start: longhands::marker_start::get_initial_value(),
                            marker_mid: longhands::marker_mid::get_initial_value(),
                            marker_end: longhands::marker_end::get_initial_value(),
                            paint_order: longhands::paint_order::get_initial_value(),
                            _moz_context_properties: longhands::_moz_context_properties::get_initial_value(),
                    }),
                    list: Arc::new(style_structs::List {
                            list_style_position: longhands::list_style_position::get_initial_value(),
                            list_style_type: longhands::list_style_type::get_initial_value(),
                            list_style_image: longhands::list_style_image::get_initial_value(),
                            quotes: longhands::quotes::get_initial_value(),
                            _moz_image_region: longhands::_moz_image_region::get_initial_value(),
                            _moz_list_reversed: longhands::_moz_list_reversed::get_initial_value(),
                    }),
                    margin: Arc::new(style_structs::Margin {
                            margin_top: longhands::margin_top::get_initial_value(),
                            margin_right: longhands::margin_right::get_initial_value(),
                            margin_bottom: longhands::margin_bottom::get_initial_value(),
                            margin_left: longhands::margin_left::get_initial_value(),
                            margin_block_start: longhands::margin_block_start::get_initial_value(),
                            margin_block_end: longhands::margin_block_end::get_initial_value(),
                            margin_inline_start: longhands::margin_inline_start::get_initial_value(),
                            margin_inline_end: longhands::margin_inline_end::get_initial_value(),
                            scroll_margin_top: longhands::scroll_margin_top::get_initial_value(),
                            scroll_margin_right: longhands::scroll_margin_right::get_initial_value(),
                            scroll_margin_bottom: longhands::scroll_margin_bottom::get_initial_value(),
                            scroll_margin_left: longhands::scroll_margin_left::get_initial_value(),
                            scroll_margin_block_start: longhands::scroll_margin_block_start::get_initial_value(),
                            scroll_margin_block_end: longhands::scroll_margin_block_end::get_initial_value(),
                            scroll_margin_inline_start: longhands::scroll_margin_inline_start::get_initial_value(),
                            scroll_margin_inline_end: longhands::scroll_margin_inline_end::get_initial_value(),
                    }),
                    outline: Arc::new(style_structs::Outline {
                            outline_color: longhands::outline_color::get_initial_value(),
                            outline_style: longhands::outline_style::get_initial_value(),
                            outline_width: longhands::outline_width::get_initial_value(),
                            _moz_outline_radius_topleft: longhands::_moz_outline_radius_topleft::get_initial_value(),
                            _moz_outline_radius_topright: longhands::_moz_outline_radius_topright::get_initial_value(),
                            _moz_outline_radius_bottomright: longhands::_moz_outline_radius_bottomright::get_initial_value(),
                            _moz_outline_radius_bottomleft: longhands::_moz_outline_radius_bottomleft::get_initial_value(),
                            outline_offset: longhands::outline_offset::get_initial_value(),
                    }),
                    padding: Arc::new(style_structs::Padding {
                            padding_top: longhands::padding_top::get_initial_value(),
                            padding_right: longhands::padding_right::get_initial_value(),
                            padding_bottom: longhands::padding_bottom::get_initial_value(),
                            padding_left: longhands::padding_left::get_initial_value(),
                            padding_block_start: longhands::padding_block_start::get_initial_value(),
                            padding_block_end: longhands::padding_block_end::get_initial_value(),
                            padding_inline_start: longhands::padding_inline_start::get_initial_value(),
                            padding_inline_end: longhands::padding_inline_end::get_initial_value(),
                            scroll_padding_top: longhands::scroll_padding_top::get_initial_value(),
                            scroll_padding_right: longhands::scroll_padding_right::get_initial_value(),
                            scroll_padding_bottom: longhands::scroll_padding_bottom::get_initial_value(),
                            scroll_padding_left: longhands::scroll_padding_left::get_initial_value(),
                            scroll_padding_block_start: longhands::scroll_padding_block_start::get_initial_value(),
                            scroll_padding_block_end: longhands::scroll_padding_block_end::get_initial_value(),
                            scroll_padding_inline_start: longhands::scroll_padding_inline_start::get_initial_value(),
                            scroll_padding_inline_end: longhands::scroll_padding_inline_end::get_initial_value(),
                    }),
                    position: Arc::new(style_structs::Position {
                            top: longhands::top::get_initial_value(),
                            right: longhands::right::get_initial_value(),
                            bottom: longhands::bottom::get_initial_value(),
                            left: longhands::left::get_initial_value(),
                            inset_block_start: longhands::inset_block_start::get_initial_value(),
                            inset_block_end: longhands::inset_block_end::get_initial_value(),
                            inset_inline_start: longhands::inset_inline_start::get_initial_value(),
                            inset_inline_end: longhands::inset_inline_end::get_initial_value(),
                            z_index: longhands::z_index::get_initial_value(),
                            flex_direction: longhands::flex_direction::get_initial_value(),
                            flex_wrap: longhands::flex_wrap::get_initial_value(),
                            justify_content: longhands::justify_content::get_initial_value(),
                            align_content: longhands::align_content::get_initial_value(),
                            align_items: longhands::align_items::get_initial_value(),
                            justify_items: longhands::justify_items::get_initial_value(),
                            flex_grow: longhands::flex_grow::get_initial_value(),
                            flex_shrink: longhands::flex_shrink::get_initial_value(),
                            align_self: longhands::align_self::get_initial_value(),
                            justify_self: longhands::justify_self::get_initial_value(),
                            order: longhands::order::get_initial_value(),
                            flex_basis: longhands::flex_basis::get_initial_value(),
                            width: longhands::width::get_initial_value(),
                            min_width: longhands::min_width::get_initial_value(),
                            max_width: longhands::max_width::get_initial_value(),
                            height: longhands::height::get_initial_value(),
                            min_height: longhands::min_height::get_initial_value(),
                            max_height: longhands::max_height::get_initial_value(),
                            block_size: longhands::block_size::get_initial_value(),
                            min_block_size: longhands::min_block_size::get_initial_value(),
                            max_block_size: longhands::max_block_size::get_initial_value(),
                            inline_size: longhands::inline_size::get_initial_value(),
                            min_inline_size: longhands::min_inline_size::get_initial_value(),
                            max_inline_size: longhands::max_inline_size::get_initial_value(),
                            box_sizing: longhands::box_sizing::get_initial_value(),
                            object_fit: longhands::object_fit::get_initial_value(),
                            object_position: longhands::object_position::get_initial_value(),
                            grid_row_start: longhands::grid_row_start::get_initial_value(),
                            grid_row_end: longhands::grid_row_end::get_initial_value(),
                            grid_auto_rows: longhands::grid_auto_rows::get_initial_value(),
                            grid_template_rows: longhands::grid_template_rows::get_initial_value(),
                            grid_column_start: longhands::grid_column_start::get_initial_value(),
                            grid_column_end: longhands::grid_column_end::get_initial_value(),
                            grid_auto_columns: longhands::grid_auto_columns::get_initial_value(),
                            grid_template_columns: longhands::grid_template_columns::get_initial_value(),
                            grid_auto_flow: longhands::grid_auto_flow::get_initial_value(),
                            grid_template_areas: longhands::grid_template_areas::get_initial_value(),
                            column_gap: longhands::column_gap::get_initial_value(),
                            row_gap: longhands::row_gap::get_initial_value(),
                    }),
                    table: Arc::new(style_structs::Table {
                            table_layout: longhands::table_layout::get_initial_value(),
                            _x_span: longhands::_x_span::get_initial_value(),
                    }),
                    text: Arc::new(style_structs::Text {
                            text_overflow: longhands::text_overflow::get_initial_value(),
                            unicode_bidi: longhands::unicode_bidi::get_initial_value(),
                            text_decoration_line: longhands::text_decoration_line::get_initial_value(),
                            text_decoration_style: longhands::text_decoration_style::get_initial_value(),
                            text_decoration_color: longhands::text_decoration_color::get_initial_value(),
                            initial_letter: longhands::initial_letter::get_initial_value(),
                    }),
                    ui: Arc::new(style_structs::UI {
                            ime_mode: longhands::ime_mode::get_initial_value(),
                            scrollbar_width: longhands::scrollbar_width::get_initial_value(),
                            _moz_user_select: longhands::_moz_user_select::get_initial_value(),
                            _moz_window_dragging: longhands::_moz_window_dragging::get_initial_value(),
                            _moz_window_shadow: longhands::_moz_window_shadow::get_initial_value(),
                            _moz_window_opacity: longhands::_moz_window_opacity::get_initial_value(),
                            _moz_window_transform: longhands::_moz_window_transform::get_initial_value(),
                            _moz_window_transform_origin: longhands::_moz_window_transform_origin::get_initial_value(),
                            _moz_force_broken_image_icon: longhands::_moz_force_broken_image_icon::get_initial_value(),
                    }),
                    svg: Arc::new(style_structs::SVG {
                            dominant_baseline: longhands::dominant_baseline::get_initial_value(),
                            vector_effect: longhands::vector_effect::get_initial_value(),
                            stop_color: longhands::stop_color::get_initial_value(),
                            stop_opacity: longhands::stop_opacity::get_initial_value(),
                            flood_color: longhands::flood_color::get_initial_value(),
                            flood_opacity: longhands::flood_opacity::get_initial_value(),
                            lighting_color: longhands::lighting_color::get_initial_value(),
                            mask_type: longhands::mask_type::get_initial_value(),
                            clip_path: longhands::clip_path::get_initial_value(),
                            mask_mode: longhands::mask_mode::get_initial_value(),
                            mask_repeat: longhands::mask_repeat::get_initial_value(),
                            mask_position_x: longhands::mask_position_x::get_initial_value(),
                            mask_position_y: longhands::mask_position_y::get_initial_value(),
                            mask_clip: longhands::mask_clip::get_initial_value(),
                            mask_origin: longhands::mask_origin::get_initial_value(),
                            mask_size: longhands::mask_size::get_initial_value(),
                            mask_composite: longhands::mask_composite::get_initial_value(),
                            mask_image: longhands::mask_image::get_initial_value(),
                    }),
                    xul: Arc::new(style_structs::XUL {
                            _moz_box_align: longhands::_moz_box_align::get_initial_value(),
                            _moz_box_direction: longhands::_moz_box_direction::get_initial_value(),
                            _moz_box_flex: longhands::_moz_box_flex::get_initial_value(),
                            _moz_box_orient: longhands::_moz_box_orient::get_initial_value(),
                            _moz_box_pack: longhands::_moz_box_pack::get_initial_value(),
                            _moz_stack_sizing: longhands::_moz_stack_sizing::get_initial_value(),
                            _moz_box_ordinal_group: longhands::_moz_box_ordinal_group::get_initial_value(),
                    }),
                custom_properties: None,
                writing_mode: WritingMode::empty(),
                rules: None,
                visited_style: None,
                flags: ComputedValueFlags::empty(),
            }
        };
    }
}

/// A per-longhand function that performs the CSS cascade for that longhand.
pub type CascadePropertyFn =
    extern "Rust" fn(
        declaration: &PropertyDeclaration,
        context: &mut computed::Context,
    );

/// A per-longhand array of functions to perform the CSS cascade on each of
/// them, effectively doing virtual dispatch.
pub static CASCADE_PROPERTY: [CascadePropertyFn; 353] = [
        longhands::align_content::cascade_property,
        longhands::align_items::cascade_property,
        longhands::align_self::cascade_property,
        longhands::backface_visibility::cascade_property,
        longhands::border_collapse::cascade_property,
        longhands::border_image_repeat::cascade_property,
        longhands::box_decoration_break::cascade_property,
        longhands::box_sizing::cascade_property,
        longhands::break_inside::cascade_property,
        longhands::caption_side::cascade_property,
        longhands::clear::cascade_property,
        longhands::color_adjust::cascade_property,
        longhands::color_interpolation::cascade_property,
        longhands::color_interpolation_filters::cascade_property,
        longhands::column_count::cascade_property,
        longhands::column_fill::cascade_property,
        longhands::column_span::cascade_property,
        longhands::contain::cascade_property,
        longhands::direction::cascade_property,
        longhands::display::cascade_property,
        longhands::dominant_baseline::cascade_property,
        longhands::empty_cells::cascade_property,
        longhands::flex_direction::cascade_property,
        longhands::flex_wrap::cascade_property,
        longhands::float::cascade_property,
        longhands::font_kerning::cascade_property,
        longhands::font_optical_sizing::cascade_property,
        longhands::font_size_adjust::cascade_property,
        longhands::font_stretch::cascade_property,
        longhands::font_style::cascade_property,
        longhands::font_synthesis::cascade_property,
        longhands::font_variant_caps::cascade_property,
        longhands::font_variant_east_asian::cascade_property,
        longhands::font_variant_ligatures::cascade_property,
        longhands::font_variant_numeric::cascade_property,
        longhands::font_variant_position::cascade_property,
        longhands::font_weight::cascade_property,
        longhands::grid_auto_flow::cascade_property,
        longhands::hyphens::cascade_property,
        longhands::image_orientation::cascade_property,
        longhands::image_rendering::cascade_property,
        longhands::ime_mode::cascade_property,
        longhands::initial_letter::cascade_property,
        longhands::isolation::cascade_property,
        longhands::justify_content::cascade_property,
        longhands::justify_items::cascade_property,
        longhands::justify_self::cascade_property,
        longhands::list_style_position::cascade_property,
        longhands::mask_type::cascade_property,
        longhands::mix_blend_mode::cascade_property,
        longhands::_moz_appearance::cascade_property,
        longhands::_moz_box_align::cascade_property,
        longhands::_moz_box_direction::cascade_property,
        longhands::_moz_box_orient::cascade_property,
        longhands::_moz_box_pack::cascade_property,
        longhands::_moz_control_character_visibility::cascade_property,
        longhands::_moz_float_edge::cascade_property,
        longhands::_moz_force_broken_image_icon::cascade_property,
        longhands::_moz_list_reversed::cascade_property,
        longhands::_moz_math_display::cascade_property,
        longhands::_moz_math_variant::cascade_property,
        longhands::_moz_min_font_size_ratio::cascade_property,
        longhands::_moz_orient::cascade_property,
        longhands::_moz_osx_font_smoothing::cascade_property,
        longhands::_moz_script_level::cascade_property,
        longhands::_moz_script_min_size::cascade_property,
        longhands::_moz_script_size_multiplier::cascade_property,
        longhands::_moz_stack_sizing::cascade_property,
        longhands::_moz_text_size_adjust::cascade_property,
        longhands::_moz_top_layer::cascade_property,
        longhands::_moz_user_focus::cascade_property,
        longhands::_moz_user_input::cascade_property,
        longhands::_moz_user_modify::cascade_property,
        longhands::_moz_user_select::cascade_property,
        longhands::_moz_window_dragging::cascade_property,
        longhands::_moz_window_shadow::cascade_property,
        longhands::object_fit::cascade_property,
        longhands::outline_style::cascade_property,
        longhands::overflow_anchor::cascade_property,
        longhands::overflow_wrap::cascade_property,
        longhands::paint_order::cascade_property,
        longhands::pointer_events::cascade_property,
        longhands::position::cascade_property,
        longhands::resize::cascade_property,
        longhands::ruby_align::cascade_property,
        longhands::ruby_position::cascade_property,
        longhands::scroll_behavior::cascade_property,
        longhands::scroll_snap_align::cascade_property,
        longhands::scroll_snap_type::cascade_property,
        longhands::scrollbar_width::cascade_property,
        longhands::shape_rendering::cascade_property,
        longhands::stroke_linecap::cascade_property,
        longhands::stroke_linejoin::cascade_property,
        longhands::table_layout::cascade_property,
        longhands::text_align::cascade_property,
        longhands::text_align_last::cascade_property,
        longhands::text_anchor::cascade_property,
        longhands::text_combine_upright::cascade_property,
        longhands::text_decoration_line::cascade_property,
        longhands::text_decoration_style::cascade_property,
        longhands::text_emphasis_position::cascade_property,
        longhands::text_justify::cascade_property,
        longhands::text_orientation::cascade_property,
        longhands::text_rendering::cascade_property,
        longhands::text_transform::cascade_property,
        longhands::touch_action::cascade_property,
        longhands::transform_box::cascade_property,
        longhands::transform_style::cascade_property,
        longhands::unicode_bidi::cascade_property,
        longhands::vector_effect::cascade_property,
        longhands::visibility::cascade_property,
        longhands::_webkit_line_clamp::cascade_property,
        longhands::white_space::cascade_property,
        longhands::word_break::cascade_property,
        longhands::writing_mode::cascade_property,
        longhands::_x_span::cascade_property,
        longhands::_x_text_zoom::cascade_property,
        longhands::z_index::cascade_property,
        longhands::break_after::cascade_property,
        longhands::break_before::cascade_property,
        longhands::clip_rule::cascade_property,
        longhands::fill_rule::cascade_property,
        longhands::_moz_box_ordinal_group::cascade_property,
        longhands::order::cascade_property,
        longhands::overflow_x::cascade_property,
        longhands::overflow_y::cascade_property,
        longhands::overflow_clip_box_block::cascade_property,
        longhands::overflow_clip_box_inline::cascade_property,
        longhands::overscroll_behavior_x::cascade_property,
        longhands::overscroll_behavior_y::cascade_property,
        longhands::fill_opacity::cascade_property,
        longhands::stroke_opacity::cascade_property,
        longhands::flex_grow::cascade_property,
        longhands::flex_shrink::cascade_property,
        longhands::_moz_box_flex::cascade_property,
        longhands::stroke_miterlimit::cascade_property,
        longhands::flood_opacity::cascade_property,
        longhands::_moz_window_opacity::cascade_property,
        longhands::opacity::cascade_property,
        longhands::shape_image_threshold::cascade_property,
        longhands::stop_opacity::cascade_property,
        longhands::border_block_end_style::cascade_property,
        longhands::border_block_start_style::cascade_property,
        longhands::border_bottom_style::cascade_property,
        longhands::border_inline_end_style::cascade_property,
        longhands::border_inline_start_style::cascade_property,
        longhands::border_left_style::cascade_property,
        longhands::border_right_style::cascade_property,
        longhands::border_top_style::cascade_property,
        longhands::column_rule_style::cascade_property,
        longhands::animation_delay::cascade_property,
        longhands::animation_direction::cascade_property,
        longhands::animation_duration::cascade_property,
        longhands::animation_fill_mode::cascade_property,
        longhands::animation_iteration_count::cascade_property,
        longhands::animation_name::cascade_property,
        longhands::animation_play_state::cascade_property,
        longhands::animation_timing_function::cascade_property,
        longhands::background_attachment::cascade_property,
        longhands::background_blend_mode::cascade_property,
        longhands::background_clip::cascade_property,
        longhands::background_image::cascade_property,
        longhands::background_origin::cascade_property,
        longhands::background_position_x::cascade_property,
        longhands::background_position_y::cascade_property,
        longhands::background_repeat::cascade_property,
        longhands::background_size::cascade_property,
        longhands::border_image_outset::cascade_property,
        longhands::border_image_slice::cascade_property,
        longhands::border_image_source::cascade_property,
        longhands::border_image_width::cascade_property,
        longhands::border_spacing::cascade_property,
        longhands::box_shadow::cascade_property,
        longhands::caret_color::cascade_property,
        longhands::clip_path::cascade_property,
        longhands::color::cascade_property,
        longhands::column_width::cascade_property,
        longhands::content::cascade_property,
        longhands::counter_increment::cascade_property,
        longhands::cursor::cascade_property,
        longhands::filter::cascade_property,
        longhands::flex_basis::cascade_property,
        longhands::font_family::cascade_property,
        longhands::font_feature_settings::cascade_property,
        longhands::font_language_override::cascade_property,
        longhands::font_size::cascade_property,
        longhands::font_variant_alternates::cascade_property,
        longhands::font_variation_settings::cascade_property,
        longhands::grid_template_areas::cascade_property,
        longhands::letter_spacing::cascade_property,
        longhands::line_height::cascade_property,
        longhands::list_style_image::cascade_property,
        longhands::list_style_type::cascade_property,
        longhands::mask_clip::cascade_property,
        longhands::mask_composite::cascade_property,
        longhands::mask_image::cascade_property,
        longhands::mask_mode::cascade_property,
        longhands::mask_origin::cascade_property,
        longhands::mask_position_x::cascade_property,
        longhands::mask_position_y::cascade_property,
        longhands::mask_repeat::cascade_property,
        longhands::mask_size::cascade_property,
        longhands::_moz_context_properties::cascade_property,
        longhands::_moz_font_smoothing_background_color::cascade_property,
        longhands::_moz_tab_size::cascade_property,
        longhands::offset_path::cascade_property,
        longhands::perspective::cascade_property,
        longhands::quotes::cascade_property,
        longhands::rotate::cascade_property,
        longhands::scale::cascade_property,
        longhands::scroll_snap_coordinate::cascade_property,
        longhands::scrollbar_color::cascade_property,
        longhands::shape_outside::cascade_property,
        longhands::stroke_dasharray::cascade_property,
        longhands::stroke_dashoffset::cascade_property,
        longhands::stroke_width::cascade_property,
        longhands::text_emphasis_style::cascade_property,
        longhands::text_indent::cascade_property,
        longhands::text_overflow::cascade_property,
        longhands::text_shadow::cascade_property,
        longhands::transition_delay::cascade_property,
        longhands::transition_duration::cascade_property,
        longhands::transition_property::cascade_property,
        longhands::transition_timing_function::cascade_property,
        longhands::translate::cascade_property,
        longhands::vertical_align::cascade_property,
        longhands::will_change::cascade_property,
        longhands::word_spacing::cascade_property,
        longhands::_x_lang::cascade_property,
        longhands::clip::cascade_property,
        longhands::_moz_image_region::cascade_property,
        longhands::grid_template_columns::cascade_property,
        longhands::grid_template_rows::cascade_property,
        longhands::fill::cascade_property,
        longhands::stroke::cascade_property,
        longhands::grid_auto_columns::cascade_property,
        longhands::grid_auto_rows::cascade_property,
        longhands::_moz_window_transform_origin::cascade_property,
        longhands::transform_origin::cascade_property,
        longhands::counter_reset::cascade_property,
        longhands::counter_set::cascade_property,
        longhands::scroll_snap_points_x::cascade_property,
        longhands::scroll_snap_points_y::cascade_property,
        longhands::_moz_window_transform::cascade_property,
        longhands::transform::cascade_property,
        longhands::column_gap::cascade_property,
        longhands::row_gap::cascade_property,
        longhands::object_position::cascade_property,
        longhands::perspective_origin::cascade_property,
        longhands::scroll_snap_destination::cascade_property,
        longhands::grid_column_end::cascade_property,
        longhands::grid_column_start::cascade_property,
        longhands::grid_row_end::cascade_property,
        longhands::grid_row_start::cascade_property,
        longhands::max_block_size::cascade_property,
        longhands::max_height::cascade_property,
        longhands::max_inline_size::cascade_property,
        longhands::max_width::cascade_property,
        longhands::marker_end::cascade_property,
        longhands::marker_mid::cascade_property,
        longhands::marker_start::cascade_property,
        longhands::_moz_binding::cascade_property,
        longhands::scroll_padding_block_end::cascade_property,
        longhands::scroll_padding_block_start::cascade_property,
        longhands::scroll_padding_bottom::cascade_property,
        longhands::scroll_padding_inline_end::cascade_property,
        longhands::scroll_padding_inline_start::cascade_property,
        longhands::scroll_padding_left::cascade_property,
        longhands::scroll_padding_right::cascade_property,
        longhands::scroll_padding_top::cascade_property,
        longhands::block_size::cascade_property,
        longhands::height::cascade_property,
        longhands::inline_size::cascade_property,
        longhands::min_block_size::cascade_property,
        longhands::min_height::cascade_property,
        longhands::min_inline_size::cascade_property,
        longhands::min_width::cascade_property,
        longhands::width::cascade_property,
        longhands::outline_offset::cascade_property,
        longhands::scroll_margin_block_end::cascade_property,
        longhands::scroll_margin_block_start::cascade_property,
        longhands::scroll_margin_bottom::cascade_property,
        longhands::scroll_margin_inline_end::cascade_property,
        longhands::scroll_margin_inline_start::cascade_property,
        longhands::scroll_margin_left::cascade_property,
        longhands::scroll_margin_right::cascade_property,
        longhands::scroll_margin_top::cascade_property,
        longhands::padding_block_end::cascade_property,
        longhands::padding_block_start::cascade_property,
        longhands::padding_bottom::cascade_property,
        longhands::padding_inline_end::cascade_property,
        longhands::padding_inline_start::cascade_property,
        longhands::padding_left::cascade_property,
        longhands::padding_right::cascade_property,
        longhands::padding_top::cascade_property,
        longhands::shape_margin::cascade_property,
        longhands::border_block_end_width::cascade_property,
        longhands::border_block_start_width::cascade_property,
        longhands::border_bottom_width::cascade_property,
        longhands::border_inline_end_width::cascade_property,
        longhands::border_inline_start_width::cascade_property,
        longhands::border_left_width::cascade_property,
        longhands::border_right_width::cascade_property,
        longhands::border_top_width::cascade_property,
        longhands::column_rule_width::cascade_property,
        longhands::outline_width::cascade_property,
        longhands::_webkit_text_stroke_width::cascade_property,
        longhands::border_bottom_left_radius::cascade_property,
        longhands::border_bottom_right_radius::cascade_property,
        longhands::border_end_end_radius::cascade_property,
        longhands::border_end_start_radius::cascade_property,
        longhands::border_start_end_radius::cascade_property,
        longhands::border_start_start_radius::cascade_property,
        longhands::border_top_left_radius::cascade_property,
        longhands::border_top_right_radius::cascade_property,
        longhands::_moz_outline_radius_bottomleft::cascade_property,
        longhands::_moz_outline_radius_bottomright::cascade_property,
        longhands::_moz_outline_radius_topleft::cascade_property,
        longhands::_moz_outline_radius_topright::cascade_property,
        longhands::bottom::cascade_property,
        longhands::inset_block_end::cascade_property,
        longhands::inset_block_start::cascade_property,
        longhands::inset_inline_end::cascade_property,
        longhands::inset_inline_start::cascade_property,
        longhands::left::cascade_property,
        longhands::margin_block_end::cascade_property,
        longhands::margin_block_start::cascade_property,
        longhands::margin_bottom::cascade_property,
        longhands::margin_inline_end::cascade_property,
        longhands::margin_inline_start::cascade_property,
        longhands::margin_left::cascade_property,
        longhands::margin_right::cascade_property,
        longhands::margin_top::cascade_property,
        longhands::right::cascade_property,
        longhands::top::cascade_property,
        longhands::background_color::cascade_property,
        longhands::border_block_end_color::cascade_property,
        longhands::border_block_start_color::cascade_property,
        longhands::border_bottom_color::cascade_property,
        longhands::border_inline_end_color::cascade_property,
        longhands::border_inline_start_color::cascade_property,
        longhands::border_left_color::cascade_property,
        longhands::border_right_color::cascade_property,
        longhands::border_top_color::cascade_property,
        longhands::column_rule_color::cascade_property,
        longhands::flood_color::cascade_property,
        longhands::lighting_color::cascade_property,
        longhands::outline_color::cascade_property,
        longhands::stop_color::cascade_property,
        longhands::text_decoration_color::cascade_property,
        longhands::text_emphasis_color::cascade_property,
        longhands::_webkit_text_fill_color::cascade_property,
        longhands::_webkit_text_stroke_color::cascade_property,
];


/// See StyleAdjuster::adjust_for_border_width.
pub fn adjust_border_width(style: &mut StyleBuilder) {
        // Like calling to_computed_value, which wouldn't type check.
        if style.get_border().clone_border_top_style().none_or_hidden() &&
           style.get_border().border_top_has_nonzero_width() {
            style.set_border_top_width(NonNegativeLength::zero());
        }
        // Like calling to_computed_value, which wouldn't type check.
        if style.get_border().clone_border_right_style().none_or_hidden() &&
           style.get_border().border_right_has_nonzero_width() {
            style.set_border_right_width(NonNegativeLength::zero());
        }
        // Like calling to_computed_value, which wouldn't type check.
        if style.get_border().clone_border_bottom_style().none_or_hidden() &&
           style.get_border().border_bottom_has_nonzero_width() {
            style.set_border_bottom_width(NonNegativeLength::zero());
        }
        // Like calling to_computed_value, which wouldn't type check.
        if style.get_border().clone_border_left_style().none_or_hidden() &&
           style.get_border().border_left_has_nonzero_width() {
            style.set_border_left_width(NonNegativeLength::zero());
        }
}

/// An identifier for a given alias property.
#[derive(Clone, Copy, Eq, PartialEq, MallocSizeOf)]
#[repr(u16)]
pub enum AliasId {
        /// -webkit-background-clip
        WebkitBackgroundClip = 0,
        /// -webkit-background-origin
        WebkitBackgroundOrigin = 1,
        /// -webkit-background-size
        WebkitBackgroundSize = 2,
        /// -moz-border-start-color
        MozBorderStartColor = 3,
        /// -moz-border-start-style
        MozBorderStartStyle = 4,
        /// -moz-border-start-width
        MozBorderStartWidth = 5,
        /// -moz-border-end-color
        MozBorderEndColor = 6,
        /// -moz-border-end-style
        MozBorderEndStyle = 7,
        /// -moz-border-end-width
        MozBorderEndWidth = 8,
        /// -webkit-border-top-left-radius
        WebkitBorderTopLeftRadius = 9,
        /// -webkit-border-top-right-radius
        WebkitBorderTopRightRadius = 10,
        /// -webkit-border-bottom-right-radius
        WebkitBorderBottomRightRadius = 11,
        /// -webkit-border-bottom-left-radius
        WebkitBorderBottomLeftRadius = 12,
        /// -moz-transition-duration
        MozTransitionDuration = 13,
        /// -webkit-transition-duration
        WebkitTransitionDuration = 14,
        /// -moz-transition-timing-function
        MozTransitionTimingFunction = 15,
        /// -webkit-transition-timing-function
        WebkitTransitionTimingFunction = 16,
        /// -moz-transition-property
        MozTransitionProperty = 17,
        /// -webkit-transition-property
        WebkitTransitionProperty = 18,
        /// -moz-transition-delay
        MozTransitionDelay = 19,
        /// -webkit-transition-delay
        WebkitTransitionDelay = 20,
        /// -moz-animation-name
        MozAnimationName = 21,
        /// -webkit-animation-name
        WebkitAnimationName = 22,
        /// -moz-animation-duration
        MozAnimationDuration = 23,
        /// -webkit-animation-duration
        WebkitAnimationDuration = 24,
        /// -moz-animation-timing-function
        MozAnimationTimingFunction = 25,
        /// -webkit-animation-timing-function
        WebkitAnimationTimingFunction = 26,
        /// -moz-animation-iteration-count
        MozAnimationIterationCount = 27,
        /// -webkit-animation-iteration-count
        WebkitAnimationIterationCount = 28,
        /// -moz-animation-direction
        MozAnimationDirection = 29,
        /// -webkit-animation-direction
        WebkitAnimationDirection = 30,
        /// -moz-animation-play-state
        MozAnimationPlayState = 31,
        /// -webkit-animation-play-state
        WebkitAnimationPlayState = 32,
        /// -moz-animation-fill-mode
        MozAnimationFillMode = 33,
        /// -webkit-animation-fill-mode
        WebkitAnimationFillMode = 34,
        /// -moz-animation-delay
        MozAnimationDelay = 35,
        /// -webkit-animation-delay
        WebkitAnimationDelay = 36,
        /// -moz-transform
        MozTransform = 37,
        /// -webkit-transform
        WebkitTransform = 38,
        /// page-break-inside
        PageBreakInside = 39,
        /// -moz-perspective
        MozPerspective = 40,
        /// -webkit-perspective
        WebkitPerspective = 41,
        /// -moz-perspective-origin
        MozPerspectiveOrigin = 42,
        /// -webkit-perspective-origin
        WebkitPerspectiveOrigin = 43,
        /// -moz-backface-visibility
        MozBackfaceVisibility = 44,
        /// -webkit-backface-visibility
        WebkitBackfaceVisibility = 45,
        /// -moz-transform-style
        MozTransformStyle = 46,
        /// -webkit-transform-style
        WebkitTransformStyle = 47,
        /// -moz-transform-origin
        MozTransformOrigin = 48,
        /// -webkit-transform-origin
        WebkitTransformOrigin = 49,
        /// -webkit-appearance
        WebkitAppearance = 50,
        /// -moz-column-width
        MozColumnWidth = 51,
        /// -moz-column-count
        MozColumnCount = 52,
        /// -moz-column-fill
        MozColumnFill = 53,
        /// -moz-column-rule-width
        MozColumnRuleWidth = 54,
        /// -moz-column-rule-color
        MozColumnRuleColor = 55,
        /// -moz-column-span
        MozColumnSpan = 56,
        /// -moz-column-rule-style
        MozColumnRuleStyle = 57,
        /// -webkit-box-shadow
        WebkitBoxShadow = 58,
        /// -webkit-filter
        WebkitFilter = 59,
        /// -moz-font-feature-settings
        MozFontFeatureSettings = 60,
        /// -moz-font-language-override
        MozFontLanguageOverride = 61,
        /// -moz-hyphens
        MozHyphens = 62,
        /// -webkit-text-size-adjust
        WebkitTextSizeAdjust = 63,
        /// word-wrap
        WordWrap = 64,
        /// -moz-margin-start
        MozMarginStart = 65,
        /// -moz-margin-end
        MozMarginEnd = 66,
        /// -moz-padding-start
        MozPaddingStart = 67,
        /// -moz-padding-end
        MozPaddingEnd = 68,
        /// offset-block-start
        OffsetBlockStart = 69,
        /// offset-block-end
        OffsetBlockEnd = 70,
        /// offset-inline-start
        OffsetInlineStart = 71,
        /// offset-inline-end
        OffsetInlineEnd = 72,
        /// -webkit-flex-direction
        WebkitFlexDirection = 73,
        /// -webkit-flex-wrap
        WebkitFlexWrap = 74,
        /// -webkit-justify-content
        WebkitJustifyContent = 75,
        /// -webkit-align-content
        WebkitAlignContent = 76,
        /// -webkit-align-items
        WebkitAlignItems = 77,
        /// -webkit-flex-grow
        WebkitFlexGrow = 78,
        /// -webkit-flex-shrink
        WebkitFlexShrink = 79,
        /// -webkit-align-self
        WebkitAlignSelf = 80,
        /// -webkit-order
        WebkitOrder = 81,
        /// -webkit-flex-basis
        WebkitFlexBasis = 82,
        /// -moz-box-sizing
        MozBoxSizing = 83,
        /// -webkit-box-sizing
        WebkitBoxSizing = 84,
        /// grid-column-gap
        GridColumnGap = 85,
        /// -moz-column-gap
        MozColumnGap = 86,
        /// grid-row-gap
        GridRowGap = 87,
        /// -webkit-user-select
        WebkitUserSelect = 88,
        /// -webkit-mask-repeat
        WebkitMaskRepeat = 89,
        /// -webkit-mask-position-x
        WebkitMaskPositionX = 90,
        /// -webkit-mask-position-y
        WebkitMaskPositionY = 91,
        /// -webkit-mask-clip
        WebkitMaskClip = 92,
        /// -webkit-mask-origin
        WebkitMaskOrigin = 93,
        /// -webkit-mask-size
        WebkitMaskSize = 94,
        /// -webkit-mask-composite
        WebkitMaskComposite = 95,
        /// -webkit-mask-image
        WebkitMaskImage = 96,
        /// -webkit-box-align
        WebkitBoxAlign = 97,
        /// -webkit-box-direction
        WebkitBoxDirection = 98,
        /// -webkit-box-flex
        WebkitBoxFlex = 99,
        /// -webkit-box-orient
        WebkitBoxOrient = 100,
        /// -webkit-box-pack
        WebkitBoxPack = 101,
        /// -webkit-box-ordinal-group
        WebkitBoxOrdinalGroup = 102,
        /// -moz-border-start
        MozBorderStart = 103,
        /// -moz-border-end
        MozBorderEnd = 104,
        /// -webkit-border-radius
        WebkitBorderRadius = 105,
        /// -moz-border-image
        MozBorderImage = 106,
        /// -webkit-border-image
        WebkitBorderImage = 107,
        /// -moz-transition
        MozTransition = 108,
        /// -webkit-transition
        WebkitTransition = 109,
        /// -moz-animation
        MozAnimation = 110,
        /// -webkit-animation
        WebkitAnimation = 111,
        /// -moz-columns
        MozColumns = 112,
        /// -moz-column-rule
        MozColumnRule = 113,
        /// -webkit-flex-flow
        WebkitFlexFlow = 114,
        /// -webkit-flex
        WebkitFlex = 115,
        /// grid-gap
        GridGap = 116,
        /// -webkit-mask
        WebkitMask = 117,
        /// -webkit-mask-position
        WebkitMaskPosition = 118,
}

#[derive(Clone, Copy, Eq, PartialEq)]
enum AliasedPropertyId {
    #[allow(dead_code)] // Servo doesn't have aliased shorthands.
    Shorthand(ShorthandId),
    Longhand(LonghandId),
}

impl fmt::Debug for AliasId {
    fn fmt(&self, formatter: &mut fmt::Formatter) -> fmt::Result {
        let name = NonCustomPropertyId::from(*self).name();
        formatter.write_str(name)
    }
}

impl AliasId {
    /// Returns the property we're aliasing, as a longhand or a shorthand.
    #[inline]
    fn aliased_property(self) -> AliasedPropertyId {
        static MAP: [AliasedPropertyId; 119] = [
            AliasedPropertyId::Longhand(LonghandId::BackgroundClip),
            AliasedPropertyId::Longhand(LonghandId::BackgroundOrigin),
            AliasedPropertyId::Longhand(LonghandId::BackgroundSize),
            AliasedPropertyId::Longhand(LonghandId::BorderInlineStartColor),
            AliasedPropertyId::Longhand(LonghandId::BorderInlineStartStyle),
            AliasedPropertyId::Longhand(LonghandId::BorderInlineStartWidth),
            AliasedPropertyId::Longhand(LonghandId::BorderInlineEndColor),
            AliasedPropertyId::Longhand(LonghandId::BorderInlineEndStyle),
            AliasedPropertyId::Longhand(LonghandId::BorderInlineEndWidth),
            AliasedPropertyId::Longhand(LonghandId::BorderTopLeftRadius),
            AliasedPropertyId::Longhand(LonghandId::BorderTopRightRadius),
            AliasedPropertyId::Longhand(LonghandId::BorderBottomRightRadius),
            AliasedPropertyId::Longhand(LonghandId::BorderBottomLeftRadius),
            AliasedPropertyId::Longhand(LonghandId::TransitionDuration),
            AliasedPropertyId::Longhand(LonghandId::TransitionDuration),
            AliasedPropertyId::Longhand(LonghandId::TransitionTimingFunction),
            AliasedPropertyId::Longhand(LonghandId::TransitionTimingFunction),
            AliasedPropertyId::Longhand(LonghandId::TransitionProperty),
            AliasedPropertyId::Longhand(LonghandId::TransitionProperty),
            AliasedPropertyId::Longhand(LonghandId::TransitionDelay),
            AliasedPropertyId::Longhand(LonghandId::TransitionDelay),
            AliasedPropertyId::Longhand(LonghandId::AnimationName),
            AliasedPropertyId::Longhand(LonghandId::AnimationName),
            AliasedPropertyId::Longhand(LonghandId::AnimationDuration),
            AliasedPropertyId::Longhand(LonghandId::AnimationDuration),
            AliasedPropertyId::Longhand(LonghandId::AnimationTimingFunction),
            AliasedPropertyId::Longhand(LonghandId::AnimationTimingFunction),
            AliasedPropertyId::Longhand(LonghandId::AnimationIterationCount),
            AliasedPropertyId::Longhand(LonghandId::AnimationIterationCount),
            AliasedPropertyId::Longhand(LonghandId::AnimationDirection),
            AliasedPropertyId::Longhand(LonghandId::AnimationDirection),
            AliasedPropertyId::Longhand(LonghandId::AnimationPlayState),
            AliasedPropertyId::Longhand(LonghandId::AnimationPlayState),
            AliasedPropertyId::Longhand(LonghandId::AnimationFillMode),
            AliasedPropertyId::Longhand(LonghandId::AnimationFillMode),
            AliasedPropertyId::Longhand(LonghandId::AnimationDelay),
            AliasedPropertyId::Longhand(LonghandId::AnimationDelay),
            AliasedPropertyId::Longhand(LonghandId::Transform),
            AliasedPropertyId::Longhand(LonghandId::Transform),
            AliasedPropertyId::Longhand(LonghandId::BreakInside),
            AliasedPropertyId::Longhand(LonghandId::Perspective),
            AliasedPropertyId::Longhand(LonghandId::Perspective),
            AliasedPropertyId::Longhand(LonghandId::PerspectiveOrigin),
            AliasedPropertyId::Longhand(LonghandId::PerspectiveOrigin),
            AliasedPropertyId::Longhand(LonghandId::BackfaceVisibility),
            AliasedPropertyId::Longhand(LonghandId::BackfaceVisibility),
            AliasedPropertyId::Longhand(LonghandId::TransformStyle),
            AliasedPropertyId::Longhand(LonghandId::TransformStyle),
            AliasedPropertyId::Longhand(LonghandId::TransformOrigin),
            AliasedPropertyId::Longhand(LonghandId::TransformOrigin),
            AliasedPropertyId::Longhand(LonghandId::MozAppearance),
            AliasedPropertyId::Longhand(LonghandId::ColumnWidth),
            AliasedPropertyId::Longhand(LonghandId::ColumnCount),
            AliasedPropertyId::Longhand(LonghandId::ColumnFill),
            AliasedPropertyId::Longhand(LonghandId::ColumnRuleWidth),
            AliasedPropertyId::Longhand(LonghandId::ColumnRuleColor),
            AliasedPropertyId::Longhand(LonghandId::ColumnSpan),
            AliasedPropertyId::Longhand(LonghandId::ColumnRuleStyle),
            AliasedPropertyId::Longhand(LonghandId::BoxShadow),
            AliasedPropertyId::Longhand(LonghandId::Filter),
            AliasedPropertyId::Longhand(LonghandId::FontFeatureSettings),
            AliasedPropertyId::Longhand(LonghandId::FontLanguageOverride),
            AliasedPropertyId::Longhand(LonghandId::Hyphens),
            AliasedPropertyId::Longhand(LonghandId::MozTextSizeAdjust),
            AliasedPropertyId::Longhand(LonghandId::OverflowWrap),
            AliasedPropertyId::Longhand(LonghandId::MarginInlineStart),
            AliasedPropertyId::Longhand(LonghandId::MarginInlineEnd),
            AliasedPropertyId::Longhand(LonghandId::PaddingInlineStart),
            AliasedPropertyId::Longhand(LonghandId::PaddingInlineEnd),
            AliasedPropertyId::Longhand(LonghandId::InsetBlockStart),
            AliasedPropertyId::Longhand(LonghandId::InsetBlockEnd),
            AliasedPropertyId::Longhand(LonghandId::InsetInlineStart),
            AliasedPropertyId::Longhand(LonghandId::InsetInlineEnd),
            AliasedPropertyId::Longhand(LonghandId::FlexDirection),
            AliasedPropertyId::Longhand(LonghandId::FlexWrap),
            AliasedPropertyId::Longhand(LonghandId::JustifyContent),
            AliasedPropertyId::Longhand(LonghandId::AlignContent),
            AliasedPropertyId::Longhand(LonghandId::AlignItems),
            AliasedPropertyId::Longhand(LonghandId::FlexGrow),
            AliasedPropertyId::Longhand(LonghandId::FlexShrink),
            AliasedPropertyId::Longhand(LonghandId::AlignSelf),
            AliasedPropertyId::Longhand(LonghandId::Order),
            AliasedPropertyId::Longhand(LonghandId::FlexBasis),
            AliasedPropertyId::Longhand(LonghandId::BoxSizing),
            AliasedPropertyId::Longhand(LonghandId::BoxSizing),
            AliasedPropertyId::Longhand(LonghandId::ColumnGap),
            AliasedPropertyId::Longhand(LonghandId::ColumnGap),
            AliasedPropertyId::Longhand(LonghandId::RowGap),
            AliasedPropertyId::Longhand(LonghandId::MozUserSelect),
            AliasedPropertyId::Longhand(LonghandId::MaskRepeat),
            AliasedPropertyId::Longhand(LonghandId::MaskPositionX),
            AliasedPropertyId::Longhand(LonghandId::MaskPositionY),
            AliasedPropertyId::Longhand(LonghandId::MaskClip),
            AliasedPropertyId::Longhand(LonghandId::MaskOrigin),
            AliasedPropertyId::Longhand(LonghandId::MaskSize),
            AliasedPropertyId::Longhand(LonghandId::MaskComposite),
            AliasedPropertyId::Longhand(LonghandId::MaskImage),
            AliasedPropertyId::Longhand(LonghandId::MozBoxAlign),
            AliasedPropertyId::Longhand(LonghandId::MozBoxDirection),
            AliasedPropertyId::Longhand(LonghandId::MozBoxFlex),
            AliasedPropertyId::Longhand(LonghandId::MozBoxOrient),
            AliasedPropertyId::Longhand(LonghandId::MozBoxPack),
            AliasedPropertyId::Longhand(LonghandId::MozBoxOrdinalGroup),
            
            AliasedPropertyId::Shorthand(ShorthandId::BorderInlineStart),
            
            AliasedPropertyId::Shorthand(ShorthandId::BorderInlineEnd),
            
            AliasedPropertyId::Shorthand(ShorthandId::BorderRadius),
            
            AliasedPropertyId::Shorthand(ShorthandId::BorderImage),
            
            AliasedPropertyId::Shorthand(ShorthandId::BorderImage),
            
            AliasedPropertyId::Shorthand(ShorthandId::Transition),
            
            AliasedPropertyId::Shorthand(ShorthandId::Transition),
            
            AliasedPropertyId::Shorthand(ShorthandId::Animation),
            
            AliasedPropertyId::Shorthand(ShorthandId::Animation),
            
            AliasedPropertyId::Shorthand(ShorthandId::Columns),
            
            AliasedPropertyId::Shorthand(ShorthandId::ColumnRule),
            
            AliasedPropertyId::Shorthand(ShorthandId::FlexFlow),
            
            AliasedPropertyId::Shorthand(ShorthandId::Flex),
            
            AliasedPropertyId::Shorthand(ShorthandId::Gap),
            
            AliasedPropertyId::Shorthand(ShorthandId::Mask),
            
            AliasedPropertyId::Shorthand(ShorthandId::MaskPosition),
        ];
        MAP[self as usize]
    }
}

/// Call the given macro with tokens like this for each longhand and shorthand properties
/// that is enabled in content:
///
/// ```
/// [CamelCaseName, SetCamelCaseName, PropertyId::Longhand(LonghandId::CamelCaseName)],
/// ```
///
/// NOTE(emilio): Callers are responsible to deal with prefs.
#[macro_export]
macro_rules! css_properties_accessors {
    ($macro_name: ident) => {
        $macro_name! {
                                [Align_content, SetAlign_content,
                                 PropertyId::Longhand(LonghandId::AlignContent)],
                            [AlignContent, SetAlignContent,
                             PropertyId::Longhand(LonghandId::AlignContent)],
                                [_webkit_align_content, Set_webkit_align_content,
                                 PropertyId::Longhand(LonghandId::AlignContent)],
                            [WebkitAlignContent, SetWebkitAlignContent,
                             PropertyId::Longhand(LonghandId::AlignContent)],
                                [Align_items, SetAlign_items,
                                 PropertyId::Longhand(LonghandId::AlignItems)],
                            [AlignItems, SetAlignItems,
                             PropertyId::Longhand(LonghandId::AlignItems)],
                                [_webkit_align_items, Set_webkit_align_items,
                                 PropertyId::Longhand(LonghandId::AlignItems)],
                            [WebkitAlignItems, SetWebkitAlignItems,
                             PropertyId::Longhand(LonghandId::AlignItems)],
                                [Align_self, SetAlign_self,
                                 PropertyId::Longhand(LonghandId::AlignSelf)],
                            [AlignSelf, SetAlignSelf,
                             PropertyId::Longhand(LonghandId::AlignSelf)],
                                [_webkit_align_self, Set_webkit_align_self,
                                 PropertyId::Longhand(LonghandId::AlignSelf)],
                            [WebkitAlignSelf, SetWebkitAlignSelf,
                             PropertyId::Longhand(LonghandId::AlignSelf)],
                                [Backface_visibility, SetBackface_visibility,
                                 PropertyId::Longhand(LonghandId::BackfaceVisibility)],
                            [BackfaceVisibility, SetBackfaceVisibility,
                             PropertyId::Longhand(LonghandId::BackfaceVisibility)],
                                [_moz_backface_visibility, Set_moz_backface_visibility,
                                 PropertyId::Longhand(LonghandId::BackfaceVisibility)],
                            [MozBackfaceVisibility, SetMozBackfaceVisibility,
                             PropertyId::Longhand(LonghandId::BackfaceVisibility)],
                                [_webkit_backface_visibility, Set_webkit_backface_visibility,
                                 PropertyId::Longhand(LonghandId::BackfaceVisibility)],
                            [WebkitBackfaceVisibility, SetWebkitBackfaceVisibility,
                             PropertyId::Longhand(LonghandId::BackfaceVisibility)],
                                [Border_collapse, SetBorder_collapse,
                                 PropertyId::Longhand(LonghandId::BorderCollapse)],
                            [BorderCollapse, SetBorderCollapse,
                             PropertyId::Longhand(LonghandId::BorderCollapse)],
                                [Border_image_repeat, SetBorder_image_repeat,
                                 PropertyId::Longhand(LonghandId::BorderImageRepeat)],
                            [BorderImageRepeat, SetBorderImageRepeat,
                             PropertyId::Longhand(LonghandId::BorderImageRepeat)],
                                [Box_decoration_break, SetBox_decoration_break,
                                 PropertyId::Longhand(LonghandId::BoxDecorationBreak)],
                            [BoxDecorationBreak, SetBoxDecorationBreak,
                             PropertyId::Longhand(LonghandId::BoxDecorationBreak)],
                                [Box_sizing, SetBox_sizing,
                                 PropertyId::Longhand(LonghandId::BoxSizing)],
                            [BoxSizing, SetBoxSizing,
                             PropertyId::Longhand(LonghandId::BoxSizing)],
                                [_moz_box_sizing, Set_moz_box_sizing,
                                 PropertyId::Longhand(LonghandId::BoxSizing)],
                            [MozBoxSizing, SetMozBoxSizing,
                             PropertyId::Longhand(LonghandId::BoxSizing)],
                                [_webkit_box_sizing, Set_webkit_box_sizing,
                                 PropertyId::Longhand(LonghandId::BoxSizing)],
                            [WebkitBoxSizing, SetWebkitBoxSizing,
                             PropertyId::Longhand(LonghandId::BoxSizing)],
                                [Break_inside, SetBreak_inside,
                                 PropertyId::Longhand(LonghandId::BreakInside)],
                            [BreakInside, SetBreakInside,
                             PropertyId::Longhand(LonghandId::BreakInside)],
                                [Page_break_inside, SetPage_break_inside,
                                 PropertyId::Longhand(LonghandId::BreakInside)],
                            [PageBreakInside, SetPageBreakInside,
                             PropertyId::Longhand(LonghandId::BreakInside)],
                                [Caption_side, SetCaption_side,
                                 PropertyId::Longhand(LonghandId::CaptionSide)],
                            [CaptionSide, SetCaptionSide,
                             PropertyId::Longhand(LonghandId::CaptionSide)],
                            [Clear, SetClear,
                             PropertyId::Longhand(LonghandId::Clear)],
                                [Color_adjust, SetColor_adjust,
                                 PropertyId::Longhand(LonghandId::ColorAdjust)],
                            [ColorAdjust, SetColorAdjust,
                             PropertyId::Longhand(LonghandId::ColorAdjust)],
                                [Color_interpolation, SetColor_interpolation,
                                 PropertyId::Longhand(LonghandId::ColorInterpolation)],
                            [ColorInterpolation, SetColorInterpolation,
                             PropertyId::Longhand(LonghandId::ColorInterpolation)],
                                [Color_interpolation_filters, SetColor_interpolation_filters,
                                 PropertyId::Longhand(LonghandId::ColorInterpolationFilters)],
                            [ColorInterpolationFilters, SetColorInterpolationFilters,
                             PropertyId::Longhand(LonghandId::ColorInterpolationFilters)],
                                [Column_count, SetColumn_count,
                                 PropertyId::Longhand(LonghandId::ColumnCount)],
                            [ColumnCount, SetColumnCount,
                             PropertyId::Longhand(LonghandId::ColumnCount)],
                                [_moz_column_count, Set_moz_column_count,
                                 PropertyId::Longhand(LonghandId::ColumnCount)],
                            [MozColumnCount, SetMozColumnCount,
                             PropertyId::Longhand(LonghandId::ColumnCount)],
                                [Column_fill, SetColumn_fill,
                                 PropertyId::Longhand(LonghandId::ColumnFill)],
                            [ColumnFill, SetColumnFill,
                             PropertyId::Longhand(LonghandId::ColumnFill)],
                                [_moz_column_fill, Set_moz_column_fill,
                                 PropertyId::Longhand(LonghandId::ColumnFill)],
                            [MozColumnFill, SetMozColumnFill,
                             PropertyId::Longhand(LonghandId::ColumnFill)],
                            [Direction, SetDirection,
                             PropertyId::Longhand(LonghandId::Direction)],
                            [Display, SetDisplay,
                             PropertyId::Longhand(LonghandId::Display)],
                                [Dominant_baseline, SetDominant_baseline,
                                 PropertyId::Longhand(LonghandId::DominantBaseline)],
                            [DominantBaseline, SetDominantBaseline,
                             PropertyId::Longhand(LonghandId::DominantBaseline)],
                                [Empty_cells, SetEmpty_cells,
                                 PropertyId::Longhand(LonghandId::EmptyCells)],
                            [EmptyCells, SetEmptyCells,
                             PropertyId::Longhand(LonghandId::EmptyCells)],
                                [Flex_direction, SetFlex_direction,
                                 PropertyId::Longhand(LonghandId::FlexDirection)],
                            [FlexDirection, SetFlexDirection,
                             PropertyId::Longhand(LonghandId::FlexDirection)],
                                [_webkit_flex_direction, Set_webkit_flex_direction,
                                 PropertyId::Longhand(LonghandId::FlexDirection)],
                            [WebkitFlexDirection, SetWebkitFlexDirection,
                             PropertyId::Longhand(LonghandId::FlexDirection)],
                                [Flex_wrap, SetFlex_wrap,
                                 PropertyId::Longhand(LonghandId::FlexWrap)],
                            [FlexWrap, SetFlexWrap,
                             PropertyId::Longhand(LonghandId::FlexWrap)],
                                [_webkit_flex_wrap, Set_webkit_flex_wrap,
                                 PropertyId::Longhand(LonghandId::FlexWrap)],
                            [WebkitFlexWrap, SetWebkitFlexWrap,
                             PropertyId::Longhand(LonghandId::FlexWrap)],
                            [Float, SetFloat,
                             PropertyId::Longhand(LonghandId::Float)],
                                [Font_kerning, SetFont_kerning,
                                 PropertyId::Longhand(LonghandId::FontKerning)],
                            [FontKerning, SetFontKerning,
                             PropertyId::Longhand(LonghandId::FontKerning)],
                                [Font_optical_sizing, SetFont_optical_sizing,
                                 PropertyId::Longhand(LonghandId::FontOpticalSizing)],
                            [FontOpticalSizing, SetFontOpticalSizing,
                             PropertyId::Longhand(LonghandId::FontOpticalSizing)],
                                [Font_size_adjust, SetFont_size_adjust,
                                 PropertyId::Longhand(LonghandId::FontSizeAdjust)],
                            [FontSizeAdjust, SetFontSizeAdjust,
                             PropertyId::Longhand(LonghandId::FontSizeAdjust)],
                                [Font_stretch, SetFont_stretch,
                                 PropertyId::Longhand(LonghandId::FontStretch)],
                            [FontStretch, SetFontStretch,
                             PropertyId::Longhand(LonghandId::FontStretch)],
                                [Font_style, SetFont_style,
                                 PropertyId::Longhand(LonghandId::FontStyle)],
                            [FontStyle, SetFontStyle,
                             PropertyId::Longhand(LonghandId::FontStyle)],
                                [Font_synthesis, SetFont_synthesis,
                                 PropertyId::Longhand(LonghandId::FontSynthesis)],
                            [FontSynthesis, SetFontSynthesis,
                             PropertyId::Longhand(LonghandId::FontSynthesis)],
                                [Font_variant_caps, SetFont_variant_caps,
                                 PropertyId::Longhand(LonghandId::FontVariantCaps)],
                            [FontVariantCaps, SetFontVariantCaps,
                             PropertyId::Longhand(LonghandId::FontVariantCaps)],
                                [Font_variant_east_asian, SetFont_variant_east_asian,
                                 PropertyId::Longhand(LonghandId::FontVariantEastAsian)],
                            [FontVariantEastAsian, SetFontVariantEastAsian,
                             PropertyId::Longhand(LonghandId::FontVariantEastAsian)],
                                [Font_variant_ligatures, SetFont_variant_ligatures,
                                 PropertyId::Longhand(LonghandId::FontVariantLigatures)],
                            [FontVariantLigatures, SetFontVariantLigatures,
                             PropertyId::Longhand(LonghandId::FontVariantLigatures)],
                                [Font_variant_numeric, SetFont_variant_numeric,
                                 PropertyId::Longhand(LonghandId::FontVariantNumeric)],
                            [FontVariantNumeric, SetFontVariantNumeric,
                             PropertyId::Longhand(LonghandId::FontVariantNumeric)],
                                [Font_variant_position, SetFont_variant_position,
                                 PropertyId::Longhand(LonghandId::FontVariantPosition)],
                            [FontVariantPosition, SetFontVariantPosition,
                             PropertyId::Longhand(LonghandId::FontVariantPosition)],
                                [Font_weight, SetFont_weight,
                                 PropertyId::Longhand(LonghandId::FontWeight)],
                            [FontWeight, SetFontWeight,
                             PropertyId::Longhand(LonghandId::FontWeight)],
                                [Grid_auto_flow, SetGrid_auto_flow,
                                 PropertyId::Longhand(LonghandId::GridAutoFlow)],
                            [GridAutoFlow, SetGridAutoFlow,
                             PropertyId::Longhand(LonghandId::GridAutoFlow)],
                            [Hyphens, SetHyphens,
                             PropertyId::Longhand(LonghandId::Hyphens)],
                                [_moz_hyphens, Set_moz_hyphens,
                                 PropertyId::Longhand(LonghandId::Hyphens)],
                            [MozHyphens, SetMozHyphens,
                             PropertyId::Longhand(LonghandId::Hyphens)],
                                [Image_orientation, SetImage_orientation,
                                 PropertyId::Longhand(LonghandId::ImageOrientation)],
                            [ImageOrientation, SetImageOrientation,
                             PropertyId::Longhand(LonghandId::ImageOrientation)],
                                [Image_rendering, SetImage_rendering,
                                 PropertyId::Longhand(LonghandId::ImageRendering)],
                            [ImageRendering, SetImageRendering,
                             PropertyId::Longhand(LonghandId::ImageRendering)],
                                [Ime_mode, SetIme_mode,
                                 PropertyId::Longhand(LonghandId::ImeMode)],
                            [ImeMode, SetImeMode,
                             PropertyId::Longhand(LonghandId::ImeMode)],
                                [Initial_letter, SetInitial_letter,
                                 PropertyId::Longhand(LonghandId::InitialLetter)],
                            [InitialLetter, SetInitialLetter,
                             PropertyId::Longhand(LonghandId::InitialLetter)],
                            [Isolation, SetIsolation,
                             PropertyId::Longhand(LonghandId::Isolation)],
                                [Justify_content, SetJustify_content,
                                 PropertyId::Longhand(LonghandId::JustifyContent)],
                            [JustifyContent, SetJustifyContent,
                             PropertyId::Longhand(LonghandId::JustifyContent)],
                                [_webkit_justify_content, Set_webkit_justify_content,
                                 PropertyId::Longhand(LonghandId::JustifyContent)],
                            [WebkitJustifyContent, SetWebkitJustifyContent,
                             PropertyId::Longhand(LonghandId::JustifyContent)],
                                [Justify_items, SetJustify_items,
                                 PropertyId::Longhand(LonghandId::JustifyItems)],
                            [JustifyItems, SetJustifyItems,
                             PropertyId::Longhand(LonghandId::JustifyItems)],
                                [Justify_self, SetJustify_self,
                                 PropertyId::Longhand(LonghandId::JustifySelf)],
                            [JustifySelf, SetJustifySelf,
                             PropertyId::Longhand(LonghandId::JustifySelf)],
                                [List_style_position, SetList_style_position,
                                 PropertyId::Longhand(LonghandId::ListStylePosition)],
                            [ListStylePosition, SetListStylePosition,
                             PropertyId::Longhand(LonghandId::ListStylePosition)],
                                [Mask_type, SetMask_type,
                                 PropertyId::Longhand(LonghandId::MaskType)],
                            [MaskType, SetMaskType,
                             PropertyId::Longhand(LonghandId::MaskType)],
                                [Mix_blend_mode, SetMix_blend_mode,
                                 PropertyId::Longhand(LonghandId::MixBlendMode)],
                            [MixBlendMode, SetMixBlendMode,
                             PropertyId::Longhand(LonghandId::MixBlendMode)],
                                [_moz_appearance, Set_moz_appearance,
                                 PropertyId::Longhand(LonghandId::MozAppearance)],
                            [MozAppearance, SetMozAppearance,
                             PropertyId::Longhand(LonghandId::MozAppearance)],
                                [_webkit_appearance, Set_webkit_appearance,
                                 PropertyId::Longhand(LonghandId::MozAppearance)],
                            [WebkitAppearance, SetWebkitAppearance,
                             PropertyId::Longhand(LonghandId::MozAppearance)],
                                [_moz_box_align, Set_moz_box_align,
                                 PropertyId::Longhand(LonghandId::MozBoxAlign)],
                            [MozBoxAlign, SetMozBoxAlign,
                             PropertyId::Longhand(LonghandId::MozBoxAlign)],
                                [_webkit_box_align, Set_webkit_box_align,
                                 PropertyId::Longhand(LonghandId::MozBoxAlign)],
                            [WebkitBoxAlign, SetWebkitBoxAlign,
                             PropertyId::Longhand(LonghandId::MozBoxAlign)],
                                [_moz_box_direction, Set_moz_box_direction,
                                 PropertyId::Longhand(LonghandId::MozBoxDirection)],
                            [MozBoxDirection, SetMozBoxDirection,
                             PropertyId::Longhand(LonghandId::MozBoxDirection)],
                                [_webkit_box_direction, Set_webkit_box_direction,
                                 PropertyId::Longhand(LonghandId::MozBoxDirection)],
                            [WebkitBoxDirection, SetWebkitBoxDirection,
                             PropertyId::Longhand(LonghandId::MozBoxDirection)],
                                [_moz_box_orient, Set_moz_box_orient,
                                 PropertyId::Longhand(LonghandId::MozBoxOrient)],
                            [MozBoxOrient, SetMozBoxOrient,
                             PropertyId::Longhand(LonghandId::MozBoxOrient)],
                                [_webkit_box_orient, Set_webkit_box_orient,
                                 PropertyId::Longhand(LonghandId::MozBoxOrient)],
                            [WebkitBoxOrient, SetWebkitBoxOrient,
                             PropertyId::Longhand(LonghandId::MozBoxOrient)],
                                [_moz_box_pack, Set_moz_box_pack,
                                 PropertyId::Longhand(LonghandId::MozBoxPack)],
                            [MozBoxPack, SetMozBoxPack,
                             PropertyId::Longhand(LonghandId::MozBoxPack)],
                                [_webkit_box_pack, Set_webkit_box_pack,
                                 PropertyId::Longhand(LonghandId::MozBoxPack)],
                            [WebkitBoxPack, SetWebkitBoxPack,
                             PropertyId::Longhand(LonghandId::MozBoxPack)],
                                [_moz_control_character_visibility, Set_moz_control_character_visibility,
                                 PropertyId::Longhand(LonghandId::MozControlCharacterVisibility)],
                            [MozControlCharacterVisibility, SetMozControlCharacterVisibility,
                             PropertyId::Longhand(LonghandId::MozControlCharacterVisibility)],
                                [_moz_float_edge, Set_moz_float_edge,
                                 PropertyId::Longhand(LonghandId::MozFloatEdge)],
                            [MozFloatEdge, SetMozFloatEdge,
                             PropertyId::Longhand(LonghandId::MozFloatEdge)],
                                [_moz_force_broken_image_icon, Set_moz_force_broken_image_icon,
                                 PropertyId::Longhand(LonghandId::MozForceBrokenImageIcon)],
                            [MozForceBrokenImageIcon, SetMozForceBrokenImageIcon,
                             PropertyId::Longhand(LonghandId::MozForceBrokenImageIcon)],
                                [_moz_orient, Set_moz_orient,
                                 PropertyId::Longhand(LonghandId::MozOrient)],
                            [MozOrient, SetMozOrient,
                             PropertyId::Longhand(LonghandId::MozOrient)],
                                [_moz_osx_font_smoothing, Set_moz_osx_font_smoothing,
                                 PropertyId::Longhand(LonghandId::MozOsxFontSmoothing)],
                            [MozOsxFontSmoothing, SetMozOsxFontSmoothing,
                             PropertyId::Longhand(LonghandId::MozOsxFontSmoothing)],
                                [_moz_stack_sizing, Set_moz_stack_sizing,
                                 PropertyId::Longhand(LonghandId::MozStackSizing)],
                            [MozStackSizing, SetMozStackSizing,
                             PropertyId::Longhand(LonghandId::MozStackSizing)],
                                [_moz_text_size_adjust, Set_moz_text_size_adjust,
                                 PropertyId::Longhand(LonghandId::MozTextSizeAdjust)],
                            [MozTextSizeAdjust, SetMozTextSizeAdjust,
                             PropertyId::Longhand(LonghandId::MozTextSizeAdjust)],
                                [_webkit_text_size_adjust, Set_webkit_text_size_adjust,
                                 PropertyId::Longhand(LonghandId::MozTextSizeAdjust)],
                            [WebkitTextSizeAdjust, SetWebkitTextSizeAdjust,
                             PropertyId::Longhand(LonghandId::MozTextSizeAdjust)],
                                [_moz_user_focus, Set_moz_user_focus,
                                 PropertyId::Longhand(LonghandId::MozUserFocus)],
                            [MozUserFocus, SetMozUserFocus,
                             PropertyId::Longhand(LonghandId::MozUserFocus)],
                                [_moz_user_input, Set_moz_user_input,
                                 PropertyId::Longhand(LonghandId::MozUserInput)],
                            [MozUserInput, SetMozUserInput,
                             PropertyId::Longhand(LonghandId::MozUserInput)],
                                [_moz_user_modify, Set_moz_user_modify,
                                 PropertyId::Longhand(LonghandId::MozUserModify)],
                            [MozUserModify, SetMozUserModify,
                             PropertyId::Longhand(LonghandId::MozUserModify)],
                                [_moz_user_select, Set_moz_user_select,
                                 PropertyId::Longhand(LonghandId::MozUserSelect)],
                            [MozUserSelect, SetMozUserSelect,
                             PropertyId::Longhand(LonghandId::MozUserSelect)],
                                [_webkit_user_select, Set_webkit_user_select,
                                 PropertyId::Longhand(LonghandId::MozUserSelect)],
                            [WebkitUserSelect, SetWebkitUserSelect,
                             PropertyId::Longhand(LonghandId::MozUserSelect)],
                                [_moz_window_dragging, Set_moz_window_dragging,
                                 PropertyId::Longhand(LonghandId::MozWindowDragging)],
                            [MozWindowDragging, SetMozWindowDragging,
                             PropertyId::Longhand(LonghandId::MozWindowDragging)],
                                [Object_fit, SetObject_fit,
                                 PropertyId::Longhand(LonghandId::ObjectFit)],
                            [ObjectFit, SetObjectFit,
                             PropertyId::Longhand(LonghandId::ObjectFit)],
                                [Outline_style, SetOutline_style,
                                 PropertyId::Longhand(LonghandId::OutlineStyle)],
                            [OutlineStyle, SetOutlineStyle,
                             PropertyId::Longhand(LonghandId::OutlineStyle)],
                                [Overflow_anchor, SetOverflow_anchor,
                                 PropertyId::Longhand(LonghandId::OverflowAnchor)],
                            [OverflowAnchor, SetOverflowAnchor,
                             PropertyId::Longhand(LonghandId::OverflowAnchor)],
                                [Overflow_wrap, SetOverflow_wrap,
                                 PropertyId::Longhand(LonghandId::OverflowWrap)],
                            [OverflowWrap, SetOverflowWrap,
                             PropertyId::Longhand(LonghandId::OverflowWrap)],
                                [Word_wrap, SetWord_wrap,
                                 PropertyId::Longhand(LonghandId::OverflowWrap)],
                            [WordWrap, SetWordWrap,
                             PropertyId::Longhand(LonghandId::OverflowWrap)],
                                [Paint_order, SetPaint_order,
                                 PropertyId::Longhand(LonghandId::PaintOrder)],
                            [PaintOrder, SetPaintOrder,
                             PropertyId::Longhand(LonghandId::PaintOrder)],
                                [Pointer_events, SetPointer_events,
                                 PropertyId::Longhand(LonghandId::PointerEvents)],
                            [PointerEvents, SetPointerEvents,
                             PropertyId::Longhand(LonghandId::PointerEvents)],
                            [Position, SetPosition,
                             PropertyId::Longhand(LonghandId::Position)],
                            [Resize, SetResize,
                             PropertyId::Longhand(LonghandId::Resize)],
                                [Ruby_align, SetRuby_align,
                                 PropertyId::Longhand(LonghandId::RubyAlign)],
                            [RubyAlign, SetRubyAlign,
                             PropertyId::Longhand(LonghandId::RubyAlign)],
                                [Ruby_position, SetRuby_position,
                                 PropertyId::Longhand(LonghandId::RubyPosition)],
                            [RubyPosition, SetRubyPosition,
                             PropertyId::Longhand(LonghandId::RubyPosition)],
                                [Scroll_behavior, SetScroll_behavior,
                                 PropertyId::Longhand(LonghandId::ScrollBehavior)],
                            [ScrollBehavior, SetScrollBehavior,
                             PropertyId::Longhand(LonghandId::ScrollBehavior)],
                                [Scroll_snap_align, SetScroll_snap_align,
                                 PropertyId::Longhand(LonghandId::ScrollSnapAlign)],
                            [ScrollSnapAlign, SetScrollSnapAlign,
                             PropertyId::Longhand(LonghandId::ScrollSnapAlign)],
                                [Scroll_snap_type, SetScroll_snap_type,
                                 PropertyId::Longhand(LonghandId::ScrollSnapType)],
                            [ScrollSnapType, SetScrollSnapType,
                             PropertyId::Longhand(LonghandId::ScrollSnapType)],
                                [Shape_rendering, SetShape_rendering,
                                 PropertyId::Longhand(LonghandId::ShapeRendering)],
                            [ShapeRendering, SetShapeRendering,
                             PropertyId::Longhand(LonghandId::ShapeRendering)],
                                [Stroke_linecap, SetStroke_linecap,
                                 PropertyId::Longhand(LonghandId::StrokeLinecap)],
                            [StrokeLinecap, SetStrokeLinecap,
                             PropertyId::Longhand(LonghandId::StrokeLinecap)],
                                [Stroke_linejoin, SetStroke_linejoin,
                                 PropertyId::Longhand(LonghandId::StrokeLinejoin)],
                            [StrokeLinejoin, SetStrokeLinejoin,
                             PropertyId::Longhand(LonghandId::StrokeLinejoin)],
                                [Table_layout, SetTable_layout,
                                 PropertyId::Longhand(LonghandId::TableLayout)],
                            [TableLayout, SetTableLayout,
                             PropertyId::Longhand(LonghandId::TableLayout)],
                                [Text_align, SetText_align,
                                 PropertyId::Longhand(LonghandId::TextAlign)],
                            [TextAlign, SetTextAlign,
                             PropertyId::Longhand(LonghandId::TextAlign)],
                                [Text_align_last, SetText_align_last,
                                 PropertyId::Longhand(LonghandId::TextAlignLast)],
                            [TextAlignLast, SetTextAlignLast,
                             PropertyId::Longhand(LonghandId::TextAlignLast)],
                                [Text_anchor, SetText_anchor,
                                 PropertyId::Longhand(LonghandId::TextAnchor)],
                            [TextAnchor, SetTextAnchor,
                             PropertyId::Longhand(LonghandId::TextAnchor)],
                                [Text_combine_upright, SetText_combine_upright,
                                 PropertyId::Longhand(LonghandId::TextCombineUpright)],
                            [TextCombineUpright, SetTextCombineUpright,
                             PropertyId::Longhand(LonghandId::TextCombineUpright)],
                                [Text_decoration_line, SetText_decoration_line,
                                 PropertyId::Longhand(LonghandId::TextDecorationLine)],
                            [TextDecorationLine, SetTextDecorationLine,
                             PropertyId::Longhand(LonghandId::TextDecorationLine)],
                                [Text_decoration_style, SetText_decoration_style,
                                 PropertyId::Longhand(LonghandId::TextDecorationStyle)],
                            [TextDecorationStyle, SetTextDecorationStyle,
                             PropertyId::Longhand(LonghandId::TextDecorationStyle)],
                                [Text_emphasis_position, SetText_emphasis_position,
                                 PropertyId::Longhand(LonghandId::TextEmphasisPosition)],
                            [TextEmphasisPosition, SetTextEmphasisPosition,
                             PropertyId::Longhand(LonghandId::TextEmphasisPosition)],
                                [Text_justify, SetText_justify,
                                 PropertyId::Longhand(LonghandId::TextJustify)],
                            [TextJustify, SetTextJustify,
                             PropertyId::Longhand(LonghandId::TextJustify)],
                                [Text_orientation, SetText_orientation,
                                 PropertyId::Longhand(LonghandId::TextOrientation)],
                            [TextOrientation, SetTextOrientation,
                             PropertyId::Longhand(LonghandId::TextOrientation)],
                                [Text_rendering, SetText_rendering,
                                 PropertyId::Longhand(LonghandId::TextRendering)],
                            [TextRendering, SetTextRendering,
                             PropertyId::Longhand(LonghandId::TextRendering)],
                                [Text_transform, SetText_transform,
                                 PropertyId::Longhand(LonghandId::TextTransform)],
                            [TextTransform, SetTextTransform,
                             PropertyId::Longhand(LonghandId::TextTransform)],
                                [Touch_action, SetTouch_action,
                                 PropertyId::Longhand(LonghandId::TouchAction)],
                            [TouchAction, SetTouchAction,
                             PropertyId::Longhand(LonghandId::TouchAction)],
                                [Transform_box, SetTransform_box,
                                 PropertyId::Longhand(LonghandId::TransformBox)],
                            [TransformBox, SetTransformBox,
                             PropertyId::Longhand(LonghandId::TransformBox)],
                                [Transform_style, SetTransform_style,
                                 PropertyId::Longhand(LonghandId::TransformStyle)],
                            [TransformStyle, SetTransformStyle,
                             PropertyId::Longhand(LonghandId::TransformStyle)],
                                [_moz_transform_style, Set_moz_transform_style,
                                 PropertyId::Longhand(LonghandId::TransformStyle)],
                            [MozTransformStyle, SetMozTransformStyle,
                             PropertyId::Longhand(LonghandId::TransformStyle)],
                                [_webkit_transform_style, Set_webkit_transform_style,
                                 PropertyId::Longhand(LonghandId::TransformStyle)],
                            [WebkitTransformStyle, SetWebkitTransformStyle,
                             PropertyId::Longhand(LonghandId::TransformStyle)],
                                [Unicode_bidi, SetUnicode_bidi,
                                 PropertyId::Longhand(LonghandId::UnicodeBidi)],
                            [UnicodeBidi, SetUnicodeBidi,
                             PropertyId::Longhand(LonghandId::UnicodeBidi)],
                                [Vector_effect, SetVector_effect,
                                 PropertyId::Longhand(LonghandId::VectorEffect)],
                            [VectorEffect, SetVectorEffect,
                             PropertyId::Longhand(LonghandId::VectorEffect)],
                            [Visibility, SetVisibility,
                             PropertyId::Longhand(LonghandId::Visibility)],
                                [_webkit_line_clamp, Set_webkit_line_clamp,
                                 PropertyId::Longhand(LonghandId::WebkitLineClamp)],
                            [WebkitLineClamp, SetWebkitLineClamp,
                             PropertyId::Longhand(LonghandId::WebkitLineClamp)],
                                [White_space, SetWhite_space,
                                 PropertyId::Longhand(LonghandId::WhiteSpace)],
                            [WhiteSpace, SetWhiteSpace,
                             PropertyId::Longhand(LonghandId::WhiteSpace)],
                                [Word_break, SetWord_break,
                                 PropertyId::Longhand(LonghandId::WordBreak)],
                            [WordBreak, SetWordBreak,
                             PropertyId::Longhand(LonghandId::WordBreak)],
                                [Writing_mode, SetWriting_mode,
                                 PropertyId::Longhand(LonghandId::WritingMode)],
                            [WritingMode, SetWritingMode,
                             PropertyId::Longhand(LonghandId::WritingMode)],
                                [Z_index, SetZ_index,
                                 PropertyId::Longhand(LonghandId::ZIndex)],
                            [ZIndex, SetZIndex,
                             PropertyId::Longhand(LonghandId::ZIndex)],
                                [Break_after, SetBreak_after,
                                 PropertyId::Longhand(LonghandId::BreakAfter)],
                            [BreakAfter, SetBreakAfter,
                             PropertyId::Longhand(LonghandId::BreakAfter)],
                                [Break_before, SetBreak_before,
                                 PropertyId::Longhand(LonghandId::BreakBefore)],
                            [BreakBefore, SetBreakBefore,
                             PropertyId::Longhand(LonghandId::BreakBefore)],
                                [Clip_rule, SetClip_rule,
                                 PropertyId::Longhand(LonghandId::ClipRule)],
                            [ClipRule, SetClipRule,
                             PropertyId::Longhand(LonghandId::ClipRule)],
                                [Fill_rule, SetFill_rule,
                                 PropertyId::Longhand(LonghandId::FillRule)],
                            [FillRule, SetFillRule,
                             PropertyId::Longhand(LonghandId::FillRule)],
                                [_moz_box_ordinal_group, Set_moz_box_ordinal_group,
                                 PropertyId::Longhand(LonghandId::MozBoxOrdinalGroup)],
                            [MozBoxOrdinalGroup, SetMozBoxOrdinalGroup,
                             PropertyId::Longhand(LonghandId::MozBoxOrdinalGroup)],
                                [_webkit_box_ordinal_group, Set_webkit_box_ordinal_group,
                                 PropertyId::Longhand(LonghandId::MozBoxOrdinalGroup)],
                            [WebkitBoxOrdinalGroup, SetWebkitBoxOrdinalGroup,
                             PropertyId::Longhand(LonghandId::MozBoxOrdinalGroup)],
                            [Order, SetOrder,
                             PropertyId::Longhand(LonghandId::Order)],
                                [_webkit_order, Set_webkit_order,
                                 PropertyId::Longhand(LonghandId::Order)],
                            [WebkitOrder, SetWebkitOrder,
                             PropertyId::Longhand(LonghandId::Order)],
                                [Overflow_x, SetOverflow_x,
                                 PropertyId::Longhand(LonghandId::OverflowX)],
                            [OverflowX, SetOverflowX,
                             PropertyId::Longhand(LonghandId::OverflowX)],
                                [Overflow_y, SetOverflow_y,
                                 PropertyId::Longhand(LonghandId::OverflowY)],
                            [OverflowY, SetOverflowY,
                             PropertyId::Longhand(LonghandId::OverflowY)],
                                [Overscroll_behavior_x, SetOverscroll_behavior_x,
                                 PropertyId::Longhand(LonghandId::OverscrollBehaviorX)],
                            [OverscrollBehaviorX, SetOverscrollBehaviorX,
                             PropertyId::Longhand(LonghandId::OverscrollBehaviorX)],
                                [Overscroll_behavior_y, SetOverscroll_behavior_y,
                                 PropertyId::Longhand(LonghandId::OverscrollBehaviorY)],
                            [OverscrollBehaviorY, SetOverscrollBehaviorY,
                             PropertyId::Longhand(LonghandId::OverscrollBehaviorY)],
                                [Fill_opacity, SetFill_opacity,
                                 PropertyId::Longhand(LonghandId::FillOpacity)],
                            [FillOpacity, SetFillOpacity,
                             PropertyId::Longhand(LonghandId::FillOpacity)],
                                [Stroke_opacity, SetStroke_opacity,
                                 PropertyId::Longhand(LonghandId::StrokeOpacity)],
                            [StrokeOpacity, SetStrokeOpacity,
                             PropertyId::Longhand(LonghandId::StrokeOpacity)],
                                [Flex_grow, SetFlex_grow,
                                 PropertyId::Longhand(LonghandId::FlexGrow)],
                            [FlexGrow, SetFlexGrow,
                             PropertyId::Longhand(LonghandId::FlexGrow)],
                                [_webkit_flex_grow, Set_webkit_flex_grow,
                                 PropertyId::Longhand(LonghandId::FlexGrow)],
                            [WebkitFlexGrow, SetWebkitFlexGrow,
                             PropertyId::Longhand(LonghandId::FlexGrow)],
                                [Flex_shrink, SetFlex_shrink,
                                 PropertyId::Longhand(LonghandId::FlexShrink)],
                            [FlexShrink, SetFlexShrink,
                             PropertyId::Longhand(LonghandId::FlexShrink)],
                                [_webkit_flex_shrink, Set_webkit_flex_shrink,
                                 PropertyId::Longhand(LonghandId::FlexShrink)],
                            [WebkitFlexShrink, SetWebkitFlexShrink,
                             PropertyId::Longhand(LonghandId::FlexShrink)],
                                [_moz_box_flex, Set_moz_box_flex,
                                 PropertyId::Longhand(LonghandId::MozBoxFlex)],
                            [MozBoxFlex, SetMozBoxFlex,
                             PropertyId::Longhand(LonghandId::MozBoxFlex)],
                                [_webkit_box_flex, Set_webkit_box_flex,
                                 PropertyId::Longhand(LonghandId::MozBoxFlex)],
                            [WebkitBoxFlex, SetWebkitBoxFlex,
                             PropertyId::Longhand(LonghandId::MozBoxFlex)],
                                [Stroke_miterlimit, SetStroke_miterlimit,
                                 PropertyId::Longhand(LonghandId::StrokeMiterlimit)],
                            [StrokeMiterlimit, SetStrokeMiterlimit,
                             PropertyId::Longhand(LonghandId::StrokeMiterlimit)],
                                [Flood_opacity, SetFlood_opacity,
                                 PropertyId::Longhand(LonghandId::FloodOpacity)],
                            [FloodOpacity, SetFloodOpacity,
                             PropertyId::Longhand(LonghandId::FloodOpacity)],
                            [Opacity, SetOpacity,
                             PropertyId::Longhand(LonghandId::Opacity)],
                                [Shape_image_threshold, SetShape_image_threshold,
                                 PropertyId::Longhand(LonghandId::ShapeImageThreshold)],
                            [ShapeImageThreshold, SetShapeImageThreshold,
                             PropertyId::Longhand(LonghandId::ShapeImageThreshold)],
                                [Stop_opacity, SetStop_opacity,
                                 PropertyId::Longhand(LonghandId::StopOpacity)],
                            [StopOpacity, SetStopOpacity,
                             PropertyId::Longhand(LonghandId::StopOpacity)],
                                [Border_block_end_style, SetBorder_block_end_style,
                                 PropertyId::Longhand(LonghandId::BorderBlockEndStyle)],
                            [BorderBlockEndStyle, SetBorderBlockEndStyle,
                             PropertyId::Longhand(LonghandId::BorderBlockEndStyle)],
                                [Border_block_start_style, SetBorder_block_start_style,
                                 PropertyId::Longhand(LonghandId::BorderBlockStartStyle)],
                            [BorderBlockStartStyle, SetBorderBlockStartStyle,
                             PropertyId::Longhand(LonghandId::BorderBlockStartStyle)],
                                [Border_bottom_style, SetBorder_bottom_style,
                                 PropertyId::Longhand(LonghandId::BorderBottomStyle)],
                            [BorderBottomStyle, SetBorderBottomStyle,
                             PropertyId::Longhand(LonghandId::BorderBottomStyle)],
                                [Border_inline_end_style, SetBorder_inline_end_style,
                                 PropertyId::Longhand(LonghandId::BorderInlineEndStyle)],
                            [BorderInlineEndStyle, SetBorderInlineEndStyle,
                             PropertyId::Longhand(LonghandId::BorderInlineEndStyle)],
                                [_moz_border_end_style, Set_moz_border_end_style,
                                 PropertyId::Longhand(LonghandId::BorderInlineEndStyle)],
                            [MozBorderEndStyle, SetMozBorderEndStyle,
                             PropertyId::Longhand(LonghandId::BorderInlineEndStyle)],
                                [Border_inline_start_style, SetBorder_inline_start_style,
                                 PropertyId::Longhand(LonghandId::BorderInlineStartStyle)],
                            [BorderInlineStartStyle, SetBorderInlineStartStyle,
                             PropertyId::Longhand(LonghandId::BorderInlineStartStyle)],
                                [_moz_border_start_style, Set_moz_border_start_style,
                                 PropertyId::Longhand(LonghandId::BorderInlineStartStyle)],
                            [MozBorderStartStyle, SetMozBorderStartStyle,
                             PropertyId::Longhand(LonghandId::BorderInlineStartStyle)],
                                [Border_left_style, SetBorder_left_style,
                                 PropertyId::Longhand(LonghandId::BorderLeftStyle)],
                            [BorderLeftStyle, SetBorderLeftStyle,
                             PropertyId::Longhand(LonghandId::BorderLeftStyle)],
                                [Border_right_style, SetBorder_right_style,
                                 PropertyId::Longhand(LonghandId::BorderRightStyle)],
                            [BorderRightStyle, SetBorderRightStyle,
                             PropertyId::Longhand(LonghandId::BorderRightStyle)],
                                [Border_top_style, SetBorder_top_style,
                                 PropertyId::Longhand(LonghandId::BorderTopStyle)],
                            [BorderTopStyle, SetBorderTopStyle,
                             PropertyId::Longhand(LonghandId::BorderTopStyle)],
                                [Column_rule_style, SetColumn_rule_style,
                                 PropertyId::Longhand(LonghandId::ColumnRuleStyle)],
                            [ColumnRuleStyle, SetColumnRuleStyle,
                             PropertyId::Longhand(LonghandId::ColumnRuleStyle)],
                                [_moz_column_rule_style, Set_moz_column_rule_style,
                                 PropertyId::Longhand(LonghandId::ColumnRuleStyle)],
                            [MozColumnRuleStyle, SetMozColumnRuleStyle,
                             PropertyId::Longhand(LonghandId::ColumnRuleStyle)],
                                [Animation_delay, SetAnimation_delay,
                                 PropertyId::Longhand(LonghandId::AnimationDelay)],
                            [AnimationDelay, SetAnimationDelay,
                             PropertyId::Longhand(LonghandId::AnimationDelay)],
                                [_moz_animation_delay, Set_moz_animation_delay,
                                 PropertyId::Longhand(LonghandId::AnimationDelay)],
                            [MozAnimationDelay, SetMozAnimationDelay,
                             PropertyId::Longhand(LonghandId::AnimationDelay)],
                                [_webkit_animation_delay, Set_webkit_animation_delay,
                                 PropertyId::Longhand(LonghandId::AnimationDelay)],
                            [WebkitAnimationDelay, SetWebkitAnimationDelay,
                             PropertyId::Longhand(LonghandId::AnimationDelay)],
                                [Animation_direction, SetAnimation_direction,
                                 PropertyId::Longhand(LonghandId::AnimationDirection)],
                            [AnimationDirection, SetAnimationDirection,
                             PropertyId::Longhand(LonghandId::AnimationDirection)],
                                [_moz_animation_direction, Set_moz_animation_direction,
                                 PropertyId::Longhand(LonghandId::AnimationDirection)],
                            [MozAnimationDirection, SetMozAnimationDirection,
                             PropertyId::Longhand(LonghandId::AnimationDirection)],
                                [_webkit_animation_direction, Set_webkit_animation_direction,
                                 PropertyId::Longhand(LonghandId::AnimationDirection)],
                            [WebkitAnimationDirection, SetWebkitAnimationDirection,
                             PropertyId::Longhand(LonghandId::AnimationDirection)],
                                [Animation_duration, SetAnimation_duration,
                                 PropertyId::Longhand(LonghandId::AnimationDuration)],
                            [AnimationDuration, SetAnimationDuration,
                             PropertyId::Longhand(LonghandId::AnimationDuration)],
                                [_moz_animation_duration, Set_moz_animation_duration,
                                 PropertyId::Longhand(LonghandId::AnimationDuration)],
                            [MozAnimationDuration, SetMozAnimationDuration,
                             PropertyId::Longhand(LonghandId::AnimationDuration)],
                                [_webkit_animation_duration, Set_webkit_animation_duration,
                                 PropertyId::Longhand(LonghandId::AnimationDuration)],
                            [WebkitAnimationDuration, SetWebkitAnimationDuration,
                             PropertyId::Longhand(LonghandId::AnimationDuration)],
                                [Animation_fill_mode, SetAnimation_fill_mode,
                                 PropertyId::Longhand(LonghandId::AnimationFillMode)],
                            [AnimationFillMode, SetAnimationFillMode,
                             PropertyId::Longhand(LonghandId::AnimationFillMode)],
                                [_moz_animation_fill_mode, Set_moz_animation_fill_mode,
                                 PropertyId::Longhand(LonghandId::AnimationFillMode)],
                            [MozAnimationFillMode, SetMozAnimationFillMode,
                             PropertyId::Longhand(LonghandId::AnimationFillMode)],
                                [_webkit_animation_fill_mode, Set_webkit_animation_fill_mode,
                                 PropertyId::Longhand(LonghandId::AnimationFillMode)],
                            [WebkitAnimationFillMode, SetWebkitAnimationFillMode,
                             PropertyId::Longhand(LonghandId::AnimationFillMode)],
                                [Animation_iteration_count, SetAnimation_iteration_count,
                                 PropertyId::Longhand(LonghandId::AnimationIterationCount)],
                            [AnimationIterationCount, SetAnimationIterationCount,
                             PropertyId::Longhand(LonghandId::AnimationIterationCount)],
                                [_moz_animation_iteration_count, Set_moz_animation_iteration_count,
                                 PropertyId::Longhand(LonghandId::AnimationIterationCount)],
                            [MozAnimationIterationCount, SetMozAnimationIterationCount,
                             PropertyId::Longhand(LonghandId::AnimationIterationCount)],
                                [_webkit_animation_iteration_count, Set_webkit_animation_iteration_count,
                                 PropertyId::Longhand(LonghandId::AnimationIterationCount)],
                            [WebkitAnimationIterationCount, SetWebkitAnimationIterationCount,
                             PropertyId::Longhand(LonghandId::AnimationIterationCount)],
                                [Animation_name, SetAnimation_name,
                                 PropertyId::Longhand(LonghandId::AnimationName)],
                            [AnimationName, SetAnimationName,
                             PropertyId::Longhand(LonghandId::AnimationName)],
                                [_moz_animation_name, Set_moz_animation_name,
                                 PropertyId::Longhand(LonghandId::AnimationName)],
                            [MozAnimationName, SetMozAnimationName,
                             PropertyId::Longhand(LonghandId::AnimationName)],
                                [_webkit_animation_name, Set_webkit_animation_name,
                                 PropertyId::Longhand(LonghandId::AnimationName)],
                            [WebkitAnimationName, SetWebkitAnimationName,
                             PropertyId::Longhand(LonghandId::AnimationName)],
                                [Animation_play_state, SetAnimation_play_state,
                                 PropertyId::Longhand(LonghandId::AnimationPlayState)],
                            [AnimationPlayState, SetAnimationPlayState,
                             PropertyId::Longhand(LonghandId::AnimationPlayState)],
                                [_moz_animation_play_state, Set_moz_animation_play_state,
                                 PropertyId::Longhand(LonghandId::AnimationPlayState)],
                            [MozAnimationPlayState, SetMozAnimationPlayState,
                             PropertyId::Longhand(LonghandId::AnimationPlayState)],
                                [_webkit_animation_play_state, Set_webkit_animation_play_state,
                                 PropertyId::Longhand(LonghandId::AnimationPlayState)],
                            [WebkitAnimationPlayState, SetWebkitAnimationPlayState,
                             PropertyId::Longhand(LonghandId::AnimationPlayState)],
                                [Animation_timing_function, SetAnimation_timing_function,
                                 PropertyId::Longhand(LonghandId::AnimationTimingFunction)],
                            [AnimationTimingFunction, SetAnimationTimingFunction,
                             PropertyId::Longhand(LonghandId::AnimationTimingFunction)],
                                [_moz_animation_timing_function, Set_moz_animation_timing_function,
                                 PropertyId::Longhand(LonghandId::AnimationTimingFunction)],
                            [MozAnimationTimingFunction, SetMozAnimationTimingFunction,
                             PropertyId::Longhand(LonghandId::AnimationTimingFunction)],
                                [_webkit_animation_timing_function, Set_webkit_animation_timing_function,
                                 PropertyId::Longhand(LonghandId::AnimationTimingFunction)],
                            [WebkitAnimationTimingFunction, SetWebkitAnimationTimingFunction,
                             PropertyId::Longhand(LonghandId::AnimationTimingFunction)],
                                [Background_attachment, SetBackground_attachment,
                                 PropertyId::Longhand(LonghandId::BackgroundAttachment)],
                            [BackgroundAttachment, SetBackgroundAttachment,
                             PropertyId::Longhand(LonghandId::BackgroundAttachment)],
                                [Background_blend_mode, SetBackground_blend_mode,
                                 PropertyId::Longhand(LonghandId::BackgroundBlendMode)],
                            [BackgroundBlendMode, SetBackgroundBlendMode,
                             PropertyId::Longhand(LonghandId::BackgroundBlendMode)],
                                [Background_clip, SetBackground_clip,
                                 PropertyId::Longhand(LonghandId::BackgroundClip)],
                            [BackgroundClip, SetBackgroundClip,
                             PropertyId::Longhand(LonghandId::BackgroundClip)],
                                [_webkit_background_clip, Set_webkit_background_clip,
                                 PropertyId::Longhand(LonghandId::BackgroundClip)],
                            [WebkitBackgroundClip, SetWebkitBackgroundClip,
                             PropertyId::Longhand(LonghandId::BackgroundClip)],
                                [Background_image, SetBackground_image,
                                 PropertyId::Longhand(LonghandId::BackgroundImage)],
                            [BackgroundImage, SetBackgroundImage,
                             PropertyId::Longhand(LonghandId::BackgroundImage)],
                                [Background_origin, SetBackground_origin,
                                 PropertyId::Longhand(LonghandId::BackgroundOrigin)],
                            [BackgroundOrigin, SetBackgroundOrigin,
                             PropertyId::Longhand(LonghandId::BackgroundOrigin)],
                                [_webkit_background_origin, Set_webkit_background_origin,
                                 PropertyId::Longhand(LonghandId::BackgroundOrigin)],
                            [WebkitBackgroundOrigin, SetWebkitBackgroundOrigin,
                             PropertyId::Longhand(LonghandId::BackgroundOrigin)],
                                [Background_position_x, SetBackground_position_x,
                                 PropertyId::Longhand(LonghandId::BackgroundPositionX)],
                            [BackgroundPositionX, SetBackgroundPositionX,
                             PropertyId::Longhand(LonghandId::BackgroundPositionX)],
                                [Background_position_y, SetBackground_position_y,
                                 PropertyId::Longhand(LonghandId::BackgroundPositionY)],
                            [BackgroundPositionY, SetBackgroundPositionY,
                             PropertyId::Longhand(LonghandId::BackgroundPositionY)],
                                [Background_repeat, SetBackground_repeat,
                                 PropertyId::Longhand(LonghandId::BackgroundRepeat)],
                            [BackgroundRepeat, SetBackgroundRepeat,
                             PropertyId::Longhand(LonghandId::BackgroundRepeat)],
                                [Background_size, SetBackground_size,
                                 PropertyId::Longhand(LonghandId::BackgroundSize)],
                            [BackgroundSize, SetBackgroundSize,
                             PropertyId::Longhand(LonghandId::BackgroundSize)],
                                [_webkit_background_size, Set_webkit_background_size,
                                 PropertyId::Longhand(LonghandId::BackgroundSize)],
                            [WebkitBackgroundSize, SetWebkitBackgroundSize,
                             PropertyId::Longhand(LonghandId::BackgroundSize)],
                                [Border_image_outset, SetBorder_image_outset,
                                 PropertyId::Longhand(LonghandId::BorderImageOutset)],
                            [BorderImageOutset, SetBorderImageOutset,
                             PropertyId::Longhand(LonghandId::BorderImageOutset)],
                                [Border_image_slice, SetBorder_image_slice,
                                 PropertyId::Longhand(LonghandId::BorderImageSlice)],
                            [BorderImageSlice, SetBorderImageSlice,
                             PropertyId::Longhand(LonghandId::BorderImageSlice)],
                                [Border_image_source, SetBorder_image_source,
                                 PropertyId::Longhand(LonghandId::BorderImageSource)],
                            [BorderImageSource, SetBorderImageSource,
                             PropertyId::Longhand(LonghandId::BorderImageSource)],
                                [Border_image_width, SetBorder_image_width,
                                 PropertyId::Longhand(LonghandId::BorderImageWidth)],
                            [BorderImageWidth, SetBorderImageWidth,
                             PropertyId::Longhand(LonghandId::BorderImageWidth)],
                                [Border_spacing, SetBorder_spacing,
                                 PropertyId::Longhand(LonghandId::BorderSpacing)],
                            [BorderSpacing, SetBorderSpacing,
                             PropertyId::Longhand(LonghandId::BorderSpacing)],
                                [Box_shadow, SetBox_shadow,
                                 PropertyId::Longhand(LonghandId::BoxShadow)],
                            [BoxShadow, SetBoxShadow,
                             PropertyId::Longhand(LonghandId::BoxShadow)],
                                [_webkit_box_shadow, Set_webkit_box_shadow,
                                 PropertyId::Longhand(LonghandId::BoxShadow)],
                            [WebkitBoxShadow, SetWebkitBoxShadow,
                             PropertyId::Longhand(LonghandId::BoxShadow)],
                                [Caret_color, SetCaret_color,
                                 PropertyId::Longhand(LonghandId::CaretColor)],
                            [CaretColor, SetCaretColor,
                             PropertyId::Longhand(LonghandId::CaretColor)],
                                [Clip_path, SetClip_path,
                                 PropertyId::Longhand(LonghandId::ClipPath)],
                            [ClipPath, SetClipPath,
                             PropertyId::Longhand(LonghandId::ClipPath)],
                            [Color, SetColor,
                             PropertyId::Longhand(LonghandId::Color)],
                                [Column_width, SetColumn_width,
                                 PropertyId::Longhand(LonghandId::ColumnWidth)],
                            [ColumnWidth, SetColumnWidth,
                             PropertyId::Longhand(LonghandId::ColumnWidth)],
                                [_moz_column_width, Set_moz_column_width,
                                 PropertyId::Longhand(LonghandId::ColumnWidth)],
                            [MozColumnWidth, SetMozColumnWidth,
                             PropertyId::Longhand(LonghandId::ColumnWidth)],
                            [Content, SetContent,
                             PropertyId::Longhand(LonghandId::Content)],
                                [Counter_increment, SetCounter_increment,
                                 PropertyId::Longhand(LonghandId::CounterIncrement)],
                            [CounterIncrement, SetCounterIncrement,
                             PropertyId::Longhand(LonghandId::CounterIncrement)],
                            [Cursor, SetCursor,
                             PropertyId::Longhand(LonghandId::Cursor)],
                            [Filter, SetFilter,
                             PropertyId::Longhand(LonghandId::Filter)],
                                [_webkit_filter, Set_webkit_filter,
                                 PropertyId::Longhand(LonghandId::Filter)],
                            [WebkitFilter, SetWebkitFilter,
                             PropertyId::Longhand(LonghandId::Filter)],
                                [Flex_basis, SetFlex_basis,
                                 PropertyId::Longhand(LonghandId::FlexBasis)],
                            [FlexBasis, SetFlexBasis,
                             PropertyId::Longhand(LonghandId::FlexBasis)],
                                [_webkit_flex_basis, Set_webkit_flex_basis,
                                 PropertyId::Longhand(LonghandId::FlexBasis)],
                            [WebkitFlexBasis, SetWebkitFlexBasis,
                             PropertyId::Longhand(LonghandId::FlexBasis)],
                                [Font_family, SetFont_family,
                                 PropertyId::Longhand(LonghandId::FontFamily)],
                            [FontFamily, SetFontFamily,
                             PropertyId::Longhand(LonghandId::FontFamily)],
                                [Font_feature_settings, SetFont_feature_settings,
                                 PropertyId::Longhand(LonghandId::FontFeatureSettings)],
                            [FontFeatureSettings, SetFontFeatureSettings,
                             PropertyId::Longhand(LonghandId::FontFeatureSettings)],
                                [_moz_font_feature_settings, Set_moz_font_feature_settings,
                                 PropertyId::Longhand(LonghandId::FontFeatureSettings)],
                            [MozFontFeatureSettings, SetMozFontFeatureSettings,
                             PropertyId::Longhand(LonghandId::FontFeatureSettings)],
                                [Font_language_override, SetFont_language_override,
                                 PropertyId::Longhand(LonghandId::FontLanguageOverride)],
                            [FontLanguageOverride, SetFontLanguageOverride,
                             PropertyId::Longhand(LonghandId::FontLanguageOverride)],
                                [_moz_font_language_override, Set_moz_font_language_override,
                                 PropertyId::Longhand(LonghandId::FontLanguageOverride)],
                            [MozFontLanguageOverride, SetMozFontLanguageOverride,
                             PropertyId::Longhand(LonghandId::FontLanguageOverride)],
                                [Font_size, SetFont_size,
                                 PropertyId::Longhand(LonghandId::FontSize)],
                            [FontSize, SetFontSize,
                             PropertyId::Longhand(LonghandId::FontSize)],
                                [Font_variant_alternates, SetFont_variant_alternates,
                                 PropertyId::Longhand(LonghandId::FontVariantAlternates)],
                            [FontVariantAlternates, SetFontVariantAlternates,
                             PropertyId::Longhand(LonghandId::FontVariantAlternates)],
                                [Font_variation_settings, SetFont_variation_settings,
                                 PropertyId::Longhand(LonghandId::FontVariationSettings)],
                            [FontVariationSettings, SetFontVariationSettings,
                             PropertyId::Longhand(LonghandId::FontVariationSettings)],
                                [Grid_template_areas, SetGrid_template_areas,
                                 PropertyId::Longhand(LonghandId::GridTemplateAreas)],
                            [GridTemplateAreas, SetGridTemplateAreas,
                             PropertyId::Longhand(LonghandId::GridTemplateAreas)],
                                [Letter_spacing, SetLetter_spacing,
                                 PropertyId::Longhand(LonghandId::LetterSpacing)],
                            [LetterSpacing, SetLetterSpacing,
                             PropertyId::Longhand(LonghandId::LetterSpacing)],
                                [Line_height, SetLine_height,
                                 PropertyId::Longhand(LonghandId::LineHeight)],
                            [LineHeight, SetLineHeight,
                             PropertyId::Longhand(LonghandId::LineHeight)],
                                [List_style_image, SetList_style_image,
                                 PropertyId::Longhand(LonghandId::ListStyleImage)],
                            [ListStyleImage, SetListStyleImage,
                             PropertyId::Longhand(LonghandId::ListStyleImage)],
                                [List_style_type, SetList_style_type,
                                 PropertyId::Longhand(LonghandId::ListStyleType)],
                            [ListStyleType, SetListStyleType,
                             PropertyId::Longhand(LonghandId::ListStyleType)],
                                [Mask_clip, SetMask_clip,
                                 PropertyId::Longhand(LonghandId::MaskClip)],
                            [MaskClip, SetMaskClip,
                             PropertyId::Longhand(LonghandId::MaskClip)],
                                [_webkit_mask_clip, Set_webkit_mask_clip,
                                 PropertyId::Longhand(LonghandId::MaskClip)],
                            [WebkitMaskClip, SetWebkitMaskClip,
                             PropertyId::Longhand(LonghandId::MaskClip)],
                                [Mask_composite, SetMask_composite,
                                 PropertyId::Longhand(LonghandId::MaskComposite)],
                            [MaskComposite, SetMaskComposite,
                             PropertyId::Longhand(LonghandId::MaskComposite)],
                                [_webkit_mask_composite, Set_webkit_mask_composite,
                                 PropertyId::Longhand(LonghandId::MaskComposite)],
                            [WebkitMaskComposite, SetWebkitMaskComposite,
                             PropertyId::Longhand(LonghandId::MaskComposite)],
                                [Mask_image, SetMask_image,
                                 PropertyId::Longhand(LonghandId::MaskImage)],
                            [MaskImage, SetMaskImage,
                             PropertyId::Longhand(LonghandId::MaskImage)],
                                [_webkit_mask_image, Set_webkit_mask_image,
                                 PropertyId::Longhand(LonghandId::MaskImage)],
                            [WebkitMaskImage, SetWebkitMaskImage,
                             PropertyId::Longhand(LonghandId::MaskImage)],
                                [Mask_mode, SetMask_mode,
                                 PropertyId::Longhand(LonghandId::MaskMode)],
                            [MaskMode, SetMaskMode,
                             PropertyId::Longhand(LonghandId::MaskMode)],
                                [Mask_origin, SetMask_origin,
                                 PropertyId::Longhand(LonghandId::MaskOrigin)],
                            [MaskOrigin, SetMaskOrigin,
                             PropertyId::Longhand(LonghandId::MaskOrigin)],
                                [_webkit_mask_origin, Set_webkit_mask_origin,
                                 PropertyId::Longhand(LonghandId::MaskOrigin)],
                            [WebkitMaskOrigin, SetWebkitMaskOrigin,
                             PropertyId::Longhand(LonghandId::MaskOrigin)],
                                [Mask_position_x, SetMask_position_x,
                                 PropertyId::Longhand(LonghandId::MaskPositionX)],
                            [MaskPositionX, SetMaskPositionX,
                             PropertyId::Longhand(LonghandId::MaskPositionX)],
                                [_webkit_mask_position_x, Set_webkit_mask_position_x,
                                 PropertyId::Longhand(LonghandId::MaskPositionX)],
                            [WebkitMaskPositionX, SetWebkitMaskPositionX,
                             PropertyId::Longhand(LonghandId::MaskPositionX)],
                                [Mask_position_y, SetMask_position_y,
                                 PropertyId::Longhand(LonghandId::MaskPositionY)],
                            [MaskPositionY, SetMaskPositionY,
                             PropertyId::Longhand(LonghandId::MaskPositionY)],
                                [_webkit_mask_position_y, Set_webkit_mask_position_y,
                                 PropertyId::Longhand(LonghandId::MaskPositionY)],
                            [WebkitMaskPositionY, SetWebkitMaskPositionY,
                             PropertyId::Longhand(LonghandId::MaskPositionY)],
                                [Mask_repeat, SetMask_repeat,
                                 PropertyId::Longhand(LonghandId::MaskRepeat)],
                            [MaskRepeat, SetMaskRepeat,
                             PropertyId::Longhand(LonghandId::MaskRepeat)],
                                [_webkit_mask_repeat, Set_webkit_mask_repeat,
                                 PropertyId::Longhand(LonghandId::MaskRepeat)],
                            [WebkitMaskRepeat, SetWebkitMaskRepeat,
                             PropertyId::Longhand(LonghandId::MaskRepeat)],
                                [Mask_size, SetMask_size,
                                 PropertyId::Longhand(LonghandId::MaskSize)],
                            [MaskSize, SetMaskSize,
                             PropertyId::Longhand(LonghandId::MaskSize)],
                                [_webkit_mask_size, Set_webkit_mask_size,
                                 PropertyId::Longhand(LonghandId::MaskSize)],
                            [WebkitMaskSize, SetWebkitMaskSize,
                             PropertyId::Longhand(LonghandId::MaskSize)],
                                [_moz_context_properties, Set_moz_context_properties,
                                 PropertyId::Longhand(LonghandId::MozContextProperties)],
                            [MozContextProperties, SetMozContextProperties,
                             PropertyId::Longhand(LonghandId::MozContextProperties)],
                                [_moz_tab_size, Set_moz_tab_size,
                                 PropertyId::Longhand(LonghandId::MozTabSize)],
                            [MozTabSize, SetMozTabSize,
                             PropertyId::Longhand(LonghandId::MozTabSize)],
                                [Offset_path, SetOffset_path,
                                 PropertyId::Longhand(LonghandId::OffsetPath)],
                            [OffsetPath, SetOffsetPath,
                             PropertyId::Longhand(LonghandId::OffsetPath)],
                            [Perspective, SetPerspective,
                             PropertyId::Longhand(LonghandId::Perspective)],
                                [_moz_perspective, Set_moz_perspective,
                                 PropertyId::Longhand(LonghandId::Perspective)],
                            [MozPerspective, SetMozPerspective,
                             PropertyId::Longhand(LonghandId::Perspective)],
                                [_webkit_perspective, Set_webkit_perspective,
                                 PropertyId::Longhand(LonghandId::Perspective)],
                            [WebkitPerspective, SetWebkitPerspective,
                             PropertyId::Longhand(LonghandId::Perspective)],
                            [Quotes, SetQuotes,
                             PropertyId::Longhand(LonghandId::Quotes)],
                            [Rotate, SetRotate,
                             PropertyId::Longhand(LonghandId::Rotate)],
                            [Scale, SetScale,
                             PropertyId::Longhand(LonghandId::Scale)],
                                [Scroll_snap_coordinate, SetScroll_snap_coordinate,
                                 PropertyId::Longhand(LonghandId::ScrollSnapCoordinate)],
                            [ScrollSnapCoordinate, SetScrollSnapCoordinate,
                             PropertyId::Longhand(LonghandId::ScrollSnapCoordinate)],
                                [Shape_outside, SetShape_outside,
                                 PropertyId::Longhand(LonghandId::ShapeOutside)],
                            [ShapeOutside, SetShapeOutside,
                             PropertyId::Longhand(LonghandId::ShapeOutside)],
                                [Stroke_dasharray, SetStroke_dasharray,
                                 PropertyId::Longhand(LonghandId::StrokeDasharray)],
                            [StrokeDasharray, SetStrokeDasharray,
                             PropertyId::Longhand(LonghandId::StrokeDasharray)],
                                [Stroke_dashoffset, SetStroke_dashoffset,
                                 PropertyId::Longhand(LonghandId::StrokeDashoffset)],
                            [StrokeDashoffset, SetStrokeDashoffset,
                             PropertyId::Longhand(LonghandId::StrokeDashoffset)],
                                [Stroke_width, SetStroke_width,
                                 PropertyId::Longhand(LonghandId::StrokeWidth)],
                            [StrokeWidth, SetStrokeWidth,
                             PropertyId::Longhand(LonghandId::StrokeWidth)],
                                [Text_emphasis_style, SetText_emphasis_style,
                                 PropertyId::Longhand(LonghandId::TextEmphasisStyle)],
                            [TextEmphasisStyle, SetTextEmphasisStyle,
                             PropertyId::Longhand(LonghandId::TextEmphasisStyle)],
                                [Text_indent, SetText_indent,
                                 PropertyId::Longhand(LonghandId::TextIndent)],
                            [TextIndent, SetTextIndent,
                             PropertyId::Longhand(LonghandId::TextIndent)],
                                [Text_overflow, SetText_overflow,
                                 PropertyId::Longhand(LonghandId::TextOverflow)],
                            [TextOverflow, SetTextOverflow,
                             PropertyId::Longhand(LonghandId::TextOverflow)],
                                [Text_shadow, SetText_shadow,
                                 PropertyId::Longhand(LonghandId::TextShadow)],
                            [TextShadow, SetTextShadow,
                             PropertyId::Longhand(LonghandId::TextShadow)],
                                [Transition_delay, SetTransition_delay,
                                 PropertyId::Longhand(LonghandId::TransitionDelay)],
                            [TransitionDelay, SetTransitionDelay,
                             PropertyId::Longhand(LonghandId::TransitionDelay)],
                                [_moz_transition_delay, Set_moz_transition_delay,
                                 PropertyId::Longhand(LonghandId::TransitionDelay)],
                            [MozTransitionDelay, SetMozTransitionDelay,
                             PropertyId::Longhand(LonghandId::TransitionDelay)],
                                [_webkit_transition_delay, Set_webkit_transition_delay,
                                 PropertyId::Longhand(LonghandId::TransitionDelay)],
                            [WebkitTransitionDelay, SetWebkitTransitionDelay,
                             PropertyId::Longhand(LonghandId::TransitionDelay)],
                                [Transition_duration, SetTransition_duration,
                                 PropertyId::Longhand(LonghandId::TransitionDuration)],
                            [TransitionDuration, SetTransitionDuration,
                             PropertyId::Longhand(LonghandId::TransitionDuration)],
                                [_moz_transition_duration, Set_moz_transition_duration,
                                 PropertyId::Longhand(LonghandId::TransitionDuration)],
                            [MozTransitionDuration, SetMozTransitionDuration,
                             PropertyId::Longhand(LonghandId::TransitionDuration)],
                                [_webkit_transition_duration, Set_webkit_transition_duration,
                                 PropertyId::Longhand(LonghandId::TransitionDuration)],
                            [WebkitTransitionDuration, SetWebkitTransitionDuration,
                             PropertyId::Longhand(LonghandId::TransitionDuration)],
                                [Transition_property, SetTransition_property,
                                 PropertyId::Longhand(LonghandId::TransitionProperty)],
                            [TransitionProperty, SetTransitionProperty,
                             PropertyId::Longhand(LonghandId::TransitionProperty)],
                                [_moz_transition_property, Set_moz_transition_property,
                                 PropertyId::Longhand(LonghandId::TransitionProperty)],
                            [MozTransitionProperty, SetMozTransitionProperty,
                             PropertyId::Longhand(LonghandId::TransitionProperty)],
                                [_webkit_transition_property, Set_webkit_transition_property,
                                 PropertyId::Longhand(LonghandId::TransitionProperty)],
                            [WebkitTransitionProperty, SetWebkitTransitionProperty,
                             PropertyId::Longhand(LonghandId::TransitionProperty)],
                                [Transition_timing_function, SetTransition_timing_function,
                                 PropertyId::Longhand(LonghandId::TransitionTimingFunction)],
                            [TransitionTimingFunction, SetTransitionTimingFunction,
                             PropertyId::Longhand(LonghandId::TransitionTimingFunction)],
                                [_moz_transition_timing_function, Set_moz_transition_timing_function,
                                 PropertyId::Longhand(LonghandId::TransitionTimingFunction)],
                            [MozTransitionTimingFunction, SetMozTransitionTimingFunction,
                             PropertyId::Longhand(LonghandId::TransitionTimingFunction)],
                                [_webkit_transition_timing_function, Set_webkit_transition_timing_function,
                                 PropertyId::Longhand(LonghandId::TransitionTimingFunction)],
                            [WebkitTransitionTimingFunction, SetWebkitTransitionTimingFunction,
                             PropertyId::Longhand(LonghandId::TransitionTimingFunction)],
                            [Translate, SetTranslate,
                             PropertyId::Longhand(LonghandId::Translate)],
                                [Vertical_align, SetVertical_align,
                                 PropertyId::Longhand(LonghandId::VerticalAlign)],
                            [VerticalAlign, SetVerticalAlign,
                             PropertyId::Longhand(LonghandId::VerticalAlign)],
                                [Will_change, SetWill_change,
                                 PropertyId::Longhand(LonghandId::WillChange)],
                            [WillChange, SetWillChange,
                             PropertyId::Longhand(LonghandId::WillChange)],
                                [Word_spacing, SetWord_spacing,
                                 PropertyId::Longhand(LonghandId::WordSpacing)],
                            [WordSpacing, SetWordSpacing,
                             PropertyId::Longhand(LonghandId::WordSpacing)],
                            [Clip, SetClip,
                             PropertyId::Longhand(LonghandId::Clip)],
                                [_moz_image_region, Set_moz_image_region,
                                 PropertyId::Longhand(LonghandId::MozImageRegion)],
                            [MozImageRegion, SetMozImageRegion,
                             PropertyId::Longhand(LonghandId::MozImageRegion)],
                                [Grid_template_columns, SetGrid_template_columns,
                                 PropertyId::Longhand(LonghandId::GridTemplateColumns)],
                            [GridTemplateColumns, SetGridTemplateColumns,
                             PropertyId::Longhand(LonghandId::GridTemplateColumns)],
                                [Grid_template_rows, SetGrid_template_rows,
                                 PropertyId::Longhand(LonghandId::GridTemplateRows)],
                            [GridTemplateRows, SetGridTemplateRows,
                             PropertyId::Longhand(LonghandId::GridTemplateRows)],
                            [Fill, SetFill,
                             PropertyId::Longhand(LonghandId::Fill)],
                            [Stroke, SetStroke,
                             PropertyId::Longhand(LonghandId::Stroke)],
                                [Grid_auto_columns, SetGrid_auto_columns,
                                 PropertyId::Longhand(LonghandId::GridAutoColumns)],
                            [GridAutoColumns, SetGridAutoColumns,
                             PropertyId::Longhand(LonghandId::GridAutoColumns)],
                                [Grid_auto_rows, SetGrid_auto_rows,
                                 PropertyId::Longhand(LonghandId::GridAutoRows)],
                            [GridAutoRows, SetGridAutoRows,
                             PropertyId::Longhand(LonghandId::GridAutoRows)],
                                [Transform_origin, SetTransform_origin,
                                 PropertyId::Longhand(LonghandId::TransformOrigin)],
                            [TransformOrigin, SetTransformOrigin,
                             PropertyId::Longhand(LonghandId::TransformOrigin)],
                                [_moz_transform_origin, Set_moz_transform_origin,
                                 PropertyId::Longhand(LonghandId::TransformOrigin)],
                            [MozTransformOrigin, SetMozTransformOrigin,
                             PropertyId::Longhand(LonghandId::TransformOrigin)],
                                [_webkit_transform_origin, Set_webkit_transform_origin,
                                 PropertyId::Longhand(LonghandId::TransformOrigin)],
                            [WebkitTransformOrigin, SetWebkitTransformOrigin,
                             PropertyId::Longhand(LonghandId::TransformOrigin)],
                                [Counter_reset, SetCounter_reset,
                                 PropertyId::Longhand(LonghandId::CounterReset)],
                            [CounterReset, SetCounterReset,
                             PropertyId::Longhand(LonghandId::CounterReset)],
                                [Counter_set, SetCounter_set,
                                 PropertyId::Longhand(LonghandId::CounterSet)],
                            [CounterSet, SetCounterSet,
                             PropertyId::Longhand(LonghandId::CounterSet)],
                                [Scroll_snap_points_x, SetScroll_snap_points_x,
                                 PropertyId::Longhand(LonghandId::ScrollSnapPointsX)],
                            [ScrollSnapPointsX, SetScrollSnapPointsX,
                             PropertyId::Longhand(LonghandId::ScrollSnapPointsX)],
                                [Scroll_snap_points_y, SetScroll_snap_points_y,
                                 PropertyId::Longhand(LonghandId::ScrollSnapPointsY)],
                            [ScrollSnapPointsY, SetScrollSnapPointsY,
                             PropertyId::Longhand(LonghandId::ScrollSnapPointsY)],
                            [Transform, SetTransform,
                             PropertyId::Longhand(LonghandId::Transform)],
                                [_moz_transform, Set_moz_transform,
                                 PropertyId::Longhand(LonghandId::Transform)],
                            [MozTransform, SetMozTransform,
                             PropertyId::Longhand(LonghandId::Transform)],
                                [_webkit_transform, Set_webkit_transform,
                                 PropertyId::Longhand(LonghandId::Transform)],
                            [WebkitTransform, SetWebkitTransform,
                             PropertyId::Longhand(LonghandId::Transform)],
                                [Column_gap, SetColumn_gap,
                                 PropertyId::Longhand(LonghandId::ColumnGap)],
                            [ColumnGap, SetColumnGap,
                             PropertyId::Longhand(LonghandId::ColumnGap)],
                                [Grid_column_gap, SetGrid_column_gap,
                                 PropertyId::Longhand(LonghandId::ColumnGap)],
                            [GridColumnGap, SetGridColumnGap,
                             PropertyId::Longhand(LonghandId::ColumnGap)],
                                [_moz_column_gap, Set_moz_column_gap,
                                 PropertyId::Longhand(LonghandId::ColumnGap)],
                            [MozColumnGap, SetMozColumnGap,
                             PropertyId::Longhand(LonghandId::ColumnGap)],
                                [Row_gap, SetRow_gap,
                                 PropertyId::Longhand(LonghandId::RowGap)],
                            [RowGap, SetRowGap,
                             PropertyId::Longhand(LonghandId::RowGap)],
                                [Grid_row_gap, SetGrid_row_gap,
                                 PropertyId::Longhand(LonghandId::RowGap)],
                            [GridRowGap, SetGridRowGap,
                             PropertyId::Longhand(LonghandId::RowGap)],
                                [Object_position, SetObject_position,
                                 PropertyId::Longhand(LonghandId::ObjectPosition)],
                            [ObjectPosition, SetObjectPosition,
                             PropertyId::Longhand(LonghandId::ObjectPosition)],
                                [Perspective_origin, SetPerspective_origin,
                                 PropertyId::Longhand(LonghandId::PerspectiveOrigin)],
                            [PerspectiveOrigin, SetPerspectiveOrigin,
                             PropertyId::Longhand(LonghandId::PerspectiveOrigin)],
                                [_moz_perspective_origin, Set_moz_perspective_origin,
                                 PropertyId::Longhand(LonghandId::PerspectiveOrigin)],
                            [MozPerspectiveOrigin, SetMozPerspectiveOrigin,
                             PropertyId::Longhand(LonghandId::PerspectiveOrigin)],
                                [_webkit_perspective_origin, Set_webkit_perspective_origin,
                                 PropertyId::Longhand(LonghandId::PerspectiveOrigin)],
                            [WebkitPerspectiveOrigin, SetWebkitPerspectiveOrigin,
                             PropertyId::Longhand(LonghandId::PerspectiveOrigin)],
                                [Scroll_snap_destination, SetScroll_snap_destination,
                                 PropertyId::Longhand(LonghandId::ScrollSnapDestination)],
                            [ScrollSnapDestination, SetScrollSnapDestination,
                             PropertyId::Longhand(LonghandId::ScrollSnapDestination)],
                                [Grid_column_end, SetGrid_column_end,
                                 PropertyId::Longhand(LonghandId::GridColumnEnd)],
                            [GridColumnEnd, SetGridColumnEnd,
                             PropertyId::Longhand(LonghandId::GridColumnEnd)],
                                [Grid_column_start, SetGrid_column_start,
                                 PropertyId::Longhand(LonghandId::GridColumnStart)],
                            [GridColumnStart, SetGridColumnStart,
                             PropertyId::Longhand(LonghandId::GridColumnStart)],
                                [Grid_row_end, SetGrid_row_end,
                                 PropertyId::Longhand(LonghandId::GridRowEnd)],
                            [GridRowEnd, SetGridRowEnd,
                             PropertyId::Longhand(LonghandId::GridRowEnd)],
                                [Grid_row_start, SetGrid_row_start,
                                 PropertyId::Longhand(LonghandId::GridRowStart)],
                            [GridRowStart, SetGridRowStart,
                             PropertyId::Longhand(LonghandId::GridRowStart)],
                                [Max_block_size, SetMax_block_size,
                                 PropertyId::Longhand(LonghandId::MaxBlockSize)],
                            [MaxBlockSize, SetMaxBlockSize,
                             PropertyId::Longhand(LonghandId::MaxBlockSize)],
                                [Max_height, SetMax_height,
                                 PropertyId::Longhand(LonghandId::MaxHeight)],
                            [MaxHeight, SetMaxHeight,
                             PropertyId::Longhand(LonghandId::MaxHeight)],
                                [Max_inline_size, SetMax_inline_size,
                                 PropertyId::Longhand(LonghandId::MaxInlineSize)],
                            [MaxInlineSize, SetMaxInlineSize,
                             PropertyId::Longhand(LonghandId::MaxInlineSize)],
                                [Max_width, SetMax_width,
                                 PropertyId::Longhand(LonghandId::MaxWidth)],
                            [MaxWidth, SetMaxWidth,
                             PropertyId::Longhand(LonghandId::MaxWidth)],
                                [Marker_end, SetMarker_end,
                                 PropertyId::Longhand(LonghandId::MarkerEnd)],
                            [MarkerEnd, SetMarkerEnd,
                             PropertyId::Longhand(LonghandId::MarkerEnd)],
                                [Marker_mid, SetMarker_mid,
                                 PropertyId::Longhand(LonghandId::MarkerMid)],
                            [MarkerMid, SetMarkerMid,
                             PropertyId::Longhand(LonghandId::MarkerMid)],
                                [Marker_start, SetMarker_start,
                                 PropertyId::Longhand(LonghandId::MarkerStart)],
                            [MarkerStart, SetMarkerStart,
                             PropertyId::Longhand(LonghandId::MarkerStart)],
                                [Scroll_padding_block_end, SetScroll_padding_block_end,
                                 PropertyId::Longhand(LonghandId::ScrollPaddingBlockEnd)],
                            [ScrollPaddingBlockEnd, SetScrollPaddingBlockEnd,
                             PropertyId::Longhand(LonghandId::ScrollPaddingBlockEnd)],
                                [Scroll_padding_block_start, SetScroll_padding_block_start,
                                 PropertyId::Longhand(LonghandId::ScrollPaddingBlockStart)],
                            [ScrollPaddingBlockStart, SetScrollPaddingBlockStart,
                             PropertyId::Longhand(LonghandId::ScrollPaddingBlockStart)],
                                [Scroll_padding_bottom, SetScroll_padding_bottom,
                                 PropertyId::Longhand(LonghandId::ScrollPaddingBottom)],
                            [ScrollPaddingBottom, SetScrollPaddingBottom,
                             PropertyId::Longhand(LonghandId::ScrollPaddingBottom)],
                                [Scroll_padding_inline_end, SetScroll_padding_inline_end,
                                 PropertyId::Longhand(LonghandId::ScrollPaddingInlineEnd)],
                            [ScrollPaddingInlineEnd, SetScrollPaddingInlineEnd,
                             PropertyId::Longhand(LonghandId::ScrollPaddingInlineEnd)],
                                [Scroll_padding_inline_start, SetScroll_padding_inline_start,
                                 PropertyId::Longhand(LonghandId::ScrollPaddingInlineStart)],
                            [ScrollPaddingInlineStart, SetScrollPaddingInlineStart,
                             PropertyId::Longhand(LonghandId::ScrollPaddingInlineStart)],
                                [Scroll_padding_left, SetScroll_padding_left,
                                 PropertyId::Longhand(LonghandId::ScrollPaddingLeft)],
                            [ScrollPaddingLeft, SetScrollPaddingLeft,
                             PropertyId::Longhand(LonghandId::ScrollPaddingLeft)],
                                [Scroll_padding_right, SetScroll_padding_right,
                                 PropertyId::Longhand(LonghandId::ScrollPaddingRight)],
                            [ScrollPaddingRight, SetScrollPaddingRight,
                             PropertyId::Longhand(LonghandId::ScrollPaddingRight)],
                                [Scroll_padding_top, SetScroll_padding_top,
                                 PropertyId::Longhand(LonghandId::ScrollPaddingTop)],
                            [ScrollPaddingTop, SetScrollPaddingTop,
                             PropertyId::Longhand(LonghandId::ScrollPaddingTop)],
                                [Block_size, SetBlock_size,
                                 PropertyId::Longhand(LonghandId::BlockSize)],
                            [BlockSize, SetBlockSize,
                             PropertyId::Longhand(LonghandId::BlockSize)],
                            [Height, SetHeight,
                             PropertyId::Longhand(LonghandId::Height)],
                                [Inline_size, SetInline_size,
                                 PropertyId::Longhand(LonghandId::InlineSize)],
                            [InlineSize, SetInlineSize,
                             PropertyId::Longhand(LonghandId::InlineSize)],
                                [Min_block_size, SetMin_block_size,
                                 PropertyId::Longhand(LonghandId::MinBlockSize)],
                            [MinBlockSize, SetMinBlockSize,
                             PropertyId::Longhand(LonghandId::MinBlockSize)],
                                [Min_height, SetMin_height,
                                 PropertyId::Longhand(LonghandId::MinHeight)],
                            [MinHeight, SetMinHeight,
                             PropertyId::Longhand(LonghandId::MinHeight)],
                                [Min_inline_size, SetMin_inline_size,
                                 PropertyId::Longhand(LonghandId::MinInlineSize)],
                            [MinInlineSize, SetMinInlineSize,
                             PropertyId::Longhand(LonghandId::MinInlineSize)],
                                [Min_width, SetMin_width,
                                 PropertyId::Longhand(LonghandId::MinWidth)],
                            [MinWidth, SetMinWidth,
                             PropertyId::Longhand(LonghandId::MinWidth)],
                            [Width, SetWidth,
                             PropertyId::Longhand(LonghandId::Width)],
                                [Outline_offset, SetOutline_offset,
                                 PropertyId::Longhand(LonghandId::OutlineOffset)],
                            [OutlineOffset, SetOutlineOffset,
                             PropertyId::Longhand(LonghandId::OutlineOffset)],
                                [Scroll_margin_block_end, SetScroll_margin_block_end,
                                 PropertyId::Longhand(LonghandId::ScrollMarginBlockEnd)],
                            [ScrollMarginBlockEnd, SetScrollMarginBlockEnd,
                             PropertyId::Longhand(LonghandId::ScrollMarginBlockEnd)],
                                [Scroll_margin_block_start, SetScroll_margin_block_start,
                                 PropertyId::Longhand(LonghandId::ScrollMarginBlockStart)],
                            [ScrollMarginBlockStart, SetScrollMarginBlockStart,
                             PropertyId::Longhand(LonghandId::ScrollMarginBlockStart)],
                                [Scroll_margin_bottom, SetScroll_margin_bottom,
                                 PropertyId::Longhand(LonghandId::ScrollMarginBottom)],
                            [ScrollMarginBottom, SetScrollMarginBottom,
                             PropertyId::Longhand(LonghandId::ScrollMarginBottom)],
                                [Scroll_margin_inline_end, SetScroll_margin_inline_end,
                                 PropertyId::Longhand(LonghandId::ScrollMarginInlineEnd)],
                            [ScrollMarginInlineEnd, SetScrollMarginInlineEnd,
                             PropertyId::Longhand(LonghandId::ScrollMarginInlineEnd)],
                                [Scroll_margin_inline_start, SetScroll_margin_inline_start,
                                 PropertyId::Longhand(LonghandId::ScrollMarginInlineStart)],
                            [ScrollMarginInlineStart, SetScrollMarginInlineStart,
                             PropertyId::Longhand(LonghandId::ScrollMarginInlineStart)],
                                [Scroll_margin_left, SetScroll_margin_left,
                                 PropertyId::Longhand(LonghandId::ScrollMarginLeft)],
                            [ScrollMarginLeft, SetScrollMarginLeft,
                             PropertyId::Longhand(LonghandId::ScrollMarginLeft)],
                                [Scroll_margin_right, SetScroll_margin_right,
                                 PropertyId::Longhand(LonghandId::ScrollMarginRight)],
                            [ScrollMarginRight, SetScrollMarginRight,
                             PropertyId::Longhand(LonghandId::ScrollMarginRight)],
                                [Scroll_margin_top, SetScroll_margin_top,
                                 PropertyId::Longhand(LonghandId::ScrollMarginTop)],
                            [ScrollMarginTop, SetScrollMarginTop,
                             PropertyId::Longhand(LonghandId::ScrollMarginTop)],
                                [Padding_block_end, SetPadding_block_end,
                                 PropertyId::Longhand(LonghandId::PaddingBlockEnd)],
                            [PaddingBlockEnd, SetPaddingBlockEnd,
                             PropertyId::Longhand(LonghandId::PaddingBlockEnd)],
                                [Padding_block_start, SetPadding_block_start,
                                 PropertyId::Longhand(LonghandId::PaddingBlockStart)],
                            [PaddingBlockStart, SetPaddingBlockStart,
                             PropertyId::Longhand(LonghandId::PaddingBlockStart)],
                                [Padding_bottom, SetPadding_bottom,
                                 PropertyId::Longhand(LonghandId::PaddingBottom)],
                            [PaddingBottom, SetPaddingBottom,
                             PropertyId::Longhand(LonghandId::PaddingBottom)],
                                [Padding_inline_end, SetPadding_inline_end,
                                 PropertyId::Longhand(LonghandId::PaddingInlineEnd)],
                            [PaddingInlineEnd, SetPaddingInlineEnd,
                             PropertyId::Longhand(LonghandId::PaddingInlineEnd)],
                                [_moz_padding_end, Set_moz_padding_end,
                                 PropertyId::Longhand(LonghandId::PaddingInlineEnd)],
                            [MozPaddingEnd, SetMozPaddingEnd,
                             PropertyId::Longhand(LonghandId::PaddingInlineEnd)],
                                [Padding_inline_start, SetPadding_inline_start,
                                 PropertyId::Longhand(LonghandId::PaddingInlineStart)],
                            [PaddingInlineStart, SetPaddingInlineStart,
                             PropertyId::Longhand(LonghandId::PaddingInlineStart)],
                                [_moz_padding_start, Set_moz_padding_start,
                                 PropertyId::Longhand(LonghandId::PaddingInlineStart)],
                            [MozPaddingStart, SetMozPaddingStart,
                             PropertyId::Longhand(LonghandId::PaddingInlineStart)],
                                [Padding_left, SetPadding_left,
                                 PropertyId::Longhand(LonghandId::PaddingLeft)],
                            [PaddingLeft, SetPaddingLeft,
                             PropertyId::Longhand(LonghandId::PaddingLeft)],
                                [Padding_right, SetPadding_right,
                                 PropertyId::Longhand(LonghandId::PaddingRight)],
                            [PaddingRight, SetPaddingRight,
                             PropertyId::Longhand(LonghandId::PaddingRight)],
                                [Padding_top, SetPadding_top,
                                 PropertyId::Longhand(LonghandId::PaddingTop)],
                            [PaddingTop, SetPaddingTop,
                             PropertyId::Longhand(LonghandId::PaddingTop)],
                                [Shape_margin, SetShape_margin,
                                 PropertyId::Longhand(LonghandId::ShapeMargin)],
                            [ShapeMargin, SetShapeMargin,
                             PropertyId::Longhand(LonghandId::ShapeMargin)],
                                [Border_block_end_width, SetBorder_block_end_width,
                                 PropertyId::Longhand(LonghandId::BorderBlockEndWidth)],
                            [BorderBlockEndWidth, SetBorderBlockEndWidth,
                             PropertyId::Longhand(LonghandId::BorderBlockEndWidth)],
                                [Border_block_start_width, SetBorder_block_start_width,
                                 PropertyId::Longhand(LonghandId::BorderBlockStartWidth)],
                            [BorderBlockStartWidth, SetBorderBlockStartWidth,
                             PropertyId::Longhand(LonghandId::BorderBlockStartWidth)],
                                [Border_bottom_width, SetBorder_bottom_width,
                                 PropertyId::Longhand(LonghandId::BorderBottomWidth)],
                            [BorderBottomWidth, SetBorderBottomWidth,
                             PropertyId::Longhand(LonghandId::BorderBottomWidth)],
                                [Border_inline_end_width, SetBorder_inline_end_width,
                                 PropertyId::Longhand(LonghandId::BorderInlineEndWidth)],
                            [BorderInlineEndWidth, SetBorderInlineEndWidth,
                             PropertyId::Longhand(LonghandId::BorderInlineEndWidth)],
                                [_moz_border_end_width, Set_moz_border_end_width,
                                 PropertyId::Longhand(LonghandId::BorderInlineEndWidth)],
                            [MozBorderEndWidth, SetMozBorderEndWidth,
                             PropertyId::Longhand(LonghandId::BorderInlineEndWidth)],
                                [Border_inline_start_width, SetBorder_inline_start_width,
                                 PropertyId::Longhand(LonghandId::BorderInlineStartWidth)],
                            [BorderInlineStartWidth, SetBorderInlineStartWidth,
                             PropertyId::Longhand(LonghandId::BorderInlineStartWidth)],
                                [_moz_border_start_width, Set_moz_border_start_width,
                                 PropertyId::Longhand(LonghandId::BorderInlineStartWidth)],
                            [MozBorderStartWidth, SetMozBorderStartWidth,
                             PropertyId::Longhand(LonghandId::BorderInlineStartWidth)],
                                [Border_left_width, SetBorder_left_width,
                                 PropertyId::Longhand(LonghandId::BorderLeftWidth)],
                            [BorderLeftWidth, SetBorderLeftWidth,
                             PropertyId::Longhand(LonghandId::BorderLeftWidth)],
                                [Border_right_width, SetBorder_right_width,
                                 PropertyId::Longhand(LonghandId::BorderRightWidth)],
                            [BorderRightWidth, SetBorderRightWidth,
                             PropertyId::Longhand(LonghandId::BorderRightWidth)],
                                [Border_top_width, SetBorder_top_width,
                                 PropertyId::Longhand(LonghandId::BorderTopWidth)],
                            [BorderTopWidth, SetBorderTopWidth,
                             PropertyId::Longhand(LonghandId::BorderTopWidth)],
                                [Column_rule_width, SetColumn_rule_width,
                                 PropertyId::Longhand(LonghandId::ColumnRuleWidth)],
                            [ColumnRuleWidth, SetColumnRuleWidth,
                             PropertyId::Longhand(LonghandId::ColumnRuleWidth)],
                                [_moz_column_rule_width, Set_moz_column_rule_width,
                                 PropertyId::Longhand(LonghandId::ColumnRuleWidth)],
                            [MozColumnRuleWidth, SetMozColumnRuleWidth,
                             PropertyId::Longhand(LonghandId::ColumnRuleWidth)],
                                [Outline_width, SetOutline_width,
                                 PropertyId::Longhand(LonghandId::OutlineWidth)],
                            [OutlineWidth, SetOutlineWidth,
                             PropertyId::Longhand(LonghandId::OutlineWidth)],
                                [_webkit_text_stroke_width, Set_webkit_text_stroke_width,
                                 PropertyId::Longhand(LonghandId::WebkitTextStrokeWidth)],
                            [WebkitTextStrokeWidth, SetWebkitTextStrokeWidth,
                             PropertyId::Longhand(LonghandId::WebkitTextStrokeWidth)],
                                [Border_bottom_left_radius, SetBorder_bottom_left_radius,
                                 PropertyId::Longhand(LonghandId::BorderBottomLeftRadius)],
                            [BorderBottomLeftRadius, SetBorderBottomLeftRadius,
                             PropertyId::Longhand(LonghandId::BorderBottomLeftRadius)],
                                [_webkit_border_bottom_left_radius, Set_webkit_border_bottom_left_radius,
                                 PropertyId::Longhand(LonghandId::BorderBottomLeftRadius)],
                            [WebkitBorderBottomLeftRadius, SetWebkitBorderBottomLeftRadius,
                             PropertyId::Longhand(LonghandId::BorderBottomLeftRadius)],
                                [Border_bottom_right_radius, SetBorder_bottom_right_radius,
                                 PropertyId::Longhand(LonghandId::BorderBottomRightRadius)],
                            [BorderBottomRightRadius, SetBorderBottomRightRadius,
                             PropertyId::Longhand(LonghandId::BorderBottomRightRadius)],
                                [_webkit_border_bottom_right_radius, Set_webkit_border_bottom_right_radius,
                                 PropertyId::Longhand(LonghandId::BorderBottomRightRadius)],
                            [WebkitBorderBottomRightRadius, SetWebkitBorderBottomRightRadius,
                             PropertyId::Longhand(LonghandId::BorderBottomRightRadius)],
                                [Border_end_end_radius, SetBorder_end_end_radius,
                                 PropertyId::Longhand(LonghandId::BorderEndEndRadius)],
                            [BorderEndEndRadius, SetBorderEndEndRadius,
                             PropertyId::Longhand(LonghandId::BorderEndEndRadius)],
                                [Border_end_start_radius, SetBorder_end_start_radius,
                                 PropertyId::Longhand(LonghandId::BorderEndStartRadius)],
                            [BorderEndStartRadius, SetBorderEndStartRadius,
                             PropertyId::Longhand(LonghandId::BorderEndStartRadius)],
                                [Border_start_end_radius, SetBorder_start_end_radius,
                                 PropertyId::Longhand(LonghandId::BorderStartEndRadius)],
                            [BorderStartEndRadius, SetBorderStartEndRadius,
                             PropertyId::Longhand(LonghandId::BorderStartEndRadius)],
                                [Border_start_start_radius, SetBorder_start_start_radius,
                                 PropertyId::Longhand(LonghandId::BorderStartStartRadius)],
                            [BorderStartStartRadius, SetBorderStartStartRadius,
                             PropertyId::Longhand(LonghandId::BorderStartStartRadius)],
                                [Border_top_left_radius, SetBorder_top_left_radius,
                                 PropertyId::Longhand(LonghandId::BorderTopLeftRadius)],
                            [BorderTopLeftRadius, SetBorderTopLeftRadius,
                             PropertyId::Longhand(LonghandId::BorderTopLeftRadius)],
                                [_webkit_border_top_left_radius, Set_webkit_border_top_left_radius,
                                 PropertyId::Longhand(LonghandId::BorderTopLeftRadius)],
                            [WebkitBorderTopLeftRadius, SetWebkitBorderTopLeftRadius,
                             PropertyId::Longhand(LonghandId::BorderTopLeftRadius)],
                                [Border_top_right_radius, SetBorder_top_right_radius,
                                 PropertyId::Longhand(LonghandId::BorderTopRightRadius)],
                            [BorderTopRightRadius, SetBorderTopRightRadius,
                             PropertyId::Longhand(LonghandId::BorderTopRightRadius)],
                                [_webkit_border_top_right_radius, Set_webkit_border_top_right_radius,
                                 PropertyId::Longhand(LonghandId::BorderTopRightRadius)],
                            [WebkitBorderTopRightRadius, SetWebkitBorderTopRightRadius,
                             PropertyId::Longhand(LonghandId::BorderTopRightRadius)],
                                [_moz_outline_radius_bottomleft, Set_moz_outline_radius_bottomleft,
                                 PropertyId::Longhand(LonghandId::MozOutlineRadiusBottomleft)],
                            [MozOutlineRadiusBottomleft, SetMozOutlineRadiusBottomleft,
                             PropertyId::Longhand(LonghandId::MozOutlineRadiusBottomleft)],
                                [_moz_outline_radius_bottomright, Set_moz_outline_radius_bottomright,
                                 PropertyId::Longhand(LonghandId::MozOutlineRadiusBottomright)],
                            [MozOutlineRadiusBottomright, SetMozOutlineRadiusBottomright,
                             PropertyId::Longhand(LonghandId::MozOutlineRadiusBottomright)],
                                [_moz_outline_radius_topleft, Set_moz_outline_radius_topleft,
                                 PropertyId::Longhand(LonghandId::MozOutlineRadiusTopleft)],
                            [MozOutlineRadiusTopleft, SetMozOutlineRadiusTopleft,
                             PropertyId::Longhand(LonghandId::MozOutlineRadiusTopleft)],
                                [_moz_outline_radius_topright, Set_moz_outline_radius_topright,
                                 PropertyId::Longhand(LonghandId::MozOutlineRadiusTopright)],
                            [MozOutlineRadiusTopright, SetMozOutlineRadiusTopright,
                             PropertyId::Longhand(LonghandId::MozOutlineRadiusTopright)],
                            [Bottom, SetBottom,
                             PropertyId::Longhand(LonghandId::Bottom)],
                                [Inset_block_end, SetInset_block_end,
                                 PropertyId::Longhand(LonghandId::InsetBlockEnd)],
                            [InsetBlockEnd, SetInsetBlockEnd,
                             PropertyId::Longhand(LonghandId::InsetBlockEnd)],
                                [Offset_block_end, SetOffset_block_end,
                                 PropertyId::Longhand(LonghandId::InsetBlockEnd)],
                            [OffsetBlockEnd, SetOffsetBlockEnd,
                             PropertyId::Longhand(LonghandId::InsetBlockEnd)],
                                [Inset_block_start, SetInset_block_start,
                                 PropertyId::Longhand(LonghandId::InsetBlockStart)],
                            [InsetBlockStart, SetInsetBlockStart,
                             PropertyId::Longhand(LonghandId::InsetBlockStart)],
                                [Offset_block_start, SetOffset_block_start,
                                 PropertyId::Longhand(LonghandId::InsetBlockStart)],
                            [OffsetBlockStart, SetOffsetBlockStart,
                             PropertyId::Longhand(LonghandId::InsetBlockStart)],
                                [Inset_inline_end, SetInset_inline_end,
                                 PropertyId::Longhand(LonghandId::InsetInlineEnd)],
                            [InsetInlineEnd, SetInsetInlineEnd,
                             PropertyId::Longhand(LonghandId::InsetInlineEnd)],
                                [Offset_inline_end, SetOffset_inline_end,
                                 PropertyId::Longhand(LonghandId::InsetInlineEnd)],
                            [OffsetInlineEnd, SetOffsetInlineEnd,
                             PropertyId::Longhand(LonghandId::InsetInlineEnd)],
                                [Inset_inline_start, SetInset_inline_start,
                                 PropertyId::Longhand(LonghandId::InsetInlineStart)],
                            [InsetInlineStart, SetInsetInlineStart,
                             PropertyId::Longhand(LonghandId::InsetInlineStart)],
                                [Offset_inline_start, SetOffset_inline_start,
                                 PropertyId::Longhand(LonghandId::InsetInlineStart)],
                            [OffsetInlineStart, SetOffsetInlineStart,
                             PropertyId::Longhand(LonghandId::InsetInlineStart)],
                            [Left, SetLeft,
                             PropertyId::Longhand(LonghandId::Left)],
                                [Margin_block_end, SetMargin_block_end,
                                 PropertyId::Longhand(LonghandId::MarginBlockEnd)],
                            [MarginBlockEnd, SetMarginBlockEnd,
                             PropertyId::Longhand(LonghandId::MarginBlockEnd)],
                                [Margin_block_start, SetMargin_block_start,
                                 PropertyId::Longhand(LonghandId::MarginBlockStart)],
                            [MarginBlockStart, SetMarginBlockStart,
                             PropertyId::Longhand(LonghandId::MarginBlockStart)],
                                [Margin_bottom, SetMargin_bottom,
                                 PropertyId::Longhand(LonghandId::MarginBottom)],
                            [MarginBottom, SetMarginBottom,
                             PropertyId::Longhand(LonghandId::MarginBottom)],
                                [Margin_inline_end, SetMargin_inline_end,
                                 PropertyId::Longhand(LonghandId::MarginInlineEnd)],
                            [MarginInlineEnd, SetMarginInlineEnd,
                             PropertyId::Longhand(LonghandId::MarginInlineEnd)],
                                [_moz_margin_end, Set_moz_margin_end,
                                 PropertyId::Longhand(LonghandId::MarginInlineEnd)],
                            [MozMarginEnd, SetMozMarginEnd,
                             PropertyId::Longhand(LonghandId::MarginInlineEnd)],
                                [Margin_inline_start, SetMargin_inline_start,
                                 PropertyId::Longhand(LonghandId::MarginInlineStart)],
                            [MarginInlineStart, SetMarginInlineStart,
                             PropertyId::Longhand(LonghandId::MarginInlineStart)],
                                [_moz_margin_start, Set_moz_margin_start,
                                 PropertyId::Longhand(LonghandId::MarginInlineStart)],
                            [MozMarginStart, SetMozMarginStart,
                             PropertyId::Longhand(LonghandId::MarginInlineStart)],
                                [Margin_left, SetMargin_left,
                                 PropertyId::Longhand(LonghandId::MarginLeft)],
                            [MarginLeft, SetMarginLeft,
                             PropertyId::Longhand(LonghandId::MarginLeft)],
                                [Margin_right, SetMargin_right,
                                 PropertyId::Longhand(LonghandId::MarginRight)],
                            [MarginRight, SetMarginRight,
                             PropertyId::Longhand(LonghandId::MarginRight)],
                                [Margin_top, SetMargin_top,
                                 PropertyId::Longhand(LonghandId::MarginTop)],
                            [MarginTop, SetMarginTop,
                             PropertyId::Longhand(LonghandId::MarginTop)],
                            [Right, SetRight,
                             PropertyId::Longhand(LonghandId::Right)],
                            [Top, SetTop,
                             PropertyId::Longhand(LonghandId::Top)],
                                [Background_color, SetBackground_color,
                                 PropertyId::Longhand(LonghandId::BackgroundColor)],
                            [BackgroundColor, SetBackgroundColor,
                             PropertyId::Longhand(LonghandId::BackgroundColor)],
                                [Border_block_end_color, SetBorder_block_end_color,
                                 PropertyId::Longhand(LonghandId::BorderBlockEndColor)],
                            [BorderBlockEndColor, SetBorderBlockEndColor,
                             PropertyId::Longhand(LonghandId::BorderBlockEndColor)],
                                [Border_block_start_color, SetBorder_block_start_color,
                                 PropertyId::Longhand(LonghandId::BorderBlockStartColor)],
                            [BorderBlockStartColor, SetBorderBlockStartColor,
                             PropertyId::Longhand(LonghandId::BorderBlockStartColor)],
                                [Border_bottom_color, SetBorder_bottom_color,
                                 PropertyId::Longhand(LonghandId::BorderBottomColor)],
                            [BorderBottomColor, SetBorderBottomColor,
                             PropertyId::Longhand(LonghandId::BorderBottomColor)],
                                [Border_inline_end_color, SetBorder_inline_end_color,
                                 PropertyId::Longhand(LonghandId::BorderInlineEndColor)],
                            [BorderInlineEndColor, SetBorderInlineEndColor,
                             PropertyId::Longhand(LonghandId::BorderInlineEndColor)],
                                [_moz_border_end_color, Set_moz_border_end_color,
                                 PropertyId::Longhand(LonghandId::BorderInlineEndColor)],
                            [MozBorderEndColor, SetMozBorderEndColor,
                             PropertyId::Longhand(LonghandId::BorderInlineEndColor)],
                                [Border_inline_start_color, SetBorder_inline_start_color,
                                 PropertyId::Longhand(LonghandId::BorderInlineStartColor)],
                            [BorderInlineStartColor, SetBorderInlineStartColor,
                             PropertyId::Longhand(LonghandId::BorderInlineStartColor)],
                                [_moz_border_start_color, Set_moz_border_start_color,
                                 PropertyId::Longhand(LonghandId::BorderInlineStartColor)],
                            [MozBorderStartColor, SetMozBorderStartColor,
                             PropertyId::Longhand(LonghandId::BorderInlineStartColor)],
                                [Border_left_color, SetBorder_left_color,
                                 PropertyId::Longhand(LonghandId::BorderLeftColor)],
                            [BorderLeftColor, SetBorderLeftColor,
                             PropertyId::Longhand(LonghandId::BorderLeftColor)],
                                [Border_right_color, SetBorder_right_color,
                                 PropertyId::Longhand(LonghandId::BorderRightColor)],
                            [BorderRightColor, SetBorderRightColor,
                             PropertyId::Longhand(LonghandId::BorderRightColor)],
                                [Border_top_color, SetBorder_top_color,
                                 PropertyId::Longhand(LonghandId::BorderTopColor)],
                            [BorderTopColor, SetBorderTopColor,
                             PropertyId::Longhand(LonghandId::BorderTopColor)],
                                [Column_rule_color, SetColumn_rule_color,
                                 PropertyId::Longhand(LonghandId::ColumnRuleColor)],
                            [ColumnRuleColor, SetColumnRuleColor,
                             PropertyId::Longhand(LonghandId::ColumnRuleColor)],
                                [_moz_column_rule_color, Set_moz_column_rule_color,
                                 PropertyId::Longhand(LonghandId::ColumnRuleColor)],
                            [MozColumnRuleColor, SetMozColumnRuleColor,
                             PropertyId::Longhand(LonghandId::ColumnRuleColor)],
                                [Flood_color, SetFlood_color,
                                 PropertyId::Longhand(LonghandId::FloodColor)],
                            [FloodColor, SetFloodColor,
                             PropertyId::Longhand(LonghandId::FloodColor)],
                                [Lighting_color, SetLighting_color,
                                 PropertyId::Longhand(LonghandId::LightingColor)],
                            [LightingColor, SetLightingColor,
                             PropertyId::Longhand(LonghandId::LightingColor)],
                                [Outline_color, SetOutline_color,
                                 PropertyId::Longhand(LonghandId::OutlineColor)],
                            [OutlineColor, SetOutlineColor,
                             PropertyId::Longhand(LonghandId::OutlineColor)],
                                [Stop_color, SetStop_color,
                                 PropertyId::Longhand(LonghandId::StopColor)],
                            [StopColor, SetStopColor,
                             PropertyId::Longhand(LonghandId::StopColor)],
                                [Text_decoration_color, SetText_decoration_color,
                                 PropertyId::Longhand(LonghandId::TextDecorationColor)],
                            [TextDecorationColor, SetTextDecorationColor,
                             PropertyId::Longhand(LonghandId::TextDecorationColor)],
                                [Text_emphasis_color, SetText_emphasis_color,
                                 PropertyId::Longhand(LonghandId::TextEmphasisColor)],
                            [TextEmphasisColor, SetTextEmphasisColor,
                             PropertyId::Longhand(LonghandId::TextEmphasisColor)],
                                [_webkit_text_fill_color, Set_webkit_text_fill_color,
                                 PropertyId::Longhand(LonghandId::WebkitTextFillColor)],
                            [WebkitTextFillColor, SetWebkitTextFillColor,
                             PropertyId::Longhand(LonghandId::WebkitTextFillColor)],
                                [_webkit_text_stroke_color, Set_webkit_text_stroke_color,
                                 PropertyId::Longhand(LonghandId::WebkitTextStrokeColor)],
                            [WebkitTextStrokeColor, SetWebkitTextStrokeColor,
                             PropertyId::Longhand(LonghandId::WebkitTextStrokeColor)],
                            [Background, SetBackground,
                             PropertyId::Shorthand(ShorthandId::Background)],
                                [Background_position, SetBackground_position,
                                 PropertyId::Shorthand(ShorthandId::BackgroundPosition)],
                            [BackgroundPosition, SetBackgroundPosition,
                             PropertyId::Shorthand(ShorthandId::BackgroundPosition)],
                                [Border_color, SetBorder_color,
                                 PropertyId::Shorthand(ShorthandId::BorderColor)],
                            [BorderColor, SetBorderColor,
                             PropertyId::Shorthand(ShorthandId::BorderColor)],
                                [Border_style, SetBorder_style,
                                 PropertyId::Shorthand(ShorthandId::BorderStyle)],
                            [BorderStyle, SetBorderStyle,
                             PropertyId::Shorthand(ShorthandId::BorderStyle)],
                                [Border_width, SetBorder_width,
                                 PropertyId::Shorthand(ShorthandId::BorderWidth)],
                            [BorderWidth, SetBorderWidth,
                             PropertyId::Shorthand(ShorthandId::BorderWidth)],
                                [Border_top, SetBorder_top,
                                 PropertyId::Shorthand(ShorthandId::BorderTop)],
                            [BorderTop, SetBorderTop,
                             PropertyId::Shorthand(ShorthandId::BorderTop)],
                                [Border_right, SetBorder_right,
                                 PropertyId::Shorthand(ShorthandId::BorderRight)],
                            [BorderRight, SetBorderRight,
                             PropertyId::Shorthand(ShorthandId::BorderRight)],
                                [Border_bottom, SetBorder_bottom,
                                 PropertyId::Shorthand(ShorthandId::BorderBottom)],
                            [BorderBottom, SetBorderBottom,
                             PropertyId::Shorthand(ShorthandId::BorderBottom)],
                                [Border_left, SetBorder_left,
                                 PropertyId::Shorthand(ShorthandId::BorderLeft)],
                            [BorderLeft, SetBorderLeft,
                             PropertyId::Shorthand(ShorthandId::BorderLeft)],
                                [Border_block_start, SetBorder_block_start,
                                 PropertyId::Shorthand(ShorthandId::BorderBlockStart)],
                            [BorderBlockStart, SetBorderBlockStart,
                             PropertyId::Shorthand(ShorthandId::BorderBlockStart)],
                                [Border_block_end, SetBorder_block_end,
                                 PropertyId::Shorthand(ShorthandId::BorderBlockEnd)],
                            [BorderBlockEnd, SetBorderBlockEnd,
                             PropertyId::Shorthand(ShorthandId::BorderBlockEnd)],
                                [Border_inline_start, SetBorder_inline_start,
                                 PropertyId::Shorthand(ShorthandId::BorderInlineStart)],
                            [BorderInlineStart, SetBorderInlineStart,
                             PropertyId::Shorthand(ShorthandId::BorderInlineStart)],
                                [_moz_border_start, Set_moz_border_start,
                                 PropertyId::Shorthand(ShorthandId::BorderInlineStart)],
                            [MozBorderStart, SetMozBorderStart,
                             PropertyId::Shorthand(ShorthandId::BorderInlineStart)],
                                [Border_inline_end, SetBorder_inline_end,
                                 PropertyId::Shorthand(ShorthandId::BorderInlineEnd)],
                            [BorderInlineEnd, SetBorderInlineEnd,
                             PropertyId::Shorthand(ShorthandId::BorderInlineEnd)],
                                [_moz_border_end, Set_moz_border_end,
                                 PropertyId::Shorthand(ShorthandId::BorderInlineEnd)],
                            [MozBorderEnd, SetMozBorderEnd,
                             PropertyId::Shorthand(ShorthandId::BorderInlineEnd)],
                            [Border, SetBorder,
                             PropertyId::Shorthand(ShorthandId::Border)],
                                [Border_radius, SetBorder_radius,
                                 PropertyId::Shorthand(ShorthandId::BorderRadius)],
                            [BorderRadius, SetBorderRadius,
                             PropertyId::Shorthand(ShorthandId::BorderRadius)],
                                [_webkit_border_radius, Set_webkit_border_radius,
                                 PropertyId::Shorthand(ShorthandId::BorderRadius)],
                            [WebkitBorderRadius, SetWebkitBorderRadius,
                             PropertyId::Shorthand(ShorthandId::BorderRadius)],
                                [Border_image, SetBorder_image,
                                 PropertyId::Shorthand(ShorthandId::BorderImage)],
                            [BorderImage, SetBorderImage,
                             PropertyId::Shorthand(ShorthandId::BorderImage)],
                                [_moz_border_image, Set_moz_border_image,
                                 PropertyId::Shorthand(ShorthandId::BorderImage)],
                            [MozBorderImage, SetMozBorderImage,
                             PropertyId::Shorthand(ShorthandId::BorderImage)],
                                [_webkit_border_image, Set_webkit_border_image,
                                 PropertyId::Shorthand(ShorthandId::BorderImage)],
                            [WebkitBorderImage, SetWebkitBorderImage,
                             PropertyId::Shorthand(ShorthandId::BorderImage)],
                                [Border_block_width, SetBorder_block_width,
                                 PropertyId::Shorthand(ShorthandId::BorderBlockWidth)],
                            [BorderBlockWidth, SetBorderBlockWidth,
                             PropertyId::Shorthand(ShorthandId::BorderBlockWidth)],
                                [Border_block_style, SetBorder_block_style,
                                 PropertyId::Shorthand(ShorthandId::BorderBlockStyle)],
                            [BorderBlockStyle, SetBorderBlockStyle,
                             PropertyId::Shorthand(ShorthandId::BorderBlockStyle)],
                                [Border_block_color, SetBorder_block_color,
                                 PropertyId::Shorthand(ShorthandId::BorderBlockColor)],
                            [BorderBlockColor, SetBorderBlockColor,
                             PropertyId::Shorthand(ShorthandId::BorderBlockColor)],
                                [Border_inline_width, SetBorder_inline_width,
                                 PropertyId::Shorthand(ShorthandId::BorderInlineWidth)],
                            [BorderInlineWidth, SetBorderInlineWidth,
                             PropertyId::Shorthand(ShorthandId::BorderInlineWidth)],
                                [Border_inline_style, SetBorder_inline_style,
                                 PropertyId::Shorthand(ShorthandId::BorderInlineStyle)],
                            [BorderInlineStyle, SetBorderInlineStyle,
                             PropertyId::Shorthand(ShorthandId::BorderInlineStyle)],
                                [Border_inline_color, SetBorder_inline_color,
                                 PropertyId::Shorthand(ShorthandId::BorderInlineColor)],
                            [BorderInlineColor, SetBorderInlineColor,
                             PropertyId::Shorthand(ShorthandId::BorderInlineColor)],
                                [Border_block, SetBorder_block,
                                 PropertyId::Shorthand(ShorthandId::BorderBlock)],
                            [BorderBlock, SetBorderBlock,
                             PropertyId::Shorthand(ShorthandId::BorderBlock)],
                                [Border_inline, SetBorder_inline,
                                 PropertyId::Shorthand(ShorthandId::BorderInline)],
                            [BorderInline, SetBorderInline,
                             PropertyId::Shorthand(ShorthandId::BorderInline)],
                            [Overflow, SetOverflow,
                             PropertyId::Shorthand(ShorthandId::Overflow)],
                            [Transition, SetTransition,
                             PropertyId::Shorthand(ShorthandId::Transition)],
                                [_moz_transition, Set_moz_transition,
                                 PropertyId::Shorthand(ShorthandId::Transition)],
                            [MozTransition, SetMozTransition,
                             PropertyId::Shorthand(ShorthandId::Transition)],
                                [_webkit_transition, Set_webkit_transition,
                                 PropertyId::Shorthand(ShorthandId::Transition)],
                            [WebkitTransition, SetWebkitTransition,
                             PropertyId::Shorthand(ShorthandId::Transition)],
                            [Animation, SetAnimation,
                             PropertyId::Shorthand(ShorthandId::Animation)],
                                [_moz_animation, Set_moz_animation,
                                 PropertyId::Shorthand(ShorthandId::Animation)],
                            [MozAnimation, SetMozAnimation,
                             PropertyId::Shorthand(ShorthandId::Animation)],
                                [_webkit_animation, Set_webkit_animation,
                                 PropertyId::Shorthand(ShorthandId::Animation)],
                            [WebkitAnimation, SetWebkitAnimation,
                             PropertyId::Shorthand(ShorthandId::Animation)],
                                [Overscroll_behavior, SetOverscroll_behavior,
                                 PropertyId::Shorthand(ShorthandId::OverscrollBehavior)],
                            [OverscrollBehavior, SetOverscrollBehavior,
                             PropertyId::Shorthand(ShorthandId::OverscrollBehavior)],
                                [Page_break_before, SetPage_break_before,
                                 PropertyId::Shorthand(ShorthandId::PageBreakBefore)],
                            [PageBreakBefore, SetPageBreakBefore,
                             PropertyId::Shorthand(ShorthandId::PageBreakBefore)],
                                [Page_break_after, SetPage_break_after,
                                 PropertyId::Shorthand(ShorthandId::PageBreakAfter)],
                            [PageBreakAfter, SetPageBreakAfter,
                             PropertyId::Shorthand(ShorthandId::PageBreakAfter)],
                            [Columns, SetColumns,
                             PropertyId::Shorthand(ShorthandId::Columns)],
                                [_moz_columns, Set_moz_columns,
                                 PropertyId::Shorthand(ShorthandId::Columns)],
                            [MozColumns, SetMozColumns,
                             PropertyId::Shorthand(ShorthandId::Columns)],
                                [Column_rule, SetColumn_rule,
                                 PropertyId::Shorthand(ShorthandId::ColumnRule)],
                            [ColumnRule, SetColumnRule,
                             PropertyId::Shorthand(ShorthandId::ColumnRule)],
                                [_moz_column_rule, Set_moz_column_rule,
                                 PropertyId::Shorthand(ShorthandId::ColumnRule)],
                            [MozColumnRule, SetMozColumnRule,
                             PropertyId::Shorthand(ShorthandId::ColumnRule)],
                            [Font, SetFont,
                             PropertyId::Shorthand(ShorthandId::Font)],
                                [Font_variant, SetFont_variant,
                                 PropertyId::Shorthand(ShorthandId::FontVariant)],
                            [FontVariant, SetFontVariant,
                             PropertyId::Shorthand(ShorthandId::FontVariant)],
                                [Text_emphasis, SetText_emphasis,
                                 PropertyId::Shorthand(ShorthandId::TextEmphasis)],
                            [TextEmphasis, SetTextEmphasis,
                             PropertyId::Shorthand(ShorthandId::TextEmphasis)],
                                [_webkit_text_stroke, Set_webkit_text_stroke,
                                 PropertyId::Shorthand(ShorthandId::WebkitTextStroke)],
                            [WebkitTextStroke, SetWebkitTextStroke,
                             PropertyId::Shorthand(ShorthandId::WebkitTextStroke)],
                            [Marker, SetMarker,
                             PropertyId::Shorthand(ShorthandId::Marker)],
                                [List_style, SetList_style,
                                 PropertyId::Shorthand(ShorthandId::ListStyle)],
                            [ListStyle, SetListStyle,
                             PropertyId::Shorthand(ShorthandId::ListStyle)],
                            [Margin, SetMargin,
                             PropertyId::Shorthand(ShorthandId::Margin)],
                                [Margin_block, SetMargin_block,
                                 PropertyId::Shorthand(ShorthandId::MarginBlock)],
                            [MarginBlock, SetMarginBlock,
                             PropertyId::Shorthand(ShorthandId::MarginBlock)],
                                [Margin_inline, SetMargin_inline,
                                 PropertyId::Shorthand(ShorthandId::MarginInline)],
                            [MarginInline, SetMarginInline,
                             PropertyId::Shorthand(ShorthandId::MarginInline)],
                                [Scroll_margin, SetScroll_margin,
                                 PropertyId::Shorthand(ShorthandId::ScrollMargin)],
                            [ScrollMargin, SetScrollMargin,
                             PropertyId::Shorthand(ShorthandId::ScrollMargin)],
                                [Scroll_margin_block, SetScroll_margin_block,
                                 PropertyId::Shorthand(ShorthandId::ScrollMarginBlock)],
                            [ScrollMarginBlock, SetScrollMarginBlock,
                             PropertyId::Shorthand(ShorthandId::ScrollMarginBlock)],
                                [Scroll_margin_inline, SetScroll_margin_inline,
                                 PropertyId::Shorthand(ShorthandId::ScrollMarginInline)],
                            [ScrollMarginInline, SetScrollMarginInline,
                             PropertyId::Shorthand(ShorthandId::ScrollMarginInline)],
                            [Outline, SetOutline,
                             PropertyId::Shorthand(ShorthandId::Outline)],
                                [_moz_outline_radius, Set_moz_outline_radius,
                                 PropertyId::Shorthand(ShorthandId::MozOutlineRadius)],
                            [MozOutlineRadius, SetMozOutlineRadius,
                             PropertyId::Shorthand(ShorthandId::MozOutlineRadius)],
                            [Padding, SetPadding,
                             PropertyId::Shorthand(ShorthandId::Padding)],
                                [Padding_block, SetPadding_block,
                                 PropertyId::Shorthand(ShorthandId::PaddingBlock)],
                            [PaddingBlock, SetPaddingBlock,
                             PropertyId::Shorthand(ShorthandId::PaddingBlock)],
                                [Padding_inline, SetPadding_inline,
                                 PropertyId::Shorthand(ShorthandId::PaddingInline)],
                            [PaddingInline, SetPaddingInline,
                             PropertyId::Shorthand(ShorthandId::PaddingInline)],
                                [Scroll_padding, SetScroll_padding,
                                 PropertyId::Shorthand(ShorthandId::ScrollPadding)],
                            [ScrollPadding, SetScrollPadding,
                             PropertyId::Shorthand(ShorthandId::ScrollPadding)],
                                [Scroll_padding_block, SetScroll_padding_block,
                                 PropertyId::Shorthand(ShorthandId::ScrollPaddingBlock)],
                            [ScrollPaddingBlock, SetScrollPaddingBlock,
                             PropertyId::Shorthand(ShorthandId::ScrollPaddingBlock)],
                                [Scroll_padding_inline, SetScroll_padding_inline,
                                 PropertyId::Shorthand(ShorthandId::ScrollPaddingInline)],
                            [ScrollPaddingInline, SetScrollPaddingInline,
                             PropertyId::Shorthand(ShorthandId::ScrollPaddingInline)],
                                [Flex_flow, SetFlex_flow,
                                 PropertyId::Shorthand(ShorthandId::FlexFlow)],
                            [FlexFlow, SetFlexFlow,
                             PropertyId::Shorthand(ShorthandId::FlexFlow)],
                                [_webkit_flex_flow, Set_webkit_flex_flow,
                                 PropertyId::Shorthand(ShorthandId::FlexFlow)],
                            [WebkitFlexFlow, SetWebkitFlexFlow,
                             PropertyId::Shorthand(ShorthandId::FlexFlow)],
                            [Flex, SetFlex,
                             PropertyId::Shorthand(ShorthandId::Flex)],
                                [_webkit_flex, Set_webkit_flex,
                                 PropertyId::Shorthand(ShorthandId::Flex)],
                            [WebkitFlex, SetWebkitFlex,
                             PropertyId::Shorthand(ShorthandId::Flex)],
                            [Gap, SetGap,
                             PropertyId::Shorthand(ShorthandId::Gap)],
                                [Grid_gap, SetGrid_gap,
                                 PropertyId::Shorthand(ShorthandId::Gap)],
                            [GridGap, SetGridGap,
                             PropertyId::Shorthand(ShorthandId::Gap)],
                                [Grid_row, SetGrid_row,
                                 PropertyId::Shorthand(ShorthandId::GridRow)],
                            [GridRow, SetGridRow,
                             PropertyId::Shorthand(ShorthandId::GridRow)],
                                [Grid_column, SetGrid_column,
                                 PropertyId::Shorthand(ShorthandId::GridColumn)],
                            [GridColumn, SetGridColumn,
                             PropertyId::Shorthand(ShorthandId::GridColumn)],
                                [Grid_area, SetGrid_area,
                                 PropertyId::Shorthand(ShorthandId::GridArea)],
                            [GridArea, SetGridArea,
                             PropertyId::Shorthand(ShorthandId::GridArea)],
                                [Grid_template, SetGrid_template,
                                 PropertyId::Shorthand(ShorthandId::GridTemplate)],
                            [GridTemplate, SetGridTemplate,
                             PropertyId::Shorthand(ShorthandId::GridTemplate)],
                            [Grid, SetGrid,
                             PropertyId::Shorthand(ShorthandId::Grid)],
                                [Place_content, SetPlace_content,
                                 PropertyId::Shorthand(ShorthandId::PlaceContent)],
                            [PlaceContent, SetPlaceContent,
                             PropertyId::Shorthand(ShorthandId::PlaceContent)],
                                [Place_self, SetPlace_self,
                                 PropertyId::Shorthand(ShorthandId::PlaceSelf)],
                            [PlaceSelf, SetPlaceSelf,
                             PropertyId::Shorthand(ShorthandId::PlaceSelf)],
                                [Place_items, SetPlace_items,
                                 PropertyId::Shorthand(ShorthandId::PlaceItems)],
                            [PlaceItems, SetPlaceItems,
                             PropertyId::Shorthand(ShorthandId::PlaceItems)],
                            [Inset, SetInset,
                             PropertyId::Shorthand(ShorthandId::Inset)],
                                [Inset_block, SetInset_block,
                                 PropertyId::Shorthand(ShorthandId::InsetBlock)],
                            [InsetBlock, SetInsetBlock,
                             PropertyId::Shorthand(ShorthandId::InsetBlock)],
                                [Inset_inline, SetInset_inline,
                                 PropertyId::Shorthand(ShorthandId::InsetInline)],
                            [InsetInline, SetInsetInline,
                             PropertyId::Shorthand(ShorthandId::InsetInline)],
                                [Text_decoration, SetText_decoration,
                                 PropertyId::Shorthand(ShorthandId::TextDecoration)],
                            [TextDecoration, SetTextDecoration,
                             PropertyId::Shorthand(ShorthandId::TextDecoration)],
                            [Mask, SetMask,
                             PropertyId::Shorthand(ShorthandId::Mask)],
                                [_webkit_mask, Set_webkit_mask,
                                 PropertyId::Shorthand(ShorthandId::Mask)],
                            [WebkitMask, SetWebkitMask,
                             PropertyId::Shorthand(ShorthandId::Mask)],
                                [Mask_position, SetMask_position,
                                 PropertyId::Shorthand(ShorthandId::MaskPosition)],
                            [MaskPosition, SetMaskPosition,
                             PropertyId::Shorthand(ShorthandId::MaskPosition)],
                                [_webkit_mask_position, Set_webkit_mask_position,
                                 PropertyId::Shorthand(ShorthandId::MaskPosition)],
                            [WebkitMaskPosition, SetWebkitMaskPosition,
                             PropertyId::Shorthand(ShorthandId::MaskPosition)],
                            [All, SetAll,
                             PropertyId::Shorthand(ShorthandId::All)],
        }
    }
}

/// Call the given macro with tokens like this for each longhand properties:
///
/// ```
/// { snake_case_ident, true }
/// ```
///
/// … where the boolean indicates whether the property value type
/// is wrapped in a `Box<_>` in the corresponding `PropertyDeclaration` variant.
#[macro_export]
macro_rules! longhand_properties_idents {
    ($macro_name: ident) => {
        $macro_name! {
                { align_content, false }
                { align_items, false }
                { align_self, false }
                { backface_visibility, false }
                { border_collapse, false }
                { border_image_repeat, false }
                { box_decoration_break, false }
                { box_sizing, false }
                { break_inside, false }
                { caption_side, false }
                { clear, false }
                { color_adjust, false }
                { color_interpolation, false }
                { color_interpolation_filters, false }
                { column_count, false }
                { column_fill, false }
                { column_span, false }
                { contain, false }
                { direction, false }
                { display, false }
                { dominant_baseline, false }
                { empty_cells, false }
                { flex_direction, false }
                { flex_wrap, false }
                { float, false }
                { font_kerning, false }
                { font_optical_sizing, false }
                { font_size_adjust, false }
                { font_stretch, false }
                { font_style, false }
                { font_synthesis, false }
                { font_variant_caps, false }
                { font_variant_east_asian, false }
                { font_variant_ligatures, false }
                { font_variant_numeric, false }
                { font_variant_position, false }
                { font_weight, false }
                { grid_auto_flow, false }
                { hyphens, false }
                { image_orientation, false }
                { image_rendering, false }
                { ime_mode, false }
                { initial_letter, false }
                { isolation, false }
                { justify_content, false }
                { justify_items, false }
                { justify_self, false }
                { list_style_position, false }
                { mask_type, false }
                { mix_blend_mode, false }
                { _moz_appearance, false }
                { _moz_box_align, false }
                { _moz_box_direction, false }
                { _moz_box_orient, false }
                { _moz_box_pack, false }
                { _moz_control_character_visibility, false }
                { _moz_float_edge, false }
                { _moz_force_broken_image_icon, false }
                { _moz_list_reversed, false }
                { _moz_math_display, false }
                { _moz_math_variant, false }
                { _moz_min_font_size_ratio, false }
                { _moz_orient, false }
                { _moz_osx_font_smoothing, false }
                { _moz_script_level, false }
                { _moz_script_min_size, false }
                { _moz_script_size_multiplier, false }
                { _moz_stack_sizing, false }
                { _moz_text_size_adjust, false }
                { _moz_top_layer, false }
                { _moz_user_focus, false }
                { _moz_user_input, false }
                { _moz_user_modify, false }
                { _moz_user_select, false }
                { _moz_window_dragging, false }
                { _moz_window_shadow, false }
                { object_fit, false }
                { outline_style, false }
                { overflow_anchor, false }
                { overflow_wrap, false }
                { paint_order, false }
                { pointer_events, false }
                { position, false }
                { resize, false }
                { ruby_align, false }
                { ruby_position, false }
                { scroll_behavior, false }
                { scroll_snap_align, false }
                { scroll_snap_type, false }
                { scrollbar_width, false }
                { shape_rendering, false }
                { stroke_linecap, false }
                { stroke_linejoin, false }
                { table_layout, false }
                { text_align, false }
                { text_align_last, false }
                { text_anchor, false }
                { text_combine_upright, false }
                { text_decoration_line, false }
                { text_decoration_style, false }
                { text_emphasis_position, false }
                { text_justify, false }
                { text_orientation, false }
                { text_rendering, false }
                { text_transform, false }
                { touch_action, false }
                { transform_box, false }
                { transform_style, false }
                { unicode_bidi, false }
                { vector_effect, false }
                { visibility, false }
                { _webkit_line_clamp, false }
                { white_space, false }
                { word_break, false }
                { writing_mode, false }
                { _x_span, false }
                { _x_text_zoom, false }
                { z_index, false }
                { break_after, false }
                { break_before, false }
                { clip_rule, false }
                { fill_rule, false }
                { _moz_box_ordinal_group, false }
                { order, false }
                { overflow_x, false }
                { overflow_y, false }
                { overflow_clip_box_block, false }
                { overflow_clip_box_inline, false }
                { overscroll_behavior_x, false }
                { overscroll_behavior_y, false }
                { fill_opacity, false }
                { stroke_opacity, false }
                { flex_grow, false }
                { flex_shrink, false }
                { _moz_box_flex, false }
                { stroke_miterlimit, false }
                { flood_opacity, false }
                { _moz_window_opacity, false }
                { opacity, false }
                { shape_image_threshold, false }
                { stop_opacity, false }
                { border_block_end_style, false }
                { border_block_start_style, false }
                { border_bottom_style, false }
                { border_inline_end_style, false }
                { border_inline_start_style, false }
                { border_left_style, false }
                { border_right_style, false }
                { border_top_style, false }
                { column_rule_style, false }
                { animation_delay, false }
                { animation_direction, false }
                { animation_duration, false }
                { animation_fill_mode, false }
                { animation_iteration_count, false }
                { animation_name, false }
                { animation_play_state, false }
                { animation_timing_function, false }
                { background_attachment, false }
                { background_blend_mode, false }
                { background_clip, false }
                { background_image, false }
                { background_origin, false }
                { background_position_x, false }
                { background_position_y, false }
                { background_repeat, false }
                { background_size, false }
                { border_image_outset, true }
                { border_image_slice, true }
                { border_image_source, false }
                { border_image_width, true }
                { border_spacing, true }
                { box_shadow, false }
                { caret_color, true }
                { clip_path, false }
                { color, false }
                { column_width, false }
                { content, false }
                { counter_increment, false }
                { cursor, false }
                { filter, false }
                { flex_basis, true }
                { font_family, false }
                { font_feature_settings, false }
                { font_language_override, false }
                { font_size, false }
                { font_variant_alternates, false }
                { font_variation_settings, false }
                { grid_template_areas, false }
                { letter_spacing, false }
                { line_height, false }
                { list_style_image, false }
                { list_style_type, true }
                { mask_clip, false }
                { mask_composite, false }
                { mask_image, false }
                { mask_mode, false }
                { mask_origin, false }
                { mask_position_x, false }
                { mask_position_y, false }
                { mask_repeat, false }
                { mask_size, false }
                { _moz_context_properties, false }
                { _moz_font_smoothing_background_color, false }
                { _moz_tab_size, false }
                { offset_path, false }
                { perspective, false }
                { quotes, false }
                { rotate, true }
                { scale, true }
                { scroll_snap_coordinate, false }
                { scrollbar_color, true }
                { shape_outside, true }
                { stroke_dasharray, false }
                { stroke_dashoffset, false }
                { stroke_width, false }
                { text_emphasis_style, true }
                { text_indent, false }
                { text_overflow, true }
                { text_shadow, false }
                { transition_delay, false }
                { transition_duration, false }
                { transition_property, false }
                { transition_timing_function, false }
                { translate, true }
                { vertical_align, false }
                { will_change, false }
                { word_spacing, false }
                { _x_lang, false }
                { clip, true }
                { _moz_image_region, true }
                { grid_template_columns, true }
                { grid_template_rows, true }
                { fill, true }
                { stroke, true }
                { grid_auto_columns, true }
                { grid_auto_rows, true }
                { _moz_window_transform_origin, true }
                { transform_origin, true }
                { counter_reset, false }
                { counter_set, false }
                { scroll_snap_points_x, false }
                { scroll_snap_points_y, false }
                { _moz_window_transform, false }
                { transform, false }
                { column_gap, false }
                { row_gap, false }
                { object_position, true }
                { perspective_origin, true }
                { scroll_snap_destination, true }
                { grid_column_end, true }
                { grid_column_start, true }
                { grid_row_end, true }
                { grid_row_start, true }
                { max_block_size, false }
                { max_height, false }
                { max_inline_size, false }
                { max_width, false }
                { marker_end, false }
                { marker_mid, false }
                { marker_start, false }
                { _moz_binding, false }
                { scroll_padding_block_end, false }
                { scroll_padding_block_start, false }
                { scroll_padding_bottom, false }
                { scroll_padding_inline_end, false }
                { scroll_padding_inline_start, false }
                { scroll_padding_left, false }
                { scroll_padding_right, false }
                { scroll_padding_top, false }
                { block_size, false }
                { height, false }
                { inline_size, false }
                { min_block_size, false }
                { min_height, false }
                { min_inline_size, false }
                { min_width, false }
                { width, false }
                { outline_offset, false }
                { scroll_margin_block_end, false }
                { scroll_margin_block_start, false }
                { scroll_margin_bottom, false }
                { scroll_margin_inline_end, false }
                { scroll_margin_inline_start, false }
                { scroll_margin_left, false }
                { scroll_margin_right, false }
                { scroll_margin_top, false }
                { padding_block_end, false }
                { padding_block_start, false }
                { padding_bottom, false }
                { padding_inline_end, false }
                { padding_inline_start, false }
                { padding_left, false }
                { padding_right, false }
                { padding_top, false }
                { shape_margin, false }
                { border_block_end_width, false }
                { border_block_start_width, false }
                { border_bottom_width, false }
                { border_inline_end_width, false }
                { border_inline_start_width, false }
                { border_left_width, false }
                { border_right_width, false }
                { border_top_width, false }
                { column_rule_width, false }
                { outline_width, false }
                { _webkit_text_stroke_width, false }
                { border_bottom_left_radius, true }
                { border_bottom_right_radius, true }
                { border_end_end_radius, true }
                { border_end_start_radius, true }
                { border_start_end_radius, true }
                { border_start_start_radius, true }
                { border_top_left_radius, true }
                { border_top_right_radius, true }
                { _moz_outline_radius_bottomleft, true }
                { _moz_outline_radius_bottomright, true }
                { _moz_outline_radius_topleft, true }
                { _moz_outline_radius_topright, true }
                { bottom, false }
                { inset_block_end, false }
                { inset_block_start, false }
                { inset_inline_end, false }
                { inset_inline_start, false }
                { left, false }
                { margin_block_end, false }
                { margin_block_start, false }
                { margin_bottom, false }
                { margin_inline_end, false }
                { margin_inline_start, false }
                { margin_left, false }
                { margin_right, false }
                { margin_top, false }
                { right, false }
                { top, false }
                { background_color, false }
                { border_block_end_color, false }
                { border_block_start_color, false }
                { border_bottom_color, false }
                { border_inline_end_color, false }
                { border_inline_start_color, false }
                { border_left_color, false }
                { border_right_color, false }
                { border_top_color, false }
                { column_rule_color, false }
                { flood_color, false }
                { lighting_color, false }
                { outline_color, false }
                { stop_color, false }
                { text_decoration_color, false }
                { text_emphasis_color, false }
                { _webkit_text_fill_color, false }
                { _webkit_text_stroke_color, false }
        }
    }
}

